import{_ as a,c as t,o,ag as s,j as e,a as p}from"./chunks/framework.jCcxW76o.js";const S=JSON.parse('{"title":"XIMSS Module","description":"","frontmatter":{"legacyLink":"XIMSS.html"},"headers":[],"relativePath":"admin/access/XIMSS.md","filePath":"admin/access/XIMSS.md"}'),i={name:"admin/access/XIMSS.md"};function l(r,n,c,d,h,u){return o(),t("div",null,n[0]||(n[0]=[s(`<h1 id="ximss-module" tabindex="-1">XIMSS Module <a class="header-anchor" href="#ximss-module" aria-label="Permalink to &quot;XIMSS Module&quot;">​</a></h1><p>The CommuniGate Pro XIMSS module implements an open <a href="./../../development/XMLAPI.html">XIMSS</a> protocol. This protocol supports advanced clients allowing them to access all Server functions in a secure and effective way.</p><p>The CommuniGate Pro XIMSS module supports both <em>clear text</em> and <em>secure (SSL/TLS)</em> connections.</p><p>The the <a href="./../../development/XMLAPI.html">XIMSS Protocol</a> section for more details on the protocol and its features.</p><p>The CommuniGate Pro XIMSS module requires either a Groupware-type License Key or a special XIMSS License Key. The Server accepts up to 5 concurrent XIMSS sessions without these Keys.</p><h2 id="Configuring" tabindex="-1">Configuring the XIMSS Module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the XIMSS Module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the XIMSS module. Open the Access page in the Settings realm:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="XIMSSLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><select name="XIMSSChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100" selected="selected">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="1000">3000</option><option value="1000">10000</option><option value="1000">30000</option><option value="1001">other</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr></tbody></table></div></form><p>Use the Log setting to specify the type of information the XIMSS module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the XIMSS module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The XIMSS module records in the System Log are marked with the <code>XIMSSI</code> tag.</p><p>When you specify a non-zero value for the <code>Maximum Number of Channels</code> setting, the XIMSS module creates a <a href="./../network/Listener.html">Listener</a>. The module starts to accept all XIMSS connections that clients establish in order to communicate with your Server. The setting is used to limit the number of simultaneous connections the XIMSS module can accept. If there are too many incoming connections open, the module will reject new connections, and the client should retry later.</p><p>By default, the XIMSS module Listener accepts clear text connections on the TCP port 11024. Follow the Listener link to tune the XIMSS <a href="./../network/Listener.html">Listener</a>.</p><h2 id="HandOver" tabindex="-1">XIMSS Connections to Other Modules <a class="header-anchor" href="#HandOver" aria-label="Permalink to &quot;XIMSS Connections to Other Modules {#HandOver}&quot;">​</a></h2><p>XIMSS connections can be made to TCP ports served with other CommuniGate Pro modules. If the first symbol received on a connection made to the <a href="./../services/HTTP.html">HTTP</a> module is the <code>&lt;</code> symbol, the HTTP module passes the connection to the XIMSS module.</p><p>When a connection is passed:</p><ul><li>the logical job of the passing module completes.</li><li>the logical job of the XIMSS module is created, in the same way when an XIMSS connection is received on a port served with the XIMSS module.</li><li>the XIMSS module restrictions for the total number of XIMSS channels and for the number of channels opened from the same IP address are applied.</li></ul><p>When all users initiate XIMSS connections via other Module ports, you can disable the XIMSS <a href="./../network/Listener.html">Listener</a> by setting all its ports to zero.</p><h2 id="FlashSec" tabindex="-1">Flash Security <a class="header-anchor" href="#FlashSec" aria-label="Permalink to &quot;Flash Security {#FlashSec}&quot;">​</a></h2><p>When a Flash client connects to an <em>XMLSocket</em> server (such as the CommuniGate Pro XIMSS module), it can send a special <code>policy-file-request</code> request. The XIMSS module replies with an XML document allowing the client to access any port on the Server.</p><h2 id="Sessions" tabindex="-1">XIMSS Sessions <a class="header-anchor" href="#Sessions" aria-label="Permalink to &quot;XIMSS Sessions {#Sessions}&quot;">​</a></h2><p>When a user is authenticated, the XIMSS module creates a XIMSS session. The current XIMSS module TCP connection can be used to communicate with that session.</p><p>A XIMSS session can be created without the XIMSS module, using special requests sent to the <a href="./../services/HTTP.html">HTTP</a> User module. See the <a href="./../../development/XMLAPI.html#HTTP">XIMSS Protocol</a> section for more details.</p><p>The XIMSS session records in the System Log are marked with the <code>XIMSS</code> tag.</p><h2 id="HTTPBind" tabindex="-1">HTTP Binding <a class="header-anchor" href="#HTTPBind" aria-label="Permalink to &quot;HTTP Binding {#HTTPBind}&quot;">​</a></h2><p>A client application can access the XIMSS interface via HTTP connections.</p><p>A client application should start by sending an HTTP Login request to create a new XIMSS session.</p><p>When a XIMSS session is created, the client application can send XIMSS protocol requests to it and receive XIMSS protocol responses from the session using HTTP requests.</p><p>Client applications can use <code>GET</code> and <code>POST</code> HTTP requests.<br> If a request contains a body, it is assumed to be an XML text, unrelated to the actual value of the Content-Type header field. The XML text must be a <code>&lt;XIMSS/&gt;</code> element.<br> If a request produces a non-empty response body, the body is always an XML text containing one <code>&lt;XIMSS/&gt;</code> element, and the response Content-Type header field is <code>text/xml</code>.</p><p>Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th></tr><tr><td align="RIGHT">XIMSS:</td><td><select name="HTTPXIMSSMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td></tr></tbody></table></div></form><p>The Access setting specifies who can create XIMSS sessions using HTTP Binding.</p><h3 id="HTTPLogin" tabindex="-1">HTTP Login <a class="header-anchor" href="#HTTPLogin" aria-label="Permalink to &quot;HTTP Login {#HTTPLogin}&quot;">​</a></h3><p>To start a XIMSS session, a client application should send an HTTP request to the CommuniGate Pro HTTPU module using the following URLs:</p><p><code>http://_domainName_[:_port_]/ximsslogin/</code><br> or<br><code>https://_domainName_[:_port_]/ximsslogin/</code></p><p>If the request contains the <code>userName</code> parameter, the Server tries to authenticate the specified user (Account):</p><ul><li>If the <code>password</code> parameter is present, the regular clear-text method is used.</li><li>If the <code>nonce</code> parameter is present, the <a href="./../sysadmin/Security.html">CRAM-MD5</a> method is used. The &quot;nonce&quot; parameter value should be a value received as part of a <code>features</code> response (see below), it should be a valid &quot;authentication nonce&quot;. The request must contain the <code>authData</code> parameter containing the base64-encoded CRAM-MD5 &quot;challenge response&quot;.</li><li>If the <code>sessionid</code> parameter is present, the <a href="./../sysadmin/Security.html#SessionIDSASL">SessionID</a> method is used.</li><li>If the <code>errorAsXML</code> parameter is present and the login operation fails, the error condition is returned not as an HTTP result code with an HTML error page, but as an <code>&lt;response/&gt;</code> element with <code>errorNum</code> and <code>errorText</code> attributes, enclosed into a <code>&lt;XIMSS/&gt;</code> element.</li><li>If the <code>version</code> parameter is present, its value specifies the protocol version the client implements (see the <a href="./../../development/XMLAPI.html#Login">Login</a> operation parameters).</li></ul><p>If the <code>userName</code> parameter is absent, the Server tries to authenticate the request using the <a href="./../sysadmin/PKI.html#ClientCert">TLS Client Certificate</a> (if specified), or using the HTTP authentication methods.<br> This functionality is the same as the WebUser Interface <a href="./WebUser.html#Auto">Automatic Login and Single Sign-on</a> functionality, but the <code>/ximsslogin/</code> URL is used.</p><p>A request to the <code>/ximsslogin/</code> URL can contain a <code>text/xml</code> body. In this case, no login operation is performed.<br> The XML body should contain one <code>&lt;XIMSS&gt;</code> element containing zero, one, or several XIMSS <a href="./../../development/XMLAPI.html#PreLogin">Pre-Login operations</a>. The Server sends an HTTP response with XML data. The response is a <code>&lt;XIMSS&gt;</code> element containing the requested operations result.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:GET /ximsslogin/ HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Type: text/xml</span></span>
<span class="line"><span>  Content-Length: 42</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;listFeatures id=&quot;list&quot; /&gt;&lt;XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 231</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;features id=&quot;s&quot; domain=&quot;x.domain.dom&quot;&gt;&lt;starttls/&gt;&lt;sasl&gt;LOGIN&lt;/sasl&gt;&lt;sasl&gt;PLAIN&lt;/sasl&gt;&lt;sasl&gt;CRAM-MD5&lt;/sasl&gt;&lt;sasl&gt;DIGEST-MD5&lt;/sasl&gt;&lt;sasl&gt;GSSAPI&lt;/sasl&gt;&lt;nonce&gt;2C3E575E5498CE63574D40F18D00C873&lt;/nonce&gt;&lt;language&gt;german&lt;/language&gt;&lt;signup/&gt;&lt;/features&gt;&lt;response id=&quot;s&quot;/&gt;&lt;/XIMSS&gt;</span></span></code></pre></div><p>If the user has been successfully authenticated, and the XIMSS session has been created, the HTTP Login response contains the XIMSS <a href="./../../development/XMLAPI.html#SessionMessage"><code>session</code> message</a> with the session ID string. Note that the <code>session</code> message does not contain the <code>id</code> attribute.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:GET /ximsslogin/?userName=account@domain&amp;password=abcd&amp;version=6.1 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 105</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;session urlID=&quot;562-kAI2lxNBR4ApmHg4wiW9&quot; userName=&quot;account@domain&quot; realName=&quot;J. Smith&quot; version=&quot;6.1.2&quot; /&gt;&lt;/XIMSS&gt;</span></span></code></pre></div><p>Alternative URLs can be used to start a XIMSS session using the <a href="./../sysadmin/PKI.html#ClientCert">TLS Client Certificate</a>, or using the HTTP authentication methods:</p><p><code>http://_domainName_[:_port_]/auth/ximsslogin/</code><br> or<br><code>https://_domainName_[:_port_]/auth/ximsslogin/</code></p><p>This method is useful if an application first retrieves an HTML page or some other document using the <a href="./../../development/WebApp.html#CGPL"><code>/auth/</code> realm</a>, forcing the browser to ask the user for credentials, and then the application creates a XIMSS session for the same user, as the browser will resend the same credentials when sending a request to the <code>/auth/ximsslogin/</code> URL.</p><h3 id="HTTPSync" tabindex="-1">HTTP Synchronous Communications <a class="header-anchor" href="#HTTPSync" aria-label="Permalink to &quot;HTTP Synchronous Communications {#HTTPSync}&quot;">​</a></h3><p>A client should send requests to a created XIMSS session use the following Session URL:</p><p><code>http://_domainName_[:_port_]/Session/_sessionID_/sync</code><br> or<br><code>https://_domainName_[:_port_]/Session/_sessionID_/sync</code>where <em>sessionID</em> is the <code>session</code> message urlID attribute.</p><p>The HTTP request body should contain one <code>&lt;XIMSS /&gt;</code> element, with zero, one, or more XIMSS protocol requests.</p><p>The Server returns one <code>&lt;XIMSS /&gt;</code> element in the HTTP response body. This element contains the XIMSS protocol <code>response</code> messages (one for each XIMSS request sent, in the same order), and all synchronous data messages generated with the submitted XIMSS requests.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:POST /Session/562-kAI2lxNBR4ApmHg4wiW9/sync HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;noop id=&quot;i1&quot; /&gt;&lt;readTime id=&quot;i2&quot; /&gt;&lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;response id=&quot;i1&quot;/&gt;&lt;currentTime id=&quot;i2&quot; gmtTime=&quot;20070502T083313&quot; localTime=&quot;20070502T003313&quot;/&gt;&lt;response id=&quot;i2&quot;/&gt;&lt;/XIMSS&gt;</span></span></code></pre></div><p>If a XIMSS client works in an unreliable environment, where it may have to resend HTTP requests, then each non-empty HTTP request should contain a <code>reqSeq</code> parameter. This parameter value should be increased by 1 for each new HTTP request sent.<br> If the Server receives an HTTP request with the same <code>reqSeq</code> parameter as the previously received and processed HTTP request, then the Server resends the last response (one it has sent to the previous HTTP request wit the same <code>reqSeq</code>).<br> If the Server receives an HTTP request with the <code>reqSeq</code> parameter not equal to the <code>reqSeq</code> parameter of the previously received request and not equal to the <code>reqSeq</code> parameter of the previously received request increased by 1, then the Server returns an error.</p><p>A client application can use an &quot;empty request&quot; (an HTTP request without a body) to read asynchronous XIMSS data messages.</p><p>When such an empty request is received, the Server checks if there is any pending asynchronous data messages for the specified session. If there is no pending asynchronous data messages, the request is held until either:</p><ul><li>an asynchronous data message is generated for the session; or</li><li>the waiting time is over; or</li><li>a new &quot;empty request&quot; is received; or</li><li>the session is closed.</li></ul><p>An empty request can specify the waiting time as the <code>maxWait</code> parameter (number of seconds).</p><p>If no data messages were retrieved, the Server sends a response containing an empty <code>&lt;XIMSS/&gt;</code> element, without any attributes.</p><p>If some data messages were retrieved, the Server sends a response (an &quot;asynchronous response&quot;) containing one <code>&lt;XIMSS/&gt;</code> element, with the <code>respSeq</code> attribute. This attribute contains the sequence number for this <code>&lt;XIMSS/&gt;</code> response element.</p><p>For each session, the Server keeps the last &quot;asynchronous response&quot; composed.</p><p>Each empty request should contain a <code>ackSeq</code> parameter. It should contain the <code>respSeq</code> value of the last received asynchronous response.<br> If the client has not received any asynchronous response yet, this parameter value must be <code>0</code>.</p><p>When the Server receives an empty request with the <code>ackSeq</code> equal to the <code>respSeq</code> value of the kept last composed asynchronous response, it considers that response as &quot;acknowledged&quot;, and removes it.</p><p>When the Server receives an empty request with the <code>ackSeq</code> equal to the <code>respSeq</code> value of the last composed asynchronous response minus one (respSeq-1), and it still keeps this composed response, the Server resends that response to the client. As a result, if the client encounters any communication error while doing an &quot;empty request&quot; HTTP transaction, it can resend that empty request.</p><p>An empty request without an <code>ackSeq</code> parameter acknowledges all &quot;asynchronous responses&quot; composed and kept.</p><p>When a server returns an empty <code>&lt;XIMSS/&gt;</code> element, the next empty request can contain either no <code>ackSeq</code> parameter, or the same <code>ackSeq</code> parameter as the previous empty request. Because of this subsequent empty requests may use the same request URL and the same parameters, and the client platform may return the previous cached <code>&lt;XIMSS/&gt;</code> element result immediately, without sending the request to the server.<br> To avoid this problem, include the <code>reqSeq</code> parameter into each empty request, increasing its value after a successful transaction.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=90&amp;ackSeq=0&amp;reqSeq=0 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...optional pause (up to 90 seconds)...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 10</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=90&amp;ackSeq=0&amp;reqSeq=1 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...optional pause (up to 90 seconds)...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS respSeq=&quot;1&quot;&gt;&lt;folderReport folder=&quot;INBOX&quot; mode=&quot;notify&quot; /&gt;&lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...response did not reach the client, client is resending the request...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=90&amp;ackSeq=0&amp;reqSeq=1 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS respSeq=&quot;1&quot;&gt;&lt;folderReport folder=&quot;INBOX&quot; mode=&quot;notify&quot; /&gt;&lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=90&amp;ackSeq=1&amp;reqSeq=2 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...optional pause (up to 90 seconds)...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 10</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS/&gt;</span></span></code></pre></div><h3 id="HTTPAsync" tabindex="-1">HTTP Asynchronous Communications <a class="header-anchor" href="#HTTPAsync" aria-label="Permalink to &quot;HTTP Asynchronous Communications {#HTTPAsync}&quot;">​</a></h3><p>A client can send requests to a created XIMSS session so that all responses (including the <code>response</code> messages and synchronous data messages) are returned only in response to the &quot;empty requests&quot;.</p><p><code>http://_domainName_[:_port_]/Session/_sessionID_/async</code><br> or<br><code>https://_domainName_[:_port_]/Session/_sessionID_/async</code> where <em>sessionID</em> is the <code>session</code> message urlID attribute.</p><p>The HTTP request body should contain one <code>&lt;XIMSS /&gt;</code> element, with zero, one, or more XIMSS protocol requests.</p><p>All generated <code>response</code> messages (one for each XIMSS request sent, in the same order), and all synchronous data messages generated with the submitted XIMSS requests are re-submitted to the XIMSS session as asynchronous messages. The Server returns an empty HTTP response.</p><p>Example (single connection, polling):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=0&amp;ackSeq=0&amp;reqSeq=0 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 10</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:POST /Session/562-kAI2lxNBR4ApmHg4wiW9/async HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;noop id=&quot;i1&quot; /&gt;&lt;readTime id=&quot;i2&quot; /&gt;&lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/plain;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?maxWait=0&amp;ackSeq=0&amp;reqSeq=1 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS respSeq=&quot;1&quot;&gt;&lt;response id=&quot;i1&quot;/&gt;&lt;currentTime id=&quot;i2&quot; gmtTime=&quot;20070502T083313&quot; localTime=&quot;20070502T003313&quot;/&gt;&lt;response id=&quot;i2&quot;/&gt;&lt;/XIMSS&gt;</span></span></code></pre></div><p>Example (2 connections, waiting):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?ackSeq=0&amp;reqSeq=0 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...waiting...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS respSeq=&quot;1&quot;&gt;</span></span>
<span class="line"><span>    &lt;response id=&quot;i1&quot;/&gt;</span></span>
<span class="line"><span>    &lt;currentTime id=&quot;i2&quot; gmtTime=&quot;20070502T083313&quot;</span></span>
<span class="line"><span>      localTime=&quot;20070502T003313&quot;/&gt;</span></span>
<span class="line"><span>    &lt;response id=&quot;i2&quot;/&gt;</span></span>
<span class="line"><span>  &lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:GET /Session/562-kAI2lxNBR4ApmHg4wiW9/get?ackSeq=1&amp;reqSeq=1 HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>...waiting...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>C:POST /Session/562-kAI2lxNBR4ApmHg4wiW9/async HTTP/1.1</span></span>
<span class="line"><span>  Host: myserver.com</span></span>
<span class="line"><span>  Content-Length: _nnn_</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  &lt;XIMSS&gt;&lt;noop id=&quot;i1&quot; /&gt;&lt;readTime id=&quot;i2&quot; /&gt;&lt;/XIMSS&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:HTTP/1.1 200 OK</span></span>
<span class="line"><span>  Content-Length: 0</span></span>
<span class="line"><span>  Connection: keep-alive</span></span>
<span class="line"><span>  Content-Type: text/xml;charset=utf-8</span></span>
<span class="line"><span>  Server: CommuniGatePro/5.3</span></span></code></pre></div><h2 id="Monitoring" tabindex="-1">Monitoring XIMSS Activity <a class="header-anchor" href="#Monitoring" aria-label="Permalink to &quot;Monitoring XIMSS Activity {#Monitoring}&quot;">​</a></h2><p>You can monitor the XIMSS Module activity using the WebAdmin Interface.</p><p>Click the Access link in the Monitors realm to open the Access Monitoring page:</p>`,80),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Display",class:"button",type:"reset"}),p(),e("input",{name:"Filter",value:"",size:"10",maxlength:"100",type:"text"})]),e("td"),e("td",{align:"right"},"3 of 3 selected")])])]),e("table",{class:"settingsBox",border:"1",cellpadding:"2",cellspacing:"0",width:"90%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",{nowrap:"nowrap"},"ID"),e("th",null,"IP Address"),e("th",null,"Account"),e("th",null,"Connected"),e("th",null,"Status"),e("th",{colspan:"2"},"Running")]),e("tr",null,[e("td",null,"9786"),e("td",null,"[216.200.213.116]"),e("td",{nowrap:"nowrap"},"user1@domain2.dom"),e("td",null,"3min"),e("td",null,"listing messages"),e("td",null,"2sec")]),e("tr",null,[e("td",null,"9794"),e("td",null,"[216.200.213.115]"),e("td",{nowrap:"nowrap"},"user2@domain1.dom"),e("td",null,"34sec"),e("td",null,"reading request"),e("td",null," ")]),e("tr",null,[e("td",null,"9803"),e("td",null,"[216.200.213.115]"),e("td",{nowrap:"nowrap"}),e("td",null,"2sec"),e("td",null,"authenticating"),e("td",null," ")])])])])],-1),s('<ul><li><p><code>ID</code></p><p>This field contains the XIMSS numeric session ID. In the CommuniGate Pro Log, this session records are marked with the <code>XIMSS-_nnnnn_</code> flag, where <em>nnnnn</em> is the session ID.</p></li><li><p><code>IP Address</code></p><p>This field contains the IP address the client has connected from.</p></li><li><p><code>Account</code></p><p>This field contains the name of the client Account (after successful authentication).</p></li><li><p><code>Connected</code></p><p>This field contains the connection time (time since the client opened this TCP/IP session).</p></li><li><p><code>Status</code></p><p>This field contains either the name of the operation in progress or, if there is not pending operation, the current session status (Authenticating, Selected, etc.).</p></li><li><p><code>Running</code></p><p>If there is an XIMSS operation in progress, this field contains the time since operation started.</p></li></ul><p>XIMSS activity can be monitored with the CommuniGate Pro <a href="./../sysadmin/Statistics.html">Statistic Elements</a>.</p>',2)]))}const g=a(i,[["render",l]]);export{S as __pageData,g as default};
