import{_ as i,c as e,o as p,ag as n,j as s,a as t}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Cluster Load Balancers","description":"","frontmatter":{"legacyLink":"ClusterBalancer.html"},"headers":[],"relativePath":"admin/cluster/Balancer.md","filePath":"admin/cluster/Balancer.md"}'),l={name:"admin/cluster/Balancer.md"};function o(h,a,r,c,d,k){return p(),e("div",null,a[0]||(a[0]=[n(`<h1 id="cluster-load-balancers" tabindex="-1">Cluster Load Balancers <a class="header-anchor" href="#cluster-load-balancers" aria-label="Permalink to &quot;Cluster Load Balancers&quot;">​</a></h1><p>The CommuniGate Pro Cluster architecture allows a load balancer to direct any connection to any working Server, eliminating a requirement for complex and unreliable &quot;high-level&quot; load balancer solutions. Inexpensive Layer 4 Switches can be used to handle the traffic.</p><p>Additionally, CommuniGate Pro Dynamic Cluster can manage software load balancers, such as the Linux &quot;ipvs&quot; kernel module: the CommuniGate Pro Cluster collects the information about working Servers belonging to one or several &quot;balancer groups&quot;, learns which Servers can be used as Load Balancers, selects one Load Balancer for each group, informs it about all active Servers in that group, and assigns the Load Balancer duties to a different server, if the selected one goes down.</p><h2 id="DSR" tabindex="-1">DSR (Direct Server Response) or DR (Direct Routing) <a class="header-anchor" href="#DSR" aria-label="Permalink to &quot;DSR (Direct Server Response) or DR (Direct Routing) {#DSR}&quot;">​</a></h2><p>The DSR/DR is the preferred Load-Balancing method for larger installations. When this method is used, each Server is configured to have the VIP (Virtual IP) shared addresses as its local IP addresses. This allows each Server to receive all packets directed to the VIP addresses, and to send responses directly to the clients using the VIP as the &quot;source&quot; address.<br> The servers should not respond to the arp requests for these VIP addresses. Instead the load balancer responds to these requests, and thus all incoming packets directed to the VIP addresses are delivered to the load balancer, which redirects them to Servers. When redirecting these incoming packets, the load balancer sends them directly to the Server MAC address, without changing the packet destination address, that remains the VIP address.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Because MAC addresses are used to redirect incoming packets, the Load Balancer and all balanced Servers (usually - CommuniGate Pro Cluster frontends) must be connected to the same network segment; there should be no router between the Load Balancer and those Servers.</p></div><p>To use the DSR method, create an &quot;alias&quot; for the loopback network interface on each Frontend Server. While the standard address for the loopback interface is 127.0.0.1, create an alias with the VIP address and the 255.255.255.255 network mask:</p><ul><li><p><strong>Solaris</strong></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig lo0:1 plumb</span></span>
<span class="line"><span>ifconfig lo0:1 _VIP_ netmask 255.255.255.255 up</span></span></code></pre></div><p>To make this configuration permanent, create the file <code>/etc/hostname.lo0:1</code> with the VIP address in it.</p></li><li><p><strong>FreeBSD</strong></p><p>To change the configuration permanently, add the following line to the <code>/etc/rc.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig_*_lo0_alias0=&quot;inet _VIP_ netmask 255.255.255.255&quot;</span></span></code></pre></div></li><li><p><strong>Linux</strong></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig lo:0 _VIP_ netmask 255.255.255.255 up</span></span></code></pre></div><p>or</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">ip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> address</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> add</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> _VIP_/32</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> dev</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> lo</span></span></code></pre></div><p>To make this configuration permanent, create the file <code>/etc/sysconfig/network-scripts/ifcfg-lo:0</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>DEVICE=lo</span></span>
<span class="line"><span>IPADDR=VIP</span></span>
<span class="line"><span>NETMASK=255.255.255.255</span></span>
<span class="line"><span>ONBOOT=yes</span></span></code></pre></div><p>Make sure that the kernel is configured to avoid ARP advertising for this <code>lo</code> interface (so the <code>VIP</code> address is not linked to any Frontend server in arp-tables). Subject to the Linux kernel version, the following commands should be added to the <code>/etc/sysctl.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># ARP: reply only if the target IP address is</span></span>
<span class="line"><span># a local address configured on the incoming interface</span></span>
<span class="line"><span>net.ipv4.conf.all.arp_ignore = 1</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># When an arp request is received on eth0, only respond</span></span>
<span class="line"><span># if that address is configured on eth0.</span></span>
<span class="line"><span>net.ipv4.conf.eth0.arp_ignore = 1</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># Enable configuration of arp_announce option</span></span>
<span class="line"><span>net.ipv4.conf.all.arp_announce = 2</span></span>
<span class="line"><span># When making an ARP request sent through eth0, always use an address</span></span>
<span class="line"><span># that is configured on eth0 as the source address of the ARP request.</span></span>
<span class="line"><span>net.ipv4.conf.eth0.arp_announce = 2</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># Repeat for eth1, eth2 (if exist)</span></span>
<span class="line"><span>#net.ipv4.conf.eth1.arp_ignore = 1</span></span>
<span class="line"><span>#net.ipv4.conf.eth1.arp_announce = 2</span></span>
<span class="line"><span>#net.ipv4.conf.eth2.arp_ignore = 1</span></span>
<span class="line"><span>#net.ipv4.conf.eth2.arp_announce = 2</span></span></code></pre></div><p>If you plan to have many VIPs, or if you plan to use CommuniGate Pro Load Balancing with the Linux built-in ipvs load balancer, do not create <code>/etc/sysconfig/network-scripts/ifcfg-lo:_n_</code> files.<br> Create the <code>/etc/sysconfig/vipaddrs</code> configuration file instead, and put all VIP addresses into it, as addresses, or subnetworks, one address per line. For example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># single addresses</span></span>
<span class="line"><span>72.20.112.45</span></span>
<span class="line"><span>72.20.112.46</span></span>
<span class="line"><span># a subnetwork</span></span>
<span class="line"><span>72.20.112.48/29</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Line starting with the # symbol are ignored. They can be used as comments.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Subnetwork masks must be 24 bits or longer.</p></div><p>Create the following configuration scripts:</p><p><code>/etc/sysconfig/network-scripts/ifvip-utils</code></p><div class="language-bash vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">bash</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#!/bin/bash</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># /etc/sysconfig/network-scripts/ifvip-utils</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">VIPADDRFILE</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;/etc/sysconfig/vipaddrs&quot;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">VIPLIST</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;&quot;</span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">           # list of VIP masks: xxx.yy.zz.tt/mm where mm should be &gt;= 24</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> xVIP </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">in</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> \`</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">cat</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $VIPADDRFILE</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> |</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> grep</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -v</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &#39;^#&#39;\`</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> [[ $xVIP </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">!=</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> *</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ]]; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">then</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xVIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">/32</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">fi</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (( \${xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">##*/</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">} </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&lt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 24</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">)); </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">then</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    echo</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;Incorrect mask: </span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xVIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> &gt;</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">2</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ; </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">exit</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 1</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  fi</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  VIPLIST</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$VIPLIST$xVIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">done</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">CURRENT</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">\`</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">ip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> address show dev lo </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">|</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> egrep</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &#39;^ +inet [0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+\\/32 .*$&#39; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">|</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sed</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -r</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &#39;s/ +inet ([0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+).*/\\1/&#39; \`</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">function</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> contains</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">() {</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  local</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> x;</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> x </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">in</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> $1</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> [[ $x </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">==</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> $2</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ]]; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">then</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 0</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">fi</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  done</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 1</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p><code>/etc/sysconfig/network-scripts/ifup-lo</code></p><div class="language-bash vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">bash</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#!/bin/bash</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># /etc/sysconfig/network-scripts/ifup-lo</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">/etc/sysconfig/network-scripts/ifup-eth</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> \${1}</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> \${2}</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># Bring up all addresses listed in the VIPADDRFILE file, as lo aliases</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">.</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> /etc/sysconfig/network-scripts/ifvip-utils</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> xVIP </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">in</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $VIPLIST; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">%/*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}       </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; xx.xx.xx.yy</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP0</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">%</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">.</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}       </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; xx.xx.xx</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP1</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">##*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">.}      </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; yy</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xMask</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$(( </span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">2</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> **</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (32 </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">-</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> \${xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">##*/</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}) ))</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (( index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">0</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xMask; index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">++</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> )); </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    thisIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xIP0</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">.</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$((</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">xIP1</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> +</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">))</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    if</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> !</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> $(contains</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$CURRENT</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$thisIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">); </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">then</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">      ip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> address</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> add</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $thisIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">/32</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> dev</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> lo</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    fi</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  done</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">done</span></span></code></pre></div><p><code>/etc/sysconfig/network-scripts/ifdown-lo</code></p><div class="language-bash vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">bash</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#!/bin/bash</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># /etc/sysconfig/network-scripts/ifdown-lo</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># Bring down all addresses listed in the VIPADDRFILE file</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">.</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> /etc/sysconfig/network-scripts/ifvip-utils</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> xVIP </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">in</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $VIPLIST; </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">%/*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}       </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; xx.xx.xx.yy</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP0</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">%</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">.</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}       </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; xx.xx.xx</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xIP1</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">\${xIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">##*</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">.}      </span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># xx.xx.xx.yy/mm -&gt; yy</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  xMask</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$(( </span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">2</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> **</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (32 </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">-</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> \${xVIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">##*/</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}) ))</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  for</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (( index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">0</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">; index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xMask; index</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">++</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> )); </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">do</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    thisIP</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$xIP0</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">.</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$((</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">xIP1</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> +</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">))</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $(</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">contains</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$CURRENT</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">$thisIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">); </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">then</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">      ip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> address</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> delete</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> $thisIP</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">/32</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> dev</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> lo</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    fi</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    done</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  done</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">/etc/sysconfig/network-scripts/ifdown-eth</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> \${1}</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> \${2}</span></span></code></pre></div></li><li><p><strong><em>other OS</em></strong></p><p>consult with the OS vendor</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a network &quot;alias&quot; is created, open the General Info page in the CommuniGate Pro WebAdmin Settings realm, and click the Refresh button to let the Server detect the newly added IP address.</p></div><p>The DSR method is transparent for all TCP-based services (including SIP over TCP/TLS), no additional CommuniGate Pro Server configuration is required: when a TCP connection is accepted on a local VIP address, outgoing packets for that connection will always have the same VIP address as the source address.</p><p>To use the DSR method for SIP UDP, the CommuniGate Pro frontend Server configuration should be updated:</p><ul><li>use the WebAdmin Interface to open the Settings realm. Open the SIP receiving page in the Real-Time section</li><li>follow the UDP Listener link to open the <a href="./../network/Listener.html">Listener</a> page</li><li>by default, the SIP UDP Listener has one socket: it listens on &quot;all addresses&quot;, on the port 5060.</li><li>change this socket configuration by changing the &quot;all addresses&quot; value to the <em>VIP</em> value (the <em>VIP</em> address should be present in the selection menu).</li><li>click the Update button</li><li>create an additional socket to receive incoming packets on the port 5060, &quot;all addresses&quot;, and click the Update button</li></ul><p>Now, when you have 2 sockets - the first socket for <em>VIP</em>:5060, the second one for <em>all addresses</em>:5060, the frontend Server can use the first socket when it needs to send packets with VIP source address.<br> Repeat this configuration change for all &quot;balanced&quot; Servers.</p><h2 id="Pinging" tabindex="-1">Pinging <a class="header-anchor" href="#Pinging" aria-label="Permalink to &quot;Pinging {#Pinging}&quot;">​</a></h2><p>Load Balancers usually send some requests to servers in their &quot;balanced pools&quot;. Lack of response tells the Load Balancer to remove the server from the pool, and to distribute incoming requests to remaining servers in that pool.</p><p>With SIP Farming switched on, the Load Balancer own requests can be relayed to other servers in the SIP Farm, and responses will come from those servers. This may cause the Load Balancer to decide that the server it has sent the request to is down, and to exclude the server from the pool.<br> To avoid this problem, use the following SIP requests for Load Balancer &quot;pinging&quot;:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>OPTION sip:aaa.bbb.ccc.ddd:5060 SIP/2.0</span></span>
<span class="line"><span>Route: &lt;sip:aaa.bbb.ccc.ddd:5060;lr&gt;</span></span>
<span class="line"><span>other SIP packet fields</span></span></code></pre></div><p>where <code>aaa.bbb.ccc.ddd</code> is the IP address of the CommuniGate Pro Server being tested.</p><p>These packets are processed with the <code>aaa.bbb.ccc.ddd</code> Server, which generates responses and sends them back to the Load Balancer (or other testing device).</p><h2 id="Samples" tabindex="-1">Sample Balancer Configurations <a class="header-anchor" href="#Samples" aria-label="Permalink to &quot;Sample Balancer Configurations {#Samples}&quot;">​</a></h2><p>Sample configuration:</p><ul><li>Router at <code>64.173.55.161</code> (netmask <code>255.255.255.224</code>), DNS server at <code>64.173.55.167</code>.</li><li>4 frontend Servers (<code>fe5</code>, <code>fe6</code>, <code>fe7</code>, <code>fe8</code>) with &quot;real&quot; IP addresses <code>64.173.55.{180,181,182,183}</code></li><li>inter-Cluster network <code>192.168.10.xxx</code>, with frontend &quot;cluster&quot; addresses <code>192.168.10.{5,6,7,8}</code></li><li>load balancer with <code>64.173.55.164</code> address (VIP address).</li><li>a loopback interface on each frontend Server has an alias configured for the <code>64.173.55.164</code> address configured.</li></ul><p>The multi-IP no-NAT RTP method is used.</p><p>The CommuniGate Pro configuration (WebAdmin Settings realm):</p><ul><li>the Network-&gt;LAN IP-&gt;Cluster-wide page: WAN IPv4 Address: <code>64.173.55.164</code></li><li>the Network-&gt;LAN IP-&gt;Server-wide page (on each frontend Server): WAN IPv4 Address: <code>64.173.55.{180,181,182,183}</code></li><li>the RealTime-&gt;SIP-&gt;Receiving-&gt;UDP Listener page (on each frontend Server): {port <code>5060</code>, address: <code>64.173.55.164</code>} and {port: <code>5060</code>, address: <code>all addresses</code>;}</li></ul><p>A &quot;no-NAT&quot; configuration with &quot;normal&quot; load balancing for POP, IMAP, and &quot;DSR&quot; load balancing for SIP (UDP/TCP), SMTP, HTTP User (8100).</p><p>The Load Balancer configuration:</p><ul><li><p><strong>Foundry ServerIron®</strong> (<code>64.173.55.176</code> is its service address)</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Startup configuration:</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server predictor round-robin</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server real fe5 64.173.55.180</span></span>
<span class="line"><span> port pop3</span></span>
<span class="line"><span> port pop3 keepalive</span></span>
<span class="line"><span> port imap4</span></span>
<span class="line"><span> port imap4 keepalive</span></span>
<span class="line"><span> port 5060</span></span>
<span class="line"><span> port 5060 keepalive</span></span>
<span class="line"><span> port smtp</span></span>
<span class="line"><span> port smtp keepalive</span></span>
<span class="line"><span> port 8100</span></span>
<span class="line"><span> port 8100 keepalive</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server real fe6 64.173.55.181</span></span>
<span class="line"><span> port pop3</span></span>
<span class="line"><span> port pop3 keepalive</span></span>
<span class="line"><span> port imap4</span></span>
<span class="line"><span> port imap4 keepalive</span></span>
<span class="line"><span> port 5060</span></span>
<span class="line"><span> port 5060 keepalive</span></span>
<span class="line"><span> port smtp</span></span>
<span class="line"><span> port smtp keepalive</span></span>
<span class="line"><span> port 8100</span></span>
<span class="line"><span> port 8100 keepalive</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server real fe7 64.173.55.182</span></span>
<span class="line"><span> port pop3</span></span>
<span class="line"><span> port pop3 keepalive</span></span>
<span class="line"><span> port imap4</span></span>
<span class="line"><span> port imap4 keepalive</span></span>
<span class="line"><span> port 5060</span></span>
<span class="line"><span> port 5060 keepalive</span></span>
<span class="line"><span> port smtp</span></span>
<span class="line"><span> port smtp keepalive</span></span>
<span class="line"><span> port 8100</span></span>
<span class="line"><span> port 8100 keepalive</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server real fe8 64.173.55.183</span></span>
<span class="line"><span> port pop3</span></span>
<span class="line"><span> port pop3 keepalive</span></span>
<span class="line"><span> port imap4</span></span>
<span class="line"><span> port imap4 keepalive</span></span>
<span class="line"><span> port 5060</span></span>
<span class="line"><span> port 5060 keepalive</span></span>
<span class="line"><span> port smtp</span></span>
<span class="line"><span> port smtp keepalive</span></span>
<span class="line"><span> port 8100</span></span>
<span class="line"><span> port 8100 keepalive</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>server virtual vip1 64.173.55.164</span></span>
<span class="line"><span> predictor round-robin</span></span>
<span class="line"><span> port pop3</span></span>
<span class="line"><span> port imap4</span></span>
<span class="line"><span> port 5060</span></span>
<span class="line"><span> port 5060 dsr</span></span>
<span class="line"><span> port smtp</span></span>
<span class="line"><span> port smtp dsr</span></span>
<span class="line"><span> port 8100</span></span>
<span class="line"><span> port 8100  dsr</span></span>
<span class="line"><span> bind pop3  fe5 pop3  fe6 pop3  fe7 pop3  fe8 pop3</span></span>
<span class="line"><span> bind imap4 fe5 imap4 fe6 imap4 fe7 imap4 fe8 imap4</span></span>
<span class="line"><span> bind 5060  fe8 5060  fe7 5060  fe6 5060  fe5 5060</span></span>
<span class="line"><span> bind smtp  fe8 smtp  fe7 smtp  fe6 smtp  fe5 smtp</span></span>
<span class="line"><span> bind 8100  fe5 8100  fe6 8100  fe7 8100  fe8 8100</span></span>
<span class="line"><span>!</span></span>
<span class="line"><span>ip address 64.173.55.176 255.255.255.224</span></span>
<span class="line"><span>ip default-gateway 64.173.55.161</span></span>
<span class="line"><span>ip dns server-address 64.173.55.167</span></span>
<span class="line"><span>ip mu act</span></span>
<span class="line"><span>end</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You should NOT use the <code>port 5060 sip-switch</code>, <code>port sip sip-proxy-server</code>, or other &quot;smart&quot; (application-level) Load Balancer features.</p></div></li><li><p><strong>Alteon/Nortel AD3®</strong> (<code>64.173.55.176</code> is its service address, hardware port 1 is used for up-link, ports 5-8 connect frontend Servers)</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>script start &quot;Alteon AD3&quot; 4  /**** DO NOT EDIT THIS LINE!</span></span>
<span class="line"><span>/* Configuration dump taken 21:06:57 Mon Apr  9, 2007</span></span>
<span class="line"><span>/* Version 10.0.33.4,  Base MAC address 00:60:cf:41:f5:20</span></span>
<span class="line"><span>/c/sys</span></span>
<span class="line"><span>        tnet ena</span></span>
<span class="line"><span>        smtp &quot;mail.communigatepro.ru&quot;</span></span>
<span class="line"><span>        mnet 64.173.55.160</span></span>
<span class="line"><span>        mmask 255.255.255.224</span></span>
<span class="line"><span>/c/sys/user</span></span>
<span class="line"><span>        admpw &quot;ffe90d3859680828b6a4e6f39ad8abdace262413d5fe6d181d2d199b1aac22a6&quot;</span></span>
<span class="line"><span>/c/ip/if 1</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        addr 64.173.55.176</span></span>
<span class="line"><span>        mask 255.255.255.224</span></span>
<span class="line"><span>        broad 64.173.55.191</span></span>
<span class="line"><span>/c/ip/gw 1</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        addr 64.173.55.161</span></span>
<span class="line"><span>/c/ip/dns</span></span>
<span class="line"><span>        prima 64.173.55.167</span></span>
<span class="line"><span>/c/sys/ntp</span></span>
<span class="line"><span>        on</span></span>
<span class="line"><span>        dlight ena</span></span>
<span class="line"><span>        server 64.173.55.167</span></span>
<span class="line"><span>/c/slb</span></span>
<span class="line"><span>        on</span></span>
<span class="line"><span>/c/slb/real 5</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        rip 64.173.55.180</span></span>
<span class="line"><span>        addport 110</span></span>
<span class="line"><span>        addport 143</span></span>
<span class="line"><span>        addport 5060</span></span>
<span class="line"><span>        addport 25</span></span>
<span class="line"><span>        addport 8100</span></span>
<span class="line"><span>        submac ena</span></span>
<span class="line"><span>/c/slb/real 6</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        rip 64.173.55.181</span></span>
<span class="line"><span>        addport 110</span></span>
<span class="line"><span>        addport 143</span></span>
<span class="line"><span>        addport 5060</span></span>
<span class="line"><span>        addport 25</span></span>
<span class="line"><span>        addport 8100</span></span>
<span class="line"><span>        submac ena</span></span>
<span class="line"><span>/c/slb/real 7</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        rip 64.173.55.182</span></span>
<span class="line"><span>        addport 110</span></span>
<span class="line"><span>        addport 143</span></span>
<span class="line"><span>        addport 5060</span></span>
<span class="line"><span>        addport 25</span></span>
<span class="line"><span>        addport 8100</span></span>
<span class="line"><span>        submac ena</span></span>
<span class="line"><span>/c/slb/real 8</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        rip 64.173.55.183</span></span>
<span class="line"><span>        addport 110</span></span>
<span class="line"><span>        addport 143</span></span>
<span class="line"><span>        addport 5060</span></span>
<span class="line"><span>        addport 25</span></span>
<span class="line"><span>        addport 8100</span></span>
<span class="line"><span>        submac ena</span></span>
<span class="line"><span>/c/slb/group 1</span></span>
<span class="line"><span>        add 5</span></span>
<span class="line"><span>        add 6</span></span>
<span class="line"><span>        add 7</span></span>
<span class="line"><span>        add 8</span></span>
<span class="line"><span>        name &quot;all-services&quot;</span></span>
<span class="line"><span>/c/slb/port 1</span></span>
<span class="line"><span>        client ena</span></span>
<span class="line"><span>/c/slb/port 5</span></span>
<span class="line"><span>        server ena</span></span>
<span class="line"><span>/c/slb/port 6</span></span>
<span class="line"><span>        server ena</span></span>
<span class="line"><span>/c/slb/port 7</span></span>
<span class="line"><span>        server ena</span></span>
<span class="line"><span>/c/slb/port 8</span></span>
<span class="line"><span>        server ena</span></span>
<span class="line"><span>/c/slb/virt 1</span></span>
<span class="line"><span>        ena</span></span>
<span class="line"><span>        vip 64.173.55.164</span></span>
<span class="line"><span>/c/slb/virt 1/service pop3</span></span>
<span class="line"><span>        group 1</span></span>
<span class="line"><span>/c/slb/virt 1/service imap4</span></span>
<span class="line"><span>        group 1</span></span>
<span class="line"><span>/c/slb/virt 1/service 5060</span></span>
<span class="line"><span>        group 1</span></span>
<span class="line"><span>        udp enabled</span></span>
<span class="line"><span>        udp stateless</span></span>
<span class="line"><span>        nonat ena</span></span>
<span class="line"><span>/c/slb/virt 1/service smtp</span></span>
<span class="line"><span>        group 1</span></span>
<span class="line"><span>        nonat ena</span></span>
<span class="line"><span>/c/slb/virt 1/service 8100</span></span>
<span class="line"><span>        group 1</span></span>
<span class="line"><span>        nonat ena</span></span>
<span class="line"><span>/</span></span>
<span class="line"><span>script end  /**** DO NOT EDIT THIS LINE!</span></span></code></pre></div></li><li><p><strong>F5 Big-IP®</strong> (<code>64.173.55.176</code> is its service address)</p><p>Use the <em>nPath Routing</em> feature for SIP UDP/TCP traffic. This is F5 Networks, Inc. term for the Direct Server Response method.<br> Because F5 BigIP is not a switch, you must use the DSR (nPath Routing) method for all services.</p><p><code>bigip_base.conf:</code></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>vlan external {</span></span>
<span class="line"><span>  tag 4093</span></span>
<span class="line"><span>  interfaces</span></span>
<span class="line"><span>      1.1</span></span>
<span class="line"><span>      1.2</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>stp instance 0 {</span></span>
<span class="line"><span>  vlans external</span></span>
<span class="line"><span>  interfaces</span></span>
<span class="line"><span>      1.1</span></span>
<span class="line"><span>        external path cost 20K</span></span>
<span class="line"><span>        internal path cost 20K</span></span>
<span class="line"><span>      1.2</span></span>
<span class="line"><span>        external path cost 20K</span></span>
<span class="line"><span>        internal path cost 20K</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>self allow {</span></span>
<span class="line"><span>  default</span></span>
<span class="line"><span>      udp snmp</span></span>
<span class="line"><span>      proto ospf</span></span>
<span class="line"><span>      tcp https</span></span>
<span class="line"><span>      udp domain</span></span>
<span class="line"><span>      tcp domain</span></span>
<span class="line"><span>      tcp ssh</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>self 64.173.55.176 {</span></span>
<span class="line"><span>  netmask 255.255.255.224</span></span>
<span class="line"><span>  vlan external</span></span>
<span class="line"><span>  allow all</span></span>
<span class="line"><span>}</span></span></code></pre></div><p><code>bigip.conf:</code></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>partition Common {</span></span>
<span class="line"><span>   description &quot;Repository for system objects and shared objects.&quot;</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>route default inet {</span></span>
<span class="line"><span>   gateway 64.173.55.161</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>monitor MySMTP {</span></span>
<span class="line"><span>   defaults from smtp</span></span>
<span class="line"><span>   dest *:smtp</span></span>
<span class="line"><span>   debug &quot;no&quot;</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>profile fastL4 CGS_fastL4 {</span></span>
<span class="line"><span>   defaults from fastL4</span></span>
<span class="line"><span>   idle timeout 60</span></span>
<span class="line"><span>   tcp handshake timeout 15</span></span>
<span class="line"><span>   tcp close timeout 60</span></span>
<span class="line"><span>   loose initiation disable</span></span>
<span class="line"><span>   loose close enable</span></span>
<span class="line"><span>   software syncookie disable</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>pool Frontends {</span></span>
<span class="line"><span>   monitor all MySMTP and gateway_icmp</span></span>
<span class="line"><span>   members</span></span>
<span class="line"><span>      64.173.55.180:any</span></span>
<span class="line"><span>      64.173.55.181:any</span></span>
<span class="line"><span>      64.173.55.182:any</span></span>
<span class="line"><span>      64.173.55.183:any</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>node * monitor MySMTP</span></span></code></pre></div><p><code>bigip_local.conf:</code></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>virtual address 64.173.55.164 {</span></span>
<span class="line"><span>   floating disable</span></span>
<span class="line"><span>   unit 0</span></span>
<span class="line"><span>}</span></span>
<span class="line"><span>virtual External {</span></span>
<span class="line"><span>   translate address disable</span></span>
<span class="line"><span>   pool Frontends</span></span>
<span class="line"><span>   destination 64.173.55.164:any</span></span>
<span class="line"><span>   profiles CGS_fastL4</span></span>
<span class="line"><span>}</span></span></code></pre></div></li></ul><h2 id="TCPOutgoing" tabindex="-1">Outgoing TCP Connections <a class="header-anchor" href="#TCPOutgoing" aria-label="Permalink to &quot;Outgoing TCP Connections {#TCPOutgoing}&quot;">​</a></h2><p>When VIP addresses are assigned to CommuniGate Pro Domains, you may want to configure your CommuniGate Pro Modules to initiate outgoing TCP connections using these VIP addresses as source IP addresses. If you do so, the response TCP packets will be directed to the Load Balancer, which should be configured to direct them to the proper Cluster Member - to the CommuniGate Pro Server that has initiated the TCP connection.</p><p>For each Cluster Member that can initiate TCP connections (usually the frontend servers), select a port range for outgoing connections. These ranges should not intersect. For example, select the port range 33000-33999 for the first Cluster Member, 34000-34999 for the second Cluster Member, etc.</p><p>Make sure that the server OS is configured so that the selected port range is outside of the OS &quot;ephemeral port&quot; range. For example, the following command can be used to check the Linux OS &quot;ephemeral port&quot; range:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> cat /proc/sys/net/ipv4/ip_local_port_range</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">32768</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 61000</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&gt;</span></span></code></pre></div><p>And the following command can be used to change the Linux OS &quot;ephemeral port&quot; range:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> echo </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;50000 61000&quot;</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> &gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /proc/sys/net/ipv4/ip_local_port_range</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> cat /proc/sys/net/ipv4/ip_local_port_range</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">50000</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 61000</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&gt;</span></span></code></pre></div><p>To make these changes permanent, add the following line to the Linux <code>/etc/sysctl.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>net.ipv4.ip_local_port_range = 50000 61000</span></span></code></pre></div><p>For each of these Cluster members, open the Network settings in the WebAdmin Settings realm, and specify the selected TCP port range. Disable the Use for Media Proxy only option to make the CommuniGate Pro Server software use the selected port range for all outgoing TCP connections with a predefined source address.</p><p>Configure the Load Balancer: all packets coming to VIP address(es) and to any port in the selected port range should be directed to the corresponding Cluster Member.</p><h2 id="SoftBalancer" tabindex="-1">Software Load Balancer <a class="header-anchor" href="#SoftBalancer" aria-label="Permalink to &quot;Software Load Balancer {#SoftBalancer}&quot;">​</a></h2><p>The CommuniGate Pro Dynamic Cluster can be used to control software load balancers (such as Linux IPVS), running on the same systems as the Cluster members.</p><p>Select the cluster members to distribute the incoming traffic to. In a frontend-backend configuration, you would usually use all or some of the frontend servers for that.</p><p>Make sure that all selected cluster members have the VIP addresses configured as &quot;loopback aliases&quot; (see above).</p><p>Use the WebAdmin Interface to open the Cluster page in the Settings realm and select the Load Balancer group A for all selected servers:</p>`,44),s("form",{action:"Null.html"},[s("div",{class:"settingsBox"},[s("table",{width:"100%"},[s("tbody",null,[s("tr",null,[s("td",{align:"RIGHT",nowrap:"nowrap"},"Load Balancer Group:"),s("td",null,[s("select",{name:"BalancerGroup"},[s("option",{value:""}),s("option",{value:"A",selected:"selected"},"A"),s("option",{value:"B"},"B"),s("option",{value:"C"},"C"),s("option",{value:"D"},"D")])]),s("td",{nowrap:"nowrap"},[t("Balancer Weight: "),s("select",{class:"popup",name:"BalancerRatio"},[s("option",{value:"0"},"0"),s("option",{value:"10"},"10"),s("option",{value:"25"},"25"),s("option",{value:"50"},"50"),s("option",{value:"75"},"75"),s("option",{value:"80"},"80"),s("option",{value:"100",selected:"selected"},"100"),s("option",{value:"150"},"150"),s("option",{value:"200"},"200"),s("option",{value:"500"},"500"),s("option",{value:"101"},"other")])])])])])])],-1),n('<ul><li><p><code>Balancer Weight</code></p><p>Use this setting to specify relative weight of this server in the Load Balancer Group. The more this value, the larger part of incoming TCP connections and UDP packets will be directed to this server.</p></li></ul><p>All or some of the selected servers should be equipped with a software load balancer, and they should have an &quot;External Load Balancer&quot; Helper application configured. This application should implement the Load Balancer <a href="./../../development/Helpers.html#Balancer">Helper protocol</a>.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>External Load Balancer</b></td></tr></tbody><tbody><tr><td align="RIGHT" width="25%">Log Level:</td><td><select name="L3"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5" selected="selected">All Info</option></select></td><td align="RIGHT" width="25%">Program Path:</td><td><input name="P3" value="$Services/IPVSHelper.sh" size="30" maxlength="255" type="text"></td></tr><tr><td align="RIGHT">Time-out:</td><td><select class="popup" name="T3"><option value="0">Never</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="30" selected="selected">30 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="11">other</option></select></td><td align="RIGHT">Auto-Restart:</td><td><select class="popup" name="A3"><option value="0">Never</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="30">30 sec</option><option value="60" selected="selected">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="21600">6 hour(s)</option><option value="61">other</option></select></td></tr></tbody></table></div></form><p>As soon as the first Load Balancer helper application starts on some Cluster Member, the Cluster Controller activates that Helper, making it direct all incoming traffic to its Cluster member, and distribute that traffic to all active Cluster members in its Load Balancer Group.</p><p>If the Cluster Member running the active Load Balancer fails or it is switched into the &quot;non-ready&quot; state, the Cluster Controller activates some other Load Balancer member in that group (if it can find one).</p><h3 id="IPVS" tabindex="-1">Linux IPVS <a class="header-anchor" href="#IPVS" aria-label="Permalink to &quot;Linux IPVS {#IPVS}&quot;">​</a></h3><p>The CommuniGate Pro Linux package includes the <code>Services/IPVSHelper.sh</code> shell application that can be used to control the IPVS software load balancer.</p><p>The application expects that the VIP addresses are stored in the <code>/etc/sysconfig/vipaddrs</code> file, and the local interface (lo) aliases for these addresses have beeen created (see above).</p><p>Specify <code>$Services/IPVSHelper.sh _parameters_</code> as the External Load Balancer &quot;program path&quot;, and start it by selecting the Helper checkbox.<br> The following parameters are supported:</p><ul><li><p><code>-p _number_</code></p><p>persistence: all connections from the same IP address will be directed to the same Cluster Member if they come within <em>number</em> seconds after the existing connection. Specify 0 (zero) to switch persistance off. The default value is 15 seconds.</p></li><li><p><code>-i _interface_</code></p><p>the ethernet interface used to receive packets addressed to the VIP address(es). The default value is <code>eth0</code></p></li><li><p><code>-s _number_</code></p><p>the &quot;syncID&quot; value used to synchronize connection tables on the active load balancer and other Cluster Members that can become load balancers. The default value is 0.</p></li><li><p><code>-t _number_</code></p><p>the time-out (in seconds) for reading a command sent by the CommuniGate Pro Server. The default value is 15.</p></li><li><p><code>-f _filePath_</code></p><p>the file system path for the file containing the list of the VIP addresses. The default value is <code>/etc/sysconfig/vipaddrs</code></p></li><li><p><code>-r _number_</code></p><p>the relative weight of the active load balancer in the Load Balancer group. All other group members have the weight of 100. The default value is 100.</p></li><li><p><code>-m</code></p><p>if this parameter is specified, the Helper application does not execute actual shell commands, but only copies the commands it would execute to its standard output, so they are recorded in the CommuniGate Pro System Log.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Linux kernel 3.5.3-1 or later is recommended. When an earlier version is used, all TCP connections made to the active Load Balancer are dropped, when a different server becomes the active Load Balancer.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If a Cluster member has the External Balancer Helper application switched on, and then it is switched off, some active connections may be broken. If you do not plan to switch the Helper application back on, restart the <code>ipvsadm</code> service or switch it off completely.</p></div>',12)]))}const y=i(l,[["render",o]]);export{u as __pageData,y as default};
