import{_ as s,c as i,o as n,ag as a}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Plugins","description":"","frontmatter":{"legacyLink":"Plugins.html","outline":[2,3]},"headers":[],"relativePath":"development/Plugins.md","filePath":"development/Plugins.md"}'),t={name:"development/Plugins.md"};function p(l,e,o,r,c,h){return n(),i("div",null,e[0]||(e[0]=[a(`<h1 id="plugins" tabindex="-1">Plugins <a class="header-anchor" href="#plugins" aria-label="Permalink to &quot;Plugins&quot;">​</a></h1><p>Extensions allow you to extend the functionality of the CommuniGate server and its user interface in a simple way, by installing just one file, without having to modify the built-in functionality of the server.</p><p>You can install a plugin downloaded from <a href="https://communigatepro.ru/" target="_blank" rel="noreferrer">communigatepro.ru</a> or developed by yourself in the Users → Plugins section of the Dash administration interface.</p><h2 id="FileFormat" tabindex="-1">Plugin file format <a class="header-anchor" href="#FileFormat" aria-label="Permalink to &quot;Plugin file format {#FileFormat}&quot;">​</a></h2><p>The plugin file is a renamed ZIP archive with <code>.cgplugin</code> extension.</p><p>The plugin description file <code>cgplugin.json</code> must be placed in the root of the archive. JSON-Schema: <a href="cgplugin.schema.json">cgplugin.schema.json</a>.</p><p>Basic parameters of the plugin configuration file:</p><ul><li><code>id</code> <em>(required)</em> - The name of the plugin. Latin characters, numbers and underscores. Must be unique to a particular plugin. It is recommended to use the reverse of the domain name before the plugin name, for example, <code>ru_communigatepro_ExamplePlugin</code></li><li><code>author</code> <em>(required)</em> - The name of the author of the plugin. For example, <code>Ivan Ivanov</code> pr <code>AO SBK</code></li><li><code>version</code> <em>(required)</em> - Version of the plugin, following <a href="https://semver.org/" target="_blank" rel="noreferrer">SemVer 2.0</a> rules. For example, <code>1.0.0</code></li><li><code>title</code> <em>(required)</em> - Field name from <a href="#Locales">locale files</a> that would be used to display the plugin title in the admin interface. For example, <code>PluginTitle</code>.</li><li><code>description</code> <em>(optional)</em> - Field name from <a href="#Locales">locale files</a> that would be used to display the plugin description in the admin interface. For example, <code>PluginDescription</code>.</li><li><code>url</code> - The address of the plugin&#39;s home page. For example, <code>https://communigatepro.ru/</code></li><li><code>icon</code> - Optional file name of the icon from the archive to display the plugin when viewing it through the administration interface. The icon must be in svg format and have 1:1 (square) proportions.</li><li><code>min_product_version</code> - Optional parameter that specifies the minimal server version required for the plugin to work correctly. If the parameter is not specified, it is assumed that the plugin is compatible with all server versions.</li></ul><h2 id="Locales" tabindex="-1">Locales <a class="header-anchor" href="#Locales" aria-label="Permalink to &quot;Locales {#Locales}&quot;">​</a></h2><p>When you load a plugin, the available <a href="./WebApp.html#Strings">locale files</a> with <code>.data</code> extension written in a <a href="./Data.html#Dictionary">CommuniGate Pro Dictionary format</a> are loaded automatically.</p><p>Data from these dictionaries will be available to other code, including CG/PL scripts contained in the plugin, with a prefix of the form <code>&lt;plugin id&gt;.</code>.</p><h2 id="Extends" tabindex="-1">Extension points <a class="header-anchor" href="#Extends" aria-label="Permalink to &quot;Extension points {#Extends}&quot;">​</a></h2><p>The list of plugin points is populated in the <code>extends</code> section of the description file. Several types of plugins are available, described below.</p><h3 id="config" tabindex="-1">Configuration options <a class="header-anchor" href="#config" aria-label="Permalink to &quot;Configuration options {#config}&quot;">​</a></h3><p>Described in the <code>config</code> section as an object with descriptions of configuration parameters. Each key is an identifier of one configuration parameter, under which it will be stored and passed to CG/PL scripts run from the plugin.</p><ul><li><code>type</code> <em>(required)</em> - Parameter type, used to select the parameter storage format and type displayed in the admin interface widget. At the moment only parameters of the <code>string</code> and <code>boolean</code> types are supported.</li><li><code>title</code> <em>(required)</em> - A string from the <a href="#Locales">localization</a> files that will be used when the parameter is displayed in the administration interface.</li><li><code>required</code> - Whether the configuration parameter is mandatory to be filled in (if the field is missing, the parameter is optional).</li><li><code>editPresentation</code> - Allows you to specify how the parameter input control is displayed. We support <code>password</code> and <code>multilineText</code> presentations for <code>string</code> parameters. If nothing is specified for <code>string</code>, a standard single line input field will be shown.</li><li><code>enum</code> - Allows you to specify multiple valid options for a configuration parameter.</li><li><code>enumTitle</code> <em>(required if there is an enum)</em> - A string from the <a href="#Locales">locales</a> files that points to the dictionary that will be used for displaying configuration options in the administration interface.</li></ul><p>Example:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;APIKey&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;editPresentation&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;password&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;APIKeyTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;ServerType&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;enum&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;proxy&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;DNS&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mail&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">],</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;enumTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;ServerTypeEnumTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;ServerTypeTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><h3 id="checkConfig" tabindex="-1">Configuration check scripts <a class="header-anchor" href="#checkConfig" aria-label="Permalink to &quot;Configuration check scripts {#checkConfig}&quot;">​</a></h3><p>A script file in CG/PL language can be added to the plugin to check whether the configuration parameters are filled in correctly. This file must be located in the archive with plugin.</p><p>Such a script file can both perform basic checks on regular expressions or filling in fields, and check the correctness of entered parameters by accessing an external server. The script file must contain a single method <code>checkConfig</code>, which checks the configuration settings available to it via the <code>pluginSettings</code> property of the script&#39;s startup environment.</p><p>Config example:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;APIKey&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;APIKeyTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;checkConfig&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;checkconfig.scgp&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Script example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry checkConfig {</span></span>
<span class="line"><span>  var settings = Vars().pluginSettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(settings.APIKey) != 10) {</span></span>
<span class="line"><span>    SetResult(&quot;invalid API key&quot;)</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="vcs" tabindex="-1">Video conferences <a class="header-anchor" href="#vcs" aria-label="Permalink to &quot;Video conferences {#vcs}&quot;">​</a></h3><p>Described in the <code>vcs</code> section as an object with descriptions of scripts provided by the plugin for integration of videoconferencing systems (hereinafter - VCS). Key - an identifier that will be used to identify a particular VCS system inside CommuniGate Pro. Each description is an object with the following parameters:</p><ul><li><code>title</code> <em>(required)</em> - A string from the <a href="#Locales">localization</a> files that will be used when displaying the parameter in the user interface.</li><li><code>script</code> <em>(required)</em> - File name (with extension) of the script file contained in the archive in CG/PL language, implementing integration with VCS.</li><li><code>icon</code> <em>(optional)</em> svg file name with icon from the archive. The icon will be displayed to the user in the interface elements associated with the specific videoconferencing system. It should have 1:1 proportions (square).</li></ul><p>Example:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;vcs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;bbb&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;BBBTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;bbb.scgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;bbb.svg&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Each video conferencing support module should be a separate CG/PL script in <a href="./CGPL.html#SyncScripts">scgp format</a>.</p><p>Each function must be implemented by a separate method within the script file (a separate &quot;entry point&quot;). The script is always run in the context of the user creating the conference, be it through a calendar event or through a button in the chat room.</p><p>The entry points to be implemented in the script file code are described below.</p><h4 id="vcsCreateConf" tabindex="-1">Entry <code>createConf</code> <a class="header-anchor" href="#vcsCreateConf" aria-label="Permalink to &quot;Entry \`createConf\` {#vcsCreateConf}&quot;">​</a></h4><ul><li><p><code>createConf</code></p><p>Creates videoconference.</p><p>Parameters available in dictionary <code>Vars().startParameter</code>:</p><ul><li><p><code>title</code> <em>(optional)</em></p><p>Conference topic.</p></li><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description.</p></li><li><p><code>isAllDay</code> <em>(optional)</em></p><p>The flag indicating the type of conference, if the conference lasts the whole day from 0 to 24 hours - 1, if the conference has any other start and end time - 0.</p></li><li><p><code>rRule</code> <em>(optional)</em></p><p>The rule of recurrence of the event and the VCS, according to <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.8.5.3" target="_blank" rel="noreferrer">RFC5545, section 3.8.5.3</a>.</p><p>Example:</p><ul><li><p><code>FREQ=DAILY;UNTIL=20241215T000000Z</code></p><p>daily recurrence, until December 15, 2024.</p></li><li><p><code>FREQ=WEEKLY;BYDAY=SU,MO,TU,WE,TH,FR</code></p><p>weekly recurrence every day of the week.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYMONTHDAY=2;UNTIL=20250328T000000Z</code></p><p>monthly, every second month, the second day until March 28, 2025.</p></li><li><p><code>FREQ=MONTHLY;BYDAY=-1SU,-1MO,-1TU,-1WE,-1TH,-1FR,-1SA;UNTIL=20250319T000000Z</code></p><p>monthly every last Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, Sunday until March 19, 2025.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYDAY=1SU,1TU,1FR;UNTIL=20250321T000000Z</code></p><p>monthly every second month, every first Tuesday, Friday, Sunday until March 21, 2025.</p></li><li><p><code>FREQ=YEARLY;BYMONTH=4;BYMONTHDAY=6;UNTIL=20261231T000000Z</code></p><p>annually, every fourth month, every sixth day until December 31, 2026.</p></li></ul></li><li><p><code>from</code> <em>(optional)</em></p><p>Conference start time in UnixTime.</p></li><li><p><code>duration</code> <em>(optional)</em></p><p>The duration of the conference in seconds.</p></li><li><p><code>offset</code> <em>(optional)</em></p><p>The offset of the organizer&#39;s time zone relative to UTC (0) in seconds.</p></li><li><p><code>participants</code> <em>(optional)</em></p><p>Array of objects containing the list of the conference participants.</p><ul><li><p><code>name</code> <em>(optional)</em></p><p>Participant name</p></li><li><p><code>email</code></p><p>Participant e-mail address</p></li></ul></li></ul><p>The return value is a dictionary with fields:</p><ul><li><p><code>cid</code></p><p>The ID of the created conference in string format. The string must be URL friendly and must not contain spaces.</p></li><li><p><code>link</code></p><p>Shared link to connect to the conference.</p></li><li><p><code>participantLinks</code> <em>(optional)</em></p><p>A dictionary containing individual links to connect to the conference for all registered participants. If this integration does not support the creation of individual links, the parameter can be omitted. The key in the dictionary is the participant&#39;s e-mail address, the value is an individual link to connect to the conference:</p></li><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description. If a value is returned, it will overwrite the given field in the calendar event. The returned empty string will clear the field in the calendar event.</p></li></ul><p>Error:</p><ul><li><p><code>error</code></p><p>Text description of an error when creating a conference. If an error has occurred, the field must be present.</p></li></ul></li></ul><h4 id="vcsUpdateConf" tabindex="-1">Entry <code>updateConf</code> <a class="header-anchor" href="#vcsUpdateConf" aria-label="Permalink to &quot;Entry \`updateConf\` {#vcsUpdateConf}&quot;">​</a></h4><ul><li><p><code>updateConf</code></p><p>Updates videoconference.</p><p>Parameters available in dictionary <code>Vars().startParameter</code>. Similar to the parameters <a href="#vcsCreateConf">entry <code>createConf</code></a> with the addition of \`cid:</p><ul><li><p><code>cid</code></p><p>Conference ID or conference ID and additional parameters in Base64Url required to update the VCS.</p></li><li><p><code>title</code> <em>(optional)</em></p><p>Conference topic.</p></li><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description.</p></li><li><p><code>isAllDay</code> <em>(optional)</em></p><p>The flag indicating the type of conference, if the conference lasts the whole day from 0 to 24 hours - 1, if the conference has any other start and end time - 0.</p></li><li><p><code>rRule</code> <em>(optional)</em></p><p>The rule of recurrence of the event and the VCS, according to <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.8.5.3" target="_blank" rel="noreferrer">RFC5545, section 3.8.5.3</a>.</p><p>Example:</p><ul><li><p><code>FREQ=DAILY;UNTIL=20241215T000000Z</code></p><p>daily recurrence, until December 15, 2024.</p></li><li><p><code>FREQ=WEEKLY;BYDAY=SU,MO,TU,WE,TH,FR</code></p><p>weekly recurrence every day of the week.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYMONTHDAY=2;UNTIL=20250328T000000Z</code></p><p>monthly, every second month, the second day until March 28, 2025.</p></li><li><p><code>FREQ=MONTHLY;BYDAY=-1SU,-1MO,-1TU,-1WE,-1TH,-1FR,-1SA;UNTIL=20250319T000000Z</code></p><p>monthly every last Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, Sunday until March 19, 2025.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYDAY=1SU,1TU,1FR;UNTIL=20250321T000000Z</code></p><p>monthly every second month, every first Tuesday, Friday, Sunday until March 21, 2025.</p></li><li><p><code>FREQ=YEARLY;BYMONTH=4;BYMONTHDAY=6;UNTIL=20261231T000000Z</code></p><p>annually, every fourth month, every sixth day until December 31, 2026.</p></li></ul></li><li><p><code>from</code> <em>(optional)</em></p><p>Conference start time in UnixTime.</p></li><li><p><code>duration</code> <em>(optional)</em></p><p>The duration of the conference in seconds.</p></li><li><p><code>offset</code> <em>(optional)</em></p><p>The offset of the organizer&#39;s time zone relative to UTC (0) in seconds.</p></li><li><p><code>participants</code> <em>(optional)</em></p><p>An array of objects describing the participants of the videoconference.</p><ul><li><p><code>name</code> <em>(optional)</em></p><p>Participant name</p></li><li><p><code>email</code></p><p>Participant&#39;s e-mail address</p></li></ul></li></ul><p>Return value is a dictionary with fields:</p><ul><li><p><code>cid</code> <em>(optional, if you need to delete the VCS for the update)</em></p><p>The ID of the created conference in string format. The string must be URL friendly and not contain spaces, colons.</p></li><li><p><code>link</code> <em>(optional, if you need to delete the VCS for the update)</em></p><p>General link to connect to the conference.</p></li><li><p><code>participantLinks</code> <em>(optional)</em></p><p>A dictionary, containing individual links to connect to the conference for all registered participants. If this integration does not support the creation of individual links, the parameter can be omitted. The key in the dictionary is the participant&#39;s e-mail address, the value is an individual link to connect to the conference:</p></li><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description. If a value is returned, it will overwrite the given field in the calendar event. The returned empty string will clear the field in the calendar event.</p></li></ul><p>Error:</p><ul><li><p><code>error</code></p><p>Text description of the error when updating the conference. If an error has occurred, the field must be present.</p></li></ul></li></ul><h4 id="vcsDeleteConf" tabindex="-1">Entry <code>deleteConf</code> <a class="header-anchor" href="#vcsDeleteConf" aria-label="Permalink to &quot;Entry \`deleteConf\` {#vcsDeleteConf}&quot;">​</a></h4><ul><li><p><code>deleteConf</code></p><p>Deletes videoconference.</p><p>Parameters available in dictionary <code>Vars().startParameter</code>:</p><ul><li><p><code>cid</code></p><p>The conference ID or conference ID and additional Base64Url parameters required to delete the VCS are converted in the plugin.</p></li><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description.</p></li></ul><p>Return value is a dictionary with fields:</p><ul><li><p><code>description</code> <em>(optional)</em></p><p>Detailed conference topic description. If a value is returned, it will overwrite the given field in the calendar event. The returned empty string will clear the field in the calendar event.</p></li></ul><p>Error:</p><ul><li><p><code>error</code></p><p>Text description of the error when deleting the videoconference. If an error has occurred, the field must be present.</p></li></ul></li></ul><h3 id="freebusy" tabindex="-1">Free/Busy <a class="header-anchor" href="#freebusy" aria-label="Permalink to &quot;Free/Busy {#freebusy}&quot;">​</a></h3><p><code>freebusy</code> section as an object with descriptions of scripts provided by the plugin for getting Free/Busy information. Key is an identifier that will be used to identify the Free/Busy source server type which will be used to load Free/Busy information into CommuniGate Pro. Each description is an object with the following parameters:</p><ul><li><p><code>title</code> <em>(required)</em></p><p>A string from the <a href="#Locales">localization</a> files that will be used when displaying the parameter in the user interface.</p></li><li><p><code>script</code> <em>(required)</em></p><p>File name (with extension) of the script file contained in the archive in CG/PL language, implementing integration with freebusy.</p></li><li><p><code>config</code> <em>(optional)</em></p><p>Parameters passed to the script are the same as extension parameters. Available in script as <em>Vars().freebusySettings</em> dictionary.</p></li><li><p><code>checkConfig</code> <em>(optional)</em> File name (with extension) of the script file contained in the archive in <a href="./CGPL.html#SyncScripts">CG/PL language</a>, , implementing validation freebusy parameters config.</p></li></ul><p>Example:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {},</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;freebusy&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;CommunigatePro&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;CommunigateProTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;freebusy.scgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;Host&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;HostTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;checkConfig&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;checkFreeBusyConfig.scgp&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Each freebusy script must be a separate CG/PL script in <a href="./CGPL.html#SyncScripts">scgp format</a>. And must define entry points listed below:</p><h4 id="freebusyGetFreeBusy" tabindex="-1">Entry <code>getFreeBusy</code> <a class="header-anchor" href="#freebusyGetFreeBusy" aria-label="Permalink to &quot;Entry \`getFreeBusy\` {#freebusyGetFreeBusy}&quot;">​</a></h4><ul><li><p><code>getFreeBusy</code></p><p>Receive Free/Busy information.</p><p>Parameters available in dictionary <code>Vars().startParameter</code>:</p><ul><li><p><code>email</code> <em>(required)</em></p><p>e-mail address of the user for whom the information is requested.</p></li><li><p><code>timeStart</code> <em>(optionally)</em></p><p>Start of the requested employment information period in <a href="./CGPL.html#TimeStamps">timestamp format</a>.</p></li><li><p><code>timeEnd</code> <em>(optionally)</em></p><p>End of the requested employment information period in <a href="./CGPL.html#TimeStamps">timestamp format</a>.</p></li></ul><p>Returned value: string containing an iCalendar Object <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.4" target="_blank" rel="noreferrer">RFC 5545, section 3.4</a> including a <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.6.4" target="_blank" rel="noreferrer">RFC 5545, section 3.6.4</a> component. In case of an error, an empty string should be returned.</p></li></ul><p>The following data are available in script in addition to described above <code>Vars().startParameter</code>:</p><ul><li><p><code>Vars().pluginSettings</code> - dictionary</p><p>Common plugin settungs, described in <code>extends/config</code>.</p></li><li><p><code>Vars().freebusySettings</code> - dictionary</p><p>Free/Busy receiving settings for domain, described in <code>extends/freebusy/freebusyid_/config</code></p><ul><li><p><code>Host</code></p><p>address of the user&#39;s domain.</p></li><li><p><code>...</code></p><p>the rest of parameters declared in <code>extends/freebusy/config</code> section and filled by server/domain administrator.</p></li></ul></li></ul><p>Example of a script file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry getFreeBusy is</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // email is passed on in the dictionary startParameter</span></span>
<span class="line"><span>  var param = Vars().startParameter;</span></span>
<span class="line"><span>  var email = param.email;</span></span>
<span class="line"><span>  var timeStart = param.timeStart;</span></span>
<span class="line"><span>  var timeEnd = param.timeEnd;</span></span>
<span class="line"><span>  if (isDate(timeStart)) {</span></span>
<span class="line"><span>    // process timestamps if passed</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // pluginSettings and freebusySettings common for requests to the given Free/Busy domain (passed in the server as env environment variables)</span></span>
<span class="line"><span>  var pluginSettings = Vars().pluginSettings;</span></span>
<span class="line"><span>  var freebusySettings = Vars().freebusySettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  var host = freebusySettings.Host;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // send request</span></span>
<span class="line"><span>  var params = NewDictionary();</span></span>
<span class="line"><span>  params.responseFormat = &quot;&quot;;</span></span>
<span class="line"><span>  var url = host + &quot;~&quot; + email + &quot;/freebusy.vfb&quot;;</span></span>
<span class="line"><span>  var httpResult = HTTPCall(url, params);</span></span>
<span class="line"><span>  if (isString(httpResult)) {</span></span>
<span class="line"><span>    SetResult(httpResult);</span></span>
<span class="line"><span>  } else {</span></span>
<span class="line"><span>    SetResult(httpResult.body);</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>The script for checking the parameters for obtaining information about the availability / occupancy of participants (Free/Busy) should also be a separate <a href="./CGPL.html#SyncScripts">CG/PL</a> script. Entry point <code>checkConfig</code>. The script also has access to parameters for obtaining information about employment (Free/Busy) <em>Vars().freebusySettings</em> and general expansion parameters <em>Vars().pluginSettings</em>.</p><p>Example of a script file for validation Free/Busy settings:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry checkConfig {</span></span>
<span class="line"><span>  // common plugin settings</span></span>
<span class="line"><span>  var pluginSettings = Vars().pluginSettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // Free/Busy settings for current domain</span></span>
<span class="line"><span>  var freebusySettings = Vars().freebusySettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(freebusySettings.Host) == 0) {</span></span>
<span class="line"><span>    SetResult(&quot;Host is empty&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(freebusySettings.Password) &lt; 6) {</span></span>
<span class="line"><span>    SetResult(&quot;Password too short&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  var req = NewDictionary();</span></span>
<span class="line"><span>  req.method = &quot;GET&quot;;</span></span>
<span class="line"><span>  var res = HTTPCall(freebusySettings.Host), req);</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (!res.isDictionary()) {</span></span>
<span class="line"><span>    SetResult(&quot;failed to connect to server&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="helpers" tabindex="-1">Helpers <a class="header-anchor" href="#helpers" aria-label="Permalink to &quot;Helpers {#helpers}&quot;">​</a></h3><p>In the plugin you can add executable files of helpers (both binary and in scripting languages). They are used in the same way as those installed and configured on the page <a href="./Helpers.html">Helpers</a>.</p><p>Helpers from plugins can be one of two types: <a href="./Helpers.html#Filters">Message Filters</a> and <a href="./Helpers.html#AppHelpers">Application Helpers</a>. Helper&#39;s name defines name of object in <code>cgplugin.json</code>. Helpers are enabled by turning the extension on and off. Helpers can be configured from the extension settings page. Configuration parameters are also defined in <code>cgplugin.json</code>. For Helpers installed as part of plugins are available protocol command to server to receive plugin settings <code>GETCONFIG</code>, subscription to update plugin configuration, command to server <code>SUBSCRIBECONFIG</code> and server response if settings are changed <code>CONFIGUPDATED</code>. Read more in <a href="./Helpers.html#Protocol">helper&#39;s protocol description</a>.</p><p>Example of protocol message exchange (I - server message, O - helper message):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>O: H00007 GETCONFIG</span></span>
<span class="line"><span>I: H00007 OK { type = &quot;cat&quot; }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>O: H00005 SUBSCRIBECONFIG</span></span>
<span class="line"><span>I: H00005 OK</span></span>
<span class="line"><span></span></span>
<span class="line"><span>I: 00010 CONFIGUPDATED { type = &quot;dog&quot; }</span></span>
<span class="line"><span>O: 00010 OK</span></span></code></pre></div><p>Helpers described in the <code>helpers</code> extension point of plugin, objects with program descriptions for different architectures. In <code>all</code> object can be listed independent of architecture helpers, mostly written in scripting languages, If <code>helper_id</code> is overridden for the current architecture, it will be used. (In the example below on the machine with x86_64 will be started 2 helpers: <code>all/@helper_id1</code> and <code>x86_64/helper_id2</code>). The presence of <code>LogLevel</code>, <code>RestartPause</code>, <code>Timeout</code> parameters in the <code>config</code> section is necessary to specify the configuration of helpers in the plugin. If they are not specified, the server will set the predefined settings in this case..</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{</span></span>
<span class="line"><span>  &quot;extends&quot;: {</span></span>
<span class="line"><span>    &quot;config&quot;: {</span></span>
<span class="line"><span>      &quot;LogLevel&quot;: {</span></span>
<span class="line"><span>        &quot;type&quot;: &quot;string&quot;,</span></span>
<span class="line"><span>        &quot;required&quot;: false,</span></span>
<span class="line"><span>        &quot;title&quot;: &quot;LogLevelTitle&quot;</span></span>
<span class="line"><span>      },</span></span>
<span class="line"><span>      &quot;RestartPause&quot;: {</span></span>
<span class="line"><span>        &quot;type&quot;: &quot;string&quot;,</span></span>
<span class="line"><span>        &quot;required&quot;: false,</span></span>
<span class="line"><span>        &quot;title&quot;: &quot;RestartPauseTitle&quot;</span></span>
<span class="line"><span>      },</span></span>
<span class="line"><span>      &quot;Timeout&quot;: {</span></span>
<span class="line"><span>        &quot;type&quot;: &quot;string&quot;,</span></span>
<span class="line"><span>        &quot;required&quot;: false,</span></span>
<span class="line"><span>        &quot;title&quot;: &quot;TimeoutTitle&quot;</span></span>
<span class="line"><span>      },</span></span>
<span class="line"><span>      &quot;SomeExtensionParameter1&quot;: {</span></span>
<span class="line"><span>        &quot;type&quot;: &quot;string&quot;,</span></span>
<span class="line"><span>        &quot;required&quot;: false,</span></span>
<span class="line"><span>        &quot;title&quot;: &quot;SomeExtensionParameter1Title&quot;</span></span>
<span class="line"><span>      },</span></span>
<span class="line"><span>      &quot;SomeExtensionParameter2&quot;: {</span></span>
<span class="line"><span>        &quot;type&quot;: &quot;string&quot;,</span></span>
<span class="line"><span>        &quot;required&quot;: false,</span></span>
<span class="line"><span>        &quot;title&quot;: &quot;SomeExtensionParameter2Title&quot;</span></span>
<span class="line"><span>      }</span></span>
<span class="line"><span>    },</span></span>
<span class="line"><span>    &quot;helpers&quot;: {</span></span>
<span class="line"><span>      &quot;all&quot;: {</span></span>
<span class="line"><span>        &quot;helper_id1&quot;: {</span></span>
<span class="line"><span>          &quot;system_exe&quot;: &quot;/usr/bin/bash&quot;,</span></span>
<span class="line"><span>          &quot;exe&quot;: &quot;script1.sh&quot;,</span></span>
<span class="line"><span>          &quot;params&quot;: &quot;--logAll -k value1 --key2=value2&quot;,</span></span>
<span class="line"><span>          &quot;type&quot;: &quot;filter&quot;</span></span>
<span class="line"><span>        },</span></span>
<span class="line"><span>        &quot;helper_id2&quot;: {</span></span>
<span class="line"><span>          &quot;system_exe&quot;: &quot;/usr/bin/perl&quot;,</span></span>
<span class="line"><span>          &quot;exe&quot;: &quot;script2.pl&quot;,</span></span>
<span class="line"><span>          &quot;params&quot;: &quot;--p1 --p2 --p3&quot;,</span></span>
<span class="line"><span>          &quot;type&quot;: &quot;app&quot;</span></span>
<span class="line"><span>        }</span></span>
<span class="line"><span>      },</span></span>
<span class="line"><span>      &quot;x86_64&quot;: {</span></span>
<span class="line"><span>        &quot;helper_id2&quot;: {</span></span>
<span class="line"><span>          &quot;exe&quot;: &quot;program2&quot;,</span></span>
<span class="line"><span>          &quot;params&quot;: &quot;--p1 --p2&quot;,</span></span>
<span class="line"><span>          &quot;type&quot;: &quot;app&quot;</span></span>
<span class="line"><span>        }</span></span>
<span class="line"><span>      }</span></span>
<span class="line"><span>    }</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><p>In the description of the helpers in the extensions. At least one of the elements must be specified <code>system_exe</code>, <code>exe</code>.</p><ul><li><code>system_exe</code> <em>(optional)</em> - The executable file already present in the system was intended to specify the scripting language interpreter.</li><li><code>exe</code> <em>(optional)</em> - executable file as part of an plugin, binary or in a scripting language.</li><li><code>params</code> <em>(optional)</em> - command line arguments passed to helper.</li><li><code>type</code> <em>(required)</em> - helper&#39;s type, <code>app</code> or <code>filter</code>.</li></ul><h3 id="skins" tabindex="-1">Skins <a class="header-anchor" href="#skins" aria-label="Permalink to &quot;Skins {#skins}&quot;">​</a></h3><p>Skins files can be added to plugin (<a href="./WSSP.html">wssp</a>, <a href="./WebApp.html">wcgp</a>, images, js, css...) If a skin name matches and files in plugins are found, they can be used. The order of skin files search: domain-specific interfaces, “server-wide” interfaces, interfaces in plugins, server-supplied (stock) interfaces. A specific interface can only be specified once in an all extensions. If an plugin is disabled, the files and skins specified in it do not participate in the search. When you enable/disable an plugin with skins files on the server, the skins cache is reset.</p><p>Described in the <code>WebSkins</code> section as an object with skin name, where each object specifies a file directory or list of files. For an unnamed interface, you can specify an empty string as the interface name (an object with a description of the files used) or strings <code>unnamed</code>, <code>noname</code></p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;dirs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;hPronto-&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;files&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;login.wssp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;login.css&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>In the description of the skins in the plugins at least one of <code>dirs</code>, <code>files</code> must be present. All files listed in a <code>files</code> array must be present in plugin. Same for directory listed in <code>dirs</code>.</p><ul><li><code>dirs</code> <em>(optional)</em> - List of dirs (0 or 1) with skin files in the plugin.</li><li><code>files</code> <em>(optional)</em> - Skin files in the root of plugin.</li></ul><h3 id="sso" tabindex="-1">Single sign-on <a class="header-anchor" href="#sso" aria-label="Permalink to &quot;Single sign-on {#sso}&quot;">​</a></h3><p>The extension specifies a list of SSO authorization methods. This requires wcgp scripts from an unnamed (base) skin. This extension is required an extension point <a href="#skins">Skins</a> with unnamed skin.</p><p>Described in <code>SingleSignOn</code> array objects with the following fields:</p><ul><li><p><code>script</code> <em>(required)</em></p><p>File name of the <code>wcgp</code> script from the archive (must be added to an unnamed skin), added by the same plugin, which will be used to redirect the user to for logging in using SSO method when the corresponding button on the login screen is pressed .</p></li><li><p><code>title</code> <em>(required)</em></p><p>Field name from <a href="#Locales">locale files</a>, that would be used to display in the user interface.</p></li><li><p><code>icon</code> <em>(optional)</em></p><p>File name of the icon from the archive to display in the user interface. The icon must be in <code>svg</code> format. (The file must be in a plugin and added to an unnamed interface)</p></li></ul><p>Example</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;unnamed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;dirs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;SingleSignOn&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sso1.wcgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Title1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;icon1.svg&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sso2.wcgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Title2&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    ]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Each element of the array is a dictionary with the fields described above: <code>script</code>, <code>title</code>, <code>icon</code> (optional). In addition, each element has a field <code>PluginId</code>, it can be used to translate a field <code>title</code> (string translations from the plugin localization file).</p>`,76)]))}const k=s(t,[["render",p]]);export{u as __pageData,k as default};
