// ================================================== //
//      Contact Center Campaign interface module      //
//                    Version 2.2.5                   //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

function newCampHtml() {
  var dnames = getDayChkbxs();
  return '<h2>' + translate('newcamp') + '</h2><table cellspacing="10">' +
    '<tr><td>' + translate('name') + '</td><td><input type="text" class="name input bg" /></td></tr>' +
    '<tr><td>' + translate('activelines') + '</td><td><input type="text" data-value="maxChannels" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('maxAttempts') + '</td><td><input type="text" data-value="maxAttempts" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('method') + '</td><td><span class="select"><select data-action="dialMode" class="campParam">' +
    '<option value="progressive">' + translate('agent') + ' -> ' + translate('customer') + '</option><option value="predictive">' + translate('customer') + ' -> ' + translate('agent') + '</option>' +
    '</select></span></td></tr>' +
    '<tr><td>' + translate('onfail') + '</td>' +
    '<td><span class="select"><select data-action="onFail" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('onbusy') + '</td><td><span class="select"><select data-action="onBusy" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('noansw') + '</td><td><span class="select"><select data-action="noAnswer" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('startdate') + '<i class="description">dd-mm-yyyy</i></td><td><input data-value="dStart" type="text" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('stopdate') + '<i class="description">dd-mm-yyyy</i></td><td><input data-value="dEnd" type="text" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('starttime') + '</td><td>' + make_select('hrs', 'HrsFrom') + ' : ' + make_select('mnts', 'MntsFrom') + '<input data-value="tStart" type="hidden" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('stoptime') + '</td><td>' + make_select('hrs', 'HrsTo') + ' : ' + make_select('mnts', 'MntsTo') + '<input data-value="tEnd" type="hidden" class="campParam input bg" /></td></tr>' +
    '<tr><td colspan="2"><p class="weekDays">' + dnames + '</p></td></tr>' +
    '</table><p><button class="button bg upload">' + translate('uploadfile') + '</button>' +
    '<input type="file" style="display:none;" class="campFile" />' +
    '<button style="margin-left:20px;" class="create button ff0">' + translate('create') + '</button>' +
    '</p>';
}
function initCampHtml(cName) {
  var sel = $('.qCamp[data-value="' + cName + '"]');
  sel.html(
    '<h2 style="margin-bottom:10px;">' + cName + '</h2>' +
    '<p><button class="button ff0 settings">' + translate('settings') + '</button>' +
    '<button style="margin-left:20px;" class="button ff0 start">' + translate('start') + '</button>' +
    '<button style="margin-left:20px;" class="button bg pause">' + translate('pause') + '</button>' +
    '<button style="margin-left:20px;" class="button bg remove">' + translate('remove') + '</button>' +
    '</p><p class="turn"><b>' + translate('activeCalls') + '</b><span></span></p>' +
    '<ul class="table_tab ver2">' +
    '<li data-value="client" class="bg first">' + translate('clientList') + '</li>' +
    '<li data-value="answered" class="bg">' + translate('answList') + '</li>' +
    '<li data-value="scheduled" class="bg">' + translate('schList') + '</li>' +
    '<li data-value="failed" class="bg last">' + translate('failList') + '</li>' +
    '</ul><div class="campListContainer"></div>'
  );
  sel.find('.start').on('click', function() {
    setCampaignStatus(cName, 'inprocess');
  });
  sel.find('.pause').on('click', function() {
    setCampaignStatus(cName, 'paused');
  });
  sel.find('.remove').on('click', function() {
    if(confirm(translate('campRemovePrompt'))) {
      removeObject('campaign', cName);
    }
  });
  sel.find('.settings').on('click', function() {
    getSettings('campaign', cName);
  });
  sel.find('ul > li').on('click', function() {
    if($(this).hasClass('bg2')) {
      return;
    }
    getCampList(true ,cName, $(this).attr('data-value'), 0, 10);
  });
}
function setCampHandlers(cmpn) {
  cmpn.find('.action').on('change', function() {
    if($(this).val() == 'redial') {
      $(this).parent().siblings('.param').show();
    } else {
      $(this).parent().siblings('.param').hide();
    }
  });
  cmpn.find('.select').each(function() {
    select_html($(this));
  });
}
function setNewCampHandlers(cmpn) {
  cmpn.find('.create').on('click', function() {
    var files = cmpn.find('.campFile')[0].files;
    if(!files) {
      return;
    }
    var campSettings = {};
    campSettings.queueName = cmpn.parent().attr('id').substring(4);
    cmpn.find('.campParam[data-value="tStart"]').val(
      +cmpn.find('.HrsFrom').val() * 3600 +
      +cmpn.find('.MntsFrom').val() * 60
    );
    cmpn.find('.campParam[data-value="tEnd"]').val(
      +cmpn.find('.HrsTo').val() * 3600 +
      +cmpn.find('.MntsTo').val() * 60
    );
    cmpn.find('.campParam').each(function() {
      if($(this).attr('data-value')) campSettings[$(this).attr('data-value')] = $(this).val();
      else if($(this).attr('data-action')) campSettings[$(this).attr('data-action')] = $(this).val();
    });
    cmpn.find('.action').each(function() {
      campSettings[$(this).attr('data-action')] = {};
      campSettings[$(this).attr('data-action')].action = $(this).val();
      if($(this).val() == 'redial') {
        campSettings[$(this).attr('data-action')].period = $(this).parent().siblings('.param').children('.period').val();
        campSettings[$(this).attr('data-action')].attempts = $(this).parent().siblings('.param').children('.attempts').val();
      }
    });
    campSettings.weekDays = [];
    cmpn.find('.weekDays input:checkbox:checked').each(function() {
      campSettings.weekDays.push($(this).val());
    });
    handleFileUpload(files, '/private/settings/campaign');
    $(document).one('fileStored', function() {
      createObject('campaign',cmpn.find('.name').val(),campSettings,'/private/settings/campaign');
    });
  });
  cmpn.find('.upload').on('click', function() {
    cmpn.find('.campFile').trigger('click');
  });
  setCampHandlers(cmpn);
}
function assignCamp(cName, qName) {
  $('#mon_' + qName + ' .qCamp').attr('data-value', cName);
  $('#mon_' + qName + ' .head .camp').attr('data-value', cName);
}
function updateCampControls(cName) {
  if(!monitorData.campaign[cName]) {
    return;
  }
  var sel = $('.qCamp[data-value="' + cName + '"]');
  sel.find('.settings').siblings().hide();
  if(monitorData.campaign[cName].status == 'paused') {
    sel.find('.start, .remove').show();
  } else if(monitorData.campaign[cName].status == 'inactive' || monitorData.campaign[cName].status == 'inprocess') {
    sel.find('.pause').show();
  } else if(monitorData.campaign[cName].status == 'completed') {
    sel.find('.remove').show();
  }
}
function unsetCamp(cName) {
  displayCampStatus(cName, 'off');
  var cmpn = $('.qCamp[data-value="' + cName + '"]');
  cmpn.html(newCampHtml());
  fixQCampWidth(cName);
  setNewCampHandlers(cmpn);
  cmpn.attr('data-value', '');
  $('.head .camp[data-value="' + cName + '"]').attr('data-value', '');
}
function displayCampStatus(cName, status) {
  $('.head .camp[data-value="' + cName + '"] a').text(translate(['campStatus',status]));
}
function fixQCampWidth(cName) {
  var t = $('.camp[data-value="' + cName + '"]');
  if(t.hasClass('active')) {
		var head = t.parent();
    var li = head.parent();
		var h = head.outerHeight() + head.siblings('.qCamp').outerHeight();
		li.stop().animate({'height':h},700);
  }
}
function displayCampCall(callID) {
  var camp = monitorData.call[callID].campaign;
  var client = getUserPart(monitorData.call[callID].client);
  $('.qCamp[data-value="' + camp + '"] .turn > span').append('<a data-value="' + callID + '">' + client + '</a>');
}
function removeCampCall(callID) {
  var camp = monitorData.call[callID].campaign;
  $('.qCamp[data-value="' + camp + '"] .turn > span a[data-value="' + callID + '"]').remove();
}
function displayCampSettings(cName, s) {
  var cmpn = $('.qCamp[data-value="' + cName + '"]');
  cmpn.append('<div class="settings"></div>');
  var sel = cmpn.children('.settings');
  sel.siblings().hide();
  var dnames = getDayChkbxs();
  sel.html(
    '<h2>' + cName + '</h2><table cellspacing="10">' +
    '<tr><td>' + translate('activelines') + '</td><td><input type="text" data-value="maxChannels" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('maxAttempts') + '</td><td><input type="text" data-value="maxAttempts" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('method') + '</td><td><span class="select"><select data-action="dialMode" class="campParam">' +
    '<option value="progressive">' + translate('agent') + ' -> ' + translate('customer') + '</option><option value="predictive">' + translate('customer') + ' -> ' + translate('agent') + '</option>' +
    '</select></span></td></tr>' +
    '<tr><td>' + translate('onfail') + '</td>' +
    '<td><span class="select"><select data-action="onFail" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('onbusy') + '</td><td><span class="select"><select data-action="onBusy" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('noansw') + '</td><td><span class="select"><select data-action="noAnswer" class="action">' +
    '<option value="skip">' + translate('skip') + '</option><option value="redial">' + translate('redial') + '</option>' +
    '</select></span><span class="param" style="display:none;">' +
    '&nbsp;&nbsp;' + translate('attPeriod') + '&nbsp;&nbsp;<input type="text" size="4" class="period input bg">' +
    '&nbsp;&nbsp;' + translate('attempts') + '&nbsp;&nbsp;<input type="text" size="4" class="attempts input bg">' +
    '</span></td></tr>' +
    '<tr><td>' + translate('startdate') + '<i class="description">dd-mm-yyyy</i></td><td><input data-value="dStart" type="text" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('stopdate') + '<i class="description">dd-mm-yyyy</i></td><td><input data-value="dEnd" type="text" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('starttime') + '</td><td>' + make_select('hrs', 'HrsFrom') + ' : ' + make_select('mnts', 'MntsFrom') + '<input data-value="tStart" type="hidden" class="campParam input bg" /></td></tr>' +
    '<tr><td>' + translate('stoptime') + '</td><td>' + make_select('hrs', 'HrsTo') + ' : ' + make_select('mnts', 'MntsTo') + '<input data-value="tEnd" type="hidden" class="campParam input bg" /></td></tr>' +
    '<tr><td colspan="2"><p class="weekDays">' + dnames + '</p></td></tr>' +
    '</table><p><button class="back button bg">' + translate('backtocamp') + '</button>' +
    '<button style="margin-left:20px;" class="update button ff0">' + translate('update') + '</button>' +
    '</p>'
  );
  sel.find('.campParam').each(function() {
    if($(this).attr('data-value')) $(this).val(s[$(this).attr('data-value')]);
    else if($(this).attr('data-action')) $(this).val(s[$(this).attr('data-action')]);
  });
  sel.find('.action').each(function() {
    $(this).val(s[$(this).attr('data-action')].action);
    if($(this).val() == 'redial') {
      $(this).parent().siblings('.param').show();
      $(this).parent().siblings('.param').children('.period').val(s[$(this).attr('data-action')].period);
      $(this).parent().siblings('.param').children('.attempts').val(s[$(this).attr('data-action')].attempts);
    }
  });
  setCampHandlers(sel);
  if(s.tStart) {
    sel.find('.HrsFrom').val(getHrs(s.tStart)).trigger('change');
    sel.find('.MntsFrom').val(getMnts(s.tStart)).trigger('change');
  }
  if(s.tEnd) {
    sel.find('.HrsTo').val(getHrs(s.tEnd)).trigger('change');
    sel.find('.MntsTo').val(getMnts(s.tEnd)).trigger('change');
  }
  if(s.weekDays) {
    sel.find('.weekDays input:checkbox:checked').each(function() {
      if(s.weekDays.indexOf($(this).val()) < 0) {
        $(this).prop('checked', false);
      }
    });
  }
  sel.find('.back').on('click', function() {
    sel.siblings().show();
    sel.remove();
    fixQCampWidth(cName);
  });
  sel.find('.update').on('click', function() {
    var o = collectCampSettings(cName, sel);
    updateSettings('campaign',cName,o);
    sel.siblings().show();
    sel.remove();
    fixQCampWidth(cName);
  });
  fixQCampWidth(cName);
}
function collectCampSettings(cName, cmpn) {
  var campSettings = {};
  cmpn.find('.campParam[data-value="tStart"]').val(
    +cmpn.find('.HrsFrom').val() * 3600 +
    +cmpn.find('.MntsFrom').val() * 60
  );
  cmpn.find('.campParam[data-value="tEnd"]').val(
    +cmpn.find('.HrsTo').val() * 3600 +
    +cmpn.find('.MntsTo').val() * 60
  );
  cmpn.find('.campParam').each(function() {
    if($(this).attr('data-value')) campSettings[$(this).attr('data-value')] = $(this).val();
    else if($(this).attr('data-action')) campSettings[$(this).attr('data-action')] = $(this).val();
  });
  cmpn.find('.action').each(function() {
    campSettings[$(this).attr('data-action')] = {};
    campSettings[$(this).attr('data-action')].action = $(this).val();
    if($(this).val() == 'redial') {
      campSettings[$(this).attr('data-action')].period = $(this).parent().siblings('.param').children('.period').val();
      campSettings[$(this).attr('data-action')].attempts = $(this).parent().siblings('.param').children('.attempts').val();
    }
  });
  campSettings.weekDays = [];
  cmpn.find('.weekDays input:checkbox:checked').each(function() {
    campSettings.weekDays.push($(this).val());
  });
  campSettings.queueName = monitorData.campaign[cName].qName;
  return campSettings;
}
function getCampList(init, name, type, from, num) {
  var c = $('.qCamp[data-value="' + name + '"] .campListContainer');
  $.get(
    ccstatistics,
    {
      session: sessionId,
      op: 'getCampList',
      name: name,
      type: type,
      from: from,
      num: num,
    },
    function(data) {
      var r = $.parseJSON(data);
      if(init) {
        displayCampList(name, type, +from, +num, r);
      } else {
        updateCampList(name, type, +from, +num, r);
      }
      if(!r || !r.total || !r.data) {
        c.html('');
      }
    }
  ).fail(function(jqXHR) {
    alert(jqXHR.status + ', ' + jqXHR.responseText);
    console.log(jqXHR.status + ', ' + jqXHR.statusText + ', ' + jqXHR.responseText);
    c.html('');
  });
}
function displayCampList(name, type, from, num, r) {
  var c = $('.qCamp[data-value="' + name + '"]');
  var clc = c.find('.campListContainer');
  c.find('li[data-value="' + type + '"]').addClass('bg2').siblings().removeClass('bg2');
  clc.html('');
  addCampListFlipper(clc, name, type, from, num, +r.total);
  displayCampListTable(clc, type, r.data);
  fixQCampWidth(name);
}
function updateCampList(name, type, from, num, r) {
  var c = $('.qCamp[data-value="' + name + '"]');
  var clc = c.find('.campListContainer');
  var tbody = c.find('tbody');
  var cfp = c.find('.campFlipContainer');
  updateCampListFlipper(cfp, from, num, +r.total);
  campListTB(tbody, r.data);
  fixQCampWidth(name);
}
function updateCampListFlipper(c, from, num, total) {
  c.find('.posStart').text(from + 1).attr('data-value', from);
  c.find('.newFrom').val(from + 1);
  var posEnd = from + num;
  if(posEnd > total) {
    posEnd = total;
  }
  c.find('.posEnd').text(posEnd).attr('data-value', posEnd);
  c.find('.total').text(total);
  if(from < 1) {
    c.find('.prev').addClass('inactive');
  } else {
    c.find('.prev').removeClass('inactive');
  }
  if(posEnd == total) {
    c.find('.next').addClass('inactive');
  } else {
    c.find('.next').removeClass('inactive');
  }
}
function addCampListFlipper(c, name, type, from, num, total) {
  var posEnd = from + num;
  if(posEnd > total) {
    posEnd = total;
  }
  c.append(
    '<p class="campFlipContainer">' +
    '<span class="left">' + translate('showline') + '&nbsp;' +
    '<input type="text" class="input bg newFrom" value="' + (from + 1) + '" />&nbsp;' +
    '<button class="button ff0 goNewFrom">' + translate('go') + '</button></span>' +
    '<span class="campListPos">' +
    translate('display') + '&nbsp;' + make_select('campListNum', 'campListNum') + '&nbsp;' +
    '<span class="posStart" data-value="' + from + '">' + (from + 1) + '</span>-' +
    '<span class="posEnd" data-value="' + posEnd + '">' + posEnd + '</span>' +
    '&nbsp;' + translate('of') + '&nbsp;' +
    '<span class="total">' + total + '</span></span>' +
    '<button class="button bg prev inactive">&lt;</button>' +
    '<button class="button bg next ' + (total <= num ? 'inactive' : '') + '">&gt;</button></p>'
  );
  select_html(c.find('.select'));
  c.find('.campListNum').on('change', function() {
    num = $(this).val();
    getCampList(false, name, type, c.find('.posStart').attr('data-value'), num);
  });
  c.find('.prev').on('click', function() {
    if($(this).hasClass('inactive')) {
      return;
    }
    var posStart = c.find('.posStart').attr('data-value') - num;
    if(posStart < 0) {
      posStart = 0;
    }
    getCampList(false, name, type, posStart, num);
  });
  c.find('.next').on('click', function() {
    if($(this).hasClass('inactive')) {
      return;
    }
    getCampList(false, name, type, c.find('.posEnd').attr('data-value'), num);
  });
  c.find('.goNewFrom').on('click', function() {
    getCampList(false, name, type, (c.find('.newFrom').val() - 1), num);
  });
}
function displayCampListTable(c, type, data) {
  c.append(
    '<table width="100%" class="campListTable table_stat"><thead></thead><tbody></tbody></table>'
  );
  var thead = c.find('thead');
  thead.html(campListTH(type));
  var tbody = c.find('tbody');
  campListTB(tbody, data);
}
function campListTB(c, data) {
  c.html('');
  for(var i = 0; i < data.length; i++) {
    c.append(campListTR(data[i]));
  }
}
function campListTR(dataLine) {
  var result = '<tr>';
  for(var i = 0; i < dataLine.length; i++) {
    result += '<td>' + (translate(['campClientStatus', dataLine[i]]) || '') + '</td>';
  }
  result += '</tr>';
  return result;
}
function campListTH(type) {
  var result = '<tr>';
  if(type == 'client') {
    result += '<th width="33%">' + translate('client') + '</th>' +
      '<th width="33%">' + translate('name') + '</th>' +
      '<th width="33%">' + translate('status') + '</th>';
  } else if(type == 'answered') {
    result += '<th width="25%">' + translate('date') + '</th>' +
      '<th width="25%">' + translate('client') + '</th>' +
      '<th width="25%">' + translate('agent') + '</th>' +
      '<th width="25%">' + translate('timeconnect') + ' (' + translate('sec') + ')</th>';
  } else if(type == 'scheduled') {
    result += '<th width="33%">' + translate('date') + '</th>' +
      '<th width="33%">' + translate('client') + '</th>' +
      '<th width="33%">' + translate('status') + '</th>';
  } else if(type == 'failed') {
    result += '<th width="25%">' + translate('date') + '</th>' +
      '<th width="25%">' + translate('client') + '</th>' +
      '<th width="25%">' + translate('agent') + '</th>' +
      '<th width="25%">' + translate('status') + '</th>';
  }
  result += '</tr>';
  return result;
}
