// ================================================== //
//      Contact Center CG-Card interface module       //
//                   Version 2.2.5                    //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var cga_jsp;
var cgs_jsp;
var cgh_jsp;
var cg_num;
var cg_name;
var cg_email;
var cg_sel;
var script_list = [];
var cardData = {};
function postAddTel() {
  var addTelBtn = $('.add_tel:visible');
  var input = addTelBtn.siblings('input');
  addTelBtn.parent().parent().before('<tr><td align="right">' + translate('phone') + '</td><td><input type="text" class="bg input tel" disabled="disabled" value="' + input.val() + '" />&nbsp;&nbsp;&nbsp;<a class="pointer xIcon rmTel"></a></td><td></td></tr>');
  input.val('');
  addTelBtn.parent().parent().parent().find('.rmTel:last-child').on('click', function() {
    var num = $(this).siblings('.tel').val();
    if(num) {
      refuseTel(num);
    }
    $(this).parent().parent().remove();
  });
}
function updExistingTel() {
  var addTelBtn = $('.add_tel:visible');
  var input = addTelBtn.siblings('input');
  var c = $('.upd_cgc:visible').parent().parent();
  var card_uid = c.find('.card_uid').val();
  if(card_uid) updateTel(input.val(), card_uid);
}
function postAddEmail() {
  var addEmailBtn = $('.add_email:visible');
  var input = addEmailBtn.siblings('input');
  addEmailBtn.parent().parent().before('<tr><td align="right">' + translate('email') + '</td><td><input type="text" class="bg input email" disabled="disabled" value="' + input.val() + '" />&nbsp;&nbsp;&nbsp;<a class="pointer xIcon rmEmail"></a></td><td></td></tr>');
  input.val('');
  addEmailBtn.parent().parent().parent().find('.rmEmail:last-child').on('click', function() {
    var email = $(this).siblings('.email').val();
    if(email) {
      refuseEmail(email);
    }
    $(this).parent().parent().remove();
  });
}
function updExistingEmail() {
  var addEmailBtn = $('.add_email:visible');
  var input = addEmailBtn.siblings('input');
  var c = $('.upd_cgc:visible').parent().parent();
  var card_uid = c.find('.card_uid').val();
  if(card_uid) updateEmail(input.val(), card_uid);
}
$(document).ready(function() {
  $('#search_card .closeIcon').on('click', function() {
    $(this).parent().hide().siblings('#cgc_form').show();
  });
  $('#str_search_tab').on('click', function() {
    $(this).addClass('active').siblings('.active').removeClass('active');
    $('#search_card').show().siblings().hide();
  });
  $('#new_cgc').on('click', function() {
    clearCGCard($('#cgc_found'));
    $('#cgc_found').show();
    $('#search_card').hide();
  });
  $('#q_cgc').on('click', function() {
    delete cardData[$('#card_tabs li.active').attr('data-value')];
    $('#card_tabs li.active').remove();
    if($('#card_tabs li').length) {
      $('#card_tabs li:last-child').trigger('click');
    } else {
      $('#cgc_form').hide();
      $('#search_card').show();
    }
  });
  $('.add_tel').on('click', function() {
    var input = $(this).siblings('input');
    if(!input.val()) {
      return;
    }
    var c = $('.upd_cgc:visible').parent().parent();
    addTel(input.val(), c.find('.card_uid').val());
  });
  $('.add_email').on('click', function() {
    var input = $(this).siblings('input');
    if(!input.val()) {
      return;
    }
    var c = $('.upd_cgc:visible').parent().parent();
    addEmail(input.val(), c.find('.card_uid').val());
  });
  $('.upd_cgc').on('click', function() {
    $('#cgc').hide().siblings('.loader').show();
    var c = $(this).parent().parent();
    var cgc = {
      uid: c.find('.card_uid').val(),
      fn: c.find('.fn').val(),
      ln: c.find('.ln').val(),
      title: c.find('.title').val(),
      org: c.find('.org').val(),
      street: c.find('.street').val(),
      city: c.find('.city').val(),
      state: c.find('.state').val(),
      pc: c.find('.pc').val(),
      country: c.find('.country').val(),
      web: c.find('.web').val(),
      twitter: c.find('.twitter').val(),
      facebook: c.find('.facebook').val(),
      desc: c.find('.card_description').val(),
    };
    if(!cgc.fn || !cgc.ln) {
      alert(translate('pleasedefinefnln'));
      return;
    }
    if(cgc.uid) {
      cg_sel = c;
      updateCGCard(cgc);
      c.find('.tel').each(function() {
        updateTel($(this).val(), cgc.uid);
        if(cardData[$(this).val()]) {
          updateCardData(cgc, cardData[$(this).val()].cgcard);
        }
      });
      c.find('.email').each(function() {
        updateEmail($(this).val(), cgc.uid);
      });
    } else {
      delete cgc.uid;
      cg_sel = c;
      addCGCard(cgc);
      c.find('.card_uid').one('change', function() {
        var uid = $(this).val();
        c.find('.tel').each(function() {
          updateTel($(this).val(), uid);
          if(cardData[$(this).val()]) {
            updateCardData(cgc, cardData[$(this).val()].cgcard);
          }
        });
        c.find('.email').each(function() {
          updateEmail($(this).val(), uid);
        });
      });
    }
  });
  $('#req_card').on('click', function() {
    cg_num = $('#search_form .num').val();
    cg_name = $('#search_form .name').val();
    cg_email = $('#search_form .email').val();
    $('#search_form .num').val('');
    $('#search_form .name').val('');
    $('#search_form .email').val('');
    cgSearch(cg_num, cg_name, cg_email);
  });
  $('#cgc_found .closeIcon').on('click', function() {
    clearCGCard($('#cgc_found'));
    $('#cgc_found').hide();
    $('#search_card').show();
  });
  $('#new_search').on('click', function() {
    $('#search_rl table').html('');
    $('#search_rl').hide();
    $('#search_form').show();
  });
  $('#scripting .open .closeIcon').on('click', function() {
    $(this).parent().hide().siblings().show();
    setTimeout(function() {$('.header .menu li.card').trigger('click')}, 50);
  });
});

function updateCardData(cgc, data) {
  var keys = Object.keys(cgc);
  for(var i = 0; i < keys.length; ++i) {
    data[keys[i]] = cgc[keys[i]];
  }
}

function displayCGCard(CGCard, c, f) {
  if(!CGCard) {
    return;
  }
  var cgc = CGCard.cgcard;
  var tel = CGCard.tel;
  if(cgc && c.find('.card_uid').val() == cgc.uid && c.is(':visible')) {
    return;
  }
  if(c.is('#cgc_form') && !f) {
    if(!tel || !tel.num) {
      return;
    }
    if(cardData[tel.num]) {
      return;
    }
    cardData[tel.num] = CGCard;
    $('#card_tabs').append('<li class="pointer" data-value="' + tel.num + '">' + tel.num + '</li>');
    $('#card_tabs li:last-child').on('click', function() {
      $(this).addClass('active').siblings('.active').removeClass('active');
      displayCGCard(cardData[$(this).attr('data-value')], c, true);
    });
    if($('#card_tabs li').length == 2) {
      $('#card_tabs li:last-child').trigger('click');
    } else {
      return;
    }
  }
  clearCGCard(c);
  c.find('.card_uid').val(cgc.uid);
  c.find('.fn').val(cgc.fn);
  c.find('.ln').val(cgc.ln);
  c.find('.title').val(cgc.title);
  c.find('.org').val(cgc.org);
  c.find('.street').val(cgc.street);
  c.find('.city').val(cgc.city);
  c.find('.state').val(cgc.state);
  c.find('.pc').val(cgc.pc);
  c.find('.country').val(cgc.country);
  c.find('.web').val(cgc.web);
  c.find('.twitter').val(cgc.twitter);
  c.find('.facebook').val(cgc.facebook);
  if(!cgc.desc) {
    cgc.desc = '';
  }
  cgc.desc = cgc.desc.replace(/<endline>/g, "\n");
  c.find('.card_description').text(cgc.desc);
  if(!cgc.tel && cg_num && c.attr('id') == 'cgc_found') {
    cgc.tel = [{num: cg_num}];
    addTel(cg_num);
  }
  if(!cgc.email && cg_email && c.attr('id') == 'cgc_found') {
    cgc.email = [{email: cg_email}];
    addEmail(cg_email);
  }
  if(typeof(cgc.tel) == 'object' && 'length' in cgc.tel) {
    for(var i = 0; i < cgc.tel.length; i++) {
      if(!cgc.tel[i].num) continue;
      c.find('.add_tel').parent().parent().before('<tr><td align="right">' + translate('phone') + '</td><td><input type="text" class="bg input tel" disabled="disabled" value="' + cgc.tel[i].num + '" />&nbsp;&nbsp;&nbsp;<a class="pointer xIcon rmTel"></a></td><td></td></tr>');
      c.find('.rmTel:last-child').on('click', function() {
        var num = $(this).siblings('.tel').val();
        if(num) {
          refuseTel(num);
        }
        $(this).parent().parent().remove();
      });
    }
  } else if(tel && !c.find('.tel[value="' + tel.num + '"]').length) {
    c.find('.tel_del').after('<tr><td align="right">' + translate('phone') + '</td><td><input type="text" class="bg input tel" disabled="disabled" value="' + tel.num + '" />&nbsp;&nbsp;&nbsp;<a class="pointer xIcon rmTel"></a></td><td></td></tr>');
    c.find('.rmTel:last-child').on('click', function() {
      var num = $(this).siblings('.tel').val();
      if(num) {
        refuseTel(num);
      }
      $(this).parent().parent().remove();
    });
  }
  if(typeof(cgc.email) == 'object' && 'length' in cgc.email) {
    for(var i = 0; i < cgc.email.length; i++) {
      if(!cgc.email[i].email) continue;
      c.find('.add_email').parent().parent().before('<tr><td align="right">' + translate('email') + '</td><td><input type="text" class="bg input email" disabled="disabled" value="' + cgc.email[i].email + '" />&nbsp;&nbsp;&nbsp;<a class="pointer xIcon rmEmail"></a></td><td></td></tr>');
      c.find('.rmEmail:last-child').on('click', function() {
        var email = $(this).siblings('.email').val();
        if(email) {
          refuseEmail(email);
        }
        $(this).parent().parent().remove();
      });
    }
  }
  //if($('#search_card').is(':visible')) {
    //$('#search_card').hide();
    c.siblings().hide();
    c.show();
  //}
}

function clearCGCard(c) {
  if(!c) {
    return;
  }
  c.find('.fn').val('');
  c.find('.ln').val('');
  c.find('.title').val('');
  c.find('.org').val('');
  c.find('.street').val('');
  c.find('.city').val('');
  c.find('.state').val('');
  c.find('.pc').val('');
  c.find('.country').val('');
  c.find('.web').val('');
  c.find('.twitter').val('');
  c.find('.facebook').val('');
  c.find('.card_description').text('');
  c.find('.card_uid').val('');
  c.find('.tel, .email').each(function() {
    $(this).parent().parent().remove();
  });
}

function displayCGSearchRL(cgs) {
  if(!cgs || !('length' in cgs)) {
    return;
  }
  var c = $('#search_rl table');
  c.html('');
  if(cgs.length) {
    for(var i = 0; i < cgs.length; i++) {
      c.append('<tr class="pointer hlHover" data-value="' + cgs[i].uid + '"><td>' + (cgs[i].fn ? cgs[i].fn + ' ' : '') + (cgs[i].ln ? cgs[i].ln : '') + '</td>' +
        '<td>' + (cgs[i].tel.length ? cgs[i].tel[0].num : '') + '</td>' +
        '<td>' + (cgs[i].email.length ? cgs[i].email[0].email : '') + '</td></tr>'
      );
    }
    c.find('tr').on('click', function() {
      getCGCard($(this).attr('data-value'));
    });
  } else {
    c.append('<tr><td align="center">' + translate('noresult') + '</td></tr>');
  }
  $('#search_form').hide();
  $('#search_rl').show();
}

function addCGAgent(name) {
  if(!monitorData.agent[name]) {
    return;
  }
  var a = monitorData.agent[name];
  $('#cga').append('<tr><td><div class="cg_agent bg" data-value="' + name + '"><table width="100%">' +
    '<tr>' +
    '<td width="33%"><h2>' + name + '</h2></td>' +
    '<td width="33%"><span class="realName">' + (a.realName ? a.realName : '') + '</span></td>' +
    '<td width="33%"><span class="extensions">' + a.extensions.join(',') + '</span></td>' +
    '</tr><tr>' +
    '<td><span class="icon ' + a.status + '"></span><span class="status">' +
    (a.statusInfo ? a.statusInfo : translate(['agentStatus', a.status])) + '</span></td>' +
    '<td><span class="busyTime"></span></td><td><span class="call"></span></td></tr>' +
  '</table></div></td></tr>');
  var cafs = $('#str_sc_ag select');
  if(cafs.val()) {
    if((cafs.val() == a.status && a.statusInfo == null) || cafs.val() == a.statusInfo) {
      $('#cga div[data-value="' + name + '"]').show();
    } else {
      $('#cga div[data-value="' + name + '"]').hide();
    }
  }
}

function displayScriptList() {
  var c;
  if($('.header .menu li.logo').hasClass('bg')) {
    if($('#tabQueues').hasClass('active')) {
      c = $('#tabQueues');
    } else {
      c = $('#tabUsers');
    }
    c.prepend(
      '<div class="scriptList right onethirdwidth bg standheight">' +
      '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
      '<div class="marg20"><h2>' + translate('scripts') + '</h2><br />' +
      '<div><div class="scrollList"><div></div></div>' +
      '<p><button class="button ff0 uploadScript">' + translate('uploadfile') + '</button><input type="file" id="uploadScript" style="display:none" /></p></div>'
    );
    for(var i = 0; i < script_list.length; i++) {
      c.find('.scriptList .scrollList > div').append('<p class="pointer hlHover" data-value="' + script_list[i] + '">' + script_list[i] + '</p>');
    }
    //c.find('.scriptList .scrollList').jScrollPane();
    c.find('.scriptList .scrollList p').on('click', function() {
      var s;
      if($('.agentSettings').length) {
        s = $('.agentSettings .script');
      } else {
        s = $('.queueSettings .script');
      }
      s.val($(this).attr('data-value'));
      $('.scriptList').remove();
    });
    $('.scriptList .closeIcon').on('click', function() {
      $('.scriptList').remove();
    });
    $('.scriptList .uploadScript').on('click', function() {
      $('#uploadScript').trigger('click');
    });
    $('#uploadScript').on('change', function() {
      var files = $(this)[0].files;
      if(!files) {
        return;
      }
      handleFileUpload(files, script_dir + '/' + files[0].name);
      $(document).one('fileStored', function() {
        $('.scriptList').remove();
        script_list = [];
        getScriptList();
      });
    });
    /*var corr;
    if(c.attr('id') == 'tabQueues') {
      corr = $('#defaultSettings').height();
      if($('.agentSettings').length) {
        corr *= 2;
      }
    } else {
      corr = $('#newUser').height();
    }
    $('.scriptList').css('top', -corr);
    $('.scriptList').css('position', 'relative');
    */
  } else {
    c = $('#scr_list');
    c.html('');
    for(var i = 0; i < script_list.length; i++) {
      c.append('<p class="pointer hlHover" data-value="' + script_list[i] + '">' + script_list[i] + '</p>');
    }
    c.find('p').on('click', function() {
      getScript($(this).attr('data-value'));
    });
    //cgs_jsp = $('#scripting .scrollList').jScrollPane({contentWidth: '0px'}).data().jsp;
    //setTimeout(function() {$('.header .menu li.card').trigger('click')}, 100);
  }
}

function displayScript(name, text) {
  var c = $('#scripting .open');
  name = name.substring(script_dir.length + 1);
  c.find('h2').text(name);
  text = text.replace(/\n/g, '<br />');
  c.find('.scenario').html(text);
  c.show().siblings().hide();
  //c.find('.scrollList').jScrollPane({contentWidth: '0px'});
}
function openScriptOnCall(name) {
  if(!name) {
    return;
  }
  $('#scenario .table_tab .scr').trigger('click');
  getScript(name);
}
function getCGHistory() {
  var cgc_found = $('#cgc_found .card_uid').val();
  var cgc_form = $('#cgc_form .card_uid').val();
  if($('#cgc_found:visible').length && cgc_found) {
    getCGCalls(cgc_found);
  } else if($('#cgc_form:visible').length && cgc_form) {
    getCGCalls(cgc_form);
  } else if(cgc_found) {
    getCGCalls(cgc_found);
  } else if(cgc_form) {
    getCGCalls(cgc_form);
  } else {
    $('#cg_card .table_tab li.cgc').trigger('click');
  }
}
function displayCGCalls(arr) {
  if(cgh_jsp) {
    cgh_jsp.destroy();
  }
  $('#cg_call').html('');
  for(var i = 0; i < arr.length; i++) {
    var date = new Date(arr[i].date * 1000);
    date.setMinutes(date.getMinutes() + date.getTimezoneOffset());
    var dd = date.getDate().toString();
    if(dd.length == 1) dd = '0' + dd;
    var mm = (date.getMonth() + 1).toString();
    if(mm.length == 1) mm = '0' + mm;
    var hh = date.getHours().toString();
    if(hh.length == 1) hh = '0' + hh;
    var min = date.getMinutes().toString();
    if(min.length == 1) min = '0' + min;
    var ds = dd + '-' + mm + ' ' + hh + ':' + min;
    var urlFile = arr[i].pathToRecord;
    if(urlFile) {
			urlFile = '/Session/' + sessionId + '/DOWNLOAD/' + urlFile;
      urlFile = encodeURI(urlFile).replace(/#/g, '%23');
    }
    var st = arr[i].status;
    if (st == 'answered') st = translate('Answered');
    else if (st == 'missed') st = translate('Missed');
    else if (st == 'unanswered') st = translate('Unanswered');
    else if (st == 'transferred') st = translate('Transferred');
    else if (st == 'outanswered') st = translate('busy');
    else if (st == 'outfailed') st = translate('failed');
    $('#cg_call').append(
      '<tr><td>' + ds + '</td><td>' + arr[i].callFrom + '</td><td>' + arr[i].peers + '</td><td>' + st + '</td>' +
      '<td>' + (urlFile ? '<a class="rec" href="' + urlFile + '" target="_blank"></a>' :
      (arr[i].status == 'answered' || arr[i].status == 'outanswered' ? '<a class="rec off"></a>' : '')) + '</td></tr>'
    );
  }
  //cgh_jsp = $('#cgh .scrollList').jScrollPane({contentWidth: '0px'}).data().jsp;
  //$('.header .menu li.card').trigger('click');
}
