// ================================================== //
//      Contact Center Settings interface module      //
//                     Version 2.2.6                  //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var curGroup;
var curAgent;
var curSms;
var genSel = false;
var ops09 = '<option value="0">0</option><option value="1">1</option>' +
  '<option value="2">2</option><option value="3">3</option>' +
  '<option value="4">4</option><option value="5">5</option>' +
  '<option value="6">6</option><option value="7">7</option>' +
  '<option value="8">8</option><option value="9">9</option>';
var crmOps = '';
var smsTable = {};
var smsTableName = '*';

$(document).ready(function() {
  $('#create_queue').on('click', function() {
    var queueName = $('.queueNameNew').val().toLowerCase();
    $('.queueNameNew').val('');
    if(queueName) {
      createUser(queueName);
      var c = $('.queueSettings');
      if(!c.length) {
        $('#tabQueues').append(
          '<div class="queueSettings bg standheight left twothirdwidth">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div></div>'
        );
      } else {
        c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div>'
        );
      }
      $('#tabQueues .closeIcon').on('click', function() {
        $(this).parent().remove();
        $('.agentList').remove();
        $('#ccObjectsList .bg').removeClass('bg');
      });
      $('.queueSettings').on('userCreated', function() {
        createObject('group', queueName, dummyGroupSettings);
        $('.queueSettings').off('userCreated');
      });
      $('.queueSettings').on('objCreated', function() {
        getGroups();
        getSettings('group', queueName);
        curGroup = queueName;
        $('.queueSettings').off('objCreated');
      });
    }
  });
  for(var i = 0; i < crmList.length; i++) {
    crmOps += '<option value="' + crmList[i] + '">' + crmList[i] + '</option>';
  }
});

function displaySettings(s) {
  closeOverlay();
  if(s.type == 'general') {
    s = s.settings;
    if(s) {
      generalSettings = s;
      var c = $('#defaultSettings .agent');
      c.html('<table cellspacing="10" cellpadding="10" width="100%" class="detals">' +
        '<tr><td colspan="4"><h3 class="dark">' + translate('agent') + '</h3></td></tr>' +
        '<tr><td width="25%"><label>' + translate('agentInitialStatus') + '</label><br /><i class="description">' + translate('agentInitialStatusinstruction') + '</i></td><td width="25%">' +
        make_select('st', 'agentInitialStatus', s.agentInitialStatus, null) + '</td>' +
        '<td width="25%"><label>' + translate('agentPty') + '</label><br />' +
        '<i class="description">' + translate('ptyinstruction') + '</i></td><td width="25%">' +
        '<span class="select"><select class="agentPty">' + ops09 +
        '</select></span></td></tr>' +
        '<tr><td><label>' + translate('agentSkill') + '</label><br /><i class="description">' + translate('agentSkillinstruction') + '</i></td><td>' +
        '<span class="select"><select class="agentSkill">' + ops09 +
        '</select></span></td><td><label>' + translate('alertTimeout') + '</label><br />' +
        '<i class="description">' + translate('alertTimeoutinstruction') + '</i></td><td>' +
        make_select('ctout', 'alertTimeout') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td></tr>' +
        '<tr><td><label>' + translate('aacw') + '</label><br /><i class="description">' + translate('agentACWinstruction') + '</i></td><td>' + make_select('ctout', 'agentACWTimeout', s.agentACWTimeout) +
        '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
        '<td><label>' + translate('agentMonitorMode') + '</label><br /><i class="description">' + translate('agentMonitorinstruction') + '</i></td>' +
        '<td><span class="select"><select class="agentMonitorMode">' +
        '<option value="ownQueues">' + translate('ownQueues') + '</option>' +
        '<option value="allQueues">' + translate('allQueues') + '</option>' +
        '</select></span></td></tr>' +
        '<tr><td><label>' + translate('iFrameName') + '</label><br /><i class="description">' + translate('iFrameNameinstruction') + '</i></td>' +
        '<td><input class="iFrameName bg input" type="text" size="10" /></td>' +
        '<td><label>' + translate('iFrameUrl') + '</label><br /><i class="description">' + translate('iFrameURLinstruction') + '</i></td>' +
        '<td><input class="iFrameUrl bg input" type="text" size="10" /></td></tr>' +
        '<tr><td><label>' + translate('browsernotifications') + '</label><br />' +
        '<i class="description">' + translate('notificationsinstruction') + '</i></td>' +
        '<td><span class="select"><select class="browserNotifications">' +
        '<option value="on">' + translate('on') + '</option>' +
        '<option value="off">' + translate('off') + '</option></select></span></td>' +
        '<td><label id="showSTL" class="yellow border pointer">' + translate('smstemplates') + '</label></td><td></td>' +
        '<tr><td><label>' + translate('sessionMode') + '</label><br />' +
        '<i class="description">' + translate('sessionmodeinstruction') + '</i></td>' +
        '<td><span class="select"><select class="sessionMode">' +
        '<option value="">-----</option></select></span></td><td></td><td></td></tr>' +
        '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>'
      );
      c = $('#defaultSettings .queue');
      c.html('<table cellspacing="10" cellpadding="10" width="100%" class="detals">' +
        '<tr><td colspan="4"><h3 class="dark">' + translate('queue') + '</h3></td></tr>' +
        '<tr><td width="25%"><label>' + translate('groupPty') + '</label><br />' +
        '<i class="description">' + translate('ptyinstruction') + '</i></td><td width="25%">' +
        '<span class="select"><select class="groupPty">' + ops09 +
        '</select></span></td>' +
        '<td width="25%"><label>' + translate('gacw') + '</label><br /><i class="description">' + translate('groupACWinstruction') + '</i></td>' +
        '<td width="25%">' + make_select('ctout', 'groupACWTimeout', s.groupACWTimeout) +
        '<input type="text" size="4" class="input bg custom" style="display:none;" /></td></tr>' +
        '<tr><td><label>' + translate('ringStrategy') + '</label><br /><i class="description">' + translate('ringStrategyinstruction') + '</i></td><td>' +
        '<span class="select"><select class="ringStrategy">' +
        '<option value="random">' + translate(['ringStrDict', 'random']) + '</option>' +
        '<option value="serial">' + translate(['ringStrDict', 'serial']) + '</option>' +
        '<option value="allFree">' + translate(['ringStrDict', 'allFree']) + '</option>' +
        '<option value="inOrder">' + translate(['ringStrDict', 'inOrder']) + '</option>' +
        '<option value="fewestCalls">' + translate(['ringStrDict', 'fewestCalls']) + '</option>' +
        '<option value="leastBusy">' + translate(['ringStrDict', 'leastBusy']) + '</option>' +
        '<option value="leastRecent">' + translate(['ringStrDict', 'leastRecent']) + '</option>' +
        '<option value="bySkill">' + translate(['ringStrDict', 'bySkill']) + '</option>' +
        '</select></span></td>' +
        '<td><label>' + translate('crmrouting') + '</label><br />' +
        '<i class="description">' + translate('crmroutinginstruction') + '</i></td>' +
        '<td><span class="select"><select class="useCRMRouting">' +
        '<option value="NO">' + translate('off') + '</option>' +
        '<option value="YES">' + translate('on') + '</option></select></span></td></tr>' +
        '<tr><td><label>' + translate('welcomeMusicList') + '</label><br /><i class="description">' + translate('welcomeMusicListinstruction') + '</i></td><td>' +
        '<input class="welcomeMusicList bg input" type="text" size="10" /></td>' +
        '<td><label>' + translate('waitingMusicList') + '</label><br /><i class="description">' + translate('waitingMusicListinstruction') + '</i></td><td>' +
        '<input class="waitingMusicList bg input" type="text" size="10" /></td></tr>' +
        '<tr><td><label>' + translate('agentSorting') + '</label><br /><i class="description">' + translate('agentSortinginstruction') + '</i></td><td>' +
        '<span class="select"><select class="agentSorting">' +
        '<option value="inOrder">' + translate(['agentSortingDict', 'inOrder']) + '</option>' +
        '<option value="byName">' + translate(['agentSortingDict', 'byName']) + '</option>' +
        '</select></span></td>' +
        '<td colspan="2"></td></tr>' +
        '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>'
      );
      c = $('#defaultSettings .other');
      c.html('<table cellspacing="10" cellpadding="10" width="100%" class="detals">' +
        '<tr><td colspan="4"><h3 class="dark">' + translate('other') + '</h3></td></tr>' +
        '<tr><td width="25%"><label>' + translate('logLevel') + '</label><br /><i class="description">' + translate('logLevelinstruction') + '</i></td><td width="25%">' +
        '<span class="select"><select class="logLevel">' + 
        '<option value="0">0</option><option value="1">1</option>' +
        '<option value="2">2</option><option value="3">3</option>' +
        '<option value="4">4</option><option value="5">5</option>' +
        '</select></span>' +
        '<select class="sendDailyReport" style="display:none"><option value="YES"></option><option value="NO"></option></select><select class="sendWeeklyReport" style="display:none"><option value="YES"></option><option value="NO"></option></select>' +
        '</td>' +
        '<td width="25%"><label>' + translate('recordingsrotation') + '</label><br /><i class="description">' + translate('deleteRecordingsAfterinstruction') + '</i></td>' +
        '<td width="25%"><span class="select"><select class="deleteRecordingsAfter"><option value="">' + translate('off') + '</option>' +
        '<option value="30">30</option><option value="60">60</option><option value="90">90</option>' +
        '<option value="180">180</option><option value="360">360</option></select></span> ' + translate('days') + '</td></tr>' +
        '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>'
      );
      c = $('#defaultSettings');
      // <triggers>
      c.find('.triggers').html(
        '<table class="detals" width="100%" cellspacing="10" cellpadding="10">' +
        '<tr><td colspan="4"><h3 class="dark">' + translate('triggers') + '</h3></td></tr>' +
        '<tr><td width="25%"><label>' + translate('agentAttachedTime') + '</label><br /><i class="description">' + translate('agentConversationTimeinstruction') + '</i></td>' +
        '<td width="25%">' + make_select('ctout', 'agentAttachedTime') +
        '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
        '<td width="25%"><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
        '<td width="25%"><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
        '<tr><td><label>' + translate('agentBreakTime') + '</label><br /><i class="description">' + translate('agentBreakTimeinstruction') + '</i></td>' +
        '<td>' + make_select('btout', 'agentBreakTime') +
        '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
        '<td><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
        '<td><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
        '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>'
      );
      if(s.triggers) {
        if(!s.triggers.agentAttachedTime) {
          c.find('.agentAttachedTime').val("").parent().parent().find('.mailTo').val("");
        } else {
          if(selectMenus.agentAttachedTime.indexOf(s.triggers.agentAttachedTime.threshold) < 0) {
            c.find('.agentAttachedTime').val('other').parent().siblings('.custom').val(s.triggers.agentAttachedTime.threshold).show();
          } else {
            c.find('.agentAttachedTime').val(s.triggers.agentAttachedTime.threshold);
          }
          if(s.triggers.agentAttachedTime.mailTo) {
            c.find('.agentAttachedTime').parents('tr').find('.mailTo').val(s.triggers.agentAttachedTime.mailTo.join(','));
          }
        }
        if(!s.triggers.agentBreakTime) {
          c.find('.agentBreakTime').val("").parents('tr').find('.mailTo').val("");
        } else {
          if(selectMenus.agentBreakTime.indexOf(s.triggers.agentBreakTime.threshold) < 0) {
            c.find('.agentBreakTime').val('other').parent().siblings('.custom').val(s.triggers.agentBreakTime.threshold).show();
          } else {
            c.find('.agentBreakTime').val(s.triggers.agentBreakTime.threshold);
          }
          if(s.triggers.agentBreakTime.mailTo) {
            c.find('.agentBreakTime').parents('tr').find('.mailTo').val(s.triggers.agentBreakTime.mailTo.join(','));
          }
        }
      }
      // </triggers>
      c.find('.cub').html(
        '<table class="detals" width="100%" cellspacing="10" cellpadding="10">' +
        '<tr><td colspan="4">' +
        '<h3 class="dark">' + translate('crmintegration') + '</h3></td></tr>' +
        '<tr><td width="25%"><label>' + translate('crmType') + '</label><br /><i class="description">' + translate('crmTypeinstruction') + '</i></td><td width="25%"><span class="select">' +
        '<select class="crmType"><option value="">-----</option>' + crmOps + '</select></span></td>' +
        '<td width="25%"><label>' + translate('crmServer') + '</label><br /><i class="description">' + translate('crmAddressinstruction') + '</i></td>' +
        '<td width="25%"><input class="crmServer bg input" type="text" size="10" /></td></tr>' +
        '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>' +
        '<p><button id="update_defaults" class="button ff0">' + translate('update') + '</button>' +
        '<button id="stopCC" class="button bg right">' + translate('stopCC') + '</button></p>'
      );
      if(s.alertTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.alertTimeout) < 0) {
        c.find('.alertTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.alertTimeout).show();
      } else {
        c.find('.alertTimeout').val(s.alertTimeout || '').trigger('change');
      }
      if(s.agentACWTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.agentACWTimeout) < 0) {
        c.find('.agentACWTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.agentACWTimeout).show();
      } else {
        c.find('.agentACWTimeout').val(s.agentACWTimeout || '').trigger('change');
      }
      if(s.groupACWTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.groupACWTimeout) < 0) {
        c.find('.groupACWTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.groupACWTimeout).show();
      } else {
        c.find('.groupACWTimeout').val(s.groupACWTimeout || '').trigger('change');
      }
      c.find('.agentACWTimeout, .groupACWTimeout, .agentAttachedTime, .agentBreakTime, .alertTimeout').on('change', function() {
        if(this.value == 'other') {
          $(this).parent().siblings('.custom').show();
        } else {
          $(this).parent().siblings('.custom').hide().val('');
        }
      });
      c.find('.iFrameName').val(s.iFrameName);
      c.find('.iFrameUrl').val(s.iFrameUrl);
      c.find('.crmType').val(s.crmType).trigger('change');
      c.find('.crmServer').val(s.crmServer);
      if(s.crmType == 'SalesForce') {
        c.find('.crmServer').val('https://salesforce.com').attr('disabled', 'disabled');
      } else if(s.crmType == 'Zoho') {
        c.find('.crmServer').val('https://zoho.com').attr('disabled', 'disabled');
      } else if(s.crmType == 'Bitrix24') {
        c.find('.crmServer').val('bitrix24.settings').attr('disabled', 'disabled');
      }
      c.find('.agentMonitorMode').val(s.agentMonitorMode || 'ownQueues').trigger('change');
      c.find('.browserNotifications').val(s.browserNotifications || 'off').trigger('change');
      c.find('.agentInitialStatus').val(s.agentInitialStatus).trigger('change');
      c.find('.agentPty').val(s.agentPty).trigger('change');
      c.find('.agentSkill').val(s.agentSkill).trigger('change');
      c.find('.groupPty').val(s.groupPty).trigger('change');
      c.find('.logLevel').val(s.logLevel).trigger('change');
      c.find('.ringStrategy').val(s.ringStrategy).trigger('change');
      c.find('.waitingMusicList').val(s.waitingMusicList.join(','));
      if(s.welcomeMusicList) c.find('.welcomeMusicList').val(s.welcomeMusicList.join(','));
      if(s.agentSorting) c.find('.agentSorting').val(s.agentSorting).trigger('change');
      c.find('.sendDailyReport').val(s.sendDailyReport === true ? 'YES' : 'NO');
      c.find('.sendWeeklyReport').val(s.sendWeeklyReport === true ? 'YES' : 'NO');
      c.find('.useCRMRouting').val(s.useCRMRouting === true ? 'YES' : 'NO');
      c.find('.deleteRecordingsAfter').val(s.deleteRecordingsAfter ? s.deleteRecordingsAfter : '');
      var modes = Object.keys(translate('sessionModes'));
      for(var i = 0; i < modes.length; ++i) {
        c.find('.sessionMode').append('<option value="' + modes[i] + '">' + translate(['sessionModes', modes[i]]) + '</option>');
      }
      c.find('.sessionMode').val(s.sessionMode ? s.sessionMode : '').trigger('change');
      c.find('.select').each(function() {
        select_html($(this));
      });
      // <salesForceCrm>
      c.find('.crmType').on('change', function() {
        if(translate('disableCRMIntegration') == 'yes') {
          $(this).val('').trigger('change');
          return;
        }
        if(this.value == 'SalesForce') {
          c.find('.crmServer').val('https://salesforce.com').attr('disabled', 'disabled');
        } else if(this.value == 'Zoho') {
          c.find('.crmServer').val('https://zoho.com').attr('disabled', 'disabled');
        } else if(this.value == 'Bitrix24') {
          c.find('.crmServer').val('bitrix24.settings').attr('disabled', 'disabled');
        } else {
          c.find('.crmServer').removeAttr('disabled');
        }
      });
      // </salesForceCrm>
      $('#update_defaults').on('click', function() {
        $('#tabQueues').append(
          '<div class="queueSettings bg standheight left twothirdwidth"><div class="loader"></div></div>'
        );
        var s = {};
        for(var i = 0; i < generalFields.length; i++) {
          s[generalFields[i]] = c.find('.' + generalFields[i]).val();
        }
        if(s.alertTimeout == 'other') {
          s.alertTimeout = c.find('.alertTimeout').parent().siblings('.custom').val();
        }
        if(s.agentACWTImeout == 'other') {
          s.agentACWTimeout = c.find('.agentACWTimeout').parent().siblings('.custom').val();
        }
        if(s.groupACWTImeout == 'other') {
          s.groupACWTimeout = c.find('.groupACWTimeout').parent().siblings('.custom').val();
        }
        if(s.waitingMusicList) s.waitingMusicList = s.waitingMusicList.replace(/\s+/g, '').split(',');
        else s.waitingMusicList = [];
        if(s.welcomeMusicList) s.welcomeMusicList = s.welcomeMusicList.replace(/\s+/g, '').split(',');
        else s.welcomeMusicList = [];
        // <triggers>
        s.triggers = {};
        if(c.find('.agentAttachedTime').val()) {
          s.triggers.agentAttachedTime = {};
          s.triggers.agentAttachedTime.threshold = c.find('.agentAttachedTime').val();
          if(s.triggers.agentAttachedTime.threshold == 'other') {
            s.triggers.agentAttachedTime.threshold = c.find('.agentAttachedTime').parent().siblings('.custom').val();
          }
          s.triggers.agentAttachedTime.mailTo = c.find('.agentAttachedTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
        }
        if(c.find('.agentBreakTime').val()) {
          s.triggers.agentBreakTime = {};
          s.triggers.agentBreakTime.threshold = c.find('.agentBreakTime').val();
          if(s.triggers.agentBreakTime.threshold == 'other') {
            s.triggers.agentBreakTime.threshold = c.find('.agentBreakTime').parent().siblings('.custom').val();
          }
          s.triggers.agentBreakTime.mailTo = c.find('.agentBreakTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
        }
        // </triggers>
        updateSettings('general', null, s);
      });
      $('#showSTL').on('click', function() {
        if($('.smsTemplatesList').length) {
          return;
        }
        $('#tabQueues').prepend(
          '<div class="smsTemplatesList right onethirdwidth bg standheight">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="marg20"><div class="loader"></div></div></div>'
        );
        getSMSTable();
        getSMSTemplates();
        $('.smsTemplatesList .closeIcon').on('click', function() {
          $('.smsTemplatesList').remove();
          $('.smsTemplateSettings').remove();
        });
      });
      setTimeout(function() {
        $('.queueSettings').remove(); $('.agentSettings').remove();
      }, 500);
      $('#stopCC').on('click', function() {
      createOverlay();
      if(confirm(translate('stopCCPrompt'))) {
        stopCC();
      } else {
        closeOverlay();
      }
    });
      //$('#tabQueues').height(c.height());
    }
  } else if(s.type == 'group') {
    var c = $('.queueSettings');
    if(!s.settings) {
      c.remove();
      return;
    }
    c.html(
      '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
      '<div class="marg20" style="display:none">' +
      '<h2 class="queueName" data-value="' + s.name + '">' + translate('settingsOf') + ' ' + s.name +
      (s.settings.realName ? ' (' + s.settings.realName + ')' : '' ) + '</h2><br />' +
      '<table class="detals" width="100%" cellspacing="10" cellpadding="10">' +
      '<tr><td width="25%"><label>' + translate('queueextension') + '</label><br />' +
      '<i class="description">' + translate('extensioninstruction') + '</i></td>' +
      '<td width="25%"><input type="text" size="10" class="extensions input bg" value="' +
      s.settings.extensions.join(',') + '" /></td>' +
      '<td width="25%"><label>' + translate('realname') + '</label><br /><i class="description">' + translate('realNameinstruction') + '</i></td>' +
      '<td width="25%"><input size="10" type="text" class="realName input bg" value="' +
      (s.settings.realName ? s.settings.realName : '') + '" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('agent') + '</h3></td></tr>' +
      '<tr><td><label>' + translate('alertTimeout') + '</label><br />' +
      '<i class="description">' + translate('alertTimeoutinstruction') + '</i></td>' +
      '<td>' + make_select('ctout', 'alertTimeout') +
      '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><label>' + translate('script') + '</label><br /><i class="description">' + translate('scriptinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="bg input script" value="' +
      (s.settings.queueSettings.script ? s.settings.queueSettings.script : '') + '" />' +
      '<a class="yellow chooseScript border pointer">' + translate('choose') + '</a></td></tr>' +
      '<tr><td><label>' + translate('aacw') + '</label><br /><i class="description">' + translate('agentACWinstruction') + '</i></td><td>' +
      make_select('ctout', 'acwTimeout', s.settings.queueSettings.acwTimeout, s.defaultSettings.acwTimeout) +
      '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><label>' + translate('maxLinesNumber') + '</label><br /><i class="description">' + translate('agentLinesinstruction') + '</i></td>' +
      '<td>' +
      make_select('maxlinesnumber', 'maxLinesNumber', s.settings.queueSettings.maxLinesNumber, s.defaultSettings.maxLinesNumber || '1') +
      '</td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('queue') + '</h3></td></tr>' +
      '<tr><td><label>' + translate('groupPty') + '</label><br />' +
      '<i class="description">' + translate('ptyinstruction') + '</i></td>' +
      '<td>' + make_select('num', 'pty', s.settings.pty, s.defaultSettings.pty) + '</td>' +
      '<td><label>' + translate('ringStrategy') + '</label><br /><i class="description">' + translate('ringStrategyinstruction') + '</i></td>' +
      '<td>' + make_select('sgy', 'ringStrategy', s.settings.queueSettings.ringStrategy, s.defaultSettings.ringStrategy) + '</td></tr>' +
      '<tr><td><label>' + translate('welcomeMusicList') + '</label><br /><i class="description">' + translate('welcomeMusicListinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="welcomeMusicList bg input" value="' +
      (s.settings.queueSettings.welcomeMusicList ? s.settings.queueSettings.welcomeMusicList.join(',') :
      s.defaultSettings.welcomeMusicList.join(',')) + '" /></td>' +
      '<td><label>' + translate('waitingMusicList') + '</label><br /><i class="description">' + translate('waitingMusicListinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="waitingMusicList bg input" value="' +
      (s.settings.queueSettings.waitingMusicList ? s.settings.queueSettings.waitingMusicList.join(',') :
      s.defaultSettings.waitingMusicList.join(',')) + '" /></td></tr>' +
      '<tr><td><label>' + translate('requestQueuePosition') + '</label><br /><i class="description">' + translate('requestQueuePositioninstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestQueuePosition') + '</td>' +
      '<td><label>' + translate('requestTimeLeft') + '</label><br /><i class="description">' + translate('requestWaitingTimeinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestTimeLeft') + '</td></tr>' +
      '<tr><td><label>' + translate('requestCallBack') + '</label><br /><i class="description">' + translate('offerCallbackinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestCallBack') + '</td>' +
      '<td><label>' + translate('callBackPrompt') + '</label><br /><i class="description">' + translate('callbackPromptinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="callBackPrompt bg input" /></td></tr>' +
      '<tr><td><label>' + translate('requestVoiceMail') + '</label><br /><i class="description">' + translate('offerVoicemailinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestVoiceMail') +
      ' <input style="display:none" type="text" size="10" class="voiceMailAddress bg input" /></td>' +
      '<td><label>' + translate('voiceMailPrompt') + '</label><br /><i class="description">' + translate('voicemailPromptinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="voiceMailPrompt bg input" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('rules') + '</h3></td></tr>' +
      '<tr class="ruleEmpty"><td><label>' + translate('quitOnEmpty') + '</label><br />' +
      '<i class="description">' + translate('quitOnEmptyinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleBusy"><td><label>' + translate('quitOnBusy') + '</label><br />' +
      '<i class="description">' + translate('quitOnBusyinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleAgentHangup"><td><label>' + translate('quitOnAgentHangup') + '</label><br />' +
      '<i class="description">' + translate('quitOnAgentHangupinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleTimeout"><td><label>' + translate('quitOnTimeout') + '</label><br />' +
      '<i class="description">' + translate('quitOnTimeoutinstruction') + '</i></td>' +
      '<td>' + make_select('ctout', 'cParam') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleLength"><td><label>' + translate('quitOnLength') + '</label><br />' +
      '<i class="description">' + translate('quitOnLengthinstruction') + '</i></td>' +
      '<td>' + make_select('qll', 'cParam') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('triggers') + '</h3></td></tr>' +
      '<tr><td width="25%"><label>' + translate('agentAttachedTime') + '</label><br /><i class="description">' + translate('agentConversationTimeinstruction') + '</i></td>' +
      '<td width="25%">' + make_select('ctout', 'agentAttachedTime') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td width="25%"><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
      '<td width="25%"><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
      '<tr><td><label>' + translate('agentBreakTime') + '</label><br /><i class="description">' + translate('agentBreakTimeinstruction') + '</i></td>' +
      '<td>' + make_select('btout', 'agentBreakTime') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
      '<td><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      // <callNoteFields>
      '<tr><td><label>' + translate('callNoteFields') + '</label></td>' +
      '<td colspan="3"><textarea id="callNoteFields" class="bg"></textarea></td></tr>' +
      // </callNoteFields>
      '</table><p style="width:100%;height:50px;"></p>' +
      '<p><button id="update_queue" class="button ff0">' + translate('update') + '</button>' +
      '<button id="remove_queue" class="button bg right">' + translate('remove') + '</button></p>' +
      '<p class="turn"><b>' + translate('agents') + '</b><span class="agents"></span>' +
      '<a class="yellow border pointer addAgent">' + translate('addagent') + '</a></p>' +
      '</div>'
    );
    // <callNoteFields>
    if(s.settings.callNoteFields) {
      c.find('#callNoteFields').val(JSON.stringify(s.settings.callNoteFields, null, 2));
    }
    // </callNoteFields>
    if(s.settings.queueSettings.alertTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.alertTimeout) < 0) {
      c.find('.alertTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.alertTimeout).show();
    } else {
      c.find('.alertTimeout').val(s.settings.queueSettings.alertTimeout || '').trigger('change');
    }
    c.find('.alertTimeout option:first-child').text(translate('default') + ' (' + s.defaultSettings.alertTimeout + ')');
    if(s.settings.queueSettings.acwTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.acwTimeout) < 0) {
      c.find('.acwTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.acwTimeout).show();
    } else {
      c.find('.acwTimeout').val(s.settings.queueSettings.acwTimeout || '').trigger('change');
    }
    c.find('.acwTimeout option:first-child').text(translate('default') + ' (' + s.defaultSettings.acwTimeout + ')');
    c.find('.acwTimeout, .cParam, .agentAttachedTime, .agentBreakTime, .alertTimeout').on('change', function() {
      if(this.value == 'other') {
        $(this).parent().siblings('.custom').show();
      } else {
        $(this).parent().siblings('.custom').hide().val('');
      }
    });
    if(s.settings.queueSettings.requestQueuePosition) {
      if(s.settings.queueSettings.requestQueuePosition === true) s.settings.queueSettings.requestQueuePosition = 'YES';
      else s.settings.queueSettings.requestQueuePosition = '';
      c.find('.requestQueuePosition').val(s.settings.queueSettings.requestQueuePosition).trigger('change');
    }
    if(s.settings.queueSettings.requestTimeLeft) {
      if(s.settings.queueSettings.requestTimeLeft === true) s.settings.queueSettings.requestTimeLeft = 'YES';
      else s.settings.queueSettings.requestTimeLeft = '';
      c.find('.requestTimeLeft').val(s.settings.queueSettings.requestTimeLeft).trigger('change');
    }
    if(s.settings.queueSettings.requestCallBack) {
      if(s.settings.queueSettings.requestCallBack === true) s.settings.queueSettings.requestCallBack = 'YES';
      else s.settings.queueSettings.requestCallBack = '';
      c.find('.requestCallBack').val(s.settings.queueSettings.requestCallBack).trigger('change');
    }
    if(s.settings.queueSettings.callBackPrompt) {
      c.find('.callBackPrompt').val(s.settings.queueSettings.callBackPrompt.join(','));
    }
    if(s.settings.queueSettings.requestVoiceMail) {
      if(s.settings.queueSettings.requestVoiceMail === true) {
        s.settings.queueSettings.requestVoiceMail = 'YES';
        c.find('.voiceMailAddress').show();
        if(s.settings.queueSettings.voiceMailAddress)
          c.find('.voiceMailAddress').val(s.settings.queueSettings.voiceMailAddress);
      }
      else s.settings.queueSettings.requestVoiceMail = '';
      c.find('.requestVoiceMail').val(s.settings.queueSettings.requestVoiceMail).trigger('change');
    }
    if(s.settings.queueSettings.voiceMailPrompt) {
      c.find('.voiceMailPrompt').val(s.settings.queueSettings.voiceMailPrompt.join(','));
    }
    if(s.settings.triggers) {
      if(!s.settings.triggers.agentAttachedTime) {
        c.find('.agentAttachedTime').val("").parent().parent().find('.mailTo').val("");
      } else {
        if(selectMenus.agentAttachedTime.indexOf(s.settings.triggers.agentAttachedTime.threshold) < 0) {
          c.find('.agentAttachedTime').val('other').parent().siblings('.custom').val(s.settings.triggers.agentAttachedTime.threshold).show();
        } else {
          c.find('.agentAttachedTime').val(s.settings.triggers.agentAttachedTime.threshold);
        }
        if(s.settings.triggers.agentAttachedTime.mailTo) {
          c.find('.agentAttachedTime').parents('tr').find('.mailTo').val(s.settings.triggers.agentAttachedTime.mailTo.join(','));
        }
      }
      if(!s.settings.triggers.agentBreakTime) {
        c.find('.agentBreakTime').val("").parents('tr').find('.mailTo').val("");
      } else {
        if(selectMenus.agentBreakTime.indexOf(s.settings.triggers.agentBreakTime.threshold) < 0) {
          c.find('.agentBreakTime').val('other').parent().siblings('.custom').val(s.settings.triggers.agentBreakTime.threshold).show();
        } else {
          c.find('.agentBreakTime').val(s.settings.triggers.agentBreakTime.threshold);
        }
        if(s.settings.triggers.agentBreakTime.mailTo) {
          c.find('.agentBreakTime').parents('tr').find('.mailTo').val(s.settings.triggers.agentBreakTime.mailTo.join(','));
        }
      }
    }
    if(s.settings.queueSettings.rules) {
      if(s.settings.queueSettings.rules.empty) {
        c.find('.ruleEmpty .action').val(s.settings.queueSettings.rules.empty.action).trigger('change');
        if(s.settings.queueSettings.rules.empty.action == 'call') {
          c.find('.ruleEmpty .aParam').val(s.settings.queueSettings.rules.empty.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.busy) {
        c.find('.ruleBusy .action').val(s.settings.queueSettings.rules.busy.action).trigger('change');
        if(s.settings.queueSettings.rules.busy.action == 'call') {
          c.find('.ruleBusy .aParam').val(s.settings.queueSettings.rules.busy.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.agentHangup) {
        c.find('.ruleAgentHangup .action').val(s.settings.queueSettings.rules.agentHangup.action).trigger('change');
        if(s.settings.queueSettings.rules.agentHangup.action == 'call') {
          c.find('.ruleAgentHangup .aParam').val(s.settings.queueSettings.rules.agentHangup.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.timeout) {
        if(s.settings.queueSettings.rules.timeout.cParam !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.rules.timeout.cParam) < 0) {
          c.find('.ruleTimeout .cParam').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.rules.timeout.cParam).show();
        } else {
          c.find('.ruleTimeout .cParam').val(s.settings.queueSettings.rules.timeout.cParam || '').trigger('change');
        }
        c.find('.ruleTimeout .action').val(s.settings.queueSettings.rules.timeout.action).trigger('change');
        if(s.settings.queueSettings.rules.timeout.action == 'call') {
          c.find('.ruleTimeout .aParam').val(s.settings.queueSettings.rules.timeout.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.length) {
        if(s.settings.queueSettings.rules.length.cParam !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.rules.length.cParam) < 0) {
          c.find('.ruleLength .cParam').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.rules.length.cParam).show();
        } else {
          c.find('.ruleLength .cParam').val(s.settings.queueSettings.rules.length.cParam || '').trigger('change');
        }
        c.find('.ruleLength .action').val(s.settings.queueSettings.rules.length.action).trigger('change');
        if(s.settings.queueSettings.rules.length.action == 'call') {
          c.find('.ruleLength .aParam').val(s.settings.queueSettings.rules.length.aParam || '').show();
        }
      }
    }
    if(s.settings.agents && s.settings.agents.length) {
      for(var i = 0; i < s.settings.agents.length; i++) {
        c.find('.agents').append(
          '<span><a class="pointer agent" data-value="' + s.settings.agents[i] + '">' +
          s.settings.agents[i] + '</a></span>'
        );
      }
      c.find('.agent').on('click', function() {
        $('#tabQueues').append(
          '<div class="agentSettings bg standheight left twothirdwidth">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div></div>'
        );
        $('.agentSettings .closeIcon').on('click', function() {
          $(this).parent().remove();
          $('.queueList').remove();
        });
        getSettings('agent', $(this).text());
      });
    }
    c.find('.addAgent').on('click', function() {
      if($('.agentList').length) return;
      getAgents();
      $('#tabQueues').prepend(
        '<div class="agentList right onethirdwidth bg standheight">' +
        '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
        '<div class="marg20"><div class="loader"></div></div></div>'
      );
      $('.agentList .closeIcon').on('click', function() {
        $('.agentList').remove();
      });
    });
    c.find('.select').each(function() {
      select_html($(this));
    });
    if(s.settings.queueSettings.maxLinesNumber) {
      c.find('.maxLinesNumber').val(s.settings.queueSettings.maxLinesNumber).trigger('change');
    }
    c.find('.requestVoiceMail').on('change', function() {
      if($(this).val() == 'YES') {
        c.find('.voiceMailAddress').show();
      } else {
        c.find('.voiceMailAddress').hide();
      }
    });
    c.find('.action').on('change', function() {
      var aParam = $(this).parents('tr').find('.aParam');
      if($(this).val() == 'call') {
        aParam.show();
      } else {
        aParam.val('');
        aParam.hide();
      }
    });
    c.find('.closeIcon').on('click', function() {
      $(this).parent().remove();
      $('.agentList').remove();
      $('.queueList').remove();
      $('.scriptList').remove();
      $('#ccObjectsList .bg').removeClass('bg');
    });
    $('#update_queue').on('click', function() {
      var s = collectGroupSettings(c);
      if(!s) return;
      var groupName = c.find('.queueName').attr('data-value');
      c.html('<div class="loader"></div>');
      updateSettings('group', groupName, s);
      curGroup = groupName;
    });
    $('#remove_queue').on('click', function() {
      if(confirm(translate('askremovequeue') + ' ' + s.name + '?')) {
        removeObject('group', s.name);
        $('.queueSettings').on('objRemoved', function() {
          removeUser(s.name);
          $('.agentList').remove();
          c.remove();
          getGroups();
        });
      }
    });
    c.find('.chooseScript').on('click', function() {
      script_list = [];
      getScriptList();
    });
    //c.css('top', -$('#defaultSettings').height());
    //c.css('min-height',$('#defaultSettings').height());
    c.children('div').fadeIn('slow');
    //$('#tabQueues').height(c.height());
  } else if(s.type == 'agent') {
    var c = $('.agentSettings');
    if(!s.settings) {
      c.remove();
      return;
    }
    c.html(
      '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
      '<div class="marg20" style="display:none">' +
      '<input type="hidden" class="extensions" value="' +
      s.settings.extensions.join(',') + '" /><input type="hidden" class="realName" value="' +
      (s.settings.realName ? s.settings.realName : '') + '" />' +
      '<h2 class="agentName" data-value="' + s.name + '">' + translate('settingsOf') + ' ' + s.name +
      (s.settings.realName ? ' (' + s.settings.realName + ')' : '' ) + '</h2><br />' +
      '<table class="detals" width="100%" cellspacing="10" cellpadding="10">' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('agent') + '</h3></td></tr>' +
      '<tr><td width="25%"><label>' + translate('alertTimeout') + '</label><br />' +
      '<i class="description">' + translate('alertTimeoutinstruction') + '</i></td>' +
      '<td width="25%">' + make_select('ctout', 'alertTimeout') +
      '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td width="25%"><label>' + translate('script') + '</label><br /><i class="description">' + translate('scriptinstruction') + '</i></td>' +
      '<td width="25%"><input type="text" size="10" class="bg input script" value="' +
      (s.settings.queueSettings.script ? s.settings.queueSettings.script : '') + '" />' +
      '<a class="yellow chooseScript border pointer">' + translate('choose') + '</a></td></tr>' +
      '<tr><td><label>' + translate('aacw') + '</label><br /><i class="description">' + translate('agentACWinstruction') + '</i></td><td>' + make_select('ctout', 'acwTimeout') +
      '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><label>' + translate('maxLinesNumber') + '</label><br /><i class="description">' + translate('agentLinesinstruction') + '</i></td>' +
      '<td>' + make_select('maxlinesnumber', 'maxLinesNumber',
        s.settings.queueSettings.maxLinesNumber, s.defaultSettings.maxLinesNumber || '1') + '</td></tr>' +
      '<tr><td><label>' + translate('agentInitialStatus') + '</label><br /><i class="description">' + translate('agentInitialStatusinstruction') + '</i></td><td>' +
      make_select('st', 'initialStatus', s.settings.queueSettings.initialStatus, s.defaultSettings.initialStatus) + '</td>' +
      '<td><label>' + translate('agentPty') + '</label><br />' +
      '<i class="description">' + translate('ptyinstruction') + '</i></td>' +
      '<td>' + make_select('num', 'agentPty', s.settings.pty[''], s.defaultSettings.pty['']) + '</td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('queue') + '</h3></td></tr>' +
      '<tr><td><label>' + translate('welcomeMusicList') + '</label><br /><i class="description">' + translate('welcomeMusicListinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="welcomeMusicList bg input" value="' +
      (s.settings.queueSettings.welcomeMusicList ? s.settings.queueSettings.welcomeMusicList.join(',') :
      s.defaultSettings.welcomeMusicList.join(',')) + '" /></td>' +
      '<td><label>' + translate('waitingMusicList') + '</label><br /><i class="description">' + translate('waitingMusicListinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="waitingMusicList bg input" value="' +
      (s.settings.queueSettings.waitingMusicList ? s.settings.queueSettings.waitingMusicList.join(',') :
      s.defaultSettings.waitingMusicList.join(',')) + '" /></td></tr>' +
      '<tr><td><label>' + translate('requestQueuePosition') + '</label><br /><i class="description">' + translate('requestQueuePositioninstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestQueuePosition') + '</td>' +
      '<td><label>' + translate('requestTimeLeft') + '</label><br /><i class="description">' + translate('requestWaitingTimeinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestTimeLeft') + '</td></tr>' +
      '<tr><td><label>' + translate('requestCallBack') + '</label><br /><i class="description">' + translate('offerCallbackinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestCallBack') + '</td>' +
      '<td><label>' + translate('callBackPrompt') + '</label><br /><i class="description">' + translate('callbackPromptinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="callBackPrompt bg input" /></td></tr>' +
      '<tr><td><label>' + translate('requestVoiceMail') + '</label><br /><i class="description">' + translate('offerVoicemailinstruction') + '</i></td>' +
      '<td>' + make_select('yesnow', 'requestVoiceMail') +
      ' <input style="display:none" type="text" size="10" class="voiceMailAddress bg input" /></td>' +
      '<td><label>' + translate('voiceMailPrompt') + '</label><br /><i class="description">' + translate('voicemailPromptinstruction') + '</i></td>' +
      '<td><input type="text" size="10" class="voiceMailPrompt bg input" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('rules') + '</h3></td></tr>' +
      '<tr class="ruleEmpty"><td><label>' + translate('quitOnEmpty') + '</label><br />' +
      '<i class="description">' + translate('quitOnEmptyinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleBusy"><td><label>' + translate('quitOnBusy') + '</label><br />' +
      '<i class="description">' + translate('quitOnBusyinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleAgentHangup"><td><label>' + translate('quitOnAgentHangup') + '</label><br />' +
      '<i class="description">' + translate('quitOnAgentHangupinstruction') + '</i></td><td></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleTimeout"><td><label>' + translate('quitOnTimeout') + '</label><br />' +
      '<i class="description">' + translate('quitOnTimeoutinstruction') + '</i></td>' +
      '<td>' + make_select('ctout', 'cParam') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr class="ruleLength"><td><label>' + translate('quitOnLength') + '</label><br />' +
      '<i class="description">' + translate('quitOnLengthinstruction') + '</i></td>' +
      '<td>' + make_select('qll', 'cParam') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><span class="select"><select class="action"><option value="" selected="selected">-----</option>' +
      '<option value="hangup">' + translate('hangup') + '</option><option value="call">' + translate('call') +
      '</option></select></span></td><td><input type="text" size="10" class="bg input aParam" style="display:none;" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr>' +
      '<tr><td colspan="4"><h3 class="dark">' + translate('triggers') + '</h3></td></tr>' +
      '<tr><td width="25%"><label>' + translate('agentAttachedTime') + '</label><br /><i class="description">' + translate('agentConversationTimeinstruction') + '</i></td>' +
      '<td width="25%">' + make_select('ctout', 'agentAttachedTime') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td width="25%"><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
      '<td width="25%"><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
      '<tr><td><label>' + translate('agentBreakTime') + '</label><br /><i class="description">' + translate('agentBreakTimeinstruction') + '</i></td>' +
      '<td>' + make_select('btout', 'agentBreakTime') + '<input type="text" size="4" class="input bg custom" style="display:none;" /></td>' +
      '<td><label>' + translate('mailTo') + '</label><br /><i class="description">' + translate('emailinstruction') + '</i></td>' +
      '<td><input type="text" class="input bg mailTo" size="10" /></td></tr>' +
      '<tr><td colspan="4" style="border-bottom:1px solid #222C36;"></td></tr></table>' +
      '<table width="90%" cellspacing="10" cellpadding="10">' +
      '<thead><tr><td width="25%">' + translate('queue') + '</td><td width="25%">' + translate('agentPty') + '</td>' +
      '<td width="25%">' + translate('agentSkill') + '</td><td width="25%">&nbsp;</td></tr></thead>' +
      '<tbody id="pty_skill" class="detals"></tbody></table></p>' +
      '<p style="width:100px"><button id="update_agent" class="button ff0">' + translate('update') + '</button></p>' +
      '<p class="turn"><b>' + translate('accessrights') + '</b><span class="queues"></span>' +
      '<a class="yellow border pointer addQueue">' + translate('addqueue') + '</a></p>' +
      '</div>'
    );
    if(s.settings.queueSettings.alertTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.alertTimeout) < 0) {
      c.find('.alertTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.alertTimeout).show();
    } else {
      c.find('.alertTimeout').val(s.settings.queueSettings.alertTimeout || '').trigger('change');
    }
    c.find('.alertTimeout option:first-child').text(translate('default') + ' (' + s.defaultSettings.alertTimeout + ')');
    if(s.settings.queueSettings.acwTimeout !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.acwTimeout) < 0) {
      c.find('.acwTimeout').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.acwTimeout).show();
    } else {
      c.find('.acwTimeout').val(s.settings.queueSettings.acwTimeout || '').trigger('change');
    }
    c.find('.acwTimeout option:first-child').text(translate('default') + ' (' + s.defaultSettings.acwTimeout + ')');
    c.find('.acwTimeout, .cParam, .agentAttachedTime, .agentBreakTime, .alertTimeout').on('change', function() {
      if(this.value == 'other') {
        $(this).parent().siblings('.custom').show();
      } else {
        $(this).parent().siblings('.custom').hide().val('');
      }
    });
    if(s.settings.queueSettings.requestQueuePosition) {
      if(s.settings.queueSettings.requestQueuePosition === true) s.settings.queueSettings.requestQueuePosition = 'YES';
      else s.settings.queueSettings.requestQueuePosition = '';
      c.find('.requestQueuePosition').val(s.settings.queueSettings.requestQueuePosition).trigger('change');
    }
    if(s.settings.queueSettings.requestTimeLeft) {
      if(s.settings.queueSettings.requestTimeLeft === true) s.settings.queueSettings.requestTimeLeft = 'YES';
      else s.settings.queueSettings.requestTimeLeft = '';
      c.find('.requestTimeLeft').val(s.settings.queueSettings.requestTimeLeft).trigger('change');
    }
    if(s.settings.queueSettings.requestCallBack) {
      if(s.settings.queueSettings.requestCallBack === true) s.settings.queueSettings.requestCallBack = 'YES';
      else s.settings.queueSettings.requestCallBack = '';
      c.find('.requestCallBack').val(s.settings.queueSettings.requestCallBack).trigger('change');
    }
    if(s.settings.queueSettings.callBackPrompt) {
      c.find('.callBackPrompt').val(s.settings.queueSettings.callBackPrompt.join(','));
    }
    if(s.settings.queueSettings.requestVoiceMail) {
      if(s.settings.queueSettings.requestVoiceMail === true) {
        s.settings.queueSettings.requestVoiceMail = 'YES';
        c.find('.voiceMailAddress').show();
        if(s.settings.queueSettings.voiceMailAddress)
          c.find('.voiceMailAddress').val(s.settings.queueSettings.voiceMailAddress);
      }
      else s.settings.queueSettings.requestVoiceMail = '';
      c.find('.requestVoiceMail').val(s.settings.queueSettings.requestVoiceMail).trigger('change');
    }
    if(s.settings.queueSettings.voiceMailPrompt) {
      c.find('.voiceMailPrompt').val(s.settings.queueSettings.voiceMailPrompt.join(','));
    }
    if(s.settings.triggers) {
      if(!s.settings.triggers.agentAttachedTime) {
        c.find('.agentAttachedTime').val("").parent().parent().find('.mailTo').val("");
      } else {
        if(selectMenus.agentAttachedTime.indexOf(s.settings.triggers.agentAttachedTime.threshold) < 0) {
          c.find('.agentAttachedTime').val('other').parent().siblings('.custom').val(s.settings.triggers.agentAttachedTime.threshold).show();
        } else {
          c.find('.agentAttachedTime').val(s.settings.triggers.agentAttachedTime.threshold);
        }
        if(s.settings.triggers.agentAttachedTime.mailTo) {
          c.find('.agentAttachedTime').parents('tr').find('.mailTo').val(s.settings.triggers.agentAttachedTime.mailTo.join(','));
        }
      }
      if(!s.settings.triggers.agentBreakTime) {
        c.find('.agentBreakTime').val("").parents('tr').find('.mailTo').val("");
      } else {
        if(selectMenus.agentBreakTime.indexOf(s.settings.triggers.agentBreakTime.threshold) < 0) {
          c.find('.agentBreakTime').val('other').parent().siblings('.custom').val(s.settings.triggers.agentBreakTime.threshold).show();
        } else {
          c.find('.agentBreakTime').val(s.settings.triggers.agentBreakTime.threshold);
        }
        if(s.settings.triggers.agentBreakTime.mailTo) {
          c.find('.agentBreakTime').parents('tr').find('.mailTo').val(s.settings.triggers.agentBreakTime.mailTo.join(','));
        }
      }
    }
    if(s.settings.queueSettings.rules) {
      if(s.settings.queueSettings.rules.empty) {
        c.find('.ruleEmpty .action').val(s.settings.queueSettings.rules.empty.action).trigger('change');
        if(s.settings.queueSettings.rules.empty.action == 'call') {
          c.find('.ruleEmpty .aParam').val(s.settings.queueSettings.rules.empty.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.busy) {
        c.find('.ruleBusy .action').val(s.settings.queueSettings.rules.busy.action).trigger('change');
        if(s.settings.queueSettings.rules.busy.action == 'call') {
          c.find('.ruleBusy .aParam').val(s.settings.queueSettings.rules.busy.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.agentHangup) {
        c.find('.ruleAgentHangup .action').val(s.settings.queueSettings.rules.agentHangup.action).trigger('change');
        if(s.settings.queueSettings.rules.agentHangup.action == 'call') {
          c.find('.ruleAgentHangup .aParam').val(s.settings.queueSettings.rules.agentHangup.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.timeout) {
        if(s.settings.queueSettings.rules.timeout.cParam !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.rules.timeout.cParam) < 0) {
          c.find('.ruleTimeout .cParam').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.rules.timeout.cParam).show();
        } else {
          c.find('.ruleTimeout .cParam').val(s.settings.queueSettings.rules.timeout.cParam || '').trigger('change');
        }
        c.find('.ruleTimeout .action').val(s.settings.queueSettings.rules.timeout.action).trigger('change');
        if(s.settings.queueSettings.rules.timeout.action == 'call') {
          c.find('.ruleTimeout .aParam').val(s.settings.queueSettings.rules.timeout.aParam || '').show();
        }
      }
      if(s.settings.queueSettings.rules.length) {
        if(s.settings.queueSettings.rules.length.cParam !== undefined && selectMenus.agentAttachedTime.indexOf(s.settings.queueSettings.rules.length.cParam) < 0) {
          c.find('.ruleLength .cParam').val('other').trigger('change').parent().siblings('.custom').val(s.settings.queueSettings.rules.length.cParam).show();
        } else {
          c.find('.ruleLength .cParam').val(s.settings.queueSettings.rules.length.cParam || '').trigger('change');
        }
        c.find('.ruleLength .action').val(s.settings.queueSettings.rules.length.action).trigger('change');
        if(s.settings.queueSettings.rules.length.action == 'call') {
          c.find('.ruleLength .aParam').val(s.settings.queueSettings.rules.length.aParam || '').show();
        }
      }
    }
    c.find('.requestVoiceMail').on('change', function() {
      if($(this).val() == 'YES') {
        c.find('.voiceMailAddress').show();
      } else {
        c.find('.voiceMailAddress').hide();
      }
    });
    c.find('.action').on('change', function() {
      var aParam = $(this).parents('tr').find('.aParam');
      if($(this).val() == 'call') {
        aParam.show();
      } else {
        aParam.val('');
        aParam.hide();
      }
    });
    for(var i = 0; i < s.settings.access.admin.length; i++) {
      c.find('.queues').append(
        '<span><a data-value="' + s.settings.access.admin[i] + '" class="queue pointer' +
        (s.settings.access.admin[i] == 'anyOne' ? '' : ' xIcon') +
        '">' + s.settings.access.admin[i] + '</a></span>'
      );
    }
    c.find('.queue').on('click', function() {
      $(this).parent().remove();
      $('#update_agent').trigger('click');
    });
    c.find('.addQueue').on('click', function() {
      if(!$('.queueList').length) displayGroupPickList(c.parent());
    });
    var sel = c.find('#pty_skill');
    var groups = Object.keys(s.groups);
    for(var i = 0; i < s.groups.length; ++i) {
      sel.append(
        '<tr class="group" data-value="' + s.groups[i] + '"><td>' + s.groups[i] + '</td>' +
        '<td>' +
        make_select('num', 'pty', s.settings.pty[s.groups[i]], s.defaultSettings.pty[s.groups[i]]) +
        '</td><td>' +
        make_select('num', 'skill', s.settings.skill[s.groups[i]], s.defaultSettings.skill[s.groups[i]]) +
        '</td><td><a class="grey border pointer removeFromGroup">' +
        translate('removefromgroup') + '</a></td></tr>'
      );
    }
    c.find('.select').each(function() {
      select_html($(this));
    });
    if(s.settings.queueSettings.maxLinesNumber) {
      c.find('.maxLinesNumber').val(s.settings.queueSettings.maxLinesNumber).trigger('change');
    }
    c.find('.quitAction').on('change', function() {
      if($(this).val() == 'call') {
        c.find('.quitParam').parent().parent().show();
      } else {
        c.find('.quitParam').val('');
        c.find('.quitParam').parent().parent().hide();
      }
    });
    c.find('.closeIcon').on('click', function() {
      $(this).parent().remove();
      $('.queueList').remove();
      $('.scriptList').remove();
    });
    c.find('.removeFromGroup').on('click', function() {
      removeAgentFromGroup(
        c.find('.agentName').attr('data-value'),
        $(this).parents('.group').attr('data-value')
      );
      curGroup = $('.queueSettings .queueName').attr('data-value');
    });
    $('#update_agent').on('click', function() {
      var s = collectAgentSettings(c);
      var agentName = c.find('.agentName').attr('data-value');
      c.html('<div class="loader"></div>');
      updateSettings('agent', agentName, s);
    });
    c.find('.chooseScript').on('click', function() {
      script_list = [];
      getScriptList();
    });
    /*var corr = 0;
    if($('.queueSettings:visible').length) {
      corr = $('.queueSettings').height() + parseInt($('.queueSettings').css('min-height').replace(/px/g, ''));
      c.css('min-height', $('.queueSettings').height());
    } else {
      corr = $('#selUser').height();
    }
    c.css('top', -corr);
    */
    c.children('div').fadeIn('slow');
    //$('#tabQueues').height(c.height());
    //$('#tabUsers').height(c.height());
  } else if(s.type == 'campaign') {
    displayCampSettings(s.name, s.settings);
  } else if(s.type == 'smsTemplate') {
    if(s.name == smsTableName) {
      smsTable = s.settings;
      return;
    }
    var c = $('.smsTemplateSettings div.marg20');
    var n = $('.smsTemplatesList tr.bg td:last-child').text();
    var t = s.settings.text ? s.settings.text : '';
    c.html(
      '<h2 class="smsTemplateName">' + s.name + '</h2><br />' +
      '<table class="detals" width="100%" cellspacing="10" cellpadding="10">' +
      '<tr><td><label>' + translate('templatenum') + '</label><br />' +
      '<i class="description">' + translate('templatenuminstruction') + '</i></td>' +
      '<td align="right"><input size="6" class="input bg smsTemplateNums" value="' + n + '" /></td></tr>' +
      '<tr><td colspan="2"><div><textarea class="input bg smsTemplateText">' + t + '</textarea></div></td></tr></table>' +
      '<p><button id="update_smstemplate" class="button ff0">' + translate('update') + '</button>' +
      '<button id="remove_smstemplate" class="button bg right">' + translate('remove') + '</button></p>'
    );
    $('#smsText').val(t);
    var name = s.name;
    var smsTableKeys = Object.keys(smsTable);
    var iKey;
    c.find('#update_smstemplate').on('click', function() {
      var nums = c.find('.smsTemplateNums').val().replace(/\s+/g, '').split(',');
      for(var i = 0; i < nums.length; i++) {
        if(smsTable[nums[i]] && smsTable[nums[i]] != name) {
          alert(
            nums[i] + ' ' + translate('isassignedtosmstemplate') + ' ' + smsTable[nums[i]] + '. ' + translate('useanother')
          );
          return;
        }
      }
      for(var i = 0; i < smsTableKeys.length; ++i) {
        iKey = smsTableKeys[i];
        if(smsTable[iKey] == name) delete smsTable[iKey];
      }
      for(var i = 0; i < nums.length; i++) {
        if(isProperNum(nums[i])) {
          smsTable[nums[i]] = name;
        }
      }
      curSms = name;
      updateSettings('smsTemplate', smsTableName, smsTable);
      updateSettings('smsTemplate', name, { text: c.find('.smsTemplateText').val() });
      c.html('<div class="loader"></div>');
    });
    c.find('#remove_smstemplate').on('click', function() {
      if(confirm(translate('askremovesms'))) {
        for(var i = 0; i < smsTableKeys.length; ++i) {
          iKey = smsTableKeys[i];
          if(smsTable[iKey] == name) delete smsTable[iKey];
        }
        updateSettings('smsTemplate', smsTableName, smsTable);
        removeObject('smsTemplate', name);
        c.parent().remove();
      }
    });
  } else {
    // unknown type
  }
}

function collectGroupSettings(c) {
  var s = {};
  s.queueSettings = {};
  for(var i = 0; i < groupFields.length; i++) {
    s.queueSettings[groupFields[i]] = c.find('.' + groupFields[i]).val();
  }
  if(s.queueSettings.alertTimeout == 'other') {
    s.queueSettings.alertTimeout = c.find('.alertTimeout').parent().siblings('.custom').val();
  }
  if(s.queueSettings.acwTimeout == 'other') {
    s.queueSettings.acwTimeout = c.find('.acwTimeout').parent().siblings('.custom').val();
  }
  if(s.queueSettings.waitingMusicList) {
    s.queueSettings.waitingMusicList = s.queueSettings.waitingMusicList.replace(/\s+/g, '').split(',');
    if(generalSettings && arraysEqual(s.queueSettings.waitingMusicList, generalSettings.waitingMusicList)) {
      s.queueSettings.waitingMusicList = '';
    }
  } else {
    s.queueSettings.waitingMusicList = [];
  }
  if(s.queueSettings.welcomeMusicList) {
    s.queueSettings.welcomeMusicList = s.queueSettings.welcomeMusicList.replace(/\s+/g, '').split(',');
    if(generalSettings && arraysEqual(s.queueSettings.welcomeMusicList, generalSettings.welcomeMusicList)) {
      s.queueSettings.welcomeMusicList = '';
    }
  } else {
    s.queueSettings.welcomeMusicList = [];
  }
  var callNoteFields = c.find('#callNoteFields').val();
  if(callNoteFields) {
    try {
      s.callNoteFields = JSON.parse(callNoteFields);
    } catch(err) {
      alert('Failed to parse callNoteFields');
      return null;
    }
  }
  s.extensions = c.find('.extensions').val();
  if(s.extensions) {
    s.extensions = s.extensions.replace(/\s+/g, '').split(',');
  } else {
    s.extensions = [];
  }
  s.pty = c.find('.pty').val();
  s.realName = c.find('.realName').val();
  s.ccType = 'group';
  s.agents = [];
  c.find('.agents .agent').each(function() {
    s.agents.push($(this).text());
  });
  s.queueSettings.rules = {};
  if(c.find('.ruleEmpty .action').val()) {
    s.queueSettings.rules.empty = {
      action: c.find('.ruleEmpty .action').val(),
    };
    if(s.queueSettings.rules.empty.action == 'call') {
      s.queueSettings.rules.empty.aParam = c.find('.ruleEmpty .aParam').val();
    }
  }
  if(c.find('.ruleBusy .action').val()) {
    s.queueSettings.rules.busy = {
      action: c.find('.ruleBusy .action').val(),
    };
    if(s.queueSettings.rules.busy.action == 'call') {
      s.queueSettings.rules.busy.aParam = c.find('.ruleBusy .aParam').val();
    }
  }
  if(c.find('.ruleAgentHangup .action').val()) {
    s.queueSettings.rules.agentHangup = {
      action: c.find('.ruleAgentHangup .action').val(),
    };
    if(s.queueSettings.rules.agentHangup.action == 'call') {
      s.queueSettings.rules.agentHangup.aParam = c.find('.ruleAgentHangup .aParam').val();
    }
  }
  if(c.find('.ruleTimeout .action').val() && c.find('.ruleTimeout .cParam').val() != '') {
    var cParam = c.find('.ruleTimeout .cParam').val() == 'other' ? c.find('.ruleTimeout .cParam').parent().siblings('.custom').val() : c.find('.ruleTimeout .cParam').val();
    s.queueSettings.rules.timeout = {
      action: c.find('.ruleTimeout .action').val(),
      cParam: cParam,
    };
    if(s.queueSettings.rules.timeout.action == 'call') {
      s.queueSettings.rules.timeout.aParam = c.find('.ruleTimeout .aParam').val();
    }
  }
  if(c.find('.ruleLength .action').val() && c.find('.ruleLength .cParam').val() != '') {
    var cParam = c.find('.ruleLength .cParam').val() == 'other' ? c.find('.ruleLength .cParam').parent().siblings('.custom').val() : c.find('.ruleLength .cParam').val();
    s.queueSettings.rules.length = {
      action: c.find('.ruleLength .action').val(),
      cParam: cParam,
    };
    if(s.queueSettings.rules.length.action == 'call') {
      s.queueSettings.rules.length.aParam = c.find('.ruleLength .aParam').val();
    }
  }
  s.queueSettings.callBackPrompt = c.find('.callBackPrompt').val();
  if(s.queueSettings.callBackPrompt) {
    s.queueSettings.callBackPrompt = s.queueSettings.callBackPrompt.replace(/\s+/g, '').split(',');
  }
  s.queueSettings.voiceMailAddress = c.find('.voiceMailAddress').val();
  s.queueSettings.voiceMailPrompt = c.find('.voiceMailPrompt').val();
  if(s.queueSettings.voiceMailPrompt) {
    s.queueSettings.voiceMailPrompt = s.queueSettings.voiceMailPrompt.replace(/\s+/g, '').split(',');
  }
  s.triggers = {};
  if(c.find('.agentAttachedTime').val()) {
    s.triggers.agentAttachedTime = {};
    s.triggers.agentAttachedTime.threshold = c.find('.agentAttachedTime').val() == 'other' ? c.find('.agentAttachedTime').parent().siblings('.custom').val() : c.find('.agentAttachedTime').val();
    s.triggers.agentAttachedTime.mailTo = c.find('.agentAttachedTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
  }
  if(c.find('.agentBreakTime').val()) {
    s.triggers.agentBreakTime = {};
    s.triggers.agentBreakTime.threshold = c.find('.agentBreakTime').val() == 'other' ? c.find('.agentBreakTime').parent().siblings('.custom').val() : c.find('.agentBreakTime').val();
    s.triggers.agentBreakTime.mailTo = c.find('.agentBreakTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
  }
  return s;
}

function collectAgentSettings(c) {
  var s = {};
  s.queueSettings = {};
  for(var i = 0; i < agentFields.length; i++) {
    s.queueSettings[agentFields[i]] = c.find('.' + agentFields[i]).val();
  }
  if(s.queueSettings.alertTimeout == 'other') {
    s.queueSettings.alertTimeout = c.find('.alertTimeout').parent().siblings('.custom').val();
  }
  if(s.queueSettings.acwTimeout == 'other') {
    s.queueSettings.acwTimeout = c.find('.acwTimeout').parent().siblings('.custom').val();
  }
  if(s.queueSettings.waitingMusicList) {
    s.queueSettings.waitingMusicList = s.queueSettings.waitingMusicList.replace(/\s+/g, '').split(',');
  } else {
    s.queueSettings.waitingMusicList = [];
  }
  if(s.queueSettings.welcomeMusicList) {
    s.queueSettings.welcomeMusicList = s.queueSettings.welcomeMusicList.replace(/\s+/g, '').split(',');
  } else {
    s.queueSettings.welcomeMusicList = [];
  }
  s.extensions = c.find('.extensions').val();
  if(s.extensions) {
    s.extensions = s.extensions.replace(/\s+/g, '').split(',');
  } else {
    s.extensions = [];
  }
  s.realName = c.find('.realName').val();
  s.ccType = 'agent';
  var pty = {};
  var skill = {};
  pty[''] = c.find('.agentPty').val();
  c.find('#pty_skill .group').each(function() {
    pty[$(this).attr('data-value')] = $(this).find('.pty').val();
    skill[$(this).attr('data-value')] = $(this).find('.skill').val();
  });
  s.pty = pty;
  s.skill = skill;
  var access = {};
  var groups = [];
  c.find('.queue').each(function() {
    groups.push($(this).attr('data-value'));
  });
  if(groups.length) {
    access.admin = groups;
    access.control = groups;
    access.monitor = groups;
  } else {
    access.admin = [];
    access.control = [];
    access.monitor = [];
  }
  s.access = access;
  s.queueSettings.rules = {};
  if(c.find('.ruleEmpty .action').val()) {
    s.queueSettings.rules.empty = {
      action: c.find('.ruleEmpty .action').val(),
    };
    if(s.queueSettings.rules.empty.action == 'call') {
      s.queueSettings.rules.empty.aParam = c.find('.ruleEmpty .aParam').val();
    }
  }
  if(c.find('.ruleBusy .action').val()) {
    s.queueSettings.rules.busy = {
      action: c.find('.ruleBusy .action').val(),
    };
    if(s.queueSettings.rules.busy.action == 'call') {
      s.queueSettings.rules.busy.aParam = c.find('.ruleBusy .aParam').val();
    }
  }
  if(c.find('.ruleAgentHangup .action').val()) {
    s.queueSettings.rules.agentHangup = {
      action: c.find('.ruleAgentHangup .action').val(),
    };
    if(s.queueSettings.rules.agentHangup.action == 'call') {
      s.queueSettings.rules.agentHangup.aParam = c.find('.ruleAgentHangup .aParam').val();
    }
  }
  if(c.find('.ruleTimeout .action').val() && c.find('.ruleTimeout .cParam').val() != '') {
    var cParam = c.find('.ruleTimeout .cParam').val() == 'other' ? c.find('.ruleTimeout .cParam').parent().siblings('.custom').val() : c.find('.ruleTimeout .cParam').val();
    s.queueSettings.rules.timeout = {
      action: c.find('.ruleTimeout .action').val(),
      cParam: cParam,
    };
    if(s.queueSettings.rules.timeout.action == 'call') {
      s.queueSettings.rules.timeout.aParam = c.find('.ruleTimeout .aParam').val();
    }
  }
  if(c.find('.ruleLength .action').val() && c.find('.ruleLength .cParam').val() != '') {
    var cParam = c.find('.ruleLength .cParam').val() == 'other' ? c.find('.ruleLength .cParam').parent().siblings('.custom').val() : c.find('.ruleLength .cParam').val();
    s.queueSettings.rules.length = {
      action: c.find('.ruleLength .action').val(),
      cParam: cParam,
    };
    if(s.queueSettings.rules.length.action == 'call') {
      s.queueSettings.rules.length.aParam = c.find('.ruleLength .aParam').val();
    }
  }
  s.queueSettings.callBackPrompt = c.find('.callBackPrompt').val();
  if(s.queueSettings.callBackPrompt) {
    s.queueSettings.callBackPrompt = s.queueSettings.callBackPrompt.replace(/\s+/g, '').split(',');
  }
  s.queueSettings.voiceMailAddress = c.find('.voiceMailAddress').val();
  s.queueSettings.voiceMailPrompt = c.find('.voiceMailPrompt').val();
  if(s.queueSettings.voiceMailPrompt) {
    s.queueSettings.voiceMailPrompt = s.queueSettings.voiceMailPrompt.replace(/\s+/g, '').split(',');
  }
  s.triggers = {};
  if(c.find('.agentAttachedTime').val()) {
    s.triggers.agentAttachedTime = {};
    s.triggers.agentAttachedTime.threshold = c.find('.agentAttachedTime').val() == 'other' ? c.find('.agentAttachedTime').parent().siblings('.custom').val() : c.find('.agentAttachedTime').val();
    s.triggers.agentAttachedTime.mailTo = c.find('.agentAttachedTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
  }
  if(c.find('.agentBreakTime').val()) {
    s.triggers.agentBreakTime = {};
    s.triggers.agentBreakTime.threshold = c.find('.agentBreakTime').val() == 'other' ? c.find('.agentBreakTime').parent().siblings('.custom').val() : c.find('.agentBreakTime').val();
    s.triggers.agentBreakTime.mailTo = c.find('.agentBreakTime').parents('tr').find('.mailTo').val().replace(/\s/g, '').split(',');
  }
  return s;
}

function displayGroupList(s) {
  $('#ccObjectsList').html('');
  groups = [];
  var keys = Object.keys(s);
  for(var i = 0; i < keys.length; ++i) {
    var o = keys[i];
    groups.push(o);
    $('#ccObjectsList').append(
      '<tr class="pointer" data-value="' + o + '"><td><a>' + o + '</a></td>' +
      '<td>' + s[o].extensions.join(',') + '</td>' +
      '<td>' + s[o].agentsNumber + '</td></tr>'
    );
  }
  $('#ccObjectsList').parents('.scrollList').jScrollPane();
  $('#ccObjectsList tr').on('click', function() {
    if($(this).hasClass('bg')) return;
    $(this).addClass('bg').siblings('tr').removeClass('bg');
    $('.agentSettings').remove();
    var c = $('.queueSettings');
    if(!c.length) {
      $('#tabQueues').append(
        '<div class="queueSettings bg standheight left twothirdwidth">' +
        '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
        '<div class="loader"></div></div>'
      );
    } else {
      c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') +
        '"></a><div class="loader"></div>'
      );
    }
    $('#tabQueues .closeIcon').on('click', function() {
      $(this).parent().remove();
      $('.agentList').remove();
      $('.queueList').remove();
      $('#ccObjectsList .bg').removeClass('bg');
    });
    getSettings('group', $(this).attr('data-value'));
  });
  if(curGroup) {
    $('#ccObjectsList tr[data-value="' + curGroup + '"]').addClass('bg');
    curGroup = null;
  }
	$window.trigger('resize');
}

function displayGroupPickList(c) {
  c.prepend(
    '<div class="queueList right onethirdwidth bg standheight">' +
    '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
    '<div class="marg20"><h2>' + translate('queuesList') + '</h2>' +
    '<i class="description">' + translate('queuerightsinstruction') + '</i><br />' +
    '<div><div class="scrollList"><table cellspacing="0" cellpadding="0" width="100%">' +
    '<tbody></tbody></table></div></div>'
  );
  for(var i = 0; i < groups.length; i++) {
    c.find('.queueList table tbody').append(
      '<tr class="pointer"><td><a>' + groups[i] + '</a></td></tr>'
    );
  }
  $('.queueList .scrollList').jScrollPane();
  c.find('.queueList tr').on('click', function() {
    var name = $(this).find('a').text();
    if($('.agentSettings .queues .queue[data-value="' + name + '"]').length) return;
    $('.agentSettings .queues').append(
      '<span><a class="xIcon pointer queue" data-value="' + name + '">' + name + '</a></span>'
    );
    $('#update_agent').trigger('click');
  });
  $('.queueList .closeIcon').on('click', function() {
    $('.queueList').remove();
  });
  /*var corr = $('#defaultSettings').height();
  corr = corr * 2;
  if($('#defaultSettings:visible').length) {
    $('.queueList').css('top', -corr);
  }
  */
}

function displayAgentList(s) {
  var c = $('.agentList');
  c.find('div.marg20').html('<h2>' + translate('listofagents') + '</h2><i class="description">' +
    translate('agentlistinstruction') + '</i><br /><div><div class="scrollList">' +
    '<table cellspacing="0" cellpadding="0" width="100%">' +
    '<thead><tr><td>' + translate('agentname') + '</td>' +
    '<td>' + translate('queueextension') + '</td></tr></thead>' +
    '<tbody></tbody></table></div></div>'
  );
  agents = [];
  var keys = Object.keys(s);
  for(var i = 0; i < keys.length; ++i) {
    var o = keys[i];
    agents.push(o);
    c.find('tbody').append(
      '<tr class="pointer"><td><a>' + o + '</a></td>' +
      '<td>' + s[o].extensions.join(',') + '</td></tr>'
    );
  }
  $('.agentList .scrollList').jScrollPane();
  c.find('tbody tr').on('click', function() {
    var name = $(this).find('a').text();
    if($('.queueSettings .agents .agent[data-value="' + name + '"]').length) return;
    $('.queueSettings .agents').append(
      '<span><a class="pointer agent" data-value="' + name + '">' +
      name + '</a><a class="pointer deleteAgent" title="' + translate('remove') + '"></a></span>'
    );
    $('#update_queue').trigger('click');
  });
  //var corr = $('#defaultSettings').height();
  //$('.agentList').css('top', -corr);
}

function displaySMSTemplatesList(s) {
  var c = $('.smsTemplatesList');
  c.find('div.marg20').html('<h2>' + translate('smstemplates') + '</h2><br />' +
    '<div class="scrollList"><table cellspacing="0" cellpadding="0" width="100%">' +
    '<thead><tr><td>' + translate('templatename') + '</td><td>' + translate('templatenum') + '</td></tr></thead>' +
    '<tbody></tbody></table></div></div>' +
    '<p><button id="create_smstemplate" class="button ff0">' + translate('createsmstemplate') + '</button>' +
    '&nbsp;&nbsp;&nbsp;<input class="smsTemplateNameNew input bg" size="8" type="text"></p>'
  );
  var keys = Object.keys(s);
  for(var i = 0; i < keys.length; ++i) {
    var o = keys[i];
    c.find('tbody').append(
      '<tr data-value="' + o + '" class="pointer"><td><a>' + o + '</a></td><td>' + s[o].join(',') + '</td></tr>'
    );
    $('#sms_form .tList .scrollList > div').append(
      '<p class="pointer" data-value="' + o + '">' + o + '</p>'
    );
  }
  $('#sms_form .tList p').on('click', function() {
    getSettings('smsTemplate', $(this).attr('data-value'));
  });
  $('#sms_form .tList .scrollList').jScrollPane();
  c.find('tbody tr').on('click', function() {
    var name = $(this).find('a').text();
    $(this).addClass('bg').siblings('.bg').removeClass('bg');
    if(!$('.smsTemplateSettings').length) {
      $('#tabQueues').append(
        '<div class="smsTemplateSettings bg standheight left twothirdwidth">' +
        '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
        '<div class="marg20"><div class="loader"></div></div></div>'
      );
    } else {
      $('.smsTemplateSettings').html(
        '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
        '<div class="marg20"><div class="loader"></div></div>'
      );
    }
    $('.smsTemplateSettings .closeIcon').on('click', function() {
      $('.smsTemplateSettings').remove();
      c.find('tbody tr.bg').removeClass('bg');
      curSms = null;
    });
    //$('.smsTemplateSettings').css('top', -$('#defaultSettings').height());
    //$('.smsTemplateSettings').css('min-height',$('#defaultSettings').height());
    getSMSTable();
    getSettings('smsTemplate', name);
  });
  c.find('.scrollList').jScrollPane();
  $('#create_smstemplate').on('click', function() {
    var smsNameNew = $('.smsTemplateNameNew').val().toLowerCase();
    $('.smsTemplateNameNew').val('');
    if(!smsNameNew || smsNameNew == smsTableName) return;
    createObject('smsTemplate', smsNameNew, { text: '' });
    curSms = smsNameNew;
  });
  if(curSms) {
    c.find('tbody tr[data-value="' + curSms +'"]').trigger('click');
    curSms = null;
  }
}
