function initTasksTable() {
  var mailboxName = $('input[name="mailbox"]').val();
  $('table.taskCol td.empty').each(function() {
    var n = $(this).attr('rowspan');
    $(this).removeAttr('rowspan');
    if(n)
      for(var i = 0; i < (n - 1); i++)
        $(this).parent().after('<tr><td class="empty">&nbsp;</td></tr>');
  });
  $('table.taskCol td.task').each(function() {
    var n = $(this).attr('rowspan');
    if(n)
      for(var i = 0; i < (n - 1); i++)
        $(this).parent().after('<tr></tr>');
  });
  var cols = $('.tasksContainer > tbody > tr > td').length;
  if(cols < 2) {
    $('.tasksContainer > tbody > tr').append(
      '<td width="90%"><table class="tasksCalendar taskCol" width="100%" cellspacing="0" cellpadding="0"></table></td>'
    );
    $('.dateCol tr').each(function() {
      $('.taskCol').append('<tr><td class="empty">&nbsp;</td></tr>');
    });
  } else {
    var width = (90 / (cols - 1)).toFixed() + '%';
    $('.tasksContainer > tbody > tr > td').each(function(i) {
      if(i != 0) $(this).attr('width', width);
    });
  }
  $('.dateRange a').text($('.dateCol tr:first-child td').text() + ' - ' + $('.dateCol tr:last-child td').text());
  var currentDay = new Date();
  currentDay = currentDay.getDate() + '-' + (currentDay.getMonth() + 1) + '-' + currentDay.getFullYear();
  $('.dateCol td[data-value="' + currentDay + '"]').addClass('currentDay');
  $('.dateCol td').on('click', function() {
    var s = $(this).attr('data-value');
    var date = new Date(s.substring(6) + '-' + s.substring(3,5) + '-' + s.substring(0,2));
    var jumpDay = (date.getTime()/86400000).toFixed();
    clearTasksParams();
    urlParams.JumpDay = jumpDay;
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
  var locale = $('html').attr('lang');
  $.datepicker.regional['ru'] = {
    monthNames: ['Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],
    monthNamesShort: ['Янв','Фев','Мар','Апр','Май','Июн','Июл','Авг','Сен','Окт','Ноя','Дек'],
    dayNames: ['воскресенье','понедельник','вторник','среда','четверг','пятница','суббота'],
    dayNamesShort: ['вск','пнд','втр','срд','чтв','птн','сбт'],
    dayNamesMin: ['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],
  };
  $('#datepicker').datepicker({ firstDay: 1, dateFormat: 'yy-mm-dd', });
  if(locale == 'ru') $('#datepicker').datepicker("option", $.datepicker.regional[locale]);
  $('.datepickerLink').on('click', function(e) {
    e.preventDefault();
    $('#datepicker').trigger('focus');
  });
  $('#ui-datepicker-div').addClass('popupEsc');
  $('#datepicker').on('change', function() {
    var date = new Date($(this).val());
    var jumpDay = (date.getTime()/86400000).toFixed();
    clearTasksParams();
    urlParams.JumpDay = jumpDay;
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
  $('.leftPrevArrow').on('click', function() {
    clearTasksParams();
    urlParams.PrevDaySet = '1';
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
  $('.rightNextArrow').on('click', function() {
    clearTasksParams();
    urlParams.NextDaySet = '1';
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
  $('.Folder').on('click', function() {
    location.href = 'Hello.wssp?center=loadMailbox&Mailbox=' + encodeURIComponent(mailboxName);
  });
  $('.calendarNavigation .less').on('click', function() {
    clearTasksParams();
    urlParams.ShrinkSet = '1';
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
  $('.calendarNavigation .more').on('click', function() {
    clearTasksParams();
    urlParams.ExtendSet = '1';
    var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
    location.href = 'Hello.wssp?' + query;
  });
}

function clearTasksParams() {
  delete urlParams.ExtendSet;
  delete urlParams.ShrinkSet;
  delete urlParams.NextDaySet;
  delete urlParams.PrevDaySet;
  delete urlParams.JumpDay;
}

