import{_ as i,c as a,o as n,ag as o,j as e}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"AirSync Module","description":"","frontmatter":{"legacyLink":"AirSync.html"},"headers":[],"relativePath":"admin/access/AirSync.md","filePath":"admin/access/AirSync.md"}'),s={name:"admin/access/AirSync.md"};function l(c,t,r,d,p,h){return n(),a("div",null,t[0]||(t[0]=[o('<h1 id="airsync-module" tabindex="-1">AirSync Module <a class="header-anchor" href="#airsync-module" aria-label="Permalink to &quot;AirSync Module&quot;">​</a></h1><p>The CommuniGate Pro Server can be used with Microsoft® Windows Mobile and other compatible devices (PDAs, smartphones) supporting the AirSync protocol - a client-server version of the Microsoft ActiveSync protocol.</p><p>The AirSync protocol allows a client device to synchronize its Calendaring, Tasks, and Contacts data with the same data in the user Account on the server. The protocol also allows a user to synchronize some or all of its E-mail mailboxes, to compose and send E-mails, Event invitations, and Event replies.</p><p>The CommuniGate Pro <a href="./../storage/Mailboxes.html#Aliases">Mailbox Alias</a> feature allows AirSync clients to access shared Mailboxes in other Accounts.</p><p>The AirSync protocol allows a client device to access the Server <a href="./../directory/CentralDir.html">Directory</a>.</p><h2 id="Configure" tabindex="-1">Configuring the AirSync Module <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Configuring the AirSync Module {#Configure}&quot;">​</a></h2><p>The AirSync protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">AIRSYNC:</td><td><select name="USERDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="USERDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the AIRSYNC Log Level setting to specify the type of information the AirSync module should put in the Server Log.<br> The AirSync module records in the System Log are marked with the <code>AIRSYNC</code> tag.</p><p>The Access setting specifies who can access the AirSync service.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Many AirSync clients are designed to access only the standard HTTP ports (port 80 for clear-text connections and port 443 for secure connections), make sure your <a href="./../services/HTTP.html">HTTP User</a> module is properly configured to accept connections on these ports.</p></div><h2 id="DeviceType" tabindex="-1">Restricting Access <a class="header-anchor" href="#DeviceType" aria-label="Permalink to &quot;Restricting Access {#DeviceType}&quot;">​</a></h2><p>Server and Domain administrators may want to restrict AirSync access to to certain devices only:</p>',13),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Enabled Mobile Device IDs")])]),e("tr",null,[e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"AirSyncAllowed-Def",value:"1"})]),e("td",{class:"settingFixed"},"!phoneX*, !vendor1/*, * ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"AirSyncAllowed-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"AirSyncAllowed",size:"100",maxlength:"10000",value:"9999BFE4D66C4BE29AAB1DF8F8CF4064, android678263333"})])])])])])])])])])],-1),o('<p>The setting value can contain zero, one, or several elements separated using the comma (<code>,</code>) symbol:</p><ul><li>if no element is specified, access is prohibited to all devices</li><li>each elements is compared to the ID of the device trying to connect; if an elements contains the <code>*</code> symbols, they are used as wildcards; The element * grants access to all devices</li><li>if an element contains the <code>/</code> symbol, the element part before that symbol is compared to the device type (such as <code>PocketPC</code>, <code>Apple</code>), and the part after the slash symbol is compared to the device ID</li><li>if an element starts with the <code>!</code> symbol and the rest of the element matches the device ID (or the device type and the device ID), the device is prohibited from accessing the Account(s)</li></ul><p>In the example above, the Default Setting contains the following elements:</p><ul><li><p><code>!phoneX*</code></p><p>devices having IDs starting with <code>phoneX</code> are prohibited</p></li><li><p><code>!vendor1/*</code></p><p>devices having the <code>vendor1</code> device type are prohibited</p></li><li><p><code>*</code></p><p>all other devices are allowed</p></li></ul><p>In the example above, the custom Setting (overriding the Default Settings) contains the following elements:</p><ul><li><p><code>9999BFE4D66C4BE29AAB1DF8F8CF4064</code></p><p>the device with this ID is allowed</p></li><li><p><code>android678263333</code></p><p>the device with this ID is allowedAll other devices are prohibited.</p></li></ul><h2 id="DeviceMgr" tabindex="-1">Managing AirSync Devices <a class="header-anchor" href="#DeviceMgr" aria-label="Permalink to &quot;Managing AirSync Devices {#DeviceMgr}&quot;">​</a></h2><p>Server and Domain administrators can monitor and manage AirSync devices employed by the Account user.</p><p>Open the Account Settings WebAdmin Interface page, open the Mail section, and follow the Mobile link. Find the AirSync Devices panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>AirSync Clients</b></td></tr><tr align="left"><th> </th><th>Client Type</th><th>ID</th><th>Policy</th><th>Last Access</th><th>Remote account wipe</th><th>Remote Device Wipe</th></tr><tr><td><input type="checkbox" name="airSync" value="sssss"></td><td>PocketPC</td><td>9999BFE4D66C4BE29AAB1DF8F8CF4064</td><td>{UsePIN=YES;}</td><td>10:54:48PM</td><td></td><td>1-Oct-08</td></tr><tr><td><input type="checkbox" name="airSync" value="zzzzz"></td><td>PocketPC</td><td>FAFABFE4D3333BE2ABBC2E0909D05175</td><td>{}</td><td>20-Sep</td><td>pending</td><td></td></tr><tr><td colspan="4" align="begin"><input type="reset" name="DiscardButton" value="Forget device" class="buttonWhite"><input type="reset" name="CancelWipe" value="Cancel" class="buttonWhite"><input type="reset" name="DoAccountWipe" value="Wipe out account" class="buttonWhite"><input type="reset" name="DoWipe" value="Wipe out device" class="button"></td><td colspan="3" align="center"><input type="reset" name="Enable PIN-lock" value="Enable PIN-lock" class="buttonWhite"> <input type="reset" name="Disable PIN-lock" value="Disable PIN-lock" class="button"></td></tr></tbody></table></div></form><p>The table elements show the device type and unique ID for each device the Account user has used, as well as the time of the last AirSync operation with that device.</p><p>Devices can be protected with a PIN (password) that needs to be entered every time the device is switched on, or after a period of inactivity. You can remotely enable or disable this function: select the device element and click the Enable PIN-lock or Disable PIN-lock button.</p><p>Some devices may fail to deal with all user Mailboxes - either because the user Account has too many Mailboxes, or because some Mailbox has too many items in it. A user can &quot;hide&quot; certain Mailboxes from the AirSync client by disabling the <a href="./WebMailbox.html#NoSync">Visible to Mobile Devices</a> Mailbox option.</p><h3 id="remote-device-and-account-wipe" tabindex="-1">Remote Device and Account Wipe <a class="header-anchor" href="#remote-device-and-account-wipe" aria-label="Permalink to &quot;Remote Device and Account Wipe&quot;">​</a></h3><p>If a device is lost or stolen, administrators can use one of two options:</p><ul><li><p><strong>Remote Account Wipe:</strong><br> This will remove only corporate account data (email, contacts, calendars, files) from the device.<br> Personal files and settings will remain intact.</p></li><li><p><strong>Full Device Wipe:</strong><br> All data, including files, accounts, and settings, will be erased.<br> The device will be reset to factory defaults, and access to it will be completely lost.</p></li></ul><div class="danger custom-block"><p class="custom-block-title">This operation is irreversible!</p><p>Data cannot be restored after the wipe.</p></div><p>Once the wipe is initiated, the device status will change to <strong>&quot;Pending&quot;</strong>.<br> The command will be executed upon the next device connection to the server.</p><h3 id="important" tabindex="-1">Important: <a class="header-anchor" href="#important" aria-label="Permalink to &quot;Important:&quot;">​</a></h3><ul><li>Outlook for iOS and Android supports only remote data wipe within the app, not a full device wipe.</li><li>Built-in mail clients for iOS and Android support both commands, including full device reset.</li><li>If a user has multiple devices linked to the same account, the wipe command will apply to <strong>all devices</strong>.</li><li>Remote account wipe is only possible if the device supports <strong>ActiveSync 16.1 or later</strong>.<br> Otherwise, the operation will not be executed.</li></ul><p>If the device is found before the wipe is executed, the administrator can cancel the operation by clicking the <strong>&quot;Cancel&quot;</strong> button.</p><h2 id="Compatibility" tabindex="-1">Compatibility Notes <a class="header-anchor" href="#Compatibility" aria-label="Permalink to &quot;Compatibility Notes {#Compatibility}&quot;">​</a></h2><p>The AirSync protocol was designed to work in a proprietary, non-standard environment. CommuniGate Pro AirSync module makes its best effort to convert AirSync data to the standard formats (such as iCalendar and vCard).</p><h3 id="replying-to-event-requests" tabindex="-1">Replying to Event Requests <a class="header-anchor" href="#replying-to-event-requests" aria-label="Permalink to &quot;Replying to Event Requests&quot;">​</a></h3><p>When an AirSync client accepts or declines an Event, it generates an E-mail message to be sent to the Event organizer. This message contains Microsoft proprietary data not suitable for any standard-based application.<br> To provide a workaround for this problem, the CommuniGate Pro AirSync module generates a Reply itself, using the standard iCalendar format. As a result, the organizer may receive 2 Event Reply messages - one from the AirSync module, and one from the Windows Mobile client itself.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When the Windows Mobile user chooses to accept or decline a request without sending a reply, only the Windows Mobile own request is affected. The AirSync module generates its reply independently, based only on the Event request &quot;RSVP&quot; attribute.</p></div><h3 id="sub-mailboxes" tabindex="-1">Sub-Mailboxes <a class="header-anchor" href="#sub-mailboxes" aria-label="Permalink to &quot;Sub-Mailboxes&quot;">​</a></h3><p>AirSync clients do not support sub-mailboxes of the <em>Sent</em> and <em>Trash</em> Mailboxes, and older clients do not support sub-mailboxes of the <em>INBOX</em> Mailbox either.<br> If an Account contains such sub-mailboxes, the Server does not inform an AirSync client about them.</p>',28)]))}const b=i(s,[["render",l]]);export{m as __pageData,b as default};
