import{_ as t,c as o,o as n,ag as a}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"FTP Module","description":"","frontmatter":{"legacyLink":"FTP.html"},"headers":[],"relativePath":"admin/access/FTP.md","filePath":"admin/access/FTP.md"}'),s={name:"admin/access/FTP.md"};function i(r,e,l,c,d,h){return n(),o("div",null,e[0]||(e[0]=[a('<h1 id="ftp-module" tabindex="-1">FTP Module <a class="header-anchor" href="#ftp-module" aria-label="Permalink to &quot;FTP Module&quot;">​</a></h1><p>The CommuniGate Pro FTP module implements an FTP server for TCP/IP networks.</p><p>The FTP protocol allows an FTP client application to connect to the Server computer and specify the user (Account) name and the password. If access to the specified user Account is granted, the client application can retrieve and update data inside that Account <a href="./../storage/FileStore.html">File Storage</a>.</p><h2 id="Protocol" tabindex="-1">File Transfer Protocol <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;File Transfer Protocol {#Protocol}&quot;">​</a></h2><p>The File Transfer Protocol allows client computers to work with files stored on remote servers. A computer running an FTP client application connects to the server computer and provides account (user) name and the password. If access to the specified user account is granted, the client application sends protocol commands to the FTP server. These protocol commands tell the server to list all files in the current directory, to change the current directory, to retrieve, upload, rename, and remove files stored on the FTP server.</p><p>The CommuniGate Pro FTP module supports all related <a href="./../common/Features.html#FTP">Internet standards</a> (RFCs).</p><p>The CommuniGate Pro FTP module supports the REST command and it can resume broken file transfer operations.</p><p>The CommuniGate Pro FTP module supports the GSSAPI authentication method. It can use the established GSSAPI &quot;context&quot; for encryption and integrity protection of the control and data channels.</p><p>The CommuniGate Pro FTP module supports the STLS command, as well as non-standard AUTH SSL and AUTH TLS-P commands for establishing secure (TLS) communication links.</p><h2 id="Configuring" tabindex="-1">Configuring the FTP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the FTP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the FTP module. Open the Access page in the Settings realm.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="FTPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><select name="FTPChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10" selected="selected">10</option><option value="25">25</option><option value="50">50</option><option value="100">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="5000">5000</option><option value="555">other</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr><tr><td align="right">Passive Mode:</td><td><select name="PassiveMode"><option value="0">Disabled</option><option value="1">Enabled</option></select></td><td></td><td><input name="WANAddress" value="1" type="checkbox"> Send WAN Address</td><td><input name="LegacyStyleList" value="1" type="checkbox"> Legacy-Style LIST</td></tr><tr><td colspan="2"></td><td></td><td><input name="FixedActivePort" value="1" checked="checked" type="checkbox"> Use Fixed Active Port</td><td></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the FTP module should put in the Server Log. Usually you should use the <code>Major</code> (password modification reports) or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the FTP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. Most FTP clients send passwords in the clear text format, and setting the Log setting to these values for long periods of time can become a security hole if the Log file can be copied from the Server computer.</p><p>The FTP module records in the System Log are marked with the <code>FTP</code> tag.</p></li><li><p><code>Channels</code></p><p>When you specify a non-zero value for the <code>TCP/IP</code> Channels setting, the FTP module creates a so-called &quot;listener&quot; on the specified port(s). The module starts to accept FTP connections from FTP clients. This setting is used to limit the number of simultaneous connections the FTP module can accept. If there are too many incoming connections open, the module will reject new connections, and the users should retry later.</p><p>If the number of channels is set to zero, the FTP module closes the listener and releases (unbinds from) the TCP port(s).</p></li><li><p><code>Listener</code></p><p>By default, the FTP module Listener accepts clear text connections on the TCP port 8021. Follow the <a href="./../network/Listener.html">listener</a> link to tune the FTP <a href="./../network/Listener.html">Listener</a>.<br> If the server computer does not have any other FTP server software running, you may want to switch the FTP Listener to the port 21 (the standard FTP port).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The FTP protocol has a &quot;NAT traversal&quot; problem. When working in the &quot;active&quot; mode, the FTP server needs to open data connections to the client computer, and if there is a NAT device between the FTP server and the client computer, attempts to establish these data connections would fail. To solve this problem, most NAT devices/programs implement an FTP proxy, but they activate this feature only if they detect an outgoing connection to the port 21.</p></div><p>If you use the FTP module with a non-standard port number (such as 8021), your users connecting from behind NAT devices won&#39;t be able to do data transfers in the &quot;active&quot; mode (the &quot;passive&quot; mode should work correctly).</p></li><li><p><code>Passive Mode</code></p><p>When this option is disabled, the FTP module rejects requests for passive-mode file transfers.</p></li><li><p><code>Send WAN Address</code></p><p>Use this option to send the Server or Cluster <a href="./../network/#WAN">WAN Address</a> when a client requests a Passive Mode transfer.</p></li><li><p><code>Use Fixed Active Port</code></p><p>If this option is enabled, the FTP module uses the fix TCP port number for active (outgoing) data connections. That port number is the port number the FTP control connection is accepted on minus 1.<br> If this option is disabled, the FTP module selects the TCP port for active (outgoing) data connections from the TCP port range set using the <a href="./../network/#Ports">Network</a> settings. You may want to disable this option for certain Cluster configurations.</p></li><li><p><code>Legacy-Style LIST</code></p><p>When this option is enabled, the Server always sends a positive response to the LIST command, even if the target directory is unavailable.<br> This option can help some clients that always open a data connection for LIST results, ignoring error messages the Server sends.</p></li></ul><h2 id="Site" tabindex="-1">Access to Account File Storage <a class="header-anchor" href="#Site" aria-label="Permalink to &quot;Access to Account File Storage {#Site}&quot;">​</a></h2><p>When an FTP user is authenticated, the current directory is set to the topmost directory of the Account <a href="./../storage/FileStore.html">File Storage</a>.<br> The FTP module allows a user to upload, download, rename and remove file from File Storage and its directories.<br> The FTP module allows a user to create, remove, and rename directories in the Account File Storage.</p><p>It is possible to access File Storage of some other Account by using the <code>~accountName/</code> name prefix (to access the <em>accountName</em> Account in the same Domain), or by using the <code>~accountName@domainName/</code> name prefix to access File Storage of any Account in any Domain.</p><p>Please see the <a href="./../storage/FileStore.html">File Storage</a> section for the details on the required Access Rights.</p><h2 id="Passive" tabindex="-1">Passive Mode Connections <a class="header-anchor" href="#Passive" aria-label="Permalink to &quot;Passive Mode Connections {#Passive}&quot;">​</a></h2><p>The FTP module supports Passive Mode transfers. In this mode, the FTP module opens a separate listener port/socket, sends the IP address and port number of that socket to the client, and the client opens a TCP connection to the specified address and port.</p><p>When the CommuniGate Pro Server is located behind a NAT/Firewall, external (WAN) clients using the Passive Mode connect to an external WAN address, rather than the Server own IP address. If the NAT/Firewall cannot fix this problem, use the Send WAN Address option.</p><p>The FTP Module uses the <a href="./../signals/NAT.html#Proxy">TCP Media Proxy</a> ports for Passive Mode transfers.</p>',21)]))}const m=t(s,[["render",i]]);export{u as __pageData,m as default};
