import{_ as s,C as a,c as n,o as l,ag as o,j as e,a as r,G as c}from"./chunks/framework.jCcxW76o.js";const P=JSON.parse('{"title":"IMAP Module","description":"","frontmatter":{"legacyLink":"IMAP.html"},"headers":[],"relativePath":"admin/access/IMAP.md","filePath":"admin/access/IMAP.md"}'),d={name:"admin/access/IMAP.md"},h={action:"Null.html"},p={class:"settingsBox"},u={width:"100%"};function m(f,t,A,g,M,b){const i=a("font");return l(),n("div",null,[t[3]||(t[3]=o('<h1 id="imap-module" tabindex="-1">IMAP Module <a class="header-anchor" href="#imap-module" aria-label="Permalink to &quot;IMAP Module&quot;">​</a></h1><p>The CommuniGate Pro IMAP module implements an IMAP server. IMAP servers allow client applications (mailers) to retrieve messages from Account Mailboxes using the IMAP4rev1 Internet protocol (RFC2060) via TCP/IP networks.</p><p>The IMAP protocol allows client applications to create additional Account Mailboxes, to move messages between Mailboxes, to mark messages in Mailboxes, to search Mailboxes, to retrieve MIME structure of stored messages, and to retrieve individual MIME components of messages stored in Account Mailboxes.</p><p>The CommuniGate Pro IMAP module supports both <em>clear text</em> and <em>secure (SSL/TLS)</em> connections.</p><h2 id="Protocol" tabindex="-1">Internet Message Access Protocol (IMAP) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Internet Message Access Protocol (IMAP) {#Protocol}&quot;">​</a></h2><p>The Internet Message Access Protocol allows client computers to work with messages stored in Mailboxes on remote mail servers. A computer running a mailer (mail client) application connects to the mail server computer and provides account (user) name and the password. If access to the specified user account is granted, the mail application sends protocol commands to the mail server. These protocol commands tell the server to list all messages in the Mailbox, to retrieve certain messages, to delete messages, to search for messages with the certain attributes, to move messages between Mailboxes, etc.</p><p>CommuniGate Pro IMAP supports <a href="./../common/Features.html#IMAP">various Internet standards</a> (RFCs) and has many <a href="./../common/Features.html#IMAP">additional unique features</a>.</p><h2 id="Configuring" tabindex="-1">Configuring the IMAP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the IMAP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the IMAP module. Open the Access page in the Settings realm:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="IMAPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><select name="IMAPChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100" selected="selected">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="5000">5000</option><option value="555">other</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr><tr><td colspan="2"> </td><td align="right">Send &#39;Running&#39; every:</td><td><select name="RunningPeriod"><option value="0">Never</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="30" selected="selected">30 sec</option><option value="60">60 sec</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="11">other</option></select></td></tr></tbody></table></div></form><p>Use the Log setting to specify the type of information the IMAP module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the IMAP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The IMAP module records in the System Log are marked with the <code>IMAP</code> tag.</p><p>When you specify a non-zero value for the <code>Maximum Number of Channels</code> setting, the IMAP module creates a so-called &quot;Listener&quot;. The module starts to accept all IMAP connections that mail clients establish in order to retrieve mail from your server. The setting is used to limit the number of simultaneous connections the IMAP module can accept. If there are too many incoming connections open, the module will reject new connections, and the mail client should retry later.</p><p>By default, the IMAP module Listener accepts clear text connections on the TCP port 143, and secure connections - on the TCP port 993. Follow the <a href="./../network/Listener.html">listener</a> link to tune the IMAP <a href="./../network/Listener.html">Listener</a>.</p><p>The IMAP module supports the STARTTLS command that allows client mailers to establish a connection in the clear text mode and then turn it into a secure connection.</p><ul><li><p><code>Send &#39;Running&#39; every</code></p><p>If this setting is not set to <code>Never</code>, the IMAP module monitors how long it take to execute the APPEND, COPY, and SEARCH operations. If any of these operations takes longer than the specified period of time, the module sends an &quot;untagged&quot; response to the client application. This feature can be used to prevent client application time-outs, and it can also help in dealing with various NAT boxes that tend to close connections if they show no activity.</p></li></ul><h2 id="MultiAccess" tabindex="-1">Multi-Access <a class="header-anchor" href="#MultiAccess" aria-label="Permalink to &quot;Multi-Access {#MultiAccess}&quot;">​</a></h2><p>While many other IMAP servers &quot;lock&quot; opened Mailboxes, the CommuniGate Pro IMAP module is designed to provide simultaneous access to any Mailbox for any number of clients.</p><p>The IMAP module uses the CommuniGate Pro Mailbox Manager that provides simultaneous access for all types of protocols and clients. See the <a href="./../storage/Mailboxes.html#MultiAccess">Mailboxes</a> section for the details.</p><h2 id="ACL" tabindex="-1">Access Control Lists <a class="header-anchor" href="#ACL" aria-label="Permalink to &quot;Access Control Lists {#ACL}&quot;">​</a></h2><p>The IMAP module supports RFC2086 (IMAP4 ACL extension). This protocol extension allows IMAP users to grant access to their Mailboxes to other users.</p><p>See the <a href="./../storage/Mailboxes.html#ACL">Mailboxes</a> section for the detailed description of Mailbox ACLs.</p><p>In order to set Access Rights, a client should use a decent IMAP client that supports the ACL protocol extension. If such a client is not available, Mailbox access rights can be set using the <a href="./WebUser.html">WebUser</a> Interface.</p><h2 id="Shared" tabindex="-1">Foreign (Shared) and Public Mailboxes <a class="header-anchor" href="#Shared" aria-label="Permalink to &quot;Foreign (Shared) and Public Mailboxes {#Shared}&quot;">​</a></h2><p>CommuniGate Pro allows account users to access Mailboxes in other Accounts. See the <a href="./../storage/Mailboxes.html#Foreign">Mailboxes</a> section for the details.</p><p>Many popular IMAP clients do not support foreign Mailboxes. There is a workaround for IMAP mailers that use the &quot;subscription&quot; scheme. Subscription is a list of Mailbox names that the mailer keeps on the server. Usually, mailers build the subscription list when you configure them for the first time. Later, they show only the Mailboxes included into the subscription list.</p><p>By using a different IMAP client or the WebUser Interface, a user can add a foreign Mailbox name (such as <code>~sales/processed</code> or <code>~public/news/company</code>) to the subscription list. This will make the old IMAP client show the foreign Mailbox along with the regular account Mailboxes, and the user will be able to work with that foreign Mailbox.</p><p>Some IMAP clients do not support foreign Mailboxes at all. To let those clients access shared Mailboxes in other Accounts, <a href="./../storage/Mailboxes.html#Aliases">Mailbox Aliases</a> can be used.</p><h2 id="AUTH" tabindex="-1">User Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;User Authentication {#AUTH}&quot;">​</a></h2><p>The IMAP module allows users to employ all <a href="./../sysadmin/Security.html#SASL">authentication methods</a> supported with the CommuniGate Pro Server.</p><p>If the Domain <a href="./../sysadmin/Security.html#SASL">CLRTXT Login Method</a> option is switched off, and the connection is not encrypted using SSL/TLS, the Server adds the LOGINDISABLED keyword into the list of its supported capabilities.</p><h2 id="NonMAIL" tabindex="-1">Non-Mail Mailboxes <a class="header-anchor" href="#NonMAIL" aria-label="Permalink to &quot;Non-Mail Mailboxes {#NonMAIL}&quot;">​</a></h2><p>The CommuniGate Pro IMAP module provides access to Mailboxes of all <a href="./../storage/Mailboxes.html#Classes">Classes</a> (Calendar, Contacts, etc.). Some clients and/or users can be confused when they see a non-Mail Mailbox.</p><p>The module includes non-Mail Mailboxes into its IMAP <code>LIST</code> command response if:</p><ul><li>the Account <a href="./../objects/Accounts.html#NonMailIMAP">Non-Mail Mailboxes visible in IMAP</a> setting is enabled, or</li><li>the IMAP <code>LIST</code> command has the <code>CLASS</code> <a href="#Extensions">extension</a>, or</li><li>the IMAP <code>ENABLE EXTENSIONS</code> <a href="#Extensions">command</a> has been executed.</li></ul><h2 id="Alerts" tabindex="-1">Notification Alerts <a class="header-anchor" href="#Alerts" aria-label="Permalink to &quot;Notification Alerts {#Alerts}&quot;">​</a></h2><p>The CommuniGate Pro IMAP module checks for any pending <a href="./../sysadmin/Alerts.html">alert message</a> sent to the authenticated Account. The alert messages are transferred to the client mailer using the standard IMAP <code>[ALERT]</code> response code.</p><p>The CommuniGate Pro IMAP module checks for alert messages right after the user is authenticated, and it can detect and send alert messages at any time during an IMAP session.</p><h2 id="LoginRef" tabindex="-1">Login Referrals <a class="header-anchor" href="#LoginRef" aria-label="Permalink to &quot;Login Referrals {#LoginRef}&quot;">​</a></h2><p>The IMAP module supports RFC2221 (Login Referrals).<br> As explained in the <a href="./../cluster/Access.html">Access section</a> all user addresses provided with mail clients are processed with the <a href="./../sysadmin/Router.html">Router</a>.<br> If the specified user name is routed to an external Internet address (handled with the SMTP module) the IMAP module returns a negative response and provides a login referral. If an IMAP client supports login referrals, it will automatically switch to the new address.</p><ul><li><p>Sample:</p><p>A user account <code>j.smith</code> has been moved from your server to the account <code>John</code> at the <code>othercompany.com</code> server. In order to reroute the user mail you have created an alias record in the Router:<br><code>&lt;j.smith&gt; = John@othercompany.com</code><br> Now, when this user tries to connect to his old j.smith account on your server, the server rejects the user name, but provides a login referral:<br><code>1234 NO [REFERRAL IMAP://John;AUTH=*@othercompany.com/] account has been moved to a remote system</code><br> If the mail client supports login referrals, it will automatically try to connect to the server othercompany.com as the user John.</p></li></ul><h2 id="Monitoring" tabindex="-1">Monitoring IMAP Activity <a class="header-anchor" href="#Monitoring" aria-label="Permalink to &quot;Monitoring IMAP Activity {#Monitoring}&quot;">​</a></h2><p>You can monitor the IMAP module activity using the WebAdmin Interface. Click the Access link in the Monitors realm to open the IMAP Monitoring page:</p>',43)),e("form",h,[e("div",p,[e("table",u,[e("tbody",null,[e("tr",null,[t[0]||(t[0]=e("td",null,[e("input",{name:"Apply",value:"Filter",class:"button",type:"reset"}),r(),e("input",{name:"Filter",value:"",size:"10",maxlength:"100",type:"text"})],-1)),e("td",null,[c(i,{color:"red"})]),t[1]||(t[1]=e("td",{align:"right"},"3 of 3 selected",-1))])])]),t[2]||(t[2]=e("table",{class:"settingsBox",border:"1",cellpadding:"2",cellspacing:"0",width:"90%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",{nowrap:"nowrap"},"ID"),e("th",null,"IP Address"),e("th",null,"Account"),e("th",null,"Connected"),e("th",null,"Status"),e("th",{colspan:"2"},"Running")]),e("tr",null,[e("td",null,"9786"),e("td",null,"[216.200.213.116]"),e("td",null,"user1@domain2.dom"),e("td",null,"3min"),e("td",null,"selecting a mailbox"),e("td",null,"2sec")]),e("tr",null,[e("td",null,"9794"),e("td",null,"[216.200.213.115]"),e("td",null,"user2@domain1.dom"),e("td",null,"34sec"),e("td",null,"connected to mailbox"),e("td",null," ")]),e("tr",null,[e("td",null,"9803"),e("td",null,"[216.200.213.115]"),e("td"),e("td",null,"2sec"),e("td",null,"Authenticating"),e("td",null," ")])])],-1))])]),t[4]||(t[4]=o(`<ul><li><p><code>ID</code></p><p>This field contains the IMAP numeric session ID. In the CommuniGate Pro Log, this session records are marked with the <code>IMAP-_nnnnn_</code> flag, where <em>nnnnn</em> is the session ID.</p></li><li><p><code>Address</code></p><p>This field contains the IP address the client has connected from.</p></li><li><p><code>Account</code></p><p>This field contains the name of the client Account (after successful authentication).</p></li><li><p><code>Connected</code></p><p>This field contains the connection time (time since the client opened this TCP/IP session).</p></li><li><p><code>Status</code></p><p>This field contains either the name of the operation in progress or, if there is not pending operation, the current session status (Authenticating, Selected, etc.)</p></li><li><p><code>Running</code></p><p>If there is an IMAP operation in progress, this field contains the time since operation started.</p></li></ul><p>If an IMAP connection is used for a <a href="./MAPI.html">MAPI</a> session, the connection row is displayed with a green background.</p><p>IMAP activity can be monitored using the CommuniGate Pro <a href="./../sysadmin/Statistics.html">Statistic Elements</a>.</p><h2 id="Specifics" tabindex="-1">IMAP Implementation Details <a class="header-anchor" href="#Specifics" aria-label="Permalink to &quot;IMAP Implementation Details {#Specifics}&quot;">​</a></h2><p>The CommuniGate Pro IMAP module implements many IMAP extensions. Some of these extenstions work in the implementation-specific manner.</p><ul><li><p><code>QUOTA</code></p><p>Each account has its own Quota Root</p></li><li><p><code>NAMESPACE</code></p><p>The standard CommuniGate Pro &quot;account name&quot; prefix. The tilda (<code>~</code>) symbol can be used to access Mailboxes in other Accounts.<br> The <code>~public</code> prefix is reported as the Public Namespace prefix, but it is the responsibility of the Domain Administrator to ensure that the Account <code>public</code> is created in the proper Domain.</p></li><li><p><code>UNSELECT</code></p><p>This IMAP command is equivalent to the <code>CLOSE</code> command, but it does not expunge any message marked as <code>\\Deleted</code></p></li></ul><h2 id="Extensions" tabindex="-1">Additional IMAP Extensions <a class="header-anchor" href="#Extensions" aria-label="Permalink to &quot;Additional IMAP Extensions {#Extensions}&quot;">​</a></h2><p>The CommuniGate Pro IMAP module provides several protocol extensions that are not part of the IMAP standard and are not included into the existing IMAP Extention standards.</p><ul><li><p><code>COPY</code></p><p>The <code>ENCRYPTED _certificateData_</code> parameter can be specified after the target Mailbox name. <em>certificateData</em> is either a base64-encoded PKI Certificate, or the asterisk (<code>*</code>) symbol, referring to the personal S/MIME Certificate of the authenticated user.<br> The copied messages are <a href="./../sysadmin/PKI.html#SMIMEPost">S/MIME-encrypted</a> using the specified certificate.</p></li><li><p><code>STATUS</code></p><p>The <code>STATUS</code> command can use the following additional data item names:</p><ul><li><p><code>INTERNALSIZE</code></p><p>The data item included into the response is a number. This number specifies the size of the Mailbox as it is stored on the server. This size is close to, but not exactly the same as the sum of the RFC822.SIZE attributes of all messages stored in the Mailbox.</p></li><li><p><code>OLDEST</code></p><p>The data item included into the response is a <code>date_time</code> string. It specifies the INTERNALDATE of the oldest message stored in the Mailbox. If the Mailbox has no messages, this data item is not included into the response.</p></li><li><p><code>UNSEENMEDIA</code></p><p>The data item included into the response is the number of messages that have the Media flag set but do not have the Seen flag set.</p></li><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>A001 STATUS mailbox (UNSEEN OLDEST INTERNALSIZE UNSEENMEDIA)</span></span>
<span class="line"><span>* STATUS mailbox (UNSEEN 14 OLDEST &quot;23-Feb-2002 07:59:42 +0000&quot; INTERNALSIZE 2345678 UNSEENMEDIA 1)</span></span>
<span class="line"><span>A001 OK completed</span></span></code></pre></div></li></ul></li><li><p><code>LIST</code></p><p>The LIST command can use additional options along with the options specified in the LISTEXT extension standard: <code>UIDVALIDITY</code>, <code>CLASS</code>, <code>MESSAGES</code>, <code>UIDNEXT</code>, <code>UNSEEN</code>, <code>INTERNALSIZE</code>, <code>OLDEST</code>, <code>UNSEENMEDIA</code></p><p>The data items included into the response have the following format:</p><p><code>\\option_name(option_value)</code></p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>A001 LIST (CHILDREN CLASS UNSEEN INTERNALSIZE) &quot;&quot; &quot;ma%&quot;</span></span>
<span class="line"><span>* LIST (\\HasNoChildren CLASS(&quot;IPF.Contact&quot;) \\UNSEEN(14) \\INTERNALSIZE(2345678) \\Unmarked) mailbox</span></span>
<span class="line"><span>A001 OK completed</span></span></code></pre></div></li></ul></li><li><p><code>APPEND</code></p><p>The <code>APPEND</code> command can use additional options:</p><ul><li><p><code>REPLACESUID(_number_)</code></p><p>If this extension is specified, after the message is appended, the message with the specified UID (if it exists) is removed from the target Mailbox. Appending and removing is performed as an atomic operation.</p></li><li><p><code>CHECKOLDEXISTS</code></p><p>If this extension is specified, it should be specified together with the <code>REPLACESUID</code> extension. When this extension is specified, the message is appended only if the message with the UID specified with the <code>REPLACESUID</code> extension still exists in the target Mailbox. Otherwise an error condition is generated.</p></li><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>A001 APPEND &quot;Drafts&quot; (\\Seen \\Draft) &quot;20-JAN-2010&quot; (REPLACESUID(30675) CHECKOLDEXISTS) {3450}</span></span>
<span class="line"><span>+ Send the message text</span></span></code></pre></div></li></ul></li><li><p>Additional message flags.</p><p>The <code>$MDN</code>, <code>$Hidden</code>, and <code>$Media</code> IMAP message flags are supported, to allow manipulation with these <a href="./../storage/Mailboxes.html#Flags">message flags</a>. Adding a $Service message flag to a message effectively removes the message from the &quot;Mailbox view&quot;.</p></li><li><p><code>ENABLE EXTENSIONS</code></p><p>After this IMAP command has been executed:</p><ul><li>messages with the special <code>$Service</code> message flag become visible</li><li>non-Mail Mailboxes become visible</li></ul></li></ul>`,9))])}const v=s(d,[["render",m]]);export{P as __pageData,v as default};
