import{_ as o,a as t,b as a,c as n,d as i,e as r,f as s,g as l,h as c,i as h,j as d,k as p,l as u,m,n as f}from"./chunks/MAPIDebug.CveBXEpP.js";import{_ as g,c as b,o as y,ag as P}from"./chunks/framework.jCcxW76o.js";const x=JSON.parse('{"title":"MAPI Connector","description":"","frontmatter":{"legacyLink":"MAPI.html"},"headers":[],"relativePath":"admin/access/MAPI.md","filePath":"admin/access/MAPI.md"}'),v={name:"admin/access/MAPI.md"};function w(C,e,A,M,I,k){return y(),b("div",null,e[0]||(e[0]=[P('<h1 id="mapi-connector" tabindex="-1">MAPI Connector <a class="header-anchor" href="#mapi-connector" aria-label="Permalink to &quot;MAPI Connector&quot;">​</a></h1><p>The CommuniGate Pro Server can be used as a &quot;service provider&quot; for Microsoft Windows applications supporting the MAPI (Microsoft Messaging API). To use this service, a special Connector library (CommuniGate Pro MAPI Connector <code>dll</code>) should be installed on client Microsoft Windows workstations.</p><p>The CommuniGate Pro MAPI Connector requires either a Groupware-type License Key or a special MAPI License Key.</p><p>You can review the CommuniGate Pro MAPI Connector Revision History.</p><h2 id="Overview" tabindex="-1">MAPI Connector Overview <a class="header-anchor" href="#Overview" aria-label="Permalink to &quot;MAPI Connector Overview {#Overview}&quot;">​</a></h2><p>MAPI stands for <strong>M</strong>essaging <strong>A</strong>pplication <strong>P</strong>rogramming <strong>I</strong>nterface, the system component that the Microsoft corporation has included into its Windows® operating system and the API to use that component with Windows applications.</p><p>The MAPI infrastructure provides an additional level of abstraction. Windows applications do not deal directly with a groupware server (or any other &quot;data store&quot;). Instead, applications send Messaging requests (such as &quot;list my mailboxes&quot;, &quot;retrieve message number X&quot;, etc.) to the MAPI component, and the MAPI component uses the installed &quot;Connector&quot; modules to send those requests to an Exchange® server, to locally stored &quot;personal folders&quot;, to a fax server, etc.</p><p>The expandable nature of the MAPI architecture allows for creation of additional &quot;Connectors&quot; that can interact with various server products. One of the problems that such a Connector has to solve is data format: Windows applications send data objects via MAPI to Connector modules in the so-called &quot;MAPI object&quot; format that has very little in common with any Internet format. The CommuniGate Pro MAPI Connector converts the MAPI data into one of the standard Internet formats and stores the converted &quot;messaging objects&quot; as standard Internet messages in a CommuniGate Pro Mailbox. When reading those Mailboxes, the CommuniGate Pro MAPI Connector converts messages back into the &quot;MAPI object&quot; format and passes the converted objects back to MAPI and Windows applications (such as Outlook).</p><p>The CommuniGate Pro MAPI Connector acts as a &quot;MAPI provider&quot;. It accepts Messaging API requests from Microsoft Outlook (Outlook 2002, Outlook XP and later) running in the &quot;groupware&quot; mode, and from other Windows applications. The MAPI Connector converts these requests into extended IMAP commands and sends them to the CommuniGate Pro Server.</p><p>The CommuniGate Pro MAPI Connector also performs data conversion between proprietary Microsoft &quot;objects&quot; data formats and the standard Internet data formats.<br> Because the standard Internet formats are used, messages stored with the CommuniGate Pro MAPI Connector can be read using any standard POP3 or IMAP mail client, the CommuniGate Pro WebUser Interface, or any XIMSS-based client.</p><p>The CommuniGate Pro MAPI Connector uses TCP/IP networks and should be configured to connect to any non-TLS (clear text) IMAP port of your CommuniGate Pro server (the port 143 is the standard IMAP port).</p><p>The CommuniGate Pro MAPI Connector supports both <em>clear text</em> and <em>secure</em> (SSL/STARTTLS) connections, and it can use plain text and secure CRAM-MD5 login methods.</p><p>The CommuniGate Pro MAPI Connector contains two code parts (shared libraries). The <em>starter code</em> part should be installed on Windows workstations. It provides the configuration interface and it is used to connect to the CommuniGate Pro server. The main MAPI Connector functionality is implemented as a shared library stored in the Server application directory, and it is called the <em>server code</em> part.</p><p>When the MAPI Connector <em>starter code</em> connects to the CommuniGate Pro Server, the Server sends the <em>server code</em> part of the MAPI Connector to the client computer.</p><p>This method allows you to deploy &quot;regular&quot; MAPI Connector updates by updating your CommuniGate Pro Server software only, without running the MAPI Connector Installer on all client workstations.</p><p><img src="'+o+'" alt="MAPI Clients Schema"></p><h2 id="Install" tabindex="-1">Installing the MAPI Connector <a class="header-anchor" href="#Install" aria-label="Permalink to &quot;Installing the MAPI Connector {#Install}&quot;">​</a></h2><p>You need to install the MAPI Connector <em>starter</em> code part shared library (a <code>.dll</code> file) on Microsoft Windows workstations. Download the <a href="https://communigatepro.ru/plugins#mapi" target="_blank" rel="noreferrer">MAPI Connector</a> archive and unpack it. The unpacked folder contains the <code>Setup.exe</code> file.</p><p>Start the unpacked <code>Setup.exe</code> application to install or update your CommuniGate Pro MAPI Connector software. After successful install, the application may ask you to re-create your Mail Profile.</p><p>You can use the same <code>Setup.exe</code> application to uninstall the MAPI Connector software from the workstations.</p><p>The MAPI Connector <code>Setup.exe</code> program can be started in the <em>silent</em> mode (without any user interface dialogs) using the following command-line parameters:</p><ul><li><p><code>/i</code></p><p>install or upgrade the MAPI Connector</p></li><li><p><code>/r</code></p><p>remove the MAPI Connector</p></li><li><p><code>/q</code></p><p>do not ask for profile configuration</p></li><li><p><code>/Q</code></p><p>do not display error messages</p></li></ul><p>You may want to use the silent mode to install or upgrade the MAPI Connector <em>starter code part</em> on many workstation, using the Windows network administration methods and tools.</p><p>To set the language of the MAPI-Connector interface the <a href="ftp://ftp.communigatepro.ru/pub/client/cgmxp32.ini" target="_blank" rel="noreferrer"><code>cgmxp32.ini</code></a> file can be used. Place it into the same directory where the setup.exe installer resides.</p><p>During installation process the file will be copied to the C:\\Windows directory (if MAPI-Connector was installed earlier, you can do this manually).</p><p>The language of the MAPI-Connector interface will be set according to the OS localization.</p><p>To automate MAPI-Connector configuration the <a href="ftp://ftp.communigatepro.ru/pub/client/cgmxui32.inf" target="_blank" rel="noreferrer"><code>cgmxui32.inf</code></a> file can be used. Modify this file to fit your needs (the description of the settings is within the file), then place it into the same directory where the setup.exe installer resides.</p><p>During installation process the file will be copied to the C:\\Windows directory (if MAPI-Connector has been installed earlier, you can do this manually).</p><p>To create an Outlook profile with the predefined MAPI-Connector settings run command prompt as Administrator and execute the following command:</p><p><code>regsvr32.exe cgmxui32.dll /i:16</code></p><p><em>For Outlook 32-bit cgmxui32.dll resides in C:\\Windows\\SysWOW64</em></p><p><em>For Outlook 64-bit cgmxui32.dll resides in C:\\Windows\\System32</em></p><p>As the result, the Outlook profile with the name <em>username</em>_CGATE (where <em>username</em> is the name of the currently logged in user) will be created with the predefined MAPI-Connector settings.</p><p>If, as the result of the command execution, an error message appears, make sure, that the command is run as Administrator, and the <a href="ftp://ftp.communigatepro.ru/pub/client/cgmxui32.inf" target="_blank" rel="noreferrer"><code>cgmxp32.inf</code></a> file exists in the C:\\Windows directory.</p><p>Alternative way not requiring Administrator rights:</p><p>Run <a href="https://www.communigatepro.ru/CGFromExchange/ExchangeToCGP-Win32-Intel.zip" target="_blank" rel="noreferrer"><code>ex2cgp</code></a>, matching Outlook bitness, with the following parameters:</p><p><code>ex2cgp.exe profileonly _full_path_to_cgmxui32.inf_</code></p><p>If you need the created profile to be set as default, add &quot;default &quot; in the end.</p><p>Example:</p><p><code>ex2cgp.exe profileonly C:\\Users\\Bob\\cgmxui32.inf default</code></p><h2 id="Profile" tabindex="-1">Creating a Mail Profile <a class="header-anchor" href="#Profile" aria-label="Permalink to &quot;Creating a Mail Profile {#Profile}&quot;">​</a></h2><p>When the CommuniGate Pro MAPI Connector is installed on a client workstation, you can create a Mail Profile that will tell Outlook and other applications to use the CommuniGate Pro MAPI services.</p><p>If you use Outlook 98 or Outlook 2000 check that it is configured to run in the &quot;groupware mode&quot;. Start Outlook, and select the <code>Options</code> item from the <code>Tools</code> menu. The Options dialog box appears. Select the <code>Mail Services</code> Tab and click the <code>Reconfigure Mail Support</code> button to open the <code>E-mail Service Options</code> dialog box. Check that the <code>Corporate or Workgroup</code> option is selected.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You may need the MS Office installation CD-ROM to complete Outlook mode switching.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The latest versions of the MAPI Connector (1.54 and up) rely on the Unicode-enabled interfaces of MAPI that are not compatible with Outlook 98 and Outlook 2000.</p></div><p>Open the <code>Mail</code> Control Panel and click the <code>Show Profiles</code> button. The list of Mail profiles appears. If the CommuniGate Pro MAPI Installer has instructed you to re-create your existing Profile, select the old Profile and click the <code>Remove</code> button.</p><p>Click the <code>Add</code> button to create a new Profile. Depending on the version of the Outlook and the Mail control panel installed, you will see several dialog boxes. If you see a dialog box with the <code>Additional Server Types</code> option, select that option. Select <code>CommuniGate Pro Server</code> as the &quot;service&quot; or &quot;additional server type&quot;.</p><p>You can add other services into the same Profile.</p><h2 id="Configure" tabindex="-1">Configuring the MAPI Connector <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Configuring the MAPI Connector {#Configure}&quot;">​</a></h2><p>When the CommuniGate Pro service is added to a Mail Profile, the service settings can be configured. Later you can open the <code>Mail</code> control panel, open this Profile, and open the <code>CommuniGate Pro Server</code> settings. You can also use the <code>Services</code> item in the Outlook <code>Tools</code> menu to open the service settings.</p><h3 id="Server" tabindex="-1">Server <a class="header-anchor" href="#Server" aria-label="Permalink to &quot;Server {#Server}&quot;">​</a></h3><p>The Server panel allows you to specify the CommuniGate Pro Server and Account data:</p><p><img src="'+t+'" alt="MAPI Server Settings"></p><ul><li><p><code>Server Name</code></p><p>The name of your CommuniGate Pro Server. This should be a domain (DNS) name that has an A-record pointing to the network (IP) address of the server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The MAPI Connector adds this name to the Account Name (see below) to send fully-qualified account names to the Server. This feature simplifies multi-domain support using a single IP address. Make sure that the specified name is either a name of some CommuniGate Pro <a href="./../objects/Domains.html">Domain</a>, or a name of some CommuniGate Pro Domain Alias, otherwise the Server will report the <code>account has been moved to a remote system</code> error.</p></div></li><li><p><code>Server Port</code></p><p>The network port the CommuniGate Pro Server uses for MAPI clients. This is the same port as the port used for <a href="./IMAP.html">IMAP</a> clients.</p></li><li><p><code>Use a Secure (SSL/TLS) connection</code></p><p>If this option is selected, the MAPI Connector establishes a regular (clear text) network connection to the specified Server port, and uses the STARTTLS command to encrypt all data sent between the workstation and the Server. STARTTLS allows you to use the same server IMAP port for both clear text and secure connections.<br> If this option is selected, and the specified Server Port is 993 (the standard port number for secure IMAP), then the MAPI Connector establishes a secure connection to that port. This method should be used if the only port available on the server is the secure IMAP port.<br> See the <a href="./../sysadmin/PKI.html#TLS">PKI</a> section for more details.</p></li><li><p><code>Use Windows Integrated Authentication (Kerberos)</code></p><p>Select this option if your Windows workstation is a member of a Windows/Active Directory Domain or is controlled by some other Kerberos KDC. The MAPI Connector will use your Windows username and credentials to connect to the CommuniGate Pro server.<br> If you want to use this option, make sure that:</p><ul><li>Your CommuniGate Pro Account has the <a href="./../objects/Accounts.html#Passwords">Kerberos Authentication</a> method enabled.</li><li>Your CommuniGate Pro Domain has the proper <a href="./../sysadmin/Security.html#Kerberos">Kerberos Keys</a> exported from the Active Directory or Kerberos KDC.</li></ul></li><li><p><code>Use the Following Authentication details</code></p><p>Select this option if you want to specify the Account name explicitly.</p><ul><li><p><code>Account Name</code></p><p>The name of the CommuniGate Pro Account to work with. This name can be a qualified name in the <code>accountName@domainName</code> form. If the simple name form is used (the name does not contain the <code>@</code> symbol), the MAPI Connector adds the <code>Server Name</code> setting value to the specified account name.</p></li><li><p><code>Password</code></p><p>The password for the specified CommuniGate Pro Account.</p></li><li><p><code>Remember Password</code></p><p>If this option is not selected, the MAPI Connector will present a Login dialog box every time it needs to connect to the Server. If this option is selected, the supplied password is stored in the MAPI Connector settings data.</p></li><li><p><code>Use Secure Authentication</code></p><p>If this option is selected, the MAPI Connector sends passwords using secure (encoded) SASL CRAM-MD5 method. The secure method does not work if passwords are stored on the Server using a one-way encrypted method (see the <a href="./../sysadmin/PKI.html#TLS">Security</a> section for more details). In this case this option should be disabled, and the MAPI Connector will send passwords in clear text.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you need to send passwords in clear text while connecting to the Server via public networks, enable the <code>Use a Secure connection</code> option, so all information is encrypted.</p></div></li></ul></li></ul><h3 id="UserSettings" tabindex="-1">Account Settings <a class="header-anchor" href="#UserSettings" aria-label="Permalink to &quot;Account Settings {#UserSettings}&quot;">​</a></h3><p>The Account Settings dialog box can be opened by pressing the Account Settings button on the Server panel. The box allows you to specify the MAPI Account name and other general data:</p><p><img src="'+a+'" alt="MAPI Account Settings"></p><h3 id="Connection" tabindex="-1">Connection <a class="header-anchor" href="#Connection" aria-label="Permalink to &quot;Connection {#Connection}&quot;">​</a></h3><p>The Connection panel allows you to select your network connection method.</p><p><img src="'+n+'" alt="MAPI Connection"></p><ul><li><p><code>Offline</code></p><p>When working in the Offline mode (without a server connection, and using the local message cache only), you may want to tell the Connector to start in the Offline mode.<br> This will eliminate connection attempts on startup (to avoid bringing up your modem, for example).</p></li></ul><h3 id="Advanced" tabindex="-1">Advanced <a class="header-anchor" href="#Advanced" aria-label="Permalink to &quot;Advanced {#Advanced}&quot;">​</a></h3><p>The Advanced panel allows you to specify other CommuniGate Pro Accounts you want to work with.</p><p><img src="'+i+'" alt="MAPI Advanced"></p><p>Use the Add and Remove buttons to specify the names of other CommuniGate Pro Accounts. If you want to access an Account in a different Domain, specify the full name: <code>accountName@domainName</code>.</p><p>The Account owners must grant you Mailbox Access Rights, otherwise you won&#39;t be able to see and open Mailboxes in those Accounts. See the <a href="./../storage/Mailboxes.html">Mailboxes</a> section for more details on foreign Mailbox access.</p><p>The Synchronization settings allow you to override the selection of folders to work with in the <a href="#Offline">Offline mode</a>.</p><ul><li><p><code>Include all folders in Send/Receive operation</code></p><p>Use this option to select all the account folders for download, regardless the selection in Outlook -&gt; Tools -&gt; Options -&gt; CommuniGate Pro.</p></li><li><p><code>Always download entire message</code></p><p>With this option checked the Connector will download the entire message bodies (versus Headers Only).</p></li></ul><p>Use the Cache files root folder settings to specify where the MAPI Connector should store its local cache. The local cache is used for most MAPI Connector operations, it also allows you to use the MAPI applications (such as Outlook) in the off-line mode.</p><ul><li><p><code>Local Outlook Application Data folder</code></p><p>Use this option to store the cache files in the default location on your workstation. The cache file will be available on this workstation only.</p></li><li><p><code>Global Outlook Application Data folder</code></p><p>Use this option is you use Windows roaming features and plan to use your Outlook application from several workstations.<br> Note: the cache files can be quite large (they may even store a complete copy of all your server-based Mailbox data, depending on the Connector settings). If the cache file becomes large, you can experience delays when you are logging into the workstation, as the workstation needs to copy all roaming data.</p></li><li><p><code>Custom</code></p><p>Use this option if you want to store the cache files in a custom location. For example, you may want to choose a shared folder on a file server to avoid delays caused by roaming.</p></li></ul><h2 id="Sharing" tabindex="-1">Enabling Mailbox Sharing <a class="header-anchor" href="#Sharing" aria-label="Permalink to &quot;Enabling Mailbox Sharing {#Sharing}&quot;">​</a></h2><p>You can specify Access Control List for your Mailboxes to grant access to those Mailboxes to other CommuniGate Pro users.</p><p>Select a Mailbox in the Outlook Folder List, and use the <code>Properties</code> menu item to open the Properties dialog box. Open the Permissions panel:</p><p><img src="'+r+'" alt="MAPI ACL"></p><p>Use the Add and remove buttons to specify the Accounts and other <em>identifiers</em> to specify those who should have access to this Mailbox.</p><p>Select an identifier in the list and use the checkboxes to grant required access rights to this identifier. See the <a href="./../storage/Mailboxes.html#ACL">Mailboxes</a> section for more details on Mailbox ACLs.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>A user needs to have the Admin Access Right in order to specify the default Mailbox (Folder) View.</p></div><h2 id="Delegation" tabindex="-1">Delegation <a class="header-anchor" href="#Delegation" aria-label="Permalink to &quot;Delegation {#Delegation}&quot;">​</a></h2><p>The MAPI Connector supports the &quot;delegation&quot; feature: users can send E-mails and Calendar invitations &quot;on behalf of&quot; or &quot;as&quot; other users.</p><p>To grant some user delegation rights for your Account,grant that user the Read (Select) right for your INBOX.</p><h2 id="FreeBusy" tabindex="-1">Free/Busy Information <a class="header-anchor" href="#FreeBusy" aria-label="Permalink to &quot;Free/Busy Information {#FreeBusy}&quot;">​</a></h2><p>The Free/Busy information is a file specifying when the person is busy, free, out of the office, etc. This information is usually made publicly available, so other users can access it when planning their meetings, scheduling appointments, etc. To compose the Free/Busy data, the groupware client application collects data from user Calendar(s), and merges it into one Free/Busy schedule.</p><h3 id="FBPost" tabindex="-1">Posting Free/Busy Information <a class="header-anchor" href="#FBPost" aria-label="Permalink to &quot;Posting Free/Busy Information {#FBPost}&quot;">​</a></h3><p>The MAPI Connector stores your Free/Busy information in your Account <a href="./../storage/FileStore.html">File Storage</a>.<br> Publicly available information in the standard vCalendar format is stored as the <code>freebusy.vfb</code> file in the topmost directory of your File Storage.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Make sure your CommuniGate Pro <a href="./../objects/Accounts.html#Settings">Account Settings</a> allow the MAPI Connector to store a file with your Free/Busy information in your File Storage.</p></div><p>This feature allows users of Outlook and other calendaring clients to access your File Storage via HTTP and retrieve your Free/Busy information. The URL for the CommuniGate Pro Connector user Free/Busy information is</p><p><code>http://domainName:port/~accountName/freebusy.vfb</code></p><h3 id="FBAccess" tabindex="-1">Accessing Free/Busy Information for Other Users <a class="header-anchor" href="#FBAccess" aria-label="Permalink to &quot;Accessing Free/Busy Information for Other Users {#FBAccess}&quot;">​</a></h3><p>In order to process Appointments and Meetings, the Outlook application on the client machine should be able to access the Free/Busy information of other users. This operation is implemented via the MAPI Connector, but also may be done by the Outlook application itself. To configure your Outlook application:</p><ul><li>Select Options from the Tools menu to open the Options dialog box.</li><li>Click the Calendar Options button to open the Calendar Options dialog box.</li><li>Click the Free/Busy Options button to open the Free/Busy Options dialog box.</li><li>Enter the <code>http://%SERVER%/~%NAME%/freebusy.vfb</code> URL string into the Search field. (read all the notes below).</li><li>Click the OK buttons to close all dialog boxes.</li></ul><p>This option will be used by the Outlook application when it needs to retrieve the Free/Busy information for an E-mail user. The application substitutes the %SERVER% symbols with the domain part of the user E-mail, and the %NAME% symbols with the username part of the user E-mail, so for the E-mail address <code>john@myserver.dom</code> the Outlook will use the <code>http://myserver.dom/~john/freebusy.vfb</code> URL to retrieve John&#39;s Free/Busy schedule.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The suggested Search URL will work only if your CommuniGate Pro Server accepts WebUser Interface connections on the port 80. If it accepts them on the default port 8100, or on any other non-standard port, the Search URL must include that port:</p></div><p><code>http://%SERVER%:8100/~%NAME%/freebusy.vfb</code></p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The suggested Search URL will work only if your CommuniGate Pro Domains have names that have A-records pointing to the CommuniGate Pro server. Often, the DNS system does not contain any A-record for your <code>mydomain.dom</code> Domains, or those records point to a different system (company Web server), while the CommuniGate Pro Server addresses are specified as <code>mail.mydomain.com</code>, or <code>cgate.mydomain.com</code>, or <code>mx.mydomain.com</code> or similar DNS A-record(s). In this case the Search URL must be modified to use the proper domain names:</p></div><p><code>http://mail.%SERVER%/~%NAME%/freebusy.vfb</code></p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If your CommuniGate Pro server is serving only one Domain, then you can specify the Search URL as:</p></div><p><code>http://mail.mydomain.com/~%NAME%/freebusy.vfb</code></p><p>where mail.mydomain.com is the name of the CommuniGate Pro Domain or its alias. This should be a name of a DNS A-record pointing to the CommuniGate Pro Server.</p><p>Search URLs specified above allow users to retrieve Free/Busy information for the users of the same CommuniGate Pro system.</p><p>The Search URL may be used to retrieve the Free/Busy Information for users of other CommuniGate Pro Servers, as long as the Search URL correctly represents their Free/Busy file URLs. To overwrite the Search URL and specify a different (correct) path to some remote user Free/Busy file, create a Contact record for that user, click on the Details tab and enter the correct FreeBusy file URL into the Internet Free-Busy Address field. See the Microsoft Outlook manual for more details on these settings.</p><h2 id="Offline" tabindex="-1">Working Offline <a class="header-anchor" href="#Offline" aria-label="Permalink to &quot;Working Offline {#Offline}&quot;">​</a></h2><p>When you work in the Offline mode, the MAPI Connector does not have access to the messages stored on the CommuniGate Pro server. To be able to work productively, you need to make sure that the messages you need are stored in the MAPI Connector local cache. You specify the cache options on the per-Mailbox (per-folder) basis.</p><p>Use the Options item in the Outlook Tools menu to open the Options dialog box. Then open the CommuniGate Pro panel:</p><p><img src="'+s+'" alt="MAPI Folders"></p><p>Select the folder you need to work with when you use the Offline mode, and select the downloading method. If you select to download the entire message, the folder name will be shown in bold, if you choose to download message headers only, there will be only a check mark next to the folder name.</p><p>Use the Outlook Tools-&gt;CommuniGate Pro Server menu to synchronize the changes you do in the Offline mode with the CommuniGate Pro server.</p><p><img src="'+l+'" alt="MAPI Tools Menu"></p><p>Synchronization takes place when the Send/Receive operation is initiated (manually or automatically, based on the schedule).</p><ul><li><p><code>Mark to Download Message(s)</code></p><p>The messages selected in the Outlook Mailbox view will be marked so their full bodies are downloaded during the next Send/Receive operation.</p></li><li><p><code>Mark to Delete Message(s)</code></p><p>The messages selected in the Outlook Mailbox view will be marked so they will be removed from the Server storage during the next Send/Receive operation.</p></li><li><p><code>Unmark Selected Headers</code></p><p>Cancels the pending off-line operations for the messages selected in the Outlook Mailbox view.</p></li></ul><h2 id="Rules" tabindex="-1">Configuring Automatic Rules <a class="header-anchor" href="#Rules" aria-label="Permalink to &quot;Configuring Automatic Rules {#Rules}&quot;">​</a></h2><p>The MAPI Connector allows you to specify the server-side Rules to process mail coming to your Account.</p><p>Use the Tools-&gt;CommuniGate Pro menu to open the Rules editor window:</p><p><img src="'+c+'" alt="MAPI Rules Editor"></p><p>Click the New button to create a new Rule. New Rule has no condition and no action.</p><p>Click the Add button to add Rule conditions and actions:</p><p><img src="'+h+'" alt="MAPI Rule Action"></p><p>See the <a href="./../mail/QueueRules.html">Automatic Rules</a> section for more details.</p><h2 id="Integration" tabindex="-1">WebMail Integration <a class="header-anchor" href="#Integration" aria-label="Permalink to &quot;WebMail Integration {#Integration}&quot;">​</a></h2><p>The MAPI Connector employs the user WebMail (WebUser Interface) settings. It instructs the MAPI applications (such as the Microsoft Outlook) to use the same names for &quot;Special&quot; Mailboxes. As a result MAPI applications and the WebUser Interface use the same Trash or Deleted Items Mailbox to store removed messages, use the same Mailbox as the Main Calendar Mailbox, etc.</p><p>The MAPI Connector also retrieves the user Domain Mail Trailer setting. The content of that setting is added to all non-encrypted and not-signed text messages submitted via the MAPI Connector.</p><p>The values specified via the Account Settings panel are stored in the WebUser Settings, so both the WebUser Interface and MAPI sessions use the same From:, Reply-To:, and Organization values.</p><h2 id="Interoperability" tabindex="-1">Communicating with Microsoft Exchange users <a class="header-anchor" href="#Interoperability" aria-label="Permalink to &quot;Communicating with Microsoft Exchange users {#Interoperability}&quot;">​</a></h2><p>Outlook users that work with Exchange servers may have problems sending meeting requests to your users working with the CommuniGate Pro MAPI Connector. Meeting requests sent via an Exchange server may come in as plain text messages instead. The Exchange users should adjust the configuration of their Outlook applications:</p><p>Using Outlook Tools menu, Exchange users should open the Options dialog box. After they click the Calendaring Options button, the dialog box appears and they should enable the <code>Send meeting requests using iCalendar by default</code> option.</p><h2 id="MakeCall" tabindex="-1">Real-Time Communications <a class="header-anchor" href="#MakeCall" aria-label="Permalink to &quot;Real-Time Communications {#MakeCall}&quot;">​</a></h2><p>The MAPI Connector allows Outlook users to employ Real-Time (VoIP, etc.) functions of the CommuniGate Pro Server.</p><p>Outlook users can initiate a phone call using the telephone number specified in a Contact item. Right-click a Contact record to open a pop-up menu and select the Call using CommuniGate Pro item:</p><p><img src="'+d+'" alt="MakeCall - Contact"></p><p>You can also use the CommuniGate Pro Server submenu in the Tools menu.</p><p>A dialog box with the Contact name and phone number appears:</p><p><img src="'+p+'" alt="MakeCall - Dialog"></p><p>You can type a different phone number in the second field. That number will be used for this call only, it will not be stored with the Contact Item.</p><p>Click the Start Call button to initiate a call. All your SIP devices will start to ring immediately. Answer this call on any device, and the Server will instruct it to initiate a call to the selected phone number.</p><p>The dialog box has a field displaying the call status:</p><p><img src="'+u+'" alt="MakeCall - Status"></p><h2 id="Encrypt" tabindex="-1">Server-side Encryption <a class="header-anchor" href="#Encrypt" aria-label="Permalink to &quot;Server-side Encryption {#Encrypt}&quot;">​</a></h2><p>The MAPI Connector allows you to specify Server-side <a href="./../mail/QueueRules.html">Rules</a>, including the Rules that can store incoming messages in an encrypted form.</p><p>You may also want to improve security for certain messages received and stored on the Server in clear-text.</p><p>Right-click on the selected message in Outlook. A pop-up menu will open:</p><p><img src="'+m+'" alt="Encryption"></p><p>When you select the Encrypt Message item, the MAPI Connector will send your default Certificate (containing your Public Key) to the Server. The Server will use that Certificate to encrypt the selected message. It will be stored on the Server in the encrypted S/MIME format - as if the message sender has sent it encrypted.</p><p>If you want to read Encrypted messages using your MAPI clients (Outlook) and the <a href="./WebMail.html">WebUser Interface</a>, make sure that your Windows desktop system and the WebUser Interface have the same Private Keys and Certificates installed. You can either generate a key and Certificate in the WebUser Interface and then export them to your Windows desktop system, or you can export your keys from the Windows desktop system and import them into your WebUser Interface settings.</p><h2 id="Debug" tabindex="-1">Troubleshooting <a class="header-anchor" href="#Debug" aria-label="Permalink to &quot;Troubleshooting {#Debug}&quot;">​</a></h2><p>The MAPI Connector works as a liaison between MAPI applications (such as Microsoft Outlook) and the CommuniGate Pro Server. The problem a user can experience with its client, can be a bug or feature of that client, or a problem in the MAPI Connector or Server software. To help investigate the problem, the MAPI Connector can generate a detailed Log of all operations it was requested to perform. You can examine that Log yourself or send it to <a href="mailto:support@communigatepro.ru" target="_blank" rel="noreferrer">CommuniGate Systems technical support</a>.</p><p>Open the Troubleshooting panel in the MAPI Connector (&quot;CommuniGate Pro Service&quot;) setup box:</p><p><img src="'+f+'" alt="MAPI Debug"></p><p>The panel displays the versions of both MAPI Connector software components: the <em>starter code</em> library installed on your desktop computer and the <em>server code</em> library retrieved from the CommuniGate Pro Server.</p><p>Select the Enable Logging option to start MAPI Connector log recording. The MAPI Connector Log keeps only the last records, so the Log file does not exceed the size specified in the Maximum Log File Size setting.</p><p>Use the checkbox controls to enable logging for various MAPI Connector components.</p><p>Click the Show Me Log File button to open a file directory window the Log file is stored in. You can use this feature to E-mail the Log file to <a href="mailto:support@communigatepro.ru" target="_blank" rel="noreferrer">CommuniGate Systems technical support</a>.</p><p>Click the Delete Log File to clear the Log file.</p><p>Use the Compatibility options to tune up the MAPI Connector operation for mixed environments.</p><ul><li><p><code>Send in Outlook native message format</code></p><p>In some rare cases special messages (such as Task requests or forwarded Contacts) sent via the MAPI Connector in the Internet format may be interpreted incorrectly by Outlook Exchange (or Outlook IMAP) users. Checking this option may help to solve the problem.</p></li><li><p><code>Send in Outlook 2000 compatible format</code></p><p>Older versions of Outlook may have problems interpreting Calendar and Contact items in the format used by newer versions of Outlook. Check this option to use older format for these items.</p></li><li><p><code>Send in Exchange 5.5 compatible format</code></p><p>Meeting requests in formats used by newer versions of Outlook may be incorrectly interpreted by Exchange 5.5 servers. Check this option if any of your correspondents use this version of Exchange server and have problems accepting your meeting requests.</p></li><li><p><code>Conservative mass deletion</code></p><p>In some configuration the Outlook Autoarchive function may remove messages in large portions. To avoid this problem, select this option.</p></li><li><p><code>Always convert RTF to HTML</code></p><p>Selecting this option causes the <code>text/rtf</code> MIME parts in outgoing messages to be converted to HTML, which is understood by the larger number of mail client applications.</p></li><li><p><code>Do not display &quot;Server transaction in progress...&quot; dialog</code></p><p>During long server transactions the Connector displays a progress indicator window. If you don&#39;t want that select this option.</p></li><li><p><code>Show reports in Outlook native format</code></p><p>Outlook can use a special form to display <em>non delivery notification</em> messages, which provides interface for re-sending of the failed messages. For this feature to work correctly the non-delivery report should contain the full body of the failed message, which is not always the case.</p></li><li><p><code>Do not respond to requests for read receipts</code></p><p>The sender of a message may request a receipt to be sent back to him when you open a message for reading. To ignore such requests select this option.</p></li><li><p><code>No history uploads for large messages</code></p><p>To fulfill Outlook requests to set some extended property on a message the MAPI Connector may re-upload modified message back to the server. This may take quite a while for large messages. To disable this kind of activity check this option.</p></li><li><p><code>Erase messages immediately, do not mark for deletion</code></p><p>To increase performance, by default messages are not removed immediately but rather are marked for deletion and removed physically when the folder containing them is closed. If the folder is accessed by several clients simultaneously, these items marked for deletion may still appear in those clients and confuse users. To avoid that you can check this option.</p></li><li><p><code>Refresh connection every minute</code></p><p>Some NAT and anti-virus/spam firewalls are very aggressive in terminating TCP connections which they assume to be idle. Closing IMAP sessions this way on the TCP level may confuse Outlook. With this option checked, the MAPI Connector will produce some minimal data exchange on the connection to the CommuniGate pro server, so that connection does not appear idle to the firewall.</p></li><li><p><code>Restrict search to downloaded items only</code></p><p>Searching through some message attributes may require downloading items to the client. This may take quite a while for large message store. With this option checked only those items that were previously cached by the MAPI Connector will be searched.</p></li></ul><h2 id="Limitations" tabindex="-1">Known Limitations <a class="header-anchor" href="#Limitations" aria-label="Permalink to &quot;Known Limitations {#Limitations}&quot;">​</a></h2><p>The protocols and APIs the MAPI Connector implements are not the Internet standards, but API from the Microsoft® Corporation. Those APIs are not fully documented, and as a result, some minor client (Outlook) functions may be unavailable. CommuniGate Systems is working on solving these problems, and the MAPI Connector updates are released on a regular basis.</p>',155)]))}const q=g(v,[["render",w]]);export{x as __pageData,q as default};
