import{_ as t,c as a,o as s,ag as n}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"POP Module","description":"","frontmatter":{"legacyLink":"POP.html"},"headers":[],"relativePath":"admin/access/POP.md","filePath":"admin/access/POP.md"}'),o={name:"admin/access/POP.md"};function i(l,e,c,r,p,d){return s(),a("div",null,e[0]||(e[0]=[n(`<h1 id="pop-module" tabindex="-1">POP Module <a class="header-anchor" href="#pop-module" aria-label="Permalink to &quot;POP Module&quot;">​</a></h1><p>The CommuniGate Pro POP module implements a POP3 server. POP3 servers allow client applications (mailers) to retrieve messages from Account Mailboxes using the POP3 Internet protocol (STD0053, RFC1939, RFC1734, RFC1725) via TCP/IP networks.</p><p>The CommuniGate Pro POP module implements several protocol extensions, including the XTND XMIT extension. Some mailers can employ this feature to submit E-mail messages to the CommuniGate Pro Server.</p><h2 id="Protocol" tabindex="-1">Post Office Protocol (POP3) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Post Office Protocol (POP3) {#Protocol}&quot;">​</a></h2><p>The Post Office Protocol allows computers to retrieve messages from mail server mailboxes. A computer running a mailer (mail client) application connects to the mail server computer and provides account (user) name and the password. If access to the specified user account is granted, the mail application sends protocol commands to the mail server. These protocol commands tell the server to list all messages in the mailbox, to retrieve certain messages, or to delete them. When a server receives a request to retrieve a message, it sends the entire message to the mail client. The mail client may choose to retrieve only the first part of the message.</p><p>The POP3 protocol does not provide direct support multi-mailbox Accounts. If a client application specifies a multi-mailbox Account, the INBOX Mailbox is opened.</p><p>When the client application sends a request to delete a message from the Mailbox, the message is not deleted immediately, but it is marked by the server. Only when the client application ends the session properly and closes the connection, the marked messages are then removed.</p><p>The POP module supports the XTND XMIT extension of the POP protocol. This extension allows users to submit messages via the POP protocol instead of the SMTP protocol.</p><h2 id="Configuring" tabindex="-1">Configuring the POP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the POP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the POP module. Open the Access page in the Settings realm:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="POPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><select name="POPChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100" selected="selected">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="5000">5000</option><option value="555">other</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr></tbody></table></div></form><p>Use the Log Level setting to specify what kind of information the POP module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the POP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The POP module records in the System Log are marked with the <code>POP</code> tag.</p><p>When you specify a non-zero value for the <code>Maximum Number of Channels</code> setting, the POP module creates a so-called &quot;listener&quot;. The module starts to accept all POP connections that mail clients establish in order to retrieve mail from your server. The setting is used to limit the number of simultaneous connections the POP module can accept. If there are too many incoming connections open, the module will reject new connections, and the mail client should retry later.</p><p>By default, the POP module Listener accepts clear text connections on the TCP port 110. The standard TCP port number for secure POP connections is 995, but it is not enabled by default. Follow the <a href="./../network/Listener.html">listener</a> link to tune the POP <a href="./../network/Listener.html">Listener</a>.</p><p>The POP module supports the STARTTLS command that allows client mailers to establish a connection in the clear text mode and then turn it into a secure connection.</p><h2 id="AUTH" tabindex="-1">User Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;User Authentication {#AUTH}&quot;">​</a></h2><p>The POP module allows users to employ all <a href="./../sysadmin/Security.html">authentication methods</a> supported with the CommuniGate Pro Server, as well as the <code>APOP</code> method.</p><p>The <a href="./../objects/Accounts.html#POPLoginLimit">Account Settings</a> can be used to limit the frequency of POP client logins.</p><h2 id="TLS" tabindex="-1">Secure (encrypted) Access <a class="header-anchor" href="#TLS" aria-label="Permalink to &quot;Secure (encrypted) Access {#TLS}&quot;">​</a></h2><p>The POP module can be used to accept SSL/TLS (encrypted) connections from user mailers (see the Listener configuration note above). Additionally, the POP module supports the <code>STLS</code> command that allows client mailers to establish plain text, unencrypted connections (using the regular TCP port 110), and then start encrypted communications on those connections.</p><h2 id="Special" tabindex="-1">Special Features <a class="header-anchor" href="#Special" aria-label="Permalink to &quot;Special Features {#Special}&quot;">​</a></h2><p>Unlike many other POP servers, the CommuniGate Pro POP module does not &quot;lock&quot; the Mailbox it opens on a mail clients behalf. The open Mailbox can be used by other client applications at the same time. See the <a href="./../storage/Mailboxes.html#MultiAccess">Mailboxes</a> section for the details.</p><p>Since the POP3 protocol was not designed to support these features, the CommuniGate Pro POP module:</p><ul><li>shows only the messages that existed in the Mailbox when the Mailbox was opened with the client mailer; all new messages received during this session will be seen by the POP client only when it connects to the Mailbox again;</li><li>keeps <em>zombies</em> for the messages deleted during the current session; the module shows them as messages of a zero size, and the module reports an error when a client application tries to retrieve a deleted message;</li></ul><p>When a client mailer retrieves a message with the RETR command, the message is marked with the &quot;Seen&quot; flag (this change is noticed when using an IMAP or XIMSS client with the same Mailbox). The TOP command that allows a client POP mailer to retrieve only the first part of the message does not set the Seen flag.</p><p>The POP module supports the &quot;empty AUTH&quot; command (the <code>AUTH</code> command without parameters), returning the list of supported <a href="./../sysadmin/Security.html">SASL methods</a>.</p><h2 id="XMIT" tabindex="-1">The XTND XMIT Extension <a class="header-anchor" href="#XMIT" aria-label="Permalink to &quot;The XTND XMIT Extension {#XMIT}&quot;">​</a></h2><p>The CommuniGate Pro POP module implements the XTND XMIT protocol extension. Mailer applications that support this extension (like Eudora®) can submit messages to the Server via a POP connection.</p><p>This feature can be useful for mobile users that would be otherwise unable to send their messages via CommuniGate Pro SMTP due to the Server anti-spam protection. Submitting messages via POP can be more convenient than using the <a href="./../sysadmin/Protection.html#Mobile">&quot;address-remembering&quot; scheme</a>, since this method does not have time restrictions.</p><h2 id="Alerts" tabindex="-1">Notification Alerts <a class="header-anchor" href="#Alerts" aria-label="Permalink to &quot;Notification Alerts {#Alerts}&quot;">​</a></h2><p>The POP3 protocol does not provide any method to send a notification alert to the client mailer. If an Account has any pending <a href="./../sysadmin/Alerts.html">Alert message</a>, the CommuniGate Pro POP Module simply rejects the connection request after the user is authenticated.</p><p>The returned error code contains the Alert message text:</p><p>ALERT: <em>alert message text</em></p><p>When the user repeats a connection attempt to the same Account, the next pending Alert message is returned as an error - till all Alert messages are sent to that user.</p><h2 id="MultiMailbox" tabindex="-1">Accessing Additional Mailboxes <a class="header-anchor" href="#MultiMailbox" aria-label="Permalink to &quot;Accessing Additional Mailboxes {#MultiMailbox}&quot;">​</a></h2><p>Unlike the <a href="./IMAP.html">IMAP</a> protocol, the POP3 protocol was designed to access only one Account Mailbox - the INBOX Mailbox.</p><p>The POP module allows users to access any Account Mailbox by specifying the Mailbox name as a part of the Account name. To access the <em>mailboxname</em> Mailbox in the <em>accountname</em> Account, a user should specify the account name as: <code>_mailboxname_#_accountname_</code>:</p><table tabindex="0"><thead><tr><th><strong>Account name</strong> (specified in the mailer settings)</th><th><strong>Accessed Mailbox</strong></th></tr></thead><tbody><tr><td><code>jsmith</code></td><td><code>INBOX</code> Mailbox in the <code>jsmith</code> Account</td></tr><tr><td><code>private#jsmith</code></td><td><code>private</code> Mailbox in the <code>jsmith</code> Account</td></tr><tr><td><code>lists/info#jsmith@client1.com</code></td><td><code>lists/info</code> Mailbox in the <code>jsmith</code> Account in the <code>client1.com</code> Domain</td></tr></tbody></table><p>The POP module allows a user to access any Mailbox in any other Account (a <em>foreign</em> or <em>shared</em> Mailbox), as well as public Mailboxes. See the <a href="./../storage/Mailboxes.html#Foreign">Mailboxes</a> section for the details.</p><p>If a user can log into the <em>accountname</em> Account and wants to access the Mailbox <em>mailboxname</em> in the <em>otheraccount</em> Account, that user should specify the Account name as: <code>~otheraccount/mailboxname#accountname</code>:</p><table tabindex="0"><thead><tr><th><strong>Account name</strong> (specified in the mailer settings)</th><th><strong>Accessed Mailbox</strong></th></tr></thead><tbody><tr><td><code>jsmith</code></td><td><code>INBOX</code> Mailbox in the <code>jsmith</code> Account</td></tr><tr><td><code>~public/announces#jsmith</code></td><td>the public Mailbox <code>announces</code></td></tr><tr><td><code>~boss/INBOX#jsmith</code></td><td><code>INBOX</code> Mailbox in the <code>boss</code> Account</td></tr></tbody></table><p>In all samples above, the user is authenticated as <code>jsmith</code>, using the jsmith account password.</p><p>If the authenticated user does not have a right to delete messages in the selected Mailbox, the <code>DELE</code> protocol operations fail and an error code is returned to the user mailer.</p><p>The POP module can also use the <a href="./../mail/Local.html#Direct">Direct Mailbox Addressing</a> feature to open additional Mailboxes.</p><h2 id="Individual" tabindex="-1">Accessing Individual Mail in a Unified Account <a class="header-anchor" href="#Individual" aria-label="Permalink to &quot;Accessing Individual Mail in a Unified Account {#Individual}&quot;">​</a></h2><p>The POP module implements <a href="./../mail/Local.html#Unified">Unified Domain-Wide Account</a> filtering. As all <a href="./../cluster/Access.html">access modules</a>, the POP module uses the <a href="./../sysadmin/Router.html">Router</a> to process the specified username.</p><p>If a client mailer specifies the <code>abcdef@client1.com</code> username (as used in the <a href="./../mail/Local.html#Unified">example</a>), the Router routes this address to the Local account <code>Cl1</code>, and it returns <code>abcdef</code> as the <em>local part</em> of the resulting address.</p><p>The POP module checks the local part returned by the Router, and if this string is not empty, it performs filtering on the open Mailbox: the module hides all Mailbox messages that do not have the <code>X-Real-To</code> header field (or other field specified in the Local Delivery module settings), or do not have the specified string (individual name) listed in that header field.</p><p>So, if the user has specified the <code>abcdef@client1.com</code> username, only the messages originally routed to that particular address will be shown in the CL1 Account Mailbox.</p><p>If a user connects as <code>Cl1</code>, the same Account Mailbox will be opened, but since the local part string will be empty in this case, all Mailbox messages will be shown.</p><ul><li><p>Example:</p><p>The Router line:</p><p><code>client1.com = Cl1.local</code></p><p>The first message is sent to:</p><p><code>abcdef@client1.com</code></p><p>It is stored in the Cl1 account INBOX with unique ID 101, and a header field is added:</p><p><code>X-Real-To: abcdef</code></p><p>The next message is sent to:</p><p><code>xyz@client1.com</code></p><p>It is stored in the Cl1 account INBOX with unique ID 102, and a header field is added:</p><p><code>X-Real-To: xyz</code></p><p>After these 2 messages are stored, POP sessions will show different <em>views</em> depending on the user name specified:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>S: +OK CommuniGate Pro POP Server is ready</span></span>
<span class="line"><span>C: USER Cl1</span></span>
<span class="line"><span>S: +OK, send pass</span></span>
<span class="line"><span>C: PASS mypassword</span></span>
<span class="line"><span>S: +OK 2 message(s)</span></span>
<span class="line"><span>C: UIDL</span></span>
<span class="line"><span>S: +OK</span></span>
<span class="line"><span>S: 1 101</span></span>
<span class="line"><span>S: 2 102</span></span>
<span class="line"><span>S: .</span></span>
<span class="line"><span>C: QUIT</span></span>
<span class="line"><span>S: +OK bye-bye</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S: +OK CommuniGate Pro POP Server is ready</span></span>
<span class="line"><span>C: USER abcdef@client1.com</span></span>
<span class="line"><span>S: +OK, send pass</span></span>
<span class="line"><span>C: PASS mypassword</span></span>
<span class="line"><span>S: +OK 1 message(s)</span></span>
<span class="line"><span>C: UIDL</span></span>
<span class="line"><span>S: +OK</span></span>
<span class="line"><span>S: 1 101</span></span>
<span class="line"><span>S: .</span></span>
<span class="line"><span>C: QUIT</span></span>
<span class="line"><span>S: +OK bye-bye</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S: +OK CommuniGate Pro POP Server is ready</span></span>
<span class="line"><span>C: USER xyz@client1.com</span></span>
<span class="line"><span>S: +OK, send pass</span></span>
<span class="line"><span>C: PASS mypassword</span></span>
<span class="line"><span>S: +OK 1 message(s)</span></span>
<span class="line"><span>C: UIDL</span></span>
<span class="line"><span>S: +OK</span></span>
<span class="line"><span>S: 1 102</span></span>
<span class="line"><span>S: .</span></span>
<span class="line"><span>C: QUIT</span></span>
<span class="line"><span>S: +OK bye-bye</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S: +OK CommuniGate Pro POP Server is ready</span></span>
<span class="line"><span>C: USER blahblah@client1.com</span></span>
<span class="line"><span>S: +OK, send pass</span></span>
<span class="line"><span>C: PASS mypassword</span></span>
<span class="line"><span>S: +OK 0 message(s)</span></span>
<span class="line"><span>C: UIDL</span></span>
<span class="line"><span>S: +OK</span></span>
<span class="line"><span>S: .</span></span>
<span class="line"><span>C: QUIT</span></span>
<span class="line"><span>S: +OK bye-bye</span></span></code></pre></div></li></ul>`,52)]))}const u=t(o,[["render",i]]);export{m as __pageData,u as default};
