import{_ as t,c as o,o as r,ag as i}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"TFTP Module","description":"","frontmatter":{"legacyLink":"TFTP.html"},"headers":[],"relativePath":"admin/access/TFTP.md","filePath":"admin/access/TFTP.md"}'),a={name:"admin/access/TFTP.md"};function d(n,e,s,l,c,h){return r(),o("div",null,e[0]||(e[0]=[i('<h1 id="tftp-module" tabindex="-1">TFTP Module <a class="header-anchor" href="#tftp-module" aria-label="Permalink to &quot;TFTP Module&quot;">​</a></h1><p>The CommuniGate Pro TFTP module implements a TFTP server for UDP/IP networks.</p><p>The TFTP protocol allows a TFTP client application to retrieve files from the Server computer and to store files on the Server computer. The CommuniGate Pro TFTP clients can read and write Account <a href="./../storage/FileStore.html">File Storage</a> files.</p><h2 id="Protocol" tabindex="-1">Trivial File Transfer Protocol <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Trivial File Transfer Protocol {#Protocol}&quot;">​</a></h2><p>The Trivial File Transfer Protocol allows client computers to work with files stored on remote servers. A computer running a TFTP client application sends UDP request packets to the server computer. These packets contain the name of the file to read or to store, and the transfer mode.<br> For a file read operation, the server computer replies with a UDP packet with a block of file data. If the file is larger than one block, then the client computer sends an ACK (acknowledgment) packet, and the server computer sends the next block of file data in response.<br> For a file write operation, the server computer replies with an ACK UDP packet, the client computer sends the first file data block, the server computer replies with an ACK packet, and the client computer sends the next data block.</p><p>The CommuniGate Pro TFTP module supports relevant <a href="./../common/Features.html#TFTP">Internet standards</a> (RFCs).</p><h2 id="Configuring" tabindex="-1">Configuring the TFTP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the TFTP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the TFTP module. Open the Access pages in the Settings realm, and open the TFTP page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr><tr><td align="right">Default Storage:</td><td><input name="DefaultSite" value="postmaster" size="30" maxlength="255" type="text"></td><td><input type="checkbox" name="TryIPDirectory" value="1" checked="checked"> Try IP-Address Directory</td></tr><tr><td colspan="2"></td><td><input type="checkbox" name="ViaController" value="1" checked="checked"> Run Sessions on Controller</td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the TFTP module should put in the Server Log. Usually you should use the <code>Major</code> (password modification reports) or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the TFTP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.<br> The TFTP module records in the System Log are marked with the <code>TFTP</code> tag.</p></li><li><p><code>listener</code></p><p>Use this link to open the UDP Listener page and specify the port number and local network address for the TFTP service, and access restrictions for that port. When the port number is set to 0, the TFTP server is disabled.<br> By default TFTP clients send requests to the UDP port 69.<br> If your server computer is already running some TFTP server, you may want to specify a non-standard port number here and reconfigure your TFTP client software to use that port number.</p></li><li><p><code>Default Storage</code></p><p>Since the TFTP protocol does not authenticate clients, you need to specify the File Storage to be used by default.<br> Specify a name of an existing Account in this field.<br> If that Account does not belong to the Main Domain, specify the full Account name as <code>accountName@domainName</code>.<br> You can specify a subdirectory of the Account File Storage by adding the subdirectory name separated with the slash (<code>/</code>) symbol: <code>accountName/directoryName</code> or <code>accountName@domainName/directoryName</code></p></li><li><p><code>Try IP-Address Directory</code></p><p>If this option is enabled, the module adds the client IP address to the specified file name, thus allowing different identically configured clients to work with different file sets (see below).</p></li><li><p><code>Run Sessions on Controller</code></p><p>This option is available in a <a href="./../cluster/">Dynamic Cluster</a> only.<br> When this option is enabled, the Server sends all TFTP requests to the Cluster Controller (unless this Server is the active Controller itself), using the inter-cluster CLI protocol. It then relays the Controller responses to the client.<br> This feature is required when you use a Load Balancer that does not keep any &quot;session&quot; or &quot;state&quot; for UDP requests, and subsequent requests within the same TFTP session can be directed to different Cluster members.</p></li></ul><h2 id="Site" tabindex="-1">Access to Account File Storage <a class="header-anchor" href="#Site" aria-label="Permalink to &quot;Access to Account File Storage {#Site}&quot;">​</a></h2><p>The file name specified in the TFTP read or write request packet is interpreted as the name of a file in the Default Account File Storage.</p><p>If the specified file name starts with the slash (<code>/</code>) or Tilda (<code>~</code>) symbol, the file name should contain at least one non-leading slash symbol. The string between the leading special symbol and that slash symbol is interpreted as an Account name, and the string after that slash symbol - as the name of the file to retrieve from the File Storage of the specified Account.</p><p>If the specified file name starts with the slash (<code>/</code>) symbol, but it does not contain any other slash symbols, the leading slash symbol is removed.</p><p>The TFTP module reads or writes the specified files on behalf of the <code>tftpuser</code> in the Main Domain. This makes it possible to retrieve files from any Account File Storage directory outside the <code>private</code> directories.<br> To allow TFTP clients to access <code>private</code> directories or to allow TFTP clients to store files, modify the target directory <a href="./../storage/FileStore.html#ACL">File Access Rights</a>, granting the <code>tftpuser</code> the Read and/or Write rights.</p><p>Examples:</p><table tabindex="0"><thead><tr><th>TFTP <em>filename</em> parameter</th><th>Addressed file</th></tr></thead><tbody><tr><td><code>file1.dat</code></td><td><code>file1.dat</code> in the Default File Storage</td></tr><tr><td><code>/file1.dat</code></td><td><code>file1.dat</code> in the Default File Storage</td></tr><tr><td><code>dirA/file1.dat</code></td><td><code>file1.dat</code> in the dirA subdirectory of the Default File Storage</td></tr><tr><td><code>/john/file1.dat</code>, <code>~john/file1.dat</code></td><td><code>file1.dat</code> in the Account john File Storage</td></tr><tr><td><code>/john/dirB/file1.dat</code>, <code>~john/dirB/file1.dat</code></td><td><code>file1.dat</code> in the dirB subdirectory of the Account john File Storage</td></tr><tr><td><code>/john@domain1.dom/dirB/file1.dat</code>, <code>~john@domain1.dom/dirB/file1.dat</code></td><td><code>file1.dat</code> in the dirB subdirectory of the Account john@domain1.dom File Storage</td></tr></tbody></table><p>If the Try IP-Address Directory option is enabled, and the specified file name does not start with the slash or Tilda symbol, the module appends the text presentation of the client IP address in front of the file name. For a file read operation, if a file with this name is not found, the inserted prefix is removed, and the module re-tries to retrieve a file.<br> This feature allows you to create subdirectories inside the Default Storage directory, named with certain client IP addresses.</p><p>Examples:</p><table tabindex="0"><thead><tr><th>TFTP <em>filename</em> parameter</th><th>Client IP address</th><th>Addressed file</th></tr></thead><tbody><tr><td><code>file1.dat</code></td><td>10.0.1.0</td><td><code>10.0.1.0/file1.dat</code> (if absent when reading, use <code>file1.dat</code>) in the Default File Storage</td></tr><tr><td><code>/file1.dat</code></td><td>10.0.1.0</td><td><code>10.0.1.0/file1.dat</code> (if absent when reading, use <code>file1.dat</code>) in the Default File Storage</td></tr><tr><td><code>dirA/file1.dat</code></td><td>10.0.1.0</td><td><code>10.0.1.0/dirA/file1.dat</code> (if absent when reading, use <code>dirA/file1.dat</code>) in the Default File Storage</td></tr><tr><td><code>/john/file1.dat</code>, <code>~john/file1.dat</code></td><td>10.0.1.0</td><td><code>file1.dat</code> in the Account john File Storage</td></tr></tbody></table>',20)]))}const u=t(a,[["render",d]]);export{p as __pageData,u as default};
