import{_ as t,c as o,o as a,ag as i}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"WebDAV Module","description":"","frontmatter":{"legacyLink":"WebDAV.html"},"headers":[],"relativePath":"admin/access/WebDAV.md","filePath":"admin/access/WebDAV.md"}'),s={name:"admin/access/WebDAV.md"};function l(n,e,r,c,d,p){return a(),o("div",null,e[0]||(e[0]=[i('<h1 id="webdav-module" tabindex="-1">WebDAV Module <a class="header-anchor" href="#webdav-module" aria-label="Permalink to &quot;WebDAV Module&quot;">​</a></h1><p>The WebDAV protocol is an extension of the HTTP protocol. Various clients use it to access and manage various data resources.<br> The CommuniGate Pro WebDAV module implements authenticated access to Account File Storage, Calendar, Task, and Contacts mailboxes.</p><p>The CommuniGate Pro WebDAV implementation is a part of the <a href="./../services/HTTP.html">HTTP User</a> module, and that module settings are applied to the WebDAV functions, too.</p><h2 id="Root" tabindex="-1">Root Element <a class="header-anchor" href="#Root" aria-label="Permalink to &quot;Root Element {#Root}&quot;">​</a></h2><p>The WebDAV component provides a read-only &quot;root&quot; element, with the following URLs:</p><p><code>http://servername[:port]/</code></p><p><code>https://servername[:port]/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default).</p><p>Various WebDAV (CalDAV, CardDAV, etc.) clients can be configured to use this Root Element. They can retrieve the Root Element properties, which direct them to other URLs (realms), implementing the respective protocols.</p><h3 id="RootDAVConfig" tabindex="-1">Configuring the Root Element Module <a class="header-anchor" href="#RootDAVConfig" aria-label="Permalink to &quot;Configuring the Root Element Module {#RootDAVConfig}&quot;">​</a></h3><p>The WebDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">RootDAV:</td><td><select name="ROOTDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="ROOTDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the RootDAV Log Level setting to specify the type of information the Root Element DAV module should put in the Server Log.<br> The Root Element DAV module records in the System Log are marked with the <code>RootDAV</code> tag.</p><p>The Access setting specifies who can access the RootDAV service.</p><h2 id="Principal" tabindex="-1">Principal Elements <a class="header-anchor" href="#Principal" aria-label="Permalink to &quot;Principal Elements {#Principal}&quot;">​</a></h2><p>The WebDAV protocol and protocols based on WebDAV allow users to access resources of other users if the proper access rights have been granted.<br> To support WebDAV ACLs (Access Control Lists), each CommuniGate Pro users is granted a unique URL that represents that user in the Access Control Lists. These URLs are:</p><p><code>http://servername[:port]/UserDAV/accountName@domainName</code></p><p><code>https://servername[:port]/UserDAV/accountName@domainName/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default).</p><h3 id="UserDAVConfig" tabindex="-1">Configuring the Principal Elements DAV Module <a class="header-anchor" href="#UserDAVConfig" aria-label="Permalink to &quot;Configuring the Principal Elements DAV Module {#UserDAVConfig}&quot;">​</a></h3><p>The WebDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">UserDAV:</td><td><select name="USERDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="USERDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the UserDAV Log Level setting to specify the type of information the Principal Elements DAV module should put in the Server Log.<br> The Principal Elements DAV module records in the System Log are marked with the <code>UserDAV</code> tag.</p><p>The Access setting specifies who can access the Principal Elements DAV Module service.</p><h2 id="FileDAV" tabindex="-1">File Access <a class="header-anchor" href="#FileDAV" aria-label="Permalink to &quot;File Access {#FileDAV}&quot;">​</a></h2><p>The CommuniGate Pro Server implements access to <a href="./../storage/FileStore.html">Account File Storage</a> via the WebDAV protocol (FileDAV).</p><p>All FileDAV data requests must be authenticated: the user should specify the Account name and password. The Account and its Domain must have the WebSite Service enabled.</p><p>The &quot;root&quot; of the user File Storage has the following URL:</p><p><code>http://servername[:port]/WebDAV/</code></p><p><code>https://servername[:port]/WebDAV/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default).</p><p>To Access the File Storage of some other user, the following URLs should be used:</p><p><code>http://servername[:port]/WebDAV/~accountName/</code></p><p><code>https://servername[:port]/WebDAV/~accountName/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default), and the <em>accountName</em> is the name of the Account to access. If this Account is located in a different Domain, use <em>accountName</em>@<em>domainName</em> instead.</p><h3 id="FileDAVConf" tabindex="-1">Configuring the FileDAV Module <a class="header-anchor" href="#FileDAVConf" aria-label="Permalink to &quot;Configuring the FileDAV Module {#FileDAVConf}&quot;">​</a></h3><p>The WebDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">FileDAV:</td><td><select name="FileDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="FileDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the FileDAV Log Level setting to specify the type of information the FileDAV module should put in the Server Log.<br> The FileDAV module records in the System Log are marked with the <code>FileDAV</code> tag.</p><p>The Access setting specifies who can access the FileDAV service.</p><h2 id="CalDAV" tabindex="-1">CalDAV <a class="header-anchor" href="#CalDAV" aria-label="Permalink to &quot;CalDAV {#CalDAV}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the CalDAV protocol, a WebDAV protocol extension.</p><p>This protocol allows CalDAV clients to access and modify Calendaring and Tasks data stored in the user Account(s).</p><p>A full-featured CalDAV client can detect the proper URL for CalDAV operations itself, when it is directed to the WebDAV Root element:</p><p><code>http://servername[:port]/</code></p><p><code>https://servername[:port]/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default).</p><p>If the CalDAV client cannot detect the CalDAV URL location, it should be specified explicitly:</p><p><code>http://servername:port/CalDAV/</code></p><p><code>https://servername:port/CalDAV/</code></p><p>Some CalDAV clients need to be configured to access a particular Calendar or Task collection. Any Calendaring or Tasks Mailbox can be accessed using the following URLs:</p><p><code>http://servername:port/CalDAV/mailboxName/</code></p><p><code>https://servername:port/CalDAV/mailboxName/</code></p><p>If the mailboxName ends with the <code>ics</code> file extension, the Server removes that extension.</p><p>All CalDAV data requests must be authenticated: the user should specify the Account name and password. The Account and its Domain must have the WebCal Service enabled.</p><p>If the user Domain Name or Domain Alias name is mail.company.com, the HTTP User port is 80, and the Mailbox name is <code>Calendar</code>, the access URL is</p><p><code>http://mail.company.com/CalDAV/Calendar</code></p><p><code>https://mail.company.com/CalDAV/Calendar.ics</code></p><p>Any Calendar-type or Tasks-type Mailbox can be accessed this way. To access a Mailbox in a different Account, the full Mailbox name should be specified:</p><p><code>http://mail.company.com/CalDAV/~username/Calendar/</code></p><p>The authenticated user should have proper <a href="./../storage/Mailboxes.html#ACL">access rights</a> to retrieve and/or modify data in Mailboxes belonging to other users.</p><p>The CalDAV module checks the <a href="./../storage/Mailboxes.html#Subscription">Mailbox Subscription</a> list and reports all Calendar-type Mailboxes in other Accounts included into this list.</p><p>The CalDAV module stores Calendar and Tasks attachments in the Account <a href="./../storage/FileStore.html">File Storage</a>, inside the <code>private/caldav/</code> directory.</p><h3 id="CalDAVConf" tabindex="-1">Configuring the CalDAV Module <a class="header-anchor" href="#CalDAVConf" aria-label="Permalink to &quot;Configuring the CalDAV Module {#CalDAVConf}&quot;">​</a></h3><p>The CalDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">CalDAV:</td><td><select name="CalDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="CalDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the CalDAV Log Level setting to specify the type of information the CalDAV module should put in the Server Log.<br> The CalDAV module records in the System Log are marked with the <code>CalDAV</code> tag.</p><p>The Access setting specifies who can access the CalDAV service.</p><h3 id="ICS" tabindex="-1">Using the Publish/Subscribe (ICS) method <a class="header-anchor" href="#ICS" aria-label="Permalink to &quot;Using the Publish/Subscribe (ICS) method {#ICS}&quot;">​</a></h3><p>The CommuniGate Pro HTTP User module implements an older, pre-CalDAV method of dealing with data in Calendar and Task Mailboxes.<br> The module allows client applications to retrieve all items using the iCalendar format. This operation is often called <em>subscribing</em> to Calendar data.<br> The module also allows client applications to rewrite the Mailbox content new iCalendar-formatted data (to <em>publish</em> calendaring data).</p><p>The URL for Calendaring data is:</p><p><code>http://servername:port/CalendarData/mailboxName</code></p><p><code>https://servername:port/CalendarData/mailboxName</code></p><p>where <code>port</code> is the HTTP User port (8100, 9100 by default).<br> If the mailboxName ends with the <code>ics</code> file extension, the server removes that extension.<br> If the mailboxName is empty, the Server uses the Default Calendar name.</p><p>All Calendaring data requests must be authenticated: the user should specify the Account name and password. The Account and its Domain must have their WebCal Service enabled.</p><p>If the user Domain Name or Domain Alias name is mail.company.com, the HTTP User port is 80, and the Mailbox name is <code>Calendar</code>, the access URL is</p><p><code>http://mail.company.com/CalendarData/Calendar</code></p><p><code>http://mail.company.com/CalendarData/Calendar.ics</code></p><p>Any Calendar-type or Tasks-type Mailbox can be accessed this way. To access a Mailbox in a different Account, the full Mailbox name should be specified:</p><p><code>http://mail.company.com/CalendarData/~username/Calendar.ics</code></p><p>The authenticated user should have proper <a href="./../storage/Mailboxes.html#ACL">access rights</a> to retrieve and/or modify data in Mailboxes belonging to other users.</p><p>The HTTP module supports the following HTTP operations for the /CalendarData/ realm:</p><ul><li>GET/HEAD: the Mailbox is parsed, and all items containing iCalendar information are retrieved as one VCALENDAR object with VEVENT and VTODO elements. If the Mailbox is a foreign one, the authenticated user must have the <code>Select</code> access right for that Mailbox.</li><li>DELETE: the Mailbox is parsed and all items containing iCalendar information are removed. If the Mailbox is a foreign one, the authenticated user must have the Delete access right for that Mailbox.</li><li>PUT: the HTTP request body is parsed as a VCALENDAR object. All parsed VEVENT and VTODO elements are added to the Mailbox as separate items. If parsing of any element failed, no item is added. If the Mailbox is a foreign one, the authenticated user must have the Insert access right for that Mailbox.</li></ul><p>Some applications do not support the DELETE method. These applications expect that the PUT operation removes all previous information from the Calendar Mailbox.<br> To support these applications, use the <code>CalendarDataDel</code> realm instead of the <code>CalendarData</code> realm, or include the <code>DeleteAll=&quot;1&quot;</code> parameter into the URL.<br> In this case each PUT operation will be preceded with a virtual DELETE operation removing all existing iCalendar items from the Mailbox.</p><h2 id="CardDAV" tabindex="-1">CardDAV <a class="header-anchor" href="#CardDAV" aria-label="Permalink to &quot;CardDAV {#CardDAV}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the CardDAV protocol, a WebDAV protocol extension.</p><p>This protocol allows CardDAV clients to access and modify Contacts data stored in the user Account(s).</p><p>A full-featured CardDAV client can detect the proper URL for CardDAV operations itself, when it is directed to the WebDAV Root element:</p><p><code>http://servername[:port]/</code></p><p><code>https://servername[:port]/</code></p><p>where <code>port</code> is a <a href="./../services/HTTP.html">HTTP User</a> Module port (8100, 9100 by default).</p><p>If the CardDAV client cannot detect the CardDAV URL location, it should be specified explicitly:</p><p><code>http://servername:port/CardDAV/</code></p><p><code>https://servername:port/CardDAV/</code></p><p>Some CardDAV clients need to be configured to access a particular Contacts collection. Any Contacts Mailbox can be accessed using the following URLs:</p><p><code>http://servername:port/CardDAV/mailboxName/</code></p><p><code>https://servername:port/CardDAV/mailboxName/</code></p><p>If the mailboxName ends with the <code>vcf</code> file extension, the Server removes that extension.</p><p>All CardDAV data requests must be authenticated: the user should specify the Account name and password. The Account and its Domain must have the WebSite Service enabled.</p><p>If the user Domain Name or Domain Alias name is mail.company.com, the HTTP User port is 80, and the Mailbox name is <code>Contacts</code>, the access URL is</p><p><code>http://mail.company.com/CardDAV/Contacts</code></p><p><code>https://mail.company.com/CardDAV/Contacts.vcf</code></p><p>Any Contacts-type Mailbox can be accessed this way. To access a Mailbox in a different Account, the full Mailbox name should be specified:</p><p><code>http://mail.company.com/CardDAV/~username/Contacts/</code></p><p>The authenticated user should have proper <a href="./../storage/Mailboxes.html#ACL">access rights</a> to retrieve and/or modify data in Mailboxes belonging to other users.</p><p>The CardDAV module checks the <a href="./../storage/Mailboxes.html#Subscription">Mailbox Subscription</a> list and reports all Contacts-type Mailboxes in other Accounts included into this list.</p><h3 id="CardDAVConf" tabindex="-1">Configuring the CardDAV Module <a class="header-anchor" href="#CardDAVConf" aria-label="Permalink to &quot;Configuring the CardDAV Module {#CardDAVConf}&quot;">​</a></h3><p>The CardDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th><th align="LEFT">Log Level</th></tr><tr><td align="RIGHT">CardDAV:</td><td><select name="CalDAVMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td><td><select name="CalDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><p>Use the CardDAV Log Level setting to specify the type of information the CardDAV module should put in the Server Log.<br> The CardDAV module records in the System Log are marked with the <code>CardDAV</code> tag.</p><p>The Access setting specifies who can access the CalDAV service.</p>',111)]))}const u=t(s,[["render",l]]);export{m as __pageData,u as default};
