import{_ as o,c as t,o as i,ag as n}from"./chunks/framework.jCcxW76o.js";const h=JSON.parse('{"title":"WebUser Interface Module","description":"","frontmatter":{"legacyLink":"WebUser.html"},"headers":[],"relativePath":"admin/access/WebUser.md","filePath":"admin/access/WebUser.md"}'),a={name:"admin/access/WebUser.md"};function s(p,e,r,l,u,c){return i(),t("div",null,e[0]||(e[0]=[n('<h1 id="webuser-interface-module" tabindex="-1">WebUser Interface Module <a class="header-anchor" href="#webuser-interface-module" aria-label="Permalink to &quot;WebUser Interface Module&quot;">​</a></h1><p>The CommuniGate Pro Server provides Web (HTTP/HTML) access to user Accounts. The WebUser component works via the <a href="./../services/HTTP.html">HTTP module</a> and allows users to read and compose messages and to perform Account and Mailbox management tasks using any Web browser.</p><p>Even if a user prefers a regular POP or IMAP mail client, the WebUser Interface can be used to access the features unavailable in some mailers. For example, the WebUser Interface can be used to specify Subscriptions and Access Control Lists for Account Mailboxes - the features many IMAP clients do not support yet. The WebUser Interface can be used to specify Mailbox Aliases, <a href="./../mail/RPOP.html">RPOP</a> (External POP) accounts, Account <a href="./../mail/QueueRules.html">Rules</a>, etc.</p><p>This sections describes the WebUser Interface from the administrator point of view. See the <a href="./WebMail.html">WebMail</a> section for more detailed user-level information.</p><h2 id="Domains" tabindex="-1">WebUser Interface to Multiple Domains <a class="header-anchor" href="#Domains" aria-label="Permalink to &quot;WebUser Interface to Multiple Domains {#Domains}&quot;">​</a></h2><p>When a user points a browser to a WebUser port of the CommuniGate Pro server, the Login page is displayed. The WebUser ports are specified in the <a href="./../services/HTTP.html">HTTP User module</a> settings, the default clear-text WebUser port is 8100, the secure one (not configured by default on some platforms) is 9100.</p><p>When the Login page is displayed, users can enter their name and password, and start a WebUser Session.</p><p>The WebUser module checks for the domain name specified in the URL and presents the Login page for the addressed Domain. If the CommuniGate Pro server <code>provider.com</code> has a secondary Domain <code>client.com</code>, then the <code>&lt;http://provider.com:_port_&gt;</code> URL will display the provider.com Login page in a user browser, and the <code>&lt;http://client.com:_port_&gt;</code> URL will display the client.com Login page, even if the client.com has no <a href="./../objects/Domains.html">dedicated IP address</a>.</p><p>When the WebUser module retrieves the domain name from a URL, it runs it through the <a href="./../sysadmin/Router.html">Router</a> domain-level records. If the Router Table has a record:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>www.client.com = client.com</span></span></code></pre></div><p>the <code>&lt;http://www.client.com:port&gt;</code> URL will be processed as the <code>&lt;http://client.com:port&gt;</code> URL and it will retrieve the client.com Login page, too.</p><p>If the URL specifies a domain name that is not routed to any CommuniGate Pro Domains, an error page is displayed. This usually indicates an error in your Server setup: the specified domain name has a DNS A-record that points to your Server (otherwise the Server would not get this request), but that name is not routed to any of the Server Domains. You should either create a secondary Domain with that name, or route this domain name to one of the existing CommuniGate Pro Domain.</p><p>If a URL specifies an IP address instead of a domain name, the WebUser module tries to find a CommuniGate Pro Domain to which the specified address is dedicated. If no Domain is found, the Main Domain Login page is displayed.</p><p>Users can open any Account in any Domain from any Login page, if they specify the complete Account name: if the Login page of the Main Domain is displayed (<code>&lt;http://provider.com:port&gt;</code>) and the <code>username@client.com</code> name is entered in the username field, the Account <code>username</code> will be opened in the <code>client.com</code> Domain (if the correct password is provided).</p><p>If a Domain has some mailing lists, its Login page contain a link to the <a href="./../mail/LIST.html">Mailing List</a> archive pages.</p><p>If the Domain has the Auto-Signup option enabled, a link to the <a href="#AutoSignup">Auto Sign-up</a> page is displayed on the Domain Login page.</p><p>If the Domain has a custom Security Certificate, a <code>Certificate</code> link is displayed. If a user clicks that link, the Domain Certificate can be installed as a <em>trusted Certificate</em> in the user browser.</p><h2 id="Sessions" tabindex="-1">Account Access and WebUser Sessions <a class="header-anchor" href="#Sessions" aria-label="Permalink to &quot;Account Access and WebUser Sessions {#Sessions}&quot;">​</a></h2><p>Some protocols (such as IMAP and POP) are session-oriented protocols: a client application establishes a connection with a server, provides the data needed to authenticate the user, processes the data (mailboxes, settings, etc.) in the user account, and then closes the connection. The HTTP protocol is not a session-oriented one: a Web browser establishes a connection, sends one or several page requests, receives the requested data, and closes the connection.</p><p>To provide the session-type functionality, the WebUser module implements a so-called <em>application server</em>: when a user is authenticated via the &quot;login page&quot;, a <em>virtual session</em> is created. The virtual session is an internal server data structure keeping the information about the user, open mailboxes, and other session-related data, but it is not linked to any particular network connection. When the user is working with an account using a browser, the WebUser module routes browser requests to one of the already opened virtual sessions.</p><p>In order to route requests properly, the WebUser module creates a unique session identifier (session ID) for each virtual session created and makes user browsers include the session ID into every request they send.</p><p>To avoid &quot;hijacking&quot; of WebUser sessions, the WebUser module remembers the network (IP) address from which the login request was received, and routes to the session only the requests received from the same IP address.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Sometimes, when a user connects via a proxy server, the user requests may come to the Server from different IP addresses (if the proxy server uses several network addresses). In this case, the user should disable the address-controlling option on the WebUser Interface <a href="./WebMail.html#Settings">Settings</a> page. Users of some large providers access the Internet via the provider&#39;s proxy servers, so their accounts should have the address-controlling option disabled.</p><p>Alternatively, enter the provider proxy IP addresses as a range into the <a href="./../signals/NAT.html#NATSites">NAT Server IP Addresses</a> list.</p><p>All network IP addresses that belong to the same range in that list are treated as &quot;same&quot;.</p></div><p>To avoid &quot;hijacking&quot; of WebUser sessions, the WebUser module can use HTTP &quot;cookies&quot;. When the Use Cookies option is enabled, the Server generates some random &quot;cookie&quot; string and sends it to the user browser when a session is initiated. The browser then always sends that string back to the Server when it tries to access any of the session pages. The Server allows the user to access the session data only when the valid &quot;cookie&quot; string is sent.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some browsers do not support &quot;cookies&quot; or can be configured not to support them. The user should check the browser options before enabling the Use Cookies option.</p></div><p>Usually, users start WebUser sessions by entering their Account names and passwords into the WebUser Interface login page fields. This is a &quot;clear text&quot; login method, and it is secure only when the page is accessed via secure (SSL/TLS) connection (via the <code>https://</code> URL).</p><p>Alternatively, users can retrieve the <code>/login/</code> URL on your Server. The Server will require an HTTP-level Authentication, and the browser will either present the Authentication dialog box, or it will send the user&#39;s Certificate if a secure (SSL/TLS) connection is used.</p><h2 id="Auto" tabindex="-1">Automatic Login and Single Sign-on <a class="header-anchor" href="#Auto" aria-label="Permalink to &quot;Automatic Login and Single Sign-on {#Auto}&quot;">​</a></h2><p>When designing a set of Web-based services (&quot;portals&quot;), it may be necessary to create a WebUser session without presenting a login page to the user. The following mechanisms can be used.</p><ul><li><p>Automating the Login page</p><p>direct the user browser to</p><p><code>http://your.server.domain[:port]/?username=accountName&amp;password=password</code></p></li><li><p>HTTP Authentication</p><p>direct the user browser to</p><p><code>http://your.server.domain[:port]/login/</code></p><p>If the browser automatically logs into this realm, it will not present the Login dialog to the user.</p></li><li><p>Certificate Authentication</p><p>direct the user browser to</p><p><code>http://your.server.domain[:port]/login/</code></p><p>If the Domain supports <a href="./../sysadmin/PKI.html#ClientCert">Client Certificates</a>, and the proper certificate is installed on the user&#39;s computer, the browser automatically logs into this realm, without presenting the Login dialog to the user.</p></li><li><p>Creating a Session via CLI</p><p>use the <a href="./../../development/CLI.html">Network CLI/API</a> to create new WebUser session, then direct the user browser to</p><p><code>http://your.server.domain[:port]/Session/sessionID/Hello.wssp</code></p></li><li><p>Automating the Login page with other Session ID</p><p>direct the user browser to</p><p><code>http://your.server.domain[:port]/?username=accountName&amp;password=sessionID&amp;SessionIDMethod=yes</code></p><p>This is the same mechanism as the automated Login page mechanism, but the <a href="./../sysadmin/Security.html#SessionIDSASL">SessionID Authentication</a> method is used instead of the clear-text Authentication method. The <em>sessionID</em> is a the ID of any existing WebUser or <a href="./XIMSS.html">XIMSS</a> session with the same <em>accountName</em> Account.</p></li></ul><h2 id="Settings" tabindex="-1">WebUser Interface Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;WebUser Interface Settings {#Settings}&quot;">​</a></h2><p>To configure the WebUser Interface module, use any Web browser to connect to the CommuniGate Pro WebAdmin Interface, open the Access pages in the Settings realm, and then open the Sessions page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>User Sessions</b></td></tr><tr><td align="right">Log Level:</td><td><select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Limit:</td><td><select name="MaxSessions"><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000" selected="selected">3000</option><option value="10000">10000</option><option value="30000">30000</option><option value="100000">100000</option><option value="300000">300000</option><option value="1000000">1000000</option><option>other</option></select></td></tr><tr><td align="right">Inactivity Time-Out:</td><td><select name="Timeout"><option value="60">minute</option><option value="120">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800" selected="selected">30 minutes</option><option value="3600">hour</option><option value="7200">2 hours</option></select></td><td align="right">Session Time Limit:</td><td><select name="SessionTimeLimit"><option value="60">60 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="240">4 min</option><option value="300">5 min</option><option value="420">7 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600" selected="selected">6 hour(s)</option><option value="25200">7 hour(s)</option><option value="28800">8 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="50400">14 hour(s)</option><option value="57600">16 hour(s)</option><option value="64800">18 hour(s)</option><option value="86400">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="432000">5 day(s)</option><option value="604800">7 day(s)</option><option value="864000">10 day(s)</option><option value="1728000">20 day(s)</option><option value="2592000">30 day(s)</option><option value="8640000">100 day(s)</option><option value="21601">other</option></select></td></tr><tr><td align="right">Max Recipients:</td><td><select name="MaxRecipients"><option value="-1">Unlimited</option><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="20">20</option><option value="30">30</option><option value="50" selected="selected">50</option><option value="100">100</option><option value="200">200</option><option value="300">300</option><option value="500">500</option><option value="1000">1000</option><option>other</option></select></td></tr></tbody></table></div><p> </p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2">Safe Link Schemas</td></tr><tr><td><table width="100%"><tbody><tr><td><input type="text" name="SafeSchemas" value="note:" size="10" maxlength="20"> <input type="text" name="SafeSchemas" value="" size="10" maxlength="20"></td></tr></tbody></table></td></tr></tbody></table></div></form><ul><li><p><code>Limit</code></p><p>Use this setting to specify the maximum number of concurrent WebUser Interface sessions.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Remember that browser (HTTP) connections are not the same as WebUser sessions. It is usually enough to support 100 concurrent <a href="./../services/HTTP.html">HTTP channels</a> to serve 5000 Sessions.</p></div></li><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the WebUser Interface module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) level.<br> The WebUser Interface module records in the System Log are marked with the <code>WEB</code> tag.</p></li><li><p><code>Inactivity Time-Out</code></p><p>Use this setting to specify the maximum time interval between client (browser) connections for a particular WebUser Session. This setting allows to disconnect the users who did not log out correctly, but simply closed their browsers or moved to a different Web site. Do not set this setting to a too small value, otherwise users can get disconnected while they are composing letters.</p></li><li><p><code>Session Time Limit</code></p><p>Use this setting to specify the maximum &quot;login&quot; time for a WebUser session. The limit is checked when a browser connects and retrieves a page from the session, so it is useless to set this setting to a value that is smaller than the Inactivity Time-Out setting value.</p></li><li><p><code>Max Recipients</code></p><p>Use this setting to specify the maximum number of E-mail addresses in messages composed using the WebUser Interface.</p></li><li><p><code>Safe Link Schemas</code></p><p>For WebUser and XIMSS Sessions security reasons the server blocks processing of references with unknown types. Use the empty field in this setting to add an URI schema (link prefixes) that is known to be safe for execution in HTML-formatted messages.</p></li></ul><p>Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><th> </th><th align="LEFT">Access</th></tr><tr><td align="RIGHT">WebUser:</td><td><select name="HTTPXIMSSMode"><option value="nobody">nobody</option><option value="clients" selected="selected">clients</option><option value="everybody">everybody</option></select></td></tr></tbody></table></div></form><p>The Access setting specifies who can create WebUser sessions.</p><h2 id="SpellCheckers" tabindex="-1">Configuring Spell Checkers <a class="header-anchor" href="#SpellCheckers" aria-label="Permalink to &quot;Configuring Spell Checkers {#SpellCheckers}&quot;">​</a></h2><p>The Server Administrator can specify one or several external spell checker programs. To configure spell checkers, follow the <a href="#SpellCheckers">Spelling</a> link on the General Settings page.</p><p>The Spelling page appears :</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr align="left"><th>Enabled</th><th>Language</th><th>Log Level</th><th>Program Name and Parameters</th><th> </th></tr><tr><td><input name="SpellCheckers" value="0" type="hidden"><input name="X0" value="1" checked="checked" type="checkbox"></td><td><input name="E0" value="English-GB" size="20" maxlength="255" type="text"></td><td><select name="L0"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td><input name="Z0" value="/usr/local/bin/aspell -a --lang=en_GB" size="40" maxlength="1024" type="text"></td><td rowspan="2"></td></tr><tr><td colspan="2"></td><td align="right">Convert to:</td><td><select name="C0"><option value="0">us-ascii</option><option value="1" selected="selected">Western European (ISO)</option><option value="2">Western European (Windows)</option><option value="3">Japanese (ISO)</option><option value="4">Cyrillic (KOI)</option><option value="5">Cyrillic (ISO)</option><option value="6">Cyrillic (Windows)</option><option value="7">Cyrillic (Alt-DOS)</option><option value="8">Ukrainian (KOI)</option><option value="9">Central European (ISO)</option><option value="10">Central European (Windows)</option><option value="11">Greek (ISO)</option><option value="12">Greek (Windows)</option><option value="13">Hebrew (ISO)</option><option value="14">Hebrew (Windows)</option><option value="15">Turkish (ISO)</option><option value="16">Turkish (Windows)</option><option value="17">Baltic (ISO)</option><option value="18">Baltic (Windows)</option><option value="19">Chinese (Big5)</option><option value="20">Chinese (Simplified)</option><option value="21">Chinese (GBK)</option><option value="22">Chinese (EUC)</option><option value="23">Korean (ISO)</option><option value="24">Korean (EUC)</option><option value="25">Korean (Windows)</option><option value="26">Arabic (ISO)</option><option value="27">Arabic (Windows)</option><option value="28">Thai (ISO)</option><option value="29">Thai (Windows)</option><option value="30">Southern European (ISO)</option><option value="31">Nordic (ISO)</option><option value="32">New European (ISO)</option><option value="33">Vietnamese (Windows)</option><option value="34">Unicode (UTF8)</option></select></td></tr><tr><td><input type="checkbox" name="X1" value="1" checked="checked"></td><td><input type="text" name="E1" value="English-US" size="20" maxlength="255"></td><td><select name="L1"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td><input type="text" name="Z1" value="/usr/local/bin/aspell -a --lang=en_US" size="40" maxlength="1024"></td><td rowspan="2"></td></tr><tr><td colspan="2"></td><td align="right">Convert to:</td><td><select name="C1"><option value="0">us-ascii</option><option value="1" selected="selected">Western European (ISO)</option><option value="2">Western European (Windows)</option><option value="3">Japanese (ISO)</option><option value="4">Cyrillic (KOI)</option><option value="5">Cyrillic (ISO)</option><option value="6">Cyrillic (Windows)</option><option value="7">Cyrillic (Alt-DOS)</option><option value="8">Ukrainian (KOI)</option><option value="9">Central European (ISO)</option><option value="10">Central European (Windows)</option><option value="11">Greek (ISO)</option><option value="12">Greek (Windows)</option><option value="13">Hebrew (ISO)</option><option value="14">Hebrew (Windows)</option><option value="15">Turkish (ISO)</option><option value="16">Turkish (Windows)</option><option value="17">Baltic (ISO)</option><option value="18">Baltic (Windows)</option><option value="19">Chinese (Big5)</option><option value="20">Chinese (Simplified)</option><option value="21">Chinese (GBK)</option><option value="22">Chinese (EUC)</option><option value="23">Korean (ISO)</option><option value="24">Korean (EUC)</option><option value="25">Korean (Windows)</option><option value="26">Arabic (ISO)</option><option value="27">Arabic (Windows)</option><option value="28">Thai (ISO)</option><option value="29">Thai (Windows)</option><option value="30">Southern European (ISO)</option><option value="31">Nordic (ISO)</option><option value="32">New European (ISO)</option><option value="33">Vietnamese (Windows)</option><option value="34">Unicode (UTF8)</option></select></td></tr><tr><td><input type="checkbox" name="X2" value="1" checked="checked"></td><td><input type="text" name="E2" value="Russian" size="20" maxlength="255"></td><td><select name="L2"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td><input type="text" name="Z2" value="/usr/local/bin/aspell -a --lang=ru" size="40" maxlength="1024"></td><td rowspan="2"></td></tr><tr><td colspan="2"></td><td align="right">Convert to:</td><td><select name="C2"><option value="0">us-ascii</option><option value="1">Western European (ISO)</option><option value="2">Western European (Windows)</option><option value="3">Japanese (ISO)</option><option value="4" selected="selected">Cyrillic (KOI)</option><option value="5">Cyrillic (ISO)</option><option value="6">Cyrillic (Windows)</option><option value="7">Cyrillic (Alt-DOS)</option><option value="8">Ukrainian (KOI)</option><option value="9">Central European (ISO)</option><option value="10">Central European (Windows)</option><option value="11">Greek (ISO)</option><option value="12">Greek (Windows)</option><option value="13">Hebrew (ISO)</option><option value="14">Hebrew (Windows)</option><option value="15">Turkish (ISO)</option><option value="16">Turkish (Windows)</option><option value="17">Baltic (ISO)</option><option value="18">Baltic (Windows)</option><option value="19">Chinese (Big5)</option><option value="20">Chinese (Simplified)</option><option value="21">Chinese (GBK)</option><option value="22">Chinese (EUC)</option><option value="23">Korean (ISO)</option><option value="24">Korean (EUC)</option><option value="25">Korean (Windows)</option><option value="26">Arabic (ISO)</option><option value="27">Arabic (Windows)</option><option value="28">Thai (ISO)</option><option value="29">Thai (Windows)</option><option value="30">Southern European (ISO)</option><option value="31">Nordic (ISO)</option><option value="32">New European (ISO)</option><option value="33">Vietnamese (Windows)</option><option value="34">Unicode (UTF8)</option></select></td></tr><tr><td><input type="hidden" name="SpellCheckers" value="3"><input type="checkbox" name="X3" value="1"></td><td><input type="text" name="E3" value="" size="20" maxlength="255"></td><td><select name="L3"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td><input type="text" name="Z3" value="" size="40" maxlength="1024"></td><td rowspan="2"></td></tr><tr><td colspan="2"></td><td align="right">Convert to:</td><td><select name="C3"><option value="0">us-ascii</option><option value="1" selected="selected">Western European (ISO)</option><option value="2">Western European (Windows)</option><option value="3">Japanese (ISO)</option><option value="4">Cyrillic (KOI)</option><option value="5">Cyrillic (ISO)</option><option value="6">Cyrillic (Windows)</option><option value="7">Cyrillic (Alt-DOS)</option><option value="8">Ukrainian (KOI)</option><option value="9">Central European (ISO)</option><option value="10">Central European (Windows)</option><option value="11">Greek (ISO)</option><option value="12">Greek (Windows)</option><option value="13">Hebrew (ISO)</option><option value="14">Hebrew (Windows)</option><option value="15">Turkish (ISO)</option><option value="16">Turkish (Windows)</option><option value="17">Baltic (ISO)</option><option value="18">Baltic (Windows)</option><option value="19">Chinese (Big5)</option><option value="20">Chinese (Simplified)</option><option value="21">Chinese (GBK)</option><option value="22">Chinese (EUC)</option><option value="23">Korean (ISO)</option><option value="24">Korean (EUC)</option><option value="25">Korean (Windows)</option><option value="26">Arabic (ISO)</option><option value="27">Arabic (Windows)</option><option value="28">Thai (ISO)</option><option value="29">Thai (Windows)</option><option value="30">Southern European (ISO)</option><option value="31">Nordic (ISO)</option><option value="32">New European (ISO)</option><option value="33">Vietnamese (Windows)</option><option value="34">Unicode (UTF8)</option></select></td></tr></tbody></table></div></form><p>To configure a spell checker, specify the language the program can process, and path to the program file, and the character set the program can handle. The internal data presentation use the UTF-8 character set, so set the <code>UTF-8</code> value if no conversion is needed.</p><p>Use the Log Level setting to specify the type of information the spell checker module should put in the Server Log.</p><p>The spell checker module records in the System Log are marked with the <code>SPELLER</code> tag.</p><p>Use the Enable check box to enable and disable the spell checker program without removing it from the program list.</p><p>To remove a spell checker program, enter an empty string into its Language field and click the Update button.</p><p>The spell checker program should provide the same &quot;pipe&quot; interface as the popular <code>Ispell</code> and <code>aspell</code> programs:</p><ul><li><p>Text is sent to the program line-by-line with the first symbol of the line being a space symbol;</p></li><li><p>For each input line, the program returns zero, one, or several non-empty response lines followed by an empty line.</p></li><li><p>Only the response lines that start with the ampersand (<code>&amp;</code>) or hash (<code>#</code>) symbols are processed.</p></li><li><p>The hash-line has the following format:</p><p><code># original offset</code></p><p>where <em>original</em> is a misspelled word, and <em>offset</em> is the position of that word in the input text line.</p></li><li><p>The ampersand-line has the following format:</p><p><code>&amp; original count offset:suggestion1, suggestion2, ...</code></p><p>where <em>original</em> is a misspelled word, and <em>offset</em> is the position of that word in the input text line, <em>count</em> is the number of <em>suggestions</em>.</p></li></ul><h2 id="Lists" tabindex="-1">WebUser Interface to Mailing Lists <a class="header-anchor" href="#Lists" aria-label="Permalink to &quot;WebUser Interface to Mailing Lists {#Lists}&quot;">​</a></h2><p>The WebUser module presents a link to the Mailing Lists page on the Domain Login Page.</p><p>The Mailing Lists page displays all <a href="./../mail/LIST.html">mailing lists</a> created in the Domain that have the <code>allow anybody to browse</code> option enabled. Each name is a link that can be used to open a page listing messages in the Mailing List archive. Since Mailing Lists messages are archived in Mailboxes, the Mailing List WebUser interface is similar to the <a href="#Mailbox">Mailbox Browsing</a> interface.</p><p>The Mailing List WebUser Interface does not require any authentication, so no virtual session is created for list users, and each browser request is processed independently.</p><h2 id="AutoSignup" tabindex="-1">Auto Sign-up <a class="header-anchor" href="#AutoSignup" aria-label="Permalink to &quot;Auto Sign-up {#AutoSignup}&quot;">​</a></h2><p>If a domain has the <a href="./../objects/Domains.html">Auto-Signup</a> option enabled, the WebUser Interface Login page contains a link to the Auto-Signup page. This page allows a new user to enter a user name, a password, the &quot;real-life&quot; name, and to create a new Account.</p><p>When a new account is created, its options and settings are taken from the domain Account Template.</p>',55)]))}const m=o(a,[["render",s]]);export{h as __pageData,m as default};
