import{_ as t,c as s,o,ag as a}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Account Access","description":"","frontmatter":{"legacyLink":"Access.html"},"headers":[],"relativePath":"admin/access/index.md","filePath":"admin/access/index.md"}'),i={name:"admin/access/index.md"};function n(c,e,r,l,d,h){return o(),s("div",null,e[0]||(e[0]=[a('<h1 id="account-access" tabindex="-1">Account Access <a class="header-anchor" href="#account-access" aria-label="Permalink to &quot;Account Access&quot;">​</a></h1><p>The CommuniGate Pro Server allows users to use various client applications to access data in their Accounts: Mailboxes, Calendars, Contacts, Files, etc.</p><ul><li>The <a href="./POP.html">POP module</a> is a POP3 server; it allows users to retrieve E-mail messages from their INBOX Mailboxes (and, optionally, other mailboxes) using POP3-based mailers.</li><li>The <a href="./IMAP.html">IMAP module</a> is an IMAP4rev1 server; it allows users to process E-mail messages in all Account Mailboxes using IMAP-based mailers.</li><li>The <a href="./WebUser.html">WebMail module</a> is an HTTP (Web) application server; it that allows users to process E-mail messages in all Account Mailboxes and employ other CommuniGate Pro Server features using any Web browser.</li><li>The <a href="./XIMSS.html">XIMSS module</a> is an <a href="./../../development/XMLAPI.html">XML Messaging, Scheduling, and Signaling</a> server; it allows users to make and control calls, to process E-mail messages and groupware items in all Account Mailboxes and employ other CommuniGate Pro Server features using &quot;rich&quot; Web-based clients (such as Flash®-based clients).</li><li>The <a href="./MAPI.html">MAPI module</a> is an extension of the IMAP module; it allows users to access their Accounts and Mailboxes via the Microsoft® Windows MAPI (Mail API) and to use the Microsoft Outlook client in its full-featured &quot;groupware&quot; mode.</li><li>The <a href="./AirSync.html">AirSync module</a> is an extension of the HTTP module; it allows users to access their Accounts and Mailboxes via the Microsoft® ActiveSync/AirSync protocol and to use the Windows Mobile clients to receive and send E-mail messages, and to synchronize Contacts, Calendar, and Tasks information with the Server Account data.</li><li>The <a href="./WebDAV.html#CalDAV">CalDAV module</a> is an extension of the HTTP module; it allows users to access their Calendar-type and Task-type Mailboxes via the CalDAV protocol.</li><li>The <a href="./WebDAV.html#CardDAV">CardDAV module</a> is an extension of the HTTP module; it allows users to access their Contact-type Mailboxes via the CardDAV protocol.</li><li>The <a href="./../services/HTTP.html">HTTP module</a> is an HTTP server; it serves as a transport layer for other modules (such as the <a href="./AirSync.html">AirSync</a>, and <a href="./WebDAV.html">WebDAV</a> modules, the <a href="./XIMSS.html">XIMSS module</a> in the HTTP Binding mode, etc.), and it provides access to Account <a href="./../storage/FileStore.html">File Storage</a>, Mailboxes, and the Account Groupware information.</li><li>The <a href="./FTP.html">FTP module</a> is an FTP server; it provides access to Account <a href="./../storage/FileStore.html">File Storage</a>.</li><li>The <a href="./TFTP.html">TFTP module</a> is a TFTP server; it provides access to Account <a href="./../storage/FileStore.html">File Storage</a>.</li></ul><h2 id="Access" tabindex="-1">Access to Accounts <a class="header-anchor" href="#Access" aria-label="Permalink to &quot;Access to Accounts {#Access}&quot;">​</a></h2><p>Every CommuniGate Pro Account can be accessed via the Access modules - POP, IMAP, XIMSS, WebUser Interface, FTP, XMPP, etc. Several client applications can use the same CommuniGate Pro Account at the same time, via the same, or different access modules.</p><p>Any <a href="./../storage/Mailboxes.html">Mailbox</a> in any CommuniGate Pro Account can be shared: it can be accessed not only by the Account owner, but also by other users - if the Account owner or an Administrator grants those users access rights for that Mailbox.</p><h2 id="MultiDomain" tabindex="-1">Serving Multiple Domains <a class="header-anchor" href="#MultiDomain" aria-label="Permalink to &quot;Serving Multiple Domains {#MultiDomain}&quot;">​</a></h2><p>The main problem of serving multiple domains on one server is to provide access to accounts in different domains. To look for the specified Account, the server should get the name of the Domain to look in.<br> Access to Accounts is similar to E-mail delivery and Signal processing: the server needs to know the &quot;full Account name&quot; - an address in the <em>accountName</em>@<em>domainName</em> form.</p><p>There are several methods to pass the domain name to the server:</p><ul><li><p>A client application explicitly specifies the domain name.</p><ul><li>If a user accesses the Server via the HTTP (Web interface), this happens automatically: the user first specifies the server URL (<code>http://domainname:port</code>), and then enters the Account name in the Login form.<br> Since all modern browsers pass the original URL to the server, the domain name becomes known, and the HTTP module immediately appends that domain name to a simple user name specified in the Login form.</li><li>If a user accesses the Server using an XMPP, this happens automatically: the user first specifies the server name in the client application settings, and the client application sends that data as the &#39;to&#39; attribute in the XML streams.</li><li>If users access the Server with POP or IMAP mailers, they can specify the full account name in the mailer &quot;account name&quot; settings.<br> Since many mailers do not accept the <code>@</code> symbol in account names, the <code>%</code> symbol can be used instead.<br> The user <code>john</code> with an Account in the secondary Domain client1.com should specify the Account name as <code>john%client1.com</code>, not just as <code>john</code>.</li><li>If users access the Server with XIMSS client applications, these applications always specify the full Account name for the authentication operations.</li></ul></li><li><p>The domain name can be detected using multihoming. If it is impossible to force users to access the server via the Web interface or to make them enter full account names in their POP/IMAP mailers, multihoming can be used.<br> A server is using multihoming if the server computer has more than one Internet (IP) address. Using the Domain Name System (DNS) the secondary domains can be assigned different IP addresses.<br> If a secondary Domain has an IP address assigned to it, and a user connects to that IP address, all simple account names specified with the user mailer are processed as names in that Domain.<br> It may be difficult to assign an IP address to each Domain, so this method should be used only if it is impossible to make users specify domain names explicitly.</p></li></ul><p>These methods can be used together: a limited number of Domains can be served using dedicated additional IP addresses, while other Domains are served using explicit domain name specifications.</p><h2 id="MultiHome" tabindex="-1">Multihoming <a class="header-anchor" href="#MultiHome" aria-label="Permalink to &quot;Multihoming {#MultiHome}&quot;">​</a></h2><p>Every access session begins with the authentication procedure: a client application sends a user (Account) name and a password to the Server.</p><p>The CommuniGate Pro Server tries to detect which Domain it should use to look for the specified Account name.</p><ul><li><p>If the specified name contains the <code>@</code> symbol or the <code>%</code> symbol, the Server assumes that the user has specified a &quot;full account name&quot;, i.e. an Account (or other Object) name with its Domain name: <code>username@domainname</code> or <code>username%domainname</code> (see above).</p></li><li><p>If the specified name does not contain the <code>@</code> symbol or the <code>%</code> symbol, the Server looks at the IP address on which it has received this connection.<br> Systems with multihoming (i.e. systems that have several local IP addresses) may have certain IP addresses assigned to some <a href="./../objects/Domains.html#IP">Domains</a>. If a connection IP address is assigned to a some Domain, that domain name is appended to the account name to get the full account name. If the address is dedicated to the Main Domain, the specified name is processed as the Main Domain name.<br> By default, all Server IP Addresses are assigned to the Main Domain.</p></li><li><p>Sample:</p><p>The server computer has 2 IP addresses: <code>192.0.0.1</code> and <code>192.0.0.2</code>.<br> The Server Main Domain is <code>company.com</code>, and the secondary Domains are <code>client1.com</code> and <code>client2.com</code>.<br> The DNS A-records for company.com is pointing to the IP address 192.0.0.1,<br> the A-record for the client1.com points to a dedicated IP address 192.0.0.2, while the A-records for the client2.com domain point to the same &quot;main&quot; IP address 192.0.0.1.<br> Each domain has an account <code>info</code>.</p><p>Three users configure their clients to access an account <code>info</code>, but they specify different names in their &quot;server&quot; settings: the first user specifies company.com, the second - client1.com, and the third user specifies client2.com.</p><p>When the first user starts her mailer:</p><ul><li>The client application takes the specified &quot;server&quot; setting <code>company.com</code>, and it uses the Domain Name System A-records to resolve (convert) that name to the IP address 192.0.0.1.</li><li>The client establishes a connection with that address (which is one of 2 addresses of the Server computer), and it passes the user name <code>info</code>.</li><li>The Server detects a simple user name <code>info</code> and detects that this connection is established via the Server address 192.0.0.1.</li><li>The Server detects that this IP address is assigned to the Main Domain, so it adds the Main Domain name company.com to the specified simple name.</li><li>The Server gets the correct full account name <code>info@company.com</code>.</li></ul><p>When the second user starts her client application:</p><ul><li>The client takes the specified &quot;server&quot; setting <code>client1.com</code>, and it uses the Domain Name System A-records to resolve (convert) that name to the IP address 192.0.0.2.</li><li>The client establishes a connection with that address (which is one of 2 addresses of the server computer), and it passes the user name <code>info</code>.</li><li>The Server detects a simple user name <code>info</code> and detects that this connection is established via the server address 192.0.0.2.</li><li>The Server detects that this IP Address is assigned to the client1.com secondary Domain, so it adds that Domain name to the specified simple name.</li><li>The Server gets the correct full account name <code>info@client1.com</code>.</li></ul><p>When the third user starts her client application:</p><ul><li>The client takes the specified &quot;server&quot; setting <code>client2.com</code>, and it uses the Domain Name System A-records to resolve (convert) that name to the IP address 192.0.0.1.</li><li>The client establishes a connection with that address (which is one of 2 addresses of the Server computer), and it passes the user name <code>info</code>.</li><li>The server detects a simple user name <code>info</code> and detects that this connection is established via the Server address 192.0.0.1.</li><li>The Server detects that this IP address is assigned to the Main Domain, so it adds the Main Domain name company.com to the specified simple name.</li><li>The server gets the <strong>incorrect</strong> full account name <code>info@company.com</code>.</li></ul><p>This happens because the client application (usually - an old POP or IMAP mailer, and FTP client, etc.) has not passed the information about the &quot;server&quot; name from its settings, and the only information the Server had was the IP address.</p><p>In order to solve this problem, the third user should specify the account name as <code>info%client2.com</code>, not just <code>info</code>. In this case, when this user starts the client application:</p><ul><li>The client takes the specified &quot;server&quot; setting <code>client2.com</code>, and it uses the Domain Name System A-records to resolve (convert) that name to the IP address 192.0.0.1.</li><li>The client establishes a connection with that address (which is one of 2 addresses of the server computer), and it passes the user name <code>info%client2.com</code>.</li><li>The Server detects a full user name <code>info%client2.com</code> and it does not look at the IP addresses. It just converts the <code>%</code> symbol into the <code>@</code> symbol.</li><li>The Server gets the correct full account name <code>info@client2.com</code>.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Most FTP clients work in the same way as the POP/IMAP mailers do, so FTP users are required to supply qualified Account names unless they connect to an IP Address assigned to their Domain.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The MAPI Connector always sends a qualified Account Name: if users specify names without the <code>@</code> or <code>%</code> symbols, the Connector adds the &#39;@&#39; symbol and <code>Server Name</code> setting value to the specified account name.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The XMPP clients send the &#39;target domain&#39; name along with the login name. If the specified login name does not contain the <code>@</code> or <code>%</code> symbols, the Server adds the &#39;@&#39; symbol and &quot;target domain&quot; name to the login name.</p></div></li></ul><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>When the full account name is composed, this name (address) is passed to the <a href="./../sysadmin/Router.html">Router</a>.</p><ul><li>If the Router reports an error, the client is not authenticated and an error message is returned to the client application. An error is usually the <code>Unknown user</code> error, but it can be any error that Router or modules can generate when routing an address.</li><li>If the Router has successfully routed the address, but the address is not routed to the <a href="./../mail/Local.html">Local Delivery</a> module, the client is not authenticated and an error message is returned to the client application. This happens if a user has specified a mailing list name, not an account name, or if the specified name is rerouted to some other host (via SMTP, for example).</li><li>If the Router routed the address to some Account in some local Domain, that Account is opened, and the Account passwords are checked.</li></ul><p>This means that all routing applied to E-mail and Signal addresses is also applied to the account names specified with mailer applications.</p><ul><li><p>Sample:</p><p>The Account <code>john</code> has a <code>john_smith</code> alias;<br> all E-mail messages and Signals addressed to john_smith will be delivered to the Account john;<br> the user can specify either john or john_smith as the &quot;account name&quot; setting in his client applications - in both cases the Account <code>john</code> will be opened when those applications connect to the Server.</p></li><li><p>Sample:</p><p>The Account <code>john</code> has been moved from the main domain company.com to the domain client1.com, and it was renamed in j.smith. The administrator has created a Router record:<br><code>&lt;John&gt; = j.smith@client1.com</code>;<br> all E-mails and Signals addressed to <a href="mailto:john@company.com" target="_blank" rel="noreferrer">john@company.com</a> will be sent to the Account j.smith in the client1.com Domain;<br> the user can still specify just <code>john</code> as the &quot;account name&quot; setting, and the same company.com &quot;server&quot; setting in his client application - but the Server will open the Account j.smith in the client1.com Domain.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Do not create any Router record that redirects the Postmaster Account in the Main Domain. You will not be able to administer the Server, unless the postmaster account is redirected to an Account that has the <a href="./../sysadmin/#Privs">Master</a> access right.</p><p>If you want the Postmaster E-mails and Signals to be directed to some other user, do not use the Router, but use the postmaster Account <a href="./../mail/QueueRules.html">Rules</a> instead.</p></div>',21)]))}const p=t(i,[["render",n]]);export{u as __pageData,p as default};
