import{_ as t,a as s}from"./chunks/ClusterWebUser.CixteROZ.js";import{_ as r,c as a,o as n,ag as c}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Account Access in Clusters","description":"","frontmatter":{"legacyLink":"ClusterAccess.html"},"headers":[],"relativePath":"admin/cluster/Access.md","filePath":"admin/cluster/Access.md"}'),o={name:"admin/cluster/Access.md"};function i(h,e,l,u,d,p){return n(),a("div",null,e[0]||(e[0]=[c('<h1 id="account-access-in-clusters" tabindex="-1">Account Access in Clusters <a class="header-anchor" href="#account-access-in-clusters" aria-label="Permalink to &quot;Account Access in Clusters&quot;">​</a></h1><p>This section explains how <a href="./Access.html">Account Access</a> operations work in the CommuniGate Pro Cluster environment.</p><p>The CommuniGate Pro Cluster architecture allows a load balancer to direct any connection to any working Server, eliminating a need for complex and unreliable &quot;high-level&quot; load balancer solutions. Inexpensive Layer 4 Switches can be used to handle the traffic.</p><h2 id="TCP" tabindex="-1">POP, IMAP, MAPI, ACAP, XMPP Interfaces <a class="header-anchor" href="#TCP" aria-label="Permalink to &quot;POP, IMAP, MAPI, ACAP, XMPP Interfaces {#TCP}&quot;">​</a></h2><p><a href="./../access/POP.html">POP</a>, <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/MAPI.html">MAPI</a>, <a href="./../signals/XMPP.html">XMPP</a> sessions are created on the Backend server that succeeds to open the target Account.</p><p>These protocols work over the TCP network protocol. When a TCP connection is established to the Server that cannot open the target Account (to a Frontend Server, or to a &quot;wrong&quot; Backend server), the Server builds a protocol proxy and connects the client application with the proper Server.</p><p>If the connection is encrypted (using SSL/TLS), request decryption and response encryption take place on the frontend server:</p><p><img src="'+t+'" alt="Cluster TCP Access"></p><h2 id="File" tabindex="-1">File Access (FTP, TFTP, HTTP) Interfaces <a class="header-anchor" href="#File" aria-label="Permalink to &quot;File Access (FTP, TFTP, HTTP) Interfaces {#File}&quot;">​</a></h2><p>When an FTP connection is established, or when a TFTP or HTTP request is received, the protocol session is created on the same Server.</p><p>Inter-cluster CLI is used to authenticate the user and/or to access the Account data if the user Account cannot be opened on the same Server.</p><h2 id="Services" tabindex="-1">Service (RADIUS, LDAP, PWD) Interfaces <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Service (RADIUS, LDAP, PWD) Interfaces {#Services}&quot;">​</a></h2><p>When a Service request is received, it is processed on the same Server.</p><p>Inter-cluster CLI is used to authenticate the user and/or to access the Account data if the user Account cannot be opened on the same Server.</p><h2 id="WebUser" tabindex="-1">WebUser Interface <a class="header-anchor" href="#WebUser" aria-label="Permalink to &quot;WebUser Interface {#WebUser}&quot;">​</a></h2><p><a href="./../access/WebUser.html">WebUser Interface</a> Sessions are created on the Backend server that succeeds to open the target Account.</p><p>User browsers send HTTP requests to the Frontend Servers via Load Balancer(s). If the session request hits the &quot;wrong&quot; Server (i.e. the server that does not host the target session), the request is proxied to the correct Server.</p><p>If the HTTP connection is encrypted (using SSL/TLS), request decryption and response encryption take place on the frontend server:</p><p><img src="'+s+'" alt="Cluster WebUser Sessions"></p>',19)]))}const f=r(o,[["render",i]]);export{m as __pageData,f as default};
