import{_ as t,a,b as r}from"./chunks/ClusterDynamic4.BwFDH4rM.js";import{_ as n,c as o,o as i,ag as s}from"./chunks/framework.jCcxW76o.js";const y=JSON.parse('{"title":"Dynamic Clusters","description":"","frontmatter":{"legacyLink":"ClusterDynamic.html"},"headers":[],"relativePath":"admin/cluster/Dynamic.md","filePath":"admin/cluster/Dynamic.md"}'),l={name:"admin/cluster/Dynamic.md"};function d(c,e,h,u,m,p){return i(),o("div",null,e[0]||(e[0]=[s('<h1 id="dynamic-clusters" tabindex="-1">Dynamic Clusters <a class="header-anchor" href="#dynamic-clusters" aria-label="Permalink to &quot;Dynamic Clusters&quot;">​</a></h1><p>While <a href="./Static.html">Static Clusters</a> can be used to handle very large sites, they do not meet the <em>carrier-grade</em> uptime requirements.</p><p>Managing a set of loosely-coupled Server also becomes a problem as the number of Server grows.</p><p>The CommuniGate Pro Dynamic Clusters address these challenges. They exceed the &quot;five-nine&quot; (99.999%) uptime requirements, and their Single Service Image infrastructure allows System and Domain administrators manage a large Cluster System in the same way a smaller single-server CommuniGate Pro system is managed.</p><p>The main difference between Static and Dynamic Clusters is the Account hosting. While each Account in a Static Cluster has its Host Server, and only that Server can access the Account data directly, all Backend Servers in a Dynamic Cluster can access the Account data directly.</p><p>The most common method to implement a Dynamic Cluster shared Account Storage is to employ File Servers or Cluster File Systems. See the <a href="./Storage.html">Storage</a> section for more information about Shared File Systems.</p><h2 id="FileLock" tabindex="-1">Traditional File-Locking Approach <a class="header-anchor" href="#FileLock" aria-label="Permalink to &quot;Traditional File-Locking Approach {#FileLock}&quot;">​</a></h2><p>Many legacy Communication servers can employ file servers for account data storage. Since those servers are usually implemented as multi-process systems (under Unix), they use the same synchronization methods in both single-server and multi-server environments, such as <em>file locks</em> implemented on the Operating System/File System level.</p><p>This method has the following problems:</p><ul><li>Every operation with Account/Mailbox data should be surrounded with file locking/unlocking operations, and additional File System operations are needed to ensure data consistency. As a result, the number of File System operations increases in 3-5 times, and (since the speed of file operation usually defines the speed of the site) the site performance suffers a lot.</li><li>Modern File Servers either do not support file locking mechanisms at all, or provide severely limited versions of those mechanisms, making the most important site component - account storage - unreliable and not fault-tolerant.</li><li>Malfunction of one of the servers can bring the entire site down (because of deadlocks), and makes fault recovery extremely painful.</li><li>Simultaneous access to the same Account/Mailbox by several clients is either prohibited or unreliable.</li></ul><p>In the attempt to decrease the negative effect of file-locking, some legacy Messaging servers support the MailDir Mailbox format only (one file per message), and they rely on the &quot;atomic&quot; nature of file directory operations (rather than on file-level locks). This approach theoretically can solve some of the outlined problems (in real-life implementations it hardly solves any), but it results in wasting most of the file server storage, and overloads the file server internal filesystem tables.<br> The performance of File Servers severely declines when an application uses many smaller files instead of few larger files.</p><p>While simple clustering based on Operating System/File System multi-access capabilities works fine for Web servers (where the data is not modified too often), it does not work well for Messaging servers where the data modification traffic is almost the same as the data retrieval traffic.</p><p>Simple Clustering does not provide any additional value (like Single Service Image), so administering a 30-Server cluster is even more difficult than administering 30 independent Servers.</p><p>The CommuniGate Pro software supports the <a href="./../storage/Mailboxes.html#Legacy">Legacy INBOX</a> feature, so a file-based clustering can be implemented with the CommuniGate Pro, too. But because of the problems outlined above, it is highly recommended to avoid this type of solutions and use the real CommuniGate Pro Dynamic Cluster instead.</p><h2 id="Controller" tabindex="-1">Cluster Controller <a class="header-anchor" href="#Controller" aria-label="Permalink to &quot;Cluster Controller {#Controller}&quot;">​</a></h2><p>CommuniGate Pro Servers in a Dynamic Cluster do not use Operating System/File System locks to synchronize Account access operations. Like in a Static Cluster, only one Server in a Dynamic Cluster has direct access to any given Account at any given moment. All other Servers work through that Server if they want to access the same Account. But this assignment is not static: any Server can open any Account directly if that Account is not opened with some other Server.</p><p>This architecture provides the maximum uptime: if a Backend Server fails, all Accounts can be accessed via other Backend Servers - without any manual operator intervention, and without any downtime. The site continues to operate and provide access to all its Accounts as long as at least one Backend Server is running.</p><p>One of the Backend Servers in a Dynamic Cluster acts as the <em>Cluster Controller</em>. It synchronizes all other Servers in the Cluster and executes operations such as creating Shared Domains, creating and removing accounts in the shared domains, etc. The Cluster Controller also provides the <em>Single Service Image</em> functionality: not only a site user, but also a site administrator can connect to any Server in the Dynamic Cluster and perform any Account operation (even if the Account is currently opened on a different Server), as well as any Domain-level operations (like Domain Settings modification), and all modifications will be automatically propagated to all Cluster Servers.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Most of the Domain-level update operations, such as updating Domain Settings, Default Account Settings, WebUser Interface Settings, and Domain-Level Alerts may take up to 30 seconds to propagate to all Servers in the Cluster. Account-Level modifications come into effect on all Servers immediately.</p></div><p>The Cluster Controller collects the load level information from the Backend Servers. When a Frontend Server receives a session request for an Account not currently opened on any Backend Server, the Controller directs the Frontend Server to the least loaded Backend Server. This second-level load balancing for Backend Server is based on actual load levels and it supplements the basic first-level Frontend load balancing (DNS round-robin or traffic-based).</p><p>When a Dynamic Cluster has at least 2 backend Servers, the Cluster Controller assigns the Controller Backup duties to one of the other backend Servers. All other Cluster members maintain connections with the Backup Controller. If the Backup Controller fails, some other backend Server is selected as a Backup Controller.</p><p>If the main Controller fails, the Backup Controller becomes the Cluster Controller. All Servers send the resynchronization information to the Backup Controller and the Cluster continues to operate without interruption.</p><p>While the Dynamic Cluster can maintain a Directory with Account records, the Dynamic Cluster functionality does not rely on the Directory. If the Directory is used, it should be implemented as a <a href="./../directory/CentralDir.html#SharedDirectory">Shared Directory</a>.</p><p>A complete Frontend-Backend Dynamic Cluster configuration uses Load Balancers and several separate networks:</p><p><img src="'+t+'" alt="Dynamic Cluster"></p><p>Since all Backend Servers in a Dynamic Cluster have direct access to Account data, they should run the operating systems using the same EOL (end-of-line) conventions. This means that all Backend Servers should either run the same or different flavors of the Unix OS, or they all should run the same or different flavors of the MS Windows OS. Frontend Servers do not have direct access to the Account data, so you can use any OS for your Frontend Servers (for example, a site can use some Unix OS for Backend Servers and Microsoft Windows for Frontend Servers).</p><h2 id="OSCluster" tabindex="-1">Cluster File Systems and Cluster OSes <a class="header-anchor" href="#OSCluster" aria-label="Permalink to &quot;Cluster File Systems and Cluster OSes {#OSCluster}&quot;">​</a></h2><p>Some of the modern Operating Systems provide advanced Clustering capabilities themselves. Most of those Cluster features are designed to help porting &quot;regular&quot;, non-clustered applications on these Cluster platforms. But some features provided with those Cluster OSes are very useful for the CommuniGate Pro Dynamic Cluster implementations.</p><p>These features include:</p><ul><li>Cluster File System</li><li>IP Aliasing</li></ul><p>A Cluster File System allows all Servers in an OS Cluster to mount and use the same file system(s) on shared devices. Unlike Network File Systems (NFS), Cluster File Systems do not require a dedicated server on the network. Cluster File Systems can utilize multiple SCSI connections provided with some high-end SCSI storage devices, and they can allow each Server to exchange the data directly with storage devices via a SAN (Storage Area Network). To ensure file system integrity, Cluster File Systems use high-speed server interconnects.</p><p>The SAN protocols are very effective for file transfers, and Cluster File Systems can provide better performance than Network File Systems.<br> The Cluster File Systems can also provide better reliability than single-server NFS solutions (where the NFS server is a single point of failure).<br> See the <a href="./Storage.html">Storage</a> section for more details.</p><p>The IP Aliasing feature allows the Cluster OS to distribute the network load between Cluster Servers without an additional Load Balancer unit.</p><p>A &quot;backend-only&quot; CommuniGate Pro Dynamic Cluster can utilize both features of a Cluster OS: the IP Aliasing is used to distribute the load between CommuniGate Pro Server, and CommuniGate Pro Servers use the Cluster File System to store all account data in shared Domains:</p><p><img src="'+a+'" alt="Dynamic - Symmetric"></p><p>A Cluster OS can be used in a frontend/backend CommuniGate Pro Cluster configuration, too. In this case, one OS Cluster is used for CommuniGate Pro frontend Servers, utilizing the IP Aliasing load balancing, and the second OS Cluster is used for CommuniGate Pro backend Servers, where the Cluster File System is employed:</p><p><img src="'+r+'" alt="Dynamic - 2 OS Clusters"></p><p>The Configuration of the CommuniGate Pro Dynamic Cluster does not depend on the type of the load balancing used (separate Load Balancers or IP Aliases), or on the type of the shared file system used (Network File System or Cluster File System).</p><h2 id="BackendConfig" tabindex="-1">Configuring Backend Servers <a class="header-anchor" href="#BackendConfig" aria-label="Permalink to &quot;Configuring Backend Servers {#BackendConfig}&quot;">​</a></h2><p>To install a Dynamic Cluster, follow these steps:</p><ul><li><p>Install and <a href="./#Config">configure</a> CommuniGate Pro Software on all Servers that will take part in a Dynamic Cluster.</p></li><li><p>Open the WebAdmin Settings-&gt;Services page and modify the PWD service settings. Each Cluster member (Backend and Frontend) opens 2 PWD connections to the Cluster Controller, so the maximum number of channels should be increased at least by <code>2*(number of Backend servers + number of Frontend servers)</code></p><p>Since additional PWD connections can be opened by Frontend and Backend servers to serve administrator and user requests, it is better to increase the number of channels by: <code>5*(number of Backend servers) + 3*(number of Frontend servers)</code></p></li><li><p>Open the WebAdmin Settings-&gt;General-&gt;Clusters page and enter the IP addresses of all backend and frontend Servers in the Cluster.</p></li><li><p>Stop all Servers.</p></li><li><p>Create a file directory that will contain Shared Domains. You should create that file directory on a storage unit that will be available for all Cluster Backend Servers (on a file server, for example). Place a link to that directory into the CommuniGate Pro <em>base directory</em>, and name that link <code>SharedDomains</code>. Make sure that all Backend Servers have all file access rights to create, remove, read, and modify files and directories inside the SharedDomains directory.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If creating symbolic links is problematic (as it is on MS Windows platforms), you should specify the location of the &quot;mounted&quot; file directory as the <code>--SharedBase</code> <a href="./../sysadmin/#Options">Command Line Option</a>:</p><p><code>--SharedBase H:\\Base</code></p></div></li><li><p>If you are upgrading from a single-server configuration, you may want to make some of your existing Domain shared, so they will be served with the entire Cluster. In this case you should move the Domain file directory from the <code>{base}/Domains</code> file directory into the <code>{base}/SharedDomains</code> file directory (located on a shared storage unit).</p></li><li><p>Modify the Startup option for all your Backend Server, so they will include the <code>--ClusterBackend</code> Command Line Option.</p></li><li><p>Start one of the Backend Servers.</p></li></ul><p>Use the WebAdmin Interface of this first Backend Server to verify that the Cluster Controller is running. Open the Domains page to check that:</p><ul><li>all domains you have placed into the SharedDomains directory are visible;</li><li>the Create Domain button is now accompanied with the Create Shared Domain button.</li></ul><p>Use the Create Shared Domain button to create additional Shared Domains to be served with the Dynamic Cluster.</p><p>When the Cluster Controller is running, the site can start serving clients (if you do not use Frontend Servers). If your configuration employs Frontend servers, at least one Frontend Server should be started.</p><h2 id="BackendAdd" tabindex="-1">Adding a Backend Server to a Dynamic Cluster <a class="header-anchor" href="#BackendAdd" aria-label="Permalink to &quot;Adding a Backend Server to a Dynamic Cluster {#BackendAdd}&quot;">​</a></h2><p>Additional Backend Server can be added to the Cluster at any moment. They should be pre-configured in the exactly the same way as the first Backend Server was configured.</p><p>To add a Backend Server to your Dynamic Cluster, start it with the <code>--ClusterBackend</code> Command Line option (it can be added to the CommuniGate Pro startup script). The Server will poll all specified Backend Server IP Addresses until it finds the active Cluster Controller.</p><p>Use the WebAdmin interface to verify that the Backend Server is running. Use the Domains page to check that all Shared Domains are visible and that you can administer Accounts in the Shared Domains.</p><p>When the Cluster Controller and at least one Backend Server are running, they both can serve all accounts in the Shared Domains. If you do not use Frontend Servers, load-balancing should be implemented using a regular load-balancer switch, DNS round-robin, or similar technique that distributes incoming requests between all Backend Servers.</p><h2 id="FrontendConfig" tabindex="-1">Adding a Frontend Server to a Dynamic Cluster <a class="header-anchor" href="#FrontendConfig" aria-label="Permalink to &quot;Adding a Frontend Server to a Dynamic Cluster {#FrontendConfig}&quot;">​</a></h2><p>You can add additional Frontend servers to the Cluster at any moment.</p><p>Install and <a href="./#Config">Configure</a> the CommuniGate Pro software on a Frontend Server computer. Since Frontend Servers do not access Account data directly, there is no need to make the SharedDomains file directory available (&quot;mounted&quot; or &quot;mapped&quot;) to any Frontend Server.</p><p>Specify the addresses of all Backend Servers using the Frontend Server Settings-&gt;General-&gt;Cluster WebAdmin page.</p><p>To add a Frontend Server to your Dynamic Cluster, stop it, and restart it with the <code>--ClusterFrontend</code> Command Line option (it can be added to the CommuniGate Pro startup script). The Server will poll all specified Backend Server IP Addresses until it finds the active Cluster Controller.</p><p>Use the WebAdmin interface to verify that the Frontend Server is running. Use the Domains page to check that all Shared Domains are visible.</p><p>When Frontend Servers try to open one of the Shared Domain accounts, the Controller directs them to one of the running Backend Servers, distributing the load between all available Backend Servers.</p><h2 id="SharedSettings" tabindex="-1">Shared Settings <a class="header-anchor" href="#SharedSettings" aria-label="Permalink to &quot;Shared Settings {#SharedSettings}&quot;">​</a></h2><p>The Dynamic Cluster maintains a separate set of &quot;Default settings&quot; for Shared Domains.</p><p>These settings include:</p><ul><li>Default Domain Settings for all Shared Domains</li><li>Default Account Settings and Default WebUser Preferences for all Accounts in Shared Domains</li><li>Cluster-Wide Alerts - these alerts are sent to all Accounts in Shared Domains</li></ul><p>When the Server Administrator uses the WebAdmin Interface to modify these settings, the WebAdmin pages display the links that allow the Administrator to switch between the Server-wide settings (that work for all non-Shared Domains), and Cluster-wide settings. The Cluster-wide settings are automatically updated on all Cluster Members, and they work for all Shared Domains.</p><p>The Cluster-wide settings also include:</p><ul><li>Cluster-wide <a href="./../network/">Network</a> Settings.</li><li>Cluster-wide <a href="./../sysadmin/Router.html#Cluster">Router</a> Table.</li><li>Cluster-wide <a href="./../directory/CentralDir.html#Cluster">Directory Integration</a> Settings.</li><li>Cluster-wide <a href="./../../development/Rules.html#Cluster">Rules</a>.</li><li>Cluster-wide <a href="./../sysadmin/Protection.html">Protection</a> Settings.</li><li>Default and Named Cluster-wide <a href="./../../development/WebApp.html">WebSkins</a>. These WebSkins are used as default Skins for WebSkins in Shared Domains.</li><li>Cluster-wide <a href="./../../development/PBXApp.html">Real-Time</a> Applications.</li><li>Cluster-wide <a href="./../sysadmin/Intercept.html">Lawful Interception</a> settings.</li></ul><h2 id="SharedProcessing" tabindex="-1">Shared Processing <a class="header-anchor" href="#SharedProcessing" aria-label="Permalink to &quot;Shared Processing {#SharedProcessing}&quot;">​</a></h2><p>The Dynamic Cluster Single Service Image component provides server synchronization beyond Account, Domain, and other Settings.</p><p>Additional &quot;shared processing&quot; functionality includes:</p><ul><li>Cluster-wide <a href="./../objects/Chronos.html">Chronos</a> processing.</li><li>Distributed <a href="./EMail.html">Queue</a> processing.</li><li>Distributed <a href="./Signals.html">Signal</a> processing.</li><li>Distributed <a href="./../mail/RPOP.html">RPOP</a> and <a href="./../signals/PSTN.html#RSIP">RSIP</a> task processing.</li><li>Cluster-wide <a href="./../mail/SMTP.html#ETRN">SMTP queue release</a> (via ETRN or Wakeup E-mail).</li><li>Cluster-wide Authentication token (<em>nonce</em>) synchronization.</li><li>Cluster-wide <a href="./../directory/#Cluster">Directory Units</a>.</li></ul><h2 id="Del" tabindex="-1">Withdrawing Servers from a Dynamic Cluster <a class="header-anchor" href="#Del" aria-label="Permalink to &quot;Withdrawing Servers from a Dynamic Cluster {#Del}&quot;">​</a></h2><p>Use the WebAdmin Interface to withdraw a Server from a Dynamic Cluster. Open the Cluster page in the Monitors realm, and click the Make Non-Ready button.</p><p>When a Frontend Server is in the Non-Ready state, all its UDP ports and all its TCP ports (except the HTTP Admin ports) are closed.<br> The load balancer delivering incoming connections to the Cluster Frontends should detect this and stop sending new connections and packets to this Frontend.</p><p>When a Backend Server is in the Non-Ready state, the Controller does not send any new sessions to this Server. Wait until all existing sessions end, and then shut down the Backend Server.</p><p>If this Backend Server is the currently active Controller, then making it Non-Ready causes the Controller to send all new sessions to the other Backend Servers. If there are no other Backend Servers in the Cluster, the Controller continues to serve all new sessions itself.</p><p>You can click the Make Ready button on the same page to re-enable the Server. If the Server is a Backend, the Controller starts to send new sessions to it.</p><p>You need to have the <a href="./../sysadmin/#Privs">Can Control Cluster</a> access right to make Cluster members Ready or Non-Ready</p><p>If a Backend Server fails, all Shared Domain Accounts that were open on that Server at the time of failure become unavailable. They become available again within 5-10 seconds, when the Cluster Controller detects the failure. A Backend Server failure does not cause any data loss.</p><h2 id="Upgrade" tabindex="-1">Upgrading Servers in a Dynamic Cluster <a class="header-anchor" href="#Upgrade" aria-label="Permalink to &quot;Upgrading Servers in a Dynamic Cluster {#Upgrade}&quot;">​</a></h2><p>The Dynamic Cluster is designed to support &quot;rolling upgrades&quot;. To upgrade to a newer version of the CommuniGate Pro software, you should upgrade the Servers one-by-one: withdraw a server from the Cluster, upgrade the software, and add the server back to the Cluster. This procedure allows your site to operate non-stop during the upgrade.</p><p>Certain changes in CommuniGate Pro software can impose some restrictions on the &quot;rolling upgrade&quot; process. Always check the <a href="./../common/History.html">History</a> section before you upgrade your Cluster, and see if any Cluster Upgrade restrictions are specified there.</p>',79)]))}const v=n(l,[["render",d]]);export{y as __pageData,v as default};
