import{_ as t,a as s,b as a,c as o}from"./chunks/ClusterSubmitRemote.DHazE7vv.js";import{_ as r,c as i,o as n,ag as l}from"./chunks/framework.jCcxW76o.js";const b=JSON.parse('{"title":"E-Mail Transfer in Clusters","description":"","frontmatter":{"legacyLink":"ClusterTransfer.html"},"headers":[],"relativePath":"admin/cluster/EMail.md","filePath":"admin/cluster/EMail.md"}'),c={name:"admin/cluster/EMail.md"};function d(m,e,u,h,p,g){return n(),i("div",null,e[0]||(e[0]=[l('<h1 id="e-mail-transfer-in-clusters" tabindex="-1">E-Mail Transfer in Clusters <a class="header-anchor" href="#e-mail-transfer-in-clusters" aria-label="Permalink to &quot;E-Mail Transfer in Clusters&quot;">​</a></h1><p>This section explains how <a href="./../mail/">E-mail Message Transfer</a> operations work in the CommuniGate Pro Cluster environment.</p><h2 id="SMTP" tabindex="-1">SMTP Relaying <a class="header-anchor" href="#SMTP" aria-label="Permalink to &quot;SMTP Relaying {#SMTP}&quot;">​</a></h2><p>Incoming SMTP connections are received with a TCP Load Balancer and sent to Cluster Frontends. A Frontend Server receives a message in the same way as it does in the single-server mode, but it may contact the Backend Servers (via <a href="./../../development/CLI.html">CLI</a>) when it needs to:</p><ul><li>authenticate the sender</li><li>verify the sender and recipient addresses</li><li>check the recipient status</li><li>retrieve the sender limits</li></ul><p>Received messages are enqueued. If a message is directed to an external address, it can be relayed by the same Frontend:</p><p><img src="'+t+'" alt="Cluster SMTP Relaying"></p><h2 id="Local" tabindex="-1">Local Delivery <a class="header-anchor" href="#Local" aria-label="Permalink to &quot;Local Delivery {#Local}&quot;">​</a></h2><p>A message directed to a local recipient can be enqueued on a &quot;wrong&quot; Server, i.e. on a Server that cannot open the target Account and deliver the message to that Account.</p><p>This situation can happen when a message is enqueued on a Frontend Server (Frontend Servers cannot directly open any Account in Shared Domains), or a message is enqueued on a Backend Server that either does not host the target Account (in a Static Cluster), or it cannot open it, because the Account is opened by some other Backend Server (in a Dynamic Cluster).</p><p>To solve the problem, the <a href="./../mail/Local.html">Local Delivery</a> module uses a Delivery channel connection to the proper Backend Server and passes the message there. The receiving Backend immediately opens the target Account, applies its Account-Level Rule and stores the transferred message. This Backend does not enqueue the message.</p><p>If there is a temporary problem or a delivery failure, the receiving Backend Server reports the error back, and the message is either delayed in Queue or it is removed from the Queue (with error report messages generated).</p><p><img src="'+s+'" alt="Cluster Local Delivery"></p><h2 id="Submit" tabindex="-1">Backend Queues <a class="header-anchor" href="#Submit" aria-label="Permalink to &quot;Backend Queues {#Submit}&quot;">​</a></h2><p><a href="./../access/WebUser.html">WebUser Interface</a>, <a href="./../access/XIMSS.html">XIMSS</a>, <a href="./../access/MAPI.html">MAPI</a> sessions, <a href="./../mail/QueueRules.html">Rules</a>, and other modules and components can generated E-mail messages on Backend Servers.</p><p>Backend Server often do not have direct access to the Internet, in this case they cannot deliver generated messages to remote systems. To solve this problem, the Backend Servers can be configured to relay all messages to the Frontend Servers first, using the <code>*</code> symbol as the <a href="./../mail/SMTP.html#Foreign">SMTP Forwarding Server</a> name.</p><p>In this case the message is submitted to the Backend Queue, where it is processed using the Server-wide and Cluster-wide Rules, and if it is not directed to a local recipient, it is directed to the SMTP module which sends it to one of the Frontend Servers:</p><p><img src="'+a+'" alt="Cluster Submit"></p><p>In this setup, each messages generated on a Backend Server is processed twice. If Cluster Rules invoke content management <a href="./../mail/ExternalFilters.html">Plugins</a>, double-processing can create a substantial overhead.</p><p>To avoid these problems and the inevitable overhead, the <a href="#Remote">Remote Queue Processing</a> method should be used.</p><h2 id="Remote" tabindex="-1">Remote Queue Processing <a class="header-anchor" href="#Remote" aria-label="Permalink to &quot;Remote Queue Processing {#Remote}&quot;">​</a></h2><p>Most of the Queue processing takes place on the Frontend Servers. Frontend Servers accept incoming SMTP E-mail Messages and either relay them to remote locations or deliver them to local Accounts via Backends, using the special inter-cluster protocol, without placing messages into the Backend Server Queue.</p><p>A certain amount of E-mail Messages can be generated directly on the Backend Servers.</p><p>They include messages:</p><ul><li>composed with WebUser, XIMSS, AirSync, CalDAV sessions;</li><li>submitted using the MAPI Connector and XTND XMIT POP3 mechanism;</li><li>created with Account-level Rules;</li><li>retrieved using the RPOP module;</li><li>submitted using the PIPE module.</li></ul><p>You may want to avoid processing Message Queues on Backends for various reasons, including:</p><ul><li>lack of Internet connectivity for Backends;</li><li>requirement to use anti-spam and/or anti-virus Plugins installed on Frontends only;</li><li>shortage of processing power and/or disk space on Backend Servers.</li></ul><p>You may also want to process Message Queues on some Frontends only.</p><p>To specify Queue processing options, open the Settings WebAdmin realm and select the Cluster link on the General page. Find the Queue Processing panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Queue Processing</b></td></tr><tr><td align="RIGHT" width="25%">Submit Messages:</td><td align="LEFT"><select name="SubmitMode"><option value="Auto" selected="selected">Auto</option><option value="Remotely">Remotely</option><option value="Locally">Locally</option><option value="Locally for Others">Locally for Others</option></select></td><td align="RIGHT" width="25%">Remote Submit Log:</td><td align="LEFT"><select name="SubmitLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Submit Messages</code></p><p>This setting specifies how the composed or received E-mail messages are submitted to the <a href="./../mail/">Enqueuer component</a> for delivery.</p><ul><li><p><code>Locally</code></p><p>messages are submitted to the Enqueuer component on the same Server (this is the &quot;regular&quot;, single-server processing mode).</p></li><li><p><code>Locally for Others</code></p><p>messages are submitted to the Enqueuer component on the same Server.<br> The Dynamic Cluster Controller is informed that this Server can accept (enqueue) E-mail messages composed or received with the other Cluster members.<br> The Dynamic Cluster Controller collects and distributes information about all active Cluster members that have this option selected.</p></li><li><p><code>Remotely</code></p><p>messages are transferred to some Cluster member that has this setting set to Locally for Others. The temporary message file content (the message envelope and the message itself) is sent to that other Cluster member via a special protocol that uses the SMTP port. If the remote message submission does not work (the Server failed to connect to the Cluster member(s) or the message file transfer fails), the message is submitted to the Server own Queue to ensure that no message is lost:</p><p><img src="'+o+'" alt="Cluster Remote Submit"></p></li><li><p><code>Auto</code></p><ul><li>if this Server is not a Dynamic Cluster member, same as <code>Locally</code></li><li>if this Server is a Dynamic Cluster frontend, same as <code>Locally for Others</code></li><li>if this Server is a Dynamic Cluster backend, same as <code>Remotely</code> if there are other Dynamic Cluster members configured as <code>Locally for Others</code>, if there are none - same as <code>Locally</code></li></ul></li></ul></li><li><p><code>Remote Submit Log</code></p><p>Use this setting to specify what kind of information is stored in the Server Log when a message is being submitted remotely (to a different Server).<br> These records are marked with the <code>SUBMIT</code> tag.</p></li></ul>',31)]))}const S=r(c,[["render",d]]);export{b as __pageData,S as default};
