import{_ as t}from"./chunks/ClusterSIP.DBDDnqhR.js";import{_ as a,c as s,o,ag as n}from"./chunks/framework.jCcxW76o.js";const g=JSON.parse('{"title":"Real-Time Processing in Clusters","description":"","frontmatter":{"legacyLink":"ClusterSignals.html"},"headers":[],"relativePath":"admin/cluster/Signals.md","filePath":"admin/cluster/Signals.md"}'),r={name:"admin/cluster/Signals.md"};function i(l,e,d,c,h,p){return o(),s("div",null,e[0]||(e[0]=[n('<h1 id="real-time-processing-in-clusters" tabindex="-1">Real-Time Processing in Clusters <a class="header-anchor" href="#real-time-processing-in-clusters" aria-label="Permalink to &quot;Real-Time Processing in Clusters&quot;">​</a></h1><p>This section explains how Real-Time operations work in the CommuniGate Pro Cluster environment:</p><ul><li>how Real-Time Tasks (such as <a href="./../../development/PBXApp.html#CGPL">Real-Time Applications</a> and <a href="./../../development/XMLAPI.html#Signals">XIMSS Call Legs</a>) communicate with each other, with <a href="./../../development/XMLAPI.html">XIMSS</a> sessions, and with <a href="./Signals.html">Real-Time Signals</a>.</li><li>how <a href="./Signals.html">Real-Time Signals</a> are created and access the <a href="./../objects/Accounts.html">Account</a> data.</li><li>how <a href="./../signals/SIP.html">SIP</a> transactions are handled.</li><li>how RTP Media streams are processed.</li></ul><h2 id="PBXLeg" tabindex="-1">Real-Time Tasks <a class="header-anchor" href="#PBXLeg" aria-label="Permalink to &quot;Real-Time Tasks {#PBXLeg}&quot;">​</a></h2><p>The CommuniGate Pro <a href="./../../development/PBXApp.html">Real-Time Tasks</a> communicate by sending <em>events</em> to <em>task handlers</em>. A <em>task handler</em> is a reference object describing a Real-Time Task, a Session, or a Real-Time Signal. In a CommuniGate Pro Cluster environment, the Task handler contains the address of the Cluster Member server the referenced Real-Time Task, Session, or Signal is running on.</p><p>When an event should be delivered to a different cluster member, it is delivered using the inter-Cluster <a href="./../../development/CLI.html">CLI/API</a>. The event recipient can reply, using the sender <em>task handler</em>, and again the inter-Cluster <a href="./../../development/CLI.html">CLI/API</a> will be used to deliver the reply event.</p><p>Real-Time Application Tasks usually employ <a href="./../signals/MediaServer.html">Media channels</a>. To be able to exchange media with external entities, Real-Time Tasks should run only on those Cluster members that have direct access to the Internet.</p><h2 id="XIMSSLeg" tabindex="-1">XIMSS Call Legs <a class="header-anchor" href="#XIMSSLeg" aria-label="Permalink to &quot;XIMSS Call Legs {#XIMSSLeg}&quot;">​</a></h2><p>When a <a href="./../../development/XMLAPI.html">XIMSS</a> session initiates a call, it creates a Call Leg object. These Call Leg objects manage XIMSS user Media channels and they should be able to exchange media with external entities, so they should run only on those Cluster members that have direct access to the Internet.</p><p>When a <a href="./Signals.html">Real-Time Signal</a> component directs an incoming call to a <a href="./../../development/XMLAPI.html">XIMSS</a> session, it creates a Call Leg object on the same Cluster member processing this incoming call Signal request. This Call Leg object is then &quot;attached&quot; to the XIMSS session (which is running on some backend Server and this can be running on a different Cluster member).</p><p>When an XIMSS session and its Call Leg are running on different Cluster members, they communicate via special events, which are delivered using the inter-Cluster <a href="./../../development/CLI.html">CLI/API</a>.</p><h2 id="Signals" tabindex="-1">Signals <a class="header-anchor" href="#Signals" aria-label="Permalink to &quot;Signals {#Signals}&quot;">​</a></h2><p><a href="./Signals.html">Real-Time Signal</a> processing results in <a href="./../network/#DNR">DNS Resolver</a> , <a href="./../signals/SIP.html">SIP</a>, and <a href="./../signals/XMPP.html">XMPP</a> requests.<br> When a Cluster is configured so that only the frontend servers can access the Internet, Real-Time Signal processing should take place on those frontend servers only.</p><p>Even if the Real-Time applications and Call Legs are configured to run on frontend servers only, Real-Time Signals can be generated on other cluster members, too: XIMSS and XMPP sessions, <a href="./../../development/Rules.html">Automated Rules</a>, and other components can send Instant Messages, <a href="./Signals.html#Events">Event packages</a> generate notification Signals, etc.</p><p>When a Real-Time Signal is running on a frontend server, it uses inter-Cluster <a href="./../../development/CLI.html">CLI/API</a> to retrieve Account data (such as SIP registration), or to perform requested actions (to deliver SUBSCRIBE or XMPP IQ request, or to initiate a call).</p><h2 id="Config" tabindex="-1">Configuring Call Leg and Signal Processing <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring Call Leg and Signal Processing {#Config}&quot;">​</a></h2><p>To configure the Call Leg and Signal creation mode, open the General page in the Settings WebAdmin realm and click the Cluster link:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Real-Time</b></td></tr><tr><td align="right" width="25%">Call Legs Processing:</td><td align="left"><select name="LegHostMode"><option value="Auto" selected="selected">Auto</option><option value="Remotely">Remotely</option><option value="Locally">Locally</option><option value="Locally for Others">Locally for Others</option></select></td><td align="right" width="25%"> </td><td> </td></tr><tr><td align="right" width="25%">Signal Processing:</td><td align="left"><select name="SignalMode"><option value="Auto" selected="selected">Auto</option><option value="Remotely">Remotely</option><option value="Locally">Locally</option><option value="Locally for Others">Locally for Others</option></select></td><td align="right" width="25%"> </td><td> </td></tr></tbody></table></div></form><ul><li><p><code>Call Legs Processing</code></p><p>This setting specifies how the Real-Time Tasks and Call Leg objects should be created with this Cluster member.</p><ul><li><p><code>Locally</code></p><p>when there is a request to create a Real-Time Task or a Call Leg object, it is created on the same Server (this is the &quot;regular&quot;, single-server processing mode).</p></li><li><p><code>Locally for Others</code></p><p>Real-Time Task and Call Leg objects are created on the same Server.<br> The Dynamic Cluster Controller is informed that this Server can create Real-Time Task and Call Leg objects for other Cluster members.<br> The Dynamic Cluster Controller collects and distributes information about all active Cluster members that have this option selected.</p></li><li><p><code>Remotely</code></p><p>when there is a request to create a Real-Time Task or a Call Leg object, a request is relayed to some Cluster member that has this setting set to Locally for Others.</p></li><li><p><code>Auto</code></p><p>same as:</p><ul><li><p><code>Locally</code></p><p>if this Server is not a Dynamic Cluster member.</p></li><li><p><code>Locally for Others</code></p><p>if this Server is a Dynamic Cluster frontend.</p></li><li><p><code>Remotely</code></p><p>if this Server is a Dynamic Cluster backend.</p></li></ul></li></ul></li><li><p><code>Signal Processing</code></p><p>This setting specifies how the Signal objects should be created with this Cluster member. Values for this setting have the same meaning as for the Call Legs Processing setting.</p></li></ul><h2 id="SIP" tabindex="-1">SIP <a class="header-anchor" href="#SIP" aria-label="Permalink to &quot;SIP {#SIP}&quot;">​</a></h2><p>The CommuniGate Pro SIP Farm® feature allows several Cluster members to process SIP request packets randomly distributed to them by a Load Balancer.</p><p>Configure the Load Balancer to distribute incoming SIP UDP packets (port 5060 by default) to the SIP ports of the selected SIP Farm Cluster members.<br> If your Cluster has Frontend Servers, then all or some of the Frontend Servers should be used as SIP Farm members.</p><p>To configure the SIP Farm Members, open the General page in the Settings WebAdmin realm and click the Cluster link:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Real-Time</b></td></tr><tr><td align="right" width="25%">SIP Farm:</td><td align="left"><select name="SIPFarmMode"><option value="Auto" selected="selected">Auto</option><option value="Disabled">Disabled</option><option value="Relay">Relay</option><option value="Member">Member</option></select></td><td align="right" width="25%"> </td><td> </td></tr></tbody></table></div></form><ul><li><p><code>SIP Farm</code></p><p>This setting specifies how the SIP requests should be processed by this Cluster member.</p><ul><li><p><code>Member</code></p><p>If this option is selected, this Cluster member is a member of a SIP Farm. It processes new requests locally or it redirects them to other SIP Farm members based on the SIP Farm algorithms.</p></li><li><p><code>Disabled</code></p><p>If this option is selected, this Cluster member is not a member of a SIP Farm; it will process incoming SIP requests locally.</p></li><li><p><code>Relay</code></p><p>If this option is selected, this Cluster member is not a member of a SIP Farm; but when it needs to send a SIP request, it will relay it via the currently available SIP Farm members.<br> Select this option for Backend Servers that do not have direct access to the Internet and thus cannot send SIP requests directly.</p></li><li><p><code>Auto</code></p><ul><li>if this Server is not a Dynamic Cluster member, same as <code>Disabled</code></li><li>if this Server is a Dynamic Cluster frontend, same as <code>Member</code></li><li>if this Server is a Dynamic Cluster backend, same as <code>Relay</code> if there are other Dynamic Cluster members configured as <code>Member</code>, if there are none - same as <code>Disabled</code></li></ul></li></ul></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>A SIP request can explicitly address some Cluster member (most in-dialog requests do). These requests are always redirected to the specified Cluster member and processed on that member, regardless of the SIP Farm settings.</p></div><p>The CommuniGate Pro Cluster maintains the information about all its Servers with the SIP Farm setting set to Member. Incoming UDP packets and TCP connections are distributed to those Servers using regular simple Load Balancers.</p><p>The receiving Server detects if the received packet must be processed on a certain Farm Server: it checks if the packet is a response or an ACK packet for an existing transaction or if the packet is directed to a Node created on a certain Server. In this case the packet is relayed to the proper Cluster member:</p><p><img src="'+t+`" alt="Cluster SIP"></p><p>Packets not directed to a particular Cluster member are distributed to all currently available Farm Members based on the CommuniGate Pro SIP Farm algorithms.</p><p>To process a Signal, Cluster members may need to retrieve certain Account information (registration, preferences, etc.). If the Cluster member cannot open the Account (because the Member is a Frontend Server or because the Account is locked on a different Backend Server), it uses the inter-Cluster <a href="./../../development/CLI.html">CLI/API</a> to retrieve the required information from the proper Backend Server.</p><p>Several Load Balancer and network configurations can be used to implement a SIP Farm:</p><h3 id="SIPSingleIP" tabindex="-1">Single-IP NAT Load Balancer <a class="header-anchor" href="#SIPSingleIP" aria-label="Permalink to &quot;Single-IP NAT Load Balancer {#SIPSingleIP}&quot;">​</a></h3><p>This method is used for small Cluster installations, when the frontend Servers do not have direct access to the Internet, and the Load Balancer performs Network Address Translation for frontend Servers.</p><p>First select the &quot;virtual&quot; IP address (VIP) - this is the only address your Cluster SIP users will &quot;see&quot;:</p><ul><li>assign the VIP address to the Load Balancer</li><li>select a &quot;sip-service&quot; DNS domain name (such as <code>_sip._mysystem.com</code>), and create a DNS A- or AAAA- record for that name, pointing to the VIP address.</li><li>create DNS SIP SRV records for all your Cluster Domains pointing to this &quot;sip-service&quot; name.</li><li>open the Network pages in the Settings realm of the CommuniGate Pro WebAdmin Interface, and specify the VIP address as the Cluster-wide WAN IP address; <strong>leave the Server-wide WAN IP Address field empty.</strong></li></ul><p>The frontend servers have IP addresses F1, F2, F3, ...</p><p>Configure the Load Balancer to process incoming UDP packets received on its VIP address and port 5060:</p><ul><li>incoming packets should be redirected evenly to F1, F2, F3 frontend server addresses, to the same port 5060.</li><li>the Load Balancer should not apply any SIP-specific logic to these packets; <strong>if your Load Balancer has any SIP-specific options, make sure they are switched off.</strong> Some Load Balancers use SIP-specific processing for port 5060 by default: consult with your Load Balancer manufacturer.</li><li>incoming packets should not create any &quot;session&quot; in the Load Balancer, i.e. the Load Balancer should not keep any information about an incoming UDP packet after it has been redirected to some frontend server.</li></ul><p>SIP-specific techniques implemented in some Load Balancers allow them to send all &quot;related&quot; requests to the same server. Usually these techniques are based on the request Call-ID field and thus fail very often. CommuniGate Pro SIP Farm technology ensures proper request handling if a request or response packet is received by any SIP Farm member. Thus, these SIP-specific Load Balancer techniques are not required with CommuniGate Pro.</p><p>Many Load Balancers create &quot;session binding&quot; for incoming UDP requests, in the same way they process incoming TCP connections - even if they do not implement any SIP-special techniques.<br> The Binding table for some Load Balancer port <code>v</code> (and the Load Balancer VIP address) contains IP address-port pairs:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>X:x &lt;-&gt; F1:f</span></span></code></pre></div><p>where X:x is the remote (sending) device IP address and port, and F1:f is the frontend Server IP address and port the incoming packet has been forwarded to.<br> When the remote device re-sends the request, this table record allows the Load Balancer to send the request to the same frontend Server (note that this is <strong>not</strong> needed with the CommuniGate Pro SIP Farm).</p><p>These Load Balancers usually create &quot;session binding&quot; for outgoing UDP requests, too: when a packet is sent from some frontend address/port F2:f to some remote address/port Y:y, a record is created in the Load Balancer Binding table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Y:y &lt;-&gt; F2:f</span></span></code></pre></div><p>When the remote device sends a response packet, this table record allows the Load Balancer to send the response to the &quot;proper&quot; frontend Server (note that this is <strong>not</strong> needed with the CommuniGate Pro SIP Farm).</p><p>CommuniGate Pro SIP Farm distributes SIP request packets by relaying them between the frontend Servers, according to the SIP Farm algorithms; the SIP Farm algorithms redirect the SIP response packets to the frontend Server that has sent the related SIP request.<br> These CommuniGate Pro SIP Farm features make the Load Balancer &quot;session binding&quot; table useless (when used for SIP UDP)</p><p>The Load Balancer &quot;session binding&quot; must be switched off (for SIP UDP), because it not only creates unnecessary overhead, but it usually corrupts the source address of the outgoing SIP packets:</p><p>When a Load Balancer receives a SIP request packet from X:x address, and relays it to the frontend Server F1:5060 address/port, the SIP Farm can relay this request to some other frontend Server (the F2:5060 address/port), where a SIP Server transaction will be created and the request will be processed.<br> SIP responses will be generated with this frontend Server, and the SIP response packets will be sent out to X:x from the F2:5060 address/port (via the Load Balancer).<br> If the Load Balancer does not do any &quot;session binding&quot;, it should simply change the packet source address from F2:5060 to VIP:5060, and redirect it to X:x.</p><p>If the Load Balancer does implement UDP &quot;session binding&quot;, it expects to see the response packets from the same F1:5060 address only; it will then redirect them to X:x after changing the response packet source address from F1:5060 to VIP:5060.<br> Packets from other servers (for which it does not have a &quot;session binding&quot;) are processed as &quot;outgoing packets&quot;, and a Load Balancer builds a new &quot;session binding&quot; for them (see above). In our case, when a Load Balancer sends a request from X:x to F1:5060, and gets a response from F2:5060, it would have to create the second &quot;session binding&quot;:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>X:x &lt;-&gt; F1:5060</span></span>
<span class="line"><span>X:x &lt;-&gt; F2:5060</span></span></code></pre></div><p>These are conflicting &quot;session binding&quot; for most Load Balancers, and in order to solve the conflict the Load Balancer will use NAT techniques and change not only the source address of the outgoing packet, but its source port, too - so the response packet will be sent to X:x with the source address set not to VIP:5060, but to VIP:5061 (or any other source port the Load Balancer uses for NAT). Many SIP devices, and most SIP devices behind firewalls will not accept responses from the VIP:5061 address/port, if they have sent requests to VIP:5060 address/port.</p><p>It is very important to consult with your Load Balancer manufacturer to ensure that the Load Balancer does not use &quot;session binding&quot; for UDP port 5060 - to avoid the problem described above.</p><h3 id="SIPMultiNAT" tabindex="-1">Multi-IP NAT Load Balancer <a class="header-anchor" href="#SIPMultiNAT" aria-label="Permalink to &quot;Multi-IP NAT Load Balancer {#SIPMultiNAT}&quot;">​</a></h3><p>In this configuration frontend Servers have direct access to the Internet (they have IP addresses directly &quot;visible&quot; from the Internet).</p><ul><li>The Load Balancer redirects incoming requests to these real F1, F2, F3... frontend Server addresses.</li><li>The Load Balancer should be implemented as the a switch, so outgoing traffic from frontend Servers will pass via the Load Balancer.</li><li>The Load Balancer should change the source IP of all outgoing SIP UDP packets coming from frontend Servers (from Fn:5060) to VIP:5060.</li></ul><p>Load Balancers with UDP &quot;session binding&quot; will have the same problems as described above.</p><h3 id="SIPDSR" tabindex="-1">DSR Load Balancer <a class="header-anchor" href="#SIPDSR" aria-label="Permalink to &quot;DSR Load Balancer {#SIPDSR}&quot;">​</a></h3><p>DSR (Direct Server Response) is the preferred Load-Balancing method for larger installations.</p><p>To use the DSR method, create an &quot;alias&quot; for the loopback network interface on each Frontend Server. While the standard address for the loopback interface is 127.0.0.1, create an alias with the VIP address and the 255.255.255.255 network mask:</p><ul><li><p><strong>Solaris</strong></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig lo0:1 plumb</span></span>
<span class="line"><span>ifconfig lo0:1 _VIP_ netmask 255.255.255.255 up</span></span></code></pre></div><p>To make this configuration permanent, create the file <code>/etc/hostname.lo0:1</code> with the VIP address in it.</p></li><li><p><strong>Linux</strong></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig lo:0 _VIP_ netmask 255.255.255.255 up</span></span></code></pre></div><p>To make this configuration permanent, create the file <code>/etc/sysconfig/network-scripts/ifcfg-lo:0</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>DEVICE=lo</span></span>
<span class="line"><span>IPADDR=_VIP_</span></span>
<span class="line"><span>NETMASK=255.255.255.255</span></span>
<span class="line"><span>ONBOOT=yes</span></span></code></pre></div><p>Make sure that the kernel is configured to avoid ARP advertising for this <code>lo</code> interface (so the <code>VIP</code> address is not linked to any Frontend server in arp-tables). Subject to the Linux kernel version, the following commands should be added to the <code>/etc/sysctl.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># ARP: reply only if the target IP address is</span></span>
<span class="line"><span># a local address configured on the incoming interface</span></span>
<span class="line"><span>net.ipv4.conf.all.arp_ignore = 1</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># When an arp request is received on eth0, only respond</span></span>
<span class="line"><span># if that address is configured on eth0.</span></span>
<span class="line"><span>net.ipv4.conf.eth0.arp_ignore = 1</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># Enable configuration of arp_announce option</span></span>
<span class="line"><span>net.ipv4.conf.all.arp_announce = 2</span></span>
<span class="line"><span># When making an ARP request sent through eth0, always use an address</span></span>
<span class="line"><span># that is configured on eth0 as the source address of the ARP request.</span></span>
<span class="line"><span>net.ipv4.conf.eth0.arp_announce = 2</span></span>
<span class="line"><span>#</span></span>
<span class="line"><span># Repeat for eth1, eth2 (if exist)</span></span>
<span class="line"><span>#net.ipv4.conf.eth1.arp_ignore = 1</span></span>
<span class="line"><span>#net.ipv4.conf.eth1.arp_announce = 2</span></span>
<span class="line"><span>#net.ipv4.conf.eth2.arp_ignore = 1</span></span>
<span class="line"><span>#net.ipv4.conf.eth2.arp_announce = 2</span></span></code></pre></div></li><li><p><strong>FreeBSD</strong></p><p>To change the configuration permanently, add the following line to the <code>/etc/rc.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ifconfig_lo0_alias0=&quot;inet VIP netmask 255.255.255.255&quot;</span></span></code></pre></div></li><li><p><strong><em>other OS</em></strong></p><p>consult with the OS vendor</p></li><li><p>When this &quot;alias&quot; is created, the frontend Servers do not respond to the &quot;arp&quot; requests for the VIP address, and all packets directed to the VIP address will be routed to the Load Balancer.</p></li><li><p>When the Load Balancer uses the &quot;DSR&quot; method, it does not change the target IP address (VIP) of the incoming packets. Instead the Load Balancer redirects incoming packets using the network-level (MAC) address of the selected frontend Server.</p></li><li><p>Because the frontend Server has the VIP address configured on one of its interfaces (on the loopback interface), it accepts this packet as a local one, and passes it to the application listening on the specified TCP or UDP port.</p></li><li><p>Because the frontend Server has the VIP address configured on one of its interfaces, response and other outgoing packets can be sent using the VIP address as the source address. If these packets come via the Load Balancer (they can bypass it), the Load Balancer should not modify them in any way.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Because MAC addresses are used to redirect incoming packets, the Load Balancer and all frontend Servers must be connected to the same network segment; there should be no router between the Load Balancer and frontend Servers.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a network &quot;alias&quot; is created, open the General Info page in the CommuniGate Pro WebAdmin Settings realm, and click the Refresh button to let the Server detect the newly added IP address.</p></div><p>The DSR method is transparent for all TCP-based services (including SIP over TCP/TLS), no additional CommuniGate Pro Server configuration is required: when a TCP connection is accepted on a local VIP address, outgoing packets for that connection will always have the same VIP address as the source address.</p><p>To use the DSR method for SIP UDP, the CommuniGate Pro frontend Server configuration should be updated:</p><ul><li>use the WebAdmin Interface to open the Settings realm. Open the SIP receiving page in the Real-Time section</li><li>follow the UDP Listener link to open the <a href="./../network/Listener.html">Listener</a> page</li><li>by default, the SIP UDP Listener has one socket: it listens on &quot;all addresses&quot;, on the port 5060.</li><li>change this socket configuration by changing the &quot;all addresses&quot; value to the <em>VIP</em> value (the <em>VIP</em> address should be present in the selection menu).</li><li>click the Update button</li><li>create an additional socket to receive incoming packets on the port 5060, &quot;all addresses&quot;, and click the Update button</li></ul><p>Now, when you have 2 sockets - the first socket for <em>VIP</em>:5060, the second one for <em>all addresses</em>:5060, the frontend Server can use the first socket when it needs to send packets with VIP source address.<br> Repeat this configuration change for all frontend Servers.</p><h2 id="RTP" tabindex="-1">RTP Media <a class="header-anchor" href="#RTP" aria-label="Permalink to &quot;RTP Media {#RTP}&quot;">​</a></h2><p>Each Media stream terminated in CommuniGate Pro (a stream relayed with a <em>media proxy</em> or a stream processed with a <em>media server channel</em>) is bound to a particular Cluster Member. The Load Balancer must ensure that all incoming Media packets are delivered to the proper Cluster Member.</p><h3 id="RTPSingleIP" tabindex="-1">Single-IP Method <a class="header-anchor" href="#RTPSingleIP" aria-label="Permalink to &quot;Single-IP Method {#RTPSingleIP}&quot;">​</a></h3><p>The &quot;single-IP&quot; method is useful for a small and medium-size installations.<br> The Cluster Members have internal addresses <code>L1</code>, <code>L1</code>, <code>L3</code>, etc.<br> The Load Balancer has an external address <code>G0</code>.<br> The <a href="./../network/">Network Settings</a> of each Cluster Member are modified, so the Media Ports used on each Member are different: ports 10000-19999 on the <code>L1</code> Member, ports 20000-29999 on the <code>L2</code> Member, ports 30000-39999 on the <code>L3</code> Member, etc.<br> All packets coming to the <code>G0</code> address to the standard ports (5060 for SIP) are distributed to the <code>L1</code>, <code>L2</code>, <code>L3</code> addresses, to the same ports.<br> All packets coming to the <code>G0</code> address to the media ports are distributed according to the port range:</p><ul><li>packets coming to the ports 10000-19999 are directed to the <code>L1</code> address (without port number change)</li><li>packets coming to the ports 20000-29999 are directed to the <code>L2</code> address (without port number change)</li><li>packets coming to the ports 30000-39999 are directed to the <code>L3</code> address (without port number change)</li></ul><p>The Server-wide WAN IP Address setting should be left empty on all Cluster Members.<br> The Cluster-wide WAN IP Address setting should specify the <code>G0</code> address.</p><p>This method should not be used for large installations (unless there is little or no media termination): it allows you to allocate only 64000 ports for all Cluster media streams (each AVP stream takes 2 ports, so the total number of audio streams is limited to 32000, and if video is used (together with audio), such a Cluster cannot support more than 16,000 concurrent A/V sessions.</p><h3 id="RTPNoNAT" tabindex="-1">Multi-IP No-NAT Load Balancer <a class="header-anchor" href="#RTPNoNAT" aria-label="Permalink to &quot;Multi-IP No-NAT Load Balancer {#RTPNoNAT}&quot;">​</a></h3><p>The &quot;multi-IP&quot; method is useful for large installations. Each frontend has its own IP address, and when a Media Channel or a Media Proxy is created on that frontend Server, this unique IP address is used for direct communication between the Server and the client device or remote server.</p><p>The <a href="./../network/">Network Settings</a> of each Cluster Member can specify the same Media Port ranges, and the number of concurrent RTP streams is not limited by 64000 ports.</p><p>In the simplest case, all frontend Servers have &quot;real&quot; IP Addresses, i.e. they are directly connected to the Internet.</p><p>If the Load Balancer uses a DSR method (see above), then it should not care about the packets originating on the frontend Servers from non-VIP addresses: these packets either bypass the Load Balancer, or it should deliver them without any modification.</p><p>If the Load Balancer uses a &quot;normal&quot; method, it should be instructed to process &quot;load balanced ports&quot; only, while packets to and from &quot;other ports&quot; (such as the ports in the Media Ports range) should be redirected without any modification.</p><h3 id="RTPMultiNAT" tabindex="-1">Multi-IP NAT Method <a class="header-anchor" href="#RTPMultiNAT" aria-label="Permalink to &quot;Multi-IP NAT Method {#RTPMultiNAT}&quot;">​</a></h3><p>You can use the Multi-IP method even if your frontend Servers do not have &quot;real&quot; IP Addresses, but they use &quot;LAN&quot;-type addresses <code>L1</code>, <code>L1</code>, <code>L3</code>, etc.</p><p>Configure the Load Balancer to host real IP Addresses G1, G2, G3,... - in addition to the VIP IP Address used to access CommuniGate Pro services.</p><p>Configure the Load Balancer to &quot;map&quot; its external IP address G1 to the frontend Server address L1, so all packets coming to the IP Address G1, port g (G1:g) are redirected to the frontend Server address L1, same port g (L1:g). The Load Balancer may change the packet target address to L1, or it may leave it as is (G1); When the Load Balancer receives a packet from the L1 address, port l (L1:l), and this port is not a port involved in a load balancing operations (an SMTP, POP, IMAP, SIP, etc.), the Load Balancer should redirect the packet outside, replacing its source address from L1 to G1: L1:l-&gt;G1:l.</p><p>Configure the Load Balancer in the same way to &quot;map&quot; its external IP addresses G2, G3, ... to the other frontend Server IP addresses L2, L3...</p><p>Configure the CommuniGate Pro frontend Servers, using the WebAdmin Settings realm. Open the Network pages, and specify the &quot;mapped&quot; IP addresses as Server-wide WAN IP Addresses: G1 for the frontend Server with L1 IP address, G2 for the frontend Server with L2 IP address, etc.</p>`,86)]))}const f=a(r,[["render",i]]);export{g as __pageData,f as default};
