import{_ as t,a}from"./chunks/ClusterStatic2.87PnKnQv.js";import{_ as r,c as n,o,ag as i}from"./chunks/framework.jCcxW76o.js";const v=JSON.parse('{"title":"Static Clusters","description":"","frontmatter":{"legacyLink":"ClusterStatic.html"},"headers":[],"relativePath":"admin/cluster/Static.md","filePath":"admin/cluster/Static.md"}'),s={name:"admin/cluster/Static.md"};function d(l,e,c,h,u,m){return o(),n("div",null,e[0]||(e[0]=[i('<h1 id="static-clusters" tabindex="-1">Static Clusters <a class="header-anchor" href="#static-clusters" aria-label="Permalink to &quot;Static Clusters&quot;">​</a></h1><p>Static Clusters can be used to handle extremely large (practically unlimited) sites, providing 24x7 site access.</p><p>Static Clusters are <em>loosely-coupled</em> systems: each Server works almost independently of the other Servers. The Static Cluster setup is an extension of the CommuniGate Pro <a href="./../directory/CentralDir.html#Routing">Distributed Domains</a> configuration.</p><p>If a Backend Server fails, the Static Cluster continues to operate, and access to Accounts on the failed Server can be restored within 2-10 minutes (depending on how easily the disk storage can be reassigned and how fast the Routing tables/Directory can be updated, or how quickly a stand-by Server can be switched on).</p><h2 id="Domains" tabindex="-1">Shared Domains <a class="header-anchor" href="#Domains" aria-label="Permalink to &quot;Shared Domains {#Domains}&quot;">​</a></h2><p>Shared Domains in a Static Cluster are created in the same way as regular CommuniGate Pro Domains. Each Server in a Static Cluster contains a subset of all Shared Domain Accounts. As a result, each Shared Domain Account has its &quot;Host Server&quot;. Only the Host Server needs physical access to the Account data, so Static Clusters can use regular, non-shared disk storage. Static Clusters rely on some method that allows each Cluster Server to learn the name of the Host Server for any Shared Domain account. This type of routing can be implemented using a shared Directory Server, in the same way it is implemented for <a href="./../directory/CentralDir.html#Routing">Distributed Domains</a>:</p><p><img src="'+t+'" alt="Static Cluster"></p><h2 id="Config" tabindex="-1">Backend and Frontend Server Settings <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Backend and Frontend Server Settings {#Config}&quot;">​</a></h2><p>To set a Static Cluster:</p><ul><li>Install and <a href="./#Config">configure</a> CommuniGate Pro Software on all Servers that will take part in a Static Cluster.</li><li>Configure all Servers to use one <a href="./../directory/CentralDir.html#SharedDirectory">Shared Directory</a> for all Shared Domains.</li><li>Create Shared Domains on all (Backend and Frontend) Servers in the same way regular, non-shared Domains are created.</li><li>Use the WebAdmin Interface to open the Settings-&gt;General-&gt;Cluster page on each Server, and enter the names (Main Domain Names) of all Backend Servers and the IP addresses of those Servers.</li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Static Clustering</b></td></tr><tr><th align="left">Member Name</th><th align="left">Member Address</th></tr><tr><td><input type="text" name="k0001" value="sv1.isp.com" size="25" maxlength="64"></td><td><input type="text" name="v0001" value="216.200.213.115" size="40" maxlength="500"></td></tr><tr><td><input type="text" name="k0002" value="sv2.isp.com" size="25" maxlength="64"></td><td><input type="text" name="v0002" value="216.200.213.116" size="40" maxlength="500"></td></tr><tr><td><input type="text" name="k0003" value="sv3.isp.com" size="25" maxlength="64"></td><td><input type="text" name="v0003" value="216.200.213.117" size="40" maxlength="500"></td></tr><tr><td><input type="text" name="k999999" value="" size="25" maxlength="64"></td><td><input name="v999999" value="" size="40" maxlength="500" type="text"></td></tr></tbody></table></div></form><p>If an address is routed to a domain listed in this table, the CommuniGate Pro Server uses its Clustering mechanism to connect to the Backend server at the specified address and performs the requested operations on that Backend server.</p><p>The logical setup of the Backend and Frontend Servers is the same - you simply do not create Shared Domain Accounts on any Frontend Server, but create them on your Backend Servers.</p><p>Computers in a Static Cluster can use different operating systems.</p><p>A complete Frontend-Backend Static Cluster configuration uses Load Balancers and several separate networks:</p><p><img src="'+a+'" alt="Static with Frontends"></p><p>In a simplified configuration, you can connect Frontend Servers directly to the Internet, and balance the load using the DNS <em>round-robin</em> mechanism. In this case, it is highly recommended to install a firewall between Frontend and Backend Servers.</p><h2 id="Add" tabindex="-1">Adding Servers to a Static Cluster <a class="header-anchor" href="#Add" aria-label="Permalink to &quot;Adding Servers to a Static Cluster {#Add}&quot;">​</a></h2><p>You can add Frontend and Backend Servers to a Static Cluster at any time.</p><p>To add a Server to a Static Cluster:</p><ul><li>Properly configure the Server (see above): configure it to access the Shared Directory, create Shared Domains, and set the Clustering Settings.</li><li>Add the IP address of the new Server to the Backend or Frontend Addresses tables of other Cluster Members (if you have specified proper network address ranges for those tables, this step is not needed).</li><li>If the new Server is a Backend one, add its name and IP Address to the Static Clustering tables on other Servers.</li></ul><p>After a new Frontend Server is configured and added to the Static Cluster, reconfigure the Load Balancer or the round-robin DNS server to direct incoming requests to the new Server, too.</p><p>After a new Backend Server is configured and added to the Static Cluster, you can start creating Accounts in its Shared Domains.</p><h2 id="Del" tabindex="-1">Withdrawing a Server from a Static Cluster <a class="header-anchor" href="#Del" aria-label="Permalink to &quot;Withdrawing a Server from a Static Cluster {#Del}&quot;">​</a></h2><p>If you decide to shut down a Static Cluster Backend Server, all Accounts hosted on that Server become unavailable. Incoming messages to unavailable Accounts will be collected in the Frontend Server queues, and they will be delivered as soon as the Backend Server is added back or these Accounts become available on a different Backend Server (see below).</p><h2 id="Failover" tabindex="-1">Backend Failover in a Static Cluster <a class="header-anchor" href="#Failover" aria-label="Permalink to &quot;Backend Failover in a Static Cluster {#Failover}&quot;">​</a></h2><p>If a Backend Server in a Static Cluster is shut down, all Accounts hosted on that Server become unavailable (there is no interrupt in service for Accounts hosted on other Backend Servers).</p><p>To restore access to the Accounts hosted on the failed Server, its Account Storage should be connected to any other Backend server. You can either:</p><ul><li>physically connect the disk storage to some other Backend Server;</li><li>use dual-access RAID devices and tell the sibling Server to take over that device;</li><li>use a file server partition or file directory for each Backend Account Storage, and mount that directory on some other Backend Server in case of a Backend Server failure.</li></ul><p>After a sibling Backend server gets physical access to Account Storage of the failed server, you should modify the Directory so all Servers will contact the new &quot;home&quot; for Accounts in that Storage. This can be done by an LDAP utility that modifies all records in the <a href="./../directory/CentralDir.html">Domains Subtree</a> that contain the name of the failed Server as the <code>hostServer</code> attribute value. The utility should set the attribute value to the name of the new Host Server, and should add the <code>oldHostServer</code> attribute with the name of the original Host Server. This additional attribute will allow you to restore the <code>hostServer</code> attribute value after the original Host Server is restored and the Account Storage is reconnected to it. If the CommuniGate Pro is used as the site Directory Server, 500,000 Directory records can be modified within 1-2 minutes.</p>',30)]))}const f=r(s,[["render",d]]);export{v as __pageData,f as default};
