import{_ as t,a as s,b as i}from"./chunks/SFSCFS.EQTSUlXL.js";import{_ as o,c as a,o as r,ag as n}from"./chunks/framework.jCcxW76o.js";const y=JSON.parse('{"title":"Cluster Storage","description":"","frontmatter":{"legacyLink":"ClusterStorage.html"},"headers":[],"relativePath":"admin/cluster/Storage.md","filePath":"admin/cluster/Storage.md"}'),l={name:"admin/cluster/Storage.md"};function h(c,e,d,m,u,p){return r(),a("div",null,e[0]||(e[0]=[n('<h1 id="cluster-storage" tabindex="-1">Cluster Storage <a class="header-anchor" href="#cluster-storage" aria-label="Permalink to &quot;Cluster Storage&quot;">​</a></h1><p>The CommuniGate Pro Dynamic Clusters require <em>Shared File Systems</em>, so backend Cluster members can work with the same data files at the same time.</p><p>The most popular and well-known implementation of a Shared File System is a file server, also called NAS (<em>network attached storage</em>).</p><p>This section provides a brief overview of Shared File System technologies, explains why SAN (SAN (<em>storage area network</em>) is <strong>not</strong> a Shared File System, and provides an introduction to Cluster File Systems that can be used to build Shared File Systems using SAN.</p><h2 id="FileSystems" tabindex="-1">Storage Systems and File Systems <a class="header-anchor" href="#FileSystems" aria-label="Permalink to &quot;Storage Systems and File Systems {#FileSystems}&quot;">​</a></h2><p>The Storage Systems (such as disk devices) used today are &quot;dumb&quot; devices from the user and application point of view. Each system or a device has some number of <em>blocks</em> - fixed-size data segments, for example 1K (1024 bytes) in size. When the disk device is connected to a computer, it can process only very simple requests, such as:</p><ul><li>READBLOCK(12345) - read the block number 12345 and send the block data to the computer.</li><li>WRITEBLOCK(765645) - receive the data from the computer and store them in the block number 765645.</li></ul><p>Disks can be connected to computers using IDE, SCSI, or FDDI interfaces. These interfaces are used to send commands and data to the disks, and to retrieve the data and command completion codes from the disks.</p><p>Storage Systems themselves do not create any other structures, meaning that a disk device cannot create &quot;files&quot; or &quot;file directories&quot;. The only thing these systems work with are blocks, and all they can do is read and write those blocks.</p><h2 id="Single" tabindex="-1">Single OS File Systems <a class="header-anchor" href="#Single" aria-label="Permalink to &quot;Single OS File Systems {#Single}&quot;">​</a></h2><p>Every modern Operating System (OS) has a component called a <em>File System</em>. That component is part of the OS <em>kernel</em> and it implements things like &quot;files&quot; and &quot;file directories&quot;.</p><p>There are many different File Systems, and they use various methods and algorithms, but the same basic functions are present in most File Systems:</p><ul><li>The File System maintains some sort of FAT (File Allocation Table) - information that associates logical files with storage block numbers. For example, the FAT can specify that the &quot;File1&quot; file is stored in 5 disk blocks with numbers 123400,123405,123401,177777,123456 and the &quot;File2&quot; file is stored in 6 disk blocks with numbers 323400,323405,323401,377777,323456, 893456.</li><li>The File System maintains a list of all unused storage blocks and it automatically <em>allocates</em> new blocks when the file grows in size, and returns blocks into the list of unused blocks when a file decreases in size or when a file is deleted.</li><li>The File System processes application requests that need to read from or write to logical files. The File System converts these requests into one or several storage block read and write operations, using the information in the File Allocation Table.</li><li>The File System maintains special files called &quot;file directories&quot; and stores the information about other files in these directories.</li><li>The File System maintains the &quot;file cache.&quot; When new information is written to a file, it stores it in the Storage System (on disks) and it also copies this information into the File System &quot;cache buffers&quot;.<br> When file information is read from storage, it passes it to the application program and also copies it into the &quot;cache buffers&quot;<br> When the same (or some other) application needs to read the same portion of the cached file, the File System simply retrieves that information from its cache buffers instead of re-reading it from the Storage System.</li></ul><p>The following figure illustrates how a File System works:</p><p><img src="'+t+'" alt="Single OS File System"></p><p>In this example, the File System serves requests from two applications.</p><ul><li><p><strong>Application 1 asks the File System to read block number 5 from <code>File1</code>.</strong></p><p>The File System finds the information for File1 in the File Allocation Table, and detects that this file has 5 blocks allocated, and file block number 5 is stored in the block number 123456 on the disk.</p><p>The File System uses the disk interface (IDE, SCSI, or any other one) to send the READBLOCK(123456) command to the disk.</p><p>The disk device sends the information from the specified block to the computer.</p><p>The File System places the read information into its cache buffers, and sends it to the application.</p></li><li><p><strong>Application 2 asks the File System to write block number 7 into <code>File2</code>.</strong></p><p>The File System finds the information for File2 in the File Allocation Table, and detects that this file has 6 blocks allocated. It checks the list of the unused disk blocks, and finds the unused block number 13477.</p><p>It removes the block number from the list of unused blocks and adds it as the 7th block to the File2 information in the File Allocation Table, so now File2 is 7 blocks in size.</p><p>The File System uses the disk interface (IDE, SCSI, or any other one) to send the WRITEBLOCK(13477) command to the disk, and sends the block data that the application program has composed.</p><p>The disk device writes the block data into the specified disk block, and confirms the operation.</p><p>The File System copies the block data information into its cache buffers.</p></li></ul><p>If any application tries to read block 5 from File1 or block 7 from File2, the File System will retrieve the information from its cache buffers, and it will not perform any disk operation.</p><p>All applications running on this operating system use the same File System. The File System guarantees the data consistency. If the disk block 13477 is allocated to File2, it will not be allocated to any other file - until File2 is deleted or is decreased in size to less than 7 blocks.</p><h2 id="NAS" tabindex="-1">Network File System (NAS) <a class="header-anchor" href="#NAS" aria-label="Permalink to &quot;Network File System (NAS) {#NAS}&quot;">​</a></h2><p>When server computers need to use the same data, a Network File System (also called NAS, or Network Attached Storage) can be used.</p><p>The Network File System is implemented using a <em>File Server</em> and a <em>network</em>. The File Server is a regular computer or specialized OS that has a regular File System and regular disk devices controlled with this File System.</p><p>The Network File System &quot;stubs&quot; running inside the OS kernel on &quot;client&quot; computers are &quot;dummy&quot; File Systems that retranslate application file requests to the File Server, using the network:</p><p><img src="'+s+'" alt="NAS Shared File System"></p><p>In this example, the File System on the File Server serves requests from several applications running on server &quot;client&quot; computers.</p><p>The only difference with the single OS is in the request delivery; instead of internal communication between an application and the File System running inside the OS kernel, the &quot;stub&quot; sends the requests via the network, receives the responses, and passes them to the application. All &quot;real work&quot; (File Allocation Table and cache maintenance) is done on the File Server computer.</p><p>Since only the File Server computer has direct access to the physical disk, all applications running on server systems use the same File System - the File System running on the File Server. That File System guarantees the data consistency. If the disk block 13477 is allocated to File2, it will not be allocated to any other file - until File2 is deleted or is decreased in size to less than 7 blocks.</p><h2 id="SAN" tabindex="-1">Storage Area Network <a class="header-anchor" href="#SAN" aria-label="Permalink to &quot;Storage Area Network {#SAN}&quot;">​</a></h2><p>Storage Area Network is a special type of network that connects computers and disk devices; in the same way as SCSI cables connect disk devices to one computer.</p><p>Any computer connected to SAN can send disk commands to any disk device connected to the same SAN. On the physical level, SAN can be implemented using FDDI, Ethernet, or other types of networks.</p><p>Some disk drives or arrays have &quot;dual-channel&quot; SCSI controllers and can be connected to two computers using regular SCSI cables. Since both computers can send disk read/write commands to that shared disk, this configuration has the same functionality as a one-disk SAN.</p><p>SAN provides Shared Disks, but SAN itself does not provide a Shared File System. If you have several computers that have access to a Shared Disk (via SAN or dual-channel SCSI), and try to use that disk with a regular File System, the disk logical structure will be damaged very quickly.</p><p>There are two main problems with Shared Disks and regular File Systems:</p><ul><li><p><strong>Disk Space Allocation inconsistency</strong></p><p>If computer X and computer Y both connected (&quot;mounted&quot;) a shared disk, their File Systems loaded the File Allocation Tables into each computer&#39;s memory. Now, if some program running on computer X tried to write a new block to some file, the File System running on that computer will check its File Allocation Table and free blocks list, and it will allocate a new file block number 13477 to that file.</p></li></ul><p>The File System running on that computer will modify its File Allocation Table, but it will have no effect on the File Allocation Tables loaded on other computers. If an application running on some other computer Y needs to expand a file, the File System running on that computer may allocate the same block 13477 to that other file, since it has no idea that this block has been already allocated by computer X.</p><ul><li><p><strong>File Data inconsistency</strong></p><p>If a program running on computer X has read block 5 from some File1, that block is copied into the computer X File System Cache. If the same or another program running on computer X tries to read the same block 5 from the same file, the computer X File System will simply copy data from its cache.</p></li></ul><p>A program running on some other computer Y can modify the information in the block 5 of File1. Since the File System running on computer X is not aware of this fact, it will continue to use its cache providing computer X applications with data that is no longer valid.</p><p>These problems make it impossible to use Shared Disks with regular File Systems as Shared File Systems. They can be used for fail-over systems or in any other configuration where only one computer is actually using the disk at any given time. The File System on computer Y starts to process the Shared Disk only when computer X has been shutdown, or stopped using the Shared Disk.</p><h2 id="CFS" tabindex="-1">Cluster File System <a class="header-anchor" href="#CFS" aria-label="Permalink to &quot;Cluster File System {#CFS}&quot;">​</a></h2><p>Cluster File Systems are software products designed to solve the problems outlined above. They allow you to build multi-computer systems with Shared Disks, solving the inconsistency problems.</p><p>Cluster File Systems are usually implemented as &quot;wrapper&quot; around some regular File System. Cluster File Systems use some kind of inter-server network to talk to each other and to synchronize their activities. That inter-server &quot;interconnect&quot; can be implemented using regular Ethernet networks, using the same SAN that connects computers and disks, or using special fast, low-latency &quot;cluster interconnect&quot; devices.</p><p><img src="'+i+'" alt="Cluster File System"></p><p>In this example, the Cluster File System is installed on several computers and serves requests from applications running on these computers.</p><ul><li><p><strong>Application 1 running on the first computer asks the Cluster File System to read block number 5 from <code>File1</code>.</strong></p><p>The Cluster File system passes the request to the regular File System serving the Shared Disk, and the data block is read in the same way it is read on a single-server system.</p></li><li><p><strong>Application 2 running on a different system asks the Cluster File System to write block number 7 into <code>File2</code>.</strong></p><p>The Cluster file system uses the inter-server network to notify the Cluster File Systems on other computers that this block is being modified. The Cluster File Systems remove the old, obsolete copy of the block data from their caches.</p><p>The Cluster File System passes the request to the regular File System. It finds the information for File2 in the File Allocation Table, and detects that this file has 6 blocks allocated. It checks the list of unused disk blocks, and finds unused block number 13477. It removes the block number from the list of unused blocks and adds it as the 7th block to the File2 information in the File Allocation Table, so now File2 is 7 blocks in size.</p><p>The Cluster File System uses the inter-server network to notify the Cluster File Systems on other computers about the File Allocation Table modification. The Cluster File Systems on those computers update their File Allocation Tables to keep them in sync.</p><p>The File System uses the disk interface to send the WRITEBLOCK(13477) command to the Shared Disk, and sends the block data that the application program has composed.</p><p>The disk device writes the block data into the specified disk block, and confirms the operation.</p></li></ul><p>The Cluster File System solves the inconsistency problems and allows several computers to use Shared Disk(s) as Shared File System.</p><p>Cluster File System products are available for several Operating Systems:</p><table tabindex="0"><thead><tr><th>Cluster File System</th><th>Operating System</th></tr></thead><tbody><tr><td>VERITAS Cluster File System</td><td>Sun Solaris</td></tr><tr><td>Sun Cluster 3.0</td><td>Sun Solaris</td></tr><tr><td>Generalized Parallel File System (GPFS)</td><td>IBM AIX, Linux</td></tr><tr><td><a href="http://www.dataplow.com/" target="_blank" rel="noreferrer">DataPlow</a></td><td>Linux, Solaris, Windows</td></tr><tr><td>PolyServe</td><td>Linux</td></tr><tr><td>GFS</td><td>Linux</td></tr></tbody></table>',47)]))}const k=o(l,[["render",h]]);export{y as __pageData,k as default};
