import{_ as i,a as l,b as d}from"./chunks/ClusterCluster.CKcII2gb.js";import{_ as u,C as c,c as h,o as m,ag as a,j as e,G as n,w as r,a as s}from"./chunks/framework.jCcxW76o.js";const W=JSON.parse('{"title":"Clusters","description":"","frontmatter":{"legacyLink":"Clusters.html"},"headers":[],"relativePath":"admin/cluster/index.md","filePath":"admin/cluster/index.md"}'),p={name:"admin/cluster/index.md"},v={action:"Null.html"},f={class:"settingsBox"},g={width:"100%"},y={align:"right"},S={align:"right"},P={align:"right"},b={align:"right"},C={align:"right"},T={align:"right"},w={align:"right"},k={align:"right"},I={align:"right"},A={align:"right"},D={align:"right"},F={align:"right"},x={align:"right"};function q(B,t,L,M,O,R){const o=c("tt");return m(),h("div",null,[t[45]||(t[45]=a('<h1 id="clusters" tabindex="-1">Clusters <a class="header-anchor" href="#clusters" aria-label="Permalink to &quot;Clusters&quot;">​</a></h1><p>When your CommuniGate Pro system should serve more than 150,000-200,000 Accounts, or when you expect a really heavy SIP/IMAP/WebMail/MAPI traffic, you should consider using a multi-server <em>Cluster configuration</em>.</p><h2 id="Terminology" tabindex="-1">Terminology <a class="header-anchor" href="#Terminology" aria-label="Permalink to &quot;Terminology {#Terminology}&quot;">​</a></h2><p>If your site serves many Domains, you may want to install several independent CommuniGate Pro Servers and distribute the load by distributing domains between the servers. In this case you do not need to employ the special Cluster Support features. However if you have one or several Domains with 100,000 or more Accounts in each, and you cannot guarantee that clients will always connect to the proper server, or if you need dynamic load balancing and very high availability, you should implement a CommuniGate Pro Cluster on your site.</p><p>Many vendors use the term <em>Cluster</em> for simple <em>fail-over</em> or <em>hot stand-by</em> configurations. The CommuniGate Pro software can be used in fail-over, as well as in <a href="./../directory/CentralDir.html#Routing">Distributed Domains</a> configurations, however these configurations are not referred to as <em>Cluster configurations</em>.</p><p>A CommuniGate Pro Cluster is a set of Server computers that handle the site mail load together. Each Cluster Server hosts a set of regular, non-shared domains (the CommuniGate Pro Main Domain is always a non-shared one), and it also serves (together with other Cluster Servers) a set of Shared Domains.</p><p>To use CommuniGate Pro servers in a Cluster, you need a special CommuniGate Pro <a href="http://www.communigatepro.ru/CGPLicensing.html" target="_blank" rel="noreferrer">Cluster License</a>.</p><p>Please read the <a href="./../sysadmin/Scalability.html">Scalability</a> section first to learn how to estimate your Server load, and how to get most out of each CommuniGate Pro Server running in the Single-server or in the Cluster mode.</p><h2 id="Types" tabindex="-1">Cluster Types <a class="header-anchor" href="#Types" aria-label="Permalink to &quot;Cluster Types {#Types}&quot;">​</a></h2><p>There are two main types of Cluster configurations: <em>Static</em> and <em>Dynamic</em>.</p><p>Each Account in a Shared Domain served with a Static Cluster is created (hosted) on a certain Server, and only that Server can access the account data directly. When a Static Cluster Server needs to perform any operation with an account hosted on a different Server, it establishes a TCP/IP connection with the account Host Server and accesses account data via that Host Server. This architecture allows you to use local (i.e. non-shared) storage devices for account data.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some vendors have &quot;Mail Multiplexor&quot;-type products. Those products usually implement a subset of Static Cluster Frontend functionality.</p></div><p>Accounts in Shared Domains served with a Dynamic Cluster are stored on a shared storage, so each Cluster Server (except for Frontend Servers, see below) can access the account data directly. At any given moment, one of the Cluster Servers acts as a Cluster Controller synchronizing access to Accounts in Shared Domains. When a Dynamic Cluster Server needs to perform any operation with an account currently opened on a different Server, it establishes a TCP/IP connection with that &quot;current host&quot; Server and accesses account data via that Server. This architecture provides the highest availability (all accounts can be accessed as long as at least one Server is running), and does not require file-locking operations on the storage device.</p><h2 id="Protocols" tabindex="-1">Supported Services <a class="header-anchor" href="#Protocols" aria-label="Permalink to &quot;Supported Services {#Protocols}&quot;">​</a></h2><p>The CommuniGate Pro Clustering features support the following services:</p><ul><li>SMTP mail receiving</li><li>SMTP mail delivery</li><li>SIP signaling</li><li>XIMSS access</li><li>WebUser Interface access</li><li>XMPP signaling</li><li>POP3 access</li><li>IMAP access</li><li>FTP</li><li>RADIUS</li><li>TFTP</li><li>HTTP access to File Storage (including uploading)</li><li>ACAP access</li><li>PWD access and remote administration</li><li>CG/PL inter-task communication</li><li>HTTP request to external servers</li><li>RPOP polling</li><li>Remote SIP Registrations</li><li>Cluster-wide Directory Units</li></ul><h2 id="Frontends" tabindex="-1">Frontend Servers <a class="header-anchor" href="#Frontends" aria-label="Permalink to &quot;Frontend Servers {#Frontends}&quot;">​</a></h2><p>Clusters of both types are usually equipped with <em>Frontend Servers</em>. Frontend Servers cannot access Account data directly - they always open connections to other (Backend) Servers to perform any operation with Account data.</p><p>Frontend servers accept TCP/IP connections from client computers (usually - from the Internet). In a pure Frontend-Backend configuration no Accounts are created on any Frontend Server, but nothing prohibits you from serving some Domains (with Accounts and mailing lists) directly on the Frontend servers.</p><p>When a client establishes a connection with one of the Frontend Servers and sends the authentication information (the Account name), the Frontend server detects on which Backend server the addressed Account can be opened, and establishes a connection with that Backend Server.</p><p>The Frontend Servers:</p><ul><li>handle all SSL/TLS encryption/decryption operations</li><li>implement SIP Farm functionality, and most of SIP protocol features, including NAT Traversal</li><li>handle most of the SMTP relaying operations themselves</li><li>run Real-Time CG/PL applications and Media Server Channels</li><li>virtually eliminate inter-server communications between Backend Servers, and (in Dynamic Clusters) provide second-level load balancing</li><li>provide an additional layer of protection against Internet attacks and allow you to avoid exposing Backend Servers to the Internet</li><li>smooth out the external traffic (soften peaks in the site load), and protect the Backend Servers from the Denial-of-Service attacks</li><li>execute outgoing HTTP requests.</li><li>execute outgoing Remote SIP Registration tasks.</li><li>execute outgoing Remote POP (RPOP) polling sessions.</li></ul><p>If the Frontend Servers are directly exposed to the Internet, and the security of a Frontend Server operating system is compromised so that someone gets unauthorized access to that Server OS, the security of the site is not totally compromised. Frontend Servers do not keep any Account information (Mailboxes, passwords) on their disks. The &quot;cracker&quot; would then have to go through the firewall and break the security of the Backend Server OS in order to get access to any Account information. Since the network between Frontend and Backend Servers can be disabled for all types of communications except the CommuniGate Pro inter-server communications, breaking the Backend Server OS is virtually impossible.</p><p>Both Static and Dynamic Clusters can work without dedicated Frontend Servers. This is called a <em>symmetric configuration</em>, where each Cluster Server implements both Frontend and Backend functions.</p><p>In the example below, the domain1.dom and domain2.dom Domain Accounts are distributed between three Static Cluster Servers, and each Server accepts incoming connections for these Domains. If the Server SV1 receives a connection for the Account <code>kate@domain1.dom</code> located on the Server SV2, the Server SV1 starts to operate as a Frontend Server, connecting to the Server SV2 as the Backend Server hosting the addressed Account.<br> At the same time, an external connection established with the server SV2 can request access to the <code>ada@domain1.dom</code> Account located on the Server SV1. The Server SV2 acting as a Frontend Server will open a connection to the Server SV1 and will use it as the Backend Server hosting the addressed Account.</p><p>In a symmetric configuration, the number of inter-server connections can be equal to the number of external (user) access-type (POP, IMAP, HTTP) connections. For a symmetric Static Cluster, the average number of inter-server connections is M*(N-1)/N, where M is the number of external (user) connections, and the N is the number of Servers in the Static Cluster. For a symmetric Dynamic Cluster, the average number of inter-Server connections is M*(N-1)/N * A/T, where T is the total number of Accounts in Shared Domains, and A is the average number of Accounts opened on each Server. For large ISP-type and portal-type sites, the A/T ratio is small (usually - not more than 1:100).</p><p>In a pure Frontend-Backend configuration, the number of inter-server connections is usually the same as the number of external (user) connections: for each external connection, a Frontend Server opens a connection to a Backend Server. A small number of inter-server connections can be opened between Backend Servers, too.</p><h3 id="FrontendDel" tabindex="-1">Withdrawing Frontend Servers from a Cluster <a class="header-anchor" href="#FrontendDel" aria-label="Permalink to &quot;Withdrawing Frontend Servers from a Cluster {#FrontendDel}&quot;">​</a></h3><p>To remove a Frontend Server from a Cluster (for maintenance, hardware upgrade, etc.), reconfigure your Load Balancer or the round-robin DNS server to stop redirection of incoming requests to this Frontend Server address. After all current POP, IMAP, SMTP sessions are closed, the Frontend Server can be shut down. Since the WebMail sessions do not use persistent HTTP connections, a Frontend Server in a WebMail-only Cluster can be shut down almost immediately.</p><p>Access to all Shared Domain Accounts is provided without interruption as long as at least one Frontend Server is running.</p><p>If a Frontend server fails, no Account becomes unavailable and no mail is lost. While POP and IMAP sessions conducted via the failed Frontend server are interrupted, all WebUser Interface session remain active, and WebUser Interface clients can continue to work via remaining Frontend Servers. POP and IMAP users can immediately re-establish their connections via remaining Frontend Servers.</p><p>If the failed Frontend server cannot be repaired quickly, its Queue can be processed with a different server, as a <a href="./../mail/PIPE.html#ForeignQueue">Foreign Queue</a>.</p><h2 id="Config" tabindex="-1">Cluster Server Configuration <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Cluster Server Configuration {#Config}&quot;">​</a></h2><p>This section specifies how each CommuniGate Pro Server should be configured to participate in a Static or Dynamic Cluster. These settings control inter-server communications in your Cluster.</p><p>First, install CommuniGate Pro Software on all Servers that will take part in your Cluster. Specify the Main Domain Name for all Cluster Servers. Those names should differ in the first domain name element only: <code>back1.isp.dom</code>, <code>back2.isp.dom</code>, <code>front1.isp.dom</code>, <code>front2.isp.dom</code>, etc.</p><p>Remember that Main Domains are never shared, so all these names should be different. You may want to create only the Server administrator accounts in the Main Domains - these accounts can be used to connect to that particular Server and configure its local, Server-specific settings.</p><h3 id="ConfNetwork" tabindex="-1">Cluster Network <a class="header-anchor" href="#ConfNetwork" aria-label="Permalink to &quot;Cluster Network {#ConfNetwork}&quot;">​</a></h3><p>Use the WebAdmin Interface to open the Settings-&gt;General-&gt;Cluster page on each Backend and Frontend Server, and enter all Frontend and Backend Server IP addresses. CommuniGate Pro Servers will accept Cluster connections from the specified IP addresses only. If the Frontend Servers use dedicated Network Interface Cards (NICs) to communicate with Backend Servers, specify the IP addresses the Frontend Servers have on that internal network:</p>',38)),t[46]||(t[46]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Cluster Network")])]),e("tr",null,[e("td",{align:"right"},"This Server Cluster Address:"),e("td",{colspan:"3",align:"center"},[e("table",{border:"0",cellpadding:"0",cellspacing:"2"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,"On restart"),e("td",null,"Active")]),e("tr",null,[e("td",null,[e("select",{name:"ControlAddress"},[e("option",{value:"[192.168.0.5]",selected:"selected"},"[192.168.0.5]"),e("option",{value:"[10.0.0.5]"},"[10.0.0.5]"),e("option",null,"[127.0.0.1]")])]),e("td",null,"[192.168.0.5]")])])])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Backend Server Addresses:"),e("td",{colspan:"3"},[e("textarea",{style:{"font-size":"9pt"},name:"BackendAddresses",rows:"4",cols:"40"},"192.168.0.4-192.168.0.8; this is a comment")])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Frontend Server Addresses:"),e("td",{colspan:"3"},[e("textarea",{style:{"font-size":"9pt"},name:"FrontendAddresses",rows:"4",cols:"40"},"192.168.0.1-192.168.0.3")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Dynamic Cluster Locker Log:"),e("td",null,[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",nowrap:"nowrap"},"Load Balancer Group:"),e("td",null,[e("select",{name:"BalancerGroup"},[e("option",{value:""}),e("option",{value:"A"},"A"),e("option",{value:"B",selected:"selected"},"B"),e("option",{value:"C"},"C"),e("option",{value:"D"},"D")])])])])])])],-1)),t[47]||(t[47]=a('<ul><li><p><code>This Server Cluster Address</code></p><p>This setting specifies the local network address this Server will use to communicate with other Servers in the Cluster. Connections to other Servers will be established from this IP address. This address is used as this Server &quot;name&quot;, identifying the Server in the Cluster.</p></li></ul><p>If you change this setting value, the new value will be in effect only after Server restart.</p><h3 id="ConfCommunication" tabindex="-1">Cluster Communication <a class="header-anchor" href="#ConfCommunication" aria-label="Permalink to &quot;Cluster Communication {#ConfCommunication}&quot;">​</a></h3><p>In all types of CommuniGate Pro cluster, connections to Backend servers can be established from Frontend servers and from other Backend servers.</p><p>If your Backend Servers use non-standard port numbers for its services, change the Backend Server Ports values.</p><p>For example, if your Backend Servers accept <a href="./../access/WebUser.html">WebUser Interface</a> connections not on the port number 8100, but on the standard HTTP port 80, set 80 in the <code>HTTP User</code> field and click the Update button.</p>',6)),e("form",v,[e("div",f,[e("table",g,[e("tbody",null,[t[42]||(t[42]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Inter-Cluster Communications")])],-1)),t[43]||(t[43]=e("tr",null,[e("th",{colspan:"2"},"Backend Port"),e("th",{align:"left"},"Cache"),e("th",{colspan:"2"},"Backend Port"),e("th",{align:"left"},"Cache")],-1)),e("tr",null,[e("td",y,[n(o,null,{default:r(()=>t[0]||(t[0]=[s("Delivery:")])),_:1})]),t[2]||(t[2]=e("td",null,[e("input",{name:"DeliveryPort",value:"25",size:"5",maxlength:"5",type:"text"})],-1)),t[3]||(t[3]=e("td",null,[e("select",{name:"DeliveryCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"150"},"150"),e("option",{value:"200"},"200"),e("option",{value:"250"},"250")])],-1)),e("td",S,[n(o,null,{default:r(()=>t[1]||(t[1]=[s("Submit:")])),_:1})]),t[4]||(t[4]=e("td",null,[e("input",{name:"SubmitPort",value:"25",size:"5",maxlength:"5",type:"text"})],-1)),t[5]||(t[5]=e("td",null,[e("select",{name:"SubmitCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5",selected:"selected"},"5"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"150"},"150"),e("option",{value:"200"},"200"),e("option",{value:"250"},"250")])],-1))]),e("tr",null,[e("td",P,[n(o,null,{default:r(()=>t[6]||(t[6]=[s("POP:")])),_:1})]),t[8]||(t[8]=e("td",null,[e("input",{name:"POPPort",value:"110",size:"5",maxlength:"5",type:"text"})],-1)),t[9]||(t[9]=e("td",null," ",-1)),e("td",b,[n(o,null,{default:r(()=>t[7]||(t[7]=[s("IMAP:")])),_:1})]),t[10]||(t[10]=e("td",null,[e("input",{name:"IMAPPort",value:"143",size:"5",maxlength:"5",type:"text"})],-1)),t[11]||(t[11]=e("td",null," ",-1))]),e("tr",null,[e("td",C,[n(o,null,{default:r(()=>t[12]||(t[12]=[s("HTTPU:")])),_:1})]),t[14]||(t[14]=e("td",null,[e("input",{name:"HTTPUserPort",value:"8100",size:"5",maxlength:"5",type:"text"})],-1)),t[15]||(t[15]=e("td",null," ",-1)),e("td",T,[n(o,null,{default:r(()=>t[13]||(t[13]=[s("HTTPA:")])),_:1})]),t[16]||(t[16]=e("td",null,[e("input",{name:"HTTPAdminPort",value:"8010",size:"5",maxlength:"5",type:"text"})],-1)),t[17]||(t[17]=e("td",null," ",-1))]),e("tr",null,[e("td",w,[n(o,null,{default:r(()=>t[18]||(t[18]=[s("XIMSS:")])),_:1})]),t[20]||(t[20]=e("td",null,[e("input",{name:"XIMSSPort",value:"11024",size:"5",maxlength:"5",type:"text"})],-1)),t[21]||(t[21]=e("td",null," ",-1)),e("td",k,[n(o,null,{default:r(()=>t[19]||(t[19]=[s("XMPP:")])),_:1})]),t[22]||(t[22]=e("td",null,[e("input",{name:"XMPPPort",value:"5222",size:"5",maxlength:"5",type:"text"})],-1)),t[23]||(t[23]=e("td",null," ",-1))]),e("tr",null,[e("td",I,[n(o,null,{default:r(()=>t[24]||(t[24]=[s("PWD:")])),_:1})]),t[26]||(t[26]=e("td",null,[e("input",{name:"PWDPort",value:"106",size:"5",maxlength:"5",type:"text"})],-1)),t[27]||(t[27]=e("td",null," ",-1)),e("td",A,[n(o,null,{default:r(()=>t[25]||(t[25]=[s("LDAP:")])),_:1})]),t[28]||(t[28]=e("td",null,[e("input",{name:"LDAPPort",value:"389",size:"5",maxlength:"5",type:"text"})],-1)),t[29]||(t[29]=e("td",null," ",-1))]),t[44]||(t[44]=e("tr",null,[e("th",{colspan:"2"},"Log Level"),e("th",{align:"left"},"Cache"),e("th",{colspan:"2"},"Log Level"),e("th",{align:"left"},"Cache")],-1)),e("tr",null,[e("td",D,[n(o,null,{default:r(()=>t[30]||(t[30]=[s("Object Admin:")])),_:1})]),t[32]||(t[32]=e("td",null,[e("select",{name:"AdminLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])],-1)),t[33]||(t[33]=e("td",null,[e("select",{name:"AdminCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"150"},"150"),e("option",{value:"200"},"200"),e("option",{value:"250"},"250")])],-1)),e("td",F,[n(o,null,{default:r(()=>t[31]||(t[31]=[s("Mailboxes:")])),_:1})]),t[34]||(t[34]=e("td",null,[e("select",{name:"SingleImageLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])],-1)),t[35]||(t[35]=e("td",null,[e("select",{name:"MailboxCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"150"},"150"),e("option",{value:"200"},"200"),e("option",{value:"250"},"250")])],-1))]),e("tr",null,[e("td",x,[n(o,null,{default:r(()=>t[36]||(t[36]=[s("Cluster Admin:")])),_:1})]),t[37]||(t[37]=e("td",null,[e("select",{name:"MailboxLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])],-1)),t[38]||(t[38]=e("td",null," ",-1)),t[39]||(t[39]=e("td",{align:"right"},null,-1)),t[40]||(t[40]=e("td",null," ",-1)),t[41]||(t[41]=e("td",null," ",-1))])])])])]),t[48]||(t[48]=a('<p>CommuniGate Pro can reuse inter-server connections for some services. Instead of closing a connection when an operation is completed, the connection is placed into an internal cache, and it is reused later, when this server needs to connect to the same server. The Cache parameter specifies the size of that connection cache. If there are too many connections in the cache, older connection are closed and pushed out of the cache.</p><p>Cluster members use the PWD protocol to perform administration operations remotely, on other cluster members. The port number they use to connect to on other Cluster members is the same as the port specified for the PWD protocol connections. These remote administrative operations have their own Log Level settings.</p><p>Servers in a Dynamic Cluster use the SMTP modules of other Cluster Backend members for remote message delivery (though the protocol between the servers is not the SMTP protocol). Use the <code>Delivery</code> port setting to specify the port number used with SMTP modules on other cluster members.</p><p>Servers in a Dynamic Cluster use the SMTP modules of other Cluster members to submit messages remotely (though the protocol between the servers is not the SMTP protocol). Use the <code>Submit</code> port setting to specify the port number used with SMTP modules on other cluster members.</p><p>When a user session running on one Cluster member needs to access a <em>foreign Mailbox</em>, and the account that this Mailbox belongs to cannot be opened by the same Cluster member, the Cluster Mailbox manager is used to access Mailboxes remotely. The Cluster Mailbox manager uses the IMAP port to connect to other cluster members. The Cluster Mailbox manager has its own Log Level setting.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Service Processing</b></td></tr><tr><td align="RIGHT" width="25%">HTTP Client:</td><td align="LEFT"><select name="HTTPClientMode"><option value="Auto" selected="selected">Auto</option><option value="Remotely">Remotely</option><option value="Locally">Locally</option><option value="Locally for Others">Locally for Others</option></select></td><td align="RIGHT" width="25%">RPOP Client:</td><td align="LEFT"><select name="RPOPClientMode"><option value="Auto" selected="selected">Auto</option><option value="Remotely">Remotely</option><option value="Locally">Locally</option><option value="Locally for Others">Locally for Others</option></select></td></tr></tbody></table></div></form><p>When a Cluster is configured so that only the frontend servers can access the Internet, certain services can run on those frontend servers only.</p><ul><li><p><code>HTTP Client</code></p><p>This setting specifies how the outgoing HTTP requests (initiated with <a href="./../../development/XMLAPI.html">XIMSS</a> sessions, <a href="./../../development/CGPL.html">CG/PL</a> applications, <a href="./../../development/Rules.html">Automated Rules</a>, etc.) are executed.</p><ul><li><p><code>Locally</code></p><p>when there is an HTTP request to execute, it is executed on the same Server (this is the &quot;regular&quot;, single-server processing mode).</p></li><li><p><code>Locally for Others</code></p><p>HTTP requests are executed on the same Server.<br> The Dynamic Cluster Controller is informed that this Server can execute HTTP requests for other Cluster members.<br> The Dynamic Cluster Controller collects and distributes information about all active Cluster members that have this option selected.</p></li><li><p><code>Remotely</code></p><p>when there is an HTTP request to execute, a request is relayed to some Cluster member that has this setting set to Locally for Others.</p></li><li><p><code>Auto</code></p><ul><li>if this Server is not a Dynamic Cluster member, same as <code>Locally</code></li><li>if this Server is a Dynamic Cluster frontend, same as <code>Locally for Others</code></li><li>if this Server is a Dynamic Cluster backend, same as <code>Remotely</code> if there are other Dynamic Cluster members configured as <code>Locally for Others</code>, if there are none - same as <code>Locally</code></li></ul></li></ul></li><li><p><code>RPOP Client</code></p><p>This setting specifies how the outgoing <a href="./../mail/RPOP.html">RPOP</a> requests are executed. The setting values have the same meanings as the HTTP Client setting values.</p></li></ul><h2 id="IPAddresses" tabindex="-1">Assigning IP Addresses to Shared Domains <a class="header-anchor" href="#IPAddresses" aria-label="Permalink to &quot;Assigning IP Addresses to Shared Domains {#IPAddresses}&quot;">​</a></h2><p>A CommuniGate Pro Cluster can serve several Shared Domains. If you plan to provide POP and IMAP access to Accounts in those Domains, you may want to assign dedicated IP addresses to those Domains to simplify client mailer setups. See the <a href="./../access/">Access</a> section for more details.</p><p>If you use Frontend Servers, only Frontend Servers should have dedicated IP Addresses for Shared Domains. Inter-server communications always use full account names (<em>accountname@domainname</em>), so there is no need to dedicate IP Addresses to Shared Domains on Backend Servers.</p><p>If you use the DNS round-robin mechanisms to distribute the site load, you need to assign N IP addresses to each Shared Domain that needs dedicated IP addresses, where N is the number of your Frontend Servers. Configure the DNS Server to return these addresses in the round-robin manner:</p><p><img src="'+i+'" alt="IP Addresses w/o Load Balancer"></p><p>In this example, the Cluster is serving two Shared Domains: <code>domain1.dom</code> and <code>domain2.dom</code>, and the Cluster has three Frontend Servers. Three IP addresses are assigned to each domain name in the DNS server tables, and the DNS server returns all three addresses when a client is requesting A-records for one of these domain names. Each time the DNS server &quot;rotates&quot; the order of the IP addresses in its responses, implementing the DNS &quot;round-robin&quot; load balancing (client applications usually use the first address in the DNS server response, and use other addresses only if an attempt to establish a TCP/IP connection with the first address fails).</p><p>When configuring these Shared Domains in your CommuniGate Pro Servers, you assign all three IP addresses to each Domain.</p><p>If you use a Load Balancer to distribute the site load, you need to place only one &quot;external&quot; IP address into DNS records describing each Shared Domain. You assign one &quot;virtual&quot; (LAN) IP address to each Shared Domain on each Frontend Server:</p><p><img src="'+l+'" alt="IP Addresses with Load Balancer"></p><p>In this example, the Cluster is serving two Shared Domains: <code>domain1.dom</code> and <code>domain2.dom</code>, and the Cluster has three Frontend Servers. One IP Addresses assigned to each Shared Domain in the DNS server tables, and those addresses are external (Internet) addresses of your Load Balancer. You should instruct the Load Balancer to distribute connections received on each of its external IP addresses to three internal IP addresses - the addresses assigned to your Frontend Servers.</p><p>When configuring these Shared Domains in your CommuniGate Pro Servers, you assign these three internal IP addresses to each Domain.</p><p>DNS MX-records for Shared Domains can point to their A-records.</p><h2 id="Details" tabindex="-1">Cluster Configuration Details <a class="header-anchor" href="#Details" aria-label="Permalink to &quot;Cluster Configuration Details {#Details}&quot;">​</a></h2><h3 id="startup-parameters" tabindex="-1">Startup Parameters <a class="header-anchor" href="#startup-parameters" aria-label="Permalink to &quot;Startup Parameters&quot;">​</a></h3><p>The best way to specify additional startup parameters is to create the <a href="./../sysadmin/#UnixOptions"><code>Startup.sh</code></a> file inside the <em>base directory</em>.</p><p>To create a Static Cluster, use the <code>--staticBackend</code> startup parameter with the Backend servers, and the <code>--staticFrontend</code> startup parameter with the Frontend servers.</p><p>To create a Dynamic Cluster, use the <code>--clusterBackend</code> startup parameter with the Backend servers, and the <code>--clusterFrontend</code> startup parameter with the Frontend servers.</p><h3 id="listeners" tabindex="-1">Listeners <a class="header-anchor" href="#listeners" aria-label="Permalink to &quot;Listeners&quot;">​</a></h3><p>To protect your site from DoS attacks, you may want to open SMTP, POP, IMAP, and other <a href="./../network/Listener.html">Listeners</a> and limit the number of connections accepted from the same IP address. Set those limits on Frontend servers only, since Backend servers receive all connections from Frontends, and each Frontend can open a lot of connections from the same IP address.</p><h3 id="webadmin" tabindex="-1">WebAdmin <a class="header-anchor" href="#webadmin" aria-label="Permalink to &quot;WebAdmin&quot;">​</a></h3><p>Usually the Backend servers are not directly accessible from the Internet. If you need to change the settings or monitor one of the Backend servers from &quot;outside&quot;, you can use the WebAdmin interface of one of the Frontend servers, using the following URL:<br><code>http://_Frontendaddress_:8010/Cluster/12.34.56.78/</code><br> where 12.34.56.78 is the [internal] IP address of the Backend server you want to access.</p><h3 id="smtp" tabindex="-1">SMTP <a class="header-anchor" href="#smtp" aria-label="Permalink to &quot;SMTP&quot;">​</a></h3><p>The outgoing mail traffic generated with regular (POP/IMAP) clients is submitted to the site using the A-records of the site Domains. As a result, the submitted messages go to the Frontend Servers and the messages are distributed from there.</p><p>Messages generated with WebUser clients and messages generated automatically (using the Automated Rules) are generated on the Backend Servers. Since usually the Backend servers are behind the firewall and since you usually do not want the Backend Servers to spend their resources maintaining SMTP queues, it is recommended to use the forwarding feature of the CommuniGate Pro <a href="./../mail/SMTP.html">SMTP module</a>.</p><p>Select the Forward to option and specify the asterisk (<code>*</code>) symbol. In this case all messages generated on the Backend Servers will be quickly sent to the Frontend Servers and they will be distributed from there. If you do not want to use all Frontend servers for Backend mail relaying, change the Forward To setting to include the IP addresses of some Frontend Servers, separating the addresses with the comma (<code>,</code>) symbol.</p><h3 id="rpop" tabindex="-1">RPOP <a class="header-anchor" href="#rpop" aria-label="Permalink to &quot;RPOP&quot;">​</a></h3><p>In a Static Cluster, RPOP activity takes place on Backend servers. As a result, it is essential for those servers to be able to initiate outgoing TCP connections to remote servers. If the Backend servers are connected to a private LAN behind a firewall, you should install some NAT server software on that network and configure the Backend servers (using their OS TCP/IP settings) to route all non-local packets via the NAT server(s). Frontend servers can be used to run NAT services.<br> In a Dynamic Cluster, RPOP activity takes place on those servers that have the RPOP service set to Locally for Others. These servers (usually - frontends) should be able to initiate outgoing TCP connections to remote servers. RPOP activity is scheduled on the active Cluster Controller, so if Backend servers do not have direct access to the Internet, their RPOP setting should be set to Remotely.</p><h3 id="ftp" tabindex="-1">FTP <a class="header-anchor" href="#ftp" aria-label="Permalink to &quot;FTP&quot;">​</a></h3><p>The FTP module does not &quot;proxy&quot; connections to Backend servers. Instead, it uses CLI to manage Account File Storage data on Backend servers. This eliminates a problem of Backend servers opening FTP connections directly to clients. If all FTP connections come to the Frontend servers, the FTP services on Backends can be switched off.</p><p>The FTP module running on cluster Frontends behind a load balancer and/or a NAT has the same problems as any FTP server running in such a configuration. To support the active mode, make sure that Frontend servers can open outgoing connections to client FTP ports (when running via a NAT, make sure that the &quot;address in use&quot; problems are addressed by the NAT software). To support the passive mode, make sure that your load balancer allows clients to connect directly to the Frontend ports the FTP module opens for individual clients.</p><h3 id="ldap" tabindex="-1">LDAP <a class="header-anchor" href="#ldap" aria-label="Permalink to &quot;LDAP&quot;">​</a></h3><p>The LDAP module does not &quot;proxy&quot; connections to Backend servers. Instead, it uses CLI to authenticate users and, optionally, to perform LDAP Provisioning operations. If all LDAP connections come to the Frontend servers, the LDAP services on Backends can be switched off, unless they serve Cluster-wide Directory Units (see below).</p><h3 id="directory" tabindex="-1">Directory <a class="header-anchor" href="#directory" aria-label="Permalink to &quot;Directory&quot;">​</a></h3><p>Cluster-wide Directory Units are processed on the Cluster Controller server. Other Cluster members communicate with Cluster-wide Units by sending LDAP requests to the Controller.<br> If you use Cluster-wide Directory Units, the LDAP service on the Backend servers should be enabled.</p><h3 id="radius" tabindex="-1">RADIUS <a class="header-anchor" href="#radius" aria-label="Permalink to &quot;RADIUS&quot;">​</a></h3><p>The RADIUS module does not &quot;proxy&quot; connections to Backend servers. Instead, it uses CLI to authenticate users and to update their statistical data. If all RADIUS connections come to the Frontend servers, the RADIUS services on Backends can be switched off.</p><h3 id="sip" tabindex="-1">SIP <a class="header-anchor" href="#sip" aria-label="Permalink to &quot;SIP&quot;">​</a></h3><p>See the <a href="./Signals.html">Cluster Signals</a> section.</p><h3 id="rsip" tabindex="-1">RSIP <a class="header-anchor" href="#rsip" aria-label="Permalink to &quot;RSIP&quot;">​</a></h3><p>RSIP processing is similar to RPOP processing. RSIP registrations are implemented as Real-Time Tasks, so they run on those servers that can run Call Legs. See the <a href="./Signals.html">Cluster Signals</a> section.</p><h3 id="postmaster-account" tabindex="-1">Postmaster Account <a class="header-anchor" href="#postmaster-account" aria-label="Permalink to &quot;Postmaster Account&quot;">​</a></h3><p>Do not remove the &quot;<code>postmaster</code>&quot; Account from the Main Domains on your Backend servers. This Account is opened &quot;by name&quot; (bypassing the Router) when any other Cluster member has to connect to that Backend. You should also keep at least the <a href="./../sysadmin/#Privs">All Domains</a> access right for the <code>postmaster</code> Account.</p><h2 id="ClusterCluster" tabindex="-1">Cluster Of Clusters <a class="header-anchor" href="#ClusterCluster" aria-label="Permalink to &quot;Cluster Of Clusters {#ClusterCluster}&quot;">​</a></h2><p>For extremely large sites (more than 5,000,000 active accounts), you can deploy a Static Cluster of Dynamic Clusters. It is essentially the same as a regular Static Cluster with Frontend Servers, but instead of Backend Servers you install Dynamic Clusters. This solves the redundancy problem of Static Clusters, but does not require extremely large Shared Storage devices and excessive network traffic of extra-large Dynamic Clusters:</p><p><img src="'+d+'" alt="Cluster of Clusters"></p><p>Frontend Servers in a &quot;Cluster of Clusters&quot; need access to the Directory in order to implement Static Clustering. The Frontend Servers only read the information from the Directory, while the Backend Servers modify the Directory when accounts are added, renamed, or removed. The <code>hostServer</code> attribute of Account directory records contains the name of the Backend Dynamic Cluster hosting the Account (the name of Backend Cluster Servers without the first domain name element).</p><p>Frontend Servers can be grouped into subsets for traffic segmentation. Each subset can have its own load balancer(s), and a switch that connects this Frontend Subset with every Backend Dynamic Cluster.</p><p>If you plan to deploy many (50 and more) Frontend Servers, the Directory Server itself can become the main site bottleneck. To remove this bottleneck and to provide redundancy on the Directory level, you can deploy several Directory Servers (each Server serving one or several Frontend subsets). Backend Dynamic Clusters can be configured to update only one &quot;Master&quot; Directory Server, and other Directory Servers can use replication mechanisms to synchronize with the Master Directory Server, or the Backend Clusters can be configured to modify all Directory Servers at once.</p>',56))])}const U=u(p,[["render",q]]);export{W as __pageData,U as default};
