import{_ as s,c as i,o as n,ag as o,j as e,a}from"./chunks/framework.jCcxW76o.js";const g=JSON.parse('{"title":"How To","description":"","frontmatter":{"legacyLink":"HowTo.html"},"headers":[],"relativePath":"admin/common/HowTo.md","filePath":"admin/common/HowTo.md"}'),l={name:"admin/common/HowTo.md"};function r(d,t,c,h,m,u){return n(),i("div",null,t[0]||(t[0]=[o('<h1 id="how-to" tabindex="-1">How To <a class="header-anchor" href="#how-to" aria-label="Permalink to &quot;How To&quot;">​</a></h1><p>This section explains how you should configure your CommuniGate Pro Server if you have some specific needs...</p><nav class="table-of-contents"><ul><li><a href="#routing">Routing</a><ul><li><a href="#how-can-i-gradually-migrate-accounts-from-my-old-server">How can I gradually migrate accounts from my old server?</a></li><li><a href="#how-can-i-relay-e-mail-and-signals-for-certain-domains">How can I relay E-mail and Signals for certain domains?</a></li><li><a href="#how-can-i-send-e-mail-and-signals-to-a-remote-host-bypassing-its-dns-mx-srv-records">How can I send E-mail and Signals to a remote host bypassing its DNS MX/SRV records?</a></li></ul></li><li><a href="#smtp-sip">SMTP, SIP</a><ul><li><a href="#how-can-i-forward-mail-to-the-other-smtp-mta-on-the-same-server">How can I forward mail to the other SMTP MTA on the same server?</a></li><li><a href="#how-can-my-customer-servers-receive-mail-if-they-have-dial-up-connections-etrn">How can my customer servers receive mail if they have dial-up connections? (ETRN)</a></li><li><a href="#how-can-i-hold-all-client-mail-till-their-servers-send-etrn">How can I hold all client mail till their servers send ETRN?</a></li><li><a href="#how-can-my-customer-servers-receive-mail-if-they-have-dynamic-ip-addresses-atrn-prop">How can my customer servers receive mail if they have dynamic IP addresses? (ATRN/PROP)</a></li><li><a href="#how-can-my-customers-release-mail-to-all-their-domains-with-one-etrn-or-atrn">How can my customers release mail to all their domains with one ETRN or ATRN?</a></li></ul></li><li><a href="#rules">Rules</a><ul><li><a href="#how-can-i-store-all-outgoing-mail-sent-by-all-my-users">How can I store all outgoing mail sent by all my users?</a></li><li><a href="#how-can-i-restrict-to-whom-my-users-can-send-mail">How can I restrict to whom my users can send mail?</a></li></ul></li><li><a href="#mailboxes">Mailboxes</a><ul><li><a href="#how-can-i-create-and-use-shared-mailboxes">How can I create and use Shared Mailboxes?</a></li><li><a href="#how-can-an-administrator-clean-user-mailboxes">How can an Administrator clean User Mailboxes?</a></li></ul></li><li><a href="#access">Access</a><ul><li><a href="#how-can-i-redirect-webmail-users-from-http-to-https">How can I redirect WebMail users from http:// to https:// ?</a></li></ul></li><li><a href="#account-file-storage">Account File Storage</a><ul><li><a href="#how-can-i-provide-username-domain-dom-personal-web-sites">How can I provide username.domain.dom Personal Web sites?</a></li></ul></li></ul></nav><h2 id="routing" tabindex="-1">Routing <a class="header-anchor" href="#routing" aria-label="Permalink to &quot;Routing&quot;">​</a></h2><h3 id="how-can-i-gradually-migrate-accounts-from-my-old-server" tabindex="-1">How can I gradually migrate accounts from my old server? <a class="header-anchor" href="#how-can-i-gradually-migrate-accounts-from-my-old-server" aria-label="Permalink to &quot;How can I gradually migrate accounts from my old server?&quot;">​</a></h3><p>In many cases, especially when you migrate users from an old server, you may want CommuniGate Pro to deliver mail to all Accounts created in a certain Domain, while mail to all Accounts that do not [yet] exist in that CommuniGate Pro Domain should be relayed to some other [old] server, without any change in the headers and envelope addresses.</p><p>Open the Domain Settings for that Domain and set the Mail to Unknown option:</p>',7),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Unknown Names")])]),e("tr",{valign:"middle"},[e("td",{align:"right",nowrap:"nowrap"},"Mail to Unknown"),e("td",null,[e("select",{name:"MailToUnknown"},[e("option",{value:"0"},"Rejected"),e("option",{value:"1"},"Discarded"),e("option",{value:"2",selected:"selected"},"Rerouted to")])]),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"Def1",value:"1",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"MailRerouteAddress",value:"*%domain.dom@otherserver.dom._via",size:"30",maxlength:"254",type:"text"})])])])])])])])])])],-1),o(`<p>Here <code>domain.dom</code> is the name of this CommuniGate Pro Domain and <code>otherserver.dom</code> is the DNS name of the other [old] server. If the DNS name for the other server does not exist, you can use the IP address instead:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>*%domain.dom@[11.22.33.44]</span></span></code></pre></div><p>When the CommuniGate Pro server receives any message directed to <code>aname@domain.dom</code>, and the Domain does not have an Account/Group/Forwarder/Mailing List with that <code>aname</code> name, the message is Rerouted (the envelope address is changed) to <code>aname%domain.dom@otherserver.dom._via</code>. The <code>._via</code> suffix tell the Router module to accept this address, and to cut off the domain name, using that part only as a name of the server to connect to (the Router module always cuts off the IP-address domain parts, too). The resulting envelope address (<code>aname%domain.dom</code>) is converted to the standard form (<code>aname@domain.dom</code>) before it is sent to that other server. As a result, the other server receives such a message with the unmodified envelope data and header fields.</p><p>As soon the <code>aname</code> Account is created in the CommuniGate Pro <code>domain.dom</code> Domain, mail starts to go to that Account automatically. You can copy all messages from the <code>aname</code> account on the old server to the <code>aname</code> Account on the new server and phase out the <code>aname</code> account on the old server.</p><h3 id="how-can-i-relay-e-mail-and-signals-for-certain-domains" tabindex="-1">How can I relay E-mail and Signals for certain domains? <a class="header-anchor" href="#how-can-i-relay-e-mail-and-signals-for-certain-domains" aria-label="Permalink to &quot;How can I relay E-mail and Signals for certain domains?&quot;">​</a></h3><p>To allow your Server to relay all E-Mail and Signals to the friend.com domain place the following record into the <a href="./../sysadmin/Router.html">Router</a> table:</p><p>Relay: friend.com = <a href="mailto:friend.com@friend.com" target="_blank" rel="noreferrer">friend.com@friend.com</a>._via</p><p>Read the <a href="./../sysadmin/Protection.html#RouterRelay">Protection</a> section to learn the meaning of the Relay: prefix (you can omit it, or you may want to use the RelayAll: prefix instead).</p><p>If you want to relay E-mail and Signals for the friend.com domain, but they should go via some different <code>firewall.friend.com</code> server, use the following Router record:</p><p>Relay: friend.com = <a href="mailto:friend.com@firewall.friend.com" target="_blank" rel="noreferrer">friend.com@firewall.friend.com</a>._via</p><p>If you want to bypass the MX or SRV records and relay all E-mail and Signals to a certain IP address (specified explicitly or using a DNS A-record), then see the <a href="#NoMX">Bypassing MX/SRV</a> section.</p><p>If you want your Server to act as a backup E-mail relay for certain domains, you can enable the <code>Relay to All Hosts We Backup</code> option in the <a href="./../mail/SMTP.html">SMTP module</a> settings.<br> This is not a perfect solution, since anybody who can modify DNS records for certain domains can use your server as a backup relay for those domains.</p><h3 id="how-can-i-send-e-mail-and-signals-to-a-remote-host-bypassing-its-dns-mx-srv-records" tabindex="-1">How can I send E-mail and Signals to a remote host bypassing its DNS MX/SRV records? <a class="header-anchor" href="#how-can-i-send-e-mail-and-signals-to-a-remote-host-bypassing-its-dns-mx-srv-records" aria-label="Permalink to &quot;How can I send E-mail and Signals to a remote host bypassing its DNS MX/SRV records?&quot;">​</a></h3><p>If your Server should send E-mail and Signals to the <code>target.domain</code> domain via the <code>relay.domain</code> relay server or proxy, you can specify the IP address of that relay with a <a href="./../sysadmin/Router.html">Router</a> record:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>target.domain = target.domain@[11.22.33.44]</span></span></code></pre></div><p>You may want to relay E-mail and Signals using DNS A-records instead of explicitly specified IP addresses:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Mail:target.domain = target.domain@relay.domain.25._via</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Signal:target.domain = target.domain@relay.domain.5060._via</span></span></code></pre></div><p>The <a href="./../mail/SMTP.html">SMTP module</a> does not look at the MX records if the port number of a remote host is explicitly specified. By specifying the standard (25) SMTP port number, you tell the SMTP module to look for the relay.domain DNS A-record, and ignore its MX records.</p><p>The <a href="./../signals/SIP.html">SIP module</a> does not look at the SRV records if the port number of a remote host is explicitly specified. By specifying the standard (5060) SIP port number, you tell the SIP module to look for the relay.domain DNS A-record, and ignore its SRV records.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You may want to add a <code>Relay:</code>, <code>NoRelay:</code> or <code>RelayAll:</code> prefix to these Router records.</p></div><h2 id="smtp-sip" tabindex="-1">SMTP, SIP <a class="header-anchor" href="#smtp-sip" aria-label="Permalink to &quot;SMTP, SIP&quot;">​</a></h2><h3 id="how-can-i-forward-mail-to-the-other-smtp-mta-on-the-same-server" tabindex="-1">How can I forward mail to the other SMTP MTA on the same server? <a class="header-anchor" href="#how-can-i-forward-mail-to-the-other-smtp-mta-on-the-same-server" aria-label="Permalink to &quot;How can I forward mail to the other SMTP MTA on the same server?&quot;">​</a></h3><p>You may want to have two different SMTP Servers (MTA) running on the same computer, but listening on either different port numbers or on different IP addresses.</p><p>To relay mail to the &quot;sibling&quot; server running on the port 26, you can redirect to the domain <code>other-port</code> if you put the following record into your <a href="./../sysadmin/Router.html">Router</a> table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>other-port = 127.0.0.1.26._via</span></span></code></pre></div><p>To relay mail to the &quot;sibling&quot; server running on the port 25, but on a different IP address 11.22.33.44, you can redirect to the domain <code>other-ip</code> if you put the following record into your <a href="./../sysadmin/Router.html">Router</a> table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>other-ip = 11.22.33.44.25._via</span></span></code></pre></div><p>For example, if all mail to the domain client57.com should go to the sibling server running on a different port, place the following records into the Router:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>other-port = 127.0.0.1.26._via</span></span>
<span class="line"><span>Relay: client57.com = client57.com@other-port</span></span></code></pre></div><p>or simply:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Relay: client57.com = client57.com@127.0.0.1.26._via</span></span></code></pre></div><h3 id="how-can-my-customer-servers-receive-mail-if-they-have-dial-up-connections-etrn" tabindex="-1">How can my customer servers receive mail if they have dial-up connections? (ETRN) <a class="header-anchor" href="#how-can-my-customer-servers-receive-mail-if-they-have-dial-up-connections-etrn" aria-label="Permalink to &quot;How can my customer servers receive mail if they have dial-up connections? (ETRN)&quot;">​</a></h3><p>Small sites may have dial-up connections only and they can be off-line most of the time. To provide better mail delivery to those sites, you should use your CommuniGate Pro server as their back-up mail relay. You should:</p><ul><li>create 2 MX records (in your DNS server) for the customer <code>domain.dom</code> domain name: a high priority record pointing directly to the customer server and a lower priority record pointing to your CommuniGate Pro server;</li><li>configure your server to let it <a href="#RelayDomain">relay mail</a> to the <code>domain.dom</code> domain;</li><li>optionally include the <code>domain.dom</code> name into the <a href="#HoldMail">Hold Mail list</a> of your CommuniGate Pro <a href="./../mail/SMTP.html#Hold">SMTP module</a>;</li><li>configure the customer server to send the wakeup <code>ETRN</code> commands to your server.</li></ul><h3 id="how-can-i-hold-all-client-mail-till-their-servers-send-etrn" tabindex="-1">How can I hold all client mail till their servers send ETRN? <a class="header-anchor" href="#how-can-i-hold-all-client-mail-till-their-servers-send-etrn" aria-label="Permalink to &quot;How can I hold all client mail till their servers send ETRN?&quot;">​</a></h3><p>If your client has a symmetric dial-on-demand link (i.e. a link that is brought up by the provider when there is any traffic to the client hosts), that client may want:</p><ul><li>to get all mail via your server instead of receiving mail directly, when each incoming message brings the connection link up;</li><li>to receive mail from your server only when the client software issues the ETRN command, so your server will not bring the link up and try to relay the client mail as soon as it is received.</li></ul><p>To serve such a customer (the <code>client.com</code> mail domain), you should:</p><ul><li><p>create a DNS A-record for the <code>mail.client.com</code> name, pointing to the IP address of the client server;</p></li><li><p>create a DNS MX record for the <code>client.com</code> domain pointing to your CommuniGate Pro server; you should NOT include the <code>mail.client.com</code> name into the MX records for the <code>client.com</code> mail domain.</p></li><li><p>create a record in the CommuniGate Pro Router:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>client.com = mail.client.com._via</span></span></code></pre></div></li><li><p>include the <code>mail.client.com</code> name into the <a href="./../mail/SMTP.html">SMTP module</a> Hold Mail for Domains setting.</p></li></ul><h3 id="how-can-my-customer-servers-receive-mail-if-they-have-dynamic-ip-addresses-atrn-prop" tabindex="-1">How can my customer servers receive mail if they have dynamic IP addresses? (ATRN/PROP) <a class="header-anchor" href="#how-can-my-customer-servers-receive-mail-if-they-have-dynamic-ip-addresses-atrn-prop" aria-label="Permalink to &quot;How can my customer servers receive mail if they have dynamic IP addresses? (ATRN/PROP)&quot;">​</a></h3><p>If a customer has a mail server and a dial-up connection with a dynamic IP address, the customer server cannot be listed in the DNS, because DNS records link domain names and fixed (static) IP addresses.</p><p>To deliver mail to those sites, you should configure your CommuniGate Pro server as their mail relay. Depending on the customer server capabilities, your can use either the <code>ATRN</code> or the Unified Domain-Wide Account (RPOP) method.</p><p>If the customer server supports the On-Demand Mail Relaying (ATRN) method, you should:</p><ul><li>create an MX record (in the your DNS server) for the customer <code>domain.dom</code> domain name; this record should point to your CommuniGate Pro server address;</li><li>include the <code>domain.dom</code> name into the Hold Mail list of your CommuniGate Pro <a href="./../mail/SMTP.html#Hold">SMTP module</a>;</li><li>create the <code>domain.dom</code> account in your CommuniGate Pro server Main Domain and assign some password to that account;</li><li>configure the customer server to send the ATRN command to your server using <code>domain.dom</code> as the login (AUTH) name and the domain.dom account password as the AUTH password. If the customer software cannot send the ATRN command, it may send the TURN command, but only after it sends the AUTH command with the proper name and password.</li></ul><p>If the customer server supports the Unified Domain-Wide Account method, you should:</p><ul><li><p>create an MX record (in the your DNS server) for the customer <code>domain.dom</code> domain name; this record should point to your CommuniGate Pro server address;</p></li><li><p>create the <code>dd-customer</code> account (actual name is not relevant) in your CommuniGate Pro server Main Domain and assign some password to that account;</p></li><li><p>add the following record to the CommuniGate Pro <a href="./../sysadmin/Router.html">Router</a>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>domain.dom = dd-customer.local</span></span></code></pre></div></li><li><p>configure the customer server to poll the <code>dd-customer</code> account on your CommuniGate Pro server;</p></li><li><p>configure the customer server to use the <code>X-Real-To</code> header field (or other field you have specified in the <a href="./../mail/Local.html">Local Delivery</a> module settings) as the &quot;special header&quot; containing the mail envelope information.</p></li></ul><h3 id="how-can-my-customers-release-mail-to-all-their-domains-with-one-etrn-or-atrn" tabindex="-1">How can my customers release mail to all their domains with one ETRN or ATRN? <a class="header-anchor" href="#how-can-my-customers-release-mail-to-all-their-domains-with-one-etrn-or-atrn" aria-label="Permalink to &quot;How can my customers release mail to all their domains with one ETRN or ATRN?&quot;">​</a></h3><p>Remote servers that use your CommuniGate Pro server as a back-up mail relay can serve multiple domains. Those servers usually send ETRN or ATRN commands specifying only one domain as the command parameter.</p><p>To let mail to all customer domains being released with one ETRN or ATRN command, you should enqueue mail sent to the customer &quot;secondary&quot; domains into the customer &quot;main domain&quot; queue.</p><p>If the remote server should receive mail for the domain1.dom, domain2.dom, and domain3.dom domains, but it sends ETRN or ATRN commands only for the domain1.dom domain, use the following Router domain-level records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>domain2.dom = domain2.dom@domain1.dom._via</span></span>
<span class="line"><span>domain3.dom = domain3.dom@domain1.dom._via</span></span></code></pre></div><p>Mail to all customer domains will be placed into the domain1.dom queue, and if you want to hold that queue till the ATRN/ETRN command is sent, include the domain1.dom name into the Hold Mail for Domains setting of the SMTP module.</p><h2 id="rules" tabindex="-1">Rules <a class="header-anchor" href="#rules" aria-label="Permalink to &quot;Rules&quot;">​</a></h2><h3 id="how-can-i-store-all-outgoing-mail-sent-by-all-my-users" tabindex="-1">How can I store all outgoing mail sent by all my users? <a class="header-anchor" href="#how-can-i-store-all-outgoing-mail-sent-by-all-my-users" aria-label="Permalink to &quot;How can I store all outgoing mail sent by all my users?&quot;">​</a></h3><p>You may need to store all outgoing mail into a Mailbox in a system administrator or a security officer Account.</p><p>To copy mail sent from certain Domains, use a Server-wide <a href="./../mail/QueueRules.html">Rule</a>:</p>`,56),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Data"),e("th",null,"Operation"),e("th",null,"Parameter")]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"0",selected:"selected"},"Return-Path")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@mydomain.dom",size:"20",maxlength:"200"})])]),e("tr",{align:"left"},[e("th",null,"Action"),e("th",{colspan:"2"},"Parameter")]),e("tr",{valign:"top"},[e("td",null,[e("select",{name:"a000000"},[e("option",{value:"0",selected:"selected"},"Store in")])]),e("td",{colspan:"2"},[e("textarea",{name:"r000000",rows:"4",cols:"40"},"~security/outgoing")])])])])])],-1),e("p",null,[a("The account "),e("code",null,"security"),a(" should already exist in the main domain, and the Mailbox "),e("code",null,"outgoing"),a(" should already exist in that account.")],-1),e("h3",{id:"how-can-i-restrict-to-whom-my-users-can-send-mail",tabindex:"-1"},[a("How can I restrict to whom my users can send mail? "),e("a",{class:"header-anchor",href:"#how-can-i-restrict-to-whom-my-users-can-send-mail","aria-label":'Permalink to "How can I restrict to whom my users can send mail?"'},"​")],-1),e("p",null,"You may meed to let certain groups of users send mail only to other members of that group and/or to only certain addresses outside that group.",-1),e("p",null,[a("The simplest way to implement restrictions is to organize these groups of users into CommuniGate Pro Domains. If all users in the Domain dept1.company.dom (except the user boss) are allowed to send mail only to the users in the same Domain and to the "),e("code",null,"supervisor@hq.company.dom"),a(" address, then the following Server-wide Rule should be used:")],-1),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Data"),e("th",null,"Operation"),e("th",null,"Parameter")]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"0",selected:"selected"},"Return-Path")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@dept1.company.dom",size:"20",maxlength:"200"})])]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"0",selected:"selected"},"Return-Path")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"boss@dept1.company.dom",size:"20",maxlength:"200"})])]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"0",selected:"selected"},"Any Recipient")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"not in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@dept1.company.dom,supervisor@hq.company.dom",size:"20",maxlength:"200"})])]),e("tr",{align:"left"},[e("th",null,"Action"),e("th",{colspan:"2"},"Parameter")]),e("tr",{valign:"top"},[e("td",null,[e("select",{name:"a000000"},[e("option",{value:"0",selected:"selected"},"Reject with")])]),e("td",{colspan:"2"},[e("textarea",{name:"r000000",rows:"4",cols:"40"},"you can send mail only to dept1.company.dom users")])])])])])],-1),o(`<h2 id="mailboxes" tabindex="-1">Mailboxes <a class="header-anchor" href="#mailboxes" aria-label="Permalink to &quot;Mailboxes&quot;">​</a></h2><h3 id="how-can-i-create-and-use-shared-mailboxes" tabindex="-1">How can I create and use Shared Mailboxes? <a class="header-anchor" href="#how-can-i-create-and-use-shared-mailboxes" aria-label="Permalink to &quot;How can I create and use Shared Mailboxes?&quot;">​</a></h3><p>A shared Mailbox is a Mailbox in Account <code>X</code> that can be used by a user (Account) <code>Y</code>. Shared Mailboxes can be used for incoming mail processed by a group of people (sales department, support department, etc.). Shared Mailboxes can be used as an extremely fast and effective alternative to mail and distribution lists: the <code>announce</code> Mailbox in the <code>marketing</code> account can be used to store all company announcements. If all employees have <code>read</code> access to that Mailbox, a single copy of each announcement becomes available to everybody.</p><p>To use a Shared Mailbox, two steps must be taken: first, potential users of the shared Mailbox should be granted access rights for that Mailbox. On the second step the user mailers should be configured to access shared Mailbox(es). Since these shared Mailboxes belong to a different account, they are called <em>foreign</em> Mailboxes.</p><p>First, the owner of the shared Mailbox should create a regular Mailbox within his/her account. It is useful to create a special account <code>public</code> and create shared Mailboxes in that account. To grant others access rights to the shared Mailbox, the account owner should use either a decent IMAP client that can deal with ACL (Access Control Lists) or the WebUser Interface. The <a href="./WebMailbox.html#MailboxManagement">WebUser Interface</a> section describes how you can set the desired <a href="./../storage/Mailboxes.html#ACL">Mailbox Access Rights</a>.</p><p>If a shared Mailbox is created inside the <code>public</code> account, it is useful to grant all Mailbox Access Rights to the real shared Mailbox owner, so the owner can perform all operations with that Mailbox without logging in as the user <code>public</code>.</p><p>To access shared Mailboxes, user mailers should be configured to display both the user account&#39;s own Mailboxes, and the available shared (foreign) Mailboxes. The most universal method is to use the account <a href="./../storage/Mailboxes.html#Subscription">Mailbox Subscription</a> list. This list is a simple set of Mailbox names, and both account&#39;s own Mailbox and foreign Mailbox names can be included into that list.</p><p>Many IMAP clients can only use the Mailbox Subscription list, but they cannot modify that list, or they do not allow a user to enter a foreign Mailbox name into that list. In this case IMAP users should use the <a href="./WebMailbox.html#Subscription">WebUser Interface</a> to fill their subscription lists. If a shared Mailbox <code>announce</code> has been created in the account <code>marketing</code>, users should put the <code>~marketing/announce</code> foreign Mailbox name into their subscription lists.</p><p>The domain administrator can use the <a href="./../objects/Accounts.html#Template">Account Template</a> to specify the initial Mailbox Subscription list, so all new accounts automatically get subscriptions to some shared Mailboxes.</p><p>When shared Mailboxes are included into the Account Subscription List, the users should configure their mail clients to display all Mailboxes listed in the Subscription List:</p><ul><li>WebUser Interface users should check that the Show All Subscribed Mailboxes <a href="./WebMailbox.html">Setting</a> is selected.</li><li>Microsoft® Outlook Express users should open the IMAP account Properties panel and enable the Advanced setting called <code>Only Show Subscribed Folders</code>. Since in this mode the Outlook Express mailer shows ONLY the Mailboxes listed in the account Mailbox Subscription list, the users should include their own Mailboxes (Sent, Drafts, etc.) into their Subscription lists.</li><li>Netscape® Messenger users should open the IMAP Mail Server Properties panel and enable the Advanced setting <code>Show only subscribed folders</code>. Since in this mode the Messenger mailer shows ONLY the Mailboxes listed in the account Mailbox Subscription list, the users should include their own Mailboxes (Sent, Drafts, etc.) into their Subscription lists.<br> The Messenger automatically scans the <code>public</code> account and displays its shared Mailboxes made available for the Messenger user. As a result, if all shared Mailboxes are created in the <code>public</code> account, Netscape Messenger users should not do anything with the Mailbox Subscription Lists.</li></ul><p>Some clients (including Microsoft Outlook and Outlook Express) cannot display foreign Mailboxes even if those Mailbox names are included into the account subscription list. Users of these mailers can access foreign Mailbox via <a href="./../storage/Mailboxes.html#Aliases">Mailbox aliases</a>. They should use the <a href="./WebMailbox.html#Aliases">WebUser Interface</a> to specify aliases for foreign Mailboxes they want to access. If a shared Mailbox <code>announce</code> has been created in the account <code>marketing</code>, users should create the <code>mkt-announce</code> Mailbox alias for the <code>~marketing/announce</code> foreign Mailbox. Their IMAP clients will display the <code>mkt-announce</code> name and will provide access to the <code>~marketing/announce</code> Mailbox messages.</p><p>The domain administrator can use the <a href="./../objects/Accounts.html#Template">Account Template</a> to specify the initial Mailbox Aliases, so all new accounts automatically get a predefined set of Mailbox aliases for the specified shared Mailboxes.</p><h3 id="how-can-an-administrator-clean-user-mailboxes" tabindex="-1">How can an Administrator clean User Mailboxes? <a class="header-anchor" href="#how-can-an-administrator-clean-user-mailboxes" aria-label="Permalink to &quot;How can an Administrator clean User Mailboxes?&quot;">​</a></h3><p>Sometimes a Server or Domain Administrator should be able to check user Mailboxes to clean or file user messages. This can be done without actually logging to the Server under that user name.</p><p>The Server Administrator with the <a href="./../sysadmin/#Privs">All Domains</a> access right has unlimited access rights to all Mailboxes in all Accounts.<br> The Domain Administrator with the <a href="./../sysadmin/#Domain"><code>CanAccessMailboxes</code></a> access right has unlimited access rights to all Mailboxes in that Domain Accounts.</p><p>Administrators can use any decent IMAP, MAPI, or XIMSS client to access user Mailboxes. That client should be able to let a user enter a Mailbox name directly.<br> To open the INBOX Mailbox in the <code>username</code> Account, administrators should log in under their own names and tell the client to open the <code>~username/INBOX</code> Mailbox.</p><p>The <a href="./WebMailbox.html#Subscription">WebUser</a> Interface can be used for the same purpose. Administrators can log in under their own names, open the Subscription page and type the user Mailbox name in the Open Mailbox panel.</p><h2 id="access" tabindex="-1">Access <a class="header-anchor" href="#access" aria-label="Permalink to &quot;Access&quot;">​</a></h2><h3 id="how-can-i-redirect-webmail-users-from-http-to-https" tabindex="-1">How can I redirect WebMail users from <code>http://</code> to <code>https://</code> ? <a class="header-anchor" href="#how-can-i-redirect-webmail-users-from-http-to-https" aria-label="Permalink to &quot;How can I redirect WebMail users from \`http://\` to \`https://\` ?&quot;">​</a></h3><p>By <a href="./../../development/WebApp.html#Editor">Creating and Managing Skins</a> copy the <code>login.wssp</code> file into <code>login.wssi</code> and replace the contents of the original <code>login.wssp</code> with the following code:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%IF secureChannel --&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%INCLUDE &quot;login.wssi&quot; --&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%ELSE --&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">html</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">head</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">meta</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> http-equiv</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;REFRESH&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> content</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0; url=https://%%domainName%%/&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">title</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Redirecting to the secure interface&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">title</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">head</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">html</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%ENDIF--&gt;</span></span></code></pre></div><h2 id="account-file-storage" tabindex="-1">Account File Storage <a class="header-anchor" href="#account-file-storage" aria-label="Permalink to &quot;Account File Storage&quot;">​</a></h2><h3 id="how-can-i-provide-username-domain-dom-personal-web-sites" tabindex="-1">How can I provide <code>username.domain.dom</code> Personal Web sites? <a class="header-anchor" href="#how-can-i-provide-username-domain-dom-personal-web-sites" aria-label="Permalink to &quot;How can I provide \`username.domain.dom\` Personal Web sites?&quot;">​</a></h3><p>The standard URL for the username@domain.dom Account File Storage is <a href="http://domain.dom/~username" target="_blank" rel="noreferrer">http://domain.dom/~username</a>.</p><p>You may want to provide better looking <code>http://username.domain.dom/</code> URLs for your Account personal Web sites. This feature is based on the method the Server uses to <a href="./../services/HTTP.html#Routing">route requests</a> sent to the HTTP User ports.</p><p>For users in the domain.dom secondary Domain, add the following records to the <a href="./../sysadmin/Router.html">Router</a>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>*.domain.dom = *@domain.dom</span></span>
<span class="line"><span>&lt;LoginPage%*@domain.dom&gt; = *@domain.dom</span></span></code></pre></div><p>If the domain.dom is your Main Domain, then add the following records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>*.domain.dom = *@fict</span></span>
<span class="line"><span>&lt;LoginPage%*@fict&gt; = *</span></span></code></pre></div><p>These records route the <code>LoginPage@username.domain.dom</code> addresses to <code>username@domain.dom</code> addresses (or <code>username</code> addresses if domain.dom is the Main Domain).</p><p>Finally, you should update your DNS server to ensure that all <code>_username_.domain.dom</code> names point to your Server IP address. You may want to use wildcard records (<code>*.domain.dom CNAME domain.dom</code>) if your DNS server supports them.</p>`,32)]))}const y=s(l,[["render",r]]);export{g as __pageData,y as default};
