import{_ as t,c as o,o as a,ag as s}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Troubleshooting","description":"","frontmatter":{"legacyLink":"HelpMe.html"},"headers":[],"relativePath":"admin/common/Troubleshooting.md","filePath":"admin/common/Troubleshooting.md"}'),r={name:"admin/common/Troubleshooting.md"};function n(i,e,c,d,l,h){return a(),o("div",null,e[0]||(e[0]=[s('<h1 id="troubleshooting" tabindex="-1">Troubleshooting <a class="header-anchor" href="#troubleshooting" aria-label="Permalink to &quot;Troubleshooting&quot;">​</a></h1><p>This section lists the most common problems with the CommuniGate Pro installations, and it provides the suggestions that should help you to solve those problems.</p><nav class="table-of-contents"><ul><li><a href="#security">Security</a><ul><li><a href="#is-my-server-an-open-relay">Is my Server an open relay?</a></li><li><a href="#an-account-was-compromised-and-my-server-is-being-used-for-mass-mailing-what-can-i-do">An Account was compromised and my server is being used for mass mailing. What can I do?</a></li></ul></li><li><a href="#webadmin">WebAdmin</a><ul><li><a href="#i-have-rerouted-the-postmaster-account-and-now-i-cannot-log-in-as-the-postmaster">I have rerouted the Postmaster account and now I cannot log in as the Postmaster</a></li><li><a href="#i-have-deleted-the-postmaster-account">I have deleted the Postmaster account</a></li><li><a href="#i-have-created-a-secondary-domain-and-now-i-cannot-log-into-webadmin">I have created a secondary Domain and now I cannot log into WebAdmin</a></li><li><a href="#when-i-try-to-log-in-i-get-the-access-from-your-network-is-denied-error">When I try to log in, I get the &quot;access from your network is denied&quot; error</a></li></ul></li><li><a href="#smtp-receiving">SMTP Receiving</a><ul><li><a href="#my-server-does-not-accept-mail-from-my-web-script-applet">My Server does not accept mail from my Web script/applet</a></li></ul></li><li><a href="#smtp-sending">SMTP Sending</a><ul><li><a href="#my-server-cannot-send-mail-to-some-host-using-ssl-tls">My Server cannot send mail to some host using SSL/TLS</a></li></ul></li><li><a href="#access">Access</a><ul><li><a href="#webuser-connections-return-the-pink-page-saying-we-do-not-provide-web-access-to-this-domain">WebUser connections return the pink page saying &quot;we do not provide Web Access to this Domain&quot;</a></li><li><a href="#webuser-sessions-are-disconnected-almost-immediately-after-login">WebUser sessions are disconnected almost immediately after login</a></li><li><a href="#what-does-the-unassigned-local-network-address-error-mean">What does the &quot;unassigned local network address&quot; error mean</a></li></ul></li><li><a href="#directory">Directory</a><ul><li><a href="#microsoft-ldap-outlook-and-outlook-express-users-cannot-find-directory-records">Microsoft LDAP (Outlook and Outlook Express) users cannot find Directory records</a></li><li><a href="#attempts-to-update-account-settings-result-in-the-directory-record-with-the-specified-dn-is-not-found-error">Attempts to update Account Settings result in the directory record with the specified DN is not found error</a></li></ul></li><li><a href="#date-and-time">Date and Time</a><ul><li><a href="#time-stamps-in-messages-sent-or-received-with-communigate-pro-are-several-hours-off">Time stamps in messages sent or received with CommuniGate Pro are several hours off</a></li></ul></li><li><a href="#logs">Logs</a><ul><li><a href="#every-time-i-access-the-webadmin-interface-a-failure-type-router-record-appears-in-the-log">Every time I access the WebAdmin interface, a Failure-type ROUTER record appears in the Log</a></li><li><a href="#what-do-these-dnr-16538-xxx-xx-x-xx-rss-mail-abuse-org-a-host-name-is-unknown-records-mean">What do these DNR-16538(xxx.xx.x.xx.rss.mail-abuse.org) A:host name is unknown records mean?</a></li></ul></li><li><a href="#miscellaneous">Miscellaneous</a><ul><li><a href="#what-is-that-non-standard-udp-port-the-communigate-pro-server-opens-on-my-system">What is that non-standard UDP port the CommuniGate Pro Server opens on my system?</a></li><li><a href="#how-can-i-make-my-formmail-type-cgi-work-with-communigate-pro">How can I make my formmail-type CGI work with CommuniGate Pro?</a></li></ul></li></ul></nav><h2 id="security" tabindex="-1">Security <a class="header-anchor" href="#security" aria-label="Permalink to &quot;Security&quot;">​</a></h2><h3 id="is-my-server-an-open-relay" tabindex="-1">Is my Server an open relay? <a class="header-anchor" href="#is-my-server-an-open-relay" aria-label="Permalink to &quot;Is my Server an open relay?&quot;">​</a></h3><p>Open Relay is an SMTP (or SIP) server configured in such a way that it allows anyone on the Internet to send e-mail (or make calls) through it, not just mail destined to or originating from known users. If you receive a lot of mail/spam from unknown origin, but the targets are your local users, then it has nothing to do with relaying; relaying means sending through your server to external targets.</p><p>With the default settings CommuniGate Pro is configured NOT to be an open relay, it relays only e-mails (calls) submitted by senders who had authenticated.<br> Relaying for non-authenticated senders is possible if the sender had connected from an address from the <a href="./../sysadmin/Protection.html#ClientFixed">Client IP Addresses</a> list, so make sure there are no excessive addresses there; ideally that list should be empty and all your users must authenticate when sending. If you receive all mail from a gateway - do NOT add the gateway address to the <code>Client IP Addresses</code> list, but add it to <a href="./../sysadmin/Protection.html#WhiteHoles">UnBlacklistable (White Hole) IP Addresses</a> list.</p><p>In <a href="./../mail/SMTP.html#Relay">SMTP Relaying</a> page make sure:</p><ul><li>the &quot;Relay to any IP Address: If Received from:&quot; is set to <code>clients</code> or <code>nobody</code></li><li>the &quot;Relay to Client IP Addresses: If Sent to:&quot; is set to <code>simple</code> or <code>none</code></li><li>the &quot;Relay to Hosts We Backup:&quot; is <code>disabled</code></li></ul><h3 id="an-account-was-compromised-and-my-server-is-being-used-for-mass-mailing-what-can-i-do" tabindex="-1">An Account was compromised and my server is being used for mass mailing. What can I do? <a class="header-anchor" href="#an-account-was-compromised-and-my-server-is-being-used-for-mass-mailing-what-can-i-do" aria-label="Permalink to &quot;An Account was compromised and my server is being used for mass mailing. What can I do?&quot;">​</a></h3><p>Someone had learned/guessed the password of an Account and uses that Account to send spam. Note that this case has nothing to do with open relaying.</p><p>Open the Mail page in the WebAdmin Monitors realm, and open the <a href="./../mail/#MonitorQueue">Queue</a> page. There you should see a lot of messages with similar size and contents.</p><ul><li>Open one of such messages to learn the compromised Account name and the sender&#39;s IP address.</li><li>Click the <a href="./../mail/#MonitorMessage">Reject All Sender&#39;s Messages</a> button.</li><li>Open the compromised Account <a href="./../objects/Accounts.html#Passwords">Settings</a> page. <ul><li>Reset or disable the password to prevent new logins.</li><li>Temporary disable the <code>Mail</code> service to stop submitting mail from existing logins.</li></ul></li><li>Use the <a href="./../mail/#MonitorMessage">Reject All Sender&#39;s Messages</a> button to clean the Queue. The messages which are being processed may not be rejected, so you may need to repeat this step several times.</li></ul><p>In order to lower the chances of the users&#39; passwords becoming compromised:</p><ul><li>Make sure all users use encrypted connections (SSL/TLS) when commuicating with the server. That will prevent hackers from learning passwords via network sniffers.</li><li>Force users to have enough long and complex passwords which cannot be guessed easily.</li><li>Force <a href="./../objects/Accounts.html#X2Auth">Two-factor Authentication</a>, if possible.</li><li>Impose tighter limits in <ul><li>&quot;Failed Logins Limit&quot; in the Account <a href="./../objects/Accounts.html#Passwords">Settings</a> page</li><li><a href="./../sysadmin/Protection.html#TempBlock">Temporarily Blocked IP Addresses</a> in Settings-&gt;Network-&gt;&quot;Blacklisted IPs&quot; pageto prevent brute-force attacks.</li></ul></li><li>Enable the <a href="./../sysadmin/Security.html#Hiding">Hide &#39;Account Unknown&#39; messages</a> to hinder address harvesting.</li></ul><p>To reduce the damage caused by compromised Accounts, and to make them to be less attractive for hackers:</p><ul><li>Impose tighter limits for &quot;Outgoing Mail Limit&quot;, &quot;Outgoing Recipients Limit&quot; and &quot;Max Recipients per Message&quot; in <a href="./../objects/Accounts.html#TransferOut">Outgoing Mail Transfer Settings</a>.<br> That will reduce the rate a hacker will be able to send messages.</li><li>Impose &quot;&#39;From&#39; Address Restrictions&quot; and &quot;&#39;From&#39; Name Restrictions&quot; in <a href="./../objects/Accounts.html#TransferOut">Outgoing Mail Transfer Settings</a>.<br> That will give the hackers less freedom for spoofing the message origin.</li><li>If your customers are to use WebMail/Pronto only and no external SMTP clients, then in the <a href="./../objects/Accounts.html#Services">Enabled Services</a> disable the <code>Relay</code> service.<br> That will disallow hackers to use SMTP which is the most convenient way to submit messages.</li></ul><h2 id="webadmin" tabindex="-1">WebAdmin <a class="header-anchor" href="#webadmin" aria-label="Permalink to &quot;WebAdmin&quot;">​</a></h2><h3 id="i-have-rerouted-the-postmaster-account-and-now-i-cannot-log-in-as-the-postmaster" tabindex="-1">I have rerouted the Postmaster account and now I cannot log in as the Postmaster <a class="header-anchor" href="#i-have-rerouted-the-postmaster-account-and-now-i-cannot-log-in-as-the-postmaster" aria-label="Permalink to &quot;I have rerouted the Postmaster account and now I cannot log in as the Postmaster&quot;">​</a></h3><p>CommuniGate Pro applies routing rules not only to addresses in incoming messages, but to all addresses it processes. If you have rerouted the <code>postmaster</code> account to some other account <code>abc</code>, then all attempts to log in as the <code>postmaster</code> will cause the Server to try to open the <code>abc</code> account. If you provide the correct password (i.e. the <code>abc</code> account password), you will be able to log in, but you will have the access rights granted to the <code>abc</code> account, not to the <code>postmaster</code> account.</p><p>You still can log into the <code>postmaster</code> account even if the <code>postmaster</code> name is redirected to a completely different address. Use the following name instead of the <code>postmaster</code> name:</p><p>abcd@postmaster.local</p><p>This address is always routed to the account <code>postmaster</code>. Use the regular <code>postmaster</code> account password with this string.</p><p>For more details on the <code>.local</code> routing, check the <a href="./../mail/Local.html#Routing">Local Delivery Module</a> section.</p><h3 id="i-have-deleted-the-postmaster-account" tabindex="-1">I have deleted the Postmaster account <a class="header-anchor" href="#i-have-deleted-the-postmaster-account" aria-label="Permalink to &quot;I have deleted the Postmaster account&quot;">​</a></h3><p>If you have deleted the <code>postmaster</code> account, stop the Server and start it again.</p><p>If the CommuniGate Pro Server does not find the <code>postmaster</code> account during the startup process, it creates a new one. Check the <code>postmaster</code> account files to get the new <code>postmaster</code> password, in the same way you used when you <a href="./../install/Install.html#Config">installed</a> the CommuniGate Pro Server.</p><h3 id="i-have-created-a-secondary-domain-and-now-i-cannot-log-into-webadmin" tabindex="-1">I have created a secondary Domain and now I cannot log into WebAdmin <a class="header-anchor" href="#i-have-created-a-secondary-domain-and-now-i-cannot-log-into-webadmin" aria-label="Permalink to &quot;I have created a secondary Domain and now I cannot log into WebAdmin&quot;">​</a></h3><p>When you connect to CommuniGate Pro via a browser, the Server checks the domain name you have specified in the browser URL. If that name matches the name of one of your Secondary Domains, the WebAdmin Interface of that Domain is opened, rather than the Server WebAdmin Interface.</p><p>To open the Server WebAdmin Interface, use the Main Domain Name in your browser URL. If that name does not have a DNS A-record or its record points to a different server, use the Server IP Address in the browser URL.</p><p>If all Server IP Addresses were assigned to secondary Domains, you can try to use ANY domain name that points to the CommuniGate Pro Server, and does not match any of the Secondary Domain names.</p><p>If all Server IP Addresses were assigned to secondary Domains and all DNS domain names pointing to your server are names of your secondary Domains or secondary Domain Aliases, then use the following URL:</p><p>http://<em>sub.domain.com</em>:8010/MainAdmin<br> https://<em>sub.domain.com</em>:9010/MainAdmin</p><p>where <em>sub.domain.com</em> is any name pointing to your server computer or any of its IP addresses.</p><h3 id="when-i-try-to-log-in-i-get-the-access-from-your-network-is-denied-error" tabindex="-1">When I try to log in, I get the &quot;access from your network is denied&quot; error <a class="header-anchor" href="#when-i-try-to-log-in-i-get-the-access-from-your-network-is-denied-error" aria-label="Permalink to &quot;When I try to log in, I get the &quot;access from your network is denied&quot; error&quot;">​</a></h3><p>Open the Network pages in the WebAdmin Settings realm, and open the Client IPs page. The Logins from Non-Client IP Addresses option is set to <code>prohibit</code>, so users can connect to the Server only from the addresses listed in the Client IP Addresses field (on the same page).</p><p>If the Client IP Addresses field was left empty, you still can connect to the Server if you launch your browser on the Server computer itself, and connect locally, using the <a href="http://127.0.0.1:8010" target="_blank" rel="noreferrer">http://127.0.0.1:8010</a> URL.</p><p>If you have not entered anything into the Client IP Addresses field, or if you cannot connect from the IP Addresses listed in that field, and you cannot connect to the server locally, using the <a href="http://127.0.0.1:8010" target="_blank" rel="noreferrer">http://127.0.0.1:8010</a> URL, then:</p><ul><li>stop the CommuniGate Pro Server;</li><li>open the <code>_{base}_/Settings/IPAddresses.settings</code> file and change the ClientOnly option from <code>YES</code> to <code>NO</code>, and save the updated file.</li><li>start the CommuniGate Pro Server again.</li></ul><h2 id="smtp-receiving" tabindex="-1">SMTP Receiving <a class="header-anchor" href="#smtp-receiving" aria-label="Permalink to &quot;SMTP Receiving&quot;">​</a></h2><h3 id="my-server-does-not-accept-mail-from-my-web-script-applet" tabindex="-1">My Server does not accept mail from my Web script/applet <a class="header-anchor" href="#my-server-does-not-accept-mail-from-my-web-script-applet" aria-label="Permalink to &quot;My Server does not accept mail from my Web script/applet&quot;">​</a></h3><p>When the SMTP module receives messages, it tries to route the address specified in the Mail From command (the message &#39;Return-Path&#39; address). If the domain name in that address is a name of the Server local Domain and the specified Account (or other Object) is not found in that Domain, the Router returns an error code and the SMTP module refuses to accept the message.</p><p>You should reconfigure your script/applet to use either an empty Return-Path (<code>&lt;&gt;</code>) for generated messages, or to use an E-mail address of some existing Account. If the script/applet cannot be reconfigured, you can create an Alias for any existing Account.</p><p>If, for example, your script/applet submits messages to your server with the <a href="mailto:webform@mydomain.com" target="_blank" rel="noreferrer">webform@mydomain.com</a> Return-Path address, and you do not have the webform Account in the mydomain.com Domain, you may want to create the webform alias for the postmaster Account. If delivery of a submitted message fails, the error report will be sent to the postmaster Account.</p><h2 id="smtp-sending" tabindex="-1">SMTP Sending <a class="header-anchor" href="#smtp-sending" aria-label="Permalink to &quot;SMTP Sending&quot;">​</a></h2><h3 id="my-server-cannot-send-mail-to-some-host-using-ssl-tls" tabindex="-1">My Server cannot send mail to some host using SSL/TLS <a class="header-anchor" href="#my-server-cannot-send-mail-to-some-host-using-ssl-tls" aria-label="Permalink to &quot;My Server cannot send mail to some host using SSL/TLS&quot;">​</a></h3><p>When the CommuniGate Pro SMTP module connects to a mail host/relay and tries to establish a secure (SSL/TLS) connection, it receives the host Certificate and check the name in that certificate. That name should match either the name of the domain the mail should go to, or the MX relay name for that domain name.</p><p>When a remote server hosts several domains on the same IP address, it always sends out only one certificate, because the server cannot learn to which domain the incoming messages will go to and thus it cannot present the Certificate for that particular domain. As a result, your (sending) server may refuse to proceed.</p><p>If the server mainhost.com also hosts client1.com and client2.com domains, and the MX records for all 3 domains point to the same name and to the same IP address on that server, the server will always present only one Certificate - usually, the mainhost.com Certificate.</p><p>To allow your CommuniGate Pro Server to send mail securely to client1.com and client2.com domains, you should specify 2 Domain-level <a href="./../sysadmin/Router.html">Router</a> records:</p><p>client1.com = <a href="mailto:client1.com@mainhost.com" target="_blank" rel="noreferrer">client1.com@mainhost.com</a>._via<br> client2.com = <a href="mailto:client1.com@mainhost.com" target="_blank" rel="noreferrer">client1.com@mainhost.com</a>._via</p><p>These records will place mail to client1.com and client2.com domains into the mailhost.com SMTP queue. You should place the mainhost.com name into the Send Encrypted list of the SMTP module, and the server will connect to the mailhost.com server, check its certificate (it should contain either the mailhost.com name or the name of the relay the SMTP module connected to), and then the SMTP module will establish a secure (SSL/TLS) connection with that server and it will send mail to recipients in the client1.com and client2.com domains via that secure connection.</p><h2 id="access" tabindex="-1">Access <a class="header-anchor" href="#access" aria-label="Permalink to &quot;Access&quot;">​</a></h2><h3 id="webuser-connections-return-the-pink-page-saying-we-do-not-provide-web-access-to-this-domain" tabindex="-1">WebUser connections return the pink page saying &quot;we do not provide Web Access to this Domain&quot; <a class="header-anchor" href="#webuser-connections-return-the-pink-page-saying-we-do-not-provide-web-access-to-this-domain" aria-label="Permalink to &quot;WebUser connections return the pink page saying &quot;we do not provide Web Access to this Domain&quot;&quot;">​</a></h3><p>It is very important to understand that the domain name <code>something.com</code> and <code>mail.something.com</code> are completely different domain names. If your CommuniGate Pro Server has the main Domain <code>mycompany.dom</code>, and you are trying to connect to it by typing <code>http://mail.mycompany.com:8100</code> in your Web browser, you will get the page saying that the CommuniGate Pro Server does not provide access to the <code>mail.mycompany.com</code> Domain.</p><p>In most cases, you want the domain names <code>mail.mycompany.com</code>, <code>webmail.mycompany.com</code>, etc. to be just other names (aliases) of the <code>mycompany.com</code> CommuniGate Pro Domain. To specify this, open the <code>mycompany.com</code> Domain Settings page and find the Aliases table. In an empty field, enter the <code>mail.mycompany.com</code> name and click the Update button. Now the CommuniGate Pro Server will know that <code>mail.mycompany.com</code> domain name is just a different name for the <code>mycompany.com</code> Domain it serves. Connection requests specifying the <code>mail.mycompany.com</code> domain name will connect to the <code>mycompany.com</code> CommuniGate Pro Domain, and messages sent to a <code>_username_@mail.mycompany.com</code> address will be delivered to the account <em>username</em> in the <code>mycompany.com</code> domain.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The WebAdmin interface opens the Server Administrator Interface if the name specified in the browser URL is not a CommuniGate Pro Domain name. This is why connections to the WebAdmin port (8010) can work, while the connections to the WebUser port (8100) return the &quot;pink page&quot;.</p></div><h3 id="webuser-sessions-are-disconnected-almost-immediately-after-login" tabindex="-1">WebUser sessions are disconnected almost immediately after login <a class="header-anchor" href="#webuser-sessions-are-disconnected-almost-immediately-after-login" aria-label="Permalink to &quot;WebUser sessions are disconnected almost immediately after login&quot;">​</a></h3><p>When a user connects to your server via a &quot;multi-homed HTTP proxy&quot; (used by large ISPs such as AOL), TCP connections come to the CommuniGate Pro Server from several different IP addresses of those proxy servers. If the <code>Require Fixed Network Address</code> option is enabled in the Account WebUser Preferences, user browser connections can be rejected. Disable the <code>Require Fixed Network Address</code> option for those users that connect via &quot;multi-homed proxy&quot; servers. If most of your users connect via those proxy servers, you may want to disable this setting in the Domain Account Defaults or in the All-Server Account Defaults.</p><h3 id="what-does-the-unassigned-local-network-address-error-mean" tabindex="-1">What does the &quot;unassigned local network address&quot; error mean <a class="header-anchor" href="#what-does-the-unassigned-local-network-address-error-mean" aria-label="Permalink to &quot;What does the &quot;unassigned local network address&quot; error mean&quot;">​</a></h3><p>Your CommuniGate Pro server computer has one or several IP (network) addresses assigned to it. Those addresses can be assigned to CommuniGate Pro Domains, and the Domains WebAdmin page shows all Domains with the IP addresses assigned to them.</p><p>Usually, the Main Domain has the Assigned IP Addresses setting set to All Available, so all IP Addresses not assigned to secondary Domains are automatically assigned to the Main Domain. If none of your Domains has the Assigned IP Addresses setting set to All Available, then some of your Server IP addresses may be not assigned to any Domain.</p><p>When a user connects to the server using a POP or IMAP client and provides just the account name (without the domain name), or when a secure (SSL/TLS) connection has to be established, the CommuniGate Pro Server takes the local IP address the user has connected to and tries to find the Domain that address is assigned to. If that IP address is not assigned to any CommuniGate Pro Domain, then the &quot;unassigned local network address&quot; error is generated.</p><p>Open the WebAdmin Settings-&gt;General page to see all the Local IP Addresses of your Server. You may have to click the Refresh button to see all addresses. The unassigned IP Addresses are displayed in red.</p><h2 id="directory" tabindex="-1">Directory <a class="header-anchor" href="#directory" aria-label="Permalink to &quot;Directory&quot;">​</a></h2><h3 id="microsoft-ldap-outlook-and-outlook-express-users-cannot-find-directory-records" tabindex="-1">Microsoft LDAP (Outlook and Outlook Express) users cannot find Directory records <a class="header-anchor" href="#microsoft-ldap-outlook-and-outlook-express-users-cannot-find-directory-records" aria-label="Permalink to &quot;Microsoft LDAP (Outlook and Outlook Express) users cannot find Directory records&quot;">​</a></h3><p>Most of LDAP clients (including the Microsoft Outlook products) contain a setting specifying the Directory subtree that should be used for search operations. In Outlook Express, this setting can found in Tools-&gt;Accounts-&gt;Directory Service, on the Advanced stub. It is called Search Base and it should contain the DN for the user domain (by default, that DN is <code>cn=_domainname_</code>).</p><p>If this setting field is left empty, Outlook products silently replace it with the <code>c=_country_code_</code> string, and search operations fail (unless your Directory has the <code>c=_country_code_</code> subtree).</p><p>If you do want to search the entire Directory with an Outlook product, enter the word <code>top</code> into the Search Base setting field.</p><h3 id="attempts-to-update-account-settings-result-in-the-directory-record-with-the-specified-dn-is-not-found-error" tabindex="-1">Attempts to update Account Settings result in the <code>directory record with the specified DN is not found</code> error <a class="header-anchor" href="#attempts-to-update-account-settings-result-in-the-directory-record-with-the-specified-dn-is-not-found-error" aria-label="Permalink to &quot;Attempts to update Account Settings result in the `directory record with the specified DN is not found` error&quot;">​</a></h3><p>This error appears when the <a href="./../objects/Domains.html#DirIntegration">Directory Integration</a> option is enabled. This option tells the CommuniGate Pro Server to update the Account record in the Central <a href="./../directory/">Directory</a> every time the Account Settings are updated. If the Directory does not contain a record for that account, the error message is returned. Account records may be missing in the Directory if the Accounts were created when the Directory Integration option was disabled.</p><p>To fix the problem, open the Domain Settings and find the <a href="./../objects/Domains.html#DirIntegration">Directory Integration</a> panel. Click the Delete All button. It will remove all Domain object records from the Directory. Then click the Insert All button. The CommuniGate Pro Server will create a Directory record for the Domain, and then it will create Directory records for all Domain Objects (Accounts, Groups, Mailing Lists).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Domain contains more than 100,000 Accounts, the Insert All operation can take several minutes.</p></div><h2 id="date-and-time" tabindex="-1">Date and Time <a class="header-anchor" href="#date-and-time" aria-label="Permalink to &quot;Date and Time&quot;">​</a></h2><h3 id="time-stamps-in-messages-sent-or-received-with-communigate-pro-are-several-hours-off" tabindex="-1">Time stamps in messages sent or received with CommuniGate Pro are several hours off <a class="header-anchor" href="#time-stamps-in-messages-sent-or-received-with-communigate-pro-are-several-hours-off" aria-label="Permalink to &quot;Time stamps in messages sent or received with CommuniGate Pro are several hours off&quot;">​</a></h3><p>This problem is caused by an incorrect Time Zone setting on the server and/or on the client machines. To check the Time Zone setting value on the server machine, open the General page in the Settings realm of the CommuniGate Pro WebAdmin Interface. The Server Time field should contain the correct Date and Time values <strong>and</strong> the correct Time Zone value: -0800 means &#39;8 hours behind the GMT&#39;, +0800 means &#39;8 hours ahead of GMT&#39;.</p><p>If the Time Zone value is incorrect, fix the OS settings that specifies that value, and re-open the General page to verify the Time Zone value.</p><h2 id="logs" tabindex="-1">Logs <a class="header-anchor" href="#logs" aria-label="Permalink to &quot;Logs&quot;">​</a></h2><h3 id="every-time-i-access-the-webadmin-interface-a-failure-type-router-record-appears-in-the-log" tabindex="-1">Every time I access the WebAdmin interface, a Failure-type ROUTER record appears in the Log <a class="header-anchor" href="#every-time-i-access-the-webadmin-interface-a-failure-type-router-record-appears-in-the-log" aria-label="Permalink to &quot;Every time I access the WebAdmin interface, a Failure-type ROUTER record appears in the Log&quot;">​</a></h3><p>The WebAdmin interface adds the <code>LoginPage@</code> string to the domain name you specify in your browser URL field and tries to route the resulting address as any other E-mail address. If routing fails, the WebAdmin Interface defaults to the main domain and to the Server WebAdmin Interface, but the failure record appears in the Router Log:</p><p>ROUTER failed to route &#39;LoginPage@mail&#39;</p><p>Usually this happens when you use a non-qualified domain name (like <code>mail</code>) instead of the qualified domain name (<code>mail.mycompany.com</code>). You should either use the qualified domain name in your browser URLs, or you should add the <code>mail</code> Domain Alias to the <code>mail.mycompany.com</code> CommuniGate Pro Domain.</p><h3 id="what-do-these-dnr-16538-xxx-xx-x-xx-rss-mail-abuse-org-a-host-name-is-unknown-records-mean" tabindex="-1">What do these <code>DNR-16538(xxx.xx.x.xx.rss.mail-abuse.org) A:host name is unknown</code> records mean? <a class="header-anchor" href="#what-do-these-dnr-16538-xxx-xx-x-xx-rss-mail-abuse-org-a-host-name-is-unknown-records-mean" aria-label="Permalink to &quot;What do these `DNR-16538(xxx.xx.x.xx.rss.mail-abuse.org) A:host name is unknown` records mean?&quot;">​</a></h3><p>When your SMTP module uses RBLs to check the IP address of the server that tries to send any mail to your server, it converts that server aa.bb.cc.dd IP Address into the dd.cc.bb.aa.<em>rbl-server-name</em> domain name, and tries to resolve this name using the DNS system. If the sending server is not a known offender, and its address is not included into the RBL database, this composed domain name will NOT exist in the DNS system, and the DNR module will report this with a Problem-level Log record.</p><p>If you use RBL servers, you may want to restrict the DNR module Log Level to Major &amp; Failures events only.</p><h2 id="miscellaneous" tabindex="-1">Miscellaneous <a class="header-anchor" href="#miscellaneous" aria-label="Permalink to &quot;Miscellaneous&quot;">​</a></h2><h3 id="what-is-that-non-standard-udp-port-the-communigate-pro-server-opens-on-my-system" tabindex="-1">What is that non-standard UDP port the CommuniGate Pro Server opens on my system? <a class="header-anchor" href="#what-is-that-non-standard-udp-port-the-communigate-pro-server-opens-on-my-system" aria-label="Permalink to &quot;What is that non-standard UDP port the CommuniGate Pro Server opens on my system?&quot;">​</a></h3><p>This is a DNR (Domain Name Resolver) socket. The port number is selected by the OS, and it can change if you restart the CommuniGate Pro Server. This socket is used to send requests (UDP packets) to DNS servers and to receive responses from those servers.</p><p>Other applications (servers, browsers, etc.) use the same type of sockets to resolve domain names, but they usually open and close those UDP sockets quickly, so you may not notice them in your <code>netstat</code> output. CommuniGate Pro opens the DNR UDP socket when it starts, and uses that socket for all DNR requests, closing the socket only when the Server shuts down.</p><h3 id="how-can-i-make-my-formmail-type-cgi-work-with-communigate-pro" tabindex="-1">How can I make my <code>formmail</code>-type CGI work with CommuniGate Pro? <a class="header-anchor" href="#how-can-i-make-my-formmail-type-cgi-work-with-communigate-pro" aria-label="Permalink to &quot;How can I make my `formmail`-type CGI work with CommuniGate Pro?&quot;">​</a></h3><p><code>Formmail</code> and similar CGIs are used to send E-mail messages from regular Web Server HTML forms. Implemented in the form of a <a href="http://www.perl.org" target="_blank" rel="noreferrer">Perl</a> script, these CGIs use the legacy <code>sendmail</code> program to send the composed messages.</p><p>On most platforms, CommuniGate Pro software installer does not replace the legacy <code>sendmail</code> program, though the package does contain the <code>sendmail</code> replacement program. In order to use that program, you should modify your Perl script: you should find all references to the <code>sendmail</code> program (usually the default path used is <code>/usr/sbin/sendmail</code>), and replace them with the <code>_{application directory}_/sendmail</code> references.</p><p>For example, if CommuniGate Pro and your CGI are installed on a MacOS X system, where the CommuniGate Pro <em>application directory</em> is <code>/usr/sbin/CommuniGatePro/</code>, the CGI script <code>/usr/sbin/sendmail</code> strings should be replaced with the <code>/usr/sbin/CommuniGatePro/sendmail</code> strings.</p>',93)]))}const p=t(r,[["render",n]]);export{u as __pageData,p as default};
