import{_ as a,a as r,b as n,c,d as s,e as d,f as l,g as h,h as m,i as u,j as p,k as D,l as g,m as y,n as b,o as f,p as A}from"./chunks/SharedDomain.4HEAsXvx.js";import{_ as v,c as S,o as P,ag as t,j as e,a as i}from"./chunks/framework.jCcxW76o.js";const q=JSON.parse('{"title":"Directory Integration","description":"","frontmatter":{"legacyLink":"CentralDir.html"},"headers":[],"relativePath":"admin/directory/CentralDir.md","filePath":"admin/directory/CentralDir.md"}'),w={name:"admin/directory/CentralDir.md"};function C(I,o,T,x,N,_){return P(),S("div",null,o[0]||(o[0]=[t('<h1 id="directory-integration" tabindex="-1">Directory Integration <a class="header-anchor" href="#directory-integration" aria-label="Permalink to &quot;Directory Integration&quot;">​</a></h1><p>CommuniGate Pro <a href="./">Directory</a> can be used to store any information. One of the Server features is integration of the CommuniGate Pro Directory and CommuniGate Pro <a href="./../objects/Domains.html">Domains</a>. The integration level is selected on a per-Domain basis.</p><p>A Server Administrator can control how CommuniGate Pro Domains are integrated with the Directory. Open the Domains page and follow the Directory Integration link.</p><h2 id="Concept" tabindex="-1">Directory Integration Concept <a class="header-anchor" href="#Concept" aria-label="Permalink to &quot;Directory Integration Concept {#Concept}&quot;">​</a></h2><p>CommuniGate Pro Domains can use the following levels of Directory integration:</p><ul><li>No integration; the Domain and the Domain Accounts settings are stored in <code>.settings</code> files, and when an Account is created, updated, renamed, or removed, Directory is not updated.</li><li>Synchronized; the Domain and Domain Account settings are stored in the <code>.settings</code> files; each Account has a Directory record that stores <em>some</em> of the Account settings as attributes: <ul><li>the Account name in the <code>uid</code> attribute</li><li>the Account Real Name in the <code>cn</code> attribute</li><li>the Account Certificate in the <code>userCertificate</code> attribute (if exists)</li><li>the hosting Server Main Domain name in the <code>hostServer</code> attribute (this attribute is needed to implement Directory-based <a href="./../cluster/">Static Clusters</a>)</li><li>an optional set of custom (and &quot;public info&quot;) settings/attributes. When an Account is created, renamed, removed, or updated, the Directory is automatically updated.</li></ul></li><li>Directory-based. The Domain and the Domain Account settings are stored in the Directory records. The <code>.settings</code> files are not created, and the Server retrieves all settings information from the Directory.</li></ul><p>Finally, the CommuniGate Pro can use regular (non Directory-Based) domains, but still allow Account provisioning via LDAP, so it looks like the Directory-Based Domains are used and LDAP commands can create and update Account. This feature is called LDAP-based Provisioning.</p><h2 id="Renaming" tabindex="-1">Attribute Renaming <a class="header-anchor" href="#Renaming" aria-label="Permalink to &quot;Attribute Renaming {#Renaming}&quot;">​</a></h2><p>Some Domain and Account settings names may not match the standard attribute names used in the Directory Schema. For example, the Account setting <code>Real Name</code> has to be stored in the Directory as the <code>cn</code> (common name) attribute, and the custom settings <code>surname</code> and <code>city</code> (see below) should be stored as attributes <code>sn</code> and <code>l</code>.</p><p>When you need to add an attribute to your Directory Schema, always try to use attribute names specified in one of the LDAP Internet Standards (RFCs). If this attribute should be used for Directory Integration (i.e. it will be used to store some Domain or Account setting value), you may want to use the Attribute Renaming capability to &quot;map&quot; CommuniGate Pro Domain or Account setting name on some Directory Attribute name.</p><p>Use the Attributes Translation table to specify the name translation rules:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Attributes Translation</b></td></tr><tr align="left"><th align="left">Name in CommuniGate</th><th align="left">Name in Directory</th></tr><tr><td><input type="hidden" name="RenameAttributes" value="0"><input type="text" name="o000000" value="city" size="30" maxlength="100"></td><td><input type="text" name="r000000" value="l" size="30" maxlength="100"></td></tr><tr><td><input type="hidden" name="RenameAttributes" value="1"><input type="text" name="o000001" value="Password" size="30" maxlength="100"></td><td><input type="text" name="r000001" value="userPassword" size="30" maxlength="100"></td></tr><tr><td><input type="hidden" name="RenameAttributes" value="2"><input type="text" name="o000002" value="RealName" size="30" maxlength="100"></td><td><input type="text" name="r000002" value="cn" size="30" maxlength="100"></td></tr><tr><td><input type="hidden" name="RenameAttributes" value="3"><input type="text" name="o000003" value="surname" size="30" maxlength="100"></td><td><input type="text" name="r000003" value="sn" size="30" maxlength="100"></td></tr><tr><td><input type="hidden" name="RenameAttributes" value="4"><input type="text" name="o000004" value="" size="30" maxlength="100"></td><td><input type="text" name="r000004" value="" size="30" maxlength="100"></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Attributes Translation feature works only for the Directory Integration component of the CommuniGate Pro Server. If you access the CommuniGate Pro Directory directly (via the <a href="./../services/LDAP.html">LDAP module</a>, for example), no translation takes place: LDAP clients should specify the Directory Attribute names, and the returned records have Directory Attribute names, not CommuniGate Pro Domain and Account setting names - &quot;cn&quot;, not &quot;RealName&quot; and &quot;userPassword&quot;, not &quot;Password&quot;.</p></div><h2 id="SubTree" tabindex="-1">Domains Subtree <a class="header-anchor" href="#SubTree" aria-label="Permalink to &quot;Domains Subtree {#SubTree}&quot;">​</a></h2><p>For each regular CommuniGate Pro Domain with the Directory setting set to <code>Keep in Sync</code>, and for each Directory-Based Domain a Directory Subtree is created. This Subtree has the Domain record as its root, and all Domain Account records as the Subtree elements (&quot;leaves&quot;). For Directory-based Domains, additional elements are created to store Account aliases, Domains settings, etc.</p><p>The Domain Subtree panel allows you to specify the location of Subtrees created for each CommuniGate Pro Domain:</p>',16),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Domain Subtree")])]),e("tr",null,[e("td",{align:"right"},"Base DN:"),e("td",{nowrap:"nowrap"},[e("input",{name:"BaseObject",value:"o=Our Company",size:"30",maxlength:"255",type:"text"}),e("input",{name:"CreateBase",value:"Create It",class:"button",type:"reset"})])]),e("tr",null,[e("td",{align:"right"},"Domain RDN Attribute:"),e("td",{nowrap:"nowrap"},[e("input",{name:"DomainRDN",value:"cn",size:"30",maxlength:"255",type:"text"})])]),e("tr",null,[e("td",{align:"right"},"Domain objectClass:"),e("td",{nowrap:"nowrap"},[e("input",{name:"DomainClass",value:"CommuniGateDomain",size:"30",maxlength:"255",type:"text"})])]),e("tr",null,[e("td",{align:"right"},"UID Subtree:"),e("td",{nowrap:"nowrap"},[e("input",{name:"SubTree",value:"",size:"30",maxlength:"255",type:"text"})])])])])])],-1),t('<ul><li><p><code>Base DN</code></p><p>This field specifies the &quot;base&quot; DN for all Domains in the Central Directory. You may want to set it as: <code>o=_your company name_</code>so each CommuniGate Pro Domain will have the following DN: <code>cn=_domain name_,o=_your company name_</code></p><p>When a Domain is placed into the Directory, a record with its DN is created. If the Base DN does not exist, the Directory Manager may return an error. Use the Create It button to create an empty record with the Base DN.</p><p>If you are an ISP you may want to give each Domain you host the top-level DN:</p><p><code>cn=_domain name_</code>In this case, specify an empty string in the Base DN field.</p></li><li><p><code>Domain RDN attribute</code></p><p>This field specifies the attribute name to use for Domain record RDNs. In most cases, the default value (<code>cn</code>) is the best choice. However, you can change that to the name of any other attribute defined in the Directory schema. If you set this name to <code>o</code>, the CommuniGate Pro Domain records will have the following DNs: <code>o=_domain name_,_base DN_</code><strong>Note:</strong> If you specify the string <code>dc</code> as the Domain RDN attribute, then the DN for a CommuniGate Pro Domain <code>mail.domain.dom</code> will be composed as <code>dc=mail,dc=domain,dc=dom</code>.</p></li><li><p><code>Domain objectClass</code></p><p>This field specifies the <em>objectClass</em> for CommuniGate Pro Domain records in the Directory. The CommuniGateDomain objectClass defined in the CommuniGate Pro Directory Manager schema is the default value. If you choose to select a different objectClass, make sure it exists in your Directory schema.</p><p>For regular Domain, the Domain Directory record is empty. As a result, you may use any objectClass that can store the <code>cn</code> attribute (or the attribute you have specified in the Domain RDN attribute setting).</p><p>For Directory-based Domains, the Domain Directory record contains all Domain settings, so the <code>objectClass</code> for these records should support all attributes included into the CommuniGateDomain <code>objectClass</code>.</p></li><li><p><code>UID subtree</code></p><p>If this field is empty, then the Domain Object (Account, Group, List, Forwarder) records are stored in the directory using the following DNs: uid=<em>objectName</em>,<em>domain DN</em>.<br> If the base DN is o=mycompany, and the Domain RDN attribute is cn, then the directory record for the <code>user1</code> Account in the <code>domain1.dom</code> Domain will have the following DN:<br><code>uid=user1,cn=domain1.dom,o=mycompany</code><br> The UID subtree parameter allows you to place the objects &quot;below&quot; the domain tree. If the UID subtree is set to <code>ou=People</code>, then the record for the same Account will have the following DN:<br><code>uid=user1,ou=People,cn=domain1.dom,o=mycompany</code><br> If the Domain RDN attribute is set to <code>dc</code>, then the record for the same Account will have the following DN:<br><code>uid=user1,ou=People,dc=domain1,dc=dom,o=mycompany</code></p></li></ul><p>Example:</p><p><code>BaseDN</code> is an empty string, <code>Domain RDN Attribute</code> is <code>cn</code>, and three CommuniGate Pro domains (domain1.dom, domain2.dom, and domain3.dom) have been created:</p><p><img src="'+a+'" alt="Pic1"></p><p>To search for Accounts in these Domain subtrees, LDAP clients should have the string <code>cn=domain_N_.dom</code>specified in their &quot;Base Object&quot; or &quot;Search Base&quot; settings.</p><p>Example:</p><p><code>BaseDN</code> is <code>o=acme</code>, <code>Domain RDN Attribute</code> is <code>cn</code>, and three CommuniGate Pro domains (domain1.dom, domain2.dom, and domain3.dom) have been created:</p><p><img src="'+r+'" alt="Pic2"></p><p>To search for Accounts in these Domain subtrees, LDAP clients should have the string <code>cn=domain_N_.dom,o=acme</code>specified in their &quot;Base Object&quot; or &quot;Search Base&quot; settings.</p><p>Example:</p><p><code>BaseDN</code> is <code>o=acme</code>, <code>Domain RDN Attribute</code> is <code>dc</code>, and three CommuniGate Pro domains (domain1.dom, domain2.dom, and domain3.dom) have been created:</p><p><img src="'+n+'" alt="Pic3"></p><p>To search for Accounts in these Domain subtrees, LDAP clients should have the string <code>dc=domain_N_,dc=dom,o=acme</code>specified in their &quot;Base Object&quot; or &quot;Search Base&quot; settings.</p><p>After you have decided how to organize your Domains Subtree, you can create additional Directory <a href="./#Units">Storage Units</a> to store your Domain and Account data in several units (if necessary). For example, if you want to use your CommuniGate Pro Directory Manager to store information not related to CommuniGate Pro Accounts, and you want all Domain and Account information to be stored either on a remote LDAP server or in a dedicated Local Storage Unit, you can create a Storage Unit <code>MyDomains</code> for the Directory Integration Base DN subtree (<code>o=acme</code> in the examples listed above). In this case, all Domains and Account records will be stored in that <code>MyDomains</code> Storage Unit (in a separate local unit or on a remote LDAP server), while all records that do not have the <code>o=acme</code> suffix will be stored in other Storage Units:</p><p><img src="'+c+'" alt="Pic4"></p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you change any Domain Subtree setting, the existing Subtree is not modified. Carefully select the proper values for the Domain Subtree settings before you start any Directory Integration activity. If you need to change these settings later, it is your responsibility to move the existing Domain Subtree to the new location (specified with the new BaseDN) and/or to change RDNs of the existing Domain records (if you have changed the Domain RDN Attribute setting).</p></div><h2 id="CustomSettings" tabindex="-1">Custom Account Settings <a class="header-anchor" href="#CustomSettings" aria-label="Permalink to &quot;Custom Account Settings {#CustomSettings}&quot;">​</a></h2><p>The CommuniGate Pro Server has a predefined set of Account Settings (see the <a href="./../objects/Accounts.html#Settings">Accounts</a> section for more details). The Directory Integration settings include a panel that allows you to specify additional, Custom settings for CommuniGate Pro Accounts:</p>',18),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Custom Account Settings")])]),e("tr",{valign:"top"},[e("td",null,[e("table",{border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"System")]),e("tr",null,[e("td",null,[e("input",{name:"n0",value:"surname",size:"30",maxlength:"100",type:"text"})])]),e("tr",null,[e("td",null,[e("input",{name:"n1",value:"city",size:"30",maxlength:"100",type:"text"})])]),e("tr",null,[e("td",null,[e("input",{name:"n12",value:"",size:"30",maxlength:"100",type:"text"})])])])])]),e("td",null,[e("table",{border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Public Info")]),e("tr",null,[e("td",null,[e("input",{name:"f0",value:"telephoneNumber",size:"30",maxlength:"100",type:"text"})])]),e("tr",null,[e("td",null,[e("input",{name:"f5",value:"",size:"30",maxlength:"100",type:"text"})])])])])])])])])])],-1),t('<p>You can use these Custom Account Settings to store additional information about your users: locations, phone numbers, demographic data, etc.</p><p>The System custom settings can be modified by Server administrators and Domain administrators with the Basic Domain Access Right.</p><p>The Public Info custom settings can be modified by the users themselves.</p><p>To add a Custom Setting, type its name into the last (empty) field and click the Update button.</p><p>Additional (custom) Account Settings are stored in Account Directory records (these records have the CommuniGateAccount objectClass).</p><p>When you select a name for a new Custom Account Setting, either use a name of an attribute already specified for CommuniGateAccount object class in the <a href="./Schema.html">Directory Schema</a>, or use the Directory Integration <a href="#Renaming">Attribute Renaming</a> feature and map the new Custom Account Setting name onto a name of any already specified attribute.</p><p>Example:</p><p>To add the <code>telephoneNumber</code> setting to all CommuniGate Pro Accounts, add the name <code>telephoneNumber</code> to the Custom Account Settings table.<br> If a Local Storage Unit is used to store CommuniGate Pro Domains and Accounts subtree, no additional action is needed: the <code>telephoneNumber</code> attribute is already included into the CommuniGateAccount object class description in all Local Unit Schemas.</p><p>Example:</p><p>To add the <code>surname</code> setting to all CommuniGate Pro Accounts, add the name <code>surname</code> to the Custom Account Settings table, and add the pair (<code>surname</code>, <code>sn</code>) to the Attribute Renaming table, so the <code>surname</code> Account Settings will be stored in Directory records as <code>sn</code> attributes.<br> If a Local Storage Unit is used to store CommuniGate Pro Domains and Accounts subtree, no additional action is needed: the <code>sn</code> attribute is already included into the CommuniGateAccount object class description in all Local Unit Schemas.</p><p>Example:</p><p>To add the <code>BirthDay</code> setting to all CommuniGate Pro Accounts, add the name <code>BirthDay</code> to the Custom Account Settings table.<br> If a Local Storage Unit is used to store CommuniGate Pro Domains and Accounts subtree, add the <code>BirthDay</code> attribute to the Local Unit Schema, and add the newly created <code>BirthDay</code> attribute name to the list of Optional Attributes of the CommuniGateAccount object class.<br> If a Remote Storage Unit is used to store CommuniGate Pro Domains and Accounts subtree, update the Directory Schema on the remote LDAP server to allow directory records of the CommuniGateAccount object class to include the <code>BirthDay</code> attribute.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Account records in the Directory always contain the <code>sn</code> attribute to make them compatible with the standard LDAP Directory Schema. If you do not include this attribute into the Custom Account Settings set, CommuniGate Pro stores account records with the <code>sn</code> attribute containing the <code>none</code> string.</p></div><p>After you have specified some Custom Account Settings, their names appear on the Account Settings pages. You can use those pages or <a href="./../../development/CLI.html">CLI</a> to add and update the Custom Setting values for all CommuniGate Pro Accounts:</p>',14),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",width:"25%"},"Real Name: "),e("td",null,[e("input",{type:"text",name:"RealName",value:"John R. Smith",size:"30",maxlength:"80"})])]),e("tr",null,[e("td",{align:"right"},"surname: "),e("td",null,[e("input",{type:"text",name:"surname",value:"Smith",size:"30",maxlength:"80"})])]),e("tr",null,[e("td",{align:"right"},"city: "),e("td",null,[e("input",{type:"text",name:"city",value:"Timbuktu",size:"30",maxlength:"80"})])]),e("tr",{valign:"bottom"},[e("td",{align:"right",width:"25%"},[i("CommuniGate  "),e("br"),i("Password: ")]),e("td",null,[e("input",{type:"password",name:"Password",value:"********",size:"12",maxlength:"32"})])]),e("tr",null,[e("td",{align:"right"},"telephoneNumber: "),e("td",null,[e("input",{type:"text",name:"city",value:"800 262 4722",size:"30",maxlength:"80"})])])])])])],-1),t('<div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you rename a custom attribute name or remove it, the attribute values are not modified in the Directory - you are effectively changing the Directory Integration parameters, not the Directory data itself. To update the actual Directory data (for example, to remove all <code>telephoneNumber</code> attribute values from the Directory), use LDAP utilities and/or applications.</p></div><h2 id="RegularDomains" tabindex="-1">Integrating Regular Domains <a class="header-anchor" href="#RegularDomains" aria-label="Permalink to &quot;Integrating Regular Domains {#RegularDomains}&quot;">​</a></h2><p>Regular CommuniGate Pro Domains do not rely on Directory data. All Domain and Account settings are stored in files inside the CommuniGate Pro file directories and CommuniGate Pro Server reads those files when it needs to retrieve Domain and Account settings. Regular Domains can store copies of <strong>some</strong> Account Settings in Directory records.</p><p>The directory record for a Regular Domain is created when the Server needs to store a directory record for any object in that Domain. For example, when the Server needs to create a directory record for the Account <code>john</code> in the <code>dom1.dom</code> Domain, it creates the <code>cn=dom1.dom</code> record first (if it does not exist), and then the Server creates the <code>uid=john,cn=dom1.dom</code> record for the Account <code>john</code>.</p><p>When the <a href="./../objects/Domains.html#DirIntegration">Directory Integration</a> Domain Setting is set to <code>Keep In Sync</code>:</p><ul><li>A directory record is created for each object (Account, Group, Mailing List, Forwarder) created in that Domain.</li><li>A directory record is removed when an object is removed from that Domain.</li><li>Directory record DNs are renamed when Domain objects are renamed.</li><li>Directory records are updated when Domain Accounts settings are updated.</li></ul><p>None of these actions takes place when the Domain Directory Integration settings is set to Disabled.</p><p>The following diagram illustrates what happens when the <code>dom1.dom</code> Domain has the Directory Integration option set to <code>Keep In Sync</code>, and an Account is created in that Domain:</p><p><img src="'+s+'" alt="Pic:Create"></p><p>In this example:</p><ul><li>The WebAdmin or CLI interface is used to create the <code>john</code> Account in the <code>dom1.dom</code> Domain.</li><li>The Account <code>john</code> is created, and the supplied settings (together with the Account Template) are used to compose the initial Account Settings.</li><li>The Account Manager executes the AddRecord Directory operation to create a record in the Directory.<br> The Directory record DN is composed using the global Directory Integration Settings. If the default settings are used, the Directory record DN is <code>uid=john,cn=dom1.dom</code>.<br> Some of the initial Account Settings are converted into Directory attributes and stored into the newly created Directory record.</li></ul><p>Now Directory search operations (initiated with an LDAP client or the WebUser Interface) can display the record for the newly created account.</p><p>Directory records for Regular Domain Accounts contain the following attributes:</p><ul><li><code>uid</code> - the Account name</li><li><code>cn</code> - the Account &quot;Real Name&quot;</li><li><code>sn</code> - an empty string if this attribute is not included into Custom Account Settings</li><li><code>hostServer</code> - the Main Domain name of the CommuniGate Pro Server that hosts this Account</li><li><code>userCertificate</code> - the Account Certificate (if exists)</li><li>custom settings (see above)</li><li><code>userPassword</code> - the Account password (<em>optionally</em>)</li><li>other standard settings - (<em>optionally</em>)</li></ul><p>The Regular Domains panel located on the Directory Integration page of the WebAdmin Interface allows you to specify these options:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Regular Domains</b></td></tr><tr><td rowspan="3" align="right">Copy into Account records:</td><td><input name="StorePassword" value="1" checked="checked" type="checkbox"> Passwords</td></tr><tr><td><input name="StoreStandard" value="1" type="checkbox"> Standard Settings</td></tr><tr><td> </td></tr></tbody></table></div></form><ul><li><p><code>Copy Password</code></p><p>If this option is selected, the Directory records for Regular Domain Accounts will contain the Account Password attribute (usually it is renamed into the <code>userPassword</code> attribute).</p></li><li><p><code>Copy Standard Settings</code></p><p>If this option is selected, the Directory records for Regular Domain Accounts will contain all CommuniGate Pro standard Settings for those Accounts (excluding the RealName and userCertificate settings that are always being stored and the Password setting that it controlled using a separate option).</p></li></ul><p>The following diagram illustrates what happens when the <code>dom1.dom</code> Domain has the Directory Integration option set to <code>Keep In Sync</code>, and Domain Account settings are updated:</p><p><img src="'+d+'" alt="Pic:Update"></p><p>In this example:</p><ul><li>The UpdateAccount operation is initiated with a WebAdmin or CLI Interface command.</li><li>The Account <code>john</code> Settings are modified using the supplied new settings and the updated settings are stored in the CommuniGate Pro Account data files.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the UpdateRecord Directory operation to update the Account record in the Directory.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It is important to understand that Directory Integration for Regular Domains is a one-way relationship: if you change attributes of Account records in the Directory (using any LDAP utility), the actual Account Settings will not be modified - CommuniGate Pro always uses data in the settings files, and never reads data from the Directory when it needs to retrieve settings for Regular Domains or settings for Accounts in those Domains. The CommuniGate Pro Manager for regular Domains and Accounts only updates the Directory, but it never reads the Account record data back from the Directory.</p></div><p>The following diagram illustrates what happens when the <code>dom1.dom</code> Domain has the Directory Integration option set to <code>Keep In Sync</code>, and a Domain Account is renamed:</p><p><img src="'+l+'" alt="Pic:Rename"></p><p>In this example:</p><ul><li>The RenameAccount operation is initiated with a WebAdmin or CLI Interface command.</li><li>The Account <code>john</code> and its files are renamed.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the RenameRecord (modifyDN) Directory operation to rename the Account record in the Directory.</li></ul><p>The following diagram illustrates what happens when the <code>dom1.dom</code> Domain has the Directory Integration option set to <code>Keep In Sync</code>, and a Domain Account is removed:</p><p><img src="'+h+'" alt="Pic:Delete"></p><p>In this example:</p><ul><li>The RemoveAccount operation is initiated with a WebAdmin or CLI Interface command.</li><li>The Account <code>john</code> and its files are removed.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the DeleteRecord Directory operation to remove the Account record from the Directory.</li></ul><p>The Directory Integration panel on the Domain Settings page has the <code>Delete All</code> button. Use this button to delete the Domain record and all Domain Object records from the Directory. The operation deletes only those records that contain the <code>hostServer</code> attribute and that attribute value is the same as the Main Domain name of this CommuniGate Pro Server.</p><p>The Directory Integration panel on the Domain Settings page has the <code>Insert All</code> button. Use this button to create a directory record for this Domain and to create directory records for all Domain Objects.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you have created several Accounts in the regular Domain when its Directory Integration setting was set to Disabled, the Directory does not contain records for those Accounts. If later you switch that setting to <code>Keep In Sync</code>, you will see error reports when you try to rename, remove, or update those Accounts: the Server tries to update the Directory records for those Accounts, but the Directory records do not exist.</p></div><p>Before you switch the Directory Integration setting from <code>Disabled</code> to <code>Keep In Sync</code>, click the <code>Delete All</code> button, and then click <code>Insert All</code> button to synchronize the Directory and the current Domain Objects set.</p><h2 id="LDAPProvisioning" tabindex="-1">LDAP-based Provisioning <a class="header-anchor" href="#LDAPProvisioning" aria-label="Permalink to &quot;LDAP-based Provisioning {#LDAPProvisioning}&quot;">​</a></h2><p>CommuniGate Pro allows you to use the LDAP protocol to create, update, rename, and remove Accounts:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>LDAP direct Provisioning</b></td></tr><tr><td><select name="LDAPProvisioning"><option value="0" selected="selected">Disabled</option><option value="1">Enabled</option></select></td></tr></tbody></table></div></form><p>When this option is enabled, the LDAP module checks the names (DNs) specified in update operations. If the DN looks like a DN of a CommuniGate Pro Account, the LDAP module does not perform the requested operation with the Directory. Instead, it executes the CreateAccount, UpdateAccount, RenameAccount, or RemoveAccount operations for the specified Account and Domain.</p><p>The diagram below illustrates how the LDAP AddRecord operation works in this case:</p><p><img src="'+m+'" alt="Pic:LDAPCreate"></p><p>In this example:</p><ul><li>The LDAP module received an AddRecord request from an LDAP client. The client asks the LDAP module to create a record with the <code>uid=john,cn=dom1.dom</code> DN.</li><li>The LDAP module checks the DN and sees that it looks like the record DN for the CommuniGate Pro Account <code>john</code> in the CommuniGate Pro Domain <code>dom1.dom</code>, and the CommuniGate Pro Domain <code>dom1.dom</code> does exist.</li><li>Instead of performing the requested AddRecord operation with the Directory, the LDAP module executes the <code>CreateAccount(john)</code> operation in the <code>dom1.dom</code> Domain.</li><li>The Account <code>john</code> is created, and the supplied LDAP attributes (together with the Account Template) are used to compose the initial Account Settings.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the AddRecord Directory operation to create a record in the Directory.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Directory Integration settings are used to convert LDAP record attribute names into the CommuniGate Pro attribute names. For example, the LDAP AddRecord request can contain the <code>cn</code> attribute. This attribute is stored in the Account settings as the Account RealName setting. When the Account Manager adds a record to the Directory, it converts the RealName Account setting back into the <code>cn</code> record attribute.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All LDAP AddRecord request attributes will be stored as the Account Settings if the LDAP client has authenticated itself as an Account with All Domain and Account Settings access right. But only the attributes specified with the Directory Integration parameters will be copied into the new Directory record. The Directory record will also contain the attributes not included into the original LDAP AddRecord request, but specified in the Account Template.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The LDAP Provisioning feature detects the <code>unixPassword</code> attributes and converts them into <code>Password</code> settings after adding a leading <code>0x02</code> byte. See the <a href="./../objects/Accounts.html#Import">Account Import</a> section for the details.</p></div><p>The following diagram illustrates how the LDAP ModifyRecord operation can be used to modify Account Settings:</p><p><img src="'+u+'" alt="Pic:LDAPUpdate"></p><p>In this example:</p><ul><li>The LDAP module received a ModifyRecord request from an LDAP client. The client asks the LDAP module to update a record with the <code>uid=john,cn=dom1.dom</code> DN.</li><li>The LDAP module checks the DN and sees that it looks like the record DN for the CommuniGate Pro Account <code>john</code> in the CommuniGate Pro Domain <code>dom1.dom</code>, and the CommuniGate Pro Domain <code>dom1.dom</code> does exist.</li><li>Instead of performing the requested ModifyRecord operation with the Directory, the LDAP module executes the <code>UpdateAccount(john)</code> operation in the <code>dom1.dom</code> Domain.</li><li>The Account <code>john</code> Settings are modified using the supplied LDAP attributes.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the ModifyRecord Directory operation to modify a record in the Directory.</li></ul><p>The following diagram illustrates how the LDAP ModifyDN operation can be used to rename Accounts:</p><p><img src="'+p+'" alt="Pic:LDAPRename"></p><p>In this example:</p><ul><li>The LDAP module received a ModifyDN request from an LDAP client. The client asks the LDAP module to change the <code>uid=john,cn=dom1.dom</code> record DN.</li><li>The LDAP module checks the DN and sees that it looks like the record DN for the CommuniGate Pro Account <code>john</code> in the CommuniGate Pro Domain <code>dom1.dom</code>, and the CommuniGate Pro Domain <code>dom1.dom</code> does exist. It also checks that the new name (<code>uid=john1</code>) looks like some CommuniGate Pro Account record DN.</li><li>Instead of performing the requested ModifyDN operation with the Directory, the LDAP module executes the <code>RenameAccount(john,john1)</code> operation in the <code>dom1.dom</code> Domain.</li><li>The Account <code>john</code> is renamed into <code>john1</code>.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the ModifyDN Directory operation to change the Account record DN in the Directory.</li></ul><p>The following diagram illustrates how the LDAP DeleteRecord operation can be used to remove Accounts:</p><p><img src="'+D+'" alt="Pic:LDAPDelete"></p><p>In this example:</p><ul><li>The LDAP module received a DeleteRecord request from an LDAP client. The client asks the LDAP module to delete the <code>uid=john,cn=dom1.dom</code> record.</li><li>The LDAP module checks the DN and sees that it looks like the record DN for the CommuniGate Pro Account <code>john</code> in the CommuniGate Pro Domain <code>dom1.dom</code>, and the CommuniGate Pro Domain <code>dom1.dom</code> does exist.</li><li>Instead of performing the requested DeleteRecord operation with the Directory, the LDAP module executes the <code>DeleteAccount(john)</code> operation in the <code>dom1.dom</code> Domain.</li><li>The Account <code>john</code> is deleted.</li><li>If the <code>dom1.dom</code> Domain Directory Integration setting is set to Keep In Sync, the Account Manager executes the DeleteRecord Directory operation to remove the Account record DN from the Directory.</li></ul><p>When LDAP Provisioning is enabled, the LDAP module uses special processing for some search requests, too. If</p><ul><li>the search request Base DN looks like a DN of some CommuniGate Pro Account, and</li><li>the search request &quot;scope&quot; parameter is &quot;base&quot;,</li></ul><p>the LDAP module calls the Account Manager directly and retrieves the effective settings for the specified Account (i.e. the Account settings as well as all its Default Settings). The module converts these settings into Directory attributes, and sends them back to the LDAP client as a search result record.<br> If the authenticated LDAP user does not have the Domain Administrator access right for the target Account Domain, only the Real Name, User Certificate, Custom, Public Info, and mail attributes are retrieved.</p><h2 id="DirectoryDomains" tabindex="-1">Directory-Based Domains <a class="header-anchor" href="#DirectoryDomains" aria-label="Permalink to &quot;Directory-Based Domains {#DirectoryDomains}&quot;">​</a></h2><p>The CommuniGate Pro Server software implements Directory-based Domains. Directory-based Domains and all their Accounts keep all their settings in the Directory - there is no <code>.settings</code> files for those Domains and Accounts.</p><p>For each Directory-based Domain a Directory record of the CommuniGateDirectoryDomain objectClass is created. This record stores all <a href="./../objects/Domains.html#Settings">Domain Settings</a>.<br> DNs for Directory-based Domains are built in the same way they are built for Regular Domain records.</p><p>For each account in a Directory-based Domain a Directory record of the CommuniGateAccount objectClass is created. This record stores all <a href="./../objects/Accounts.html#Settings">Account Settings</a> (including the Custom Settings).<br> DNs for accounts in the Directory-based Domains are built in the same way they are built for Regular Domain Account records.</p><p>Directory records for Directory-based Domain Accounts must contain the storageLocation attribute. This attribute specifies the location of the Account file directory (for the multi-mailbox accounts) or the location of the Account INBOX (for single-mailbox accounts). The location is specified as a file path relative to the <em>base directory</em> of the CommuniGate Pro Server hosting this Account.</p><p>If a CommuniGate Pro server has to open an Account in a Directory-based Domain, and the Account storageLocation attribute starts with the asterisk (<code>*</code>) symbol, the CommuniGate Pro Server creates the Account file directory (for multi-mailbox Accounts) and other required Account files and file directories.</p><ul><li>If the storageLocation attribute contained only one asterisk, then the new account location path is composed in the same way it is composed for new accounts in the Regular CommuniGate Pro Domains, using the path for the Domain file directory and the Foldering Domain Setting.</li></ul><p>Directory records are created for aliases of Directory-based Domain Accounts.<br> Alias records have the same DNs as Accounts (<code>uid=_aliasname_,_domain DN_</code>).<br> Alias records have the standard <code>alias</code> objectClass, and their aliasedObjectName attribute specifies the DN of the original account record.</p><p>The following diagram illustrates how the LDAP AddRecord operation can be used to create an Account in the Directory-based Domain:</p><p><img src="'+g+'" alt="Pic:DirCreate"></p><p>In this example:</p><ul><li>The LDAP module received an AddRecord request from an LDAP client. The client asks the LDAP module to create a new record with the <code>uid=john,cn=dom1.dom</code> DN.</li><li>The LDAP module creates a new record in the Directory and stores all supplied attributes in it. The response is sent back to the LDAP client and the operation is completed.</li><li>Any Server component tries to open the account <code>john</code> in the Directory-Based Domain <code>dom1.dom</code>. The request is sent to the Directory and the record with the <code>uid=john,cn=dom1.dom</code> DN is retrieved.</li><li>The storageLocation attribute in the retrieved record contains the asterisk (<code>*</code>) symbol. The Server creates the Account files on disk, and updates the Directory record, storing the file path to the Account files in the storageLocation attribute.</li><li>The Account <code>john</code> is opened and the requested operation is executed.</li></ul><p>Since the Account in the Directory-based Domains do not store their settings in the CommuniGate Pro data files, the settings are retrieved from the account Directory record every time an account has to be opened. The following diagram illustrates this procedure</p><p><img src="'+y+'" alt="Pic:DirAccess"></p><p>Since the Directory records are the only source of the Account settings, modifying Directory record attributes effectively modifies the Account Settings:</p><p><img src="'+b+'" alt="Pic:DirUpdate"></p><p>In this example:</p><ul><li>The LDAP module received a ModifyRecord request from an LDAP client. The client asks the LDAP module to change attributes in the<code>uid=john,cn=dom1.dom</code> record.</li><li>The LDAP module tells the Directory to modify the specified record. The response is sent back to the LDAP client and the operation is completed.</li><li>Any Server component tries to open the account <code>john</code> in the Directory-Based Domain <code>dom1.dom</code>. The request is sent to the Directory and the record with the <code>uid=john,cn=dom1.dom</code> DN is retrieved and its attributes are used as Account Settings. Since the attribute value has been modified, the Account Setting set with that attribute is effectively modified.</li></ul><h2 id="SharedDirectory" tabindex="-1">Shared (Multi-Server) Directory <a class="header-anchor" href="#SharedDirectory" aria-label="Permalink to &quot;Shared (Multi-Server) Directory {#SharedDirectory}&quot;">​</a></h2><p>Several CommuniGate Pro Servers can use the same physical Directory (Directory Unit) to keep all their Domain Integration Records.</p><p>The shared Directory Unit can be implemented as a Local Storage Unit on one of the CommuniGate Pro Servers, or it can be hosted on some third-party Directory Server.</p><ul><li>Specify the same <a href="#SubTree">Domains Subtree</a> parameters on all CommuniGate Pro Servers.</li><li>On all CommuniGate Pro Server (except the one that will host the shared Directory) create Remote Storage Units for the same Subtrees. The Remote Storage Unit Subtree parameter should be either the same as the Domains Subtree Base DN parameter, or should be its parent, so the entire Domains Subtree will be stored in those Remote Storage Units.</li><li>Configure all those Storage Units to point to the server that will host the shared Directory.</li></ul><p>To simplify the setup, especially if you have many CommuniGate Pro Servers, it is recommended to create the Remote Storage Units for the <code>&lt;root&gt;</code> Subtrees. To create such a Unit, remove the default <code>Main</code> Local Unit first:</p><p><img src="'+f+'" alt="Pic:SharedDirectory"></p><p>In this example:</p><ul><li><p>One CommuniGate Pro Server is used to host the Shared Directory.</p></li><li><p>The SV1 and SV2 CommuniGate Pro Servers are configured to use that Shared Directory: they both have Remote Storage Units <code>SHR</code> for their <code>&lt;root&gt;</code> Directory Subtrees, and those Units point to the Directory hosting Server.</p></li><li><p>All Servers have the same Directory Integration settings - the Domain Subtree Base DN is <code>o=acme</code> for all Servers.</p></li><li><p>The actual <code>o=acme</code> record is created in the <code>Main</code> Local Storage Unit on the Directory Hosting Server.</p></li><li><p>The Directory records for:</p><ul><li>the <code>dom1.dom</code> Domain created on the SV1 Server,</li><li>the <code>dom2.dom</code> Domain created on the SV2 Server, and</li><li>the <code>dom3.dom</code> Domain created on the Directory Hosting Server</li></ul><p>are stored in the <code>Main</code> Local Storage Unit on the Directory Hosting Server</p></li></ul><h2 id="Routing" tabindex="-1">Distributed Domains (Directory Routing) <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Distributed Domains (Directory Routing) {#Routing}&quot;">​</a></h2><p>When several CommuniGate Pro Servers use a <a href="#SharedDirectory">Shared Directory</a> to keep all their Domain Integration Records, these Servers can be used to serve the same Domain (or the same Domains). Such a Domain is called a Distributed Domain, and each Server hosts a subset of that Domain Accounts. The Distributed Domain should not be a Main Domain of any CommuniGate Pro Server:</p><p><img src="'+A+`" alt="Pic:Distributed Domain"></p><p>In this example:</p><ul><li>Three CommuniGate Pro Servers (with the <code>sv1.corp.dom</code>, <code>sv2.corp.dom</code>, and <code>sv3.corp.dom</code> Main Domains) all have the same <code>corp.dom</code> Secondary Domain. Some Accounts are created in the <code>corp.dom</code> Domain on each Server.</li><li>The Domain Subtree Base DN is set to an empty string (<code>&lt;root&gt;</code>) on all CommuniGate Pro Servers.</li><li>The Shared Directory is hosted on a separate device/server, but in reality one of the CommuniGate Pro Servers can act as the Shared Directory Host.</li><li>The Directory Integration option of the <code>corp.dom</code> Domain is set to <code>Keep In Sync</code> on all Servers.</li></ul><p>When an Account is created, renamed, removed, or updated on one of the sv*.corp.dom Servers, the Directory Unit on the Shared Directory Server is updated. As a result, the Shared Directory contains records for all Accounts created on all sv*.corp.dom Servers.</p><p>When any Server creates an Account and places a record into the Shared Directory, it stores the Server Main Domain name as the record <code>hostServer</code> attribute.</p><p>The Shared Directory can be used to route Distributed Domain mail to the proper location (Server). Open the General page in the WebAdmin Settings realm, then open Cluster settings page, and enable the <code>Directory-Based Clustering</code>. The address routing mechanism is modified:</p><ul><li>When the CommuniGate Pro Server receives a mail for one of its local Domains, it checks if a local Domain object (Account, Alias, Mailing List, Group, Forwarded) exists.</li><li>If no local object is found in the addressed Domain, the Server checks the Directory.</li><li>If the Directory contains a record for the specified object (<code>uid=_objectName_,cn=_domainName_</code>), the record <code>hostServer</code> attribute is checked.</li><li>If the <code>hostServer</code> attribute is absent, or if it contains the Main Domain Name of this CommuniGate Pro Server, an error message is generated. Otherwise, the address is rerouted to the proper relaying module (SIP or SMTP), to the remove server with the <em>hostserver</em> name.</li></ul><p>This Distributed Domain configuration is useful for multi-location and international organizations and corporations where all employee Accounts should be in the same Domain, but each organizational unit is served with its own Server. The DNS MX records for the such a Distributed Domain should point to any or to all Servers hosting that Domain. When a Server receives mail for a Distributed Domain, it either delivers the mail locally (if the addressed Account is hosted on that Server), or relays mail to Server specified in the hostServer attribute of the Account Directory record.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The names and IP addresses for &quot;distributed&quot; systems should be entered into the &quot;Static Members&quot; table on the Clusters WebAdmin page.</p></div><p>Usually, one of the Servers (the &quot;main location&quot;) hosts most of the Distributed Domain Accounts. It is recommended to host the Shared Directory on that CommuniGate Pro Server to minimize the delays introduced with the Directory lookups. Other CommuniGate Pro Server serving this Distributed Domain can be configured to reroute all mail to non-local objects of the Distributed Domain to that &quot;main location&quot; Server. Open the Distributed Domain <a href="./../objects/Domains.html#Unknown">Settings</a>, and set the Mail/Signal To Unknown options to</p><p><code>Reroute To: *%domain.dom@mainserver._via</code></p><p>This method eliminates a need for &quot;remote location&quot; Servers to communicate with the Directory when they have to route addresses. The &quot;remote location&quot; Servers communicate with the Directory only when Accounts are created in, renamed, or removed from a Distributed Domain, and when a WebMail, XIMSS, SIP, or LDAP user requests a Directory search operation. This can drastically improve the &quot;remote location&quot; Servers performance if the communication links between them and the Shared Directory Server are slow and/or unreliable.</p><p>In asymmetric, &quot;main/remote location&quot; configurations, the high-priority MX records for the Distributed Domain should point to the &quot;main location&quot; Server, while &quot;remote location&quot; Server names can be used for low-priority MX records. It is not recommended to use <a href="#DirectoryDomains">Directory-based Domains</a> for Distributed Domains if connections between &quot;remote location&quot; Servers and the Shared Directory are slow and/or unreliable.</p><p>The Distributed Domains concept is the foundation of the CommuniGate Pro <a href="./../cluster/">Static Clusters</a>.</p><p>For small Distributed Domains, routing can be implemented using regular CommuniGate Pro <a href="./../sysadmin/Router.html">Router</a> records. If the Distributed Domain has the same Accounts as shown in the example above, the <code>SV1</code> server should have the following records in its Router:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>; SV2 accounts</span></span>
<span class="line"><span>&lt;dan@corp.dom&gt; = dan%corp.dom@sv2.corp.dom._via</span></span>
<span class="line"><span>&lt;ed@corp.dom&gt; = ed%corp.dom@sv2.corp.dom._via</span></span>
<span class="line"><span>&lt;fred@corp.dom&gt; = fred%corp.dom@sv2.corp.dom._via</span></span>
<span class="line"><span>;</span></span>
<span class="line"><span>; SV3 accounts</span></span>
<span class="line"><span>&lt;gil@corp.dom&gt; = gil%corp.dom@sv3.corp.dom._via</span></span>
<span class="line"><span>&lt;hugh@corp.dom&gt; = hugh%corp.dom@sv3.corp.dom._via</span></span>
<span class="line"><span>&lt;judy@corp.dom&gt; = judy%corp.dom@sv3.corp.dom._via</span></span></code></pre></div><p>While this method does not require any Directory activity, it is hardly acceptable for Domains with more than few dozen Accounts, unless names of Accounts hosted on different Servers can be easily expressed using the Router wildcard symbols. For example, if all Accounts hosted on the Server SV2 end with the <code>-uk</code> suffix (<code>dan-uk@corp.dom</code>, <code>ed-uk@corp.dom</code>, <code>fred-uk@corp.dom</code>, etc.), routing for all SV2 Accounts can be specified with one Router record:</p><p><code>&lt;*-uk@corp.dom&gt; = *-uk%corp.dom@sv2.corp.dom._via</code></p><h2 id="Cluster" tabindex="-1">Directory Integration in a Cluster <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Directory Integration in a Cluster {#Cluster}&quot;">​</a></h2><p>The CommuniGate Pro <a href="./../cluster/">Dynamic Cluster</a> maintains cluster-wide Directory Integration settings: the cluster-wide Attribute Renaming table, Domain Subtree, and Custom Attributes settings are used with all Accounts in Shared Domains, while &quot;regular&quot; settings are used for all Accounts in &quot;local&quot; Domains.</p><p>When you open the Directory Integration WebAdmin page on a Cluster Member, the page contains a link that allows you to switch the Cluster-wide Settings.</p>`,109)]))}const L=v(w,[["render",C]]);export{q as __pageData,L as default};
