import{_ as r,a}from"./chunks/Tree2.ByF2wDwZ.js";import{_ as n,c as s,o as l,ag as o,j as e,a as t}from"./chunks/framework.jCcxW76o.js";const f=JSON.parse('{"title":"Directory","description":"","frontmatter":{"legacyLink":"Directory.html"},"headers":[],"relativePath":"admin/directory/index.md","filePath":"admin/directory/index.md"}'),c={name:"admin/directory/index.md"};function d(h,i,p,u,m,b){return l(),s("div",null,i[0]||(i[0]=[o('<h1 id="directory" tabindex="-1">Directory <a class="header-anchor" href="#directory" aria-label="Permalink to &quot;Directory&quot;">​</a></h1><p>The CommuniGate Pro Server includes the Directory Manager implementing high-performance standards-based Directory storage.</p><p>The Directory can contain records about the CommuniGate Pro Accounts, Domains, and other objects. It can also contain any other type of records, and it can be used as a stand-alone Directory Server serving any LDAP-based applications.</p><p>The Directory Manager is not the same as an LDAP server. The CommuniGate Pro <a href="./../services/LDAP.html">LDAP module</a> provides access to the Directory for LDAP clients, but various CommuniGate Pro components (Account and Domain Managers, WebUser Interface, etc.) access the Directory data directly, bypassing LDAP communications.</p><p>The Directory Manager implements <em>Meta-Directory</em>: it can store directory data in one or several sets of the server files (Local Units), and it can also use external LDAP servers as Directory Remote Units. Many different configurations are possible. The following simplest configurations are used most often:</p><ul><li>All Directory data is stored in a single Local Unit. In this case Meta-Directory is the same as a Directory implemented with a regular LDAP server.</li><li>All Directory data is stored in a single Remote Unit. In this case Meta-Directory is used just as a method to access records stored on an external LDAP server.</li></ul><h2 id="Brief" tabindex="-1">What is Directory? <a class="header-anchor" href="#Brief" aria-label="Permalink to &quot;What is Directory? {#Brief}&quot;">​</a></h2><ul><li><p><em>attribute</em></p><p>a name (<em>attribute name</em>) and one or several <em>attribute values</em>.<br> Usually an attribute is presented in the <code>_name_=_value_</code> form.<br> Attribute names are case-insensitive.</p><p>Samples:</p><p><code>userName=john</code><br><code>eyeColor=blue</code></p></li><li><p><em>object class</em></p><p>an attribute with the <code>objectClass</code> name; this attribute is used to specify a nature of the object it belongs to.</p><p>Samples:</p><p><code>objectClass=person</code><br><code>objectClass=organization</code></p></li><li><p><em>distinguished name</em> (DN).</p><p>a sequence of <em>attributes</em> presented in the <code>_name_=_value_</code> form and separated with the comma (<code>,</code>) symbol.<br> DNs are used as unique names for objects (records).</p><p>Sample:</p><p><code>userName=john,server=BigIron,realm=Internet</code></p><p>DNs are used to build object name trees, with the rightmost attribute specifying the most generic name, and the leftmost attribute specifying the unique object name itself.<br> The leftmost attribute is called <em>Relative Distinguished Name</em> (RDN) - it provides a unique name for the object among all objects with DNs having the same parent DN.</p><p>Sample:</p><p><code>userName=jim,server=BigIron,realm=Internet</code><br> this is a different DN, but it has the same &quot;parent DN&quot; (<code>server=BigIron,realm=Internet</code>)</p><p>Sample:</p><p><code>userName=john,server=SmallCopper,realm=Internet</code><br> this is a different DN, with a different &quot;parent DN&quot; (<code>server=SmallCopper,realm=Internet</code>)</p></li><li><p><em>directory record</em> or <em>object</em></p><p>set of <em>attributes</em> with a <em>distinguished name</em><br> Usually a record is presented as several lines starting with the name presenting the record DN, followed by the lines presenting the record attributes. Several records are usually separated with an empty line.</p><p>Sample:</p><p><code>DN: userName=jim,server=BigIron,realm=Internet</code><br><code>objectClass=person</code><br><code>eyeColor=blue</code><br><code>mailboxLimit=1024000</code></p><p><code>DN: userName=john,server=BigIron,realm=Internet</code><br><code>objectClass=person</code><br><code>eyeColor=green</code><br><code>mailboxLimit=2048000</code></p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The LDAP standard recommends to include the RDN attribute into the set of attributes making up a directory record. CommuniGate Pro Directory Manager enforces this rule.</p></div><ul><li><p><em>directory</em></p><p>a set of <em>directory records</em>; this can be a very large set (millions of records). The set is organized as a tree using DNs. Records are removed automatically when the record with the parent DN is removed. Record DNs are updated automatically when the parent DN is changed (renamed).</p></li><li><p><em>directory schema</em></p><p>a set of directory restrictions, including:</p><ul><li>a set of <em>attribute names</em> that can be used in the Directory (<code>userName, mail, city, eyeColor, ...</code>);</li><li>a set of objectClass attribute values that can be used in the Directory (<code>person, organization, device, printer ...</code>);</li><li>for each objectClass - names of the attributes that must be present in the object record; for records with <code>objectClass=person</code> a schema may require attributes with <code>cn</code> (canonical name) and <code>sn</code> (surname) names;</li><li>for each objectClass - names of the attributes that may be present in the object record; for records with <code>objectClass=person</code> a schema may allow attributes with <code>driverLicense</code> and <code>eyeColor</code> names.</li></ul></li></ul><h2 id="Units" tabindex="-1">Directory Storage Units <a class="header-anchor" href="#Units" aria-label="Permalink to &quot;Directory Storage Units {#Units}&quot;">​</a></h2><p>While the entire CommuniGate Pro Directory is presented to its clients as one large tree of directory records, its subtrees can be stored in separate <em>storage units</em>. This type of &quot;virtual&quot; directories is often called Meta-Directory.</p><p>CommuniGate Pro Directory supports two types of storage units:</p><ul><li><em>local</em> units - sets of files managed with the CommuniGate Pro File Directory Manager. These files contain directory records, replication information, and subtree schemas.</li><li><em>remote</em> units - descriptors managed with the CommuniGate Pro LDAP Directory Manager. These descriptors contain the information about remote Directories accessed via LDAP.</li></ul><p>As a result, the CommuniGate Pro Directory may include subtrees located on remote servers. If an LDAP server ldap.server.dom provides access to some directory tree, you can create a remote unit in the CommuniGate Pro Directory that points to the ldap.server.dom server and the entire <code>ldap.server.dom</code> directory tree or one of its subtrees will be seen in the CommuniGate Pro Directory as some subtree.</p><p>Initially, the CommuniGate Pro server creates one Local Storage Unit <code>Main</code> that contains the entire directory. You may add additional storage units using the WebAdmin Interface.</p><p>The diagram below shows a directory stored in one Local Unit <code>Main</code>:</p><p><img src="'+r+'" alt="Tree1"></p><p>The diagram below shows the same directory stored in 2 Storage Units, with the entire <code>o=MyCompany</code> subtree stored in a separate Storage Unit <code>LDAP1</code>:</p><p><img src="'+a+'" alt="Tree2"></p><ul><li><p>Example 1:</p><p>An external LDAP server <code>ldap1.com</code> has a subtree <code>o=MyCompany</code>, and you want to store all CommuniGate Pro Domain and Account records in that subtree. You can use the following settings:</p><ul><li>In the <a href="./CentralDir.html">Integration</a> settings, specify Base DN as <code>o=MyCompany,o=ldap1</code></li><li>Create a Remote Unit MYLDAP for the <code>o=ldap1</code> subtree.</li><li>Enter <code>ldap1.com</code> as the server name, and an empty string as the Server Subtree in the MYLDAP Unit Settings.</li></ul><p>Now, when the CommuniGate Pro Server tries to access a directory record for the Account <code>john</code> in the <code>domain1.com</code> Domain:</p><ul><li>The <code>uid=john,cn=domain1.com,o=MyCompany,o=ldap1</code> DN is formed.</li><li>The Directory Manager detects that this record should reside on the MYLDAP Unit, and it asks that Unit to perform the requested operation on the record with the <code>uid=john,cn=domain1.com,o=MyCompany</code> DN (the Unit &quot;mount point&quot;, <code>o=ldap1</code> is removed from the DN).</li><li>The MYLDAP Unit sends the request for the <code>uid=john,cn=domain1.com,o=MyCompany</code> DN to the remote server <code>ldap1.com</code>.</li></ul></li><li><p>Example 2:</p><p>An external LDAP server <code>ldap1.com</code> has a subtree <code>o=MyCompany</code>, and you want to store all CommuniGate Pro Domain and Account records in that subtree (the same situation as in the Example 1). You can use the following settings:</p><ul><li>In the <a href="./CentralDir.html">Integration</a> settings, specify Base DN as <code>o=ldap1</code></li><li>Create a Remote Unit MYLDAP for the <code>o=ldap1</code> subtree.</li><li>Enter <code>ldap1.com</code> as the server name, and <code>o=MyCompany</code> as the Server Subtree in the MYLDAP Unit Settings.</li></ul><p>Now, when the CommuniGate Pro Server tries to access a directory record for the Account <code>john</code> in the <code>domain1.com</code> Domain:</p><ul><li>The <code>uid=john,cn=domain1.com,o=ldap1</code> DN is formed.</li><li>The Directory Manager detects that this record should reside on the MYLDAP Unit, and it asks that Unit to perform the requested operation on the record with the <code>uid=john,cn=domain1.com</code> DN (the Unit &quot;mount point&quot;, <code>o=ldap1</code> is removed from the DN).</li><li>The MYLDAP Unit adds the Server Subtree suffix (<code>o=MyCompany</code>) to the DN, and then it sends the request for the <code>uid=john,cn=domain1.com,o=MyCompany</code> DN to the remote server <code>ldap1.com</code> .</li></ul></li></ul><p>Click the Directory link in the CommuniGate Pro Server WebAdmin Interface. The Directory Storage Units pages (realm) opens. You need to have the Directory access right to open these pages.</p>',22),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("thead",null,[e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Display",class:"button",type:"reset"}),t(" Filter: "),e("input",{name:"Filter",size:"30",maxlength:"50",value:"",type:"text"})]),e("td",{align:"right"},[e("i",null,"2 of 2 selected")])])]),e("tbody",null,[e("tr",null,[e("th",{align:"left",nowrap:"nowrap"},"Unit Name"),e("th",{align:"left",nowrap:"nowrap"},"Subtree")]),e("tr",null,[e("td",null,[e("a",{href:"#Local"},"Main")]),e("td",null,[e("a",{href:"#Local"},"<root>")])]),e("tr",null,[e("td",null,[e("a",{href:"#Remote"},"node6")]),e("td",null,[e("a",{href:"#Remote"},"o=node6")])])])])])],-1),e("p",null,[t("The "),e("code",null,"<root>"),t(" string is used to specify the name of the default Storage Unit (i.e. the Storage Unit that stores the root of the Directory Tree).")],-1),e("p",null,"To create a new Storage Unit, type a name for the new unit (this name will be used for administrating only), the Distinguished Name (DN) for the subtree that should be stored in that unit, and click the Add Remote Unit or Add Local Unit button.",-1),e("h2",{id:"Local",tabindex:"-1"},[t("Local Storage Units "),e("a",{class:"header-anchor",href:"#Local","aria-label":'Permalink to "Local Storage Units {#Local}"'},"​")],-1),e("p",null,"Local Directory unit is a set of files containing unit data (records/entries), unit schema, unit settings, and unit modification journal.",-1),e("p",null,"Open the Directory WebAdmin page and click the name of a Local Storage Unit. The unit Settings page opens.",-1),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Settings")])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Subtree:"),e("td",{colspan:"2"})]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Log Level:"),e("td",{colspan:"2"},[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2",selected:"selected"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},[e("input",{name:"EnforceSchema",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,"Enforce Schema"),e("td",{align:"right",nowrap:"nowrap"},"Search Results Limit:"),e("td",null,[e("select",{name:"MaxRecordLimit"},[e("option",{value:"10"},"10"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",null,"other")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},[e("input",{name:"ComposeDisplayName",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,"Compose 'displayName' attribute"),e("td",{colspan:"2"}," ")])])])])],-1),o('<ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the Local Storage Unit Manager should put in the Server Log.</p></li><li><p><code>Enforce Schema</code></p><p>When this option is selected, the Local Storage Unit Manager compares the structure of all new and updated records with the Unit Schema. If this option is disabled, then the Manager checks only the names of the record attributes and ensures that those attributes are included into the Unit Schema, but it does not enforce the objectClass-related restrictions.</p></li><li><p><code>Search Results Limit</code></p><p>This setting limits the maximum number of records a Directory Search operation can return.</p></li><li><p><code>Compose &#39;displayName&#39; attribute</code></p><p>If this option is selected, the Local Storage Unit Manager checks if the <code>displayName</code> attribute is explicitly requested in a search operation, but this attribute is absent in a retrieved Directory record. In this case, the Manager composes the <code>displayName</code> attribute on-the-fly, using the <code>cn</code> attribute, or, if it is absent, the <code>uid</code> attribute.</p></li></ul><p>Each Local Unit has its own Schema. See the <a href="./Schema.html">Schema</a> section for more details on Unit Schemas.</p><p>You can browse and modify the Local Unit Schema by retrieving and modifying the virtual record with the <code>cn=schema</code> DN. If the Local Unit is mounted on some Directory subtree, the DN for the Unit Schema record is <code>cn=schema,_subtree_</code>.</p><h2 id="Remote" tabindex="-1">Remote Storage Units <a class="header-anchor" href="#Remote" aria-label="Permalink to &quot;Remote Storage Units {#Remote}&quot;">​</a></h2><p>Click a Remote Storage Unit name on the Directory WebAdmin page to open the unit Settings page:</p>',5),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Settings")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Log:"),e("td",null,[e("select",{name:"Log"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2",selected:"selected"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"LDAP Server Name:"),e("td",null,[e("input",{type:"text",name:"Server",value:"node6.communigatepro.ru",size:"30",maxlength:"64"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Security:"),e("td",null,[e("select",{name:"TLSMode"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"TLSPort"),e("option",{value:"2"},"STARTTLS")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Server Subtree:"),e("td",null,[e("input",{type:"text",name:"BaseObject",value:"",size:"30",maxlength:"256"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"BIND DN:"),e("td",null,[e("input",{type:"text",name:"BINDName",value:"cn=admin,o=CommuniGate Systems,c=US",size:"30",maxlength:"100"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Bind Password:"),e("td",null,[e("input",{name:"BINDPassword",value:"********",size:"30",maxlength:"64",type:"text"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Search Filter:"),e("td",null,[e("input",{name:"LDAPFilter",value:"(cn=*.net)",size:"30",maxlength:"1000",type:"text"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Protocol Version:"),e("td",null,[e("select",{name:"LDAPVersion"},[e("option",{value:"2",selected:"selected"},"2"),e("option",{value:"3"},"3")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Channel Cache:"),e("td",null,[e("select",{name:"ChannelCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"7"},"7"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250")])])])])])])],-1),o('<ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the Remote Unit Manager should put in the Server Log.</p></li><li><p><code>LDAP Server Name</code></p><p>This field specifies the name or the IP address of the remote LDAP server that hosts the Storage Unit subtree. If the remote LDAP server uses non-standard TCP port, you can specify the Server Name as <code>servername:port</code>.</p></li><li><p><code>Security</code></p><p>If the TLSPort option is set, connections to the remote server will be established in the secure mode. The default port for secure connections is 636.<br> If the STARTTLS option is set, connections are established to the regular LDAP port, and then the STARTTLS LDAP command is sent to initiate secure (encrypted) communication.</p></li><li><p><code>Server Subtree</code></p><p>This field specifies the remote LDAP server subtree to be &quot;mounted&quot;. When this setting is left empty, the entire remote directory becomes visible as a CommuniGate Pro Directory subtree.</p></li><li><p><code>BIND DN</code>, <code>BIND Password</code></p><p>These fields specify the Distinguished Name and Password to use for &quot;binding&quot; (logging into) the remote LDAP server. If these fields are left blank, the CommuniGate Pro will use anonymous access to the remote LDAP server.</p></li><li><p><code>Search Filter</code></p><p>This field contains an optional search filter (in the RFC 2254 format). This filter is included into all LDAP search operations sent to the LDAP server.</p></li><li><p><code>Protocol Version</code></p><p>Use this field to specify the LDAP protocol version supported with the remote LDAP server.</p></li><li><p><code>Channel Cache</code></p><p>Use this field to specify the number of &quot;cached&quot; TCP connections used to connect to the remote LDAP server.</p></li></ul><h2 id="RemoteRoot" tabindex="-1">Remote Directory Root <a class="header-anchor" href="#RemoteRoot" aria-label="Permalink to &quot;Remote Directory Root {#RemoteRoot}&quot;">​</a></h2><p>In certain situations a CommuniGate Pro server should not keep any Directory data in its Local Storage units. Instead, all Directory records should be stored on a remote LDAP server (some other CommuniGate Pro server or a third-party Directory server). In this case, the CommuniGate Pro &quot;root&quot; should be stored in a Remote Storage Unit pointing to that external server. By default, the Directory &quot;root&quot; is stored in the <code>Main</code> Local Storage Unit.</p><p>To tell the CommuniGate Pro Server that the Directory &quot;root&quot; and the entire Directory tree is stored on a remote server, follow these steps:</p><ul><li>open the <code>Main</code> Storage Unit settings</li><li>relocate the Unit to a fictitious subtree <code>o=dummy</code></li><li>create a Remote Storage Unit <code>RemoteRoot</code> specifying an empty string as its Subtree</li><li>configure the <code>RemoteRoot</code> Storage Unit so it will access the proper remote LDAP server</li><li>check that the remote directory is available (using the CommuniGate Pro Directory Browser)</li><li>open the <code>Main</code> Storage Unit settings and click the Remove Unit button to remove this Storage Unit</li></ul><h2 id="Binding" tabindex="-1">Binding to the Directory <a class="header-anchor" href="#Binding" aria-label="Permalink to &quot;Binding to the Directory {#Binding}&quot;">​</a></h2><p>Directory records can be (and usually are) protected from unauthorized access. When users want to access protected Directory data, they should authenticate themselves first. This process is called <em>binding</em> and successful authentication &quot;binds&quot; the user to a certain DN (distinguished name) in the Directory.</p><p>When a user tries to read or modify the Directory data, the binding DN is used to check the Directory <a href="#AccessRights">Access Rights</a>.</p><p>When a user accesses the Directory from a CommuniGate Pro <a href="./../access/WebUser.html">WebUser Interface</a> or a <a href="./../access/XIMSS.html">XIMSS</a> session, the binding DN is the DN of the user Account record:<br><code>uid=_accountname_,cn=_domainname_,o=MyCompany</code>.<br> See the <a href="./../directory/CentralDir.html">Directory Integration</a> chapter for the details.</p><p>When the Directory is accessed using the <a href="./../services/LDAP.html">LDAP</a> module, the client can authenticate itself using the CommuniGate Pro Account name and the Account password. In this case, the binding DN is the DN of the Account record.</p><p>Before converting the user account name into the account Directory record DN, the user account <a href="./../sysadmin/#Privs">Server Access Rights</a> are checked. If the account has the Directory access right, the special &quot;master&quot; bind DN is used instead of the user account record DN. Clients with the &quot;master&quot; bind DN have unlimited Directory access rights.</p><p>Any Directory DN can be used for LDAP binding. The directory record with the specified DN must exist, the record should contain the <code>userPassword</code> attribute, and the attribute value must match the supplied password string.</p><p>If a client has not authenticated itself, the special <code>anyone</code> bind DN is used.</p><h2 id="AccessRights" tabindex="-1">Access Right Records <a class="header-anchor" href="#AccessRights" aria-label="Permalink to &quot;Access Right Records {#AccessRights}&quot;">​</a></h2><p>The CommuniGate Pro Directory restricts client rights to read, search, and modify Directory records. The Directory contains a set of the Access Right records that allow and prohibit directory operations depending on the target directory subtree and on the client binding DN.</p><p>Open the Directory Access Rights page to set the Access Right records:</p>',16),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null," "),e("th",null,"Name"),e("th",null,"Target"),e("th",null,"Bind DN"),e("th",null,"Type"),e("th",{colspan:"2"}," ")]),e("tr",{valign:"top"},[e("td"),e("td",null,[e("input",{name:"N0",value:"SiblingWatch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T0",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B0",value:"sibling",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R0"},[e("option",{value:"0"},"prohibit"),e("option",{value:"1",selected:"selected"},"allow")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Edit")]),e("td",null,[e("input",{name:"D0",value:"Down",class:"button",type:"reset"})])]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"U1",value:" Up ",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"N1",value:"ChildSearch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T1",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B1",value:"child",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R1"},[e("option",{value:"0"},"prohibit"),e("option",{value:"1",selected:"selected"},"allow")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Edit")]),e("td",null,[e("input",{name:"D1",value:"Down",class:"button",type:"reset"})])]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"U2",value:" Up ",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"N2",value:"DirSearch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T2",value:"o=MyCompany",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B2",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R2"},[e("option",{value:"0"},"prohibit"),e("option",{value:"1",selected:"selected"},"allow")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Edit")]),e("td",null," ")]),e("tr",{valign:"top"},[e("td",null," "),e("td",null,[e("input",{name:"N2",value:"",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T2",value:"",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B2",value:"",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R2"},[e("option",{value:"0"},"prohibit"),e("option",{value:"1",selected:"selected"},"allow")])]),e("td",{class:"arrow"}," "),e("td",null," ")])])])])],-1),o('<p>Each Access Right record has:</p><ul><li>a name</li><li>a target: the DN the record applies to; wildcard symbols (&quot;*&quot;) can be used in Target strings</li><li>a Bind DN: the client binding DN the record applies to; wildcard symbols (&quot;*&quot;) can be used in Bind DN strings</li><li>the record type: enabling or disabling</li><li>a link to the Record specific access rights</li></ul><p>The <code>Up</code> and <code>Down</code> buttons allow you to move the records in the table, increasing and decreasing record priorities.</p><p>When a client requests to perform a search, read, modify, or any other operation on a record or a subtree with a certain DN, the Access Right records are checked from top to the bottom. The server looks for an Access Right record that:</p><ul><li>has the Target field matching the DN specified in the client request</li><li>has the Bind DN field matching the client binding DN</li><li>has the operation (delete, create) matching the requested operation, or has the attribute matching the attribute used in the operation</li></ul><p>When such an Access Right record is found, the record type specifies if the operation is allowed or prohibited. If no Access Right record is found, the operation is prohibited.</p><p>If the client binding DN is &quot;master&quot; (see above), all operations are allowed.</p><p>When a client requests a &quot;read&quot;-type operation, the procedure is repeated for all attributes the client wants to retrieve. If the operation is prohibited for all specified attributes, the read operation fails. Otherwise, the operation is performed, and the attributes the client has a right to retrieve are returned to the client.</p><p>If a client requests a &quot;search&quot;-type operation, the procedure is repeated for all attributes used in the search filter. If the search operation is prohibited for at least one of those attributes, the search operation fails. The RDNs of found records is checked. If the RDN attribute is not allowed to be read, the record is not returned to the client.</p><p>If a client requests a &quot;rename&quot;-type operation, the procedure is used twice: to learn if the client has a right to delete the original Directory record, then to learn if the client has a right to create a Directory record in the new location.</p><p>Special strings can be used in the Bind DN field:</p><ul><li><p><code>anyone</code></p><p>the Access Right record is applied for any BindDN, including the <code>anyone</code> (absent) BindDN.</p></li><li><p><code>sibling</code></p><p>the Access Right record is applied if the Bind DN and the Target DN have the same parent DN. For example, the <code>uid=someuser,cn=domain1.com</code> and <code>uid=otheruser,cn=domain1.com</code> DNs are &quot;siblings&quot;. This type of bind DN specifications is useful to grant CommuniGate Pro users access to the Directory records of other users in the same CommuniGate Pro Domain.</p></li><li><p><code>parent</code></p><p>the Access Right record is applied if the Bind DN is a parent of the Target DN. For example, the <code>cn=domain1.com</code> DN is a parent of <code>uid=user1,cn=domain1.com</code> and <code>id=book1,uid=user1,cn=domain1.com</code> DNs.</p></li><li><p><code>child</code></p><p>the Access Right record is applied if the Target DN is a parent of the Bind DN.</p></li><li><p><code>self</code></p><p>the Access Right record is applied if the Target DN is the same as the Bind DN. This type of bind DN specification is useful to grant CommuniGate Pro Account users a right to modify their own directory record attributes.</p></li></ul><p>To create an Access Right record, enter the record name, target DN, and bind DN into the last empty element of the Access Rights table and click the Update button. Use the <code>Up</code> buttons to set the record priority.</p><p>To remove an Access Right record, delete the record name and click the Update button.</p><p>The <a href="./../cluster/Dynamic.html">Dynamic Cluster</a> environment supports the Cluster-wide Directory Access Rights. These Access Rights can be set on any Cluster Member and they are distributed to all Cluster Members.<br> The Cluster-wide Access Rights are applied after the Server-wide Access Rights.<br> To set the Cluster-wide Directory Access Rights, open the Access Rights page and click the Cluster-wide link.</p><h2 id="AccessSpecs" tabindex="-1">Access Right Specifications <a class="header-anchor" href="#AccessSpecs" aria-label="Permalink to &quot;Access Right Specifications {#AccessSpecs}&quot;">​</a></h2><p>To specify Directory Access Rights, open the Access Rights page and click the &quot;specifications&quot; link to open the Access Right record:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Record-Level Rights</b></td></tr><tr align="center"><td>prohibit <input name="delete" value="1" type="checkbox"> Record Deletion</td><td>prohibit <input name="create" value="1" type="checkbox"> Record Creation</td></tr></tbody></table></div></form><p>These options specify if clients with the given Bind DN can create or delete records with the given Target DN.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Attribute Reading</b></td></tr><tr align="center"><td>prohibit: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>This field lists the data attributes that clients with the given Bind DN can read from the records with the given Target DN. The attribute names should be comma-separated. To allow clients read all record attributes, use the asterisk (<code>*</code>) symbol.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Attribute Searching</b></td></tr><tr align="center"><td>prohibit: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>This field lists the attributes that clients with the given Bind DN can use in filters when searching Target DN subtrees.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Attribute Modifying</b></td></tr><tr align="center"><td>prohibit: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>This field lists the data attributes that clients with the given Bind DN can modify in the Target DN records.</p><p>Sample Access Right record:</p><ul><li><p>Target DN</p><p><code>uid=*,cn=domain1.com</code></p></li><li><p>Bind DN</p><p><code>sibling</code></p></li><li><p>Type</p><p><code>allow</code></p></li><li><p>Readable Attributes</p><p><code>objectClass,officeEmail,roomNumber,cn,uid</code></p></li></ul><p>This record allows all <code>domain1.com</code> users to read the <code>objectClass</code>, <code>cn</code>, <code>uid</code>, <code>officeEmail</code>, and <code>roomNumber</code> attributes from Directory records of other <code>domain1.com</code> Domain users.</p><p>Sample Access Right record:</p><ul><li><p>Target DN</p><p><code>cn=domain1.com</code></p></li><li><p>Bind DN</p><p><code>child</code></p></li><li><p>Type</p><p><code>allow</code></p></li><li><p>Readable Attributes</p><p><code>objectClass,officeEmail,roomNumber</code></p></li><li><p>Searchable Attributes</p><p><code>cn,uid</code></p></li></ul><p>This record allows all <code>domain1.com</code> users to search the Domain Directory subtree by <code>cn</code> (canonical name) and <code>uid</code>, but not by other readable attributes.</p><h2 id="Browser" tabindex="-1">Directory Browser <a class="header-anchor" href="#Browser" aria-label="Permalink to &quot;Directory Browser {#Browser}&quot;">​</a></h2><p>The CommuniGate Pro WebAdmin Interface includes a Directory Browser. Open the Directory realm and click the Browser link to open the Directory Browser page.</p><p>The Browser page includes the DN field:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Distinguished Name</b></td></tr><tr><td><input name="Up" value="Up" class="button" type="reset"></td><td><input name="NewBaseDN" value="o=SBK,c=RU" size="60" maxlength="200" type="text"></td><td><input name="Display" value="Go" class="button" type="reset"></td></tr></tbody></table></div></form><p>Use this field to type the DN of the Directory record/subtree you want to view and click the <code>Go</code> button. Click the <code>Up</code> button to remove the leftmost DN element and open the parent Directory record.</p><p>The next panel displays the Directory record with the specified DN:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr align="left"><th>Attribute</th><th>Value</th></tr><tr><td>businesscategory</td><td>&quot;Software development/technical support&quot;</td></tr><tr><td>description</td><td>&quot;\\&quot;SBK subsidiary\\&quot;&quot;</td></tr><tr><td>o</td><td>&quot;SBK&quot;</td></tr><tr><td>objectclass</td><td>organization</td></tr><tr><td>seealso</td><td>&quot;o=SBK, c=RU&quot;</td></tr><tr><td>telephonenumber</td><td>676-555-1212</td></tr></tbody></table></div></form><p>If the record with the specified DN could not be retrieved, this panel will contain the error message.</p><p>The next panel displays all record children.</p>',40),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Subtree")])])]),e("thead",null,[e("tr",null,[e("td",{colspan:"2",nowrap:"nowrap"},[e("input",{name:"Display",value:"Display",class:"button",type:"reset"}),t(),e("select",{name:"Limit"},[e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300",selected:"selected"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000")]),t(" Filter: "),e("input",{name:"Filter",value:"",size:"20",maxlength:"200",type:"text"})])])]),e("tbody",null,[e("tr",{align:"left"},[e("th",null,"RDN"),e("th",null,"objectClass")]),e("tr",null,[e("td",null,[e("a",{href:"#Browser"},"cn=aaa.dom")]),e("td",null,"(top,organization,CommuniGateDomain)")]),e("tr",null,[e("td",null,[e("a",{href:"#Browser"},"cn=bbb.dom")]),e("td",null,"(top,organization,CommuniGateDomain)")])])])])],-1),o('<p>Use the pop-up menu to limit the number of records displayed on the subtree panel.</p><p>To search for specific records, enter an LDAP filter string (in the RFC 2254 format) into the Filter field and click the Display button.</p><p>The table elements display children RDNs and object classes.</p><p>Click the child element RDN link to open the child record in the Directory Browser.</p><h2 id="Import" tabindex="-1">Importing Directory Data <a class="header-anchor" href="#Import" aria-label="Permalink to &quot;Importing Directory Data {#Import}&quot;">​</a></h2><p>The CommuniGate Pro WebAdmin Interface allows the Server Administrator to import directory modifications from text files in the LDIF and &quot;replog&quot; formats:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="center" width="20%"><input name="BatchLDIF" value="LDIF Import" class="button" type="reset"></td><td align="center" width="20%"><input name="BatchLMOD" value="LMOD Import" class="button" type="reset"></td><td colspan="2"><input name="Import" type="file"></td></tr></tbody></table></div></form><p>To import data into the CommuniGate Pro Directory, click the Browse button and select an LDIF file on your workstation. Click the LDIF Import button to insert all records from the selected LDIF file.</p><p>To apply a set of record modifications to the CommuniGate Pro Directory, click the Browse button and select a &quot;replog&quot; file on your workstation. Click the LMOD Import button to apply all modifications from the selected file.</p><h2 id="Cluster" tabindex="-1">Cluster-wide Directory Units <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Cluster-wide Directory Units {#Cluster}&quot;">​</a></h2><p>The <a href="./../cluster/Dynamic.html">Dynamic Cluster</a> environment supports &quot;Shared&quot; or &quot;Cluster-wide&quot; Directory Units. These Units are &quot;visible&quot; on all Cluster members.</p><p>When Cluster-wide Unit settings are modified via any Cluster member, the new settings are automatically distributed to all other members.</p><p>When a Cluster-wide Remote Unit is used on any Cluster member, an outgoing LDAP request is generated directly from that member. All necessary synchronization tasks are performed on the remote LDAP server.</p><p>When a Cluster-wide Local Unit is used on the Cluster Controller, the request is performed locally. When a Cluster-wide Local Unit is used on a non-Controller Cluster member, the request is forwarded to the current Cluster Controller using the LDAP protocol (in the same way Remote Units relay requests to remote LDAP servers).</p><p>The Cluster-wide Unit data (settings and optional data files) are stored inside the <a href="./../cluster/Dynamic.html">SharedDomains</a> file directory. When the current Cluster Controller stops or fails, and the Backup Controller assumes the Cluster Controller role, it re-mounts all Cluster-wide Local Units, and processes them as regular Local Units, while other Cluster members redirect requests to those Cluster-wide Local Units to this new Cluster Controller.</p><p>To create a Cluster-wide Unit, select the Cluster-wide checkbox (it appears in the Dynamic Cluster environment only).</p>',16)]))}const D=n(c,[["render",d]]);export{f as __pageData,D as default};
