import{_ as t,c as i,o as a,ag as s}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Installation","description":"","frontmatter":{"legacyLink":"Install.html"},"headers":[],"relativePath":"admin/install/Install.md","filePath":"admin/install/Install.md"}'),n={name:"admin/install/Install.md"};function o(r,e,l,h,p,d){return a(),i("div",null,e[0]||(e[0]=[s(`<h1 id="installation" tabindex="-1">Installation <a class="header-anchor" href="#installation" aria-label="Permalink to &quot;Installation&quot;">​</a></h1><p>You should download the CommuniGate Pro software either from the CommuniGate Systems <a href="http://www.communigatepro.ru/CommuniGatePro/default.html#Current" target="_blank" rel="noreferrer">Web</a> site, or from any authorized mirror site. Make sure you have the latest version of the software, and that the downloaded version is designed to work on the selected platform.</p><p>Install the Server following the instructions below, and then proceed with <a href="#Config">Initial Configuration</a>.</p><h2 id="Install" tabindex="-1">Installation <a class="header-anchor" href="#Install" aria-label="Permalink to &quot;Installation {#Install}&quot;">​</a></h2><p>On all systems, the CommuniGate Pro uses 2 directories (folders):</p><ul><li>the <em>application directory</em> containing the Server application and supplementary files (as Web Interface page templates). Files in this folder are not modified when the system runs.</li><li>the <em>base directory</em> containing Account data, Settings, Queued messages, Logs, and other Server data.</li></ul><h3 id="Linux" tabindex="-1">Installing on a Linux System <a class="header-anchor" href="#Linux" aria-label="Permalink to &quot;Installing on a Linux System {#Linux}&quot;">​</a></h3><ul><li><p>Log in as a super-user (root).</p><ul><li><p>Using Red Hat package manager (the .rpm file):</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">rpm</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -i</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CGatePro-Linux-_version_.rpm</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"># rpm needs another argument to update the package:</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">#   rpm -U CGatePro-Linux-_version_.rpm</span></span></code></pre></div></li><li><p>Using the Debian Package Manager (the .deb file):</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">dpkg</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -i</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CGatePro-Linux-_version_.deb</span></span></code></pre></div></li></ul><p>Though CommuniGate Pro has a minimal dependence on external libraries, for the sake of resolving the remaining ones it may be preferable to use the advanced package managers such as <code>yum</code> or <code>apt</code>:</p><ul><li><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">yum</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> install</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CGatePro-Linux-_version_.rpm</span></span></code></pre></div></li><li><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">apt</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> install</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CGatePro-Linux__version_.deb</span></span></code></pre></div></li></ul><p>The CommuniGate Pro software will be installed in the <code>/opt</code> directory.</p></li><li><p>The installer will create a systemd unit <code>CommuniGate.service</code>. In order to start and stop it automatically with the system, the installer will apply the <code>enable</code> preset policy. To view the service status, stop and start it, you can use the following commands run as a superuser:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> status</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CommuniGate</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> stop</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CommuniGate</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> start</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CommuniGate</span></span></code></pre></div></li><li><p>If your system was running some standalone SMTP server/MTA (such as Postfix, Exim or sendmail), you need to stop and disable that server.</p><p>For example, to disable Postfix you can use the following command run as a superuser:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> mask</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --now</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> postfix</span></span></code></pre></div></li><li><p>If your system was running POP, IMAP, or poppwd servers, remove the lines describing those servers from the <code>/etc/inetd.conf</code> file (or put the hash <code>#</code> symbol into the first position of those lines).</p></li><li><p>The Installer renames the <code>/bin/mail</code> program into the <code>/bin/LegacyMail</code>. If you decide to uninstall the CommuniGate Pro system, the legacy mail program will be renamed back to <code>/bin/mail</code>.</p></li><li><p>The Installer creates the new <code>/bin/mail</code> application - a drop-in substitution for the legacy <code>mail</code> program.</p></li><li><p>The installer will create a base directory” <code>/var/CommuniGate</code> used by the Server by default. You can move the &quot;base directory&quot; to any other location. In this case, you need to set up the appropriate <a href="./../sysadmin/#Options">startup parameter</a> in <a href="./../sysadmin/Scalability.html#SystemdUnit">initialization system settings</a>.</p></li><li><p>Restart the system or launch the start-up script manually:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> start</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CommuniGate</span></span></code></pre></div></li><li><p>Proceed with <a href="#Config">Initial Configuration</a>.</p></li></ul><h2 id="Config" tabindex="-1">Initial Configuration <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Initial Configuration {#Config}&quot;">​</a></h2><p>When the CommuniGate Pro software is installed:</p><ul><li><p>Restart the OS or start the CommuniGate Pro Server manually.</p></li><li><p><strong>Within 10 minutes</strong>, connect to the WebAdmin Interface with any Web browser, using the port number 8010. Type the following URL in your browser: <code>http://_your.server.domain_:8010</code></p><p>where <em>your.server.domain</em> is the domain name or the IP address of the computer running the CommuniGate Pro Server.</p></li><li><p>Read the License Agreement, enter the preferred password for the <code>postmaster</code> Account, and click the Accept button.</p></li><li><p>You will be redirected to the QuickStart page. Use the <code>postmaster</code> name and the selected password to open the page.</p></li><li><p>Proceed using the <a href="./QuickStart.html">Quick Start</a> instructions.</p></li></ul><p>If you failed to enter a new postmaster password within 10 minutes, the Server will be shut down. When you are ready to enter the password, repeat the steps listed above.</p><p>The <a href="./Migration.html">Migration</a> section can help you to schedule your CommuniGate Pro deployment process.</p><h2 id="Upgrade" tabindex="-1">Upgrading to a Newer Version <a class="header-anchor" href="#Upgrade" aria-label="Permalink to &quot;Upgrading to a Newer Version {#Upgrade}&quot;">​</a></h2><p>When you upgrade to a new version, the files in the <em>application directory</em> are substituted with the new files.</p><p>The <em>base directory</em> and all its files are not modified when you upgrade the CommuniGate Pro Server software, so all Accounts, Mailboxes, messages, settings, File Storage files, Licenses, customized Web Skin, and Real-Time Application files stay in place and continue to work with the new version of the CommuniGate Pro software.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you chose to manually modify Web Skin or Real-Time Application files right in the application directory, then you should save them before upgrading.</p></div><p>To upgrade:</p><ul><li>Download the new version of the CommuniGate Pro Software.</li><li>Stop the CommuniGate Pro Server.</li><li>Remove the previous version of the software using the same installation utility you used to install the software (the <em>base directory</em> will not be removed). This step is needed if the OS installer does not allow you to install a new version &quot;on top&quot; of the old one.</li><li>Install the new version of the CommuniGate Pro Software.</li><li>Start the CommuniGate Pro Server.</li></ul><h2 id="Moving" tabindex="-1">Moving to a New Hardware Server <a class="header-anchor" href="#Moving" aria-label="Permalink to &quot;Moving to a New Hardware Server {#Moving}&quot;">​</a></h2><p>You may want to move your CommuniGate Pro server to a different computer - running the same or a different OS. All your module settings, Account and Domain settings, Mailboxes, licenses, and other data can be preserved.</p><p>CommuniGate Pro keeps all its data in the <a href="#Install">base directory</a>. This is the only directory you need to copy to your new server computer.</p><p>CommuniGate Pro uses the same file formats on all hardware and software (OS) platforms, so usually you can just pack the entire CommuniGate Pro base directory into an archive file (using <code>tar</code> and <code>gzip</code> on Unix systems, <code>zip</code> on MS Windows systems), and unpack the archive on the new server computer.</p><p>Additional processing is needed when you move the CommuniGate Pro Server from a computer running any MS Windows operating system to a computer running any flavor of Unix, or vice versa. CommuniGate Pro files are text files, and text files on MS Windows and Unix have different EOL (end of line) symbols: CR-LF (return - linefeed) on MS Windows and bare LF (linefeed) symbol on Unix systems. To copy files properly, you may want to use any FTP software to copy files between those systems: when an FTP client is instructed to transfer files in the ASCII mode, it properly converts EOL symbols.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>CommuniGate Pro base directory can contain non-text (binary) files in the <code>WebSkins</code> and <code>PBXApps</code> directories inside the Account and Domains subdirectories - graphic, audio, and video files used in the custom Skin Interfaces and Real-Time Applications.</p><p>Account File Storage can also contain binary files. These files are stored in the <code>account.web</code> directories inside the Account directories.</p><p>The mailbox files with <code>.mb4</code> and <code>.emb4</code> extensions are binary and must not be converted.</p><p>When you move a CommuniGate Pro <em>base directory</em> between systems using different EOL conventions, check that those binary files are copied in the BINARY mode (i.e. without EOL re-coding).</p></div><p>If the new server computer is running a Unix system, check that the copied directory and all its files and subdirectories have the same access rights as they had on the old system.</p><p>After the CommuniGate Pro <em>base directory</em> is copied, download and install the proper version of the CommuniGate Pro Server on the new server computer. There is no need to copy the content of <a href="#Install">application directory</a> from the old server computer, even if both new and old computers are running the same operating system.</p><p>Check that the newly installed copy of the CommuniGate Pro Server (its startup script, if any) is configured to use the copied base directory, and then start the CommuniGate Pro Server on the new computer. Use the WebAdmin Interface to modify the computer-related settings on the new server. For example, you may need to update the Client IP Addresses table or re-assign IP addresses to CommuniGate Pro Domains.</p>`,28)]))}const u=t(n,[["render",o]]);export{m as __pageData,u as default};
