import{_ as t,c as o,o as a,ag as s}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Migrating to CommuniGate Pro","description":"","frontmatter":{"legacyLink":"Migration.html"},"headers":[],"relativePath":"admin/install/Migration.md","filePath":"admin/install/Migration.md"}'),r={name:"admin/install/Migration.md"};function i(n,e,d,l,c,h){return a(),o("div",null,e[0]||(e[0]=[s('<h1 id="migrating-to-communigate-pro" tabindex="-1">Migrating to CommuniGate Pro <a class="header-anchor" href="#migrating-to-communigate-pro" aria-label="Permalink to &quot;Migrating to CommuniGate Pro&quot;">​</a></h1><p>If your system was already running some type of E-mail server, you may want to integrate your existing E-mail environment into the CommuniGate Pro messaging system.</p><p>To migrate all your users, you need:</p><ul><li>to create all existing mail accounts on your new CommuniGate Pro Server, using already specified account settings, especially - account passwords</li><li>to migrate all user E-mail from the old server to the new CommuniGate Pro Server</li></ul><h2 id="External" tabindex="-1">Supporting Network Users <a class="header-anchor" href="#External" aria-label="Permalink to &quot;Supporting Network Users {#External}&quot;">​</a></h2><p>Users that access their mail accounts using any standard Internet Protocol (POP, IMAP) do not have to switch their mailer applications or change mailer settings - CommuniGate Pro supports not only the published mail access protocols standards, but most of unofficial protocol extensions, too.</p><h2 id="Mailboxes" tabindex="-1">Using Legacy Mailbox files <a class="header-anchor" href="#Mailboxes" aria-label="Permalink to &quot;Using Legacy Mailbox files {#Mailboxes}&quot;">​</a></h2><p>One of the supported Mailbox formats supported by CommuniGate Pro is the BSD-type text mailbox format: a Mailbox is a text file with messages separated with an empty line and a line starting with the symbols <code>From</code> .</p><p>Since most legacy mail systems use this format, the existing mailbox files can be used when migrating to CommuniGate Pro. You should either copy the old mailbox files into the proper places in the CommuniGate Pro Account directories, or you can specify that some Accounts have Legacy INBOXes (see above), and the old mailbox files will be used &quot;in place&quot;.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When CommuniGate Pro stores a message in a BSD-type Mailbox, it adds additional fields to the separator (<code>From</code>) line. These fields are ignored by legacy mailers and mail servers, but they allow the CommuniGate Pro Server to keep the message status and unique message ID information. When you make your CommuniGate Pro Server use a BSD-type mailbox file composed with an old mail system, it issues warnings (Log records) about missing fields in the message separators. The Server still opens such mailboxes: it creates empty status flag sets for such messages, and it generates unique IDs on-fly. As users read, move, and/or delete old mail from their mailboxes, messages stored with the old mail system disappear, and the Server stops complaining when opening these mailbox files.</p></div><h2 id="Passwords" tabindex="-1">Converting Passwords <a class="header-anchor" href="#Passwords" aria-label="Permalink to &quot;Converting Passwords {#Passwords}&quot;">​</a></h2><p>If your old mail server authenticated clients are using the Unix OS account and passwords (the <code>passwd</code> and <code>shadow</code> files), you can simply enable the <a href="./../sysadmin/Security.html">Use OS Password</a> option for those accounts and the CommuniGate Pro Server will use the OS authentication procedures for them.</p><p>Since the OS Passwords are one-way encrypted, they cannot be used for secure SASL authentication methods. The following procedure can be used to allow migrated users to employ the secure SASL methods:</p><ul><li>enable the Use OS Password option either in the Default Account Settings or in the Account Template.</li><li>specify an empty string for the CommuniGate Password in the Account Template.</li><li>import all accounts without the Password field.</li></ul><p>Users can connect to the newly created accounts using their old OS Passwords - i.e. the same passwords they used with the legacy mail system. When users try to modify their account passwords, the new passwords will be stored as CommuniGate Passwords. All users that have updated their passwords will be able to use the secure SASL authentication methods.</p><p>Sometimes you cannot use this method. For example, you migrate users from a different server, and you do not register them all with the Unix OS on the new server, but you do have the <code>passwd</code> file from the old server. In this case, you may want to enter the Unix-style (<code>crypt</code>-encrypted) passwords as the CommuniGate (internal) Passwords.</p><p>To make the CommuniGate Pro server process its internal password string as a <code>U-crpt</code> (<code>crypt</code>-encrypted) or other support encrypted password (see below), store the password in the Account Settings with one-byte binary 002 prefix. If you want to create a user <code>test</code> using the <a href="./../../development/CLI.html">CLI</a> interface, and the Unix (<code>crypt</code>-encrypted) password for that user is <code>AslUzT1JkPsocc</code>, then use the following CLI command:<br><code>createaccount &quot;test&quot; {Password=&quot;\\002AslUzT1JkPsocc&quot;;}</code></p><p>If you create users by <a href="./../objects/Accounts.html#Loader">importing</a> an account list from a text file, place the Unix passwords strings into the <code>UnixPassword</code> column, not into the Password column. In this case, the Loader will automatically add the binary 002 prefix to all password strings. If you create users using the <a href="./../directory/CentralDir.html#LDAPProvisioning">LDAP Provisioning</a> feature, specify the encrypted password as the <code>unixPassword</code> attribute.</p><p>Account Settings of the new accounts should specify one of the CommuniGate Pro <em>password encryption</em> methods (clear text or A-crpt). Users will be able to log in using their old Unix/encrypted passwords. When they update their passwords, new CommuniGate Password strings will be stored using the specified CommuniGate Pro password encryption method. All users that have updated their passwords will be able to use the secure SASL authentication methods.</p><p>Some servers produced by the Netscape and Software.com companies store user passwords using several encryption methods. When passwords are retrieved from those servers, they have the following form:<br><code>{_method_}_eNcoDeD_</code><br> or<br><code>$_method_$_eNcoDeD_</code><br> where <em>method</em> specifies one of the standard encryption methods, and the <em>eNcoDeD</em> string is an encrypted password (sometime - Base64-encoded).</p><p>CommuniGate Pro can use these passwords in the same way it uses the Unix-encrypted passwords, and they should be entered in the same way: you should use the binary 002 prefix in the CLI commands and/or you should place those passwords into the UnixPassword field of the <a href="./../objects/Accounts.html#Loader">Account Import file</a>.</p><p>The following encryption methods are supported:</p><ul><li><code>{crypt}</code> - the standard Unix crypt method.</li><li><code>{WM-CRY}</code> - the standard Unix crypt method (same as {crypt}).</li><li><code>{MD5}</code> - the MD5 digesting method (Base-64 encoded MD5 digest of the password string).</li><li><code>{SHA}</code> - the SHA1 digesting method (Base-64 encoded SHA1 digest of the password string).</li><li><code>{NS-MTA-MD5}</code> - the MD5-based method used in the Post.Office servers and old Netscape Messaging Servers (the eNcoDeD portion contains 64 hexadecimal digits).</li><li><code>{SSHA}</code> - the &quot;salted SHA1&quot; digesting method (Base-64 encoded SHA1 digest of the password and salt strings, followed with the salt bytes). This method is used in the Sun Directory Server application.</li><li><code>{LANM}</code> - the &quot;LAN Manager&quot; hash used in Microsoft Windows servers (the eNcoDeD portion contains 32 hexadecimal digits).</li><li><code>{MSNT}</code> - the &quot;Microsoft NT&quot; hash used in Microsoft Windows servers (the eNcoDeD portion contains 32 hexadecimal digits).</li><li><code>$1$</code> - MD5-based password hash used in FreeBSD and some other Unix systems.</li><li><code>$2a$</code> - BlowFish-based password hash used in OpenBSD and some other Unix systems.</li></ul><p>The following is a sample Import file:</p><table tabindex="0"><thead><tr><th>Name</th><th>UnixPassword</th><th>Password Type</th></tr></thead><tbody><tr><td><code>user1</code></td><td><code>YIdhkjeHDKbYsji</code></td><td>Unix-crypt</td></tr><tr><td><code>user2</code></td><td><code>{SHA}Ue4Erbim2TC7CmuukMOBejeytr2=</code></td><td>SHA1-digested</td></tr><tr><td><code>user3</code></td><td><code>{MD5}zverMUhsgJUIDjeytr2=</code></td><td>MD5-digested</td></tr><tr><td><code>user4</code></td><td><code>{crypt}YIdhkjeHDKbYsji</code></td><td>Unix-crypt, same as for the <code>user1</code> account</td></tr><tr><td><code>user5</code></td><td><code>$1$VlPrB$vNjOAytB3W.j0bkkbaN2Z.</code></td><td>BSD-type MD5-encrypted</td></tr></tbody></table><p>You can use a CommuniGate Pro CLI script to automatically import all users and their passwords from the OS <code>/etc/passwd</code> file. See the <a href="http://www.communigatepro.ru/CGPerl/" target="_blank" rel="noreferrer">CommuniGate Perl Interface</a> site for a sample script.</p><h2 id="Sendmail" tabindex="-1">Migrating from <code>sendmail</code> <a class="header-anchor" href="#Sendmail" aria-label="Permalink to &quot;Migrating from `sendmail` {#Sendmail}&quot;">​</a></h2><p>If you are migrating from a <code>sendmail</code>-based mail system, you may find the following information useful:</p><ul><li><p>The <code>aliases</code> file</p><p>The sendmail aliases file allows the administrator to redirect local mail to one or several addresses. Sendmail uses the term &quot;alias&quot; for too many different things, so you should select the proper CommuniGate Pro feature to implement different types of sendmail &quot;aliases&quot;:</p></li><li><p>Each account can have one or several <a href="./../objects/Accounts.html">aliases</a>. Mail sent to any Account Alias name is routed to the Account itself. If the <code>domain.dom</code> Account <code>john.smith</code> has <code>j.smith</code> and <code>smith</code> aliases, mail sent to <code>j.smith@domain.dom</code> and <code>smith@domain.dom</code> addresses is delivered to the <code>john.smith@domain.dom</code> Account. When an Account is renamed, its Aliases automatically start to point to the new name, and when an Account is removed, all its Aliases are removed, too.</p></li><li><p>Domain <a href="./../objects/Forwarders.html">Forwarder</a> objects allow you to redirect mail sent to a Domain address to any other address. The <code>domain.dom</code> Forwarder <code>susan.smith</code> can reroute all mail sent to <code>susan.smith@domain.dom</code> address to the <code>susan@otherisp.dom</code> address.</p></li><li><p>Domain <a href="./../objects/Groups.html">Group</a> objects allow you to redirect mail sent to some Domain address to any set of addresses.</p></li><li><p>The <a href="./../sysadmin/Router.html">Router</a> module allows you to redirect mail sent to a certain address to any other address. The Router Alias Record <code>&lt;*.smith@domain.dom&gt; = Smith@domain.dom</code> will reroute mail sent to <code>john.smith@domain.dom</code> and to <code>susan.smith@domain.dom</code> to the <code>Smith@domain.dom</code> address.</p></li><li><p>The <a href="./../objects/Accounts.html">Account Rules</a> allow the administrator and/or the users themselves to redirect/forward/mirror all or certain mail to one or several addresses.</p></li><li><p>The <a href="./../mail/QueueRules.html">Server-Wide Rules</a> allow the administrator to redirect/forward/mirror all or certain mail to one or several addresses.</p></li><li><p>The shared or <a href="./../storage/Mailboxes.html#Foreign">Foreign Mailboxes</a> feature allows a user to grant access to a Mailbox to other users; in many cases a shared Mailbox is a much better alternative to mail distribution.</p></li><li><p>The <a href="./../mail/LIST.html">LIST</a> module provides a very powerful mailing list distribution mechanism.</p></li><li><p><code>procmail</code> processing</p><p>The Server-Wide, Domain-Wide, and Account-Level <a href="./../mail/QueueRules.html">Automated Rules</a> allow administrators and users to perform automatic mail processing and filtering using the powerful condition checking and processing operations built into the CommuniGate Pro Server.<br> For the situations where messages should be processed using an external filter or processor, the <code>Execute</code> Automated Rules operation can be used to start the specified external program as a separate OS task (for example, the Rules can be used to process all or certain incoming messages with the same <code>procmail</code> program).</p></li></ul><h2 id="Exchange" tabindex="-1">Migrating from Microsoft® Exchange Servers <a class="header-anchor" href="#Exchange" aria-label="Permalink to &quot;Migrating from Microsoft® Exchange Servers {#Exchange}&quot;">​</a></h2><p>The special <a href="http://www.communigatepro.ru/CGFromExchange/" target="_blank" rel="noreferrer">Exchange Migration Utility</a> allows you to retrieve user lists from an Exchange server and to create those users in CommuniGate Pro Domains. The utility copies all user folder data (mail, calendaring, contacts, etc.) converting data and address formats &quot;on-the-fly&quot;.</p><p>The utility requires an MS Windows workstation to run.</p><h2 id="IMAPMove" tabindex="-1">Copying Mailboxes from Other IMAP Servers <a class="header-anchor" href="#IMAPMove" aria-label="Permalink to &quot;Copying Mailboxes from Other IMAP Servers {#IMAPMove}&quot;">​</a></h2><p>If you have a list of account names and passwords you can copy the contents of the mail folders accessible via IMAP protocol from the Other Server by using the <a href="http://www.communigatepro.ru/syncIMAPMail/" target="_blank" rel="noreferrer">syncIMAPMail</a> mail migration and synchronization utility.</p><p>If the passwords are not known then you can:</p><ul><li>authenticate as admin and specify the name of the account being copied via <code>--proxyAuth</code> option, if that IMAP extension is supported by the Other Server.</li><li>authenticate as admin via PLAIN method and specify the name of the account being copied, if that authentication method is supported by the Other Server.</li><li>reset the passwords to a known value.</li></ul><h2 id="ExtAuth" tabindex="-1">Migrating from an Arbitrary Server (&quot;on-the-fly&quot; migration) <a class="header-anchor" href="#ExtAuth" aria-label="Permalink to &quot;Migrating from an Arbitrary Server (&quot;on-the-fly&quot; migration) {#ExtAuth}&quot;">​</a></h2><p>Use this alternative migration method when the password switching method explained above cannot be used, and/or the user names and passwords cannot be retrieved from the old server.</p><p>The method is based on the <a href="./../sysadmin/Security.html#External">External Authentication</a> feature of the CommuniGate Pro server.</p><p>Download, install, and tailor the <a href="http://www.communigatepro.ru/CGAUTH/authMigrate.pl" target="_blank" rel="noreferrer">migration script</a>, and configure CommuniGate Pro to use this script as the CommuniGate Pro External Authentication program.</p><p>Create the target CommuniGate Pro Domain, and enable the Consult External for Unknown Domain settings. In &quot;Login Methods&quot; disable all methods except PLAIN and SESSIONID to force users&#39; mail applications to submit only unencrypted passwords. Disable the &quot;Use CommuniGate Password&quot; option and enable the &quot;Use External Password option&quot; in the Account Template.</p><p>When a user attempts to connect to a non-existent Account, or when CommuniGate Pro receives a message for non-existent Account, the External Authentication script is called. The script connects to the old server using the SMTP protocol and checks if the account with the same name (same address) exists on the old server. If the old server does not reject the address, the script creates the Account with this name in the CommuniGate Pro Domain. Then the CommuniGate Pro Server delivers the message to this newly created Account.</p><p>When a user connects to the CommuniGate Pro Server, the user mailer sends the user name and the user password in the plain text form. Because the CommuniGate Pro Account has the Use CommuniGate Password option disabled, and the Use External Password option enabled, the External Authentication script is called. The script connects to the old server using the POP or IMAP protocol and checks if it can log into the old server with the provided user credentials.</p><p>If the old server accepts the specified password:</p><ul><li>the script uses the CommuniGate Pro <a href="./../../development/CLI.html">CLI</a>: <ul><li>to set the specified password as the CommuniGate Password for this Account,</li><li>to switch off the Use External Password option for this Account,</li><li>to switch on the Use CommuniGate Password option for this Account.</li></ul></li><li>the script starts the syncIMAPMail programs to copy the account mailboxes from the old server to the CommuniGate Pro server, or saves the name/password pairs into a text file which you can use later (this is a configurable option).</li></ul><p>After the first successful login, the correct password will be set as the new CommuniGate Password, and all Account mail will be copied from the old server.</p><p>After all old server users have successfully connected to the CommuniGate Pro server at least once, all their Accounts will be created and have the correct CommuniGate Passwords set. Then you can disable the External Authentication script and retire the old server.</p><h2 id="Calendars" tabindex="-1">Migration of Calendars and Contacts <a class="header-anchor" href="#Calendars" aria-label="Permalink to &quot;Migration of Calendars and Contacts {#Calendars}&quot;">​</a></h2><p>If Calendars and Contacts can be exported from the Other Server as text files in <code>vCalendar</code> and <code>vCard</code> formats respectively, then they can be imported via <a href="./WebCalendar.html#ImportExport">Importing Calendars</a> and <a href="./WebContacts.html#ImportExport">Importing Contacts</a> in CommuniGate Pro WebMail interface.</p><p>Importing the data of multiple users can be automated via <code>importCalendars.pl</code> script from the <a href="http://www.communigatepro.ru/ScriptRepository/" target="_blank" rel="noreferrer">Script Repository for CommuniGate Pro</a>.</p><h2 id="Switching" tabindex="-1">Switching Servers <a class="header-anchor" href="#Switching" aria-label="Permalink to &quot;Switching Servers {#Switching}&quot;">​</a></h2><p>Very often it is essential to switch to the new server without any interruption in the services you provide.</p><p>If you install the new CommuniGate Pro server on the same system as the old mail server, you should:</p><ul><li>switch CommuniGate Pro <a href="./../access/IMAP.html">IMAP service</a> to port 144, so it will not interfere with your old server IMAP activity.</li><li>Configure CommuniGate Pro and create <a href="./../objects/Domains.html#Aliases">Domain Aliases</a> and/or full featured Secondary <a href="./../objects/Domains.html">Domains</a>.</li><li>Create some test accounts in the main and secondary domains and check that you can log into those accounts using <a href="./../access/WebUser.html">WebUser Interface</a>.</li><li>Check that you can send mail from those accounts using the <a href="./../access/WebUser.html">WebUser Interface</a>: mail to other test accounts in the created domains and mail to other servers should be delivered correctly.</li><li>If you have an IMAP client that allows you to specify a non-standard port number, check that you can log into the test accounts on the IMAP port 144.</li><li>Create tab-delimited file(s) with names, passwords, and other attributes of your existing accounts and use the <a href="./../objects/Accounts.html#Loader">Account Import</a> feature to create all accounts on your new server.</li></ul><p>All this can be done while your old server is still active.</p><p>Now, you should stop your old server activity by either changing its port numbers to non-standard values, or by disconnecting it from the external network.</p><p>Use the <a href="http://www.communigatepro.ru/syncIMAPMail/" target="_blank" rel="noreferrer"><code>syncIMAPMail</code></a> program to copy all messages from your old server to CommuniGate Pro.</p><p>When all messages are copied, change the CommuniGate Pro IMAP port number back to 143. Now CommuniGate Pro will operate as your mail server, without any interruption in the services you provide.</p><p>You may want to keep the old server running for several hours - in case its queue contained some delayed outgoing messages. Just check that the old server does not try to use the standard ports.</p><h2 id="MoveToSecondary" tabindex="-1">Moving to Secondary Domains <a class="header-anchor" href="#MoveToSecondary" aria-label="Permalink to &quot;Moving to Secondary Domains {#MoveToSecondary}&quot;">​</a></h2><p>If you create several <a href="./../objects/Domains.html">Secondary domains</a> in CommuniGate Pro, you may want to move accounts from your old server(s) to a Secondary CommuniGate Pro Domain, not to its Main Domain.</p><p>In this case, you should add the NewName field to your account list file, and copy all names into that column, adding the <code>@domainname</code> string to each name.</p><p>If you use the IMAP protocol to move messages between the servers, you may use a simpler method:</p><ul><li>If the target domain has an IP address assigned to that domain, use that address in the mail copying programs: all non-qualified names provided on connections established with that address are interpreted as names in that domain. See the <a href="./../cluster/Access.html">Access</a> section for the details.</li><li>If the target domain does not have an assigned IP address, temporarily assign the IP address of the main domain to that secondary domain. Move the messages, and remove the IP address from the list of addresses assigned to that domain.</li></ul>',64)]))}const p=t(r,[["render",i]]);export{u as __pageData,p as default};
