import{_ as s,C as r,c as u,o as p,ag as l,j as e,G as n,w as a,a as i}from"./chunks/framework.jCcxW76o.js";const A=JSON.parse('{"title":"External Filters","description":"","frontmatter":{"legacyLink":"VirusScan.html"},"headers":[],"relativePath":"admin/mail/ExternalFilters.md","filePath":"admin/mail/ExternalFilters.md"}'),d={name:"admin/mail/ExternalFilters.md"},m={action:"Null.html"},v={class:"settingsBox"},c={width:"100%"},h={class:"settingsBox",width:"100%"},g={colspan:"2",align:"center"},f={class:"settingsBox",width:"100%"},y={colspan:"2",align:"center"},b={class:"settingsBox",width:"100%"},x={colspan:"2",align:"center"};function S(E,t,P,w,T,F){const o=r("font");return p(),u("div",null,[t[16]||(t[16]=l('<h1 id="external-filters" tabindex="-1">External Filters <a class="header-anchor" href="#external-filters" aria-label="Permalink to &quot;External Filters&quot;">​</a></h1><p>This section explains how CommuniGate Pro can employ External Filter programs to scan messages. This feature is used to implement virus protection and content filtering.</p><p>The CommuniGate Pro Filters provide a much more solid solution than various stand-alone SMTP-based &quot;mail scanners&quot;:</p><ul><li>Stand-alone &quot;scanner&quot; SMTP relays usually implement only the basic SMTP functions. Since all SMTP connections have to be established to those relays, and not to the CommuniGate Pro SMTP module, the CommuniGate Pro SMTP extended functionality becomes unavailable to users and other SMTP servers.</li><li>Stand-alone &quot;scanner&quot; SMTP relays usually provide much weaker performance and reliability than CommuniGate Pro Servers. When the &quot;scanner&quot; relay goes down, the CommuniGate Pro SMTP functionality becomes unavailable, too.</li><li>Stand-alone &quot;scanner&quot; SMTP relays usually cannot scan several messages simultaneously, so when a large message is being scanned, the SMTP traffic to the CommuniGate Pro Server stops.</li><li>Stand-alone &quot;scanner&quot; SMTP relays cannot scan messages not submitted via SMTP. For example, messages composed using the WebUser Interface and directed to a user on the same CommuniGate Pro Server are delivered without any SMTP transfer operations.</li></ul><p>External Filters run alongside the CommuniGate Pro Server. They do not deal with message transfer protocols. Instead, the CommuniGate Pro Server passes them a message file right before the message is being enqueued into module queues. As a result, all messages can be scanned, not only the messages sent via a particular mail transfer protocol.</p><p>If the CommuniGate Pro <a href="./">ENQUEUER</a> is configured to use several processors (threads), several messages can be scanned simultaneously. As a result, long messages that require several seconds of scanning time do not stop the message flow.</p><p>The third-party Plugins distributed by CommuniGate Systems usually require an additional License Key. Several Plugins are <a href="./default.html#Plugins">currently available</a>.</p><p>The <a href="./../../development/Helpers.html">Helpers</a> section specifies the information about the External Filters protocol. Read that section if you plan to design a new Plugin.</p><h2 id="Launch" tabindex="-1">Starting External Filters <a class="header-anchor" href="#Launch" aria-label="Permalink to &quot;Starting External Filters {#Launch}&quot;">​</a></h2><p>After you have installed an External Filter program, or built your own one, use the CommuniGate Pro WebAdmin Interface to configure the External Filters. Open the General pages in the Settings realm, and click the Helpers link.</p>',10)),e("form",m,[e("div",v,[e("table",c,[e("tbody",null,[t[15]||(t[15]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Content Filtering")])],-1)),e("tr",null,[e("td",null,[e("table",h,[e("tbody",null,[e("tr",null,[t[1]||(t[1]=e("td",{align:"right"},[e("select",{name:"U3"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])],-1)),t[2]||(t[2]=e("td",null,[e("input",{name:"N3",value:"VirusScan",size:"15",maxlength:"200",type:"text"})],-1)),e("td",g,[n(o,{color:"red"},{default:a(()=>t[0]||(t[0]=[e("i",null,null,-1)])),_:1})])]),t[3]||(t[3]=e("tr",null,[e("td",{align:"right",width:"25%"},"Log Level:"),e("td",null,[e("select",{name:"L3"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",width:"25%"},"Program Path:"),e("td",null,[e("input",{name:"P3",value:"VirusScan\\scan.exe",size:"30",maxlength:"255",type:"text"})])],-1)),t[4]||(t[4]=e("tr",null,[e("td",{align:"right"},"Time-out:"),e("td",null,[e("select",{name:"T3"},[e("option",{value:"0"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30",selected:"selected"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min")])]),e("td",{align:"right"},"Auto-Restart:"),e("td",null,[e("select",{name:"A3"},[e("option",{value:"0"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15",selected:"selected"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"5400"},"90 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)")])])],-1))])])])]),e("tr",null,[e("td",null,[e("table",f,[e("tbody",null,[e("tr",null,[t[6]||(t[6]=e("td",{align:"right"},[e("select",{name:"U4"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])],-1)),t[7]||(t[7]=e("td",null,[e("input",{name:"N4",value:"SpamCheck",size:"15",maxlength:"200",type:"text"})],-1)),e("td",y,[n(o,{color:"red"},{default:a(()=>t[5]||(t[5]=[e("i",null,null,-1)])),_:1})])]),t[8]||(t[8]=e("tr",null,[e("td",{align:"right",width:"25%"},"Log Level:"),e("td",null,[e("select",{name:"L4"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",width:"25%"},"Program Path:"),e("td",null,[e("input",{name:"P4",value:"SpamScan\\Scanner.exe -v",size:"30",maxlength:"255",type:"text"})])],-1)),t[9]||(t[9]=e("tr",null,[e("td",{align:"right"},"Time-out:"),e("td",null,[e("select",{name:"T4"},[e("option",{value:"0"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60",selected:"selected"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min")])]),e("td",{align:"right"},"Auto-Restart:"),e("td",null,[e("select",{name:"A4"},[e("option",{value:"0"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60",selected:"selected"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"5400"},"90 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)")])])],-1))])])])]),e("tr",null,[e("td",null,[e("table",b,[e("tbody",null,[e("tr",null,[t[11]||(t[11]=e("td",{align:"right"},[e("select",{name:"U5"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])],-1)),t[12]||(t[12]=e("td",null,[e("input",{name:"N5",value:"",size:"15",maxlength:"200",type:"text"})],-1)),e("td",x,[n(o,{color:"red"},{default:a(()=>t[10]||(t[10]=[e("i",null,null,-1)])),_:1})])]),t[13]||(t[13]=e("tr",null,[e("td",{align:"right",width:"25%"},"Log Level:"),e("td",null,[e("select",{name:"L5"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",width:"25%"},"Program Path:"),e("td",null,[e("input",{name:"P5",value:"",size:"30",maxlength:"255",type:"text"})])],-1)),t[14]||(t[14]=e("tr",null,[e("td",{align:"right"},"Time-out:"),e("td",null,[e("select",{name:"T5"},[e("option",{value:"0",selected:"selected"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min")])]),e("td",{align:"right"},"Auto-Restart:"),e("td",null,[e("select",{name:"A5"},[e("option",{value:"0",selected:"selected"},"Never"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"5400"},"90 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)")])])],-1))])])])])])])])]),t[17]||(t[17]=l('<p>To specify a new External Filter program to run, use the last element in this table. Assign some name to the Filter program and enter into the first field. You will use this name when you specify the <code>ExternalFilter</code> Rule actions.<br> Enter the program path and other options, and click the Update button.</p><p>To remove an External Filter program, enter an empty string into its Filter name field, and click the Update button.</p><p>Each External Filter program has the following options:</p><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the External Filter module should put in the Server Log. Usually you should use the <code>Problems</code> Log level (status change and non-fatal errors). But when you experience problems with the External Filter program, you may want to set the Log setting to <code>Low-Level</code> or <code>All Info</code>: in this case the inter-program protocol-level details will be recorded in the System Log as well.<br> The External Filter records in the System Log are marked with the <code>EXTFILTER</code> tag.</p></li><li><p><code>Program Path</code></p><p>Use this setting to specify the file name path for the External Filter program (with optional parameters). If the External Filter Software has been installed inside the CommuniGate Pro <em>base directory</em>, you can use the relative path (<code>VirusScan\\scan.exe</code>, for example). Otherwise, use the full path (such as <code>D:\\Programs\\VirusScan\\scan.exe</code> or <code>/usr/sbin/myFilter</code>).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Always use the backslash (<code>\\\\</code>) path separators if the CommuniGate Pro Server runs on a Microsoft Windows platform.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>On Unix platforms, if you want to specify parameters that include spaces or other special symbols, enclose them into the quote (<code>&quot;</code>) symbols. On other platforms, use the platform-specific agreements for command line parameters.</p></div></li></ul><p>Set the first option value to Enabled, and click the Update button to start the External Filter program. If the program cannot be started, an error message appears on the Helpers page.</p><ul><li><p><code>Time-out</code></p><p>Certain conditions and/or errors in the External program code can make it enter a loop and stop responding to CommuniGate Pro Server requests. If a response for any of the Server requests is not received within the specified period of time, the Server sends a termination signal to the External Program.</p></li><li><p><code>Auto-Restart</code></p><p>Certain conditions and/or errors in the External program code can crash that program. Also, the Server itself can send a termination signal to the External program if the program does not respond to requests within the specified period of time (see above).<br> If the Auto-Restart parameter is not set to Never, the CommuniGate Pro server detects the External Program termination, waits for the specified period of time, and then restarts the External Program automatically. Then it resends all pending requests to the newly started External Program and resumes normal request processing.<br> If the Auto-Restart parameter is set to Never, you need to open the Helpers WebAdmin page and click the Update button to force the Server to restart the External program.</p></li></ul><h2 id="Scanning" tabindex="-1">Using External Filters <a class="header-anchor" href="#Scanning" aria-label="Permalink to &quot;Using External Filters {#Scanning}&quot;">​</a></h2><p>An enabled External Filter is not used for scanning mail messages by default. If you have specified an External Filter program with the <em>filterName</em> name, you can scan all messages with that program by creating a Server-Wide <a href="./QueueRules.html">Rule</a>. Specify no condition for that Rule (so the Rule will apply to all messages the Server processes), and specify one Rule action - <code>ExternalFilter filterName</code>.</p><p>Messages are scanned only when the option next to the Filter name is set to Enabled. You may want set this option to Disabled to let messages bypass this External Filter program. If this option is set to Disabled, the <code>ExternalFilter filterName</code> Rule operation is a null operation (it does nothing).</p><p>If you want to scan only some messages, add condition(s) to this Rule. The following sample Rule check the size of a message, and uses the <code>VirusScan</code> External Filter program to scan only those messages that are larger than the specified limit:</p>',10)),t[18]||(t[18]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Data"),e("th",null,"Operation"),e("th",null,"Parameter")]),e("tr",null,[e("td",null,[e("select",{name:"c0"},[e("option",{value:"0"},"---"),e("option",{value:"1"},"From"),e("option",{value:"2"},"Sender"),e("option",{value:"3"},"Return-Path"),e("option",{value:"4"},"To"),e("option",{value:"5"},"Cc"),e("option",{value:"6"},"Any To or Cc"),e("option",{value:"7"},"Each To or Cc"),e("option",{value:"8"},"Reply-To"),e("option",{value:"9"},"'From' Name"),e("option",{value:"10"},"Subject"),e("option",{value:"11"},"Message-ID"),e("option",{value:"12",selected:"selected"},"Message Size"),e("option",{value:"13"},"Time Of Day"),e("option",{value:"14"},"Current Date"),e("option",{value:"15"},"Current Day"),e("option",{value:"16"},"Human Generated"),e("option",{value:"17"},"Header Field"),e("option",{value:"18"},"Any Recipient"),e("option",{value:"19"},"Each Recipient"),e("option",{value:"20"},"Existing Mailbox"),e("option",{value:"21"},"Security"),e("option",{value:"22"},"Source"),e("option",{value:"23"},"Submit Address"),e("option",{value:"24"},"Any Route"),e("option",{value:"25"},"Each Route")])]),e("td",null,[e("select",{name:"o0"},[e("option",{value:"0"},"is"),e("option",{value:"1"},"is not"),e("option",{value:"2"},"in"),e("option",{value:"3"},"not in"),e("option",{value:"4",selected:"selected"},"greater than"),e("option",{value:"5"},"less than")])]),e("td",null,[e("input",{name:"p0",value:"2048",size:"20",maxlength:"5000",type:"text"})])]),e("tr",null,[e("td",null,[e("select",{name:"c1"},[e("option",{value:"0"},"---"),e("option",{value:"1"},"From"),e("option",{value:"2"},"Sender"),e("option",{value:"3"},"Return-Path"),e("option",{value:"4"},"To"),e("option",{value:"5"},"Cc"),e("option",{value:"6"},"Any To or Cc"),e("option",{value:"7"},"Each To or Cc"),e("option",{value:"8"},"Reply-To"),e("option",{value:"9"},"'From' Name"),e("option",{value:"10"},"Subject"),e("option",{value:"11"},"Message-ID"),e("option",{value:"12"},"Message Size"),e("option",{value:"13"},"Time Of Day"),e("option",{value:"14"},"Current Date"),e("option",{value:"15"},"Current Day"),e("option",{value:"16"},"Human Generated"),e("option",{value:"17"},"Header Field"),e("option",{value:"18"},"Any Recipient"),e("option",{value:"19"},"Each Recipient"),e("option",{value:"20"},"Existing Mailbox"),e("option",{value:"21"},"Security"),e("option",{value:"22"},"Source"),e("option",{value:"23"},"Submit Address"),e("option",{value:"24"},"Any Route"),e("option",{value:"25"},"Each Route")])]),e("td",null,[e("select",{name:"o1"},[e("option",{value:"0"},"is"),e("option",{value:"1"},"is not"),e("option",{value:"2"},"in"),e("option",{value:"3"},"not in"),e("option",{value:"4"},"greater than"),e("option",{value:"5"},"less than")])]),e("td",null,[e("input",{name:"p1",value:"",size:"20",maxlength:"5000",type:"text"})])]),e("tr",{align:"left"},[e("th",null,"Action"),e("th",{colspan:"2"},"Parameter")]),e("tr",{valign:"top"},[e("td",null,[e("select",{name:"a0"},[e("option",{value:"0"},"---"),e("option",{value:"1"},"Store in"),e("option",{value:"2"},"Store Encrypted in"),e("option",{value:"3"},"Mark"),e("option",{value:"4"},"Add Header"),e("option",{value:"5"},"Tag Subject"),e("option",{value:"6"},"Reject with"),e("option",{value:"7"},"Discard"),e("option",{value:"8"},"Stop Processing"),e("option",{value:"9"},"Remember 'From' in"),e("option",{value:"10"},"Accept Request"),e("option",{value:"11"},"Redirect To"),e("option",{value:"12"},"Forward to"),e("option",{value:"13"},"Mirror to"),e("option",{value:"14"},"Reply with"),e("option",{value:"15"},"Reply to All with"),e("option",{value:"16"},"React with"),e("option",{value:"17"},"SendIM"),e("option",{value:"18"},"SendURL"),e("option",{value:"19"},"Execute"),e("option",{value:"20"},"Write To Log"),e("option",{value:"21",selected:"selected"},"ExternalFilter")])]),e("td",{colspan:"2"},[e("textarea",{name:"r0",cols:"40",rows:"4"},"VirusScan")])]),e("tr",{valign:"top"},[e("td",null,[e("select",{name:"a1"},[e("option",{value:"0"},"---"),e("option",{value:"1"},"Store in"),e("option",{value:"2"},"Store Encrypted in"),e("option",{value:"3"},"Mark"),e("option",{value:"4"},"Add Header"),e("option",{value:"5"},"Tag Subject"),e("option",{value:"6"},"Reject with"),e("option",{value:"7"},"Discard"),e("option",{value:"8"},"Stop Processing"),e("option",{value:"9"},"Remember 'From' in"),e("option",{value:"10"},"Accept Request"),e("option",{value:"11"},"Redirect To"),e("option",{value:"12"},"Forward to"),e("option",{value:"13"},"Mirror to"),e("option",{value:"14"},"Reply with"),e("option",{value:"15"},"Reply to All with"),e("option",{value:"16"},"React with"),e("option",{value:"17"},"SendIM"),e("option",{value:"18"},"SendURL"),e("option",{value:"19"},"Execute"),e("option",{value:"20"},"Write To Log"),e("option",{value:"21"},"ExternalFilter")])]),e("td",{colspan:"2"},[e("textarea",{name:"r1",cols:"40",rows:"4"})])])])])])],-1)),t[19]||(t[19]=e("p",null,[i("External Filters are contacted from the Server "),e("a",{href:"./"},"ENQUEUER"),i(" threads. Since it can take several seconds to process a large message, increase the number of ENQUEUER processors (threads) using the Queue page in the WebAdmin Interface Settings realm.")],-1)),t[20]||(t[20]=e("p",null,"Alternatively, you can disable the Enqueue Asynchronously option (on the same page), and make each submitting thread scan the messages during the submit process.",-1))])}const C=s(d,[["render",S]]);export{A as __pageData,C as default};
