import{_ as a,C as n,c as l,o as r,ag as o,j as e,a as s,G as d,w as c}from"./chunks/framework.jCcxW76o.js";const M=JSON.parse('{"title":"LIST Module","description":"","frontmatter":{"legacyLink":"LIST.html"},"headers":[],"relativePath":"admin/mail/LIST.md","filePath":"admin/mail/LIST.md"}'),p={name:"admin/mail/LIST.md"},h={action:"Null.html"},u={class:"settingsBox"},m={width:"100%"},b={border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},g={align:"right"};function f(v,t,y,w,x,S){const i=n("font");return r(),l("div",null,[t[12]||(t[12]=o('<h1 id="list-module" tabindex="-1">LIST Module <a class="header-anchor" href="#list-module" aria-label="Permalink to &quot;LIST Module&quot;">​</a></h1><p>The CommuniGate Pro LIST module implements the mailing list mechanism. It also implements mail distribution to <a href="./../objects/Groups.html">Groups</a>.</p><h2 id="Description" tabindex="-1">Mailing Lists <a class="header-anchor" href="#Description" aria-label="Permalink to &quot;Mailing Lists {#Description}&quot;">​</a></h2><p>The system administrator can create one or several mailing lists. Users from the same or any other mail system can subscribe to these mailing lists using the Web interface or by sending E-mail. They can post messages on mailing lists by sending E-mail to the list addresses, and posted messages are delivered to all subscribers. All posted messages are stored in the mailing list Mailbox that serves as an archive.</p><p>If a user subscribes in the FEED mode, all posted messages are redirected to that user immediately after they are received by the LIST module.</p><p>When a user subscribes in the DIGEST mode, the user starts to receive list digests: a multi-part messages generated with the LIST module for each mailing list. Each digest message contains all messages posted on the list since the last digest was generated, prefixed with an index of these messages.</p><p>When a user subscribes in the INDEX mode, the user starts to receive messages containing the indexes of newly posted messages. If the user wants to read some of the posted messages, they can use a Web browser to access the mailing list archive.</p><h2 id="Configuring" tabindex="-1">Configuring the LIST module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the LIST module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the LIST module. Open the Mail pages in the Settings realm, then open the LIST page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Processors: <select name="ListProcessors"><option value="0">off</option><option value="1">1</option><option value="2" selected="selected">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="4">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log setting to specify what kind of information the LIST module should put in the Server Log. Usually you should use the <code>Major</code> (message processing reports) level. But when you experience problems with the LIST module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in these cases more details will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The LIST module records in the System Log are marked with the <code>LIST</code> tag.</p></li><li><p><code>Processors</code></p><p>When you specify a non-zero value for the <code>Processors</code> setting, the LIST module starts to process queued messages directed to mailing lists, starts to generate digests, and starts to clean the mailing list archives. The module can use several simultaneous processors (threads) to process several mailing lists at the same time. If you have more than 50 mailing lists, or if you have many lists with extremely large (10,000+) subscriber lists, you should allow the module to use more than 1 processor.</p></li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Mailing Lists</b></td></tr><tr align="left"><th>Name</th><th>Domain</th><th>Owner</th></tr><tr><td><a href="#Create">SIMS</a></td><td><a href="../objects/Domains.md">node5.communigatepro.ru</a></td><td><a href="../objects/Accounts.md">ali</a></td></tr><tr><td><a href="#Create">CGatePro</a></td><td><a href="../objects/Domains.md">test.communigatepro.ru</a></td><td><a href="../objects/Accounts.md">kwa</a></td></tr></tbody></table></div></form><p>This table shows all mailing lists created. By following the links in the table, you can open an individual list setup page, the <a href="./../objects/Domains.html">Domain Settings</a> page for the list Domain, or the <a href="./../objects/Accounts.html">Account Settings</a> page for the mailing list owner.</p><h3 id="Creating" tabindex="-1">Creating Mailing Lists <a class="header-anchor" href="#Creating" aria-label="Permalink to &quot;Creating Mailing Lists {#Creating}&quot;">​</a></h3><p>Each Mailing List is created inside the Main or one of the secondary <a href="./../objects/Domains.html">Domains</a>, and each Mailing List belongs to its owner - an Account in the same Domain.</p><p>To create a Mailing List, create an Account or choose an existing one - the List owner Account. Use the WebAdmin Interface to open the <a href="./../objects/Accounts.html">Account Settings</a> page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Mailing Lists</b></td></tr><tr align="left"><th>Name</th><th align="center">Subscribers</th></tr><tr><td><a href="#ConfigList">rd-list</a></td><td align="center">1025</td></tr><tr><td><a href="#ConfigList">marketing</a></td><td align="center">127</td></tr><tr><th colspan="2" align="left"><input name="NewList" value="Create Mailing List" type="reset" class="button"> <input name="NewListName" size="20" maxlength="255" type="text" value="sales-updates"></th></tr></tbody></table></div></form><p>To create a mailing list, type the list name and click the Create Mailing List button.</p><p>If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Mailing Lists</a> Access Right to create Mailing Lists in your Domain.</p><p>The Server checks that there is no Account or other <a href="./../objects/">Object</a> with the same name in this Domain, and creates a new Mailing List.</p><p>Several <a href="./../storage/Mailboxes.html">Mailboxes</a> are created in the List owner Account:</p><ul><li><p><em>listname</em></p><p>this Mailbox is the Mailing List archive: it contains the messages posted to this Mailing List</p></li><li><p><em>listname</em>/requests</p><p>this Mailbox contains the messages with subscription requests.</p></li><li><p><em>listname</em>/reports</p><p>this Mailbox contains bounce and other DSN (Delivery Status Notification) messages generated for the messages distributed via this Mailing List.</p></li><li><p><em>listname</em>/approval</p><p>this Mailbox contains postings that require the list owner approval (moderated postings).</p><p>To post these messages, the Mailing List owner should redirect them back to the Mailing List using an authenticated submit method: a <a href="./../access/MAPI.html">MAPI</a> or <a href="./../access/XIMSS.html">XIMSS</a> client, the CommuniGate Pro <a href="./../access/WebUser.html">WebUser Interface</a>, the XTND XMIT <a href="./../access/POP.html">POP3</a> method, a local &quot;mail&quot; command, the <a href="./PIPE.html">PIPE</a> module, etc.</p></li></ul><h3 id="ConfigList" tabindex="-1">Configuring Mailing Lists <a class="header-anchor" href="#ConfigList" aria-label="Permalink to &quot;Configuring Mailing Lists {#ConfigList}&quot;">​</a></h3><p>To configure a Mailing List, open the Mailing List Settings page. You should select a link to the Settings page either from the list of all mailing lists located in the LIST module Settings page, or from the list owner <a href="./../objects/Accounts.html">Account Settings page</a>.</p><p>You should have the <a href="./../sysadmin/#Privs">All Domains</a> Server Administrator access right or the <a href="./../sysadmin/#Domain">Domain Administrator</a> access right in order to open the Mailing List Settings pages via the WebAdmin Interface.</p><p>In order to modify a Mailing List settings or subscriber lists, the Domain Administrator should have the <code>CanAccessLists</code> access right.</p><p>The list owners can access the Mailing List settings pages using the WebUser Interface with their Accounts. The WebUser session page listing Mailboxes and Mailbox folders also provides links to the Account Mailing Lists pages.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><th align="right">Log:</th><th><select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5" selected="selected">All Info</option></select></th><th><a href="#Subscribers">Subscribers</a></th><th align="right">Owner:</th><th><a href="../objects/Accounts.md">listmaster</a></th></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log setting to specify what kind of information about this mailing list should be put in the Server Log. Usually you should use the <code>Major</code> (message posting, subscription, digest, and clean-up operations) level. But when you experience problems with this particular mailing list, you may want to set the list Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case more details will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The mailing list records placed in the System Log are marked with the <code>List(listname)</code> tag.<br> Only the system administrator can change the mailing list Log setting.</p></li></ul>',29)),t[13]||(t[13]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("th",{align:"right",nowrap:"nowrap"},"Description:"),e("td",null,[s(" "),e("input",{type:"text",name:"RealName",value:"R&D Discussion",size:"30",maxlength:"99"})])]),e("tr",null,[e("th",{align:"right",nowrap:"nowrap"},"Preferred Character Set:"),e("td",null,[s(" "),e("select",{name:"charset"},[e("option",{value:"0",selected:"selected"},"ISO-8859-1"),e("option",{value:"1"},"ISO-2022-JP"),e("option",{value:"2"},"KOI8-R")])])]),e("tr",null,[e("th",{align:"right",nowrap:"nowrap"},"Digest & Archive:"),e("td",null,[s(" "),e("select",{name:"Store"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])])]),e("tr",null,[e("th",{align:"right",nowrap:"nowrap"},"Verify Owner Using:"),e("td",null,[s(" "),e("select",{name:"OwnerCheck"},[e("option",{value:"0"},"Return-Path"),e("option",{value:"1"},"IP Addresses"),e("option",{value:"2",selected:"selected"},"Authentication")])])])])])])],-1)),t[14]||(t[14]=o('<ul><li><p><code>Description</code></p><p>Use the Description setting to specify the full name of the list. It will be used as a &quot;comment&quot; in the list E-mail address as the Real Name setting is used in account E-mail addresses.</p></li><li><p><code>Preferred Character Set</code></p><p>This option specifies how the List module should handle non-ASCII texts. It is used when displaying list messages via the Web interface: messages in the list can be composed using different character sets, and to display them all on one page, the module should know which character set is preferred.</p></li><li><p><code>Digesting and Archiving</code></p><p>Posted messages can be stored in a Mailbox created in the list owner Account. Such a Mailbox is used to collect messages for message digests. If messages are not removed from that Mailbox after a digest is created, this Mailbox can be used as a mailing list archive.</p><ul><li><p><code>Enabled</code></p><p>All posted messages are stored in the owner Account Mailbox. Use the link next to the pop-up menu to open the Digesting and Archiving Settings page.</p></li><li><p><code>Disabled</code></p><p>The posted messages are not stored in the owner Account Mailbox, archiving and digesting options are disabled.<br> All digest and index-mode subscribers are processed as feed-mode subscribers.<br> All new attempts to subscribe to the mailing list in the digest or index mode are rejected.</p></li></ul></li><li><p><code>Verify Owner</code></p><p>When the LIST module receives an E-mail message, it checks if the message is sent by the List Owner. First, the message Return-Path is compared to the list owner E-mail address. The Return-Path should be <code>ownerName@listdomain</code>, where the ownerName is the owner Account name (not one of its aliases), and the listdomain is the list and owner Account Domain name (not one of its Domain aliases).</p><p>The Verify Owner setting specifies the additional checks to be made:</p><ul><li><p><code>Return-Path</code></p><p>When this option is selected, no additional check is made.</p></li><li><p><code>IP Addresses</code></p><p>When this option is selected, the LIST module checks that the message has been submitted either using one of the <em>authenticating</em> methods (see below), or via SMTP, from a computer with an IP address included into the <a href="./../sysadmin/Protection.html">Client IP Addresses</a> list.</p></li><li><p><code>Authentication</code></p><p>When this option is selected, the LIST module checks that the message has been submitted using one of the <em>authenticating</em> methods:</p><ul><li>via <a href="./SMTP.html">SMTP</a>, using the AUTH authenticaiton;</li><li>via <a href="./../access/WebUser.html">WebUser Interface</a>;</li><li>via <a href="./../access/POP.html">POP</a> with XTND XMIT extension;</li><li>via the <a href="./PIPE.html">PIPE</a> module.</li></ul></li></ul></li></ul><p>The Settings page contains a set of options, settings, and text areas that controls the subscription, postings, message distribution, and bounce processing. See the sections below for the details.</p><h3 id="Rename" tabindex="-1">Renaming Mailing Lists <a class="header-anchor" href="#Rename" aria-label="Permalink to &quot;Renaming Mailing Lists {#Rename}&quot;">​</a></h3><p>To rename a mailing list, open that list Settings page via the System Administrator Web interface (see above).</p><p>You should have the <a href="./../sysadmin/#Privs">All Domains</a> Server Administrator access right or the <a href="./../sysadmin/#Domain">Domain Administrator</a> access right in order to open the Mailing List Settings pages.</p><p>Enter the new name for the list in the Mailing List Settings page, and click the Rename button. The Server checks if there is no Account or Mailing List with the new name in the same Domain and renames the mailing list. Then the Mailing List Settings page is reopened.</p><h3 id="Remove" tabindex="-1">Removing Mailing Lists <a class="header-anchor" href="#Remove" aria-label="Permalink to &quot;Removing Mailing Lists {#Remove}&quot;">​</a></h3><p>To remove a mailing list, open that list Settings page via the System Administrator Web interface (see above).</p><p>Click the Remove List button. A confirmation page appears. If you click the Remove button on the confirmation page, the list is removed, the files with the list subscribers and list settings are deleted, and the mailing list Mailboxes are removed from the list owner Account.</p><h2 id="Macro" tabindex="-1">Composing Service Texts <a class="header-anchor" href="#Macro" aria-label="Permalink to &quot;Composing Service Texts {#Macro}&quot;">​</a></h2><p>Several Mailing list settings specify texts to be sent to the subscribers - message subjects, message headers and trailers, confirmation requests, etc. A specified text can contain special symbol combinations to be substituted with actual data before the text is inserted into a message.</p><p>The following symbol combinations can be used:</p><table tabindex="0"><thead><tr><th>Where</th><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td>All Texts</td><td><code>^N</code></td><td>the <em>listname</em> string</td></tr><tr><td></td><td><code>^D</code></td><td>the <em>domain</em> string</td></tr><tr><td></td><td><code>^E</code></td><td>the Description setting</td></tr><tr><td>Digest Subject, Header, Trailer</td><td><code>^X</code></td><td>the sequence number of the current digest</td></tr><tr><td>Feed Subject Prefix, Header, Trailer</td><td><code>^B</code></td><td>the sequence number of the current message</td></tr><tr><td></td><td><code>^C</code></td><td>the original message &#39;From&#39; address</td></tr></tbody></table><p>If there is a number after a special symbol combination (as in <code>^N80</code>), the number specifies the maximum length of the substitution string.<br> If a substitution is longer than specified, its last symbols are cut off.</p><p>If there is a number after a special string combination, and the number starts with 0, as in <code>^N040</code>, the number specifies the length of the substitution string.<br> If a substitution string is longer than specified, its last symbols are cut off, and if a string is shorter than specified, space symbols are added to the beginning of the string.<br> If the number starts with two 0 symbols, the 0 symbols are used instead of spaces.</p><h2 id="Subscription" tabindex="-1">Subscription Processing <a class="header-anchor" href="#Subscription" aria-label="Permalink to &quot;Subscription Processing {#Subscription}&quot;">​</a></h2><p>Each mailing list is a list of subscribers, i.e. a list of E-mail addresses receiving messages posted on the mailing list.</p><p>In order to subscribe, unsubscribe, and change their <a href="#Modes">subscription mode</a> via E-mail, users of the <em>listname</em>@<em>domain</em> mailing list should send any message to the following addresses:</p><table tabindex="0"><thead><tr><th>Address</th><th>New user</th><th>Existing subscriber</th></tr></thead><tbody><tr><td><code>listname-on@domain</code> or <code>listname-subscribe@domain</code></td><td>to subscribe to the list in the default mode</td><td>to confirm the current subscription mode</td></tr><tr><td><code>listname-feed@domain</code></td><td>to subscribe to the list in the FEED mode</td><td>to change the subscription mode to FEED</td></tr><tr><td><code>listname-digest@domain</code></td><td>to subscribe to the list in the DIGEST mode</td><td>to change the subscription mode to DIGEST</td></tr><tr><td><code>listname-index@domain</code></td><td>to subscribe to the list in the INDEX mode</td><td>to change the subscription mode to INDEX</td></tr><tr><td><code>listname-null@domain</code></td><td>to subscribe to the list in the NULL mode</td><td>to change the subscription mode to NULL</td></tr><tr><td><code>listname-off@domain</code> or <code>listname-unsubscribe@domain</code></td><td></td><td>to unsubscribe from the list</td></tr><tr><td><code>listname-confirm@domain</code></td><td></td><td>to get the confirmation ID; this ID can be used as the password for other subscription operations and for list archive browsing</td></tr></tbody></table><p>When subscription request messages are sent to these addresses, the message <code>From:</code> header fields are used as requesters E-mail addresses.</p><p>You can specify who can subscribe to the mailing list, and how they should subscribe.</p>',21)),t[15]||(t[15]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Subscription Policy")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Subscribe:"),e("td",null,[e("select",{name:"Subscribe"},[e("option",{value:"0"},"nobody"),e("option",{value:"1"},"moderated"),e("option",{value:"2"},"this domain only"),e("option",{value:"3"},"locals only"),e("option",{value:"4",selected:"selected"},"anybody")])]),e("td",{align:"right",nowrap:"nowrap"},"Requests to Save"),e("td",null,[e("select",{name:"SaveRequests"},[e("option",{value:"0"},"no"),e("option",{value:"1",selected:"selected"},"accepted"),e("option",{value:"2"},"rejected"),e("option",{value:"3"},"all")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Default Mode:"),e("td",null,[e("select",{name:"Distribution"},[e("option",{value:"0",selected:"selected"},"feed"),e("option",{value:"1"},"digest"),e("option",{value:"2"},"index"),e("option",{value:"3"},"null"),e("option",{value:"4"},"banned")])]),e("td"),e("td",{nowrap:"nowrap"},[e("input",{name:"Confirmation",value:"1",checked:"checked",type:"checkbox"}),s("Request Confirmation")])]),e("tr",null,[e("th",{colspan:"4"},"Confirmation Request Message")]),e("tr",null,[e("td",{align:"right"},"Subject:"),e("td",{colspan:"3"},[e("input",{name:"ConfirmationSubject",size:"40",maxlength:"200",value:"Confirmation Request (^I)",type:"text"})])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Text:"),e("td",{colspan:"3"},[e("textarea",{name:"ConfirmationText",cols:"50",rows:"3"},`This is an automated message from the <^N@^D> mailing list manager
Somebody (probably you) have requested the ^P operation for your <^A> address
If you want to confirm this operation, use the Reply command in your mailer.
Check that the Subject of the reply message contains the confirmation ID: ^I, the reply is directed to <^N-^O@^D>, and the 'From' address of your reply is <^A>.
If you do not want to confirm the requested operation, simply do nothing
All requests about this mailing list should be sent to <^N-request@^D>`)])])])])])],-1)),t[16]||(t[16]=o('<ul><li><p><code>Subscribe</code></p><ul><li><p><code>nobody</code></p><p>users cannot subscribe to this mailing list and/or change the subscription mode by themselves. Only the system administrator and the list owner can do these operations. Users still can unsubscribe by themselves.</p></li><li><p><code>this domain only</code></p><p>only users from the mailing list Domain can subscribe.</p></li><li><p><code>locals Only</code></p><p>only users registered with this Server can subscribe.</p></li><li><p><code>anybody</code></p><p>any user on any system can subscribe to this list.</p></li><li><p><code>moderated</code></p><p>all subscription requests will be stored in the <code>listname/requests</code> Mailbox (see below) and should be approved by the list owner. The List owner should redirect these requests to the <em>listname</em>-on, <em>listname</em>-feed and other addresses to subscribe new users and to let them change the subscription mode. Users still can unsubscribe by themselves. When user requests are stored in the <code>listname/requests</code> Mailbox for approval, they are &quot;flagged&quot; (get the Flag marker).</p></li></ul></li><li><p><code>Save Requests</code></p><p>This setting specifies which subscription requests (i.e. messages sent to the <em>listname</em>-on, <em>listname</em>-off and other addresses listed above) should be stored in the <code>listname/requests</code> Mailbox in the list owner Account. Messages stored in this Mailbox can be examined if some user reports problems when trying to subscribe to, unsubscribe from, or change the subscription mode to this list.<br> You can specify if none, all, only the accepted, or only the rejected request messages should be stored in the <em>listname</em>/requests Mailbox.<br> Requests waiting for the list owner approval are always stored in the <code>listname/requests</code> Mailbox.</p><p>All stored request messages get the <code>X-List-Report</code> additional header field . This field contains the list manager report (Delivery Status Notification message). It is recommended that the List owners configure their mailer applications so they display the X-List-Report fields.</p></li><li><p><code>Default Mode</code></p><p>When a new user sends a subscription request in to the <em>listname</em>-on@<em>domain</em> or <em>listname</em>-subscribe@<em>domain</em> address, i.e. when the subscription mode is not specified, the mode specified with the Default Mode setting is used.</p></li></ul><h3 id="Modes" tabindex="-1">Subscription Modes <a class="header-anchor" href="#Modes" aria-label="Permalink to &quot;Subscription Modes {#Modes}&quot;">​</a></h3><p>Each list user (E-mail address) is subscribed in one of the following modes:</p><ul><li><p><code>FEED</code></p><p>In this mode, the subscriber receives list messages as they are posted. See the <a href="#FEED">FEED Mode Distribution</a> section for more details.</p></li><li><p><code>DIGEST</code></p><p>In this mode, the subscriber periodically receives <em>digest</em> messages. A digest message starts with the Table Of Content - the list of the messages posted, followed by the posted messages themselves. See the <a href="#DIGEST">DIGEST/INDEX Mode Distribution</a> section for more details.</p></li><li><p><code>INDEX</code></p><p>In this mode, the subscriber periodically receives <em>index</em> messages. An index message is the same as the digest Table Of Content, but it does not contain the posted messages themselves. INDEX subscribers can see if they are interested in any posted messages, and use the Web interface to read those messages in the mailing list archive.<br> See the <a href="#DIGEST">DIGEST/INDEX Mode Distribution</a> section for more details.</p></li><li><p><code>NULL</code></p><p>In this mode, the subscriber does not receive any messages from the list. This mode can be used by the &quot;posters&quot; - the list users that only post messages on the list.</p></li><li><p><code>BANNED</code></p><p>The &quot;banned&quot; users do not receive messages from the list, and they cannot change their subscription mode themselves.<br> You can use this method to make it impossible for certain users to subscribe to your mailing lists, though usually the more generic anti-spam and other system-wide protection methods should be used.</p></li></ul><h3 id="Confirmation" tabindex="-1">Confirmation Requests <a class="header-anchor" href="#Confirmation" aria-label="Permalink to &quot;Confirmation Requests {#Confirmation}&quot;">​</a></h3><p>There are several very common problems with most of publicly available mailing lists:</p><ul><li>subscription messages are sent from incorrect addresses, those incorrect addresses are inserted into the subscribers list, and mailing list messages are repeatedly sent to those incorrect or unused addresses.</li><li>list abusers (such as spammers) subscribe nonexistent E-mail addresses just to allow themselves to post on the lists that accept posts from subscribers only.</li><li>using easily forged message headers, some persons can subscribe and unsubscribe another person E-mail addresses.</li></ul><p>These and some other problems can be solved using confirmation requests.</p><ul><li><p><code>Request Confirmations</code></p><p>When this option is selected, the List manager does not fulfill subscription requests immediately. Instead, a confirmation request message is composed and sent to the address that is about to be included or excluded from the subscribers list. The confirmation request contains a unique identifier (Confirmation ID) in its Subject field. When the user receives such a confirmation request, they can simply use the mailer Reply command to confirm the requested operation.</p></li><li><p><code>Confirmation Message</code></p><p>These text settings allow you to specify the subject and the body of confirmation request messages the module sends to the subscribers. In addition to generic &quot;symbol combinations&quot;, these service texts can also contain the following combinations:</p><table tabindex="0"><thead><tr><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td><code>^O</code></td><td>the requested operation</td></tr><tr><td><code>^P</code></td><td><code>unsubscribe</code> for the <code>unsubscribe</code> operation, <code>subscribe</code> for the <code>subscribe</code> operation, and <code>subscribe(operation)</code> for other operations</td></tr><tr><td><code>^A</code></td><td>the subscriber address</td></tr><tr><td><code>^I</code></td><td>the confirmation identifier</td></tr></tbody></table></li></ul><h3 id="SubscribeMessages" tabindex="-1">Welcome and Good Bye Messages <a class="header-anchor" href="#SubscribeMessages" aria-label="Permalink to &quot;Welcome and Good Bye Messages {#SubscribeMessages}&quot;">​</a></h3>',10)),t[17]||(t[17]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Welcome/Policy Message")])]),e("tr",null,[e("td",{align:"right"},"Subject:"),e("td",null,[e("input",{name:"PolicySubject",size:"40",maxlength:"200",value:"Welcome!",type:"text"})])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Text:"),e("td",null,[e("textarea",{name:"PolicyText",cols:"50",rows:"3"},'This is an automated message from the <^N@^D> mailing list manager You are subscribed to "^E" <^N@^D> as <^A> To unsubscribe, send any message to: <^N-off@^D> To switch to the FEED mode, send any message to <^N-feed@^D> To switch to the DIGEST mode, send any message to <^N-digest@^D> To switch to the INDEX mode, send any message to <^N-index@^D> Send administrative queries to <^N-request@^D>')])])])])])],-1)),t[18]||(t[18]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Good Bye Message")])]),e("tr",null,[e("td",{align:"right"},"Subject:"),e("td",null,[e("input",{name:"ByeSubject",size:"40",maxlength:"200",value:"Good Bye!",type:"text"})])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Text:"),e("td",null,[e("textarea",{name:"ByeText",cols:"50",rows:"3"},"Your address <^A> has been removed from the <^N@^D> mailing list Thank you for being with us, and please come back soon")])])])])])],-1)),t[19]||(t[19]=o('<p>When a new user is subscribed, the Policy Text message is sent to that new user. When a user unsubscribes, the Good Bye message is sent.</p><p>Besides the generic &quot;symbol combinations&quot;, these service texts can also contain the following combinations:</p><table tabindex="0"><thead><tr><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td><code>^A</code></td><td>the subscriber address</td></tr><tr><td><code>^I</code></td><td>the confirmation identifier</td></tr></tbody></table><h2 id="Postings" tabindex="-1">Posting Messages <a class="header-anchor" href="#Postings" aria-label="Permalink to &quot;Posting Messages {#Postings}&quot;">​</a></h2><p>To post a message on the mailing list, the author should send it to the <em>listname</em>@<em>domain</em> address.</p>',5)),t[20]||(t[20]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Posting Policy")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Accept Postings:"),e("td",null,[e("select",{name:"Postings"},[e("option",{value:"0"},"from owner only"),e("option",{value:"1"},"moderated"),e("option",{value:"2",selected:"selected"},"from subscribers"),e("option",{value:"3"},"moderate guests"),e("option",{value:"4"},"from anybody")])]),e("td",{align:"right",nowrap:"nowrap"},"New Subscribers:"),e("td",null,[e("select",{name:"FirstModerated"},[e("option",{value:"0"},"Unmoderated"),e("option",{value:"1"},"Moderate first"),e("option",{value:"2",selected:"selected"},"Moderate first 2"),e("option",{value:"3"},"Moderate first 3"),e("option",{value:"5"},"Moderate first 5"),e("option",{value:"10"},"Moderate first 10"),e("option",{value:"10000"},"Moderate All"),e("option",{value:"10001"},"Prohibit"),e("option",{value:"10002"},"Special")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Allowed Format:"),e("td",null,[e("select",{name:"Format"},[e("option",{value:"0"},"plain text only"),e("option",{value:"1",selected:"selected"},"text only"),e("option",{value:"2"},"text alternative"),e("option",{value:"3"},"anything")])]),e("td",{align:"right",nowrap:"nowrap"},"Maximum Size:"),e("td",null,[e("select",{name:"SizeLimit"},[e("option",{value:"-1"},"Unlimited"),e("option",{value:"0"},"0 Kbyte"),e("option",{value:"1024"},"1 Kbyte"),e("option",{value:"3072"},"3 Kbytes"),e("option",{value:"10240"},"10 Kbytes"),e("option",{value:"30720",selected:"selected"},"30 Kbytes"),s(),e("option",{value:"102400"},"100 Kbytes"),e("option",{value:"307200"},"300 Kbytes"),e("option",{value:"1048576"},"1 Mbyte"),e("option",{value:"3145728"},"3 Mbytes"),e("option",{value:"10485760"},"10 Mbytes"),e("option",{value:"31457280"},"30 Mbytes"),e("option",{value:"104857600"},"100 Mbytes"),e("option",{value:"314572800"},"300 Mbytes")])])]),e("tr",null,[e("td",{rowspan:"2",align:"right"},"Prohibit:"),e("td",{colspan:"3",nowrap:"nowrap"},[e("input",{name:"CheckCharset",value:"1",type:"checkbox"}),s("Non-matching Character Set")])]),e("tr",null,[e("td",{colspan:"3",nowrap:"nowrap"},[e("input",{name:"CheckDigestSubject",value:"1",checked:"checked",type:"checkbox"}),s("Unmodified Digest Subjects")])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Service Fields:"),e("td",{colspan:"3"},[e("textarea",{name:"ListFields",rows:"3",cols:"50"},"*auto*")])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"Compose 'From' Address as:"),e("td",null,[e("select",{name:"FromAddressMode"},[e("option",{value:"0"},"Author Name and Address"),e("option",{value:"1"},"Author Name and List Address"),e("option",{value:"2",selected:"selected"},"Author Name with Address and List Address")])])])])])])],-1)),t[21]||(t[21]=o('<ul><li><p><code>Accept Postings</code></p><p>This setting specifies who can post messages on this mailing list:</p><ul><li><p><code>from owner only</code></p><p>Only messages submitted by the list owner (using any authenticated method) will be posted</p></li><li><p><code>moderated</code></p><p>Messages from everybody but the list owner are redirected to the list owner for approval; if the list owner redirects a message back to the list, the message is posted.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This mode can be used to change the list posting policy when the list owner wants to postpone all postings. If you use the <code>from subscribers</code> mode, the New Subscribers setting (see below) provides more advanced moderation options.</p></div></li><li><p><code>from subscribers</code></p><p>Messages from the list subscribers are accepted for posting; some messages can be moderated (see below).</p></li><li><p><code>moderate guests</code></p><p>Messages from the list subscribers are accepted for posting; some messages can be moderated (see below). Messages from addresses that are not subscribed are moderated.</p></li><li><p><code>from anybody</code></p><p>Messages from any address are accepted for posting.</p></li></ul></li><li><p><code>New Subscribers</code></p><p>This setting is effective only if the Accept Postings setting is set to <code>from subscribers</code>. When a user subscribes and starts to post messages, the messages are stored in the list owner Mailbox waiting for approval. After the specified number of messages is approved and posted, all messages sent by this user are posted on the list directly, without the list owner approval.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This is a very effective way to enforce the list policies and to protect the mailing list from &quot;spamming&quot;.</p></div><p>If you set this option to <code>Moderate All</code>, then all messages from new subscribers will be stored for approval (the LIST module will not update the posted messages counter).</p><p>If you set this option to <code>Prohibited</code> new subscribers won&#39;t be able to post on the list (their postings will be rejected).</p><p>If you set this option to <code>Special</code>, new subscribers will be able to post auto-generated messages. This is useful if you want to subscribe this mailing list to other mailing lists.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When an auto-generated message should be posted on the list, and the message is not a message generated by the list owner, the message <code>Sender</code> address (if exists) is used instead of the <code>From</code> address. If that address is subscribed to the list, and the subscriber posting mode is set to <code>Special</code>, the message is posted.</p></div><p>You can open the <a href="#Subscribers">subscribers list</a> and change this setting for individual subscribers. You may want to change this setting to <code>Unmoderated</code> for some users, letting only those users post messages on the list, while posting from all other users (and new users) will be either stored for approval or rejected.</p></li><li><p><code>Allowed Format</code></p><p>This setting specifies the allowed MIME format for postings.</p><ul><li><p><code>plain text only</code></p><p>only messages in the text/plain format can be posted</p></li><li><p><code>text only</code></p><p>only messages in the text (text/plain, text/html, etc.) formats can be posted</p></li><li><p><code>text alternative</code></p><p>only messages in the text format or multipart/alternative messages that contain a part in the text format can be posted (for example, a message can contain a <code>text/html</code> variant part and the same text as a <code>image/gif</code> variant part)</p></li><li><p><code>anything</code></p><p>messages in any MIME format can be posted</p></li></ul><p>The list owner can always post messages in any format.</p></li><li><p><code>Maximum Size</code></p><p>This setting restricts the size of messages that can be posted on this mailing list. The list owner can always post messages of any size.</p></li><li><p><code>Prohibit Unmodified Digest Subject</code></p><p>When this option is selected, the Subject fields of all postings are checked. If the Subject is a &quot;reply prefix&quot; (such as Re:, Re&gt;, etc.) followed by this list Digest String (see <a href="#DIGEST">below</a>), the message is rejected.</p></li><li><p><code>Prohibit Non-matched Character Set</code></p><p>When this option is selected, the character set used to compose the posting is checked. If the character set is explicitly specified, and it does not match the Preferred Character Set for this list, the message is rejected.</p></li><li><p><code>Service Fields</code></p><p>Use this option to specify the message header fields to be added to all distributed messages (feed, digest and index). If this option value starts with the asterisk (<code>*</code>) symbol, the module automatically generates the <code>List-ID</code>, <code>List-Unsubscribe</code>, <code>Precedence</code> and (if list browsing is enabled) <code>List-Archive</code> fields.</p><p>Otherwise, the specified fields are added. The following symbol combinations can be used in this field:</p><table tabindex="0"><thead><tr><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td><code>^N</code></td><td>the <em>listname</em> string</td></tr><tr><td><code>^D</code></td><td>the <em>domain</em> string</td></tr><tr><td><code>^P</code></td><td>the first HTTP User module port</td></tr><tr><td><code>^R</code></td><td>the <code>http</code> or the <code>https</code> string, depending on the type of the first HTTP User module port</td></tr></tbody></table></li><li><p><code>Compose &#39;From&#39; Address as:</code></p><p>This setting specifies how the &#39;From&#39; addresses of the senders are modified in posted messages.</p><ul><li><p><code>Author Name and Address</code></p><p>The original Author name (the comment part) and address are used.</p></li><li><p><code>Author Name and List Address</code></p><p>The Author name is used but the address is replaced with the List address. Use this option to make List messages to be compatible with DMARC.</p></li><li><p><code>Author Name with Address and List Address</code></p><p>Same as above but also the Author address is inserted into the comment part.</p></li></ul></li></ul><h2 id="Processing" tabindex="-1">Processing Messages <a class="header-anchor" href="#Processing" aria-label="Permalink to &quot;Processing Messages {#Processing}&quot;">​</a></h2><p>When a posted message is being sent to subscribers, the original message header is modified. Usually, only the From, Date, Message-ID, and Subject fields are copied from the original message.</p><p>You can specify additional header fields to be copied from original postings to the messages sent to subscribers - directly or as parts of digests.</p>',4)),t[22]||(t[22]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"RFC822 Fields to Keep")])]),e("tr",null,[e("td",{nowrap:"nowrap"},[s("To/Cc: "),e("select",{name:"KeepToAndCc"},[e("option",{value:"0"},"remove"),e("option",{value:"1"},"keep"),e("option",{value:"2"},"copy as Cc")])]),e("td",null,[e("input",{name:"SupplFields",value:"X-Mailer",size:"10",maxlength:"100",type:"text"})])])])])])],-1)),t[23]||(t[23]=o('<ul><li><p><code>RFC822 Fields to Keep</code></p><p>Use these fields to specify the names of additional RFC822 header fields to be copied from the original postings to the distributed messages. If you want to remove a name, enter an empty string into the name field.</p><p>If you want to copy all header fields, enter the asterisk (*) symbol into the first field.</p><p>If you want to copy the Message-ID for the messages distributed using the &quot;feed&quot; mode, include the Message-ID field name.</p><p>If the To And Cc option is set to:</p><ul><li>remove - the original <code>To</code> and <code>Cc</code> fields are not copied; the Mailing List address is added as the <code>To</code> field;</li><li>keep - the original <code>To</code> and <code>Cc</code> are copied;</li><li>copy as Cc - the original <code>To</code> and <code>Cc</code> fields are copied as <code>Cc</code> fields; the Mailing List address is added as the <code>To</code> field.</li></ul></li></ul><h2 id="Bounce" tabindex="-1">Bounce Processing <a class="header-anchor" href="#Bounce" aria-label="Permalink to &quot;Bounce Processing {#Bounce}&quot;">​</a></h2><p>Incorrect and expired E-mail addresses create the most annoying problems for mailing list administrators. The CommuniGate Pro LIST module automates processing of incorrect, expired, and temporarily unavailable addresses.</p><p>All messages sent to subscribers (in all modes) have message envelope information that routes all error reports back to the LIST module. When a report is received, the LIST module:</p><ul><li>stores the report in the <code>listname/reports</code> Mailbox in the owner Account (optional);</li><li>parses the report text;</li><li>if the report has a correct delivery-report (RFC1892/RFC894) structure, processes all records in the report.</li></ul><p>Most of the problems can be detected immediately when sending a list message from the CommuniGate Pro Server, so most of the error reports are generated locally, on the same CommuniGate Pro server. The CommuniGate Pro server generates reports in the proper format, so most of the delivery problems are handled automatically.</p><p>If a list message has been sent to a remote site without a problem, but then that remote site fails to deliver the message to the recipient, the delivery report is generated on that remote site. Most of the modern mail servers generate delivery reports in the correct format, so in this case many problems are handled automatically, too.</p><p>And, finally, it is still possible to receive unformatted delivery reports from other sites. The LIST module can store those unformatted reports in the <em>listname</em>/reports Mailbox, so the list owner can process them manually.</p><p>Each record in the delivery report contains information about one E-mail address, and indicates if the original message was or was not delivered to that address. It can also specify if the delivery problem is fatal (as when account is removed from the system), or if it is a non-fatal, temporary problem (as when a remote site is down or when the account disk space quota is exceeded).</p><p>If a non-fatal report is received, the E-mail address in question is suspended, and no list messages are sent to that address, and all additional error reports about that address are ignored. When the LIST module performs periodic list clean-ups, it sends a warning message to all suspended addresses. The warning message notifies that user that some list messages have not been delivered to the user address, and it also asks the user to confirm subscription (by replying to the warning message).</p><p>There are two ways to specify the suspension period:</p><ul><li>An address can be suspended for a fixed period of time. When that period ends, the LIST module resumes sending list messages to this address. This can result in new bounces which will increment the bounce counter, and the address is unsubscribed after the bounce counter exceeds the specified limit.<br> The warning messages are sent to the failed address after the suspension is over, too - till the user confirms the subscription by replying to the warning message.</li><li>An address can be suspended till the user confirms subscription by replying to the warning message. If no confirmation is received during the specified period of time, the address is unsubscribed.</li></ul><p>When a user confirms the subscription by replying to the warning message, the suspension period ends, and the bounce counter associated with the user E-mail address is cleared.</p>',13)),t[24]||(t[24]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Bounce Processor")])]),e("tr",{valign:"top"},[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"On a Non-Fatal Bounce:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"tillConfirmed",value:"0",checked:"checked",type:"radio"})]),e("td",{align:"right",nowrap:"nowrap"},"suspend subscription for:"),e("td",null,[e("select",{name:"CoolOffPeriod"},[e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600",selected:"selected"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"864000"},"10 day(s)")])])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"unsubscribe after:"),e("td",null,[e("select",{name:"maxBounces"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5",selected:"selected"},"5"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"200"},"200")]),s(" bounces")])]),e("tr",null,[e("td",null,[e("input",{name:"tillConfirmed",value:"1",type:"radio"})]),e("td",{colspan:"2",nowrap:"nowrap"},"suspend till confirmation")]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"unsubscribe after:"),e("td",null,[e("select",{name:"UnsubBouncedPeriod"},[e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800",selected:"selected"},"7 day(s)"),e("option",{value:"864000"},"10 day(s)"),e("option",{value:"2592000"},"30 day(s)")])])])])])])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Process a Fatal Bounce as:"),e("td",null,[e("select",{name:"FatalWeight"},[e("option",{value:"1"},"Non-Fatal"),e("option",{value:"3"},"3 Non-Fatal"),e("option",{value:"10"},"10 Non-Fatal"),e("option",{value:"10000",selected:"selected"},"Fatal")])])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"}," "),e("td",null,[e("input",{name:"FailureNotification",value:"1",checked:"checked",type:"checkbox"}),s("Notify Owner when Unsubscribing")])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Cleanup List every:"),e("td",null,[e("select",{name:"CleanupPeriod"},[e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400",selected:"selected"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"864000"},"10 day(s)")])])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Bounce Reports to Save:"),e("td",{nowrap:"nowrap"},[e("select",{name:"SaveReports"},[e("option",{value:"0"},"no"),e("option",{value:"1",selected:"selected"},"unprocessed"),e("option",{value:"2"},"all")])])]),e("tr",null,[e("th",{colspan:"3"},"Warning Message")]),e("tr",null,[e("td",{align:"right"},"Subject:"),e("td",{colspan:"2"},[e("input",{name:"WarningSubject",size:"40",maxlength:"200",value:"WARNING! (^I)",type:"text"})])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Text:"),e("td",{colspan:"2"},[e("textarea",{name:"WarningText",cols:"50",rows:"3"},`This is an automated message from the <^N@^D> mailing list manager
List messages sent to your address <^A> have bounced.
If you read this message, your mail system has been probably fixed.
To clear the bounce counter and to prevent automatic cancellation of your subscription, use the Reply command in your mailer.
Check that the Subject of the reply message contains the confirmation ID: ^I, and the reply is directed to <^N-^O@^D>,
and the 'From' address of your reply is <^A>.

All requests about this mailing list should be sent to <^N-request@^D>`)])])])])])],-1)),t[25]||(t[25]=o('<ul><li><p><code>suspend subscription for</code></p><p>If this option is selected, it specifies for how long a subscriber should be suspended if the system receives a non-fatal problem report about the subscriber&#39;s E-mail address.<br> The <code>unsubscribe after</code> option specifies the number of unconfirmed suspension periods after which the user is unsubscribed.</p></li><li><p><code>suspend till confirmation</code></p><p>If this option is selected, a non-fatal error report suspends the address till the subscriber sends a confirmation message.<br> The <code>unsubscribe after</code> option specifies the time period to wait for a confirmation message.</p></li><li><p><code>Process a Fatal Bounce as</code></p><p>This setting specifies how the system should process fatal problem reports: as non-fatal, as several non-fatal, or as a fatal problem. If you specify that the system should unsubscribe a user after receiving 10 non-fatal problem reports about the user address, and you specify that a fatal problem report should be processed as 5 non-fatal reports, this will tell the system to unsubscribe the user after 2 fatal reports. If you specify that a fatal problem report should be processed as fatal, the system will unsubscribe a user immediately upon receiving a fatal problem report.</p></li><li><p><code>Notify Owner When Unsubscribing</code></p><p>If this option is selected, an E-mail message is sent to the List Owner every time an address is unsubscribed because of mail bouncing.</p></li><li><p><code>Cleanup List every</code></p><p>This setting specifies how often the system should scan the subscription list. When scanning the list, the system:</p><ul><li>sends warning messages to the subscribers with non-zero bounce counter;</li><li>removes subscribers who sent subscription requests more than 2 days ago and who have not confirmed the subscription requests;</li><li>removes unsubscribed addresses from the list.</li></ul></li><li><p><code>Bounce Reports to Save</code></p><p>This setting specifies which delivery reports should be saved in the <em><code>listname</code></em><code>/reports</code> Mailbox in the list owner Account. If you specify <code>unprocessed</code>, only the messages that the LIST module fails to parse and process are stored in that Mailbox.</p></li><li><p><code>Warning Message</code></p><p>These text settings specify the subject and the text of a warning message that is sent to subscribers when their subscription is suspended. In addition to generic &quot;symbol combinations&quot;, this service text can contain the following combinations:</p><table tabindex="0"><thead><tr><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td><code>^A</code></td><td>the subscriber address</td></tr><tr><td><code>^I</code></td><td>the confirmation identifier</td></tr></tbody></table></li></ul><h2 id="FEED" tabindex="-1">FEED Mode Distribution <a class="header-anchor" href="#FEED" aria-label="Permalink to &quot;FEED Mode Distribution {#FEED}&quot;">​</a></h2><p>After a message is posted, it is distributed to all users subscribed in the FEED mode.</p><p>The <code>To</code> header field of a distributed message contains the mailing list address. The <code>From</code>, <code>Date</code>, and <code>Message-ID</code> fields (and specified <a href="#AdditionalFields">additional fields</a>) are copied from the original posting.</p><p>The body of the distributed message is a copy of the original message body. If the original message was not in the MIME format, or if it was in the MIME text/plain or multipart/mixed format (the most common formats), the FEED Mode Header text is inserted before and the FEED Mode Trailer text is inserted after the body of the original posting.</p>',5)),t[26]||(t[26]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Feed Mode Format")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Subject Prefix:"),e("td",null,[e("input",{name:"FeedSubject",size:"20",maxlength:"100",value:"[R&D]",type:"text"})]),e("td",{align:"right",nowrap:"nowrap"},"Direct Replies:"),e("td",null,[e("select",{name:"Reply"},[e("option",{value:"0",selected:"selected"},"to List"),e("option",{value:"1"},"to Sender")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"}," "),e("td",null,[e("input",{name:"FeedPrefixMode",value:"1",type:"checkbox",checked:"checked"}),s(" insert after Reply Prefix")]),e("td",{align:"right",nowrap:"nowrap"}," "),e("td",null," ")]),e("tr",null,[e("td",{colspan:"4",align:"center"},[s("Header"),e("br"),e("textarea",{name:"FeedHeader",cols:"50",rows:"3"})])]),e("tr",null,[e("td",{colspan:"4",align:"center"},[s("Trailer"),e("br"),e("textarea",{name:"FeedTrailer",cols:"50",rows:"3"},`#############################################################
This message is sent to you because you are subscribed to the mailing list <^N@^D>.
To unsubscribe, E-mail to: <^N-off@^D>
To switch to the DIGEST mode, E-mail to <^N-digest@^D>
To switch to the INDEX mode, E-mail to <^N-index@^D>
Send administrative queries to <^N-request@^D>`)])])])])])],-1)),t[27]||(t[27]=o('<ul><li><p><code>Subject Prefix</code></p><p>This setting specifies the string that is inserted into the beginning of the Subject field of all messages distributed in the FEED mode.<br> When a message is distributed, the system checks the Subject field. If the subject prefix found after the reply prefix (<code>Re:</code>, <code>Re&gt;</code>, etc.), then the subject prefix is deleted.<br> The Subject Prefix string can contain special <a href="#Macro">symbol combinations</a>.</p></li><li><p><code>insert after Reply Prefix</code></p><p>Select this option to insert the Subject Prefix after the Reply prefix (this helps client mailers to group related messages into <em>discussion threads</em>).</p><p>Sample:</p><ul><li><p>the Subject Prefix setting: <code>[R&amp;D]</code></p></li><li><p>a posted message: <code>Subject: test</code></p></li><li><p>the distributed message: <code>Subject: [R&amp;D] test</code></p></li><li><p>the posted reply: <code>Subject: Re: [R&amp;D] test</code></p></li><li><p>the distributed reply (<code>insert after Reply Prefix</code> is not selected): <code>Subject: [R&amp;D] Re: test</code></p></li><li><p>the distributed reply (<code>insert after Reply Prefix</code> is selected): <code>Subject: Re: [R&amp;D] test</code></p></li><li><p>the composed digest:</p><p><code>1) test</code><br><code>2) Re: test</code></p></li></ul></li><li><p><code>Direct Replies</code></p><p>If the <code>to List</code> option is selected, the Reply-To header field with the E-mail address of the list is added to all distributed messages. As a result, when subscribers answer to distributed messages, their replies are directed to the mailing list by default.<br> If the <code>to Sender</code> option is selected, the Reply-To header is inserted with the From address of the message author (sender).</p></li><li><p><code>Header</code></p><p>This setting specifies the text to be included in the beginning of messages distributed in the FEED mode.<br> The Header string can contain special <a href="#Macro">symbol combinations</a>.</p></li><li><p><code>Trailer</code></p><p>This setting specifies the text to be included at the end of messages distributed in the FEED mode.<br> The Trailer string can contain special <a href="#Macro">symbol combinations</a>.</p></li></ul><h2 id="Storage" tabindex="-1">Digesting and Archiving <a class="header-anchor" href="#Storage" aria-label="Permalink to &quot;Digesting and Archiving {#Storage}&quot;">​</a></h2><p>Posted messages can be stored in a Mailbox created in the list owner Account. Such a Mailbox is used to collect messages for message digests. If messages are not removed from that Mailbox after a digest is created, this Mailbox can be used as a mailing list archive.</p><p>Select the <code>Enabled</code> value for the Digesting and Archiving option and follow the link next to that setting to modify the Digesting and Archiving settings.</p><h2 id="DIGEST" tabindex="-1">DIGEST/INDEX Mode Distribution <a class="header-anchor" href="#DIGEST" aria-label="Permalink to &quot;DIGEST/INDEX Mode Distribution {#DIGEST}&quot;">​</a></h2><p>When the Digesting and Archiving option is enabled, all posted messages are stored in a Mailbox created in the list owner Account. The LIST module periodically checks that Mailbox and creates list digests and indexes.</p><p>A digest message contains a set of the messages posted on the mailing list since the time when the previous digest was composed.</p><p>A digest message body contains the digest header, the table of contents (TOC) listing all the messages in the digest, the TOC trailer, the posted messages, and the digest trailer.</p><p>A list index message contains the same digest header, TOC, and TOC trailer, but it does not contain the posted messages themselves and it does not contain the digest trailer.</p><p>List index messages are created at the same time the list digest messages are created. Digest messages are sent to the digest-mode subscribers, and index messages are sent to the index-mode subscribers.</p>',10)),t[28]||(t[28]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Digest Generator")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Generate every:"),e("td",null,[e("select",{name:"DigestPeriod"},[e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"360"},"6 min"),e("option",{value:"600"},"10 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"18000"},"5 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400",selected:"selected"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"864000"},"10 day(s)"),e("option",{value:"1728000"},"20 day(s)"),e("option",{value:"2592000"},"30 day(s)"),e("option",{value:"8640000"},"100 day(s)")])]),e("td",{colspan:"2"}," ")]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"or if Larger than:"),e("td",null,[e("select",{name:"DigestSizeLimit"},[e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1024"},"1024"),e("option",{value:"3072"},"3K"),e("option",{value:"10240"},"10K"),e("option",{value:"30720"},"30K"),e("option",{value:"102400",selected:"selected"},"100K"),e("option",{value:"307200"},"300K"),e("option",{value:"1048576"},"1024K"),e("option",{value:"3145728"},"3M"),e("option",{value:"10485760"},"10M"),e("option",{value:"31457280"},"30M"),e("option",{value:"104857600"},"100M"),e("option",{value:"314572800"},"300M"),e("option",{value:"1073741824"},"1024M"),e("option",{value:"3221225472"},"3G"),e("option",{value:"10737418240"},"10G"),e("option",{value:"32212254720"},"30G")])]),e("td",{align:"right",nowrap:"nowrap"},"or when messages collected:"),e("td",null,[e("select",{name:"DigestMessageLimit"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"50"},"50"),e("option",{value:"100",selected:"selected"},"100"),e("option",{value:"200"},"200"),e("option",{value:"1000"},"1000"),e("option",{value:"10000"},"10000"),e("option",{value:"100000"},"100000")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"First Digest at:"),e("td",null,[e("select",{name:"DigestTimeOfDay"},[e("option",{value:"0"},"12:00AM"),e("option",{value:"1800"},"12:30AM"),e("option",{value:"3600"},"1:00AM"),e("option",{value:"5400"},"1:30AM"),e("option",{value:"7200"},"2:00AM"),e("option",{value:"9000"},"2:30AM"),e("option",{value:"10800"},"3:00AM"),e("option",{value:"12600"},"3:30AM"),e("option",{value:"14400"},"4:00AM"),e("option",{value:"16200"},"4:30AM"),e("option",{value:"18000",selected:"selected"},"5:00AM"),e("option",{value:"19800"},"5:30AM"),e("option",{value:"21600"},"6:00AM"),e("option",{value:"23400"},"6:30AM"),e("option",{value:"25200"},"7:00AM"),e("option",{value:"27000"},"7:30AM"),e("option",{value:"28800"},"8:00AM"),e("option",{value:"30600"},"8:30AM"),e("option",{value:"32400"},"9:00AM"),e("option",{value:"34200"},"9:30AM"),e("option",{value:"36000"},"10:00AM"),e("option",{value:"37800"},"10:30AM"),e("option",{value:"39600"},"11:00AM"),e("option",{value:"41400"},"11:30AM"),e("option",{value:"43200"},"12:00PM"),e("option",{value:"45000"},"12:30PM"),e("option",{value:"46800"},"1:00PM"),e("option",{value:"48600"},"1:30PM"),e("option",{value:"50400"},"2:00PM"),e("option",{value:"52200"},"2:30PM"),e("option",{value:"54000"},"3:00PM"),e("option",{value:"55800"},"3:30PM"),e("option",{value:"57600"},"4:00PM"),e("option",{value:"59400"},"4:30PM"),e("option",{value:"61200"},"5:00PM"),e("option",{value:"63000"},"5:30PM"),e("option",{value:"64800"},"6:00PM"),e("option",{value:"66600"},"6:30PM"),e("option",{value:"68400"},"7:00PM"),e("option",{value:"70200"},"7:30PM"),e("option",{value:"72000"},"8:00PM"),e("option",{value:"73800"},"8:30PM"),e("option",{value:"75600"},"9:00PM"),e("option",{value:"77400"},"9:30PM"),e("option",{value:"79200"},"10:00PM"),e("option",{value:"81000"},"10:30PM"),e("option",{value:"82800"},"11:00PM"),e("option",{value:"84600"},"11:30PM")])]),e("td",{colspan:"2"}," ")])])])])],-1)),t[29]||(t[29]=o(`<ul><li><p><code>Generate Every</code></p><p>This setting specifies how often the LIST module should generate digest (and index) messages for this list.</p></li><li><p><code>First Digest at</code></p><p>This setting specifies the time of the day when the first digest should be generated.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Generate Every setting value is not more than 1 day, every day the first digest is generated at the specified time. If this setting is set to 4:00, the Generate Every setting is set to 1 Day, and the last digest was generated at 23:00 on Monday, the next digest will be generated at 4:00 on Tuesday.</p></div><p>If the the Generate Every setting value is set to N days (N&gt;1), the first digest is generated at the specified time N days later: if this setting is set to 4:00, the Generate Every setting is set to 5 Days, and the last digest was generated at 23:00 on Monday, the next digest will be generated at 4:00 on Friday.</p></li><li><p><code>if Larger than</code></p><p>This setting specifies the maximum size of the messages to be included into one digest. If the total size of all messages posted since the last digest was generated exceeds this limit, a new digest (and index) is generated immediately, overriding the <code>Generate Every</code> and <code>First Digest at</code> settings.</p></li><li><p><code>if has X messages</code></p><p>This setting specifies the maximum number of messages to be included into one digest. As soon as the specified number of messages is posted, a new digest is generated immediately.</p></li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Digest Format</b></td></tr><tr><td align="right">Subject:</td><td><input name="DigestSubject" value="^N Digest #^X" size="20" maxlength="100" type="text"></td><td align="right">Body Format:</td><td><select name="DigestFormat"><option value="0" selected="selected">plain text</option><option value="1">standard MIME</option><option value="2">embedded MIME</option></select></td></tr><tr><td colspan="4" align="center"><b>Header</b><br><textarea name="DigestHeader" cols="50" rows="3">^E Digest #^X</textarea></td></tr><tr><td colspan="4" align="center"><b>Index Line</b><br><textarea name="TOCLine" cols="50" rows="3">^X02) ^S80 by ^F</textarea></td></tr><tr><td colspan="4" align="center"><b>Index Trailer</b><br><textarea name="TOCTrailer" cols="50" rows="3">This digest is sent to you because you are subscribed to the mailing list &lt;^N@^D&gt;.
To unsubscribe, E-mail to: &lt;^N-off@^D&gt;
To switch to the FEED mode, E-mail to &lt;^N-feed@^D&gt;
Send administrative queries to &lt;^N-request@^D&gt;</textarea></td></tr><tr><td colspan="4" align="center"><b>Trailer</b><br><textarea name="DigestTrailer" cols="50" rows="3"></textarea></td></tr></tbody></table></div></form><ul><li><p><code>Digest Subject</code></p><p>This text setting specifies the Subject header field for digest and index messages created for this mailing list.<br> If the <a href="#BadDigestReply">Prohibit Unmodified Digest Subjects</a> option is selected, the mailing list manager rejects all postings with a reply prefix (<code>Re:</code>, <code>Re&gt;</code>, etc.) followed by an unmodified Digest Subject text.</p></li><li><p><code>Body Format</code></p><p>This setting specifies how the digest body should be formatted.</p><ul><li><p><code>plain text</code></p><p>Digests are composed as plain text messages; individual messages are separated with a line containing minus symbols.</p></li><li><p><code>standard MIME</code></p><p>Digests are composed in the MIME multipart/digest format, where the first part has the text/plain Content-type and contains the digest TOC, and other parts contain the messages (postings).</p></li><li><p><code>embedded MIME</code></p><p>Digests are composed in the MIME multipart/mixed format, where the first part has the text/plain Content-type and contains the digest TOC, and the second part uses the standard multipart/digest format and contains all messages (postings).</p></li></ul></li><li><p><code>Header</code></p><p>This text setting specifies the text to be included into all digest and index messages before the Index Lines (Table of Contents).</p></li><li><p><code>Index Line</code></p><p>This setting specifies the format for an index entry. Like the service text settings, the Index Line can (and should) have special symbol combination, but these combinations are different.<br> For each posted message, values from the message are substituted into the Index Line text and the resulting line is stored in the digest or index message being composed.</p><table tabindex="0"><thead><tr><th>Combination</th><th>Substituted with</th></tr></thead><tbody><tr><td><code>^X</code></td><td>the message sequence number in the digest being composed</td></tr><tr><td><code>^F</code></td><td>the <code>From</code> header field of the message</td></tr><tr><td><code>^T</code></td><td>the <code>Date</code> header field of the message</td></tr><tr><td><code>^S</code></td><td>the <code>Subject</code> header field of the message</td></tr><tr><td><code>^I</code></td><td>the <code>Message-Id</code> header of the message</td></tr></tbody></table></li><li><p><code>Index Trailer</code></p><p>This text setting specifies the text to be included into all digest and index messages after the Index Lines.</p></li><li><p><code>Trailer</code></p><p>This text setting specifies the text to be included after the last message in the digest.</p></li></ul><h2 id="Archiving" tabindex="-1">Archiving <a class="header-anchor" href="#Archiving" aria-label="Permalink to &quot;Archiving {#Archiving}&quot;">​</a></h2><p>All messages posted on a <em>listname</em> mailing list are stored in the <em><code>listname</code></em> Mailbox in the list owner Account. When a digest is being composed, the posted messages are retrieved from that Mailbox. This Mailbox also serves as an archive for all posted messages, and this archive can be searched via the user Web interface.</p><p>Each time after a digest is composed, the Mailbox is checked and the oldest posted messages are removed to keep the archive Mailbox size within the specified limits.</p>`,6)),t[30]||(t[30]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,[s("Archiving "),e("select",{name:"Store"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Maximum Archive Size:"),e("td",null,[e("select",{name:"ArchiveSizeLimit"},[e("option",{value:"-1"},"Unlimited"),e("option",{value:"0"},"0 Kbyte"),e("option",{value:"1024"},"1 Kbyte"),e("option",{value:"3072"},"3 Kbytes"),e("option",{value:"10240"},"10 Kbytes"),s(),e("option",{value:"30720"},"30 Kbytes"),e("option",{value:"102400"},"100 Kbytes"),e("option",{value:"307200",selected:"selected"},"300 Kbytes"),e("option",{value:"1048576"},"1 Mbyte"),e("option",{value:"3145728"},"3 Mbytes"),s(),e("option",{value:"10485760"},"10 Mbytes"),e("option",{value:"31457280"},"30 Mbytes"),e("option",{value:"104857600"},"100 Mbytes"),e("option",{value:"314572800"},"300 Mbytes")])]),e("td",{align:"right",nowrap:"nowrap"},"Messages to Keep:"),e("td",null,[e("select",{name:"ArchiveMessageLimit"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"200"},"200"),e("option",{value:"1000",selected:"selected"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Start new Archive every:"),e("td",null,[e("select",{name:"ArchiveSwapPeriod"},[e("option",{value:"-1"},"never"),e("option",{value:"1",selected:"selected"},"month"),e("option",{value:"2"},"2 months"),e("option",{value:"3"},"3 month"),e("option",{value:"6"},"6 month"),e("option",{value:"12"},"year"),e("option",{value:"24"},"2 years"),e("option",{value:"36"},"3 years"),e("option",{value:"60"},"5 years")])]),e("td",{align:"right",nowrap:"nowrap"},"Browse Access:"),e("td",null,[e("select",{name:"Browse"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"subscribers"),e("option",{value:"2"},"clients"),e("option",{value:"3"},"anybody")])])])])])])],-1)),t[31]||(t[31]=o('<ul><li><p><code>Maximum Archive Size</code></p><p>This setting specifies the maximum size of the archive Mailbox. After a digest is generated, the new archive file can be generated or the oldest messages can be removed from the Mailbox to keep the Mailbox size below the specified limit.</p></li><li><p><code>Messages to Keep</code></p><p>This setting specifies the maximum number of messages that can be left in the archive Mailbox after a digest is generated.</p></li><li><p><code>Start new Archive every</code></p><p>This setting specifies when the new archive Mailbox should be created. The old archive Mailbox becomes a submailbox with the name YYYY-MM-DD, where YYYY specifies the year, MM specifies the month, and DD specifies the day when the first archive message was stored.<br> Unless the Start New Archive option is set to <code>never</code>, a new archive is created when the archive Mailbox size limit or the archived message number limit is exceeded.<br> If the Start New Archive option is set to <code>never</code> and the Maximum Archive Size option is set to zero, all messages are removed from the archive Mailbox as soon as a digest is generated.</p></li><li><p><code>Browse Access</code></p><p>This setting specifies if this mailing list should appear in the Mailing Lists section of the WebUser Interface.</p><ul><li><p><code>nobody</code></p><p>The mailing list will not be available via the Web Interface.</p></li><li><p><code>anybody</code></p><p>The mailing list will be displayed as a browsable mailing list, and its archive can be used by anybody.</p></li><li><p><code>subscribers</code></p><p>The mailing list will be displayed as a browsable mailing list, but in order to browse its archive, users should enter their E-mail address and the Confirmation ID (as the password). To retrieve a forgotten Confirmation ID, a user can always send a message to <code>&lt;listname-confirm@domain&gt;</code> and get the confirmation ID even if the list subscription mode does not require confirmations.<br> If the subscriber (E-mail address) is a local CommuniGate Pro Account, then not only the confirmation ID, but also the Account password can be used as the list access password.</p></li><li><p><code>clients</code></p><p>The mailing list will be displayed as a browsable mailing list, and can be browsed from the Internet addresses included into the server <a href="./../sysadmin/Protection.html">Client IP Addresses</a> list.<br> For users trying to view the list from outside the specified addresses/networks this mode works as the <code>subscribers</code> mode: these users have to enter the name/password pair (E-mail and Confirmaton ID) to browse the list.</p></li></ul></li></ul><h2 id="Subscribers" tabindex="-1">Subscribers List <a class="header-anchor" href="#Subscribers" aria-label="Permalink to &quot;Subscribers List {#Subscribers}&quot;">​</a></h2><p>If you are a system administrator or the list owner, you can access the subscribers list page following the <a href="#Subscribers">Subscribers</a> link on the Mailing List Settings page.</p><p>The Subscribers page contains the list of all E-mail addresses subscribed to the mailing list. For each address additional information (such as the subscriber&#39;s real name, number of bounces from this address, etc.) is listed. Each address can be marked, and you can use the Mark All button to mark all list subscribers. You can use the Filter field to display the subscribers with matching addresses only.</p>',4)),e("form",h,[e("div",u,[e("table",m,[e("tbody",null,[t[10]||(t[10]=e("tr",null,[e("td",null,[e("table",{border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{nowrap:"nowrap"},[e("input",{name:"Apply",value:"Display",class:"button",type:"reset"})]),e("td",null,[e("select",{name:"Limit"},[e("option",{value:"10"},"10"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000")])]),e("td",null,[s("Filter: "),e("input",{name:"Filter",value:"",size:"30",maxlength:"255",type:"text"})]),e("td",{align:"right"},[e("i",null,"2 of 2 selected")])])])])])],-1)),e("tr",null,[e("td",null,[e("table",b,[e("tbody",null,[t[8]||(t[8]=e("tr",null,[e("th",null," "),e("th",{align:"left",nowrap:"nowrap"},"E-mail"),e("th",{align:"left",nowrap:"nowrap"},"Mode"),e("th",{align:"left",nowrap:"nowrap"},"Subscribed"),e("th",{align:"right",nowrap:"nowrap"},"Posts"),e("th",{colspan:"2",align:"left",nowrap:"nowrap"},"Bounces"),e("th",{align:"left",nowrap:"nowrap"},"Real Name")],-1)),t[9]||(t[9]=e("tr",null,[e("td",null,[e("input",{type:"checkbox",name:"Sub",value:"andy@vax.communigatepro.ru"})]),e("td",null,"andy@vax.communigatepro.ru"),e("td",null,"null"),e("td",null,"15:54:51"),e("td",{align:"right"},"3"),e("td",{align:"right"}),e("td"),e("td",null,"Andy")],-1)),e("tr",null,[t[1]||(t[1]=e("td",null,[e("input",{type:"checkbox",name:"Sub",value:"test@mail.communigatepro.ru"})],-1)),t[2]||(t[2]=e("td",null,"test@mail.communigatepro.ru",-1)),t[3]||(t[3]=e("td",null,"feed",-1)),t[4]||(t[4]=e("td",null,"18:18:11",-1)),e("td",g,[d(i,{color:"maroon"},{default:c(()=>t[0]||(t[0]=[s("2 mod")])),_:1})]),t[5]||(t[5]=e("td",{align:"right"},null,-1)),t[6]||(t[6]=e("td",null,null,-1)),t[7]||(t[7]=e("td",null,"Test Account",-1))])])])])])]),t[11]||(t[11]=e("tfoot",null,[e("tr",null,[e("td",null,[e("table",{border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"SelectAll",value:"Mark All",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"Unsubscribe",value:"Unsubscribe",class:"buttonRed",type:"reset"})]),e("td",{nowrap:"nowrap"},[e("input",{name:"Postings",value:"Set",class:"buttonWhite",type:"reset"}),e("select",{name:"Posts"},[e("option",{value:"0",selected:"selected"},"Unmoderated"),e("option",{value:"1"},"Moderate first"),e("option",{value:"2"},"Moderate first 2"),e("option",{value:"3"},"Moderate first 3"),e("option",{value:"5"},"Moderate first 5"),e("option",{value:"10"},"Moderate first 10"),e("option",{value:"10000"},"Moderate All"),e("option",{value:"10001"},"Prohibit"),e("option",{value:"10002"},"Special")])])]),e("tr",null,[e("td",null," "),e("td",null,[e("input",{name:"Failed",value:"Mark Failed",class:"button",type:"reset"})]),e("td",{nowrap:"nowrap"},[e("input",{name:"ChangeMode",value:"Set",class:"buttonWhite",type:"reset"}),e("select",{name:"NewMode"},[e("option",{value:"0",selected:"selected"},"feed"),e("option",{value:"1"},"digest"),e("option",{value:"2"},"index"),e("option",{value:"3"},"null"),e("option",{value:"4"},"banned")])])])])])])])],-1))])])]),t[32]||(t[32]=o('<ul><li><p><code>Unsubscribe</code></p><p>Mark some subscribers and click this button to unsubscribe them from the list. Depending on the current FeedBack setting value, the LIST module will either unsubscribe them immediately or just send them confirmation requests. If the FeedBack setting (see below) value is <code>Send Welcome</code>, the <code>Good Bye</code> messages are sent to unsubscribed addresses.</p></li><li><p><code>Mark Failed</code></p><p>Mark some subscribers and click this button to tell the LIST module that mail to those addresses bounced. This can be useful in situations when the LIST module fails to process bounce reports automatically, because they come in a non-standard format. Clicking the Mark Failed button will result in the same actions (increased bounce counter, suspension, and warning generation) as caused by receiving a non-fatal bounce from the marked address.</p></li><li><p><code>Set Postings</code></p><p>These controls allow you to change the moderation mode for the selected users. You can select some subscribers and set their posting mode to moderated, prohibited, unmoderated, or special. See the <a href="#Postings">Posting Messages</a> section for more details.</p></li><li><p><code>Set Mode</code></p><p>These controls allow you to change the subscription mode for the selected users. See the <a href="#Subscription">Subscription Processing</a> section for more details. If the FeedBack setting (see below) value is set to <code>ask Confirmation</code>, the subscription mode is not changed, but a confirmation request for the mode change operation is sent to the marked subscribers.</p></li></ul><h3 id="Adding" tabindex="-1">Adding Subscribers <a class="header-anchor" href="#Adding" aria-label="Permalink to &quot;Adding Subscribers {#Adding}&quot;">​</a></h3><p>You can manually add subscribers to the list. Enter the new subscriber E-mail address press the Subscribe button.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><table class="settingsBox"><tbody><tr><td rowspan="2"><input name="Create" value="Subscribe" class="button" type="reset">  </td><td align="right">Single Address:</td><td><input name="NewName" value="" size="30" maxlength="255" type="text"></td></tr><tr><td align="right">Import:</td><td><input name="Import" type="file"></td></tr><tr><td colspan="3"> </td></tr><tr><td> </td><td> </td><td><a href="#Adding">Export Subscribers</a></td></tr></tbody></table></td><td>  </td><td align="right"><table class="settingsBox" height="100%"><tbody><tr><td align="center">Feedback</td></tr><tr><td align="center"><select name="Welcome"><option value="0">ask confirmation</option><option value="1">send Welcome</option><option value="2" selected="selected">silently</option></select></td></tr></tbody></table></td></tr></tbody></table></div></form><ul><li><p><code>Feedback</code></p><p>If this option is set to <code>ask Confirmation</code>, all operations performed result in confirmation requests being sent to the specified subscriber address.<br> If this option is set to <code>Send Welcome</code>, confirmation requests are not generated, and the subscription modes are changed immediately, but the Welcome and Good Bye messages are sent to subscribers when you unsubscribe a user or subscribe a new user.<br> If this option is set to <code>silently</code>, no messages are sent to subscribers.</p></li><li><p><code>Single User</code></p><p>Use this field to enter an E-mail address of the user you want to subscribe to this list. A new subscriber address can be specified as an E-mail address with a comment, as <code>John Smith &lt;johns@company.com&gt;</code> or <code>johns@company.com (John Smith)</code>, in this case the comment is stored the subscriber&#39;s real name.<br> Click the Subscribe button to subscribe the specified address.</p></li></ul><h3 id="ImpEx" tabindex="-1">Importing Subscriber Lists <a class="header-anchor" href="#ImpEx" aria-label="Permalink to &quot;Importing Subscriber Lists {#ImpEx}&quot;">​</a></h3><p>You can use text files with E-mail addresses to add subscribers to mailing lists. Open the <a href="#Subscribers">Subscribers</a> page, and use the Import control to select a file with E-mail addresses. Click the Subscribe button to add the addresses to the mailing list.</p><p>The text file should have one E-mail address per line, with several optional fields on each line. If a line contains several fields, they should be separated with the tabulation (TAB) symbol.</p><ul><li>The first and the only required field is the E-mail address.</li><li>The second field specifies the subscription mode. The first field symbol is checked. The symbols <code>d</code> and <code>D</code> require the DIGEST mode, the symbols <code>I</code> and <code>i</code> - the INDEX mode, and the letters <code>f</code> and <code>F</code> - the FEED mode. All other field symbols are ignored. If the first symbol is not recognized or the field is absent, the new user is subscribed in the Mailing List default mode.</li><li>The last field (if a line contains more than 2 fields) specifies the real name of the new user.</li></ul><p>The Mailing List manager checks the file format first. If the file format is incorrect, no new user is subscribed. This allows you to fix the file format and to try the same file: either all addresses are added, or none is added.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The import file must be prepared on the client computer (on the computer you use to run your browser). The browser allows you to upload files from disks connected to that computer, not to the CommuniGate Pro Server computer.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When using Netscape and some other Unix browsers, make sure that the file name ends with the <code>.txt</code> suffix - otherwise the browser won&#39;t upload the file as a text one, and the file will be ignored.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some versions of the Netscape® browser for &quot;classic&quot; MacOS® do not convert the MacOS text files (that use the CR symbol as the line separator) into CR-LF delimited text files. You may see the &quot;format error&quot; messages if you try to import a subscriber list from a MacOS computer using that browser. You should either use a different browser, or you should convert the subscriber list into a CR-LF delimited text file before importing it with that browser.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you are moving users from a different mailing list system, make sure you have set the Feedback option to Silently - otherwise all inserted subscribers will receive confirmation requests and/or Welcome messages.</p></div><h3 id="SubLists" tabindex="-1">Subscribing Lists to Lists <a class="header-anchor" href="#SubLists" aria-label="Permalink to &quot;Subscribing Lists to Lists {#SubLists}&quot;">​</a></h3><p>You may want to subscribe List1 to List2, so all messages posted on the List2 list are sent to the List1 subscribers, too.</p><p>After you have added the qualified address of the List1 (list1@domain1.dom) to the List2 subscribers list, add the qualified address of the List2 (list2@domain2.dom) to the List1 susbcribers list. Set the subscription mode to <code>null</code>, so messages will not go back to the List2 list, and set the posting mode to <code>special</code>, so messages from List2 (which are auto-generated list messages) will be allowed for posting on List1.</p><h2 id="Service" tabindex="-1">Processing Service Requests <a class="header-anchor" href="#Service" aria-label="Permalink to &quot;Processing Service Requests {#Service}&quot;">​</a></h2><p>The LIST module processes messages sent to <code>listserver@localdomainname</code>. The module takes the List Server commands from the message body, processes those commands, and composes a response message with the command execution results.</p><p>All commands sent to the above address apply to the mailing lists in the specified Domain only (to the virtual list server in that Domain).</p><p>The messages with the List Server commands should be in the plain text format, or in the mulitpart/alternative format containing a part in the plain text format.</p><p>Each List Server command is stored on one text line. Line starting with the <code>%</code>, <code>*</code>, <code>#</code>, and <code>;</code> symbols are not processed (comment lines).</p><p>The following commands are supported:</p><ul><li><p><code>SUBSCRIBE listname [mode [confirmation ID]]</code><br><code>SUB listname [mode [confirmation ID]]</code></p><p>These commands subscribe the message author to the <em>listname</em> mailing list. If the <em>mode</em> is not specified, the default subscription mode is used.<br> This is equivalent to sending a message to the <code>listname-on@localdomainname</code> address.</p></li><li><p><code>UNSUBSCRIBE listname [confirmation ID]</code><br><code>UNSUB listname [confirmation ID]</code></p><p>These commands unsubscribe the message author from the <em>listname</em> mailing list.<br> This is equivalent to sending a message to the <code>listname-off@localdomainname</code> address.</p></li><li><p><code>CONFIRM listname</code><br><code>GETID listname</code></p><p>These commands send the message author his/her <em>listname</em> subscription ConfirmationID (password).<br> This is equivalent to sending a message to the <code>listname-confirm@localdomainname</code> address.</p></li><li><p><code>WHICH</code><br><code>CHECK</code></p><p>These commands list the mailing lists (in this <em>localdomainname</em> Domain) the message author is subscribed to.</p></li><li><p><code>HELP</code></p><p>This command displays the list of supported commands.</p></li><li><p><code>QUIT</code><br><code>FINISH</code></p><p>These commands tell the LIST module to stop processing. The rest of the message text is ignored.</p></li></ul><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>The LIST module routes to itself all following addresses:<br><em><code>listname</code></em><code>@domain</code><br> if the list <em><code>listname</code></em> exists in the <em><code>domain</code></em> Domain, or<br><em><code>listname</code></em><br> addresses, if the mailing list <em><code>listname</code></em> exists in the Main Domain.</p><p>Messages to these addresses are processed as submissions to the specified mailing lists.</p><p>The LIST module detects addresses in the form<br><em><code>listname</code></em><code>-request@domain</code> and <em><code>listname</code></em><code>-admin@domain</code><br> or<br><em><code>listname</code></em><code>-request</code> and <em><code>listname</code></em><code>-admin</code>.<br> Messages sent to these addresses are rerouted to the mailing list owner.</p><p>The LIST module also routes to itself the following addresses:<br><em><code>listname</code></em><code>-xxx@domain</code><br> and<br><em><code>listname</code></em><code>-xxx</code>.</p><p>The xxx suffix can be one of the following:</p><ul><li><p><code>on</code>, <code>off</code>, <code>subscribe</code>, <code>unsubscribe</code>, <code>feed</code>, <code>digest</code>, <code>index</code></p><p>messages sent to these addresses are processed as <a href="#Subscription">subscription requests</a>.</p></li><li><p><code>report</code></p><p>messages sent to these addresses are processed as delivery reports about the distributed messages</p></li><li><p>anything else</p><p>messages are rejected</p></li></ul>',31))])}const I=a(p,[["render",f]]);export{M as __pageData,I as default};
