import{_ as o,c as t,o as i,ag as a}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"PIPE Module","description":"","frontmatter":{"legacyLink":"PIPE.html"},"headers":[],"relativePath":"admin/mail/PIPE.md","filePath":"admin/mail/PIPE.md"}'),s={name:"admin/mail/PIPE.md"};function n(d,e,r,l,p,c){return i(),t("div",null,e[0]||(e[0]=[a(`<p></p><h1 id="pipe-module" tabindex="-1">PIPE Module <a class="header-anchor" href="#pipe-module" aria-label="Permalink to &quot;PIPE Module&quot;">​</a></h1><p>The PIPE module allows external applications running on the Server computer to submit messages to the CommuniGate Pro Server bypassing TCP/IP connections and Internet protocols, and it allows the Server to deliver messages to external applications.</p><p>The PIPE module is also used to submit messages composed with the <code>mail</code> and <code>sendmail</code> programs that come with the CommuniGate Pro server software. These programs are designed as drop-in substitutions for legacy <code>mail</code> and <code>sendmail</code> programs.</p><h2 id="Submitted" tabindex="-1">The Submitted Folder <a class="header-anchor" href="#Submitted" aria-label="Permalink to &quot;The Submitted Folder {#Submitted}&quot;">​</a></h2><p>The CommuniGate Pro PIPE module creates the <code>Submitted</code> folder inside the CommuniGate Pro <em>base folder</em>.</p><p>The PIPE module scans this folder periodically, and processes the files with the <code>.sub</code> file name extension. When such a file is found, the module copies it into a <em>message queue</em> file and submits that file to the Server kernel for processing.</p><p>The <code>.sub</code> text files should contain messages in the RFC822 format. The module uses the data in the RFC822 header fields to compose the message envelope.</p><ul><li>The RFC821 &quot;channel format&quot; should NOT be used: submitted files should use the system native &quot;End of Line&quot; character(s), the dot (.) symbol in the first position should not be doubled, and the file should not end with the dot (.) symbol.</li><li>Addresses specified in the <code>To:</code>, <code>Cc:</code>, <code>Bcc:</code> header fields are used to create the message envelope (recipient addresses).</li><li>The <code>Bcc:</code> header fields are removed from the submitted message.</li><li>If at least one <code>Envelope-To:</code> header field is detected, message envelope (recipient) addresses are formed using the addresses specified in these header fields, and addresses in all <strong>remaining</strong> To, Cc, and Bcc headers are not placed into the message envelope. The <code>Envelope-To:</code> header fields are removed from the submitted message.</li><li>If no <code>Envelope-To:</code> header field exists, and the <code>Envelope-Ignore</code> field or fields exist, the addresses specified in To/Cc/Bcc header fields and also listed in the Envelope-Ignore fields are NOT included into the message envelope.</li><li>If the <code>Sender:</code> and/or <code>From:</code> header fields contain addresses without the domain part, the Server domain name is added to those addresses.</li><li>If the <code>Return-Path:</code> header field exists, the address specified in that header is used to compose the Return-Path envelope address, and this header field is removed from the submitted message.</li><li>If the <code>Return-Path:</code> header field does not exist, the address specified in the <code>From:</code> or <code>Sender:</code> header field is used to compose the envelope Return-Path address.</li><li>If the <code>Envelope-ID:</code> header field exists, its content is used as the message Envelope ID. This header field is removed from the submitted message.</li><li>If the <code>Envelope-Notify:</code> header field exists, it should contain one or several keywords <code>SUCCESS</code>,<code>FAILURE</code>,<code>DELAY</code>,<code>RELAY</code> separated with comma symbols, or it should contain one keyword <code>NEVER</code>.<br> This header field specifies the DSN parameters applied to all envelope addresses composed after this field is met. This header field is removed from the submitted message.<br> Several <code>Envelope-Notify:</code> header fields can be used to specify different DSN parameters for different addresses.</li></ul><p>If processing of a <code>.sub</code> file fails (for example, if the file does not have any recipient address), the module places a record into the System Log, and changes the file extension to <code>.bad</code>.</p><p>If a .sub file is submitted successfully, the file is deleted from the Submitted folder.</p><p>Because of the way the PIPE module processes the Submitted folder, it is recommended to compose messages in a different file directory and then move the composed .sub files to the Submitted folder, or to compose messages in the Submitted folder, in files with the <code>.tmp</code> file name extension, and then change the file name extension to <code>.sub</code>.</p><p>Messages submitted via the PIPE module are marked as &quot;received from a trusted source&quot;, so they can be relayed without restrictions.</p><p>The Submitted folder is used for <a href="./../misc/Mail.html#LegacyMail">Legacy Mail Emulation</a>.</p><h2 id="Delivery" tabindex="-1">Delivering to External Applications <a class="header-anchor" href="#Delivery" aria-label="Permalink to &quot;Delivering to External Applications {#Delivery}&quot;">​</a></h2><p>The PIPE module accepts all messages directed to the <code>pipe</code> domain.</p><p>The local part of the message address specifies the external application to launch. The part can contain parameters, and can be enclosed into the quotation marks.</p><ul><li><p>Example:</p><p>A message directed to the <code>&quot;execjoe -l store&quot;@pipe</code> address will be sent to the application <code>execjoe</code> started with the <code>-l store</code> parameters. You usually use the PIPE delivery via the <a href="./../sysadmin/Router.html">Router</a>:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@somedomain&gt; = exec*@pipe</span></span></code></pre></div><p>this Router record will direct messages sent to the <code>joe@somedomain</code> address to the <code>execjoe</code> application.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@somedomain&gt; = &quot;execall\\ -u\\ *&quot;@pipe</span></span></code></pre></div><p>this Router record will direct messages sent to the <code>joe@somedomain</code> address to the <code>execall</code> application started with the <code>-u joe</code> parameters.</p><p>To limit the set of applications that can be started via the PIPE module, the <em>external application directory</em> is specified as one of the PIPE module settings. The application names specified in message addresses can not include the slash (<code>/</code>) or the backslash (<code>\\</code>) symbols, and they cannot start with the dot (<code>.</code>) symbol, and it specified the name of the application (program) file in the <em>external application directory</em>.</p><p>The message text (including the message headers and the message body) is passed to the external application as its <em>standard input</em>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The application must read the entire <em>stdin</em> data stream, otherwise message processing fails.</p></div><p>When the external application completes, the PIPE module reads and discards the application <em>standard output</em>. Make sure that your application does not write anything to its <em>standard output</em>, so it is not blocked when the communication channel (pipe) buffer between the application and the Server is full.</p><p>When the external application completes, the PIPE module reads its <em>standard error</em> channel. If it is not empty, the message delivery fails, and the text written to <em>standard error</em> is sent as an error report to the message sender.</p><h3 id="Serial" tabindex="-1">Serialized Delivery <a class="header-anchor" href="#Serial" aria-label="Permalink to &quot;Serialized Delivery {#Serial}&quot;">​</a></h3><p>In order to allow several PIPE processors to deliver messages simultaneously, the PIPE module creates a separate queue for each message it has to deliver. If you want to serialize processing, you can use the following form of the PIPE address:<br><code>&quot;queue[name] application parameters&quot;@pipe</code><br> All messages directed to these addresses will be placed into the <em>name</em> queue, and a single PIPE processor will send the enqueued messages to the application(s) specified in those addresses. You can use any alphanumeric string as a queue <em>name</em>, and you can specify as many queues as you need.</p><p>The following <a href="./../sysadmin/Router.html">Router</a> records can be used to maintain two serialized PIPE queues (the PROC1 and ARCH queues):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;incoming&gt; = &quot;queue[PROC1] procin -mark&quot;@pipe</span></span>
<span class="line"><span>&lt;control&gt;  = &quot;queue[PROC1] procin1 -control&quot;@pipe</span></span>
<span class="line"><span>&lt;archiver&gt; = &quot;queue[ARCH] appendfile /var/archive&quot;@pipe</span></span></code></pre></div><p>All messages sent to the <a href="mailto:incoming@maindomain.com" target="_blank" rel="noreferrer">incoming@maindomain.com</a> and <a href="mailto:control@maindomain.com" target="_blank" rel="noreferrer">control@maindomain.com</a> will be processed one-by-one using one PIPE processor.</p><p>For PIPE addresses that do not have the <code>queue[name]</code> prefix, the PIPE module creates separate queues with numeric names.</p><h3 id="Tags" tabindex="-1">Command Tags <a class="header-anchor" href="#Tags" aria-label="Permalink to &quot;Command Tags {#Tags}&quot;">​</a></h3><p>The message text (the header and the body) is sent to the task as that task <em>standard input (stdin)</em>.</p><p>An application name can be prefixed with the <code>[FILE]</code> tag:<br><code>[FILE] application parameters</code><br> When this prefix is used, the application standard input will be empty (closed), or it will contain only the message header fields added by Rules. The string -f Queue/<em>fileid</em>.msg (the -f flag and the Message file name, relative to the <em>base directory</em>) will be appended to the end of the application parameters:<br> -f Queue/12002345.msg</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The beginning of a Queue file contains the service information (envelope, options, etc.). The application should ignore this information skipping the file data till the first empty line. The message itself starts after that first empty line in the Queue file.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Header fields added to the message by Server-wide and Cluster-wide <a href="./QueueRules.html">Rules</a> are not stored in the message Queue file, they are sent via the task <em>standard input</em>.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This prefix should not be used on MS Windows platform, as the Server keeps the message file open, making it impossible for an external Task to read the file.</p></div><p>An application name can be prefixed with the <code>[RETPATH]</code> tag:<br><code>[RETPATH] application parameters</code><br> When this prefix is specified, the string &quot;-p&quot; followed by the message return-path address is added to the end of the application parameters:<br> -p <a href="mailto:address@domain.com" target="_blank" rel="noreferrer">address@domain.com</a></p><p>An application name can be prefixed with the <code>[RCPT]</code> tag:<br><code>[RCPT]application parameters</code><br> When this prefix is specified the string &quot;-r&quot; followed by the original recipient address is added to the end of the application parameters:<br> -r <a href="mailto:address1@domain1.com" target="_blank" rel="noreferrer">address1@domain1.com</a></p><p>An application name can be prefixed with the <code>[STDERR]</code> tag (see below).</p><p>An application name can have several prefix strings, and they can be specified in any order. If several of <code>[FILE]</code>, <code>[RETPATH]</code>, and <code>[RCPT]</code> prefix strings are specified, the <code>-f</code> flag and its parameter are added first, followed with the <code>-p</code> flag and its parameter, followed with the <code>-r</code> flag and its parameter.</p><p>If the <code>[STDERR]</code> prefix is specified and the external application completes sending some data to its <em>standard error</em> channel, the <em>standard error</em> data is used to compose the error report text.</p><h2 id="Configure" tabindex="-1">Configuring the PIPE module <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Configuring the PIPE module {#Configure}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the PIPE module. Open the Mail pages in the Settings realm, then open the PIPE page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Processors: <select name="MaxChannels"><option value="0">0</option><option value="1">1</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="11">other</option></select></td></tr><tr><td colspan="2"><hr></td></tr><tr><td align="right">Application Directory:</td><td><input type="text" name="AppDirectory" value="" size="25" maxlength="255"></td></tr><tr><td align="right">Processing Time Limit:</td><td><select name="ExecTimeOut"><option value="1">1 second</option><option value="5">5 seconds</option><option value="10">10 seconds</option><option value="15">15 seconds</option><option value="30">30 seconds</option><option value="60">minute</option><option value="120" selected="selected">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800">30 minutes</option><option value="3600">hour</option><option value="7200">2 hours</option><option value="10800">3 hours</option><option value="21600">6 hours</option><option value="43200">12 hours</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log setting to specify what kind of information the PIPE module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the PIPE module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The PIPE module records in the System Log are marked with the <code>PIPE</code> tag.</p></li><li><p><code>Processors</code></p><p>This option specifies the number of threads used to deliver messages. If some of your external applications are slow, you may want to use several PIPE delivery threads, so several messages can be processed at the same time.</p></li><li><p><code>Application Directory</code></p><p>This option specifies the directory with the applications the PIPE module can launch. If an empty string is specified for this option, all messages directed to the PIPE module are rejected.</p></li><li><p><code>Processing Time Limit</code></p><p>This option limits the time an external application uses to process a message. If an external application does not complete within the specified period of time, the application process is interrupted and the message is rejected.</p></li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Submitting</b></td></tr><tr><td align="right">Check Directory every:</td><td><select name="PollInterval"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30" selected="selected">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="31">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Check &#39;Submitted&#39; Directory</code></p><p>This option specifies how often the PIPE module should scan the Submitted directory and deliver the .sub files stored there.</p></li></ul><h2 id="ForeignQueue" tabindex="-1">Foreign Queue Processing <a class="header-anchor" href="#ForeignQueue" aria-label="Permalink to &quot;Foreign Queue Processing {#ForeignQueue}&quot;">​</a></h2><p>In emergency situations you may need to process an additional Queue directory without stopping your server. These situations include a server hardware failure when the rescued Queue files should be processed with some other, already running server.</p><p>To process an additional <code>Queue</code> directory, move it to the <em>base directory</em> of a running server as the <code>ForeignQueue</code> directory. If you prefer to use symbolic links, make sure that the <code>Queue</code> and <code>ForeignQueue</code> directories are created on the same file system.</p><p>Every 3 minutes the PIPE module checks if the <code>ForeignQueue</code> directory exists in the server <em>base directory</em>. If the <code>ForeignQueue</code> directory is found, the module moves all <code>.msg</code> files from the <code>ForeignQueue</code> to the <code>Queue</code> directory (it can rename the files in the process), and deletes all <code>.tmp</code> files found in the <code>ForeignQueue</code> directory. Files with other extensions are left in the <code>ForeignQueue</code> directory.</p><p>All moved <code>.msg</code> files are submitted to the Server kernel, into the <a href="./#Enqueue">ENQUEUER</a> queue, and the Server starts to process them in the same way it processes all submitted messages.</p><p>When the scanning process is completed, the <code>ForeignQueue</code> directory can be removed from the <em>base directory</em>.</p>`,56)]))}const m=o(s,[["render",n]]);export{u as __pageData,m as default};
