import{_ as l,C as d,c as r,o as c,ag as s,j as e,a as o,G as a,w as n}from"./chunks/framework.jCcxW76o.js";const z=JSON.parse('{"title":"Automated E-mail Processing Rules","description":"","frontmatter":{"legacyLink":"QueueRules.html"},"headers":[],"relativePath":"admin/mail/QueueRules.md","filePath":"admin/mail/QueueRules.md"}'),u={name:"admin/mail/QueueRules.md"},h={action:"Null.html"},p={border:"0",cellspacing:"0",cellpadding:"5"},m={valign:"TOP",bgcolor:"#eeeeee"},g={action:"Null.html"},f={border:"0",cellspacing:"0",cellpadding:"5"},b={valign:"top",bgcolor:"#eeeeee"},y={action:"Null.html"},v={border:"0",cellspacing:"0",cellpadding:"5"},T={valign:"top",bgcolor:"#eeeeee"},w={action:"Null.html"},R={border:"0",cellspacing:"0",cellpadding:"5"},x={valign:"top",bgcolor:"#eeeeee"},S={action:"Null.html"},A={border:"0",cellspacing:"0",cellpadding:"5"},k={valign:"TOP",bgcolor:"#eeeeee"},I={action:"Null.html"},C={border:"0",cellspacing:"0",cellpadding:"5"},M={valign:"TOP",bgcolor:"#eeeeee"},N={action:"Null.html"},E={border:"0",cellspacing:"0",cellpadding:"5"},_={valign:"top",bgcolor:"#eeeeee"},P={nowrap:"nowrap"},F={action:"Null.html"},D={border:"0",cellspacing:"0",cellpadding:"5"},q={valign:"top",bgcolor:"#eeeeee"},L={action:"Null.html"},O={border:"0",cellspacing:"0",cellpadding:"5"},V={valign:"top",bgcolor:"#eeeeee"};function W(U,t,j,H,B,J){const i=d("tt");return c(),r("div",null,[t[40]||(t[40]=s('<h1 id="automated-e-mail-processing-rules" tabindex="-1">Automated E-mail Processing Rules <a class="header-anchor" href="#automated-e-mail-processing-rules" aria-label="Permalink to &quot;Automated E-mail Processing Rules&quot;">​</a></h1><p>The CommuniGate Pro Server can automatically process messages using sets of <a href="./../../development/Rules.html">Automated Rules</a>.</p><p>This section describes the Automated Processing Rules for E-mail messages, also called the Queue Rules.</p><p>The Server-Wide and Cluster-wide Rules are applied to all messages submitted to the Server and to the Cluster. These Rules are applied by the <a href="./">Enqueuer</a> component, before it enqueues a message into the transfer module queues.</p><p>When a message is directed to an Account on this CommuniGate Pro Server, the <a href="./Local.html">Local Delivery</a> module applies the Account-level Rules. The Account-level Rules are the Rules specified for the particular Account along with the Rules specified for the Account Domain.</p><h2 id="Configure" tabindex="-1">Specifying Message Rules <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Specifying Message Rules {#Configure}&quot;">​</a></h2><p>System administrators can specify Server-Wide and Cluster-wide Message Rules. Use the WebAdmin Interface to open the Mail pages in the Settings realm, and click the Rules link.</p><p>System administrators can specify Account Rules using links on the <a href="./../objects/Accounts.html#Rules">Account Settings</a> page.</p><p>Account users can specify their Rules themselves, using the <a href="./../access/WebUser.html">WebUser Interface</a>. System or Domain administrators can limit the set of Rule actions a user is allowed to specify.</p><p>System and Domain Administrators can specify Domain-Wide Rules using the Rules links on the Domain Settings page.</p><p>See the <a href="./../../development/Rules.html">Automated Rules</a> section to learn how to set the Rules.</p><h2 id="Conditions" tabindex="-1">Rule Conditions <a class="header-anchor" href="#Conditions" aria-label="Permalink to &quot;Rule Conditions {#Conditions}&quot;">​</a></h2><p>Each Rule can use universal conditions specified in the <a href="./../../development/Rules.html#Conditions">Generic Rules</a> section.<br> This section describes the additional Rule conditions you can use in E-mail (Queue) Rules.</p>',13)),t[41]||(t[41]=e("ul",null,[e("li",null,[e("p",null,[e("code",null,"From [is | is not | in | not in] (string)"),e("br"),e("code",null,"Sender [is | is not | in | not in] (string)")]),e("p",null,[o("This condition checks the message "),e("code",null,"From"),o(" or "),e("code",null,"Sender"),o(" address."),e("br"),o(" If a message has no From/Sender address, the condition is met if its operation is "),e("code",null,"is not"),o(" or "),e("code",null,"not in"),o(".")]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"From")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@*communigatepro.ru",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,"This condition will be met for all messages coming from any account in any of the communigatepro.ru subdomains. The same as above, but the message Sender, Reply-To, To, or Cc address is checked.")]),e("li",null,[e("p",null,[e("code",null,"To [is | is not | in | not in] (string)"),e("br"),e("code",null,"Cc [is | is not | in | not in] (string)"),e("br"),e("code",null,"Reply-To [is | is not | in | not in] (string)")]),e("p",null,"The message Reply-To, To, or Cc address is checked."),e("p",null,"If a message has several addresses of the given type, the condition is met if it is true for at least one address. If a message has no addresses of the specified type, the condition is not met.")]),e("li",null,[e("p",null,[e("code",null,"Any To or Cc [is | is not | in | not in] (string)")]),e("p",null,"The same as above, but all message To AND Cc addresses are checked. If the message has no To/Cc addresses, the condition is not met.")]),e("li",null,[e("p",null,[e("code",null,"Each To or Cc [is | is not | in | not in] (string)")]),e("p",null,"All message To AND Cc addresses are checked. The condition is met if it is true for each To and Cc address of the message, or if the message has no To/Cc addresses."),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Each To or Cc")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@mycompany.com,*@mydept.mycompany.com",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,"This condition will be met for messages where all To and CC addresses are addresses in the mycompany.com domain or addresses in the mydept.mycompany.com domain.")]),e("li",null,[e("p",null,[e("code",null,"Return-Path [is | is not | in | not in] (string)")]),e("p",null,'This condition compares the message "Return-Path" (a.k.a. MAIL FROM) envelope address with the specified string.')]),e("li",null,[e("p",null,[e("code",null,"'From' Name [is | is not | in | not in] (string)")]),e("p",null,'The same as above, but the instead of the address, the "address comment" (the real name) included in the From address is checked.'),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"'From' Name")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*J. Smith*",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,[o("This condition will be met for messages with the following "),e("code",null,"From:"),o(" addresses:"),e("br"),e("code",null,"From: jsmith@company.com (John J. Smith)"),e("br"),e("code",null,'From: "Bill J. Smith" b.smith@othercompany.com'),e("br"),e("code",null,"From: Susan J. Smith <susan@thirdcompany.com>")])]),e("li",null,[e("p",null,[e("code",null,"Subject [is | is not | in | not in] (string)")]),e("p",null,"This condition checks if the message subject is (or is not) equal to the specified string."),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Subject")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*rgent*",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,[o("This condition will be met for messages with the following Subject fields:"),e("br"),e("code",null,"Subject: we urgently need your assistance"),e("br"),e("code",null,"Subject: Urgent!")])]),e("li",null,[e("p",null,[e("code",null,"Message-ID [is | is not | in | not in] (string)")]),e("p",null,"This condition checks if the message ID is (or is not) equal to the specified string."),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Message-ID")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*@*",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,[o("This condition will be met for all messages without the Message-ID flag and for messages that have Message-ID without the "),e("code",null,"@"),o(" symbol.")])]),e("li",null,[e("p",null,[e("code",null,"Message Size [is | is not | less than | greater than] (number)")]),e("p",null,"This condition checks if the message size is less than (or greater than) the specified number of bytes."),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Message Size")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"greater than")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"100K",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,"This condition will be met for messages larger than 100 kilobytes.")]),e("li",null,[e("p",null,[e("code",null,"Human Generated")]),e("p",null,"This condition checks if the message is not generated by some automatic message generating software."),e("div",{class:"tip custom-block"},[e("p",{class:"custom-block-title"},"Note"),e("p",null,"This condition has no parameters, so the operation code and the parameter value (if any) are ignored.")]),e("p",null,[o("It actually checks that the message header does not contain any of the following fields: Precedence: bulk, Precedence: junk, Precedence: list, X-List*, X-Mirror*, X-Auto* (except for "),e("code",null,"X-Auto-Response-Suppress"),o("), X-Mailing-List, Auto-*"),e("br"),o(" This condition also checks that the message has a non-empty Return-Path.")])]),e("li",null,[e("p",null,[e("code",null,"Header Field [is | is not | in | not in] (string)")]),e("p",null,[o("This condition checks if the message RFC822 header contains (or does not contain) the specified header field. The fields added using the "),e("code",null,"Add Header"),o(" operation (see below) are checked, too.")]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Header Field")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"X-Mailer: CommuniGate*",size:"35",maxlength:"200"})])])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Attachment name [is | is not | in | not in] (string)")]),e("p",null,[o("This condition checks if the names of the attached files match the specified "),e("em",null,"string"),o(".")]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Attachment name")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*.exe",size:"35",maxlength:"200"})])])])])])])])])]),e("p",null,[o("This condition will be met by E-mails that have at least one attached file with the following extension "),e("code",null,"exe"),o(". "),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Attachment name")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*.exe",size:"35",maxlength:"200"})])])])])])])])])])]),e("p",null,[o("This condition will be met by E-mails that do not have any attached files with an extension "),e("code",null,"exe"),o(". "),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Attachment name")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*.exe,*.docx",size:"35",maxlength:"200"})])])])])])])])])])]),e("p",null,[o("This condition will be met by E-mails that have at least one attached file with an extension "),e("code",null,"exe"),o(" or "),e("code",null,"docx"),o(". "),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"hidden",name:"CNUM",value:"0"}),e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Attachment name")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"not in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*.exe,*.docx",size:"35",maxlength:"200"})])])])])])])])])])]),e("p",null,[o("This condition will be met by E-mails that do not have any attached files with an extension "),e("code",null,"exe"),o(" or "),e("code",null,"docx"),o(".")])]),e("li",null,[e("p",null,[e("code",null,"Any Recipient [is | is not | in | not in] (string)")]),e("p",null,[o('This condition compares message "Envelope" addresses and the specified '),e("em",null,"string"),o(". If this condition is used in an Account-Level Rule, only the addresses routed to that account are checked.")]),e("p",null,[o("The addresses are processed in the form they had "),e("em",null,"before"),o(" the Router Table and other routing methods have modified them. If an account has several aliases, this condition allows you to check if a message was sent to a specific account alias.")]),e("p",null,"Messages can be submitted to the server using the ESMTP ORCPT parameter. This parameter specifies how the address was composed on the sending server, before the relaying/forwarding server has converted it to a different address. In this (rare) case, that server can use the ESMTP ORCPT parameter to specify the original address."),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("ul",null,[e("li",null,[o("a message was composed somewhere and sent to the address "),e("a",{href:"mailto:user1@domain1.com",target:"_blank",rel:"noreferrer"},"user1@domain1.com"),o(";")]),e("li",null,[o("the domain1.com server received the message and converted that envelope address to "),e("a",{href:"mailto:user2@domain2.com",target:"_blank",rel:"noreferrer"},"user2@domain2.com"),o(" (mail forwarding);")]),e("li",null,"the domain1.com server relayed the message to your CommuniGate Pro server domain2.com;"),e("li",null,"the domain2.com CommuniGate Pro server received a message;"),e("li",null,"the domain2.com CommuniGate Pro server found that the user2 is an alias of the user3 account, and the server routed the message to that user3 account.")]),e("p",null,[o("If the domain1.com server is an advanced server and informed the domain2.com CommuniGate Pro server that the original address was "),e("a",{href:"mailto:user1@domain1.com",target:"_blank",rel:"noreferrer"},"user1@domain1.com"),o(", the string "),e("a",{href:"mailto:user1@domain1.com",target:"_blank",rel:"noreferrer"},"user1@domain1.com"),o(" is used when the Recipient condition is checked.")]),e("p",null,[o("If the domain1.com server has not informed your server about the original address, the "),e("a",{href:"mailto:user2@domain2.com",target:"_blank",rel:"noreferrer"},"user2@domain2.com"),o(" string is used when the Recipient condition is checked.")]),e("p",null,"The condition is met if it is met for at least one envelope address.")])])]),e("li",null,[e("p",null,[e("code",null,"Each Recipient [is | is not | in | not in] (string)")]),e("p",null,"The same as above, but the condition is met only if it is met for all message envelope addresses (if used in an Account-Level Rule - for all message addresses routed to that account).")]),e("li",null,[e("p",null,[e("code",null,"Source [is | is not | in | not in] (string)")]),e("p",null,"This condition checks the source where from the message was received:"),e("ul",null,[e("li",null,[e("p",null,[e("code",null,"trusted")]),e("p",null,[o("via SMTP from a computer with the network address listed in the "),e("a",{href:"./../sysadmin/Protection.html#ClientFixed"},"Client IP Addresses"),o(" list")])]),e("li",null,[e("p",null,[e("code",null,"whitelisted")]),e("p",null,[o("via SMTP from a computer with the network address listed in the "),e("a",{href:"./../sysadmin/Protection.html#WhiteHoles"},"White Hole Addresses"),o(" list")])]),e("li",null,[e("p",null,[e("code",null,"authenticated")]),e("p",null,"via SMTP, WebUser, MAPI, POP XMIT, Rules - when the originator of the message has been authenticated")])]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Source")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0"},"is"),e("option",{value:"1"},"is not"),e("option",{value:"2"},"in"),e("option",{value:"3",selected:"selected"},"not in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"trusted,whitelisted,authenticated",size:"35",maxlength:"200"})])])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Security [is | is not | in | not in] (string)")]),e("p",null,"This condition checks if the message is an encrypted or a signed one. It compares the following string with the condition operand:"),e("ul",null,[e("li",null,[e("p",null,[e("code",null,"SMIME:encrypted")]),e("p",null,"if the message is encrypted using the S/MIME standard")]),e("li",null,[e("p",null,[e("code",null,"SMIME:signed")]),e("p",null,"if the message is digitally signed using the binary S/MIME standard (PKCS7)")]),e("li",null,[e("p",null,[e("code",null,"signed")]),e("p",null,"if the message is digitally signed")]),e("li",null,[e("p",null,[o("("),e("em",null,"empty string"),o(")")]),e("p",null,"in all other cases")])]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Security")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0"},"is"),e("option",{value:"1",selected:"selected"},"is not"),e("option",{value:"2"},"in"),e("option",{value:"3"},"not in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*encrypted*",size:"35",maxlength:"200"})])])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Calendar Method [is | is not | in | not in] (string)")]),e("p",null,[o("This condition checks if the message contains a calendar part of particular type ("),e("code",null,"REQUEST"),o(", "),e("code",null,"REPLY"),o(", "),e("code",null,"CANCEL"),o("). This condition can be used in Domain-wide or Account-level rules only.")]),e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("table",{border:"1",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",{bgcolor:"#eeeeee"},[e("table",{width:"100%",border:"0",cellspacing:"0",cellpadding:"2"},[e("tbody",null,[e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Calendar Method")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0"},"is"),e("option",{value:"1"},"is not"),e("option",{value:"2"},"in"),e("option",{value:"3",selected:"selected"},"not in")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"REQUEST,CANCEL",size:"35",maxlength:"200"})])])])])])])])])])])],-1)),t[42]||(t[42]=s('<p>The following conditions can be used in Server-Wide Rules only:</p><ul><li><p><code>Any Route [is | is not | in | not in] (string)</code></p><p>This condition checks a message &quot;Envelope Recipient&quot; address - the address actually telling the Server were to transfer the message to. The condition compares the routing information string for a recipient address and the specified <em>string</em>.</p><p>The condition is met if it is met for at least one envelope recipient address.</p><p>The message address routing information is presented in the following format: <code>module(queue)address</code><br> where <em>module</em> is the name of the module the address is routed to, <em>queue</em> is the name of the module queue the address is routed to, and <em>address</em> is the address in that queue.</p><p>For example, the envelope recipient <code>user@domain</code> address can be routed to:</p><ul><li><p><code>SMTP(domain)user@domain</code> if <code>domain</code> is a remote domain</p></li><li><p><code>LOCAL(user)</code> if <code>domain</code> is the Main Domain</p></li><li><p><code>LOCAL(user@domain)</code> if <code>domain</code> is a secondary CommuniGate Pro Domain</p></li></ul><p>If you plan to use this type of Rule condition, use the Test button on the WebAdmin Interface Router page to see how various addresses are routed.</p></li><li><p><code>Each Route [is | is not | in | not in] (string)</code></p><p>The same as above, but the condition is met only if it is met for all message envelope addresses.</p></li><li><p><code>Authenticated [is | is not | in | not in] (string)</code></p><p>This condition checks the Message authentication. If the Message has been authenticated by this CommuniGate Pro Server, the authenticated Account name (<code>account@domain</code>) is compared with the specified <em>string</em>.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Authenticated</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="*@*communigatepro.ru" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all messages submitted by any account on any of communigatepro.ru subdomains with authentication.</form></li></ul></li></ul><h2 id="Actions" tabindex="-1">Rule Actions <a class="header-anchor" href="#Actions" aria-label="Permalink to &quot;Rule Actions {#Actions}&quot;">​</a></h2><p>Each Rule can have zero, one, or several actions. If a message meets all the Rule conditions, the Rule actions are performed.</p><p>You can use all universal actions described in the <a href="./../../development/Rules.html#Actions">Generic Rules</a> section. This section describes the additional Rule actions you can use in E-mail (Queue) Rules.</p>',5)),e("ul",null,[t[35]||(t[35]=s('<li><p><code>Stop Processing</code></p><p>This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for that message. The message is stored in the INBOX.</p></li><li><p><code>Discard</code></p><p>This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for that message.<br> The message is not stored in the INBOX, but a positive Delivery Notification message is sent back to the message sender (if requested).</p><ul><li><p>Sample:</p><p><code>IF From is *thatannoyingguy@*</code><br><code>THEN</code><br><code>Discard</code></p></li></ul></li><li><p><code>Reject With [error message text]</code></p><p>See the <a href="./../../development/Rules.html#Actions">Rules</a> section.<br> If the action parameter text is not empty, it is used as the error message text.<br> You can still store the rejected message using the Store action before the Reject action.</p><ul><li><p>Sample:</p><p><code>IF Subject is *UCE*</code><br><code>THEN</code><br><code>Reject   please do not send such messages here</code></p></li></ul></li><li><p><code>Mark (flagName [, flagName...])</code></p><p>This action sets or resets the specified message <a href="./../storage/Mailboxes.html#Flags">flag(s)</a>.<br> Initially the set of message flags contains:</p><ul><li>the <code>Media</code> flag - if the message contains a voicemail or videomail (if the message has the <code>audio/*</code>, <code>video/*</code>, or <code>multipart/voice-message</code> Content-Type).</li><li>the <code>Hidden</code> flag - if the message header contains the Sensitivity field with the <code>private</code> value.</li></ul><p>Flag <a href="./../storage/Mailboxes.html#Flags">Names</a> can be used to add flags to the set, while Flag <a href="./../storage/Mailboxes.html#Flags">Negative Names</a> can be used to remove flags from the set.<br> When the message is stored in a Mailbox as a result of the <code>Store in</code> action, as well as when the message is stored in the INBOX after all Rules are applied, the message is stored with the specified flag set.</p><ul><li><p>Sample:</p><p><code>IF Sender is *list*</code><br><code>THEN</code><br><code>Mark Flagged,Read</code></p></li></ul></li><li><p><code>Add Header (header fields)</code></p><p>This action adds RFC822 header fields to the message. Initially, the set of additional message header field contains the Return-Path field generated using the return-path in the message envelope.<br> When a message is stored, sent, copied, or sent to an external program, the additional header fields are added to the message.</p><ul><li><p>Sample:</p><p><code>IF Subject is *purchase*order*</code><br><code>THEN</code><br><code>Add Header X-Special-Processing: order</code>The Add Header action can be used to add an X-Color field. This field is detected by the WebUser Interface and is used to highlight a message in the Mailbox:</p></li></ul><p>Sample:</p><p><code>IF Header Field is X-Spam: *</code><br><code>THEN</code><br><code>Add Header X-Color: red</code></p></li><li><p><code>Tag Subject (tag)</code></p><p>This action specifies a string to be added to the Subject header field.<br> When a message is stored, sent, copied, or sent to an external program, the specified subject tags are inserted into the beginning of the Subject header field.</p><p>Sample:</p><p><code>IF From is ceo@mycompany.dom</code><br><code>THEN</code><br><code>Tag Subject [CEO]</code><br> If several Tag Subject actions have been used with one message, the latest tag is added first, followed with the other tags, followed with the original message Subject.<strong>Note:</strong> the following actions are not implicit &quot;Discard&quot; actions, and they do not prevent the original message from being stored in the INBOX. If you want, for example, to redirect a message without keeping a copy in your INBOX, specify the Redirect action followed with the Discard action.</p></li><li><p><code>Store in (mailboxName)</code></p><p>The message is copied to the specified Mailbox in your Account.</p><p>Sample:</p><p><code>IF From is developer@partner.com</code><br><code>THEN</code><br><code>Store in DeveloperBox</code><br><code>Discard</code>If the mailbox name starts with the <code>[IGNOREFAILURES]</code> prefix, the prefix is removed, and errors occurd while storing a message into a Mailbox are ignored. Otherwise, if there was an error, the Rule processing fails.<br> If the mailbox name starts with the <code>[MUSTEXIST]</code> prefix, the prefix is removed, and the Rule processing fails if the Mailbox does not exist. Otherwise, if the Mailbox does not exist, an attempt to create it is made.<br> If the mailbox name starts with the <code>[IFEXISTS]</code> prefix, the prefix is removed, and the action completes immediately if the Mailbox does not exist.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You may use only one of the above prefixes at a time.</p></div><p>If the mailbox name is specified as <code>~accountName/mailboxName</code>, or as <code>~accountName@domainName/mailboxName</code> the message is stored in the <em>mailboxName</em> Mailbox in the <em>accountName</em> Account in the same Domain or in the <em>accountName</em>@<em>domainName</em> Account.</p><p>When this action is used in a Server-wide or Cluster-wide Rule, the mailbox name must be specified in this form, as there is no default Account for those Rules.</p><p>You should have the Insert access right to that Mailbox.</p><p>Sample:</p><p><code>IF Subject is *Make*$*</code><br><code>THEN</code><br><code>Store in ~postmaster/abuse</code><br><code>Discard</code>If the specified Mailbox cannot be opened or the message cannot be stored in that Mailbox, the Rules processing stops (as if the Stop Processing action was used).</p></li><li><p><code>Redirect to (addresses)</code></p><p>The message is redirected to one or several specified E-mail addresses. If several addresses are specified, they should be separated with the comma (<code>,</code>) symbol.<br> The specified addresses replace the message To/Cc header fields, unless these specified addresses are prefixed with the <code>[bcc]</code> string;<br> The &quot;new sender&quot; address is constructed as the E-mail address of the current Account, or to the MAILER-DAEMON address if the action is used in a Server-wide or a Cluster-wide Rule.<br> The redirected message Return-path address is set to the &quot;new sender&quot; address, or to the empty address if the Return-path address of the original message was empty.<br> The redirected message Sender address is set to the &quot;new sender&quot; address.<br> A Return-Path header field (if any) is changed to the X-Original-Return-Path field.<br> Return-Receipt-To, Errors-To and DKIM-Signature fields are removed.<br> Message-ID, Date, and Sender fields (if any) are renamed into X-Original-Message-ID, X-Original-Date, and X-Original-Sender.<br> New Date and Message-ID fields are created.</p></li><li><p><code>Forward to (addresses)</code></p><p>The message is forwarded to the specified addresses. Same as the Redirect operation, but the &quot;new sender&quot; address is not stored as the Sender field. Instead it is used to compose a new From field.<br> The old From field is renamed into X-Original-From field.</p></li><li><p><code>Mirror to (addresses)</code></p><p>The message is mirrored (redirected) to the specified addresses (with minimal header changes).<br> The redirected message Return-Path is preserved.<br> A Resent-From header field is added. It contains the E-mail address of the current Account (without its Real Name), or the MAILER-DAEMON address if the action is used in a Server-wide or a Cluster-wide Rule.<br> A Return-Path header field (if any) is changed to the X-Original-Return-Path field.<br> Return-Receipt-To and the Errors-To fields are removed.</p></li>',10)),e("li",null,[t[4]||(t[4]=s("<p><code>Reply with (message text)</code></p><p>The specified text is used to compose a reply message. The reply is sent to the address specified in the Reply-To address of the original message. If the Reply-To header is absent, the reply is sent to the From address of the original message.</p><p>The header fields <code>Subject: Re: original message subject</code> and <code>In-Reply-To: original message-ID</code> are added to the reply message.</p><p>The specified message text can contain macro symbols that are substituted with actual data when a reply message is composed:</p><ul><li><code>^S</code> is substituted with the Subject of the original message (in its original form)</li><li><code>^s</code> is substituted with the Subject of the original message (in the MIME-decoded form)</li><li><code>^F</code> is substituted with the From address of the original message (in its original form)</li><li><code>^f</code> is substituted with the From address of the original message (in the MIME-decoded form)</li><li><code>^T</code> is substituted with the Date field of the original message</li><li><code>^I</code> is substituted with the Message-ID field of the original message</li><li><code>^R</code> is substituted with the To field of the original message (in the MIME-decoded form)</li><li><code>^r</code> is substituted with the E-mail address of the current Account.</li></ul><p>Sample:</p>",6)),e("form",h,[e("table",p,[e("tbody",null,[e("tr",m,[e("td",null,[a(i,null,{default:n(()=>t[0]||(t[0]=[o("Reply with")])),_:1})]),t[1]||(t[1]=e("td",null,[e("textarea",{rows:"8",cols:"50",name:"name"},`Dear ^F!

We got your message ^I on ^T. It will be processed shortly and you will be contacted within 1-2 days.

Respectfully, Human Resources.`)],-1))])])])]),t[5]||(t[5]=s("<p>If the specified text starts with the plus (<code>+</code>) symbol, the lines following this symbol are added to the message header. The text should specify the Subject field, since the system will not automatically add the <code>Subject: Re: original subject</code> and <code>In-Reply-To: original message-ID</code> fields into the reply message.</p><p>The specified header portion can contain additional <code>To</code>, <code>Cc</code>, and <code>Bcc</code> fields and the reply message will be sent to those addresses (the <code>Bcc</code> fields will be removed from the message header).</p><p>Unless the specified header contains the <code>From</code> field, the From field is composed using the From Address from the Account WebUser Settings. If that address is not set the From Address is composed using the full Account Name and the Account Real Name setting.</p><p>If the full Account name is not stored as the <code>From</code> field, it is stored as the <code>Sender</code> field.</p><p>The <code>^S</code> and other macro symbols can be used in the additional header fields, too.</p><p>An empty line should separate the message body from the additional header fields:</p>",6)),e("form",g,[e("table",f,[e("tbody",null,[e("tr",b,[e("td",null,[a(i,null,{default:n(()=>t[2]||(t[2]=[o("Reply with")])),_:1})]),t[3]||(t[3]=e("td",null,[e("textarea",{rows:"8",cols:"50",name:"name"},`+Reply-To: special@mycompany.com
Subject: your message about ^S
X-URL-Ref: http://www.mycompany.com
Bcc: statistics@mycompany.com

Dear ^F!

We got your message ^I on ^T. It will be processed shortly and you will be contacted within 1-2 days.

Respectfully, Human Resources.`)],-1))])])])]),t[6]||(t[6]=e("p",null,[o("If the specified text starts with the "),e("code",null,"[charsetName]"),o(" string, the text is converted to the specified charset (all non-ASCII texts are stored in the UTF-8 charset), otherwise it is converted into the charset used in the incoming message. If the incoming message did not have a charset specified, and the Rule is an Account-Level one, the Preferred Charset specified in the Account WebUser Preferences is used.")],-1)),t[7]||(t[7]=e("p",null,[o("If the text starts with the plus symbol, the plus symbol must be specified after the "),e("code",null,"[charsetName]"),o(" string.")],-1)),t[8]||(t[8]=e("p",null,[o("Unless the specified header contains the "),e("code",null,"MIME-Version"),o(" and "),e("code",null,"Content-Type"),o(" fields, these fields are added to the composed message.")],-1))]),t[36]||(t[36]=e("li",null,[e("p",null,[e("code",null,"Reply to All with (message text)")]),e("p",null,[o("The same as above, but the reply is sent to all addresses listed in the "),e("code",null,"To"),o(" and "),e("code",null,"Cc"),o(" fields of the original message.")])],-1)),e("li",null,[t[13]||(t[13]=s("<p><code>React with (message text)</code></p><p>The specified message text should contain a header, an empty line, and the message body. The header should contain any number of <code>To</code>, <code>Cc</code>, and <code>Bcc</code> fields, the Subject field, as well as any number of additional fields.<br> The composed message is sent to the specified addresses.</p><p>The specified message header and the message body can contain macro symbols listed above.</p><p>The <code>From</code>, <code>Sender</code>,<code>MIME-Version</code>, and <code>Content-Type</code> fields are composed in the same way as for the Reply With operation.</p><p>Sample:</p>",5)),e("form",y,[e("table",v,[e("tbody",null,[e("tr",T,[e("td",null,[a(i,null,{default:n(()=>t[9]||(t[9]=[o("React with")])),_:1})]),t[10]||(t[10]=e("td",null,[e("textarea",{rows:"6",cols:"50",name:"name"},`To: 123456@pager.mycompany.com (my pager)
Cc: "My Home Account" <myhome@provider.com>

FYI: message ^I was received from ^F. Its Subject was: ^S`)],-1))])])])]),t[14]||(t[14]=e("p",null,[o("The message text can start with the "),e("code",null,"[charsetName]"),o(" string (see above).")],-1)),t[15]||(t[15]=e("p",null,"Sample:",-1)),e("form",w,[e("table",R,[e("tbody",null,[e("tr",x,[e("td",null,[a(i,null,{default:n(()=>t[11]||(t[11]=[o("React with")])),_:1})]),t[12]||(t[12]=e("td",null,[e("textarea",{rows:"6",cols:"50",name:"name"},`[ISO-8859-1]To: myhome@provider.com (my Home Account)
MIME-Version: 1.0
Content-type: text/html; charset=ISO-8859-1

<HTML><BODY>
Nachricht <B>^I</B> wurde empfangen von ^F <P>Das Betreff war: <I>^S</I>
</BODY></HTML>`)],-1))])])])])]),t[37]||(t[37]=e("li",null,[e("p",null,[e("code",null,"Store Encrypted in (mailbox name)")]),e("p",null,[o("This action works in the same way as the "),e("code",null,"Store in"),o(" action, but a message is converted into "),e("a",{href:"./../sysadmin/PKI.html#SMIME"},"S/MIME encrypted"),o(" form before being stored.")])],-1)),e("li",null,[t[20]||(t[20]=s('<p><code>Copy Attachments into (file directory name)</code></p><p>This action copies the message attachments to the specified <a href="./../storage/FileStore.html">File Storage</a> directory.<br> Attachments are detected as parts of the topmost <code>multipart/mixed</code> or <code>multipart/related</code> MIME structure. If a message contains only one non-multipart part, and the Content-Disposition for that part is &quot;attachment&quot;, it is treated as an attachment, too.<br> If the directory name has the <code>[replace]</code> prefix, an existing file with the same name is replaced, otherwise an error is generated if the file already exists.<br> If the directory name is empty, then files are stored to the topmost level of the Account File Storage.<br> If the directory name ends with the star (<code>*</code>) symbol, the symbol is replaced with a unique string, the file extension from the attachment name (if any) is added and the resulting name is used as the File Storage file name for the attachment.</p><p>Sample:</p>',3)),e("form",S,[e("table",A,[e("tbody",null,[e("tr",k,[e("td",null,[a(i,null,{default:n(()=>t[16]||(t[16]=[o("Copy Attachments into")])),_:1})]),t[17]||(t[17]=e("td",null,[e("textarea",{rows:"2",cols:"50",name:"name"},"[replace]pic-archive")],-1))])])])]),t[21]||(t[21]=e("p",null,"Sample:",-1)),e("form",I,[e("table",C,[e("tbody",null,[e("tr",M,[e("td",null,[a(i,null,{default:n(()=>t[18]||(t[18]=[o("Copy Attachments into")])),_:1})]),t[19]||(t[19]=e("td",null,[e("textarea",{rows:"2",cols:"50",name:"name"},"videolib/video-*")],-1))])])])])]),e("li",null,[t[24]||(t[24]=s('<p><code>Execute (command line)</code></p><p>The specified command is executed in a separate OS process (task).<br> The message text (the header and the body) is sent to the task as that task <em>standard input (stdin)</em>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The task must read the entire <em>stdin</em> data stream, otherwise the Execute command fails.</p></div><p>A command text can be prefixed with the <code>[FILE]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[FILE] myprogram parm1</span></span></code></pre></div><p>When this prefix is used, the task standard input will be empty (closed) or it will contain only the message header fields added by previous Rules.<br> The string -f Queue/<em>fileid</em>.msg (the -f flag and the Message file name, relative to the <em>base directory</em>) will be appended to the end of the command text:</p><p>-f Queue/12002345.msg</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Usually access to the <em>base directory</em> is not granted to regular users, so the <code>[FILE]</code> prefix can be used in the Server-Wide Rules only.</p></div><p>A command text can be prefixed with the <code>[RETPATH]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[RETPATH] myprogram parm1</span></span></code></pre></div><p>When this prefix is specified, the <code>-p</code> string followed by the message return-path address is added to the end of the command text:</p><p>-p &quot;<a href="mailto:address@domain.com" target="_blank" rel="noreferrer">address@domain.com</a>&quot;</p><p>A command text can be prefixed with the <code>[RCPT]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[RCPT] myprogram parm1</span></span></code></pre></div><p>When this prefix is specified the <code>-r</code> string followed by the list of message recipient addresses is added to the end of the command text:</p><p>-r &quot;<a href="mailto:address1@domain1.com" target="_blank" rel="noreferrer">address1@domain1.com</a>&quot; &quot;<a href="mailto:address2@domain2.com" target="_blank" rel="noreferrer">address2@domain2.com</a>&quot;</p><p>A command text can be prefixed with the <code>[ORCPT]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[ORCPT] myprogram parm1</span></span></code></pre></div><p>When this prefix is specified the <code>-r</code> string followed by the list of message recipient addresses is added to the end of the command text. If a recipient address was submitted together with its &quot;original recipient&quot; parameter (the ESMTP ORCPT parameter), the original address is used.</p><p>-r &quot;<a href="mailto:origAddress1@domain1.com" target="_blank" rel="noreferrer">origAddress1@domain1.com</a>&quot; &quot;<a href="mailto:origAddress2@domain2.com" target="_blank" rel="noreferrer">origAddress2@domain2.com</a>&quot;</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The <code>[RCPT]</code> and <code>[ORCPT]</code> prefixes cannot be used together.</p></div><p>A command text in an Account-Level Rule can be prefixed with the <code>[ACCNT]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[ACCNT] myprogram parm1</span></span></code></pre></div><p>When this prefix is specified the <code>-u</code> string followed by the Account name is added to the command text:</p><p>-u &quot;accountName@domainName&quot;</p><p>A command text in a Server-Wide Rule can be prefixed with the <code>[ROUTE]</code> tag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>[ROUTE] myprogram parm1</span></span></code></pre></div><p>When this prefix is specified the string <code>-R</code> followed by the Routed recipient addresses is added to the command text:</p><p>-R &quot;LOCAL(accountName@domainName)&quot; &quot;SMTP(example.com)user@example.com&quot;</p><p>See the <a href="#RouteFormat">conditions</a> section for the Route data format information.</p><p>A command text can be prefixed with the <code>[STDERR]</code> tag (see below).</p><p>A command text can have several prefix strings, and they can be specified in any order. If several of <code>[FILE]</code>, <code>[RETPATH]</code>, and <code>[RCPT]</code> prefix strings are specified, the <code>-f</code> flag and its parameter are added first, followed with the <code>-p</code> flag and its parameter, followed with the <code>-r</code> flag and its parameters.</p><p>When the task completes, the task <em>exit code</em> is checked. If the code is zero, the Rule action is considered as executed successfully, and the next Rule action is executed.</p><p>If the task exit code is non-zero, the message is rejected with the error code &quot;<code>automated processing failed</code>&quot;, and the data from the task <em>standard error</em> channel is recorded in the Log along with the task exit code.<br> If the <code>[STDERR]</code> prefix was specified on the command line, the data written to the <em>standard error</em> channel (if any) is used to compose the error report text.</p><p>The data from the task <em>standard output</em>, if any, should not exceed 4Kbytes in size. It is recorded in the Log and discarded.</p><p>The CommuniGate Pro Server monitors the task during its execution, and it interrupts the task if it does not complete within 2 minutes.</p><p>When a task is to be executed as a part of Account-Level Rule processing, the OS User Name is composed using the Account <a href="./../objects/Accounts.html#OSName">OS User Name</a> setting, and the task is executed in that <em>OS User Environment</em>.</p><p>When the CommuniGate Pro runs under control of a Unix system, the task is assigned the specified Unix User <em>ID</em>, <em>group ID</em>, and the <em>set of groups</em>; the task current directory is set to the Unix User <em>home directory</em>.<br> The Execute action cannot be used in Account-Level Rules if the CommuniGate Pro Server runs under MS Windows operating system. When a task is to be executed as a part of a Server-Wide Rule, it is launched in the CommuniGate Pro Server own environment (with the <em>base directory</em> being the current directory).</p><p>Sample:</p>',39)),e("form",N,[e("table",E,[e("tbody",null,[e("tr",_,[e("td",P,[a(i,null,{default:n(()=>t[22]||(t[22]=[o("Execute")])),_:1})]),t[23]||(t[23]=e("td",null,[e("textarea",{rows:"6",cols:"40",name:"name"},"myscript --myoption -f requests/archive")],-1))])])])])]),e("li",null,[t[27]||(t[27]=e("p",null,[e("code",null,"ExternalFilter")],-1)),t[28]||(t[28]=e("p",null,[o("This action tells the Server to pass the message to an "),e("a",{href:"./ExternalFilters.html"},"External Filter"),o(" program. This action can be specified only in the Server-Wide Rules. The action parameter specifies the name of the External Filter program to use.")],-1)),t[29]||(t[29]=e("p",null,"Sample:",-1)),e("form",F,[e("table",D,[e("tbody",null,[e("tr",q,[e("td",null,[a(i,null,{default:n(()=>t[25]||(t[25]=[o("ExternalFilter")])),_:1})]),t[26]||(t[26]=e("td",null,[e("textarea",{rows:"2",cols:"40",name:"name"},"VirusScan")],-1))])])])])]),t[38]||(t[38]=e("li",null,[e("p",null,[e("code",null,"Accept Request (options)")]),e("p",null,[o("This action can be used to accept Calendaring Meeting Requests automatically. See the "),e("a",{href:"./WebCalendar.html#Automatic"},"Calendaring"),o(" section for more details.")])],-1)),t[39]||(t[39]=e("li",null,[e("p",null,[e("code",null,"Accept Reply")]),e("p",null,[o("This action can be used to accept Calendaring Meeting Replies automatically. See the "),e("a",{href:"./WebCalendar.html#Automatic"},"Calendaring"),o(" section for more details.")])],-1)),e("li",null,[t[32]||(t[32]=e("p",null,[e("code",null,"Add a Disclaimer")],-1)),t[33]||(t[33]=e("p",null,"This action adds the specified disclaimer at the top of the email text or calendar event description. To move the disclaimer to the end, add the [APPEND] attribute at the beginning of the disclaimer text. HTML tags are supported in disclaimer, which will be removed in text versions of messages.",-1)),t[34]||(t[34]=e("p",null,"Sample:",-1)),e("form",L,[e("table",O,[e("tbody",null,[e("tr",V,[e("td",null,[a(i,null,{default:n(()=>t[30]||(t[30]=[o("Disclaimer")])),_:1})]),t[31]||(t[31]=e("td",null,[e("textarea",{rows:"5",cols:"50",name:"name"},`[APPEND]
<div class="alert" style="padding: 4px 12px; background-color: #FFD5DF;">
This message was received from an external sender. Be careful when opening links and attachments from it!
</div>`)],-1))])])])])])]),t[43]||(t[43]=s(`<h2 id="Macro" tabindex="-1">Macro Substitution <a class="header-anchor" href="#Macro" aria-label="Permalink to &quot;Macro Substitution {#Macro}&quot;">​</a></h2><p>Parameter strings for <a href="./../../development/Rules.html#SendURL">SendURL</a>, <a href="./../../development/Rules.html#SendIM">Send IM</a>, <a href="./../../development/Rules.html#SendPush">Send Push</a>, <a href="./../../development/Rules.html#WriteToLog">Write To Log</a> actions can include &quot;macro&quot; - symbol combinations that are substituted with actual data before the parameter is used with the Queue Rule action.</p><p>The following symbol combinations are available:</p><ul><li><code>^S</code> is substituted with the Subject of the original message (in its original form)</li><li><code>^s</code> is substituted with the Subject of the original message (in the MIME-decoded form, converted to UTF-8)</li><li><code>^F</code> is substituted with the From address of the original message (decoded, converted to UTF-8, including the &quot;Real name&quot; part)</li><li><code>^E</code> is substituted with the From address of the original message (the E-mail address only)</li><li><code>^T</code> is substituted with the RFC822-formatted timestamp taken from the Date field of the original message.</li><li><code>^t</code> is substituted with the RFC822-formatted current-time.</li><li><code>^I</code> is substituted with the Message-ID field of the original message</li><li><code>^R</code> is substituted with the To E-mail addresses of the original message (a comma-separated list)</li><li><code>^r</code> is substituted with the recipient E-mail addresses (a comma-separated list).</li><li><code>^^</code> is substituted with a single <code>^</code> symbol.</li></ul><h2 id="Vacation" tabindex="-1">Vacation Message <a class="header-anchor" href="#Vacation" aria-label="Permalink to &quot;Vacation Message {#Vacation}&quot;">​</a></h2><p>Each Account can have a &quot;simplified&quot; Rule to generate Vacation messages. When enabled, the Rule checks that the message is not an auto-generated one, and that the message author (the &#39;From&#39; address) has not be placed into the <code>RepliedAddresses</code> string list. It then composes and sends an Vacation message and adds the message author address into the <code>RepliedAddresses</code> string list, so the Vacation message will be sent to each message author only once. Alternatively, the Notify option may be enabled, so a copy of each incoming message is forwarded to the specified addresses.</p><p>This Rule conditions are: <code>Human Generated</code><br><code>Current Date     is greater   specified time</code> (optional)<br><code>Current Date     is less      specified time</code> (optional)<br><code>From             not in       #RepliedAddresses</code> (optional)</p><p>The Rule actions are:</p><p><code>Reply with            Reply Text</code><br><code>Forward to            address list</code><br><code>Remember &#39;From&#39; in    RepliedAddresses</code></p><p>Only the text of the Reply message can be modified:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="Vacation" value="1" checked="checked" type="checkbox"><b> Vacation Message</b></td></tr><tr><td align="center"><input type="checkbox" name="VacationFrom" value="1" checked="checked">Starts: <input type="date" name="vacationDateFrom" value="2024-01-01" min="2015-01-01" max="2050-01-01">    <input type="checkbox" name="VacationTill" value="1" checked="checked">Ends: <input type="date" name="vacationDateTill" value="2024-01-10" min="2015-01-01" max="2050-01-01"></td></tr><tr><td align="center"><textarea style="font-size:9pt;" name="VacationText" rows="5" cols="70">Dear ^F!

I&#39;m on vacation right now, please contact me after 06-Aug-2008.

Sincerely, Me.</textarea></td></tr><tr><td align="center"><input name="VacationNote" value="1" checked="checked" type="checkbox">Notify:</td></tr><tr><td align="center"><textarea style="font-size:9pt;" name="VacationText" rows="3" cols="70">secretary@domain.com</textarea></td></tr><tr><td align="center"><input name="ClearRepliedAddresses" value="Clear &#39;Replied Addresses&#39; List" class="buttonWhite" type="reset"></td></tr></tbody></table></div></form><ul><li><p><code>Vacation Message</code></p><p>If this option is not selected the Vacation Message Rule is disabled. If this option is selected, the Vacation Message Rule is enabled with a low priority (the rule priority is set to 2).</p></li><li><p><code>Starts</code></p><p>If this option is selected, the Vacation Message Rule starts working at the date specified with this setting.</p></li><li><p><code>Ends</code></p><p>If this option is selected, the Vacation Message Rule stops working at the date specified with this setting.</p></li><li><p><code>Notify</code></p><p>If this option is selected and a list of addresses is specified, a copy of incoming message is forwarded to specified addresses. This option is available only when the account has rights to specify the <em>redirecting</em> Rule actions.</p></li></ul><p>Even if the Administrator has not allowed the user to specify Automated Rules, the Vacation Message can be enabled by the user herself, and the user can always modify the Vacation Message text.</p><p>If &quot;Clear &#39;Replied Addresses&#39; List&quot; button is clicked, the <code>RepliedAddresses</code> string list is removed from the Account dataset. Alternatively, the Enable Vacation Message button can be present. It enables the Vacation Rule and clears the Replied Addresses list at the same time.</p><h2 id="Redirect" tabindex="-1">Copy All Mail Simplified Rule <a class="header-anchor" href="#Redirect" aria-label="Permalink to &quot;Copy All Mail Simplified Rule {#Redirect}&quot;">​</a></h2><p>An Account can use a simplified Rule to send copies all incoming E-mail messages to a different address or addresses.</p><p>This Rule condition is either empty (the Rule action is applied to all messages) or, optionally, <code>human generated</code>, the Rule actions are <code>Forward to</code> or <code>Redirect to</code> or <code>Mirror to</code>, and, optionally, <code>Discard</code>.</p><p>Only the list of redirection addresses can be modified:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="Redirect" value="1" type="checkbox" checked="checked"><b> Copy All Mail To</b></td></tr><tr><td colspan="3" align="center"><textarea style="font-size:9pt;" name="RedirectText" rows="3" cols="50">myothername@other.provider.com, thirdName@third.provider.net</textarea></td></tr><tr align="center"><td><input type="checkbox" name="RedirKeep" value="1"> Keep the Original</td><td><input type="checkbox" name="RedirHuman" value="1" checked="checked"> Do not Copy Automatic Messages</td><td><select name="CopyRuleAction"><option value="0" selected="selected">Send on behalf of this Account</option><option value="1">Keep the Original sender Address</option><option value="2">Send unchanged Copy</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Copy All Mail To</code></p><p>If this option is not selected the Copy All Mail Rule is disabled. If this option is selected, the Copy All Mail Rule is enabled with the lowest priority (the rule priority is set to 1).</p></li><li><p><code>Keep the Original</code></p><p>If this option is not selected, the action <code>Discard</code> is added to the Rule and all copied messages are NOT stored in the account INBOX.</p></li><li><p><code>Do not Copy Automatic Messages</code></p><p>If this option is selected, the condition <code>Human Generated</code> is added to the Rule and messages from non-human sources (mailing list messages, error messages, redirected and mirrored messages) are not processed with this Rule.</p></li><li><p><code>Send on behalf of this Account</code></p><p>If this option is selected, the <code>Forward to</code> action is used for this Rule. This option must be used if the Account has &#39;From&#39; Address/Name <a href="./../objects/Accounts.html#TransferOut">restrictions</a> enforced, or if the target host enforces DMARC or other checks of the sender address.</p></li><li><p><code>Keep the Original sender Address</code></p><p>If this option is selected, the <code>Redirect to</code> action is used for this Rule.</p></li><li><p><code>Send unchanged Copy</code></p><p>If this option is selected, the <code>Mirror to</code> action is used for this Rule. The account user can set this Rule only if the Account is granted a right to specify the <em>redirecting</em> Rule actions. Otherwise only the Administrator can set this Rule for the user account.</p></li></ul><h2 id="Junk" tabindex="-1">Junk Processing Simplified Rules <a class="header-anchor" href="#Junk" aria-label="Permalink to &quot;Junk Processing Simplified Rules {#Junk}&quot;">​</a></h2><p>An Account can have simplified Rules to handle junk E-mail messages.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Junk Mail Control</b></td></tr><tr align="center"><td>High probability: <select name="JunkHighAction"><option value="0"></option><option value="1" selected="selected">Discard</option><option value="2">Store in Junk</option><option value="3">Mark as Junk</option></select></td><td>Medium probability: <select name="JunkMediumAction"><option value="0"></option><option value="1">Discard</option><option value="2" selected="selected">Store in Junk</option><option value="3">Mark as Junk</option></select></td><td>Low probability: <select name="JunkLowAction"><option value="0"></option><option value="1">Discard</option><option value="2">Store in Junk</option><option value="3" selected="selected">Mark as Junk</option></select></td></tr></tbody></table></div></form><p>These Rules rely on other Rules, usually employing <a href="#ExternalFilter">External Filter</a> programs, to add a special message headers field with the &quot;junk probability&quot; level.</p><p>Each Junk Control Rule has a condition checking contents on the <code>X-Junk-Score</code> message header field. The other condition checks if the message From address is not included into the AddressBook dataset (&quot;whitelisting&quot;).</p><p>If the conditions are met, a Junk Control Rule can either discard the E-mail message, store it in the Junk Mailbox (the Junk Mailbox name as specified using the Account Preferences), or mark the stored E-mail Message with the <code>Junk</code> flag.</p><h2 id="Log" tabindex="-1">Logging Rules Activity <a class="header-anchor" href="#Log" aria-label="Permalink to &quot;Logging Rules Activity {#Log}&quot;">​</a></h2><p>The <a href="./">Enqueuer</a> component records Server-Wide Rules activity in the Log.<br> Set the Enqueuer Log Level to <code>Low-Level</code> or <code>All Info</code> to see the Rules checked and the actions executed.</p><p>The <a href="./Local.html">Local Delivery</a> module records Domain-Wide and Account-Level Rules activity in the Log.<br> Set the Local Delivery module Log Level to <code>Low-Level</code> or <code>All Info</code> to see the Rules checked and the actions executed.</p>`,29))])}const G=l(u,[["render",W]]);export{z as __pageData,G as default};
