import{_ as l,C as r,c as d,o as p,ag as s,j as e,a as o,G as n,w as i}from"./chunks/framework.jCcxW76o.js";const C=JSON.parse('{"title":"SMTP Module","description":"","frontmatter":{"legacyLink":"SMTP.html"},"headers":[],"relativePath":"admin/mail/SMTP.md","filePath":"admin/mail/SMTP.md"}'),u={name:"admin/mail/SMTP.md"},c={action:"Null.html"},h={class:"settingsBox"},m={width:"100%"},v={valign:"top"},g={colspan:"2",align:"right",nowrap:"nowrap"},f={align:"right",nowrap:"nowrap"},y={colspan:"2",align:"right",nowrap:"nowrap"},T={colspan:"2",align:"right"},b={align:"right",nowrap:"nowrap"},S={align:"right",colspan:"2"};function P(w,t,M,k,R,I){const a=r("tt");return p(),d("div",null,[t[27]||(t[27]=s('<h1 id="smtp-module" tabindex="-1">SMTP Module <a class="header-anchor" href="#smtp-module" aria-label="Permalink to &quot;SMTP Module&quot;">​</a></h1><p>The CommuniGate Pro SMTP module implements E-mail message transfer using the <a href="./../common/Features.html#SMTP">SMTP and ESMTP Internet protocols</a> via TCP/IP networks.</p><p>The Simple Mail Transfer Protocol allows computers to transfer messages using network connections. A computer that has a message to send connects to the recipient&#39;s computer and establishes a network link. Then it sends one or several messages and closes the network connection.</p><p>Mailer applications use the SMTP protocol to submit messages to the mail servers, and mail servers then forward the submitted messages to the recipients. All mailers have a setting called SMTP Host Address that specifies the network address of the mail server computer. Mailer applications open TCP connections to that address when they have a message to submit.</p><p>The CommuniGate Pro SMTP module supports special &quot;secure ports&quot; and the <code>STARTTLS</code> SMTP extension, and it can receive and send mail via secure (encrypted) connections.</p><p>The CommuniGate Pro SMTP module supports the <code>AUTH</code> extension and it allows remote users to authenticate themselves before submitting messages.</p><p>The CommuniGate Pro SMTP module also implements a protocol variation called LMTP (Local Mail Transfer Protocol).</p><h2 id="Protocol" tabindex="-1">Simple Mail Transfer Protocol (SMTP) and DNS <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Simple Mail Transfer Protocol (SMTP) and DNS {#Protocol}&quot;">​</a></h2><p>Mail servers use the global Domain Name System to find the network address of the recipient computer or the recipient mail server. Each domain (part of the E-mail address after the <code>@</code> symbol) should have a special so-called MX-record in the Domain Name System. That record specifies the name of the computer that actually receives mail for that domain. For example, MX records can specify that mail for the domain <code>company.com</code> should be sent to the computer <code>mail.company.com</code>, and mail to the domain <code>enduser.com</code> should be sent to the computer <code>provider.com</code>.</p><p>There can be several MX-records for one domain (with different priority values). If one (high-priority or primary) computer cannot receive mail, mail is sent to lower-priority computers (called Back-up Mail Servers). Back-up mailer servers then try to deliver the message to the primary server.</p><p>When the name of the recipient computer is retrieved from the DNS, the sending mail server consults the DNS again. Now it uses the DNS to convert the receiving mail server name into its network address. The so-called DNS A-records contain the pairs that link a computer name to its global Internet network (IP) address.</p><p>When the network address of the recipient mail server is received from the DNS, the sending mail server opens an SMTP connection to that server and transfers the message(s). When all messages to that domain are transferred, the connection is closed.</p><p>When a message contains several addresses within the same domain, the SMTP module can transfer only one copy of the message to the mail server serving that domain, and that server delivers messages to all recipients in that domain. But if there are too many addresses, the SMTP module can break them in several portions and send several copies, each containing only a portion of the address set.</p><p>If there are several messages to one domain, the SMTP module can open several connections to the mail server serving that domain and send those messages simultaneously.</p><p>If you want to receive messages from the Internet with your own mail server, you should register your domain name, and ask your provider to register that name with the Domain Name System. The DNS records should point to the computer running your mail server.</p><h2 id="Configuring" tabindex="-1">Configuring the SMTP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the SMTP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the SMTP module. Open the Mail pages in the Settings realm, then open the SMTP pages.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5" selected="selected">All Info</option></select></td><td colspan="2"> </td><td align="right">Channels: <select name="MaxOutputChannels"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="500">500</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="51">other</option></select></td></tr></tbody></table></div></form><p>Use the Log setting to specify what kind of information the SMTP module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the SMTP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The SMTP module records in the System Log are marked with the <code>SMTPI</code> tag for incoming connections, with the <code>SMTP</code> tag for outgoing connections, and with <code>SMTPW</code> tag for connections used to wake up the back-up server.</p><h2 id="Sending" tabindex="-1">Sending Messages via the Internet <a class="header-anchor" href="#Sending" aria-label="Permalink to &quot;Sending Messages via the Internet {#Sending}&quot;">​</a></h2><p>If you want to send messages over the Internet, your server should have a TCP/IP link to the Internet. When a message should be transferred to some remote host, the SMTP module connects to that host via the TCP/IP network, and it transfers the message using the SMTP protocol.</p><ul><li><p><code>Channels</code></p><p>This setting (see above) limits the number of outgoing SMTP connections the module is allowed to open simultaneously.</p></li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td colspan="2"><input name="UseForeignServer" value="0" checked="checked" type="radio">Send Directly to Recipients</td><td align="right">Default IP Address:</td><td><select name="DefaultSendingIP"><option value="[0.0.0.0]" selected="selected">OS default</option><option value="[213.33.180.10]">[213.33.180.10]</option><option value="[10.1.0.1]">[10.1.0.1]</option><option value="[10.1.0.51]">[10.1.0.51]</option><option value="[10.1.1.1]">[10.1.1.1]</option><option value="[127.0.0.1]">[127.0.0.1]</option></select></td></tr><tr><td colspan="2"><input name="UseForeignServer" value="1" type="radio">Forward to <input name="ForeignServer" value="mail.provider.com" size="25" maxlength="255" type="text"></td><td colspan="2"></td></tr><tr><td colspan="4"><hr></td></tr><tr><td align="right">Channels/Host:</td><td><select name="ChannelsPerHost"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4" selected="selected">4</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="20">20</option><option value="25">25</option><option value="6">other</option></select></td><td align="right">Add Channels after:</td><td><select name="StartParallel"><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60" selected="selected">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600">6 hour(s)</option><option value="25200">7 hour(s)</option><option value="28800">8 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option></select></td></tr><tr><td colspan="2"> </td><td align="RIGHT">or when Queue size is:</td><td><select name="StartParallelQueue"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="15">15</option><option value="20">20</option><option value="30">30</option><option value="40">40</option><option value="50" selected="selected">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="4">other</option></select></td></tr><tr><td colspan="4"><hr></td></tr><tr><td align="right">Recipients/Message:</td><td><select name="SendRecipients"><option value="-1" selected="selected">unlimited</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="9999">other</option></select></td><td></td><td><input name="HideReceivedFields" value="1" type="checkbox">Hide &#39;Received&#39; fields</td></tr><tr><td colspan="3"> </td><td><input name="AlwaysTryEHLO" value="1" type="checkbox">Always try &#39;EHLO&#39;</td></tr></tbody></table></div></form><ul><li><p><code>Default IP Address</code></p><p>When CommuniGate Pro receives a message, it can assign one of its local network addresses to that message, and if the SMTP module needs to send such a message, it will send it via the assigned local address. See the <a href="./../objects/Domains.html#RelayIP">Domains</a> section for more details. All other messages are sent out via the Default SMTP IP Address. Set this setting to <code>OS Default</code> to let the server OS pick the proper local network address itself.</p></li><li><p><code>Recipients/Message</code></p><p>This setting specifies how many recipients can be sent with one message. If a message has too many recipients, the specified number of recipients is sent, then the message body is sent, and then the module repeats the sending procedure with the same message - for the remaining recipient addresses.</p></li><li><p><code>Hide Received Fields</code></p><p>If this option is selected, the SMTP module modifies all <code>Received</code> header fields in the messages it sends to non-client network addresses. Only the time stamp values are left in those fields, while all other field values are replaced with some dummy data.</p></li><li><p><code>Always use EHLO</code></p><p>If this option is selected, the SMTP module always sends the <code>EHLO</code> command to remote servers, trying to establish the extended SMTP (ESMTP) protocol.<br> If this option is not selected, the SMTP module checks the remote server greeting line. The SMTP module sends the <code>EHLO</code> command only if this line contains the <code>ESMTP</code> word.</p></li></ul><p>When sending messages over the Internet, the SMTP module can forward them to some other mail server, or it can deliver messages directly to the recipients, using the DNS MX-records to find the recipient hosts on the Internet.</p><p>When the SMTP module sends a message from a Domain with an assigned IP address:</p><ul><li>the connection to the remote server can be made from the Domain IP address, see <a href="./../objects/Domains.html#OutgoingIP">Domain Settings</a> section</li><li>the module sends the HELO/EHLO command using that Domain name. If this name does not resolve to the Network IP Address of this CommuniGate Pro Server, some receiving systems may reject SMTP connections coming from your Server.<br> In this situation you can update the <a href="./../objects/Domains.html#HELOPrefix">Domain Settings</a> to specify an alternative name to use with the HELO/EHLO command.</li></ul><p>When the SMTP module sends a message from a Domain without any assigned IP address:</p><ul><li>the connection to the remote server is made from the <a href="#DefaultIP">Default IP address</a></li><li>the module sends the HELO/EHLO command using the Main Domain name. If this name does not resolve to the Network IP Address of this CommuniGate Pro Server, some receiving systems may reject SMTP connections coming from your Server.<br> In this situation you can update the Default <a href="./../objects/Domains.html#HELOPrefix">Domain Settings</a> to specify an alternative name to use with the HELO/EHLO command.</li></ul><h3 id="Foreign" tabindex="-1">Sending via a Forwarding Mail Server <a class="header-anchor" href="#Foreign" aria-label="Permalink to &quot;Sending via a Forwarding Mail Server {#Foreign}&quot;">​</a></h3><ul><li><p><code>Forward to</code></p><p>When this option is selected, the SMTP module connects to the specified <em>Forwarding Mail Server</em> (also called a <em>smart host</em>) and sends all queued messages to that server. Since the Forwarding Mail Server is usually &quot;close&quot; to your server, messages leave your system quickly. But this method can cause additional delays in message delivery, since messages are queued on the Forwarding Server and those queues can be processed slowly. This method is recommended when your server is connected to the Internet using a slow link, or when you use a dial-up link and you want messages to leave your server as soon as possible to keep the connection time short.</p><p>Select the Forward to option and specify the name or the IP address of the Forwarding Server. The SMTP module will forward all outgoing messages to that mail server for delivery.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The name of the Forwarding Mail Server should be the name of the real computer (as specified in an A-type DNS record), not a mail domain (MX-type) name. While your provider domain name can be <code>provider.com</code>, the name of the provider mail server can be something like <code>mail.provider.com</code>. Consult with your provider to get the exact name of the Forwarding Mail Server you can use.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You can specify the IP address of the Forwarding Server instead of its name. You can also specify several IP addresses, separated with the comma (,) symbol. If an SMTP connection to the first specified address cannot be established, the SMTP module will try the next specified address.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When configuring a <a href="./../cluster/EMail.html#Submit">Cluster Backend</a> Server, you can specify the asterisk (<code>*</code>) symbol in the Forward To setting. In this case, all Cluster Frontends (specified on the Cluster Settings page) will be used as the Forwarding Mail Servers.</p></div></li><li><p><code>AUTH Name</code></p><p>The Forwarding Mail Server should be configured to enable relaying from your server to any other server on the Internet. Some Forwarding Mail Servers may require your server to use the AUTH command with a valid name and password parameters before transferring messages that need to be relayed. In this case you should enter the AUTH login name and password in the AUTH fields.</p><p>This type of configuration is used when your server has a &quot;dynamic IP address&quot;, and receives mail from the same Forwarding Server using the <a href="#ATRNWakeup">ATRN method</a>. Usually the username and password used for mail forwarding are the same as the username and password used for ATRN receiving.</p></li></ul><h3 id="SendDirectly" tabindex="-1">Sending Messages Directly to Recipients <a class="header-anchor" href="#SendDirectly" aria-label="Permalink to &quot;Sending Messages Directly to Recipients {#SendDirectly}&quot;">​</a></h3><ul><li><p><code>Directly to Recipients</code></p><p>When this option is selected, the SMTP module uses the DNS (Domain Name System) to convert message recipient addresses into the names and addresses of the receiving hosts. A receiving host can be the recipient host itself, or a relay host. The information about the proper relay host is stored in so-called MX records on Domain Name Servers. For each destination host several records can exist, each record having a priority value. If the SMTP module fails to connect to the relay host with the highest priority, other MX records are used and other relay hosts are tried. If no relay host is available, the message remains in the SMTP queue, and more attempts to deliver it (and all other messages to the same host) are made later.</p></li></ul><p>This method allows the system to deliver a message either directly to the recipient computer or to a relay host that is &quot;very close&quot; to the recipient computer. Recipients can read your messages almost immediately, and your messaging system does not rely on any Forwarding Mail Server performance.</p><h3 id="MultiChannel" tabindex="-1">Multi-channel Delivery <a class="header-anchor" href="#MultiChannel" aria-label="Permalink to &quot;Multi-channel Delivery {#MultiChannel}&quot;">​</a></h3><p>When the Server queue contains several messages to be directed to the same domain, the SMTP module opens a connection to that domain mail server and sends messages one by one. If the established connection is slow and there is a large message in the Queue, other messages would wait too long before being delivered. You may want to allow the SMTP module to open additional connections to the same mail server and send other messages in parallel.</p><ul><li><p><code>Channels/Host</code></p><p>Use this setting to limit the number of TCP connection the SMTP module is allowed to establish with one domain mail server.</p></li><li><p><code>Add Channel after</code></p><p>When the SMTP module cannot send a single message within this time period, and there are other messages in the same Queue, the module opens a new parallel connection.</p></li><li><p><code>when Queue size is</code></p><p>If the SMTP module is sending a message, and there number of unsent messages in the same Queue is equal or larger than the value of this setting, the module opens a new parallel connection.</p></li></ul><h3 id="Retrying" tabindex="-1">Retrying Sending Attempts <a class="header-anchor" href="#Retrying" aria-label="Permalink to &quot;Retrying Sending Attempts {#Retrying}&quot;">​</a></h3><p>If an attempt to deliver a message fails, the SMTP module can delay delivery of that message, or it can delay delivery of the entire host queue (if a connection with the host could not be established or an established connection was broken, etc). The Retrying panel allows you to control how the SMTP module makes attempts to deliver messages:</p>',40)),t[28]||(t[28]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Retrying")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Retry Every:"),e("td",null,[e("select",{name:"DelayFailedTime"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800",selected:"selected"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1801"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"for the first:"),e("td",null,[e("select",{name:"ChangeDelayAfter"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800",selected:"selected"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"10801"},"other")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"then Every:"),e("td",null,[e("select",{name:"AltDelayFailedTime"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800",selected:"selected"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"10801"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"for:"),e("td",null,[e("select",{name:"MaxAttemptsTime"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200",selected:"selected"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"259201"},"other")])])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Messages with empty 'Return-Path':"),e("td",{align:"right",nowrap:"nowrap"},"for:"),e("td",null,[e("select",{name:"EmptyPathAttemptsTime"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800",selected:"selected"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"10801"},"other")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Delay Messages:"),e("td",null,[e("select",{name:"DelayFailedFrom"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200",selected:"selected"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1201"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"Delay Recipients:"),e("td",null,[e("select",{name:"DelayFailedRecipient"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200",selected:"selected"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1201"},"other")])])]),e("tr",null,[e("td",{colspan:"3",align:"right",nowrap:"nowrap"},"Send Warnings after:"),e("td",null,[e("select",{name:"SendWarningTime"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800",selected:"selected"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"345600"},"4 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"10801"},"other")])])])])])])],-1)),t[29]||(t[29]=s('<ul><li><p><code>Retry Every</code></p><p>Use this setting to tell the SMTP module when it should retry to send a message if a connection fails. If you use a Forwarding Mail Server, this option specifies when the module should retry to connect to that server if the previous connection failed for any reason. If you use the Directly to Recipients method, and a connection to some remote host (domain) fails, all messages directed to that domain will be suspended for the specified time. Usually SMTP systems suspend messages for 30 minutes.</p></li><li><p><code>for the first</code> .... <code>then Retry</code></p><p>Use these settings to tell the SMTP module when and how it should change the retry interval. Usually, you would tell the SMTP module to increase the retry interval to 1-2 hours after a message has spent more than 2 hours in the queue.</p></li><li><p><code>for</code></p><p>Use this setting to limit the number of attempts to deliver a message. If a message cannot be delivered within the specified period of time, the message is rejected and an error report saying that the host is unavailable is sent back to the message sender.</p></li><li><p><code>Messages with empty &#39;Return Paths&#39;: for</code></p><p>This setting specified the alternative Keep Trying value for messages with empty Return-Paths. These messages are used to report failed or successful delivery, and they can be discarded from the Queue after fewer attempts.</p></li><li><p><code>Delay Messages</code></p><p>When a receiving host returns a &quot;temporary failure&quot; (4xx) response for a message sending command (MAIL FROM, DATA, the &quot;final dot&quot;), this setting specifies when an attempt to send this message should be repeated.</p></li><li><p><code>Delay Recipient</code></p><p>When a receiving host returns a &quot;temporary failure&quot; (4xx) response for a message recipient command (RCPT TO), this setting specifies when an attempt to send the message to this recipient should be repeated.</p></li><li><p><code>Send Warnings After</code></p><p>Use these settings to tell the SMTP module when warning messages should be sent back to the message senders, notifying them about delivery delays.</p></li></ul><h3 id="Secure" tabindex="-1">Secure (encrypted) Message Relaying <a class="header-anchor" href="#Secure" aria-label="Permalink to &quot;Secure (encrypted) Message Relaying {#Secure}&quot;">​</a></h3><p>You can configure your CommuniGate Pro Server SMTP module to use secure (encrypted) connections when sending messages to remote sites.</p>',3)),t[30]||(t[30]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Send Encrypted (SSL/TLS)")])]),e("tr",{valign:"top"},[e("td",{align:"right"}," "),e("td",null,[e("select",{name:"SendTLSMode"},[e("option",{value:"0"},"Never"),e("option",{value:"1",selected:"selected"},"Wherever possible (low security)"),e("option",{value:"2"},"Always (high security)")])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"TLS Version:"),e("td",null,[e("select",{name:"TLSMaxVersion"},[e("option",{value:"0"},"SSLv3"),e("option",{value:"1"},"TLSv1.0"),e("option",{value:"2",selected:"selected"},"TLSv1.1"),e("option",{value:"3"},"TLSv1.2"),e("option",{value:"4"},"TLSv1.3")])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"TLS Client Certificate:"),e("td",null,[e("select",{name:"TLSCertMode"},[e("option",{value:"0"},"None"),e("option",{value:"1"},"Sender Domain's or None"),e("option",{value:"2",selected:"selected"},"Sender or Main Domain's")])])])])])])],-1)),t[31]||(t[31]=s('<ul><li><p><code>Never</code></p><p>Select this option if you want the SMTP module to send via an unencrypted channel.</p></li><li><p><code>Wherever possible (low security)</code></p><p>Select this option if you want the SMTP module to try to use SSL/TLS connections with remote SMTP servers that support this feature. If the remote server supports the STARTTLS command, the SMTP module tries to establish a secure (SSL/TLS) connection with that server.<br> The module does not check the remote server Certificate validity or the Certificate Subject in this case. If the STARTTLS command or secure connection negotiations fail, the server defaults back to plain-text communication and sends messages via an unencrypted channel.<br> Some servers advertise STARTTLS support, but fail to accept SSL/TLS connections. When this option is selected, it is impossible to send E-mail to those servers. To solve this problem, inform the broken server administrator, and create a <a href="#SendingProf">Profile</a> with the list of the exception hosts which uses the &quot;Never&quot; option.</p></li><li><p><code>Always (high security)</code></p><p>Select this option to enforce secure connections with the remote servers.</p><p>When the CommuniGate Pro SMTP module connects to a remote SMTP server, it checks if that server supports the <code>STARTTLS</code> protocol extension command. Then the SMTP module uses this command to initiate a secure connection with that server.</p><p>The CommuniGate Pro SMTP module checks the validity of the remote server Certificate using the specified set of the <a href="./../sysadmin/PKI.html#Trusted">Trusted Certificates</a>.<br> The remote server Certificate <em>subject</em> must contain the <code>cn</code> (<em>Common Name</em>) field that matches either the domain name of the remote site, or the name of this relay. This can often cause a problem, since the domain <code>company.dom</code> may have the MX record <code>relay1.company.dom</code>, but the computer with the <code>relay1.company.dom</code> address has the &quot;main&quot; DNS name <code>smtp.company.dom</code> and its Certificate is issued to that name (its Certificate <em>subject</em> contains <code>smtp.company.dom</code> in the <code>cn</code> field).</p><p>To solve this problem, you should explicitly route all traffic to the <code>company.dom</code> domain via the <code>smtp.company.dom</code> relay, using the following <a href="./../sysadmin/Router.html">Router</a> record:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>NoRelay:company.dom = company.dom@smtp.company.dom._via</span></span></code></pre></div><p>See the <a href="#Routing">Routing</a> section for more details about SMTP routing.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This feature ensures that messages between your server and a remote server are transferred securely. To provide complete end-to-end security, you should verify that:</p><ul><li>users submit messages to servers either using a private network, or using TLS/SSL connections over the public Internet (secure SMTP or secure WebMail);</li><li>all mail servers and relays exchange messages either using a private network, or using TLS/SSL connections over the public Internet (secure SMTP);</li><li>users read messages either using a private network, or using TLS/SSL connections over the public Internet (secure POP, IMAP, WebMail).</li></ul></div><p>If the receiving server does not support the STARTTLS command, or the remote server certificate cannot be validated, or the remote server certificate Subject does not match the domain or domain relay name, all messages to that domain are <strong>rejected</strong>, ensuring that no message is sent via a potentially insecure link.</p><p>If your server sends all outgoing mail via a <a href="#Foreign">Forwarding Mail Server</a>, the CommuniGate Pro SMTP module does not check the <em>Subject</em> of the Forwarding Server certificate.</p></li><li><p><code>TLS Version</code></p><p>The highest version of TLS the SMTP module will try to use. If the connection fails due to TLS handshake problems and the &quot;herever possible&quot; flag is set, then for the every next attempt the version one step lower will be used. The final delivery attempt will be done without TLS.</p></li><li><p><code>TLS Client Certificate</code></p><p>A remote server may request that the sending server additionally authenticates by a certificate. If the remote server sends certificate request during handshake, it can be handled in three possible ways:</p><ul><li><p>None</p><p>no client certificate is sent.</p></li><li><p>Sender Domain&#39;s or None</p><p>if a certificate matching the request is installed in the sending domain, it will be sent; no certificate is sent otherwise.</p></li><li><p>Sender or Main Domain&#39;s</p><p>if a certificate matching the request is installed in the sending domain, it will be sent; the certificate from the Main Domain is sent otherwise.</p></li></ul></li></ul><p>If an outgoing connection is made to the port 465 (see <a href="#SendPort">Sending to Non-Standard Ports</a> section), then the SMTP module initiates the secure (SSL/TLS) protocol immediately after establishing a TCP/IP connection.</p><h3 id="SendingProf" tabindex="-1">Target Host Profiles <a class="header-anchor" href="#SendingProf" aria-label="Permalink to &quot;Target Host Profiles {#SendingProf}&quot;">​</a></h3><p>A Host Profile is an additional named set of the SMTP Module settings. You can have several profiles, for different sets of target hosts.</p><p>To create a new Profile, or edit an existing profile, use the WebAdmin Interface to open the Sending settings page of the SMTP module. The page lists names of all created Profiles.</p>',5)),t[32]||(t[32]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},"Profiles")]),e("tr",null,[e("td",null,[e("a",{href:"SMTP.html#SendingProf"},"Big providers")]),e("td",null," "),e("td",null,[e("a",{href:"SMTP.html#SendingProf"},"Lame Hosts")]),e("td",null," ")]),e("tr",null,[e("td",null,[e("a",{href:"SMTP.html#SendingProf"},"our ISP")]),e("td",null," "),e("td",null," ")]),e("tr",null,[e("td",{colspan:"3"},[e("hr")])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"New Profile Name:"),e("td",{align:"left"},[e("input",{name:"NewProfile",type:"text",size:"18",maxlength:"200"})]),e("td",null,[e("input",{name:"CreateProfile",type:"submit",value:"Create Profile",class:"buttonWhite"})])])])])])],-1)),t[33]||(t[33]=e("p",null,"Enter the new Profile name and click the Create Profile button. A new Profile will be created.",-1)),t[34]||(t[34]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("td",null,[e("b",null,"Big providers")]),e("td")]),e("tr",{valign:"top"},[e("td",{align:"right",width:"*/3"},"Comment:"),e("td",null,[e("textarea",{name:"Comment",cols:"70",rows:"3"},`Big providers.
More channels, less delays.`)])]),e("tr",{valign:"top"},[e("td",{align:"right",width:"*/3"},"Hosts:"),e("td",null,[e("textarea",{name:"Hosts",cols:"70",rows:"3"},"*gmail.com,*yahoo.com")])])])])])],-1)),t[35]||(t[35]=s('<p>Each Profile has a list of domain names to whose hosts the Profile&#39;s settings are applied. The specified names can contain a wildcard - the asterisk (<code>*</code>) symbol. The settings of the SMTP Module are used as default values for the Profile&#39;s settings.</p><p>The Profiles are checked in the alphabetical order of their names. A domain may be listed in multiple profiles, but only the first matched profile will be used.</p><p>By using Profiles you can override the default SMTP module settings for particular target domain or group of domains. For example, you can assign a domain a dedicated <a href="#Foreign">Forwarding Server</a>, with dedicated authentication parameters.</p><h2 id="Receive" tabindex="-1">Receiving Messages <a class="header-anchor" href="#Receive" aria-label="Permalink to &quot;Receiving Messages {#Receive}&quot;">​</a></h2><p>The SMTP protocol is used to receive messages from the Internet and from the client mailer applications. If you want to receive messages from the Internet, you need a TCP/IP link to the Internet, and your server domain name and the IP address should be included into the DNS records.</p><p>Click the Receiving link on any SMTP Settings page to open the SMTP Receiving settings page.</p>',6)),t[36]||(t[36]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Processing")])]),e("tr",null,[e("td",null,[o("Log Level: "),e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5",selected:"selected"},"All Info")])]),e("td",{colspan:"4",class:"arrow",align:"center",nowrap:"nowrap"},[e("a",{href:"Listener.html"},"Listener")]),e("td",{align:"right"},[o("Channels: "),e("select",{name:"MaxInputChannels"},[e("option",{value:"0"},"0"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"25",selected:"selected"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250"),e("option",{value:"500"},"500"),e("option",{value:"1000"},"1000"),e("option",{value:"2500"},"2500"),e("option",{value:"26"},"other")])])])])])])],-1)),t[37]||(t[37]=s('<ul><li><p><code>Channels</code></p><p>When you specify a non-zero value for this setting, the SMTP module creates a so-called &quot;listener&quot;. The module starts to accept all SMTP connections that other mail servers establish in order to send mail to your Server. This setting is used to limit the number of simultaneous connections the SMTP module can accept. If there are too many incoming connections open, the module will reject new connections, and sending mail systems will retry later.</p></li><li><p><code>Listener</code></p><p>This link allows you to tune the SMTP <a href="./../network/Listener.html">Listener</a>. You can specify which TCP ports to use for SMTP incoming connections (by default, the port 25 is used), which local IP addresses to use for incoming connections (all available addresses are used by default), and which remote addresses should be granted access to your CommuniGate Pro SMTP Server (by default, all addresses can connect to the SMTP port).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To allow Microsoft® Outlook Express 4.x users to submit messages using secure connections, you should configure the SMTP listener to accept connections on the TCP port 465, and enable the <code>SSL/TLS</code> option for that port.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Netscape® Messenger and modern versions of Microsoft Outlook and Outlook Express products do not need any special port for secure communications, since these products use the <code>STARTTLS</code> command to initiate secure communications after establishing a regular, clear text SMTP connection to the standard port number 25.</p></div></li></ul>',1)),e("form",c,[e("div",h,[e("table",m,[e("tbody",null,[t[23]||(t[23]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Processing")])],-1)),e("tr",v,[t[4]||(t[4]=e("td",{rowspan:"2"},"Advertise:",-1)),e("td",g,[n(a,null,{default:i(()=>t[0]||(t[0]=[o("AUTH")])),_:1}),t[1]||(t[1]=o(" to:"))]),t[5]||(t[5]=e("td",null,[e("select",{name:"AdvertizeAUTH"},[e("option",{value:"0"},"nobody"),e("option",{value:"1"},"non-clients"),e("option",{value:"2"},"clients"),e("option",{value:"3",selected:"selected"},"everybody")])],-1)),e("td",f,[n(a,null,{default:i(()=>t[2]||(t[2]=[o("8BITMIME")])),_:1}),t[3]||(t[3]=o(" to:"))]),t[6]||(t[6]=e("td",null,[e("select",{name:"Advertize8BIT"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"non-clients"),e("option",{value:"2"},"clients"),e("option",{value:"3"},"everybody")])],-1))]),e("tr",null,[e("td",y,[n(a,null,{default:i(()=>t[7]||(t[7]=[o("NO-SOLICITING")])),_:1}),t[8]||(t[8]=o(":"))]),t[9]||(t[9]=e("td",{colspan:"3"},[e("input",{name:"NoSolicit",value:"dom.spammer:ADLT,dom.listing:ADV",size:"40",maxlength:"1000",type:"text"})],-1))]),t[24]||(t[24]=e("tr",null,[e("td",{colspan:"6"},[e("hr")])],-1)),e("tr",null,[t[14]||(t[14]=e("td",null,"Verify:",-1)),e("td",T,[n(a,null,{default:i(()=>t[10]||(t[10]=[o("Return-Path")])),_:1}),t[11]||(t[11]=o(" for:"))]),t[15]||(t[15]=e("td",null,[e("select",{name:"VerifyReturnPath"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"non-clients"),e("option",{value:"2"},"clients"),e("option",{value:"3"},"everybody")])],-1)),e("td",b,[n(a,null,{default:i(()=>t[12]||(t[12]=[o("HELO")])),_:1}),t[13]||(t[13]=o(" for:"))]),t[16]||(t[16]=e("td",null,[e("select",{name:"VerifyHELO"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"non-clients"),e("option",{value:"2"},"clients"),e("option",{value:"3"},"everybody")])],-1))]),t[25]||(t[25]=e("tr",null,[e("td",null," "),e("td",{colspan:"2",align:"right"},"Check SPF records:"),e("td",null,[e("select",{name:"SPFMode"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Add Header"),e("option",{value:"2"},"Enabled"),e("option",{value:"3"},"with DMARC")])]),e("td",{align:"right"},"Reverse Connect:"),e("td",null,[e("select",{name:"ReverseCheck"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Add Header"),e("option",{value:"2"},"Enabled")])])],-1)),t[26]||(t[26]=e("tr",null,[e("td",{colspan:"6"},[e("hr")])],-1)),e("tr",null,[t[19]||(t[19]=e("td",null,"Require:",-1)),e("td",S,[n(a,null,{default:i(()=>t[17]||(t[17]=[o("STARTTLS")])),_:1}),t[18]||(t[18]=o(" for:"))]),t[20]||(t[20]=e("td",null,[e("select",{name:"ForceTLSforNonLocal"},[e("option",{value:"0",selected:"selected"},"nobody"),e("option",{value:"1"},"non-clients"),e("option",{value:"2"},"clients"),e("option",{value:"3"},"everybody")])],-1)),t[21]||(t[21]=e("td",{align:"right",nowrap:"nowrap"},null,-1)),t[22]||(t[22]=e("td",null,null,-1))])])])])]),t[38]||(t[38]=s('<ul><li><p><code>Advertise AUTH capability</code></p><p>If a server reports (in its initial <code>EHLO</code> prompt) that it supports SMTP Authentication, some mailer clients force users to authenticate themselves before sending messages. If you select the Non-Clients value, and a connection is accepted from an address included into the Client IP Addresses list, the SMTP module will not report that it supports the AUTH command. If the Nobody value is selected, the SMTP module never reports that it supports SMTP AUTH. This option does not disable the SMTP Authentication feature itself.</p></li><li><p><code>Advertise 8BITMIME</code></p><p>If your Server does not report the 8BITMIME capability, some mailers and servers will MIME-encode all non-ASCII messages that they send to your Server . This server-side encoding can cause troubles for many old mail clients. To avoid these troubles, your Server should report the 8BITMIME capability.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The CommuniGate Pro SMTP module itself never converts non-ASCII messages into the MIME form, and (according to RFC1652) it should not advertise the 8BITMIME capability. But the modern Internet is completely 8-bit transparent and clean, so it is safe to enable the Advertise 8BITMIME option, preventing other servers from doing unnecessary 8bit-to-MIME message body conversion.</p></div></li><li><p><code>Advertise NO-SOLICITING</code></p><p>Use this setting to specify the <em>Solicitation class keywords</em> your Server is not willing to accept. See the <a href="./../common/Features.html#SMTP">RFC3865</a> for more details.</p></li><li><p><code>Verify HELO</code></p><p>This option specifies if the parameters of HELO/EHLO commands should be verified.<br> You can tell the module to verify these addresses only for the connections from network addresses not included into the Client IP Addresses list. This is useful if:</p><ul><li>many of your clients use mailers that send bogus names in the <code>HELO/EHLO</code> commands;</li><li>your Internet connection is a dial-up one, and you do not want any outgoing (DNS) traffic to be generated when receiving mail from your own client computers (Client Hosts).</li></ul></li><li><p><code>Verify Return-Path</code></p><p>Return-Path E-mail addresses (sent using the <code>MAIL FROM</code> protocol commands) are processed with the <a href="./../sysadmin/Router.html">Router</a>. If the resulting address is routed to a remote host (a non-local domain name), this option specifies if the that domain name should be verified.<br> See the <a href="./../sysadmin/Protection.html#MailFrom">Protection</a> section for more details.</p></li><li><p><code>Check SPF records</code></p><p>This option tells the SMTP module to verify non-local Return-Path domain names using the SPF DNS records.</p><ul><li>If this option is set to Disabled, the SPF records are not used.</li><li>If this option is set to &quot;Add Header&quot;, the SPF records are checked,<br> and the <code>Received-SPF</code> header field with the SPF record processing result is added to all incoming messages.</li><li>If this option is set to Enabled, the SPF records are checked.<br> If these records say that messages with the specified Return-Path domain cannot be sent from the sender network (IP) address (the SPF records specify &quot;hard failure&quot; for that address), the Return-Path is rejected.<br> In other cases, the <code>Received-SPF</code> header field is added to the message.</li><li>If this option is set to &quot;with DMARC&quot;, the SPF records are checked, Return-Path and message body are accepted;<br> Then if the sender is not authenticated then domain in &#39;From:&#39; address from the message header is checked; if the domain does not exist (no A nor MX DNS records) the message body is rejected.<br> Then DMARC record for the domain is checked, if the record is not found then the record for the organizational domain is checked. If the DMARC policy is &quot;reject&quot; and SPF check result is not &quot;pass&quot; and the message has no DKIM signature which is valid and aligned to the domain, the message body is rejected.<br> In other cases, the <code>Received-SPF</code> header field is added to the message.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The SPF/DMARC records are not checked for SMTP connections from <a href="./../sysadmin/Protection.html#ClientFixed">Client</a> or <a href="./../sysadmin/Protection.html#WhiteHoles">White Hole</a> network addresses.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Verify Return-Path option is set to Nobody, this option is not used.</p></div></li><li><p><code>Reverse Connect</code></p><p>This option tells the SMTP module to verify non-local Return-Path addresses by connecting to the mail servers hosting those addresses and verifying that those servers accept the specified addresses.<br> If this option is set to Add Header, the addresses that cannot be verified are not rejected. Instead, the <code>X-Reverse-Check</code> header field containing the verification failure code is added to the message.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Reverse Connect processing is not used for incoming SMTP connections from <a href="./../sysadmin/Protection.html#ClientFixed">Client</a> or <a href="./../sysadmin/Protection.html#WhiteHoles">White Hole</a> network addresses.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Verify Return-Path option is set to Nobody, this option is not used.</p></div></li><li><p><code>Require STARTTLS</code></p><p>This option is applied to messages with Return-Path addresses not belonging to any Domain created on this Server. If the SMTP connection is established from the specified address (Client, non-Client, etc.) and the connection is not secured using SSL/TLS encryption, the Return-Path and the message itself is rejected.<br> For messages with Return-Path addresses belonging to some Domain created on this Server, this functionality is controlled using the <a href="./../objects/Domains.html#SMTPTLS">Domain Settings</a>.</p></li></ul><h3 id="AUTH" tabindex="-1">Sender Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;Sender Authentication {#AUTH}&quot;">​</a></h3><p>If a message sender (the message Return-Path specified with the MAIL FROM protocol command) is a local Object - an Account, or a Group, or a Mailing List in a local Domain, that Domain is opened, and its <a href="./../objects/Domains.html#SMTPAuth">SMTP Force AUTH</a> option is checked.</p><p>If this option is enabled, the message will be rejected if the client mailer has not sent the SMTP AUTH command first. The option value specifies for which sending mailer IP addresses this feature should be used.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This option checks for the &quot;fixed&quot; Client IP Addresses only - it does not pay attention to the &quot;temp-client&quot; addresses added with the <a href="./../sysadmin/Protection.html#Mobile">Process as a Client Address</a> feature.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Use this option carefully. Some users may use different mail relays to submit their messages with their CommuniGate Pro Account names as the message Return-Paths.</p></div><p>If this option is enabled and those messages are directed to your Server, they will be rejected, because mail relay servers are not able to authenticate the senders on your Server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Most mailers will send the AUTH command only when the server advertises its SMTP AUTH capability. Make sure that your server does advertise it (see <a href="#AdvAUTH">above</a>).</p></div><h3 id="Limits" tabindex="-1">Limits and Protection <a class="header-anchor" href="#Limits" aria-label="Permalink to &quot;Limits and Protection {#Limits}&quot;">​</a></h3>',9)),t[39]||(t[39]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Limits")])]),e("tr",null,[e("td",{colspan:"2",nowrap:"nowrap"},"Message Limits:"),e("td",{align:"right"},"Size:"),e("td",null,[e("select",{name:"InputSizeLimit"},[e("option",{value:"-1"},"Unlimited"),e("option",{value:"0"}," 0 Kbyte"),e("option",{value:"1024"}," 1 Kbyte"),e("option",{value:"3072"}," 3 Kbytes"),e("option",{value:"10240"}," 10 Kbytes"),e("option",{value:"30720"}," 30 Kbytes"),e("option",{value:"102400"},"100 Kbytes"),e("option",{value:"307200"},"300 Kbytes"),e("option",{value:"1048576"}," 1 Mbyte"),e("option",{value:"3145728"}," 3 Mbytes"),e("option",{value:"10485760",selected:"selected"}," 10 Mbytes"),e("option",{value:"31457280"}," 30 Mbytes"),e("option",{value:"104857600"},"100 Mbytes"),e("option",{value:"314572800"},"Other")])]),e("td",{align:"right"},"Recipients:"),e("td",null,[e("select",{name:"RecipientsLimit"},[e("option",{value:"0"},"unlimited"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"25",selected:"selected"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250"),e("option",{value:"1000"},"1000")])])]),e("tr",null,[e("td",{colspan:"6"},[e("hr")])]),e("tr",null,[e("td",{colspan:"2",rowspan:"3",valign:"top"},"Non-Client Sender:"),e("td",{align:"right"},"Recipients:"),e("td",null,[e("select",{name:"RCPTFlowLimit"},[e("option",{value:"0"},"Unlimited"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"11"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"in:"),e("td",null,[e("select",{name:"RCPTFlowPeriod"},[e("option",{value:"5"},"5 seconds"),e("option",{value:"7"},"7 seconds"),e("option",{value:"10"},"10 seconds"),e("option",{value:"15"},"15 seconds"),e("option",{value:"30",selected:"selected"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours"),e("option",{value:"86400"},"day"),e("option",{value:"172800"},"2 days"),e("option",{value:"259200"},"3 days"),e("option",{value:"345600"},"4 days"),e("option",{value:"432000"},"5 days"),e("option",{value:"604800"},"week")])])]),e("tr",null,[e("td",{align:"right"},"Delay Prompt for:"),e("td",null,[e("select",{name:"DelayPrompt"},[e("option",{value:"0"},"0 seconds"),e("option",{value:"1"},"1 second"),e("option",{value:"2"},"2 second"),e("option",{value:"3"},"3 second"),e("option",{value:"5"},"5 seconds"),e("option",{value:"7"},"7 seconds"),e("option",{value:"10"},"10 seconds"),e("option",{value:"15"},"15 seconds"),e("option",{value:"30",selected:"selected"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes")])]),e("td",{align:"right"}," "),e("td",null," ")]),e("tr",null,[e("td",{align:"right"},"Disconnect after:"),e("td",null,[e("select",{name:"ProtocolErrorLimit"},[e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"20",selected:"selected"},"20"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250"),e("option",{value:"1000"},"1000"),e("option",{value:"6"},"other")]),o(" errors and")]),e("td",{align:"right",nowrap:"nowrap"},"Deny Access for:"),e("td",null,[e("select",{name:"TempDenyTime"},[e("option",{value:"0"},"disabled"),e("option",{value:"15"},"15 seconds"),e("option",{value:"30"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900",selected:"selected"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours"),e("option",{value:"86400"},"day"),e("option",{value:"172800"},"2 days"),e("option",{value:"259200"},"3 days"),e("option",{value:"345600"},"4 days"),e("option",{value:"432000"},"5 days"),e("option",{value:"604800"},"week")])])])])])])],-1)),t[40]||(t[40]=s('<ul><li><p><code>Message Size Limit</code></p><p>This setting tells the module to reject all incoming messages that are larger than the specified limit.</p></li><li><p><code>Message Recipients Limit</code></p><p>This setting limits the number of recipients for each incoming message. Specifying a lower value makes your server less attractive for spammers.</p></li><li><p><code>Non-Client Sender: Limits</code></p><p>Use this option to specify a time period and the limit on the number of message recipients. For each non-client IP address the SMTP module counts all messages coming from that IP address, and all recipients specified for those messages. If the total number of all recipients specified during the set time period exceeds the set limit, new recipients are rejected with a temporary code, forcing the sending server to retry sending messages to those recipients later.<br> If a sender has completed a successful SMTP AUTH operation that allows the sender to relay via the CommuniGate Pro server, the recipients sent via that connection are not counted.<br> This setting can be used to protect your Server from spammers that send one message or a batch of messages to a large number of users of your system. On the other hand, if a large number of your users is subscribed to some mailing list, this option can cause delays for messages coming from that list.</p></li><li><p><code>Non-Client Sender: Delay Prompt</code></p><p>Use this option to specify the delay time between the moment when an SMTP connection is accepted from a non-client address and the moment when the Server responds with an initial prompt. This delay can be used to force spam-sending programs to disconnect from your Server. Normal servers should still be able to transfer mail, as the RFC2821 standard requires them to wait 5 minutes for the initial prompt, and most servers do wait at least 3 minutes.<br> When this setting has a non-zero value, the Server checks if any data line has been received from the sender before the initial SMTP prompt is sent. If the sender has sent some data without waiting for an initial Server prompt, an error message is returned to the sender and the connection is closed.<br> The Prompt Delay is introduced only for connection made to the port 25.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you start to use long Prompt Delays, expect to see your Server using much more SMTP Input channels, as each SMTP transaction becomes longer.</p></div></li><li><p><code>Non-Client Sender: Disconnect</code></p><p>Use this option to specify how many protocol errors the SMTP module should detect before it drops the connection with the sender. This feature protects your Server from spammers that try various E-mail addresses (dictionary attack), causing &quot;unknown account&quot; errors.<br> The SMTP module places the network addresses of disconnected senders into the <a href="./../sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> list. The SMTP module rejects new connections from the Temporarily Blocked Addresses.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The module does not block a &quot;failed sender&quot; network address if that address is a <a href="./../sysadmin/Protection.html#ClientFixed">Client IP Address</a> (specified explicitly or via DNS) or if that address is a <a href="./../sysadmin/Protection.html#WhiteHoles">White Hole Address</a>.</p></div></li></ul><p>When an incoming recipient address (<code>RCPT TO</code>) command addresses a local Account, the Account <a href="./../objects/Domains.html#VerifyStatus">Domain settings</a> can instruct the SMTP Module to check the current status of that Account.<br> If E-mail to the Account can not be delivered immediately (Account is over quota, etc.), the recipient address is rejected with a &quot;temporary failure&quot; (4xx) response code.</p><h3 id="Wakeup" tabindex="-1">Waking up the Backup Server <a class="header-anchor" href="#Wakeup" aria-label="Permalink to &quot;Waking up the Backup Server {#Wakeup}&quot;">​</a></h3><p>If your Server has a dial-up link, its domain name should have at least one additional DNS MX record, specifying a &quot;back-up&quot; mail server (usually, your ISP mail server). When your Server is off-line, all messages directed to your domain(s) are sent to that back-up mail server.</p><p>The back-up mail server tries to deliver collected messages to your server. Usually, the retry period is 30 minutes, so your system should stay on-line for at least that period of time in order to receive messages from the back-up server.</p><p>To avoid this delay, the SMTP module can be configured to send the Remote Queue Starting (&quot;ETRN&quot;) command to the back-up server. When the back-up server receives that command, it immediately starts to send the collected messages to your Server.</p>',6)),t[41]||(t[41]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Retrieving from a Backup Server")])]),e("tr",null,[e("td",null,[e("input",{type:"checkbox",name:"SendWakeups",value:"1"})]),e("td",{nowrap:"nowrap"},"Send Wakeups"),e("td",{align:"right"},"Every:"),e("td",null,[e("select",{name:"WakeupInterval"},[e("option",{value:"60",selected:"selected"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours"),e("option",{value:"86400"},"day"),e("option",{value:"172800"},"2 days"),e("option",{value:"259200"},"3 days"),e("option",{value:"604800"},"week")])]),e("td",{align:"right"},"to:"),e("td",null,[e("input",{type:"text",name:"BackupServer",value:"mail.provider.dom",size:"20",maxlength:"254"})])]),e("tr",null,[e("td",null," "),e("td",{nowrap:"nowrap"},[e("input",{type:"checkbox",name:"UseATRN",value:"1",checked:"checked"}),o("Use ATRN")]),e("td",{align:"right"},"AUTH Name:"),e("td",null,[e("input",{type:"text",name:"ATRNLoginName",value:"my.login.name",size:"20",maxlength:"99"})]),e("td",{align:"right"},"Password:"),e("td",null,[e("input",{type:"password",name:"ATRNPassword",value:"abcd",size:"20",maxlength:"99"})])])])])])],-1)),t[42]||(t[42]=s('<ul><li><p><code>Send Wakeups</code></p><p>Use these settings to specify the address of the Back-up Server, and to specify how often the Remote Queue Starting command should be sent.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The name of the back-up server should be the name of the real computer (as specified in an A-type DNS record), not a mail domain name. While your provider domain name can be <code>provider.com</code>, the name of the provider mail server can be something like <code>mail.provider.com</code>. Consult with your provider to get the exact name of your back-up server, or just examine the DNS MX records for your domain: your back-up server is specified with the MX record that has the priority next to your own Server MX Record priority.</p></div><p>The SMTP module wake-up activity is limited with the <a href="./Dialup.html#Schedule">TCP Activity Schedule</a>.</p><h3 id="ATRNWakeup" tabindex="-1">On-demand Mail Relaying (ATRN) <a class="header-anchor" href="#ATRNWakeup" aria-label="Permalink to &quot;On-demand Mail Relaying (ATRN) {#ATRNWakeup}&quot;">​</a></h3><p>The <code>ETRN</code> command can be used to release your domain queue on a remote backup server only if your server has a static IP address.</p><p>If your server has a dynamic IP address, the <code>ETRN</code> method does not work, since the backup server does not know the IP address your server is using, and the backup server is not able to open a connection to your server.</p><p>If your server uses a dynamic IP address, it should use the On-demand Mail Relaying method to retrieve mail from the backup server.</p><p>When On-demand Mail Relaying method is used, your server connects to the backup server, authenticates itself, and then it issues the <code>ATRN</code> command. Then the servers exchange their roles and the backup server starts to send your server your domain mail via the same channel. This eliminates a need for the backup server to open a connection to your server.</p><p>Since the backup server does not open a connection itself, it has to verify that the server that sends the ATRN command and wants to retrieve your domain mail is really your server. Your server should provide some name and password that should be accepted by the remote server and that should allow your server to issue the ATRN command.</p><p>Consult the remote server administrator to learn the name and the password your server should send before sending the ATRN command.</p><ul><li><p><code>Use ATRN</code></p><p>select this option to use the ATRN (On-demand Mail Relaying) method instead of the ETRN method.</p></li><li><p><code>AUTH Name</code> and <code>Password</code></p><p>this pair of strings is sent to the remote server using the AUTH command. The access rights granted to this login name on the remote server should allow your server to use the ATRN command.</p></li></ul><p>The CommuniGate Pro SMTP module uses the AUTH CRAM-MD5 authentication method to send passwords in an encrypted form. If the remote server does not support the CRAM-MD5 method, the clear-text AUTH LOGIN method is used.</p><p>If your backup server does not support On-demand Mail Relaying, you should use the Unified Domain-Wide Account method implemented with the <a href="./RPOP.html">RPOP</a> module.</p><p>The RFC2645 suggests to use the special TCP port number 366 to provide the ATRN services. If your backup mail server provides the ATRN services on that port (or on any port other that the standard SMTP port 25), you should specify the port number in the Send Wakeups To setting field. Use the colon symbol to separate the server name and the port number:<br><code>mail.provider.dom:366</code></p><p>You can use secure communications with the backup server if you include the backup server name into the <a href="#Secure">Send Encrypted</a> list.</p><p>When the backup server name is specified, the SMTP Settings page displays the Wake Up Now button. Click that button to initiate a wakeup session immediately.</p><h3 id="LMTP" tabindex="-1">LMTP Support <a class="header-anchor" href="#LMTP" aria-label="Permalink to &quot;LMTP Support {#LMTP}&quot;">​</a></h3><p>The SMTP module implements the LMTP protocol. It supports this protocol on all its ports, and it is not required to configure additional ports just to support LMTP.</p><p>The SMTP module switches to the LMTP mode when it receives the <code>LHLO</code> LMTP command.</p><h2 id="Dialup" tabindex="-1">Serving Dial-up Client Hosts <a class="header-anchor" href="#Dialup" aria-label="Permalink to &quot;Serving Dial-up Client Hosts {#Dialup}&quot;">​</a></h2><p>The CommuniGate Pro Server can be used as a back-up mail server for dial-up systems. Dial-up systems receiving mail via SMTP expect their back-up servers to receive and keep all their messages when these systems are off-line. When a dial-up system connects to the Internet again, it connects to its back-up mail server and either issues the special Remote Queue Starting command (ETRN, RFC1985), or sends a dummy E-mail message to a special address on the back-up server.</p><h3 id="ETRN" tabindex="-1">Remote Queue Starting (ETRN) <a class="header-anchor" href="#ETRN" aria-label="Permalink to &quot;Remote Queue Starting (ETRN) {#ETRN}&quot;">​</a></h3><p>When your server receives the ETRN command, it tries to send out all messages collected for the host specified as the ETRN command parameter. This method allows a dial-up system to get its messages immediately, instead of waiting for your server to make the next attempt to deliver the collected messages.</p><p>The SMTP module supports the ETRN command, so CommuniGate Pro can be used as a back-up mail server. No special setting is required, since this feature is always enabled.</p><p>The SMTP module uses the <a href="./../sysadmin/Router.html">Router</a> to process the ETRN parameter (domain name). It adds the <code>wakeup</code> fictitious user name to that domain to get a regular E-mail address <code>wakeup@etrn-parameter</code> and runs it through the Router. If the address is routed to an SMTP host, the SMTP module releases (wakes up) that host queue.</p><p>If you have routed the domain <code>client.com</code> to <code>mail.client.com</code> in your Router Table, all mail to the client.com domain will be kept in the mail.client.com queue. Since the ETRN command parameter is processed with the Router, too, the <code>ETRN client.com</code> command will correctly release the mail.client.com queue.</p><p>In a <a href="./../cluster/">Dynamic Cluster</a> environment, the ETRN command received by any cluster member releases domain queues on all cluster members.</p><h3 id="ATRN" tabindex="-1">On-Demand Mail Relaying (ATRN/TURN) <a class="header-anchor" href="#ATRN" aria-label="Permalink to &quot;On-Demand Mail Relaying (ATRN/TURN) {#ATRN}&quot;">​</a></h3><p>When the SMTP module receives the <code>ATRN</code> command, it checks that the connected party has authenticated itself. Then the module releases the specified domain queue and sends all its messages directly via this (already established) connection. No special settings is required to enable the ATRN feature of the CommuniGate Pro SMTP module. There are some notes about the ATRN implementation:</p><ul><li>Only one ATRN command parameter is allowed.</li><li>The name of the domain queue to be released should match the name of the authenticated user. If you want to allow a dial-up client host to release the <code>domain.dom</code> queue, you should create the <code>domain.dom</code> Account in the CommuniGate Pro Main Domain, and the client host should authenticate itself using the domain.dom as the login name and the domain.dom Account password as the password.</li><li>If the ATRN command does not have a parameter, the name of the authenticated user is used as the name of the queue to be released.</li><li>The domain name used in the ATRN command must be included into the <code>Hold Mail for Domains</code> list.</li></ul><p>The <code>ATRN</code> command parameter (if any) is processed in the same way the <a href="#ETRN"><code>ETRN</code></a> command parameter is processed.</p><p>The RFC2645 suggests to use the special TCP port number 366 to provide the ATRN services. CommuniGate Pro SMTP module provides the ATRN services on all ports its <a href="./../network/Listener.html">Listener</a> is using. To comply with the RFC2645 standard, you may want to add the port 366 to the SMTP Listener settings.</p><p>For compatibility with legacy Microsoft Exchange servers, the <code>TURN</code> SMTP command is supported, too. It is processed in the same way as the ATRN command without a parameter, and it requires authentication, too. The name of the queue to release is the same as the name of the authenticated user.</p><h3 id="WakeupMail" tabindex="-1">Waking up via E-mail <a class="header-anchor" href="#WakeupMail" aria-label="Permalink to &quot;Waking up via E-mail {#WakeupMail}&quot;">​</a></h3><p>The SMTP module supports an alternative wakeup method: a dial-up system can send any message to <code>domainName-wakeup@serverDomain</code> to release the domainName message queue. The serverDomain name should be the Main Domain name of the CommuniGate Pro Server.</p><p>In a <a href="./../cluster/">Dynamic Cluster</a> environment, the Wakeup E-mail received by any cluster member releases domain queues on all cluster members.</p><h3 id="Hold" tabindex="-1">Holding Mail in Queue <a class="header-anchor" href="#Hold" aria-label="Permalink to &quot;Holding Mail in Queue {#Hold}&quot;">​</a></h3><p>You can ask the SMTP module to hold mail for certain hosts in its queue, and not to try to deliver that mail until the receiving server issues the ETRN command or sends a wake-up E-mail. This can be useful if the receiving server is on a symmetric dial-on-demand line and its provider brings the link up automatically when there is any traffic for that receiving server.</p><h2 id="Relay" tabindex="-1">Message Relaying <a class="header-anchor" href="#Relay" aria-label="Permalink to &quot;Message Relaying {#Relay}&quot;">​</a></h2><p>The situation when the SMTP module receives a message from a remote system and then sends that message to some other host is called <em>relaying</em>.</p><p>To avoid Server abuse, some relay restrictions can be specified.</p>',41)),t[43]||(t[43]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Relay")])]),e("tr",null,[e("td",{nowrap:"nowrap",width:"30%"},"Relay to any IP Address:"),e("td",{nowrap:"nowrap",align:"right"},"If Received from:"),e("td",null,[e("select",{name:"RelayToStrangers"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"clients"),e("option",{value:"0"},"anybody")]),o(" IP Address")])]),e("tr",null,[e("td",{nowrap:"nowrap",width:"30%"},"Relay to Client IP Addresses:"),e("td",{nowrap:"nowrap",align:"right"},"If Sent to:"),e("td",{nowrap:"nowrap"},[e("select",{name:"RelayToClients"},[e("option",{value:"0"},"any"),e("option",{value:"1",selected:"selected"},"simple"),e("option",{value:"2"},"no")]),o(" E-mail Address")])]),e("tr",null,[e("td",{nowrap:"nowrap",width:"30%"},"Relay to Hosts We Backup:"),e("td",{nowrap:"nowrap",align:"right"}),e("td",null,[e("select",{name:"RelayToBackedUp"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])])])])])])],-1)),t[44]||(t[44]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"ETRN/ATRN Processing")])]),e("tr",{valign:"top"},[e("td",{nowrap:"nowrap",align:"right"},"Accept Wakeups from:"),e("td",null,[e("select",{name:"ReleaseQueues"},[e("option",{value:"0"},"nobody"),e("option",{value:"1",selected:"selected"},"clients"),e("option",{value:"2"},"anybody")])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Hold Mail for Domains:"),e("td",null,[e("textarea",{name:"HoldHosts",rows:"3",cols:"50"},"client1.com, client2.com, client3.com, client4.com, *.client4.com")])])])])])],-1)),t[45]||(t[45]=s(`<ul><li><p><code>Relay to any IP Address</code></p><p>See the <a href="./../sysadmin/Protection.html#Relay">Protection</a> chapter for the information about this setting. If the Nobody option is selected, relaying is still possible for authenticated users.</p></li><li><p><code>Relay to Client IP Addresses</code></p><p>See the <a href="./../sysadmin/Protection.html#Relay">Protection</a> chapter for the information about this setting.</p></li><li><p><code>Relay to Hosts We Backup</code></p><p>This option allows the SMTP module to relay messages to any domain, if the MX records for that domain includes this CommuniGate Pro Server name (its Main Domain name) as a back-up mail relay.</p></li><li><p><code>Accept Wakeups</code></p><p>This option tells the SMTP module to accept ETRN commands and wake-up E-mail messages either from anybody, or only from the hosts included into the Client IP Addresses list, or from no host at all.<br> Since the ATRN command, unlike ETRN, requires authentication, the ATRN command is always accepted from any address.</p></li><li><p><code>Hold Mail for Domains</code></p><p>When the SMTP module builds a queue for one of the domains (hosts) listed in this field, it immediately places that queue &quot;on hold&quot;, waiting for the ETRN/ATRN command or any other external action that releases that queue. This method should be used for the sites that receive mail via your server, and that want to receive it only when they issue the ETRN/ATRN command.<br> The specified names can contain a wildcard - the asterisk (<code>*</code>) symbol.</p></li></ul><h3 id="RelayIP" tabindex="-1">Relaying via Dedicated IP Addresses <a class="header-anchor" href="#RelayIP" aria-label="Permalink to &quot;Relaying via Dedicated IP Addresses {#RelayIP}&quot;">​</a></h3><p>You may want to send messages for some of your CommuniGate Pro Domains via Local IP Addresses assigned to those Domains. See the <a href="./../objects/Domains.html#RelayIP">Domain Settings</a> section for more details.</p><p>If a message is to be delivered to the <em>hostName</em> host via a particular <em>12.34.56.78</em> Local IP Address, the message is not placed into the <code>hostName</code> SMTP queue. Instead, the Server places it into the <code>@12.34.56.78|hostName</code> SMTP queue.</p><p>This technique allows the Server to process messages from different Domains independently. If the IP Address of one of your Domains is blacklisted by remote hosts (because that Domain users have abused the mail system), messages to the same remote hosts from other Domains will not be delayed or rejected.</p><p>If the <code>hostname</code> name is included into the <a href="#Hold">Hold Mail for Domains</a> list, the Server never adds the <code>@12.34.56.78|</code> prefix, so all messages to that host are always enqueued into a single queue, and that queue can be used with the ATRN command.</p><p>The ETRN command releases not only the <code>hostname</code> queue, but all <em>hostName</em> queues with preferred IP prefixes (<code>@12.34.56.78|hostName</code> queues).</p><h3 id="Submit" tabindex="-1">Processing the Submit Port <a class="header-anchor" href="#Submit" aria-label="Permalink to &quot;Processing the Submit Port {#Submit}&quot;">​</a></h3><p>You may want to enable SMTP receiving on the port 587. Sessions established to that port are processed differently:</p><ul><li>Connections are not rejected when the <a href="./../network/Listener.html#Reserve">Reserved for Clients</a> limit is reached.</li><li>The AUTH capabilities are always advertised.</li><li>Messages (the MAIL FROM commands) are accepted only after successful authentication.</li></ul><h2 id="BlackList" tabindex="-1">Processing Mail from Blacklisted Addresses <a class="header-anchor" href="#BlackList" aria-label="Permalink to &quot;Processing Mail from Blacklisted Addresses {#BlackList}&quot;">​</a></h2><p>When a <a href="./../sysadmin/Protection.html">Blacklisted</a> host connects to the SMTP module, the module does not reject a connection. Instead, it receives the <code>MAIL FROM</code> SMTP command, and starts to process the recipient (<code>RCPT TO</code>) addresses sent from the blacklisted host. The module adds the domain <code>blacklisted</code> to each recipient address received from a blacklisted host, i.e. the received address <code>user@domain</code> is converted into <code>user%domain@blacklisted</code>. Then the address is processed with the Router as usual. If the Router Table does not contain special rules for the <code>blacklisted</code> domain, the address is rejected with a special error code.</p><p>The default Router Table contains the following line:<br><code>&lt;blacklist-admin*@blacklisted&gt; = postmaster</code><br> All messages from blacklisted hosts sent to the <code>blacklist-admin</code> address in any domain, are routed to the postmaster, so these messages are accepted. This &quot;white hole&quot; feature allows the blacklisted host users to contact the postmaster on your server if they want to discuss the blacklisting issue. If you remove this line from the Router Table, no address will be accepted from blacklisted hosts.</p><p>When rejecting addresses sent from blacklisted hosts, the SMTP module verifies if the <code>blacklist-admin@blacklisted</code> address can be routed with the Router. If the Router Table contains such records (a default one or a different one), the error code sent back to the blacklisted host explains that mail to <code>blacklist-admin@serverdomain name</code> is accepted even from that blacklisted site.</p><p>If you want to provide a &quot;white hole&quot; feature, but you do not want the information about the white-hole address to be included into the error code, simply use a different name for the &quot;white hole&quot; address.</p><ul><li><p>Example:</p><p><code>&lt;abuse*@blacklisted&gt; = postmaster</code></p></li></ul><p>The following table contains samples of SMTP sessions established from a blacklisted host. The host commands are marked with <code>C:</code>, the SMTP module responses are marked with <code>S:</code>.</p><p>Router Table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span></span></span></code></pre></div><p>SMTP protocol:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C: MAIL FROM: user@host</span></span>
<span class="line"><span>S: 250 user@host sender accepted</span></span>
<span class="line"><span>C: RCPT TO: somebody@somehost</span></span>
<span class="line"><span>S: 591 Your host \\[10.1.1.1\\] is blacklisted. No mail will be accepted</span></span>
<span class="line"><span>C: RCPT TO: abuse@somehost</span></span>
<span class="line"><span>S: 591 Your host \\[10.1.1.1\\] is blacklisted. No mail will be accepted</span></span>
<span class="line"><span>C: RCPT TO: blacklist-admin@somehost</span></span>
<span class="line"><span>S: 591 Your host \\[10.1.1.1\\] is blacklisted. No mail will be accepted</span></span>
<span class="line"><span>....</span></span></code></pre></div><hr><p>Router Table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;abuse*@blacklisted&gt; = postmaster</span></span></code></pre></div><p>SMTP protocol:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C: MAIL FROM: user@host</span></span>
<span class="line"><span>S: 250 user@host sender accepted</span></span>
<span class="line"><span>C: RCPT TO: somebody@somehost</span></span>
<span class="line"><span>S: 591 Your host \\[10.1.1.1\\] is blacklisted. No mail will be accepted</span></span>
<span class="line"><span>C: RCPT TO: abuse@somehost</span></span>
<span class="line"><span>S: 250 abuse%somehost@blacklisted will leave Internet</span></span>
<span class="line"><span>C: RCPT TO: blacklist-admin@somehost</span></span>
<span class="line"><span>S: 591 Your host is blacklisted. No mail will be accepted</span></span>
<span class="line"><span>....</span></span></code></pre></div><hr><p>Router Table:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;blacklist-admin*@blacklisted&gt; = postmaster</span></span></code></pre></div><p>SMTP protocol:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C: MAIL FROM: user@host</span></span>
<span class="line"><span>S: 250 user@host sender accepted</span></span>
<span class="line"><span>C: RCPT TO: somebody@somehost</span></span>
<span class="line"><span>S: 591 Your host [10.1.1.1] is blacklisted. Send your questions to blacklist-admin@mycompany.com.</span></span>
<span class="line"><span>C: RCPT TO: abuse@somehost</span></span>
<span class="line"><span>S: 591 Your host [10.1.1.1] is blacklisted. Send your questions to blacklist-admin@mycompany.com.</span></span>
<span class="line"><span>C: RCPT TO: blacklist-admin@somehost</span></span>
<span class="line"><span>S: 250 blacklist-admin%somehost@blacklisted will leave Internet</span></span>
<span class="line"><span>....</span></span></code></pre></div><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>The SMTP module immediately (on the first <a href="./../sysadmin/Router.html">Router</a> call) accepts messages addressed to <code>domain name-wakeup</code> local addresses. When these messages are enqueued into the SMTP module queue, they are processed as <a href="#Dialup">wake-up requests</a> for the domain name domain message queue.</p><p>The SMTP module also immediately accepts all addresses with IP-address domains, i.e. with domain names like <code>[xx.yy.zz.tt]</code>. Please note that the <a href="./../sysadmin/Router.html">Router</a> adds brackets to the IP-address domain names that do not have them, and the Router changes the IP addresses of local domains to those domain names. The Router performs these operations before calling the modules.</p><p>The SMTP module immediately accepts addresses that have domain parts ending with the <code>._smtp</code> suffix. This suffix is processed in the same way as the <a href="./../sysadmin/Router.html#Via"><code>._via</code></a> suffix.</p><p>The SMTP module immediately accepts addresses that have domain parts ending with the <code>._smtpq</code> suffix. This suffix is processed in the same way as the <a href="./../sysadmin/Router.html#Via"><code>._relay</code></a> suffix.</p><p>On the final call, the SMTP module accepts mail to any domain if that domain name contains at least one dot (<code>.</code>) symbol. If the Forward option is selected, all these addresses are rerouted to the specified Forwarding Server domain.</p><p>Before accepting an address, the SMTP module checks if the address does not contain any <code>@</code> symbol, but contains one or several <code>%</code> symbols. In this case, the rightmost <code>%</code> symbol is changed to the <code>@</code> symbol.</p><h2 id="SendPort" tabindex="-1">Sending to Non-Standard Ports <a class="header-anchor" href="#SendPort" aria-label="Permalink to &quot;Sending to Non-Standard Ports {#SendPort}&quot;">​</a></h2><p>Some mail servers can be configured to receive incoming SMTP mail on a non-standard port. The CommuniGate Pro SMTP module can send messages to those servers, if the domain part of an E-mail address contains the port number or is routed to an address that includes the port number.</p><p>Use the <a href="./../sysadmin/Router.html#Via"><code>._relay</code></a> or <a href="./../sysadmin/Router.html#Via"><code>._via</code></a> suffix with the port number: <code>domain.port._relay</code>. The SMTP module will not use the <em>domain</em> MX records in this case, it will try to resolve the <em>domain</em> name directly into an IP address. Sample Router record:<br><code>secret.communigatepro.ru = mail.communigatepro.ru.26._relay</code></p><h2 id="Monitoring" tabindex="-1">Monitoring SMTP Activity <a class="header-anchor" href="#Monitoring" aria-label="Permalink to &quot;Monitoring SMTP Activity {#Monitoring}&quot;">​</a></h2><p>The Monitors realm of the <a href="./../sysadmin/">WebAdmin Interface</a> allows Server Administrators to monitor the SMTP module activity. The SMTP Monitor section contains three pages - the Delivery (sending) page, the Waiting page, and the Receiving page.</p><p>The Delivery page displays the active outgoing SMTP connections:</p>`,44)),t[46]||(t[46]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"ID"),e("th",null,"Target"),e("th",null,"Messages"),e("th",null,"Status"),e("th",null,"Running"),e("th",null,"Message"),e("th",null,"Size"),e("th",null,"Return-Path")]),e("tr",null,[e("td",null,"158996"),e("td",{nowrap:"nowrap"},[e("a",{href:"#HostQueue"},"domain1.dom")]),e("td",null,"1"),e("td",{nowrap:"nowrap"},"opening connection"),e("td",null,"8sec"),e("td",null,[e("a",{href:"Transfer.html"},"23458798")]),e("td"),e("td",{nowrap:"nowrap"})]),e("tr",null,[e("td",null,"158997"),e("td",{nowrap:"nowrap"},[e("a",{href:"#HostQueue"},"domain2.dom")]),e("td",null,"2"),e("td",{nowrap:"nowrap"},"opening connection"),e("td",null,"2sec"),e("td",null,[e("a",{href:"Transfer.html"},"58798234")]),e("td"),e("td",{nowrap:"nowrap"})])])])])],-1)),t[47]||(t[47]=s("<ul><li><p><code>ID</code></p><p>This field contains the numeric ID of the outgoing SMTP session. In the CommuniGate Pro Log, this session records are marked with the <code>SMTP-nnnnn</code> flag, where <em>nnnnn</em> is the session ID.</p></li><li><p><code>Target</code></p><p>This field contains the target Queue name (which normally matches the destination hostname).</p></li><li><p><code>Messages</code></p><p>This field contains the number of messages in the destination Queue.</p></li><li><p><code>Status</code></p><p>This field contains the operation in progress.</p></li><li><p><code>Running</code></p><p>If there is an SMTP operation in progress, this field contains the time since operation started.</p></li><li><p><code>Message, Size, Return-Path</code></p><p>If there is a message being sent to the destination host, these fields contain its ID, size and Return-Path, respectively.</p></li></ul><p>The Receiving page displays the incoming SMTP connections:</p>",2)),t[48]||(t[48]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"ID"),e("th",null,"Source"),e("th",null,"Account"),e("th",null,"Status"),e("th",null,"Running"),e("th",null,"Size"),e("th",null,"Return-Path"),e("th",null,"Recipient")]),e("tr",{bgcolor:"#EEFFEE"},[e("td",null,"151"),e("td",{nowrap:"nowrap"},"[192.168.0.104]:58312"),e("td",null,"user1@domain1.dom"),e("td",{nowrap:"nowrap"},"reading recipients"),e("td"),e("td",null,"28798"),e("td",null,"user1@domain1.dom"),e("td",{nowrap:"nowrap"},"user2@domain1.dom")]),e("tr",null,[e("td",null,"152"),e("td",{nowrap:"nowrap"},"[10.0.0.104]:47531 (TLS)"),e("td"),e("td",{nowrap:"nowrap"},"checking return-path"),e("td",null,"2sec"),e("td"),e("td",null,"xfs@company.com"),e("td",{nowrap:"nowrap"})])])])])],-1)),t[49]||(t[49]=s('<ul><li><p><code>ID</code></p><p>This field contains the numeric ID of the incoming SMTP session. In the CommuniGate Pro Log, this session records are marked with the <code>SMTPI-nnnnn</code> flag, where <em>nnnnn</em> is the session ID.</p></li><li><p><code>Source</code></p><p>This field contains the IP address the sender has connected from.<br> The <code>(TLS)</code> mark indicates that the SSL/TLS encryption is being used.</p></li><li><p><code>Account</code></p><p>This field contains the name of the client Account, if the sender had authenticated.</p></li><li><p><code>Status</code></p><p>This field contains the operation in progress.</p></li><li><p><code>Running</code></p><p>If there is an SMTP operation in progress, this field contains the time since operation started.</p></li><li><p><code>Size, Return-Path, Recipient</code></p><p>If there is a message being received, these fields contain its size, Return-Path or a recipient address, respectively.</p></li></ul><p>If the sender had connected to port 587 (SMTP Submit), the connection row is displayed with a green background.</p><p>SMTP activity can be monitored using the CommuniGate Pro <a href="./../sysadmin/Statistics.html">Statistic Elements</a>.</p>',3))])}const N=l(u,[["render",P]]);export{C as __pageData,N as default};
