import{_ as o,a as i,b as n,c as r}from"./chunks/AttachedFile.DwTXXnDs.js";import{_ as l,c as d,o as u,ag as t,j as e,a as s}from"./chunks/framework.jCcxW76o.js";const T=JSON.parse('{"title":"E-Mail Transfer","description":"","frontmatter":{"legacyLink":"Transfer.html"},"headers":[],"relativePath":"admin/mail/index.md","filePath":"admin/mail/index.md"}'),h={name:"admin/mail/index.md"};function c(p,a,m,g,f,v){return u(),d("div",null,a[0]||(a[0]=[t('<h1 id="e-mail-transfer" tabindex="-1">E-Mail Transfer <a class="header-anchor" href="#e-mail-transfer" aria-label="Permalink to &quot;E-Mail Transfer&quot;">​</a></h1><p>One of the main functions of the CommuniGate Pro Server is E-mail Message transfer. Acting as an MTA (Mail Transfer Agent), the Server accepts messages from various sources (modules, internal components, etc.), and delivers (transfers) them to remote or local destinations using the same or different modules.</p><p>While all submitted messages are stored as individual files in the <code>Queue</code> directory inside the CommuniGate Pro &quot;base directory&quot;, each message can be enqueued into several different queues (if it has several recipients). Each communication Module can maintain one or several logical queues. For example, the SMTP Module maintains one queue for each Internet domain.</p><h2 id="Sources" tabindex="-1">E-mail Sources and Destinations <a class="header-anchor" href="#Sources" aria-label="Permalink to &quot;E-mail Sources and Destinations {#Sources}&quot;">​</a></h2><p>The CommuniGate Pro Server has the following set of message sources:</p><ul><li>The <a href="./SMTP.html">SMTP</a> Module submits messages received from mailer applications and from other mail servers via the Internet. The Submit Address tag used: <code>SMTP</code>.</li><li>The <a href="./RPOP.html">RPOP</a> Module submits messages retrieved from remote POP servers. The Submit Address tag used: <code>RPOP</code>.</li><li>The <a href="./Local.html">Local Delivery</a> Module submits messages generated with the Account-level (Account and Domain) <a href="./QueueRules.html">Automated Mail Processing Rules</a>. The Submit Address tag used: <code>RULE</code>.</li><li>The <a href="./Local.html">Local Delivery</a> Module re-submits messages directed to &#39;all&#39; addresses and redirected to all Forwarders in the specified Domain. The Submit Address tag used: <code>ALLF</code>.</li><li>The <a href="./PIPE.html">PIPE</a> Module submits messages received from external applications via interprocess communication channels, and the messages generated and stored in the special <code>Submitted</code> directory. The Submit Address tag used: <code>PIPE</code>.</li><li>The <a href="./../access/POP.html">POP</a> Module submits messages received from certain mailer applications employing the XTND XMIT protocol extension. The Submit Address tag used: <code>POP</code>.</li><li>The <a href="./../access/IMAP.html">IMAP</a> Module submits messages received from <a href="./../access/MAPI.html">MAPI</a> client applications. The Submit Address tag used: <code>IMAP</code>.</li><li>The <a href="./../access/WebUser.html">WebUser Interface</a> Module submits messages composed within Web browsers. The Submit Address tag used: <code>HTTP</code>.</li><li>The <a href="./../access/XIMSS.html">XIMSS</a> Module submits messages composed within XIMSS clients. The Submit Address tag used: <code>XIMSS</code>.</li><li>The <a href="./../../development/PBXApp.html">Real-Time Applications</a> submit messages such as incoming voicemails. The Submit Address tag used: <code>PBX</code>.</li><li>The <a href="#Enqueue">Enqueuer</a> component submits messages generated with the Server-wide and Cluster-wide <a href="./QueueRules.html">Automated Mail Processing Rules</a>. The Submit Address tag used: <code>SRULE</code>.</li><li>The <a href="#Dequeue">Dequeuer</a> component generates and submits delivery notification messages. The Submit Address tag used: <code>DSN</code>.</li><li>The <a href="./../access/WebUser.html">WebUser Interface</a> and <a href="./../access/XIMSS.html">XIMSS</a> modules generate and submit Message Disposition Notification (&quot;Read Receipts&quot;) messages. The Submit Address tag used: <code>MDN</code>.</li><li>The <a href="./WebCalendar.html">Calendaring</a> component generates and submits Event Request Reply messages. The Submit Address tag used: <code>ICAL</code>.</li><li>The <a href="./LIST.html">LIST</a> Module submits messages to be distributed to mailing list subscribers. The Submit Address tag used: <code>LIST</code>.</li><li>The <a href="./LIST.html">LIST</a> Module submits reply messages generated when processing administration requests. The Submit Address tag used: <code>LSRV</code>.</li><li>The <a href="./LIST.html">LIST</a> Module submits messages directed to individual subscribers (Warnings, Hello, Bye, etc.) The Submit Address tag used: <code>LSTM</code>.</li><li>The <a href="./LIST.html">LIST</a> Module submits messages directed to the list owner. The Submit Address tag used: <code>LSTO</code>.</li><li>The <a href="./LIST.html">LIST</a> Module re-submits messages directed a <a href="./../objects/Groups.html">Group</a>. The Submit Address tag used: <code>GROUP</code>.</li><li>The <a href="./../sysadmin/Statistics.html#Handlers">Triggers</a> component generates and submits notification messages. The Submit Address tag used: <code>EVENT</code>.</li><li>The <a href="./../sysadmin/Intercept.html">Lawful Interception</a> component generates and submits report messages. The Submit Address tag used: <code>LWIT</code>.</li></ul><p>The CommuniGate Pro Server transfers messages to the following destinations:</p><ul><li>the <a href="./SMTP.html">SMTP Module</a> transfers messages to other SMTP mail servers via the Internet;</li><li>the <a href="./LIST.html">LIST Module</a> accepts and processes messages with mailing list postings, and with various list administration requests;</li><li>the <a href="./Local.html">Local Delivery Module</a> transfers messages to local user mailboxes;</li><li>the <a href="./PIPE.html">PIPE Module</a> transfers messages to external applications via interprocess communication channels;</li><li>the Queue Component itself transfers (discards) messages routed to NULL or ERROR addresses;</li></ul><p>The following diagram illustrates the message flow inside the CommuniGate Pro Server:</p><p><img src="'+r+'" alt="Transfer Scheme"></p><h2 id="Submit" tabindex="-1">Submitting Messages <a class="header-anchor" href="#Submit" aria-label="Permalink to &quot;Submitting Messages {#Submit}&quot;">​</a></h2><p>All messages are created as temporary files. They are stored in the <code>Queue</code> directory as files with the <code>.tmp</code> extension. A Module or an internal component stores the message envelope and the message itself in such a file and then submits it to the Enqueuer component for processing.</p><p>The message envelope is a set of text lines. Each line specifies either the message return-path, or one message recipient address, or message delivery options.</p><p>If a Module fails to compose a message (for example, an SMTP connection breaks during message transfer), the Module discards of the temporary file.</p><p>When a message is completely composed and submitted to the Enqueuer, the file extension is changed to <code>.msg</code> and the message is scheduled for processing.</p><p>When the Server restarts, the Enqueuer component finds all files with the <code>.msg</code> extension stored in the <code>Queue</code> directory and resubmits them for processing.</p><p>Open the General pages in the Settings realm of the CommuniGate Pro WebAdmin Interface, and find the Temp File Manager panel panel on the Others page:</p>',17),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Temp File Manager")])]),e("tr",null,[e("td",{align:"right"},"Log Level:"),e("td",null,[e("select",{name:"TempFilesLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1",selected:"selected"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])])]),e("tr",null,[e("td",{align:"right"},"Recycle Temp Files:"),e("td",{nowrap:"nowrap"},[e("select",{name:"TempFilesReuse"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])])])])])])],-1),t('<ul><li><p><code>Log</code></p><p>This setting specifies what kind of information the Temporary Files manager should put in the Server Log. Usually you should use the <code>Failures</code> (file system error reports) level. But when you experience a problem with some Module submitting messages, you may want to set this setting to <code>Low-Level</code> or <code>All Info</code>: in this case file i/o operations will be recorded in the System Log as well. When the problem is solved, set the TempFiler Log setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The Temporary Files manager Log records are marked with the <code>TEMPFILE</code> tag.</p></li><li><p><code>Recycle Temp Files</code></p><p>Enable this option to improve performance of your system under heavy load: discarded temporary file are not deleted, and they are reused.</p></li></ul><h2 id="Foldering" tabindex="-1">Queue Limits and Foldering <a class="header-anchor" href="#Foldering" aria-label="Permalink to &quot;Queue Limits and Foldering {#Foldering}&quot;">​</a></h2><p>If a Server is heavily loaded, it can contain thousands of message files in its Queue directory. Many operating and file systems cannot efficiently process large directories. You may want to split the Queue directory into several subdirectories, each containing a portion of Temporary and Queue files.</p><p>You may want to limit the total number of messages in the CommuniGate Pro Queue. When this number is reached, the modules reject attempts to submit new messages.</p><p>Use the WebAdmin Interface to specify the Queue processing options. Open the Mail pages in the Settings realm, then open the Queue page:</p>',5),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Message Queue")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap",width:"25%"},"Log Level:"),e("td",null,[e("select",{name:"QueueLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",nowrap:"nowrap",width:"25%"}," "),e("td",null," ")]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Queue Size Limit:"),e("td",null,[e("select",{name:"QueueLimit"},[e("option",{value:"-1",selected:"selected"},"Unlimited"),e("option",{value:"0"},"0"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000")])]),e("td",{align:"right",nowrap:"nowrap"},"Queue Foldering:"),e("td",null,[e("select",{name:"QueueFoldering"},[e("option",{value:"-1",selected:"selected"},"Auto"),e("option",{value:"0"},"0"),e("option",{value:"10"},"10"),e("option",{value:"100"},"100")])])])])])])],-1),t('<ul><li><p><code>Queue Limit</code></p><p>If you specify a limit with this option, the CommuniGate Pro modules (SMTP, PIPE, RPOP, MAPI, WebUser) will stop accepting new messages when the number of messages in the Queue exceeds the specified limit.</p></li><li><p><code>Queue Foldering</code></p><p>This setting specifies where the CommuniGate Pro Server will create new Temporary files, and, as a result, how the message files will be stored in the Queue Directory.<br> If you select the 0 (zero) value, no subdirectory will be created in the Queue directory, and all Temporary files will be created directly in the Queue directory.<br> If you select the 10 or 100 value, subdirectory with <code>NN</code> names (where NN is a 2-digit number from 00 to 99) will be created in the Queue directory. The newly created Temporary files will be created inside these subdirectories. The server will use 10 or 100 subdirectories, depending on this setting value.<br> If you select the <code>Auto</code> value, Queue subdirectories will be used when the total number of messages in the Queue exceeds 5000.</p></li></ul><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>When a message is submitted for processing, the Enqueuer component examines its envelope information. Each recipient address is parsed and passed to the <a href="./../sysadmin/Router.html">Router</a> component. The Router component decides which Module or component should process each recipient address.</p><h2 id="Enqueue" tabindex="-1">Enqueueing <a class="header-anchor" href="#Enqueue" aria-label="Permalink to &quot;Enqueueing {#Enqueue}&quot;">​</a></h2><p>When all recipient addresses are parsed and routed, the Enqueuer component applies the <a href="./QueueRules.html">Server-Wide Rules</a> to the message. Then it passes the message to the modules specified with the Router component.</p><p>Communication modules do not process E-mail messages immediately, but enqueue them into the module-specific queues. The SMTP Module creates and maintains a queue for each Internet domain, the Local Delivery Module creates and maintains a queue for each local Account, etc.</p><p>The Enqueuer component can enqueue messages:</p><ul><li>synchronously: as soon as messages are composed and submitted, Routing and Sever-wide/Cluster-wide Rules are applied, and the message composer component is informed if the message has been rejected (for example, if an External Filter has found a virus in the message). For example, the SMTP incoming channel sends a negative response to the sender of an infected message, the message is not enqueued, and no error report (bounce) messages are generated for infected messages.</li><li>asynchronously: the composer component immediately receives a positive response, and it can continue processing without waiting for the Enqueuer component. For example, the SMTP incoming channel can immediately start receiving the next message.</li></ul><p>Most of the internal components enqueue messages asynchronously, as they cannot do anything useful if a message is rejected with the Enqueuer component. The components receiving messages directly from users or remote systems (SMTP, MAPI, WebMail, XIMSS) try to enqueue messages synchronously, so if a message is rejected with the Enqueuer component, the submitting agent (a user or a remote system) can get an error message.</p><p>Use the WebAdmin Interface to configure the Enqueuer component. Open the Queue page in the Settings realm.</p>',10),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Message Enqueuer")])]),e("tr",null,[e("td",{width:"25%",nowrap:"nowrap",align:"right"},"Log:"),e("td",null,[e("select",{name:"EnqueuerLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{width:"25%",nowrap:"nowrap",align:"right"},"Processors:"),e("td",null,[e("select",{name:"EnqueuerProcessors"},[e("option",{value:"1",selected:"selected"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50")])])]),e("tr",null,[e("td",{width:"25%",nowrap:"nowrap",align:"right"},"Hop Counter Limit:"),e("td",null,[e("select",{name:"EnqueuerHopCounter"},[e("option",{value:"1"},"1"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"20",selected:"selected"},"20"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"21"},"other")])]),e("td",{nowrap:"nowrap",align:"RIGHT"},"Enqueue Asynchronously if Senders are:"),e("td",null,[e("select",{name:"EnqueueAsync"},[e("option",{value:"nobody"},"nobody"),e("option",{value:"clients"},"clients"),e("option",{value:"non-clients"},"non-clients"),e("option",{value:"authenticated"},"authenticated"),e("option",{value:"unauthenticated"},"unauthenticated"),e("option",{value:"anybody",selected:"selected"},"anybody")])])])])])])],-1),t('<ul><li><p><code>Enqueuer Log</code></p><p>Use this setting to specify what kind of information the Enqueuer component should put in the Server Log. Usually you should use the <code>Failures</code> (file system error reports) level.<br> The Enqueuer component Log records are marked with the <code>ENQUEUER</code> tag.</p></li><li><p><code>Enqueue Asynchronously</code></p><p>Use this option to specify when the asynchronous Enqueuer mode should be used:</p><ul><li><p>anybody</p><p>always use the asynchronous mode</p></li><li><p>nobody</p><p>never - always use the synchronous mode</p></li><li><p>authenticated</p><p>use only for messages received from authenticated sources (SMTP AUTH, AirSync, MAPI, WebMail, XIMSS, etc.)</p></li><li><p>unauthenticated</p><p>use only for messages not received from authenticated sources</p></li><li><p>clients</p><p>use only for messages received from authenticated sources or from the Network IP Addresses included into the Client IP Addresses list.</p></li><li><p>non-clients</p><p>use only for messages received from neither from an authenticated source, nor from a Network IP Address included into the Client IP Addresses list.</p></li></ul></li><li><p><code>Processors</code></p><p>Use this setting to specify the number of Enqueuer processors (threads).<br> If the asynchronous Enqueuer mode is not used, the Enqueuer threads are needed only to enqueue existing messages after the Server restart, and to enqueue messages generated with the internal Server component, so you may want to use 2-3 threads only.<br> If the asynchronous Enqueuer mode is used, then each message is processed with some Enqueuer thread. In this case, 10-20 Enqueuer threads should be enough even for a heavily loaded Server.</p><p>You should increase the number of Enqueuer processors if:</p><ul><li>there are very many Server-Wide <a href="./QueueRules.html">Rules</a>;</li><li>Server-Wide Rules use the <code>Execute</code> action to start external programs;</li><li>one or more <a href="./../mail/ExternalFilters.html">External Filter</a> (anti-virus, content filtering, etc.) programs are enabled;</li><li>incoming load is very high, with many messages being submitted every second via the SMTP or other modules.</li></ul><p>The <code>numEnqueuerMessages</code> <a href="./../sysadmin/Statistics.html">Statistics</a> element shows the number of messages that have been received, but not enqueued yet. If this number is growing, you need to increase the number of Enqueuer processors.</p></li><li><p><code>Hop Counter Limit</code></p><p>When a message is being received by any host or Module, it gets an additional Received: header field. The Hop Counter is the number of Received: header fields in the message. If a message contains too many Received: header fields, it may indicate that a message is in some sort of mail loop. This parameter specifies the Limit for the Hop Counter - any message that has more Received: header fields than specified in this setting is rejected by the ENQUEUER - without any attempt to deliver it to the recipients specified in the message envelope.</p></li></ul><h2 id="Delays" tabindex="-1">Delays and Suspensions <a class="header-anchor" href="#Delays" aria-label="Permalink to &quot;Delays and Suspensions {#Delays}&quot;">​</a></h2><p>When a communication Module fails to transfer a message, it uses the kernel queue management component to delay processing.</p><ul><li>a Module can delay an entire queue: for example, the SMTP Module can delay a queue created for an Internet domain, if it cannot connect to that domain or its relays;</li><li>a Module can delay an individual queued message: for example, the SMTP Module can delay a message if the receiving host rejects this particular message (transition failure);</li><li>a Module can delay an individual recipient address in a queued message: for example, the SMTP Module can delay an address if the receiving host rejects that particular address (transition failure).</li></ul><h2 id="Dequeue" tabindex="-1">Dequeueing <a class="header-anchor" href="#Dequeue" aria-label="Permalink to &quot;Dequeueing {#Dequeue}&quot;">​</a></h2><p>When a communication Module transfers a message or when it rejects a message because of a fatal error, it removes the message from the Module queue. The Module composes a delivery report and passes it to the Dequeuer component.</p><p>The Dequeuer component processes delivery information. If requested, it composes Delivery Status Notification (DSN) messages and submits them back to the system for delivery to the original message sender. When a message has several recipients, the Dequeuer component may choose to delay DSN generation, so each DSN message can contain reports about several recipients.</p><p>When all message recipients are processed and the message is dequeued from all queues, the Dequeuer component removes the message file from the <code>Queue</code> directory.</p><p>Use the WebAdmin Interface to configure the Dequeuer component. Open the Queue page in the Settings realm.</p>',9),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Message Dequeuer")])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"Log:"),e("td",null,[e("select",{name:"DequeuerLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2",selected:"selected"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{nowrap:"nowrap",align:"right"},"Processors:"),e("td",null,[e("select",{name:"DequeuerProcessors"},[e("option",{value:"1",selected:"selected"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50")])])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"Reporting Delay:"),e("td",null,[e("select",{name:"DequeuerWaitTime"},[e("option",{value:"0"},"0 seconds"),e("option",{value:"1"},"1 second"),e("option",{value:"5"},"5 seconds"),e("option",{value:"10"},"10 seconds"),e("option",{value:"15",selected:"selected"},"15 seconds"),e("option",{value:"30"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours")])]),e("td",{nowrap:"nowrap",align:"right"},"Send Return-Receipts to:"),e("td",{nowrap:"nowrap"},[e("select",{name:"DequeuerReceipt"},[e("option",{value:"0",selected:"selected"},"everybody"),e("option",{value:"1"},"clients"),e("option",{value:"2"},"authenticated"),e("option",{value:"3"},"nobody")])])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"On Failure, Return:"),e("td",{nowrap:"nowrap"},[e("select",{name:"DequeuerReject"},[e("option",{value:"0"},"headers by default"),e("option",{value:"1",selected:"selected"},"body by default"),e("option",{value:"2"},"always headers"),e("option",{value:"3"},"always body")])]),e("td",{nowrap:"nowrap",align:"RIGHT"},"Log Message Delivery:"),e("td",{nowrap:"nowrap"},[e("select",{name:"EMailDeliveryLog"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},[e("input",{type:"checkbox",name:"CopyErrorReports",value:"1"})]),e("td",null,[s("Copy Failure Reports to: "),e("input",{type:"text",name:"ErrorReportCopyAddress",value:"postmaster",size:"30",maxlength:"254"})]),e("td",{nowrap:"nowrap",align:"RIGHT"},"Allow Message Revocation:"),e("td",{nowrap:"nowrap"},[e("select",{name:"AllowMessageRecall"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])])],-1),t('<ul><li><p><code>Dequeuer Log</code></p><p>Use this setting to specify what kind of information the Dequeuer component should put in the Server Log. Usually you should use the <code>Major &amp; Failures</code> (delivery reports) level.<br> The Dequeuer component Log records are marked with the <code>DEQUEUER</code> tag.</p></li><li><p><code>Processors</code></p><p>Use this setting to specify the number of Dequeuer processors (threads). Usually one Dequeuer thread is enough even for a heavy-loaded server. Only if your Server performs some kind of special message processing and has to generate a lot of DSN messages, should you use several Dequeuer threads.</p></li><li><p><code>Reporting Delay</code></p><p>Use this setting to specify the maximum delay between the moment when a message was transferred or failed and the moment when a delivery report is generated. The more the delay, the more reports can be placed in one DSN message. A DSN message is generated immediately after the last message recipient is processed.</p></li><li><p><code>On Failure, Return</code></p><p>Use this setting to specify what portion of a failed message should be included into the DSN (error report) message.</p><ul><li>If the sender has not specified this option explicitly, and the <code>headers by default</code> option is selected, only the failed message headers will be returned;</li><li>If the sender has not specified this option explicitly, and the <code>body by default</code> option is selected, the entire failed message will be returned;</li><li>If the <code>always headers</code> option is selected, only the message headers are included into the DSN message, even if the message sender has specified that the entire message should be returned on failure;</li><li>If the <code>always body</code> option is selected, the entire message is included into the DSN message, even if the message sender has specified that only the message headers should be returned on failure.</li></ul></li><li><p><code>Copy Failure Reports</code></p><p>When this option is enabled, all error messages generated with the CommuniGate Pro Dequeuer are sent to both the failed message return-path and to the specified E-mail address.</p></li><li><p><code>Send Return-Receipts to</code></p><p>Positive reports (delivery reports and relay reports) are generated only if the message sender has requested them. Use this setting to specify who can request these reports:</p><p><code>everybody</code></p><p>reports are generated and sent whenever the message sender requests them.</p><p><code>clients</code></p><p>reports are generated and sent if the sender has submitted the message from a Client IP Address or if the message has been submitted by an authenticated user.</p><p><code>authenticated</code></p><p>reports are generated and sent if the message has been submitted by an authenticated user (via WebUser, XIMSS, SMTP AUTH, MAPI, etc.)</p><p><code>nobody</code></p><p>positive reports are not generated.</p></li><li><p><code>Log Message Delivery</code></p><p>If this option is enabled, then the Dequeuer places a record for each E-mail delivery into the <a href="./../sysadmin/Logs.html#EMails">EMails supplementary Log.</a></p></li><li><p><code>Allow Message Revocation</code></p><p>If this option is enabled, then the Server processes messages with <code>X-Special-Delivery: recall</code> header and tries to cancel delivery of the messages that were recalled.</p></li></ul><h2 id="MonitorQueue" tabindex="-1">Monitoring a Queue <a class="header-anchor" href="#MonitorQueue" aria-label="Permalink to &quot;Monitoring a Queue {#MonitorQueue}&quot;">​</a></h2><p>Transfer modules (such as <a href="./SMTP.html">SMTP</a>, <a href="./Local.html">Local Delivery</a>, <a href="./LIST.html">LIST</a>, and <a href="./PIPE.html">PIPE</a>) maintain one or several queues for messages to be delivered. Each Module uses its own methods to build the queues (for example, the SMTP Module usually builds a separate queue for each remote domain to deliver to, while the Local Delivery Module builds a separate queue for each local Account), see the manual section describing the Module for more details.</p><p>To open a Module queue, click the queue name link on Module Monitor page. The Module (&quot;host&quot;) queue page opens:</p>',4),e("form",{action:"Null.html"},[e("table",{width:"90%",border:"0",cellspacing:"0",cellpadding:"0"},[e("tbody",null,[e("tr",null,[e("td",null," "),e("td",{align:"RIGHT"},"2 of 2 selected")])])]),e("p"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"LEFT"},[e("th",null,"Module"),e("th",null,"Status"),e("th",null,"Last Problem")]),e("tr",{align:"LEFT"},[e("td",{nowrap:"nowrap"},[e("a",{href:"SMTP.html"},"SMTP")]),e("td",null,"Processing"),e("td",null,"no response")])])])]),e("p"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"LEFT",nowrap:"nowrap"},[e("th",null,"Message"),e("th",null,"In Queue"),e("th",null,"Return Path"),e("th",null,"Recipients"),e("th",null,"Size"),e("th",null,"Delayed"),e("th",null,"Last Problem")]),e("tr",null,[e("td",{nowrap:"nowrap"},[e("a",{href:"#MonitorMessage"},"44220010")]),e("td",{nowrap:"nowrap"},"5 min"),e("td",{nowrap:"nowrap"},"<system_admin@domain.dom>"),e("td",{nowrap:"nowrap"},"2"),e("td",{nowrap:"nowrap"},"634"),e("td",{nowrap:"nowrap"}),e("td",{nowrap:"nowrap"})]),e("tr",null,[e("td",{nowrap:"nowrap"},[e("a",{href:"#MonitorMessage"},"44220003")]),e("td",{nowrap:"nowrap"},"15 min"),e("td",{nowrap:"nowrap"},"<user2@domain3.dom>"),e("td",{nowrap:"nowrap"},"1"),e("td",{nowrap:"nowrap"},"26K"),e("td",{nowrap:"nowrap"}),e("td",{nowrap:"nowrap"})])])])])],-1),t('<p>The table header contains the information about the entire queue (&quot;host&quot;):</p><ul><li><p><code>Module</code></p><p>The link to the Monitor page of the Transfer Module this queue belongs to.</p></li><li><p><code>Status</code></p><p><code>Active</code> - this queue is being processes by the Module.<br><code>Ready</code> - this queue can be processes by the Module at any time.<br><code>Delayed till _time_</code> - this queue will not be processes by the Module until the time specified. The queue can be delayed because there was a queue-wide transfer operation error (an SMTP host did not respond, or a Local Account is over its quota, etc.)</p></li><li><p><code>Last Error</code></p><p>This field indicates the last queue-wide transfer operation error.</p></li></ul><p>The table contains a record for each message in the queue. For each enqueued message, the following information fields are displayed:</p><ul><li><p><code>Message</code></p><p>The message internal ID. You can use this link to open the <a href="#Message">Message Monitor</a> page.</p></li><li><p><code>In Queue</code></p><p>The time the message has spent in this queue.</p></li><li><p><code>Return Path</code></p><p>The message envelope &quot;Return-Path&quot; address.</p></li><li><p><code>Recipients</code></p><p>The number of message addresses that should be delivered to the &quot;host&quot; this queue is created for. For example, a message directed to user1@company.dom and user2@company.dom addresses via SMTP will appear once in the company.dom SMTP queue, with the indicated number of addresses being 2.</p></li><li><p><code>Size</code></p><p>The message size.</p></li><li><p><code>Delayed</code> and <code>Last Error</code></p><p>If delivery failed for this particular message, the Transfer Module could delay this message individually (rather than delaying the entire queue). In this case, this field will show the time when the Module will try to deliver the message again, and the Last Error field will show the information about the cause of the transfer operation failure.</p></li></ul><p>If you have the <a href="./../sysadmin/#Privs">Can Release Queues</a> access right, and the Queue has the Delayed status, the Host Queue Monitor page contains the Release Now button. Click this button to remove the delay interval set for this queue and to allow the Module to process the queue immediately.</p><p>If you have the <a href="./../sysadmin/#Privs">Can Reject Queues</a> access right, and the Queue has the Delayed or Ready status, the Host Queue Monitor page contains the Reject Host Queue button. Click this button to reject the queue:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td rowspan="2" align="right"><input name="Reject" value="Reject Message" class="button" type="reset"></td><td><input name="RejNoNDN" value="0" checked="checked" type="radio"><input name="RejText" value="canceled by server operator" size="30" maxlength="100" type="text"></td></tr><tr><td><input name="RejNoNDN" value="1" type="radio">Suppress Failed Delivery Reports</td></tr></tbody></table></div></form><p>The specified text is used to generate DSN messages (error reports) for all messages placed into this queue.</p><p>If the Suppress Failed Delivery Reports option is selected, no DSN message is generated when the queue messages are being rejected.</p><h2 id="MonitorMessage" tabindex="-1">Monitoring a Message <a class="header-anchor" href="#MonitorMessage" aria-label="Permalink to &quot;Monitoring a Message {#MonitorMessage}&quot;">​</a></h2><p>To monitor the status of a message in the Server Queue, click the message link on the Module queue or other Monitor page. The Message Monitor page opens:</p>',11),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("th",{align:"right"},"Sender:"),e("td",null,"user@mail.communigatepro.ru")]),e("tr",null,[e("th",{align:"right"},"Return-Path:"),e("td",null,"<user@mail.communigatepro.ru>")]),e("tr",null,[e("th",{align:"right"},"Message-ID:"),e("td",null,"<list-26325892@mail.communigatepro.ru>")]),e("tr",null,[e("th",{align:"right"},"Subject:"),e("td",null,"Re: FormMail.pl configured for CGP")]),e("tr",null,[e("th",{align:"right"},"Size:"),e("td",null,"37222 bytes (34018 in envelope)")]),e("tr",null,[e("th",{align:"right"},"Submitted:"),e("td",null,"Sat, 03 May 2014 09:16:58 -0800 (12hours ago)")])])])]),e("p"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Recipient"),e("th",null,"Module"),e("th",null,"Queue"),e("th",null,"Status"),e("th",null,"Retry in")]),e("tr",null,[e("td",{nowrap:"nowrap"},"postmaster@domain1.dom"),e("td",null,[e("a",{href:"SMTP.html"},"SMTP")]),e("td",null,[e("a",{href:"#HostQueue"},"domain1.dom")]),e("td",null,"Delayed"),e("td",null,"24min")]),e("tr",null,[e("td",{nowrap:"nowrap"},"john.smith@domain2.dom"),e("td",null,[e("a",{href:"SMTP.html"},"SMTP")]),e("td",null,[e("a",{href:"#HostQueue"},"domain2.dom")]),e("td",null,"Delayed"),e("td",null,"57min")])])])])],-1),t('<p>The first part of the page shows the message attributes: the envelope Return-Path, Message-ID, Envelope-ID (if present), message Subject, and the time the message was submitted to the Server Queue.</p><p>If the message has been submitted by an authenticated user, the Sender line displayes the sender&#39;s Account name.</p><p>The second part of the page lists all active message recipient addresses (if a message address has been already processed, it is not shown). For each address the following information is displayed:</p><ul><li><p><code>Recipient</code></p><p>Recipient address.</p></li><li><p><code>Module</code></p><p>The name of the Module that will process this address. This is also a link to the Module Monitor page.</p></li><li><p><code>Queue</code></p><p>The name of the Module queue containing this address. This is also a link to the Module queue Monitor page.</p></li><li><p><code>Status</code></p><p><code>Processing</code> - the Module is processing this address.<br><code>Ready</code> - the Module can start processing of this address at any time.<br><code>Suspended</code> - the Module has delayed processing of this message.<br><code>Delayed</code> - the Module has delayed processing of the entire queue containing this address.</p></li><li><p><code>Retry In</code></p><p>Time till the Module resumes processing of this message or the queue containing this message.</p></li></ul><p>If you have the <a href="./../sysadmin/#Privs">Can Reject Queues</a> access right, the Message Monitor page contains the Reject Message button. Click this button to reject all active message addresses.</p><p>If the message has been submitted by an authenticated sender, click the Reject All Sender&#39;s Messages button to reject all messages submitted by this sender.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td rowspan="2" align="right"><input name="RejectAllAuthed" value="Reject All Sender&#39;s Messages" class="button" type="reset">  <input name="Reject" value="Reject Message" class="button" type="reset"></td><td><input name="RejNoNDN" value="0" checked="checked" type="radio"><input name="RejText" value="canceled by server operator" size="30" maxlength="100" type="text"></td></tr><tr><td><input name="RejNoNDN" value="1" type="radio">Suppress Failed Delivery Reports</td></tr></tbody></table></div></form><p>Only the addresses that are not being processed can be rejected.</p><p>The specified text is used to generate DSN messages (error reports) for all rejected recipient addresses.</p><p>If the Suppress Failed Delivery Reports option is selected, no DSN message is generated when the message addresses are being rejected.</p><p>If you have the <a href="./../sysadmin/#Privs">Can View Queue Messages</a> access right, the Message Monitor page contains the Message content (it is displayed using the Unnamed Stock <a href="./../../development/WebApp.html">Skin</a>).</p>',11),e("table",{class:"externalMessage"},[e("tr",null,[e("td",null,[e("table",{width:"100%",cellspacing:"0",class:"rfcheader"},[e("tr",{valign:"top"},[e("td",{width:"100%"},[e("table",{class:"rfcheaderfields"},[e("tr",null,[e("td",{class:"rfcfieldname"},"From:"),e("td",{class:"rfcfieldvalue"},'"User Name" <userName@server.dom>')]),e("tr",null,[e("td",{class:"rfcfieldname"},"Subject:"),e("td",{class:"rfcfieldvalue"},"Some subject here")]),e("tr",null,[e("td",{class:"rfcfieldname"},"Date:"),e("td",{class:"rfcfieldvalue"},"Fri, 07 Dec 2007 02:56:41 -0800")]),e("tr",null,[e("td",{class:"rfcfieldname"},"Message-Id:"),e("td",{class:"rfcfieldvalue"},"<web-12490003@server.dom>")]),e("tr",null,[e("td",{class:"rfcfieldname"},"X-Mailer:"),e("td",{class:"rfcfieldvalue"},"CommuniGate Pro WebUser v5.3.5")])])]),e("td",{class:"rfcheaderlinks"},[e("a",{href:"#MonitorMessage",target:"_blank"},[e("img",{src:o,alt:"Message Header"})]),e("br"),e("br"),e("a",{href:"#MonitorMessage",target:"_blank"},[e("img",{src:i,alt:"Undecoded Message"})])])])])])]),e("tr",null,[e("td",null,[e("div",{class:"letterText"},[s("TEST - TEST TEST"),e("br"),e("br"),s(" --"),e("br"),s(" This is a test letter with one attachment."),e("br")]),e("div",null,[e("a",{href:"#MonitorMessage"},[e("img",{src:n,alt:"Attachment"}),e("br"),e("b",null,"Attachment:"),s(" TestDocument.doc")]),s(),e("span",{style:{"font-size":"-1"}},"(29K)")])])])],-1)]))}const w=l(h,[["render",c]]);export{T as __pageData,w as default};
