import{_ as a,c as t,o as i,ag as r}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Billing","description":"","frontmatter":{"legacyLink":"Billing.html"},"headers":[],"relativePath":"admin/misc/Billing.md","filePath":"admin/misc/Billing.md"}'),o={name:"admin/misc/Billing.md"};function l(n,e,s,p,c,d){return i(),t("div",null,e[0]||(e[0]=[r('<h1 id="billing" tabindex="-1">Billing <a class="header-anchor" href="#billing" aria-label="Permalink to &quot;Billing&quot;">​</a></h1><p>The CommuniGate Pro Server can act as a Billing platform.</p><p>Each <a href="./../objects/Accounts.html">Account</a> can have one or several <em>Balances</em>. CommuniGate Pro modules and components can post charges and credits to these balances, make refunds, etc.</p><p>The <em>current amount</em> is maintained for each Balance, along with active <em>reservations</em>.</p><p>The log of all transactions is kept in the Account data files. The Log format provides for easy backup and restore operations, and for Balance recovery after hardware failures.</p><p>The &quot;default&quot; or &quot;generic&quot; Balance uses an empty string as its name.</p><p>Monetary values (funds) are presented as 64-bit signed integer values.</p><h2 id="Reserve" tabindex="-1">Reservations <a class="header-anchor" href="#Reserve" aria-label="Permalink to &quot;Reservations {#Reserve}&quot;">​</a></h2><p>The Balance reservations are used when some billed activity takes time and/or a billing activity takes place in several steps.</p><p>The application first &quot;reserves&quot; a certain monetary amount, sufficient to pay for some initial stage of the billed activity. For example, it can be an amount needed to pay for the first minute of a call, or to play the first level of a game.<br> If the selected Balance does not have sufficient funds, the reservation request is rejected.<br> Otherwise, a reservation (with an application-supplied or server-generated name) is created inside the Balance. The total funds available in the Balance are decreased by the reserved amount, but not charge record is created in the transaction log.</p><p>As the payment amount of the billed activity approaches the reserved amount, the application &quot;extends&quot; the created reservation by some additional amount. If the Balance does have enough &quot;free funds&quot; (i.e. funds not reserved with other reservations), the reservation amount is extended.</p><p>The application can release the created reservation. The reservation is removed from the Balance, and the reserved amount is returned to the Balance &quot;free funds&quot;. For example, this function can be used when a phone call was not connected, as the reserved funds must be released without recording any charge transaction.</p><p>Finally, the application charges the Balance, specifying the reservation. The charge amount should not exceed the amount reserved.<br> The transaction log record is created, and the charged amount is subtracted from the Balance and from the reservation reserved amount. Optionally, the reservation can be released, and the remaining funds returned to the Balance &quot;free funds&quot;.</p><p>When a reservation is created or extended, the application can specify the reservation expiration time. The reservation is released automatically after the specified time. This feature can be used if the application can disconnect or quit without explicitly releasing its reservations.<br> When creating or extending a reservation, the application can specify the amount that should be charged if the reservation is timed-out and it is released automatically. For example, when a game application extends the reservation to cover the next game level, it can specify the amount that should be already be paid for the current game. If the application quits or disconnects without explicitly charging the Balance reservation, the reservation will be released automatically, but the specified amount will be changed first.</p><h2 id="API" tabindex="-1">Interfaces <a class="header-anchor" href="#API" aria-label="Permalink to &quot;Interfaces {#API}&quot;">​</a></h2><p>The CommuniGate Pro Billing subsystem is available for:</p><ul><li><a href="./../../development/CGPL.html">CG/PL</a> server-side applications (PBX Tasks, WebUser applets, etc.)</li><li><a href="./../../development/XMLAPI.html">XIMSS</a> client applications.</li><li><a href="./../signals/Parlay.html">ParlayX</a> client applications.</li><li><a href="./../../development/CLI.html">CLI</a> client applications.</li></ul><h2 id="OpCodes" tabindex="-1">Operations <a class="header-anchor" href="#OpCodes" aria-label="Permalink to &quot;Operations {#OpCodes}&quot;">​</a></h2><p>The following Billing operations are available:</p><ul><li><p><code>list</code></p><p>This operation lists all Balances available for this Account.</p><ul><li><p>Parameters:</p><p><em>none</em></p></li><li><p>Results:</p><ul><li><p><code>balance</code></p><p>an array of available Balance names.</p></li></ul></li></ul></li><li><p><code>credit</code></p><p>This operation adds funds to a Balance.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. If the Balance with this name does not exist, it is created.</p></li><li><p><code>amount</code></p><p>a non-negative number: the credited amount.</p></li><li><p><code>reference</code></p><p>a string: arbitrary data used for references, dispute resolutions, etc.</p></li><li><p><code>description</code></p><p>an object (usually a string or an array of strings): arbitrary data describing the transaction.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>amount</code></p><p>a number: the current Balance value.</p></li></ul></li></ul></li><li><p><code>remove</code></p><p>This operation removes a Balance.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Balance history is not removed. If the current Balance value is not zero, a record is added to the Balance history, changing the Balance value to zero.</p></div><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. The Balance with this name is removed.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>amount</code></p><p>a number: the removed Balance value.</p></li></ul></li></ul></li><li><p><code>reserve</code></p><p>This operation reserves funds from a Balance. The reserved amount cannot be used for other charges. The reservation can be released explicitly, returning funds to the Balance, or it can expire after the specified period of time.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. This Balance must already exist.</p></li><li><p><code>amount</code></p><p>a number: the amount to reserve. If the reservation already exists, this value is used to increase the reserved amount.</p></li><li><p><code>reserve</code></p><p>a string, optional: if this parameter exists, it should specify the existing reservation. The <code>amount</code> will be added to this reserve. If this parameter is absent, a new reservation is created.</p></li><li><p><code>expires</code></p><p>a timestamp, optional: if this parameter exists, it specifies when this reservation should expire.</p></li><li><p><code>overdraft</code></p><p>optional: if this parameter exists, it is possible to reserve an amount larger than the current Balance value. If this parameter does not exist, attempts to reserve an amount larger than the current Balance value are rejected.</p></li><li><p><code>charge</code></p><p>a number: the amount to charge if this reservation expires and it is automatically released.</p></li><li><p><code>reference</code>, <code>description</code></p><p>these strings can be specified if the <code>charge</code> parameter is specified. They have the same meaning as the <code>credit</code> operation parameters, and they are used if this reservation is automatically charged when it expires.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>reserve</code></p><p>a string: the reservation name (the same as the <code>reserve</code> parameter, if it was specified).</p></li><li><p><code>amount</code></p><p>a number: the current reservation value.</p></li><li><p><code>total</code></p><p>a number: the current Balance &quot;free funds&quot;.</p></li></ul></li></ul></li><li><p><code>release</code></p><p>This operation releases a reservation. The reserved amount is returned to the Balance.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. This Balance must already exist.</p></li><li><p><code>reserve</code></p><p>a string: the existing reservation name.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>reserve</code></p><p>a string: the reservation name (the same as the <code>reserve</code> parameter, if it was specified).</p></li><li><p><code>amount</code></p><p>a number: the released reservation value.</p></li><li><p><code>total</code></p><p>a number: the current Balance &quot;free funds&quot;.</p></li></ul></li></ul></li><li><p><code>charge</code></p><p>This operation subtracts funds from a Balance or a reservation.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. This Balance must already exist.</p></li><li><p><code>amount</code></p><p>a number: the amount to charge.</p></li><li><p><code>reserve</code></p><p>a string, optional: if this parameter exists, the charge is applied to the already existing reservation. If this parameter is absent, the charge is applied to the Balance itself.</p></li><li><p><code>overdraft</code></p><p>optional, cannot be specified together with the <code>reserve</code> parameter: if this parameter exists, it is possible to charge an amount larger than the current Balance value. If this parameter does not exist, attempts to charge an amount larger than the current Balance value are rejected.</p></li><li><p><code>release</code></p><p>optional, cannot be specified without the <code>reserve</code> parameter: if this parameter exists, the reservation is released after the charge is made.</p></li><li><p><code>reference</code>, <code>description</code></p><p>same as for the <code>credit</code> operation.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>amount</code></p><p>a number: the current Balance &quot;free funds&quot; or reservation value.</p></li><li><p><code>total</code></p><p>a number: the current Balance &quot;free funds&quot; (only if the <code>reserve</code> parameter is specified).</p></li><li><p><code>expires</code></p><p>a timestamp: the reservation expiration time (only if the <code>reserve</code> parameter is specified and the reservation has an expiration time set).</p></li></ul></li></ul></li><li><p><code>read</code></p><p>This operation reads the current Balance or reservation value.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. This Balance must already exist.</p></li><li><p><code>reserve</code></p><p>a string, optional: if this parameter exists, it must specify an existing reservation. The operation reads that reservation value. If this parameter is absent, the operation reads the Balance value.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>amount</code></p><p>a number: the current Balance or reservation value.</p></li><li><p><code>expires</code></p><p>a timestamp: the reservation expiration time (only if the <code>reserve</code> parameter is specified and the reservation has an expiration time set).</p></li></ul></li></ul></li><li><p><code>history</code></p><p>This operation reads the Balance transaction log.</p><ul><li><p>Parameters:</p><ul><li><p><code>balance</code></p><p>a string: the Balance name. This Balance must already exist.</p></li><li><p><code>timeFrom</code>,<code>timeTill</code></p><p>timestamps: Balance records from recorded on or after <code>timeFrom</code> but before <code>timeTill</code> (exclusive) are read.</p></li><li><p><code>limit</code></p><p>a number: the maximum number of records to display.<br> If this number is positive, the newest records are returned first, and the oldest records are discarded if the record number limit is reached.<br> If this number is negative, the oldest records are returned first, and the newest records are discarded if the record number limit is reached.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>history</code></p><p>an array of transaction records. Each record contains the following elements:</p><ul><li><p><code>Date</code></p><p>a timestamp: the time of transaction.</p></li><li><p><code>amount</code></p><p>a number: the transaction amount (positive for <code>credit</code> operations).</p></li><li><p><code>balance</code></p><p>a number: the Balance value after this transaction.</p></li><li><p><code>reference</code>, <code>description</code></p><p>copies of the <code>credit</code> and <code>charge</code> operation parameters.</p></li></ul></li></ul></li></ul></li><li><p><code>calllog</code></p><p>This operation reads the Call Log files.</p><ul><li><p>Parameters:</p><ul><li><p><code>timeFrom</code>,<code>timeTill</code></p><p>timestamps: records for calls that took place on or after <code>timeFrom</code> but before <code>timeTill</code> (exclusive) are read.</p></li><li><p><code>limit</code></p><p>a number: the maximum number of records to display.<br> If this number is positive, the newest records are returned first, and the oldest records are discarded if the record number limit is reached.<br> If this number is negative, the oldest records are returned first, and the newest records are discarded if the record number limit is reached.</p></li><li><p><code>filter</code></p><p>optional string: if specified, the operation returns only the calls with peers whose addresses or &quot;real names&quot; match the specified string.</p></li></ul></li><li><p>Results:</p><ul><li><p><code>callHistory</code></p><p>an array of transaction records. Each record contains the following elements:</p><ul><li><p><code>Date</code></p><p>a timestamp: call start time (GMT).</p></li><li><p><code>direction</code></p><p>the &quot;inp&quot; string for incoming calls, the &quot;out&quot; string for outgoing calls.</p></li><li><p><code>To</code></p><p>the peer address string.</p></li><li><p><code>RealName</code></p><p>(optional) the real name of the peer.</p></li><li><p><code>Call-ID</code></p><p>the call Call-ID string.</p></li><li><p><code>disconnected</code></p><p>a timestamp: call end time (GMT).</p></li><li><p><code>connected</code></p><p>a timestamp: call connected time (GMT). If absent, the call has not been connected.</p></li><li><p><code>dialogError</code></p><p>(optional) call completion/failure error code string.</p></li><li><p><code>dialogApp</code></p><p>(optional) if a call has been answered by a PBX application, the application program name string.</p></li></ul></li><li><p><code>amount</code></p><p>the total number of found call records</p></li></ul></li></ul></li></ul>',20)]))}const m=a(o,[["render",l]]);export{u as __pageData,m as default};
