import{_ as s,c as a,o as t,ag as o}from"./chunks/framework.jCcxW76o.js";const h=JSON.parse('{"title":"Miscellaneous: E-Mail","description":"","frontmatter":{"legacyLink":"Misc.html"},"headers":[],"relativePath":"admin/misc/Mail.md","filePath":"admin/misc/Mail.md"}'),d={name:"admin/misc/Mail.md"};function i(r,e,n,c,l,p){return t(),a("div",null,e[0]||(e[0]=[o(`<p></p><h1 id="miscellaneous-e-mail" tabindex="-1">Miscellaneous: E-Mail <a class="header-anchor" href="#miscellaneous-e-mail" aria-label="Permalink to &quot;Miscellaneous: E-Mail&quot;">​</a></h1><p>This section describes various CommuniGate Pro E-mail Transfer features not mentioned elsewhere.</p><h2 id="Receipt" tabindex="-1">Return Receipts <a class="header-anchor" href="#Receipt" aria-label="Permalink to &quot;Return Receipts {#Receipt}&quot;">​</a></h2><p>Senders can request return-receipts by including the <code>Return-Receipt-To:</code> header fields into messages. When a message containing a Return-Receipt-To: header field is delivered to a local Account, the Server generates a Delivery Notification message. That message is sent to the Return-Path address of the message, not to the address specified in the message Return-Receipt-To: header field.</p><h2 id="AddressTest" tabindex="-1">Address Testing <a class="header-anchor" href="#AddressTest" aria-label="Permalink to &quot;Address Testing {#AddressTest}&quot;">​</a></h2><p>If a message has the</p><p>X-Special-Delivery: test</p><p>header field, the SMTP and Local Delivery modules do not send the message to its recipients.</p><p>The SMTP module connects to all hosts the message is addressed to, then the module sends all recipient addresses to those hosts, but it does not send the message itself.</p><p>The Local Delivery module checks if the account exists, but the module does not try to apply the Account Rules to the message and the module does not store the message in the Account Inbox.</p><p>This feature can be used to verify addresses on large mailing lists: if an address contains an unknown domain name, or the host is not unreachable, or if the host rejects a user address, an error message is generated in the regular way, and can be used to detect &quot;bad&quot; addresses and to &quot;clean&quot; the mailing list.</p><h2 id="ReqHeaders" tabindex="-1">Adding Required Headers <a class="header-anchor" href="#ReqHeaders" aria-label="Permalink to &quot;Adding Required Headers {#ReqHeaders}&quot;">​</a></h2><p>If a message does not have a properly composed RFC header part, the Server adds an RFC header to the message. This header contains the required fields only.</p><p>If a submitted message does not have a <code>Date:</code> header field, the Server adds one using the date and time when the message was submitted to the Server.</p><p>If a submitted message does not have a <code>Message-ID:</code> header field, and the message was received from a &quot;trusted source&quot;, the Server adds a <code>Message-ID:</code> field to the message.</p><h2 id="LegacyMail" tabindex="-1">Legacy Mail Emulation <a class="header-anchor" href="#LegacyMail" aria-label="Permalink to &quot;Legacy Mail Emulation {#LegacyMail}&quot;">​</a></h2><p>The CommuniGate Pro software package includes the command-line program <code>mail</code> (<code>mail.exe</code> for the Microsoft Windows platforms). You can use this program to submit messages to the CommuniGate Pro system, as you used the legacy <code>mail</code> program to submit messages to the <code>sendmail</code> MTA.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>mail [-EiInv]  [-d base-directory]</span></span>
<span class="line"><span>     [-s subject] [-f from-address]</span></span>
<span class="line"><span>     [-c Cc-addresses] [-b bcc-addresses] to-addresses</span></span></code></pre></div><ul><li><p><code>-i</code>, <code>-I</code>, <code>-n</code>, <code>-v</code></p><p>These options are ignored; they are included for compatibility only.</p></li><li><p><code>-E</code></p><p>Do not send messages with an empty body. This is useful for piping errors from cron scripts.</p></li><li><p><code>-f from-address</code></p><p>Use the <em>from-address</em> as the message From: address. If this parameter is not specified, the current user name is used.</p></li><li><p><code>-d base-directory</code></p><p>Use the <em>base-directory</em> path as the location of the CommuniGate Pro <em>base directory</em>.</p></li><li><p><code>-s subject</code></p><p>Specifies the <em>subject</em> (only the first argument after the -s flag is used as a subject; be careful to quote subjects containing spaces).</p></li><li><p><code>-c cc-addresses</code></p><p>Send carbon copies to the <em>cc-addresses</em>; cc-addresses should be a comma-separated list of e-mail addresses.</p></li><li><p><code>-b bcc-addresses</code></p><p>Send blind carbon copies to the <em>bcc-addresses</em>; bcc-addresses should be a comma-separated list of e-mail addresses.</p></li><li><p><code>to-addresses</code></p><p>A comma-separated list of E-mail addresses.</p></li></ul><p>The CommuniGate Pro software package includes the command-line program <strong><code>sendmail</code></strong> (<code>sendmail.exe</code> for the Microsoft Windows platforms). You can use this program to submit messages to the CommuniGate Pro system, using the interface of the legacy <code>sendmail</code> program.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>sendmail [-i] [-t] [-d base-directory]</span></span>
<span class="line"><span>         [-f from-address] [-F sender-name] [-V envid]</span></span>
<span class="line"><span>         [-Oparameter] [-oparameter] [-B body_type] [address, ...]</span></span></code></pre></div><ul><li><p><code>-d base-directory</code></p><p>Use the <em>base-directory</em> path as the location of the CommuniGate Pro <em>base directory</em>.</p></li><li><p><code>-i</code></p><p>Ignore dots alone on lines by themselves in incoming messages. This should be set if you are reading data from a file.</p></li><li><p><code>-t</code></p><p>Read message for recipients. To:, Cc:, and Bcc: lines will be scanned for recipient addresses. The Bcc: lines will be deleted before transmission. The addresses listed on the command line will be excluded from the list of the recipients.</p></li><li><p><code>-ffrom-address</code></p><p>Use the <em>from-address</em> as the message From: address. If this parameter is not specified, the current user name is used.</p></li><li><p><code>-Fsender-name</code></p><p>Set the full name of the sender.</p></li><li><p><code>-V envid</code></p><p>The Envelope ID of the message.</p></li><li><p><code>-Oparameter</code><br><code>-oparameter</code><br><code>-B bodytype_</code><br><code>-C configfile_</code><br><code>-N dsn</code><br><code>-h hopcount_</code><br><code>-R return</code><br><code>-qparameter</code></p><p>These options are ignored.</p></li><li><p><code>addresses</code></p><p>The destination addresses (without the <code>-t</code> option) or the addresses to be excluded from the the destination address list (if the <code>-t</code> option is specified).</p></li></ul><p>The CommuniGate Pro mail and sendmail commands use the <a href="./../mail/PIPE.html#Submitted">Submitted folder</a> feature.</p>`,24)]))}const u=s(d,[["render",i]]);export{h as __pageData,u as default};
