import{_ as n,c as s,o as a,ag as t,j as e}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Listeners","description":"","frontmatter":{"legacyLink":"Listener.html"},"headers":[],"relativePath":"admin/network/Listener.md","filePath":"admin/network/Listener.md"}'),i={name:"admin/network/Listener.md"};function r(c,o,l,d,p,h){return a(),s("div",null,o[0]||(o[0]=[t('<h1 id="listeners" tabindex="-1">Listeners <a class="header-anchor" href="#listeners" aria-label="Permalink to &quot;Listeners&quot;">​</a></h1><p>The CommuniGate Pro Server accepts SMTP, IMAP, POP, LDAP, and other TCP connections using TCP <em>Listeners</em>.<br> The CommuniGate Pro Server receives SIP, SNMP, RADIUS, TFTP and other UDP requests using UDP <em>Listeners</em>.</p><p>A Listener opens one or several <em>listener sockets</em>, each socket accepting TCP connections or receiving UDP packets directed to the specified port number and, optionally, to the specified local IP address.</p><p>The Listener settings allow the Server administrator to specify remote address restrictions, providing access to the listener sockets only to the specified networks.</p><p>The CommuniGate Pro TCP Listeners can be configured to accept <em>clear text</em> connections or <em>secure</em> (TLS/SSL) connections.</p><p>The CommuniGate Pro TCP Listeners can limit the number of incoming connections that come from the same IP address. This can help to prevent certain Denial of Service (DoS) attacks.</p><h2 id="Ports" tabindex="-1">Multi-Socket Listening <a class="header-anchor" href="#Ports" aria-label="Permalink to &quot;Multi-Socket Listening {#Ports}&quot;">​</a></h2><p>TCP and UDP services use Listeners to accept incoming connections and packets. Each Listener can use one or several <em>listener sockets</em>.</p><p>A listener socket accepts incoming TCP connections or receives UDP packets on the port number you specify. You should also specify if the socket should accept connections or receive packets on all IP addresses your server computer has, or only on a selected address.</p><p>For example, you may want to create a socket that accepts all connections on one local IP address, while the other socket is used to accept connections on the other local IP address - and only from the specified networks.</p><p>Because of the nature of TCP sockets, you cannot have two listener sockets that use the same port number and the same local IP address: if you create a listener socket on the TCP port N that works with ALL local IP addresses, you cannot create a different socket on the same port N. If you create a listener socket on the TCP port N and a specific local address xx.xx.xx.xx, then you can create a different listener socket on the same TCP port N and a different local address yy.yy.yy.yy.</p><p>If your CommuniGate Pro Server coexists with some other server software, such as a third-party Web server, you may want to configure that Web server to use one local IP address, while your CommuniGate Pro server would provide its HTTP services on a different local IP address - but on the same port number. If that port number is 80, and the domain name <code>www.company.com</code> resolves into the first IP address, while <code>mail.company.com</code> resolves into the second IP address, then typing <code>http://www.company.com</code> in a client browser will bring up the third-party Web Server home page, while typing <code>http://mail.company.com</code> will bring up the CommuniGate Pro Login page - with both servers running on the same server computer.</p>',12),e("form",{action:"Null.html"},[e("table",{class:"settingsBox",cellpadding:"3",width:"90%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",{nowrap:"nowrap"},"Port"),e("th",{nowrap:"nowrap"},"Local IP Address"),e("th",{nowrap:"nowrap"},"Init SSL/TLS"),e("th",{colspan:"2",nowrap:"nowrap"},"Remote IP Address Restrictions")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"hidden",name:"Ports",value:"0"}),e("input",{type:"text",name:"p0000",value:"143",size:"5",maxlength:"5"})]),e("td",null,[e("select",{name:"a0000"},[e("option",{value:"*",selected:"selected"},"all addresses"),e("option",{value:"[10.0.0.90]"},"[10.0.0.90]"),e("option",{value:"[127.0.0.1]"},"[127.0.0.1]")])]),e("td",null,[e("select",{name:"s0000"},[e("option",{value:"0",selected:"selected"},"off"),e("option",{value:"1"},"on"),e("option",{value:"2"},"ext")])]),e("td",{align:"right"},[e("select",{name:"r0000"},[e("option",{value:"0"},"None"),e("option",{value:"1"},"Deny"),e("option",{value:"2",selected:"selected"},"Grant")])]),e("td",null,[e("textarea",{name:"d0000",rows:"4",cols:"32"},`10.0.0.81-10.0.0.90; internal LAN
10.0.1.12 ; gateway`)])]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"hidden",name:"Ports",value:"1"}),e("input",{type:"text",name:"p0001",value:"993",size:"5",maxlength:"5"})]),e("td",null,[e("select",{name:"a0001"},[e("option",{value:"*",selected:"selected"},"all addresses"),e("option",{value:"[10.0.0.90]"},"[10.0.0.90]"),e("option",{value:"[127.0.0.1]"},"[127.0.0.1]")])]),e("td",null,[e("select",{name:"s0001"},[e("option",{value:"0"},"off"),e("option",{value:"1",selected:"selected"},"on"),e("option",{value:"2"},"ext")])]),e("td",{align:"right"},[e("select",{name:"r0001"},[e("option",{value:"0",selected:"selected"},"None"),e("option",{value:"1"},"Deny"),e("option",{value:"2"},"Grant")])]),e("td",null,[e("textarea",{name:"d0001",rows:"4",cols:"32"})])]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"hidden",name:"Ports",value:"2"}),e("input",{type:"text",name:"p0002",value:"0",size:"5",maxlength:"5"})]),e("td",null,[e("select",{name:"a0002"},[e("option",{value:"*",selected:"selected"},"all addresses"),e("option",{value:"[10.0.0.90]"},"[10.0.0.90]"),e("option",{value:"[127.0.0.1]"},"[127.0.0.1]")])]),e("td",null,[e("select",{name:"s0002"},[e("option",{value:"0",selected:"selected"},"off"),e("option",{value:"1"},"on"),e("option",{value:"2"},"ext")])]),e("td",{align:"right"},[e("select",{name:"r0002"},[e("option",{value:"0",selected:"selected"},"None"),e("option",{value:"1"},"Deny"),e("option",{value:"2"},"Grant")])]),e("td",null,[e("textarea",{name:"d0002",rows:"4",cols:"32"})])])])])],-1),t('<p>To create a new listener socket, change the value in the last table element from 0 to the desired port number and click the Update button.</p><p>To remove a listener socket, change its port number to 0 and click the Update button.</p><p>Even if your server has only one IP address, you may want to create two listener sockets for most of your TCP services: one for regular, <em>clear text</em> connections and one (on a different port number) for secure connections (see below).</p><h2 id="Restrictions" tabindex="-1">Restrictions <a class="header-anchor" href="#Restrictions" aria-label="Permalink to &quot;Restrictions {#Restrictions}&quot;">​</a></h2><p>You may want a listener socket to accept connections or to receive packets only from certain remote network (IP) addresses.</p><p>If the remote IP address of an incoming connection or a received packet is included into the <a href="./#Denied">Denied IP Addresses</a> list, the connection is rejected and the packet is dropped.</p><p>If you set the Restriction setting to <code>Grant</code>, and list the IP addresses in the text field, the socket will accept connections or packets from the specified addresses only.</p><p>If you set the Restriction setting to <code>Deny</code>, and list the IP addresses in the text field, the socket will deny access to all clients trying to connect from the specified (blacklisted) addresses.</p><p>The IP addresses are specified in a multi-line format. See the <a href="./#IPLists">Network</a> section for more details.</p><p>There is a difference between the Access Restrictions on the listener socket level, and the restrictions set in the SMTP module. When a remote site connects to your server SMTP port and the site IP address is not accepted by the listener socket, the connection is closed immediately. As a result, the remote site will try all other IP addresses of your server, and then it will try to relay mail via your back-up server.</p><p>On the other hand, if the remote site address is included into the Server <a href="./../sysadmin/Protection.html#Relay">Protection</a> Black-List, SMTP sessions are not closed immediately. Instead, the SMTP session starts and the remote (blacklisted) server is allowed to send the addresses of message recipients. But the SMTP module rejects each address with a &quot;fatal error&quot; code, thus stopping the blacklisted host from trying to relay those messages via your back-up servers.</p><p>There is a difference between the Access Restrictions on the listener socket level, and the restrictions set by the <a href="./../sysadmin/Security.html#Access">Grant Access to the Clients Only</a> option. When a remote site connects to your Server POP, IMAP, WebUser, or other access-type port and the site IP address is not accepted by the listener socket, the connection is closed immediately. As a result, the remote site may try all other IP addresses of your server (and you may have different access restrictions on listener sockets serving those addresses).</p><p>On the other hand, if the remote site address is not included into the Server <a href="./../sysadmin/Protection.html">Client IP Addresses</a> list, sessions are not closed immediately. Instead, an access-type session starts, and, if the Grant Access to Clients Only option is enabled, an error message is sent to the remote site before the module closes the connection.</p><h2 id="Secure" tabindex="-1">Secure Sockets <a class="header-anchor" href="#Secure" aria-label="Permalink to &quot;Secure Sockets {#Secure}&quot;">​</a></h2><p>The <code>Init SSL/TLS</code> option is available for TCP Listeners only.</p><p>Set the <code>Init SSL/TLS</code> listener socket option to <code>On</code> to tell the Listener component to initiate SSL/TLS negotiations as soon as a connection from a remote site is accepted. Only when a secure connection is established, the Listener allows the communication module to initiate its own protocol (IMAP, HTTP, etc.) - on top of the secure SSL/TLS protocol.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Please read the <a href="./../sysadmin/PKI.html#TLS">Security</a> section and configure your Domain TLS certificates before you set this option to <code>On</code>.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a Listener accepts a connection on a Secure Socket, it tries to detect the CommuniGate Pro Domain the client has connected to. At this time no information has yet been transferred from the client to the server, so the local server IP address the client has connected to is the only data CommuniGate Pro can use to detect the target Domain.</p><p>If you want a Domain to have its own Security Certificate and to use it for Secure Socket connections, that Domain <strong>must</strong> have an IP address assigned to it.</p><p>When the Domain is selected, the Listener retrieves the Domain Certificate and initiates a secure (SSL/TLS) session. If the selected Domain does not have a Certificate, the connection is dropped and an error message is placed into the CommuniGate Pro Log.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The current versions of the Internet protocols support the STARTTLS/STLS or equivalent commands. These commands are used to provide secure communications <strong>without</strong> creating a special Secure Socket on an additional port. Instead, a regular port is used, and a regular, non-secure connection is established, and then the client sends the STARTTLS or an equivalent command, and the client and server initiate the SSL/TLS session. If the software you use employs the STARTTLS command (as most SMTP software packages do these days), then you do not need to create any special Secure Socket for secure (SSL/TLS) communications.</p></div><p>Set the <code>Init SSL/TLS</code> listener socket option to <code>Ext</code> to tell the Listener component that all connections coming to this socket are SSL/TLS secured, but that there is an external device implementing all SSL/TLS encryption/decryption operations.<br> Connections coming to these ports are clear-text connections, but higher-level CommuniGate Pro components and protocols process these connections as if they come encrypted: <a href="./../sysadmin/Security.html">clear-text Login</a> operations are considered secure, STARTTLS operations are prohibited, etc.</p><h2 id="IPLimit" tabindex="-1">Limiting Connections from the same Network Address <a class="header-anchor" href="#IPLimit" aria-label="Permalink to &quot;Limiting Connections from the same Network Address {#IPLimit}&quot;">​</a></h2><p>The connection-limiting options are available for TCP Listeners only.</p><p>To prevent various Denial of Service (DoS) attacks you may want to limit the number of connections a Listener can accept (on all sockets) from the same IP address:</p>',23),e("form",{action:"Null.html"},[e("table",{class:"settingsBox",cellpadding:"3",width:"90%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Reserve Connections for Clients:"),e("td",null,[e("select",{name:"ReserveClient"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"Limit Connections from same Address:"),e("td",null,[e("select",{name:"MaxConnectionsPerAddress"},[e("option",{value:"0"},"unlimited"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"other")])]),e("td",{align:"right",nowrap:"nowrap"},"Non-Clients:"),e("td",null,[e("select",{name:"MaxConnectionsPerNonClientAddress"},[e("option",{value:"0"},"unlimited"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5",selected:"selected"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"other")])])])])])],-1),t('<p>The Non-Client setting applies only to the TCP connections from Network IP Addresses not included into the <a href="./">Client IP Addresses</a> list. This setting value should be equal or smaller than the main Limit Connections setting value.</p><p>When you set these settings, you should remember that:</p><ul><li>IMAP clients usually open several connections to the server. If you set this setting for the IMAP listener to less than 5, you can cause problems for your users.</li><li>Web browsers can open several simultaneous connections to retrieve embedded graphic files and other HTML page elements.</li><li>Many Web clients can connect to your server via the same proxy, and they all appear as connecting to your server from the same IP address.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To avoid problems with inter-server communication, this setting has no effect on connections that come from other Servers in the same CommuniGate Pro <a href="./../cluster/">Cluster</a>.</p></div><h2 id="Reserve" tabindex="-1">Reserving Connections for Client Addresses <a class="header-anchor" href="#Reserve" aria-label="Permalink to &quot;Reserving Connections for Client Addresses {#Reserve}&quot;">​</a></h2><p>To prevent various Denial of Service (DoS) attacks you may want to set aside a certain number of available TCP connections for those who connect to your Server from <a href="./">Client IP Addresses</a>.</p><p>If the difference between the maximum number of allowed connections and the number of active connections is equal to or smaller than the specified Reserve value, connections from non-Client IP Addresses are rejected.</p>',7)]))}const v=n(i,[["render",r]]);export{m as __pageData,v as default};
