import{_ as r,a}from"./chunks/NetworkFirewall2.WaeDR2th.js";import{_ as i,c as n,o as l,ag as o,j as e,a as t}from"./chunks/framework.jCcxW76o.js";const b=JSON.parse('{"title":"Network","description":"","frontmatter":{"legacyLink":"Network.html"},"headers":[],"relativePath":"admin/network/index.md","filePath":"admin/network/index.md"}'),d={name:"admin/network/index.md"};function c(p,s,h,u,m,v){return l(),n("div",null,s[0]||(s[0]=[o(`<h1 id="network" tabindex="-1">Network <a class="header-anchor" href="#network" aria-label="Permalink to &quot;Network&quot;">​</a></h1><p>CommuniGate Pro is a network server, and it needs to know the configuration of your network. Most of the settings are retrieved automatically from your OS setup, but you may want to change these settings and/or specify additional settings.</p><p>This section describes the CommuniGate Pro network settings.</p><h2 id="IPLists" tabindex="-1">Network Address Lists <a class="header-anchor" href="#IPLists" aria-label="Permalink to &quot;Network Address Lists {#IPLists}&quot;">​</a></h2><p>Many CommuniGate Pro components use Network (IP) Address lists. These lists are specify <a href="./../sysadmin/Protection.html">Client</a> and <a href="./../sysadmin/Protection.html">Blacklisted</a> addresses, access restrictions for <a href="./Listener.html">Listeners</a>, etc.</p><p>This section describes the Network Address List format.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="center"><textarea name="ClientHosts" rows="10" cols="80">10.10.12.24                 ; our back-up
10.10.13.32-10.10.13.191    ; our dial-ups
!10.10.13.100-10.10.13.102  ; excluded addresses
; a comment line
77.177.66.166               ; our other office
64.173.55.160/27            ; 64.173.55.160-64.173.55.191
2001:470:1f01:2565::a:0/125 ; 2001:470:1f01:2565::a:0-2001:470:1f01:2565::a:7</textarea></td></tr></tbody></table></div></form><p>A Network Address List is specified as multi-line text data.</p><p>Each text line should contain one of the following:</p><ul><li>one IP address</li><li>an address range - two IP addresses separated with the minus (<code>-</code>) symbol: a range includes both IP addresses and all addresses between them</li><li>an address and a numeric mask, separated with the slash (<code>/</code>) symbol.<br> The mask value should be between 1 and 32 for IPv4 addresses and between 1 and 128 for IPv6 addresses. It specifies how many higher bits of the specified address are valid. The remaining lower bits of the address must be zero. The range includes all addresses with the specified higher bits.</li></ul><p>The first IP address can be preceded with the exclamation point (<code>!</code>) symbol. In this case the specified IP address or the address range is excluded from the list composed using the preceding lines.</p><p>A comment (separated with the semicolon (<code>;</code>) symbol) the can be placed at the end of a line.<br> Lines starting with the semicolon symbol, and empty lines are comment lines.</p><h2 id="LAN" tabindex="-1">LAN Addresses <a class="header-anchor" href="#LAN" aria-label="Permalink to &quot;LAN Addresses {#LAN}&quot;">​</a></h2><p>If you use CommuniGate Pro in a corporate environment, most of your users will connect to the Server from the corporate LAN(s).</p><p>Use the WebAdmin Interface to specify your LAN Addresses. Open the Network pages in the Settings realm, then open the LAN IPs page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>LAN IP Addresses</b></td></tr><tr><td align="center"><textarea name="LANHosts" rows="10" cols="60">10.0.0.1-10.0.0.255  ; office LAN
10.0.1.12            ; remote office on VPN
10.0.1.15-10.0.1.220 ; DHCP LAN addresses</textarea></td></tr><tr><td align="center">Server LAN IP Address:<select name="LANAddress"><option selected="selected">disabled</option><option>[10.0.0.15]</option><option>[10.0.0.16]</option><option>[127.0.0.1]</option></select></td></tr></tbody></table></div></form><p>The LAN IP Addresses table initially contains the addresses the CommuniGate Pro software retrieved from the Server OS configuration. Correct this list to include all LAN (local networks) the CommuniGate Pro Server needs to serve.<br> The <a href="#IPLists">Network Address Lists</a> section explains the list format.</p><p>Usually, you want all E-mail and Real-Time (VoIP/IM) clients connecting from the LAN addresses to be able to relay E-mails and Signals to any Internet destination. In this case you may want to include the LAN addresses into the <a href="./../sysadmin/Protection.html#ClientFixed">Client IP Addresses</a> list.</p><p>The list of LAN IP Addresses is used to support Real-Time (voice, video, etc.) communications, so the CommuniGate Pro Server knows which addresses are belong to NAT&#39;ed (&quot;local&quot;) addresses, i.e. which addresses cannot be contacted directly from the Internet.</p><p>Use the Server LAN IP Address setting to select the Server own IP Address the Server OS uses to communicate with computers on the LAN.</p><h2 id="Ports" tabindex="-1">Port Allocation <a class="header-anchor" href="#Ports" aria-label="Permalink to &quot;Port Allocation {#Ports}&quot;">​</a></h2><p>CommuniGate Pro can let the OS select &quot;ephemeral ports&quot; for outgoing TCP connections, or it can allocate these ports itself.<br> The ports used for <a href="./../signals/NAT.html#Proxy">Media Proxies</a> and active <a href="./../access/FTP.html">FTP</a> data connections are always allocated by the CommuniGate Pro Server itself.</p><p>Use the WebAdmin Interface to specify the port allocation parameters. Open the Network pages in the Settings realm, then open the LAN IPs page.</p>`,23),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Port Allocation")])]),e("tr",null,[e("td",{align:"right"},"UDP:"),e("td",{nowrap:"nowrap"},[e("input",{name:"UDPPortFrom",value:"62000",size:"5",maxlength:"5",type:"text"}),t(" - "),e("input",{name:"UDPPortTill",value:"62099",size:"5",maxlength:"5",type:"text"})]),e("td",null," "),e("td",null,[e("input",{name:"PortsRoundRobin",value:"1",type:"checkbox"}),t(" Round-Robin Allocation")])]),e("tr",null,[e("td",{align:"right"},"TCP:"),e("td",{nowrap:"nowrap"},[e("input",{name:"TCPPortFrom",value:"62000",size:"5",maxlength:"5",type:"text"}),t(" - "),e("input",{name:"TCPPortTill",value:"62099",size:"5",maxlength:"5",type:"text"})]),e("td",null,[t("Reusage Delay:"),e("select",{class:"popup",name:"TCPTimeWait"},[e("option",{value:"0"},"0 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"30",selected:"selected"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"240"},"4 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"31"},"other")])]),e("td",null,[e("input",{name:"PortsForProxyOnly",value:"1",type:"checkbox"}),t(" Use for Media Proxy only")])])])])])],-1),o(`<ul><li><p><code>UDP</code></p><p>This setting specifies the port number range to be used for UDP proxy operations. If the CommuniGate Pro Server is behind a NAT/Firewall, make sure that all UDP packets received by the NAT/Firewall for these ports are relayed to the CommuniGate Pro Server.</p></li><li><p><code>TCP Ports</code></p><p>This setting specifies the port number range to be used for outgoing TCP connections, including proxy operations. If the CommuniGate Pro server is behind a NAT/Firewall, make sure that all TCP connections received by the NAT/Firewall for these ports are relayed to the CommuniGate Pro Server.</p></li><li><p><code>Round-Robin Allocation</code></p><p>When this option is selected, UDP and TCP ports are allocated evenly using the entire port range.<br> When this option is not selected, UDP and TCP ports are allocated using the first (lowest) available port in the port range.</p></li><li><p><code>Reusage Delay</code></p><p>An explicitly allocated TCP port can be re-used after a pause, which should not be smaller than the OS TCP TIME_WAIT time period. Use this setting to specify the re-usage delay.</p></li><li><p><code>Use for Media Proxy only</code></p><p>When this option is selected, TCP ports are explicitly allocated for TCP media proxy and FTP data channels only.<br> When this option is not selected, TCP ports are explicitly allocated for all outoging TCP connections (SMTP, SMPP, <a href="./../mail/RPOP.html">RPOP</a>, etc.)</p></li></ul><h2 id="Proxy" tabindex="-1">Trusted Proxy Servers Addresses <a class="header-anchor" href="#Proxy" aria-label="Permalink to &quot;Trusted Proxy Servers Addresses {#Proxy}&quot;">​</a></h2><p>You can specify a list of trusted Proxy server addresses.</p><p>Use the WebAdmin Interface to specify the Trusted Proxy Servers Addresses. Open the Network pages in the Settings realm, then open the LAN page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Trusted Proxy servers IP Addresses</b></td></tr><tr><td align="center"><textarea name="LANHosts" rows="10" cols="60">10.18.254.254
172.16.3.2</textarea></td></tr></tbody></table></div></form><p>If the Proxy server is included in the list of trusted servers, it must send <a href="https://github.com/haproxy/haproxy/blob/master/doc/proxy-protocol.txt" target="_blank" rel="noreferrer">PROXY protocol</a> headers. For the HTTP protocol, the Proxy server can instead send <a href="https://datatracker.ietf.org/doc/html/rfc7239" target="_blank" rel="noreferrer">Forwarded</a> or <a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Forwarded-For" target="_blank" rel="noreferrer">X-Forwarded-For</a> headers. If the server does not receive these headers, the connection will be closed.</p><p>When the server receives a request with <a href="https://github.com/haproxy/haproxy/blob/master/doc/proxy-protocol.txt" target="_blank" rel="noreferrer">PROXY protocol</a> headers or an HTTP request with <a href="https://datatracker.ietf.org/doc/html/rfc7239" target="_blank" rel="noreferrer">Forwarded</a> or <a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Forwarded-For" target="_blank" rel="noreferrer">X-Forwarded-For</a> headers set by the proxy server, it checks whether the IP address of the Proxy server is included in the list of trusted addresses. If the Proxy server is trusted, the server considers the IP address obtained from the <a href="https://github.com/haproxy/haproxy/blob/master/doc/proxy-protocol.txt" target="_blank" rel="noreferrer">PROXY protocol</a> headers or the <a href="https://datatracker.ietf.org/doc/html/rfc7239" target="_blank" rel="noreferrer">Forwarded</a> or <a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Forwarded-For" target="_blank" rel="noreferrer">X-Forwarded-For</a> headers as the client&#39;s original address. Otherwise, the IP address from the headers is ignored.</p><p>For the administrator interface to function correctly, the HTTP Proxy server must include the port number in the HTTP Host header where the Proxy server accepts connections to the administrator interface. For example: Host: myhost:8010.</p><p>In a <a href="./../cluster/">Cluster</a> environment, both the Server-wide or Cluster-wide Trusted Proxy servers list are checked.</p><h2 id="NATed" tabindex="-1">NATed Addresses <a class="header-anchor" href="#NATed" aria-label="Permalink to &quot;NATed Addresses {#NATed}&quot;">​</a></h2><p>CommuniGate Pro can provide <a href="./../signals/SIP.html">SIP</a> and <a href="./../access/XIMSS.html">XIMSS</a> signaling, and media communications for remote clients located behind NAT devices, implementing the <em>far-end NAT traversal</em> functionality.</p><p>See the <a href="./../signals/NAT.html">NAT</a> section for more details.</p><h2 id="WAN" tabindex="-1">NAT/Firewall Parameters <a class="header-anchor" href="#WAN" aria-label="Permalink to &quot;NAT/Firewall Parameters {#WAN}&quot;">​</a></h2><p>There are two main types of LAN installations:</p><ul><li>your CommuniGate Pro Server is installed behind a NAT/Firewall device;<br> or</li><li>your CommuniGate Pro Server has at least two network interfaces, one connected to the LAN, and one - to the Internet (WAN).</li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Local NAT/Firewall/Load Balancer</b></td></tr><tr><td align="center">WAN IPv4 Address: <input type="text" name="WANAddress" value="64.173.55.161" size="15" maxlength="20"></td><td align="center">WAN IPv6 Address: <input type="text" name="WAN6Address" value="2001:470:1f01:2565::a:7" size="30" maxlength="20"></td></tr></tbody></table></div></form><ul><li><p><code>WAN IPv4 Address</code></p><p>If your CommuniGate Pro Server has several network interfaces, some connecting it to the LAN, and some - to the WAN (Internet), use this setting to specify the IP address the Server OS uses by default when connecting to remote hosts over the Internet:</p><p><img src="`+r+'" alt="Network Firewall 1"></p><p>If your CommuniGate Pro Server is installed on a LAN behind a NAT/Firewall, the NAT/Firewall device should be configured to relay all connections on its communication (POP, SMTP, SIP, XMPP, etc.) ports to the CommuniGate Pro Server LAN address. Use this setting to specify the IP address your NAT/Firewall &quot;relays&quot; to CommuniGate Pro.</p><p>For example, if your CommuniGate Pro Server has the 10.0.1.12 IP address on your LAN, and the NAT/Firewall relays all incoming connections coming to the 77.77.77.77 IP address to the 10.0.1.12 address, specify the 77.77.77.77 IP address in this setting:</p><p><img src="'+a+'" alt="Network Firewall 2"></p></li><li><p><code>WAN IPv6 Address</code></p><p>If your CommuniGate Pro Server is connected to the IPv6 network, specify the Server IP address the Server OS uses by default to connect to remote hosts over the IPv6 Internet.</p></li></ul><h2 id="DNR" tabindex="-1">Domain Name Resolver (DNR) <a class="header-anchor" href="#DNR" aria-label="Permalink to &quot;Domain Name Resolver (DNR) {#DNR}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the Resolver settings. Open the Network pages in the Settings realm, and follow the DNS Resolver link.</p>',19),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Domain Name Resolver")])]),e("tr",null,[e("td",{align:"right"},"Log Level:"),e("td",null,[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right"},"Concurrent Requests:"),e("td",null,[e("select",{name:"MaxRequests"},[e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"15"},"15"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250"),e("option",{value:"300"},"300"),e("option",{value:"11"},"other")])])]),e("tr",null,[e("td",{align:"right"},"DNS Servers Addresses:"),e("td",null,[e("select",{name:"DNRAddressesSource"},[e("option",{value:"0",selected:"selected"},"OS-specified"),e("option",{value:"1"},"Custom")]),t(),e("input",{name:"DNSServers",value:"[209.1.58.247], [206.40.74.1]",size:"40",maxlength:"1000",type:"text"})]),e("td",{align:"right"},"Source IP Address:"),e("td",{nowrap:"nowrap"},[e("select",{name:"BindAddress"},[e("option",{value:"[0.0.0.0]",selected:"selected"},"OS default"),e("option",{value:"[192.168.1.152]"},"[192.168.1.152]"),e("option",{value:"[127.0.0.1]"},"[127.0.0.1]")]),t(":"),e("input",{type:"text",name:"BindPort",value:"",size:"5",maxlength:"99"})])]),e("tr",null,[e("td",{align:"RIGHT"},"Balance Server Load:"),e("td",null,[e("select",{name:"BalanceLoad"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])]),e("td",{align:"RIGHT"},"Use Supplementary Responses:"),e("td",null,[e("select",{name:"UseSupplRecords"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])])]),e("tr",null,[e("td",{align:"right"},"Initial Time-out:"),e("td",null,[e("select",{name:"InitialWait"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"4"},"4 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"6"},"6 sec"),e("option",{value:"7",selected:"selected"},"7 sec"),e("option",{value:"8"},"8 sec"),e("option",{value:"9"},"9 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"12"},"12 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"25"},"25 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"45"},"45 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"11"},"other")])]),e("td",{align:"right"},"Retry Limit:"),e("td",null,[e("select",{name:"Retries"},[e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4",selected:"selected"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"11"},"other")])])])])])])],-1),o('<ul><li><p><code>Log Level</code></p><p>Use this setting to specify what kind of information the Domain Name Resolver should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> levels. In the later case you will see the information about all failed DNS lookups. If you use the RBL services, you may see a lot of failed lookups in the Log. When you experience problems with the Domain Name Resolver, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.<br> The Resolver records in the System Log are marked with the <code>DNR</code> tag.</p></li><li><p><code>Concurrent Requests</code></p><p>This setting limits the number of concurrent requests the Resolver can send to Domain Name Servers. On a heavily-loaded Mail or Signal relay processing many thousand requests per second, this parameter should be selected after some testing: older DNS servers may crash if requested to process too many concurrent requests.</p></li><li><p><code>DNS Addresses</code></p><p>This setting specifies how the CommuniGate Pro Server selects the DNS servers to use. If the <code>OS-specified</code> option is selected, the Server reads the DNS server addresses from the Server host OS. To force the server to re-read those addresses, click the Refresh button on the General page in the Settings section.<br> If the <code>Custom</code> option is selected, the CommuniGate Pro Server will use the DNS servers addresses listed in the text field next to this pop-up menu.<br> If no DNS server address is specified, the CommuniGate Pro Server uses the 127.0.0.1 address, trying to connect to a DNS server that can be running on the same computer as the CommuniGate Pro Server.</p></li><li><p><code>Balance Server Load</code></p><p>If this option is disabled, then the initial request is always sent to the first DNS server in the list, and if there is no response from that server, the request is resent to the second DNS server, etc.<br> If this option is enabled, then initial requests are sent to different DNS servers: the first initial request is sent to the first DNS server (and if it fails - the request is resent to the second DNS server), the second initial request is sent to the second DNS server (and if it fails - the request is resent to the third DNS server), etc.<br> Enable this option if your Server performs a lot of DNR operations and it can use several equally effective DNS servers.</p></li><li><p><code>Use Supplementary Responses</code></p><p>If this option is enabled, then &quot;supplementary&quot; records in MX and SRV requests are processed. These records contain the IP addresses (A and AAAA records) for the domain names listed in an MX or SRV response, so no additional DNR request is needed to retrieve these IP addresses.</p></li><li><p><code>Initial Time-out</code></p><p>The Domain Name System uses the connectionless UDP protocol by default, and if there any network trouble, a UDP request or response can be lost (while the TCP protocol automatically resends lost packets).<br> The Domain Name Resolver waits for a response from a DNS server for the period of time specified with this option.<br> If a response is not received, the Resolver resends the request, and waits twice longer, if it times out again, it can resend the request again and wait three times longer.<br> If you have several Domain Name Servers specified, each time the resolver needs to repeat a request, it sends it to the next DNS server in the list.</p></li><li><p><code>Retry Limit</code></p><p>This option specifies how many time the Resolver should re-send the same request if it has not received any response from a DNS server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a request is an <a href="./../sysadmin/Protection.html">RBL</a> request, the Resolver sends the same request not more than twice, and both times it uses the same (Initial) response time-out.</p></div></li><li><p><code>Source IP Address</code></p><p>This option selects the <em>source network address and port</em> for UDP DNR requests send. If an IP address and/or a port is not specified, the address and/or port is selected using the Server host OS.</p></li></ul><p>The Domain Name Resolver uses TCP connections if a DNS server sent a UDP response with the &quot;Truncated&quot; flag set. This feature allows the Resolver to retrieve very large records from DNS servers.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Dummy IP Addresses</b></td></tr><tr><td align="center"><textarea name="DNRDummyIPs" cols="50" rows="3">64.94.110.11 ; *.com, *.net &quot;wildcard&quot;</textarea></td></tr></tbody></table></div></form><ul><li><p><code>Dummy IP Addresses</code></p><p>This <a href="#IPLists">Address List</a> setting allows you to specify network (IP) addresses that should be considered as &quot;non-existent&quot;.</p><p>Some DNS authorities may choose to &quot;map&quot; all non-existent names within their domains to some special IP address(es).</p><p>When a domain name is resolved into IP addresses, the Resolver checks the first address. If this address is listed in the Dummy IP Addresses list, the Resolver returns the &quot;unknown host/domain name&quot; error code.</p></li></ul><p>The Domain Name Resolver caches responses to SRV-type DNS requests.</p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Cache</b></td></tr><tr><td align="RIGHT">Limit:</td><td><select name="CacheSize"><option value="1">1</option><option value="3">3</option><option value="10">10</option><option value="30" selected="selected">30</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="31">other</option></select></td><td align="RIGHT">Cache Negative:</td><td><select name="CacheNegative"><option value="1">1 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="45">45 sec</option><option value="60">60 sec</option><option value="180">3 min</option><option value="300">5 min</option><option value="600" selected="selected">10 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="601">other</option></select></td></tr></tbody></table></div><ul><li><p><code>Limit</code></p><p>The maximum Cache size. When the number of items in the cache exceeds this limit, the oldest unused records are being removed from the cache.</p></li><li><p><code>Cache Negative</code></p><p>Use this setting to specify for how long negative (failure) DNS responses should be cached.</p></li></ul><p>The Tester allows to test responses to some sorts of DNS requests.</p>',8),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{width:"50%",nowrap:"nowrap",align:"center"},[t("Test Address: "),e("input",{name:"TestAddress",value:"communigatepro.ru",size:"35",maxlength:"500",type:"text"}),t(),e("input",{name:"Test",value:"Test",class:"button",type:"submit"}),e("select",null,[e("option",{selected:"selected"},"A"),e("option",null,"AAAA"),t(),e("option",null,"MX"),e("option",null,"PTR"),e("option",null,"TXT")])])]),e("tr",null,[e("td",null,[e("textarea",{style:{width:"99%"},rows:"5",readonly:""},`communigatepro.ru
[0.0.0.0]:56848 -> UDP:[8.8.8.8]:53
48ms
[176.99.14.206]`)])])])])],-1),o(`<p>The Tester can be used to check:</p><ul><li>the true domain name in Punycode, if the domain name contains International characters</li><li>the Source and the target DNS Server IP addresses, and if the <code>Balance Server Load</code> setting works</li><li>the response time</li><li>the returned result</li><li>errors, if any.</li></ul><p>Unlike the real Resolver the Tester tries only one time ignoring the <code>Retry Limit</code> setting.</p><h2 id="IPv6" tabindex="-1">IPv6 Support <a class="header-anchor" href="#IPv6" aria-label="Permalink to &quot;IPv6 Support {#IPv6}&quot;">​</a></h2><p>The CommuniGate Pro Server provides full support for both IPv4 and IPv6 network protocols for the following Server Operating Systems:</p><ul><li>Linux</li><li>FreeBSD</li><li>MacOS X</li><li>Windows (Vista and newer)</li><li>Solaris</li><li>AIX</li></ul><p>If the Server runs on a platform with IPv6 support, and it detects any local IPv6 address, it assumes that the IPv6 networking is enabled.<br> In this case, the Server creates all network sockets as IPv6 sockets. These sockets communicate with IPv4 systems using the <em>IPv4-mapped IPv6 address</em> method.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The <em>IPv4-mapped IPv6 address</em> method is disabled by default in FreeBSD system kernels. Use the <code>sysctl -w net.inet6.ip6.v6only=0</code> command in your OS startup scripts to enable this method.</p></div><p>You can explicitly instruct the Server to switch IPv6 networking support on or off by using the <code>--IPv6</code> <a href="./../sysadmin/#Options">Command Line Option</a>:</p><ul><li><code>--IPv6 NO</code> switches the IPv6 support off, even if some local IPv6 addresses are detected.</li><li><code>--IPv6 YES</code> switches the IPv6 support on, even if no local IPv6 local address is detected, but the Server OS supports IPv6 networking.</li></ul><h2 id="Denied" tabindex="-1">Denied Addresses <a class="header-anchor" href="#Denied" aria-label="Permalink to &quot;Denied Addresses {#Denied}&quot;">​</a></h2><p>You may want to deny access to your Server for all incoming TCP connections and UDP packets coming from certain IP Addresses.</p><p>Use the WebAdmin Interface to specify the Denied Addresses. Open the Network pages in the Settings realm, then open the Blacklisted IPs page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Denied IP Addresses</b></td></tr><tr><td align="center"><textarea name="DenyHosts" rows="10" cols="60">10.18.0.0-10.18.255.255
172.16.3.2
192.168.0.0/16</textarea></td></tr></tbody></table></div></form><p>The TCP and UDP <a href="./Listener.html">Listeners</a> consult with this IP Address list before they check their own restrictions settings.</p><p>In a <a href="./../cluster/">Cluster</a> environment, connections and packets from an IP Address are denied if that Address is included into either Server-wide or Cluster-wide Denied IP Addresses list.</p><h2 id="Debug" tabindex="-1">Debug Addresses <a class="header-anchor" href="#Debug" aria-label="Permalink to &quot;Debug Addresses {#Debug}&quot;">​</a></h2><p>You may need to obtain a detailed <a href="./../sysadmin/Logs.html">Log</a> of all communications with certain clients or remote servers.</p><p>Use the WebAdmin Interface to specify the Debug Addresses. Open the Network pages in the Settings realm, then open the Debug IPs page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Debug IP Addresses</b></td></tr><tr><td align="center"><textarea name="LANHosts" rows="10" cols="60">10.18.0.0-10.18.255.255
172.16.3.2
192.168.0.0/16</textarea></td></tr></tbody></table></div></form><p>When the Server:</p><ul><li>accepts a TCP connection from an address in this list</li><li>opens a TCP connection to an address in this list</li><li>receives a UDP packet from an address in this list</li><li>sends a UDP packet to an address in this list</li></ul><p>the protocol Log Level for that connection or packet is set to All Info.</p><p>In a <a href="./../cluster/">Cluster</a> environment, both the Server-wide or Cluster-wide Debug Addresses lists are checked.</p>`,24)]))}const g=i(d,[["render",c]]);export{b as __pageData,g as default};
