import{_ as l}from"./chunks/DASettings.B6nCiTNJ.js";import{_ as s,C as c,c as r,o as u,ag as i,j as e,a as o,G as a}from"./chunks/framework.jCcxW76o.js";const I=JSON.parse('{"title":"Accounts","description":"","frontmatter":{"legacyLink":"Accounts.html"},"headers":[],"relativePath":"admin/objects/Accounts.md","filePath":"admin/objects/Accounts.md"}'),d={name:"admin/objects/Accounts.md"},p={action:"Null.html"},h={class:"settingsBox"},m={width:"100%"};function v(g,t,f,b,y,w){const n=c("tt");return u(),r("div",null,[t[19]||(t[19]=i('<h1 id="accounts" tabindex="-1">Accounts <a class="header-anchor" href="#accounts" aria-label="Permalink to &quot;Accounts&quot;">​</a></h1><p>An Account is the basic <em>service unit</em>: every user served with a CommuniGate Pro Server should have an Account on that Server.</p><p>Each Account is protected with a password, so only the Account owner (and, optionally, System and Domain Administrators) can have access to Account data.</p><p>The <code>postmaster</code> Account is automatically created in the Main Domain. The Master (unlimited) access right is granted to that Account.</p><p>The <code>pbx</code> Account is automatically created in the Main Domain. See the <a href="./PBX.html">PBX</a> section for more details.</p><h2 id="Create" tabindex="-1">Creating a New Account <a class="header-anchor" href="#Create" aria-label="Permalink to &quot;Creating a New Account {#Create}&quot;">​</a></h2><p>To create a new Account, type a new Account name into the field on the right side of the Create Account button and click that button.<br> The selected Account name should meet the <a href="./Domains.html#Provision">Domain Object</a> name restrictions.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="right" width="30%"><input name="Create" value="Create Account" class="button" type="reset"></td><td><input name="NewName" value="jsmith" size="20" maxlength="127" type="text"></td><td> </td><td class="arrow"><a href="#Template">Template</a></td></tr><tr><td align="right"><select name="NewType"><option value="0" selected="selected">Multi-Mailbox</option><option value="4">A-Grade</option><option value="4">B-Grade</option></select></td><td> </td><td> </td></tr></tbody></table></div></form><p>Use the pop-up menu to specify the Account type:</p><ul><li><p><code>MultiMailbox</code></p><p>A folder-type Account that can contain several Mailboxes of various types, as well as File Storage. The INBOX Mailbox is automatically created within the new Account. All incoming E-mails are stored in the INBOX Mailbox by default. The user can create additional Mailboxes using any IMAP client or AirSync client software, or using the CommuniGate Pro Web E-mail Interface.</p></li><li><p><code>A-Grade</code>, <code>B-Grade</code>, ...</p><p>Same as <code>MultiMailbox</code>, but depending on the license type some addtional <a href="./Accounts.html#Services">Services</a> may be available to the Account.</p></li></ul><p>By default, the Account name becomes the person&#39;s E-mail name, so Account names should contain only letters, digits, dash and point (dot) symbol - some mail systems cannot send mail to E-mail addresses containing other symbols.</p><p>Click the Create Account button. When a new Account is created, its name appears in the Domain Objects list. The Server automatically displays the <a href="#Settings">Settings page</a> for the new Account.</p><p>The Settings of a newly created Account are automatically set to the <a href="#Template">Account Template</a> values.</p><p>You can create several Accounts at once, by preparing an Account List file and using the <a href="#Loader">Import</a> option.</p><p>If you have the Domain Administrator (not the Server Administrator) access rights, you need to be granted the <a href="./../sysadmin/#DomainPrivs"><code>CanCreateAccounts</code></a> access right.</p><h2 id="Settings" tabindex="-1">Specifying Account Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;Specifying Account Settings {#Settings}&quot;">​</a></h2><p>To specify Account Settings, click the Account name link in the Accounts list. The Account Settings page appears.</p>',17)),e("form",p,[e("div",h,[e("table",m,[e("tbody",null,[t[12]||(t[12]=e("tr",null,[e("td",{align:"right"},"Created: "),e("td",null,"12-May-2007"),e("td",{class:"arrow",align:"right"},[e("a",{href:"#"},"Access Rights"),o(" ")])],-1)),t[13]||(t[13]=e("tr",null,[e("td",{align:"right",nowrap:"nowrap",width:"25%"},"Real Name: "),e("td",null,[e("input",{name:"RealName",value:"John F. Smith",size:"50",maxlength:"255",type:"text"})]),e("td",null," ")],-1)),t[14]||(t[14]=e("tr",null,[e("td",{align:"right"},"Title: "),e("td",null,[e("input",{name:"Title",value:"",size:"50",maxlength:"255",type:"text"})])],-1)),t[15]||(t[15]=e("tr",null,[e("td",{align:"right"},"City: "),e("td",null,[e("input",{name:"City",value:"Moscow",size:"50",maxlength:"255",type:"text"})])],-1)),e("tr",null,[t[2]||(t[2]=e("td",{align:"right"},"Services: ",-1)),e("td",null,[t[0]||(t[0]=e("input",{name:"Services",value:"",size:"50",maxlength:"255",type:"text"},null,-1)),t[1]||(t[1]=o(" ")),a(n)])]),e("tr",null,[t[5]||(t[5]=e("td",{align:"right"},"Organization: ",-1)),e("td",null,[t[3]||(t[3]=e("input",{name:"Organization",value:"ACME Industries, Inc.",size:"50",maxlength:"255",type:"text"},null,-1)),t[4]||(t[4]=o(" ")),a(n)])]),e("tr",null,[t[8]||(t[8]=e("td",{align:"right"},"Space Test: ",-1)),e("td",null,[t[6]||(t[6]=e("input",{name:"Space Test",value:"",size:"50",maxlength:"255",type:"text"},null,-1)),t[7]||(t[7]=o(" ")),a(n)])]),t[16]||(t[16]=e("tr",{valign:"bottom"},[e("td",{align:"right",nowrap:"nowrap"},[o("CommuniGate  "),e("br"),o("Password: ")]),e("td",null,[e("input",{name:"Password",value:"********",size:"50",maxlength:"255",type:"password"})]),e("td",null," ")],-1)),t[17]||(t[17]=e("tr",null,[e("td",{align:"right"},"FirstName: "),e("td",null,[e("input",{name:"FirstName",value:"John F.",size:"50",maxlength:"255",type:"text"}),o(" ")])],-1)),t[18]||(t[18]=e("tr",null,[e("td",{align:"right"},"FamilyName: "),e("td",null,[e("input",{name:"FamilyName",value:"Smith",size:"50",maxlength:"255",type:"text"}),o(" ")])],-1)),e("tr",null,[t[11]||(t[11]=e("td",{align:"right"},"department: ",-1)),e("td",null,[t[9]||(t[9]=e("input",{name:"department",value:"",size:"50",maxlength:"255",type:"text"},null,-1)),t[10]||(t[10]=o(" ")),a(n)])])])])])]),t[20]||(t[20]=i('<ul><li><p><code>Real Name</code></p><p>This field is used to specify the real-life user name. The Server uses this information to compose the default &#39;From&#39; address in Web Mailer.</p></li><li><p>additional <em>System</em> fields</p><p>If the Server <a href="./../directory/CentralDir.html#CustomSettings">Directory Integration</a> settings contain some System Custom Account Setting fields, these fields appear in this panel where they can be set and modified.</p></li><li><p><code>CommuniGate Password</code></p><p>The Account password. When authenticating a user, the Server can check either this password or OS password, or both (see below).</p></li><li><p>additional <em>Public Info</em> fields</p><p>If the Server <a href="./../directory/CentralDir.html#CustomSettings">Directory Integration</a> settings contain some Public Info Custom Account Setting fields, these fields appear in this panel where they can be set and modified.</p></li></ul><p>The modified values of the Real Name and additional fields are updated in the Directory if the Domain has the <a href="./Domains.html#Central">Directory Integration</a> setting set to Keep In Sync.</p><p>After the Account Settings are modified, click the Update button.</p><h3 id="Passwords" tabindex="-1">Authentication Methods <a class="header-anchor" href="#Passwords" aria-label="Permalink to &quot;Authentication Methods {#Passwords}&quot;">​</a></h3><p>Use the Authentication panel to specify the Account authentication methods.</p>',5)),t[21]||(t[21]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("table",{border:"0",cellpadding:"0",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("b",null,"Authentication")]),e("td",{align:"right",nowrap:"nowrap",width:"30%"},[e("b",null,"Secure Only:"),o(),e("select",{name:"RequireAPOP"},[e("option",{value:"-1",selected:"selected"},"default(No)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes"),e("option",{value:"2"},"Require TLS")])])])])])])]),e("tr",{valign:"top"},[e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",width:"45%"},"CommuniGate Password:"),e("td",null,[e("select",{name:"UseAppPassword"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Password Modification:"),e("td",null,[e("select",{name:"PWDAllowed"},[e("option",{value:"-1"},"default(prohibit)"),e("option",{value:"0"},"prohibit"),e("option",{value:"1",selected:"selected"},"allow")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Minimal Password Length:"),e("td",null,[e("select",{name:"PasswordMinLength"},[e("option",{value:"-2",selected:"selected"},"default(6)"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"10"),e("option",{value:"12"},"12"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"11"},"other")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Password Complexity:"),e("td",null,[e("select",{name:"PasswordComplexity"},[e("option",{value:"-1",selected:"selected"},"default(any)"),e("option",{value:"0"},"any"),e("option",{value:"1"},"mixed case letters"),e("option",{value:"2"},"letters and digits"),e("option",{value:"3"},"special")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Password Encryption:"),e("td",null,[e("select",{name:"PasswordEncryption"},[e("option",{value:"-1",selected:"selected"},"default(A-crpt)"),e("option",{value:"0"},"clear"),e("option",{value:"1"},"A-crpt"),e("option",{value:"2"},"U-crpt"),e("option",{value:"3"},"UB-crpt")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Ask to change Password every:"),e("td",null,[e("select",{class:"popup",name:"PasswordChangeInterval"},[e("option",{value:"-2"},"default(Never)"),e("option",{value:"-1"},"Never"),e("option",{value:"1"},"7 day(s)"),e("option",{selected:"selected"},"10 day(s)"),e("option",null,"2 week(s)"),e("option",null,"3 week(s)"),e("option",null,"4 week(s)"),e("option",null,"60 day(s)"),e("option",null,"90 day(s)"),e("option",null,"120 day(s)"),e("option",null,"180 day(s)"),e("option",null,"365 day(s)"),e("option",null,"730 day(s)"),e("option",null,"other")]),o(" on Next Login: "),e("label",{class:"checkboxBox"},[e("input",{type:"checkbox",name:"PasswordChangeForced",value:"1"}),e("span",{class:"pseudocheckbox"}," ")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Prohibit reusing previous passwords:"),e("td",null,[e("select",{class:"popup",name:"PreventPreviousPasswordsReuse"},[e("option",{value:"-1"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",null,"Enabled")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Number of previous forbidden passwords:"),e("td",null,[e("select",{class:"popup",name:"PreviousPasswordsToBlock"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Delete previous passwords after:"),e("td",null,[e("select",{class:"popup",name:"DeletePasswordHistoryAfter"},[e("option",{value:"-3"},"default(365 day(s))"),e("option",{value:"-2"},"Never"),e("option",{value:"90"},"90 day(s)"),e("option",{value:"180"},"180 day(s)"),e("option",{value:"365"},"365 day(s)"),e("option",{value:"730"},"730 day(s)"),e("option",{value:"-1"},"other")])])]),e("tr",null,[e("td",null," ")]),e("tr",null,[e("td",{align:"right",width:"45%"},"Log Login/Logout:"),e("td",null,[e("select",{name:"LogLogin"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Password Recovery:"),e("td",null,[e("select",{name:"PasswordRecovery"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])]),e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",width:"45%"},"OS UserName:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"OSUserName-Def",value:"1",checked:"checked",type:"radio"})]),e("td",{class:"settingFixed"},"*")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"OSUserName-Def",value:"0",type:"radio"})]),e("td",null,[e("input",{name:"OSUserName",size:"10",maxlength:"255",value:""})])])])])])]),e("tr",null,[e("td",{align:"right",width:"45%"},"OS Password:"),e("td",null,[e("select",{name:"UseSysPassword"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{width:"45%",align:"right"},"Authentication URI:"),e("td",null,[e("table",{cellspacing:"0",cellpadding:"1",border:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"AuthURI-Def",value:"1",checked:"checked",type:"radio"})]),e("td",{class:"settingFixed"},"ldap://10.0.1.2:389/uid=*,dc=company,dc=com ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"AuthURI-Def",value:"0",type:"radio"})]),e("td",null,[e("input",{name:"AuthURI",size:"50",maxlength:"10000",value:""})])])])])])]),e("tr",null,[e("td",{align:"right",width:"45%"},"External Password:"),e("td",null,[e("select",{name:"UseExtPassword"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"right",width:"45%"},"Cache External Password for:"),e("td",null,[e("select",{name:"ExtPassTTL"},[e("option",{value:"0"},"0 сек"),e("option",{value:"1"},"30 сек"),e("option",{value:"2"},"60 сек"),e("option",{value:"3"},"5 мин"),e("option",{value:"4"},"10 мин"),e("option",{value:"5"},"30 мин"),e("option",{value:"6"},"60 мин"),e("option",{value:"7"},"2 час."),e("option",{value:"8"},"3 час."),e("option",{value:"9"},"6 час."),e("option",{value:"10"},"12 час."),e("option",{value:"11"},"24 час."),e("option",{value:"12"},"другое")])])]),e("tr",null,[e("td",{align:"right",width:"45%"},"Detailed Logging:"),e("td",null,[e("select",{name:"LogProtocols"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])])]),e("tr",{valign:"top"},[e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",width:"45%"},"Kerberos Login:"),e("td",null,[e("select",{name:"UseKerberosPassword"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"right",width:"45%"},"Certificate Login:"),e("td",null,[e("select",{name:"UseCertificateAuth"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])]),e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Alt RADIUS Password:"),e("td",null,[e("input",{type:"password",name:"RADIUSPassword",value:"********",size:"15",maxlength:"255"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Alt SIP Password:"),e("td",null,[e("input",{type:"password",name:"SIPPassword",value:"",size:"15",maxlength:"255"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Directory Integration:"),e("td",null,[e("select",{name:"CentralDirectory"},[e("option",{value:"-1",selected:"selected"},"default(Keep In Sync)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Keep In Sync")])])])])])])]),e("tr",null,[e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"RIGHT",width:"45%"},"Failed Logins Limit:"),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-FailedLoginFlow"},[e("option",{value:"-2"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"31"},"other")]),o(" in "),e("select",{class:"popup",name:"period-FailedLoginFlow"},[e("option",{value:"-2"},"default(60 sec)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20",selected:"selected"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"21"},"other")])])])])])]),e("td",null,[e("table",{border:"0",cellpadding:"3",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"RIGHT",width:"45%"},"Last Failed Login:"),e("td",null,[e("div",{class:"settingFixed"},"05-Aug [64.173.55.170]")]),e("td",null,[e("input",{type:"reset",value:"Clear",class:"button"})])])])])])])])])])],-1)),t[22]||(t[22]=i('<p>To log into the CommuniGate Pro Account, a user (a client application) supplies a password, directly, or via some secure authentication protocol. For successful authentication:</p><ul><li>the supplied password should match the CommuniGate Password stored in the Account settings (see above), or</li><li>the supplied password should match the password of the &quot;mapped&quot; Server OS account (see below), or</li><li>the supplied password should be verified using Authentication URI (see below), or</li><li>the supplied password should be verified using an External Authenticator program.</li></ul><p>Besides the password-based authentication methods, CommuniGate Pro Server can authenticate its Account users using other methods, such as Kerberos and TLS Certificates.<br> See the <a href="./../sysadmin/Security.html">Security</a> section for the details.</p><ul><li><p><code>CommuniGate Password</code></p><p>CommuniGate Pro Account internal password can be stored as an Account setting (see above).<br> The following settings control how this internal CommuniGate password is used.</p><ul><li><p><code>CommuniGate Password</code></p><p>This setting tells the Server if it should compare the user-provided password and the internal CommuniGate Password.</p></li><li><p><code>Password Modification</code></p><p>This setting controls if the user can modify the CommuniGate Password via the <a href="./../services/PWD.html">PWD module</a>, the <a href="./WebMail.html#Password">WebUser Interface</a>, <a href="./../signals/XMPP.html">XMPP</a> module, or the <a href="./../../development/XMLAPI.html">XIMSS</a> Interface.</p></li><li><p><code>Password Complexity</code></p><p>This setting specifies how complex the user-supplied CommuniGate Password should be.</p><ul><li><p><code>any</code></p><p>no restriction</p></li><li><p><code>mixed case letters</code></p><p>the password must contain both upper-case and lower-case letters</p></li><li><p><code>letters and digits</code></p><p>the password must contain both upper-case and lower-case letters, and at least one decimal digit.</p></li><li><p><code>special</code></p><p>the password complexity is verified by <code>passwordcomplexity.scgp</code> <a href="./../../development/CGPL.html#SyncScripts">Synchronous Script</a> with customizeable code.</p></li></ul></li><li><p><code>Password Encryption</code></p><p>This setting specifies how the Server should store the CommuniGate Password. If the <code>clear</code> option is selected, the password is stored as a clear-text string. All other options specify various encryption methods. In most cases, you will not specify this setting on a per-account basis, but rather using the Domain Account Defaults or global Account Defaults.<br> The <code>U-crpt</code> password encryption is used for compatibility with the Unix &quot;crypt&quot; encryption method and it should be used for migrating users from other servers only. The U-crtp-encrypted passwords can not be used for Secure (SASL) Authentication methods.<br> See the <a href="./../sysadmin/Security.html">Security section</a> for the details.</p></li><li><p><code>Ask to change Password every</code></p><p>This setting specifies how often the Server will ask the user to change the password.<br> User will be asked to change the password on login to the Account via <a href="./../access/WebUser.html">WebUser Interface</a> or Pronto client.</p></li><li><p><code>on Next Login</code></p><p>This option forces the Server to ask the user to change the password on next login to the Account via <a href="./../access/WebUser.html">WebUser Interface</a> or Pronto client.</p></li><li><p><code>Prohibit reusing previous passwords</code></p><p>This setting determines whether the server stores information about previously used user passwords. If this setting is enabled, you can configure <code>Number of previous forbidden passwords</code> and the retention period of information about previously used passwords <code>Delete Password History After</code>.</p></li><li><p><code>Alt RADIUS Password</code>, <code>Alt SIP Password</code></p><p>These alternative passwords (if set) are used for <a href="./../services/RADIUS.html#AUTH">RADIUS</a> and <a href="./../signals/SIP.html#AUTH">SIP</a> authentication operations.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When you set new values for these options, they are stored using the current <code>Password Encryption</code> method.</p></div></li><li><p><code>Password Recovery</code></p><p>This setting controls if the user can use the <a href="./WebMail.html#Password">WebUser Interface</a> or the <a href="./../../development/XMLAPI.html">XIMSS</a> Interface to ask the Server to send the CommuniGate Password to the &quot;recovery E-mail&quot; address.</p></li></ul></li><li><p><code>Server OS Integration</code></p><p>CommuniGate Pro Accounts can be &quot;mapped&quot; onto the accounts (registered users) of the Server OS. When a CommuniGate Pro user is being authenticated using a Server OS password, or when a separate process (program) should be launched on the user behalf, the CommuniGate Pro Server constructs an OS <em>username</em> (OS account name) to be used for that CommuniGate Pro user (Account).</p><ul><li><p><code>OS UserName</code></p><p>This setting specifies how to compose the Server OS <em>username</em>. The asterisk (<code>*</code>) symbol is substituted with the CommuniGate Pro Account name. If this setting contains just one symbol - the asterisk symbol, then the CommuniGate Pro Account is &quot;mapped&quot; onto the OS account with the same name: when the CommuniGate Pro Server checks the OS password for the Account <code>jmsith</code>, it checks if the specified password can be used to log into the OS account <code>jsmith</code>.</p><p>If the setting contains <code>*.dj</code>, the OS username for the CommuniGate Pro Account <code>jsmith</code> is <code>jsmith.dj</code> - and the <code>jsmith.dj</code> name is used for all OS-level operations initiated on behalf of the CommuniGate Pro Account <code>jsmith</code>.</p></li><li><p><code>OS Password</code></p><p>If this option is enabled, the Account user can log in using the password set in the Server OS registration information for this user.</p></li></ul></li><li><p><code>Other Login Methods</code></p><p>CommuniGate Pro Accounts users can use other methods to log into their Accounts.</p><ul><li><p><code>Authentication URI</code></p><p>An External Resource can be used for authentication.<br> The URI (Uniform Resource Identifier) is of the form <code>schema://address[:port]/parameters</code></p><p>Currently only the <code>ldap</code> and <code>ldaps</code> schemas are supported.<br> See the <a href="./../sysadmin/Security.html#LDAPURI">Security section</a> for the details.</p></li><li><p><code>Kerberos Login</code></p><p>If this option is enabled, the user can log into the Account using the Kerberos Authentication method.<br> See the <a href="./../sysadmin/Security.html#Kerberos">Security section</a> for the details.</p></li><li><p><code>Certificate Login</code></p><p>If this option is enabled, the user can log into the Account using the Client Certificate Authentication method.<br> See the <a href="./../sysadmin/PKI.html#ClientCert">PKI section</a> for the details.</p></li><li><p><code>External Password</code></p><p>If this option is enabled, the user can log into the Account using a password verified with the External Authenticator program.<br> See the <a href="./../sysadmin/Security.html#External">Security section</a> for the details.</p></li></ul></li><li><p><code>Secure Only</code></p><p>This option requires use of <a href="./../sysadmin/Security.html#SASL">secure authentication methods</a> (APOP or non-clear-text SASL methods) with this Account. If a user client application connects to the Server and supplies a password for this Account using an insecure (&quot;clear text&quot;) authentication method, the Server will reject the connection even if the supplied password is correct. Clear-Text password are still accepted if they are passed through a secure (SSL/TLS) communication channel.<br> If the option is set to <code>Require TLS</code> then the login is possible only through connections secured with SSL/TLS.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Since OS passwords can be checked only using the clear-text authentication method, enabling the Secure Only option forces the users employing OS passwords to use secure (SSL/TLS) communication channels.</p></div></li><li><p><code>Detailed Logging</code></p><p>If this option is enabled, access protocol operations (POP, IMAP, ACAP, LDAP, etc.) and mailbox operations for this Account are recorded in the System Log using the All Info Log Level.</p></li><li><p><code>Log Login/Logout</code></p><p>If this option is enabled, login/logout operations for this Account are recorded in the special <a href="./../sysadmin/Logs.html#Login">Supplementary Log</a>.</p></li><li><p><code>Failed Login Limit</code></p><p>This setting specifies a time period and the number of incorrect login attempts that a user or users can make before the Account is disabled for login operations. Account logins are re-enabled after the same period of time.<br> The Server remembers the IP Address of the client that performed the last successful login. Logins from this IP Address are not blocked even when the number of incorrect login attempts exceeds the limit.</p></li><li><p><code>Last Failed Login</code></p><p>This element is displayed when there was a failed attempt to log into this Account. The element displays the attempt date and/or time, and the IP address the attempt was made from.<br> Click the Clear button to remove the Last Failed Login info and to reset the Account Failed Logins counter.</p></li></ul><p>If the CommuniGate Password, OS Password, Kerberos, Certificate, and External Authentication options are disabled, the user will not be able to access the Account.</p><p>Any Authentication setting can be set to the <code>default</code> value, in this case the setting value is taken from the Domain Default Account Settings or the Server-wide or Cluster-wide Default Account Settings.</p><h3 id="X2Auth" tabindex="-1">Two-factor Authentication <a class="header-anchor" href="#X2Auth" aria-label="Permalink to &quot;Two-factor Authentication {#X2Auth}&quot;">​</a></h3><p>CommuniGate Pro supports a customizable set of methods for verifying that password authentication is performed by a user who possesses something that can be contacted separately from the primary authentication channel: for example, a mobile phone ready to receive an SMS, a land-line phone ready to receive a call, an e-mail address on another mail system, and so on. Standalone TOTP-based applications (<a href="http://www.ietf.org/rfc/rfc6238.txt" target="_blank" rel="noreferrer">RFC 6238</a>) are also supported, allowing users to generate one-time passcodes independently, without requiring network access or third-party services.</p><p>Having verified the account&#39;s primary password, CommuniGate Pro uses the <code>x2auth.scgp</code> Synchronous script to deliver to the user an one-time password using either of these additional methods. By default the following methods are available: an e-mail message to the e-mail address, defined for the Forgotten Password Recovery; an SMS or a phone call to the number, defined in the Alternative Contact in the Account Settings. The set of the available methods is determined by the <code>strings.x2auth.data</code> file of the <a href="./../../development/WebApp.html#Strings">Basic Skin Text Dataset</a>. The user then has to enter that one-time password to confirm the possession of the items used for this additional authentication.</p><p>This additional authentication is supported for logins through the <a href="./WebMail.html">WebUser Interface</a> or the <a href="./../../development/XMLAPI.html#X2Auth">XIMSS</a> protocol. After a successful login the additional verification can be not requested for the logins from the same IP address for the specified period of time.</p><p>If Two-Factor Authentication is enabled by the System Administrator, the user is required to set up and use one of the available methods. If Two-Factor Authentication is later disabled by the System Administrator, the previously enabled method for an individual user is not automatically deactivated and can be disabled by the user in their personal settings.</p><h3 id="Services" tabindex="-1">Enabled Services <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Enabled Services {#Services}&quot;">​</a></h3><p>There is a set of settings that specify which CommuniGate Pro services can be used with the Account:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Enabled Services</b></td></tr><tr><td rowspan="3"><input name="Access-Def" value="1" type="checkbox">Default</td><td class="serviceName"><input name="X" value="Mail" checked="checked" type="checkbox">Mail</td><td class="serviceName"><input name="X" value="Relay" checked="checked" type="checkbox">Relay</td><td class="serviceName"><input name="X" value="Signal" checked="checked" type="checkbox">Signal</td><td class="serviceName"><input name="X" value="Roaming" checked="checked" type="checkbox">Roaming</td><td class="serviceName"><input name="X" value="TLS" checked="checked" type="checkbox">TLS</td><td class="serviceName"><input name="X" value="POP" checked="checked" type="checkbox">POP</td><td class="serviceName"><input name="X" value="IMAP" checked="checked" type="checkbox">IMAP</td><td class="serviceName"><input name="X" value="MAPI" checked="checked" type="checkbox">MAPI</td></tr><tr><td class="serviceName"><input name="X" value="AirSync" checked="checked" type="checkbox">AirSync</td><td class="serviceName"><input name="X" value="SIP" checked="checked" type="checkbox">SIP</td><td class="serviceName"><input name="X" value="XMPP" checked="checked" type="checkbox">XMPP</td><td class="serviceName"><input name="X" value="WebMail" checked="checked" type="checkbox">WebMail</td><td class="serviceName"><input name="X" value="XIMSS" checked="checked" type="checkbox">XIMSS</td><td class="serviceName"><input name="X" value="FTP" checked="checked" type="checkbox">FTP</td><td class="serviceName"><input name="X" value="Agent" checked="checked" type="checkbox">Agent</td><td class="serviceName"><input name="X" value="PWD" checked="checked" type="checkbox">PWD</td></tr><tr><td class="serviceName"><input name="X" value="LDAP" checked="checked" type="checkbox">LDAP</td><td class="serviceName"><input name="X" value="RADIUS" checked="checked" type="checkbox">RADIUS</td><td class="serviceName"><input name="X" value="S/MIME" checked="checked" type="checkbox">S/MIME</td><td class="serviceName"><input name="X" value="WebCAL" checked="checked" type="checkbox">WebCAL</td><td class="serviceName"><input name="X" value="WebSite" checked="checked" type="checkbox">WebSite</td><td class="serviceName"><input name="X" value="PBX" checked="checked" type="checkbox">PBX</td><td class="serviceName"><input name="X" value="HTTP" checked="checked" type="checkbox">HTTP</td></tr></tbody></table></div></form><ul><li><p><code>Mail</code></p><p>If this Service is disabled, incoming E-mail Messages are not delivered to this Account. Incoming messages are suspended in the <a href="./../mail/Local.html">Local Delivery</a> Module queue, and they are rejected if this option is not re-enabled within the specified period of time.<br> See the <a href="./../mail/Local.html#Disabled">Local Delivery</a> module settings for the details.<br> If this option is disabled, Account cannot compose and submit E-mail Messages.</p></li><li><p><code>Relay</code></p><p>If this Service is disabled, Account user is not able to use the <a href="./../sysadmin/Protection.html#Mobile">Mobile Users Support</a> features.<br> You may want to disable this Service when you provide free WebMail Accounts, and you do not want spammers to use these Accounts to enable SMTP relaying.</p></li><li><p><code>Signal</code></p><p>If this Service is disabled, incoming Signals sent to this Account are rejected.</p></li><li><p><code>Roaming</code></p><p>If this Service is disabled, the Account user cannot connect (login) from Internet Addresses not included into the <a href="./../sysadmin/Protection.html#Relay">Client Addresses</a> list.<br> You may want to disable this Service if you want your users to connect to their Accounts only from the Internet Addresses on your own network.</p></li><li><p><code>TLS</code></p><p>If this Service is disabled, secure (SSL/TLS) access to this Account is disabled.</p></li><li><p><code>POP</code>, <code>IMAP</code>, <code>MAPI</code>, <code>AirSync</code>, <code>PWD</code>, <code>XMPP</code>, <code>FTP</code></p><p>If a protocol Service is disabled, the Account cannot be opened (the Account user cannot be authenticated) using that protocol.</p></li><li><p><code>SIP</code></p><p>If this Service is disabled, <a href="./../signals/SIP.html">SIP</a> operations requiring authentication (REGISTER, outgoing calls, etc.) are not available for this Account.</p></li><li><p><code>WebMail</code></p><p>If this Service is disabled, the Account cannot be opened using the <a href="./../access/WebUser.html">WebUser Interface</a>.</p></li><li><p><code>XIMSS</code></p><p>If this Service is disabled, the Account cannot be opened using the <a href="./../access/XIMSS.html">XIMSS</a> Interface.</p></li><li><p><code>Agent</code></p><p>If this Service is disabled, the Account cannot be assigned an Agent role in <a href="https://www.communigatepro.ru/en/main/platform/contactcenter.html" target="_blank" rel="noreferrer">Contact Center</a>.</p></li><li><p><code>SMIME</code></p><p>If this Service is disabled, Secure Mail (S/MIME) features implemented in the <a href="./../access/WebUser.html">WebUser</a> and <a href="./../access/XIMSS.html">XIMSS</a> Interfaces are not available for this Account.</p></li><li><p><code>LDAP</code></p><p>If this Service is disabled, the Account user cannot be authenticated with the <a href="./../services/LDAP.html">LDAP</a> module.</p></li><li><p><code>RADIUS</code></p><p>If this Service is disabled, the Account user cannot be authenticated with the <a href="./../services/RADIUS.html">RADIUS</a> module.</p></li><li><p><code>WebCal</code></p><p>If this Service is disabled, the Account user cannot use the <a href="./WebCalendar.html">Calendaring</a> functions of the <a href="./../access/WebUser.html">WebUser</a> and <a href="./../access/XIMSS.html">XIMSS</a> Interfaces, and the user cannot be authenticated using the <a href="./../access/WebDAV.html#CalDAV">CalDAV</a> protocol.</p></li><li><p><code>WebSite</code></p><p>If this Service is disabled, HTTP and WebDAV access to this Account is disabled.</p></li><li><p><code>PBX</code></p><p>If this Service is disabled, the Account cannot use the <a href="./PBX.html">PBX</a> services.</p></li><li><p><code>HTTP</code></p><p>If this Service is disabled, sessions and real-time applications created for this Account cannot use outgoing HTTP transactions.</p></li></ul><p>The Server checks the Account and the Account <a href="./Domains.html">Domain</a> settings. Only if the Service is enabled for both the Account and the Account Domain, that service can be used with this Account. See the <a href="./Domains.html#Services">Domains Settings</a> section for more details.</p><p>If you select the <code>default</code> option, the Enabled Services for this Account are defined using Domain Default Account Settings or the Server-wide/Cluster-wide Default Account Settings.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Please note a difference between the Default Account settings and the Enabled Services specified for the Domain: while you can override the Default Account Settings for some Account by explicitly specifying the enabled Services for that Account, you cannot override the Enabled Services specified for the Domain. If the Default Account Settings disable POP and IMAP access, you can explicitly enable POP and IMAP access for a particular account. But if POP and IMAP access is disabled with the Domain Settings, no Account in that Domain can be accessed via these protocols.</p></div><h3 id="AccessSettings" tabindex="-1">Access Settings <a class="header-anchor" href="#AccessSettings" aria-label="Permalink to &quot;Access Settings {#AccessSettings}&quot;">​</a></h3>',19)),t[23]||(t[23]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Access")])]),e("tr",null,[e("td",{width:"25%",align:"right",nowrap:"nowrap",rowspan:"3"},"Session Limits: "),e("td",{align:"right"},"POP: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"POPSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(3)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])]),e("td",{align:"right"},"IMAP: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"IMAPSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])])]),e("tr",null,[e("td",{align:"right"},"AirSync: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"AirSyncSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])]),e("td",{align:"right"},"XMPP: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"XMPPSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])])]),e("tr",null,[e("td",{align:"right"},"XIMSS: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"XIMSSSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])]),e("td",{align:"right"},"WebUser: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"WebUserSessionLimit"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"3"},"3"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"4"},"other")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap",colspan:"2"},"POP Login Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-POPSessionFlow"},[e("option",{value:"-2"},"default(5)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3",selected:"selected"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"4"},"other")]),o(" in "),e("select",{class:"popup",name:"period-POPSessionFlow"},[e("option",{value:"-2"},"default(5 min)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600",selected:"selected"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"601"},"other")])]),e("td",{colspan:"2"}," ")])])])])],-1)),t[24]||(t[24]=e("ul",null,[e("li",null,[e("p",null,[e("code",null,"Session Limits")]),e("p",null,"These settings limit the number of concurrent sessions accessing this Account. If the number of the already opened sessions exceeds the specified limit, a new login operation is rejected with an error code being sent to the client application.")]),e("li",null,[e("p",null,[e("code",null,"POP Login Limit")]),e("p",null,"This setting limits the frequency of POP Logins into this Account. If the number of POP logins exceeds the specified limit, the session is rejected with an error code being sent to the mail client. The user should change the POP client settings to make it check mail less often.")])],-1)),t[25]||(t[25]=e("h3",{id:"Mail",tabindex:"-1"},[o("Mail Storage Settings "),e("a",{class:"header-anchor",href:"#Mail","aria-label":'Permalink to "Mail Storage Settings {#Mail}"'},"​")],-1)),t[26]||(t[26]=e("p",null,"Open the Mail Settings page in the Mail section of the Account Settings:",-1)),t[27]||(t[27]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Mailbox Storage")])]),e("tr",null,[e("td",{width:"30%",align:"RIGHT",nowrap:"nowrap"},"Mail Storage Limit: "),e("td",null,[e("select",{name:"MaxAccountSize"},[e("option",{value:"-2",selected:"selected"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"102400"},"100K"),e("option",{value:"307200"},"300K"),e("option",{value:"1048576"},"1024K"),e("option",{value:"3145728"},"3M"),e("option",{value:"10485760"},"10M"),e("option",{value:"31457280"},"30M"),e("option",{value:"104857600"},"100M"),e("option",{value:"314572800"},"300M"),e("option",{value:"1073741824"},"1024M"),e("option",{value:"3221225472"},"3G"),e("option",{value:"10737418240"},"10G"),e("option",{value:"32212254720"},"30G"),e("option",{value:"32212254719"},"other")])]),e("td",{align:"RIGHT",width:"30%"},"Used:"),e("td",{width:"25%"},[e("input",{type:"reset",name:"RecalcMailStorage",value:"3431K",class:"button"})])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Mailbox Limit: "),e("td",null,[e("select",{name:"MaxMailboxes"},[e("option",{value:"-2",selected:"selected"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"9999"},"other")])]),e("td",{align:"RIGHT"},"Used:"),e("td",null,"31")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Archive Messages after: "),e("td",null,[e("select",{class:"popup",name:"ArchiveMessagesAfter"},[e("option",{value:"-2"},"default(730 day(s))"),e("option",{value:"0"},"Never"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"2592000"},"30 day(s)"),e("option",{value:"7776000"},"90 day(s)"),e("option",{value:"15552000"},"180 day(s)"),e("option",{value:"31536000",selected:"selected"},"365 day(s)"),e("option",{value:"63072000"},"730 day(s)"),e("option",{value:"31536001"},"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Delete Messages after: "),e("td",null,[e("select",{class:"popup",name:"DeleteMessagesAfter"},[e("option",{value:"-2",selected:"selected"},"default(Never)"),e("option",{value:"0"},"Never"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"432000"},"5 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"2592000"},"30 day(s)"),e("option",{value:"7776000"},"90 day(s)"),e("option",{value:"15552000"},"180 day(s)"),e("option",{value:"31536000"},"365 day(s)"),e("option",{value:"63072000"},"730 day(s)"),e("option",{value:"31536001"},"other")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"New Mailbox Format: "),e("td",null,[e("select",{name:"DefaultMailboxType"},[e("option",{value:"-1",selected:"selected"},"default(Text)"),e("option",{value:"0"},"Text"),e("option",{value:"1"},"MailDir"),e("option",{value:"2"},"Sliced")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Non-Mail Folders visible via IMAP: "),e("td",null,[e("select",{name:"IMAPSeesNonMail"},[e("option",{value:"-1",selected:"selected"},"default(No)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Zap Deleted Messages: "),e("td",null,[e("select",{name:"EraseDeletedMessages"},[e("option",{value:"-1"},"default(No)"),e("option",{value:"0"},"No"),e("option",{value:"1",selected:"selected"},"Yes")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Encrypted Mailbox Creation: "),e("td",null,[e("select",{name:"EncryptedMailboxesAllowed"},[e("option",{value:"-1",selected:"selected"},"default(Prohibit)"),e("option",{value:"0"},"Prohibit"),e("option",{value:"1"},"Allow")])])])])])])],-1)),t[28]||(t[28]=i('<ul><li><p><code>Mail Storage Limit</code></p><p>This option is used to specify the maximum total size of the all Account Mailboxes. If a new incoming message cannot be stored in an Account, because the Account size would exceed the specified limit, the message is rejected and the message sender receives an error report.</p><p>The current Mail Storage usage value is shown as a button, if the page is viewed by a System Administrator. By clicking this button you can re-calculate the usage storage counter if that counter was de-synchronized.</p></li><li><p><code>Mailbox Limit</code></p><p>This option is used to specify the maximum number of Mailboxes that can be created in this Account.</p></li><li><p><code>Archive Messages after</code>, <code>Delete Messages after</code></p><p>See the <a href="./Chronos.html#MailClean">Chronos</a> section for the details.</p></li><li><p><code>New Mailbox Format</code></p><p>This setting specifies the default <a href="./../storage/Mailboxes.html#Formats">format</a> for all new Mailboxes created in this Account.</p></li><li><p><code>Non-Mail Folders visible via IMAP</code></p><p>This setting controls if IMAP clients see non-Mail (Calendar, Contacts, etc.) Mailboxes. See the <a href="./../access/IMAP.html#NonMail">IMAP</a> module section for more details.</p></li><li><p><code>Zap Deleted Messages</code></p><p>When this option is selected, the messages being deleted from the Account Mailboxes are rewritten with garbage first.</p></li><li><p><code>Encrypted Mailbox Creation</code></p><p>This setting specifies if the Account user is allowed to create Encrypted Mailboxes.</p></li></ul><h3 id="TransferIn" tabindex="-1">Incoming Mail Transfer Settings <a class="header-anchor" href="#TransferIn" aria-label="Permalink to &quot;Incoming Mail Transfer Settings {#TransferIn}&quot;">​</a></h3>',2)),t[29]||(t[29]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Incoming Mail Transfer")])]),e("tr",null,[e("td",{width:"25%",align:"right",nowrap:"nowrap"},"Incoming Mail Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-MailInpFlow"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"31"},"other")]),o(" in "),e("select",{class:"popup",name:"period-MailInpFlow"},[e("option",{value:"-2"},"default(15 sec)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600",selected:"selected"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"601"},"other")])]),e("td",{width:"25%",align:"right",nowrap:"nowrap"},"Incoming Message Size Limit: "),e("td",null,[e("select",{class:"popup",name:"MaxMessageSize"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"102400"},"100K"),e("option",{value:"307200"},"300K"),e("option",{value:"1048576"},"1024K"),e("option",{value:"3145728"},"3M"),e("option",{value:"10485760"},"10M"),e("option",{value:"31457280",selected:"selected"},"30M"),e("option",{value:"104857600"},"100M"),e("option",{value:"314572800"},"300M"),e("option",{value:"1073741824"},"1024M"),e("option",{value:"3221225472"},"3G"),e("option",{value:"10737418240"},"10G"),e("option",{value:"32212254720"},"30G"),e("option",{value:"31457281"},"other")])])]),e("tr",null,[e("td",{colspan:"4"},[e("hr")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Delay New Mail if: "),e("td",null,[e("select",{class:"popup",name:"QuotaSuspend"},[e("option",{value:"-2",selected:"selected"},"default(100)"),e("option",{value:"0"},"0"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"75"},"75"),e("option",{value:"80"},"80"),e("option",{value:"85"},"85"),e("option",{value:"90"},"90"),e("option",{value:"95"},"95"),e("option",{value:"97"},"97"),e("option",{value:"99"},"99"),e("option",{value:"100"},"100"),e("option",{value:"101"},"101"),e("option",{value:"98"},"other")]),o("% full")]),e("td",{align:"right",nowrap:"nowrap"},"Send Alerts if: "),e("td",null,[e("select",{class:"popup",name:"QuotaAlert"},[e("option",{value:"-2",selected:"selected"},"default(80)"),e("option",{value:"0"},"0"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"75"},"75"),e("option",{value:"80"},"80"),e("option",{value:"85"},"85"),e("option",{value:"90"},"90"),e("option",{value:"95"},"95"),e("option",{value:"97"},"97"),e("option",{value:"99"},"99"),e("option",{value:"100"},"100"),e("option",{value:"101"},"101"),e("option",{value:"81"},"other")]),o("% full")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Send Notice if: "),e("td",null,[e("select",{class:"popup",name:"QuotaNotice"},[e("option",{value:"-2",selected:"selected"},"default(90)"),e("option",{value:"0"},"0"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"75"},"75"),e("option",{value:"80"},"80"),e("option",{value:"85"},"85"),e("option",{value:"90"},"90"),e("option",{value:"95"},"95"),e("option",{value:"97"},"97"),e("option",{value:"99"},"99"),e("option",{value:"100"},"100"),e("option",{value:"101"},"101"),e("option",{value:"91"},"other")]),o("% full")]),e("td",{colspan:"2"}," ")]),e("tr",null,[e("td",{colspan:"4"},[e("hr")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Allowed Mail Rules: "),e("td",null,[e("select",{name:"RulesAllowed"},[e("option",{value:"-1",selected:"selected"},"default(Filters only)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Filters only"),e("option",{value:"2"},"All but Exec"),e("option",{value:"3"},"Any")])]),e("td",{align:"right"},"Used:"),e("td",null,"7")]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Remote Poll modifications: "),e("td",null,[e("select",{name:"RPOPAllowed"},[e("option",{value:"-1",selected:"selected"},"default(Prohibit)"),e("option",{value:"0"},"Prohibit"),e("option",{value:"1"},"Allow")])]),e("td",{align:"right"},"Used:"),e("td",null,"3")]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},'Accepts Mail to "all": '),e("td",null,[e("select",{name:"MailToAll"},[e("option",{value:"-1",selected:"selected"},"default(Yes)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes")])])])])])])],-1)),t[30]||(t[30]=i('<ul><li><p><code>Incoming Message Size Limit</code></p><p>This option is used to specify the maximum size of an E-mail Message that can be delivered to the Account.</p></li><li><p><code>Incoming Mail Limit</code></p><p>This option is used to limit the number of E-mail Messages an Account can receive over the specified period of time.<br> See the <a href="./../mail/Local.html#Flow">Local Delivery Module</a> section for more details.</p></li><li><p><code>Delay New Mail</code></p><p>If the Account mail storage size is limited, and the specified percent of that limit is already used, or it would be used when the new message is added, message delivery to this Account is suspended. The <a href="./../mail/Local.html#Quota">Local Delivery module</a> settings specify what actually happens to the Account message queue in this case.</p></li><li><p><code>Send Alerts</code></p><p>This option specifies when the <a href="./../sysadmin/Alerts.html#Quota">Storage Quota Alerts</a> should be sent to the Account user.<br> The Alert message text is a <a href="./../sysadmin/#Strings">Server String</a> and it can be customized.</p></li><li><p><code>Send Notice</code></p><p>This option specifies when the Local Delivery module should compose and store an &quot;over quota&quot; message in the Account INBOX. If this Notice Message is stored, no new Notice Message will be composed and stored for the next 24 hours.<br> The Notice Message Subject and the Message text are <a href="./../sysadmin/#Strings">Server Strings</a> and they can be customized. There are two different Notice Message bodies - one is used when an incoming message has been delivered, and the other one - when an incoming message is too big to be delivered to the Account.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Notice Messages are not submitted to the <a href="./../mail/">Queue</a>, they are composed with the Local Delivery module and they are stored directly in the Account INBOX.</p></div></li></ul><p>To disable these 3 options, set their values to 101%.</p><ul><li><p><code>Allowed Mail Rules</code></p><p>This setting tells the Server if the user is allowed to specify automated Rules that instruct the Server how to process incoming E-mail messages.</p><ul><li><p><code>No</code></p><p>If this option is selected, only the administrator can specify the automated rules for this user.</p></li><li><p><code>Filter Only</code></p><p>If this option is selected, the user can specify only the following actions:<br><code>Discard</code>, <code>Reject</code>, <code>Stop Processing</code>, <code>Mark</code>, <code>Add Header</code>, <code>Tag Subject</code>, <code>Store in</code>, <code>Copy Attachments to</code>, and <code>Store Encrypted in</code>.</p></li><li><p><code>All But Exec</code></p><p>If this option is selected, the user can specify any action, but the <code>Execute</code> action.</p></li><li><p><code>Any</code></p><p>If this option is selected, the user can specify any action.</p></li></ul><p>Click the <a href="./../mail/QueueRules.html">Mail Rules</a> link to specify the rules to be applied to all incoming E-mail messages directed to this Account.</p><p>If an administrator creates an Automated Rule containing actions the Account user is not allowed to specify, the user will be able to view that Rule, but not to modify any part of it.</p></li><li><p><code>RPOP Modifications</code></p><p>This setting tells the Server if the user is allowed to specify remote host (RPOP) accounts that the <a href="./../mail/RPOP.html">RPOP module</a> should poll on the user&#39;s behalf.<br> If this option is disabled, only the administrator can specify the RPOP accounts for this user.<br> Click the <a href="./../mail/RPOP.html#Individual">RPOP</a> link to specify the remote accounts to be polled on behalf of this user.</p></li><li><p><code>Accept Mail to all</code></p><p>This setting tells the Server to store messages directed to the <code>all@_domain_</code> address in the Account INBOX.</p></li></ul><h3 id="TransferOut" tabindex="-1">Outgoing Mail Transfer Settings <a class="header-anchor" href="#TransferOut" aria-label="Permalink to &quot;Outgoing Mail Transfer Settings {#TransferOut}&quot;">​</a></h3>',4)),t[31]||(t[31]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Outgoing Mail Transfer")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Outgoing Mail Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-MailInpFlow"},[e("option",null,"default(unlimited)"),e("option",null,"unlimited"),e("option",null,"0"),e("option",null,"1"),e("option",null,"3"),o(),e("option",null,"5"),e("option",null,"10"),e("option",{selected:"selected"},"15"),e("option",null,"20"),e("option",null,"30"),e("option",null,"100"),e("option",null,"300"),e("option",null,"1000"),e("option",null,"3000"),o(),e("option",null,"10000"),e("option",null,"30000"),e("option",null,"100000"),e("option",null,"300000"),e("option",null,"1000000"),e("option",null,"other")]),o(" in "),e("select",{class:"popup",name:"period-MailInpFlow"},[e("option",null,"default(20 sec)"),e("option",null,"1 sec"),e("option",null,"3 sec"),e("option",null,"5 sec"),e("option",null,"10 sec"),e("option",null,"15 sec"),o(),e("option",null,"20 sec"),e("option",null,"30 sec"),e("option",null,"60 sec"),e("option",null,"2 min"),e("option",null,"3 min"),e("option",null,"5 min"),o(),e("option",{selected:"selected"},"10 min"),e("option",null,"15 min"),e("option",null,"20 min"),e("option",null,"30 min"),e("option",null,"60 min"),e("option",null,"2 hour(s)"),e("option",null,"3 hour(s)"),o(),e("option",null,"6 hour(s)"),e("option",null,"12 hour(s)"),e("option",null,"24 hour(s)"),e("option",null,"2 day(s)"),e("option",null,"3 day(s)"),e("option",null,"7 day(s)"),o(),e("option",null,"2 week(s)"),e("option",null,"3 week(s)"),e("option",null,"4 week(s)"),e("option",null,"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Outgoing Message Size Limit: "),e("td",null,[e("select",{name:"MaxMessageSize"},[e("option",null,"default(unlimited)"),e("option",null,"unlimited"),e("option",null,"0"),e("option",null,"100K"),e("option",null,"300K"),e("option",{value:"1048576"},"1024K"),o(),e("option",null,"3M"),e("option",null,"10M"),e("option",{selected:"selected"},"30M"),e("option",null,"100M"),e("option",null,"300M"),e("option",null,"1024M"),e("option",null,"3G"),e("option",null,"10G"),o(),e("option",null,"30G"),e("option",null,"other")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Outgoing Recipients Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-MailOutFlow"},[e("option",null,"default(unlimited)"),e("option",null,"unlimited"),e("option",null,"0"),e("option",null,"1"),e("option",null,"3"),o(),e("option",null,"5"),e("option",null,"10"),e("option",null,"15"),e("option",{selected:"selected"},"20"),e("option",null,"30"),e("option",null,"100"),e("option",null,"300"),e("option",null,"1000"),e("option",null,"3000"),o(),e("option",null,"10000"),e("option",null,"30000"),e("option",null,"100000"),e("option",null,"300000"),e("option",null,"1000000"),e("option",null,"other")]),o(" in "),e("select",{class:"popup",name:"period-MailOutFlow"},[e("option",null,"default(30 sec)"),e("option",null,"1 sec"),e("option",null,"3 sec"),e("option",null,"5 sec"),e("option",null,"10 sec"),e("option",null,"15 sec"),o(),e("option",null,"20 sec"),e("option",null,"30 sec"),e("option",null,"60 sec"),e("option",null,"2 min"),e("option",null,"3 min"),e("option",null,"5 min"),e("option",{selected:"selected"},"10 min"),e("option",null,"15 min"),o(),e("option",null,"20 min"),e("option",null,"30 min"),e("option",null,"60 min"),e("option",null,"2 hour(s)"),e("option",null,"3 hour(s)"),e("option",null,"6 hour(s)"),e("option",null,"12 hour(s)"),e("option",null,"24 hour(s)"),o(),e("option",null,"2 day(s)"),e("option",null,"3 day(s)"),e("option",null,"7 day(s)"),e("option",null,"2 week(s)"),e("option",null,"3 week(s)"),e("option",null,"4 week(s)"),e("option",null,"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Max Recipients per Message: "),e("td",null,[e("select",{name:"MaxMailOutSize"},[e("option",null,"default(unlimited)"),e("option",null,"unlimited"),e("option",null,"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"5"),o(),e("option",null,"10"),e("option",{selected:"selected"},"15"),e("option",null,"20"),e("option",null,"30"),e("option",null,"50"),e("option",null,"100"),e("option",null,"other")])])]),e("tr",null,[e("td",{colspan:"4"},[e("hr")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"'From' Address Restrictions: "),e("td",null,[e("select",{name:"RestrictFromAddr"},[e("option",null,"default(None)"),e("option",null,"None"),e("option",{selected:"selected"},"Relaxed"),e("option",null,"Strict")])]),e("td",{align:"right",nowrap:"nowrap"},"'From' Name Restrictions: "),e("td",null,[e("select",{name:"RestrictFromName"},[e("option",{selected:"selected"},"default(None)"),e("option",null,"None"),e("option",null,"Relaxed"),e("option",null,"Strict")])])]),e("tr",null,[e("td",{colspan:"4"},[e("hr")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Add Trailer to Sent Mail: "),e("td",null,[e("select",{name:"AddMailTrailer"},[e("option",{selected:"selected"},"default(Yes)"),e("option",null,"No"),e("option",null,"Yes")])]),e("td"),e("td")]),e("tr",null,[e("td",{colspan:"4"},[e("hr")])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"Reroute External Recipients to: "),e("td",null,[e("table",{cellspacing:"0",cellpadding:"1",border:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"ExtRcptTo-Def",value:"1",type:"radio"})]),e("td",{class:"settingFixed"},"* ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"ExtRcptTo-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"ExtRcptTo",size:"50",maxlength:"10000",value:"*@smarthost.com._via"})])])])])])])])])])],-1)),t[32]||(t[32]=i('<ul><li><p><code>Outgoing Mail Limit</code></p><p>This option is used to limit the number of E-mail Messages composed and submitted on behalf of this Account, over the specified period of time.<br> If the number of messages submitted during the specified period of time exceeds the specified limit, the Account user&#39;s ability to submit messages is suspended (for the specified period of time).</p></li><li><p><code>Outgoing Message Size Limit</code></p><p>This option is used to specify the maximum size of an E-mail Message that can be composed and submitted by this Account.</p></li><li><p><code>Outgoing Recipients Limit</code></p><p>This option is used to limit the number of recipients to whom E-mail Messages can be submitted on behalf of this Account, over the specified period of time.<br> If the number of recipients submitted during the specified period of time exceeds the limit, the user&#39;s ability to submit messages is suspended.</p></li><li><p><code>Max Recipients per Message</code></p><p>This option is used to specify the maximum number of recipients in a single E-mail Message that can be submitted by this Account.</p></li><li><p><code>&#39;From&#39; Address Restrictions</code></p><p>This option is used to specify what e-mail address can be used in <code>From:</code> header in messages submitted by this Account.</p><ul><li><p><code>None</code></p><p>If this option is selected, any address can be used, including a non-existent one.</p></li><li><p><code>Strict</code></p><p>If this option is selected, only the Account name can be used as the address.</p></li><li><p><code>Relaxed</code></p><p>If this option is selected, the following can be used:</p><ul><li>any address which is routed to the Account through <a href="./Accounts.html#Aliases">Alias</a>, <a href="./Forwarders.html">Forwarder</a>, or <a href="./../sysadmin/Router.html">Router</a> entry.</li><li>a <a href="./Groups.html">Group</a> name, if the Account is a member of that <a href="./Groups.html#Settings">Group</a>.</li><li>another Account name from the same CommuniGate server, if this Account has <code>CanImpersonate</code> <a href="./../sysadmin/#DomainPrivs">Domain access right</a>, or if that Account had granted this Account the <code>Delegate</code> <a href="./Accounts.html#AccessRights">Account access right</a>.</li></ul></li></ul></li><li><p><code>&#39;From&#39; Name Restrictions</code></p><p>This option is used to specify what title can be used in <code>From:</code> header in messages submitted by this Account.</p><ul><li><p><code>None</code></p><p>If this option is selected, any name can be used.</p></li><li><p><code>Strict</code></p><p>If this option is selected, the following can be used:</p><ul><li>the exact value of <a href="./Accounts.html#Settings">Real Name</a> attribute of this Account, if the &#39;From&#39; address is routed to the Account.</li><li>the exact value of <a href="./Groups.html#Settings">Real Name</a> of a <a href="./Groups.html">Group</a>, if the &#39;From&#39; address is routed to that Group and this Account is the member of the Group.</li><li>the exact value of <a href="./Accounts.html#Settings">Real Name</a> attribute of another Account, if the &#39;From&#39; address is routed to that Account, and if this Account has <code>CanImpersonate</code> <a href="./../sysadmin/#DomainPrivs">Domain access right</a>, or if that Account had granted this Account the <code>Delegate</code> <a href="./Accounts.html#AccessRights">Account access right</a>.</li></ul></li><li><p><code>Relaxed</code></p><p>If this option is selected, the following can be used:</p><ul><li>an empty string.</li><li>the copy of the &#39;From&#39; address.</li><li>any string containing the value of <a href="./Accounts.html#Settings">Real Name</a> attribute of this Account, if the &#39;From&#39; address is routed to the Account.</li><li>any string containing the value of <a href="./Groups.html#Settings">Real Name</a> of a <a href="./Groups.html">Group</a>, if the &#39;From&#39; address is routed to that Group and this Account is the member of the Group.</li><li>any string containing the value of <a href="./Accounts.html#Settings">Real Name</a> attribute of another Account, if the &#39;From&#39; address is routed to that Account, and if this Account has <code>CanImpersonate</code> <a href="./../sysadmin/#DomainPrivs">Domain access right</a>, or if that Account had granted this Account the <code>Delegate</code> <a href="./Accounts.html#AccessRights">Account access right</a>.</li></ul></li></ul><p>These options are used to prevent system abuse by the system own users, and for mitigation of damage from compromised Accounts used by hackers.</p><p>These limits and restrictions are applied to the messages submitted from <em>authenticated sources</em>: via SMTP using the AUTH operation, via the WebUser Interface and XIMSS clients, via the MAPI module, via the <a href="./../access/POP.html">POP</a> module XTND XMIT command, via <a href="./../access/AirSync.html">AirSync</a> clients, etc.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some of users can send messages via SMTP without using the AUTH operation, because they send from the network addresses specified in the <a href="./../sysadmin/Protection.html#ClientFixed">Client IP Addresses</a> list, or because they use the <a href="./../sysadmin/Protection.html#Temp">Read-then-Send</a> method. In this case the messages they submit cannot be attributed to any Account and those messages are not counted, and their From: headers are not checked.</p><p>If you want to apply the Outgoing Flow Control settings to all messages submitted by your users, you should force all of them to use the SMTP AUTH operation by enabling the Force SMTP AUTH option in the Domain Settings.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The messages generated by Account-level or Domain-wide Rule action, including ones generated by the <a href="./../mail/QueueRules.html#Redirect">Copy All Mail To</a> simplified Rule, are also fall under the restrictions. So when the restrictions are on, the user may be able to use only the &quot;Send on behalf of this Account&quot; (<code>Forward to</code>) action, but not <code>Redirect to</code> and <code>Mirror to</code> actions which preserve the original <code>From:</code> header.</p></div></li><li><p><code>Add Mail Trailer</code></p><p>This setting tells the Server to append the trailer text (specified in the <a href="./Domains.html#WebUser">Domain Settings</a>) to all messages this user composes using the <a href="./../access/WebUser.html">WebUser Interface</a>.</p></li><li><p><code>Reroute External Recipients to</code></p><p>This setting specifies how the addresses of the external message recipients are changed.<br> If the setting value is <code>*</code> or empty string then the recipients are unchanged. Otherwise the <code>*</code> symbol is replaced with the original recipient address and the <a href="./../sysadmin/Router.html">Router</a> restarts trying to route this new address.</p><ul><li><p>Sample:</p><p>The Domain <code>Reroute External Recipients to</code> option is set to<br><code>*@smarthost.com._via</code><br> The outgoing messages from users of this domain will be sent to intended recipients through the <code>smarthost.com</code> server.</p></li><li><p>Sample:</p><p>The Account <code>Reroute External Recipients to</code> option is set to<br><code>error</code><br> The user will be able to send only locally within the Server, attempts to send to outside will cause an error.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This rerouting is applied only to external addresses (directed to SMTP Module), not applied to local addresses.</p></div><p>Any of these Settings can be set to the <code>default</code> value, in this case the setting value is taken from the Domain Default Account Settings or the server-wide/cluster-wide Default Account Settings.</p></li></ul><h3 id="Signal" tabindex="-1">Signaling Settings <a class="header-anchor" href="#Signal" aria-label="Permalink to &quot;Signaling Settings {#Signal}&quot;">​</a></h3><p>Open the Call Settings page in the Real-Time section of the Account Settings:</p>',3)),t[33]||(t[33]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Calls")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Allowed Call Rules: "),e("td",null,[e("select",{name:"SignalRulesAllowed"},[e("option",{value:"-1"},"default(No)"),e("option",{value:"0"},"No"),e("option",{value:"1",selected:"selected"},"Any")])]),e("td",{align:"RIGHT"},"Used:"),e("td",null,"10")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Concurrent Calls: "),e("td",null,[e("select",{class:"popup",name:"CallsLimit"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2",selected:"selected"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"1000"},"1000"),e("option",{value:"11"},"other")])]),e("td",{align:"RIGHT"},"Used:"),e("td",null,"0")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Incoming Calls Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-CallInpFlow"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1",selected:"selected"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"101"},"other")]),o(" in "),e("select",{class:"popup",name:"period-CallInpFlow"},[e("option",{value:"-2"},"default(15 sec)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600",selected:"selected"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"601"},"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Call Logs: "),e("td",null,[e("select",{name:"CallLogs"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Outgoing Calls Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-CallOutFlow"},[e("option",{value:"-2"},"default(unlimited)"),e("option",{value:"-1",selected:"selected"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"101"},"other")]),o(" in "),e("select",{class:"popup",name:"period-CallOutFlow"},[e("option",{value:"-2"},"default(15 sec)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600",selected:"selected"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"601"},"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Call Info: "),e("td",null,[e("select",{name:"DialogInfo"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])])],-1)),t[34]||(t[34]=i('<ul><li><p><code>Allowed Call Rules</code></p><p>This setting tells the Server if the user is allowed to specify automated Rules that instruct the Server how to process incoming <a href="./../cluster/Signals.html">Signals</a>.</p><ul><li><p><code>No</code></p><p>If this option is selected, only the administrator can specify the automated Signal Rules for this user.</p></li><li><p><code>Any</code></p><p>If this option is selected, the user can specify any action.</p></li></ul><p>Click the <a href="./../signals/SignalRules.html">Call Rules</a> link to specify the rules to be applied to all incoming Signals (calls) directed to this Account.</p><p>If an administrator creates an Automated Rule containing actions the Account user is not allowed to specify, the user will be able to view that Rule, but not to modify any part of it.</p></li><li><p><code>Concurrent Calls</code></p><p>This setting specifies the maximum number of concurrent calls this Account can be involved in (as a caller or a callee).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Call Info option is disabled, the number of concurrent calls cannot be defined and it cannot be limited.</p></div></li><li><p><code>Call Logs</code></p><p>If this option is enabled, the <a href="./../cluster/Signals.html">Signal</a> component places call log records into the <code>private/logs/</code> files in the Account <a href="./../storage/FileStore.html">File Storage</a>.</p></li><li><p><code>Call Info</code></p><p>If this option is enabled, the <a href="./../cluster/Signals.html">Signal</a> component stores the current calls information in the Account data, from where it can be retrieved using the <a href="./../cluster/Signals.html#DialogPackage">dialog</a> Signal package, and other methods.<br> Disable this option if the Account is a service one, handling many concurrent calls, and there is no need to retrieve the current call information.</p></li><li><p><code>Incoming Calls Limit</code></p><p>This setting specifies the maximum number of incoming calls this Account can receive over the specified period of time.</p></li><li><p><code>Outgoing Calls Limit</code></p><p>This setting specifies the maximum number of outgoing calls this Account can make over the specified period of time.</p></li></ul>',1)),t[35]||(t[35]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Device Registration")])]),e("tr",null,[e("td",{width:"30%",align:"RIGHT",nowrap:"nowrap"},"Registered Devices: "),e("td",null,[e("select",{class:"popup",name:"MaxSignalContacts"},[e("option",{value:"-2",selected:"selected"},"default(10)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"1000"},"1000"),e("option",{value:"11"},"other")])]),e("td",{align:"RIGHT",width:"30%"},"Used:"),e("td",{width:"25%"},"2")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"RSIP modifications: "),e("td",null,[e("select",{name:"RSIPAllowerd"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])]),e("td",{align:"RIGHT",width:"30%"},"Used:"),e("td",{width:"25%"},"1")])])])])],-1)),t[36]||(t[36]=e("ul",null,[e("li",null,[e("p",null,[e("code",null,"Registered Devices")]),e("p",null,'This setting specifies the maximum number of "Contacts" (devices) the Server can register for this Account. The Used field shows the number of the currently registered devices.')]),e("li",null,[e("p",null,[e("code",null,"RSIP modifications")]),e("p",null,[o("This setting specifies if the Account user is allowed to modify the Account "),e("a",{href:"./../signals/PSTN.html#RSIP"},"RSIP settings"),o(". The Used field shows the current number of the Account RSIP records.")])])],-1)),t[37]||(t[37]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Instant Messaging and Presence")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Roster Limit: "),e("td",null,[e("select",{class:"popup",name:"MaxRosterItems"},[e("option",{value:"-2",selected:"selected"},"default(20)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"10"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"1000"},"1000"),e("option",{value:"21"},"other")])]),e("td",{align:"RIGHT"},"Used:"),e("td",null,"7")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Send IMs to SIP Devices: "),e("td",null,[e("select",{name:"SIPIMMode"},[e("option",{value:"-1"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"If Supported"),e("option",{value:"2"},"Enabled")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"IM Logs: "),e("td",null,[e("select",{name:"IMLogs"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Outgoing NOTIFY Requests Limit: "),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"limit-NotifyOutFlow"},[e("option",{value:"-2"},"default(100)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"100",selected:"selected"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",{value:"101"},"other")]),o(" in "),e("select",{class:"popup",name:"period-NotifyOutFlow"},[e("option",{value:"-2"},"default(15 sec)"),e("option",{value:"1"},"1 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15",selected:"selected"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"1209600"},"2 week(s)"),e("option",{value:"1814400"},"3 week(s)"),e("option",{value:"2419200"},"4 week(s)"),e("option",{value:"601"},"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Map Call Dialog Status to Presence: "),e("td",null,[e("select",{name:"DialogToPresence"},[e("option",{value:"-1",selected:"selected"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])])])])])],-1)),t[38]||(t[38]=i('<ul><li><p><code>Roster Limit</code></p><p>This setting specifies the maximum number of Roster elements (&quot;Buddies&quot;) for this Account.</p></li><li><p><code>Send IMs to SIP Devices</code></p><p>If this option is set to Enabled, incoming Instant Messages are delivered to all registered SIP devices;<br> if this option is set to If Supported, incoming Instant Messages are delivered only to those registered SIP devices that declared support for the <code>MESSAGE</code> SIP Method;<br> if this option is set to Disabled, incoming Instant Messages are not delivered to registered SIP devices.</p></li><li><p><code>IM Logs</code></p><p>If this option is enabled, incoming and outgoing Instant Messages are stored in the Account File Storage.</p></li><li><p><code>Outgoing NOTIFY Requests Limit</code></p><p>This setting specifies the maximum number of NOTIFY requests (such as presence updates, call dialog status updates, etc.) this Account can send over the specified period of time. Increase this setting as you increase the allowed Roster Limit: when the Account changes its presence state, a NOTIFY request with the new presence info is sent to each Roster item (to each &quot;buddy&quot;).</p></li><li><p><code>Map Call Dialog Status to Presence</code></p><p>If this option is enabled, and this Account has active calls, then the Account presence state is set to &quot;on-phone&quot;.</p></li></ul><p>The Instant Messages processing is also controlled with <a href="./../signals/IMPresence.html#Prefs">Account Preferences</a>.</p><h3 id="File" tabindex="-1">File Storage Settings <a class="header-anchor" href="#File" aria-label="Permalink to &quot;File Storage Settings {#File}&quot;">​</a></h3><p>Open the File Settings page in the Files section of the Account Settings:</p>',4)),t[39]||(t[39]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"File Storage")])]),e("tr",null,[e("td",{width:"30%",align:"RIGHT",nowrap:"nowrap"},"File Storage Limit: "),e("td",null,[e("select",{class:"popup",name:"MaxWebSize"},[e("option",{value:"-2"},"default(30M)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"10240"},"10K"),e("option",{value:"30720"},"30K"),e("option",{value:"102400"},"100K"),e("option",{value:"307200"},"300K"),e("option",{value:"1048576"},"1024K"),e("option",{value:"3145728"},"3M"),e("option",{value:"10485760"},"10M"),e("option",{value:"31457280"},"30M"),e("option",{value:"104857600",selected:"selected"},"100M"),e("option",{value:"314572800"},"300M"),e("option",{value:"1073741824"},"1024M"),e("option",{value:"3221225472"},"3G"),e("option",{value:"10737418240"},"10G"),e("option",{value:"32212254720"},"30G"),e("option",{value:"104857601"},"other")])]),e("td",{align:"RIGHT"},"Used:"),e("td",{width:"25%"},"1340K")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Files Limit: "),e("td",null,[e("select",{class:"popup",name:"MaxWebFiles"},[e("option",{value:"-2",selected:"selected"},"default(1000)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"1001"},"other")])]),e("td",{align:"RIGHT"},"Used:"),e("td",{width:"25%"},"33")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"File Size Limit: "),e("td",null,[e("select",{class:"popup",name:"MaxFileSize"},[e("option",{value:"-2",selected:"selected"},"default(unlimited)"),e("option",{value:"-1"},"unlimited"),e("option",{value:"0"},"0"),e("option",{value:"10240"},"10K"),e("option",{value:"30720"},"30K"),e("option",{value:"102400"},"100K"),e("option",{value:"307200"},"300K"),e("option",{value:"1048576"},"1024K"),e("option",{value:"3145728"},"3M"),e("option",{value:"10485760"},"10M"),e("option",{value:"31457280"},"30M"),e("option",{value:"104857600"},"100M"),e("option",{value:"314572800"},"300M"),e("option",{value:"1073741824"},"1024M"),e("option",{value:"3221225472"},"3G"),e("option",{value:"10737418240"},"10G"),e("option",{value:"32212254720"},"30G"),e("option",{value:"32212254719"},"other")])]),e("td",{colspan:"2"}," ")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Add Banner to HTML: "),e("td",null,[e("select",{name:"AddWebBanner"},[e("option",{value:"-1",selected:"selected"},"default(Yes)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Default file for HTTP: "),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"DefaultWebPage-Def",value:"1",checked:"checked"})]),e("td",{class:"settingFixed"},"default.html")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"DefaultWebPage-Def",value:"0"})]),e("td",null,[e("input",{name:"DefaultWebPage",size:"10",maxlength:"10000",value:""})])])])])])])])])])],-1)),t[40]||(t[40]=i('<ul><li><p><code>File Storage Limit</code></p><p>This option is used to specify the maximum total size of the all files in the Account <a href="./../storage/FileStore.html">File Storage</a>. If this option is set to zero, the Account File Storage is disabled.</p></li><li><p><code>File Size Limit</code></p><p>This option is used to specify the maximum size of a file that can be stored in the Account File Storage.</p></li><li><p><code>Files Limit</code></p><p>This option is used to specify the maximum number of all files in the Account <a href="./../storage/FileStore.html">File Storage</a>.</p></li><li><p><code>Add Banner to HTML</code></p><p>This setting tells the Server to insert the Web banner code (specified in the <a href="./Domains.html#WebUser">Domain Settings</a>) to all HTML files retrieved from this Account <a href="./../storage/FileStore.html">File Storage</a>.</p></li><li><p><code>Default Web Page</code></p><p>When an HTTP URL for a File Storage file does not specify a file name (<code>http://domain:port/~account/</code> or <code>http://domain:port/~account/subDir/</code>), a file with the Default Web Page name is retrieved.</p></li></ul><h3 id="WebUser" tabindex="-1">WebUser Interface Settings <a class="header-anchor" href="#WebUser" aria-label="Permalink to &quot;WebUser Interface Settings {#WebUser}&quot;">​</a></h3><p>Open the Account Settings page to modify the WebUser Interface settings:</p>',3)),t[41]||(t[41]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"WebUser Interface")])]),e("tr",{valign:"top"},[e("td",{align:"RIGHT"},"Hidden Skins:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"HiddenSkins-Def",value:"1"})]),e("td",{class:"settingFixed"}," ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"HiddenSkins-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"HiddenSkins",size:"50",maxlength:"10000",value:"Pronto-steel"})])])])])])]),e("tr",{valign:"top"},[e("td",{align:"RIGHT"},"Hidden Languages:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"HiddenLang-Def",value:"1"})]),e("td",{class:"settingFixed"}," ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"HiddenLang-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"HiddenLanguages",size:"50",maxlength:"10000",value:"klingon"})])])])])])]),e("tr",{valign:"top"},[e("td",{align:"RIGHT"},"Hidden Pronto Modules:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"HiddenProntoModules-Def",value:"1",checked:"checked"})]),e("td",{class:"settingFixed"},"Twitter,Video")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"HiddenProntoModules-Def",value:"0"})]),e("td",null,[e("input",{name:"HiddenProntoModules",size:"50",maxlength:"10000",value:""})])])])])])]),e("tr",{valign:"top"},[e("td",{align:"RIGHT"},"Banner Parameters:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"BannerInfo-Def",value:"1"})]),e("td",{class:"settingFixed"}," ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"BannerInfo-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"BannerInfo",size:"50",maxlength:"10000",value:"zuka=ttt"})])])])])]),e("td",{colspan:"2"}," ")])])])])],-1)),t[42]||(t[42]=i('<ul><li><p><code>Hidden Skins</code></p><p>This option is used to specify the names of the WebUser Interface (and Pronto) <a href="./../../development/WebApp.html#Skins">Skins</a> that should be hidden from this Account user. If several names are specified, separate them with the comma (<code>,</code>) symbol. To hide the &quot;unnamed&quot; Skin, specify the <code>unnamed</code> name.</p></li><li><p><code>Hidden Languages</code></p><p>This option is used to specify the names of the languages (by the names of the <a href="./../../development/WebApp.html#Strings">Language Files</a>) that should be hidden from this Account user. If several names are specified, separate them with the comma (<code>,</code>) symbol.</p></li><li><p><code>Hidden Pronto Modules</code></p><p>This option is used to specify the names of the Pronto modules that should not be loaded for this Account user. If several names are specified, separate them with the comma (<code>,</code>) symbol.<br> The following module names are recognized: IM, Contacts, Mail, History, Dialer, Files, Calendar, Tasks, Prefs, Notes, Chats</p></li><li><p><code>Banner Parameters</code></p><p>This setting value is passed to the <a href="./../../development/Helpers.html#Banner">External Banner System</a> when it is requested to generate an advertising banner for this Account session.</p></li></ul><h2 id="Aliases" tabindex="-1">Account Aliases <a class="header-anchor" href="#Aliases" aria-label="Permalink to &quot;Account Aliases {#Aliases}&quot;">​</a></h2><p>Each Account can have Aliases (alternative names).</p><p>If the <code>john_smith</code> Account has the <code>jsmith</code> and <code>j.smith</code> Aliases, E-mail directed to jsmith and to j.smith will be stored in the <code>john_smith</code> Account, and the Signals directed to to jsmith and to j.smith will be delivered to the <code>john_smith</code> Account.<br> To access the john_smith Account via POP, IMAP, XMPP, XIMSS, WebUser, or any other client application both the user names <code>jsmith</code> and <code>j.smith</code> can be specified in the client application settings.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Aliases</b></td></tr><tr><td align="center"><input name="AliasName" value="j.smith" size="50" maxlength="127" type="text"></td></tr><tr><td align="center"><input name="AliasName" value="jsmith" size="50" maxlength="127" type="text"></td></tr><tr><td align="center"><input name="AliasName" value="" size="50" maxlength="127" type="text"></td></tr></tbody></table></div></form><p>You can modify existing Aliases, you can add an Alias by typing a new name in the empty field, and you can remove an Alias by deleting it from its field. Use the Update button to update the Account Aliases list.</p><p>Alias names should not be the same as the name of some other Account, or other Object in the same Domain.<br> The Alias names should meet the <a href="./Domains.html#Provision">Domain Object</a> name restrictions.</p><p>You can specify several Aliases in one field by separating them with the comma (<code>,</code>) symbol.</p><h2 id="TelNums" tabindex="-1">Account Telephone Numbers <a class="header-anchor" href="#TelNums" aria-label="Permalink to &quot;Account Telephone Numbers {#TelNums}&quot;">​</a></h2><p>Each Account can have zero, one, or more Telephone (PSTN) numbers assigned to it.</p><p>The Server maintains a global list of all Telephone Numbers assigned to all Accounts in all Domains.</p><p>Telephone numbers should be specified in the E.164 format: <code>+_country_code_ _area_code_ _local_number_</code>. The number should contain only digits and it can start with the plus (<code>+</code>) symbol.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><ul><li>Only when a <a href="./../cluster/Signals.html">Signal</a> (a call) comes to your CommuniGate Pro Server or Cluster, these Telephone Number mappings take effect.</li><li>An assigned Telephone Number should be registered with one of the PSTN Gateways. When a PSTN call is made to that number, the Gateway should receive the call and it should direct the call to your CommuniGate Pro Server via a VoIP protocol (such as <a href="./../signals/SIP.html">SIP</a>).<br> When a call made to a PSTN number arrives to the Server, it is usually still directed to the dialed PSTN number, and not to the user Account name. The Server uses its global list of assigned Telephone Numbers to route the call to the proper Account.</li><li>Users may want to register their assigned Telephone Numbers with one of the global <a href="./../sysadmin/Router.html#Telnum">ENUM services</a>.<br> If a Telephone number is linked to a CommuniGate Pro Domain using such a service, VoIP calls made by users of all VoIP systems employing that ENUM service will be routed to the CommuniGate Pro Account directly, via the Internet, bypassing PSTN.</li></ul></div><p>To manage the Account Telephone Numbers, open the WebAdmin Account Management pages, then open the Call Settings page in the Real-Time section:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Telephone Numbers</b></td></tr><tr><td align="center"><input name="AliasName" value="+74992713154 " size="50" maxlength="127" type="text"></td></tr><tr><td align="center"><input name="AliasName" value="+74992713155" size="50" maxlength="127" type="text"></td></tr><tr><td align="center"><input name="AliasName" value="" size="50" maxlength="127" type="text"></td></tr></tbody></table></div></form><p>You can modify existing Telephone Numbers, you can add a Telephone Number by typing a new name in the empty field, and you can remove a Telephone Number by deleting it from its field. Use the Update button to update the Telephone Numbers list.</p><p>See the <a href="./../signals/PSTN.html">PSTN</a> section for more details.</p><h2 id="AccessRights" tabindex="-1">Access Rights <a class="header-anchor" href="#AccessRights" aria-label="Permalink to &quot;Access Rights {#AccessRights}&quot;">​</a></h2><p>The CommuniGate Pro Server maintains an Access Control List (ACL) for every Account.</p><p>The Access Control Lists are used to control what other users can do with this Account.</p><p>A Server Administrator with the <a href="./../sysadmin/#Privs">All Domains</a> access right has all access rights to all Server or Cluster Accounts.</p><p>The Account owner can grant certain limited access rights to other users, controlled with a <a href="./../sysadmin/Security.html#ACL">Access Control List</a>.</p><p>The following Account access rights are supported:</p><ul><li><p><code>c</code> (CreateMailbox)</p><p>If you grant a user the CreateMailbox access right, that user will be able to create Mailboxes on the &quot;top&quot; of your Account (i.e. Mailboxes that are not sub-Mailboxes of existing Mailboxes in your Account).</p></li><li><p><code>x</code> (Delegate)</p><p>If you grant a user the Delegate access right, that user will be able to subscribe to the Account <a href="./../cluster/Signals.html#Events">Event packages</a>, access all folders of the Account and create calendar events on the Account behalf.</p></li><li><p><code>j</code> (CallControl)</p><p>If you grant a user the CallControl access right, that user will be able to access the information about your real-time communications.<br> This information includes the data about <a href="./../cluster/Signals.html">Signal</a> objects handling your incoming calls, and it can be used to <a href="./PBXServices.html#InPickup">intercept your incoming calls</a> (&quot;call pick-up&quot;).</p></li></ul><p>The Account Access Control Lists can be set and modified using the <a href="./WebMail.html#AccessRights">WebUser Interface</a>, a <a href="./../access/XIMSS.html">XIMSS</a>, or a <a href="./../access/MAPI.html">MAPI</a> client.</p><h2 id="fullTextSearch" tabindex="-1">Full-Text Search <a class="header-anchor" href="#fullTextSearch" aria-label="Permalink to &quot;Full-Text Search {#fullTextSearch}&quot;">​</a></h2><p>To use <a href="./../sysadmin/#fullTextSearch">Full-Text Search</a> you must enable Indexing for User. Until then, it is not possible to build <a href="./../sysadmin/#searchIndex">Search Index</a> either on existing mailbox messages or to index new ones. Once Indexing is enabled, you must build the <a href="./../sysadmin/#searchIndex">Search Index</a> once. If for some reason the <a href="./../sysadmin/#searchIndex">Search Index</a> for a User has been disabled, even for a short time, its contents may be out of date and re-indexing may be required after re-enabling.</p>',27)),t[43]||(t[43]=e("form",{action:"Null.html"},[e("table",{width:"100%",class:"settingsBox"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"4"},[e("b",null,"Search Index")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Search Index: "),e("td",null,[e("select",{class:"popup",name:"FtsEnabled"},[e("option",{value:"-2"},"default(Disabled)"),e("option",{value:"-1"},"Disabled"),e("option",{value:"0",selected:"selected"},"Enabled")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Status: "),e("td",null,"Ready")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Size: "),e("td",{nowrap:"nowrap"},"2286 K")]),e("tr",null,[e("td",null,[e("input",{name:"Index",value:"Index",class:"button",type:"reset"})])])])])],-1)),t[44]||(t[44]=e("div",{class:"tip custom-block"},[e("p",{class:"custom-block-title"},"Note"),e("p",null,[o("Building "),e("a",{href:"./../sysadmin/#searchIndex"},"Search Index"),o(" for large (more than 1 GB) mailboxes can take a significant time, so it is recommended to run Indexing during times of low Server load.")])],-1)),t[45]||(t[45]=e("p",null,[o("If "),e("a",{href:"./../sysadmin/#searchIndex"},"Search Index"),o(" is disabled, its data can be deleted to free up disk space. To do this, click the “Clear Index” button.")],-1)),t[46]||(t[46]=e("form",{action:"Null.html"},[e("table",{width:"100%",class:"settingsBox"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"4"},[e("b",null,"Search Index")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Search Index: "),e("td",null,[e("select",{class:"popup",name:"FtsEnabled"},[e("option",{value:"-2",selected:"selected"},"default(Disabled)"),e("option",{value:"-1"},"Disabled"),e("option",{value:"0"},"Enabled")])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Status: "),e("td",null,"Ready")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Size: "),e("td",{nowrap:"nowrap"},"2286 K")]),e("tr",null,[e("td",null,[e("input",{name:"RemoveIndex",value:"Clear Index",class:"button",type:"reset"})])])])])],-1)),t[47]||(t[47]=e("h2",{id:"Rename",tabindex:"-1"},[o("Renaming Accounts "),e("a",{class:"header-anchor",href:"#Rename","aria-label":'Permalink to "Renaming Accounts {#Rename}"'},"​")],-1)),t[48]||(t[48]=e("p",null,"If you want to rename an Account, open its Settings page, and enter a new Account name into the New Account Name field. Click the Rename Account button.",-1)),t[49]||(t[49]=e("p",null,"If there is no other Object with the same name as the specified new Account name, the Account is renamed and its Account Settings page should reappear on the screen under the new name.",-1)),t[50]||(t[50]=e("p",null,"You cannot rename an Account when it is in use.",-1)),t[51]||(t[51]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"bottom"},[e("td",{align:"right",nowrap:"nowrap"},"New Account Name:"),e("td",null,[e("input",{name:"NewName",size:"18",maxlength:"200",type:"text"})]),e("td",{rowspan:"2"},[e("input",{name:"Remove",value:"Remove Account",class:"buttonRed",type:"reset"})])]),e("tr",null,[e("td",null," "),e("td",null,[e("input",{name:"Rename",value:"Rename Account",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"Block",value:"Block Account",class:"button",type:"reset"})])])])])])],-1)),t[52]||(t[52]=i('<p>If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Accounts</a> Access Right to rename Accounts in your Domain.</p><p>You can move an Account into a different Domain, if you specify the new Account name as <code>_newName_@_domainName_</code>.<br> If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Accounts</a> Access Right for both Domains.</p><h2 id="Remove" tabindex="-1">Removing Accounts <a class="header-anchor" href="#Remove" aria-label="Permalink to &quot;Removing Accounts {#Remove}&quot;">​</a></h2><p>If you want to remove an Account, open its Settings page, and click the Remove Account button. The confirmation page should appear.</p><p>If you confirm the action, the selected Account, all its Mailboxes, Settings, and other Account-related data files will be permanently removed from the Server disks.</p><p>The Account Aliases and all Mailing List owned by this Account will be removed, too.</p><p>You cannot remove an Account when it is in use.</p><p>If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Accounts</a> Access Right to remove Accounts from your Domain.</p><h2 id="Block" tabindex="-1">Blocking Accounts <a class="header-anchor" href="#Block" aria-label="Permalink to &quot;Blocking Accounts {#Block}&quot;">​</a></h2><p>If necessary, you can fully or partially block the Account, open its Settings page, and click the Block Account button. A page with a confirmation request and blocking options should appear.</p><p>If the Account is being blocked fully, no blocking options are available. No service will work, login by any means will be disabled, emails will not be delivered. The Account will not be counted in the licenses.</p><p>If the Account is being blocked partially, the options of preventing Login to Account and Deleting emails are available. All services will continue to work.</p><p>After blocking, &quot;Account is Blocked&quot; will appear at the top of the page. Regardless of the type of blocking mode, no data will be lost. In case of renaming, the User will remain blocked. After unblocking the user will be able to continue using the Account as before.</p><p>If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Accounts</a> Access Right for both Domains.</p><h2 id="Unblock" tabindex="-1">Unblocking Accounts <a class="header-anchor" href="#Unblock" aria-label="Permalink to &quot;Unblocking Accounts {#Unblock}&quot;">​</a></h2><p>Both full and partial blocking of the Account are reversible. Open the page with its Settings and click the Unblock Account button. The confirmation page should appear.</p><p>After unblocking, the Account status will return to the state before blocking. No data will be lost and no settings will be reset.</p><p>If you are a Domain Administrator, you should have the <a href="./../sysadmin/#DomainPrivs">Can Create Accounts</a> Access Right for both Domains.</p><h2 id="DefSpecs" tabindex="-1">Default Account Settings <a class="header-anchor" href="#DefSpecs" aria-label="Permalink to &quot;Default Account Settings {#DefSpecs}&quot;">​</a></h2><p>An Account setting can have the <code>default</code> value. In this case the actual setting value is taken from the Default Account Settings for the Account Domain.<br> You can modify the Default Account Setting values by clicking the Account Defaults link on any Domain administration page of the WebAdmin Interface.</p><p>The Default Account Settings page resembles a regular Account Settings page.</p><p>The Domain Default Account Settings themselves can be assigned the <code>default</code> value.<br> In this case the setting value is retrieved from the Server-wide or Cluster-wide <em>Default Account Settings</em>.<br> You can modify the server-wide Default Account Settings by clicking the Account Defaults link on the Domains (Domain List) page.</p><p>A Dynamic <a href="./../cluster/">Cluster</a> installation maintains separate server-wide Default Account Settings for all Accounts in non-Shared (Local) Domains, and cluster-wide Default Account Settings for all Accounts in the Shared Domains. In the Cluster environment, the Default Account Settings page displays links that allow you to switch between the Server-wide and Cluster-wide Default Settings.</p><p><img src="'+l+'" alt="Settings"></p><p>Example:</p><table tabindex="0"><thead><tr><th></th><th></th><th></th></tr></thead><tbody><tr><td>The global (Server)</td><td>Default Account Settings:</td><td><code>Storage Limt = 10Mbytes</code></td></tr><tr><td><code>company.dom</code></td><td>Default Account Settings:</td><td><code>Storage Limt = 30Mbytes</code></td></tr><tr><td><code>client1.dom</code></td><td>Default Account Settings:</td><td><code>Storage Limt = default</code></td></tr></tbody></table><p>Now:</p><ul><li>If you create an Account in any Domain, and set its <code>Storage Limit</code> to some value, that value will be used.</li><li>If you create an Account in the <code>company.dom</code> Domain, and set its <code>Storage Limit</code> value to <code>default</code>, the Account will be able to keep up to 30Mbytes of mail (the Default Account Setting for that Domain).</li><li>If you create an Account in the <code>client1.dom</code> Domain, and set its <code>Storage Limit</code> value to <code>default</code>, the Account will be able to keep up to 10Mbytes of mail (the global Default Account Setting for the Server).</li></ul><p>When you serve many Accounts, you should try to specify most of the setting values as <code>default</code>, so you can easily change those settings for all Accounts. If some Account should be treated differently, you should explicitly specify the required setting value for that Account.</p><h2 id="ServiceClass" tabindex="-1">Class of Service <a class="header-anchor" href="#ServiceClass" aria-label="Permalink to &quot;Class of Service {#ServiceClass}&quot;">​</a></h2><p>A Class of Service is an additional named Default Account Settings set. You can have several sets within each Domain, and you can specify a set to use for each Account, so Accounts in the same Domain can have different Default Settings.</p><p>To create a new Class of Service, use the WebAdmin Interface to open the Account Defaults page (a Domain one, a Server-wide, or a Cluster-wide one).</p><p>If you are a Server Administrator, or a Domain Administrators with the <a href="./../sysadmin/#DomainPrivs">ServiceClasses Access Right</a>, you can create additional Classes of Service:</p>',33)),t[53]||(t[53]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"bottom"},[e("td",{nowrap:"nowrap",align:"RIGHT"},"New Class of Service Name:"),e("td",null,[e("input",{name:"NewServiceClass",type:"text",size:"18",maxlength:"200",value:"Premium"})]),e("td",{rowspan:"2"},[e("input",{name:"CreateServiceClass",type:"reset",value:"Create Class of Service",class:"button"})])])])])])],-1)),t[54]||(t[54]=i('<p>Enter the new Class of Service name and click the Create Class of Service button. A new Class of Service will be created.</p><p>The Account Defaults page lists all created Classes of Service:</p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Classes of Service</b></td></tr><tr><td><a href="#ServiceClass">FreeUser</a></td><td><a href="#ServiceClass">Basic</a></td></tr><tr><td><a href="#ServiceClass">Premium</a></td><td><a href="#ServiceClass">Business</a></td></tr></tbody></table></div><p>To open the Class of Service settings, click its name. The Class of Service settings page is the same as the Account Defaults page.</p><p>Account Defaults can be viewed as an unnamed Class of Service.</p><p>If you are a Server Administrator, or a Domain Administrators with the <a href="./../sysadmin/#DomainPrivs">ServiceClasses Access Right</a>, you can rename or remove Classes of Service. Use the WebAdmin Interface to open the Class of Service page, and scroll to the bottom of the page:</p>',6)),t[55]||(t[55]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"bottom"},[e("td",{nowrap:"nowrap",align:"RIGHT"},"New Class of Service Name:"),e("td",null,[e("input",{name:"NewServiceClass",type:"text",size:"18",maxlength:"200",value:"Business"})]),e("td",{rowspan:"2"},[e("input",{name:"RemoveServiceClass",type:"reset",value:"Remove Class of Service",class:"buttonRed"})])]),e("tr",null,[e("td",null," "),e("td",null,[e("input",{name:"RenameServiceClass",type:"reset",value:"Rename Class of Service",class:"button"})])])])])])],-1)),t[56]||(t[56]=i('<p>When there is at least one Class of Service created on the Domain or Server/Cluster level, the Account Settings page includes the Class of Service setting. If you are a Server Administrator, or a Domain Administrators with the <a href="./../sysadmin/#DomainPrivs">ServiceClass Access Right</a>, you can modify this setting:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="RIGHT">Class of Service: </td><td><select name="ServiceClass"><option value=""></option><option>FreeUser</option><option>Basic</option><option selected="selected">Premium</option></select></td><td> </td></tr></tbody></table></div></form><p>When an Account Class of Service setting is not empty, the following algorithm is used to retrieve an Account settings:</p><ul><li>If the Account has a setting value explicitly assigned, that value is used.</li><li>If the Domain has a Class of Service with the specified name, and that Class of Service settings contain a setting value, that value is used.</li><li>If the Server-wide (a Cluster-wide for Accounts in shared Domains) has a Class of Service with the specified name, and that Class of Service settings contain a setting value, that value is used.</li><li>Finally, the Server-wide (a Cluster-wide for Accounts in shared Domains) Account Default settings are used to retrieve the setting value.</li></ul><p>You can create a Domain Class of Service with the same name as a Server-wide (or Cluster-wide) Class of Service to override some of its settings.</p><h2 id="Template" tabindex="-1">Account Template <a class="header-anchor" href="#Template" aria-label="Permalink to &quot;Account Template {#Template}&quot;">​</a></h2><p>When you need to create many Accounts, you may want to specify some non-default setting for all new Accounts. Each Domain has its own Account Template, and you can modify it by clicking the Template link on the Account List page.</p><p>The Accounts Template page resembles a regular Account Settings page.</p><p>All the settings set there will be copied to all newly created Accounts in this Domain.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Default Account Settings and Account Template are quite different. The Account Template is used only when an Account is being created. All template settings with non-default values are copied to the new Account settings. If you modify the template settings after an Account has been created, those Account settings will not change.</p></div><p>Besides the initial, non-Default setting values, the Account Template can be used to instruct the Server to create additional Mailboxes in each new Account (by default only the <code>INBOX</code> Mailbox is created), to subscribe the Account to certain Mailboxes, and to create Mailbox Aliases in all newly created Accounts.</p>',11)),t[57]||(t[57]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("table",{border:"0",cellpadding:"0",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("b",null,"Additional Mailboxes")]),e("td",{width:"10%"},[e("b",null,"Locked")])])])])])]),e("tr",null,[e("td",null,[e("input",{type:"text",name:"InitialMailboxes",value:"Sent",size:"20",maxlength:"100"})]),e("td",null,[e("select",{name:"T1"},[e("option",{value:"0",selected:"selected"}),e("option",{value:"1"},"IPF.Appointment"),e("option",{value:"2"},"IPF.StickyNote")])]),e("td",null,[e("input",{type:"checkbox",name:"L1",value:"1"})])]),e("tr",null,[e("td",null,[e("input",{type:"text",name:"InitialMailboxes",value:"Drafts",size:"20",maxlength:"100"})]),e("td",null,[e("select",{name:"T2"},[e("option",{value:"0",selected:"selected"}),e("option",{value:"1"},"IPF.Appointment"),e("option",{value:"2"},"IPF.StickyNote")])]),e("td",null,[e("input",{type:"checkbox",name:"L2",value:"1"})])]),e("tr",null,[e("td",null,[e("input",{type:"text",name:"InitialMailboxes",value:"Calendar",size:"20",maxlength:"100"})]),e("td",null,[e("select",{name:"T3"},[e("option",{value:"0"}),e("option",{value:"1",selected:"selected"},"IPF.Appointment"),e("option",{value:"2"},"IPF.StickyNote")])]),e("td",null,[e("input",{type:"checkbox",name:"L3",value:"1",checked:"checked"})])]),e("tr",null,[e("td",null,[e("input",{type:"text",name:"InitialMailboxes",value:"",size:"20",maxlength:"100"})]),e("td",null,[e("select",{name:"T4"},[e("option",{value:"0",selected:"selected"}),e("option",{value:"1"},"IPF.Appointment"),e("option",{value:"2"},"IPF.StickyNote")])]),e("td",null,[e("input",{type:"checkbox",name:"L4",value:"1"})])])])])])],-1)),t[58]||(t[58]=i(`<p>Enter a name into the empty field to add a Mailbox name to the list.</p><p>For non-mail Mailboxes, specify the <a href="./../storage/Mailboxes.html#Classes">Mailbox Class</a> from the pop-up menu.<br> If you select the <a href="./../storage/Mailboxes.html#Locked">Lock</a> checkbox, it will be impossible to delete or rename the created Mailbox.</p><p>In this sample, when a new multi-mailbox Account is created in this Domain, the mail Mailboxes <code>Sent</code> and <code>Drafts</code>, and the calendar Mailbox <code>Calendar</code> will be created in that Account, along with the <code>INBOX</code> Mailbox.<br> The Account users will not be able to delete or rename the Calendar Mailbox.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Initial Subscription</b></td></tr><tr><td><input name="InitialSubscription" value="INBOX" size="40" maxlength="255" type="text"></td></tr><tr><td><input name="InitialSubscription" value="Sent" size="40" maxlength="255" type="text"></td></tr><tr><td><input name="InitialSubscription" value="~public/news" size="40" maxlength="255" type="text"></td></tr><tr><td><input name="InitialSubscription" value="" size="40" maxlength="255" type="text"></td></tr></tbody></table></div></form><p>See the <a href="./../storage/Mailboxes.html#Subscription">Mailboxes</a> section to learn about Mailbox Subscriptions.</p><p>Creating initial non-empty subscription:</p><ul><li>simplifies the initial set-up of some client mailers that can access only those Account Mailboxes that are included into the Mailbox Subscription list;</li><li>helps new users to subscribe to public Mailboxes containing administrative information, news, etc.</li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Initial Mailbox Aliases</b></td></tr><tr align="left"><th>Alias Name</th><th>Mailbox Name</th></tr><tr><td><input name="a0" value="mkt-news" size="15" maxlength="255" type="text"></td><td><input name="m0" value="~marketing/announcements" size="30" maxlength="255" type="text"></td></tr><tr><td><input name="a2" value="" size="15" maxlength="255" type="text"></td><td><input name="m2" value="" size="30" maxlength="255" type="text"></td></tr></tbody></table></div></form><p>See the <a href="./../storage/Mailboxes.html#Aliases">Mailboxes</a> section to learn about Mailbox Aliases.</p><p>Specifying a non-empty list of Mailbox Aliases simplifies the initial set-up for Microsoft Outlook users that need access to public Mailbox and other <a href="./../storage/Mailboxes.html#Foreign">Foreign Mailboxes</a>, but cannot use their mailers to access foreign Mailboxes directly.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Greeting E-mail</b></td></tr><tr><td align="center"><textarea name="InitialMessage" rows="10" cols="60">From: Server Postmaster &lt;postmaster@communigatepro.ru&gt; To: New Subscriber &lt;^A@^D&gt; Subject: Welcome to our wonderful server! MIME-Version:1.0 Content-Type: text/plain Dear ^E &lt;^A@^D&gt;, We are happy to see you with us! If you ever have any problem with our service, please send e-mail to: support@^D. The support team.</textarea></td></tr></tbody></table></div></form><p>This field can contain a mail message in the RFC822 format. If this field is not empty, then the specified message is stored in the INBOX Mailbox of every newly created Account.</p><p>The text can contain the following macro combinations, replaced with the newly created Account data:</p><ul><li><code>^A</code> - the newly created Account name.</li><li><code>^D</code> - the Domain name.</li><li><code>^E</code> - the newly created Account Real Name.</li></ul><p>The <code>Date:</code> header field is automatically added to the stored messages.</p><p>The message text can start with a <code>[_charsetName_]</code> prefix, then the text will be converted from UTF-8 to the specified character set. Specify the Content-Type header field with the proper the <code>charset=</code> parameter:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Greeting E-mail</b></td></tr><tr><td align="center"><textarea name="InitialMessage" rows="10" cols="60">[ISO-8859-1] From: Server Postmaster &lt;postmaster@communigatepro.ru&gt; To: New Subscriber &lt;^A@^D&gt; Subject: Bienvenue à notre serveur merveilleux! MIME-Version:1.0 Content-Type: text/plain; charset=ISO-8859-1 Cher Client, Nous sommes heureux de vous voir avec nous!</textarea></td></tr></tbody></table></div></form><p>Templates can be used to generate an initial default Web (HTML) page in the File Storage for all newly created Accounts:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Initial Personal Home Page</b></td></tr><tr><td align="center"><textarea name="InitialWebPage" rows="6" cols="60">&lt;HTML&gt; &lt;HEAD&gt;&lt;/HEAD&gt; &lt;BODY&gt; &lt;H1&gt;This is my personal Web Page.&lt;/H1&gt; &lt;/BODY&gt; &lt;/HTML&gt;</textarea></td></tr></tbody></table></div></form><p>This field can contain an HTML text. If this field is not empty, then the specified text is stored as the Default Web Page file in the File Storage of each newly created Account.</p><h2 id="Loader" tabindex="-1">Importing User Account Information <a class="header-anchor" href="#Loader" aria-label="Permalink to &quot;Importing User Account Information {#Loader}&quot;">​</a></h2><p>The built-in Account Loader allows the administrator to register sets of users. The user names and Account attributes should be placed into a tab-delimited text file on the administrator (client) computer, and that file should be uploaded to the server using the Import field.</p><p>Click the browse button to select a file on your local system, and then click the Import Accounts button to create Accounts listed in the selected file.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="right" width="30%"><input name="Create" value="Create Account" class="button" type="reset"></td><td><input name="NewName" value="" size="20" maxlength="127" type="text"></td><td> </td><td class="arrow"><a href="#Template">Template</a></td></tr><tr><td align="right"><select name="NewType"><option value="0" selected="selected">Multi-Mailbox</option><option value="1">A-Grade</option><option value="2">B-Grade</option></select></td><td></td><td> </td><td> </td></tr><tr><td align="right"><input name="Batch" value="Import Accounts" class="button" type="reset"></td><td colspan="3"><input name="Import" type="file"></td></tr></tbody></table></div></form><p>Below is a sample IMPORT file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Name	Ignore	Storage	Aliases</span></span>
<span class="line"><span>johnd	sales dept	50M</span></span>
<span class="line"><span>susan	mgmnt	10M	susan.s,susan_smith</span></span>
<span class="line"><span>sales	dummy	30M</span></span>
<span class="line"><span>info	dummy	50M	help</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The import file must be prepared on the client computer (on the computer you use to run your browser). The browser allows you to upload files from disks connected to that computer, not to the CommuniGate Pro Server computer.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When using Netscape and some other Unix browsers, make sure that the file name ends with the <code>.txt</code> suffix - otherwise the browser won&#39;t upload the file as a text one, and the file will be ignored.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The MacOS 9.x versions of the Microsoft Internet Explorer upload Macintosh files in the encoded <code>x-macbinary</code> format if the file contains a <em>resource fork</em>. Most text files created with Macintosh text editor applications contain resource forks that keep the information about the file fonts, file window position, and other Macintosh data. Such files cannot be used as import files with the Microsoft Internet Explorer browser. Either use a text editor application that saves text files without resource forks or use a browser that uploads Macintosh files without encoding.</p></div><p>The first file line describes the file contents. It should contain tab-delimited names of Account attributes. The following names are supported:</p><ul><li><p><code>Name</code></p><p>This column contains the Account names. This attribute is not required to be in the first column, but it must exist. All other attributes are optional.</p></li><li><p><code>RealName</code></p><p>This column contains the Account user &quot;real name&quot;.</p></li><li><p><code>Password</code></p><p>This column contains the Account password. If the file does not contain this column, or this field is empty, the CommuniGate Password and the Use CommuniGate Password settings are taken from the Domain Account Template.</p></li><li><p><code>UnixPassword</code></p><p>This column can be used instead of the <code>Password</code> column. If it exists, it should contain <code>crypt</code>-encrypted Account passwords. The Account Loader will add the binary prefix to those strings, so these CommuniGate passwords will be used as <code>U-crpt</code> encrypted passwords. See the <a href="./../install/Migration.html#UnixPasswords">Migration</a> section for more details.</p></li><li><p><code>ChangePassword</code></p><p>If this column value is <code>Yes</code> string then the user will be asked to change the password on next login to the Account via <a href="./../access/WebUser.html">WebUser Interface</a> or Pronto client.</p></li><li><p><code>Storage</code></p><p>This column contains the maximum Account Mail Storage size (in bytes, or in kilobytes, if the number is followed with <code>K</code>, or in megabytes, if the number is followed with <code>M</code>). The column data can contain <code>-1</code> or <code>unlimited</code> to specify unlimited storage.</p></li><li><p><code>Aliases</code></p><p>This column contains the Account Aliases; to specify several Aliases, separate them with the comma symbol.</p></li><li><p><code>Telnums</code></p><p>This column contains the Account Telnums; to specify several Telnums, separate them with the comma symbol.</p></li><li><p><code>MailInRules</code></p><p>This column contains the Account <a href="./../mail/QueueRules.html">Mail Processing Rules</a>. Rules should be represented in the internal format, as an <a href="./../../development/Data.html#Array">array</a> of individual Rules. Each Rule is an array, where the first element is the Rule priority, the second element is the Rule Name <a href="./../../development/Data.html#Formats">string</a>, the third element is the Rule conditions array, and the last element is the Rule Actions array.</p></li><li><p><code>SignalInRules</code></p><p>This column contains the Account <a href="./../signals/SignalRules.html">Signal Processing Rules</a>.</p></li><li><p><code>Ignore</code></p><p>This column is ignored. An Account list file can contain several Ignore columns.</p></li><li><p><code>_setting name_</code></p><p>You can use columns that contain initial values for various additional Account settings (File Storage file and size limit, type or Rule actions enabled, etc.). Any additional column should have the same name as the selected Account setting name (keyword). For example, you can use the column named <code>MaxWebSize</code> to specify the storage limit for the Account File Storage, and you can also use the column named <code>MaxAccountSize</code> instead of the <code>Storage</code> column.</p></li><li><p><code>_Custom Setting_</code></p><p>You can use columns that contain initial values for various <a href="./../directory/CentralDir.html#CustomSettings">Custom Account Settings</a>. For example, if the Directory Integration page contains the Custom Setting <code>city</code>, you can include a column named <code>city</code> in your Account Import file.</p></li></ul><p>If the first line is parsed, all other lines are processed. Each line should contain tab-delimited fields, with the field contents specified in the first line. A line can contain less fields than the first line, in this case missing fields are processed as empty fields.</p><p>Attribute values for empty and missing fields are taken from the <a href="#Template">Account Template</a>.</p><p>If an error occurs while processing some file line (missing name field, duplicate name, etc.), all Accounts created while processing previous lines are removed, and the number of the line that caused the problem is displayed. You can fix the file and try again.</p>`,34))])}const T=s(d,[["render",v]]);export{I as __pageData,T as default};
