import{_ as o,c as t,o as a,ag as n}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"Chronos","description":"","frontmatter":{"legacyLink":"Chronos.html"},"headers":[],"relativePath":"admin/objects/Chronos.md","filePath":"admin/objects/Chronos.md"}'),s={name:"admin/objects/Chronos.md"};function r(i,e,l,h,c,d){return a(),t("div",null,e[0]||(e[0]=[n('<h1 id="chronos" tabindex="-1">Chronos <a class="header-anchor" href="#chronos" aria-label="Permalink to &quot;Chronos&quot;">​</a></h1><p>The Chronos component is used to schedule and perform automatic tasks for CommuniGate Pro Accounts.</p><p>These tasks include:</p><ul><li><a href="#MailClean">Mailbox cleaning and archiving</a></li><li>Calendar notifications</li><li><a href="./../mail/RPOP.html">Remote POP (RPOP) polling</a></li><li><a href="./../signals/PSTN.html#RSIP">Remote SIP (RSIP) registrations</a></li></ul><p>In the CommuniGate Pro <a href="./../cluster/Dynamic.html">Dynamic Cluster</a> environment, the Chronos component scheduler runs on the Cluster Controller, distributing the Chronos tasks to all available backend Servers.</p><h2 id="Schedule" tabindex="-1">Scheduled Tasks <a class="header-anchor" href="#Schedule" aria-label="Permalink to &quot;Scheduled Tasks {#Schedule}&quot;">​</a></h2><p>Any CommuniGate Pro component can schedule a Chronos Task for a CommuniGate Pro Account. When a new Chronos Task is scheduled, the Account is placed into the Chronos process activation queue. At the scheduled time a Chronos processor thread opens the Accounts and performs the requested Task, re-scheduling the Account.</p><h2 id="Config" tabindex="-1">Configuring the Chronos Component <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the Chronos Component {#Config}&quot;">​</a></h2><p>You can use the WebAdmin Interface to configure the Chronos component. Open the General pages in the Settings realm, then open the Others page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Chronos</b></td></tr><tr><td align="RIGHT" width="20%">Log Level:</td><td><select name="ChronosLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Chronos component should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code> (Chronos task completion reports), or <code>Problems</code> (failures, completion reports, and non-fatal errors) levels. When you experience problems with the Chronos component, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case the Chronos processing internals will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The Chronos component records in the System Log are marked with the <code>CHRONOS</code> tag.</p></li></ul><h2 id="MailClean" tabindex="-1">Mailbox Cleaning and Archiving <a class="header-anchor" href="#MailClean" aria-label="Permalink to &quot;Mailbox Cleaning and Archiving {#MailClean}&quot;">​</a></h2><p>The Chronos component can automatically clean and archive the Account Mailboxes.</p><p>If the Archive Messages after <a href="./Accounts.html#Mail">Account setting</a> is set to any value other than Never, then all messages from the <code>INBOX</code> and <code>_SentItem_</code> Mailboxes which are older than the specified time period are moved to the<br><code>Archive/_YYYY_-_MM_</code><br> Mailboxes, where <em>YYYY</em> is the year number and <em>MM</em> is the month number of the moved messages &quot;internal date&quot;.<br> The <em>SentItem</em> Mailbox name is specified with the Account Preferences.</p><p>If the Delete Messages after <a href="./Accounts.html#Mail">Account setting</a> is set to any value other than Never, all messages from all Account Mailboxes which are older than the specified time period are periodically deleted.</p><div class="warning custom-block"><p class="custom-block-title">Warning!</p><p>This process does not apply to Mailboxes with a non-empty <a href="./../storage/Mailboxes.html#Classes">Mailbox Class</a> - i.e. to Calendar, Contacts, Tasks, Notes, and other non-mail Mailboxes.</p><p>The Archive Mailboxes created to copy <code>INBOX</code> and <code>_SentItem_</code> messages are created with a non-empty Mailbox Class.</p></div>',16)]))}const u=o(s,[["render",r]]);export{p as __pageData,u as default};
