import{_ as r,c as s,o as i,ag as o,j as e,a as t}from"./chunks/framework.jCcxW76o.js";const b=JSON.parse('{"title":"Groups","description":"","frontmatter":{"legacyLink":"Groups.html"},"headers":[],"relativePath":"admin/objects/Groups.md","filePath":"admin/objects/Groups.md"}'),n={name:"admin/objects/Groups.md"};function l(d,a,p,c,m,h){return i(),s("div",null,a[0]||(a[0]=[o('<h1 id="groups" tabindex="-1">Groups <a class="header-anchor" href="#groups" aria-label="Permalink to &quot;Groups&quot;">​</a></h1><p>CommuniGate Pro Domains can contain Group objects. A Group contains a set of group members. Group members are other objects in the same Domain and/or external E-mail addresses. Each Group has its own Settings.</p><p>Messages sent to a Group are processed with the <a href="./../mail/LIST.html">LIST module</a>. The module copies the messages without any modification of any header field, and it resubmits them using the Group members to fill the envelope recipient list.</p><p>Administrators can create Group objects to simplify mailing to logical groups of users (&quot;marketing&quot;, &quot;sales&quot;, etc.). A message can be addresses to a simple <code>groupname@domain.dom</code> address, and the server will distribute it to all groupname Group members.</p><p>Real-time (IM, audio, video, etc.) requests sent to a Group are processed with the <a href="./../cluster/Signals.html">Signal</a> component. These requests are &quot;forked&quot; to all Group members.</p><h2 id="Create" tabindex="-1">Creating a New Group <a class="header-anchor" href="#Create" aria-label="Permalink to &quot;Creating a New Group {#Create}&quot;">​</a></h2><p>Groups in any Domain can be created by the Server Administrator if the administrator Account has the Can Modify All Accounts And Domain Settings access right.</p><p>A Domain Administrator can create, remove, and rename groups only if the CanCreateGroups access right is granted to the administrator account.</p><p>To create a new group, type a new group name into the field on the right side of the Create Group button.<br> The selected Group name should meet the <a href="./Domains.html#Provision">Domain Object</a> name restrictions.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="right" width="30%"><input name="CreateGroup" value="Create Group" class="button" type="reset"></td><td><input name="NewGroupName" value="" size="20" maxlength="127" type="text"></td><td colspan="2"> </td></tr></tbody></table></div></form><p>Click the Create Group button. When a new group is created, its name appears in the list. The Server automatically displays the <a href="#Settings">Settings page</a> for the new group.</p><h2 id="Settings" tabindex="-1">Specifying Group Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;Specifying Group Settings {#Settings}&quot;">​</a></h2><p>To specify Group Settings, click the Group name on the Objects list page. The Group Settings page appears.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="right">Real Name: <input type="text" name="RealName" value="Sales Group" size="40" maxlength="255"></td><td align="right">Search Filter: <input type="text" name="MembersURI" value="directory://cn=my.domain?mail?sub?(&amp;(objectClass=inetOrgPerson)(ou=Sales))" size="40" maxlength="255"></td></tr><tr><td><input type="checkbox" name="FinalDelivery" value="1">Report Delivery to Group</td><td><input type="checkbox" name="SetReplyTo" value="1" checked="checked">Set Reply-To to Group</td></tr><tr><td><input type="checkbox" name="Expand" value="1" checked="checked">Expand Member Groups</td><td><input type="checkbox" name="RejectAuto" value="1" checked="checked">Reject Automatic Messages</td></tr><tr><td><input type="checkbox" name="RemoveAuthor" value="1" checked="checked">Remove Author from Distribution</td><td><input type="checkbox" name="RemoveToAndCc" value="1" checked="checked">Remove To and Cc from Distribution</td></tr><tr><td><input type="checkbox" name="EmailDisable" value="1" checked="checked">Disable E-mails</td><td><input type="checkbox" name="LiveDisable" value="1" checked="checked">Disable Signals</td></tr><tr><td><input type="checkbox" name="EmailDisable" value="1" checked="checked">E-mails from Member Only</td><td><input type="checkbox" name="HideInDirectory" value="1" checked="checked">Hide In Directory</td></tr></tbody></table></div></form><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Members</b></td></tr><tr><td align="center"><input type="text" name="Members" value="john" size="80" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="Members" value="jim" size="80" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="Members" value="susan" size="80" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="Members" value="bill@partner.dom" size="80" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="Members" value="" size="80" maxlength="1000"></td></tr></tbody></table></div></form><ul><li><p><code>Members</code></p><p>This is the list of static Group members. If the member name does not contain a domain part, it specifies an object in the same Domain: a Domain Account or some other Group.<br> The last empty element of the table allows the administrator to add a new static member to the Group. To delete a member from the Group, delete the member name and click the Update button.<br> You can enter several addresses in one field, separating them with the comma (<code>,</code>) symbol. After you click the Update button, each address will be displayed in a separate field.</p></li><li><p><code>RealName</code></p><p>A brief description of the Group. This string is used to compose the comment for this Group E-mail or Signal address.</p></li><li><p><code>Search Filter</code></p><p>An LDAP URI that specifies serach parameters in the Central Directory. The queries using this parameter are used to collect dynamic members of the group. The supported scheme is <code>directory://</code> or <code>ldap://</code>. With the latter scehme the host name should be omitted or should specify loopback address, as searching only within the local Central Directory is supported in the current versions.</p></li><li><p><code>Report Delivery to Group</code></p><p>If this option is selected, then a delivery report (if requested) is generated as soon as an E-mail message is copied and re-submitted for delivery to all Group members. If subsequent delivery to any Group member fails, error reports are not generated.<br> If this option is not selected, delivery to this Group is processed as &quot;relaying&quot;, and the delivery notification options are copied to addresses of all Group members.<br> If delivery to any Group member fails, the sender gets an error message.<br> If a message was sent with delivery notification requested, the sender will get notification delivery from all Group members.</p></li><li><p><code>Set Reply-To to Group</code></p><p>If this option is selected, the Reply-to: header pointing to the Group address is added to the message copy before it is sent to Group members. This ensures that replies to a message sent to this Group will go back to the Group, not to the message author.</p></li><li><p><code>Expand Member Groups</code></p><p>If this option is selected, the Group members are checked before a message is copied and sent to member addresses. If a Group member is some other Group in the same Domain, then that Group members are extracted and inserted into the address list. If that Group also has this option enabled, the extracted members are checked, too. This option allows to process Group delivery more efficiently (only one message copy is created for all recipients) and it also helps to avoid duplicates and mail loops.<br> If the Group contains 2 other groups (sub-groups) as members and those sub-groups contain the same address, then only one copy of the message is delivered to that address if the Expand option is enabled. If this option is disabled, the copy of the original message will be delivered to both sub-groups, and each sub-group will send its copy of the original message to that address.</p></li><li><p><code>Reject Automatic Messages</code></p><p>If this option is selected, automatic messages (i.e. not &quot;<a href="./../mail/QueueRules.html#HumanGenerated">Human-Generated</a>&quot; messages) cannot be sent to this Group.</p></li><li><p><code>Remove Author from Distribution</code></p><p>If this option is selected, the message <code>From:</code>address is removed from the (optionally expanded) members list.</p></li><li><p><code>Remove To and Cc from Distribution</code></p><p>If this option is selected, all addresses from the message To and Cc fields are removed from the (optionally expanded) members list.</p></li><li><p><code>Disable E-mails</code></p><p>If this option is selected, <a href="./../mail/">E-mail messages</a> sent to this Group are rejected.</p></li><li><p><code>Disable Signals</code></p><p>If this option is selected, <a href="./../cluster/Signals.html">Real-Time Signals</a> sent to this Group are rejected.</p></li><li><p><code>E-mails from Member Only</code></p><p>If this option is selected, <a href="./../mail/">E-mail messages</a> sent to this Group are delivered only if sent by its members.</p></li><li><p><code>Hide in Directory</code></p><p>If this option is selected, a record in the <a href="./../directory/CentralDir.html">Directory</a> for this Group is not created.</p></li></ul><h2 id="fullTextSearch" tabindex="-1">Full-Text Search <a class="header-anchor" href="#fullTextSearch" aria-label="Permalink to &quot;Full-Text Search {#fullTextSearch}&quot;">​</a></h2><p>To use <a href="./../sysadmin.html#fullTextSearch">Full-Text Search</a> on mailbox messages of Group members, you need to build a <a href="./../sysadmin.html#searchIndex">Search Index</a>. This can be useful if you want to provide quick search access for a specific category of users - for example, a prioritized Group - without waiting for a full Indexing of all Domain Users. If Domain Users have <a href="./../sysadmin/#searchIndex">Search Index</a> disabled by default, the “Enable Indexing for all Users in the Group” option is available for Group members. In this case Indexing will be enabled in the settings of each User who is a member of the Group.</p>',18),e("form",{action:"Null.html"},[e("table",{width:"100%",class:"settingsBox"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"4"},[e("b",null,"Search Index")])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},[e("input",{type:"checkbox",name:"EnableFTSForAll",value:"1"}),t(" Enable Search Index for All Accounts in Group ")])]),e("tr",null,[e("td",null,[e("input",{name:"Index",value:"Index",class:"button",type:"reset"})])])])])],-1),o('<h2 id="MemberProc" tabindex="-1">Group Members Processing <a class="header-anchor" href="#MemberProc" aria-label="Permalink to &quot;Group Members Processing {#MemberProc}&quot;">​</a></h2><p>The CommuniGate Pro Server can do certain &quot;reverse processing&quot; operations with Group members by finding Groups containing a certain Domain object (such as an Account, a Group, or a Forwarder).</p><p>When a Domain object is removed, the Server removes the object name from all Groups in that Domain.</p><p>When a Domain object is renamed, the Server updates the object name in all Groups in that Domain.</p><p>When an Account user is trying to open a <a href="./../storage/Mailboxes.html#Foreign">Foreign Mailbox</a>, the Server checks the <a href="./../storage/Mailboxes.html#ACL">Mailbox Access Rights</a> granted to all Groups containing that Account.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To allow the Server to find an object in Group member lists, the member lists should contain the &quot;real&quot; object name, not its Alias (or any other name <a href="./../sysadmin/Router.html">routed</a> to the object name).</p></div><h2 id="Rename" tabindex="-1">Renaming Groups <a class="header-anchor" href="#Rename" aria-label="Permalink to &quot;Renaming Groups {#Rename}&quot;">​</a></h2><p>If you want to rename a Group, open its Settings page, fill the New Group Name field, and click the Rename Group button.</p><p>If there is no other Object with the same name as the specified new Group name, the Group is renamed and its Group Settings page should reappear on the screen under the new name.</p>',9),e("form",{action:"Null.html"},[e("table",{class:"settingsBox",cellpadding:"3",width:"90%"},[e("tbody",null,[e("tr",null,[e("td",{valign:"bottom"},[e("input",{name:"Remove",value:"Remove Group",class:"buttonRed",type:"reset"})]),e("td",{valign:"bottom"},[t("New Group Name:"),e("br"),e("input",{name:"NewName",size:"18",maxlength:"255",type:"text"}),e("br"),e("input",{name:"Rename",value:"Rename Group",class:"button",type:"reset"})])])])])],-1),e("h2",{id:"Remove",tabindex:"-1"},[t("Removing Groups "),e("a",{class:"header-anchor",href:"#Remove","aria-label":'Permalink to "Removing Groups {#Remove}"'},"​")],-1),e("p",null,"If you want to remove a Group, open its Settings page, and click the Remove Group button.",-1)]))}const g=r(n,[["render",l]]);export{b as __pageData,g as default};
