import{_ as o,c as s,o as i,ag as a,j as e,a as n}from"./chunks/framework.jCcxW76o.js";const g=JSON.parse('{"title":"Named Task","description":"","frontmatter":{"legacyLink":"NamedTasks.html"},"headers":[],"relativePath":"admin/objects/NamedTasks.md","filePath":"admin/objects/NamedTasks.md"}'),r={name:"admin/objects/NamedTasks.md"};function m(c,t,d,h,l,p){return i(),s("div",null,t[0]||(t[0]=[a('<h1 id="named-task" tabindex="-1">Named Task <a class="header-anchor" href="#named-task" aria-label="Permalink to &quot;Named Task&quot;">​</a></h1><p>The CommuniGate Pro Server provides special Domain Objects - &quot;Named Tasks&quot;. When a Real-Time Signal is addressed to the Named Task name, the Server launches a Real-Time Application specified for that Named Task, and passes the Signal to that Application instance. When new Signals are directed to the same address, they are delivered to the same Application instance.</p><p>Named Tasks are used to implement collaboration services, such as XMPP-style &quot;chatrooms&quot;.</p><h2 id="Create" tabindex="-1">Creating a New Named Task <a class="header-anchor" href="#Create" aria-label="Permalink to &quot;Creating a New Named Task {#Create}&quot;">​</a></h2><p>Named Tasks in any Domain can be created by the Server Administrator if the administrator Account has the Can Modify All Accounts And Domain Settings access right.</p><p>A Domain Administrator can create, remove, and rename Named Tasks only if the CanCreateNamedTasks access right is granted to the administrator Account.</p><p>To create a Named Task, create an Account or choose an existing one - the Named Task owner Account.<br> Use the WebAdmin Interface to open the <a href="./Accounts.html">Account Settings</a> pages, then open the Call Settings page in the Real-Time section, and find the Named Tasks panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Named Tasks</b></td></tr><tr align="left"><th>Name</th><th align="center">Program Name</th></tr><tr><td><a href="#">projectx-talk</a></td><td align="center">chatroom</td></tr><tr><th colspan="2" align="left"><input name="NewTask" value="Create Named Task" class="button" type="reset"> <input name="NewTaskName" size="20" maxlength="255" type="text"></th></tr></tbody></table></div></form><p>Enter the name of the Named Task to create and click the Create Named Task button.</p><p>The Server checks that there is no Account or other <a href="./">Object</a> with the same name in this Domain, and creates a new Named Task.</p><h2 id="Settings" tabindex="-1">Specifying Named Task Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;Specifying Named Task Settings {#Settings}&quot;">​</a></h2><p>To specify Named Task Settings, click the Named Task name on the owner Account Settings page. The Named Task Settings page appears.</p>',12),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right"},"Owner:"),e("td",{nowrap:"nowrap",class:"settingFixed"},[e("a",{href:"Accounts.html"},"jksmith")])]),e("tr",null,[e("td",{align:"right"},"Real Name:"),e("td",null,[e("input",{type:"text",name:"RealName",value:"Proejct X chatroom",size:"40",maxlength:"255"})])]),e("tr",null,[e("td",{align:"right"},"Program Name:"),e("td",null,[e("input",{type:"text",name:"ProgramName",value:"chatroom",size:"40",maxlength:"255"})])])])])])],-1),a('<ul><li><p><code>RealName</code></p><p>A brief description of the Named Task.</p></li><li><p><code>Program Name</code></p><p>The <a href="./../../development/PBXApp.html">Real-Time Application</a> name. The Named Task runs one instance of this Application. To update the Named Task settings, click the Update button.</p></li></ul><h2 id="Rename" tabindex="-1">Renaming Named Tasks <a class="header-anchor" href="#Rename" aria-label="Permalink to &quot;Renaming Named Tasks {#Rename}&quot;">​</a></h2><p>If you want to rename a Named Task, open its Settings page, fill the New Named Task Name field, and click the Rename Named Task button.</p><p>If there is no other Object with the same name as the specified new Named Task name, the Named Task is renamed and its Named Task Settings page should reappear on the screen under the new name.</p>',4),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{valign:"bottom"},[e("input",{name:"Remove",value:"Remove Named Task",class:"buttonRed",type:"reset"})]),e("td",{valign:"bottom"},[n("New Named Task Name:"),e("br"),e("input",{name:"NewName",size:"18",maxlength:"255",type:"text"}),e("br"),e("input",{name:"Rename",value:"Rename Named Task",class:"button",type:"reset"})])])])])])],-1),a('<h2 id="Remove" tabindex="-1">Removing Named Task <a class="header-anchor" href="#Remove" aria-label="Permalink to &quot;Removing Named Task {#Remove}&quot;">​</a></h2><p>If you want to remove a Named Task, open its Settings page, and click the Remove Named Task button.</p><h2 id="Temporary" tabindex="-1">Temporary Named Tasks <a class="header-anchor" href="#Temporary" aria-label="Permalink to &quot;Temporary Named Tasks {#Temporary}&quot;">​</a></h2><p>The CommuniGate Pro Server allows it users to create temporary Named Tasks. These Task are assigned a temporary name, and they are started immediately. When a temporary Named Task ends, its name is released and can be reused for other Objects in the same Domain.</p><p>Temporary Named Tasks can be used to create ad-hoc Instant Messaging chatrooms. When an XMPP or XIMSS client sends a request to retrieve a &quot;unique room name&quot;, a Temporary Named Task running the <code>chatroom</code> Real-Time Application is created and started, and its name is reported to the client.</p><h2 id="Chatroom" tabindex="-1">Chatrooms <a class="header-anchor" href="#Chatroom" aria-label="Permalink to &quot;Chatrooms {#Chatroom}&quot;">​</a></h2><p>CommuniGate Pro implements XMPP-style chatrooms (multi-party Instant Messaging sessions) using the Real-Time Application <code>chatroom</code>.</p><p>The Application implements the chatroom according to the XEP-0045 specification.</p><p>The <code>chatroom</code> Application implements the following additional functions:</p><ul><li><p>logging</p><p>the conversation log is stored in the owner Account file storage, as the <code>private/chatlogs/_taskName_/_YYYY_-_MM_.log</code> text files, where <em>taskName</em> is the chatroom (Named Task) name, <em>YYYY</em> is the year, and <em>MM</em> is the month number.</p></li><li><p>command line interface</p><p>a user can send a &quot;groupchat&quot; Instant Message starting with the #cmd: prefix. The rest of the message is interpreted as a command. The command is executed subject to the sending user current &quot;role&quot; and &quot;affiliation&quot;. The command response is sent as an Instant Message with the #cmdResult: prefix to the command sender. The implemented commands are listed below.</p></li><li><p>chatroom merging</p><p>A CommuniGate Pro chatroom can be instructed to connect to some other chatroom (running on this or other CommuniGate Pro Server, or on some other XMPP server), as a participant.<br> When connected, the messages distributed inside this CommuniGate Pro chatroom are sent to the remote chatroom with a prefix specifying the sender nickname in this chatroom. In the same way messages distributed in the remote chatroom are distributed in the CommuniGate Pro chatroom with a prefix specifying the sender nickname in the remote chatroom.<br> A CommuniGate Pro chatroom can connect to several local and remote chatrooms at once, acting as a bridge between all of them.</p></li></ul><p>The <code>chatroom</code> Application implements the following command line interface commands:</p><ul><li><p><code>help</code></p><p>returns the supported command list.</p></li><li><p><code>killroom</code></p><p>disconnects all participants and terminated this Named Task application instance.</p></li><li><p><code>kick _nickName_</code></p><p><code>kick [_E-mail address_]</code></p><p>removes the specified participant from the chatroom.<br> This command is available to administrators and moderators only.</p></li><li><p><code>voice _nickName_</code></p><p><code>voice [_E-mail address_]</code></p><p>changes the specified participant &quot;role&quot; to participant, so the participant can post messages.<br> This command is available to administrators and moderators only.</p></li><li><p><code>novoice _nickName_</code></p><p><code>novoice [_E-mail address_]</code></p><p>changes the specified participant &quot;role&quot; to visitor, so the participant cannot post messages.<br> This command is available to administrators and moderators only.</p></li><li><p><code>moderator _nickName_</code></p><p><code>moderator [_E-mail address_]</code></p><p>changes the specified participant &quot;role&quot; to moderator.<br> This command is available to administrators only.</p></li><li><p><code>member _nickName_</code></p><p><code>member [_E-mail address_]</code></p><p>changes the specified participant &quot;affiliation&quot; to member.<br> This command is available to administrators only.</p></li><li><p><code>admin _nickName_</code></p><p><code>admin [_E-mail address_]</code></p><p>changes the specified participant &quot;affiliation&quot; to administrator.<br> This command is available to the Named Task owner only.</p></li><li><p><code>guest _nickName_</code></p><p><code>guest [_E-mail address_]</code></p><p>changes the specified participant &quot;affiliation&quot; to guest.<br> This command is available to administrators only.</p></li><li><p><code>ban _nickName_</code></p><p><code>ban [_E-mail address_]</code></p><p>changes the specified participant &quot;affiliation&quot; to outcast, and removes the user from the chatroom.<br> This user will not be able to connect to his chatroom again.<br> This command is available to administrators only.</p></li><li><p><code>msg _nickName_ _message_</code></p><p>sends a private message <em>message</em> to the specified participant.</p></li><li><p><code>announce _message_</code></p><p>sends a regular &quot;groupchat&quot; message <em>message</em> on the user behalf. This message will not be removed from the message history, but it can be replaced with the next <code>announce</code> command sent by any user. This command is available to administrators and moderators only.</p></li><li><p><code>sysann _message_</code></p><p>sends a &quot;groupchat&quot; message <em>message</em> from the room itself. This message will not be removed from the message history, but it can be replaced with the next <code>sysann</code> command sent by any user. This command is available to administrators and moderators only.</p></li><li><p><code>temp _message_</code></p><p>sends a regular &quot;groupchat&quot; message <em>message</em> on the user behalf. This message is not stored in the message history, and it is not recorded in the chatroom conversation log files. This command is available to administrators and moderators only.</p></li><li><p><code>invite _userAddress_ [_reason_]</code></p><p>sends an invitation to this chatroom to the <em>userAddress</em> user.</p></li><li><p><code>join _roomAddress_</code></p><p>sends a join request to the <em>roomAddress</em> chatroom on the user behalf.</p></li><li><p><code>merge _roomAddress_ [ _thisRoomNick_ [ _otherRoomNick_ ] ]</code></p><p>connects this chatroom as a participant to the <em>roomAddress</em> chatroom.<br><em>thisRoomNick</em> specifies the nickName of this chatroom inside the <em>roomAddress</em> chatroom. If <em>thisRoomNick</em> is not specified, this chatroom name (the Named Task name) is used.<br><em>otherRoomNick</em> specifies the nickName of the <em>roomAddress</em> chatroom in this chatroom. If <em>otherRoomNick</em> is not specified, this username part of the <em>roomAddress</em> is used. This command is available to administrators and moderators only.</p></li></ul><h2 id="AutoCreateChats" tabindex="-1">Automatically Created Chatrooms <a class="header-anchor" href="#AutoCreateChats" aria-label="Permalink to &quot;Automatically Created Chatrooms {#AutoCreateChats}&quot;">​</a></h2><p>Many XMPP-only &quot;chat&quot; implement handle &quot;chatroom-only&quot; domains, such as chats.mycompany.com. These servers automatically create a chatroom when an unknown name is addressed in their domain.</p><p>CommuniGate Pro <a href="./Domains.html">Domains</a> contain various Objects - Accounts, Aliases, Forwarders, Mailing Lists, Groups, and others, and creating chatrooms by user request is usually not desired: the Server or Domain administrator can create chatroom Named Tasks, while regular users can create &quot;temporary chatrooms&quot; with unique names, used for ad-hoc chatrooms.</p><p>To allow regular users to create chatroom Named Tasks by an attempt to connect to an non-existent name in the Domain, enabled the <a href="./Domains.html">Auto-Create Chatrooms</a> Domain Settings.<br> If a user of some Account in the same Domain tries to connect to a non-existent chatroom, a chatroom Named Task is created automatically, with this Account as its owner.<br> If an attempt to connect to a non-existent chatroom is done by a user of a different CommuniGate Pro Domain or by an external user, a chatroom Named Task is created only if the target Domain has the <code>chatmaster</code> Account. This Account is used as the newly created Named Task owner.</p>',16)]))}const T=o(r,[["render",m]]);export{g as __pageData,T as default};
