import{_ as l}from"./chunks/ObjectSchema1.Dvn5S6pP.js";import{_ as d,C as s,c as m,o as h,ag as r,j as e,a,G as o,w as i}from"./chunks/framework.jCcxW76o.js";const M=JSON.parse('{"title":"Objects","description":"","frontmatter":{"legacyLink":"Objects.html"},"headers":[],"relativePath":"admin/objects/index.md","filePath":"admin/objects/index.md"}'),u={name:"admin/objects/index.md"},p={action:"Null.html"},f={class:"settingsBox"},b={width:"100%"},A={border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},g={align:"center",colspan:"4"},y={align:"center",colspan:"4"},v={align:"center",colspan:"4"},D={href:"#Accounts"};function w(T,t,x,S,j,k){const n=s("tt"),c=s("font");return h(),m("div",null,[t[16]||(t[16]=r('<h1 id="objects" tabindex="-1">Objects <a class="header-anchor" href="#objects" aria-label="Permalink to &quot;Objects&quot;">​</a></h1><p>Each CommuniGate Pro Server has a hierarchy of <em>objects</em> it serves:</p><ul><li>on the topmost level there is a set of Domains</li><li>each Domain contains Accounts, Groups, Mailing Lists, Aliases, Forwarders and Named Tasks</li><li>Each Account contains one or several Mailboxes</li><li>Each Mailbox contains some number of messages</li></ul><p>Besides these basic objects, CommuniGate Pro supports supplementary objects: Accounts can contain File Storage and Preference Data, Domains can contain Certificates, WebUser Skin files, Real-Time Applications, etc.</p><h2 id="domains" tabindex="-1">Domains <a class="header-anchor" href="#domains" aria-label="Permalink to &quot;Domains&quot;">​</a></h2><p>Domains are the CommuniGate Pro objects that contain other objects: Accounts, Mailing Lists, Groups, Aliases, Forwarders and Named Tasks. Each Domain has a domain name (client.com, www.company1.com, etc.):</p><p><img src="'+l+'" alt="Object Schema"></p><p>While each CommuniGate Pro Domain has its domain name, it is not necessary to create a separate CommuniGate Pro Domain for each domain name you want to serve. CommuniGate Pro Domains can have Domain Aliases: they allow you to assign several names to the same CommuniGate Pro Domain. For example, the CommuniGate Pro Domain <code>company.com</code> may have a Domain Alias <code>mail.company.com</code>. In this case all references to the domain name mail.company.com will be processed as references to the company.com CommuniGate Pro Domain.</p><p>There is a special CommuniGate Pro Domain, called the <em>Main Domain</em>. Other CommuniGate Pro Domains are called <em>secondary domains</em>. The Main Domain is created as soon as the Server is installed, and its name is specified in the <a href="./../sysadmin/#General">General Settings</a>. If your Server should serve only one Domain, the Main Domain is all you need and there is no need to create secondary domains. The Main Domain name is used as the Server Name.</p><p>Each CommuniGate Pro Domain has its own settings and a set of <a href="#DomainObjects">Domain Objects</a>.</p><p>See the <a href="./Domains.html">Domains</a> section for more information about CommuniGate Pro Domains.</p><h2 id="DomainObjects" tabindex="-1">Domain Objects <a class="header-anchor" href="#DomainObjects" aria-label="Permalink to &quot;Domain Objects {#DomainObjects}&quot;">​</a></h2><p>Each Domain has its own, independent set of Objects: Accounts, Groups, Forwarders, Aliases, Mailing Lists, Named Tasks. Each Object should have a name that is unique within the Domain. Different Objects in different Domains can have the same names.</p><p>Object names are case-insensitive. Object names can contain Latin letters, digits, the underscore (<code>_</code>), the minus (<code>-</code>), and the point (<code>.</code>) symbols. The point symbol cannot be used as the first or the last symbol of an Object name.</p><p>Object names should not contain more than 128 symbols.</p><p>Use the WebAdmin Interface to view <a href="./Domains.html">Domain</a> Objects. Open the Users realm, and follow the link for the selected Domain.<br> To open the Domain object list, you should have the <a href="./../sysadmin/#Privs">All Domains</a> access right or a Domain Administrator right for this Domain.</p><p>If you are a <a href="./../sysadmin/#Domain">Domain Administrator</a>, then the list of Objects in your Domain appears on the main <a href="./../services/HTTP.html#WebDomain">Domain Administration</a> page.</p>',17)),e("form",p,[e("div",f,[e("table",b,[e("tbody",null,[t[14]||(t[14]=e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Display",class:"button",type:"reset"}),a(),e("select",{name:"Limit"},[e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000",selected:"selected"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000")]),a(" Filter: "),e("input",{name:"Filter",value:"",size:"20",maxlength:"99",type:"text"})])],-1)),t[15]||(t[15]=e("tr",null,[e("td",{colspan:"4"},[e("table",{border:"0",cellpadding:"0",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"checkbox",name:"ShowAccounts",value:"1",checked:"checked"}),a(" Accounts (2 of 345)")]),e("td",null,[e("input",{type:"checkbox",name:"ShowResourceAccounts",value:"1",checked:"checked"}),a(" Resource Mailboxes (1 of 3)")]),e("td",null,[e("input",{type:"checkbox",name:"Details",value:"1",checked:"checked"}),a(" Account Details")]),e("td",null,[e("input",{type:"checkbox",name:"ShowForwarders",value:"1",checked:"checked"}),a(" Forwarders (1 of 10)")]),e("td",null,[e("input",{type:"checkbox",name:"ShowAliases",value:"1"}),a(" Aliases (0 of 5)")]),e("td",null,[e("input",{type:"checkbox",name:"ShowLists",value:"1",checked:"checked"}),a(" Mailing Lists (1 of 1)")])])])])])],-1)),e("tr",null,[e("td",null,[e("table",A,[e("tbody",null,[t[9]||(t[9]=e("tr",null,[e("th",{align:"left",nowrap:"nowrap"},"Object"),e("th",{align:"left",nowrap:"nowrap"},"Type"),e("th",{colspan:"4"}," ")],-1)),t[10]||(t[10]=e("tr",null,[e("td",null,[e("a",{href:"#Accounts"},"lsmith")]),e("td",null,"MultiMailbox"),e("td",{align:"right"},"2")],-1)),t[11]||(t[11]=e("tr",null,[e("td",null,[e("a",{href:"#ResourceAccounts"},"room")]),e("td",null,"Resource Mailbox")],-1)),t[12]||(t[12]=e("tr",null,[e("td",null,[e("a",{href:"Groups.html"},"smith-L")]),e("td",null,"Group"),e("td",{align:"center",colspan:"4"},[e("i",null,"15")])],-1)),e("tr",null,[t[1]||(t[1]=e("td",null,[e("a",{href:"LIST.html"},"support")],-1)),t[2]||(t[2]=e("td",null,"Mailing List",-1)),e("td",g,[o(n,null,{default:i(()=>t[0]||(t[0]=[a("18")])),_:1})])]),e("tr",null,[t[4]||(t[4]=e("td",null,[e("a",{href:"Forwarders.html"},"susan")],-1)),t[5]||(t[5]=e("td",null,"Forwarder",-1)),e("td",y,[o(n,null,{default:i(()=>t[3]||(t[3]=[a("susan@otherdomain.dom")])),_:1})])]),t[13]||(t[13]=e("tr",null,[e("td",null,[e("a",{href:"#Accounts"},"xsmith")]),e("td",null,"Text Mailbox"),e("td",{align:"right"},"34K"),e("td",{align:"right"},"20:34:56"),e("td",null,"[10.0.8.195]"),e("td",{align:"right"},"1")],-1)),e("tr",null,[t[7]||(t[7]=e("td",null,[e("a",{href:"#Aliases"},"x.smith")],-1)),t[8]||(t[8]=e("td",null,"Alias",-1)),e("td",v,[e("a",D,[e("i",null,[o(c,{color:"black"},{default:i(()=>t[6]||(t[6]=[a("xsmith")])),_:1})])])])])])])])])])])])]),t[17]||(t[17]=r('<p>To select Objects by name, enter a string into the Filter field, and click the Display button: only the Objects with names containing the specified string will be displayed.</p><p>The pop-up menu allows you to limit the number of Objects to be displayed.</p><p>The checkbox options specify the type of Objects you want to display: Account, ResourceMailboxes, Groups, Forwarders, Aliases. The information will include the selected and total number of those Objects in the Domain.</p><p>Each line in the list contains an Object name and its type.</p><ul><li>If the Object is an Account, the Account type is displayed.<br> If the Account Details option is selected, the line displays the information about: <ul><li>the Mail storage used with this Account</li><li>the last time when the Account was opened and the network address from which it was accessed</li><li>the current number of real-time Devices registered with this AccountThis Account Details retrieval operation is resource-consuming: do not use it if you want to display a lot of Accounts on one page.</li></ul></li><li>If the Object is an Alias, the real Account name is displayed.</li><li>If the Object is a Forwarder, the forwarding address is displayed.</li><li>If the Object is a Group, the number of Group members is displayed.</li><li>If the Object is a Mailing List, the number of List subscribes is displayed, but only if at least one List distribution has been performed.</li></ul><h2 id="accounts" tabindex="-1">Accounts <a class="header-anchor" href="#accounts" aria-label="Permalink to &quot;Accounts&quot;">​</a></h2><p>An Account is the basic <em>service unit</em>: every user served with a CommuniGate Pro Server should have an Account in one of the Server <a href="#Domains">Domains</a>.</p><p>Each Account is protected with a password, so only the Account owner (and, optionally, System and Domain Administrators) can have unrestricted access to Account data.</p><p>When the CommuniGate Pro Server is installed, the <code>postmaster</code> Account is automatically created in the Main Domain.<br> The <a href="./../sysadmin/#Privs">Master</a> (unlimited) access right is granted to that Account.</p><p>Account E-mail and Signal address is</p><p><em>accountname</em>@<em>domainname</em></p><p>where <em>accountname</em> is a name of a CommuniGate Pro Account, and <em>domainname</em> is the name of the CommuniGate Pro Domain in which this Account is created.</p><p>Messages directed to an Account address are delivered to the Account using the <a href="./../mail/Local.html">Local Delivery</a> module.</p><p>Signals directed to an Account address are delivered using the <a href="./../signals/">Signal</a> component.</p><p>An administrator can create <a href="#Aliases">Account Aliases</a> to assign multiple names to one Account.</p><p>Each CommuniGate Pro Account has its own settings and <a href="./../storage/">Storage</a> for the Account Mailboxes, files, and other data.</p><p>See the <a href="./Accounts.html">Accounts</a> section for more information about CommuniGate Pro Accounts.</p><h2 id="ResourceAccounts" tabindex="-1">Resource Mailboxes <a class="header-anchor" href="#ResourceAccounts" aria-label="Permalink to &quot;Resource Mailboxes {#ResourceAccounts}&quot;">​</a></h2><p>A Resource Mailbox is a special type of Account with minimal rights. It is used to accept or reject events in the Calendar. A Resource Mailbox does not have access to the settings of a regular Account and all services are disabled. You cannot set a password or authorise in the Resource Mailbox.</p><p>See the <a href="./ResourceAccounts.html">Resource Mailboxes</a> section for more information about CommuniGate Pro Resource Accounts.</p><h2 id="groups" tabindex="-1">Groups <a class="header-anchor" href="#groups" aria-label="Permalink to &quot;Groups&quot;">​</a></h2><p>CommuniGate Pro Domains can contain Groups. Groups are essentially lists of Account names and/or other groups and sending a message to a group results in sending it to all group members.</p><p>See the <a href="./Groups.html">Groups</a> section for more information about CommuniGate Pro groups.</p><h2 id="forwarders" tabindex="-1">Forwarders <a class="header-anchor" href="#forwarders" aria-label="Permalink to &quot;Forwarders&quot;">​</a></h2><p>CommuniGate Pro Domains can contain Forwarders. Each Forwarder has a name and contains an E-mail address for redirection. If mail is sent to <code>_name_@domain.com</code> where <em>name</em> is a Forwarder object in the domain.com CommuniGate Pro Domain, then mail is re-routed to the E-mail address specified in that Forwarder object.</p><p>Group and Forwarder Objects are different:</p><ul><li>a Forwarder can contain only one address, while a group can contain several addresses;</li><li>a Forwarder works on the <a href="./../sysadmin/Router.html">Router</a> level, substituting its own address with the specified address, while a group object actually processes a message sent to the group and generates a new message copy to be sent to the group members.</li></ul><p>See the <a href="./Forwarders.html">Forwarders</a> section for more information about CommuniGate Pro Forwarders.</p><h2 id="Aliases" tabindex="-1">Account Aliases <a class="header-anchor" href="#Aliases" aria-label="Permalink to &quot;Account Aliases {#Aliases}&quot;">​</a></h2><p>An Account Alias is an alternative name assigned to a CommuniGate Pro Account. Each Account can have zero, one, or several Account Aliases.</p><p>For example, the Account <code>j.smith</code> in the <code>domain2.com</code> Domain can have aliases <code>smith</code> and <code>jsmith</code>. Mail sent to the <code>smith@domain2.com</code> address will be stored in the <code>j.smith</code> Account, and attempts to login as <code>jsmith@domain2.com</code> will open the same <code>j.smith</code> Account.</p><p>You can use <a href="#Forwarders">Forwarders</a> to assign alternative name for Accounts, too. If you create the Forwarder <code>js</code> in the <code>domain2.com</code> Domain, and make it point to the <code>j.smith</code> address, it will work as yet another alias for the <code>j.smith</code> Account.</p><p>If you rename the Account <code>j.smith</code> into <code>james.smith</code>, all Account Aliases will &quot;move&quot; with it - <code>smith</code> and <code>jsmith</code> will remain the Aliases for the <code>james.smith</code> Account. If you remove the Account, the Account Aliases will be removed, too.</p><p>Renaming and removing of Accounts has no effect on the Forwarders: if you rename or remove the <code>j.smith</code> Account, the Forwarder <code>js</code> will continue to point to the <code>j.smith</code> address.</p><p>As a result, it is not recommended to use Forwarders where you can use Aliases. Forwarders should be used to create &quot;objects&quot; that redirect mail to other Domains or to other mail servers.</p><h2 id="MailLists" tabindex="-1">Mailing Lists <a class="header-anchor" href="#MailLists" aria-label="Permalink to &quot;Mailing Lists {#MailLists}&quot;">​</a></h2><p>CommuniGate Pro Domains can contain Mailing Lists. Each Mailing Lists has a name and it always belongs to some Account in the same Domain - the Mailing List owner.</p><p>A Mailing List contains a list of subscribers, and it maintains several Mailboxes in the list owner Account. Those Mailboxes are used to store and archive postings, generate digests, store subscription requests and error reports.</p><p>Groups and Mailing Lists are different:</p><ul><li>Groups are designed for a small number of members, Mailing Lists are designed to handle several hundred thousand subscribers per list;</li><li>Groups are designed mostly for local members (Accounts) and if the subscriber Account is renamed or removed, it is also renamed in or removed from all the Groups in its Domain;</li><li>Mailing Lists provide a lot of features beyond basic mail distribution: automatic subscribing, bounce processing, archiving and digesting, browsing, posting policies, moderating, etc.</li></ul><p>See the <a href="./../mail/LIST.html">LIST</a> section for more information about CommuniGate Pro Mailing Lists.</p><h2 id="NamedTasks" tabindex="-1">Named Tasks <a class="header-anchor" href="#NamedTasks" aria-label="Permalink to &quot;Named Tasks {#NamedTasks}&quot;">​</a></h2><p>CommuniGate Pro Domains can contain Named Tasks. Each Named Task has a name and it always belongs to some Account in the same Domain - the Named Task owner.</p><p>A Named Task is a <a href="./../../development/PBXApp.html">Real-Time Application</a> task that is automatically started with the Server when a Signal or an E-mail is addressed to the Named Task name. All those Signals and E-mails are delivered to a single instance of the Real-Time Application task, even in the <a href="./../cluster/">Cluster</a> environment.</p><p>Named Tasks are used to implement collaboration mechanisms such as Instant Message &quot;chat rooms&quot;, various communication gateways, etc.</p><p>See the <a href="./NamedTasks.html">Named Tasks</a> section for more information about CommuniGate Pro Named Tasks.</p><h2 id="database" tabindex="-1">Database <a class="header-anchor" href="#database" aria-label="Permalink to &quot;Database&quot;">​</a></h2><h3 id="DomainData" tabindex="-1">Domain Files <a class="header-anchor" href="#DomainData" aria-label="Permalink to &quot;Domain Files {#DomainData}&quot;">​</a></h3><p>All CommuniGate Pro Domain data is stored inside a file directory created in the <code>Domains</code> subdirectory inside the Server <em>base directory</em>. This directory name is the same as the Domain name.<br> The Main Domain data is stored inside the <code>Accounts</code> file directory created inside the <em>base directory</em>.</p><p>Inside a Domain file directory, a <code>Settings</code> file directory is created. This directory contains files with the domain-wide data:</p><ul><li><p><code>Access.settings</code></p><p>This file has the dictionary format, it contains the names of the users that have administrative access rights to the Server or to this Domain, and the list of the granted rights. By storing all administrative access rights in one location the CommuniGate Pro Server makes it easier to maintain server security. Only the <code>Access.settings</code> file stored in the Main Domain <code>Settings</code> directory can contain the server-level administration access rights. All other <code>Access.settings</code> files can contain only the Domain-level Administration access rights.</p></li><li><p><code>Domain.settings</code></p><p>This file contains the <a href="./Domains.html#Settings">Domain Settings</a>.</p></li><li><p><code>Template.settings</code></p><p>This file contains the Account Template for this Domain and provides the Account Settings for new Accounts in this Domain.</p></li><li><p><code>Aliases.data</code></p><p>This file contains the list of all account-level aliases specified for the Domain Accounts.</p></li><li><p><code>LISTS</code></p><p>This directory contains files with the information about the <a href="./../mail/LIST.html">mailing lists</a> created in the Domain.</p></li><li><p><code>WebSkins</code></p><p>This directory contains custom <a href="./WebApp.html#Skins">WebUser Interface Skins</a> for this Domain.</p></li><li><p><code>PBXApp</code></p><p>This directory contains custom <a href="./../../development/PBXApp.html#Environs">PBX Application Environment</a> for this Domain.</p></li></ul><h3 id="AccountServiceData" tabindex="-1">Account Service Files <a class="header-anchor" href="#AccountServiceData" aria-label="Permalink to &quot;Account Service Files {#AccountServiceData}&quot;">​</a></h3><p>Every CommuniGate Pro Account contains at least one (INBOX) Mailbox, and at least two service files. Service files have the following file name extensions:</p><ul><li><p><code>.settings</code></p><p>This <a href="./../../development/Data.html">dictionary</a> file contains Account Settings, including the Account <a href="./../../development/Rules.html">Rules</a>.</p></li><li><p><code>.info</code></p><p>This <a href="./../../development/Data.html">dictionary</a> file contains volatile Account information, such as Mailbox sizes, SIP Registrations, Event subscriptions, etc.</p><p>Since the <code>.info</code> file is being modified rather often, the CommuniGate Pro Server is built to survive .info file corruptions. For example, if the Mailbox last UID information is corrupted, the Server rescans the Mailbox and restores the correct Mailbox info.</p></li><li><p><code>.prefs</code></p><p>This <a href="./../../development/Data.html">dictionary</a> file contains Account Preferences, including the preferences of <a href="./WebMail.html">WebMail</a> and Pronto interfaces.</p></li><li><p><code>.dst</code></p><p>This optional <a href="./../../development/Data.html">dictionary</a> file contains the Account &quot;DataSet&quot;, that includes Account DataSet <a href="./WebContacts.html#DataSet">Address Books</a> (also known as <a href="./../../development/Rules.html#StringLists">string lists</a>), and application preferences.</p></li><li><p><code>.web</code></p><p>This optional file directory is the Account <a href="./../storage/FileStore.html">File Storage</a>.</p></li><li><p><code>.balances</code></p><p>This optional file directory contains files with <a href="./../misc/Billing.html">Billing</a> history information.</p></li></ul><h3 id="Location" tabindex="-1">Account Files Location <a class="header-anchor" href="#Location" aria-label="Permalink to &quot;Account Files Location {#Location}&quot;">​</a></h3><p>The Account files are located in the Domain file directory or in its subdirectory (see the <a href="./Domains.html#Subdirs">Domains</a> section for the details). The <code>GetAccountLocation</code> <a href="./../../development/CLI.html">CLI</a> command can be used to learn the physical location of the Account files.</p><p>For a multi-mailbox Account, a directory with the Account name and <code>.macnt</code> extension is created, and all Account files are stored in that directory. The Account service files are stored as <code>account._extension_</code>. The INBOX Mailbox is stored as the <code>INBOX._mailboxType_</code> file.<br> Example: for the multi-mailbox Account <code>John</code>, the <code>john.macnt</code> directory is created, and the files <code>INBOX.mbox</code>, <code>account.settings</code>, <code>account.info</code> are placed in that directory.</p><p>For a single-mailbox Account, the INBOX Mailbox is created as a file in the Domain file directory or its subdirectory, and it has the <code>_accountName_._mailboxType_</code> file name. The Account service files are stored in the same directory as <code>_accountName_._extension_</code>.<br> Example: for the single-mailbox Account <code>John</code>, the <code>john.mbox</code>, <code>john.settings</code>, and <code>john.info</code> are placed into the Domain file directory.</p>',58))])}const C=d(u,[["render",w]]);export{M as __pageData,C as default};
