import{_ as t,c as s,o as i,ag as a}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"HTTP Modules","description":"","frontmatter":{"legacyLink":"HTTP.html"},"headers":[],"relativePath":"admin/services/HTTP.md","filePath":"admin/services/HTTP.md"}'),o={name:"admin/services/HTTP.md"};function n(d,e,l,r,p,h){return i(),s("div",null,e[0]||(e[0]=[a(`<h1 id="http-modules" tabindex="-1">HTTP Modules <a class="header-anchor" href="#http-modules" aria-label="Permalink to &quot;HTTP Modules&quot;">​</a></h1><p>The CommuniGate Pro HTTP Admin and User modules implement the Hypertext Transfer Protocol via TCP/IP networks.</p><p>The HTTP Admin module:</p><ul><li>provides access to the <a href="./../sysadmin/">Server WebAdmin</a> (Administration) Interface pages.</li><li>provides access to <a href="./../sysadmin/#Domain">Domain WebAdmin</a> (Administration) Interface pages.</li></ul><p>The HTTP User module:</p><ul><li>implements the <a href="./../access/WebUser.html">WebUser Interface</a> to user <a href="./../objects/Accounts.html">Accounts</a> and <a href="./../mail/LIST.html">Mailing List</a> archives.</li><li>implements the <a href="./../access/AirSync.html">AirSync</a> protocol.</li><li>provides HTTP Binding for the <a href="./../access/XIMSS.html#HTPBind">XIMSS</a> Interface.</li><li>provides access to Account <a href="#WebSites">File Storage</a>.</li><li>provides access to the <a href="./../signals/Parlay.html">Parlay X</a> interface.</li><li>implements various <a href="./../access/WebDAV.html">WebDAV</a> protocols (File Access, CalDAV, CardDAV, etc.) and <a href="./../access/WebDAV.html#ICS">Publish/Subscribe</a> access methods to the Calendaring and Tasks data.</li><li>provides access to <a href="#CGI">Common Gateway Interface (CGI)</a> programs.</li><li>provides access to <a href="./../../development/WebApp.html#CGPL">CG/PL Web applications</a>.</li><li>provides access to <a href="#CLI">CLI/API</a>.</li><li>is used to implement the Microsoft &quot;Autodiscover&quot; and Mozilla Thunderbird Autoconfiguration protocols.</li></ul><p>The CommuniGate Pro HTTP modules support various authentication methods, including the GSSAPI, <a href="./../sysadmin/Security.html#Kerberos">Kerberos</a>, and <a href="./../sysadmin/PKI.html#ClientCert">Certificate</a> methods implementing the <em>single sign-on</em> functionality.</p><p>The HTTP User module also implements an <a href="#Client">HTTP client</a>. This functionality is used to send HTTP requests to and received HTTP responses from remote servers.</p><h2 id="WebAdmin" tabindex="-1">WebAdmin Server Interface <a class="header-anchor" href="#WebAdmin" aria-label="Permalink to &quot;WebAdmin Server Interface {#WebAdmin}&quot;">​</a></h2><p>The Server Administrator can use any Web browser application to configure and to monitor the Server remotely, using the Web (HTML) <em>forms</em>.</p><p>The authentication schemes supported with the HTTP protocol protect the WebAdmin pages from an unauthorized access. In order to access the WebAdmin pages, the user should provide the name and the password of a CommuniGate Pro Account with required <a href="./../sysadmin/#Privs">Server Access Rights</a>.</p><p>By default, the HTTP Admin module accepts <em>clear text</em> TCP/IP WebAdmin connections on the port 8010 and <em>secure</em> (SSL/TLS) connections on the TCP port 9010.</p><p>To access the WebAdmin pages, the Server administrator should use the following URLs:<br><code>http://_domain.com_:8010</code></p><p><code>https://_domain.com_:9010</code><br> where <em>domain.com</em> is the CommuniGate Pro Main Domain name or its alias, or the IP address of the CommuniGate Pro Server.</p><p>Server configuration errors can cut you off the WebAdmin Server Interface, if all your Server IP addresses and DNS names are assigned to secondary Domains.</p><p>To access the WebAdmin Server Interface, use the following URLs: <code>http://_sub.domain.com_:8010/MainAdmin/</code><br><code>https://_sub.domain.com_:9010/MainAdmin/</code><br> where <em>sub.domain.com</em> is any name pointing to your Server computer or any of the Server IP addresses.</p><h2 id="WebDomain" tabindex="-1">WebAdmin Domain Interface <a class="header-anchor" href="#WebDomain" aria-label="Permalink to &quot;WebAdmin Domain Interface {#WebDomain}&quot;">​</a></h2><p>If the CommuniGate Pro Server supports several <a href="./../objects/Domains.html">Secondary Domains</a>, the same port can be used by the <a href="./../sysadmin/#Domain">Domain Administrators</a> to access the Secondary Domains settings and account lists.</p><p>A Domain Administrator should access the server using the following URL: <code>http://_sub.domain.com_:8010</code><br><code>https://_sub.domain.com_:9010</code><br> where <em>sub.domain.com</em> is the name of the secondary Domain to administer.</p><p>The Server will ask for a user (Account) name and a password, and if the specified Account has the <a href="./../sysadmin/Security.html#DomainAdmin">Domain Administrator access right</a>, the list of the Domain Accounts is displayed.</p><p>Sometimes this URL cannot be used. For example, a secondary Domain may have no DNS A-records (only MX records). To access such a Domain, its Domain Administrator should use the following URL:</p><p><code>http://_domain.com_:8010/Admin/_sub.domain.com_/</code><br> where: <em>domain.com</em> is the name of the Main Server Domain or its alias, or the IP address of the CommuniGate Pro Server.</p><p><em>sub.domain.com</em> is the name of the Domain to access.</p><p>Other Domains can specify your Domain as their <a href="./../sysadmin/#SubDomains">Administrator Domain</a>. The Domain Settings page of your Domains provides a list of those Domains:</p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Administrated Domains</b></td></tr><tr><td><a href="Objects.html">node100.example.com</a></td><td align="RIGHT"><a href="../objects/Domains.md">settings</a></td></tr><tr><td><a href="Objects.html">test-dom.example.com</a></td><td align="RIGHT"><a href="../objects/Domains.md">settings</a></td></tr></tbody></table></div><p>You can open their WebAdmin Domain Interfaces using the links on this page. Remember that you should login using your full Account name (<code>_yourAccountName_@_yourDomainName_</code>) when accessing other Domain WebAdmin pages.</p><h2 id="WebUser" tabindex="-1">Access to the WebUser Interface <a class="header-anchor" href="#WebUser" aria-label="Permalink to &quot;Access to the WebUser Interface {#WebUser}&quot;">​</a></h2><p>CommuniGate Pro users can connect to the CommuniGate Pro Server with any Web browser (via the HTTP protocol) to manage their Accounts, to browse their Mailboxes, to read, copy, delete, forward, and redirect messages, to move messages between Mailboxes, to compose and submit new messages, etc.<br> This CommuniGate Pro component is called the <a href="./../access/WebUser.html">WebUser Interface</a>.</p><p>Registered users and guests can also use this component to browse <a href="./../mail/LIST.html">Mailing List</a> archives.</p><p>By default, the HTTP User module accepts <em>clear text</em> TCP/IP connections on the TCP port 8100, and the secure connections - on the TCP port 9100. If your Server does not have to coexist with some other Web Server on the same computer, it is recommended to change these port numbers to 80 and 443 - the standard HTTP and HTTPS port numbers.<br> In this case your users will not have to specify the port number in their browsers.</p><h2 id="WebSites" tabindex="-1">Access to Account File Storage <a class="header-anchor" href="#WebSites" aria-label="Permalink to &quot;Access to Account File Storage {#WebSites}&quot;">​</a></h2><p>CommuniGatePro users can user their Account File Storage as personal Web sites. See the <a href="./../storage/FileStore.html">File Storage</a> section for the details.</p><p>The URL for the accountName@domainName File Storage (or personal Web site) is: <code>http://domainName:port/~accountName</code></p><p><code>https://domainName:port/~accountName</code></p><p>where <code>port</code> is the HTTP User ports (8100 and 9100 by default).</p><p>The list of files in that File Storage can be seen at:</p><p><code>http://domainName:port/~accountName/index.wssp</code></p><p><code>https://domainName:port/~accountName/index.wssp</code></p><p>This page can be used to manage the File Storage. It is available to the Account owner, Domain Administrators or, and to authenticated user granted the <a href="./../storage/FileStore.html">File Access Rights</a> .</p><p>The &quot;davmount&quot; (RFC4709) document can be retrieved using the following URLs:</p><p><code>http://domainName:port/~accountName/davmount</code></p><p><code>https://domainName:port/~accountName/?davmount=1</code></p><p>You can specify an alternative File Storage prefix using the <a href="./../objects/Domains.html#WebUser">Domain Settings</a>. That setting can be an empty string, in this case personal Web sites can be accessed using the following URLs:</p><p><code>http://domainName:port/accountName/</code></p><p><code>https://domainName:port/accountName/</code></p><p>You can also use the CommuniGate Pro Router to access personal Web sites with domain-level URLs. See the <a href="#Routing">Routing</a> section below.</p><h2 id="Configuring" tabindex="-1">Configuring the HTTP modules <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the HTTP modules {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the HTTP modules. Open the Services pages in the Settings realm, then open the HTTPA (Admin) and/or HTTPU (User) page.</p><form action="Null.html"><div align="center" class="WebAdmin"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="RIGHT">Log Level:</td><td><select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option selected="selected">All Info</option></select></td><td align="RIGHT">Channels:</td><td><select name="MaxInputChannels"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option>3</option><option>5</option><option>7</option><option>10</option><option>15</option><option>30</option><option>50</option><option selected="selected">100</option><option>300</option><option>500</option><option>1000</option><option>3000</option><option>5000</option><option>10000</option><option>other</option></select></td><td align="RIGHT" class="arrow"><a href="Listener.html">Listener</a></td></tr><tr><td align="RIGHT">Request Size Limit:</td><td><select name="HTTPRequestSizeLimit"><option value="-1">unlimited</option><option>10K</option><option>30K</option><option>100K</option><option>300K</option><option>1024K</option><option>3M</option><option>10M</option><option selected="selected">30M</option><option>100M</option><option>300M</option><option>1024M</option><option>other</option></select></td><td><input type="checkbox" name="ScanLargeRequests" value="1">Scan Large Requests</td></tr><tr><td align="RIGHT">Compress If Larger:</td><td><select class="popup" name="CompressSize"><option value="-1">unlimited</option><option value="10240" selected="selected">10K</option><option value="30720">30K</option><option value="102400">100K</option><option value="307200">300K</option><option value="1048576">1024K</option><option value="3145728">3M</option><option value="10485760">10M</option><option value="31457280">30M</option><option value="104857600">100M</option><option value="314572800">300M</option><option value="1073741824">1024M</option><option value="10241">other</option></select></td><td><input name="SupportKeepAlive" value="1" checked="checked" type="checkbox">Support &#39;Keep-Alive&#39;</td><td> </td></tr></tbody></table></div><p></p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>HTTP Options</b></td></tr><tr><td><input type="checkbox" name="AdvertiseBasicAUTH" value="1">Advertise &#39;Basic&#39; Authentication</td><td><input type="checkbox" name="AdvertiseDigestAUTH" value="1" checked="checked">Advertise &#39;Digest&#39; Authentication</td></tr><tr><td><input type="checkbox" name="AdvertiseNTLMAUTH" value="1">Advertise &#39;NTLM&#39; Authentication</td><td><input type="checkbox" name="AdvertiseNegotiateAUTH" value="1">Advertise &#39;Negotiate&#39; Authentication</td></tr></tbody></table></div></div></form><ul><li><p><code>Log Level</code></p><p>Use this setting to specify what kind of information the HTTP module should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the HTTP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.<br> The HTTP Admin module records in the System Log are marked with the <code>HTTPA</code> tag.<br> The HTTP User module records in the System Log are marked with the <code>HTTPU</code> tag.</p></li><li><p><code>Channels</code></p><p>This setting is used to limit the number of simultaneous TCP/IP connections the HTTP module can accept. Most browsers open several connections to load an HTML page and all embedded pictures, so do not set this limit to less than 5, otherwise some browsers may fail to download embedded graphic objects.</p></li><li><p><code>Listener</code></p><p>Follow this link to open the HTTP Admin Port or HTTP User Port <a href="./../network/Listener.html">listener</a> settings. There you can specify the TCP port number(s) the service should use, the interfaces to use, and other options.</p><p>If the CommuniGate Pro Server computer runs some other Web Server application, you should specify a port number in the &quot;secondary range&quot; to avoid conflicts with that other Web Server application. Usually the &quot;secondary&quot; Web Servers use ports numbers in the 8000-8100 range. If you set the port number to 8010, you will be able to connect to your server by entering <code>http://_xxx.yyy.zzz_:8010</code> in your Web browser, where <em>xxx.yyy.zzz</em> is the exact domain name (A-record) or the IP address of your Server.</p></li><li><p><code>Request Size Limit</code></p><p>This setting limits the maximum size of an HTTP request the Server accepts. You may want to increase this limit if you want to allow your users to upload larger files and/or to attach larger files to messages composed using he <a href="./WebMail.html">WebUser Interface</a>.</p></li><li><p><code>Support Keep-Alive</code></p><p>If this option is enabled, the CommuniGate Pro supports the Keep-Alive protocol feature, so a user browser can retrieve several files using the same HTTP connection. Some browsers do not implement this function correctly and they may have problems if this option is enabled.</p></li><li><p><code>Compress If Larger</code></p><p>If the composed response size is larger than the value of this option, and the client browser supports compression, the response is compressed before being sent to the client.</p></li><li><p><code>Scan Large Requests</code></p><p>If this option is disabled, and the size of a HTTP request to be received exceeds the specified limit, the Server sends an error response and closes the connection. Many browsers do not display the error response in this case. Instead, they display a generic &quot;connection is broken&quot; message.<br> If this option is enabled, the Server sends an error response back and receives the entire request (but it does not store it anywhere). The user browser then displays the error message.</p></li><li><p><code>Advertise Basic AUTH</code>, <code>Advertise Digest AUTH</code>,<br><code>Advertise NTLM AUTH</code>, <code>Advertise Negotiate AUTH</code></p><p>If these options are enabled, the Server will inform browsers that clear-text (Basic) or secure (Digest, NTLM, Negotiate/SNEGO) authentication methods are available. If you plan to connect to the WebAdmin Interface via clear-text (non-encrypted) links over the Internet, you may want to enable these options. Different browsers work differently when these options are enabled. Some may fail, some may still use the clear-text (Basic) authentication method, so enable these options only if needed.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The GSSAPI (Kerberos) authentication methods become available when the Negotiate AUTH method is enabled.</p></div></li></ul><p>The HTTP modules set the MIME <code>Content-Type</code> for every object they send. To detect the proper Content-Type for plain files, the modules use the file name extension and the following &quot;basic&quot; built-in table:</p><table tabindex="0"><thead><tr><th>File Extension</th><th>MIME type</th></tr></thead><tbody><tr><td><code>html</code></td><td><code>text/html</code></td></tr><tr><td><code>txt</code></td><td><code>text/plain</code></td></tr><tr><td><code>gif</code></td><td><code>image/gif</code></td></tr><tr><td><code>jpg</code></td><td><code>image/jpeg</code></td></tr><tr><td><code>css</code></td><td><code>text/css</code></td></tr><tr><td><code>js</code></td><td><code>text/javascript</code></td></tr></tbody></table><p>There is also an &quot;extended&quot; built-in table, which is displayed on the WebAdmin page.</p><p>You can create your own custom extension table by specifying additional file name extensions and corresponding MIME Content-Types:</p><form action="Null.html"><div class="WebAdmin"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>MIME types</b></td></tr><tr align="LEFT"><th>File Extension</th><th>MIME type</th></tr><tr><td><input type="text" name="e0" value="tp1" size="7" maxlength="20"></td><td><input type="text" name="m0" value="text/type1" size="30" maxlength="100"></td></tr><tr><td><input type="text" name="e1" value="grp" size="7" maxlength="20"></td><td><input type="text" name="m1" value="application/x-group" size="30" maxlength="100"></td></tr><tr><td><input type="text" name="e2" value="xzp" size="7" maxlength="20"></td><td><input type="text" name="m2" value="video/x-xzip" size="30" maxlength="100"></td></tr><tr><td><input type="text" name="e3" value="" size="7" maxlength="20"></td><td><input type="text" name="m3" value="" size="30" maxlength="100"></td></tr><tr><td colspan="2"><hr></td></tr><tr><td class="settingFixed">doc</td><td class="settingFixed">application/msword</td></tr><tr><td class="settingFixed">eml</td><td class="settingFixed">message/rfc822</td></tr><tr><td class="settingFixed">flv</td><td class="settingFixed">video/x-flv</td></tr><tr><td class="settingFixed">htm</td><td class="settingFixed">text/html</td></tr><tr><td class="settingFixed">js</td><td class="settingFixed">text/javascript</td></tr><tr><td class="settingFixed">jss</td><td class="settingFixed">text/javascript</td></tr><tr><td class="settingFixed">mov</td><td class="settingFixed">video/quicktime</td></tr><tr><td class="settingFixed">mp3</td><td class="settingFixed">audio/mpeg</td></tr><tr><td class="settingFixed">mpg</td><td class="settingFixed">video/mpeg</td></tr><tr><td class="settingFixed">pdf</td><td class="settingFixed">application/pdf</td></tr></tbody></table></div></div></form><p>The extended &quot;built-in&quot; table is displayed under the custom table.</p><p>When a file extension is converted into a MIME type, the custom table is checked first, then the built-in tables are checked. As a result, you can redefine the built-in table values with the custom table values</p><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>The HTTP modules use the <a href="./../sysadmin/Router.html">Router</a> to process all address it receives. But unlike other <a href="./../cluster/Access.html">Access</a> modules, the HTTP modules often deal not with complete E-mail addresses, but with domain names only.</p><p>When the HTTP Admin module receives a request, it uses the name or the IP address specified in the URL to decide which Domain Administration pages to display.</p><p>When the HTTP User module receives a request, it uses the name or the IP address specified in the URL to decide which Domain (its login page, Mailing Lists, File Storage, etc.) to access.</p><p>In order to support all types of CommuniGate Pro Routing features (Router Table, Domain Aliases, IP Address to Domain Mapping, etc.), the HTTP module composes a complete E-mail address <code>LoginPage@_domainname_</code> (where <em>domainname</em> is the domain name specified in the request URL), and then it processes this address with the Router:</p><ul><li>If the <code>LoginPage@_domainname_</code> address is routed to any module other than LOCAL, an error is returned.</li><li>If the <code>LoginPage@_domainname_</code> address is routed to the LOCAL module and local part of the resulting address is still <code>LoginPage</code>, then the domain part of the resulting address is used to open the proper CommuniGate Pro Domain.</li><li>If the address is routed to the LOCAL module, but the resulting username is not LoginPage, the <a href="./../storage/FileStore.html">File Storage</a> of the addressed Account is opened. If the resulting address has a local part, then the File Storage subdirectory with that name is opened.</li></ul><p>Samples (<a href="./../sysadmin/Router.html">Router</a> Table records, domainA.com is a CommuniGate Pro Domain):</p><ul><li><p><code>mail2.domain.com = domainA.com</code></p><p>When the <code>http://mail2.domain.com/</code> URL is used, the <code>&lt;LoginPage@mail2.domain.com&gt;</code> address is routed to <a href="mailto:LoginPage@domainA.com" target="_blank" rel="noreferrer">LoginPage@domainA.com</a> address, and the domainA.com Web Interface is opened.</p></li><li><p><code>&lt;LoginPage@mail2.domain.com&gt; = user@domainA.com</code></p><p>When the <code>http://mail2.domain.com/</code> URL is used, the <code>&lt;LoginPage@mail2.domain.com&gt;</code> address is routed to LOCAL account <a href="mailto:user@domainA.com" target="_blank" rel="noreferrer">user@domainA.com</a>, and the <a href="mailto:user@domainA.com" target="_blank" rel="noreferrer">user@domainA.com</a> File Storage is opened.</p></li><li><p><code>&lt;LoginPage@mail2.domain.com&gt; = subDir@user@domainA.com.domain</code></p><p>When the <code>http://mail2.domain.com/</code> URL is used, the <code>&lt;LoginPage@mail2.domain.com&gt;</code> address is routed to the LOCAL account <a href="mailto:user@domainA.com" target="_blank" rel="noreferrer">user@domainA.com</a> with the subDir local address part, and the subDir directory of the <a href="mailto:user@domainA.com" target="_blank" rel="noreferrer">user@domainA.com</a> File Storage is opened.</p></li></ul><h2 id="WebApps" tabindex="-1">Web Applications <a class="header-anchor" href="#WebApps" aria-label="Permalink to &quot;Web Applications {#WebApps}&quot;">​</a></h2><p>The HTTP User module can start <a href="./../../development/WebApp.html#CGPL">CG/PL Web Applications</a>.</p><p>Use the WebAdmin Interface to open the HTTP User settings page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Web Applicaitons</b></td></tr><tr align="left"><th width="50%">URI Path Component</th><th width="50%">Web Application</th></tr><tr><td><input type="text" name="a0" value="autodiscover/autodiscover.xml" size="50" maxlength="200"></td><td><input type="text" name="b0" value="ms_autodiscover_pox.wcgp" size="30" maxlength="200"></td></tr><tr><td><input type="text" name="a2" value=".well-known/autoconfig/mail/config-v1.1.xml" size="50" maxlength="200"></td><td><input type="text" name="b2" value="thunderbird_autoconf.wcgp" size="30" maxlength="200"></td></tr><tr><td><input type="text" name="a3" value="" size="50" maxlength="200"></td><td><input type="text" name="b3" value="" size="30" maxlength="200"></td></tr></tbody></table></div></form><ul><li><p><code>URI Path Component</code></p><p>The URI (Universal Resource Location) component, after the first slash <code>/</code> symbol.<br> The component may contain the asterisk (<code>*</code>) symbols.</p></li><li><p><code>Web Application</code></p><p>The name of a <a href="./../../development/WebApp.html#CGPL">CG/PL Web Application</a> to start. Each domain may have its own version of the application.</p></li></ul><p>Web Applications can be used to extend functionality of the <a href="./../access/WebUser.html">WebUser Interface</a>.</p><p>Web Applications are used to implement the Microsoft &quot;Autodiscover&quot; and Mozilla Thunderbird Autoconfiguration protocols.</p><h2 id="CGI" tabindex="-1">Common Gateway Interface (CGI) <a class="header-anchor" href="#CGI" aria-label="Permalink to &quot;Common Gateway Interface (CGI) {#CGI}&quot;">​</a></h2><p>The HTTP User module can start CGI programs and scripts. To access a CGI program, the <code>/cgi-bin/_programName_</code> URL should be used, and the <em>programName</em> program should be placed into the CommuniGate Pro CGI Directory.</p><p>Use the WebAdmin Interface to open the HTTP User settings page:</p><form action="Null.html"><div align="center" class="WebAdmin"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>CGI Applications</b></td></tr><tr><td align="RIGHT">CGI Directory:</td><td><input type="text" name="SystemCGIDirectory" value="myCGIs" size="30" maxlength="100"></td></tr><tr align="LEFT"><th>File Extension</th><th>Program to Start</th></tr><tr><td><input type="hidden" name="CGIExtensions" value="0"><input type="text" name="x0" value="pl" size="7" maxlength="20"></td><td><input type="text" name="p0" value="C:\\Programs\\Perl.exe" size="30" maxlength="100"></td></tr><tr><td><input type="hidden" name="CGIExtensions" value="2"><input type="text" name="x2" value="" size="7" maxlength="20"></td><td><input type="text" name="p2" value="" size="30" maxlength="100"></td></tr><tr align="LEFT"><th colspan="2">HTTP Header Fields</th></tr><tr><td colspan="2"><input type="hidden" name="CGIHeaderFields" value="1"> <input type="text" name="f1" value="X-Portal-Data" size="30" maxlength="200"></td></tr><tr><td colspan="2"><input type="hidden" name="CGIHeaderFields" value="2"> <input type="text" name="f2" value="" size="30" maxlength="200"></td></tr></tbody></table></div></div></form><ul><li><p><code>CGI Directory</code></p><p>Enter the name of the server system file directory where your CGI programs are located. If that directory is inside the CommuniGate Pro <em>base directory</em>, then you can specify its relative name, otherwise specify the full path to that directory. The CGI Directory should not have any subdirectories.</p></li><li><p><code>File Extensions</code></p><p>While some operating systems (such as Unix) can start various interpreter-type programs/scripts by starting the proper interpreter, other operating systems require that the interpreter program is started explicitly. The CommuniGate Pro Server supports those operating systems by allowing you to specify the name of the interpreter program for certain file extensions. As a result, when the CommuniGate Pro Server needs to start a program or script with the specified extension, it forms the OS-level command line by prefixing the program/script name with the specified interpreter program name.<br> In the above example the Server will process the <code>/cgi-bin/script.pl</code> URL by executing the <code>Perl.exe script.pl</code> command.</p></li><li><p><code>HTTP Header Field</code></p><p>Use this table to specify custom, non-standard HTTP Request header fields that you want to pass to your CGI applications. If a request contains a header line with the specified field name, the line is passed to CGI applications as an environment variable with the <code>HTTP_H__convertedFieldName_</code> name, where convertedFieldName is the field name in the uppercase letters, with all minus (<code>-</code>) symbols substituted with the underscore (<code>_</code>) symbols.</p></li></ul><p>CGI programs can be used to extend functionality of the <a href="./../access/WebUser.html">WebUser Interface</a>. They can log into the Server via its PWD module to do some <a href="./../../development/CLI.html">CLI/API</a> operations and/or via the <a href="./../access/IMAP.html">IMAP</a> or <a href="./../access/XIMSS.html">XIMSS</a> modules to access and modify Mailbox data. To simplify these login operations, CGI programs can use the <a href="./../sysadmin/Security.html#SessionIDSASL">SessionID Authentication</a> method.</p><h2 id="CLI" tabindex="-1">Command Line Interface (CLI/API) Access <a class="header-anchor" href="#CLI" aria-label="Permalink to &quot;Command Line Interface (CLI/API) Access {#CLI}&quot;">​</a></h2><p>The HTTP User module provides access to the Server <a href="./../../development/CLI.html">Command Line Interface/API</a> via the <code>/CLI/</code> realm.</p><h3 id="text-method" tabindex="-1">Text Method <a class="header-anchor" href="#text-method" aria-label="Permalink to &quot;Text Method&quot;">​</a></h3><p>Send a GET or POST request with a <code>command</code> parameter. The parameter value should contain the CLI command to be executed.<br> If the request fails, the error code is returned as an HTTP response error string.<br> If the request is successful, the HTTP response code is 200.<br> If the request produced an output, the text representation of the resulting object is sent as the HTTP response body.</p><h3 id="soap-method" tabindex="-1">SOAP Method <a class="header-anchor" href="#soap-method" aria-label="Permalink to &quot;SOAP Method&quot;">​</a></h3><p>Send a SOAP XML request. The request should have exactly one XML element - the CLI command to execute.<br> The XML element tag is the CLI command tag.<br> the XML element sub-elements are <a href="./../../development/Data.html#XMLObjects">XML representations</a> of parameter objects and/or <code>key</code> elements. The <code>key</code> element text body is a CLI command key.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> xmlns:SOAP-ENV</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;http://schemas.xmlsoap.org/soap/envelope/&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">createAccount</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;newuser@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;TextMailbox&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;RealName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;John Doe&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Password&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;soappass&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">createAccount</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>This request is converted into:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>createAccount &quot;newuser@domain.dom&quot; TextMailbox {RealName=&quot;John Doe&quot;; Password=&quot;soappass&quot;;}</span></span></code></pre></div><p>If the request produces an output, its XML representation is added to the SOAP response.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> xmlns:SOAP-ENV</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;http://schemas.xmlsoap.org/soap/envelope/&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">getAccount</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;newuser@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">param</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">getAccount</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>This request is converted to:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>getAccount &quot;newuser@domain.dom&quot;</span></span></code></pre></div><p>and a dictionary output is produced:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{Password=&quot;\\\\001xxxxx&quot;; RealName=&quot;John Doe&quot;;}</span></span></code></pre></div><p>This response is sent with the SOAP response:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> xmlns:SOAP-ENV</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;http://schemas.xmlsoap.org/soap/envelope/&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">object</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Password&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;\\\\001fjh{\\\\024hdfu&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;RealName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SOAP Test&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">object</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOAP-ENV:Envelope</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h2 id="Client" tabindex="-1">HTTP Client <a class="header-anchor" href="#Client" aria-label="Permalink to &quot;HTTP Client {#Client}&quot;">​</a></h2><p>The HTTP Client functionality is used to send HTTP Requests to remote servers. It is used with:</p><ul><li><a href="./../../development/CGPL.html">CG/PL</a> <code>HTTPCall</code> function.</li><li><a href="./../../development/XMLAPI.html">XIMSS</a> <code>retrieveURL</code> operation.</li></ul><p>Use the WebAdmin Interface to specify the HTTP Client processing parameters. Open the General pages in the Settings realm, and find the HTTP Client Manager panel on the Others page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>HTTP Client Manager</b></td></tr><tr><td align="RIGHT" width="40%">Log Level:</td><td><select name="HTTPOutputLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5" selected="selected">All Info</option></select></td></tr><tr><td align="RIGHT">Cache:</td><td><select class="popup" name="HTTPOutputCacheSize"><option value="10">10</option><option value="30" selected="selected">30</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="31">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the HTTP Client Manager should put in the Server Log. The HTTP Client Manager records in the System Log are marked with the <code>HTTPO</code> tag.</p></li><li><p><code>Cache</code></p><p>Use this setting to specify how many HTTP connections the Manager should keep open, increasing the processing speed for requests sent to the same remove HTTP server (these requests will reuse already open connections).</p></li></ul><p>The HTTP module sends a request to the specified <code>http:</code> or <code>https:</code> URL. The module accepts an optional parameter dictionary which can contain the following elements:</p><ul><li><p><code>method</code></p><p>If this element is specified, it specifies the HTTP request method (<code>GET</code>, <code>MOVE</code>, etc.)<br> If this element is not specified, the HTTP request method is set to <code>GET</code> if the <code>body</code> element is absent, otherwise the <code>POST</code> method is used.</p></li><li><p><code>urlParams</code></p><p>This optional element value should be a dictionary. All its key-value pairs are sent as URL parameters in the HTTP request line.<br> Each dictionary value should be either a single value - a string or a number, or an array of single values. For an array-type value, a URL parameter for each array element is composed separately, using the same dictionary key.</p></li><li><p><code>Content-Type</code>, <code>Content-Subtype</code></p><p>These optional elements specify the Content-Type header field for the HTTP request.</p></li><li><p><code>body</code></p><p>If this optional element value is a dictionary:</p><ul><li>the HTTP body is composed as &quot;form data&quot;</li><li>if the <code>method</code> element is specified, it must be <code>POST</code>, <code>PUT</code>, <code>PATCH</code></li><li>if the <code>Content-Type</code> element is not specified, the request <code>Content-Type</code> field is set to <code>multipart/form-data</code>.</li><li>if the <code>Content-Type</code> element is specified, it must be <code>multipart</code>, otherwise the <code>Content-Subtype</code> must be specified, too, and it must be set to <code>x-www-form-urlencoded</code>.</li><li>if the <code>Content-Type</code> element is not specified or if it is set to <code>multipart</code>, request body form data is composed using the <code>mutlipart/form-data</code> format, otherwise the <code>x-www-form-urlencoded</code> format is used.</li><li>each dictionary value should be be either: <ul><li>a single value - a string, a number, a datablock, a dictionary</li><li>an array of single values</li></ul></li></ul><p>For an array-type value, form data for each array element is composed separately, using the same dictionary key.<br> If a single value is a dictionary, its empty-string (&quot;&quot;) element value is used. If the request uses the <code>mutlipart/form-data</code> format, then the dictionary <code>Content-Type</code>, <code>Content-Subtype</code>, and (optionally) <code>charset</code> string element values are used to compose the form element <code>Content-Type</code> header field, and the <code>filename</code> string element (if it exists) is added to the form element <code>Content-Disposition</code> header field. Example:<br> The following <code>body</code> element:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{</span></span>
<span class="line"><span>  field1 = &quot;value1&quot;; field2 = #145;</span></span>
<span class="line"><span>  field3 = [YWJjYWJj]; field4 = (&quot;value2&quot;,#777);</span></span>
<span class="line"><span>  field5 = {&quot;Content-Type&quot;=&quot;image&quot;; &quot;Content-Subtype&quot;=&quot;png&quot;; &quot;&quot; = [shjhsjhkwuyuieyriuyuiyi];};</span></span>
<span class="line"><span>}</span></span></code></pre></div><p>will be sent as</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field1&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>value1</span></span>
<span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field2&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>145</span></span>
<span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field3&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>abcabc</span></span>
<span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field4&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>value2</span></span>
<span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field4&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>777</span></span>
<span class="line"><span>--_______________post-field_</span></span>
<span class="line"><span>Content-Disposition: form-data; name=&quot;field5&quot;</span></span>
<span class="line"><span>Content-Type: image/png</span></span>
<span class="line"><span></span></span>
<span class="line"><span>binary data</span></span>
<span class="line"><span>--_______________post-field_--</span></span></code></pre></div><p>If this optional element value is a string:</p><ul><li>the string is copied line-by-line into the request body</li><li>the string EOL (End Of Line) separators are replaced with the Internet EOL (<code>&lt;carriage-return&gt;&lt;line-feed&gt;</code>) symbols</li><li>if the <code>Content-Type</code> element is not specified, the <code>Content-Type</code> field is set to <code>text/plain</code>.</li></ul><p>If this optional element value is a datablock:</p><ul><li>the datablock is used as the request body</li><li>if the <code>Content-Type</code> element is not specified, the <code>Content-Type</code> field is set to <code>application/octet-stream</code>.</li></ul><p>If this optional element value is an XML Object:</p><ul><li>the XML Object text presentation is copied into the text body.</li><li>if the <code>Content-Type</code> element is not specified, the <code>Content-Type</code> field is set to <code>text/xml</code>.</li></ul></li><li><p><code>charset</code></p><p>If this optional element is specified, it should be a name of a known character set. The request body is encoded from the UTF-8 encoding into the specified character set, and the <code>charset=_charset_name_</code> parameter is added to the <code>Content-Type</code> header field.<br> If this element value is an empty string, no <code>charset=_charset_name_</code> header field parameter is added.<br> If this element is not specified, the <code>charset=utf-8</code> header field parameter is added, but only if the Content Type of the request body is <code>text</code>.</p></li><li><p><code>closeConnection</code></p><p>If this element is specified, the module adds the <code>Connection: close</code> header field to the request.</p></li><li><p><code>User-Agent</code></p><p>If this element is specified, the module uses its string value as the custom <code>User-Agent</code> header field value. If this element value is an empty string, this header field is not sent at all.</p></li><li><p><code>Cookie</code></p><p>This optional element value should be a string. It is used as the <code>Cookie</code> header field data.</p></li><li><p><code>If-Modified-Since</code></p><p>The optional element should be either a timestamp or a string in the iCalendar date-time format. This element sets the HTTP request <code>If-Modified-Since</code> header field value.</p></li><li><p><code>responseFormat</code></p><p>This optional element specifies how the HTTP response body should be converted (see below).</p></li><li><p><code>authName</code>, <code>authPassword</code></p><p>These optional elements specify the credentials to send with the HTTP request.</p></li><li><p><code>timeout</code></p><p>If this optional element is specified, it should be a number or a numeric string. Its value specifies the time-out for the HTTP request(s) sent. This value cannot exceed the maximum time-out value specified with the calling Server component.<br> If this element is not specified, the maximum time-out value is used.</p></li><li><p><code>redirectLimit</code></p><p>This optional element specifies how many time the HTTP module can resend the request to the new destination (URL) when it receives a 3xx response from a remote server<br> If this element is not specified then the module resends a <code>GET</code> or <code>HEAD</code> up to 3 times, and does not resend other requests.</p></li><li><p><code>supplFields</code></p><p>This optional element is a dictionary. The dictionary keys specified additional HTTP request field names, and the dictionary values (which should be strings or arrays of strings) specify the HTTP request field values.</p></li></ul><p>The module returns either an error code, or a result dictionary with the following elements:</p><ul><li><p><code>responseCode</code></p><p>The numeric value of the HTTP response code (200 for successful operations, 300-399 for &quot;redirect&quot; responses the module has not processed itself, 400-599 for failed operations).</p></li><li><p><code>responseText</code></p><p>A string containing the information text part of the HTTP response line.</p></li><li><p><code>Content-Type</code>, <code>Content-Subtype</code></p><p>Strings containing the response body content type and subtype.</p></li><li><p><code>charset</code></p><p>A string with the response body charset. If this element is present (it was specified as the <code>charset=_charset_name_</code> parameter of the HTTP response <code>Content-Type</code> header field, the response body is encoded from that character set into the UTF-8 encoding.</p></li><li><p><code>body</code></p><p>This element exists if the HTTP response contains a non-empty body. This body is converted into the <code>body</code> response element according to the <code>responseFormat</code> request element value. If the responseFormat request element is not specified, the response Content type and subtype are used:</p><table tabindex="0"><thead><tr><th>responseFormat</th><th>Content-Type<br>(if responseFormat is not specified)</th><th>converted to</th></tr></thead><tbody><tr><td><code>xml</code></td><td><code>*/xml</code>, <code>*/*+xml</code></td><td>the body is interpreted as a text presentation of an XML Object. The <code>body</code> element is the XML Object read</td></tr><tr><td><code>calendar</code></td><td><code>*/calendar</code></td><td>the body is interpreted as an iCalendar text. The <code>body</code> element is an <a href="./../../development/Data.html#XMLiCalendar"><code>iCalendar</code> XML Object</a> presenting the parsed body text.</td></tr><tr><td><em>empty string</em></td><td><code>*/*</code></td><td>The <code>body</code> element is a datablock containing the HTTP response body.</td></tr></tbody></table><p>If the module fails to convert the HTTP response body, then it returns an error if the responseFormat was specified. If the responseFormat was not specified, then the HTTP response body is returned as a datablock.</p></li><li><p><code>Date</code>, <code>Last-Modified</code>, <code>Expires</code></p><p>Timestamp elements with the HTTP response header field values.</p></li><li><p><code>Server</code>, <code>Location</code></p><p>string elements with the response header field values.</p></li><li><p><code>Set-Cookie</code></p><p>string or array of strings with the response header field value(s).</p></li></ul>`,107)]))}const u=t(o,[["render",n]]);export{m as __pageData,u as default};
