import{_ as t,c as o,o as i,ag as r}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"LDAP Module","description":"","frontmatter":{"legacyLink":"LDAP.html"},"headers":[],"relativePath":"admin/services/LDAP.md","filePath":"admin/services/LDAP.md"}'),a={name:"admin/services/LDAP.md"};function n(s,e,c,d,l,h){return i(),o("div",null,e[0]||(e[0]=[r('<h1 id="ldap-module" tabindex="-1">LDAP Module <a class="header-anchor" href="#ldap-module" aria-label="Permalink to &quot;LDAP Module&quot;">​</a></h1><p>The CommuniGate Pro LDAP module implements an LDAP server for TCP/IP networks.</p><p>The LDAP protocol allows a client application (a mailer or a search agent) to connect to the Server computer and retrieve information from the server <a href="./../directory/">Directory</a>. The LDAP protocol can also be used to modify data in the Directory.</p><p>Besides the Directory, the LDAP module provides access to the <a href="./../objects/Accounts.html">Account Manager</a> for provisioning, and to the <a href="./../sysadmin/Router.html">Router</a> component for external filtering and other systems (E-mail address verifications).</p><p>The CommuniGate Pro LDAP module supports both <em>clear text</em> and <em>secure</em> <a href="./../sysadmin/PKI.html#TLS">SSL/TLS</a> connections. The LDAP module supports the &quot;Start TLS&quot; command (RFC2830) that allows client applications to establish a connection in the clear text mode and then turn it into a secure connection.</p><h2 id="Protocol" tabindex="-1">Lightweight Directory Access Protocol <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Lightweight Directory Access Protocol {#Protocol}&quot;">​</a></h2><p>The CommuniGate Pro LDAP module provides access to the CommuniGate Pro <a href="./../directory/">Directory</a> tree and its records.</p><p>It is important to understand that the CommuniGate Pro LDAP module itself does not provide any Directory services. It just implements an access protocol, and the functionality it provides depends on the CommuniGate Pro Directory Manager and its units.</p><p>Very often LDAP services are used to look for names and E-mail addresses of Server users. But since the LDAP module provides access to the entire <a href="./../directory/">Directory</a> tree, it can be used to work with any type of data placed into the CommuniGate Pro Directory. While the CommuniGate Pro Directory can be stored in several Storage Units - both local and remote, the LDAP clients see the entire Directory as one large tree.</p><p>To browse and modify the Directory, system administrators can use either LDAP clients and utilities, or the <a href="./../directory/#Browser">Directory Browser</a> interface built into the CommuniGate Pro WebAdmin Interface.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>While the LDAP module implements an LDAP server functionality, the CommuniGate Pro Server can also work as an LDAP client, using the LDAP protocol to access external LDAP servers and their databases. Those external Directories are presented as subtrees of the CommuniGate Pro Directory tree. See the <a href="./../directory/#Remote">Remote Units</a> Directory section for more details.</p></div><h2 id="Configuring" tabindex="-1">Configuring the LDAP module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the LDAP module {#Configuring}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the LDAP module. Open the Services pages in the Settings realm, and open the LDAP page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="LDAPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><select name="LDAPChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="25" selected="selected">25</option><option value="50">50</option><option value="100">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="5000">5000</option><option value="555">other</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the LDAP module should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the LDAP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.</p><p>The LDAP module records in the System Log are marked with the <code>LDAP</code> tag. Please note that LDAP is a binary protocol, so all low-level data is presented in the hexadecimal form.</p></li><li><p><code>Channels</code></p><p>When you specify a non-zero value for the <code>TCP/IP</code> Channels setting, the LDAP module creates a so-called &quot;listener&quot; on the specified port. The module starts to accept all LDAP connections that mail clients establish in order to update password data. This setting is used to limit the number of simultaneous connections the LDAP module can accept. If there are too many incoming connections open, the module will reject new connections, and the user should retry later.<br> If the number of channels is set to zero, the LDAP module closes the listener and releases (unbinds from) the TCP port(s).</p></li><li><p><code>listener</code></p><p>By default, the LDAP module Listener accepts clear text connections on the TCP port 389, and secure connections - on the TCP port 636. Follow the <a href="./../network/Listener.html">listener</a> link to tune the LDAP <a href="./../network/Listener.html">Listener</a>.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The pre-4.7 Netscape ® LDAP clients crash if they communicate with a very fast server returning more than 90 records. Ask your users to update to the 4.7 or later version of Netscape browser/mailer product.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Netscape® LDAP client (version 4.7) does not correctly process the &quot;properties&quot; command - it always tries to connect to the port 389, even if the search was successfully made on a different (for example, secure) port.</p></div><p>Sometimes you need to specify the Directory Tree Root element (an empty string) as the &quot;search base DN&quot;. Some LDAP clients do not process this situation correctly (for example, Microsoft LDAP client silently replaces an empty Search Base string with the <code>c=_your_country_</code> string).<br> In these cases you should specify the string  <code>top</code>  as your Search Base string. The LDAP module interpretes this string as an empty string (Directory Root DN).</p><h2 id="AUTH" tabindex="-1">Client Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;Client Authentication {#AUTH}&quot;">​</a></h2><p>The Directory Access Rights are based on the so-called Bind DNs rather than on CommuniGate Pro Account names and Account rights. See the Directory Manager <a href="./../directory/#AccessRights">Access Rights</a> section for more details.</p><p>The Directory Access Rights set by default do not require Directory (LDAP) clients to authenticate in order to retrieve any information from the Directory tree.</p><p>When an LDAP client tries to authenticate as a certain DN, the LDAP server retrieves the Directory record with the specified DN and compares that record <code>userPassword</code> attribute with the password supplied by the LDAP client. If the record exists, and it contains the <code>userPassword</code> attribute, and the attribute value matches the supplied password, the LDAP client authentication succeeds.</p><p>The LDAP module provides an alternative authentication method, when the client specifies a CommuniGate Pro Account name instead of some record DN. In this case, the CommuniGate Pro Server opens the specified Account and compares the Account password with the supplied password. If the passwords match, the Server builds a DN for the Account record using the <a href="./../directory/CentralDir.html">Directory Integration</a> settings, and uses it as the Bind DN.</p><p>Sample: If the Directory Integration settings are:</p><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td>Base DN:</td><td><code>o=myCompany</code></td></tr><tr><td>Domain RDN attribute:</td><td><code>cn</code></td></tr></tbody></table><p>and the client has submitted the <code>user@domain.dom</code> name and the correct password for the <a href="mailto:user@domain.com" target="_blank" rel="noreferrer">user@domain.com</a> account, then the LDAP client is authenticated with the following Bind DN:<br><code>uid=user,cn=domain.dom,o=myCompany</code><br> and this client can access the Directory information available for that Bind DN.</p><p>The LDAP module uses the alternative authentication method if the specified string does not contain any equals (<code>=</code>) symbol, or if it starts with the <code>mail=</code> symbols and does not contain any other equals (<code>=</code>) symbols.</p><p>This authentication service can be disabled by disabling the <code>LDAP</code> <a href="./../objects/Accounts.html#Services">Service</a> for a Domain and/or an Account.</p><p>The <a href="./../directory/CentralDir.html#LDAPProvisioning">LDAP Provisioning</a> option can modify the authentication process. If this option is enabled and the supplied Bind DN represents the DN for some CommuniGate Pro Account, the supplied Bind DN is converted into that Account name, and the alternative method is used.</p><table tabindex="0"><thead><tr><th>Bind DN string specified</th><th>Data used to verify the password</th></tr></thead><tbody><tr><td><code>uid=user,cn=domain.dom,o=myCompany</code> (LDAP Provisioning is off)</td><td>the <code>userPassword</code> record attribute of the <code>uid=user,cn=domain.dom,o=myCompany</code> Directory record</td></tr><tr><td><code>ou=human_resources,o=myCompany</code></td><td>the <code>userPassword</code> record attribute of the<code>ou=human_resources,o=myCompany</code> Directory record</td></tr><tr><td><code>user@domain.com</code></td><td>the <code>user@domain.dom</code> Account password</td></tr><tr><td><code>mail=user@domain.com</code></td><td>the <code>user@domain.dom</code> Account password</td></tr><tr><td><code>uid=user,cn=domain.dom,o=myCompany</code> (LDAP Provisioning is on)</td><td>the <code>user@domain.dom</code> Account password</td></tr></tbody></table><p>The LDAP module allows users to employ all <a href="./../sysadmin/Security.html">authentication methods</a> supported with the CommuniGate Pro Server. It supports Simple, SASL, and NTLM BIND methods.</p><p>If the Account password authentication method is used, and the specified Account has the <a href="./../sysadmin/#Privs">Directory Administrator</a> access right, the LDAP client can access and modify all Directory data (&quot;master&quot;-type access).</p><h2 id="Central" tabindex="-1">Central (users) Directory <a class="header-anchor" href="#Central" aria-label="Permalink to &quot;Central (users) Directory {#Central}&quot;">​</a></h2><p>The LDAP services can be used to retrieve information about the CommuniGate Pro <a href="./../objects/Accounts.html">Accounts</a> and other Domain <a href="./../objects/">Objects</a>.</p><p>To search the Directory for CommuniGate Pro Domain Objects (Accounts, Groups, Mailing Lists), the LDAP clients should be tuned to point to the proper Subtree (this parameter is called &quot;Search Base&quot; in many LDAP clients). The Directory Subtree for the <code>company.com</code> Domain is <code>cn=company.com,o=MyCompany</code>, where cn is the Domain RDN attribute, and o=MyCompany is the Base DN for CommuniGate Pro Domains. The Base DN and Domain RDN attribute are the <a href="./../directory/CentralDir.html#SubTree">Directory Integration</a> settings and can be modified. If these settings are modified, the locations of Domain subtrees are changed, and the LDAP clients should be reconfigured to specify the new locations in their &quot;Search Base&quot; settings.</p><h2 id="RouterDN" tabindex="-1">Router Subtree <a class="header-anchor" href="#RouterDN" aria-label="Permalink to &quot;Router Subtree {#RouterDN}&quot;">​</a></h2><p>Some external application and devices (such as external E-mail filters) use the LDAP protocol to verify if the E-mail recipient should be accepted on behalf of the &quot;main&quot; mail server.<br> These applications check a <em>object</em>@<em>domain</em> E-mail address using one of the following requests:</p><ul><li>a &#39;record retrieval&#39; (scope=base) request for the <code>mail=_object_@_domain_,_searchbase_</code> DN, or</li><li>a &#39;record search&#39; (scope=one) request for the <code>_searchbase_</code> DN, using the <code>mail=_object_@_domain_</code> filter</li></ul><p>To support these application and devices, the CommuniGate Pro LDAP module implements a virtual <code>dc=cgprouter</code> Directory subtree. If a &#39;record retrieval&#39; (scope=base) request DN is <code>mail=_object_@_domain_,dc=cgprouter</code>, or a &#39;record search&#39; (scope=one) request DN is <code>dc=cgprouter</code>, and the search filter is <code>mail=_object_@_domain_</code>, the LDAP module does not consult the Directory. Instead, it tries to process the specified <em>object</em>@<em>domain</em> E-mail address using the <a href="./../sysadmin/Router.html">Router</a> component.</p><p>If the specified E-mail address is successfully routed to a local Account, or to the &quot;Black Hole&quot;, or it is routed to an external host, but relaying to that host is allowed, the LDAP module returns a fictitious Directory record, informing an application that the supplied E-mail address is a valid one, and E-mail sent to that address can be accepted.</p><p>If the address can not be routed (or relaying is not allowed) and the request was the &#39;record search&#39; one, the result is empty. If the request was the &#39;record retrieval&#39; one, the result delivers routing error.</p><h2 id="Limits" tabindex="-1">Limits <a class="header-anchor" href="#Limits" aria-label="Permalink to &quot;Limits {#Limits}&quot;">​</a></h2><p>LDAP memory usage restrictions</p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>LDAP response</b></td></tr><tr><td>LDAP response size limit: <select class="popup"><option>100K</option> <option>300K</option> <option>500K</option> <option>1024K</option> <option>2M</option> <option>5M</option> <option>10M</option> <option>15M</option> <option>other</option></select></td></tr></tbody></table></div><ul><li><p><code>Size</code></p><p>Maximum allowed size (in bytes) of the LDAP response</p></li></ul><h2 id="Provisioning" tabindex="-1">LDAP Provisioning <a class="header-anchor" href="#Provisioning" aria-label="Permalink to &quot;LDAP Provisioning {#Provisioning}&quot;">​</a></h2><p>CommuniGate Pro supports Directory-based Domains. Account information in those Domains is stored in the Directory, and the LDAP module can be used to modify Account data in the Directory. Directory-based Domains resemble the architecture of some older Messaging Systems, and CommuniGate Pro supports it for compatibility and migration reasons. See the <a href="./../directory/CentralDir.html#DirectoryDomains">Directory-Based Domains</a> section for more details.</p><p>The LDAP module can also be used to perform basic provisioning operations within regular Domains. This feature is called LDAP Provisioning. If the DN specified in the request &quot;looks like&quot; a DN of a Directory record that some CommuniGate Pro Account has (or could have), the LDAP module does not perform any operation on the Directory at all. Instead of passing the request to the Directory, the LDAP module sends a command directly to the Account Manager, and the Account Manager creates/removes/renames/updates/reads the specified Account. See the <a href="./../directory/CentralDir.html#LDAPProvisioning">Directory Integration</a> section for more details.</p><h2 id="MailAttribute" tabindex="-1">The <code>mail</code> Attribute processing <a class="header-anchor" href="#MailAttribute" aria-label="Permalink to &quot;The `mail` Attribute processing {#MailAttribute}&quot;">​</a></h2><p>Many LDAP clients expect to see the <code>mail</code> attribute in Account and other Domain Object records. But, by default, CommuniGate Pro does not store such an attribute in those directory records.</p><p>If the LDAP module has to return such a record (a record of the CommuniGateAccount, CommuniGateMailList, or CommuniGateGroup object class), and that record does not contain the <code>mail</code> attribute, the LDAP module can compose that attribute on-the-fly, using the Object record DN: it takes the <code>uid</code> value from the DN (Account/Object name), the <code>cn</code> attribute value (Domain name), and merges them using the <code>@</code> symbol to build the uidValue@cnValue <code>mail</code> attribute value. As a result, when an object is renamed (its record <code>uid</code> attribute is changed), or when the Domain is renamed (the <code>cn</code> attribute in the object DN is changed), the <code>mail</code> attribute is automatically updated.</p><p>Since the <code>mail</code> attribute is not stored in the Directory records by default, all search filters that use the <code>mail</code> attribute can be modified internally to use the <code>uid</code> attribute instead. If the search operation is &quot;equals to&quot;, and the search string contains the <code>@</code> symbol, only the part of the string before that symbol is used.</p><p>These two features can be enabled or disabled using the Domain Integration page in the Users realm of the WebAdmin Interface:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>LDAP Attribute Processing</b></td></tr><tr><td><input name="SubstituteMailAttr" value="1" checked="checked" type="checkbox"> Substitute &#39;mail&#39; with &#39;uid&#39; in conditions</td></tr><tr><td><input name="ComposeMailAttr" value="1" checked="checked" type="checkbox"> Compose &#39;mail&#39; using &#39;uid&#39;</td></tr><tr><td><input name="IgnoreObjCategory" value="1" checked="checked" type="checkbox"> Ignore &#39;objectCategory&#39; conditions</td></tr></tbody></table></div></form><ul><li><p><code>Ignore objectCategory filters</code></p><p>Some clients (including Microsoft Outlook) always send their LDAP search requests using filters checking for certain <code>objectCategory</code> attribute values.<br> Since this attribute is not included into CommuniGate Pro Account records by default, you would have to create this attribute as a Custom one, and put a &quot;proper&quot; value into each Account settings.<br> This option tells the LDAP server to ignore all &quot;objectCategory equals <em>value</em>&quot; search operations (the Server treats these operations as the constant <code>true</code>-values).</p></li></ul><p>The LDAP module checks if a search request explicitly specifies the <code>displayName</code> attribute. If a retrieved record does not contain that attribute, but the record contains the <code>cn</code> attribute, or the <code>uid</code> attribute, the value of the <code>cn</code> or <code>uid</code> attribute is included into the response as the <code>displayName</code> attribute value.</p><h2 id="Paging" tabindex="-1">Paging Search Results <a class="header-anchor" href="#Paging" aria-label="Permalink to &quot;Paging Search Results {#Paging}&quot;">​</a></h2><p>The LDAP module supports the Extension for Simple Paged Results Manipulation (<a href="http://www.ietf.org/rfc/rfc2696.txt" target="_blank" rel="noreferrer">RFC2696</a>) which allows LDAP clients to retrieve large search results in smaller portions (pages).<br> However, to return one page to a client the Server has to find all records matching the search criteria, then optionally sort them; and only then it can return the requested page. In order to prevent the performance degradation caused by repetitive searches and sortings the Server may cache several such search results using its internal memory.</p><p>The caching parameters can be adjusted using the Domain Integration page in the Users realm of the WebAdmin Interface:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>LDAP paged Search Results Cache</b></td></tr></tbody><tbody><tr><td width="50%" align="right">Size:<select class="popup"><option>0</option><option>1</option><option>2</option>3<option>5</option> 10<option>20</option><option>30</option><option>50</option><option>other</option></select></td><td width="50%" align="left">Used: 1</td></tr><tr><td width="50%" align="right">Time-out:<select class="popup"><option>60 sec</option><option>2 min</option><option>3 min</option> <option selected="selected">4 min</option><option>5 min</option><option>10 min</option><option>20 min</option><option>30 min</option> <option>60 min</option><option>other</option></select></td><td width="50%"> </td></tr></tbody></table></div></form><ul><li><p><code>Size</code></p><p>The maximum number of cached search results.</p></li><li><p><code>Used</code></p><p>The number of currntly cached results.</p></li><li><p><code>Time-out</code></p><p>The time period since the last client retrieval of a subsequent page, after which the memory used by cached data will be released.</p></li></ul>',61)]))}const m=t(a,[["render",n]]);export{p as __pageData,m as default};
