import{_ as t,c as o,o as a,ag as n}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"PWD Module","description":"","frontmatter":{"legacyLink":"PWD.html"},"headers":[],"relativePath":"admin/services/PWD.md","filePath":"admin/services/PWD.md"}'),s={name:"admin/services/PWD.md"};function r(i,e,l,d,c,p){return a(),o("div",null,e[0]||(e[0]=[n('<h1 id="pwd-module" tabindex="-1">PWD Module <a class="header-anchor" href="#pwd-module" aria-label="Permalink to &quot;PWD Module&quot;">​</a></h1><p>The CommuniGate PWD module implements a poppwd server for TCP/IP networks.</p><p>The poppwd protocol allows a client application to connect to the Server computer and to specify the user (Account) name and the password. If access to the specified user account is granted, the mailer application sends the new password to the Server, and the server update the user password in the user account information data.</p><p>The PWD module also provides access to the Server <a href="./../../development/CLI.html">Command Line Interface</a> (CLI)</p><h2 id="Protocol" tabindex="-1">Password Modification Protocol (poppwd) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Password Modification Protocol (poppwd) {#Protocol}&quot;">​</a></h2><p>The PWD module can be used to modify the CommuniGate Pro Account password. If the &quot;old&quot; password specified by a mail client matches the password set in the user&#39;s Account Settings, the new password is stored in the Account Settings.</p><p>The PWD module checks the Can Modify Password <a href="./../objects/Accounts.html#Settings">Account Settings</a> option and refuses to modify an Account password if this option is disabled.</p><p>The PWD module supports the <em>clear text</em> authentication method, and it also supports the secure APOP and SASL AUTH authentication methods.</p><p>When used in a <a href="./../cluster/">Cluster environment</a>, the PWD module can update passwords on all Cluster member servers.</p><h2 id="Configuring" tabindex="-1">Configuring the PWD module <a class="header-anchor" href="#Configuring" aria-label="Permalink to &quot;Configuring the PWD module {#Configuring}&quot;">​</a></h2><p>Use a Web browser to open the Settings realm of the WebAdmin Interface. Open the Services pages, then open the PWD page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="PWDLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right">Channels:</td><td><input name="MaxInputChannels" value="10" size="10" maxlength="24" type="text"></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the PWD module should put in the Server Log. Usually you should use the <code>Major</code> (password modification reports) or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the PWD module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.<br> The poppwd clients send passwords in the clear text format, and setting the Log setting to these values for long periods of time can become a security hole, if the Log file can be copied from the Server computer.</p><p>The PWD module records in the System Log are marked with the <code>PWD</code> tag.</p></li><li><p><code>channels</code></p><p>When you specify a non-zero value for the <code>TCP/IP</code> Channels setting, the PWD module creates a so-called &quot;listener&quot; on the specified port. The module starts to accept incoming PWD connections.<br> This setting is used to limit the number of simultaneous connections the PWD module can accept. If there are too many incoming connections open, the module will reject new connections, and the user should retry later.<br> If the number of channels is set to zero, the PWD module closes the listener and releases (unbinds from) the TCP port.</p></li><li><p><code>listener</code></p><p>By default, the PWD module Listener accepts clear text connections on the TCP port 106. Follow the <a href="./../network/Listener.html">listener</a> link to tune the PWD <a href="./../network/Listener.html">Listener</a>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some versions of Apple MacOS X use the port 106 for Apple&#39;s own version of a Password Server. To avoid conflicts with that program, the default CommuniGate Pro PWD port on that OS is set to 8106.</p></div></li></ul><h2 id="CLI" tabindex="-1">Providing Access to the Server CLI <a class="header-anchor" href="#CLI" aria-label="Permalink to &quot;Providing Access to the Server CLI {#CLI}&quot;">​</a></h2><p>As soon as a PWD user is authenticated, the Server Command Line Interface (CLI) commands are accepted. See the <a href="./../../development/CLI.html">Command Line Interface</a> section for the details.</p>',15)]))}const m=t(s,[["render",r]]);export{u as __pageData,m as default};
