import{_ as i,C as s,c as l,o as r,ag as o,j as e,a as n,G as d,w as u}from"./chunks/framework.jCcxW76o.js";const R=JSON.parse('{"title":"RADIUS Module","description":"","frontmatter":{"legacyLink":"RADIUS.html"},"headers":[],"relativePath":"admin/services/RADIUS.md","filePath":"admin/services/RADIUS.md"}'),c={name:"admin/services/RADIUS.md"},p={action:"Null.html"},h={class:"settingsBox"},m={width:"100%"},A={class:"settingsBox",width:"100%"},g={colspan:"2",align:"center"};function v(S,t,f,I,D,U){const a=s("font");return r(),l("div",null,[t[7]||(t[7]=o('<h1 id="radius-module" tabindex="-1">RADIUS Module <a class="header-anchor" href="#radius-module" aria-label="Permalink to &quot;RADIUS Module&quot;">​</a></h1><p>The CommuniGate Pro Server supports the RADIUS authentication and account protocol. It can be used with for various NAS (Network Access Server) devices and programs.</p><p>The RADIUS module acts as a RADIUS server. It receives authentication requests from RADIUS clients (NAS), verifies the supplied credentials and accepts or rejects these requests.</p><p>The RADIUS module supports the following authentication methods:</p><ul><li>PAP</li><li>CHAP</li><li>MS-CHAPv1</li><li>MS-CHAPv2</li><li>EAP <ul><li>MD5-Challenge</li></ul></li><li>DIGEST-MD5</li></ul><p>The RADIUS module can use an external helper application to implement site-specific access policy (based on RADIUS request attributes) and to return additional attributes to NAS.</p><h2 id="Config" tabindex="-1">Configuring the RADIUS Module <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the RADIUS Module {#Config}&quot;">​</a></h2><p>By default the CommuniGate Pro RADIUS module is not activated.</p><p><a href="./../../development/CGPL.html">CG/PL</a> applications can communicate with remote RADIUS servers: they can send RADIUS requests and receive RADIUS responses. To enable this RADIUS client functionality, the RADIUS module has to be activated.</p><p>Use the WebAdmin Interface to configure the RADIUS module. Open the Services pages in the Settings realm, and open the RADIUS page:</p>',10)),t[8]||(t[8]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Processing")])]),e("tr",null,[e("td",{align:"right"},"Log Level:"),e("td",null,[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3",selected:"selected"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{class:"arrow",align:"right"},[e("a",{href:"Listener.html"},"Listener")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Password:"),e("td",null,[e("input",{name:"Password",value:"********",size:"12",maxlength:"50",type:"text"})]),e("td",null,[e("input",{name:"CheckNASID",value:"1",type:"checkbox"}),n(" Require NAS ID")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Channels:"),e("td",null,[e("select",{name:"RADIUSChannels"},[e("option",{value:"1"},"1"),e("option",{value:"3",selected:"selected"},"3"),e("option",{value:"5"},"5"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100")])]),e("td",null,[e("input",{name:"RecordLog",value:"1",type:"checkbox"}),n(" Record")])])])])])],-1)),t[9]||(t[9]=o('<ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the RADIUS module should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the RADIUS module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.</p><p>The RADIUS module Log records are marked with the <code>RADIUS</code> tag. Please note that RADIUS is a binary protocol, so all low-level data is presented in the hexadecimal form.</p></li><li><p><code>listener</code></p><p>Use this link to open the UDP Listener page and specify the port number and local network address for the RADIUS server authentication service, and access restrictions for that port. When the port number is set to 0, the RADIUS server is disabled.<br> By default RADIUS clients send requests to the UDP port 1812.<br> If your server computer is already running some RADIUS server, you may want to specify a non-standard port number here and reconfigure your RADIUS client software to use that port number.</p></li><li><p><code>Channels</code></p><p>Use this setting to specify the number of RADIUS module processors (threads) used to process RADIUS requests. If you set this setting to 0, all requests will be processed directly with the RADIUS Listener thread(s).</p></li><li><p><code>Require NAS ID</code></p><p>The RADIUS protocol requires all requests to contain a <code>NAS-Identifier</code> or a <code>NAS-IP-Address</code> attribute (or both). If this option is not selected, requests without these attribute are accepted, and the word <code>unknown</code> is used as the Identifier in the module log records.</p></li><li><p><code>Password</code></p><p>Use this setting to specify the RADIUS &quot;shared secret&quot;. All RADIUS clients should use the same &quot;shared secret&quot; in order to access the RADIUS server.</p></li><li><p><code>Record</code></p><p>If this option is enabled, the RADIUS module stores all Accounting requests in a text file. See the <a href="#Log">Accounting Log</a> section below.</p></li></ul><h2 id="AUTH" tabindex="-1">RADIUS Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;RADIUS Authentication {#AUTH}&quot;">​</a></h2><p>The RADIUS module accepts properly formatted &quot;Access-Request&quot; requests from RADIUS clients, retrieves the User-Name and User-Password attributes and tries to find the specified CommuniGate Pro <a href="./../objects/Accounts.html">Account</a> and verify its password. If the password can be verified and the Account and its Domain both have the RADIUS Service enabled, a positive response is sent to the RADIUS client, otherwise a negative response with the error code text is sent.</p><p>If the CommuniGate Password option is enabled for the specified Account, the RADIUS module checks if the Account has the <code>RADIUSPassword</code> setting. If it exists, it is used instead of the standard <code>Password</code> setting. This feature allows an Administrator to assign a alternative Account password to be used for the RADIUS authentication only.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Clients authenticating via RADIUS do not use any network address on the Server, and Secondary Domain users should specify their full Account name (<code>_account_@_domain_</code>), or should specify a name that is routed to their Account using the <a href="./../sysadmin/Router.html">Router</a>. Because the Router is used to process the User-Name attribute, account aliases can be used for authentication, too. See the <a href="./../cluster/Access.html">Access</a> section for more details.</p></div><h2 id="External" tabindex="-1">External Helper <a class="header-anchor" href="#External" aria-label="Permalink to &quot;External Helper {#External}&quot;">​</a></h2><p>The CommuniGate Pro Server can use an external Helper program to implement a RADIUS authentication policy. That program should be created by your own technical staff.</p><p>The program name and its optional parameters should be specified using the WebAdmin Helpers page. Open the General page in the Settings realm, and click the Helpers link:</p>',8)),e("form",p,[e("div",h,[e("table",m,[e("tbody",null,[t[6]||(t[6]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"External RADIUS")])],-1)),e("tr",null,[e("td",null,[t[5]||(t[5]=e("input",{name:"ExternalFilters",value:"0",type:"hidden"},null,-1)),e("table",A,[e("tbody",null,[e("tr",null,[t[1]||(t[1]=e("td",{align:"right"},[e("input",{name:"O3",value:"",type:"hidden"}),n(),e("select",{name:"U3"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])],-1)),t[2]||(t[2]=e("td",null,[e("input",{name:"N3",value:"RADIUS",size:"15",maxlength:"200",type:"text"})],-1)),e("td",g,[d(a,{color:"red"},{default:u(()=>t[0]||(t[0]=[e("i",null,null,-1)])),_:1})])]),t[3]||(t[3]=e("tr",null,[e("td",{align:"right",width:"25%"},"Log Level:"),e("td",null,[e("select",{name:"A"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2",selected:"selected"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right",width:"25%"},"Program Path:"),e("td",null,[e("input",{name:"P3",value:"helpers/RADIUSpolicy",size:"30",maxlength:"255",type:"text"})])],-1)),t[4]||(t[4]=e("tr",null,[e("td",{align:"right"},"Time-out:"),e("td",null,[e("select",{name:"C"},[e("option",{value:"0",selected:"selected"},"disabled"),e("option",{value:"15"},"15 seconds"),e("option",{value:"30"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour")])]),e("td",{align:"right"},"Auto-Restart:"),e("td",null,[e("select",{name:"D"},[e("option",{value:"0"},"disabled"),e("option",{value:"5"},"5 seconds"),e("option",{value:"7"},"7 seconds"),e("option",{value:"10"},"10 seconds"),e("option",{value:"15",selected:"selected"},"15 seconds"),e("option",{value:"30"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours")])])],-1))])])])])])])])]),t[10]||(t[10]=o('<p>See the <a href="./../../development/Helpers.html">Helper Applications</a> section to learn about these options. The External RADIUS module System Log records are marked with the <code>EXTRADIUS</code> tag.</p><p>If the External RADIUS program is not enabled, then the positive authentication response is sent as soon as the user password is verified. The response does not contain any additional attributes.</p><p>To learn how to create your own External RADIUS programs, see the <a href="./../../development/Helpers.html#RADIUS">Helper Applications</a> section.</p><p>Sample External RADIUS programs and scripts can be found at the <a href="http://www.communigatepro.ru/CGRADIUS/" target="_blank" rel="noreferrer">RADIUS Helper programs</a> site.</p><h2 id="Log" tabindex="-1">Accounting Log <a class="header-anchor" href="#Log" aria-label="Permalink to &quot;Accounting Log {#Log}&quot;">​</a></h2><p>If the Record option is enabled, all RADIUS accounting operations are recorded in a text-based Accounting Log file. The Accounting Log files are stored inside the <code>RADIUSLog</code> file subdirectory.</p><p>A single-server system creates the <code>RADIUSLog</code> directory inside the Settings subdirectory of the <em>base directory</em>.<br> A <a href="./../cluster/">Dynamic Cluster</a> system creates the <code>RADIUSLog</code> directory inside the Settings subdirectory of the <em>SharedDomains</em> directory.</p><p>Each RADIUS Accounting Log file has a <code>_yyyy_-_mm_-_dd_</code> file name (where <em>yyyy</em> is the current year, <em>mm</em> is the current month, and <em>dd</em> is the current month day), with the <code>log</code> file name extension. At local midnight, a new Accounting Log file is created.</p><p>Each RADIUS Accounting Log record is a text line containing a time-stamp, the operation type or command (<code>started</code>, <code>ended</code>, <code>updated</code>, <code>inited</code>, <code>stopped</code>), and optionally an account name.<br> The rest of the line contains accounting request attributes.<br> Each attribute is stored using the numeric attribute type, the equal (<code>=</code>) symbol, and the attribute value.<br> Attribute values are encoded in the same way as in they are encoded in dictionaries used in <a href="./../../development/Helpers.html">External RADIUS Helper</a> Interface.</p>',9))])}const y=i(c,[["render",v]]);export{R as __pageData,y as default};
