import{_ as t,c as o,o as a,ag as r}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"SNMP Module","description":"","frontmatter":{"legacyLink":"SNMP.html"},"headers":[],"relativePath":"admin/services/SNMP.md","filePath":"admin/services/SNMP.md"}'),n={name:"admin/services/SNMP.md"};function s(i,e,l,d,p,c){return a(),o("div",null,e[0]||(e[0]=[r('<h1 id="snmp-module" tabindex="-1">SNMP Module <a class="header-anchor" href="#snmp-module" aria-label="Permalink to &quot;SNMP Module&quot;">​</a></h1><p>The CommuniGate Pro Server maintains a set of <a href="./../sysadmin/Statistics.html">Statistics Elements</a> containing information about the Server activity. These Elements can be be accessed via the built-in SNMP server (&quot;agent&quot;).</p><p>The SNMP agent receives requests from SNMP clients (&quot;managers&quot;) and either returns the information about internal states, counters, problems, or modifies the internal settings by a client request.</p><p>The <a href="http://www.communigatepro.ru/CGMRTG/" target="_blank" rel="noreferrer">Setting up MRTG for CommuniGate Pro</a> document should help you configure the popular freeware SNMP manager.</p><h2 id="Config" tabindex="-1">Configuring the SNMP Module <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the SNMP Module {#Config}&quot;">​</a></h2><p>By default, the CommuniGate Pro SNMP agent is not activated.</p><p>Use the WebAdmin Interface to configure the SNMP Module. Open the Services pages in the Settings realm, and open the SNMP page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="SNMPLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td></tr><tr><td align="right">Password:</td><td colspan="2"><input name="Password" value="********" size="12" maxlength="50" type="text"></td></tr><tr><td align="right">Trap Password:</td><td colspan="2"><input name="ActivePassword" value="********" size="12" maxlength="50" type="text"></td></tr><tr><td align="right">Trap Protocol:</td><td colspan="2"><select name="TrapProtocol"><option value="0" selected="selected">SNMPv1</option><option value="1">SNMPv2</option><option value="2">SNMPv3</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the SNMP agent should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the SNMP agent, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.</p><p>The SNMP agent records in the System Log are marked with the <code>SNMP</code> tag. Please note that SNMP is a binary protocol, so all low-level data is presented in the hexadecimal form.</p></li><li><p><code>listener</code></p><p>Use this link to open the UDP Listener page and specify the port number and local network address for the SNMP agent, and access restrictions for that port. When the port number is set to 0, the SNMP agent is disabled.<br> By default SNMP Manager programs send requests to the UDP port 161.<br> If your server computer is already running some other SNMP agent, you may want to specify a non-standard port number here and reconfigure your SNMP Manager software to use that port number.</p></li><li><p><code>Password</code></p><p>Use this setting to specify the SNMP &quot;community name&quot;. The CommuniGate Pro SNMP agent accepts only those SNMP requests that contain the proper &quot;community name&quot; data.</p></li><li><p><code>Trap Password</code></p><p>This setting specifies an alternative SNMP &quot;community name&quot;. The CommuniGate Pro SNMP agent accepts SNMP requests containing this &quot;community name&quot;, and remembers the network (IP) addresses those requests have come from. The module then can send SNMP <a href="#Traps">Traps</a> to all remembered addresses.</p></li><li><p><code>Trap Protocol</code></p><p>This setting specifies the SNMP protocol version to use when sending SNMP Traps.</p></li></ul><h2 id="MIB" tabindex="-1">Accessing the Server MIB <a class="header-anchor" href="#MIB" aria-label="Permalink to &quot;Accessing the Server MIB {#MIB}&quot;">​</a></h2><p>The MIB (Management Information Base) is a text file describing the internal objects the SNMP agent can display, monitor, and/or modify. You need the CommuniGate Pro MIB file to properly configure the SNMP client (&quot;manager&quot;) you want to use for server monitoring.</p><p>Different versions of the CommuniGate Pro software support different sets of internal objects, and CommuniGate Pro Server generates its MIB by a user request, presenting the most current information.</p><p>To access the CommuniGate Pro MIB file, use the WebAdmin interface to access the CGatePro-MIB.txt file:<br><code>http://yourservername:8010/CGatePro-MIB.txt</code></p><p>Save this file to a monitoring workstation disk and use it to configure your SNMP manager software.</p><h2 id="Traps" tabindex="-1">Sending SNMP Traps <a class="header-anchor" href="#Traps" aria-label="Permalink to &quot;Sending SNMP Traps {#Traps}&quot;">​</a></h2><p>The SNMP module can send Traps on certain Events. See the <a href="./../sysadmin/Statistics.html#Handlers">Statistics Triggers</a> section for more details. Traps can be sent to the network addresses explicitly specified in the Event Handler settings and/or to all remembered network addresses - addresses from which SNMP requests with the &quot;Trap Password&quot; <em>community name</em> have been received.</p><p>The SNMP module sends Traps using the SNMP protocol version specified with the Trap Protocol setting.</p>',17)]))}const m=t(n,[["render",s]]);export{u as __pageData,m as default};
