import{_ as t,c as o,o as s,ag as i}from"./chunks/framework.jCcxW76o.js";const h=JSON.parse('{"title":"STUN Module","description":"","frontmatter":{"legacyLink":"STUN.html"},"headers":[],"relativePath":"admin/services/STUN.md","filePath":"admin/services/STUN.md"}'),n={name:"admin/services/STUN.md"};function a(r,e,l,p,d,c){return s(),o("div",null,e[0]||(e[0]=[i('<h1 id="stun-module" tabindex="-1">STUN Module <a class="header-anchor" href="#stun-module" aria-label="Permalink to &quot;STUN Module&quot;">​</a></h1><p>The CommuniGate Pro Server supports the STUN protocol.</p><p>The STUN module acts as a STUN server. It receives requests from client systems and sends back responses, containing the IP Network information that these systems can use to detect the type of NAT network they are in.</p><h2 id="Config" tabindex="-1">Configuring the STUN Module <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the STUN Module {#Config}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the STUN module. Open the Services pages in the Settings realm, and open the STUN page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td class="arrow" align="right">UDP <a href="Listener.html">Listener</a></td><td colspan="2"> </td></tr><tr><td colspan="2"> </td><td class="arrow" align="right">TCP <a href="Listener.html">Listener</a></td><td align="RIGHT">Channels:</td><td><select class="popup" name="MaxInputChannels"><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="31">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify which records the STUN module should put in the Server Log.</p><p>The STUN module Log records are marked with the <code>STUN</code> tag.</p></li><li><p><code>Listener</code></p><p>Use this link to open the UDP Listener and TCP Listener pages and specify the port numbers and local network addresses for the STUN service, and access restrictions for these port.<br> By default STUN clients send &quot;Bind&quot; requests to the UDP port 3478, and they send &quot;Shared Secret&quot; requests to the secured TCP (TLS) port 5349.</p></li><li><p><code>Channels</code></p><p>Use this setting to specify the maximum concurrent number of STUN TCP requests.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The &quot;old&quot; STUN protocol (RFC 3489) requires 4 UDP sockets to be configured, using 2 different ports and 2 different IP Addresses, in all combinations. To support the RFC 3489 protocol, the STUN server should have at least 2 different Local IP Addresses available to its clients.</p></div><h2 id="Multiplex" tabindex="-1">Protocol Multiplexing <a class="header-anchor" href="#Multiplex" aria-label="Permalink to &quot;Protocol Multiplexing {#Multiplex}&quot;">​</a></h2><p>The <a href="./../signals/SIP.html">SIP</a> module supports STUN packet multiplexing with the SIP protocol. When a STUN packet is received on any of the SIP UDP Listener sockets, the packet is passed to the STUN module for processing.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The STUN module must know the exact Network IP Address the request was received on. To support STUN protocol, the SIP Module UDP Listener sockets must be configured using explicitly specified IP Addresses, and not use the &quot;all addresses&quot; settings.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The SIP module UDP Listener sockets can be used as &quot;alternative&quot; STUN address and port. I.e. you can create only 2 UDP Listener sockets for the network address IP1, port 3478, and for the network address IP2, port 3478 - if there are at least 2 SIP UDP Listener sockets, for:</p><ul><li>network address IP1, port 5060 (or any port other than 3478)</li><li>network address IP2, port 5060 (or any port other than 3478)</li></ul></div><p>To support ICE clients, the STUN module supports STUN packet multiplexing with the RTP protocol: the Media Proxy and Media Server legs detect STUN packets and send them the the STUN module for processing.</p>',13)]))}const m=t(n,[["render",a]]);export{h as __pageData,m as default};
