import{_ as a,c as n,o,ag as s,j as e}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Instant Messaging and Presence","description":"","frontmatter":{"legacyLink":"IMPresence.html"},"headers":[],"relativePath":"admin/signals/IMPresence.md","filePath":"admin/signals/IMPresence.md"}'),i={name:"admin/signals/IMPresence.md"};function r(c,t,l,d,u,h){return o(),n("div",null,t[0]||(t[0]=[s('<h1 id="instant-messaging-and-presence" tabindex="-1">Instant Messaging and Presence <a class="header-anchor" href="#instant-messaging-and-presence" aria-label="Permalink to &quot;Instant Messaging and Presence&quot;">​</a></h1><p>The CommuniGate Pro Real-Time component can receive, send, and relay Instant Message requests. These requests usually contain small text strings, but they also can contain service information (such as &quot;user is typing a message&quot;), and/or some non-text data.</p><p>The CommuniGate Pro Real-Time component maintains and distributes the &quot;presence&quot; information, and exchange the presence updates with external systems.</p><h2 id="Roster" tabindex="-1">Roster <a class="header-anchor" href="#Roster" aria-label="Permalink to &quot;Roster {#Roster}&quot;">​</a></h2><p>Each CommuniGate Pro Account has a Roster - a set of &quot;Buddies&quot; - <code>username@domainname</code> addresses with the associated status information.</p><p>When the Account user adds a Buddy to the Roster (using any XIMSS, XMPP, or SIP client, or the WebUser Interface), a Signal request is sent to the Buddy address. If the receiver confirms this request &quot;to become friends&quot;, then the Buddy status in the Roster status information becomes &quot;confirmed&quot;, and both sides can see the Presence status of each other.</p><p>Roster Buddies can be assigned to one or several Roster Groups, and client applications usually show Roster Buddies sorted by Groups.</p><h2 id="Presence" tabindex="-1">Presence <a class="header-anchor" href="#Presence" aria-label="Permalink to &quot;Presence {#Presence}&quot;">​</a></h2><p>Each CommuniGate Pro Account can have zero, one, or several client application connected to it using SIP, XMPP, XIMSS or other real-time protocols. Each client can specify its &quot;presence state&quot; - such as &quot;online&quot;, &quot;away&quot;, &quot;busy&quot;, etc.</p><p>The CommuniGate Pro Server &quot;aggregates&quot; all reported &quot;presence states&quot; to compose the presence state of the Account itself. For example, if at least one client application reports the &quot;busy&quot; state, the Account state is set to &quot;busy&quot;, otherwise if there is at least one client application reporting the &quot;online&quot; state, the Account state is set to &quot;online&quot;, etc. If there is no client application connected to (or registered with) the Account - the Account state is set to &quot;offline&quot;.</p><p>When presence information is distributed, the CommuniGate Pro server adds the &quot;hash&quot; of the Account avatar (read from the Account <a href="./../storage/FileStore.html">File Storage</a>), so avatar changes can be detected by other users.</p><h2 id="IM" tabindex="-1">Instant Messages <a class="header-anchor" href="#IM" aria-label="Permalink to &quot;Instant Messages {#IM}&quot;">​</a></h2><p>When an Instant Message request is delivered to a CommuniGate Pro Account, it is processed as any other Signal Request - <a href="./SignalRules.html">Signal Automated Rules</a> are applied, the request is forked to all active XIMSS and XMPP sessions, and, optionally, to registered SIP devices.</p><p>Incoming and outgoing IMs are stored in the Account <a href="./../storage/FileStore.html#IMLogs">File Storage</a>.</p><p>If an IM cannot be delivered because there is no session or device to relay it to, the message is appended to a special file in the Account <a href="./../storage/FileStore.html#IMLogs">File Storage</a>.<br> When the Account user launches an XMPP or XIMSS client application, all stored IMs from that file are delivered to the user via that client application, and the file is removed.</p><p>Incoming IMs can be rejected without processing if the IM sender is not a confirmed Buddy in the Account Roster. See the Preferences section below.</p><h2 id="Prefs" tabindex="-1">Preferences <a class="header-anchor" href="#Prefs" aria-label="Permalink to &quot;Preferences {#Prefs}&quot;">​</a></h2><p>The Account user can control Instant Message processing using the following Preferences:</p>',18),e("div",{align:"center",class:"WebUser"},[e("form",{action:"Null.html"},[e("table",{class:"contentTable",width:"90%"},[e("tbody",null,[e("tr",null,[e("td",{rowspan:"3",class:"settingsGroup",align:"RIGHT",valign:"top"},"Instant Messaging"),e("td",{class:"settingsTitle"},"Accepted Senders besides Buddies"),e("td",{class:"settingsValue"},[e("select",{name:"RosterIMMode"},[e("option",{value:"Default",selected:"selected"},"default(everybody)"),e("option",{value:"nobody"},"nobody"),e("option",{value:"samedomain"},"same domain users"),e("option",{value:"authenticated"},"authenticated"),e("option",{value:"everybody"},"everybody")])])]),e("tr",null,[e("td",{class:"settingsTitle"},"IM Offline Storage"),e("td",{class:"settingsValue"},[e("select",{name:"DelayedIM"},[e("option",{value:"-1",selected:"selected"},"default(Enabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("td",{class:"settingsTitle"},"Always Receive to All Devices"),e("td",{class:"settingsValue"},[e("select",{name:"IMGoToAll"},[e("option",{value:"-1",selected:"selected"},"default(No)"),e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes")])])])])])])],-1),s("<ul><li><p><code>Accepted Senders besides Buddies</code></p><p>This setting controls incoming IMs from addresses not included into the Account Roster. The following values are supported:</p><ul><li><p>everybody</p><p>All Instant Messages are accepted</p></li><li><p>authenticated</p><p>Instant Messages from the same CommuniGate Pro system Accounts are accepted</p></li><li><p>same domain</p><p>Instant Messages from Accounts in the same CommuniGate Pro Domain are accepted</p></li><li><p>nobody</p><p>Instant Messages are rejected</p></li></ul></li><li><p><code>IM Offline Storage</code></p><p>If this option is enabled, and there is no active XMPP or XIMSS session, nor any SIP device registered (if IM delivery to SIP devices is enabled), then the &quot;no address found&quot; error is not returned to the sender. Instead, the IM is stored in the File Storage file, and the positive response is returned to the IM sender.</p></li><li><p><code>Always Receive to All Devices</code></p><p>If this option is set to Yes, then incoming Instant Messages are always delivered to all active XMPP and XIMSS sessions and registered SIP clients with messaging capability (if delivery to SIP clients is enabled). Otherwise, messages sent within conversation are delivered to the session or the device specified by the sender.</p></li></ul>",1)]))}const g=a(i,[["render",r]]);export{m as __pageData,g as default};
