import{_ as p,C as s,c as r,o as d,ag as a,j as e,a as t,G as i,w as l}from"./chunks/framework.jCcxW76o.js";const S=JSON.parse('{"title":"Media Server","description":"","frontmatter":{"legacyLink":"MediaServer.html"},"headers":[],"relativePath":"admin/signals/MediaServer.md","filePath":"admin/signals/MediaServer.md"}'),u={name:"admin/signals/MediaServer.md"},c={action:"Null.html"},v={class:"settingsBox"},h={width:"100%"};function m(g,o,y,f,T,M){const n=s("tt");return d(),r("div",null,[o[18]||(o[18]=a('<h1 id="media-server" tabindex="-1">Media Server <a class="header-anchor" href="#media-server" aria-label="Permalink to &quot;Media Server&quot;">​</a></h1><p>The CommuniGate Pro Media Server component can <em>terminate media</em> for calls - it can play and record audio/video (media) information.</p><p>To play media data, the Media Server encodes it using a selected <em>codec</em> and sends it to the remote party via the RTP protocol. The Media Server also supports the encrypted SRTP protocol for media exchanges.</p><p>To record media data, the Media Server decodes received RTP data, rearranges it to restore the original data frame sequence and converts the resulting data into a standard format.</p><p>To participate in a call, the Media Server creates a Media Channel. Each Media Channel uses two UDP ports and sockets for audio data (the AVP/RTP protocol), and, optionally, two UDP ports and sockets for video data.</p><p>A Media Channel is created and controlled with <a href="./../../development/PBXApp.html">PBX Tasks</a>.</p><p>A Task can connect its Media Channel to several remote parties, creating a <em>conference</em>.</p><h2 id="Config" tabindex="-1">Media Server Settings <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Media Server Settings {#Config}&quot;">​</a></h2><p>To configure the Media Server component, open the Real-Time pages in the WebAdmin Settings realm, and follow the Media link.</p>',9)),o[19]||(o[19]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Processing")])]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"Log Level:"),e("td",null,[e("select",{name:"TempFilesLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1",selected:"selected"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right"},"UDP TOS Tag:"),e("td",null,[e("select",{name:"UDPTOSByte"},[e("option",{value:"-1",selected:"selected"},"OS default"),e("option",{value:"0"},"0"),e("option",{value:"2"},"2"),e("option",{value:"4"},"4"),e("option",{value:"8"},"8"),e("option",{value:"16"},"16"),e("option",{value:"32"},"32"),e("option",{value:"64"},"64"),e("option",{value:"128"},"128"),e("option",{value:"127"},"other")])])]),e("tr",null,[e("td",{align:"right"},"Pre-playing:"),e("td",null,[e("select",{name:"X1"},[e("option",null,"20"),e("option",null,"40"),e("option",{selected:"selected"},"60"),e("option",null,"80"),e("option",null,"100"),e("option",null,"140"),e("option",null,"180"),e("option",null,"220"),e("option",null,"300"),e("option",null,"other")]),t(" msec")]),e("td",{align:"right"},"Lingered Playing:"),e("td",null,[e("select",{name:"X1"},[e("option",null,"20"),e("option",null,"40"),e("option",null,"60"),e("option",null,"80"),e("option",{selected:"selected"},"100"),e("option",null,"140"),e("option",null,"180"),e("option",null,"220"),e("option",null,"300"),e("option",null,"other")]),t(" msec")])]),e("tr",null,[e("td",{align:"right"},"Packet Size:"),e("td",null,[e("select",{class:"popup",name:"PacketMsec"},[e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20",selected:"selected"},"20"),e("option",{value:"30"},"30"),e("option",{value:"40"},"40"),e("option",{value:"50"},"50"),e("option",{value:"21"},"other")]),t("msec")]),e("td",{align:"right"},"Mixer Delay:"),e("td",null,[e("select",{name:"X1"},[e("option",null,"20"),e("option",null,"40"),e("option",null,"60"),e("option",null,"80"),e("option",{selected:"selected"},"100"),e("option",null,"140"),e("option",null,"180"),e("option",null,"220"),e("option",null,"300"),e("option",null,"other")]),t(" msec")])]),e("tr",null,[e("td",{align:"RIGHT"},"Internal Sampling Rate:"),e("td",null,[e("select",{class:"popup",name:"InternalRate"},[e("option",{value:"8000",selected:"selected"},"8000"),e("option",{value:"16000"},"16000"),e("option",{value:"24000"},"24000"),e("option",{value:"16001"},"other")]),t("Hz")]),e("td",{colspan:"2"}," ")])])])])],-1)),o[20]||(o[20]=a('<ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Media Server component should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code>, or <code>Problems</code> levels. When you experience problems with the Media Server component, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case the media processing internals will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The Media Server component records in the System Log are marked with the <code>MEDIA</code> tag.</p></li><li><p><code>UDP TOS Tag</code></p><p>Use this setting to specify the TOS tag for all outgoing UDP packets sent with Media Channels. This tag can be used to set the Media traffic priority on your LAN.</p></li><li><p><code>Pre-playing</code></p><p>When a Media Channel plays a pre-recorded or pre-composed media data, it can initially send some data portions (packets) &quot;in advance&quot;. If later network delays cause some packets to arrive to the remote party with a delay, the &quot;pre-played&quot; media data allow that other party to play data smoothly.<br> Use this setting to specify the amount of media data to be &quot;pre-played&quot;.</p></li><li><p><code>Lingered Playing</code></p><p><a href="./../../development/PBXApp.html">PBX Applications</a> often play several media files in a sequence, composing a phrase with several part files. To ensure smooth media parts &quot;merging&quot;, a Media Channel reports playing completion when it still has some media data to play. This allows the application to prepare the next media data portion and submit it to the Media Channel for playing.<br> The Media Channel starts playing this next portion as soon as it actually finishes playing the previous one.<br> Use this setting to specify when Media Channels should report playing completion.</p></li><li><p><code>Packet Size</code></p><p>Use this setting to specify the size (time length) of each RTP packet the Media Server generates.</p></li><li><p><code>Mixer Delay</code></p><p>Use this setting to specify the initial amount of delay the Media Channel uses in the &quot;mixer&quot; mode. Increasing this value increases the mixer quality for lines with large or variable latency, but it also increases the &quot;playback delay&quot;.</p></li><li><p><code>Internal Sampling Rate</code></p><p>Specifies the sampling rate for internal audio processing. Increase this value if you use wide-band codecs.</p></li></ul><p>When the remote peer SDP does not announce the special <code>telephone-event</code> codec, the Media Server tries to detect the DTMF signals in the received and decoded audio data. The following settings allow you to fine-tune this process.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Inband DTMF Discovery</b></td></tr><tr><td align="RIGHT">Threshold Level:</td><td><select class="popup" name="InbandDTMFLevel"><option value="40">40</option><option value="50">50</option><option value="60" selected="selected">60</option><option value="70">70</option><option value="80">80</option><option value="90">90</option><option value="100">100</option><option value="120">120</option><option value="150">150</option><option value="170">170</option><option value="200">200</option><option value="300">300</option><option value="400">400</option><option value="500">500</option><option value="700">700</option><option value="800">800</option><option value="900">900</option><option value="1000">1000</option><option value="1200">1200</option><option value="1500">1500</option><option value="2000">2000</option><option value="61">other</option></select></td><td align="RIGHT">Minimal Duration:</td><td><select class="popup" name="InbandDTMFDuration"><option value="0">0</option><option value="10">10</option><option value="20">20</option><option value="30">30</option><option value="40">40</option><option value="50">50</option><option value="60">60</option><option value="70">70</option><option value="80">80</option><option value="90">90</option><option value="100">100</option><option value="120" selected="selected">120</option><option value="140">140</option><option value="160">160</option><option value="180">180</option><option value="200">200</option><option value="300">300</option><option value="350">350</option><option value="121">other</option></select>msec</td></tr><tr><td align="RIGHT">Signal/Noise Ratio:</td><td><select class="popup" name="InbandDTMFNoise"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6" selected="selected">6</option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="12">12</option><option value="15">15</option><option value="18">18</option><option value="20">20</option><option value="30">30</option><option value="11">other</option></select></td><td align="RIGHT">Harmonics Ratio:</td><td><select class="popup" name="InbandDTMFHarmonics"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10" selected="selected">10</option><option value="12">12</option><option value="15">15</option><option value="18">18</option><option value="20">20</option><option value="30">30</option><option value="11">other</option></select></td></tr><tr><td align="RIGHT">Signal Ratio:</td><td><select class="popup" name="InbandDTMFSignal"><option value="5">5</option><option value="10">10</option><option value="12">12</option><option value="15" selected="selected">15</option><option value="18">18</option><option value="20">20</option><option value="22">22</option><option value="25">25</option><option value="27">27</option><option value="30">30</option><option value="35">35</option><option value="50">50</option><option value="16">other</option></select></td><td colspan="2"> </td></tr></tbody></table></div></form><ul><li><p><code>Threshold Level</code></p><p>Decreasing this setting value allows the Media Channel to detect lesser quality (lower volume) in-band DTMF, but it may also result in &quot;false-positives&quot;, when some incoming sounds are incorrectly interpreted as DTMF signals.</p></li><li><p><code>Signal/Noise Ratio</code>, <code>Harmonics Ratio</code>, <code>Signal Ratio</code></p><p>Decreasing these setting values allows the Media Channel to detect lesser quality (less clean) in-band DTMF, but it may also result in &quot;false-positives&quot;, when some incoming sounds are incorrectly interpreted as DTMF signals.</p></li><li><p><code>Minimal Duration</code></p><p>To be detected as a DTMF signal, an DTMF audio sound should last longer than the specified value. Decreasing this setting value can result in &quot;false-positives&quot;, when some incoming sounds are incorrectly interpreted as DTMF signals.</p></li></ul><h2 id="Codecs" tabindex="-1">Codecs <a class="header-anchor" href="#Codecs" aria-label="Permalink to &quot;Codecs {#Codecs}&quot;">​</a></h2><p>The Media Server supports a set of audio codecs. The following panel allows you to control how these codecs are used:</p>',6)),e("form",c,[e("div",v,[e("table",h,[e("tbody",null,[o[16]||(o[16]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Codecs")])],-1)),o[17]||(o[17]=e("tr",null,[e("td",null,"Name"),e("td",null,"Priority")],-1)),e("tr",null,[e("td",null,[o[1]||(o[1]=e("input",{type:"hidden",name:"codecs",value:"0"},null,-1)),o[2]||(o[2]=e("input",{type:"hidden",name:"n0",value:"G729"},null,-1)),i(n,null,{default:l(()=>o[0]||(o[0]=[t("G729")])),_:1})]),o[3]||(o[3]=e("td",{nowrap:"nowrap"},[e("select",{name:"p0"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"4"),e("option",{selected:"selected"},"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9"),e("option",null,"Highest")]),t(),e("select",{name:"r0"},[e("option",{value:"1"},"1"),e("option",null,"2"),e("option",{selected:"selected"},"3"),e("option",null,"4"),e("option",null,"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9")])],-1))]),e("tr",null,[e("td",null,[o[5]||(o[5]=e("input",{type:"hidden",name:"codecs",value:"0"},null,-1)),o[6]||(o[6]=e("input",{type:"hidden",name:"n0",value:"G722"},null,-1)),i(n,null,{default:l(()=>o[4]||(o[4]=[t("G722")])),_:1})]),o[7]||(o[7]=e("td",{nowrap:"nowrap"},[e("select",{name:"p0"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"4"),e("option",{selected:"selected"},"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9"),e("option",null,"Highest")]),t(),e("select",{name:"r0"},[e("option",{value:"1"},"1"),e("option",null,"2"),e("option",{selected:"selected"},"3"),e("option",null,"4"),e("option",null,"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9")])],-1))]),e("tr",null,[e("td",null,[o[9]||(o[9]=e("input",{type:"hidden",name:"codecs",value:"0"},null,-1)),o[10]||(o[10]=e("input",{type:"hidden",name:"n0",value:"PCMA"},null,-1)),i(n,null,{default:l(()=>o[8]||(o[8]=[t("PCMU")])),_:1})]),o[11]||(o[11]=e("td",{nowrap:"nowrap"},[e("select",{name:"p0"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"4"),e("option",{selected:"selected"},"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9"),e("option",null,"Highest")]),t(),e("select",{name:"r0"},[e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"4"),e("option",{selected:"selected"},"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9")])],-1))]),e("tr",null,[e("td",null,[o[13]||(o[13]=e("input",{type:"hidden",name:"codecs",value:"1"},null,-1)),o[14]||(o[14]=e("input",{type:"hidden",name:"n1",value:"PCMA"},null,-1)),i(n,null,{default:l(()=>o[12]||(o[12]=[t("PCMA")])),_:1})]),o[15]||(o[15]=e("td",{nowrap:"nowrap"},[e("select",{name:"p0"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",null,"4"),e("option",{selected:"selected"},"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9"),e("option",null,"Highest")]),t(),e("select",{name:"r0"},[e("option",{value:"1"},"1"),e("option",null,"2"),e("option",null,"3"),e("option",{selected:"selected"},"4"),e("option",null,"5"),e("option",null,"6"),e("option",null,"7"),e("option",null,"8"),e("option",null,"9")])],-1))])])])])]),o[21]||(o[21]=a('<p>There are two Priority settings for each codec - the primary and the secondary one.</p><p>When a Media Server composes an <em>initial offer</em>, the codecs are listed sorted by their primary and secondary priority values.<br> Codecs with the primary Priority set to Inactive or to 1 are not listed in the initial offer.</p><p>When a Media Server composes an <em>answer</em> or a non-initial <em>offer</em>, i.e. when the audio codecs supported by the peer are known, only the codecs supported by the peer are listed.<br> Codecs with the primary Priority set to Inactive are not listed in answers and non-initial offers.<br> The Media Server codecs are listed sorted by their primary Priority values. If several Media Server codecs have the same primary Priority values, they are listed in the same order as they were listed in the peer&#39;s offer.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The set of supported codecs depends on the platform CommuniGate Pro is running on.</p></div><p>Compressing codecs (such as G.729) require a lot of CPU resources. You may want to offload coding-encoding operations to separate Transcoder servers:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>External Media Servers</b></td></tr><tr><td align="RIGHT">Usage:</td><td><select name="ExternalUsage"><option value="no" selected="selected">Disabled</option><option value="transcoder">Transcoder</option><option value="media">Remote</option></select></td></tr><tr><td> </td><td><textarea name="ExternalServers" cols="50" rows="3">10.0.1.24-10.0.1.29 ; transcoder farm</textarea></td></tr></tbody></table></div></form><p>If the Usage setting is set to <code>Transcoder</code>, the Media Server tries to create a <em>transcoder channel</em> on one of the listed Transcoder servers. The peer is instructed to exchange media with the created <em>transcoder channel</em>, while the <em>transcoder channel</em> exchanges media with the CommuniGate Pro Media Server using the PCM (G.711) codec.</p><p>Transcoder servers are used in a round-robin manner. If a Transcoder refuses to create a <em>transcoder channel</em>, and there are more than 2 servers specified, the next server is contacted.</p><p>The CommuniGate Pro Server software or special CommuniGate Pro Transcoder software can be used to implement Transcoder servers.</p><h2 id="Features" tabindex="-1">Features <a class="header-anchor" href="#Features" aria-label="Permalink to &quot;Features {#Features}&quot;">​</a></h2><p>The Media Server supports clients connecting from remote NATed networks, using the same algorithms as those employed with the <a href="./NAT.html#Proxy">Media Proxy</a> component. When a call media is terminated with the CommuniGate Pro Media Server, there is no need to build a Media Proxy to handle media transfer over a remote NAT.</p><p>The Media Server supports DTMF &quot;codecs&quot;: if the peer announces support for such a codec, the Media Server detects audio packets sent using that codec and interprets the packet content as DTMF symbols. The Media Server can also send DTMF symbols using special DTMF &quot;codecs&quot;.<br> If the peer does not announce support for a DTMF &quot;codec&quot;, the Media Server detects DTMF symbols sent &quot;in-band&quot;, analyzing the audio data received.</p>',12))])}const w=p(u,[["render",m]]);export{S as __pageData,w as default};
