import{_ as i,a,b as s,c as n,d as r}from"./chunks/SIPEdgeCollapse.DhdnLjEk.js";import{_ as d,c as l,o as c,ag as o,j as e}from"./chunks/framework.jCcxW76o.js";const A=JSON.parse('{"title":"NAT Traversal","description":"","frontmatter":{"legacyLink":"NAT.html"},"headers":[],"relativePath":"admin/signals/NAT.md","filePath":"admin/signals/NAT.md"}'),p={name:"admin/signals/NAT.md"};function h(u,t,m,v,P,f){return c(),l("div",null,t[0]||(t[0]=[o('<h1 id="nat-traversal" tabindex="-1">NAT Traversal <a class="header-anchor" href="#nat-traversal" aria-label="Permalink to &quot;NAT Traversal&quot;">​</a></h1><p>The &quot;original, &quot;basic&quot; VoIP communication model assumes that endpoints can communicate directly, i.e. that all &quot;entities&quot;, both clients (phones, softphones, PBX applications) and servers have &quot;real&quot; Internet IP Addresses. In this situation the entities can exchange media data directly, sending media packets (usually using the RTP or T.120 protocols) directly to each other.</p><p>The real-life situation is quite different from this model, and media data cannot be sent directly between endpoints. The CommuniGate Pro Server solves this problem by automatically creating Media Proxies and instructing endpoints to send media data to that Media Proxy for relaying.</p><p>A Media Proxy is created when:</p><ul><li>one endpoint is connected to the <a href="./../network/">LAN</a>, while the other one is located somewhere within the <a href="./../network/">WAN</a>.</li><li>one endpoint is located behind a remote <a href="./../network/">NAT</a>, while the other one is not located behind the same NAT (see the option below).</li><li>one endpoint is located within an IPv4 network, while the other one is located in the IPv6 network.</li><li>the Signal component explicitly requested creation of a Media Proxy.</li></ul><p>Media Proxies are created with the SIP and XIMSS components when a call is being sent to a remote entity.</p><h2 id="MediaProxy" tabindex="-1">NAT Traversal and Media Stream Proxy <a class="header-anchor" href="#MediaProxy" aria-label="Permalink to &quot;NAT Traversal and Media Stream Proxy {#MediaProxy}&quot;">​</a></h2><p>The &quot;basic&quot; communication model assumes that endpoints can communicate directly, i.e. that all &quot;entities&quot;, both clients (phones, softphones, PBX applications) and servers have &quot;real&quot; Internet IP Addresses. In this situation the Server is needed only to establish a call. Media data and (in case of SIP) in-call signaling requests are sent directly between the endpoints:</p><p><img src="'+i+'" alt="Basic SIP Call"></p><p>In the real life, many clients are located in remote LANs (&quot;behind a NAT&quot;), or in different LANs so they cannot communicate directly. CommuniGate Pro supports automatic &quot;NAT traversal&quot; for the standard-based Real-Time communications.</p><h2 id="NearEnd" tabindex="-1">Near-End NAT Traversal <a class="header-anchor" href="#NearEnd" aria-label="Permalink to &quot;Near-End NAT Traversal {#NearEnd}&quot;">​</a></h2><p>The CommuniGate Pro SIP and XIMSS Modules detect the session initiation requests that are sent from one side of NAT to the other side (a request from a LAN client to a party on the Internet/WAN and vice versa). In this case, the Server uses some local server port (or a set of ports depending on the media protocol(s) used) to build a media stream proxy. The Server then modifies the session initiation request to direct the traffic from both sides to that proxy.</p><p>The Media Proxy relays media data between the &quot;LAN leg&quot; and the &quot;WAN leg&quot; of the media connection:</p><p><img src="'+a+'" alt="Near End NAT SIP Traversal"></p><p>The CommuniGate Pro SIP and XIMSS Modules detect session update (SIP re-INVITE) and session close (SIP BYE) requests and update and remove the Media Proxies accordingly. The time-out mechanism is used to remove &quot;abandoned&quot; Media Proxies.</p><p>The CommuniGate Pro provides NAT proxy services for:</p><ul><li>UDP media protocols</li><li>RTP media protocols based on UDP</li><li>TCP media protocols</li><li>T.120 media protocols based on TCP</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If you need the Media Proxy functionality, make sure that the LAN and NAT data is specified correctly on the <a href="./../network/">LAN IPs</a> and <a href="#Config">NAT</a> WebAdmin settings pages.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Server automatically builds Media Proxies when it relays requests from IPv4 addresses to IPv6 addresses and vice versa.</p></div><h2 id="FarEnd" tabindex="-1">Far-End NAT Traversal <a class="header-anchor" href="#FarEnd" aria-label="Permalink to &quot;Far-End NAT Traversal {#FarEnd}&quot;">​</a></h2><p>The CommuniGate Pro SIP and XIMSS Modules also provide the &quot;far-end&quot; NAT traversal capabilities by detecting requests coming from clients located behind remote Firewall/NATs.<br> The Modules add appropriate Record-Route and Path headers to these requests and they build Media Proxies to relay traffic to and from those clients.</p><p><img src="'+s+'" alt="Far End NAT SIP Traversal"></p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Modern SIP clients support various NAT traversal methods (STUN, etc.). Many of these implementations are quite buggy, so it is often more reliable to switch the client-side NAT traversal methods off, and rely on the CommuniGate Pro SIP Module far-end NAT traversal capabilities instead.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Due to the nature of the TCP protocol and the Firewall concept, it is not possible (in general) to open a TCP connection to a client behind a far-end NAT (&quot;near-end&quot; NAT configurations do not have this problem). This means that clients behind a far-end NAT cannot initiate TCP (T.120) sessions.</p></div><p>To solve this problem, you may want to:</p><ul><li>always initiate TCP sessions from a client that is not behind a far-end NAT/Firewall (these clients accept those invitations and start outgoing TCP connections without a problem)<br> or</li><li>use an additional copy of the CommuniGate Pro Server on that remote location as a near-end NAT traversal solution for that network, eliminating a need for far-end NAT traversal on the &quot;main&quot; CommuniGate Pro server<br> or</li><li>configure the remote Firewall/NAT to relay all incoming TCP request to the T.120 port (usually, the port 1503) to a particular workstation behind that Firewall.</li></ul><h2 id="Edge" tabindex="-1">Edge Services <a class="header-anchor" href="#Edge" aria-label="Permalink to &quot;Edge Services {#Edge}&quot;">​</a></h2><p>The CommuniGate Pro SIP Module can be used as an &quot;Edge Service&quot; or ALG (&quot;Application Level Gateway&quot;), providing NAT traversal functionality for users registered on other servers.</p><p><img src="'+n+'" alt="SIP Edge Services"></p><p>The CommuniGate Pro SIP Module detects &quot;media loops&quot;, when a call placed from within LAN is proxied to WAN, and then proxied back to the same LAN. In this case the Media Proxies are removed, eliminating unnecessary overhead, and allowing SIP clients to communicate directly within one LAN, while proving registrar services outside that LAN.</p><p><img src="'+r+`" alt="Collapsing Media Proxy"></p><p>The SIP module can detect much more complex loop cases, either avoiding Media Proxies altogether, or minimizing the number of Media Proxies used.</p><h2 id="Config" tabindex="-1">NATed Addresses <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;NATed Addresses {#Config}&quot;">​</a></h2><p>To detect clients located behind NATs, the Server needs to know which addresses are used on remote networks behind those NATs.<br> Use the WebAdmin Interface to specify the NATed Addresses. Open the Network pages in the Settings realm, then open the NATed IPs page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>NATed IP Addresses</b></td></tr><tr><td align="center"><textarea name="LANHosts" rows="10" cols="60">10.0.0.0-10.255.255.255
172.16.0.0-172.31.255.255
192.168.0.0-192.168.255.255
169.254.0.0/16
</textarea></td></tr></tbody></table></div></form><p>If a SIP client sends a request to CommuniGate Pro and the client own network address specified in the request headers is included into the NATed IP Addresses list, while the Server has received this request from a different network address, NOT included into the NATed IP Addresses list, the Server decides that this client is behind a NAT.</p><h2 id="NATSites" tabindex="-1">NAT Systems <a class="header-anchor" href="#NATSites" aria-label="Permalink to &quot;NAT Systems {#NATSites}&quot;">​</a></h2><p>Some NAT servers make attempts to perform &quot;SIP application gateway&quot; functions, changing the IP addresses specified in the relayed SIP requests.<br> Many of those NAT servers fail to perform these gateway functions correctly, and CommuniGate Pro should treat clients connecting via those NAT servers using its &quot;far-end NAT traversal&quot; functionality, but CommuniGate Pro cannot detect that this functionality is needed, because the client IP addresses specified in their SIP requests are damaged.<br> You can specify the IP addresses of those broken NAT servers in the NAT Server IP Addresses field: all requests coming from the specified Network Addresses are treated as requests from &quot;NATed&quot; clients:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>NAT Server IP Addresses</b></td></tr><tr><td align="center"><textarea name="LANHosts" rows="10" cols="60">77.177.66.166           ; company1 NAT is broken
12.23.45.67             ; company2 NAT server is broken
12.23.45.89-12.23.45.94 ; company3 NAT server is multi-homed
</textarea></td></tr></tbody></table></div></form><p>You may need to relay requests to remote SIP servers (such as PSTN gateways) located behind a far-end NAT. Since these servers do not issue SIP REGISTER requests to your CommuniGate Pro Server, there is no way to automatically detect these far-end NAT traversal situations.<br> Include the public Network IP Addresses of these remote SIP servers into the NAT Server IP Addresses field to instruct the CommuniGate Pro SIP Module to use far-end NAT traversal techniques when starting sessions with these SIP servers.</p><p>When clients connect to the CommuniGate Pro server from behind multi-homed NAT servers, the client Signal (SIP, XIMSS) connections and media (RTP) streams can come from different IP Addresses.<br> When a client uses HTTP transactions to connect to WebUser or XIMSS <a href="./../access/WebUser.html#Sessions">session</a>, the HTTP requests coming from multi-homed NAT servers can come from different IP Addresses.<br> In thess situations clients can experience lack of media transfer or rejection of session requests caused by a &quot;wrong IP Address&quot; problem.</p><p>To avoid this problem, two different IP Addresses are treated as the &quot;same address&quot; if both of them are included into the same IP Address range in the NAT Server IP Addresses list.</p><h2 id="Pinger" tabindex="-1">Pinger <a class="header-anchor" href="#Pinger" aria-label="Permalink to &quot;Pinger {#Pinger}&quot;">​</a></h2><p>To send incoming calls to a <a href="./SIP.html">SIP</a> client behind a NAT, CommuniGate Pro keeps the &quot;communication hole&quot; between the client and Server open by periodically sending dummy packets to that client.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>NATed Clients Pinger</b></td></tr><tr><td>Log Level: <select name="NATPingerLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td>Clients Limit: <select name="Ping1XX"><option>1</option><option>3</option><option>10</option><option>30</option><option>100</option><option>300</option><option>1000</option><option>3000</option><option>10000</option><option>30000</option><option>100000</option><option>other</option></select></td><td>Ping Clients every:</td><td>UDP: <select name="PingXX"><option value="3">3 seconds</option><option value="5">5 seconds</option><option value="10">10 seconds</option><option value="15">15 seconds</option><option value="30">30 seconds</option><option value="60" selected="selected">minute</option><option value="120">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800">30 minutes</option><option value="3600">hour</option></select></td></tr><tr><td colspan="3"> </td><td>TCP: <select name="PingXX"><option value="3">3 seconds</option><option value="5">5 seconds</option><option value="10">10 seconds</option><option value="15">15 seconds</option><option value="30">30 seconds</option><option value="60">minute</option><option value="120" selected="selected">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800">30 minutes</option><option value="3600">hour</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log Level</code></p><p>Use this setting to specify what kind of information the NAT Pinger component should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels.<br> The NAT Pinger component records in the System Log are marked with the <code>NATPING</code> tag.</p></li><li><p><code>Clients Limit</code></p><p>Use this setting to specify how many different NAT clients the Server can ping.</p></li><li><p><code>Ping Clients Every</code></p><p>Use this setting to specify how often the Server should send its &quot;pinging&quot; packets to its clients using UDP and TCP protocols.</p></li></ul><h2 id="Proxy" tabindex="-1">Media Proxy <a class="header-anchor" href="#Proxy" aria-label="Permalink to &quot;Media Proxy {#Proxy}&quot;">​</a></h2><p>CommuniGate Pro supports various real-time communications. Most of those real-time protocols cannot be used via a NAT/Firewall, so CommuniGate Pro can act as &quot;proxy&quot; for those protocols.</p><p>When a client on the LAN tries to communicate with a remote system on the Internet (WAN), CommuniGate Pro creates a Media Proxy - a communication port on its own system.<br> It forces the client to connect to that Media Proxy instead of the remote system media port.<br> The CommuniGate Pro Media Proxy communicates with the remote system itself, relaying the data received from the LAN client to the remote system and vice versa.</p><p>A Media Proxy is created to serve entries (users) located behind <a href="#Config">remote NAT</a> devices.</p><p>A Media Proxy is created to relay traffic between an IPv4 and IPv6 entries.</p>`,51),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Media Proxy")])]),e("tr",null,[e("td",{align:"right"},"Log Level:"),e("td",{nowrap:"nowrap"},[e("select",{name:"ProxyLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",{align:"right"},"UDP TOS Tag:"),e("td",null,[e("select",{name:"UDPTOSByte"},[e("option",{value:"-1",selected:"selected"},"OS default"),e("option",{value:"0"},"0"),e("option",{value:"2"},"2"),e("option",{value:"4"},"4"),e("option",{value:"8"},"8"),e("option",{value:"16"},"16"),e("option",{value:"32"},"32"),e("option",{value:"64"},"64"),e("option",{value:"128"},"128"),e("option",{value:"127"},"other")])])]),e("tr",null,[e("td",{align:"right"},"Source Port Restriction:"),e("td",{nowrap:"nowrap"},[e("select",{name:"UDPPortRestricted"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1",selected:"selected"},"Enabled")])]),e("td",{align:"right"},"Relay for clients behind the same NAT:"),e("td",null,[e("select",{name:"NATSameMediaRelay"},[e("option",{value:"never"},"Never"),e("option",{value:"listed"},"NAT Sites"),e("option",{value:"always",selected:"selected"},"Always")])])])])])])],-1),o('<ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the Media Proxy component should put in the Server Log. Usually you should use the <code>Major</code> or <code>Problems</code> (non-fatal errors) levels. But when you experience problems with the Proxy component, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well.<br> The Media Proxy component records in the System Log are marked with the <code>MEDIAPROXY</code> tag.<br> A Media Proxy can create zero, one or several stream proxies for each media stream (for example, one stream proxy for the audio stream, and one - for the video stream). Stream proxy records in the System Log are marked with <code>UDPPROXY</code> or the <code>TCPPROXY</code> tag.</p></li><li><p><code>Source Port Restriction</code></p><p>When this option is selected, the UDP-based media from external non-NATed sources is accepted only when it comes from the correct IP address and port number.<br> When this option is not selected, only the media source IP address is checked. This helps to serve certain broken devices that send SDP data with incorrectly specifed media port numbers.</p></li><li><p><code>UDP TOS Tag</code></p><p>Unless this option is set to <code>OS default</code>, the UDP-based media packets get the specified TOS (type of service) tag value. This may help you prioritize the media traffic if your network infrastructure assigned a higher priority to packets with the specified TOS tag.</p></li><li><p><code>Relay for clients behind the same NAT</code></p><p>When two endpoints are located behind the same far-end NAT (i.e. when their visible, external Network IP Addresses are the same), this option specifies if a Media Proxy should be built to relay media between these endpoints.</p><ul><li><p><code>Never</code></p><p>Media Proxy is not built for these endpoints. Use this option when you expect that endpoints behind the same NAT IP can communicate directly.</p></li><li><p><code>NAT Sites</code></p><p>Media Proxy is built for these endpoints if their visible Network IP Address is included into the <a href="#NATSites">NAT Server IP Addresses</a> list.</p></li><li><p><code>Always</code></p><p>Media Proxy is always built for these endpoints.</p></li></ul></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some remote NAT systems are &quot;multihomed&quot;. In this case, a signaling request can come from one external IP Address of that system, while the media stream may come from a different IP Address.</p><p>CommuniGate Pro Media Proxies can support these NAT systems if all their external IP Addresses are included into a single IP Address range, and if this IP Address range is included into the <a href="#NATSites">NAT Systems</a> list.</p></div>',2)]))}const b=d(p,[["render",h]]);export{A as __pageData,b as default};
