import{_ as o,c as i,o as n,ag as s,j as e,a}from"./chunks/framework.jCcxW76o.js";const g=JSON.parse('{"title":"PSTN","description":"","frontmatter":{"legacyLink":"PSTN.html"},"headers":[],"relativePath":"admin/signals/PSTN.md","filePath":"admin/signals/PSTN.md"}'),l={name:"admin/signals/PSTN.md"};function r(c,t,d,p,h,u){return n(),i("div",null,t[0]||(t[0]=[s(`<h1 id="pstn" tabindex="-1">PSTN <a class="header-anchor" href="#pstn" aria-label="Permalink to &quot;PSTN&quot;">​</a></h1><p>The CommuniGate Pro Server can use various <em>PSTN Gateways</em> to connect the modern VoIP network to the traditional Public Switched Telephone Network (PSTN). While most Gateways are implemented as standards-based SIP devices, they can experience problems when end-users connect to these Gateways directly. The most common problems include:</p><ul><li>PSTN addressing scheme is different from VoIP: traditional numeric (E.164) addresses are used instead of E-mail type account@domain VoIP addresses.</li><li>PSTN is not a free network, and Gateway may require certain authentication data to establish and maintain a call. This information is used for billing.</li><li>PSTN is not a free network, and its call transfer logic is different because of that. As a result, most Gateways do not support call transfer operations.</li><li>some PSTN gateways are designed to support individual devices (such as SIP phones) and require period REGISTER operations to direct incoming calls to those devices.</li></ul><p>To solve these problems, CommuniGate Pro provides a set of &quot;stock&quot; <a href="./../../development/PBXApp.html">Real-Time Applications</a>.</p><p>This section explains how these stock applications work, and how they can be configured.<br> While these applications are flexible enough to serve various configurations, Server and Domain Administrators can upload their own, customized versions of these applications.</p><h2 id="Incoming" tabindex="-1">Incoming Calls <a class="header-anchor" href="#Incoming" aria-label="Permalink to &quot;Incoming Calls {#Incoming}&quot;">​</a></h2><p>PSTN Gateways can direct incoming PSTN calls to a SIP entity, such as a CommuniGate Pro Server. These incoming Gateways usually are unable to transfer calls, to switch media streams, etc.</p><p>To overcome PSTN Gateway limitations, incoming calls from those gateways are usually directed to a CommuniGate Pro <a href="./PBX.html">Real-Time</a> applications acting as a B2BUA.<br> There is a stock <code>gatewayincoming</code> application designed to be used for this purpose.</p><p>The stock <code>gatewayincoming</code> application expects the destination address to be delivered to it as an application parameter. If the Gateway sends incoming requests to your system using addresses in a special domain <code>incoming.company.dom</code>, then the following Router record will direct them to the <code>gatewayincoming</code> application:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@incoming.company.dom&gt; = gatewayincoming{*}#pbx@localhost</span></span></code></pre></div><p>If you know that the Gateway addresses all your local Accounts as &quot;domestic&quot; numbers (numbers without the country code), you can correct his in the Router record. For example if the Gateway uses 10-digit North American numbers without the <code>1</code> country code, you can use the following Router record:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@incoming.company.dom&gt; = gatewayincoming{+1*}#pbx@localhost</span></span></code></pre></div><p>Incoming PSTN calls are often directed not to a particular user, but to a Real-Time application acting as a &quot;PBX center&quot;. This application answers incoming calls, and allows the callers to select the user to call, call the selected Account, and bridges the call. Since this application also acts as a B2BUA, PSTN Gateway calls can be routed to it directly, without first routing them to the special B2BUA application such as the <code>gatewayincoming</code> application:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@incoming.company.dom&gt; = pbx#pbx@localhost</span></span></code></pre></div><h2 id="RSIP" tabindex="-1">Remote SIP (RSIP) Registrations <a class="header-anchor" href="#RSIP" aria-label="Permalink to &quot;Remote SIP (RSIP) Registrations {#RSIP}&quot;">​</a></h2><p>Some PSTN Gateways cannot be configured to direct incoming calls to a specific address (such as a CommuniGate Pro Account). Instead, these Gateways expect SIP REGISTER requests to be sent to them periodically.<br> These SIP requests specify the Gateway target account (usually - a PSTN phone number), the credentials (such as some username and password), and the SIP address to direct incoming PSTN calls to.</p><p>Each CommuniGate Pro Account can contain zero, one, or several RSIP records. Each RSIP record specifies an account information for some remote PSTN Gateway. The CommuniGate Pro server periodically sends the SIP REGISTER requests to that gateway using the specified information, and then the PSTN Gateway receives a phone call, it directs it to this CommuniGate Pro Account.</p><p>A Server or a Domain Administrator with the <a href="./../sysadmin/#DomainPrivs">RSIP Registrations</a> Access Right can manage the Account RSIP Registration records.<br> Open the WebAdmin Account Management pages, then open the RSIP page in the Real-Time section:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr align="left"><th>Name</th><th>Register Every</th><th>Account</th><th>at Host</th><th>Authentication Name</th><th>Password</th><th>Target</th><th colspan="2" width="20%">Last</th></tr><tr><td>localVoip</td><td><select class="popup" name="f0"><option value="0">Never</option><option value="120">2 min</option><option value="180" selected="selected">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600">6 hour(s)</option><option value="28800">8 hour(s)</option><option value="86400">24 hour(s)</option><option value="1000000000">Disabled</option><option value="181">other</option></select></td><td><input type="text" name="u0" value="4992713154" size="10" maxlength="64"></td><td><input type="text" name="h0" value="sip.provider.dom" size="15" maxlength="64"></td><td><input type="text" name="a0" value="sipuser" size="10" maxlength="64"></td><td><input type="password" name="p0" value="sipsip" size="6" maxlength="64"></td><td><input type="text" name="t0" value="" size="10" maxlength="64"></td><td>5:32:00AM</td><td></td></tr><tr><td>AltVoip</td><td><select class="popup" name="f1"><option value="0">Never</option><option value="120">2 min</option><option value="180">3 min</option><option value="300" selected="selected">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600">6 hour(s)</option><option value="28800">8 hour(s)</option><option value="86400">24 hour(s)</option><option value="1000000000">Disabled</option><option value="301">other</option></select></td><td><input type="text" name="u1" value="+74992713154@domain2.dom" size="10" maxlength="64"></td><td><input type="text" name="h1" value="sip.provider.dom" size="15" maxlength="64"></td><td><input type="text" name="a1" value="user@domain3.dom" size="10" maxlength="64"></td><td><input type="password" name="p1" value="zzzz" size="6" maxlength="64"></td><td><input type="text" name="t1" value="altuser@domainx.dom" size="10" maxlength="64"></td><td>5:32:50AM</td><td>Illegal password</td></tr><tr><td><input type="text" name="n2" value="" size="10" maxlength="64"></td><td><select class="popup" name="f2"><option value="0" selected="selected">Never</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600">6 hour(s)</option><option value="28800">8 hour(s)</option><option value="86400">24 hour(s)</option><option value="1000000000">Disabled</option><option value="999999999">other</option></select></td><td><input type="text" name="u2" value="" size="10" maxlength="64"></td><td><input type="text" name="h2" value="" size="15" maxlength="64"></td><td><input type="text" name="a2" value="" size="10" maxlength="64"></td><td><input type="password" name="p2" value="" size="6" maxlength="64"></td><td></td><td></td></tr></tbody></table></div></form><p>Each RSIP record should have a unique name, used solely for its identification with the Account.</p><p>To create a new RSIP record, select some name for it and enter it into the <code>Name</code> field in the last table row. Fill other fields and press the Update button.</p><p>To modify an RSIP record, modify values in the record fields and press the Update button.</p><p>To remove an RSIP record, set its Period value to Never and press the Update button.</p><ul><li><p><code>Register Every</code></p><p>This setting specifies how often the Server should send the SIP REGISTER requests. These requests use the SIP registration expiration time which is 2 minutes longer than this time period.<br> Use the value the PSTN Gateway provider recommends.</p></li><li><p><code>Account</code></p><p>This setting specifies the Account name (the address) for the REGISTER requests. If the specified value does not contain the <code>@</code> symbol, the <code>at Host</code> value is appended to it then the REGISTER request is sent.<br> Use the value assigned to you by the PSTN Gateway provider (usually - the phone number).</p></li><li><p><code>at Host</code></p><p>This setting specifies the domain name or the IP Network Address of the PSTN Gateway. The SIP Register requests are sent to that address.<br> Use the value recommended by the PSTN Gateway provider.<br> If the REGISTER request should be sent via some SIP proxy, specify that proxy domain name or the IP Network Address after the PSTN Gateway name, separated with the <code>@</code> symbol: <em>gatewayName</em>@<em>proxyName</em></p></li><li><p><code>Authentication Name</code>, <code>Password</code></p><p>These settings specify the credentials (the user name and the password) needed to authenticate the SIP Register request sender.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Authentication name may or may not contain the <code>@</code> symbol followed by some domain name.</p></div><p>If the Authentication Name setting is left empty, the Account setting value is used.<br> Use the values assigned to you by the PSTN Gateway provider.</p></li><li><p><code>Target</code></p><p>This setting specifies the Account address the PSTN Gateway should send the incoming calls to. Usually this field is left empty, in this case the calls are directed to this Account.</p></li></ul><p>The last field contains the time when the last SIP REGISTER request completed, and, optionally, an error code received from the PSTN Gateway.</p><p>The RSIP Registration functionality is implemented using the <a href="./../objects/Chronos.html">Chronos</a> component. At the scheduled time, the component starts the <code>rsipRegister</code> <a href="./../../development/PBXApp.html">Real-Time Application</a>, which performs the REGISTER transaction.</p><p>The SIP REGISTER request <code>Contact</code> field is composed so that incoming calls from the PSTN Gateway are sent to the <code>gatewayincoming</code> application which acts as a B2BUA and bridges the call to this Account (or to the Account specified with the Target field).<br> If you want to send the incoming calls directly to this Account, bypassing the B2BUA, add the asterisk (<code>*</code>) symbol in front of the At Host setting value.</p><p>When the CommuniGate Pro Server is installed, it creates the <code>pbx</code> Account in the Main Domain. A Signal Rule is automatically created for this Account to direct all incoming calls to the <a href="./PBXCenter.html">PBX Center</a> application.<br> If you want to specify SIP Registration records for this <code>pbx</code> Account, so it will receive incoming calls from the <code>sip.provider.dom</code> PSTN Gateway, specify the At Host setting as <code>*sip.provider.dom</code>.</p><p>Account users can review their RSIP Registration records and (if the RSIP Registration setting is enabled) modify them using the WebUser Interface.</p><h2 id="Routing" tabindex="-1">Outgoing Call Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Outgoing Call Routing {#Routing}&quot;">​</a></h2><p>The CommuniGate Pro <a href="./../sysadmin/Router.html">Router</a> processes every Signal address in the system.</p><ul><li>The Router uses Default or Custom records to detect telephony (PSTN) type addresses and to convert them to the standard E.164 form (+<em>country_code area_code local_number</em>) in the fictitious <code>telnum</code> domain name. For example, when a SIP phone user dials <code>011 44 3335555</code>, the Server receives that address as <code>sip:011443335555@client1.dom</code> URI, and the Router converts this address into +44333555@telnum address.<br> Usually all numeric addresses of the certain length are processed as PSTN numbers.<br> See the <a href="./../sysadmin/Router.html#Default">Router</a> section to learn about the Router records used to detect telephony type addresses.</li><li>The Router maps PSTN numbers to local or remote VoIP addresses, if possible.<br> The Router checks if an address (number) in the fictitious <code>telnum</code> domain is assigned to some local Account. If an Account is found, the Router routes the address to that Account.<br> For addresses not assigned to any local Account, the Router can use global and local ENUM services, as well as CommuniGate Pro Forwarders.</li><li>The Router directs unmapped PSTN numbers either directly to a PSTN Gateway, or to a CommuniGate Pro Real-Time application designed to support external PSTN Gateways.</li></ul><h2 id="B2BUAOut" tabindex="-1">Outgoing Calls via B2BUA <a class="header-anchor" href="#B2BUAOut" aria-label="Permalink to &quot;Outgoing Calls via B2BUA {#B2BUAOut}&quot;">​</a></h2><p>The <a href="#Routing">Router</a> can route calls to the PSTN network via a <a href="./../../development/PBXApp.html">Real-Time Application</a>.<br> The CommuniGate Pro Server comes with a &quot;stock&quot; <code>gatewaycaller</code> application that can be used for relaying outgoing PSTN calls to one or several PSTN gateways. This section describes this application functionality.</p><p>When the <code>gatewayCaller</code> application receives an incoming call, it requires authentication. As a result, only the users with the Accounts on your CommuniGate Pro Server or Cluster can place calls via this application.</p><p>When an authenticated call request is received, the application retrieves and uses the following Account <a href="#Settings">PSTN Settings</a>:</p><ul><li><p><code>PSTNGatewayName</code> (Gateway Name)</p><p>The Gateway domain name. It is used as an address to send the call requests to.<br> If this setting value is empty, the Account is not allowed to make PSTN calls and its calls are rejected.</p></li><li><p><code>PSTNGatewayVia</code> (Gateway Address)</p><p>This setting is a non-empty string if the requests to the Gateway should not be sent directly (to the DNS-resolved addresses), but they should be sent via a different proxy. This setting should contain the domain name or the IP address of that proxy.</p></li><li><p><code>PSTNFromName</code> (Caller ID)</p><p>This setting specifies the address (usually, a PSTN number) to be used as the Caller ID (the <code>From:</code> address) in the call request sent to the Gateway. If this setting value is empty, the From: address of the original request is used.</p></li><li><p><code>PSTNGatewayAuthName</code> (Name for Gateway)<br><code>PSTNGatewayPassword</code> (Password for Gateway)</p><p>If the Gateway requires authentication, these settings specify the authentication data to use with the requests sent to the Gateway.</p></li><li><p><code>PSTNBillingPlan</code> (Billing Plan)</p><p>This setting contains the name of the billing plan to apply. The stock <code>gatewaycaller</code> application tries to read the specification for the billing plan <code>standard</code> from the PBX environment file with the name <code>billingplan-standard.objdata</code>. The file should contain a dictionary where each key is a phone number prefix and the value is either a number with the call cost per a minute, or a reason string to use to block calls to numbers with this prefix:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{</span></span>
<span class="line"><span>  1990 = blocked; // calls to +1-990-XXX-XXXX are blocked</span></span>
<span class="line"><span>  1 = #0;         // calls to North American numbers are free</span></span>
<span class="line"><span>  &quot;&quot; = #10;</span><span>       // everything else costs 10 units per minute</span></span>
<span class="line"><span>}</span></span></code></pre></div></li></ul><p>A CommuniGate Pro Account can use a default value for each of its setting (taken either from the Domain-wide or Server-wide/Cluster-wide Default Settings) or a setting value can set explicitly for that Account. As a result, all Accounts in all Domains can use the same Gateway and same Gateway credentials, but different Caller ID settings, or each Domain and/or each Account can use its own Gateway, with Domain or Account-specific credentials.</p><p>The application needs to retrieve Settings from other Accounts, so it should be started on behalf of an Account with the Domain Administrator access rights.<br> The automatically created <code>postmaster</code> or <code>pbx</code> Accounts can be used.</p><p>The application expects to get the destination number as its parameter.<br> The following Router record routes all addresses in the fictitious <code>pstn</code> domain to the <code>gatewaycaller</code> application started on behalf of the <code>pbx</code> Account in the Main Domain, and it passes the &quot;user part&quot; of the <code>pstn</code> domain address as the application parameter:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@pstn&gt; = gatewaycaller{*}#pbx</span></span></code></pre></div><p>After processing all Account Settings, the application starts a new Task and instructs that Task to send a call request to the selected Gateway using the retrieved Account settings. If the call succeeds, the original and new Tasks &quot;bridge&quot; the media streams.<br> The original Task processes Signal requests from the caller, the second Task processes the requests from the Gateway. Some of these requests are processed with the Tasks themselves, some are relayed to the peering Task for relaying to the caller or to the gateway.</p><p>The technology used to implement this type of call setup (when a call is established using two formally independent Signaling sessions) is called a Back-to-Back User Agent (B2BUA).</p><p>When a caller wants to Transfer a call, the Transfer request is sent to the original Task. This Task implements the requested call transfer itself, switching to some other VoIP device/entity. The second Task does not send any Transfer request to the Gateway, but it may send a call update (SIP re-INVITE or UPDATE) request to the gateway in order to redirect its media streams to the new call participant.</p><p>Some PSTN Gateways do not support even the simple call update requests. Specify the name of those Gateways with a leading hash (<code>#</code>) symbol. The application will remove that symbol from the name, and it will not bridge media streams. The application will use a CommuniGate Pro Media Server channel to relay media between the caller and gateway. If the caller switches its media address by sending a call Update request, or if the caller sends a call Transfer request, the Media Server channel updates its internal information, and no request is sent to the Gateway, which continues to exchange media data with the Media Server channel.</p><p>If you need to use several different gateways per user or per domain (depending on the destination), you can specify the gatewaycaller PSTN<em>xxxxxx</em> settings as dictionaries. For example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>PSTNGatewayName:{gw1=provider1.com;gw2=provder2.com;}</span></span>
<span class="line"><span>PSTNFromName:{gw1=fromName1;gw2=fromName2;}</span></span></code></pre></div><p>You can Route different PSTN numbers to different gateways by passing the second parameter to the gatewaycaller application:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;+46(5-12d)@pstn&gt; = gatewaycaller{+46*,gw1}#pbx</span></span>
<span class="line"><span>&lt;*@pstn&gt;          = gatewaycaller{*,gw2}#pbx</span></span></code></pre></div><p>All calls to unprocessed numbers in the <code>pstn</code> domain will be routed to the gatewaycaller application, and this application will get the second parameter of &quot;gw1&quot; if the callee is in Sweden (a E.164 number starting with +46), and &quot;gw2&quot; in all other cases.<br> The gatewaycaller application reads all required PSTN<em>xxxxxx</em> settings. If a settings value is a dictionary, it takes either the &quot;gw1&quot; or the &quot;gw2&quot; element from the dictionary.</p><h2 id="LocalArea" tabindex="-1">Local Area Calls <a class="header-anchor" href="#LocalArea" aria-label="Permalink to &quot;Local Area Calls {#LocalArea}&quot;">​</a></h2><p>When a user dials a &quot;short&quot; number (a number without the country code and the area code), the call is expected to be delivered to the that number with the user&#39;s own area code.</p><p>A Router record created during a CommuniGate Pro Server installation routes all calls to 7 digit number address in any local Domain to the <code>localAreaCall</code> application.</p><p>The stock <code>localAreaCall</code> application requires the caller to authenticate, and then it retrieves the following Account <a href="#Settings">PSTN Settings</a>:</p><ul><li><p><code>PSTNAreaCode</code> (Local Area Code)</p><p>This setting specifies the Account country code and the local area code.</p></li></ul><p>The applications needs to retrieve Settings from other Accounts, so it should be started on behalf of an Account with the Domain Administrator access rights.<br> The automatically created <code>postmaster</code> or <code>pbx</code> Accounts can be used.</p><p>The application expects to get the dialed destination number as its parameter.<br> The following Router record routes all 7-digit addresses in all local Domains to the <code>localAreaCall</code> application started on behalf of the <code>pbx</code> Account in the Main Domain, and it passes that address (a 7-digit number) as the application parameter:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;(7d)@*&gt; = localAreaCall{*}#pbx@localhost</span></span></code></pre></div><p>The application retrieves the callers country code and the local area code from the caller&#39;s PSTNAreaCode Account Settings, removes all non-digit symbols from the Setting value, catenates the &quot;cleaned&quot; with the dialed number and the <code>@telnum</code> domain name, and Redirects the call request to the resulting address.</p><p>The <a href="./../cluster/Signals.html">Signal</a> module processes the redirected request using the Router, so it can be directed to a PSTN Gateway or (after successful mapping) directly to some VoIP address.</p><h2 id="Domestic" tabindex="-1">Domestic Calls <a class="header-anchor" href="#Domestic" aria-label="Permalink to &quot;Domestic Calls {#Domestic}&quot;">​</a></h2><p>Many countries traditionally use separate calling prefixes for out-of-area domestic and international calls. Many countries use <code>0areacode localnumber</code> numbers for domestic calls, while <code>00countrycode areacode localnumber_</code> numbers are used for international calls.</p><p>If all CommuniGate Pro users are located in the same country, domestic calls can be properly routed with a single Router Record. For example, if all CommuniGate Pro users are located in Germany (country code <code>49</code>, <code>0</code> is the out-of-area prefix), the following Router record can be used (note the order of these records):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;0(7-20d)@*&gt; = +49*@telnum</span></span>
<span class="line"><span>&lt;00(8-20d)@*&gt; = +*@telnum</span></span></code></pre></div><p>You can also use the <code>localAreaCall</code> application to properly route Domestic calls. Route all calls with the domestic prefix to the <code>localAreaCall</code> application, but specify the second parameter - a string <code>c</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;0(8-20d)@*&gt; = localAreaCall{*,c}#pbx@localhost</span></span></code></pre></div><p>The <code>localAreaCall</code> application does the same processing as it does for the <a href="#LocalArea">Local Area</a> calls. But instead of using the entire PSTNAreaCode Setting value, it uses only:</p><ul><li>the country code if the setting value is specified as <code>countrycode-areacode</code> or as <code>countrycode(areacode)</code> or</li><li>the first digit if this digit is <code>1</code> (North America) or <code>7</code> (Russia) or</li><li>the first 2 digits</li></ul><h2 id="Emergency" tabindex="-1">Emergency Calls <a class="header-anchor" href="#Emergency" aria-label="Permalink to &quot;Emergency Calls {#Emergency}&quot;">​</a></h2><p>Call to Emergency Response Centers are done by dialing a well-known number, such as <code>911</code> in North America or <code>112</code> in Western Europe.</p><p>Use the Router to redirect calls to these numbers (in any Domain) to the <code>emergency</code> application:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;911@*&gt; = emergency#pbx@localhost</span></span></code></pre></div><p>The stock <code>emergency</code> application requires the caller to authenticate, and then it retrieves the following Account <a href="#Settings">PSTN Settings</a>:</p><ul><li><p><code>PSTNEmergency</code> (Emergency Code)</p><p>This setting specifies the way to contact the Emergency Response Center for this Account user.</p></li></ul><p>The applications needs to retrieve Settings from other Accounts, so it should be started on behalf of an Account with the Domain Administrator access rights.<br> The automatically created <code>postmaster</code> or <code>pbx</code> Accounts can be used.</p><p>The application processes the retrieved PSTNEmergency setting value:</p><ul><li><p>If the retrieved string has the <code>call=</code> prefix, then the remaining part of the string is used as the address to redirect the call to.</p></li><li><p>If the retrieved string has the <code>http=</code> prefix, then application reads the <code>emergency.settings</code> from the Real-Time Environment. This file should contain a <a href="./../../development/Data.html">dictionary</a>.</p><p>The application makes an HTTP request using the <code>emergency.settings</code> dictionary as parameters for the <a href="./../../development/CGPL.html">HTTPCall</a> CG/PL operation. The call body is a dictionary with the following elements:</p><ul><li><p><code>userName</code></p><p>the authenticated caller&#39;s Account Name (accountName@domainName).</p></li><li><p><code>fromWhom</code></p><p>the caller&#39;s name (URI) as specified in the Request From: data.</p></li><li><p><code>areaCode</code></p><p>the PSTNEmergency Setting value with the <code>http=</code> prefix removed.</p></li></ul><p>When the application receives an HTTP response, the HTTP response body should contain a <a href="./../../development/Data.html">string</a> or an <a href="./../../development/Data.html">array</a> with the destination address(es).</p></li></ul><p>The application redirects the call to the specified address(es).</p><h2 id="Settings" tabindex="-1">PSTN Account Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;PSTN Account Settings {#Settings}&quot;">​</a></h2><p>PSTN Settings are implemented as <a href="./../directory/CentralDir.html">Custom</a> Account Settings. The main WebAdmin Account Management page does not show the Custom Settings with names starting with the <code>PSTN</code> prefix. Instead, a link to a special PSTN Settings page is available on the Account Settings and Account Default Settings pages.</p><p>Click the PSTN link to open the PSTN Settings page:</p>`,81),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("th",{align:"right",width:"20%"},"Local Area Code:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNAreaCode-Def",value:"1",type:"radio"})]),e("td",null,"7(499)")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNAreaCode-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"PSTNAreaCode",size:"50",maxlength:"1000",value:"7(499)"})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Emergency Code:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNEmergency-Def",value:"1",checked:"checked",type:"radio"})]),e("td",null,"call=911@our.local.dom")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNEmergency-Def",value:"0",type:"radio"})]),e("td",null,[e("input",{name:"PSTNEmergency",size:"50",maxlength:"1000",value:""})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Gateway Domain:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNGatewayDomain-Def",value:"1",type:"radio"})]),e("td",null,"provider.com")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNGatewayDomain-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"PSTNGatewayDomain",size:"50",maxlength:"1000",value:'{gw1=server1.lan;gw2=provider.com;gw3="*provider.com";}'})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Gateway Address:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNGatewayVia-Def",value:"1",type:"radio"})]),e("td",null,"personal.provider.com")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNGatewayVia-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"PSTNGatewayVia",size:"50",maxlength:"1000",value:'{gw1=10.1.0.5;gw2=personal.provider.com;gw3="sip:64.173.55.169:5060";}'})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Caller ID:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNFromName-Def",value:"1",type:"radio"})]),e("td",null,"Moscow")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNFromName-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"PSTNFromName",size:"50",maxlength:"1000",value:"{gw1=dmak;gw2=user2;gw3=74992713154;}"})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Name for Gateway:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNGatewayAuthName-Def",value:"1",type:"radio"})]),e("td",null,"dmak")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNGatewayAuthName-Def",value:"0",checked:"checked",type:"radio"})]),e("td",null,[e("input",{name:"PSTNGatewayAuthName",size:"50",maxlength:"1000",value:"{gw2=dmak;gw3=support;}"})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Password for Gateway:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNGatewayPassword-Def",value:"1",checked:"checked",type:"radio"})]),e("td",null,"********")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNGatewayPassword-Def",value:"0",type:"radio"})]),e("td",null,[e("input",{name:"PSTNGatewayPassword",size:"50",maxlength:"1000",value:"********"})])])])])])]),e("tr",null,[e("th",{align:"right",width:"20%"},"Billing Plan:"),e("td",null,[e("table",{border:"0",cellpadding:"1",cellspacing:"0"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"PSTNBillingPlan-Def",value:"1",checked:"checked",type:"radio"})]),e("td")]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"PSTNBillingPlan-Def",value:"0",type:"radio"})]),e("td",null,[e("input",{name:"PSTNBillingPlan",size:"50",maxlength:"1000",value:""})])])])])])])])])])],-1),e("p",null,[a("A Domain Administrator should have the "),e("a",{href:"./../sysadmin/#DomainPrivs"},"PSTN Settings"),a(" Access Right to modify PSTN Settings.")],-1)]))}const y=o(l,[["render",r]]);export{g as __pageData,y as default};
