import{_ as l,C as r,c as d,o as p,ag as s,j as e,a as o,G as i,w as a}from"./chunks/framework.jCcxW76o.js";const w=JSON.parse('{"title":"SIP Module","description":"","frontmatter":{"legacyLink":"SIP.html"},"headers":[],"relativePath":"admin/signals/SIP.md","filePath":"admin/signals/SIP.md"}'),u={name:"admin/signals/SIP.md"},c={action:"Null.html"},h={class:"settingsBox"},m={width:"100%"},v={action:"Null.html"},f={class:"settingsBox"},b={width:"100%"};function g(P,t,S,y,I,T){const n=r("font");return p(),d("div",null,[t[31]||(t[31]=s('<h1 id="sip-module" tabindex="-1">SIP Module <a class="header-anchor" href="#sip-module" aria-label="Permalink to &quot;SIP Module&quot;">​</a></h1><p>The CommuniGate Pro SIP Module implements the <a href="./../common/Features.html#SIP">SIP Internet protocols</a> via IP networks.</p><p>The module is used to receive <a href="./../cluster/Signals.html">Signal</a> Requests from remote entities, and to send Signals to remote entities.</p><p>The SIP protocol does not include the protocols required for actual data transfer (media transfer protocols). Instead, the SIP protocol allows all participating parties to find each other on the network, to negotiate the media transfer protocol(s) and protocol parameters, to establish interactive real-time sessions, and to manage those sessions: add new parties, close sessions, update session parameters, etc.</p><h2 id="Protocol" tabindex="-1">Session Initiation Protocol (SIP) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Session Initiation Protocol (SIP) {#Protocol}&quot;">​</a></h2><p>The CommuniGate Pro SIP Module implements the SIP protocol functionality. The module uses TCP and UDP listeners to receive SIP request and response packets via these network protocols. It also sends the response and request packets via the TCP and UDP network protocols.</p><p>The SIP module parses all received SIP packets, and uses the module subcomponents to process the parsed packets. Request packets are submitted to the SIP Server subcomponent, to a new SIP Server transaction or to an existing one.<br> The SIP Server component uses the <a href="./../cluster/Signals.html">Signal</a> Module to process the request. The responses generated with the Signal module are submitted to the SIP Server transaction, and the SIP Server sends them back to the source of the SIP request.</p><p>The <a href="./../cluster/Signals.html">Signal</a> module can send a Request to a remote SIP device or to a remote SIP server. The module uses the SIP Client subcomponent to create a SIP Client transaction. This transaction is used to send a SIP Request via an Internet protocol, and to process the Responses sent back.</p><p>SIP Request packets received with the SIP Module are submitted to the SIP Server subcomponent, while SIP Response packets are submitted to the SIP Client subcomponent, with two exceptions:</p><ul><li>if no Client transaction can be found for a Response packet, the packet is relayed &quot;upstream&quot; by the SIP Module itself, without using the <a href="./../cluster/Signals.html">Signal</a> module.</li><li>if no Server transaction can be found for an ACK Request, a SIP Client transaction is created to relay the ACK Request &quot;downstream&quot;.</li></ul><p>The CommuniGate Pro SIP module supports UDP and TCP communications, and it also supports secure (TLS) communications over the TCP protocol.</p><p>The CommuniGate Pro SIP module supports <em>near-end</em> and <em>far-end</em> NAT traversal, enabling SIP communications for both large corporations with many internal LANs, as well as for home users connecting to the Internet via &quot;dumb&quot; NAT devices.</p><p>The session initiation schema described above works correctly only if both parties can communicate directly. If there is a firewall or a <em>NAT</em> device between the parties, direct communication is not possible. In this case, the CommuniGate Pro SIP module builds and manages <a href="./NAT.html"><em>media proxies</em></a>, relaying not only the SIP protocol requests and responses, but the media data, too.</p><h2 id="TransportConfig" tabindex="-1">SIP Transport Settings <a class="header-anchor" href="#TransportConfig" aria-label="Permalink to &quot;SIP Transport Settings {#TransportConfig}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the SIP module. Open the Real-Time pages in the Settings realm, then open the SIP pages.</p><p>Click the Transport link to open the SIP Transport Settings.</p><h3 id="ServerTransport" tabindex="-1">Transport <a class="header-anchor" href="#ServerTransport" aria-label="Permalink to &quot;Transport {#ServerTransport}&quot;">​</a></h3><p>The Transport panel allows you to configure the network-level options for SIP packet receiving:</p>',18)),t[32]||(t[32]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Transport")])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Log Level:"),e("td",null,[e("select",{name:"ZZ"},[e("option",null,"Crashes Only"),e("option",null,"Failures"),e("option",{selected:"selected"},"Major & Failures"),e("option",null,"Problems"),e("option",null,"Low-Level"),e("option",null,"All Info")])]),e("td",{class:"arrow"},[o("UDP "),e("a",{href:"Listener.html#UDP"},"Listener")]),e("td",{align:"RIGHT"},"Dump Call-Related Packets:"),e("td",null,[e("select",{name:"DebugCalls"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Enqueuers:"),e("td",null,[e("select",{name:"Enqueuers"},[e("option",{value:"0",selected:"selected"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"7"},"7"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"4"},"other")])]),e("td",{rowspan:"2",class:"arrow"},[o("TCP "),e("a",{href:"Listener.html"},"Listener")]),e("td",{align:"right"},"Channels:"),e("td",null,[e("select",{name:"MaxInputChannels"},[e("option",{value:"0"},"off"),e("option",{value:"1"},"1"),e("option",{value:"3"},"3"),e("option",{value:"5",selected:"selected"},"5"),e("option",{value:"10"},"10"),e("option",{value:"25"},"25"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250"),e("option",{value:"500"},"500"),e("option",{value:"1000"},"1000"),e("option",{value:"2500"},"2500"),e("option",{value:"3000"},"3000"),e("option",{value:"5000"},"5000"),e("option",{value:"7500"},"7500"),e("option",{value:"9000"},"9000"),e("option",{value:"6"},"other")])])]),e("tr",null,[e("td",{align:"right"},"Enqueued Limit:"),e("td",null,[e("select",{name:"MaxSubmitted"},[e("option",{value:"0"},"0"),e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000",selected:"selected"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"3001"},"other")])]),e("td",{align:"right"},"Idle Timeout:"),e("td",null,[e("select",{name:"TCPIdleTimeout"},[e("option",{value:"5"},"5 seconds"),e("option",{value:"7"},"7 seconds"),e("option",{value:"10"},"10 seconds"),e("option",{value:"15"},"15 seconds"),e("option",{value:"30"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600",selected:"selected"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours"),e("option",{value:"86400"},"day"),e("option",{value:"172800"},"2 days"),e("option",{value:"259200"},"3 days"),e("option",{value:"345600"},"4 days"),e("option",{value:"432000"},"5 days"),e("option",{value:"604800"},"week")])])]),e("tr",null,[e("td",{align:"RIGHT"},"Use Short Field Names:"),e("td",null,[e("select",{name:"UseShortFields"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"Enabled")])]),e("td",{colspan:"3"}," ")]),e("tr")])]),e("table",{class:"settingsBox",cellpadding:"3",width:"90%"},[e("tbody",null,[e("tr",null,[e("td",{colspan:"2"}),e("td",{rowspan:"2"},"UDP Request Size Limit:"),e("td",{align:"right"},"LAN:"),e("td",null,[e("input",{name:"LANUDPLimit",value:"10K",size:"5",maxlength:"6",type:"text"})])]),e("tr",null,[e("td",{align:"right"},"UDP TOS Tag:"),e("td",null,[e("select",{name:"UDPTOSByte"},[e("option",{value:"-1",selected:"selected"},"OS default"),e("option",{value:"0"},"0"),e("option",{value:"2"},"2"),e("option",{value:"4"},"4"),e("option",{value:"8"},"8"),e("option",{value:"16"},"16"),e("option",{value:"32"},"32"),e("option",{value:"64"},"64"),e("option",{value:"128"},"128"),e("option",{value:"127"},"other")])]),e("td",{align:"right"},"WAN:"),e("td",null,[e("input",{name:"WANUDPLimit",value:"1400",size:"5",maxlength:"6",type:"text"})])])])])])],-1)),t[33]||(t[33]=s('<ul><li><p><code>Log Level</code></p><p>Use this setting to specify the type of information about SIP packets and SIP transport the module should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code> (session establishment reports), or <code>Problems</code> (failures, session establishment and non-fatal errors) levels.<br> When you experience problems with the SIP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case the packet contents and other details will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The SIP module transport records in the System Log are marked with the <code>SIPDATA</code> tag.<br> Generic SIP information records have the <code>SIP</code> tag.</p></li><li><p><code>Dump Call-Related Packets</code></p><p>When this setting is enabled, all packets related to VoIP calls (<code>INVITE</code>, <code>BYE</code>, etc) are written to the log as if Log Level were set to All Info.</p></li><li><p><code>UDP</code></p><p>To configure the UDP transport, click the UDP <code>listener</code> link. The <a href="./../network/Listener.html#UDP">UDP Listener</a> page will open. By default, the SIP UDP port is 5060.</p></li><li><p><code>TCP</code></p><p>To configure the TCP transport, click the TCP <code>listener</code> link. The <a href="./../network/Listener.html">TCP Listener</a> page will open. There you can specify both secure and clear-text TCP ports. By default, the clear-text SIP TCP port is 5060, and the SIP TLS port is 5061.</p></li><li><p><code>Input Channels</code></p><p>Use this option to specify the maximum number of TCP communication channels the module can open. If the number is exceeded, the module will reject new incoming TCP connections.</p></li><li><p><code>Idle Timeout</code></p><p>Use this option to specify when the SIP module should close a TCP communication channel if there is no activity on that channel. This helps to reduce the resources used for TCP communication channels on large installations. On the other hand, some SIP clients may not function properly if the server closes its TCP connection on a time-out.</p></li><li><p><code>Enqueuers</code></p><p>When this option is set to a non-zero value, received packets are not processed immediately: they are placed into a special queue and the receiving thread becomes ready to receive a new packet immediately. The option specifies a number of additional threads that take packets from that queue and process them, sending them to Server or Client SIP transactions.</p></li><li><p><code>Enqueued Limit</code></p><p>When packets are not processed immediately, but placed into a special queue first (see above), this option limits the size of that queue. When the number of packets in the queue exceeds this limit, new received packets are dropped. You may want to increase the number of Enqueuers in this situation.</p></li><li><p><code>Use Short Field Names</code></p><p>If this option is enabled, all SIP packets (client requests and server responses) the Server generates will use alternative (1-symbol) packet header field names. You may want to enable this option to decrease packet sizes.</p></li><li><p><code>UDP Request Size Limit</code></p><p>Use this option to specify the size for the largest UDP packet that can be sent within your LAN and outside your LAN. If the SIP module needs to deliver a packet and the protocol is not explicitly specified, the SIP module uses the UDP protocol, unless the packet size is larger than the specified limit. In the latter case the TCP protocol is used.</p></li><li><p><code>UDP TOS Tag</code></p><p>Use this setting to specify the TOS tag for all outgoing SIP UDP packets. This tag can be used to set the SIP traffic priority on your LAN.</p></li></ul><h2 id="ServerConfig" tabindex="-1">SIP Server Settings <a class="header-anchor" href="#ServerConfig" aria-label="Permalink to &quot;SIP Server Settings {#ServerConfig}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the SIP module. Open the Real-Time pages in the Settings realm, then open the SIP pages.</p><p>Click the Receiving link to open the SIP Server (UAS) Settings.</p><h3 id="ServerTransactions" tabindex="-1">Transactions <a class="header-anchor" href="#ServerTransactions" aria-label="Permalink to &quot;Transactions {#ServerTransactions}&quot;">​</a></h3><p>The Transactions panel allows you to specify how the SIP Module handles SIP server (UAS) transactions.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Server Transactions</b></td></tr><tr><td>Log Level: <select name="ServerLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="center">Processors: <select name="ServerProcessors"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">other</option></select></td><td align="center">Object Limit: <select name="MaxServerTransactions"><option value="0">0</option><option value="1">1</option><option value="3">3</option><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300">300</option><option value="1000" selected="selected">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="30000">30000</option><option value="100000">100000</option><option value="300000">300000</option><option value="1001">other</option></select></td><td align="center">Event Limit: <select name="MaxServerMessages"><option value="0">0</option><option value="1">1</option><option value="3">3</option><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300" selected="selected">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="30000">30000</option><option value="1001">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log setting to specify what kind of information the SIP Server subcomponent should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code> (session establishment reports), or <code>Problems</code> (failures, session establishment and non-fatal errors) levels.<br> The SIP Server subcomponent records in the System Log are marked with the SIPS tag.</p></li><li><p><code>Processors</code></p><p>Use this setting to specify the number of threads used to process SIP Server transactions.</p></li><li><p><code>Object Limit</code></p><p>Use this setting to specify the maximum number of concurrent server transactions the SIP Module is allowed to handle. When this number is exceeded, incoming SIP packets with new requests are dropped.</p></li><li><p><code>Event Limit</code></p><p>Use this setting to specify the maximum number of unprocessed events sent to all active SIP server transactions. If this number is exceeded, the SIP Server component is overloaded: no new SIP server transactions can be created, and incoming SIP packets with new requests are dropped.</p></li></ul><h3 id="AUTH" tabindex="-1">Protocol <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;Protocol {#AUTH}&quot;">​</a></h3><p>The SIP Module server component implements <a href="./../cluster/Signals.html#AUTH">Request Authentication</a> for remote clients. If an internal Server component rejects a Request because it does not contain authentication data, the Module adds special fields to the response it sends, facilitating authentication.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Protocol</b></td></tr><tr><td><input name="AdvertiseDigestAUTH" value="1" checked="checked" type="checkbox"> Advertise &#39;Digest&#39; Authentication</td><td><input name="AdvertiseNTLMAUTH" value="1" checked="checked" type="checkbox"> Advertise &#39;NTLM&#39; Authentication</td></tr><tr><td><input name="SendNonINVITE100" value="1" checked="checked" type="checkbox"> Send &#39;100 Trying&#39; for non-INVITEs</td><td><input name="SendINVITE100" value="1" checked="checked" type="checkbox"> Always Send &#39;100 Trying&#39; for INVITEs</td></tr></tbody></table></div></form><ul><li><p><code>Advertise Digest AUTH</code></p><p>Select this option to inform SIP clients that the standard DIGEST authentication method is supported.</p></li><li><p><code>Advertise Digest NTLM</code></p><p>Select this option to inform SIP clients that the non-standard NTLM authentication method is supported.</p></li></ul><p>The user name specified in the authentication data is processed using the <a href="./../sysadmin/Router.html">Router</a> component, so Account Aliases and Forwarders, as well as Domain Aliases can be used in authentication names.<br> The specified <a href="./../objects/Accounts.html#Services">Account</a> and its <a href="./../objects/Domains.html#Services">Domain</a> must have the <code>SIP</code> Service enabled.</p><p>All CommuniGate Pro <a href="./../sysadmin/Security.html">Account passwords</a> can be used for SIP authentication.</p><p>If the CommuniGate Password option is enabled for the specified Account, the SIP module checks if the Account has the <code>SIPPassword</code> setting. If it exists, it is used instead of the standard <code>Password</code> setting. This feature allows an Administrator to assign a alternative Account password to be used for the SIP authentication only.</p><ul><li><p><code>Send &#39;100 Trying&#39; for non-INVITEs</code></p><p>If this option is enabled and the client resends a request, the SIP module sends the 100 (&quot;Trying&quot;) response even in the request method is not <code>INVITE</code>.</p></li><li><p><code>Always Send &#39;100 Trying&#39; for INVITEs</code></p><p>If this option is enabled, the SIP module always sends the 100 (&quot;Trying&quot;) response before it starts to process an <code>INVITE</code> request.</p></li></ul><h3 id="Protection" tabindex="-1">Protection <a class="header-anchor" href="#Protection" aria-label="Permalink to &quot;Protection {#Protection}&quot;">​</a></h3><p>The SIP Module server component implements several protection techniques:</p><ul><li>UDP packets and TCP connections from Network IP Addresses included into the <a href="./../network/#Denied">Denied Addresses</a> list are dropped without processing.</li><li>When the number of misformed SIP packets received from some Network IP Address address exceeds the specified frequency limit, that Address is added to the <a href="./../sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> list.</li><li>When a SIP request is rejected because of some authentication error, the response is sent after some delay, and the sender Network IP Address is added to the <a href="./../sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> list if the number of the authentication errors associated with that Address exceeds the specified frequency limit.</li><li>When a SIP request received from Network IP Addresses included into the <a href="./../sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> list, they are dropped without processing.</li></ul><h2 id="ClientConfig" tabindex="-1">SIP Client Settings <a class="header-anchor" href="#ClientConfig" aria-label="Permalink to &quot;SIP Client Settings {#ClientConfig}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the SIP module. Open the Real-Time pages in the Settings realm, then open the SIP pages.</p><p>Click the Sending link to open the SIP Client (UAC) Settings.</p><h3 id="ClientTransactions" tabindex="-1">Transactions <a class="header-anchor" href="#ClientTransactions" aria-label="Permalink to &quot;Transactions {#ClientTransactions}&quot;">​</a></h3><p>The Transactions panel allows you to specify how the SIP Module handles SIP client (UAC) transactions.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Client Transactions</b></td></tr><tr><td>Log Level: <select name="ClientLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="center">Processors: <select name="ClientProcessors"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">other</option></select></td><td align="center">Object Limit: <select name="MaxClientTransactions"><option value="1">1</option><option value="3">3</option><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300">300</option><option value="1000" selected="selected">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="301">other</option></select></td><td align="center">Event Limit: <select name="MaxClientMessages"><option value="1">1</option><option value="3">3</option><option value="10">10</option><option value="30">30</option><option value="100">100</option><option value="300" selected="selected">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option><option value="301">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log setting to specify what kind of information the SIP Client subcomponent should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code> (session establishment reports), or <code>Problems</code> (failures, session establishment and non-fatal errors) levels.<br> The SIP Client subcomponent records in the System Log are marked with the SIPC tag.</p></li><li><p><code>Processors</code></p><p>Use this setting to specify the number of threads used to process SIP Client transactions.</p></li><li><p><code>Object Limit</code></p><p>Use this setting to specify the maximum number of concurrent client transactions the SIP Module is allowed to handle.</p></li><li><p><code>Event Limit</code></p><p>Use this setting to specify the maximum number of unprocessed events sent to all active SIP client transactions. If this number is exceeded, the SIP Client component is overloaded, and no new SIP client transactions can be created.</p></li></ul><h3 id="ClientProto" tabindex="-1">Protocol <a class="header-anchor" href="#ClientProto" aria-label="Permalink to &quot;Protocol {#ClientProto}&quot;">​</a></h3><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Protocol</b></td></tr><tr><td><input name="AlwaysRecordRoute" value="1" type="checkbox"> Force Dialog Relaying</td><td align="right">Relay to Any IP Address for:</td><td><select name="RelayMode"><option value="0">nobody</option><option value="1" selected="selected">clients</option><option value="2">anybody</option></select></td></tr><tr><td><input name="UseOutgoingProxy" value="1" type="checkbox"> Relay via: <input name="OutgoingProxy" value="edge.company.dom" size="17" maxlength="255" type="text"></td><td align="right">Timer B:</td><td><select name="TimerB"><option value="4">4 sec</option><option value="5">5 sec</option><option value="6">6 sec</option><option value="7">7 sec</option><option value="8">8 sec</option><option value="9">9 sec</option><option value="10">10 sec</option><option value="11">11 sec</option><option value="12">12 sec</option><option value="13">13 sec</option><option value="14">14 sec</option><option value="15">15 sec</option><option value="16">16 sec</option><option value="20">20 sec</option><option value="24">24 sec</option><option value="30">30 sec</option><option value="32" selected="selected">32 sec</option><option value="40">40 sec</option><option value="45">45 sec</option><option value="60">60 sec</option><option value="64">64 sec</option><option value="120">2 min</option><option value="128">128 sec</option><option value="256">256 sec</option><option value="33">other</option></select></td></tr><tr><td><input type="checkbox" name="SendPAI" value="1" checked="checked"> Send P-Asserted-Identity</td><td colspan="2"> </td></tr></tbody></table></div></form><ul><li><p><code>Force Dialog Relaying</code></p><p>If this option is disabled, the SIP Module introduces itself only into those SIP dialogs that require its participation (such as those involving NAT/Firewall traversal). If this option is enabled, the SIP module introduces itself into all SIP dialogs opened. This feature can be used for troubleshooting, as all details of dialog transactions are recorded in the Server Log.</p></li><li><p><code>Relay to Non-Clients</code></p><p>If this option is set to <code>anybody</code>, the SIP Module acts as an Open Relay: it relays any SIP request to any destination.<br> To prevent abuse of your Server, allow relaying for <code>clients</code> only or for <code>nobody</code>.<br> The SIP Module will send Requests if at least one the following conditions is met:</p><ul><li>the destination address is listed as a <a href="./../sysadmin/Protection.html#ClientFixed">Client IP</a> address.</li><li>the Request is being relayed to devices registered with some Account on your Server.</li><li>the Request is generated by a Local <a href="./../cluster/Signals.html">Node</a> (such as a PBX Task).</li><li>the Request sender is authenticated with your Server.</li><li>the Request is received from a network address listed in as a <a href="./../sysadmin/Protection.html#ClientFixed">Client IP</a> address (only if this option is set to <code>clients</code>).</li></ul><p>If none of these conditions is met, the request is rejected with the 401 (&quot;Authentication required&quot;) error code.</p></li><li><p><code>Relay via</code></p><p>Enable this option if you want to relay all outgoing packets via some external SIP server. Note that this setting is not used for addresses explicitly routed to external hosts using the <a href="./../sysadmin/Router.html#Via">._via</a> suffix or other routing methods.</p></li><li><p><code>Timer B</code></p><p>This option controls the value of the &quot;Timer B&quot; (specified in RFC3261). It controls the maximum time the INVITE-type transaction will wait for any first response from the called party.<br> While the standard specifies the 32 seconds value, we strongly recommend to lower this value to 5-10 seconds: if the remote party does not provide any answer within that time (not even the 100-Trying response), most likely it is down and there is no need to wait for 32 seconds before reporting this to the call originator.<br> Lowering this time allows the SIP Client transaction to try other SRV records (if any exists): if this timer is set to 32 seconds, the calling user is likely to give up before the next SRV record is tried.</p></li><li><p><code>487-Wait Timer</code></p><p>When a SIP transaction is terminated by the client, a CANCEL request is generated and sent. This setting specifies for how long the Module should wait for a 487-response from the client.<br> If no response is received, the Module generates the 487-response itself.</p></li><li><p><code>Send P-Asserted-Identity</code></p><p>If this option is enabled, and the request sender is authenticated, a <code>P-Asserted-Identity</code> field is added to the SIP request sent. The field contains a SIP URI with the authenticated Account full name (<code>sip:accountName@domainName</code>).</p></li></ul><h2 id="WindowsMessenger" tabindex="-1">Microsoft® Windows Products Support <a class="header-anchor" href="#WindowsMessenger" aria-label="Permalink to &quot;Microsoft® Windows Products Support {#WindowsMessenger}&quot;">​</a></h2><p>The Microsoft &quot;RTC&quot; products (including Windows Messenger) use the standard SIP protocol for audio and video sessions.<br> These clients use the proprietary SIP protocol extensions for Instant Messaging, Presence, Whiteboard, Remote Assistance and other services. CommuniGate Pro implements the extensions required to support these applications.</p><p>The Windows Messenger versions prior to 5.0 are not supported.</p><p>The CommuniGate Pro SIP module should have the Advertise NTLM option enabled.</p><p>The Windows Messenger audio and video sessions use standard RTP media protocols and these sessions can be used <a href="./NAT.html#MediaProxy">over a NAT/Firewall</a>.<br> The Windows Messenger Instant Messaging uses the SIP protocol for media transfer and Instant Messaging sessions can be used over a NAT/Firewall.<br> The Windows Messenger Whiteboard, Application Sharing, and Remote Assistance sessions use T.120 and non-standard protocols and these sessions can be used over a NAT/Firewall.<br> The Windows Messenger File Transfer sessions use a non-standard protocol and these sessions currently cannot be used over a NAT/Firewall.</p><h2 id="Hacks" tabindex="-1">SIP Devices Support and Workarounds <a class="header-anchor" href="#Hacks" aria-label="Permalink to &quot;SIP Devices Support and Workarounds {#Hacks}&quot;">​</a></h2><p>Many currently available SIP devices and applications incorrectly implement various aspects of the SIP protocol.<br> The CommuniGate Pro SIP Module tries to compensate for certain client problems and bugs, based on the type of SIP devices connected to it.</p><p>Use the WebAdmin Interface to configure the SIP workarounds. Open the Real-Time pages in the Settings realm, then open the SIP pages. Click the Workarounds link. The Workarounds table appears:</p>',37)),e("form",c,[e("div",h,[e("table",m,[e("tbody",null,[t[12]||(t[12]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Problems/Bugs")])],-1)),e("tr",null,[t[11]||(t[11]=e("th",{align:"left"},"Agent Name",-1)),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[0]||(t[0]=[o("Microsoft")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[1]||(t[1]=[o("SubPresence")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[2]||(t[2]=[o("FixContacts")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[3]||(t[3]=[o("NoTCP")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[4]||(t[4]=[o("NoMaddr")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[5]||(t[5]=[o("NoPath")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[6]||(t[6]=[o("BadByeAuth")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[7]||(t[7]=[o("NeedsEpid")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[8]||(t[8]=[o("NoSubMWI")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[9]||(t[9]=[o("ActiveHold")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[10]||(t[10]=[o("TCPPing")])),_:1})])]),t[13]||(t[13]=e("tr",null,[e("td",null,[e("input",{name:"A100",value:"RTC/*",size:"20",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"b100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"c100",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,[e("input",{name:"d100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"e100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"f100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"g100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"h100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"i100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"j100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"k100",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"l100",value:"1",type:"checkbox"})])],-1)),t[14]||(t[14]=e("tr",null,[e("td",null,[e("input",{name:"A101",value:"SomeClient*",size:"20",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"b101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"c101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"d101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"e101",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,[e("input",{name:"f101",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,[e("input",{name:"g101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"h101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"i101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"j101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"k101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"l101",value:"1",type:"checkbox"})])],-1)),t[15]||(t[15]=e("tr",null,[e("td",null,[e("input",{name:"A102",value:"",size:"20",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"b102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"c102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"d102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"e102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"f102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"g102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"h102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"i102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"j102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"k102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"l102",value:"1",type:"checkbox"})])],-1))])])])]),t[34]||(t[34]=e("p",null,"To specify workarounds for a certain product, put the product name into the last (empty) table element, select the required workarounds and click the Update button.",-1)),t[35]||(t[35]=e("p",null,"To remove a certain product, remove its name from the table, and click the Update button.",-1)),t[36]||(t[36]=e("p",null,"A similar table exists for remote sites:",-1)),e("form",v,[e("div",f,[e("table",b,[e("tbody",null,[t[28]||(t[28]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Problems/Bugs")])],-1)),e("tr",null,[t[27]||(t[27]=e("th",{align:"left"},"Agent Name",-1)),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[16]||(t[16]=[o("Microsoft")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[17]||(t[17]=[o("SubPresence")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[18]||(t[18]=[o("FixContacts")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[19]||(t[19]=[o("NoTCP")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[20]||(t[20]=[o("NoMaddr")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[21]||(t[21]=[o("NoPath")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[22]||(t[22]=[o("BadByeAuth")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[23]||(t[23]=[o("NeedsEpid")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[24]||(t[24]=[o("NoSubMWI")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[25]||(t[25]=[o("ActiveHold")])),_:1})]),e("th",null,[i(n,{size:"-1"},{default:a(()=>t[26]||(t[26]=[o("TCPPing")])),_:1})])]),t[29]||(t[29]=e("tr",null,[e("td",null,[e("input",{name:"A101",value:"sip.provider.dom",size:"20",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"b101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"c101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"d101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"e101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"f101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"g101",value:"1",type:"checkbox",checked:"checked"})]),e("td",null,[e("input",{name:"h101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"i101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"j101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"k101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"l101",value:"1",type:"checkbox"})])],-1)),t[30]||(t[30]=e("tr",null,[e("td",null,[e("input",{name:"A101",value:"",size:"20",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"b101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"c101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"d101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"e101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"f101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"g101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"h101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"i101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"j101",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"k102",value:"1",type:"checkbox"})]),e("td",null,[e("input",{name:"l102",value:"1",type:"checkbox"})])],-1))])])])]),t[37]||(t[37]=s('<p>When the SIP module is about to relay a Signal request to a remote destination, it applied the workaround methods specified for the request URI domain as well as the methods specified for the target URI domain.</p><p>The currently implemented workaround methods are:</p><ul><li><p><code>Microsoft</code></p><p>The entity is a Microsoft client. Protocol messages are signed, and other SIP protocol derivations are processed.</p></li><li><p><code>SubPresence</code></p><p>The entity supports Presence, but does not implement a push-type Presence Agent (<code>Publish</code>). The Server will send <code>SUBSCRIBE</code> requests to monitor the entity Presence status.</p></li><li><p><code>noTCP</code>, <code>noMaddr</code></p><p>The entity does not support <code>transport</code> and/or <code>maddr</code> Contact parameters. The Server will modify the Contact data sent to this entity.</p></li><li><p><code>noPath</code></p><p>The entity does not support the RFC3327 (<code>Path</code> fields).<br> The Server will modify the Contact data sent to this entity.</p></li><li><p><code>badByeAuth</code></p><p>The entity incorrectly calculates Authentication digests for non-INVITE (<code>BYE</code>, <code>NOTIFY</code>, <code>REFER</code>) requests.</p></li><li><p><code>needsEpid</code></p><p>The entity uses a non-standard <code>epid=</code> parameter in its From/To URIs and fails to work if the peer does not preserve this non-standard parameter.</p></li><li><p><code>NoSubMWI</code></p><p>The entity supports the Message-summary Event package (to implement MWI - Message Waiting Indicator), but it fails to send SUBSCRIBE requests to activate this service.<br> The Server will subscribe the client on registration.</p></li><li><p><code>ActiveHold</code></p><p>The entity has problems with switching media flow from the default bi-directional (<code>sendRecv</code>) to any other mode or back.<br> The Server will leave the media state in the (<code>sendRecv</code>) mode even when the media state requested by a local PBX application or bridged peer is inactive or one-way.</p></li><li><p><code>TCPPing</code></p><p>When this entity sends a REGISTER request over a TCP connection from a NAT&#39;ed network, do not start to send the PING packets to that entity. Instead, enable the &quot;Keep Alive&quot; option for the request TCP connection.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Most OS have very long time-outs for the &quot;Keep Alive&quot; option. If you plan to use this workaround, it is recommended to decrease these timeouts in the Server OS to 1-3 minutes.</p></div></li><li><p><code>badUpdate</code></p><p>The entity advertises support for the SIP UPDATE method, but it incorrectly processes SIP UPDATE requests.</p></li></ul><p>The following Web Site contains a periodically updated <a href="http://www.communigatepro.ru/SIP/HCL.html" target="_blank" rel="noreferrer">document</a> listing the tested SIP Clients, the problems discovered and the known workarounds.</p><h2 id="Routing" tabindex="-1">Routing <a class="header-anchor" href="#Routing" aria-label="Permalink to &quot;Routing {#Routing}&quot;">​</a></h2><p>The SIP module immediately (on the first <a href="./../sysadmin/Router.html">Router</a> call) accepts all signal addresses with IP-address domains, i.e. with domain names like <code>[xx.yy.zz.tt]</code>. Please note that the <a href="./../sysadmin/Router.html">Router</a> adds brackets to the IP-address domain names that do not have them, and the Router changes the IP addresses of local domains to those domain names. The Router performs these operations before calling the modules.</p><p>On the final call, the SIP module accepts signal to any domain if that domain name contains at least one dot (<code>.</code>) symbol. If the Relay via option is selected, all these addresses are rerouted to the specified Relay via domain.</p><p>Before accepting an address, the SIP module checks if the address does not contain any <code>@</code> symbol, but contains one or several <code>%</code> symbols. In this case, the rightmost <code>%</code> symbol is changed to the <code>@</code> symbol.</p><p>If the target domain name contains a <code>._udp</code>, <code>._tcp</code>, or <code>._tls</code> suffix, the corresponding transport protocol is used, and the suffix is removed from the target domain name.</p><h2 id="Monitoring" tabindex="-1">Monitoring SIP Activity <a class="header-anchor" href="#Monitoring" aria-label="Permalink to &quot;Monitoring SIP Activity {#Monitoring}&quot;">​</a></h2><p>The Monitors realm of the <a href="./../sysadmin/">WebAdmin Interface</a> allows Server Administrators to monitor the SIP module activity. The SIP Monitor page contains two frames - the receiving (Server) frame, and the sending (Client) frame.</p><p>The SIPS frame displays the active SIP Server transactions:</p>',12)),t[38]||(t[38]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Filter",class:"button",type:"reset"}),o(" "),e("input",{name:"Filter",value:"",size:"10",maxlength:"100",type:"text"})]),e("td",{align:"right"},"2 of 2 selected")])])]),e("table",{class:"settingsBox",cellpadding:"2",cellspacing:"0",width:"96%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",{nowrap:"nowrap"},"ID"),e("th",null,"Status"),e("th",null,"Msg"),e("th",null,"Phase"),e("th",null,"Source"),e("th",null,"Target"),e("th",null," ")]),e("tr",null,[e("td",null,"38984"),e("td",{nowrap:"nowrap"},"waiting (15s)"),e("td",null,"0"),e("td",null,"completed"),e("td",{nowrap:"nowrap"},"udp[10.10.0.226:59645]"),e("td",null,"SIGNAL-40726"),e("td",null,"OPTIONS sip:ns.communigatepro.ru")]),e("tr",null,[e("td",null,"38994"),e("td",{nowrap:"nowrap"},"waiting (7s)"),e("td",null,"0"),e("td",null,"completed"),e("td",{nowrap:"nowrap"},"tcp[10.0.14.193:24777]"),e("td",null,"SIGNAL-40734"),e("td",null,"MESSAGE sips:user@communigatepro.ru")])])])])],-1)),t[39]||(t[39]=e("p",null,"The SIPC frame displays the active SIP Client transactions:",-1)),t[40]||(t[40]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Filter",class:"button",type:"reset"}),o(" "),e("input",{name:"Filter",value:"",size:"10",maxlength:"100",type:"text"})]),e("td",{align:"right"},"2 of 2 selected")])])]),e("table",{class:"settingsBox",cellpadding:"2",cellspacing:"0",width:"96%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",{nowrap:"nowrap"},"ID"),e("th",null,"Status"),e("th",null,"Msg"),e("th",null,"Phase"),e("th",null,"Source"),e("th",null,"Target"),e("th",null," ")]),e("tr",null,[e("td",null,"35184"),e("td",{nowrap:"nowrap"},"waiting (2m)"),e("td",null,"0"),e("td",null,"provisioned"),e("td",null,"SIGNAL-40726"),e("td",null,"udp[10.0.1.34:5060]"),e("td",null,"INVITE sip:user@10.0.1.34:5060")]),e("tr",null,[e("td",null,"35188"),e("td",{nowrap:"nowrap"},"waiting (7s)"),e("td",null,"0"),e("td",null,"request sent"),e("td",null,"SIGNAL-40732"),e("td",null,"udp[10.0.1.34:5060]"),e("td",null,"MESSAGE sips:user@communigatepro.ru")])])])])],-1))])}const x=l(u,[["render",g]]);export{w as __pageData,x as default};
