import{_ as t,c as o,o as i,ag as n}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"SMPP Module","description":"","frontmatter":{"legacyLink":"SMPP.html"},"headers":[],"relativePath":"admin/signals/SMPP.md","filePath":"admin/signals/SMPP.md"}'),s={name:"admin/signals/SMPP.md"};function a(l,e,r,p,d,u){return i(),o("div",null,e[0]||(e[0]=[n('<h1 id="smpp-module" tabindex="-1">SMPP Module <a class="header-anchor" href="#smpp-module" aria-label="Permalink to &quot;SMPP Module&quot;">​</a></h1><p>The CommuniGate Pro SMPP Module implements the <a href="./../common/Features.html#SMPP">SMPP protocol</a> via TCP/IP networks.</p><p>The SMPP module implements the client (ESME) part of the SMPP protocol. The module can connect to the specified SMPP servers (SMSC, Short Message Service Centre) and relay IM (Instant Message) <a href="./../cluster/Signals.html">Real-Time Signal</a> requests as SMS messages to recipient mobile phones.</p><p>The SMPP module can also receive SMS messages from SMPP servers and send them as IM Signal requests to the specified recipients.</p><h2 id="Protocol" tabindex="-1">Short Message Peer to Peer Protocol (SMPP) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Short Message Peer to Peer Protocol (SMPP) {#Protocol}&quot;">​</a></h2><p>The CommuniGate Pro SMPP Module implements the SMPP protocol functionality. When the Server Administrator specifies one or several SMPP servers (SMSC systems), the SMPP Module opens a TCP connection to the specified server address and &quot;binds&quot; using the specified credentials.<br> When an IM Signal is routed to the SMPP Module, the Module finds the SMPP server it is routed to, and sends it to that server via the SMPP connection.</p><p>To maintain a connection when it is idle (no IM Requests to relay), the module periodically sends the <code>enquire_link</code> request to the SMPP server.</p><p>If a connection to the server cannot be established, or it has been broken and it is being re-established, the IM Signals are enqueued. They are relayed to the server when a connection is established.</p><p>The SMPP module processes only the <code>MESSAGE</code> Real-Time requests, all other requests are rejected.</p><h2 id="Config" tabindex="-1">Configuring the SMPP Module <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the SMPP Module {#Config}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the SMPP module. Open the Real-Time pages page in the Settings realm, then open the SMPP page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="LogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td>Reject if not Relayed in: <select class="popup" name="QueueTimeout"><option value="15">15 sec</option><option value="20">20 sec</option><option value="30" selected="selected">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="300">5 min</option><option value="31">other</option></select></td><td>Dialog Timeout: <select class="popup" name="BindingTimeout"><option value="15">15 sec</option><option value="30">30 sec</option><option value="60">60 sec</option><option value="120">2 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="1200" selected="selected">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="10800">3 hour(s)</option><option value="1201">other</option></select></td><td>Source IP Address: <select name="SourceIP"><option value="[0.0.0.0]">OS default</option><option value="[10.1.8.200]">[10.1.8.200]</option><option value="[192.168.1.104]">[192.168.1.104]</option><option value="[127.0.0.1]">[127.0.0.1]</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use the Log Level setting to specify what kind of information the SMPP module should put in the Server Log. Usually you should use the <code>Major</code> (Signal relay reports) or <code>Problems</code> (relay reports and non-fatal errors) levels. But when you experience problems with the SMPP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The SMPP records in the System Log are marked with the <code>SMPP</code> tag.</p></li><li><p><code>Reject if not Relayed in</code></p><p>If a Signal request to be relayed to a SMPP server is enqueued longer than this period of time, the Signal request is rejected.</p></li><li><p><code>Dialog Timeout</code></p><p>This option specifies the <a href="#Dialogs">SMS Dialog</a> binding time-out.</p></li><li><p><code>Source IP Address</code></p><p>This option selects the <em>source network address</em> for outgoing SMPP connections. You can allow the CommuniGate Pro server OS to select the proper address or your can explicitly select one of the server IP addresses.</p></li></ul><h2 id="HostConfig" tabindex="-1">Configuring SMPP Server Records <a class="header-anchor" href="#HostConfig" aria-label="Permalink to &quot;Configuring SMPP Server Records {#HostConfig}&quot;">​</a></h2><p>You can specify one or several SMPP servers the SMPP module should connect to.</p><form action="Null.html"><div><table class="settingsBox"><tbody><tr align="LEFT"><th>Name</th><th>Mode</th><th>SMSC Address</th><th>System ID</th><th>Password</th><th>Sender</th><th>Recipient</th><th>Dialogs</th><th>Encoding</th><th>Ping Period</th></tr><tr><td><input type="text" name="N0" value="provider1" size="10" maxlength="100"></td><td><select name="M0"><option value="off">Off</option><option value="in">Receive</option><option value="out" selected="selected">Send</option><option value="inout">Send &amp; Receive</option></select></td><td><input type="text" name="S0" value="64.173.55.161:901" size="15" maxlength="100"></td><td><input type="text" name="U0" value="paul456" size="8" maxlength="16"></td><td><input type="password" name="P0" value="wpsd" size="6" maxlength="9"></td><td><input type="text" name="D0" value="+74992713154" size="12" maxlength="16"></td><td><input type="text" name="R0" value="postmaster@domain" size="8" maxlength="160"></td><td><input type="checkbox" name="A0" value="1"></td><td><select name="C0"><option value="gsm-03.38" selected="selected">gsm-03.38</option><option value="iso-8859-1">Western European (ISO)</option><option value="iso-8859-5">Cyrillic (ISO)</option><option value="iso-8859-9">Hebrew (ISO)</option><option value="iso-2022-jp">Japanese (ISO)</option><option value="ks_c_5601-1987">Korean (Windows)</option></select></td><td><select class="popup" name="T0"><option value="0">Never</option><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300" selected="selected">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="301">other</option></select></td></tr><tr><td><input type="text" name="N1" value="masslist" size="10" maxlength="100"></td><td><select name="M1"><option value="off">Off</option><option value="in">Receive</option><option value="out">Send</option><option value="inout" selected="selected">Send &amp; Receive</option></select></td><td><input type="text" name="S1" value="tls:smpp.provider.dom:950" size="15" maxlength="100"></td><td><input type="text" name="U1" value="gremlin" size="8" maxlength="16"></td><td><input type="password" name="P1" value="juuukt10" size="6" maxlength="9"></td><td><input type="text" name="D1" value="4992713154" size="12" maxlength="16"></td><td><input type="text" name="R1" value="" size="8" maxlength="160"></td><td><input type="checkbox" name="A1" value="1" checked="checked"></td><td><select name="C1"><option value="gsm-03.38">gsm-03.38</option><option value="iso-8859-1" selected="selected">Western European (ISO)</option><option value="iso-8859-5">Cyrillic (ISO)</option><option value="iso-8859-9">Hebrew (ISO)</option><option value="iso-2022-jp">Japanese (ISO)</option><option value="ks_c_5601-1987">Korean (Windows)</option></select></td><td><select class="popup" name="T1"><option value="0">Never</option><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30" selected="selected">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="31">other</option></select></td></tr><tr><td><input type="text" name="N3" value="" size="10" maxlength="100"></td><td><select name="M3"><option value="off" selected="selected">Off</option><option value="in">Receive</option><option value="out">Send</option><option value="inout">Send &amp; Receive</option></select></td><td><input type="text" name="S3" value="" size="15" maxlength="100"></td><td><input type="text" name="U3" value="" size="8" maxlength="16"></td><td><input type="password" name="P3" value="" size="6" maxlength="9"></td><td><input type="text" name="D3" value="" size="12" maxlength="16"></td><td><input type="text" name="r3" value="" size="8" maxlength="16"></td><td><input type="checkbox" name="A3" value="1"></td><td><select name="C3"><option value="gsm-03.38" selected="selected">gsm-03.38</option><option value="iso-8859-1">Western European (ISO)</option><option value="iso-8859-5">Cyrillic (ISO)</option><option value="iso-8859-9">Hebrew (ISO)</option><option value="iso-2022-jp">Japanese (ISO)</option><option value="ks_c_5601-1987">Korean (Windows)</option></select></td><td><select class="popup" name="T3"><option value="0" selected="selected">Never</option><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="21599">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Name</code></p><p>This is an internal name of this SMPP server configuration. Any name can be used, but there should be no two SMPP server configurations with the same name. An empty name is allowed.</p></li><li><p><code>Mode</code></p><p>The operation mode for this SMPP server configuration: send-only, receive-only, send-and-receive. The SMPP module logs into the SMPP server as &quot;Transmitter&quot;, &quot;Receiver&quot;, or &quot;Transceiver&quot;.<br> To disable the SMPP server configuration without removing it, select the Off mode.</p></li><li><p><code>SMSC Address</code></p><p>The SMPP server (SMSC) domain name or Network IP Address, with the port number to connect to, separated using the colon (<code>:</code>) symbol.<br> If the port number is not specified, the port 2775 is used.<br> If the connection to the SMPP server should be established securely (using the TLS protocol), add the <code>tls:</code> prefix before the server domain name.</p></li><li><p><code>System ID</code>, <code>Password</code></p><p>These fields contain the credentials to be used to &quot;bind&quot; (log into) the SMPP server.<br> By default the SMPP module uses the CommuniGate string as SMPP &quot;System Type&quot;. Some SMPP servers require some other string to be used as &quot;System Type&quot;. You can specify that string in the System ID field, after the actual System ID, separating it with the @ symbol. For example, if the System ID is user1234, and the requires System Type is SMPP, then specify the user1234@SMPP value in the System ID field.</p></li><li><p><code>Sender</code></p><p>This field is used to compose the &quot;sender&quot; for the SMS messages sent. Usually it is a phone number assigned to the SMPP account you bind to. Use the +<em>countryCode__phoneNumber</em> format to specify the &quot;international&quot; sender format.<br> If this field contains the * symbol, the actual sender E-mail address is substituted. If this address is +<em>number</em>@telnum, only the <em>number</em> part is used. If this address is <em>userName</em>@null, only the <em>userName</em> part is used.<br> If this field is empty, it is processed as if it has the * value.<br> If the resulting address starts with the + symbol, it is removed and the address is sent to the SMPP server as an &quot;international&quot; one. Otherwise it is sent either as a &quot;local&quot; one (if it starts with a digit) or as an &quot;alphanumeric&quot; one.</p></li><li><p><code>Dialogs</code></p><p>When this option is selected, messages sent and received via this SMPP configuration will be processed to support <a href="#Dialogs">SMS Dialogs</a>.</p></li><li><p><code>Recipient</code></p><p>An empty string or an E-mail address of the default recipient. If specified, incoming messages are sent to the specified address if:</p><ul><li>the Dialogs option is disabled</li><li>the Dialogs option is enabled, but no address for the incoming message sender has been remembered (no &quot;binding&quot; found)</li><li>the Dialogs option is enabled, and a &quot;binding&quot; address is found, but the incoming message has the @@ prefix (two &quot;at&quot; symbols and a space)</li></ul><p>If this setting is not specified (left blank):</p><ul><li>if the Dialogs option is enabled, but no address for an incoming message sender has been remembered (no &quot;binding&quot; found), that incoming message is rejected.</li><li>if the Dialogs option is disabled, a message is routed to the destination address specified with the SMPP protocol: if a message is directed to the phone number +74992713154, then it is sent to the +74992713154@telnum address, which can be routed to some local Account (via the Telnum or other mechanism).</li></ul></li><li><p><code>Encoding</code></p><p>The preferred character set (encoding) to use for message sending. If a message cannot be encoded using this character set, it is sent using the Unicode encoding.</p></li><li><p><code>Keep Alive</code></p><p>This option specifies the maximum time period between commands sent to the SMPP server.<br> If there is no message to send to the SMPP server within this time period, the <code>enquire_link</code> command is sent to prevent the server from closing the connection.</p></li></ul><p>To create a new SMPP server configuration, enter the server name and other settings into the last (empty) element, and click the Update button.</p><p>To remove an SMPP server configuration, enter an empty string into its Server (not the Name!) field, and click the Update button.</p><h2 id="Router" tabindex="-1">Routing Signal Requests to the SMPP Module <a class="header-anchor" href="#Router" aria-label="Permalink to &quot;Routing Signal Requests to the SMPP Module {#Router}&quot;">​</a></h2><p>To route a Signal to the SMPP module:</p><ul><li>route it to the <code>phonenumber@smpp</code> address, where <em>phonenumber</em> is the target telephone number in the E.164 format (with the leading <code>+</code> sign). The Signal request will be sent to the first available (enabled) SMPP server configured. If there is an enabled SMPP server with an empty name, the Signal will be sent to that server.</li><li>route it to the <code>phonenumber@name._smpp</code> address, where <em>name</em> is the internal name of a configured and enabled SMPP server.</li></ul><p>Example:<br> with the SMPP server configuration displayed above, Signals directed to <code>+74992713152@smpp</code> will be sent to provider1 (the <code>64.173.55.161:901</code> SMPP server), while Signals directed to <code>+74992713152@masslist._smpp</code> will be sent to masslist (the <code>smpp.provider.dom:950</code> SMPP server).</p><p>Usually, SMS Messages are directed to a regular phone number, i.e. to some +<em>countryCode phoneNumber</em>@telnum address. By default, this address is routed to the <code>gatewaycaller</code> application that relays incoming Instant Messages to one of the SMPP servers. It can take take the SMPP server name from the PSTNSMSGateway setting of the sender, or, if this setting is empty, from the application parameter (used as a default gateway).<br> To use the provider1 SMPP server as the default one, add the following record to the <a href="./../sysadmin/Router.html">Router</a> Table:</p><p><code>IM:&lt;*@telnum&gt; = gatewaycaller{*,provider1}#pbx</code></p><h2 id="Dialogs" tabindex="-1">SMS Dialogs <a class="header-anchor" href="#Dialogs" aria-label="Permalink to &quot;SMS Dialogs {#Dialogs}&quot;">​</a></h2><p>This SMPP Module implements &quot;SMS Dialogs&quot;: when a CommuniGate Pro user sends an Instant Message to some SMPP endpoint (such as a mobile phone), the endpoint user can reply and the reply will be sent to the CommuniGate Pro user as an SMS.</p><p>When an instant message sent from some <em>user1</em>@<em>domain1</em> address is relayed as an SMS message to the phone number <em>XXXXXXX</em>, the SMPP module adds a prefix to the message text:<br><code>@a=user1@domain1 message text</code></p><p>Subsequent instant messages from the same <em>user1</em>@<em>domain1</em> address are relayed to the <em>XXXXXXX</em> phone number with the &quot;short&quot; prefix:<br><code>@a message text</code></p><p>When an instant message sent from some other <em>user2</em>@<em>domain2</em> address is relayed as an SMS message to the same phone number <em>XXXXXXX</em>, the SMPP module adds a different prefix to the message text:<br><code>@b=user2@domain2 message text</code></p><p>Subsequent instant messages from the same <em>user2</em>@<em>domain2</em> address are relayed to the <em>XXXXXXX</em> phone number with the &quot;short&quot; prefix:<br><code>@b message text</code></p><p>The SMPP module remembers these &quot;bindings&quot;, consisting of the sender address, the destination phone number, and the prefix (a low-case letter) assigned.</p><p>When a user of the <em>XXXXXXX</em> phone replies to a message, the SMPP module checks all bindings for the <em>XXXXXXX</em> phone number. If there is exactly one binding, the module relays the received SMS message as an instant message to the address from that binding.<br> If no binding is found, or if there are two or more binding for this phone number, the SMS message is not accepted.</p><p>The user can reply with an SMS message starting with the @<em>x</em>: or @<em>x</em><code>_</code> prefix, where &quot;_&quot; is the space symbol.<br> In this case the SMPP module tries to find a binding for the <em>XXXXXXX</em> phone number and the <em>x</em> prefix. If it is found, the SMS message is relayed to the address in the found binding, otherwise the SMS message is not accepted.</p><p>Example: single dialog as seen on the mobile phone screen:</p><table tabindex="0"><thead><tr><th></th><th style="text-align:right;"></th></tr></thead><tbody><tr><td>@a=smith@company.dom Hi! Got good news about that contract.</td><td style="text-align:right;"></td></tr><tr><td></td><td style="text-align:right;">Great. Signed?</td></tr><tr><td>@a They&#39;ve signed it, we&#39;ll get it tomorrow.</td><td style="text-align:right;"></td></tr><tr><td></td><td style="text-align:right;">Congrats, CU!</td></tr></tbody></table><p>Example: two dialogs as seen on the mobile phone screen:</p><table tabindex="0"><thead><tr><th></th><th style="text-align:right;"></th></tr></thead><tbody><tr><td>@a=susan@company.dom Will you be in town this weekend?</td><td style="text-align:right;"></td></tr><tr><td></td><td style="text-align:right;">Yes</td></tr><tr><td>@a Please come visit us on saturday, we&#39;ll be at home all day long.</td><td style="text-align:right;"></td></tr><tr><td>@b=smith@company.dom Hey, just received their signed contract!</td><td style="text-align:right;"></td></tr><tr><td></td><td style="text-align:right;">@b good! I&#39;ll be there in 30m</td></tr><tr><td></td><td style="text-align:right;">@a Thnx a lot, I will!</td></tr></tbody></table><p>The SMPP Module retires each &quot;binding&quot; if the there it was not used in either direction for the specified Binding Timeout time period.<br> If the Binding Timeout value is too low, then a cell phone user may not be able to answer to a recenlty received SMS message, because by the time the user discovers the SMS, the binding could have expired. If the Binding Timeout value is too high, then cell phone users may have several active bindings too often, forcing them to use <code>@x</code> prefixes too often.</p>',39)]))}const c=t(s,[["render",a]]);export{m as __pageData,c as default};
