import{_ as a,C as d,c as r,o as u,ag as l,j as e,a as i,G as n,w as o}from"./chunks/framework.jCcxW76o.js";const y=JSON.parse('{"title":"Automated Signal Processing Rules","description":"","frontmatter":{"legacyLink":"SignalRules.html"},"headers":[],"relativePath":"admin/signals/SignalRules.md","filePath":"admin/signals/SignalRules.md"}'),c={name:"admin/signals/SignalRules.md"},h={action:"Null.html"};function p(m,t,g,f,b,R){const s=d("tt");return u(),r("div",null,[t[17]||(t[17]=l('<h1 id="automated-signal-processing-rules" tabindex="-1">Automated Signal Processing Rules <a class="header-anchor" href="#automated-signal-processing-rules" aria-label="Permalink to &quot;Automated Signal Processing Rules&quot;">​</a></h1><p>The CommuniGate Pro Server can automatically process Signals using sets of <a href="./../../development/Rules.html">Automated Rules</a>. Rules are not applied to Signal Requests sent inside already established Dialogs.</p><p>The system-wide (Server-Wide and Cluster-wide) Rules are applied to all Signals sent to the Server and/or to the Cluster.</p><p>When a Signal request is directed to a CommuniGate Pro Server Account, the Account-level Rules are applied.<br> The Account-level Rules are the Rules specified for the particular Account along with the Rules specified for the Account Domain.</p><h2 id="Apply" tabindex="-1">Applying Signal Rules <a class="header-anchor" href="#Apply" aria-label="Permalink to &quot;Applying Signal Rules {#Apply}&quot;">​</a></h2><p>Each signal Rules has its <em>stage</em> and <em>priority</em>. The stage specifies when the Rule should be applied:</p><ul><li>immediately when the Signal is received</li><li>after the Signal is being processed for some time</li><li>when the Signal fails with the No Answer, Busy, or some other error condition.</li></ul><p>Within each stage the Rules are applied according to their priority.</p><p>When Server, Cluster, Domain, and Account Rules are &quot;merged&quot;, they are grouped based on the stage value. Within each stage, the Rules are applied in the following order:</p><ul><li>the Server and Cluster Rules with the priority &gt; 5</li><li>the Domain Rules with the priority &gt; 5</li><li>all Account Rules</li><li>the Domain Rules with the priority &lt;= 5</li><li>the Server and Cluster Rules with the priority &lt;= 5</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When Signal processing starts, all Server and Cluster Rules for the &quot;immediate&quot; stage are applied first, and only then processing continues. The Signal can be directed to a local Account, and the Account and Account Domain Rules are &quot;merged&quot; with the Server and Cluster Rules. But at that moment all Server and Cluster Rules for the &quot;immediate&quot; stage have been already applied and removed from the &quot;merged&quot; set.</p></div><h2 id="Configure" tabindex="-1">Specifying Signal Rules <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Specifying Signal Rules {#Configure}&quot;">​</a></h2><p>System administrators can specify Server-wide and Cluster-wide Signal Rules. Use the WebAdmin Interface to open the Real-Time pages in the Settings realm, and click the Rules link.</p><p>System and Domain Administrators can specify Account Rules using links on the <a href="./../objects/Accounts.html">Account Settings</a> WebAdmin Interface pages.</p><p>Account users can specify their Rules themselves, using the <a href="./../access/WebUser.html">WebUser Interface</a>. System or Domain Administrators can limit the set of Rule actions a user is allowed to specify.</p><p>System and Domain Administrators can specify Domain-Wide Rules using the Rules links on the <a href="./../objects/Domains.html">Domain Settings</a> pages.</p><p>See the generic <a href="./../../development/Rules.html">Automated Rules</a> section to learn how to set Rules.</p><h2 id="Conditions" tabindex="-1">Rule Conditions <a class="header-anchor" href="#Conditions" aria-label="Permalink to &quot;Rule Conditions {#Conditions}&quot;">​</a></h2><p>Each Rule can use universal conditions specified in the <a href="./../../development/Rules.html#Conditions">Rules</a> section.<br> Additionally, the following Rule conditions can be used in Signal processing Rules:</p>',19)),e("ul",null,[t[16]||(t[16]=l('<li><p><code>Operation [is | is not | in | not in] string</code></p><p>This condition checks if the Request method is or is not equal to the specified <em>string</em>.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Operation</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="INVITE" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all INVITE Requests.</form></li></ul></li><li><p><code>CallType [is | is not | in | not in] string</code></p><p>This condition checks if the Request SDP type is (or is not) equal to the specified <em>string</em>.<br> The SDP type is <code>AV</code> if the request method is INVITE and it contains at least one audio or video media channel;<br> The SDP type is <code>IM</code> if the request method is MESSAGE or if the request method is INVITE and it contains an IM channel.<br> The SDP type is an empty string in all other cases.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">CallType</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="AV" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all audio/video INVITE Requests.</form></li></ul></li>',2)),e("li",null,[t[14]||(t[14]=e("p",null,[e("code",null,"Target Address [is | is not | in | not in] string")],-1)),t[15]||(t[15]=e("p",null,[i("This condition checks if the Request URI is (or is not) equal to the specified "),e("em",null,"string"),i(".")],-1)),e("ul",null,[t[12]||(t[12]=l('<li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Target Address</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="sip:*@vm.communigatepro.ru" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all signals coming to on any vm.communigatepro.ru account.</form></li><li><p><code>From [is | is not | in | not in] string</code></p><p>This condition checks if the Request <code>From</code> address is (or is not) equal to the specified <em>string</em>.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">From</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="*@*communigatepro.ru" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all signals coming from any account of any of communigatepro.ru subdomains.</form></li></ul></li><li><p><code>To [is | is not | in | not in] string</code></p><p>The same as above, but the Request To field address is checked.</p></li>',3)),e("li",null,[t[10]||(t[10]=e("p",null,[e("code",null,"'From' Name [is | is not | in | not in] string")],-1)),t[11]||(t[11]=e("p",null,'The same as above, but the instead of the address, the "address comment" (the real name) included in the From address is checked.',-1)),e("ul",null,[e("li",null,[t[9]||(t[9]=e("p",null,"Sample:",-1)),e("form",h,[t[4]||(t[4]=l('<div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">&#39;From&#39; Name</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="*J. Smith*" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for Requests with the following ',2)),n(s,null,{default:o(()=>t[0]||(t[0]=[i("From:")])),_:1}),t[5]||(t[5]=i(" addresses:")),t[6]||(t[6]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[1]||(t[1]=[i("From: <sip:jsmith@company.com> (John J. Smith)")])),_:1}),t[7]||(t[7]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[2]||(t[2]=[i('From: "Bill J. Smith" <sip:b.smith@othercompany.com>')])),_:1}),t[8]||(t[8]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[3]||(t[3]=[i("From: Susan J. Smith <sips:susan@thirdcompany.com>")])),_:1})])])])]),t[13]||(t[13]=l('<li><p><code>Authenticated [is | is not | in | not in] string</code></p><p>This condition checks the Request authentication. If the Request has been authenticated by this CommuniGate Pro Server, the authenticated Account name (<code>account@domain</code>) is compared with the specified <em>string</em>.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Authenticated</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="*@*communigatepro.ru" size="35" maxlength="200"></td></tr></tbody></table></div>This condition will be met for all signals coming from any account on any of communigatepro.ru subdomains.</form></li></ul></li><li><p><code>Presence [is | is not | in | not in] string</code></p><p>This condition checks the aggregated presence of the request target. This condition can be used in the Domain- and Account- level Rules only.<br> The Presence is one of the strings <code>online</code>, <code>busy</code>, <code>away</code>. The Presence is an empty string when the call target is offline.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Presence</option></select></td><td><select name="o000000"><option value="0" selected="selected">in</option></select></td><td><input type="text" name="p000000" value="busy,away" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>Active Devices [is | is not | less than | greater than | in | not in] number-string</code></p><p>This condition checks the total number of Registered Devices for the request target. This condition can be used in the Domain- and Account- level Rules only.<br> When a call is forked to a different destination, the total number of Registered Device is increased by the number of registered devices for the new request target.<br> When a call is redirect to a different destination, the total number of Registered Device is reset to zero, and then it is increased by the number of registered devices for the new request target.</p></li><li><p><code>Device Type [is | is not | in | not in] string</code></p><p>This condition checks the type of device sending the request (the User-Agent request field).</p></li><li><p><code>Request Field [is | is not | in | not in] string</code></p><p>The <em>string</em> must contain the Request field name and the field data picture, separated with the colon (<code>:</code>) symbol. This condition compares the specified request field data with the data picture. Only simple, unstructured request fields can be compared.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Request Field</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="P-CGP-Private:special*data" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li>',5))])])]),t[18]||(t[18]=e("h2",{id:"Actions",tabindex:"-1"},[i("Rule Actions "),e("a",{class:"header-anchor",href:"#Actions","aria-label":'Permalink to "Rule Actions {#Actions}"'},"​")],-1)),t[19]||(t[19]=e("p",null,"Each Rule can have zero, one, or several actions. If a Request meets all the Rule conditions, the Rule actions are performed.",-1)),t[20]||(t[20]=e("p",null,[i("You can use all universal actions described in the "),e("a",{href:"./../../development/Rules.html#Actions"},"Rules"),i(" section. This section describes the Rule actions that can be used in Signal Rules:")],-1)),t[21]||(t[21]=e("ul",null,[e("li",null,[e("p",null,[e("code",null,"Stop Processing")]),e("p",null,"This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for this Signal at this time. Signal processing proceeds.")]),e("li",null,[e("p",null,[e("code",null,"Discard Rules")]),e("p",null,"This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for this Signal, and all remaining Rules (scheduled to apply at later times or if the Signal fails) are removed, too. Signal processing proceeds.")]),e("li",null,[e("p",null,[e("code",null,"Redirect to addresses")]),e("p",null,[i('The Signal is redirected to one or several specified addresses: the current Signal "destination set" is cleared, and the specified addresses form the new "destination set".'),e("br"),i(" Each address should be specified as a "),e("code",null,"sip:"),i(", "),e("code",null,"sips:"),i(", or "),e("code",null,"tel:"),i(" URI. If several addresses are specified, they should be separated with the comma ("),e("code",null,","),i(") sign."),e("br"),i(" To redirect the Signal into a "),e("a",{href:"./../../development/PBXApp.html"},"PBX application"),i(" you can use the address "),e("code",null,"#myProgram"),i(" to run the application "),e("code",null,"myProgram"),i(" on behalf of the Signal authenticated source.")]),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Operation")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"INVITE",size:"35",maxlength:"200"})])]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Authenticated")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"adManager@domain.com",size:"35",maxlength:"200"})])])])])]),e("br"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Redirect to")])]),e("td",null,[e("textarea",{name:"o000000",cols:"40",rows:"3"},"sip:adManager@domain.com")])])])])]),i("This Rule will direct all INVITE Signals to the adManager@domain.com address, unless the Signal authenticated source is adManager@domain.com."),e("br"),i("You can use this Rule to implement an advertising server: the adManager@domain.com Account can start a PBX application that will play some media to the caller, and then, acting as a B2BUA, will connect the caller with the original destination. The calls made by that application will have adManager@domain.com as their authenticated source, so this Rule will not redirect them.")])])])]),e("li",null,[e("p",null,[e("code",null,"Fork to addresses")]),e("p",null,[i("Same as "),e("code",null,"Redirect to"),i(', but the specified addresses are added to the current "destination set" without clearing it first.')])]),e("li",null,[e("p",null,[e("code",null,"ParlayDirect parameters")])]),e("li",null,[e("p",null,[e("code",null,"ParlayNotify parameters")]),e("p",null,[i('These actions implement the "CallDirection" and "CallNotification" '),e("a",{href:"./Parlay.html"},"ParlayX"),i(' Interfaces. The parameters setings specifies the request operation to use, the Parlay "correlator", and the URL to send the request to.')])])],-1)),t[22]||(t[22]=l('<h2 id="Macro" tabindex="-1">Macro Substitution <a class="header-anchor" href="#Macro" aria-label="Permalink to &quot;Macro Substitution {#Macro}&quot;">​</a></h2><p>Parameter strings for <a href="./../../development/Rules.html#SendURL">SendURL</a>, <a href="./../../development/Rules.html#SendIM">Send IM</a>, <a href="./../../development/Rules.html#SendPush">Send Push</a>, <a href="./../../development/Rules.html#WriteToLog">Write To Log</a> actions can include &quot;macro&quot; - symbol combinations that are substituted with actual data before the parameter is used with the Signal Rule action.</p><p>The following symbol combinations are available:</p><p><code>^F</code> is substituted with the request From address (including the &quot;Real name&quot; part, decoded and converted to UTF-8)<br><code>^E</code> is substituted with the request From address (the E-mail address only)<br><code>^t</code> is substituted with the RFC822-formatted current-time.<br><code>^I</code> is substituted with the request Call-ID.<br><code>^R</code> is substituted with the request To address (the E-mail address only)<br><code>^M</code> is substituted with the request Method.<br><code>^U</code> is substituted with the request URL.<br><code>^^</code> is substituted with a single <code>^</code> symbol.</p><h2 id="Log" tabindex="-1">Logging Rules Activity <a class="header-anchor" href="#Log" aria-label="Permalink to &quot;Logging Rules Activity {#Log}&quot;">​</a></h2><p>The <a href="./../cluster/Signals.html">Signal</a> component records system-wide Rules activity in the Log. Set the Signal Log Level to <code>Low-Level</code> or <code>All Info</code> to see the Rules checked and the actions executed.</p>',6))])}const S=a(c,[["render",p]]);export{y as __pageData,S as default};
