import{_ as a,C as d,c as r,o as u,ag as l,j as e,a as i,G as n,w as o}from"./chunks/framework.jCcxW76o.js";const y=JSON.parse('{"title":"Automated Signal Processing Rules","description":"","frontmatter":{"legacyLink":"SignalRules.html"},"headers":[],"relativePath":"admin/signals/SignalRules.md","filePath":"admin/signals/SignalRules.md"}'),c={name:"admin/signals/SignalRules.md"},h={action:"Null.html"};function p(m,t,g,f,b,R){const s=d("tt");return u(),r("div",null,[t[17]||(t[17]=l("",19)),e("ul",null,[t[16]||(t[16]=l("",2)),e("li",null,[t[14]||(t[14]=e("p",null,[e("code",null,"Target Address [is | is not | in | not in] string")],-1)),t[15]||(t[15]=e("p",null,[i("This condition checks if the Request URI is (or is not) equal to the specified "),e("em",null,"string"),i(".")],-1)),e("ul",null,[t[12]||(t[12]=l("",3)),e("li",null,[t[10]||(t[10]=e("p",null,[e("code",null,"'From' Name [is | is not | in | not in] string")],-1)),t[11]||(t[11]=e("p",null,'The same as above, but the instead of the address, the "address comment" (the real name) included in the From address is checked.',-1)),e("ul",null,[e("li",null,[t[9]||(t[9]=e("p",null,"Sample:",-1)),e("form",h,[t[4]||(t[4]=l("",2)),n(s,null,{default:o(()=>t[0]||(t[0]=[i("From:")])),_:1}),t[5]||(t[5]=i(" addresses:")),t[6]||(t[6]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[1]||(t[1]=[i("From: <sip:jsmith@company.com> (John J. Smith)")])),_:1}),t[7]||(t[7]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[2]||(t[2]=[i('From: "Bill J. Smith" <sip:b.smith@othercompany.com>')])),_:1}),t[8]||(t[8]=e("br",null,null,-1)),n(s,null,{default:o(()=>t[3]||(t[3]=[i("From: Susan J. Smith <sips:susan@thirdcompany.com>")])),_:1})])])])]),t[13]||(t[13]=l("",5))])])]),t[18]||(t[18]=e("h2",{id:"Actions",tabindex:"-1"},[i("Rule Actions "),e("a",{class:"header-anchor",href:"#Actions","aria-label":'Permalink to "Rule Actions {#Actions}"'},"​")],-1)),t[19]||(t[19]=e("p",null,"Each Rule can have zero, one, or several actions. If a Request meets all the Rule conditions, the Rule actions are performed.",-1)),t[20]||(t[20]=e("p",null,[i("You can use all universal actions described in the "),e("a",{href:"./../../development/Rules.html#Actions"},"Rules"),i(" section. This section describes the Rule actions that can be used in Signal Rules:")],-1)),t[21]||(t[21]=e("ul",null,[e("li",null,[e("p",null,[e("code",null,"Stop Processing")]),e("p",null,"This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for this Signal at this time. Signal processing proceeds.")]),e("li",null,[e("p",null,[e("code",null,"Discard Rules")]),e("p",null,"This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked for this Signal, and all remaining Rules (scheduled to apply at later times or if the Signal fails) are removed, too. Signal processing proceeds.")]),e("li",null,[e("p",null,[e("code",null,"Redirect to addresses")]),e("p",null,[i('The Signal is redirected to one or several specified addresses: the current Signal "destination set" is cleared, and the specified addresses form the new "destination set".'),e("br"),i(" Each address should be specified as a "),e("code",null,"sip:"),i(", "),e("code",null,"sips:"),i(", or "),e("code",null,"tel:"),i(" URI. If several addresses are specified, they should be separated with the comma ("),e("code",null,","),i(") sign."),e("br"),i(" To redirect the Signal into a "),e("a",{href:"./../../development/PBXApp.html"},"PBX application"),i(" you can use the address "),e("code",null,"#myProgram"),i(" to run the application "),e("code",null,"myProgram"),i(" on behalf of the Signal authenticated source.")]),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Operation")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"INVITE",size:"35",maxlength:"200"})])]),e("tr",null,[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Authenticated")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"adManager@domain.com",size:"35",maxlength:"200"})])])])])]),e("br"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Redirect to")])]),e("td",null,[e("textarea",{name:"o000000",cols:"40",rows:"3"},"sip:adManager@domain.com")])])])])]),i("This Rule will direct all INVITE Signals to the adManager@domain.com address, unless the Signal authenticated source is adManager@domain.com."),e("br"),i("You can use this Rule to implement an advertising server: the adManager@domain.com Account can start a PBX application that will play some media to the caller, and then, acting as a B2BUA, will connect the caller with the original destination. The calls made by that application will have adManager@domain.com as their authenticated source, so this Rule will not redirect them.")])])])]),e("li",null,[e("p",null,[e("code",null,"Fork to addresses")]),e("p",null,[i("Same as "),e("code",null,"Redirect to"),i(', but the specified addresses are added to the current "destination set" without clearing it first.')])]),e("li",null,[e("p",null,[e("code",null,"ParlayDirect parameters")])]),e("li",null,[e("p",null,[e("code",null,"ParlayNotify parameters")]),e("p",null,[i('These actions implement the "CallDirection" and "CallNotification" '),e("a",{href:"./Parlay.html"},"ParlayX"),i(' Interfaces. The parameters setings specifies the request operation to use, the Parlay "correlator", and the URL to send the request to.')])])],-1)),t[22]||(t[22]=l("",6))])}const S=a(c,[["render",p]]);export{y as __pageData,S as default};
