import{_ as s,c as i,o as a,ag as o,j as e,a as n}from"./chunks/framework.jCcxW76o.js";const P=JSON.parse('{"title":"XMPP Module","description":"","frontmatter":{"legacyLink":"XMPP.html"},"headers":[],"relativePath":"admin/signals/XMPP.md","filePath":"admin/signals/XMPP.md"}'),r={name:"admin/signals/XMPP.md"};function l(c,t,d,h,p,u){return a(),i("div",null,t[0]||(t[0]=[o('<h1 id="xmpp-module" tabindex="-1">XMPP Module <a class="header-anchor" href="#xmpp-module" aria-label="Permalink to &quot;XMPP Module&quot;">​</a></h1><p>The CommuniGate Pro XMPP Module implements the <a href="./../common/Features.html#XMPP">XMPP protocol</a> via TCP/IP networks.</p><p>The XMPP module implements the client-server XMPP protocol. The module allows end-user applications (XMPP clients) to log into the CommuniGate Pro Server and to execute <a href="./../cluster/Signals.html">Real-Time Signal</a> operations.</p><p>The XMPP module implements the server-server XMPP protocol. The module allows the remote XMPP systems (remote servers) to connect to the CommuniGate Pro Server, and it allows the CommuniGate Pro Server to connect to the remote XMPP systems, so they can exchange <a href="./../cluster/Signals.html">Real-Time Signal</a> requests and responses.</p><p>The module implements the basic <a href="./../common/Features.html#XMPP">XMPP protocol and its extensions (XEPs)</a>.</p><h2 id="Protocol" tabindex="-1">Extensible Messaging and Presence Protocol (XMPP) <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Extensible Messaging and Presence Protocol (XMPP) {#Protocol}&quot;">​</a></h2><p>The CommuniGate Pro XMPP Module implements the XMPP protocol functionality. It uses one <a href="./../network/Listener.html">TCP Listener</a> for both client-server and server-server connections, distinguishing them not by the port number the remote side connects to, but by the XML data transferred.<br> By default, the XMPP Module TCP Listener uses the plain-text ports 5222 and 5269 and the secure (TLS) port 5223.</p><p>When a client-server connection is established, the XMPP module authenticates a user, and creates a session for the user Account. It then sends the Real-Time Signals on that Account behalf.</p><p>When a server-server connection is established, the XMPP module receives XMPP requests, converts them into internal Real-Time Signals, and submits them to the Real-Time component for processing and further delivery. It also receives the Signals directed to it by the Real-Time component and delivers them to remote XMPP systems.</p><p>The XMPP Module maintains a separate queue for each target and source domain, i.e. there are different queues for requests to the target.dom Domain coming from addresses in the source1.dom and source2.dom domains.<br> The XMPP module tries to open a new TCP/IP connection for each queue. If a connection is established, it sends all enqueued requests (as XMPP XML stanzas). When all enqueued requests are sent, the module keeps the connection open waiting for new requests to be sent to this queue. If the connection stays idle for the specified period of time, the XMPP module closes it.</p><p>The XMPP <code>message</code> requests are sent as <code>MESSAGE</code> Real-Time requests, the XMPP <code>presence</code> requests are sent as <code>SUBSCRIBE</code> and <code>NOTIFY</code> Real-Time requests (using the <code>presence</code> Event package), the XMPP <code>iq</code> requests are sent as <code>INFO</code> Real-Time requests.<br> The XMPP request data beyond the basic information is sent as the <code>P-XMPP-Data</code> field data.</p><h2 id="ServerConfig" tabindex="-1">XMPP Server Settings <a class="header-anchor" href="#ServerConfig" aria-label="Permalink to &quot;XMPP Server Settings {#ServerConfig}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the XMPP module. Open the Real-Time pages page in the Settings realm, then open the XMPP pages.<br> Click the Receiving link to open the XMPP Server Settings.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="XMPPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td class="arrow" align="right"><a href="Listener.html">Listener</a></td><td align="right">Channels:</td><td><select name="XMPPChannels"><option value="0">off</option><option value="1">1</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100" selected="selected">100</option><option value="250">250</option><option value="500">500</option><option value="1000">1000</option><option value="5000">5000</option><option value="555">other</option></select></td></tr></tbody></table></div></form><p>Use the Log Level setting to specify what kind of information the XMPP module should put in the Server Log. Usually you should use the <code>Major</code> (message transfer reports) or <code>Problems</code> (message transfer and non-fatal errors) levels. But when you experience problems with the XMPP module, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case protocol-level or link-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.</p><p>The XMPP server records in the System Log are marked with the <code>XMPPI</code> tag.<br> If the remote party specifies that the connection is used for a client session (as opposed to server-to-server transfer), the System Log tag is changed to <code>XMPPS</code>.</p><p>System Log records for outgoing server-to-server XMPP connections are marked with the <code>XMPPO</code> tag.</p><p>When you specify a non-zero value for the <code>Channels</code> setting, the XMPP module creates a <a href="./../network/Listener.html">TCP listener</a>, and the module starts to accept XMPP connections from client applications and remote servers.<br> The setting is used to limit the number of simultaneous connections the XMPP module can accept. If there are too many incoming connections open, the module will reject new connections, and client applications and remote servers should retry later.</p><p>By default, the XMPP module Listener accepts clear text connections on the TCP port 5222 (&quot;client port&quot;) and 5269 (&quot;server port&quot;) and secure TLS connections on the TCP port 5223 (&quot;secure client port&quot;).<br> Follow the <a href="./../network/Listener.html">listener</a> link to tune the XMPP <a href="./../network/Listener.html">Listener</a>.</p><p>The XMPP module supports the <code>starttls</code> command; it allows client applications and remote servers to establish a connection in the clear text mode and then turn it into a secure connection.</p><p>The XMPP module supports all available <a href="./../sysadmin/Security.html#SASL">SASL</a> authentication methods. Additionally, the module supports the legacy Jabber authentication - plain text &quot;password&quot; and &quot;digest&quot;.<br> To disable the &quot;digest&quot; Jabber authentication method, you need to disable the CRAM-MD5 method for the target Domain.</p><h2 id="ClientConfig" tabindex="-1">XMPP Client Settings <a class="header-anchor" href="#ClientConfig" aria-label="Permalink to &quot;XMPP Client Settings {#ClientConfig}&quot;">​</a></h2><p>Use the WebAdmin Interface to configure the XMPP module. Open the Real-Time pages page in the Settings realm, then open the XMPP pages.<br> Click the Sending link to open the XMPP Client Settings.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td align="right">Log Level:</td><td><select name="XMPPLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="RIGHT">Idle Timeout:</td><td><select name="IdleTimeout"><option value="0">0 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120" selected="selected">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="21600">6 hour(s)</option><option value="28800">8 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="86400">24 hour(s)</option><option value="121">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log Level</code></p><p>This is the same setting as seen on the <a href="#ServerConfig">XMPP Server Settings</a> page.</p></li><li><p><code>Source IP Address</code></p><p>This option selects the default <em>source network address</em> for outgoing XMPP connections. You can allow the server OS to select the proper address or your can explicitly select one of the server IP addresses as the default source network address.</p></li><li><p><code>Use Domain IP Addresses</code></p><p>This option selects <em>source network addresses</em> for outgoing XMPP connections. If this option is selected, the XMPP Module will use the first Assigned IP Address of the sender&#39;s Domain, if the Domain Assigned IP Addresses can be used for outgoing connections.<br> If this option is not selected, or if the sender&#39;s Domain does not have any Assigned IP Address, the XMPP Module uses the default <em>source network address</em>.</p></li><li><p><code>Idle Timeout</code></p><p>Use this setting to specify how long the XMPP module should keep an outgoing connection open if it has no data to be sent to a remote server.</p></li></ul><h3 id="Secure" tabindex="-1">Secure (encrypted) Relaying <a class="header-anchor" href="#Secure" aria-label="Permalink to &quot;Secure (encrypted) Relaying {#Secure}&quot;">​</a></h3><p>You can configure your CommuniGate Pro Server XMPP module to use secure (encrypted) connections when relaying IM and presence data to certain remote sites. This feature is especially useful if your company has several offices and the traffic between the offices is sent via the public Internet.</p><p>You should simply list the domain names that should receive IM/Presence information from your server via secure connections:</p>',28),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Send Encrypted (SSL/TLS)")])]),e("tr",{valign:"top"},[e("td",{align:"right"},[n("to Domains:"),e("br"),n("(high security)")]),e("td",null,[e("textarea",{name:"SecureHosts",rows:"3",cols:"50"},"office*.company.com,partnercompany.com,!badserver.org")])]),e("tr",{valign:"top"},[e("td",{align:"right"},[e("input",{name:"AlwaysTrySecure",value:"1",type:"checkbox",checked:"checked"})]),e("td",null,"wherever possible (low security)")])])])])],-1),o('<p>The specified names can contain a wildcard - the asterisk (<code>*</code>) symbol.</p><p>When the CommuniGate Pro XMPP module connects to a relay of one of the listed domains, it checks if that relay supports the <code>starttls</code> protocol command. Then the XMPP module uses this command to initiate a secure connection with that relay.</p><p>The CommuniGate Pro XMPP module checks the validity of the remote relay Certificate using the specified set of the <a href="./../sysadmin/PKI.html#Trusted">Trusted Certificates</a>.<br> The remote relay Certificate <em>subject</em> must contain the <code>cn</code> (<em>Common Name</em>) field that matches either the domain name of the remote site, or the name of this relay. This can often cause a problem, since the domain <code>company.dom</code> may have the SRV record <code>xmpp.company.dom</code>, but the computer with the <code>xmpp.company.dom</code> address has the &quot;main&quot; DNS name <code>server.company.dom</code> and its Certificate is issued to that name (its Certificate <em>subject</em> contains <code>server.company.dom</code> in the <code>cn</code> field).</p><p>To solve this problem, you should explicitly route all traffic to the <code>company.dom</code> domain via the <code>server.company.dom</code> relay, using the following <a href="./../sysadmin/Router.html">Router</a> record:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>NoRelay:company.dom = company.dom@server.company.dom._via</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This feature ensures that information sent from your server to the remote relay is transferred securely. To provide complete end-to-end security, you should verify that:</p></div><ul><li>users submit data to servers either using a private network, or using TLS/SSL connections over the public Internet;</li><li>all XMPP/SIP servers and relays exchange messages either using a private network, or using TLS/SSL connections over the public Internet;</li><li>users receive data either using a private network, or using TLS/SSL connections over the public Internet.</li></ul><p>If the domain is listed in the Send Secure To Domains list, and the receiving server does not support the <code>starttls</code> command, or the remote server certificate cannot be validated, or the remote server certificate Subject does not match the domain or domain relay name, all Signals sent to that domain are <strong>rejected</strong>, ensuring that no data is sent via a potentially insecure link.</p><ul><li><p><code>wherever possible</code></p><p>Select this option if you want the XMPP module to try to use SSL/TLS connections with all remote XMPP servers that support this feature. If the remote domain is <strong>not</strong> listed in the Send Secure To Domains list, but the remote server supports the <code>starttls</code> command, the XMPP module tries to establish a secure (SSL/TLS) connection with that server.<br> The module does not check the remote server Certificate validity or the Certificate Subject in this case. If the <code>starttls</code> command or secure connection negotiations fail, the server defaults back to plain-text communication and sends data via an unencrypted channel.<br> Some servers advertise <code>starttls</code> support, but fail to accept SSL/TLS connections. When this option is selected, it is impossible to send Signals to those servers. To solve this problem, inform the broken server administrator, and enter the server domain into the Send Secure To Domains list, prefixed with the exclamation point (<code>!</code>) symbol. The XMPP module will not try to use SSL/TLS connections with that server/domain.</p></li></ul><h2 id="Monitoring" tabindex="-1">Monitoring XMPP Activity <a class="header-anchor" href="#Monitoring" aria-label="Permalink to &quot;Monitoring XMPP Activity {#Monitoring}&quot;">​</a></h2><p>The Monitors realm of the <a href="./../sysadmin/">WebAdmin Interface</a> allows Server Administrators to monitor the XMPP module activity.</p><p>Click the Real-time link in the Monitors realm to open the XMPP Monitoring page. This page has the same format as the <a href="./../access/IMAP.html#Monitoring">IMAP Monitoring</a> WebAdmin page.</p><h2 id="Registration" tabindex="-1">Registration <a class="header-anchor" href="#Registration" aria-label="Permalink to &quot;Registration {#Registration}&quot;">​</a></h2><p>The XMPP module implements the XEP-0077 extension (registration and password changes).</p><p>The <a href="./../objects/Domains.html#AutoSignup">Auto Signup</a> option allows users to &#39;register&#39; (to create Accounts for themselves).</p><p>If the <a href="./../objects/Accounts.html#Passwords">Allow to Modify</a> Password option is enabled, the users can modify their passwords themselves.</p><h2 id="Chatroom" tabindex="-1">Chat Rooms <a class="header-anchor" href="#Chatroom" aria-label="Permalink to &quot;Chat Rooms {#Chatroom}&quot;">​</a></h2><p>The XEP-0045 extension (Multi-User Chat) is implemented outside the XMPP module itself, using the <a href="./../../development/CGPL.html">CG/PL</a> <code>chatroom</code> <a href="./../objects/NamedTasks.html#Chatroom">Named Task</a>.</p><p>The Named Task is started automatically when the first user tries to access it. The Named Task receives all Instant Message and Presence requests sent to it from various clients (XMPP, XIMSS, other Tasks, etc.), and distributes these Signal requests to the room participants.</p><h2 id="Components" tabindex="-1">Components <a class="header-anchor" href="#Components" aria-label="Permalink to &quot;Components {#Components}&quot;">​</a></h2><p>The XMPP module implements the XEP-0114 extension (Jabber Component Protocol). It allows &quot;trusted components&quot; to connect to the CommuniGate Pro XMPP module. Usually these &quot;trusted components&quot; are external servers acting as gateways to some other IM/Presence networks.</p><p>Use the WebAdmin Interface to open the Receiving page in of the XMPP Module Settings.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Protocol</b></td></tr></tbody><tbody><tr><td align="RIGHT">Component Password:</td><td><input size="30" maxlength="64" name="ComponentPassword" value="********" type="text"></td></tr></tbody></table></div></form><ul><li><p><code>Component Password</code></p><p>Use this field to set a password (&quot;shared secret&quot;) string. When &quot;trusted components&quot; connect to the XMPP module, they must present this password in order to establish a connection.</p></li></ul><p>The &quot;trusted components&quot; specify the domain name they are serving. The XMPP Module accepts all Signal addresses routed to any domain specified by any &quot;trusted component&quot; and it relays these Signals to the &quot;trusted component&quot; via the extablished XMPP connection.<br> If, for example, a &quot;trsuted component&quot; has connected to the XMPP Module to serve the icq.company.dom domain, then all Signal requests directed to any address in the icq.company.dom domain is accepted with the XMPP module, and it delivers the Signal request to this &quot;trusted component&quot; (which is likely to be a gateway to the ICQ network).</p><h2 id="SupplItems" tabindex="-1">Supplementary Discovery Items <a class="header-anchor" href="#SupplItems" aria-label="Permalink to &quot;Supplementary Discovery Items {#SupplItems}&quot;">​</a></h2><p>The XMPP module allows you to specify additional XMPP entities (domains, JIDs, resources) that are returned when the &#39;item discovery&#39; request is sent to the Server or to any of the Server Domains. These items are returned together with the list of all chatrooms and registered Components.</p><p>You may want to use this feature to add the commonly-used external Gateways and Chatrooms to the &#39;item discovery&#39; lists retrieved with the XMPP and XIMSS clients.</p><p>Use the WebAdmin Interface to open the Receiving page in of the XMPP Module Settings.</p><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Supplementary &#39;Discovery&#39; Items</b></td></tr></tbody><tbody><tr><td align="center"><input maxlength="1000" size="60" name="SupplDiscoItems" value="conference.jabber.org" type="text"></td></tr><tr><td align="center"><input maxlength="1000" size="60" name="SupplDiscoItems" value="room@domain1.dom" type="text"></td></tr><tr><td align="center"><input maxlength="1000" size="60" name="SupplDiscoItems" value="gateways.dom" type="text"></td></tr><tr><td align="center"><input maxlength="1000" size="60" name="SupplDiscoItems" value="" type="text"></td></tr></tbody></table></div><p>To add a new item, enter its name into the last, empty field and click the Update button.<br> To remove an item, delete its name, and click the Update button.</p>',31)]))}const g=s(r,[["render",l]]);export{P as __pageData,g as default};
