import{_ as o}from"./chunks/SignalScheme.BkxABKcO.js";import{_ as t,c as i,o as n,ag as a}from"./chunks/framework.jCcxW76o.js";const g=JSON.parse('{"title":"Real-Time Signals","description":"","frontmatter":{"legacyLink":"Signals.html"},"headers":[],"relativePath":"admin/signals/index.md","filePath":"admin/signals/index.md"}'),s={name:"admin/signals/index.md"};function l(r,e,p,c,d,u){return n(),i("div",null,e[0]||(e[0]=[a('<h1 id="real-time-signals" tabindex="-1">Real-Time Signals <a class="header-anchor" href="#real-time-signals" aria-label="Permalink to &quot;Real-Time Signals&quot;">​</a></h1><p>One of the main functions of the CommuniGate Pro Server is Real-time communication. Acting as a Signaling Center, the Server receives Real-Time Signals (Requests) from various sources (the SIP and XMPP Modules, sessions, &quot;call legs&quot;, internal kernel components, etc.)<br> The CommuniGate Pro Server either processes (terminates) these Requests itself, or it delivers them to remote entities (via the SIP or XMPP protocol), or it delivers them to internal sessions and &quot;call legs&quot;.</p><p>For each Requests, the Signal module optionally generates some <em>provisioning</em> Responses (such as &quot;Trying&quot; or &quot;Ringing&quot;), and one <em>final</em> Response.</p><h2 id="AOR" tabindex="-1">AORs <a class="header-anchor" href="#AOR" aria-label="Permalink to &quot;AORs {#AOR}&quot;">​</a></h2><p>Users configure their devices (IP phones, AV conferencing tools, Instant Messaging tools) to connect to a selected Server when they go on-line.</p><p>Each user has a unique &quot;XMPP identifier&quot; or &quot;SIP identifier&quot;, also called AOR (Address of Record).</p><p>For session-less protocols such as SIP, the Server registers the users by remembering their &quot;SIP identifier&quot; and the network (IP) addresses they use.</p><p>Each user may have several <em>registrations</em> active if that user has several communication devices in the on-line mode (an office IP Phone, a desktop computer, an instant messaging program on a laptop, etc.)</p><p>Registrations allow SIP users to communicate with each other without the knowledge of the network addresses being used, using just the &quot;SIP identifiers&quot; (AORs).</p><p>AORs have the same form as E-mail addresses: <code>username@domainName</code>. The CommuniGate Pro user AOR is the full name of the user Account, so the user SIP AOR name is exactly the same as the user E-mail address.</p><p>CommuniGate Pro uses the <a href="./../sysadmin/Router.html">Router</a> component for all Real-Time Communication operations, so Aliases, <a href="./../objects/Forwarders.html">Forwarders</a>, and other Routing methods work for Real-Time Communications, too.</p><h2 id="Signal" tabindex="-1">Signals <a class="header-anchor" href="#Signal" aria-label="Permalink to &quot;Signals {#Signal}&quot;">​</a></h2><p>A Signal is a basic Real-time Task. One Real-time entity can send Signals to some other Real-time entity to start, modify, or stop a communication dialog, to deliver a status update, etc.</p><p>The sending entity composes a Request object and sends it to the CommuniGate Pro Signal module. The Signal module processes the Request, optionally sends Requests to other entities, and returns a Response object to the sending entity.</p><p>Many CommuniGate Pro modules and components can use Signals:</p><ul><li>The <a href="./SIP.html">SIP Module</a> server subcomponent receives Requests from external Real-time entities (SIP clients, other SIP Servers) using the SIP protocol. When the Signal Module generates a Response object, the SIP Module sends the response back to the external entity.</li><li>The <a href="./XMPP.html">XMPP Module</a> and <a href="./../access/XIMSS.html">XIMSS Module</a> send and receive Signal Requests and Responses, and transfer them between the client application and the CommuniGate Pro Server.</li><li>Internal <a href="#Nodes">Real-time Node</a>, such as <a href="./../../development/PBXApp.html">Real-Time Application</a> nodes (such as PBX applications) can send various Signal requests.</li><li><a href="./../../development/Rules.html">Automated Processing Rules</a> can use Signals (to send Instant Messages as notifications).</li></ul><h2 id="Processing" tabindex="-1">Processing Requests <a class="header-anchor" href="#Processing" aria-label="Permalink to &quot;Processing Requests {#Processing}&quot;">​</a></h2><p>When the Signal Module receives a Request, it calculates the target URI for it. It takes the Request URI (or the first Route URI in the Request Route set), and uses the <a href="./../sysadmin/Router.html">Router</a> component to detect the Request destination. There are several possible outcomes of this process:</p><ul><li>The Router returned an error code (for example, the Request URI addressed a local Account that does not exist). This error code is returned to the Signal source, and processing stops.</li><li>The Router returned a non-local address (an address in a non-local Domain). The Request is passed to the <a href="./SIP.html">SIP Module</a> for relaying. The Response returned with the SIP module is passed to the Signal source.</li><li>The Router returned an address of a local internal <a href="#Nodes">Real-time Node</a>. The Request is passed to that Node for processing. The Response returned with the Node is passed to the Signal source.</li><li>The Router returned a local Account address, and the Request can be processed with the Signal Module itself. The Request is processed, and the Response is returned to the Signal source. This case includes REGISTER-type Requests and other Requests which URIs target local Domains.</li><li>The Router returned a local address, and the Request cannot be processed with the Signal Module itself. The <a href="#Forking">Forking process</a> starts with the Request URI as the initial AOR set.</li><li>The Router returned the <code>null</code> address. The OK code is returned to the Signal source without further processing.</li></ul><p>The following diagram illustrates the Signal flow inside the CommuniGate Pro Server:</p><p><img src="'+o+'" alt="Signal Scheme"></p><h2 id="Rules" tabindex="-1">Automated Processing (Rules) <a class="header-anchor" href="#Rules" aria-label="Permalink to &quot;Automated Processing (Rules) {#Rules}&quot;">​</a></h2><p>After an address has been processed with the Router, but before it was relayed to a local or a remote entity, Server-wide and Cluster-wide <a href="./../signals/SignalRules.html">Automated Signal Processing Rules</a> are applied.</p><p>The Rules control how the Request is processed: they can direct it to a different destination, or they can reject the Request.</p><p>Only the Dialog-initiating Requests are processed with the Automated Rules.</p><h2 id="Forking" tabindex="-1">Forking <a class="header-anchor" href="#Forking" aria-label="Permalink to &quot;Forking {#Forking}&quot;">​</a></h2><p>The Signal module maintains the AOR (Address-of-Record) and Contact sets for each Request it processed. The module starts the Forking process by processing addresses in the AOR set.</p><p>When a 2xx response is received while processing any AOR, AOR processing stops. If the Request was an INVITE request, all outstanding Requests relayed to other AORs are canceled.</p><p>When all AORs have been processed, the module returns the &quot;best&quot; processing result to the Request source.</p><p>When an AOR to be processed is <a href="./../sysadmin/Router.html">Routed</a> to a non-local address, that address is placed into the Contact set.</p><p>When an AOR to be processed is <a href="./../sysadmin/Router.html">Routed</a> to a local Group, all Group members are added to the AOR set.</p><p>When an AOR to be processed is <a href="./../sysadmin/Router.html">Routed</a> to a local Account, all Account active <em>Registrations</em> (registered addresses of the Account user devices) are added to the Contact set.</p><p>If an AOR already exists in the AOR set, it is not added to the AOR set.</p><p>If an address already exists in the Contact set, it is not added to the Contact set.</p><p>The Signal module checks each address it adds to the Contact set.<br> If the new Contact address is a <a href="#Nodes">Local Node</a> address, the Request is passed to that Node for processing.<br> If the new Contact address is an external address, the Request is passed to the SIP Module for relaying.</p><p>When a local or an external entity returns a redirect-type Response, the module checks the initial AOR (the Request URI).</p><ul><li>If the initial AOR was Routed to a local Account or Group, the addresses specified in the redirect-type Response are added to the AOR set and the Forking process continues.</li><li>If the initial AOR was Routed to a remote address, the redirect-type Response is returned to the Request source.</li></ul><h2 id="Config" tabindex="-1">Configuring the Signal Component <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring the Signal Component {#Config}&quot;">​</a></h2><p>You can use the WebAdmin Interface to configure the Signal component. Open the Real-Time pages in the Settings realm, then open the Signals page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="TempFilesLogLevel"><option value="0">Crashes Only</option><option value="1" selected="selected">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td>Processors: <select name="Processors"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">other</option></select></td><td>Object Limit: <select name="XT"><option value="1">30</option><option>100</option><option>300</option><option>500</option><option selected="selected">1000</option><option>2000</option><option>5000</option><option>10000</option><option>30000</option><option>100000</option><option value="2222">other</option></select></td><td>Event Limit: <select name="XT1"><option value="1">30</option><option>100</option><option selected="selected">300</option><option>500</option><option>1000</option><option>2000</option><option>5000</option><option>10000</option><option>30000</option><option value="2222">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Signal component should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable problems only), <code>Major</code> (Signal progress reports), or <code>Problems</code> (failures, progress reports, and non-fatal errors) levels.<br> When you experience problems with the Signal component, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case the signal processing internals will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The Signal component records in the System Log are marked with the <code>SIGNAL</code> tag.</p></li><li><p><code>Processors</code></p><p>The Signal component uses several simultaneous processors (threads) to process Signal &quot;tasks&quot;. One processor can handle several Signal tasks. If you use many time-consuming <a href="./SignalRules.html">Automated Rules</a>, you should allow the component to use more processors for signal processing.</p></li><li><p><code>Object Limit</code></p><p>This setting specifies how many Signal &quot;tasks&quot; the component can handle at any given time.<br> If this limit is exceeded, new Signals are rejected, and an error is returned to the Signal sender.</p></li><li><p><code>Event Limit</code></p><p>This setting specifies the critical number of unprocessed events sent to all active Signal &quot;tasks&quot;.<br> If this number is exceeded, the component is overloaded (the component Processors cannot handle events as they appear), new Signals are rejected, and an error is returned to the event sender.</p></li></ul><p>Use the Signal Task panel to configure Signal processing by Signal Tasks.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Signal Task</b></td></tr><tr><td align="right">AOR Limit:</td><td><select class="popup" name="AORLimit"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="31">other</option></select></td><td align="right">Time Limit:</td><td><select class="popup" name="TimeLimit"><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900" selected="selected">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400">24 hour(s)</option><option value="901">other</option></select></td></tr><tr><td align="right">Active Fork Limit:</td><td><select class="popup" name="ForkLimit"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="31">other</option></select></td><td align="right"> </td><td><input type="checkbox" name="AuthAllINVITEs" value="1" checked="checked"> Authenticate all outgoing calls</td></tr></tbody></table></div></form><ul><li><p><code>AOR Limit</code></p><p>This setting limits the number of AORs that can be processed for a single operation. It limits the total number of forks, redirects, etc. for a single request.</p></li><li><p><code>Active Fork Limit</code></p><p>This setting limits the number of concurrent forks for a single request.</p></li><li><p><code>Time Limit</code></p><p>This setting specifies the default time limit for request processing.</p></li><li><p><code>Authenticate all outgoing calls</code></p><p>The CommuniGate Pro Server requires user authentication for certain Requests:</p><ul><li>when requests are sent remotely via SIP, authentication is performed with the <a href="./SIP.html#ServerConfig">SIP module</a> server component</li><li>the <a href="./../access/XIMSS.html">XIMSS</a> and <a href="./XMPP.html">XMPP</a> modules send all Signals authenticated, on behalf of the logged-in Account</li><li>the <a href="./../../development/PBXApp.html">Real-Time Applications</a> send Signals authenticated, on behalf of their <em>current Account</em> (unless the Application has impersonated as &quot;nobody&quot;)</li></ul><p>This option requires authentication for all calls (initial INVITE requests) send from this Server Account addresses.</p><p>When a call-type Signal (an initial INVITE request with audio-video Session Descriptor) is authenticated, the Signal Module performs additional processing of the authenticated Account.</p><p>The Signal component can limit the number of &quot;calls&quot; an Account can place over a specified period of time. If more calls are placed, they are rejected without processing.<br> This limit can be set individually, for each Account, or server/cluster-wide as well as Domain-wide default settings can be used. See the <a href="./../objects/Accounts.html#Signal">Accounts</a> section for more details.</p></li></ul><h2 id="Account" tabindex="-1">Sending Signals to Accounts <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Sending Signals to Accounts {#Account}&quot;">​</a></h2><p>If the first AOR in the set (the AOR specified in the Request URI) is a local Account address, and the Request is an INVITE request, the Account device registration is retrieved, along with certain Account settings and preferences.</p><p>An Account can have <a href="./SignalRules.html">Automated Signal Rules</a>, which are retrieved with Account device registrations. These Rules are &quot;mixed&quot; with the Domain-wide Rules specified for the Account Domain and are applied to all requests sent to the Account.</p><p>The Signal component controls how many &quot;calls&quot; (initial INVITE requests with audio-video Session Descriptors) an Account receives over a specified period of time. If more calls are received, they are rejected without processing.<br> This limit can be set individually, for each Account, or server/cluster-wide as well as Domain-wide default settings can be used. See the <a href="./../objects/Accounts.html#Signal">Accounts</a> section for more details.</p><h2 id="Remote" tabindex="-1">Sending Signals to Remote Systems <a class="header-anchor" href="#Remote" aria-label="Permalink to &quot;Sending Signals to Remote Systems {#Remote}&quot;">​</a></h2><p>If a Signal is to be relayed to a remote system, the Signal component directs it to some signaling module.</p><p>The Signal target address can be explicitly routed to some module. For example, all domains with the <code>._xmpp</code> suffix are routed to the <a href="./XMPP.html">XMPP</a> module.</p><p>If the Signal target address is not explicitly routed to some module, the Signal component check the target domain name</p><ul><li>If the domain name is an IP address, the Signal is routed to the <a href="./SIP.html">SIP</a> module.</li><li>If the domain name has SIP SRV records in the DNS, the Signal is routed to the <a href="./SIP.html">SIP</a> module.</li><li>If the domain name has XMPP SRV records in the DNS, the Signal is routed to the <a href="./XMPP.html">XMPP</a> module.</li><li>In all other cases the Signal is routed to the <a href="./SIP.html">SIP</a> module.</li></ul><h2 id="ServiceCalls" tabindex="-1">Service Calls <a class="header-anchor" href="#ServiceCalls" aria-label="Permalink to &quot;Service Calls {#ServiceCalls}&quot;">​</a></h2><p>If a Request is routed to a <code>*nnnn</code> name in any of the local <a href="./../objects/Domains.html">Domains</a> (where <em>nnnn</em> is any sequence starting with a decimal digit), the Request is rerouted to its originator (the Request <code>From:</code> address).</p><p>This feature allows users to dial a <code>*nnnn</code> number to request a service from the Server. The Request is routed to the user&#39;s own Account, where it starts the Self-Call application. The application provides the requested service using the Request <code>To:</code> address to learn the dialed &quot;service option&quot; number.</p><h2 id="Registrar" tabindex="-1">Registrar Services <a class="header-anchor" href="#Registrar" aria-label="Permalink to &quot;Registrar Services {#Registrar}&quot;">​</a></h2><p>Communication devices used by CommuniGate Pro users should register themselves before they can receive Requests from other entities.</p><p>Registration Requests require user authentication.</p><p>One <a href="./../objects/Accounts.html">Account</a> credentials can be used to modify registrations for a different Account, if the authenticated Account has the <a href="./../sysadmin/#DomainPrivs">CanImpersonate</a> access right for the target Account Domain.</p><p>To configure the Registrar Service options, open the Real-Time pages in the WebAdmin Settings realm, and select the Signals page.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Services</b></td></tr><tr><td rowspan="2">Registration Time:</td><td align="right">Minimal:</td><td><select name="MinRegister"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30" selected="selected">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="31">other</option></select></td><td align="right">Default:</td><td><select name="DefaultRegister"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800" selected="selected">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="1801">other</option></select></td><td align="right">Maximal:</td><td><select name="MaxRegister"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400" selected="selected">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="86401">other</option></select></td></tr><tr><td align="right">Random delta:</td><td><select name="MinRegister"><option value="0" selected="selected">0 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="15">15 sec</option><option value="30">30 sec</option><option value="60">60 sec</option><option value="120">2 min</option><option value="300">5 min</option><option value="31">other</option></select></td><td colspan="4"> </td></tr><tr><td>MS RTC:</td><td align="right">Integrate with Roster:</td><td><select name="RTCRoster"><option value="0" selected="selected">Disabled</option><option value="1" selected="selected">Enabled</option></select></td><td colspan="2"></td></tr></tbody></table></div></form><ul><li><p><code>Registration: Minimal</code></p><p>Use this option to specify the minimal Registration expiration time period accepted.<br> If a Registration Request contains a shorter expiration time, the Request is rejected, and the Response sent specifies this minimal accepted time. The entity (usually - a SIP device) can resend the Registration Request with an adjusted expiration time.</p></li><li><p><code>Registration: Default</code></p><p>This option value is used when a Registration Request does not specify a Registration expiration time.</p></li><li><p><code>Registration: Maximal</code></p><p>Use this option to specify the maximal Registration expiration time period accepted.<br> If a Registration Request contains a longer expiration time period, the period is shorten to the specified value.</p></li><li><p><code>Registration: Random delta</code></p><p>If this option is set to a non-zero value X, the requested Registration expiration time period is decreased by a random value, from 0 to X.<br> Large sites can use this feature to soften &quot;registration storms&quot;, when a large number of devices starts to register at the same time (after a network failure or a maintenance window).<br> The requested expiration time period is decreased only if it is larger than <code>2*X</code> and larger than <code>Minimal+X</code>.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Registrar component supports the SIP <code>gruu</code> (Globally Routable User Agent (UA) URIs) extensions.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Clients that use for registration domain names starting with <code>srtp.</code> or <code>dtls.</code> prefixes are marked as ones expecting secure media offers in incoming calls. Alternatively, if <a href="./LOCAL.html#RouteSettings">Account Detail</a> is enabled on the server and authentication name during registration contained as detail string <code>srtp</code> or <code>dtls</code>, then the Client will also be offered secure media on incoming calls.</p></div><h2 id="Events" tabindex="-1">Event Packages <a class="header-anchor" href="#Events" aria-label="Permalink to &quot;Event Packages {#Events}&quot;">​</a></h2><p>The Signal Module supports several Event Packages. When it receives a SUBSCRIBE Request targeting a local Account, it may process the Request itself, without forwarding it to the Account registered entities.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>As a workaround for many buggy clients, the Module accepts SUBSCRIBE Requests sent to local Domains (instead of local Accounts). For these requests, the address in the <code>To</code> field is used to replace the domain-type address in the Request URI.</p></div><p>The Signal module maintains &quot;tuple&quot; states for each Account, for each Event Package it supports. The module allows one or several entities to update the &quot;tuples&quot;, and it aggregates them into one Account &quot;state information&quot; for the Package. When the aggregated &quot;state information&quot; changes, the module sends NOTIFY requests with the updated state to all subscribed entities.</p><p>The Signal module allows external entities to modify &quot;tuples&quot; using PUBLISH requests.</p><p>The Signal module allows external entities to modify &quot;tuples&quot; for certain Packages using non-standard SERVICE requests.</p><p>The Signal module provides &quot;watcher&quot; packages for all Event Packages. These packages provide the information about current subscribers to the &quot;base&quot; Event packages. &quot;Watcher of watcher&quot; packages are implemented, too.</p><p>Unless explicitly specified otherwise, subscription to a Account Event package is available only to the Account owner, to other Accounts with the <code>CanImpersonate</code> <a href="./../sysadmin/#DomainPrivs">Access Right</a> for the Account Domain, and to other Accounts that have the Delegate <a href="./../objects/Accounts.html#AccessRights">Account Access Right</a> for this Account.<br> The same restrictions are applied to subscriptions to all &quot;watcher&quot; packages.</p><h3 id="Presence" tabindex="-1">Presence <a class="header-anchor" href="#Presence" aria-label="Permalink to &quot;Presence {#Presence}&quot;">​</a></h3><p>The Signal Module implements a Presence Server. The Module supports the <code>PIDF</code>, <code>CPIM-PIDF</code> and <code>XPIDF</code> Presence Information formats.</p><p>The Signal Module provides special processing for the REGISTER requests. If an external entity (a SIP device) indicates support for the SUBSCRIBE method, the module establishes a presence subscription dialog with that entity.<br> The module then processes all NOTIFY requests sent by that entity to maintain its Presence &quot;tuple&quot; or &quot;segment&quot;.</p><p>A Presence segment value is a string from a fixed set, listed here starting from the lowest priority value to the highest priority one:</p><ul><li><code>offline</code></li><li><code>away</code></li><li><code>out-lunch</code></li><li><code>in-meeting</code></li><li><code>be-back</code></li><li><code>online</code></li><li><code>on-phone</code></li><li><code>busy</code></li></ul><p>The event aggregated value is a segment value with the highest priority, or <code>offline</code> if no segment exists.</p><p>When a NOTIFY request is composed, the aggregated value is converted into a presence document in one of the supported formats.</p><p>Subscription to the Event package is available to anyone, subject to the standard subscription approval process.</p><h3 id="MessageSummary" tabindex="-1">Message Summary <a class="header-anchor" href="#MessageSummary" aria-label="Permalink to &quot;Message Summary {#MessageSummary}&quot;">​</a></h3><p>The Signal Module implements the MWI (Message Waiting Indication) Service. The Module supports the <code>simple-message-summary</code> Information format.</p><p>The Server itself maintains the &quot;INBOX&quot; tuple/segment for this Event package. The segment value is set to an <a href="./../../development/Data.html">array</a>:</p><ul><li>the first element is the number of INBOX messages that have the $Media flag set and do not have the Seen flag set (the number of unread media messages);</li><li>the second element is the number of INBOX messages that have the $Media flag set (the total number of media messages);</li></ul><p>The event aggregated value is an array containing the by-element sum of all segment array values.</p><p>When a NOTIFY request using the <code>simple-message-summary</code> Information format is composed, the first aggregated array element value is used as the number of new voice messages, and the difference between the second and the first elements is used as the number of old voice messages.<br> If the first array element value is not zero, the <code>Messages-Waiting</code> element is set to <code>yes</code>, otherwise it is reset to <code>no</code>.</p><h3 id="Registration" tabindex="-1">Registration <a class="header-anchor" href="#Registration" aria-label="Permalink to &quot;Registration {#Registration}&quot;">​</a></h3><p>The Signal Module implements the Registrar Monitoring Service. The Module supports the <code>reginfo+xml</code> Information format, and it can inform network entities (such as SIP clients) about all other entities registered with an Account.</p><h3 id="DialogPackage" tabindex="-1">Dialog <a class="header-anchor" href="#DialogPackage" aria-label="Permalink to &quot;Dialog {#DialogPackage}&quot;">​</a></h3><p>The Signal Module implements the Dialog Monitoring Service. The Module supports the <code>dialog-info+xml</code> Information format, and it can inform network entities (such as SIP clients) about all dialogs active with an Account.</p><p>Subscription to the Dialog package is available to the Account owner, to other Accounts with the <code>CanControlCalls</code> <a href="./../sysadmin/#DomainPrivs">Domain Access Right</a>, and to other Accounts with the CallControl <a href="./../objects/Accounts.html#AccessRights">Access Right</a> granted by with Account owner.</p><h2 id="Calls" tabindex="-1">Calls <a class="header-anchor" href="#Calls" aria-label="Permalink to &quot;Calls {#Calls}&quot;">​</a></h2><p>The CommuniGate Pro Server creates Call objects when processing call-starting INVITE requests. Call objects contain information about the calls initiated with these requests.<br> Call objects are destroyed when these calls are terminated.</p><p>If the caller is authenticated, the call status is recorded in the caller Account data, and a <a href="#CDR">CDR</a> record is generated. When a call is completed, an accounting record for this outgoing call is added to the caller <a href="#CallLogs">call log</a>.</p><p>If the call target (callee) is authenticated, the call status is recorded in the callee Account data, and a <a href="#CDR">CDR</a> record is generated. When a call is completed, an accounting record for this incoming call is added to the callee <a href="#CallLogs">call log</a>.</p><p>When the authenticated peer (the caller or the callee) places a call on hold, their Account &quot;Hold Music&quot; preference is used.<br> If it is not set to <code>disabled</code>, the specified sound file is read from the Account File Storage. If the file name is &quot;*&quot; or if the specified file is not found, the <code>HoldMusic</code> file is read from the Account Domain <a href="./../../development/PBXApp.html">Real-Time Application Environment</a>.<br> When the sound file is read, a <a href="./MediaServer.html">Media Channel</a> is created and instructed to play the retrieved file to the other peer.</p><p>You can use the WebAdmin Interface to configure the Call Manager component. Open the Real-Time pages in the Settings realm, then open the Signals page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Calls</b></td></tr><tr><td align="RIGHT">Log Level:</td><td><select name="CallLogLevel"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4" selected="selected">Low Level</option><option value="5">All Info</option></select></td><td align="RIGHT">Time Limit:</td><td><select name="CallTimeLimit"><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400" selected="selected">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="864000">10 day(s)</option><option value="1209600">2 week(s)</option><option value="2592000">30 day(s)</option><option value="8640000">100 day(s)</option><option value="901">other</option></select></td></tr><tr><td align="RIGHT">Signal Idle Timeout:</td><td><select name="CallSignalIdle"><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600" selected="selected">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400">24 hour(s)</option><option value="2401">other</option></select></td><td align="RIGHT">Media Idle Timeout:</td><td><select name="CallMediaIdle"><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900" selected="selected">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="57600">16 hour(s)</option><option value="86400">24 hour(s)</option><option value="1201">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Call Manager component should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable failures only), <code>Major</code> (failures and major events), or <code>Problems</code> (failures, major events, and non-fatal errors) levels.<br> The Call Manager component records in the System Log are marked with the <code>DIALOG</code> tag.</p></li><li><p><code>Time Limit</code></p><p>This setting specifies a time limit for Calls. When this limit is exceeded, the Call object is removed. Keep this limit high enough to avoid call interruptions.</p></li><li><p><code>Signal Idle Timeout</code>, <code>Media Idle Timeout</code></p><p>If there is no signal sent within a Call for the specified period of time, and, if a Media Proxy is associated with that Call, there no media data to relay for the specified period of time, a call termination (BYE) request is sent to both sides of the call, and the Call object is removed. Keep these limits high enough to avoid call interruptions when a call is placed on hold.</p></li></ul><h3 id="CallLogs" tabindex="-1">Account Call Logs <a class="header-anchor" href="#CallLogs" aria-label="Permalink to &quot;Account Call Logs {#CallLogs}&quot;">​</a></h3><p>The Account Call Logs are stored as text files in the Account <a href="./../storage/FileStore.html#CallLogs">File Storage</a>.</p><p>These files have the following format:</p><p><code>2_dd-mmm hh:mm:ss_direction_peer_callId_callTime_alertTime_errorCode[_programName]</code> where:</p><ul><li><p><code>_</code></p><p>is the tabulation symbol (symbol code is 0x09)</p></li><li><p><code>2</code></p><p>record format version</p></li><li><p><code>dd</code></p><p>2-digit month day number</p></li><li><p><code>mmm</code></p><p>3-letter month name</p></li><li><p><code>hh</code>, <code>mm</code>, <code>ss</code></p><p>2-digit numbers for the call termination hour (00..23), minute (00..59), second (00..59)</p></li><li><p><code>direction</code></p><p>1-letter call direction: <code>I</code> - incoming, <code>O</code> - outgoing</p></li><li><p><code>peer</code></p><p>E-mail address of the call peer:<br>   <code>&lt;username@domainName&gt;</code><br> or<br>   <code>&quot;real name&quot; &lt;username@domainName&gt;</code></p></li><li><p><code>callId</code></p><p>call <code>Call-ID</code> string.</p></li><li><p><code>callTime</code></p><p>call duration (in seconds). The time between the moment the call connected and the moment the call disconnected. If this call has not succeeded, this field is empty.</p></li><li><p><code>alertTime</code></p><p>call alerting time (in seconds). The time between the moment the call started and the moment the call connected or (if the call has not succeeded) the moment the call failed.</p></li><li><p><code>errorCode</code></p><p>a string with the error code for the call attempt failure or the call disconnect reason. If the call has completed without an error, this field is empty.</p></li><li><p><code>programName</code></p><p>this optional field contains the name of the <a href="./../../development/PBXApp.html">Real-Time Application</a> that handled this call.</p></li></ul><h3 id="CDR" tabindex="-1">Call Detail Records (CDRs) <a class="header-anchor" href="#CDR" aria-label="Permalink to &quot;Call Detail Records (CDRs) {#CDR}&quot;">​</a></h3><p>The Signal module can generate Call Detail Records for INVITE and BYE transactions it processes. It can also generate Call Detail Records for completed calls using the information in the <a href="#Calls">Call</a> objects.</p><p>CDRs can be generated and stored in special <a href="./../sysadmin/Logs.html#Suppl">supplementary Log</a> files.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Monitoring</b></td></tr><tr><td><input name="CDRCallLog" value="1" checked="checked" type="checkbox"> Record Call CDRs</td><td><input name="CDRLog" value="1" type="checkbox"> Record INVITE/BYE CDRs</td></tr></tbody></table></div></form><ul><li><p><code>Record Call CDRs</code></p><p>Select this option to generate CDR Log files for Calls (Call objects).</p></li><li><p><code>Record INVITE/BYE CDRs</code></p><p>Select this option to generate CDR Log files for INVITE and BYE requests.</p></li></ul><p>When the <a href="./../../development/Helpers.html#CDR">External CDR Processor</a> Helper application is enabled, the Signal Module generates all types of CDRs and sends them to that application.</p><p>CDR data text for INVITE/BYE requests has the following format (the tabulation symbol is used as the field separator): <code>01 NNN-method dialog-identifier parties network-addresses flags</code> where:</p><ul><li><p><code>01</code></p><p>the CDR format version number</p></li><li><p><em>NNN</em></p><p>the transaction result code (numeric)</p></li><li><p><em>Method</em></p><p>the transaction operation/method (INVITE, BYE).</p></li><li><p><em>dialog-identifier</em></p><p>the transaction <code>Call-ID</code> field, the <code>From</code> field <code>tag</code> parameter, the <code>To</code> field <code>tag</code> parameter, enclosed in the <strong>&lt;</strong> and <strong>&gt;</strong> symbols.<br> Note: If a call is terminated by the callee, the <em>fromTag</em> of the BYE transaction is the <em>toTag</em> of the INVITE transaction and vice versa.</p></li><li><p><em>parties</em></p><p>the transaction <code>From</code> and <code>To</code> field URIs addresses, enclosed in the <strong>&lt;</strong> and <strong>&gt;</strong> symbols.</p></li><li><p><em>network-addresses</em></p><p>the network (IP) address the transaction request and responses were received from, enclosed in the <strong>[</strong> and <strong>]</strong> symbols.</p></li><li><p><em>flags</em></p><p>optional fields separated with tabulation symbols:</p><ul><li><p><code>[auth:accountName]</code></p><p>this element is added if the transaction request is authenticated. The <em>accountName</em> is the name of the authenticated CommuniGate Pro Account.</p></li><li><p><code>[redir:accountName]</code></p><p>this element is added if the transaction request was redirected from a local Account. The <em>accountName</em> is the name of that CommuniGate Pro Account.</p></li><li><p><code>[billing:billingData]</code></p><p>this element is added if the transaction request has a P-Billing-Id field. The <em>billingData</em> string is the field content.</p></li><li><p><code>[referred:referredby]</code></p><p>this element is added if the transaction request has a Referred-By field. The <em>referredby</em> string is the field content.CDR data text for calls has the following format (the tabulation symbol is used as the field separator):</p><p><code>02 callType accountName alertTime connectTime reason dialog-identifier [&quot;fromName&quot;] &lt;from&gt; [&quot;toName&quot;] &lt;to&gt;[[toProgramName]] flags</code> where:</p><ul><li><p><code>02</code></p><p>the CDR format version number</p></li><li><p><em>callType</em></p><p>the call type (INP, OUT).</p></li><li><p><em>accountName</em></p><p>the full Account name (<em>accountName</em>@<em>domainName</em>).</p></li><li><p><em>alertTime</em></p><p>the time period (in seconds) between the time the call was initiated and the time the call was accepted or rejected.</p></li><li><p><em>connectTime</em></p><p>the time period (in seconds) between the time the call was accepted and the time the call was terminated. If the call was not accepted, this field contains the <code>-</code> (minus) symbol.</p></li><li><p><em>reason</em></p><p>the reason the call was rejected or terminated.</p></li><li><p><em>dialog-identifier</em></p><p>the call <code>Call-ID</code> field, the <code>From</code> field <code>tag</code> parameter, the <code>To</code> field <code>tag</code> parameter, enclosed in the <strong>&lt;</strong> and <strong>&gt;</strong> symbols.</p></li><li><p><em>from</em>, <em>to</em></p><p>the transaction <code>From</code> and <code>To</code> field URIs.</p></li><li><p><em>fromName</em>, <em>toName</em></p><p>the transaction <code>From</code> and <code>To</code> field &quot;real names&quot;. These fields are optional. If present, these field values are enclosed into the quotation mark (<strong>&quot;</strong>)symbols.</p></li><li><p><em>toProgramName</em></p><p>optional - the name of the PBX Application that has accepted the call.</p></li><li><p><em>flags</em></p><p>the same as used with version 01 records.</p></li></ul></li></ul></li></ul><h2 id="Nodes" tabindex="-1">Local Nodes <a class="header-anchor" href="#Nodes" aria-label="Permalink to &quot;Local Nodes {#Nodes}&quot;">​</a></h2><p>The CommuniGate Pro Server dynamically creates, runs, and removes Real-Time Nodes.</p><p>A Node is an internal CommuniGate Pro Server object that can receive Signal Requests and produce Responses for those Requests. A Node can also send Requests and process Responses.</p><p>Various CommuniGate Pro components and modules use Nodes to implement Signaling functions:</p><ul><li>The <a href="./../../development/PBXApp.html">Real-Time Application</a> component creates a Node for each &quot;call leg&quot;.</li><li>The <a href="./../../development/XMLAPI.html">XIMSS</a> session manager creates a Node for each XIMSS &quot;call leg&quot;.</li><li>The <a href="#Presence">Presence</a> subcomponent creates a Node and uses it to manage Presence Event Subscriptions for those devices that cannot proactively update their Presence state.</li></ul><p>You can use the WebAdmin Interface to configure the Nodes component. Open the Real-Time pages in the Settings realm, then open the Nodes page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Processing</b></td></tr><tr><td>Log Level: <select name="TempFilesLogLevel"><option value="0">Crashes Only</option><option value="1" selected="selected">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td>Processors: <select name="Processors"><option value="0">off</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">other</option></select></td><td>Object Limit: <select name="NT"><option value="1">50</option><option>100</option><option>300</option><option>500</option><option selected="selected">1000</option><option>2000</option><option>5000</option><option>10000</option><option>20000</option><option>50000</option><option value="2222">other</option></select></td><td>Event Limit: <select name="NT1"><option value="1">50</option><option>100</option><option selected="selected">300</option><option>500</option><option>1000</option><option>2000</option><option>5000</option><option>10000</option><option>20000</option><option>50000</option><option value="2222">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Local Nodes component should put in the Server Log. Usually you should use the <code>Failure</code> (unrecoverable failures only), <code>Major</code> (failures and major events), or <code>Problems</code> (failures, major events, and non-fatal errors) levels. When you experience problems with the Local Nodes component, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case the Node processing internals will be recorded in the System Log. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The Local Nodes component records in the System Log are marked with the <code>NODE</code> tag.</p></li><li><p><code>Processors</code></p><p>The Local Nodes component uses several simultaneous processors (threads) to process Nodes. One processor can handle several Nodes tasks.<br> If you use many Nodes implementing time-consuming operations (complex Real-Time Applications, etc.) you should allow the component to use more processors.</p></li><li><p><code>Object Limit</code></p><p>This setting specifies how many Nodes the component can handle at the same time. If this limit is exceeded, attempts to create new Nodes result in an error.</p></li><li><p><code>Event Limit</code></p><p>This setting specifies the critical number of unprocessed events (sent to all active Nodes). If this number is exceeded, the component is overloaded (the component Processors cannot handle events as they appear), and attempts to create new Nodes result in an error.</p></li></ul><h2 id="CallLegs" tabindex="-1">Call Legs <a class="header-anchor" href="#CallLegs" aria-label="Permalink to &quot;Call Legs {#CallLegs}&quot;">​</a></h2><p>The Server creates special Local Nodes called <em>Call Legs</em>. Each Call Leg terminates signaling for one phone call. Each <a href="./../../development/PBXApp.html">PBX Task</a> is a Call Leg, and each <a href="./../access/XIMSS.html">XIMSS</a> session can create one or more Call Legs to handle phone calls initiated or accepted by the XIMSS session user.</p><p>The settings in the Call Legs panel are applied to all types of Call Legs:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Call Legs</b></td></tr><tr><td>Session Expiration:</td><td align="right">Minimal:</td><td><select name="MinSessionRefresh"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90" selected="selected">90 sec</option><option value="120">2 min</option><option value="180">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="86400">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="91">other</option></select></td><td align="right">Default:</td><td><select name="DefaultSessionRefresh"><option value="1">1 sec</option><option value="2">2 sec</option><option value="3">3 sec</option><option value="5">5 sec</option><option value="10">10 sec</option><option value="15">15 sec</option><option value="20">20 sec</option><option value="30">30 sec</option><option value="40">40 sec</option><option value="60">60 sec</option><option value="90">90 sec</option><option value="120">2 min</option><option value="180" selected="selected">3 min</option><option value="300">5 min</option><option value="600">10 min</option><option value="900">15 min</option><option value="1200">20 min</option><option value="1800">30 min</option><option value="2400">40 min</option><option value="3600">60 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="14400">4 hour(s)</option><option value="21600">6 hour(s)</option><option value="36000">10 hour(s)</option><option value="43200">12 hour(s)</option><option value="86400">24 hour(s)</option><option value="172800">2 day(s)</option><option value="259200">3 day(s)</option><option value="604800">7 day(s)</option><option value="181">other</option></select></td></tr><tr><td>Hop Limit:</td><td></td><td><select name="MaxForwards"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="15">15</option><option value="20" selected="selected">20</option><option value="30">30</option><option value="40">40</option><option value="60">60</option><option value="70">70</option><option value="90">90</option><option value="100">100</option><option value="21">other</option></select></td><td colspan="2"></td></tr></tbody></table></div></form><ul><li><p><code>Session-Expiration</code></p><p>Use this setting to specify how often the parties should exchange the INVITE (or OPTION) requests to verify that the call has not been broken.</p></li><li><p><code>Hop Limit</code></p><p>Use this setting to specify the <code>Max-Forwards</code> field value for the requests sent with Call Legs.</p></li></ul><h2 id="API" tabindex="-1">Signal API <a class="header-anchor" href="#API" aria-label="Permalink to &quot;Signal API {#API}&quot;">​</a></h2><p>The Signal tasks can receive &quot;events&quot; from other CommuniGate Pro components, such as <a href="./../../development/CGPL.html">CG/PL</a> tasks and <a href="./../access/XIMSS.html">XIMSS</a> client sessions. To send an event, the sender should obtain a <em>signal handle</em>.</p><p>A Signal task accepts the following events:</p><ul><li><p><code>decline</code></p><p>This event causes the Signal task to cancel Signal Request processing and to reject it with the 603 Declined error code.</p></li><li><p><code>fork</code></p><p>This event data should be a string or an array of strings. The Signal Request is forked to the URIs specified with these strings.</p></li><li><p><code>redirect</code></p><p>Same as <code>fork</code>, but all currently &quot;forked&quot; Requests are canceled.</p></li></ul>',130)]))}const v=t(s,[["render",l]]);export{g as __pageData,v as default};
