import{_ as o,c as n,o as i,ag as a,j as e}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"External Storage","description":"","frontmatter":{"legacyLink":"ExternalSync.html"},"headers":[],"relativePath":"admin/storage/ExternalSync.md","filePath":"admin/storage/ExternalSync.md"}'),l={name:"admin/storage/ExternalSync.md"};function r(s,t,d,c,m,h){return i(),n("div",null,t[0]||(t[0]=[a('<h1 id="external-storage" tabindex="-1">External Storage <a class="header-anchor" href="#external-storage" aria-label="Permalink to &quot;External Storage&quot;">​</a></h1><p>CommuniGate Pro <a href="./../objects/Accounts.html">Accounts</a> can utilize mailbox storage of other (external) systems. There are 2 main methods for mailbox storage integration:</p><ul><li>Remote Access. The mailboxes stored on a remote system are seen as CommuniGate Pro Account own mailboxes. When such a Mailbox is opened, CommuniGate Pro connects to the external system and performs all requested Mailbox operations remotely, reading and modifying data directly in the external system mailbox storage.</li><li>Synchronized Storage. Mailboxes are stored locally, within the CommuniGate Pro Accounts. The CommuniGate Pro periodically connects to the external system and synchronizes its local storage with the external system mailbox storage: messages added to or deleted from the CommuniGate Pro Mailboxes are added to and deleted from the external storage mailboxes, and messages added to or deleted from the external storage mailboxes are added to and deleted from the CommuniGate Pro mailboxes.</li></ul><h2 id="Config" tabindex="-1">Configuring External Storage <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Configuring External Storage {#Config}&quot;">​</a></h2><p>To configure External Mailbox Storage for an Account, open the Account Settings using the WebAdmin Interface, and open the Mail Settings page in the Mail section:</p>',5),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"External Storage")])]),e("tr",{valign:"top"},[e("td",{width:"25%",align:"RIGHT",nowrap:"nowrap"},"External Storage Mode: "),e("td",null,[e("select",{name:"SyncMode"},[e("option",{value:"-1"},"default(Disabled)"),e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"AIRSYNC"),e("option",{value:"2",selected:"selected"},"IMAP")])]),e("td",{width:"25%",align:"RIGHT",nowrap:"nowrap"},"External Server: "),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"SyncServer-Def",value:"1",checked:"checked"})]),e("td",{class:"settingFixed"},"imap.service.dom:993")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"SyncServer-Def",value:"0"})]),e("td",null,[e("input",{name:"SyncServer",size:"30",maxlength:"10000",value:""})])])])])])]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Account Name: "),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"SyncUserName-Def",value:"1"})]),e("td",{class:"settingFixed"},"^0")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"SyncUserName-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"SyncUserName",size:"30",maxlength:"10000",value:"j.smith1"})])])])])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Password: "),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"SyncUserPassword-Def",value:"1"})]),e("td",{class:"settingFixed"},"^0")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"SyncUserPassword-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"SyncUserPassword",size:"30",maxlength:"10000",value:"********"})])])])])])])])])])],-1),a('<ul><li><p><code>External Storage Mode</code></p><p>The External Storage integration method.</p></li><li><p><code>External Server</code></p><p>The name of the external mailbox storage system. It can contain a macro symbol <code>^0</code> which is substituted with the CommuniGate Pro Account Domain name.<br> The name may contain an IP port suffix, and it may include the <code>tls:</code> prefix to indicate that CommuniGate Pro must connect to that system via a secure (encrypted) connection.<br> If the specified IP port is a standard secure port for the selected protocol (993 for IMAP, 443 for HTTP-based protocols), secure connects are used with our without the <code>tls:</code> prefix specified.</p></li><li><p><code>Account Name</code></p><p>The external mailbox storage system credential.<br> This settings can contain a macro symbol <code>^0</code> which is substituted with the CommuniGate Pro Account name.</p></li><li><p><code>Password</code></p><p>The external mailbox storage system credential.<br> This settings can contain a macro symbol <code>^0</code> which is substituted with the CommuniGate Pro Account password. The CommuniGate Pro Password should not be stored using a one-way hash method, otherwise a synchronization attemp will fail.</p></li></ul><h2 id="IMAP" tabindex="-1">Remote Access via IMAP <a class="header-anchor" href="#IMAP" aria-label="Permalink to &quot;Remote Access via IMAP {#IMAP}&quot;">​</a></h2><p>When the External Storage Mode setting is set to <code>IMAP</code>, the Account Mailbox storage is extended using the external mailbox storage system, via IMAP connections:</p><ul><li>All external mailbox storage mailboxes are visible in the mailbox list. If there is a local Mailbox with the same name as an mailbox in external mailbox storage, the external mailbox is used.</li><li>When a mailbox is being opened, a local Mailbox with the specified name is opened, if present. If not present, an IMAP connection to the external mailbox storage is created. It is used to open the specified external mailbox and to process mailbox operation by reading and modifying the external mailbox.</li><li>When there is a request to create a mailbox, it is created locally, inside the CommuniGate Pro Account, if the requested Mailbox Class is not &quot;Email&quot; (empty), or if the parent mailbox is a Local Mailbox. In all other cases the mailbox is created in the external mailbox storage.</li></ul><h2 id="AirSync" tabindex="-1">Synchronized Storage via AirSync <a class="header-anchor" href="#AirSync" aria-label="Permalink to &quot;Synchronized Storage via AirSync {#AirSync}&quot;">​</a></h2><p>When the External Storage Mode setting is set to <code>AirSync</code>, the Account Mailbox storage is synchronized with the external mailbox storage system using the AirSync protocol:</p><ul><li>The mailbox tree is synchronized every time a mailbox listing operation is applied to the Account</li><li>Mailbox creation, renaming, deletion operations are applied to the external mailbox storage first, and then the mailbox trees are synchronized.</li><li>Each Mailbox is synchronized when it is being opened and then periodically while the Mailbox is kept open.</li><li>When a message or other item is being moved from one Mailbox to a different Mailbox, this operation is applied to the external mailbox storage, and then both Mailboxes are synchronized.</li></ul>',7)]))}const x=o(l,[["render",r]]);export{p as __pageData,x as default};
