import{_ as t,c as a,o as i,ag as s}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"File Storage","description":"","frontmatter":{"legacyLink":"FileStore.html"},"headers":[],"relativePath":"admin/storage/FileStore.md","filePath":"admin/storage/FileStore.md"}'),o={name:"admin/storage/FileStore.md"};function r(n,e,c,l,d,h){return i(),a("div",null,e[0]||(e[0]=[s(`<h1 id="file-storage" tabindex="-1">File Storage <a class="header-anchor" href="#file-storage" aria-label="Permalink to &quot;File Storage&quot;">​</a></h1><p>CommuniGate Pro <a href="./../objects/Accounts.html">Accounts</a> contain a <em>File Storage</em> - a set of HTML, JPEG, and other files. File Storage can contain directories which can contain files and other (<em>nested</em>) directories.</p><p>The CommuniGate Pro <a href="./../services/HTTP.html">HTTP</a> module can be used to access and to manage the Account File Storage. This feature makes an Account File Storage act as a <em>personal Web site</em>.</p><p>The CommuniGate Pro <a href="./../access/FTP.html">FTP</a> module, the <a href="./../access/TFTP.html">TFTP</a> module, and the <a href="./../services/HTTP.html">HTTP</a> module WebDAV extension can be used to access and to manage the Account File Storage.</p><p>The <a href="./../../development/CLI.html">CLI API</a> can be used to access and to manage the Account File Storage.</p><p>The total number of files and folders and the total size of all File Storage files is limited with the <a href="./../objects/Accounts.html#File">Account Settings</a>.</p><p>The Account File Storage is used:</p><ul><li>to <a href="./WebMessage.html#StoreFiles">store message attachments</a>.</li><li>to store audio prompts and other files used in <a href="./../../development/PBXApp.html">Real-Time Applications</a>.</li><li>to store various Account-level Logs (such as call logs).</li></ul><h2 id="Special" tabindex="-1">Special Files and Folders <a class="header-anchor" href="#Special" aria-label="Permalink to &quot;Special Files and Folders {#Special}&quot;">​</a></h2><p>Certain File Storage names have special meanings.</p><ul><li><p><code>_empty_</code></p><p>An empty-name file is retrieved via HTTP when no file name is specified in the Access URL, such as <code>http://server:port/~username/</code>, or <code>http://server:port/~username</code>, or <code>http://server:port/~username/subfolder/</code></p></li></ul><p>In this case, a file with a predefined name is retrieved. This predefined name is set as an Account Setting, and is usually set to <code>default.html</code>. So, an HTTP retrieval request for the <code>http://server:port/~username/subfolder/</code> URL produces the same result as the <code>http://server:port/~username/subfolder/default.html</code> request.</p><ul><li><p><code>freebusy.vfb</code></p><p>This text file contains the user Free/Busy information. When the Account Main Calendar is modified with the CommuniGate Pro <a href="./../access/MAPI.html">MAPI</a> module, <a href="./../access/XIMSS.html">XIMSS</a> interface, or <a href="./../access/AirSync.html">AirSync</a>, <a href="./../access/WebDAV.html#CalDAV">CalDAV</a>, or the <a href="./../access/WebUser.html">WebUser Interface</a> module, the file is deleted.<br> When this file is being accessed and it does not exist, the Server opens the Account Main Calendar, builds the Free/Busy information, and stores the information in the <code>freebusy.vfb</code> file.</p></li></ul><p>If the Free/Busy information cannot be built (for example, if no Main Calendar Mailbox exists in the Account), the <a href="./../services/HTTP.html">HTTP</a> module generates an empty Free/Busy dataset and sends it to the client.</p><ul><li><p><code>_any_name_.meta</code></p><p>these names are reserved and cannot be used.</p></li><li><p><code>private/logs/calls-_yyyy_-_mmm_</code></p><p>These text files are created and filled with the <a href="./../cluster/Signals.html#CallLogs">Signal Dialog</a> objects. <em>yyyy</em> is a 4-digit year number, and <em>mmm</em> is a 3-letter month name.<br> Each file record has tab-delimited fields and contains information about one call made from or to the Account.</p></li><li><p><code>private/IM/_userName_@_domainName_.log</code></p><p>These text files contain <a href="./../signals/IMPresence.html#IM">Instant Messages</a> send to and received from the <em>userName</em>@<em>domainName</em> address.<br> Each Instant Message is stored as one text line, with the following tab-delimited fields:</p></li><li><p>time stamp (GMT): <em>YYYYMMDD_T_hhmmsss</em></p></li><li><p>direction: &lt; for incoming IMs, &gt; for outgoing IMs</p></li><li><p>deviceID: <a href="./../../development/Data.html#String"><em>string</em></a> - for &quot;groupchat&quot; messages - the sender or receiver device ID, an empty field otherwise</p></li><li><p>body: <a href="./../../development/Data.html#String"><em>string</em></a> - the message body text, as a String object <a href="./../../development/Data.html">presentation</a>.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Names starting with the tilda (<code>~</code>) symbol are used to specify <a href="#Foreign">Foreign Files</a>, and, as a result, this symbol cannot be used as the first symbol of a file name.<br> Many Microsoft® products use names starting with the tilda symbol for temporary or service files. To avoid the problem, always use those products with Account Storage subdirectories, and not with the topmost Storage directory.</p></div><h2 id="Virtual" tabindex="-1">Virtual Files and Folders <a class="header-anchor" href="#Virtual" aria-label="Permalink to &quot;Virtual Files and Folders {#Virtual}&quot;">​</a></h2><p>Virtual names do not specify actual files or folders in the File Storage, but they can be used to retrieve certain information.</p><ul><li><p><code>index.wssp</code></p><p>This name is used for <a href="#HTMLAdmin">HTML-based File Storage management</a>. Access to this resource requires authentication.</p></li><li><p><code>freebusy.wssp</code></p><p>This name is used to retrieve formatted Free/Busy information. The actual data is retrieved from the <code>freebusy.vfb</code> file (see above).</p></li><li><p><code>pubcal/_calendarName_.ics</code></p><p>These names are used to retrieve the contents of the specified Account Calendar Mailbox in the iCalendar format. This virtual files can be used to &quot;publish&quot; the Calendar information. The user must have the right to Select the specified Mailbox.</p></li><li><p><code>$DomainSkins</code>, <code>$ServerSkins</code>, <code>$ClusterSkins</code></p><p>These virtual directories provide access to the Domain-wide or to the Server-wide/Cluster-wide <a href="./../../development/WebApp.html">Skins</a>. Each Skin is presented as a subdirectory, with the name <code>$unnamed$</code> used for the &quot;unnamed&quot; Skins.<br> The Account must have the proper <a href="./../sysadmin/#Priv">Access Rights</a> to see and manage these directories.</p></li><li><p><code>$DomainPBXApp</code>, <code>$ServerPBXApp</code>, <code>$ClusterPBXApp</code></p><p>These virtual directories provide access to the Domain-wide or to the Server-wide/Cluster-wide <a href="./../../development/PBXApp.html">Real-Time Application Environments</a>. Language variants are presented as subdirectories.<br> The Account must have the proper <a href="./../sysadmin/#Priv">Access Rights</a> to see and manage these directories.</p></li></ul><h2 id="Attrs" tabindex="-1">File Attributes <a class="header-anchor" href="#Attrs" aria-label="Permalink to &quot;File Attributes {#Attrs}&quot;">​</a></h2><p>Each file and file directory can have an set of attributes or meta-information.</p><p>For example, the <code>Betty.jpeg</code> file contains meta-information such as the location where the photo was taken, comments, etc.</p><p>Each attribute is an XML element.</p><p>Some attributes are &quot;protected&quot; - they can be modified only by the Account owner, the System or Domain Admin or if the user is granted the &quot;Administer&quot; Access Right to that file or file directory.</p><h2 id="ACL" tabindex="-1">File Access Rights <a class="header-anchor" href="#ACL" aria-label="Permalink to &quot;File Access Rights {#ACL}&quot;">​</a></h2><p>The CommuniGate Pro Server maintains an Access Control List (ACL) for every Storage file or file directory. This list is stored as an <code>&lt;ACL&gt;</code> protected File Attribute.</p><p>The Access Control Lists are used to control the <a href="#Foreign">Foreign File Access</a> feature that allows Account users to access File Storage in other Accounts.</p><p>All files and file directories in an Account File Storage located outside the <code>private</code> directory are open for &quot;list&quot; (directories) and &quot;read&quot; operations for any Account user, as well as for non-authenticated users. For example, these files can be accessed via unauthenticated HTTP requests, and they can be used as a Personal Web Site.</p><p>The Account owner has all access rights to all Account Storage files and directories.</p><p>A Server Administrator with the <a href="./../sysadmin/#Privs">All Domains</a> access right has all access rights to all files in all Server or Cluster Accounts.</p><p>Domain Administrators with the <code>CanViewWebSites</code> access right have all access rights for all files in their Domain Accounts.</p><p>The Account owner can grant certain limited file access rights to other users, using the <a href="./../sysadmin/Security.html#ACL">Access Control Lists</a>.</p><p>The following File Access Rights are supported:</p><ul><li><p><code>l</code> (List, file directories only)</p><p>If you grant a user the List access right, that user will be able to see the content of this file directory.</p></li><li><p><code>d</code> (Delete, file directories only)</p><p>If you grant a user the Delete access right, that user will be able to remove files and empty file sub-directories from this file directory.</p></li><li><p><code>r</code> (Read)</p><p>If you grant a user the Read access right to a file, that user will be able to read this file and its unprotected attributes. If you grant a user the Read access right to a file directory, that user will be able to read all files in this directory for which the Access Control Lists are not specified.</p></li><li><p><code>w</code> (Write)</p><p>If you grant a user the Write access right to a file, that user will be able to write to this file and to modify its unprotected attributes. If you grant a user the Write access right to a file directory, that user will be able to write to all files in this directory for which the Access Control Lists are not specified, and the user will be able to create new files in this directory.</p></li><li><p><code>a</code> (Administer)</p><p>If you grant a user the Administer access right, that user will be able to modify the file ACL and other &quot;protected&quot; File Attributes.</p></li></ul><p>When a file directory is created, the ACL of the outer directory (if any) is copied to the newly created directory.</p><h2 id="Protected" tabindex="-1">Shared Private Files <a class="header-anchor" href="#Protected" aria-label="Permalink to &quot;Shared Private Files {#Protected}&quot;">​</a></h2><p>Read access to files and List access to directories inside the <code>private</code> directory can be granted to other CommuniGate Pro users and external &quot;guests&quot;, using the protected <code>&lt;accessPwd&gt;</code> File Attribute.</p><p>Each <code>&lt;accessPwd&gt;</code> attribute should have a <code>&lt;key/&gt;</code> element containing a random string - the <em>access-password</em>. It is recommended to add <code>&lt;EMail/&gt;</code> element(s) with the E-mail address(es) of the users to whom this <em>access-password</em> has been sent.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">accessPwd</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;dyf984897498ih12ui3u-3y887&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;User Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user1@domain1.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user2@domain2.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">accessPwd</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>When this attribute is added to the <code>private</code> directory, it enables an alternative access path to all files within that directory and its subdirectories:</p><p><code>protected/pwd/_access-password_/</code></p><p>If this attribute is added to the <code>private/dir1/dir2</code> directory, it enables an alternative access path to all files within that directory and its subdirectories:</p><p><code>protected/dir1/pwd/_access-password_/dir2/</code></p><p>If the XML attribute listed in the example above is added to the <code>private/dir1/dir2</code> directory file attributes, the user can compose a Personal Site URL using the alternative path:</p><p><code>http://server:port/~username/protected/dir1/pwd/dyf984897498ih12ui3u-3y887/dir2/file.name</code></p><p>The user then can send this URL to <code>user1@domain1.dom</code> and <code>user2@domain2.dom</code> and other addresses. The recipients can access this <code>file.name</code> file by following this link.</p><p>The user can revoke this access right by removing this <code>&lt;accessPwd/&gt;</code> attribute.</p><p>Alternative file paths can be used in FTP and TFTP protocols, and in all other CommuniGate Pro components that access the Account File Storage.</p><h2 id="HTMLAdmin" tabindex="-1">HTML-based Management <a class="header-anchor" href="#HTMLAdmin" aria-label="Permalink to &quot;HTML-based Management {#HTMLAdmin}&quot;">​</a></h2><p>Users can manage their Account File Storage using a Web browser. There are two methods to access the File Storage administration pages:</p><ul><li>By opening a <a href="./../access/WebUser.html">WebUser Session</a>, and using the Files link in the WebUser Interface navigation panel.</li><li>By opening the <code>Index.wssp</code> file in their own personal Web site:<br><code>http://domain.dom:8100/~username/Index.wssp</code><br> A browser will present a Login (authentication) dialog box, and the users should enter their Account names and passwords in order to open the Web site administration page.</li></ul><p>Server administrators with the <a href="./../sysadmin/#Privs">All Domains</a> access right and Domain administrators with the <code>CanAccessWebSites</code> access right can access File Storage in other Accounts.</p><p>Server and Domain administrators can access File Storage of any Account using the WebAdmin Interface: the Account management pages have the Files link in their navigation panels.</p><p>All management methods use similar HTML pages for File Storage administration, see the WebUser Interface <a href="./WebFiles.html">Files</a> section for the details.</p><h2 id="HTTPAdmin" tabindex="-1">HTTP-based Management <a class="header-anchor" href="#HTTPAdmin" aria-label="Permalink to &quot;HTTP-based Management {#HTTPAdmin}&quot;">​</a></h2><p>File Storage data can be modified using the HTTP 1.1 <code>PUT</code>, <code>DELETE</code>, and <code>MOVE</code> methods. Some HTML design tools can use these methods to upload files to the server.</p><p>These HTTP requests should contain the Authentication information: the Account name of the File Storage owner or the Account name of a Server/Domain Administrator, and the password for that Account.</p><h2 id="Access" tabindex="-1">HTTP Access to File Storage <a class="header-anchor" href="#Access" aria-label="Permalink to &quot;HTTP Access to File Storage {#Access}&quot;">​</a></h2><p>CommuniGate Pro allows each user to be presented on the World Wide Web with a personal Web site. The URL for the <em>accountname</em>@<em>domainname</em> Account File Storage is:<br><code>&lt;http://_domainname_:_port_/~_accountname_&gt;</code>   where the <em>port</em> is the <a href="./../services/HTTP.html#Configuring">WebUser port</a>.<br> For example, the <code>jsmith@client1.com</code> account has a personal Web site at:<br><code>&lt;http://client1.com:8100/~jsmith&gt;</code></p><p>Personal Web sites use the same HTTP port as the <a href="./../access/WebUser.html">WebUser</a> Interface (the port 8100 by default).</p><p>In addition to the <code>~</code> prefix, an alternative prefix can be specified in the <a href="./../objects/Domains.html#WebUser">Domain Settings</a>. The alternative prefix can be an empty string.</p><p>All Routing Rules discussed in the <a href="./../cluster/Access.html">Access</a> section apply to the personal Web site URLs, so Account and Domain aliases can be used in the personal Web site URLs.</p><p>Personal Web sites can be accessed without a prefix, using just the server part of the URL string. When the CommuniGate Pro server receives an HTTP connection on the its <a href="./../access/WebUser.html">WebUser port</a>, it uses the special <a href="./../services/HTTP.html#Routing">Domain Routing</a> procedure.</p><p>If the domain name <code>user.domain.com</code> has a DNS A-record pointing to the IP address of the CommuniGate Pro server, and the CommuniGate Pro Router has the following record:<br><code>&lt;LoginPage@user.domain.com&gt; = userA@domainB.com</code><br> and the Account userA exists in the CommuniGate Pro Domain domainB, then the URL <code>http://user.domain.com/</code> can be used to access the personal Web site (File Storage) of the <a href="mailto:userA@domainB.com" target="_blank" rel="noreferrer">userA@domainB.com</a> Account.</p><p>File Storage must not contain any <code>index.wssp</code> file. This name is reserved for the File Storage Management forms.</p><p>The home (default) page of a personal Web Site should have the <code>default.html</code> name. This means that when the file name is not specified explicitly, the <code>default.html</code> name is assumed. If a File Storage has folders (subdirectories), then the request with the <code>http://_server_:_port_/_prefix user_/_folder_/</code> URL retrieves the <code>default.html</code> file from that subdirectory.</p><p>The name of the default page is specified as an <a href="./../objects/Accounts.html#File">Account Setting</a> and it can be modified on the per-Account basis.</p><h2 id="FTPAdmin" tabindex="-1">FTP Access and Management <a class="header-anchor" href="#FTPAdmin" aria-label="Permalink to &quot;FTP Access and Management {#FTPAdmin}&quot;">​</a></h2><p>File Storage data can be accessed, modified, and managed using the CommuniGate Pro <a href="./../access/FTP.html">FTP module</a>. When an Account user connects to the FTP module, the FTP &quot;root directory&quot; as well as the &quot;current directory&quot; are set to the Account File Storage top directory.</p><h2 id="WebDAV" tabindex="-1">WebDAV Access and Management <a class="header-anchor" href="#WebDAV" aria-label="Permalink to &quot;WebDAV Access and Management {#WebDAV}&quot;">​</a></h2><p>File Storage data can be accessed, modified, and managed using the CommuniGate Pro <a href="./../services/HTTP.html">HTTP module</a> WebDAV extension.<br> use <code>http://_server_:_port_/WebDAV/</code> or <code>https://_server_:_port_/WebDAV/</code> URLs to configure a WebDAV client.</p><p>Access to the /WebDAV/ realm requires authentication, and the authenticated Account and its Domain must have the <a href="./../objects/Domains.html#Services">WebSite Service</a> enabled.<br> This realm presents the authenticated Account File Storage top directory.</p><p>The File Access WebDAV protocol works over the <a href="./../services/HTTP.html">HTTP</a> protocol, using the HTTP User Module. Open the HTTP User Module settings, and find the Sub-Protocols panel:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sub-Protocols</b></td></tr><tr><td align="RIGHT">FileDAV:</td><td><select name="CALDAVLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5" selected="selected">All Info</option></select></td></tr></tbody></table></div></form><p>Use the FileDAV Log setting to specify the type of information the File Access WebDAV module should put in the Server Log.</p><p>The File Access WebDAV module records in the System Log are marked with the <code>FileDAV</code> tag.</p><h2 id="Foreign" tabindex="-1">Foreign File Access <a class="header-anchor" href="#Foreign" aria-label="Permalink to &quot;Foreign File Access {#Foreign}&quot;">​</a></h2><p>The CommuniGate Pro allows an Account user to access File Storage in other Accounts.<br> Access to these foreign Files (also called shared Files) is controlled via the <a href="#ACL">File Access Rights</a>.</p><p>To access a file or a file directory in a different Account, the file name should be specified as <code>~_accountname_/_filename_</code>. For example, to access the <code>images/pict01.jpg</code> file in the Boss Account, the file name should be specified as <code>~Boss/images/pict01.jpg</code> .</p><p>If there are several local Domains on the Server, files in a different Domain can be accessed by specifying full Account names. To access the <code>images/pict01.jpg</code> file in the Account <code>designer</code> in the client.com Domain, the file name should be specified as <code>~designer@client.com/images/pict01.jpg</code>.</p><p>Account names specified after the &quot;~&quot; sign are processed with the <a href="./../sysadmin/Router.html">Router</a>, so Account Alias names can be used instead of the real Account names, and all Routing Table rules are applied.</p><h2 id="Subscription" tabindex="-1">File Subscription <a class="header-anchor" href="#Subscription" aria-label="Permalink to &quot;File Subscription {#Subscription}&quot;">​</a></h2><p>Each Account has a <em>file subscription</em> set - a set of file and/or file directory names.</p><p>This list is maintained with various clients. Usually, it contains the names of foreign file directories, such as <code>~accountName/dir1/dir2/</code>, letting clients show some preselected foreign file directories.</p>`,85)]))}const u=t(o,[["render",r]]);export{m as __pageData,u as default};
