import{_ as a,c as t,o as s,ag as o}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"Mailboxes","description":"","frontmatter":{"legacyLink":"Mailboxes.html"},"headers":[],"relativePath":"admin/storage/Mailboxes.md","filePath":"admin/storage/Mailboxes.md"}'),i={name:"admin/storage/Mailboxes.md"};function l(n,e,r,c,d,h){return s(),t("div",null,e[0]||(e[0]=[o(`<h1 id="mailboxes" tabindex="-1">Mailboxes <a class="header-anchor" href="#mailboxes" aria-label="Permalink to &quot;Mailboxes&quot;">​</a></h1><p>CommuniGate Pro <a href="./../objects/Accounts.html">Accounts</a> contain one or several Mailboxes. Each Mailbox has its own unique name and it can contain zero or more messages. The <a href="./../access/POP.html">POP</a>, <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/MAPI.html">MAPI</a>, <a href="./../access/XIMSS.html">XIMSS</a>, <a href="./../access/WebUser.html">WebUser Interface</a>, and <a href="./../../development/PBXApp.html">Real-Time Application</a> modules provide <a href="./../cluster/Access.html">access</a> to Account Mailboxes.</p><p>Several storage formats can be used for CommuniGate Pro Mailboxes. A multi-Mailbox Account can contain Mailboxes stored in different formats.</p><p>Each Account always has the <code>INBOX</code> Mailbox. Any message delivered to a CommuniGate Pro Account is stored in its INBOX Mailbox - unless some <a href="./../mail/QueueRules.html">Automated Processing Rules</a> instruct the Server to store the message in a different Mailbox.</p><h2 id="Names" tabindex="-1">Mailbox Names <a class="header-anchor" href="#Names" aria-label="Permalink to &quot;Mailbox Names {#Names}&quot;">​</a></h2><p>When an Account is created, its INBOX Mailbox is automatically created. The System and/or Domain Administrator can specify additional Mailboxes to be created at that time.</p><p>A user can create a Mailbox using an <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/MAPI.html">MAPI</a>, or <a href="./../access/XIMSS.html">XIMSS</a> mailer application or using the <a href="./WebMail.html#Mailboxes">WebUser Interface</a>.</p><p>Mailboxes can be &quot;nested&quot;: for any Mailbox &quot;A&quot; you can create a sub-Mailbox &quot;B&quot; - in the same way as you can created a file directory inside some other file directory. The CommuniGate Pro Server uses the slash (<code>/</code>) symbol as the hierarchy separator: <code>INBOX/important</code> is the name of the sub-Mailbox <code>important</code> &quot;inside&quot; the <code>INBOX</code> Mailbox.</p><p>CommuniGate Pro allows you to store messages in some Mailbox <code>X</code> and at the same time you can create sub-Mailboxes <code>X/Y, X/Z</code> for that Mailbox. This feature is implemented by providing two &quot;invisible&quot; Mailbox entities - one for storing messages, one - for serving as a &quot;directory&quot; for the nested Mailboxes. The &quot;directory&quot; entity is created automatically, as soon as you try to create the first sub-Mailbox. You can, though, create the &quot;directory&quot; entity without creating the &quot;mail storage&quot; entity: use the <code>ABCDEF/</code> name as the new Mailbox name to create only the directory entity with the <code>ABCDEF</code> name. The name <code>ABCDEF</code> will be listed, but will not be &quot;selectable&quot; - and you will not be able to store messages in the <code>ABCDEF</code> Mailbox. You can later create the regular <code>ABCDEF</code> Mailbox and the &quot;storage&quot; entity for your <code>ABCDEF</code> Mailbox name will be added.</p><p>It is impossible to delete the INBOX Mailbox. You can rename the INBOX Mailbox, though. In this case a new empty INBOX Mailbox will be created automatically.</p><p>Mailbox names are case-sensitive. Some file systems (NTFS, for example) provide case-insensitive file naming conventions. When these file systems are used for CommuniGate Pro Account/Mailbox storage, the Mailbox names are still case-sensitive, but you cannot create two Mailboxes with names that differ in case only. The INBOX Mailbox name is an exception: it is always a case-insensitive name.</p><h2 id="Flags" tabindex="-1">Message Flags <a class="header-anchor" href="#Flags" aria-label="Permalink to &quot;Message Flags {#Flags}&quot;">​</a></h2><p>Messages in Mailboxes have individual flags. These flags can be set when the message is being stored in the Mailbox, and they can be updated using Mailbox access protocols and methods, such as <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/MAPI.html">MAPI</a>, <a href="./../access/XIMSS.html">XIMSS</a>, <a href="./../access/WebUser.html">WebUser Interface</a>, <a href="./../../development/PBXApp.html">Real-Time Applications</a>.</p><p>Some flags are set automatically, even when the access protocol used does not support flag modification. For example, the Seen flag is set automatically when the message is being read using the <a href="./../access/POP.html">POP</a> protocol RETR command.</p><p>Several components (such as <a href="./../mail/QueueRules.html">Automated Rule</a>, <a href="./../../development/CGPL.html">CG/PL</a> programs, etc.) can access message flags by name. They can also use &quot;negative names&quot; to instruct the server to reset a certain flag or to look for messages that do not have that flag set.</p><p>The following table lists the predefined message flags along with their IMAP and Negative names:</p><table tabindex="0"><thead><tr><th>Name</th><th>Description</th><th>IMAP Name</th><th>Negative Name</th></tr></thead><tbody><tr><td><code>Seen</code></td><td>This flag is set when the message was read by a client. It can be set automatically as a result of certain Mailbox access operations, and it can be set and reset explicitly with mail client applications.</td><td><code>\\Seen</code></td><td><code>Unseen</code></td></tr><tr><td><code>Read</code></td><td><em>same as <code>Seen</code></em></td><td></td><td><code>Unread</code></td></tr><tr><td><code>Answered</code></td><td>This flag is set when a reply was sent for this message. This flag is explicitly set and reset with mail client applications.</td><td><code>\\Answered</code></td><td><code>Unanswered</code></td></tr><tr><td><code>Flagged</code></td><td>This flag is set to attach a &quot;flag&quot; to the message (for example, a mail client can show this message to the user as an important one). This flag is explicitly set and reset with mail client applications.</td><td><code>\\Flagged</code></td><td><code>Unflagged</code></td></tr><tr><td><code>Draft</code></td><td>This flag is set for messages that have not been sent yet. It tells a mail client that it can open and edit this message. This flag is explicitly set and reset with mail client applications.</td><td><code>\\Draft</code></td><td><code>Undraft</code></td></tr><tr><td><code>Deleted</code></td><td>This flag is set for messages that were marked for deletion. Some mail clients allow users to mark some Mailbox messages first, and then delete (&quot;expunge&quot;) all marked messages from the Mailbox. This flag is explicitly set and reset with mail client applications.</td><td><code>\\Deleted</code></td><td><code>Undeleted</code></td></tr><tr><td><code>Redirected</code></td><td>This flag is set when a copy of the message was sent (redirected) to someone. This flag is explicitly set and reset with mail client applications.</td><td><code>$Forwarded</code></td><td><code>NotRedirected</code></td></tr><tr><td><code>MDNSent</code></td><td>This flag is set when an MDN (&quot;read report&quot;) for the message has been sent. This flag helps mail clients to send only one MDN report for each message. This flag is explicitly set and reset with mail client applications.</td><td><code>$MDNSent</code></td><td><code>NoMDNSent</code></td></tr><tr><td><code>Hidden</code></td><td>Messages with this flag set are visible only to the Mailbox Account owner and to those users who have the Admin <a href="#ACL">Access Right</a> for this Mailbox. This flag allows users to grant access to their Mailboxes to others while keeping certain messages private (hidden).</td><td><code>$Hidden</code></td><td><code>NotHidden</code></td></tr><tr><td><code>Service</code></td><td>Messages with this flag set are not visible to <a href="./../access/IMAP.html">IMAP</a> or <a href="./../access/POP.html">POP</a> clients. <a href="./../access/MAPI.html">MAPI</a> clients can use this flag to create service items invisible to users (such as Mailbox forms).</td><td><code>$Service</code></td><td><code>NotService</code></td></tr><tr><td><code>Media</code></td><td>If this flag is set, the message is treated as containing some &quot;media&quot; (audio/video) data.</td><td><code>$Media</code></td><td><code>NotMedia</code></td></tr><tr><td><code>Junk</code></td><td>If this flag is set, the message is treated as &quot;junk&quot; (spam).</td><td><code>Junk</code></td><td><code>NotJunk</code></td></tr></tbody></table><p>Besides the predefined flags CommuniGate Server supports custom flags which can be defined by user. The IMAP names of the custom flags can not contain spaces and these characters: <code>\\(){%*&quot;</code> The names are case-insensitive. The custom flags do not have Negative names.</p><h2 id="ACL" tabindex="-1">Mailbox Access Rights <a class="header-anchor" href="#ACL" aria-label="Permalink to &quot;Mailbox Access Rights {#ACL}&quot;">​</a></h2><p>The CommuniGate Pro Server maintains an Access Control List (ACL) for every Mailbox it creates.</p><p>The Access Control Lists are used to control the <a href="#Foreign">Foreign Mailbox Access</a> feature that allows Account users to access Mailboxes in other Accounts.</p><p>A Server Administrator with the <a href="./../sysadmin/#Privs">All Domains</a> access right has all access rights to all Mailboxes in all Server or Cluster Accounts.</p><p>Domain Administrators with the <code>CanViewMailboxes</code> access right have all access rights for all Mailboxes in their Domains.</p><p>The Mailbox Account owner can grant certain limited access rights to other users, using the <a href="./../sysadmin/Security.html#ACL">Access Control Lists</a>.</p><p>The following Mailbox access rights are supported:</p><ul><li><p><code>l</code> (Lookup)</p><p>If you grant a user the Lookup access right, that user will be able to see this Mailbox when it asks the Server to list all Mailboxes in your Account.</p></li><li><p><code>r</code> (Read/Select)</p><p>If you grant a user the Read access right, that user will be able to open (select) this Mailbox and see (read) the messages in this Mailbox.</p></li><li><p><code>s</code> (Seen)</p><p>If you grant a user the Seen access right, that user will be able to mark messages as read (seen). Usually a message is automatically marked as seen when a user reads it. But if this access right is not granted to a user reading the Mailbox, the Mailbox message &quot;seen&quot; status will not be changed.</p></li><li><p><code>w</code> (Write/Flags)</p><p>If you grant a user the Write access right, that user will be able to set message flags: i.e. to mark messages as answered or &quot;flagged&quot;, and to reset the message flags.</p></li><li><p><code>d</code> (Delete)</p><p>If you grant a user the Delete access right, that user will be able to mark messages as deleted and to compress the Mailbox, removing all its messages marked as deleted.</p></li><li><p><code>i</code> (Insert)</p><p>If you grant a user the Insert access right, that user will be able to append messages to this Mailbox and to copy messages from other Mailboxes into this one.</p></li><li><p><code>p</code> (Post)</p><p>This access right is not used by modern mailers.</p></li><li><p><code>c</code> (Create)</p><p>If you grant a user the Create access right, that user will be able to create new Mailboxes &quot;inside&quot; this Mailbox.</p></li><li><p><code>a</code> (Administer)</p><p>If you grant a user the Administer access right, that user will be able:</p><ul><li>to modify the Mailbox ACL</li><li>to modify the Mailbox meta-data (such as the Mailbox Class)</li><li>to see <a href="#Hidden">Hidden</a> Mailbox messages</li></ul></li></ul><p>When a sub-Mailbox is created, it inherits the ACL of the outer (parent) Mailbox. This means that if you create the <code>INBOX/sales</code> Mailbox, it is created with the same ACL as specified for the <code>INBOX</code> Mailbox.</p><p>To delete a foreign Mailbox, a user should have:</p><ul><li>the Create access right for the outer (parent) Mailbox, and</li><li>the Delete access right for the specified Mailbox</li></ul><p>To rename a foreign Mailbox, a user should have:</p><ul><li>the Create access right for the outer (parent) Mailbox of the original Mailbox, and</li><li>the Delete access right for the specified original Mailbox, and</li><li>the Create access right for the outer (parent) Mailbox of the new Mailbox (Mailbox name)</li></ul><p>To create a foreign Mailbox, a user should have the Create access right for the outer (parent) Mailbox of the Mailbox to be created.</p><p>When the target Mailbox is a &quot;top&quot; one in an Account, and thus there is no outer (parent) Mailbox, the &quot;CreateMailboxes&quot; <a href="./../objects/Accounts.html#AccessRights">Account Access Right</a> is checked instead.</p><p>The Mailbox Access Control Lists can be set and modified using the <a href="./WebMail.html#MailboxManagement">WebUser Interface</a>, a <a href="./../access/XIMSS.html">XIMSS</a>, a <a href="./../access/MAPI.html">MAPI</a>, or a decent <a href="./../access/IMAP.html">IMAP</a> client.</p><h2 id="Formats" tabindex="-1">Mailbox Formats <a class="header-anchor" href="#Formats" aria-label="Permalink to &quot;Mailbox Formats {#Formats}&quot;">​</a></h2><p>CommuniGate Pro stores received messages in Account Mailboxes. The server supports several Mailbox formats, and the Mailbox type is defined by the Mailbox file (or directory) name extension.</p><p>For single-Mailbox Accounts, the Mailbox type is specified when the Account is created.</p><p>Each multi-Mailbox Account has a <a href="./../objects/Accounts.html#MailboxType">setting</a> that specifies the default type for all new Mailboxes created in this Account. A user can explicitly specify the Mailbox type creating a Mailbox in a multi-Mailbox Account: if the Mailbox name is specified as <code>_name_._extension_</code>, then the Mailbox <em>name</em> of the <em>extension</em> type is created.</p><h3 id="mbox" tabindex="-1">The Text Mailbox (<code>.mbox</code>) Format <a class="header-anchor" href="#mbox" aria-label="Permalink to &quot;The Text Mailbox (\`.mbox\`) Format {#mbox}&quot;">​</a></h3><p>The Mailbox files with this extension store messages in the legacy BSD mailbox format. Each message in the Mailbox is preceded with the a <em>From-line</em>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From &lt;&gt;(flags-UID-origUID) timestamp</span></span></code></pre></div><p>This is the same format as one used in legacy mail systems, but with a &quot;comment&quot; added after the return-path part. The .mbox format remains compatible with legacy applications (local mailers), and at the same time it allows the CommuniGate Pro Server to store the required message information (message status flags, the unique Mailbox message ID, and, optionally, the &quot;permanent&quot; message UID).</p><p>If a Mailbox file has been copied from an old system, or when it is used as an <a href="./../objects/Domains.html#Legacy">Legacy INBOX</a> and old applications can add messages to this Mailbox, some messages may have no &quot;comment;&quot; part. CommuniGate Pro allows a user to work with such messages, but it does not store message flags if they were modified, and it does not remember the message UIDs between sessions. The simplest solution is to copy such messages to a different Mailbox and then copy them back to the original Mailbox - the copy operation places the correct information into the <em>From-line</em>.</p><p>When a message is being stored in the <code>.mbox</code>-type Mailbox, all message lines are checked. If there is an empty line followed with the line starting with the letters <code>From</code>, the &#39;<code>&gt;</code>&#39; symbol is inserted before the letter <code>F</code>.</p><p>The Text Mailboxes become less effective as their size grows. When a Text Mailbox is being opened, it has to be parsed, in order to detect message boundaries and retrieve the UID, flags, and other per-message information. When some messages are being deleted from the middle of a Text Mailbox, the Server has to copy the remaining messages data, compressing the Mailbox. To make these processes more efficient, the CommuniGate Pro server can deal with Mailbox data in large chunks. A special semaphore object limits the number of buffers allocated for large Mailbox processing. Changing this parameter can change the overall large Mailbox access (you may want to increase or decrease it, depending on the OS and file system you use).</p><p>To improve Text Mailbox opening speed, the CommuniGate Pro can maintain a Mailbox index (<code>.bdx</code>) file alongside the Text Mailbox Mailbox file. If the index file exists, the Server reads it instead of parsing the entire Mailbox file. CommuniGate Pro automatically creates an index file when it the Mailbox file size exceeds the specified limit. The Server removes the index file if the Mailbox becomes smaller than that limit.<br> The Index file is created when any message in the Mailbox is modified or deleted. If new messages have been added to the Mailbox, but the Mailbox has not been opened, or it has been only read without any flag modification, the Index file may not be created.</p><p>To store Message Attributes, special &quot;invisible&quot; messages are created in the Text Mailbox.</p><p>Use the WebAdmin Interface to specify the Text Mailbox Manager settings. Open the General pages in the Settings realm, and find the Text Mailbox Manager panel on the Others page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Text Mailbox Manager</b></td></tr><tr><td align="right">Concurrently used large buffers:</td><td><select name="NumLargeBuffers"><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="20" selected="selected">20</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="21">other</option></select></td></tr><tr><td align="right">Index Mailboxes larger than:</td><td><select name="MBOXSizeToIndex"><option value="10240">10K</option><option value="30720">30K</option><option value="102400">100K</option><option value="307200" selected="selected">300K</option><option value="1048576">1024K</option><option value="3145728">3M</option><option value="10485760">10M</option><option value="31457280">30M</option><option value="104857600">100M</option><option value="314572800">300M</option><option value="1073741824">1024M</option><option value="3221225472">3G</option><option value="10737418240">10G</option><option value="32212254720">30G</option><option value="30721">other</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Concurrently used large buffers</code></p><p>Use this setting to specify how many concurrent operations (parsing, deletion) the Text Mailbox Manager can perform on large Mailboxes.</p></li><li><p><code>Index Mailboxes larger than</code></p><p>Use this setting to specify the minimal size for Mailboxes that need indexing.</p></li></ul><h3 id="mdir" tabindex="-1">The MailDir Mailbox (<code>.mdir</code>) Format <a class="header-anchor" href="#mdir" aria-label="Permalink to &quot;The MailDir Mailbox (\`.mdir\`) Format {#mdir}&quot;">​</a></h3><p>Mailboxes with this extension are file directories. Each Mailbox message is stored as a separate file in the Mailbox directory.</p><p>The message file name has the following format:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>iiiiOoooo-flags-timestamp-nLines</span></span></code></pre></div><p>where <em>iiii</em> is the message unique ID, O<em>oooo</em> is the message permanent UID (optional), <em>flags</em> are the message status flags, the <em>timestamp</em> is the message <em>internal time stamp</em> - the time (GMT) when the message was added to the Mailbox, in the <code>yyyymmddhhmmss</code> format, and <em>nLines</em> is the number of text lines in the message.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>On the Unix platforms, the MailDir Mailboxes implement the <em>shared storage model</em>: if the same message is directed to many Accounts/Mailboxes, only one message file is created, and a <em>hard link</em> to that file is placed into each Mailbox directory.<br> When a message is removed from all Mailboxes, the file is automatically deleted by the OS.<br> This feature is disabled for the Accounts that have the &quot;Zap Deleted Messages&quot; Setting enabled.</p></div><p>To store Message Attributes, special files with O<em>oooo</em> names are created inside the Mailbox directory.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Most freeware mail systems use either the mbox-like or mdir-like formats, and designers of those systems make various claims about the advantages of the formats they have selected. It is important to remember that:</p><ul><li>CommuniGate Pro does not use OS or file system features (locks) to provide multi-access to Mailboxes. CommuniGate Pro Mailboxes in all formats can be accessed by several clients and components at the same time, and all synchronization is implemented inside the CommuniGate Pro Mailbox Manager that works in the same way for all Mailbox formats.</li><li>CommuniGate Pro uses efficient mechanisms to parse Mailboxes, so many claims about various Mailbox formats being &#39;slower&#39; or &#39;faster&#39; than other formats usually do not apply to CommuniGate Pro installations.</li><li>CommuniGate Pro allows users to create Mailboxes in different formats, even within the same Account.</li></ul></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Text format is more efficient than the MailDir format in most cases, this is why this format is used as the default one. The MailDir format is recommended only for those Mailboxes that contain many (100 or more) large (1MB or more) messages. If a user has a <code>Proposals</code> Mailbox where she stores all messages with attached documents, each 0.5-5MB in size, then this Mailbox may work faster if it is created in the .mdir format.</p></div><h3 id="mslc" tabindex="-1">The Sliced Mailbox (<code>.mslc</code>) Format <a class="header-anchor" href="#mslc" aria-label="Permalink to &quot;The Sliced Mailbox (\`.mslc\`) Format {#mslc}&quot;">​</a></h3><p>Mailboxes with this extension are file directories. These directories contain <code>data_NNNN_</code> files, each file contains one or more messages, in the format similar to one used in Text Mailboxes.</p><p>The <code>index.bdx</code> file contains the mailbox index, and includes information for all messages stored in all data files.</p><p>As new messages are added to such a Mailbox, they are either appended to the existing data files, or stored in a newly created data file, depending on the message size and the size and number of messages stored in the existing data files.</p><p>When messages are removed, data files can be merged to keep the total number of data files low.</p><h3 id="mb4" tabindex="-1">The 4th Version Mailbox (<code>.mb4</code>) Format <a class="header-anchor" href="#mb4" aria-label="Permalink to &quot;The 4th Version Mailbox (\`.mb4\`) Format {#mb4}&quot;">​</a></h3><p>Mailboxes with this extension are file directories. All files in those directories have <code>.mb4</code> extensions, or <code>.emb4</code> if the Mailbox is encrypted.</p><p>The files are pseudo-textual: they may be viewed as text, but cannot be edited and may contain non-printable charcaters. The CR+LF combination is used as EOL (end-of-line) regardless of the Server OS convention.</p><p>The messages are stored in <code>data_NNNN_.mb4</code> files.</p><p>To store Message Flags and Attributes, mailbox index, settings and other data, some special files are created inside the Mailbox directory.</p><p>When messages are deleted by user they are only marked for deletion and not displayed to the user, and they may remain in the mailbox files for some time. The marked for deletion messages are physically removed on the server discretion. To hide the contents of the messages being deleted the &quot;Zap Deleted Messages&quot; Setting can be enabled.</p><p>The files from the Mailbox directory are binary and must not be converted when moving between Unix and Windows OSes.</p><h2 id="Classes" tabindex="-1">Mailbox Classes <a class="header-anchor" href="#Classes" aria-label="Permalink to &quot;Mailbox Classes {#Classes}&quot;">​</a></h2><p>Each Mailbox can have a Class attribute. This attribute specifies the type of the information this Mailbox is created for: Calendar, Contacts, Tasks, Notes, etc. If a Mailbox does not contain the Class attribute, it means that it is created to store regular E-mail messages.</p><p>The Mailbox Class does not restrict the types of data that can be stored in the Mailbox: E-mail and Contacts messages can be stored in Mailboxes with the Tasks Class, Notes messages can be stored in Calendar Class Mailboxes, etc. The Mailbox Class information is used with the advanced user interfaces (WebUser, MAPI) to present the Mailbox content in the proper format.</p><p>When a Mailbox is created with an advanced client interface, the interface can set the Mailbox Class. Mailbox Classes can also be updated using the CommuniGate Pro <a href="./../../development/CLI.html">CLI/API</a>.</p><h2 id="Special" tabindex="-1">Special Mailboxes <a class="header-anchor" href="#Special" aria-label="Permalink to &quot;Special Mailboxes {#Special}&quot;">​</a></h2><p>Some Mailboxes have special meanings.</p><p>The <code>INBOX</code> Mailbox receives all incoming E-mail messages, unless these messages are explicitly directed to other Mailboxes with <a href="./../mail/QueueRules.html">Rules</a> or using <a href="./../mail/Local.html#Direct">Direct Mailbox Addressing</a>.<br> When an Account is created, its <code>INBOX</code> Mailbox is created automatically.</p><p>Other special Mailboxes do not have fixed names. The Account user or an administrator can specify or modify the name used for any special Mailbox. These names are stored in Account Preferences.</p><p>The CommuniGate Pro Server recognizes Special Mailbox names (starting and ending with the <code>$</code> symbols) as references to special Mailboxes. This feature allows client applications to access special Mailboxes in any Account, without being reconfigured to use the actual name of those special Mailboxes. These Special names do not show up in the Account Mailbox lists.</p><ul><li><p>Trash</p><p>This Mailbox is used to store messages to be deleted. Clients can move messages from other Mailboxes to this Mailbox, using it as a &quot;Tash can&quot;. Special name: <code>$Trash$</code></p></li><li><p>Sent Messages</p><p>This Mailbox is used to store copies of sent E-mail messages. Special name: <code>$Sent$</code></p></li><li><p>Outgoing Messages</p><p>This Mailbox is used to store delayed E-mail messages scheduled to be sent some time later. Special name: <code>$Outgoing$</code></p></li><li><p>Drafts</p><p>This Mailbox is used to store E-mail message drafts. Special name: <code>$Drafts$</code></p></li><li><p>Junk</p><p>This Mailbox is used to store junk E-mail messages. Special name: <code>$Junk$</code></p></li><li><p>History</p><p>This Mailbox is used to store &quot;log&quot;-type messages, such as copies of the IM sessions. Special name: <code>$History$</code></p></li><li><p>Default Calendar</p><p>This Mailbox is used as the Account main Calendar Mailbox. This Mailbox is expected to be of the <a href="#Classes">Calendar class</a>. Special name: <code>$Calendar$</code></p></li><li><p>Default Task List</p><p>This Mailbox is used as the Account main Tasks Mailbox. This Mailbox is expected to be of the <a href="#Classes">Tasks class</a>. Special name: <code>$Tasks$</code></p></li><li><p>Default Contacts</p><p>This Mailbox is used as the Account main Contacts Mailbox. This Mailbox is expected to be of the <a href="#Classes">Contacts class</a>. Special name: <code>$Contacts$</code></p></li><li><p>Default Notes</p><p>This Mailbox is used as the Account main Notes Mailbox. This Mailbox is expected to be of the <a href="#Classes">Notes class</a>. Special name: <code>$Notes$</code></p></li></ul><h2 id="Locked" tabindex="-1">Locked Mailboxes <a class="header-anchor" href="#Locked" aria-label="Permalink to &quot;Locked Mailboxes {#Locked}&quot;">​</a></h2><p>Each Mailbox can have the Locked attribute. If this attribute is set, the Mailbox cannot be deleted or renamed.</p><p>A locked Mailbox can be deleted or renamed together with its parent Mailbox, if the parent Mailbox itself is not locked.</p><p>You can specify the Locked attribute for the Mailboxes created using the <a href="./../objects/Accounts.html#Template">Account Template</a>. The Mailbox Locked attribute can also be updated using the CommuniGate Pro <a href="./../../development/CLI.html">CLI/API</a>.</p><h2 id="Creating" tabindex="-1">Creating Mailboxes <a class="header-anchor" href="#Creating" aria-label="Permalink to &quot;Creating Mailboxes {#Creating}&quot;">​</a></h2><p>Every Account has a <a href="./../objects/Accounts.html#MailboxType">setting</a> that specifies the default format for new Mailboxes that can be created in this Account.</p><p>The Account user can explicitly specify the storage format for a new Mailbox by adding the format extension to the new Mailbox name. If a user tells the CommuniGate Pro Server to create the <code>newmailbox.mdir</code> Mailbox, the <code>.mdir</code>-formatted Mailbox <code>newmailbox</code> is created.</p><h2 id="Subscription" tabindex="-1">Mailbox Subscription <a class="header-anchor" href="#Subscription" aria-label="Permalink to &quot;Mailbox Subscription {#Subscription}&quot;">​</a></h2><p>The CommuniGate Pro Server allows an Account user to <em>subscribe</em> to some Mailboxes. The Account Mailbox subscription is a simple list of Mailbox names. This list is not used by the Server itself - the Server just stores one subscription list for each Account.</p><p>Many <a href="./../access/IMAP.html">IMAP</a> mailers use the Account subscription list and show only the Mailboxes the Account is subscribed to. The <a href="./WebMail.html#Subscription">WebUser Interface</a> can also be configured to show only the subscribed Mailboxes.</p><p>You can modify the Account subscription either via a decent IMAP mailer, or using the WebUser Interface.</p><p>You can use the Account Mailbox subscription to make some not-so-decent IMAP mailers access foreign Mailboxes: make sure that your IMAP client is configured to use the Account Mailbox subscription, and add the desired <a href="#Foreign">foreign Mailbox</a> name into the subscription list.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some IMAP mailers tend to rebuild Account subscription lists: they empty the subscription, and then subscribe you to all Mailboxes in your own Account.</p></div><p>The Account Mailbox subscription is stored in the Account <code>.info</code> service file.</p><h2 id="Aliases" tabindex="-1">Mailbox Aliases <a class="header-anchor" href="#Aliases" aria-label="Permalink to &quot;Mailbox Aliases {#Aliases}&quot;">​</a></h2><p>Many <a href="./../access/IMAP.html">IMAP</a> clients (such as Microsoft Outlook and Outlook Express) and <a href="./../access/AirSync.html">AirSync</a> clients (such as Windows Mobile, Apple iPhone, Nokia PDAs, etc.) cannot handle <a href="#Foreign">foreign Mailboxes</a> directly, and they cannot use the Account <a href="#Subscription">Mailbox subscription</a> to access foreign Mailboxes.</p><p>Mailbox Aliases can be used to let these clients access foreign Mailboxes.</p><p>A Mailbox Alias is a name associated with some [foreign] Mailbox name. For example, you can create a Mailbox Alias <code>salesBox</code> for the <code>~sales/INBOX</code> Mailbox name. You will see the <code>salesBox</code> Mailbox in your client application, but in reality this will be the <code>INBOX</code> Mailbox in the <code>sales</code> Account.</p><p>Mailbox Aliases can be created only on the topmost level of the Account Mailbox hierarchy, that means that the Mailbox Alias name cannot contain the slash (<code>/</code>) symbol.</p><p>A Mailbox Alias provides access to the Mailbox it is associated with, and to all its sub-mailboxes (subject to <a href="#ACL">Access Control List</a> restrictions).</p><p>A Mailbox Alias can contain just a foreign Account name (<code>~_accountName_</code>). Such an Alias provides access to all accessible Mailboxes in that foreign Account. The Mailbox Alias itself is presented as an unselectable Mailbox name.</p><p>Sample configuration: The owner of the Account <code>chief</code> has granted &quot;lookup&quot; and other access rights for his Mailboxes <code>INBOX</code> and <code>Pending</code> to the <code>assistant</code> Account.</p><p>The user <code>assistant</code> has created the Mailbox Alias <code>boss</code> pointing to <code>~j.smith</code>.</p><p>When the user <code>assistant</code> connects to her Account using any IMAP or XIMSS client, or the WebUser Interface, she sees all her own Mailboxes, the unselectable Mailbox <code>boss</code>, and also the <code>boss/INBOX</code> and <code>boss/Pending</code> Mailboxes.</p><p>If the user <code>j.smith</code> creates a new Mailbox <code>Urgent</code> in his Account and grants access rights for that Mailbox to the <code>assistant</code> Account, the user <code>assistant</code> will immediately see the new Mailbox as the <code>boss/Urgent</code> Mailbox.</p><h2 id="MultiAccess" tabindex="-1">Simultaneous Access <a class="header-anchor" href="#MultiAccess" aria-label="Permalink to &quot;Simultaneous Access {#MultiAccess}&quot;">​</a></h2><p>The CommuniGate Pro Server allows several client applications to connect, open the same Mailbox, and read and modify the Mailbox data at the same time.</p><p>The CommuniGate Pro <em>multithreaded</em> design allows the Server to synchronize client activities without using OS-level <em>file locks</em> and it does not require a client to wait till all other clients close the Mailbox.</p><p>Simultaneous Access means that:</p><ul><li>several clients can have simultaneous access to the same Mailbox</li><li>new messages can be added to a Mailbox while mailer clients are working with that Mailbox</li><li>messages can be deleted from a Mailbox while mailer clients are working with that Mailbox</li></ul><p>Clients accessing the same Mailbox can use the same or different Mailbox access protocols - <a href="./../access/POP.html">POP</a>, <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/MAPI.html">MAPI</a>, <a href="./../access/AirSync.html">AirSync</a>, <a href="./../access/WebUser.html">WebUser</a>, or <a href="./../../development/XMLAPI.html">XIMSS</a> Interface.</p><p>Simultaneous Access is supported for all <a href="./Mailboxes.html">Mailbox types</a> implemented in the CommuniGate Pro software.</p><p>This feature allows you to work with your Mailbox from several workstations and devices, and it lets a group of people (i.e. the sales department) process messages in one centralized Mailbox.</p><h2 id="Foreign" tabindex="-1">Foreign and Public Mailboxes <a class="header-anchor" href="#Foreign" aria-label="Permalink to &quot;Foreign and Public Mailboxes {#Foreign}&quot;">​</a></h2><p>The CommuniGate Pro allows an Account user to access Mailboxes in other Accounts.<br> Access to these foreign Mailboxes (also called shared Mailboxes) is controlled via the <a href="#ACL">Mailbox Access Rights</a>.</p><p>To access a Mailbox in a different Account, the Mailbox name should be specified as <code>~_accountname_/_mailboxname_</code>. For example, to access the <code>INBOX</code> Mailbox in the Boss Account, the Mailbox name should be specified as <code>~Boss/INBOX</code> .</p><p>If there are several local Domains on the Server, Mailboxes in a different Domain can be accessed by specifying full Account names. To access the <code>LIST/reports</code> Mailbox in the Account ListMaster in the client.com Domain, the Mailbox name should be specified as <code>~ListMaster@client.com/LIST/reports</code>.</p><p>Account names specified after the &quot;~&quot; sign are processed with the <a href="./../sysadmin/Router.html">Router</a>, so Account Alias names can be used instead of the real Account names, and all Routing Table rules are applied.</p><p>Very often Foreign Mailboxes are used:</p><ul><li>to let a secretary view and mark messages in your INBOX;</li><li>to let several sales persons see and process a single &quot;sales maildrop&quot; - the INBOX of the <code>sales</code> Account;</li><li>to let several engineers see and process a single &quot;technical support maildrop&quot; - the INBOX of the <code>support</code> Account.</li></ul><p>CommuniGate Pro can provide &quot;public&quot; Mailboxes, too. This can be done by creating an Account <code>public</code>, and assigning public Access rights to its Mailboxes. Usually, each group of public Mailboxes is managed by some administrator, who is not required to be a CommuniGate Pro administrator.</p><p>A CommuniGate Pro Server administrator should create the <code>public</code> Account, log into that Account using the WebUser Interface or a decent IMAP client, create some public Mailboxes, and grant administration rights to regular users that will administer these public Mailboxes. Those users will then grant access rights to other users, create sub-Mailboxes, and perform other administrative tasks.</p><p>For example, a public Mailbox administrator can use <a href="./../mail/QueueRules.html">Automated Rules</a> to copy certain incoming messages directly into some public Mailbox.</p><p>Some IMAP clients (such as Microsoft Outlook and Outlook Express), and most AirSync clients do not support foreign Mailboxes at all. To let those clients access shared Mailboxes in other Accounts, <a href="./Mailboxes.html#Aliases">Mailbox Aliases</a> can be used.</p><h2 id="Legacy" tabindex="-1">Legacy Mailboxes <a class="header-anchor" href="#Legacy" aria-label="Permalink to &quot;Legacy Mailboxes {#Legacy}&quot;">​</a></h2><p>On some systems users have direct (login) access to the mail server computer, and some of them get used to <em>Local Mailers</em> - <code>mail</code>, <code>elm</code>, and others. <em>Local Mailers</em> do not use any network protocol to access mailboxes. Instead, those programs read and modify mailbox files directly, via the file system.</p><p>The CommuniGate Pro allows you to create Accounts with <em>Legacy</em> INBOX Mailboxes. These Mailboxes are stored not inside the CommuniGate Pro <em>base directory</em>, but in the system directory known to the legacy mailer applications.</p><p>Since these INBOX files can be read and modified directly, bypassing the CommuniGate Pro protocols and modules, the Server needs to synchronize its activity with legacy mail applications using OS <em>file locking</em> features - either FileLevel locks or FileRange locks.</p><p>On Unix systems the FileLevel locks are known as <code>flock</code> operations, and RangeLevel locks are known as <code>fcntl</code> operations. Check with your OS manual to see which method the legacy mailers use on your system, and configure the CommuniGate Pro Server to use that method. For systems that support only one file locking mechanism (MS Windows, Sun Solaris, and some other systems), selecting either method selects that mechanism.</p><p>You should use Legacy Mailboxes only when absolutely necessary, because:</p><ul><li>access to Legacy Mailboxes is less effective as it consumes resources needed for OS <em>file locking</em>.</li><li><em>local mailer</em> applications do NOT synchronize correctly, and <strong>there is always a chance that a local mailer destroys a mailbox</strong>. If some of your users have to work via local mailers, warn them about this fact, and ask them to avoid using <em>local mailers</em> and modern (protocol-based) mailers at the same time. These bugs in most local mailers do not show up if messages are only added to the mailbox when a local mailer is active. Local mailers may corrupt mailboxes if messages are deleted from a mailbox during the time a local mailer is active.</li></ul><p>If you have to support Local Mailer compatibility for all or some Accounts in a Domain (usually - in the Main Domain), you should specify the <a href="./../objects/Domains.html#Legacy">Legacy INBOX</a> settings for that Domain.</p><p>When you create an Account that has an Legacy INBOX, the Server checks if the Account INBOX file already exists in the specified location and creates one if the Mailbox file is absent.</p><p>When you delete an Account that has an Legacy INBOX, the Server does NOT remove the INBOX Mailbox file.</p><h2 id="Logs" tabindex="-1">Server Log Records <a class="header-anchor" href="#Logs" aria-label="Permalink to &quot;Server Log Records {#Logs}&quot;">​</a></h2><p>Log records created for Mailbox-related events have the MAILBOX tag.<br> The level of records being recorded for Mailboxes is specified in <a href="./../objects/Domains.html#Settings">Domain</a> settings.</p><p>The records contain Account name and Mailbox name. Non-ASCII characters in Mailbox names are encoded in modified UTF-7.</p><p>The records level 0 (Crashes) contain messages about critical failures which require attention of the Server administrator.</p><p>The records level 1 (Failures) contain messages about failures which can be fixed by the Server automatically or ignored.</p><p>The records level 2 (Major &amp; Failures) contain messages about:</p><ul><li>Mailbox opening and closing</li><li>appending a message</li><li>deleting a message</li><li>message flags changing</li><li>message attributes changing</li></ul><p>Also there are messages about:</p><ul><li>creation of a Mailbox</li><li>Mailbox deletion</li><li>Mailbox renaming</li><li>changing Mailbox access rights</li></ul><p>The records level 3 (Problems) partially duplicate the messages of level 2, but contain more detailed information about the operations performed (size of mail messages, specific names of the flags to be changed, etc.).</p><p>The records level 4 (Low Level) and 5 (All Info) contain messages about reading mail, as well as other messages specific to the particular folder format (about operations with the file system, etc.).</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span> 1. … 2 MAILBOX(user@domain/INBOX) #1 opened by IMAP-000022, 1 open</span></span>
<span class="line"><span> 2. … 2 MAILBOX(user@domain/INBOX) #2 opened by WEBUSER-000033, 2 open</span></span>
<span class="line"><span> 3. … 2 MAILBOX(user@domain/INBOX) #3 opened by LOCAL-000001, 3 open</span></span>
<span class="line"><span> 4. … 3 MAILBOX(user@domain/INBOX) {181} appended [1] @7454: 70+1169 bytes</span></span>
<span class="line"><span> 5. … 2 MAILBOX(user@domain/INBOX) #3 {181} appended</span></span>
<span class="line"><span> 6. … 2 MAILBOX(user@domain/INBOX) [17701] stored as {181}</span></span>
<span class="line"><span> 7. … 2 MAILBOX(user@domain/INBOX) #3 closed, 2 open</span></span>
<span class="line"><span> 8. … 3 MAILBOX(user@domain/INBOX) #2 flags update (1): +Seen,Deleted</span></span>
<span class="line"><span> 9. … 2 MAILBOX(user@domain/INBOX) #2 {181} flags updated</span></span>
<span class="line"><span>10. … 2 MAILBOX(user@domain/INBOX) #2 closed, 1 open</span></span>
<span class="line"><span>11. … 2 MAILBOX(user@domain/INBOX) #1 {181} deleted</span></span>
<span class="line"><span>12. … 2 MAILBOX(user@domain/INBOX) #1 closed, 0 open</span></span></code></pre></div><p>Interpretation:</p><ol><li>the mailbox INBOX of user@domain Account was opened by IMAP-000022 with session #1, there is 1 open session</li><li>the mailbox was opened by WEBUSER-000033 with session #2, there are 2 open sessions</li><li>the mailbox was opened by LOCAL module with session #3, there are 3 open sessions</li><li>a message with ID 181 was appended to the mailbox into file 1 at offset 7454: there are 1169 bytes of data and 70 of metadata</li><li>the session #3 appended the message with ID 181 to the mailbox</li><li>the message with ID 17701 from Queue was srored into the mailbox with ID 181</li><li>the session #3 was closed, there are 2 open sessions</li><li>the session #2 requested updating flags of one message: adding flags Seen and Deleted</li><li>the session #2 changed flags of message 181</li><li>the session #2 was closed, there are 2 open sessions</li><li>the session #1 deleted the message 181</li><li>the session #1 was closed, there are no more open sessions</li></ol>`,150)]))}const u=a(i,[["render",l]]);export{p as __pageData,u as default};
