import{_ as r,C as l,c as d,o as c,ag as a,j as e,a as i,G as o,w as s}from"./chunks/framework.jCcxW76o.js";const w=JSON.parse('{"title":"Public Key Infrastructure","description":"","frontmatter":{"legacyLink":"PKI.html"},"headers":[],"relativePath":"admin/sysadmin/PKI.md","filePath":"admin/sysadmin/PKI.md"}'),u={name:"admin/sysadmin/PKI.md"},h={action:"Null.html"},p={class:"settingsBox"},m={width:"100%"},f={class:"settingsBox"},y={width:"100%"};function g(b,t,C,S,v,A){const n=l("font");return c(),d("div",null,[t[12]||(t[12]=a(`<h1 id="public-key-infrastructure" tabindex="-1">Public Key Infrastructure <a class="header-anchor" href="#public-key-infrastructure" aria-label="Permalink to &quot;Public Key Infrastructure&quot;">​</a></h1><p>Regular (&quot;classical&quot;) cryptography methods use data blocks called &quot;secret keys&quot;. Information encrypted using some &quot;secret key&quot; can be decrypted by anyone who knows the encryption method and posses the same &quot;secret key&quot;. This type of cryptography is called symmetric cryptography.</p><p>An alternative cryptography method is based on key pairs - a &quot;private key&quot; and a &quot;public key&quot;. These keys must be generated together using special algorithms. Any information encrypted with the &quot;private key&quot; can be decrypted by anyone who knows the matching &quot;public key&quot;, and any information encrypted with the &quot;public key&quot; can be decrypted using the matching &quot;private key&quot;.<br> The Public Key Infrastructure (PKI) is the technology based on this asymmetric cryptography.</p><h2 id="Terms" tabindex="-1">PKI Terminology <a class="header-anchor" href="#Terms" aria-label="Permalink to &quot;PKI Terminology {#Terms}&quot;">​</a></h2><ul><li><p><strong>Private Key</strong></p><p>A block of data (a large binary number) generated using one of the PKI algorithms. Each party taking part in secure communications should keep its Private Key securely. This key should never be transferred between communication parties.</p></li><li><p><strong>Public Key</strong></p><p>A block of data (a large binary number) generated together with the Private Key. Each party taking part in secure communications can and should distribute its Public key openly. It is assumed that Public Key can be learned by anyone, including hostile entities. Public Keys are usually distributed in the form of Certificates.</p></li><li><p><strong>Data Digest</strong></p><p>A relatively small block of data calculated by applying a special digest function to the original (usually larger) data block.</p></li><li><p><strong>Data Signature</strong></p><p>A Digest of the Data block encrypted using the Private Key of the Signer.</p></li><li><p><strong>Signed Data</strong></p><p>A data block with attached Signature of that block. A party receiving Signed Data can verify that the data block has not been modified in transit by using the Public Key of the Signer to decrypt the Signature and to compare the resulting Data Digest with the Data Digest it calculated itself.</p></li><li><p><strong>Certificate</strong></p><p>A data block with containing the name of the Certificate owner (called Certificate Subject), the Public Key of the owner, the name of the Certificate Issuer, the serial number of the Certificate, and some additional data elements. This data block is signed by the Issuer.<br> Certificates play the role of Digital ID cards.</p></li><li><p><strong>Issuer</strong></p><p>A party that issues Certificates for other parties, signing them with the Private Key of the Issuer. Issuers are also called Certificate Authorities. Each certificate generated by a certain Issuer has a unique serial number.</p></li><li><p><strong>Trusted Authorities</strong></p><p>A list individually maintained by a communication party. Each list element contains the name of a &quot;trusted authority&quot; and its Public Key.<br> When a party receives any Certificate, it can check if the Certificate Issuer is included into the &quot;trusted authority&quot; list, and that the Certificate Signature can be verified using that &quot;trusted authority&quot; Public Key.<br> Modern operating systems allow users to securely maintain Trusted Authorities databases on their desktops.</p></li><li><p><strong>Root Authorities</strong></p><p>Globally recognized Certificate Authorities. Most modern operating systems pre-insert several Root Authorities into the client Trusted Authorities databases, making Root Authorities trusted by all client computers running these operating systems.</p></li><li><p><strong>Authority Chain</strong></p><p>A set of Issuer Certificates for a certain Certificate.<br> Some Authority X may be not widely accepted as a &quot;trusted one&quot;, but its Certificate may be issued by a more widely trusted Authority Y. In this case Certificates issued by X won&#39;t be widely accepted, but if those Certificates are sent together with the X own Certificate, issued by Y, then these Certificates may be accepted by all parties that trust Y.</p></li><li><p><strong>Self-Signed Certificate</strong></p><p>A Certificate issued by a party for itself. The Subject and Issuer of such a Certificate are the same. The Self-Signed Certificate contains the party Public Key and is signed using the Private Key of the same party.<br> Self-Signed Certificates can be trusted only if other parties explicitly include them into their lists of &quot;trusted authorities&quot;.</p></li><li><p><strong>Multiparty Encryption</strong></p><p>An encryption method used to send data to parties with known Certificates. A single encrypted messages can be independently decrypted by any party that possesses a Private Key matching one of the Certificates used for encryption.</p></li></ul><h2 id="DomainKeys" tabindex="-1">Domain PKI Settings <a class="header-anchor" href="#DomainKeys" aria-label="Permalink to &quot;Domain PKI Settings {#DomainKeys}&quot;">​</a></h2><p>Each CommuniGate Pro Domain has its own PKI settings. They include a Private Key associated with the Domain and Certificates containing the matching Public Keys.</p><p>To configure the Domain PKI settings, use the WebAdmin Interface to open the Domain Settings page for the target Domain, and click the Security link. The PKI page will appear:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>PKI Services</b></td></tr><tr><td align="center"><select name="CertificateType"><option value="-1" selected="selected">default(Test)</option><option value="0">Enabled</option><option value="1">Disabled</option><option value="2">Test</option></select></td></tr></tbody></table></div></form><p>This option allows you to specify the PKI Mode for this Domain:</p><ul><li><p><code>Disabled</code></p><p>If this option is selected, PKI Functions for this Domain are disabled. If this option is selected, all other Domain PKI settings have no effect.</p></li><li><p><code>Test</code></p><p>If this option is selected, the Server-wide Test Private key and self-signed Test Certificate are used for this Domain. You do not have to configure any other Domain PKI settings if this option is selected. Use this mode for testing purposes only.<br> The Server-wide Test Certificate uses the Server Main Domain name as its Subject and <code>AO SBK</code> as the Issuer. The Test Certificate expires 30 days after the last Server restart time.</p></li><li><p><code>Enabled</code></p><p>If this option is selected, the Domain PKI functions are enabled.</p></li></ul><h3 id="KeyGen" tabindex="-1">Assigning a Private Key <a class="header-anchor" href="#KeyGen" aria-label="Permalink to &quot;Assigning a Private Key {#KeyGen}&quot;">​</a></h3><p>Initially CommuniGate Pro Domains do not have any Private Keys assigned. You should select the size of the key and click the Generate Key button to create a random Private Key and assign it to the Domain.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Private Key</b></td></tr><tr><td align="CENTER">Size:<select name="KeySize"><option value="0">Import</option><option value="512" selected="selected">512</option><option value="1024">1024</option><option value="2048">2048</option><option>4096</option></select></td><td align="CENTER" rowspan="2"> <input name="GenKey" type="reset" value="Generate Key" class="button"></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Depending on your server hardware platform, it can take up to several seconds to generate a 2048-bit Key.</p></div><p>Only after you assign a Private Key, the Certificate-related fields will appear on the Security page.</p><p>You can use any third-party program to generate a Private Key. You should instruct that program to output the Private Key in the <code>PEM format</code> (as shown below).<br> Select the <code>Import</code> option in the Size: menu and click the Generate Key button. A text field appears. Copy the PEM-encoded Key (in the RSA or PKCS#8 format) into that text field, and click the Generate Key button:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Private Key</b></td></tr><tr><td align="CENTER">Size:<select name="KeySize"><option value="0" selected="selected">Import</option><option value="512">512</option><option value="1024">1024</option><option value="2048">2048</option><option>4096</option></select></td><td align="CENTER"> <input name="GenKey" type="reset" value="Generate Key" class="button"></td></tr><tr><td align="center" colspan="2">Enter a PEM-encoded Private Key:<br><textarea name="PrivateKey" cols="65" rows="7">-----BEGIN RSA PRIVATE KEY-----
MIIBPAIBAAJBAKrbeqkuRk8VcRmWFmtP+LviMB3+6dizWW3DwaffznyHGAFwUJ/I Tv0XtbsCyl3QoyKGhrOAy3RvPK5M38iuXT0CAwEAAQJAZ3cnzaHXM/bxGaR5CR1R rD1qFBAVfoQFiOH9uPJgMaoAuoQEisPHVcZDKcOv4wEg6/TInAIXBnEigtqvRzuy oQIhAPcgZzUq3yVooAaoov8UbXPxqHlwo6GBMqnv20xzkf6ZAiEAsP4BnIaQTM8S mvcpHZwQJdmdHHkGKAs37Dfxi67HbkUCIQCeZGliHXFa071Fp06ZeWlR2ADonTZz rJBhdTe0v5pCeQIhAIZfkiGgGBX4cIuuckzEm43g9WMUjxP/0GlK39vIyihxAiEA mymehFRT0MvqW5xAKAx7Pgkt8HVKwVhc2LwGKHE0DZM=
-----END RSA PRIVATE KEY-----</textarea></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Make sure that the key you import is not password-encrypted. Something like the following starting lines:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>-----BEGIN RSA PRIVATE KEY-----</span></span>
<span class="line"><span>Proc-Type: 4,ENCRYPTED</span></span>
<span class="line"><span>DEK-Info: DES-CBC,90C96A721C4E4B0B</span></span>
<span class="line"><span></span></span>
<span class="line"><span>GzLyio+Or3zXm1N7ILWlYDsR6cgPlzHomAxi6aeUthl4lSqBHaqMlh+/76I/6sNx</span></span>
<span class="line"><span>.................</span></span></code></pre></div><p>indicate that the Private Key is encrypted and it cannot be imported into the Server.</p></div><p>If the Private Key is set correctly, and the Key can be used for public/private key cryptography, you will see the following panel:</p>`,20)),e("form",h,[e("div",p,[e("table",m,[e("tbody",null,[t[2]||(t[2]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Private Key")])],-1)),t[3]||(t[3]=e("tr",null,[e("td",{align:"right"},"Key Size:"),e("td",null,"512 bit"),e("td",{rowspan:"2"},[i(" "),e("input",{name:"RemoveKey",value:"Remove Key and Certificate",class:"buttonRed",type:"reset"})])],-1)),e("tr",null,[t[1]||(t[1]=e("td",{align:"right"},"Encryption Test:",-1)),e("td",null,[o(n,{color:"GREEN"},{default:s(()=>t[0]||(t[0]=[e("i",null,"Verification String is OK",-1)])),_:1})])])])])])]),t[13]||(t[13]=a(`<p>If the Key Test field indicates an error, the imported Private Key cannot be used for public/private key cryptography.</p><p>Use the Remove button if you want to remove the entered Domain Private Key. Since the Domain Certificate can be used with one and only one Private Key, it becomes useless when you delete the Private Key, so the existing Domain Certificate will be removed, too.</p><h3 id="CertGen" tabindex="-1">Assigning a Certificate <a class="header-anchor" href="#CertGen" aria-label="Permalink to &quot;Assigning a Certificate {#CertGen}&quot;">​</a></h3><p>A Domain must have a Certificate to support PKI functions.</p><p>The Domain Certificate name (the Common Name part of the Certificate Subject field) should match the domain name used by client applications.<br> If a CommuniGate Pro Domain has Domain Aliases, attempts to connect to the Server using a Domain Alias name will result in warning messages on the client workstations notifying users about the name mismatch. Since a Certificate can contain only one name, select the name (the real Domain name or one of the Domain Aliases) that your users will use in their client application settings. If your CommuniGate Pro Domain name is <code>company.dom</code>, and that domain name does not have a DNS A-record, but the Domain has an Alias <code>mail.company.dom</code> that has an A-record pointing to the CommuniGate Pro Server, your users will use the <code>mail.company.dom</code> name in their client settings and WebUser Interface URLs, so the Domain Certificate should be issued for the <code>mail.company.dom</code> name rather than the <code>company.dom</code> name.</p><p>You may also use &quot;wildcard&quot; domain names for your certificates. If the Domain name has at least 2 components, the Common Name menu will contain a &quot;wildcard&quot; domain name: the name of the Domain with the first component substituted with the asterisk (<code>*</code>) symbol. If the Domain name has only 2 components, the asterisk component is added to form a 3-component name.</p><p>To create a Certificate, fill the fields in the Certificate Attributes table:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Certificate Generator</b></td></tr><tr><td align="right">Common Name:</td><td><select name="cn"><option value="d1.communigatepro.ru" selected="selected">d1.communigatepro.ru</option><option value="myalias.dom">myalias.dom</option><option value="*.communigatepro.ru">*.communigatepro.ru</option></select></td></tr><tr><td align="right">Alternative Names:</td><td><input name="SAN" value="d1.communigatepro.ru, d2.communigatepro.ru" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Country:</td><td><input name="c" value="RU" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Province:</td><td><input name="st" value="CA" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">City:</td><td><input name="l" value="Sausalito" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Organization:</td><td><input name="o" value="ACME Yacht Rentals, Inc." size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Unit:</td><td><input name="ou" value="On-line Services" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Contact:</td><td><input name="contact" value="bill@domain.company" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Signature:</td><td><select name="HashName"><option value="Default" selected="selected">default(SHA1)</option><option value="MD5">MD5</option><option value="SHA1">SHA1</option><option value="SHA2">SHA2</option></select></td></tr><tr align="center"><td><input name="GenTemp" value="Generate Self-Signed" class="button" type="reset"></td><td><input name="GenCSR" value="Create Signing Request" class="button" type="reset"></td></tr></tbody></table></div></form><ul><li><p><code>Common Name</code></p><p>When the Certificate is sent to a client application, the application checks that the Certificate Common Name matches the name the user has specified in the URL and/or in the mailer settings.</p></li><li><p><code>Alternative Names</code></p><p>Optional comma-separated list of additional host names for which this certificate should be considered valid. Usually includes the Common Name as the first element.</p></li><li><p><code>Contact</code></p><p>This field must contain a valid E-mail address, though that address does not have to be inside this CommuniGate Pro Domain.</p></li></ul><p>All other fields are optional.</p><p>To receive a Certificate from an external source (&quot;trusted authority&quot;), click the Generate Signing Request button. A text field containing the PEM-encoded CSR (Certificate Signing Request) will appear:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Certificate Generator</b></td></tr><tr><td align="right">Common Name:</td><td><select name="cn"><option value="d1.communigatepro.ru" selected="selected">d1.communigatepro.ru</option><option value="myalias.dom">myalias.dom</option><option value="*.communigatepro.ru">*.communigatepro.ru</option></select></td></tr><tr><td align="right">Country:</td><td><input name="c" value="US" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Province:</td><td><input name="st" value="CA" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">City:</td><td><input name="l" value="Sausalito" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Organization:</td><td><input name="o" value="ACME Yacht Rentals, Inc." size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Unit:</td><td><input name="ou" value="On-line Services" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Contact:</td><td><input name="contact" value="bill@domain.company" size="30" maxlength="200" type="text"></td></tr><tr align="center"><td><input name="GenTemp" value="Generate Self-Signed" class="button" type="reset"></td><td><input name="GenCSR" value="Create Signing Request" class="button" type="reset"></td></tr><tr><th colspan="2">Enter a PEM-encoded Certificate</th></tr><tr><td colspan="2" align="center"><textarea cols="65" rows="10">-----BEGIN CERTIFICATE REQUEST-----
MIIBZTCCAQ8CAQAwgakxCzAJBgNVBAYTAlVTMQswCQYDVQQIEwJDQTESMBAGA1UE
BxMJU2F1c2FsaXRvMSEwHwYDVQQKExhBQ01FIFlhY2h0IFJlbnRhbHMsIEluYy4x
GTAXBgNVBAsTEE9uLWxpbmUgU2VydmljZXMxFzAVBgNVBAMTDmQxLnN0YWxrZXIu
Y29tMSIwIAYJKoZIhvcNAQkBFhNiaWxsQGRvbWFpbi5jb21wYW55MFwwDQYJKoZI
hvcNAQEBBQADSwAwSAJBAKrbeqkuRk8VcRmWFmtP+LviMB3+6dizWW3DwaffznyH
GAFwUJ/ITv0XtbsCyl3QoyKGhrOAy3RvPK5M38iuXT0CAwEAAaAAMA0GCSqGSIb3
DQEBBAUAA0EABFysKDutO/ZF16Sp7+LL3IcjUb29xlvZSnBXYsD/qWKqUF4gzfch
4Qyxci6ynsh7HNjdJBFdFyO+J2ywXZilYg==
-----END CERTIFICATE REQUEST-----</textarea><br><i>submit this request to a Certification Authority and paste the result below</i></td></tr><tr><th colspan="2">Enter a PEM-encoded Certificate</th></tr><tr><td colspan="2" align="center"><textarea name="Certificate" rows="10" cols="72" class="settingsTextarea"></textarea><br><input name="SetCert" value="Set Certificate" class="button" type="reset"></td></tr></tbody></table></div></form><p>Copy the CSR text and submit it to the Certification Authority (CA) of your choice. You can submit via E-mail or using a Web form on the CA site. The Certification Authority should send you back the signed Certificate in the PEM-format. Enter that Certificate into the bottom field and click the Set Certificate button.</p><p>If the Certificate is accepted, the Certificate information is displayed:</p>`,14)),t[14]||(t[14]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Domain Certificate")])]),e("tr",{valign:"top"},[e("th",{align:"right"},[e("b",null,"Issued to:")]),e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,"Country"),e("td",null,"US")]),e("tr",null,[e("td",null,"Province"),e("td",null,"CA")]),e("tr",null,[e("td",null,"City"),e("td",null,"Sausalito")]),e("tr",null,[e("td",null,"Organization"),e("td",null,"ACME Yacht Rentals, Inc.")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"On-line Services")]),e("tr",null,[e("td",null,[e("i",null,"Common Name")]),e("td",null,"d1.communigatepro.ru")]),e("tr",null,[e("td",null,"Contact"),e("td",null,"bill@domain.company")])])])])]),e("tr",{valign:"top"},[e("th",{align:"right"},[e("b",null,"Issued by:")]),e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,"Country"),e("td",null,"US")]),e("tr",null,[e("td",null,"Province"),e("td",null,"CA")]),e("tr",null,[e("td",null,"City"),e("td",null,"Sausalito")]),e("tr",null,[e("td",null,"Organization"),e("td",null,"ACME Yacht Rentals, Inc.")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"On-line Services")]),e("tr",null,[e("td",null,[e("i",null,"Common Name")]),e("td",null,"d1.communigatepro.ru")]),e("tr",null,[e("td",null,"Contact"),e("td",null,"bill@domain.company")])])])])]),e("tr",{valign:"top"},[e("th",{align:"right"},"Serial Number:"),e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,"89AB673940123456")])])])])]),e("tr",{valign:"top"},[e("th",{align:"right"},"Valid:"),e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"right"},"From:"),e("td",null,"06-Nov-07"),e("td",{align:"right"},"Till:"),e("td",null,"05-Nov-09")])])])])]),e("tr",null,[e("td",{colspan:"2",align:"center"},[e("input",{name:"RefreshCert",value:"Refresh Self-Signed",class:"button",type:"reset"}),i("  "),e("input",{name:"RemoveCert",value:"Remove Certificate",class:"buttonRed",type:"reset"})])])])])])],-1)),t[15]||(t[15]=a(`<p>The Certificate panel shows the Certificate Issuer (the Certificate Authority), the Certificate Subject (the data you have entered and the selected domain name), the Certificate serial number and the validity period of this Certificate.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The entered Private Key and Certificate will be used for the Domain secure communications ONLY if the PKI Services option is set to <code>Enabled</code>.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Certificate contains the Domain name or a Domain Alias as a part of the &quot;Subject&quot; data.</p></div><p>When you rename the CommuniGate Pro Domain, the domain name in the Domain Certificate does not change, and the client applications may start to warn users about the name mismatch.</p><p>Click the Remove Certificate button to remove the Domain Certificate.</p><h3 id="CAGen" tabindex="-1">Assigning a Certificate Authority Chain <a class="header-anchor" href="#CAGen" aria-label="Permalink to &quot;Assigning a Certificate Authority Chain {#CAGen}&quot;">​</a></h3><p>If the Certificate issuer is known to the users client software (mailers and browsers), the warning message does not appear on the user screen when the client software receives a Certificate from the Server. In many cases, the &quot;trusted authority&quot; does not issue certificates itself. Instead, it delegates the right to issue certificates to some other, intermediate authority. When your Server uses a Certificate issued by such an authority, the Server should also present the Certificate of that authority issued by the &quot;trusted authority&quot;. The client software would check your Certificate first, then it will detect that the issuer of your Certificate is not a &quot;trusted authority&quot; and it will check the additional Certificate(s) the Server has sent. If that additional Certificate is issued by a &quot;trusted authority&quot;, and it certifies the issuer of your Domain Certificate, your Certificate is accepted without a warning.</p><p>When you receive a Certificate from a Certificate Authority that is not listed as a &quot;trusted authority&quot; in the client software settings, that intermediate Certificate Authority (CA) should also give you its own Certificate signed with a &quot;trusted authority&quot;. That Certificate should be in the same PEM format as your Domain Certificate:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Certificate Authority Chain (Optional)</b></td></tr><tr><td colspan="2" align="center"><textarea name="CAChain" cols="74" rows="12">-----BEGIN CERTIFICATE-----
MIIEMTCCA5qgAwIBAgIQI2yXHivGDQv5dGDe8QjDwzANBgkqhkiG9w0BAQIFADBfMQswCQYD VQQGEwJVUzEXMBUGA1UEChMOVmVyaVNpZ24sIEluYy4xNzA1BgNVBAsTLkNsYXNzIDMgUHVi bGljIFByaW1hcnkgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNOTcwNDE3MDAwMDAwWhcN MDQwMTA3MjM1OTU5WjCBujEfMB0GA1UEChMWVmVyaVNpZ24gVHJ1c3QgTmV0d29yazEXMBUG A1UECxMOVmVyaVNpZ24sIEluYy4xMzAxBgNVBAsTKlZlcmlTaWduIEludGVybmF0aW9uYWwg U2VydmVyIENBIC0gQ2xhc3MgMzFJMEcGA1UECxNAd3d3LnZlcmlzaWduLmNvbS9DUFMgSW5j b3JwLmJ5IFJlZi4gTElBQklMSVRZIExURC4oYyk5NyBWZXJpU2lnbjCBnzANBgkqhkiG9w0B
AQEFAAOBjQAwgYkCgYEA2IKA6NYZAn0fhRg5JaJlK+G/1AXTvOY2O6rwTGxbtueqPHNFVbLx
veqXQu2aNAoV1Klc9UAl3dkHwTKydWzEyruj/lYncUOqY/UwPpMo5frxCTvzt01OOfdcSVq4
wR3Tsor+cDCVQsv+K1GLWjw6+SJPkLICp1OcTzTnqwSye28CAwEAAaOCAZAwggGMMA8GA1Ud
EwQIMAYBAf8CAQAwCwYDVR0PBAQDAgEGMBEGCWCGSAGG+EIBAQQEAwIBBjAgBgNVHSUEGTAX BgpghkgBhvhFAQgBBglghkgBhvhCBAEwggE1BgNVHSAEggEsMIIBKDCCASQGC2CGSAGG+EUB BwEBMIIBEzAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cudmVyaXNpZ24uY29tL0NQUzCB5gYI KwYBBQUHAgIwgdkwFRYOVmVyaVNpZ24sIEluYy4wAwIBARqBv1ZlcmlTaWduJ3MgQ2VydGlm aWNhdGlvbiBQcmFjdGljZSBTdGF0ZW1lbnQsIHd3dy52ZXJpc2lnbi5jb20vQ1BTLCBnb3Zl cm5zIHRoaXMgY2VydGlmaWNhdGUgJiBpcyBpbmNvcnBvcmF0ZWQgYnkgcmVmZXJlbmNlIGhl cmVpbi4gU09NRSBXQVJSQU5USUVTIERJU0NMQUlNRUQgJiBMSUFCSUxJVFkgTFRELiAoYykx OTk3IFZlcmlTaWduMA0GCSqGSIb3DQEBAgUAA4GBALiMmMMrSPVyzWgNGrN0Y7uxWLaYRSLs
EY3HTjOLYlohJGyawEK0Rak6+2fwkb4YH9VIGZNrjcs3S4bmfZv9jHiZ/4PC/NlVBp4xZkZ9 G3hg9FXUbFXIaWJwfE22iQYFm8hDjswMKNXRjM1GUOMxlmaSESQeSltLZl5lVR5fN5qu
-----END CERTIFICATE-----</textarea><br><input name="SetCA" value="Set Authority Chain" class="button" type="reset"></td></tr></tbody></table></div></form><p>The CA Chain may include several certificates: the first one certifies the issuer of the Domain Certificate you have entered, but it itself may be issued by some intermediate authority. The next Certificate certifies that intermediate authority, etc. The last Certificate in the chain should be issued by some authority &quot;known&quot; to client software - usually, some Root Authority.</p><p>If your CA Chain contains several separate PEM-encoded Certificates, enter all of them into the Certificate Authority Chain field. The Certificate issued by a Root Authority should be the last one in the list.</p><p>Click the Set CA Chain button to assign the Certificate Authority Chain to the Domain. If all Certificates in the Chain are decoded successfully and their format is correct, the CA Chain list is displayed:</p>`,12)),t[16]||(t[16]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Certificate Authority Chain (Optional)")])]),e("tr",{align:"left"},[e("th",null,"Issued to"),e("th",null,"Issued by"),e("th",null,"From"),e("th",null,"Till")]),e("tr",{valign:"top"},[e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,"Organization"),e("td",null,"VeriSign Trust Network")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"VeriSign, Inc.")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"VeriSign International Server CA - Class 3")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"www.verisign.com/CPS Incorp.by Ref. LIABILITY LTD.(c)97 VeriSign")])])])]),e("td",null,[e("table",{class:"settingsBox",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,"Country"),e("td",null,"US")]),e("tr",null,[e("td",null,"Organization"),e("td",null,"VeriSign, Inc.")]),e("tr",null,[e("td",null,"Unit"),e("td",null,"Class 3 Public Primary Certification Authority")])])])]),e("td",{align:"center"},"17-Apr-97"),e("td",{align:"center"},"08-Jan-04")]),e("tr",null,[e("td",{colspan:"4",align:"center"},[e("input",{name:"RemoveChain",value:"Remove Authority Chain",class:"buttonRed",type:"reset"})])])])])])],-1)),t[17]||(t[17]=a(`<div class="tip custom-block"><p class="custom-block-title">Note</p><p>CommuniGate Pro checks only the format of each Certificate in the Chain. It does not check that each Certificate really certifies the issuer of the previous Certificate and that the last certificate in the Chain is issued by a Root Authority.</p></div><p>When set, the Certificate Authority Chain is sent to clients together with the Domain Certificate.</p><p>Click the Remove CA Chain button to remove the Certificate Authority Chain from the Domain Security Settings.</p><h2 id="Install" tabindex="-1">Using Self-Signed Certificates <a class="header-anchor" href="#Install" aria-label="Permalink to &quot;Using Self-Signed Certificates {#Install}&quot;">​</a></h2><p>You can create a Self-Signed Certificate if you do not want to use any external Certificate Authority.<br> Click the Generate Self-Signed button and the CommuniGate Pro Server creates a Self-Signed certificate for you: the Issuer will be same entity you have specified, and the entire Certificate will be signed using the Domain Private Key. When a Domain has a Self-Signed Certificate, client applications will warn users that the addressed server has presented a certificate &quot;issued by an unknown authority&quot;. Users can &quot;<a href="#Install">install</a>&quot; self-signed certificates to avoid these warnings.</p><p>When client applications receive a Certificate and its issuer is not included into their list of Trusted Authorities, the applications may display warnings or they may refuse to accept the Certificate.</p><p>Your users can &quot;install&quot; your Domain Certificates into their Trusted Authorities lists. Once installed, the Certificate becomes a &quot;trusted&quot; one. For some programs (such as Mac versions of Microsoft Outlook and Outlook Express) installing an &quot;untrusted&quot; Certificate is the only way to use that Certificate for secure communications.</p><p>To install a Domain Certificate, the user should use a browser application and open the login page of the <a href="./../access/WebUser.html">WebUser Interface</a> for the selected Domain. If the Domain has an enabled Certificate, the Secure Certificate link appears. The user should click on that link to download the Domain Certificate and &quot;open&quot; it. The browser should allow the user to verify the Certificate and to install it into the list of Trusted Authorities.</p><p>When a Domain has a Self-Signed Certificate, the Refresh Self-Signed button appears on the WebAdmin page. Click this button to create a new Self-Signed Certificate with the same serial number, but with a new validity period.</p><h2 id="Trusted" tabindex="-1">Trusted Root Certificates <a class="header-anchor" href="#Trusted" aria-label="Permalink to &quot;Trusted Root Certificates {#Trusted}&quot;">​</a></h2><p>The CommuniGate Pro Server can verify validity of Certificates presented to it. For example, the <a href="./WebSMIME.html">WebUser Interface</a> performs validity checks when displaying signed messages.</p><p>A Certificate is considered valid if:</p><ul><li>it is equal to one of the Trusted Certificates, or</li><li>it is issued by a holder of one of the Trusted Certificates.</li></ul><p>There are several sets of the Trusted Certificates:</p><ul><li>Built-in trusted Certificates: these certificates are installed with the CommuniGate Pro Server software, and they are updated when the Server software is updated.</li><li>Server-wide and Cluster-wider Trusted Certificates.</li><li>Domain-wide Trusted Certificates.</li></ul><p>When a PKI operation is performed for a certain Domain (or for a certain Account in that Domain), the following Trusted Certificates are checked:</p><ul><li>the Domain Trusted Certificates</li><li>the Cluster-wide Trusted Certificates if the Domain is a Shared one, and the Server-wide Trusted Certificates if the Domain is not a Shared one</li><li>the built-in Trusted Certificates</li></ul><p>When a PKI operation is performed for the System itself (for example, an outgoing TLS connection is being established), the following Trusted Certificates are checked:</p><ul><li>the Server-wide Trusted Certificates</li><li>the Cluster-wide Trusted Certificates</li><li>the built-in Trusted Certificates</li></ul><p>Use the WebAdmin Interface to update the set of Server-wide and Cluster-wide Trusted Certificates. Open Security page in the the Users realm. The Trusted Certificates page will open:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><th> </th><th>Issued to</th><th>Serial Number</th><th>From</th><th>Till</th></tr><tr><td></td><td>RSA Data Security, Inc.</td><td><span style="font-size:-2;font-family:monospace;">02AD667E4E45FE5E576F3C98195EDDC0</span></td><td>09-Nov-94</td><td>08-Jan-10</td></tr><tr><td></td><td>Thawte Personal Freemail CA</td><td><span style="font-size:-2;font-family:monospace;">00</span></td><td>01-Jan-96</td><td>01-Jan-21</td></tr><tr><td></td><td>Thawte Personal Basic CA</td><td><span style="font-size:-2;font-family:monospace;">00</span></td><td>01-Jan-96</td><td>01-Jan-21</td></tr><tr><td><input type="checkbox" value="0" name="Cert"></td><td>My Company CA</td><td><span style="font-size:-2;font-family:monospace;">010256FF</span></td><td>01-Jan-96</td><td>01-Jan-21</td></tr></tbody><tfoot><tr><td colspan="5"><input name="Remove" value="Delete Marked" class="buttonRed" type="reset"></td></tr></tfoot></table></div></form><p>Trusted Certificates included into the displayed set have a checkbox marker. To remove certain Trusted Certificates, select its checkbox and click the Remove Marked button.</p><p>In addition to the certificates from the displayed set, the Domain-wide pages display the built-in Trusted Certificates, and the Trusted Certificates from the Server-wide set (or from the Cluster-wide set for Shared Domains).<br> The Server-wide and Cluster-wide Trusted Certificates pages display the the built-in Trusted Certificates.<br> These additional certificates do not have checkbox markers.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Enter a PEM-encoded Certificate</b></td></tr><tr><td align="center"><textarea name="Certificate" cols="72" rows="10">-----BEGIN CERTIFICATE-----
MIIDLTCCApagAwIBAgIBADANBgkqhkiG9w0BAQQFADCB0TELMAkGA1UEBhMCWkEx
FTATBgNVBAgTDFdlc3Rlcm4gQ2FwZTESMBAGA1UEBxMJQ2FwZSBUb3duMRowGAYD
VQQKExFUaGF3dGUgQ29uc3VsdGluZzEoMCYGA1UECxMfQ2VydGlmaWNhdGlvbiBT
ZXJ2aWNlcyBEaXZpc2lvbjEkMCIGA1UEAxMbVGhhd3RlIFBlcnNvbmFsIEZyZWVt
YWlsIENBMSswKQYJKoZIhvcNAQkBFhxwZXJzb25hbC1mcmVlbWFpbEB0aGF3dGUu
Y29tMB4XDTk2MDEwMTAwMDAwMFoXDTIwMTIzMTIzNTk1OVowgdExCzAJBgNVBAYT
AlpBMRUwEwYDVQQIEwxXZXN0ZXJuIENhcGUxEjAQBgNVBAcTCUNhcGUgVG93bjEa
MBgGA1UEChMRVGhhd3RlIENvbnN1bHRpbmcxKDAmBgNVBAsTH0NlcnRpZmljYXRp
b24gU2VydmljZXMgRGl2aXNpb24xJDAiBgNVBAMTG1RoYXd0ZSBQZXJzb25hbCBG
cmVlbWFpbCBDQTErMCkGCSqGSIb3DQEJARYccGVyc29uYWwtZnJlZW1haWxAdGhh
d3RlLmNvbTCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA1GnX1LCUZFtx6UfY
DFG26nKRsIRefS0Nj3sS34UldSh0OkIsYyeflXtL734Zhx2G6qPduc6WZBrCFG5E
rHzmj+hND3EfQDimAKOHePb5lIZererAXnbr2RSjXW56fAylS1V/Bhkpf56aJtVq
uzgkCGqYx7Hao5iR/Xnb5VrEHLkCAwEAAaMTMBEwDwYDVR0TAQH/BAUwAwEB/zAN
BgkqhkiG9w0BAQQFAAOBgQDH7JJ+Tvj1lqVnYiqk8E0RYNBvjWBYYawmu1I1XAjP
MPuoSpaKH2JCI4wXD/S6ZJwXrEcp352YXtJsYHFcoqzceePnbgBHH7UNKOgCneSa
/RP0ptl8sfjcXyMmCZGAc9AUG95DqYMl8uacLxXK/qarigd1iwzdUYRr5PjRznei
gQ==
-----END CERTIFICATE-----</textarea><br><br><input name="Create" value="Set Certificate" class="button" type="reset"></td></tr></tbody></table></div></form><p>To add a Certificate to the set, enter the PEM-encoded Certificate data into the text field and click the Set Certificate button. The new Certificate should appear in the displayed set.</p><h2 id="TLS" tabindex="-1">SSL/TLS Secure Connections <a class="header-anchor" href="#TLS" aria-label="Permalink to &quot;SSL/TLS Secure Connections {#TLS}&quot;">​</a></h2><p>The TLS (Transport Level Security) protocol a PKI application used to provide security and integrity of data transferred between a pair of communicating parties. The parties use PKI encryption to securely exchange a &quot;secret key&quot; data, and then all data transferred between the parties is encrypted using that &quot;secret key&quot;. The earlier versions of the TLS protocol were called the SSL (Secure Socket Layer) protocols.</p><p>The CommuniGate Pro Server supports SSL/TLS connections for all its TCP-based services and modules. Secure connections can be established in two ways:</p><ul><li>A client application uses a special port to connect to the Server and starts to establish a TLS (encrypted) connection right after a TCP connection with that port is established. This method is used in all Web browsers when a <code>https://</code> URL is used.<br> This method is also used when SIP clients use the &quot;TLS transport&quot; option.<br> Some mail clients use it for POP, IMAP, LDAP, and (rarely) for SMTP connections.<br> To support these clients, configure the <a href="./../network/Listener.html">Listeners</a> for HTTP, SIP, POP, IMAP, SMTP, and LDAP modules: the Listeners should accept TCP connections on those special ports (see the module descriptions for the proper Secure Port Numbers) and the Init SSL/TLS option should be enabled for those ports.</li><li>A client application uses a standard port to connect to the Server, and then it issues a special command (usually called STARTTLS or STLS) over the established clear-text TCP connection. When the Server receives such a command it starts to establish a secure connection. To support these clients you do not have to configure additional ports with the module Listeners.</li></ul><p>Usually certificates for SSL/TLS communications can be assigned only to the CommuniGate Pro <a href="./../objects/Domains.html">Domains</a> that have at least one assigned network (IP) address. This limitation comes from the design of the TLS protocols used today: when a client application wants to initiate a secure connection, the Server has no information about the Domain the client wants to connect to. The Server knows only to which local IP address the client has connected, so it opens the Domain this IP address is assigned to, and uses the PKI Settings of that Domain.</p><p>An exception to this rule is the XMPP protocol. Before an XMPP client sends the <code>&lt;starttls&gt;</code> command, it explicitly specifies the target domain in the <code>&lt;stream&gt;</code> data, so the Server can initiate a TLS session with a Domain that has no assigned network address.</p><p>Use the WebAdmin Interface to specify the Server-wide SSL/TLS processing parameters. Open the General pages in the Settings realm, and find the TLS Sessions panel on the Others page:</p>`,32)),t[18]||(t[18]=e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",{style:{display:"table",width:"100%"}},[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"TLS Sessions")])]),e("tr",null,[e("td",{align:"right"},"Log Level:"),e("td",null,[e("select",{name:"TLSLogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2",selected:"selected"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4"},"Low Level"),e("option",{value:"5"},"All Info")])]),e("td",null,[e("input",{name:"TLSProcessDomainNames",value:"1",type:"checkbox",checked:"checked"}),i("Process Target Domain extensions ")])]),e("tr",null,[e("td",{align:"right"},"Time to Live:"),e("td",null,[e("select",{name:"TLSTimeToLive"},[e("option",{value:"15"},"15 seconds"),e("option",{value:"30",selected:"selected"},"30 seconds"),e("option",{value:"60"},"minute"),e("option",{value:"120"},"2 minutes"),e("option",{value:"180"},"3 minutes"),e("option",{value:"300"},"5 minutes"),e("option",{value:"600"},"10 minutes"),e("option",{value:"900"},"15 minutes"),e("option",{value:"1800"},"30 minutes"),e("option",{value:"3600"},"hour"),e("option",{value:"7200"},"2 hours"),e("option",{value:"10800"},"3 hours"),e("option",{value:"21600"},"6 hours"),e("option",{value:"43200"},"12 hours"),e("option",{value:"86400"},"day"),e("option",{value:"172800"},"2 days"),e("option",{value:"259200"},"3 days"),e("option",{value:"604800"},"week"),e("option",{value:"864000"},"10 days"),e("option",{value:"1209600"},"2 weeks"),e("option",{value:"2678400"},"month")])]),e("td",null,[e("input",{name:"TLSAbortOnWrongCert",value:"1",type:"checkbox"}),i("Abort on Wrong Client Certificate ")])]),e("tr",null,[e("td",{align:"right"},"Oldest Accepted:"),e("td",null,[e("select",{name:"TLSMinVersion"},[e("option",{value:"0"},"SSLv3"),e("option",{value:"1",selected:"selected"},"TLSv1.0"),e("option",{value:"2"},"TLSv1.1"),e("option",{value:"3"},"TLSv1.2"),e("option",{value:"4"},"TLSv1.3")])])]),e("tr",null,[e("td",{colspan:"1"}," ")]),e("tr",null,[e("td",{class:"settingsBox",width:"100%",colspan:"4"},[e("table",{width:"80%"},[e("tbody",{style:{display:"table",width:"100%"}},[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Cipher Settings")])]),e("tr",null,[e("td",{align:"right"},"Current cipher list:"),e("td",null,[e("div",{style:{"word-wrap":"break-word",width:"400px"}},"DEFAULT")])]),e("tr",null,[e("td",{align:"right"},"Current cipher suites:"),e("td",null,[e("div",{style:{"word-wrap":"break-word",width:"400px"}},"TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256")])]),e("tr",null,[e("td",{align:"right"},"Cipher set:"),e("td",null,[e("select",{name:"OpenSSLCipherSet"},[e("option",{value:"0"},"All Available"),e("option",{value:"1",selected:"selected"},"Default"),e("option",{value:"2"},"Custom")])])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Custom cipher list:"),e("td",{colspan:"3"},[e("textarea",{style:{"font-size":"9pt"},name:"OpenSSLCustomCipherList",rows:"2",cols:"60"},"DEFAULT@SECLEVEL=2")])]),e("tr",{valign:"top"},[e("td",{align:"right"},"Custom cipher suites:"),e("td",{colspan:"3"},[e("textarea",{style:{"font-size":"9pt"},name:"OpenSSLCustomCipherSuites",rows:"2",cols:"60"},"TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:TLS_AES_128_CCM_8_SHA256:TLS_AES_128_CCM_SHA256")])])])])])])])])])],-1)),t[19]||(t[19]=a('<ul><li><p><code>Log</code></p><p>Use this setting to specify what kind of information the TLS module should put in the Server Log. The TLS module records in the System Log are marked with the <code>TLS</code> tag.</p></li><li><p><code>Time To Live</code></p><p>This setting specifies the <em>cache time</em> for TLS sessions. When all connections using the same TLS session are closed, the Server waits for the specified time before deleting the TLS session parameters. This feature allows clients to open new connections <em>resuming</em> the old TLS sessions. It increases connection speeds and decreases the Server CPU load. This feature is especially important for HTTP clients that open and close connections very often.</p></li><li><p><code>Oldest Accepted</code></p><p>This setting specifies the oldest SSL/TLS protocol version accepted. If a remote peer specifies that it only supports an SSL/TLS version older than this one, an attempt to create a secure connection is rejected.<br> This option controls incoming TCP connections only.</p></li><li><p><code>Process Target Domain extensions</code></p><p>When this setting is enabled, the Server supports the TLS protocol extensions which allow the client to specify the name of the Server Domain it wants to access. This feature allows you to host several TLS-enabled Domains using the same Server Network IP Address.</p></li><li><p><code>Abort on Wrong Client Certificate</code></p><p>When a Server requires a client to <a href="#ClientCert">send a Certificate</a>, the client may send an incorrect certificate: expired, issued by a wrong issuer, etc.<br> If this option is enabled, this situation aborts the current TLS negotiation process. If this option is disabled, then incorrect certificates are ignored.</p></li></ul><h3 id="TLSCipherSettings" tabindex="-1">Cipher Settings <a class="header-anchor" href="#TLSCipherSettings" aria-label="Permalink to &quot;Cipher Settings {#TLSCipherSettings}&quot;">​</a></h3><p>This settings specify Cipher List and Cipher Suites the Server uses for TLS for HTTP and SMTP sessions. These parameters define which cipher methods the Server offers to clients during TLS negotiation process for TLSv1.2 and below(Cipher List) and for TLSv1.3(Cipher Suites). For more information about the parameters and their formats please refer to <a href="https://docs.openssl.org/3.3/man1/openssl-ciphers/#cipher-list-format" target="_blank" rel="noreferrer">OpenSSL documentation</a>.</p><ul><li><p><code>Current Cipher List</code> and <code>Current Cipher Suites</code></p><p>Shows Cipher List and Cipher Suites currentry used by the Server.</p></li><li><p><code>Cipher set</code></p><p>This setting specifies which set of Cipher List and Cipher Suites to use:</p><ul><li><p><code>All Available</code></p><p>Use all available cipher methods.</p></li><li><p><code>Default</code></p><p>Use cipher methods enabled by default in OpenSSL.</p></li><li><p><code>Custom</code></p><p>Use user-defined custom Cipher List and Cipher Suites.</p></li></ul></li><li><p><code>Custom Cipher List</code> and <code>Custom Cipher Suites</code></p><p>User-defined Cipher List and Cipher Suites.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p><code>Custom Cipher List</code> and <code>Custom Cipher Suites</code> will only be used if <code>Custom</code> option for <code>Cipher set</code> is set.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Be careful using <code>Custom Cipher List</code> and <code>Custom Cipher Suites</code> since ill-formatted or insufficient set of cipher methods might lead to inability to use HTTPS by users and administrators alike.</p></div><h2 id="ClientCert" tabindex="-1">Client Certificates <a class="header-anchor" href="#ClientCert" aria-label="Permalink to &quot;Client Certificates {#ClientCert}&quot;">​</a></h2><p>The CommuniGate Pro Server can request a Client Certificate when an external client (a mailer, browser, or a real-time device) establishes a <a href="#TLS">TLS</a> connection with a certain Domain.</p><p>Use the WebAdmin Interface to open the Domain Settings page for the target Domain, and click the Security link. The PKI page will appear:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Request Client Certificates</b></td></tr><tr><td align="right">Issued by:</td><td><select name="XX"><option value="0"></option><option value="1" selected="selected">Certificate Name 1</option><option value="2">Certificate Name 2</option><option value="3">Certificate Name 3</option></select></td><td align="right">Required:</td><td><select name="X1X"><option value="-1" selected="selected">default(No)</option><option value="0">No</option><option value="1">Yes</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Issued By</code></p><p>Select one of the <a href="#Trusted">Trusted Certificates</a> specified for this Domain.<br> When a Trusted Certificate is selected, all TLS clients connecting to this Domain will be requested to present a valid certificate issued by the owner of the selected Trusted Certificate. These certificates can be used for <a href="./Security.html#Certificate">Certificate Authentication</a>.</p></li><li><p><code>Required</code></p><p>If this option is selected, only clients presenting valid Certificates can establish TLS connections to this Domain.</p></li></ul><p>The CommuniGate Pro Server processes Client Certificate requests when it establishes a <a href="#TLS">TLS</a> connection to remote servers (SMTP, XMPP, SIP, POP, and other connections). It processes these requests by sending the TLS Certificate assigned to the Main Domain.</p><h2 id="SMIME" tabindex="-1">S/MIME Functionality <a class="header-anchor" href="#SMIME" aria-label="Permalink to &quot;S/MIME Functionality {#SMIME}&quot;">​</a></h2><p>S/MIME is a PKI application used to digitally sign and encrypt E-mail and other messages. While TLS ensures data security when information is sent over an unprotected network, such as the Internet, S/MIME provides end-to-end data security: an S/MIME message is encrypted by the sender (using Multiparty Encryption) and submitted to the sender&#39;s server in the encrypted form. The same encrypted form is used when the message is transferred over a network, when it is stored on an intermediate server, and when it is deposited in the recipients&#39; Mailboxes. Only the recipients can decrypt the message using their Private Keys, and only when they actually read the message: the message stays encrypted in the recipient&#39;s Mailboxes.</p><p>To use end-to-end S/MIME security, individual users should have their own PKI keys. Each user should have a Private Key securely stored in a storage available to that user only, and a matching Public Key embedded into a Certificate. This Certificate should be issued by a Certificate Authority that other users trust.</p><p>CommuniGate Pro WebUser and XIMSS Interfaces support S/MIME functions. The Server provides secure storage for user Private Keys. These Keys can be unlocked and used only by the users themselves, using these Interfaces.</p><p>To use a traditional desktop client application (a POP, IMAP, or MAPI client) the user Private Key should be stored in the PKI storage of the desktop operating system.<br> The WebUser and XIMSS Interfaces can export and import Private Keys, so the user can use the same Private Key for desktop applications and when employing these Interfaces. See the <a href="./WebSMIME.html">Secure Mail</a> section for more details.</p><h2 id="SMIMEKeys" tabindex="-1">Domain S/MIME Settings <a class="header-anchor" href="#SMIMEKeys" aria-label="Permalink to &quot;Domain S/MIME Settings {#SMIMEKeys}&quot;">​</a></h2><p>The CommuniGate Pro Server implements a Certificate Server, issuing Certificates for its users.</p><p>A CommuniGate Pro Domain can act as a Certificate Authority for all its Accounts if:</p><ul><li>The Domain <a href="#DomainKeys">PKI Functions</a> are Enabled.</li><li>The Domain has a valid Private Key.</li><li>The Domain has a special S/MIME Certificate.</li></ul><p>To specify Domain S/MIME settings, use the WebAdmin Interface to open the Domain Settings pages. Open the Security page and click the S/MIME link. If the Domain has a valid Private Key, a page similar to those for the generic Domain Certificate are displayed. These fields can be used to enter a special S/MIME certificate for the Domain. This Certificate is used as the Issuer (Certificate Authority) for all S/MIME Certificates requested by users in this Domain.</p><h2 id="SMIMERules" tabindex="-1">Automatic S/MIME Encryption <a class="header-anchor" href="#SMIMERules" aria-label="Permalink to &quot;Automatic S/MIME Encryption {#SMIMERules}&quot;">​</a></h2><p>The S/MIME features can be used to provide secure message store. CommuniGate Pro can encrypt all or certain messages before it stores them in user Mailboxes.</p><p>The <code>Store Encrypted</code> <a href="./../mail/QueueRules.html">Rule</a> action is used to encrypt incoming E-mail messages and store them in the specified Mailbox.</p><p>Messages are encrypted using the S/MIME Certificate of the Mailbox owner. If the <code>Store Encrypted</code> Rule action is used in an Account-Level (i.e. in an Account or in a Domain-wide) Rule, and the specified Mailbox does not belong to the user Account, the message is encrypted using the Certificates of the Mailbox owner and the current Account.</p><ul><li><p>Sample:</p><p>The Account john has a Rule with the following action:<br><code>Store Encrypted in    ~jim/INBOX</code><br> When this action is taken, the message is stored in the INBOX Mailbox of the Account jim encrypted with both john and jim Certificates. Both jim and john can decrypt and read this message.</p></li></ul><h2 id="SMIMEPost" tabindex="-1">Stored Message Encryption <a class="header-anchor" href="#SMIMEPost" aria-label="Permalink to &quot;Stored Message Encryption {#SMIMEPost}&quot;">​</a></h2><p>After CommuniGate Pro users receive certain clear-text E-mail messages, they may prefer to keep them encrypted in the Server Mailboxes. The <a href="./../access/MAPI.html">MAPI</a> and <a href="./../access/XIMSS.html">XIMSS</a> clients, and the <a href="./WebSMIME.html">WebUser Interface</a> provide the Encrypt and Decrypt functions that allow users to encrypt and decrypt individual messages in their Mailboxes.</p><h2 id="DKIM" tabindex="-1">DKIM Message Signing <a class="header-anchor" href="#DKIM" aria-label="Permalink to &quot;DKIM Message Signing {#DKIM}&quot;">​</a></h2><p>DKIM (stands for DomainKeys Identified Mail) is an E-mail authentication method which allows for a unique Signature to be added for each E-mail message you send. The Signature is generated by using encryption with public and private keys. The receiving mail server can use the public key to determine if your private key was used to generate the message&#39;s Signature, and that the message body and the most important headers were not altered during the transit.</p><p>To specify Domain DKIM settings, use the WebAdmin Interface to open the Domain Settings pages. Open the Security page and click the DKIM link.</p><p>To enable adding the Signatures to outgoing messages you need to complete the following steps:</p>',33)),e("ol",null,[e("li",null,[t[8]||(t[8]=e("p",null,[i("Generate (or import externally-generated) Private Key in the same way as assigning a Private Key for the "),e("a",{href:"./PKI.html#KeyGen"},"Domain"),i("."),e("br"),i(" After the Private Key is assigned the corresponding Public Key will be displayed.")],-1)),e("div",f,[e("table",y,[e("tbody",null,[t[6]||(t[6]=e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Private Key")])],-1)),t[7]||(t[7]=e("tr",null,[e("td",{align:"right"},"Key Size:"),e("td",null,"1024 bit"),e("td",{rowspan:"2"},[i(" "),e("input",{type:"submit",name:"RemoveKey",value:"Remove Key",class:"buttonRed"})])],-1)),e("tr",null,[t[5]||(t[5]=e("td",{align:"right"},"Encryption Test:",-1)),e("td",null,[o(n,{color:"GREEN"},{default:s(()=>t[4]||(t[4]=[e("i",null,"Verification String is OK",-1)])),_:1})])])])])]),t[9]||(t[9]=e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Public Key")])]),e("tr",null,[e("td",null,[e("textarea",{style:{width:"99%"},rows:"3",readonly:""},"MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDjLml46+DMPGpLpSQROFxyNnyFcyX9ZtscLo3YegyhB266JOYNzlfdPU4gBKWS89lnr2yVWC6dUgIVInJhin+stzROZ1MBd9dx6iOE4xAC2LxZeYvzjT07CoXzfdyb35N1TpSfL09ERXilNUgAoDqTAaJ+eGeN+N45LQTPtd0+QQIDAQAB")])])])])],-1))]),t[10]||(t[10]=e("li",null,[e("p",null,[i("Specify the value for "),e("code",null,"Domain"),i(' - it should be either the current Domain name, or its "organizational domain" name.')])],-1)),t[11]||(t[11]=e("li",null,[e("p",null,[i("Choose and specify the value for "),e("code",null,"Selector"),i(" - an arbitrary string.")])],-1))]),t[20]||(t[20]=e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Public Key")])])]),e("caption",null,"DKIM Signature Parameters"),e("tbody",null,[e("tr",null,[e("td",{align:"right"},"Domain:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"DKIMdomain-Def",value:"1"})]),e("td",{class:"settingFixed"},"mail.dept1.company.com ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"DKIMdomain-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"DKIMdomain",size:"40",maxlength:"10000",value:"company.com"})])])])])])]),e("tr",null,[e("td",{align:"right"},"Selector:"),e("td",null,[e("table",{border:"0",cellspacing:"0",cellpadding:"1"},[e("tbody",null,[e("tr",null,[e("td",null,[e("input",{type:"radio",name:"DKIMselector-Def",value:"1"})]),e("td",{class:"settingFixed"},"mail ")]),e("tr",{valign:"top"},[e("td",null,[e("input",{type:"radio",name:"DKIMselector-Def",value:"0",checked:"checked"})]),e("td",null,[e("input",{name:"DKIMselector",size:"20",maxlength:"10000",value:"feb2017"})])])])])])])])])],-1)),t[21]||(t[21]=e("ol",{start:"4"},[e("li",null,[e("p",null,[i("Create DNS TXT record for name "),e("code",null,"Selector._domainkey.domain"),i(" with value "),e("code",null,'"v=DKIM1; p=MIGfMA0GCSqG..."'),i(' where the value of "p=" is your Public Key.')])]),e("li",null,[e("p",null,[i("Use "),e("code",null,"Check"),i(" button to verify that the DNS record exists and contains the right Public Key. Remember that newly created DNS records may need time to propagate through the world.")])])],-1)),t[22]||(t[22]=e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"DNS Record")])]),e("tr",null,[e("td",{align:"left",valign:"top"},[e("input",{name:"CheckDNS",type:"submit",value:"Check",class:"button"})])]),e("tr",null,[e("td",null,[e("textarea",{style:{width:"99%"},rows:"4",readonly:""},'feb2017._domainkey.company.com text = "v=DKIM1; p=MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDjLml46+DMPGpLpSQROFxyNnyFcyX9ZtscLo3YegyhB266JOYNzlfdPU4gBKWS89lnr2yVWC6dUgIVInJhin+stzROZ1MBd9dx6iOE4xAC2LxZeYvzjT07CoXzfdyb35N1TpSfL09ERXilNUgAoDqTAaJ+eGeN+N45LQTPtd0+QQIDAQAB"')])])])])],-1)),t[23]||(t[23]=a('<ol start="6"><li>After all the above steps are complete switch the <code>Enabled</code> to <code>Yes</code></li></ol><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Sign Outgoing Messages</b></td></tr><tr><td>Enabled: <select name="DKIMenabled"><option value="0">No</option><option value="1" selected="selected">Yes</option></select></td></tr></tbody></table></div><p>It is recommended to rotate the Private Key regularly (about every 3 months), by generating new Keys and creating new DNS record for a new <code>Selector</code>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The DKIM Signatures are composed by <a href="./../mail/">Enqueuer</a> component when the message is enqueued, but physically added when the message is sent, stored or sent to an external program.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>For the DKIM signing process the relation of a message to a Domain is determined by the message&#39;s <code>From:</code> address. A user whose Account is in some other Domain may change his <code>From:</code> address so his messages will be signed according to the current Domain settings. Also, messages being relayed from external sources may be signed by the current Domain if their <code>From:</code> addresses match the names of the objects in the current Domain.</p></div>',5))])}const I=r(u,[["render",g]]);export{w as __pageData,I as default};
