import{_ as a,c as i,o as n,ag as t,j as e,a as o}from"./chunks/framework.jCcxW76o.js";const v=JSON.parse('{"title":"Protection","description":"","frontmatter":{"legacyLink":["Protection.html","AntiSpam.html"]},"headers":[],"relativePath":"admin/sysadmin/Protection.md","filePath":"admin/sysadmin/Protection.md"}'),r={name:"admin/sysadmin/Protection.md"};function l(d,s,c,h,u,p){return n(),i("div",null,s[0]||(s[0]=[t(`<h1 id="protection" tabindex="-1">Protection <a class="header-anchor" href="#protection" aria-label="Permalink to &quot;Protection&quot;">​</a></h1><p>The Internet is flooded with soliciting E-mail messages distributed to millions of E-mail addresses. These messages are known as &quot;spam&quot;.</p><p>Spammers fill your user Mailboxes with a huge amount of unwanted messages, not only overloading your network and Server resources, but making mail retrieval very slow and difficult for your users.</p><p>Besides the methods described in this section, additional methods are described in the <a href="./../network/#Denied">Denied Addresses</a> section.</p><p>In order to distribute their messages to millions of E-mail addresses, spammers try to use any SMTP mail server on the Internet as a relay: they deliver one copy of the message to each mail server, requesting that server to route the message to several hundred addresses. This practice not only overloads your Server resources, but it places you at risk of being recognized as a spammer (since &quot;spam&quot; messages come from your Server).</p><p>The CommuniGate Pro Server has Protection Options that can help you to deal with &quot;spam&quot;.</p><h2 id="Relay" tabindex="-1">Prohibiting Unauthorized Relaying <a class="header-anchor" href="#Relay" aria-label="Permalink to &quot;Prohibiting Unauthorized Relaying {#Relay}&quot;">​</a></h2><p>If your SMTP module can accept incoming TCP connections, your Server can be used by spammers as a mail relay engine: they can distribute their messages all over the world using your Server as an <em>open relay</em>.</p><p>Also, if your SIP module can accept incoming SIP requests, your Server can be used by &quot;voip&quot; spammers as a SIP relay engine: they can distribute their calls and/or instant messages all over the world using your Server as an <em>open relay</em>.</p><p>To protect your site from spammers, you should restrict the Server relaying functionality. Basically, only your own users should be able to use your Server to relay E-mail messages and Signal requests to other places on the Internet. Messages and Signal requests coming from other sources should go only to your own Accounts, and should be relayed to other Internet sites only when you have explicitly allowed that type of relaying.</p><h3 id="ClientFixed" tabindex="-1">Specifying Client IP Addresses <a class="header-anchor" href="#ClientFixed" aria-label="Permalink to &quot;Specifying Client IP Addresses {#ClientFixed}&quot;">​</a></h3><p>The simplest way to decide if an incoming SMTP message or a SIP request is coming from your own user is to look at the network (IP) address it is coming from. If all your users connect from one or several LAN(s), you can treat all messages coming from those networks as &quot;messages from Clients&quot;, and your Server will relay them to the Internet.</p><p>Use the WebAdmin Interface to open the Network pages inside the Settings section (realm), and click the Client IP Addresses link.</p><p>Enter the IP addresses on your client connect from, as well as the IP addresses of other systems that should be allowed to use your server as a mail relay:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Client IP Addresses</b></td></tr><tr><td align="center"><textarea name="ClientHosts" rows="10" cols="60">10.10.12.24               ; our back-up
10.10.13.32-10.10.13.191  ; our dial-ups
64.173.55.169             ; our other office</textarea></td></tr><tr><td align="center"><input type="checkbox" name="LANisClient" value="1" checked="checked"> Process LAN IP Addresses as Clients</td></tr></tbody></table></div></form><ul><li><p><code>Process LAN IP Addresses as Clients</code></p><p>Select this option to include all <a href="./../network/">LAN IP Addresses</a> into the Client IP Addresses list.</p></li></ul><p>The IP addresses are specified in a multi-line format. See the <a href="./../network/#IPLists">Network</a> section for more details.</p><p>If you provide dial-up services, enter the IP address ranges you have allocated to your dial-up users.</p><h3 id="ClientDNS" tabindex="-1">Specifying Client Domains by Name <a class="header-anchor" href="#ClientDNS" aria-label="Permalink to &quot;Specifying Client Domains by Name {#ClientDNS}&quot;">​</a></h3><p>You can specify your Client IP Addresses using the <em>reverse lookup</em> domain names.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input type="checkbox" name="UseClientByName" value="1" checked="checked"><b> Detect Clients by DNS Name</b></td></tr><tr><td align="center"><input type="text" name="ClientByNames" value="*.communigatepro.ru" size="20" maxlength="100"></td></tr><tr><td align="center"><input type="text" name="ClientByNames" value="" size="20" maxlength="100"></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Each Domain can have its own <a href="./../objects/Domains.html#ClientIPs">Client IP Addresses</a> list, extending the Server-wide and Cluster-wide lists.</p></div><p>When a client connects from an IP address not listed in the Client IP Addresses list, and the Detect Clients by DNS Name option is enabled, the server tries to get the domain name for that IP address (if the IP address is <code>aa.bb.cc.dd</code>, the Server tries to retrieve the PTR record for the <code>dd.cc.dd.aa.in-addr.arpa</code> name). If the PTR domain name is retrieved, it is checked against the strings specified in the table (these strings can include the wildcard (<code>*</code>) symbols). If the retrieved name matches one of the table strings, the server retrieves the DNS A record for the retrieved domain name, and checks that the IP address is included into the IP addresses in that record. If it is included, the address is considered to be a &quot;Client IP Address&quot;, and it is processed in the same way as if it was entered into the Client IP Addresses list.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>While this method was popular with legacy mail servers, it can be very expensive for large-scale systems. It requires your Server to make 2 DNS transactions for each incoming connection not coming from explicitly specified Client IP Addresses, and these transactions can take a lot of time.</p></div><p>Use this method only when absolutely necessary, for example when your Server needs to support a large (and unknown) set of campus networks, and the only thing known about those networks is the fact that all their IP addresses can be &quot;reversed-resolved&quot; into some subdomain of the school domain. Even in this case, try to enter all known addresses and networks into the Client IP Addresses list, decreasing the number of required &quot;reverse-resolving&quot; operations.</p><h3 id="SMTP" tabindex="-1">Configuring the SMTP module <a class="header-anchor" href="#SMTP" aria-label="Permalink to &quot;Configuring the SMTP module {#SMTP}&quot;">​</a></h3><p>When a message is received with the <a href="./../mail/SMTP.html">SMTP module</a>, and the sender IP address is not found in the Client Addresses list, the message is marked as being received &quot;from a stranger&quot;. If this message should be relayed by your server to some other host on the Internet, and that host is not listed in the Client IP Addresses list either, the message can be rejected.</p><p>As a result, servers and workstations included into the Client Addresses list can use your Server to send (relay) messages to any mail server on the Internet. But any message coming from an unlisted address and directed to some other unlisted system can be rejected. This will prohibit spammers from using your Server as an &quot;open mail relay&quot;.</p><p>Since this functionality can affect your legitimate users if you do not specify their IP addresses correctly, the Relay to non-Clients option is available on the <a href="./../mail/SMTP.html">SMTP Relaying</a> page.<br> Set that option to &quot;if received from <code>Clients</code>&quot;, and &quot;stranger-to-stranger&quot; relay attempts will be rejected.</p><p>The Client IP Addresses list can include addresses of some other mail servers. The Server can relay mail sent by anybody and addressed to a server with a network address included into the Client IP Addresses list, but it can also check if the message address is a &quot;simple&quot; one.</p><p>The <a href="./../mail/SMTP.html">SMTP Relaying</a> page contains the To Client IP Addresses option. Set this option to &quot;If Sent to: <code>simple</code> addresses&quot; to prohibit relaying of &quot;complex addresses&quot; (such as <code>username%somehost@otherserver</code>) to servers listed in the Client IP Addresses list. This setting will prevent spammers from using your servers for &quot;two-server relays&quot;.</p><p>The following is the &quot;two-server relay&quot; method:</p><ul><li>a spammer sends a message with the <code>username%somehost@server2</code> address to the <code>server1</code> server;</li><li>the <code>server1</code> server relays the message to the <code>server2</code> server, because the <code>server2</code> address is included into the <code>server1</code> Client IP Addresses list;</li><li>the <code>server2</code> server relays the message to username@somehost, since it has received it from <code>server1</code>, which is included into the <code>server2</code> Client IP Addresses list.</li></ul><p>When servers relay only &quot;simple&quot; E-mail addresses to each other, those servers cannot be used for &quot;two-server relaying&quot; even if they maintain &quot;mutual trust&quot; (i.e. list each other in the Client IP Addresses lists).</p><p>To avoid problems with old mail servers that ignore the quote marks in addresses, the addresses with the local part containing quotes cannot be relayed to Client IP Addresses servers if the &quot;simple&quot; option is selected.</p><p>If the Relay to Client IP Addresses option is set to &quot;no&quot;, these addresses are not processed in any special way - messages sent to servers with Client IP Addresses are processed in the same way as messages sent to servers with non-Client IP Addresses.</p><h2 id="ClientOnly" tabindex="-1">Client-only Logins <a class="header-anchor" href="#ClientOnly" aria-label="Permalink to &quot;Client-only Logins {#ClientOnly}&quot;">​</a></h2><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Logins from Non-Client IP Addresses</b></td></tr><tr><td><input name="ClientsOnly" value="1" type="radio" checked="checked"> prohibit</td></tr><tr><td><input name="ClientsOnly" value="0" type="radio"> allow</td></tr></tbody></table></div></form><p>If you do not plan to support <a href="#Mobile">roaming users</a>, you may want to select the &quot;prohibit&quot; option for the Logins from from Non-Client IP Addresses setting, to allow any type of &quot;login&quot; operation from the Client IP Addresses only.<br> Connections from other addresses are accepted, but only the services that do not require &quot;login&quot; operations will be available: SMTP mail transfer, incoming SIP requests, HTTP access to File Storage, public Mailing List browsing, etc.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Please check that your Client IP Addresses field is filled with your client addresses and read the <a href="./Security.html#Access">Security</a> section before you select this option.</p></div><h2 id="Mobile" tabindex="-1">Relaying for Roaming (non-client) Users <a class="header-anchor" href="#Mobile" aria-label="Permalink to &quot;Relaying for Roaming (non-client) Users {#Mobile}&quot;">​</a></h2><p>If some of your users travel a lot, they may use various ISPs to connect to the Internet, and as a result they will connect to your Server from various IP addresses. If those users use your Server as the SMTP mail relay to which they submit all outgoing messages, Relay Restrictions will not allow them to send messages when their IP addresses are not in the Client IP Addresses list.</p><p>You should <strong>not</strong> select the &quot;prohibit&quot; for the Logins from Non-Client IP Addresses setting, if you want to support roaming users.<br> Select the Allow option instead.</p><h3 id="AUTH" tabindex="-1">The SMTP AUTH method <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;The SMTP AUTH method {#AUTH}&quot;">​</a></h3><p>Most E-mail clients support &quot;SMTP AUTH&quot; - the standard SMTP Authentication method that allows a mailer to authenticate the user (the sender). If the SMTP module receives a message from an authenticated user, the message is marked as being &quot;submitted from a local Account&quot;, and this message can be relayed to the Internet.</p><h3 id="Temp" tabindex="-1">The Read-then-Send method <a class="header-anchor" href="#Temp" aria-label="Permalink to &quot;The Read-then-Send method {#Temp}&quot;">​</a></h3><p>To allow roaming users with older mailer applications (those not supporting SMTP AUTH) to send messages via the CommuniGate Pro server, the POP, IMAP, and other &quot;access-type&quot; modules check if an authenticated user has connected from an IP address not listed as one of the Client Addresses. During that POP/IMAP session, and for some time after the session is closed, that IP address is considered to be a &quot;Client Address&quot;, so that users can send mail via your Server right AFTER they have checked their mail.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Logins from Non-Client IP Addresses</b></td></tr><tr><td colspan="2"><input name="ClientsOnly" value="1" type="radio"> prohibit</td></tr><tr><td colspan="2"><input name="ClientsOnly" value="0" checked="checked" type="radio"> allow</td></tr><tr><td align="right"><input name="TempClients" value="1" type="checkbox" checked="checked">Process as a Client IP Address for</td><td><select name="TempClientTime"><option value="1">1 second</option><option value="5">5 seconds</option><option value="10">10 seconds</option><option value="15">15 seconds</option><option value="30">30 seconds</option><option value="60">minute</option><option value="120">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800" selected="selected">30 minutes</option><option value="3600">hour</option></select>after the user disconnects</td></tr><tr><td align="right">Remembered IP Addresses Limit:</td><td><select name="MaxTempClients"><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="30">30</option><option value="100" selected="selected">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="10000">10000</option></select></td></tr></tbody></table></div></form><p>The expiration time is used because of the &quot;dynamic IP address&quot; policies of most ISPs: when a user disconnects from an ISP modem pool, and some other user connects to the Internet via the same ISP, the same IP address can be assigned to that other user.</p><p>Inform your users about the expiration time. They should compose all their messages off-line, then they should connect to the Internet using any ISP, check their mail on your Server, and only then they can send the queued outgoing messages. If they want to reply to some messages they have just retrieved from the Mailbox on your Server, they should use the Get Mail command in their mailer application again, and only then can they send their replies.</p><p>Since many mailer applications try to send queued messages first, the SMTP module checks the Return-Path (the address in the <code>Mail From</code> SMTP protocol command). If that address is an address of a registered user, a to-be-relayed message is not rejected with the &quot;permanent failure&quot; error code. Instead, a &quot;temporary failure&quot; code is returned (with the &quot;try to authenticate first&quot; comment). Many mailers do not interrupt the mail session when they receive such a code, and continue by authenticating the user, retrieving the user mail, and retrying to send the queued messages. The queued messages will be accepted this time, because the user is authenticated from the same address.</p><p>An SMTP (message submit) session should start either during a POP or IMAP session, or within the expiration time after the end of the POP/IMAP session. Then that SMTP session can last as long as needed (several hours), if the queued messages are large and the link is slow.</p><h3 id="MobileSettings" tabindex="-1">Account and Domain Settings <a class="header-anchor" href="#MobileSettings" aria-label="Permalink to &quot;Account and Domain Settings {#MobileSettings}&quot;">​</a></h3><p>Support for roaming users can be disabled on per-account and per-domain basis by disabling the <code>Roaming</code> option in the <a href="./../objects/Accounts.html#Services">Enabled Services</a> section on the Account Settings and Domain Settings pages. If this service is disabled for an Account, the Account user will able to connect only from the internet addresses included into the Client IP Addresses list.</p><p>Mail relaying for mobile users can be disabled on per-account and per-domain basis by disabling the <code>Relay</code> option in the <a href="./../objects/Accounts.html#Services">Enabled Services</a> section on the Account Settings and Domain Settings pages. If an Account or a Domain has this service disabled, the IP address from which the user connects is not remembered as &quot;a temporary client IP address&quot;, and the SMTP Authentication will not allow this user to relay messages via your SMTP module. This setup is useful when you give users Accounts on your Server, but you do not want them to be able to relay SMTP mail through your Server (they are forced to submit messages using the WebUser Interface or any other non-SMTP methods).</p><h2 id="MailFrom" tabindex="-1">Return-Path Address Verification <a class="header-anchor" href="#MailFrom" aria-label="Permalink to &quot;Return-Path Address Verification {#MailFrom}&quot;">​</a></h2><p>If your SMTP module can accept incoming TCP connections, your server can be used by spammers as a mail relay engine: they can distribute their messages all over the world using your server. To protect your site from spammers, the SMTP module can verify the Return-Path address (specified with the Mail From SMTP command) of incoming messages.</p><p>The SMTP module parses the message Return-Path (Mail From) address and rejects it if:</p><ul><li>the Return-Path domain name is an empty string (no domain specified)</li><li>the Return-Path address is routed (via the Server Router) to the ERROR address</li></ul><p>When the Verify HELO and Return-Path option is selected in the SMTP Service Settings, the SMTP module refuses to receive a message if:</p><ul><li>the Return-Path domain name is specified as an IP address, and that address is not included into the Client Addresses list</li></ul><p>If the connection comes from an address not included into the Client IP Addresses list, additional DNS verification checks are done, and the SMTP module rejects the Return-Path address if:</p><ul><li>the Domain Name System does not have MX or A records for the Return-Path domain (an unregistered domain)</li><li>the Domain Name System has an MX record for the Return-Path domain, but it points to an A-record that does not exist (a faked domain)</li></ul><p>The SMTP module uses the <a href="./Router.html">Router</a> after it parses the Mail From address. If that address is an address of a local user, or the address is known (rerouted) with the Router, the Mail From address is accepted. This eliminates Domain Name System calls for the addresses &quot;known&quot; to the Server.</p><p>The addresses routed to the <code>ERROR</code> address are rejected, so you can specify &quot;bad&quot; addresses and domains in the Router.</p><ul><li><p>Examples:</p><p>If you do not want to accept mail from any address in the offenderdomain.com domain, put the following line into the Router settings:<br><code>offenderdomain.com = error</code><br> or<br><code>&lt;*@offenderdomain.com&gt; = error</code></p><p>If you do not want to accept mail from all addresses starting with &quot;promo&quot; in the offenderdomain.com domain, put the following line into the Router settings:<br><code>&lt;promo*@offenderdomain.com&gt; = error</code></p></li></ul><p>If the Return-Path domain cannot be verified because the Domain Name Server that keeps that domain records is not available, the module refuses to accept the message, but instead of a &quot;permanent&quot; error code the module returns a &quot;temporary&quot; error code to the sending system. The sending system will try again later.</p><p>You can tell the SMTP module to use <a href="./../mail/SMTP.html#UseSPF">SPF DNS records</a> to check that messages with the specified Return-Path can come from the sender&#39;s network (IP) address.</p><p>You can tell the SMTP module to use the <a href="./../mail/SMTP.html#UseSPF">Reverse Connect</a> method:</p><ul><li>the SMTP module makes a connection to the server that receives E-mail for this Return-Path address</li><li>the SMTP module sends the Return-Path address to that server and checks the server response</li></ul><p>If the server rejects this address, the SMTP module rejects the supplied Return-Path address, too.</p><h2 id="BlackList" tabindex="-1">Blacklisting Offenders <a class="header-anchor" href="#BlackList" aria-label="Permalink to &quot;Blacklisting Offenders {#BlackList}&quot;">​</a></h2><p>Since your SMTP module can accept incoming TCP connections, your server can be used by spammers as a mail relay engine: they can try to distribute their messages all over the world using your server, and they can also send a lot of unwanted messages to your users.</p><p>To protect your system from known spammer sites, CommuniGate Pro provides several methods to maintain &quot;black lists&quot; of offending hosts IP addresses.</p><p>When a &quot;blacklisted&quot; host connects to your server and tries to submit a message via SMTP, it gets an error message from your SMTP module and mail from that host is not accepted.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Connections from &quot;blacklisted&quot; hosts are still accepted. If you want to reject all connections from the certain Network Addresses, see the <a href="./../network/#Denied">Denied Addresses</a> section.</p></div><p>Use the WebAdmin Interface to open the Network pages in the Settings realm, then open the Blacklisted IP Addresses page.</p><h3 id="BlackFixed" tabindex="-1">Specifying Offender Addresses <a class="header-anchor" href="#BlackFixed" aria-label="Permalink to &quot;Specifying Offender Addresses {#BlackFixed}&quot;">​</a></h3><p>Enter the IP addresses of offending hosts in the Blacklisted IP Addresses field:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Blacklisted IP Addresses</b></td></tr><tr><td align="center"><textarea name="BlackListed" rows="10" cols="60">10.34.56.78               ; bad host
10.34.50.01-10.34.59.99   ; bad network
</textarea></td></tr></tbody></table></div></form><p>Each line can contain either one address: <code>10.34.56.78</code>or an address range: <code>10.34.50.01-10.34.59.99</code></p><p>A comment can be placed at the end of a line, separated with the semicolon (<code>;</code>) symbol. A line starting with the semicolon symbol is a comment line, and it is ignored.</p><h3 id="BlackDNS" tabindex="-1">Using DNS-based Blacklisting (RBL) <a class="header-anchor" href="#BlackDNS" aria-label="Permalink to &quot;Using DNS-based Blacklisting (RBL) {#BlackDNS}&quot;">​</a></h3><p>It is difficult to keep the Server &quot;blacklist&quot; current. So-called RBL (Real-time Blackhole List) services can be used to check if an IP address is known as a source of spam.</p><p>Some ISPs have their own RBL servers running, but any RBL server known to have a decent blacklist can be used with your CommuniGate Pro server. Consult with your provider about the best RBL server available.</p><p>To use RBL servers, select the <code>Use Blacklisting DNS Servers</code> option and enter the exact domain name (<em>not</em>  the IP address!) of the RBL server. Now, when the SMTP module accepts a connection from an IP address <code>aa.bb.cc.dd</code>, and this address is not listed in the Blacklisted, Unblacklistable, or Client Addresses lists, the module composes a fictitious domain name <code>dd.cc.bb.aa.rbl-server-name</code> where rbl-server-name is the domain name of the RBL server you have specified.</p><p>The SMTP module then tries to &quot;resolve&quot; this name into an IP address. If this operation succeeds and the retrieved IP address is in the 127.0.0.2-127.1.255.255 range, then the <code>aa.bb.cc.dd</code> address is considered to be blacklisted.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This option results in an additional DNS (Domain Name System) operation and it can cause delays in incoming connection processing.</p></div><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="UseRBL" value="1" type="checkbox" checked="checked"><b> Use Blacklisting DNS Servers (RBLs)</b></td></tr><tr><td align="center"><input name="RBLDomain" value="rbl.rblprovider.com" size="30" maxlength="100" type="text"></td></tr><tr><td align="center"><input name="RBLDomain" value="" size="30" maxlength="100" type="text"></td></tr></tbody></table></div></form><p>You can specify several RBL Servers using the last (empty) field in the RBL Server table. To remove a server from the list, enter an empty string into its field. The more servers you use, the larger the incoming connection processing delay. If you really need to use several RBL servers, but do no want those additional delays, make your own DNS server retrieve the RBL information from those servers (using daily zone updates) and use your own DNS server as an RBL server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>An RBL server failure can cause very long delays for incoming connections. To avoid these situations, the requests to RBL servers are sent not more than twice, each time with the minimal time-out.</p></div><h3 id="BlackNames" tabindex="-1">Blacklisting Domains by Name <a class="header-anchor" href="#BlackNames" aria-label="Permalink to &quot;Blacklisting Domains by Name {#BlackNames}&quot;">​</a></h3><p>When a client connects from a network address not listed in the Blacklisted IP Addresses lists, and the Blacklist by DNS Name option is enabled, the server tries to get the domain name for that IP address (if the IP address is <code>aa.bb.cc.dd</code>, the Server tries to retrieve the PTR record for the <code>dd.cc.bb.aa.in-addr.arpa</code> name).<br> If the PTR domain name is retrieved, it is checked against the strings specified in the table (these strings can include the wildcard (<code>*</code>) symbols). If the retrieved name matches one of the table strings, the address is processed as a blacklisted one.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="UseBlacklistByName" value="1" type="checkbox" checked="checked"><b> Detect Blacklisted by DNS Name</b></td></tr><tr><td align="center"><input name="BlacklistByNames" value="*.dial-up.telco.dom" size="30" maxlength="100" type="text"></td></tr><tr><td align="center"><input name="BlacklistByNames" value="" size="30" maxlength="100" type="text"></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the Blacklist by DNS Name option is enabled, the server has to make an additional reverse-lookup DNS operation (unless the <a href="#ClientDNS">Detect Clients by DNS Name</a> has been already enabled). This additional DNS operation can cause additional delays when processing incoming SMTP connections, so enable this option only when needed, and only when you cannot specify all blacklisted addresses explicitly - in the Blacklisted IP Addresses list.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the reverse-lookup DNS operation fails, the server places the DNR error code into the container used to keep the reverse-lookup DNS operation results (DNS names). The error code is enclosed in parenthesis. To blacklist all network addresses that do not have reverse-DNS records, place the <code>(host name is unknown)</code> string into the Blacklist by DNS Name table:</p></div><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="UseBlacklistByName" value="1" type="checkbox" checked="checked"><b> Detect Blacklisted by DNS Name</b></td></tr><tr><td align="center"><input name="BlacklistByNames" value="*.dial-up.telco.dom" size="30" maxlength="100" type="text"></td></tr><tr><td align="center"><input name="BlacklistByNames" value="(host name is unknown)" size="30" maxlength="100" type="text"></td></tr><tr><td align="center"><input name="BlacklistByNames" value="" size="30" maxlength="100" type="text"></td></tr></tbody></table></div></form><h3 id="WhiteHoles" tabindex="-1">Un-listing Addresses (White Hole Addresses) <a class="header-anchor" href="#WhiteHoles" aria-label="Permalink to &quot;Un-listing Addresses (White Hole Addresses) {#WhiteHoles}&quot;">​</a></h3><p>When using RBL Servers or DNS Names for blacklisting, you may want to avoid blacklisting certain sites.</p><p>Enter those &quot;unblacklistable&quot; addresses using the same format you use for Blacklisted IP Address list:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="UseBlacklistByName" value="1" type="checkbox" checked="checked"><b> UnBlacklistable (White Hole) IP Addresses</b></td></tr><tr><td align="center"><textarea name="WhiteHoles" rows="10" cols="60">192.168.254.18 ; a good fellow, got into RBL by mistake</textarea></td></tr></tbody></table></div></form><p>You can &quot;unblacklist&quot; addresses using their DNS (PTR) names:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="UseBlacklistByName" value="1" type="checkbox" checked="checked"><b> Detect White Holes by DNS Name</b></td></tr><tr><td align="center"><input name="WhiteHolesByNames" value="*.communigatepro.ru" size="30" maxlength="100" type="text"></td></tr><tr><td align="center"><input name="WhiteHolesByNames" value="" size="30" maxlength="100" type="text"></td></tr></tbody></table></div></form><p>Select the checkbox to enable this option and enter the DNS domain names you do not want to be blacklisted. This can be useful if some &quot;good&quot; addresses are blacklisted with the RBL services you use.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The explicitly specified Blacklisted IP Addresses cannot be &quot;unblacklisted&quot; using the DNS Names.</p></div><h3 id="BlacklistedHeader" tabindex="-1">Processing Messages from Blacklisted Addresses <a class="header-anchor" href="#BlacklistedHeader" aria-label="Permalink to &quot;Processing Messages from Blacklisted Addresses {#BlacklistedHeader}&quot;">​</a></h3><p>You can modify the SMTP module reaction on messages coming from blacklisted IP addresses. Instead of rejecting them (by adding the <code>@blacklisted</code> suffix to all their recipient addresses), the module can accept those message, but add a specified Header field to each of them:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Messages from Blacklisted IP Addresses</b></td></tr><tr><td align="center" width="50%"><input name="RejectBlacklisted" checked="checked" value="1" type="radio"> Reject</td><td align="center"><input name="RejectBlacklisted" value="0" type="radio"> Add Header: <input name="BlacklistedHeader" value="X-Spam: ^1 blacklisted(^0)" size="30" maxlength="256" type="text"></td></tr></tbody></table></div></form><p>The Header field string can contain the following macro combinations:</p><ul><li><code>^0</code>. This combination is replaced with the name of the RBL host blacklisting the address. If no RBL host was used, the combination is replaced with an empty string.</li><li><code>^1</code>. This combination is replaced with the network address of the blacklisted host.</li></ul><h3 id="TempBlock" tabindex="-1">Temporarily Blocked Addresses <a class="header-anchor" href="#TempBlock" aria-label="Permalink to &quot;Temporarily Blocked Addresses {#TempBlock}&quot;">​</a></h3><p>CommuniGate Pro maintains its own &quot;temporary Blacklist&quot;. Network addresses in that list are blocked for a certain time period only.</p>`,112),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Temporarily Blocked IP Addresses")])]),e("tr",{valign:"top"},[e("td",{nowrap:"nowrap",align:"RIGHT"},"Block after:"),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"BlockedLoginsLimit"},[e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"7"},"7"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000",selected:"selected"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"1001"},"other")]),o(" failed Logins in "),e("select",{class:"popup",name:"BlockedLoginsPeriod"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600",selected:"selected"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"601"},"other")])]),e("td",{colspan:"2"}," ")]),e("tr",{valign:"top"},[e("td",{nowrap:"nowrap",align:"RIGHT"},"Block after:"),e("td",{nowrap:"nowrap"},[e("select",{class:"popup",name:"BlockedLoginsLimit"},[e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"7"},"7"),e("option",{value:"10"},"10"),e("option",{value:"15"},"15"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000",selected:"selected"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"1001"},"other")]),o(" protocol errors in "),e("select",{class:"popup",name:"BlockedLoginsPeriod"},[e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600",selected:"selected"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2400"},"40 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"172800"},"2 day(s)"),e("option",{value:"259200"},"3 day(s)"),e("option",{value:"604800"},"7 day(s)"),e("option",{value:"601"},"other")])]),e("td",{colspan:"2"}," ")]),e("tr",null,[e("td",{align:"RIGHT",nowrap:"nowrap"},"Blocking Time:"),e("td",null,[e("select",{name:"BlockedTime"},[e("option",{value:"0",selected:"selected"},"0 sec"),e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"86399"},"other")])]),e("td",{align:"RIGHT",nowrap:"nowrap"},"Blocked Addresses Limit:"),e("td",null,[e("select",{name:"BlockedLimit"},[e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000",selected:"selected"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"29999"},"other")])])]),e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},"Temporarily UnBlockable IP Addresses")]),e("tr",null,[e("td",{nowrap:"nowrap",align:"right"},"UnBlocking Time:"),e("td",null,[e("select",{class:"popup",name:"TempUnBlockableTime"},[e("option",{value:"0"},"0 sec"),e("option",{value:"1"},"1 sec"),e("option",{value:"2"},"2 sec"),e("option",{value:"3"},"3 sec"),e("option",{value:"5"},"5 sec"),e("option",{value:"10"},"10 sec"),e("option",{value:"15"},"15 sec"),e("option",{value:"20"},"20 sec"),e("option",{value:"30"},"30 sec"),e("option",{value:"40"},"40 sec"),e("option",{value:"60"},"60 sec"),e("option",{value:"90"},"90 sec"),e("option",{value:"120"},"2 min"),e("option",{value:"180"},"3 min"),e("option",{value:"300"},"5 min"),e("option",{value:"600"},"10 min"),e("option",{value:"900"},"15 min"),e("option",{value:"1200"},"20 min"),e("option",{value:"1800",selected:"selected"},"30 min"),e("option",{value:"2700"},"45 min"),e("option",{value:"3600"},"60 min"),e("option",{value:"7200"},"2 hour(s)"),e("option",{value:"10800"},"3 hour(s)"),e("option",{value:"14400"},"4 hour(s)"),e("option",{value:"21600"},"6 hour(s)"),e("option",{value:"28800"},"8 hour(s)"),e("option",{value:"36000"},"10 hour(s)"),e("option",{value:"43200"},"12 hour(s)"),e("option",{value:"86400"},"24 hour(s)"),e("option",{value:"1801"},"other")])]),e("td",{nowrap:"nowrap",align:"right"},"UnBlockable Addresses Limit:"),e("td",null,[e("select",{class:"popup",name:"TempUnBlockableLimit"},[e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000",selected:"selected"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"3001"},"other")])])])])])])],-1),t('<p>IP Addresses can be blocked when the Server detects some activity from those addresses that can be qualified as suspicious:</p><ul><li><p>too many protocol errors in <a href="./../mail/SMTP.html#DenyOnError">SMTP receiving sessions</a> (the number of errors is configured in the SMTP module)</p></li><li><p>addresses routed to the <a href="#SpamTrap"><code>spamtrap</code> address</a> in SMTP receiving sessions</p></li><li><p>too many failed authentication (Login) attempts from the same address</p></li><li><p>too many protocol errors (misformed packets) in the packet-based protocols, such as <a href="./../signals/SIP.html">SIP</a>.</p></li><li><p><code>Block after</code></p><p>Use this setting to specify when a Network IP Address should be blocked:</p><ul><li><p><code>failed Logins in</code></p><p>maximum frequency of failed Login attempts: if there are more failed Login attempts from some IP Address during the specified period of time, this IP Address is blocked.</p></li><li><p><code>protocol errors in</code></p><p>maximum frequency of protocol errors or misformed packets: if there are more misformed protocol packets from some IP Address during the specified period of time, this IP Address is blocked.</p></li></ul></li><li><p><code>Blocking Time</code></p><p>Use this setting to specify for how long an IP Address should be blocked.</p></li><li><p><code>Blocked Addresses Limit</code></p><p>Use this setting to specify the maximum number of IP Addresses the Server can block.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Addresses included into the <a href="#WhiteHoles">White Hole Addresses</a> list are never placed into the Temporarily Blocked Addresses list.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>In a <a href="./../cluster/">Dynamic Cluster</a> environment only the Cluster-wide Temporarily Blocked Addresses settings are in effect.</p></div><ul><li><p><code>Temporarily UnBlockable IP Addresses</code></p><p>The Temporarily UnBlockable IP Addresses are a temporary analogue of permanent <a href="#WhiteHoles">White Hole Addresses</a>.<br> An IP address becomes temporarily unblockable as a result of successful authentication made from that address.</p><ul><li><p><code>UnBlocking Time</code></p><p>Use this setting to specify for how long an IP Address should be unblockable.</p></li><li><p><code>UnBlockable Addresses Limit</code></p><p>Use this setting to specify the maximum number of IP Addresses the Server can not block.</p></li></ul></li></ul><h2 id="TestAddress" tabindex="-1">Checking Network Address Status <a class="header-anchor" href="#TestAddress" aria-label="Permalink to &quot;Checking Network Address Status {#TestAddress}&quot;">​</a></h2><p>Your IP tables can become quite large, making it difficult to check if a particular network address is recognized by the Server as a Client one, or as a Blacklisted one.</p><p>Use the Test Address panel located on the Client IP Addresses and Blacklisted IP Addresses pages:</p>',8),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{align:"center",nowrap:"nowrap",width:"50%"},[o("Test Address: "),e("input",{name:"TestAddress",value:"10.0.1.89",size:"20",maxlength:"100",type:"text"})]),e("td",null,[e("input",{name:"Test",value:"Test",class:"button",type:"reset"})]),e("td",{align:"center",nowrap:"nowrap"},"[10.0.1.89](host1.lan) is Trusted")])])])])],-1),t(`<p>Enter an IP address and click the Test button. The IP address status appears.</p><p>The status shows the IP address you have entered. It can have the <code>Local</code> prefix, if the address is the local address of your Server, or it can have the <code>LAN</code> prefix, if the address is included into <a href="./../network/">LAN IP Addresses</a> list.</p><p>The &quot;reverse-resolved&quot; name is displayed if the Server had to perform the &quot;reverse-resolving&quot; DNS operation to get the address status.</p><p>The address and optional name are followed by the address status:</p><ul><li><p><code>Trusted</code></p><p>the IP address is a Client IP address.</p></li><li><p><code>TempTrusted</code></p><p>the IP address is processed as a Client IP address because some user (with the Relay Service enabled) has recently authenticated from that address.</p></li><li><p><code>Blacklisted</code></p><p>the IP address is blacklisted. If the address is blacklisted because it is included into some RBL, the name of that RBL server is displayed.</p></li><li><p><code>Regular</code></p><p>all other addresses.</p></li></ul><h2 id="SpamTrap" tabindex="-1">Spam Traps <a class="header-anchor" href="#SpamTrap" aria-label="Permalink to &quot;Spam Traps {#SpamTrap}&quot;">​</a></h2><p>You can protect your site from incoming spam by creating and advertising one or several &quot;spam-trap&quot; E-mail addresses. The CommuniGate Pro Router detects a special local address, <code>spamtrap</code>. If your server receives a message, and at least one of its recipients is <code>spamtrap@yourhost</code> or at least one of its recipients is routed to <code>spamtrap</code>, the Server rejects the entire message.</p><p>You may want to create one or several alias records for &quot;nice-looking&quot; fictitious E-mail addresses and route those addresses to <code>spamtrap</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;misterX&gt; = spamtrap</span></span>
<span class="line"><span>&lt;johnsmith@subdomain.com&gt; = spamtrap</span></span></code></pre></div><p>Alternatively, you can create <a href="./../objects/Forwarders.html">Forwarders</a> pointing to the <code>spamtrap</code> address.</p><p>Then you should do your best to help these addresses (<code>misterX@yoursite.com</code>, <code>johnsmith@subdomain.com</code>) to get to the bulk mailing lists used by spammers. Since most of those lists are composed by robots scanning Web pages and Usenet newsgroups, place these fictitious addresses on Web pages and include them into the signatures used when you and your users post Usenet messages. To avoid confusion, make the fictitious E-mail addresses invisible for a human browsing your Web pages and/or attach a comment explaining the purpose of these addresses.</p><p>Many bulk mailing lists are sorted by the domain name, and as a result many spam messages come to your site addressed to several recipients. These recipients are the E-mail addresses in your domain(s) that became known to spammers. When the fictitious, &quot;spam-trap&quot; addresses make it to those databases, most of spam messages will have these addresses among the message recipients. This will allow the Server to reject the entire messages, and they will not be delivered to any real recipient on your site.</p><p>When at least one of the incoming message recipient addresses is routed to the <code>spamtrap</code> address, the entire message is rejected, and the IP Address of the sending server is placed into the <a href="#TempBlock">Temporarily Blocked Addresses</a> list, unless this IP Address is included into the <a href="#ClientFixed">Client IP Addresses</a> or <a href="#WhiteHoles">White Hole Addresses</a> lists.</p><h2 id="Banned" tabindex="-1">Banning Mail by Header and Body Lines <a class="header-anchor" href="#Banned" aria-label="Permalink to &quot;Banning Mail by Header and Body Lines {#Banned}&quot;">​</a></h2><p>You can specify a set of message Header and Body lines to be used to detect spam. When the server receives mail in the RFC822 format (via <a href="./../mail/SMTP.html">SMTP</a>, <a href="./../mail/RPOP.html">RPOP</a>, <a href="./../access/POP.html#XMIT">POP XTND XMIT</a>, <a href="./../mail/PIPE.html">PIPE</a> modules), it compares each received header and body line with the specified lists. If a message contains one of the specified lines, the message is rejected.</p><p>You can use the wildcard (&#39;*&#39;, asterisk) symbols in the Banned Lines you specify. Usually you should not use them, since you are expected to compose the &quot;banned&quot; lists by copying header or body lines from the known spam messages.</p><p>Message lines are compared to the specified Banned lines in the <strong>case-sensitive</strong> mode.</p><p>Each Header line can include the end of line symbols if the header field was &quot;wrapped&quot;.</p><p>If a message header or body is encoded (using MIME or UU encoding), the lines are <strong>not</strong> decoded before they are compared to the Banned line sets.</p><p>To specify the set of Banned Lines, open the Queue pages in the Settings realm of the WebAdmin Interface, and click the RFCReader link.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Banned Header Lines</b></td></tr><tr><td align="center"><input type="text" name="BannedHeaderLines" value="Subject: Body Fat Loss-No Dieting!" size="60" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="BannedHeaderLines" value="From: The Legal Network &lt;*@*hackedisp.com&gt;" size="60" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="BannedHeaderLines" value="" size="60" maxlength="1000"></td></tr></tbody></table></div><br><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Banned Body Lines</b></td></tr><tr><td align="center"><input type="text" name="BannedBodyLines" value="No special skills or experience is required. We will give you" size="60" maxlength="1000"></td></tr><tr><td align="center"><input type="text" name="BannedBodyLines" value="" size="60" maxlength="1000"></td></tr></tbody></table></div></form><p>To add a new line, enter it in the empty field, and click the Update button.</p><p>To remove a line, delete it from its field, and click the Update button.</p><h2 id="Filter" tabindex="-1">Filtering Mail <a class="header-anchor" href="#Filter" aria-label="Permalink to &quot;Filtering Mail {#Filter}&quot;">​</a></h2><p>When a message is received with the Server, a set of <a href="./../mail/QueueRules.html">Server-Wide Rules</a> is applied. These Rules can be used to detect unwanted messages and reject, discard, or redirect them.</p><p>For example, the following Rule can be used to reject all messages that have a missing <code>To:</code> header field:</p>`,26),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null,"Data"),e("th",null,"Operation"),e("th",null,"Parameter")]),e("tr",null,[e("td",null,[e("select",{name:"c0000"},[e("option",{value:"0"},"---"),e("option",{value:"1",selected:"selected"},"Header Field")])]),e("td",null,[e("select",{name:"o0000"},[e("option",{value:"0",selected:"selected"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p0000",value:"To:*",size:"20",maxlength:"200"})])]),e("tr",{align:"left"},[e("th",null,"Action"),e("th",{colspan:"2"},"Parameter")]),e("tr",{valign:"top"},[e("td",null,[e("select",{name:"a0000"},[e("option",{value:"0"},"---"),e("option",{value:"1",selected:"selected"},"Reject with")])]),e("td",{colspan:"2"},[e("textarea",{name:"r0000",rows:"4",cols:"30"},"Messages without To: fields are not accepted here")])])])])])],-1),t(`<p>You can create various filtering rules using all features of CommuniGate Pro Automated Mail Processing, including external filter programs started with the <code>Execute</code> Rule Action.</p><h2 id="RouterRelay" tabindex="-1">Relaying Rerouted Messages <a class="header-anchor" href="#RouterRelay" aria-label="Permalink to &quot;Relaying Rerouted Messages {#RouterRelay}&quot;">​</a></h2><p>Read this section if you need to provide special relaying features.</p><p>If you place an alias record into the Router table:</p><p><code>NoRelay:&lt;user&gt; = user@other.host</code> then all mail from strangers to that user will be rerouted to that other.host server. If that server address is not included into the Client IP Addresses list, these messages will be treated as messages &quot;from a stranger to a stranger&quot;, and they will be rejected if the Relay for Clients Only option is switched on.</p><p>To enable relaying, use the <code>Relay:</code> prefix:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Relay:&lt;user&gt; = user@other.host</span></span>
<span class="line"><span>&lt;user&gt; = user@other.host</span></span></code></pre></div><p>When an address is being converted with such a record, it gets a marker that allows the server to relay messages to that address. If an address is modified with a record that has the <code>NoRelay:</code> prefix, this marker is not set, but it is not reset either - if it has has been set with some other Router record (see the example below).</p><p>The same situation exists if you want to reroute all mail for a certain domain to a different host (for example, if you back up that host), and that host address is not included into the Client IP Addresses list.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Relay:clienthost.com = client1.com</span></span>
<span class="line"><span>Relay:&lt;*@clienthost.com&gt; = client1.com</span></span></code></pre></div><p>When the address modified with the Router record is not a &quot;simple address&quot;, i.e. it contains several routes, as in <code>user%host1@host2</code>, or <code>&lt;@host2:user@host1&gt;</code> - the <code>Relay:</code> prefix does not set the flag that allows message relaying. This is done because the host to which the rerouted message is relayed may &quot;trust&quot; all messages that come from your host, and relaying addresses with multiple routes would allow someone to relay messages to anybody through your host and that other host.</p><p>If the receiving server is well-protected, too, you may need a Router record that allows relaying of any address rerouted with that record. Use the <code>RelayAll:</code> prefix for those records:</p><p><code>RelayAll:&lt;report-*@clienthost.com&gt; = report-*@client1.com</code></p><p>Very often you do not want the Router records to be used for actual relaying - you provide them for your own clients only, to specify a special path for certain addresses/domains. For example, if you want mail to <code>bigprovdier.com</code> to be sent via a particular relay <code>relay3.com</code>, you should place the following record into the Router table:</p><p><code>NoRelay:bigprovdier.com = bigprovdier.com@relay3.com._via</code></p><p>Without the NoRelay prefix, any host on the Internet could send messages to bigprovdier.com via your Server. The NoRelay prefix tells the Router not to add marker to addresses in the bigprovdier.com domain, so only your own users (clients) can send mail to bigprovdier.com domain using your Server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You may have an alias record in your Router:</p><p><code>Relay:&lt;joe&gt; = joe5@bigprovdier.com</code></p><p>This record tells the server to reroute all mail addressed to <a href="mailto:joe@mydomain.com" target="_blank" rel="noreferrer">joe@mydomain.com</a> to <a href="mailto:joe5@bigprovdier.com" target="_blank" rel="noreferrer">joe5@bigprovdier.com</a>. Since this record has the <code>Relay:</code> prefix, anybody in the world can send E-mail messages and Signals to <a href="mailto:joe@mydomain.com" target="_blank" rel="noreferrer">joe@mydomain.com</a> and they will be successfully relayed to the bigprovdier.com domain.<br> The <code>joe5@bigprovdier.com</code> address will be converted to <code>joe5%bigprovdier.com@relay3.com._via</code> and sent via relay3.com host: the second address transformation does not add the &quot;can relay&quot; marker, but it does not reset the &quot;can relay&quot; marker set during the first transformation:</p><table tabindex="0"><thead><tr><th>Operation Applied</th><th>Address</th><th>Marker</th></tr></thead><tbody><tr><td>Received (Original) address</td><td><code>joe@mydomain.com</code></td><td>NO</td></tr><tr><td>Main Domain (<code>mydomain.com</code>) cut-off:</td><td><code>joe</code></td><td>NO</td></tr><tr><td>Router Record: <code>Relay:&lt;joe&gt; = joe5@bigprovdier.com</code></td><td><code>joe5@bigprovdier.com</code></td><td>YES</td></tr><tr><td>Router Record: <code>NoRelay:bigprovdier.com = bigprovdier.com@relay3.com._via</code></td><td><code>joe5%bigprovdier.com@relay3.com._via</code></td><td>YES</td></tr><tr><td>SMTP/SIP Module: accepted for the host <code>relay3.com</code></td><td><code>joe5@bigprovdier.com</code></td><td>YES</td></tr></tbody></table></div><h2 id="Cluster" tabindex="-1">Cluster Setup <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Cluster Setup {#Cluster}&quot;">​</a></h2><p>When a Server is a member of a <a href="./../cluster/">Dynamic Cluster</a>, the WebAdmin Network and Queue Settings pages provide links that allow you to switch between the local (server-wide) and the cluster-wide Settings.</p><p>The cluster-wide Address Tables (Client IP Addresses, Blacklisted IP Addresses, Unblacklistable IP Addresses) are processed as extensions of the server-wide tables: an address is considered to be listed if it is included into either the server-wide or into the cluster-wide table.</p><p>The cluster-wide &quot;Client By DNS Name&quot; list is processed as an extension of the individual server-wide list of &quot;Client By DNS Name&quot; domain names (if the Detect Clients by DNS Name option is enabled on the cluster-wide page).</p><p>The cluster-wide &quot;Blacklist By DNS Name&quot; list is processed as an extension of the individual server-wide list of &quot;Blacklist By DNS Name&quot; domain names (if the Blacklist by DNS Name option is enabled on the cluster-wide page).</p><p>The cluster-wide list of &quot;Blacklisted&quot; RBLs is processed as an extension of the individual server-wide RBL server lists. Each server will consult with the locally-specified RBL servers first, then it will consult with the RBL servers specified in the cluster-wide settings.</p><p>The cluster-wide &quot;Banned&quot; settings are processed as extensions of the server-wide settings: a message is banned if its header or body line is listed in the server-wide or in the cluster-wide settings.</p>`,24)]))}const y=a(r,[["render",l]]);export{v as __pageData,y as default};
