import{_ as o,c as t,o as a,ag as s}from"./chunks/framework.jCcxW76o.js";const p=JSON.parse('{"title":"Router","description":"","frontmatter":{"legacyLink":"Router.html"},"headers":[],"relativePath":"admin/sysadmin/Router.md","filePath":"admin/sysadmin/Router.md"}'),i={name:"admin/sysadmin/Router.md"};function n(r,e,d,l,c,m){return a(),t("div",null,e[0]||(e[0]=[s(`<h1 id="router" tabindex="-1">Router <a class="header-anchor" href="#router" aria-label="Permalink to &quot;Router&quot;">​</a></h1><p>This section is for advanced administrators only. In most situations the default routing methods are sufficient. Only if your Server is working as a message or signal relay for other systems, or if you want to use sophisticated routing schemes, should you read this section.</p><p>When the Server processes a submitted <a href="./../mail/">Message</a>, it extracts the information about recipients from the message &quot;envelope&quot; and decides into which module queue the message should be placed, which entity the module should send the message to, and how it should address that entity. Similar operations are performed with <a href="./../cluster/Signals.html">Real-time Signals</a> received from external sources or generated with internal components and directed to local or external entities.</p><p><a href="./../cluster/Access.html">Access</a> modules (such as <a href="./../access/POP.html">POP</a>, <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/WebUser.html">WebUser Interface</a>, etc.) also deal with addresses. When a client application or program logs in, it provides a name of the Account it wants to log into. This address is processed using the same operations as ones used to process Message and Signal addresses.</p><p>The CommuniGate Pro Router component implements these routing operations. Whenever your Server gets some address, that address is processed using the Router component. This provides additional consistency to all Server components: when, for example, you create an <a href="./../objects/#Aliases">Alias</a> for some Account, that Alias can be used to send E-mail and Signals to that Account, and the Alias name can be used to log into that Account.</p><h2 id="Address" tabindex="-1">Address Structure <a class="header-anchor" href="#Address" aria-label="Permalink to &quot;Address Structure {#Address}&quot;">​</a></h2><p>Each E-mail or Signal address consists of two strings: a domain name and a local part. Usually, an address looks like <code>xxxx@yyyyy</code>, where yyyyy is the domain name (the unique name of the recipient mail system) and xxxx is the local part, i.e. a user name or an account name in that system.</p><ul><li><p>Addresses can be more complicated, for example, an E-mail address can include some path information:</p><p><code>&lt;@zzzz:xxxx@yyyyy&gt;</code> or <code>zzzz!yyyyy!xxxx</code> or <code>xxxx%yyyyy@zzzz</code><br> These addresses specify that an E-mail message or a Signal should be sent to the system zzzz first, and then that system should deliver it to xxxx@yyyyy (to the account xxxx on the system yyyyy).</p></li></ul><p>When the Router parses an address, it extracts the name of the system the message should be delivered to. It becomes the domain name part of the address. The rest of the address is placed into the local part, i.e. the local part defines the recipient when the message or the signal is delivered to the system specified with the domain name. In the examples above, the domain name part is zzzz, while the local part is xxxx@yyyyy.</p><p>See the RFC822 and related documents for details on E-mail address formats.</p><p>If a local part contains a complex address (i.e. the local part itself contains domain name(s) and a local part), the local part is presented using the <code>%</code> notation: <code>local%domain1%domain2</code>, so the full address in the CommuniGate Pro canonical form would be <code>local%domain1%domain2@domain</code>.</p><h2 id="OwnDomain" tabindex="-1">Main Domain Name <a class="header-anchor" href="#OwnDomain" aria-label="Permalink to &quot;Main Domain Name {#OwnDomain}&quot;">​</a></h2><p>When the domain name is extracted from an address, the Router compares it against the domain name of the Server (set in the <a href="./#General">General</a> settings). If they match, the domain name is set to an empty string. When the domain part becomes an empty string, the Router restarts processing with the local part, trying to divide it into the domain and local parts again.<br> For example, if the Main Domain name of your Server is company.com, then the following addresses will be converted as shown:</p><table tabindex="0"><thead><tr><th style="text-align:right;">Address</th><th>local part</th><th>domain part</th></tr></thead><tbody><tr><td style="text-align:right;"><code>support@company.com</code></td><td><code>support</code></td><td><code>company.com</code></td></tr><tr><td style="text-align:right;"><em>routed --&gt;</em></td><td><code>support</code></td><td></td></tr><tr><td style="text-align:right;"><code>&lt;@company.com:sales@example.com&gt;</code></td><td><code>sales@example.com</code></td><td><code>company.com</code></td></tr><tr><td style="text-align:right;"><em>routed --&gt;</em></td><td><code>sales@example.com</code></td><td></td></tr><tr><td style="text-align:right;"><em>routed --&gt;</em></td><td><code>sales</code></td><td><code>example.com</code></td></tr></tbody></table><h2 id="MX" tabindex="-1">Domains and DNS records <a class="header-anchor" href="#MX" aria-label="Permalink to &quot;Domains and DNS records {#MX}&quot;">​</a></h2><p>Your Server can support many independent <a href="./../objects/Domains.html">Domains</a> in addition to the Main Server Domain.</p><p>In order to process Messages and Signals directed to your Server Domains, you should ensure that the Messages sent to that domain are directed to your Server with the global DNS system.</p><p>Example 1: your server (example.com) serves the example.com Domain and a partners-example.com Domain. Make sure that DNS MX records are created for both Domains, and that those records point to your example.com Server.</p><p>Example 2: your server (example.com) acts as an &quot;Remote POP&quot; mail host relay for some client systems. Each client has its own domain name (client1.com, client2.com, and client3.com), and you have configured your Router to ensure that all E-mails sent to the client1.com domain will be routed to the Unified Domain-Wide Account client1, etc.<br> You should also ensure that when an E-mail is sent to the client1.com domain, that E-mail is routed to your server (example.com). The client1.com MX record should be created in the DNS system and that record should point to your Server (example.com).</p><h2 id="Table" tabindex="-1">Routing Table <a class="header-anchor" href="#Table" aria-label="Permalink to &quot;Routing Table {#Table}&quot;">​</a></h2><p>When an address is parsed and its domain part is extracted, the Router checks the routing records in the Routing Table.</p><p>Use the WebAdmin Interface to manage the Routing Table. Open the Router page in the Settings realm:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="center">Log Level: <select name="LogLevel"><option value="0">Crashes Only</option><option value="1" selected="selected">Failures</option><option value="2">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td></tr><tr><td align="center"><textarea style="font-size:9pt;" name="RouterTable" rows="12" cols="80">fax.company.com     = company.com       ; -&gt; to the same domain
hq.company.com      = newhq.company.com ; -&gt; to some other server
Relay:*.test.com    = company.com       ; aaa.test.com, bbb.test.com
; just a comment line
&lt;sales&gt;             = john              ; simple alias
&lt;sales@client1.com&gt; = sales-client1     ; simple foreign alias
&lt;info@client1.com&gt;  = info@otherhost.com; account -&gt; other account
&lt;*@client2.com&gt;     = *.cl2             ; sales@.. -&gt; sales.cl2
test.com            = Unified.local     ; unified Domain-Wide Account</textarea></td></tr><tr><td align="center"><input name="ExtendNonQualifiedDomains" value="1" type="checkbox"> Add <input name="DomainQualifier" value="myorg.org" size="20" maxlength="63" type="text"> to Non-Qualified Domain Names</td></tr></tbody></table></div></form><p>Each line in the Routing Table is a routing record. A routing record contains optional prefixes, a left part, the equals (<code>=</code>) symbol and a right part. The semicolon (<code>;</code>) symbol can be used to place a comment after the right part of a routing record. A comment line can be added to the Table by inserting a line starting with the semicolon symbol.</p><p>The Router takes a parsed address (i.e. the domain and local parts of the address) and uses the Table, scanning its records from top to bottom. If an applicable record is found, it is applied as described below and the modified address is processed with the Router again.</p><ul><li><p><code>Log Level</code></p><p>Use this setting to specify what kind of information the CommuniGate Pro Router should put in the System Log. Usually you should use the <code>Failures</code> (address routing failures) level. But when you experience problems with the Router, you may want to set the Log setting to <code>Low-Level</code> or <code>All Info</code>: in this case more low-level information about the Router activity will be recorded in the System Log as well. The Router component records in the System Log are marked with the <code>ROUTER</code> tag.</p></li></ul><h3 id="RecordPrefix" tabindex="-1">Prefix <a class="header-anchor" href="#RecordPrefix" aria-label="Permalink to &quot;Prefix {#RecordPrefix}&quot;">​</a></h3><p>A Routing record can contain a Relay-mode prefix: <code>Relay:</code> (can be shorten to <code>R:</code>), <code>NoRelay:</code> (can be shorten to <code>N:</code>), or <code>RelayAll:</code>. See the <a href="./Protection.html#RouterRelay">Protection</a> section for the details.<br> If none of these prefixes is specified, the <code>NoRelay:</code> prefix is assumed.</p><p>A Routing record can contain zero, one, or several of the following operation-type prefixes:</p><ul><li><code>Mail:</code> (can be shorten to <code>M:</code>). Records with this prefix take effect when an address is routed for some E-mail delivery operation.</li><li><code>Access:</code> (can be shorten to <code>A:</code>). Records with this prefix take effect when an address is routed for some account access operation.</li><li><code>Signal:</code> (can be shorten to <code>S:</code>). Records with this prefix take effect when an address is routed for some Signal operation.</li></ul><p>These prefixes should be specified after an optional Relay-mode prefix. If none of these prefixes is specified, the Routing record is applied to addresses used in all operations.</p><h3 id="RecordSample" tabindex="-1">Sample <a class="header-anchor" href="#RecordSample" aria-label="Permalink to &quot;Sample {#RecordSample}&quot;">​</a></h3><p>The left part of a Routing record contains a Sample: a string with an optional wildcard.</p><p>The following wildcards are supported:</p><ul><li><p><code>*</code></p><p>this wildcard matches zero or more symbols.</p><ul><li><p>Example:</p><p><code>sta*r</code><br> This sample matches any <code>sta_XXXXXX_r</code> string where <em>XXXXXX</em> is any substring (including an empty substring inside the star string).</p></li></ul></li><li><p><code>(size type)</code></p><p><em>type</em> is the substring type:</p><ul><li><code>d</code> - decimal digits (<code>0</code> .. <code>9</code>)</li><li><code>h</code> - hexadecimal digits (<code>0</code> .. <code>9</code>, <code>A</code> .. <code>F</code>, <code>a</code> .. <code>f</code>)</li><li><code>L</code> - alpha-numeric symbols (<code>0</code> .. <code>9</code>, <code>A</code> .. <code>Z</code>, <code>a</code> .. <code>z</code>)</li><li><code>*</code> - any symbols</li></ul><p><em>size</em> is an optional substring length. It can be specified in the following forms:</p><ul><li><p><code>_nnn_</code> (where <em>nnn</em> a decimal number): a matched substring should have <em>nnn</em> symbols.</p></li><li><p><code>_nnn_+</code> : a matched substring should have <em>nnn</em> or more symbols.</p></li><li><p><code>_nnn_-_mmm_</code> (where <em>mmm</em> a decimal number, <em>mmm</em> &gt;= <em>nnn</em>): a matched substring should have between <em>nnn</em> and <em>mmm</em> symbols.</p></li><li><p>Example:</p><p><code>sta(3*)r</code><br> This sample matches any <code>sta_XXX_r</code> string where <em>XXX</em> are any 3 symbols.</p></li><li><p>Example:</p><p><code>sta(4+d)r</code><br> This sample matches any <code>sta_DDDDD_r</code> string where <em>DDDDD</em> are 4 or more decimal digits.</p></li><li><p>Example:</p><p><code>sta(3-5h)r</code><br> This sample matches any <code>sta_HHH_r</code> string where <em>HHH</em> are 3,4, or 5 hexadecimal digits.</p></li></ul></li></ul><p>The backslash (<code>\\</code>) symbol is used as an escape symbol: <code>\\\\</code> is processed as a single backslash symbol, <code>*</code> is processed as an asterisk symbol, etc.</p><p>Only one wildcard symbol is allowed in a sample.</p><h3 id="RecordRoute" tabindex="-1">Route <a class="header-anchor" href="#RecordRoute" aria-label="Permalink to &quot;Route {#RecordRoute}&quot;">​</a></h3><p>The right part of a Routing record contains a Route: a string with an optional <code>*</code> wildcard.</p><p>When the Record Sample matches an address, the address is changed to the Record Route. The substring matching the Sample wildcard substitutes the Route wildcard.</p><p>The backslash (<code>\\</code>) symbol is used as an escape symbol: <code>\\\\</code> is processed as a single backslash symbol, <code>*</code> is processed as an asterisk symbol, etc.</p><p>Only one wildcard symbol is allowed in a Route.</p><h3 id="DomainRouting" tabindex="-1">Domain-Level Routing Records <a class="header-anchor" href="#DomainRouting" aria-label="Permalink to &quot;Domain-Level Routing Records {#DomainRouting}&quot;">​</a></h3><p>If the left part of a Routing record contains a domain name, the record specifies domain-level routing.</p><p>When some address is being processed and the domain name matches a domain name specified in such a record, the domain part is substituted with the right part of the routing record.</p><ul><li><p>Example:</p><p><code>hq.company.com = twisted.company.com</code><br> All addresses with the hq.company.com domain part are changed to have the twisted.company.com domain part. The Router restarts, trying to route the modified address.</p></li></ul><p>A routing path can specify relays.</p><ul><li><p>Example:</p><p><code>hq.company.com = hq.company.com@relay.company.com</code><br> All E-mails and Signals directed to the domain name hq.company.com will be redirected to the system (domain) relay.company.com, and then, from that system, to the domain hq.company.com.</p></li></ul><p>If E-mails and Signals to several domains should be routed in the same or similar way, you may use the asterisk (<code>*</code>) symbol as the wildcard symbol.</p><ul><li><p>Example:</p><p><code>*.old_company.com = new_company.com</code><br> In this case addresses in all the domains ending with .old_company.com will be changed to have the new_company.com domain part, with the local parts (user names) unchanged.</p></li></ul><p>Very often this type of routing is used to process all subdomains of the some domain.</p><ul><li><p>Example:</p><p><code>*.mycompany.com = mycompany.com</code><br> If the mycompany.com is the Server&#39;s Main Domain name, then this routing record makes the Server process E-mails and Signals sent to all subdomains of its Main Domain as E-mail and Signals sent to the Main domain, the address <a href="mailto:user@mail.mycompany.com" target="_blank" rel="noreferrer">user@mail.mycompany.com</a> will be processed as the <a href="mailto:user@mycompany.com" target="_blank" rel="noreferrer">user@mycompany.com</a> address.</p></li><li><p>Example:</p><p><code>*.old_company.com = *.new_company.com</code><br> When such a routing line is entered and an E-mail or a Signal comes in for the domain host5.old_company.com, it is routed to host5.new_company.com.</p></li><li><p>Example:</p><p><code>system-*.mycompany.com = uu*.local</code><br> This routing line will redirect system-abc.mycompany.com to uuabc.local .</p></li></ul><p>Besides domain-level routing records, routing for domains can be specified using <a href="#Alias">account-level</a> records (see below).<br> Records for <a href="./../mail/Local.html#Unified">Unified Domain-Wide Accounts</a> are domain-level routing records, too.</p><h3 id="Alias" tabindex="-1">Account-Level Routing Records <a class="header-anchor" href="#Alias" aria-label="Permalink to &quot;Account-Level Routing Records {#Alias}&quot;">​</a></h3><p>If the left part of a routing record contains an address in the angle brackets (<code>&lt;</code> and <code>&gt;</code>), the record is an Account-level record - a routing rule for a specific address.</p><p>When an address is parsed and the Router scans the Table records, it compares the address domain part with the domain part of all Account-Level routing records.</p><p>If the domain parts match, the Router compares the local part of the address with the local part of the account-level record address. If both domain and local parts match, the right part of the account-level routing record is used as the new address. The Router restarts, parsing and processing this new address.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Because the Server Main Domain Name in the parsed address is immediately replaced with an empty string, account-level records that should apply to addresses in the Main Domain should not contain any domain part at all.</p></div><p>In the all examples below <code>mycompany.com</code> is the Server Main Domain name.</p><ul><li><p>Example:</p><p><code>&lt;sales&gt; = bill</code><br> in this case, all messages to <a href="mailto:sales@mycompany.com" target="_blank" rel="noreferrer">sales@mycompany.com</a> will go to bill, as if they were sent to <a href="mailto:bill@mycompany.com" target="_blank" rel="noreferrer">bill@mycompany.com</a>.<strong>Note:</strong> if there is an account-level record for the local name <code>xxxx</code>, there is no need to actually create a real <code>xxxx</code> Account on the Server. Additionally, that Account would be useless, since no message or signal will ever reach that Account: everything directed to the <code>xxxx</code> name will be routed elsewhere.</p></li></ul><p>The right side of an account-level record can be any address.</p><ul><li><p>Example:</p><p><code>&lt;sales&gt; = Bill@thatcompany.com</code><br> All messages directed to <a href="mailto:sales@mycompany.com" target="_blank" rel="noreferrer">sales@mycompany.com</a> will be directed to <a href="mailto:Bill@thatcompany.com" target="_blank" rel="noreferrer">Bill@thatcompany.com</a>. The Router takes the new address, extracts the domain name (thatcompany.com) and local (Bill) parts, then the Router restarts trying to find a route to thatcompany.com.</p></li></ul><p>You can use the wildcard symbol (<code>*</code>) in the local part of account-level records. The same symbol can be used in any part of the right-side address to specify substring substitution.</p><ul><li><p>Example:</p><p><code>&lt;dept-*&gt; = postmaster@*-dept.mycompany.com</code><br> This record will redirect all E-mails and Signals sent to <a href="mailto:dept-sales@mycompany.com" target="_blank" rel="noreferrer">dept-sales@mycompany.com</a> to the user postmaster at the sales-dept.mycompany.com department server.</p></li></ul><p>You can use Router account-level records to reroute E-mails and Signals sent to some of the your Server Secondary Domains. In the following example, the client.com is a local Secondary Domain.</p><ul><li><p>Example:</p><p><code>&lt;sales@client.com&gt; = Bill@client.com</code><br> All messages directed to <a href="mailto:sales@client.com" target="_blank" rel="noreferrer">sales@client.com</a> will be directed to <a href="mailto:Bill@client.com" target="_blank" rel="noreferrer">Bill@client.com</a>.</p></li><li><p>Example:</p><p><code>&lt;sales@client.com&gt; = Bill</code><br> All messages directed to <a href="mailto:sales@client.com" target="_blank" rel="noreferrer">sales@client.com</a> will be directed to <a href="mailto:Bill@mycompany.com" target="_blank" rel="noreferrer">Bill@mycompany.com</a> (i.e. to the address Bill in the Main Domain).</p></li></ul><p>In most cases you do not have to use account-level Router Records: if you need to provide an alternative name some Account, use <a href="./../objects/Accounts.html">Account Aliases</a> instead. If you need to re-route all E-mails and Signals sent to some name in a local Server Domain to some other address, use <a href="./../objects/Forwarders.html">Forwarders</a> instead.</p><p>You may need to create an alias for a specific account on a foreign system. For example, if all E-mail sent to some domain should be routed to a specific mail host or to a unified account, but certain accounts in that domain should be routed to accounts on your or other systems.</p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Mail:&lt;sales@client1.com&gt; = sales-client1</span></span>
<span class="line"><span>Mail:client1.com = new.client1.com</span></span></code></pre></div><p>These records route all E-mails directed to the account sales at the domain client1.com to the Account sales-client1 in your Server Main Domain, while messages to all other accounts in the client1.com domain are routed to the new.client1.com system.</p></li></ul><p>The wildcard symbol (<code>*</code>) can be used only in the local part of the full account name (i.e. it can be used before the <code>@</code> symbol).</p><p>You can use the wildcard feature to host several domains in one CommuniGate Pro Domain creating a unique &quot;address space&quot; for each domain name.</p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@client5.com&gt; = cl5-*</span></span>
<span class="line"><span>&lt;*@client7.com&gt; = cl7-*</span></span></code></pre></div><p>E-mails and Signals sent to <a href="mailto:sales@client5.com" target="_blank" rel="noreferrer">sales@client5.com</a> address will be directed to the cl5-sales Account in the Main Domain, E-mails and Signals sent to <a href="mailto:info@client5.com" target="_blank" rel="noreferrer">info@client5.com</a> address will be directed to the cl5-info Account in the Main Domain, while E-mails and Signals sent to <a href="mailto:sales@client7.com" target="_blank" rel="noreferrer">sales@client7.com</a> address will be directed to the in the cl7-sales Account in the Main Domain.</p><p>This method can be used when you do not want to create full-scale CommuniGate Pro <a href="./../objects/Domains.html">Domains</a> for many domains containing very few Accounts.</p></li></ul><h3 id="AllLocal" tabindex="-1">All-Local Routing Records <a class="header-anchor" href="#AllLocal" aria-label="Permalink to &quot;All-Local Routing Records {#AllLocal}&quot;">​</a></h3><p>Account-level records can use wildcard symbol (<code>*</code>) as the domain part. This records are applied to the addresses that contain any local Domain (i.e. a Domain created on this CommuniGate Pro Server or Cluster). The right-side address of such record specifies an address in the same local Domain.</p><ul><li><p>Example:</p><p><code>&lt;abuse@*&gt; = postmaster</code><br> This record reroutes an abuse@<em>domainX.dom</em> address into postmaster@domainX.dom for all <em>domainX.dom</em> Domains created in your CommuniGate Pro system.</p></li></ul><p>If the right-side address contains a domain part, the address is routed to that domain.</p><ul><li><p>Example:</p><p><code>&lt;abuse@*&gt; = postmaster@somedomain.com</code><br> This record reroutes abuse@domainX.dom addresses into the postmaster%somedomain.com@domainX.dom addresses for all domainX.dom Domains created in your CommuniGate Pro system. Then the postmaster%somedomain.com@domainX.dom addresses are rerouted to the <a href="mailto:postmaster@somedomain.com" target="_blank" rel="noreferrer">postmaster@somedomain.com</a> address.</p></li></ul><p>The local part of the left-side address can contain a wildcard (as in regular account-level records). The string matching this wildcard symbol can be used in the right-side address.</p><ul><li><p>Example:</p><p><code>&lt;+*@*&gt; = 011*</code><br> This record reroutes the <code>+490088899@domainX.dom</code> address into the <code>011490088899@domainX.dom</code> address for all domainX.dom Domains created in your CommuniGate Pro system.</p></li></ul><h2 id="Special" tabindex="-1">Special Addresses <a class="header-anchor" href="#Special" aria-label="Permalink to &quot;Special Addresses {#Special}&quot;">​</a></h2><p>If an address is routed to one of the local Domains (including an empty domain part which is routed to the Main Domain), the local part is checked against the following special values:</p><ul><li><p><code>null</code></p><p>this address is directed to a fictitious internal &quot;Black hole&quot; module.<br> When an E-mail message is routed to the &quot;Black hole&quot;, the address is marked as &quot;delivered&quot; immediately, without any additional processing.<br> When a Signal request is routed to the &quot;Black hole&quot;, request is considered &quot;delivered&quot; immediately, generating the 200 &quot;OK&quot; response, unless it is an <code>INVITE</code>, <code>UPDATE</code>, or <code>OPTIONS</code> request: in these cases, the 480 &quot;No Address Found&quot; response is generated.</p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@bad.company.com&gt; = null</span></span>
<span class="line"><span>&lt;junk&gt; = null</span></span></code></pre></div><p>With these records in the Routing Table, the Server will discard all E-mails and Signals sent to the domain<code>bad.company.com</code>, as well as all E-mails and Signals sent to the Main Domain address junk.</p></li></ul></li><li><p><code>MAILER-DAEMON</code>, <code>Calendar-Alarm</code></p><p>these special addresses are processed in the same way as the <code>null</code> address.</p></li><li><p><code>error</code></p><p>E-Mails and Signals sent to this address are rejected without processing, generating an error report/response. If the domain name part of an address is <code>error</code>, or if the domain name part is empty, and the local name part is <code>error</code>, the address is rejected without processing, generating an error report/response.</p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>bad.company.com = error</span></span>
<span class="line"><span>&lt;junk&gt; = error</span></span></code></pre></div><p>With these records entered, the Server will reject all E-mail messages and Signals sent to the bad.company.com domain or to the Main Domain address junk.</p></li></ul></li><li><p><code>blacklisted</code></p><p>E-mails sent to this address are rejected without processing, generating the &quot;Blacklisted Address&quot; error report.<br> See the <a href="./../mail/SMTP.html#BlackList">SMTP module</a> description for the details.</p></li><li><p><code>spamtrap</code></p><p>E-mails and Signals sent to this address are rejected without processing, but the <a href="./../mail/SMTP.html">SMTP module</a> processes them in a special manner. See the <a href="./Protection.html#SpamTrap">Protection</a> section for the details.</p></li><li><p><code>incomplete</code></p><p>Signals sent to this address are rejected with the &quot;Address Incomplete&quot; error code. It can be used to support some SIP clients that send call (INVITE) requests as soon as the user dials a digit.</p><ul><li><p>Example:</p><p><code>&lt;(1-4d)@*&gt; = incomplete</code></p><p>With these Router record present, dialing a 1-,2-, or 3-digit number will return the &quot;Address Incomplete&quot; error code to the client, forcing it to wait for additional input from the user.</p></li></ul></li><li><p><code>listserver</code></p><p>E-mails sent to this address are sent to the <a href="./../mail/LIST.html#Service">LIST</a> module.</p></li><li><p><code>all</code></p><p>E-mails sent to this address are sent to all Domain Accounts. See the <a href="./../objects/Domains.html#All">Domains</a> section for the details.</p></li><li><p><code>alldomains</code></p><p>E-mails sent to this address are sent to all Accounts in all Domains. See the <a href="./../objects/Domains.html#AllDomains">Domains</a> section for the details.</p></li></ul><p>If an address is routed to the domain name null, then it is processed in the same way as the addresses routed to the local part null in a local domain (see above).</p><p>If an address is routed to the domain name error, then it is processed in the same way as the addresses routed to the local part error in a local domain (see above).</p><p>If an address is routed to the domain name blacklisted, then it is processed in the same way as the addresses routed to the local part blacklisted in a local domain (see above).</p><p>If the domain name part ends with the symbols <code>.here</code> or <code>._here</code>, this suffix is removed, and the remaining part of the domain name is used as the name of a local CommuniGate Pro Domain. This suffix allows you to avoid routing loops in certain situations.</p><ul><li><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>dept1.xyz.com = dept1.xyz.com._here</span></span>
<span class="line"><span>dept2.xyz.com = dept2.xyz.com._here</span></span>
<span class="line"><span>*.xyz.com = *.abc.com</span></span></code></pre></div><p>E-Mails and Signals sent to all subdomains of the xyz.com domain are rerouted to the subdomains of the abc.com domain, except for the addresses in the dept1.xyz.com and dept2.xyz.com subdomains, which are routed to the local dept1.xyz.com and dept2.xyz.com CommuniGate Pro Domains.</p></li></ul><h2 id="Via" tabindex="-1">Explicit Routing via Remote Systems <a class="header-anchor" href="#Via" aria-label="Permalink to &quot;Explicit Routing via Remote Systems {#Via}&quot;">​</a></h2><p>After all Routing Table records are applied, the Router checks if the domain name part ends with the <code>._via</code> suffix. If the suffix is found, it is removed, the shorten domain name is used as the target host name, and the local part of the address is used as the address to pass to that host.</p><ul><li><p>Example:</p><p>The Server Main Domain name is <code>company.com</code>.<br> E-Mails and Signals sent to the <code>sales.company.com</code> Domain should be relayed to a separate sales.company.com server, while addresses in all other subdomains of the company.com domain should be processed as addresses in the Main Domain, i.e. <a href="mailto:user@subdomain.company.com" target="_blank" rel="noreferrer">user@subdomain.company.com</a> addresses should be processed as <a href="mailto:user@company.com" target="_blank" rel="noreferrer">user@company.com</a> addresses.<br> You can implement these routing rules using the following records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>sales.company.com = sales.company.com._via ; explicitly relay to a remote host</span></span>
<span class="line"><span>*.company.com = company.com ; all other subdomains are rerouted</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Addresses in the sales.company.com domain will be relayed with the domain part removed, i.e. the address <a href="mailto:user@sales.company.com" target="_blank" rel="noreferrer">user@sales.company.com</a> will be relayed to sales.company.com host as <code>&lt;user&gt;</code>.</p></div><p>This may cause troubles if the sales.company.com server does not accept addresses without domains. See the next example for a possible solution.</p></li><li><p>Example:</p><p>E-Mails and Signals sent to the client1.com, client2.com, and client3.com domains should be sent to the host.com server.<br> You can implement this routing using the following records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>client1.com = client1.com@host.com._via</span></span>
<span class="line"><span>client2.com = client2.com@host.com._via</span></span>
<span class="line"><span>client3.com = client3.com@host.com._via</span></span></code></pre></div><p>or, in a more flexible way:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>client1.com = client1.com@relay</span></span>
<span class="line"><span>client2.com = client2.com@relay</span></span>
<span class="line"><span>client3.com = client3.com@relay</span></span>
<span class="line"><span>relay = host.com._via</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You can specify just <code>host.com</code> instead of <code>host.com._via</code> here (given there is no other router record for host.com), but in this case mail to <code>user@client1.com</code> will be sent to the host.com as <code>user%client1.com@host.com</code>. By specifying the <code>._via</code> suffix you not only tell the Router to route the address to a relaying module, but you also force that module to send only the local part of the address to the remote server.</p></div><p>Address Processing without the <code>._via</code> suffix</p><table tabindex="0"><thead><tr><th></th><th></th><th></th></tr></thead><tbody><tr><td><code>user @ client1.host</code></td><td>Router converts to</td><td><code>user%client1.host @ relay</code></td></tr><tr><td><code>user%client1.host @ relay</code></td><td>Router converts to</td><td><code>user%client1.host @ host.com</code></td></tr><tr><td><code>user%client1.host @ host.com</code></td><td>Router stops</td><td><em>no rule for host.com</em></td></tr><tr><td><code>user%client1.host @ host.com</code></td><td>Router accepts</td><td>for SIP/SMTP <code>host.com</code> host as <code>user%client1.host@host.com</code></td></tr></tbody></table><p>Address Processing with the <code>._via</code> suffix</p><table tabindex="0"><thead><tr><th></th><th></th><th></th></tr></thead><tbody><tr><td><code>user @ client1.host</code></td><td>Router converts to</td><td><code>user%client1.host @ relay</code></td></tr><tr><td><code>user%client1.host @ relay</code></td><td>Router converts to</td><td><code>user%client1.host @ host.com._via</code></td></tr><tr><td><code>user%client1.host @ host.com._via</code></td><td>Router accepts</td><td>for <code>host.com</code> as <code>user@client1.host</code></td></tr></tbody></table></li></ul><p>If the domain part of the address contains the <code>._via</code> suffix, the module checks the last domain name part after removing this suffix. If that part is a number, the dot (<code>.</code>) symbol separating this part is changed to the colon (<code>:</code>) symbol:</p><p><code>host.domain.dom.26._via</code> --&gt; host.domain.dom:26</p><p>When the domain name contains a colon symbol, the SIP, XMPP, and SMTP modules:</p><ul><li>Do not use DNS MX/SRV records for that name, and retrieve the DNS A-records only.</li><li>Use the number after the colon symbol as the number of the TCP/UDP port to connect to, instead of using the standard port number (25 for SMTP, 5060 for SIP).</li></ul><p>The Router also checks if the domain part of the address ends with the <code>._relay</code> suffix. This suffix is removed and the resulting domain name is used as the target host name (after changing the optional port number separator to the colon symbol).<br> This domain name (after removal of the optional port number and its separator) is added to the local name, using the <code>@</code> symbol as the separator.</p><ul><li><p>Example:</p><p>The Server Main Domain is <code>company.com</code>.<br> E-mails and Signals for the <code>xxxx.department.company.com</code> domains (where xxxx can be sales, marketing, etc.) should be sent to separate servers, according to their DNS records, while addresses in all other subdomains of company.com should be processed as addresses in the Main Domain, i.e. <a href="mailto:user@subdomain.company.com" target="_blank" rel="noreferrer">user@subdomain.company.com</a> addresses should be processed as <a href="mailto:user@company.com" target="_blank" rel="noreferrer">user@company.com</a> addresses.<br> You can implement this routing using the following records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>*.sales.company.com = *.sales.company.com._relay ; explicitly relay outside</span></span>
<span class="line"><span>*.company.com = company.com ; all other subdomains are rerouted</span></span></code></pre></div></li></ul><p>The Router also checks if the domain part of the address ends with the <code>._dir</code> suffix. This suffix is processed the same way as the <code>_via</code> suffix. In addition the server tries to retrieve the record from the <a href="./../directory/">Directory</a> via the <code>dn</code> built from the original address and the destination domain in the form <code>mail=user@domain, cn=host.com</code>.<br> If the record can be retrieved (this may require setting up a <a href="./../directory/#Remote">Remote Directory Unit</a> for the <code>cn=host.com</code> search base) the result of address routing is accepted, otherwise the routing error is generated.<br> When the suffix <code>._dis</code> is used, the search behavior is changed: the <code>mail=user@domain</code> part is used as the search filter and the search base is <code>cn=host.com</code>.<br> If the attempt to retrieve the record results in some connection-level error, the routing result is a temporary error, so, for example, SMTP senders would retry deliveries to this address.</p><h2 id="PBXApp" tabindex="-1">Routing to Real-Time Applications <a class="header-anchor" href="#PBXApp" aria-label="Permalink to &quot;Routing to Real-Time Applications {#PBXApp}&quot;">​</a></h2><p>Many Signals (especially phone calls) should be handled with the &quot;stock&quot; or custom <a href="./../../development/PBXApp.html">Real-Time Applications</a>. To Route a Signal to an Application you need to specify the Application name and, separated with the hash (<code>#</code>) symbol, the name of the Account that will be used to run the application:</p><ul><li><p>The following record routes Signals sent to the <em>someName</em>@<em>someDomain</em> address to the application <code>myProgram</code> started on behalf of the <code>user@domain</code> Account:</p><p><code>&lt;someName@someDomain&gt; = myProgram#user@domain</code></p></li></ul><p>You can specify the application parameters by adding them after the application name, enclosed into the <code>{</code> and <code>}</code> brackets and separated with the comma (<code>,</code>) symbol.</p><ul><li><p>The following record routes Signals sent to the <em>someName</em>@<em>someDomain</em> address to the application <code>myProgram</code> started on behalf of the <code>user@domain</code> Account. The program is started with 2 parameters - &quot;mixer&quot; and &quot;fast&quot;:</p><p><code>&lt;someName@someDomain&gt; = myProgram{mixer,fast}#user@domain</code></p></li></ul><p>The wildcards in the right part of a Router record are substituted before any processing begins, so you can use the wildcard value as the application parameter.</p><ul><li><p>The following record routes Signals sent to the <code>+(20d)@someDomain</code> addresses to the application <code>myProgram</code> started on behalf of the <code>user@domain</code> Account. The program is started with a parameter. The parameter is the catenation of the string <code>num=</code> and the wildcard value - the phone number without the leading <code>+</code> symbol:</p><p><code>&lt;+(20d)@someDomain&gt; = myProgram{num=*}#user@domain</code></p></li></ul><h2 id="Telnum" tabindex="-1">Phone Number Routing <a class="header-anchor" href="#Telnum" aria-label="Permalink to &quot;Phone Number Routing {#Telnum}&quot;">​</a></h2><p>If the domain part of an address is <code>telnum</code>, the address local part is processed as a E.164 phone number.</p><p>The following steps are taken by the Router <strong>before</strong> it applies its Routing Table(s) and other routing methods:</p><ul><li>The Router checks if the phone number is assigned to any Account in any CommuniGate Pro Domain. If such an account is found, the Signal is redirected to that Account. See the <a href="./../objects/Accounts.html#Telnums">Accounts</a> section for more details on Assigned Phone Number.</li><li>The Router applies the <a href="#ENUM">ENUM Routing</a> method, using all Telephony ENUM DNS domains specified. In a <a href="./../cluster/">Dynamic Cluster</a> environment, the Server-wide ENUM domains are checked first, then the Cluster-wide ENUM domains are used.</li></ul><p>If the phone number is not rerouted by any of the above methods, the Router processes it as a regular address.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Phone Number ENUM Domains</b></td></tr><tr><td align="center"><input type="text" name="A000000" value="e164.arpa" size="20" maxlength="254"></td></tr><tr><td align="center"><input type="text" name="A000000" value="e164.org" size="20" maxlength="254"></td></tr><tr><td align="center"><input type="text" name="A000000" value="" size="20" maxlength="254"></td></tr></tbody></table></div></form><p>To add a ENUM domain, enter its name into the empty field, and click the Update button.<br> To remove a ENUM domain, remove its name from the field and click the Update button.<br> Domains are used in the specified order.</p><p>See the <a href="./../signals/PSTN.html">PSTN</a> section to learn more about PSTN and telephone number routing.</p><h2 id="IP" tabindex="-1">Routing by IP Addresses <a class="header-anchor" href="#IP" aria-label="Permalink to &quot;Routing by IP Addresses {#IP}&quot;">​</a></h2><p>After all Routing Table records are applied, the Router checks if the domain name is actually an IP address. If the IP-address domain name is not enclosed into the square brackets, the Router encloses it: <code>user@10.34.45.67</code> is converted into <code>user@[10.34.45.67]</code>. This allows you to specify Routing Table records for IP addresses assuming that the address is always enclosed into square brackets.</p><p>For IP addresses enclosed in square brackets, the Router checks if the IP address is assigned to one of this Server Domains. If a Domain is found, the IP address is substituted with that Domain name. If the IP address is the IP address of the Server Main Domain, an empty string is placed into the domain name part, and the Router makes the next iteration after parsing the local name part of the address.</p><p>If an IP address is not assigned to a local Domain, the Router processes the <code>[10.34.45.67]</code> domain name as the <a href="#Via"><code>10.34.45.67._default_port_._via</code></a> name:<br> the Router sends the address to the SIP or SMTP module, cutting off the domain part and using it as the host name to relay to.</p><h2 id="Modules" tabindex="-1">Routing via Modules <a class="header-anchor" href="#Modules" aria-label="Permalink to &quot;Routing via Modules {#Modules}&quot;">​</a></h2><p>If no Routing Table record can be applied to an address, and the address is not a special address or an IP address of a local domain, the Router calls each communication module requesting a routing operation.</p><p>Each module looks at the address passed and can:</p><ul><li>ignore the address if the module does not know how to handle it;</li><li>modify the address (for example, the LIST module converts addresses <code>listname-admin@listdomain</code> into the real address of the mailing list owner);</li><li>reject the address (for example, the Local Delivery module rejects <code>username@domainname</code> addresses if the domain name is a name of a local domain, and there is no username Account or Alias in that domain);</li><li>accept the address.</li></ul><p>If a module has modified an address, the Router makes a new iteration, repeating all steps for the new, modified address.</p><p>If the Router is called from the <a href="./../mail/">Message Enqueuer</a> component, and a module has accepted the address, the message is enqueued to this module for delivery.</p><p>If the Router is called from the <a href="./../cluster/Signals.html">Signal</a> component, and a module has accepted the address, the Signal Request is sent to this module for processing.</p><p>Each module is called twice. First, the Router calls each module asking to process &quot;explicit&quot; addresses. On this call the modules process only the addresses that are definitely directed to that module: the SMTP module processes addresses with the domain part ending with <code>._smtp</code>, the LIST module processes the addresses of the existing mailing lists, etc.</p><p>If all modules have ignored an address, the Router calls each module again, asking for a &quot;final&quot; attempt. On that stage, the Local Delivery module processes all addresses directed to local Domains, the SIP module accepts all signal-type addresses, the SMTP module processes all addresses with domain names that have at least one dot, etc.</p><p>This two-step method allows several modules to correctly process addresses without relying to a particular module call order. If each module would process an address in one step, <code>listname@domainname</code> addresses (that look like Local account addresses), would be rejected with the Local Delivery module if it is called before the LIST module, <code>user@accountName.local</code> addresses would be taken with the SMTP module instead of the Local Delivery module, etc.</p><p>See the module descriptions for the details.</p><h2 id="External" tabindex="-1">External Helper Routing <a class="header-anchor" href="#External" aria-label="Permalink to &quot;External Helper Routing {#External}&quot;">​</a></h2><p>After all Routing Table records are applied, the Router checks if the domain name is the <code>external</code> string. In this case, the domain part is cut off, and the local part is passed to the <a href="./Security.html#External">External Authenticator</a> program.</p><p>The external program can use any method to process the supplied address, and it should return a modified address or an error code.</p><p>If a modified address is returned, the Router makes the next iteration with this new address.</p><ul><li><p>Example:</p><p>Signals to addresses starting with <code>011</code> in any local Domain should be routed using an external Helper program.<br> You can implement this routing using the following record:<br><code>NoRelay:Signal:&lt;011*@*&gt; = tele-*@external ; route using an external program</code></p><p>If a Signal is sent to 0115556666@local.domain.dom, where local.domain.dom is a local Domain, the address will be rerouted to tele-5556666@external and the External Helper will receive a request to route the tele-5556666 address.</p></li></ul><h2 id="ENUM" tabindex="-1">ENUM Routing <a class="header-anchor" href="#ENUM" aria-label="Permalink to &quot;ENUM Routing {#ENUM}&quot;">​</a></h2><p>The Router supports DNS-based routing for telephone numbers. This method is usually applied to <em>E.164 numbers</em> - telephone numbers starting with the plus symbol followed with the country code, area code, and the local number.</p><p>If the domain name has the <code>._enum</code> suffix, then the Router:</p><ul><li>follows RFC2916 and issues the DNS NAPTR request for the number in the address local part, using the domain name (without the <code>._enum</code> suffix) as the search suffix.</li><li>processes all result records of the <code>E2U+SIP</code> type for Signal-type addresses, or the E2U+EMAIL for other addresses.</li><li>if the found mapping string starts with the <code>sip:</code>, <code>sips:</code>, <code>mailto:</code> prefix, removes the prefix.</li></ul><p>The Router restarts, processing the found mapping string as the new destination address.</p><p>If the DNS search returns the &quot;unknown host name&quot; error, the <code>._enum</code> domain name suffix is replaced with the <code>._noenum</code> suffix, and the Router restarts to process the modified address.</p><ul><li><p>Example:</p><p>Router records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;+(7-15d)@*&gt; = +*@telnum ; direct +number to e164 &quot;telnum&quot; domain</span></span>
<span class="line"><span>telnum = e164.arpa._enum ; direct +number to e164.arpa</span></span>
<span class="line"><span>e164.arpa._noenum = pstn</span></span>
<span class="line"><span>&lt;+44*@pstn&gt; = gatewaycaller{+44*}#pbx</span></span>
<span class="line"><span>pstn = main.office.dom</span></span></code></pre></div><p>A sample address +74992713154@some.local.domain.dom will be processed using the following steps:</p><ul><li>The first Router record converts this address to <code>+74992713154@telnum</code></li><li>The second Router record converts this address to <code>+74992713154@e164.arpa._enum</code></li><li>The Router looks for a DNS NAPTR record <code>4.5.1.3.1.7.2.9.9.4.7.e164.arpa</code></li><li>The resulting record <code>sip:pbx@communigatepro.ru</code> is found, the <code>sip:</code> prefix is removed, and the Router restarts to process the <code>pbx@communigatepro.ru</code> address</li></ul><p>A sample address +74992713152@some.local.domain.dom will be processed using the following steps:</p><ul><li>The first Router record converts this address to <code>+74992713152@telnum</code></li><li>The second Router record converts this address to <code>+74992713152@e164.arpa._enum</code></li><li>The Router looks for a DNS NAPTR record <code>2.5.1.3.1.7.2.9.9.4.7.e164.arpa</code></li><li>There is no NAPTR record for this domain name, so the address is converted to <code>+74992713152@e164.arpa._noenum</code> and the Router restarts to process this address</li><li>The third Router record converts the address into <code>+74992713152@pstn</code> and the Router restarts to process this address</li><li>The fourth Router record directs all calls to the <code>+44</code> country code to the local <code>gatewaycaller</code> PBX application, but this record does not match the <code>+74992713152@pstn</code> address</li><li>The fifth Router record redirects this address to <code>+74992713152@main.office.dom</code> so the Signal is relayed to the <code>main.office.dom</code> server.</li></ul></li></ul><h2 id="TelSchema" tabindex="-1"><code>tel:</code> Routing <a class="header-anchor" href="#TelSchema" aria-label="Permalink to &quot;\`tel:\` Routing {#TelSchema}&quot;">​</a></h2><p>When a <code>tel:phoneNumber</code> URI is being parsed, it is converted into <code>sip:phoneNumber@tel</code> URI internally. The fictitious <code>tel</code> domain is usually routed to the <code>telnum</code> domain (see above) to provide unified handling of all phone numbers.</p><p>When composing a URI from an internal form, any <code>sip:phoneNumber@tel</code> URI is composed as <code>tel:phoneNumber</code>.</p><h2 id="Defaults" tabindex="-1">Default Records <a class="header-anchor" href="#Defaults" aria-label="Permalink to &quot;Default Records {#Defaults}&quot;">​</a></h2><p>When the CommuniGate Pro Server is installed, the following records are placed into the Routing Table:</p><ul><li><p><code>&lt;root&gt; = postmaster</code></p><p>This record reroutes all E-mails and Signals sent to the <code>root</code> name to the postmaster Account.<br> This is useful on Unix systems, where many logging utilities are preconfigured to mail reports to the user <code>root</code>.</p></li><li><p><code>localhost =</code></p><p>On many systems the <code>localhost</code> domain name used for the local IP address of that system, and some mailer programs use this name as a domain name.<br> This record routes addresses within the &quot;localhost&quot; domain to the main server domain.</p></li><li><p><code>mailhost =</code></p><p>Some mailer programs use the <code>mailhost</code> name as the domain name of the local mail server.<br> This record routes such addresses to the Accounts in the CommuniGate Pro Main Domain.</p></li><li><p><code>&lt;blacklist-admin*@blacklisted&gt; = postmaster</code></p><p>This record implements <a href="./../mail/SMTP.html#BlackList">White Hole processing</a> for blacklisted hosts.</p></li><li><p><code>&lt;*(3-4d)@*&gt; = voicemail#*</code></p><p>This record redirects all Signals (calls) sent to <code>*_nnn_</code> and <code>*_nnnn_</code> addresses in any local Domain to the <a href="./PBXVoicemail.html">PBX Voicemail</a> application started for the Account with the <em>nnn</em> alias.</p></li><li><p><code>&lt;7(2d)@*&gt; = pbx{*}#pbx</code></p><p>This record redirects all Signals (calls) sent to <code>7_nn_</code> addresses in any local Domain to the pbx Account in the same Domain.<br> This Router record is needed to implement certain functions of the stock <a href="./PBXCenter.html">PBX Center</a> application.</p></li><li><p><code>&lt;8(3d)@*&gt; = pickup{*}#pbx</code></p><p>This record redirects all Signals (calls) sent to <code>8_nnn_</code> addresses in any local Domain to the pbx Account in the same Domain, starting the <code>pickup</code> application. The application then routes the <em>nnn</em>@<em>callerDomain</em> address and &quot;picks up&quot; an incoming call pending for that Account.<br> See the <a href="./PBXServices.html#InPickup">PBX Services</a> section for the details.</p></li><li><p><code>tel = telnum</code></p><p>This record is used to process <code>tel:phoneNumber</code> URIs (see <a href="#TelSchema">above</a>).</p></li><li><p><code>&lt;+(8-20d)@*&gt; = +*@telnum</code></p><p>This record redirects all <code>+_nnnn...nn_</code> addresses in any local Domain to the fictitious <code>telnum</code> domain.</p></li><li><p><code>Signal:telnum = pstn</code></p><p>This record redirects all Signals (calls) sent to the fictitious domain <code>telnum</code> to the fictitious <code>pstn</code> domain.</p></li><li><p><code>Signal:&lt;*@pstn&gt; = gatewaycaller{*}#pbx</code></p><p>This record redirects all Signals (calls) sent to the fictitious <code>pstn</code> domain to the <code>gatewaycaller</code> application started on behalf of the <code>pbx</code> Account in the Main Domain.<br> The phone number (the local part of the address in the <code>pstn</code> domain) is passed to the application as a parameter.</p></li><li><p><code>Signal:&lt;911@*&gt; = emergency@localhost</code></p><p>This record redirects all Signals (calls) sent to the <code>911</code> addresses in any local Domain to the <code>emergency</code> name in the <code>localhost</code> domain (this name is usually Routed to the Main Domain).</p></li><li><p><code>Signal:&lt;112@*&gt; = emergency@localhost</code></p><p>This record redirects all Signals (calls) sent to the <code>112</code> addresses in any local Domain to the <code>emergency</code> name in the <code>localhost</code> domain (this name is usually Routed to the Main Domain).</p></li><li><p><code>Signal:&lt;emergency&gt; = emergency#pbx</code></p><p>This record redirects all Signals (calls) sent to the <code>emergency</code> addresses in the Main Domain to the <code>emergency</code> application started on behalf of the <code>pbx</code> Account in the Main Domain.</p></li><li><p><code>Signal:&lt;(7d)@*&gt; = localAreaCall{*}#pbx@localhost</code></p><p>This record redirects all Signals (calls) sent to 7-digit numbers in each local Domain to the <code>localAreaCall</code> application started on behalf of the <code>pbx</code> Account in the Main Domain.<br> The phone number (the local part of the address) is passed to the application as a parameter.</p></li></ul><p>All these default records can be modified or removed, if needed.</p><h2 id="Qualifier" tabindex="-1">Extending Non-Qualified Domain Names <a class="header-anchor" href="#Qualifier" aria-label="Permalink to &quot;Extending Non-Qualified Domain Names {#Qualifier}&quot;">​</a></h2><p>Users working on sites that have many different Servers (<code>server1.myorg.org</code>, <code>server2.myorg.org</code>, <code>server3.myorg.org</code>) tend to use addresses with non-qualified domain names (<code>user@server1</code>, <code>user@server2</code>, <code>user@server3</code>). When you have only few servers in your myorg.org &quot;upper level&quot; domain, you can &quot;fix&quot; those addresses by specifying several Router Table records:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>server1 = server1.myorg.org</span></span>
<span class="line"><span>server2 = server2.myorg.org</span></span>
<span class="line"><span>server3 = server3.myorg.org</span></span></code></pre></div><p>If you have many servers in your myorg.org &quot;upper level&quot; domain, it becomes impossible to provide Router Table records for all of them. In this case you may want to enable the Add <code>myorg.org</code> to Non-Qualified Domain Names option. If this option is enabled, and an address cannot be routed using CommuniGate Pro Router Table and Modules, and the domain part of the address does not contain a dot symbol, the specified string (<code>myorg.org</code>) is added to the address domain name (separated with the dot symbol). The address <code>user@someserver</code> will be converted to the <code>user@someserver.myorg.org</code> address and the Router will try to route this new, corrected address.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It is a very bad practice to use non-qualified domain names in E-mail or Signal addresses. Enable this option only if you can not enforce a policy that requires your users to specify correct, fully-qualified domain names in all addresses they use.</p></div><h2 id="GlobalAliases" tabindex="-1">All-Domain Aliases <a class="header-anchor" href="#GlobalAliases" aria-label="Permalink to &quot;All-Domain Aliases {#GlobalAliases}&quot;">​</a></h2><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>All-Domain Aliases</b></td></tr><tr align="left"><th>Local Name</th><th>Reroute to</th></tr><tr><td><input type="text" name="A000000" value="abuse" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="postmaster@maindomain.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000001" value="" size="20" maxlength="254"></td><td><input type="text" name="I000001" value="" size="40" maxlength="254"></td></tr></tbody></table></div></form><p>This table allows you to specify aliases that will work for all local Domains.</p><p>When the CommuniGate Pro Server detects that a message or a signal should be directed to some name in one of the Server local domains, these records are checked. If the local part of the address matches the Local Address field in one of these records, the address is rerouted to the address specified in the Reroute To field.</p><p>If, for example, the <code>abuse</code> and <code>postmaster@maindomain.dom</code> addresses are entered into the All-Domain Aliases table (as shown above), then all messages directed to any <code>abuse@_domain.dom_</code> address (where <em>domain.com</em> is one of the CommuniGate Pro Domains) are rerouted to the <code>postmaster@maindomain.com</code>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It is very easy to create routing loops using these records: if you enter <code>postmaster -&gt; postmaster@maindomain.dom</code> into this table, you will create a loop that will make it <strong><em>impossible to connect to the Server as <code>postmaster</code></em></strong>. If you want E-mails and Signals to all <code>postmaster</code> names in all Domains to go to the postmaster account in the main CommuniGate Pro domain, you should use: <code>postmaster -&gt; anyname@postmaster.local</code> or, if the <a href="./../mail/Local.html">Direct Mailbox Addressing</a> option is enabled: <code>postmaster -&gt; mailboxName#postmaster</code></p></div><p>You can use wildcard (<code>*</code>) symbols in these fields.</p><p>For example, you may want to create a &quot;dial plan&quot; for your organization that has 10 different departments, each served with its own Domain:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>All-Domain Aliases</b></td></tr><tr align="left"><th>Local Name</th><th>Reroute to</th></tr><tr><td><input type="text" name="A000000" value="91*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain1.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000001" value="92*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain2.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000002" value="93*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain3.dom" size="40" maxlength="254"></td></tr></tbody></table></div></form><p>If Accounts in each Domain have aliases in the <code>200-299</code> range, then the users can call other users within the same Domain by dialing the <code>2_xx_</code> number.<br> They dial the <code>91</code> prefix (a <code>912_xx_</code> number) to reach users in the domain1.com Domain.<br> They will use the <code>92</code> prefix to reach users in the domain2.com Domain, etc.</p><h2 id="Cluster" tabindex="-1">Cluster-wide Routing Table <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Cluster-wide Routing Table {#Cluster}&quot;">​</a></h2><p>The CommuniGate Pro <a href="./../cluster/Dynamic.html#SharedSettings">Dynamic Cluster</a> maintains the Cluster-Wide Routing Table. When you open the Router WebAdmin page on any Cluster member, you see the link that opens a Cluster-Wide Routing Table page. All modifications made to this Table are automatically propagated to all Cluster Members.</p><p>The Cluster-Wide Router Table is processed as an extension of the Server Router Table: the Cluster-Wide Router Table records are checked when no Server Router Table record can be applied.</p>`,164)]))}const u=o(i,[["render",n]]);export{p as __pageData,u as default};
