import{_ as s,c as a,o as t,ag as n}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Scalability","description":"","frontmatter":{"legacyLink":"Scalability.html"},"headers":[],"relativePath":"admin/sysadmin/Scalability.md","filePath":"admin/sysadmin/Scalability.md"}'),i={name:"admin/sysadmin/Scalability.md"};function o(r,e,l,c,p,h){return t(),a("div",null,e[0]||(e[0]=[n(`<h1 id="scalability" tabindex="-1">Scalability <a class="header-anchor" href="#scalability" aria-label="Permalink to &quot;Scalability&quot;">​</a></h1><p>This section explains how CommuniGate Pro and the Server OS can be optimized for maximizing per-server capacity and performance.</p><p>For horizontal scaling and multi-server redundancy, the <a href="./../cluster/">Cluster</a> configurations should also be used.</p><h2 id="Accounts" tabindex="-1">Serving Large Domains <a class="header-anchor" href="#Accounts" aria-label="Permalink to &quot;Serving Large Domains {#Accounts}&quot;">​</a></h2><p>If some Domains you serve have a large number of Accounts (5,000 or more), you should consider storing accounts in <a href="./../objects/Domains.html#Subdirs">Account Subdirectories</a> rather than in a flat domain directory. This recommendation is based on the method that file systems use to maintain the list of entries within a directory index, and the maximum recommended number of entries is largely dependent on the type of file system in use.</p><p>For example, a file system with a hashed directory index is capable of efficiently accessing more directory entries than those file systems that use only a flat file for directory indexing. Some file systems can easily access an index of over 50,000 entries, while others become sluggish at only 1,000.</p><p>This same principle also applies to sites with over 2,000 or more domains on the server or cluster. In this scenario, it is recommended to use <a href="./../objects/Domains.html#DomainFolders">Domain Subdirectories</a></p><p>You can store subdirectories on multiple logical volumes, if necessary for storage volume or performance - just replace the moved subdirectories with their symbolic links. You can also move domain directories from the Domains directory and replace them with symbolic links.</p><h2 id="LocalDelivery" tabindex="-1">Handling High-Volume Local Delivery <a class="header-anchor" href="#LocalDelivery" aria-label="Permalink to &quot;Handling High-Volume Local Delivery {#LocalDelivery}&quot;">​</a></h2><p>When the number of messages to be delivered to local CommuniGate Pro accounts is expected to be higher than 1 message/second, you should allocate more &quot;processors&quot; in the <a href="./../mail/Local.html">Local Delivery</a> Module. This is especially important for environments that process heavy inbound SMTP traffic (often used as a performance test environment). Insufficient number of Local Delivery module processors (threads) may result in excessive Queue growth and large latency in message delivery. You should watch the Local Delivery module Monitor and allocate more processors (threads) to that module if you see that the module Queue size grows to more than 200-300 messages. Do not allocate additional threads if, for example, you have 10 Local Delivery processors and see the waiting Local Delivery queue of 200 messages: this Queue size introduces only 1-2 seconds delivery latency. Increase the number of Local Delivery threads only if you see that Queue growing.</p><p>Some types of storage arrays benefit from a significant number of parallel delivery threads. For example, there are some NFS arrays which can deliver messages more efficiently with 100 Local Delivery processors than with 10, given the same number of messages. The storage vendor should be requested to provide information about the optimal number of parallel write operations for each system accessing the array, and the number of CommuniGate Pro Local Delivery processors can be adjusted to hit this target number. As Local Delivery processors are static (the configured number of processors remain in existence consistently throughout the life of the process), it is important to configure enough processors but wasteful of system resources to configure vastly too many.</p><p>Administrators of heavily loaded servers may want to disable the Use Conservative Info Updates option (located in the Local Account Manager panel on the Others page in the WebAdmin Settings realm). Disabling this option decreases the load on the file I/O subsystem.</p><h2 id="Connections" tabindex="-1">Supporting Many Concurrent Clients <a class="header-anchor" href="#Connections" aria-label="Permalink to &quot;Supporting Many Concurrent Clients {#Connections}&quot;">​</a></h2><p>For larger installations, the number of users that can be served simultaneously is an issue of a very high concern. In order to estimate how many users you can serve at the same time, you should realize what type of service your clients will use.</p><ul><li><p>POP3 Clients</p><p>POP3 mailers connect to the server just to download new messages. Based on the average connections speeds, expected mail traffic, and your user habits, you can estimate how much time an average session would take. For example, if you are an ISP and you estimate that an average your &quot;check mail&quot; operation will take 15 seconds, and they mostly check their accounts an average of 2 times each during 12 peak hours, then with 100,000 POP3 users you can expect to see 100,000 * 2 * 15 sec / (12*60*60 sec) = ~70 concurrent POP3 sessions.</p><p>This number is not high, but POP3 sessions put a high load on your disk I/O and network I/O subsystems: after authentication, a POP3 session is, essentially, a &quot;file downloading&quot; type of activity.</p></li><li><p>IMAP4 Clients</p><p>The IMAP protocol allows a much more sophisticated processing than POP3. Mail is usually left on the server, and some unwanted messages can be deleted by users without downloading them first.</p><p>The IMAP protocol is &quot;mail access&quot;, not &quot;mail downloading&quot; protocol. IMAP users spend much more time being connected to the server. In corporate environments, users can leave their IMAP sessions open for hours, if not days. While such inactive sessions do not put any load on your disk or network I/O subsystems or CPU, each session still requires an open network connection and a processing thread in the server. Since the IMAP protocol allows users to request search operations on the server, IMAP users can also consume a lot of CPU resources if they use this feature a lot.</p><p>When the server needs to handle many IMAP or POP connections, it is important to configure more IMAP and POP channels, to allow for large numbers of users to connect concurrently. Some modern IMAP clients and the MAPI Connector may even open multiple connections for a single account, and each is counted in the <a href="./../access/IMAP.html#Configuring">IMAP channel</a> total. Fortunately, IMAP and POP channels are created only when used, so no resources are consumed if the IMAP and POP channels are set to 10000 if only 2000 are being used - however, be careful to set this value below the threshold where your system will be unable to withstand further connections, and could become unresponsive for users already connected. The IMAP and POP channels setting provides a limit for protecting your system or cluster resources from being overwhelmed, in the case of a peak load or denial of service (DoS) attack.</p></li><li><p>WebUser Clients</p><p>The CommuniGate Pro WebUser Interface provides the same features provided by IMAP mailer clients, but it does not require an open network connection (and processing thread) for each user session. When a client (a browser) sends a request, a network connection is established, the request is processed with a server thread, and the connection is closed.</p><p>This allows the Server to use just 100 HTTP connections to serve 3,000 or more open sessions.</p><p>CommuniGate Pro also supports the HTTP 1.1 &quot;Keep-Alive&quot; option, located on the WebUser Interface Settings page as &quot;Support Keep-Alive&quot;. HTTP Keep-Alive sessions for WebUsers will cause each WebUser session to maintain one or more open connections from the user client to the server for the entire session duration. This method is not recommended on a busy, high-volume server as it will consume significant CPU and operating system resources, but can be used to optimize WebUser response time for end users if the system can handle the additional overhead. Keep-Alive connections will only be offered on Frontend servers in a Cluster.</p></li><li><p>XIMSS Clients (including Pronto)</p><p>XIMSS clients may work directly, via a TCP connection - then the same considerations as those for IMAP clients should be applied. If XIMSS client work using HTTP Binding (so-callend &quot;Proxy-safe mode&quot;), then the limit for HTTP User connections should be increased. Most XIMSS clients keep one HTTP connection open all the time, in order to receive asynchronous messages from the server.</p></li><li><p>SIP/RTP Clients</p><p>As compared to messaging, which tends to be very disk I/O-limited, SIP and RTP comunications have real-time requirements and only a few actions (such as a SIP REGISTER) cause some disk I/O operations. Real-time traffic is highly susceptible to any network or system latency, and as such is more closely tied to CPU performance than E-mail transfer. However, these real-time requirements can be satisfied through today&#39;s ever increasing CPU and bus speeds.</p><p>In order to optimize SIP and RTP performance, your CommuniGate Pro Server should run on modern systems with adequate CPU and memory headroom. If most of the traffic through CommuniGate Pro is just SIP signaling traffic, then even a single-CPU server should be capable of upwards of 100 calls per second. However, when performing significant amounts of SIP and RTP proxying, NAT traversal, PBX functions and media termination, the demands on memory, network, and especially CPU will be significant.<br> Increasing the number of <a href="./../signals/SIP.html#ServerConfig">SIP Server</a> and <a href="./../signals/SIP.html#ClientConfig">SIP Client</a> processors, as well as <a href="./../cluster/Signals.html#Config">Signal</a> processors, is required.<br> These threads are all &quot;static&quot;, meaning that the threads are created regardless of whether or not they are in use, and they will consume some memory resources for their stacks.</p></li></ul><h2 id="Tuning" tabindex="-1">System Tuning <a class="header-anchor" href="#Tuning" aria-label="Permalink to &quot;System Tuning {#Tuning}&quot;">​</a></h2><p>When optimizing a system for performance, there are often certain system kernel and TCP/UDP stack tuning options available which allow the system to open more concurrent network connections and allow the CommuniGate Pro process to open many file descriptors. While most operating systems allow for tuning these options, the method of doing so will differ greatly across platforms, and you may need to contact your operating system vendor or research the proper way to modify your system accordingly.</p><p>The number of available file descriptors should be set to approximately 2x the number of concurrent IMAP, POP, SMTP, SIP/RTP, and other types of connections required. You should also be certain that the operating system is capable of efficiently opening this many TCP/UDP sockets simultaneously - some OSes have a &quot;hash table&quot; for managing sockets, and this table should be set greater than the number of sockets required. Often times, allowing at least 8192 sockets and 16384 open file descriptors per process should be plenty for most systems, even under significant load. Increasing these values much too high can in most cases consume some memory resources, and should be avoided. Setting the limit on the number of open file descriptors to &quot;unlimited&quot; in the shell can also cause problems on some operating systems, as this could set the available file descriptors to the 32-bit or 64-bit limits, which can in some cases waste memory and CPU resources.</p><h3 id="setting-the-tcp-time-wait-time" tabindex="-1">Setting the TCP <code>TIME_WAIT</code> time <a class="header-anchor" href="#setting-the-tcp-time-wait-time" aria-label="Permalink to &quot;Setting the TCP \`TIME_WAIT\` time&quot;">​</a></h3><p>When you expect to serve many TCP/IP connections, it is important to check the time your Server OS waits before releasing a logically closed TCP/IP socket. If this time is too long, those &quot;died&quot; sockets can consume all OS TCP/IP resources, and all new connections will be rejected on the OS level, so the CommuniGate Pro Server will not be able to warn you.</p><p>This problem can be seen even on the sites that have just few hundred accounts. This indicates that some of the clients have configured their mailers to check the server too often. If client mailers connect to the server every minute, and the OS TIME_WAIT time is set to 2 minutes, the number of &quot;died&quot; sockets will grow, and eventually, they will consume all OS TCP/IP resources.</p><p>While the default TIME_WAIT setting on many systems is often 120 or 240 seconds, some operating systems have begun setting a default TIME_WAIT value of 60 seconds, and it is probably safe to set<code>TIME_WAIT</code> time as low as 20-30 seconds.</p><p>The TIME_WAIT problem is a very common one for Windows systems. Unlike most Unix systems, Windows NT does not have a generic setting for the TIME_WAIT interval modification. To modify this setting, you should create an entry in the Windows NT Registry (the information below is taken from the <a href="http://www.microsoft.com/" target="_blank" rel="noreferrer">http://www.microsoft.com</a> site):</p><ul><li><p>Run Registry Editor (RegEdit.exe)</p></li><li><p>Go to the following key in the registry:<br><code>HKEY_LOCAL_MACHINE\\System\\CurrentControlSet\\Services\\tcpip\\Parameters</code></p></li><li><p>Choose <code>Add Value</code> from the <code>Edit</code> menu and create the following entry:</p><ul><li><p>Value Name:</p><p><code>TcpTimedWaitDelay</code></p></li><li><p>Data Type:</p><p><code>REG_DWORD</code></p></li><li><p>Value:</p><p>30-300 (decimal) - time in seconds<br> Default: 0xF0 (240 decimal) not in registry by default</p></li></ul></li><li><p>Quit the Registry Editor</p></li><li><p>Restart the computer for the registry change to take effect.</p></li></ul><p>Description: This parameter determines the length of time that a connection will stay in the TIME_WAIT state when being closed. While a connection is in the TIME_WAIT state, the socket pair cannot be reused. This is also known as the &quot;2MSL&quot; state, as by RFC the value should be twice the maximum segment lifetime on the network. See RFC793 for further details on MSL.</p><h2 id="SMTPDelivery" tabindex="-1">Handling High-Volume SMTP Delivery <a class="header-anchor" href="#SMTPDelivery" aria-label="Permalink to &quot;Handling High-Volume SMTP Delivery {#SMTPDelivery}&quot;">​</a></h2><p>To handle high-volume (more than 50 messages/second) SMTP delivery load you need to ensure that your DNS server(s) can handle the load CommuniGate Pro generates and that the UDP packet exchange between CommuniGate Pro and the DNS servers does not suffer from excessive packet loss. You may want to re-configure your Routers to give UDP traffic a higher priority over the TCP traffic.</p><p>Use the WebAdmin Interface to fine-tune the DNS Resolvers settings. Open the Network pages in the Settings realm, then open the DNS Resolver page.</p><p>You may want to try various values for the Concurrent Requests: depending on your DNS server(s) setup, increasing the number of Concurrent Requests over 10-20 can result in DNS server performance degradation.</p><p>If an average size of the messages sent via SMTP is higher than 20K, you should carefully select the number of SMTP sending channels (threads), too. Too many concurrent data transfers can exceed the available network bandwidth and result in performance degradation. 500 channels sending data to remote sites with a relatively slow 512Kbit/sec connectivity can generate 250Mbit/sec outgoing traffic from your site. Usually the traffic is much lighter, since outgoing channels spend a lot of time negotiating parameters and exchanging envelope information. But as the average message size grows channels spend more time sending actual message data and the TCP traffic generated by each channel increases.</p><p>If using <a href="./../../development/Helpers.html#Filters">SMTP External Message Filters</a> (Plugins) - such as anti-virus, anti-spam, or other content-filtering helpers - then the SMTP load can be optimized by putting any temporary file directories used by these plugins onto a memory or tmpfs filesystem, if your system has the available memory. Since all messages should be queued in the real CommuniGate Pro Queue directories, there should be no risk in putting the plugin temporary file directories, as long as those directories never contain the only copy of any message. Even in the event of an error, power failure, or server crash, any undelivered message should always be queued to &quot;stable storage&quot; in the normal CommuniGate Pro Queue directory.</p><h2 id="Resources" tabindex="-1">Estimating Resource Usage <a class="header-anchor" href="#Resources" aria-label="Permalink to &quot;Estimating Resource Usage {#Resources}&quot;">​</a></h2><p>Each network connection requires one network socket descriptor in the server process. On Unix systems, the total number of sockets and files opened within a server process is limited.</p><p>When the CommuniGate Pro server starts, it tries to put this limit as high as possible, and then it decreases it a bit, if it sees that the limit set can be equal to the system-wide limit (if the CommuniGate Pro consumes all the &quot;descriptors&quot; available on the server OS, this will most likely result in the OS crash). The resulting limit is recorded in the CommuniGate Pro Log.</p><p>To increase the maximum number of file and socket descriptors the CommuniGate Pro Server process can open, see the instructions below.</p><p>Each network connection is processed by a server <em>thread</em>. Each thread has its own <em>stack</em>, and the CommuniGate Pro threads have 128Kbyte stacks on most platforms. Most of the stack memory is not used, so they do not require a lot of real memory, but they do add up, resulting in bigger <em>virtual memory</em> demand. Most OSes do not allow the process virtual memory to exceed a certain limit. Usually, that limit is set to the OS swap space plus the real memory size. So, on a system with just 127Mbytes of the swap space and 96Mbytes of real memory, the maximum virtual memory that can be allocated is 220Mbytes. Since the swap space is shared by all processes that run under the server OS, the effective virtual memory limit on such a system will be around 100-150MB - and, most likely, the CommuniGate Pro Server will be able to create 500-1000 processing threads.</p><p>On 32-bit computers, 4GB of virtual memory is the theoretical process memory size limit (and in reality this virtual memory limit for user-space processes is often only 2GB), and allocating more than 4GB of disk space for page swapping does not provide any benefit. Since memory has dropped in price significantly, 4GB of RAM memory is often recommended for 32-bit systems in order to maximize the available memory capacity, on those operating systems which allow a single process to utilize 2GB or more of virtual memory space. When supporting many concurrent IMAP, POP3, or SIP/RTP connections, the CGServer process will grow in size according to the per-thread stack space allocated, in addition to other memory needs. If supporting greater than 4000 processing threads, then an operating system should be considered which can allocate more than 2GB of virtual memory to the CGServer process, and 4GB of RAM memory should be installed on the system.</p><p>During a POP3 or IMAP4 access session one of the Account Mailboxes is open. If that Mailbox is a text file Mailbox, the Mailbox file is open. During an incoming SMTP session a temporary file is created for an incoming message, and it is kept open while the message is being received. So, on Unix systems, the total number of open POP, IMAP, and SMTP connections cannot exceed 1/2 of the maximum number of socket/file descriptors per process. For high-performing systems, you may want to consider allowing at least 8192 or more open file descriptors per process.</p><p>While a WebUser session does not require a network connection (and thus a dedicated socket and a thread), it can keep more than one Mailbox open. (If using HTTP Keep-Alive, then each WebUser session does consume at least one network connection, also.)</p><p>On Unix systems, when the Server detects that the number of open network sockets and file descriptors is coming close to the set limit, it starts to reject incoming connections, and reports about this problem via the Log.</p><h2 id="OS" tabindex="-1">OS Limitations and OS Tuning <a class="header-anchor" href="#OS" aria-label="Permalink to &quot;OS Limitations and OS Tuning {#OS}&quot;">​</a></h2><p>This section explains how to optimize the kernel and TCP tuning parameters available on some of the most common CommuniGate Pro platform Operating Systems.</p><p>The most commonly encountered limits are:</p><ul><li>Open file descriptors - the maximum number of files and network sockets a single process can open.</li><li>The maximum size of virtual memory available to a process.</li></ul><div class="danger custom-block"><p class="custom-block-title">DANGER</p><p>Please always confirm these changes with your operating system vendor, and always test changes on a test system before using on a production server. Variations in operating system versions, patches, hardware, and load requirements can vary the best settings for these values. Examples are provided as a guide but may not always be optimal for every situation.</p></div><h3 id="Solaris" tabindex="-1">Solaris <a class="header-anchor" href="#Solaris" aria-label="Permalink to &quot;Solaris {#Solaris}&quot;">​</a></h3><p>Generally applicable to Solaris 8, 9, and 10</p><h4 id="communigate-pro-startup-sh-file" tabindex="-1">CommuniGate Pro &quot;Startup.sh&quot; file <a class="header-anchor" href="#communigate-pro-startup-sh-file" aria-label="Permalink to &quot;CommuniGate Pro &quot;Startup.sh&quot; file&quot;">​</a></h4><p>Startup.sh is by default referenced at <code>/var/CommuniGate/Startup.sh</code>. You may need to create it. This file is read by the init startup script <code>/etc/init.d/STLKCGPro.init</code> to be executed at boot time.<br> The default Solaris <code>malloc</code> library is not very efficient in a multithreaded environment, especially when the Server has more than 2 CPUs, and the alternative <code>mtmalloc</code> library may provide better performance.<br> The following is a recommended Startup.sh file for larger Solaris implementations.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>SUPPLPARAMS=&quot;--DefaultStackSize 131072 --closeStuckSockets --CreateTempFilesDirectly 10&quot;</span></span>
<span class="line"><span>ulimit -n 32768</span></span>
<span class="line"><span>LD_PRELOAD=libmtmalloc.so</span></span></code></pre></div><h4 id="ncsize" tabindex="-1">ncsize <a class="header-anchor" href="#ncsize" aria-label="Permalink to &quot;ncsize&quot;">​</a></h4><p>Solaris <code>ncsize</code> kernel parameter has to be <em>decreased</em> on the large systems, especially - on Dynamic Cluster backends. The cache this parameter controls cannot keep any usable subset of file paths, but the large cache size causes the system to waste a lot of CPU cycles checking this cache table (symptoms: more than 50% CPU utilization, most CPU time is spent in the kernel). Decrease the <code>ncsize</code> kernel parameter value down to 1000-2000.</p><h4 id="additions-to-etc-system" tabindex="-1">Additions to <code>/etc/system</code> <a class="header-anchor" href="#additions-to-etc-system" aria-label="Permalink to &quot;Additions to \`/etc/system\`&quot;">​</a></h4><p>Following are a few settings appropriate for most Solaris systems, where significant load capacity is required. A good estimate is to set these values between 1-2 times the expected peak capacity.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>* system file descriptor limit (setting the max setting to 32768 may</span></span>
<span class="line"><span>* be better in some instances)</span></span>
<span class="line"><span>set rlim_fd_cur=4096</span></span>
<span class="line"><span>set rlim_fd_max=16384</span></span>
<span class="line"><span>* tcp connection hash size</span></span>
<span class="line"><span>set tcp:tcp_conn_hash_size=16384</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p><code>/etc/system</code> changes require a system reboot to take effect.</p></div><h4 id="other-kernel-driver-options" tabindex="-1">Other kernel driver options: <a class="header-anchor" href="#other-kernel-driver-options" aria-label="Permalink to &quot;Other kernel driver options:&quot;">​</a></h4><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># solaris 9/10 uses a default of 49152</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_recv_hiwat 49152 # or 65536</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_xmit_hiwat 49152 # or 65536</span></span>
<span class="line"><span># increase the connection queue</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_conn_req_max_q 512</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_conn_req_max_q0 5120</span></span>
<span class="line"><span># decrease timers</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_fin_wait_2_flush_interval 135000</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_time_wait_interval 60000</span></span>
<span class="line"><span>ndd -set /dev/tcp tcp_keepalive_interval 30000</span></span>
<span class="line"><span>## naglim should likely only be disabled on Backends</span></span>
<span class="line"><span>## 1=disabled, default is 53 (difficult to confirm)</span></span>
<span class="line"><span># ndd -set /dev/tcp tcp_naglim_def 1</span></span></code></pre></div><h3 id="windows-9x-nt-200x-xp-vista" tabindex="-1">Windows 9x/NT/200x/XP/Vista <a class="header-anchor" href="#windows-9x-nt-200x-xp-vista" aria-label="Permalink to &quot;Windows 9x/NT/200x/XP/Vista&quot;">​</a></h3><p>The Windows system limits the maximum port number assigned to outgoing connections. By default this value is 5000. You may want to increase that value to 20,000 or more, by adding the <code>MaxUserPort</code> DWORD-type value to the <code>HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters</code> key.</p><p>For more details, check the <a href="http://support.microsoft.com/support/kb/articles/Q196/2/71.ASP" target="_blank" rel="noreferrer">Microsoft Support Article Q196271</a>.</p><h3 id="Linux" tabindex="-1">Linux <a class="header-anchor" href="#Linux" aria-label="Permalink to &quot;Linux {#Linux}&quot;">​</a></h3><h4 id="SystemdUnit" tabindex="-1">CommuniGate Pro startup environment settings <a class="header-anchor" href="#SystemdUnit" aria-label="Permalink to &quot;CommuniGate Pro startup environment settings {#SystemdUnit}&quot;">​</a></h4><p>To customize the startup environment, it is recommended to use the built-in unit file editor in modern Linux operating systems that are based on systemd. The following command will open the text editor to configure the server startup parameters:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">systemctl</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> edit</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> CommuniGate</span></span></code></pre></div><p>An example of the contents of such a configuration file:</p><div class="language-ini vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">ini</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">[Service]</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">EnvironmentFile</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span></span>
<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">Environment</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SUPPLPARAMS=--DefaultStackSize 131072 --useNonBlockingSockets --closeStuckSockets”</span></span>
<span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">LimitCORE=infinity</span></span>
<span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">LimitNOFILE=32768</span></span>
<span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">LimitNPROC=16384</span></span>
<span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">OOMScoreAdjust=-1000</span></span></code></pre></div><p>The list of startup parameters is set by the <code>SUPPLPARAMS</code> environment variable. A detailed list of supported command line arguments can be found in <a href="./../sysadmin/#Options">related article</a>.</p><h4 id="communigate-pro-startup-sh-file-1" tabindex="-1">CommuniGate Pro &quot;Startup.sh&quot; file <a class="header-anchor" href="#communigate-pro-startup-sh-file-1" aria-label="Permalink to &quot;CommuniGate Pro &quot;Startup.sh&quot; file&quot;">​</a></h4><p>In CommuniGate Pro versions before 6.5.1, the <code>/var/CommuniGate/Startup.sh</code> file was used to set startup parameters and environment variables. This file was read by the startup script at boot time. Currently, it is recommended to use <a href="#SystemdUnit">unit files editor</a> to configure the startup of CommuniGate Pro. For compatibility purposes when migrating from earlier versions of the software, the systemd unit <code>CommuniGate.service</code> will continue to support loading environment variables from the <code>Startup.sh</code>.</p><div class="warning custom-block"><p class="custom-block-title">Important note</p><p>When using systemd initialization with the <code>Startup.sh</code> file, the kernel limit setting (<code>ulimit</code>) and any other commands from this script file are not guaranteed to work, but the parameters from the <code>SUPPLPARAMS</code> variable will be loaded and used.</p></div><div class="warning custom-block"><p class="custom-block-title">Note for administrators of systems using SELinux security features</p><p>When using CommuniGate Pro on GNU/Linux operating systems that use SELinux security (e.g., RED OS), the system policy may prevent the systemd process from reading the <code>Startup.sh</code> file.</p><p>If access control system errors occur when starting CommuniGate, the following options are available:</p><ul><li><p>Transfer the settings from the <code>Startup.sh</code> file to <a href="#SystemdUnit">systemd unit</a> and delete this file.</p></li><li><p>Extend access privileges to this file by executing the following commands as superuser, after which you will need to restart the CommuniGate Pro server:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">semanage</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> fcontext</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -a</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -t</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> bin_t</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> /var/CommuniGate/Startup.sh</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">restorecon</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -v</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &#39;/var/CommuniGate/Startup.sh&#39;</span></span></code></pre></div></li></ul></div><h4 id="linux-kernel-2-6-and-later" tabindex="-1">Linux kernel 2.6 and later: <a class="header-anchor" href="#linux-kernel-2-6-and-later" aria-label="Permalink to &quot;Linux kernel 2.6 and later:&quot;">​</a></h4><p>Linux kernel 2.6 introduced &quot;POSIX threads&quot;, replacing the previous default thread library &quot;LinuxThreads&quot;. The 2.6 kernel implementations are the first Linux release for which using POSIX threading is recommended. Following are some tuning options for Linux 2.6. For most Linux distributions, these shell commands should be placed into a boot script to be run at system startup. RedHat and a few other distributions may also provide a facility to configure &quot;sysctl&quot; data in the file <code>/etc/sysctl.conf</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>#!/bin/sh</span></span>
<span class="line"><span># Linux 2.6 tuning script</span></span>
<span class="line"><span># max open files</span></span>
<span class="line"><span>echo  131072 &gt; /proc/sys/fs/file-max</span></span>
<span class="line"><span># kernel threads</span></span>
<span class="line"><span>echo 131072 &gt; /proc/sys/kernel/threads-max</span></span>
<span class="line"><span># socket buffers</span></span>
<span class="line"><span>echo 65536 &gt; /proc/sys/net/core/wmem_default</span></span>
<span class="line"><span>echo 1048576 &gt; /proc/sys/net/core/wmem_max</span></span>
<span class="line"><span>echo 65536 &gt; /proc/sys/net/core/rmem_default</span></span>
<span class="line"><span>echo 1048576 &gt; /proc/sys/net/core/rmem_max</span></span>
<span class="line"><span># netdev backlog</span></span>
<span class="line"><span>echo 4096 &gt; /proc/sys/net/core/netdev_max_backlog</span></span>
<span class="line"><span># socket buckets</span></span>
<span class="line"><span>echo 131072 &gt; /proc/sys/net/ipv4/tcp_max_tw_buckets</span></span>
<span class="line"><span># port range</span></span>
<span class="line"><span>echo &#39;16384 65535&#39; &gt; /proc/sys/net/ipv4/ip_local_port_range</span></span></code></pre></div><h3 id="FreeBSD" tabindex="-1">FreeBSD <a class="header-anchor" href="#FreeBSD" aria-label="Permalink to &quot;FreeBSD {#FreeBSD}&quot;">​</a></h3><p>Following are some tuning optimizations applicable to different versions of FreeBSD.</p><h4 id="communigate-pro-startup-sh-file-2" tabindex="-1">CommuniGate Pro &quot;Startup.sh&quot; file <a class="header-anchor" href="#communigate-pro-startup-sh-file-2" aria-label="Permalink to &quot;CommuniGate Pro &quot;Startup.sh&quot; file&quot;">​</a></h4><p>Startup.sh is by default referenced at <code>/var/CommuniGate/Startup.sh</code>. You may need to create it. This file is read by the init startup script <code>/usr/local/etc/rc.d/CommuniGate.sh</code> to be executed at boot time. The following is a Startup.sh file for CommuniGate Pro version 4.3 or later for most FreeBSD implementations. In some cases, you may find that more file descriptors are required, so the &quot;ulimit -n&quot; value can be increased up to 32768 safely, if necessary:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>SUPPLPARAMS=&quot;--DefaultStackSize 131072 --useNonBlockingSockets --closeStuckSockets --CreateTempFilesDirectly 10&quot;</span></span>
<span class="line"><span>ulimit -n 16384</span></span></code></pre></div><p>A <code>/boot/loader.conf.local</code> file can be used to set boot-time kernel parameters:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># increase the TCP connection hash to a value just greater than peak needs</span></span>
<span class="line"><span># (this can be set higher if necessary)</span></span>
<span class="line"><span>net.inet.tcp.tcbhashsize=&quot;16384&quot;</span></span></code></pre></div><p>The Loader configuration file <code>/boot/loader.conf</code> should be modified:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>kern.maxdsiz=&quot;1G&quot;                # max data size</span></span>
<span class="line"><span>kern.dfldsiz=&quot;1G&quot;                # initial data size limit</span></span>
<span class="line"><span>kern.maxssiz=&quot;128M&quot;              # max stack size</span></span>
<span class="line"><span>kern.ipc.nmbclusters=&quot;65536&quot;     # set the number of mbuf clusters</span></span>
<span class="line"><span>net.inet.tcp.tcbhashsize=&quot;16384&quot; # size of the TCP control-block hashtable</span></span></code></pre></div><h4 id="freebsd-5-and-above" tabindex="-1">FreeBSD 5 and above <a class="header-anchor" href="#freebsd-5-and-above" aria-label="Permalink to &quot;FreeBSD 5 and above&quot;">​</a></h4><p>Sysctl settings can be set automatically in the <code>/etc/sysctl.conf</code> file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span># cache dir locations, on by default</span></span>
<span class="line"><span>vfs.vmiodirenable=1</span></span>
<span class="line"><span># increase socket buffers</span></span>
<span class="line"><span>kern.ipc.maxsockbuf=1048576</span></span>
<span class="line"><span>kern.ipc.somaxconn=4096</span></span>
<span class="line"><span># increase default buffer size</span></span>
<span class="line"><span>net.inet.tcp.sendspace=65536</span></span>
<span class="line"><span>net.inet.tcp.recvspace=65536</span></span>
<span class="line"><span># decrease time wait</span></span>
<span class="line"><span>net.inet.tcp.keepidle=300000</span></span>
<span class="line"><span>net.inet.tcp.keepintvl=30000</span></span>
<span class="line"><span># increase vnodes</span></span>
<span class="line"><span>kern.maxvnodes=131072</span></span>
<span class="line"><span># increase maxfiles/maxfiles per process</span></span>
<span class="line"><span>kern.maxfiles=131072</span></span>
<span class="line"><span>kern.maxfilesperproc=65536</span></span>
<span class="line"><span># increase port range</span></span>
<span class="line"><span>net.inet.ip.portrange.last=65535</span></span>
<span class="line"><span># default: net.inet.ip.rtexpire: 3600</span></span>
<span class="line"><span>net.inet.ip.rtexpire=300</span></span>
<span class="line"><span># decrease MSL from 30000</span></span>
<span class="line"><span>net.inet.tcp.msl=10000</span></span>
<span class="line"><span># increase max threads per process from 1500</span></span>
<span class="line"><span>kern.threads.max_threads_per_proc=5000</span></span></code></pre></div><h3 id="HP-UX" tabindex="-1">HP-UX <a class="header-anchor" href="#HP-UX" aria-label="Permalink to &quot;HP-UX {#HP-UX}&quot;">​</a></h3><p>HP-UX kernel parameters for HP-UX are set through a few different mechanisms, depending on the HP-UX version used. The following kernel parameters are important to increase higher than peak capacity needs:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>  maxfiles      Soft file limit per process</span></span>
<span class="line"><span>  maxfiles_lim  Hard file limit per processes</span></span>
<span class="line"><span>  maxdsiz       Maximum size of the data segment</span></span>
<span class="line"><span>  nfile         Maximum number of open files</span></span>
<span class="line"><span>  ninode        Maximum number of open inodes</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  # suggested parameter settings</span></span>
<span class="line"><span>  maxfiles      4096</span></span>
<span class="line"><span>  maxfiles_lim  32768</span></span>
<span class="line"><span>  maxdsiz       (2048*1024*1024)</span></span>
<span class="line"><span>  nfile         32768</span></span>
<span class="line"><span>  ninode        32768</span></span></code></pre></div><p>Decreasing the TCP TIME_WAIT parameter is also recommended:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ndd -set /dev/tcp tcp_time_wait_interval 60000</span></span></code></pre></div><h3 id="OSX" tabindex="-1">Mac OS X <a class="header-anchor" href="#OSX" aria-label="Permalink to &quot;Mac OS X {#OSX}&quot;">​</a></h3><p>The Mac OS X sets a 6MB limit on &quot;additional&quot; virtual memory an application can allocate. This is not enough for sites with more than several thousand users, and you should increase that limit by specifying the following in the CommuniGate Pro Startup.sh file:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ulimit -d 1048576</span></span>
<span class="line"><span>ulimit -n 10000</span></span></code></pre></div><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span></span></span></code></pre></div>`,96)]))}const u=s(i,[["render",o]]);export{m as __pageData,u as default};
