import{_ as r,C as c,c as d,o as h,ag as i,j as t,G as s,w as a,a as n}from"./chunks/framework.jCcxW76o.js";const v=JSON.parse('{"title":"Security","description":"","frontmatter":{"legacyLink":"security.html"},"headers":[],"relativePath":"admin/sysadmin/Security.md","filePath":"admin/sysadmin/Security.md"}'),l={name:"admin/sysadmin/Security.md"},u={action:"Null.html"},p={class:"settingsBox"},m={width:"100%"};function f(g,e,b,A,S,y){const o=c("font");return h(),d("div",null,[e[17]||(e[17]=i('<h1 id="security" tabindex="-1">Security <a class="header-anchor" href="#security" aria-label="Permalink to &quot;Security&quot;">​</a></h1><p>The CommuniGate Pro Server ensures that only certain users are allowed to access certain resources.</p><p>The CommuniGate Pro Server can authenticate its users, and it can also reject connections from outside of the &quot;client networks&quot;.</p><h2 id="SASL" tabindex="-1">Authentication Methods <a class="header-anchor" href="#SASL" aria-label="Permalink to &quot;Authentication Methods {#SASL}&quot;">​</a></h2><p>The CommuniGate Pro Server supports both clear-text and secure SASL authentication methods for the following TCP-based session-oriented protocols:</p><ul><li><code>POP</code> (as specified in RFC1734)</li><li><code>IMAP</code> (as specified in RFC2060)</li><li><code>LDAP</code> (as specified in RFC2251)</li><li><code>ACAP</code> (as specified in RFC2244)</li><li><code>SMTP</code> (as specified in RFC2554)</li><li><code>FTP</code> (as specified in RFC2228)</li><li><code>XMPP</code> (as specified in RFC3920)</li></ul><p>These secure methods allow mail clients to send encrypted passwords over non-encrypted and insecure links. If anybody can monitor your network traffic, SASL methods ensure that the real passwords cannot be detected by watching the client-server network traffic.</p><p>As an alternative to SASL methods, secure links (SSL/TLS) can be used between the client mailer and the server. When an SSL link is established, the entire network traffic between the server and the client is encrypted, and passwords can be sent in clear text over these secure links.</p><p>You can force an Account user to use either a SASL authentication method or SSL/TLS links if you enable the <code>Secure Method Required</code> option in the Account Settings. When this option is enabled, the Server rejects all authentication requests that send passwords in the clear text format over insecure links.</p><p>The CommuniGate Pro Server supports the following insecure (clear text) SASL authentication methods:</p><ul><li><code>PLAIN</code></li><li><code>LOGIN</code></li></ul><p>The CommuniGate Pro Server supports the following secure SASL authentication methods:</p><ul><li><code>CRAM-MD5</code></li><li><code>DIGEST-MD5</code></li><li><code>GSSAPI</code></li></ul><p>The CommuniGate Pro Server supports the following GSSAPI authentication methods:</p><ul><li><code>Kerberos V5</code></li><li><code>NTLM</code></li></ul><p>The CommuniGate Pro Server supports the following SASL-EXTERNAL authentication methods:</p><ul><li><code>TLS-Certificate</code></li></ul><p>The CommuniGate Pro Server supports the non-standard <code>NTLM</code> and <code>MSN</code> SASL methods used in Microsoft® products.</p><p>The CommuniGate Pro supports the secure <code>APOP</code> authentication method (used mostly for the POP protocol), and the insecure &quot;regular login&quot; method for the protocols that support Clear Text Login.</p><p>The CommuniGate Pro Server supports the special <a href="#SessionIDSASL"><code>SessionID</code> Authentication</a> method.</p><p>Use the WebAdmin Interface to open a <a href="./../objects/Domains.html">Domain Settings</a> page and find the Login Methods panel:</p>',21)),t("form",u,[t("div",p,[t("table",m,[t("tbody",null,[e[16]||(e[16]=t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Login Methods")])],-1)),t("tr",null,[t("td",null,[e[1]||(e[1]=t("input",{name:"AUTHMethods",value:"CLRTXT",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[0]||(e[0]=[n("CLRTXT")])),_:1})]),t("td",null,[e[3]||(e[3]=t("input",{name:"AUTHMethods",value:"CRAM-MD5",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[2]||(e[2]=[n("CRAM-MD5")])),_:1})]),t("td",null,[e[5]||(e[5]=t("input",{name:"AUTHMethods",value:"DIGEST-MD5",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[4]||(e[4]=[n("DIGEST-MD5")])),_:1})]),t("td",null,[e[7]||(e[7]=t("input",{name:"AUTHMethods",value:"APOP",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[6]||(e[6]=[n("APOP")])),_:1})])]),t("tr",null,[t("td",null,[e[9]||(e[9]=t("input",{name:"AUTHMethods",value:"GSSAPI",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[8]||(e[8]=[n("GSSAPI")])),_:1})]),t("td",null,[e[11]||(e[11]=t("input",{name:"AUTHMethods",value:"NTLM",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[10]||(e[10]=[n("NTLM")])),_:1})]),t("td",null,[e[13]||(e[13]=t("input",{name:"AUTHMethods",value:"MSN",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[12]||(e[12]=[n("MSN")])),_:1})]),t("td",null,[e[15]||(e[15]=t("input",{name:"AUTHMethods",value:"SessionID",checked:"checked",type:"checkbox"},null,-1)),s(o,{size:"-1"},{default:a(()=>e[14]||(e[14]=[n("SESSIONID")])),_:1})])])])])])]),e[18]||(e[18]=i('<ul><li><p><code>CLRTXT</code></p><p>When this option is selected, the Server advertises all supported non-secure (clear text) authentication methods for this Domain.</p></li><li><p><code>CRAM-MD5</code>, <code>DIGEST-MD5</code></p><p>When these options are selected, the Server advertises the secure CRAM-MD5 and DIGEST-MD5 authentication methods for this Domain.<br> Do not select these options if the Domain Accounts use one-way encrypted passwords, OS Passwords, or other authentication methods that do not support secure authentication methods.</p></li><li><p><code>APOP</code></p><p>When this option is selected, the Server provides a special initial prompt for POP and PWD connections. Mail clients can use this prompt to employ the secure APOP authentication method.<br> Do not select this option if the Domain Accounts use one-way encrypted passwords, OS Passwords, or other authentication methods that do not support secure authentication methods.</p></li><li><p><code>GSSAPI</code></p><p>When this option is selected, the Server advertises support for the GSSAPI authentication method.<br> Do not select this option if the Domain is not set to support GSSAPI methods (for example, you have not specified the required <a href="#Kerberos">Kerberos Keys</a>).</p></li><li><p><code>MSN</code>, <code>NTLM</code></p><p>When these options are selected, the Server advertises the non-standard MSN and NTLM authentication methods (used in some Microsoft products) for this Domain.<br> Do not select these options if the Domain Accounts use one-way encrypted passwords, OS Passwords, or other authentication methods that do not support secure authentication methods.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Microsoft Outlook products for various versions of MacOS do not work correctly with the MSN method if more that one account is configured in those products.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some Microsoft products send incorrect credentials when they detect that the server supports the NTLM SASL method. While those products then resend the correct credentials, the failed login attempts produce Failure-level Log records and may increase the &quot;failed logins&quot; counter too quickly, so the account becomes &quot;temporarily locked&quot;.</p></div><p>The Advertise options control only the session-type services (SMTP, POP, IMAP, ACAP, PWD, FTP), and they do not have any effect on the transaction-type services (HTTP, SIP).<br> The Advertise options control only how the methods are advertised. Client applications can still use all these methods, even if these options are switched off.</p></li><li><p><code>SESSIONID</code></p><p>This option enables the <a href="#SessionIDSASL">SessionID</a> Authentication method for the Domain.</p></li></ul><h2 id="Passwords" tabindex="-1">Account Passwords <a class="header-anchor" href="#Passwords" aria-label="Permalink to &quot;Account Passwords {#Passwords}&quot;">​</a></h2><p>The CommuniGate Pro Server supports several passwords for each account.</p><p>One password is the CommuniGate Pro&#39;s &quot;own password &quot;. This password is stored as an element of the Account Settings, and it can be used with the CommuniGate Pro Server only.</p><p>Additional variants of CommuniGate Pro internal password can be specified with <em>tag</em> names. When authenticating with these <em>tagged</em> passwords the authenticating client application should specify the password tag after account name separated with <code>$</code> symbol: <code>user$tag</code>.</p><p>The other password is the &quot;OS password&quot;. The user may be registered with the Server OS and the CommuniGate Pro Server can check the supplied password against the password set in the Server OS registration information for this user.</p><p>An account can have the Authentication URI specified that is used to authenticate to an external LDAP server. This method works only with Clear Text authentication methods.</p><p>An account can have the External Password option enabled. In this case, user authentication is done using any custom authentication program running as a separate process (see below).</p><p>The system administrator can <a href="./../objects/Accounts.html#Passwords">enable</a> any set of passwords for any user account. On larger sites, it is better to enable these options using the Server-wide or Domain-wide Default Account Settings.</p><p>When several passwords are enabled for an account, the Server first checks the CommuniGate (internal) password, then the OS password, then Authentication URI if not empty, and then tries to use the External Authentication program. If at least one of these passwords matches the password presented with the client application, the application is granted access to that account.</p><h2 id="Internal" tabindex="-1">CommuniGate Passwords <a class="header-anchor" href="#Internal" aria-label="Permalink to &quot;CommuniGate Passwords {#Internal}&quot;">​</a></h2><p>CommuniGate passwords are strings stored in the Account Settings. Password strings can be stored in the clear-text format or in encoded format. The Password Encryption Account Setting specifies the encryption to use when the account password is updated. When this setting is changed, the currently stored password is not re-encrypted.</p><p>When the <code>U-crpt</code> Password Encryption option is selected, the CommuniGate passwords are stored using the standard Unix <code>crypt</code> routine. If the <code>UB-crpt</code> Password Encryption option is selected, an enhanced Blowfish-based encryption is used.<br><code>U-crpt</code> and <code>UB-crpt</code> methods implement a one-way encryption. As a result, the Server cannot decrypt them into their original (clear text) form, and it cannot use them for secure (<a href="#SASL">SASL</a>) Authentication Methods. Use these encryption methods only if you need compatibility with legacy password strings, but cannot use the OS passwords - it is usually more important to support &quot;on-the-wire&quot; security (using SASL methods), rather then &quot;on-the-disk&quot; security (using one-way password encryption methods).</p><p>U-crpt passwords can contain special prefixes. These prefixes allow you to import passwords encrypted using other password encryption methods.<br> See the <a href="./../install/Migration.html#Passwords">Migration</a> section for more details.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Please remember that the plain Unix <code>crypt</code> routine uses only the first 8 symbols of the password string.</p></div><p>If the CommuniGate Password is absent or empty, it cannot be used to log into the Account even if the Use CommuniGate Password option is enabled. But if the user has logged in using the OS Password or the External Authentication method, the user can specify (update) the Account CommuniGate Password. This feature can be used to <a href="./../install/Migration.html#Passwords">migrate</a> users from legacy mail systems where you can not compose the list of accounts with their non-encrypted (plain text) user passwords.</p><h2 id="PreviousPasswords" tabindex="-1">Use of previous passwords <a class="header-anchor" href="#PreviousPasswords" aria-label="Permalink to &quot;Use of previous passwords {#PreviousPasswords}&quot;">​</a></h2><p>The administrator can enable disallowing the use of previous passwords.</p><p>If the prohibition to use previous passwords is enabled, you can specify the password information retention period and the number of passwords to be checked from the CommuniGate Pro stored passwords list. Information about previously used passwords is saved in the file <code>account.info</code>. The password confirmation date, the password hash with a random salt, the salt itself, and the hashing algorithm are stored. The hashing algorithm currently used is <code>SHA-256</code>. When enabled, the information is saved when the administrator or user changes the password. When enabled, it is checked for both the administrator and the user. If the option is disabled, the next time the password is changed, the history will be deleted from <code>account.info</code>. Setting the <code>Delete Password History After</code> setting to <code>Never</code> disables erase by expiring. If you specify a different value for <code>Delete Password History After</code> every time you try to change a password, expired passwords will be deleted from the list of information about previously used passwords.</p><h2 id="OS" tabindex="-1">OS Passwords <a class="header-anchor" href="#OS" aria-label="Permalink to &quot;OS Passwords {#OS}&quot;">​</a></h2><p>When the Server checks the OS password, it composes the <em>username</em> string using the Account <a href="./../objects/Domains.html">OS User Name setting</a>. When the default setting <code>*</code> is used, the composed OS user name is the same as the Account name. By changing the OS User Name settings you can use different OS usernames for Accounts in different CommuniGate Pro domains.</p><p>Notes about OS Passwords:</p><ul><li><p>Microsoft Windows 95/98/ME:<br> OS does not support passwords, the Use OS Password option does not work.</p></li><li><p>Microsoft Windows 200x/XP/NT/Vista:<br> The Windows NT domain authentication system is used. The Windows account used to run the CommuniGate Pro Messaging Server should have the <code>Act as part of the operating system</code> privilege.</p><p>The --BatchLogon <a href="./#Options">command line option</a> can be used to tell the Server to use the LOGON_BATCH authentication method (if the option is not present, the LOGON_NETWORK method is used).</p><p>The Server checks if the composed OS user name contains the percent (<code>%</code>) symbol. If the symbol is found, the part of the name before that symbol is used as the Windows account name, and the part after that symbol is used as the Windows domain name.<br> If Accounts in the <code>company1.dom</code> CommuniGate Pro domain have the OS User Name setting set to <code>*%comp1</code>, then the OS user name for the CommuniGate Pro Account <code>joe</code> will be <code>joe%comp1</code>, and the CommuniGate Pro Server will use the Windows <code>LogonUser</code> API to try to authenticate the mail client as the Windows user joe in the Windows domain comp1.</p></li><li><p>Unix-based systems:<br> The <code>passwd</code> and <code>shadow</code> or other OS-supported authentication mechanisms are used.</p></li></ul><p>The OS passwords are one-way-encrypted passwords. As a result, they cannot be used for <a href="#SASL">Secure Authentication Methods</a>.</p><h2 id="Kerberos" tabindex="-1">Kerberos Authentication <a class="header-anchor" href="#Kerberos" aria-label="Permalink to &quot;Kerberos Authentication {#Kerberos}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the Kerberos authentication method. The Kerberos method is based on the &quot;tickets&quot; that client applications send to the server. These tickets are issued by Kerberos authorities (Key Distribution Centers, KDC) that share a common &quot;key&quot; with the Server. See the Kerberos documentation for the details.</p><p>To support Kerberos Authentication, you need to add Kerberos Server key(s) to the CommuniGate Pro Server, on the per-domain basis. Create a server &quot;principal&quot; in your KDC database. The principal name should be equal to the name of CommuniGate Pro Domain or one of its Domain Aliases. Export the created key as a <code>keytab</code> file.</p><p>Open the Domain Settings using the CommuniGate Pro WebAdmin Interface, and follow the Security and Kerberos links. The list of Domain Kerberos Keys will be displayed:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr align="left"><th> </th><th>Realm</th><th></th><th>Issued</th><th>Version</th><th>Type</th></tr><tr><td><input type="checkbox" name="Key" value="1"></td><td>REALM1.COM</td><td>(3)imap<b>/</b>domain1.com</td><td>19-05-2004 17:36:33</td><td>6</td><td>RC4-HMAC</td></tr><tr><td><input type="checkbox" name="Key" value="2"></td><td>REALM1.COM</td><td>(3)imap<b>/</b>domain1.com</td><td>21-05-2004 17:32:35</td><td>9</td><td>DES-MD5</td></tr><tr><td><input type="checkbox" name="Key" value="4"></td><td>REALM1.COM</td><td>(3)imap<b>/</b>domain1.com</td><td>24-05-2004 12:41:55</td><td>10</td><td>DES-MD5</td></tr><tr><td><input type="checkbox" name="Key" value="5"></td><td>REALM1.COM</td><td>(3)imap<b>/</b>domain1.com</td><td>24-05-2004 17:33:27</td><td>13</td><td>DES-CRC32</td></tr><tr><th colspan="2" align="left"><input name="DeleteKeys" value="Delete Marked" class="buttonRed" type="reset"></th><th colspan="4"><input name="Import" value="Import Keys:" class="button" type="reset">  <input name="ImportKeys" type="file"></th></tr></tbody></table></div></form><p>Each Domain can have several Kerberos Keys. To add Keys, click the browser file-select button and select the <code>keytab</code> file exported from KDC. Click the Import Keys button to add keys from the file to the set of the Domain Kerberos Keys.</p><p>To remove Keys, mark the Keys using checkboxes and click the Delete Marked button.</p><p>Domain Administrators can Add or Remove Kerberos Keys only if they have the <a href="./#DomainPrivs">KerberosKeys Access Right</a>.</p><p>When the Server receives a Kerberos Ticket, it extracts the Server Name (&quot;sname&quot;) from the Ticket. If the Server Name has only 1 component (<code>domain.dom</code>), this component is used as the target Domain name (<em>ticket-domain-name</em>). If the Server Name has 2 or more components (<code>service/domain.dom</code>), then the second component is used. The Server then builds a fictitious E-mail address <code>LoginPage@ticket-domain-name</code> and tries to route this address. This is the same routing mechanism as one used for finding the target Domain for <a href="./../services/HTTP.html">HTTP</a> requests.</p><p>If the target Domain is found, the Server looks for the proper key in the list of the Kerberos Keys for that Domain. If the Key is found, and the Ticket and Authorization info can be decrypted with that Key, the user is authenticated. The name of the Account is taken from the Client Name specified in the Ticket. That name must be a &quot;simple&quot; name, i.e. it cannot contain <code>@</code> or <code>%</code> symbols.</p><p>CommuniGate Pro adds the name of the target Domain to the retrieved user name and uses the resulting E-mail address as the name of the Account to open.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>After the resulting user name is processed with the Router, it checks that the target Account belongs to the same Domain as the Domain the Kerberos Key was retrieved from, so Administrators of one Domain cannot create Kerberos tickets allowing users to access Accounts in other CommuniGate Pro Domains.</p></div><p>Only Accounts with enabled Kerberos Authentication method can be accessed using Kerberos tickets.</p><h3 id="KerbAD" tabindex="-1">Integrating with Microsoft Active Directory <a class="header-anchor" href="#KerbAD" aria-label="Permalink to &quot;Integrating with Microsoft Active Directory {#KerbAD}&quot;">​</a></h3><p>You may want to use Microsoft Active Directory as your Kerberos Key Distribution Center (KDC). Follow these steps:</p><ul><li><p>create an Active Directory account <code>cgatepro</code> (you may want to use a different name)</p></li><li><p>use the Microsoft <code>ktpass</code> utility to export keys: <code>ktpass -princ _service_/_hostName_@_REALMNAME_ -mapuser cgatepro -pass _password_ -out keytab.data -crypto RC4-HMAC-NT -ptype KRB5_NT_SRV_HST</code> where</p><ul><li><p><em>service</em></p><p>is the name of the CommuniGate Pro service you want to use: <code>imap</code> for IMAP and MAPI, <code>HTTP</code> for Web browsers</p></li><li><p><em>hostName</em></p><p>is the name of the CommuniGate Pro Domain your Kerberos users should log into. Most client applications treat this name as the host name to which they should connect.</p></li><li><p><em>REALMNAME</em></p><p>is the name of the Kerberos Realm - the Active Directory domain name with which you want to authenticate</p></li><li><p><em>password</em></p><p>is the password to assign to the <code>cgatepro</code> account.<br> Note: because of the bugs in the Windows 2000 Active Directory, it is recommended to use the <code>-kvno 0</code> parameter when using the <code>ktpass</code> command on that platform.</p></li></ul></li><li><p>Import the resulting keytab.data file into the CommuniGate Pro Domain Kerberos settings, as specified above.</p></li></ul><p>See the Microsoft Knowledge Base article Q324144 for more details.</p><p>If you want to use Kerberos Authentication (Single Sign-on) with Microsoft browsers, please read the &quot;HTTP-Based Cross-Platform Authentication via the Negotiate Protocol&quot; article in the Microsoft documentation set (MSDN).</p><h2 id="Certificate" tabindex="-1">Certificate Authentication <a class="header-anchor" href="#Certificate" aria-label="Permalink to &quot;Certificate Authentication {#Certificate}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the Client Certificate authentication method. This method can be used when clients connect to the Server via secure <a href="./PKI.html#TLS">SSL/TLS</a> connections. The Server may request a client to send a Client Certificate (installed on the client computer), signed with the Trusted Certificate selected on the Server for the target Domain.</p><p>If a client sends such a Certificate, the E-mail address specified in the Certificate <code>subjectAltName</code> element (if any) or in the <code>Subject</code> element E-mail field can be used for the Certificate-based Authentication. It is interpreted as the name of the CommuniGate Pro Account to log into.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>After the supplied E-mail address is processed with the Router, it checks that the target Account belongs to the same Domain as the Domain the used to verify the supplied Certificate, so Administrators of one Domain cannot create Certificates allowing users to access Accounts in other CommuniGate Pro Domains.</p></div><p>Only Accounts with enabled Certificate Authentication method can be accessed using Client Certificates.</p><p>See the <a href="./PKI.html">PKI</a> section for more details.</p><h2 id="External" tabindex="-1">External Authentication <a class="header-anchor" href="#External" aria-label="Permalink to &quot;External Authentication {#External}&quot;">​</a></h2><p>The CommuniGate Pro Server can use an external Helper program for user authentication. That program should be created by your own technical staff and it can implement authentication mechanisms required at your site but not supported directly with the CommuniGate Pro Server.</p><p>The External Authenticator can also be used:</p><ul><li>to automatically provision Accounts based on some external data source</li><li>to assist with the <a href="./Router.html">Router</a> operations</li><li>to assist with Account provisioning.</li></ul><p>The External Authenticator program name and its optional parameters should be specified using the WebAdmin Helpers page. Open the General page in the Settings realm, and click the Helpers link:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input name="U0" value="1" type="checkbox" checked="checked"><b> External Authentication</b></td></tr><tr><td align="right" width="25%">Log Level:</td><td><select name="ExternalAuthenticatorLog"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2" selected="selected">Major &amp; Failures</option><option value="3">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="right" width="25%">Program Path:</td><td><input name="P0" value="/usr/sbin/paswcheck" size="30" maxlength="255" type="text"></td></tr><tr><td align="right">Time-out:</td><td><select name="ExternalAuthenticatorTimeout"><option value="0" selected="selected">disabled</option><option value="15">15 seconds</option><option value="30">30 seconds</option><option value="60">minute</option><option value="120">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800">30 minutes</option><option value="3600">hour</option></select></td><td align="right">Auto-Restart:</td><td><select name="ExternalAuthenticatorRestart"><option value="0">disabled</option><option value="5">5 seconds</option><option value="7">7 seconds</option><option value="10">10 seconds</option><option value="15" selected="selected">15 seconds</option><option value="30">30 seconds</option><option value="60">minute</option><option value="120">2 minutes</option><option value="180">3 minutes</option><option value="300">5 minutes</option><option value="600">10 minutes</option><option value="900">15 minutes</option><option value="1800">30 minutes</option><option value="3600">hour</option><option value="7200">2 hours</option><option value="10800">3 hours</option><option value="21600">6 hours</option></select></td></tr></tbody></table></div></form><p>See the <a href="./../../development/Helpers.html">Helper Programs</a> section to learn about these options.</p><p>The External Authentication module System Log records are marked with the <code>EXTAUTH</code> tag.</p><p>If the External Authentication program is not running, all External Authentication requests are rejected.</p><p>To create your own External Authentication program, see the <a href="./../../development/Helpers.html#AUTH">Helper Applications</a> section to learn about the External Authentication interface protocol.</p><p>Sample External Authentication programs and scripts can be found at the <a href="http://www.communigatepro.ru/CGAUTH/" target="_blank" rel="noreferrer">Authentication Helpers</a> site.</p><h2 id="Hiding" tabindex="-1">Account Name Harvesting <a class="header-anchor" href="#Hiding" aria-label="Permalink to &quot;Account Name Harvesting {#Hiding}&quot;">​</a></h2><p>Some spammers use &#39;brute force&#39; attacks on mail systems, sending random names and passwords to system POP, IMAP, and other access ports. If the system sends different error messages for the &quot;unknown account&quot; and &quot;incorrect password&quot; situations, the attacker can harvest a large portion of the system Account names and then use those names for spam mailings.</p><p>Use the WebAdmin Interface to configure the Login Security options. Open the General pages in the Settings realm, and find the Login Security panel on the Others page:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Login Security</b></td></tr><tr><td> </td><td><input name="HideAccountUnknown" value="1" checked="checked" type="checkbox">Hide &#39;Account Unknown&#39; messages</td></tr></tbody></table></div></form><ul><li><p><code>Hide &#39;Unknown Account&#39; messages</code></p><p>If this option is enabled, the Server does not send the <code>Unknown Account</code> and <code>Incorrect Password</code> error messages. Instead, both messages are replaced with the <code>Incorrect Account Name or Password</code> error message.</p></li></ul><p>The CommuniGate Pro Server can temporarily disable all types of login operation for an Account that has seen too many incorrect login attempts. The <a href="./../objects/Accounts.html#Passwords">Account Settings</a> specify a time period and the number of incorrect login attempts that a user or users can make before the Account is disabled for login operations. The Account is re-enabled after the same period of time.</p><h2 id="Privs" tabindex="-1">Granting Access Rights to Users <a class="header-anchor" href="#Privs" aria-label="Permalink to &quot;Granting Access Rights to Users {#Privs}&quot;">​</a></h2><p>In order to control, monitor, and maintain the CommuniGate Pro Server, one Postmaster Account is usually enough. But you may want to allow other users to connect to the administrator interfaces of your CommuniGate Pro Server: for example, you may want to allow an operator to monitor the Logs, but you do not want to grant that operator all Postmaster access rights.</p><p>You should be logged in as the Postmaster, or other Account with the &quot;Can Do Everything&quot; right in order to assign Access Rights.</p><p>To grant access rights to a user and/or to revoke those rights, open that user Account <a href="./../objects/Accounts.html#Settings">(the Account Setting page)</a>, and click the Access Rights link. The Access Rights page will appear.</p><p>The page lists all Access Rights and the rights granted to the selected user are marked.</p><p>The following access rights can be granted only to the users (accounts) in the Main Domain:</p><ul><li><p><code>Can Do Everything (the &#39;Master&#39; right)</code></p><p>If a user is granted this right, it has all access rights to all System components.</p></li><li><p><code>Can Modify Server and Module Settings (the &#39;Settings&#39; right)</code></p><p>This right allows a user to change configuration of all CommuniGate Pro components and modules (SMTP, POP, Router, etc.)</p></li><li><p><code>Can Modify Directory Settings (the &#39;Directory&#39; right)</code></p><p>This right allows a user to change configuration of the System <a href="./../directory/">Directory</a></p></li><li><p><code>Can Modify All Domains and Accounts Settings (the &#39;All Domains&#39; right)</code></p><p>This setting specifies if the user is allowed to create, rename and delete Domains, Accounts and other Objects, and to change Domain, Account, and other Object Settings.</p></li><li><p><code>Can Read All Domains and Accounts Settings (the &#39;All Domains Read&#39; right)</code></p><p>This setting specifies if the user is allowed to read Domain, Account, and other Object Settings.</p></li><li><p><code>Can Monitor (the &#39;Monitor&#39; right)</code></p><p>This setting specifies if the user is allowed to view Server Logs, to monitor Server Queues, etc.</p></li></ul><p>The following access rights can be granted to users in any domain:</p><ul><li><p><code>Can Modify This Domain and its Account Settings:</code></p><p>This setting specifies if the user is allowed to create, remove and delete Accounts within its own domain, and to change some of the Domain Settings. You usually assign this right to a user (&quot;domain master&quot;) who will manage the Domain.</p></li></ul><p>Initially, the user <code>Postmaster</code> in the Main Domain has the Master Access right.</p><p>Select the desired Access Rights and click the Update button.</p><p>The Access Rights are stored in a single file for each Domain, the <code>Access.settings</code> file stored in the Settings subdirectory of the Domain file directory. This makes it easy to check who is granted the Server Administration rights.</p><h2 id="Access" tabindex="-1">Restricting Access <a class="header-anchor" href="#Access" aria-label="Permalink to &quot;Restricting Access {#Access}&quot;">​</a></h2><p>If you do not plan to support mobile users, you may want to restrict access to the Server accounts. Use the following option on the <a href="./Protection.html">Client IP Addresses</a> page:</p><ul><li><p><code>Logins from Non-Client Addresses</code></p><p>When the &quot;prohibit&quot; option is selected, all &quot;login&quot; operations (needed for POP, IMAP, SIP, XMPP, WebUser Interface, ACAP, PWD, etc.) are accepted only from the Server computer itself, and from the <a href="./Protection.html">Client IP Addresses</a>.</p><p>When an access module accepts a connection from an unlisted network address, and this option is selected, the module sends an error code to the client application, and the connection is closed immediately. Links with the rest of the Internet will be used only for mail <a href="./../mail/">Transfer</a>, Real-Time <a href="./../cluster/Signals.html">Signals</a> exchange, and for HTTP access to Account <a href="./../storage/FileStore.html">File Storage</a>.</p><p>When this option is selected, the SMTP AUTH operation can be used only if a client mailer or server connects from the network address included into Client Addresses list.</p><p>When this option is selected, any Signaling operation that requires authentication can be used only if a client device or server connects from the network address included into Client Addresses list.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Before you enable this option, make sure that the network address you are currently using is included into the Client Addresses list: otherwise you will immediately lose HTTP Admin access to the Server.</p></div></li></ul><p>You can also specify the access restrictions on the lower (TCP) connection level. For each service (module), open the <a href="./../network/Listener.html">Listener</a> page and specify the addresses the service (module) should or should not accept connections from. If a connection comes from an address that is not included into the <code>Grant</code> list or is included into the <code>Deny</code> list, the connection is closed immediately, and no module-level operations are performed.</p><h2 id="Impersonate" tabindex="-1">Impersonating <a class="header-anchor" href="#Impersonate" aria-label="Permalink to &quot;Impersonating {#Impersonate}&quot;">​</a></h2><p>The CommuniGate Pro Server supports impersonating - a login mode when the credentials are supplied for one Account (the Authentication Account), while a different Account (the Authorization Account) is being opened.<br> It can also be used for <a href="./../cluster/Signals.html#Registrar">Real-Time Registration</a>.</p><p>Impersonating is supported for <code>PLAIN</code> and <code>GSSAPI</code> Authentication methods.</p><p>When Impersonating is used, the Server checks if the authentication Account credentials are valid, and if the requested service is allowed for that Account. It also checks if the Authentication Account has the <code>CanImpersonate</code> <a href="./#Domain">Domain access right</a>.</p><h2 id="SessionIDSASL" tabindex="-1">The SessionID Authentication Method <a class="header-anchor" href="#SessionIDSASL" aria-label="Permalink to &quot;The SessionID Authentication Method {#SessionIDSASL}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the special <code>SessionID</code> Authentication method. This method uses the session ID of a <a href="./../access/WebUser.html">WebUser</a> or <a href="./../access/XIMSS.html">XIMSS</a> session instead of the Account password.<br> The method is useful for <a href="./../services/HTTP.html#CGI">CGI</a> programs and scripts.<br> This method is disabled by default (see above).</p><p>The method is a SASL method and requires &quot;immediate&quot; parameters in the authentication protocol command. The first parameter is the Account name, the second parameter, separated with the space symbol, is the session ID.<br> The SESSIONID authentication operation for the PWD module is:</p><p><code>AUTH SESSIONID _userName_ _session-ID_</code><br> The SESSIONID authentication operation for the IMAP module is: <code>AUTHENTICATE SESSIONID _bindata_</code><br> where <em>bindata</em> are base64-encoded parameter data: <code>_userName_ _session-ID_</code></p><p>If the user <code>john@doe.dom</code> has an open WebUser Session with the 114-bXaKw92JK1pZVB5taj1r ID, then the PWD command:<br><code>AUTH SESSIONID john@doe.dom 114-bXaKw92JK1pZVB5taj1r</code><br> opens the john@doe.dom account in this PWD session.</p><h2 id="ACL" tabindex="-1">Access Control Lists (ACLs) <a class="header-anchor" href="#ACL" aria-label="Permalink to &quot;Access Control Lists (ACLs) {#ACL}&quot;">​</a></h2><p>The Account owner can grant certain rights to other users: a right to access certain <a href="./../storage/Mailboxes.html">Mailboxes</a>, a right to control telephony features, etc.</p><p>Each element of the Access Control List contains a name and a set of access rights granted to that name.</p><p>An ACL element name can be:</p><ul><li><p><code>null@null</code></p><p>This ACL element specifies the access rights granted to &quot;guests&quot; (non-authenticated users).</p></li><li><p><code>anyone</code></p><p>This ACL element specifies the access rights granted to everybody (all authenticated accounts).</p></li><li><p><code>anyone@</code></p><p>This ACL element specifies the access rights granted to all Accounts in the same CommuniGate Pro Domain.</p></li><li><p><code>anyone@_domainName_</code></p><p>This ACL element specifies the access rights granted to all Accounts in the CommuniGate Pro <em>domainName</em> Domain. The <em>domainName</em> should be the real Domain name, and not a Domain Alias name.</p></li><li><p><code>_accountName_</code></p><p>This ACL element specifies the access rights granted to the <em>accountName</em> Account user in the same CommuniGate Pro Domain. The <em>accountName</em> should be a real Account name, and not an Account Alias or a Forwarder.</p></li><li><p><code>_accountName_@_domainName_</code></p><p>This ACL element specifies the access rights granted to an Account user in a different CommuniGate Pro Domain. The <em>domainName</em> should be the real Domain name, and not a Domain Alias name.</p></li><li><p><code>#_groupName_</code></p><p>This ACL element specifies the access rights granted to all members of the <em>groupName</em> <a href="./../objects/Groups.html">Group</a> (in the same Domain).</p></li><li><p><code>#_groupName_@_domainName_</code></p><p>This ACL element specifies the access rights granted to all members of the <em>groupName</em> <a href="./../objects/Groups.html">Group</a> in a different CommuniGate Pro Domain. The <em>domainName</em> should be the real Domain name, and not a Domain Alias name.</p></li></ul><p>An ACL element name can have a <code>+</code> or a <code>-</code> prefix.</p><p>Account owners always have all access rights to all objects (Mailboxes, functions) in their own Accounts.</p><p>For any other <code>_someaccount_</code> Account, the effective access rights are checked.</p><p>The effective access rights are calculated in several steps:</p><ul><li>If there is an ACL element for the <code>_someaccount_</code> name (without a <code>+</code> or a <code>-</code> prefix), then the Access right specified in that ACL element are used as the effective access rights.<br> Otherwise</li><li>All ACL elements without a <code>+</code> or a <code>-</code> prefix and matching the <code>_someaccount_</code> name are merged to form the &quot;direct&quot; access rights.</li><li>All ACL elements with the <code>-</code> prefix and matching the <code>_someaccount_</code> name are merged to form the &quot;removed&quot; access rights.</li><li>All ACL elements with the <code>+</code> prefix and matching the <code>_someaccount_</code> name are merged to form the &quot;added&quot; access rights.</li><li>The &quot;removed&quot; access rights are removed from the &quot;direct&quot; access rights.</li><li>The &quot;added&quot; access rights are merged with the &quot;direct&quot; access rights.</li><li>The resulting &quot;direct&quot; access rights are used as the effective access rights.</li></ul><p>When granting access rights, the real Account names, not Account Aliases should be used. If an Account <code>j.smith</code> has two aliases <code>john.smith</code> and <code>jonny</code>, the access rights should be granted to the name <code>j.smith</code>.</p><ul><li><p>Examples:</p><p>Grant the Lookup, Select, and Seen access rights to all users in the same Domain, excluding the user John, who should have only the Lookup right, and the user Susan who should have the Lookup, Select, Seen, and Delete rights:</p><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td><code>anyone@</code></td><td>Lookup, Select, Seen</td></tr><tr><td><code>-john</code></td><td>Select, Seen</td></tr><tr><td><code>+susan</code></td><td>Delete</td></tr></tbody></table><p>Grant the Lookup, Select, and Seen access rights to all users in a different company2.com Domain, excluding the user <a href="mailto:john@company2.com" target="_blank" rel="noreferrer">john@company2.com</a> who should have no access rights, and grant the Lookup, Select, and Delete rights to the user susan in a yet another company3.com Domain.</p><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td><code>anyone@company2.com</code></td><td>Lookup, Select, Seen</td></tr><tr><td><code>-john@company2.com</code></td><td>Lookup, Select, Seen</td></tr><tr><td><code>susan@company3.com</code></td><td>Lookup, Select, Delete</td></tr></tbody></table></li></ul><p>The Access Control Lists can be set and modified using the <a href="./WebMail.html#MailboxManagement">WebUser Interface</a>, a <a href="./../access/XIMSS.html">XIMSS</a>, a <a href="./../access/MAPI.html">MAPI</a>, or a decent <a href="./../access/IMAP.html">IMAP</a> client.</p>',103))])}const P=r(l,[["render",f]]);export{v as __pageData,P as default};
