import{_ as a,c as i,o as r,ag as t,j as e,a as s}from"./chunks/framework.jCcxW76o.js";const f=JSON.parse('{"title":"System Administration","description":"","frontmatter":{"legacyLink":"SysAdmin.html"},"headers":[],"relativePath":"admin/sysadmin/index.md","filePath":"admin/sysadmin/index.md"}'),n={name:"admin/sysadmin/index.md"};function d(c,o,l,h,m,p){return r(),i("div",null,o[0]||(o[0]=[t('<h1 id="system-administration" tabindex="-1">System Administration <a class="header-anchor" href="#system-administration" aria-label="Permalink to &quot;System Administration&quot;">​</a></h1><p>When the CommuniGate Pro Server is up and running, it can be configured, monitored, and set up using any Web browser.</p><p>By default, the <a href="./../services/HTTP.html">HTTP module</a> provides access to the CommuniGate Pro Server Administration pages (the WebAdmin Interface) via the TCP port number 8010. To use the WebAdmin Interface, use the <code>http://_serveraddress_:8010</code> URL, where <em>serveraddress</em> is the server IP address or the Server DNS name (A-record).</p><p>You can also administer the CommuniGate Pro Server via the <a href="./../../development/CLI.html">network command-line interface</a>.</p><h2 id="Privs" tabindex="-1">Realms and Access Rights <a class="header-anchor" href="#Privs" aria-label="Permalink to &quot;Realms and Access Rights {#Privs}&quot;">​</a></h2><p>The WebAdmin Interface pages are grouped into five Realms. To access a page in any realm, you should have a CommuniGate Pro Account, and that Account should be explicitly granted access rights to that realm.</p><ul><li>The Settings realm contains pages that allow a Server Administrator to modify the Server kernel and module settings.</li><li>The Users realm contains pages that allow a Server Administrator to create and remove Domains and Accounts, and to modify the Domain and Account settings.</li><li>The Monitors realm contains pages that allow a Server Administrator to monitor server and module queues, communication channels and their states, to browse the <a href="./Logs.html">Server Logs</a>, and to view the Server <a href="./Statistics.html">Statistics</a>.<br> If a user is granted an access right to the Monitors realm, additional Monitor Access rights can be granted, too (rights to release and reject module queues, reconfigure the Log Manager, etc.)</li><li>The Directory realm contains pages that allow a Server Administrator to configure the CommuniGate Pro Directory services.</li><li>The Master realm contains the pages that allow a Server Administrator to grant and revoke Server Administrator access rights, and to modify the Server License Keys.</li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>An Account should be granted the Domains Read access right to access the Users realm to read information about all Domains and Accounts.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>An Account should be granted the All Domains access right to access the Users realm to read information and to make modifications in all Domains and Accounts.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If an Account is granted the Master access right, the Account user can access all realms and make all types of modifications.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>These Server Administration access rights can be granted to the Main Domain Accounts only. Accounts in secondary Domains can be granted <a href="#Domain">Domain Administration</a> rights only.</p></div><p>When a Server is installed for the first time, it creates the <code>postmaster</code> Account in the Main Domain, and it grants the Master access right to that Account.</p><h2 id="Expertise" tabindex="-1">Interface Types <a class="header-anchor" href="#Expertise" aria-label="Permalink to &quot;Interface Types {#Expertise}&quot;">​</a></h2><p>The CommuniGate Pro Server is very complex and flexible software. Its set of Settings and other configuration options can be overwhelming for someone not familiar with the product.</p><p>An WebAdmin Interface Type ranging from <code>Basic</code> to <code>Expert</code> is assigned to each Administrator. These Types (or Expertise Levels) are designed to simplify the learning process:</p><ul><li><code>Basic</code>: the WebAdmin Interface is shrunk to the minimal set of pages, and only the essential settings are displayed on these pages.</li><li><code>Advanced</code>: the WebAdmin Interface shows all pages and settings needed to control a typical installation.</li><li><code>Expert</code>: the WebAdmin Interface shows all available pages and settings.</li></ul><p>When the CommuniGate Pro Server is installed for the first time, and the <code>postmaster</code> Account is created, the <code>Basic</code> WebAdmin Interface Type is set for that Account. You can change the Interface Type by opening the <a href="#WebAdminPrefs">WebAdmin Preferences</a> pages.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This documentation shows the WebAdmin pages and settings as they are displayed in the <code>Expert</code> mode.</p></div><h2 id="General" tabindex="-1">General Settings <a class="header-anchor" href="#General" aria-label="Permalink to &quot;General Settings {#General}&quot;">​</a></h2>',19),e("p",null,[s("Use the WebAdmin Interface to open the General page in the Settings realm:"),e("form",{action:"Null.html"},[e("div",{align:"center",class:"WebAdmin"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Main Domain Name:"),e("td",null,[e("input",{type:"text",name:"domain",size:"20",maxlength:"63",value:"mycompany.com"})]),e("td",{align:"RIGHT"},[e("input",{type:"reset",name:"Refresh",value:"Refresh",class:"button"})])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Contact Person:"),e("td",null,[e("input",{type:"text",name:"sysContact",size:"50",maxlength:"255",value:" "})])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Location:"),e("td",null,[e("input",{type:"text",name:"sysLocation",size:"50",maxlength:"255"})])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Internals Log:"),e("td",{colspan:"2"},[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Crashes Only"),e("option",{value:"1"},"Failures"),e("option",{value:"2"},"Major & Failures"),e("option",{value:"3"},"Problems"),e("option",{value:"4",selected:"selected"},"Low Level"),e("option",{value:"5"},"All Info")])])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Crash Recovery:"),e("td",{colspan:"2"},[e("select",{name:"CrashRecovery"},[e("option",{value:"0"},"Disabled"),e("option",{value:"1"},"Enabled")])])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Separate WebAdmin Realms:"),e("td",{colspan:"2"},[e("select",{name:"SeparateAdminRealms"},[e("option",{value:"0"},"No"),e("option",{value:"1"},"Yes")])])]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Time:"),e("td",{colspan:"2"},"Wed, 06 Dec 2006 00:38:40 -0800")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Up-time:"),e("td",{colspan:"2"},"125 day(s) 5 hour(s) 23 min 16 sec")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server OS:"),e("td",null,"Sun Solaris"),e("td",{align:"RIGHT"}," ")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Hardware:"),e("td",null,"x86 (32-bit)"),e("td",{align:"RIGHT"}," ")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server Version:"),e("td",{colspan:"2"},"6.3.0")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"MAPI Version:"),e("td",{colspan:"2"},"1.54.12.34/1.54.12.34 , 2.60.6/2.60.5")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"IPv6 Support:"),e("td",{colspan:"2"},"Enabled")]),e("tr",null,[e("th",{nowrap:"nowrap",align:"RIGHT"},"Name Server(s) IP Address(es):"),e("td",null,"[64.173.55.167]")]),e("tr",{valign:"top"},[e("th",{nowrap:"nowrap",align:"RIGHT"},"Server IP Address(es):"),e("td",{colspan:"2"},[e("table",{class:"settingsBox"},[e("tbody",null,[e("tr",null,[e("td",null,"[64.173.55.171] "),e("td",null,[e("a",{href:"../objects/Domains.md"},"mycompany.com")])]),e("tr",null,[e("td",null,"[64.173.55.170] "),e("td",null,[e("a",{href:"../objects/Domains.md"},"client2.dom")])]),e("tr",null,[e("td",null,"[2001:470:1f01:2565::a:845] "),e("td",null,[e("a",{href:"../objects/Domains.md"},"mycompany.com")])])])])])]),e("tr",{valign:"top"},[e("th",{align:"right",nowrap:"nowrap"},"Startup Parameters:"),e("td",{colspan:"2"},[e("div",{style:{width:"300pt"}},[e("pre",null,'"--Base" "/var/CommuniGate" "--Daemon"')])])])])])])])])],-1),t('<ul><li><p><code>Main Domain Name</code></p><p>In this field you should enter the name that the CommuniGate Pro Server will interpret as its own <em>Main Domain Name</em>. All mail addressed to that domain will be treated as local, and (in the simplest case) that mail will be stored in local Account Mailboxes. Initially, this field contains the server computer name that CommuniGate Pro retrieves from the OS. If this names looks like <code>host12345hh.company.com</code>, you should change it to the name of the domain this Server should process.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Unless you create additional <a href="./../objects/Domains.html">Domains</a> ONLY the E-mail Messages and Signals directed to addresses in the Main Domain will be processed as <em>local</em>. If the Main Domain Name is entered as <code>company.com</code>, then Messages to <code>mail.company.com</code> or Signals to <code>sip.company.com</code> will not be processed as local, and if such a Message or Signal is received, the Server will try to deliver it to the <code>mail.company.com</code> or the <code>sip.company.com</code> system over the network.</p></div><p>If the DNS record for <code>mail.company.com</code> or <code>sip.company.com</code> points to the same Server computer, the <em>mail loop</em> or <em>signal loop</em> error will be detected, and the Message or Signal will be rejected.</p><p>If your Server should serve several domain names, enter the additional domain names as <a href="./../objects/Domains.html#Aliases">Main Domain Aliases</a> (if those domain names should be &quot;mapped&quot; to the Main Domain), or create additional (&quot;secondary&quot;) <a href="./../objects/Domains.html">Domains</a>.</p><p>National (non-Latin) symbols are not allowed in the Main Domain Name, but they are allowed in additinal <a href="./../objects/Domains.html">Domains</a> and in <a href="./../objects/Domains.html#Aliases">Domain Alias</a> names.</p><ul><li><p>Sample configuration:</p><p>Your Server should serve the <code>company.com</code> and <code>client1.com</code> domains. These domain names have their DNS MX-records and SIP SRV-records pointing to <code>server.company.com</code> and <code>server.client1.com</code> A-records, and these A-records point to IP address(es) assigned to your CommuniGate Pro Server system.</p><ul><li>set <code>company.com</code> as the Main Domain Name.</li><li>open the Domains page, find the <code>**company.com**</code> record and click on its <code>Settings</code> link to open the company.com Domain Settings page. Scroll it down to find the Domain Aliases fields.</li><li>enter <code>server.company.com</code> into an empty Domain Aliases field, and click the Update button.</li><li>open the Domains page. Enter <code>client1.com</code> into the text field and click the Create Domain button.</li><li>the <code>client1.com</code> record should appear in the list; click its <code>Settings</code> link to open the client1.com Domain Settings page. Scroll it down to find the Domain Aliases fields.</li><li>enter <code>server.client1.com</code> into an empty Domain Aliases field, and click the Update button.</li></ul><p>The value of this field is used in <a href="./../services/SNMP.html">SNMP</a> protocol as <a href="http://oid-info.com/get/1.3.6.1.2.1.1.5" target="_blank" rel="noreferrer">system.sysName</a> object.</p></li></ul></li><li><p><code>Contact Person</code></p><p>In this field you should enter the textual identification of the contact person for this managed node, together with information on how to contact this person.<br> The value of this field is used in <a href="./../services/SNMP.html">SNMP</a> protocol as <a href="http://oid-info.com/get/1.3.6.1.2.1.1.4" target="_blank" rel="noreferrer">system.sysContact</a> object.</p></li><li><p><code>Server Location</code></p><p>The physical location of this node (e.g.,&#39;telephone closet, 3rd floor&#39;).<br> The value of this field is used in <a href="./../services/SNMP.html">SNMP</a> protocol as <a href="http://oid-info.com/get/1.3.6.1.2.1.1.6" target="_blank" rel="noreferrer">system.sysLocation</a> object.</p></li><li><p><code>System Internals Log</code></p><p>Use this setting to specify what kind of information the Server kernel module should put in the <a href="./Logs.html">Server Log</a>. Usually you should use the <code>Major</code> (message transfer reports) level. But when you experience problems with the server kernel, you may want to set the Log Level setting to <code>Low-Level</code> or <code>All Info</code>: in this case low-level details will be recorded in the System Log as well. When the problem is solved, set the Log Level setting to its regular value, otherwise your System Log files will grow in size very quickly.<br> The kernel records in the System Log are marked with the <code>SYSTEM</code> tag.</p><p>Kernel problems are very unlikely to happen. If you see any problem with the Server, try to detect which component is causing it, and change the Log setting of that component (Router, SMTP, POP, etc.) to get more information.</p></li><li><p><code>Crash Recovery</code></p><p>If this option is enabled, the CommuniGate Pro Server uses special recovery techniques to proceed after various failures (including the crashing bugs in the Server software itself).</p><p>If you see &quot;<code>exception raised</code>&quot; messages in your CommuniGate Pro Log and/or in the OS <code>system.log</code> or <code>mail.log</code>, you may want to disable this option and force the Server to stop when an exception is raised again, and to produce a <em>core dump</em> file.<br> Core dump files can be uploaded to the CommuniGate Systems ftp site for examination.</p><p>CommuniGate Systems recommends you to disable this option if you are running any beta-version of the CommuniGate Pro software.</p></li><li><p><code>Separate WebAdmin Realms</code></p><p>If this option is disabled, WebAdmin realms are addressed using the <code>/Master/_realmName_/_page_</code> URLs, with <code>/Master/</code> as the authentication realm. The Server Administrator can access all WebAdmin pages by entering the password only once, but the Server Administrator Account must have the Master access right.</p><p>If this option is enabled, WebAdmin realms are addressed using the <code>/_realmName_/_page_</code> URLs, with <code>/_realmName_/</code> as the authentication realm. The Server Administrator needs to enter a password to open each realm, but the Server Administrator needs the access right for that realm only.</p><p>Enable this option if some of your Server Administrators do not have the Master access right.</p></li><li><p>Information fields</p><p>Information fields on the General Settings page display</p><ul><li>the name of the Server Operating System</li><li>the Server hardware platform (CPU type)</li><li>the CommuniGate Pro Server version</li><li>the Server Local Time and Time Zone (this information is useful for Server Administrators that have to examine Logs from remote locations, as all time stamps in the System Logs are specified in the Server local time)</li><li>the <a href="./../access/MAPI.html">MAPI Connector</a> server part version</li><li>the flag indicating <a href="./../network/#IPV6">IPv6</a> support</li><li>the <a href="./../network/#DNR">Domain Name Server</a> network address(es)</li><li>the Server network addresses. Each address is accompanied with a link to the <a href="./../objects/Domains.html#IP">Domain</a> it is assigned to, or the address is marked as un-assigned.</li><li>the Server <a href="#Options">Startup Parameters</a>.</li></ul></li><li><p><code>Refresh</code></p><p>This button can be used after the Server OS local IP Addresses have been changed or the DNS settings for CommuniGate Pro Domains have been modified. When you click this button:</p><ul><li>the Server re-reads the list of Local IP Addresses from the OS</li><li>the Server re-reads the <a href="./../network/#DNR">Domain Name Server addresses</a> from the OS settings</li><li>the Server updates the &quot;Assigned IP Addresses&quot; for all Domains. If some Domains have IP Addresses specified &quot;Using DNS A/MX Records&quot;, the new addresses are retrieved from the DNS system</li><li>the Server re-loads the MAPI Connector server part (so you can upgrade the MAPI Connector server part without restarting the Server)</li></ul></li><li><p><code>Drop Root</code></p><p>This button is available on certain Unix platforms. It allows the System Administrator to tell the server to drop the &quot;superuser&quot; privileges. Certain functions (such as OS Authentication, Execute Rules operations, etc.) may become unavailable.<br> If the Server succeeds to drop the &quot;superuser&quot; privileges, the button title changes to <code>Restore Root</code>. Click the Restore Root button to restore the &quot;superuser&quot; privileges.</p></li></ul><h2 id="Locale" tabindex="-1">Specifying the Preferred Language <a class="header-anchor" href="#Locale" aria-label="Permalink to &quot;Specifying the Preferred Language {#Locale}&quot;">​</a></h2><p>CommuniGate Pro supports multiple languages, and different users can use different languages. If most of your users will use the same language, it is recommended to set this language as the default one for the entire Server or for a particular Domain.</p><p>Use the WebAdmin Interface to open the Account Defaults page in the Users realm to specify Server-wide language settings. If you want to set a default language for a particular Domain, open that Domain pages in the WebAdmin Users realm, and open the Domain Account Defaults page from there.<br> Click the Preferences link to open the Default Preferences page.</p><p>Select the default Language and select a matching Preferred Character set: ISO-2022-JP for Japanese, KOI8-R for Russian, etc. If most of your users use modern Web browsers with the proper UTF-8 support, set the Use UTF-8 option to Reading and Composing.</p><p>Set the display names for the INBOX Mailbox and the virtual MAPI Outbox folder. These strings are used only with the CommuniGate Pro own client components - the WebUser Interface and MAPI, so you can enter any valid Mailbox name here, in any language. You can also change these names at any time.</p><p>Set the names for special Mailboxes - Sent, Drafts, Notes, Trash, Contacts, Calendar, and Tasks. Please note that these names will be used with the CommuniGate Pro own client components only - the WebUser Interface and MAPI. To make the user&#39;s IMAP clients use the same Mailboxes for the same purposes, the same Mailbox names should be specified in the IMAP client configurations. If you change these names later, the new Mailboxes will be created when a client needs to access a special Mailbox: the already existing special Mailboxes will not be renamed.</p><h2 id="TimeZone" tabindex="-1">Specifying the Preferred Time Zone <a class="header-anchor" href="#TimeZone" aria-label="Permalink to &quot;Specifying the Preferred Time Zone {#TimeZone}&quot;">​</a></h2><p>CommuniGate Pro supports multiple time zones, and different users can be located in different zones. If most of your users will use the same time zone, it is recommended to set this zone as the default one for the entire Server or for a particular Domain.</p><p>Open the Account Defaults page in the Domains section of the WebAdmin Interface if you want to set the Server-wide default time zone. If you want to set a default time zone for a particular Domain, open the Domains page of the WebAdmin Interface, open the Accounts or Settings page for the selected Domain and open the Domain Account Defaults page from there. Click the Preferences link to open the Default Preferences page.</p><p>Select the default Time Zone from the list. If you select the &quot;built-in&quot; zone (<code>HostOS</code>), the Server will use a fictitious zone that has the same time difference with GMT as the Server OS has at this time. This zone has no support for daylight saving time and it cannot be used for sending recurrent events outside your Server. Unless your Time Zone is not listed, avoid selecting the &quot;built-in&quot; zone.</p><h2 id="Directories" tabindex="-1">Base Directory Structure <a class="header-anchor" href="#Directories" aria-label="Permalink to &quot;Base Directory Structure {#Directories}&quot;">​</a></h2><p>All CommuniGate Pro Server files - Accounts, Domains, Mailboxes, settings, queues, etc. are stored in one place - in the Server <em>base directory</em>.</p><p>When the Server starts, it creates the following objects inside its base directory:</p><ul><li>The <code>Settings</code> directory. This directory contains files with module and kernel component settings.</li><li>The <code>Queue</code> directory. This directory contains <a href="./../mail/">Temporary and Message files</a>. The Message files contain messages submitted to the Server, but still undelivered to all their recipients.</li><li><code>BadFiles</code> directory. This directory contains Message files the <a href="./../mail/">Enqueuer kernel component</a> failed to parse. This directory should be empty.</li><li><code>Accounts</code> directory. This directory contains <a href="./../objects/Accounts.html">account files</a> for the Main Server Domain.</li><li><code>Domains</code> directory. This directory contains directories for all other <a href="./../objects/Domains.html">Domains</a>.</li><li><code>Submitted</code> directory. This drop-in directory is used to submit messages to Server via the <a href="./../mail/PIPE.html">PIPE module</a>.</li><li><code>SystemLogs</code> directory. This directory contains <a href="./Logs.html">Server Logs</a>.</li><li><code>ProcessID</code> file. This file exists only when the Server is running and contains the numeric identifier of the Server process in the OS.</li><li><code>Directory</code> directory. This directory contains the Server <a href="./../services/LDAP.html#Central">Central Directory</a> files.</li><li><code>tmp</code> directory. This directory used to store temporary files and directories created by the server. (The <code>--TmpDir</code> parameter can override default <code>tmp</code> directory name).</li></ul><p>For more information about the Account and Domain files and directories, see the <a href="./../objects/">Objects</a> section.</p><p>You can use symbolic links to move some of these directories to other locations (and other disks).</p><h2 id="Options" tabindex="-1">Command Line Options <a class="header-anchor" href="#Options" aria-label="Permalink to &quot;Command Line Options {#Options}&quot;">​</a></h2><p>The CommuniGate Pro Server supports the following command-line options (parameters):</p><ul><li><p><code>--CGateBase _directory_</code><br> or<br><code>--Base _directory_</code></p><p>The next parameter string specifies the location of the CommuniGate Pro <a href="#Directories"><em>base directory</em></a>.</p></li><li><p><code>--TmpDir _directory_</code></p><p>The next parameter string specifies the location of the CommuniGate Pro temporary files and directories.</p></li><li><p><code>--logToConsole</code></p><p>This option tells the Server to duplicate all its <a href="./Logs.html">System Log</a> records to the <code>stdout</code> (standard output). This option can be used for troubleshooting when the Web interface to System Logs is not available.</p></li><li><p><code>--logAll</code></p><p>This option tells the Server to ignore all current Log Level settings and record all possible Log records.</p></li><li><p><code>--daemon</code></p><p>This option can be specified on Unix platforms only. It tells the Server to fork and operate in the background, with stdin, stdout, and stderr redirected to <code>/dev/null</code>.</p></li><li><p><code>--CGateApplication _directory_</code></p><p>The next parameter string specifies the location of the CommuniGate Pro <a href="#Directories"><em>application directory</em></a>. You can use this option when the application itself cannot properly detect its own location, or if the CommuniGate Pro Server application file is not placed in the same location as other application directory files and subdirectories.</p></li><li><p><code>--IPv6 [ YES | NO ]</code></p><p>See the <a href="./../network/#IPV6">Network</a> section for the details.</p></li><li><p><code>--lockLockFile [YES | NO]</code></p><p>This option tells the Server not to try to lock the ProcessID lock file. This option can be used if the file system hosting the <em>base directory</em> does not support file locks.</p></li><li><p><code>--dropRoot</code></p><p>This option can be specified on Unix platforms only (this does not include Linux). It tells the Server to drop the <em>root privilege</em> permanently. The server drops the privilege approximately 60 seconds after the end of its kernel initialization process, so all listening sockets can be opened when the server is still running as the <em>root</em>. The root privilege cannot be restored later. See the <a href="#Root">Server Root Privilege</a> section for more details.</p></li><li><p><code>--delayOnStart _seconds_</code></p><p>This option tells the Server to sleep for the specified number of seconds before proceeding with initialization. This option can be used when CommuniGate Pro starts during system startup and it should let other services to startup fully (for example, an external file system can be mounted, a virtual IP address can be created, etc.)</p></li><li><p><code>--threadsScope _scope_</code></p><p>This option can be specified on platforms supporting p-threads (most Unix flavors). The next parameter string can be either &quot;system&quot; or &quot;process&quot;. See your OS manual to learn how these &quot;scheduling scopes&quot; work. If this option is not specified, the default OS scheduling mode is used.</p></li><li><p><code>--batchLogon</code></p><p>This option can be specified on Microsoft Windows platforms only.<br> The option tells the Server to use &#39;batch logon&#39; instead of the &#39;network logon&#39; when an account password is verified using the Windows OS password system.</p></li><li><p><code>--sharedFiles</code></p><p>This option can be specified on Microsoft Windows platform only.<br> The option tells the Server to open all files with the FILE SHARE_READ sharing attribute making it possible for other programs (such as backup daemons) read the CommuniGate Pro base directory files when the server is running. This option is enabled by default on the Microsoft Windows NT/XP/200x platforms.</p></li><li><p><code>--noSharedFiles</code></p><p>This option can be specified on Microsoft Windows platform only.<br> The option tells the Server to open all files without the FILE_SHARE_READ sharing attribute if the Server does not need to read the file from several threads.</p></li><li><p><code>--useNonBlockingSockets</code></p><p>This option tells the Server to set its TCP and UDP sockets in the non-blocking mode. This option can improve the Server performance on some platforms.</p></li><li><p><code>--useBlockingSockets</code></p><p>This option tells the Server to set its TCP and UDP sockets in the blocking mode.</p></li><li><p><code>--closeStuckSockets</code></p><p>This option tells the Server to maintain a list of open communication sockets and check if some socket operations did not complete in time and due to the kernel bugs the OS failed to interrupt the operation in time. It is recommended to use this option on heavily-loaded Solaris systems.</p></li><li><p><code>--localIPBuffer _size_value_</code></p><p>This option tells the Server to use a buffer of the specified size when it retrieves a list of the Server Local IP addresses from the OS. On some platforms (such as Linux) the default buffer size is set to a relatively small value, because some versions of these OSes have problems processing large buffers. If your Server system has many IP addresses (more than a thousand) and your CommuniGate Pro Server does not recognize all of them, you may want to use this parameter to specify a larger buffer size. The default size is 16K or 128K, you may want to specify larger values (<code>204800</code> or <code>200K</code>).</p></li><li><p><code>--threadPriority [ YES | NO ]</code></p><p>If this option value is NO, the Server skips all attempts to increase an individual thread priority. Use this value if bugs in the Server OS cause an application to crash when a thread priority is increased (&quot;non-global zones&quot; in Solaris 10).</p></li><li><p><code>--defaultStackSize _size_value_</code></p><p>This option modifies the default stack size (in bytes) for the process threads.</p></li><li><p><code>--SIPUDPSendBuffer _size_value_</code></p><p><code>--SIPUDPReceiveBuffer _size_value_</code></p><p>These options specify custom send and receive buffer sizes (in bytes) for the <a href="./../signals/SIP.html">SIP</a> UDP listener socket.</p></li><li><p><code>--SIPUDPReceiverHighPty [ YES | NO ]</code></p><p>If this option value is YES, the priority of the thread receiving SIP UDP packets is increased. It is recommended that you use this option only when a non-zero number of <a href="./../signals/SIP.html#Enqueuers">SIP Enqueuer</a> threads is used.</p></li><li><p><code>--DNRUDPSendBuffer _size_value_</code></p><p><code>--DNRUDPReceiveBuffer _size_value_</code></p><p>These options specify custom send and receive buffer sizes (in bytes) for the <a href="./../network/#DNR">DNR</a> UDP socket.</p></li><li><p><code>--DNRUDPReceiverHighPty [ YES | NO ]</code></p><p>If this option value is YES, the priority of the thread receiving DNR UDP packets is increased.</p></li><li><p><code>--excludeLocalIP _ip_address_</code></p><p>Use these options to remove the specfied Network IP Address from the list of addresses which are processed as &quot;local&quot; (i.e. the addresses assigned to the Server computer).</p></li><li><p><code>--createTempFilesDirectly _pool_size_</code></p><p>This option modifies the way the Temporary Files Manager creates its files. With the default value of 0, a special thread is used to keep a pool of pre-created files ready for consumption by any component. If this option is set to a non-zero value, and the amount of pre-created Temporary Files in the pool is below this value, new Temporary Files are created with the requesting threads themselves.<br> You may want to specify a non-zero value for this option on heavily-loaded systems with low file creation performance.</p></li><li><p><code>--UseSystemPorts [ YES | NO ]</code></p><p>On Unix systems, if this option value is YES, the Server will try to use the TCP/UDP ports with numbers below 1024, even when the Server application is not running as a <a href="#Root">&quot;superuser&quot;</a> (&quot;root&quot;).</p></li><li><p><code>--randomDataDevice _path_</code></p><p>This option specifies the path to the system entropy source. Without this parameter or when reading from the specified path fails the server uses the value of the system timer for seeding its PRNG.Command line option names are case-insensitive.</p></li></ul><h3 id="NTOptions" tabindex="-1">Specifying Command Line Options under Windows <a class="header-anchor" href="#NTOptions" aria-label="Permalink to &quot;Specifying Command Line Options under Windows {#NTOptions}&quot;">​</a></h3><p>You can specify the Command Line Options using the Services control panel &quot;Startup Parameters&quot; field. A non-empty set of Command Line Options is stored in the System Registry and it is used every time the CommuniGate Pro Messaging Server service is started without parameters. To clear the stored set of the Command Line Options, specify a single minus (<code>-</code>) symbol using the Services control panel &quot;Startup Parameters&quot; field.</p><h3 id="UnixOptions" tabindex="-1">Customizing Unix Startup Scripts <a class="header-anchor" href="#UnixOptions" aria-label="Permalink to &quot;Customizing Unix Startup Scripts {#UnixOptions}&quot;">​</a></h3><p>You may need to add certain shell commands to the CommuniGate Startup script. Since the Startup script is a part of CommuniGate Pro application software, it is overwritten every time you upgrade your CommuniGate Pro system. Instead of modifying the Startup script itself, you can place a <code>Startup.sh</code> file into the CommuniGate Pro <em>base directory</em>. Startup scripts check if that file exists, and execute it before performing the requested start/stop operations.</p><h2 id="Shutdown" tabindex="-1">Shutting Down <a class="header-anchor" href="#Shutdown" aria-label="Permalink to &quot;Shutting Down {#Shutdown}&quot;">​</a></h2><p>The CommuniGate Pro Server can be shut down by sending it a SIGTERM or a SIGINT signal.</p><p>On Unix platforms you can use the startup script with the <code>stop</code> parameter, or you can get the Server process id from the ProcessID file in the base directory and use the <code>kill</code> command to stop the server.</p><p>On the Windows NT platform, you can use the Services control panel to stop and start the CommuniGate Pro server.</p><p>You can also use the <code>shutdown</code> <a href="./../../development/CLI.html">CLI API</a> command to stop the server.</p><p>When the Server receives a shutdown request, it closes all the connections, commits or rolls back Mailbox modifications, and performs other shutdown tasks. Usually these tasks take 5-15 seconds, but sometimes (depending on the OS network subsystem) they can take more time. Always allow the Server to shut down completely, and do not interrupt the shutdown process.</p><h2 id="Syslog" tabindex="-1">OS syslog <a class="header-anchor" href="#Syslog" aria-label="Permalink to &quot;OS syslog {#Syslog}&quot;">​</a></h2><p>The CommuniGate Pro server can store as much as several megabytes of Log data per minute (depending on the Log Level settings of its modules and components), and it can search and selectively retrieve records from the log. To provide the required speed and functionality, the Server maintains its own multithreaded <a href="./Logs.html">Log system</a>.</p><p>The Server places records into the OS log:</p><ul><li>when it starts up;</li><li>when it shuts down;</li><li>when it detects its own memory leaks;</li><li>when it detects its own program error;</li><li>when a program error exception (signal) is raised.</li></ul><p>The system Log is:</p><ul><li>system.log or mail.log file on Unix systems</li><li>Event Log on Windows systems</li></ul><h2 id="AdminAlerts" tabindex="-1">Urgent Notifications <a class="header-anchor" href="#AdminAlerts" aria-label="Permalink to &quot;Urgent Notifications {#AdminAlerts}&quot;">​</a></h2><p>The CommuniGate Pro Server can display Urgent Notification Messages to Server Administrators.</p><p>The Urgent Notifications are displayed in WebAdmin Interface:</p>',39),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",null,[e("table",{width:"100%",cellspacing:"0",class:"tabSet"},[e("tbody",null,[e("tr",{align:"center",valign:"bottom"},[e("td",{class:"tabName"},[e("div",null,"mail.mycompany.com")]),e("td",{class:"tabActive"},[e("div",null,"Settings")]),e("td",{class:"tab"},[e("div",null,[e("a",null,"Users")])]),e("td",{class:"tab"},[e("div",null,[e("a",null,"Monitors")])]),e("td",{class:"tab"},[e("div",null,[e("a",null,"Directory")])]),e("td",{class:"tab"},[e("div",null,[e("a",null,"Master")])])])])])])]),e("tr",null,[e("td",{class:"tabDataOuter"},[e("table",{width:"100%",cellspacing:"0",cellpadding:"0",class:"tabData"},[e("tbody",null,[e("tr",null,[e("td",{align:"left",style:{color:"#F00","font-style":"italic"}},"A problem with Module SMTP, TCP listener on [0.0.0.0]:25: failed to start. Error Code=network address/port is already in use")])])])])])])])])],-1),t('<p>There may be Notifications about failures with <a href="./../../development/Helpers.html">Helpers</a>, filesystem errors, license keys expiration, and other critical events which require immediate reaction from the Server Administrator.<br> When there are several Notification in progress, one randomly choosen Notification is displayed.<br> The Server automatically deactivates the Notifications when they become outdated.</p><h2 id="Root" tabindex="-1">Server Root Privilege <a class="header-anchor" href="#Root" aria-label="Permalink to &quot;Server Root Privilege {#Root}&quot;">​</a></h2><p>The CommuniGate Pro is designed as a highly secure application. In order to perform certain operations, the Server runs as <em>root</em> on Unix platforms, and it carefully checks that no user can access restricted OS resources via the Server. Since many other servers do not provide the same level of security, system administrators preferred to run servers in a non-root mode, so a hole in the server security would not allow an intruder to access the restricted OS resources.</p><p>CommuniGate Pro can &quot;drop&quot; the <em>root privilege</em>. The privilege can be dropped in the permanent or reversible mode. When asked to drop the root (uid=0) privilege, the Server changes its UID:</p><ul><li>to the UID of the Unix user <code>cgatepro</code> (if exists), otherwise</li><li>to the UID of the Unix user <code>nobody</code> (if exists), otherwise</li><li>to the UID 1</li></ul><p>When the root privilege is dropped, the following restrictions apply:</p><ul><li>No <a href="./../network/Listener.html">Listener</a> port with number &lt; 1024 can be opened. If you try to add a listener with the port number n (n &lt; 1024), the port with the number 8000+n is opened instead (unless the <a href="#UseSystemPorts">--UseSystemPorts</a> Command Line Option is used).</li><li>Remote applications started via Account-Level <a href="./../mail/QueueRules.html">Rule</a> EXECUTE command run in the current CommuniGate Pro Server environment (the effective UID and other OS-level process parameters are not changed).</li><li>OS Passwords cannot be used.</li></ul><p>If the root privilege was dropped in the reversible mode, the root privilege can be restored. For example, if you need to open a listener on the port 576, but the Server root privilege has been dropped, you should restore the root privilege first, then open the listener port, and then you can drop the Root privilege again.</p><p>To drop the root privilege permanently, use a special <a href="#Options">Command Line Option</a>.</p><p>To drop the root privilege in the reversible mode, click the &quot;Drop Root&quot; button on the General page. The button should change to the &quot;Restore Root&quot; button - you can use it to restore the Server root privilege.</p><h2 id="Domain" tabindex="-1">Domain Administrator <a class="header-anchor" href="#Domain" aria-label="Permalink to &quot;Domain Administrator {#Domain}&quot;">​</a></h2><p>If your Server has several <a href="./../objects/Domains.html">Domains</a>, you may want to grant some users in those Domains the <a href="./../sysadmin/Security.html#DomainAdmin"><em>Domain Administrator</em> access right</a>.</p><p>A Domain Administrator can control the Domain using the same WebAdmin port (see <a href="./../services/HTTP.html#WebDomain">HTTP module</a> description for the details), or using the <a href="./../../development/CLI.html">Command Line Interface (API)</a> commands. Domain Administrator access is limited to his Domain (and, optionally, to <a href="#SubDomains">certain other domains</a>), and to explicitly allowed Domain and Account settings and operations.</p><p>When you grant the Domain Administrator access right to a user, you will see a list of specific access rights - the internal names of Domain and Account Settings.<br> Each option controls the settings this Domain Administrator can modify, and the operations this Domain Administrator can perform.</p><p>Domain Administrator access rights can be granted to users by a Server Administrator with the All Domains and Account Settings access right.</p><p>A System Administrator with the All Domains and Account Settings access right can perform all operations potentially available to a Domain Administrator in any Domain.</p><h3 id="SubDomains" tabindex="-1">Domains Administrators in other Domains <a class="header-anchor" href="#SubDomains" aria-label="Permalink to &quot;Domains Administrators in other Domains {#SubDomains}&quot;">​</a></h3><p>When a customer has several Domains, you may want to let an Account in one Domain administer other Domains. You should grant such an Account the <code>CanAdminSubDomains</code> access right. Then you should open the <a href="./../objects/Domains.html">Domain Settings</a> page for the target Domain and specify the Administrator&#39;s Domain name in the Administrator Domain Name field.</p><ul><li><p>Sample:</p><p>A customer has the company1.com, company2.com, company3.dom Domains on your Server. You may want to specify <code>company1.com</code> as the Administrator Domain Name in the company2.com and company3.com Domain Settings. Now, any Account in the company1.com Domain that has the <code>CanAdminSubDomains</code> Domain Administrator right can administer all three Domains.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a Domain Administrator connects to the Domain WebAdmin Interface, the browser displays the Login Dialog Box. If the Administrator Account is in a different Domain, the full account name (<em>accountName</em>@<em>domainName</em>) should be specified.</p></div><h3 id="DomainPrivs" tabindex="-1">Domain Administrator Access Rights <a class="header-anchor" href="#DomainPrivs" aria-label="Permalink to &quot;Domain Administrator Access Rights {#DomainPrivs}&quot;">​</a></h3><p>Domain Administrators can perform operations on their own Domains and, optionally, on certain other Domains. The set of allowed operations is defined by the Domain Access Rights explicitly granted to the Domain Administrator Account and listed in the table below:</p><h4 id="domain-settings" tabindex="-1">Domain Settings <a class="header-anchor" href="#domain-settings" aria-label="Permalink to &quot;Domain Settings&quot;">​</a></h4><table tabindex="0"><thead><tr><th><strong>Access Right</strong></th><th><strong>Description</strong></th></tr></thead><tbody><tr><td><code>DomainAccessModes</code></td><td><a href="./../objects/Domains.html#Services">Enabled Services</a></td></tr><tr><td><code>AutoSignup</code></td><td>Provisioning: <a href="./../objects/Domains.html#AutoSignup">Auto-Signup</a> Setting</td></tr><tr><td><code>ExternalOnProvision</code></td><td>Provisioning: <a href="./../objects/Domains.html#ExtAuthProvision">Consult External on Provision</a> Setting</td></tr><tr><td><code>TrailerText</code></td><td>Client Interfaces: <a href="./../objects/Domains.html#WebUser">Mail Trailer Text</a> Setting</td></tr><tr><td><code>WebBanner</code></td><td>WebUser Interface: <a href="./../objects/Domains.html#WebUser">Web Banner Text</a> Setting</td></tr><tr><td><code>WebSitePrefix</code></td><td>WebUser Interface: <a href="./../objects/Domains.html#WebUser">Personal Web Site Prefix</a> Setting</td></tr><tr><td><code>Foldering</code></td><td>Large Domains: <a href="./../objects/Domains.html#Subdirs">Foldering Method</a> Setting</td></tr><tr><td><code>FolderIndex</code></td><td>Large Domains: <a href="./../objects/Domains.html#Subdirs">Generate Index</a> Setting</td></tr><tr><td><code>RenameInPlace</code></td><td>Large Domains: <a href="./../objects/Domains.html#Subdirs">Rename in Place</a> Setting</td></tr><tr><td><code>AllWithForwarders</code></td><td>Mail to All: <a href="./../objects/Domains.html#All">Send to Forwarders</a> Setting</td></tr><tr><td><code>MailToAllAction</code></td><td>Mail to All: <a href="./../objects/Domains.html#All">Distributed for</a> Setting</td></tr><tr><td><code>ExternalOnUnknown</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Consult External for Unknown</a> Setting</td></tr><tr><td><code>MailToUnknown</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Mail to Unknown Names</a> Setting</td></tr><tr><td><code>MailRerouteAddress</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Mail Rerouted to</a> Setting</td></tr><tr><td><code>SignalToUnknown</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Signal to Unknown Names</a> Setting</td></tr><tr><td><code>SignalRerouteAddress</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Signal Rerouted to</a> Setting</td></tr><tr><td><code>AccessToUnknown</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Access to Unknown Names</a> Setting</td></tr><tr><td><code>AccessRerouteAddress</code></td><td>Unknown Names: <a href="./../objects/Domains.html#Unknown">Access Rerouted to</a> Setting</td></tr><tr><td><code>CentralDirectory</code></td><td><a href="./../objects/Domains.html#DirIntegration">Directory Integration</a> Setting</td></tr><tr><td><code>CertificateType</code></td><td>Security: <a href="./../sysadmin/Security.html#DomainKeys">Domain PKI</a> Settings</td></tr><tr><td><code>KerberosKeys</code></td><td>Security: <a href="./../sysadmin/Security.html#Kerberos">Kerberos Keys</a></td></tr><tr><td><code>RelayAddress</code></td><td>SMTP Sending: <a href="./../objects/Domains.html#RelayIP">Send via</a> Setting</td></tr><tr><td><code>ForceSMTPAuth</code></td><td>SMTP Receiving: <a href="./../objects/Domains.html#SMTPAuth">Force AUTH</a> Setting</td></tr><tr><td><code>recipientStatus</code></td><td>SMTP Receiving: <a href="./../objects/Domains.html#VerifyStatus">When Receiving</a> Setting</td></tr><tr><td><code>ServiceClasses</code></td><td>Can create, rename, and remove <a href="./../objects/Accounts.html#ServiceClass">Classes of Service</a></td></tr></tbody></table><h4 id="objects" tabindex="-1">Objects <a class="header-anchor" href="#objects" aria-label="Permalink to &quot;Objects&quot;">​</a></h4><table tabindex="0"><thead><tr><th><strong>Access Right</strong></th><th><strong>Description</strong></th></tr></thead><tbody><tr><td><code>CanCreateAccounts</code></td><td><a href="./../objects/Accounts.html#Create">Create</a>, <a href="./../objects/Accounts.html#Rename">rename</a>, and <a href="./../objects/Accounts.html#Remove">remove</a> Accounts</td></tr><tr><td><code>CanCreateSpecialAccounts</code></td><td>Create <a href="./../objects/Accounts.html#Create">single-mailbox</a> or <a href="./../objects/Accounts.html#Create">Legacy INBOX</a> Accounts</td></tr><tr><td><code>CanCreateGroups</code></td><td>Create, rename, remove, and modify <a href="./../objects/Groups.html">Groups</a></td></tr><tr><td><code>CanCreateForwarders</code></td><td>Manage <a href="./../objects/Forwarders.html">Forwarders</a></td></tr><tr><td><code>CanCreateNamedTasks</code></td><td>Manage <a href="./../objects/NamedTasks.html">Named Tasks</a></td></tr><tr><td><code>CanCreateLists</code></td><td><a href="./../mail/LIST.html#Creating">Create</a>, <a href="./../mail/LIST.html#Rename">rename</a>, and <a href="./../mail/LIST.html#Remove">remove</a> Mailing Lists</td></tr><tr><td><code>CanAccessLists</code></td><td>Modify <a href="./../mail/LIST.html#ConfigList">Mailing Lists</a></td></tr><tr><td><code>CanCreateAliases</code></td><td>Manage <a href="./../objects/#Aliases">Aliases</a></td></tr><tr><td><code>CanCreateTelnums</code></td><td>Manage <a href="./Router.html#Telnums">Telephone Numbers</a></td></tr><tr><td><code>CanPostAlerts</code></td><td>Post Domain and Account <a href="./Alerts.html#Posting">Alerts</a></td></tr><tr><td><code>CanAdminSubDomains</code></td><td>Administer <a href="#SubDomains">other Domains</a></td></tr><tr><td><code>CanModifySkins</code></td><td>Manage <a href="./WebApp.html#Skins">Domain Skins</a></td></tr><tr><td><code>CanModifyPBXApps</code></td><td>Manage <a href="./../../development/PBXApp.html#Editor">Domain Real-Time Applications</a></td></tr><tr><td><code>CanAccessMailboxes</code></td><td>Unrestricted Access to all <a href="./../storage/Mailboxes.html#ACL">Account Mailboxes</a></td></tr><tr><td><code>CanAccessWebSites</code></td><td>Unrestricted Access to all <a href="./../storage/FileStore.html">File Storage</a> files</td></tr><tr><td><code>CanControlCalls</code></td><td>Unrestricted Access to all <a href="./../objects/Accounts.html#AccessRights">Call Control</a> functions</td></tr><tr><td><code>CanCreateWebUserSessions</code></td><td>Manage WebUser sessions via <a href="./../../development/CLI.html#WebSession">CLI</a></td></tr><tr><td><code>CanImpersonate</code></td><td>Ability to <a href="./Security.html#Impersonate">Impersonate</a></td></tr><tr><td><code>CanControlAirSync</code></td><td>Ability to control <a href="./../access/AirSync.html">AirSync</a> clients</td></tr><tr><td><code>CanCreditAccounts</code></td><td>Ability to credit <a href="./../misc/Billing.html">Account Balances</a></td></tr><tr><td><code>CanChargeAccounts</code></td><td>Ability to charge <a href="./../misc/Billing.html">Account Balances</a> and to reserve funds.</td></tr><tr><td><code>CanChargeReserves</code></td><td>Ability to charge fund reserved in <a href="./../misc/Billing.html">Account Balances</a></td></tr></tbody></table><h4 id="account-settings" tabindex="-1">Account Settings <a class="header-anchor" href="#account-settings" aria-label="Permalink to &quot;Account Settings&quot;">​</a></h4><table tabindex="0"><thead><tr><th><strong>Access Right</strong></th><th><strong>Description</strong></th></tr></thead><tbody><tr><td><code>ServiceClass</code></td><td><a href="./../objects/Accounts.html#ServiceClass">Class of Service</a> settings</td></tr><tr><td><code>BasicSettings</code></td><td><a href="./../objects/Accounts.html#Settings">Basic</a> Settings: Password, RealName, <a href="./../directory/CentralDir.html#CustomSettings">Custom</a> and Public Info settings</td></tr><tr><td><code>PSTNSettings</code></td><td><a href="./../signals/PSTN.html">PSTN</a> settings</td></tr><tr><td><code>WebUserSettings</code></td><td><a href="./WebMail.html#Settings">Preferences</a></td></tr><tr><td><code>UseAppPassword</code></td><td>CommuniGate Password: <a href="./../objects/Accounts.html#Passwords">Allow to Use</a></td></tr><tr><td><code>PWDAllowed</code></td><td>CommuniGate Password: <a href="./../objects/Accounts.html#Passwords">Allow to Modify</a></td></tr><tr><td><code>PasswordEncryption</code></td><td>CommuniGate Password: <a href="./../objects/Accounts.html#Passwords">Encryption</a></td></tr><tr><td><code>RequireAPOP</code></td><td>Authentication methods: <a href="./../objects/Accounts.html#Passwords">Secure only</a></td></tr><tr><td><code>UseKerberosPassword</code></td><td><a href="./../objects/Accounts.html#Passwords">Kerberos</a> Authentication</td></tr><tr><td><code>UseCertificateAuth</code></td><td><a href="./../objects/Accounts.html#Passwords">Certificate</a> Authentication</td></tr><tr><td><code>UseSysPassword</code></td><td>Authentication methods: <a href="./../objects/Accounts.html#Passwords">Enable OS Password</a></td></tr><tr><td><code>OSUserName</code></td><td>Authentication methods: <a href="./../objects/Accounts.html#Passwords">Server OS user name</a></td></tr><tr><td><code>UseExtPassword</code></td><td>Authentication methods: <a href="./../objects/Accounts.html#Passwords">External Authentication</a></td></tr><tr><td><code>LogLogin</code></td><td>Logging for login/logout events in a <a href="./Logs.html#Login">Supplementary Log</a></td></tr><tr><td><code>FailedLoginFlows</code></td><td>Authentication: <a href="./../objects/Accounts.html#Passwords">Failed Login Limit</a></td></tr><tr><td><code>AccessModes</code></td><td><a href="./../objects/Accounts.html#Services">Enabled Services</a></td></tr><tr><td><code>MailInpFlow</code></td><td>Mail Transfer options: <a href="./../objects/Accounts.html#Transfer">Incoming Mail Limit</a></td></tr><tr><td><code>MailOutFlow</code></td><td>Mail Transfer options: <a href="./../objects/Accounts.html#Transfer">Outgoing Mail Limit</a></td></tr><tr><td><code>MaxMessageSize</code></td><td>Mail Transfer options: <a href="./../objects/Accounts.html#Transfer">Incoming Message Size Limit</a></td></tr><tr><td><code>MaxMailOutSize</code></td><td>Mail Transfer options: <a href="./../objects/Accounts.html#Transfer">Outgoing Message Size Limit</a></td></tr><tr><td><code>MailToAll</code></td><td>Mail processing options: <a href="./../objects/Accounts.html#Transfer">Accept Mail to all</a></td></tr><tr><td><code>AddMailTrailer</code></td><td>Mail processing options: <a href="./../objects/Accounts.html#Transfer">Add Trailer to Sent Mail</a></td></tr><tr><td><code>QuotaNotice</code></td><td>Mail Quota Processing: <a href="./../objects/Accounts.html#Quota">Send Notice</a></td></tr><tr><td><code>QuotaAlert</code></td><td>Mail Quota Processing: <a href="./../objects/Accounts.html#Quota">Send Alerts</a></td></tr><tr><td><code>QuotaSuspend</code></td><td>Mail Quota Processing: <a href="./../objects/Accounts.html#Quota">Delay New Mail</a></td></tr><tr><td><code>RulesAllowed</code></td><td>Mail processing options: <a href="./../objects/Accounts.html#Rules">Rules</a></td></tr><tr><td><code>RPOPAllowed</code></td><td>Mail processing options: <a href="./../objects/Accounts.html#RPOP">RPOP Accounts</a></td></tr><tr><td><code>MaxAccountSize</code></td><td>Mail Storage limits: <a href="./../objects/Accounts.html#Mail">Mail Storage</a></td></tr><tr><td><code>MaxMailboxes</code></td><td>Mail Storage limits: <a href="./../objects/Accounts.html#Mail">Mailboxes</a></td></tr><tr><td><code>DefaultMailboxType</code></td><td>Mail Storage options: <a href="./../objects/Accounts.html#Mail">New Mailboxes</a></td></tr><tr><td><code>MaxSignalContacts</code></td><td>Signal processing limits: <a href="./../objects/Accounts.html#Signal">Contacts</a></td></tr><tr><td><code>SignalRulesAllowed</code></td><td>Signal processing options: <a href="./../objects/Accounts.html#Signal">Rules</a></td></tr><tr><td><code>CallsLimit</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Concurrent Calls</a> option</td></tr><tr><td><code>CallLogs</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Call Logs</a> option</td></tr><tr><td><code>DialogInfo</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Call Info</a> option</td></tr><tr><td><code>CallInpFlow</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Incoming Calls Limit</a> option</td></tr><tr><td><code>CallOutFlow</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Outgoing Calls Limit</a> option</td></tr><tr><td><code>RSIPAllowed</code></td><td>Signals: <a href="./../signals/PSTN.html#RSIP">RSIP Registrations</a></td></tr><tr><td><code>AirSyncAllowed</code></td><td>Ability to specify which <a href="./../access/AirSync.html">AirSync</a> clients can access the Account.</td></tr><tr><td><code>MaxRosterItems</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">MaxRosterItems</a> option</td></tr><tr><td><code>IMLogs</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">IM Logs</a> option</td></tr><tr><td><code>NotifyOutFlow</code></td><td>Signals: <a href="./../objects/Accounts.html#Signal">Outgoing NOTIFY Requests Limit</a> option</td></tr><tr><td><code>MaxWebSize</code></td><td>File Storage limits: <a href="./../objects/Accounts.html#File">Web Storage</a></td></tr><tr><td><code>MaxFileSize</code></td><td>File Storage limits: <a href="./../objects/Accounts.html#File">Web Storage</a></td></tr><tr><td><code>MaxWebFiles</code></td><td>File Storage limits: <a href="./../objects/Accounts.html#File">Web Files</a></td></tr><tr><td><code>AddWebBanner</code></td><td>File Storage options: <a href="./../objects/Accounts.html#File">Add Web Banner</a></td></tr><tr><td><code>DefaultWebPage</code></td><td>File Storage options: <a href="./../objects/Accounts.html#File">Default Web Page</a></td></tr></tbody></table><h2 id="WebAdminPrefs" tabindex="-1">WebAdmin Preferences <a class="header-anchor" href="#WebAdminPrefs" aria-label="Permalink to &quot;WebAdmin Preferences {#WebAdminPrefs}&quot;">​</a></h2><p>Server and Domain administrators can customize the WebAdmin Interface parameters, including the initial number of objects to be displayed in the Object Lists, the refresh rate for the Monitor pages, etc. The Preferences also specify the character set used for WebAdmin pages. If you plan to use non-ASCII symbols, specify the correct character set first.</p><p>The bottom part of every WebAdmin page contains the name of the authenticated Administrator viewing that page, and the link to the WebAdmin Preferences page.</p><p>Each CommuniGate Pro WebAdmin <em>realm</em> has its own Preferences. Click the Preferences link to open the Preferences page.</p><p>The specified Preferences are stored as one of the Administrator Account Setting attributes, so different administrators can have different Preferences.</p><h2 id="Custom" tabindex="-1">Customizing Domain WebAdmin Interface <a class="header-anchor" href="#Custom" aria-label="Permalink to &quot;Customizing Domain WebAdmin Interface {#Custom}&quot;">​</a></h2><p>The Server Administrator can modify the look and feel of the Domain WebAdmin interface. For each CommuniGate Pro Domain, a custom version of WebAdmin files can be created.</p><p>The WebAdmin Interface uses the same <a href="./../../development/WebApp.html">Skins</a> Interface as the WebUser Interface. The WebAdmin Interface uses the <code>Admin-_xxxxx_</code> Skins.<br> Within those Skins, the <code>admin_yyyyyyyy_</code> files are used to compose pages in the User Realm of the Server WebAdmin Interface, as well as the Domain WebAdmin Interface pages.</p><p>To modify a the Domain WebAdmin Interface pages, upload custom <code>admin_yyyyyyyy_</code> files into the <code>Admin-_xxxxx_</code> Skins. You can create new <code>Admin-_xxxxx_</code> Skins, and select those Skins (shown without the Admin- prefix) in the Domain Administrator Preferences.</p><p>The Server Administrator can also upload custom <code>admin*</code> files into the Server-wide and Cluster-wide Skins.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The Server WebAdmin interface <strong>always</strong> uses the &quot;stock&quot; Skin files located in the WebSkins subdirectory of the <em>application directory</em>. If you modify the WebAdmin interface for the Main Domain, the modified pages will be used when a Domain Administrator of the Main Domain uses the WebAdmin Domain Interface.</p><p>The Server Administrator will see the Server WebAdmin Interface (with the Settings, Domains, Directory, and Monitors realms) and the &quot;stock&quot; Skin files will be used to compose the Server WebAdmin Interface pages.</p></div><h2 id="Strings" tabindex="-1">Customizing Server Prompts <a class="header-anchor" href="#Strings" aria-label="Permalink to &quot;Customizing Server Prompts {#Strings}&quot;">​</a></h2><p>The Server Administrator can modify the protocol prompts and other text strings the CommuniGate Pro Server sends to client applications.</p><p>To modify the Server Strings, open the General pages in the WebAdmin Interface Settings realm, and open the Strings page:<form action="Null.html"><div align="center" class="WebAdmin"><div class="settingsBox"><table width="100%"><tbody><tr align="LEFT"><th>Keyword</th><th>Text</th></tr><tr><td><input type="hidden" name="String" value="0"><input type="hidden" name="n0" value="ACAPByeBye">ACAPByeBye</td><td><input type="radio" name="r0" value="0" checked="checked">CommuniGate Pro ACAP closing connection<br><input type="radio" name="r0" value="1"><input type="text" name="s0" value="" size="40" maxlength="4095"></td></tr><tr><td><input type="hidden" name="String" value="1"><input type="hidden" name="n1" value="ACAPPrompt">ACAPPrompt</td><td><input type="radio" name="r1" value="0" checked="checked">CommuniGate Pro ACAP ^0<br><input type="radio" name="r1" value="1"><input type="text" name="s1" value="" size="40" maxlength="4095"></td></tr><tr><td><input type="hidden" name="String" value="2"><input type="hidden" name="n2" value="FTPByeBye">FTPByeBye</td><td><input type="radio" name="r2" value="0" checked="checked">CommuniGate Pro FTP Server connection closed<br><input type="radio" name="r2" value="1"><input type="text" name="s2" value="" size="40" maxlength="4095"></td></tr><tr><td><input type="hidden" name="String" value="3"><input type="hidden" name="n3" value="FTPPrompt">FTPPrompt</td><td><input type="radio" name="r3" value="0">CommuniGate Pro FTP Server ^0 ready<br><input type="radio" name="r3" value="1" checked="checked"><input type="text" name="s3" value="Welcome to FTP" size="40" maxlength="4095"></td></tr><tr><td colspan="2" align="center" height="30">................................</td></tr><tr><td><input type="hidden" name="String" value="50"><input type="hidden" name="n50" value="SubjectFailed">SubjectFailed</td><td><input type="radio" name="r50" value="0" checked="checked">Undeliverable mail<br><input type="radio" name="r50" value="1"><input type="text" name="s50" value="" size="40" maxlength="4095"></td></tr></tbody></table></div></div></form></p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The actual Strings page has much more elements.</p></div><p>To modify a Server String, enter the new text in the text field, and select the lower radio button.<br> To change the string to its default value (displayed above the text field), simply select the upper radio button.</p><p>Click the Update button to update the Server Strings.</p><h2 id="Backup" tabindex="-1">Backup and Recovery <a class="header-anchor" href="#Backup" aria-label="Permalink to &quot;Backup and Recovery {#Backup}&quot;">​</a></h2><p>The Server data are stored in files, so backups can be easily performed by various third-party utilities.<br> The <a href="./Install.html#Install">base directory</a> with the data can be backed up in whole or by parts.<br> However, different parts require different approaches; some can be copied and restored while the Server is running, others require the Server to be stopped or other additional steps to be taken. Also, different objects have different importance, and as a result, they may have different backup frequency.</p><h3 id="BackupRoot" tabindex="-1">Base directory root objects <a class="header-anchor" href="#BackupRoot" aria-label="Permalink to &quot;Base directory root objects {#BackupRoot}&quot;">​</a></h3><ul><li><p>The <code>Settings</code> directory</p><p>This directory contains files with module and kernel component settings.<br> Recovery requires stopping the server. You can restore individual files with the settings of the corresponding modules.</p></li><li><p>The <code>Queue</code> directory</p><p>This directory contains files with module and kernel component settings.<br> You should not restore the content - this will lead to duplication of messages.</p></li><li><p><code>BadFiles</code> directory</p><p>This directory contains Message files the <a href="./../mail/">Enqueuer kernel component</a> failed to parse. This directory should be empty.<br> There is no point in restoring the contents.</p></li><li><p><code>Submitted</code> directory</p><p>This drop-in directory is used to submit messages to Server via the <a href="./../mail/PIPE.html">PIPE module</a>.<br> You should not restore the content - this will lead to duplication of messages.</p></li><li><p><code>SystemLogs</code> directory</p><p>This directory contains <a href="./Logs.html">Server Logs</a>.<br> It is possible to restore without stopping the server. You can restore individual files, including under a different name.</p></li><li><p><code>Directory</code> directory</p><p>This directory contains the Server <a href="./../services/LDAP.html#Central">Central Directory</a> files.<br> Recovery requires stopping the server.<br> You can restore individual files with the settings of the respective <a href="./../directory/#Units">Directory Storage Units</a>.<br> If the Dicectory contains no custom data then instead of recovering the files the contents of the Directory may be <a href="./../objects/Domains.html#DirIntegration">recreated</a>.</p></li><li><p><code>ProcessID</code> file</p><p>This file exists only when the Server is running and contains the numeric identifier of the Server process in the OS.<br> You should not restore this file.</p></li><li><p><code>Accounts</code> and <code>Domains</code> directories</p><p>These directories contain domain and user data and are the main backup items.<br> Objects should be restored from these directories individually.</p></li></ul><h3 id="BackupDomain" tabindex="-1">Domains <a class="header-anchor" href="#BackupDomain" aria-label="Permalink to &quot;Domains {#BackupDomain}&quot;">​</a></h3><p>Backing up a whole <a href="./../objects/Domains.html">Domain</a> is desirable while the Domain is <a href="./../objects/Domains.html#Suspend">suspended</a>, otherwise some files may be copied in inconsistent state. However, suspension of a Domain means denial of service to all users of that Domain. Therefore, if copying a large domain takes a long time, then this approach may not be appropriate and you need to backup individual Accounts.</p><p>Domain recovery requires Server (Cluster) shutdown. It is possible to restore to a Domain directory with a different name.</p><h3 id="BackupAccount" tabindex="-1">Accounts <a class="header-anchor" href="#BackupAccount" aria-label="Permalink to &quot;Accounts {#BackupAccount}&quot;">​</a></h3><p>Backing up an <a href="./../objects/Accounts.html">Account</a> directory is desirable when the user is not logged in, when incoming messages are not delivered, when files from the <a href="./../storage/FileStore.html">File Storage</a> are not written, etc., otherwise some files may be copied in inconsistent state. To achieve that you may temporary disable the Account <a href="./../objects/Accounts.html#Services">Enabled Services</a> and submit <code>KillAccountSessions</code> command via <a href="./../../development/CLI.html">CLI</a>.</p><p>To automate regular copying of Accounts use the <a href="http://www.communigatepro.ru/CGPCyberBackup/" target="_blank" rel="noreferrer">Backup plugin</a>.</p><p>Recovering the contents of an Account directory may be performed only into existing Account directory; do not create Account directory manually. For that you can create a new Account via <a href="./../objects/Accounts.html#Create">WebAdmin</a> or <a href="./../../development/CLI.html#Account">CLI</a>. Stopping the server is not required, but after restoring the files, it is advisable to submit <code>ClearAccountCache</code> command via <a href="./../../development/CLI.html">CLI</a> because the contents of the <code>account.info</code> and <code>account.settings</code> files may be cached in memory.</p><h3 id="BackupMailbox" tabindex="-1">Mailboxes <a class="header-anchor" href="#BackupMailbox" aria-label="Permalink to &quot;Mailboxes {#BackupMailbox}&quot;">​</a></h3><p>Mailboxes may be of four <a href="./../storage/Mailboxes.html#Formats">Formats</a>:</p><ul><li><a href="./../storage/Mailboxes.html#mbox"><code>Text Format</code></a> - a file with <code>.mbox</code> extension; also there may be files with <code>.flags</code> and <code>.bdx</code> extensions.<br> The <code>.bdx</code> file may be not restored since it&#39;s an index file which can be recreated by the Server.</li><li><a href="./../storage/Mailboxes.html#mdir"><code>MailDir Format</code></a> - a directory with <code>.mdir</code> extension.<br> One should be restored wholly.</li><li><a href="./../storage/Mailboxes.html#mslc"><code>Sliced Format</code></a> - a directory with <code>.mslc</code> extension.<br> One should be restored wholly.</li><li><a href="./../storage/Mailboxes.html#mb4"><code>4th Version Format</code></a> - a directory with <code>.mb4</code> extension.<br> One should be restored wholly.</li></ul><p>You can restore Mailboxes without stopping the server.</p><p>It is advisable to restore a Mailbox as duplicate under a new name, so that the user himself would find the lost messages in the restored Mailbox and copy them to the original Mailbox.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some client applications (including Pronto) may need to reconnect to see the restored Mailboxes.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>For non-mail Mailboxes (calendars, contacts, notes, etc.) the info about the Mailbox type is stored separately in <code>account.info</code> file; therefore, you need to restore over an existing Mailbox of the corresponding type, which you can create a new empty one via <a href="./WebCalendar.html#CreateBox">WebMail</a> or <a href="./../../development/CLI.html">CLI</a> interfaces.</p></div><h3 id="BackupMessages" tabindex="-1">E-mail Messages <a class="header-anchor" href="#BackupMessages" aria-label="Permalink to &quot;E-mail Messages {#BackupMessages}&quot;">​</a></h3><p>To backup or recover a single <a href="./WebMessage.html">Message</a> is possible only from <a href="./../storage/Mailboxes.html#mdir"><code>MailDir Format</code></a> Mailbox. For all cases it is recommended to backup and restore the entire mail folder.</p><p>To recover incoming Messages accidentally deleted by users, use <a href="http://www.communigatepro.ru/CGPJournaler/" target="_blank" rel="noreferrer">Journaling</a>.</p><h3 id="BackupFiles" tabindex="-1">Files <a class="header-anchor" href="#BackupFiles" aria-label="Permalink to &quot;Files {#BackupFiles}&quot;">​</a></h3><p>You can restore Files into the Account <a href="./../storage/FileStore.html">File Storage</a> without stopping the Server.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Some client applications (including Pronto) may need to reconnect to see the restored Files and file folders.</p></div><h2 id="fullTextSearch" tabindex="-1">Full-Text Search <a class="header-anchor" href="#fullTextSearch" aria-label="Permalink to &quot;Full-Text Search {#fullTextSearch}&quot;">​</a></h2><p>CommuniGate Pro supports Full-Text Search that allows you to perform fast and flexible word-form-based queries on the contents of e-mails. This is especially convenient when working with large volumes of mail, when it is important to find the specific messages quickly knowing only some of its content. Full-text Search simplifies navigation through mailboxes and saves time while working with correspondence.</p><h3 id="searchIndex" tabindex="-1">Search Index <a class="header-anchor" href="#searchIndex" aria-label="Permalink to &quot;Search Index {#searchIndex}&quot;">​</a></h3><p>The <a href="#fullTextSearch">Full-Text Search</a> uses a special data structure - Search Index. It is created based on the contents of emails and allows you to perform a quick text search without having to manually go through all the messages each time. Without the Search Index, <a href="#fullTextSearch">Full-Text Search</a> cannot be used.</p><p>The Search Index contains processed information from mailboxes - data such as message body and subject, sender and recipient addresses, flags, labels, and so on. It is automatically updated when new emails arrive or can be manually rebuilt for <a href="./../objects/Domains.html#fullTextSearch">Domain</a>, for <a href="./../objects/Groups.html#fullTextSearch">Group</a>, or for a specific <a href="./../objects/Accounts.html#fullTextSearch">User</a>.</p><p>The disk space used by Search Index depends on the size of mailboxes and the amount of text information in emails. On average, it ranges from 1% to 5% of the total e-mail size, although the exact ratio depends on the structure and content of the specific messages.</p><h3 id="searchIndexEnabling" tabindex="-1">Enabling Search Index <a class="header-anchor" href="#searchIndexEnabling" aria-label="Permalink to &quot;Enabling Search Index {#searchIndexEnabling}&quot;">​</a></h3><p>By default, <a href="#searchIndex">Search Index</a> is disabled and not available to the User. To use <a href="#fullTextSearch">Full-Text Search</a>, it must be enabled for <a href="./../objects/Domains.html#fullTextSearch">Domain</a>, for <a href="./../objects/Groups.html#fullTextSearch">Group</a>, or for a specific <a href="./../objects/Accounts.html#fullTextSearch">User</a>. After that new emails will be indexed automatically.</p><p>To be able to search existing emails, in addition to enabling <a href="#searchIndex">Search Index</a>, you need to index them - this is done once when <a href="#searchIndex">Search Index</a> is enabled. Also, if for some reason the <a href="#searchIndex">Search Index</a> for a User has been disabled, its contents may be out of date and may need to be re-indexed when re-enabled.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Building <a href="#searchIndex">Search Index</a> for large (more than 1 GB) mailboxes can take a significant time. It is recommended to run Indexing during periods of <strong>low server load</strong>, such as nights or weekends.</p></div><h3 id="searchSyntax" tabindex="-1">Query Syntax <a class="header-anchor" href="#searchSyntax" aria-label="Permalink to &quot;Query Syntax {#searchSyntax}&quot;">​</a></h3><p>Search queries may include logical operators to refine search results. The operators <code>AND</code>, <code>OR</code>, <code>NOT</code> allow combining conditions and filtering data according to certain criteria. Operators should be written in capital letters.</p><ul><li><p><code>AND</code></p><p>The <code>AND</code> operator is used to search for documents that contain all the keywords specified in the query. The results will only include documents that match each of the conditions.</p><p><strong>Example</strong>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>foo AND bar</span></span></code></pre></div><p>This query will return only documents that contain both the words “foo” and “bar”.</p></li><li><p><code>OR</code></p><p>The <code>OR</code> operator is used to search for documents that contain at least one of the specified keywords. This operator expands the search results to include documents that match at least one of the conditions.</p><p><strong>Example</strong>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>foo OR bar</span></span></code></pre></div><p>This query will return documents containing either “foo” or “bar” or both.</p></li><li><p><code>NOT</code></p><p>The <code>NOT</code> operator exclude documents that contain the specified keyword from search results. This allows you to narrow your search by excluding unwanted results.</p><p><strong>Example</strong>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>foo NOT bar</span></span></code></pre></div><p>This query will return documents that contain the word “foo” but do not contain the word “bar”.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If no logical operator is specified between two words, the <code>AND</code> operator is applied by default.</p></div><ul><li><p>Grouping</p><p>Search query operators can also be grouped using brackets.</p><p><strong>Example</strong>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>(foo OR bar) NOT baz</span></span></code></pre></div><p>This query will return documents containing either “foo” or “bar” or both, but will exclude documents containing “baz”.</p></li><li><p>Special characters</p><p>The search index uses various special characters to control search query operators. For example, <strong>&amp;&amp;</strong> can be used in place of <strong>AND</strong>, <strong>||</strong> in place of <strong>OR</strong>, and <strong>!</strong> could be used in place of <strong>NOT</strong>.</p><p>It is important to remember that using special characters outside of the context of the search query doesn&#39;t do anything - such characters will be ignored. If they are to be included in the query, they should be escaped with a backslash (<strong>\\</strong>).</p><p>Here is a complete list of special characters that can be used in search queries: <code>+</code> <code>-</code> <code>&amp;&amp;</code> <code>||</code> <code>!</code> <code>(</code> <code>)</code> <code>{</code> <code>}</code> <code>[</code> <code>]</code> <code>^</code> <code>&quot;</code> <code>~</code> <code>*</code> <code>?</code> <code>:</code> <code>\\</code>.</p></li></ul>',84)]))}const g=a(n,[["render",d]]);export{f as __pageData,g as default};
