import{_ as t,c as a,o as n,ag as o}from"./chunks/framework.jCcxW76o.js";const h=JSON.parse('{"title":"CommuniGate Programming Language (CG/PL)","description":"","frontmatter":{"legacyLink":"CGPL.html"},"headers":[],"relativePath":"development/CGPL.md","filePath":"development/CGPL.md"}'),s={name:"development/CGPL.md"};function i(r,e,l,c,d,u){return n(),a("div",null,e[0]||(e[0]=[o(`<h1 id="communigate-programming-language-cg-pl" tabindex="-1">CommuniGate Programming Language (CG/PL) <a class="header-anchor" href="#communigate-programming-language-cg-pl" aria-label="Permalink to &quot;CommuniGate Programming Language (CG/PL)&quot;">​</a></h1><p>The CommuniGate Programming Language (CG/PL) is a powerful, yet simple procedural language. It can be used with various components of the CommuniGate Pro Server software, including:</p><ul><li><a href="./PBXApp.html">Real-Time Applications</a> (such as &quot;IP-PBX&quot;).</li><li><a href="./WebApp.html">Web Applications</a>.</li><li><a href="#SynScripts">Synchronous Scripts</a>.</li></ul><p>The language structure and the language features are the same for all applications, but different applications use different sets of built-in functions and procedures.</p><p>The following is a simple CG/PL program (using the &quot;basic&quot; and &quot;alternative&quot; syntax):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// A simple CG/PL application</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  myName = &quot;Jim&quot; + &quot; &quot; + &quot;Smith&quot;;</span></span>
<span class="line"><span>  if length(myName) &gt; 10 then</span></span>
<span class="line"><span>    myName = Substring(myName,0,8) + &quot;..&quot;;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end;</span></span></code></pre></div><p></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>/*</span></span>
<span class="line"><span> * A simple CG/PL application</span></span>
<span class="line"><span> */</span></span>
<span class="line"><span>entry Main {</span></span>
<span class="line"><span>  myName = &quot;Jim&quot; + &quot; &quot; + &quot;Smith&quot;;</span></span>
<span class="line"><span>  if(myName.length() &gt; 10) {</span></span>
<span class="line"><span>    myName = myName.substring(0,8) + &quot;..&quot;;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h2 id="Data" tabindex="-1">Data Model <a class="header-anchor" href="#Data" aria-label="Permalink to &quot;Data Model {#Data}&quot;">​</a></h2><p>Information is presented as <em>objects</em>. An object can be a <a href="./Data.html#String">string</a>, a <a href="./Data.html#Number">number</a>, a <a href="./Data.html#DataBlock">datablock</a>, a <a href="./Data.html#Date">timestamp</a>, an <a href="./Data.html#IPAddr">ip-address</a>, an <a href="./Data.html#Array">array</a>, a <a href="./Data.html#Dictionary">dictionary</a>, or an <a href="./Data.html#XML">XML object</a>. See the <a href="./Data.html">Data</a> section for more details.</p><p>An object can also be a <a href="#MailboxRef"><em>Mailbox handle</em></a>, a <a href="#MultiTask"><em>Task handle</em></a>, or any other special object defined within a particular environment.</p><p>A special type of object is the <em>null-value</em> (<code>null</code> value or &quot;no object&quot; value).</p><p>When processing logical (<em>boolean</em>) values, the <em>null-value</em> is used as a false-value, and a string &quot;YES&quot; is used as a <em>true-value</em>.</p><h2 id="Lexemes" tabindex="-1">Lexemes <a class="header-anchor" href="#Lexemes" aria-label="Permalink to &quot;Lexemes {#Lexemes}&quot;">​</a></h2><p>The program <em>source code</em> is a plain text encoded using the UTF-8 character set.</p><p>The language lexemes are:</p><ul><li><em>keywords</em> - <code>and</code>, <code>by</code>, <code>elif</code>, <code>else</code>, <code>entry</code>, <code>exitif</code>, <code>external</code>, <code>false</code>, <code>for</code>, <code>forward</code>, <code>function</code>, <code>if</code>, <code>is</code>, <code>not</code>, <code>loop</code>, <code>null</code>, <code>or</code>, <code>procedure</code>, <code>return</code>, <code>spawn</code>, <code>stop</code>, <code>then</code>, <code>true</code>, <code>var</code>, <code>xor</code>, <code>while</code>.<br> All keywords are case-insensitive.</li><li><em>names</em> - sequences starting with alpha-symbols and optionally followed by alpha-symbols, digits, and/or underscore symbols.<br> All names are case-insensitive.<br> The keywords cannot be used as names.</li><li><em>signs</em> - <code>+</code>, <code>-</code>, <code>*</code>, <code>//</code>, <code>/</code>, <code>%</code>, <code>+=</code>, <code>-=</code>, <code>*=</code>, <code>/=</code>, <code>%=</code>, <code>=</code>, <code>==</code>, <code>!=</code>, <code>&lt;</code>, <code>&lt;=</code>, <code>&gt;</code>, <code>&gt;=</code>, <code>!</code>, <code>&amp;</code>, <code>&amp;&amp;</code>, <code>&amp;=</code>, <code>|</code>, <code>||</code>, <code>|=</code>, <code>?</code>, <code>;</code>, <code>,</code>, <code>:</code>, <code>(</code>, <code>)</code>, <code>[</code>, <code>]</code>, <code>{</code>, <code>}</code></li><li><em>numbers</em> - sequences of digits.</li><li><em>strings</em> - quoted strings as specified in the <a href="./Data.html">Data</a> section.</li></ul><p>A comment is a double-slash (<code>//</code>) symbol and all following symbols up to and including the next EOL (end-of-line) symbol.</p><p>A comment is a pair of the slash and star (<code>/*</code>) symbols and all following symbols up to and including the first pair of the star and slash (<code>*/</code>) symbols.</p><p><em>white-space</em> is a sequence of 1 or more space symbols, tabulation symbols, EOL symbols, and/or comments. At least one white space is required between a name and a keyword, other lexemes can be separated with zero or more white spaces.</p><h2 id="Literals" tabindex="-1">Literals <a class="header-anchor" href="#Literals" aria-label="Permalink to &quot;Literals {#Literals}&quot;">​</a></h2><p>Literals are constant values representing themselves. A literal is one of the following:</p><ul><li>a <em>number</em> lexem</li><li>a <em>string</em> lexem</li><li>the <em>null</em> keyword (the null-value)</li><li>the <em>false</em> keyword (the false-value, same as the null-value)</li><li>the <em>true</em> keyword (the true-value)</li></ul><h2 id="ProcDefs" tabindex="-1">Code Sections <a class="header-anchor" href="#ProcDefs" aria-label="Permalink to &quot;Code Sections {#ProcDefs}&quot;">​</a></h2><p>A program code is a set of code sections:</p><ul><li>Entries are code sections executed when the program is activated.</li><li>Procedures and functions are code sections that can be used in (<em>called from</em>) entry code sections, and other procedures and/or functions.</li></ul><p>The procedures and functions can be called <em>recursively</em>: a procedure or a function can call itself - directly or via calling some other procedures or functions.</p><p>All code sections are <em>reenterable</em>: the same code section can be used by several program <em>activations</em> or <em>Tasks</em> at the same time.</p><p>Code sections must be declared before they can be used. Declarations include forward-declarations, external-declarations, and definitions.</p><p>A program code may contain not more than one forward-declaration of a code section, specified before its definition.<br> Forward-definitions are used in programs containing two or more code sections calling each other, so it is not possible to define each section before it is used in the other code section.</p><h3 id="Modules" tabindex="-1">Modules <a class="header-anchor" href="#Modules" aria-label="Permalink to &quot;Modules {#Modules}&quot;">​</a></h3><p>External-declarations allow code sections to call code sections defined in separate program code <em>modules</em>.<br> External-declarations are allowed only in the environments that support them, such as the <a href="./PBXApp.html">Real-Time Application</a> and <a href="./WebApp.html">Web Applications</a> environments. See the environment description for more details.<br> If the external-declaration specifies the code section name as a regular name, when this code section is used, the module with the same name as the code section name is loaded: if the external declaration is<br><code>function myName(param) external;</code><br> and the myName function is called, then the separate program code module &quot;myName&quot; is loaded, and its code section &quot;myName&quot; is called.<br> The external-declaration may contain a qualified name, explicitly specifying the module name: if the external declaration is<br><code>function myModule::myName(param) external;</code><br> and the myModule::myName function is called, then the separate program code module &quot;myModule&quot; is loaded, and its code section &quot;myName&quot; is called.<br> The code section name and its parameter names specified in an external-declaration must match the code section name and its parameter names specified in the code section definition given in an external program code <em>module</em>.<br> The code section definition can specify more parameters than an external-declaration. The missing parameters are assigned null-values when such an external-declaration is used.</p><p>A program code should contain exactly one external-declaration or exactly one definition (but not both) of each code section used.</p><h3 id="Entry" tabindex="-1">Entries <a class="header-anchor" href="#Entry" aria-label="Permalink to &quot;Entries {#Entry}&quot;">​</a></h3><p>An entry declaration consists of the <code>entry</code> keyword, the entry name, followed by one of the following:</p><ul><li><p>for a forward-declaration:</p><p>the <code>forward</code> keyword followed by the semicolon (<code>;</code>) symbol</p></li><li><p>for an entry definition:</p><p>the <code>is</code> keyword followed by an operator sequence, followed by the <code>end</code> keyword (optionally followed by the <code>entry</code> keyword), and followed by the semicolon (<code>;</code>) symbol</p></li><li><p>for an alternative entry definition:</p><p>the left brace (<code>{</code>) symbol followed by an operator sequence, followed by the right brace (<code>}</code>) symbol</p></li></ul><p>If a running program reaches the end of an entry section operator sequence, an implicit <code>stop</code> operator is executed.</p><p>The following example shows an entry for a <a href="./PBXApp.html">Real-Time Application</a>. It tries to accept an incoming call, and if succeeds, it plays a sound. The entry code ends, quitting the program and thus finishing the call:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry main is</span></span>
<span class="line"><span>  if acceptCall() == null then</span></span>
<span class="line"><span>    playFile(&quot;greeting.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>Or, in the alternative form, and using the alternative form of the conditional operator:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry main {</span></span>
<span class="line"><span>  if (acceptCall() == null) {</span></span>
<span class="line"><span>    playFile(&quot;greeting.wav&quot;);</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="Procedure" tabindex="-1">Procedures <a class="header-anchor" href="#Procedure" aria-label="Permalink to &quot;Procedures {#Procedure}&quot;">​</a></h3><p>A procedure declaration consists of the <code>procedure</code> keyword, the procedure name, the left parenthesis, an optional list of parameter names, the right parenthesis, followed by one of the following:</p><ul><li><p>for a forward-declaration:</p><p>the <code>forward</code> keyword followed by the semicolon (<code>;</code>) symbol</p></li><li><p>for a procedure definition:</p><p>the <code>is</code> keyword followed by an operator sequence, followed by the <code>end</code> keyword (optionally followed by the <code>procedure</code> keyword), and followed by the semicolon (<code>;</code>) symbol</p></li><li><p>for an alternative procedure definition:</p><p>the left brace (<code>{</code>) symbol followed by an operator sequence, followed by the right brace (<code>}</code>) symbol</p></li><li><p>for an external-declaration:</p><p>the <code>external</code> keyword followed by the semicolon (<code>;</code>) symbol</p></li></ul><p>If a running program reaches the end of a procedure operator sequence, an implicit <code>return</code> operator is executed.</p><p>The following example shows a <a href="./PBXApp.html">Real-Time Application</a> procedure that speaks the specified number:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure sayNumber(x) is</span></span>
<span class="line"><span>  x = x % 100;</span></span>
<span class="line"><span>  if x &gt;= 10 then</span></span>
<span class="line"><span>    PlayFile(String(x/10*10)+&quot;.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>  if x != 0 then</span></span>
<span class="line"><span>    PlayFile(String(x%10)+&quot;.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end procedure;</span></span></code></pre></div><p>If a forward-declaration is used, the procedure definition must have exactly the same parameters as its forward-declaration.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure sayMoney(x,units) forward;</span></span>
<span class="line"><span>procedure sayNumber(x) forward;</span></span>
<span class="line"><span>procedure sayMoney(x,units) is</span></span>
<span class="line"><span>  sayNumber(x);</span></span>
<span class="line"><span>  PlayFile(units+&quot;.wav&quot;);</span></span>
<span class="line"><span>end procedure;</span></span></code></pre></div><h3 id="Function" tabindex="-1">Functions <a class="header-anchor" href="#Function" aria-label="Permalink to &quot;Functions {#Function}&quot;">​</a></h3><p>A function declaration is the same as a procedure declaration, but the <code>function</code> keyword is used instead of the <code>procedure</code> keyword.</p><p>All program control paths in a function code section must end with a <code>return</code> or a <code>stop</code> operator.</p><p>The following example defines a function calculating the factorial of its argument:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function Factorial(x) is</span></span>
<span class="line"><span>  if x &lt;= 1 then return 1; end if;</span></span>
<span class="line"><span>  return Factorial(x-1)*x;</span></span>
<span class="line"><span>end function;</span></span></code></pre></div><p>Below is the same function definition in the alternative form, using the ternary operator:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function Factorial(x) {</span></span>
<span class="line"><span>  return x &lt;= 1 ? 1 : Factorial(x-1)*x;</span></span>
<span class="line"><span>}</span></span></code></pre></div><p>All code section (entry, procedure, and function) names used within the same program code must be unique.</p><h2 id="Vars" tabindex="-1">Variables <a class="header-anchor" href="#Vars" aria-label="Permalink to &quot;Variables {#Vars}&quot;">​</a></h2><p>Variables are containers. Any object (including a null-value) can be assigned to a variable, and that object becomes the variable value. Initially, the variable value is a null-value.</p><p>Local variables are local to the code section (function/procedure/entry) instance (invocation) where they were created. All their values are destroyed when the code section exits (returns).</p><p>To declare variables, use the <code>var</code> keyword and the list of variable names:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var var1,var2,var3;</span></span></code></pre></div><p>It is possible to declare a local variable and immediately assign it some value, using an initial value expression:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var var1=expr1,var2,var3=expr3;</span></span></code></pre></div><p>Each code section can contain several <code>var</code> declarations. Variables should be used after they are declared (later in the code section code).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var myCount;           // the myCount variable is created</span></span>
<span class="line"><span>myCount = 3;           // the numeric value 3 is assigned to it</span></span>
<span class="line"><span>myCount = myCount + 2; // myCount variable value changed to 5</span></span>
<span class="line"><span>myCount = &quot;Service&quot;;   // myCount variable value changed to a string</span></span></code></pre></div><p>Alternatively, if the code section contains no explicit <code>var</code> declaration, any name used in any code section operator which is not declared as a <a href="#ProcDefs">procedure or function</a> name, and which is not matching a <a href="#BuiltFuncs">built-in</a> procedure or function name declares a variable with this name.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myCount = 3;           // the myCount variable is created and</span></span>
<span class="line"><span>                       // the numeric value 3 is assigned to it</span></span>
<span class="line"><span>myCount = myCount + 2; // myCount variable value changed to 5</span></span>
<span class="line"><span>myCount = &quot;Service&quot;;   // myCount variable value changed to a string</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Declaring a variable inside some &quot;block operator&quot; (such as the <code>if</code> or <code>loop</code> operator) declares this variable only inside this &quot;block operator&quot;.</p></div><p>&quot;Task variables&quot; are stored in a dictionary unique for each Task (&quot;invocation&quot;) created, and they can be used in all code sections, after being declared as Task variables. The Task variables dictionary is destroyed when the Task completes.</p><p>The Task variables are declared using the same <code>var</code> keyword and the variable name list, but these declarations should be placed outside any code section, and they should not contain any initial value expressions.</p><p>The alternative way to use the &quot;task variables&quot; is to access the Task variable dictionary directly, using the <a href="#VarsF"><code>Vars()</code></a> built-in function.</p><h2 id="Const" tabindex="-1">Constants <a class="header-anchor" href="#Const" aria-label="Permalink to &quot;Constants {#Const}&quot;">​</a></h2><p>Constants are names associated with literal values.</p><p>To declare constants, use the <code>const</code> keyword and the list of constant names and their values:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>const c1=1234,c2=&quot;test&quot;,cFlag=true;</span></span></code></pre></div><p>When the constant name is used, the value associated with it is substituted.</p><h2 id="Exprs" tabindex="-1">Expressions <a class="header-anchor" href="#Exprs" aria-label="Permalink to &quot;Expressions {#Exprs}&quot;">​</a></h2><p>The language implements unary operations. Unary operations are specified as</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>operation operand</span></span></code></pre></div><p>The following unary operations are supported:</p><ul><li><p><code>-</code></p><p>unary minus. If the operand value is a number, operation value is the number with the opposite sign, otherwise the operation value is the number 0.<br> The following expressions have the value of -5:</p><p><code>-5</code><br><code>-(3+2)</code></p></li><li><p><code>+</code></p><p>unary plus. If the operand value is a number, operation value is that number, otherwise the operation value is the number 0.<br> The following expressions have the value of 5:</p><p><code>+5</code><br><code>+(10/2)</code></p></li><li><p><code>not</code></p><p>Negation. If the operand value is a null-value, the operation value is a true-value, otherwise the operation value is a null-value.<br> The <code>!</code> symbol can be used instead of the <code>not</code> keyword.<br> The following expressions have the value of &quot;YES&quot;:</p><p><code>not null</code><br><code>!(2 == 3)</code></p></li></ul><p>The unary operations have a higher priority than binary and ternary operations.</p><p>The following expression has the value of -1, not -3:</p><p><code>-2 + 1</code></p><p>The language implements binary operations. Binary operations are specified as</p><blockquote><p><em>left-operand</em> <em>operation</em> <em>right-operand</em></p></blockquote><p>Unless explicitly specified otherwise, both operands are computed first (in a non-specified order), and the operation is applied to the operand values.</p><p>The following binary operations are supported, listed in the descending priority order:</p><ul><li><p><code>*</code>, <code>/</code>, <code>%</code></p><p>These arithmetic operations can be applied to numeric operand values only.<br> If one of the operands is not a Number, or if the right operand of the <code>/</code> or <code>%</code> operations is number 0, the operation value is a null-value.<br> The following expressions have the value of 10:</p><p><code>5 * 2</code><br><code>-20 / -2</code><br><code>30 % 20</code></p></li><li><p><code>+</code>, <code>-</code></p><p>These arithmetic operations can be applied to numeric operand values.<br> The <code>+</code> operation can be applied to a pair of string operand values, producing a string value with their catenation.<br> The <code>+</code> operation can be applied to a pair of datablock operand values, producing a datablock value with their catenation.<br> The <code>+</code> operation can be applied to a datablock and a string value operands, producing a datablock copy with the string bytes added to the datablock end.<br> The <code>+</code> operation can be applied to a datablock and a numeric value operands, where the numeric value should be in the 0..255 range, producing a datablock copy with an additional byte (containing the numeric operand value) added to the datablock end.<br> The <code>+</code> operation can be applied to a timestamp and a numeric value operands, producing a timestamp value that is the numeric value seconds later than the timestamp operand value.<br> The <code>-</code> operation can be applied to a left operand with a timestamp value and a right operand with a numeric value, producing a timestamp value that is the numeric value seconds earlier than the timestamp operand value.<br> The <code>-</code> operation can be applied to a pair or operands with timestamp values, producing a numeric value - the number of seconds between the left and the right operand values.<br> In other cases the operation value is a null-value.<br> The following expressions have the value of 5:</p><p><code>3 + 2</code><br><code>-2 - -7</code></p><p>The following expression has the value of &quot;John Doe&quot;:</p><p><code>&quot;Joh&quot; + &quot;n Doe&quot;</code></p></li><li><p><code>&lt;</code>, <code>&lt;=</code>, <code>==</code>, <code>!=</code>, <code>&gt;=</code>, <code>&gt;</code></p><p>These comparison operations can be applied to a pair of numeric operands, to produce a true-value when the arithmetic comparison condition is met.<br> These comparison operations can be applied to a pair of timestamp operands, to produce a true-value when the arithmetic comparison condition is met.<br> These comparison operations can be applied to a pair of string operands, to produce a true-value when the arithmetic comparison condition is met. Strings are interpreted as sequences of UTF-8 encoded 16-bit Unicode symbols, compared symbol by symbol.<br> These comparison operations can be applied to a pair of datablock operands, to produce a true-value when the arithmetic comparison condition is met. Datablocks are interpreted as sequences on bytes (with values in the 0..255 range), compared byte by byte.<br> The <code>==</code>, <code>!=</code> comparison operations can also be applied to any pair of objects, checking if they are &quot;equal&quot;:</p><ul><li>A null-value is equal to and only to a null-value.</li><li>Numbers are equal if their numeric values are equal.</li><li>Strings are equal if they have the same length and have the same symbol in each string position.</li><li>Datablocks are equal if they have the same length and have the same data byte in each datablock position.</li><li>Arrays are equal if they have the same number of elements and elements in each position are equal.</li><li>Dictionaries are equal if they have the same number of key-value pairs, the key strings are equal, and the values for each key are equal in both dictionaries.</li><li>For all other object types any object is equal to itself only (no two different objects are considered equal).</li></ul><p>In other cases the comparison operation value is a null-value.<br> The following expressions have the value of &quot;YES&quot;:</p><p><code>1+2 == 3</code><br><code>2+2 != 3</code><br><code>2+2 &gt;= 3</code><br><code>&quot;Joe&quot; == &quot;Joe&quot;</code><br><code>null == (2 == 3)</code></p></li><li><p><code>and</code>, <code>or</code>, <code>xor</code>, <code>and then</code>, <code>or else</code></p><p>these logical operations compare their operands with null-values.<br> The <code>and</code> operation value is a true-value if both operand values are not null-values, and a null-value otherwise.<br> The <code>&amp;</code> symbol can be used instead of the <code>and</code> keyword.<br> The <code>or</code> operation value is a true-value if at least of the operand values is not a null-value, and a null-value otherwise.<br> The <code>|</code> symbol can be used instead of the <code>or</code> keyword.<br> The <code>xor</code> operation value is a null-value if none or both operand values are null-values. Otherwise, the operation value is the operand value that is not a null-value.<br> The <code>^</code> symbol can be used instead of the <code>xor</code> keyword.<br> The <code>and then</code> operation computes the left operand value first. If that value is a null-value, the right operand is not computed, and the operation value is a null-value. Otherwise the right operand is computed and its value becomes the operation value.<br> The <code>&amp;&amp;</code> symbols can be used instead of the <code>and then</code> keywords.<br> The <code>or else</code> operation computes the left operand value first. If that value is not a null-value, the right operand is not computed, and the left operand value becomes the operation value. Otherwise the right operand is computed and its value becomes the operation value.<br> The <code>||</code> symbols can be used instead of the <code>or else</code> keywords.<br> The following expressions have the value of &quot;YES&quot;:</p><p><code>1+2 == 3 &amp; 2+2 == 4</code><br><code>2+2 == 3 or else 7-5 == 2</code><br><code>false ^ true</code></p></li></ul><p>The binary operations of the same priority group left-to-right: <code>X op Y op Z</code> is the same as <code>( X op Y ) op Z</code></p><p>The binary operations have a higher priority than the ternary operations.</p><p>The language implements one ternary operation:</p><ul><li><p><code>cond ? expr1 : expr2</code></p><ul><li>the <em>cond</em> operand is computed.</li><li>If the computed value is not a null-value, the <em>expr1</em> operand is computed and its value becomes the operation value.</li><li>Otherwise the <em>expr2</em> operand is computed and its value becomes the operation value.</li></ul><p>The following expressions have the value of &quot;Good&quot;:</p><p><code>3 == 3 ? &quot;Good&quot; : &quot;Bad&quot;</code><br><code>null ? 77777 : &quot;Good&quot;</code></p></li></ul><p>The ternary operation groups right-to-left: <code>A ? B : C ? D : E</code> is the same as <code>A ? B : (C ? D : E)</code></p><p>The language implements the indexing operation:</p><p><code>object[index]</code></p><ul><li><p>where</p><p>the <em>object</em> expression should have an array, a dictionary value, a string value, or a datablock (otherwise the operation results in a program exception), and the <em>index</em> expression should have a numeric value smaller than the number of <em>object</em> elements, or the length of the <em>object</em> string or datablock.<br> If the <em>object</em> expression value is an array, the operation references the array element number <em>index</em> (the first element has the number 0).<br> Retrieving an element that does not exist results in a null-value.<br> Assigning a new value to the first array element that does not exist adds the value to the array as a new element.<br> An attempt to assign a new value to any other non-existing array element results in a program exception.<br> If SquareArray value is (1,4,9,16,25), the following expression has the value of 9:</p></li></ul><p><code>SquareArray[2]</code></p><p>while the following operator:</p><p><code>SquareArray[5] = &quot;Blue&quot;;</code></p><p>changes the SquareArray value to <code>(1,4,9,16,25,&quot;Blue&quot;)</code>.</p><p>If the <em>object</em> expression value is a dictionary, the operation references the dictionary key number <em>index</em> (the first key has the number 0).<br> Retrieving a key that does not exist results in a null-value.<br> An attempt to assign a new value to a referenced key results in a program exception.</p><p>If SquareDictionary value is <code>{&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}</code>, the following expression has the value of <code>&quot;three&quot;</code>:</p><p><code>SquareDictionary[2]</code></p><p>If the <em>object</em> expression value is a string, the operation returns a 1-byte string containing the string symbol number <em>index</em> (the first string symbol has the number 0).<br> Retrieving a symbol that does not exist results in a null-value.<br> An attempt to assign a new value to any string symbol results in a program exception.<br> If SquareString value is &quot;grass&quot;, the following expression has the value of &quot;r&quot;:</p><p><code>SquareString[1]</code></p><p>If the <em>object</em> expression value is a datablock, the operation returns a number representing the datablock byte number <em>index</em> (the first datablock byte has the number 0).<br> Datablock bytes have unsigned numeric values in the 0..255 range.<br> Retrieving a byte that does not exist results in a null-value.<br> An attempt to assign a new value to any datablock byte results in a program exception.</p><p>The language implements the key, or dictionary-element operation:</p><p><code>dictionary.keyName</code></p><ul><li><p>where</p><p>the <em>dictionary</em> expression should have a dictionary value (otherwise the operation results in a program exception), and the <em>keyName</em> is a name.<br> The operation references the <em>dictionary</em> element with the key <em>keyName</em>.<br> Retrieving an element for a key that does not exist results in a null-value.<br> Assigning a null-value to a key results in the key-value pair being removed from the dictionary.<br> Assigning a non-null-value to a key that does not exist results in a new key-value pair being added to the dictionary.<br> If SquareDictionary value is <code>{&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}</code>, the following expression has the value of 9:</p></li></ul><p><code>SquareDictionary.three</code></p><p>and the following expression has the value of null:</p><p><code>SquareDictionary.four</code></p><p>The language implements the computed key, or dictionary-element operation:</p><p><code>dictionary.(keyExpr)</code></p><ul><li><p>where</p><p>the <em>dictionary</em> expression should have a dictionary value, and the <em>keyExpr</em> expression should have a string value (otherwise the operation results in a program exception).<br> The operation references the <em>dictionary</em> element for the <em>keyExpr</em> key.<br> If SquareDictionary value is <code>{&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}</code>, the following expression has the value of 9:</p></li></ul><p><code>SquareDictionary.(&quot;th&quot; + &quot;ree&quot;)</code></p><p>The language implements function calls. A function call is specified as a name followed by parentheses optionally containing a list of expressions (<em>parameter-expressions</em>):</p><p><code>functionName()</code><br><code>functionName(arg1)</code><br><code>functionName(arg1,arg2,...)</code></p><p>The <em>functionName</em> should be a name of a <a href="#BuiltFuncs">built-in function</a> or an already <a href="#ProcDefs">defined function</a>.<br> Parameter expressions (if any) are computed, and the function code is executed using the parameter expression values.<br> A function result is an object, and the indexing and dictionary-element operations can be applied to a function result.</p><p>If MyFunction function has 2 parameters and its returned value is an array <code>(1,&quot;four&quot;,9)</code>, the following expression has the value of &quot;four&quot;:</p><p><code>MyFunction(myData,&quot;zzz&quot;)[1]</code></p><p>A function with one or more parameters can be called as a <em>method</em>:</p><p><code>arg1.functionName()</code><br><code>arg1.functionName(arg2)</code><br><code>arg1.functionName(arg2,arg3,...)</code></p><p>The MyFunction function call (see above) can be expressed as a method:</p><p><code>myData.MyFunction(&quot;zzz&quot;)[1]</code></p><h2 id="Opers" tabindex="-1">Operators <a class="header-anchor" href="#Opers" aria-label="Permalink to &quot;Operators {#Opers}&quot;">​</a></h2><p>An operator sequence contains zero or more operators, followed by the semicolon (<code>;</code>) symbol.</p><p>An empty operator performs no action:</p><p><code>;</code></p><p>A null operator consists of the keyword <code>null</code>. It performs no action:</p><p><code>null;</code></p><p>An assignment operator consists of a data container reference (a variable, an array element, or a dictionary element), the assignment operation, and an expression. The expression and the data container reference are computed (in an unspecified order), and the expression value is used to modify the data container.<br> The <code>=</code> operation assigns the expression value to the data container.</p><p><code>myVar = 123 + 111;</code><br><code>myVar = &quot;string&quot;;</code></p><p>Other assignment operations consist of a binary operation symbol and the <code>=</code> symbol. They apply the corresponding binary operation to the current data container value and the expression value, and store the result in the data container.</p><p><code>myVar[123] += 123; myVar.message += &quot;, program stopped&quot;;</code></p><p>If a data container reference is an array element, that element must exist or it must be the first non-existent array element, i.e. if an array has 3 elements, you can assign values to elements number 0,1,2, and 3. In the last case, a new element is added to the array.</p><p>If a data container reference is a dictionary element, assigning a null-value effectively removes the element from the dictionary.</p><p>A procedure call operator is specified in the same way as a function call expression. The name used should be a name of a <a href="#BuiltFuncs">built-in procedure</a> or an already <a href="#ProcDefs">defined procedure</a>.</p><p>If MyProc procedure has 2 parameters, the following operator is a correct procedure call:</p><p><code>MyProc(myData,&quot;zzz&quot;);</code></p><p>For procedure with one or more parameters, a call operator can be specified as a <em>method</em>:</p><p><code>arg1.procedureName()</code><br><code>arg1.procedureName(arg2)</code><br><code>arg1.procedureName(arg2,arg3,...)</code></p><p>The MyProc call (see above) can be specified as a method:</p><p><code>myData.MyProc(&quot;zzz&quot;);</code></p><p>A stop operator terminates the Task execution. It consists of the <code>stop</code> keyword:</p><p><code>stop;</code></p><p>A return operator finishes function or procedure execution.<br> A return operator within a function consists of the <code>return</code> keyword and an expression. This expression is computed and its value becomes the value of the function call.</p><p><code>return 12*year+month;</code></p><p>A return operator within a procedure consists of the <code>return</code> keyword.</p><p><code>return;</code></p><p>A conditional operator consists of the <code>if</code> keyword followed by an expression (<em>if-expression</em>), the <code>end</code> keyword, an operator sequence (<em>if-sequence</em>), and the <code>end</code> keyword optionally followed by the <code>if</code> keyword.<br> The <em>if-expression</em> is computed, and if its value is not a null-value, the <em>if-sequence</em> is executed, and the conditional operation execution ends.</p><p>The following example increases the myCount variable value by 2 if its value is less than 10:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>A conditional operator can optionally contain one or more <em>elif-portions</em> after the <em>if-sequence</em>. Each <em>elif-portion</em> consists of the <code>elif</code> keyword, an expression (<em>elif-expression</em>), the <code>then</code> keyword, and an operator sequence (<em>elif-sequence</em>).<br> If the <em>if-expression</em> value is a null-value, the first <em>elif-expression</em> is computed, and if its value is not a null-value, its <em>elif-sequence</em> is executed and the conditional operation execution ends. If the <em>elif-expression</em> value is a null-value, the next <em>elif-portion</em> is processed.<br> In the following example the myCount variable value is checked. If the value is less than 10, the variable value is increased by 2. Otherwise (i.e. if the variable value is not less than 10), if the value is less than 20, it is decreased by 3:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>elif myCount &lt; 20 then</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>A conditional operator can optionally contain an else-portion. It is specified after the if-sequence and after all optional elif-portions. The else-portion consists of the <code>else</code> keyword and an operator sequence (<em>else-sequence</em>).<br> If the if-expression value is a null-value, and all optional elif-expression values are null-values, the else-sequence is executed and the conditional operator execution ends.<br> The following example increases the myCount variable value by 2 if the value is less than 10, it decreases the variable value by 3 if the value is not less than 10, but it is less than 20, and the variable value is multiplied by 4 in all other cases:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>elif myCount &lt; 20 then</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>else</span></span>
<span class="line"><span>  myCount = myCount * 4;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>The loop operator consists of an optional preamble, the <code>loop</code> keyword, an operator sequence (<em>initial sequence</em>), and the <code>end</code> keyword optionally followed by the <code>loop</code> keyword.<br> Operators in the sequence are executed repeatedly.<br> A preamble for a <em>while-loop</em> is the <code>while</code> keyword and an expression (<em>while-expression</em>).<br> The while-expression is computed every time before the operator sequence is executed. If the while-expression result is a null-value, the loop operator ends.<br> A preamble for a <em>for-loop</em> is the <code>for</code> keyword optionally followed by an <em>initializer operator</em>, optionally followed by the <code>while</code> keyword and an expression (<em>while-expression</em>), optionally followed by the <code>by</code> keyword and an assignment operator (the <em>iterator operator</em>).<br> The <em>initializer operator</em> is either an assignment operator, or the <code>var</code> keyword followed by variable declarations. In the later case, these variables can be used only in the <em>while-expression</em>, <em>iterator operator</em>, and inside the loop operator sequence.<br> If the <em>initializer operator</em> is specified, it is executed once, when the <code>loop</code> operator starts.<br> If the <em>while-expression</em> is specified, it is computed every time before the <code>loop</code> operator sequence is executed. If the while-expression result is a null-value, the loop operator ends.<br> If the <em>iterator operator</em> is specified, it is executed every time after the <code>loop</code> operator sequence is executed.</p><p>The following example checks the myCount variable value and keeps increasing it by 2 while that value is less than 10:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>while myCount &lt; 10 loop</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>The following example calls the myProc procedure in an unconditional loop:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>loop</span></span>
<span class="line"><span>  myProc(2,&quot;test.wav&quot;);</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>The following example calls the myProc procedure 3 times, with parameter values 5,7,9:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>for i = 5 while i &lt; 10 by i += 2 loop</span></span>
<span class="line"><span>  myProc(i);</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>The loop operator can optionally contain one or more <em>exitif-portions</em> between the initial sequence and the <code>end</code> keyword. Each <em>exitif-portion</em> consists of the <code>exitif</code> keyword, followed by an expression (<em>exitif-expression</em>), the semicolon (<code>;</code>) symbol, and an operator sequence. After the initial sequence is executed, the first exitif-expression is computed. If its value is not null, the <code>loop</code> operator execution ends. Otherwise the exitif operator sequence is executed, and the next <em>exitif expression</em> is computed. After the last exitif operator sequence is executed, the <code>loop</code> operator execution repeats.</p><p>The following example appends the &quot;aaa&quot; string to the myWord variable, checks the variable lengths, and if the length is less than 20, appends the &quot;bbb&quot; string to the myWord variable, and repeats the process:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>loop</span></span>
<span class="line"><span>  myWord += &quot;aaa&quot;;</span></span>
<span class="line"><span>exitif length(myWord) &gt;= 20;</span></span>
<span class="line"><span>  myWord += &quot;bbb&quot;;</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><h3 id="alternative-forms" tabindex="-1">Alternative Forms <a class="header-anchor" href="#alternative-forms" aria-label="Permalink to &quot;Alternative Forms&quot;">​</a></h3><p>Some operators in a sequence may be presented in an <em>alternative</em> form. Operators in an <em>alternative</em> form are not followed by the semicolon symbol.</p><p>The alternative form of a conditional operator consists of the <code>if</code> keyword followed by an expression (<em>if-expression</em>), and an operator sequence (<em>if-sequence</em>) enclosed in left (<code>{</code>) and right (<code>}</code>) brace symbols.<br> The alternative form of a conditional operator can optionally contain one or more elif-portions after the enclosed if-sequence. Each elif-portion consists of the <code>elif</code> keyword, an expression (<em>elif-expression</em>), and an operator sequence (elif-sequence), enclosed into braces.<br> The alternative form of a conditional operator can optionally contain an else-portion. It is specified after the enclosed if-sequence and after all optional elif-portions. The else-portion consists of the <code>else</code> keyword and an operator sequence (<em>else-sequence</em>) enclosed in braces.</p><p>The following example increases the myCount variable value by 2 if the value is less than 10, it decreases the variable value by 3 if the value is not less than 10, but it is less than 20, and the variable value is multiplied by 4 in all other cases:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if (myCount &lt; 10) {</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>} elif (myCount &lt; 20) {</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>} else {</span></span>
<span class="line"><span>  myCount = myCount * 4;</span></span>
<span class="line"><span>}</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It is not required to use parentheses to enclose if-expressions or elif-expressions.</p></div><p>The alternative form of a while-loop operator consists of the <code>while</code> keyword, an expression (<em>while-expression</em>), the left brace (<code>{</code>) symbol, an operator sequence (<em>initial sequence</em>), zero or more exitif-portions and a right brace (<code>}</code>) symbol.<br> The alternative form of a for-loop operator consists of the <code>for</code> keyword, the left parenthesis (<code>(</code>) symbol, an optional <em>initializer operator</em>, the semicolon (<code>;</code>) symbol, an optional <em>while-expression</em>, the semicolon (<code>;</code>) symbol, an optional <em>iterator operator</em>, the right parenthesis (<code>)</code>) symbol, the left brace (<code>{</code>) symbol, an operator sequence (<em>initial sequence</em>), zero or more exitif-portions and a right brace (<code>}</code>) symbol.<br> Each optional exitif-portion consists of the <code>exitif</code> keyword, followed by an expression (exitif-expression), the semicolon (<code>;</code>) symbol, and an operator sequence.</p><p>The following example appends the &quot;aaa&quot; string to the myWord variable, checks the variable lengths, and if the length is less than 20, appends the &quot;bbb&quot; string to the myWord variable, and repeats the process:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>while ( true ) {</span></span>
<span class="line"><span>  myWord = myWord + &quot;aaa&quot;;</span></span>
<span class="line"><span>exitif (length(myWord) &gt;= 20);</span></span>
<span class="line"><span>  myWord = myWord + &quot;bbb&quot;;</span></span>
<span class="line"><span>}</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It is not required to use parentheses to enclose while-expressions or exitif-expressions.</p></div><p>The following example assigns the factorial of the variable X value to the myFactor variable.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myFactor = 1;</span></span>
<span class="line"><span>for(i = 0; i &lt;= X; i += 1) {</span></span>
<span class="line"><span>  myFactor *= i;</span></span>
<span class="line"><span>}</span></span></code></pre></div><h2 id="BuiltFuncs" tabindex="-1">Built-in Procedures and Functions <a class="header-anchor" href="#BuiltFuncs" aria-label="Permalink to &quot;Built-in Procedures and Functions {#BuiltFuncs}&quot;">​</a></h2><p>The following procedures and functions are built into the language, and they are available to all applications. You should not use their names for user-defined procedures or functions.</p><ul><li><p><code>Same(arg1,arg2)</code></p><p>This function returns a true-value if the values of <em>arg1</em> and <em>arg2</em> are the same object or if both values are null-values or both values are true-values. In other cases the function returns a null-value.<br> The value of <code>Same(&quot;J&quot; + &quot;ack&quot;,&quot;Jack&quot;)</code> is a null-value.<br> In the following example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>x = &quot;my string&quot;;</span></span>
<span class="line"><span>y = &quot;my string&quot;;</span></span>
<span class="line"><span>z = x;</span></span>
<span class="line"><span>test1 = Same(x,y);</span></span>
<span class="line"><span>test2 = Same(x,x);</span></span>
<span class="line"><span>test3 = Same(x,z);</span></span></code></pre></div><p>the resulting value of <code>test1</code> is a null-value, while the values of <code>test2</code> and <code>test3</code> are true-values.</p></li><li><p><code>Copy(arg)</code></p><p>If the <em>arg</em> value is a null-value, this function returns a null-value.<br> Otherwise, the function returns the copy of the <em>arg</em> value.<br> For complex objects (such as arrays, dictionaries, XML objects), this function copies all complex object elements, too.</p></li><li><p><code>Length(arg)</code></p><p>If <em>arg</em> is a string, this function returns the string size (in bytes);<br> If <em>arg</em> is a datablock, this function returns the datablock size (in bytes);<br> If <em>arg</em> is an array, this function returns the number of array elements;<br> If <em>arg</em> is a dictionary, this function returns the number of dictionary keys;<br> If <em>arg</em> is a Mailbox handle, this function returns the number of messages in the Mailbox;<br> In all other cases, this function returns the number 0.</p></li><li><p><code>Min(arg1,arg2)</code></p><p>If the <em>arg1</em> value <code>&lt;</code> the <em>arg2</em> value, then the function returns the <em>arg1</em> value, otherwise it returns the <em>arg2</em> value.<br> See above for the <code>&lt;</code> operation definition.</p></li><li><p><code>Max(arg1,arg2)</code></p><p>If the <em>arg1</em> value <code>&gt;</code> the <em>arg2</em> value, then the function returns the <em>arg1</em> value, otherwise it returns the <em>arg2</em> value.<br> See above for the <code>&gt;</code> operation definition.</p></li><li><p><code>Void(arg1)</code></p><p>This procedure does nothing, it just discards the <em>arg1</em> value. Use this procedure when you need to call a function, but you do not want to use the function result.</p></li><li><p><code>ProcCall(name)</code><br><code>ProcCall(name,arg1)</code><br><code>ProcCall(name,arg1,arg2)</code><br><code>ProcCall(name,arg1,....)</code></p><p>This procedure has 1 or more parameters. The <em>name</em> value should be a string, it specifies a simple or a qualified external procedure name.<br> This external procedure is called, using the remaining parameters as its parameters.<br> There is no need to use external-declarations for procedures called this way.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ProcCall(&quot;myModule::myProc&quot;,123,&quot;2222&quot;);</span></span></code></pre></div><p>is the same as</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure myModule::myProc(x,y) external;</span></span>
<span class="line"><span>myModule::myProc(123,&quot;2222&quot;);</span></span></code></pre></div></li><li><p><code>FuncCall(name)</code><br><code>FuncCall(name,arg1)</code><br><code>FuncCall(name,arg1,arg2)</code><br><code>FuncCall(name,arg1,....)</code></p><p>This function has 1 or more parameters. The <em>name</em> value should be a string, it specifies a simple or a qualified external function name.<br> This external function is called, using the remaining parameters as its parameters.<br> There is no need to use external-declarations for functions called this way.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>x = FuncCall(&quot;myModule::myFunc&quot;,123,&quot;2222&quot;);</span></span></code></pre></div><p>is the same as</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function myModule::myFunc(x,y) external;</span></span>
<span class="line"><span>x = myModule::myFunc(123,&quot;2222&quot;);</span></span></code></pre></div></li><li><p><code>objectClass(arg)</code></p><p>the function returns a string with the name of the class the <em>arg</em> value belongs to (&quot;SharedString&quot; for strings, &quot;SharedNumber&quot; for numbers, &quot;SharedDate&quot; for timestamps, &quot;SharedData&quot; for datablocks, etc.)</p></li></ul><h3 id="Strings" tabindex="-1">Strings <a class="header-anchor" href="#Strings" aria-label="Permalink to &quot;Strings {#Strings}&quot;">​</a></h3><ul><li><p><code>IsString(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a string, otherwise the function returns a null-value.</p></li><li><p><code>String(arg)</code></p><p>If the <em>arg</em> value is a string, this function returns this string.<br> If the <em>arg</em> value is a number, this function returns a string with the decimal representation of that number.<br> If the <em>arg</em> value is a datablock, this function returns a string with the datablock content (interpreted as textual data).<br> If the <em>arg</em> value is a timestamp, this function returns a string with the system-standard timestamp text representation.<br> If the <em>arg</em> value is an ip-address, this function returns a string with the canonical representation of that network address.<br> If the <em>arg</em> value is an XML Object, this function returns the XML object text body (&quot;text node&quot;).<br> If the <em>arg</em> value is a null-value, this function returns a null-value.<br> In all other cases, this function returns a string with a textual representation of the <em>arg</em> value.</p></li><li><p><code>Substring(str,from,len)</code></p><p>If the <em>str</em> value is a string, and the <em>from</em> value is a number, and the <em>len</em> value is a non-negative number, this function returns a string that is a substring of the <em>str</em> value, with the <em>len</em> length.<br> If <em>from</em> has a non-negative value, the substring starts at the <em>from</em> position (the first symbol of the string has the position 0).<br> If <em>from</em> is a negative value, then the substring ends at the -1-<em>from</em> position from the string end (to include the last <em>str</em> symbol(s), <em>from</em> should be -1).<br> If the <em>from</em> value (or -1-<em>from</em> value) is equal to or greater than the <em>str</em> value length, the result is an empty string.<br> If the <em>from</em> + <em>len</em> (or -1-<em>from</em> + <em>len</em>) value is greater than the <em>str</em> value length, the resulting string is shorter than <em>len</em>.<br> In all other cases this function returns a null-value.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This function interprets a string as a sequence of bytes, and thus it can break non-ASCII symbols which are stored as a multi-byte sequence.</p></div></li><li><p><code>FindSubstring(str,substr)</code><br><code>FindSubstring(str,substr,offset)</code></p><p>The <em>str</em> and <em>substr</em> values should be strings, while the <em>offset</em> should be a number. The function checks if the <em>substr</em> value is a substring of the <em>str</em> value.<br> If the <em>offset</em> parameter is specified and its value is greater than zero, then the search ignores the first <em>offset</em> bytes of the <em>str</em> string value, and the position of the first found substring in the <em>str</em> value is returned.<br> If the <em>offset</em> parameter is specified and its value is less than zero, then the search ignores the last -1-<em>offset</em> bytes of the <em>str</em> string value, and the position of the last found substring in the <em>str</em> value is returned.<br> All positions start with 0.<br> If no substring is found, this function returns the number -1.<br> Example 1. The value of <code>FindSubstring(&quot;forest&quot;,&quot;for&quot;)</code> is 0.<br> Example 2. The value of <code>FindSubstring(&quot;A forest&quot;,&quot;for&quot;)</code> is 2.<br> Example 3. The value of <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;,1)</code> is 2.<br> Example 4. The value of <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;,4)</code> is 9.<br> Example 5. The value of <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;,-3)</code> is 9.<br> Example 6. The value of <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;,-5)</code> is 2.</p></li><li><p><code>Range(str,from,len)</code></p><p>This function works in the same way as the <code>Substring</code> function, but if the <em>str</em> value is a string, it is interpreted as a sequence of &quot;glyphs&quot; - single and multi-byte sequences representing ASCII and non-ASCII symbols. The <em>from</em> and <em>len</em> values specify the substring position and length in terms of symbols, rather than bytes.<br> If the <em>str</em> value is a datablock, the function returns a datablock containing a portion of the <em>str</em> value, cut using the same rules, while the <em>from</em> and <em>len</em> values specify the position position and length in bytes.</p></li><li><p><code>EOL()</code></p><p>This function returns a string containing the EOL (end-of-line) symbol(s) used on the Server OS platform.</p></li><li><p><code>CRLF()</code></p><p>This function returns a string with the Internet EOL (<code>&lt;carriage-return&gt;&lt;line-feed&gt;</code>) symbols.</p></li><li><p><code>ToUpperCase(str)</code></p><p>If the <em>str</em> value is a string, the function result is this string with all its letters converted to the upper case.</p></li><li><p><code>ToLowerCase(str)</code></p><p>If the <em>str</em> value is a string, the function result is this string with all its letters converted to the lower case.</p></li><li><p><code>IsDigit(str)</code></p><p>This function returns a true-value if the <em>str</em> value is a 1-symbol string and that symbol is a decimal digit (<code>0</code>..<code>9</code>), otherwise the function returns a null-value.</p></li><li><p><code>IsWhiteSpaces(str)</code></p><p>This function returns a true-value if the <em>str</em> value is a string containing only space, <code>&lt;tab&gt;</code>, <code>&lt;carriage-return&gt;</code> or <code>&lt;line-feed&gt;</code> symbols, otherwise the function returns a null-value.</p></li><li><p><code>FindRegEx(str,picture)</code></p><p>The function compares the <em>str</em> string with the <em>picture</em> string containing a <em>regular expression</em>.<br> If <em>str</em> is not a string, or <em>picture</em> is not a string, or the <em>picture</em> string cannot be interpreted as a <em>regular expression</em>, or the <em>str</em> string does not match the <em>regular expression</em>, the function returns a null-value.<br> Otherwise, the function returns an array of strings. Its zero element contains a copy of the <em>str</em> string, while additional elements (if any) contain the <em>str</em> substrings matching the <em>regular expression groups</em>.<br> The <em>picture</em> string should specify a <em>regular expression</em> using the <em>extended POSIX syntax</em>.</p></li><li><p><code>EmailDomainPart(address)</code></p><p>If the <em>address</em> value is a string, and the string contains the @ symbol, this function returns a string containing the <em>address</em> string part after its first the @ symbol.<br> Otherwise, the function returns a null-value.</p></li><li><p><code>EmailUserPart(address)</code></p><p>If the <em>address</em> value is not string, this function returns a null-value.<br> If the <em>address</em> value is a string not containing the @ symbol, this function returns the same string.<br> Otherwise (the <em>address</em> value is a string containing the @ symbol), this function returns the <em>address</em> string part before the first @ symbol.</p></li></ul><h3 id="Numbers" tabindex="-1">Numbers <a class="header-anchor" href="#Numbers" aria-label="Permalink to &quot;Numbers {#Numbers}&quot;">​</a></h3><ul><li><p><code>IsNumber(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a number, otherwise the function returns a null-value.</p></li><li><p><code>Number(arg)</code></p><p>If the <em>arg</em> value is a number, this function returns this number.<br> If the <em>arg</em> value is a string, this function returns the numeric value of that string, till the first non-numeric symbol.<br> For example, the value of <code>Number(&quot;123#&quot;)</code> is 123.<br> In all other cases, this function returns the number 0.</p></li><li><p><code>RandomNumber()</code></p><p>This function returns a random integer number in the <code>[0..9223372036854775807]</code> (<code>[0..2*63-1]</code>) range.</p></li></ul><h3 id="TimeStamps" tabindex="-1">TimeStamps <a class="header-anchor" href="#TimeStamps" aria-label="Permalink to &quot;TimeStamps {#TimeStamps}&quot;">​</a></h3><ul><li><p><code>IsDate(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a timestamp, otherwise the function returns a null-value.</p></li><li><p><code>Date(arg)</code></p><p>If the <em>arg</em> value is a timestamp, this function returns this timestamp.<br> If the <em>arg</em> value is the number 0, this function returns the &quot;remote past&quot; timestamp.<br> If the <em>arg</em> value is a negative number, this function returns the &quot;remote future&quot; timestamp.<br> If the <em>arg</em> value is a positive number N, this function returns the timestamp corresponding to the start of the Nth day, where the 1st day is 2nd of January, 1970.<br> If the <em>arg</em> value is a string, if should be a textual representation of some timestamp, and this function returns that timestamp.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>GMTTime()</code></p><p>This function returns a timestamp object with the current GMT time.</p></li><li><p><code>LocalTime()</code></p><p>This function returns a timestamp object with the current local time.</p></li><li><p><code>GMTToLocal(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a timestamp object containing the <em>arg</em> value converted from the GMT to the local time.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>LocalToGMT(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a timestamp object containing the <em>arg</em> value converted from the local time to the GMT.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>Year(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the <em>arg</em> value year.<br> If the the timestamp value is the &quot;remote past&quot; timestamp, the function returns the number 0.<br> If the the timestamp value is the &quot;remote future&quot; timestamp, the function returns the number 9999.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>Month(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a string containing the <em>arg</em> value month name (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec).<br> If the <em>arg</em> value is a number in the 1..12 range, this function returns a string containing the name of month number <em>arg</em> (<code>Month(1)</code> returns Jan).<br> In all other cases, this function returns a null-value.</p></li><li><p><code>MonthNum(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns the <em>arg</em> value month number (1 for January).<br> In all other cases, this function returns a null-value.</p></li><li><p><code>MonthDay(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the day of month for the <em>arg</em> value date (1 is returned for the first day of month).<br> In all other cases, this function returns a null-value.</p></li><li><p><code>Hour(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the <em>arg</em> value hour.<br> If the the timestamp value is the &quot;remote past&quot; timestamp, the function returns the number 0.<br> If the the timestamp value is the &quot;remote future&quot; timestamp, the function returns the number 9999.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>Minute(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the <em>arg</em> value minute.<br> If the the timestamp value is the &quot;remote past&quot; timestamp, the function returns the number 0.<br> If the the timestamp value is the &quot;remote future&quot; timestamp, the function returns the number 9999.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>Second(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the <em>arg</em> value second.<br> If the the timestamp value is the &quot;remote past&quot; timestamp, the function returns the number 0.<br> If the the timestamp value is the &quot;remote future&quot; timestamp, the function returns the number 9999.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>WeekDay(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a string containing the name of week day of the <em>arg</em> value date (Mon, Tue, Wed, Thu, Fri, Sat, Sun).<br> In all other cases, this function returns a null-value.</p></li><li><p><code>YearDay(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns a number containing the day of year for the <em>arg</em> value date (the number 1 is returned for the 1st of January).<br> In all other cases, this function returns a null-value.</p></li><li><p><code>TimeOfDay(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns the number of seconds between the date <em>arg</em> value and the start of its day.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>DateNumber(arg)</code></p><p>If the <em>arg</em> value is a timestamp object, this function returns the number of full days between the <em>arg</em> value date and 01-Jan-1970.<br> In all other cases, this function returns a null-value.</p></li><li><p><code>DateByMonthDay(year,monthNum,monthDay)</code></p><p>The <em>year</em>, <em>monthNum</em>, <em>monthDay</em> values should be positive numbers. If any of these values is incorrect, this function returns a null-value. Otherwise, the function returns a timestamp object presenting midnight of the specified date.<br> The following expression timestamp value is midnight, 05-Nov-2008:</p><p><code>DateByMonthDay(2008,11,5)</code></p></li><li><p><code>DateByYearDay(year,yearDay)</code></p><p>The <em>year</em>, <em>yearDay</em> values should be positive numbers. If any of these values is incorrect, this function returns a null-value. Otherwise, the function returns a timestamp object presenting midnight of the specified date.<br> The following expression timestamp value is midnight, 01-Feb-2006:</p><p><code>DateByYearDay(2006,32)</code></p></li></ul><h3 id="IPAddrs" tabindex="-1">IP Addresses <a class="header-anchor" href="#IPAddrs" aria-label="Permalink to &quot;IP Addresses {#IPAddrs}&quot;">​</a></h3><ul><li><p><code>IsIPAddress(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is an ip-address, otherwise the function returns a null-value.</p></li><li><p><code>IPAddress(arg)</code></p><p>If the <em>arg</em> value is an ip-address, this function returns this ip-address.<br> If the <em>arg</em> value is a string with a correct presentation of an IP address (with an optional port number), the function returns that ip-address.<br> In all other cases, this function returns a null-value.</p></li></ul><h3 id="Datablocks" tabindex="-1">Datablocks <a class="header-anchor" href="#Datablocks" aria-label="Permalink to &quot;Datablocks {#Datablocks}&quot;">​</a></h3><ul><li><p><code>IsData(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a datablock, otherwise the function returns a null-value.</p></li><li><p><code>RandomData(length)</code></p><p>The <em>length</em> value should be a positive numbers not larger than 4096.<br> This function returns a datablock of the specified length, filled with random data.</p></li><li><p><code>EmptyData()</code></p><p>This function returns an empty datablock.</p></li></ul><h3 id="Arrays" tabindex="-1">Arrays <a class="header-anchor" href="#Arrays" aria-label="Permalink to &quot;Arrays {#Arrays}&quot;">​</a></h3><ul><li><p><code>IsArray(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is an array, otherwise the function returns a null-value.</p></li><li><p><code>NewArray()</code></p><p>This function returns a newly created empty array.</p></li><li><p><code>Invert(arg)</code></p><p>The <em>arg</em> value should be an array, otherwise this function call results in a program exception.<br> This function returns an array containing the same elements as the <em>arg</em> value, but in the reversed order.</p></li><li><p><code>Find(source,object)</code></p><p>If the <em>source</em> value is an array, this function returns a number - the index in the array for the first element equal to the <em>object</em> value. If the <em>source</em> array does not contain such an object, a negative numeric value is returned.<br> If the <em>source</em> value is a <a href="#Calendars">Calendar handle</a>, calendar items are returned (see below).<br> If the <em>source</em> value is anything else, a negative numeric value is returned.</p></li><li><p><code>AddElement(target,element)</code></p><p>If the <em>target</em> value is an array, this procedure adds <em>element</em> value as the new last element of that array.<br> If the myArray value is (1,4,9,16,25), the <code>AddElement(myArray,&quot;test&quot;)</code> call changes the myArray value to (1,4,9,16,25,&quot;test&quot;).<br> If the <em>target</em> value is an XML Object, this procedure adds <em>element</em> value as its new sub-element (the <em>element</em> value should be a string or an XML Object).<br> In all other cases this procedure call results in a program exception.</p></li><li><p><code>RemoveElement(target,what)</code></p><p>This procedure removes an element from an array.<br> If <em>target</em> value is an array, the <em>what</em> value should be a number or a string containing a decimal number, specifying the array element to remove.<br> If the myArray value is (1,4,9,16,25), the <code>RemoveElement(myArray,2)</code> call changes the <code>myArray</code> value to (1,4,16,25).<br> In all other cases this procedure call results in a program exception.</p></li><li><p><code>InsertElement(target,index,element)</code></p><p>This procedure inserts an element into an array.<br> The <em>target</em> value should be an array, otherwise this procedure call results in a program exception.<br> The <em>index</em> value should be a number or a string containing a decimal number, specifying where to insert the <em>element</em> value. All existing array elements with index number of <em>index</em> and bigger increase their index number by one.<br> If the myArray value is (1,4,9,16,25), the <code>InsertElement(myArray,2,&quot;Jack&quot;)</code> call changes the myArray value to (1,4,&quot;Jack&quot;,9,16,25).</p></li><li><p><code>SortStrings(arg)</code></p><p>This procedure sorts array elements.<br> The <em>arg</em> value should be an array, and all array elements must be strings, otherwise this procedure call results in a program exception.<br> The array elements are compared as case-insensitive UTF-8 strings.</p></li></ul><h3 id="Dictionaries" tabindex="-1">Dictionaries <a class="header-anchor" href="#Dictionaries" aria-label="Permalink to &quot;Dictionaries {#Dictionaries}&quot;">​</a></h3><ul><li><p><code>IsDictionary(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a dictionary, otherwise the function returns a null-value.</p></li><li><p><code>NewDictionary()</code></p><p>This function returns a newly created empty dictionary.</p></li><li><p><code>SetCaseSensitive(target,flag)</code></p><p>This procedure specifies if dictionary keys should be processes as case-sensitive.<br> The <em>target</em> value should be a dictionary, otherwise this procedure call results in a program exception.<br> If <em>flag</em> value is a null-value, the <em>target</em> dictionary becomes case-insensitive, otherwise it becomes case-sensitive.<br> New dictionaries are created as case-sensitive.</p></li></ul><h3 id="XML" tabindex="-1">XML Objects <a class="header-anchor" href="#XML" aria-label="Permalink to &quot;XML Objects {#XML}&quot;">​</a></h3><ul><li><p><code>IsXML(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is an XML object, otherwise the function returns a null-value.</p></li><li><p><code>NewXML(type)</code><br><code>NewXML(type,prefix)</code><br><code>NewXML(type,prefix,namespace)</code></p><p>This function returns a newly created XML Object of type <em>type</em>. The <em>type</em> value should be a string containing a valid XML tag.<br> The <em>prefix</em> value (if specified) can be a null-value or a string containing a valid XML prefix. This prefix is used to qualify the XML object name, if not specified or if its value is a null-value, then an empty string value is used.<br> If the <em>namespace</em> value is specified and its value is not a null-value, it should be a string containing the namespace to be associated with the <em>prefix</em> value.</p></li><li><p><code>SetNamespace(data,namespace)</code><br><code>SetNamespace(data,namespace,prefix)</code></p><p>This procedure associates an XML prefix with some namespace.<br> The <em>data</em> value should be an XML Object, otherwise this procedure call results in a program exception.<br> If the <em>prefix</em> is not specified, or its value is a null-value, then an empty string value is used. Otherwise, its value should be a string containing a valid XML prefix.<br> If the <em>namespace</em> value is a null-value, the namespaces associated with the <em>prefix</em> value is removed. Otherwise the <em>namespace</em> value should be a string, containing the namespace to be associated with the <em>prefix</em> value.</p></li><li><p><code>GetNamespace(data)</code><br><code>GetNamespace(data,prefix)</code></p><p>This function returns a string with the namespace associated with the specified XML prefix, or a null-value if there is no associated namespace.<br> The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.<br> If the <em>prefix</em> is not specified, or its value is a null-value, then an empty string value is used. Otherwise, its value should be a string containing a valid XML prefix.</p></li><li><p><code>GetPrefix(data,namespace)</code></p><p>This function returns a string with the prefix assigned to the specified namespace, or a null-value if the namespace is not included into the XML object.<br> The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.<br> The <em>prefix</em> value should be a string containing a valid XML prefix.</p></li><li><p><code>SetAttribute(data,value,name)</code><br><code>SetAttribute(data,value,name,prefix )</code></p><p>This procedure sets an XML Object attribute for the specified name and prefix.<br> The <em>data</em> value should be an XML Object, otherwise this procedure call results in a program exception.<br> The <em>name</em> value should be a string containing a valid XML attribute name.<br> If the <em>prefix</em> parameter is specified, its value should be a null-value or a string containing a valid XML prefix.<br> If the <em>value</em> value is a null-value, the attribute with the specified name and prefix is removed. Otherwise the <em>value</em> value should be a string containing the new attribute value.</p></li><li><p><code>GetAttribute(data,name)</code><br><code>GetAttribute(data,name,prefix)</code></p><p>The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.<br> If the <em>prefix</em> parameter is specified, its value value should be a null-value or a string containing a valid XML prefix.<br> If the <em>name</em> value is a string, it should contain a valid XML attribute name. In this case this function returns a string value of the attribute with the specified name and prefix, or a null-value if there is no such attribute.<br> If the <em>name</em> value is a number, it should specify the attribute index (starting from 0). If an attribute with this index does not exist, this function returns a null-value. Otherwise, this function returns an array. The first array element is the attribute name, the second array element is the attribute prefix.<br> If the <em>name</em> value is not a string and it is not a number, this function call results in a program exception.</p></li><li><p><code>XMLBody(data,type)</code><br><code>XMLBody(data,type,namespace)</code><br><code>XMLBody(data,type,namespace,index)</code></p><p>This function returns an XML sub-element with the specified type, namespace, and position, or a null-value if there is no such sub-element.<br> The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.<br> The <em>type</em> value should be a null-value or a string containing a valid XML tag name. If the <em>type</em> value is a null-value, the function retrieves sub-elements of any type.<br> If the <em>namespace</em> parameter is specified, its value should be a null-value or a string containing a namespace. If the <em>namespace</em> is not specified, or its value is a null-value, the function looks for sub-elements ignoring their namespaces.<br> If the <em>index</em> parameter is specified, its value should be a non-negative number. To retrieve the first sub-element with the specified type and namespace, the <em>index</em> value (if specified) should be 0.</p></li><li><p><code>XMLType(data)</code></p><p>This function returns a string with the XML Object type.<br> The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.</p></li><li><p><code>XMLPrefix(data)</code></p><p>This function returns a string with the XML Object type prefix.<br> The <em>data</em> value should be an XML Object, otherwise this function call results in a program exception.</p></li></ul><h3 id="Conversion" tabindex="-1">Data Conversion <a class="header-anchor" href="#Conversion" aria-label="Permalink to &quot;Data Conversion {#Conversion}&quot;">​</a></h3><ul><li><p><code>ObjectToString(arg)</code></p><p>This function returns a string with a textual representation of the <em>arg</em> value.<br> If the <em>arg</em> value is a null-value, the function returns the &quot;#null#&quot; string.</p></li><li><p><code>ObjectToXML(arg)</code></p><p>This function returns an XML representation of the <em>arg</em> value, as specified in <a href="./Data.html#XMLObjects">XML Objects</a> section.</p></li><li><p><code>ToObject(arg)</code></p><p>If the <em>arg</em> value is a string or a datablock, this function returns an object textually represented with the <em>arg</em> value.<br> If the <em>arg</em> value is an XML object, this function returns an object this XML represents (as specified in <a href="./Data.html#XMLObjects">XML Objects</a> section).<br> Otherwise this function call results in a program exception.<br> If conversion fails or if the <em>arg</em> value is the &quot;#null#&quot; string, the function returns a null-value.</p></li><li><p><code>Base32Encode(arg)</code></p><p>The <em>arg</em> value should be a string or a datablock, otherwise this function call results in a program exception.<br> This function returns a string containing the base32-encoded <em>arg</em> data.</p></li><li><p><code>Base32Decode(arg)</code></p><p>The <em>arg</em> value should be a string, otherwise this function call results in a program exception.<br> This function returns a datablock containing the base32-decoded <em>arg</em> data.</p></li><li><p><code>Base64Encode(arg)</code></p><p>The <em>arg</em> value should be a string or a datablock, otherwise this function call results in a program exception.<br> This function returns a string containing the base64-encoded <em>arg</em> data.</p></li><li><p><code>Base64Decode(arg)</code></p><p>The <em>arg</em> value should be a string, otherwise this function call results in a program exception.<br> This function returns a datablock containing the base64-decoded <em>arg</em> data.</p></li><li><p><code>Base64UrlEncode(arg)</code></p><p>The <em>arg</em> value should be a string or a datablock, otherwise this function call results in a program exception.<br> This function returns a string containing the base64url-encoded <em>arg</em> data.</p></li><li><p><code>Base64UrlDecode(arg)</code></p><p>The <em>arg</em> value should be a string, otherwise this function call results in a program exception.<br> This function returns a datablock containing the base64url-decoded <em>arg</em> data.</p></li><li><p><code>AppToXML(data,format)</code></p><p>This function converts application data into its XML representation.<br> The <em>data</em> value should be a string or a datablock containing the application data text.<br> The <em>format</em> value should be a string specifying the application data format. The following formats are supported:</p><ul><li>vCard - vCard format, the function returns either a <a href="./Data.html#XMLVCard">vCard</a> XML object, or an array of vCard XML objects.</li><li>vCardGroup - vCardGroup format, the function returns a <a href="./Data.html#XMLVCardGroup">vCardGroup</a> XML object.</li><li>iCalendar - iCalendar format, the function returns an <a href="./Data.html#XMLiCalendar">iCalendar</a> XML object.</li><li>sdp - SDP format, the function returns an <a href="./Data.html#XMSDP">SDP</a> XML object.</li></ul><p>If the function fails to parse the application data, or the specified format is not supported, the function returns an error code string.</p></li><li><p><code>XMLToApp(data)</code></p><p>This function converts an XML representation into application data (see above).<br> The <em>data</em> value should be an XML object.<br> The function returns the application data string.<br> If the XML object is not a representation of some supported application data format, the resulting string is a generic textual representation of the <em>data</em> value XML object.<br> If the function fails to convert the XML representation into application data, the resulting string contains the error code.</p></li><li><p><code>ObjectToJSON(arg)</code></p><p>This function returns a string with a JSON (JavaScript Object Notation) representation of the <em>arg</em> value.<br> Null-values are represented as null tokens.<br> Timestamp objects are represented as RFC822-formatted date strings.<br> Binary data blocks are represented as base64-encoded strings.</p></li><li><p><code>JSONToObject(arg)</code></p><p>If the <em>arg</em> value is a string or a datablock, this function returns an object textually represented with the <em>arg</em> value, using the JSON format.<br> Otherwise this function call results in a program exception.<br> If conversion fails or if the <em>arg</em> value is the null string, the function returns a null-value.</p></li><li><p><code>Convert(data,format)</code></p><p>This function converts the <code>data</code> value into the format specified with the <em>format</em> value, which should be a string.<br> The following <em>format</em> values are supported (case-insensitive, unless explicitly specified):</p><ul><li><p>&quot;base32&quot;</p><p>If the <em>data</em> value is a string, the function returns a datablock with its base32-decoded data.<br> If the <em>data</em> value is a datablock, the function returns a string with its base32-encoded data.</p></li><li><p>&quot;base64&quot;</p><p>If the <em>data</em> value is a string, the function returns a datablock with its base64-decoded data.<br> If the <em>data</em> value is a datablock, the function returns a string with its base64-encoded data.</p></li><li><p>&quot;hex&quot;</p><p>If the <em>data</em> value is a string, it should contain hexadecimal symbols, and the function returns a datablock with its decoded data.<br> If the <em>data</em> value is a datablock, the function returns a string with its hexadecimal encoding. The &quot;HEX&quot; format produces upper-case encodings, the &quot;hex&quot; format produces lower-case encodings.</p></li><li><p>&quot;toURI&quot;</p><p>The <em>data</em> should be a string, the function returns that string URI-encoded.</p></li><li><p>&quot;fromURI&quot;</p><p>The <em>data</em> should be an URI-encoded string, the function returns the decoded string.</p></li><li><p>&quot;ucs-2[+][le|be]&quot;</p><p>If the <em>data</em> value is a string, the function returns a datablock with its ucs-2 encoded data.<br> If the <em>data</em> value is a datablock, the function returns a string with its ucs-2 decoded data.<br> The le or be suffix specifies the ucs-2 encoding byte order (little-endian or big-endian, respectively). The big-endian byte order is used by default.<br> If the datablock to be decoded contains a BOM (byte order mark), the byte order suffix is ignored.<br> The + symbol causes the BOM (byte order mark) to be placed into the encoded data. This symbol is ignored when decoding.</p></li><li><p>&quot;<em>charsetName</em>&quot; (any character set name known to the CommuniGate Pro Server)</p><p>If the <em>data</em> value is a string, the function returns a datablock with its data encoded using the specified character set.<br> If the <em>data</em> value is a datablock, the function returns a string with its data decoded from the specified character set.</p></li><li><p>&quot;utfcode&quot;</p><p>If the <em>data</em> value is a string, the function returns a number - the Unicode code of the first string symbol.<br> If the <em>data</em> value is a number, it is interpreted as a Unicode code, and the function returns a string consisting of this symbol.</p></li><li><p>&quot;words&quot;</p><p>If the <em>data</em> value is a string, the function splits it into words - non-empty substrings separated with sequences of &quot;white space&quot; and &quot;end of line&quot; symbols, and returns an array containing all &quot;word&quot; strings.</p></li><li><p>&quot;asn.1&quot;</p><p>If the <em>data</em> value is an array, it should represent some <a href="./Data.html#ASN1">ASN.1 data structure</a>. The function returns a datablock with ASN.1 BER encoding of this structure.<br> If encoding fails, the function returns an error code string.<br> If the <em>data</em> value is a datablock, the function returns an array representing this <a href="./Data.html#ASN1">ASN.1 data structure</a>.<br> If decoding fails, the function returns an error code string.</p></li><li><p>&quot;dns-a&quot;</p><p>If the <em>data</em> value is a string, the function peforms a DNS A-record search for this domain name.<br> The function returns either an array of IP Addresses from the found records, or an error code string.</p></li><li><p>&quot;dns-aaaa&quot;</p><p>Same as &quot;dns-a&quot;, but for the DNS AAAA-record.</p></li><li><p>&quot;dns-ptr&quot;</p><p>If the <em>data</em> value is a string, the function peforms a DNS PTR-record search for this domain name.<br> If the <em>data</em> value is an IP Address, the function peforms a DNS &quot;IN-Addr&quot; PTR-record search for that address.<br> The function returns either an array with one string element - the found domain name, or an error code string.</p></li><li><p>&quot;dns-txt&quot;</p><p>If the <em>data</em> value is a string, the function peforms a DNS TXT-record search for this domain name.<br> The function returns either an array containing the found record strings, or an error code string.</p></li><li><p>&quot;gennonce&quot;</p><p>The function returns a datablock with a &quot;nonce&quot; data. The <em>data</em> value should be a number, it specifies the &quot;nonce&quot; size in bytes. If this value is outside the supported nonce size range, the function returns a null-value.</p></li><li><p>&quot;checknonce&quot;</p><p>If the <em>data</em> value is a datablock, the function returns a true-value if this datablock is a valid &quot;nonce&quot;, otherwise the function returns a null-value.</p></li></ul></li><li><p><code>SystemInfo(what)</code></p><p>This function retrieves platform-specific data specified with the <em>what</em> value, which should be a string.<br> The following <em>what</em> values are supported (case-insensitive, unless explicitly specified):</p><ul><li><p>&quot;serverVersion&quot;</p><p>The function returns a string with this CommuniGate Pro Server version.</p></li><li><p>&quot;serverOS&quot;</p><p>The function returns a string with the name of the Operating System controlling the computer this CommuniGate Pro Server is running on.</p></li><li><p>&quot;serverCPU&quot;</p><p>The function returns a string with the type of processor(s) this CommuniGate Pro Server is running on.</p></li><li><p>&quot;mainDomainName&quot;</p><p>The function returns a string with the CommuniGate Pro Server Main Domain Name.</p></li><li><p>&quot;licenseDomainName&quot;</p><p>The function returns a string with the Cluster Domain Name for a Cluster system, the Main Domain Name or a non-clustered system.</p></li><li><p>&quot;startTime&quot;</p><p>The function returns a timestamp value specifying the time when this CommuniGate Pro Server instance started.</p></li><li><p>&quot;serverInstance&quot;</p><p>The function returns a string which is unique for each running instance of the CommuniGate Pro Server.</p></li><li><p>&quot;clusterInstance&quot;</p><p>The function returns a string which is unique for each running instance of the CommuniGate Pro Cluster, and it has the same value for all cluster members.</p></li><li><p>&quot;knownCharsets&quot;</p><p>The function returns an array with the list of character sets names known to the server.</p></li></ul></li><li><p><code>QRCode(str)</code></p><p>This function returns a data block that contains <em>image/png</em> data for QR representation of the <em>str</em> string value.</p></li><li><p><code>TOTPCode(str)</code></p><p>This function returns a numeric sequence containing the time-based one-time password (TOTP) for the secret, encoded in base32 format and passed as a string value <em>str</em>.</p></li></ul><h3 id="Crypto" tabindex="-1">Cryptography <a class="header-anchor" href="#Crypto" aria-label="Permalink to &quot;Cryptography {#Crypto}&quot;">​</a></h3><ul><li><p><code>CryDigest(algName,data)</code></p></li><li><p><code>CryDigest(algName,data,salt)</code></p><p>This function computes the cryptographic digest of the <em>data</em> datablock.<br> The <em>algName</em> value should be a string specifying the digest algorithm name (MD5, SHA1, etc).<br> If the third parameter <em>salt</em> is specified, the digest is calculated using the <code>HMAC</code> algorithm with this third parameter used as the key and <em>algName</em> used for both HMAC stages.<br> If the algorithm with the specified name is unknown, the function returns a null-value, otherwise the function returns a datablock with the calculated digest.</p></li><li><p><code>CryEncrypt(algName,key,data)</code></p><p>This function encrypts the <em>data</em> datablock using the <em>key</em> datablock as the encryption key. For the ciphers with fixed block size the last data block should contain the initialization vector.<br> The <em>algName</em> value should be a string specifying the cipher algorithm name (RC4, DES3, AES, etc).<br> If the algorithm with the specified name is unknown, the function returns a null-value, otherwise the function returns a datablock with the encrypted data.</p></li><li><p><code>CryDecrypt(algName,key,data)</code></p><p>This function decrypts the <em>data</em> datablock using the <em>key</em> datablock as the decryption key. For the ciphers with fixed block size the last data block should contain the initialization vector.<br> The <em>algName</em> value should be a string specifying the cipher algorithm name.<br> If the algorithm with the specified name is unknown, the function returns a null-value, otherwise the function returns a datablock with the decrypted data.</p></li></ul><h3 id="environments" tabindex="-1">Environments <a class="header-anchor" href="#environments" aria-label="Permalink to &quot;Environments&quot;">​</a></h3><ul><li><p><code>Vars()</code></p><p>This function returns a dictionary unique for this <em>Task</em> (a program invocation). This dictionary can be used to store &quot;task variables&quot; visible in all procedures and functions executed in this Task.<br> When a Task is started with parameters (for example, when a <a href="./PBXApp.html">Real-Time Application</a> is started to process a Signal directed with the <a href="./../admin/sysadmin/Router.html#PBXApp">Router</a>), the parameter array is placed into the <code>startParameter</code> element of the <code>Vars()</code> dictionary.<br> The following example retrieves the first two Task parameters:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>firstParam  = Vars().startParameter[0];</span></span>
<span class="line"><span>secondParam = Vars().startParameter[1];</span></span></code></pre></div></li></ul><h3 id="Addresses" tabindex="-1">Addresses and URIs <a class="header-anchor" href="#Addresses" aria-label="Permalink to &quot;Addresses and URIs {#Addresses}&quot;">​</a></h3><ul><li><p><code>SIPURIToEmail(uri)</code></p><p>This function converts the <em>uri</em> value from a SIP URI into an E-mail string.<br> If the <em>uri</em> value is not a string, or if it cannot be parsed as a SIP URI, the function returns a null-value.</p></li><li><p><code>EmailToSIPURI(email)</code></p><p>This function converts the <em>email</em> value from an E-mail address into a SIP URI string.<br> If the <em>email</em> value is not a string, or if it cannot be parsed as an E-mail, the function returns a null-value.</p></li><li><p><code>PhoneNumberToSIPURI(phoneNumber)</code></p><p>This function converts the <em>phoneNumber</em> value into a SIP URI string.<br> If the <em>email</em> value is not a string, or if it cannot be parsed as a telephone number, the function returns a null-value.<br> The function removes all formatting symbols from the <em>phoneNumber</em> value, leaving only the digits and the leading plus (+) symbol (if it exists).<br> The function adds the current Domain name to the converted number.</p></li><li><p><code>RouteAddress(email,type)</code></p><p>This function uses the <a href="./../admin/sysadmin/Router.html">Router</a> to process the <em>email</em> address.<br> The <em>type</em> value specifies the address type: it should be the mail, signal, or access string.<br> If address routing fails, the function returns an error code string. Otherwise, the function result is a dictionary with the following elements:</p><ul><li><p><code>module</code></p><p>the name of the CommuniGate Pro module that will process this address.</p></li><li><p><code>host</code></p><p>a string with the name of the host (a local Account, a remote domain, etc.) the address is routed to.</p></li><li><p><code>object</code></p><p>a string with the name of the host object the address is routed to.</p></li><li><p><code>canRelay</code></p><p>this optional element exists and contains a true-value if information can be relayed to this address.</p></li></ul></li><li><p><code>RouteENUM(service,phoneNumber,domain)</code></p><p>This function uses the <a href="./../admin/network/#DNR">Domain Name Resolver</a> to convert the <em>phoneNumber</em> telephone number (a string with any sequence of digits with an optional leading + symbol) into a URL.<br> The <em>service</em> value should be a string. It specifies the ENUM &quot;service&quot; (such as &quot;E2U+SIP&quot; or &quot;E2U+MAIL&quot;).<br> The <em>domain</em> value should be a string. It specifies the ENUM domain name (such as &quot;e164.arpa&quot;).<br> If the telephone number has been converted successfully, this function returns an array. Its first element contains a string - the resulting URL.<br> Otherwise, this function returns an error code string.</p></li></ul><h3 id="Account" tabindex="-1">Account Data <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Account Data {#Account}&quot;">​</a></h3><p>The following functions and procedures are available when the program (a Task) has a &quot;current Account&quot; set.</p><ul><li><p><code>MyDomain()</code></p><p>This function returns a string with the current Domain name, if there is one. If there is no Account or Domain associated with the current Task, this function returns a null-value.</p></li><li><p><code>MyEmail()</code></p><p>This function returns a string with the current Account E-mail, if there is one. If there is no Account associated with the current Task, this function returns a null-value.</p></li><li><p><code>GetAccountPreferences(keyName)</code></p><p>This function returns Preference data for the current Account.<br> If the <em>keyName</em> is a non-empty string, the Account Preference object for that key is returned. Otherwise a dictionary with all effective Account Preferences is returned.<br> If the <em>keyName</em> string starts with a ~<em>username</em>/ prefix, the prefix is removed. The <em>username</em> string specifies the name of the Account to use. If this Account is not the same as the current Account, the operation succeeds only if the current Account has a Domain Administrator right for the specified Account Domain.</p></li><li><p><code>SetAccountPreferences(keyValue,keyName)</code></p><p>This function updates Preference data for the current Account.<br> If the <em>keyName</em> is a non-empty string, the <em>keyValue</em> value specifies the new object for that key. If the <em>keyValue</em> is a null-value, the object is removed from the Account Preference data, enabling the default value for the specified key.<br> If the <em>keyName</em> string starts with a ~<em>username</em>/ prefix, the prefix is removed. The <em>username</em> string specifies the name of the Account to update. If this Account is not the same as the current Account, the operation succeeds only if the current Account has a Domain Administrator right for the specified Account Domain.<br> If the <em>keyName</em> is a ~<em>username</em>/ string, or an empty string, or if it is not a string, the <em>keyValue</em> value must be a dictionary. It is used to update the Account Preference Data.<br> This function returns a null-value if Preference data is successfully updated, otherwise it returns a string with an error code.</p></li><li><p><code>Impersonate(email)</code></p><p>This function Routes the <em>email</em> address and sets the result as the current Account.<br> If the routed address is not local, the current Account is cleared.<br> If the routed address is local and it is not the same as the current Account, the current Account must have the <a href="./../admin/sysadmin/#Privs">CanImpersonate</a> access right for the routed address Domain.<br> When the current Account is changed, the preferences, the selected language, and the selected time zone are changed, too.<br> This function returns a null-value if the operation has succeeded, otherwise it returns a string with an error code.</p></li><li><p><code>ReadGroupMembers(groupName)</code></p><p>This function reads a <a href="./../admin/objects/Groups.html">Group</a>.<br> The <em>groupName</em> value should be a string. It specifies the name of the Group to read. If this name does not contain a Domain name, the current Domain is used.<br> This function returns an array of strings containing Group member E-mail addresses. This function returns a null-value if there is no Group with the specified name.<br> The current Account should have the Domain Administrator right for the Group Domain.</p></li><li><p><code>ReadTelnums()</code><br><code>ReadTelnums(accountName)</code></p><p>This function reads <a href="./../admin/objects/Accounts.html#Telnums">Phone Numbers</a> assigned to the <em>accountName</em> Account or to the current Account, if the <em>accountName</em> parameter is not specified or if its value is a null-value.<br> This function returns an array of strings. This function returns a null-value if there is no Account with the specified name.<br> To retrieve the Phone Numbers assigned to a different Account, the current Account should have the Domain Administrator right for the <em>accountName</em> Account Domain.</p></li><li><p><code>UpdateAccountMailRule(ruleData)</code><br><code>UpdateAccountMailRule(ruleData,accountName)</code></p></li><li><p><code>UpdateAccountSignalRule(ruleData)</code><br><code>UpdateAccountSignalRule(ruleData,accountName)</code></p><p>These functions modify Account Queue or Signal Rules.<br> The <em>ruleData</em> parameter is a string or an array. It has the same meaning as the <em>newRule</em> parameter of the <a href="./CLI.html#RuleUpdate">UpdateAccountMailRule</a> and <a href="./CLI.html#RuleUpdate">UpdateAccountSignalRule</a> CLI commands.<br> These functions update the Rules of the the <em>accountName</em> Account, or the current Account if the <em>accountName</em> parameter is not specified or its value is a null-value.<br> To update Queue Rules of a different Account, the current Account should have the <code>RulesAllowed</code> Domain Administrator right for the <em>accountName</em> Account Domain.<br> To update Signal Rules of a different Account, the current Account should have the <code>SignalRulesAllowed</code> Domain Administrator right for the <em>accountName</em> Account Domain.<br> This function returns a null-value if the operation has succeeded, otherwise it returns a string with an error code.</p></li></ul><h3 id="Mailboxes" tabindex="-1">Mailboxes <a class="header-anchor" href="#Mailboxes" aria-label="Permalink to &quot;Mailboxes {#Mailboxes}&quot;">​</a></h3><ul><li><p><code>ListMailboxes(filter)</code></p><p>This function lists all Mailboxes in the current Account.<br> The <em>filter</em> value should be a string - it specifies the search pattern. If the value is a null-value, the search pattern <code>*</code> (all Account Mailboxes) is used.<br> To search Mailboxes in a different Account, the search pattern should be specified as a <code>~accountName/pattern</code> string.<br> If the operation is successful, this function returns a dictionary. Each dictionary key is a string with the found Mailbox name.<br> The dictionary element value is:</p><ul><li>a dictionary with the Mailbox attributes - if the found Mailbox is an &quot;item container&quot; only.</li><li>an empty array - if the found Mailbox is a &quot;mailbox folder&quot; only.</li><li>an array with one dictionary element- if the found Mailbox is both a &quot;mailbox folder&quot; and an &quot;item container&quot;.</li></ul><p>If the Mailbox Access rights allow the current Account to see that Mailbox, but do not allow the current Account to open it, the Mailbox Attribute dictionary is replaced with a string containing the Mailbox Access Rights for the current Account.<br> If this function fails, it returns a string with an error code.</p></li><li><p><code>CreateMailbox(mailboxName,class)</code></p><p>This function creates the <em>mailboxName</em> <a href="./../admin/storage/Mailboxes.html">Mailbox</a>.<br> If the <em>class</em> is not a null-value, it specified the Mailbox Class for the newly created Mailbox.<br> This function returns a null-value if the Mailbox is successfully created, otherwise it returns a string with an error code.</p></li><li><p><code>RenameMailbox(oldMailboxName,newMailboxName,renameSub)</code></p><p>This function renames the <em>oldMailboxName</em> Mailbox into <em>newMailboxName</em>. Both parameters must have string values.<br> If the <em>renameSub</em> value is not a null-value, all <em>oldMailboxName</em> sub-Mailboxes are renamed, too.<br> This function returns a null-value if the Mailbox is successfully renamed, otherwise it returns a string with an error code.</p></li><li><p><code>DeleteMailbox(mailboxName,deleteSub)</code></p><p>This function deletes the <em>mailboxName</em> Mailbox.<br> If the <em>deleteSub</em> value is not a null-value, all <em>mailboxName</em> sub-Mailboxes are deleted, too.<br> This function returns a null-value if the Mailbox is successfully deleted, otherwise it returns a string with an error code.</p></li><li><p><code>GetMailboxACLs(mailboxName)</code></p><p>This function reads the Access Control List for the <em>mailboxName</em> Mailbox.<br> If the function successfully retrieves the ACL data, it returns a dictionary containing ACL identifiers as keys, and access rights as value strings.<br> Otherwise the function returns a string with an error code.</p></li><li><p><code>SetMailboxACLs(mailboxName,newACLs)</code></p><p>This function updates the Access Control List for the <em>mailboxName</em> Mailbox.<br> The <em>newACL</em> value should be a dictionary, containing ACL identifiers as keys, and access rights as value strings.<br> To remove an identifier from the ACL, specify an empty array as its value.<br> This function returns a null-value if the Mailbox ACL is successfully modified, otherwise it returns a string with an error code.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To access Mailboxes in other Accounts, specify a Mailbox name as a &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>mailboxName</em>&quot; string.</p></div></li><li><p><code>GetMailboxAliases(accountName)</code></p><p>This function reads <a href="./../admin/storage/Mailboxes.html#Aliases">Mailbox Aliases</a> created in the <em>accountName</em> Account or to the current Account, if the <em>accountName</em> value is a null-value.<br> If the function successfully retrieves the Mailbox Aliases data, it returns a dictionary. Each dictionary key is the Mailbox Alias name, and its value is a string with the Mailbox name this Mailbox Alias points to.<br> Otherwise the function returns a string with an error code.</p></li><li><p><code>SetMailboxAliases(newAliases,accountName)</code></p><p>This function sets the Mailbox Aliases for the <em>accountName</em> Account or for the current Account, if the <em>accountName</em> value is a null-value. The old Mailbox Aliases are removed.<br> The <em>newAliases</em> value should be a dictionary. Each dictionary key is the Mailbox Alias name, and its value is a string with the Mailbox name this Mailbox Alias points to.<br> This function returns a null-value if the Mailbox Aliases are successfully modified, otherwise it returns a string with an error code.</p></li><li><p><code>GetMailboxSubscription(accountName)</code></p><p>This function reads <a href="./../admin/storage/Mailboxes.html#Subscription">Mailbox Subscription</a> created in the <em>accountName</em> Account or to the current Account, if the <em>accountName</em> value is a null-value.<br> If the function successfully retrieves the Mailbox Subscription data, it returns an array. Each array element is a string containing a Mailbox name.<br> Otherwise the function returns a string with an error code.</p></li><li><p><code>SetMailboxSubscription(newSubscription,accountName)</code></p><p>This function sets the Mailbox Subscription for the <em>accountName</em> Account or to the current Account, if the <em>accountName</em> value is a null-value. The old Mailbox Subscription elements are removed.<br> The <em>newSubscription</em> value should be an array. Each array element is a string containing a Mailbox name.<br> This function returns a null-value if the Mailbox Subscription is successfully modified, otherwise it returns a string with an error code.</p></li></ul><h3 id="MailboxRef" tabindex="-1">Mailbox Handles <a class="header-anchor" href="#MailboxRef" aria-label="Permalink to &quot;Mailbox Handles {#MailboxRef}&quot;">​</a></h3><p>Mailbox handles are internal objects representing <a href="./../admin/storage/Mailboxes.html">Mailboxes</a>. Mailbox Messages can be addressed either using their UID (unique IDs) numeric values, or their current index values.</p><p>Some operations use a &quot;message set&quot; as a parameter. A message set specifies a set of numbers, which is interpreted either as a set of message UIDs or a set of message indeces.<br> If a &quot;message set&quot; parameter value is a number, the resulting set includes this number only.<br> If a &quot;message set&quot; parameter value is an array, containing numeric elements. All these numbers are included into the resulting set. The array can also contain &quot;ranges&quot;, where a &quot;range&quot; is an array containing two numbers (&quot;range ends&quot;). The resulting set includes the &quot;range end&quot; numbers, and all numbers between them.<br> Examples:</p><p>if a &quot;message set&quot; value is the 123 number, the resulting set includes the number 123 only if a &quot;message set&quot; value is the (123, 125, 130) array, the resulting set includes the numbers 123,125,130 if a &quot;message set&quot; value is the (123, (125,128), 130) array, the resulting set includes the numbers 123,125,126,127,128,130</p><ul><li><p><code>OpenMailbox(mailboxName)</code></p><p>This function opens a Mailbox. The <em>mailboxName</em> value should be a string. It specifies the Mailbox name.<br> If the name does not start with the <code>~</code> symbol, the Mailbox is opened in the current Account, if any.<br> The current Account (if any) must have the <a href="./../admin/storage/Mailboxes.html#ACL">Read/Select</a> access right for the specified Mailbox.<br> The function returns a Mailbox handle if the Mailbox has been opened successfully, otherwise it returns an error code string.</p></li><li><p><code>OpenMailboxView(params)</code></p><p>This function opens a Mailbox and creates a Mailbox handle.<br> The <em>params</em> value should be a dictionary containing a <code>mailbox</code> and <code>sortField</code> string elements, and optional <code>mailboxClass</code>, <code>sortOrder</code>, <code>filter</code>, <code>filterField</code> string elements, and <code>UIDValidity</code>, <code>UIDMin</code> numeric elements.<br> See the <a href="./XMLAPI.html#folderOpen">XIMSS</a> section for more details on these parameter values.<br> The function returns a Mailbox handle if the Mailbox has been opened successfully, otherwise it returns an error code string.</p></li><li><p><code>MailboxUIDs(boxRef,flags)</code></p><p>This function returns an array of numbers - Mailbox message UIDs.<br> The <em>boxRef</em> value should be a Mailbox handle.<br> If the <em>flags</em> value is a string, it should contain a comma-separated list of message flag <a href="./../admin/storage/Mailboxes.html#Flags">Names</a> and/or <a href="./../admin/storage/Mailboxes.html#Flags">Negative Names</a>. Only UIDs of messages that have flags specified with the flag Names and do not have flags specified with the Negative Names are included into the resulting array.<br> The following example retrieves UIDs of all messages that have the Seen flag and do not have the Deleted flag:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myMailbox = OpenMailbox(&quot;INBOX&quot;);</span></span>
<span class="line"><span>seen = MailboxUIDs(myMailbox,&quot;Seen,Undeleted&quot;);</span></span></code></pre></div></li><li><p><code>SubscribeEvents(object,refData)</code></p><p>This function enables or disables object <em>object</em> event generation.<br> If the <em>refData</em> value is a null-value, the <em>object</em> stops to generate events.<br> Otherwise, the <em>refData</em> value should be a <a href="./Data.html">&quot;basic&quot;</a> object. When the <em>object</em> generates events and send them to this Task, the event <em>parameter</em> element contains the <em>refData</em> value.<br> If the <em>object</em> value is a Mailbox handle, it should be created with the <code>OpenMailboxView</code> function. A Mailbox notification Event is sent to this Task when the Mailbox messages are removed, added, or modified. The &quot;mailbox view&quot; is not actually modified (i.e. the <code>MailboxUIDs</code> function returns the same set of message UIDs) until the Sync operation is applied to that Mailbox handle.</p></li><li><p><code>IsMailboxNotifyEvent(data)</code></p><p>This function returns a true-value if the <code>data</code> value is a Mailbox notification Event, otherwise it returns a null-value.</p></li><li><p><code>Sync(boxRef)</code></p><p>This function checks for Mailbox modifications.<br> The <em>boxRef</em> value should be a Mailbox Handle.<br> This function takes the first pending Mailbox modification and &quot;commits&quot; it by modifying the message UIDs (adding added messages, removing removed messages). It returns a dictionary with the following elements:</p><ul><li><p><code>mode</code></p><p>a &quot;removed&quot;, &quot;added&quot;, &quot;updated&quot;, or &quot;attrsUpdated&quot; string specifying this Mailbox modification type.</p></li><li><p><code>UID</code></p><p>a number - the UID of the removed, added, or modified message</p></li><li><p><code>index</code></p><p>for an updated message - its position in the message UIDs array.<br> for a removed message - its position in the message UIDs array before it was removed from that array.<br> for an added message - its position in the message UIDs array after it was added to that array.<br> If there is no pending modification in the Mailbox, this function returns a null-value.</p></li></ul></li><li><p><code>MailboxInternalTimeByUID(boxRef,uid)</code></p><p>This function returns a timestamp object containing the message Internal Date.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> If a message with the specified UID does not exist in the Mailbox, the function returns a null-value.</p></li><li><p><code>MailboxFlagsByUID(boxRef,uid)</code></p><p>This function returns a string containing a comma-separated list of Mailbox message flags Names.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> If a message with the specified UID does not exist in the Mailbox, the function returns a null-value.</p></li><li><p><code>MailboxOrigUIDByUID(boxRef,uid)</code></p><p>This function returns a number containing the message &quot;original&quot; (permanent) UID.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> If a message with the specified UID does not exist in the Mailbox, the function returns a null-value.</p></li><li><p><code>MailboxUIDByOrigUID(boxRef,origUID)</code></p><p>This function returns a number containing the real UID of the message with the specified &quot;original&quot; (permanent) UID.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>origUID</em> value should be a number - the message original UID.<br> If a message with the specified original UID does not exist in the Mailbox, the function returns a null-value.</p></li><li><p><code>MailboxSetFlags(boxRef,idData,params)</code></p><p>This function modifies Mailbox Message flags.<br> The <em>boxRef</em> value should be a Mailbox handle, and the <em>idData</em> value is a &quot;message set&quot; (see above).<br> If the <em>params</em> value is a string, it should be &quot;flag values&quot;: a comma-separated list of message flag <a href="./../admin/storage/Mailboxes.html#Flags">Names</a> and/or <a href="./../admin/storage/Mailboxes.html#Flags">Negative Names</a>.<br> If the <em>params</em> value is a dictionary, it should include the following elements:</p><ul><li><p><code>flags</code></p><p>the &quot;flag values&quot; string</p></li><li><p><code>useIndex</code></p><p>if this optional element is present, the &quot;message set&quot; specified with the <em>idData</em> value is interpreted as a set of message index values in the <em>boxRef</em> &quot;mailbox view&quot;, if this element is absent, it is interpreted as the UID value set.<br> This element can be present only if the <em>boxRef</em> handle was open using the OpenMailboxView function. Otherwise this function call results in a program exception.<br> The function sets the flags specified with their Names and resets the flags specified with their Negative Names.<br> The function returns a null-value if the current Account (if any) has sufficient Mailbox <a href="./../admin/storage/Mailboxes.html#ACL">Access Rights</a> to modify the flags, and flags have been successfully modified, otherwise the function returns an error code string.</p></li></ul></li><li><p><code>MailboxExpunge(boxRef)</code></p><p>This function removes all Mailbox messages marked as &quot;purgable&quot; or &quot;deleted&quot;.<br> The <em>boxRef</em> value should be a Mailbox handle.<br> This function returns a null-value if the operation has succeeded, otherwise it returns a string with an error code.</p></li><li><p><code>MailboxAudioByUID(boxRef,uid)</code></p><p>This function returns a datablock containing an audio section of the message.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> If a message with the specified UID does not exist in the Mailbox, or the message does not contain an <code>audio</code> part, the function returns a null-value.</p></li><li><p><code>MailboxRedirectByUID(boxRef,uid,addresses)</code></p></li><li><p><code>MailboxForwardByUID(boxRef,uid,addresses)</code></p><p>These function redirect or forward the specified message to the specified E-mail addresses.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID, the <em>addresses</em> should be a string containing one E-mail address or several E-mail addresses separated with the comma (<code>,</code>) symbols.<br> These functions return a null-value if the operation has succeeded, otherwise they return a string with an error code.</p></li><li><p><code>MailboxAppend(boxRef,headers,content)</code></p><p>These function composes an E-mail message and appends it to the Mailbox.<br> The <em>boxRef</em> value should be a Mailbox handle.<br> The <em>headers</em> and <em>content</em> values are processed in the same way they are processed with the <a href="#SubmitEMail"><code>SubmitEMail</code></a> function.<br> The <em>headers</em> dictionary may contain the following additional elements:</p><ul><li><p><code>flags</code></p><p>a string that specifies the message flags the newly created message will have in the Mailbox. Several flags can be specified, separated with the comma symbol. See the <a href="./../admin/storage/Mailboxes.html#Flags">Mailbox</a> section for more details.</p></li><li><p><code>internalDate</code></p><p>a timestamp value with the &quot;internal timestamp&quot; for the newly created message. If absent, the current time is used.</p></li><li><p><code>replacesUID</code>, <code>replaceMode</code></p><p>an UID value for the previous version of this message. The meaning is the same as the meaning of these attributes in the <a href="./XMLAPI.html#messageAppend">XIMSS <code>messageAppend</code></a> operation.</p></li><li><p><code>report</code></p><p>if this element is specified, it should have the &quot;uid&quot; value.<br> If the <em>content</em> value is a <a href="./Data.html#XMLvCard">vCard</a> or <a href="./Data.html#XMLvCardGroup">vCardGroup</a> XML object, a Contacts item is composed (regular <em>headers</em> elements are ignored), and this item is added to the Mailbox.<br> If the operation has failed, this function returns a string with an error code.<br> If the operation has succeeded, this function returns a null-value, or, if the <code>report</code> element was specified in the <em>headers</em> dictionary, the function returns a number - the UID value of the newly created Mailbox message.</p></li></ul></li><li><p><code>MailboxCopy(boxRef,uidData,parameters)</code></p><p>These function copies or moves messages from one Mailbox to some other Mailbox.<br> The <em>boxRef</em> value should be a Mailbox handle.<br> The <em>uidData</em> value should be either a number or an array of numbers or &quot;ranges&quot;, where a &quot;range&quot; is an array with 2 numbers as its elements. The &quot;range&quot; includes its &quot;start&quot; and &quot;end&quot; numbers, and all the numbers in between.<br> All these numbers specify the set of UIDs or Mailbox indeces of the message(s) to be copied.<br> If the <em>uidData</em> value is the 123 number, the message with UID 123 is copied. If the <em>uidData</em> value is the (123, 125, 130) array, the messages with UIDs 123,125,130 are copied. If the <em>uidData</em> value is the (123, (125,128), 130) array, the messages with UIDs 123,125,126,127,128,130 are copied.<br> If the <em>parameters</em> value is a string, it specifies the target Mailbox name.<br> Otherwise, the <em>parameters</em> value should be a dictionary with the following elements:</p><ul><li><p><code>targetMailbox</code></p><p>the target Mailbox name string.</p></li><li><p><code>doMove</code></p><p>if this element is present, the original messages are removed after they have been successfully copied.</p></li><li><p><code>mailboxClass</code></p><p>if this element value is a string, and the targetMailbox Mailbox does not exist, that Mailbox is created.<br> If the element value is a non-empty string, that value is assigned as the <a href="./../admin/storage/Mailboxes.html#Classes">Mailbox Class</a> to the newly created Mailbox.</p></li><li><p><code>useIndex</code></p><p>if this element is present, the set specified with the <em>uidData</em> value is interpreted as a set of message index values in the <em>boxRef</em> &quot;mailbox view&quot;. This element can be present only if the <em>boxRef</em> handle was open using the OpenMailboxView function. Otherwise this function call results in a program exception.</p></li><li><p><code>report</code></p><p>if this element is present, the function returns an array of numbers - the UIDs of copied messages created in the target Mailbox.<br> This function returns a null-value or an array if the operation has succeeded, otherwise it returns a string with an error code.</p></li></ul></li><li><p><code>GetMessageAttr(boxRef,uid)</code></p><p>This function retrieves Message attributes.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> If the function succeeds, it returns a dictionary with the message attribute values, otherwise it returns a string with an error code.</p></li><li><p><code>UpdateMessageAttr(boxRef,uid,newData)</code></p><p>This function modifies Message attributes.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> The <em>newData</em> value should be a dictionary with new attribute values. To remove an attribute, set its value to the &quot;default&quot; string.<br> If the function succeeds, it returns a null-value, otherwise it returns a string with an error code.</p></li></ul><h3 id="MessageRef" tabindex="-1">Message Handles <a class="header-anchor" href="#MessageRef" aria-label="Permalink to &quot;Message Handles {#MessageRef}&quot;">​</a></h3><p>Message Handles are internal objects representing individual messages stored in <a href="./../admin/storage/Mailboxes.html">Mailboxes</a>.</p><ul><li><p><code>OpenMessage(boxRef,uid)</code></p><p>This function opens a Message Handle.<br> The <em>boxRef</em> value should be a Mailbox handle, the <em>uid</em> value should be a number - the message UID.<br> The function returns a Message Handle if the message has been opened successfully, otherwise it returns a null-value.</p></li><li><p><code>MessagePart(msgRef,type)</code></p><p>The <em>msgRef</em> value should be a Message Handle.<br> If the <code>type</code> value is a null-value, this function returns a dictionary containing the message MIME structure.<br> Otherwise, the <code>type</code> value should be a string. It specifies the message subpart to search for:</p><ul><li><p>audio</p><p>a subpart with <code>audio/*</code> Content-Type.</p></li><li><p>plain</p><p>a subpart with <code>text/plain</code> Content-Type.</p></li><li><p>text</p><p>a subpart with <code>text/*</code> Content-Type. If several alternative subtypes are available, the <code>text/plain</code> part has the lowest priority, followed by text/html part. If a subpart is found, this function returns a dictionary with this subpart MIME structure.<br> If no subpart is not found, the function returns a null-value.<br> If the message cannot be read or parsed, the function returns an error code string.<br> The dictionary elements are:</p></li><li><p><code>estimatedSize</code></p><p>estimated size of the message (or message part) decoded body.</p></li><li><p><code>filename</code></p><p>optional - the decoded message part file name.</p></li><li><p><code>Content-Type</code></p><p>the message (or message part) content type string (such as &quot;text&quot;, &quot;image&quot;, etc.)</p></li><li><p><code>Content-Subtype</code></p><p>the message (or message part) content subtype string (such as &quot;plain&quot;, &quot;jpeg&quot;, etc.)</p></li><li><p><code>DispositionParams</code></p><p>a dictionary with <code>Content-Disposition</code> field parameters</p></li><li><p><code>ContentTypeParams</code></p><p>a dictionary with <code>Content-Type</code> field parameters</p></li><li><p><code>MIMEPartID</code></p><p>This element is an empty string for the message itself. For message subparts, this element is a string with the message part ID.</p></li><li><p><code>MIMEParts</code></p><p>an array of MIME subparts. Each array element is a dictionary with subpart MIME structure.</p></li><li><p><code>contentFieldName</code></p><p>a string with <code>Content-contentFieldName</code> field value</p></li></ul></li><li><p><code>MessageHeader(msgRef,partID,fieldName)</code></p><p>This function returns an array of the specified message header fields, or a dictionary with all message header fields. If the message cannot be read or parsed, the function returns an error code string.<br> The <em>msgRef</em> value should be a Message Handle.<br> If the <em>partID</em> is a null-value, then the message header fields are returned.<br> If the <em>partID</em> is a string, it should be a message part ID, and that message part should be of the <code>text/rfc822headers</code> type, or it should be the (only) subpart of the <code>message/rfc822</code> part. The header fields of the specified message part are returned.<br> If the <em>fieldName</em> value is a string, it specifies the message header field name, and the function value is an array of the specified field values.<br> Otherwise, the <em>fieldName</em> value should be a null-value. In this case the function value is a dictionary: the dictionary keys are the names of all message header fields, and their values are arrays with the corresponding field values.<br> If the field name specifies an Email-type field (&quot;From&quot;, &quot;To&quot;, &quot;Sender&quot;, etc.) then the field value is a dictionary. The dictionary element with an empty (&quot;&quot;) key is the parsed E-mail address. An optional <code>realName</code> element contains the address &quot;comment&quot; string.<br> If the field name is a &quot;E-<em>emailField</em>&quot; string, where <em>emailField</em> is an Email-type field name, then the field value is a string with the parsed E-mail address.<br> If the field name is a date-type field (&quot;Date&quot;,&quot;Resent-Date&quot;), then the field value is a timestamp.<br> In all other cases, the field value is a string containing the field data, MIME-decoded and converted into the UTF-8 character set.</p><p>Example: the <code>msgRef</code> Message Handle references a message with the following header:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>Subject: I&#39;ll be there!</span></span>
<span class="line"><span>To: &quot;Recipient Name&quot; &lt;toName@domain&gt;, &lt;toName1@domain1&gt;,</span></span>
<span class="line"><span>To: &lt;toName2@domain2&gt;</span></span>
<span class="line"><span>Cc: &quot;Cc Name&quot; &lt;toName3@domain3&gt;</span></span>
<span class="line"><span>MIME-Version: 1.0</span></span>
<span class="line"><span>X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>Date: Fri, 24 Oct 2008 02:51:24 -0800</span></span>
<span class="line"><span>Message-ID: &lt;ximss-38150012@this.server.dom&gt;</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span></code></pre></div><p>Then the <code>MessageHeader(msgRef,null,&quot;To&quot;)</code> returns</p><p><code>({&quot;&quot;=&quot;toName@domain&quot;,realName=&quot;Sender Name&quot;},{&quot;&quot;=&quot;toName1@domain1&quot;},{&quot;&quot;=&quot;toName2@domain2&quot;})</code></p><p>the <code>MessageHeader(msgRef,null,&quot;E-Cc&quot;)</code> returns</p><p><code>(&quot;toName3@domain3&quot;)</code></p><p>and the <code>MessageHeader(msgRef,null,null)</code> returns</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{</span></span>
<span class="line"><span> Cc = ({&quot;&quot;=&quot;toName3@domain3&quot;,realName=&quot;Cc Name&quot;});</span></span>
<span class="line"><span> Date = (#T24-10-2008_10:51:24);</span></span>
<span class="line"><span> From = ({&quot;&quot;=&quot;fromName@domain&quot;,realName=&quot;Sender Name&quot;});</span></span>
<span class="line"><span> Message-ID = (&quot;&lt;ximss-38150012@this.server.dom&gt;&quot;);</span></span>
<span class="line"><span> Subject = (&quot;I&#39;ll be there!&quot;);</span></span>
<span class="line"><span> To=({&quot;&quot;=&quot;toName@domain&quot;,realName=&quot;Recipient Name&quot;},{&quot;&quot;=&quot;toName1@domain1&quot;},{&quot;&quot;=&quot;toName2@domain2&quot;});</span></span>
<span class="line"><span> X-Mailer = (&quot;SuperClient v7.77&quot;);</span></span>
<span class="line"><span>}</span></span></code></pre></div></li><li><p><code>MessageBody(msgRef,partID)</code></p><p>This function returns the message or message part body.<br> The <em>msgRef</em> value should be a Message Handle.<br> If the <em>partID</em> is a null-value, then the entire message body is returned.<br> If the <em>partID</em> is a string, it should be a message part ID. The message part body is returned.<br> If the message cannot be read, or if the specified message part is not found, this function returns an error code string.<br> If the message or message part Content-Type is text/*, the function reencodes the result using the UTF-8 character set.<br> If the message or message part Content-Type is text/xml, the function returns a parsed XML object.<br> For all other Content-Types, the function returns a datablock with the message body data.</p></li></ul><h3 id="Calendars" tabindex="-1">Calendars <a class="header-anchor" href="#Calendars" aria-label="Permalink to &quot;Calendars {#Calendars}&quot;">​</a></h3><p>Calendar handles are internal objects representing Calendars. When a Calendar handle is created, it can be used to retrieve its events within the specified time intervals, to publish new events, to accept, decline, and cancel events, etc.</p><ul><li><p><code>OpenCalendar(mailboxName)</code></p><p>This function opens the specified Mailbox as a Calendar. The <em>mailboxName</em> value should be a string. It specifies the Mailbox name.<br> If the name does not start with the <code>~</code> symbol, the Mailbox is opened in the current Account, if any.<br> The current Account (if any) must have the <a href="./../admin/storage/Mailboxes.html#ACL">Read/Select</a> access right for the specified Mailbox.<br> The function returns a Calendar handle if the Mailbox has been opened successfully and the Calendar is built using its content, otherwise the function returns an error code string.</p></li><li><p><code>Find(calendarRef,params)</code></p><p>the <em>calendarRef</em> value should be a Calendar handle, and the <em>params</em> value should be a dictionary.<br> This function retrieves all calendar events falling into the specified time interval.<br> The <em>params</em> dictionary should contain the required <code>timeFrom</code> and <code>timeTill</code> elements with the timestamp values, and optional <code>limit</code> and <code>skip</code> number elements, and an optional <code>byAlarm</code> element. These elements have the same meanings as the attributes of the <a href="./XMLAPI.html#findEvents"><code>findEvents</code></a> XIMSS operation.<br> If the function fails, it returns an error code string. Otherwise, it returns an array of dictionaries for each 24-hour day (in the selected time zone) included into the specified time interval.<br> Each dictionary has the following elements:</p><ul><li><p><code>timeFrom</code>, <code>timeTill</code>, <code>skip</code>, <code>items</code></p><p>these elements have the same meanings as the attributes of the <a href="./XMLAPI.html#events"><code>events</code></a> XIMSS data message</p></li><li><p><code>events</code></p><p>An array of found Events, represented as dictionaries with the following elements:</p><ul><li><p><code>UID</code>, <code>timeFrom</code>, <code>dateFrom</code>, <code>duration</code>, <code>alarmTime</code></p><p>these elements have the same meanings as the attributes of the <code>event</code> sub-elements of the <a href="./XMLAPI.html#events"><code>events</code></a> XIMSS data message</p></li><li><p><code>data</code></p><p>the <a href="./Data.html#XMLvevent">XML presentation</a> of the found Event</p></li><li><p><code>parent</code></p><p>this element is present if the found Event is an exception of some other Event. The element value is the <a href="./Data.html#XMLvevent">XML presentation</a> of that parent Event.<br> The value of the <code>data</code> element is included into the <code>parent</code> element value as a sub-element of its <code>exceptions</code> sub-element.</p></li></ul></li></ul></li><li><p><code>ProcessCalendar(calendarRef,params)</code></p><p>the <em>calendarRef</em> value should be a Calendar handle, and the <em>params</em> value should be a dictionary.<br> The function applies an operation specified with the <em>params</em> to the specified Calendar.<br> If the operation succeeds, this function returns a null-value. Otherwise it returns an error code string.<br> The operation performed is specified with the <code>opCode</code> string element of the <em>params</em> dictionary:</p><ul><li><p>&quot;PUBLISH&quot;</p><p>The function publishes an Event or a ToDo element in the Calendar. Other <em>params</em> elements:</p><ul><li><p><code>data</code></p><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to place into the Calendar.</p></li><li><p><code>attachments</code></p><p>(optional) array containing the item attachments, each array element specified as an <a href="#EMailPart">EMail part content</a>.<br> If this element is not specified, and a calendaring item with the same UID already exists in the Calendar, then all attachments are copied from the existing item. To remove all attachments, specify an empty array.</p></li><li><p><code>sendRequests</code></p><p>this optional string element has the same meaning as the attribute of the XIMSS <a href="./XMLAPI.html#calendarPublish">calendarPublish</a> operation.</p></li></ul></li><li><p>&quot;CANCEL&quot;</p><p>The function removes an Event or a ToDo element from the Calendar. Other <em>params</em> elements:</p><ul><li><p><code>data</code></p><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to remove from the Calendar.</p></li><li><p><code>UID</code></p><p>this optional numeric element has the same meaning as the attribute of the XIMSS <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> operation.</p></li><li><p><code>itemUID</code>, <code>sendRequests</code></p><p>these optional string elements have the same meanings as the attributes of the XIMSS <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> operation.</p></li><li><p><code>recurrenceId</code></p><p>this optional timestamp element has the same meaning as the attribute of the XIMSS <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> operation.</p></li><li><p><code>requestComment</code></p><p>this optional string element has the same meaning as the body element of the XIMSS <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> operation.</p></li></ul></li><li><p>&quot;DECLINE&quot;</p><p>The function rejects a calendaring item and sends a negative reply the item organizer. Other <em>params</em> elements:</p><ul><li><p><code>data</code></p><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to decline.</p></li><li><p><code>sendReply</code></p><p>this optional string element has the same meaning as the attribute of the XIMSS <a href="./XMLAPI.html#calendarDecline">calendarDecline</a> operation.</p></li><li><p><code>replyComment</code></p><p>this optional string element has the same meaning as the body element of the XIMSS <a href="./XMLAPI.html#calendarDecline">calendarDecline</a> operation.<br> The <em>calendarRef</em> value can be a null-value. In this case, only a negative reply is generated.</p></li></ul></li><li><p>&quot;ACCEPT&quot;</p><p>The function places a calendaring item into a Calendar and sends a positive reply the item organizer. The existing items(s) with the same UID are replaced. Other <em>params</em> elements:</p><ul><li><p><code>data</code></p><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to accept.</p></li><li><p><code>attachments</code></p><p>this optional element has the same meaning here as for the <code>PUBLISH</code> operation code.</p></li><li><p><code>PARTSTAT</code>, <code>sendReply</code></p><p>these string elements have the same meaning as the attributes of the XIMSS <a href="./XMLAPI.html#calendarAccept">calendarAccept</a> operation.</p></li><li><p><code>replyComment</code></p><p>this optional string element has the same meaning as the body element of the XIMSS <a href="./XMLAPI.html#calendarAccept">calendarAccept</a> operation.</p></li></ul></li><li><p>&quot;UPDATE&quot;</p><p>The function updates a calendaring item in a Calendar using a reply-type <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> object. This item specifies if a particular attendee has accepted or rejected the invitation. Other <em>params</em> elements:</p><ul><li><p><code>data</code></p><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> &quot;reply&quot; element to use for updating.</p></li></ul></li></ul></li></ul><h3 id="FileStorage" tabindex="-1">File Storage <a class="header-anchor" href="#FileStorage" aria-label="Permalink to &quot;File Storage {#FileStorage}&quot;">​</a></h3><p>The following functions manage files and file directories in the current Account <a href="./../admin/storage/FileStore.html">File Storage</a>.<br> To access other Accounts File Storage, specify a file or folder name as a ~<em>account</em>[@<em>domainName</em>]/<em>fileName</em> string.</p><ul><li><p><code>ReadStorageFile(fileDescr)</code></p><p>This function reads a File Storage file.<br> If the <em>fileDescr</em> value is a string, it specifies the name of the <a href="./../admin/storage/FileStore.html">File Storage</a> file to read. The entire file is read - and only files not larger than 1MB in size can be read this way.<br> If the <em>fileDescr</em> value is a dictionary, the following dictionary elements are used:</p><ul><li><p><code>fileName</code></p><p>a string - the name of the file to read</p></li><li><p><code>position</code></p><p>an optional element. Its value should be a non-negative number, it specifies the file position (in bytes) from which reading should start.</p></li><li><p><code>limit</code></p><p>an optional element. Its value should be a non-negative number, it specifies the maximum data length to read (in bytes). If the file is shorter than starting position plus the read limit, a shorter datablock is read. This value should not exceed 1MB.<br> This function returns a datablock value with the file content, or a null-value if the specified file could not be read.</p></li></ul></li><li><p><code>WriteStorageFile(fileDescr,data)</code></p><p>This function stores the <em>data</em> value (which should be either a datablock or a string) into the specified <a href="./../admin/storage/FileStore.html">File Storage</a> file.<br> If the <em>fileDescr</em> value is a string, it specifies the name of the file to write to. The entire file is rewritten.<br> If the <em>fileDescr</em> value is a dictionary, the following dictionary elements are used:</p><ul><li><p><code>fileName</code></p><p>a string - the name of the file to write</p></li><li><p><code>position</code></p><p>an optional element. If present, the file is not completely rewritten.<br> If this element value is a non-negative number, it specifies the file position (in bytes) from which writing should start.<br> If this element value is the &quot;end&quot; or &quot;append&quot; string, the writing operation starts from the current file end.<br> If this element value is the &quot;new&quot; string, the writing operation checks that the file does not already exist.<br> This function returns a null-value if the file is successfully written, otherwise it returns a string with an error code.</p></li></ul></li><li><p><code>AppendStorageFile(fileName,data)</code></p><p>This function appends the <em>data</em> datablock or string to the end of the <em>fileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file.<br> If <em>fileName</em> is not a string or <em>data</em> is not a datablock nor it is a string, this function call results in a program exception.<br> This function returns a null-value if the file is successfully written, otherwise it returns a string with an error code.</p></li><li><p><code>DeleteStorageFile(fileName)</code></p><p>This function deletes the <em>fileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file.<br> This function returns a null-value if the file is successfully deleted, otherwise it returns a string with an error code.</p></li><li><p><code>RenameStorageFile(oldFileName,newFileName)</code></p><p>This function renames the <em>oldFileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file into <em>newFileName</em>. Both parameters must have string values.<br> This function returns a null-value if the file is successfully renamed, otherwise it returns a string with an error code.</p></li><li><p><code>CreateStorageDirectory(directoryName)</code></p><p>This function creates the <em>directoryName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> directory.<br> This function returns a null-value if the directory is successfully created, otherwise it returns a string with an error code.</p></li><li><p><code>RenameStorageDirectory(oldDirectoryName,newDirectoryName)</code></p><p>This function renames the <em>oldDirectoryName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> directory into <em>newDirectoryName</em>. Both parameters must have string values.<br> This function returns a null-value if the directory is successfully renamed, otherwise it returns a string with an error code.</p></li><li><p><code>DeleteStorageDirectory(directoryName)</code></p><p>This function deletes the <em>directoryName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> directory. The directory should be empty.<br> This function returns a null-value if the directory is successfully deleted, otherwise it returns a string with an error code.</p></li><li><p><code>ListStorageFiles(folderName)</code></p><p>This function returns information about all files in the specified <a href="./../admin/storage/FileStore.html">File Storage</a> subdirectory.<br> If <em>folderName</em> is not a string, information about the top-level directory in the current Account <a href="./../admin/storage/FileStore.html">File Storage</a> is returned.<br> This function returns a null-value if an error occurred. Otherwise, the function returns a dictionary. Each dictionary key is a file or a subdirectory name, and the dictionary value is a dictionary with the following elements:</p><ul><li><p><code>STFileSize</code></p><p>a numeric value with the file size in bytes. This element is present for files and absent for subdirectories.</p></li><li><p><code>STCreated</code></p><p>(optional) a timestamp value with the file creation date.</p></li><li><p><code>STModified</code></p><p>a timestamp value with the file modification date.</p></li><li><p><code>MetaModified</code></p><p>(optional) a timestamp value with the file or subdirectory attribute set modification date.</p></li></ul></li><li><p><code>ReadStorageFileAttr(fileName,attributes)</code></p><p>This function reads attributes of the <em>fileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file or file directory.<br> If <em>fileName</em> is not a string or <em>attributes</em> is neither an array nor a null-value, this function call results in a program exception.<br> The <em>attributes</em> value should be either a null-value (then all file attributes are retrieved), or an array of strings - then only the attributes with names included into the array are retrieved.<br> If attributes are successfully retrieved, this function returns an array of file attributes (each attribute is an XML object). Otherwise the function returns a string with an error code.</p></li><li><p><code>WriteStorageFileAttr(fileName,attributes)</code></p><p>This function modifies attributes of the <em>fileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file or file directory.<br> If <em>fileName</em> is not a string or <em>attributes</em> is not an array, this function call results in a program exception.<br> The <em>attributes</em> value should be an array of XML objects. See the <a href="./XMLAPI.html#fileAttrWrite">XIMSS</a> section for more details.<br> This function returns a null-value if the attributes have been successfully updated, otherwise it returns a string with an error code.</p></li><li><p><code>LockStorageFile(fileName,params)</code></p><p>This function manages &quot;locks&quot; of the <em>fileName</em> <a href="./../admin/storage/FileStore.html">File Storage</a> file or file directory.<br> If <em>fileName</em> is not a string or <em>params</em> is not a dictionary, this function call results in a program exception.<br> The <em>params</em> value should be a dictionary with lock request parameters. See the <a href="./XMLAPI.html#fileLock">XIMSS</a> section for more details.<br> This function returns a dictionary if the operation has been completed successfully, otherwise it returns a string with an error code.</p></li></ul><h3 id="Roster" tabindex="-1">Roster <a class="header-anchor" href="#Roster" aria-label="Permalink to &quot;Roster {#Roster}&quot;">​</a></h3><p>The following built-in functions implement an interface to the Account Roster.</p><ul><li><p><code>ReadRoster()</code><br><code>ReadRoster(accountName)</code></p><p>This function retrieves Roster items.<br> If the the <em>accountName</em> parameter is not specified, or if its value is a null-value, the current Account Roster is read, otherwise the <em>accountName</em> value should be a string specifying the name of the Account to read Roster items from.<br> This function returns a dictionary with Roster items, where dictionary keys are contact E-mail addresses, and dictionary values are dictionaries with the following elements:</p><ul><li><p><code>Inp</code></p><p>the &quot;incoming&quot; subscription mode: it controls if the contact can watch the user presence. Possible values: null-value, true-value, &quot;Pending&quot;, &quot;Blocked&quot;.</p></li><li><p><code>Out</code></p><p>the &quot;outgoing&quot; subscription mode: it controls if the user can watch the contact presence. Possible values: null-value, true-value, &quot;Pending&quot;.</p></li><li><p><code>RealName</code></p><p>the contact real name string (optional). If the function fails to retrieve Roster items, it returns an error code string.</p></li></ul></li><li><p><code>SetRoster(params)</code><br><code>SetRoster(params,accountName)</code></p><p>This function updates a Roster item.<br> If the the <em>accountName</em> parameter is not specified, or it value is a null-value, the current Account Roster is updated, otherwise the <em>accountName</em> value should be a string specifying the name of the Account to update.<br> The <em>params</em> should be a dictionary with the following elements:</p><ul><li><p><code>peer</code></p><p>The contact E-mail address string (&quot;<em>accountName</em>@<em>domainName</em>&quot;).</p></li><li><p><code>what</code></p><p>The operation type string:</p><ul><li>&quot;update&quot;: update the contact information.</li><li>&quot;remove&quot;: remove the contact from the Roster.</li><li>&quot;subscribed&quot;: confirm the contact request to monitor the user&#39;s presence information.</li><li>&quot;unsubscribed&quot;: reject the contact request to monitor the user&#39;s presence information, or revoke the already granted right to monitor.</li><li>&quot;subscribe&quot;: send a request to monitor the contact&#39;s presence information.</li><li>&quot;subBoth&quot;: confirm the contact request to monitor the user&#39;s presence information, and send a request to monitor the contact&#39;s presence information.</li><li>&quot;unsubscribe&quot;: stop monitoring the contact&#39;s presence information.</li></ul></li><li><p><code>data</code></p><p>optional - a dictionary containing new contact info.</p></li></ul></li></ul><h3 id="Dataset" tabindex="-1">Datasets <a class="header-anchor" href="#Dataset" aria-label="Permalink to &quot;Datasets {#Dataset}&quot;">​</a></h3><p>The following built-in functions implement an interface to the Account Datasets. To access Datasets in other Accounts, the dataset name should be specified as a &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>datasetName</em>&quot; string.</p><ul><li><p><code>DatasetList(datasetName,filterField,filterValue)</code></p><p>This function retrieves data entries from an Account dataset.<br> The <em>datasetName</em> value should be a string with the dataset name.<br> The <em>filterField</em>, <em>filterValue</em> values should be null-values or strings. If the values are strings, they specify an entry attribute name and value. Only the entries that have the specified attribute with the specified value are included into the resulting value.<br> This function returns a dictionary with dataset entries. The dictionary keys are entry names, the dictionary elements are data entries. Each data entry is a dictionary containing the data entry attributes.<br> If the dataset entries could not be retrieved, the function returns an error code string.</p></li><li><p><code>DatasetCreate(datasetName)</code></p><p>This function creates an Account dataset.<br> The <em>datasetName</em> value should be a string; it specifies the dataset name.<br> If the dataset is created successfully, the function returns a null-value. Otherwise the function returns an error code string.</p></li><li><p><code>DatasetRemove(datasetName,ifExists)</code></p><p>This function removes an Account dataset.<br> The <em>datasetName</em> value should be a string; it specifies the dataset name.<br> If the <em>ifExists</em> value is not a null-value, and the dataset to be removed already does not exist, the function does not return an error code.<br> If the dataset is removed successfully, the function returns a null-value. Otherwise the function returns an error code string.</p></li><li><p><code>DatasetSet(datasetName,entryName,entryData,ifExists)</code></p><p>This function modifies data entries in an Account dataset.<br> The <em>datasetName</em> value should be a string; it specifies the dataset name.<br> The <em>entryName</em> value should be a string; it specifies the entry name.<br> The <em>entryData</em> value should be a dictionary; it specifies the entry data (attributes).<br> If the <em>ifExists</em> value is a null-value, then the dataset is created if it does not exist, and the entry with the specified name is created if it does not exist.<br> If the dataset is updated successfully, the function returns a null-value. Otherwise the function returns an error code string.</p></li><li><p><code>DatasetDelete(datasetName,entryName,ifExists)</code></p><p>This function deletes a data entry from an Account dataset.<br> The <em>datasetName</em> value should be a string; it specifies the dataset name.<br> The <em>entryName</em> value should be a string; it specifies the entry name.<br> If the <em>ifExists</em> value is not a null-value, and the entry to be deleted already does not exist, the function does not return an error code.<br> If the dataset is removed successfully, the function returns a null-value. Otherwise the function returns an error code string.</p></li></ul><h3 id="Directory" tabindex="-1">Directory <a class="header-anchor" href="#Directory" aria-label="Permalink to &quot;Directory {#Directory}&quot;">​</a></h3><p>The following built-in functions implement an interface to the <a href="./../admin/directory/">Directory</a> Manager.</p><ul><li><p><code>DirectorySearch(baseDN,filter,parameters)</code></p><p>This function performs a directory search, returning a dictionary with found records.<br> The <em>baseDN</em> value should be a string with the search base DN. If this value is &quot;$&quot;, the <a href="./../admin/directory/CentralDir.html">Directory Integration</a> settings are used to compose the base DN for the current Domain.<br> The <em>filter</em> value should be a null-value, or a string with a search filter, in the RFC2254 format.<br> The <em>parameters</em> value should be a null-value or a dictionary containing search options:</p><ul><li><p><code>limit</code></p><p>If this option value is a positive number, it specifies the maximum number of records to return. Otherwise, the record limit is set to 100.</p></li><li><p><code>keys</code></p><p>If this option value is &quot;DN&quot;, the resulting dictionary keys are full record DNs. Otherwise, the record RDNs are used as resulting dictionary keys.</p></li><li><p><code>scope</code></p><p>If this option value is &quot;sub&quot;, a subtree search is performed. Otherwise, only the direct children of the base DN record are searched.</p></li><li><p><code>attributes</code></p><p>If this option value is an array of strings, only the attributes listed in the array are included into resulting records.<br> Otherwise, all record attributes are included into resulting records.<br> If the directory search operation fails (no base DN record, insufficient access rights, etc.), this function returns an error code string.</p></li></ul></li><li><p><code>DirectoryModify(theDN,newRDN,record)</code></p><p>This function performs a directory search, returning a dictionary with found records.<br> The <em>theDN</em> value should be a string with the record DN. If this value is &quot;$&quot;, the <a href="./../admin/directory/CentralDir.html">Directory Integration</a> settings are used to compose the base DN for the current Domain.<br> The <em>newRDN</em> value should be a null-value, or a string with a new relative DN for the record, where the record should be relocated.<br> The <em>record</em> value should be a null-value (then the record specified with theDN parameter is deleted) or a dictionary containing attributes for the record to be created.<br> If the directory modification operation fails (no base DN record, insufficient access rights, etc.), this function returns an error code string.</p></li></ul><h3 id="Services" tabindex="-1">Services <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Services {#Services}&quot;">​</a></h3><ul><li><p><code>GetLanguage()</code></p><p>This function value is a string with the currently &quot;selected language&quot;.</p></li><li><p><code>SetLanguage(lang)</code></p><p>This procedure sets the &quot;selected language&quot;. The <em>lang</em> value should be a string with the language name, or a null-value to select the default language.</p></li><li><p><code>GetTimeZoneName()</code></p><p>This function value is a string with the currently selected time zone name. If no time zone is selected (the Server time offset is used), the function returns a null-value.</p></li><li><p><code>SetTimeZone(zoneName)</code></p><p>This procedure sets the current time zone. The <em>zoneName</em> value should be a string with a known time zone name. If an unknown zone name is specified, or if the <em>zoneName</em> value is not a string, the <em>no zone</em> fictitious value is set, and the Server current time offset is used.</p></li><li><p><code>ReadEnvirFile(fileName)</code></p><p>This function retrieves the specified file from the current &quot;environment&quot; - such as the <a href="./PBXApp.html">Real-Time Application</a> environment.<br> This function value is a datablock with the file content or a null-value if the specified file does not exist.</p></li><li><p><code>ReadSkinObject(tagName)</code><br><code>ReadSkinObject(tagName,index)</code><br><code>ReadSkinObject(tagName,index,skinName)</code></p><p>This function retrieves the specified object from the specified WebUser skin&#39;s <a href="./WebApp.html#Strings">Text Dataset</a> (or the Basic skin, if <em>skinName</em> is not specified). Object is specified by its <em>tagName</em> and <em>index</em>, where <em>index</em> can be either of:</p><ul><li><p><code>null</code></p><p>the entire object is returned;</p></li><li><p><em>a string</em></p><p>used as the key when the object is a dictionary;</p></li><li><p><em>a number</em></p><p>used as the index when the object is an array or a dictionary;</p></li><li><p><em>an array</em></p><p>elements are sequentially used as keys or indices through the object hierarchy. This function value is the object defined by the combination of <em>tagName</em> and <em>index</em> or a null-value if the specified object does not exist in the skin&#39;s Text Dataset.</p></li></ul></li><li><p><code>SysLog(arg)</code></p><p>This procedure places the textual representation of the <em>arg</em> value into the Server Log.</p></li><li><p><code>SysProfile(arg)</code></p><p>If the <em>arg</em> value is a null-value, the procedure decreases an internal integer <em>profile level</em> counter by 1, otherwise it increases it by 1.<br> The <em>profile level</em> counter is set to zero when the program starts.<br> When the <em>profile level</em> counter is positive, profiling records are placed into the Server Log when every user-defined and some built-in functions and procedures are entered and exited.</p></li><li><p><code>ExecuteCLI(arg)</code></p><p>This function executes the <a href="./CLI.html">Command Line Interface (CLI)</a> command.<br> The <em>arg</em> value should be a string containing one CLI command.<br> If the CLI command has been executed successfully, this function returns a null-value. Otherwise this function returns an error code string.<br> If the CLI command has produced an output, it is placed into the <a href="#VarsF">Task variable</a> <code>executeCLIResult</code> (it can be accessed as <code>Vars().executeCLIResult</code>.<br> If the CLI command has failed, or it has not produced any output, this Task variable is assigned a null-value.</p></li><li><p><code>SetApplicationStatus(arg)</code></p><p>This procedure copies its argument and stores is in the current Task descriptor.<br> External modules and entities can retrieve this information from the Task descriptor.</p></li><li><p><code>StoreCDR(arg)</code></p><p>This procedure sends the <em>arg</em> value (which should be a string) to the <a href="./Helpers.html#CDR">External CDR Processor</a> program.<br> The &quot;APP&quot; prefix is added to the <em>arg</em> value, and the application is supposed to provide its name and the version number as the first part of the <em>arg</em> value to allow the External CDR Processor program to differentiate records generated with different applications: APP <em>arg</em></p></li><li><p><code>DoBalance(parameters,accountName)</code></p><p>This function performs a <a href="./../admin/misc/Billing.html">Billing</a> operation.<br> If the <em>accountName</em> is null, the operation is applied to the current Account. Otherwise, the <em>accountName</em> value must be a string specifying the target Account name. In any case, the operation is subject to the Access Rights restrictions.<br> The <em>parameters</em> value must be a dictionary. It specifies the operation parameters, see the <a href="./../admin/misc/Billing.html">Billing</a> section for the details. The operation name should be specified as the value of the dictionary key &quot;op&quot;.<br> The function returns an error code string if the operation has failed.<br> Otherwise the function returns a dictionary with the operation results (as specified in the <a href="./../admin/misc/Billing.html">Billing</a> section).</p></li><li><p><code>Statistics(elementName,opCode,setValue)</code></p><p>This function reads and updates the Server <a href="./../admin/sysadmin/Statistics.html">Statistics Element</a> value.<br> The <em>elementName</em> value should be a string specifying either a <a href="./../admin/sysadmin/Statistics.html">Statistics Element</a> OID, or a <a href="./../admin/sysadmin/Statistics.html#Custom">Custom Statistics Element</a> name.<br> The <em>setValue</em> value should be a numeric value.<br> The <em>opCode</em> value should be a null-value or a string. If the string value is &quot;inc&quot;, then the Element value is increased by the <em>setValue</em> value. If the string value is &quot;set&quot;, then the Element value is set to the <em>setValue</em> value. If the value is a null-value, then the Element value is not modified.<br> Only the Custom Statistics Elements can be modified.<br> The function returns either a number - the current Statistics Element value, or an error code string.</p></li><li><p><code>CallHelper(name,parameters)</code><br><code>CallHelper(name,parameters,mode)</code></p><p>This function sends a request to an <a href="./Helpers.html#AppHelpers">External Application Helper</a>.<br> The <em>name</em> value should be a string specifying the Application Helper name.<br> The <em>parameters</em> value (application-specific) is passed to the Application Helper program.<br> The optional <em>mode</em> string is used to specify the cluster member that is used to run Application Helper program.<br> The function returns the data object from the External Application Helper response (it may return a null-value).</p></li><li><p><code>BannerRead(type,parameters)</code></p><p>This function sends a request to the <a href="./Helpers.html#Banner">External Banner System</a>.<br> The <em>type</em> value should be a string specifying the banner type (application-specific, such as &quot;prontoEmailTop&quot;, &quot;myClientLeftBanner&quot;).<br> The <em>parameters</em> value is passed to the External Banner System.<br> The function returns the banner data object from the External Banner System response (it may return a null-value).</p></li><li><p><code>syncDelay(milliseconds)</code></p><p>This function blocks the execution of the script for the specified number of milliseconds.</p></li></ul><h3 id="Communications" tabindex="-1">Communications <a class="header-anchor" href="#Communications" aria-label="Permalink to &quot;Communications {#Communications}&quot;">​</a></h3><ul><li><p><code>HTTPCall(URL,parameters)</code></p><p>This function performs an HTTP transaction.<br> The current Account must have the <code>HTTP</code> <a href="./../admin/objects/Accounts.html#Services">Service</a> enabled.<br> The <em>URL</em> value should be a string. It specifies the request URL.<br> The <em>parameters</em> value should be a dictionary. It specifies the request parameters and, optionally, the request body.<br> These values, along with the maximum time-out time of 30 seconds are passed to the <a href="./../admin/services/HTTP.html#Client">HTTP Client</a> module for processing.<br> This function returns either a result dictionary the HTTP module produced, or an error code string.</p></li><li><p><code>SubmitEMail(headers,content)</code></p><p>This function composes and sends an E-mail message.<br> The <em>headers</em> value should be a null-value or a dictionary. This dictionary specifies the header field values for the composed E-mail message. The following elements are processed (all of them are optional):</p><ul><li><p><code>From</code></p><p>the element value should be an E-mail address string. It specifies the message <code>From:</code> address</p></li><li><p><code>To</code></p><p>the element value should be an E-mail address string or an array of E-mail address strings. It specifies the message <code>To:</code> address(es)</p></li><li><p><code>Cc</code></p><p>the element value should be an E-mail address string or an array of E-mail address strings. It specifies the message <code>Cc:</code> address(es)</p></li><li><p><code>Bcc</code></p><p>the element value should be an E-mail address string or an array of E-mail address strings. It specifies the message <code>Bcc:</code> address(es)</p></li><li><p><code>Subject</code></p><p>the element value should be a string. It specifies the message <code>Subject:</code> field.</p></li><li><p><code>Date</code></p><p>the element value should be a timestamp. It specifies the message <code>Date:</code> field. If this element is absent, the current time is used.</p></li><li><p><code>sourceType</code></p><p>the element value should be a string. It specifies the <a href="./../admin/mail/#Sources">message source</a>. If this element is absent, the &quot;CGPL&quot; string value is used.</p></li><li><p><code>sourceAddress</code></p><p>the element value should be a string. It specifies the address of the message source (network address, remote system name, etc.)</p></li><li><p><code>Message-ID</code></p><p>the element value should be a string. It specifies the message <code>Message-ID:</code> field. If this element is absent, an automatically generated string is used.</p></li><li><p><code>protocol</code></p><p>the element value should be a string. It specifies the name of the protocol used to submit this message.</p></li><li><p><code>Content-Class</code></p><p>the element value should be a string. It specifies the E-mail header <code>Content-Class:</code> field value.</p></li><li><p><code>X-Priority</code></p><p>the element value should be a string. It specifies the E-mail header <code>X-Priority:</code> field value.</p></li><li><p><code>X-Mailer</code></p><p>the element value should be a string. It specifies the message <code>X-Mailer:</code> field. If this element is absent, an automatically generated string is used. The <em>content</em> value specifies the E-mail message body. If the value is a dictionary, then the dictionary <code>body</code> element is the actual content, and other dictionary elements specify various body parameters (content header fields). Otherwise the <em>content</em> itself is the actual content and the content body parameters set is an empty one.<br> The following content body parameters (dictionary elements) are processed (all of them are optional):</p></li><li><p><code>Content-Type</code></p><p>the element value should be a string. It specifies the content body Content-Type. If this element is not specified, the Content-Type is set to &quot;text&quot; if the actual content is a string, otherwise it the Content-Type is set to &quot;application&quot;</p></li><li><p><code>Content-Subtype</code></p><p>the element value should be a string. It specifies the content body Content-Type subtype. If this element is absent, and the Content-Type is set to &quot;text&quot;, the Content-Subtype is set to &quot;plain&quot;</p></li><li><p><code>filename</code></p><p>the element value should be a string. It specifies the content body file name.</p></li><li><p><code>Content-Disposition</code></p><p>the element value should be a string. It specifies the content body Content-Disposition. If this element is absent, and the <code>fileName</code> element is present, the Content-Disposition value is set to &quot;attachment&quot;<br> If the actual content is a string, it is stored &quot;as is&quot;, using the <code>8bit</code> Content-Transfer-Encoding.<br> If the actual content is a datablock, it is stored using the <code>base64</code> Content-Transfer-Encoding.<br> If the actual content is an array, the content is a multi-part one. Only the Content-Subtype parameter element is used, if it is absent, the &quot;mixed&quot; value is used.<br> Each array element is stored in the same way as the <em>content</em> value itself.<br> If the actual content is not an array, a string, or a datablock, an empty content body is stored.<br> This function returns a null-value if an E-mail message has been composed and sent (submitted to the Queue). Otherwise, this function returns an error code string.</p></li></ul><p>In the following example, a simple text message is sent.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Message&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  result  = SubmitEmail(headers,&quot;Test Message Body\\eEnd Of Message\\e&quot;);</span></span></code></pre></div><p>In the following example, a multipart/mixed message is sent. It contains an HTML text and a binary attachment.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>content = NewArray();</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  textPart = NewDictionary();</span></span>
<span class="line"><span>  textPart.(&quot;Content-Type&quot;) = &quot;text&quot;;</span></span>
<span class="line"><span>  textPart.(&quot;Content-Subtype&quot;) = &quot;html&quot;;</span></span>
<span class="line"><span>  textPart.body = &quot;&lt;HTML&gt;&lt;BODY&gt;This is an &lt;B&gt;HTML&lt;/B&gt; text&lt;/BODY&gt;&lt;/HTML&gt;&quot;;</span></span>
<span class="line"><span>  content[0] = textPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  dataPart = NewDictionary();</span></span>
<span class="line"><span>  dataPart.(&quot;Content-Type&quot;)    = &quot;image&quot;;</span></span>
<span class="line"><span>  dataPart.(&quot;Content-Subtype&quot;) = &quot;gif&quot;;</span></span>
<span class="line"><span>  dataPart.fileName = &quot;file.gif&quot;;</span></span>
<span class="line"><span>  dataPart.body     = ReadStorageFile(dataPart.fileName);</span></span>
<span class="line"><span>  content[1] = dataPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Attachment&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  headers.(&quot;Content-Class&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  result = SubmitEMail(headers,content);</span></span></code></pre></div><p>It is possible to include parts of other E-mail messages into a newly composed one. If there is a content body parameter <code>MIMEPartID</code> with a string value, then there must be a content body parameter <code>source</code> with a Message Handle value.<br> If the <code>MIMEPartID</code> parameter value is &quot;message&quot;, the entire <code>source</code> Message is copied (as a <code>message/rfc822</code> MIME part body).<br> If the <code>MIMEPartID</code> parameter value is any other string, it specifies the MIME part of the <code>source</code> Message to be copied into the new message; when copying the part headers, only the MIME (<code>Content-xxxxxx</code>) fields are copied.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>content = NewArray();</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  textPart = NewDictionary();</span></span>
<span class="line"><span>  textPart.(&quot;Content-Type&quot;)    = &quot;text&quot;;</span></span>
<span class="line"><span>  textPart.(&quot;Content-Subtype&quot;) = &quot;plain&quot;;</span></span>
<span class="line"><span>  textPart.body = &quot;Please see the attached letter.\\e&quot;;</span></span>
<span class="line"><span>  content[0] = textPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  attachPart = NewDictionary();</span></span>
<span class="line"><span>  attachPart.(&quot;source&quot;)    = MyOldMessage;</span></span>
<span class="line"><span>  attachPart.(&quot;MIMEPartID&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span>  content[1] = dataPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Forwarded message&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  headers.(&quot;Content-Class&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  result = SubmitEMail(headers,content);</span></span></code></pre></div></li><li><p><code>SendEMail(fromAddress,subject,to,headers,content)</code></p><p>This function composes and sends an E-mail message. A call to this function does the same as the SubmitEMail(<em>headers</em>,<em>content</em>) function call, where the <em>fromAddress</em>, <em>subject</em>, and <em>to</em> value (if they are not null-values) are used instead of the <em>headers</em> dictionary <code>From</code>,<code>Subject</code>, and <code>To</code> elements.</p><p>In the following example, a simple text message is sent.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>result = SendEmail(&quot;from@sender.dom&quot;,&quot;Test Message&quot;,&quot;To@recipient.dom&quot;,</span></span>
<span class="line"><span>                      null,&quot;Test Message\\eEnd Of Message\\e&quot;);</span></span></code></pre></div></li><li><p><code>SendInstantMessage(fromAddress,toAddress,content)</code></p><p>This function sends an Instant Message.<br> The <em>fromAddress</em> value should be a string or a null-value. It specifies the message <code>From</code> (sender) address.<br> If this value is a null-value, then the sender address is the current Account address.<br> If this value is a string, but it does not contain a @ symbol, the sender address is the current Account address, and this value is used as the sender &quot;instance&quot; name.<br> If this value contains a @ symbol, it can also specify the sender &quot;instance&quot; name, as in &quot;user@domain/instance&quot; string.<br> The <em>toAddress</em> value should be a string. It specifies the message <code>To</code> (recipient) address.<br> It must contain the @ symbol and it can specify the recipient &quot;instance&quot; name, as in &quot;user@domain/instance&quot; string.<br> The <em>content</em> value should be a string or a dictionary. If the value is a string, it specifies the message content. If the value is a dictionary, it can contain the following elements:</p><ul><li><p><code>&quot;&quot;</code> (empty string)</p><p>this optional element should be a string - the instant message body.</p></li><li><p><code>type</code></p><p>this optional element should be a string - the instant message XMPP-style type - &quot;chat&quot;, &quot;groupchat&quot;, etc.</p></li><li><p><code>id</code></p><p>this optional element should be an string - it specifies the IM request &quot;id&quot; attribute.</p></li><li><p><code>suppl</code></p><p>this optional element should be an array of XML objects to be sent inside the instant message.</p></li><li><p><code>IMSubject</code></p><p>this optional element should be a string - the instant message subject.</p></li><li><p><code>IMState</code></p><p>if this optional element is present, the &quot;&quot; (body), IMSubject and suppl elements should not be used. This element should be one of the strings &quot;gone&quot;, &quot;composing&quot;, &quot;paused&quot;, &quot;active&quot;, and informs the recipient about the sender intentions.<br> The function only initiates an Instant Message signaling operation, it does not wait for the message delivery operation to complete.<br> This function returns a null-value if an Instant Message has been composed and sent (submitted to the Signal component). Otherwise, this function returns an error code string.</p></li></ul></li><li><p><code>SendXMPPIQ(fromAddress,toAddress,content)</code></p><p>This function sends an XMPP-style IQ request or a presence request.<br> The <em>fromAddress</em> and <em>toAddress</em> values have the same meaning as for the SendInstantMessage function.<br> The content value should be a dictionary with the following elements:</p><ul><li><p><code>type</code></p><p>this element should be a string - &quot;get&quot;, &quot;set&quot;, &quot;result&quot;, etc. To send a presence request, this element should be &quot;cgp_presence&quot;.</p></li><li><p><code>suppl</code></p><p>this element should be an array of XML objects to be sent inside the IQ request.</p></li><li><p><code>id</code></p><p>this element should be an string - it specifies the IQ request &quot;id&quot; attribute. This element is not used for presence requests.</p></li><li><p><code>opcode</code></p><p>this element should be an string, it is used for presence requests only. It specifies the presence request &quot;type&quot; attribute value, such as &quot;unavailable&quot;.</p></li><li><p><code>status</code></p><p>this element should be an string, it is used for presence requests only. It specifies the presence state, such as &quot;online&quot;, &quot;busy&quot;, etc.</p></li></ul><p>The function only initiates an signaling operation, it does not wait for the operation to complete.<br> This function returns a null-value if a request has been composed and sent (submitted to the Signal component). Otherwise, this function returns an error code string.</p></li><li><p><code>RADIUSCall(address,parameters)</code></p><p>This function composes and sends a RADIUS request.<br> The <em>address</em> value should be an ip-address. It specifies the address and the port of the RADIUS server to send the request to.<br> The <em>parameters</em> value should be a dictionary with the following elements:</p><ul><li><p><code>Type</code></p><p>this element should be a string. It specifies the type of RADIUS request to send:<br> &quot;authenticate&quot;, &quot;accountingStart&quot;, &quot;accountingUpdate&quot;, &quot;accountingStop&quot;.</p></li><li><p><code>Secret</code></p><p>this element should be a string. It specifies the &quot;shared secret&quot; of the RADIUS server.</p></li><li><p><code>Username</code></p><p>this element should be a string. It is used to compose the <code>userName</code> (1) request attribute.</p></li><li><p><code>Password</code></p><p>this element should exist in the <code>authenticate</code> requests, and it should be a string. It contains the clear text password to use in the authentication operation.</p></li><li><p><code>nn</code> (where nn is a decimal number)</p><p>these elements specify additional request attributes (by their attribute numbers).<br> These element values should be strings, or (for the integer-type parameters) - numbers, or (for Internet-type parameters) ip-addresses.<br> If an element value is a datablock, then the content of the datablock is sent without any encoding.<br> If an element value is an array, then the request attribute is added to the request zero or more times, once for each array value.</p></li><li><p><code>-nnnnn</code> (where nnnnn is a decimal number)</p><p>these elements specify additional vendor-specific attributes (where nnnnn is the VendorID). See the <a href="./../admin/services/RADIUS.html">RADIUS</a> section to see more on the vendor-specific attribute presentation.</p></li><li><p><code>Error</code></p><p>if this optional element value is &quot;data&quot;, and a denied-response is received for an authentication request, the function returns a response attribute dictionary (see below) with an additional <code>Error</code> element.<br> If this optional element value is not &quot;data&quot;, and a denied-response is received for an authentication request, the function returns an error string.</p></li><li><p><code>Retries</code></p><p>this optional element should be a number or a numeric string in the [1..20] range. It overrides the default limit of request resends. Set this element to 1 if you want the RADIUS request to be sent only once.</p></li><li><p><code>Timeout</code></p><p>this optional element should be a number or a numeric string in the [0..30] range. It overrides the default timeout value (in seconds). When a response is not received within the specified time, the request is resent or an error message is produced.<br> If the RADIUS operation succeeds, this function returns a dictionary. This dictionary contains attributes the RADIUS server sent in its response. If the RADIUS fails, this function returns a string with an error code.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Requests are sent using the UDP socket of the <a href="./../admin/services/RADIUS.html">RADIUS module</a>, so this module should be enabled (it should be configured to use some non-zero port number).</p></div></li></ul><p>In the following example, a RADIUS authentication request is sent. The request contains the nasIdentifier (32) text attribute.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>callParam = newDictionary();</span></span>
<span class="line"><span>callParam.Type     = &quot;authenticate&quot;;</span></span>
<span class="line"><span>callParam.Secret   = &quot;sys2&quot;;</span></span>
<span class="line"><span>callParam.Username = &quot;user4567&quot;;</span></span>
<span class="line"><span>callParam.Password = &quot;drum$1245&quot;;</span></span>
<span class="line"><span>callParam.(&quot;32&quot;)   = &quot;my NAS&quot;;</span></span>
<span class="line"><span>result = RADIUSCall(IPAddress(&quot;[10.0.1.77]:1812&quot;),callParam);</span></span></code></pre></div><p>In the following example, a RADIUS accounting request is sent. The request contains the nasIdentifier (32) text attribute and the acctSessionTime (46) numeric attribute.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>callParam = newDictionary();</span></span>
<span class="line"><span>callParam.Type     = &quot;accountingStart&quot;;</span></span>
<span class="line"><span>callParam.Secret   = &quot;sys2&quot;;</span></span>
<span class="line"><span>callParam.Username = &quot;user4567&quot;;</span></span>
<span class="line"><span>callParam.(&quot;32&quot;)   = &quot;my NAS&quot;;</span></span>
<span class="line"><span>callParam.(&quot;46&quot;)   = SessionTimeInMinites*60;</span></span>
<span class="line"><span>result = RADIUSCall(IPAddress(&quot;[10.0.1.77]:1812&quot;),callParam);</span></span></code></pre></div></li></ul><h3 id="SyncScripts" tabindex="-1">Synchronous Scripts <a class="header-anchor" href="#SyncScripts" aria-label="Permalink to &quot;Synchronous Scripts {#SyncScripts}&quot;">​</a></h3><p>CG/PL code sections can be used for immediate synchronous operation and their code can be shared between different environments. Such a code should be stored in files with the extension <code>.scgp</code>, its external modules should be store in files with the extension <code>.scgi</code> in the <a href="./WebApp.html#Skins">Basic Skin</a> environment.</p><p>A synchronous script takes an object as a parameter, which is accessible through the <code>startParameter</code> key in the <code>Vars()</code> dictionary, and returns an object as a result. The execution time-out is 5 minutes. CG/PL programs that implement both <a href="./PBXApp.html">Real-Time Applications</a> and <a href="./WebApp.html">Web Applications</a> can use the same shared synchronous scripts code.</p><ul><li><p><code>RunScript(scriptName)</code><br><code>RunScript(scriptName,paramObj)</code><br><code>RunScript(scriptName,paramObj,entryName)</code></p><p>This function is used to run a script synchronously.<br> The <em>scriptName</em> value should be a string with the script name with the optional <code>.scgp</code> suffix.<br> The <em>paramObj</em> is the optional parameter with any CG/PL object.<br> The <em>entryName</em> is the optional parameter with the name of the entry point. The entry point <code>main</code> is used if this parameter is omitted.<br> This function returns an object constructed by the synchronous script.<br> If there is a problem with running the specified script the function returns null.</p></li><li><p><code>SetResult(object)</code></p><p>This procedure is used to set result of synchronous script execution.<br> The <em>object</em> parameter will be passed as the result of the RunScript function.</p></li></ul><h2 id="MultiTask" tabindex="-1">Multitasking <a class="header-anchor" href="#MultiTask" aria-label="Permalink to &quot;Multitasking {#MultiTask}&quot;">​</a></h2><p>Certain environments (such as <a href="./PBXApp.html">Real-Time Application</a> environments) provide multitasking functionality. In these environments, program invocations (<em>Tasks</em>) can locate each other and exchange data. This section defines the additional language features available in these multitasking environments.</p><p>Task handles are internal objects representing a Task. In a <a href="./../admin/cluster/">Cluster</a> environment, a Task handler includes a reference to the cluster member running the Task.</p><h3 id="Spawn" tabindex="-1">Spawning <a class="header-anchor" href="#Spawn" aria-label="Permalink to &quot;Spawning {#Spawn}&quot;">​</a></h3><p>A program (a running Task) can create a new Task by using the spawning expression. It is specified using the <code>spawn</code> keyword followed by a name of an entry code section. A new Task is created and it starts to run concurrently with the Task that used the spawning expression, executing the specified entry code section.<br> The entry code section name can be followed with an expression enclosed in parentheses. If specified, the copy of the expression value is assigned to the <code>startParameter</code> element of the <a href="#VarsF"><code>Vars()</code> dictionary</a> (global variables) in the new Task.<br> The current Task handle is assigned to the <code>parent</code> element of the <a href="#VarsF"><code>Vars()</code> dictionary</a> in the new Task.<br> The spawning expression value is a Task handle for the newly created Task, or null if the system failed to create a new Task.</p><p>In the following example, a program executing the <code>Main</code> entry code section creates a new task that starts to execute the <code>DoBackup</code> entry code section, which copies files &quot;file1&quot;,&quot;file2&quot;,....&quot;file100&quot; into &quot;backup1&quot;,&quot;backup2&quot;,..., files.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry DoBackup is</span></span>
<span class="line"><span>  nameIndex = 1;</span></span>
<span class="line"><span>  while nameIndex &lt;= 100 loop</span></span>
<span class="line"><span>    fileData = ReadStorageFile(&quot;file&quot; + String(nameIndex));</span></span>
<span class="line"><span>    if fileData != null then</span></span>
<span class="line"><span>      resultCode = WriteStorageFile(&quot;backup&quot; + String(nameIndex),fileData);</span></span>
<span class="line"><span>      if resultCode != null then</span></span>
<span class="line"><span>        Log(&quot;failed to backup file&quot; + String(nameIndex) +</span></span>
<span class="line"><span>            &quot;. Error Code=&quot; + resultCode);</span></span>
<span class="line"><span>      end if;</span></span>
<span class="line"><span>    end if;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span>end entry;</span></span>
<span class="line"><span> </span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  backuper = spawn DoBackup;</span></span>
<span class="line"><span>  if backuper == null then</span></span>
<span class="line"><span>    Log(&quot;Failed to start a Backup Task&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>Tasks do not share any variables, even when a Task directly creates a new Task using the spawning expression.</p><ul><li><p><code>ThisTask()</code></p><p>This function returns the Task handle of the current Task.<br> This function returns a null value if the current environment is not a Task.</p></li><li><p><code>IsTask(arg)</code></p><p>This function returns a true-value if the <em>arg</em> value is a Task Handle, otherwise the function returns a null-value.</p></li></ul><h3 id="Events" tabindex="-1">Events <a class="header-anchor" href="#Events" aria-label="Permalink to &quot;Events {#Events}&quot;">​</a></h3><p>The <em>Actor Model</em> is used: Tasks exchange data by sending each other <em>Events</em>.</p><ul><li><p><code>SendEvent(taskRef,eventName)</code><br><code>SendEvent(taskRef,eventName,eventParam)</code></p><p>This function sends an Event to a Task. It returns a null value if an Event was sent successfully, or a string with an error code otherwise (for example, when the specified Task does not exist).<br> The <em>taskRef</em> value should be a Task handle.<br> The <em>eventName</em> value should be a string starting with a Latin letter.<br> The optional <em>eventParam</em> parameter value should be a null-value, or a Task handle, or a <a href="./Data.html">&quot;basic&quot;</a> object.<br> This function only sends an Event to the specified (target) Task. It does not wait till that Task receives an event, nor does it wait for any response from the target Task.</p></li><li><p><code>ReadInput(secsToWait)</code></p><p>Events sent to a task are enqueued, and the task can read the first Event in queue using this function. The function value is a dictionary containing the event data.<br> The <em>secsToWait</em> value should be a non-negative number.<br> If the Task Event queue is empty and the Task does not receive a new Event within the specified number of seconds, the function returns a null-value.<br> If this function returns a dictionary value, the dictionary contains the following elements:</p><ul><li><p><code>what</code></p><p>the Event name string. If the Event was sent using the SendEvent operation, this string is the <em>eventName</em> parameter value used in the SendEvent call in the sender Task.</p></li><li><p><code>sender</code></p><p>the Task handle of the sender Task (the Task that has sent this event). In a <a href="./../admin/cluster/">Cluster</a> environment, this Task and the current Task may be running on different Cluster member computers.<br> If the Event is sent by the platform itself, or if the sender was not a Task, the <code>sender</code> element does not exist.</p></li><li><p><code>parameter</code></p><p>the event parameter. If the event was sent using the SendEvent operation in the sender Task, this element contains the <em>eventParam</em> parameter value of the SendEvent call.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>depending on the environment, the ReadInput function can return various other objects. For example, if the function is used in a <a href="./PBXApp.html">Real-Time Application</a> environment, it can return a string containing the first enqueued DTMF symbol.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The ReadInput function may have &quot;false wakeups&quot;, i.e. it can return the null-object even before the specified time period has elapsed.</p></div></li></ul></li></ul><h3 id="Meetings" tabindex="-1">Meetings <a class="header-anchor" href="#Meetings" aria-label="Permalink to &quot;Meetings {#Meetings}&quot;">​</a></h3><p>The Meeting mechanism allows a Task to make itself known to other Tasks associated with the same Account.</p><p>Each Account can have several named Meeting Sets and an unnamed Default Meeting Set. Several named Meetings can be created in any Meeting Set. Each Meeting is a dictionary object that can contain zero or one Task handle.</p><p>The set name can be specified as a &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>setName</em>&quot; string to access Meetings Sets in other Accounts.<br> To access Meeting Sets in other Accounts, the current Account should have the <code>canImpersonate</code> Domain Access Right for the target Account Domain.</p><ul><li><p><code>CreateMeeting(setName,key)</code><br><code>CreateMeeting(setName,key,parameter)</code></p><p>This function creates a Meeting object in some Meeting Set within the current Account.<br> The <em>setName</em> parameter specifies the Meeting set name. If its value is a null-value or an empty string, the Default Meeting Set is used.<br> The <em>key</em> parameter must be a string. It specifies a unique ID or name for the new Meeting. For example, an application implementing real-time conferencing can generate a random numeric string to be used as the conference password, and it can create a Meeting using that string. Other Tasks associated with the same Account can find that Meeting (and a Task handle for the Task associated with it) if they know the <em>key</em> and the <em>setName</em> parameter values used with the CreateMeeting operation.<br> If the <em>parameter</em> parameter is specified and its value is not a null-value, that value is stored with the Meeting.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>the value is stored using its textual representation, so only the standard objects can be used as the <em>parameter</em> values or the <em>parameter</em> value sub-elements. For example, you cannot store Mailbox or Task handles.</p></div><p>This function returns a null-value if a Meeting has been created. Otherwise, this function returns an error code string.</p></li><li><p><code>ActivateMeeting(setName,key)</code><br><code>ActivateMeeting(setName,key,parameter)</code></p><p>This function adds the Task handle for the current Task to a Meeting in the current Account.<br> The <em>setName</em> and <em>key</em> parameter values specify an already created Meeting.<br> There should be no other Task handle stored in this Meeting.<br> The current Task becomes the Meeting <em>Active Task</em>.<br> The optional <em>parameter</em> parameter value is stored with the Meeting.<br> This function returns a null-value if the Task handle has been successfully added. Otherwise, this function returns an error code string.</p></li><li><p><code>DeactivateMeeting(setName,key)</code><br><code>DeactivateMeeting(setName,key,parameter)</code></p><p>This function removes Task handle for the current Task from a Meeting in the current Account.<br> The <em>setName</em> and <em>key</em> parameter values specify an already created Meeting, and that Meeting should contain a Task handle for the current Task.<br> The optional <em>parameter</em> parameter value is stored with the Meeting.<br> When this operation completes successfully, the Meeting has no <em>Active Task</em>.<br> This function returns a null-value if the Task handle has been successfully removed. Otherwise, this function returns an error code string.</p></li><li><p><code>RemoveMeeting(setName,key)</code></p><p>This function removes a Meeting from a current Account Meeting Set.<br> The <em>setName</em> and <em>key</em> parameter values specify the Meeting to remove.<br> This function returns a null-value if the Meeting has been successfully removed or if the specified Meeting has not been found. Otherwise, this function returns an error code string.</p></li><li><p><code>FindMeeting(setName,key)</code></p><p>This function retrieves Meeting information from a current Account Meeting Set.<br> The <em>setName</em> and <em>key</em> parameter values specify the Meeting to look for.<br> If the Account does not have the specified Meeting, the function returns null.<br> Otherwise, the function returns the Meeting information dictionary containing the following elements:</p><ul><li><p><code>parameter</code></p><p>the value of the <em>parameter</em> parameter used with the CreateMeeting operation.</p></li><li><p><code>id</code></p><p>a Task handle for the <em>Active Task</em>, if any.<br> In a <a href="./../admin/cluster/">Cluster</a> environment, the Active Task and the current Task may be running on different Cluster member computers.</p></li></ul></li><li><p><code>ClearMeeting(setName,key)</code></p><p>This function removes a Task handle from a Meeting (if any).<br> The <em>setName</em> and <em>key</em> parameter values specify the Meeting to clear.<br> This function can be used to clear a reference set by a Task that has died.<br> This function returns a null-value if the Meeting has been successfully cleared. Otherwise, this function returns an error code string.</p></li></ul><h3 id="Queues" tabindex="-1">Queues <a class="header-anchor" href="#Queues" aria-label="Permalink to &quot;Queues {#Queues}&quot;">​</a></h3><p>The Queue mechanism allows a Task to make itself known to other Tasks associated with the same Account. When a Task registered in a Queue is found by some other Task, the found Task is removed from the Queue.</p><p>The queue name can be specified as a &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>queueName</em>&quot; string to access Queues in other Accounts.<br> To access Queues in other Accounts, the current Account should have the <code>canImpersonate</code> Domain Access Right for the target Account Domain.</p><ul><li><p><code>Enqueue(queueName)</code><br><code>Enqueue(queueName,parameter)</code><br><code>Enqueue(queueName,parameter,pty)</code></p><p>This function registers the current Task with the Account associated with it.<br> An Account may have several Queues with Task registrations.<br> The <em>queueName</em> parameter specifies the Queue name. If this parameter value is a null-value or an empty string, the default Queue of the associated Account is used.<br> The optional <em>parameter</em> parameter value is stored with the Task registration.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>the value is stored using its textual representation, so only the standard objects can be used as the <em>parameter</em> values or the <em>parameter</em> value sub-elements. For example, you cannot store Mailbox or Task handles.</p></div><p>The optional <em>pty</em> parameter value should be a string containing a decimal number with one digit, the dot (.) symbol and any number of digits. The Task is placed in the Queue before all other Tasks with a smaller <em>pty</em> parameter value, but after all tasks with the same or larger <em>pty</em> parameter value.<br> If the <em>pty</em> parameter is not specified, or if its value is a null-string, the default &quot;1.0&quot; value is assumed.<br> A Task may register itself several times in different Queues, but it can be registered only once with any given Queue. If the Enqueue function is used by a Task that has been already enqueued into the same Queue, the function does not create a second registration. Instead, the function updates the <em>parameter</em> value enqueued with the Task and may change the Task position in the Queue according to the new <em>pty</em> parameter value.<br> The function returns a null-value if registration has failed. If registration was successful, the function returns a dictionary containing the following elements:</p><ul><li><p><code>length</code></p><p>a number - the total number of Tasks in the Queue</p></li><li><p><code>position</code></p><p>a number - the current position of the current Tasks in the Queue.<br> The position of the first Task in the Queue is 0</p></li></ul></li><li><p><code>CheckQueue(queueName)</code></p><p>This function checks the current Task position in an Account Queue.<br> The <em>queueName</em> parameter specifies the Queue name.<br> The function returns a null-value if it has failed to access the specified Queue. Otherwise, it returns the same dictionary as the Enqueue function.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The <code>position</code> element exists in the returned dictionary only if the current Task is currently enqueued into the specified Queue. If current Task was not enqueued, or if it has been already removed from the Queue by some other task, this elements will be absent.</p></div></li><li><p><code>Dequeue(queueName)</code></p><p>This procedure removes the current Task from the Account Queue.<br> The <em>queueName</em> parameter specifies the Queue name.</p></li><li><p><code>ReadQueue(queueName)</code></p><p>This function retrieves the first Task from the Account Queue.<br> The <em>queueName</em> parameter specifies the Queue name.<br> The function returns a null-value if there is no Tasks in the specified Queue.<br> Otherwise, the function returns a dictionary containing the following elements:</p><ul><li><p><code>id</code></p><p>the Task handle for the retrieved Task. In a <a href="./../admin/cluster/">Cluster</a> environment, this Task and the current Task may be running on different Cluster member computers</p></li><li><p><code>parameter</code></p><p>the value of the <em>parameter</em> parameter used when the Task was enqueued</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>this function removes the first Task from the Queue. Unless the retrieved Task re-enqueues itself into the same Queue, no other Task will find it in that Queue.</p></div></li></ul></li></ul><h2 id="Syntax" tabindex="-1">Formal Syntax <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;Formal Syntax {#Syntax}&quot;">​</a></h2><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td><em>string</em></td><td>&quot;string-data&quot;</td></tr><tr><td><em>number</em></td><td>&quot;digits&quot;</td></tr><tr><td><em>name</em></td><td>&quot;alpha-numeric-and-underscore-starting-with-alpha&quot;</td></tr><tr><td><em>variable</em></td><td><em>name</em></td></tr><tr><td><em>codeName</em></td><td><em>name</em> | <em>name</em> :: <em>name</em></td></tr><tr><td><em>varDeclaration</em></td><td><code>var</code> <em>name</em> 0*(<code>,</code> <em>name</em>)</td></tr><tr><td><em>varValueDeclaration</em></td><td><code>var</code> <em>name</em> [<code>=</code> <em>expr</em>] <strong>0*</strong> (<code>,</code> <em>name</em> [<code>=</code> <em>expr</em>] )</td></tr><tr><td><em>dataRef</em></td><td><em>variable</em> | <em>expr</em> <code>[</code> <em>expr</em> <code>]</code> | <em>expr</em> <code>.</code> <em>name</em> | <em>expr</em> <code>.(</code> <em>expr</em> <code>)</code></td></tr><tr><td><em>constDeclaration</em></td><td><code>const</code> <em>name</em> <code>=</code> <em>constExpr</em> <strong>0*</strong> (<code>,</code> <em>name</em> <code>=</code> <em>constExpr</em>)</td></tr><tr><td><em>constExpr</em></td><td><em>string</em> | <em>number</em> | <code>null</code> | <code>false</code> | <code>true</code></td></tr><tr><td><em>spawnExpr</em></td><td><code>spawn</code> <em>name</em> [ <code>(</code> <em>expr</em> <code>)</code> ]</td></tr><tr><td><em>basicExpr</em></td><td><em>constExpr</em> | <em>dataRef</em> | <em>expr</em> <code>.</code> <em>name</em> <code>(</code> [ <em>argList</em> ] <code>)</code> | <em>spawnExpr</em></td></tr><tr><td><em>unaryOp</em></td><td><code>!</code> | <code>not</code> | <code>-</code> | <code>+</code></td></tr><tr><td><em>unary</em></td><td><em>basicExpr</em> | <em>unaryOp</em> <em>unary</em> | <code>(</code> <em>expr</em> <code>)</code></td></tr><tr><td><em>multOp</em></td><td><code>\\</code> | <code>/</code> | <code>%</code></td></tr><tr><td><em>multBinary</em></td><td><em>unary</em> | <em>multBinary</em> <em>multOp</em> <em>unary</em></td></tr><tr><td><em>addOp</em></td><td><code>+</code> | <code>-</code></td></tr><tr><td><em>addBinary</em></td><td><em>multBinary</em> | <em>addBinary</em> <em>addOp</em> <em>multBinary</em></td></tr><tr><td><em>cmpOp</em></td><td><code>&lt;</code> | <code>&lt;=</code> | <code>==</code> | <code>!=</code> | <code>&gt;=</code> | <code>\\&gt;</code></td></tr><tr><td><em>cmpBinary</em></td><td><em>addBinary</em> | <em>cmpBinary</em> <em>cmpOp</em> <em>addBinary</em></td></tr><tr><td><em>logicOp</em></td><td><code>&amp;</code> | <code>and</code> | <code>|</code> | <code>or</code> | <code>&amp;&amp;</code> | <code>and then</code> | <code>||</code> | <code>or else</code></td></tr><tr><td><em>logicBinary</em></td><td><em>cmpBinary</em> | <em>logicBinary</em> <em>logOp</em> <em>cmpBinary</em></td></tr><tr><td><em>ternary</em></td><td><em>logicBinary</em> | <em>logicBinary</em> <code>?</code> <em>logicBinary</em> <code>:</code> <em>ternary</em></td></tr><tr><td><em>expr</em></td><td><em>ternary</em></td></tr><tr><td><em>argList</em></td><td><em>expr</em> <strong>0*</strong> (<code>,</code> <em>expr</em>)</td></tr><tr><td><em>funcCall</em></td><td><em>codeName</em> <code>(</code> [ <em>argList</em> ] <code>)</code></td></tr><tr><td><em>procCall</em></td><td><em>codeName</em> <code>(</code> [ <em>argList</em> ] <code>)</code> | <em>expr</em> <code>.</code> <em>name</em> <code>(</code> [ <em>argList</em> ] <code>)</code></td></tr><tr><td><em>letOp</em></td><td><code>=</code> | <code>+=</code> | <code>-=</code> | <code>*=</code> | <code>/=</code> | <code>%=</code> | <code>|=</code> | <code>&amp;=</code></td></tr><tr><td><em>letOper</em></td><td><em>dataRef</em> <em>letOp</em> <em>expr</em></td></tr><tr><td><em>nullOper</em></td><td>| <code>null</code></td></tr><tr><td><em>stopOper</em></td><td><code>stop</code></td></tr><tr><td><em>returnOper</em></td><td><code>return</code> [ <em>expr</em> ]</td></tr><tr><td><em>ifOper</em></td><td><code>if</code> <em>expr</em> <code>then</code> <em>opSequence</em> <strong>0*</strong> ( <code>elif</code> <em>expr</em> <code>then</code> <em>opSequence</em> ) [ <code>else</code> <em>opSequence</em> ] <code>end</code> [ <code>if</code> ]</td></tr><tr><td><em>altIfOper</em></td><td><code>if</code> <em>expr</em> <code>{</code> <em>opSequence</em> <code>}</code> <strong>0*</strong> ( <code>elif</code> <em>expr</em> <code>{</code> <em>opSequence</em> <code>}</code> ) [ <code>else</code> <code>{</code> <em>opSequence</em> <code>}</code> ]</td></tr><tr><td><em>loopInitOp</em></td><td><em>letOp</em> | <em>varValueDeclaration</em></td></tr><tr><td><em>loopPreamble</em></td><td><code>while</code> <em>expr</em> | <em>for</em> [ <em>loopInitOp</em> ] [<code>while</code> <em>expr</em> ] [ <code>by</code> <em>letOp</em> ]</td></tr><tr><td><em>altLoopPreamble</em></td><td><code>while</code> <em>expr</em> | <code>for</code> <code>(</code> [ <em>loopInitOp</em> ] <code>;</code> [ <em>expr</em> ] <code>;</code> [ <em>letOp</em> ] <code>)</code></td></tr><tr><td><em>loopOper</em></td><td>[ <em>loopPreamble</em> ] <code>loop</code> <em>opSequence</em> <strong>0*</strong> ( <code>exitif</code> <em>expr</em> <code>;</code> <em>opSequence</em>) <code>end</code> [ <code>loop</code> ]</td></tr><tr><td><em>altLoopOper</em></td><td><em>altLoopPreamble</em> <code>{</code> <em>opSequence</em> <strong>0*</strong> ( <code>exitif</code> <em>expr</em> <code>;</code> <em>opSequence</em>) <code>}</code></td></tr><tr><td><em>oper</em></td><td><em>nullOper</em> | <em>procCall</em> | <em>letOper</em> | <em>returnOper</em> | <em>stopOper</em> | <em>ifOper</em> | <em>loopOper</em> | <em>varValueDeclaration</em></td></tr><tr><td><em>altOper</em></td><td><em>altIfOper</em> | <em>altLoopOper</em></td></tr><tr><td><em>seqOper</em></td><td><em>oper</em> <code>;</code> | <em>altOper</em></td></tr><tr><td><em>opSequence</em></td><td><strong>0*</strong> ( <em>seqOper</em> )</td></tr><tr><td><em>entryBody</em></td><td><code>forward</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>entry</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>procBody</em></td><td><code>forward</code> <code>;</code> | <code>external</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>procedure</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>funcBody</em></td><td><code>forward</code> <code>;</code> | <code>external</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>function</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>parmList</em></td><td><em>name</em> 0 <strong>*</strong> (<code>,</code> <em>name</em>)</td></tr><tr><td><em>entry</em></td><td><code>entry</code> <em>name</em> <em>entryBody</em></td></tr><tr><td><em>procedure</em></td><td><code>procedure</code> <em>codeName</em> <code>(</code> [ <em>parmList</em> ] <code>)</code> <em>procBody</em></td></tr><tr><td><em>function</em></td><td><code>function</code> <em>codeName</em> <code>(</code> [ <em>parmList</em> ] <code>)</code> <em>funcBody</em></td></tr><tr><td><em>program</em></td><td><strong>1*</strong> (<em>entry</em> | <em>procedure</em> | <em>function</em> | <em>varDeclaration</em> | <em>constDeclaration</em>)</td></tr></tbody></table>`,268)]))}const m=t(s,[["render",i]]);export{h as __pageData,m as default};
