import{_ as a,c as t,o as i,ag as o}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Command Line Interface/API","description":"","frontmatter":{"legacyLink":"CLI.html"},"headers":[],"relativePath":"development/CLI.md","filePath":"development/CLI.md"}'),s={name:"development/CLI.md"};function n(c,e,r,d,h,E){return i(),t("div",null,e[0]||(e[0]=[o('<h1 id="command-line-interface-api" tabindex="-1">Command Line Interface/API <a class="header-anchor" href="#command-line-interface-api" aria-label="Permalink to &quot;Command Line Interface/API&quot;">​</a></h1><p>The CommuniGate Pro Server provides a Command Line Interface (CLI) for Server administrating. This interface can be used as an alternative for the Web Administrator interface.</p><p>CLI can also be used as the Application Program Interface (API), so the Server can be managed via scripts and other programs that issue the CLI commands to the Server.</p><h2 id="Access" tabindex="-1">CLI Access <a class="header-anchor" href="#Access" aria-label="Permalink to &quot;CLI Access {#Access}&quot;">​</a></h2><p>The CommuniGate Pro Server provides several methods to access its CLI:</p><ul><li>using TCP connections to the <a href="./../admin/services/PWD.html">PWD</a> module (as an extension to the PWD/poppwd protocol)</li><li>using <a href="./CGPL.html#CLI">CG/PL <code>ExecuteCLI</code></a> command.</li><li>using the <a href="./../admin/services/HTTP.html#CLI">HTTP</a> CLI realm.</li><li>using <a href="./XMLAPI.html#cliExecute">XIMSS <code>cliExecute</code></a> operation.</li></ul><p>When the CLI is used over the PWD connection, the CLI commands are accepted as soon as the user is authenticated. For each CLI command the Server checks the authenticated user access rights.</p><p>If a command produces some data, the data is sent after the protocol line with the positive response. The CR-LF combination is sent after the data.</p><p>Below is a sample PWD session with CLI commands:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C: telnet servername.com 106</span></span>\n<span class="line"><span>S: 200 CommuniGate Pro at mail.servername.com PWD Server 5.3 ready</span></span>\n<span class="line"><span>C: USER postmaster</span></span>\n<span class="line"><span>S: 300 please send the PASS</span></span>\n<span class="line"><span>C: PASS postmasterpassword</span></span>\n<span class="line"><span>S: 200 login OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1&quot;</span></span>\n<span class="line"><span>S: 501 Account with this name already exists</span></span>\n<span class="line"><span>C: RenameAccount &quot;user1&quot; into &quot;user2&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateDomain &quot;client1.com&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1@client1.com&quot; TextMailbox</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: ListDomains</span></span>\n<span class="line"><span>S: 200 data follow</span></span>\n<span class="line"><span>S: (mail.servername.com, client1.com, client2.com)</span></span>\n<span class="line"><span>C: QUIT</span></span>\n<span class="line"><span>S: 200 CommuniGate Pro PWD connection closed</span></span></code></pre></div><p>The <a href="http://www.communigatepro.ru/CGPerl/" target="_blank" rel="noreferrer">CommuniGate Pro Perl Interface</a> document contains a set of the <a href="http://www.perl.org" target="_blank" rel="noreferrer">Perl language</a> utilities that allow a Perl script to access the CommuniGate Pro CLI API via the PWD protocol. The document also contains links to several useful sample Perl scripts (automated Account registration and removal, etc.)</p><p>The <a href="http://www.communigatepro.ru/CGJava/" target="_blank" rel="noreferrer">CommuniGate Pro Java Interface</a> document contains the set of the <a href="http://java.com" target="_blank" rel="noreferrer">Java language</a> classes that allow a Java program to access the CommuniGate Pro CLI API via the PWD protocol. The document also contains links to several sample Java programs.</p><h2 id="Syntax" tabindex="-1">CLI Syntax <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;CLI Syntax {#Syntax}&quot;">​</a></h2><p>The CommuniGate Pro CLI uses the standard <a href="./Data.html">Data Formats</a> to parse commands and to format the output results.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>These Dictionary format syntax rules allow you to specify a string without the quotation marks if the string contains alphanumerical symbols only. You should use the quotation marks if a string contains the dot (<code>.</code>), comma (<code>,</code>), and other non-alphanumerical symbols.</p></div><p>In spite of the fact that the standard Data formats can use several text lines, all data (including arrays and dictionaries) you specify as CLI parameters should be stored on one command line.</p><p>If a CLI command produces some output in the array or dictionary format, the output data can be presented on several lines.</p><h2 id="DomainSet" tabindex="-1">Domain Set Administration <a class="header-anchor" href="#DomainSet" aria-label="Permalink to &quot;Domain Set Administration {#DomainSet}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right to use the Domain Set Administration CLI commands.</p><p>The following commands are available for the System Administrators only:</p><h3 id="LISTDOMAINS" tabindex="-1"><code>LISTDOMAINS</code> <a class="header-anchor" href="#LISTDOMAINS" aria-label="Permalink to &quot;`LISTDOMAINS` {#LISTDOMAINS}&quot;">​</a></h3><p>Use this command to get the list of domains. The command produces output data - an <em>array</em> with the names of all server domains.</p><h3 id="MAINDOMAINNAME" tabindex="-1"><code>MAINDOMAINNAME</code> <a class="header-anchor" href="#MAINDOMAINNAME" aria-label="Permalink to &quot;`MAINDOMAINNAME` {#MAINDOMAINNAME}&quot;">​</a></h3><p>Use this command to get the name of the Main Domain. The command produces output data - a <em>string</em> with the Main Domain name.</p><h3 id="GETDOMAINDEFAULTS" tabindex="-1"><code>GETDOMAINDEFAULTS</code> <a class="header-anchor" href="#GETDOMAINDEFAULTS" aria-label="Permalink to &quot;`GETDOMAINDEFAULTS` {#GETDOMAINDEFAULTS}&quot;">​</a></h3><p>Use this command to get the server-wide default Domain Settings. The command produces an output - a <em>dictionary</em> with the default Domain Settings.</p><h3 id="UPDATEDOMAINDEFAULTS" tabindex="-1"><code>UPDATEDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATEDOMAINDEFAULTS" aria-label="Permalink to &quot;`UPDATEDOMAINDEFAULTS newSettings` {#UPDATEDOMAINDEFAULTS}&quot;">​</a></h3><p>Use this command to change the server-wide default Domain settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the default Domain settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified.</p></li></ul><h3 id="SETDOMAINDEFAULTS" tabindex="-1"><code>SETDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#SETDOMAINDEFAULTS" aria-label="Permalink to &quot;`SETDOMAINDEFAULTS newSettings` {#SETDOMAINDEFAULTS}&quot;">​</a></h3><p>Use this command to change the server-wide default Domain settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the server-wide default Domain settings dictionary.</p></li></ul><h3 id="GETCLUSTERDOMAINDEFAULTS" tabindex="-1"><code>GETCLUSTERDOMAINDEFAULTS</code> <a class="header-anchor" href="#GETCLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`GETCLUSTERDOMAINDEFAULTS` {#GETCLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><h3 id="UPDATECLUSTERDOMAINDEFAULTS" tabindex="-1"><code>UPDATECLUSTERDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`UPDATECLUSTERDOMAINDEFAULTS newSettings` {#UPDATECLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><h3 id="SETCLUSTERDOMAINDEFAULTS" tabindex="-1"><code>SETCLUSTERDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#SETCLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`SETCLUSTERDOMAINDEFAULTS newSettings` {#SETCLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>UPDATE</code>|<code>SET</code>]<code>DOMAINDEFAULTS</code> commands to work with the cluster-wide default Domain Settings.</p><h3 id="GETSERVERACCOUNTDEFAULTS" tabindex="-1"><code>GETSERVERACCOUNTDEFAULTS</code> <a class="header-anchor" href="#GETSERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETSERVERACCOUNTDEFAULTS` {#GETSERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to get the server-wide Default Account settings. The command produces an output - a <em>dictionary</em> with the global default Account settings.</p><h3 id="UPDATESERVERACCOUNTDEFAULTS" tabindex="-1"><code>UPDATESERVERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATESERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATESERVERACCOUNTDEFAULTS newSettings` {#UPDATESERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to update the server-wide Default Account settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Default Account settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified.</p></li></ul><h3 id="SETSERVERACCOUNTDEFAULTS" tabindex="-1"><code>SETSERVERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#SETSERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETSERVERACCOUNTDEFAULTS newSettings` {#SETSERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to set the server-wide Default Account settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the server-wide Default Account settings dictionary.</p></li></ul><h3 id="GETCLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>GETCLUSTERACCOUNTDEFAULTS</code> <a class="header-anchor" href="#GETCLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETCLUSTERACCOUNTDEFAULTS` {#GETCLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><h3 id="UPDATECLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>UPDATECLUSTERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATECLUSTERACCOUNTDEFAULTS newSettings` {#UPDATECLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><h3 id="SETCLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>SETCLUSTERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#SETCLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETCLUSTERACCOUNTDEFAULTS newSettings` {#SETCLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>UPDATE</code>|<code>SET</code>]<code>SERVERACCOUNTDEFAULTS</code> commands to work with the cluster-wide Default Account settings.</p><h3 id="GETSERVERACCOUNTPREFS" tabindex="-1"><code>GETSERVERACCOUNTPREFS</code> <a class="header-anchor" href="#GETSERVERACCOUNTPREFS" aria-label="Permalink to &quot;`GETSERVERACCOUNTPREFS` {#GETSERVERACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to get the server-wide Default Account Preferences. The command produces an output - a <em>dictionary</em> with the default Preferences.</p><h3 id="SETSERVERACCOUNTPREFS" tabindex="-1"><code>SETSERVERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#SETSERVERACCOUNTPREFS" aria-label="Permalink to &quot;`SETSERVERACCOUNTPREFS newSettings` {#SETSERVERACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to change the server-wide Default Account Preferences.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the server-wide Default Account Preferences. All old server-wide Default Account Preferences are removed.</p></li></ul><h3 id="UPDATESERVERACCOUNTPREFS" tabindex="-1"><code>UPDATESERVERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#UPDATESERVERACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATESERVERACCOUNTPREFS newSettings` {#UPDATESERVERACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to change the server-wide Default Account Preferences.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Default Account Preferences. It does not have to contain all preferences data, the omitted Preferences will be left unmodified.</p></li></ul><h3 id="GETCLUSTERACCOUNTPREFS" tabindex="-1"><code>GETCLUSTERACCOUNTPREFS</code> <a class="header-anchor" href="#GETCLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`GETCLUSTERACCOUNTPREFS` {#GETCLUSTERACCOUNTPREFS}&quot;">​</a></h3><h3 id="SETCLUSTERACCOUNTPREFS" tabindex="-1"><code>SETCLUSTERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#SETCLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`SETCLUSTERACCOUNTPREFS newSettings` {#SETCLUSTERACCOUNTPREFS}&quot;">​</a></h3><h3 id="UPDATECLUSTERACCOUNTPREFS" tabindex="-1"><code>UPDATECLUSTERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATECLUSTERACCOUNTPREFS newSettings` {#UPDATECLUSTERACCOUNTPREFS}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>SET</code>|<code>UPDATE</code>]<code>SERVERACCOUNTPREFS</code> commands to work with the cluster-wide Default Account Preferences.</p><h3 id="CREATEDOMAIN" tabindex="-1"><code>CREATEDOMAIN domainName [ SHARED ] [ PATH storage ] [ settings ]</code> <a class="header-anchor" href="#CREATEDOMAIN" aria-label="Permalink to &quot;`CREATEDOMAIN domainName [ SHARED ] [ PATH storage ] [ settings ]` {#CREATEDOMAIN}&quot;">​</a></h3><p>Use this command to create a new secondary Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name to create.</p></li><li><p><code>storage : string</code></p><p>This optional parameter specifies the &quot;storage mount Point&quot; directory for the Domain data (the name should be specified without the .mnt suffix).</p></li><li><p><code>settings : dictionary</code></p><p>This optional parameter specifies the Domain settings. Use the SHARED keyword to create a Cluster-wide Domain in a Dynamic Cluster.</p></li></ul><h3 id="RENAMEDOMAIN" tabindex="-1"><code>RENAMEDOMAIN oldDomainName INTO newDomainName [ PATH storage ]</code> <a class="header-anchor" href="#RENAMEDOMAIN" aria-label="Permalink to &quot;`RENAMEDOMAIN oldDomainName INTO newDomainName [ PATH storage ]` {#RENAMEDOMAIN}&quot;">​</a></h3><p>Use this command to rename a Domain.</p><ul><li><p><code>oldDomainName : string</code></p><p>This parameter specifies the name of an existing secondary Domain.</p></li><li><p><code>newDomainName : string</code></p><p>This parameter specifies the new Domain name.</p></li><li><p><code>storage : string</code></p><p>This optional parameter specifies the new &quot;storage mount Point&quot; directory for the Domain data (the name should be specified without the .mnt suffix).</p></li></ul><h3 id="DELETEDOMAIN" tabindex="-1"><code>DELETEDOMAIN domainName [ FORCE ]</code> <a class="header-anchor" href="#DELETEDOMAIN" aria-label="Permalink to &quot;`DELETEDOMAIN domainName [ FORCE ]` {#DELETEDOMAIN}&quot;">​</a></h3><p>Use this command to remove a Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of the Domain to be removed.</p></li><li><p><code>FORCE</code></p><p>This optional parameter specifies that the Domain should be removed even if it is not empty. All Domain objects (Accounts, Groups, etc.) will be removed.</p></li></ul><h3 id="CREATEDIRECTORYDOMAIN" tabindex="-1"><code>CREATEDIRECTORYDOMAIN domainName [ settings ]</code> <a class="header-anchor" href="#CREATEDIRECTORYDOMAIN" aria-label="Permalink to &quot;`CREATEDIRECTORYDOMAIN domainName [ settings ]` {#CREATEDIRECTORYDOMAIN}&quot;">​</a></h3><p>Use this command to create a new directory-based Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name to create.</p></li><li><p><code>settings : dictionary</code></p><p>This optional parameter specifies the Domain settings. This operation is allowed only when the Directory-based Domains are enabled.</p></li></ul><h3 id="RELOADDIRECTORYDOMAINS" tabindex="-1"><code>RELOADDIRECTORYDOMAINS</code> <a class="header-anchor" href="#RELOADDIRECTORYDOMAINS" aria-label="Permalink to &quot;`RELOADDIRECTORYDOMAINS` {#RELOADDIRECTORYDOMAINS}&quot;">​</a></h3><p>Use this command to tell the server to scan the Domains Directory subtree so it can find all additional Directory-based Domains created directly in the Directory, bypassing the CommuniGate Pro Server.<br> This operation is allowed only when the Directory-based Domains are enabled.</p><h3 id="LISTSERVERTELNUMS" tabindex="-1"><code>LISTSERVERTELNUMS [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTSERVERTELNUMS" aria-label="Permalink to &quot;`LISTSERVERTELNUMS [ FILTER filter ] limit` {#LISTSERVERTELNUMS}&quot;">​</a></h3><p>Use this command to read Telnum numbers created in all (non-clustered) Domains. The command produces an output - a <em>dictionary</em> where each key is a Telnum number, and its value is the Account name it is assigned to. An numeric element for an empty (<code>&quot;&quot;</code>) key is added, it contains the total number of Telnum numbers created.</p><ul><li><p><code>filter : string</code></p><p>If this optional parameter is specified, only the telnum numbers containing the specified string are returned.</p></li><li><p><code>limit : number</code></p><p>The maximum number of Telnum numbers to return.</p></li></ul><h3 id="LISTCLUSTERTELNUMS" tabindex="-1"><code>LISTCLUSTERTELNUMS [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTCLUSTERTELNUMS" aria-label="Permalink to &quot;`LISTCLUSTERTELNUMS [ FILTER filter ] limit` {#LISTCLUSTERTELNUMS}&quot;">​</a></h3><p>The same as LISTSERVERTELNUMS, but for shared Cluster Domains.</p><h3 id="GETSERVERTRUSTEDCERTS" tabindex="-1"><code>GETSERVERTRUSTEDCERTS</code> <a class="header-anchor" href="#GETSERVERTRUSTEDCERTS" aria-label="Permalink to &quot;`GETSERVERTRUSTEDCERTS` {#GETSERVERTRUSTEDCERTS}&quot;">​</a></h3><p>Use this command to get the server-wide set of Trusted Certificates. The command produces an output - an <em>array</em> of <em>datablocks</em>. Each <em>datablock</em> contains one X.509 certificate data.</p><h3 id="SETSERVERTRUSTEDCERTS" tabindex="-1"><code>SETSERVERTRUSTEDCERTS newCertificates</code> <a class="header-anchor" href="#SETSERVERTRUSTEDCERTS" aria-label="Permalink to &quot;`SETSERVERTRUSTEDCERTS newCertificates` {#SETSERVERTRUSTEDCERTS}&quot;">​</a></h3><p>Use this command to set the server-wide set of Trusted Certificates.</p><ul><li><p><code>newCertificates : array</code></p><p>This array should contain <em>datablocks</em> with X.509 certificate data. It is used to replace the server-wide list of Trusted Certificates.</p></li></ul><h3 id="GETCLUSTERTRUSTEDCERTS" tabindex="-1"><code>GETCLUSTERTRUSTEDCERTS</code> <a class="header-anchor" href="#GETCLUSTERTRUSTEDCERTS" aria-label="Permalink to &quot;`GETCLUSTERTRUSTEDCERTS` {#GETCLUSTERTRUSTEDCERTS}&quot;">​</a></h3><h3 id="SETCLUSTERTRUSTEDCERTS" tabindex="-1"><code>SETCLUSTERTRUSTEDCERTS newCertificates</code> <a class="header-anchor" href="#SETCLUSTERTRUSTEDCERTS" aria-label="Permalink to &quot;`SETCLUSTERTRUSTEDCERTS newCertificates` {#SETCLUSTERTRUSTEDCERTS}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>SET</code>]<code>SERVERTRUSTEDCERTS</code> commands to work with the cluster-wide set of Trusted Certificates.</p><h3 id="GETDIRECTORYINTEGRATION" tabindex="-1"><code>GETDIRECTORYINTEGRATION</code> <a class="header-anchor" href="#GETDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`GETDIRECTORYINTEGRATION` {#GETDIRECTORYINTEGRATION}&quot;">​</a></h3><p>Use this command to get the server-wide Directory Integration settings. The command produces an output - a <em>dictionary</em> with the Directory Integration settings.</p><h3 id="SETDIRECTORYINTEGRATION" tabindex="-1"><code>SETDIRECTORYINTEGRATION newSettings</code> <a class="header-anchor" href="#SETDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`SETDIRECTORYINTEGRATION newSettings` {#SETDIRECTORYINTEGRATION}&quot;">​</a></h3><p>Use this command to set the server-wide Directory Integration settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the server-wide Directory Integration settings dictionary.</p></li></ul><h3 id="GETCLUSTERDIRECTORYINTEGRATION" tabindex="-1"><code>GETCLUSTERDIRECTORYINTEGRATION</code> <a class="header-anchor" href="#GETCLUSTERDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`GETCLUSTERDIRECTORYINTEGRATION` {#GETCLUSTERDIRECTORYINTEGRATION}&quot;">​</a></h3><h3 id="SETCLUSTERDIRECTORYINTEGRATION" tabindex="-1"><code>SETCLUSTERDIRECTORYINTEGRATION newSettings</code> <a class="header-anchor" href="#SETCLUSTERDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`SETCLUSTERDIRECTORYINTEGRATION newSettings` {#SETCLUSTERDIRECTORYINTEGRATION}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>SET</code>]<code>DIRECTORYINTEGRATION</code> commands to work with the cluster-wide Directory Integration settings.</p><h3 id="CREATEDOMAINSTORAGE" tabindex="-1"><code>CREATEDOMAINSTORAGE [ SHARED ] PATH storage</code> <a class="header-anchor" href="#CREATEDOMAINSTORAGE" aria-label="Permalink to &quot;`CREATEDOMAINSTORAGE [ SHARED ] PATH storage` {#CREATEDOMAINSTORAGE}&quot;">​</a></h3><p>Use this command to create a &quot;storage mount point&quot; for new Domains.</p><ul><li><p><code>storage : string</code></p><p>This parameter specifies the &quot;storage mount Point&quot; name. Use the SHARED keyword to create a &quot;storage mount point&quot; for Cluster Domains in a Dynamic Cluster.</p></li></ul><h3 id="LISTDOMAINSTORAGE" tabindex="-1"><code>LISTDOMAINSTORAGE [ SHARED ]</code> <a class="header-anchor" href="#LISTDOMAINSTORAGE" aria-label="Permalink to &quot;`LISTDOMAINSTORAGE [ SHARED ]` {#LISTDOMAINSTORAGE}&quot;">​</a></h3><p>Use this command to list &quot;storage mount points&quot; for Domains.<br> The command produces an output - an <em>array</em> with &quot;storage mount points&quot; names.<br> Use the SHARED keyword to list &quot;storage mount point&quot; for Cluster Domains in a Dynamic Cluster.</p><h2 id="Domain" tabindex="-1">Domain Administration <a class="header-anchor" href="#Domain" aria-label="Permalink to &quot;Domain Administration {#Domain}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the Domain Administration CLI commands.</p><h3 id="GETDOMAINSETTINGS" tabindex="-1"><code>GETDOMAINSETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINSETTINGS" aria-label="Permalink to &quot;`GETDOMAINSETTINGS [ domainName ]` {#GETDOMAINSETTINGS}&quot;">​</a></h3><p>Use this command to get the Domain settings. The command produces an output - a <em>dictionary</em> with the domainName settings. Only the explicitly set (not the default) settings are included into that dictionary.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain.</p></li></ul><h3 id="GETDOMAINEFFECTIVESETTINGS" tabindex="-1"><code>GETDOMAINEFFECTIVESETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINEFFECTIVESETTINGS" aria-label="Permalink to &quot;`GETDOMAINEFFECTIVESETTINGS [ domainName ]` {#GETDOMAINEFFECTIVESETTINGS}&quot;">​</a></h3><p>Use this command to get the Domain settings. The command produces an output - a <em>dictionary</em> with the domainName settings. Both the explicitly set and the default settings are included into that dictionary.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain.</p></li></ul><h3 id="UPDATEDOMAINSETTINGS" tabindex="-1"><code>UPDATEDOMAINSETTINGS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEDOMAINSETTINGS" aria-label="Permalink to &quot;`UPDATEDOMAINSETTINGS [ domainName ] newSettings` {#UPDATEDOMAINSETTINGS}&quot;">​</a></h3><p>Use this command to update the Domain settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Domain settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified. If a new setting value is specified as the string <code>default</code>, the Domain setting value is removed, so the default Domain settings value will be used. If this command is used by a Domain Administrator, it will update only those Domain Settings that this Domain Administrator is allowed to modify.</p></li></ul><h3 id="GETACCOUNTDEFAULTS" tabindex="-1"><code>GETACCOUNTDEFAULTS [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETACCOUNTDEFAULTS [ domainName ]` {#GETACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to get the default Account settings for the specified Domain. The command produces an output - a <em>dictionary</em> with the default settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the Administrator Domain.</p></li></ul><h3 id="UPDATEACCOUNTDEFAULTS" tabindex="-1"><code>UPDATEACCOUNTDEFAULTS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATEACCOUNTDEFAULTS [ domainName ] newSettings` {#UPDATEACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to modify the Default Account settings for the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to modify the Domain Default Account settings. The dictionary does not have to contain all settings data, the omitted settings will be left unmodified. If a new setting value is specified as the string <code>default</code>, the setting value is removed, so the global Server Default Account Settings will be used. If this command is used by a Domain Administrator, it will update only those Default Account settings this Administrator is allowed to modify.</p></li></ul><h3 id="GETACCOUNTDEFAULTPREFS" tabindex="-1"><code>GETACCOUNTDEFAULTPREFS [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`GETACCOUNTDEFAULTPREFS [ domainName ]` {#GETACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Use this command to get the Default Account Preferences for the specified Domain. The command produces an output - a <em>dictionary</em> with the default Preferences.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="SETACCOUNTDEFAULTPREFS" tabindex="-1"><code>SETACCOUNTDEFAULTPREFS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`SETACCOUNTDEFAULTPREFS [ domainName ] newSettings` {#SETACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Use this command to change the Default Account Preferences for the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the authenticated user Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Default Account Preferences. All old Default Account Preferences are removed. This command can be used by Domain Administrators only if they have the <code>WebUserSettings</code> access right.</p></li></ul><h3 id="UPDATEACCOUNTDEFAULTPREFS" tabindex="-1"><code>UPDATEACCOUNTDEFAULTPREFS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`UPDATEACCOUNTDEFAULTPREFS [ domainName ] newSettings` {#UPDATEACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Use this command to change the Default Account Preferences for the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the authenticated user Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to modify the Domain Default Account Preferences. It does not have to contain all Preferences data, the omitted elements will be left unmodified.<br> If a new element value is specified as the string <code>default</code>, the Default Preferences value is removed, so the default Server-wide (or Cluster-wide) Account Preferences value will be used. This command can be used by Domain Administrators only if they have the <code>WebUserSettings</code> access right.</p></li></ul><h3 id="GETACCOUNTTEMPLATE" tabindex="-1"><code>GETACCOUNTTEMPLATE [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTTEMPLATE" aria-label="Permalink to &quot;`GETACCOUNTTEMPLATE [ domainName ]` {#GETACCOUNTTEMPLATE}&quot;">​</a></h3><p>Use this command to get the Account Template settings. The command produces an output - a <em>dictionary</em> with the Template settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="UPDATEACCOUNTTEMPLATE" tabindex="-1"><code>UPDATEACCOUNTTEMPLATE [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTTEMPLATE" aria-label="Permalink to &quot;`UPDATEACCOUNTTEMPLATE [ domainName ] newSettings` {#UPDATEACCOUNTTEMPLATE}&quot;">​</a></h3><p>Use this command to modify the Account Template settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to modify the Domain Account Template. All new Accounts in the specified Domain will be created with the Template settings. The dictionary does not have to contain all settings data, the omitted settings will be left unmodified. If a new setting value is specified as the string <code>default</code>, the Template setting value is removed. If this command is used by a Domain administrator, it will update only those Template settings that the Domain administrator is allowed to modify.</p></li></ul><h3 id="GETDOMAINALIASES" tabindex="-1"><code>GETDOMAINALIASES domainName</code> <a class="header-anchor" href="#GETDOMAINALIASES" aria-label="Permalink to &quot;`GETDOMAINALIASES domainName` {#GETDOMAINALIASES}&quot;">​</a></h3><p>Use this command to get the list of Domain Aliases. The command produces an output - an <em>array</em> with the Domain alias names.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li></ul><h3 id="GETDOMAINMAILRULES" tabindex="-1"><code>GETDOMAINMAILRULES domainName</code> <a class="header-anchor" href="#GETDOMAINMAILRULES" aria-label="Permalink to &quot;`GETDOMAINMAILRULES domainName` {#GETDOMAINMAILRULES}&quot;">​</a></h3><p>Use this command to get the list of Domain Queue Rules. The command produces an output - an <em>array</em> of the Queue Rules specified for the Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li></ul><h3 id="SETDOMAINMAILRULES" tabindex="-1"><code>SETDOMAINMAILRULES domainName newRules</code> <a class="header-anchor" href="#SETDOMAINMAILRULES" aria-label="Permalink to &quot;`SETDOMAINMAILRULES domainName newRules` {#SETDOMAINMAILRULES}&quot;">​</a></h3><p>Use this command to set the Domain Queue Rules.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newRules : array</code></p><p>This array should contain the Domain Queue Rules. All old Domain Queue Rules are removed. This command can be used by Domain Administrators only if they have the <code>RulesAllowed</code> access right.</p></li></ul><h3 id="GETDOMAINSIGNALRULES" tabindex="-1"><code>GETDOMAINSIGNALRULES domainName</code> <a class="header-anchor" href="#GETDOMAINSIGNALRULES" aria-label="Permalink to &quot;`GETDOMAINSIGNALRULES domainName` {#GETDOMAINSIGNALRULES}&quot;">​</a></h3><p>Use this command to get the list of Domain Signal Rules. The command produces an output - an <em>array</em> of the Signal Rules specified for the Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li></ul><h3 id="SETDOMAINSIGNALRULES" tabindex="-1"><code>SETDOMAINSIGNALRULES domainName newRules</code> <a class="header-anchor" href="#SETDOMAINSIGNALRULES" aria-label="Permalink to &quot;`SETDOMAINSIGNALRULES domainName newRules` {#SETDOMAINSIGNALRULES}&quot;">​</a></h3><p>Use this command to set the Domain Signal Rules.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newRules : array</code></p><p>This array should contain the Domain Signal Rules. All old Domain Signal Rules are removed. This command can be used by Domain Administrators only if they have the <code>SignalRulesAllowed</code> access right.</p></li></ul><h3 id="LISTADMINDOMAINS" tabindex="-1"><code>LISTADMINDOMAINS [ domainName ]</code> <a class="header-anchor" href="#LISTADMINDOMAINS" aria-label="Permalink to &quot;`LISTADMINDOMAINS [ domainName ]` {#LISTADMINDOMAINS}&quot;">​</a></h3><p>Use this command to get the list of Domains that can be administered by Domain Administrator Accounts in the specified domainName Domain. The command produces an output - an <em>array</em> with the Domain names.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the authenticated user Domain.</p></li></ul><h3 id="LISTDOMAINOBJECTS" tabindex="-1"><code>LISTDOMAINOBJECTS domainName [ FILTER filter ] limit [ ACCOUNTS ] [ ALIASES ] [ FORWARDERS ] [ COOKIE cookie ]</code> <a class="header-anchor" href="#LISTDOMAINOBJECTS" aria-label="Permalink to &quot;`LISTDOMAINOBJECTS domainName [ FILTER filter ] limit [ ACCOUNTS ] [ ALIASES ] [ FORWARDERS ] [ COOKIE cookie ]` {#LISTDOMAINOBJECTS}&quot;">​</a></h3><p>Use this command to get a list of Domain objects.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>filter : string</code></p><p>This optional parameter specifies a filter string: only objects with names including this string as a substring are listed.</p></li><li><p><code>limit : numeric string</code></p><p>This parameter specifies the maximum number of objects to list.</p></li><li><p><code>ACCOUNTS, ALIASES, FORWARDERS</code></p><p>These keywords specify which Domain objects should be listed.</p></li><li><p><code>cookie : string</code></p><p>This optional parameter specifies a &quot;cookie&quot; string.</p></li></ul><p>The command produces output data - an array with the following elements:</p><ul><li><p>a numeric <em>string</em> with the total number of Domain Accounts</p></li><li><p>a <em>dictionary</em> with Domain Objects. Each dictionary key is a Domain Object name. The dictionary value depends on the Domain Object type:</p><ul><li><p>Account</p><p>the dictionary object is a string (the Account file extension)</p></li><li><p>Account Alias</p><p>the dictionary object is an <em>array</em>. Its only element is a string with the Alias owner (Account) name.</p></li><li><p>Forwarder</p><p>the dictionary object is an <em>array</em>. Its only element is an <em>array</em>. Its only element is a string with the Forwarder address.</p></li></ul></li><li><p>a numeric <em>string</em> with the total number of Aliases in the Domain.</p></li><li><p>a numeric <em>string</em> with the total number of Forwarders in the Domain.</p></li><li><p>a new &quot;cookie&quot; <em>string</em> (optional, exists only if there was the <code>COOKIE cookie</code> part in the command.)</p></li></ul><p>To list Objects in large Domains, specify some reasonable <em>limit</em> value (below 10,000) and specify and empty cookie string. If not all Objects are returned, issue the command again, using the new cookie value specified in the response array. When all Objects are returned, the new cookie value in the response is an empty string.</p><h3 id="LISTACCOUNTS" tabindex="-1"><code>LISTACCOUNTS [ domainName ]</code> <a class="header-anchor" href="#LISTACCOUNTS" aria-label="Permalink to &quot;`LISTACCOUNTS [ domainName ]` {#LISTACCOUNTS}&quot;">​</a></h3><p>Use this command to get the list of all Accounts in the Domain. The command produces output data - a <em>dictionary</em> with the keys listing all Accounts in the specified (or default) Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="LISTDOMAINTELNUMS" tabindex="-1"><code>LISTDOMAINTELNUMS domainName [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTDOMAINTELNUMS" aria-label="Permalink to &quot;`LISTDOMAINTELNUMS domainName [ FILTER filter ] limit` {#LISTDOMAINTELNUMS}&quot;">​</a></h3><p>Use this command to read Telnum numbers created in the specified Domain. The command produces an output - a <em>dictionary</em> where each key is a Telnum number, and its value is the Account name it is assigned to. An numeric element for an empty (<code>&quot;&quot;</code>) key is added, it contains the total number of Telnum numbers created.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>filter : string</code></p><p>If this optional parameter is specified, only the telnum numbers containing the specified string are returned.</p></li><li><p><code>limit : number</code></p><p>The maximum number of Telnum numbers to return.</p></li></ul><h3 id="INSERTDIRECTORYRECORDS" tabindex="-1"><code>INSERTDIRECTORYRECORDS domainName</code> <a class="header-anchor" href="#INSERTDIRECTORYRECORDS" aria-label="Permalink to &quot;`INSERTDIRECTORYRECORDS domainName` {#INSERTDIRECTORYRECORDS}&quot;">​</a></h3><p>Use this command to insert records for Domain objects (Accounts, Groups, Mailing Lists, Forwarders) into the Directory.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the authenticated user Domain. This command can be used by Domain Administrators only if they have the <code>CentralDirectory</code> access right.</p></li></ul><h3 id="DELETEDIRECTORYRECORDS" tabindex="-1"><code>DELETEDIRECTORYRECORDS domainName</code> <a class="header-anchor" href="#DELETEDIRECTORYRECORDS" aria-label="Permalink to &quot;`DELETEDIRECTORYRECORDS domainName` {#DELETEDIRECTORYRECORDS}&quot;">​</a></h3><p>Use this command to delete Domain object records from the Directory.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the authenticated user Domain. This command can be used by Domain Administrators only if they have the <code>CentralDirectory</code> access right.</p></li></ul><h3 id="CREATEACCOUNTSTORAGE" tabindex="-1"><code>CREATEACCOUNTSTORAGE domainName PATH storage</code> <a class="header-anchor" href="#CREATEACCOUNTSTORAGE" aria-label="Permalink to &quot;`CREATEACCOUNTSTORAGE domainName PATH storage` {#CREATEACCOUNTSTORAGE}&quot;">​</a></h3><p>Use this command to create a &quot;storage mount point&quot; for new Accounts in the Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>storage : string</code></p><p>This parameter specifies the &quot;storage mount Point&quot; name.</p></li></ul><h3 id="LISTACCOUNTSTORAGE" tabindex="-1"><code>LISTACCOUNTSTORAGE domainName</code> <a class="header-anchor" href="#LISTACCOUNTSTORAGE" aria-label="Permalink to &quot;`LISTACCOUNTSTORAGE domainName` {#LISTACCOUNTSTORAGE}&quot;">​</a></h3><p>Use this command to list Account &quot;storage mount points&quot; in the specified Domain.<br> The command produces an output - an <em>array</em> with &quot;storage mount points&quot; names.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li></ul><p>The following commands are available for the System Administrators only:</p><h3 id="SETDOMAINALIASES" tabindex="-1"><code>SETDOMAINALIASES domainName newAliases</code> <a class="header-anchor" href="#SETDOMAINALIASES" aria-label="Permalink to &quot;`SETDOMAINALIASES domainName newAliases` {#SETDOMAINALIASES}&quot;">​</a></h3><p>Use this command to set the Domain aliases.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newAliases : array</code></p><p>This array should contain the Domain alias name strings. All old Domain aliases are removed.</p></li></ul><h3 id="SETDOMAINSETTINGS" tabindex="-1"><code>SETDOMAINSETTINGS domainName newSettings</code> <a class="header-anchor" href="#SETDOMAINSETTINGS" aria-label="Permalink to &quot;`SETDOMAINSETTINGS domainName newSettings` {#SETDOMAINSETTINGS}&quot;">​</a></h3><p>Use this command to change the Domain settings.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Domain settings dictionary. All old Domain settings are removed.</p></li></ul><h3 id="SETACCOUNTDEFAULTS" tabindex="-1"><code>SETACCOUNTDEFAULTS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETACCOUNTDEFAULTS [ domainName ] newSettings` {#SETACCOUNTDEFAULTS}&quot;">​</a></h3><p>Use this command to change the Default Account settings for the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Domain Default Account settings. All old Account Default settings are removed.</p></li></ul><h3 id="SETACCOUNTTEMPLATE" tabindex="-1"><code>SETACCOUNTTEMPLATE [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTTEMPLATE" aria-label="Permalink to &quot;`SETACCOUNTTEMPLATE [ domainName ] newSettings` {#SETACCOUNTTEMPLATE}&quot;">​</a></h3><p>Use this command to change the Account Template settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Domain Account Template. All new Accounts in the specified Domain will be created with the Template settings. All old Account Template settings are removed.</p></li></ul><h3 id="GETDOMAINLOCATION" tabindex="-1"><code>GETDOMAINLOCATION [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINLOCATION" aria-label="Permalink to &quot;`GETDOMAINLOCATION [ domainName ]` {#GETDOMAINLOCATION}&quot;">​</a></h3><p>Use this command to get the Domain file directory path (relative to the Server <em>base directory</em>). The command produces an output - a <em>string</em> with the Domain file path.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="SUSPENDDOMAIN" tabindex="-1"><code>SUSPENDDOMAIN domainName</code> <a class="header-anchor" href="#SUSPENDDOMAIN" aria-label="Permalink to &quot;`SUSPENDDOMAIN domainName` {#SUSPENDDOMAIN}&quot;">​</a></h3><p>Use this command to suspend a Domain, so all currently active Accounts are closed and no Account can be opened in this Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of the Domain to be suspended.</p></li></ul><h3 id="RESUMEDOMAIN" tabindex="-1"><code>RESUMEDOMAIN domainName</code> <a class="header-anchor" href="#RESUMEDOMAIN" aria-label="Permalink to &quot;`RESUMEDOMAIN domainName` {#RESUMEDOMAIN}&quot;">​</a></h3><p>Use this command to resume a Domain, so Accounts can be opened in this Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of the Domain to be resumed.</p></li></ul><h2 id="Account" tabindex="-1">Account Administration <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Account Administration {#Account}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the Account Administration CLI commands.</p><h3 id="CREATEACCOUNT" tabindex="-1"><code>CREATEACCOUNT accountName [ accountType ] [ PATH storage ] [ LEGACY ] [ settings ]</code> <a class="header-anchor" href="#CREATEACCOUNT" aria-label="Permalink to &quot;`CREATEACCOUNT accountName [ accountType ] [ PATH storage ] [ LEGACY ] [ settings ]` {#CREATEACCOUNT}&quot;">​</a></h3><p>Use this command to create new accounts.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name for the new Account.<br> The name can contain the <code>@</code> symbol followed by the Domain name, in this case the Account is created in the specified Domain. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>accountType : MultiMailbox | TextMailbox | MailDirMailbox | SlicedMailbox | AGrade | BGrade | CGrade | ResourceMailbox</code></p><p>This optional parameter specifies the type of the Account to create. If no Account type is specified a <code>MultiMailbox</code>-type Account is created.</p></li><li><p><code>storage : string</code></p><p>This optional parameter specifies the &quot;storage mount Point&quot; directory for the Account data (the name should be specified without the .mnt suffix).</p></li><li><p><code>LEGACY</code></p><p>This optional flag tells the system to create an Account with a Legacy (visible for legacy mailers) INBOX.</p></li><li><p><code>settings : dictionary</code></p><p>This optional parameter specifies the initial Account settings. Account is created using the settings specified in the Account Template for the target Domain. If the <em>settings</em> parameter is specified, it is used to modify the Template settings.<br> This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right. Additionally, if a single-mailbox Account format is requested or the LEGACY flag is used, the Domain Administrators must have the <code>CanCreateSpecialAccounts</code> access right.<br> If this command is used by a Domain Administrator, it will use only those Account settings this Administrator is allowed to modify.</p></li></ul><h3 id="RENAMEACCOUNT" tabindex="-1"><code>RENAMEACCOUNT oldAccountName into newAccountName [ PATH storage ]</code> <a class="header-anchor" href="#RENAMEACCOUNT" aria-label="Permalink to &quot;`RENAMEACCOUNT oldAccountName into newAccountName [ PATH storage ]` {#RENAMEACCOUNT}&quot;">​</a></h3><p>Use this command to rename Accounts.</p><ul><li><p><code>oldAccountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newAccountName : string</code></p><p>This parameter specifies the new Account name. The name can include the Domain name (see above).</p></li><li><p><code>storage : string</code></p><p>This optional parameter specifies the &quot;storage mount Point&quot; directory for the moved Account data (the name should be specified without the .mnt suffix). This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right.</p></li></ul><h3 id="DELETEACCOUNT" tabindex="-1"><code>DELETEACCOUNT oldAccountName</code> <a class="header-anchor" href="#DELETEACCOUNT" aria-label="Permalink to &quot;`DELETEACCOUNT oldAccountName` {#DELETEACCOUNT}&quot;">​</a></h3><p>Use this command to remove Accounts.</p><ul><li><p><code>oldAccountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right.</p></li></ul><h3 id="BLOCKACCOUNT" tabindex="-1"><code>BLOCKACCOUNT accountName MODE mode [ PREVENTLOGIN PREVENTDEL PREVENTSHOWFOLDERS ]</code> <a class="header-anchor" href="#BLOCKACCOUNT" aria-label="Permalink to &quot;`BLOCKACCOUNT accountName MODE mode [ PREVENTLOGIN PREVENTDEL PREVENTSHOWFOLDERS ]` {#BLOCKACCOUNT}&quot;">​</a></h3><p>Use this command to block Accounts.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>mode : Full | Part</code></p><p>This parameter specifies an Account blocking mode: Full - full blocking, Part - partial blocking. If the Account is completely blocked and it&#39;s folders are delegated, the delegated folders will be hidden and deletion or moving messages will be forbidden.</p></li><li><p><code>PREVENTLOGIN</code></p><p>This optional parameter is applied to the Part blocking mode only and prevents User&#39;s authorization in the System by any means.</p></li><li><p><code>PREVENTDEL</code></p><p>This optional parameter is applied to the Part blocking mode only and prevents deletion of emails from User&#39;s Mailbox.</p></li><li><p><code>PREVENTSHOWFOLDERS</code></p><p>This optional parameter is applied to the Part blocking mode only and prevents showing delegated folders. For partial blocking, you must specify one of the flags for the blocking to complete successfully. This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right.</p></li></ul><h3 id="UNBLOCKACCOUNT" tabindex="-1"><code>UNBLOCKACCOUNT accountName</code> <a class="header-anchor" href="#UNBLOCKACCOUNT" aria-label="Permalink to &quot;`UNBLOCKACCOUNT accountName` {#UNBLOCKACCOUNT}&quot;">​</a></h3><p>Use this command to unblock Accounts.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right.</p></li></ul><h3 id="SETACCOUNTTYPE" tabindex="-1"><code>SETACCOUNTTYPE accountName accountType</code> <a class="header-anchor" href="#SETACCOUNTTYPE" aria-label="Permalink to &quot;`SETACCOUNTTYPE accountName accountType` {#SETACCOUNTTYPE}&quot;">​</a></h3><p>Use this command to change the Account type.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>accountType : MultiMailbox | AGrade | BGrade | CGrade | ResourceMailbox</code></p><p>This parameter specifies the new Account type. The current Account type must also belong to this type set. This command can be used by Domain Administrators only if they have the <code>CanCreateAccounts</code> access right.</p></li></ul><h3 id="GETACCOUNTSETTINGS" tabindex="-1"><code>GETACCOUNTSETTINGS accountName</code> <a class="header-anchor" href="#GETACCOUNTSETTINGS" aria-label="Permalink to &quot;`GETACCOUNTSETTINGS accountName` {#GETACCOUNTSETTINGS}&quot;">​</a></h3><p>Use this command to get the Account settings. The command produces an output - a <em>dictionary</em> with the Account settings. Only the explicitly set (not the default) Account settings are included into the dictionary.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).<br> You can also specify the single asterisk (<code>*</code>) symbol instead of an Account name. This will indicate the current authenticated Account.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can send the <code>GETACCOUNTSETTINGS</code> command for their own Accounts.</p></div></li></ul><h3 id="UPDATEACCOUNTSETTINGS" tabindex="-1"><code>UPDATEACCOUNTSETTINGS accountName newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTSETTINGS" aria-label="Permalink to &quot;`UPDATEACCOUNTSETTINGS accountName newSettings` {#UPDATEACCOUNTSETTINGS}&quot;">​</a></h3><p>Use this command to update the Account settings.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Account settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified. If a new setting value is specified as the string <code>default</code>, the Account setting value is removed, so the default Account setting value will be used. If this command is used by a Domain Administrator, it will update only those Account settings this Administrator is allowed to modify.</p></li></ul><h3 id="GETACCOUNTEFFECTIVESETTINGS" tabindex="-1"><code>GETACCOUNTEFFECTIVESETTINGS accountName</code> <a class="header-anchor" href="#GETACCOUNTEFFECTIVESETTINGS" aria-label="Permalink to &quot;`GETACCOUNTEFFECTIVESETTINGS accountName` {#GETACCOUNTEFFECTIVESETTINGS}&quot;">​</a></h3><p>Use this command to get the effective Account settings. The command produces an output - a <em>dictionary</em> with the Account settings. Both the explicitly set and the default Account settings are included into the dictionary.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).<br> You can also specify the single asterisk (<code>*</code>) symbol instead of an Account name. This will indicate the current authenticated Account.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can send the <code>GETACCOUNTEFFECTIVESETTINGS</code> command for their own Accounts.</p></div></li></ul><h3 id="GETACCOUNTONESETTING" tabindex="-1"><code>GETACCOUNTONESETTING accountName keyName</code> <a class="header-anchor" href="#GETACCOUNTONESETTING" aria-label="Permalink to &quot;`GETACCOUNTONESETTING accountName keyName` {#GETACCOUNTONESETTING}&quot;">​</a></h3><p>Use this command to get a single setting from the effective Account settings list. The command produces an output - an <em>object</em> which can be a <em>string</em>, an <em>array</em> or a <em>dictionary</em> with the Account setting, or <em>null-object</em>.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).<br> You can also specify the single asterisk (<code>*</code>) symbol instead of an Account name. This will indicate the current authenticated Account.</p></li><li><p><code>keyName : string</code></p><p>This parameter specifies the name of the setting to read.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can send the <code>GETACCOUNTONESETTING</code> command for their own Accounts.</p></div></li></ul><h3 id="SETACCOUNTPASSWORD" tabindex="-1"><code>SETACCOUNTPASSWORD accountName PASSWORD newPassword [ METHOD method | NAME tag ] [ CHECK ]</code> <a class="header-anchor" href="#SETACCOUNTPASSWORD" aria-label="Permalink to &quot;`SETACCOUNTPASSWORD accountName PASSWORD newPassword [ METHOD method | NAME tag ] [ CHECK ]` {#SETACCOUNTPASSWORD}&quot;">​</a></h3><p>Use this command to update the Account password.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newPassword : string</code></p><p>This string specifies the new Account password. The new password will be stored using the effective Password Encryption setting of the target Account.</p></li><li><p><code>tag : string</code></p><p>This optional parameter specifies the tag for an application-specific password. If the <em>newPassword</em> string is empty, the corresponding application-specific password is removed.</p></li><li><p><code>method : string</code></p><p>This optional parameter specifies the Account Access Mode. If this mode is &quot;SIP&quot;, the the Alternative SIP Password Setting is modified, if this mode is RADIUS, then the Alternative RADIUS Password Setting is modified. In all other cases, the CommuniGate Password setting is modified. The new password will be stored using the effective Password Encryption setting of the target Account. To use this command, the user should have the &quot;Basic Settings&quot; Domain Administration right for the target Account Domain. Any user can modify her own Account password. In this case, or when the <code>CHECK</code> keyword is explicitly specified, the operation succeeds only if the the supplied password matches the size and complexity restrictions and the Account <code>CanModifyPassword</code> effective Setting is enabled.</p></li></ul><h3 id="VERIFYACCOUNTPASSWORD" tabindex="-1"><code>VERIFYACCOUNTPASSWORD accountName PASSWORD password</code> <a class="header-anchor" href="#VERIFYACCOUNTPASSWORD" aria-label="Permalink to &quot;`VERIFYACCOUNTPASSWORD accountName PASSWORD password` {#VERIFYACCOUNTPASSWORD}&quot;">​</a></h3><p>Use this command to verify the Account password.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>password : string</code></p><p>This string is used to specify the password to check (in the clear text format). To use this command, the user should have any Domain Administration right for the target Account Domain.</p></li></ul><h3 id="VERIFYACCOUNTIDENTITY" tabindex="-1"><code>VERIFYACCOUNTIDENTITY accountName FOR identity</code> <a class="header-anchor" href="#VERIFYACCOUNTIDENTITY" aria-label="Permalink to &quot;`VERIFYACCOUNTIDENTITY accountName FOR identity` {#VERIFYACCOUNTIDENTITY}&quot;">​</a></h3><p>Use this command to check if the value of &#39;From:&#39; header is allowed to be used by the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>identity : string</code></p><p>This string is to be the value of &#39;From:&#39; header, e.g. &quot;Real Name <a href="mailto:user@domain.dom" target="_blank" rel="noreferrer">user@domain.dom</a>&quot;. To use this command, the user should have any Domain Administration right for the target Account Domain.</p></li></ul><h3 id="GETACCOUNTALIASES" tabindex="-1"><code>GETACCOUNTALIASES accountName</code> <a class="header-anchor" href="#GETACCOUNTALIASES" aria-label="Permalink to &quot;`GETACCOUNTALIASES accountName` {#GETACCOUNTALIASES}&quot;">​</a></h3><p>Use this command to get the list of Account aliases. The command produces an output - an <em>array</em> with the Account alias names.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTALIASES" tabindex="-1"><code>SETACCOUNTALIASES accountName newAliases</code> <a class="header-anchor" href="#SETACCOUNTALIASES" aria-label="Permalink to &quot;`SETACCOUNTALIASES accountName newAliases` {#SETACCOUNTALIASES}&quot;">​</a></h3><p>Use this command to set the Account aliases.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newAliases : array</code></p><p>This array should contain the Account alias name strings. All old Account aliases are removed. This command can be used by Domain Administrators only if they have the <code>CanCreateAliases</code> access right.</p></li></ul><h3 id="GETACCOUNTTELNUMS" tabindex="-1"><code>GETACCOUNTTELNUMS accountName</code> <a class="header-anchor" href="#GETACCOUNTTELNUMS" aria-label="Permalink to &quot;`GETACCOUNTTELNUMS accountName` {#GETACCOUNTTELNUMS}&quot;">​</a></h3><p>Use this command to get the list of telephone numbers assigned to the Account. The command produces an output - an <em>array</em> with the assigned numbers.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTTELNUMS" tabindex="-1"><code>SETACCOUNTTELNUMS accountName newTelnums</code> <a class="header-anchor" href="#SETACCOUNTTELNUMS" aria-label="Permalink to &quot;`SETACCOUNTTELNUMS accountName newTelnums` {#SETACCOUNTTELNUMS}&quot;">​</a></h3><p>Use this command to assign telephone numbers to the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newTelnums : array</code></p><p>This array should contain the telephone number strings. All old numbers assigned to the Account are removed. This command can be used by Domain Administrators only if they have the <code>CanCreateTelnums</code> access right.</p></li></ul><h3 id="MODIFYACCOUNTTELNUMS" tabindex="-1"><code>MODIFYACCOUNTTELNUMS accountName parameters</code> <a class="header-anchor" href="#MODIFYACCOUNTTELNUMS" aria-label="Permalink to &quot;`MODIFYACCOUNTTELNUMS accountName parameters` {#MODIFYACCOUNTTELNUMS}&quot;">​</a></h3><p>Use this command to change telephone numbers assigned to the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>parameters : dictionary</code></p><p>This dictionary should contain the <code>op</code> string element specifying the requested operation:</p><ul><li><p><code>add</code></p><p>the <em>parameters</em> dictionary must contain the <code>telnum</code> string element with a telnum number to be added (atomically) to the set of Telnums assigned to the specified Account. If this set already contains this Telnum, an error code is returned.</p></li><li><p><code>del</code></p><p>the <em>parameters</em> dictionary must contain the <code>telnum</code> string element with a telnum number to be removed (atomically) from the set of Telnums assigned to the specified Account. If this set does not contain this Telnum, an error code is returned.</p></li><li><p><code>pop</code></p><p>The <em>parameters</em> dictionary must not contain any other elements. The first Telnum assigned to the specified Account is atomically removed from the Account Telnum set, and copied into the command result dictionary. If the Account Telnum set was empty, no error code is returned, and no element is copied into the command result dictionary. The command produces an output - a <em>dictionary</em>. For the <code>pop</code> operation, this dictionary can contain the <code>telnum</code> string element - the Telnum removed from the Account Telnum set. This command can be used by Domain Administrators only if they have the <code>CanCreateTelnums</code> access right.</p></li></ul></li></ul><h3 id="GETACCOUNTMAILRULES" tabindex="-1"><code>GETACCOUNTMAILRULES accountName</code> <a class="header-anchor" href="#GETACCOUNTMAILRULES" aria-label="Permalink to &quot;`GETACCOUNTMAILRULES accountName` {#GETACCOUNTMAILRULES}&quot;">​</a></h3><p>Use this command to get the list of Account Queue Rules. The command produces an output - an <em>array</em> of the Queue Rules specified for the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTMAILRULES" tabindex="-1"><code>SETACCOUNTMAILRULES accountName newRules</code> <a class="header-anchor" href="#SETACCOUNTMAILRULES" aria-label="Permalink to &quot;`SETACCOUNTMAILRULES accountName newRules` {#SETACCOUNTMAILRULES}&quot;">​</a></h3><p>Use this command to set the Account Queue Rules.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newRules : array</code></p><p>This array should contain the Account Queue Rules. All old Account Queue Rules are removed. This command can be used by Domain Administrators only if they have the <code>RulesAllowed</code> access right. This command can be used by any Account user to modify own Rules (subject to &quot;allowed actions&quot; restrictions).</p></li></ul><h3 id="GETACCOUNTSIGNALRULES" tabindex="-1"><code>GETACCOUNTSIGNALRULES accountName</code> <a class="header-anchor" href="#GETACCOUNTSIGNALRULES" aria-label="Permalink to &quot;`GETACCOUNTSIGNALRULES accountName` {#GETACCOUNTSIGNALRULES}&quot;">​</a></h3><p>Use this command to get the list of Account Signal Rules. The command produces an output - an <em>array</em> of the Signal Rules specified for the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTSIGNALRULES" tabindex="-1"><code>SETACCOUNTSIGNALRULES accountName newRules</code> <a class="header-anchor" href="#SETACCOUNTSIGNALRULES" aria-label="Permalink to &quot;`SETACCOUNTSIGNALRULES accountName newRules` {#SETACCOUNTSIGNALRULES}&quot;">​</a></h3><p>Use this command to set the Account Signal Rules.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newRules : array</code></p><p>This array should contain the Account Signal Rules. All old Account Signal Rules are removed. This command can be used by Domain Administrators only if they have the <code>SignalRulesAllowed</code> access right.</p></li></ul><h3 id="UPDATEACCOUNTMAILRULE" tabindex="-1"><code>UPDATEACCOUNTMAILRULE accountName newRule</code> <a class="header-anchor" href="#UPDATEACCOUNTMAILRULE" aria-label="Permalink to &quot;`UPDATEACCOUNTMAILRULE accountName newRule` {#UPDATEACCOUNTMAILRULE}&quot;">​</a></h3><h3 id="updateaccountmailrule-accountname-delete-oldrule" tabindex="-1"><code>UPDATEACCOUNTMAILRULE accountName DELETE oldRule</code> <a class="header-anchor" href="#updateaccountmailrule-accountname-delete-oldrule" aria-label="Permalink to &quot;`UPDATEACCOUNTMAILRULE accountName DELETE oldRule`&quot;">​</a></h3><h3 id="UPDATEACCOUNTSIGNALRULE" tabindex="-1"><code>UPDATEACCOUNTSIGNALRULE accountName newRule</code> <a class="header-anchor" href="#UPDATEACCOUNTSIGNALRULE" aria-label="Permalink to &quot;`UPDATEACCOUNTSIGNALRULE accountName newRule` {#UPDATEACCOUNTSIGNALRULE}&quot;">​</a></h3><h3 id="updateaccountsignalrule-accountname-delete-oldrule" tabindex="-1"><code>UPDATEACCOUNTSIGNALRULE accountName DELETE oldRule</code> <a class="header-anchor" href="#updateaccountsignalrule-accountname-delete-oldrule" aria-label="Permalink to &quot;`UPDATEACCOUNTSIGNALRULE accountName DELETE oldRule`&quot;">​</a></h3><p>Use these commands to update an Account Queue or Signal Rule.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newRule : array</code></p><p>This parameter should be an array, its first element specifies the Rule priority, its second element specifies the Rule name. The optional third, forth, and fifth elements specify the Rule conditions, Rule actions, and Rule comment.<br> If the parameter array contains less than 4 elements, the array first element is used to update the priority of the already existing Rule with the name specified as the second array element. If such a Rule does not exist, the command returns an error.<br> If the parameter array contains 4 or more elements, the entire parameter array is stored as a new Rule. If there is an existing Rule with the same name, it is removed.</p></li><li><p><code>oldRule : string</code></p><p>This string parameter (specified after the DELETE keyword) specifies a name of the Rule to be removed. If such a Rule does not exist, the command does nothing and it does not return an error. The <code>UpdateAccountMailRule</code> command can be used by Domain Administrators only if they have the <code>RulesAllowed</code> access right. The <code>UpdateAccountSignalRule</code> command can be used by Domain Administrators only if they have the <code>SignalRulesAllowed</code> access right.<br> This command can be used by any Account user to modify own Rules (subject to &quot;allowed actions&quot; restrictions).</p></li></ul><h3 id="GETACCOUNTRPOPS" tabindex="-1"><code>GETACCOUNTRPOPS accountName</code> <a class="header-anchor" href="#GETACCOUNTRPOPS" aria-label="Permalink to &quot;`GETACCOUNTRPOPS accountName` {#GETACCOUNTRPOPS}&quot;">​</a></h3><p>Use this command to get the list of Account RPOP records. The command produces an output - a <em>dictionary</em> with RPOP records specified for the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTRPOPS" tabindex="-1"><code>SETACCOUNTRPOPS accountName newRecords</code> <a class="header-anchor" href="#SETACCOUNTRPOPS" aria-label="Permalink to &quot;`SETACCOUNTRPOPS accountName newRecords` {#SETACCOUNTRPOPS}&quot;">​</a></h3><p>Use this command to set the Account RPOP records.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newRecords : dictionary</code></p><p>This dictionary should contain the Account RPOP records. All old Account RPOP records are removed. This command can be used by Domain Administrators only if they have the <code>CanModifyRPOP</code> access right.</p></li></ul><h3 id="GETACCOUNTRSIPS" tabindex="-1"><code>GETACCOUNTRSIPS accountName</code> <a class="header-anchor" href="#GETACCOUNTRSIPS" aria-label="Permalink to &quot;`GETACCOUNTRSIPS accountName` {#GETACCOUNTRSIPS}&quot;">​</a></h3><p>Use this command to get the list of Account RSIP records. The command produces an output - a <em>dictionary</em> with RSIP records specified for the Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="SETACCOUNTRSIPS" tabindex="-1"><code>SETACCOUNTRSIPS accountName newRecords</code> <a class="header-anchor" href="#SETACCOUNTRSIPS" aria-label="Permalink to &quot;`SETACCOUNTRSIPS accountName newRecords` {#SETACCOUNTRSIPS}&quot;">​</a></h3><p>Use this command to set the Account RSIP records.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newRecords : dictionary</code></p><p>This dictionary should contain the Account RSIP records. All old Account RSIP records are removed. This command can be used by Domain Administrators only if they have the <code>CanModifyRSIP</code> access right.</p></li></ul><h3 id="UPDATESCHEDULEDTASK" tabindex="-1"><code>UPDATESCHEDULEDTASK accountName taskData</code> <a class="header-anchor" href="#UPDATESCHEDULEDTASK" aria-label="Permalink to &quot;`UPDATESCHEDULEDTASK accountName taskData` {#UPDATESCHEDULEDTASK}&quot;">​</a></h3><p>Use this command to set the Account Scheduled Task records.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>taskData : dictionary</code></p><p>This dictionary should contain the Scheduled Task data:</p><ul><li><p>id</p><p>the Scheduled Task name string. If there is no existing task with this name, a new Scheduled Task record is created.</p></li><li><p>program</p><p>the Scheduled Task program name string. It should be a name of the <a href="./PBXApp.html">Real-Time Application</a> available for the Account Domain environment. If this element is not specfied, an existing Scheduled Task record (if any) is deleted.</p></li><li><p>script</p><p>if the Scheduled Task program name is not set, this parameter can be used to set the name of the <a href="./CGPL.html#SyncScripts">Synchronous Script</a> available from the Account Domain Basic skin. If neither <code>program</code> nor this element is specified, the existing Scheduled Task record (if any) is deleted.</p></li><li><p>parameter</p><p>an optional <a href="./Data.html">simple Object</a>. When the Scheduled Task program is launched, this Object is passed to it as its <code>startParameter</code> element.</p></li><li><p>when</p><p>a timestamp (GMT time) specifying when the Scheduled Task should be launched, or <code>now</code> string.</p></li><li><p>period</p><p>an optional parameter - a <code>day</code>, <code>week</code>, <code>month</code>, or <code>year</code> string, or a number. When specified, the Scheduled Task is automatically re-scheduled after the specified period of time (if this parameter is a number, then it specified the number of seconds).<br> If this parameter is not specified, the Scheduled Task record is removed as soon as the Task is launched. When a Scheduled Task is launched, its <code>main</code> entry point is launched. The Task <code>startParameter</code> array contains the following elements:</p></li><li><p><code>startParameter[0]</code> is the Scheduled Task name string</p></li><li><p><code>startParameter[1]</code> is the timestamp specifying the moment the Task was started</p></li><li><p><code>startParameter[2]</code> (optional) is the Scheduled Task parameter data</p></li></ul><p>This command can be used by Domain Administrators with the <code>CanModifyRSIP</code> access right for the target Account.</p></li></ul><h3 id="GETACCOUNTRIGHTS" tabindex="-1"><code>GETACCOUNTRIGHTS accountName</code> <a class="header-anchor" href="#GETACCOUNTRIGHTS" aria-label="Permalink to &quot;`GETACCOUNTRIGHTS accountName` {#GETACCOUNTRIGHTS}&quot;">​</a></h3><p>Use this command to get the array of the Server or Domain access rights granted to the specified user. The command produces output data - an <em>array</em> listing all Account Server Access rights.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name.</p></li></ul><h3 id="GETACCOUNTINFO" tabindex="-1"><code>GETACCOUNTINFO accountName [Key keyName | ( keyList) ]</code> <a class="header-anchor" href="#GETACCOUNTINFO" aria-label="Permalink to &quot;`GETACCOUNTINFO accountName [Key keyName | ( keyList) ]` {#GETACCOUNTINFO}&quot;">​</a></h3><p>Use this command to get an element of the Account &quot;info&quot; dictionary. The command produces an output - see below.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above). You can also specify the single asterisk (<code>*</code>) symbol instead of an Account name. This will indicate the current authenticated Account.</p></li><li><p><code>keyList : array</code></p><p>This optional parameter specifies the names of the info keys to retrieve.<br> Note that when Account &quot;info&quot; data are stored in <code>.info</code> dictionary files, the &quot;info&quot; elements have dictionary names starting with the hash (<code>#</code>) symbol. You should NOT include the hash symbol into the keyName parameter of the GETACCOUNTINFO command.<br> Sample:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>GETACCOUNTINFO &quot;user1@domain1.com&quot; (LastLogin,LastAddress)</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The &quot;info&quot; element names are case-sensitive.</p></div><p>The output is a <em>dictionary</em> with all those &quot;info&quot; elements that exist and are specified in the keyList array.</p></li><li><p><code>keyName : string</code></p><p>This optional parameter specifies the name of the requested &quot;info&quot; element. It can be specified only if the <em>keyList</em> parameter is not specified.<br> Note that when Account &quot;info&quot; data are stored in <code>.info</code> dictionary files, the &quot;info&quot; elements have dictionary names starting with the hash symbol. You should NOT include the hash symbol into the keyName parameter of the GETACCOUNTINFO command.<br> Sample:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>GETACCOUNTINFO &quot;user1@domain1.com&quot; Key LastLogin</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The &quot;info&quot; element names are case-sensitive.</p></div><p>The output is the specified &quot;info&quot; element. If the element is not found, the output is an empty string - two quotation marks (<code>&quot;&quot;</code>).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can use the <code>GETACCOUNTINFO</code> command to retrieve elements from their own Account &quot;info&quot; data.</p></div></li></ul><h3 id="GETACCOUNTPREFS" tabindex="-1"><code>GETACCOUNTPREFS accountName</code> <a class="header-anchor" href="#GETACCOUNTPREFS" aria-label="Permalink to &quot;`GETACCOUNTPREFS accountName` {#GETACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to get the Account Preferences. The command produces an output - a <em>dictionary</em> with the Account Preferences.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can use the <code>GETACCOUNTPREFS</code> command to retrieve their own Account Preferences.</p></div></li></ul><h3 id="UPDATEACCOUNTPREFS" tabindex="-1"><code>UPDATEACCOUNTPREFS accountName newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATEACCOUNTPREFS accountName newSettings` {#UPDATEACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to modify the Account Preferences.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Account Preferences dictionary. It does not have to contain all Preferences data, the omitted elements will be left unmodified. If a new Preferences value is specified as the string <code>default</code>, the Preferences value is removed, so the default Preferences value will be used. This command can be used by Domain Administrators only if they have the <code>WebUserSettings</code> access right.</p></li></ul><h3 id="SETACCOUNTPREFS" tabindex="-1"><code>SETACCOUNTPREFS accountName newSettings</code> <a class="header-anchor" href="#SETACCOUNTPREFS" aria-label="Permalink to &quot;`SETACCOUNTPREFS accountName newSettings` {#SETACCOUNTPREFS}&quot;">​</a></h3><p>Use this command to set the Account Preferences.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary should contain the new Account Preferences. All old Account Preferences are removed. This command can be used by Domain Administrators only if they have the <code>WebUserSettings</code> access right.</p></li></ul><h3 id="GETACCOUNTEFFECTIVEPREFS" tabindex="-1"><code>GETACCOUNTEFFECTIVEPREFS accountName</code> <a class="header-anchor" href="#GETACCOUNTEFFECTIVEPREFS" aria-label="Permalink to &quot;`GETACCOUNTEFFECTIVEPREFS accountName` {#GETACCOUNTEFFECTIVEPREFS}&quot;">​</a></h3><p>Use this command to get the effective Account Preferences. The command produces an output - a <em>dictionary</em> with Account Preferences. Both the explicitly set and the default settings are included into that dictionary.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All users can use this command to retrieve their own effective Preferences.</p></div></li></ul><h3 id="KILLACCOUNTSESSIONS" tabindex="-1"><code>KILLACCOUNTSESSIONS accountName</code> <a class="header-anchor" href="#KILLACCOUNTSESSIONS" aria-label="Permalink to &quot;`KILLACCOUNTSESSIONS accountName` {#KILLACCOUNTSESSIONS}&quot;">​</a></h3><p>Use this command to interrupt all Account sessions (POP, IMAP, FTP, WebUser, etc.).</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All Domain Administrators can use this command.</p></div></li></ul><p>The following command manage the Account <a href="./../admin/objects/Accounts.html#AccessRights">Access Rights</a>. These command can be used by the Account owner and by Domain Administrators who have the <code>CanImpersonate</code> access right.</p><h3 id="GETACCOUNTACL" tabindex="-1"><code>GETACCOUNTACL accountName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETACCOUNTACL" aria-label="Permalink to &quot;`GETACCOUNTACL accountName [ AUTH authAccountName ]` {#GETACCOUNTACL}&quot;">​</a></h3><p>Use this command to get the Account Rights ACLs (Access Control Lists). The command produces an output - a <em>dictionary</em> with the ACL elements.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account (target Account). The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the ACL info is returned only if the specified Account has the <code>Admin</code> access right for the target Account.</p></li></ul><h3 id="SETACCOUNTACL" tabindex="-1"><code>SETACCOUNTACL accountName [ AUTH authAccountName ] newACL</code> <a class="header-anchor" href="#SETACCOUNTACL" aria-label="Permalink to &quot;`SETACCOUNTACL accountName [ AUTH authAccountName ] newACL` {#SETACCOUNTACL}&quot;">​</a></h3><p>Use this command to modify the access control list for the Account Access Rights.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account (target Account). The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the ACL info is updated only if the specified Account has the <code>Admin</code> access right for target Account.</p></li><li><p><code>newACL : dictionary</code></p><p>This parameter specifies the access right elements to be modified. Each dictionary key specifies an <em>identifier</em>, and the key value should be a string with access right symbols.<br> If the key value string starts with the minus (<code>-</code>) symbol, access rights specified in the string are removed from the access right element. If the key value string starts with the plus (<code>+</code>) symbol, access rights specified in the string are added to the access right element. In other cases, access rights specified in the string replace the set of rights in the access right element. If the access right element for the specified key did not exist, it is created. If the new access right element has empty set of access rights, the element is removed.</p></li></ul><h3 id="GETACCOUNTACLRIGHTS" tabindex="-1"><code>GETACCOUNTACLRIGHTS accountName AUTH authAccountName</code> <a class="header-anchor" href="#GETACCOUNTACLRIGHTS" aria-label="Permalink to &quot;`GETACCOUNTACLRIGHTS accountName AUTH authAccountName` {#GETACCOUNTACLRIGHTS}&quot;">​</a></h3><p>This command produces an output - a <em>string</em> with the effective access rights for the given authAccountName.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account (target Account). The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>authAccountName : string</code></p><p>This parameter specifies the name of an Account whose effective access rights for the target Account should be retrieved.</p></li></ul><p>The following commands are available for the System Administrators only:</p><h3 id="SETACCOUNTSETTINGS" tabindex="-1"><code>SETACCOUNTSETTINGS accountName newSettings</code> <a class="header-anchor" href="#SETACCOUNTSETTINGS" aria-label="Permalink to &quot;`SETACCOUNTSETTINGS accountName newSettings` {#SETACCOUNTSETTINGS}&quot;">​</a></h3><p>Use this command to change the Account settings.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Account settings dictionary. All old Account settings are removed.</p></li></ul><h3 id="GETACCOUNTLOCATION" tabindex="-1"><code>GETACCOUNTLOCATION accountName</code> <a class="header-anchor" href="#GETACCOUNTLOCATION" aria-label="Permalink to &quot;`GETACCOUNTLOCATION accountName` {#GETACCOUNTLOCATION}&quot;">​</a></h3><p>Use this command to get the Account file directory path (for multi-mailbox Accounts) or the Account INBOX Mailbox path (for single-mailbox Accounts). The command produces an output - a <em>string</em> with the Account file path. The path is relative to the file directory of the Account Domain.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><h3 id="GETACCOUNTPRESENCE" tabindex="-1"><code>GETACCOUNTPRESENCE accountName</code> <a class="header-anchor" href="#GETACCOUNTPRESENCE" aria-label="Permalink to &quot;`GETACCOUNTPRESENCE accountName` {#GETACCOUNTPRESENCE}&quot;">​</a></h3><p>Use this command to get the Account &quot;presence&quot; status. The command produces an output:</p><ul><li><p><em>array</em> of two <em>strings</em> - the Account &quot;presence&quot; status and its custom status message, or</p></li><li><p><em>string</em> - the Account &quot;presence&quot; status (if no custom status message is set), or</p></li><li><p>null-object - if the Account &quot;presence&quot; status is not set at all.</p></li><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name (see above).</p></li></ul><p>The <code>AccessMode</code> Account and Domain Setting specifies <a href="./../admin/objects/Accounts.html#Services">Enabled Services</a>. The Setting value can be one of the following:</p><ul><li>The <code>All</code> string: all services are enabled.</li><li>The <code>None</code> string: all services are disabled.</li><li>An array of strings. The first array element is a number or a numeric string, the other array elements are names of the enabled services.<br> All services with numbers larger than the value of the first array element are enabled, too.<br> The currently supported services (with their numbers) are:<br> 1:Mail, 2:POP, 3:IMAP, 4:WebMail, 5:PWD, 6:Agent, 7:WebSite, 8:Relay, 9:Roaming, 10:FTP, 11:MAPI, 12:TLS, 13:S/MIME, 14:LDAP, 15:WebCAL, 16:RADIUS, 17:SIP, 18:PBX, 19:XMPP, 20:XIMSS, 21:Signal, 22:AirSync, 23:HTTP, 24:MobilePBX, 25:XMedia, 26:YMedia, 27:MobileClient, 28:ClientMail, 29:ClientIM, 30:ClientVoIP</li></ul><h2 id="Group" tabindex="-1">Group Administration <a class="header-anchor" href="#Group" aria-label="Permalink to &quot;Group Administration {#Group}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the Groups Administration CLI commands.</p><h3 id="LISTGROUPS" tabindex="-1"><code>LISTGROUPS [ domainName ]</code> <a class="header-anchor" href="#LISTGROUPS" aria-label="Permalink to &quot;`LISTGROUPS [ domainName ]` {#LISTGROUPS}&quot;">​</a></h3><p>Use this command to get the list of all Groups in the Domain. The command produces output data - an <em>array</em> with the names of all Groups in the specified (or default) Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="CREATEGROUP" tabindex="-1"><code>CREATEGROUP groupName [ settings ]</code> <a class="header-anchor" href="#CREATEGROUP" aria-label="Permalink to &quot;`CREATEGROUP groupName [ settings ]` {#CREATEGROUP}&quot;">​</a></h3><p>Use this command to create new Groups.</p><ul><li><p><code>groupName : string</code></p><p>This parameter specifies the name for the new Group.<br> The name can contain the <code>@</code> symbol followed by the Domain name, in this case the Group is created in the specified Domain. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>settings : dictionary</code></p><p>This optional parameter specifies the initial Group settings and the members list. This command can be used by Domain Administrators only if they have the <code>CanCreateGroups</code> access right.</p></li></ul><h3 id="RENAMEGROUP" tabindex="-1"><code>RENAMEGROUP oldGroupName into newGroupName</code> <a class="header-anchor" href="#RENAMEGROUP" aria-label="Permalink to &quot;`RENAMEGROUP oldGroupName into newGroupName` {#RENAMEGROUP}&quot;">​</a></h3><p>Use this command to rename Groups.</p><ul><li><p><code>oldGroupName : string</code></p><p>This parameter specifies the name of an existing Group. The name can include the Domain name (see above).</p></li><li><p><code>newGroupName : string</code></p><p>This parameter specifies the new Group name. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateGroups</code> access right.</p></li></ul><h3 id="DELETEGROUP" tabindex="-1"><code>DELETEGROUP groupName</code> <a class="header-anchor" href="#DELETEGROUP" aria-label="Permalink to &quot;`DELETEGROUP groupName` {#DELETEGROUP}&quot;">​</a></h3><p>Use this command to remove Groups.</p><ul><li><p><code>groupName : string</code></p><p>This parameter specifies the name of an existing Group. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateGroups</code> access right.</p></li></ul><h3 id="GETGROUP" tabindex="-1"><code>GETGROUP groupName</code> <a class="header-anchor" href="#GETGROUP" aria-label="Permalink to &quot;`GETGROUP groupName` {#GETGROUP}&quot;">​</a></h3><p>Use this command to get the Group settings. The command produces an output - a <em>dictionary</em> with the Group settings and members.</p><ul><li><p><code>groupName : string</code></p><p>This parameter specifies the name of an existing Group. The name can include the Domain name (see above).</p></li></ul><h3 id="SETGROUP" tabindex="-1"><code>SETGROUP groupName newSettings</code> <a class="header-anchor" href="#SETGROUP" aria-label="Permalink to &quot;`SETGROUP groupName newSettings` {#SETGROUP}&quot;">​</a></h3><p>Use this command to set the Group settings.</p><ul><li><p><code>groupName : string</code></p><p>This parameter specifies the name of an existing Group. The name can include the Domain name (see above).</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Group settings dictionary. This command can be used by Domain Administrators only if they have the <code>CanCreateGroups</code> access right.</p></li></ul><h2 id="Forward" tabindex="-1">Forwarder Administration <a class="header-anchor" href="#Forward" aria-label="Permalink to &quot;Forwarder Administration {#Forward}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the Forwarders Administration CLI commands.</p><h3 id="LISTFORWARDERS" tabindex="-1"><code>LISTFORWARDERS [ domainName ]</code> <a class="header-anchor" href="#LISTFORWARDERS" aria-label="Permalink to &quot;`LISTFORWARDERS [ domainName ]` {#LISTFORWARDERS}&quot;">​</a></h3><p>Use this command to get the list of all Forwarders in the Domain. The command produces output data - an <em>array</em> with the names of all Forwarders in the specified (or default) Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="CREATEFORWARDER" tabindex="-1"><code>CREATEFORWARDER forwarderName TO address</code> <a class="header-anchor" href="#CREATEFORWARDER" aria-label="Permalink to &quot;`CREATEFORWARDER forwarderName TO address` {#CREATEFORWARDER}&quot;">​</a></h3><p>Use this command to create new Forwarders.</p><ul><li><p><code>forwarderName : string</code></p><p>This parameter specifies the name for the new Forwarder.<br> The name can contain the <code>@</code> symbol followed by the Domain name, in this case the Forwarder is created in the specified Domain. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>address : string</code></p><p>This parameter specifies the E-mail address the Forwarder should reroute E-mail messages and Signals to. This command can be used by Domain Administrators only if they have the <code>CanCreateForwarders</code> access right.</p></li></ul><h3 id="RENAMEFORWARDER" tabindex="-1"><code>RENAMEFORWARDER oldForwarderName INTO newForwarderName</code> <a class="header-anchor" href="#RENAMEFORWARDER" aria-label="Permalink to &quot;`RENAMEFORWARDER oldForwarderName INTO newForwarderName` {#RENAMEFORWARDER}&quot;">​</a></h3><p>Use this command to rename Forwarders.</p><ul><li><p><code>oldForwarderName : string</code></p><p>This parameter specifies the name of an existing Forwarder. The name can include the Domain name (see above).</p></li><li><p><code>newForwarderName : string</code></p><p>This parameter specifies the new Forwarder name. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateForwarders</code> access right.</p></li></ul><h3 id="DELETEFORWARDER" tabindex="-1"><code>DELETEFORWARDER forwarderName</code> <a class="header-anchor" href="#DELETEFORWARDER" aria-label="Permalink to &quot;`DELETEFORWARDER forwarderName` {#DELETEFORWARDER}&quot;">​</a></h3><p>Use this command to remove Forwarders.</p><ul><li><p><code>forwarderName : string</code></p><p>This parameter specifies the name of an existing Forwarder. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateForwarders</code> access right.</p></li></ul><h3 id="GETFORWARDER" tabindex="-1"><code>GETFORWARDER forwarderName</code> <a class="header-anchor" href="#GETFORWARDER" aria-label="Permalink to &quot;`GETFORWARDER forwarderName` {#GETFORWARDER}&quot;">​</a></h3><p>Use this command to get the Forwarder address. The command produces an output - a <em>string</em> with the E-mail address this Forwarder reroutes all E-mail messages and Signals to.</p><ul><li><p><code>forwarderName : string</code></p><p>This parameter specifies the name of an existing Forwarder. The name can include the Domain name (see above).</p></li></ul><h3 id="FINDFORWARDERS" tabindex="-1"><code>FINDFORWARDERS domainName TO forwarderAddress</code> <a class="header-anchor" href="#FINDFORWARDERS" aria-label="Permalink to &quot;`FINDFORWARDERS domainName TO forwarderAddress` {#FINDFORWARDERS}&quot;">​</a></h3><p>Use this command to find all Forwarders pointing to the specified address. The command produces an output - an <em>array</em> with the found Forwarder names.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>forwarderAddress : string</code></p><p>This parameter specifies an E-mail address to look for.</p></li></ul><h2 id="NamedTask" tabindex="-1">Named Task Administration <a class="header-anchor" href="#NamedTask" aria-label="Permalink to &quot;Named Task Administration {#NamedTask}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the Named Task Administration CLI commands.</p><h3 id="LISTDOMAINNAMEDTASKS" tabindex="-1"><code>LISTDOMAINNAMEDTASKS [ domainName ]</code> <a class="header-anchor" href="#LISTDOMAINNAMEDTASKS" aria-label="Permalink to &quot;`LISTDOMAINNAMEDTASKS [ domainName ]` {#LISTDOMAINNAMEDTASKS}&quot;">​</a></h3><p>Use this command to get the list of all Named Tasks in the Domain. The command produces output data - a <em>dictionary</em> where the keys are the Named Task names, and the values are dictionaries, containing the Task owner name, the task Real Name, and the name of the Real-Time Application program this Named Task runs.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="LISTACCOUNTNAMEDTASKS" tabindex="-1"><code>LISTACCOUNTNAMEDTASKS accountName</code> <a class="header-anchor" href="#LISTACCOUNTNAMEDTASKS" aria-label="Permalink to &quot;`LISTACCOUNTNAMEDTASKS accountName` {#LISTACCOUNTNAMEDTASKS}&quot;">​</a></h3><p>Use this command to get the list of all Named Tasks owned by the specified Account. The command produces output data - a <em>dictionary</em> containing the same data as the LISTDOMAINNAMEDTASKS command result.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the owner Account name.</p></li></ul><h3 id="CREATENAMEDTASK" tabindex="-1"><code>CREATENAMEDTASK taskName FOR accountName</code> <a class="header-anchor" href="#CREATENAMEDTASK" aria-label="Permalink to &quot;`CREATENAMEDTASK taskName FOR accountName` {#CREATENAMEDTASK}&quot;">​</a></h3><p>Use this command to create new Named Tasks.</p><ul><li><p><code>taskName : string</code></p><p>This parameter specifies the name for the new Named Task.<br> The name can contain the <code>@</code> symbol followed by the Domain name, in this case the Named Task is created in the specified Domain. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>accountName : string</code></p><p>This parameter specifies the owner Account name. It must not contain the <code>@</code> symbol and a Domain name, as this owner Account must be in the same Domain as the Named Task itself. This command can be used by Domain Administrators only if they have the <code>CanCreateNamedTasks</code> access right.</p></li></ul><h3 id="RENAMENAMEDTASK" tabindex="-1"><code>RENAMENAMEDTASK oldTaskName into newTaskName</code> <a class="header-anchor" href="#RENAMENAMEDTASK" aria-label="Permalink to &quot;`RENAMENAMEDTASK oldTaskName into newTaskName` {#RENAMENAMEDTASK}&quot;">​</a></h3><p>Use this command to rename Named Tasks.</p><ul><li><p><code>oldTaskName : string</code></p><p>This parameter specifies the name of an existing Named Task. The name can include the Domain name (see above).</p></li><li><p><code>newTaskName : string</code></p><p>This parameter specifies the new Named Task name. This command can be used by Domain Administrators only if they have the <code>CanCreateNamedTasks</code> access right.</p></li></ul><h3 id="DELETENAMEDTASK" tabindex="-1"><code>DELETENAMEDTASK taskName</code> <a class="header-anchor" href="#DELETENAMEDTASK" aria-label="Permalink to &quot;`DELETENAMEDTASK taskName` {#DELETENAMEDTASK}&quot;">​</a></h3><p>Use this command to remove Named Tasks.</p><ul><li><p><code>taskName : string</code></p><p>This parameter specifies the name of an existing Named Task. The name can include the Domain name (see above). This command can be used by Domain Administrators only if they have the <code>CanCreateNamedTasks</code> access right.</p></li></ul><h3 id="GETNAMEDTASK" tabindex="-1"><code>GETNAMEDTASK taskName</code> <a class="header-anchor" href="#GETNAMEDTASK" aria-label="Permalink to &quot;`GETNAMEDTASK taskName` {#GETNAMEDTASK}&quot;">​</a></h3><p>Use this command to get the Named Task settings. The command produces an output - a <em>dictionary</em> with the Named Task settings.</p><ul><li><p><code>taskName : string</code></p><p>This parameter specifies the name of an existing Named Task. The name can include the Domain name (see above).</p></li></ul><h3 id="UPDATENAMEDTASK" tabindex="-1"><code>UPDATENAMEDTASK taskName newSettings</code> <a class="header-anchor" href="#UPDATENAMEDTASK" aria-label="Permalink to &quot;`UPDATENAMEDTASK taskName newSettings` {#UPDATENAMEDTASK}&quot;">​</a></h3><p>Use this command to set the Named Task settings.</p><ul><li><p><code>taskName : string</code></p><p>This parameter specifies the name of an existing Named Task. The name can include the Domain name (see above).</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Named Task settings dictionary. This command can be used by Domain Administrators only if they have the <code>CanCreateNamedTasks</code> access right.</p></li></ul><h2 id="Rights" tabindex="-1">Access Rights Administration <a class="header-anchor" href="#Rights" aria-label="Permalink to &quot;Access Rights Administration {#Rights}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">Master</a> Server access right to use the Access Rights Administration CLI commands.</p><h3 id="SETACCOUNTRIGHTS" tabindex="-1"><code>SETACCOUNTRIGHTS accountName newRights</code> <a class="header-anchor" href="#SETACCOUNTRIGHTS" aria-label="Permalink to &quot;`SETACCOUNTRIGHTS accountName newRights` {#SETACCOUNTRIGHTS}&quot;">​</a></h3><p>Use this command to set the Account Server Access rights.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The name can include the Domain name.</p></li><li><p><code>newRights : array</code></p><p>This array should contain the Access Right codes. All old Account access rights are removed. To set access rights for an Account in a secondary Domain (i.e. Domain Administration Rights), the user may have only the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right.</p></li></ul><h2 id="Mailbox" tabindex="-1">Mailbox Administration <a class="header-anchor" href="#Mailbox" aria-label="Permalink to &quot;Mailbox Administration {#Mailbox}&quot;">​</a></h2><p>A user should be the Mailbox owner, or should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanAccessMailboxes</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to use the Mailbox Administration CLI commands.</p><h3 id="LISTMAILBOXES" tabindex="-1"><code>LISTMAILBOXES accountName [ FILTER filter ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#LISTMAILBOXES" aria-label="Permalink to &quot;`LISTMAILBOXES accountName [ FILTER filter ] [ AUTH authAccountName ]` {#LISTMAILBOXES}&quot;">​</a></h3><p>Use this command to get the list of Account Mailboxes. The command produces an output - a <em>dictionary</em>.<br> each dictionary key specifies a Mailbox name;<br> if the authAccountName user is not specified or if the specified user has the <code>Select</code> access right for this Mailbox, the key value contains a <em>dictionary</em> with Mailbox information;<br> if the specified authAccountName does not have the <code>Select</code> access right, the key value contains an empty <em>array</em>;<br> if there is a &#39;mailbox folder&#39; with the dictionary key, but there is no &#39;regular&#39; Mailbox with that name, the key value is an empty <em>array</em>;<br> if there is a &#39;mailbox folder&#39; with the dictionary key, and there is also a &#39;regular&#39; Mailbox with that name, the key value is an <em>array</em> with one element - the information for the &#39;regular&#39; Mailbox (either a dictionary or an empty array).</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>filter : string</code></p><p>This optional parameter specifies the filter string to apply to Account Mailbox names. The filter can use the same wildcard symbols <code>*</code> and <code>%</code> as the IMAP LIST command. If the filter is not specified, the filter string <code>*</code> is assumed, and all Account Mailboxes are returned.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the LIST operation should be executed. If this name is specified, the output includes only those Mailboxes for which the specified Account has the <code>Lookup</code> Mailbox access right.</p></li></ul><h3 id="CREATEMAILBOX" tabindex="-1"><code>CREATEMAILBOX accountName MAILBOX mailboxName [ CLASS mailboxClass ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#CREATEMAILBOX" aria-label="Permalink to &quot;`CREATEMAILBOX accountName MAILBOX mailboxName [ CLASS mailboxClass ] [ AUTH authAccountName ]` {#CREATEMAILBOX}&quot;">​</a></h3><p>Use this command to create a Mailbox in the specified Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name for the new Mailbox.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf this operation should be executed.</p></li><li><p><code>mailboxClass : string</code></p><p>This optional parameter specifies the Mailbox class for the new Mailbox</p></li></ul><h3 id="DELETEMAILBOX" tabindex="-1"><code>DELETEMAILBOX accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#DELETEMAILBOX" aria-label="Permalink to &quot;`DELETEMAILBOX accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#DELETEMAILBOX}&quot;">​</a></h3><h3 id="deletemailbox-accountname-mailboxes-mailboxname-auth-authaccountname" tabindex="-1"><code>DELETEMAILBOX accountName MAILBOXES mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#deletemailbox-accountname-mailboxes-mailboxname-auth-authaccountname" aria-label="Permalink to &quot;`DELETEMAILBOX accountName MAILBOXES mailboxName [ AUTH authAccountName ]`&quot;">​</a></h3><p>Use this command to remove a Mailbox from the specified Account. If the keyword MAILBOXES is used, all nested Mailboxes (submailboxes) are deleted, too.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of the Mailbox to be deleted.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the Mailbox is deleted only if the specified Account has the <code>Create</code> access right for the &#39;outer&#39; Mailbox (this means that an Account should have the <code>Create</code> access right for the <code>Archive</code> Mailbox in order to delete the <code>Archive/March</code> Mailbox), and the specified Account should have the <code>DELETE</code> right for the specified Mailbox.</p></li></ul><h3 id="RENAMEMAILBOX" tabindex="-1"><code>RENAMEMAILBOX accountName MAILBOX mailboxName INTO newMailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#RENAMEMAILBOX" aria-label="Permalink to &quot;`RENAMEMAILBOX accountName MAILBOX mailboxName INTO newMailboxName [ AUTH authAccountName ]` {#RENAMEMAILBOX}&quot;">​</a></h3><h3 id="renamemailbox-accountname-mailboxes-mailboxname-into-newmailboxname-auth-authaccountname" tabindex="-1"><code>RENAMEMAILBOX accountName MAILBOXES mailboxName INTO newMailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#renamemailbox-accountname-mailboxes-mailboxname-into-newmailboxname-auth-authaccountname" aria-label="Permalink to &quot;`RENAMEMAILBOX accountName MAILBOXES mailboxName INTO newMailboxName [ AUTH authAccountName ]`&quot;">​</a></h3><p>Use this command to rename a Mailbox in the specified Account. If the keyword MAILBOXES is used, all nested Mailboxes (submailboxes) are renamed, too.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of the Mailbox to be renamed.</p></li><li><p><code>newMailboxName : string</code></p><p>This parameter specifies the new name for the Mailbox.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the Mailbox is renamed only if the specified Account has a right to perform the DELETEMAILBOX operation with the original Mailbox name and the CREATEMAILBOX operation with the new Mailbox name (see above).</p></li></ul><h3 id="GETMAILBOXINFO" tabindex="-1"><code>GETMAILBOXINFO accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETMAILBOXINFO" aria-label="Permalink to &quot;`GETMAILBOXINFO accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#GETMAILBOXINFO}&quot;">​</a></h3><p>Use this command to get the internal information about the Account Mailbox. The command produces an output - a <em>dictionary</em> with the Mailbox internal information.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of an existing Mailbox in the specified Account.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the Mailbox info is returned only if the specified Account has the <code>Select</code> Mailbox access right.</p></li></ul><h3 id="GETMAILBOXACL" tabindex="-1"><code>GETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETMAILBOXACL" aria-label="Permalink to &quot;`GETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#GETMAILBOXACL}&quot;">​</a></h3><p>Use this command to get the access control list for the Account Mailbox. The command produces an output - a <em>dictionary</em> with the Mailbox access elements.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of an existing Mailbox in the specified Account.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the ACL info is returned only if the specified Account has the <code>Admin</code> access right for the specified Mailbox.</p></li></ul><h3 id="SETMAILBOXACL" tabindex="-1"><code>SETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ] newACL</code> <a class="header-anchor" href="#SETMAILBOXACL" aria-label="Permalink to &quot;`SETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ] newACL` {#SETMAILBOXACL}&quot;">​</a></h3><p>Use this command to modify the access control list for the Account Mailbox.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of an existing Mailbox in the specified Account.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed. If this name is specified, the ACL info is updated only if the specified Account has the <code>Admin</code> access right for the specified Mailbox.</p></li><li><p><code>newACL : dictionary</code></p><p>This parameter specifies the access right elements to be modified. Each dictionary key specifies an <em>identifier</em>, and the key value should be a string with access right symbols.<br> If the key value string starts with the minus (<code>-</code>) symbol, access rights specified in the string are removed from the access right element. If the key value string starts with the plus (<code>+</code>) symbol, access rights specified in the string are added to the access right element. In other cases, access rights specified in the string replace the set of rights in the access right element. If the access right element for the specified key did not exist, it is created. If the new access right element has empty set of access rights, the element is removed.</p></li></ul><h3 id="GETMAILBOXRIGHTS" tabindex="-1"><code>GETMAILBOXRIGHTS accountName MAILBOX mailboxName AUTH authAccountName</code> <a class="header-anchor" href="#GETMAILBOXRIGHTS" aria-label="Permalink to &quot;`GETMAILBOXRIGHTS accountName MAILBOX mailboxName AUTH authAccountName` {#GETMAILBOXRIGHTS}&quot;">​</a></h3><p>This command produces an output - a <em>string</em> with the effective Mailbox access rights for the given authAccountName.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of an existing Mailbox in the specified Account.</p></li><li><p><code>authaccountname : string</code></p><p>This parameter specifies the name of an Account whose effective access rights should be retrieved.</p></li></ul><h3 id="SETMAILBOXCLASS" tabindex="-1"><code>SETMAILBOXCLASS accountName MAILBOX mailboxName [ AUTH authAccountName ] CLASS newClass</code> <a class="header-anchor" href="#SETMAILBOXCLASS" aria-label="Permalink to &quot;`SETMAILBOXCLASS accountName MAILBOX mailboxName [ AUTH authAccountName ] CLASS newClass` {#SETMAILBOXCLASS}&quot;">​</a></h3><p>Use this command to set the &quot;class&quot; of an Account Mailbox.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>mailboxName : string</code></p><p>This parameter specifies the name of an existing Mailbox in the specified Account.</p></li><li><p><code>authaccountname : string</code></p><p>This optional parameter specifies the name of an Account whose Mailbox access rights should be used.</p></li><li><p><code>newClass : string</code></p><p>The Mailbox class.</p></li></ul><h3 id="GETMAILBOXSUBSCRIPTION" tabindex="-1"><code>GETMAILBOXSUBSCRIPTION accountName</code> <a class="header-anchor" href="#GETMAILBOXSUBSCRIPTION" aria-label="Permalink to &quot;`GETMAILBOXSUBSCRIPTION accountName` {#GETMAILBOXSUBSCRIPTION}&quot;">​</a></h3><p>This command produces an output - an <em>array</em> with the list of Account &quot;subscribed Mailboxes&quot;.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li></ul><h3 id="SETMAILBOXSUBSCRIPTION" tabindex="-1"><code>SETMAILBOXSUBSCRIPTION accountName newSubscription</code> <a class="header-anchor" href="#SETMAILBOXSUBSCRIPTION" aria-label="Permalink to &quot;`SETMAILBOXSUBSCRIPTION accountName newSubscription` {#SETMAILBOXSUBSCRIPTION}&quot;">​</a></h3><p>Use this command to set the Account &quot;subscribed Mailboxes&quot; list.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>newSubscription : array</code></p><p>The list of subscribed Mailboxes. Each array element should be a <em>string</em> with a Mailbox name.</p></li></ul><h3 id="GETMAILBOXALIASES" tabindex="-1"><code>GETMAILBOXALIASES accountName</code> <a class="header-anchor" href="#GETMAILBOXALIASES" aria-label="Permalink to &quot;`GETMAILBOXALIASES accountName` {#GETMAILBOXALIASES}&quot;">​</a></h3><p>This command produces an output - a <em>dictionary</em>. Each dictionary key is the name of an existing Mailbox alias, and the key value is a <em>string</em> with the name of Mailbox this alias points to.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li></ul><h3 id="SETMAILBOXALIASES" tabindex="-1"><code>SETMAILBOXALIASES accountName newAliases</code> <a class="header-anchor" href="#SETMAILBOXALIASES" aria-label="Permalink to &quot;`SETMAILBOXALIASES accountName newAliases` {#SETMAILBOXALIASES}&quot;">​</a></h3><p>Use this command to set the Account Mailbox aliases.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>newAliases : dictionary</code></p><p>The set of new Mailbox aliases.</p></li></ul><h2 id="Alert" tabindex="-1">Alert Administration <a class="header-anchor" href="#Alert" aria-label="Permalink to &quot;Alert Administration {#Alert}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanPostAlerts</code> <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the <a href="./../admin/sysadmin/Alerts.html">Alert</a> Administration CLI commands.</p><h3 id="GETDOMAINALERTS" tabindex="-1"><code>GETDOMAINALERTS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINALERTS" aria-label="Permalink to &quot;`GETDOMAINALERTS [ domainName ]` {#GETDOMAINALERTS}&quot;">​</a></h3><p>Use this command to get the Domain Alerts. The command produces an output - a <em>dictionary</em> with the Domain alert strings and time stamps.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain.</p></li></ul><h3 id="SETDOMAINALERTS" tabindex="-1"><code>SETDOMAINALERTS [ domainName ] newAlerts</code> <a class="header-anchor" href="#SETDOMAINALERTS" aria-label="Permalink to &quot;`SETDOMAINALERTS [ domainName ] newAlerts` {#SETDOMAINALERTS}&quot;">​</a></h3><p>Use this command to change the Domain alerts.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain.</p></li><li><p><code>newAlerts : dictionary</code></p><p>This dictionary is used to replace the Domain alert dictionary. All old Domain alerts are removed.</p></li></ul><h3 id="POSTDOMAINALERT" tabindex="-1"><code>POSTDOMAINALERT domainName ALERT newAlert</code> <a class="header-anchor" href="#POSTDOMAINALERT" aria-label="Permalink to &quot;`POSTDOMAINALERT domainName ALERT newAlert` {#POSTDOMAINALERT}&quot;">​</a></h3><p>Use this command to post a Domain-wide alert message.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newAlert : string</code></p><p>This string specifies the Alert text.</p></li></ul><h3 id="REMOVEDOMAINALERT" tabindex="-1"><code>REMOVEDOMAINALERT domainName ALERT timeStamp</code> <a class="header-anchor" href="#REMOVEDOMAINALERT" aria-label="Permalink to &quot;`REMOVEDOMAINALERT domainName ALERT timeStamp` {#REMOVEDOMAINALERT}&quot;">​</a></h3><p>Use this command to remove a Domain-wide alert message.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>timeStamp : string</code></p><p>This string specifies the time stamp of the Alert message to be removed.</p></li></ul><h3 id="GETACCOUNTALERTS" tabindex="-1"><code>GETACCOUNTALERTS accountName</code> <a class="header-anchor" href="#GETACCOUNTALERTS" aria-label="Permalink to &quot;`GETACCOUNTALERTS accountName` {#GETACCOUNTALERTS}&quot;">​</a></h3><p>Use this command to get the Account Alerts. The command produces an output - a <em>dictionary</em> with the Account alert strings and time stamps.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li></ul><h3 id="SETACCOUNTALERTS" tabindex="-1"><code>SETACCOUNTALERTS accountName newAlerts</code> <a class="header-anchor" href="#SETACCOUNTALERTS" aria-label="Permalink to &quot;`SETACCOUNTALERTS accountName newAlerts` {#SETACCOUNTALERTS}&quot;">​</a></h3><p>Use this command to change the Account alerts.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>newAlerts : dictionary</code></p><p>This dictionary is used to replace the Account alert dictionary. All old Account alerts are removed.</p></li></ul><h3 id="POSTACCOUNTALERT" tabindex="-1"><code>POSTACCOUNTALERT accountName ALERT newAlert</code> <a class="header-anchor" href="#POSTACCOUNTALERT" aria-label="Permalink to &quot;`POSTACCOUNTALERT accountName ALERT newAlert` {#POSTACCOUNTALERT}&quot;">​</a></h3><p>Use this command to post an Account alert message.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>newAlert : string</code></p><p>This string specifies the Alert text.</p></li></ul><h3 id="REMOVEACCOUNTALERT" tabindex="-1"><code>REMOVEACCOUNTALERT accountName ALERT timeStamp</code> <a class="header-anchor" href="#REMOVEACCOUNTALERT" aria-label="Permalink to &quot;`REMOVEACCOUNTALERT accountName ALERT timeStamp` {#REMOVEACCOUNTALERT}&quot;">​</a></h3><p>Use this command to remove an Account alert message.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>timeStamp : string</code></p><p>This string specifies the time stamp of the Alert message to be removed.</p></li></ul><p>The following commands are available for the System Administrators only:</p><h3 id="GETSERVERALERTS" tabindex="-1"><code>GETSERVERALERTS</code> <a class="header-anchor" href="#GETSERVERALERTS" aria-label="Permalink to &quot;`GETSERVERALERTS` {#GETSERVERALERTS}&quot;">​</a></h3><p>Use this command to get the list of the server-wide Alerts. The command produces an output - a <em>dictionary</em> with the server alert strings and time stamps.</p><h3 id="SETSERVERALERTS" tabindex="-1"><code>SETSERVERALERTS newAlerts</code> <a class="header-anchor" href="#SETSERVERALERTS" aria-label="Permalink to &quot;`SETSERVERALERTS newAlerts` {#SETSERVERALERTS}&quot;">​</a></h3><p>Use this command to change the server-wide Alerts.</p><ul><li><p><code>newAlerts : dictionary</code></p><p>This dictionary is used to replace the server-wide Alert dictionary. All old server-wide alerts are removed.</p></li></ul><h3 id="POSTSERVERALERT" tabindex="-1"><code>POSTSERVERALERT newAlert</code> <a class="header-anchor" href="#POSTSERVERALERT" aria-label="Permalink to &quot;`POSTSERVERALERT newAlert` {#POSTSERVERALERT}&quot;">​</a></h3><p>Use this command to post a server-wide Alert message.</p><ul><li><p><code>newAlert : string</code></p><p>This string specifies the Alert text.</p></li></ul><h3 id="REMOVESERVERALERT" tabindex="-1"><code>REMOVESERVERALERT timeStamp</code> <a class="header-anchor" href="#REMOVESERVERALERT" aria-label="Permalink to &quot;`REMOVESERVERALERT timeStamp` {#REMOVESERVERALERT}&quot;">​</a></h3><p>Use this command to remove a server-wide Alert message.</p><ul><li><p><code>timeStamp : string</code></p><p>This string specifies the time stamp of the Alert message to be removed.</p></li></ul><h3 id="GETCLUSTERALERTS" tabindex="-1"><code>GETCLUSTERALERTS</code> <a class="header-anchor" href="#GETCLUSTERALERTS" aria-label="Permalink to &quot;`GETCLUSTERALERTS` {#GETCLUSTERALERTS}&quot;">​</a></h3><h3 id="SETCLUSTERALERTS" tabindex="-1"><code>SETCLUSTERALERTS newAlerts</code> <a class="header-anchor" href="#SETCLUSTERALERTS" aria-label="Permalink to &quot;`SETCLUSTERALERTS newAlerts` {#SETCLUSTERALERTS}&quot;">​</a></h3><h3 id="POSTCLUSTERALERT" tabindex="-1"><code>POSTCLUSTERALERT newAlert</code> <a class="header-anchor" href="#POSTCLUSTERALERT" aria-label="Permalink to &quot;`POSTCLUSTERALERT newAlert` {#POSTCLUSTERALERT}&quot;">​</a></h3><h3 id="REMOVECLUSTERALERT" tabindex="-1"><code>REMOVECLUSTERALERT timeStamp</code> <a class="header-anchor" href="#REMOVECLUSTERALERT" aria-label="Permalink to &quot;`REMOVECLUSTERALERT timeStamp` {#REMOVECLUSTERALERT}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>GET</code>|<code>SET</code>|<code>POST</code>|<code>REMOVE</code>]<code>SERVERALERT</code>[<code>S</code>] commands to work with the cluster-wide Alerts.</p><h2 id="FreeBusy" tabindex="-1">Free/Busy <a class="header-anchor" href="#FreeBusy" aria-label="Permalink to &quot;Free/Busy {#FreeBusy}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or <code>CanModifyFreeBusy</code> the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the <a href="./../admin/misc/Calendars.html#FreeBusy">Administration CLI commands</a>.</p><h3 id="GETDOMAINFREEBUSY" tabindex="-1"><code>GETDOMAINFREEBUSY [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINFREEBUSY" aria-label="Permalink to &quot;`GETDOMAINFREEBUSY [ domainName ]` {#GETDOMAINFREEBUSY}&quot;">​</a></h3><p>Use this command to get the Domain Free/Busy settings. The command produces an output - a <em>dictionary</em>, with the Domain Free/Busy settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain</p></li></ul><h3 id="SETDOMAINFREEBUSY" tabindex="-1"><code>SETDOMAINFREEBUSY [ domainName ] newFreeBusy</code> <a class="header-anchor" href="#SETDOMAINFREEBUSY" aria-label="Permalink to &quot;`SETDOMAINFREEBUSY [ domainName ] newFreeBusy` {#SETDOMAINFREEBUSY}&quot;">​</a></h3><p>Use this command to change the Domain Free/Busy.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newFreeBusy : dictionary</code></p><p>This dictionary is used to replace the Domain Free/Busy dictionary. All old Domain Free/Busy are removed.</p></li></ul><h2 id="Plugins" tabindex="-1">Plugins Settings <a class="header-anchor" href="#Plugins" aria-label="Permalink to &quot;Plugins Settings {#Plugins}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or <code>Can Modify Plugins Settings</code> the <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to use the CLI commands to change domain plugins settings.</p><h3 id="GETDOMAINPLUGINSSETTINGS" tabindex="-1"><code>GETDOMAINPLUGINSSETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINPLUGINSSETTINGS" aria-label="Permalink to &quot;`GETDOMAINPLUGINSSETTINGS [ domainName ]` {#GETDOMAINPLUGINSSETTINGS}&quot;">​</a></h3><p>Use this command to get the Domain Plugins Settings. The command produces an output - a <em>dictionary</em>, with the Domain Plugins settings.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of an existing Domain</p></li></ul><h3 id="SETDOMAINPLUGINSSETTINGS" tabindex="-1"><code>SETDOMAINPLUGINSSETTINGS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETDOMAINPLUGINSSETTINGS" aria-label="Permalink to &quot;`SETDOMAINPLUGINSSETTINGS [ domainName ] newSettings` {#SETDOMAINPLUGINSSETTINGS}&quot;">​</a></h3><p>Use this command to change the Domain Plugins Settings.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to replace the Domain Plugins Settings dictionary. All old Domain Plugins Settings are removed.</p></li></ul><h2 id="WebSite" tabindex="-1">File Storage Administration <a class="header-anchor" href="#WebSite" aria-label="Permalink to &quot;File Storage Administration {#WebSite}&quot;">​</a></h2><p>The following commands allow an authenticated user to deal with files in the Account <a href="./../admin/storage/FileStore.html">File Storage</a> area. To access File Storage:</p><ul><li>authenticated user should be the Account owner, or</li><li>the authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>WebSite</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right, or</li><li>the authenticated user should be granted a <a href="./../admin/storage/FileStore.html#ACL">File Access Right</a> to the specified file or directory (only if <code>AUTH</code> parameter is not specified)</li></ul><p>If a file name ends with the slash (<code>/</code>) symbol, it specifies a file directory name.</p><h3 id="READSTORAGEFILE" tabindex="-1"><code>READSTORAGEFILE accountName FILE fileName [ OFFSET position ] [ SIZE sliceSize ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#READSTORAGEFILE" aria-label="Permalink to &quot;`READSTORAGEFILE accountName FILE fileName [ OFFSET position ] [ SIZE sliceSize ] [ AUTH authAccountName ]` {#READSTORAGEFILE}&quot;">​</a></h3><p>Use this command to retrieve a file from the Account File Storage. This command produces an output - a <em>array</em> of 3 elements. The first element is a <em>datablock</em> with the content of the specified file, the second element is a timestamp with the file modification date, and the third element is a number equal to the current file size.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of the File Storage file to be retrieved.</p></li><li><p><code>position : number</code></p><p>If this parameter is specified the File Storage file is read starting from the specified file position.</p></li><li><p><code>sliceSize : number</code></p><p>If this parameter is specified, no more than the specified number of file data bytes is returned.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="WRITESTORAGEFILE" tabindex="-1"><code>WRITESTORAGEFILE accountName FILE fileName [ OFFSET position ] [ AUTH authAccountName ] DATA fileData</code> <a class="header-anchor" href="#WRITESTORAGEFILE" aria-label="Permalink to &quot;`WRITESTORAGEFILE accountName FILE fileName [ OFFSET position ] [ AUTH authAccountName ] DATA fileData` {#WRITESTORAGEFILE}&quot;">​</a></h3><p>Use this command to store a file in the Account File Storage.<br> If a File Storage file with the specified name already exists, the old file is removed.<br> If the <em>fileName</em> specifies a directory (it ends with the slash (<code>/</code>) symbol) the command creates a directory. In this case, the OFFSET <em>position</em> part must be absent, and the <em>fileData</em> parameter must be an empty datablock.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name for the File Storage file.</p></li><li><p><code>position : offset</code></p><p>If this parameter is absent, or it exists and it is the zero number, the existing file (if any) is removed first, and a new file is created.<br> If this parameter is a non-zero number, its value must be positive; the File Storage file is rewritten/extended starting from the specified file position. The file should already exist, and the specified position should not be larger than the current file size.<br> If this option is <code>BEG</code>, then the file should already exist, the file is rewritten from the beginning, but its old data beyond the end of the fileData (if any) is not removed.<br> If this option is <code>END</code>, then the fileData is appended to the end of the file. If the file does not exist, it is created.<br> If this option is <code>NEW</code>, then the file must not exist, a new file is created and fileData is stored in it.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li><li><p><code>fileData : datablock</code></p><p>This parameter contains the file data.</p></li></ul><h3 id="RENAMESTORAGEFILE" tabindex="-1"><code>RENAMESTORAGEFILE accountName FILE oldFileName INTO newFileName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#RENAMESTORAGEFILE" aria-label="Permalink to &quot;`RENAMESTORAGEFILE accountName FILE oldFileName INTO newFileName [ AUTH authAccountName ]` {#RENAMESTORAGEFILE}&quot;">​</a></h3><p>Use this command to rename a file or a file directory in the Account File Storage.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>oldFileName : string</code></p><p>This parameter specifies the name of an existing File Storage file or file directory.</p></li><li><p><code>newFileName : string</code></p><p>This parameter specifies the new name for the File Storage file or file directory.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="DELETESTORAGEFILE" tabindex="-1"><code>DELETESTORAGEFILE accountName FILE fileName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#DELETESTORAGEFILE" aria-label="Permalink to &quot;`DELETESTORAGEFILE accountName FILE fileName [ AUTH authAccountName ]` {#DELETESTORAGEFILE}&quot;">​</a></h3><p>Use this command to remove a file or a file directory from the Account File Storage.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of an existing File Storage file or file directory.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="LISTSTORAGEFILES" tabindex="-1"><code>LISTSTORAGEFILES accountName [ PATH filePath ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#LISTSTORAGEFILES" aria-label="Permalink to &quot;`LISTSTORAGEFILES accountName [ PATH filePath ] [ AUTH authAccountName ]` {#LISTSTORAGEFILES}&quot;">​</a></h3><p>Use this command to list all files in the File Storage top directory or in one of its subdirectories. This command produces an output - a <em>dictionary</em>, where each key is a name of the File Storage file, and the key value is a <em>dictionary</em> for a regular file and an empty <em>array</em> for subdirectories.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>filePath : string</code></p><p>This optional parameter specifies the name of the File Storage subdirectory. You can omit this parameter along with the PATH keyword, in this case the command returns the list of files in the top File Storage directory.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="GETSTORAGEFILEINFO" tabindex="-1"><code>GETSTORAGEFILEINFO accountName [ PATH filePath ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETSTORAGEFILEINFO" aria-label="Permalink to &quot;`GETSTORAGEFILEINFO accountName [ PATH filePath ] [ AUTH authAccountName ]` {#GETSTORAGEFILEINFO}&quot;">​</a></h3><p>Use this command to get the statistical information about all files in the Account File Storage. This command produces an output - an <em>array</em> with 2 <em>number</em> elements. The first element contains the total size of all File Storage files, the second element contains the number of files in the File Storage.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="READSTORAGEFILEATTR" tabindex="-1"><code>READSTORAGEFILEATTR accountName FILE fileName [ attributes ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#READSTORAGEFILEATTR" aria-label="Permalink to &quot;`READSTORAGEFILEATTR accountName FILE fileName [ attributes ] [ AUTH authAccountName ]` {#READSTORAGEFILEATTR}&quot;">​</a></h3><p>Use this command to read attributes of an Account File Storage file or file directory. This command produces an output - an <em>array</em> of XML elements containing file or file directory attributes.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of an existing File Storage file or file directory.</p></li><li><p><code>attributes : array</code></p><p>This optional parameter specifies an array of strings. If specified, only file attributes with names included into this array are retrieved.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="UPDATESTORAGEFILEATTR" tabindex="-1"><code>UPDATESTORAGEFILEATTR accountName FILE fileName attributes [ AUTH authAccountName ]</code> <a class="header-anchor" href="#UPDATESTORAGEFILEATTR" aria-label="Permalink to &quot;`UPDATESTORAGEFILEATTR accountName FILE fileName attributes [ AUTH authAccountName ]` {#UPDATESTORAGEFILEATTR}&quot;">​</a></h3><p>Use this command to update attributes of an Account File Storage file or file directory.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of an existing File Storage file or file directory.</p></li><li><p><code>attributes : array</code></p><p>This parameter specifies an array of XML elements - the new file attribute values.</p></li><li><p><code>authAccountName : string</code></p><p>This optional parameter specifies the name of an Account on whose behalf the operation should be executed.</p></li></ul><h3 id="GETFILESUBSCRIPTION" tabindex="-1"><code>GETFILESUBSCRIPTION accountName</code> <a class="header-anchor" href="#GETFILESUBSCRIPTION" aria-label="Permalink to &quot;`GETFILESUBSCRIPTION accountName` {#GETFILESUBSCRIPTION}&quot;">​</a></h3><p>This command produces an output - an <em>array</em> with the list of Account &quot;subscribed files&quot;.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li></ul><h3 id="SETFILESUBSCRIPTION" tabindex="-1"><code>SETFILESUBSCRIPTION accountName newSubscription</code> <a class="header-anchor" href="#SETFILESUBSCRIPTION" aria-label="Permalink to &quot;`SETFILESUBSCRIPTION accountName newSubscription` {#SETFILESUBSCRIPTION}&quot;">​</a></h3><p>Use this command to set the Account &quot;subscribed files&quot; list.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>newSubscription : array</code></p><p>The list of subscribed files. Each array element should be a <em>string</em> with a file name.</p></li></ul><h2 id="Lists" tabindex="-1">Mailing Lists Administration <a class="header-anchor" href="#Lists" aria-label="Permalink to &quot;Mailing Lists Administration {#Lists}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <a href="./../admin/sysadmin/#Domain">Domain Administrator</a> access right to use the Mailing List Administration CLI commands.</p><h3 id="LISTLISTS" tabindex="-1"><code>LISTLISTS [ domainName ]</code> <a class="header-anchor" href="#LISTLISTS" aria-label="Permalink to &quot;`LISTLISTS [ domainName ]` {#LISTLISTS}&quot;">​</a></h3><p>Use this command to get the list of all mailing lists in the Domain. The command produces output data - an <em>array</em> of strings. Each string is the name of a mailing list in the specified (or default) Domain.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name.</p></li></ul><h3 id="GETDOMAINLISTS" tabindex="-1"><code>GETDOMAINLISTS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINLISTS" aria-label="Permalink to &quot;`GETDOMAINLISTS [ domainName ]` {#GETDOMAINLISTS}&quot;">​</a></h3><p>Use this command to get the list of all mailing lists in the Domain. The command produces output data - a <em>dictionary</em>. Each dictionary key is the name of a mailing list in the specified (or default) Domain. The key value is a numeric string with the actual number of the list subscribers (&quot;-1&quot; if the current number of subscribers is not known).</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name.</p></li></ul><h3 id="GETACCOUNTLISTS" tabindex="-1"><code>GETACCOUNTLISTS accountName</code> <a class="header-anchor" href="#GETACCOUNTLISTS" aria-label="Permalink to &quot;`GETACCOUNTLISTS accountName` {#GETACCOUNTLISTS}&quot;">​</a></h3><p>Use this command to get the list of all mailing lists belonging to the specified Account. The command produces output data - a <em>dictionary</em>. Each dictionary key is the name of a mailing list belonging to the specified (or default) Account. The key value is a numeric string with the actual number of the list subscribers (&quot;-1&quot; if the current number of subscribers is not known).</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the list&#39;s owner Account name.</p></li></ul><h3 id="CREATELIST" tabindex="-1"><code>CREATELIST listName for accountName</code> <a class="header-anchor" href="#CREATELIST" aria-label="Permalink to &quot;`CREATELIST listName for accountName` {#CREATELIST}&quot;">​</a></h3><p>Use this command to create a mailing list.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of a mailing list to create. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>accountName : string</code></p><p>This parameter specifies the name of the mailing list owner (without the Domain name). It should be the name of an already existing Account in the mailing list Domain.Domain Administrators can use this command if they have the CanCreateLists Domain access right.</p></li></ul><h3 id="RENAMELIST" tabindex="-1"><code>RENAMELIST listName into newName</code> <a class="header-anchor" href="#RENAMELIST" aria-label="Permalink to &quot;`RENAMELIST listName into newName` {#RENAMELIST}&quot;">​</a></h3><p>Use this command to rename a mailing list.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>newName : string</code></p><p>This parameter specifies the new name for the mailing list (without the Domain part).Domain Administrators can use this command if they have the CanCreateLists Domain access right.</p></li></ul><h3 id="DELETELIST" tabindex="-1"><code>DELETELIST listName</code> <a class="header-anchor" href="#DELETELIST" aria-label="Permalink to &quot;`DELETELIST listName` {#DELETELIST}&quot;">​</a></h3><p>Use this command to remove a mailing list.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.Domain Administrators can use this command if they have the CanCreateLists Domain access right.</p></li></ul><p>The following commands can be used by the mailing list owner, by a Domain Administrator with the CanAccessLists access right, or by a Server Administrator with the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right.</p><h3 id="GETLIST" tabindex="-1"><code>GETLIST listName</code> <a class="header-anchor" href="#GETLIST" aria-label="Permalink to &quot;`GETLIST listName` {#GETLIST}&quot;">​</a></h3><p>Use this command to retrieve list settings. The command produces an output - a <em>dictionary</em> with the listName mailing list settings.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li></ul><h3 id="UPDATELIST" tabindex="-1"><code>UPDATELIST listName newSettings</code> <a class="header-anchor" href="#UPDATELIST" aria-label="Permalink to &quot;`UPDATELIST listName newSettings` {#UPDATELIST}&quot;">​</a></h3><p>Use this command to modify list settings.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the mailing list settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified.</p></li></ul><h3 id="LIST" tabindex="-1"><code>LIST listName operation [silently] [confirm] subscriber</code> <a class="header-anchor" href="#LIST" aria-label="Permalink to &quot;`LIST listName operation [silently] [confirm] subscriber` {#LIST}&quot;">​</a></h3><p>Use this command to update the subscribers list.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>operation : subscribe | feed | digest | index | null | banned | unsubscribe</code></p><p>This parameter specifies the operation (see the <a href="./../admin/mail/LIST.html">LIST module</a> section for the details).</p></li><li><p><code>silently</code></p><p>This optional parameter tells the server not to send the Welcome/Bye message to the subscriber.</p></li><li><p><code>confirm</code></p><p>This optional parameter tells the server to send a confirmation request to the subscriber.</p></li><li><p><code>subscriber : E-mail address</code></p><p>The subscriber address. It can include the <em>comment part</em> used as the subscriber&#39;s real name. Sample:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>LIST MyList@mydomain.com FEED confirm &quot;Bill Jones&quot; &lt;BJones@company.com&gt;</span></span></code></pre></div><h3 id="LISTSUBSCRIBERS" tabindex="-1"><code>LISTSUBSCRIBERS listName [ FILTER filter [ limit ] ]</code> <a class="header-anchor" href="#LISTSUBSCRIBERS" aria-label="Permalink to &quot;`LISTSUBSCRIBERS listName [ FILTER filter [ limit ] ]` {#LISTSUBSCRIBERS}&quot;">​</a></h3><p>Use this command to retrieve list subscribers. The command produces an output - an <em>array</em> with subscribers&#39; E-mail addresses.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>filter : string</code></p><p>If this optional parameter is specified, only the addresses containing the specified string are returned.</p></li><li><p><code>limit : number</code></p><p>This optional parameter limits the number of subscriber addresses returned.</p></li></ul><h3 id="READSUBSCRIBERS" tabindex="-1"><code>READSUBSCRIBERS listName [ FILTER filter [ limit ] ]</code> <a class="header-anchor" href="#READSUBSCRIBERS" aria-label="Permalink to &quot;`READSUBSCRIBERS listName [ FILTER filter [ limit ] ]` {#READSUBSCRIBERS}&quot;">​</a></h3><p>Use this command to retrieve list subscribers. The command produces an output - an <em>array</em>, where the first element is a number - the total number of list subscribers, and the second element is an array of subscriber descriptor dictionaries.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>filter : string</code></p><p>If this optional parameter is specified, only subscribers with addresses containing the specified string are returned.</p></li><li><p><code>limit : number</code></p><p>This optional parameter limits the number of subscriber dictionaries returned.</p></li></ul><p>A dictionary describing a subscriber has the following elements:</p><ul><li><p><code>Sub</code></p><p>E-mail address string</p></li><li><p><code>RealName</code></p><p>an optional string with Real name</p></li><li><p><code>mode</code></p><p>a string with subscription mode (index, digest, null, etc.)</p></li><li><p><code>subscribeTime</code></p><p>timestamp data specifying the moment when this user subscribed.</p></li><li><p><code>posts</code></p><p>number of postings on this list</p></li><li><p><code>lastBounceTime</code></p><p>optional timestamp data specifying the last time when messages sent to this user failed.</p></li><li><p><code>bounces</code></p><p>optional numeric data specifying the number of failed delivery reports received for this user.</p></li></ul><h3 id="GETSUBSCRIBERINFO" tabindex="-1"><code>GETSUBSCRIBERINFO listName NAME subscriberAddress</code> <a class="header-anchor" href="#GETSUBSCRIBERINFO" aria-label="Permalink to &quot;`GETSUBSCRIBERINFO listName NAME subscriberAddress` {#GETSUBSCRIBERINFO}&quot;">​</a></h3><p>Use this command to retrieve information about a list subscriber. The command produces an output - a <em>dictionary</em> with subscriber information.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>subscriberAddress : string</code></p><p>This parameter specifies the E-mail address of the list subscriber. If the subscriber does not exist, an empty dictionary is returned. Otherwise, the dictionary contains the following elements:</p></li><li><p><code>mode</code></p><p>This string element specified the subscription mode (<code>digest</code>, <code>index</code>, etc.) This element is equal to <code>unsubscribe</code> if the address has been unsubscribed, but has not been removed from the list. This element is equal to <code>subscribe</code> if a user has started subscription, but the subscription has not been confirmed.</p></li><li><p><code>confirmationID</code></p><p>This element contains the subscriber&#39;s Confirmation ID string.</p></li><li><p><code>timeSubscribed</code></p><p>This string element specifies when the address was subscribed (in the ACAP date/time format).</p></li><li><p><code>posts</code></p><p>This string element may contain the strings <code>special</code>, <code>moderateAll</code>, <code>prohibited</code>, or the string with the number of messages posted from this address. If the next postings from this address are to be moderated, the element contains an array with one string element that contains the number of postings to be moderated.</p></li><li><p><code>bounces</code></p><p>This optional string element contains the number of bounces received from this address.</p></li><li><p><code>lastBounced</code></p><p>This optional string element specifies the last time when messages to this address bounced were bounced. The data and time are specified in the ACAP format.</p></li><li><p><code>RealName</code></p><p>This optional string element contains the real name of the subscriber.</p></li></ul><h3 id="SETPOSTINGMODE" tabindex="-1"><code>SETPOSTINGMODE listName FOR subscriberAddress [ UNMODERATED | MODERATEALL | PROHIBITED | SPECIAL | numberOfModerated ]</code> <a class="header-anchor" href="#SETPOSTINGMODE" aria-label="Permalink to &quot;`SETPOSTINGMODE listName FOR subscriberAddress [ UNMODERATED | MODERATEALL | PROHIBITED | SPECIAL | numberOfModerated ]` {#SETPOSTINGMODE}&quot;">​</a></h3><p>Use this command to set the posting mode for the specified subscriber.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>subscriberAddress : string</code></p><p>This parameter specifies the E-mail address of the list subscriber.</p></li><li><p><code>postingMode : number</code></p><p>This optional parameter limits the number of subscriber addresses returned. The command sets the posting mode the specified subscriber. If <em>numberOfModerated</em> (a number) is specified, the posting mode set requires moderation of the first numberOfModerated messages from this subscriber.</p></li></ul><h3 id="PROCESSBOUNCE" tabindex="-1"><code>PROCESSBOUNCE listName [ FATAL ] FOR subscriberAddress</code> <a class="header-anchor" href="#PROCESSBOUNCE" aria-label="Permalink to &quot;`PROCESSBOUNCE listName [ FATAL ] FOR subscriberAddress` {#PROCESSBOUNCE}&quot;">​</a></h3><p>Use this command to perform the same action the List Manager performs when it receives a bounce message for the subscriber address.</p><ul><li><p><code>listName : string</code></p><p>This parameter specifies the name of an existing mailing list. It can include the Domain name. If the Domain name is not specified, the user Domain is used by default.</p></li><li><p><code>subscriberAddress : string</code></p><p>This parameter specifies the E-mail address of the list subscriber. Use the <code>FATAL</code> keyword to emulate a &quot;fatal&quot; bounce. Otherwise the command emulates a non-fatal bounce.</p></li></ul><h2 id="WebSkin" tabindex="-1">Web Skins Administration <a class="header-anchor" href="#WebSkin" aria-label="Permalink to &quot;Web Skins Administration {#WebSkin}&quot;">​</a></h2><p>The following commands can be used to manage CommuniGate Pro <a href="./WebApp.html">Skins</a> used for the CommuniGate Pro WebUser Interface.</p><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanModifySkins</code> <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to modify the Domain Skins.</p><h3 id="LISTDOMAINSKINS" tabindex="-1"><code>LISTDOMAINSKINS [ domainName ]</code> <a class="header-anchor" href="#LISTDOMAINSKINS" aria-label="Permalink to &quot;`LISTDOMAINSKINS [ domainName ]` {#LISTDOMAINSKINS}&quot;">​</a></h3><p>Use this command to list custom Domain Skins. The command produces an output - an <em>array</em> with Skin names.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li></ul><h3 id="CREATEDOMAINSKIN" tabindex="-1"><code>CREATEDOMAINSKIN [ domainName SKIN ] skinName</code> <a class="header-anchor" href="#CREATEDOMAINSKIN" aria-label="Permalink to &quot;`CREATEDOMAINSKIN [ domainName SKIN ] skinName` {#CREATEDOMAINSKIN}&quot;">​</a></h3><p>Use this command to create a custom Domain Skin.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it should be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of the new Skin. To create the unnamed Domain Skin, specify an empty string as the <em>skinName</em> parameter value. A named Domain Skin can be created only when the unnamed Domain Skin exists.</p></li></ul><h3 id="RENAMEDOMAINSKIN" tabindex="-1"><code>RENAMEDOMAINSKIN [ domainName SKIN ] skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMEDOMAINSKIN" aria-label="Permalink to &quot;`RENAMEDOMAINSKIN [ domainName SKIN ] skinName INTO newSkinName` {#RENAMEDOMAINSKIN}&quot;">​</a></h3><p>Use this command to rename a custom named Domain Skin.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it should be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing named Skin.</p></li><li><p><code>newSkinName : string</code></p><p>This parameter specifies the new name for the Skin.</p></li></ul><h3 id="DELETEDOMAINSKIN" tabindex="-1"><code>DELETEDOMAINSKIN [ domainName SKIN ] skinName</code> <a class="header-anchor" href="#DELETEDOMAINSKIN" aria-label="Permalink to &quot;`DELETEDOMAINSKIN [ domainName SKIN ] skinName` {#DELETEDOMAINSKIN}&quot;">​</a></h3><p>Use this command to delete a custom Domain Skin.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it should be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of the Skin to be deleted. To delete the unnamed Domain Skin, specify an empty string as the <em>skinName</em> parameter value.<br> The unnamed Domain Skin can be deleted only when no named Domain Skin exists.</p></li></ul><h3 id="LISTDOMAINSKINFILES`" tabindex="-1"><code>LISTDOMAINSKINFILES</code> [ <code>domainName SKIN</code> ] <code>skinName</code> <a class="header-anchor" href="#LISTDOMAINSKINFILES`" aria-label="Permalink to &quot;`LISTDOMAINSKINFILES` [ `domainName SKIN` ] `skinName` {#LISTDOMAINSKINFILES`}&quot;">​</a></h3><p>Use this command to list files in a custom Domain Skin. The command produces an output - a <em>dictionary</em> with Skin file names as keys. The dictionary element values are dictionaries with file attributes.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it must be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Domain Skin.</p></li></ul><h3 id="READDOMAINSKINFILE`" tabindex="-1"><code>READDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName</code> <a class="header-anchor" href="#READDOMAINSKINFILE`" aria-label="Permalink to &quot;`READDOMAINSKINFILE` [ `domainName SKIN` ] `skinName FILE fileName` {#READDOMAINSKINFILE`}&quot;">​</a></h3><p>Use this command to read a file from a custom Domain Skin. The command produces an output - an <em>array</em>. The first array element is a datablock with the Skin file content, the second array element is a timestamp with the file modification date.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it must be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Domain Skin.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of an existing file in the specified Domain Skin.</p></li></ul><h3 id="STOREDOMAINSKINFILE" tabindex="-1"><code>STOREDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STOREDOMAINSKINFILE" aria-label="Permalink to &quot;`STOREDOMAINSKINFILE` \\[ `domainName SKIN` \\] `skinName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STOREDOMAINSKINFILE}&quot;">​</a></h3><h3 id="storedomainskinfile-domainname-skin-skinname-file-filename-delete" tabindex="-1"><code>STOREDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storedomainskinfile-domainname-skin-skinname-file-filename-delete" aria-label="Permalink to &quot;`STOREDOMAINSKINFILE` \\[ `domainName SKIN` \\] `skinName FILE fileName DELETE`&quot;">​</a></h3><p>Use this command to store a file into a custom Domain Skin, or to delete a file from a custom Domain Skin.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain. If it is specified, it must be followed with the SKIN keyword.</p></li><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Domain Skin.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the Skin file name.</p></li><li><p><code>fileContent : datablock</code></p><p>This datablock contains file content. This parameter is specified only if the DATA keyword is used. If the DATA keyword is specified and the Skin contains a file with the same name, the old file is deleted. The file with the specified name is removed from the Skin Cache (in the Dynamic Cluster the file is removed from Skin caches on all cluster members). When TRYCOMPILE keyword is specified, the WSSP or CG/PL is compiled before storing. If compilation error occurs, it is returned in the command output and skin file is not stored.</p></li></ul><p>The following commands are available for the System Administrators only:</p><h3 id="LISTSERVERSKINS" tabindex="-1"><code>LISTSERVERSKINS</code> <a class="header-anchor" href="#LISTSERVERSKINS" aria-label="Permalink to &quot;`LISTSERVERSKINS` {#LISTSERVERSKINS}&quot;">​</a></h3><p>Use this command to list custom Server Skins. The command produces an output - an <em>array</em> with Skin names.</p><h3 id="CREATESERVERSKIN" tabindex="-1"><code>CREATESERVERSKIN skinName</code> <a class="header-anchor" href="#CREATESERVERSKIN" aria-label="Permalink to &quot;`CREATESERVERSKIN skinName` {#CREATESERVERSKIN}&quot;">​</a></h3><p>Use this command to create a custom Server Skin.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of the new Skin.</p></li></ul><h3 id="RENAMESERVERSKIN" tabindex="-1"><code>RENAMESERVERSKIN skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMESERVERSKIN" aria-label="Permalink to &quot;`RENAMESERVERSKIN skinName INTO newSkinName` {#RENAMESERVERSKIN}&quot;">​</a></h3><p>Use this command to rename a custom Server Skin.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Skin.</p></li><li><p><code>newSkinName : string</code></p><p>This parameter specifies the new name for the Skin.</p></li></ul><h3 id="DELETESERVERSKIN" tabindex="-1"><code>DELETESERVERSKIN skinName</code> <a class="header-anchor" href="#DELETESERVERSKIN" aria-label="Permalink to &quot;`DELETESERVERSKIN skinName` {#DELETESERVERSKIN}&quot;">​</a></h3><p>Use this command to delete a custom Server Skin.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of the Skin to be deleted.</p></li></ul><h3 id="LISTSERVERSKINFILES" tabindex="-1"><code>LISTSERVERSKINFILES skinName</code> <a class="header-anchor" href="#LISTSERVERSKINFILES" aria-label="Permalink to &quot;`LISTSERVERSKINFILES skinName` {#LISTSERVERSKINFILES}&quot;">​</a></h3><p>Use this command to list files in a custom Server Skin. The command produces an output - a <em>dictionary</em> with Skin file names as keys. The dictionary element values are dictionaries with file attributes.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Server Skin.</p></li></ul><h3 id="READSERVERSKINFILE" tabindex="-1"><code>READSERVERSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#READSERVERSKINFILE" aria-label="Permalink to &quot;`READSERVERSKINFILE skinName FILE fileName` {#READSERVERSKINFILE}&quot;">​</a></h3><p>Use this command to read a file from a custom Server Skin. The command produces an output - an <em>array</em>. The first array element is a datablock with the Skin file content, the second array element is a timestamp with the file modification date.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Server Skin.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the name of an existing file in the specified Server Skin.</p></li></ul><h3 id="STORESERVERSKINFILE" tabindex="-1"><code>STORESERVERSKINFILE skinName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORESERVERSKINFILE" aria-label="Permalink to &quot;`STORESERVERSKINFILE skinName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORESERVERSKINFILE}&quot;">​</a></h3><h3 id="storeserverskinfile-skinname-file-filename-delete" tabindex="-1"><code>STORESERVERSKINFILE skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storeserverskinfile-skinname-file-filename-delete" aria-label="Permalink to &quot;`STORESERVERSKINFILE skinName FILE fileName DELETE`&quot;">​</a></h3><p>Use this command to store a file into a custom Server Skin, or to delete a file from a custom Server Skin.</p><ul><li><p><code>skinName : string</code></p><p>This parameter specifies the name of an existing Server Skin.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the Skin file name.</p></li><li><p><code>fileContent : datablock</code></p><p>This datablock contains the file content. This parameter is specified only if the DATA keyword is used. If the DATA keyword is specified and the Skin contains a file with the same name, the old file is deleted. The file with the specified name is removed from the Skin Cache (in the Dynamic Cluster the file is removed from Skin caches on all cluster members). When TRYCOMPILE keyword is specified, the WSSP or CG/PL is compiled before storing. If compilation error occurs, it is returned in the command output and skin file is not stored.</p></li></ul><h3 id="LISTCLUSTERSKINS" tabindex="-1"><code>LISTCLUSTERSKINS</code> <a class="header-anchor" href="#LISTCLUSTERSKINS" aria-label="Permalink to &quot;`LISTCLUSTERSKINS` {#LISTCLUSTERSKINS}&quot;">​</a></h3><h3 id="CREATECLUSTERSKIN" tabindex="-1"><code>CREATECLUSTERSKIN skinName</code> <a class="header-anchor" href="#CREATECLUSTERSKIN" aria-label="Permalink to &quot;`CREATECLUSTERSKIN skinName` {#CREATECLUSTERSKIN}&quot;">​</a></h3><h3 id="RENAMECLUSTERSKIN" tabindex="-1"><code>RENAMECLUSTERSKIN skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMECLUSTERSKIN" aria-label="Permalink to &quot;`RENAMECLUSTERSKIN skinName INTO newSkinName` {#RENAMECLUSTERSKIN}&quot;">​</a></h3><h3 id="DELETECLUSTERSKIN" tabindex="-1"><code>DELETECLUSTERSKIN skinName</code> <a class="header-anchor" href="#DELETECLUSTERSKIN" aria-label="Permalink to &quot;`DELETECLUSTERSKIN skinName` {#DELETECLUSTERSKIN}&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>LIST</code>|<code>CREATE</code>|<code>RENAME</code>|<code>DELETE</code>]<code>SERVERSKIN</code>[<code>S</code>] commands to work with the cluster-wide Skins.</p><h3 id="LISTCLUSTERSKINFILES" tabindex="-1"><code>LISTCLUSTERSKINFILES skinName</code> <a class="header-anchor" href="#LISTCLUSTERSKINFILES" aria-label="Permalink to &quot;`LISTCLUSTERSKINFILES skinName` {#LISTCLUSTERSKINFILES}&quot;">​</a></h3><h3 id="READCLUSTERSKINFILE" tabindex="-1"><code>READCLUSTERSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#READCLUSTERSKINFILE" aria-label="Permalink to &quot;`READCLUSTERSKINFILE skinName FILE fileName` {#READCLUSTERSKINFILE}&quot;">​</a></h3><h3 id="STORECLUSTERSKINFILE" tabindex="-1"><code>STORECLUSTERSKINFILE skinName FILE fileName DATA fileContent</code> <a class="header-anchor" href="#STORECLUSTERSKINFILE" aria-label="Permalink to &quot;`STORECLUSTERSKINFILE skinName FILE fileName DATA fileContent` {#STORECLUSTERSKINFILE}&quot;">​</a></h3><h3 id="storeclusterskinfile-skinname-file-filename-delete" tabindex="-1"><code>STORECLUSTERSKINFILE skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storeclusterskinfile-skinname-file-filename-delete" aria-label="Permalink to &quot;`STORECLUSTERSKINFILE skinName FILE fileName DELETE`&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>LIST</code>|<code>READ</code>|<code>STORE</code>]<code>SERVERSKINFILE</code>[<code>S</code>] commands to work with files in the cluster-wide Skins.</p><h3 id="LISTSTOCKSKINFILES" tabindex="-1"><code>LISTSTOCKSKINFILES skinName</code> <a class="header-anchor" href="#LISTSTOCKSKINFILES" aria-label="Permalink to &quot;`LISTSTOCKSKINFILES skinName` {#LISTSTOCKSKINFILES}&quot;">​</a></h3><h3 id="readstockskinfile-skinname-file-filename" tabindex="-1"><code>READSTOCKSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#readstockskinfile-skinname-file-filename" aria-label="Permalink to &quot;`READSTOCKSKINFILE skinName FILE fileName`&quot;">​</a></h3><p>Use these commands instead of the [<code>LIST</code>|<code>READ</code>]<code>SERVERSKINFILE</code>[<code>S</code>] commands to work with files in the built-in Skins.</p><h2 id="WebSession" tabindex="-1">Web Interface Integration <a class="header-anchor" href="#WebSession" aria-label="Permalink to &quot;Web Interface Integration {#WebSession}&quot;">​</a></h2><p>The following commands can be used to integrate the CommuniGate Pro WebUser Interface with third-party applications.</p><h3 id="CREATEWEBUSERSESSION" tabindex="-1"><code>CREATEWEBUSERSESSION accountName ADDRESS ip-address [ FOR orig-address ] [ SKIN skinName ]</code> <a class="header-anchor" href="#CREATEWEBUSERSESSION" aria-label="Permalink to &quot;`CREATEWEBUSERSESSION accountName ADDRESS ip-address [ FOR orig-address ] [ SKIN skinName ]` {#CREATEWEBUSERSESSION}&quot;">​</a></h3><p>Use this command to create a WebUser session for the specified Account. The command produces an output - a <em>string</em> that contains the WebUser Session ID. This string can be used to compose a URL that will allow the client browser to &quot;enter&quot; the WebUser Session. That URL can have the following format:</p><p><code>http://cgateproserver:port/Session/_rrrrrrrrrrrr_/Mailboxes.wssp</code></p><p>where <code>rrrrrrrrrrrr</code> is the Session ID string returned.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the Account name.</p></li><li><p><code>ip-address : string or IP address</code></p><p>This parameter specifies the IP address and port of the client browser.<br> If the Account has the &quot;Fixed IP&quot; Preference setting enabled, connections to the session will be allowed from this IP address only.</p></li><li><p><code>orig-address : string</code></p><p>This parameter specifies the original IP address of the client browser, if the client connects via a proxy. The <em>ip-address</em> parameter specifies the proxy IP address.<br> If the Account has the &quot;Fixed IP&quot; Preference setting enabled, connections to the session will be allowed from the proxy IP address only and only from this original IP address (passed by the proxy in the <code>X-FORWARDED-FOR</code> HTTP header field).</p></li><li><p><code>skinName : string</code></p><p>This optional parameter specifies the Skin to use for the newly created session.<br> The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to create WebUser Sessions.</p></li></ul><h3 id="CREATEXIMSSSESSION" tabindex="-1"><code>CREATEXIMSSSESSION accountName ADDRESS ip-address [ FOR orig-address ]</code> <a class="header-anchor" href="#CREATEXIMSSSESSION" aria-label="Permalink to &quot;`CREATEXIMSSSESSION accountName ADDRESS ip-address [ FOR orig-address ]` {#CREATEXIMSSSESSION}&quot;">​</a></h3><p>Use this command to create a XIMSS session for the specified Account. The command produces an output - a <em>string</em> that contains the XIMSS Session ID. This string can be used to compose a URL that will allow the client browser to work with the XIMSS Session using HTTP Binding.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the Account name.</p></li><li><p><code>ip-address : string</code></p></li><li><p><code>orig-address : string</code></p><p>These parameters have the same meaning as for the <code>CREATEWEBUSERSESSION</code> command.<br> The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to create XIMSS Sessions.</p></li></ul><h3 id="CREATELITESESSION" tabindex="-1"><code>CREATELITESESSION ADDRESS ip-address [ FOR orig-address ]</code> <a class="header-anchor" href="#CREATELITESESSION" aria-label="Permalink to &quot;`CREATELITESESSION ADDRESS ip-address [ FOR orig-address ]` {#CREATELITESESSION}&quot;">​</a></h3><p>Use this command to create a LITE session. The command produces an output - a <em>string</em> that contains the LITE Session ID. This string can be used to compose a URL that will allow the client browser to access the LITE Session.</p><ul><li><p><code>ip-address : string</code></p></li><li><p><code>orig-address : string</code></p><p>These parameters have the same meaning as for the <code>CREATEWEBUSERSESSION</code> command.<br> The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to create LITE Sessions.</p></li></ul><h3 id="FINDACCOUNTSESSION" tabindex="-1"><code>FINDACCOUNTSESSION accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]</code> <a class="header-anchor" href="#FINDACCOUNTSESSION" aria-label="Permalink to &quot;`FINDACCOUNTSESSION accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]` {#FINDACCOUNTSESSION}&quot;">​</a></h3><p>Use this command to find an existing session for the specified Account. The command produces an output - a <em>string</em> that contains the Session ID.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the Account name.</p></li><li><p><code>ip-address : string or IP address</code></p><p>This optional parameter specifies the IP address of the client browser. If it is specified, the command will find only those sessions that have the &quot;Fixed IP&quot; Preference disabled or have the same login IP address as the specified one.</p></li><li><p><code>proxied-address : string</code></p><p>This optional parameter specifies the IP address of the client browser, if this browser is located behind an HTTP proxy. The <em>ip-address</em> then specifies the IP address of that proxy.</p></li><li><p><code>protocol : string</code></p><p>This optional parameter specifies the Session protocol (<code>WebUser</code>, <code>XIMSS</code>, <code>XMPP</code>, etc.) If specified, only the sessions created with the specified protocol are searched.</p></li><li><p><code>transport : string</code></p><p>This optional parameter specifies the Session transport (<code>HTTP</code>, <code>XIMSS</code>, <code>XMPP</code>, etc.) If specified, only the sessions created with the specified transport are searched.</p></li><li><p><code>client : string</code></p><p>This optional parameter specifies the Session client. If specified, only the sessions created with the specified client (if the client has informed the session about its name) are searched. The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to use this command.</p></li></ul><h3 id="LISTACCOUNTSESSIONS" tabindex="-1"><code>LISTACCOUNTSESSIONS accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]</code> <a class="header-anchor" href="#LISTACCOUNTSESSIONS" aria-label="Permalink to &quot;`LISTACCOUNTSESSIONS accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]` {#LISTACCOUNTSESSIONS}&quot;">​</a></h3><p>Use this command to retrieve all existing sessions for the specified Account. The command produces an output - an <em>array</em> of strings, where each string is the Session ID.<br> Command parameters are the same as the FINDACCOUNTSESSION command parameters.<br> The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to use this command.</p><h3 id="LISTLITESESSIONS" tabindex="-1"><code>LISTLITESESSIONS [ ADDRESS ip-address [ FOR proxied-address ] ]</code> <a class="header-anchor" href="#LISTLITESESSIONS" aria-label="Permalink to &quot;`LISTLITESESSIONS [ ADDRESS ip-address [ FOR proxied-address ] ]` {#LISTLITESESSIONS}&quot;">​</a></h3><p>Use this command to retrieve all LITE sessions. The command produces an output - an <em>array</em> of strings, where each string is the Session ID.<br> Command parameters are the same as the LISTACCOUNTSESSIONS command parameters.<br> The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right to use this command.</p><h3 id="GETSESSION" tabindex="-1"><code>GETSESSION sessionID [ DOMAIN domainName ]</code> <a class="header-anchor" href="#GETSESSION" aria-label="Permalink to &quot;`GETSESSION sessionID [ DOMAIN domainName ]` {#GETSESSION}&quot;">​</a></h3><p>Use this command to retrieve Session data. The command produces an output - a <em>dictionary</em> with the <em>session dataset</em> (specified in the <a href="./WSSP.html">WSSP</a> section of this manual).</p><ul><li><p><code>sessionID : string</code></p><p>This parameter specifies the Session ID.</p></li><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of Domain the session Account belongs to. The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right to retrieve Session data if the <em>domainName</em> parameter is not specified. If the <em>domainName</em> is specified, the authenticated user should have the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right for the specified Domain. This operation resets the session inactivity timer.</p></li></ul><h3 id="UPDATESESSION" tabindex="-1"><code>UPDATESESSION sessionID [ DOMAIN domainName ] dictParam</code> <a class="header-anchor" href="#UPDATESESSION" aria-label="Permalink to &quot;`UPDATESESSION sessionID [ DOMAIN domainName ] dictParam` {#UPDATESESSION}&quot;">​</a></h3><p>Use this command to modify custom parameters of a Session.</p><ul><li><p><code>sessionID : string</code></p><p>This parameter specifies the Session ID.</p></li><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of Domain the session Account belongs to.</p></li><li><p><code>dictParam : dictionary</code></p><p>This parameter specifies the dictionary that lists new values for the attributes to be updated. The special value <code>#NULL#</code> can be used to remove the attribute. The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right to modify a Session if the <em>domainName</em> parameter is not specified. If the <em>domainName</em> is specified, the authenticated user should have the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right for the specified Domain.</p></li></ul><h3 id="KILLSESSION" tabindex="-1"><code>KILLSESSION sessionID [ DOMAIN domainName ]</code> <a class="header-anchor" href="#KILLSESSION" aria-label="Permalink to &quot;`KILLSESSION sessionID [ DOMAIN domainName ]` {#KILLSESSION}&quot;">​</a></h3><p>Use this command to terminate a Session.</p><ul><li><p><code>sessionID : string</code></p><p>This parameter specifies the Session ID.</p></li><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of Domain the session Account belongs to. The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right to terminate a Session if the <em>domainName</em> parameter is not specified. If the <em>domainName</em> parameter is specified, the authenticated user should have the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right for the specified Domain.</p></li></ul><h3 id="BLESSSESSION" tabindex="-1"><code>BLESSSESSION sessionID [ PASSWORD secret ] [ AUTH accountName ]</code> <a class="header-anchor" href="#BLESSSESSION" aria-label="Permalink to &quot;`BLESSSESSION sessionID [ PASSWORD secret ] [ AUTH accountName ]` {#BLESSSESSION}&quot;">​</a></h3><p>Use this command to terminate a Session.</p><ul><li><p><code>sessionID : string</code></p><p>This parameter specifies the Session ID.</p></li><li><p><code>accountName : string</code></p><p>This optional parameter specifies the name of the Account the session belongs to. The authenticated user should have the <code>Master</code> <a href="./../admin/sysadmin/">Server Administration</a> access right to complete the Two-factor Authentication process for a Session if the <em>secret</em> parameter is not specified (when the Session should be waiting the Two-factor Authentication process completion in background). If the <em>accountName</em> is specified, the authenticated user should have the <code>CanImpersonate</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right for the Domain of the specified Account. Specific administrative rights are not required when the <em>secret</em> parameter is specified and the target session belongs to the authenticated user.</p></li></ul><h3 id="blesssession-sessionid-password-secret-domain-domainname" tabindex="-1"><code>BLESSSESSION sessionID [ PASSWORD secret ] [ DOMAIN domainName ]</code> <a class="header-anchor" href="#blesssession-sessionid-password-secret-domain-domainname" aria-label="Permalink to &quot;`BLESSSESSION sessionID [ PASSWORD secret ] [ DOMAIN domainName ]`&quot;">​</a></h3><p>Use this command to complete the second stage of a Two-factor authentication process for the given session.</p><ul><li><p><code>sessionID : string</code></p><p>This parameter specifies the Session ID.</p></li><li><p><code>secret : string</code></p><p>This optional parameter specifies the one-time secret used with Two-factor Authentication.</p></li><li><p><code>domainName : string</code></p><p>This optional parameter specifies the name of Domain the session Account belongs to. The authenticated user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right to complete the Two-factor Authentication process for a Session if the <em>domainName</em> parameter is not specified. If the <em>domainName</em> is specified, the authenticated user should have the <code>CanCreateWebUserSessions</code> <a href="./../admin/sysadmin/#Domain">Domain Administration</a> access right for the specified Domain. If the <em>secret</em> parameter is not specified then the Session should be waiting the Two-factor Authentication process completion in background and authenticated user should have the <code>Master</code> <a href="./../admin/sysadmin/">Server Administration</a> access right.</p></li></ul><h2 id="PBXApp" tabindex="-1">Real-Time Application Administration <a class="header-anchor" href="#PBXApp" aria-label="Permalink to &quot;Real-Time Application Administration {#PBXApp}&quot;">​</a></h2><p>The following commands can be used to manage CommuniGate Pro <a href="./PBXApp.html">Real-Time</a> Application Environments.</p><p>A user should have the <a href="./../admin/sysadmin/#Privs">All Domains</a> Server access right or the <code>CanModifyPBXApps</code> <a href="./../admin/sysadmin/#Domain">Domain Administration access right</a> to modify the Domain Real-Time Application Environment.</p><h3 id="CREATEDOMAINPBX" tabindex="-1"><code>CREATEDOMAINPBX domainName [ FILE language ]</code> <a class="header-anchor" href="#CREATEDOMAINPBX" aria-label="Permalink to &quot;`CREATEDOMAINPBX domainName [ FILE language ]` {#CREATEDOMAINPBX}&quot;">​</a></h3><p>Use this command to create the Domain Real-Time Application Environment or to create its national subset.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>language : string</code></p><p>This optional parameter specifies a national subset name.</p></li></ul><h3 id="DELETEDOMAINPBX" tabindex="-1"><code>DELETEDOMAINPBX domainName FILE language</code> <a class="header-anchor" href="#DELETEDOMAINPBX" aria-label="Permalink to &quot;`DELETEDOMAINPBX domainName FILE language` {#DELETEDOMAINPBX}&quot;">​</a></h3><p>Use this command to remove a national subset from the Domain Real-Time Application Environment.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>language : string</code></p><p>This parameter specifies a national subset name.</p></li></ul><h3 id="LISTDOMAINPBXFILES" tabindex="-1"><code>LISTDOMAINPBXFILES domainName [ FILE language ]</code> <a class="header-anchor" href="#LISTDOMAINPBXFILES" aria-label="Permalink to &quot;`LISTDOMAINPBXFILES domainName [ FILE language ]` {#LISTDOMAINPBXFILES}&quot;">​</a></h3><p>Use this command to list files in the Domain Real-Time Application Environment. The command produces an output - a <em>dictionary</em> with file names used as keys. The dictionary element values are dictionaries with file attributes.</p><ul><li><p><code>domainName : string</code></p><p>This optional parameter specifies the Domain name. If the Domain name is not specified, the command applies to the administrator Domain.</p></li><li><p><code>language : string</code></p><p>This optional parameter specifies a national subset name.</p></li></ul><h3 id="READDOMAINPBXFILE" tabindex="-1"><code>READDOMAINPBXFILE domainName FILE fileName</code> <a class="header-anchor" href="#READDOMAINPBXFILE" aria-label="Permalink to &quot;`READDOMAINPBXFILE domainName FILE fileName` {#READDOMAINPBXFILE}&quot;">​</a></h3><p>Use this command to read a file from the Domain Real-Time Application Environment. The command produces an output - a <em>datablock</em> with the file contents.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the file name. To retrieve a file from a national subset, specify the name as <em>language</em>/<em>fileName</em>.</p></li></ul><h3 id="STOREDOMAINPBXFILE" tabindex="-1"><code>STOREDOMAINPBXFILE domainName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STOREDOMAINPBXFILE" aria-label="Permalink to &quot;`STOREDOMAINPBXFILE domainName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STOREDOMAINPBXFILE}&quot;">​</a></h3><h3 id="storedomainpbxfile-domainname-file-filename-delete" tabindex="-1"><code>STOREDOMAINPBXFILE domainName FILE fileName DELETE</code> <a class="header-anchor" href="#storedomainpbxfile-domainname-file-filename-delete" aria-label="Permalink to &quot;`STOREDOMAINPBXFILE domainName FILE fileName DELETE`&quot;">​</a></h3><p>Use this command to store a file into the Domain Real-Time Application Environment, or to delete a file from the Domain Real-Time Application Environment.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the Domain name.</p></li><li><p><code>fileName : string</code></p><p>This parameter specifies the file name. To store a file into a national subset, specify the name as <em>language</em>/<em>fileName</em>.</p></li><li><p><code>fileContent : datablock</code></p><p>This parameter is specified only if the DATA keyword is used. It should contain the file contents. If the DATA keyword is specified and the environment contains a file with the specified name, the old file is deleted. The file with the specified name is removed from the Environment cache (in the Dynamic Cluster the file is removed from all cluster members caches). When TRYCOMPILE keyword is specified, the CG/PL is compiled before storing. If compilation error occurs, it is returned in the command output and skin file is not stored.</p></li></ul><p>The following commands are available for the System Administrators only:</p><h3 id="CREATESERVERPBX" tabindex="-1"><code>CREATESERVERPBX language</code> <a class="header-anchor" href="#CREATESERVERPBX" aria-label="Permalink to &quot;`CREATESERVERPBX language` {#CREATESERVERPBX}&quot;">​</a></h3><p>Use this command to create the Server-wide Real-Time Application Environment or to create its national subset.</p><ul><li><p><code>language : string</code></p><p>This parameter specifies a national subset name.</p></li></ul><h3 id="DELETESERVERPBX" tabindex="-1"><code>DELETESERVERPBX language</code> <a class="header-anchor" href="#DELETESERVERPBX" aria-label="Permalink to &quot;`DELETESERVERPBX language` {#DELETESERVERPBX}&quot;">​</a></h3><p>Use this command to remove a national subset of the Server-wide Real-Time Application Environment.</p><ul><li><p><code>language : string</code></p><p>This parameter specifies a national subset name.</p></li></ul><h3 id="LISTSERVERPBXFILES" tabindex="-1"><code>LISTSERVERPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTSERVERPBXFILES" aria-label="Permalink to &quot;`LISTSERVERPBXFILES [ language ]` {#LISTSERVERPBXFILES}&quot;">​</a></h3><p>Use this command to list files in the Server-wide Real-Time Application Environment. The command produces an output - a <em>dictionary</em> with file names used as keys. The dictionary element values are dictionaries with file attributes.</p><ul><li><p><code>language : string</code></p><p>This optional parameter specifies a national subset name.</p></li></ul><h3 id="READSERVERPBXFILE" tabindex="-1"><code>READSERVERPBXFILE fileName</code> <a class="header-anchor" href="#READSERVERPBXFILE" aria-label="Permalink to &quot;`READSERVERPBXFILE fileName` {#READSERVERPBXFILE}&quot;">​</a></h3><p>Use this command to read a file from the Server-wide Real-Time Application Environment. The command produces an output - a <em>datablock</em> with the file contents.</p><ul><li><p><code>fileName : string</code></p><p>This parameter specifies the file name. To retrieve a file from a national subset, specify the name as <em>language</em>/<em>fileName</em>.</p></li></ul><h3 id="STORESERVERPBXFILE" tabindex="-1"><code>STORESERVERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORESERVERPBXFILE" aria-label="Permalink to &quot;`STORESERVERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORESERVERPBXFILE}&quot;">​</a></h3><h3 id="storeserverpbxfile-filename-delete" tabindex="-1"><code>STORESERVERPBXFILE fileName DELETE</code> <a class="header-anchor" href="#storeserverpbxfile-filename-delete" aria-label="Permalink to &quot;`STORESERVERPBXFILE fileName DELETE`&quot;">​</a></h3><p>Use this command to store a file into the Server-wide Real-Time Application Environment, or to delete a file from the Server-wide Real-Time Application Environment.</p><ul><li><p><code>fileName : string</code></p><p>This parameter specifies the file name. To store a file into a national subset, specify the name as <em>language</em>/<em>fileName</em>.</p></li><li><p><code>fileContent : datablock</code></p><p>This parameter is specified only if the DATA keyword is used. It should contain the file contents. If the DATA keyword is specified and the environment contains a file with the specified name, the old file is deleted. The file with the specified name is removed from the Environment cache (in the Dynamic Cluster the file is removed from all cluster members caches). When TRYCOMPILE keyword is specified, the CG/PL is compiled before storing. If compilation error occurs, it is returned in the command output and skin file is not stored.</p></li></ul><h3 id="CREATECLUSTERPBX" tabindex="-1"><code>CREATECLUSTERPBX language</code> <a class="header-anchor" href="#CREATECLUSTERPBX" aria-label="Permalink to &quot;`CREATECLUSTERPBX language` {#CREATECLUSTERPBX}&quot;">​</a></h3><h3 id="DELETECLUSTERPBX" tabindex="-1"><code>DELETECLUSTERPBX language</code> <a class="header-anchor" href="#DELETECLUSTERPBX" aria-label="Permalink to &quot;`DELETECLUSTERPBX language` {#DELETECLUSTERPBX}&quot;">​</a></h3><h3 id="LISTCLUSTERPBXFILES" tabindex="-1"><code>LISTCLUSTERPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTCLUSTERPBXFILES" aria-label="Permalink to &quot;`LISTCLUSTERPBXFILES [ language ]` {#LISTCLUSTERPBXFILES}&quot;">​</a></h3><h3 id="READCLUSTERPBXFILE" tabindex="-1"><code>READCLUSTERPBXFILE fileName</code> <a class="header-anchor" href="#READCLUSTERPBXFILE" aria-label="Permalink to &quot;`READCLUSTERPBXFILE fileName` {#READCLUSTERPBXFILE}&quot;">​</a></h3><h3 id="STORECLUSTERPBXFILE" tabindex="-1"><code>STORECLUSTERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORECLUSTERPBXFILE" aria-label="Permalink to &quot;`STORECLUSTERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORECLUSTERPBXFILE}&quot;">​</a></h3><h3 id="storeclusterpbxfile-filename-delete" tabindex="-1"><code>STORECLUSTERPBXFILE fileName DELETE</code> <a class="header-anchor" href="#storeclusterpbxfile-filename-delete" aria-label="Permalink to &quot;`STORECLUSTERPBXFILE fileName DELETE`&quot;">​</a></h3><p>These commands are available in the Dynamic Cluster only.<br> Use these commands instead of the [<code>LIST</code>|<code>READ</code>|<code>STORE</code>]<code>SERVERPBXFILE</code>[<code>S</code>] commands to work with files in the cluster-wide Real-Time Application Environment.</p><h3 id="LISTSTOCKPBXFILES" tabindex="-1"><code>LISTSTOCKPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTSTOCKPBXFILES" aria-label="Permalink to &quot;`LISTSTOCKPBXFILES [ language ]` {#LISTSTOCKPBXFILES}&quot;">​</a></h3><h3 id="READSTOCKPBXFILE" tabindex="-1"><code>READSTOCKPBXFILE fileName</code> <a class="header-anchor" href="#READSTOCKPBXFILE" aria-label="Permalink to &quot;`READSTOCKPBXFILE fileName` {#READSTOCKPBXFILE}&quot;">​</a></h3><p>Use these commands instead of the [<code>LIST</code>|<code>READ</code>]<code>SERVERPBXFILE</code>[<code>S</code>] commands to work with files in the stock (built-in) Real-Time Application Environment.</p><h2 id="PBXRun" tabindex="-1">Real-Time Application Control <a class="header-anchor" href="#PBXRun" aria-label="Permalink to &quot;Real-Time Application Control {#PBXRun}&quot;">​</a></h2><p>The following commands can be used to manage CommuniGate Pro <a href="./PBXApp.html">Real-Time</a> Application Tasks.</p><h3 id="STARTPBXTASK" tabindex="-1"><code>STARTPBXTASK accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]</code> <a class="header-anchor" href="#STARTPBXTASK" aria-label="Permalink to &quot;`STARTPBXTASK accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]` {#STARTPBXTASK}&quot;">​</a></h3><p>Use this command to start a new PBX Task. The command produces an output - a <em>string</em> with the Task ID.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an Account. The Task is started on this Account behalf.<br> The name can include the Domain name. If the Domain name is not specified, the current user Domain is used by default.</p></li><li><p><code>programName : string</code></p><p>The name of the program (the .sppr file) to start.</p></li><li><p><code>entryName : string</code></p><p>This optional parameter specifies the program entry point. If this parameter is not specified, the <code>main</code> entry point is used.</p></li><li><p><code>parameter : object</code></p><p>This optional parameter specifies the program parameter. The program code can retrieve it using the following code:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Vars().startParameter</span></span></code></pre></div></li></ul><h3 id="SENDTASKEVENT" tabindex="-1"><code>SENDTASKEVENT taskID EVENT eventName [ PARAM parameter ]</code> <a class="header-anchor" href="#SENDTASKEVENT" aria-label="Permalink to &quot;`SENDTASKEVENT taskID EVENT eventName [ PARAM parameter ]` {#SENDTASKEVENT}&quot;">​</a></h3><p>Use this command to send an Event to an existing PBX Task.</p><ul><li><p><code>taskID : string</code></p><p>This parameter specifies the Task ID.</p></li><li><p><code>eventName : string</code></p><p>The name of the Event to send.</p></li><li><p><code>parameter : object</code></p><p>This optional parameter specifies the Event parameter.</p></li></ul><h3 id="KILLNODE" tabindex="-1"><code>KILLNODE taskID</code> <a class="header-anchor" href="#KILLNODE" aria-label="Permalink to &quot;`KILLNODE taskID` {#KILLNODE}&quot;">​</a></h3><p>Use this command to kill an existing PBX Task.</p><ul><li><p><code>taskID : string</code></p><p>This parameter specifies the Task ID.</p></li></ul><h3 id="READNODESTATUS" tabindex="-1"><code>READNODESTATUS taskID</code> <a class="header-anchor" href="#READNODESTATUS" aria-label="Permalink to &quot;`READNODESTATUS taskID` {#READNODESTATUS}&quot;">​</a></h3><p>Use this command to read the current <a href="./CGPL.html#SetAppStatus">application status</a> of an existing PBX Task. The command produces an output - the application status object.</p><ul><li><p><code>taskID : string</code></p><p>This parameter specifies the Task ID.</p></li></ul><h2 id="full-text-search" tabindex="-1">Full-Text Search <a class="header-anchor" href="#full-text-search" aria-label="Permalink to &quot;Full-Text Search&quot;">​</a></h2><h3 id="BUILDDOMAINSEARCHINDEX" tabindex="-1"><code>BUILDDOMAINSEARCHINDEX domainName [ ENABLEFORALL ]</code> <a class="header-anchor" href="#BUILDDOMAINSEARCHINDEX" aria-label="Permalink to &quot;`BUILDDOMAINSEARCHINDEX domainName [ ENABLEFORALL ]` {#BUILDDOMAINSEARCHINDEX}&quot;">​</a></h3><p>Use this command to build <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for all Domain Users. If the User already has <a href="./../admin/sysadmin/#searchIndex">Search Index</a> built for their account, the existing search index would not be rebuilt. If <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is disabled in Default User Settings, it will be built only for the users that have Search Index enabled.</p><ul><li><p><code>domainName : string</code></p><p>This parameter sets the name of the Domain to build <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for.</p></li><li><p><code>ENABLEFORALL</code></p><p>This optional parameter enables <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for all the domain users. <a href="./../admin/sysadmin/#searchIndex">Search Index</a> will not be enabled for users that have specifically disabled Search Index in their profile settings.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Building <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for large (over 1 GB) mailboxes can take a significant time, so it is recommended to run Indexing during low Server load times.</p></div><h3 id="GETDOMAINSEARCHINDEXSTATE" tabindex="-1"><code>GETDOMAINSEARCHINDEXSTATE domainName</code> <a class="header-anchor" href="#GETDOMAINSEARCHINDEXSTATE" aria-label="Permalink to &quot;`GETDOMAINSEARCHINDEXSTATE domainName` {#GETDOMAINSEARCHINDEXSTATE}&quot;">​</a></h3><p>Use this command to retrieve the state of the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of a Domain. This command returns a string with the value <code>none</code> if the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> in the Domain does not exist, <code>waiting</code> if the Domain is waiting for the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> to be built, <code>indexing</code> if the Domain is in the process of building the <a href="./../admin/sysadmin/#searchIndex">Search Index</a>, and <code>ready</code> if the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is ready.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of the Domain which <a href="./../admin/sysadmin/#searchIndex">Search Index</a> state is to be retrieved for.</p></li></ul><h3 id="REMOVEDOMAINSEARCHINDEX" tabindex="-1"><code>REMOVEDOMAINSEARCHINDEX domainName</code> <a class="header-anchor" href="#REMOVEDOMAINSEARCHINDEX" aria-label="Permalink to &quot;`REMOVEDOMAINSEARCHINDEX domainName` {#REMOVEDOMAINSEARCHINDEX}&quot;">​</a></h3><p>Use this command to clear the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of all Domain Users. The <a href="./../admin/sysadmin/#searchIndex">Search Index</a> in the User Defaults must be turned off. If <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is enabled in the settings of a particular User, the cleanup will not be performed for that User.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of the Domain, <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for which is to be cleared.</p></li></ul><h3 id="BUILDACCOUNTSEARCHINDEX" tabindex="-1"><code>BUILDACCOUNTSEARCHINDEX accountName</code> <a class="header-anchor" href="#BUILDACCOUNTSEARCHINDEX" aria-label="Permalink to &quot;`BUILDACCOUNTSEARCHINDEX accountName` {#BUILDACCOUNTSEARCHINDEX}&quot;">​</a></h3><p>Use this command to build the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for the User. If the User already has <a href="./admin/sysadmin/#searchIndex">Search Index</a> built, it will be rebuilt completely. If <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is disabled in the User or Domain settings, it will be enabled for the specified User.</p><ul><li><p><code>accountName : string</code>.</p><p>This parameter specifies the full name of the User specifying the Domain, <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for which it should be built.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Building <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for large (more than 1 GB) mailboxes can take a significant time, so it is recommended to run Indexing during low Server load times.</p></div><h3 id="GETACCOUNTSEARCHINDEXSTATE" tabindex="-1"><code>GETACCOUNTSEARCHINDEXSTATE accountName</code> <a class="header-anchor" href="#GETACCOUNTSEARCHINDEXSTATE" aria-label="Permalink to &quot;`GETACCOUNTSEARCHINDEXSTATE accountName` {#GETACCOUNTSEARCHINDEXSTATE}&quot;">​</a></h3><p>Use this command to retrieve the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> status of the User. This command returns a string with the value <code>none</code> if <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of the User is missing, <code>waiting</code> if the User is waiting for the Search Index to be built, <code>indexing</code> if the User is in the process of building the <a href="./../admin/sysadmin/#searchIndex">Search Index</a>, and <code>ready</code> if the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is ready to go.</p><ul><li><p><code>accountName : string</code>.</p><p>This parameter specifies the full name of the User specifying the Domain whose <a href="./../admin/sysadmin/#searchIndex">Search Index</a> status is to be retrieved.</p></li></ul><h3 id="GETACCOUNTSEARCHINDEXSIZE" tabindex="-1"><code>GETACCOUNTSEARCHINDEXSIZE accountName</code> <a class="header-anchor" href="#GETACCOUNTSEARCHINDEXSIZE" aria-label="Permalink to &quot;`GETACCOUNTSEARCHINDEXSIZE accountName` {#GETACCOUNTSEARCHINDEXSIZE}&quot;">​</a></h3><p>Use this command to get the size of the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of the User. This command returns a number.</p><ul><li><p><code>accountName : string</code>.</p><p>This parameter specifies the full name of the User specifying the Domain whose <a href="./../admin/sysadmin/#searchIndex">Search Index</a> status is to be retrieved.</p></li></ul><h3 id="REMOVEACCOUNTSEARCHINDEX" tabindex="-1"><code>REMOVEACCOUNTSEARCHINDEX accountName</code> <a class="header-anchor" href="#REMOVEACCOUNTSEARCHINDEX" aria-label="Permalink to &quot;`REMOVEACCOUNTSEARCHINDEX accountName` {#REMOVEACCOUNTSEARCHINDEX}&quot;">​</a></h3><p>Use this command to clear the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of a User. The <a href="./../admin/sysadmin/#searchIndex">Search Index</a> of a User or Domain must be disabled.</p><ul><li><p><code>accountName : string</code>.</p><p>This parameter specifies the full name of the User specifying the Domain whose <a href="./../admin/sysadmin/#searchIndex">Search Index</a> should be cleared.</p></li></ul><h3 id="SEARCHININDEX" tabindex="-1"><code>SEARCHININDEX accountName SEARCHSTRING searchString [ OPTIONS options ]</code> <a class="header-anchor" href="#SEARCHININDEX" aria-label="Permalink to &quot;`SEARCHININDEX accountName SEARCHSTRING searchString [ OPTIONS options ]` {#SEARCHININDEX}&quot;">​</a></h3><p>Use this command to search for a string in <a href="./../admin/sysadmin/#searchIndex">Search Index</a>. This command returns an object with the search results. If the string format is incorrect, the query will not be processed and the server will return an <code>Invalid Query</code> error.</p><ul><li><p><code>accountName : string</code>.</p><p>This parameter specifies the full name of the User specifying the Domain whose <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is to be searched.</p></li><li><p><code>searchString : string</code>.</p><p>This parameter specifies the string to be searched. It supports <a href="./../admin/sysadmin/sysadmin/#searchSyntax">Query Syntax</a>.</p></li><li><p><code>options : dictionary</code>.</p><p>Dictionary with <a href="./XMLAPI/#searchOptions">search options</a>.</p></li></ul><h3 id="BUILDGROUPSEARCHINDEX" tabindex="-1"><code>BUILDGROUPSEARCHINDEX domainName groupName [ ENABLEFORALL ]</code> <a class="header-anchor" href="#BUILDGROUPSEARCHINDEX" aria-label="Permalink to &quot;`BUILDGROUPSEARCHINDEX domainName groupName [ ENABLEFORALL ]` {#BUILDGROUPSEARCHINDEX}&quot;">​</a></h3><p>Use this command to build <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for all Users in the Group. If a User already has <a href="./../admin/sysadmin/#searchIndex">Search Index</a> built, it will not be rebuilt. If <a href="./../admin/sysadmin/#searchIndex">Search Index</a> is disabled in the Users default settings, then the index will be built only for those Users who have it enabled in their settings.</p><ul><li><p><code>domainName : string</code>.</p><p>This parameter specifies the name of the Domain, <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for which Group the index is to be built.</p></li><li><p><code>groupName : string</code>.</p><p>This parameter specifies the name of the Group to get the users to build Search Index for.</p></li><li><p><code>ENABLEFORALL</code>.</p><p>This optional parameter enables <a href="./../admin/sysadmin/#searchIndex">Search Index</a> in the settings of each User in the Group.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Building <a href="./../admin/sysadmin/#searchIndex">Search Index</a> for large (more than 1 GB) mailboxes can take a significant time, so it is recommended to run Indexing during low Server load times.</p></div><h2 id="SyncScripts" tabindex="-1">Synchronous Scripts <a class="header-anchor" href="#SyncScripts" aria-label="Permalink to &quot;Synchronous Scripts {#SyncScripts}&quot;">​</a></h2><p>The following commands can be used to employ <a href="./CGPL.html#SyncScripts">Synchronous Scripts</a> that are available on the server.</p><h3 id="RUNSCRIPT" tabindex="-1"><code>RUNSCRIPT accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]</code> <a class="header-anchor" href="#RUNSCRIPT" aria-label="Permalink to &quot;`RUNSCRIPT accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]` {#RUNSCRIPT}&quot;">​</a></h3><p>Use this command to execute a synchronous script. The command produces an output - the synchronous script resulting <em>object</em>.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an Account. The script is started on this Account behalf.<br> The name can include the Domain name. If the Domain name is not specified, the current user Domain is used by default.</p></li><li><p><code>programName : string</code></p><p>The name of the script (the .scgp file) to start.</p></li><li><p><code>entryName : string</code></p><p>This optional parameter specifies the script entry point. If this parameter is not specified, the <code>main</code> entry point is used.</p></li><li><p><code>parameter : object</code></p><p>This optional parameter specifies the script parameter. The script code can retrieve it using the following code:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Vars().startParameter</span></span></code></pre></div></li></ul><h2 id="Services" tabindex="-1">Account Services <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Account Services {#Services}&quot;">​</a></h2><p>The following commands can be used to manage various CommuniGate Pro Account Services.</p><h3 id="REMOVEACCOUNTSUBSET" tabindex="-1"><code>REMOVEACCOUNTSUBSET accountName SUBSET subsetName</code> <a class="header-anchor" href="#REMOVEACCOUNTSUBSET" aria-label="Permalink to &quot;`REMOVEACCOUNTSUBSET accountName SUBSET subsetName` {#REMOVEACCOUNTSUBSET}&quot;">​</a></h3><p>Use this command to remove an Account &quot;dataset&quot; (such as the <code>RepliedAddresses</code> dataset).</p><p>A user should be the Account owner or should have the <a href="./../admin/sysadmin/#Domain">BasicSettings</a> Domain Administration access right to use this command.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>subsetName : string</code></p><p>This parameter specifies the name of an existing data subset in the specified Account.</p></li></ul><h3 id="DATASET" tabindex="-1"><code>DATASET accountName parameters</code> <a class="header-anchor" href="#DATASET" aria-label="Permalink to &quot;`DATASET accountName parameters` {#DATASET}&quot;">​</a></h3><p>Use this command to manage Account &quot;datasets&quot;. The command produces an output - a <em>dictionary</em> with the operation results.</p><p>A user should be the Account owner or should have the <a href="./../admin/sysadmin/#Domain">BasicSettings</a> Domain Administration access right to use this command.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>parameters : dictionary</code></p><p>This dictionary should contain:</p><ul><li><p><code>subsetName</code></p><p>a string element specifying the target dataset or the dataset subset</p></li><li><p><code>what</code></p><p>a string element specifying the operation to apply. Other dictionary elements are operation-specific. The following is the list of supported operations (the <code>what</code> values) and the additional <em>parameters</em> dictionary elements used for each operation:</p></li></ul></li><li><p><code>listSubsets</code></p><p>this operation lists all subsets of the specified dataset. To list all top-level datasets in the Account, specify the an empty string as the <code>subsetName</code> value. The resulting dictionary contains the found subset names as keys and empty strings as values.</p></li><li><p><code>createSet</code></p><p>this operation creates the specified dataset.</p></li><li><p><code>removeSet</code></p><p>this operation removes the specified dataset.</p></li><li><p><code>listEntries</code></p><p>this operation lists subset entries. The resulting dictionary contains the found entry names as keys and the entry attribute name-value dictionaries as values.</p><ul><li><p><code>attribute</code>, <code>data</code></p><p>optional string elements; they specify the name and the value of an entry attribute. If specified, the result includes only the entries that have the specified attribute with the specified value.<br> Use the <code>entry</code> attribute name to filter by entry names.</p></li><li><p><code>mode</code></p><p>an optional string element; if it is absent or its value is <code>eq</code>, then the specified attribute should have the specified value;<br> if its value is <code>beg</code>, then the beginning of the specified attribute value should match the specified value.<br> if its value is <code>end</code>, then the tail of the specified attribute value should match the specified value.<br> if its value is <code>incl</code>, then the specified attribute value should include the specified value.</p></li></ul></li><li><p><code>setEntry</code></p><p>this operation creates a new entry or updates an existing entry.</p><ul><li><p><code>data</code></p><p>a dictionary with the attribute name-value pairs; they are used to update an existing entry or to create a new one.</p></li><li><p><code>entryName</code></p><p>the entry name string; if the entry with the specified name does not exist, it is created. If this element is absent, a unique entry name is generated.</p></li><li><p><code>ifExists</code></p><p>if this element exists, then the new entry cannot be created, and only an existing entry can be updated; if this element is absent and the specified dataset is not found, the dataset is created.</p></li></ul></li><li><p><code>deleteEntry</code></p><p>this operation removes the specified entry from the specified dataset.</p><ul><li><p><code>entryName</code></p><p>the entry name string</p></li></ul></li><li><p><code>addRandomEntry</code></p><p>this operation adds a new entry to the specified dataset or the dataset subset. A unique name is generated and assigned to this entry. If the operation succeeds, the resulting dictionary has the string <code>entryName</code> element with the entry name generated.</p><ul><li><p><code>data</code></p><p>a dictionary with the attribute name-value pairs. It must contain the addressbook.Email attribute.</p></li><li><p><code>entryLimit</code></p><p>an optional numeric value; if specified and positive, then the operation checks the the current number of subset entries does not exceed this limit. If the dataset already contains an entry with the same addressbook.Email attribute value, the dataset is not modified.</p></li></ul></li><li><p><code>findAddress</code></p><p>this operation finds an entry with the specified addressbook.Email attribute value. The operation result is a dictionary. If an entry is found, its name is returned as the dictionary element with an empty-string name.</p><ul><li><p><code>address</code></p><p>a string with an E-mail address to look for</p></li></ul></li></ul><h3 id="ROSTER" tabindex="-1"><code>ROSTER accountName parameters</code> <a class="header-anchor" href="#ROSTER" aria-label="Permalink to &quot;`ROSTER accountName parameters` {#ROSTER}&quot;">​</a></h3><p>Use this command to manage Account Roster. The command produces an output - a <em>dictionary</em> with the operation results.</p><p>A user should be the Account owner or should have the <a href="./../admin/sysadmin/#Domain">BasicSettings</a> Domain Administration access right to use this command.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>parameters : dictionary</code></p><p>This dictionary should contain the <code>what</code> string element, specifying the operation to apply: <code>List</code>, <code>Update</code>, <code>remove</code>, <code>Presence</code>, <code>probe</code>. Other dictionary elements are operation-specific.</p></li></ul><h3 id="BALANCE" tabindex="-1"><code>BALANCE accountName parameters</code> <a class="header-anchor" href="#BALANCE" aria-label="Permalink to &quot;`BALANCE accountName parameters` {#BALANCE}&quot;">​</a></h3><p>Use this command to manage Account Billing Balances. The command produces an output - a <em>dictionary</em> with the operation results (as specified in the <a href="./../admin/misc/Billing.html">Billing</a> section).</p><p>A user should be the Account owner or should have the <a href="./../admin/sysadmin/#Domain">CanCreditAccounts</a> Domain Administration access right to use this command.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>parameters : dictionary</code></p><p>This dictionary should contain the <code>op</code> string element, specifying the operation to apply: <code>list</code>, <code>reserve</code>, <code>release</code>, <code>charge</code>, <code>credit</code>, <code>read</code>, <code>readAll</code>, <code>history</code>, <code>remove</code>. Other dictionary elements are operation-specific, they are specified in the <a href="./../admin/misc/Billing.html">Billing</a> section.</p></li></ul><h2 id="Settings" tabindex="-1">Server Settings <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;Server Settings {#Settings}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">Settings</a> Server access right to use the Server Settings CLI commands.</p><h3 id="LISTMODULES" tabindex="-1"><code>LISTMODULES</code> <a class="header-anchor" href="#LISTMODULES" aria-label="Permalink to &quot;`LISTMODULES` {#LISTMODULES}&quot;">​</a></h3><p>Use this command to list all Server modules. The command produces an output - an <em>array</em> with all module names.</p><h3 id="GETMODULE" tabindex="-1"><code>GETMODULE moduleName</code> <a class="header-anchor" href="#GETMODULE" aria-label="Permalink to &quot;`GETMODULE moduleName` {#GETMODULE}&quot;">​</a></h3><p>Use this command to get the module settings. The command produces an output - a <em>dictionary</em> with the module settings.</p><ul><li><p><code>moduleName : string</code></p><p>This parameter specifies the name of a CommuniGate Pro Server module.</p></li></ul><h3 id="SETMODULE" tabindex="-1"><code>SETMODULE moduleName newSettings</code> <a class="header-anchor" href="#SETMODULE" aria-label="Permalink to &quot;`SETMODULE moduleName newSettings` {#SETMODULE}&quot;">​</a></h3><p>Use this command to set the module settings.</p><ul><li><p><code>moduleName : string</code></p><p>This parameter specifies the name of a CommuniGate Pro Server module.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the module settings dictionary.</p></li></ul><h3 id="UPDATEMODULE" tabindex="-1"><code>UPDATEMODULE moduleName newSettings</code> <a class="header-anchor" href="#UPDATEMODULE" aria-label="Permalink to &quot;`UPDATEMODULE moduleName newSettings` {#UPDATEMODULE}&quot;">​</a></h3><p>Use this command to update the module settings.</p><ul><li><p><code>moduleName : string</code></p><p>This parameter specifies the name of a CommuniGate Pro Server module.</p></li><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the module settings dictionary. It does not have to contain all settings data, the omitted settings will be left unmodified.</p></li></ul><h3 id="GETQUEUESETTINGS" tabindex="-1"><code>GETQUEUESETTINGS</code> <a class="header-anchor" href="#GETQUEUESETTINGS" aria-label="Permalink to &quot;`GETQUEUESETTINGS` {#GETQUEUESETTINGS}&quot;">​</a></h3><p>Use this command to get the Queue settings. The command produces an output - a <em>dictionary</em> with the Queue settings.</p><h3 id="SETQUEUESETTINGS" tabindex="-1"><code>SETQUEUESETTINGS newSettings</code> <a class="header-anchor" href="#SETQUEUESETTINGS" aria-label="Permalink to &quot;`SETQUEUESETTINGS newSettings` {#SETQUEUESETTINGS}&quot;">​</a></h3><p>Use this command to set the Queue settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the Queue settings dictionary.</p></li></ul><h3 id="GETSIGNALSETTINGS" tabindex="-1"><code>GETSIGNALSETTINGS</code> <a class="header-anchor" href="#GETSIGNALSETTINGS" aria-label="Permalink to &quot;`GETSIGNALSETTINGS` {#GETSIGNALSETTINGS}&quot;">​</a></h3><p>Use this command to get the Signal component settings. The command produces an output - a <em>dictionary</em> with the component settings.</p><h3 id="SETSIGNALSETTINGS" tabindex="-1"><code>SETSIGNALSETTINGS newSettings</code> <a class="header-anchor" href="#SETSIGNALSETTINGS" aria-label="Permalink to &quot;`SETSIGNALSETTINGS newSettings` {#SETSIGNALSETTINGS}&quot;">​</a></h3><p>Use this command to set the Signal component settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the component settings dictionary.</p></li></ul><h3 id="GETMEDIASERVERSETTINGS" tabindex="-1"><code>GETMEDIASERVERSETTINGS</code> <a class="header-anchor" href="#GETMEDIASERVERSETTINGS" aria-label="Permalink to &quot;`GETMEDIASERVERSETTINGS` {#GETMEDIASERVERSETTINGS}&quot;">​</a></h3><p>Use this command to read the Media Server component settings. The command produces an output - a <em>dictionary</em> with the component settings.</p><h3 id="SETMEDIASERVERSETTINGS" tabindex="-1"><code>SETMEDIASERVERSETTINGS newSettings</code> <a class="header-anchor" href="#SETMEDIASERVERSETTINGS" aria-label="Permalink to &quot;`SETMEDIASERVERSETTINGS newSettings` {#SETMEDIASERVERSETTINGS}&quot;">​</a></h3><p>Use this command to set the Media Server component settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the component settings dictionary.</p></li></ul><h3 id="GETSESSIONSETTINGS" tabindex="-1"><code>GETSESSIONSETTINGS</code> <a class="header-anchor" href="#GETSESSIONSETTINGS" aria-label="Permalink to &quot;`GETSESSIONSETTINGS` {#GETSESSIONSETTINGS}&quot;">​</a></h3><p>Use this command to get the user Sessions settings. The command produces an output - a <em>dictionary</em> with the Sessions settings.</p><h3 id="SETSESSIONSETTINGS" tabindex="-1"><code>SETSESSIONSETTINGS newSettings</code> <a class="header-anchor" href="#SETSESSIONSETTINGS" aria-label="Permalink to &quot;`SETSESSIONSETTINGS newSettings` {#SETSESSIONSETTINGS}&quot;">​</a></h3><p>Use this command to set the user Sessions settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the Sessions settings dictionary.</p></li></ul><h3 id="GETCLUSTERSETTINGS" tabindex="-1"><code>GETCLUSTERSETTINGS</code> <a class="header-anchor" href="#GETCLUSTERSETTINGS" aria-label="Permalink to &quot;`GETCLUSTERSETTINGS` {#GETCLUSTERSETTINGS}&quot;">​</a></h3><p>Use this command to get the Cluster settings. The command produces an output - a <em>dictionary</em> with the Cluster settings.</p><h3 id="SETCLUSTERSETTINGS" tabindex="-1"><code>SETCLUSTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETCLUSTERSETTINGS" aria-label="Permalink to &quot;`SETCLUSTERSETTINGS newSettings` {#SETCLUSTERSETTINGS}&quot;">​</a></h3><p>Use this command to set the Cluster settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to set the Cluster settings dictionary.</p></li></ul><h3 id="GETLOGSETTINGS" tabindex="-1"><code>GETLOGSETTINGS</code> <a class="header-anchor" href="#GETLOGSETTINGS" aria-label="Permalink to &quot;`GETLOGSETTINGS` {#GETLOGSETTINGS}&quot;">​</a></h3><p>Use this command to get the Main Log settings. The command produces an output - a <em>dictionary</em> with the Main Log settings.</p><h3 id="UPDATELOGSETTINGS" tabindex="-1"><code>UPDATELOGSETTINGS newSettings</code> <a class="header-anchor" href="#UPDATELOGSETTINGS" aria-label="Permalink to &quot;`UPDATELOGSETTINGS newSettings` {#UPDATELOGSETTINGS}&quot;">​</a></h3><p>Use this command to set the Main Log settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>This dictionary is used to update the Main Log settings dictionary.</p></li></ul><h3 id="GETNETWORK" tabindex="-1"><code>GETNETWORK</code> <a class="header-anchor" href="#GETNETWORK" aria-label="Permalink to &quot;`GETNETWORK` {#GETNETWORK}&quot;">​</a></h3><p>Use this command to retrieve the Network settings. The command produces an output - a <em>dictionary</em> with the server Network settings.</p><h3 id="SETNETWORK" tabindex="-1"><code>SETNETWORK newSettings</code> <a class="header-anchor" href="#SETNETWORK" aria-label="Permalink to &quot;`SETNETWORK newSettings` {#SETNETWORK}&quot;">​</a></h3><p>Use this command to set the server Network Settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>New server Network settings.</p></li></ul><h3 id="GETDNRSETTINGS" tabindex="-1"><code>GETDNRSETTINGS</code> <a class="header-anchor" href="#GETDNRSETTINGS" aria-label="Permalink to &quot;`GETDNRSETTINGS` {#GETDNRSETTINGS}&quot;">​</a></h3><p>Use this command to retrieve the DNR (Domain Name Resolver) settings. The command produces an output - a <em>dictionary</em> with the DNR settings.</p><h3 id="SETDNRSETTINGS" tabindex="-1"><code>SETDNRSETTINGS newSettings</code> <a class="header-anchor" href="#SETDNRSETTINGS" aria-label="Permalink to &quot;`SETDNRSETTINGS newSettings` {#SETDNRSETTINGS}&quot;">​</a></h3><p>Use this command to set the DNR (Domain Name Resolver) settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>New DNR settings.</p></li></ul><h3 id="GETBANNED" tabindex="-1"><code>GETBANNED</code> <a class="header-anchor" href="#GETBANNED" aria-label="Permalink to &quot;`GETBANNED` {#GETBANNED}&quot;">​</a></h3><p>Use this command to retrieve the Banned Message Lines settings. The command produces an output - a <em>dictionary</em> with the server Banned Message Lines settings.</p><h3 id="SETBANNED" tabindex="-1"><code>SETBANNED newSettings</code> <a class="header-anchor" href="#SETBANNED" aria-label="Permalink to &quot;`SETBANNED newSettings` {#SETBANNED}&quot;">​</a></h3><p>Use this command to set the server Banned Message Line Settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>New server Banned settings.</p></li></ul><h3 id="GETCLUSTERNETWORK" tabindex="-1"><code>GETCLUSTERNETWORK</code> <a class="header-anchor" href="#GETCLUSTERNETWORK" aria-label="Permalink to &quot;`GETCLUSTERNETWORK` {#GETCLUSTERNETWORK}&quot;">​</a></h3><h3 id="SETCLUSTERNETWORK" tabindex="-1"><code>SETCLUSTERNETWORK newSettings</code> <a class="header-anchor" href="#SETCLUSTERNETWORK" aria-label="Permalink to &quot;`SETCLUSTERNETWORK newSettings` {#SETCLUSTERNETWORK}&quot;">​</a></h3><p>Use these commands to retrieve and update the Cluster-wide Network settings.</p><h3 id="GETCLUSTERBANNED" tabindex="-1"><code>GETCLUSTERBANNED</code> <a class="header-anchor" href="#GETCLUSTERBANNED" aria-label="Permalink to &quot;`GETCLUSTERBANNED` {#GETCLUSTERBANNED}&quot;">​</a></h3><h3 id="SETCLUSTERBANNED" tabindex="-1"><code>SETCLUSTERBANNED newSettings</code> <a class="header-anchor" href="#SETCLUSTERBANNED" aria-label="Permalink to &quot;`SETCLUSTERBANNED newSettings` {#SETCLUSTERBANNED}&quot;">​</a></h3><p>Use these commands to retrieve and update the Cluster-wide Banned Message Lines settings.</p><h3 id="GETSERVERMAILRULES" tabindex="-1"><code>GETSERVERMAILRULES</code> <a class="header-anchor" href="#GETSERVERMAILRULES" aria-label="Permalink to &quot;`GETSERVERMAILRULES` {#GETSERVERMAILRULES}&quot;">​</a></h3><p>Use this command to read the Server-Wide Automated Mail Processing Rules. The command produces an output - an <em>array</em> of the Server Queue Rules.</p><h3 id="SETSERVERMAILRULES" tabindex="-1"><code>SETSERVERMAILRULES newRules</code> <a class="header-anchor" href="#SETSERVERMAILRULES" aria-label="Permalink to &quot;`SETSERVERMAILRULES newRules` {#SETSERVERMAILRULES}&quot;">​</a></h3><p>Use this command to set the Server-Wide Automated Mail Processing Rules.</p><ul><li><p><code>newRules : array</code></p><p>An array of new Server Queue Rules.</p></li></ul><h3 id="GETSERVERSIGNALRULES" tabindex="-1"><code>GETSERVERSIGNALRULES</code> <a class="header-anchor" href="#GETSERVERSIGNALRULES" aria-label="Permalink to &quot;`GETSERVERSIGNALRULES` {#GETSERVERSIGNALRULES}&quot;">​</a></h3><p>Use this command to read the Server-Wide Automated Signal Processing Rules. The command produces an output - an <em>array</em> of the Server Signal Rules.</p><h3 id="SETSERVERSIGNALRULES" tabindex="-1"><code>SETSERVERSIGNALRULES newRules</code> <a class="header-anchor" href="#SETSERVERSIGNALRULES" aria-label="Permalink to &quot;`SETSERVERSIGNALRULES newRules` {#SETSERVERSIGNALRULES}&quot;">​</a></h3><p>Use this command to set the Server-Wide Automated Signal Processing Rules.</p><ul><li><p><code>newRules : array</code></p><p>An array of new Server Signal Rules.</p></li></ul><h3 id="GETCLUSTERMAILRULES" tabindex="-1"><code>GETCLUSTERMAILRULES</code> <a class="header-anchor" href="#GETCLUSTERMAILRULES" aria-label="Permalink to &quot;`GETCLUSTERMAILRULES` {#GETCLUSTERMAILRULES}&quot;">​</a></h3><h3 id="SETCLUSTERMAILRULES" tabindex="-1"><code>SETCLUSTERMAILRULES newRules</code> <a class="header-anchor" href="#SETCLUSTERMAILRULES" aria-label="Permalink to &quot;`SETCLUSTERMAILRULES newRules` {#SETCLUSTERMAILRULES}&quot;">​</a></h3><h3 id="GETCLUSTERSIGNALRULES" tabindex="-1"><code>GETCLUSTERSIGNALRULES</code> <a class="header-anchor" href="#GETCLUSTERSIGNALRULES" aria-label="Permalink to &quot;`GETCLUSTERSIGNALRULES` {#GETCLUSTERSIGNALRULES}&quot;">​</a></h3><h3 id="SETCLUSTERSIGNALRULES" tabindex="-1"><code>SETCLUSTERSIGNALRULES newRules</code> <a class="header-anchor" href="#SETCLUSTERSIGNALRULES" aria-label="Permalink to &quot;`SETCLUSTERSIGNALRULES newRules` {#SETCLUSTERSIGNALRULES}&quot;">​</a></h3><p>Use these commands to retrieve and update the Cluster-wide Rules.</p><h3 id="GETROUTERTABLE" tabindex="-1"><code>GETROUTERTABLE</code> <a class="header-anchor" href="#GETROUTERTABLE" aria-label="Permalink to &quot;`GETROUTERTABLE` {#GETROUTERTABLE}&quot;">​</a></h3><p>Use this command to read the Router Table. The command produces an output - a (multi-line) <em>string</em> with the Router Table text.</p><h3 id="SETROUTERTABLE" tabindex="-1"><code>SETROUTERTABLE newTable</code> <a class="header-anchor" href="#SETROUTERTABLE" aria-label="Permalink to &quot;`SETROUTERTABLE newTable` {#SETROUTERTABLE}&quot;">​</a></h3><p>Use this command to set the Router Table.</p><ul><li><p><code>newTable : string</code></p><p>A (multi-line) string containing the text of the new Router Table<br> Note: multiple lines should be separated with the <code>\\e</code> symbols.</p></li></ul><h3 id="GETROUTERSETTINGS" tabindex="-1"><code>GETROUTERSETTINGS</code> <a class="header-anchor" href="#GETROUTERSETTINGS" aria-label="Permalink to &quot;`GETROUTERSETTINGS` {#GETROUTERSETTINGS}&quot;">​</a></h3><p>Use this command to read the Router settings. The command produces an output - a <em>dictionary</em> with the Router settings.</p><h3 id="SETROUTERSETTINGS" tabindex="-1"><code>SETROUTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETROUTERSETTINGS" aria-label="Permalink to &quot;`SETROUTERSETTINGS newSettings` {#SETROUTERSETTINGS}&quot;">​</a></h3><p>Use this command to set the Router settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>A dictionary containing new Router settings.</p></li></ul><h3 id="GETCLUSTERROUTERTABLE" tabindex="-1"><code>GETCLUSTERROUTERTABLE</code> <a class="header-anchor" href="#GETCLUSTERROUTERTABLE" aria-label="Permalink to &quot;`GETCLUSTERROUTERTABLE` {#GETCLUSTERROUTERTABLE}&quot;">​</a></h3><h3 id="SETCLUSTERROUTERTABLE" tabindex="-1"><code>SETCLUSTERROUTERTABLE newTable</code> <a class="header-anchor" href="#SETCLUSTERROUTERTABLE" aria-label="Permalink to &quot;`SETCLUSTERROUTERTABLE newTable` {#SETCLUSTERROUTERTABLE}&quot;">​</a></h3><h3 id="GETCLUSTERROUTERSETTINGS" tabindex="-1"><code>GETCLUSTERROUTERSETTINGS</code> <a class="header-anchor" href="#GETCLUSTERROUTERSETTINGS" aria-label="Permalink to &quot;`GETCLUSTERROUTERSETTINGS` {#GETCLUSTERROUTERSETTINGS}&quot;">​</a></h3><h3 id="SETCLUSTERROUTERSETTINGS" tabindex="-1"><code>SETCLUSTERROUTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETCLUSTERROUTERSETTINGS" aria-label="Permalink to &quot;`SETCLUSTERROUTERSETTINGS newSettings` {#SETCLUSTERROUTERSETTINGS}&quot;">​</a></h3><p>Use these commands to deal with the Cluster-Wide Router Table and settings.</p><h3 id="GETSERVERSETTINGS" tabindex="-1"><code>GETSERVERSETTINGS</code> <a class="header-anchor" href="#GETSERVERSETTINGS" aria-label="Permalink to &quot;`GETSERVERSETTINGS` {#GETSERVERSETTINGS}&quot;">​</a></h3><p>Use this command to read the Server &quot;other&quot; settings. The command produces an output - a <em>dictionary</em> with the Server settings.</p><h3 id="UPDATESERVERSETTINGS" tabindex="-1"><code>UPDATESERVERSETTINGS newSettings</code> <a class="header-anchor" href="#UPDATESERVERSETTINGS" aria-label="Permalink to &quot;`UPDATESERVERSETTINGS newSettings` {#UPDATESERVERSETTINGS}&quot;">​</a></h3><p>Use this command to update the &quot;other&quot; Server settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>A dictionary containing new Server settings.</p></li></ul><h3 id="REFRESHOSDATA" tabindex="-1"><code>REFRESHOSDATA</code> <a class="header-anchor" href="#REFRESHOSDATA" aria-label="Permalink to &quot;`REFRESHOSDATA` {#REFRESHOSDATA}&quot;">​</a></h3><p>Use this command to make the Server re-read the IP data from the server OS: the set of the local IP addresses, and the set of the DNS addresses.</p><h3 id="GETLANIPS" tabindex="-1"><code>GETLANIPS</code> <a class="header-anchor" href="#GETLANIPS" aria-label="Permalink to &quot;`GETLANIPS` {#GETLANIPS}&quot;">​</a></h3><p>Use this command to retrieve the set of LAN IP Addresses. The command produces an output - a (multi-line) <em>string</em> with LAN IP addresses and address ranges.</p><h3 id="SETLANIPS" tabindex="-1"><code>SETLANIPS newAddresses</code> <a class="header-anchor" href="#SETLANIPS" aria-label="Permalink to &quot;`SETLANIPS newAddresses` {#SETLANIPS}&quot;">​</a></h3><p>Use this command to update the set of LAN IP Addresses.</p><ul><li><p><code>newAddresses : string</code></p><p>This (multi-line) string parameter contains the set of addresses and address ranges forming the new set of LAN IP Addresses.</p></li></ul><h3 id="GETCLUSTERLANIPS" tabindex="-1"><code>GETCLUSTERLANIPS</code> <a class="header-anchor" href="#GETCLUSTERLANIPS" aria-label="Permalink to &quot;`GETCLUSTERLANIPS` {#GETCLUSTERLANIPS}&quot;">​</a></h3><p>Use this command to retrieve the set of Cluster-wide LAN IP Addresses. The command produces an output - a (multi-line) <em>string</em> with Cluster-wide LAN IP addresses and address ranges.</p><h3 id="SETCLUSTERLANIPS" tabindex="-1"><code>SETCLUSTERLANIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERLANIPS" aria-label="Permalink to &quot;`SETCLUSTERLANIPS newAddresses` {#SETCLUSTERLANIPS}&quot;">​</a></h3><p>Use this command to update the set of Cluster-wide LAN IP Addresses.</p><ul><li><p><code>newAddresses : string</code></p><p>This (multi-line) string parameter contains the set of addresses and address ranges forming the new set of Cluster-wide LAN IP Addresses.</p></li></ul><p>The following command sets have the same parameters and outputs as the <code>GETLANIPS | SETLANIPS | GETCLUSTERLANIPS | SETCLUSTERLANIPS</code> command set:</p><h3 id="GETPROXYIPS" tabindex="-1"><code>GETPROXYIPS</code> <a class="header-anchor" href="#GETPROXYIPS" aria-label="Permalink to &quot;`GETPROXYIPS` {#GETPROXYIPS}&quot;">​</a></h3><h3 id="SETPROXYIPS" tabindex="-1"><code>SETPROXYIPS newAddresses</code> <a class="header-anchor" href="#SETPROXYIPS" aria-label="Permalink to &quot;`SETPROXYIPS newAddresses` {#SETPROXYIPS}&quot;">​</a></h3><h3 id="GETCLUSTERPROXYIPS" tabindex="-1"><code>GETCLUSTERPROXYIPS</code> <a class="header-anchor" href="#GETCLUSTERPROXYIPS" aria-label="Permalink to &quot;`GETCLUSTERPROXYIPS` {#GETCLUSTERPROXYIPS}&quot;">​</a></h3><h3 id="SETCLUSTERPROXYIPS" tabindex="-1"><code>SETCLUSTERPROXYIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERPROXYIPS" aria-label="Permalink to &quot;`SETCLUSTERPROXYIPS newAddresses` {#SETCLUSTERPROXYIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide Trusted Proxy Server IP Addresses.</p><h3 id="GETCLIENTIPS" tabindex="-1"><code>GETCLIENTIPS</code> <a class="header-anchor" href="#GETCLIENTIPS" aria-label="Permalink to &quot;`GETCLIENTIPS` {#GETCLIENTIPS}&quot;">​</a></h3><h3 id="SETCLIENTIPS" tabindex="-1"><code>SETCLIENTIPS newAddresses</code> <a class="header-anchor" href="#SETCLIENTIPS" aria-label="Permalink to &quot;`SETCLIENTIPS newAddresses` {#SETCLIENTIPS}&quot;">​</a></h3><h3 id="GETCLUSTERCLIENTIPS" tabindex="-1"><code>GETCLUSTERCLIENTIPS</code> <a class="header-anchor" href="#GETCLUSTERCLIENTIPS" aria-label="Permalink to &quot;`GETCLUSTERCLIENTIPS` {#GETCLUSTERCLIENTIPS}&quot;">​</a></h3><h3 id="SETCLUSTERCLIENTIPS" tabindex="-1"><code>SETCLUSTERCLIENTIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERCLIENTIPS" aria-label="Permalink to &quot;`SETCLUSTERCLIENTIPS newAddresses` {#SETCLUSTERCLIENTIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide Client IP Addresses.</p><h3 id="GETBLACKLISTEDIPS" tabindex="-1"><code>GETBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETBLACKLISTEDIPS` {#GETBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="SETBLACKLISTEDIPS" tabindex="-1"><code>SETBLACKLISTEDIPS newAddresses</code> <a class="header-anchor" href="#SETBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETBLACKLISTEDIPS newAddresses` {#SETBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERBLACKLISTEDIPS" tabindex="-1"><code>GETCLUSTERBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETCLUSTERBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETCLUSTERBLACKLISTEDIPS` {#GETCLUSTERBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERBLACKLISTEDIPS" tabindex="-1"><code>SETCLUSTERBLACKLISTEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETCLUSTERBLACKLISTEDIPS newAddresses` {#SETCLUSTERBLACKLISTEDIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide Blacklisted IP Addresses.</p><h3 id="GETWHITEHOLEIPS" tabindex="-1"><code>GETWHITEHOLEIPS</code> <a class="header-anchor" href="#GETWHITEHOLEIPS" aria-label="Permalink to &quot;`GETWHITEHOLEIPS` {#GETWHITEHOLEIPS}&quot;">​</a></h3><h3 id="SETWHITEHOLEIPS" tabindex="-1"><code>SETWHITEHOLEIPS newAddresses</code> <a class="header-anchor" href="#SETWHITEHOLEIPS" aria-label="Permalink to &quot;`SETWHITEHOLEIPS newAddresses` {#SETWHITEHOLEIPS}&quot;">​</a></h3><h3 id="GETCLUSTERWHITEHOLEIPS" tabindex="-1"><code>GETCLUSTERWHITEHOLEIPS</code> <a class="header-anchor" href="#GETCLUSTERWHITEHOLEIPS" aria-label="Permalink to &quot;`GETCLUSTERWHITEHOLEIPS` {#GETCLUSTERWHITEHOLEIPS}&quot;">​</a></h3><h3 id="SETCLUSTERWHITEHOLEIPS" tabindex="-1"><code>SETCLUSTERWHITEHOLEIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERWHITEHOLEIPS" aria-label="Permalink to &quot;`SETCLUSTERWHITEHOLEIPS newAddresses` {#SETCLUSTERWHITEHOLEIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide WhiteHole IP Addresses.</p><h3 id="GETNATEDIPS" tabindex="-1"><code>GETNATEDIPS</code> <a class="header-anchor" href="#GETNATEDIPS" aria-label="Permalink to &quot;`GETNATEDIPS` {#GETNATEDIPS}&quot;">​</a></h3><h3 id="SETNATEDIPS" tabindex="-1"><code>SETNATEDIPS newAddresses</code> <a class="header-anchor" href="#SETNATEDIPS" aria-label="Permalink to &quot;`SETNATEDIPS newAddresses` {#SETNATEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERNATEDIPS" tabindex="-1"><code>GETCLUSTERNATEDIPS</code> <a class="header-anchor" href="#GETCLUSTERNATEDIPS" aria-label="Permalink to &quot;`GETCLUSTERNATEDIPS` {#GETCLUSTERNATEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERNATEDIPS" tabindex="-1"><code>SETCLUSTERNATEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERNATEDIPS" aria-label="Permalink to &quot;`SETCLUSTERNATEDIPS newAddresses` {#SETCLUSTERNATEDIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide NATed IP Addresses.</p><h3 id="GETNATSITEIPS" tabindex="-1"><code>GETNATSITEIPS</code> <a class="header-anchor" href="#GETNATSITEIPS" aria-label="Permalink to &quot;`GETNATSITEIPS` {#GETNATSITEIPS}&quot;">​</a></h3><h3 id="SETNATSITEIPS" tabindex="-1"><code>SETNATSITEIPS newAddresses</code> <a class="header-anchor" href="#SETNATSITEIPS" aria-label="Permalink to &quot;`SETNATSITEIPS newAddresses` {#SETNATSITEIPS}&quot;">​</a></h3><h3 id="GETCLUSTERNATSITEIPS" tabindex="-1"><code>GETCLUSTERNATSITEIPS</code> <a class="header-anchor" href="#GETCLUSTERNATSITEIPS" aria-label="Permalink to &quot;`GETCLUSTERNATSITEIPS` {#GETCLUSTERNATSITEIPS}&quot;">​</a></h3><h3 id="SETCLUSTERNATSITEIPS" tabindex="-1"><code>SETCLUSTERNATSITEIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERNATSITEIPS" aria-label="Permalink to &quot;`SETCLUSTERNATSITEIPS newAddresses` {#SETCLUSTERNATSITEIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide NAT Site IP Addresses.</p><h3 id="GETDEBUGIPS" tabindex="-1"><code>GETDEBUGIPS</code> <a class="header-anchor" href="#GETDEBUGIPS" aria-label="Permalink to &quot;`GETDEBUGIPS` {#GETDEBUGIPS}&quot;">​</a></h3><h3 id="SETDEBUGIPS" tabindex="-1"><code>SETDEBUGIPS newAddresses</code> <a class="header-anchor" href="#SETDEBUGIPS" aria-label="Permalink to &quot;`SETDEBUGIPS newAddresses` {#SETDEBUGIPS}&quot;">​</a></h3><h3 id="GETCLUSTERDEBUGIPS" tabindex="-1"><code>GETCLUSTERDEBUGIPS</code> <a class="header-anchor" href="#GETCLUSTERDEBUGIPS" aria-label="Permalink to &quot;`GETCLUSTERDEBUGIPS` {#GETCLUSTERDEBUGIPS}&quot;">​</a></h3><h3 id="SETCLUSTERDEBUGIPS" tabindex="-1"><code>SETCLUSTERDEBUGIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERDEBUGIPS" aria-label="Permalink to &quot;`SETCLUSTERDEBUGIPS newAddresses` {#SETCLUSTERDEBUGIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide Debug IP Addresses.</p><h3 id="GETDENIEDIPS" tabindex="-1"><code>GETDENIEDIPS</code> <a class="header-anchor" href="#GETDENIEDIPS" aria-label="Permalink to &quot;`GETDENIEDIPS` {#GETDENIEDIPS}&quot;">​</a></h3><h3 id="SETDENIEDIPS" tabindex="-1"><code>SETDENIEDIPS newAddresses</code> <a class="header-anchor" href="#SETDENIEDIPS" aria-label="Permalink to &quot;`SETDENIEDIPS newAddresses` {#SETDENIEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERDENIEDIPS" tabindex="-1"><code>GETCLUSTERDENIEDIPS</code> <a class="header-anchor" href="#GETCLUSTERDENIEDIPS" aria-label="Permalink to &quot;`GETCLUSTERDENIEDIPS` {#GETCLUSTERDENIEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERDENIEDIPS" tabindex="-1"><code>SETCLUSTERDENIEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERDENIEDIPS" aria-label="Permalink to &quot;`SETCLUSTERDENIEDIPS newAddresses` {#SETCLUSTERDENIEDIPS}&quot;">​</a></h3><p>Use these commands to retrieve and set Server-wide and Cluster-wide Denied IP Addresses.</p><p>A user should have the <a href="./../admin/sysadmin/#Privs">Settings</a> or <a href="./../admin/sysadmin/#Privs">User</a> Server access right or the to use the following CLI commands.</p><h3 id="ROUTE" tabindex="-1"><code>ROUTE address [ mail | access | signal ]</code> <a class="header-anchor" href="#ROUTE" aria-label="Permalink to &quot;`ROUTE address [ mail | access | signal ]` {#ROUTE}&quot;">​</a></h3><p>Use this command to get the routing for the specified address.</p><ul><li><p><code>address : string</code></p><p>This parameter specifies the E-mail address to be processed with the CommuniGate Pro Router.</p></li><li><p><code>mail</code> or <code>access</code> or <code>signal</code></p><p>This optional flag specifies the Routing type (see the <a href="./../admin/sysadmin/Router.html">Router</a> section for more details). The default mode is <code>access</code>. This command produces an output - an array of three strings:</p></li><li><p><em>module</em></p><p>the name of the CommuniGate Pro module the address is routed to, or <code>SYSTEM</code> if the address is routed to a built-in destination (like <code>NULL</code>).</p></li><li><p><em>host</em></p><p>the object/queue handled by the specified module: an Internet domain name for the SMTP module, a local Account name for the Local Delivery module, etc.</p></li><li><p><em>address</em></p><p>the address inside the queue (E-mail address for SMTP, Real-To: address for Local Delivery, etc.)</p></li></ul><h3 id="GETIPSTATE" tabindex="-1"><code>GETIPSTATE ip-address [ TEMP ]</code> <a class="header-anchor" href="#GETIPSTATE" aria-label="Permalink to &quot;`GETIPSTATE ip-address [ TEMP ]` {#GETIPSTATE}&quot;">​</a></h3><p>Use this command to get the type assigned to the specified address. The command produces an output - a <em>string</em> with the IP address type.<br> If the TEMP keyword is specified, the temporary Client IP Addresses set is checked.</p><ul><li><p><code>ip-address : string or IP address</code></p><p>This parameter specifies the IP Address to check.</p></li></ul><p>A user should have the <a href="./../admin/sysadmin/#Privs">Master</a> Server access right to use the following CLI commands.</p><h3 id="GETSERVERINTERCEPT" tabindex="-1"><code>GETSERVERINTERCEPT</code> <a class="header-anchor" href="#GETSERVERINTERCEPT" aria-label="Permalink to &quot;`GETSERVERINTERCEPT` {#GETSERVERINTERCEPT}&quot;">​</a></h3><p>Use this command to read the Lawful Intercept settings. The command produces an output - a <em>dictionary</em> with the Intercept settings.</p><h3 id="SETSERVERINTERCEPT" tabindex="-1"><code>SETSERVERINTERCEPT newSettings</code> <a class="header-anchor" href="#SETSERVERINTERCEPT" aria-label="Permalink to &quot;`SETSERVERINTERCEPT newSettings` {#SETSERVERINTERCEPT}&quot;">​</a></h3><p>Use this command to set the Lawful Intercept settings.</p><ul><li><p><code>newSettings : dictionary</code></p><p>A dictionary containing new Intercept settings.</p></li></ul><h3 id="GETCLUSTERINTERCEPT" tabindex="-1"><code>GETCLUSTERINTERCEPT</code> <a class="header-anchor" href="#GETCLUSTERINTERCEPT" aria-label="Permalink to &quot;`GETCLUSTERINTERCEPT` {#GETCLUSTERINTERCEPT}&quot;">​</a></h3><h3 id="SETCLUSTERINTERCEPT" tabindex="-1"><code>SETCLUSTERINTERCEPT newSettings</code> <a class="header-anchor" href="#SETCLUSTERINTERCEPT" aria-label="Permalink to &quot;`SETCLUSTERINTERCEPT newSettings` {#SETCLUSTERINTERCEPT}&quot;">​</a></h3><p>These commands are the same as the GETSERVERINTERCEPT and SETSERVERINTERCEPT commands, but they deal with the Cluster-Wide Lawful Intercept settings.</p><h2 id="Monitor" tabindex="-1">Monitoring <a class="header-anchor" href="#Monitor" aria-label="Permalink to &quot;Monitoring {#Monitor}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">Monitoring</a> Server access right to use the Server Monitoring CLI commands.</p><h3 id="GETSTATELEMENT" tabindex="-1"><code>GETSTATELEMENT ObjectID</code> <a class="header-anchor" href="#GETSTATELEMENT" aria-label="Permalink to &quot;`GETSTATELEMENT ObjectID` {#GETSTATELEMENT}&quot;">​</a></h3><p>Use this command to retrieve the current value of a Server statistics (SNMP) element.</p><ul><li><p><code>ObjectID : string</code></p><p>The object ID of the Server statistics element (see the <a href="./../admin/sysadmin/Statistics.html">Statistics</a> section for more details). This command produces an output - a <em>number</em>, <em>string</em>, or other object with the Server statistics element value.</p></li></ul><h3 id="SETSTATELEMENT" tabindex="-1"><code>SETSTATELEMENT ObjectID [ INC | SET ] setValue</code> <a class="header-anchor" href="#SETSTATELEMENT" aria-label="Permalink to &quot;`SETSTATELEMENT ObjectID [ INC | SET ] setValue` {#SETSTATELEMENT}&quot;">​</a></h3><p>Use this command to update the current value of a Server statistics (SNMP) element. Only the &quot;Custom&quot; elements can be updated.</p><ul><li><p><code>ObjectID : string</code></p><p>The object ID of the Server statistics element (see the <a href="./../admin/sysadmin/Statistics.html">Statistics</a> section for more details).</p></li><li><p><code>setValue : numeric string</code></p><p>if the <code>INC</code> keyword is used, this value is added to the Element value, if the <code>SET</code> keyword is used, this value is assigned to the Element.</p></li></ul><h3 id="GETNEXTSTATNAME" tabindex="-1"><code>GETNEXTSTATNAME ObjectID</code> <a class="header-anchor" href="#GETNEXTSTATNAME" aria-label="Permalink to &quot;`GETNEXTSTATNAME ObjectID` {#GETNEXTSTATNAME}&quot;">​</a></h3><p>Use this command to enumerate available Server statistics (SNMP) elements.</p><ul><li><p><code>ObjectID : string</code></p><p>An empty string or the object ID of the already found Server statistics element (see the <a href="./../admin/sysadmin/Statistics.html">Statistics</a> section for more details). This command produces an output - a <em>string</em> with the ObjectID of the next statistics element.<br> If the ObjectID parameter is an empty string, the ObjectID of the first available Server statistics element is returned.<br> If a statistics element for the specified ObjectID is not found, or if the found element is the last available one, the command returns an error.</p></li></ul><h3 id="GETDIALOGINFO" tabindex="-1"><code>GETDIALOGINFO DialogID</code> <a class="header-anchor" href="#GETDIALOGINFO" aria-label="Permalink to &quot;`GETDIALOGINFO DialogID` {#GETDIALOGINFO}&quot;">​</a></h3><p>Use this command to retrieve the information about a Signal Dialog object.</p><ul><li><p><code>DialogID : number</code></p><p>The Dialog ID. This command produces an output - a <em>dictionary</em> with the Dialog status data.</p></li></ul><h3 id="SHUTDOWN" tabindex="-1"><code>SHUTDOWN</code> <a class="header-anchor" href="#SHUTDOWN" aria-label="Permalink to &quot;`SHUTDOWN` {#SHUTDOWN}&quot;">​</a></h3><p>Use this command to stop the CommuniGate Pro Server.</p><h2 id="Stats" tabindex="-1">Statistics <a class="header-anchor" href="#Stats" aria-label="Permalink to &quot;Statistics {#Stats}&quot;">​</a></h2><p>The Account-Level Statistics data is collected if the Account Statistics option is enabled.<br> To enable this option, open the General pages in the Settings realm of the CommuniGate Pro WebAdmin Interface, and find the Local Account Manager panel on the Other page.</p><h3 id="GETACCOUNTSTAT" tabindex="-1"><code>GETACCOUNTSTAT accountName [ KEY keyName ]</code> <a class="header-anchor" href="#GETACCOUNTSTAT" aria-label="Permalink to &quot;`GETACCOUNTSTAT accountName [ KEY keyName ]` {#GETACCOUNTSTAT}&quot;">​</a></h3><p>Use this command to retrieve statistics data about the specified Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>keyName : string</code></p><p>This optional parameter specifies the name of the statistical entry to retrieve. This command produces an output - a <em>number</em> or a <em>timeStamp</em> with the specified statistical information, or (if the <code>KEY</code> keyword and the <em>keyName</em> parameter are not specified) a <em>dictionary</em> with all available statistical data. If the statistical data for the specified key does not exist, an empty <em>string</em> is returned.<br> To use this command, the user should have the Domain Administration right for the target Account Domain. All users can retrieve the Account statistics data for their own accounts.</p></li></ul><h3 id="RESETACCOUNTSTAT" tabindex="-1"><code>RESETACCOUNTSTAT accountName [ KEY keyName ]</code> <a class="header-anchor" href="#RESETACCOUNTSTAT" aria-label="Permalink to &quot;`RESETACCOUNTSTAT accountName [ KEY keyName ]` {#RESETACCOUNTSTAT}&quot;">​</a></h3><p>Use this command to reset statistics data about the specified Account.</p><ul><li><p><code>accountName : string</code></p><p>This parameter specifies the name of an existing Account. The asterisk (<code>*</code>) symbol can be used to specify the current authenticated Account.</p></li><li><p><code>keyName : string</code></p><p>This optional parameter specifies the name of the statistical entry to reset. If the <code>KEY</code> keyword and the <em>keyName</em> parameter are not specified, all Account statistical entries are reset. To use this command, the user should have the &quot;Basic Settings&quot; Domain Administration right for the target Account Domain.</p></li></ul><p>The following Account statistics data keys are implemented:</p><table tabindex="0"><thead><tr><th>Key name</th><th>Value</th></tr></thead><tbody><tr><td><code>StatReset</code></td><td>The date &amp; time when the last parameterless <code>RESETACCOUNTSTAT</code> command was sent to this Account</td></tr><tr><td><code>MessagesReceived</code></td><td>The total number of messages delivered to the Account</td></tr><tr><td><code>BytesReceived</code></td><td>The total size of all messages delivered to the Account</td></tr><tr><td><code>MessagesSent</code></td><td>The total number of messages sent on the Account behalf</td></tr><tr><td><code>BytesSent</code></td><td>The total size of all messages sent on the Account behalf</td></tr><tr><td><code>CallsReceived</code></td><td>The total number of calls received for the Account</td></tr><tr><td><code>CallsSent</code></td><td>The total number of calls placed on the Account behalf</td></tr><tr><td><code>Logins</code></td><td>The total number of successful Account authentications</td></tr></tbody></table><h3 id="GETDOMAINSTAT" tabindex="-1"><code>GETDOMAINSTAT domainName [ KEY keyName ]</code> <a class="header-anchor" href="#GETDOMAINSTAT" aria-label="Permalink to &quot;`GETDOMAINSTAT domainName [ KEY keyName ]` {#GETDOMAINSTAT}&quot;">​</a></h3><p>Use this command to retrieve statistics data about the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain. The asterisk (<code>*</code>) symbol can be used to specify the Domain of the current authenticated Account.</p></li><li><p><code>keyName : string</code></p><p>This optional parameter specifies the name of the statistical entry to retrieve. This command produces an output - a <em>string</em> with the specified statistical information, or (if the <code>KEY</code> keyword and the <em>keyName</em> parameter are not specified) a <em>dictionary</em> with all available statistical data. To use this command, the user should have the Domain Administration right for the target Domain.</p></li></ul><h3 id="RESETDOMAINSTAT" tabindex="-1"><code>RESETDOMAINSTAT domainName [ KEY keyName ]</code> <a class="header-anchor" href="#RESETDOMAINSTAT" aria-label="Permalink to &quot;`RESETDOMAINSTAT domainName [ KEY keyName ]` {#RESETDOMAINSTAT}&quot;">​</a></h3><p>Use this command to reset statistics data about the specified Domain.</p><ul><li><p><code>domainName : string</code></p><p>This parameter specifies the name of an existing Domain. The asterisk (<code>*</code>) symbol can be used to specify the Domain of the current authenticated Account.</p></li><li><p><code>keyName : string</code></p><p>This optional parameter specifies the name of the statistical entry to reset. If the <code>KEY</code> keyword and the <em>keyName</em> parameter are not specified, all Domain statistical entries are reset. To use this command, the user should have the &quot;Basic Settings&quot; Domain Administration right for the target Domain.</p></li></ul><p>The following Domain statistics data keys are implemented:</p><table tabindex="0"><thead><tr><th>Key name</th><th>Value</th></tr></thead><tbody><tr><td><code>StatReset</code></td><td>The date &amp; time when the last parameterless <code>RESETDOMAINSTAT</code> command was sent to this Domains</td></tr><tr><td><code>MessagesReceived</code></td><td>The total number of messages delivered to the Domain Accounts</td></tr><tr><td><code>BytesReceived</code></td><td>The total size of all messages delivered to the Domain Accounts</td></tr><tr><td><code>MessagesSent</code></td><td>The total number of messages sent on the Domain Accounts behalf</td></tr><tr><td><code>BytesSent</code></td><td>The total size of all messages sent on the Domain Accounts behalf</td></tr><tr><td><code>CallsReceived</code></td><td>The total number of calls received by the Domain Accounts</td></tr><tr><td><code>CallsSent</code></td><td>The total number of calls placed on the Domain Accounts behalf</td></tr></tbody></table><h2 id="Directory" tabindex="-1">Directory Administration <a class="header-anchor" href="#Directory" aria-label="Permalink to &quot;Directory Administration {#Directory}&quot;">​</a></h2><p>A user should have the <a href="./../admin/sysadmin/#Privs">Directory</a> Server access right to use the Directory Administration CLI commands.</p><h3 id="LISTDIRECTORYUNITS" tabindex="-1"><code>LISTDIRECTORYUNITS [ SHARED ]</code> <a class="header-anchor" href="#LISTDIRECTORYUNITS" aria-label="Permalink to &quot;`LISTDIRECTORYUNITS [ SHARED ]` {#LISTDIRECTORYUNITS}&quot;">​</a></h3><p>Use this command to retrieve the list of all Directory units created. If the SHARED keyword is used, the cluster-wide Units are listed.</p><p>This command produces an output - a dictionary, where the keys are Directory Unit mount points, and the values are Directory Unit names.</p><h3 id="CREATEDIRECTORYUNIT" tabindex="-1"><code>CREATEDIRECTORYUNIT unitName [ SHARED ] [ REMOTE ] mountPoint</code> <a class="header-anchor" href="#CREATEDIRECTORYUNIT" aria-label="Permalink to &quot;`CREATEDIRECTORYUNIT unitName [ SHARED ] [ REMOTE ] mountPoint` {#CREATEDIRECTORYUNIT}&quot;">​</a></h3><p>Use this command to create a new Directory Unit.</p><ul><li><p><code>unitName : string</code></p><p>This parameter specifies the new Unit name.</p></li><li><p><code>mountPoint : string</code></p><p>This parameter specifies the new Unit mount point (mount DN). If the SHARED keyword is used, a cluster-wide Directory Unit is created. If the REMOTE keyword is used, a Remote (LDAP-based) Directory Unit is created, otherwise a Local (File-based) Directory Unit is created.</p></li></ul><h3 id="RELOCATEDIRECTORYUNIT" tabindex="-1"><code>RELOCATEDIRECTORYUNIT unitName [ SHARED ] newMountPoint</code> <a class="header-anchor" href="#RELOCATEDIRECTORYUNIT" aria-label="Permalink to &quot;`RELOCATEDIRECTORYUNIT unitName [ SHARED ] newMountPoint` {#RELOCATEDIRECTORYUNIT}&quot;">​</a></h3><p>Use this command to re-mount an existing Directory Unit on a different mount point.</p><ul><li><p><code>unitName : string</code></p><p>This parameter specifies the Directory Unit name. If the SHARED keyword is used, this is a cluster-wide Directory Unit name.</p></li><li><p><code>mountPoint : string</code></p><p>This parameter specifies the new mount point (mount DN).</p></li></ul><h3 id="DELETEDIRECTORYUNIT" tabindex="-1"><code>DELETEDIRECTORYUNIT unitName [ SHARED ]</code> <a class="header-anchor" href="#DELETEDIRECTORYUNIT" aria-label="Permalink to &quot;`DELETEDIRECTORYUNIT unitName [ SHARED ]` {#DELETEDIRECTORYUNIT}&quot;">​</a></h3><p>Use this command to remove an existing Directory Unit.</p><ul><li><p><code>unitName : string</code></p><p>This parameter specifies the Directory Unit name. If the SHARED keyword is used, this is a cluster-wide Directory Unit name.</p></li></ul><h3 id="GETDIRECTORYUNIT" tabindex="-1"><code>GETDIRECTORYUNIT unitName [ SHARED ]</code> <a class="header-anchor" href="#GETDIRECTORYUNIT" aria-label="Permalink to &quot;`GETDIRECTORYUNIT unitName [ SHARED ]` {#GETDIRECTORYUNIT}&quot;">​</a></h3><p>Use this command to retrieve the Directory Unit settings.</p><ul><li><p><code>unitName : string</code></p><p>This parameter specifies the Directory Unit name. If the SHARED keyword is used, this is a cluster-wide Directory Unit name. This command produces an output - a dictionary with the Directory Unit settings.</p></li></ul><h3 id="SETDIRECTORYUNIT" tabindex="-1"><code>SETDIRECTORYUNIT unitName [ SHARED ] newSettings</code> <a class="header-anchor" href="#SETDIRECTORYUNIT" aria-label="Permalink to &quot;`SETDIRECTORYUNIT unitName [ SHARED ] newSettings` {#SETDIRECTORYUNIT}&quot;">​</a></h3><p>Use this command to change the Directory Unit settings.</p><ul><li><p><code>unitName : string</code></p><p>This parameter specifies the Directory Unit name. If the SHARED keyword is used, this is a cluster-wide Directory Unit name.</p></li><li><p><code>newSettings : dictionary</code></p><p>This parameter specifies the new Directory Unit settings.</p></li></ul><h3 id="GETDIRECTORYACCESSRIGHTS" tabindex="-1"><code>GETDIRECTORYACCESSRIGHTS [ SHARED ]</code> <a class="header-anchor" href="#GETDIRECTORYACCESSRIGHTS" aria-label="Permalink to &quot;`GETDIRECTORYACCESSRIGHTS [ SHARED ]` {#GETDIRECTORYACCESSRIGHTS}&quot;">​</a></h3><p>Use this command to retrieve the Directory Access Rights. If the SHARED keyword is used, the cluster-wide Access Rights are retrieved.</p><p>This command produces an output - an array of Access Rights elements.</p><h3 id="SETDIRECTORYACCESSRIGHTS" tabindex="-1"><code>SETDIRECTORYACCESSRIGHTS [ SHARED ] newAccessRights</code> <a class="header-anchor" href="#SETDIRECTORYACCESSRIGHTS" aria-label="Permalink to &quot;`SETDIRECTORYACCESSRIGHTS [ SHARED ] newAccessRights` {#SETDIRECTORYACCESSRIGHTS}&quot;">​</a></h3><p>Use this command to set the Directory Access Rights. If the SHARED keyword is used, the cluster-wide Access Rights are set.</p><ul><li><p><code>newAccessRights : array</code></p><p>This parameter specifies the new Directory Access Rights.</p></li></ul><h2 id="Misc" tabindex="-1">Miscellaneous Commands <a class="header-anchor" href="#Misc" aria-label="Permalink to &quot;Miscellaneous Commands {#Misc}&quot;">​</a></h2><h3 id="LISTCLICOMMANDS" tabindex="-1"><code>LISTCLICOMMANDS</code> <a class="header-anchor" href="#LISTCLICOMMANDS" aria-label="Permalink to &quot;`LISTCLICOMMANDS` {#LISTCLICOMMANDS}&quot;">​</a></h3><p>Use this command to retrieve the list of all CLI commands supported by this version of CommuniGate Pro Server.<br> This command produces an output - an <em>array</em> of strings, where each string is a supported command name.</p><h3 id="NOOP" tabindex="-1"><code>NOOP</code> <a class="header-anchor" href="#NOOP" aria-label="Permalink to &quot;`NOOP` {#NOOP}&quot;">​</a></h3><p>This command always completes successfully.</p><h3 id="ECHO" tabindex="-1"><code>ECHO object</code> <a class="header-anchor" href="#ECHO" aria-label="Permalink to &quot;`ECHO object` {#ECHO}&quot;">​</a></h3><p>This command produces an output - an <em>object</em>, which is the command parameter copy.</p><h3 id="GETVERSION" tabindex="-1"><code>GETVERSION</code> <a class="header-anchor" href="#GETVERSION" aria-label="Permalink to &quot;`GETVERSION` {#GETVERSION}&quot;">​</a></h3><p>This command produces an output - a <em>string</em> with this CommuniGate Pro Server version.</p><h3 id="GETSYSTEMINFO" tabindex="-1"><code>GETSYSTEMINFO what</code> <a class="header-anchor" href="#GETSYSTEMINFO" aria-label="Permalink to &quot;`GETSYSTEMINFO what` {#GETSYSTEMINFO}&quot;">​</a></h3><p>This command produces an output - an <em>object</em> returned by the CG/PL <a href="./CGPL.html">SystemInfo</a> function called with the <em>what</em> parameter.<br> If that function returns a null-object, this command returns an error.</p><h3 id="GETCURRENTTIME" tabindex="-1"><code>GETCURRENTTIME</code> <a class="header-anchor" href="#GETCURRENTTIME" aria-label="Permalink to &quot;`GETCURRENTTIME` {#GETCURRENTTIME}&quot;">​</a></h3><p>This command produces an output - a <em>timestamp</em> with this CommuniGate Pro Server internal timer value.</p><h3 id="SETLOGALL" tabindex="-1"><code>SETLOGALL [ ON | OFF ]</code> <a class="header-anchor" href="#SETLOGALL" aria-label="Permalink to &quot;`SETLOGALL [ ON | OFF ]` {#SETLOGALL}&quot;">​</a></h3><p>Use this command to switch on and off the &quot;Log Everything&quot; mode (this mode can also be enabled by using the <code>--LogAll</code> command line option. To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="DUMPALLOBJECTS" tabindex="-1"><code>DUMPALLOBJECTS [ FILE ]</code> <a class="header-anchor" href="#DUMPALLOBJECTS" aria-label="Permalink to &quot;`DUMPALLOBJECTS [ FILE ]` {#DUMPALLOBJECTS}&quot;">​</a></h3><p>Use this command to write the list of all application data objects.<br> If the FILE keyword is used, then <code>objects_dump.txt</code> file is created in the Server <em>base directory</em> and the list is written to it; if the file already exists then the command does nothing. If the FILE keyword is not used then the list is wtitten into the OS syslog.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This list may contain millions of objects, and this command can easily overload the OS syslog facilities. It also blocks object creation and releasing functionality, effectively suspending CommuniGate Pro Server activities till all objects are listed.</p></div><p>To use this command, the user should have the <code>Master</code> <a href="./../admin/sysadmin/">Server Administration</a> right.</p><h3 id="TESTLOOP" tabindex="-1"><code>TESTLOOP seconds</code> <a class="header-anchor" href="#TESTLOOP" aria-label="Permalink to &quot;`TESTLOOP seconds` {#TESTLOOP}&quot;">​</a></h3><p>Use this command to test the server CPU load. The command executes some calculation loop for the specified number of seconds. This command produces an output - a <em>number</em> that indicates the average CLI thread CPU performance (the number of times the test loop was executed divided by the test time).<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="SETTRACE" tabindex="-1"><code>SETTRACE facility [ ON | OFF ]</code> <a class="header-anchor" href="#SETTRACE" aria-label="Permalink to &quot;`SETTRACE facility [ ON | OFF ]` {#SETTRACE}&quot;">​</a></h3><p>Use this command to switch on and off internal logging facitilies that write to OS syslog. The <em>facility</em> parameter should be a string with one of the folloing supported values:</p><ul><li><p><code>FileIO</code></p><p>record all file read/write/truncate operations</p></li><li><p><code>FileOp</code></p><p>record all file create/rename/remove operations<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p></li></ul><h3 id="WRITELOG" tabindex="-1"><code>WRITELOG logLevel logRecord</code> <a class="header-anchor" href="#WRITELOG" aria-label="Permalink to &quot;`WRITELOG logLevel logRecord` {#WRITELOG}&quot;">​</a></h3><p>Use this command to store a record into the Server Log.</p><ul><li><p><code>logLevel : number</code></p><p>This parameter specifies the record log level.</p></li><li><p><code>logRecord : string</code></p><p>This parameter specifies the string to be placed into the Server Log. Log records generated with this command have the <code>SYSTEM</code> prefix. To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p></li></ul><h3 id="RELEASESMTPQUEUE" tabindex="-1"><code>RELEASESMTPQUEUE queueName</code> <a class="header-anchor" href="#RELEASESMTPQUEUE" aria-label="Permalink to &quot;`RELEASESMTPQUEUE queueName` {#RELEASESMTPQUEUE}&quot;">​</a></h3><p>Use this command to release an SMTP queue.</p><ul><li><p><code>queueName : string</code></p><p>This parameter specifies the queue (domain) name to release. In a Dynamic Cluster environment this command releases the specified SMTP queue on all servers. To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p></li></ul><h3 id="REJECTQUEUEMESSAGE" tabindex="-1"><code>REJECTQUEUEMESSAGE messageID [ REPORT errorText ]</code> <a class="header-anchor" href="#REJECTQUEUEMESSAGE" aria-label="Permalink to &quot;`REJECTQUEUEMESSAGE messageID [ REPORT errorText ]` {#REJECTQUEUEMESSAGE}&quot;">​</a></h3><p>Use this command to reject a message from the Server Queue.</p><ul><li><p><code>messageID : number</code></p><p>This parameter specifies the message ID.</p></li><li><p><code>errorText : string</code></p><p>This optional parameter specifies the text to be included into the error report (bounce) sent to the message sender. If this parameter is <code>NONDN</code>, no DSN report message is generated. To use this command, the user should have the &quot;Can Reject Queues&quot; Server Administration right.</p></li></ul><h3 id="REJECTQUEUEMESSAGES" tabindex="-1"><code>REJECTQUEUEMESSAGES SENDER authedSender [ REPORT errorText ]</code> <a class="header-anchor" href="#REJECTQUEUEMESSAGES" aria-label="Permalink to &quot;`REJECTQUEUEMESSAGES SENDER authedSender [ REPORT errorText ]` {#REJECTQUEUEMESSAGES}&quot;">​</a></h3><p>Use this command to reject all messages sent by the specified sender from the Server Queue.</p><ul><li><p><code>authedSender : string</code></p><p>This parameter specifies the authenticated sender&#39;s name.</p></li><li><p><code>errorText : string</code></p><p>This optional parameter specifies the text to be included into the error report (bounce) sent to the message sender. If this parameter is <code>NONDN</code>, no DSN report message is generated. In a Dynamic Cluster environment this command rejects messages from all server queues. To use this command, the user should have the &quot;Can Reject Queues&quot; Server Administration right.</p></li></ul><h3 id="GETMESSAGEQUEUEINFO" tabindex="-1"><code>GETMESSAGEQUEUEINFO moduleName QUEUE queueName</code> <a class="header-anchor" href="#GETMESSAGEQUEUEINFO" aria-label="Permalink to &quot;`GETMESSAGEQUEUEINFO moduleName QUEUE queueName` {#GETMESSAGEQUEUEINFO}&quot;">​</a></h3><p>Use this command to read information about a module message Queue.</p><ul><li><p><code>moduleName : string</code></p><p>This parameter specifies the module name.</p></li><li><p><code>queueName : string</code></p><p>This parameter specifies the module queue name. This command produces an output - a <em>dictionary</em> with the specified queue information. If the module does not have the specified queue, the dictionary is empty. Otherwise it contains the following elements:</p></li><li><p><code>nTotal</code></p><p>a number - the total number of messages in the queue</p></li><li><p><code>size</code></p><p>a number - the total size of all messages in the queue</p></li><li><p><code>delayedTill</code></p><p>(optional) a timestamp - the effective release time for this queue</p></li><li><p><code>lastError</code></p><p>(optional) a string with the last problem report</p></li></ul><h3 id="GETCURRENTCONTROLLER" tabindex="-1"><code>GETCURRENTCONTROLLER</code> <a class="header-anchor" href="#GETCURRENTCONTROLLER" aria-label="Permalink to &quot;`GETCURRENTCONTROLLER` {#GETCURRENTCONTROLLER}&quot;">​</a></h3><p>Use this command to get the IP address of the current Dynamic Cluster Controller.<br> This command produces an output - a <em>string</em> with the Cluster Controller IP Address.<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="RECONNECTCLUSTERADMIN" tabindex="-1"><code>RECONNECTCLUSTERADMIN</code> <a class="header-anchor" href="#RECONNECTCLUSTERADMIN" aria-label="Permalink to &quot;`RECONNECTCLUSTERADMIN` {#RECONNECTCLUSTERADMIN}&quot;">​</a></h3><p>Use this command to force a Dynamic Cluster member to re-open all its inter-cluster Administrative connections, and (for a non-controller member) to re-open its Administrative connection to the Controller.</p><h3 id="GETTEMPCLIENTIPS" tabindex="-1"><code>GETTEMPCLIENTIPS</code> <a class="header-anchor" href="#GETTEMPCLIENTIPS" aria-label="Permalink to &quot;`GETTEMPCLIENTIPS` {#GETTEMPCLIENTIPS}&quot;">​</a></h3><p>Use this command to retrieve the set of temporary Client IP Addresses. The command produces an output - a <em>string</em> with Temporary Client IP addresses separated with the comma (<code>,</code>) symbols.<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="REPORTFAILEDLOGINADDRESS" tabindex="-1"><code>REPORTFAILEDLOGINADDRESS address</code> <a class="header-anchor" href="#REPORTFAILEDLOGINADDRESS" aria-label="Permalink to &quot;`REPORTFAILEDLOGINADDRESS address` {#REPORTFAILEDLOGINADDRESS}&quot;">​</a></h3><p>Use this command to increment the counter of failed Login attempts from the specified IP address used in the <a href="./../admin/sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> functionality.</p><ul><li><p><code>address : string</code></p><p>The Network IP Address to report. To use this command, the user should have the &quot;Server Settings&quot; Server Administration right.</p></li></ul><h3 id="TEMPBLACKLISTIP" tabindex="-1"><code>TEMPBLACKLISTIP address [ TIMEOUT seconds | DELETE ]</code> <a class="header-anchor" href="#TEMPBLACKLISTIP" aria-label="Permalink to &quot;`TEMPBLACKLISTIP address [ TIMEOUT seconds | DELETE ]` {#TEMPBLACKLISTIP}&quot;">​</a></h3><p>Use this command to add an address to the <a href="./../admin/sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> set.</p><ul><li><p><code>address : string</code></p><p>The Network IP Address to add.</p></li><li><p><code>seconds : number</code></p><p>The time period the address should be blосked for. Use the DELETE keyword or specify zero time period to remove the address from the <a href="./../admin/sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a> set.</p></li></ul><h3 id="GETTEMPBLACKLISTEDIPS" tabindex="-1"><code>GETTEMPBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETTEMPBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETTEMPBLACKLISTEDIPS` {#GETTEMPBLACKLISTEDIPS}&quot;">​</a></h3><p>Use this command to retrieve the set of <a href="./../admin/sysadmin/Protection.html#TempBlock">Temporarily Blocked Addresses</a>. The command produces an output - a <em>string</em> with Temporary Blocked IP addresses separated with the comma (<code>,</code>) symbols.<br> Each IP address may have a <code>-nnnn</code> suffix, where nnnn is either the number of seconds this address will remain blocked for, or the <code>*</code> symbol indicating permanent address blocking.<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="SETTEMPBLACKLISTEDIPS" tabindex="-1"><code>SETTEMPBLACKLISTEDIPS addresses</code> <a class="header-anchor" href="#SETTEMPBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETTEMPBLACKLISTEDIPS addresses` {#SETTEMPBLACKLISTEDIPS}&quot;">​</a></h3><p>Use this command to add addresses to the Temporary Blocked IP Addresses list.</p><ul><li><p><code>addresses : string</code></p><p>A string with a list of IP addresses, using the output format of the <code>GetTempBlacklistedIPs</code> command. To use this command, the user should have the &quot;Server Settings&quot; Server Administration right.</p></li></ul><h3 id="TEMPUNBLOCKIP" tabindex="-1"><code>TEMPUNBLOCKIP address [ TIMEOUT seconds | DELETE ]</code> <a class="header-anchor" href="#TEMPUNBLOCKIP" aria-label="Permalink to &quot;`TEMPUNBLOCKIP address [ TIMEOUT seconds | DELETE ]` {#TEMPUNBLOCKIP}&quot;">​</a></h3><p>Use this command to add an address to the Temporary UnBlockable IP Addresses set.</p><ul><li><p><code>address : string</code></p><p>The Network IP Address to add.</p></li><li><p><code>seconds : number</code></p><p>The time period the address should be in the set. Use the DELETE keyword or specify zero time period to remove the address from the Temporary UnBlockable IP Addresses set.</p></li></ul><h3 id="GETTEMPUNBLOCKABLEIPS" tabindex="-1"><code>GETTEMPUNBLOCKABLEIPS</code> <a class="header-anchor" href="#GETTEMPUNBLOCKABLEIPS" aria-label="Permalink to &quot;`GETTEMPUNBLOCKABLEIPS` {#GETTEMPUNBLOCKABLEIPS}&quot;">​</a></h3><p>Use this command to retrieve the set of Temporary UnBlockable IP Addresses. The command produces an output - a <em>string</em> with Temporary UnBlockable IP addresses separated with the comma (<code>,</code>) symbols.<br> Each IP address may have a <code>-nnnn</code> suffix, where nnnn is either the number of seconds this address will remain in the set, or the <code>*</code> symbol indicating permanent address presence.<br> To use this command, the user should have the &quot;Can Monitor&quot; Server Administration right.</p><h3 id="SETTEMPUNBLOCKABLEIPS" tabindex="-1"><code>SETTEMPUNBLOCKABLEIPS addresses</code> <a class="header-anchor" href="#SETTEMPUNBLOCKABLEIPS" aria-label="Permalink to &quot;`SETTEMPUNBLOCKABLEIPS addresses` {#SETTEMPUNBLOCKABLEIPS}&quot;">​</a></h3><p>Use this command to add addresses to the Temporary UnBlockable IP Addresses set.</p><ul><li><p><code>addresses : string</code></p><p>A string with a list of IP addresses, using the output format of the <code>GetTempUnBlockableIPs</code> command. To use this command, the user should have the &quot;Server Settings&quot; Server Administration right.</p></li></ul><h2 id="Index" tabindex="-1">Index <a class="header-anchor" href="#Index" aria-label="Permalink to &quot;Index {#Index}&quot;">​</a></h2><ul><li><p>Domain Set Administration</p><p><a href="#LISTDOMAINS"><code>LISTDOMAINS</code></a>, <a href="#MAINDOMAINNAME"><code>MAINDOMAINNAME</code></a><br><a href="#GETDOMAINDEFAULTS"><code>GETDOMAINDEFAULTS</code></a>, <a href="#UPDATEDOMAINDEFAULTS"><code>UPDATEDOMAINDEFAULTS</code></a>, <a href="#SETDOMAINDEFAULTS"><code>SETDOMAINDEFAULTS</code></a>, <a href="#GETCLUSTERDOMAINDEFAULTS"><code>GETCLUSTERDOMAINDEFAULTS</code></a>, <a href="#UPDATECLUSTERDOMAINDEFAULTS"><code>UPDATECLUSTERDOMAINDEFAULTS</code></a>, <a href="#SETCLUSTERDOMAINDEFAULTS"><code>SETCLUSTERDOMAINDEFAULTS</code></a><br><a href="#GETSERVERACCOUNTDEFAULTS"><code>GETSERVERACCOUNTDEFAULTS</code></a>, <a href="#UPDATESERVERACCOUNTDEFAULTS"><code>UPDATESERVERACCOUNTDEFAULTS</code></a>, <a href="#SETSERVERACCOUNTDEFAULTS"><code>SETSERVERACCOUNTDEFAULTS</code></a>, <a href="#GETCLUSTERACCOUNTDEFAULTS"><code>GETCLUSTERACCOUNTDEFAULTS</code></a>, <a href="#UPDATECLUSTERACCOUNTDEFAULTS"><code>UPDATECLUSTERACCOUNTDEFAULTS</code></a>, <a href="#SETCLUSTERACCOUNTDEFAULTS"><code>SETCLUSTERACCOUNTDEFAULTS</code></a><br><a href="#GETSERVERACCOUNTPREFS"><code>GETSERVERACCOUNTPREFS</code></a>, <a href="#SETSERVERACCOUNTPREFS"><code>SETSERVERACCOUNTPREFS</code></a>, <a href="#UPDATESERVERACCOUNTPREFS"><code>UPDATESERVERACCOUNTPREFS</code></a>, <a href="#GETCLUSTERACCOUNTPREFS"><code>GETCLUSTERACCOUNTPREFS</code></a>, <a href="#SETCLUSTERACCOUNTPREFS"><code>SETCLUSTERACCOUNTPREFS</code></a>, <a href="#UPDATECLUSTERACCOUNTPREFS"><code>UPDATECLUSTERACCOUNTPREFS</code></a><br><a href="#CREATEDOMAIN"><code>CREATEDOMAIN</code></a>, <a href="#RENAMEDOMAIN"><code>RENAMEDOMAIN</code></a>, <a href="#DELETEDOMAIN"><code>DELETEDOMAIN</code></a>, <a href="#CREATEDIRECTORYDOMAIN"><code>CREATEDIRECTORYDOMAIN</code></a>, <a href="#RELOADDIRECTORYDOMAINS"><code>RELOADDIRECTORYDOMAINS</code></a><br><a href="#LISTSERVERTELNUMS"><code>LISTSERVERTELNUMS</code></a>, <a href="#LISTCLUSTERTELNUMS"><code>LISTCLUSTERTELNUMS</code></a><br><a href="#GETSERVERTRUSTEDCERTS"><code>GETSERVERTRUSTEDCERTS</code></a>, <a href="#SETSERVERTRUSTEDCERTS"><code>SETSERVERTRUSTEDCERTS</code></a>, <a href="#GETCLUSTERTRUSTEDCERTS"><code>GETCLUSTERTRUSTEDCERTS</code></a>, <a href="#SETCLUSTERTRUSTEDCERTS"><code>SETCLUSTERTRUSTEDCERTS</code></a><br><a href="#GETDIRECTORYINTEGRATION"><code>GETDIRECTORYINTEGRATION</code></a>, <a href="#GETCLUSTERDIRECTORYINTEGRATION"><code>GETCLUSTERDIRECTORYINTEGRATION</code></a>, <a href="#SETCLUSTERDIRECTORYINTEGRATION"><code>SETCLUSTERDIRECTORYINTEGRATION</code></a>,<br><a href="#CREATEDOMAINSTORAGE"><code>CREATEDOMAINSTORAGE</code></a>, <a href="#LISTDOMAINSTORAGE"><code>LISTDOMAINSTORAGE</code></a></p></li><li><p>Domain Administration</p><p><a href="#GETDOMAINSETTINGS"><code>GETDOMAINSETTINGS</code></a>, <a href="#GETDOMAINEFFECTIVESETTINGS"><code>GETDOMAINEFFECTIVESETTINGS</code></a>, <a href="#UPDATEDOMAINSETTINGS"><code>UPDATEDOMAINSETTINGS</code></a>, <a href="#SETDOMAINSETTINGS"><code>SETDOMAINSETTINGS</code></a><br><a href="#GETACCOUNTDEFAULTS"><code>GETACCOUNTDEFAULTS</code></a>, <a href="#UPDATEACCOUNTDEFAULTS"><code>UPDATEACCOUNTDEFAULTS</code></a>, <a href="#SETACCOUNTDEFAULTS"><code>SETACCOUNTDEFAULTS</code></a><br><a href="#GETACCOUNTDEFAULTPREFS"><code>GETACCOUNTDEFAULTPREFS</code></a>, <a href="#UPDATEACCOUNTDEFAULTPREFS"><code>UPDATEACCOUNTDEFAULTPREFS</code></a>, <a href="#SETACCOUNTDEFAULTPREFS"><code>SETACCOUNTDEFAULTPREFS</code></a><br><a href="#GETDOMAINALIASES"><code>GETDOMAINALIASES</code></a>, <a href="#SETDOMAINALIASES"><code>SETDOMAINALIASES</code></a><br><a href="#GETACCOUNTTEMPLATE"><code>GETACCOUNTTEMPLATE</code></a>, <a href="#UPDATEACCOUNTTEMPLATE"><code>UPDATEACCOUNTTEMPLATE</code></a>, <a href="#SETACCOUNTTEMPLATE"><code>SETACCOUNTTEMPLATE</code></a><br><a href="#GETDOMAINMAILRULES"><code>GETDOMAINMAILRULES</code></a>, <a href="#SETDOMAINMAILRULES"><code>SETDOMAINMAILRULES</code></a>, <a href="#GETDOMAINSIGNALRULES"><code>GETDOMAINSIGNALRULES</code></a>, <a href="#SETDOMAINSIGNALRULES"><code>SETDOMAINSIGNALRULES</code></a>,<br><a href="#LISTADMINDOMAINS"><code>LISTADMINDOMAINS</code></a><br><a href="#LISTDOMAINOBJECTS"><code>LISTDOMAINOBJECTS</code></a>, <a href="#LISTACCOUNTS"><code>LISTACCOUNTS</code></a>, <a href="#LISTDOMAINTELNUMS"><code>LISTDOMAINTELNUMS</code></a><br><a href="#INSERTDIRECTORYRECORDS"><code>INSERTDIRECTORYRECORDS</code></a>, <a href="#DELETEDIRECTORYRECORDS"><code>DELETEDIRECTORYRECORDS</code></a><br><a href="#GETDOMAINLOCATION"><code>GETDOMAINLOCATION</code></a>, <a href="#CREATEACCOUNTSTORAGE"><code>CREATEACCOUNTSTORAGE</code></a>, <a href="#LISTACCOUNTSTORAGE"><code>LISTACCOUNTSTORAGE</code></a>,<br><a href="#SUSPENDDOMAIN"><code>SUSPENDDOMAIN</code></a>, <a href="#RESUMEDOMAIN"><code>RESUMEDOMAIN</code></a></p></li><li><p>Account Administration</p><p><a href="#CREATEACCOUNT"><code>CREATEACCOUNT</code></a>, <a href="#RENAMEACCOUNT"><code>RENAMEACCOUNT</code></a>, <a href="#DELETEACCOUNT"><code>DELETEACCOUNT</code></a>, <a href="#BLOCKACCOUNT"><code>BLOCKACCOUNT</code></a>, <a href="#UNBLOCKACCOUNT"><code>UNBLOCKACCOUNT</code></a><br><a href="#SETACCOUNTTYPE"><code>SETACCOUNTTYPE</code></a>, <a href="#GETACCOUNTSETTINGS"><code>GETACCOUNTSETTINGS</code></a>, <a href="#UPDATEACCOUNTSETTINGS"><code>UPDATEACCOUNTSETTINGS</code></a>, <a href="#GETACCOUNTEFFECTIVESETTINGS"><code>GETACCOUNTEFFECTIVESETTINGS</code></a>, <a href="#GETACCOUNTONESETTING"><code>GETACCOUNTONESETTING</code></a>, <a href="#SETACCOUNTSETTINGS"><code>SETACCOUNTSETTINGS</code></a><br><a href="#SETACCOUNTPASSWORD"><code>SETACCOUNTPASSWORD</code></a>, <a href="#VERIFYACCOUNTPASSWORD"><code>VERIFYACCOUNTPASSWORD</code></a>, <a href="#VERIFYACCOUNTIDENTITY"><code>VERIFYACCOUNTIDENTITY</code></a><br><a href="#GETACCOUNTALIASES"><code>GETACCOUNTALIASES</code></a>, <a href="#SETACCOUNTALIASES"><code>SETACCOUNTALIASES</code></a>, <a href="#GETACCOUNTTELNUMS"><code>GETACCOUNTTELNUMS</code></a>, <a href="#SETACCOUNTTELNUMS"><code>SETACCOUNTTELNUMS</code></a> <a href="#MODIFYACCOUNTTELNUMS"><code>MODIFYACCOUNTTELNUMS</code></a><br><a href="#GETACCOUNTMAILRULES"><code>GETACCOUNTMAILRULES</code></a>, <a href="#SETACCOUNTMAILRULES"><code>SETACCOUNTMAILRULES</code></a>, <a href="#GETACCOUNTSIGNALRULES"><code>GETACCOUNTSIGNALRULES</code></a>, <a href="#SETACCOUNTSIGNALRULES"><code>SETACCOUNTSIGNALRULES</code></a>, <a href="#UPDATEACCOUNTMAILRULE"><code>UPDATEACCOUNTMAILRULE</code></a>, <a href="#UPDATEACCOUNTSIGNALRULE"><code>UPDATEACCOUNTSIGNALRULE</code></a>,<br><a href="#GETACCOUNTRPOPS"><code>GETACCOUNTRPOPS</code></a>, <a href="#SETACCOUNTRPOPS"><code>SETACCOUNTRPOPS</code></a>, <a href="#GETACCOUNTRSIPS"><code>GETACCOUNTRSIPS</code></a>, <a href="#SETACCOUNTRSIPS"><code>SETACCOUNTRSIPS</code></a>, <a href="#UPDATESCHEDULEDTASK"><code>UPDATESCHEDULEDTASK</code></a>, <a href="#GETACCOUNTRIGHTS"><code>GETACCOUNTRIGHTS</code></a>, <a href="#GETACCOUNTINFO"><code>GETACCOUNTINFO</code></a><br><a href="#GETACCOUNTPREFS"><code>GETACCOUNTPREFS</code></a>, <a href="#UPDATEACCOUNTPREFS"><code>UPDATEACCOUNTPREFS</code></a>, <a href="#SETACCOUNTPREFS"><code>SETACCOUNTPREFS</code></a>, <a href="#GETACCOUNTEFFECTIVEPREFS"><code>GETACCOUNTEFFECTIVEPREFS</code></a><br><a href="#KILLACCOUNTSESSIONS"><code>KILLACCOUNTSESSIONS</code></a><br><a href="#GETACCOUNTACL"><code>GETACCOUNTACL</code></a>, <a href="#SETACCOUNTACL"><code>SETACCOUNTACL</code></a>, <a href="#GETACCOUNTACLRIGHTS"><code>GETACCOUNTACLRIGHTS</code></a><br><a href="#GETACCOUNTLOCATION"><code>GETACCOUNTLOCATION</code></a> <a href="#GETACCOUNTPRESENCE"><code>GETACCOUNTPRESENCE</code></a></p></li><li><p>Group Administration</p><p><a href="#LISTGROUPS"><code>LISTGROUPS</code></a>, <a href="#CREATEGROUP"><code>CREATEGROUP</code></a>, <a href="#RENAMEGROUP"><code>RENAMEGROUP</code></a>, <a href="#DELETEGROUP"><code>DELETEGROUP</code></a>, <a href="#GETGROUP"><code>GETGROUP</code></a>, <a href="#SETGROUP"><code>SETGROUP</code></a></p></li><li><p>Forwarder Administration</p><p><a href="#LISTFORWARDERS"><code>LISTFORWARDERS</code></a>, <a href="#CREATEFORWARDER"><code>CREATEFORWARDER</code></a>, <a href="#RENAMEFORWARDER"><code>RENAMEFORWARDER</code></a>, <a href="#DELETEFORWARDER"><code>DELETEFORWARDER</code></a>, <a href="#GETFORWARDER"><code>GETFORWARDER</code></a> <a href="#FINDFORWARDERS"><code>FINDFORWARDERS</code></a></p></li><li><p>Named Task Administration</p><p><a href="#LISTDOMAINNAMEDTASKS"><code>LISTDOMAINNAMEDTASKS</code></a>, <a href="#LISTACCOUNTNAMEDTASKS"><code>LISTACCOUNTNAMEDTASKS</code></a>, <a href="#CREATENAMEDTASK"><code>CREATENAMEDTASK</code></a>, <a href="#RENAMENAMEDTASK"><code>RENAMENAMEDTASK</code></a>, <a href="#DELETENAMEDTASK"><code>DELETENAMEDTASK</code></a>, <a href="#GETNAMEDTASK"><code>GETNAMEDTASK</code></a>, <a href="#UPDATENAMEDTASK"><code>UPDATENAMEDTASK</code></a></p></li><li><p>Access Rights Administration</p><p><a href="#SETACCOUNTRIGHTS"><code>SETACCOUNTRIGHTS</code></a></p></li><li><p>Mailbox Administration</p><p><a href="#LISTMAILBOXES"><code>LISTMAILBOXES</code></a>, <a href="#CREATEMAILBOX"><code>CREATEMAILBOX</code></a>, <a href="#DELETEMAILBOX"><code>DELETEMAILBOX</code></a>, <a href="#RENAMEMAILBOX"><code>RENAMEMAILBOX</code></a>, <a href="#SETMAILBOXCLASS"><code>SETMAILBOXCLASS</code></a><br><a href="#GETMAILBOXINFO"><code>GETMAILBOXINFO</code></a>, <a href="#GETMAILBOXACL"><code>GETMAILBOXACL</code></a>, <a href="#SETMAILBOXACL"><code>SETMAILBOXACL</code></a>, <a href="#GETMAILBOXRIGHTS"><code>GETMAILBOXRIGHTS</code></a><br><a href="#GETMAILBOXSUBSCRIPTION"><code>GETMAILBOXSUBSCRIPTION</code></a>, <a href="#SETMAILBOXSUBSCRIPTION"><code>SETMAILBOXSUBSCRIPTION</code></a><br><a href="#GETMAILBOXALIASES"><code>GETMAILBOXALIASES</code></a>, <a href="#SETMAILBOXALIASES"><code>SETMAILBOXALIASES</code></a></p></li><li><p>Alert Administration</p><p><a href="#GETDOMAINALERTS"><code>GETDOMAINALERTS</code></a>, <a href="#SETDOMAINALERTS"><code>SETDOMAINALERTS</code></a>, <a href="#POSTDOMAINALERT"><code>POSTDOMAINALERT</code></a>, <a href="#REMOVEDOMAINALERT"><code>REMOVEDOMAINALERT</code></a><br><a href="#GETACCOUNTALERTS"><code>GETACCOUNTALERTS</code></a>, <a href="#SETACCOUNTALERTS"><code>SETACCOUNTALERTS</code></a>, <a href="#POSTACCOUNTALERT"><code>POSTACCOUNTALERT</code></a>, <a href="#REMOVEACCOUNTALERT"><code>REMOVEACCOUNTALERT</code></a><br><a href="#GETSERVERALERTS"><code>GETSERVERALERTS</code></a>, <a href="#SETSERVERALERTS"><code>SETSERVERALERTS</code></a>, <a href="#POSTSERVERALERT"><code>POSTSERVERALERT</code></a>, <a href="#REMOVESERVERALERT"><code>REMOVESERVERALERT</code></a>, <a href="#GETCLUSTERALERTS"><code>GETCLUSTERALERTS</code></a>, <a href="#SETCLUSTERALERTS"><code>SETCLUSTERALERTS</code></a>, <a href="#POSTCLUSTERALERT"><code>POSTCLUSTERALERT</code></a>, <a href="#REMOVECLUSTERALERT"><code>REMOVECLUSTERALERT</code></a></p></li><li><p>File Storage Administration</p><p><a href="#READSTORAGEFILE"><code>READSTORAGEFILE</code></a>, <a href="#WRITESTORAGEFILE"><code>WRITESTORAGEFILE</code></a>, <a href="#RENAMESTORAGEFILE"><code>RENAMESTORAGEFILE</code></a>, <a href="#DELETESTORAGEFILE"><code>DELETESTORAGEFILE</code></a>, <a href="#LISTSTORAGEFILES"><code>LISTSTORAGEFILES</code></a>, <a href="#GETSTORAGEFILEINFO"><code>GETSTORAGEFILEINFO</code></a> <a href="#READSTORAGEFILEATTR"><code>READSTORAGEFILEATTR</code></a> <a href="#UPDATESTORAGEFILEATTR"><code>UPDATESTORAGEFILEATTR</code></a> <a href="#GETFILESUBSCRIPTION"><code>GETFILESUBSCRIPTION</code></a> <a href="#SETFILESUBSCRIPTION"><code>SETFILESUBSCRIPTION</code></a></p></li><li><p>Mailing Lists Administration</p><p><a href="#LISTLISTS"><code>LISTLISTS</code></a>, <a href="#GETDOMAINLISTS"><code>GETDOMAINLISTS</code></a>, <a href="#GETACCOUNTLISTS"><code>GETACCOUNTLISTS</code></a><br><a href="#CREATELIST"><code>CREATELIST</code></a>, <a href="#RENAMELIST"><code>RENAMELIST</code></a>, <a href="#DELETELIST"><code>DELETELIST</code></a>, <a href="#GETLIST"><code>GETLIST</code></a>, <a href="#UPDATELIST"><code>UPDATELIST</code></a><br><a href="#LIST"><code>LIST</code></a>, <a href="#LISTSUBSCRIBERS"><code>LISTSUBSCRIBERS</code></a>, <a href="#READSUBSCRIBERS"><code>READSUBSCRIBERS</code></a><br><a href="#GETSUBSCRIBERINFO"><code>GETSUBSCRIBERINFO</code></a>, <a href="#SETPOSTINGMODE"><code>SETPOSTINGMODE</code></a>, <a href="#PROCESSBOUNCE"><code>PROCESSBOUNCE</code></a></p></li><li><p>Web Skins Administration</p><p><a href="#LISTDOMAINSKINS"><code>LISTDOMAINSKINS</code></a>, <a href="#CREATEDOMAINSKIN"><code>CREATEDOMAINSKIN</code></a>, <a href="#RENAMEDOMAINSKIN"><code>RENAMEDOMAINSKIN</code></a>, <a href="#DELETEDOMAINSKIN"><code>DELETEDOMAINSKIN</code></a>, <a href="#LISTDOMAINSKINFILES"><code>LISTDOMAINSKINFILES</code></a>, <a href="#READDOMAINSKINFILE"><code>READDOMAINSKINFILE</code></a>, <a href="#STOREDOMAINSKINFILE"><code>STOREDOMAINSKINFILE</code></a><br><a href="#LISTSERVERSKINS"><code>LISTSERVERSKINS</code></a>, <a href="#CREATESERVERSKIN"><code>CREATESERVERSKIN</code></a>, <a href="#RENAMESERVERSKIN"><code>RENAMESERVERSKIN</code></a>, <a href="#DELETESERVERSKIN"><code>DELETESERVERSKIN</code></a>, <a href="#LISTSERVERSKINFILES"><code>LISTSERVERSKINFILES</code></a>, <a href="#READSERVERSKINFILE"><code>READSERVERSKINFILE</code></a>, <a href="#STORESERVERSKINFILE"><code>STORESERVERSKINFILE</code></a><br><a href="#LISTCLUSTERSKINS"><code>LISTCLUSTERSKINS</code></a>, <a href="#CREATECLUSTERSKIN"><code>CREATECLUSTERSKIN</code></a>, <a href="#RENAMECLUSTERSKIN"><code>RENAMECLUSTERSKIN</code></a>, <a href="#DELETECLUSTERSKIN"><code>DELETECLUSTERSKIN</code></a>, <a href="#LISTCLUSTERSKINFILES"><code>LISTCLUSTERSKINFILES</code></a>, <a href="#READCLUSTERSKINFILE"><code>READCLUSTERSKINFILE</code></a>, <a href="#STORECLUSTERSKINFILE"><code>STORECLUSTERSKINFILE</code></a><br><a href="#LISTSTOCKSKINFILES"><code>LISTSTOCKSKINFILES</code></a>, <a href="#READSTOCKSKINFILE"><code>READSTOCKSKINFILE</code></a></p></li><li><p>Web Interface Integration</p><p><a href="#CREATEWEBUSERSESSION"><code>CREATEWEBUSERSESSION</code></a>, <a href="#CREATEXIMSSSESSION"><code>CREATEXIMSSSESSION</code></a>, <a href="#CREATELITESESSION"><code>CREATELITESESSION</code></a>, <a href="#FINDACCOUNTSESSION"><code>FINDACCOUNTSESSION</code></a>, <a href="#LISTACCOUNTSESSIONS"><code>LISTACCOUNTSESSIONS</code></a>, <a href="#LISTLITESESSIONS"><code>LISTLITESESSIONS</code></a>, <a href="#GETSESSION"><code>GETSESSION</code></a>, <a href="#UPDATESESSION"><code>UPDATESESSION</code></a>, <a href="#KILLSESSION"><code>KILLSESSION</code></a>, <a href="#BLESSSESSION"><code>BLESSSESSION</code></a></p></li><li><p>Real-Time Application Administration</p><p><a href="#CREATEDOMAINPBX"><code>CREATEDOMAINPBX</code></a>, <a href="#DELETEDOMAINPBX"><code>DELETEDOMAINPBX</code></a>, <a href="#LISTDOMAINPBXFILES"><code>LISTDOMAINPBXFILES</code></a>, <a href="#READDOMAINPBXFILE"><code>READDOMAINPBXFILE</code></a>, <a href="#STOREDOMAINPBXFILE"><code>STOREDOMAINPBXFILE</code></a><br><a href="#CREATESERVERPBX"><code>CREATESERVERPBX</code></a>, <a href="#DELETESERVERPBX"><code>DELETESERVERPBX</code></a>, <a href="#LISTSERVERPBXFILES"><code>LISTSERVERPBXFILES</code></a>, <a href="#READSERVERPBXFILE"><code>READSERVERPBXFILE</code></a>, <a href="#STORESERVERPBXFILE"><code>STORESERVERPBXFILE</code></a><br><a href="#CREATECLUSTERPBX"><code>CREATECLUSTERPBX</code></a>, <a href="#DELETECLUSTERPBX"><code>DELETECLUSTERPBX</code></a>, <a href="#LISTCLUSTERPBXFILES"><code>LISTCLUSTERPBXFILES</code></a>, <a href="#READCLUSTERPBXFILE"><code>READCLUSTERPBXFILE</code></a>, <a href="#STORECLUSTERPBXFILE"><code>STORECLUSTERPBXFILE</code></a><br><a href="#LISTSTOCKPBXFILES"><code>LISTSTOCKPBXFILES</code></a>, <a href="#READSTOCKPBXFILE"><code>READSTOCKPBXFILE</code></a></p></li><li><p>Real-Time Application Control</p><p><a href="#STARTPBXTASK"><code>STARTPBXTASK</code></a>, <a href="#SENDTASKEVENT"><code>SENDTASKEVENT</code></a>, <a href="#KILLNODE"><code>KILLNODE</code></a>, <a href="#READNODESTATUS"><code>READNODESTATUS</code></a></p></li><li><p>Full-Text Search</p><p><a href="#BUILDDOMAINSEARCHINDEX"><code>BUILDDOMAINSEARCHINDEX</code></a>, <a href="#GETDOMAINSEARCHINDEXSTATE"><code>GETDOMAINSEARCHINDEXSTATE</code></a>, <a href="#REMOVEDOMAINSEARCHINDEX"><code>REMOVEDOMAINSEARCHINDEX</code></a>, <a href="#BUILDACCOUNTSEARCHINDEX"><code>BUILDACCOUNTSEARCHINDEX</code></a>, <a href="#GETACCOUNTSEARCHINDEXSTATE"><code>GETACCOUNTSEARCHINDEXSTATE</code></a>, <a href="#GETACCOUNTSEARCHINDEXSIZE"><code>GETACCOUNTSEARCHINDEXSIZE</code></a>, <a href="#REMOVEACCOUNTSEARCHINDEX"><code>REMOVEACCOUNTSEARCHINDEX</code></a>, <a href="#SEARCHININDEX"><code>SEARCHININDEX</code></a>, <a href="#BUILDGROUPSEARCHINDEX"><code>BUILDGROUPSEARCHINDEX</code></a></p></li><li><p>Synchronous Scripts</p><p><a href="#RUNSCRIPT"><code>RUNSCRIPT</code></a></p></li><li><p>Account Services</p><p><a href="#REMOVEACCOUNTSUBSET"><code>REMOVEACCOUNTSUBSET</code></a> <a href="#DATASET"><code>DATASET</code></a> <a href="#ROSTER"><code>ROSTER</code></a> <a href="#BALANCE"><code>BALANCE</code></a></p></li><li><p>Server Settings</p><p><a href="#LISTMODULES"><code>LISTMODULES</code></a>, <a href="#GETMODULE"><code>GETMODULE</code></a>, <a href="#SETMODULE"><code>SETMODULE</code></a>, <a href="#UPDATEMODULE"><code>UPDATEMODULE</code></a><br><a href="#GETQUEUESETTINGS"><code>GETQUEUESETTINGS</code></a>, <a href="#SETQUEUESETTINGS"><code>SETQUEUESETTINGS</code></a>, <a href="#GETSIGNALSETTINGS"><code>GETSIGNALSETTINGS</code></a>, <a href="#SETSIGNALSETTINGS"><code>SETSIGNALSETTINGS</code></a>, <a href="#GETMEDIASERVERSETTINGS"><code>GETMEDIASERVERSETTINGS</code></a>, <a href="#SETMEDIASERVERSETTINGS"><code>SETMEDIASERVERSETTINGS</code></a><br><a href="#GETSESSIONSETTINGS"><code>GETSESSIONSETTINGS</code></a>, <a href="#SETSESSIONSETTINGS"><code>SETSESSIONSETTINGS</code></a><br><a href="#GETCLUSTERSETTINGS"><code>GETCLUSTERSETTINGS</code></a>, <a href="#SETCLUSTERSETTINGS"><code>SETCLUSTERSETTINGS</code></a><br><a href="#GETLOGSETTINGS"><code>GETLOGSETTINGS</code></a>, <a href="#UPDATELOGSETTINGS"><code>UPDATELOGSETTINGS</code></a><br><a href="#GETNETWORK"><code>GETNETWORK</code></a>, <a href="#SETNETWORK"><code>SETNETWORK</code></a>, <a href="#GETCLUSTERNETWORK"><code>GETCLUSTERNETWORK</code></a>, <a href="#SETCLUSTERNETWORK"><code>SETCLUSTERNETWORK</code></a><br><a href="#GETDNRSETTINGS"><code>GETDNRSETTINGS</code></a>, <a href="#SETDNRSETTINGS"><code>SETDNRSETTINGS</code></a>,<br><a href="#GETBANNED"><code>GETBANNED</code></a>, <a href="#GETCLUSTERBANNED"><code>GETCLUSTERBANNED</code></a>, <a href="#SETBANNED"><code>SETBANNED</code></a>, <a href="#SETCLUSTERBANNED"><code>SETCLUSTERBANNED</code></a><br><a href="#GETSERVERMAILRULES"><code>GETSERVERMAILRULES</code></a>, <a href="#SETSERVERMAILRULES"><code>SETSERVERMAILRULES</code></a>, <a href="#GETCLUSTERMAILRULES"><code>GETCLUSTERMAILRULES</code></a>, <a href="#SETCLUSTERMAILRULES"><code>SETCLUSTERMAILRULES</code></a><br><a href="#GETSERVERSIGNALRULES"><code>GETSERVERSIGNALRULES</code></a>, <a href="#SETSERVERSIGNALRULES"><code>SETSERVERSIGNALRULES</code></a>, <a href="#GETCLUSTERSIGNALRULES"><code>GETCLUSTERSIGNALRULES</code></a>, <a href="#SETCLUSTERSIGNALRULES"><code>SETCLUSTERSIGNALRULES</code></a><br><a href="#GETROUTERTABLE"><code>GETROUTERTABLE</code></a>, <a href="#SETROUTERTABLE"><code>SETROUTERTABLE</code></a>, <a href="#GETCLUSTERROUTERTABLE"><code>GETCLUSTERROUTERTABLE</code></a>, <a href="#SETCLUSTERROUTERTABLE"><code>SETCLUSTERROUTERTABLE</code></a><br><a href="#GETROUTERSETTINGS"><code>GETROUTERSETTINGS</code></a>, <a href="#SETROUTERSETTINGS"><code>SETROUTERSETTINGS</code></a>, <a href="#GETCLUSTERROUTERSETTINGS"><code>GETCLUSTERROUTERSETTINGS</code></a>, <a href="#SETCLUSTERROUTERSETTINGS"><code>SETCLUSTERROUTERSETTINGS</code></a><br><a href="#REFRESHOSDATA"><code>REFRESHOSDATA</code></a><br><a href="#GETLANIPS"><code>GETLANIPS</code></a>, <a href="#SETLANIPS"><code>SETLANIPS</code></a>, <a href="#GETCLUSTERLANIPS"><code>GETCLUSTERLANIPS</code></a>, <a href="#SETCLUSTERLANIPS"><code>SETCLUSTERLANIPS</code></a><br><a href="#GETPROXYIPS"><code>GETPROXYIPS</code></a>, <a href="#SETPROXYIPS"><code>SETPROXYIPS</code></a>, <a href="#GETCLUSTERPROXYIPS"><code>GETCLUSTERPROXYIPS</code></a>, <a href="#SETCLUSTERPROXYIPS"><code>SETCLUSTERPROXYIPS</code></a><br><a href="#GETCLIENTIPS"><code>GETCLIENTIPS</code></a>, <a href="#SETCLIENTIPS"><code>SETCLIENTIPS</code></a>, <a href="#GETCLUSTERCLIENTIPS"><code>GETCLUSTERCLIENTIPS</code></a>, <a href="#SETCLUSTERCLIENTIPS"><code>SETCLUSTERCLIENTIPS</code></a><br><a href="#GETBLACKLISTEDIPS"><code>GETBLACKLISTEDIPS</code></a>, <a href="#SETBLACKLISTEDIPS"><code>SETBLACKLISTEDIPS</code></a>, <a href="#GETCLUSTERBLACKLISTEDIPS"><code>GETCLUSTERBLACKLISTEDIPS</code></a>, <a href="#SETCLUSTERBLACKLISTEDIPS"><code>SETCLUSTERBLACKLISTEDIPS</code></a><br><a href="#GETWHITEHOLEIPS"><code>GETWHITEHOLEIPS</code></a>, <a href="#SETWHITEHOLEIPS"><code>SETWHITEHOLEIPS</code></a>, <a href="#GETCLUSTERWHITEHOLEIPS"><code>GETCLUSTERWHITEHOLEIPS</code></a>, <a href="#SETCLUSTERWHITEHOLEIPS"><code>SETCLUSTERWHITEHOLEIPS</code></a><br><a href="#GETNATEDIPS"><code>GETNATEDIPS</code></a>, <a href="#SETNATEDIPS"><code>SETNATEDIPS</code></a>, <a href="#GETCLUSTERNATEDIPS"><code>GETCLUSTERNATEDIPS</code></a>, <a href="#SETCLUSTERNATEDIPS"><code>SETCLUSTERNATEDIPS</code></a><br><a href="#GETNATSITEIPS"><code>GETNATSITEIPS</code></a>, <a href="#SETNATSITEIPS"><code>SETNATSITEIPS</code></a>, <a href="#GETCLUSTERNATSITEIPS"><code>GETCLUSTERNATSITEIPS</code></a>, <a href="#SETCLUSTERNATSITEIPS"><code>SETCLUSTERNATSITEIPS</code></a><br><a href="#GETDEBUGIPS"><code>GETDEBUGIPS</code></a>, <a href="#SETDEBUGIPS"><code>SETDEBUGIPS</code></a>, <a href="#GETCLUSTERDEBUGIPS"><code>GETCLUSTERDEBUGIPS</code></a>, <a href="#SETCLUSTERDEBUGIPS"><code>SETCLUSTERDEBUGIPS</code></a><br><a href="#GETDENIEDIPS"><code>GETDENIEDIPS</code></a>, <a href="#SETDENIEDIPS"><code>SETDENIEDIPS</code></a>, <a href="#GETCLUSTERDENIEDIPS"><code>GETCLUSTERDENIEDIPS</code></a>, <a href="#SETCLUSTERDENIEDIPS"><code>SETCLUSTERDENIEDIPS</code></a><br><a href="#ROUTE"><code>ROUTE</code></a> <a href="#GETIPSTATE"><code>GETIPSTATE</code></a><br><a href="#GETSERVERINTERCEPT"><code>GETSERVERINTERCEPT</code></a>, <a href="#SETSERVERINTERCEPT"><code>SETSERVERINTERCEPT</code></a>, <a href="#GETCLUSTERINTERCEPT"><code>GETCLUSTERINTERCEPT</code></a>, <a href="#SETCLUSTERINTERCEPT"><code>SETCLUSTERINTERCEPT</code></a><br><a href="#GETSERVERSETTINGS"><code>GETSERVERSETTINGS</code></a> <a href="#UPDATESERVERSETTINGS"><code>UPDATESERVERSETTINGS</code></a></p></li><li><p>Monitoring</p><p><a href="#GETSTATELEMENT"><code>GETSTATELEMENT</code></a>, <a href="#SETSTATELEMENT"><code>SETSTATELEMENT</code></a>, <a href="#GETNEXTSTATNAME"><code>GETNEXTSTATNAME</code></a>, <a href="#GETDIALOGINFO"><code>GETDIALOGINFO</code></a>, <a href="#SHUTDOWN"><code>SHUTDOWN</code></a></p></li><li><p>Statistics</p><p><a href="#GETACCOUNTSTAT"><code>GETACCOUNTSTAT</code></a>, <a href="#RESETACCOUNTSTAT"><code>RESETACCOUNTSTAT</code></a>, <a href="#GETDOMAINSTAT"><code>GETDOMAINSTAT</code></a>, <a href="#RESETDOMAINSTAT"><code>RESETDOMAINSTAT</code></a></p></li><li><p>Directory Administration</p><p><a href="#LISTDIRECTORYUNITS"><code>LISTDIRECTORYUNITS</code></a>, <a href="#CREATEDIRECTORYUNIT"><code>CREATEDIRECTORYUNIT</code></a>, <a href="#RELOCATEDIRECTORYUNIT"><code>RELOCATEDIRECTORYUNIT</code></a>, <a href="#DELETEDIRECTORYUNIT"><code>DELETEDIRECTORYUNIT</code></a>, <a href="#GETDIRECTORYUNIT"><code>GETDIRECTORYUNIT</code></a>, <a href="#SETDIRECTORYUNIT"><code>SETDIRECTORYUNIT</code></a>, <a href="#GETDIRECTORYACCESSRIGHTS"><code>GETDIRECTORYACCESSRIGHTS</code></a>, <a href="#SETDIRECTORYACCESSRIGHTS"><code>SETDIRECTORYACCESSRIGHTS</code></a></p></li><li><p>Miscellaneous Commands</p><p><a href="#LISTCLICOMMANDS"><code>LISTCLICOMMANDS</code></a>, <a href="#NOOP"><code>NOOP</code></a>, <a href="#ECHO"><code>ECHO</code></a>, <a href="#GETVERSION"><code>GETVERSION</code></a>, <a href="#GETSYSTEMINFO"><code>GETSYSTEMINFO</code></a>, <a href="#GETCURRENTTIME"><code>GETCURRENTTIME</code></a>, <a href="#SETLOGALL"><code>SETLOGALL</code></a>, <a href="#DUMPALLOBJECTS"><code>DUMPALLOBJECTS</code></a>, <a href="#TESTLOOP"><code>TESTLOOP</code></a>, <a href="#WRITELOG"><code>WRITELOG</code></a>, <a href="#RELEASESMTPQUEUE"><code>RELEASESMTPQUEUE</code></a>, <a href="#REJECTQUEUEMESSAGE"><code>REJECTQUEUEMESSAGE</code></a>, <a href="#REJECTQUEUEMESSAGES"><code>REJECTQUEUEMESSAGES</code></a>, <a href="#GETMESSAGEQUEUEINFO"><code>GETMESSAGEQUEUEINFO</code></a>, <a href="#GETCURRENTCONTROLLER"><code>GETCURRENTCONTROLLER</code></a>, <a href="#RECONNECTCLUSTERADMIN"><code>RECONNECTCLUSTERADMIN</code></a>,<br><a href="#GETTEMPCLIENTIPS"><code>GETTEMPCLIENTIPS</code></a>, <a href="#REPORTFAILEDLOGINADDRESS"><code>REPORTFAILEDLOGINADDRESS</code></a>,<br><a href="#TEMPBLACKLISTIP"><code>TEMPBLACKLISTIP</code></a>, <a href="#GETTEMPBLACKLISTEDIPS"><code>GETTEMPBLACKLISTEDIPS</code></a>, <a href="#SETTEMPBLACKLISTEDIPS"><code>SETTEMPBLACKLISTEDIPS</code></a>,<br><a href="#TEMPUNBLOCKIP"><code>TEMPUNBLOCKIP</code></a>, <a href="#GETTEMPUNBLOCKABLEIPS"><code>GETTEMPUNBLOCKABLEIPS</code></a>, <a href="#SETTEMPUNBLOCKABLEIPS"><code>SETTEMPUNBLOCKABLEIPS</code></a></p></li></ul>',1083)]))}const T=a(s,[["render",n]]);export{m as __pageData,T as default};
