import{_ as t,c as n,o as a,ag as s}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Helper Applications","description":"","frontmatter":{"legacyLink":"Helpers.html"},"headers":[],"relativePath":"development/Helpers.md","filePath":"development/Helpers.md"}'),o={name:"development/Helpers.md"};function r(i,e,p,l,d,c){return a(),n("div",null,e[0]||(e[0]=[s(`<h1 id="helper-applications" tabindex="-1">Helper Applications <a class="header-anchor" href="#helper-applications" aria-label="Permalink to &quot;Helper Applications&quot;">​</a></h1><p>The CommuniGate Pro Server can use external programs to implement various operations - <a href="./../admin/mail/ExternalFilters.html">message scanning</a>, <a href="./../admin/sysadmin/Security.html">user authentication</a>, <a href="./../admin/services/RADIUS.html">RADIUS</a> login policies, etc. All these external programs are handled in the same way, and they communicate with the Server using a simple Helper Interface protocol.</p><p>See the <a href="./../admin/sysadmin/#Helpers">System Administration</a> section to learn how to specify the Helper programs to use.</p><h2 id="Config" tabindex="-1">Helper Settings <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Helper Settings {#Config}&quot;">​</a></h2><p>To specify the External Helper program path and other parameters, open the General page in the Settings realm of the WebAdmin Interface and click the Helpers link:</p><form action="Null.html"><div align="center" class="WebAdmin"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><input type="checkbox" name="U0" value="1" checked="checked"><b><i>Helper Name</i></b></td></tr><tr><td align="RIGHT" width="25%">Log Level:</td><td><select name="L0"><option value="0">Crashes Only</option><option value="1">Failures</option><option value="2">Major &amp; Failures</option><option value="3" selected="selected">Problems</option><option value="4">Low Level</option><option value="5">All Info</option></select></td><td align="RIGHT" width="25%">Program Path:</td><td><input type="text" name="P0" value="C:\\Debug\\Test.exe -i 8 -r" size="30" maxlength="255"></td></tr><tr><td align="RIGHT">Time-out:</td><td><select name="T0"><option value="0">Never</option><option value="5">5 sec</option><option value="10">10 sec</option><option selected="selected">15 sec</option><option>20 sec</option><option>30 sec</option><option>45 sec</option><option>60 sec</option><option>90 sec</option><option>2 min</option><option>3 min</option><option>5 min</option><option>10 min</option><option>15 min</option><option>20 min</option><option>30 min</option><option>40 min</option><option>45 min</option><option>60 min</option></select></td><td align="RIGHT">Auto-Restart:</td><td><select name="A0"><option value="0">Never</option><option value="5">5 sec</option><option value="10" selected="selected">10 sec</option><option>15 sec</option><option>20 sec</option><option>30 sec</option><option>45 sec</option><option>60 sec</option><option>90 sec</option><option>2 min</option><option>3 min</option><option>5 min</option><option>10 min</option><option>15 min</option><option>20 min</option><option>30 min</option><option>40 min</option><option>45 min</option><option value="3600">60 min</option><option value="5400">90 min</option><option value="7200">2 hour(s)</option><option value="10800">3 hour(s)</option><option value="18000">5 hour(s)</option><option value="21600">6 hour(s)</option></select></td></tr></tbody></table></div></div></form><p>The checkbox next to the Helper name tells the Server to start the specified program as a separate OS process.</p><ul><li><p><code>Log</code></p><p>Use this setting to specify the type of information the Helper support module should put in the Server Log. Each Helper uses its own tag for its Log record.</p></li><li><p><code>Program Path</code></p><p>The file name (path) of the Helper program. If a relative path is specified, it should be relative to the CommuniGate Pro <em>base directory</em>.<br> If the first setting symbol is <code>$</code>, then the rest of the setting string should be a path relative to the CommuniGate Pro <em>application directory</em>.</p></li><li><p><code>Time-out</code></p><p>If the Helper program does not send a response within the specified period of time, the program is stopped.</p></li><li><p><code>Auto-Restart</code></p><p>If the Helper program stops, and this option is disabled, all pending requests are rejected. If the Helper program stops when this option is enabled, the Server waits for the specified period of time, restarts the Helper Program and re-sends the requests to it.</p></li></ul><h2 id="Manifesto" tabindex="-1">Child Processes Manifesto <a class="header-anchor" href="#Manifesto" aria-label="Permalink to &quot;Child Processes Manifesto {#Manifesto}&quot;">​</a></h2><p>For security purposes, a Child Processes Manifesto file can be used to limit the set of external programs launched by the CommuniGate Pro Server. The Manifesto is a text file <code>Settings/ChildProcs.data</code> from the CommuniGate Pro <em>base directory</em>.</p><p>An external program will not be launched if the initial (left) part of its path/name does not match one of the lines from the Manifesto.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Initially the Child Processes Manifesto file is missing, which means there are no restrictions on running external programs</p></div><p>In addition to Helper Programs, the Manifesto also applies to other programs that can be run by the Server:</p><ul><li>to <a href="./HTTP.html#CGI">CGI</a> programs and scripts</li><li>external <a href="./WebUser.html#SpellCheckers">Spell Checker</a> programs</li><li>external applications for delivery via <a href="./PIPE.html#Delivery">PIPE</a> module</li><li>programs launched by &#39;Execute&#39; action of a <a href="./QueueRules.html#Actions">Rule</a></li></ul><p>Lines of the Manifesto, in addition to the path and name of the Program, can also include the following command line parameters of the Program. Whitespaces matter.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>CGPKAV/CGPKAV</span></span>
<span class="line"><span>CGPKAS/CGPKAS</span></span>
<span class="line"><span>/usr/local/bin/aspell -a --lang=</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Specifying the <code>/</code> and <code>.</code> lines in the Manifesto will allow execution of any command starting with <code>/</code> or <code>.</code> accordingly. That might be dangerous from security standpoint.</p></div><h2 id="Protocol" tabindex="-1">Helper Protocol <a class="header-anchor" href="#Protocol" aria-label="Permalink to &quot;Helper Protocol {#Protocol}&quot;">​</a></h2><p>When the Helper program is launched, the Server sends commands to the Helper process via the process <em>standard input</em>. The Server reads the program responses from the process <em>standard output</em>.</p><p>Commands and responses are text lines, ending with the EOL symbol(s) used in the Server OS.</p><p>Each command starts with a sequence number, and the response produced with the Helper program starts with the same number. This method allows the Helper program to process several requests simultaneously, and it can return responses in any order.</p><p>The Helper program can send information responses at any time. An information response starts with the asterisk (<code>*</code>) symbol. The Server ignores information responses, but they can be seen in the Server Log.</p><p>The response lines generated with a Helper program should not be larger than 4096 bytes.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Communication between the Server and an Helper program takes place via OS <em>pipes</em>, and many programming libraries buffer output data sent to pipes. Check that your Helper program uses some form of the <em>flush</em> command after it sends a response to its standard output, otherwise the response will not reach the Server.</p></div><p>Helper programs are started with the CommuniGate Pro <em>base directory</em> as their current directory.</p><p>Helper programs should not write anything to their <em>standard error</em> streams, unless they want to report a reason for the failure before quitting. CommuniGate Pro reads the program <em>standard error</em> stream only after the program has terminated, and if the program writes into that stream while processing Server commands, the program will be suspended by the OS when the <em>standard error</em> pipe buffer is full.</p><p>The Interface Version command is used to provide compatibility between different versions of Helper programs and different versions of the CommuniGate Pro Server. The Server sends this command specifying the protocol version it implements:<br><code>nnnnnn INTF serverInterfaceVersion</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>serverInterfaceVersion</em></p><p>the version of the Helper protocol implemented by this version of the CommuniGate Pro Server</p></li></ul><p>The Helper program should return the INTF response and the supported protocol version.<br><code>nnnnnn INTF programInterfaceVersion</code><br> If the returned number is smaller than the Server protocol version, the Server will use this (older) protocol version.</p><p>When the Server shuts down or when it needs to stop the Helper program, it sends the <code>QUIT</code> command, and then closes the process <em>standard input</em>. The Helper program should send the <code>OK</code> response and it should quit within 5 seconds.</p><p>Sample session (<code>I:</code> - server commands sent to the program standard input, <code>O:</code> - responses the program writes to its standard output, COMMAND - a Helper-specific command):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>O: * My Helper program started</span></span>
<span class="line"><span>I: 00001 INTF 1</span></span>
<span class="line"><span>O: 00001 INTF 1</span></span>
<span class="line"><span>I: 00002 COMMAND parameters</span></span>
<span class="line"><span>O: 00002 OK</span></span>
<span class="line"><span>I: 00003 COMMAND parameters</span></span>
<span class="line"><span>I: 00004 COMMAND parameters</span></span>
<span class="line"><span>O: * processing 00003 will take some time</span></span>
<span class="line"><span>O: 00004 ERROR description</span></span>
<span class="line"><span>O: 00003 OK</span></span>
<span class="line"><span>I: 00005 QUIT</span></span>
<span class="line"><span>O: * processed: 5 requests. Quitting.</span></span>
<span class="line"><span>O: 00005 OK</span></span>
<span class="line"><span>I: stdin closed</span></span></code></pre></div><p>The sample above shows that the Server does not wait for a response before it sends the next command, and that it can accept responses for several pending commands in any order - as long as each command receives a response within the specified time limit.</p><p>In the versions of application helpers and external filters specified in the document, helper commands are supported. Helper commands start with the &#39;H&#39; character, followed by the helper command number, command and optionally parameters. Ends with the EOL character(s) used in the Server OS. A list of supported commands will be added later. Server and helper command numbering are unrelated and are needed to identify responses.</p><h2 id="AUTH" tabindex="-1">External Authentication <a class="header-anchor" href="#AUTH" aria-label="Permalink to &quot;External Authentication {#AUTH}&quot;">​</a></h2><p><a href="./../admin/sysadmin/Security.html#External">External Authenticator</a> programs can be used to provide authentication, provisioning, and routing services using external data sources.</p><p>The External Authenticator Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.</p><p>This manual describes the External Authenticator Interface Version 11.</p><p>When a user should be authenticated using the <em>clear text</em> method, the Server sends the following command:<br><code>nnnnnn VRFY (mode) name@domain password [loginAddress]</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>mode</em></p><p>the name of the service (IMAP, POP, FTP, etc.) that requested this authentication operation.<br> This parameter can be absent if the request has been received from an unnamed Server component.<br> If the service name is specified, it is enclosed into the parenthesis.</p></li><li><p><em>name</em></p><p>user Account name</p></li><li><p><em>domain</em></p><p>user Account Domain name</p></li><li><p><em>password</em></p><p>password string to verify. If the password contains special symbols, the password is encoded as a quoted <a href="./Data.html">String</a>.</p></li><li><p><em>loginAddress</em></p><p>the network address from which the user logs in.<br> This parameter can be absent if the password is checked by an internal Server component.<br> If the parameter is specified, it is enclosed into square brackets.</p></li></ul><p>When a user should be authenticated using a secure <a href="#SASL">SASL</a> method, the following command is sent:<br><code>nnnnnn SASL(method) (mode) name@domain password key [loginAddress]</code><br> where:</p><ul><li><p><em>method</em></p><p>the name of the secure SASL method used (<code>CRAM-MD5</code>, <code>APOP</code>)</p></li><li><p><em>key</em></p><p>the <em>challenge</em> string sent to the client mailer. If the challenge contains special symbols, it is encoded as a quoted <a href="./Data.html">String</a>.</p></li></ul><p>If the password is accepted, the External Authenticator should return a positive response:<br><code>nnnnnn OK</code></p><p>If the password was not accepted, a negative response should be returned:<br><code>nnnnnn ERROR optional-error-message</code></p><p>If the password is accepted, and there is an authentication response to be returned to the client, a positive response with a quoted string should be returned:<br><code>nnnnnn RETURN &quot;authentication-response&quot;</code></p><p>SASL password verification requires that the External Authenticator program correctly implements all supported SASL methods and algorithms. Alternatively, the External Authenticator program can return the user plain text password, making the Server verify the password and calculate necessary authentication responses. The user plain text password should be returned as a quoted string:<br><code>nnnnnn PLAIN &quot;plain-text-password&quot;</code></p><p>Sample session (<code>I:</code> - server commands sent to the program standard input, <code>O:</code> - responses the program writes to its standard output):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>I: 00001 INTF 1</span></span>
<span class="line"><span>O: 00001 INTF 1</span></span>
<span class="line"><span>I: 00010 VRFY user1@domain1.com dsyui134</span></span>
<span class="line"><span>O: 00010 OK</span></span>
<span class="line"><span>I: 00011 VRFY (IMAP) user2@domain2.com jskj23#45 [10.0.3.4]</span></span>
<span class="line"><span>O: 00011 ERROR incorrect password</span></span>
<span class="line"><span>I: 00012 SASL(CRAM-MD6) user4@domain2.com hdkj547812329394055 &lt;pop-23456@mydomain.com&gt; [10.0.1.4]</span></span>
<span class="line"><span>I: 00013 VRFY (IMAP) user2@domain2.com &quot;jskj23\\&quot;45&quot;</span></span>
<span class="line"><span>O: 00013 OK</span></span>
<span class="line"><span>O: 00012 ERROR unsupported SASL method</span></span>
<span class="line"><span>I: 00014 SASL(DIGEST-MD5) user4@domain2.com 012345 &quot;user:qop:zz:mmm:uri&quot; [10.0.1.4]</span></span>
<span class="line"><span>O: 00014 RETURN &quot;0123456789AAAA&quot;</span></span>
<span class="line"><span>I: 00015 SASL(DIGEST-MD5) user4@domain2.com 012345 &quot;user:qop:zz:mmm:uri&quot; [10.0.1.4]</span></span>
<span class="line"><span>O: 00015 PLAIN &quot;my$$password&quot;</span></span></code></pre></div><p>The External Authentication program can be used to retrieve plain text passwords from external databases.</p><p>To retrieve a password, the Server sends the following command:<br><code>nnnnnn READPLAIN name@domain</code><br> where:</p><ul><li><p><em>name</em>@<em>domain</em></p><p>the full name (address) of the target Account.</p></li></ul><p>The program should return the user plain text password as a quoted string:<br><code>nnnnnn PLAIN &quot;plain-text-password&quot;</code><br> If the program cannot retrieve the plain text password, it should return the FAILURE response.</p><p>The External Authentication program can be used to process unknown names, too. For example, the program can consult an external database, check if the user exists in that database, create an Account, Alias, Group, Mailing List, or Forwarder using the CommuniGate Pro <a href="./CLI.html">CLI/API</a>, and return a positive response to the Server. In this case, CommuniGate Pro will re-try to open a Domain object with the specified name.</p><p>To check an unknown name, the Server sends the following command:<br><code>nnnnnn NEW name@domain relayType</code><br> where:</p><ul><li><p><em>relayType</em></p><p><code>[MAIL]</code> if the command is sent as a part of mail-type routing process,<br><code>[SIGNAL]</code> if the command is sent as a part of signal-type routing process,<br><code>[ACCESS]</code> if the command is sent as a part of access-type routing process.</p></li><li><p><em>name</em>@<em>domain</em></p><p>the full name (address) of the unknown local object.</p></li></ul><p>If the program sends the <code>OK</code> response, the Server tries to find the <em>name</em> object in the <em>domain</em> Domain again.</p><p>If the program sends the <code>ROUTED address</code> response, the Server takes the supplied <em>address</em> response and restarts the Router procedure with this address. The routed address gets a &quot;can Relay&quot; attribute, unless it is specified with the <code>[NORELAY]</code> prefix.</p><p>If the program sends the <code>FAILURE</code> response, the Server Router returns a &quot;temporary internal error&quot; code (this code causes the SMTP module to return a 4xx error code, not a permanent 5xx error code).</p><p>If the program sends any other response, the Server Router returns the &quot;unknown user account&quot; error.</p><p>Sample session:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>I: 00010 NEW user1@domain1.com [MAIL]</span></span>
<span class="line"><span>O: 00010 ERROR this account is not known</span></span>
<span class="line"><span>I: 00011 NEW user2@domain2.com [MAIL]</span></span>
<span class="line"><span>I: 00012 NEW user3@domain2.com [ACCESS]</span></span>
<span class="line"><span>O: 00012 OK</span></span>
<span class="line"><span>O: 00011 ROUTED [NORELAY] userX@domain2.com</span></span></code></pre></div><p>The Consult External for Unknown <a href="./../admin/objects/Domains.html#Unknown">Domain Setting</a> tells the Server to use the External Authenticator program when an unknown name is addressed.</p><p>The External Authentication program can be used to assist in address <a href="./../admin/sysadmin/Router.html">Routing</a>. If an address is routed to the <code>@external</code> domain, the address &quot;local part&quot; is passed to the External Authentication program using the ROUTE command:<br><code>nnnnnn ROUTE &lt;address&gt; relayType</code><br> where:</p><ul><li><p><em>relayType</em></p><p><code>[MAIL]</code> if the command is sent as a part of mail-type routing process,<br><code>[SIGNAL]</code> if the command is sent as a part of signal-type routing process,<br><code>[ACCESS]</code> if the command is sent as a part of access-type routing process.</p></li><li><p><em>address</em></p><p>the local part of the address with the <code>external</code> domain part.</p></li></ul><p>If the program sends the <code>ROUTED address</code> response, the Server takes the supplied <em>address</em> response and restarts the Router procedure with this address. The routed address gets a &quot;can Relay&quot; attribute if the address is specified with the <code>[RELAY]</code> prefix.</p><p>If the program sends the <code>FAILURE</code> response, the Server Router returns a &quot;temporary internal error&quot; code (this code causes the SMTP module to return a 4xx error code, not a permanent 5xx error code).</p><p>If the program sends any other response, the Server Router returns the &quot;cannot route the address&quot; error.</p><p>Sample session:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>I: 00010 ROUTE &lt;user1&gt; [MAIL]</span></span>
<span class="line"><span>O: 00010 ERROR this account is blocked</span></span>
<span class="line"><span>I: 00011 ROUTE &lt;user2%domain1.dom&gt; [MAIL]</span></span>
<span class="line"><span>I: 00012 ROUTE &lt;&quot;user3##name&quot;%domain2.dom&gt; [SIGNAL]</span></span>
<span class="line"><span>O: 00012 FAILURE internal error</span></span>
<span class="line"><span>O: 00011 ROUTED [RELAY] userX@domain100.dom</span></span></code></pre></div><p>The External Authentication program can be used to assist in provisioning operations. If the <a href="./../admin/objects/Domains.html#ExtAuthProvision">Consult External on Provision</a> Domain Setting is enabled, the Server sends the following commands to the External Authentication program:</p><ul><li><p>before an Account is created:</p><p><code>nnnnnn PRECREATE [authAccount] accountName@domainName accountType initialSettings</code><br><em>initialSettings</em> is a dictionary.<br> If this operation fails, the Account is not created.</p></li><li><p>after an Account is created:</p><p><code>nnnnnn POSTCREATE [authAccount] accountName@domainName accountType initialSettings</code><br> If this operation fails, the newly created Account is removed.</p></li><li><p>before an Account is renamed:</p><p><code>nnnnnn PRERENAME [authAccount] accountName@domainName newAccountName@newDomainName</code><br> If this operation fails, the Account is not renamed.</p></li><li><p>after an Account is renamed:</p><p><code>nnnnnn POSTRENAME [authAccount] accountName@domainName newAccountName@newDomainName</code><br> If this operation fails, the renamed Account is renamed back.</p></li><li><p>before an Account is removed:</p><p><code>nnnnnn PREDELETE [authAccount] accountName@domainName</code><br> If this operation fails, the Account is not removed.</p></li><li><p>after an Account is removed:</p><p><code>nnnnnn POSTDELETE [authAccount] accountName@domainName</code></p></li><li><p>before an Account License Class is changed:</p><p><code>nnnnnn PRETYPECHANGE [authAccount] accountName@domainName newClass</code><br> If this operation fails, the Account License Class is not changed.</p></li><li><p>after an Account License Class is changed:</p><p><code>nnnnnn POSTTYPECHANGE [authAccount] accountName@domainName newClass</code></p></li><li><p>before an Account settings are updated:</p><p><code>nnnnnn PREUPDATE [authAccount] accountName@domainName newSettings</code><br> If this operation fails, the Account settings are not updated.</p></li><li><p>after an Account settings are updated:</p><p><code>nnnnnn POSTUPDATE [authAccount] accountName@domainName newSettings</code></p></li><li><p>before an Account password is updated:</p><p><code>nnnnnn PREPWDCHANGE [authAccount] accountName@domainName newPassword</code><br> If this operation fails, the Account password is not updated.</p></li><li><p>The password is one of Account settings, so the PREUPDATE command will follow this one.</p></li></ul><p><em>authAccount</em> is the name of the Account performing the provisioning operation. If it is not known, this account name and the square brackets surrounding it are omitted.</p><p>The program should either send an <code>OK</code> response, or a <code>FAILURE &quot;errorCode&quot;</code> response.</p><h2 id="Filters" tabindex="-1">External Message Filters <a class="header-anchor" href="#Filters" aria-label="Permalink to &quot;External Message Filters {#Filters}&quot;">​</a></h2><p><a href="./../admin/mail/ExternalFilters.html">External Message Filter</a> programs are used for content filtering (anti-virus and anti-spam filtering).</p><p>The External Filter Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This section describes the External Filter protocol <em>version 5</em>.</p><ul><li><p>The program should process the External Filter requests:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum FILE fileName</span></span></code></pre></div><p>where <em>fileName</em> is the name of the file the program should scan.</p></li><li><p>If message processing should proceed, the response line should have the following format:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum [ modifiers ] OK</span></span></code></pre></div><p>where <em>modifiers</em> is zero, one, or several keywords (each with an optional parameter), separated using the space symbol:</p><ul><li><p>ADDHEADER <em>header-field-text</em></p><p><em>header-field-text</em> is a text string to be added to the message header. It should contain one or several RFC822/RFC2822 header fields.<br> This (optionally multi-line) header field text should be placed into the response line using the <a href="./Data.html#String">String</a> format.</p></li><li><p>MIRRORTO <em>address</em></p><p><em>address</em> is a text string to mirror the message to.<br> The string should contain exactly one E-mail address. To mirror the message to several addresses, use several MIRRORTO modifiers.<br> The address text should be placed into the response line using the <a href="./Data.html#String">String</a> format.</p></li><li><p>ADDROUTE <em>address</em> This modifier is supported when the Filter is used in Server-wide and Cluster-wide Rules only. <em>address</em> is a text string to add to the message &quot;route set&quot;, i.e. to the list of addresses this message is to be delivered to. The string should contain exactly one E-mail address. To add several addresses, use several ADDROUTE modifiers. The address text should be placed into the response line using the <a href="./Data.html#String">String</a> format. Examples:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>1077 OK</span></span>
<span class="line"><span>1078 ADDHEADER &quot;X-SPAM-SCORE: 100\\eX-SPAM-FILTER: CGateProSpamFilter(r)&quot; OK</span></span>
<span class="line"><span>1079 ADDHEADER &quot;X-SPAM-SCORE: 100&quot; MIRRORTO &quot;spamreport@mydomain.com&quot; MIRRORTO &quot;abuse@mydomain.com&quot; OK</span></span></code></pre></div></li><li><p>If a message should be rejected the response line should have the following format:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum ERROR report</span></span></code></pre></div><p>where <em>report</em> is a text string explaining why the message is rejected.<br> This (optionally multi-line) text should be placed into the response line in the CommuniGate Pro <a href="./Data.html#String">String</a> format.</p></li><li><p>If a message should be discarded the response line should have the following format:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum DISCARD</span></span></code></pre></div></li><li><p>If message processing should be postponed (because of the license limitations, for example), the response line should have the following format:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum REJECTED report</span></span></code></pre></div><p>where <em>report</em> is a text string explaining why the message processing should be postponed.</p></li><li><p>If the program receives a request it cannot process, it should return the FAILURE response:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>seqNum FAILURE</span></span></code></pre></div><p>If the program has sent the FAILURE response or any unlisted response, the Server places a record into its Log and proceeds as if it has received the OK response.</p></li><li><p>The program SHOULD be ready to process several requests simultaneously (using several threads). Since the External Filter program is used with the Server-Wide Rules (processed with the <a href="./../admin/mail/#Enqueue">Enqueuer</a> Server component), the program should be ready to handle N concurrent requests, when N is the number of Enqueuer &quot;processors&quot; (threads).</p></li><li><p>The program MAY be implemented as a single-threaded one, so it reads the next request only after the previous request has been processed. But this design can result in severe performance degradation of the entire Server: when a single-threaded External Filter program is scanning a large message, other messages are not being enqueued.</p></li></ul><p>If the external program crashes, CommuniGate Pro suspends the Enqueuer process until the external program is restarted.</p><h2 id="RADIUS" tabindex="-1">External RADIUS Helpers <a class="header-anchor" href="#RADIUS" aria-label="Permalink to &quot;External RADIUS Helpers {#RADIUS}&quot;">​</a></h2><p><a href="./../admin/sysadmin/Security.html#External">External RADIUS</a> programs can be used to provide additional checks for authentication operations performed via the <a href="./../admin/services/RADIUS.html">RADIUS module</a>, as well as to add additional attributes into RADIUS responses.</p><p>The External RADIUS Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This manual describes the External RADIUS Interface Version 2.</p><p>If the External RADIUS program is enabled, it is used after the user password is verified. The Server sends it the following command:<br><code>nnnnnn LOGIN name@domain attributes settings</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>name</em></p><p>user Account name</p></li><li><p><em>domain</em></p><p>user Account Domain name</p></li><li><p><em>attributes</em></p><p>a <a href="./Data.html">dictionary</a> with all request attributes.</p></li><li><p><em>settings</em></p><p>a <a href="./Data.html">dictionary</a> with the Account settings.</p></li></ul><p>If the login request is accepted, the Helper program should return a positive response:<br><code>nnnnnn ACCEPT attributes</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>the request sequence number</p></li><li><p><em>attributes</em></p><p>a <a href="./Data.html">dictionary</a> with the attributes to be added to the RADIUS response.</p></li></ul><p>If the password was not accepted, a negative response should be returned:<br><code>nnnnnn REJECT optional-error-message</code></p><p>If the External RADIUS program is enabled, it is used to process the <code>Start</code>, <code>Stop</code>, and <code>Interim-Update</code> accounting requests. The Server sends the following command:<br><code>nnnnnn ACCNT command name@domain attributes</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>command</em></p><p>the accounting command (<code>started</code>, <code>ended</code>, <code>updated</code>)</p></li><li><p><em>name</em></p><p>user Account name</p></li><li><p><em>domain</em></p><p>user Account Domain name</p></li><li><p><em>attributes</em></p><p>a <a href="./Data.html">dictionary</a> with request attributes.</p></li></ul><p>The Helper program should return a positive response:<br><code>nnnnnn OK</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>the request sequence number</p></li></ul><p>The attributes in dictionaries should use the attribute type numeric values as keys (for example <code>27</code> for <code>Session-Timeout</code>).</p><p>The following attributes are interpreted as 32-bit integer values and they are encoded as numeric strings in dictionaries:<br><code>NAS-Port</code>, <code>Service-Type</code>, <code>Framed-Protocol</code>, <code>Framed-Routing</code>, <code>Framed-MTU</code>, <code>Framed-Compression</code>, <code>Login-Service</code>, <code>Login-TCP-Port</code>, <code>Framed-IPX-Network</code>, <code>Session-Timeout</code>, <code>Idle-Timeout</code>, <code>Termination-Action</code>, <code>Framed-AppleTalk-Link</code>, <code>Framed-AppleTalk-Network</code>, <code>Event-Timestamp</code>, <code>NAS-Port-Type</code>, <code>Port-Limit</code>, <code>ARAP-Zone-Access</code>, <code>Password-Retry</code>, <code>Prompt</code>, <code>Tunnel-Type</code>, <code>Tunnel-Medium-Type</code>, <code>Tunnel-Preference</code>, <code>Acct-Interim-Interval</code>, <code>Acct-Delay-Time</code>, <code>Acct-Input-Octets</code>, <code>Acct-Output-Octets</code>, <code>Acct-Authentic</code>, <code>Acct-Session-Time</code>, <code>Acct-Input-Packets</code>, <code>Acct-Output-Packets</code>, <code>Acct-Terminate-Cause</code>, <code>Acct-Link-Count</code>, <code>Acct-Input-Gigawords</code>, <code>Acct-Output-Gigawords</code>.</p><p>The following attributes are interpreted as 32-bit IP addresses and they are encoded as <code>aaa.bbb.ccc.ddd</code> strings in dictionaries:<br><code>NAS-IP-Address</code>, <code>Framed-IP-Address</code>, <code>Framed-IP-Netmask</code>, <code>Login-IP-Host</code>.</p><p>The following attributes are ignored in Helper responses:<br><code>User-Name</code>, <code>User-Password</code>, <code>CHAP-Password</code>, <code>State</code>, <code>Proxy-State</code>, <code>EAP-Message</code>, <code>Message-Authenticator</code>, <code>Acct-Status-Type</code>.</p><p>All other attribute values are encoded either as a <a href="./Data.html#String">String</a> or as <a href="./Data.html#DataBlock">DataBlocks</a>. The Server uses the DataBlocks format for those attribute values that contain bytes outside the hexadecimal 0x20-0x7F range.<br> The DataBlock format must be used if the value contains binary zero bytes.</p><p>If an attribute has multiple values, the attribute value is encoded as an <a href="./Data.html#Array">Array</a>.</p><p>The following attributes are added to the attribute dictionaries passed to the Helper:</p><ul><li><p><code>0</code></p><p>the RADIUS protocol request ID. It can be used to detect retransmitted packets (duplicate requests)</p></li><li><p><code>secretKey</code> (authentication requests only)</p><p>a string value with the RADIUS module &quot;shared secret&quot; setting.</p></li><li><p><code>authData</code> (authentication requests only)</p><p>a 16-byte DataBlock containing the &quot;authentication data&quot; portion of the RADIUS request.</p></li></ul><p>The Vendor-specific attributes are presented using keys with negative numeric values. The key absolute value is the &quot;VendorID&quot; value. For each VendorID, the associated element is a dictionary. This dictionary keys are Vendor-specific &quot;vendor types&quot;, with associated &quot;specific attributes&quot;. The &quot;specific attributes&quot; values can be stored as <a href="./Data.html#String">String</a>, <a href="./Data.html#DataBlock">DataBlocks</a>, <a href="./Data.html#Number">Number</a>, or <a href="./Data.html#Array">Arrays</a> of Strings, DataBlocks, and/or Numbers.</p><p>Sample session (<code>I:</code> - server commands sent to the program standard input, <code>O:</code> - responses the program writes to its standard output):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>I: 00001 INTF 1</span></span>
<span class="line"><span>O: 00001 OK 1</span></span>
<span class="line"><span>I: 00002 LOGIN user1@domain1.com {0=#15; 1=&quot;User1&quot;;4=10.0.0.1;32=&quot;NAS 1&quot;;31=4992713154;&quot;-311&quot;={9=#777;10=&quot;ZZZ&quot;;}; authData=[AbndghAbndgh1sjkjkss3T=]; secretKey=a123;} {RealName=&quot;User&quot;; NATIP=&quot;192.168.1.3&quot;;}</span></span>
<span class="line"><span>O: 00002 ACCEPT {8=192.168.1.3; 9=255.255.255.0; 13=(0,3);}</span></span>
<span class="line"><span>I: 00003 LOGIN user1@domain1.com {0=#16; 1=&quot;uSEr1&quot;;32=&quot;NAS 2&quot;;31=415.5512.12; 8=192.168.1.3; authData=[Abnd278sjkljsljkjksFG=]; secretKey=a123;} {NATIP=&quot;10.0.1.114&quot;;}</span></span>
<span class="line"><span>O: 00003 REJECT</span></span>
<span class="line"><span>I: 00004 ACCNT started user1@domain1.com {0=#17;1=&quot;uSEr1&quot;;32=&quot;NAS 2&quot;;31=415.5512.12; 8=192.168.1.3;}</span></span>
<span class="line"><span>O: 00004 OK</span></span></code></pre></div><p>Note: the Server can send several concurrent requests for the same target Account.</p><p>Note: the External RADIUS program is called when the target Account is open. In a <a href="./../admin/cluster/">Dynamic Cluster</a> system this means that External RADIUS programs should run on backend servers, and that External RADIUS programs running on different backend servers will never get requests for the same Account at the same time.</p><h2 id="CDR" tabindex="-1">External CDR Processor <a class="header-anchor" href="#CDR" aria-label="Permalink to &quot;External CDR Processor {#CDR}&quot;">​</a></h2><p><a href="./../admin/cluster/Signals.html#CDR">External CDR Processor</a> programs can be used to process CDRs (Call Detail Records) generated with the <a href="./../admin/cluster/Signals.html">Signal</a> component when a call is attempted, established, or tiered down. They can also process CDR records generated with <a href="./CGPL.html">CG/PL applications</a>.</p><p>The External CDR Processor Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This manual describes the External CDR Processor Interface Version 1.</p><p>If the External CDR Processor program is enabled, the Signal module generated CDRs and sends them to the program.</p><p>When a CDR is composed, the Server sends the following command:<br><code>nnnnnn CDR cdrdata_</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>cdr_data</em></p><p>CDR data in the <a href="./../admin/cluster/Signals.html#CDR">Signal</a> component format or in the <a href="./CGPL.html#CDR">CG/PL Application</a> format.</p></li></ul><p>when the record is processed, the program should return a positive response:<br><code>nnnnnn OK</code></p><h2 id="Balancer" tabindex="-1">External Load Balancer <a class="header-anchor" href="#Balancer" aria-label="Permalink to &quot;External Load Balancer {#Balancer}&quot;">​</a></h2><p>External Load Balancer programs are used to control software load balancers for the <a href="./../admin/cluster/">Dynamic Cluster</a> installations. These programs should be installed and enabled on all Cluster members that can act as load balancers. For each &quot;balancing groups&quot; the Cluster Controller selects one of the available load balancers and activates it, while other load balancers work in the &quot;backup&quot; mode.</p><p>The External Load Balancer Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This manual describes the External Load Balancer Interface Version 1.</p><p>When the Cluster Controller detects a change in the cluster member belonging to this Load Balancer Group, the program receives the following command:<br><code>nnnnnn MEMBERS (ip-address [,ip-address...] ) (ip-address [,ip-address...] )</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>ip-addresses</em></p><p>Two sets of Network IP addresses. The first one lists all currently available cluster members, the second list - all currently disabled (but running) cluster members. Each set may contain zero or more addresses, separated with the comma (,) symbol. Each address is the &quot;Server WAN IPv4 Address&quot; of the cluster member, as specified in its Network Settings.</p></li></ul><p>When the program starts, or when the Server detects a change in its &quot;Server WAN IPv4 Address&quot; Network Setting, the program receives the following command:<br><code>nnnnnn LOCAL ip-address</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>ip-address</em></p><p>the current &quot;Server WAN IPv4 Address&quot; Network Setting of this Server.</p></li></ul><p>When this load balancer needs to be activated, the program receives the following command:<br><code>nnnnnn STARTBALANCER</code></p><p>When the Cluster Controller needs to deactivate this load balancer, the program receives the following command:<br><code>nnnnnn STOPBALANCER</code></p><h2 id="AppHelpers" tabindex="-1">External Application Helpers <a class="header-anchor" href="#AppHelpers" aria-label="Permalink to &quot;External Application Helpers {#AppHelpers}&quot;">​</a></h2><p>External Application Helper programs can be used to provide <a href="./CGPL.html">CG/PL</a> applications with arbitrary data..</p><p>The External Application Helper Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This manual describes the External Application Helper Interface Version 3.</p><p>When a client requests data, the Server sends the following command:<br><code>nnnnnn USER user@domain REQ requestData</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>user@domain</em></p><p>the name of the account that owns the context for the request to the helper.</p></li><li><p><em>requestData</em></p><p>the request data from the application, which may be a string, array, dictionary or datablock.</p></li></ul><p>When the request is processed, the program should return a positive response:<br><code>nnnnnn RESP responseData</code><br> where:</p><ul><li><p><em>responseData</em></p><p>the text presentation of the response data.</p></li></ul><p>Sample session (<code>I:</code> - server commands sent to the program standard input, <code>O:</code> - responses the program writes to its standard output):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>I: 00001 INTF 2</span></span>
<span class="line"><span>O: 00001 INTF 2</span></span>
<span class="line"><span>I: 00010 USER john@dummy.dom REQ &quot;What time is it?&quot;</span></span>
<span class="line"><span>O: 00010 RESP &quot;11:18pm&quot;</span></span></code></pre></div><p>If the External Application Helper program is not running, any request immediately produces an empty response.</p><h2 id="Banner" tabindex="-1">External Banner System <a class="header-anchor" href="#Banner" aria-label="Permalink to &quot;External Banner System {#Banner}&quot;">​</a></h2><p>External Banner System programs can be used to provide <a href="./XMLAPI.html#Banner">XIMSS</a> and other clients with &quot;banner&quot; data (advertising information that a client presents to the user).</p><p>The External Banner System Interface protocol is based on the generic <a href="#Protocol">Helper Protocol</a>.<br> This manual describes the External Banner System Interface Version 1.</p><p>When a client requests a banner, the Server sends the following command:<br><code>nnnnnn BANNER bannerType [ accountName@domainName ] [ INFO bannerSetting ] [ PREFS bannerPreference ] [ PARAM paramData ]</code><br> where:</p><ul><li><p><em>nnnnnn</em></p><p>a unique sequence number for this request</p></li><li><p><em>bannerType</em></p><p>if the banner type string specified with the client application (specifies the client application and its banner type, for example: prontoEmailTop, myClientLeftBanner).</p></li><li><p><em>accountName</em>@<em>domainName</em></p><p>full name of the Account requesting a banner.</p></li><li><p><em>bannerSetting</em></p><p>(optional) the <code>BannerInfo</code> Account Setting value.</p></li><li><p><em>bannerPreference</em></p><p>(optional) the <code>BannerClass</code> Account Preference value.</p></li><li><p><em>paramData</em></p><p>(optional) the text presentation of the parameter object specified with the client application.</p></li></ul><p>When the record is processed, the program should return a positive response:<br><code>nnnnnn RESULT resultData</code><br> where:</p><ul><li><p><em>resultData</em></p><p>the text presentation of the banner info.</p></li></ul><p>The program can also return a blocking response:<br><code>nnnnnn BLOCK</code><br> The specified <em>bannerType</em> is added to the list of &quot;blocked&quot; types. If any client requests a banner of a &quot;blocked&quot; type, an empty response is returned immediately, without calling the External Banner System program.</p><p>If the External Banner System program is not running, any banner request immediately produces an empty response.</p>`,139)]))}const u=t(o,[["render",r]]);export{m as __pageData,u as default};
