import{_ as a,a as n,b as t,c as s,d as i,e as o,f as l,g as r,h as p,i as d}from"./chunks/PBXBridgeDisconnect.Dgrb5Fns.js";import{_ as c,c as h,o as u,ag as m}from"./chunks/framework.jCcxW76o.js";const w=JSON.parse('{"title":"Real-Time Applications","description":"","frontmatter":{"legacyLink":"PBXApp.html"},"headers":[],"relativePath":"development/PBXApp.md","filePath":"development/PBXApp.md"}'),f={name:"development/PBXApp.md"};function g(T,e,v,b,y,k){return u(),h("div",null,e[0]||(e[0]=[m('<p></p><h1 id="real-time-applications" tabindex="-1">Real-Time Applications <a class="header-anchor" href="#real-time-applications" aria-label="Permalink to &quot;Real-Time Applications&quot;">​</a></h1><p>The CommuniGate Pro Real-Time Application module provides an infrastructure to design and deploy applications processing various <a href="./../admin/cluster/Signals.html">Signals</a>.<br> Real-Time Applications used to process voice calls include voice mail, auto-attendant, conferencing, etc. These applications implement the &quot;IP-PBX&quot; functionality, providing an Internet standards-based alternative to legacy PBX (Private Branch Exchange) systems.</p><p>A Real-Time Application can be invoked when a <a href="./../admin/cluster/Signals.html">Signal</a> is sent to a certain Account, or certain Signals can be explicitly directed to Real-Time Applications.</p><p>The CommuniGate Pro Server software comes with several Real-Time Applications already built-in. These applications are highly customizable, and they can be used in most &quot;regular&quot; cases.</p><p>Read this section if you want to customize the built-in Applications, and/or if you want to create your own Real-Time Applications.</p><h2 id="Environs" tabindex="-1">Application Environments <a class="header-anchor" href="#Environs" aria-label="Permalink to &quot;Application Environments {#Environs}&quot;">​</a></h2><p>A Real-Time Application Environment is a set of files that may include:</p><ul><li><a href="./CGPL.html">CGPL</a> files with Application code and code modules.</li><li>Arbitrary service files - pre-recorded media files, for example.</li><li>Language directories.</li></ul><p>Environments are designed to support several human (spoken) languages. The default Environment language is English. To support other languages, an Environment should contain <em>language directories</em>, named as the languages they support (<code>french</code>, <code>russian</code>, <code>japanese</code>, etc.)</p><p>A language directory can contain the same files as the Environment itself, but it cannot contain language subdirectories.</p><p>Real-Time Application Tasks can select a language to be used. When a non-default language is selected, and the application code tries to read a file from the Application Environment, the selected language subdirectory is used. If the file is not found in the language subdirectory, the file is retrieved from the Application Environment itself (i.e. the default language file is used).</p><p>The CommuniGate Pro server comes with a built-in &quot;Stock&quot; Real-Time Application Environment. This Environment contains some basic applications and all files required by those applications, as well as some useful code section and media files.</p><p>Each CommuniGate Pro system has its Server-wide Application Environment. A CommuniGate Pro <a href="./../admin/cluster/">Dynamic Cluster</a> installation also has a Cluster-wide Application Environment. To modify these Environments, open the WebAdmin Interface Domains section and follow the PBX link.</p><p>Each CommuniGate Pro <a href="./../admin/objects/Domains.html">Domain</a> has its own Application Environment. To modify that Environment, open the WebAdmin Interface Domains section, open the Domain Settings for the selected Domain and follow the PBX link.</p><p>Modifications of the Cluster-wide Environment, as well as modifications of an Environment in any Shared Domain are automatically distributed to all Cluster Members.</p><p>Since Domains have their own Application Environments, different applications in different Domains can have the same name.</p><p>All Application Environment files should use the UTF-8 character set for non-ASCII symbols.</p><h2 id="FileHierarchy" tabindex="-1">Environment Files Hierarchy <a class="header-anchor" href="#FileHierarchy" aria-label="Permalink to &quot;Environment Files Hierarchy {#FileHierarchy}&quot;">​</a></h2><p>Real-Time Application Tasks are executed &quot;on behalf&quot; of a certain CommuniGate Pro <a href="./../admin/objects/Accounts.html">Account</a>.<br> When an application requests an &quot;environment file&quot; and the default language is selected, the Server looks for the file in:</p><ul><li>the Account Domain Environment.</li><li>the Server-wide Environment or (if the Account belongs to a Shared Domain) the Cluster-wide Environment.</li><li>the Stock Environment.</li></ul><p>If a non-default language is selected, the Server first looks for the file in the language directories of the Environments listed above. If the file is not found in any of those directories, the listed Environments themselves are searched. So, if a language-specific file has not been created, the default-language (English) file is used.</p><p>This hierarchy provides for simple Application customization. Accounts in all Domains can use the same Stock or Server-wide applications, while Domain Administrators can customize these applications by uploading custom files into their Domain Environments.</p><h2 id="Editor" tabindex="-1">Managing Environments <a class="header-anchor" href="#Editor" aria-label="Permalink to &quot;Managing Environments {#Editor}&quot;">​</a></h2><p>The WebAdmin Interface provides the Real-Time Application Environment Editor pages to manage Server-wide, Cluster-wide, and Domain Application Environments.</p><p>To manage the Server-wide and Cluster-wide Environments, open the Users realm of the WebAdmin Interface, and click the PBX link.</p><p>To manage the Domain Environment, open that Domain page in the Users realm of the WebAdmin Interface, and click the PBX link. The Domain Administrator should have the CanModifyPBXApps Access Right to be able to create and modify the Domain Application Environment.</p><p>The Environment Editor page contains the list of all files &quot;visible&quot; in this Environment: it lists files directly uploaded to this particular Environment, as well as all files uploaded to the Environments used as the &quot;default files&quot; source for this Environment:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td colspan="2" align="left"><input name="Remove" value="Delete Marked" class="buttonRed" type="reset"></td><td><input name="Create" value="Upload File" class="button" type="reset"><input name="Upload" type="file"></td><td align="right"><input name="Flush" value="Uncache" class="buttonWhite" type="reset"></td></tr><tr><th> </th><th align="left">Name</th><th align="right">Size</th><th align="right">Modified</th></tr><tr><td align="center"><input type="checkbox" name="MFile" value="Help.gif"></td><td><a href="#Editor">Help.gif</a></td><td align="right">155</td><td align="right">25-Sep-04</td></tr><tr><td align="center">default</td><td><a href="#Editor">addressbook.sppi</a></td><td align="right">5143</td><td align="right">23-Sep-05</td></tr><tr><td align="center">default</td><td><a href="#Editor">voicemail.sppr</a></td><td align="right">8K</td><td align="right">27-Feb-05</td></tr><tr><td align="center">default</td><td><a href="#Editor">failure.wav</a></td><td align="right">10K</td><td align="right">27-Feb-05</td></tr><tr><td colspan="5" align="center">...</td></tr><tr><td align="center">default</td><td><a href="#Editor">xfer.wav</a></td><td align="right">15K</td><td align="right">28-Sep-05</td></tr><tr><td align="center"><input type="checkbox" name="MFile" value="xxx.wssp"></td><td><a href="#Editor">xonix.wav</a></td><td align="right">30K</td><td align="right">02-Oct-05</td></tr></tbody></table></div></form><p>Files directly uploaded to the Environment have a checkbox in the Marker column. Files from the other Environments &quot;visible&quot; in this Environment have the word <code>default</code> in that column.</p><p>You can download any of the Environment files by clicking the file name.</p><p>You can upload a file to the Environment by clicking the Browse button and selecting a file on your workstation, then clicking the Upload button.</p><p>You can delete any of the files uploaded to the Environment by selecting the checkboxes and clicking the Delete Marked button.</p><p>If you are uploading a file with the <code>.sppr</code> or the <code>.sppi</code> extension, the Editor assumes that the file contain some CG/PL program code, and it tries to compile that code.<br> If you are uploading a file with the <code>.settings</code> extension, the Editor assumes that the file contain a <a href="./Data.html">dictionary</a>, and it tries to parse it.<br> If the compiler or the parser detects an error, the file is not uploaded, and the file content is displayed on the Editor page, with the red <code>&lt;--ERROR--&gt;</code> marker indicating the location of the error.</p><p>The Server places used Real-Time Environment files into an internal cache. When you upload a file to any Environment, that Environment cache is automatically cleared. If you upload a file to a Shared Domain Environment or to the Cluster-wide Environment, the updated file automatically propagates to all Cluster Members.</p><p>You can upload a set of files by uploading a TAR-archive (a file with <code>.tar</code> name extension). For example, when you have a TAR-archive with a predesigned Real-Time Application you can open the Environment you want to modify, and upload the <code>.tar</code> file. The Server will unpack the archive and store each file individually, as if they were uploaded one-by-one.</p><p>The Editor page contains the list of all Language directories:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Languages</b></td></tr><tr><td align="center"><input type="checkbox" name="MSkin" value="arabic"></td><td><a href="#Editor">arabic</a></td></tr><tr><td align="center"><input type="checkbox" name="MSkin" value="french"></td><td><a href="#Editor">french</a></td></tr><tr><td align="center"><input type="checkbox" name="MSkin" value="russian"></td><td><a href="#Editor">russian</a></td></tr></tbody><tfoot><tr><th></th><th align="right"><input name="CreateLanguage" value="Create" class="button" type="reset"><input name="NewName" size="30" maxlength="255" type="text"></th></tr></tfoot></table></div></form><p>To create a new Variant, enter the language name, and click the Create Language button.</p><p>To open a Language directory, click its name. The Editor will display the Language name, and it will provide the <code>UP</code> link to the list of the default language files.</p><h3 id="CLI" tabindex="-1">CLI/API <a class="header-anchor" href="#CLI" aria-label="Permalink to &quot;CLI/API {#CLI}&quot;">​</a></h3><p>The Command Line Interface/API can be used to manage Application Environments. See the <a href="./CLI.html#PBXApp">Real-Time Application Administration</a> section for the details.</p><h3 id="VirtualFileStorage" tabindex="-1">Virtual File Storage Area <a class="header-anchor" href="#VirtualFileStorage" aria-label="Permalink to &quot;Virtual File Storage Area {#VirtualFileStorage}&quot;">​</a></h3><p>The Application Environments can be modified using <a href="./../admin/access/FTP.html">FTP</a> and <a href="./../admin/services/HTTP.html">HTTP</a> clients, <a href="./CGPL.html">CG/PL</a> applications, and any other method that provides access to the Account <a href="./../admin/storage/FileStore.html">File Storage</a>.<br> Special <code>$DomainPXBApp</code>, <code>$ServerPXBApp</code>, and <code>$ClusterPXBApp</code> directories provide access to the Domain and Server/Cluster-wide Application Environments.</p><h2 id="Model" tabindex="-1">Application Model <a class="header-anchor" href="#Model" aria-label="Permalink to &quot;Application Model {#Model}&quot;">​</a></h2><p>Real-Time Applications run as <a href="./CGPL.html#MultiTask">Tasks</a>. To start an Application, the CommuniGate Pro Server starts a new Task and instructs it to execute the <code>main</code> <a href="./CGPL.html#ProcDefs">entry</a> code section of the specified Application.</p><p>A Real-Time Application Task can run in the <em>disconnected</em> mode, or it can be a part of exactly one Real-Time <em>session</em> (such as a phone call) with some <em>peer</em>. A <em>peer</em> is any Real-Time entity, such as a SIP phone, a PSTN gateway, a remote Real-Time application communicating via SIP, or a local Real-Time Application, i.e. some other Task.</p><p>If a Task is participating in a session with some <em>peer</em>, it can be in one of the following modes:</p><ul><li><p><code>incoming</code></p><p>an incoming session (a <em>call</em> in the telephony terms, an <em><code>INVITE</code> request</em> in the SIP terms) has been directed to the Task, but the Task has not accepted the session (call) yet.</p></li><li><p><code>provisioned</code></p><p>an incoming session has been directed to the Task, the Task has not accepted the session yet, but it has sent a provisional response to the caller.</p></li><li><p><code>connecting</code></p><p>the Task has initiated an outgoing session (call), but the session has not been established yet.</p></li><li><p><code>connected</code></p><p>the Task has accepted an incoming session, or the Task has established an outgoing session.</p></li></ul><p><img src="'+a+'" alt="PBX Illustration"></p><p>A Task can receive <a href="./../admin/cluster/Signals.html">Signals</a> from its peer, and it can send Signals itself. Signals can be used to end the current session, to update the session parameters, etc. Some of the Signals sent by the peer are processed by the Real-Time Application Environment itself, while other Signals are passed to the Task for processing.</p><p>A Real-Time Application Task can have a Media Channel associated with it. When a session is established, the Task Media Channel is connected to the peer&#39;s media channel.</p><p>A Task can use its Media Channel to send media (audio, video) to the peer, and to record media sent by the peer.</p><p>A Task can switch the peer media somewhere else - for example, to a separate service providing <em>music on hold</em> or other media services. When the peer media is switched away, the Task Media Channel cannot be used, but the Task still can control the peer by sending Signals to it and it still receives Signals from the peer. The Task can switch the peer media back to its own Media Channel.</p><p><img src="'+n+'" alt="PBX Illustration"></p><p>A Media Channel provides a <em>conversation space</em>. A Task can attach other peer media to the Task own Media Channel. This operation creates a conversation space (or a <em>conference</em>) that includes the Task own peer and all peers with media attached to this Task. Media sent by any peer in a <em>conversation space</em> is relayed to all other peers in that space, using the data mixing algorithms and parameters defined for that media type.</p><p><img src="'+t+'" alt="PBX Illustration"></p><p>A Task with attached peer media can use its Media Channel to send media to its own peer and to all attached peers at once.</p><h3 id="CallTransfer" tabindex="-1">Call Transfer <a class="header-anchor" href="#CallTransfer" aria-label="Permalink to &quot;Call Transfer {#CallTransfer}&quot;">​</a></h3><p>Real-Time Application Tasks can automatically process Call Transfer requests.</p><p>When a Task receives a REFER request (from a remote client, or from a different Task), it can:</p><ul><li>process it automatically (this is the default option)</li><li>reject it</li><li>pass it to the application</li></ul><p>If a Task is instructed to processes REFER requests automatically, it creates a new INVITE request and sends it to the address specified in the Refer-To: field. While this INVITE request is in progress, the task informs the peer about the call progress by sending it NOTIFY requests.</p><p>If the INVITE request is completed successfully, the Task sends the BYE Signal request to the current peer (unless it has already received the BYE Signal from the current peer), and then it switches its Signal dialog and the Media Channel to the new peer:</p><p><img src="'+s+'" alt="PBX Transfer Illustration"></p><p>The INVITE signal initiated with the REFER signal can contain authentication information. The application program can instruct the Task:</p><ul><li>to authenticate the INVITE signal as coming from the current Account. This is the default option.</li><li>to authenticate the INVITE signal as coming from the peer (the entity that has sent the REFER signal).</li><li>to reject REFER signals.</li></ul><p>To process &quot;Assisted&quot; Call Transfer, the Real-Time Application engine detects all INVITE signals with the Replaces field. If the dialog data specified in the Replaces field matches an active dialog established in any Real-Time Task, the INVITE signal is directed to that Task. The Task sends a BYE signal to the current peer, and it switches its Signal dialog to the source of this INVITE signal, and it switches the Media channel to the entity specified in the INVITE signal.<br> This processing takes place automatically, transparently to the application program the Task is running.</p><p><img src="'+i+'" alt="PBX Transfer Illustration"></p><h3 id="CallBridge" tabindex="-1">Bridged Calls <a class="header-anchor" href="#CallBridge" aria-label="Permalink to &quot;Bridged Calls {#CallBridge}&quot;">​</a></h3><p>A pair of Real-Time Application Tasks can build a Media Bridge. When a Media Bridge is built, the Tasks&#39; peers exchange media, while each Task stays in control of the peer signaling.</p><p>To build a bridge:</p><ul><li>an application program some Task A is running uses the <a href="#Signals">StartBridge</a> CG/PL function to send a special <code>[bridgeStart]</code> event to some other Task B. The request contains the the current Task A peer media description.</li><li>the application program the Task B is running receives this request.</li><li>the Task B application program uses the <a href="#Signals">AcceptBridge</a> CG/PL function to build the bridge.</li><li>the Real-Time Application engine sends a re-INVITE signal to the Task B peer, switching its Media to the Task A peer Media.</li><li>the Real-Time Application engine sends a <code>[bridgeResponse]</code> event to Task A. This event contains the Task B peer media description.</li><li>the AcceptBridge operation in Task B application program completes, and the Task B application program continues to run.</li><li>when the Task A receives the <code>[bridgeResponse]</code> event, the Real-Time Application engine processes the event itself, and it does not deliver it to the Task A application program.</li><li>the Real-Time Application engine sends a re-INVITE to the Task A peer, switching its Media to the Task B peer Media.</li><li>the StartBridge operation in Task A completes, and the Task A application program continues to run.</li></ul><p><img src="'+o+'" alt="Bridge Start Illustration"></p><p>When the Tasks A and B are in the &quot;bridged&quot; state, one of the Tasks (Task B here) can receive a re-INVITE signal from its peer. The new media description in this signal request may ask the Task to change its media parameters (hold/resume, switching to a different media source, etc.). This re-INVITE signal is processed automatically, without any involvement of the application programs the Tasks are running:</p><ul><li>the Real-Time Application engine sends a special <code>[bridgeUpdate]</code> event to the Task A. This event contains the new media description.</li><li>the Real-Time Application engine processes the <code>[bridgeUpdate]</code> event itself, and it does not deliver it to the Application program the Task A is running.</li><li>the Real-Time Application engine sends a re-INVITE signal to the Task A peer, switching it to the new Media source of the Task B peer.</li><li>the Real-Time Application engine sends the new Peer A media description (received with the re-INVITE response) to the Task B as a special <code>[bridgeResponse]</code> event.</li><li>when the Task B receives the <code>[bridgeResponse]</code> event, the Real-Time Application engine process it itself and does not deliver it to the Task B application program.</li><li>the new Task A media descriptor received is sent to the Peer B as a response to the initial re-INVITE signal, switching the Task B peer to the new Task A peer media.</li></ul><p><img src="'+l+'" alt="Bridge Update Illustration"></p><p>When the Tasks A and B are in the &quot;bridged&quot; state, one of the Tasks (Task A here) can receive a Call Transfer (REFER) signal from its peer:</p><ul><li>the the Real-Time Application engine composes the INVITE signal for the Task A, and sends it to the referred peer; the Signal contains the Task B peer media description.</li><li>the INVITE signal succeeds and the new Task A peer (peer C) media description is received.</li><li>the Real-Time Application engine automatically sends a special <code>[bridgeUpdate]</code> event to the Task B, with new peer media description.</li><li>when the Task B received the <code>[bridgeUpdate]</code> event, the Real-Time Application engine processes the event itself, and it does not deliver it to the Task B application program.</li><li>the Real-Time Application engine sends a re-INVITE signal to the Task B peer, switching it to the Media source of the new Task A peer.</li></ul><p><img src="'+r+'" alt="Bridged REFER Illustration"></p><p>When the Tasks A and B are in the &quot;bridged&quot; state, one of the Tasks (Task A here) can receive Call Transfer (INVITE with Replaces) signal (delivered to it by the <a href="./../admin/cluster/Signals.html">Signal</a> module based on the Replaces field content):</p><ul><li>the Real-Time Application engine automatically sends a special <code>[bridgeUpdate]</code> event to the Task B, with new Task A peer media parameters.</li><li>the Real-Time Application engine sends a re-INVITE signal to the Task B peer, switching it to the Media source of the Task A new peer.</li><li>the Real-Time Application engine sends the INVITE response to the new Task A peer with the Task B peer media parameters, connecting the new Task A peer and the Task B peer media.</li></ul><p>When the Tasks A and B are in the &quot;bridged&quot; state, one of the Tasks (Task A here) can decide to break the Media Bridge:</p><ul><li>an application program the Task A is running uses the <a href="#Signals">BreakBridge</a> CG/PL function to break the Media bridge.</li><li>the Real-Time Application engine automatically sends a special <code>[bridgeClose]</code> event to the Task B, and sends a re-INVITE signal to the Task A peer, switching it to the Task A Media Channel.</li><li>when the Task B receives the <code>[bridgeClose]</code> event, the Real-Time Application engine automatically sends a re-INVITE request to the Task B peer switching it to the Task B Media Channel.</li><li>the Real-Time Application engine delivers the <code>[bridgeClose]</code> event to the Task B application program.</li></ul><p><img src="'+p+'" alt="Bridge Break Illustration"></p><p>When the Tasks A and B are in the &quot;bridged&quot; state, one of the Tasks (Task A here) can receive a disconnect (BYE) signal from its peer, or it can quit for various reasons. In this case:</p><ul><li>the Real-Time Application engine automatically sends a special <code>[bridgeClose]</code> event to the Task B.</li><li>when the Task B receives the <code>[bridgeClose]</code> event, the Real-Time Application engine automatically sends a re-INVITE request to the Task B peer switching it to the Task B Media Channel.</li><li>the Real-Time Application engine delivers the <code>[bridgeClose]</code> event to the Task B application program.</li></ul><p><img src="'+d+`" alt="Bridge Disconnect Illustration"></p><p>The Real-Time Application engine may choose to implement a Media Bridge using one Task Media Channel as a &quot;media relay&quot;.</p><h3 id="B2BUA" tabindex="-1">B2BUAs (Back-to-Back User Agents) <a class="header-anchor" href="#B2BUA" aria-label="Permalink to &quot;B2BUAs (Back-to-Back User Agents) {#B2BUA}&quot;">​</a></h3><p>The Bridged Call functionality is used to implement the B2BUA (Back-to-Back User Agents) technology. A pair of Real-Time Tasks in the Bridged Mode can work as a &quot;smart proxy&quot;: while peers connected to these tasks can communicate directly, the signaling is still controlled with the Tasks and the application programs these Tasks are running.</p><h2 id="CGPL" tabindex="-1">CG/PL Applications <a class="header-anchor" href="#CGPL" aria-label="Permalink to &quot;CG/PL Applications {#CGPL}&quot;">​</a></h2><p>Real-Time Applications can be written using the <a href="./CGPL.html">CG/PL</a> language.</p><p>When a Task is created to process an incoming call, the <code>main</code> entry of the specified CG/PL application program is executed.</p><p>Real-Time Applications can use CG/PL <a href="./CGPL.html#ProcDefs">external-declarations</a>. When a code section (a procedure or a function) declared as <em>external</em> is called, a file with the code section name and the <code>.sppi</code> extension is loaded from the current Environment. The program code in this file must contain the code section with the specified name and of the proper type (a procedure or a function).<br> The program code in an <code>.sppi</code> file may contain other code sections as well.</p><p>Real-Time Applications can use the following built-in procedures and functions.</p><h3 id="Input" tabindex="-1">Input <a class="header-anchor" href="#Input" aria-label="Permalink to &quot;Input {#Input}&quot;">​</a></h3><ul><li><p><code>ReadInput(timeOut)</code></p><p>This function is used to receive external Task communications: DTMF symbol entered by the peer, signals sent by the peer, and Events sent by other Tasks and by the system itself. See the CG/PL <a href="./CGPL.html#Events">Events</a> section for the detail.<br> The <em>timeOut</em> value should be a number specifying the maximum wait period (in seconds). If the <em>timeOut</em> value is zero, the function checks for pending digits and events, without any waiting.<br> The function returns:</p><ul><li>a string with the first <a href="#DTMF">DTMF</a> symbol in the Task DTMF buffer. The symbol is removed from the Task buffer.</li><li>a dictionary with the first waiting <a href="./CGPL.html#Events">Event</a>. The Event is removed from the Task Event queue.</li><li>a null-value if no DTMF symbol and no Event was received during the specified time period.</li></ul></li></ul><p>When the peer disconnects, the Task receives a Disconnect Event from the system (this Event dictionary does not contain the <code>.sender</code> element).</p><ul><li><p><code>IsDisconnectEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a Disconnect Event.</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: ReadInput()</span></span>
<span class="line"><span>//   Accept an incoming call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Play the PressPound media file.</span></span>
<span class="line"><span>//   Wait for any input for up to 5 seconds.</span></span>
<span class="line"><span>//   If the &quot;pound&quot; (&quot;#&quot;) symbol was entered,</span></span>
<span class="line"><span>//     play the Good media file.</span></span>
<span class="line"><span>//   Otherwise,</span></span>
<span class="line"><span>//     play the Bad media file.</span></span>
<span class="line"><span>//   Stop.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  PlayFile(&quot;PressPound&quot;);</span></span>
<span class="line"><span>  PlayFile(ReadInput(5) == &quot;#&quot; ? &quot;Good&quot; : &quot;Bad&quot;);</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><h3 id="Signals" tabindex="-1">Signals <a class="header-anchor" href="#Signals" aria-label="Permalink to &quot;Signals {#Signals}&quot;">​</a></h3><ul><li><p><code>AcceptCall()</code></p><p>This function accepts an incoming session, if there is one: the Task should be in the <code>incoming</code> or <code>provisioned</code> mode.<br> This function returns a null-value if the session is accepted successfully, and the Task is placed into the <code>connected</code> mode.<br> If a session cannot be accepted, this function returns an error code string, and the Task is placed into the <code>disconnected</code> mode.</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: AcceptCall()/RejectCall()</span></span>
<span class="line"><span>//   If the current local time is not between 8:00 and 17:00,</span></span>
<span class="line"><span>//     reject the call (with the 403 error code) and stop.</span></span>
<span class="line"><span>//   Otherwise,</span></span>
<span class="line"><span>//     accept the call (stop if it is not possible)</span></span>
<span class="line"><span>//     play the Welcome media file and stop.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  currentTime = TimeOfDay(GMTToLocal(GMTTime()));</span></span>
<span class="line"><span>  currentHour = currentTime / 3600;</span></span>
<span class="line"><span>  if currentHour &lt; 8 or currentHour &gt;= 17 then</span></span>
<span class="line"><span>    RejectCall(403); stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  PlayFile(&quot;Welcome&quot;);</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><ul><li><p><code>RedirectCall(newURI)</code></p><p>This procedure redirects an incoming session, if there is one: the Task should be in the <code>incoming</code> or <code>provisioned</code> mode.<br> The <em>newURI</em> value should be a string, or an array of strings. The incoming session is redirected to the URI(s) specified and the Task is placed into the <code>disconnected</code> mode.</p></li><li><p><code>ForkCall(newURI)</code></p><p>This procedure redirects an incoming session, if there is one: the Task should be in the <code>incoming</code> or <code>provisioned</code> mode.<br> The <em>newURI</em> value should be a string, or an array of strings. The incoming session is directed to the URI(s) specified, and the current Task remains in the same state, so it can accept, reject, redirect, provision, or fork this call later.</p></li><li><p><code>ProvisionCall(media,reliably)</code></p><p>This function sends a provisional Response for an incoming session Request, if there is a pending one: the Task should be in the <code>incoming</code> or <code>provisioned</code> mode.<br> If the <em>media</em> value is not a null-value, then a Task Media Channel is created, the Task is placed into the <code>provisioned</code> mode and the Media Channel operations (such as <code>PlayFile</code>) can be used to generate &quot;ring-back tones&quot;.<br> If the <em>reliably</em> value is not a null-value, the response confirmation (SIP <code>PRACK</code>) is requested, and the Task is suspended till a confirmation request arrives.<br> This function returns a null-value if the response is sent successfully.<br> If a provisional response cannot be sent, this function returns an error code string.</p></li><li><p><code>ProvisionCall(parameters)</code></p><p>This function is an extension of the <code>ProvisionCall</code> function shown above. The function parameters are specified using the <em>parameters</em> dictionary, which can contain the following elements:</p><ul><li><p><code>media</code></p><p>if this element is present, then it has the same effect as a non-null value of the <em>media</em> parameter of the ProvisionCall function.</p></li><li><p><code>reliably</code></p><p>if this element is present, then it has the same effect as a non-null value of the <em>reliably</em> parameter of the ProvisionCall function.</p></li><li><p><code>responseCode</code></p><p>if this element is present, its value should be a number in the 101..199 range (inclusive). It specifies the numeric Response code sent. If this element is not present, the 180 value is used.</p></li><li><p><code>responseText</code></p><p>if this element is present, its value should be a string. It specifies the textual Response code sent. If this element is not present, the default Response text is used.</p></li><li><p><code>reasonCode</code></p><p>if this element is present, its value should be a positive number. The Reason header field is added to the Response, using this element and the <code>reasonText</code> element values.<br> If the element value is less than 1000, the composed field contains SIP as the &quot;protocol&quot; value, otherwise the protocol value is set to Q.850, and 1000 is substracted from the element value.</p></li><li><p><code>reasonText</code></p><p>if this element is present, its value should be a string. This element is used only when the <code>reasonCode</code> element is a positive number.</p></li></ul></li><li><p><code>RejectCall(responseCode)</code></p><p>This procedure rejects an incoming session if there is one: the Task should be in the <code>incoming</code> or <code>provisioned</code> mode.<br> The <em>responseCode</em> value should be a numeric value between 400 and 699, or an error code string. This number is sent back to the caller as the Signal Response code. If the code 401 is sent back, and the request came from outside the CommuniGate Pro Server (via the <a href="./../admin/signals/SIP.html">SIP</a> protocol), the SIP server module adds the proper fields to the response to facilitate client Authentication.<br> Alternatively, the <em>responseCode</em> value can be a dictionary with the optional <code>responseCode</code>, <code>responseText</code>, <code>reasonCode</code>, <code>reasonText</code> elements, which have the same meanings as the elements of the <code>ProvisionCall()</code> function parameter.<br> The Task is placed into the <code>disconnected</code> mode.</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: RedirectCall()/ProvisionCall()</span></span>
<span class="line"><span>//   Provision the call (stop if it is not possible).</span></span>
<span class="line"><span>//   If the current local time is between 12:00 and 13:00,</span></span>
<span class="line"><span>//     fork the call to user1 in the same domain.</span></span>
<span class="line"><span>//   Play the &quot;PleaseWait&quot; media file.</span></span>
<span class="line"><span>//   If the current local time is not between 8:00 and 17:00,</span></span>
<span class="line"><span>//     redirect the call to user2 in the same domain, and stop.</span></span>
<span class="line"><span>//   Otherwise,</span></span>
<span class="line"><span>//   Accept the call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Play the Welcome media file, and stop.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if ProvisionCall(true,true) != null then stop; end if;</span></span>
<span class="line"><span>  currentTime = TimeOfDay(GMTToLocal(GMTTime()));</span></span>
<span class="line"><span>  currentHour = currentTime / 3600;</span></span>
<span class="line"><span>  if currentHour &gt;= 12 and currentHour &lt;= 13 then</span></span>
<span class="line"><span>    ForkCall(&quot;sip:user1@&quot; + MyDomain());</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>  PlayFile(&quot;PleaseWait&quot;);</span></span>
<span class="line"><span>  if currentHour &lt; 8 or currentHour &gt;= 17 then</span></span>
<span class="line"><span>    RedirectCall(&quot;sip:user2@&quot; + MyDomain());</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  PlayFile(&quot;Welcome&quot;);</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If a pending incoming call has been canceled, the Task receives a Disconnect Event, and the Task mode changes to <em>disconnected</em>.</p></div><ul><li><p><code>SetCallParameters(parameters)</code></p><p>This procedure sets call (INVITE dialog) parameters.<br> The <em>parameters</em> value should be a dictionary with new call option parameters. The existing parameter values are removed.<br> The following parameters are used for all dialog requests:</p><ul><li><p><code>Max-Forwards</code></p><p>a positive number used to limit the number of &quot;hops&quot; a request can traverse.</p></li><li><p><code>customIdentity</code></p><p>a string or a dictionary to be used as the request <code>P-Asserted-Identity</code> header field. This field is also added to the provisioning responses.</p></li><li><p><code>Privacy</code></p><p>a string or an array of strings to be used as the request <code>Privacy</code> header field.</p></li><li><p><code>IPSource</code></p><p>the IP Address object that overrides the Server rules and explicitly sets the source IP Address for outgoing SIP packets and locally generated media.</p></li><li><p><code>allowedAudioCodecs</code></p><p>if this parameter is an array, it lists the names of audio codecs that can be included into SDP documents sent with this task.</p></li><li><p><code>allowedVideoCodecs</code></p><p>if this parameter is an array, it lists the names of video codecs that can be included into SDP documents sent with this task. If this array is empty, the sent SDP does not include the &quot;video&quot; media, unless this SDP is an answer to an SDP offer that includes the &quot;video&quot; media.</p></li><li><p><code>allowedSSRC</code></p><p>if this parameter is &quot;NO&quot;, all &quot;ssrc&quot; attributes are removed from SDP.</p></li><li><p><code>allowedAttributes</code></p><p>if this parameter is &quot;nonCustom&quot;, all custom attributes (with names starting with <code>x-</code>) are removed from SDP.<br> if this parameter is &quot;required&quot;, all attributes except the required ones are removed from SDP. The &quot;phone&quot;, &quot;info&quot;, &quot;uri&quot;, &quot;email&quot;, &quot;time&quot;, &quot;zone&quot;, &quot;key&quot;, &quot;bandwidth&quot;, &quot;title&quot; SDP elements are removed, too.<br> The following parameters are used when a call dialog is established:</p></li><li><p><code>Session-Expires</code></p><p>a non-negative number specifying the default session expiration (dialog refreshing) time period. If set to zero, no dialog refreshing takes place.<br> Some parameters are used when a call is initiated (with the <code>StartCall</code>, <code>StartBridgedCall</code> functions) or when a call is accepted (with the <code>AcceptCall</code> function) - see below.</p></li></ul></li><li><p><code>StartCall(destination)</code></p><p>This function initiates an outgoing session. The Task should be in the <code>disconnected</code> mode.<br> The <em>destination</em> value should be a string containing the URI to send a session request to, or a dictionary containing the following string elements:</p><ul><li><p><code>&quot;&quot;</code> (empty string)</p><p>the URI to send the request to.</p></li><li><p><code>From</code> (optional)</p><p>an E-mail, URI, or field-data to use for the request <code>From</code> field. If not specified, the current Account data is used.</p></li><li><p><code>To</code> (optional)</p><p>an E-mail, URI, or field-data to use for the request <code>To</code> field. If not specified, the request URI is used.</p></li><li><p><code>Call-ID</code> (optional)</p><p>a string to use for the request <code>Call-ID</code> field. If not specified, a new Call-ID is generated. The following optional parameters are taken from the <em>destination</em> dictionary. If they are absent (or the <em>destination</em> is not a dictionary), they are taken from the current call parameters set with the <code>SetCallParameters</code> procedure:</p></li><li><p><code>authUsername</code>, <code>authPassword</code></p><p>credentials (the authenticated name and password strings) to be used if an outgoing request is rejected with the 401 error code.</p></li><li><p><code>Expires</code></p><p>a number specifying the maximum calling (alerting) time (in seconds).</p></li><li><p><code>Subject</code></p><p>request Subject string.</p></li><li><p><code>Remote-Party-Id</code></p><p>an array of dictionaries, each used to compose request <code>Remote-Party-Id</code> fields.</p></li><li><p><code>Privacy</code></p><p>a string or an array of strings to compose the request <code>Privacy</code> field.</p></li><li><p><code>Diversion</code></p><p>an array to compose the request <code>Diversion</code> fields.</p></li><li><p><code>P-CGP-Private</code></p><p>a string to compose the request <code>P-CGP-Private</code> field. This field can be used to pass arbitrary parameters between sending and receiving Tasks (on the same or different systems).</p></li><li><p><code>P-CGP-Local</code></p><p>a string to compose the request <code>P-CGP-Local</code> field. This field can be used to pass arbitrary parameters between sending and receiving Tasks (only within the same single-server or Cluster systems).</p></li><li><p><code>P-Billing-Id</code></p><p>a string to compose the request <code>P-Billing-Id</code> field stored in the Call object. This string is added to the server-generated CDRs.</p></li><li><p><code>Call-Info</code></p><p>an array to compose the request <code>Call-Info</code> fields.</p></li><li><p><code>Alert-Info</code></p><p>a string to compose the request <code>Alert-Info</code> field.</p></li><li><p><code>Replaces</code></p><p>a string or a dictionary to compose the request <code>Replaces</code> field. If a dictionary is used, it should contain the string values <code>Call-ID</code>, <code>fromTag</code>, <code>toTag</code>, and a boolean value <code>early-only</code>.</p></li><li><p><code>Via</code></p><p>if this string parameter is specified, it should contain a URI. The URI is added to the request as its Route field, forcing the request to be sent via that URI.</p></li><li><p><code>NoInitSDP</code></p><p>if this parameter is specified, the call establishment request does not contain the local Media channel SDP.</p></li><li><p><code>No100rel</code></p><p>if this parameter is specified, the outgoing requests do not have the &quot;100rel&quot; SIP option advertised as supported.</p></li><li><p><code>mediaRelay</code></p><p>if this parameter exists, a Media Proxy is always created for an outgoing call.</p></li><li><p><code>TimerB</code></p><p>if this parameter exists, its numeric value overrides the default &quot;Timer B&quot; value for an outgoing SIP transaction: this is the number of seconds to wait till the remote site sends any response (such as 100-Trying).</p></li><li><p><code>Relay</code></p><p>if this parameter exists and its value is &quot;NO&quot;, the outgoing SIP request cannot be relayed to non-client destinations.</p></li><li><p><code>encryptMedia</code></p><p>if this parameter exists and its value is &quot;NO&quot;, SDP documents (offers) sent with this task will not include elements needed to enabled media encryption. This function returns an error code string if an outgoing call cannot be initiated.<br> If an outgoing call has been initiated successfully, the function returns a null-value, and the Task starts to receive call progress Events from the system: zero or more <em>provisional response</em> Events, followed by exactly one <em>final response</em> Event.<br> If the outgoing session has been established successfully, the Task receives a final response Event without a parameter.<br> If the outgoing session has not been established, the Task receives a final response Event with a parameter - the error code string.</p></li></ul></li><li><p><code>IsCallProvisionEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a call provisional response Event. Otherwise the function returns a null-value.</p></li><li><p><code>IsCallCompletedEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a call final response Event. Otherwise the function returns a null-value. When a Task receives a final response Event, the call signaling process has completed. If the Event has a parameter, the call has failed, and the parameter contains the error code string.</p></li><li><p><code>CancelCall()</code></p><p>If a Task has a pending outgoing call (initiated using the StartCall function), this procedure cancels that call (the Task will not receive a final response Event).</p></li><li><p><code>Disconnect()</code><br><code>Disconnect(reasonCode,reasonText)</code></p><p>This procedure ends the active session, if any, and the Task is placed into the <code>disconnected</code> mode.<br> If the <em>reasonCode</em> is specified, its value should be a positive number, and if the <em>reasonText</em> is specified, its value should be a string. If the BYE signal is sent to the peer, the Reason header field with the <em>reasonCode</em> and <em>reasonText</em> values is added to the signal request.</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: StartCall()/Disconnect()</span></span>
<span class="line"><span>//   Accept an incoming call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Remember the caller URI.</span></span>
<span class="line"><span>//   Play the CallBack media file.</span></span>
<span class="line"><span>//   Disconnect();</span></span>
<span class="line"><span>//   Call the caller back (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Play the IamBack media file, and stop.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  fromWhom = RemoteURI();</span></span>
<span class="line"><span>  PlayFile(&quot;CallBack&quot;);</span></span>
<span class="line"><span>  Disconnect();</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if StartCall(fromWhom) != null then stop; end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  loop</span></span>
<span class="line"><span>    input = ReadInput(3600);</span></span>
<span class="line"><span>  exitif not IsCallProvisionEvent(input);</span></span>
<span class="line"><span>    null;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if not IsCallCompletedEvent(input) or else</span></span>
<span class="line"><span>     input.parameter != null then stop; end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  PlayFile(&quot;IamBack&quot;);</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><ul><li><p><code>IsConnected()</code></p><p>This function returns a true-value if the Task is in the <code>connected</code> mode.</p></li><li><p><code>IsHalfConnected()</code></p><p>This function returns a true-value if the Task is in the <code>connected</code> or <code>provisioned</code> mode.</p></li></ul><h3 id="Dialog" tabindex="-1">Dialog <a class="header-anchor" href="#Dialog" aria-label="Permalink to &quot;Dialog {#Dialog}&quot;">​</a></h3><ul><li><p><code>RemoteURI()</code></p><p>This function returns a string with the peer URI (taken from the dialog From/To addresses). If there is no session in place, the function returns a null-value.</p></li><li><p><code>LocalURI()</code></p><p>This function returns a string with the Task URI.</p></li><li><p><code>IncomingRequestURI()</code></p><p>This function returns a string with URI of the pending incoming INVITE request. If there is no pending incoming INVITE request, the function returns a null-value.</p></li><li><p><code>RouteLocalURI(uri)</code></p><p>This function tries to <a href="./../admin/sysadmin/Router.html">Route</a> the E-mail address from the specified URI. If the URI cannot be parsed, or the URI address cannot be routed, or it routes to a non-local address (i.e an E-mail address hosted on a different system), this function returns a null-value. Otherwise, the function returns the E-mail address of the CommuniGate Pro user the original URI address is routed to.<br> This function allows you to correctly process all <a href="./../admin/objects/Forwarders.html">Forwarders</a>, <a href="./../admin/objects/Accounts.html#Aliases">Aliases</a>, and other CommuniGate Pro Routing methods.</p></li><li><p><code>RemoteIPAddress()</code></p><p>This function returns an ip-address object the session establishment request was received from or was sent to. This IP Address/port pair is the actual peer address or the address of a proxy used to relay the peer signaling.</p></li><li><p><code>RemoteAuthentication()</code></p><p>This function returns a null-value if the session starting request was not authenticated, or a string with the authenticated user E-mail address.</p></li><li><p><code>PendingRequestData(fieldName)</code></p><p>This function returns a data element of the pending incoming request.<br> If a request is pending, the function returns the following data, depending on the <em>fieldName</em> value, which should be a string:</p><ul><li><p><code>Call-ID</code></p><p>the function returns a string with the request Call-ID value.</p></li><li><p><code>From</code>, <code>To</code>, <code>Referred-By</code></p><p>the function returns a dictionary if the field exists in the request. The dictionary contains the following elements:</p><ul><li><p><code>&quot;&quot;</code> (and element with empty string key)</p><p>the address (in the <em>username@domain</em> form)</p></li><li><p><code>@realName</code></p><p>a string with the &quot;display-name&quot; part of the address</p></li><li><p><code>@schema</code></p><p>a string with the URI schema (if absent, <code>sip</code> is assumed)</p></li><li><p><code>@port</code></p><p>a number with the &quot;port&quot; part of the URI</p></li><li><p><code>@tag</code></p><p>the &quot;tag&quot; field parameter</p></li><li><p><code>@field-params</code></p><p>a dictionary with other field parameters.</p></li><li><p><code>@headers</code></p><p>a dictionary with URI headers.</p></li><li><p><code>anyOtherName</code></p><p>a URI parameter. All elements except the address element are optional.</p></li></ul></li><li><p><code>Remote-Party-Id</code>, <code>History-Info</code></p><p>the function returns an array if the field or fields exist in the request. Each array element is a dictionary with the same elements as in the <code>From</code> field dictionary.</p></li><li><p><code>Foreign-Asserted-Identity</code></p><p>the function returns an array of the request <code>P-Asserted-Identity</code> fields. Each dictionary contains the same elements as the <code>From</code> field dictionary.</p></li><li><p><code>Route</code>, <code>Record-Route</code>, <code>Diversion</code>, <code>Via</code>, <code>Path</code>, <code>Supported</code>, <code>Require</code>, <code>Proxy-Require</code>, <code>Privacy</code>, <code>Allow</code>, <code>Allow-Events</code></p><p>the function returns an array containing one or more strings with field values. If no field value exists, the function returns a null-value.</p></li><li><p><code>CSeq</code></p><p>the function returns a number - the value of the CSeq field numeric part.</p></li><li><p><code>Max-Forwards</code></p><p>the function returns a number - the value of the Max-Forwards field.</p></li><li><p><code>User-Agent</code>, <code>Reason</code>, <code>P-CGP-Private</code>, <code>P-CGP-Local</code></p><p>the function returns a string - the field value. If the field is absent, the function returns a null-value.</p></li><li><p><code>Accept</code></p><p>the function returns an array containing 2 strings for each field value: the accepted content type and the accepted content subtype. If the field is absent, the function returns a null-value.</p></li><li><p><code>xmlsdp</code></p><p>the function returns an <a href="./Data.html#XML">XML presentation</a> of the pending request SDP. If no request is pending, the function returns a null-value.</p></li></ul></li><li><p><code>PendingRequestExData(fieldName)</code></p><p>This function returns a non-standard data element of the pending incoming request.<br> The <em>fieldName</em> value should be a string. It specifies the name of a non-standard request field.<br> If a request is pending, the function returns specified field data.<br> If no request is pending, the function returns a null-value.</p></li><li><p><code>SetLocalContactParameter(paramName,paramValue)</code></p><p>This procedure allows you to add &quot;field&quot; parameters to the Contact field data for this Task dialog(s).<br> The <em>paramName</em> value should be a string. It specifies the field parameter name.<br> If the <em>paramValue</em> value is a non-empty string, it specifies the field parameter value.<br> If the <em>paramValue</em> value is an empty string, a parameter without a value is set (such as <code>isfocus</code>).<br> If the <em>paramValue</em> value is a null-value, a previously set field parameter is removed.</p></li></ul><h3 id="DTMF" tabindex="-1">DTMF <a class="header-anchor" href="#DTMF" aria-label="Permalink to &quot;DTMF {#DTMF}&quot;">​</a></h3><p>Each Task has a DTMF buffer string. When a DTMF symbol is received either in an INFO Request or as a media packet (via the Media Channel), the symbol is appended to this buffer.</p><ul><li><p><code>DTMF()</code></p><p>This function returns a string with the current content of the DTMF buffer. The DTMF buffer is not changed. Usually this function is not used, the <code>ReadInput()</code> function is used instead.</p></li><li><p><code>ClearDTMF()</code></p><p>This procedure empties the DTMF buffer.</p></li><li><p><code>SetInterruptOnDTMF(arg)</code></p><p>This function sets a flag controlling media playing and recording interrupts with received DTMF symbols.<br> The <em>arg</em> value specifies the new flag value: if this value is a null-value, received DTMF symbols will not interrupt media playing or recording, otherwise received DTMF symbols will interrupt media playing and recording.<br> When a Task is created, this flag value is set to a true-value.<br> The function returns the previous value of this flag.</p></li><li><p><code>SendDTMF(symbol)</code></p><p>This function sends a DTMF symbol to the peer.<br> The <em>symbol</em> value should be a string containing 1 DTMF symbol.<br> The function returns a null-value if the symbol has been sent, or a string with an error code if sending failed.</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: ReadInput()/SendDTMF()</span></span>
<span class="line"><span>//   Accept an incoming call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Wait for an input for 10 seconds. If no input - stop.</span></span>
<span class="line"><span>//   If a digit is entered</span></span>
<span class="line"><span>//      play that digit, and send it back.</span></span>
<span class="line"><span>//      (using &quot;0&quot; ... &quot;9&quot; files)</span></span>
<span class="line"><span>//   If a star (&quot;*&quot;) is entered,</span></span>
<span class="line"><span>//     wait for a digit (for 3 seconds)</span></span>
<span class="line"><span>//     and play the digit number square (2 digits)</span></span>
<span class="line"><span>//   If a pound (&quot;#&quot;) is entered or the Peer</span></span>
<span class="line"><span>//     has disconnected, or any Event was sent, stop.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  loop</span></span>
<span class="line"><span>    input = ReadInput(10);</span></span>
<span class="line"><span>	if input == &quot;*&quot; then</span></span>
<span class="line"><span>	  input = ReadInput(3);</span></span>
<span class="line"><span>	  if IsString(input) and input != &quot;#&quot; then</span></span>
<span class="line"><span>	    input = &quot;*&quot; + input;</span></span>
<span class="line"><span>	  end if;</span></span>
<span class="line"><span>	end if;</span></span>
<span class="line"><span>  exitif not IsString(input) or input == &quot;#&quot;;</span></span>
<span class="line"><span>    if Substring(input,0,1) != &quot;*&quot; then</span></span>
<span class="line"><span>	  PlayFile(input);</span></span>
<span class="line"><span>	  void(SendDTMF(input));</span></span>
<span class="line"><span>	else</span></span>
<span class="line"><span>	  input = Number(Substring(input,1,1);</span></span>
<span class="line"><span>	  product = input *  input;</span></span>
<span class="line"><span>	  PlayFile(String(product/10));</span></span>
<span class="line"><span>	  PlayFile(String(product%10));</span></span>
<span class="line"><span>	end if;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><h3 id="Media" tabindex="-1">Media <a class="header-anchor" href="#Media" aria-label="Permalink to &quot;Media {#Media}&quot;">​</a></h3><ul><li><p><code>PlayFile(fileName)</code><br><code>PlayFile(fileName,msec)</code></p><p>This procedure retrieves a file from its Application Environment and plays it. The string parameter <em>fileName</em> specifies the file name. If the specified file name does not contain a file name extension, the <a href="#Formats">supported extensions</a> are added and tried.<br> The file should contain media data in one of the <a href="#Formats">supported formats</a>.<br> If the <em>msec</em> parameter is specified, its value should be a number. Then the specified file is played for <em>msec</em> milliseconds, repeating file in a loop if the file media playing period is shorter than the specified period. If the <em>msec</em> parameter has a negative value, the file is played in an infinite loop.<br> Playing is suppressed or interrupted if the session ends, if the DTMF buffer is not empty (unless DTMF Interruption is disabled), or if there is an Event enqueued for this Task.</p></li><li><p><code>Play(waveData)</code><br><code>Play(waveData,msec)</code></p><p>This procedure plays the <em>waveData</em> value which should be a datablock.<br> The datablock should contain media data in one of the <a href="#Formats">supported formats</a>.<br> If the <em>msec</em> parameter is specified, it works in the same way as it works for the PlayFile procedure.<br> Playing is suppressed or interrupted if the session ends, if the DTMF buffer is not empty (unless DTMF Interruption is disabled), or if there is an Event enqueued for this Task.</p></li><li><p><code>PlayTone(freq,msec)</code><br><code>PlayTone(freq,msec,freq2)</code><br><code>PlayTone(freq,msec,freq2,ratio)</code></p><p>This procedure plays a &quot;tone&quot; (a sine wave). The <em>freq</em> parameter value should be a non-negative number - the wave frequency (in Hz). If the value is zero, audio silence is generated.<br> The <em>msec</em> parameter value should be a number, it works in the way as it works for the PlayFile procedure.<br> If the <em>freq2</em> parameter is specified, the generated tone is a combination of two sine waves, and the parameter value should be a positive number specifying the second wave frequency (in Hz).<br> If the <em>ratio</em> parameter is specified, its value should be a positive number in the 1..10000 range. It specifies the relative amplitude of the second wave, the first wave amplitude being 100.<br> Playing is suppressed or interrupted if the session ends, if the DTMF buffer is not empty (unless DTMF Interruption is disabled), or if there is an Event enqueued for this Task.</p></li><li><p><code>GetPlayPosition()</code></p><p>This function returns a number - the portion of the media (in milliseconds) played by the last <code>PlayFile</code> or <code>Play</code> operation.<br> If the media was played in a loop, the length of the played portion in the last &quot;loop&quot; is returned: if a 3-second sound was played in loop, and it was interrupted after 7.2 seconds, the function returns 1200.<br> If the last Play* operation did not play its sound (because the DTMF buffer was not empty or there was an enqueued Event), the function returns either 0, or a negative value.</p></li><li><p><code>SetPlayPosition(arg)</code></p><p>This procedure instructs the very next <code>Play*</code> operation to start playing its sound not from its beginning.<br> The <em>arg</em> value should be a non-negative number. It specifies how many milliseconds of the media should be skipped before the Play* operation starts to play the media.</p></li><li><p><code>IsPlayCompleted()</code></p><p>This function returns a true-value if the media played by the last <code>Play*</code> operation was played in full. If media playing was interrupted, the function returns a null-value.</p></li><li><p><code>Record(timeLimit)</code></p><p>This function records incoming audio data. The <em>timeLimit</em> value should be a positive number, it specifies the maximum recording time in seconds.<br> Recording is suppressed or interrupted if the session ends, if the DTMF buffer is not empty, or if there is an Event enqueued for this Task.<br> The function returns a null-value if recording was suppressed, or a datablock with the recorded sound in the <code>WAV</code> format.</p></li><li><p><code>SetLocalHold(flag)</code></p><p>This procedure sets the current call &quot;on Hold&quot; (if the <em>flag</em> is a true-value), or releases the call from hold (if the <em>flag</em> is a null-value).<br> This procedure can be used only when the Task is in the <em>connected</em> mode, and the Task peer media is not bridged.</p></li><li><p><code>ReleaseMediaChannel()</code></p><p>This procedure releases the Task Media Channel (releasing the associated system resources).<br> This procedure can be used only when the Task is in the <em>disconnected</em> mode, or when the Task peer media is bridged.</p></li><li><p><code>MediaOption(optionName)</code><br><code>MediaOption(optionName,newValue)</code></p><p>This function return the current value of a Task Media Channel option.<br> If the <em>newValue</em> is specified and its value is not a null-value, then it is set as the new option value.<br> The <em>optionName</em> value should be a string and it specifies the option name. The following options are supported:</p><ul><li><p>&quot;preplay&quot;</p><p>this a numeric option, is specifies the amount of pre-recorded media (in milliseconds) sent to remote peers &quot;ahead of time&quot;, to pre-fill the peer jitter buffers.</p></li><li><p>&quot;mixerDelay&quot;</p><p>this a numeric option, it specifies the delay (in milliseconds) the Media Channel introduces before it reads Media Leg audio and mixes it with other Media Leg audio when a Media Channel has more than 2 active Media Legs (&quot;conferencing&quot;). The larger the delay, the better the Media Channel mixer processes irregular media streams coming from conference participants connected via sluggish networks.</p></li><li><p>&quot;inputSilenceLevel&quot;</p><p>this a numeric option, it specifies the minimum level of the incoming audio. If the level is lower than the specified value, it is processed as a complete silence - it is not recorded and if there are more than 2 Media Legs (&quot;conferencing&quot;), this Media Leg incoming audio is not used mixed.</p></li><li><p>&quot;skipSilence&quot;</p><p>this a numeric option, it specifies a time limit (in milliseconds). When the Media Channel is used to record the incoming media and the incoming audio level is lower than the &quot;silence level&quot; (see above), and this silence lasts longer than the specified time limit, recording is suspended. It resumes as soon as the incoming audio level increases above the &quot;silence level&quot;.</p></li><li><p>&quot;stopRecordOnPause&quot;</p><p>this a numeric option, it controls recording of silence. When the Media Channel is used to record the incoming media and the incoming audio level is lower than the &quot;silence level&quot; (see above), and this silence lasts longer than the time limit specified with the &quot;skipSilence&quot; option (see above), recording is stopped if the value if this option is set to 1. The Task also receives special DTMF signal #15.</p></li><li><p>&quot;mixMOH&quot;</p><p>this a numeric option, it specifies if media from a peer sending MOH (Music-on-hold) should be processed or it should be ingnored. If the value is 1, the MOH media is processed, if the value is 0 (default), the MOH media is ignored.<br> If there are not more than two peers connected to the Media Channel, MOH media is always processed.</p></li></ul></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: Record()/PlayFile()/Play()</span></span>
<span class="line"><span>//   Accept an incoming call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Play the GreetingIs file.</span></span>
<span class="line"><span>//   Read the current prompt from</span></span>
<span class="line"><span>//      the MyGreeting.wav file in the File Storage.</span></span>
<span class="line"><span>//   Loop playing the greeting.</span></span>
<span class="line"><span>//      if &quot;1&quot; is entered, rewrite the prompt file and quit</span></span>
<span class="line"><span>//      if &quot;2&quot; is entered, play &quot;Beep&quot; and record the prompt.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span>  PlayFile(&quot;GreetingIs&quot;);</span></span>
<span class="line"><span>  prompt = ReadStorageFile(&quot;MyGreeting.wav&quot;);</span></span>
<span class="line"><span>  loop</span></span>
<span class="line"><span>    if IsData(prompt) then Play(prompt); end if;</span></span>
<span class="line"><span>    input = ReadInput(10);</span></span>
<span class="line"><span>  exitif not IsString(input) or else input == &quot;#&quot;;</span></span>
<span class="line"><span>    if input == &quot;1&quot; then</span></span>
<span class="line"><span>	  if WriteStorageFile(&quot;MyGreeting.wav&quot;,prompt) then</span></span>
<span class="line"><span>	    PlayFile(&quot;Goodbye&quot;); stop;</span></span>
<span class="line"><span>	  end if;</span></span>
<span class="line"><span>	  PlayFile(&quot;Failure&quot;);</span></span>
<span class="line"><span>	elif input == &quot;2&quot; then</span></span>
<span class="line"><span>	  PlayFile(&quot;Beep&quot;);</span></span>
<span class="line"><span>	  prompt = Record(30);</span></span>
<span class="line"><span>	else</span></span>
<span class="line"><span>	  PlayFile(&quot;InvalidEntry&quot;);</span></span>
<span class="line"><span>	end if;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span>  PlayFile(&quot;GoodBye&quot;);</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><h3 id="Bridge" tabindex="-1">Bridges and Mixers <a class="header-anchor" href="#Bridge" aria-label="Permalink to &quot;Bridges and Mixers {#Bridge}&quot;">​</a></h3><ul><li><p><code>StartBridge(taskRef)</code></p><p>This function sends a special <em>StartBridge</em> Event to the specified Task asking it to take over this Task peer media.<br> The <em>taskRef</em> value should be a task handle. It specifies the Task to send the request to.<br> This function returns a null-value if the specified Task successfully took over this Task peer media. Otherwise, the function returns an error code string.<br> The current Task should be in the <code>incoming</code>, <code>provisioned</code>, or <code>connected</code> mode.<br> The current Task is placed into the waiting state, and the target Task receives a special <em>StartBridge</em> Event.</p></li><li><p><code>IsStartBridgeEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a <em>StartBridge</em> Event. Otherwise the function returns a null-value.</p></li><li><p><code>RejectBridge(input,errorCode)</code></p><p>This function rejects the <em>StartBridge</em> request.<br> The <em>input</em> parameter value should be a <em>StartBridge</em> Event to reject.<br> The <em>errorCode</em> parameter value should be a string.<br> The StartBridge function in the Task that has sent this <em>StartBridge</em> Event exits the waiting state and it returns an error code string.<br> This function returns a null-value if the pending incoming call has been successfully rejected. Otherwise, the function returns an error code string.</p></li><li><p><code>AcceptBridge(input)</code></p><p>This function builds a Media Bridge with the Task that has sent it the <em>StartBridge</em> Event.<br> The <em>input</em> value should be the <em>StartBridge</em> Event to accept.<br> This function returns a null-value if the Media Bridge has been successfully established. Otherwise, the function returns an error code string.<br> The StartBridge function in the Task that has sent this <em>StartBridge</em> Event exits the waiting state. That function returns a null-value if the Media Bridge is established, otherwise, it returns an error code string. If that Task was in the <code>incoming</code> or <code>provisioned</code> mode, the call in accepted, and the Task switches to the <code>connected</code> mode.</p></li></ul><p>When a Media Bridge is successfully established between a pair of Tasks, their peer media are connected to each other. Tasks Media Channels are disconnected from their peers and the Media Channel operations (<code>PlayFile</code>, <code>Record</code>, etc.) cannot be used.<br> A Task cannot use the <code>StartBridge</code>, <code>AcceptBridge</code>, and <code>AttachMixer</code> functions while a Media Bridge is active.</p><ul><li><p><code>BreakBridge()</code></p><p>This function removes the Media Bridge established with a successful completion of the <code>StartBridge</code> or <code>AcceptBridge</code> function.<br> The Task Media Channel is reconnected to the peer media.<br> A special <em>BreakBridge</em> Event is sent to the &quot;bridged&quot; Task.<br> This function returns a null-value if the existing media bridge has been broken. Otherwise, the function returns an error code string.</p></li><li><p><code>IsBreakBridgeEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a <em>BreakBridge</em> Event. Otherwise the function returns a null-value.<br> When a Task receives a <em>BreakBridge</em> Event, it does not have to use the BreakBridge() procedure, as the Media Bridge has been already removed.</p></li></ul><p>If a Task disconnects its peer, or the Task peer disconnects itself, or a Task stops (normally, or because of an error), and there is an active Media Bridge, this Media Bridge is automatically removed.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// Sample: StartBridge()/AcceptBridge()/BreakBridge()</span></span>
<span class="line"><span>//   Accept an incoming call (stop if it&#39;s not possible).</span></span>
<span class="line"><span>//   Create a new Task to run the Caller code,</span></span>
<span class="line"><span>//     and send it an Event with the URI to dial.</span></span>
<span class="line"><span>//   Play the PleaseWait media file.</span></span>
<span class="line"><span>//   Wait for a StartBridge Event from the Caller Task.</span></span>
<span class="line"><span>//   Accept it and loop till the user disconnects.</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>//   The Caller code:</span></span>
<span class="line"><span>//   Receive a URI to call as an Event from the parent Task</span></span>
<span class="line"><span>//   Connect to the URI and play the YouGotACall media file</span></span>
<span class="line"><span>//   StartBridge with the parent, loop till the user disconnects</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Caller forward;</span></span>
<span class="line"><span>procedure ControlBridge() forward;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  if AcceptCall() != null then stop; end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  callerTask = spawn Caller;</span></span>
<span class="line"><span>  if callerTask == null or else</span></span>
<span class="line"><span>     SendEvent(callerTask,&quot;dial&quot;,&quot;sip:internal@partner.dom&quot;) != null then</span></span>
<span class="line"><span>	PlayFile(&quot;Failure&quot;);</span></span>
<span class="line"><span>	stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  PlayFile(&quot;PleaseWait&quot;);</span></span>
<span class="line"><span>  input = ReadInput(30);</span></span>
<span class="line"><span>  if not IsStartBridgeEvent(input) or else</span></span>
<span class="line"><span>     AcceptBridge(input) != null then</span></span>
<span class="line"><span>	PlayFile(&quot;Failure&quot;);</span></span>
<span class="line"><span>	stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // we have established a bridge</span></span>
<span class="line"><span>  ControlBridge();</span></span>
<span class="line"><span>  PlayFile(&quot;GoodBye&quot;);</span></span>
<span class="line"><span>end entry;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>// Caller Task code</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Caller is</span></span>
<span class="line"><span>  // wait for a &quot;dial&quot; event from the main task</span></span>
<span class="line"><span>  input = ReadInput(30);</span></span>
<span class="line"><span>  if input == null or input.what != &quot;dial&quot; then stop; end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  mainTask = input.sender;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // Calling the URI specified as the Event parameter</span></span>
<span class="line"><span>  // If connection failed, send an Event back to the</span></span>
<span class="line"><span>  //  main task and quit</span></span>
<span class="line"><span>  resultCode = StartCall(startEvent.parameter);</span></span>
<span class="line"><span>  if resultCode != null then</span></span>
<span class="line"><span>    void(SendEvent(mainTask,&quot;result&quot;,resultCode));</span></span>
<span class="line"><span>	stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // wait for any Event other than provisional ones</span></span>
<span class="line"><span>  loop</span></span>
<span class="line"><span>    input = ReadInput(3600);</span></span>
<span class="line"><span>  exitif not IsCallProvisionEvent(input);</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // the parent has sent us &quot;stop&quot; - then we&#39;ll die immediately</span></span>
<span class="line"><span>  if IsDictionary(input) and then input.what == &quot;stop&quot; then stop; end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if not IsCallCompletedEvent(input) or else input.parameter != null then</span></span>
<span class="line"><span>    void(SendEvent(mainTask,&quot;result&quot;,&quot;generic error&quot;));</span></span>
<span class="line"><span>	stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if StartBridge(mainTask) != null then</span></span>
<span class="line"><span>	PlayFile(&quot;Failure&quot;);</span></span>
<span class="line"><span>	stop;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // we have established a bridge</span></span>
<span class="line"><span>  ControlBridge();</span></span>
<span class="line"><span>  PlayFile(&quot;GoodBye&quot;);</span></span>
<span class="line"><span>end entry;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>// Controlling the peer signaling:</span></span>
<span class="line"><span>// while the media is bridged:</span></span>
<span class="line"><span>//	exit if the peer hangs up, dials &quot;#&quot;</span></span>
<span class="line"><span>//  or if the bridge is removed</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>procedure ControlBridge() is</span></span>
<span class="line"><span>  loop</span></span>
<span class="line"><span>    input = ReadInput(3600);</span></span>
<span class="line"><span>  exitif IsBreakBridgeEvent(input) or else</span></span>
<span class="line"><span>          IsDisconnectEvent(input) or else input == &quot;#&quot;;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span>  void(BreakBridge());</span></span>
<span class="line"><span>end procedure;</span></span></code></pre></div><ul><li><p><code>AttachMixer(input)</code></p><p>The <em>input</em> value should be a StartBridge Event sent to this Task.<br> This function attaches the peer media of the sender Task to this Task Media Channel.<br> This function returns a null-value if the sender Task peer media is successfully attached to this Task Media Channel. Otherwise, the function returns an error code string.<br> The StartBridge function in the sender Task exits the waiting state. That StartBridge function returns a null-value if the sender Task peer media is attached successfully. Otherwise, that function returns an error code string.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the <code>AttachMixer</code> function is used when the Task is in the <em>disconnected</em> mode, and the Task does not have a Media Channel, a new Media Channel is created for this Task.</p></div></li><li><p><code>DetachMixer(taskRef)</code></p><p>This function detaches the peer media of the specified Task from this Task Media Channel.<br> The <em>taskRef</em> value should be a task handle.<br> The function returns a null-value if the peer media of the specified Task was attached to this Task Media Channel, and if that peer media is successfully reconnected back to the specified Task.<br> The specified Task receives a BreakBridge Event.<br> The function returns an error code string if the other Task peer media cannot be detached.<br> The <em>taskRef</em> value can be a null-value. In this case, all other Tasks peer media are detached from this Task Media Channel.</p></li><li><p><code>MixerAttached()</code></p><p>This function returns an array of task handles for all Tasks that attached their peer media to this Task Media Channel.<br> If this Task Media Channel does not have any other Task peer media attached, this function returns a null-value.</p></li><li><p><code>MuteMixer(taskRef,flag)</code></p><p>This procedure tells the Task Media Channel if it should ignore input from the specified Task.<br> The <em>taskRef</em> value should be a Task handle. This Task should have its peer media attached to the current Task Media Channel.<br> The <em>taskRef</em> value can be a null-value, in this case the current Task peer media is controlled.<br> The <em>flag</em> value specifies the operation: if the flag is a true-value, the peer media is ignored, if it is a null-value, the Media Channel starts to process media from the peer.<br> If the <em>flag</em> value is the &quot;special&quot; string, the peer media is not distributed to other &quot;normal&quot; peers.<br> If the <em>flag</em> value is the &quot;hearsSpecial&quot; string, the peer mute mode is not modified, but the media from the &quot;special&quot; peers is distributed to it.<br> If the <em>flag</em> value is the &quot;hearsMute&quot; string, the peer mute mode is not modified, but the media from all peers (muted, special, or unmuted) is distributed to it.<br> If the <em>flag</em> value is the &quot;hearsNormal&quot; string, the peer mute mode is not modified, but the media from the &quot;special&quot; peers is not distributed to it.</p></li></ul><p>When a Task has other Task peer media attached to its Media Channel, all media are placed into one <em>conversation space</em> (or a <em>conference</em>).</p><p>This Task cannot use the <code>StartBridge</code> or <code>AcceptBridge</code> functions.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>In certain cases the system may decide to convert an <code>AcceptBridge</code> function operation into an <code>AttachMixer</code> function operation. As a result, the <code>BreakBridge</code> operation can be used by a Task that has exactly one other peer media attached to its Media Channel.</p></div><p>If a Task disconnects its peer, or the Task peer disconnects itself, or a Task stops (normally, or because of an error), and there are other Task peer media attached to this Task Media Channel, the system automatically detaches all of them.</p><ul><li><p><code>StartBridgedCall(destination,event)</code></p><p>This function works as the <code>StartCall</code> function, but the <code>event</code> value should be StartBridge Event sent to this Task by an <em>ingress</em> Task. The Task initiates a call using the media descriptor from the Event data (describing the ingress Task peer media).<br> Provisional responses are delivered as Events to the current Task, and they are sent to the ingress Task (see below).<br> If the call is successful, a Media Bridge between the Tasks is built,the current Task receives a final response Event, and the StartBridge operation in the ingress Task completes successfully.<br> If the call fails, the current Task receives a final response Event, but no Event is sent to the ingress Task. The current Task can either try a new StartBridgedCall operation, or it can use AcceptBridge/AttachMixer/RejectBridge operations to process the received StartBridge Event.<br> If the <em>ingress</em> Task quits, or if that Task had a pending incoming call and that call was canceled, the initiated outgoing call is canceled, and the current Task receives the <em>BreakBridge</em> event.</p></li></ul><h3 id="Transfer" tabindex="-1">Call Transfer <a class="header-anchor" href="#Transfer" aria-label="Permalink to &quot;Call Transfer {#Transfer}&quot;">​</a></h3><ul><li><p><code>TransferSupported()</code></p><p>This function returns a true-value if the peer supports Transfer operations, otherwise the function returns a null-value.</p></li><li><p><code>IsCallTransferredEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a <em>CallTransferred</em> Event (this event can be sent when an external request has switched this Task to a different peer). Otherwise the function returns a null-value.</p></li><li><p><code>TransferCall(destination)</code></p><p>This function attempts a &quot;blind transfer&quot; of the Task peer. The Task should be in the <code>connected</code> mode.<br> The <em>destination</em> value should be a string containing the URI or an E-mail address to transfer the call to.<br> If the call transfer fails, the function returns an error code string.<br> If the call transfer succeeds, the function returns a null-value.<br> When the operation is completed, the Task stays in the <code>connected</code> mode, unless the peer has disconnected explicitly (by sending the BYE request).</p></li><li><p><code>StartTransfer(taskRef)</code></p><p>This function sends a special <em>StartTransfer</em> Event to the specified Task asking it to connect Task peers directly.<br> The <em>taskRef</em> value should be a task handle. It specifies the Task to send the request to.<br> This function returns a null-value if the specified Task successfully connected the peers. Otherwise, the function returns an error code string.<br> The current Task should be in the <code>connected</code> mode.<br> The current Task is placed into the waiting state, and the target Task receives a special <em>StartTransfer</em> Event.</p></li><li><p><code>IsStartTransferEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a <em>StartTransfer</em> Event.<br> Otherwise the function returns a null-value.</p></li><li><p><code>RejectTransfer(input,errorCode)</code></p><p>This function rejects the <em>StartTransfer</em> request.<br> The <em>input</em> parameter value should be a <em>StartTransfer</em> Event to reject.<br> The <em>errorCode</em> parameter value should be a string.<br> The StartTransfer function in the Task that has sent this <em>StartTransfer</em> Event exits the waiting state and it returns an error code string.</p></li><li><p><code>AcceptTransfer(input)</code></p><p>This function connects the current Task peer with the peer of the Task that has sent it the <em>StartTransfer</em> Event.<br> The <em>input</em> value should be the <em>StartTransfer</em> Event to accept.<br> This function returns a null-value if the peers have been successfully connected. Otherwise, the function returns an error code string.<br> The StartTransfer function in the Task that has sent this <em>StartTransfer</em> Event exits the waiting state. That function returns a null-value if the peers have been connected, otherwise, it returns an error code string.</p></li></ul><p>If the peers have been connected, both Tasks stay in the <code>connected</code> mode, unless their peers explicitly send the disconnect Signals. The Tasks should either quit or they should use the <code>Disconnect</code> procedure to fully disconnect from their peers.</p><h3 id="Info" tabindex="-1">Info Requests <a class="header-anchor" href="#Info" aria-label="Permalink to &quot;Info Requests {#Info}&quot;">​</a></h3><p>Applications can receive and send INFO requests.</p><p>Certain INFO requests (such as DTMF event requests) are processed automatically and this section does not apply to them.</p><p>INFO request data is presented as a dictionary, with the following elements:</p><ul><li><p><code>Content-Type</code></p><p>This optional string element contains the request body Content-Type (such as <code>application</code>).</p></li><li><p><code>Content-Subtype</code></p><p>This optional string element contains the request body Content-Type subtype.</p></li><li><p><code>&quot;&quot;</code> (empty key)</p><p>This optional string or datablock or XML element contains the request body content.</p></li><li><p><code>SendCallInfo(params)</code></p><p>This function sends an INFO request to the Task peer. The Task should be in the <code>connected</code> mode.<br> The <em>params</em> value should be a dictionary containing the INFO request data.<br> If the operation fails, the function returns an error code string.<br> If the operation succeeds, the function returns a null-value.</p></li></ul><p>When an INFO request is sent to a Task, the Task receives a special <em>CallInfo</em> Event. The Event <code>parameter</code> element contains a dictionary - the INFO request data.</p><ul><li><p><code>IsCallInfoEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is a <em>CallInfo</em> Event. Otherwise the function returns a null-value.</p></li></ul><h3 id="Register" tabindex="-1">Register Requests <a class="header-anchor" href="#Register" aria-label="Permalink to &quot;Register Requests {#Register}&quot;">​</a></h3><p>Applications can send REGISTER requests to external SIP servers.</p><p>REGISTER request data is presented as a dictionary, with the following elements:</p><ul><li><p><code>targetDomain</code></p><p>This string specifies the domain for registration.</p></li><li><p><code>Via</code></p><p>This optional element specifies the address of the remote server if it&#39;s different from the <code>targetDomain</code> value or can not be resolved from it.</p></li><li><p><code>fromAddress</code></p><p>This string specifies the Address Of Record (full account name) on the remote server.</p></li><li><p><code>Call-ID</code>, <code>CSeq</code></p><p>These string elements specify parameters for the registration dialog.</p></li><li><p><code>authUsername</code>, <code>authPassword</code></p><p>These string elements specify credentials for the registration.</p></li><li><p><code>&quot;&quot;</code> (empty key)</p><p>This string should specify the value for the Contact URI of the REGISTER request. That URI should be used by the remote SIP server as the target for the <code>INVITE</code> requests while processing calls coming in for the account on the remote system.</p></li><li><p><code>SendCallRegister(params)</code></p><p>This function sends an REGISTER request to a remote SIP server. The Task should be in the <code>disconnected</code> mode.<br> The <em>params</em> value should be a dictionary containing the REGISTER request data.<br> If the operation fails, the function returns an error code string.<br> If the operation succeeds, the function returns the TimeStamp when the requested registration expires.</p></li></ul><p>Upon a successful REGISTER operation completion the function returns a TimeStamp value - the GMT time when the requested registration will expire. The task should re-schedule the next registration request for the time before that expiration time stamp, and for the next attempt use the same parameters, including <code>Call-ID</code>, and increment the <code>CSeq</code> value by 3.</p><h3 id="Service" tabindex="-1">Service Requests <a class="header-anchor" href="#Service" aria-label="Permalink to &quot;Service Requests {#Service}&quot;">​</a></h3><ul><li><p><code>SendCallOptions(params)</code></p><p>This function sends an OPTION request to the Task peer (if the dialog has been established and the Task is in the <code>connected</code> mode), or to an arbitrary entity (if the Task is in the <em>disconnected</em> mode).<br> The <em>params</em> value is interpreted in the same way as the <code>StartCall</code> <em>destination</em> parameter value.<br> If the operation fails, the function returns an error code string.<br> If the operation succeeds, the function returns a null-value.</p></li><li><p><code>SignalOption(optionName)</code><br><code>SignalOption(optionName,newValue)</code></p><p>This function return the current value of a Task Signal option.<br> If the <em>newValue</em> value is specified and its value is not a null-value, then it is set as the new option value.<br> The <em>optionName</em> value should be a string and it specifies the option name. The following options are supported:</p><ul><li><p>&quot;refer&quot;</p><p>this option specifies how the Task processes the <a href="#ReferProc">REFER requests</a> and <a href="#ReplacesProc">INVITE/replaces requests</a>. The supported values are:</p><ul><li><p>&quot;self&quot;</p><p>outgoing signals are authenticated as coming from the current Account; this is the default value</p></li><li><p>&quot;peer&quot;</p><p>outgoing signals are authenticated as coming from the Task peer (i.e. the sender of the REFER signal)</p></li><li><p>&quot;disabled&quot;</p><p>REFER and INVITE/replaces request processing is prohibited.</p></li></ul></li><li><p>&quot;transferReport&quot;</p><p>this option specifies if call transfers are to be reported. The supported values are:</p><ul><li><p>&quot;NO&quot;</p><p>no event is sent when a Task is transferred to a different peer; this is the default value</p></li><li><p>true-value (&quot;YES&quot;)</p><p>the Task receives a special <em>CallTransferred</em> Event when it is transferred to a different peer.</p></li></ul></li><li><p>&quot;bridgeBreak&quot;</p><p>this option specifies how the Task reacts when a media bridge is broken by the other task. The supported values are:</p><ul><li><p>&quot;disconnect&quot;</p><p>the Task disconnects its current peer, and the Task enters the <em>disconnected</em> mode.</p></li><li><p>&quot;keep&quot;</p><p>if the Task does not have a Media channel, it is created. Then the Task peer is <a href="#BridgeBreak">switched to that channel</a>.</p></li><li><p>&quot;default&quot;</p><p>if the Task does not have a Media channel, the Task disconnects its current peer. Otherwise, the Task peer is <a href="#BridgeBreak">switched to that channel</a>. This is the default value.</p></li></ul></li><li><p>&quot;bridgedProvisionRelay&quot;</p><p>this option specifies how the provisional responses generated with the <code>StartBridgedCall</code> function are delivered to the peer. The supported values are:</p><ul><li><p>true-value (&quot;YES&quot;)</p><p>provisional responses are relayed to this Task peer, using the ProvisionCall function with the <code>reliably</code> parameter set to a null-value; this is the default value</p></li><li><p>&quot;reliably&quot;</p><p>provisional responses are relayed to this Task peer, using the ProvisionCall function with the <code>reliably</code> parameter set to a true-value</p></li><li><p>&quot;NO&quot;</p><p>provisional responses are not relayed to this Task peer</p></li></ul></li><li><p>&quot;bridgedProvisionToTags&quot;</p><p>this option specifies how the provisional responses generated with the <code>StartBridgedCall</code> function are delivered to the peer. The supported values are:</p><ul><li><p>&quot;NO&quot;</p><p>all provisional responses contain the same To-tag, assigned to this Task; this is the default value.</p></li><li><p>true-value (&quot;YES&quot;)</p><p>the provisional responses keep their original To-tags.</p></li></ul></li><li><p>&quot;bridgedProvisionQueue&quot;</p><p>this option specifies the provisioning response FIFO queue size. This queue is used when provisioning responses from the other task are received faster that they can be delivered to this Task peer. The default queue length is 10.</p></li><li><p>&quot;callInfo&quot;</p><p>this is a read-only option; if specified, the newValue must be a null-value.<br> The function returns information about the system &quot;call&quot; object: time connected, proxies used, etc.</p></li></ul></li><li><p><code>SendCallNotify(params)</code></p><p>This function sends a NOTIFY request to an arbitrary entity (the Task must be in the <em>disconnected</em> mode).<br> The <em>params</em> value must be a dictionary containing the following string elements:</p><ul><li><p><code>&quot;&quot;</code> (empty string), <code>From</code>, <code>To</code>, <code>Call-ID</code></p><p>these elements are processed in the same way as the <code>StartCall</code> <em>destination</em> parameter elements.</p></li><li><p><code>Event</code></p><p>the event name string</p></li><li><p><code>@Event-Params</code></p><p>an optional dictionary with the parametes to put into the request <code>Event</code> field.</p></li><li><p><code>Subscription-State</code></p><p>an optional string to put into the request <code>Subscription-State</code> field.</p></li><li><p><code>@Content</code></p><p>an optional string or a datablock to send as the request body.</p></li><li><p><code>Content-Type</code>, <code>Content-Subtype</code></p><p>optional strings for the request Content-Type field.<br> If the operation fails, the function returns an error code string.<br> If the operation succeeds, the function returns a null-value.</p></li></ul></li></ul><h3 id="XMPP" tabindex="-1">Instant Messages and XMPP-type Requests <a class="header-anchor" href="#XMPP" aria-label="Permalink to &quot;Instant Messages and XMPP-type Requests {#XMPP}&quot;">​</a></h3><p>A Task can receive Instant messages and XMPP requests. They are delivered to the Task as Events.</p><ul><li><p><code>IsInstantMessageEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is an Instant Message Event. Otherwise the function returns a null-value.<br> The event parameter is a dictionary. It contains the same elements as the SendInstantMessage function <em>content</em> parameter, with the following additional elements:</p><ul><li><p><code>From</code></p><p>a string - the sender E-Mail address.</p></li><li><p><code>peerName</code></p><p>an optional string - the sender &quot;real name&quot;.</p></li><li><p><code>fromInstance</code></p><p>an optional string - the sender &quot;instance&quot;.</p></li><li><p><code>To</code></p><p>a string - the original recipient E-Mail address.</p></li><li><p><code>toInstance</code></p><p>an optional string - the recipient &quot;instance&quot;.</p></li><li><p><code>authName</code></p><p>an optional string - the authenticated identity of the sender.</p></li><li><p><code>redirector</code></p><p>an optional string - the authenticated identity of the message redirector (the Account that redirected this message using its <a href="./../admin/signals/SignalRules.html">Automated Rules</a> or other means).</p></li></ul></li><li><p><code>IsXMPPIQEvent(input)</code></p><p>This function returns a true-value if the <em>input</em> value is an XMPP IQ/presence Event. Otherwise the function returns a null-value.<br> The event parameter is a dictionary. It contains the same elements as the SendXMPPIQ function <em>content</em> parameter, with the following additional elements: <code>From</code>, <code>peerName</code>, <code>fromInstance</code>, <code>To</code>, <code>toInstance</code>, <code>authName</code>, <code>redirector</code>, which have the same meanings as in Instant Message Events.</p></li></ul><h2 id="Formats" tabindex="-1">Supported Media Formats <a class="header-anchor" href="#Formats" aria-label="Permalink to &quot;Supported Media Formats {#Formats}&quot;">​</a></h2><p>The following audio file formats are supported:</p><ul><li><p><code>WAV</code> (data starts with the <code>RIFF</code> tag)</p><p>a file should contain a single <code>data</code> chunk with PCM 8-bit or 16-bit data, or GSM-encoded data.</p></li><li><p><code>au</code> (data starts with the <code>.snd</code> tag)</p><p>a file should contain PCM 8-bit or 16-bit data, or 8-bit mu-Law data.</p></li><li><p><code>gsm</code></p><p>a file should contain a stream of 33-byte GSM 06.10-encoded frames.</p></li></ul>`,154)]))}const C=c(f,[["render",g]]);export{w as __pageData,C as default};
