import{_ as s,c as n,o as a,ag as o,j as e,a as t}from"./chunks/framework.jCcxW76o.js";const f=JSON.parse('{"title":"Automated Rules","description":"","frontmatter":{"legacyLink":"Rules.html"},"headers":[],"relativePath":"development/Rules.md","filePath":"development/Rules.md"}'),l={name:"development/Rules.md"};function r(d,i,c,u,p,h){return a(),n("div",null,i[0]||(i[0]=[o('<h1 id="automated-rules" tabindex="-1">Automated Rules <a class="header-anchor" href="#automated-rules" aria-label="Permalink to &quot;Automated Rules&quot;">​</a></h1><p>The CommuniGate Pro Server can automatically process <a href="./../admin/mail/">E-mail Messages</a> and <a href="./../admin/cluster/Signals.html">Signals</a> using sets of Automated Rules.</p><p>The Server-wide and Cluster-wide sets of Automated Rules are applied to all Messages and to all Signals transferred via the Server or the Cluster.</p><p>The Account-level sets of Automated Rules are applied to all E-mail Messages and to all Signals sent to the Account.</p><p>Each Rule in a set has a name, a priority, a set of conditions, and a set of actions. The higher priority Rules are checked first: a Rule with the priority level of 9 is applied before a Rule with the priority level 1.</p><p>If a Message or a Signal meets all Rule conditions, the Rule actions are performed, and automated processing either stops, or proceeds checking other, lower-priority Rules.</p><h2 id="Specifying" tabindex="-1">Specifying Rules <a class="header-anchor" href="#Specifying" aria-label="Permalink to &quot;Specifying Rules {#Specifying}&quot;">​</a></h2><p>System administrators can specify Server-Wide and Cluster-Wide Rules.</p><p>To specify Server-Wide Message (Queue) Rules, use the WebAdmin Interface to open the Mail pages in the Settings realm, and click the Rules link.<br> To specify Server-Wide Signal Rules, use the WebAdmin Interface to open the Real-Time pages in the Settings realm, and click the Rules link.</p><p>System and Domain Administrators can specify Account Rules using links on the <a href="./../admin/objects/Accounts.html#Rules">Account Settings</a> page.</p><p>Account users can specify their Rules themselves, using the <a href="./../admin/access/WebUser.html">WebUser Interface</a>. System or Domain administrators can limit the set of Rule actions a user is allowed to specify.</p><p>System and Domain Administrators can specify Domain-Wide Rules using the Rules links on the Domain Settings page.</p><h2 id="List" tabindex="-1">Creating, Renaming and Removing Rules <a class="header-anchor" href="#List" aria-label="Permalink to &quot;Creating, Renaming and Removing Rules {#List}&quot;">​</a></h2><p>When the list of Rules appears in a browser window, the Rule names and priorities can be modified:</p>',14),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{colspan:"4"},[e("table",{border:"0",cellpadding:"2",cellspacing:"0",width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{width:"30%"},[e("input",{name:"Create",value:"Add Rule",class:"button",type:"reset"})]),e("td",{width:"30%"},[e("input",{name:"NewName",value:"",size:"20",maxlength:"100",type:"text"})]),e("td",{align:"right"},[e("input",{name:"Remove",value:"Delete Marked",class:"buttonRed",type:"reset"})])])])])])]),e("tr",{align:"left"},[e("th",null,"Priority"),e("th",{width:"30%"},"Name"),e("th",null," "),e("th",null," ")]),e("tr",{class:"smallTable"},[e("td",null,[e("select",{name:"p0"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7",selected:"selected"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"Highest")])]),e("td",null,[e("input",{type:"text",name:"n0",value:"Sports List",size:"20",maxlength:"50"})]),e("td",null,[e("a",{href:"#Conditions"},"Edit")]),e("td",null,[e("input",{type:"checkbox",name:"d0",value:"1"})])]),e("tr",{class:"smallTable"},[e("td",null,[e("select",{name:"p2"},[e("option",{value:"0"},"Inactive"),e("option",{value:"1"},"1"),e("option",{value:"2",selected:"selected"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"Highest")])]),e("td",null,[e("input",{type:"text",name:"n2",value:"From Ali",size:"20",maxlength:"50"})]),e("td",null,[e("a",{href:"#Conditions"},"Edit")]),e("td",null,[e("input",{type:"checkbox",name:"d2",value:"1"})])]),e("tr",{class:"smallTable"},[e("td",null,[e("select",{name:"p4"},[e("option",{value:"0",selected:"selected"},"Inactive"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"4"},"4"),e("option",{value:"5"},"5"),e("option",{value:"6"},"6"),e("option",{value:"7"},"7"),e("option",{value:"8"},"8"),e("option",{value:"9"},"9"),e("option",{value:"10"},"Highest")])]),e("td",null,[e("input",{type:"text",name:"n4",value:"Info Reply",size:"20",maxlength:"50"})]),e("td",null,[e("a",{href:"#Conditions"},"Edit")]),e("td",null,[e("input",{type:"checkbox",name:"d4",value:"1"})])])])])])],-1),o('<p>After you have modified the Rule names and/or priorities, click the Update button. The list is displayed re-sorted by priority.</p><p>Rules with the <code>Inactive</code> priority are not applied, but they are not deleted from the Rule set, and they can be re-enabled at any moment.</p><p>To create a new Rule, enter its name in the field on the top and click the Add Rule button.</p><p>To remove a Rule, select the checkbox in the Delete column and click the Update button.</p><p>To modify the Rule conditions and actions, click the Edit link.</p><h2 id="Conditions" tabindex="-1">Rule Conditions <a class="header-anchor" href="#Conditions" aria-label="Permalink to &quot;Rule Conditions {#Conditions}&quot;">​</a></h2><p>Each Rule can have zero, one, or several conditions. The conditions are checked in the same order they are specified. If an E-mail Message or a Signal meets all the Rule conditions, the Rule actions are performed.</p><p>The condition operations <code>is</code> and <code>is not</code> process their parameters as &quot;pictures&quot;: the asterisk (<code>*</code>) symbols in parameters are processed as wildcards that match zero or more symbols in the tested string. To check that a string contains the <code>@thatdomain</code> substring, the <code>is *@thatdomain*</code> operation should be used, and to check that a string does not end with the <code>somedomain.com</code> substring, the <code>is not *somedomain.com</code> operation should be used.</p><p>The condition operations <code>in</code> and <code>not in</code> process their parameters as sets of one or more &quot;pictures&quot; separated with the comma (<code>,</code>) symbols. The tested string is compared to all picture strings. The <code>in</code> condition is met if the tested string matches at least one picture string. The <code>not in</code> condition is met if the tested string does not match any picture string in the specified set.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Do not use excessive spaces around the comma signs: spaces before the comma sign become trailing spaces of the previous picture, and spaces after the comma sign become leading spaces of the next picture.</p></div><p>The following Rule conditions can be used in both E-Mail Queue and Signal processing Rules:</p><ul><li><p><code>Submit Address [is | is not | in | not in] string</code></p><p>This condition checks the E-mail or Signal submit address.<br> If the Message or Signal was generated within the Server itself, its submit address is empty.<br> Otherwise the &quot;submit address&quot; string contains the name of the component that received or generated the <a href="./../admin/mail/#Sources">E-mail Message</a> or <a href="./../admin/cluster/Signals.html#Sources">Signal</a>, and (separated with a space symbol) the network (IP) address the E-mail or Signal came from, optionally followed with the IP port number (separated with a colon symbol).<br> If the Message or Signal was generated locally, with an internal Server component (such as Rules), the network address field contains [0.0.0.0].</p><ul><li><p>Sample (Queue Rule):</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Submit Address</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option><option value="1">is not</option><option value="2">in</option><option value="3">not in</option></select></td><td><input type="text" name="p000000" value="SMTP [10.0.0.*]*" size="35" maxlength="200"></td></tr></tbody></table></div></form></li><li><p>Sample (Signal Rule):</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Submit Address</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option><option value="1">is not</option><option value="2">in</option><option value="3">not in</option></select></td><td><input type="text" name="p000000" value="SIP [10.0.0.15]:5060" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>Time Of Day [is | is not | less than | greater than | in | not in] time string</code></p><p>This condition checks the current time of day in the user&#39;s time zone (for the Account-level Rules) or in the Server Time Zone (for the system-wide Rules).</p><p>This condition allows you to compose rules that are applied only at certain times of day.</p><p>A time string should be specified as <em>hh</em>:<em>mm</em> or <em>hh</em>:<em>mm</em>:<em>ss</em>, where <em>hh</em> is the hour, <em>mm</em> - minutes, <em>ss</em> - seconds.<br> Time strings can contain the am or pm suffix.</p><p>If the condition is <code>in</code> or <code>not in</code>, then the parameter string should contain a pair of time strings, separated with the minus (<code>-</code>) symbol.<br> If the second time value is not smaller than the first one (as in 08:30-5:15pm), the <code>in</code> condition is met at any time after 8:30 and before 17:15.<br> If the second time value is smaller than the first one (as in 22:30-5:15), the <code>in</code> condition is met at any time after 22:30 and at any time before 5:15.</p><ul><li><p>Sample (Queue Rule):</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Time Of Day</option></select></td><td><select name="o000000"><option value="0" selected="selected">greater than</option><option value="1">less than</option></select></td><td><input type="text" name="p000000" value="8:15am" size="35" maxlength="200"></td></tr><tr><td><select name="c000001"><option value="1" selected="selected">Time Of Day</option></select></td><td><select name="o000001"><option value="0">greater than</option><option value="1" selected="selected">in</option></select></td><td><input type="text" name="p000001" value="6:15pm-05:00am" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul><p>If the Account-level Rule condition is <code>is</code>, <code>is not</code>, <code>in</code>, or <code>not in</code> the work string can be used as <em>time string</em>.<br> If the current day of week is included into the &quot;working days&quot; set and the current time of day is inside the &quot;working hours&quot; range specified for this Account, then the <code>is</code> and <code>in</code> conditions are met. Otherwise, the <code>is not</code> and <code>not in</code> conditions are met.</p></li><li><p><code>Current Date [is | is not | less than | greater than] date string</code></p><p>This condition checks the current time and date. This condition allows you to compose rules that are applied to Messages or Signals only before or after the specified date and time.</p><p>To compare dates only, specify the date string in the following format:</p><ul><li><code>DD MMM YYYY</code></li></ul><p>To compare date and time, specify the date string using one of the following formats:</p><ul><li><code>DD MMM YYYY hh:mm</code></li><li><code>DD MMM YYYY hh:mm:ss</code></li><li><code>DD MMM YYYY hh:mm:ss +ZZZZ</code></li><li><code>DD MMM YYYY hh:mm:ss -ZZZZ</code></li></ul><p>where: <code>DD</code> is the day of month <code>MMM</code> is month specified as a 3-letter English abbreviation:<br> Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec <code>YYYY</code> is the year <code>hh</code> is the hour <code>mm</code> is the minute <code>ss</code> is the second <code>+ZZZZ</code> or <code>-ZZZZ</code> is the time zone; if the time zone is not specified, the user-specified time zone is used for the Account-level Rules and the Server time zone is used for the Server-wide and Cluster-wide Rules.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Current Date</option></select></td><td><select name="o000000"><option value="0" selected="selected">greater than</option><option value="1">less than</option></select></td><td><input type="text" name="p000000" value="20 Jun 2007" size="35" maxlength="200"></td></tr><tr><td><select name="c000001"><option value="1" selected="selected">Current Date</option></select></td><td><select name="o000001"><option value="0">greater than</option><option value="1" selected="selected">less than</option></select></td><td><input type="text" name="p000001" value="27 Jun 2007 15:20:00" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>Current Day [is | is not | in | not in] day string</code></p><p>This condition checks the current day of week. It allows you to compose rules that are applied to Messages or Signals only on certain days of week.<br> Days should be specified either as numbers (0 for Sunday, 6 for Saturday), or as RFC822 abbreviations (Mon, Tue, Wed, Thu, Fri, Sat, Sun).</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Current Day</option></select></td><td><select name="o000000"><option value="0">is</option><option value="1" selected="selected">in</option></select></td><td><input type="text" name="p000000" value="Sat,Sun" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>Preference [is | is not | in | not in] string</code></p><p>The <em>string</em> must contain the Account Preference name and the preference data picture, separated with the colon (<code>:</code>) symbol. This condition compares the specified Account Preference value with the data picture.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Preference</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option></select></td><td><input type="text" name="p000000" value="CallOutPrivacy:YES" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>FreeBusy [is | is not | in | not in] status string</code></p><p>This condition should not be used in the Server-wide or Cluster-wide Rule. The condition retrieves the Account Free-Busy data and retrieves the status value for the current time. This status value is compared to the specified <em>status string</em>.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">FreeBusy</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option><option value="1">is not</option></select></td><td><input type="text" name="p000000" value="BUSY" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul></li><li><p><code>Existing Mailbox [is | is not] string</code></p><p>The parameter specifies a mailbox name, and this condition checks if the specified Mailbox exists (or if it does not exist). A Mailbox &quot;exists&quot; if it is possible to open the Mailbox with the specified name and to add a Message to it. If this condition is used in an Account-level Rule and the parameter specifies a Mailbox in a different Account, and that Mailbox exists, but the current user cannot add a message to it, the Mailbox is treated as one that &quot;does not exist&quot; for this Rule condition.</p><ul><li><p>Sample:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td><select name="c000000"><option value="1" selected="selected">Existing Mailbox</option></select></td><td><select name="o000000"><option value="0" selected="selected">is</option><option value="1">is not</option></select></td><td><input type="text" name="p000000" value="SPAM" size="35" maxlength="200"></td></tr></tbody></table></div></form></li></ul><p>This condition is useful in Domain-Wide Rules: a Rule can check if the current Account has a special Mailbox, and copy certain Messages to that Mailbox only if it exists.</p></li></ul><h3 id="StringLists" tabindex="-1">String Lists <a class="header-anchor" href="#StringLists" aria-label="Permalink to &quot;String Lists {#StringLists}&quot;">​</a></h3><p>The CommuniGate Pro Server can store named lists of strings as the <a href="./../admin/objects/Accounts.html">Account</a> DataSet subsets.</p><p>Each list can contain zero, one, or several strings. The Rule Condition operations can refer to those lists, if:</p><ul><li>The Rule is an Account-level (or a Domain-wide) one.</li><li>The condition operation is <code>in</code> or <code>not in</code>.</li><li>The operation parameter is specified as a <em>string</em>.</li><li>The operation parameter starts with the hash (<code>#</code>) symbol.</li></ul><p>For example, the Condition operation <code>Sender    in    #Blocked</code> checks if the E-mail Message or Signal sender&#39;s address is included into the String List called <code>Blocked</code>.</p><p>String List subsets can be used as WebUser Interface <a href="./WebContacts.html#DataSet">Address Books</a>.</p><h3 id="GroupMember" tabindex="-1">Group Membership <a class="header-anchor" href="#GroupMember" aria-label="Permalink to &quot;Group Membership {#GroupMember}&quot;">​</a></h3><p>The CommuniGate Pro Server can use <a href="./../admin/objects/Groups.html">Group</a> object contents as the list of addresses.</p><p>The Rule Condition operations can refer to contents of those groups if:</p><ul><li>The condition operation is <code>in</code> or <code>not in</code>.</li><li>The operation parameter is specified as a <em>groupname</em>.</li><li>The operation parameter starts with the dollar sign (<code>$</code>) symbol.</li></ul><p>For example, the Condition operations: <code>Sender        in        $sales</code></p><p>checks if the sender&#39;s address of the Message or Signal is contained in a Group named <code>sales</code>. If the group name is specified without a domain part, the contents of the group with that name are used in the domain for which the User-Level Rule is applied or is Common to the Domain.</p><p><code>From          not in    $group1,$group2</code></p><p>checks if the sender&#39;s address is not contained in one of the Groups <code>group1</code> or <code>group2</code>.</p><p><code>ReplyTo       in        user@domain,$group1,$group2</code></p><p>checks if the reply address is contained in Groups <code>group1</code> or <code>group2</code> or if it is the User user@domain. The following examples work similarly.</p><p><code>To            not in    user@domain,$group1@alias,$group2@domain</code><br><code>Cc            in        $group2@domain,user@domain,$group1@alias</code></p><p>Only &quot;From&quot; and &quot;To&quot; are available for the Signal.</p><h2 id="Actions" tabindex="-1">Rule Actions <a class="header-anchor" href="#Actions" aria-label="Permalink to &quot;Rule Actions {#Actions}&quot;">​</a></h2><p>Each Rule can have zero, one, or several actions. If an E-mail Message or Signal meets all the Rule conditions, the Rule actions are performed.</p><p>Rule Action parameters can contain Macro symbol combinations (<code>^X</code>, where <em>X</em> is a letter).<br> Different sets of Macro symbol combinations are processed<br> See the <a href="./../admin/signals/SignalRules.html#Macro">Signal Rules</a> and <a href="./../admin/mail/QueueRules.html#Macro">E-mail Rules</a> sections to learn about the Macro symbol combinations available.</p><p>The following Rule actions can be used in all Message and Signal processing Rules:</p>',34),e("ul",null,[e("li",null,[e("p",null,[e("code",null,"Reject errorMessage")]),e("p",null,[t("This action should be the last one in a Rule. Execution of this Rule stops and no other (lower-priority) Rules are checked."),e("br"),t(' If a Rule is a Signal processing one, the Signal fails with the specified error code. If there are Signal Rules for the "Failure" condition, those Rules are applied, otherwise the the Signal is rejected immediately.'),e("br"),t(" If a Rule is an E-mail processing one, the Message is rejected, and a negative Delivery Notification is sent back to the Message sender."),e("br"),t(" If the action parameter text is not empty, it is used as the error report text."),e("br"),t(" E-mail processing Rules can still store rejected Messages using the Store action before the Reject action.")]),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Subject")])]),e("td",null,[e("select",{name:"o000000"},[e("option",{value:"0",selected:"selected"},"is"),e("option",{value:"1"},"is not")])]),e("td",null,[e("input",{type:"text",name:"p000000",value:"*UCE*",size:"35",maxlength:"200"})])])])])]),e("br"),e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Reject with")])]),e("td",null,[e("textarea",{rows:"2",cols:"40",name:"name"},"Please do not send this type of messages here.")])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"SendURL URL"),t(" ("),e("code",null,"Execute URL URL"),t(")")]),e("p",null,[t("An HTTP connection is made to the remote Web server specified in the URL, and an HTTP GET request with the specified URL is sent to that server."),e("br"),t(" If any response is received, the response is discarded. If no response is received within 10 seconds, the HTTP connection is closed."),e("br"),t(" When the "),e("em",null,"URL"),t(" parameter is processed using "),e("a",{href:"#Macro"},"Macro Substitution"),t(", the calculated values are URL-encoded first.")]),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Execute URL")])]),e("td",null,[e("textarea",{rows:"2",cols:"60",name:"name"},"http://www.server.dom/file.xyz?parameter=tt")])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Send IM messageText")]),e("p",null,[t("An Instant message with the specified message text is sent."),e("br"),t(" If the message text starts with the "),e("code",null,"To: user@domain"),t(" line, then the Instant Message is sent to the specified address. Otherwise, the message is sent to the current Account (for Account-level Rules), or it is not sent at all (for Server-wide/Cluster-wide Rules).")]),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Send IM")])]),e("td",null,[e("textarea",{rows:"2",cols:"60",name:"name"},`To: assistant@domain.dom
You've got mail!`)])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Send Push messageText")]),e("p",null,"A Push message with the specified text is sent."),e("ul",null,[e("li",null,[e("p",null,"Sample:"),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{valign:"top"},[e("td",null,[e("select",{name:"c000000"},[e("option",{value:"1",selected:"selected"},"Send Push")])]),e("td",null,[e("textarea",{rows:"2",cols:"60",name:"name"})])])])])])])])])]),e("li",null,[e("p",null,[e("code",null,"Write To Log recordText")]),e("p",null,[t("A Major-Level (Level 2) record with the Message or Signal ID and the specified "),e("em",null,"recordText"),t(" string is placed into the "),e("a",{href:"./../admin/sysadmin/Logs.html"},"System Log"),t("."),e("br"),t(" Only the Server Administrator is allowed to specify this action.")])]),e("li",null,[e("p",null,[e("code",null,"Remember 'From' in stringList")]),e("p",null,[t("This action can be used in Account-Level Rules only. The operation parameter specifies the name of a string list that exists in or should be created in the Account dataset. The Message author or Signal sender ("),e("code",null,"From"),t(") address is added to the specified list."),e("br"),t(" If the list already has 500 or more elements, the new element is not added.")])])],-1),o('<h2 id="Domain" tabindex="-1">Domain-Wide Rules <a class="header-anchor" href="#Domain" aria-label="Permalink to &quot;Domain-Wide Rules {#Domain}&quot;">​</a></h2><p><a href="./../admin/sysadmin/#Domain">Domain Administrators</a> can specify Domain-wide Rules.</p><p>When a Message is being delivered to any Account by the Local Delivery module, or when a Signal targets any Server Account, the &quot;effective&quot; set of Account-level Rules is applied.<br> The first Rules in the effective set are Domain-wide Rules with priorities above 5, then it includes all Account-level Rules, and then - all Domain-wide Rules with priorities equal to or less than 5.</p><p>This method guarantees that all Domain-Wide Rules with priorities higher than 5 are applied before any Account Rule. If such a Domain-Wide Rule uses the Stop Processing action, no Account Rules are applied.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Domain-Wide Rules are &quot;mixed&quot; with the Account Rules and are applied in the same environment as the Account Rules, &quot;on behalf&quot; of the Account user.</p></div><h2 id="Cluster" tabindex="-1">Cluster-Wide Rules <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Cluster-Wide Rules {#Cluster}&quot;">​</a></h2><p>The <a href="./../admin/cluster/Dynamic.html#SharedSettings">Dynamic Cluster</a> Administrators can see an additional link on the Rules pages of the WebAdmin Interface. This link can be used to open the list of Cluster-wide Rules.</p><p>When you modify the Cluster-wide Rules set on any Cluster Member, the set is automatically updated on all Cluster members.</p><p>The effective set of &quot;server-wide&quot; rules for each Cluster member is a union of the Server-Wide Rules explicitly set on that Cluster member and the Cluster-wide Rules.</p><p>Rules from both sets are applied together, in the order specified with the Rule priority attribute. For example, Messages can be processed with a high-priority Cluster-wide Rule, then with a medium-priority Server-wide Rule, then with a low-priority Cluster-wide Rule.</p>',10)]))}const g=s(l,[["render",r]]);export{f as __pageData,g as default};
