import{_ as t,c as o,o as s,ag as i}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Web Applications","description":"","frontmatter":{"legacyLink":"WebApp.html"},"headers":[],"relativePath":"development/WebApp.md","filePath":"development/WebApp.md"}'),a={name:"development/WebApp.md"};function n(d,e,r,c,l,h){return s(),o("div",null,e[0]||(e[0]=[i('<h1 id="web-applications" tabindex="-1">Web Applications <a class="header-anchor" href="#web-applications" aria-label="Permalink to &quot;Web Applications&quot;">​</a></h1><p>The CommuniGate Pro Web Application module provides access to various CommuniGate Pro Objects (accounts, messages, mailing lists, web files) via any Web (HTTP/HTML) browser.</p><p>The <a href="./../admin/services/HTTP.html">HTTP module</a> receives HTTP client browser requests that come to the WebUser port(s), and passes those requests to the Web Application module. The Web Application module either retrieves the requested file, or it starts some internal <em>web application</em> code and converts the result into the HTML, WML or other <em>markup</em> format. The result is returned to the HTTP module that delivers it back to the client browser.</p><p>Read this section if you want to customize your CommuniGate Pro Server WebUser Interface.</p><h2 id="SessionStateless" tabindex="-1">Stateless and Session-based Processing <a class="header-anchor" href="#SessionStateless" aria-label="Permalink to &quot;Stateless and Session-based Processing {#SessionStateless}&quot;">​</a></h2><p>Regular HTTP servers are <em>stateless</em> processors: a user&#39;s browser may send several sequential requests, but the HTTP server does not keep any information about the browser or the client between the requests. Each request is processed individually.</p><p>The Web Application Server allows users to &quot;log in&quot;, providing a name of some CommuniGate Pro Account and the account password. For each successful login, a <em>Session</em> is started. The session keeps the information about user actions and requests, so all HTTP requests sent to the same session can share and use the same set of session data.</p><p>To maintain a session, all session requests have URLs in the following form: <code>http://hostname:serverport/Session/sessionID/sessionRequest</code> where the <em>sessionID</em> string identifies the session, and the <em>sessionRequest</em> is the name of the file to retrieve or the application component to run.</p><p>The Web Application Sessions have time-out counters. If no HTTP request has been sent to a session during the configurable time-out interval, the Session is closed. The session user can close the session by sending a request for the special <em>Bye</em> page.</p><h2 id="Skins" tabindex="-1">Skins <a class="header-anchor" href="#Skins" aria-label="Permalink to &quot;Skins {#Skins}&quot;">​</a></h2><p>The Server WebUser Interface implements Skins. Each Skin is a set of files that define how the information is presented to users. Skins files include:</p><ul><li><a href="#WSSP">WSSP files</a> used to build &quot;web pages&quot; (HTML, WML, etc.) and format the page data.</li><li>static service files - graphic elements, style sheets, etc.</li><li><a href="#Strings">Language files</a> containing various static text strings (messages, page and button titles, tags, etc.) referenced from WSSP files.</li></ul><p>The CommuniGate Pro software comes with one <em>Unnamed</em> Stock Skin, providing the very basic and simple HTML interface. It also comes with some <em>Named</em> Stock Skins that provide more visually rich interfaces. This Stock Skins are stored in the <em>application directory</em>, they are parts of the software package, and they <strong>should not be modified by server administrators</strong>.</p><p>CommuniGate Pro installations can also use Unnamed and Named <em>custom</em> Skins. Custom Skins can be created as Server-wide Skins. These custom Skins are available to all users. Each CommuniGate Pro Domain can also have its own set of custom Skins, available only to the users of that Domain.</p><p>When a user connects to the WebUser Interface service (the HTTP User port), the <em>hostname</em> string specified in a stateless request URL is used to find the CommuniGate Pro <a href="./../admin/objects/Domains.html">Domain</a>. When the Domain is found, its Default Account WebUser Preferences are retrieved and the SkinName (Layout) and Language Settings are used.</p><p>The SkinName Setting specified the name of the Skin to use (if that Setting is empty, the Unnamed Skin is used).</p><p>If the Skin with the specified Name is not found in the set of the Domain Skins, the Server-wide Skin sets are checked. If the Skin with the specified name is still not found, the Stock Skin with this name is used. If the Named Stock Skin is not found either, the Unnamed Stock Skin is used.</p><p>Since Domains can have their own Skin sets, the same request sent to different Domains can display different pages: the Default WebUser Preferences can specified different Skin Names in different Domains, and even if the Preferences are the same, different Skins with the same name can exist in different Domains.</p><p>Stateless requests can use any Skin available for the addressed Domain. To use an alternative Skin, a Stateless HTTP request should specify the Skin name using the <code>Skin</code> request parameter.</p><p>The Language Setting retrieved from the Domain effective Default Account WebUser Preferences specifies the language to use on the stateless page. To use an alternative language, a Stateless HTTP request should specify the language name using the <code>Language</code> request parameter.</p><p>Session-based HTTP requests do not use the hostname string specified in the URL. Instead, when a user logs in, and a Web Application session is created for the specified CommuniGate Pro <a href="./../admin/objects/Accounts.html">Account</a>, the effective Account WebUser preferences are retrieved. Those preferences contain the name of the Skin to use (an empty value specifies an Unnamed Skin). The Skin with the specified name is selected from the Skin set of the Account Domain (note that the Domain specified with the request URL can be different).<br> If the Account Domain does not have the specified Skin, the Server-wide Skin is used.</p><p>Session-based HTTP requests use the Language specified with the Account WebUser Preferences.</p><h2 id="FileHierarchy" tabindex="-1">Skin Files Hierarchy <a class="header-anchor" href="#FileHierarchy" aria-label="Permalink to &quot;Skin Files Hierarchy {#FileHierarchy}&quot;">​</a></h2><p>When a WebUser Interface request is processed, the Server needs to retrieve certain files from the selected Skin. If the requested file is not found in the selected Skin, and the selected Skin is a Domain Skin, the file is retrieved from the Server-wide Skin with the same name. If the requested file is not found in the Server-wide Skin, the Stock Skin with the same name is checked. If the file is still not found, and the selected Skin is a Named Skin, then unnamed Server-wide and unnamed Stock Skins are checked.</p><p>Initially, when no Domain has any custom Skin, and the Server-wide Skins are empty, all Domains can use the Stock Skins only. The Unnamed Skin is selected by default.<br> By uploading files into the Server-wide Unnamed Skin, the Server Administrator can &quot;shadow&quot; the Unnamed Stock Skin files, and this can change the application look and feel for all Domains.<br> By uploading files into the Unnamed Skin of some CommuniGate Pro Domain, the Server or Domain Administrator can &quot;shadow&quot; the Stock Skin and Server-wide Unnamed Skin files and change the look and feel for that particular Domain.</p><p>This hierarchy allows Server and Domain Administrators to use new Skins that are designed &quot;from scratch&quot;, or to develop small Skin variation, re-using the already existing Skins.</p><p>The <a href="./../admin/cluster/">Dynamic Cluster</a> installations have two sets of the Server-wide Skins - one set is used for local Server Domains, while the other, Cluster set is used for all Shared Domains in the Cluster. Modifications of these Cluster-wide Skins, as well as modifications of any Skin in any Shared Domain are automatically distributed to all Cluster Members.</p><h2 id="Strings" tabindex="-1">Languages and Skin Text Dataset <a class="header-anchor" href="#Strings" aria-label="Permalink to &quot;Languages and Skin Text Dataset {#Strings}&quot;">​</a></h2><p>Each Skin can have a Text Dataset - the <code>strings.data</code> text file. This &quot;default language&quot; file contains a <a href="./Data.html">dictionary</a>. The <a href="./WSSP.html">WSSP</a> script pages can use various commands to retrieve data from this Text Dataset dictionary.</p><p>A Skin can contain additional, localized Text Dataset files - <code>language.data</code> files, where <em>language</em> is the language name (<em>french.data</em>, <em>japanese.data</em>, etc.). If a non-default language is selected, the Text Dataset from the specified language file is used.</p><p>When the selected Text Dataset of the selected Skin does not contain the requested data, the same language Text Datasets are checked in all Skin &quot;parents&quot; (as specified above). If the requested data is still not found, the &quot;default language&quot; Text Dataset is used.</p><p>Use the UTF-8 character set to place non-ASCII symbols strings into a Text Dataset file. Check the <a href="http://www.unicode.org" target="_blank" rel="noreferrer">http://www.unicode.org</a> site to learn more about Unicode and the UTF-8 charset.</p><p>You may want to break one Text Dataset file into several files. You can place several <code>strings.subname.data</code> files into a Skin. These files are read when the <code>strings.data</code> file is read. The file content (a dictionary) is added to the Text Dataset dictionary as the <code>subname</code> key value.<br> The <code>language.subname.data</code> files are processed in the same way, extending the localized Text Datasets.</p><h2 id="Files" tabindex="-1">Serving Regular Files <a class="header-anchor" href="#Files" aria-label="Permalink to &quot;Serving Regular Files {#Files}&quot;">​</a></h2><p>When a URL specifies a file with any file name extension other than <code>.wssp</code>, the Web Application module retrieves this file from the selected Skin, places it into the internal Skin Cache, and returns that file to the client browser via the HTTP module connection.</p><p>The specified file names are always converted into the lowercase letters.</p><p>When the Web Application module receives a request for the same file, it is retrieved from the Skin Cache.</p><p>If the file has been requested using a Session-based URL, the session time-out counter is reset. This can be used to create a frame in the client browser window, and make that frame periodically retrieve some file using the session URL. As a result, this session inactivity timer can be reset to keep the session alive as long as this frame is displayed in the user&#39;s browser.</p><p>System and Domain administrators can upload custom files into server-wide and Domain Skins to modify the Web Application look and feel.<br> For example, the Stock Skin uses the <code>Logo.gif</code> file for most of its pages. By uploading a custom Logo.gif file to a server-wide Unnamed Skin you can change the look of the Web Application pages even without creating and uploading custom page (WSSP) files.</p><p>To include a file reference to into a .wssp page retrieved with a Stateless request, use the %%filesRef%% prefix in the .wssp code:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>... href=&quot;%%filesRef%%filename.extension&quot; ...</span></span></code></pre></div><p>See the <a href="#Stateless">Code Components for Stateless Requests</a> section for more details.</p><p>Sessions can use Named Skins, and the session-based pages usually need to refer to regular files in the same Skin. References in the &quot;session realm&quot; (<code>href=&quot;filename.extension&quot;</code> or <code>href=&quot;/Session/sessionID/filename.extension&quot;</code>) work, but they do not allow client browsers to cache these files between sessions, since each session has its own sessionID, and file URLs are different for each session. To allow client browsers to cache regular files, use the %%SESSION(filesRef)%% prefix for file URLs:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>... href=&quot;%%SESSION(filesRef)%%/filename.extension&quot; ...</span></span></code></pre></div><p>See the <a href="./WSSP.html#Exprs">Session Dataset</a> description for more details.</p><h2 id="WSSP" tabindex="-1">Serving Web Application (WSSP) Files <a class="header-anchor" href="#WSSP" aria-label="Permalink to &quot;Serving Web Application (WSSP) Files {#WSSP}&quot;">​</a></h2><p>When a URL specifies a resource with the <code>.wssp</code> file name extension, the Web Application module retrieves the specified WSSP file from the Skin, and Compiles it into some internal code. The module then runs the Web Application code associated with the file name. This code produces a dataset with various string, array, and dictionary data. Then the module runs the WSSP internal (compiled) code to produce an HTML page using this dataset, and returns the resulting HTML page to the browser using the HTTP module connection.</p><p>The specified resource names are always converted into the lowercase letters.</p><p>The <a href="./WSSP.html">WSSP Scripting</a> section explains the WSSP file format. System and Domain administrators can create custom WSSP files and upload them to the server-wide and Domain Skins to modify the Web Application look and feel.</p><p>The <a href="#Processing">section below</a> lists the available Web Application code components, defining the set of WSSP pages that this version of CommuniGate Pro server can generate. It specifies how each component processes the form parameters sent to it, and what data is included into the dataset it generates.</p><h2 id="Editor" tabindex="-1">Creating and Managing Skins <a class="header-anchor" href="#Editor" aria-label="Permalink to &quot;Creating and Managing Skins {#Editor}&quot;">​</a></h2><p>You can create and manage Skins using the <a href="./../admin/services/HTTP.html">WebAdmin Interface</a>, <a href="./CLI.html">CLI/API</a>, or any client/protocol (such as <a href="./../admin/access/FTP.html">FTP</a>) that can access the Account <a href="./../admin/storage/FileStore.html">File Storage</a>.</p><h3 id="WebAdminEdit" tabindex="-1">WebAdmin Editor <a class="header-anchor" href="#WebAdminEdit" aria-label="Permalink to &quot;WebAdmin Editor {#WebAdminEdit}&quot;">​</a></h3><p>The WebAdmin Interface provides Skin Editor pages to manage Server-wide, Cluster-wide, and Domain Skins.</p><p>To manage the Server-wide and Cluster-wide Skins, open the Users realm of the WebAdmin Interface, and click the Skins link.</p><p>To manage the Domain Skins, open that Domain page in the Users realm of the WebAdmin Interface, and click the Skins link. The Domain Administrator should have the CanModifySkins Access Right to be able to create and modify the Domain Skins.</p><p>When the Domain Skins Editor page is opened, and there is no Unnamed Skin for the Domain, the page contains the Create Unnamed Skin button. Click this button to create the Unnamed Skin for this Domain.</p><p>The Skin Editor page contains the list of all files &quot;visible&quot; in this Skin: it lists files directly uploaded to this particular Skin, as well as all files uploaded to the Skins used as the &quot;default files&quot; source for this Skin:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="left"><input name="Create" value="Upload File" class="button" type="reset"><input name="Upload" type="file"></td><td align="right"><input name="Flush" value="Uncache" class="buttonWhite" type="reset"></td></tr></tbody></table></div><br><div class="settingsBox"><table width="100%"><tbody><tr><th> </th><th align="left">Name</th><th align="right">Size</th><th align="right">Modified</th></tr><tr><td align="center"><input type="checkbox" name="MFile" value="Help.gif"></td><td><a href="#Editor">Help.gif</a></td><td align="right">155</td><td align="right">25-Sep-06</td></tr><tr><td align="center">default</td><td><a href="#Editor">addressbook.wssi</a></td><td align="right">1143</td><td align="right">23-Sep-06</td></tr><tr><td align="center">default</td><td><a href="#Editor">alerts.wssp</a></td><td align="right">1727</td><td align="right">26-Sep-07</td></tr><tr><td align="center">default</td><td><a href="#Editor">answeredletter.gif</a></td><td align="right">890</td><td align="right">27-Feb-06</td></tr><tr><td align="center">default</td><td><a href="#Editor">attachedFile.gif</a></td><td align="right">1147</td><td align="right">27-Feb-07</td></tr><tr><td colspan="5" align="center">...</td></tr><tr><td align="center">default</td><td><a href="#Editor">mailbox.wssp</a></td><td align="right">5806</td><td align="right">28-Sep-06</td></tr><tr><td align="center"><input type="checkbox" name="MFile" value="mailboxes.wssp"></td><td><a href="#Editor">mailboxes.wssp</a></td><td align="right">3452</td><td align="right">02-Oct-06</td></tr><tr><td colspan="5" align="center">...</td></tr><tr><td align="center">default</td><td><a href="#Editor">strings.data</a></td><td align="right">28K</td><td align="right">27-Oct-06</td></tr><tr><td align="center">default</td><td><a href="#Editor">german.data</a></td><td align="right">31K</td><td align="right">28-Oct-06</td></tr><tr><td colspan="5" align="center">...</td></tr><tr><td align="center">default</td><td><a href="#Editor">website.wssp</a></td><td align="right">592</td><td align="right">28-Sep-06</td></tr><tr><td align="center">default</td><td><a href="#Editor">websitebody.wssi</a></td><td align="right">2648</td><td align="right">28-Sep-06</td></tr><tr><td colspan="2" align="left"><input name="Remove" value="Delete Marked" class="buttonRed" type="reset"></td><td></td><td align="right"><input name="Flush" value="Uncache" class="buttonWhite" type="reset"></td></tr></tbody></table></div></form><p>Files directly uploaded to the Skin have a checkbox in the Marker column. Files from the other skins &quot;visible&quot; in this Skin have the word <code>default</code> in that column.</p><p>You can download any of the Skin files by clicking the file name.</p><p>You can upload a file to the Skin by clicking the Browse button and selecting a file on your workstation, then clicking the Upload button.</p><p>You can delete any of the files uploaded to the Skin by selecting the checkboxes and clicking the Delete Marked button.</p><p>If you are uploading a <code>.wssp</code> or a <code>.wssi</code> file, the Editor tries to compile that <a href="./WSSP.html">WSSP</a> file first.<br> If you are uploading a <code>.wcgp</code> or a <code>.wcgi</code> file, the Editor tries to compile that <a href="#CGPL">CG/PL</a> file first.<br> If you are uploading a <code>.data</code> file, the Editor tries to parse it as a <a href="./Data.html">dictionary</a> file first.<br> If the compiler or the parser detects an error, the file is not uploaded, and the file content is displayed on the Editor page, with the red <code>&lt;--ERROR--&gt;</code> marker indicating the location of the error.</p><p>When you upload a file to any Skin, that Skin cache is automatically cleared. If you upload a file to a Shared Domain Skin or to a Cluster-wide Skin, the update automatically propagates to all Cluster Members.</p><p>You can upload a set of files by uploading a TAR-archive (a file with <code>.tar</code> name extension). For example, when you have a TAR-archive with a predesigned Skin you can open the Skin you want to modify (the Server-wide Unnamed Skin or Domain-wide Unnamed Skin or some Named Skin), and upload the <code>.tar</code> file. The Server will unpack the archive and store each file individually, as if they were uploaded one-by-one.</p><p>The Editor page for the Unnamed Skin contains the list of all Named Skins:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Named Skins</b></td></tr><tr><td align="center" width="50"><input type="checkbox" name="MSkin" value="GGGG"></td><td align="left"><a href="#Editor">GoldenFleece</a></td></tr><tr><td align="center"><input type="checkbox" name="MSkin" value="IceColdMail"></td><td align="left"><a href="#Editor">IceColdMail</a></td></tr></tbody><tfoot><tr><th align="center"><input name="RemoveSkin" value="Delete Marked" class="buttonRed" type="reset"></th><th align="right"><input name="CreateSkin" value="Create" class="buttonWhite" type="reset"><input name="NewName" size="30" maxlength="255" type="text"></th></tr></tfoot></table></div></form><p>To create a Named Skin, enter its name, and click the Create button.</p><p>To remove Named Skins, use the checkboxes to select the Skins, and then click Remove Marked button. Only empty Skins (Skins without any files) can be removed.</p><p>To remove the Unnamed Skin, remove all its files and all Named Skins, and then click Remove Unnamed Skin button.</p><p>To open a Skin, click its name. The Editor will display the Skin Name, and it will provide the <code>UP</code> link to the Unnamed Skin page.</p><p>The Named Skin Editor allows you to rename the Skin by entering a new Skin Name and clicking the Rename Skin button.</p><h3 id="CLIEdit" tabindex="-1">CLI/API <a class="header-anchor" href="#CLIEdit" aria-label="Permalink to &quot;CLI/API {#CLIEdit}&quot;">​</a></h3><p>The Command Line Interface/API can be used to manage Skins. See the <a href="./CLI.html#WebSkin">Web Skins Administration</a> section for the details.</p><h3 id="FileStorage" tabindex="-1">Virtual File Storage Area <a class="header-anchor" href="#FileStorage" aria-label="Permalink to &quot;Virtual File Storage Area {#FileStorage}&quot;">​</a></h3><p>The Skins can be modified using <a href="./../admin/access/FTP.html">FTP</a> and <a href="./../admin/services/HTTP.html">HTTP</a> clients, <a href="./CGPL.html">CG/PL</a> applications, and any other method that provides access to the Account <a href="./../admin/storage/FileStore.html">File Storage</a>.<br> Special <code>$DomainSkins</code>, <code>$ServerSkins</code>, and <code>$ClusterSkins</code> directories provide access to the Domain and Server/Cluster-wide Skins.</p><h2 id="Processing" tabindex="-1">Request Processing <a class="header-anchor" href="#Processing" aria-label="Permalink to &quot;Request Processing {#Processing}&quot;">​</a></h2><p>The CommuniGate Pro Web Application module processes a request for a WSSP file by calling a code component that produces a <em>dataset</em> - a <a href="./Data.html">dictionary</a> containing text string keys and values, associated with those keys. Values can be text strings, arrays of values, or dictionaries.</p><p>For example, when a Domain default page is requested, the code component called and it produces a dictionary that contains keys such as <code>canAutoSignup</code>, <code>hasMailLists</code>, <code>hasCertificate</code>.</p><p>The Web Application module then uses the script code from a WSSP file to convert this data into into an HTML or other markup language page.</p><p>This section lists the available CommuniGate Pro code components, specifies when those components are called, explains how the code components process the <code>&lt;FORM&gt;</code> parameters, and specifies the content of the dataset produced by each code component.</p><h2 id="Stateless" tabindex="-1">Code Components for Stateless Requests <a class="header-anchor" href="#Stateless" aria-label="Permalink to &quot;Code Components for Stateless Requests {#Stateless}&quot;">​</a></h2><p>The Web Application module checks the <code>Skin</code> HTTP parameter for all Stateless requests. If this parameter exists, the module tries to open a Named Skin with the specified name, otherwise the Unnamed Skin (for the addressed Domain) is used.</p><p>The Web Application module checks the <code>Language</code> HTTP parameter for all Stateless requests. If this parameter exists, the module uses it to selected a non-default Text DataSet for the selected Skin.</p><p>The Web Application module places certain data into datasets produced with all Stateless Requests code components. The following list specifies these &quot;generic&quot; dataset elements that can be used with all Stateless WSSP pages:</p><ul><li><p><code>filesRef</code></p><p>This element value is a string that can be used to form a URL that refers to a file (image, style sheet, data, etc.) from the same Skin in the same Domain. The <code>&lt;img src=&quot;%%filesRef%%Logo.jpeg&quot;&gt;</code> HTML element will display the <code>Logo.jpg</code> file &quot;visible&quot; in the current Skin.</p></li><li><p><code>serverName</code></p><p>This element value is a string with this CommuniGate Pro server name (its Main Domain Name).</p></li><li><p><code>skinName</code></p><p>This optional element value is the current Skin name string.</p></li><li><p><code>language</code></p><p>If a non-default language was selected, this optional element contains a string - the selected language name.</p></li><li><p><code>domainName</code></p><p>This element value is a string containing the CommuniGate Pro Domain name. This element exists only if the Server has succeeded to direct the Stateless Request to one of the server Domains.</p></li><li><p><code>accessURL</code></p><p>This element value is a string containing the preferred URL to access the domain&#39;s Web services. This element exists only if the Server has succeeded to direct the Stateless Request to one of the server Domains.</p></li><li><p><code>charset</code></p><p>This element value is the value of the <code>charset</code> element from the Domain Skin Text Dataset. Individual code components may specify other values for the <code>charset</code> element (see below).</p></li><li><p><code>secureChannel</code></p><p>This element exists and has the <code>YES</code> string value if the request has been received via a secure (HTTPS) connection.</p></li></ul><p>The following sections specify the Stateless URLs, the name of the code component called, the actions taken by the component, the dataset produced with that component, and the name of the WSSP file used to produce the HTTP response.</p><p><strong>URLs: <code>/</code>, <code>/default.html</code></strong></p><p>these URLs are used to process Login operations.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request has the <code>username</code> and <code>password</code> parameters, the code tries to authenticate the client using these parameter values. If the supplied credentials are correct, a new WebUser Session is created, and a request for the &quot;entry page&quot; is sent to the Session. This request usually returns an HTML &quot;jump page&quot; that is sent back to the user browser. It forces the browser to enter the &quot;Session realm&quot;.</p><p>If the request has the <code>DisableIPWatch</code> parameter, the &quot;Fixed IP Address&quot; security feature will be disabled for this session, even if the Account WebUser preferences enable it.</p><p>If the request has the <code>DisableUseCookie</code> parameter, the &quot;Use Cookies&quot; security feature will be disabled for this session, even if the Account WebUser preferences enable it.</p><p>If the request has <code>SessionSkin</code> parameter with a string value not equal to <code>*</code>, the session is opened using the Skin specified with this parameter. The Skin is searched in the Domain of the logged-in user (which can be different than the Domain used to display the Login page).</p></li><li><p><strong>Result Dataset</strong></p><p>If <code>username</code> or <code>password</code> parameter has not been specified, or a WebUser Session could not be created, the component generates the following <em>dataset</em>:</p><ul><li><p><code>autoSignup</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if the addressed Domain provides the Auto-Signup operation.</p></li><li><p><code>autoLogin</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if automatic login is enabled for the addressed Domain.</p></li><li><p><code>clientAddress</code></p><p>this string element contains the IP address of the user browser.</p></li><li><p><code>errorCode</code></p><p>this element is added to the dataset if the Login operation has failed. The value is a string with the error code.</p></li><li><p><code>forgotPassword</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if the <code>errorCode</code> value is &quot;Incorrect Password&quot; or &quot;Unknown Account&quot;.</p></li><li><p><code>hasCertificate</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if the addressed Domain has a custom <a href="./../admin/sysadmin/Security.html">Certificate</a>.</p></li><li><p><code>hasDirectory</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if the default Skin for the addressed Domain has an array element <code>GuestDirectoryFields</code> in its Text Dataset, and that array is not empty.</p></li><li><p><code>hasLists</code></p><p>this element (with the string <code>YES</code> as the value) is added to the dataset if the addressed Domain has at least one Mailing List. This element is always added if the addressed Domain is a Shared Domain.</p></li><li><p><code>skinNames</code></p><p>this element contains an array - the list of skin names available in the addressed Domain.</p></li><li><p><code>loginName</code></p><p>this string element is added to the dataset if the user has tried to log in, but failed. The value specified in the username parameter becomes the loginName element value.</p></li><li><p><code>restoreSessionPage</code></p><p>this string element is added to the dataset if the user has been disconnected. It contains the name of the interrupted request session page name.<br> To allow an interrupted request to resume, the <code>restoreSessionPage</code> HTTP parameter with this element value should be included into the HTTP request generated by this page.</p></li><li><p><code>restoreCharset</code></p><p>this string element is added to the dataset if the user has been disconnected. It contains the charset used in the interrupted request.<br> To allow an interrupted request to resume, the <code>restoreCharset</code> HTTP parameter with this element value should be included into the HTTP request generated by this page.</p></li><li><p><code>restoreParameters</code></p><p>this array element is added to the dataset if the user has been disconnected. Each array element is a dictionary with the following elements:</p><ul><li><p><code>name</code></p><p>name of an interrupted request parameter.</p></li><li><p><code>value</code></p><p>encoded value of an interrupted request parameter. To allow an interrupted request to resume, parameters with these names and values should be included into the HTTP request generated by this page.</p></li></ul></li></ul></li><li><p><strong>WSSP page</strong></p><p>the <code>login.wssp</code> page is used to generate the HTTP response.</p></li></ul><p>If login operation was successful, the HTTP Redirect response is returned, with the Redirect URL pointing to the <em>StartPage</em> wssp page within a newly created Session. The StartPage is specified as the <code>StartPage</code> Skin string.</p><p>If login operation was successful, but the request contained the <code>restoreSessionPage</code> parameter, the <code>resume.wssp</code> page is displayed (as a Stateless one).</p><p>The Result Dataset for this page contains:</p><ul><li><p><code>restoreParameters</code></p><p>see description above.</p></li><li><p><code>sessionID</code></p><p>the SessionID for the newly created session (the same value as the value of <code>SESSION(ID)</code> function that can be used on session wssp pages).</p></li><li><p><code>jumpPage</code></p><p>the wssp page to open if the user wants to resume the interrupted operation (it includes optional parameters).</p></li></ul><p><strong>URL: <code>/RecoveryPassword.wssp</code></strong></p><p>this URL is used to process Password Recovery operations.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request has the <code>username</code> and <code>Send</code> parameters, the component tries to find the specified Account, retrieves the Account password, and the <code>RecoverPassword</code> Account Setting. If the password can be decrypted and the RecoverPassword is specified, an E-mail message containing the password is composed and sent to the RecoverPassword E-mail address.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>errorCode</code></p><p>this element is added to the dataset if the Password Recovery operation has failed. The value is a string with the error code.</p></li><li><p><code>messageCode</code></p><p>this element is added to the dataset if the Password Recovery operation has succeeded. The value is the <code>PasswordSent</code> string.</p></li></ul></li><li><p><strong>WSSP page</strong></p><p>the <code>recoverypassword.wssp</code> page is used to generate the HTTP response.</p></li></ul><p><strong>URL: <code>/Signup.wssp</code></strong></p><p>this URL is used to process Auto-Signup operations.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request has the <code>username</code>, <code>password1</code>, <code>password2</code>, and the <code>realName</code> parameters, the component tries to create the specified Account. Before it tries to create an Account, it checks if the <code>password1</code> and <code>password2</code> strings are the same. If a new Account is created, its <code>UseAppPassword</code> setting is set to <code>YES</code>, the <code>Password</code> and <code>RealName</code> settings are set to the specified values. If the HTTP request contains a non-empty ForgotPassword parameter, it is used as the RecoverPassword Account Setting.</p><p>The component checks if the request contains one or more <code>PublicInfo</code> string parameters. The value of the parameter must be one of the Public Info Attributes specified in the <a href="./../admin/directory/CentralDir.html">Directory Integration</a> settings. The component than checks if there is a non-empty request parameter with this name, and adds the parameter value to the initial Account settings.<br> Example: to provide a <code>City</code> field on the Auto-Signup page, include the <code>&lt;INPUT type=&quot;hidden&quot; name=&quot;PublicInfo&quot; value=&quot;City&quot;&gt;</code> control and the <code>&lt;INPUT type=&quot;text&quot; name=&quot;City&quot; value=&quot;&quot; size=30 maxlength=255&gt;</code> control into the Signup.wssp HTML code.</p><p>If an Account has been created, a new WebUser Session is created, and a request for the &quot;entry page&quot; is sent to the Session (see above).</p></li><li><p><strong>Result Dataset</strong></p><p>If <code>username</code>, <code>password1</code>, <code>password2</code>, or the <code>realName</code> parameter has not been specified in the HTTP request, or a new Account could not be created, the component generates the following <em>dataset</em>:</p><ul><li><p><code>errorCode</code></p><p>this element is added to the dataset if the Auto-Signup operation has failed. The value is a string with the error code.</p></li><li><p><code>userName</code></p><p>this element is added to the dataset if HTTP request contained a non-empty <code>userName</code> parameter. The element value is the value of the parameter.</p></li><li><p><code>realName</code></p><p>this element is added to the dataset if HTTP request contained a non-empty <code>realName</code> parameter. The element value is the value of the parameter.</p></li><li><p><code>recoverPassword</code></p><p>this element is added to the dataset if HTTP request contained a non-empty <code>recoverPassword</code> parameter. The element value is the value of the parameter.</p></li></ul></li><li><p><strong>WSSP page</strong></p><p>the <code>signup.wssp</code> page is used to generate the HTTP response.</p></li></ul><p><strong>URL: <code>/List/</code>, <code>/List/default.html</code></strong></p><p>this URL is used to retrieve the list of the browsable Domain <a href="./../admin/mail/LIST.html">Mailing Lists</a>.</p><ul><li><p><strong>Actions</strong></p><p>The HTTP request parameters are not processed.</p></li><li><p><strong>Result Dataset</strong></p><p>The component generates the following <em>dataset</em>:</p><ul><li><p><code>errorCode</code></p><p>this element is added to the dataset if the list retrieval operation has failed. The value is a string with the error code.</p></li><li><p><code>lists</code></p><p>this element contains an array of mailing list descriptors. Each descriptor is a dictionary with the following keys and values:</p><ul><li><p><code>name</code></p><p>a string with the mailing list name.</p></li><li><p><code>realName</code></p><p>the mailing list &quot;description&quot; string.</p></li><li><p><code>browse</code></p><p>the string describing the mailing list archive browsing policies. The string value can be <code>anyone</code> or <code>subscribers</code>.</p></li></ul></li></ul></li><li><p><strong>WSSP page</strong></p><p>the <code>listlist.wssp</code> page is used to generate the HTTP response.</p></li></ul><p><strong>URL: <code>/List/listname/</code></strong>, <strong><code>/List/listname/List.html</code></strong></p><p>this URL is used to retrieve a portion of the mailing list records for the <em>listname</em> <a href="./../admin/mail/LIST.html">Mailing List</a>.</p><p>The code component actually uses the generic <a href="#Mailbox">Mailbox</a> Code Component.</p><ul><li><p><strong>Actions</strong></p><p>The component checks if the HTTP request contains the <code>NextMessage</code> parameter with a numeric value. If it exists, the value is interpreted as the unique message ID (UID) in the list archive Mailbox, and the component tries to find this message in the selected Mailbox &quot;view&quot;, and tries to find the next message in the view.</p><p>The component checks if the HTTP request contains the <code>PrevMessage</code> parameter with a numeric value. If it exists, the value is interpreted as the unique message ID in the list archive Mailbox, and the component tries to find this message in the selected Mailbox &quot;view&quot;, and tries to find the previous message in the view.</p><p>If the next or previous message is found, its UID is added to the dataset (see below) and the generic Mailbox component is not used for processing.</p><p>If no next/previous message is found, the generic Mailbox component is used to process the HTTP request parameters and to compose the resulting dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>listName</code></p><p>a string with the Mailing List name.</p></li></ul><p>If a next or previous message is found:</p><ul><li><p><code>messageJump</code></p><p>a string with the found message UID.</p></li></ul><p>If a next or previous message was not requested in the HTTP request parameters or it was not found:</p><ul><li><p><code>realName</code></p><p>the Mailing List Description string</p></li><li><p><code>charset</code></p><p>the Mailing List Preferred charset string</p></li></ul><p>the generic Mailbox code component is used to generate the rest of the resulting dataset.</p></li><li><p><strong>WSSP page</strong></p><p>the <code>listmailbox.wssp</code> page is used to generate the HTTP response.</p></li></ul><p><strong>URL: <code>/List/listname/Message/uid.html</code></strong></p><p>this URL is used to retrieve the message with <em>uid</em> unique ID from the <em>listname</em> mailing list archive.</p><p>The code component actually uses the generic <a href="#Message">Message</a> Code Component.</p><ul><li><p><strong>Actions</strong></p><p>The generic Message component is used to process the HTTP request parameters and to compose the resulting dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>listName</code></p><p>a string with the Mailing List name.</p></li><li><p><code>nextMsg</code></p><p>this element is added if there is a next message in the archive Mailbox view. The element value is a string with the next message UID.</p></li><li><p><code>prevMsg</code></p><p>this element is added if there is a previous message in the archive Mailbox view. The element value is a string with the previous message UID. The generic Message code component is used to generate the rest of the resulting dataset.</p></li></ul></li><li><p><strong>WSSP page</strong></p><p>the <code>listmessage.wssp</code> page is used to generate the HTTP response.</p></li></ul><h2 id="Error" tabindex="-1">Error Pages <a class="header-anchor" href="#Error" aria-label="Permalink to &quot;Error Pages {#Error}&quot;">​</a></h2><p>The WSSP mechanism is used to generate HTTP response body for error responses. The following table lists the HTTP error codes, the situations when this error code is generated, and the WSSP file used to product the HTTP error response body.</p><table tabindex="0"><thead><tr><th>Code</th><th>Error conditions</th><th>WSSP file used</th></tr></thead><tbody><tr><td>301</td><td>the requested resource has been moved</td><td><code>moved.wssp</code></td></tr><tr><td>404</td><td>the requested resource does not exist</td><td><code>notfound.wssp</code></td></tr><tr><td>401</td><td>the requested page requires the HTTP Authorization (request header)</td><td><code>unauthorized.wssp</code></td></tr><tr><td>401</td><td>the credentials in the HTTP Authorization request header are incorrect</td><td><code>denied.wssp</code></td></tr><tr><td>500</td><td>generic system error</td><td><code>failure.wssp</code></td></tr><tr><td>501</td><td>generic system error</td><td><code>error.wssp</code></td></tr></tbody></table><p>These WSSP pages are processed using datasets generated for all Stateless requests, with the following additional elements:</p><ul><li><p><code>errorCode</code></p><p>this element is added to the dataset if there is an error code to be reported to the user.</p></li><li><p><code>hostName</code></p><p>this element is added to the dataset if the HTTP request contained the <code>Host:</code> field. The element value is that request field parameter.</p></li></ul><p>The <code>disconnected.wssp</code> page is used when an HTTP request was sent to a WebUser Session, but the session has not been found. The page is processed using a dataset generated for all Stateless requests.</p><h2 id="Session" tabindex="-1">Code Components for Session Requests <a class="header-anchor" href="#Session" aria-label="Permalink to &quot;Code Components for Session Requests {#Session}&quot;">​</a></h2><p>When a new WebUser Session is created, the Skin specified in the Account WebUser Preferences is opened and is used as the &quot;Session Skin&quot;. The string <code>StartPage</code> is retrieved from that Skin Text Dataset, and a jump page is composed and sent to the user browser. The jump page redirects the user browser into the &quot;Session Realm&quot;, to the page specified with the <code>StartPage</code> string.</p><p>HTTP requests to the &quot;Session realm&quot; (requests with URLs started with <code>/Session/</code>) are processed as Session Requests. The second component of the Session Request URL is a unique Session ID, the HTTP module uses it to find the WebUser session.</p><p>If the specified session is not found, or the Session has the <code>Fixed Network Address</code> option set, and the HTTP request did not come from the same IP address as the Login request that started the session, the <code>disconnected.wssp</code> page is displayed (see above).</p><p>After the Session is found, the Web Application module processes the rest of the request URL as the &quot;request inside this session realm&quot;. If the request URL specifies a regular file, that file is retrieved from the Session Skin, and it is sent back to the user browser.</p><p>For each <code>.wssp</code> request a code component is called. It processes the HTTP request parameters and generates a <em>result dataset</em>. Then the .wssp file is retrieved from the Skin, and it is used to compose the HTTP response.</p><p>If the result dataset does not contain the <code>blockAlerts</code> element, the Web Application module checks if there is a pending <a href="./../admin/sysadmin/Alerts.html">Alert</a> for the session user. If one or several pending alerts are found, the <code>Alerts</code> code component is called, and the <code>Alerts.wssp</code> file is used to compose the HTTP response.</p><p>The Web Application module checks for certain HTTP request parameters and processes them for all .wssp page requests. The following list specifies these &quot;generic&quot; actions:</p><ul><li><p><code>EmptyTrashNow</code></p><p>If the HTTP request contains this parameter, and the Mailbox or Mailbox alias with the name <code>Trash</code> can be opened with the &quot;Can Delete&quot; Mailbox Access Right, then the code component removes all messages from that Mailbox. If this operation fails, the error code is placed into the resulting dataset as the <code>errorCode</code> string element.</p></li><li><p><code>SMIMEUnlock</code></p><p>If the HTTP request contains this parameter and the session does not have an Active Private Key, and the encrypted Private Key exists in the Account Settings, and the HTTP request contains the <code>SMIMEPassword</code> parameter, the module tries to activate (&quot;unlock&quot;) the Private Key using the supplied password. If the operation fails, the error code is placed into the resulting dataset as the <code>SMIMEError</code> string element.</p></li></ul><p>The Web Application module places certain data into datasets produced with all Session Requests code components. The following list specifies these &quot;generic&quot; dataset elements that can be used with all Session WSSP pages:</p><ul><li><p><code>messageText</code></p><p>This string element is added if the HTTP request contains the <code>messageText</code> parameter. The element value is the same as the HTTP parameter value.</p></li><li><p><code>messageCode</code></p><p>This string element is added if the HTTP request contains the <code>messageCode</code> parameter. The element value is the same as the HTTP parameter value.</p></li><li><p><code>secureChannel</code></p><p>This element exists and has the <code>YES</code> string value if the request has been received via a secure (HTTPS) connection.</p></li><li><p><code>charset</code></p><p>This string element contains the Preferred Charset selected in the User Preferences, if the Use UTF8 mode is set to Never. Otherwise, this element contains the <code>utf-8</code> string.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>It&#39;s just a default value, individual code components can specify different values for this dataset element.</p></div></li><li><p><code>SMIMEActive</code></p><p>This element exists and has the <code>YES</code> string value if the session has an unlocked (Active) SMIME Private Key.</p></li><li><p><code>SMIMEInactive</code></p><p>This element exists and has the <code>YES</code> string value if the session does not have an unlocked (Active) SMIME Private Key, but the user has the Private Key in the Account Settings, and the Key can be unlocked.</p></li><li><p><code>mailboxes</code></p><p>The list of all selectable Mailboxes visible to the user.</p></li></ul><p>If a .wssp request specifies an unknown code component, but the .wssp file with the specified name can be retrieved from the Session Skin, that .wssp file is processed using the dataset with the &quot;generic&quot; elements only, and the result is sent back to the user browser.</p><p>Example: The Stock Skin uses <code>Hello.wssp</code> requests. There is no code component with this name, so a dataset with the generic values is composed, and the <code>Hello.wssp</code> file is used to process this dataset.</p><p>The following sections specify the names of existing code components (names for .wssp requests), the actions taken by these component, and the dataset produced with these components.</p><p>The code component results are processed using the .wssp files with the same names as the code component names.</p><p><strong>Name: <code>Mailboxes</code></strong></p><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>Create</code> parameter and the <code>NewName</code> parameter is a non-empty string, the component tries to create a Mailbox with the specified name. If this operation fails, the <code>errorCode</code> element with the error code text is added to the result dataset. If the Mailbox is created, the <code>messageCode</code> element with <code>MailboxCreated</code> string value is added to the result dataset, and the created Mailbox name is added to the list of subscribed Mailboxes, if the Show Subscribed Mailboxes option is selected in the Account WebUser Preferences.<br> If the request contains the <code>newClass</code> parameter, then the created Mailbox is set to the specified class.</p><p>If the HTTP request contains the <code>Filter</code> parameter, only the Mailboxes with names containing this parameter value are included into the list.</p><p><strong>Result Dataset</strong></p><p>The code component creates a list of all Account Mailboxes and Mailbox Aliases (if the Show All Account Mailboxes option is selected in the Account WebUser Preferences), or the list of all subscribed Mailboxes (if the Show Subscribed Mailboxes option is selected). If both options are selected, these two lists are merged into one.</p><ul><li><p><code>filter</code></p><p>this string element contains the current value of the HTTP <code>Filter</code> parameter.</p></li><li><p><code>newName</code></p><p>this string element contains the current value of the HTTP <code>NewName</code> parameter.</p></li><li><p><code>mailboxClasses</code></p><p>this array elements contains strings - names of all supported Mailbox classes.</p></li><li><p><code>mailboxList</code></p><p>this element is an array with one dictionary-type element for each Mailbox in the composed Mailbox list. Each dictionary contains the following elements:</p><ul><li><p><code>mailboxName</code></p><p>this string element contains the Mailbox name.</p></li><li><p><code>parent</code></p><p>this string element exists if the Mailbox is a submailbox of some other Mailbox. The string contains the name of that parent Mailbox.</p></li><li><p><code>nonSelectable</code></p><p>this string element with the value <code>Yes</code> is added if the Mailbox is not selectable. If it is added, none of the following elements is added to the dictionary.</p></li><li><p><code>isList</code></p><p>this element is added if the Mailbox is the main Mailbox (archive) for a Mailing List (this also means that there is a Mailing List with the same name).</p></li><li><p><code>nMessages</code></p><p>this string element contains the number of messages in the Mailbox. If the number cannot be retrieved, the element value is the <code>???</code> string.</p></li><li><p><code>nRecent</code></p><p>this string element contains the number of &quot;Recent&quot; messages in the Mailbox.</p></li><li><p><code>numUnread</code></p><p>this string element contains the number of &quot;Unseen&quot; messages in the Mailbox.</p></li><li><p><code>size</code></p><p>this string element contains the &quot;rounded&quot; size of the Mailbox.</p></li><li><p><code>mailboxClass</code></p><p>this optional string element contains the Mailbox class (for non-mail Mailboxes).</p></li><li><p><code>mailboxPage</code></p><p>this string element contains the name of the wssp page to be used to process this Mailbox class.</p></li></ul></li><li><p><code>nSelected</code></p><p>this string element contains the number of elements in the <code>mailboxList</code> array.</p></li><li><p><code>trashSize</code></p><p>this string element is added only if the Account has the <code>Trash</code> Mailbox. It contains the <code>Trash</code> Mailbox size.</p></li><li><p><code>currentStorage</code></p><p>this string element contains the &quot;rounded-up&quot; total size of Account Mailboxes.</p></li><li><p><code>storageLimit</code></p><p>this string element contains the &quot;rounded-up&quot; Account total Mailbox size limit. If the Account does not have the total Mailbox size limit, this element contains the <code>unlimited</code> string.</p></li></ul><p><strong>Name: <code>Mailbox</code></strong></p><p>The HTTP request must contain the <code>Mailbox</code> parameter - the name of the Mailbox to be displayed.</p><p><strong>Actions</strong></p><p>For each Mailbox, the module creates a session object that contains the Mailbox view parameters. When the object is created, these parameters are initiated with the WebUser Preferences values.</p><p>The HTTP request <code>Msg</code> parameters are interpreted as &quot;message set elements&quot;. A request can contain several parameters, and each parameter should have a numeric value - the Unique ID of a Mailbox message.</p><p>If the HTTP request contains the <code>Forward</code> or <code>Redirect</code> parameter and the <code>RedirectAddresses</code> parameter is not empty, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, and the message set messages are forwarded or redirected to the specified addresses.<br> If the HTTP request contains the <code>ListApprove</code> parameter and the Mailbox is an &quot;approval&quot; or &quot;requests&quot; Mailbox for some mailing list, the request is processed as the <code>Redirect</code> request with the effective address being the mailing list address or the &quot;subscription&quot; request for that list.<br> If the operation has been successful, the <code>messageCode</code> element with the <code>MessagesForwardedInfo</code> or <code>MessagesRedirectedInfo</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>Copy</code> or <code>Move</code> parameter and the <code>MailboxName</code> parameter contains a name of some selectable Mailbox, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, and the message set messages are copied to the specified Mailbox. If the <code>Move</code> parameter was specified, the message set messages are marked as Deleted, physically deleted, or moved to Trash - depending on the WebUser Preferences.<br> If the operation has been successful, the <code>messageCode</code> element with the <code>MessagesCopiedInfo</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the WebUser Preferences DeleteMethod option is set to <code>Move To Trash</code>, and the HTTP request contains the <code>Delete</code> parameter, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, the message set messages are copied to the Trash Mailbox and deleted. If the <code>Trash</code> Mailbox did not exist, it is created.</p><p>If the HTTP request contains the <code>DeleteAll</code> parameter, all Mailbox messages are deleted, using the method specified with the WebUser Preferences DeleteMethod option.</p><p>If the HTTP request contains the <code>read</code>, <code>unread</code>, <code>flag</code>, <code>unflag</code>, <code>delete</code>, or <code>undelete</code> parameters, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, and the flags for the message set messages are modified. The <code>delete</code> and <code>undelete</code> parameters are processed in this way only if the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>, and the HTTP request contains the <code>Purge</code> parameter, all Mailbox messages with the <code>Deleted</code> flag are deleted.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>NextMessage</code> parameter with a numeric value, the value is interpreted as the unique ID (UID) of a Mailbox message, and the component tries to find the next Mailbox message. If such a message is found, its UID is added to the Result Dataset as the <code>messageJump</code> element.</p><p>If the HTTP request contains the <code>PrevMessage</code> parameter with a numeric value, the value is interpreted as the UID of a Mailbox message, and the component tries to find the previous Mailbox message. If such a message is found, its UID is added to the Result Dataset as the <code>messageJump</code> element.</p><p>If the HTTP request contains the <code>NextUnread</code> parameter and the Mailbox contains an unread message, the UID of that unread message is added to the Result Dataset as the <code>messageJump</code> element.</p><p>If the messageJump element was not added to the Result Dataset, the code component uses the generic Mailbox component to process the HTTP request parameters and to compose the resulting dataset.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>mailbox</code></p><p>a string with the Mailbox name.</p></li><li><p><code>mailboxClass</code></p><p>if this string element exists, it contains the Mailbox class.</p></li><li><p><code>mailboxPage</code></p><p>this string element contains the name of the wssp page that should be used to display Mailboxes of this class.</p></li><li><p><code>isSentBox</code></p><p>this element exists and contains the YES string if the current Mailbox is the Mailbox selected to keep copies of sent messages.</p></li><li><p><code>isDraftsBox</code></p><p>this element exists and contains the YES string if the current Mailbox is the Mailbox selected to keep message drafts.</p></li></ul><p>If a next unread, next, or previous message is found:</p><ul><li><p><code>messageJump</code></p><p>a string with the found message UID.</p></li></ul><p>If a next unread, next, or previous message was not requested in the HTTP request parameters or it was not found:</p><ul><li><p><code>refreshTime</code></p><p>the Mailbox view refresh time (in seconds), retrieved from the WebUser Preferences.</p></li><li><p><code>listApproval</code></p><p>this string element exists if the Mailbox is the <em>approval</em> Mailbox for a mailing list. The element contains the E-mail address of that mailing list.</p></li></ul><p>The generic Mailbox code component is used to generate the rest of the resulting dataset.</p><p><strong>Name: <code>Contacts</code></strong></p><p>Processed in the same way as the Mailbox page.</p><p><strong>Name: <code>Notes</code></strong></p><p>Processed in the same way as the Mailbox page.</p><p><strong>Name: <code>Calendar</code></strong></p><p>The HTTP request must contain the <code>Mailbox</code> parameter - the name of a Calendar-type Mailbox to be displayed.</p><p><strong>Actions</strong></p><p>For each Mailbox, the module creates a session object that contains the Mailbox view parameters. When the object is created, these parameters are initiated with the WebUser Preferences values. The object also contains the month number for the &quot;monthly calendar&quot; view. It is initially set to the current month. The object contains the day number that specifies the first day to be displayed in the Calendar view. The object also contains the &quot;byDay&quot; flag that controls how the calendar data is stored in the dataset (by days or by time intervals).</p><p>The HTTP request <code>prevMonthlyCalendar</code> parameter can specify the number of months to be subtracted from the &quot;monthly calendar&quot; month number.</p><p>The HTTP request <code>nextMonthlyCalendar</code> parameter can specify the number of months to be added to the &quot;monthly calendar&quot; month number.</p><p>The HTTP request <code>JumpDay</code> parameter can specify the &quot;day number in the epoch&quot; that will become the first day to be displayed in the Calendar view.</p><p>The HTTP request <code>byDay</code> parameter can specify the new byDay flag value.</p><p>The HTTP request <code>Msg</code> parameters are interpreted as &quot;message set elements&quot;. A request can contain several parameters, and each parameter should have a numeric value - the Unique ID of a Mailbox message.</p><p>If the WebUser Preferences DeleteMethod option is set to <code>Move To Trash</code>, and the HTTP request contains the <code>Delete</code> parameter, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, the message set messages are copied to the Trash Mailbox and deleted. If the <code>Trash</code> Mailbox did not exist, it is created.</p><p>If the HTTP request contains the <code>read</code>, <code>unread</code>, <code>flag</code>, <code>unflag</code>, <code>delete</code>, or <code>undelete</code> parameters, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, and the flags for the message set messages are modified. The <code>delete</code> and <code>undelete</code> parameters are processed in this way only if the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>, and the HTTP request contains the <code>Purge</code> parameter, all Mailbox messages with the <code>Deleted</code> flag are deleted.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>mailbox</code></p><p>a string with the Mailbox name.</p></li><li><p><code>refreshTime</code></p><p>the Mailbox view refresh time (in seconds), retrieved from the WebUser Preferences.</p></li><li><p><code>weekDayNames</code></p><p>the array containing weekday name strings, starting with the day specified as the first weekday in the WebUser Preferences.</p></li><li><p><code>todayDay</code></p><p>the day of month for the current date.</p></li><li><p><code>todayMonth</code></p><p>the current month.</p></li><li><p><code>todayYear</code></p><p>the current year.</p></li><li><p><code>todayDayNum</code></p><p>the &quot;day number in the epoch&quot; for the current day.</p></li><li><p><code>monthlyCalendar</code></p><p>an array containing one element for each week of the months to be displayed in the &quot;monthly calendar&quot;. Each week element is an array with 7 elements. If the element does not correspond to a month day (i.e. the element corresponds to a day before the first day of month or after the last day of month), the element is an empty string. Otherwise the element is a dictionary containing the following subelements:</p><ul><li><p><code>day</code></p><p>a string with the day of the month corresponding to this element.</p></li><li><p><code>workDay</code></p><p>an optional YES string added if the day is a working day.</p></li><li><p><code>dayNum</code></p><p>the &quot;day number in the epoch&quot; for this day.</p></li></ul></li><li><p><code>year</code></p><p>the string with the number of the year the first displayed day belongs to.</p></li><li><p><code>byDay</code></p><p>the optional element containing the YES string. It is added if the byDay flag is set.</p></li><li><p><code>timeSlices</code></p><p>an array containing time slice starting times if the byDay flag is set. Each element is a dictionary containing the following values:</p><ul><li><p><code>hour</code></p><p>the hour number in the 24-hour system.</p></li><li><p><code>PMhour</code></p><p>the hour number in the 12-hour system if the hour value is 12 or more.</p></li><li><p><code>minute</code></p><p>the minute number. Always 2 digits.</p></li></ul></li><li><p><code>calendarDays</code></p><p>an array containing calendar view elements if the byDay flag is set. Each element is a dictionary presenting calendar data for one day. It contains the following elements:</p><ul><li><p><code>weekDay</code></p><p>the weekday name of this day</p></li><li><p><code>year</code></p><p>the number of the year this day belongs to</p></li><li><p><code>month</code></p><p>the name of month this day belongs to</p></li><li><p><code>day</code></p><p>the day number in the month</p></li><li><p><code>dayNum</code></p><p>the &quot;day number in the epoch&quot;</p></li><li><p><code>allDayEvents</code></p><p>an optional array containing descriptors for all-day events for this day. Each array element is a dictionary containing &quot;Event elements&quot; (see below)</p></li><li><p><code>events</code></p><p>an array containing descriptors this day events. Each descriptor corresponds to one time interval, it is a dictionary containing &quot;Event elements&quot; (if there is an Event in this time interval) and the following elements:</p><ul><li><p><code>nTimeSlices</code></p><p>the length of the descriptor time interval, in time slices.</p></li><li><p><code>conflicts</code></p><p>an optional array containing UIDs of other Events conflicting with the Event displayed in this time interval.</p></li><li><p><code>status</code></p><p>if the time interval does not contain an Event and it does not belong to a &quot;working time&quot; period, this element contains the <code>UNAVAILABLE</code> string.</p></li></ul></li></ul></li><li><p><code>calendarDays</code></p><p>an array containing calendar days if the byDay flag is not set. Each element is a dictionary containing the following values:</p><ul><li><p><code>weekDay</code></p><p>the weekday name of this day</p></li><li><p><code>year</code></p><p>the number of the year this day belongs to</p></li><li><p><code>month</code></p><p>the name of month this day belongs to</p></li><li><p><code>day</code></p><p>the day number in the month</p></li><li><p><code>dayNum</code></p><p>the &quot;day number in the epoch&quot;</p></li></ul></li><li><p><code>allDayEvents</code></p><p>an array containing information about All-Day Events if the byDay flag is not set. The array has one element for each displayed day. This element is an empty string if there is no All-Day Events in that day, or it is an array containing dictionary subelements for each All-Day Event taking place that day. Each dictionary subelement contains the &quot;Event elements&quot; for one All-Day Event.</p></li><li><p><code>calendarSlices</code></p><p>an array containing information for a time interval if the byDay flag is not set. Each array element is a dictionary containing the following elements:</p><ul><li><p><code>hour</code></p><p>the hour number in the 24-hour system.</p></li><li><p><code>PMhour</code></p><p>the hour number in the 12-hour system if the hour value is 12 or more.</p></li><li><p><code>minute</code></p><p>the minute number. Always 2 digits.</p></li><li><p><code>days</code></p><p>an array with the calendar data for this time interval in each day. Each element is a dictionary with the day data containing the &quot;Event elements&quot; if this time interval contains an Event in that day, and also the following elements:</p><ul><li><p><code>nTimeSlices</code></p><p>the length of the descriptor time interval, in time slices.</p></li><li><p><code>conflicts</code></p><p>an optional array containing UIDs of other Events conflicting with the Event displayed in this time interval.</p></li><li><p><code>status</code></p><p>if the time interval does not contain an Event and it does not belong to a &quot;working time&quot; period, this element contains the <code>UNAVAILABLE</code> string.</p></li></ul></li></ul></li></ul><p>The &quot;Event elements&quot; are:</p><ul><li><p><code>summary</code></p><p>the string with Event Summary text.</p></li><li><p><code>ID</code></p><p>a numeric string with the UID of the Event message in the Mailbox.</p></li><li><p><code>status</code></p><p>a string with the Event busy status.</p></li><li><p><code>priority</code></p><p>a numeric with the Event priority value. This element exists only if the Event priority is not zero.</p></li></ul><p><strong>Name: <code>Tasks</code></strong></p><p>The HTTP request must contain the <code>Mailbox</code> parameter - the name of a Tasks-type Mailbox to be displayed.</p><p><strong>Actions</strong></p><p>For each Mailbox, the module creates a session object that contains the Mailbox view parameters. When the object is created, these parameters are initiated with the WebUser Preferences values. The object contains the day number that specifies the first day to be displayed in the Tasks view.</p><p>The HTTP request <code>JumpDay</code> parameter can specify the &quot;day number in the epoch&quot; that will become the first day to be displayed in the Tasks view.</p><p>The HTTP request <code>Msg</code> parameters are interpreted as &quot;message set elements&quot;. A request can contain several parameters, and each parameter should have a numeric value - the Unique ID of a Mailbox message.</p><p>If the WebUser Preferences DeleteMethod option is set to <code>Move To Trash</code>, and the HTTP request contains the <code>Delete</code> parameter, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, the message set messages are copied to the Trash Mailbox and deleted. If the <code>Trash</code> Mailbox did not exist, it is created.</p><p>If the HTTP request contains the <code>read</code>, <code>unread</code>, <code>flag</code>, <code>unflag</code>, <code>delete</code>, or <code>undelete</code> parameters, a &quot;message set&quot; is composed using the <code>Msg</code> parameters, and the flags for the message set messages are modified. The <code>delete</code> and <code>undelete</code> parameters are processed in this way only if the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the WebUser Preferences DeleteMethod option is not set to <code>Move To Trash</code>, and the HTTP request contains the <code>Purge</code> parameter, all Mailbox messages with the <code>Deleted</code> flag are deleted.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>The HTTP request <code>showCompleted</code> parameter can specify the new showCompleted flag value.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>mailbox</code></p><p>a string with the Mailbox name.</p></li><li><p><code>refreshTime</code></p><p>the Mailbox view refresh time (in seconds), retrieved from the WebUser Preferences.</p></li><li><p><code>showCompleted</code></p><p>the optional element containing the YES string. It is added if the showCompleted flag is set.</p></li><li><p><code>numTotal</code></p><p>the total number of calendaring items in the Mailbox.</p></li><li><p><code>numSelected</code></p><p>the total number of selected Task items.</p></li><li><p><code>tasks</code></p><p>an array with selected tasks. Each element is a dictionary describing a task. It contains the following elements:</p><ul><li><p><code>nBefore</code></p><p>this number string exists if the Task starts after the initial time displayed in the Tasks view. It shows how many Task view time periods should be skipped before the Task starts.</p></li><li><p><code>nDuration</code></p><p>this number string specifies the time interval (in time periods) between either the Task start time or the Task view first display time (whatever is later) and the Task Due time or the Task view last display time (whatever is earlier).</p></li><li><p><code>nAfter</code></p><p>this numeric string exists if the Task ends before the Task view end time. It shows how many Task view time periods should be skipped after the Task ends.</p></li><li><p><code>ID</code></p><p>a string with the UID of the Task message in the Mailbox.</p></li><li><p><code>percentComplete</code></p><p>a numeric string with the Percent-Complete value of the Task object.</p></li><li><p><code>summary</code></p><p>a string with the Task summary</p></li><li><p><code>priority</code></p><p>a numeric string with the Task priority if it was set (is not zero).</p></li></ul></li></ul><p><strong>Name: <code>Message</code></strong></p><p>The HTTP request must contain the <code>Mailbox</code> parameter (the name of the Mailbox containing the messages to be displayed), and the <code>MSG</code> parameter - the Unique ID of that message in the Mailbox.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>Copy</code> or <code>Move</code> parameter and the <code>MailboxName</code> parameter contains a name of some selectable Mailbox, the message is copied to the specified Mailbox. If the <code>Move</code> parameter was specified, the message is marked as Deleted, or it is deleted - depending on the WebUser Preferences.<br> If the operation has been successful, the <code>messageCode</code> element with the <code>MessageCopied</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.<br> If the Move operation has removed the message, the <code>backToMailbox</code> element with the <code>Yes</code> value is added to the result dataset, and the code component stops request processing.</p><p>If the HTTP request contains the <code>Redirect</code> parameter and the <code>RedirectAddresses</code> parameter is not empty,the message is redirected to the specified addresses.<br> If the HTTP request contains the <code>ListApprove</code> parameter and the message Mailbox is an &quot;approval&quot; Mailbox for some mailing list, the request is processed as the <code>Redirect</code> request with the effective address being the mailing list address.<br> If the operation has been successful, the <code>messageCode</code> element with the <code>MessageRedirected</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>TakeAddress</code> parameter the message <code>From:</code> address is added to the Account address book.</p><p>If the HTTP request contains the <code>TakeCertificate</code> parameter the certificate from the message digital signature is added to the Account address book.</p><p>If the HTTP request contains the <code>StoreFiles</code> parameter and the <code>selectedWebFolder</code> parameter contains a name of the File Storage folder, the file parts of the message (attachments, images) are stored in the specified folder.<br> If the operation has been successful, the <code>messageCode</code> element with the <code>FilesCopied</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>read</code>, <code>unread</code>, <code>flag</code>, <code>unflag</code>, <code>delete</code>, or <code>undelete</code> parameters, the message flags are modified.<br> If the operation has not been successful, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>Then the code component use the generic Message component to process the HTTP request parameters and the compose the resulting dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>mailbox</code></p><p>A string with the Mailbox name.</p></li></ul><p>If the message has not been removed:</p><ul><li><p><code>MSG</code></p><p>A string with the message UID.</p></li><li><p><code>flagged</code>, <code>recent</code>, <code>deleted</code>, <code>flagged</code>, <code>media</code>, <code>isDraft</code></p><p>These elements with the <code>Yes</code> value are added if the message has the corresponding flags.</p></li><li><p><code>status</code></p><p>This string element has the following values:</p><ul><li><code>Deleted</code> - if the message has the Deleted flag set, otherwise</li><li><code>Draft</code> - if the message has the Draft flag set, otherwise</li><li><code>Redirected</code> - if the message has the Redirected flag set, otherwise</li><li><code>Unread</code> - if the message does not have the Seen flag set, otherwise</li><li><code>Answered</code> - if the message has the Answered flag set, otherwise</li><li><code>Read</code></li></ul></li><li><p><code>messageBody</code></p><p>A string with HTML presentation of the message, generated using the generic Message code component.</p></li><li><p><code>charset</code></p><p>The charset to use for message display. This element can be set with the generic Message code component.</p></li><li><p><code>nextMsg</code></p><p>this element is added if there is a next message in the Mailbox view. The element value is a string with the next message UID.</p></li><li><p><code>prevMsg</code></p><p>this element is added if there is a previous message in the Mailbox view. The element value is a string with the previous message UID.</p></li><li><p><code>hasFiles</code></p><p>this <code>YES</code> string element is added if there is the message contains a file part.</p></li><li><p><code>editableContact</code></p><p>this <code>YES</code> string element is added if the message is a VCard object that can be updated.</p></li><li><p><code>editableGroup</code></p><p>this <code>YES</code> string element is added if the message is a Group object that can be updated.</p></li><li><p><code>editableNote</code></p><p>this <code>YES</code> string element is added if the message is a Note object that can be updated.</p></li><li><p><code>editableEvent</code></p><p>this <code>YES</code> string element is added if the message is an Event &quot;published&quot; by this user and it that can be updated.</p></li><li><p><code>editableTask</code></p><p>this <code>YES</code> string element is added if the message is a Task &quot;published&quot; by this user and it that can be updated.</p></li><li><p><code>canCancelEvent</code></p><p>this <code>YES</code> string element is added if the message is an Event this user can cancel.</p></li><li><p><code>canCancelTask</code></p><p>this <code>YES</code> string element is added if the message is a Task this user can cancel.</p></li><li><p><code>canAcceptDecline</code></p><p>this <code>YES</code> string element is added if the message is a Task or Event request.</p></li><li><p><code>percentComplete</code></p><p>this element containing a number is added if the message is an Task delegated to this user by someone else.</p></li><li><p><code>statusCode</code></p><p>this optional string element contains the status of the message if the message is a Task or an Event.</p></li><li><p><code>conflictingID</code></p><p>this optional string element contains the UID of the Default Calendar Mailbox message that conflicts with the displayed Event Request.</p></li><li><p><code>canUpdatePartStatus</code></p><p>this <code>YES</code> string element is added if the message is a reply to the user&#39;s Task or Event request.</p></li><li><p><code>canCancelEvent</code></p><p>this <code>YES</code> string element is added if the message is a cancel request from an Event organizer.</p></li><li><p><code>canCancelTask</code></p><p>this <code>YES</code> string element is added if the message is a cancel request from a Task organizer.</p></li><li><p><code>listApproval</code></p><p>this string element exists if the message Mailbox is the <em>approval</em> Mailbox for a mailing list. The element contains the E-mail address of that mailing list.</p></li></ul></li></ul><p><strong>Name: <code>Compose</code></strong></p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>charset</code> parameter, the parameter value is used as the <em>desired</em> charset - the charset to be used in the composed message.</p><p>The optional <code>Operation</code> HTTP request parameter specifies the type of the Compose operation and it can have the <code>Reply</code>, <code>ReplyAll</code>, <code>Forward</code>, or <code>EditDraft</code> value.<br> If this parameter is specified, the <code>OrigMessage</code> parameter (with the UID of the original message) and the <code>OrigMailbox</code> parameter (with the name of the Mailbox containing the original message) must be specified.</p><p>If the HTTP request contains the Operation parameter and it does not contain the <code>filled</code> parameter, the original message header fields are used to compose the Subject, To, Cc, and the message body data for the new message.<br> Otherwise, the <code>Subject</code>, <code>To</code>, <code>Cc</code>, <code>Bcc</code>, and <code>Body</code> HTTP request parameters are used as the new message data.</p><p>If the HTTP request contains the <code>AddressBook</code> parameter and it does not contain the <code>CloseBook</code> parameter, or if HTTP request contains the <code>OpenBook</code> parameter the generic AddressBook code component is used to process the request parameters and to form some result dataset elements.</p><p>If the HTTP request contains the <code>isEvent</code> parameter, the Calendar Event item is being composed. If the HTTP request contains the <code>isTask</code> parameter, the Calendar Task (ToDo) item is being composed. If the HTTP request contains the <code>isNote</code> parameter, the Note item is being composed.</p><p>If the HTTP request contains the <code>Send</code> parameter, the composed message is submitted to the Server Queue. If the HTTP request contains the <code>Save</code> parameter, the composed message is stored as a Draft in the selected Drafts Mailbox.<br> In both cases all HTTP request <code>Attachment</code> parameters are added to the message as attachments.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>operation</code></p><p>This string element is added to the result dataset if the HTTP request contains the <code>Operation</code> parameter. The element value equals the request parameter value.</p></li><li><p><code>origMessage</code></p><p>This element containing the UID of the original message is added to the result dataset if the HTTP request contains the <code>OrigMessage</code> parameter.</p></li><li><p><code>origMailbox</code></p><p>This element with the name of the Mailbox containing the original message is added to the result dataset if the HTTP request contains the <code>OrigMailbox</code> parameter.</p></li><li><p><code>sentOrSaved</code></p><p>This element with <code>Yes</code> value is added to the result dataset if the Send or SaveDraft operation has completed successfully. If this element is added:</p><ul><li>The <code>sent</code> element with the <code>Yes</code> value is added if the operation was the Send operation.</li><li>The <code>messageCode</code> element with the <code>MessageSent</code> or <code>MessageSaved</code> value is added to dataset.</li><li>No other element listed below is added to the result dataset.</li></ul></li><li><p><code>Subject</code>, <code>To</code>, <code>Cc</code>, <code>Bcc</code></p><p>These elements contain strings with the current header fields data.</p></li><li><p><code>From</code></p><p>This element contains a string with the <code>From</code> address specified in the WebUser Preferences.</p></li><li><p><code>addressBook</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the HTTP request contains the <code>AddressBook</code> parameter and does not contain the <code>CloseBook</code> parameter or if the HTTP request contains the <code>OpenBook</code> parameter.</p></li><li><p><code>body</code></p><p>This string element contains the current message body text.</p></li><li><p><code>mailerWidth</code></p><p>This string element contains the <code>MailerWidth</code> WebUser Preferences option value.</p></li><li><p><code>forwardedMessage</code></p><p>This optional string element contains the HTML representation of the original message. This element is added to the result dataset if the HTTP request <code>Operation</code> parameter is <code>Forward</code>.</p></li><li><p><code>DSN</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the HTTP request contains the <code>DSN</code> parameter.</p></li><li><p><code>SaveSent</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the WebUser Preferences contain a non-empty <code>SentBox</code> option and the HTTP does not contain the <code>Filled</code> parameter or the HTTP request contains the <code>SaveSent</code> parameter.</p></li><li><p><code>desiredCharset</code></p><p>This string element contains the name of charset to be used in the composed message.</p></li><li><p><code>charset</code></p><p>This element is the <code>UTF-8</code> string if the <code>Use UTF8</code> WebUser Preferences option is set to &quot;for Reading and Composing&quot;. Otherwise, this element contains the same value as the <code>desiredCharset</code> result dataset element.</p></li><li><p><code>isEvent</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the item being composed is a Calendar Event item.</p></li><li><p><code>isTask</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the item being composed is a Calendar Task (ToDo) item.</p></li><li><p><code>isNote</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the item being composed is a Note item.</p></li></ul><p>The following elements are added if the item being composed is a Calendar item:</p><ul><li><p><code>allDayEvent</code></p><p>This element with the <code>Yes</code> value is added to the result dataset if the item is an All-Day Event. The element value is controlled with the HTTP parameter of the same name.</p></li></ul></li></ul><p><strong>Name: <code>MailboxSettings</code></strong></p><p>The HTTP request must contain the <code>Mailbox</code> parameter - the name of the Mailbox to manage.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>Remove</code> parameter, the Mailbox is removed. If the HTTP request also contains the <code>RemoveSub</code> parameter, all Mailbox submailboxes are removed, too.<br> If the operation has been successful and the Show Subscribed Mailboxes option is selected in the WebUser Preferences, the deleted Mailbox(es) are removed from the Account subscription list.<br> If the operation has been successful, the <code>removed</code> element with the <code>Yes</code> string value is added to the result data set and the code component stops request processing. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>Rename</code> parameter and the <code>NewName</code> parameters is not empty, the Mailbox is renamed. The NewName parameter value is converted into the &quot;UTF-7 Mailbox Name encoding&quot; format and is used as the new Mailbox name.<br> If the HTTP request also contains the <code>RenameSub</code> parameter, all Mailbox submailboxes are renamed, too.<br> If the operation has been successful and the Show Subscribed Mailboxes option is selected in the WebUser Preferences, the renamed Mailbox(es) are renamed in the Account subscription list.<br> If the operation has been successful, the <code>removed</code> element with the <code>Yes</code> string value is added to the result data set and the code component stops request processing. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>Update</code> parameter, the code component retrieves all <code>Acc</code> parameters from the request. Each <code>Acc</code> parameter should have a numeric value. For each retrieved <code>Acc</code> parameter value <em>nnn</em>, the <code>Znnn</code> parameter is retrieved. If it contains a non-empty string, all <code>Knnn</code> request parameters are retrieved, where <em>K</em> is a <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox access right</a> letter.<br> The list of <code>Znnn</code> name strings with their <code>Knnn</code> parameter sets are used to form and set the new ACL list for the selected Mailbox.<br> If the ACL update operation has been successful, the <code>messageCode</code> element with the <code>Updated</code> string value is added to the result dataset. Otherwise, the <code>errorCode</code> element with the operation error code string value is added to the result dataset.</p><p>If the HTTP request contains the <code>DeleteAll</code> parameter, all Mailbox messages are deleted, using the method specified with the WebUser Preferences DeleteMethod option. If the operation has been successful, the <code>messageCode</code> element with the <code>MessagesDeleted</code> string value is added to the result dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>renamed</code></p><p>This element with the <code>Yes</code> string value is added to the dataset if the Mailbox has been renamed. In this case no other element is added to the result dataset.</p></li><li><p><code>removed</code></p><p>This element with the <code>Yes</code> string value is added to the dataset if the Mailbox has been removed. In this case no other element is added to the result dataset.</p></li><li><p><code>rights</code></p><p>This array element contains the Mailbox ACL (Access Control List) elements. Each array element is a dictionary with the following elements:</p><ul><li><p><code>ident</code></p><p>this string element contains the ACL element <em>name</em>.</p></li><li><p><code>index</code></p><p>this string element contains the element number in the ACL set.</p></li><li><p><code>lookup</code>, <code>select</code>, <code>seen</code>, <code>flags</code>, <code>insert</code>, <code>post</code>, <code>create</code>, <code>delete</code>, <code>admin</code></p><p>these elements with <code>Yes</code> string values are added when the ACL element includes these Mailbox access rights.</p></li></ul></li></ul></li></ul><p><strong>Name: <code>Alerts</code></strong></p><p>This code component can be called implicitly, if the Web Application module has detected a pending <a href="./../admin/sysadmin/Alerts.html">Alert</a> message.</p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>AlertTime</code> parameter, that parameter should contain a time stamp in the ACAP format. The code component confirms all Alerts older than the specified time.</p><p>If the HTTP request contains the <code>returnURL</code> parameter, the parameter value is added to the result dataset (as the <code>returnURL</code> element).</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>alerts</code></p><p>This element is added to the result dataset if there are pending Alerts for the session user. The element value is an array of dictionary elements, each element describing one alert message. Each dictionary contains the following elements:</p><ul><li><p><code>time</code></p><p>A string element containing the time when the alert was posted.</p></li><li><p><code>text</code></p><p>A string element containing the alert message text.</p></li></ul></li><li><p><code>currentTime</code></p><p>This element is added to the result dataset if there are pending Alerts for the session user. Its string value contains the current time in the ACAP format.</p></li><li><p><code>returnURL</code></p><p>If the Alerts page was retrieved automatically, when some other page had to be displayed, the encoded URL for that other page is placed into this string element.</p></li></ul></li></ul><p><strong>Name: <code>Subscription</code></strong></p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>Open</code> parameter, the <code>MailboxName</code> parameter value is converted into the &quot;UTF-7 Mailbox Name encoding&quot; format, the converted string is added to the result dataset as the <code>jump</code> element, and the request processing ends.</p><p>If the HTTP request contains the <code>Update</code> parameter:</p><ul><li>All <code>Elem</code> request parameters are retrieved, converted into the &quot;UTF-7 Mailbox Name encoding&quot; format, and form the new Account Subscription list.</li><li>All <code>AliasName</code> request are retrieved, they should contain numeric values. For each retrieved numeric value <em>nnn</em>, the parameters pairs <code>annn</code> and <code>mnnn</code> are retrieved. If both parameters exist and contain non-empty strings, the strings are converted into the &quot;UTF-7 Mailbox Name encoding&quot; format, and are used to form the new set of Account Mailbox Aliases.</li><li>If the Subscription or Mailbox Aliases update operation fails, the <code>errorCode</code> element is added to the result dataset. Otherwise the <code>messageCode</code> element with the <code>Updated</code> string value is added to the result dataset.</li></ul></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>jump</code></p><p>The name of the Mailbox to open (&quot;to jump to&quot;). If this element exists, none of the following elements is added to the result dataset.</p></li><li><p><code>subscription</code></p><p>This array element contains the Account subscription list. Each array element is a string with some Mailbox name.</p></li><li><p><code>aliases</code></p><p>This array element contains the Account Mailbox Aliases list. Each array element is a dictionary with the following elements:</p><ul><li><p><code>index</code></p><p>A string with this Mailbox Alias element index.</p></li><li><p><code>name</code></p><p>A string with the Mailbox Alias name.</p></li><li><p><code>ref</code></p><p>A string with the name of the Mailbox this Alias points to.</p></li></ul></li></ul></li></ul><p><strong>Name: <code>Password</code></strong></p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>ModifyPassword</code> parameter, the request should also contain the <code>OldPassword</code> parameter, and that parameter should match the current Account password. If the <code>OldPassword</code> parameter value is correct:</p><ul><li>The <code>RecoverPassword</code> request parameter value is set as the new <code>RecoverPassword</code> Account setting. The <code>messageCode</code> element with the <code>Updated</code> string value is added to the result dataset.</li><li>If the Account user is allowed to modify the Account password, the <code>NewPassword1</code> and <code>NewPassword2</code> parameters are checked. If they are non-empty and match each other, then the Account password is updated using these parameters value.</li></ul><p>If the password has been updated successfully, the <code>messageCode</code> element with the <code>PasswordChanged</code> string value is added to the result dataset. If the password update operation failed, the <code>errorCode</code> element is added to the result dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>RecoverPassword</code></p><p>This string element contains the Account <code>RecoverPassword</code> setting value.</p></li></ul></li></ul><p><strong>Name: <code>PublicInfo</code></strong></p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains the <code>Update</code> parameter, the request should also contain zero, one, or several <code>ID</code> parameters, each with a numeric value. For each ID parameter, its numeric value <em>nnn</em> is used to retrieve the pair of <code>Nnnn</code> and <code>Vnnn</code> string parameters. The value of the <code>Nnnn</code> parameter specifies the name of the Account Public Info setting, the value of the <code>Vnnn</code> parameter specifies the setting value. These pairs are used to set the new Account Public Info settings. If an empty string is specified as a setting value, the setting is removed from the Account Settings.</p><p>If the Public Info settings have been updated successfully, the <code>messageCode</code> element with the <code>Updated</code> string value is added to the result dataset. If the password update operation failed, the <code>errorCode</code> element is added to the result dataset.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>publicInfo</code></p><p>This array element contains a set Public Info elements. It contains one element for each Public Info Setting specified with the <a href="./../admin/directory/CentralDir.html">Directory Integration</a> settings. Each array element is a dictionary with the following elements:</p><ul><li><p><code>id</code></p><p>this string element contains the element number in the set.</p></li><li><p><code>name</code></p><p>this string element contains the Public Info setting name.</p></li><li><p><code>value</code></p><p>this string element contains the current Public Info setting value. This element exists only if the Account contains this Public Info setting.</p></li></ul></li></ul></li></ul><p><strong>Name: <code>WebSite</code></strong></p><p>The code component uses the generic WebSite component to process the HTTP parameters and to form the result dataset. Before the generic component is called, the following elements are added to the result dataset:</p><ul><li><p><strong>Result Dataset</strong></p><ul><li><p><code>fileRef</code></p><p>The <code>WebFile/</code> string.</p></li><li><p><code>pageRef</code></p><p>The <code>website.wssp</code> string.</p></li></ul></li></ul><p><strong>Name: <code>Bye</code></strong></p><ul><li><p><strong>Actions</strong></p><p>The code component can delete old messages from the Trash (as specified in the WebUser preferences and if string parameter <code>noEmpty</code> was not set) and closes the session. The session will be destroyed as soon as this HTTP request is processed, so the <code>bye.wssp</code> code can use session data, but the produced HTML code should not contain references to session objects.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>blockAlerts</code></p><p>This element has the <code>Yes</code> string value. It is added to the result dataset to prevent Alert processing.</p></li></ul></li></ul><h2 id="Generic" tabindex="-1">Generic Code Components <a class="header-anchor" href="#Generic" aria-label="Permalink to &quot;Generic Code Components {#Generic}&quot;">​</a></h2><p>The Web Application module has several generic components used to process both stateless and session requests.</p><p><strong>Generic <code>Mailbox</code> component</strong></p><ul><li><p><strong>Actions</strong></p><p>If the HTTP request contains <code>Filter</code>, <code>Search</code>, <code>Limit</code> parameters, these parameter values are used to modify the Mailbox &quot;viewer&quot; current <em>Filter</em>, <em>Search</em>, <em>Limit</em> values.</p><p>If the HTTP request parameter <code>Skip</code> exists, it should have a numeric value. This number is used to set the current <em>first message index</em> - the number of the first message to be displayed on this page.</p><p>If the HTTP request contains the parameter <code>Next</code>, then the current <em>first message index</em> is increased by the current <em>Limit</em> value.</p><p>If the HTTP request contains the parameter <code>Prev</code>, then the current <em>first message index</em> is decreased by the current <em>Limit</em> value.</p><p>If the HTTP request contains the parameter <code>Sort</code>, its numeric value specifies the number of &quot;sorting&quot; column (to sort the Mailbox view by the first column, the <code>Sort</code> parameter should be 0).</p><p>If the HTTP request contains the parameter <code>SDir</code>, its numeric value specifies the sorting order: the value 1 requests ascending order, the value 0 - descending order, the value -1 reverses the current sorting order.</p></li><li><p><strong>Result Dataset</strong></p><ul><li><p><code>checkAll</code></p><p>This element has the <code>CHECKED</code> string value. It is added to the result dataset if the HTTP request contains the <code>MarkAll</code> parameters.</p></li><li><p><code>filter</code></p><p>The string value of this element is the current <em>Filter</em> string.</p></li><li><p><code>search</code></p><p>The string value of this element is the current <em>Search</em> string.</p></li><li><p><code>limit</code></p><p>The string value of this element is the current <em>Limit</em> value (a number).</p></li><li><p><code>sentBox</code></p><p>This element has the <code>YES</code> string value and exists only if this Mailbox is a <code>Sent</code>-type Mailbox.</p></li><li><p><code>headers</code></p><p>The array value of this element contains Mailbox view column headers. Each array element is a dictionary with the following elements:</p><ul><li><p><code>index</code></p><p>This string element contains the column number.</p></li><li><p><code>name</code></p><p>This string element contains the column name.</p></li><li><p><code>hilited</code></p><p>This element has the <code>YES</code> string value and exists only if this column is the sorting column.</p></li><li><p><code>sdir</code></p><p>If this column is not the sorting column, this element contains the current sorting order (<code>0</code> or <code>1</code>). If this column is the sorting column, this element contains the reversed current sorting order (<code>1 - current sorting order</code>).</p></li><li><p><code>ralign</code></p><p>This element has the <code>YES</code> string value and exists only if this is a date- or size-type column and thus needs the reversed horizontal alignment.</p></li></ul></li><li><p><code>messages</code></p><p>The array value of this element contains the Mailbox view data. Each array element is a dictionary with message data, and it contains the following elements:</p><ul><li><p><code>id</code></p><p>this element contains the message Unique ID (UID)</p></li><li><p><code>color</code></p><p>if the message has the <code>X-Color</code> header field with a valid HTML &quot;color&quot; string as its value, this element exists and contains the value of that header field.</p></li><li><p><code>notText</code></p><p>this optional element has the <code>YES</code> string value; it exists if the message Content-Type is not <code>text</code>.</p></li><li><p><code>notAltText</code></p><p>this optional element has the <code>YES</code> string value; it exists if the message Content-Type is not <code>text</code> and the message Content-Type/Subtype is not <code>multipart/alternative</code>.</p></li><li><p><code>fields</code></p><p>this array element contains message column data. The columns are stored in the same order as columns in the <code>headers</code> result dataset element. Each element is a dictionary. It contains the following elements:</p><ul><li><p><code>hilited</code></p><p>This element has the <code>YES</code> string value and exists only if this column is the sorting column.</p></li><li><p><code>sdir</code></p><p>If this column is not the sorting column, this element contains the current sorting order (<code>0</code> or <code>1</code>) If this column is the sorting column, this element contains the reversed current sorting order (<code>1 - current sorting order</code>).</p></li><li><p><code>ralign</code></p><p>This element has the <code>YES</code> string value and exists only if this is a date- or size-type column and thus needs the reversed horizontal alignment.</p></li><li><p><code>isRef</code></p><p>This element exists for the selected column and for the first &quot;clickable&quot; column. If it exists, it contains the string <code>YES</code>.</p></li><li><p><code>value</code></p><p>This element contains the column data. It exists for all columns except for the Status column. For the Sent and Received columns the element contains the &quot;date&quot; value - values of that type can be displayed using the <code>DATE:</code>, <code>DATETIMESHORT</code> and similar prefixes.</p></li><li><p><code>isStatus</code></p><p>This <code>YES</code> string element exists if the column is the Status column.</p></li><li><p><code>isDate</code></p><p>This This <code>YES</code> string element element exists if the column is the Sent or Recieved column and the <code>value</code> element contains the &quot;date&quot;-type value.</p></li><li><p><code>isPty</code></p><p>This <code>YES</code> string element exists if the column is the Priority column.</p></li><li><p><code>status</code></p><p>This element exists if the column is the Status column. If it exists, it contains the one of the following strings:</p><ul><li>If the message has the Deleted flag - <code>Deleted</code>, otherwise</li><li>If the message has the Draft flag - <code>Draft</code>, otherwise</li><li>If the message has the Redirected flag - <code>Redirected</code>, otherwise</li><li>If the message does not have the Seen flag - <code>Unread</code>, otherwise</li><li>If the message has the Answered flag - <code>Answered</code>, otherwise</li><li><code>Read</code></li></ul></li><li><p><code>flagged</code></p><p>This element exists if the column is the Status column and the message has the Flagged flag. If it exists, it contains the string <code>YES</code>.</p></li><li><p><code>recent</code></p><p>This element exists if the column is the Status column and the message has the Recent flag. If it exists, it contains the string <code>YES</code>.</p></li><li><p><code>hidden</code></p><p>This element exists if the column is the Status column and the message has the Hidden flag. If it exists, it contains the string <code>YES</code>.</p></li><li><p><code>media</code></p><p>This element exists if the column is the Status column and the message has the Media flag. If it exists, it contains the string <code>YES</code>.</p></li></ul></li></ul></li><li><p><code>firstNumber</code></p><p>This string element contains the number of the first message in the view.</p></li><li><p><code>firstNumber1</code></p><p>This string element contains the number of the first message in the view increased by 1.</p></li><li><p><code>lastNumber</code></p><p>This string element contains the number of the first message in the view increased by the number of the <code>messages</code> array elements if this array is not empty, or increased by 1 if the <code>messages</code> array is empty.</p></li><li><p><code>numTotal</code></p><p>The total number of messages in this Mailbox.</p></li><li><p><code>numUnread</code></p><p>The total number of unread messages (messages without the Seen flag) in this Mailbox.</p></li><li><p><code>numSelected</code></p><p>The total number of Mailbox messages that can be displayed with the current Filter and Search values.</p></li><li><p><code>multiPage</code></p><p>This element with the <code>YES</code> string value is added if the <code>nSelected</code> value is not equal to the number of the <code>messages</code> array elements.</p></li><li><p><code>sortColumn</code></p><p>This element contains the number of the currently selected sorting column.</p></li><li><p><code>sortAscending</code></p><p>This element contains <code>1</code> is the currently selected sorting order is ascending, and <code>0</code> if it is descending.</p></li></ul></li></ul><p><strong>Generic <code>Message</code> component</strong></p><p>The generic Message component is used to convert the an RFC822 message into an HTML text. It processes simple and multi-part messages, attachments, digests, inline images and other letter components. To build a HTML presentation, the component uses <a href="#Message">Code Components for Message Rendering</a>.</p><h2 id="Message" tabindex="-1">Code Components for Message Rendering <a class="header-anchor" href="#Message" aria-label="Permalink to &quot;Code Components for Message Rendering {#Message}&quot;">​</a></h2><p>The Web Application module can render messages, converting them into a markup (HTML) text. This process is controlled by the Application module itself. It detects the MIME structure of the message, and processes each part recursively. For each part, a dataset is produced and a .wssp file is used to produce a markup language presentation.</p><p>Message Rendering code components do not perform any actions.</p><p>A Result Dataset produced by every Message Rendering code component includes the following fields:</p><ul><li><p><code>MIMEPart</code></p><p>this string element contains a URL reference for the message or the message part that is being rendered.</p></li><li><p><code>filesRef</code></p><p>this string element contains the URL prefix needed to retrieve files from the proper Skin. When a message is being rendered withing some WebUser Session, this string is the same as the <code>SESSION(filesRef)</code> string.</p></li><li><p><code>printVersion</code></p><p>this string element exists and contains the <code>YES</code> string if the message should be displayed in a printable form.</p></li></ul><p>The following Message Rendering code components are implemented:</p><p><strong>Name: <code>RFC822Message</code></strong></p><p>This code component is used to render a mail message - a message stored in a Mailbox or a <code>message/rfc822</code> MIME subpart of some other message.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>RFC822Header</code></p><p>this string element contains the rendered markup presentation of the message RFC822 header.</p></li><li><p><code>RFC822Body</code></p><p>this string element contains the rendered markup presentation of the message RFC822/MIME body.</p></li><li><p><code>isSubPart</code></p><p>this optional element exists and has the YES string value if the message is a MIME subpart of some other message.</p></li></ul><p><strong>Name: <code>RFC822Header</code></strong></p><p>This code component is used to render an RFC822 mail message header.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>RFC822Fields</code></p><p>this element is an array with one dictionary-type element for each &quot;visible&quot; field in the header. Each dictionary contains the following elements:</p><ul><li><p><code>name</code></p><p>this string element contains the header field name.</p></li><li><p><code>value</code></p><p>this string element contains the MIME-decoded field value.</p></li></ul></li></ul><p><strong>Name: <code>AttachmentPart</code>, <code>ImagePart</code></strong></p><p>This code component is used to render an image or an attachment. Images and attachments can be separate MIME parts, or can be embedded into text parts using UUENCODE encoding.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>attachmentName</code></p><p>this string contains the file name as it is stored in the message data.</p></li><li><p><code>fileName</code></p><p>this string contains the &quot;cleaned&quot; file name (with all path components removed and image file name suffix added if necessary).</p></li><li><p><code>embeddedPart</code></p><p>if this string parameter exists, the file is an &quot;embedded&quot; UUENCODE data, and the string specifies the embedded component number inside the MIME part.</p></li><li><p><code>decodedSize</code></p><p>this string element contains the approximate size of the decoded file data.</p></li></ul><p><strong>Name: <code>DeliveryReportPart</code></strong></p><p>This code component is used to render a <code>message/report</code> MIME subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>MessageFields</code></p><p>this array element contains one dictionary element for each message-level report field. Each dictionary element contains the following elements:</p><ul><li><p><code>name</code></p><p>this string element contains the report field name.</p></li><li><p><code>value</code></p><p>this string element contains the MIME-decoded report field value.</p></li></ul></li><li><p><code>Reports</code></p><p>this array element contains one array element for each recipient report. Each recipient report is an array containing one dictionary element for each recipient-level report field. Each dictionary element contains the following elements:</p><ul><li><p><code>name</code></p><p>this string element contains the report field name.</p></li><li><p><code>value</code></p><p>this string element contains the MIME-decoded report field value.</p></li></ul></li></ul><p><strong>Name: <code>DispositionReportPart</code></strong></p><p>This code component is used to render a <code>message/disposition-notification</code> MIME subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>fields</code></p><p>this array element contains one dictionary element for each message-level report field. Each dictionary element contains the following elements:</p><ul><li><p><code>name</code></p><p>this string element contains the report field name.</p></li><li><p><code>value</code></p><p>this string element contains the MIME-decoded report field value.</p></li></ul></li></ul><p><strong>Name: <code>EncryptedPart</code></strong></p><p>This code component is used to render an encrypted MIME subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>decryptedPart</code></p><p>this array element contains the rendered markup presentation of the decrypted content. The element exists only if decryption was successful.</p></li><li><p><code>decryptionErrorCode</code></p><p>if this string element exists, it contains the error message explaining why content decryption has failed.</p></li><li><p><code>cipherName</code></p><p>This string element contains the name of the cipher used for content encryption.</p></li><li><p><code>keyLength</code></p><p>This string element contains the size of the encryption cipher key (in bits).</p></li></ul><p><strong>Name: <code>SignedPart</code></strong></p><p>This code component is used to render a signed MIME subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>signedPart</code></p><p>this array element contains the rendered markup presentation of the signed content. The element exists only if decoding was successful (for binary-type signed messages).</p></li><li><p><code>encoding</code></p><p>this string element contains words &quot;Binary&quot; or &quot;Text&quot; depending on the format of the signed subpart.</p></li><li><p><code>decryptionErrorCode</code></p><p>if this string element exists, it contains the error message explaining why binary content decoding has failed.</p></li><li><p><code>digesterName</code></p><p>This string element contains the name of the digester used for digital signing.</p></li><li><p><code>signatures</code></p><p>If this array element exists, then the signed content was verified by at least one digital signature. Each element of this array is a dictionary with signature data. These dictionaries contain the following elements:</p><ul><li><p><code>contact</code></p><p>this string element contains the E-mail address of the signer</p></li><li><p><code>commonName</code></p><p>this string element contains the &quot;real name&quot; of the signer</p></li><li><p><code>Country</code>, <code>Province</code>, <code>Organization</code>, <code>Unit</code></p><p>these optional string elements contain additional information about the signer.</p></li></ul></li></ul><p><strong>Name: <code>CalendarPart</code></strong></p><p>This code component is used to render an iCalendar subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>Summary</code>, <code>Location</code>, <code>Comment</code></p><p>these string element contain the iCalendar attribute data.</p></li><li><p><code>Priority</code></p><p>this numeric string element contains the iCalendar element <code>PRIORITY</code> attribute value.</p></li><li><p><code>dateFrom</code></p><p>this date element contains the iCalendar element <code>DTSTART</code> attribute value.</p></li><li><p><code>method</code></p><p>this string element contains the iCalendar object METHOD parameter.</p></li><li><p><code>description</code></p><p>this string element contains the formatted <code>DESCRIPTION</code> attribute value.</p></li><li><p><code>organizer</code></p><p>this optional dictionary element contains the <code>ORGANIZER</code> attribute. The dictionary can contain various parameters specified for that attribute (&quot;cn&quot;, etc.). The E-mail address (the value) of the attribute is available as the <code>theValue</code> element of this dictionary.</p></li><li><p><code>attendees</code></p><p>this optional array element contains dictionary elements for each <code>ATTENDEE</code> attribute. Each dictionary can contain various parameters specified for that attribute (&quot;cn&quot;, &quot;role&quot;, etc.). The E-mail address (the value) of the attribute is available as the <code>theValue</code> element of this dictionary.</p></li><li><p><code>isEvent</code></p><p>this optional element exists and contains the YES string if the iCalendar element is a VEVENT. The following optional elements may exist only if this isEvent element exists:</p><ul><li><p><code>allDayEvent</code></p><p>this optional element exists and contains the YES string if the VEVENT is an All-Day Event.</p></li><li><p><code>recurrence</code></p><p>this optional element exists and contains the YES string if the VEVENT is a recurrent Event.</p></li><li><p><code>duration</code></p><p>this optional numeric string element exists and contains the Event duration in second if the VEVENT is a recurrent event.</p></li><li><p><code>dateTill</code></p><p>this optional date element exists and contains the Event &quot;end date&quot; if the Event is not a recurrent one, and if it&#39;s not a 1-day All-Day Event.</p></li><li><p><code>busyStatus</code></p><p>this optional string element contains the status of the Event if the iCalendar method is PUBLISH.</p></li></ul></li><li><p><code>isTask</code></p><p>this optional element exists and contains the YES string if the iCalendar element is a VTODO. The following optional elements may exist only if this isTask element exists:</p><ul><li><p><code>dateTill</code></p><p>this optional date element contains the VTODO &quot;due date&quot;.</p></li><li><p><code>percentComplete</code></p><p>this numeric string element contains the VTODO PERCENT-COMPLETE attribute value.</p></li></ul></li></ul><p><strong>Name: <code>vCardPart</code></strong></p><p>This code component is used to render an vCard subpart.</p><p><strong>Result Dataset</strong></p><ul><li><p><code>FN</code></p><p>this string element contains the Formatted Name vCard attribute value.</p></li><li><p><code>UID</code></p><p>this string element contains the UID vCard attribute value.</p></li><li><p><code>REV</code></p><p>this date element contains the REV vCard attribute value.</p></li><li><p><code>elements</code></p><p>this array element contains dictionary elements for other vCard attributes. Each dictionary has the following elements:</p><ul><li><p><code>name</code></p><p>a string with vCard attribute name</p></li><li><p><code>value</code></p><p>the vCard element value. The value can be a dictionary or an array of dictionary elements if vCard has several attributes of the same name. Each dictionary contains the attribute parameters and the attribute value as <code>theValue</code> element.</p></li></ul></li></ul><h2 id="Redirect" tabindex="-1">Redirect-type Response <a class="header-anchor" href="#Redirect" aria-label="Permalink to &quot;Redirect-type Response {#Redirect}&quot;">​</a></h2><p>Session and Stateless requests processed using WSSP files produce markup language documents. Before these documents are sent to the client browser, their first lines are checked. If the first document line starts with the <code>&lt;REDIRECT&gt;</code> tag, the rest of the document first line is interpreted as a URL.</p><p>The Server returns the 301 (&quot;Moved&quot;) response code with the Location header containing the specified URL.</p><p>The Server also processes the <code>&lt;RELREDIRECT&gt;</code> tag at the beginning of the document. It is processed in the same way as the <code>&lt;REDIRECT&gt;</code> tag, but the URL placed into the Location header is prefixed with the http or https prefix, the server name (and, optionally, port number) retrieved from the request URL.</p><h2 id="CGPL" tabindex="-1">CG/PL Applications <a class="header-anchor" href="#CGPL" aria-label="Permalink to &quot;CG/PL Applications {#CGPL}&quot;">​</a></h2><p>Session and Stateless requests can be processed using CG/PL applications (rather than the code components built into the Server). These CG/PL applications are called Web Applications.</p><p>A stateless request addressing a <code>/programName.wcgp</code> or <code>/programName.wcgp/someurl_</code> resource makes the Server load the <code>programname.wcgp</code> <a href="./CGPL.html">CG/PL</a> application from the selected Skin.<br> If the application produces any output, it is returned to the client browser, otherwise the 404 Not Found error is returned.</p><p>An application can be started by addressing a <code>/auth/programName.wcgp</code> or <code>/auth/programName.wcgp/someurl_</code> resource. Such an HTTP request is authenticated first, and the application is executed on behalf of the authenticated Account.</p><p>An application can be started by addressing the <code>/sys/programName.wcgp</code> resource. The application is executed in the Server-wide or the Cluster-wide Unnamed Skin environment on behalf of the <code>postmaster</code> Account in the Main Domain. The <code>sysEntry</code> code section of the <em>programName</em>.wcgp file is executed.</p><p>Session requests addressing a <code>/programName.wcgp</code> in the Session (<code>/Session/sessionID/</code>) realm makes the Server load the <code>programname.wcgp</code> <a href="./CGPL.html">CG/PL</a> application from the Session Skin.<br> Only the <code>GET</code>, <code>POST</code>, and <code>HEAD</code> HTTP requests are supported.<br> If the application produces any output, it is returned to the client browser, otherwise the 404 Not Found error is returned.<br> The application is executed on behalf of the Account the Session belongs to.</p><p>When a CG/PL module is loaded to process an HTTP request, the <code>main</code> module entry is executed.</p><p>Web Applications can use CG/PL <a href="./CGPL.html#ProcDefs">external-declarations</a>. When a code section (a procedure or a function) declared as <em>external</em> is called, a file with the code section name and the <code>.wcgi</code> extension is loaded from the current Skin. The program code in this file must contain the code section with the specified name and of the proper type (a procedure or a function).<br> The program code in an <code>.wcgi</code> file may contain other code sections as well.</p><p>CG/PL Web Applications can use the following built-in procedures and functions.</p><h3 id="HTTPInput" tabindex="-1">HTTP Request Input <a class="header-anchor" href="#HTTPInput" aria-label="Permalink to &quot;HTTP Request Input {#HTTPInput}&quot;">​</a></h3><ul><li><p><code>GetHTTPParameter(name [ ,index ])</code></p><p>This function retrieves an HTTP request parameter. HTTP request parameters include URL parameters and/or form fields.<br> The <em>name</em> value should be a string specifying the HTTP request parameter name.<br> An HTTP request can contain several parameters with the same name. If the <em>index</em> parameter is present, its value should be a number specifying which HTTP request parameter of the specified name should be retrieved.<br> If the HTTP request contains the <code>FormCharset</code> parameter, its value is interpreted as the character set name. The function converts the raw parameter data into the UTF-8 character set. If the <code>FormCharset</code> parameter is absent, the raw parameter data is assumed to be encoded using the UTF-8 character set.<br> If the parameter value contains several lines, the EOL (line separator) symbols are converted to those used with the Server host OS.<br> This function returns a string containing the parameter value. If the parameter with the specified name and, optionally, index is not found, this function returns a null-value.</p></li><li><p><code>GetHTTPBinaryParameter(name [ ,index ])</code></p><p>This function retrieves an HTTP request parameter raw data.<br> This function returns a datablock containing the parameter value. If the parameter with the specified name and, optionally, index is not found, this function returns a null-value.</p></li><li><p><code>GetHTTPField(name)</code></p><p>This function retrieves the <em>name</em> HTTP request field.<br> The following fields are supported: <code>Authorization</code>, <code>Referer</code>, <code>Destination</code>, <code>Cookie</code>, <code>User-Agent</code>, <code>Host</code>.<br> If the <code>name</code> value is an empty string, the HTTP request URL (without the optional URL parameters) is returned.<br> If the <code>name</code> value is the <code>Schema</code> string, the request URL schema used (the <code>http</code> or <code>https</code> string) is returned.<br> If the <code>name</code> value is the <code>Host</code> string, the request Host field is returned, with the optional &quot;port&quot; part removed.<br> If the <code>name</code> value is the <code>Port</code> string, the port number from the Host field is returned; if no port is specified in that field, the number 80 is returned for clear text connections, and the number 443 for secure connections.<br> If the specified field name if not in the supported set, or if the request does not contain the specified field, this function returns a null-value.</p></li><li><p><code>GetHTTPQuery()</code></p><p>This function retrieves the parameter string from the HTTP request URL.<br> If the request URL does not contain parameters, the function return a null-value.</p></li><li><p><code>GetHTTPResource()</code></p><p>This function retrieves the HTTP request query string, including all URL parameters.</p></li><li><p><code>GetHTTPMethod()</code></p><p>This function retrieves the HTTP request method string (GET, POST, etc.).</p></li><li><p><code>GetHTTPType()</code></p><p>This function retrieves the HTTP request body Content type.</p></li><li><p><code>GetHTTPSubtype()</code></p><p>This function retrieves the HTTP request body Content subtype.</p></li><li><p><code>GetHTTPData()</code></p><p>This function retrieves the HTTP request body.<br> If the request body content subtype is <code>xml</code> or it ends with <code>+xml</code>, the function tries to convert the body content into XML and returns an XML object.<br> If the request body content type is <code>text</code>, the function converts the body content into UTF-8 and returns a string.<br> Otherwise, the function returns a datablock.<br> If any conversion operation fails, or if the request body is absent or it is too long, the function return a null-value.</p></li></ul><h3 id="HTTPOutput" tabindex="-1">HTTP Response Output <a class="header-anchor" href="#HTTPOutput" aria-label="Permalink to &quot;HTTP Response Output {#HTTPOutput}&quot;">​</a></h3><ul><li><p><code>SetHTTPResponseData(data)</code></p><p>This procedure sets the HTTP response body.<br> The <em>data</em> value should be either a string, a datablock, a dictionary, or an XML object.</p></li><li><p><code>SetHTTPResponseType(mimeType,subtype)</code></p><p>This procedure sets the HTTP response Content-Type field values.<br> The <em>mimeType</em> and <em>subtype</em> values should be strings containing valid MIME atoms.</p></li><li><p><code>SetHTTPResponseCode(code)</code></p><p>This procedure sets the HTTP response code.<br> The <em>code</em> value should be a number in the 200..999 range or a string.<br> If the string starts with a 3-digit prefix and the <code>-</code> symbol, then the prefix specifies the HTTP response code, and the rest of the string specifies the HTTP response text.<br> If there is no such prefix in the <em>code</em> string value, then the HTTP response code is set to 500, and the entire string is used as the HTTP response text.</p></li><li><p><code>RemoteIPAddress()</code></p><p>This function returns an ip-address object specifying the IP Address the HTTP request was received from.</p></li><li><p><code>ProxiedIPAddress()</code></p><p>If the HTTP request was relayed by some external HTTP proxy, this function returns the original client IP Address. Otherwise the function returns a null-object.</p></li><li><p><code>SendHTTPContinue()</code></p><p>This function sends the 100-Continue HTTP response.<br> If the response is successfully sent, the function returns a null-value, otherwise it returns an error code string.</p></li><li><p><code>AddHTTPResponseField(fieldName,fieldValue)</code></p><p>This procedure adds a field to the HTTP response.<br> The <em>fieldName</em> and <em>fieldValue</em> values should be strings.</p></li><li><p><code>ProcessWSSP(pageName,resultSet)</code></p><p>This procedure composes the HTTP response body using the specified WSSP page and the result dataset.<br> The <em>pageName</em> value should be a string with the page name (without the <code>wssp</code> suffix). This page is retrieved from the currently selected Skin.<br> The <em>resultSet</em> value should be a dictionary. The Server modifies this dictionary adding the common Session or stateless processing elements (see above), and then it is passed to the WSSP interpreter.<br> The resulting page is set as the HTTP response body.</p></li></ul><h3 id="SessionCGPL" tabindex="-1">Session Data <a class="header-anchor" href="#SessionCGPL" aria-label="Permalink to &quot;Session Data {#SessionCGPL}&quot;">​</a></h3><p>Functions and procedures listed in this section are available only for Session HTTP requests.</p><ul><li><p><code>SessionData()</code></p><p>This function returns the <a href="./WSSP.html#Exprs">Session Dataset</a> dictionary.</p></li></ul>',284)]))}const m=t(a,[["render",n]]);export{u as __pageData,m as default};
