import{_ as t,C as n,c as l,o as h,ag as i,j as p,a as e,G as o}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"XIMSS Protocol","description":"","frontmatter":{"legacyLink":"XMLAPI.html"},"headers":[],"relativePath":"development/XMLAPI.md","filePath":"development/XMLAPI.md"}'),r={name:"development/XMLAPI.md"};function d(k,s,c,E,g,u){const a=n("null");return h(),l("div",null,[s[2]||(s[2]=i(`<h1 id="ximss-protocol" tabindex="-1">XIMSS Protocol <a class="header-anchor" href="#ximss-protocol" aria-label="Permalink to &quot;XIMSS Protocol&quot;">​</a></h1><p>The CommuniGate Pro Server implements the XML Interface to Messaging, Scheduling and Signaling (XIMSS) protocol.</p><p>The Interface is implemented with the <a href="./../admin/access/XIMSS.html">XIMSS module</a> supporting TCP/IP networks.</p><p>The protocol session examples use the <code>S:</code> marker to show the data sent by the Server, and the <code>C:</code> marker to show the data sent by a Client.</p><p>The &quot;client-side&quot; programming libraries for the XIMSS protocol can be found at the <a href="http://www.communigatepro.ru/XIMSSClient/Guide/" target="_blank" rel="noreferrer">XIMSS Client</a> web site.</p><h2 id="Syntax" tabindex="-1">Protocol and Message Syntax <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;Protocol and Message Syntax {#Syntax}&quot;">​</a></h2><p>XML API clients should open clear-text or secure TCP connections to the CommuniGate Pro Server XML module. When a connection is established, both sides can send and receive <em>messages</em>.</p><p>Each message is a text string ending with a binary zero byte.</p><p>Each message should be formatted as an XML document.</p><p>A client asks the Server to take actions and/or to retrieve data by sending a <em>request</em> message. Each request message must contain the <code>id</code> attribute.</p><p>When the Server completes the requested operation, it sends back a <em>response</em> message:</p><ul><li><p><code>response</code></p><p>Attributes:</p><ul><li><p><code>id</code></p><p>the same as the <code>id</code> attribute of the request message.</p></li><li><p><code>errorText</code></p><p>this optional attribute is present only if the operation has failed. It contains the error message text.</p></li><li><p><code>errorNum</code></p><p>this optional attribute is present only if the operation has failed. It contains the numeric error code.</p></li><li><p><code>exeTime</code></p><p>this optional attribute is present if the operation request contained <code>exeTime</code> attribute with non-zero value. It contains the command execution time in milliseconds measured by the Server.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">noop</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">myCommand</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> myParam</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> exeTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorText</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;unknown command&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorNum</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;500&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> exeTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;211&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div></li></ul><p>Example:</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">noop</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">myCommand</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> myParam</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorText</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;unknown command&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorNum</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;500&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span></code></pre></div><p>A client can send the next request message without waiting for the current request response (pipelining).</p><p>The Server can send <em>data</em> messages to the client:</p><ul><li>when it processes a client request message;<br> these messages are sent before the response message is sent;<br> these messages include the same <code>id</code> attribute as the request message.</li><li>when an asynchronous Server event (such as arrival of an Alert or an Instant Message) is delivered to the client session.<br> these messages do not include any <code>id</code> attribute.</li></ul><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">noop</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">alert</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> gmtTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T083313&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T003313&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Account is over quota&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">alert</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">alert</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> gmtTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T083500&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T003500&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Please logout, as we are shutting down.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">alert</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>A Client must send some command to the Server at least once in 10 minutes, otherwise the Server closes the connection.</p></div><h2 id="PreLogin" tabindex="-1">Pre-Login Operations <a class="header-anchor" href="#PreLogin" aria-label="Permalink to &quot;Pre-Login Operations {#PreLogin}&quot;">​</a></h2><p>After a connection with the Server is established, and before the client performs the <code>login</code> operation, the client can perform only the operations listed in this section.</p><p>When a connection is established, the Server takes the IP Address the client has connected to and selects the <a href="./../admin/objects/Domains.html">Domain</a> this IP address is assigned to.</p><p>Operations in this section can explicitly specify an alternative target Domain: if it is found, the new target Domain is set and it is used in the next operations.</p><h3 id="listFeatures" tabindex="-1">listFeatures <a class="header-anchor" href="#listFeatures" aria-label="Permalink to &quot;listFeatures {#listFeatures}&quot;">​</a></h3><p>This operation tells the Server to return a <code>features</code> message containing available communication and authentication options.</p><p>Attributes:</p><ul><li><p><code>domain</code></p><p>optional target <a href="./../admin/objects/Domains.html">Domain</a> name.</p></li></ul><h3 id="readStrings" tabindex="-1">readStrings <a class="header-anchor" href="#readStrings" aria-label="Permalink to &quot;readStrings {#readStrings}&quot;">​</a></h3><p>This operation reads the vocabulary (words, tags, button names, etc.) stored in the current Domain <a href="./WebApp.html">Skin</a>. The Server sends a <a href="#strings"><code>strings</code></a> data message with the dictionary data.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name. If not specified, the unnamed Skin is used.</p></li><li><p><code>language</code></p><p>the vocabulary language. If the attribute is missing, the Account Defaults <code>Language</code> preference string is used.</p></li><li><p><code>timeModified</code></p><p>if this attribute is specified, it should contain a date and time value (GMT time). If this attribute is specified, the <a href="#strings"><code>strings</code></a> data message does not have any body element if the requested vocabulary modification time is not newer than this attribute value.</p></li></ul><h3 id="starttls" tabindex="-1">starttls <a class="header-anchor" href="#starttls" aria-label="Permalink to &quot;starttls {#starttls}&quot;">​</a></h3><p>This operation tells the server to establish SSL/TLS security on this connection.</p><p>Attributes:</p><ul><li><p><code>domain</code></p><p>optional target <a href="./../admin/objects/Domains.html">Domain</a> name.</p></li></ul><p>If the server returns a positive response, the client should start SSL/TLS negotiations immediately.</p><h3 id="recoverPassword" tabindex="-1">recoverPassword <a class="header-anchor" href="#recoverPassword" aria-label="Permalink to &quot;recoverPassword {#recoverPassword}&quot;">​</a></h3><p>This operation asks the server to E-mail the password of the specified Account to the E-mail address the Account user has specified.</p><p>Attributes:</p><ul><li><p><code>domain</code></p><p>optional target <a href="./../admin/objects/Domains.html">Domain</a> name.</p></li><li><p><code>userName</code></p><p>the Account name.</p></li></ul><p>If the server returns a positive response, the Account password has been E-mailed.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation introduces a delay before returning a response.</p></div><h3 id="signup" tabindex="-1">signup <a class="header-anchor" href="#signup" aria-label="Permalink to &quot;signup {#signup}&quot;">​</a></h3><p>This operation tells the Server to create a new Account.</p><p>Attributes:</p><ul><li><p><code>domain</code></p><p>optional target <a href="./../admin/objects/Domains.html">Domain</a> name.</p></li><li><p><code>userName</code></p><p>the new Account name.</p></li><li><p><code>password</code></p><p>the new Account password.</p></li><li><p><code>realName</code></p><p>a Real Name of the new Account owner (optional).</p></li><li><p><code>recoverPassword</code></p><p>an E-mail address that can be used to recover a forgotten password (optional).</p></li></ul><p>If the server returns a positive response, the Account has been created.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation does not log user into a newly created Account.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation introduces a delay before returning a response.</p></div><p>The Server sends the following data messages:</p><h5 id="features" tabindex="-1">features <a class="header-anchor" href="#features" aria-label="Permalink to &quot;features {#features}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <code>listFeatures</code> operation.</p><ul><li>Body:</li></ul><p>a set of XML elements:</p><ul><li><p><code>domain</code></p><p>the target Domain name.</p></li><li><p><code>sasl</code></p><p>the text body of this element is the name of the SASL mechanism enabled for the target Domain.</p></li><li><p><code>starttls</code></p><p>if this element is present, the client can perform the <code>starttls</code> operation.</p></li><li><p><code>nonce</code></p><p>a valid &quot;nonce&quot; data. This &quot;nonce&quot; data can be used with SASL <a href="./../admin/access/XIMSS.html#HTTPLogin">HTTP Login</a> methods.</p></li><li><p><code>language</code></p><p>the text body of this element contains the default language selected for the target Domain. If this element is absent, the default (English) language is selected.</p></li><li><p><code>signup</code></p><p>if this element is present, the client can perform the <code>signup</code> operation with the target Domain.</p></li><li><p><code>connect</code></p><p>if this element is present, it specifies the connection method the client should use for the login and session requests. It is based on the Recommended XIMSS Method <a href="./../admin/objects/Domains.html#WebUser">Domain Setting</a> for the target Domain.<br> The element has the following attributes:</p><ul><li><p><code>protocol</code></p><p>the protocol to use: <code>http</code> or <code>ximss</code>. The recommended protocol should be a secure one (such as https) if the <code>listFeatures</code> operation was issued over a secure protocol.</p></li><li><p><code>port</code></p><p>the TCP port number to use. If not specified, the client should use the same port as it used to send this <code>listFeatures</code> operation.</p></li></ul></li></ul><h2 id="Login" tabindex="-1">Login Operations <a class="header-anchor" href="#Login" aria-label="Permalink to &quot;Login Operations {#Login}&quot;">​</a></h2><p>The client should perform the <code>login</code> operation to authenticate the user and to create a XIMSS session.</p><h3 id="login" tabindex="-1">login <a class="header-anchor" href="#login" aria-label="Permalink to &quot;login {#login}&quot;">​</a></h3><p>Attributes:</p><ul><li><p><code>domain</code></p><p>optional target <a href="./../admin/objects/Domains.html">Domain</a> name.</p></li><li><p><code>method</code></p><p>this attribute specifies the <a href="./../admin/sysadmin/Security.html#SASL">SASL</a> method to use. If this attribute is missing the <em>clear-text</em> (<em>password</em>) method is used.</p></li><li><p><code>authData</code></p><p>If the <em>clear-text</em> method is used, this attribute contains the username.<br> For all other methods, this is a string with base64-encoded SASL protocol data.</p></li><li><p><code>password</code></p><p>This attribute is used for the <em>clear-text</em> authentication method only, it contains the user password in the clear-text form.</p></li><li><p><code>version</code></p><p>This attribute specifies the protocol version this Client is designed for (for example, 6.0). If the version is not specified, the 5.4 version is assumed.Example:</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">login</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> authData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> password</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123rtu&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">session</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> urlID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12-skejlkieuoiuoi-dnciru&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> userName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;User J. Smith&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>The Server sends the following data messages:</p><h5 id="session" tabindex="-1">session <a class="header-anchor" href="#session" aria-label="Permalink to &quot;session {#session}&quot;">​</a></h5><p>This message contains information about the newly created session. It is sent before the positive response for the <code>login</code> operation is sent.</p><p>Attributes:</p><ul><li><p><code>urlID</code></p><p>the session ID string. This ID string can be used to access session data via <a href="#HTTP">HTTP</a>.</p></li><li><p><code>userName</code></p><p>the authenticated Account full name (<code>accountName@domainName</code>).</p></li><li><p><code>realName</code></p><p>the authenticated Account user Real Name (this attribute is absent if the Real Name is not specified in the Account Settings).</p></li><li><p><code>version</code></p><p>the protocol version supported with the Server (for example, 6.1).</p></li></ul><p>Examples:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">login</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> authData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example2.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> password</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;rrr123&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">session</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> urlID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12-skejlkieuoiuoi-dnciru&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> userName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;User J. Smith&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> version</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;6.1.2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>When the specified SASL method involves sending a challenge to the client, it is sent as a <a href="#challenge"><code>challenge</code></a> data message, with the <code>value</code> attribute containing the base64-encoded SASL protocol challenge data.<br> The client should respond by sending an <a href="#auth"><code>auth</code></a> request with the same <code>id</code> attribute as one used in the <code>login</code> request, and the <code>value</code> attribute containing the base64-encoded SASL protocol response data.</p><p>Example (see RFC2195):</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">login</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> method</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;CRAM-MD5&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">challenge</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;PDE4OTYuNjk3MTcwOTUyQHBvc3RvZmZpY2UucmVzdG9uLm1jaS5uZXQ+&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">auth</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;dGltIGI5MTNhNjAyYzdlZGE3YTQ5NWI0ZTZlNzMzNGQzODkw&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">session</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> urlID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12-skejlkieuoiuoi-dnciru&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> userName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;User J. Smith&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h2 id="X2Auth" tabindex="-1">Two-Factor Authentication <a class="header-anchor" href="#X2Auth" aria-label="Permalink to &quot;Two-Factor Authentication {#X2Auth}&quot;">​</a></h2><p>If Two-Factor Authentication is enabled and required to complete the <a href="#login"><code>login</code></a> operation the <a href="#session"><code>session</code></a> response contains the <code>x2auth</code> dictionary that describes the methods available for Two-Factor Authentication, with the key of each element being the method name and the value being the dictionary with method parameters:</p><p>Parameters:</p><ul><li><code>address</code></li></ul><p>optional parameter with the obfuscated address where the one-time password will be sent to.<br> This parameter may be an array when one method supports multiple addresses.</p><ul><li><code>icon</code></li></ul><p>this optional attribute specifies the icon file name to represent this method in the user interface.</p><ul><li><code>humanTag</code></li></ul><p>this optional attribute specifies the name of the string element in the Skin to name this method in UI.</p><ul><li><code>humanName</code></li></ul><p>this optional attribute specifies the string to name this method in UI. It&#39;s used when <code>humanTag</code> element is not present. When neither <code>humanTag</code> nor <code>humanName</code> are present, the raw method name can be used in UI.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">login</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> authData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example2.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> password</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;rrr123&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> x2auth</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">session</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> urlID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;14-skejlkieuoiuoi-dnciru&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> userName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1@example.dom&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;User J. Smith&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> version</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;6.2c1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">x2auth</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sms&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;address&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+1555***2207&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;humanName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Send SMS to&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;call&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;address&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+1555***2207&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;humanTag&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;x2authvoiptag&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;x2authvoip.png&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;email&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;address&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;d***6@gmail.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;humanTag&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;x2authemailtag&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;push&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;address&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;John&#39;s iPhone&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Samsung Galaxy S6&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;humanTag&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;x2authpushtag&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;x2authvoip.png&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">x2Auth</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">session</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>The client should present the user interface to select a method and then use <a href="#x2AuthStart"><code>x2AuthStart</code></a> command to start the second stage of authentication and <a href="#x2AuthComplete"><code>x2AuthComplete</code></a> to complete it.</p><h3 id="x2AuthStart" tabindex="-1">x2AuthStart <a class="header-anchor" href="#x2AuthStart" aria-label="Permalink to &quot;x2AuthStart {#x2AuthStart}&quot;">​</a></h3><p>This operation starts transmission of the one-time secret to the devices possessed by the user, using the specified method. On a success the Server sends the <a href="#x2authData"><code>x2auth</code></a> data message.</p><p>Attributes:</p><ul><li><p><code>index</code></p><p>Optional index of element in the array of addresses available for the selected method.</p><p>Body:</p><ul><li>String with the selected method name.</li></ul></li></ul><h3 id="x2AuthComplete" tabindex="-1">x2AuthComplete <a class="header-anchor" href="#x2AuthComplete" aria-label="Permalink to &quot;x2AuthComplete {#x2AuthComplete}&quot;">​</a></h3><p>Body:</p><ul><li>Optional string with the one-time secret to confirm the second stage of authentication.</li></ul><p>The server sends the following empty data message in response to the <code>x2AuthStart</code> command:</p><ul><li><p><code>x2auth</code></p><p>Attributes:</p><ul><li><code>user</code></li></ul><p>Set if the <code>x2AuthComplete</code> expects the one-time secret from user input to unlock the session. This is the default.</p></li><li><p><code>background</code></p><p>Set when the one-time secret verification is expected to complete in background. In this case <code>x2AuthComplete</code> can be executed without one-time password to check for that completion.</p></li></ul><p>The server sends the following asynchronous empty data message in response to the <code>x2AuthStart</code> and <code>x2AuthComplete</code> commands when second stage of the authentication is completed in background:</p><ul><li><code>x2AuthCompleted</code></li></ul><h3 id="x2authTotp" tabindex="-1">TOTP Setup Process for Two-Factor Authentication <a class="header-anchor" href="#x2authTotp" aria-label="Permalink to &quot;TOTP Setup Process for Two-Factor Authentication {#x2authTotp}&quot;">​</a></h3><p>If mandatory Two-Factor Authentication is enabled for the user, and the user has chosen TOTP-based authentication, then after calling <a href="#x2AuthStart"><code>x2AuthStart</code></a>, the server checks whether a TOTP secret has already been set by the user.</p><p>If the secret has not been set previously, the server will return an error: &quot;<code>TOTP is not initialized yet</code>&quot;. Upon receiving this error, the client should send the <a href="#totpGenerateSecret"><code>totpGenerateSecret</code></a> command to generate a new secret. In response, the user will receive a <a href="#totpSecret"><code>totpSecret</code></a> message containing the generated TOTP secret encoded in Base32 and a QR code image encoded in Base64 for scanning with a time-based one-time password (TOTP) application.</p><p>After scanning the QR code with the TOTP application, the client must send the previously received secret along with a one-time password generated by the application back to the server using the <a href="#totpSetSecret"><code>totpSetSecret</code></a> command. If the one-time password is verified successfully and the secret is accepted, the server will return an empty response. At that point, both the TOTP initialization process and the two-factor authentication process will be considered complete, and the full set of account-related operations will become available. In case of a verification failure, the server will respond with an error description.</p><h3 id="totpGenerateSecret" tabindex="-1">totpGenerateSecret <a class="header-anchor" href="#totpGenerateSecret" aria-label="Permalink to &quot;totpGenerateSecret {#totpGenerateSecret}&quot;">​</a></h3><p>This operation requests the generation of a TOTP secret. If successful, the server responds with the following message:</p><ul><li id="totpSecret"><p><code>totpSecret</code></p><p>Attributes:</p><ul><li><p><code>secret</code></p><p>The TOTP secret generated by the server and encoded in Base32 format.</p></li></ul><p>Body:</p><ul><li>An XML <code>base64</code> object containing a QR code image for scanning with a time-based one-time password (TOTP) application.</li></ul><p>Example:</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">totpGenerateSecret</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">totpSecret</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> secret</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;S426CAWTPDNE4YRPRCQBFBEBRI======&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: iVBORw0KGgoAAAANSUhEUgAAADEAAAAxAQMAAABJUtNfAAAABlBMVEX///8AAABVwtN+ AAABPU</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: lEQVR4nGNgIAD4Hx5IUP7BwMChE285iYOBgXsJ44quF0B60V4rIxC9cnN1FJDmUP1aawSU53+1a</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: tVqoHoGhmu1QGEGrkU85zImMDCwytqtadFgYGCyvOFw1gPID9n3/yBQntXO586lCwwMLNf03p/L</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: YGBgXm33jA1Is7csvXugAyj+6kIjO1A9W//H2bckgOK/vqh07wBqjFv5/G8EUP3PBSzHHYDyp2x</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: O9FsAzd/xgOfwD6C597akVwDNZTXSOeF2AKh+5tszDziA6lYrpORpAPm31uZ8A1LsdsfDwwKADJ</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: 5NZ/iAFFOFltPxGUB1zsdjQoF8tgy2GfJA9zPwy9/yOAGkHnOd4OoA+ld9XvqLA0D/rzp0xP8GK</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S: Dy4el7uANIruPwkgfZzKMafuwk0l//llzu3gPIEAADVbDp+iAEAAIzZSNUAAAAASUVORK5CYII=</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">totpSecret</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h3 id="totpSetSecret" tabindex="-1">totpSetSecret <a class="header-anchor" href="#totpSetSecret" aria-label="Permalink to &quot;totpSetSecret {#totpSetSecret}&quot;">​</a></h3><p>This operation requests the setting of a TOTP secret for the user. If the secret is successfully set, the server will return an empty response.</p><p>Attributes:</p><ul><li><p><code>secret</code></p><p>The TOTP secret encoded in Base32 format, obtained during the execution of the <a href="#totpGenerateSecret"><code>totpGenerateSecret</code></a> operation.</p></li><li><p><code>code</code></p><p>The one-time password generated by a time-based one-time password (TOTP) application after scanning the QR code.</p></li></ul><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">totpSetSecret</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> secret</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;S426CAWTPDNE4YRPRCQBFBEBRI======&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> code</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123456&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h2 id="Service" tabindex="-1">Service Operations <a class="header-anchor" href="#Service" aria-label="Permalink to &quot;Service Operations {#Service}&quot;">​</a></h2><p>The following operations can be used to manage the client-server connection.</p><h3 id="noop" tabindex="-1">noop <a class="header-anchor" href="#noop" aria-label="Permalink to &quot;noop {#noop}&quot;">​</a></h3><p>This operation does not do anything and it always succeeds.</p><h3 id="bye" tabindex="-1">bye <a class="header-anchor" href="#bye" aria-label="Permalink to &quot;bye {#bye}&quot;">​</a></h3><p>This operation does not do anything and it always succeeds. After the response message is sent to the client, the Server closes the connection and destroys the current session.</p><h3 id="passwordModify" tabindex="-1">passwordModify <a class="header-anchor" href="#passwordModify" aria-label="Permalink to &quot;passwordModify {#passwordModify}&quot;">​</a></h3><p>This operation modifies the Account Password and/or the Password Recovery E-mail Address.</p><p>Attributes:</p><ul><li><p><code>oldPassword</code></p><p>the current Account password. The operation verifies this password before attempting any modification.</p></li><li><p><code>newPassword</code></p><p>this optional attribute specifies the new password. The <a href="./../admin/objects/Accounts.html#Passwords">password modification</a> operation must be allowed for this Account.</p></li><li><p><code>recoveryEMail</code></p><p>this optional attribute specifies the new password recovery E-mail.</p></li><li><p><code>name</code></p><p>this optional attribute specifies the tag for &quot;application-specific&quot; password.</p></li><li><p><code>remove</code></p><p>when this optional attribute is set to yes, the &quot;application-specific&quot; password with the tag specified in the the <code>name</code> parameter is removed.</p></li></ul><h3 id="listSpecPasswords" tabindex="-1">listSpecPasswords <a class="header-anchor" href="#listSpecPasswords" aria-label="Permalink to &quot;listSpecPasswords {#listSpecPasswords}&quot;">​</a></h3><p>This command is used to retrieve the list of application passwords tags.</p><h3 id="setSessionOption" tabindex="-1">setSessionOption <a class="header-anchor" href="#setSessionOption" aria-label="Permalink to &quot;setSessionOption {#setSessionOption}&quot;">​</a></h3><p>This operation sets an option value for the current session.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the option name</p></li><li><p><code>value</code></p><p>the option value.</p><p>The following session options are supported:</p><ul><li><p>reportMailboxChanges</p><p>if the option value is yes, the Server sends <a href="#mailboxModified"><code>mailboxModified</code></a> data messages, for any other value, the Server stops sending these data messages.</p></li><li><p>idleTimeout</p><p>the session idle time-out is set to the specified number of seconds or to a some larger value, if the specified value is unavailable.</p></li></ul></li></ul><h3 id="listUploaded" tabindex="-1">listUploaded <a class="header-anchor" href="#listUploaded" aria-label="Permalink to &quot;listUploaded {#listUploaded}&quot;">​</a></h3><p>This operation retrieves information for one or all files from the <a href="#FileUpload">&quot;uploaded file set&quot;</a>. The Server sends uploaded file information in an <a href="#uploadedFile"><code>uploadedFile</code></a> data message (see below).</p><p>Attributes:</p><ul><li><p><code>uploadID</code></p><p>if this optional parameter is specified, information is retrieved only for the file with this fileID.<br> If this parameter is not specified, information for all &quot;uploaded file set&quot; files is retrieved.</p></li></ul><h3 id="clearUploaded" tabindex="-1">clearUploaded <a class="header-anchor" href="#clearUploaded" aria-label="Permalink to &quot;clearUploaded {#clearUploaded}&quot;">​</a></h3><p>This operation removes one or all files from the <a href="#FileUpload">&quot;uploaded file set&quot;</a>.</p><p>Attributes:</p><ul><li><code>uploadID</code></li></ul><p>if this optional parameter is specified, only the file with this fileID is removed from the &quot;uploaded file set&quot;.<br> If this parameter is not specified, all files are removed from the &quot;uploaded file set&quot;.</p><h3 id="readConfigFile" tabindex="-1">readConfigFile <a class="header-anchor" href="#readConfigFile" aria-label="Permalink to &quot;readConfigFile {#readConfigFile}&quot;">​</a></h3><p>This operation reads a configuration file stored on the Server. The Server sends a <a href="#configFile"><code>configFile</code></a> data message with the configuration file data (see below).</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the configuration name.</p></li><li><p><code>timeModified</code></p><p>if this attribute is specified, it should contain a date and time value (GMT time). If this attribute is specified, the <code>configFile</code> data message does not have any body element if the requested configuration modification time is not newer than this attribute value.</p></li></ul><h3 id="readTime" tabindex="-1">readTime <a class="header-anchor" href="#readTime" aria-label="Permalink to &quot;readTime {#readTime}&quot;">​</a></h3><p>This operation reads the current time from the Server. The Server sends a <a href="#currentTime"><code>currentTime</code></a> message.</p><h3 id="readStatus" tabindex="-1">readStatus <a class="header-anchor" href="#readStatus" aria-label="Permalink to &quot;readStatus {#readStatus}&quot;">​</a></h3><p>This operation reads the current Account status. The Server sends a <a href="#currentStatus"><code>currentStatus</code></a> message.</p><h3 id="readSession" tabindex="-1">readSession <a class="header-anchor" href="#readSession" aria-label="Permalink to &quot;readSession {#readSession}&quot;">​</a></h3><p>This operation makes the Server to resend the <a href="#SessionMessage"><code>session</code></a> message (which is sent when a new session is created).</p><h3 id="listKnownValues" tabindex="-1">listKnownValues <a class="header-anchor" href="#listKnownValues" aria-label="Permalink to &quot;listKnownValues {#listKnownValues}&quot;">​</a></h3><p>This operation causes the Server to send a <a href="#knownValues"><code>knownValues</code></a> message. This message contains sets of &quot;known values&quot;: known Time Zone names, character set names, etc.</p><h3 id="skinList" tabindex="-1">skinList <a class="header-anchor" href="#skinList" aria-label="Permalink to &quot;skinList {#skinList}&quot;">​</a></h3><p>This operation lists <a href="./WebApp.html">Skins</a> in the current Domain.</p><p>Attributes:</p><ul><li><p><code>filter</code></p><p>an optional attribute specifies a picture with the star (<code>*</code>) symbol used as wildcards. Only the Skin names matching this picture are reported.The Server returns one <a href="#skinInfo"><code>skinInfo</code></a> message for each Skin found.</p></li></ul><h3 id="skinFileList" tabindex="-1">skinFileList <a class="header-anchor" href="#skinFileList" aria-label="Permalink to &quot;skinFileList {#skinFileList}&quot;">​</a></h3><p>This operation provides a list of the selected Skin file names.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name. If not specified, the unnamed Skin is used.</p></li><li><p><code>filter</code></p><p>an optional attribute specifies a picture with the star (<code>*</code>) symbol used as wildcards. Only the file names matching this picture are reported.The Server returns one <a href="#skinFileInfo"><code>skinFileInfo</code></a> message for each file found.</p></li></ul><h3 id="skinFileRead" tabindex="-1">skinFileRead <a class="header-anchor" href="#skinFileRead" aria-label="Permalink to &quot;skinFileRead {#skinFileRead}&quot;">​</a></h3><p>This operation reads a file from the specified Skin in the current Domain.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name. If not specified, the unnamed Skin is used.</p></li><li><p><code>fileName</code></p><p>the name of file to read.</p></li><li><p><code>type</code></p><p>If this optional attribute exists and its value is <code>binary</code>, the file data is returned base64-encoded.The Server returns a <a href="#skinFileData"><code>skinFileData</code></a> message.</p></li></ul><h3 id="cliExecute" tabindex="-1">cliExecute <a class="header-anchor" href="#cliExecute" aria-label="Permalink to &quot;cliExecute {#cliExecute}&quot;">​</a></h3><p>This operation executes a <a href="./CLI.html">Network CLI</a> command.</p><p>Attributes:</p><ul><li><p><code>report</code></p><p>if this attribute is present, and its value is <code>xml</code>, the resulting object will be sent as its XML presentation.</p><p>Body:</p><ul><li>the CLI command text. If the CLI command produces a result, the Server sends a <a href="#cliResult"><code>cliResult</code></a> message.</li></ul></li></ul><h3 id="retrieveXML" tabindex="-1">retrieveXML <a class="header-anchor" href="#retrieveXML" aria-label="Permalink to &quot;retrieveXML {#retrieveXML}&quot;">​</a></h3><p>This operation reads an XML document from a remote server. The current user must have the <code>HTTP</code> <a href="./../admin/objects/Accounts.html#Services">Service</a> enabled.</p><p>Attributes:</p><ul><li><p><code>url</code></p><p>the XML document URL (<code>http:</code> or <code>https:</code>).</p></li><li><p><code>timeout</code></p><p>the operation time-out (in seconds).If the document is successfully retrieved, the Server sends a <a href="#retrievedXML"><code>retrievedXML</code></a> message with the retrieved document content.</p></li></ul><h3 id="httpCall" tabindex="-1">httpCall <a class="header-anchor" href="#httpCall" aria-label="Permalink to &quot;httpCall {#httpCall}&quot;">​</a></h3><p>This operation sends an HTTP request to and receive an HTTP response from a remote server. The current user must have the <code>HTTP</code> <a href="./../admin/objects/Accounts.html#Services">Service</a> enabled.<br> This operation uses the specified URL, a composed request dictionary, and a maximum time-out of 30 seconds to call the <a href="./../admin/services/HTTP.html#Client">HTTP Client</a> module to execute an HTTP request.</p><p>Attributes:</p><ul><li><p><code>url</code></p><p>the document URL (<code>http:</code> or <code>https:</code>).</p></li><li><p><code>other attributes</code></p><p>other attributes are used to compose the request dictionary.</p></li></ul><p>Body:</p><p>If specified, it is used to compose the <code>body</code> element of the request dictionary (the HTTP request body). It should use one of the following formats:</p><ul><li><p>a text body</p><p>the text is used as the request body.</p></li><li><p>one <code>body</code> XML element</p><p>the element text body is used as the request body.</p></li><li><p>one <code>base64</code> XML element</p><p>the element text body is base64-decoded and the resulting datablock is used as the request body.</p></li><li><p>a set of <code>field</code> XML elements</p><p>a dictionary with these elements is used as the request body (the HTTP POST request data).<br> Each <code>field</code> element specifies a form field: the element <code>name</code> attribute specifies the form field name; the field value is specified with the <code>field</code> element body, which should be either a text or an <a href="./Data.html#XML">XML presentation</a> of a number, datablock, or a dictionary (see the <a href="./../admin/services/HTTP.html#Client">HTTP Client</a> module section for the details).Besides these <code>body</code> data elements, the <code>httpCall</code> request body can contain:</p></li><li><p>one <code>supplFields</code> XML element</p><p>the element body should contain one or more <a href="./Data.html#XML"><code>subKey</code></a> elements; they form a dictionary specifying additional HTTP request fields.</p></li><li><p>one <code>urlParams</code> XML element</p><p>the element body should contain one or more <a href="./Data.html#XML"><code>subKey</code></a> elements - they form a dictionary specifying HTTP request URL parameters.When the transaction completes, the Server sends a <a href="#retrievedURL"><code>retrievedURL</code></a> message with the transaction results.</p></li></ul><h3 id="spellerList" tabindex="-1">spellerList <a class="header-anchor" href="#spellerList" aria-label="Permalink to &quot;spellerList {#spellerList}&quot;">​</a></h3><p>This operation causes the Server to send <a href="#speller"><code>speller</code></a> messages, containing the names of installed spell checkers.</p><h3 id="spellerCheck" tabindex="-1">spellerCheck <a class="header-anchor" href="#spellerCheck" aria-label="Permalink to &quot;spellerCheck {#spellerCheck}&quot;">​</a></h3><p>This operation checks the spelling of an arbitrary text. For each spelling error found, the Server sends a <a href="#spellerReport"><code>spellerReport</code></a> message.</p><p>Attributes:</p><ul><li><p><code>speller</code></p><p>the spell checker name.</p></li><li><p><code>mode</code></p><p>if this attribute exists and it has the &quot;glyphs&quot; value, offsets and lengths in the <a href="#spellerReport"><code>spellerReport</code></a> messages define symbols (UTF8-encoded) rather than bytes.</p></li></ul><p>Body:</p><ul><li>the text to check.</li></ul><h3 id="getSessionData" tabindex="-1">getSessionData <a class="header-anchor" href="#getSessionData" aria-label="Permalink to &quot;getSessionData {#getSessionData}&quot;">​</a></h3><p>This operation causes the Server to reply with the <a href="#sessionData"><code>sessionData</code></a> message - XML representation of the session custom parameters dictionary or its subpart specified with the <code>name</code> attribute.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the name of the key in the custom session data dictionary (optional).</p></li></ul><h3 id="setSessionData" tabindex="-1">setSessionData <a class="header-anchor" href="#setSessionData" aria-label="Permalink to &quot;setSessionData {#setSessionData}&quot;">​</a></h3><p>This operation modifies the contents of the custom session parameters dictionary.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the name of the key in the custom session data dictionary.</p></li><li><p><code>delete</code></p><p>if this options attribute is set the operation removed the subpart of the session data specified with the <code>delete</code> attribute.</p></li></ul><p>Body:</p><p>The XML representation of the session custom parameters dictionary or its subpart specified with the <code>name</code> attribute.</p><h3 id="getLanguage" tabindex="-1">getLanguage <a class="header-anchor" href="#getLanguage" aria-label="Permalink to &quot;getLanguage {#getLanguage}&quot;">​</a></h3><p>This operation causes the Server to reply with the <a href="#sessionData"><code>language</code></a> message - the language that is used by default for session operation with scripts or WSSP templates.</p><h3 id="setLanguage" tabindex="-1">setLanguage <a class="header-anchor" href="#setLanguage" aria-label="Permalink to &quot;setLanguage {#setLanguage}&quot;">​</a></h3><p>This operation modifies the default language to be used in the session for operation with scripts and WSSP templates.</p><p>Attributes:</p><ul><li><p><code>language</code></p><p>the name of the language.</p></li></ul><p>The Server can send the following service data messages at any time:</p><h5 id="alert" tabindex="-1">alert <a class="header-anchor" href="#alert" aria-label="Permalink to &quot;alert {#alert}&quot;">​</a></h5><p>The authenticated account has received an <a href="./../admin/sysadmin/Alerts.html">Alert</a>. As soon as the Server sends the Alert data message to the Client, the Alert message is marked as &quot;confirmed&quot;.</p><p>Attributes:</p><ul><li><p><code>gmtTime</code></p><p>the time when the Alert was posted (GMT).</p></li><li><p><code>localTime</code></p><p>the time when the Alert was posted (in the selected time zone).</p></li><li><p>Body:</p><p>the Alert text (in the UTF-8 encoding).</p></li></ul><h5 id="byeRet" tabindex="-1">bye <a class="header-anchor" href="#byeRet" aria-label="Permalink to &quot;bye {#byeRet}&quot;">​</a></h5><p>The Server has decided to close a session (time-out, administrator action, etc.)<br> The client is supposed to close its Server connection (if it has one), and to inform the user.</p><h5 id="newUploaded" tabindex="-1">newUploaded <a class="header-anchor" href="#newUploaded" aria-label="Permalink to &quot;newUploaded {#newUploaded}&quot;">​</a></h5><p>A new file has been added to the session <a href="#FileUpload">&quot;uploaded file set&quot;</a>.</p><p>Attributes:</p><ul><li><p><code>uploadID</code></p><p>a string identifying the file in the &quot;uploaded file set&quot;.</p></li></ul><h5 id="mailboxModified" tabindex="-1">mailboxModified <a class="header-anchor" href="#mailboxModified" aria-label="Permalink to &quot;mailboxModified {#mailboxModified}&quot;">​</a></h5><p>Some of the current Account mailboxes has been modified. These messages are sent only if the session option <a href="#reportMailboxChanges">reportMailboxChanges</a> value was set to yes.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the modified mailbox name.</p></li></ul><h5 id="sessionData" tabindex="-1">session <a class="header-anchor" href="#sessionData" aria-label="Permalink to &quot;session {#sessionData}&quot;">​</a></h5><p>The Server sends this message in response to the <a href="#gretSessionData"><code>getSessionData</code></a> command.<br> It contains the XML-representation of the requested custom session parameters dictionary.</p><h5 id="sessionDataModified" tabindex="-1">sessionDataModified <a class="header-anchor" href="#sessionDataModified" aria-label="Permalink to &quot;sessionDataModified {#sessionDataModified}&quot;">​</a></h5><p>The Server sends this message when the dictionary with custom session parameters has been modified externally.</p><p>The Server can send the following data messages:</p><h5 id="uploadedFile" tabindex="-1">uploadedFile <a class="header-anchor" href="#uploadedFile" aria-label="Permalink to &quot;uploadedFile {#uploadedFile}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#listUploaded"><code>listUploaded</code></a> request.</p><p>Attributes:</p><ul><li><p><code>uploadID</code></p><p>a string identifying a file in the &quot;uploaded file set&quot;.</p></li><li><p><code>fileName</code></p><p>the uploaded file name (optional)</p></li><li><p><code>size</code></p><p>the uploaded file size</p></li><li><p><code>type</code></p><p>the uploaded file Content type</p></li><li><p><code>subtype</code></p><p>the uploaded file Content subtype (optional)</p></li><li><p><code>charset</code></p><p>the uploaded file Content charset (optional)</p></li></ul><h5 id="strings" tabindex="-1">strings <a class="header-anchor" href="#strings" aria-label="Permalink to &quot;strings {#strings}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#readStrings"><code>readStrings</code></a> request.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name.</p></li><li><p><code>language</code></p><p>the selected language.</p></li><li><p><code>timeModified</code></p><p>the vocabulary modification date and time (GMT time).</p></li></ul><p>Body:</p><p>a set of <code>string</code> and <code>strings</code> XML elements. Each element has the <code>name</code> attribute - the name (or &quot;key&quot;) of the vocabulary element.<br> String-type vocabulary elements are presented using <code>string</code> elements. The <code>string</code> element body is the vocabulary element value.<br> Dictionary-type vocabulary elements are presented using <code>strings</code> elements. The <code>strings</code> element body is the set of <code>string</code> XML elements.<br> Array-type vocabulary elements are presented using <code>strings</code> elements. The <code>strings</code> element body is the set of <code>string</code> XML elements without the <code>name</code> attribute.Example:<br> The Client reads the default (english) vocabulary.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">readStrings</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> language</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;AppendButton&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Append&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;AppendModes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;simple&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Simple Mode&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;advanced&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Advanced Mode&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;KnownFields&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;From&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Subject&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">string</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">strings</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h5 id="configFile" tabindex="-1">configFile <a class="header-anchor" href="#configFile" aria-label="Permalink to &quot;configFile {#configFile}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#readConfigFile"><code>readConfigFile</code></a> request.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name.</p></li><li><p><code>name</code></p><p>the configuration name.</p></li><li><p><code>timeModified</code></p><p>the configuration modification date and time (GMT time).</p></li><li><p>Body:</p></li></ul><p>the <code>config</code> XML element.</p><h5 id="currentTime" tabindex="-1">currentTime <a class="header-anchor" href="#currentTime" aria-label="Permalink to &quot;currentTime {#currentTime}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#readTime"><code>readTime</code></a> request.</p><p>Attributes:</p><ul><li><p><code>gmtTime</code></p><p>the current Server time (GMT).</p></li><li><p><code>localTime</code></p></li></ul><p>the current Server time (in the selected time zone).</p><h5 id="currentStatus" tabindex="-1">currentStatus <a class="header-anchor" href="#currentStatus" aria-label="Permalink to &quot;currentStatus {#currentStatus}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#readStatus"><code>readStatus</code></a> request.</p><ul><li><p>Body:</p><p>a set of XML elements:</p><ul><li><p><code>messageStore</code></p><p>The information about the Account Message Storage.</p><p>Attributes:</p><ul><li><p><code>used</code></p><p>the currently used storage (in bytes).</p></li><li><p><code>limit</code></p><p>the storage quota. This attribute is absent if the quota is set to Unlimited.</p></li></ul></li><li><p><code>fileStore</code></p><p>The information about the Account File Storage.</p><p>Attributes:</p><ul><li><p><code>limit</code></p><p>the file storage quota. This attribute is absent if the quota is set to Unlimited.</p></li><li><p><code>fileSizeLimit</code></p><p>the file size quota. This attribute is absent if the quota is set to Unlimited.</p></li><li><p><code>fileLimit</code></p><p>the quota on the number of all files. This attribute is absent if the quota is set to Unlimited.</p></li></ul></li><li><p><code>PrevLogin</code></p><p>The information about the previous successful login.</p><p>Attributes:</p><ul><li><p><code>gmtTime</code></p><p>the login time (GMT).</p></li><li><p><code>localTime</code></p><p>the login time (in the selected time zone).</p></li><li><p><code>ip</code></p><p>the network address from which the user logged in.</p></li></ul></li><li><p><code>LastFailedLogin</code></p><p>The information about the last failed login.</p><p>Attributes:</p><ul><li><p><code>gmtTime</code></p><p>the time of the last failed login attempt (GMT).</p></li><li><p><code>localTime</code></p><p>the time of the last failed login attempt (in the selected time zone).</p></li><li><p><code>ip</code></p><p>the network address from which the failed attempt to log in was made.</p></li></ul></li><li><p><code>RulesAllowed</code>, <code>SignalRulesAllowed</code>, <code>RPOPAllowed</code>, <code>RSIPAllowed</code>, <code>PWDAllowed</code>, <code>PasswordRecovery</code>, <code>EncryptedMailboxesAllowed</code></p><p>The effective Account settings data. These elements do not have attributes, and their text body is the setting value.</p></li><li><p><code>option</code></p><p>zero, one, or several XML elements. The element body is a string, specifying an option enabled for the current Account:</p><ul><li><p><code>S/MIME</code></p><p>Secure Mail services are enabled.</p></li><li><p><code>SMIMEActive</code></p><p>Secure Mail services are unlocked.</p></li><li><p><code>SMIMEInactive</code></p><p>Secure Mail services are locked (but the Account does have a Private PKI key).</p></li><li><p><code>WebCAL</code></p><p>Calendaring services are enabled.</p></li><li><p><code>WebSite</code></p><p>Web access to File Storage is enabled.</p></li><li><p><code>Signal</code></p><p>Signaling services are enabled.</p></li><li><p><code>PBX</code></p><p>PBX services are enabled.</p></li><li><p><code>HTTP</code></p><p>HTTP transaction Services are enabled.</p></li></ul></li><li><p><code>signalBind</code></p><p>The information about the session Real-Time parameters.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the &quot;clientID&quot; name assigned to this session.</p></li></ul></li><li><p><code>hiddenModules</code></p><p>Comma-separated list of disabled client modules.</p></li><li><p><code>timeout</code></p><p>The information about the session time-out parameters.</p><p>Attributes:</p><ul><li><p><code>limit</code></p><p>the session time limit, in seconds.</p></li><li><p><code>idle</code></p><p>optional; the idle time-out, in seconds. If this attribute is not present, idle time-outs for this session are disabled.</p></li></ul></li></ul></li></ul><h5 id="knownValues" tabindex="-1">knownValues <a class="header-anchor" href="#knownValues" aria-label="Permalink to &quot;knownValues {#knownValues}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#listKnownValues"><code>listKnownValues</code></a> request.</p><ul><li><p>Body:</p><p>a set of XML elements:</p><ul><li><p><code>tzid</code></p><p>the element <code>name</code> attribute specifies a known Time Zone name;</p></li><li><p><code>charset</code></p><p>the element <code>name</code> attribute specifies a known character set name;</p></li><li><p><code>mailRuleAllowed</code></p><p>the element <code>name</code> attribute specifies a supported Allowed Mail Rule mode. Each mode defines which Mail Rule actions the user is allowed to modify; Elements are sorted, with the &quot;most restrictive&quot; mode listed first.</p></li><li><p><code>mailRuleCondition</code></p><p>the element <code>name</code> attribute specifies a supported Mail Rule condition.</p></li><li><p><code>mailRuleAction</code></p><p>the element <code>name</code> attribute specifies a supported Mail Rule action; the element <code>allowedSet</code> attribute specifies the enabling Allowed Mail Rule name. The user can modify a Rule containing this operation only if the user Account <code>RulesAllowed</code> setting value is the specified or a less restrictive Allowed Mail Rule mode.</p></li><li><p><code>signalRuleAllowed</code>, <code>signalRuleCondition</code>, <code>signalRuleAction</code></p><p>the same elements as the <code>mailRuleAllowed</code>, <code>mailRuleCondition</code>, <code>mailRuleAction</code> elements, but for the Signal Rules.</p></li><li><p><code>safeSchema</code></p><p>the element <code>name</code> attribute specifies a URL schema that can be considered safe in mail content.</p></li><li><p><code>webAccessURL</code></p><p>the element <code>name</code> attribute specifies the preferred URL (schema, host, port) for accessing web services of the domain.</p></li></ul></li></ul><h5 id="skinInfo" tabindex="-1">skinInfo <a class="header-anchor" href="#skinInfo" aria-label="Permalink to &quot;skinInfo {#skinInfo}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#skinList"><code>skinList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name.</p></li></ul><h5 id="skinFileInfo" tabindex="-1">skinFileInfo <a class="header-anchor" href="#skinFileInfo" aria-label="Permalink to &quot;skinFileInfo {#skinFileInfo}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#skinFileList"><code>skinFileList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>skinName</code></p><p>the Skin name.</p></li><li><p><code>fileName</code></p><p>the file name.</p></li><li><p><code>size</code></p><p>the file size in bytes.</p></li><li><p><code>timeModified</code></p><p>an optional attribute with the file modification date and time (local time).</p></li></ul><h5 id="skinFileData" tabindex="-1">skinFileData <a class="header-anchor" href="#skinFileData" aria-label="Permalink to &quot;skinFileData {#skinFileData}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#skinFileRead"><code>skinFileRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of read file.</p></li><li><p><code>timeModified</code></p><p>the file modification date and time (local time).</p></li><li><p>Body:</p></li></ul><p>Either a text with file data, or the <code>base64</code> element. The text body of this XML element is base64-encoded file data (base64 encoding allows you to retrieve binary data).</p><h5 id="cliResult" tabindex="-1">cliResult <a class="header-anchor" href="#cliResult" aria-label="Permalink to &quot;cliResult {#cliResult}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#cliExecute"><code>cliExecute</code></a> request.</p><ul><li><p>Body:</p><p>text or XML presentation of the CLI command output.Example:<br> The Client reads some Account aliases.</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliExecute</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;GETACCOUNTALIASES user@domain.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliExecute</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliResult</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;(alias1,alias2)&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliResult</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliExecute</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> report</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;xml&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;GETACCOUNTALIASES user@domain.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliExecute</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliResult</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;alias1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;alias2&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cliResult</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h5 id="retrievedXML" tabindex="-1">retrievedXML <a class="header-anchor" href="#retrievedXML" aria-label="Permalink to &quot;retrievedXML {#retrievedXML}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#retrieveXML"><code>retrieveXML</code></a> request.</p><p>Attributes:</p><ul><li><p><code>url</code></p><p>the document URL.</p></li><li><p>Body:</p></li></ul><p>one XML element with the retrieved document.</p><h5 id="retrievedURL" tabindex="-1">retrievedURL <a class="header-anchor" href="#retrievedURL" aria-label="Permalink to &quot;retrievedURL {#retrievedURL}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#httpCall"><code>httpCall</code></a> request.</p><p>Attributes:</p><ul><li><p><code>url</code></p><p>the document URL.</p></li><li><p><code>other attributes</code></p><p>the elements of the result dictionary returned with the HTTP Client module (excluding the <code>body</code> element).</p></li><li><p>Body:</p></li></ul><p>the <code>body</code> element of the result dictionary:</p><ul><li><p>the element is a string</p><p>the text body containing this string</p></li><li><p>the element is a datablock</p><p>a <code>base64</code> XML element containing base64-encoded datablock data</p></li><li><p>the element is an XML Object</p><p>the XML Object</p></li></ul><h5 id="speller" tabindex="-1">speller <a class="header-anchor" href="#speller" aria-label="Permalink to &quot;speller {#speller}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#spellerList"><code>spellerList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>speller</code></p><p>the spell checker name; usually - the language name or the dialect name (such as English-US or French-CA).</p></li></ul><h5 id="spellerReport" tabindex="-1">spellerReport <a class="header-anchor" href="#spellerReport" aria-label="Permalink to &quot;spellerReport {#spellerReport}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#spellerCheck"><code>spellerCheck</code></a> request and detects a spelling error.</p><p>Attributes:</p><ul><li><p><code>position</code></p><p>the misspelled word position in the supplied text.</p></li><li><p><code>size</code></p><p>the misspelled word size in the supplied text (in bytes).</p></li></ul><p>Body:</p><p>zero, one, or more <code>guess</code> XML elements. The text body of each element is a suggested replacement for the misspelled word.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The supplied text is XML-decoded first, and the attributes specify the word position and size in the resulting decoded text (which must use UTF-8 character set).</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The position and size specify either bytes or symbols, depending on the request <code>mode</code> attribute value.</p></div><h2 id="Mailboxes" tabindex="-1">Mailbox Management <a class="header-anchor" href="#Mailboxes" aria-label="Permalink to &quot;Mailbox Management {#Mailboxes}&quot;">​</a></h2><p>A client can use the following set of operations to manipulate Mailboxes in the authenticated Account, as well as in other Accounts (by specifying the full Mailbox name as <code>~accountName@domainName/mailboxName</code>).</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All non-ASCII Mailbox names are specified using the UTF-8 charset (and not the IMAP UTF-7 encoding method).</p></div><h3 id="mailboxCreate" tabindex="-1">mailboxCreate <a class="header-anchor" href="#mailboxCreate" aria-label="Permalink to &quot;mailboxCreate {#mailboxCreate}&quot;">​</a></h3><p>This operation creates a new <a href="./../admin/storage/Mailboxes.html">Mailbox</a>.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>this attribute specifies the new Mailbox name.</p></li><li><p><code>mailboxClass</code></p><p>this optional attribute specifies the Mailbox class.</p></li></ul><h3 id="mailboxRename" tabindex="-1">mailboxRename <a class="header-anchor" href="#mailboxRename" aria-label="Permalink to &quot;mailboxRename {#mailboxRename}&quot;">​</a></h3><p>This operation renames a <a href="./../admin/storage/Mailboxes.html">Mailbox</a>.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>this attribute specifies the existing Mailbox name.</p></li><li><p><code>newName</code></p><p>this attribute specifies the new Mailbox name.</p></li><li><p><code>children</code></p><p>if this optional attribute is present, all Mailbox &quot;children&quot; (nested Mailboxes) are renamed, too.</p></li></ul><h3 id="mailboxRemove" tabindex="-1">mailboxRemove <a class="header-anchor" href="#mailboxRemove" aria-label="Permalink to &quot;mailboxRemove {#mailboxRemove}&quot;">​</a></h3><p>This operation removes a <a href="./../admin/storage/Mailboxes.html">Mailbox</a>.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>an existing Mailbox name.</p></li><li><p><code>children</code></p><p>if this optional attribute is present, all Mailbox &quot;children&quot; (nested Mailboxes) are removed, too.</p></li></ul><h3 id="mailboxList" tabindex="-1">mailboxList <a class="header-anchor" href="#mailboxList" aria-label="Permalink to &quot;mailboxList {#mailboxList}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#mailbox"><code>mailbox</code></a> data message (see below) for each <em>visible</em> Mailbox (the Mailboxes for which the authenticated Account has the <a href="./../admin/storage/Mailboxes.html#ACL">lookup</a> access right).</p><p>Attributes:</p><ul><li><p><code>filter</code></p><p>this optional attribute specifies the filter string in the IMAP protocol format.</p></li><li><p><code>mailboxClass</code></p><p>if this optional attribute is specified, only the Mailboxes of the specified class are listed. Specify an empty string value to list only &quot;mail&quot;-class Mailboxes.</p></li><li><p><code>pureFolder</code></p><p>if this optional attribute exists, and its value is yes, then the result includes &quot;pure&quot; folders, if the value is no, &quot;pure&quot; folders are not included.<br> See the <a href="#mailbox"><code>mailbox</code></a> data message description for the details.</p></li></ul><h3 id="mailboxSubList" tabindex="-1">mailboxSubList <a class="header-anchor" href="#mailboxSubList" aria-label="Permalink to &quot;mailboxSubList {#mailboxSubList}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#mailboxSubscription"><code>mailboxSubscription</code></a> data message (see below) for each element in the Account <em>mailbox subscription</em> set. Note that Mailboxes in this set may or may not exist.</p><p>Attributes:</p><ul><li><p><code>filter</code></p><p>this optional attribute specifies the filter string in the IMAP protocol format.</p></li></ul><h3 id="mailboxSubUpdate" tabindex="-1">mailboxSubUpdate <a class="header-anchor" href="#mailboxSubUpdate" aria-label="Permalink to &quot;mailboxSubUpdate {#mailboxSubUpdate}&quot;">​</a></h3><p>This operation modifies Account <em>mailbox subscription</em> set.</p><p>Body:</p><p>a set of <code>mailboxSubscription</code> elements.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>a Mailbox name in the UTF-8 character set.</p></li><li><p><code>mode</code></p><p>if this attribute value is add the <code>mailbox</code> name is added to the <em>Mailbox subscription</em> set (unless the set already contains this name).<br> otherwise, the <code>mailbox</code> name is removed from the <em>mailbox subscription</em> set.</p></li></ul><h3 id="mailboxAliasList" tabindex="-1">mailboxAliasList <a class="header-anchor" href="#mailboxAliasList" aria-label="Permalink to &quot;mailboxAliasList {#mailboxAliasList}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#mailboxAlias"><code>mailboxAlias</code></a> data message (see below) for each <a href="./../admin/storage/Mailboxes.html#Aliases">Mailbox Alias</a> in the current Account.</p><h3 id="mailboxAliasUpdate" tabindex="-1">mailboxAliasUpdate <a class="header-anchor" href="#mailboxAliasUpdate" aria-label="Permalink to &quot;mailboxAliasUpdate {#mailboxAliasUpdate}&quot;">​</a></h3><p>This operation modifies the Account <em>Mailbox Aliases</em> set.</p><p>Body:</p><p>a set of <code>mailboxAlias</code> elements.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the Mailbox Alias name in the UTF-8 character set.</p></li><li><p><code>mode</code></p><p>if this attribute value is add the <code>name</code> Alias is added to the <em>Mailbox Aliases</em> set. If the set already contains an Alias with this name, it is replaced.<br> otherwise, the <code>name</code> Alias is removed from the <em>Mailbox Aliases</em> set.</p></li></ul><p>Body:</p><p>a string: the target Mailbox name in the UTF-8 character set.</p><h3 id="mailboxRightsGet" tabindex="-1">mailboxRightsGet <a class="header-anchor" href="#mailboxRightsGet" aria-label="Permalink to &quot;mailboxRightsGet {#mailboxRightsGet}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#mailboxRights"><code>mailboxRights</code></a> data message (see below) with the user access rights for the specified Mailbox.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>an existing Mailbox name.</p></li></ul><h3 id="mailboxACLList" tabindex="-1">mailboxACLList <a class="header-anchor" href="#mailboxACLList" aria-label="Permalink to &quot;mailboxACLList {#mailboxACLList}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#mailboxACL"><code>mailboxACL</code></a> data message (see below) with the <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Control List</a> data.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>an existing Mailbox name.</p></li></ul><h3 id="mailboxACLUpdate" tabindex="-1">mailboxACLUpdate <a class="header-anchor" href="#mailboxACLUpdate" aria-label="Permalink to &quot;mailboxACLUpdate {#mailboxACLUpdate}&quot;">​</a></h3><p>This operation modifies the <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Control List</a> for the specified Mailbox.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>an existing Mailbox name.</p></li><li><p>Body:</p></li></ul><p>A set of <code>aclElem</code> XML elements:</p><p>Attributes:</p><ul><li><p><code>pattern</code></p><p>the ACL element &quot;name&quot;. It can be an Account name, a name with &quot;+&quot; or &quot;-&quot; prefix, etc. See the <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Control Lists</a> section for more details.</p></li><li><p><code>mode</code></p><p>if this optional attribute value is add, the specified rights are added to the right set already specified for this ACL element. If the ACL element did not exist, it is created.<br> if this optional attribute value is sub, the specified rights are removed from the right set specified for this ACL element.<br> if this optional attribute value is clear, this ACL element is removed.<br> if this optional attribute has any other value, or if this attribute is absent, the specified rights replace the right set already specified for this ACL element. If the ACL element did not exist, it is created.</p></li><li><p>Body:</p><p>a string; each symbol specifies a <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Right</a>.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="mailbox" tabindex="-1">mailbox <a class="header-anchor" href="#mailbox" aria-label="Permalink to &quot;mailbox {#mailbox}&quot;">​</a></h5><p>These synchronous data messages are sent when the Server processes the <a href="#mailboxList"><code>mailboxList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the Mailbox name in the UTF-8 character set.</p></li><li><p><code>UIDVALIDITY</code>, <code>MESSAGES</code>, <code>UIDNEXT</code>, <code>UNSEEN</code>, <code>OLDEST</code>, <code>CLASS</code>, <code>MEDIA</code>, <code>UNSEENMEDIA</code></p><p>standard and extended <a href="./../admin/access/IMAP.html">IMAP</a> Mailbox attributes</p></li><li><p><code>SIZE</code></p><p>Mailbox size (internal, same as INTERNALSIZE in IMAP).</p></li><li><p><code>pureFolder</code></p><p>this attribute exists and it has the yes value if the Mailbox is a pure folder - i.e. it cannot contain messages, but it can contain sub-Mailboxes.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>A Mailbox is seen as a pure folder if it can contain messages, but the Mailbox class does not match the class specified in the <a href="#mailboxList"><code>mailboxList</code></a> request.</p></div></li><li><p><code>isFolder</code></p><p>this attribute exists and it has the yes value if the Mailbox is a mailbox and a folder - i.e. it can contain messages, and it can contain sub-Mailboxes.</p></li><li><p><code>rights</code></p><p>the effective access rights for the Mailbox. If this attribute is absent, access to the Mailbox is not restricted.</p></li></ul><h5 id="mailboxSubscription" tabindex="-1">mailboxSubscription <a class="header-anchor" href="#mailboxSubscription" aria-label="Permalink to &quot;mailboxSubscription {#mailboxSubscription}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#mailboxSubList"><code>mailboxSubList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the Mailbox name in the UTF-8 character set.</p></li></ul><h5 id="mailboxAlias" tabindex="-1">mailboxAlias <a class="header-anchor" href="#mailboxAlias" aria-label="Permalink to &quot;mailboxAlias {#mailboxAlias}&quot;">​</a></h5><p>These messages are sent when the Server processes the <a href="#mailboxSubList"><code>mailboxSubList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the Mailbox Alias name in the UTF-8 character set.</p></li><li><p>Body:</p></li></ul><p>a string; the target Mailbox name in the UTF-8 character set.</p><h5 id="mailboxRights" tabindex="-1">mailboxRights <a class="header-anchor" href="#mailboxRights" aria-label="Permalink to &quot;mailboxRights {#mailboxRights}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#mailboxRightsGet"><code>mailboxRightsGet</code></a> request.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the Mailbox name.</p></li><li><p>Body:</p></li></ul><p>a string; each symbol specifies an effective <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Right</a> granted to the current user.</p><h5 id="mailboxACL" tabindex="-1">mailboxACL <a class="header-anchor" href="#mailboxACL" aria-label="Permalink to &quot;mailboxACL {#mailboxACL}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#mailboxACLList"><code>mailboxACLList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the Mailbox name.</p></li><li><p>Body:</p></li></ul><p>A set of <code>aclElem</code> XML elements, one element for each Mailbox Access Control List element:</p><p>Attributes:</p><ul><li><p><code>pattern</code></p><p>the ACL element &quot;name&quot;. It can be an Account name, a name with &quot;+&quot; or &quot;-&quot; prefix, etc. See the <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Control Lists</a> section for more details.</p></li><li><p>Body:</p><p>a string; each symbol specifies a <a href="./../admin/storage/Mailboxes.html#ACL">Mailbox Access Right</a> granted to or revoked from the &quot;name&quot;.Example:</p></li><li><p>A001: the Client asks the Server to create the <code>MyNotes</code> Notes-type Mailbox.</p></li><li><p>A002: the Client asks the Server to rename the <code>MyNotes</code> Mailbox into <code>SharedNotes</code>.</p></li><li><p>A003: the Client asks the Server to grant the Lookup and Select rights for the <code>SharedNotes</code> Mailbox to users <code>user1</code> and <code>user2</code>.</p></li><li><p>A004: the Client asks the Server to add the Delete and Insert rights for the <code>SharedNotes</code> Mailbox to user <code>user1</code> and to revoke the Select right from the user <code>user2</code>.</p></li><li><p>A005: the Client asks the Server to retrieve the ACL data for the <code>SharedNotes</code> Mailbox.</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxCreate</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;MyNotes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailboxClass</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;IPF.StickyNote&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxRename</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;MyNotes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> newName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SharedNotes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACLUpdate</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SharedNotes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;lr&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;lr&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACLUpdate</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACLUpdate</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SharedNotes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;add&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;di&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sub&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;r&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACLUpdate</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACLList</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SharedNotes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACL</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SharedNotes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;lrdi&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> pattern</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;user2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;l&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">aclElem</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">mailboxACL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h2 id="Mailbox" tabindex="-1">Mailbox Operations <a class="header-anchor" href="#Mailbox" aria-label="Permalink to &quot;Mailbox Operations {#Mailbox}&quot;">​</a></h2><p>A client can use the following operations to process a Mailbox in the authenticated Account, as well as in other Accounts (by specifying the full Mailbox name as <code>~accountName@domainName/mailboxName</code>).</p><h3 id="folderOpen" tabindex="-1">folderOpen <a class="header-anchor" href="#folderOpen" aria-label="Permalink to &quot;folderOpen {#folderOpen}&quot;">​</a></h3><p>This operation opens the specified Mailbox as a &quot;Folder&quot;.<br> A Folder represents a Server Mailbox, with all messages being sorted and, optionally, filtered.<br> Each folder has a name, and one session cannot have two folders with the same name. On the other hand, the same session can open the same Mailbox as two different folders (with different names). For example, an application may use one folder to show the Mailbox content sorted by the Date field, while maintaining a separate window where it shows the same Mailbox, but only the messages containing the <code>Business</code> tag in the Keywords field, with all these messages sorted by the From field.<br> When Mailbox messages are added, removed, or updated, the Server reports these updates to all clients that have opened that Mailbox as a Folder.<br> Each folder sends its update notifications independently, so the client does not need to know that two folders are presenting different views on the same Server Mailbox.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the name for the new Folder to be opened. A client can use an arbitrary string as a Folder name.</p></li><li><p><code>mailbox</code></p><p>the Mailbox name. If this attribute is not specified, the folder name is used.</p></li><li><p><code>mailboxClass</code></p><p>an optional attribute. If the specified Mailbox does not exist and this optional attribute is specified, the specified Mailbox is created.<br> If this attribute value is a non-empty string, that value is assigned as the <a href="./../admin/storage/Mailboxes.html#Classes">Mailbox Class</a> to the newly created Mailbox.</p></li><li><p><code>sortField</code></p><p>the name of a message header field to use for Mailbox sorting.</p></li><li><p><code>sortOrder</code></p><p>if this optional attribute is specified and it has the <code>desc</code> value, the sorting order is reversed.</p></li><li><p><code>filter</code></p><p>if this optional attribute is specified, only the Mailbox messages matching this attribute value are included into the Folder.</p></li><li><p><code>filterField</code></p><p>if this optional attribute is specified, its value specifies the message header field to compare with the filter attribute. Only the messages containing the specified field and with the field value matching the filter attribute value are included into the folder.<br> If this attribute value is FLAGS, the <code>filter</code> attribute value should contain a comma-separated list of <a href="./../admin/storage/Mailboxes.html#Flags">message flags names and/or negative names</a>. Only the messages with the specified flags set and the specified negative flags not set are included into the Server view.<br> For example, the <code>filter=&quot;Media,Unseen&quot;</code> attribute will tell the Server to build a view using only the messages with the <code>Media</code> flags set and the <code>Seen</code> flag not set.<br> If this attribute value is body, messages containing the filter attribute value in any message body part are included into the server view.<br> If this attribute is missing, messages containing the filter attribute value in message body part, or in any message header field are included into the server view.</p></li><li><p><code>hideDeleted</code></p><p>If this optional attribute is present, the &quot;hide deleted&quot; folder mode is switched on if the attribute value is yes. If this optional attribute is absent, the &quot;hide deleted&quot; folder mode is switched on if the current effective value of the DeleteMode Account Preference is not Mark.<br> When the &quot;hide deleted&quot; mode is on, a mailbox message is removed from the folder list as soon as the &quot;Deleted&quot; flag is assigned to it. If the &quot;Deleted&quot; flag is removed later, the message does not re-appear in the folder, but it will become visible again after the folder is re-opened.</p></li><li><p><code>UIDValidity</code>, <code>UIDMin</code></p><p>If these optional numeric attributes are present, and the Folder Mailbox UIDValidity value is equal to the UIDValidity request attribute value, then only the messages with UID not smaller than the UIDMin value are included into the Folder.</p></li></ul><p>Body:</p><p>the request body should contain one or more <code>&lt;field&gt;</code> elements.<br> Each element body should contain a name of a header field to be retrieved for each message.<br> These fields are called <em>viewer fields</em>.<br> The following <code>sortField</code> and <em>viewer fields</em> can be specified:</p><ul><li><code>From</code>, <code>To</code>, <code>Cc</code>, <code>Bcc</code>, <code>Reply-To</code>, <code>Sender</code>, <code>Return-Path</code>, or other <em>Email-field</em> name. If a message header contains the specified <em>Email-field</em>, it is parsed. If the field contains a &quot;comment&quot; (i.e. a &quot;real name&quot;), it is used. Otherwise, the parsed E-mail address is used.</li><li><code>Date</code>, <code>Resent-Date</code>. The field date value is converted to GMT. When elements with these field values are sent within a <code>folderReport</code> message, they contain the <code>localTime</code> attribute specifying the field value in the Time Zone selected for the current user.</li><li>any other E-mail header field name (<code>Subject</code>, <code>X-Mailer</code>, etc). The field MIME-decoded value is used.</li><li><code>E-From</code>, <code>E-To</code>, or other <code>E-Email-field</code> name. If a message header contains the specified <em>Email-field</em>, it is parsed, and the parsed E-mail address is used.</li><li><code>Pty</code>. The <code>X-Priority</code> field value is converted to the strings High, Low, or to an empty string.</li><li><code>UID</code>. The message metadata - its UID (unique ID) in the Mailbox.</li><li><code>ORIGUID</code>. The message metadata - its original UID in the Mailbox. Unless the message is an updated version of some older (and now deleted) message, the ORIGUID value is the same as the UID value.</li><li><code>SIZE</code>. The message metadata - its &quot;raw&quot; size in the Mailbox.</li><li><code>INTERNALDATE</code>. The message metadata - its &quot;timestamp&quot;. It is formatted in the same way as the <code>Date</code> element.</li><li><code>FLAGS</code> the message metadata attribute values are used.<br> See the <a href="./../admin/storage/Mailboxes.html#Flags">Mailboxes</a> section for more information on the Mailbox message flags.</li></ul><p>A session can use several open Folders at the same time.</p><p>A client should maintain an <em>internal view</em> of the Folder - an array or a table with one element for each Folder message. A client should keep that view synchronized with the Server view (implemented with that Folder).</p><p>When a Folder is opened, the Server sends a <a href="#folderReport"><code>folderReport</code></a> data message containing the total number of messages in the Folder. The client uses this number to create the initial internal view table, filling it with empty elements.</p><p>To display the Mailbox content on the screen, the client checks which elements of its internal view table it should use. If some of those elements are empty, the client should ask the Server to send it the information about the Folder messages specified by their index values (positions) in the sorted view (in the Folder).</p><p>Some Mailbox operations use a <em>message set</em> to specify the Mailbox messages to apply the operation to. Messages can be specified either by their UIDs, or by their index numbers (their positions in the folder view).</p><p>To specify messages by their UIDs, use one or more <code>UID</code> elements.<br> Each <code>UID</code> element can include one message, in this case the message UID is specified as the element body: <code>&lt;UID&gt;12377&lt;/UID&gt;</code>.<br> An <code>UID</code> element can include a range of message UIDs specified as the <code>from</code> and <code>till</code> attributes: <code>&lt;UID from=&quot;12377&quot; till=&quot;12455&quot; /&gt;</code>. The operation is applied to all Mailbox messages with UIDs not smaller than the <code>from</code> attribute value and not larger than the <code>till</code> attribute value. Please remember that Folder messages are not sorted by their UIDs, unless the <code>sortField=&quot;UID&quot;</code> attribute was used in the <a href="#folderOpen"><code>folderOpen</code></a> operation.</p><p>To specify messages by index, use one or more <code>index</code> elements.<br> Each <code>index</code> element can include one message, in this case the message index is specified as the element body: <code>&lt;index&gt;14&lt;/index&gt;</code>.<br> An <code>index</code> element can include an index range specified as the <code>from</code> and <code>till</code> attributes: <code>&lt;index from=&quot;12&quot; till=&quot;10000&quot; /&gt;</code>. The operation is applied to all Folder messages with position (index) not smaller than the <code>from</code> attribute value and not larger than the <code>till</code> attribute value.</p><p>A <em>message set</em> can include one or more <code>UID</code> elements, or it can include one or more <code>index</code> elements, but it cannot include both <code>UID</code> and <code>index</code> elements.</p><h3 id="folderBrowse" tabindex="-1">folderBrowse <a class="header-anchor" href="#folderBrowse" aria-label="Permalink to &quot;folderBrowse {#folderBrowse}&quot;">​</a></h3><p>This operation makes the Server send data messages for the specified message set in an open Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li></ul><p>Body:</p><p>a <em>message set</em> (see above).The Server sends a <a href="#folderReport"><code>folderReport</code></a> data message for each message with the index or UID in the specified set. The data message attributes specify the message index (position) in the Folder and the message UID.<br> The <a href="#folderReport"><code>folderReport</code></a> data message body contains the <code>viewer fields</code> values.</p><p>The &quot;on demand&quot; client-server synchronization model is used. When a Folder message is modified, added, or deleted, the client gets an asynchronous <a href="#folderReport"><code>folderReport</code></a> data message with the <code>mode</code> attribute value set to <code>notify</code> (a &quot;notify-mode&quot; message).</p><p>The newly added messages do not become visible in the logical Folder and the deleted messages are not removed from the logical Folder. Requests to retrieve deleted message data return no data items or empty data items.</p><p>When the client application is ready to update its &quot;internal view&quot;, it should use the <a href="#folderSync"><code>folderSync</code></a> operation:</p><h3 id="folderSync" tabindex="-1">folderSync <a class="header-anchor" href="#folderSync" aria-label="Permalink to &quot;folderSync {#folderSync}&quot;">​</a></h3><p>This operation tells the Server to send all pending Folder modifications to the client.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>limit</code></p><p>optional; the maximum number of data messages to return.</p></li></ul><p>The Server sends <a href="#folderReport"><code>folderReport</code></a> data messages with the <code>mode</code> attribute set to the <code>removed</code>, <code>added</code>, <code>updated</code>, or <code>attrsUpdated</code> value.</p><p>After the Server sends a &quot;notify-mode&quot; message to the Client, the Server may choose not to send further &quot;notify-mode&quot; messages for this Folder until the client performs the <code>folderSync</code> operation on this Folder.</p><p>If the limit attribute is specified and the specified number of data message has been sent, the Server finishes the the <code>folderSync</code> operation, but expects the client to perform an additional <code>folderSync</code> operation on this Folder before it sends further &quot;notify-mode&quot; messages for this Folder.</p><p>The client can send requests to the Server asking for certain update operations (such as message deletion), but it should update its internal view only when the Server sends it a <a href="#folderReport"><code>folderReport</code></a> data message informing the client about actual changes in the Folder.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>Unlike UIDs, Folder message index can change any time when the <code>folderSync</code> operation is performed. Before you start any operation using an index-based message set, make sure that you have correctly updated the internal view with all <a href="#folderReport"><code>folderReport</code></a> data messages generated with the previously sent <a href="#folderSync"><code>folderSync</code></a> operation.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>When a message has been removed from or added to a Mailbox, the Server only sends <a href="#folderReport"><code>folderReport</code></a> data messages with the <code>mode=&quot;notify&quot;</code> attribute. The Server-side &quot;view&quot; of the modified Folder (the logical Folder) is not updated, and it is safe to use an index-based message set to start a Folder operation.</p></div><h3 id="folderSearch" tabindex="-1">folderSearch <a class="header-anchor" href="#folderSearch" aria-label="Permalink to &quot;folderSearch {#folderSearch}&quot;">​</a></h3><p>This operation searches messages in an open Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>filter</code></p><p>the search string as for IMAP <a href="https://tools.ietf.org/html/rfc3501#section-6.4.4" target="_blank" rel="noreferrer">SEARCH</a> command.</p></li><li><p><code>limit</code></p><p>optional; the maximum number of data messages to return.</p></li><li><p><code>timeout</code></p><p>optional; the operation time-out (in seconds). The maximum is 5.</p></li></ul><p>Body:</p><p>a <em>message set</em> (see above).</p><p>The Server sends <a href="#folderSearchResult"><code>folderSearchResult</code></a> data messages with the UIDs or indexes of the messages matching the search criteria. If the search did not complete due to timeout or result limit then the reply will contain <code>next</code> attribute with the message UID/index where to start the next search.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSearch</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> limit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;5&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeout</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> filter</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SINCE 1-Feb-2008 NOT FROM Smith OR SUBJECT test SUBJECT xxx&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> from</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> till</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSearch</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSearchResult</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> next</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;480&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;285&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;386&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;479&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSearchResult</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h3 id="mailboxSync" tabindex="-1">mailboxSync <a class="header-anchor" href="#mailboxSync" aria-label="Permalink to &quot;mailboxSync {#mailboxSync}&quot;">​</a></h3><p>This operation sends the report on modified items since the last synchronization.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>clientID</code></p><p>the string that identifies the client; for each such client the serer keeps the separate history of changes in the mailbox.</p></li><li><p><code>syncID</code></p><p>the string that identifies the last synchronization point; for the first synchronization run it should be set to &quot;0&quot;.</p></li><li><p><code>limit</code></p><p>optional; the maximum number of data messages to return.</p></li><li><p><code>timeFrom</code></p><p>optional; the time stamp for the oldest item to retrieve.</p></li><li><p><code>totalSizeLimit</code></p><p>optional; the maximum number of bytes for new message data to retrieve.</p></li></ul><p>The Server sends <a href="#mailboxSyncReport"><code>mailboxSyncReport</code></a> data messages that indicate the changes since the last synchronization.</p><h3 id="messageCopy" tabindex="-1">messageCopy <a class="header-anchor" href="#messageCopy" aria-label="Permalink to &quot;messageCopy {#messageCopy}&quot;">​</a></h3><p>This operation copies messages from an open Folder to a target Mailbox.<br> Note: the target is specified as a Mailbox, not as a Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the source Folder name.</p></li><li><p><code>targetMailbox</code></p><p>the target Mailbox name.</p></li><li><p><code>mailboxClass</code></p><p>If the target Mailbox does not exist and this optional attribute is specified, the target Mailbox is created. If this attribute value is a non-empty string, the value is assigned as the <a href="./../admin/storage/Mailboxes.html#Classes">Mailbox Class</a> to the newly created Mailbox.</p></li><li><p><code>encrypt</code></p><p>if this optional attribute exists, and its value is yes, the messages are copied encrypted, using the current user S/MIME certificate.</p></li><li><p><code>decrypt</code></p><p>if this optional attribute exists, and its value is yes, and the <code>encrypt</code> attribute is not specified, the messages are copied decrypted. The Account Private Key should be unlocked, otherwise an error is returned.</p></li><li><p><code>report</code></p><p>If this optional attribute is specified, it should have the <code>uid</code> value.<br> For each message copied to the target mailbox, the Server sends the synchronous <code>messageAdded</code> message containing the UID of the copied message.</p></li><li><p>Body:</p></li></ul><p>a <em>message set</em> (see above).</p><h3 id="messageMove" tabindex="-1">messageMove <a class="header-anchor" href="#messageMove" aria-label="Permalink to &quot;messageMove {#messageMove}&quot;">​</a></h3><p>This operation is the same as the <code>messageCopy</code> operation, but if the messages have been copied successfully, the operation deletes the original messages.</p><p>This operation can also be used to implement the &quot;encrypt/decrypt message&quot; functionality: the selected messages should be moved to the same Mailbox using the <code>encrypt</code> or <code>decrypt</code> operation attribute.</p><h3 id="messageMark" tabindex="-1">messageMark <a class="header-anchor" href="#messageMark" aria-label="Permalink to &quot;messageMark {#messageMark}&quot;">​</a></h3><p>This operation modifies <a href="./../admin/storage/Mailboxes.html#Flags">Mailbox message flags</a> in an open Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>flags</code></p><p>this attribute specifies the Mailbox message flags to add or delete. Several operations can be specified, separated with the comma symbol. See the <a href="./../admin/storage/Mailboxes.html#Flags">Mailbox</a> section for more details.</p></li><li><p><code>mode</code></p><p>an optional attribute. If specified and equals to <code>delete</code> then the specified flags are deleted (flags with negative names are not set).</p></li><li><p>Body:</p></li></ul><p>a <em>message set</em> (see above).</p><h3 id="messageRemove" tabindex="-1">messageRemove <a class="header-anchor" href="#messageRemove" aria-label="Permalink to &quot;messageRemove {#messageRemove}&quot;">​</a></h3><p>This operation removes messages from an open Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>mode</code></p><p>an optional attribute, specifying the delete operation method. If specified, it should have one of the following values:</p><ul><li>Immediately - the messages are physically removed from the Folder Mailbox.</li><li>Move To Trash - the messages are moved to the Trash Mailbox (its name is specified with the <code>TrashBox</code> Account preference). If the specified Folder is the Trash Mailbox itself, the messages are physically removed.</li><li>Mark - the messages are marked with the <em>Deleted</em> flag.</li></ul><p>If this attribute is not specified, the method specified with the DeleteMode Account Preference is used.</p></li><li><p>Body:</p></li></ul><p>a <em>message set</em> (see above).</p><h3 id="folderExpunge" tabindex="-1">folderExpunge <a class="header-anchor" href="#folderExpunge" aria-label="Permalink to &quot;folderExpunge {#folderExpunge}&quot;">​</a></h3><p>This operation removes all messages marked with the <code>Deleted</code> flag from the Folder Mailbox.<br> Note: it removes ALL marked Mailbox messages, not only the messages visible in this Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li></ul><h3 id="folderClose" tabindex="-1">folderClose <a class="header-anchor" href="#folderClose" aria-label="Permalink to &quot;folderClose {#folderClose}&quot;">​</a></h3><p>This operation closes an open Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li></ul><h3 id="folderReopen" tabindex="-1">folderReopen <a class="header-anchor" href="#folderReopen" aria-label="Permalink to &quot;folderReopen {#folderReopen}&quot;">​</a></h3><p>This operation re-builds an open Folder by re-scanning its Mailbox using different sorting and filtering parameters.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>sortField</code>, <code>sortOrder</code>, <code>filter</code>, <code>filterField</code>, <code>hideDeleted</code>, <code>UIDValidity</code>, <code>UIDMin</code></p><p>these attributes have the same meaning as the same <a href="#folderOpen"><code>folderOpen</code></a> operation attributes.</p></li></ul><p>Body:</p><p>if the request body contains at least one <code>&lt;field&gt;</code> element, these elements specify the new <em>viewer fields</em> set. If no <code>&lt;field&gt;</code> element is specified, the <em>viewer fields</em> set is not modified.</p><p>When a client uses this command, the Server sends the <code>folderReport</code> message with the <code>mode</code> attribute set to <code>init</code>, notifying the client about the new Folder size.<br> The client should clear its internal Folder view, and re-populate it again.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If a Client receives a <code>folderReport</code> message with the <code>mode</code> attribute set to <code>notify</code> when the Client has already sent the <code>folderReopen</code> command, the Client should use the <code>folderSync</code> command after it receives response for the <code>folderReopen</code> command.</p></div><h3 id="emptyTrash" tabindex="-1">emptyTrash <a class="header-anchor" href="#emptyTrash" aria-label="Permalink to &quot;emptyTrash {#emptyTrash}&quot;">​</a></h3><p>This operation physically removes all messages from the Trash Mailbox (if it has been specified).</p><h3 id="emptyMailbox" tabindex="-1">emptyMailbox <a class="header-anchor" href="#emptyMailbox" aria-label="Permalink to &quot;emptyMailbox {#emptyMailbox}&quot;">​</a></h3><p>This operation physically removes all messages from the specified mailbox.</p><p>Attributes:</p><ul><li><p><code>mailbox</code></p><p>the mailbox name.</p></li><li><p><code>duration</code></p><p>time limit (in &quot;time delta&quot; format) between the current time and the internal date of the newest message to keep in the mailbox. Specify 0 to delete all messages.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="folderReport" tabindex="-1">folderReport <a class="header-anchor" href="#folderReport" aria-label="Permalink to &quot;folderReport {#folderReport}&quot;">​</a></h5><p>These messages are sent synchronously when a Folder is being opened or re-opened, and when the client sends a <a href="#folderBrowse"><code>folderBrowse</code></a> or a <a href="#folderSync"><code>folderSync</code></a> request.<br> These messages are sent asynchronously when a Folder status changes (messages are added, removed, or updated), in this case its <code>mode</code> attribute is set to <code>notify</code>.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>mode</code></p><p>this optional attribute specifies the type of notification.</p><ul><li>If the attribute value is init then the <code>messages</code> attribute specifies the total number of messages in the Folder, and the <code>unseen</code> attribute specifies the total number of unseen messages (messages without the Seen flag) in the Folder.<br> This is a synchronous data message sent when a Folder is being opened or re-opened.</li><li>If the attribute value is notify some Mailbox messages have been added, modified, or deleted.<br> This message is sent as an asynchronous data message.<br> The client is expected to send the <a href="#folderSync"><code>folderSync</code></a> request for this Folder.</li><li>If the attribute value is removed then the <code>index</code> and <code>UID</code> attributes specify the message removed from the Folder.<br> This data message is sent only in response to the <a href="#folderSync"><code>folderSync</code></a> request.<br> The client should immediately update its internal view: for all messages with the index value larger than the specified <code>index</code> attribute value, the index value is decreased by 1.</li><li>If the attribute value is added then the <code>index</code> and <code>UID</code> attributes specify the message added to the Folder.<br> This data message is sent only in response to the <a href="#folderSync"><code>folderSync</code></a> request.<br> The client should immediately update its internal view: for all messages with the index value equal or larger than the specified <code>index</code> attribute value, the index value is increased by 1.</li><li>If the attribute value is updated, or attrsUpdated, or the attribute is missing, then the <code>index</code> and <code>UID</code> attributes specify a Mailbox message and the body contains the message <em>viewer field</em> values.</li></ul><p>This attribute is present and it is set to error when the <a href="#folderBrowse"><code>folderBrowse</code></a> request fails to retrieve the message data (for example, when a message has been already deleted, but it has not been removed from the view, because the <a href="#folderSync"><code>folderSync</code></a> request has not been issued yet.</p></li><li><p><code>index</code></p><p>the message index in this Folder.<br> This attribute is not present when the <code>mode</code> attribute value is init.</p></li><li><p><code>UID</code></p><p>the message UID (unique ID).<br> This attribute is not present when the <code>mode</code> attribute value is removed, updated, attrsUpdated, or added.</p></li><li><p><code>messages</code></p><p>the total number of messages in the Folder.<br> This attribute is present when the <code>mode</code> attribute value is init, removed, or added.</p></li><li><p><code>unseen</code></p><p>the total number of unseen messages in the Folder.<br> This attribute is present when the <code>mode</code> attribute value is init, removed, updated, attrsUpdated, or added.</p></li><li><p><code>rights</code></p><p>the effective access rights for the Folder.<br> This attribute is present when the <code>mode</code> attribute value is init. If this attribute is absent, access to the Folder is not restricted.</p></li><li><p><code>UIDValidity</code>, <code>UIDNext</code></p><p>the Folder Mailbox UIDValidity and UIDNext values.<br> These attributes are present when the <code>mode</code> attribute value is init.</p></li><li><p>Body:</p></li></ul><p>The body is present when the <code>mode</code> attribute value is absent (<a href="#folderBrowse"><code>folderBrowse</code></a> response message), or when the <code>mode</code> attribute value is updated, attrsUpdated, or added (<a href="#folderSync"><code>folderSync</code></a> response message).<br> The body contains a set of XML elements with <em>viewer field</em> values.</p><p>Example 1:</p><ul><li>A001: the Client asks the Server to open the INBOX Mailbox as Folder &quot;INBOX&quot; and to sort it by the INTERNALDATE &#39;field&#39; (this is not an actual message field, but a message metadata element - it specifies the time when the message was added into the Mailbox). The Client informs the Server that it needs to retrieve the FLAGS, From, and Subject fields of Mailbox messages.</li><li>the Server opens the INBOX Mailbox and sorts it; the Server informs the Client that the Folder has 234 messages.</li><li>A002: the Client asks the Server to send it data from the first 4 Folder messages, and the Server sends that information to the Client.</li><li>while the Server was processing this request, one message was added to the Mailbox.</li><li>after the Server has sent the response message, the Folder messages number 2 and 35 were deleted.</li><li>A003: the Client asks the Server to send it data from the first 4 messages in the sorted view (again).</li><li>A004: the Client asks the Server to send it all Folder modifications.</li><li>The Server informs the Client about the message number 35 being removed. The Client should remove the element number 35 from its internal view table and update the information on its screen if necessary. The total number of Folder messages has changed to 233.</li><li>The Server informs the Client about the message number 2 being removed. The Client should remove the element number 2 from its internal view table. The message number 3 becomes the message number 2, the message number 4 becomes the message number 3, etc.</li><li>The Server adds a newly added message to the Folder and informs the Client that it has inserted the message as the message number 1. The Client should update its internal view table by inserting a new element as the element number 1. The element number 1 becomes the element number 2, the element number 2 becomes the element number 3, etc.</li><li>A005: the Client asks the Server to send it data from the first 4 messages in the Folder (again).</li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderOpen</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sortField</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INTERNALDATE&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sortOrder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;asc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;FLAGS&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;From&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Subject&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">field</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderOpen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;init&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;234&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">index</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> from</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> till</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Deleted&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;John H. Smith&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Hello - just a test&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;543&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Answered&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Jim Spammer&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is the best offer!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;343&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Media&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Meeting reminder&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;512&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Flagged&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Admin@hq.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Shutdown @ 4:45AM&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">index</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> from</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> till</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Deleted&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;John H. Smith&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Hello - just a test&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;543&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Answered&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Jim Spammer&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is the best offer!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;343&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Media&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;512&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Flagged&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Admin@hq.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Shutdown @ 4:45AM&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSync</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;35&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;117&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;233&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;343&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;232&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;976&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;added&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;233&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Recent&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;CGatePro Discussions&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;[CGP] Re: Session Timer?&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">index</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> from</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> till</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderBrowse</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Deleted&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;John H. Smith&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Hello - just a test&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;976&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Recent&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;CGatePro Discussions&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;[CGP] Re: Session Timer?&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;543&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Answered&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Jim Spammer&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is the best offer!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;512&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Flagged&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Admin@hq.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Shutdown @ 4:45AM&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span></code></pre></div><p>Example 2:</p><ul><li>A010: the Client asks the Server to copy 3 messages from the already opened INBOX Mailbox to the Archive Mailbox</li><li>The Archive Mailbox appears to be opened, and the Server sends a Mailbox notification message to the Client</li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageCopy</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A010&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Archive&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;512&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;123&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;976&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageCopy</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Archive&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A010&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>Example 3:</p><ul><li>A020: the Client asks the Server to mark 3 messages (UIDs 512, 123, and 976) with the Deleted flag.</li><li>The Server sets these flags, and it sends a Mailbox notification message to the Client.</li><li>A021: the Client asks the Server to send it all Mailbox modifications.</li><li>The Server sends the updated information for the messages with UID 512 and 976. The message with the UID 123 already had the Deleted flag set, so this request has not modified that message and the Server does not send information for this message.</li><li>A022: the Client asks the Server to expunge the Mailbox.</li><li>The Server deletes the messages with UIDs 512, 123, and 976, as well as message with UIDs 446 and 756 which also happened to have the Deleted flag set. The Server sends a Mailbox notification message to the Client.</li><li>A023: the Client asks the Server to send it all Mailbox modifications.</li><li>The Server sends data messages informing the client that it has removed the messages with UIDs 512, 123, 976, 446, and 756 from its sorted Mailbox view.</li><li>A024: the Client closes the INBOX Mailbox.</li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageMark</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A020&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Deleted&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;512&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;123&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;976&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageMark</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A020&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSync</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;976&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;updated&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Recent,Deleted&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;CGatePro Discussions&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;[CGP] Re: Session Timer?&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;512&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;updated&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Seen,Deleted,Flagged&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Admin@hq.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Shutdown @ 4:45AM&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderExpunge</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A022&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A022&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSync</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;232&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;12&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;976&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;231&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;29&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;446&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;230&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;123&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;756&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;229&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;512&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;deleted&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;228&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;11&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A023&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">closeMailbox</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A024&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A024&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h5 id="mailboxSyncReport" tabindex="-1">mailboxSyncReport <a class="header-anchor" href="#mailboxSyncReport" aria-label="Permalink to &quot;mailboxSyncReport {#mailboxSyncReport}&quot;">​</a></h5><p>These messages are sent synchronously when the client sends a <a href="#mailboxSync"><code>mailboxSync</code></a> request.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>mode</code></p><p>this attribute specifies the type of record.</p><ul><li>If the attribute value is info then the <code>hasMore</code> attribute specifies whether there are not reported yet changes, and the <code>syncID</code> attribute specifies the value to be used with the next synchronization request.</li><li>Other records contain the attribute <code>origUID</code> to refer to the messages that have been added, modified, or deleted.<br> The <code>mode</code> attribute then contains the type of the change:<br> removed for messages that were deleted since the last synchronization run;<br> flagsUpdated or attrUpdated for messages with modified flags or attributes;<br> added or updated for new messages and messages whose body has been modified;</li></ul></li></ul><p>Body:</p><p>The body is present when the <code>mode</code> attribute value is not deleted.<br> The body contains a set of XML elements with <em>viewer field</em> values.<br> When the <code>mode</code> attribute value is added or updated the body also contains the message.</p><h2 id="Message" tabindex="-1">Message Operations <a class="header-anchor" href="#Message" aria-label="Permalink to &quot;Message Operations {#Message}&quot;">​</a></h2><p>A client can use the following set of operations to retrieve Messages from Mailboxes.</p><h3 id="folderRead" tabindex="-1">folderRead <a class="header-anchor" href="#folderRead" aria-label="Permalink to &quot;folderRead {#folderRead}&quot;">​</a></h3><p>This operation tells the Server to retrieve a Message or its part. It is sent to the client as a <a href="#folderMessage"><code>folderMessage</code></a> data message.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p><code>partID</code></p><p>this optional attribute specifies the message part to read. If it is not specified, the entire message is read.</p></li><li><p><code>mode</code></p><p>if this optional attribute is set to replyFrom or replyAll, the partID attribute should either be absent or it should specify an <code>EMail</code> subpart element. The <code>folderMessage</code> response message body is an <code>EMail</code> element with a pre-composed reply E-mail.<br> if this optional attribute is set to forward, the partID attribute should either be absent or it should specify an <code>EMail</code> subpart element. The <code>folderMessage</code> response message body is an <code>EMail</code> element with a pre-composed inline forward E-mail.<br> The replyFromHTML, replyAllHTML and forwardHTML variants can be used to choose the HTML part of the original message.<br> The html and htmlForce variants will transform HTML parts to be safely displayed in browser. In htmlForce mode the text/plain parts will also be transformed to HTML.</p></li><li><p><code>totalSizeLimit</code></p><p>the maximum total size of all message parts returned.</p></li><li><p><code>x509</code></p><p>if this optional attribute is set to base64, the <a href="./Data.html#XMLCertificate"><code>x509</code></a> subelements in the retrieved messages (digital signatures) will contain the base64-encoded certificate data.</p></li></ul><h3 id="messageAppend" tabindex="-1">messageAppend <a class="header-anchor" href="#messageAppend" aria-label="Permalink to &quot;messageAppend {#messageAppend}&quot;">​</a></h3><p>This operation tells the Server to compose a Message and append it to an open folder or to an arbitrary Mailbox. This operation also allows to create delayed messages.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the target Folder name. If specified, the <code>targetMailbox</code> attribute is ignored. This attribute must be <a href="./../admin/storage/Mailboxes.html#Special">Outgoing</a> for delayed messages.</p></li><li><p><code>targetMailbox</code></p><p>the target Mailbox name. It must be specified if the <code>folder</code> attribute is absent.</p></li><li><p><code>mailboxClass</code></p><p>this optional attribute can be specified if the <code>targetMailbox</code> attribute is specified.<br> If the target Mailbox does not exist and this optional attribute is specified, the target Mailbox is created. If this attribute value is a non-empty string, the value is assigned as the <a href="./../admin/storage/Mailboxes.html#Classes">Mailbox Class</a> to the newly created Mailbox.</p></li><li><p><code>flags</code></p><p>this optional attribute specifies the message flags the newly created message will have in the Mailbox. Several flags can be specified, separated with the comma symbol. See the <a href="./../admin/storage/Mailboxes.html#Flags">Mailbox</a> section for more details.</p></li><li><p><code>internalDate</code></p><p>this optional attribute specifies the &quot;internal timestamp&quot; for the newly created message. If this parameter is not specified, the current time is used.</p></li><li><p><code>replacesUID</code></p><p>this optional attribute can be specified if the <code>folder</code> attribute is specified.<br> If the message has been successfully composed and appended to the Folder, the message with the <code>replacesUID</code> UID is removed from the Folder Mailbox.</p></li><li><p><code>replaceMode</code></p><p>this optional attribute can be specified if the <code>replacesUID</code> attribute is specified.<br> if the attribute value is checkOld, the the operation fails if the Folder Mailbox does not contain a message with <code>replacesUID</code> real UID. This check and the append/delete operations are executed atomically.<br> if the attribute value is copyOrigUID, the operation fails if the Folder Mailbox does not contain a message with <code>replacesUID</code> real UID. If the message does exist, then its ORIGUID attribute is copied to the newly created message. This check, the append/delete operations, and the attribute assignment are executed atomically.<br> if the attribute value is origUID, replaceUID attribute specified the ORIGUID attribute of the message to be replaced. The operation fails if the Folder Mailbox does not contain a message with <code>replacesUID</code> ORIGUID. If the message does exist, then its ORIGUID attribute is copied to the newly created message. This check, the append/delete operations, and the attribute assignment are executed atomically.</p></li><li><p><code>report</code></p><p>If this optional attribute is specified, it should have the uid value.<br> If the message has been successfully composed and appended to the target Mailbox or Folder, the Server sends the synchronous <code>messageAdded</code> message containing the UID of the newly appended message.<br> Body: The <a href="#MIMEFormat">XML presentation</a> of the Message (the <code>EMail</code> data).<br> If the <code>EMail</code> element contains the <code>uploadID</code> attribute, the RFC message body is built from the contents of the respective file in the session &quot;uploaded file set&quot;.<br> If the <code>EMail</code> element contains <code>Date</code> tag, it means that the message is delayed. It will be sent on date and time specified in <code>Date</code> tag. The <code>internalDate</code> attribute of <code>messageAppend</code> operation must be specified and equals to <code>Date</code> tag for correct specification of sending date and time.<br> The text parts of the message XML presentation should use the Line Feed (0x0A) symbol as the EOL (end of line) symbol.</p></li></ul><p>Example:<br> The Client appends a simple text message to the Mailbox &quot;Sent&quot;, with the <code>Seen</code> and <code>Answered</code> flags. If the Mailbox does not exist, it is created.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sent&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen,Answered&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mailboxClass</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060621T215124&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T045124Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>This operation adds the following message to the Mailbox:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>Subject: I&#39;ll be there!</span></span>
<span class="line"><span>To: &quot;Recipient Name&quot; &lt;toName@domain&gt;</span></span>
<span class="line"><span>X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>Date: Wed, 21 Jun 2006 21:51:24 -0700</span></span>
<span class="line"><span>Message-ID: &lt;web-40721383@domain.dom&gt;</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Dear Susan,</span></span>
<span class="line"><span></span></span>
<span class="line"><span>I will come to your place tomorrow, thank you for the invitation!</span></span>
<span class="line"><span>Mary.</span></span></code></pre></div><p>To create messages with file attachments, put the files into the <a href="#FileUpload">&quot;uploaded file set&quot;</a> first. Then you can specify them in the MIME elements by using the <code>uploadID</code> attribute.<br> You can specify the <code>type</code>, <code>subtype</code>, and (for text files) <code>charset</code> attributes. If you do not explicitly specify them, they are copied from the Content-Type field of the HTTP request used to upload the file.</p><p>Example:<br> The client first uploads 2 files - <code>test.gif</code> (using uploadID <code>att01</code>) and <code>sample.pdf</code> (using uploadID <code>att02</code>). Then the client appends a message to the &quot;Drafts&quot; Folder, with the &quot;Draft&quot; message flag, replacing the existing message with the 578 UID.<br> The message contains some text in the alternative (plain and html) formats, and the uploaded files as attachments.<br> The client requests the Server to send the UID of the newly created message (756).<br> While the client was adding the new message, a different process added some other message (with UID=755) to the &quot;Drafts&quot; Folder Mailbox.<br> The client then clears the &quot;uploaded file set&quot;, and re-syncs its state with the &quot;Drafts&quot; Folder.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Draft,Seen&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> replacesUID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;578&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> report</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;uid&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Text with attachments&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060621T215124&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T045124Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;alternative&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;html&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">html</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">body</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">i</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/i</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">p</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">p</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">i</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/i</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> uploadID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;att01&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> uploadID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;att02&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;application&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;pdf&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;notify&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAdded</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;756&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">clearUploaded</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderSync</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;17&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;578&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;removed&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;301&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;127&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;755&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;added&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;302&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Recent,Drafts&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Other Name&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Drafts&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> index</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;17&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;756&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> mode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;added&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> messages</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;303&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> unseen</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Recent,Drafts,Seen&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FLAGS</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Sender Name&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>This operation adds the following message to the Mailbox:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>Subject: Text with attachments</span></span>
<span class="line"><span>To: &quot;Recipient Name&quot; &lt;toName@domain&gt;</span></span>
<span class="line"><span>X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>Date: Wed, 21 Jun 2006 21:51:24 -0700</span></span>
<span class="line"><span>Message-ID: &lt;web-40721383@domain.dom&gt;</span></span>
<span class="line"><span>Content-Type: multipart/mixed; boundary=&quot;_===38330025====my.server.domain===_&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: multipart/alternative; boundary=&quot;_===38330025-X====my.server.domain===_&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025-X====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: 8bit</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Dear Susan,</span></span>
<span class="line"><span></span></span>
<span class="line"><span>I will come to your place tomorrow, thank you for the invitation!</span></span>
<span class="line"><span>Mary.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025-X====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: text/html; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: 8bit</span></span>
<span class="line"><span></span></span>
<span class="line"><span>&lt;html&gt;&lt;body&gt;&lt;i&gt;Dear Susan,&lt;/i&gt;&lt;p&gt;I will come to your place tomorrow, thank you for the invitation!&lt;p&gt;&lt;i&gt;Mary.&lt;/i&gt;</span></span>
<span class="line"><span>--_===38330025-X====my.server.domain===_--</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: image/gif; name=&quot;test.gif&quot;</span></span>
<span class="line"><span>Content-Disposition: attachment; filename=&quot;test.gif&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: base64</span></span>
<span class="line"><span></span></span>
<span class="line"><span>R0lGODlhCgAMAPf/AP//////zP//mf//Zv//M///AP/M///MzP/Mmf/MZv/MM//MAP+Z//+Z</span></span>
<span class="line"><span>zP+Zmf+ZZv+ZM/+ZAP9m//9mzP9mmf9mZv9mM/9mAP8z//8zzP8zmf8zZv8zM/8zAP8A//8A</span></span>
<span class="line"><span>zP8Amf8AZv8AM/8AAMz//8z/zMz/mcz/Zsz/M8z/AMzM/8zMzMzMmczMZszMM8zMAMyZ/8yZ</span></span>
<span class="line"><span>zMyZmcyZZsyZM8yZAMxm/8xmzMxmmcxmZsxmM8xmAMwz/8wzzMwzmcwzZswzM8wzAMwA/8wA</span></span>
<span class="line"><span>zMwAmcwAZswAM8wAAJn//5n/zJn/mZn/Zpn/M5n/AJnM/5nMzJnMmZnMZpnMM5nMAJmZ/5mZ</span></span>
<span class="line"><span>zJmZmZmZZpmZM5mZAJlm/5lmzJlmmZlmZplmM5lmAJkz/5kzzJkzmZkzZpkzM5kzAJkA/5kA</span></span>
<span class="line"><span>zJkAmZkAZpkAM5kAAGb//2b/zGb/mWb/Zmb/M2b/AGbM/2bMzGbMmWbMZmbMM2bMAGaZ/2aZ</span></span>
<span class="line"><span>zGaZmWaZZmaZM2aZAGZm/2ZmzGZmmWZmZmZmM2ZmAGYz/2YzzGYzmWYzZmYzM2YzAGYA/2YA</span></span>
<span class="line"><span>zGYAmWYAZmYAM2YAADP//zP/zDP/mTP/ZjP/MzP/ADPM/zPMzDPMmTPMZjPMMzPMADOZ/zOZ</span></span>
<span class="line"><span>zDOZmTOZZjOZMzOZADNm/zNmzDNmmTNmZjNmMzNmADMz/zMzzDMzmTMzZjMzMzMzADMA/zMA</span></span>
<span class="line"><span>zDMAmTMAZjMAMzMAAAD//wD/zAD/mQD/ZgD/MwD/AADM/wDMzADMmQDMZgDMMwDMAACZ/wCZ</span></span>
<span class="line"><span>zACZmQCZZgCZMwCZAABm/wBmzABmmQBmZgBmMwBmAAAz/wAzzAAzmQAzZgAzMwAzAAAA/wAA</span></span>
<span class="line"><span>zAAAmQAAZgAAM+4AAN0AALsAAKoAAIgAAHcAAFUAAEQAACIAABEAAADuAADdAAC7AACqAACI</span></span>
<span class="line"><span>AAB3AABVAABEAAAiAAARAAAA7gAA3QAAuwAAqgAAiAAAdwAAVQAARAAAIgAAEe7u7t3d3bu7</span></span>
<span class="line"><span>u6qqqoiIiHd3d1VVVURERCIiIhEREQAAACH+HUdpZkJ1aWxkZXIgMC40IGJ5IFl2ZXMgUGln</span></span>
<span class="line"><span>dWV0ACH5BAUEALkALAAAAAAKAAwAAAg1AHPlG0gw379cAgEoXHgw4UKFDfM9hIhQ4sSIEwFg</span></span>
<span class="line"><span>vCiQ4L+PIC1m/Cfx34qQGkVeBMkSZEAAOw==</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: application/pdf; name=&quot;sample.pdf&quot;</span></span>
<span class="line"><span>Content-Disposition: attachment; filename=&quot;sample.pdf&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: base64</span></span>
<span class="line"><span></span></span>
<span class="line"><span>JVBERi0xLjIgDSXi48/TDQogDTggMCBvYmoNPDwNL0xlbmd0aCA5IDAgUg0vRmlsdGVyIC9G</span></span>
<span class="line"><span>bGF0ZURlY29kZSANPj4Nc3RyZWFtDQpIic2X3VLjuBaFn6DfQXfDuaCP5X9fJiQEpkNI2eFQ</span></span>
<span class="line"><span>[......skipped......]</span></span>
<span class="line"><span>Ug0vSUQgWzxjNjIyNzFiYzY4YmFlYjY3YzBkM2ViNTk4MjJiZTA4Nz48YzYyMjcxYmM2OGJh</span></span>
<span class="line"><span>ZWI2N2MwZDNlYjU5ODIyYmUwODc+XQ0+Pg1zdGFydHhyZWYNODc1NA0lJUVPRg0=</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_--</span></span></code></pre></div><p>To create messages with MIME parts (attachments) copied from other messages stored on the Server, use the copyMIME element instead of a MIME element:</p><h6 id="copyMIME" tabindex="-1">copyMIME <a class="header-anchor" href="#copyMIME" aria-label="Permalink to &quot;copyMIME {#copyMIME}&quot;">​</a></h6><p>Attributes:</p><ul><li><p><code>folder</code> or <code>calendar</code></p><p>the name of an open Folder or an open Calendar.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p><code>partID</code> this optional attribute specifies the message part to copy. If it is not specified, the entire message is copied. If it is specified, the non-MIME (other than <code>Content-xxxxx</code>) part header fields are not copied.Example: The Client stores a note in the &quot;Notes&quot; Mailbox, appending parts 3 and 4 (attachments) of the message 156 stored in the INBOX folder:</p></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Notes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Vacation Pictures&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060621T215124&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T045124Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;The first part of the underwater shots.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">copyMIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;156&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">copyMIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;156&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;4&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>You can attach files stored in the Personal File Storage. Specify the full file name in the MIME elements by using the <code>fileName</code> attribute.<br> You must explicitly specify <code>type</code>, <code>subtype</code>, and (for text files) <code>charset</code> attributes.<br> You should specify the <code>disposition-filename</code> attribute, as the <code>fileName</code> attribute is not used to form the attachment name.</p><p>Example:<br> The Client stores a note in the &quot;Notes&quot; Mailbox, appending the file <code>private/MyFile.jpg</code> as the <code>photo.jpg</code> attachment:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Notes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Vacation Pictures&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060621T215124&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T045124Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Attached please find the images I have stored as files.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;image&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;jpeg&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;private/MyFile.jpg&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> disposition-filename</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;photo.jpg&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>Note: if a <code>&lt;MIME /&gt;</code> element has the <code>disposition</code> attribute value <code>none</code>, the <code>Content-Disposition:</code> header field is not created, and the <code>Content-Type</code> field is stored without the <code>name</code> parameter.</p><p>Обратите внимание: в качестве разделителя строк в текстовых частях MIME должен использоваться один символ перевода строки (0x0A, десятичное 10).</p><p>You can ask the Server to use the &quot;flowed&quot; format for text MIME parts.</p><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Notes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Test text&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> format</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;flowed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is a very long long long long long long long long long long superlong long long long long long long line, followed with a shorter line:</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">This is a shorter line.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>This operation adds the following message to the Mailbox:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Subject: Test text</span></span>
<span class="line"><span>Content-Transfer-Encoding: 8bit</span></span>
<span class="line"><span>Content-Type: text/plain; format=&quot;flowed&quot;; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>This is a very long long long long long long long long long long superlong</span></span>
<span class="line"><span>long long long long long long line, followed with a shorter line:</span></span>
<span class="line"><span>This is a shorter line.</span></span></code></pre></div><p>(there is a trailing space after the &quot;superlong&quot; word)</p><p>To create a signed message, make sure that S/MIME Private key is unlocked, and specify the <code>sign</code> attribute in the topmost <code>EMail</code> element.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sent&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen,Answered&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sign</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>This operation adds the following message to the Mailbox:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>Subject: I&#39;ll be there!</span></span>
<span class="line"><span>To: &quot;Recipient Name&quot; &lt;toName@domain&gt;</span></span>
<span class="line"><span>X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>Content-Type: multipart/signed; protocol=&quot;application/x-pkcs7-signature&quot;; micalg=&quot;SHA1&quot;; boundary=&quot;_===signed==2610002====my.server.domain===_&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>This is a signed S/MIME message</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===signed==2610002====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: 8bit</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Dear Susan,</span></span>
<span class="line"><span></span></span>
<span class="line"><span>I will come to your place tomorrow, thank you for the invitation!</span></span>
<span class="line"><span>Mary.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===signed==2610002====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: application/x-pkcs7-signature; name=&quot;smime.p7s&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: base64</span></span>
<span class="line"><span>Content-Disposition: attachment; filename=&quot;smime.p7s&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>MIIE6wYJKoZIhvcNAQcCoIIE3DCCBNgCAQExCzAJBgUrDgMCGgUAMAsGCSqGSIb3DQEHAaCC</span></span>
<span class="line"><span>ArkwggK1MIICX6ADAgECAgcAk9RF+n/7MA0GCSqGSIb3DQEBBAUAMIG6MQswCQYDVQQGEwJV</span></span>
<span class="line"><span>UzELMAkGA1UECBMCQ0ExFDASBgNVBAcTC01pbGwgVmFsbGV5MSIwIAYDVQQKExlDb21tdW5p</span></span>
<span class="line"><span>.............</span></span>
<span class="line"><span>gIbXNT64QJ+gEYkI9mnePiS1TUOOzGYfXaLy1pqm6jmzBUt7/3UY8ZNHVIwM0Fzj7NwzqM1U</span></span>
<span class="line"><span>Esbkyi3WHNxTZ4HSCs8J2enGQEZjNWHOuX96xQojYGLV0m5Z/FatV9GQ8jNVBmQ9xYGKxmlY</span></span>
<span class="line"><span>jT9ze/oHyKuj7KR8QrgQSYiJVnn7</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===signed==2610002====my.server.domain===_--</span></span></code></pre></div><h3 id="messageSubmit" tabindex="-1">messageSubmit <a class="header-anchor" href="#messageSubmit" aria-label="Permalink to &quot;messageSubmit {#messageSubmit}&quot;">​</a></h3><p>This operation tells the Server to compose a Message and submit it to the Queue for delivery. A message copy can be stored in a Mailbox.</p><p>Attributes:</p><ul><li><p><code>useDSN</code></p><p>if this optional attribute exists, and its value is yes, delivery reports are generated when a message is delivered, or if delivery fails.<br> If this attribute is absent, delivery reports are generated only when message delivery fails.</p></li><li><p><code>targetMailbox</code>, <code>mailboxClass</code>, <code>flags</code>, <code>internalDate</code></p><p>if the optional <code>targetMailbox</code> attribute is specified, then the composed message is appended to the specified Mailbox. These attributes have the same meaning as for the <code>messageAppend</code> operation.</p></li><li><p><code>dataset</code></p><p>if the optional attribute is specified, it specifies the name of an Account dataset. All message target addresses (see below) are stored in the specified dataset, removing existing duplicates.</p></li><li><p>Body:</p></li></ul><p>The <a href="#MIMEFormat">XML presentation</a> of the Message (the <code>EMail</code> element), and zero, one, or several <code>Envelope-To</code> elements. Each <code>Envelope-To</code> element should have a text body - the E-mail address to send the message to.<br> If no <code>Envelope-To</code> element is specified, the message is sent to the addresses specified in all addresses specified in the <code>To</code>, <code>Cc</code>, and <code>Bcc</code> elements inside the <code>EMail</code> element.<br> If the <code>EMail</code> element contains the <code>uploadID</code> attribute, the RFC message body is built from the contents of the respective file in the session &quot;uploaded file set&quot;.<br> When the message MIME text is generated, all addresses from the <code>Bcc</code> elements are skipped.<br> If the XML presentation does not include the <code>Message-ID</code>, <code>Date</code>, <code>MIME-Version</code> fields, the server creates these message fields itself.Example:<br> The Client sends a simple text message to the <code>toName@domain address</code> and the Bcc copy is sent to <code>bccName@domain</code> address. The Client requests delivery notification.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> useDSN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Bcc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;bccName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Bcc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>Example:<br> The Client sends a simple text message to the <code>a1@domain</code> and <code>a2@domain</code> addresses (different from the addresses specified in the <code>To</code> and <code>Cc</code> elements).<br> The message copy should be stored in the &quot;Sent Items&quot; Mailbox with the &quot;Seen&quot; flag.<br> The Client requests delivery notification.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sent Items&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> flags</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Seen&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Envelope-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain address&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Envelope-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Envelope-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a2@domain address&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Envelope-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Cc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;ccName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Cc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>Example:<br> The Client forwards the message 156 stored in the INBOX folder to the <code>a1@domain</code> address:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Fwd: Sorry, I cannot make it :-(&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Attached please find the message I received this morning...</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">copyMIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;156&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>This operation adds the following message to the Mailbox:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>Subject: Fwd: Sorry, I cannot make it :-(</span></span>
<span class="line"><span>To: &quot;Recipient Name&quot; &lt;toName@domain&gt;</span></span>
<span class="line"><span>X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>Date: Wed, 21 Jun 2006 22:55:24 -0800</span></span>
<span class="line"><span>Message-ID: &lt;ximss-38150012@this.server.dom&gt;</span></span>
<span class="line"><span>MIME-Version: 1.0</span></span>
<span class="line"><span>Content-Type: multipart/mixed; boundary=&quot;_===38330025====my.server.domain===_&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Dear Susan,</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Attached please find the message I received this morning...</span></span>
<span class="line"><span>Mary.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_</span></span>
<span class="line"><span>Content-Type: message/rfc822</span></span>
<span class="line"><span></span></span>
<span class="line"><span>From: &quot;Barbara Smith&quot; &lt;barbara@domain&gt;</span></span>
<span class="line"><span>Subject: Sorry, I cannot make it :-(</span></span>
<span class="line"><span>To: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>X-Mailer: OtherClient v8.88</span></span>
<span class="line"><span>Date: Wed, 21 Jun 2006 21:51:24 -0800</span></span>
<span class="line"><span>Message-ID: &lt;zzzzzzzzz@other.server.dom&gt;</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Mary,</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Sorry, but I will be out of town tomorrow...</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Barbara.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===38330025====my.server.domain===_--</span></span></code></pre></div><h3 id="messageRedirect" tabindex="-1">messageRedirect <a class="header-anchor" href="#messageRedirect" aria-label="Permalink to &quot;messageRedirect {#messageRedirect}&quot;">​</a></h3><p>This operation tells the Server to compose a copy of a message stored in a Mailbox, and to submit it to the Queue for delivery.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p><code>partID</code></p><p>this optional attribute specifies the message part to read. If it is not specified, the entire message is redirected. If specified, it should specify a message part that is an E-mail message: a sub-part of the <code>message/rfc822</code> part, a digest part, etc.</p></li><li><p><code>mirror</code></p><p>if this optional attribute is yes, then the message is &quot;mirrored&quot;: it is sent to the specified addresses, but the message header <code>To</code> and <code>Cc</code> fields are left unchanged.</p></li><li><p><code>markRedirected</code></p><p>if this attribute is yes, then the &quot;Redirected&quot; flag is added to the message.<br> If this attribute is not specified, the yes value is assumed if the <code>partID</code> is not specified, otherwise the no value is assumed.</p></li><li><p>Body:</p></li></ul><p>A set of one or more <code>To</code> elements specifying the recipient address(es).</p><p>Example:<br> The Client redirects the message 156 stored in the INBOX folder to the <code>a1@domain</code> and <code>a2@domain</code> addresses:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageRedirect</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;156&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient-2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a2@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageRedirect</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h3 id="messageForward" tabindex="-1">messageForward <a class="header-anchor" href="#messageForward" aria-label="Permalink to &quot;messageForward {#messageForward}&quot;">​</a></h3><p>This operation tells the Server to compose a copy of a message stored in a Mailbox, and to submit it to the Queue for delivery. The operation uses the same attributes as the <code>messageRedirect</code> operation, but the <code>mirror</code> attribute is not supported.</p><h3 id="messageConfirm" tabindex="-1">messageConfirm <a class="header-anchor" href="#messageConfirm" aria-label="Permalink to &quot;messageConfirm {#messageConfirm}&quot;">​</a></h3><p>This operation tells the Server to compose an MDN (Message Disposition Notification) report for a message stored in a Mailbox, and to submit it to the Queue for delivery.<br> Client applications should use this operation when:</p><ul><li><p>the message has been displayed to the user, and</p></li><li><p>the message has the Disposition-Notification header field, and</p></li><li><p>the message does not have the $MDNSent <a href="./../admin/storage/Mailboxes.html#Flags">Message Flag</a>, and</p></li><li><p>the user Preference <code>SendMDNMode</code> is set to <code>Automatically</code> or it is set to <code>Manually</code> and the user has explicitly requested to send a confirmation. Attributes:</p></li><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p><code>type</code></p><p>this attribute should be set to <code>auto</code> (if the confirmation is generated automatically) or to <code>manual</code> (if the user has explicitly requested to send a confirmation).</p></li></ul><h3 id="messageAttrRead" tabindex="-1">messageAttrRead <a class="header-anchor" href="#messageAttrRead" aria-label="Permalink to &quot;messageAttrRead {#messageAttrRead}&quot;">​</a></h3><p>This operation reads the Mailbox message attributes.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p>Body:</p></li></ul><p>a set of <code>field</code> XML elements. Each element should have a text body containing the name of an attribute to retrieve.If no <code>field</code> element is specified, all attributes are retrieved.<br> The Server returns a <code>messageAttrData</code> message.</p><h3 id="messageAttrWrite" tabindex="-1">messageAttrWrite <a class="header-anchor" href="#messageAttrWrite" aria-label="Permalink to &quot;messageAttrWrite {#messageAttrWrite}&quot;">​</a></h3><p>This operation modifies Mailbox message attributes.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>UID</code></p><p>the message UID.</p></li><li><p>Body:</p></li></ul>`,549)),p("p",null,[s[0]||(s[0]=e("XML presentation of a dictionary with new attribute values. To remove an attribute specify the null-object (")),o(a),s[1]||(s[1]=e(") value."))]),s[3]||(s[3]=i(`<p>The Server sends the following data messages:</p><h5 id="folderMessage" tabindex="-1">folderMessage <a class="header-anchor" href="#folderMessage" aria-label="Permalink to &quot;folderMessage {#folderMessage}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#folderRead"><code>folderRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>folder</code>, <code>UID</code>, <code>partID</code>, <code>mode</code></p><p>copies of the <a href="#folderRead"><code>folderRead</code></a> request attributes.</p></li><li><p>Body:</p></li></ul><p>The <a href="#MIMEFormat">XML presentation</a> of the Message or its part.</p><h5 id="messageAdded" tabindex="-1">messageAdded <a class="header-anchor" href="#messageAdded" aria-label="Permalink to &quot;messageAdded {#messageAdded}&quot;">​</a></h5><p>These synchronous data messages are sent when the Server processes the <a href="#messageAppend"><code>messageAppend</code></a>, <a href="#contactAppend"><code>contactAppend</code></a>, and <a href="#messageCopy"><code>messageCopy</code></a> requests with the <code>report</code> attributes set.</p><p>Attributes:</p><ul><li><p><code>folder</code> or <code>targetMailbox</code></p><p>the target Folder or Mailbox name, copied from the request attribute.</p></li><li><p><code>UID</code></p><p>the newly added message UID.<strong>Note:</strong> even if this data message is sent for a Folder, the Server will still send asynchronous <a href="#folderReport"><code>folderReport</code></a> data message notifying the client about a new message added to the Folder. The client SHOULD use the <code>folderSync</code> operation to synchronize its internal view with the Server view, otherwise the newly added message will not be &quot;seen&quot; in the Folder.</p></li></ul><h5 id="messageAttrData" tabindex="-1">messageAttrData <a class="header-anchor" href="#messageAttrData" aria-label="Permalink to &quot;messageAttrData {#messageAttrData}&quot;">​</a></h5><p>These synchronous data messages are sent when the Server processes the <a href="#messageAttrRead"><code>messageAttrRead</code></a> requests.</p><p>Attributes:</p><ul><li><p><code>folder</code>, <code>UID</code></p><p>copied from the request.</p></li><li><p>Body:</p></li></ul><p>The <a href="#MIMEFormat">XML presentation</a> of the attribute set dictionary.</p><h2 id="Account" tabindex="-1">Account Management <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Account Management {#Account}&quot;">​</a></h2><p>A client can use the following set of operations to manage Account ACLs.</p><h3 id="accountRightsGet" tabindex="-1">accountRightsGet <a class="header-anchor" href="#accountRightsGet" aria-label="Permalink to &quot;accountRightsGet {#accountRightsGet}&quot;">​</a></h3><p>This operation makes the Server send an <a href="#accountRights"><code>accountRights</code></a> data message (see below) with the user access rights for the current or specified Account.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>an optional account specifying the target Account name. If this attribute is absent, the current Account is used.</p></li></ul><h3 id="accountACLList" tabindex="-1">accountACLList <a class="header-anchor" href="#accountACLList" aria-label="Permalink to &quot;accountACLList {#accountACLList}&quot;">​</a></h3><p>This operation makes the Server send an <a href="#accountACL"><code>accountACL</code></a> data message (see below) with the <a href="./../admin/sysadmin/Security.html#ACL">Mailbox Access Control List</a> data.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>an optional account specifying the target Account name. If this attribute is absent, the current Account is used.</p></li></ul><h3 id="accountACLUpdate" tabindex="-1">accountACLUpdate <a class="header-anchor" href="#accountACLUpdate" aria-label="Permalink to &quot;accountACLUpdate {#accountACLUpdate}&quot;">​</a></h3><p>This operation modifies the <a href="./../admin/sysadmin/Security.html#ACL">Account Access Control List</a>.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>an optional account specifying the target Account name. If this attribute is absent, the current Account is used.</p></li><li><p>Body:</p></li></ul><p>A set of <code>aclElem</code> XML elements. These elements are the same as those used with the <code>mailboxACLUpdate</code> operation, but their body strings use symbols that specify <a href="./../admin/objects/Accounts.html#AccessRights">Account Access Rights</a>.</p><p>The Server sends the following data messages:</p><h5 id="accountRights" tabindex="-1">accountRights <a class="header-anchor" href="#accountRights" aria-label="Permalink to &quot;accountRights {#accountRights}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#accountRightsGet"><code>accountRightsGet</code></a> request.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>the Account name (if specified in the request).</p></li></ul><p>Body:</p><p>a string; each symbol specifies an effective <a href="./../admin/objects/Accounts.html#AccessRights">Account Access Right</a> granted to the current user.</p><h5 id="accountACL" tabindex="-1">accountACL <a class="header-anchor" href="#accountACL" aria-label="Permalink to &quot;accountACL {#accountACL}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#accountACLList"><code>accountACLList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>the Account name (if specified in the request).</p></li><li><p>Body:</p></li></ul><p>A set of <code>aclElem</code> XML elements, one element for each Account Access Control List element, same as used in the <a href="#mailboxACL"><code>mailboxACL</code></a> data messages, but the element body strings contain symbols representing <a href="./../admin/objects/Accounts.html#AccessRights">Account Access Rights</a>.</p><h2 id="SMIME" tabindex="-1">Secure Messaging (S/MIME) <a class="header-anchor" href="#SMIME" aria-label="Permalink to &quot;Secure Messaging (S/MIME) {#SMIME}&quot;">​</a></h2><p>A client can use the following set of operations to use the Server S/MIME features.</p><h3 id="SMIMEUnlock" tabindex="-1">SMIMEUnlock <a class="header-anchor" href="#SMIMEUnlock" aria-label="Permalink to &quot;SMIMEUnlock {#SMIMEUnlock}&quot;">​</a></h3><p>This operation unlocks the Account Private Key stored on the Server.<br> When the Private Key is unlocked, the Server decrypts encrypted parts of messages retrieved using the <a href="#folderRead"><code>folderRead</code></a> operation.<br> The Server can also encrypt and/or digitally sign submitted messages.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation transfers the unlocking string (&quot;storage password&quot;) in clear text. The client application should use this command only over a secure (TLS) connection.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The unlocked Private Key is added to the current session data only, and it is not stored anywhere. If a different session is opened for the same Account, it should unlock the Private Key by itself.</p></div><p>Attributes:</p><ul><li><p><code>password</code></p><p>the unlocking string (password).</p></li><li><p><code>duration</code></p><p>optional attribute - the time (in seconds) to keep the Private Key unlocked; the Private Key is automatically locked after this period of time.</p></li></ul><h3 id="SMIMELock" tabindex="-1">SMIMELock <a class="header-anchor" href="#SMIMELock" aria-label="Permalink to &quot;SMIMELock {#SMIMELock}&quot;">​</a></h3><p>This operation locks the Account Private Key stored on the Server (it removes the unlocked Private Key from the current session data).<br> It is recommended to use this operation after a certain period of user inactivity.</p><h3 id="SMIMEModifyPassword" tabindex="-1">SMIMEModifyPassword <a class="header-anchor" href="#SMIMEModifyPassword" aria-label="Permalink to &quot;SMIMEModifyPassword {#SMIMEModifyPassword}&quot;">​</a></h3><p>This operation changes the password string protecting the Account Private Key in the Server storage. The Account Private Key must be unlocked.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation transfers the unlocking string (&quot;storage password&quot;) in clear text. The client application should use this command only over a secure (TLS) connection.</p></div><p>Attributes:</p><ul><li><p><code>password</code></p><p>the new unlocking string (password).</p></li></ul><h3 id="SMIMEGet" tabindex="-1">SMIMEGet <a class="header-anchor" href="#SMIMEGet" aria-label="Permalink to &quot;SMIMEGet {#SMIMEGet}&quot;">​</a></h3><p>This operation retrieves S/MIME-related information stored on the Server.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>type of information retrieved.If the value of the <code>type</code> attribute is certificate, then the Server sends a <a href="#certificate"><code>certificate</code></a> data message with the Account Public Certificate.</p></li></ul><h3 id="SMIMESet" tabindex="-1">SMIMESet <a class="header-anchor" href="#SMIMESet" aria-label="Permalink to &quot;SMIMESet {#SMIMESet}&quot;">​</a></h3><p>This operation modifies S/MIME-related information stored on the Server.</p><p>Attributes:</p><ul><li><p><code>mode</code></p><p>operation: add, new, update, delete.</p></li><li><p><code>password</code></p><p>the S/MIME unlocking password (required for the <code>add</code> and <code>new</code> operations).</p></li><li><p><code>filePassword</code></p><p>the password used to decrypt the imported data (required for the <code>add</code> and <code>delete</code> operations).</p></li><li><p><code>duration</code></p><p>when a new S/MIME key and certificate are set, they remain unlock. If this attribute is set, it specifies the number of seconds the S/MIME data remains unlock.</p></li><li><p><code>PFX</code></p><p>this attribute is used only if the body does not contain a <code>PFX</code> XML element. This attribute identifies a file in the &quot;uploaded file set&quot;. The file should contain PKCS12 data containing a Private Key and a Certificate.</p></li><li><p>Body:</p></li></ul><p>an optional <code>PFX</code> element; it should contain a <code>base64</code> XML element with a textual body that is a Base64-encoded PKCS12 data containing a Private Key and a Certificate.</p><p>If the <code>mode</code> value is add, the Server gets the PKCS12 data specified with the <code>PFX</code> body XML element or with the <code>PFX</code> attribute, decrypts it using the specified <code>filePassword</code> value, and assigns the decrypted Private Key and Certificate to the current Account.<br> The server encrypts the stored Private Key data using the the specified <code>password</code> value, which becomes the &quot;S/MIME unlocking string&quot;.</p><p>If the <code>mode</code> value is new, the Server generates a random Private Key and issues an S/MIME Certificate for the current Account, using the Account Domain &quot;S/MIME Issuer&quot; Certificate.<br> The server encrypts the stored Private Key data using the the specified <code>password</code> value, which becomes the &quot;S/MIME unlocking string&quot;.</p><p>If the <code>mode</code> value is update, the Server updates the Account Certificate, if this Certificate was issued using the Account Domain &quot;S/MIME Issuer&quot; Certificate.</p><p>If the <code>mode</code> value is delete, the Server gets the PKCS12 data specified with the <code>PFX</code> body XML element or with the <code>PFX</code> attribute, decrypts it using the specified <code>filePassword</code> value, and compares the retrieved Private Key with the Private Key of the current Account.<br> If the Private Keys are the same, the Account Private Key and Certificate are removed.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation transfers the storage passwords in clear text. The client application should use this command only over a secure (TLS) connection.</p></div><p>The Server sends the following data messages:</p><h5 id="certificate" tabindex="-1">certificate <a class="header-anchor" href="#certificate" aria-label="Permalink to &quot;certificate {#certificate}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#SMIMEGet"><code>SMIMEGet</code></a> request.</p><ul><li><p>Body:</p><p>an XML presentation of the Account S/MIME Public <a href="./Data.html#XMLCertificate">Certificate</a>.</p></li></ul><p>The Server detects all signed message parts and tries to verify that the part body has not been altered since the time it was signed, and that the signature certificates are valid (i.e. issued by known authorities).</p><p>The <code>MIME</code> element body for a signed message part contain 2 XML sub-elements: the first element is the signed data (an <code>EMail</code> or <code>MIME</code> element), the second part is the <code>SMIMESignature</code> XML element.</p><p>If the Server failed to decode or decrypt the signature data, the <code>MIME</code> element body for a signed message part contains the <code>decryptionError</code> attribute with the error code text.</p><p>The <code>SMIMESignature</code> element body contains Certificate sub-elements for all signatures that match the part data. If the Server failed to verify the Certificate, its element contains the validationError attribute with the error code text. If no signature matches the the part data, the <code>SMIMESignature</code> element is empty.</p><p>Example:<br> The Client retrieves a signed message:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> totalSizeLimit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Re: I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070830T204318&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T184318Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> digesterName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SHA1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;5171&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;signed&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">           Type-micalg</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SHA1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-protocol</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;application/x-pkcs7-signature&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3032&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;01&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> charset</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;utf-8&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;86&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;01-01&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Attached please find a file I received this morning...</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> disposition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;attachment&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Disposition-filename</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;logo.gif&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1929&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;01-02&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;gif&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;image&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SMIMESignature</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">x509</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;fromName@domain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> validationError</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;presented certificate is issued by an unknown authority&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> version</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cn</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Sender Name&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cn</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contact</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contact</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">issuer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">c</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;US&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">c</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cn</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;issuer.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">cn</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contact</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;postmaster@issuer.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contact</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">l</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Moscow&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">l</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">                  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">o</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Issuer Company, Inc.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">o</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ou</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Issuer Department&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ou</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">st</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;CA&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">st</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">issuer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">validFrom</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20040924T231857Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">validFrom</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">validTill</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20170923T231857Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">validTill</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">x509</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SMIMESignature</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>When the Account Private Key is unlocked, the Server tries to decrypt all encrypted message parts.</p><ul><li><p>If decrypting fails, the encrypted part element contains an additional attribute:</p></li><li><p><code>decryptionError</code></p></li></ul><p>the decrypting error message text.</p><p>If decrypting fails, the encrypted part is shown as the <code>MIME</code> or <code>EMail</code> XML sub-element of the encrypted part element.</p><p>If decrypting succeeds, the encrypted part element body contains a <code>MIME</code> or <code>EMail</code> XML sub-element with the decrypted data.</p><ul><li><p>The encrypted part element contains additional attributes:</p></li><li><p><code>cipherName</code></p></li></ul><p>the name of cryptographic cipher used to encrypt the decrypted part.</p><ul><li><code>keyLength</code></li></ul><p>the length of cryptographic cipher key (in bits) used to encrypt the decrypted part.</p><p>Example:<br> The Client retrieves an encrypted message, then unlocks the Account Private Key and then retrieves the same message again:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> totalSizeLimit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Re: I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070830T204318&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T184318Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> disposition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;attachment&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Disposition-filename</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;smime.p7m&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;4536&quot;</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">           subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;x-pkcs7-mime&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;application&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;smime.p7m&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-smime-type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;enveloped-data&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SMIMEUnlock</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> password</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;smime-password&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> totalSizeLimit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;55&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Return-Path</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Re: I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070830T204318&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T184318Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> cipherName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;RC2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> disposition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;attachment&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Disposition-filename</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;smime.p7m&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;4536&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> keyLength</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;40&quot;</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">          subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;x-pkcs7-mime&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;application&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;smime.p7m&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-smime-type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;enveloped-data&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;E&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Re: I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;a1@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070830T204318&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070830T184318Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;web-40721383@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3275&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;E&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mixed&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> charset</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;utf-8&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;329&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;E-01&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-format</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;flowed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">            This is an encrypted E-mail with an attachment.</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">            On Thu, 30 Aug 2007 20:40:49 -0800</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Sender Name</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">fromName@domain</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> wrote:</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> Dear Susan,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &amp;gt;</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> I will come to your place tomorrow, thank you for the invitation!</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> Mary.</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> disposition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;attachment&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Disposition-filename</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;logo.gif&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1929&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;E-02&quot;</span></span>
<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">                subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;gif&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;image&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">folderMessage</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>When the Account Private Key is unlocked, a client can submit a signed E-mail.</p><ul><li><p>The <code>EMail</code> element should contain an additional attribute:</p><ul><li><code>sign</code></li></ul></li></ul><p>if this optional attribute exists, and its value is yes, the message body is signed.</p><p>Example:<br> The Client submits a signed text message to the <code>toName@domain</code> address.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sign</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>When the Account Private Key is unlocked, a client can submit an encrypted E-mail if there is an Address Book containg records for all E-mail recipients, and each of those records contains a recipient PKI Certificate.</p><ul><li><p>The topmost <code>EMail</code> element should contain additional attributes:</p><ul><li><code>encrypt</code></li></ul></li></ul><p>if this optional attribute exists, and its value is yes, the message body is encrypted.</p><ul><li><code>addressBook</code></li></ul><p>the name of the Address Book to look the recipient certificates in.</p><ul><li><code>addressBook1</code>, <code>addressBook2</code></li></ul><p>optional: names of the additional Address Books. If no recipient certificate is found in the Address Book with the name stated in the <code>addressBook</code> attribute, these Address Books are checked.</p><p>The topmost <code>EMail</code> element should contain the single &quot;inner&quot; <code>EMail</code> element - the content of that element will be encrypted. The inner <code>EMail</code> element header fields can be the same as in the topmost <code>EMail</code> element, or they can be different. For example, the &quot;inner&quot; <code>EMail</code> element <code>Subject</code> element can be different.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>You cannot specify both the <code>sign</code> and <code>encrypt</code> attributes for the topmost <code>EMail</code> element. To send an encrypted and signed message, add the <code>sign</code> attribute to the inner <code>EMail</code> element.</p></div><p>Example:<br> The Client submits an encrypted and signed text message to the <code>toName@domain</code> address. Note unmatching subjects. The Client requests delivery notification.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> useDSN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> encrypt</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> addressBook</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Contacts&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;A message regarding your request&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sign</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;yes&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;fromName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;I&#39;ll be there!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Recipient Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;toName@domain&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SuperClient v7.77&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Dear Susan,</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I will come to your place tomorrow, thank you for the invitation!</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Mary.</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x0A;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">messageSubmit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h2 id="Contacts" tabindex="-1">Contacts Operations <a class="header-anchor" href="#Contacts" aria-label="Permalink to &quot;Contacts Operations {#Contacts}&quot;">​</a></h2><p>Contacts (vCard and vCardGroup) information can be stored as an E-mail item in any Mailbox. A vCard data element can be attached (as a MIME part) to any E-mail message. Each message can contain several MIME parts each containing several vCard objects.</p><p><a href="#MIMEFormat"><code>MIME</code></a> parts with the <code>text</code> type and <code>x-vcard</code> or <code>dictionary</code> subtype contain <a href="./Data.html#XMLvCard"><code>vCard</code></a> elements.</p><p><a href="#MIMEFormat"><code>MIME</code></a> parts with the <code>text</code> type and <code>x-vgroup</code> subtype contain one <a href="./Data.html#XMLvCardGroup"><code>vCardGroup</code></a> element.</p><p>To include vCard data into a message (using the <a href="#messageAppend"><code>messageAppend</code></a>, <a href="#messageSubmit"><code>messageSubmit</code></a> operations) include a <a href="#MIMEFormat"><code>MIME</code></a> element with <code>type=&quot;text&quot;</code> and <code>subtype=&quot;directory&quot;</code> attributes. The element body should contain one or more <a href="./Data.html#XMLvCard"><code>vCard</code></a> elements.</p><p>To include vCardGroup data into a message (using the <a href="#messageAppend"><code>messageAppend</code></a>, <a href="#messageSubmit"><code>messageSubmit</code></a> operations) include a <a href="#MIMEFormat"><code>MIME</code></a> element with <code>type=&quot;text&quot;</code> and <code>subtype=&quot;x-vgroup&quot;</code> attributes. The element body should contain one <a href="./Data.html#XMLvCardGroup"><code>vCardGroup</code></a> element.</p><p>The Contact-class Mailboxes are used to store special messages (&quot;items&quot;) containing only vCard or vCardGroup data. In a properly composed vCard item:</p><ul><li>the <code>Subject</code> field contains the vCard <code>FN</code> property.</li><li>the <code>To</code> field contains the vCard <code>EMAIL</code> properties.</li><li>the <code>X-Telnum</code> field contains the vCard <code>TEL</code> properties.</li><li>the <code>X-Has-Certificate</code> field exists and contains the <code>true</code> value if the vCard contains a <code>KEY</code> property.</li></ul><p>In a properly composed vCardGroup item:</p><ul><li>the <code>Subject</code> field contains the vCardGroup <code>NAME</code> property.</li></ul><p>Use the following operations to compose, store, and retrieve these special messages:</p><h3 id="contactAppend" tabindex="-1">contactAppend <a class="header-anchor" href="#contactAppend" aria-label="Permalink to &quot;contactAppend {#contactAppend}&quot;">​</a></h3><p>This operation composes a special E-mail message containing the vCard or vCardGroup data as its body, forms all necessary E-mail message header fields and stores the resulting message in the specified Folder or Mailbox.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the target Folder name. If specified, the <code>targetMailbox</code> attribute is ignored.</p></li><li><p><code>targetMailbox</code></p><p>the target Mailbox name. It must be specified if the <code>folder</code> attribute is absent.<br> if the target Mailbox does not exist, it is created.</p></li><li><p><code>flags</code>, <code>replacesUID</code>, <code>replaceMode</code>, <code>report</code></p><p>these optional attributes have the same meaning as the same <code>messageAppend</code> attributes. If the <code>flags</code> attribute is not specified, its value assumed to be <code>Seen</code>.</p></li></ul><p>Body:</p><p>exactly one <a href="./Data.html#XMLvCard"><code>vCard</code></a> or <a href="./Data.html#XMLvCardGroup"><code>vCardGroup</code></a> element.The operation adds the vCard <code>UID</code> and <code>FN</code> attributes if they are missing.</p><p>Example 1:<br> The Client appends a vCard object to the <code>Contacts</code> Mailbox.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contactAppend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A011&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> targetMailbox</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Contacts&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Bjorn Jensen&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">N</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FAMILY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Jensen&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FAMILY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">GIVEN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;bjorn&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">GIVEN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIDDLE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;A&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIDDLE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">PREFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Mr.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">PREFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SUFFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;II&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SUFFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">N</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMAIL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">INTERNET</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">USERID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;bjorn@domain.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">USERID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMAIL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">TEL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">WORK</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VOICE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MSG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NUMBER</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+1 313 747-4454&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NUMBER</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">TEL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">KEY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">x509</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BINVAL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;dGhpcyBjb3VsZCBiZSAKbXkgY2VydGlmaWNhdGUK&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BINVAL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">KEY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">contactAppend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A011&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h3 id="contactsImport" tabindex="-1">contactsImport <a class="header-anchor" href="#contactsImport" aria-label="Permalink to &quot;contactsImport {#contactsImport}&quot;">​</a></h3><p>This operation parses an uploaded file, which should contain vCard items. The resulting items are copied into the specified Folder.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>uploadID</code></p><p>a string identifying a file in the &quot;uploaded file set&quot;.</p></li></ul><h3 id="contactFind" tabindex="-1">contactFind <a class="header-anchor" href="#contactFind" aria-label="Permalink to &quot;contactFind {#contactFind}&quot;">​</a></h3><p>This operation searches the open Folder for vCard items (messages) with an E-mail or Telephone number matching the specified address.<br> When a &quot;fuzzy&quot; search is requested, the operation searches for vCard items containing E-mail addresses or &quot;File as&quot; names that include the specified address as a substring.<br> Only the E-mail message header fields (<code>To</code> and <code>X-Telnum</code>) are checked, not the actual vCard data.</p><p>Attributes:</p><ul><li><p><code>folder</code></p><p>the Folder name.</p></li><li><p><code>totalSizeLimit</code></p><p>same as for the <a href="#folderRead"><code>folderRead</code></a> operation. If set to zero, no vCard message body is returned.</p></li><li><p><code>peer</code></p><p>the address to search for.</p></li><li><p><code>limit</code></p><p>the optional parameter limiting the number of items to find. The operation finishes when it finds the specified number of matching items or when all folder items are checked.</p></li><li><p><code>mode</code></p><p>if this optional attribute is specified and it has the sub value, &quot;fuzzy search&quot; is requested.<br> The found vCard message content is sent to the client as the <a href="#folderMessage"><code>folderMessage</code></a> data message, with the additional attributes:</p></li></ul><p>Attributes:</p><ul><li><p><code>folder</code>, <code>peer</code></p><p>the same values as in the request.</p></li><li><p><code>UID</code></p><p>the found vCard message UID (numeric).</p></li><li><p><code>foundAddress</code></p><p>optional; the <code>To</code> or <code>X-Telnum</code> address element that matches the <code>peer</code> value.</p></li><li><p><code>peerName</code></p><p>optional; the &quot;File as&quot; name of found vCard.</p></li></ul><h2 id="Calendar" tabindex="-1">Calendar Operations <a class="header-anchor" href="#Calendar" aria-label="Permalink to &quot;Calendar Operations {#Calendar}&quot;">​</a></h2><p>A client can use the following operations to process a Calendar in the authenticated Account, as well as in other Accounts (by specifying the full Mailbox name as <code>~accountName@domainName/mailboxName</code>).</p><h3 id="calendarOpen" tabindex="-1">calendarOpen <a class="header-anchor" href="#calendarOpen" aria-label="Permalink to &quot;calendarOpen {#calendarOpen}&quot;">​</a></h3><p>This operation opens the specified Mailbox as a &quot;Calendar&quot;.<br> A Calendar represents a Server Mailbox, with all messages being parsed and all calendaring information retrieved. Alternatively, a Calendar can represent an iCalendar document (a set of iCalendar events) retrieved via the HTTP/HTTPS protocol using the specified URL.<br> Each calendar has a name, and one session cannot have two calendars with the same name. On the other hand, the same session can open the same Mailbox as two different calendars (with different names).</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the name for the new Calendar to be opened. A client can use an arbitrary string as a Calendar name.</p></li><li><p><code>url</code></p><p>if specified, the URL of a remote iCalendar object. The object is retrieved, parsed, and all its VEVENT elements are used as the Calendar object data. No Server Mailbox is read in this case.</p></li><li><p><code>mailbox</code></p><p>the Mailbox name. This attribute is used only if the <code>url</code> attribute is not specified. If this attribute is not specified, the calendar name is used.<br> A session can use several open Calendars at the same time.</p></li></ul><h3 id="calendarClose" tabindex="-1">calendarClose <a class="header-anchor" href="#calendarClose" aria-label="Permalink to &quot;calendarClose {#calendarClose}&quot;">​</a></h3><p>This operation closes an open Calendar.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li></ul><h3 id="findEvents" tabindex="-1">findEvents <a class="header-anchor" href="#findEvents" aria-label="Permalink to &quot;findEvents {#findEvents}&quot;">​</a></h3><p>This operation retrieves the VEVENT objects from the specified Calendar. Only the Events that fall into the specified time interval are retrieved.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>timeFrom</code>, <code>timeTill</code></p><p>the beginning and the end of the time interval (time values should be specified for the selected time zone).</p></li><li><p><code>byAlarm</code></p><p>if this optional attribute exists, and its value is yes, the operation looks not for the Events in the specified time interval, but for the Events that have an Alert element set within the specified time interval.</p></li><li><p><code>limit</code></p><p>this optional numeric attribute limits the number of the Events returned.</p></li><li><p><code>skip</code></p><p>this optional numeric attribute specifies how many &quot;to be returned&quot; Events should be skipped. Using this attribute, a client can retrieve a large Event set in smaller &quot;chunks&quot;.The Server sends one <a href="#events"><code>events</code></a> data message for each 24-hour day (in the selected time zone) included into the specified time interval.</p></li></ul><h3 id="findTasks" tabindex="-1">findTasks <a class="header-anchor" href="#findTasks" aria-label="Permalink to &quot;findTasks {#findTasks}&quot;">​</a></h3><p>This operation retrieves the VTODO objects from the specified Calendar. Only the Tasks that fall into the specified time interval are retrieved.</p><p>Attributes:</p><ul><li><p><code>calendar</code>, <code>timeFrom</code>, <code>timeTill</code>, <code>byAlarm</code>, <code>limit</code>, <code>skip</code></p><p>these attributes have the same meanings as the <code>findEvents</code> operation attributes.The Server sends one <a href="#tasks"><code>tasks</code></a> data message for each 24-hour day (in the selected time zone) included into the specified time interval.</p></li></ul><h3 id="calendarRead" tabindex="-1">calendarRead <a class="header-anchor" href="#calendarRead" aria-label="Permalink to &quot;calendarRead {#calendarRead}&quot;">​</a></h3><p>This operation tells the Server to retrieve a Message or its part. It is sent to the client as a <a href="#calendarMessage"><code>calendarMessage</code></a> data message.<br> This operation is the same as the <a href="#folderRead"><code>folderRead</code></a> operation, but instead of the <code>folder</code> attribute it uses the <code>calendar</code> to specify the open Calendar name.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>This operation cannot be applied to a Calendar object built using a remote (URL-specified) iCalendar object. Use the <code>calendarReadItem</code> operation instead.</p></div><h3 id="calendarReadItem" tabindex="-1">calendarReadItem <a class="header-anchor" href="#calendarReadItem" aria-label="Permalink to &quot;calendarReadItem {#calendarReadItem}&quot;">​</a></h3><p>This operation tells the Server to retrieve a calendar item. It is sent to the client as a <a href="#calendarItem"><code>calendarItem</code></a> data message.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>UID</code></p><p>the item message UID (a number).</p></li></ul><h3 id="calendarPublish" tabindex="-1">calendarPublish <a class="header-anchor" href="#calendarPublish" aria-label="Permalink to &quot;calendarPublish {#calendarPublish}&quot;">​</a></h3><p>This operation places a calendaring item into a Calendar. The existing items(s) with the same UID are removed.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>sendRequests</code></p><p>if this optional attribute exists and its value is no, the item is stored without notifying participants.<br> Otherwise, if there was an existing item with the same UID, Cancel requests are sent to all participants existing in the old item, but excluded from the new item.<br> A meeting or task request is sent to all participants, or, if this attribute value is <code>new</code>, to all newly added participants.</p></li><li><p><code>copyExceptions</code></p><p>if this optional attribute value is not no and the item does not contain the <code>recurrenceID</code> element, and the Calendar already contains an item with the same UID, all recurrence exceptions from the existing item are copied into the newly published item.</p></li></ul><p>Body:</p><p>An <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to place into the selected Calendar, and optional <a href="#MIMEFormat"><code>MIME</code></a> and/or <a href="#copyMIME"><code>copyMIME</code></a> elements to add (the same as elements used with the <code>messageAppend</code> operation).<br> If no <code>MIME</code> or <code>copyMIME</code> element is present, and there is an existing Calendar item with the same UID, the attachments are copied from that item. To prevent this, include an empty <code>noMIME</code> element.The <code>iCalendar</code> element may contain optional <a href="./Data.html#XMLvtimezone"><code>vtimezone</code></a> elements, and it should contain exactly one calendaring item element.<br> It is not required to include a <code>vtimezone</code> element for a time zone used in a calendaring item element if this time zone is one of the standard time zones known to the Server.<br> It is allowed to omit a time zone name in the properties containing date values without the <code>Z</code> suffix. In this case the time zone selected as the current user Preference TimeZone value is used.<br> If the item does not contain an UID element, the Server generates a unique UID and adds it to the item.<br> To create or update a recurrence exception item, include the <code>recurrenceID</code> element into the <code>vevent</code> element.</p><p>Example 1:<br> The Client published an iCalendar object to the <code>Calendar</code> calendar.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">calendarPublish</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> calendar</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Calendar&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">iCalendar</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> xmlns</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;urn:ietf:params:xml:ns:xcal&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCalendar</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> method</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;PUBLISH&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> prodid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;CommuniGate Pro 5.1.7&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> version</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2.0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vevent</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">organizer</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> CN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Big Boss&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;MAILTO:boss@company.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">organizer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attendee</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> CN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Small Boy&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;MAILTO:boy@company.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attendee</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;FREQ=WEEKLY;BYDAY=MO,TH&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstamp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20061022T091143Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstamp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;18927897984@kjjkjkjk-123444&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sequence</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;0&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sequence</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Report Meeting&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20060515T100000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20060515T110000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">busystatus</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;BUSY&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">busystatus</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">last-modified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20060516T034850Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">last-modified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">created</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20060516T034850Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">created</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">priority</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;5&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">priority</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">description</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;A twice-a-week meeting to discuss the progress of the assigned projects.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">description</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vevent</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCalendar</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">iCalendar</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> uploadID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;att01&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">copyMIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;156&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">calendarPublish</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A021&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If a time value is specified without the &quot;Z&quot; suffix, it is assumed to be a local time in the Time Zone selected for the current user.</p></div><h3 id="calendarCancel" tabindex="-1">calendarCancel <a class="header-anchor" href="#calendarCancel" aria-label="Permalink to &quot;calendarCancel {#calendarCancel}&quot;">​</a></h3><p>This operation removes a calendaring item from a Calendar. Cancel requests are sent to all participants.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>UID</code></p><p>optional; the message UID (numeric).</p></li><li><p><code>itemUID</code></p><p>optional; the Event item (iCalendar) UID string.</p></li><li><p><code>recurrenceId</code></p><p>optional; the recurrence ID timestamp.</p></li><li><p><code>sendRequests</code></p><p>if this optional attribute is no, cancel request messages are not sent to the item attendees.</p></li><li><p>Body:</p></li><li><p>an optional <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to cancel.<br> If this element is not specified, the item with the specified iCalendar Event UID or the specified message UID is taken from the Calendar. Then all items with the same Event item (iCalendar) UID are removed.</p></li><li><p>optional <code>requestComment</code> element containing a text body - a comment to include into the cancel request message.</p></li></ul><p>To cancel only one recurrence of a recurrent event either specify an <code>iCalendar</code> element with the <code>recurrenceId</code> sub-element, or, if the <code>iCalendar</code> element is not specified, use the <code>recurrenceId</code> attribute.</p><h3 id="calendarUpdate" tabindex="-1">calendarUpdate <a class="header-anchor" href="#calendarUpdate" aria-label="Permalink to &quot;calendarUpdate {#calendarUpdate}&quot;">​</a></h3><p>This operation updates a calendaring item in a Calendar using a reply-type <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> object. This item specifies if a particular attendee has accepted or rejected the invitation.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li></ul><p>Body:</p><p>The <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> reply-type item.</p><h3 id="calendarForward" tabindex="-1">calendarForward <a class="header-anchor" href="#calendarForward" aria-label="Permalink to &quot;calendarForward {#calendarForward}&quot;">​</a></h3><p>This operation tells the Server to compose a copy of an Event stored in a Calendar, and to submit it to the Queue for delivery as a Meeting request.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>UID</code></p><p>the Event UID.</p></li><li><p>Body:</p></li></ul><p>A set of one or more <code>To</code> elements specifying the recipient address(es).</p><h3 id="calendarAccept" tabindex="-1">calendarAccept <a class="header-anchor" href="#calendarAccept" aria-label="Permalink to &quot;calendarAccept {#calendarAccept}&quot;">​</a></h3><p>This operation places a calendaring item into a Calendar and sends a positive reply the item organizer. The existing items(s) with the same UID are replaced.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>PARTSTAT</code></p><p>the acceptance status: <code>ACCEPTED</code>, <code>TENTATIVE</code>, <code>IN-PROCESS</code> (Tasks only), <code>COMPLETED</code> (Tasks only).</p></li><li><p><code>sendReply</code></p><p>if this optional attribute is no, no reply message is sent to the item organizer.</p></li><li><p><code>folder</code></p><p>the optional Folder name from which the invitation calendar element was read. This attribute is used to find the Folder owner and direct Calendar operations to the owner&#39;s default Calendar.</p></li><li><p><code>proposedTimeStart</code></p><p>an optional attribute with the new time for the event to start; if the attribute is set the <code>COUNTER</code> calendar response is sent to the event organizer.</p></li></ul><p>Body:</p><ul><li>The <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to place into the selected Calendar;</li><li>optional <a href="#MIMEFormat"><code>MIME</code></a> and/or <a href="#copyMIME"><code>copyMIME</code></a> elements to add (the same as elements used with the <code>messageAppend</code> operation);</li><li>optional <code>replyComment</code> element containing a text body - a comment to include into the reply message.</li></ul><p>If the item is placed successfully, the iCalendar reply message is sent to the item organizer. Replies are not sent for Event items specifying the current user as an attendee with <code>RSVP=FALSE</code> parameter, or if the request <code>sendReply</code> attribute is set to no.</p><h3 id="calendarDecline" tabindex="-1">calendarDecline <a class="header-anchor" href="#calendarDecline" aria-label="Permalink to &quot;calendarDecline {#calendarDecline}&quot;">​</a></h3><p>This operation is used to decline invitations and counterproposals, as well as to send a response to the event organizer or the participant whose counterproposal has been declined.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name. This parameter is optional.<br> If specified, the items with the same UID are removed from this Calendar.<br> If the item has the <code>recurrenceId</code> element, then only this exception is removed from the Calendar.</p></li><li><p><code>sendReply</code></p><p>if this optional attribute is set to no, no response will be sent to the organizer or participant who made the counterproposal. The default value is <code>yes</code>.</p></li><li><p><code>folder</code></p><p>the optional Folder name from which the invitation calendar element was read. This attribute is used to find the Folder owner and direct Calendar operations to the owner&#39;s default Calendar.</p></li><li><p><code>proposedTimeStart</code></p><p>an optional attribute with the new time for the event to start; if the attribute is set the <code>COUNTER</code> calendar response is sent to the event organizer.</p></li><li><p><code>attendeeEmail</code></p><p>the email of the participant whose counterproposal is being declined. This is only used for handling <code>DECLINECOUNTER</code>.</p></li><li><p>Body:</p></li><li><p>The <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> element to decline.</p></li><li><p>optional <code>replyComment</code> element containing a text body - a comment to include into the reply message.</p></li></ul><p>Use this operation when a user decides not to attend a meeting stored as a published item in a Calendar. (if the current user is the meeting organizer, use the <a href="#calendarCancel"><code>calendarCancel</code></a> operation instead).<br> Specify the published item itself and the <code>calendar</code> attribute to remove the item from the Calendar.<br> The operation sends a negative reply message to the item organizer (unless the <code>sendReply</code> attribute is set to no).</p><p>Use this operation when a user opens a request item (in an incoming E-mail) and decides to decline that request.<br> Specify the request item, and do not specify any <code>calendar</code> attribute.<br> The operation sends a negative reply message to the item organizer (unless the <code>sendReply</code> attribute is set to no).</p><p>Use this operation when a user opens a cancellation request item (in an incoming E-mail), and decides to remove the canceled item from the Calendar.<br> Specify the cancellation request item and the <code>calendar</code> attribute (usually - the Main Calendar name), to remove the corresponding item(s) from that calendar.<br> The operation does not send any reply message.</p><p>If the specified item is a request, the operation sends a negative reply message to the item organizer.<br> If the specified item is a cancel request item, the operation does not send a reply message to the item organizer; specify the <code>calendar</code> attribute to remove the corresponding item from the calendar.</p><p>Use this operation if the user decides to decline a proposed alternative meeting time suggested by a participant. The counterproposal decline is handled using the <code>attendeeEmail</code> attribute. If sendReply=&quot;no&quot;, the counterproposal is removed only from the organizer&#39;s calendar. If sendReply is not specified (or is set to <code>yes</code>), the participant will be notified.</p><h4 id="additional-clarifications" tabindex="-1">Additional Clarifications: <a class="header-anchor" href="#additional-clarifications" aria-label="Permalink to &quot;Additional Clarifications:&quot;">​</a></h4><p>The counterproposals referenced in this operation comply with the standard described in RFC 5546 (iTIP, iCalendar). In this specification, a counterproposal represents a participant’s response proposing a new time for the event. The counterproposal decline operation is used to reject the proposed time change, removing it from the calendar or sending a notification to the participant.</p><h3 id="calendarImport" tabindex="-1">calendarImport <a class="header-anchor" href="#calendarImport" aria-label="Permalink to &quot;calendarImport {#calendarImport}&quot;">​</a></h3><p>This operation parses an uploaded file, which should contain <a href="./Data.html#XMLiCalendar">iCalendar</a>/<a href="./Data.html#XMLvCalendar">vCalendar</a> items. The resulting items are copied into a Calendar. The existing items(s) with the same UID are removed.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>uploadID</code></p><p>a string identifying a file in the &quot;uploaded file set&quot;.</p></li></ul><h3 id="freeBusyRead" tabindex="-1">freeBusyRead <a class="header-anchor" href="#freeBusyRead" aria-label="Permalink to &quot;freeBusyRead {#freeBusyRead}&quot;">​</a></h3><p>This operation retrieves the FreeBusy information for the specified Account.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>the target Account name. If this attribute is not specified, the current Account FreeBusy information is retrieved.</p></li><li><p><code>timeFrom</code>, <code>timeTill</code></p><p>the beginning and the end of the time interval (time values should be specified for the selected time zone).The Server sends a <a href="#freeBusyData"><code>freeBusyData</code></a> data message.</p></li></ul><h3 id="calendarGetEventUID" tabindex="-1">calendarGetEventUID <a class="header-anchor" href="#calendarGetEventUID" aria-label="Permalink to &quot;calendarGetEventUID {#calendarGetEventUID}&quot;">​</a></h3><p>This operation retrieves the UID (numeric) of a message with the given Event item (iCalendar) UID string</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>itemUID</code></p><p>the Event item (iCalendar) UID string.The Server sends a <a href="#calendarEventUID"><code>calendarEventUID</code></a> data message.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="events" tabindex="-1">events <a class="header-anchor" href="#events" aria-label="Permalink to &quot;events {#events}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#findEvents"><code>findEvents</code></a> request.</p><p>Attributes:</p><ul><li><p><code>calendar</code>, <code>timeFrom</code>, <code>timeTill</code>, <code>skip</code></p><p>the same as in the <a href="#findEvents"><code>findEvents</code></a> request.</p></li><li><p><code>items</code></p><p>the total number of Events found.</p></li><li><p>Body:</p></li></ul><p>a set of <code>event</code> elements for each Event found.</p><p>Attributes:</p><ul><li><p><code>UID</code></p><p>the Event message UID (a number).</p></li><li><p><code>itemUID</code></p><p>the Event item (iCalendar) UID string.</p></li><li><p><code>timeFrom</code></p><p>the time when this Event starts (in the selected time zone). This attribute is not included for &quot;all-day&quot; Events when the <code>byAlarm</code> mode is not set.</p></li><li><p><code>dateFrom</code></p><p>the date when this Event starts (in the selected time zone). This attribute is included for &quot;all-day&quot; Events only, and only when the <code>byAlarm</code> mode is not set.</p></li><li><p><code>duration</code></p><p>the Event duration (in seconds).</p></li><li><p><code>alarmTime</code></p><p>this attribute is included only if the request contained the <code>byAlarm</code> attribute. The attribute value specifies the time (in the selected time zone) when the Event Alarm should take place.</p></li><li><p><code>busyStatus</code></p><p>the Event busy status (<code>BUSY</code>, <code>TENTATIVE</code>, <code>UNAVAILABLE</code>, <code>FREE</code>).</p></li><li><p><code>partstat</code></p><p>the participation status of the requesting user (<code>NEEDS-ACTION</code>, <code>ACCEPTED</code>, <code>DECLINED</code>, <code>TENTATIVE</code>).</p></li><li><p><code>organizer</code></p><p>this attribute is present and it has the yes value if the current user is the organizer of the Event.</p></li><li><p><code>recurrence</code></p><p>this attribute is present and it has the yes value if the Event is a recurrent one.</p></li><li><p><code>recurrenceId</code></p><p>this attribute is present if the found Event is an exception of its main Event. The attribute value is a time stamp identifying this exception.</p></li><li><p><code>attendees</code></p><p>this attribute is present if the Event has attendees. The attribute value is the number of attendees.</p></li><li><p><code>location</code></p><p>this attribute is present if the Event has the Location element. The attribute value is the Location element value, optionally shortened.</p></li><li><p><code>priority</code></p><p>this attribute is present if the Event has its priority set.</p></li><li><p><code>class</code></p><p>this attribute is present if the Event has its privacy class set (<code>PUBLIC</code>, <code>PRIVATE</code>, <code>CONFIDENTIAL</code>).</p></li><li><p>Body:</p><p>Event fields: <code>summary</code></p></li></ul><h5 id="tasks" tabindex="-1">tasks <a class="header-anchor" href="#tasks" aria-label="Permalink to &quot;tasks {#tasks}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#findTasks"><code>findTasks</code></a> request.</p><p>Attributes:</p><ul><li><p><code>calendar</code>, <code>timeFrom</code>, <code>timeTill</code>, <code>skip</code></p><p>the same as in the <a href="#findTasks"><code>findTasks</code></a> request.</p></li><li><p><code>items</code></p><p>the total number of tasks found.</p></li></ul><p>Body:</p><p>a set of <code>task</code> elements for each Task found.</p><p>Attributes:</p><ul><li><p><code>UID</code></p><p>the Task message UID (a number).</p></li><li><p><code>itemUID</code></p><p>the Task item (iCalendar) UID string.</p></li><li><p><code>timeFrom</code></p><p>the time when this Task starts (in the selected time zone).</p></li><li><p><code>due</code></p><p>the time this Task is due (in the selected time zone).</p></li><li><p><code>percent-complete</code></p><p>the Task completion stage; a number, usually in the 0..100 range.</p></li><li><p><code>alarmTime</code></p><p>this attribute is included only if the request contained the <code>byAlarm</code> attribute. The attribute value specifies the time (in the selected time zone) when the Task Alarm should take place.</p></li><li><p><code>organizer</code></p><p>this attribute is present and it has the yes value if the current user is the organizer of the Task.</p></li><li><p><code>recurrence</code></p><p>this attribute is present and it has the yes value if the Task is a recurrent one.</p></li><li><p><code>recurrenceId</code></p><p>this attribute is present if the found Task is an exception of its main Task. The attribute value is a time stamp identifying this exception.</p></li><li><p><code>attendees</code></p><p>this attribute is present if the Task has assignees. The attribute value is the number of assignees.</p></li><li><p><code>location</code></p><p>this attribute is present if the Task has the Location element. The attribute value is the Location element value, optionally shortened.</p></li><li><p><code>priority</code></p><p>this attribute is present if the Task has its priority set.</p></li><li><p>Body:</p><p>Task fields: <code>summary</code></p></li></ul><h5 id="calendarReport" tabindex="-1">calendarReport <a class="header-anchor" href="#calendarReport" aria-label="Permalink to &quot;calendarReport {#calendarReport}&quot;">​</a></h5><p>These asynchronous data messages are sent when the Calendar data is modified.</p><p>Attributes:</p><ul><li><p><code>calendar</code></p><p>the Calendar name.</p></li><li><p><code>mode</code></p><p>this optional attribute specifies the type of notification.</p><ul><li>If the attribute value is <code>notify</code> some calendar messages have been added, modified, or deleted.<br> The client is expected to re-send the <a href="#findEvents"><code>findEvents</code></a> request for this Calendar.</li></ul></li></ul><p>After the Server sends a &quot;notify-mode&quot; <code>calendarReport</code> message to the Client, the Server may choose not to send further &quot;notify-mode&quot; messages for this Calendar until the client performs the <a href="#findEvents"><code>findEvents</code></a> operation on this Calendar.</p><h5 id="calendarMessage" tabindex="-1">calendarMessage <a class="header-anchor" href="#calendarMessage" aria-label="Permalink to &quot;calendarMessage {#calendarMessage}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#calendarRead"><code>calendarRead</code></a> request.<br> This message is the same as <code>folderMessage</code>, but instead of the <code>folder</code> attribute it contains the <code>calendar</code> attribute with the Calendar name.</p><h5 id="calendarItem" tabindex="-1">calendarItem <a class="header-anchor" href="#calendarItem" aria-label="Permalink to &quot;calendarItem {#calendarItem}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#calendarReadItem"><code>calendarReadItem</code></a> request.</p><p>Attributes:</p><ul><li><p><code>calendar</code>, <code>UID</code></p><p>the copy of the <a href="#calendarReadItem"><code>calendarReadItem</code></a> request attributes.</p></li><li><p>Body:</p></li></ul><p>the xml presentation of the calendar item (<code>vevent</code>, <code>vtodo</code>).</p><h5 id="freeBusyData" tabindex="-1">freeBusyData <a class="header-anchor" href="#freeBusyData" aria-label="Permalink to &quot;freeBusyData {#freeBusyData}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#freeBusyRead"><code>freeBusyRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>userName</code></p><p>the copy of the same <a href="#freeBusyRead"><code>freeBusyRead</code></a> request attribute.</p></li><li><p>Body:</p></li></ul><p>the <a href="./Data.html#XMLvfreebusy"><code>vfreebusy</code></a> object containing a set of <code>freebusy</code> elements. All time values returned are specified as the local time in the Time Zone selected for the current user.</p><p>After the Server sends a &quot;notify-mode&quot; <code>calendarReport</code> message to the Client, the Server may choose not to send further &quot;notify-mode&quot; messages for this Calendar until the client performs the <code>findEvents</code> operation on this Calendar.</p><h5 id="calendarEventUID" tabindex="-1">calendarEventUID <a class="header-anchor" href="#calendarEventUID" aria-label="Permalink to &quot;calendarEventUID {#calendarEventUID}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#calendarGetEventUID"><code>calendarGetEventUID</code></a> request.</p><p>Attributes:</p><ul><li><p><code>calendar</code>, <code>itemUID</code></p><p>the copy of the <a href="#calendarGetEventUID"><code>calendarGetEventUID</code></a> request attributes.</p></li><li><p><code>UID</code></p><p>the message UID (numeric).</p></li></ul><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">calendarGetEventUID</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> calendar</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Calendar&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> itemUID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;869760485.2.user&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">calendarEventUID</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> calendar</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Calendar&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> itemUID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;869760485.2.user&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h2 id="Signals" tabindex="-1">Signaling <a class="header-anchor" href="#Signals" aria-label="Permalink to &quot;Signaling {#Signals}&quot;">​</a></h2><p>A Client should use the &quot;bind&quot; operation to start receiving signals directed to the authenticated user.</p><p>A Client can maintain one or several concurrent communication sessions (&quot;calls&quot;). Each call is identified with its <code>callLeg</code> identifier. The <code>callLeg</code> attribute is present in all call-related operation requests and in all Server data messages related to that call. Each call is independent.</p><p>For each call, a Client should be able to create one or several &quot;media objects&quot;, which implement actual media (audio, video, etc.) communications. The media descrptor element (&quot;SDP elements&quot;) are data elements (text or XML) that a Client retrieves from and sends to &quot;media objects&quot;.<br> As a minimum, it should be possible to perform the following operations on each media object:</p><ul><li>retrieve an &quot;offer&quot; SDP from the media object, and then send it an &quot;answer&quot; SDP that describes the media object of the communication peer; or</li><li>send an &quot;offer&quot; SDP describing a communication peer to the media object, and then retrieve an &quot;answer&quot; SDP from that media object.</li></ul><p>If it is not possible to re-send an &quot;offer&quot; SDP to an already active media object, a new media object should be created, and the new &quot;offer&quot; SDP is sent to. If the &quot;answer&quot; SDP is successfully retrieved from the new media object, the old media object should be disposed of.</p><p>If it is not possible to re-retreive an &quot;offer&quot; SDP from an already active media object, a new media object should be created, and an &quot;offer&quot; SDP is retreieved from it. When the &quot;answer&quot; SDP received and sent to the new media object, the old media object should be disposed of.</p><p>A media object supports &quot;forking&quot; if it is possible to retrieve a single &quot;offer&quot; SDP from that media object, and then send several &quot;answer&quot; SDP elements to that media object, establishing several concurrent media communication channels.</p><p>Many messages and operation requests described in this section may contain an &quot;SDP descriptor&quot; as the XML body.<br> The SDP descriptor may be specified using the <a href="./Data.html#XMLSDP">XML presentation</a>, or as an sdpText XML element with the SDP descriptor in the native SDP text format.<br> The <a href="#signalBind"><code>signalBind</code></a> operation request specifies the format that the Server will be using in its messages (see below).</p><h3 id="signalBind" tabindex="-1">signalBind <a class="header-anchor" href="#signalBind" aria-label="Permalink to &quot;signalBind {#signalBind}&quot;">​</a></h3><p>This operation allows the current XIMSS session to receive signals directed to the authenticated user.</p><p>Attributes:</p><ul><li><p><code>clientID</code></p><p>an optional parameter specifying a name for this session. If not specified, the Server generates a unique one.</p></li><li><p><code>mode</code></p><p>if this attribute exists, and its value is fixed, the Server rejects the operation if the Account already has an open session using the same name;<br> if this attribute exists, and its value is kill, the Server closes the currently opened Account session with the same name (if any).<br> if this attribute does not exist or it has some other value, the Server generates a unique name for this session if the Account already has an open session that uses the specified name;</p></li><li><p><code>presence</code></p><p>if this optional attribute exists, and its value is yes, the client starts to receive <a href="#Roster">Roster and Presence</a> notifications.</p></li><li><p><code>readIM</code></p><p>if this optional attribute exists, and its value is 1, the <code>readIM</code> messages use the &quot;extended&quot; format.</p></li></ul><p>Body (optional):</p><p>the XML presentation of the client <a href="./Data.html#XMLSDP">SDP</a> descriptor.<br> The descriptor is used to specify the client capabilities (ability to accept audio/video calls) and to detect &quot;far-end NAT&quot; configurations.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To detect &quot;far-end NAT&quot; configurations, the SDP descriptor must contain the <code>ip</code> attribute with the default media IP address used by the client (see <a href="./Data.html#XMLSDP">below</a>).</p></div><p>An sdpText XML element can be used instead of the <a href="./Data.html#XMLSDP">SDP</a> element. The sdpText XML element body should be text containing SDP data in the SDP native format.<br> If the sdpText is used, then SDP information in <code>callIncoming</code>, <code>callProvisioned</code>, <code>callConnected</code>, and <code>callUpdated</code> Server messages is also presented using the sdpText XML element.</p><h3 id="signalUnbind" tabindex="-1">signalUnbind <a class="header-anchor" href="#signalUnbind" aria-label="Permalink to &quot;signalUnbind {#signalUnbind}&quot;">​</a></h3><p>After this operation is complete, the current XIMSS session does not receive signals directed to the authenticated user.</p><h3 id="callKill" tabindex="-1">callKill <a class="header-anchor" href="#callKill" aria-label="Permalink to &quot;callKill {#callKill}&quot;">​</a></h3><p>Use this operation to end the call and release all associated resources.<br> If the call was in the &#39;calling&#39; state, the outgoing call is canceled.<br> If the call was in the &#39;alerting&#39; state, the incoming call is rejected.<br> If the call was in the &#39;connected&#39; state, the disconnect signal is sent to the peer.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.After this operation succeeds, it is possible to create a new call with the same identifier.</p></li></ul><p>Outgoing calls are initiated by the Client using the <a href="#callStart"><code>callStart</code></a> operation request. The Client should generate a unique <code>callLeg</code> attribute value for the <code>callStart</code> request. All other requests and messages related to this call will have the same <code>callLeg</code> attribute value.<br> When an outgoing call is started, the Server may send:</p><ul><li>zero, one, or several <a href="#callProvisioned"><code>callProvisioned</code></a> messages</li><li>zero, one, or several <a href="#callUpdateRequest"><code>callUpdateRequest</code></a> messages</li><li>zero or one <a href="#callUpdateSolicited"><code>callUpdateSolicited</code></a> message</li></ul><p>Each of these messages contains a <code>tag</code> attribute, identifying an &quot;early dialog&quot; (a &quot;ringing&quot; device) .<br> When an outgoing call is started, the Client may send:</p><ul><li>zero, one, or several <a href="#callUpdate"><code>callUpdate</code></a> operation requests for &quot;early&quot; dialogs established with <a href="#callProvisioned"><code>callProvisioned</code></a>, <a href="#callUpdateRequest"><code>callUpdateRequest</code></a>, <a href="#callUpdateSolicited"><code>callUpdateSolicited</code></a> messages. For each <a href="#callUpdate"><code>callUpdate</code></a> operation requests, the Server sends back a <a href="#callUpdated"><code>callUpdated</code></a> message.</li></ul><p>An outgoing call becomes an &quot;established&quot; call when the Server sends a <a href="#callConnected"><code>callConnected</code></a> message.<br> An outgoing call fails if the Server sends a <a href="#callDisconnected"><code>callDisconnected</code></a> message.<br> The Client can cancel a pending outgoing call using the <a href="#callKill"><code>callKill</code></a> operation.</p><p>Incoming calls are initiated by the Server sending to the Client a <a href="#callIncoming"><code>callIncoming</code></a> message.<br> The Server generates a unique <code>callLeg</code> value for the <code>callIncoming</code> message. All other requests and messages related to this call will have the same <code>callLeg</code> attribute value. The Server-generated <code>callLeg</code> value for incoming calls use the inp prefix, so the Client should not use this prefix for the <code>callLeg</code> values it generates for outgoing calls.<br> When an incoming call is received, the Server may send:</p><ul><li>zero, one, or several <a href="#callUpdateRequest"><code>callUpdateRequest</code></a> messages</li></ul><p>When an incoming call is received, the Client may send:</p><ul><li>zero, one, or several <a href="#callProvision"><code>callProvision</code></a> operation requests. For each <a href="#callProvision"><code>callProvision</code></a> operation request, the Server sends back a <a href="#callUpdated"><code>callUpdated</code></a> message.</li><li>zero, one, or several <a href="#callUpdate"><code>callUpdate</code></a> operation requests. For each <a href="#callUpdate"><code>callUpdate</code></a> operation request, the Server sends back a <a href="#callUpdated"><code>callUpdated</code></a> message.</li></ul><p>An incoming call fails (it is cancelled) if the Server sends a <a href="#callDisconnected"><code>callDisconnected</code></a> message.<br> The Client can end processing an incoming call by rejecting the call with the <a href="#callReject"><code>callReject</code></a> operation, or by redirecting the call with the <a href="#callRedirect"><code>callRedirect</code></a> operation.<br> The Client can accept an incoming call with the <a href="#callAccept"><code>callAccept</code></a> operation, making it an &quot;established&quot; call.</p><p>When an outgoing call connects or when an incoming call is accepted, the call becomes an &quot;established&quot; one. Media in an established call flows in both directions (unless one party decides to put the call &quot;on hold&quot;).<br> When a call is established, the Server may send:</p><ul><li>zero, one, or several <a href="#callUpdateRequest"><code>callUpdateRequest</code></a> messages</li><li>zero, one, or several <a href="#callUpdateSolicited"><code>callUpdateSolicited</code></a> messages</li></ul><p>When a call is established, the Client may send:</p><ul><li>zero, one, or several <a href="#callUpdate"><code>callUpdate</code></a> operation requests. For each <a href="#callUpdate"><code>callUpdate</code></a> operation request, the Server sends back a <a href="#callUpdated"><code>callUpdated</code></a> message.</li></ul><p>An established call ends if the Server sends a <a href="#callDisconnected"><code>callDisconnected</code></a> message.<br> The Client can end an established call using the <a href="#callKill"><code>callKill</code></a> operation.</p><h3 id="callStart" tabindex="-1">callStart <a class="header-anchor" href="#callStart" aria-label="Permalink to &quot;callStart {#callStart}&quot;">​</a></h3><p>Use this operation to start an outgoing call.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the new call identifier. The current XIMSS session should have no other call with this identifier.</p></li><li><p><code>peer</code></p><p>an E-mail address or a SIP URI to call.</p></li><li><p><code>peerName</code></p><p>an optional string - the real name of the callee.</p></li></ul><p>Body (optional):</p><p>An <a href="#SDPdescriptor">SDP descriptor</a>.<br> If the <code>callStart</code> request succeeds, the new call object is created and an outgoing call is initiated.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The client should be ready to process call-related Server messages even before the client receives the positive response for this <code>callStart</code> request.</p></div><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the call fails (the <code>callDisconnected</code> message is received), the client still needs to use the <code>callKill</code> operation to release the resources associated with the call, and to allow itself to reuse the call identifier.</p></div><h5 id="media-handling" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h5><p>Call with SDP: the Client creates a media object (called &quot;untagged&quot; object).<br> The Client should configure the created media object to operate in the &quot;receiving-only&quot; mode.<br> The Client retrieves an &quot;offer SDP&quot; from that untagged media object, and sends that SDP with the <code>callStart</code> request.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>To process &quot;behind-the-NAT&quot; calls correctly, the SDP descriptor must contain the <code>ip</code> attribute with the default media IP address used with the client.</p></div><p>Call without SDP: the Client does not create any media object. The Cleint sends the <code>callStart</code> request without an SDP body element.</p><p>Optionally, the Client should be prepared to create additional media objects and to build an &quot;association mapping&quot;, where each created media object is accociated with a string - a value of the <code>tag</code> attribute of the receieved <a href="#callProvisioned"><code>callProvisioned</code></a> and/or <a href="#callUpdateRequest"><code>callUpdateRequest</code></a> messages.</p><h3 id="callProvision" tabindex="-1">callProvision <a class="header-anchor" href="#callProvision" aria-label="Permalink to &quot;callProvision {#callProvision}&quot;">​</a></h3><p>Use this operation to provision an incoming call (the call object is created when the <a href="#callIncoming"><code>callIncoming</code></a> message is received from the Server). Call provisioning informes the caller that the callee is being alerted (the callee&#39;s &quot;phone rings&quot;).</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the incoming call identifier.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>When the operation completes, the Client will receive the <a href="#callUpdated"><code>callUpdated</code></a> message from the Server.</p><h4 id="media-handling-1" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-1" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h4><p>If the Client wishes to send &quot;early media&quot; to the caller, the Client sends a <code>callProvision</code> request with SDP. &quot;Early media&quot; <em>may</em> be played by the caller&#39;s device instead of its default &quot;ringback&quot; tones.<br> To send early media, the Client should create an untagged media object.<br> The Client should configure the created media object to operate in the &quot;sending-only&quot; mode.</p><ul><li><p>If the <a href="#callIncoming"><code>callIncoming</code></a> message contained an SDP:</p><p>That SDP element is an &quot;offer&quot;.<br> The Client should send this &quot;offer&quot; SDP to the untagged media object.<br> Then the Client should retrieve the &quot;answer&quot; SDP from that media object and send it to the Server using the <code>callProvision</code> request.<br> Then the Client can instruct the media object to play the desired &quot;early media&quot;.</p></li><li><p>If the <a href="#callIncoming"><code>callIncoming</code></a> message did not contain an SDP:</p><p>The Client should retrieve an &quot;offer&quot; SDP from the untagged media object and send it to the Server using the <code>callProvision</code> request.<br> When the Client receives the <a href="#callUpdated"><code>callUpdated</code></a> message from the Server, it will contain an error code or an &quot;answer&quot; SDP.<br> If the &quot;answer&quot; SDP is received, the Client should send it to the untagged media object, and then the Client can instruct the media object to play the desired &quot;early media&quot;.</p></li></ul><h3 id="callRedirect" tabindex="-1">callRedirect <a class="header-anchor" href="#callRedirect" aria-label="Permalink to &quot;callRedirect {#callRedirect}&quot;">​</a></h3><p>Use this operation to redirect an incoming call.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the incoming call identifier.</p></li><li><p><code>fork</code></p><p>if this optional attribute exists, and its value is yes, the call is directed to the specified destinations, but it is still pending for this session, and it can be accepted or rejected.</p></li></ul><p>Body:</p><p>one or more XML <code>To</code> elements. Each element should have a text body specifying a URI to redirect the call to.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The client still needs to use the <code>callKill</code> operation to release the resources associated with the call and to allow itself to reuse the call identifier.</p></div><p>Example:<br> Redirecting an incoming call <code>inp003</code> to the <code>user1@example.com</code> and <code>user2@example.com</code>.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">callRedirect</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A018&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> callLeg</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;inp003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user1@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user2@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">callRedirect</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A018&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h4 id="media-handling-2" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-2" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h4><p>The Client should dispose of all media objects associated with this call.</p><h3 id="callReject" tabindex="-1">callReject <a class="header-anchor" href="#callReject" aria-label="Permalink to &quot;callReject {#callReject}&quot;">​</a></h3><p>Use this operation to reject an incoming call. You can also use the <code>callKill</code> operation, but this operation allows you to specify an error code.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the incoming call identifier.</p></li><li><p><code>signalCode</code></p><p>a numeric code (defined with the SIP standards) to pass to the Signal component as an error code.<br> Use the 486 code (&quot;Busy here&quot;) to signal that this device is &quot;busy&quot; (but other devices registered for this user will continue to ring).<br> Use a 6xx code (600 - &quot;Busy Everywhere&quot; or 603 - &quot;Declined&quot;) to signal that the user does not want to accept this call on any device (all other devices will stop ringing, too).<br> If this parameter is not specified, the 603 code is used.<strong>Note:</strong> the client still needs to use the <code>callKill</code> operation to release the resources associated with the call and to allow itself to reuse the call identifier.</p></li></ul><p>Example:<br> Rejecting an incoming call <code>inp004</code> with the 603 &quot;Declined&quot; code:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">callReject</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A020&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> callLeg</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;inp004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> signalCode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;603&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A020&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h4 id="media-handling-3" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-3" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h4><p>The Client should dispose of all media objects associated with this call.</p><h3 id="callAccept" tabindex="-1">callAccept <a class="header-anchor" href="#callAccept" aria-label="Permalink to &quot;callAccept {#callAccept}&quot;">​</a></h3><p>Use this operation to accept an incoming call.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the incoming call identifier.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>When the operation completes, the Client will receive the <a href="#callUpdated"><code>callUpdated</code></a> message from the Server.</p><h4 id="media-handling-4" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-4" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h4><p>The Client should create an untagged media object, if it has not been created yet.</p><ul><li><p>If the Client has already sent a <a href="#callProvision"><code>callProvision</code></a> request with SDP:</p><p>The <code>callAccept</code> request should contain no SDP element, and the <code>callUpdated</code> message will not contain any SDP element.</p></li><li><p>If the Client has not sent any <a href="#callProvision"><code>callProvision</code></a> request with SDP, and the <a href="#callIncoming"><code>callIncoming</code></a> message contained an SDP:</p><p>That SDP element is an &quot;offer&quot;.<br> The Client should send this &quot;offer&quot; SDP to the untagged media object.<br> Then the Client should retrieve the &quot;answer&quot; SDP from that media object and send it to the Server using the <code>callAccept</code> request.<br> When the connection is established, the Client will receive the <a href="#callUpdated"><code>callUpdated</code></a> message without an SDP from the Server.</p></li><li><p>If the Client has not sent any <a href="#callProvision"><code>callProvision</code></a> request with SDP, and the <a href="#callIncoming"><code>callIncoming</code></a> message did not contain an SDP:</p><p>The Client should retrieve an &quot;offer&quot; SDP from the untagged media object and send it to the Server using the <code>callAccept</code> request.<br> The Client will receive the <a href="#callUpdated"><code>callUpdated</code></a> message from the Server, which contains an &quot;answer&quot; SDP.<br> The Client should send that &quot;answer&quot; SDP to the untagged media object.<br> The Client should configure the &quot;untagged&quot; media object to stop playing &quot;early media&quot; and to operate in the &quot;sending and receiving&quot; mode.</p></li></ul><h3 id="callUpdate" tabindex="-1">callUpdate <a class="header-anchor" href="#callUpdate" aria-label="Permalink to &quot;callUpdate {#callUpdate}&quot;">​</a></h3><p>Use this operation to update a call (to modify the call SDP descriptor). The Client may need to use this function if it places a call on hold or resumes it, when it changes the number and/type of the media streams (for example, adds a vidio stream to an audio call), switches to a different media object, etc.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>tag</code></p><p>optional: the &quot;to-tag&quot; (dialog/fork ID) of an &quot;early&quot; dialog; should be used when updating an outgoing call.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>When the operation completes, the Client will receive a <a href="#callUpdated"><code>callUpdated</code></a> message from the Server.<br> If the operation fails, the <code>callUpdated</code> message contains <code>signalCode</code> and <code>errorText</code> attributes. If the operation succeeds, the <code>callUpdated</code> message does not contain these attributes.</p><h4 id="media-handling-5" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-5" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h4><p>If the Client does not want to modify the call SDP descriptor, it should send the <code>callUpdate</code> request without an SDP descriptor. The Server will send back a <code>callUpdated</code>message without an SDP element.</p><p>To modify the call SDP descriptor, the Client should retrieve a new &quot;offer&quot; SDP from the untagged media object. Alternatively, it should create a new media object and retrieve the &quot;offer&quot; SDP from it. This &quot;offer&quot; SDP should be sent using the <code>callUpdate</code> request.<br> If the <code>callUpdated</code> message received does not contain an <code>errorText</code> attribute, it contains an &quot;answer&quot; SDP, and the Client should send it to the same media object. If it is a newly created media object, the old &quot;untagged&quot; media object should be removed, and the new one should become the current &quot;untagged&quot; media object.<br> If the operation fails, the <code>callUpdated</code> message contains an <code>errorText</code> attribute. In this case, the untagged media object should be reverted to its previous state. If a new media object has been created to retrieve an &quot;offer&quot; SDP, that new media object should be removed.</p><h3 id="callTransfer" tabindex="-1">callTransfer <a class="header-anchor" href="#callTransfer" aria-label="Permalink to &quot;callTransfer {#callTransfer}&quot;">​</a></h3><p>Use this operation to transfer the connected peer to a different party.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>peer</code></p><p>an E-mail address or a SIP URI to transfer the call to. Use this attribute to initiate a &quot;blind transfer&quot; operation.</p></li><li><p><code>otherLeg</code></p><p>the call identifier. It should specify some other &quot;call&quot; in this session. Both calls should be in the &#39;connected&#39; state. Use this attribute to complete an &quot;attended transfer&quot; operation. The remote peer of the &quot;callLeg&quot; call is connected to the remote peer of the &quot;otherLeg&quot; call.</p></li></ul><p>If the <code>otherLeg</code> attribute is specified, the <code>peer</code> attribute is ignored.</p><p>If the call transfer operation succeeds, the &quot;callLeg&quot; call is disconnected (the <a href="#callDisconnected"><code>callDisconnected</code></a> data message is sent to the client). Additionally, in the case of an &quot;attended transfer&quot;, the client receives the <code>callDisconnected</code> message for the &quot;otherLeg&quot; call, too.</p><p>If the call transfer operation fails, a <a href="#callOpFailed"><code>callOpFailed</code></a> data message is sent to the client.</p><h3 id="callUpdateAccept" tabindex="-1">callUpdateAccept <a class="header-anchor" href="#callUpdateAccept" aria-label="Permalink to &quot;callUpdateAccept {#callUpdateAccept}&quot;">​</a></h3><p>Use this operation to accept call SDP modifications.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.The Client should send this request in response to <a href="#callUpdateRequest"><code>callUpdateRequest</code></a>, <a href="#callProvisioned"><code>callProvisioned</code></a>, and <a href="#callConnected"><code>callConnected</code></a> messages. See the description of these messages for the details.</p><h3 id="callUpdateReject" tabindex="-1">callUpdateReject <a class="header-anchor" href="#callUpdateReject" aria-label="Permalink to &quot;callUpdateReject {#callUpdateReject}&quot;">​</a></h3><p>Use this operation to reject call SDP modifications.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>signalCode</code></p><p>the numeric code (defined with the SIP standards) to pass to the Signal component as an error code.<br> If this attribute is absent, the 488 code (&quot;Not Acceptable Here&quot;) is used.</p></li></ul><p>Body:</p><p>none.The Client should send this request instead of the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request if the Client fails to perform the requested SDP modification.<br> See <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> description for the details.</p><h3 id="callSendDTMF" tabindex="-1">callSendDTMF <a class="header-anchor" href="#callSendDTMF" aria-label="Permalink to &quot;callSendDTMF {#callSendDTMF}&quot;">​</a></h3><p>Use this operation to send a DTMF signal via the signaling path.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p>Body:</p></li></ul><p>a one-symbol string with the DTMF code to send (10 for &#39;*&#39;, 11 for &#39;#&#39;).</p><p>If the operation succeeds, the server sends a <a href="#callOpCompleted"><code>callOpCompleted</code></a> message.</p><p>If the operation fails, the server sends a <a href="#callOpFailed"><code>callOpFailed</code></a> message.</p><h3 id="callSendInfo" tabindex="-1">callSendInfo <a class="header-anchor" href="#callSendInfo" aria-label="Permalink to &quot;callSendInfo {#callSendInfo}&quot;">​</a></h3><p>Use this operation to send an INFO signal to the connected peer.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p><p>Body:</p></li></ul><p>a <code>MIME</code> XML element:</p><p>Attributes:</p><ul><li><code>type</code></li></ul><p>INFO content Content-Type.</p><ul><li><code>subtype</code></li></ul><p>INFO content subtype (optional).</p><pre><code>Body:

a string with INFO content data.
</code></pre><p>If the operation succeeds, the server sends a <a href="#callOpCompleted"><code>callOpCompleted</code></a> data message.</p><p>If the operation fails, the server sends a <a href="#callOpFailed"><code>callOpFailed</code></a> data message.</p><h3 id="makeCall" tabindex="-1">makeCall <a class="header-anchor" href="#makeCall" aria-label="Permalink to &quot;makeCall {#makeCall}&quot;">​</a></h3><p>Use this operation to establish a call using any registered device or client. The Server initiates a call to the authenticated Account (&quot;self-call&quot;), causing all its registered devices and clients to ring. When any device answers the call, that device is instructed to call the specified address (or telephone number).</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>an E-mail address or a SIP URI to call.</p></li><li><p><code>callerParams</code></p><p>an optional attribute containing SIP R-URI (request-URI) parameters for the &quot;self-call&quot;.</p></li></ul><p>The operation completes as soon as the CG/PL task implementing this functionality is started. Asynchronous <a href="#makeCallReport"><code>makeCallReport</code></a> data messages are sent when the status of this task changes. When the call attempt completes, an empty <a href="#makeCallReport"><code>makeCallReport</code></a> data message is sent.</p><p>The Server can send the following data messages:</p><h5 id="callDisconnected" tabindex="-1">callDisconnected <a class="header-anchor" href="#callDisconnected" aria-label="Permalink to &quot;callDisconnected {#callDisconnected}&quot;">​</a></h5><p>These asynchronous data messages are sent when an outgoing call fails, when an incoming call is canceled, or when an established call disconnects:</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>signalCode</code></p><p>this optional attribute specifies the numeric signaling error code.</p></li><li><p><code>errorText</code></p><p>optional: specifies the call disconnect reason.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>The client still needs to use the <code>callKill</code> operation to release the resources associated with the call and to allow itself to reuse the call identifier.</p></div></li></ul><h6 id="media-handling-6" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-6" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><p>Dispose of all media objects associated with this call.</p><h5 id="callProvisioned" tabindex="-1">callProvisioned <a class="header-anchor" href="#callProvisioned" aria-label="Permalink to &quot;callProvisioned {#callProvisioned}&quot;">​</a></h5><p>These asynchronous data messages are sent when there is an outgoing call in progress, after a <a href="#callStart"><code>callStart</code></a> request was sent to the Server:</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>callId</code></p><p>the call Call-Id string</p></li><li><p><code>tag</code></p><p>the &quot;to-tag&quot; (dialog/fork ID) of an outgoing &quot;early&quot; dialog.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>In response, the Client should send a <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> or a <a href="#callUpdateReject"><code>callUpdateReject</code></a> request to the Server.</p><h6 id="media-handling-7" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-7" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><ul><li><p>If the <code>callProvisioned</code> message does not contain an SDP element:</p><p>if there is a media object or a ringback player associated with the <code>tag</code> attribute value, the Client should ignore this message.<br> Otherwise, the Client should create a ringback player (which plays a &quot;ringback&quot; sound, informing the user that the callee is being alterted), and associate this player with the <code>tag</code> attribute value.</p></li><li><p>If the <code>callProvisioned</code> message contains an SDP element, and there is a media object associated with the <code>tag</code> attribute value:</p><p>The SDP element is an &quot;offer&quot;.<br> The Client should use this &quot;offer&quot; SDP to update the associated media object. Then the Client should retrieve the &quot;answer&quot; SDP from that media object and send it to the Server using the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request.</p></li><li><p>If the <code>callProvisioned</code> message contains an SDP element, there is no media object associated with the <code>tag</code> attribute value, and the <a href="#callStart"><code>callStart</code></a> request contained an &quot;offer&quot; SDP:</p><p>The SDP element is an &quot;answer&quot;.<br> The Client should remember this &quot;answer&quot; SDP associated with the <code>tag</code> attribute value, replacing any older SDP associated with this <code>tag</code> attribute value.<br> If the &quot;untagged&quot; media object supports forking, the Client should send this &quot;answer&quot; SDP to that media object; the Client should also remove any ringback object associated with the <code>tag</code> attribute value.<br> If the &quot;untagged&quot; media object does not support &quot;forking&quot;, the Client should create a ringback player and associate it with the <code>tag</code> attribute value, if a ringback player associate with this value does not already exist.</p></li><li><p>If the <code>callProvisioned</code> message contains an SDP element, there is no media object associated with the <code>tag</code> attribute value, and the <a href="#callStart"><code>callStart</code></a> request did not contain an SDP:</p><p>The SDP element is an &quot;offer&quot;.<br> The Client should create a new media object and associate it with the <code>tag</code> attribute value. If there is a ringback object associated with the <code>tag</code> attribute value, the Client should remove it.<br> The Client should send this &quot;offer&quot; SDP to the newly created media object, retrieve the &quot;answer&quot; SDP from the media object, and send this &quot;answer&quot; SDP to the Server using the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request.</p></li></ul><p>If the Client cannot process the <code>callProvisioned</code> message, it should send the <a href="#callUpdateReject"><code>callUpdateReject</code></a> request to the Server.</p><h5 id="callConnected" tabindex="-1">callConnected <a class="header-anchor" href="#callConnected" aria-label="Permalink to &quot;callConnected {#callConnected}&quot;">​</a></h5><p>These asynchronous data messages are sent when an outgoing call (initiated with a <a href="#callStart"><code>callStart</code></a> request) succeeds, and the call is established:</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>callId</code></p><p>the call Call-Id string</p></li><li><p><code>peer</code></p><p>the address of the peer which has accepted this call.</p></li><li><p><code>tag</code></p><p>the &quot;to-tag&quot; (dialog/fork ID) of the established dialog.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>In response, the Client should send a <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> or a <a href="#callUpdateReject"><code>callUpdateReject</code></a> request to the Server.</p><h6 id="media-handling-8" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-8" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><ul><li><p>If there is a media object associated with the <code>tag</code> attribute value, and the <code>callConnected</code> message does not contain an SDP element:</p><p>The Client should remove all other media objects and all ringback players. The selected media object becomes the &quot;untagged&quot; media object.</p></li><li><p>If there is a media object associated with the <code>tag</code> attribute value, and the <code>callConnected</code> message contains an SDP element:</p><p>The SDP element is an &quot;offer&quot;.<br> The Client should send this &quot;offer&quot; SDP to the selected media object. Then the Client should retrieve the &quot;answer&quot; SDP from that media object and send it to the Server using the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request.<br> The Client should remove all other media objects and all ringback players. The selected media object becomes the &quot;untagged&quot; media object.</p></li><li><p>If there is no a media object associated with the <code>tag</code> attribute value, the <a href="#callStart"><code>callStart</code></a> request contained an &quot;offer&quot; SDP, and the <code>callConnected</code> message contains an SDP element:</p><p>The SDP element is an &quot;answer&quot;.<br> The Client should send this &quot;answer&quot; SDP to the &quot;untagged&quot; media object. If the media object supports &quot;forking&quot; and some &quot;answer&quot; SDP have been sent to it, the Client should instruct the media object so stop these other media communications.<br> The Client should remove all tagged media objects and ringback players.</p></li><li><p>If there is no a media object associated with the <code>tag</code> attribute value, the <a href="#callStart"><code>callStart</code></a> request contained an &quot;offer&quot; SDP, and the <code>callConnected</code> message does not contain an SDP element:</p><p>The SDP element is an &quot;answer&quot;.<br> If the media object supports &quot;forking&quot;, then some &quot;answer&quot; SDP associated with the <code>tag</code> attribute value has been already sent to it. The Client should instruct the media object to stop all other media communications.<br> If the media object does not support &quot;forking&quot;, then some &quot;answer&quot; SDP received with a <a href="#callProvisioned"><code>callProvisioned</code></a> message and associated with the <code>tag</code> attribute value should be &quot;remembered&quot;. The Client should send this remembered &quot;answer&quot; SDP to the untagged media object.<br> The Client should remove all tagged media objects and ringback players.</p></li><li><p>If there is no a media object associated with the <code>tag</code> attribute value, the <a href="#callStart"><code>callStart</code></a> request did not contain an &quot;offer&quot; SDP:</p><p>The <code>callConnected</code> message must contain an SDP element, and that SDP element is an &quot;offer&quot;.<br> The Client should create a new media object, and to send this &quot;offer&quot; SDP to the new media object. Then the Client should retrieve the &quot;answer&quot; SDP from that media object and send it to the Server using the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request.<br> The Client should remove all other media objects and all ringback players. The created media object becomes the &quot;untagged&quot; media object.</p></li></ul><p>The &quot;untagged&quot; media object (the only media object left) should be instructed to use the &quot;sending and receiving&quot; mode.</p><h5 id="callIncoming" tabindex="-1">callIncoming <a class="header-anchor" href="#callIncoming" aria-label="Permalink to &quot;callIncoming {#callIncoming}&quot;">​</a></h5><p>These asynchronous data messages are sent when new incoming calls are received (you need to use the <code>signalBind</code> operation to receive incoming calls):</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier. The Server generates these identifiers itself.</p></li><li><p><code>peer</code></p><p>the remote peer E-mail address.</p></li><li><p><code>peerName</code></p><p>optional; the remote peer real name.</p></li><li><p><code>callId</code></p><p>the call Call-Id string</p></li><li><p><code>transferredBy</code></p><p>optional; the E-mail address of the person who has transferred this call.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><h6 id="media-handling-9" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-9" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><p>The Client may create an &quot;untagged&quot; media object immediately, or it may create it when the Client sends <a href="#callProvision"><code>callProvision</code></a> or <a href="#callAccept"><code>callAccept</code></a> requests.</p><ul><li><p>If the <code>callIncoming</code> message contains an SDP element:</p><p>The SDP element is an &quot;offer&quot;.<br> The Client should pass this SDP to the &quot;untagged&quot; media object when it is created.</p></li></ul><h5 id="callUpdateRequest" tabindex="-1">callUpdateRequest <a class="header-anchor" href="#callUpdateRequest" aria-label="Permalink to &quot;callUpdateRequest {#callUpdateRequest}&quot;">​</a></h5><p>These asynchronous data messages are sent when the communication peer wants to update the call parameters (such as SDP).</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>tag</code></p><p>optional: the &quot;to-tag&quot; (dialog/fork ID) of an &quot;early&quot; dialog.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.</p><p>The client should answer by sending the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> or <a href="#callUpdateReject"><code>callUpdateReject</code></a> request to the Server.</p><h6 id="media-handling-10" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-10" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><ul><li><p>If the <code>callUpdateRequest</code> message does not contain an SDP element, the Client can ignore it.</p></li><li><p>If the <code>callUpdateRequest</code> message contains an SDP element:</p><p>This element is an &quot;offer&quot; SDP.<br> If the call is still outgoing, the Client should remove any &quot;ringback player&quot; associated with this tag.<br> The Client should find the media object associated with the <code>tag</code> attribute (or create a new media object if none is found).<br> If no <code>tag</code> attribute is specified, the &quot;untagged&quot; media object should be used.<br> The &quot;offer&quot; SDP from the <code>callUpdateRequest</code> message should be used to update the selected media object.<br> The client should retrieve the &quot;answer&quot; SDP from the selected media object, and send it to the Server using the <a href="#callUpdateAccept"><code>callUpdateAccept</code></a> request.<br> If the client does not want to or cannot accept the new &quot;offer&quot; SDP, it should inform the Server using the <a href="#callUpdateReject"><code>callUpdateReject</code></a> request.</p></li></ul><h5 id="callUpdated" tabindex="-1">callUpdated <a class="header-anchor" href="#callUpdated" aria-label="Permalink to &quot;callUpdated {#callUpdated}&quot;">​</a></h5><p>These asynchronous data messages are sent when an existing call is updated (placed on hold, switched to a different remote peer, etc.).</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>peer</code></p><p>optional; the remote peer E-mail address. It is sent when a call has been transferred.</p></li><li><p><code>peerName</code></p><p>optional; the remote peer real name.</p></li><li><p><code>signalCode</code></p><p>this optional attribute specifies the numeric signaling error code.</p></li><li><p><code>errorText</code></p><p>optional; the error message.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.This message is received in response to the <a href="#callUpdate"><code>callUpdate</code></a>, <a href="#callProvision"><code>callProvision</code></a>, <a href="#callAccept"><code>callAccept</code></a> requests. See the description of those requests for the details.</p><p>If the operation fails, the <code>signalCode</code> and <code>errorText</code> attributes are present.<br> If the operation succeeds, the <code>signalCode</code> and <code>errorText</code> attributes are absent, and an <a href="#SDPdescriptor">SDP descriptor</a> <em>may</em> be present.</p><h5 id="callUpdateSolicited" tabindex="-1">callUpdateSolicited <a class="header-anchor" href="#callUpdateSolicited" aria-label="Permalink to &quot;callUpdateSolicited {#callUpdateSolicited}&quot;">​</a></h5><p>These asynchronous data messages are sent when the communication peer wants to update the call SDP descriptor, but it wants this Client to provide an SDP offer.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>tag</code></p><p>optional: the &quot;to-tag&quot; (dialog/fork ID) of an &quot;early&quot; dialog.</p></li><li><p>Body (optional):</p></li></ul><p>An <a href="#SDPdescriptor">SDP descriptor</a>.The Server sends these messages only when a call is established or when an outgoing call is pending.</p><h6 id="media-handling-11" tabindex="-1">Media Handling <a class="header-anchor" href="#media-handling-11" aria-label="Permalink to &quot;Media Handling&quot;">​</a></h6><p>The Client should execute the <a href="#callUpdate"><code>callUpdate</code></a> operation with a new &quot;offer&quot; SDP.</p><p>If the Client cannot initiate a <code>callUpdate</code> operation (for example, it cannot create a new media object), it should send the <a href="#callUpdateReject"><code>callUpdateReject</code></a> request to the Server.</p><p>For a pending outgoing call, the Client should create a &quot;tagged&quot; media object, from which it should retrieve the &quot;offer&quot; SDP for the <a href="#callUpdate"><code>callUpdate</code></a> request.</p><h5 id="callOpCompleted" tabindex="-1">callOpCompleted <a class="header-anchor" href="#callOpCompleted" aria-label="Permalink to &quot;callOpCompleted {#callOpCompleted}&quot;">​</a></h5><p>These asynchronous data messages are sent when in-call operations (such as <code>callUpdate</code>, <code>callSendDTMF</code>, <code>callSendInfo</code>) are completed.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li></ul><h5 id="callOpFailed" tabindex="-1">callOpFailed <a class="header-anchor" href="#callOpFailed" aria-label="Permalink to &quot;callOpFailed {#callOpFailed}&quot;">​</a></h5><p>These asynchronous data messages are sent when in-call operations (such as <code>callUpdate</code>, <code>callSendDTMF</code>, <code>callSendInfo</code>) fail.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>signalCode</code></p><p>the numeric signaling error code.</p></li><li><p><code>errorText</code></p><p>the error message.</p></li></ul><h5 id="callDTMF" tabindex="-1">callDTMF <a class="header-anchor" href="#callDTMF" aria-label="Permalink to &quot;callDTMF {#callDTMF}&quot;">​</a></h5><p>These asynchronous data messages are sent when a DTMF signal is received via the signaling path.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p>Body:</p></li></ul><p>A string with the numeric DTMF code received.</p><h5 id="callTransferred" tabindex="-1">callTransferred <a class="header-anchor" href="#callTransferred" aria-label="Permalink to &quot;callTransferred {#callTransferred}&quot;">​</a></h5><p>These asynchronous data messages are sent when the remote peer has transferred the call to a different peer.</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p><code>peer</code></p><p>the new peer address.</p></li><li><p><code>peerName</code></p><p>optional; the new peer real name.</p></li><li><p><code>callId</code></p><p>the call Call-Id string; call transfer usually results in a Call-Id change.</p></li><li><p><code>mode</code></p><p>a hint on transfer scenario.</p></li><li><p><code>tag</code></p><p>a dialog fork identifier.</p></li><li><p>Body:</p></li></ul><p>Empty.</p><h5 id="callInfo" tabindex="-1">callInfo <a class="header-anchor" href="#callInfo" aria-label="Permalink to &quot;callInfo {#callInfo}&quot;">​</a></h5><p>These asynchronous data messages are sent when an INFO signal is received:</p><p>Attributes:</p><ul><li><p><code>callLeg</code></p><p>the call identifier.</p></li><li><p>Body:</p></li></ul><p>the same as in the <a href="#callSendInfo"><code>callSendInfo</code></a> request.</p><h5 id="makeCallReport" tabindex="-1">makeCallReport <a class="header-anchor" href="#makeCallReport" aria-label="Permalink to &quot;makeCallReport {#makeCallReport}&quot;">​</a></h5><p>These asynchronous data messages are sent after the <a href="#makeCall"><code>makeCall</code></a> operation is initiated.</p><p>Body:</p><p>A string containing the current operation status. A message contains an empty body if the calling process completes.</p><p>Example Incoming-01. Incoming call session with an initial SDP. The Client does not send any custom &quot;ringback&quot; media to the caller.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client receives a \`callIncoming\` message with a Server-generated \`callLeg\` attribute.</span></span>
<span class="line"><span>S:&lt;callIncoming id=&quot;A001&quot; callLeg=&quot;inp01&quot; peer=&quot;user@domain&quot; &gt;SDP:X(offer)&lt;/callIncoming&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client starts to alert the user (the Client starts &quot;ringing&quot;).</span></span>
<span class="line"><span>The Client notifiers the caller that the user is being alerted:</span></span>
<span class="line"><span>C:&lt;callProvision id=&quot;A001&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to accept this incoming call.</span></span>
<span class="line"><span>The Client creates an &quot;untagged&quot; media object A, and sends the received SDP:X(offer) (an &quot;offer&quot; SDP) to that media object A.</span></span>
<span class="line"><span>The Client retrieves an &quot;answer&quot; SDP from the media object A, and sends it to the Server, accepting the call:</span></span>
<span class="line"><span>C:&lt;callAccept id=&quot;A002&quot; callLeg=&quot;inp01&quot;&gt;SDP:A(answer)&lt;/callAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span>The Server sends back the \`callUpdated\` message:</span></span>
<span class="line"><span>S:&lt;callUpdated callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>Note: the \`callUpdated\` may arrive before arrival of the \`response\` message for the \`callAccept\` request.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client stops &quot;ringing&quot;.</span></span>
<span class="line"><span>The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callDisconnected callLeg=&quot;inp01&quot; /&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A003&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span></code></pre></div><p>Example Incoming-02. Incoming call session without an initial SDP. The Client does not send any custom &quot;ringback&quot; media to the caller.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client receives a \`callIncoming\` message with a Server-generated \`callLeg\` attribute.</span></span>
<span class="line"><span>S:&lt;callIncoming id=&quot;A001&quot; callLeg=&quot;inp01&quot; peer=&quot;user@domain&quot; /&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client starts to alert the user (the Client starts &quot;ringing&quot;).</span></span>
<span class="line"><span>The Client notifiers the caller that the user is being alerted:</span></span>
<span class="line"><span>C:&lt;callProvision id=&quot;A001&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to accept this incoming call.</span></span>
<span class="line"><span>The Client creates an &quot;untagged&quot; media object A, and retrieves an &quot;offer&quot; SDP from this media object: SDP:A(offer).</span></span>
<span class="line"><span>The Client sends this SDP to the Server, accepting the call:</span></span>
<span class="line"><span>C:&lt;callAccept id=&quot;A002&quot; callLeg=&quot;inp01&quot;&gt;SDP:A(offer)&lt;/callAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span>The Server sends back the \`callUpdated\` message with an &quot;answer&quot; SDP:</span></span>
<span class="line"><span>S:&lt;callUpdated callLeg=&quot;inp01&quot;&gt;SDP:X(answer)&lt;/callUpdated&gt;</span></span>
<span class="line"><span>Note: the \`callUpdated\` may arrive before arrival of the \`response\` message for the \`callAccept\` request.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client stops &quot;ringing&quot;.</span></span>
<span class="line"><span>The Client sends the received &quot;answer&quot; SDP to the media object A.</span></span>
<span class="line"><span>The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callDisconnected callLeg=&quot;inp01&quot; /&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A003&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span></code></pre></div><p>Example Incoming-03. Incoming call session with an initial SDP. The Client does not send any custom &quot;ringback&quot; media to the caller. The call has been cancelled by the caller (or some other client or device has answered this call).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client receives a \`callIncoming\` message with a Server-generated \`callLeg\` attribute.</span></span>
<span class="line"><span>S:&lt;callIncoming id=&quot;A001&quot; callLeg=&quot;inp01&quot; peer=&quot;user@domain&quot; &gt;SDP:X(offer)&lt;/callIncoming&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client starts to alert the user (the Client starts &quot;ringing&quot;).</span></span>
<span class="line"><span>The Client notifiers the caller that the user is being alerted:</span></span>
<span class="line"><span>C:&lt;callProvision id=&quot;A001&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The incoming call is cancelled:</span></span>
<span class="line"><span>S:&lt;callDisconnected callLeg=&quot;inp01&quot; /&gt;</span></span>
<span class="line"><span>The call ends (it is a &quot;missed&quot; call for this Client), the Client stops &quot;ringing&quot;.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A002&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span></code></pre></div><p>Example Incoming-04. Incoming call session with an initial SDP. The Client does not send any custom &quot;ringback&quot; media to the caller. The call has been declined by the user.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client receives a \`callIncoming\` message with a Server-generated \`callLeg\` attribute.</span></span>
<span class="line"><span>S:&lt;callIncoming id=&quot;A001&quot; callLeg=&quot;inp01&quot; peer=&quot;user@domain&quot; &gt;SDP:X(offer)&lt;/callIncoming&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client starts to alert the user (the Client starts &quot;ringing&quot;).</span></span>
<span class="line"><span>The Client notifiers the caller that the user is being alerted:</span></span>
<span class="line"><span>C:&lt;callProvision id=&quot;A001&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The incoming call is declined:</span></span>
<span class="line"><span>S:&lt;callReject id=&quot;A002&quot; callLeg=&quot;inp01&quot; signalCode=&quot;603&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client stops &quot;ringing&quot;.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A003&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span></code></pre></div><p>Example Incoming-05. Incoming call session with an initial SDP. The Client does not send any custom &quot;ringback&quot; media to the caller. The user has redirected the call to the <code>voicemail</code> application.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client receives a \`callIncoming\` message with a Server-generated \`callLeg\` attribute.</span></span>
<span class="line"><span>S:&lt;callIncoming id=&quot;A001&quot; callLeg=&quot;inp01&quot; peer=&quot;user@domain&quot; &gt;SDP:X(offer)&lt;/callIncoming&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client starts to alert the user (the Client starts &quot;ringing&quot;).</span></span>
<span class="line"><span>The Client notifiers the caller that the user is being alerted:</span></span>
<span class="line"><span>C:&lt;callProvision id=&quot;A001&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The incoming call is redirected:</span></span>
<span class="line"><span>S:&lt;callRedirect id=&quot;A002&quot; callLeg=&quot;inp01&quot;&gt;&lt;To&gt;#voicemail&lt;/To&gt;&lt;/callRedirect&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client stops &quot;ringing&quot;.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A003&quot; callLeg=&quot;inp01&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span></code></pre></div><p>Example Outgoing-01. Outgoing call session with an initial SDP.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client creates a media object A and makes it the &quot;untagged&quot; media object for the new call.</span></span>
<span class="line"><span>The Client retrieves the &quot;offer&quot; SDP from that object: SDP:A(offer)</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot;&gt;SDP:A(offer)&lt;/callStart&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client already has a &quot;ringback player&quot; for this device (tag), so it does not do any additional media operation.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer)&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot;, and passes the received SDP:X(answer) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A. The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callDisconnected callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span></code></pre></div><p>Example Outgoing-02. Outgoing call session with an initial SDP, multiple callee devices. Media objects do not support &quot;forking&quot;. The Client does not support advanced outgoing call messages.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client creates a media object A and makes it the &quot;untagged&quot; media object for the new call.</span></span>
<span class="line"><span>The Client retrieves the &quot;offer&quot; SDP from that object: SDP:A(offer)</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot;&gt;SDP:A(offer)&lt;/callStart&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client creates one more &quot;ringback player&quot;, so the user knows that the communication peer is being alerted. Both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer1)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer1) received, associated with the tag &quot;device1&quot;. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer2)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer2) received, associated with the tag &quot;device1&quot;. It replaces the SDP:X(answer1) received for this tag earlier. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateRequest callLeg=&quot;c1&quot; tag=&quot;device3&quot;&gt;SDP:Y(offer)&lt;/callUpdateRequest&gt;</span></span>
<span class="line"><span>C:&lt;callUpdateReject id=&quot;A006&quot; callLeg=&quot;c1&quot; errorText=&quot;not implemented&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateSolicited callLeg=&quot;c1&quot; tag=&quot;device4&quot; /&gt;</span></span>
<span class="line"><span>C:&lt;callUpdateReject id=&quot;A006&quot; callLeg=&quot;c1&quot; errorText=&quot;not implemented&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer3)&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, and passes the received SDP:X(answer3) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, and retrieves the SDP:X(answer2) media descriptor, as it was the last one it stored for the &quot;device1&quot; tag. The Client passes the received SDP:X(answer2) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A006&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to end this call, the Client ends this call and releases the Server resources associated with this call:</span></span>
<span class="line"><span>S:&lt;callKill id=&quot;A007&quot; callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A007&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span></code></pre></div><p>Example Outgoing-03. Outgoing call session with an initial SDP, multiple callee devices. Media objects do not support &quot;forking&quot;, additional messages from the called devices.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client creates a media object A and makes it the &quot;untagged&quot; media object for the new call.</span></span>
<span class="line"><span>The Client retrieves the &quot;offer&quot; SDP from that object: SDP:A(offer)</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot;&gt;SDP:A(offer)&lt;/callStart&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client creates one more &quot;ringback player&quot;, so the user knows that the communication peer is being alerted. Both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer1)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer1) received, associated with the tag &quot;device1&quot;. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer2)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer2) received, associated with the tag &quot;device1&quot;. It replaces the SDP:X(answer1) received for this tag earlier. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateRequest callLeg=&quot;c1&quot; tag=&quot;device2&quot;&gt;SDP:Y(offer)&lt;/callUpdateRequest&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot; associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>The Client creates a new &quot;tagged&quot; media object B, and associates it with the &quot;device2&quot; tag. The media object B is configured to work in the &quot;receiving only&quot; mode.</span></span>
<span class="line"><span>The Client passes the received SDP:Y(offer) as an &quot;offer&quot; SDP to this media object B.</span></span>
<span class="line"><span>The Client retrieves the &quot;answer&quot; SDP from that media object: SDP:B(answer), and passes it to the Server:</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A006&quot; callLeg=&quot;c1&quot;&gt;SDP:B(answer)&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer3)&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes the &quot;tagged&quot; media object B, and passes the received SDP:X(answer3) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes the &quot;tagged&quot; media object B, and retrieves the SDP:X(answer2) media descriptor, as it was the last one it stored for the &quot;device1&quot; tag. The Client passes the received SDP:X(answer2) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it, and with a different tag:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes the &quot;untagged&quot; media object A, and makes the &quot;tagged&quot; media object B (associated with the &quot;device2&quot; tag) the new &quot;untagged&quot; media object.</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>The call has connected, the &quot;untagged&quot; media object (be it A or B) is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A007&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A007&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to end this call, the Client ends this call and releases the Server resources associated with this call:</span></span>
<span class="line"><span>S:&lt;callKill id=&quot;A008&quot; callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A008&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span></code></pre></div><p>Example Outgoing-04. Outgoing call session with an initial SDP, multiple callee devices. Media objects do not support &quot;forking&quot;, additional messages from the called devices.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client creates a media object A and makes it the &quot;untagged&quot; media object for the new call.</span></span>
<span class="line"><span>The Client retrieves the &quot;offer&quot; SDP from that object: SDP:A(offer)</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot;&gt;SDP:A(offer)&lt;/callStart&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client creates one more &quot;ringback player&quot;, so the user knows that the communication peer is being alerted. Both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer1)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer1) received, associated with the &quot;device1&quot; tag. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer2)&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client stores the SDP:X(answer2) received, associated with the &quot;device1&quot; tag. It replaces the SDP:X(answer1) received for this tag earlier. No changes to the media, both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateRequest callLeg=&quot;c1&quot; tag=&quot;device2&quot;&gt;SDP:Y(offer1)&lt;/callUpdateRequest&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot; associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>The Client creates a new media object B, and associates it with the &quot;device2&quot; tag. The media object B is configured to work in the &quot;receiving only&quot; mode.</span></span>
<span class="line"><span>The Client passes the received SDP:Y(offer1) as an &quot;offer&quot; SDP to this media object B.</span></span>
<span class="line"><span>The Client retrieves the &quot;answer&quot; SDP from that media object: SDP:B(answer), and passes it to the Server:</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A006&quot; callLeg=&quot;c1&quot;&gt;SDP:B(answer)&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateRequest callLeg=&quot;c1&quot; tag=&quot;device2&quot;&gt;SDP:Y(offer2)&lt;/callUpdateRequest&gt;</span></span>
<span class="line"><span>The Client uses the received SDP to update the existing media object B associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>If this is not possible, the Client creates a new media object C, sends it the received SDP:Y(offer2) as an &quot;offer&quot; SDP, and retrieves from that media object the &quot;answer&quot; SDP:C(answer). If it succeeds, it removes the media object B and makes the newly created media object C a &quot;tagged&quot; media object associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>The new media object C is configured to work in the &quot;receiving only&quot; mode.</span></span>
<span class="line"><span>The Client and passes the retrieved &quot;answer&quot; SDP to the Server:</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A007&quot; callLeg=&quot;c1&quot;&gt;SDP:C(answer)&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A007&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callUpdateSolicited callLeg=&quot;c1&quot; tag=&quot;device3&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a new media object D, and associates it with the &quot;device3&quot; tag.</span></span>
<span class="line"><span>The new media object D is configured to work in the &quot;receiving only&quot; mode.</span></span>
<span class="line"><span>The Client retrieves the &quot;offer&quot; SDP - SDP:D(offer) - from this media object, and passes it to the Server, using the \`callUpdate\` operation.</span></span>
<span class="line"><span>C:&lt;callUpdate id=&quot;A008&quot; callLeg=&quot;c1&quot;&gt;SDP:D(offer)&lt;/callUpdate&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A008&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Server then sends the \`callUpdated\` message:</span></span>
<span class="line"><span>S:&lt;callUpdated callLeg=&quot;c1&quot; tag=&quot;device3&quot;&gt;SDP:Z(answer)&lt;/callUpdated&gt;</span></span>
<span class="line"><span>The Client should pass the received SDP to the media object D as an &quot;answer&quot; SDP.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X(answer3)&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes all &quot;tagged&quot; media object (C and D), and passes the received SDP:X-3 media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes all &quot;tagged&quot; media object (C and D), and retrieves the SDP:X(answer2) media descriptor, as it was the last one it stored for the tag=&quot;device1&quot;. The Client passes the received SDP:X(answer2) media descriptor (it&#39;s an &quot;answer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it, and with a different tag:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes the &quot;untagged&quot; media object A and the tagged media object D, and makes the &quot;tagged&quot; media object C (associated with the &quot;device2&quot; tag) the new &quot;untagged&quot; media object.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it, and with a different tag:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device3&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, removes the &quot;untagged&quot; media object A and the tagged media object C, and makes the &quot;tagged&quot; media object D (associated with the &quot;device3&quot; tag) the new &quot;untagged&quot; media object.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The call has connected, the &quot;untagged&quot; media object (be it A, C, or D) is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A007&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A007&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to end this call, the Client ends this call and releases the Server resources associated with this call:</span></span>
<span class="line"><span>S:&lt;callKill id=&quot;A008&quot; callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A008&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span></code></pre></div><p>Example Outgoing-11. Outgoing call session without an initial SDP.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client does not create any media object before a call.</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client already has a &quot;ringback player&quot; for this device (tag), so it does not do any additional media operation.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:X-1&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot;, creates an &quot;untagged&quot; media object A, and passes the received SDP:X-1 media descriptor (it&#39;s an &quot;offer&quot; SDP) to its &quot;untagged&quot; media object A.</span></span>
<span class="line"><span>The Client retrieves the &quot;answer&quot; SDP (SDP:A-1) from the media object A, and sends it to the Server:</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;&gt;SDP:A-1&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span>The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callDisconnected callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The Client releases the Server resources associated with this call:</span></span>
<span class="line"><span>C:&lt;callKill id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span></code></pre></div><p>Example Outgoing-12. Outgoing call session without an initial SDP, multiple callee devices.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>The Client does not create any media object before a call.</span></span>
<span class="line"><span>C:&lt;callStart id=&quot;A001&quot; callLeg=&quot;c1&quot; peer=&quot;user@domain&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A001&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device1&quot;/&gt;</span></span>
<span class="line"><span>The Client creates a &quot;ringback player&quot; so the user knows that the communication peer is being alerted.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A002&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A002&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client creates one more &quot;ringback player&quot;, so the user knows that the communication peer is being alerted. Both players are playing.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A003&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A003&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callProvisioned callLeg=&quot;c1&quot; tag=&quot;device2&quot;&gt;SDP:X-1&lt;/callProvisioned&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot; associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>The Client creates a media object A, makeing it a &quot;tagged&quot; object associated with the &quot;device2&quot; tag.</span></span>
<span class="line"><span>The Client sends the received SDP:X-1 as an &quot;offer&quot; SDP to the media object A.</span></span>
<span class="line"><span>The Client retrieves an &quot;answer&quot; SDP from the media object A (SDP:A-1) and sends it to the Server.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A004&quot; callLeg=&quot;c1&quot;&gt;SDP:A-1&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A004&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device1&quot;&gt;SDP:Y-1&lt;/callConnected&gt;</span></span>
<span class="line"><span>The Client removes the &quot;ringback player&quot;, and the media object A (tagged with the &quot;device2&quot; tag).</span></span>
<span class="line"><span>The Client creates a media object B, making it the &quot;untagged&quot; media object, and sends the received SDP:Y-1 media descriptor (it&#39;s an &quot;offer&quot; SDP) to this &quot;untagged&quot; media object B.</span></span>
<span class="line"><span>The Client retrieves an &quot;answer&quot; SDP from the media object B (SDP:B-1) and sends it to the Server.</span></span>
<span class="line"><span>The call has connected, the media object B is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A005&quot; callLeg=&quot;c1&quot;&gt;SDP:B-1&lt;/callUpdateAccept&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Alternatively, the &lt;callConnected/&gt; message could come without any SDP in it and with a different device tag:</span></span>
<span class="line"><span>S:&lt;callConnected callLeg=&quot;c1&quot; tag=&quot;device2&quot;/&gt;</span></span>
<span class="line"><span>The Client removes all &quot;ringback players&quot;, and makes the media object A (associated with the &quot;device2&quot; tag) the &quot;untagged&quot; media object.</span></span>
<span class="line"><span>The call has connected, the media object A is instructed to work in the &quot;send and receive&quot; mode, communications started.</span></span>
<span class="line"><span>C:&lt;callUpdateAccept id=&quot;A005&quot; callLeg=&quot;c1&quot;/&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A005&quot;/&gt;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>The user instructs the Client to end this call, the Client ends this call and releases the Server resources associated with this call:</span></span>
<span class="line"><span>S:&lt;callKill id=&quot;A006&quot; callLeg=&quot;c1&quot; /&gt;</span></span>
<span class="line"><span>S:&lt;response id=&quot;A006&quot;/&gt;</span></span>
<span class="line"><span>The call ends, the Client removes the &quot;untagged&quot; media object A.</span></span></code></pre></div><h2 id="IM" tabindex="-1">Instant Messaging <a class="header-anchor" href="#IM" aria-label="Permalink to &quot;Instant Messaging {#IM}&quot;">​</a></h2><p>The Instant Messaging (IM) model assumes that a client maintains a separate window for each &quot;peer&quot;, where a &quot;peer&quot; is some other IM user taking part in an IM conversation.</p><h3 id="sendIM" tabindex="-1">sendIM <a class="header-anchor" href="#sendIM" aria-label="Permalink to &quot;sendIM {#sendIM}&quot;">​</a></h3><p>This operation sends an Instant Message to the specified user. The Server sends a XIMSS response without waiting till the Instant Message is actually delivered (or failed).<br> There is no explicit IM session opening operation. If the Server does not have an open IM session with the specified peer, a new session is created.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the E-mail address of the user to send this message to.</p></li><li><p><code>clientID</code></p><p>optional; the name or ID of the peer device to send this message to.</p></li><li><p><code>type</code></p><p>optional; the message XMPP-style type - <code>chat</code>, <code>groupchat</code>, etc.</p></li><li><p><code>iqid</code></p><p>optional; the message identifier string.</p></li><li><p>Body:</p></li><li><p>the Instant Message text (in the UTF-8 encoding) or</p></li><li><p>the <code>body</code> XML element, with the Instant Message text as its body, and, optionally, other XML message elements. Or</p></li><li><p>the <code>composing</code> XML element (this element should be sent when the user is preparing the message but has not sent it yet). Or</p></li><li><p>the <code>paused</code> XML element (this element should be sent when the user has stopped preparing the message before sending it). Or</p></li><li><p>the <code>gone</code> XML element (this element should be sent when the user has finished the conversation).</p></li><li><p>the <code>subject</code> XML element; its text body is the message subject string.</p></li></ul><h3 id="closeIM" tabindex="-1">closeIM <a class="header-anchor" href="#closeIM" aria-label="Permalink to &quot;closeIM {#closeIM}&quot;">​</a></h3><p>A request to close all IM sessions with the specified user.<br> A client application should send this request when it closes an IM conversation window.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the user E-mail address.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="readIM" tabindex="-1">readIM <a class="header-anchor" href="#readIM" aria-label="Permalink to &quot;readIM {#readIM}&quot;">​</a></h5><p>These asynchronous data messages are sent when the Server receives an Instant Message for the client user.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the sender E-mail address.</p></li><li><p><code>peerName</code></p><p>optional; the sender real name.</p></li><li><p><code>clientID</code></p><p>optional; the name or ID of the peer device this message was sent from.</p></li><li><p><code>subject</code></p><p>optional; the message subject string (if the basic format is used).</p></li><li><p><code>iqid</code></p><p>optional; the message identifier string.</p></li><li><p><code>gmtTime</code></p><p>optional; the time stamp when the message was received.</p></li><li><p>Body:</p></li><li><p>the <code>composing</code> XML element; this element is sent when the remote peer is preparing (typing) the message but has not sent it yet. Or</p></li><li><p>the <code>paused</code> XML element; this element is sent when the remote peer has stopped preparing the message. Or</p></li><li><p>the <code>gone</code> XML element; this element is sent when the remote peer has finished the conversation. Or</p></li><li><p>the message content in the basic or extended format, as requested with the last <code>signalBind</code> operation:</p></li><li><p>simple format:</p><p>the Instant Message text (in the UTF-8 encoding)</p></li><li><p>extended format:</p><p>the <code>body</code> XML element with the body containing the Instant Message text, and optional additional XML message elements. the <code>subject</code> XML element; its text body is the message subject string.</p></li></ul><p>There is no explicit Instant Message session opening operation. If the client has no open conversation window for the specified user, it should open a new one.</p><h5 id="errorIM" tabindex="-1">errorIM <a class="header-anchor" href="#errorIM" aria-label="Permalink to &quot;errorIM {#errorIM}&quot;">​</a></h5><p>These asynchronous data messages are sent when the Server fails to deliver an Instant Message.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the recipient E-mail address.</p></li><li><p><code>errorText</code></p><p>the error message text.</p></li><li><p><code>signalCode</code></p><p>the numeric signaling error code.</p></li><li><p><code>sendid</code></p><p>the <code>id</code> attribute of the <code>sendIM</code> operation that sent the failed Instant Message.</p></li></ul><h2 id="Roster" tabindex="-1">Roster and Presence <a class="header-anchor" href="#Roster" aria-label="Permalink to &quot;Roster and Presence {#Roster}&quot;">​</a></h2><p>The Roster and Presence model resembles that of the <a href="./../admin/signals/XMPP.html">XMPP</a> protocol.</p><p>A Roster is a set of items, each item describing a &quot;contact&quot; - some other local or remote user. The user can monitor the presence information of a &quot;contact&quot;, and a &quot;contact&quot; can be granted a right to monitor the user&#39;s presence information.</p><h3 id="rosterList" tabindex="-1">rosterList <a class="header-anchor" href="#rosterList" aria-label="Permalink to &quot;rosterList {#rosterList}&quot;">​</a></h3><p>This operation retrieves all active Roster items.</p><p>Attributes:</p><ul><li><p><code>accountName</code></p><p>if this optional attribute is specified, the operation reads the Roster items from the specified Account.<br> The Server sends <a href="#rosterItem"><code>rosterItem</code></a> data messages for all currently active Roster &quot;contacts&quot;.</p></li></ul><h3 id="rosterSet" tabindex="-1">rosterSet <a class="header-anchor" href="#rosterSet" aria-label="Permalink to &quot;rosterSet {#rosterSet}&quot;">​</a></h3><p>This operation modifies a Roster &quot;contact&quot;.</p><p>Attributes:</p><ul><li><p><code>accountName</code></p><p>if this optional attribute is specified, the operation updates the Roster in the specified Account.</p></li><li><p><code>peer</code></p><p>the contact E-mail address.</p></li><li><p><code>subscription</code></p><p>an optional attribute:</p><ul><li><code>update</code> or no attribute: update the contact information.</li><li><code>remove</code>: remove the contact from the Roster.</li><li><code>subscribed</code>: confirm the contact request to monitor the user&#39;s presence information.</li><li><code>unsubscribed</code>: reject the contact request to monitor the user&#39;s presence information, or revoke the already granted right to monitor.</li><li><code>subscribe</code>: send a request to monitor the contact&#39;s presence information.</li><li><code>subBoth</code>: confirm the contact request to monitor the user&#39;s presence information, and send a request to monitor the contact&#39;s presence information.</li><li><code>unsubscribe</code>: stop monitoring the contact&#39;s presence information.</li></ul></li><li><p><code>name</code></p><p>an optional attribute specifying the Contact real name.</p></li><li><p>Body:</p></li></ul><p>a set of <code>group</code> XML elements; each element body specifies the name of a Group this contact belongs to.</p><p>The <code>update</code>, <code>subscribed</code>, and <code>subscribe</code> operations create a new Roster item if the item with the specified E-mail address does not exist.</p><h3 id="rosterGroupSet" tabindex="-1">rosterGroupSet <a class="header-anchor" href="#rosterGroupSet" aria-label="Permalink to &quot;rosterGroupSet {#rosterGroupSet}&quot;">​</a></h3><p>This operation manages Roster &quot;contact groups&quot;.</p><p>Attributes:</p><ul><li><p><code>accountName</code></p><p>if this optional attribute is specified, the operation updates the Roster in the specified Account.</p></li><li><p><code>group</code></p><p>the group name.</p></li><li><p><code>mode</code></p><ul><li><code>add</code>: create a new contact group with the specified name.</li><li><code>delete</code>: remove the exiting contact group with the specified name from the Roster.</li><li><code>rename</code>: rename the exiting contact group.</li></ul></li><li><p><code>newName</code></p><p>the new contact group name (used only with the <code>mode</code> attribute set to <code>rename</code>).</p></li></ul><h3 id="presenceSet" tabindex="-1">presenceSet <a class="header-anchor" href="#presenceSet" aria-label="Permalink to &quot;presenceSet {#presenceSet}&quot;">​</a></h3><p>This operation sets the user presence information. The Server aggregates the presence information reported by all currently connected clients (XIMSS, XMPP, SIP) and distributes it to all network entities subscribed to that information.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>this optional element may have the <code>unavailable</code> value. It indicates that the user is &quot;virtually offline&quot;.<br> If this attribute is absent, the user is online.</p></li><li><p>Body:</p></li></ul><p>an optional <code>show</code> XML element; its text body specifies the XMPP-style user presence status:</p><ul><li><code>dnd</code> - do not disturb, busy, on-the-phone.</li><li><code>away</code> - will be right back, in a meeting, out-to-lunch.</li><li><code>xa</code> - away (&quot;extended away&quot;).</li></ul><p>Alternatively, you can use a <code>presence</code> XML element instead of the <code>show</code> XML element. The <code>presence</code> XML element text body specifies the more detailed user presence status:</p><ul><li><code>offline</code> - &quot;virtually offline&quot;.</li><li><code>online</code> - online.</li><li><code>on-phone</code> - user is engaged into a real-time conversation.</li><li><code>in-meeting</code> - user is in a middle of a meeting.</li><li><code>busy</code> - generic form &quot;cannot chat right now&quot;.</li><li><code>be-back</code> - user will be right back</li><li><code>out-lunch</code> - user is out for a break/meal.</li><li><code>away</code> - extended away.</li></ul><p>The XML body can also contact an optional <code>status</code> XML element; its text body sets the custom status message. To remove a previously set custom status message, specify an empty <code>status</code> XML element.</p><p>When a session starts, the user is &quot;virtually offline&quot;. The client should use this operation to indicate that the user is online.</p><p>When the user disconnects, its session status is automatically changed to <code>unavailable</code> (offline).</p><p>This operation can also be used to send presence information to a specific target (for example, to join an XMPP conference room). To send presence information rather than to set it, use additional attributes:</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the E-mail address of the user or a conference room to send the presence information to.</p></li><li><p><code>clientID</code></p><p>optional; the name or ID of the peer device to send the presence information to.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="rosterItem" tabindex="-1">rosterItem <a class="header-anchor" href="#rosterItem" aria-label="Permalink to &quot;rosterItem {#rosterItem}&quot;">​</a></h5><p>These data messages are sent synchronously when the Server processes the <a href="#rosterList"><code>rosterList</code></a> request. One message is sent for each Roster item (&quot;Contact&quot;).<br> These data messages can also be sent sent asynchronously (see below).</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the contact E-mail address.</p></li><li><p><code>subscription</code></p><ul><li><code>to</code>: the user can monitor the contact.</li><li><code>from</code>: the contact can monitor the user.</li><li><code>both</code>: the user and the contact can monitor each other.</li><li><code>none</code>: the user and the contact do not monitor each other.</li></ul></li><li><p><code>ask</code></p><p>this optional attribute has the <code>subscribe</code> value if the user has requested a subscription to the contact&#39;s presence information, but this request has not been confirmed yet.</p></li><li><p><code>name</code></p><p>an optional attribute specifying the Contact real name.</p></li><li><p>Body:</p></li></ul><p>a set of <code>group</code> XML elements; each element body specifies the name of a Group this contact belongs to.<br> If the <a href="#Signals"><code>signalBind</code> operation</a> was used to enable Roster and Presence notifications:</p><ul><li>Every time a Roster item is added or updated, the Server sends <code>rosterItem</code> messages with the new or updated data.</li><li>Every time a Roster item is deleted, the Server sends the <code>rosterItem</code> message with the <code>subscription</code> attribute set to <code>remove</code>.</li><li>The Server sends the <a href="#presence"><code>presence</code></a> data messages.</li></ul><h5 id="presence" tabindex="-1">presence <a class="header-anchor" href="#presence" aria-label="Permalink to &quot;presence {#presence}&quot;">​</a></h5><p>These asynchronous data messages are sent when a presence state of some Roster &quot;contact&quot; (item) is changed, and Presence notifications are enabled.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the Contact E-mail address.</p></li><li><p><code>type</code></p><p>an optional attribute:</p><ul><li><code>unavailable</code>: the contact is offline.</li><li><code>subscribe</code>: the contact is requesting subscription to the user&#39;s presence information.</li><li><em>absent</em>: the contact is online.</li></ul></li><li><p>Body:</p></li></ul><p>a <code>presence</code> XML element; its text body specifies the detailed contact presence status (see above);<br> an optional <code>show</code> XML element; its text body specifies the XMPP-style contact presence status (see above).</p><p>These asynchronous data messages are also sent when a remote entity sends its presence information to this particular XIMSS session (for example, a remote conference room informs this session about users joining and leaving the room). In this case, the data message contains additional attributes.</p><p>Attributes:</p><ul><li><p><code>clientID</code></p><p>the name or ID of the peer device the presence information was sent from.</p></li></ul><h2 id="fullTextSearch" tabindex="-1">Full-Text Search <a class="header-anchor" href="#fullTextSearch" aria-label="Permalink to &quot;Full-Text Search {#fullTextSearch}&quot;">​</a></h2><h3 id="searchInIndex" tabindex="-1">searchInIndex <a class="header-anchor" href="#searchInIndex" aria-label="Permalink to &quot;searchInIndex {#searchInIndex}&quot;">​</a></h3><p>This operation performs a search for the search string with support for the <a href="./../admin/sysadmin/#searchSyntax">Query Syntax</a> in the <a href="./../admin/sysadmin/#searchIndex">Search Index</a> and, as a result, sends a <a href="#searchResult"><code>searchResult</code></a> message with the found data. If the string format is incorrect, the operation will not be processed, and the server will return an <code>Invalid Query</code> error.</p><p>Set of XML elements:</p><ul><li><p><code>searchString</code></p><p>search string.</p></li><li><p><code>searchOptions</code></p><p><a href="#searchOptions">search options</a>.</p></li></ul><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">searchInIndex</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;searchString&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;hello&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;searchOptions&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subkey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;limit&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;10&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subkey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;offset&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;0&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">searchInIndex</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">searchResult</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;limit&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;10&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;offset&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;0&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;total&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;count&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mails&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Subject&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;[Comm] test&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Body&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;0J/RgNC40LLQtdGCLCDQnNC40YAh&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Date&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20250304T144659&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;From&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Bob</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">bob@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Alice</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">alice@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Cc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Bcc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;In-Reply-To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Message-ID&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">gj2v6a$prm$1@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;References&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mailboxName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;INBOX&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;boxSeq&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;messageUid&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">searchResult</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><h4 id="searchOptions" tabindex="-1">Search options <a class="header-anchor" href="#searchOptions" aria-label="Permalink to &quot;Search options {#searchOptions}&quot;">​</a></h4><p>Search options determine which results will be retrieved from the <a href="./../admin/sysadmin/#searchIndex">Search Index</a>.</p><ul><li><p><code>limit</code></p><p>the maximum number of messages to return. Default is 50.</p></li><li><p><code>offset</code></p><p>the number of messages to skip before fetching. Default is 0.</p></li><li><p><code>fragmentSize</code></p><p>the size of the text fragment in which the search string was found. The fragment length reaches the specified value, but truncation occurs at word boundaries. By default, the full text is returned.</p></li><li><p><code>preTag</code></p><p>opening tag for highlighting the search string. Default is <code>&lt;b&gt;</code>.</p></li><li><p><code>postTag</code></p><p>closing tag for highlighting the search string. Default is <code>&lt;/b&gt;</code>.</p></li><li><p><code>returnBody</code></p><p>if the value is set to yes, the message body will be included in the search results. By default, it is not included.</p></li><li><p><code>dateFrom</code></p><p>start date of messages in the selection, in Unix Timestamp format. Default is 0, which corresponds to 1970-01-01T00:00:00Z.</p></li><li><p><code>dateTo</code></p><p>end date of messages in the selection, in Unix Timestamp format. Default is 4294967295, which corresponds to 2106-02-07T06:28:15Z.</p></li><li><p><code>fields</code></p><p>array of fields in which the search string is looked for. Default is <code>[&quot;From&quot;, &quot;To&quot;, &quot;Cc&quot;, &quot;Bcc&quot;, &quot;Subject&quot;, &quot;Body&quot;, &quot;Attachments&quot;]</code>.</p></li><li><p><code>mailboxNames</code></p><p>array of mailbox names in which the search string is looked for. By default, all mailboxes are included.</p></li><li><p><code>subject</code></p><p>subject of the message. This parameter supports <a href="./../admin/sysadmin/#searchSyntax">Query Syntax</a>. By default, this parameter is ignored.</p></li><li><p><code>from</code></p><p>sender’s email address or name. This parameter supports <a href="./../admin/sysadmin/#searchSyntax">Query Syntax</a>. By default, this parameter is ignored.</p></li><li><p><code>to</code></p><p>recipient’s email address or name. This parameter supports <a href="./../admin/sysadmin/#searchSyntax">Query Syntax</a>. By default, this parameter is ignored.</p></li><li><p><code>requiredFlags</code></p><p>array of <a href="./../admin/storage/Mailboxes.html#Flags">flags</a>; only messages with these flags will be included. By default, this parameter is ignored.</p></li><li><p><code>excludedFlags</code></p><p>array of <a href="./../admin/storage/Mailboxes.html#Flags">flags</a>; messages with these flags will be excluded. By default, this parameter is ignored.</p></li><li><p><code>priority</code></p><p>message priority (1–5) from the X-Priority header, where 1 is the highest and 5 is the lowest. By default, this parameter is ignored.</p></li><li><p><code>attachmentTypes</code></p><p>array of attachment types; only messages containing these types will be included, for example <code>[&quot;PDF&quot;, &quot;DOCX&quot;]</code>. Attachment types are case-insensitive. If only the presence of attachments is important, regardless of type, use an asterisk (<code>*</code>), for example <code>[&quot;*&quot;]</code>. By default, this parameter is ignored.</p></li></ul><h5 id="searchResult" tabindex="-1">searchResult <a class="header-anchor" href="#searchResult" aria-label="Permalink to &quot;searchResult {#searchResult}&quot;">​</a></h5><p>This message is sent when the Server processes the <a href="#searchInIndex"><code>searchInIndex</code></a> request.</p><p>Body:</p><p>Set of XML elements:</p><ul><li><p><code>limit</code></p><p>the maximum number of messages to return.</p></li><li><p><code>offset</code></p><p>the number of messages to skip before fetching.</p></li><li><p><code>total</code></p><p>the total number of messages found.</p></li><li><p><code>count</code></p><p>the number of messages returned in the selection.</p></li><li><p><code>mails</code></p><p>array of found messages.</p></li></ul><h3 id="readSearchIndexState" tabindex="-1">readSearchIndexState <a class="header-anchor" href="#readSearchIndexState" aria-label="Permalink to &quot;readSearchIndexState {#readSearchIndexState}&quot;">​</a></h3><p>As a result of this operation, the server sends a <a href="#searchIndexState"><code>searchIndexState</code></a> message with the current state of the <a href="./../sysadmin/#searchIndex">Search Index</a>.</p><h4 id="searchIndexState" tabindex="-1">searchIndexState <a class="header-anchor" href="#searchIndexState" aria-label="Permalink to &quot;searchIndexState {#searchIndexState}&quot;">​</a></h4><p>This message is sent when the server processes the <a href="#readSearchIndexState"><code>readSearchIndexState</code></a> request.</p><p>Body:</p><p>a string with the current state of the <a href="./../sysadmin/#searchIndex">Search Index</a>, which can have the following values:</p><ul><li><code>none</code> - Index does not exist.</li><li><code>waiting</code> - Waiting for index to be built.</li><li><code>indexing</code> - Index is being built.</li><li><code>ready</code> - Index is ready for use.</li></ul><h2 id="email-threads" tabindex="-1">Email Threads <a class="header-anchor" href="#email-threads" aria-label="Permalink to &quot;Email Threads&quot;">​</a></h2><p>Email threads are formed based on the <code>Message-ID</code> and <code>In-Reply-To</code> headers:</p><ul><li><code>Message-ID</code> — a header containing a unique identifier for each email.</li><li><code>In-Reply-To</code> — a header containing the <code>Message-ID</code> of the email being replied to.</li></ul><p>If an email includes the <code>In-Reply-To</code> header, it is considered a reply and added to the corresponding thread. If <code>In-Reply-To</code> is missing, the email is treated as the start of a new thread.</p><h3 id="fetchThread" tabindex="-1">fetchThread <a class="header-anchor" href="#fetchThread" aria-label="Permalink to &quot;fetchThread {#fetchThread}&quot;">​</a></h3><p>This operation searches for all emails that belong to the same thread as the specified message and responds with a <a href="#thread"><code>thread</code></a> message containing the found emails.</p><p>Attributes:</p><ul><li><code>folder</code> — the name of the folder view.</li><li><code>UID</code> — the UID of the message.</li></ul><p>Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fetchThread</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> folder</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;INBOX&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">thread</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mails&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Subject&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Hello&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Body&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SGkgQWxpY2Uh&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Date&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20250304T144659&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;From&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Bob</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">bob@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Alice</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">alice@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Cc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Bcc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;In-Reply-To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Message-ID&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">gj2v6a$prm$1@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;References&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mailboxName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;INBOX&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;boxSeq&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;messageUid&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Subject&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;RE: Hello&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Body&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:          &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SGkgQm9iIQ==&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">binString</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Date&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20250304T144725&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;From&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Alice</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">alice@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Bob</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">bob@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Cc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Bcc&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;In-Reply-To&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">gj2v6a$prm$1@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Message-ID&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">bs4j8r$zht51@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;References&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">gj2v6a$prm$1@example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mailboxName&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Sent Items&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;boxSeq&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;2&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;messageUid&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:        &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">number</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:      &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">thread</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span></code></pre></div><h3 id="thread" tabindex="-1">thread <a class="header-anchor" href="#thread" aria-label="Permalink to &quot;thread {#thread}&quot;">​</a></h3><p>This data message is sent when the server processes a <a href="#fetchThread"><code>fetchThread</code></a> request.</p><p>Body:</p><p>A set of XML elements:</p><ul><li><code>mails</code> — an array of found messages, sorted by date.</li></ul><h2 id="XMPPIQ" tabindex="-1">XMPP-style requests <a class="header-anchor" href="#XMPPIQ" aria-label="Permalink to &quot;XMPP-style requests {#XMPPIQ}&quot;">​</a></h2><p>A client can send and receive XMPP-style &quot;iq&quot; requests.</p><h3 id="iqSend" tabindex="-1">iqSend <a class="header-anchor" href="#iqSend" aria-label="Permalink to &quot;iqSend {#iqSend}&quot;">​</a></h3><p>This operation sends an XMPP-style &quot;iq&quot; request to the specified user. The Server sends a XIMSS response without waiting for the request to be actually delivered and processed.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the E-mail address of the user to send the iq request to.</p></li><li><p><code>clientID</code></p><p>optional; the name or ID of the peer device to send the iq request to.</p></li><li><p><code>type</code></p><p>the XMPP iq request type (<code>get</code>, <code>set</code>, <code>result</code>, or <code>error</code>).</p></li><li><p><code>iqid</code></p><p>this attribute value is used as the <code>id</code> attribute of the XMPP iq request.</p></li></ul><p>Body:</p><p>the XMPP iq request body.</p><p>The Server sends the following data messages:</p><h5 id="iqRead" tabindex="-1">iqRead <a class="header-anchor" href="#iqRead" aria-label="Permalink to &quot;iqRead {#iqRead}&quot;">​</a></h5><p>These asynchronous data messages are sent when the Server receives an XMPP-style iq request for the client user.</p><p>Attributes:</p><ul><li><p><code>peer</code></p><p>the sender E-mail address.</p></li><li><p><code>clientID</code></p><p>optional; the name or ID of the peer device this message was sent from.</p></li><li><p><code>type</code></p><p>the XMPP iq request type (<code>get</code>, <code>set</code>, <code>result</code>, or <code>error</code>).</p></li><li><p><code>iqid</code></p><p>the <code>id</code> attribute of the received XMPP iq request.</p></li><li><p>Body:</p></li></ul><p>the XMPP iq request body.</p><h2 id="Prefs" tabindex="-1">Preferences <a class="header-anchor" href="#Prefs" aria-label="Permalink to &quot;Preferences {#Prefs}&quot;">​</a></h2><p>A client can retrieve and update the authenticated user Preferences and <a href="./../admin/directory/CentralDir.html#CustomSettings">Public Info</a> data.</p><h3 id="prefsRead" tabindex="-1">prefsRead <a class="header-anchor" href="#prefsRead" aria-label="Permalink to &quot;prefsRead {#prefsRead}&quot;">​</a></h3><p>This operation retrieves authenticated user Preferences or Public Info data.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>this is an optional parameter.<br> If the specified value is <code>default</code>, the default Preferences for the Account Domain are retrieved.<br> If the specified value is <code>custom</code>, the explicitly specified Account Preferences are retrieved.<br> If the specified value is <code>publicInfo</code>, the Account Public Info settings are retrieved.<br> If the attribute is not specified, the effective Account Preferences are retrieved.</p></li><li><p>Body:</p><p>Zero or more XML <code>name</code> elements. These elements body specify the names of elements to retrieve; If no <code>name</code> element is specified, all Preference or Public Info elements are retrieved.</p></li></ul><p>The Server returns one <a href="#prefs"><code>prefs</code></a> data message.</p><h3 id="prefsStore" tabindex="-1">prefsStore <a class="header-anchor" href="#prefsStore" aria-label="Permalink to &quot;prefsStore {#prefsStore}&quot;">​</a></h3><p>This operation updates authenticated user Preferences or Public Info data.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>this is an optional parameter.<br> If the specified value is <code>publicInfo</code>, the Account Public Info settings are updated.<br> If the attribute is not specified, the custom Account Preferences are updated.</p></li><li><p>Body:</p><p>XML elements with the names equal to the Preference element names. An element body contains the new Preference element value. If the value is the <code>default</code> string, the Public Info or custom Preference value is removed, and the default value becomes the effective element value.<br> If the value is an array, it should be presented using the <a href="./Data.html#XMLArray"><code>array</code></a> XML presentation.<br> If the value is a dictionary, it should be presented using the <a href="./Data.html#XMLDictionary"><code>dictionary</code></a> XML presentation.</p></li></ul><p>If the body contains the <code>UserFromAddr</code> element, the Server uses this element and an optional <code>UserFromName</code> element to compose the <code>UserFrom</code> element with an E-mail address value (in the &quot;<em>UserFromName_value</em>&quot; &lt;<em>UserFromAddr_value</em>&gt; format).</p><h3 id="prefsReload" tabindex="-1">prefsReload <a class="header-anchor" href="#prefsReload" aria-label="Permalink to &quot;prefsReload {#prefsReload}&quot;">​</a></h3><p>The Server implements some operations (such as message removal) based on the Preference values read when the session is started. When some other session modifies the Preferences, the client may use this operation to tell the Server to update these &quot;cached&quot; values.</p><p>Attributes:</p><p><em>none</em></p><p>The Server sends the following data messages:</p><h5 id="prefs" tabindex="-1">prefs <a class="header-anchor" href="#prefs" aria-label="Permalink to &quot;prefs {#prefs}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#prefsRead"><code>prefsRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>an optional attribute, the same as the request attribute.</p></li></ul><p>Body:</p><p>XML elements, with the names equal to Preference or Public Info element names. An element body contains the element value.<br> If the value is an array, it is presented using the <a href="./Data.html#XMLArray"><code>array</code></a> XML presentation.<br> If the value is a dictionary, it is presented using the <a href="./Data.html#XMLDictionary"><code>dictionary</code></a> XML presentation.</p><p>If the <code>prefs</code> data contains the <code>UserFrom</code> string, the Server tries to parse that E-mail address. If the address is parsed, the <code>UserFromAddr</code> element (with the pure <code>userName@domainName</code> address) and, optionally, <code>UserFromName</code> element (with the address comment) are added to the data message body.</p><h5 id="prefsModified" tabindex="-1">prefsModified <a class="header-anchor" href="#prefsModified" aria-label="Permalink to &quot;prefsModified {#prefsModified}&quot;">​</a></h5><p>These asynchronous data messages are sent when the Account Preferences are modified (by this session, some other session, or some other CommuniGate Pro Server component).<br> It it recommended that the client re-reads the Account Preferences in response to this message.</p><h2 id="Files" tabindex="-1">File Storage Operations <a class="header-anchor" href="#Files" aria-label="Permalink to &quot;File Storage Operations {#Files}&quot;">​</a></h2><p>A client can manage the Account <a href="./../admin/storage/FileStore.html">File Storage</a>.<br> If the authenticated user has the <a href="./../admin/sysadmin/#DomainPrivs">CanAccessWebSites</a> Domain Administrator right, this client can manage files in someone else&#39;s Account by using the prefix when specifying file names: <code>~accountName/fileName</code>.</p><h3 id="fileList" tabindex="-1">fileList <a class="header-anchor" href="#fileList" aria-label="Permalink to &quot;fileList {#fileList}&quot;">​</a></h3><p>This operation provides a list files in a File Storage directory, and the information about these files.</p><p>Attributes:</p><ul><li><p><code>directory</code></p><p>an optional attribute with the File Storage subdirectory name. If absent and the <code>fileName</code> attribute is also absent, the content of the Account top File Storage directory is returned.</p></li><li><p><code>fileName</code></p><p>an optional attribute, specified only when the <code>directory</code> attribute is absent. If specified only the information about this File Storage entry is returned, even if it is a directory.</p></li><li><p><code>gmtTime</code></p><p>an optional attribute, when specified with any value the time stamps in the result are in GMT instead of the local time.The Server returns one <a href="#fileInfo"><code>fileInfo</code></a> data message for each file or directory in the specified File Storage directory.</p></li></ul><h3 id="fileDirInfo" tabindex="-1">fileDirInfo <a class="header-anchor" href="#fileDirInfo" aria-label="Permalink to &quot;fileDirInfo {#fileDirInfo}&quot;">​</a></h3><p>This operation provides information about all Account files or all files in the specified directory.</p><p>Attributes:</p><ul><li><p><code>directory</code></p><p>an optional attribute with the File Storage subdirectory name. If absent, the information about all Account File Storage files is returned.The Server returns one <a href="#fileDirInfoData"><code>fileDirInfo</code></a> data message.</p></li></ul><h3 id="fileDirList" tabindex="-1">fileDirList <a class="header-anchor" href="#fileDirList" aria-label="Permalink to &quot;fileDirList {#fileDirList}&quot;">​</a></h3><p>This operation provides a list of all File Storage folders. The Server returns one <a href="#fileDirName"><code>fileDirName</code></a> data message for each File Storage directory.</p><h3 id="fileWrite" tabindex="-1">fileWrite <a class="header-anchor" href="#fileWrite" aria-label="Permalink to &quot;fileWrite {#fileWrite}&quot;">​</a></h3><p>This operation stores data in a file.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file to write to.</p></li><li><p><code>position</code></p><p>If this attribute is absent, then this operation completely rewrites the specified file. If the file did not exist, it is created.<br> If this attribute value is <code>append</code>, this operation adds the data to the file end (atomically).<br> If this attribute value is <code>new</code>, this operation first checks that the specified file does not exist, and then creates the file and stores the data in it.<br> If this attribute value is a number, the file must exist, and the operation rewrites the file from the byte position specified with this number.</p></li><li><p><code>type</code></p><p>If this optional attribute exists and its value is <code>binary</code>, the request body is <code>base64</code> XML element, its body is base64-decoded before being written to the file.<br> If this optional attribute exists and its value is <code>object</code>, the request body is an <a href="./Data.html#XMLObjects">XML representation</a> of a data <a href="./Data.html">Object</a>; the text representation of this Object is written to the file. If this value is used, the <code>position</code> attribute must not be specified.<br> If this optional attribute exists and its value is <code>xml</code>, the request body must be a single XML element. Its text representation is written to the file. If this value is used, the <code>position</code> attribute must not be specified.<br> If this optional attribute exists and its value is <code>vcard</code>, the request body must be a single XML element representing a <a href="./Data.html#XMLvCard">vCard</a> object. The vCard text representation is written to the file. If this value is used, the <code>position</code> attribute must not be specified.</p></li></ul><p>Body:</p><p>Either a text with file data, or a <code>base64</code> XML element, or an XML representation of an object, or an XML element to write to the file.</p><h3 id="fileStore" tabindex="-1">fileStore <a class="header-anchor" href="#fileStore" aria-label="Permalink to &quot;fileStore {#fileStore}&quot;">​</a></h3><p>This operation stores an uploaded file or a message MIME part as a File Storage file.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file to be created.</p></li><li><p><code>uploadID</code></p><p>a string identifying a file in the &quot;uploaded file set&quot;.</p></li><li><p><code>folder</code>, <code>UID</code>, <code>partID</code></p><p>these attributes have the same meaning as for the <code>fileRead</code> operation. They identify a message MIME part to retrieve, decode, and store as a file.</p></li><li><p><code>calendar</code></p><p>use this attribute instead of the <code>folder</code> attribute to copy a MIME part from an open Calendar, rather than a E-mail folder.</p></li><li><p><code>position</code></p><p>this optional attribute has the same meaning as for the <code>fileWrite</code> operation.<br> Either a <code>uploadID</code> attribute should be specified, or the <code>folder</code> is specified, or the <code>calendar</code> attribute should be specified. No two of these attributes should be specified together in the same <code>fileStore</code> operation.</p></li></ul><h3 id="fileRead" tabindex="-1">fileRead <a class="header-anchor" href="#fileRead" aria-label="Permalink to &quot;fileRead {#fileRead}&quot;">​</a></h3><p>This operation reads data from a file.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file to read from.</p></li><li><p><code>position</code></p><p>This numeric attribute specifies the file position to start reading from. If this attribute is absent, then the file is read from its start (from the file position 0).</p></li><li><p><code>limit</code></p><p>This numeric attribute specifies the maximum size of the file data portion to read. If specified, it should not exceed 3MB. If not specified, the 3MB limit is used.</p></li><li><p><code>type</code></p><p>If this optional attribute exists and its value is <code>binary</code>, the file data is returned base64-encoded, as the <code>base64</code> XML element body.<br> If this optional attribute exists and its value is <code>object</code>, the file data is parsed as a text presentation of an <a href="./Data.html">Object</a>, and the Object <a href="./Data.html#XMLObjects">XML representation</a> is returned. If this value is used, the <code>position</code> and <code>limit</code> attributes must not be specified, and the file size should not exceed 3MB.<br> If this optional attribute exists and its value is <code>xml</code>, the file data is parsed as an XML document, and its XML content is returned. If this value is used, the <code>position</code> and <code>limit</code> attributes must not be specified, and the file size should not exceed 3MB.<br> If this optional attribute exists and its value is <code>vcard</code>, the file data is parsed as vCard document, and its XML representation is returned. If this value is used, the <code>position</code> and <code>limit</code> attributes must not be specified, and the file size should not exceed 3MB.The Server returns a <a href="#fileData"><code>fileData</code></a> data message.</p></li></ul><h3 id="fileRename" tabindex="-1">fileRename <a class="header-anchor" href="#fileRename" aria-label="Permalink to &quot;fileRename {#fileRename}&quot;">​</a></h3><p>This operation renames a file in the File Storage.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file to rename.</p></li><li><p><code>newName</code></p><p>the new name for the file.</p></li></ul><h3 id="fileRemove" tabindex="-1">fileRemove <a class="header-anchor" href="#fileRemove" aria-label="Permalink to &quot;fileRemove {#fileRemove}&quot;">​</a></h3><p>This operation removes a file from the File Storage.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file to remove.</p></li></ul><h3 id="fileCopy" tabindex="-1">fileCopy <a class="header-anchor" href="#fileCopy" aria-label="Permalink to &quot;fileCopy {#fileCopy}&quot;">​</a></h3><p>This operation copies file or message contents into a File Storage file.</p><p>Attributes:</p><ul><li><p><code>newName</code></p><p>the name of file to create (copy target). If file with this name already exists, it is removed.</p></li><li><p><code>fileName</code></p><p>optional: the name of File Storage file to copy.</p></li></ul><p>Body:</p><p>one optional <a href="#copyMIME"><code>copyMIME</code></a> element. It specified a message part to decode and copy into the specified file.The operation must contain either a <code>fileName</code> attribute or one <code>copyMIME</code> body element.</p><h3 id="fileDirCreate" tabindex="-1">fileDirCreate <a class="header-anchor" href="#fileDirCreate" aria-label="Permalink to &quot;fileDirCreate {#fileDirCreate}&quot;">​</a></h3><p>This operation creates a file directory in the File Storage.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file directory to create.</p></li></ul><h3 id="fileDirRename" tabindex="-1">fileDirRename <a class="header-anchor" href="#fileDirRename" aria-label="Permalink to &quot;fileDirRename {#fileDirRename}&quot;">​</a></h3><p>This operation renames a file directory in the File Storage.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file directory to rename.</p></li><li><p><code>newName</code></p><p>the new name for the file directory.</p></li></ul><h3 id="fileDirRemove" tabindex="-1">fileDirRemove <a class="header-anchor" href="#fileDirRemove" aria-label="Permalink to &quot;fileDirRemove {#fileDirRemove}&quot;">​</a></h3><p>This operation removes a file directory from the File Storage.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file directory to remove. Only empty directories can be removed.</p></li></ul><h3 id="fileAttrRead" tabindex="-1">fileAttrRead <a class="header-anchor" href="#fileAttrRead" aria-label="Permalink to &quot;fileAttrRead {#fileAttrRead}&quot;">​</a></h3><p>This operation reads file or directory attributes.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file or file directory.</p></li><li><p>Body:</p></li></ul><p>a set of <code>field</code> XML elements. Each element should have a text body containing the name of an attribute to retrieve.If no <code>field</code> element is specified, all attributes are retrieved.<br> The Server returns a <a href="#fileAttrData"><code>fileAttrData</code></a> data message.</p><h3 id="fileAttrWrite" tabindex="-1">fileAttrWrite <a class="header-anchor" href="#fileAttrWrite" aria-label="Permalink to &quot;fileAttrWrite {#fileAttrWrite}&quot;">​</a></h3><p>This operation modifies file or directory attributes.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file or file directory.</p></li><li><p>Body:</p></li></ul><p>a set of file attribute XML elements.<br> If a body XML element has the <code>mode</code> attribute with the <code>delete</code> value, then all attributes with the same name as the name of this body XML element are removed, and the body XML element is not added.<br> If a body XML element has the <code>mode</code> attribute with the <code>add</code> value, the body XML element is added to the file attributes.<br> If a body XML element has the <code>mode</code> attribute with any other value or does not have the <code>mode</code> attribute, then all attributes with the same name as the name of this body XML element are removed, and then the body XML element is added to the file attributes.<br> Before a body XML element is added to the attribute set, its <code>mode</code> attribute (if any) is removed.</p><h3 id="fileLock" tabindex="-1">fileLock <a class="header-anchor" href="#fileLock" aria-label="Permalink to &quot;fileLock {#fileLock}&quot;">​</a></h3><p>This operation manages file or directory &quot;locks&quot;.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file or file directory.</p></li><li><p><code>mode</code></p><p>the requested operation: <code>lock</code> (locking and lock refreshing), <code>unlock</code> (unlocking), <code>testlock</code> (noop, reading the lock list).</p></li><li><p><code>scope</code></p><p>this attribute is required for the locking operation, it specifies the lock scope: <code>exclusive</code> or <code>shared</code>.</p></li><li><p><code>type</code></p><p>this attribute is required for the locking operation, it specifies the lock type (<code>read</code>, <code>write</code>, etc.)</p></li><li><p><code>token</code></p><p>this attribute is required for the lock refreshing and unlocking operations, it specifies the lock token previously received by this client application. The lock belonging to this <code>owner</code> with the specified <code>token</code> is refreshed or unlocked (removed).</p></li><li><p><code>timeTill</code></p><p>this attribute is required for the locking and lock refreshing operation, it specifies the lock expiration time (specified for the selected time zone). If not specified, the default expiration time is used.</p></li><li><p><code>create</code></p><p>if this attribute is present and set to the <code>yes</code> string, the locking operation does not fail if the specified file or directory does not exist, but it tries to create it first.</p></li></ul><p>Body:</p><p>for the locking operations, the <code>owner</code> XML element containing the information about the lock owner.If this operation succeeds, the Server sends a <a href="#fileLockData"><code>fileLockData</code></a> data message.</p><h3 id="fileSubList" tabindex="-1">fileSubList <a class="header-anchor" href="#fileSubList" aria-label="Permalink to &quot;fileSubList {#fileSubList}&quot;">​</a></h3><p>This operation makes the Server send a <a href="#fileSubscription"><code>fileSubscription</code></a> data message for each element in the Account <em>file subscription</em> set. Note that files in this set may or may not exist.</p><h3 id="fileSubUpdate" tabindex="-1">fileSubUpdate <a class="header-anchor" href="#fileSubUpdate" aria-label="Permalink to &quot;fileSubUpdate {#fileSubUpdate}&quot;">​</a></h3><p>This operation modifies Account <em>file subscription</em> set.</p><p>Body:</p><p>a set of <code>fileSubscription</code> elements.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>a file name in the UTF-8 character set.</p></li><li><p><code>mode</code></p><p>if this attribute value is <code>add</code> the <code>fileName</code> name is added to the <em>file subscription</em> set (unless the set already contains this name).<br> otherwise, the <code>fileName</code> name is removed from the <em>file subscription</em> set.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="fileInfo" tabindex="-1">fileInfo <a class="header-anchor" href="#fileInfo" aria-label="Permalink to &quot;fileInfo {#fileInfo}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#fileList"><code>fileList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the file or subdirectory name.</p></li><li><p><code>directory</code></p><p>an optional attribute, the same as the <code>directory</code> attribute in the <a href="#fileList"><code>fileList</code></a> request.</p></li><li><p><code>type</code></p><p>an optional attribute exists and contains the <code>directory</code> value, if this message describes a subdirectory.</p></li><li><p><code>size</code></p><p>an optional attribute with the file size in bytes (absent if this message describes a subdirectory).</p></li><li><p><code>timeModified</code></p><p>an optional attribute with the file modification date and time (local time, unless the <code>gmtTime</code> attribute was specified in the request).</p></li><li><p><code>timeAttrModified</code></p><p>an optional attribute with the file attribute set modification date and time (local time, unless the <code>gmtTime</code> attribute was specified in the request).If the <code>fileName</code> attribute was specified in the <a href="#fileList"><code>fileList</code></a> request, or if the name specified in the <code>directory</code> request attribute belongs to a regular file, and not to a file directory, the <code>directory</code> attribute is not included into the <code>fileInfo</code> message, and the <code>fileName</code> attribute contains the full name of the target file or directory.</p></li></ul><h5 id="fileDirInfoData" tabindex="-1">fileDirInfo <a class="header-anchor" href="#fileDirInfoData" aria-label="Permalink to &quot;fileDirInfo {#fileDirInfoData}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#fileDirInfo"><code>fileDirInfo</code></a> request.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>All attributes are optional, they do not exist, if the system does not maintain the requested values (for example, when the operation is applied to a virtual <code>$DomainPBXApp$</code> directory).</p></div><p>Attributes:</p><ul><li><p><code>directory</code></p><p>an optional attribute, the same as the <code>directory</code> attribute in the <a href="#fileDirInfo"><code>fileDirInfo</code></a> request.</p></li><li><p><code>files</code></p><p>the total number of files in the Account or in the specified subdirectory (and all nested directories).</p></li><li><p><code>size</code></p><p>the total size of all files (in bytes).</p></li><li><p><code>filesLimit</code></p><p>the storage file limit setting of the directory owner Account.</p></li><li><p><code>sizeLimit</code></p><p>the file storage limit setting of the directory owner Account.</p></li></ul><h5 id="fileDirName" tabindex="-1">fileDirName <a class="header-anchor" href="#fileDirName" aria-label="Permalink to &quot;fileDirName {#fileDirName}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#fileDirList"><code>fileDirList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>directory</code></p><p>the File Storage directory name.</p></li></ul><h5 id="fileData" tabindex="-1">fileData <a class="header-anchor" href="#fileData" aria-label="Permalink to &quot;fileData {#fileData}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#fileRead"><code>fileRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of read file.</p></li><li><p><code>position</code></p><p>the file position of the read data.</p></li><li><p><code>slice</code></p><p>the size of read data (in bytes). To read the next portion of the file, add the <code>position</code> and <code>slice</code> values to get the new <code>position</code> value.</p></li><li><p><code>size</code></p><p>the file total size.</p></li><li><p><code>timeModified</code></p><p>an optional attribute with the file modification date and time (local time).</p></li><li><p><code>type</code></p><p>a copy of the request <code>type</code> attribute.</p></li><li><p>Body:</p></li></ul><p>Either a text with file data, or the <code>base64</code> (its body is base64-encoded file data), or an XML representation of the file content Object.</p><p>Examples:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">position=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> slice</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;22&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> size</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;22&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeModified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20061018T115836&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is not your file!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> limit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">position=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> slice</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> size</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;22&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeModified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20061018T115836&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is not you&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A002&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> limit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> position</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">position=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> slice</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;7&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> size</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;22&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeModified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20061018T115836&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;r file!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A003&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> limit</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> position</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;binary&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">position=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;15&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> slice</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;7&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> size</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;22&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeModified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20061018T115836&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;ciBmaWxlIQ==&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">base64</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileData</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A004&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">fileRead</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> fileName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;test.txt&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> position</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;25&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A005&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorText</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;reading beyond the EOF mark&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> errorNum</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;500&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span></code></pre></div><h5 id="fileAttrData" tabindex="-1">fileAttrData <a class="header-anchor" href="#fileAttrData" aria-label="Permalink to &quot;fileAttrData {#fileAttrData}&quot;">​</a></h5><p>This data message is sent when the Server processes the <a href="#fileAttrRead"><code>fileAttrRead</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the name of file or file directory.</p></li><li><p>Body:</p><p>a set of file attribute XML elements.</p></li></ul><h5 id="fileLockData" tabindex="-1">fileLockData <a class="header-anchor" href="#fileLockData" aria-label="Permalink to &quot;fileLockData {#fileLockData}&quot;">​</a></h5><p>These data messages are sent when the Server processes the <a href="#fileLock"><code>fileLock</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the file name in the UTF-8 character set.</p></li><li><p><code>token</code></p><p>the token string for the newly created or refreshed lock.</p></li><li><p><code>expires</code></p><p>the newly created or refreshed lock expiration time.</p></li><li><p><code>create</code></p><p>this attribute exists if an empty file has been created as a result of this <a href="#fileLock"><code>fileLock</code></a> request.</p></li><li><p>Body:</p><p>a set of <code>fileLockData</code> XML elements for all existing file locks.<br> Each element contains the <code>expires</code>, <code>scope</code>, <code>type</code> attributes described above.<br> The element body contains the <code>owner</code> XML element with the lock owner information.</p></li></ul><h5 id="fileSubscription" tabindex="-1">fileSubscription <a class="header-anchor" href="#fileSubscription" aria-label="Permalink to &quot;fileSubscription {#fileSubscription}&quot;">​</a></h5><p>These data messages are sent when the Server processes the <a href="#fileSubList"><code>fileSubList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>fileName</code></p><p>the file name in the UTF-8 character set.</p></li></ul><h2 id="Rules" tabindex="-1">Automated Rule Management <a class="header-anchor" href="#Rules" aria-label="Permalink to &quot;Automated Rule Management {#Rules}&quot;">​</a></h2><p>A client can manage the Account <a href="./Rules.html">Automated Rules</a>.</p><h4 id="ruleData" tabindex="-1"><code>rule</code> <a class="header-anchor" href="#ruleData" aria-label="Permalink to &quot;\`rule\` {#ruleData}&quot;">​</a></h4><p>Each rule is presented as a <code>rule</code> XML element. Rules sets are addressed using the <code>type</code> parameter. The following parameter values are supported:</p><ul><li><code>mailIn</code> - incoming <a href="./../admin/mail/QueueRules.html">E-mail (Queue) Rules</a>.</li><li><code>signalIn</code> - incoming <a href="./../admin/signals/SignalRules.html">Signal Rules</a>.</li></ul><p>Each Rule in a set has name and priority attributes. Signal Rules also have a <code>stage</code> attribute, specifying when the Rule should be applied.</p><p>Each Rule contains zero or more <code>condition</code> elements, zero or more <code>action</code> elements, and zero or one <code>comment</code> elements:</p><ul><li><code>condition</code></li></ul><p>See the <a href="./Rules.html#Conditions">Rules</a> section for more information.</p><p>Attributes:</p><ul><li><p><code>opCode</code></p><p>the Rule condition data.</p><ul><li><code>operator</code></li></ul><p>the Rule condition operation.</p><ul><li>Body:</li></ul></li></ul><p>the Rule condition parameter.</p><ul><li><code>action</code></li></ul><p>See the <a href="./Rules.html#Actions">Rules</a> section for more information.</p><p>Attributes:</p><ul><li><p><code>opCode</code></p><p>the Rule action operation.</p></li><li><p>Body:</p></li></ul><p>the Rule action parameter.</p><ul><li><p><code>comment</code></p><ul><li>Body: the Rule comment text.</li></ul></li></ul><p>Example:<br> a Mail Rule storing all messages with the <code>X-Junk: 5</code> header field in the <code>Junk</code> Mailbox. Exception is made for messages coming from authenticated users.</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rule</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mailIn&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Junk Filter&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> priority</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">condition</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> opCode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Header Field&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> operator</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;is&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;X-Junk: 5*&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">condition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">condition</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> opCode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Source&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> operator</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;is not&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;authenticated&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">condition</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">action</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> opCode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Store in&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Junk&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">action</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">action</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> opCode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Discard&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">action</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">comment</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;This is my test Rule</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#x21;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">comment</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="ruleList" tabindex="-1">ruleList <a class="header-anchor" href="#ruleList" aria-label="Permalink to &quot;ruleList {#ruleList}&quot;">​</a></h3><p>This operation tells the Server to send one <a href="#ruleData"><code>rule</code></a> data message for each Account Rule of the specified type. These messages do not have a body.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li></ul><h3 id="ruleRead" tabindex="-1">ruleRead <a class="header-anchor" href="#ruleRead" aria-label="Permalink to &quot;ruleRead {#ruleRead}&quot;">​</a></h3><p>This operation tells the Server to send one <a href="#rule"><code>rule</code></a> data message for the specified Rule. This message body contains XML elements with the Rule condition(s), action(s), and an optional comment.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li><li><p><code>name</code></p><p>the Rule name.</p></li></ul><h3 id="ruleSet" tabindex="-1">ruleSet <a class="header-anchor" href="#ruleSet" aria-label="Permalink to &quot;ruleSet {#ruleSet}&quot;">​</a></h3><p>This operation stores a new Rule. If there is an existing Rule with the same name, it is removed.<br> The user should have a right to specify conditions and actions used in both new and old Rules.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li><li><p><code>name</code></p><p>the Rule name.</p></li><li><p><code>priority</code></p><p>the Rule priority.</p></li><li><p><code>stage</code></p><p>the Rule stage (for Signal Rules).</p></li></ul><p>Body:</p><p>the same XML elements as used in the <a href="#ruleData"><code>rule</code></a> message: zero or more <code>condition</code> elements, zero or more <code>action</code> elements, and zero or one <code>comment</code> element.</p><h3 id="ruleUpdate" tabindex="-1">ruleUpdate <a class="header-anchor" href="#ruleUpdate" aria-label="Permalink to &quot;ruleUpdate {#ruleUpdate}&quot;">​</a></h3><p>This operation modifies the existing Rule priority and/or its stage (for Signal Rules).<br> The user should have a right to specify conditions and actions used in the Rule to be modified.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li><li><p><code>name</code></p><p>the Rule name.</p></li><li><p><code>priority</code></p><p>the Rule priority.</p></li><li><p><code>stage</code></p><p>the Rule stage (for Signal Rules).</p></li></ul><h3 id="ruleRename" tabindex="-1">ruleRename <a class="header-anchor" href="#ruleRename" aria-label="Permalink to &quot;ruleRename {#ruleRename}&quot;">​</a></h3><p>This operation renames an existing Rule.<br> The user should have a right to specify conditions and actions used in the Rule to be renamed.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li><li><p><code>name</code></p><p>the existing Rule name.</p></li><li><p><code>newName</code></p><p>the new Rule name.</p></li></ul><h3 id="ruleRemove" tabindex="-1">ruleRemove <a class="header-anchor" href="#ruleRemove" aria-label="Permalink to &quot;ruleRemove {#ruleRemove}&quot;">​</a></h3><p>This operation removes an existing Rule.<br> The user should have a right to specify conditions and actions used in the Rule to be removed.</p><p>Attributes:</p><ul><li><p><code>type</code></p><p>the Rule set.</p></li><li><p><code>name</code></p><p>the existing Rule name.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="rule" tabindex="-1">rule <a class="header-anchor" href="#rule" aria-label="Permalink to &quot;rule {#rule}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#ruleList"><code>ruleList</code></a> request or the <a href="#ruleRead"><code>ruleRead</code></a> request. See above for the <a href="#ruleData"><code>rule</code></a> message format.</p><h2 id="remote-pop-remote-sip-management" tabindex="-1">Remote POP, Remote SIP Management <a class="header-anchor" href="#remote-pop-remote-sip-management" aria-label="Permalink to &quot;Remote POP, Remote SIP Management&quot;">​</a></h2><h4 id="rpopRecordData" tabindex="-1">rpopRecord <a class="header-anchor" href="#rpopRecordData" aria-label="Permalink to &quot;rpopRecord {#rpopRecordData}&quot;">​</a></h4><p><a href="./../admin/mail/RPOP.html">RPOP records</a> are presented using the the XML elements:</p><p>Attributes:</p><ul><li>name</li></ul><p>the record name</p><p>Body:</p><p>the <a href="./Data.html#XMLDictionary">XML represntation</a> of an <a href="./../admin/mail/RPOP.html#Data">RPOP Record dictionary</a>.</p><p>A client can manage the Account <a href="./../admin/mail/RPOP.html#Data">RPOP Account</a> records.</p><h3 id="rpopList" tabindex="-1">rpopList <a class="header-anchor" href="#rpopList" aria-label="Permalink to &quot;rpopList {#rpopList}&quot;">​</a></h3><p>This operation tells the Server to send one <a href="#rpopRecord"><code>rpopRecord</code></a> data message for each Account RPOP record.</p><p>Attributes:</p><ul><li><em>none</em></li></ul><h3 id="rpopUpdate" tabindex="-1">rpopUpdate <a class="header-anchor" href="#rpopUpdate" aria-label="Permalink to &quot;rpopUpdate {#rpopUpdate}&quot;">​</a></h3><p>This operation updates the Account RPOP record set.<br> The user should have a right to modify the Account RPOP records.</p><p>Attributes:</p><ul><li><em>none</em></li><li>Body:</li></ul><p>one or more <a href="#rpopRecordData"><code>rpopRecord</code></a> elements. These elements must have an additional attribute:</p><ul><li><p><code>mode</code></p><p>if this attribute value is <code>delete</code>, the only the <code>name</code> attribute is used. The specified RPOP record is removed from the Account RPOP record set.<br> Otherwise, the RPOP record specified using the <code>rpopRecord</code> element body is added to the Account RPOP record set; if a record with the same name existed in the set, it is removed.</p></li></ul><p><a href="./../admin/signals/PSTN.html#RSIP">RSIP records</a> are presented using the <code>rsipRecord</code> XML elements:</p><p>Attributes:</p><ul><li>name</li></ul><p>the record name</p><ul><li>Body:</li></ul><p>the <a href="./Data.html#XMLDictionary">XML represntation</a> of an <a href="./../admin/signals/PSTN.html#RSIP">RSIP Record dictionary</a>.</p><p>A client can manage the Account <a href="./../admin/signals/PSTN.html#RSIP">RSIP records</a>.</p><h3 id="rsipList" tabindex="-1">rsipList <a class="header-anchor" href="#rsipList" aria-label="Permalink to &quot;rsipList {#rsipList}&quot;">​</a></h3><p>This operation tells the Server to send one <a href="#rsipRecord"><code>rsipRecord</code></a> data message for each Account RSIP record.</p><p>Attributes:</p><ul><li><em>none</em></li></ul><h3 id="rsipUpdate" tabindex="-1">rsipUpdate <a class="header-anchor" href="#rsipUpdate" aria-label="Permalink to &quot;rsipUpdate {#rsipUpdate}&quot;">​</a></h3><p>This operation updates the Account RSIP record set.<br> The user should have a right to modify the Account RSIP records.</p><p>Attributes:</p><ul><li><em>none</em></li></ul><p>Body:</p><p>one or more <code>rsipRecord</code> elements. These elements must have an additional attribute:</p><ul><li><p><code>mode</code></p><p>if this attribute value is <code>delete</code>, the only the <code>name</code> attribute is used. The RSIP record with the same <code>name</code> attribute is removed from the Account RSIP record set.<br> Otherwise, the RSIP record specified using the <code>rsipRecord</code> element body is added to the Account RSIP record set; if a record with the same name existed in the set, it is removed.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="rpopRecord" tabindex="-1">rpopRecord <a class="header-anchor" href="#rpopRecord" aria-label="Permalink to &quot;rpopRecord {#rpopRecord}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#rpopList"><code>rpopList</code></a> request. See above for the <a href="#rpopRecordData"><code>rpopRecord</code></a> message format.<br> The optional <code>timeCompleted</code> attribute indicates the time (in the selected time zone) when the last connection attempt was made.<br> If the last attempt to poll the RPOP account failed, the record has an additional <code>errorText</code> attribute containing the failed attempt error code string.</p><h5 id="rsipRecord" tabindex="-1">rsipRecord <a class="header-anchor" href="#rsipRecord" aria-label="Permalink to &quot;rsipRecord {#rsipRecord}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#rsipList"><code>rsipList</code></a> request. See above for the <a href="#rsipRecordData"><code>rsipRecord</code></a> message format.<br> The optional <code>timeCompleted</code> attribute indicates the time (in the selected time zone) when the last connection attempt was made.<br> If the last attempt to poll the RSIP account failed, the record has an additional <code>errorText</code> attribute containing the failed attempt error code string.</p><h2 id="PBXApp" tabindex="-1">Real-Time Application Management <a class="header-anchor" href="#PBXApp" aria-label="Permalink to &quot;Real-Time Application Management {#PBXApp}&quot;">​</a></h2><p>A client can interact with the <a href="./PBXApp.html">Real-Time Applications</a> running on the CommuniGate Pro Server or Cluster.</p><p>A XIMSS session can communicate with <a href="./CGPL.html#MultiTask">Tasks</a> by sending them <a href="./CGPL.html#Events">Events</a>. Tasks see a XIMSS session as a yet another Task, so they can send Events back to it.</p><p>Each XIMSS session maintains a list of Tasks Handles for the Tasks it communicates with. Each handle in the list is associated with an taskID string. The XIMSS client uses these taskID strings to address the Tasks in the list.</p><h3 id="taskFindMeeting" tabindex="-1">taskFindMeeting <a class="header-anchor" href="#taskFindMeeting" aria-label="Permalink to &quot;taskFindMeeting {#taskFindMeeting}&quot;">​</a></h3><p>This operation implements the FindMeeting operation. See the <a href="./CGPL.html#Meetings">CG/PL</a> section for more information.</p><p>Attributes:</p><ul><li><p><code>meetingSet</code></p><p>the optional Meeting set name. If the parameter value is missing or it is an empty string, the Default Meeting Set is used.</p></li><li><p><code>meetingName</code></p><p>the unique ID or name for the Meeting.If this operation succeeds, the Server returns a <a href="#taskMeeting"><code>taskMeeting</code></a> data message with the found meeting data.</p></li></ul><h3 id="taskCreateMeeting" tabindex="-1">taskCreateMeeting <a class="header-anchor" href="#taskCreateMeeting" aria-label="Permalink to &quot;taskCreateMeeting {#taskCreateMeeting}&quot;">​</a></h3><p>This operation implements the CreateMeeting operation. See the <a href="./CGPL.html#Meetings">CG/PL</a> section for more information.</p><p>Attributes:</p><ul><li><p><code>meetingSet</code></p><p>the optional Meeting set name. If the parameter value is missing or it is an empty string, the Default Meeting Set is used.</p></li><li><p><code>meetingName</code></p><p>the unique ID or name for the Meeting.</p></li></ul><p>Body:</p><p>The text to add to the Meeting Event as a parameter.</p><ul><li><code>taskRemoveMeeting</code>, <code>taskClearMeeting</code>, <code>taskActivateMeeting</code>, <code>taskDeactivateMeeting</code></li></ul><p>These operations implement the Meeting operations. See the <a href="./CGPL.html#Meetings">CG/PL</a> section for more information.</p><p>Attributes:</p><ul><li><p><code>meetingSet</code></p><p>the optional Meeting set name. If the parameter value is missing or it is an empty string, the Default Meeting Set is used.</p></li><li><p><code>meetingName</code></p><p>the unique ID or name for the Meeting.</p></li></ul><h3 id="taskSendEvent" tabindex="-1">taskSendEvent <a class="header-anchor" href="#taskSendEvent" aria-label="Permalink to &quot;taskSendEvent {#taskSendEvent}&quot;">​</a></h3><p>This operation send an Event to a Task.</p><p>Attributes:</p><ul><li><p><code>taskRef</code></p><p>the internal taskID of the Task to send an Event to.</p></li><li><p><code>eventName</code></p><p>the name of the Event to send.</p></li><li><p>Body:</p></li></ul><p>optional text or an XML presentation of a <a href="#Formats">data object</a> to be sent as the Event parameter.</p><h3 id="taskStart" tabindex="-1">taskStart <a class="header-anchor" href="#taskStart" aria-label="Permalink to &quot;taskStart {#taskStart}&quot;">​</a></h3><p>This operation starts a <a href="./PBXApp.html">Real-Time Application</a> Task.<br> If this operation succeeds, the server sends a <a href="#taskCreated"><code>taskCreated</code></a> data message.</p><p>Attributes:</p><ul><li><p><code>programName</code></p><p>the application name.</p></li><li><p><code>entryName</code></p><p>this optional attribute specified the program entry name; if not specified, the <code>main</code> entry is started.</p></li><li><p>Body:</p></li></ul><p>a set of <code>param</code> XML elements. These element text bodies are placed into the Task <code>startParameter</code> array.</p><h3 id="taskClose" tabindex="-1">taskClose <a class="header-anchor" href="#taskClose" aria-label="Permalink to &quot;taskClose {#taskClose}&quot;">​</a></h3><p>There are some session resources associated with each internal taskID. If your client works with many different Tasks, it is recommended that it uses the taskClose operation when it ends communication with a particular Task, so its session-internal taskID is released.<br> If the same Task sends an Event to this session, or its Task Handle is discovered using other mechanisms, the new taskID is assigned to this Task in this session.</p><p>Attributes:</p><ul><li><p><code>taskRef</code></p><p>the internal taskID to release.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="taskMeeting" tabindex="-1">taskMeeting <a class="header-anchor" href="#taskMeeting" aria-label="Permalink to &quot;taskMeeting {#taskMeeting}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#taskFindMeeting"><code>taskFindMeeting</code></a> request.</p><p>Attributes:</p><ul><li><p><code>meetingSet</code>, <code>meetingName</code></p><p>copies of the <a href="#taskFindMeeting"><code>taskFindMeeting</code></a> request attributes.</p></li><li><p><code>taskRef</code></p><p>an optional attribute: the internal taskID of the Task that has activated this Meeting.</p></li><li><p><code>expires</code></p><p>an optional attribute with the Meeting expiration date and time (GMT).</p></li><li><p>Body:</p></li></ul><p>The XML presentation of the Meeting parameters.</p><h5 id="taskCreated" tabindex="-1">taskCreated <a class="header-anchor" href="#taskCreated" aria-label="Permalink to &quot;taskCreated {#taskCreated}&quot;">​</a></h5><p>This synchronous data message is sent when the Server processes the <a href="#taskStart"><code>taskStart</code></a> request.</p><p>Attributes:</p><ul><li><p><code>taskRef</code></p><p>the internal taskID of the created Task.</p></li></ul><h5 id="taskEvent" tabindex="-1">taskEvent <a class="header-anchor" href="#taskEvent" aria-label="Permalink to &quot;taskEvent {#taskEvent}&quot;">​</a></h5><p>This asynchronous data message is sent when some Task or the Server itself sends an Event to the current XIMSS session.</p><p>Attributes:</p><ul><li><p><code>taskRef</code></p><p>the internal taskID of the Task that has sent this Event. If this attribute is absent, then the Event was generated and sent by the Server itself.</p></li><li><p><code>eventName</code></p><p>the name of the received Event.</p></li><li><p>Body:</p></li></ul><p>The text or the XML presentation of the Event parameter.</p><h2 id="Directory" tabindex="-1">Directory <a class="header-anchor" href="#Directory" aria-label="Permalink to &quot;Directory {#Directory}&quot;">​</a></h2><p>A client can access the global <a href="./../admin/directory/">Directory</a>.</p><h3 id="listDirectory" tabindex="-1">listDirectory <a class="header-anchor" href="#listDirectory" aria-label="Permalink to &quot;listDirectory {#listDirectory}&quot;">​</a></h3><p>This operation retrieves data from the Directory.</p><p>Attributes:</p><ul><li><p><code>baseDN</code></p><p>the Directory record DN to start the search from. If the attribute value is <code>$</code>, the baseDN is set to the Directory subtree containing records for the current Account Domain.</p></li><li><p><code>filter</code></p><p>this optional attribute specifies a search filter in the RFC2254 format.</p></li><li><p><code>scope</code></p><p>this optional attribute specifies the search type:</p><ul><li><code>base</code> - the baseDN record is retrieved (the filter attribute is ignored)</li><li><code>one</code> (default) - the baseDN immediate subtree is searched (one-level search)</li><li><code>sub</code> - the entire baseDN subtree is searched (multi-level search)</li></ul></li><li><p><code>limit</code></p><p>this optional attribute specifies the maximum number of directory records to retrieve.</p></li><li><p><code>sortField</code></p><p>(optional) the comma-separated list of field names to use for records sorting. <strong>Note:</strong> attributes listed closer to the list end have higher sorting weight.</p></li><li><p><code>sortOrder</code></p><p>if this optional attribute is specified and it has the <code>desc</code> value, the sorting order is reversed.</p></li><li><p><code>cookie</code></p><p>this optional attribute specifies the &quot;paging cookie&quot;. It should be an empty string to retrieve the first set of records. It should be set to the value of the <code>cookie</code> attribute of the last returned <a href="#directoryData"><code>directoryData</code></a> data message to retrieve the next set of records.</p></li><li><p>Body (optional):</p></li></ul><p>a set of <code>field</code> XML elements. Each element should have a text body containing the name of an attribute to retrieve. If no <code>field</code> element is specified, all non-service Directory record attributes are retrieved.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>If the <code>mail</code> attribute is explicitly specified, the Server will compose this attribute value for all CommuniGate Pro Object records without this attribute.The Server sends a <a href="#directoryData"><code>directoryData</code></a> data message for each record found.</p></div><h3 id="modifyDirectory" tabindex="-1">modifyDirectory <a class="header-anchor" href="#modifyDirectory" aria-label="Permalink to &quot;modifyDirectory {#modifyDirectory}&quot;">​</a></h3><p>This operation modifies the data in the Directory.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the Directory record DN to modify. The <code>$</code> symbol is replaced with a string with the value of the Directory subtree containing records for the current Account Domain.</p></li><li><p><code>newName</code></p><p>if this optional attribute is specified then the record DN is renamed to the new name.</p></li><li><p>Body (optional):</p></li></ul><p>The XML presentation of the Directory record attributes.<br> If the Body is empty and there is no <code>newName</code> attribute then the existing record with the given DN is deleted.Example:</p><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">modifyDirectory</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mail=user@example.dom,$&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mail&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user@example.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;cn&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;User J. Smith&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sn&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C: &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> key</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;objectclass&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;top&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;person&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;organizationalPerson&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;inetOrgPerson&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subValue</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C: &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">subKey</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">modifyDirectory</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">S:&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">response</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;A001&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/&gt;</span></span></code></pre></div><p>The Server sends the following data messages:</p><h5 id="directoryData" tabindex="-1">directoryData <a class="header-anchor" href="#directoryData" aria-label="Permalink to &quot;directoryData {#directoryData}&quot;">​</a></h5><p>This synchronous data message is sent for each Directory record retrieved with the <a href="#listDirectory"><code>listDirectory</code></a> command.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the record DN.</p></li><li><p><code>cookie</code></p><p>exists only in the last returned record, only if the command contained this attribute, and if the retrieved records are not the last records. Use the value of this attribute in the repeated <a href="#listDirectory"><code>listDirectory</code></a> command to retrieve more records.</p></li></ul><p>Body:</p><p>The XML presentation of the Record attributes.</p><h2 id="Dataset" tabindex="-1">Datasets <a class="header-anchor" href="#Dataset" aria-label="Permalink to &quot;Datasets {#Dataset}&quot;">​</a></h2><p>A client can manage the Account Datasets (such as the <code>RepliedAddresses</code> Dataset).</p><p>To access Datasets in other Accounts, the dataset name should be specified as <code>~accountName/datasetName</code> or <code>~accountName@domainName/datasetName</code></p><h3 id="datasetCreate" tabindex="-1">datasetCreate <a class="header-anchor" href="#datasetCreate" aria-label="Permalink to &quot;datasetCreate {#datasetCreate}&quot;">​</a></h3><p>This operation creates an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the name of the dataset to create.</p></li></ul><h3 id="datasetRemove" tabindex="-1">datasetRemove <a class="header-anchor" href="#datasetRemove" aria-label="Permalink to &quot;datasetRemove {#datasetRemove}&quot;">​</a></h3><p>This operation removes an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the name of the dataset to remove.</p></li><li><p><code>ifExists</code></p><p>if this optional attribute exists, and its value is yes, no error is generated when the specified dataset does not exist.</p></li></ul><h3 id="datasetAddAddress" tabindex="-1">datasetAddAddress <a class="header-anchor" href="#datasetAddAddress" aria-label="Permalink to &quot;datasetAddAddress {#datasetAddAddress}&quot;">​</a></h3><p>This operation adds an address to an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the name of the dataset to add an E-mail address to.</p></li><li><p><code>realName</code></p><p>this optional attribute specified the E-mail &quot;real name&quot;.</p></li><li><p>Body:</p></li></ul><p>The E-mail address string.</p><h3 id="datasetList" tabindex="-1">datasetList <a class="header-anchor" href="#datasetList" aria-label="Permalink to &quot;datasetList {#datasetList}&quot;">​</a></h3><p>This operation retrieves entries from an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the dataset name.</p></li><li><p><code>filterField</code>, <code>filter</code></p><p>these optional attributes specify an entry attribute name and value. If specified, the operation returns only the entries that have the specified attribute with the specified value.</p></li><li><p><code>mode</code></p><p>this optional attribute can be specified only if the <code>filterField</code> attribute is specified.<br> If the <code>mode</code> attribute is absent, or if its value is eq, then an entry is listed if its entry attribute value is equal to the specified value.<br> If the <code>mode</code> attribute value is beg, then an entry is listed if its entry attribute value starts with the specified value.<br> If the <code>mode</code> attribute value is end, then an entry is listed if its entry attribute value ends with the specified value.<br> If the <code>mode</code> attribute value is contains, then an entry is listed if its entry attribute value contains the specified value as its substring.The Server sends a <a href="#datasetData"><code>datasetData</code></a> data message for each record found.</p></li></ul><h3 id="datasetListSubsets" tabindex="-1">datasetListSubsets <a class="header-anchor" href="#datasetListSubsets" aria-label="Permalink to &quot;datasetListSubsets {#datasetListSubsets}&quot;">​</a></h3><p>This operation lists all subsets of the specified Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the dataset name. specify an empty string to list the top-level Account datasets.The Server sends a <a href="#datasetSubset"><code>datasetSubset</code></a> data message for each dataset found.</p></li></ul><h3 id="datasetSet" tabindex="-1">datasetSet <a class="header-anchor" href="#datasetSet" aria-label="Permalink to &quot;datasetSet {#datasetSet}&quot;">​</a></h3><p>This operation modifies entries in an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the name of the dataset to modify.</p></li><li><p>Body:</p></li></ul><p>The <code>datasetData</code> element. Its <code>name</code> attribute specifies the name of the dataset entry to modify or create. If not specified, a random name is selected for a new entry.<br> The element body should be an XML presentation of the entry attributes to modify.</p><h3 id="datasetDelete" tabindex="-1">datasetDelete <a class="header-anchor" href="#datasetDelete" aria-label="Permalink to &quot;datasetDelete {#datasetDelete}&quot;">​</a></h3><p>This operation removes an entry from an Account dataset.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the name of the dataset to modify.</p></li><li><p><code>name</code></p><p>the name of the dataset entry to remove.</p></li></ul><p>The Server sends the following data messages:</p><h5 id="datasetData" tabindex="-1">datasetData <a class="header-anchor" href="#datasetData" aria-label="Permalink to &quot;datasetData {#datasetData}&quot;">​</a></h5><p>This synchronous data message is sent for each dataset entry retrieved with the <a href="#datasetList"><code>datasetList</code></a> request.</p><p>Attributes:</p><ul><li><p><code>name</code></p><p>the dataset entry name.</p></li><li><p>Body:</p></li></ul><p>The XML presentation of the dataset entry attributes.</p><h5 id="datasetSubset" tabindex="-1">datasetSubset <a class="header-anchor" href="#datasetSubset" aria-label="Permalink to &quot;datasetSubset {#datasetSubset}&quot;">​</a></h5><p>This synchronous data message is sent for each dataset subset retrieved with the <a href="#datasetListSubsets"><code>datasetListSubsets</code></a> request.</p><p>Attributes:</p><ul><li><p><code>dataset</code></p><p>the subset entry name.</p></li><li><p>Body:</p></li></ul><p>none</p><h2 id="Billing" tabindex="-1">Billing <a class="header-anchor" href="#Billing" aria-label="Permalink to &quot;Billing {#Billing}&quot;">​</a></h2><p>A client can manage the <a href="./../admin/misc/Billing.html">Account Balances</a>.</p><h3 id="balance" tabindex="-1">balance <a class="header-anchor" href="#balance" aria-label="Permalink to &quot;balance {#balance}&quot;">​</a></h3><p>This operation performs a <a href="./../admin/misc/Billing.html">Billing</a> operation.</p><p>Attributes:</p><ul><li><p><em>accountName</em></p><p>the target account name (optional). If not specified, the operation is applied to the session owner Account.</p></li><li><p><em>localTime</em></p><p>if this attribute does not exist or its value is not no, then all timestamp-type values in the operation parameters should be specified as local times in the Time Zone selected for the current user, and all timestamp-type values in the operation result are converted into the local time in that Time Zone.<br> If this attribute value is no, then all timestamp-type values in the operation parameters and result are GMT times.</p></li><li><p>Body:</p></li></ul><p>The XML presentation of a dictionary. The dictionary contains the Billing operation (the <code>op</code> element) and the operation parameters.If the operation produces any result, the Server sends a <a href="#balanceData"><code>balanceData</code></a> data message.</p><p>The Server sends the following data messages:</p><h5 id="balanceData" tabindex="-1">balanceData <a class="header-anchor" href="#balanceData" aria-label="Permalink to &quot;balanceData {#balanceData}&quot;">​</a></h5><p>This synchronous data message is sent when a <a href="#balance"><code>balance</code></a> operation produces a result.</p><p>Attributes:</p><ul><li><p><em>accountName</em></p><p>the target account name (optional, the same as specified with the <code>balance</code> operation request).</p></li><li><p>Body:</p></li></ul><p>The <a href="./Data.html">XML presentation</a> presentation of the result dictionary.</p><h2 id="Helpers" tabindex="-1">Application Helpers <a class="header-anchor" href="#Helpers" aria-label="Permalink to &quot;Application Helpers {#Helpers}&quot;">​</a></h2><p>A client can call <a href="./Helpers.html#AppHelpers">External Application Helpers</a>.</p><h3 id="callHelper" tabindex="-1">callHelper <a class="header-anchor" href="#callHelper" aria-label="Permalink to &quot;callHelper {#callHelper}&quot;">​</a></h3><p>This operation calls an External Application Helper. If the operation produces any result, the Server sends a <a href="#helperReply"><code>helperReply</code></a> data message.</p><p>Attributes:</p><ul><li><p><em>name</em></p><p>the name of the Application Helper to call.</p></li><li><p><em>mode</em></p><p>the optional string to specify cluster member with the helper application.</p></li><li><p>Body:</p></li></ul><p>(optional) the XML presentation of the request sent to the Helper.</p><p>The Server sends the following data messages:</p><h5 id="helperReply" tabindex="-1">helperReply <a class="header-anchor" href="#helperReply" aria-label="Permalink to &quot;helperReply {#helperReply}&quot;">​</a></h5><p>This synchronous data message is sent when a <a href="#callHelper"><code>callHelper</code></a> operation produces a result.</p><p>Attributes:</p><ul><li><p><em>name</em></p><p>the same value as in the <code>callHelper</code> operation.</p></li><li><p>Body:</p></li></ul><p>(optional) the XML presentation of the response data received from the Helper.</p><h2 id="Banner" tabindex="-1">Banner Retrieval <a class="header-anchor" href="#Banner" aria-label="Permalink to &quot;Banner Retrieval {#Banner}&quot;">​</a></h2><p>A client can employ an <a href="./Helpers.html#Banner">External Banner System</a>.</p><h3 id="bannerRead" tabindex="-1">bannerRead <a class="header-anchor" href="#bannerRead" aria-label="Permalink to &quot;bannerRead {#bannerRead}&quot;">​</a></h3><p>This operation retrieves banner info. If the operation produces any result, the Server sends a <a href="#bannerRet"><code>banner</code></a> data message.</p><p>Attributes:</p><ul><li><p><em>type</em></p><p>the banner type to retrieve (application-specific, such as prontoEmailTop, myClientLeftBanner).</p></li><li><p>Body:</p></li></ul><p>(optional) the XML presentation of the External Banner System parameter object.</p><p>The Server sends the following data messages:</p><h5 id="banner" tabindex="-1">banner <a class="header-anchor" href="#banner" aria-label="Permalink to &quot;banner {#banner}&quot;">​</a></h5><p>This synchronous data message is sent when a <a href="#bannerRead"><code>bannerRead</code></a> operation produces a result.</p><p>Attributes:</p><ul><li><p><em>type</em></p><p>the same value as in the <code>bannerRead</code> operation.</p></li></ul><p>Body:</p><p>(optional) the XML presentation of the External Banner System resulting object.</p><h2 id="SyncScripts" tabindex="-1">Synchronous Scripts <a class="header-anchor" href="#SyncScripts" aria-label="Permalink to &quot;Synchronous Scripts {#SyncScripts}&quot;">​</a></h2><p>A client can employ an <a href="./CGPL.html#SyncScripts">Synchronous Scripts</a> that are available on the server.</p><h3 id="runScript" tabindex="-1">runScript <a class="header-anchor" href="#runScript" aria-label="Permalink to &quot;runScript {#runScript}&quot;">​</a></h3><p>This operation executes a synchronous script. In response the Server sends a <a href="#scriptResult"><code>scriptResult</code></a> data message.</p><p>Attributes:</p><ul><li><p><em>fileName</em></p><p>the file name of the synchronous script file (the suffix <code>.scgp</code> is optional).</p></li><li><p><em>name</em></p><p>(optional) the name of the script entry point.</p></li><li><p>Body:</p></li></ul><p>(optional) the XML presentation of the parameter object.</p><p>The Server sends the following data messages:</p><h5 id="scriptResult" tabindex="-1">scriptResult <a class="header-anchor" href="#scriptResult" aria-label="Permalink to &quot;scriptResult {#scriptResult}&quot;">​</a></h5><p>This synchronous data message is sent when a <a href="#runScript"><code>runScript</code></a> operation produces a result.</p><p>Attributes:</p><ul><li>Body:</li></ul><p>(optional) the XML presentation of the synchronous script resulting object.</p><h2 id="Formats" tabindex="-1">XML Data Formats <a class="header-anchor" href="#Formats" aria-label="Permalink to &quot;XML Data Formats {#Formats}&quot;">​</a></h2><p>Data elements are presented in the XML format using the following conventions.</p><h3 id="email" tabindex="-1"><code>EMail</code> <a class="header-anchor" href="#email" aria-label="Permalink to &quot;\`EMail\`&quot;">​</a></h3><p>This XML element represents an E-mail message or its message/rfc822 MIME subpart.</p><ul><li><p>Body:</p><p>a set of XML elements containing E-mail message header fields, such as <code>From</code>, <code>Date</code>, etc., and not including MIME content-related fields (such as <code>Content-Type</code>),<br> and (optionally) a <a href="#MIMEFormat"><code>MIME</code></a> element with the message body.</p><p>The type of each XML element is the field name:</p><pre><code>\`&lt;Subject&gt;Hello, world!&lt;/Subject&gt;\`
</code></pre><p>Field categories:</p><ul><li><p><em>Addresses</em>: <code>From</code>, <code>To</code>, <code>Cc</code>, <code>Bcc</code>, <code>Return-Path</code>, <code>Sender</code>, <code>Reply-To</code>, <code>Disposition-Notification-To</code>, <code>Recent-From</code>, <code>Recent-To</code>, <code>Return-Receipt-To</code>, <code>Errors-To</code></p><p>The element body is the E-mail address, in the <code>userName@domainName</code> format, or a more generic <code>userName</code>[<code>%domainA</code>[<code>%domainB</code>]]<code>@domainName</code> format.<br> These elements can contain the <code>realName</code> attribute - a MIME-decoded address <em>name-part</em> or <em>comment</em>.<br> If a field contains several addresses, then several XML elements are created, so each element contains exactly one address.</p></li><li><p><em>Timestamps</em>: <code>Date</code>, <code>Resent-Date</code></p><p>These elements contain:<br> the <code>timeShift</code> attribute - the time difference (in seconds) between the local time specified in the field and the corresponding GMT time<br> the <code>localTime</code> attribute - the field time value (in the iCalendar format) in the Time Zone selected for the current user.<br> The element body is the field global (GMT) time value in the iCalendar format.</p></li><li><p><code>Pty</code></p><p>These elements body are <code>High</code> or <code>Low</code> strings. These values are converted to and from numeric <code>X-Priority</code> header field values.</p></li><li><p><em>Phones</em>: <code>X-Telnum</code></p><p>The element body is a phone number.<br> These elements can contain the <code>type</code> attribute (<code>WORK</code>, <code>CELL</code>, <code>HOME</code>, <code>AGENT</code>, etc.) specifying the type of the phone number/address.<br> If a field contains several phone numbers, then several XML elements are created, so each element contains exactly one phone number.</p></li><li><p><em>Unstructured</em> All fields not listed in previous categories belong to this category. The element body contains the MIME-decoded field value.</p></li></ul></li></ul><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &quot;Mr. Sender.&quot; &lt;user1@example.com&gt;</span></span>
<span class="line"><span>To: user2@example.com (My Friend),</span></span>
<span class="line"><span> =?iso-8859-1?Q?=4Eot=20A=20Friend?= &lt;user2@example.com&gt;</span></span>
<span class="line"><span>Date: Mon, 10 Apr 2006 13:15:48 -0700</span></span>
<span class="line"><span>Subject: It&#39;s 1:15PM now, the meeting has started!</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Mr. Sender.&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user1@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;My Friend&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user2@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Not A Friend&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user3@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Bcc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user1@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Bcc</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060410T151548&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20060410T201548Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;It&#39;s 1:15PM now, the meeting has started!&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="mime" tabindex="-1"><code>MIME</code> <a class="header-anchor" href="#mime" aria-label="Permalink to &quot;\`MIME\`&quot;">​</a></h3><p>This XML element represents a message body or its part (referred to as &quot;part&quot; in the rest of this section).</p><p>Attributes:</p><ul><li><code>partID</code></li></ul><p>this string provides the MIME part location within the message. It can be used to retrieve this message part.</p><ul><li><code>estimatedSize</code></li></ul><p>the estimated size (in bytes) of the part data, after the part data is decoded.</p><ul><li><code>type</code></li></ul><p>the part <code>Content-Type</code> type, without the subtype information.</p><ul><li><code>subtype</code></li></ul><p>the part <code>Content-Type</code> subtype, if present.</p><ul><li><code>charset</code></li></ul><p>the part character set (assume UTF-8 if the attribute is absent).</p><ul><li><code>contentID</code></li></ul><p>the <code>Content-ID</code> string (without the enclosing angle brackets).</p><ul><li><code>disposition</code></li></ul><p>the <code>Content-Disposition</code> string (without parameters).</p><ul><li><code>description</code></li></ul><p>the <code>Content-Description</code> string.</p><ul><li><code>location</code></li></ul><p>the <code>Content-Location</code> string.</p><ul><li><code>class</code></li></ul><p>the <code>Content-Class</code> string, after removing the <code>urn:</code> and <code>content-classes:</code> prefixes.</p><ul><li><code>Type-name</code></li></ul><p>any Content-Type field <em>name</em> parameter with its value, excluding the <code>boundary</code>, <code>charset</code>, and <code>format</code> parameters.</p><ul><li><code>Disposition-name</code></li></ul><p>any Content-Disposition field <em>name</em> parameter with its value.</p><ul><li>Body:</li></ul><p>The element body is optional. When present, it contains the part body data.<br> If the Server fails to read the element body part data, the <code>readError</code> attribute is added to the element. The attribute value contains the reading error code.<br> If the Server fails to parse the element body part data, the <code>parserError</code> attribute is added to the element. The attribute value contains the parsing error code.<br> The element format depends on the part <code>Content-Type</code> (the &quot;*&quot; symbol below means any Content-Type or subtype):</p><ul><li><code>multipart/*</code></li></ul><p>Zero or more <code>MIME</code> XML elements containing message subparts.</p><ul><li><code>message/rfc822</code></li></ul><p>A <code>EMail</code> XML element for the enclosed message.</p><ul><li><code>text/rfc822-headers</code></li></ul><p>An <code>EMail</code> XML element (not containing any <a href="#MIMEFormat"><code>MIME</code></a> body element).</p><ul><li><code>text/directory</code>, <code>text/x-vcard</code></li></ul><p>Zero or more <a href="./Data.html#XMLvCard"><code>vCard</code></a> XML elements.</p><ul><li><code>text/x-vgroup</code></li></ul><p>One <a href="./Data.html#XMLvCardGroup"><code>vCardGroup</code></a> XML element.</p><ul><li><code>text/calendar</code></li></ul><p>an <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> XML element.</p><ul><li><code>message/disposition-notification</code>, <code>message/delivery-status</code></li></ul><p>a <code>MIMEReport</code> XML element.</p><ul><li><code>*/xml</code>, <code>*/*+xml</code></li></ul><p>The XML data of the body element.</p><ul><li><code>text/*</code></li></ul><p>The decoded message text, with all EOL symbols replaced with the Line Feed (0x0A) symbol.<strong>Note:</strong> When a message is being retrieved with the <code>folderRead</code> operation, a MIME element body is included only if:</p><ul><li>its Content-Type is one of the supported types listed above</li><li>its Content-Disposition is not <code>attachment</code></li><li>its size plus the size of the parts already included into the response XML does not exceed the <code>totalSizeLimit</code> operation attribute.</li></ul><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>From: &lt;user1@example.com&gt;</span></span>
<span class="line"><span>To: user2@example.com</span></span>
<span class="line"><span>MIME-Version: 1.0</span></span>
<span class="line"><span>Content-Type: multipart/alternative;boundary=&quot;abcd&quot;</span></span>
<span class="line"><span>Content-Description: Test Message</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--abcd</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;iso-8859-1&quot;;</span></span>
<span class="line"><span>format=flowed; paramX=&quot;valueX&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: quoted-printable</span></span>
<span class="line"><span></span></span>
<span class="line"><span>=46rom where I stay, I can see &amp; hear a lot!</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--abcd</span></span>
<span class="line"><span>Content-Type: text/html; charset=&quot;iso-8859-1&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: quoted-printable</span></span>
<span class="line"><span></span></span>
<span class="line"><span>&lt;html&gt;&lt;body bgcolor=3D&quot;yellow&quot;&gt;</span></span>
<span class="line"><span>&lt;I&gt;From where I stay&lt;/I&gt;, I can see &amp;amp; hear a lot!</span></span>
<span class="line"><span>&lt;/body&gt;&lt;/html&gt;</span></span>
<span class="line"><span>--abcd--</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user1@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;user2@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;alternative&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Description</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Test Message&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> charset</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;iso-8859-1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type-paramX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;valueX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      From where I stay, I can see </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> hear a lot!</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;html&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> charset</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;iso-8859-1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type-paramX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;valueX&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">html</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">body bgcolor=</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">yellow</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;quot;&amp;gt;</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">I</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">From where I stay</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/I</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, I can see </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">amp; hear a lot!</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/body</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">/html</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="MIMEReport" tabindex="-1"><code>MIMEReport</code> <a class="header-anchor" href="#MIMEReport" aria-label="Permalink to &quot;\`MIMEReport\` {#MIMEReport}&quot;">​</a></h3><p>This XML element represents a message report, such as Disposition Notification or a Delivery report.</p><p>Attributes:</p><p><em>none</em></p><p>Body:</p><p>a set of XML elements containing report header fields, such as <code>Reporting-MTA</code>, <code>Final-Recipient</code>, etc.<br> and (optionally) <a href="#MIMEReport"><code>MIMEReport</code></a> elements for the report body.</p><p>Example:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Subject: Delivery report: TEST - disposition and delivery</span></span>
<span class="line"><span>From: &lt;MAILER-DAEMON@remote.example.com&gt;</span></span>
<span class="line"><span>To: &lt;sender@local.example.com&gt;</span></span>
<span class="line"><span>Date: Wed, 02 May 2007 00:33:13 -0700</span></span>
<span class="line"><span>Message-ID: &lt;receipt-39457791@remote.example.com&gt;</span></span>
<span class="line"><span>X-MAPI-Message-Class: REPORT.IPM.Note.DR</span></span>
<span class="line"><span>MIME-Version: 1.0</span></span>
<span class="line"><span>Content-Type: multipart/report; report-type=&quot;delivery-status&quot;; boundary=&quot;_===39457791====remote.example.com===_&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===39457791====remote.example.com===_</span></span>
<span class="line"><span>Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Message delivered to &#39;&lt;recepient@remote.example.com&gt;&#39;</span></span>
<span class="line"><span>LOCAL module(account recepient) reports:</span></span>
<span class="line"><span>Delivered to the user mailbox</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===39457791====remote.example.com===_</span></span>
<span class="line"><span>Content-Type: message/delivery-status</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Reporting-MTA: dns; remote.example.com</span></span>
<span class="line"><span></span></span>
<span class="line"><span>Original-Recipient: rfc822;&lt;recepient@remote.example.com&gt;</span></span>
<span class="line"><span>Final-Recipient: LOCAL;&lt;recepient&gt;</span></span>
<span class="line"><span>Action: delivered</span></span>
<span class="line"><span>Status: 2.0.0</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===39457791====remote.example.com===_</span></span>
<span class="line"><span>Content-Type: text/rfc822-headers</span></span>
<span class="line"><span></span></span>
<span class="line"><span>From: &quot;Sender Name&quot; &lt;sender@local.example.com&gt;</span></span>
<span class="line"><span>Subject: TEST - disposition and delivery</span></span>
<span class="line"><span>To: recepient@remote.example.com</span></span>
<span class="line"><span>X-Mailer: CommuniGate Pro WebUser v5.1.9</span></span>
<span class="line"><span>Date: Wed, 02 May 2007 00:35:51 -0700</span></span>
<span class="line"><span>Message-ID: &lt;web-3990004@local.example.com&gt;</span></span>
<span class="line"><span>MIME-Version: 1.0</span></span>
<span class="line"><span>Disposition-Notification-To: &lt;sender@local.example.com&gt;</span></span>
<span class="line"><span>Content-Type: text/plain;charset=&quot;utf-8&quot;;format=&quot;flowed&quot;</span></span>
<span class="line"><span>Content-Transfer-Encoding: 8bit</span></span>
<span class="line"><span></span></span>
<span class="line"><span>--_===39457791====remote.example.com===_--</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Delivery report: TEST - disposition and delivery&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;MAILER-DAEMON@communigatepro.ru&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;sender@local.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T003313&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070502T073313Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">receipt-39457791@remote.example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-MAPI-Message-Class</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;REPORT.IPM.Note.DR&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-MAPI-Message-Class</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1433&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;report&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;multipart&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> Type-report-type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;delivery-status&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> charset</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;utf-8&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;120&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;01&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;plain&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Message delivered to </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;#39;&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">recepient@remote.example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;&amp;#39;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">LOCAL module(account recepient) reports:</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> Delivered to the user mailbox</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;158&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;02&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;delivery-status&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;message&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIMEReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Reporting-MTA</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;dns; remote.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Reporting-MTA</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIMEReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Original-Recipient</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;rfc822;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">recepient@remote.example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Original-Recipient</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Final-Recipient</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;LOCAL;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">recepient</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Final-Recipient</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Action</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;delivered&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Action</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">     &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Status</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;2.0.0&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Status</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIMEReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIMEReport</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> estimatedSize</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;787&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> partID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;03&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> subtype</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;rfc822-headers&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> type</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;text&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> realName</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Sender Name&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;sender@local.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">From</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;TEST - disposition and delivery&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Subject</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;recepient@remote.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;CommuniGate Pro WebUser v5.1.9&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X-Mailer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> localTime</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20070502T003551&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> timeShift</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-25200&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20070502T073551Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Date</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;lt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">web-3990004@local.example.com</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Message-ID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Disposition-Notification-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;sender@local.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">Disposition-Notification-To</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">   &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMail</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h2 id="HTTP" tabindex="-1">HTTP Access <a class="header-anchor" href="#HTTP" aria-label="Permalink to &quot;HTTP Access {#HTTP}&quot;">​</a></h2><p>Some clients may be unable to implement all operations via the XIMSS protocol. When a XIMSS session is created, its ID is reported back to the client using the <a href="#SessionMessage"><code>session</code></a> data message. The Server provides access to that session via the HTTP protocol.</p><h3 id="MIMEDownload" tabindex="-1">Message Part Retrieval <a class="header-anchor" href="#MIMEDownload" aria-label="Permalink to &quot;Message Part Retrieval {#MIMEDownload}&quot;">​</a></h3><p>The following URL can be used to retrieve any part of a message visible in any currently opened Folder: <code>/Session/sessionID/MIME/folder/UID-partID-suffix</code>[<code>/filename</code>], where</p><ul><li><p><em>sessionID</em></p><p>the current XIMSS session ID, sent with the <a href="#sessionData"><code>session</code></a> data message</p></li><li><p><em>folder</em></p><p>the target Folder name or the target Calendar name</p></li><li><p><em>UID</em></p><p>the target message UID in the target Folder or Calendar</p></li><li><p><em>partID</em></p><p>the id of the requested message MIME part. This is the string reported in the <code>MIME</code> XML element when the message was retrieved using the <code>folderRead</code> operation. If the entire message is to be retrieved, the <em>partID</em> string and the following <code>-</code> symbol should be omitted.</p></li><li><p><em>suffix</em></p><p>the retrieval mode:</p><ul><li><code>P.txt</code> - the entire undecoded part (including the headers and the body) is retrieved.</li><li><code>H.txt</code> - the part headers are retrieved.</li><li><code>B.extension</code> - the decoded part body is retrieved. You can use any appropriate file name extension. The HTTP response gets the Content-Type of the retrieved MIME part.</li><li><code>R/cid</code> - the <em>cid</em> string should be URI-encoded. Its decoded value specifies a MIME-part Content-ID. The Server searches all MIME parts &quot;related&quot; to the current one, and retrieves the body of the part with the matching Content-ID.<br> This feature is used to convert <code>cid:</code>-type URLs in HTML-formatted messages.</li></ul></li><li><p><em>filename</em></p><p>an optional file name. It is ignored by the Server, but it can help the user browser to store the file under the proper name.Examples:</p></li></ul><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:GET /Session/1-2xklkdld8-djdkjk/MIME/INBOX/567-01-B.gif HTTP/1.1</span></span></code></pre></div><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:GET /Session/1-2xklkdld8-djdkjk/MIME/INBOX/567-02-01-B.gif/Logo.gif HTTP/1.1</span></span></code></pre></div><p>It is possible to retrieve only a portion of a message part,using the HTTP <code>Range</code> header field. Alternatively (when HTTP request fields cannot be specified), the URL parameters can be used:</p><ul><li><code>OffsetFrom</code></li></ul><p>part data byte-position to start with (0 means to start from the beginning).</p><ul><li><code>OffsetTill</code></li></ul><p>(optional) part data byte-position following the last byte to send.Example:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:GET /Session/1-2xklkdld8-djdkjk/MIME/INBOX/567-01-B.gif?OffsetFrom=100&amp;OffsetTill=200 HTTP/1.1</span></span></code></pre></div><p>This request retrieves 100 bytes (bytes 100..199 inclusive) from the GIF file encoded in the specified MIME part.</p><h3 id="Profile" tabindex="-1">Profile Retrieval <a class="header-anchor" href="#Profile" aria-label="Permalink to &quot;Profile Retrieval {#Profile}&quot;">​</a></h3><p>The following URL can be used to retrieve the Profile vCard or any of its properties: <code>/Session/sessionID/PROFILE/[propertyname[/index][/filename]]</code>, where</p><ul><li><p><em>sessionID</em></p><p>the current XIMSS session ID, sent with the <a href="#sessionData"><code>session</code></a> data message</p></li><li><p><em>propertyname</em></p><p>the vCard property name, such as <code>PHOTO</code>. If the property name is not specified, the entire vCard is retrieved.</p></li><li><p><em>index</em></p><p>if the vCard contains several values for the specified property name, the index of the value to retrieve (zero-based). If not specified, the index value of 0 is assumed.</p></li><li><p><em>filename</em></p><p>any properly encoded URL-string.Example:</p></li></ul><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">C:GET /Session/1-2xklkdld8-djdkjk/PROFILE/PHOTO/0/avatar HTTP/1.1</span></span></code></pre></div><p>This request retrieves the first value of the &quot;PHOTO&quot; property of the Profile vCard.</p><h3 id="FileUpload" tabindex="-1">File Uploading <a class="header-anchor" href="#FileUpload" aria-label="Permalink to &quot;File Uploading {#FileUpload}&quot;">​</a></h3><p>The following URL can be used to upload a file to the session &quot;uploaded file set&quot;. <code>/Session/sessionID/UPLOAD/uploadID</code>, where</p><ul><li><p><em>sessionID</em></p><p>the current XIMSS session ID, sent with the <a href="#sessionData"><code>session</code></a> data message.</p></li><li><p><em>uploadID</em></p><p>a string identifying this file in the &quot;uploaded file set&quot;.</p></li></ul><p>The HTTP request should be:</p><ul><li>a POST request, with the multipart/form-data content, and the file (raw binary data) should be sent as the <code>fileData</code> form element, or</li><li>a PUT request, and the file (raw binary data) should be sent as the request body.</li></ul><p>When the file is uploaded and added to the &quot;uploaded file set&quot;, the Server returns the 200 response code. If uploading failed, the Server returns the 500 response code.</p><p>The uploaded file is stored together with its Content-Type value.</p><p>If the &quot;uploaded file set&quot; already contains a file with the specified <code>uploadID</code> value, the old file is removed.</p><h3 id="FileDownload" tabindex="-1">File Downloading <a class="header-anchor" href="#FileDownload" aria-label="Permalink to &quot;File Downloading {#FileDownload}&quot;">​</a></h3><p>The following URL can be used to download a file from the session Account <a href="./../admin/storage/FileStore.html">File Storage</a>. <code>/Session/sessionID/DOWNLOAD/fileName</code>, where</p><ul><li><p><em>sessionID</em></p><p>the current XIMSS session ID, sent with the <a href="#sessionData"><code>session</code></a> data message.</p></li><li><p><em>fileName</em></p><p>the file name in the session Account File Storage.<br> Note: to download a file from the &quot;uploaded file set&quot;, specify the <em>fileName</em> as <code>$UPLOAD$/uploadId</code>, where <em>uploadId</em> is the &quot;uploaded file set&quot; file identifier.</p></li></ul><h3 id="Export" tabindex="-1">Data Export <a class="header-anchor" href="#Export" aria-label="Permalink to &quot;Data Export {#Export}&quot;">​</a></h3><p>The following URL can be used to export data from a folder or a calendar: <code>/Session/sessionID/Export/folderName/fileName</code>[<code>?oldStyle=1</code>] If the <em>folderName</em> is a name of an open <a href="#Calendar">Calendar</a> object, the request retrieves an iCalendar text that includes all object VEVENT and VTODO items, and all VTIMEZONE objects referenced.<br> If the <em>folderName</em> is a name of an open folder object, the request retrieves a vCard text that includes all VCard items stored in that folder. If the oldStyle parameter is specified, the vCard items are exported using the vCard 2.1 format and the UTF-8 character set, otherwise the vCard 3.0 format and the Unicode character set is used.</p><h3 id="KeyAndCertExport" tabindex="-1">Private Key and Certificate Export <a class="header-anchor" href="#KeyAndCertExport" aria-label="Permalink to &quot;Private Key and Certificate Export {#KeyAndCertExport}&quot;">​</a></h3><p>The following URL can be used to export the Account Private Key and Certificate as a PKCS12 (&quot;PFX&quot;) file: <code>/Session/sessionID/CertAndKey.pfx?PFXPassword=password</code>[<code>&amp;PFXPassword1=password1</code>] If the <code>PFXPassword1</code> is specified, its value must be the same as the <code>PFXPassword</code> value.<br> The session must have its S/MIME unlocked.<br> The Account Private Key and Certificate are placed into PKCS12-formated data encrypted using the <code>PFXPassword</code> value.</p><h3 id="Abend" tabindex="-1">Abnormal Termination <a class="header-anchor" href="#Abend" aria-label="Permalink to &quot;Abnormal Termination {#Abend}&quot;">​</a></h3><p>The following URL can be used to close the session without doing any &quot;logout cleanup&quot; procedures: <code>/Session/sessionID/KILL</code></p>`,1114))])}const f=t(r,[["render",d]]);export{m as __pageData,f as default};
