import{_ as e,a as i,b as o}from"./chunks/ClusterDynamic4.BwFDH4rM.js";import{_ as l,c as r,o as t,ag as p}from"./chunks/framework.jCcxW76o.js";const C=JSON.parse('{"title":"Динамические Кластеры","description":"","frontmatter":{"legacyLink":"russian/ClusterDynamic.html"},"headers":[],"relativePath":"russian/admin/cluster/Dynamic.md","filePath":"russian/admin/cluster/Dynamic.md"}'),n={name:"russian/admin/cluster/Dynamic.md"};function m(s,a,d,h,u,c){return t(),r("div",null,a[0]||(a[0]=[p('<h1 id="динамические-кластеры" tabindex="-1">Динамические Кластеры <a class="header-anchor" href="#динамические-кластеры" aria-label="Permalink to &quot;Динамические Кластеры&quot;">​</a></h1><p>Хотя <a href="./Static.html">Статические Кластеры</a> могут использоваться для обработки очень больших сайтов, они не вполне отвечают <em>промышленным требованиям</em> по обеспечению безотказной работы.</p><p>Обслуживание набора слабо связанных Серверов также становится проблематичным по мере роста количества Серверов.</p><p>Для решения этих проблем предназначены Динамические Кластера CommuniGate Pro. Они отвечают требованиям безотказной работы &quot;пять девяток&quot; (99,999% времени) и инфраструктура, создающая Образ Единого Сервиса, позволяет Системным Администраторам и Администраторам Домена обслуживать большие Кластерные Системы точно так же, как если бы они обслуживали односерверную систему CommuniGate Pro.</p><p>Основная разница между Статическими и Динамическими Кластерами заключается в способе хранения информации о Пользователях. В отличие от Статического Кластера, в котором для каждого Пользователя существует его Хост Сервер, и только этот Сервер может получать доступ непосредственно к данным пользователя, в Динамическом Кластере все Бэкенд-Серверы могут напрямую получать доступ к данным Пользователя.</p><p>Наиболее часто используемым методом для реализации в Динамическом Кластере совместно используемого Хранилища Пользователей является развёртывание Файловых Серверов или Кластерной Файловой Системы. Дополнительную информацию об Общих Файловых Системах смотрите в разделе <a href="./Storage.html">Хранилище</a>.</p><h2 id="FileLock" tabindex="-1">Традиционный подход, использующий Блокировку Файлов <a class="header-anchor" href="#FileLock" aria-label="Permalink to &quot;Традиционный подход, использующий Блокировку Файлов {#FileLock}&quot;">​</a></h2><p>Многие из существующих Коммуникационных серверов могут использовать в качестве хранилища данных пользователя файловые сервера. Так как эти сервера обычно реализованы как многозадачные системы (в Unix), то в них используются одинаковые методы синхронизации как в односерверной, так и в многосерверной среде, например, такие, как механизм <em>блокировки файлов</em>, реализованный на уровне Операционной/Файловой системы.</p><p>Этот метод имеет следующие проблемы:</p><ul><li>Каждая операция с данными пользователя или данными в папке должна сопровождаться операциями блокировки/разблокировки, плюс, для обеспечения целостности данных, требуются дополнительные операции Файловой Системы. В результате, число операций Файловой Системы увеличивается в 3-5 раз и (так как скорость работы сайта обычно определяется скоростью проведения файловых операций) производительность сайта в целом существенно снижается.</li><li>Современные Файловые Сервера либо вообще не поддерживают механизмы блокировки файлов, либо используют существенно ограниченные версии таковых механизмов, что приводит к тому, что наиболее важная часть сайта - хранение данных пользователя - становится ненадёжной и подверженной сбоям.</li><li>Сбои в работе одного из серверов могут (из-за взаимной блокировки) привести к остановке всего сайта, превратив восстановление работоспособности системы в чрезвычайно сложную задачу.</li><li>Одновременный доступ нескольких клиентов к данным одного пользователя или одной папки также становится невозможным или ненадёжным.</li></ul><p>В попытке уменьшить отрицательное влияние блокировки файлов, некоторые из серверов Сообщений поддерживают только формат папки MailDir (один файл на сообщение) и полагаются на &quot;атомарную&quot; природу операций в файловой директории (а не на блокировки файлов). Подобный подход, позволяя в теории решить некоторые из описанных проблем (хотя в реальных ситуациях это едва ли помогает) ведёт к не экономному использованию ресурсов файлового сервера и сильно перегружает внутренние таблицы файловой системы.<br> Производительность Файловых Серверов сильно снижается, если приложение использует много маленьких файлов вместо нескольких больших.</p><p>Хотя простые методы кластеризации, основывающиеся на возможностях параллельного доступа Операционной/Файловой системы работают нормально для Веб Серверов (где данные изменяются не слишком часто), они не работают сколько-нибудь удовлетворительным образом для серверов Сообщений, где общий объём изменяемых данных почти совпадает с объёмом получаемых данными.</p><p>Простая Кластеризация не даёт никакого дополнительного выигрыша (например, не создаёт Образ Единого Сервиса), так что администрирование 30-серверного кластера становится даже более трудоёмким, чем администрирование 30 независимых Серверов.</p><p>Программное обеспечение CommuniGate Pro поддерживает возможность <a href="./../storage/Mailboxes.html#Legacy">Внешний INBOX</a>, так что основанная на файлах кластеризация так же может быть реализована в системах с CommuniGate Pro. Но, ввиду описанных выше проблем, настоятельно рекомендуется избегать решений такого типа и использовать вместо них настоящий Динамический Кластер CommuniGate Pro.</p><h2 id="Controller" tabindex="-1">Контроллер Кластера <a class="header-anchor" href="#Controller" aria-label="Permalink to &quot;Контроллер Кластера {#Controller}&quot;">​</a></h2><p>Серверы CommuniGate Pro входящие, в Динамический Кластер, не используют механизмы блокировок Операционной/Файловой Системы для синхронизации операций доступа Пользователей. Как и в Статическом Кластере, только один Сервер в Динамическом Кластере имеет прямой доступ к любому отдельно взятому Пользователю в некоторый произвольный момент времени. Все другие Сервера, если они хотят получить доступ к этому Пользователю, работают через этот Сервер. Но это назначение не является статическим: любой сервер может открыть напрямую данные любого Пользователя, если этот Пользователь не открыт каким-либо другим Сервером.</p><p>Такая архитектура обеспечивает максимальное время бесперебойной работы: сбой, происшедший на Бэкенд-Сервере, не приводит к остановке работы - все Пользователи смогут работать через другие Бэкенд-Серверы без какого бы то ни было ручного вмешательства и без простоя системы. Сайт будет продолжать работать и обеспечивать доступ ко всем Пользователям до тех пор, пока будет работать хотя бы один Бэкенд-Сервер.</p><p>Один из Бэкенд-Серверов в Динамическом Кластере действует как <em>Контроллер Кластера</em>. Он синхронизирует все другие Серверы в Кластере и выполняет операции создание Общих Доменов, создание и удаление Пользователей в Общих Доменах, и так далее. Контроллер Кластера также обеспечивает функциональность <em>Образа Единого Сервиса</em>: не только пользователь сайта, но также и администратор сайта может соединиться с любым из серверов в Динамическом Кластере и выполнить любую операцию с Пользователем (даже если в это же время Пользователь открыт на другом Сервере) или с Доменом (произвести изменение Установок Домена) и все произведённые изменения автоматически будут использоваться всеми Серверами, входящими в Кластер.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Распространение на все Сервера, входящие в Кластер, большинства изменений на уровне Домена, таких, как изменение Установок Домена, Установок Пользователя по Умолчанию, Установок Веб Интерфейса Пользователя и Предупреждений уровня Домена может занять до 30 секунд. Изменения уровня Пользователя вступят в силу на всех Серверах немедленно.</p></div><p>Контроллер Кластера собирает с Бэкенд-Серверов информацию о их загрузке. Когда Фронтенд-Сервер получает запрос на установление сессии с Пользователем, который в это время не открыт ни на каком Бэкенд-Сервере, Контроллер направляет Фронтенд-Сервер на наименее загруженный Бэкенд-Сервер. Такая вторичная балансировка нагрузки для Бэкенд-Серверов основывается на их фактическом уровне загрузки и дополняет основную балансировку нагрузки (через циклический DNS или по трафику) Фронтенд-Серверов.</p><p>Если в Динамическом Кластере есть два или более Бэкенд-Сервера, то Контроллер Кластера назначает обязанности Запасного Контроллера на один из оставшихся Бэкенд-Серверов. Все остальные члены Кластера поддерживают соединения с Запасным Контроллером. Если Запасной Контроллер прекращает работу, то в качестве Запасного Контроллера выбирается какой-либо другой Бэкенд-Сервер.</p><p>Если основной Контроллер прекращает работу, то активным Контроллером Кластера становится Запасной Контроллер. Все Сервера отправляют информацию ресинхронизации на Запасной Контроллер и Кластер продолжает работу без остановок.</p><p>Хотя Динамический Кластер может обслуживать Справочник с записями о Пользователях, функциональность Динамического Кластера не полагается на Справочник. Если Справочник все же используется, то он должен быть реализован как <a href="./../directory/CentralDir.html#SharedDirectory">Общий Справочник</a>.</p><p>Полная конфигурация Фронтенд-Бэкенд Динамического Кластера использует также Балансировщик Нагрузки и работает в нескольких отдельных сетях:</p><p><img src="'+e+'" alt="Динамический Кластер"></p><p>Так как все Бэкенд-Серверы в Динамическом Кластере имеют прямой доступ к данным Пользователя, то они должны работать под управлением операционной системы, использующей одинаковые правила относительно EOL (конца строки). Это означает, что все Бэкенд-Серверы должны работать либо под управлением ОС семейства Unix, либо они должны работать под управлением ОС семейства Windows. Фронтенд-Серверы не имеют прямого доступа к данным Пользователя и, следовательно, вы можете использовать для Фронтенд-Серверов любую ОС (например, на сайте могут использоваться какая-нибудь из ОС Unix на Бэкенд-Серверах и Microsoft Windows на Фронтенд-Серверах).</p><h2 id="OSCluster" tabindex="-1">Кластерные Файловые и Операционные системы <a class="header-anchor" href="#OSCluster" aria-label="Permalink to &quot;Кластерные Файловые и Операционные системы {#OSCluster}&quot;">​</a></h2><p>Некоторые из современных операционных систем обладают встроенным возможностями для Кластеризации. Большинство из этих возможностей Кластеризации предназначены для того, чтобы облегчить перенос &quot;обычных&quot;, не кластерных приложений на эти Кластерные платформы. Но некоторые из возможностей, предоставляемые этими ОС, очень полезны для реализации Динамического Кластера CommuniGate Pro.</p><p>Эти возможности включает в себя:</p><ul><li>Кластерную Файловую Систему</li><li>IP Псевдонимы</li></ul><p>Кластерная Файловая Система позволяет всем Серверам в Кластере ОС монтировать и использовать единую файловую систему на совместно используемых устройствах. В отличие от Сетевой Файловой Системы (NFS), в Кластерной Файловой Системе отсутствует требование на выделенный сервер в сети. Кластерная Файловая Система может использовать множественные SCSI соединения, предоставляемые некоторыми устройствами хранения SCSI верхнего уровня, которые позволяют каждому Серверу обмениваться данными непосредственно с устройствами хранения через SAN (Storage Area Network, Сеть хранения данных). Для обеспечения целостности системы, Кластерная Файловая Система использует высокоскоростные межсерверные соединения.</p><p>SAN протоколы очень эффективны для передачи файлов и Кластерная файловая Система может обеспечить лучшую производительность, чем Сетевая Операционная Система.<br> Кластерные Файловые Системы могут также обеспечить более высокую надёжность, чем односерверные NFS решения (где NFS сервер является единственной точкой сбоя).<br> Дополнительную информацию смотрите в разделе <a href="./Storage.html">Хранилище</a>.</p><p>Возможность назначения Псевдонимов для IP позволяет ОС Кластера равномерно распределять нагрузку на сеть между Серверами Кластера, не добавляя отдельное устройство, балансирующее нагрузку.</p><p>Динамический кластер CommuniGate Pro, состоящий только из Бэкенд-серверов, может использовать все возможности таких систем: Псевдонимы IP используются для равномерного распределения нагрузки между Серверами CommuniGate Pro, а сами Сервера CommuniGate Pro используют Кластерную Файловую Систему для хранения всех данных пользователя в общем Домене:</p><p><img src="'+i+'" alt="Динамический - Симметричный"></p><p>Кластерная ОС может также использоваться в конфигурациях CommuniGate Pro с Фронтенд-Бэкенд Серверами. В этом случае одна Кластерная ОС используется для Фронтенд-Серверов CommuniGate Pro, задействуя Псевдонимы IP для равномерного распределения нагрузки, а вторая Кластерная ОС используется для Бэкенд-Серверов CommuniGate Pro, на которых активирована Кластерная Файловая Система:</p><p><img src="'+o+'" alt="Динамический - 2 Кластерные ОС"></p><p>Настройка Динамического Кластера CommuniGate Pro не зависит как от типа используемого балансировщика нагрузки (отдельный или Псевдонимы IP), так и от типа Общей Файловой Системы (Сетевая Файловая Система или Кластерная Файловая Система).</p><h2 id="BackendConfig" tabindex="-1">Настройка Бэкенд-Серверов <a class="header-anchor" href="#BackendConfig" aria-label="Permalink to &quot;Настройка Бэкенд-Серверов {#BackendConfig}&quot;">​</a></h2><p>Для того, чтобы установить Динамический Кластер, выполните следующие действия:</p><ul><li><p>Установите и <a href="./#Config">настройте</a> программное обеспечение CommuniGate Pro на всех Серверах, которые должны войти в Динамический Кластер.</p></li><li><p>Откройте через Веб Интерфейс Администратора страницу Установки-&gt;Услуги и измените настройки службы PWD. Каждый член Кластера (Бэкенд и Фронтенд) открывает два PWD соединения с Контроллером Кластера, так что максимальное число каналов должно быть увеличено как минимум на <code>2* (число Бэкенд-Серверов + число Фронтенд-Серверов)</code></p><p>Так как дополнительные PWD соединения могут открываться Фронтенд и Бэкенд серверами для обслуживания административных запросов и запросов пользователя, лучше увеличить число каналов на: <code>5* (число Бэкенд-Серверов) + 3*(число Фронтенд-Серверов)</code></p></li><li><p>Откройте в Веб Интерфейсе Администратора страницу Установки-&gt;Общее-&gt;Кластер и введите IP адреса всех Фронтенд и Бэкенд Серверов в Кластере.</p></li><li><p>Остановите все Сервера.</p></li><li><p>Создайте файловую директорию, в которой будут находится Общие Домены. Вы должны создать эту файловую директорию на таком устройстве хранения, которое будет доступно для всех Бэкенд-Серверов в Кластере (например, на файловом сервере). Поместите ссылку на эту директорию в <em>директории данных</em> CommuniGate Pro и назовите эту ссылку <code>SharedDomains</code>. Убедитесь, что все Бэкенд-Серверы имеют полные права доступа и могут создавать, удалять, читать и изменять файлы и директории внутри директории SharedDomains.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Если создание символьной ссылки является проблематичным (как, например, на платформах MS Windows), то вы должны указать месторасположение &quot;смонтированной&quot; файловой директории в опции <code>--SharedBase</code> <a href="./../sysadmin/#Options">в Командной Строке</a>:</p><p><code>--SharedBase H:\\Base</code></p></div></li><li><p>Если вы мигрируете с односерверной конфигурации, вы можете сделать какие-либо из существующих доменов общими, и они будут обслуживаться всем Кластером. В этом случае, вам необходимо передвинуть директорию с доменом из директории <code>{base}/Domains</code> в директорию <code>{base}/SharedDomains</code> (размещённую на совместно используемом устройстве хранения).</p></li><li><p>Измените опции Запуска для каждого из ваших Бэкенд-Серверов так, чтобы у всех у них в Командной Строке присутствовала опция <code>--ClusterBackend</code>.</p></li><li><p>Запустите один из Бэкенд-Серверов.</p></li></ul><p>Используйте Веб Интерфейс Администратора этого первого Бэкенд-Сервера чтобы убедиться, что Контроллер Кластера работает. Откройте страницу Домены и проверьте, что:</p><ul><li>сервер видит все домены, которые вы поместили в директорию SharedDomains;</li><li>рядом с кнопкой Создать Домен теперь имеется кнопка Создать Домен в Динамическом Кластере.</li></ul><p>Используйте кнопку Создать Домен в Динамическом Кластере, чтобы создать дополнительные Общие Домены, которые будут обслуживаться Динамическим Кластером.</p><p>После того, как Контроллер Кластера заработал, сайт может начинать обслуживание клиентов (если вы не используете другие Фронтенд-Сервера). Если в вашей конфигурации развёрнуты также и Фронтенд-Сервера, то как минимум один из них должен быть запущен.</p><h2 id="BackendAdd" tabindex="-1">Добавление Бэкенд-Серверов в Динамический Кластер <a class="header-anchor" href="#BackendAdd" aria-label="Permalink to &quot;Добавление Бэкенд-Серверов в Динамический Кластер {#BackendAdd}&quot;">​</a></h2><p>Вы можете добавить дополнительные Бэкенд-Серверы в Кластер в любой момент. Они должны быть настроены точно также, как был настроен первый Бэкенд-Сервер.</p><p>Чтобы добавить Бэкенд-Сервер в Динамический Кластер, запустите его с параметром Командной Строки <code>--ClusterBackend</code> (этот параметр может быть добавлен в сценарий автоматического запуска CommuniGate Pro). Сервер будет опрашивать все указанные IP адреса Бэкенд-Серверов до тех пор, пока он не обнаружит Активный Контроллер Кластера.</p><p>Используйте Веб Интерфейс Администратора, чтобы убедиться, что Бэкенд-Сервер работает. Используйте страницу Домены, чтобы проверить, что Сервер видит все Общие Домены, и что вы можете управлять пользователями в Общих Доменах.</p><p>Если работает Контроллер Кластера и, как минимум, один Бэкенд-Сервер, то они оба могут обслуживать всех пользователей Общих Доменов. Если вы не используете Фронтенд-Серверы, то балансировка нагрузки должна быть реализована через обычный коммутатор, балансирующий нагрузку, циклический DNS или подобные им техники, равномерно распределяющие входящие запросы между всеми Бэкенд-Серверами.</p><h2 id="FrontendConfig" tabindex="-1">Добавление Фронтенд-Серверов в Динамический Кластер <a class="header-anchor" href="#FrontendConfig" aria-label="Permalink to &quot;Добавление Фронтенд-Серверов в Динамический Кластер {#FrontendConfig}&quot;">​</a></h2><p>Вы можете добавить дополнительные Фронтенд-Серверы в Кластер в любой момент.</p><p>Установите и <a href="./#Config">настройте</a> программное обеспечение CommuniGate Pro на компьютере с Фронтенд-Сервером. Так как Фронтенд-Серверы не имеют прямого доступа к данным Пользователя, то, соответственно, нет необходимости делать директорию SharedDomains доступной (&quot;смонтированной&quot; или &quot;отображённой&quot;) для какого бы то ни было Фронтенд-Сервера.</p><p>Используя в Веб Интерфейсе Администратора Фронтенд-Сервера страницу Установки-&gt;Общее-&gt;Кластер, укажите адреса всех Бэкенд-Серверов.</p><p>Чтобы добавить Фронтенд-Сервер в ваш Динамический Кластер, остановите его (сервер) и перезапустите его с параметром Командной Строки <code>--ClusterFrontend</code> (этот параметр может быть добавлен в сценарий автоматического запуска CommuniGate Pro). Сервер будет опрашивать все указанные IP адреса Бэкенд-Серверов до тех пор, пока он не обнаружит Активный Контроллер Кластера.</p><p>Используйте Веб Интерфейс Администратора этого Фронтенд-Сервера чтобы убедиться, что он работает. Используйте страницу Домены чтобы проверить, что Сервер видит все Общие Домены.</p><p>Когда Фронтенд-Серверы пытаются открыть данные одного из Пользователей Общего Домена, Контроллер направляет их на один из Бэкенд-Серверов, равномерно распределяя нагрузку между всеми доступными Бэкенд-Серверами.</p><h2 id="SharedSettings" tabindex="-1">Общие для Кластера Настройки <a class="header-anchor" href="#SharedSettings" aria-label="Permalink to &quot;Общие для Кластера Настройки {#SharedSettings}&quot;">​</a></h2><p>Для Общих Доменов Динамический Кластер имеет отдельный набор &quot;Установок по Умолчанию&quot;.</p><p>Эти установки включает в себя:</p><ul><li>Настройки Домена по умолчанию для всех Общих Доменов</li><li>Установки Пользователя по Умолчанию и Настройки Веб Интерфейса Пользователя по Умолчанию для всех Общих Доменов</li><li>Общекластерные Предупреждения - эти предупреждения отправляются всем Пользователям в Общих Доменах</li></ul><p>Когда Администратор Сервера использует Веб Интерфейс Администратора для изменения этих установок, то на страницах Веб Администрирования отображается ссылка, позволяющая Администратору переключатся между Общесерверными установками (которые применяются для всех не Общих Доменов) и Общекластерными установками. Общекластерные установки автоматически изменяются на всех членах Кластера и применяются для всех Общих Доменов.</p><p>Общекластерные Установки также включают в себя:</p><ul><li>Общекластерные Установки <a href="./../network/">Сети</a>.</li><li>Общекластерные Таблицы <a href="./../sysadmin/Router.html#Cluster">Маршрутизации</a>.</li><li>Общекластерные Установки <a href="./../directory/CentralDir.html#Cluster">Центрального Справочника</a>.</li><li>Общекластерные <a href="./../../development/Rules.html#Cluster">Правила</a>.</li><li>Общекластерные Установки <a href="./../sysadmin/Protection.html">Защиты</a>.</li><li>Общекластерные Именованные и применяемые по умолчанию <a href="./../../development/WebApp.html">Виды Интерфейса</a>. Эти Виды Интерфейса используются по умолчанию в Общих Доменах.</li><li>Общекластерные Среды Приложений <a href="./../../development/PBXApp.html">Реального Времени</a>.</li><li>Общекластерные настройки <a href="./../sysadmin/Intercept.html">СОРМ - перехвата сообщений</a>.</li></ul><h2 id="SharedProcessing" tabindex="-1">Общая Обработка <a class="header-anchor" href="#SharedProcessing" aria-label="Permalink to &quot;Общая Обработка {#SharedProcessing}&quot;">​</a></h2><p>Компонент Образ Единого Сервиса Динамического Кластера обеспечивает синхронизацию Установок Пользователей, Установок Доменов и ряда других настроек.</p><p>Дополнительная функциональность &quot;общей обработки&quot; включает в себя также:</p><ul><li>Обработка периодических общекластерных задач <a href="./../objects/Chronos.html">Chronos</a>.</li><li>Распределённая обработка <a href="./EMail.html">Очереди</a>.</li><li>Распределённая обработка <a href="./Signals.html">Сигналов</a>.</li><li>Распределённая обработка задач <a href="./../mail/RPOP.html">RPOP</a> и <a href="./../signals/PSTN.html#RSIP">RSIP</a>.</li><li>Общекластерное <a href="./../mail/SMTP.html#ETRN">освобождение очереди SMTP</a> (через команду ETRN или сообщение пробуждения).</li><li>Общекластерная синхронизация жетонов Аутентификации (<em>nonce</em>).</li><li>Общекластерные <a href="./../directory/#Cluster">Тома Хранения Справочника</a>.</li></ul><h2 id="Del" tabindex="-1">Удаление Серверов из Динамического Кластера <a class="header-anchor" href="#Del" aria-label="Permalink to &quot;Удаление Серверов из Динамического Кластера {#Del}&quot;">​</a></h2><p>Для удаления Серверов из Динамического Кластера используйте Веб Интерфейс Администратора. Откройте страницу Кластеры в области Наблюдение и нажмите на кнопку Убрать Готовность.</p><p>Когда Фронтенд-Сервер не находится в состоянии Готовности, все его UDP порты и все его TCP порты (кроме портов, используемых для Администрирования по HTTP) закрываются.<br> Балансировщик нагрузки, доставляющий входящие соединения на Фронтенд-Сервер, должен обнаружить это состояние и прекратить отправку соединений и пакетов на этот Фронтенд-Сервер.</p><p>Когда Бэкенд-Сервер не находится в состоянии Готовности, Контроллер не отправляет на этот Сервер новые сессии. Подождите окончания всех существующих сессий и выключите Бэкенд-Сервер.</p><p>Если Бэкенд-Сервер является Активным Контроллером, то перевод его из состояния Готовности заставит Контроллер отправлять все новые сессии на другие Бэкенд-Сервера. Если в Кластере нет других Бэкенд-Серверов, то Контроллер будет продолжать самостоятельно обслуживать новые сессии.</p><p>Вы можете нажать на кнопку Установить Готовность на этой же странице для того, чтобы заново включить Сервер. Если Сервер является Бэкенд-Сервером, то Контроллер начинает отправлять на него новые сессии.</p><p>Необходимо иметь право доступа <a href="./../sysadmin/#Privs">&quot;Может управлять Кластером&quot;</a>, чтобы устанавливать или сбрасывать Готовность.</p><p>Если Бэкенд-Сервер заканчивает работу из-за сбоя, то сессии всех Пользователей Общих Доменов открытых на этом Сервере, не смогут продолжаться. Они смогут продолжить работу снова через 5-10 секунд, когда Контроллер Кластера обнаружит этот сбой. Сбой в работе Бэкенд-Сервера не приводит к потере данных.</p><h2 id="Upgrade" tabindex="-1">Модернизация Серверов в Динамическом Кластере <a class="header-anchor" href="#Upgrade" aria-label="Permalink to &quot;Модернизация Серверов в Динамическом Кластере {#Upgrade}&quot;">​</a></h2><p>Динамический Кластер создавался таким образом, чтобы сделать возможным плавную модернизацию всех входящих в него серверов. Для установки более новой версии программного обеспечения CommuniGate Pro вы должны обновлять сервера один за одним, поочерёдно: сначала уберите сервер из Кластера, затем обновите программное обеспечение и снова добавьте сервер обратно в Кластер. Эта процедура позволяет вашему сайту работать без остановок во время обновления.</p><p>Определённые изменения в программном обеспечении CommuniGate Pro могут накладывать определённые ограничения на процесс &quot;плавной модернизации&quot;. Всегда проверяйте раздел <a href="./../common/History.html">История</a> перед тем, как обновить ваш Кластер и убедитесь, что там отсутствуют ограничения на Обновления Кластера.</p>',79)]))}const S=l(n,[["render",m]]);export{C as __pageData,S as default};
