import{_ as e,a as o,b as a}from"./chunks/SFSCFS.EQTSUlXL.js";import{_ as p,c as r,o as l,ag as i}from"./chunks/framework.jCcxW76o.js";const F=JSON.parse('{"title":"Кластерное Хранилище","description":"","frontmatter":{"legacyLink":"russian/ClusterStorage.html"},"headers":[],"relativePath":"russian/admin/cluster/Storage.md","filePath":"russian/admin/cluster/Storage.md"}'),u={name:"russian/admin/cluster/Storage.md"};function s(n,t,d,S,q,m){return l(),r("div",null,t[0]||(t[0]=[i('<h1 id="кластерное-хранилище" tabindex="-1">Кластерное Хранилище <a class="header-anchor" href="#кластерное-хранилище" aria-label="Permalink to &quot;Кластерное Хранилище&quot;">​</a></h1><p>Динамические Кластера CommuniGate Pro требуют наличия <em>Общей Файловой Системы</em>, чтобы Backend члены Кластера могли работать с одними и теми же данными одновременно.</p><p>Наиболее популярной и хорошо известной реализацией Общей Файловой Системы является файловый сервер, также называемый NAS (<em>network attached storage, сетевое хранилище</em>).</p><p>В этом разделе коротко описываются технологии, используемые в Общих Файловых Системах, объясняется, почему SAN (storage area network*, сеть хранения данных*) <strong>не</strong> является Общей Файловой Системой, а также содержится краткое введение в Кластерные Файловые Системы, которые могут использоваться для построения Общей Файловой Системы с использованием SAN.</p><h2 id="FileSystems" tabindex="-1">Системы Хранения и Файловые Системы <a class="header-anchor" href="#FileSystems" aria-label="Permalink to &quot;Системы Хранения и Файловые Системы {#FileSystems}&quot;">​</a></h2><p>Используемые сегодня Системы Хранения (такие как дисковые устройства) являются довольно &quot;примитивными&quot; устройствами с точки зрения пользователя и приложений. Каждая система или устройство имеет некоторое количество <em>блоков</em> - сегментов данных фиксированного размера, например, размером 1К (1024 байт). При соединении дискового устройства с компьютером оно может обрабатывать только очень простые запросы, такие как:</p><ul><li>READBLOCK(12345) - прочитать блок номер 12345 и отправить данные в компьютер.</li><li>WRITEBLOCK(765645) - получить данные от компьютера и сохранить их в блоке номер 765645.</li></ul><p>Диски могут соединяться с компьютерами при помощи интерфейсов IDE, SCSI или FDDI. Эти интерфейсы используются для отправки дискам команд и данных и для получения от диска данных и кодов выполнения команд.</p><p>Сами по себе Системы Хранения не создают никакие другие структуры, что означает что дисковое устройство не может создавать &quot;файлы&quot; или &quot;файловые директории&quot;. Эти системы работают только с блоками и всё, что они могут делать - это читать и записывать эти блоки.</p><h2 id="Single" tabindex="-1">Файловые Системы в Одиночной ОС <a class="header-anchor" href="#Single" aria-label="Permalink to &quot;Файловые Системы в Одиночной ОС {#Single}&quot;">​</a></h2><p>В каждой современной Операционной Системе (ОС) есть компонент, называемый <em>Файловая Система</em>. Этот компонент является частью <em>ядра</em> ОС и в нём реализованы такие вещи, как &quot;файлы&quot; и &quot;файловые директории&quot;.</p><p>Существует много разных Файловых Систем, в них используются различные методы и алгоритмы, но некоторые основные функции имеются в большинстве Файловых Систем:</p><ul><li>Файловая Система ведёт в том или ином виде Таблицу Размещения Файлов (FAT) - информацию, которая связывает логические файлы с номерами блоков в устройстве хранения. Например, в FAT может быть задано, что &quot;File1&quot; хранится в 5 блоках диска с номерами 123400, 123405, 123401, 177777, 123456, а &quot;File2&quot; хранится в 6 блоках диска с номерами 323400, 323405, 323401, 377777, 323456, 893456.</li><li>Файловая Система ведёт список всех неиспользуемых блоков хранения и автоматически <em>размещает</em> новые блоки, когда файл увеличивается в размере и возвращает блоки в список неиспользованных блоков, когда файл уменьшает свой размер или удаляется.</li><li>Файловая Система обрабатывает запросы приложений, которым необходимо прочитать данные из логических файлов или записать данные в них. Файловая Система преобразовывает эти запросы в одну или несколько операций чтения/записи блоков, используя информацию из Таблицы Размещения Файлов.</li><li>Файловая Система ведёт специальные файлы, называемые &quot;файловыми директориями&quot; и сохраняет в них информацию о других файлах, &quot;находящихся&quot; в этих директориях.</li><li>Файловая система также обеспечивает работу &quot;файлового кэша&quot; При записи информации в файл она сохраняется на Устройстве Хранения (на дисках) и одновременно копируется в &quot;кэш-буфер&quot; Файловой Системы.<br> При чтении информации из хранилища, она передаётся в приложение и одновременно копируется в &quot;кэш-буфер&quot;&quot;<br> Когда этому (или другому) приложению необходимо прочитать эту же порцию информации из файла, находящегося в кэше, Файловая Система просто возвращает эту информацию из своего кэш-буфера вместо того, чтобы прочитывать её повторно из Системы Хранения.</li></ul><p>Следующий рисунок иллюстрирует работу Файловой Системы:</p><p><img src="'+e+'" alt="Файловая Система в Одиночной ОС"></p><p>В этом примере Файловая Система обслуживает запросы от двух приложений.</p><ul><li><p><strong>Приложение 1 просит Файловую Систему прочитать блок номер 5 из <code>File1</code>.</strong></p><p>Файловая Система находит информацию о File1 в Таблице Размещения Файлов и определяет, что для этого файла размещено 5 блоков, и блок файла номер 5 хранится на диске в блоке номер 123456.</p><p>Файловая Система через интерфейс диска (IDE, SCSI или любой другой) отправляет диску команду READBLOCK(123456).</p><p>Дисковое устройство отправляет информацию из указанного блока в компьютер.</p><p>Файловая Система помещает прочитанную информацию в кэш-буфер и отправляет её приложению.</p></li><li><p><strong>Приложение 2 просит Файловую Систему записать блок номер 7 в <code>File2</code>.</strong></p><p>Файловая Система находит информацию о File2 в Таблице Размещения Файлов и определяет, что для этого файла размещено 6 блоков. Она проверяет список неиспользуемых блоков диска и находит неиспользуемый блок номер 13477.</p><p>Она удаляет номер блока из списка неиспользуемых блоков и добавляет его блоком номер 7 в информацию о File2 в Таблице Размещения Файлов, так что теперь File2 имеет размер 7 блоков.</p><p>Файловая Система через интерфейс диска (IDE, SCSI или любой другой) отправляет диску команду WRITEBLOCK(13477) и отправляет данные блока, которые были созданы приложением.</p><p>Дисковое устройство записывает данные блока в указанной блок диска и подтверждает выполнение операции.</p><p>Файловая Система копирует данные блока в кэш-буфер.</p></li></ul><p>Если любое приложение попытается прочитать блок 5 из File1 или блок 7 из File2, то Файловая Система получит информацию из кэш-буфера и не будет выполнять операцию на диске.</p><p>Все приложения, работающие в этой Операционной системе, используют единую Файловую Систему. Файловая Система гарантирует целостность данных. Если блок диска 13477 выделен для File2, то он не будет выделяться ни для какого-либо другого файла - до тех пор, пока File2 не будет удалён или не уменьшит свой размер до размера менее, чем 7 блоков.</p><h2 id="NAS" tabindex="-1">Сетевая Файловая Система (NAS) <a class="header-anchor" href="#NAS" aria-label="Permalink to &quot;Сетевая Файловая Система (NAS) {#NAS}&quot;">​</a></h2><p>Если компьютерам сервера необходимо использовать одни и те же данные, то может использоваться Сетевая Файловая Система (также называемая Network Attached Storage, NAS).</p><p>Сетевая Файловая Система реализуется с использованием <em>Файлового Сервера</em> и <em>сети</em>. Файловый Сервер - это обычный компьютер или специальная ОС с обычной Файловой Системой и обычными дисковыми устройствами, управляемыми этой Файловой Системой.</p><p>Сетевая Файловая Система &quot;встраивает&quot; часть себя внутрь ядра ОС на &quot;клиентских&quot; компьютерах как &quot;подставную&quot; Файловую Систему, ретранслирующую запросы приложения к файлам на Файловый Сервер через сеть:</p><p><img src="'+o+'" alt="Общая Файловая Система с NAS"></p><p>В этом примере Файловая Система на Файловом Сервере обслуживает запросы нескольких приложений, запущенных на &quot;клиентских&quot; компьютерах сервера.</p><p>Единственная разница с одиночной ОС заключается в доставке запросов; вместо нескольких внутренних операций между приложением и Файловой Системой, работающей в составе ядра ОС, встроенная &quot;заглушка&quot; отправляет запросы через сеть, получает ответы и передаёт их приложению. Вся &quot;реальная работа&quot; (обслуживание Таблицы Размещения Файлов и кэша) выполняется на компьютере Файлового Сервера.</p><p>Так как только компьютер Файлового Сервера имеет прямой доступ к физическому диску, то все приложения, запущенные на сервере, используют одну и ту же Файловую Систему - Файловую Систему, работающую на Файловом Сервере. Эта Файловая Система гарантирует целостность данных. Если блок диска 13477 выделен для File2, то он не будет выделяться ни для какого-либо другого файла - до тех пор, пока File2 не будет удалён или не уменьшит свой размер до размера менее, чем 7 блоков.</p><h2 id="SAN" tabindex="-1">Сеть Хранения Данных (SAN) <a class="header-anchor" href="#SAN" aria-label="Permalink to &quot;Сеть Хранения Данных (SAN) {#SAN}&quot;">​</a></h2><p>Сеть Хранения Данных является сетью специального типа, соединяющей компьютеры и дисковые устройства, подобно тому, как SCSI кабеля соединяют дисковые устройства с компьютером.</p><p>Любой компьютер, соединённый с SAN, может отправлять дисковые команды на любое дисковое устройство, подсоединённое к SAN. На физическом уровне, SAN может быть реализован через FDDI, Ethernet или любой другой тип интерфейса.</p><p>Некоторые диски или массивы имеют &quot;двухканальные&quot; контроллеры SCSI и могут быть соединены с двумя компьютерами через обычные кабели SCSI. Так как оба компьютера могут отправлять дисковые команды чтения/записи на такой общий диск, то такая конфигурация имеет такую же функциональность, как и однодисковый SAN.</p><p>SAN обеспечивает реализацию Общих Дисков, но сам по себе SAN не является Общей Файловой Системой. Если у вас есть несколько компьютеров, имеющих доступ к Общему Диску (через SAN или по двухканальному SCSI) и вы попытаетесь использовать такой диск с обычной Файловой Системой, то очень быстро логическая структура диска будет нарушена.</p><p>С Общими Дисками и обычными Файловыми Системами возникают две основные проблемы:</p><ul><li><p><strong>Отсутствие целостности при размещении свободного пространства Диска</strong></p><p>Если компьютер X и компьютер Y оба соединены с общим диском (&quot;смонтировали его&quot;), то их Файловые Системы загрузили в память каждого компьютера Таблицы Размещения Файлов. Теперь, если некоторая программа, запущенная на компьютере X, попытается записать новые блоки в какой-нибудь файл, то Файловая Система, работающая на этом компьютере, сначала проверит Таблицу Размещения Файлов и выделит блок номер 13477 для этого файла.</p><p>Затем Файловая Система, работающая на этом компьютере, изменит свою Таблицу Размещения Файлов, но эти изменения не окажут никакого эффекта на Таблицы Размещения Файлов, загруженные в память других компьютеров. Если приложению, запущенному на каком-либо другом компьютере Y, потребуется увеличить размер файла, то Файловая Система, работающая на этом компьютере Y, может выделить тот же самый блок 13477 для другого файла, так как она понятия не имела о том, что этот блок уже был выделен компьютером X.</p></li><li><p><strong>Отсутствие целостности Данных Файла</strong></p><p>Если программа, запущенная на компьютере X, прочитала блок 5 из какого-нибудь файла File1, то это блок копируется в кэш Файловой Системы. Если эта же или другая программа, запущенная на компьютере X попытается прочитать тот же самый блок 5 из этого же файла, то Файловая Система компьютера X просто скопирует данные из своего кэша.</p><p>Но программа, запущенная на каком-либо другом компьютере Y, может изменить информацию в блоке 5 файла File1. Так как Файловая Система, запущенная на компьютере X, не будет знать об этом, то она продолжит использовать свой кэш, отправляя приложениям на компьютере X данные, потерявшие актуальность.</p></li></ul><p>Эти проблемы делают невозможным использование Общих Дисков с обычными Файловыми Системами в качестве Общей Файловой Системы. Они могут использоваться для систем восстановления после сбоев или в других конфигурациях, где в любой момент времени диск фактически используется только одним из компьютеров. Файловая Система на компьютере Y начинает использовать Общий Диск только когда компьютер X выключен или прекратил использование Общего Диска.</p><h2 id="CFS" tabindex="-1">Кластерная Файловая Система <a class="header-anchor" href="#CFS" aria-label="Permalink to &quot;Кластерная Файловая Система {#CFS}&quot;">​</a></h2><p>Кластерные Файловые Системы - это программные продукты, предназначенные для решения проблем, упомянутых выше. Они позволяют вам строить многокомпьютерные системы с Общими Дисками, решая проблемы целостности данных.</p><p>Кластерные Файловые Системы обычно реализуются как &quot;надстройки&quot; над обычными Файловыми Системами. Кластерные Файловые Системы используют некое подобие межсерверной сети для передачи информации друг другу и синхронизации своей деятельности. Межсерверные &quot;взаимодействия&quot; могут реализовываться как по обычным сетям Ethernet, используя тот же самый SAN, соединяющий компьютеры и диски, так и используя для &quot;взаимодействий кластеров&quot; специальные устройства с низкими задержками.</p><p><img src="'+a+'" alt="Кластерная Файловая Система"></p><p>В этом примере Кластерная Файловая Система устанавливается на нескольких компьютерах и обслуживает запросы от приложений, запущенных на этих компьютерах.</p><ul><li><p><strong>Приложение 1, запущенное на первом компьютере, просит Кластерную Файловую Систему прочитать блок номер 5 из <code>File1</code>.</strong></p><p>Кластерная Файловая Система передаёт запрос обычной Файловой Системе, обслуживающей Общий Диск и далее блок данных читается точно таким же образом, как он читается на одиночном сервере.</p></li><li><p><strong>Приложение 2, запущенное на другой системе, просит Кластерную Файловую Систему записать блок номер 7 в <code>File2</code>.</strong></p><p>Кластерная Файловая Система через межсерверную сеть уведомляет Кластерные Файловые Системы на других компьютерах об изменении этого блока. Кластерные Файловые Системы удаляют старую, устаревшую копию данных блока из своего кэша.</p><p>Кластерная Файловая Система передаёт запрос обычной Файловой Системе. Она находит информацию о File2 в Таблице Размещения Файлов и определяет, что для этого файла выделено 6 блоков. Она проверяет список неиспользуемых блоков диска и находит неиспользуемый блок номер 13477. Она удаляет номер блока из списка неиспользуемых блоков и добавляет его блоком номер 7 в информацию о File2 в Таблице Размещения Файлов, так что теперь File2 имеет размер 7 блоков.</p><p>Кластерная Файловая Система через межсерверную сеть уведомляет Кластерные Файловые Системы на других компьютерах об изменении Таблицы Размещения Файлов. Кластерные Файловые Системы на этих компьютерах синхронизируются и изменяют свои копии Таблиц Размещения Файлов.</p><p>Файловая Система использует интерфейс диска для отправки команды WRITEBLOCK(13477) на Общий Диск и отправляет данные блока, сгенерированные в приложении.</p><p>Дисковое устройство записывает данные блока в указанной блок диска и подтверждает выполнение операции.</p></li></ul><p>Кластерная Файловая Система решает проблему целостности и в качестве Общей Файловой Системы позволяет нескольким компьютерам использовать Общие Диски.</p><p>Кластерная Файловая Система доступна для нескольких Операционных Систем:</p><table tabindex="0"><thead><tr><th>Кластерная файловая система</th><th>Операционная Система</th></tr></thead><tbody><tr><td>VERITAS Cluster File System</td><td>Sun Solaris</td></tr><tr><td>Sun Cluster 3.0</td><td>Sun Solaris</td></tr><tr><td>Generalized Parallel File System (GPFS)</td><td>IBM AIX, Linux</td></tr><tr><td><a href="http://www.dataplow.com/" target="_blank" rel="noreferrer">DataPlow</a></td><td>Linux, Solaris, Windows</td></tr><tr><td>PolyServe</td><td>Linux</td></tr><tr><td>GFS</td><td>Linux</td></tr></tbody></table>',44)]))}const A=p(u,[["render",s]]);export{F as __pageData,A as default};
