import{_ as a,a as n}from"./chunks/Tree2.ByF2wDwZ.js";import{_ as i,c as d,o as p,ag as t,j as e,a as o}from"./chunks/framework.jCcxW76o.js";const v=JSON.parse('{"title":"Справочник","description":"","frontmatter":{"legacyLink":"russian/Directory.html"},"headers":[],"relativePath":"russian/admin/directory/index.md","filePath":"russian/admin/directory/index.md"}'),c={name:"russian/admin/directory/index.md"};function r(u,l,s,m,h,D){return p(),d("div",null,l[0]||(l[0]=[t('<h1 id="справочник" tabindex="-1">Справочник <a class="header-anchor" href="#справочник" aria-label="Permalink to &quot;Справочник&quot;">​</a></h1><p>Сервер CommuniGate Pro включает в себя Менеджер Справочника, в котором реализован высокопроизводительный, основывающийся на публичных стандартах Справочник.</p><p>Справочник может содержать записи о Пользователях, Доменах и других объектах CommuniGate Pro. Он также может содержать в себе любые другие типы записей и может использоваться как выделенный Сервер Справочника, обслуживающий приложения, работающие по протоколу LDAP.</p><p>Менеджер Справочника не является LDAP сервером. <a href="./../services/LDAP.html">Модуль LDAP</a> CommuniGate Pro обеспечивает доступ к Справочнику для LDAP клиентов, но различные компоненты CommuniGate Pro (Менеджер Пользователей и Менеджер Доменов, Веб Интерфейс Пользователя и т.д.) получают данные из Справочника напрямую, минуя LDAP протокол.</p><p>В Менеджере Справочника реализован <em>Мета-Справочник</em>: такой Мета-Справочник может хранить данные справочника в одном или нескольких наборах серверных файлов (Локальные Тома), а также может использовать внешние LDAP сервера как Удалённые Тома Справочника. Возможно множество различных конфигураций. Следующая простейшая конфигурация является наиболее распространённой:</p><ul><li>Все данные Справочника сохраняются в одном Локальном Томе. В этом случае Мета-Справочник является таким же Справочником, который реализуется при помощи обычного LDAP сервера.</li><li>Все данные Справочника сохраняются в одном Удалённом Томе. В этом случае Мета-Справочник используется просто как метод доступа к записям, хранящимся на внешнем LDAP сервере.</li></ul><h2 id="Brief" tabindex="-1">Что такое Справочник? <a class="header-anchor" href="#Brief" aria-label="Permalink to &quot;Что такое Справочник? {#Brief}&quot;">​</a></h2><ul><li><p><em>атрибут</em></p><p>имя (<em>имя атрибута</em>) и одно или несколько <em>значений атрибута.</em><br> Обычно атрибуты представлены в форме <code>_имя_=_значение_</code>.<br> Имена атрибутов независимы от регистра.</p><p>Примеры:</p><p><code>userName=john</code><br><code>eyeColor=blue</code></p></li><li><p><em>класс объекта</em></p><p>атрибут с именем <code>objectClass</code>; этот атрибут используется для указания природы объекта, которому он принадлежит.</p><p>Примеры:</p><p><code>objectClass=person</code><br><code>objectClass=organization</code></p></li><li><p><em>Полное имя записи</em> (DN).</p><p>последовательность <em>атрибутов</em> в форме <code>_имя_=_значение_</code> и разделённых знаком запятой (<code>,</code>).<br> DNы используются как уникальные имена объектов (записей).</p><p>Пример:</p><p><code>userName=john,server=BigIron,realm=Internet</code></p><p>DNы используются для построения деревьев имён объектов, где самый правый атрибут задаёт самое общее имя, а самый левый атрибут задаёт уникальное имя объекта.</p><p>Самый левый атрибут называется <em>Относительным Полным Именем</em> (RDN) - оно обеспечивает уникальность имени объекта среди всех других объектов, имеющих такой же родительский DN.</p><p>Пример:</p><p><code>userName=jim,server=BigIron,realm=Internet</code></p><p>это другой DN, хотя &quot;родительский DN&quot; точно такой же (<code>server=BigIron,realm=Internet</code>)</p><p>Пример:</p><p><code>userName=john,server=SmallCopper,realm=Internet</code></p><p>это другой DN, с другим &quot;родительским DN&quot; (<code>server=SmallCopper,realm=Internet</code>)</p></li><li><p><em>запись справочника</em> или <em>объект</em></p><p>набор <em>атрибутов</em> с <em>полным именем записи</em><br> Обычно запись представляется в виде нескольких строк, начинающихся с имени, представляющего DN записи, за которым следуют атрибуты записи. Записи обычно разделяются пустой строкой.</p><p>Пример:</p><p><code>DN: userName=jim,server=BigIron,realm=Internet</code><br><code>objectClass=person</code><br><code>eyeColor=blue</code><br><code>mailboxLimit=1024000</code></p><p><code>DN: userName=john,server=BigIron,realm=Internet</code><br><code>objectClass=person</code><br><code>eyeColor=green</code><br><code>mailboxLimit=2048000</code></p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Стандарты LDAP рекомендуют включать атрибут RDN в набор атрибутов, составляющих запись справочника. Менеджер Справочника CommuniGate Pro жёстко следует этому правилу.</p></div><ul><li><p><em>справочник</em></p><p>набор <em>записей справочника</em>; может достигать очень больших размеров (миллионы записей). Через DN набор организуется в виде дерева. При удалении родительского DN записи удаляются автоматически. При изменении (переименовании) родительских DNов записи также автоматически изменяются.</p></li><li><p><em>схема справочника</em></p><p>набор ограничений справочника, включающих в себя:</p><ul><li>набор <em>имён атрибутов</em>, которые могут использоваться в Справочнике (<code>userName, mail, city, eyeColor, ...</code>);</li><li>набор значений атрибута objectClass, которые могут находиться в Справочнике (<code>person, organization, device, printer ...</code>);</li><li>для каждого objectClass - имена атрибутов, которые обязана иметь запись объекта; для записей типа <code>objectClass=person</code> схема может требовать наличия атрибутов с именами <code>cn</code> (Имя-Идентификатор) и <code>sn</code> (фамилия);</li><li>для каждого objectClass - имена атрибутов, которые может иметь запись объекта; для записей типа <code>objectClass=person</code> схема может разрешать атрибуты с именами <code>driverLicense</code> и <code>eyeColor</code>.</li></ul></li></ul><h2 id="Units" tabindex="-1">Тома Хранения Справочника <a class="header-anchor" href="#Units" aria-label="Permalink to &quot;Тома Хранения Справочника {#Units}&quot;">​</a></h2><p>Хотя весь Справочник CommuniGate Pro представляется клиентам как одно большое дерево записей, его поддеревья могут храниться в отдельных <em>томах хранения.</em> Такой тип &quot;виртуальных&quot; справочников часто называют Мета-Справочником.</p><p>Справочник CommuniGate Pro поддерживает два типа томов хранения:</p><ul><li><em>локальные</em> - наборы файлов, управляемые Менеджером Справочника CommuniGate Pro. Эти файлы содержат записи справочника, информацию о дублировании и схемы поддеревьев.</li><li><em>удалённые</em> - дескрипторы, обслуживаемые LDAP Менеджером Справочника CommuniGate Pro. Эти дескрипторы содержат информацию об удалённых Справочниках, доступ к которым осуществляется через LDAP.</li></ul><p>В результате Справочник CommuniGate Pro может иметь поддеревья, расположенные на удалённых серверах. Если LDAP сервер ldap.server.dom обеспечивает доступ к какому-либо дереву справочника, то вы можете создать указывающий на сервер ldap.server.dom удалённый том в Справочнике CommuniGate Pro и, таким образом, полное дерево справочника <code>ldap.server.dom</code> (или одно из его поддеревьев) будет видно в Справочнике CommuniGate Pro как какое-либо поддерево.</p><p>Первоначально сервер CommuniGate Pro создаёт один Локальный Том Хранения <code>Main</code>, в котором содержится весь справочник. Через Веб Интерфейс Администратора вы можете добавлять новый тома хранения.</p><p>На диаграмме ниже показан справочник, которой хранится в одном Локальном Томе с именем <code>Main</code>:</p><p><img src="'+a+'" alt="Дерево1"></p><p>На диаграмме ниже показан тот же справочник, но теперь он хранится в двух Томах Хранения, причём всё поддерево <code>o=MyCompany</code> хранится в отдельном Томе Хранения <code>LDAP1</code>:</p><p><img src="'+n+'" alt="Дерево2"></p><ul><li><p>Пример 1:</p><p>Внешний LDAP сервер <code>ldap1.com</code> имеет поддерево <code>o=MyCompany</code> и вы хотите, чтобы все Домены CommuniGate Pro и записи о Пользователях хранились в этом поддереве. Используйте следующие настройки:</p><ul><li>В настройках <a href="./CentralDir.html">Центрального Справочника</a> укажите Базовый DN как <code>o=MyCompany,o=ldap1</code></li><li>Создайте Удалённый Том MYLDAP для поддерева <code>o=ldap1</code>.</li><li>Введите <code>ldap1.com</code> как имя сервера и введите в Настройках Тома MYLDAP в значении Поддерево на Сервере пустую строку.</li></ul><p>Теперь, когда Сервер CommuniGate Pro попытается получить доступ к записи справочника для пользователя <code>john</code> в домене <code>domain1.com</code>:</p><ul><li>Формируется DN <code>uid=john,cn=domain1.com,o=MyCompany,o=ldap1</code>.</li><li>Менеджер Справочника определяет, что эта запись должна располагаться в Томе MYLDAP и просит этот Том выполнить требуемую операцию с записью, имеющей DN <code>uid=john,cn=domain1.com,o=MyCompany</code> (при этом &quot;связывающий узел&quot; Тома <code>o=ldap1</code> удаляется из DN).</li><li>Том MYLDAP отправляет запрос с DN <code>uid=john,cn=domain1.com,o=MyCompany</code> на удалённый сервер <code>ldap1.com</code>.</li></ul></li><li><p>Пример 2:</p><p>Внешний LDAP сервер <code>ldap1.com</code> имеет поддерево <code>o=MyCompany</code> и вы хотите, чтобы все Домены CommuniGate Pro и записи о Пользователях хранились в этом поддереве (точно также, как и в Примере 1). Используйте следующие настройки:</p><ul><li>В настройках <a href="./CentralDir.html">Центрального Справочника</a> укажите Базовый DN как <code>o=ldap1</code></li><li>Создайте Удалённый Том MYLDAP для поддерева <code>o=ldap1</code>.</li><li>Введите <code>ldap1.com</code> как имя сервера и введите в Настройках Тома MYLDAP в значении Поддерево на Сервере <code>o=MyCompany</code>.</li></ul><p>Теперь, когда Сервер CommuniGate Pro попытается получить доступ к записи справочника для пользователя <code>john</code> в домене <code>domain1.com</code>:</p><ul><li>Формируется DN <code>uid=john,cn=domain1.com,o=ldap1</code>.</li><li>Менеджер Справочника определяет, что эта запись должна располагаться в Томе MYLDAP и просит этот Том выполнить требуемую операцию с записью, имеющей DN <code>uid=john,cn=domain1.com</code> (при этом &quot;связывающий узел&quot; Тома <code>o=ldap1</code> удаляется из DN).</li><li>Том MYLDAP добавляет к DN указанный суффикс Поддерева на Сервере <code>o=MyCompany</code> и затем отправляет запрос с таким DN <code>uid=john,cn=domain1.com,o=MyCompany</code> на удалённый сервер <code>ldap1.com</code>.</li></ul></li></ul><p>Откройте Веб Интерфейс Администратора Сервера CommuniGate Pro и перейдите по ссылке Справочник. Откроются страницы (раздел) с Томами Хранения Справочника. Для открытия этих страниц вам необходимо иметь Права Доступа к Справочнику.</p>',22),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("thead",null,[e("tr",null,[e("td",null,[e("input",{name:"Apply",value:"Показывать",class:"button",type:"reset"}),o(" Фильтр: "),e("input",{name:"Filter",size:"30",maxlength:"50",value:"",type:"text"})]),e("td",{align:"right"},[e("i",null,"Показано 2 из 2")])])]),e("tbody",null,[e("tr",null,[e("th",{align:"left",nowrap:"nowrap"},"Имя Тома"),e("th",{align:"left",nowrap:"nowrap"},"Поддерево")]),e("tr",null,[e("td",null,[e("a",{href:"#Local"},"Main")]),e("td",null,[e("a",{href:"#Local"},"<root>")])]),e("tr",null,[e("td",null,[e("a",{href:"#Remote"},"node6")]),e("td",null,[e("a",{href:"#Remote"},"o=node6")])])])])])],-1),e("p",null,[o("Строка "),e("code",null,"<root>"),o(" используется для указания имени Тома Хранения по умолчанию (то есть Тома Хранения, хранящего корень Дерева Справочника).")],-1),e("p",null,"Для того, чтобы создать новый Том Хранения, введите его имя (это имя будет использоваться только для целей администрирования), Полное Имя (DN) для поддерева, которое должно хранится в этом томе и нажмите на кнопку Создать Локальный Том или Создать Удалённый Том.",-1),e("h2",{id:"Local",tabindex:"-1"},[o("Локальные Тома "),e("a",{class:"header-anchor",href:"#Local","aria-label":'Permalink to "Локальные Тома {#Local}"'},"​")],-1),e("p",null,"Локальные Тома Справочника - это наборы файлов, содержащие данные справочника (записи/пункты), схему тома, установки тома и журнал изменений справочника.",-1),e("p",null,"Откройте через Веб Интерфейс Администратора область Справочник и нажмите на ссылку с именем Локального Тома Хранения. Откроется страница с Установками Тома.",-1),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Установки")])]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Поддерево:"),e("td",{colspan:"2"})]),e("tr",null,[e("td",{colspan:"2",align:"right",nowrap:"nowrap"},"Уровень Журнала:"),e("td",{colspan:"2"},[e("select",{name:"LogLevel"},[e("option",{value:"0"},"Катастрофы"),e("option",{value:"1"},"Сбои"),e("option",{value:"2",selected:"selected"},"Основное"),e("option",{value:"3"},"Проблемы"),e("option",{value:"4"},"Подробности"),e("option",{value:"5"},"Всё")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},[e("input",{name:"EnforceSchema",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,"Проверять Схему"),e("td",{align:"right",nowrap:"nowrap"},"Ограничение Результатов Поиска:"),e("td",null,[e("select",{name:"MaxRecordLimit"},[e("option",{value:"10"},"10"),e("option",{value:"30",selected:"selected"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000"),e("option",null,"другое")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},[e("input",{name:"ComposeDisplayName",value:"1",checked:"checked",type:"checkbox"})]),e("td",null,"Создавать 'displayName' атрибут"),e("td",{colspan:"2"}," ")])])])])],-1),t('<ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку, чтобы указать, какую информацию Менеджер Локальных Томов Хранения должен сохранять в Журнале работы Сервера.</p></li><li><p><code>Проверять Схему</code></p><p>Когда выбрана эта опция, Менеджер Локального Тома Хранения сравнивает структуру всех новых и изменяемых записей со Схемой Тома. Если эта опция выключена, то Менеджер смотрит только имена атрибутов записей и проверяет, что эти атрибуты включены в схему Тома, но не проверяет ограничения для objectClass.</p></li><li><p><code>Ограничение Результатов Поиска</code></p><p>Эта настройка ограничивает максимальное число записей, которое может возвращать операция Поиска в Справочнике.</p></li><li><p><code>Создавать &#39;displayName&#39; атрибут</code></p><p>Если указана эта опция, то Менеджер Локального Тома Хранения проверяет, был ли атрибут <code>displayName</code> явно затребован в операции поиска, но при этом сам этот атрибут отсутствует в полученной записи Справочника. В этом случае Менеджер создаёт атрибут <code>displayName</code> на лету, используя атрибут <code>cn</code> или, если он отсутствует, атрибут <code>uid</code>.</p></li></ul><p>Каждый Локальный Том имеет свою собственную Схему. Дополнительную информацию о Схемах Тома смотрите в разделе <a href="./Schema.html">Схема</a>.</p><p>Вы можете просматривать и изменять Схему Локального Тома запрашивая и изменяя виртуальную запись с DN <code>cn=schema</code>. Если Локальный Том смонтирован на каком-либо поддереве Справочника, то DN записи для Схемы Тома будет <code>cn=schema,_поддерево_</code>.</p><h2 id="Remote" tabindex="-1">Удалённые Тома <a class="header-anchor" href="#Remote" aria-label="Permalink to &quot;Удалённые Тома {#Remote}&quot;">​</a></h2><p>Откройте Веб Интерфейс Администратора и в разделе Справочник нажмите на ссылке с именем Удалённого Тома Хранения для того, чтобы открыть страницу с его Установками:</p>',5),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Установки")])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Уровень Журнала:"),e("td",null,[e("select",{name:"Log"},[e("option",{value:"0"},"Катастрофы"),e("option",{value:"1"},"Сбои"),e("option",{value:"2",selected:"selected"},"Основное"),e("option",{value:"3"},"Проблемы"),e("option",{value:"4"},"Подробности"),e("option",{value:"5"},"Всё")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Имя LDAP Сервера:"),e("td",null,[e("input",{type:"text",name:"Server",value:"node6.communigatepro.ru",size:"30",maxlength:"64"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Безопасность:"),e("td",null,[e("select",{name:"TLSMode"},[e("option",{value:"0",selected:"selected"},"Disabled"),e("option",{value:"1"},"TLSPort"),e("option",{value:"2"},"STARTTLS")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Поддерево на Сервере:"),e("td",null,[e("input",{type:"text",name:"BaseObject",value:"",size:"30",maxlength:"256"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Bind DN:"),e("td",null,[e("input",{type:"text",name:"BINDName",value:"cn=admin,o=CommuniGate Systems,c=US",size:"30",maxlength:"100"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Bind Пароль:"),e("td",null,[e("input",{name:"BINDPassword",value:"********",size:"30",maxlength:"64",type:"text"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Фильтр для поиска:"),e("td",null,[e("input",{name:"LDAPFilter",value:"(cn=*.net)",size:"30",maxlength:"1000",type:"text"})])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Версия Протокола:"),e("td",null,[e("select",{name:"LDAPVersion"},[e("option",{value:"2",selected:"selected"},"2"),e("option",{value:"3"},"3")])])]),e("tr",null,[e("td",{align:"right",nowrap:"nowrap"},"Кэш Каналов:"),e("td",null,[e("select",{name:"ChannelCache"},[e("option",{value:"0"},"0"),e("option",{value:"1"},"1"),e("option",{value:"2"},"2"),e("option",{value:"3"},"3"),e("option",{value:"5"},"5"),e("option",{value:"7"},"7"),e("option",{value:"10",selected:"selected"},"10"),e("option",{value:"15"},"15"),e("option",{value:"20"},"20"),e("option",{value:"30"},"30"),e("option",{value:"50"},"50"),e("option",{value:"100"},"100"),e("option",{value:"250"},"250")])])])])])])],-1),t('<ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку, чтобы указать, какую информацию Менеджер Удалённых Томов Хранения должен сохранять в Журнале работы Сервера.</p></li><li><p><code>Имя LDAP Сервера</code></p><p>Это поле указывает имя или IP адрес удалённого LDAP сервера, на котором размещено поддерево Тома Хранения. Если удалённый LDAP сервер использует нестандартный TCP порт, то можно указать Имя Сервера в виде <code>имясервера:порт</code>.</p></li><li><p><code>Безопасность</code></p><p>Если установлена опция TLSPort, то соединения с удалённым сервером будут устанавливаться в безопасном режиме. По умолчанию портом для безопасных соединений является порт номер 636.<br> Если установлена опция STARTTLS, то соединения устанавливаются через обычный порт LDAP, а затем отправляется LDAP команда STARTTLS для инициирования коммуникаций в безопасном (зашифрованном) режиме.</p></li><li><p><code>Поддерево на Сервере</code></p><p>Это поле указывает поддерево на удалённом LDAP сервере, которое должно быть &quot;смонтировано&quot;. Если эта настройка имеет пустое значение, то весь удалённый справочник будет виден как поддерево Справочника CommuniGate Pro.</p></li><li><p><code>Bind DN</code>, <code>Bind Пароль</code></p><p>Это поле задаёт Полное имя записи и Пароль, которые будут использоваться для &quot;привязки&quot; удалённого LDAP сервера (для входа на него). Если это поле оставлено пустым, то CommuniGate Pro будет использовать анонимный доступ к удалённому LDAP серверу.</p></li><li><p><code>Фильтр для поиска</code></p><p>Это поле может содержать строку с фильтром поиска (в формате RFC 2254). Этот фильтр добавляется во все запросы LDAP поиска, которые отправляются на LDAP сервер.</p></li><li><p><code>Версия Протокола</code></p><p>Используйте это поле для указания поддерживаемой удалённым LDAP сервером версии протокола LDAP.</p></li><li><p><code>Кэш Каналов</code></p><p>Используйте это поле для указания числа &quot;кэшируемых&quot; TCP соединений, используемых для соединения с удалённым LDAP сервером.</p></li></ul><h2 id="RemoteRoot" tabindex="-1">Удалённый Справочник как Корневой <a class="header-anchor" href="#RemoteRoot" aria-label="Permalink to &quot;Удалённый Справочник как Корневой {#RemoteRoot}&quot;">​</a></h2><p>В определённых ситуациях сервер CommuniGate Pro не должен хранить никаких данных Справочника в своих Локальных Томах. Вместо этого все записи Справочника должны хранится на удалённом LDAP сервере (каком-нибудь другом сервере CommuniGate Pro или на сервере Справочника стороннего производителя). В этом случае &quot;корень&quot; CommuniGate Pro должен храниться в Удалённом Томе Хранения, указывающем на такой внешний сервер. По умолчанию &quot;корень&quot; Справочника хранится в Локальном Томе Хранения с именем <code>Main</code>.</p><p>Для того чтобы указать Серверу CommuniGate Pro что &quot;корень&quot; Справочника и всё дерево Справочника хранятся на удалённом сервере, выполните следующие действия:</p><ul><li>откройте настройки Тома Хранения <code>Main</code></li><li>переместите Том в фиктивное поддерево <code>o=dummy</code></li><li>создайте Удалённый Том Хранения <code>RemoteRoot</code>, указав в его Поддереве пустую строку</li><li>настройте Удалённый Том <code>RemoteRoot</code> так, чтобы он имел соответствующий доступ на удалённом LDAP сервере</li><li>проверьте, что удалённый справочник доступен (используя Просмотр Справочника CommuniGate Pro)</li><li>откройте установки Тома Хранения <code>Main</code> и нажмите на кнопку Удалить Том</li></ul><h2 id="Binding" tabindex="-1">Привязка к Справочнику <a class="header-anchor" href="#Binding" aria-label="Permalink to &quot;Привязка к Справочнику {#Binding}&quot;">​</a></h2><p>Записи Справочника могут быть защищены (и, обычно, действительно защищены) от неавторизованного доступа. Когда пользователи хотят получить доступ к защищённым данным Справочника, они должны сначала аутентифицироваться. Этот процесс называется <em>привязка</em> и успешная аутентификация &quot;привязывает&quot; (&quot;binds&quot;) пользователя к определённому Полному имени записи (DN) в Справочнике.</p><p>Если пользователь пытается прочитать или изменить данные Справочника, то для проверки <a href="#AccessRights">Прав Доступа</a> к Справочнику используется привязанный DN.</p><p>Когда пользователь использует Справочник через <a href="./../access/WebUser.html">Веб Интерфейс Пользователя</a> CommuniGate Pro или через <a href="./../access/XIMSS.html">XIMSS</a> сессию, то привязанный DN является DNом записи этого Пользователя:<br><code>uid=_accountname_,cn=_domainname_,o=MyCompany</code>.<br> Дополнительную информацию смотрите в разделе <a href="./CentralDir.html">Центральный Справочник</a>.</p><p>Когда доступ к Справочнику осуществляется через модуль <a href="./../services/LDAP.html">LDAP</a>, клиент может аутентифицироваться при помощи своего имени Пользователя и пароля CommuniGate Pro. В этом случае привязанным DN будет DN записи Пользователя.</p><p>До преобразования имени пользователя в DN записи Пользователя Справочника, проверяются <a href="./../sysadmin/#Privs">Права Доступа к Серверу</a> пользователя. Если пользователь имеет право доступа к Справочнику, то используется специальный &quot;мастер&quot; Bind DN вместо DN записи пользователя. Клиенты с &quot;мастер&quot; Bind DN обладают неограниченными правами доступа к Справочнику.</p><p>Для привязки через LDAP может использоваться любой DN Справочника. Запись справочника с указанным DN должна существовать, запись должна содержать атрибут <code>userPassword</code>, и значение атрибута должно соответствовать введённому паролю.</p><p>Если клиент не аутентифицировался, то используется специальный Bind DN <code>anyone</code>.</p><h2 id="AccessRights" tabindex="-1">Записи Прав Доступа <a class="header-anchor" href="#AccessRights" aria-label="Permalink to &quot;Записи Прав Доступа {#AccessRights}&quot;">​</a></h2><p>Справочник CommuniGate Pro ограничивает права клиентов на чтение, поиск и изменение записей Справочника. Справочник содержит набор записей Прав Доступа, которые разрешают и запрещают операции в Справочнике для конкретных поддеревьев Справочника в зависимости от привязанного DN клиента.</p><p>Для задания записей Прав Доступа откройте страницу Права Доступа к Справочнику:</p>',16),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",{align:"left"},[e("th",null," "),e("th",null,"Имя"),e("th",null,"Что"),e("th",null,"Bind DN"),e("th",null,"Тип"),e("th",{colspan:"2"}," ")]),e("tr",{valign:"top"},[e("td"),e("td",null,[e("input",{name:"N0",value:"BrotherWatch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T0",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B0",value:"brother",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R0"},[e("option",{value:"0"},"Запрещено"),e("option",{value:"1",selected:"selected"},"Разрешено")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Изменить")]),e("td",null,[e("input",{name:"D0",value:"Вниз",class:"button",type:"reset"})])]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"U1",value:" Вверх ",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"N1",value:"ChildSearch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T1",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B1",value:"child",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R1"},[e("option",{value:"0"},"Запрещено"),e("option",{value:"1",selected:"selected"},"Разрешено")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Изменить")]),e("td",null,[e("input",{name:"D1",value:"Вниз",class:"button",type:"reset"})])]),e("tr",{valign:"top"},[e("td",null,[e("input",{name:"U2",value:" Вверх ",class:"button",type:"reset"})]),e("td",null,[e("input",{name:"N2",value:"DirSearch",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T2",value:"o=MyCompany",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B2",value:"*",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R2"},[e("option",{value:"0"},"Запрещено"),e("option",{value:"1",selected:"selected"},"Разрешено")])]),e("td",{class:"arrow"},[e("a",{href:"#AccessSpecs"},"Изменить")]),e("td",null," ")]),e("tr",{valign:"top"},[e("td",null," "),e("td",null,[e("input",{name:"N2",value:"",size:"10",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"T2",value:"",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("input",{name:"B2",value:"",size:"15",maxlength:"255",type:"text"})]),e("td",null,[e("select",{name:"R2"},[e("option",{value:"0"},"Запрещено"),e("option",{value:"1",selected:"selected"},"Разрешено")])]),e("td",{class:"arrow"}," "),e("td",null," ")])])])])],-1),t('<p>Каждая запись Права Доступа имеет:</p><ul><li>имя</li><li>что: DN, к которому применяется запись; в строках могут использоваться символы шаблона подстановки (&quot;*&quot;)</li><li>Bind DN: привязанный DN клиента, к которому применяется запись; в строках могут использоваться символы шаблона подстановки (&quot;*&quot;)</li><li>тип: Запрещено или Разрешено</li><li>ссылка на Запись, задающую права доступа</li></ul><p>Кнопки <code>Вниз</code> и <code>Вверх</code> позволяют вам передвигать записи в таблице, увеличивая или уменьшая приоритеты записей.</p><p>Когда клиент требует выполнения операции поиска, чтения, изменения или любой другой операции с записью Справочника или с поддеревом, имеющими определённый DN, Права Доступа проверяются, начиная с верхней записи. Сервер ищет запись Прав Доступа, которая:</p><ul><li>имеет в поле &quot;Что&quot; DN, совпадающий с DN, указанным в запросе клиента</li><li>имеет в поле Bind DN значение, совпадающее с привязанным DN клиента</li><li>имеет операцию (удалять, создавать), совпадающую с затребованной операций или имеющую атрибут, совпадающий с атрибутом, используемым в операции</li></ul><p>При обнаружении такой записи Права Доступа тип записи указывает, разрешена операция или запрещена. Если не найдено никакой записи Права Доступа, операция считается запрещённой.</p><p>Если клиент имеет &quot;мастер&quot; привязанный DN (смотрите выше), то ему разрешены все операции.</p><p>Когда клиент требует совершения операции типа &quot;чтение&quot;, то процедура повторяется для всех атрибутов, которые клиент хочет получить. Если операция запрещена для всех указанных атрибутов, то операция чтения заканчивается неуспешно. В противном случае операция выполняется и клиенту возвращаются все атрибуты, которые он имеет право получать.</p><p>Когда клиент требует совершения операции типа &quot;поиск&quot;, то процедура повторяется для всех атрибутов, используемых в фильтре поиска. Если операция поиска запрещена хотя бы для одного из этих атрибутов, то она заканчивается неуспешно. У найденных записей проверяется RDN. Если RDN не разрешён для чтения, то запись не возвращается клиенту.</p><p>Если клиент требует совершения операции типа &quot;переименование&quot;, то процедура используется дважды: первый раз для проверки того, что клиент имеет право удалить оригинальную запись Справочника и второй раз, чтобы убедится, что клиент имеет право создать запись Справочника в новом месте.</p><p>В поле Bind DN могут использоваться специальные строки:</p><ul><li><p><code>anyone</code></p><p>запись Права Доступа применяется для любого Bind DN, включая <code>anyone</code> (отсутствующий) Bind DN.</p></li><li><p><code>brother</code></p><p>запись Права Доступа применяется, если Bind DN и целевой DN имеют общий родительский DN. Например, DNы <code>uid=someuser,cn=domain1.com</code> и <code>uid=otheruser,cn=domain1.com</code> являются &quot;братьями&quot; (brother). Такой способ задания Bind DN целесообразно предоставлять тем пользователям CommuniGate Pro, которые получают доступ к записям Справочника о других пользователях, находящихся в этом же домене CommuniGate Pro.</p></li><li><p><code>parent</code></p><p>запись Права Доступа применяется, если целевой DN является родительским для Bind DN. Например, DN <code>cn=domain1.com</code> является отцом для DNов <code>uid=user1,cn=domain1.com</code> и <code>id=book1,uid=user1,cn=domain1.com</code>.</p></li><li><p><code>child</code></p><p>запись Права Доступа применяется, если целевой DN является родительским для Bind DN.</p></li><li><p><code>self</code></p><p>запись Права Доступа применяется, если целевой DN совпадает с Bind DN. Такой способ задания Bind DN целесообразно предоставлять тем Пользователям CommuniGate Pro, которые имеют право изменять значения атрибутов у своих собственных записей справочника.</p></li></ul><p>Для того, чтобы создать запись Права Доступа, введите имя записи, целевой DN (поле Что) и Bind DN в последнем пустом элементе в Таблице Прав Доступа и нажмите на кнопку Модифицировать. Используйте кнопку <code>Вверх</code> для изменения приоритета записи.</p><p>Для того, чтобы удалить запись Права Доступа, сотрите её имя и нажмите на кнопку Модифицировать.</p><p>В среде <a href="./../cluster/Dynamic.html">Динамического Кластера</a> поддерживаются Общекластерные Права Доступа к Справочникам. Эти права доступа могут быть заданы на любом члене кластера и передаются всем членам кластера.<br> Общекластерные Права Доступа применяются после общесерверных Прав Доступа.<br> Для задания Общекластерных Прав Доступа к Справочнику откройте страницу Права Доступа и нажмите на ссылку Общие для кластера.</p><h2 id="AccessSpecs" tabindex="-1">Задание Прав Доступа <a class="header-anchor" href="#AccessSpecs" aria-label="Permalink to &quot;Задание Прав Доступа {#AccessSpecs}&quot;">​</a></h2><p>Для задания Прав Доступа к Справочнику откройте страницу Права Доступа и нажмите на ссылку &quot;Изменить&quot; (откроется запись Права Доступа):</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Права уровня Записи</b></td></tr><tr align="center"><td>Запрещено <input name="delete" value="1" type="checkbox"> Удаление Записей</td><td>Запрещено <input name="create" value="1" type="checkbox"> Создание Записей</td></tr></tbody></table></div></form><p>Эти опции определяют, могут ли клиенты с заданным Bind DN создавать или удалять записи с заданным целевым DN.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Чтение Атрибутов</b></td></tr><tr align="center"><td>Запрещено: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>В этом поле перечисляются те атрибуты данных, которые клиенты с заданным Bind DN могут читать из записей с заданным целевым DN. Имена атрибутов должны отделяться символом запятой. Для того, чтобы позволить клиентам читать все атрибуты записи, используйте символ звёздочка (<code>*</code>).</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Поиск по Атрибутам</b></td></tr><tr align="center"><td>Запрещено: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>В этом поле перечисляются атрибуты, которые клиенты с заданным Bind DN могут использовать в фильтрах при поиске в поддеревьях Целевого DN.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Изменение Атрибутов</b></td></tr><tr align="center"><td>Запрещено: <textarea name="Readable" rows="4" cols="60" wrap="yes">*</textarea></td></tr></tbody></table></div></form><p>В этом поле перечисляются те атрибуты данных, которые клиенты с заданным Bind DN могут изменять в записях с заданным целевым DN.</p><p>Пример записи Права Доступа:</p><ul><li><p>Что</p><p><code>uid=*,cn=domain1.com</code></p></li><li><p>Bind DN</p><p><code>brother</code></p></li><li><p>Тип</p><p><code>Разрешено</code></p></li><li><p>Атрибуты для чтения</p><p><code>objectClass,officeEmail,roomNumber,cn,uid</code></p></li></ul><p>Эта запись разрешает всем пользователям из домена <code>domain1.com</code> читать атрибуты <code>objectClass</code>, <code>cn</code>, <code>uid</code>, <code>officeEmail</code> и <code>roomNumber</code> из записей Справочника других пользователей Домена <code>domain1.com</code>.</p><p>Пример записи Права Доступа:</p><ul><li><p>Что</p><p><code>cn=domain1.com</code></p></li><li><p>Bind DN</p><p><code>child</code></p></li><li><p>Тип</p><p><code>Разрешено</code></p></li><li><p>Атрибуты для чтения</p><p><code>objectClass,officeEmail,roomNumber</code></p></li><li><p>Атрибуты для поиска</p><p><code>cn,uid</code></p></li></ul><p>Эта запись позволяет всем пользователям из домена <code>domain1.com</code> искать в поддереве Справочника этого Домена по атрибутам <code>cn</code> и <code>uid</code>, но не по другим доступным атрибутам.</p><h2 id="Browser" tabindex="-1">Просмотр Справочника <a class="header-anchor" href="#Browser" aria-label="Permalink to &quot;Просмотр Справочника {#Browser}&quot;">​</a></h2><p>Веб Интерфейс Администратора CommuniGate Pro содержит средства для просмотра Справочника. Для того, чтобы открыть страницу Просмотра Справочника, откройте раздел Справочник и нажмите на ссылку Просмотр.</p><p>Страница Просмотра включает следующие поля DN:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Полное имя записи (DN)</b></td></tr><tr><td><input name="Up" value="Вверх" class="button" type="reset"></td><td><input name="NewBaseDN" value="o=SBK,c=RU" size="60" maxlength="200" type="text"></td><td><input name="Display" value="Перейти" class="button" type="reset"></td></tr></tbody></table></div></form><p>Используя это поле, введите тот DN записи/поддерева Справочника, который вы хотите видеть и нажмите на кнопку <code>Перейти</code>. Нажмите на кнопку <code>Вверх</code> для удаления самого левого элемента DN и открытия его &quot;родительской&quot; записи Справочника.</p><p>На следующей панели отображаются записи Справочника с указанным DN:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr align="left"><th>Атрибут</th><th>Значение</th></tr><tr><td>businesscategory</td><td>&quot;Software development/technical support&quot;</td></tr><tr><td>description</td><td>&quot;\\&quot;SBK subsidiary\\&quot;&quot;</td></tr><tr><td>o</td><td>&quot;SBK&quot;</td></tr><tr><td>objectclass</td><td>organization</td></tr><tr><td>seealso</td><td>&quot;o=SBK, c=RU&quot;</td></tr><tr><td>telephonenumber</td><td>676-555-1212</td></tr></tbody></table></div></form><p>Если запись с указанным DN не может быть прочитана, то в этой панели будет содержаться сообщение об ошибке.</p><p>На следующей панели отображаются все дочерние записи.</p>',40),e("form",{action:"Null.html"},[e("div",{class:"settingsBox"},[e("table",{width:"100%"},[e("tbody",null,[e("tr",null,[e("td",{class:"settingBoxCaption",colspan:"2"},[e("b",null,"Поддерево")])])]),e("thead",null,[e("tr",null,[e("td",{colspan:"2",nowrap:"nowrap"},[e("input",{name:"Display",value:"Показывать",class:"button",type:"reset"}),o(),e("select",{name:"Limit"},[e("option",{value:"10"},"10"),e("option",{value:"30"},"30"),e("option",{value:"100"},"100"),e("option",{value:"300",selected:"selected"},"300"),e("option",{value:"1000"},"1000"),e("option",{value:"3000"},"3000"),e("option",{value:"10000"},"10000"),e("option",{value:"30000"},"30000"),e("option",{value:"100000"},"100000"),e("option",{value:"300000"},"300000"),e("option",{value:"1000000"},"1000000")]),o(" Фильтр: "),e("input",{name:"Filter",value:"",size:"20",maxlength:"200",type:"text"})])])]),e("tbody",null,[e("tr",{align:"left"},[e("th",null,"RDN"),e("th",null,"objectClass")]),e("tr",null,[e("td",null,[e("a",{href:"#Browser"},"cn=aaa.dom")]),e("td",null,"(top,organization,CommuniGateDomain)")]),e("tr",null,[e("td",null,[e("a",{href:"#Browser"},"cn=bbb.dom")]),e("td",null,"(top,organization,CommuniGateDomain)")])])])])],-1),t('<p>Чтобы ограничить число показываемых записей, вы можете использовать меню, находящееся на панели.</p><p>Для поиска указанных записей, введите в поле Фильтр LDAP строку-фильтр (в формате RFC 2254) и нажмите на кнопку Показывать.</p><p>Элементы таблицы являются дочерними RDN и objectClass.</p><p>Нажмите на ссылку с именем дочернего элемента RDN для того, чтобы просмотреть эту запись.</p><h2 id="Import" tabindex="-1">Импорт Данных Справочника <a class="header-anchor" href="#Import" aria-label="Permalink to &quot;Импорт Данных Справочника {#Import}&quot;">​</a></h2><p>Веб Интерфейс Администратора CommuniGate Pro позволяет Администратору Сервера импортировать из текстовых файлов в форматах LDIF и &quot;replog&quot; изменения в Справочник:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="center" width="20%"><input name="BatchLDIF" value="Импортировать LDIF" class="button" type="reset"></td><td align="center" width="20%"><input name="BatchLMOD" value="Импортировать LMOD" class="button" type="reset"></td><td colspan="2"><input name="Import" type="file"></td></tr></tbody></table></div></form><p>Для импорта данных в Справочник CommuniGate Pro нажмите на кнопку Обзор (Browse) и введите имя LDIF файла, находящегося на вашем компьютере. Нажмите на кнопку Импортировать LDIF, чтобы вставить все записи из выбранного LDIF файла.</p><p>Для того, чтобы применить к Справочнику CommuniGate Pro набор изменений записей, нажмите на кнопку Обзор (Browse) и выберите &quot;replog&quot;, находящийся на вашем компьютере. Нажмите на кнопку Импортировать LMOD, чтобы применить все изменения из выбранного файла.</p><h2 id="Cluster" tabindex="-1">Общекластерные Тома Хранения Справочника <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Общекластерные Тома Хранения Справочника {#Cluster}&quot;">​</a></h2><p>В среде <a href="./../cluster/Dynamic.html">Динамического Кластера</a> поддерживаются Общекластерные Тома Хранения Справочника. Эти тома доступны на всех членах кластера.</p><p>Когда настройки Общекластерного Тома Хранения изменяются на любом члене кластера, новые настройки автоматически становятся доступны на других членах кластера.</p><p>Когда Общекластерный Удалённый Том Хранения используется на любом члене кластера, исходящее соединение LDAP организовывается прямо на этом члене кластера. Необходимые задачи синхронизации выполняются удалённым сервером LDAP.</p><p>Когда Общекластерный Локальный Том Хранения используется Контроллером Кластера, запрос выполняется локально. Когда Общекластерный Локальный Том Хранения используется на члене Кластера ином, нежели Контроллер, запрос перенаправляется на текущий Контроллер Кластера, используя протокол LDAP (таким же образом, как для Удалённых Томов Хранения на внешних серверах LDAP).</p><p>Файлы данных Общекластерных Томов Хранения (настройки и, возможно, данные) хранятся внутри директории <a href="./../cluster/Dynamic.html">SharedDomains</a>. При остановке текущего Контроллера кластера, когда Запасной Контроллер Кластера принимает роль Контроллера, он перемонтирует Общекластерные Тома Хранения и работает с ними, как с обычными Локальными томами, тогда как другие члены кластера направляют запросы для работы с этими Томами на текущий Контроллер Кластера.</p><p>Для создания Общекластерного Тома Хранения, отметьте флажок Общекластерный (доступен только в среде Динамического Кластера).</p>',16)]))}const P=i(c,[["render",r]]);export{v as __pageData,P as default};
