import{_ as o,c as t,o as i,ag as a}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Модуль PIPE","description":"","frontmatter":{"legacyLink":"russian/PIPE.html"},"headers":[],"relativePath":"russian/admin/mail/PIPE.md","filePath":"russian/admin/mail/PIPE.md"}'),p={name:"russian/admin/mail/PIPE.md"};function d(n,e,c,l,u,s){return i(),t("div",null,e[0]||(e[0]=[a(`<h1 id="модуль-pipe" tabindex="-1">Модуль PIPE <a class="header-anchor" href="#модуль-pipe" aria-label="Permalink to &quot;Модуль PIPE&quot;">​</a></h1><p>Модуль PIPE позволяет внешним приложениям, запущенным на компьютере Сервера, передавать сообщения на Сервер CommuniGate Pro минуя TCP/IP соединения и Интернет протоколы, а также позволяет Серверу доставлять сообщения внешним приложениям.</p><p>Модуль PIPE используется также при передаче сообщений, созданных программами <code>mail</code> и <code>sendmail</code>, которые входят в комплект с программного обеспечения сервера CommuniGate Pro. Эти программы предназначены для замены существующих программ <code>mail</code> и <code>sendmail</code>.</p><h2 id="Submitted" tabindex="-1">Папка Submitted <a class="header-anchor" href="#Submitted" aria-label="Permalink to &quot;Папка Submitted {#Submitted}&quot;">​</a></h2><p>Модуль PIPE CommuniGate Pro создаёт папку <code>Submitted</code> внутри <em>директории данных</em> CommuniGate Pro.</p><p>Модуль PIPE периодически сканирует эту папку и обрабатывает файлы, имеющие расширение <code>.sub</code>. При обнаружении такого файла, модуль копирует его в файл <em>очереди сообщений</em> и передаёт его ядру сервера на обработку.</p><p>Текстовые файлы <code>.sub</code> должны содержать сообщения в формате RFC822. Модуль использует данные их полей заголовков RFC822 для создания конверта сообщения.</p><ul><li>&quot;Формат канала&quot;, как он описан в RFC822, НЕ должен использоваться: переданные файлы должны использовать родной для системы символ(ы) &quot;Конца строки&quot;, символ точка (.) в начале строки не должен удваиваться и файл не должен заканчиваться символом точка (.).</li><li>Адреса, указанные в полях заголовков <code>To:</code>, <code>Cc:</code>, <code>Bcc:</code> используются для создания конверта сообщения (адреса получателей).</li><li>Поля заголовка <code>Bcc:</code> удаляются из передаваемого сообщения.</li><li>Если обнаружено хотя бы одно поле заголовка <code>Envelope-To:</code>, адреса в конверте (получателя) формируются с использованием адресов, указанных в этих полях заголовка, а адреса во всех <strong>оставшихся</strong> заголовках To, Cc, и Bcc не помещаются в конверт сообщения. Поля заголовка <code>Envelope-To:</code> удаляются из передаваемого сообщения.</li><li>Если не существует ни одного поля заголовка <code>Envelope-To:</code>, но существует одно или несколько полей <code>Envelope-Ignore</code>, то адреса, указанные в полях заголовка To/Cc/Bcc и перечисленные в полях Envelope-Ignore НЕ включаются в конверт сообщения.</li><li>Если поля заголовка <code>Sender:</code> и/или <code>From:</code> содержат адреса без доменной части, то к ним добавляется имя домена Сервера.</li><li>Если существует поле заголовка <code>Return-Path:</code>, то адрес, указанный в этом заголовке используется как Return-Path адрес конверта, и это поле заголовка удаляется из переданного сообщения.</li><li>Если поле заголовка <code>Return-Path:</code> не существует, то адрес, указанный в полях заголовка <code>From:</code> или <code>Sender:</code> используется для формирования Return-Path адреса конверта.</li><li>Если поле заголовка <code>Envelope-ID:</code> существует, то его содержимое используется как идентификатор конверта сообщения. Это поле заголовка будет удалено из передаваемого сообщения.</li><li>Если поле заголовка <code>Envelope-Notify:</code> существует, то в нём должно содержаться одно или несколько ключевых слов <code>SUCCESS</code>, <code>FAILURE</code>, <code>DELAY</code>, <code>RELAY</code>, разделённых запятой, или же в нём должно содержаться одно ключевое слово <code>NEVER</code>.<br> Это поле заголовка указывает параметры DSN, которые будут применяться ко всем адресам в конверте, сформированным после обнаружения этого поля. Это поле заголовка будет удалено из передаваемого сообщения.<br> Для указания различных параметров DSN для разных адресов могут использоваться несколько полей заголовков <code>Envelope-Notify:</code>.</li></ul><p>Если обработка <code>.sub</code> файла заканчивается неудачно (например, в файле не содержится адреса получателя), то модуль помещает соответствующую запись в Системный Журнал и меняет расширение файла на <code>.bad</code>.</p><p>Если .sub файл передан успешно, то он удаляется из папки Submitted.</p><p>Из-за специфики обработки PIPE модулем папки Submitted, рекомендуется создавать сообщения в другой файловой директории и затем перемещать созданные .sub файлы в папку Submitted с расширением <code>.tmp</code>, а затем менять расширение файла на <code>.sub</code>.</p><p>Сообщения, переданные через PIPE модуль, отмечаются как &quot;полученные из доверенного источника&quot; и в дальнейшем могут ретранслироваться без ограничений.</p><p>Папка Submitted используется для <a href="./../misc/Mail.html#LegacyMail">Эмуляции Стандартного приложения mail</a>.</p><h2 id="Delivery" tabindex="-1">Доставка во Внешние Приложения <a class="header-anchor" href="#Delivery" aria-label="Permalink to &quot;Доставка во Внешние Приложения {#Delivery}&quot;">​</a></h2><p>Модуль PIPE принимает все сообщения, направляемые в домен <code>pipe</code>.</p><p>Локальная часть адреса сообщения задаёт внешнее приложение, которое должно быть запущено. Эта часть может так же содержать параметры, заключённые в кавычки.</p><ul><li><p>Пример:</p><p>Сообщение, направленное на адрес <code>&quot;execjoe -l store&quot;@pipe</code> будет отправлено приложению <code>execjoe</code>, запущенному с параметрами <code>-l store</code>. Обычно вы используете PIPE доставку в <a href="./../sysadmin/Router.html">Маршрутизаторе</a>:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@somedomain&gt; = exec*@pipe</span></span></code></pre></div><p>эта запись в Маршрутизаторе направит все сообщения, отправленные на адрес <code>joe@somedomain</code> в приложение <code>execjoe</code>.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@somedomain&gt; = &quot;execall\\ -u\\ *&quot;@pipe</span></span></code></pre></div><p>эта запись в Маршрутизаторе направит все сообщения, посланные на адрес <code>joe@somedomain</code> в приложение <code>execall</code>, запущенное с параметрами <code>-u joe</code>.</p><p>Для того, чтобы ограничить набор приложений, которые могут запускаться через PIPE модуль, в настройках модуля PIPE задаётся <em>каталог для внешних программ</em>. Имена приложений, указанные в адресах сообщения не могут включать в себя символ косой черты (<code>/</code>) или символы обратной косой черты (<code>\\</code>), не могут начинаться с символа точка (<code>.</code>) и должны указывать на имя исполняемого файла, находящегося в <em>каталоге для внешних программ</em>.</p><p>Текст сообщения (включая заголовки и тело сообщения) передаётся внешней программе на её <em>стандартный ввод</em>.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Программа должна считывать все данные потока <em>стандартного ввода</em>, в противном случае обработка сообщения закончится неуспешно.</p></div><p>Когда внешнее приложение завершает свою работу, PIPE модуль читает и выкидывает её <em>стандартный вывод</em>. Убедитесь, что ваша программа ничего не записывает в <em>стандартный вывод</em>, чтобы её работа не блокировалась в случае, когда буфер коммуникационного канала (pipe) между сервером и программой переполнен.</p><p>Когда внешнее приложение завершает свою работу, PIPE модуль читает <em>стандартный вывод ошибок</em> внешнего приложения. Если он не пустой, то доставка сообщения заканчивается неуспешно, и текст, записанный в <em>стандартном выводе ошибок</em> отправляется как сообщение об ошибке отправителю сообщения.</p><h3 id="Serial" tabindex="-1">Последовательная доставка <a class="header-anchor" href="#Serial" aria-label="Permalink to &quot;Последовательная доставка {#Serial}&quot;">​</a></h3><p>Чтобы позволить PIPE процессорам доставлять сообщения одновременно, PIPE модуль создаёт отдельные очереди для каждого сообщения, которое он должен доставить. Если вы хотите использовать последовательную доставку, вы можете использовать следующий вид PIPE адреса:<br><code>&quot;queue[name] application parameters&quot;@pipe</code><br> Все сообщения, направляемые на такие адреса, будут помещаться в очередь <em>name</em> и сообщения в очереди будут отправляться внешним приложениям, указанным в адресах, одним PIPE процессором. Вы можете использовать любую алфавитно-цифровую строку как имя <em>name</em> для очереди, и вы можете указывать столько очередей, сколько вам необходимо.</p><p>Следующие записи в <a href="./../sysadmin/Router.html">Маршрутизаторе</a>: могут использоваться для обслуживания двух PIPE очередей (очереди PROC1 и ARCH):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;incoming&gt; = &quot;queue[PROC1] procin -mark&quot;@pipe</span></span>
<span class="line"><span>&lt;control&gt;  = &quot;queue[PROC1] procin1 -control&quot;@pipe</span></span>
<span class="line"><span>&lt;archiver&gt; = &quot;queue[ARCH] appendfile /var/archive&quot;@pipe</span></span></code></pre></div><p>Все сообщения, отправленные на адреса <a href="mailto:incoming@maindomain.com" target="_blank" rel="noreferrer">incoming@maindomain.com</a> и <a href="mailto:control@maindomain.com" target="_blank" rel="noreferrer">control@maindomain.com</a> будут обрабатываться одно за одним, используя один PIPE процессор.</p><p>Для PIPE адресов, не имеющих префикса <code>queue[name]</code>, PIPE модуль создаст отдельные очереди с цифровыми именами.</p><h3 id="Tags" tabindex="-1">Теги Команд <a class="header-anchor" href="#Tags" aria-label="Permalink to &quot;Теги Команд {#Tags}&quot;">​</a></h3><p>Текст сообщения (заголовок и тело) отправляется на <em>стандартный ввод</em> (stdin) задачи.</p><p>Имя программы может иметь в качестве префикса тег <code>[FILE]</code>:<br><code>[FILE] application parameters</code><br> При использовании этого префикса стандартный ввод программы будет пустым (закрыт), или будет содержать только поля заголовка сообщения, добавленные в Правилах. Строка -f Queue/<em>field</em>.msg (флаг -f и имя файла Сообщения, относительно к <em>директории данных</em>) будут добавлены в конец параметров программы:<br> -f Queue/12002345.msg</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Начало файла Очереди содержит сервисную информацию (конверт, опции и т.д.). Программа должна игнорировать эту информацию, пропустив все данные файла до первой пустой строки. Само сообщение начинается после первой пустой строки в файле Очереди.</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Поля заголовков, добавляемые к сообщению Общими для Сервера и Общими для Кластера <a href="./QueueRules.html">Правилами</a>, не хранятся в файле Очереди, а отправляются задаче через <em>стандартный ввод</em> задачи.</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Этот префикс не должен использоваться на платформе MS Windows, так как Сервер держит файл сообщения открытым, что делает невозможным для внешних Задач чтение из него.</p></div><p>Имя программы может иметь в качестве префикса тег <code>[RETPATH]</code>:<br><code>[RETPATH] application parameters</code><br> При указании этого префикса, строка &quot;-p&quot;, за которой следует адрес return-path сообщения, добавляется в конец параметров программы:<br> -p <a href="mailto:address@domain.com" target="_blank" rel="noreferrer">address@domain.com</a></p><p>Имя программы может иметь в качестве префикса тег <code>[RCPT]</code>:<br><code>[RCPT]application parameters</code><br> При указании этого префикса, строка &quot;-r&quot;, за которой следует оригинальный адрес получателя сообщения, добавляется в конец параметров программы:<br> -r <a href="mailto:address1@domain1.com" target="_blank" rel="noreferrer">address1@domain1.com</a></p><p>Имя программы может иметь в качестве префикса тег <code>[STDERR]</code> (смотрите ниже).</p><p>Имя программы может иметь несколько префиксов, и они могут быть указаны в любом порядке. Если указано несколько префиксов <code>[FILE]</code>, <code>[RETPATH]</code> и <code>[RCPT]</code>, то сначала добавляется флаг <code>-f</code> и его параметры, затем флаг <code>-p</code> и его параметры, а затем флаг <code>-r</code> и его параметры.</p><p>Если был указан префикс <code>[STDERR]</code> и внешнее приложение завершило отправку некоторых данных в свой канал <em>стандартного вывода ошибок</em>, то данные из <em>стандартного вывода ошибок</em> используются для формирования текста сообщения об ошибке.</p><h2 id="Configure" tabindex="-1">Настройка модуля PIPE <a class="header-anchor" href="#Configure" aria-label="Permalink to &quot;Настройка модуля PIPE {#Configure}&quot;">​</a></h2><p>Для того, чтобы настроить параметры PIPE модуля, используйте Веб Интерфейс Администратора. Откройте страницу Почта в области Установки, затем откройте страницу PIPE.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Обработка</b></td></tr><tr><td>Уровень Журнала: <select name="LogLevel"><option value="0">Катастрофы</option><option value="1">Сбои</option><option value="2">Основное</option><option value="3" selected="selected">Проблемы</option><option value="4">Подробности</option><option value="5">Всё</option></select></td><td align="right">Процессоры: <select name="MaxChannels"><option value="0">0</option><option value="1">1</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="11">другое</option></select></td></tr><tr><td colspan="2"><hr></td></tr><tr><td align="right">Каталог с Программами:</td><td><input type="text" name="AppDirectory" value="" size="25" maxlength="255"></td></tr><tr><td align="right">Ограничение Времени Обработки:</td><td><select name="ExecTimeOut"><option value="1">1 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="30">30 сек</option><option value="60">минута</option><option value="120" selected="selected">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1800">30 мин</option><option value="3600">час</option><option value="7200">2 час.</option><option value="10800">3 час.</option><option value="21600">6 час.</option><option value="43200">12 час.</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку для того, что бы указать, какую информацию модуль PIPE должен сохранять в Журнале работы Сервера. Обычно используется уровень <code>Основное</code> (отчёты о передаче сообщений) или уровень <code>Проблемы</code> (передача сообщений и не фатальные ошибки). В случае, если в работе модуля PIPE возникают проблемы, возможно, целесообразным будет увеличить детализацию до уровня <code>Подробности</code> или <code>Всё</code>: в этом случае в Журнал работы Сервера будет записываться более подробная информация о работе модуля. Когда проблема решена, верните настройку Уровень Журнала в её обычное значение, иначе Системный Журнал будет очень быстро увеличивать свой размер.</p><p>Записи, помещённые модулем PIPE в журнал работы Сервера, имеют пометку <code>PIPE</code> .</p></li><li><p><code>Процессоры</code></p><p>Эта опция указывает число нитей, используемых для доставки сообщений. Если некоторые из ваших внешних приложений работают медленно, возможно, вы захотите использовать несколько нитей доставки PIPE, так, чтобы несколько сообщений могли обрабатываться одновременно.</p></li><li><p><code>Каталог с Программами</code></p><p>Эта опция указывает каталог с приложениями, которые может запускать модуль PIPE. Если в этой опции указана пустая строка, то все сообщения, направляемые в модуль PIPE, отвергаются.</p></li><li><p><code>Ограничение Времени Обработки</code></p><p>Эта опция ограничивает время обработки сообщения внешним приложением. Если внешнее приложение не завершило свою работу в течении указанного периода времени, его процесс прерывается и сообщение отвергается.</p></li></ul><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Отправка</b></td></tr><tr><td align="right">Проверять Каталог раз в:</td><td><select name="PollInterval"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30" selected="selected">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час.</option><option value="10800">3 час.</option><option value="14400">4 час.</option><option value="21600">6 час.</option><option value="36000">10 час.</option><option value="43200">12 час.</option><option value="31">другое</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Проверять Каталог </code>Submitted<code> раз в</code></p><p>Эта опция указывает, как часто PIPE модуль должен сканировать директорию Submitted и доставлять находящиеся там .sub файлы.</p></li></ul><h2 id="ForeignQueue" tabindex="-1">Обработка Чужих Очередей <a class="header-anchor" href="#ForeignQueue" aria-label="Permalink to &quot;Обработка Чужих Очередей {#ForeignQueue}&quot;">​</a></h2><p>В чрезвычайной ситуации вам может понадобится обработать дополнительную директорию Queue, не останавливая ваш сервер. Такие ситуации могут возникать из-за сбоев в аппаратном обеспечении Сервера, когда восстановленные файлы должны быть обработаны каким-нибудь другим работающим Сервером.</p><p>Для обработки дополнительной директории <code>Queue</code>, передвиньте её в <em>директорию данных</em> работающего Сервера как директорию <code>ForeignQueue</code>. Если вы предпочитаете использовать символьные ссылки, то убедитесь, что директории <code>Queue</code> и <code>ForeignQueue</code> находятся на одной файловой системе.</p><p>Каждые 3 минуты PIPE модуль проверяет, существует ли в <em>директории данных</em> Сервера директория <code>ForeignQueue</code>. При обнаружении директории <code>ForeignQueue</code>, модуль передвигает все <code>.msg</code> файлы из директории <code>ForeignQueue</code> в директорию <code>Queue</code> (в процессе он может переименовывать файлы), и удаляет все <code>.tmp</code> файлы, найденные в директории <code>ForeignQueue</code>. Файлы с другими расширениями остаются в директории <code>ForeignQueue</code>.</p><p>Все передвинутые <code>.msg</code> файлы передаются ядру Сервера в очередь <a href="./#Enqueue">ENQUEUER</a>, и Сервер начинает обрабатывать их так же, как он обрабатывает другие передаваемые сообщения.</p><p>Когда процесс сканирования завершён, директория <code>ForeignQueue</code> может быть удалена из <em>директории данных</em>.</p>`,55)]))}const P=o(p,[["render",d]]);export{m as __pageData,P as default};
