import{_ as p,c as l,o,ag as i}from"./chunks/framework.jCcxW76o.js";const m=JSON.parse('{"title":"Тарификация","description":"","frontmatter":{"legacyLink":"russian/Billing.html"},"headers":[],"relativePath":"russian/admin/misc/Billing.md","filePath":"russian/admin/misc/Billing.md"}'),c={name:"russian/admin/misc/Billing.md"};function d(a,e,r,t,u,n){return o(),l("div",null,e[0]||(e[0]=[i('<h1 id="тарификация" tabindex="-1">Тарификация <a class="header-anchor" href="#тарификация" aria-label="Permalink to &quot;Тарификация&quot;">​</a></h1><p>Сервер CommuniGate Pro может работать как платформа для Тарификации.</p><p>Каждый <a href="./../objects/Accounts.html">Пользователь</a> может иметь один или несколько <em>Остатков</em>. Модули и компоненты CommuniGate Pro могут списывать из этих остатков плату за услуги и пополнять остатки, осуществлять различные операции возмещения средств и т.п.</p><p>Для каждого Остатка поддерживается <em>текущая сумма</em>, учитывающая активные <em>блокировки средств</em>.</p><p>Журнал всех транзакций хранится в файлах данных Пользователя. Формат Журнала позволяет легко производить операции резервного копирования и восстанавливать данные после различных аппаратных сбоев.</p><p>В качестве имени Остатка &quot;по умолчанию&quot; (&quot;обычного&quot; Остатка) используется пустая строка.</p><p>Денежные значения (денежные средства) представлены как целочисленные 64-битные целые значения со знаком.</p><h2 id="Reserve" tabindex="-1">Блокировки средств <a class="header-anchor" href="#Reserve" aria-label="Permalink to &quot;Блокировки средств {#Reserve}&quot;">​</a></h2><p>Блокировки средств используются, когда тарифицируемая услуга продолжается во времени, и/или услуга тарифицируется в несколько этапов.</p><p>В первую очередь приложение «блокирует» некоторое количество средств на Остатке, достаточное для начального этапа тарифицируемых процедур. Например, это может быть сумма, необходимая для оплаты первой минуты звонка или прохождения первого уровня игры.<br> Если на балансовом Остатке недостаточно средств, запрос о блокировке отвергается.<br> При наличии средств для части балансового Остатка создаётся блокировка с именем, заданным приложением или самим сервером. Общее количество средств, доступных на балансовом Остатке, уменьшается на размер блокировки, но запись о списании средств в журнале Остатка не создаётся.</p><p>Как только плата за тарифицируемые процедуры приближается к размеру блокировки, приложение может увеличить размер блокировки на некоторую дополнительную сумму. Если на балансовом Остатке достаточно «свободных» средств (не зарезервированных другими «блокировками»), то размер блокировки увеличивается.</p><p>Приложение может освободить созданные им блокировки. Информация о блокировке удаляется из данных Остатка, и блокированная сумма зачисляется к свободным средствам Остатка. Например, эта функция может быть использована, если исходящий звонок не состоялся (на него не ответили), и блокированные средства должны быть освобождены без списания их с Остатка.</p><p>Наконец, приложение может списать заблокированные средства, указав имя блокировки. Размер списания не должен превышать размер блокировки.<br> В журнале Остатка создаётся запись о транзакции, и размер списания вычитается из Остатка и из размера блокировки. По выбору приложения блокировка может быть освобождена, и блокированная сумма зачисляется к свободным средствам Остатка.</p><p>При создании или расширении блокировки приложение может указать время окончания блокировки. Блокировка освобождается автоматически в указанное время. Это свойство можно использовать, если приложение может завершить работу без явного освобождения блокировок.<br> При создании или расширении блокировки приложение может указать размер списания для случаев, когда блокировка освобождается автоматически. Например, когда игровое приложение расширяет блокировку при переходе на следующий уровень игры, оно может указать сумму, которая должна быть списана за уже пройденный уровень. Если приложение завершается без явного списания блокированных средств с Остатка, блокировка будет освобождена автоматически, но указанная для автоматического списания сумма будет списана.</p><h2 id="API" tabindex="-1">Интерфейсы <a class="header-anchor" href="#API" aria-label="Permalink to &quot;Интерфейсы {#API}&quot;">​</a></h2><p>Подсистема Тарификации CommuniGate Pro доступна в:</p><ul><li>приложениях <a href="./../../development/CGPL.html">CG/PL</a>, выполняющихся на сервере (PBX Задачи, WebUser аплеты и т.п.).</li><li>сессиях протокола <a href="./../../development/XMLAPI.html">XIMSS</a>, использующихся клиентскими программами.</li><li>клиентских приложениях <a href="./../signals/Parlay.html">ParlayX</a>.</li><li>программах и сценариях, использующих интерфейс <a href="./../../development/CLI.html">CLI</a>.</li></ul><h2 id="OpCodes" tabindex="-1">Операции <a class="header-anchor" href="#OpCodes" aria-label="Permalink to &quot;Операции {#OpCodes}&quot;">​</a></h2><p>Доступны следующие операции Тарификации:</p><ul><li><p><code>list</code></p><p>Эта операция возвращает все Остатки, доступные для этого Пользователя.</p><ul><li><p>Параметры:</p><p><em>отсутствуют</em></p></li><li><p>Результаты:</p><ul><li><p><code>balance</code></p><p>массив имён доступных Остатков.</p></li></ul></li></ul></li><li><p><code>credit</code></p><p>Эта операция добавляет средства на Остаток.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Если Остаток с таким названием не существует, то он будет создан.</p></li><li><p><code>amount</code></p><p>неотрицательное число: зачисляемая сумма.</p></li><li><p><code>reference</code></p><p>строка: произвольные данные, используемые для указания ссылки, полезной при разрешении спорных ситуаций и т.д.</p></li><li><p><code>description</code></p><p>объект (обычно - строка или массив строк): произвольные данные, описывающие транзакцию.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>amount</code></p><p>число: текущее значение Остатка.</p></li></ul></li></ul></li><li><p><code>remove</code></p><p>Эта операция удаляет Остаток.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>История Остатков не удаляется. Если текущее значение Остатка ненулевое, то в историю Остатков добавляется запись, обнуляющая значение Остатка.</p></div><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Остаток с таким названием будет удалён.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>amount</code></p><p>число: размер удалённого Остатка.</p></li></ul></li></ul></li><li><p><code>reserve</code></p><p>Эта операция блокирует средства на Остатке. Заблокированная сумма не может быть использована для оплаты других услуг. Блокировка может отменяться явно, с возвращением заблокированных средств на Остаток, или она может прекращаться автоматически после заданного интервала времени.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Этот Остаток уже должен существовать.</p></li><li><p><code>amount</code></p><p>число: размер блокируемых средств. Если блокировка уже существует, это значение используется для увеличения блокируемой суммы.</p></li><li><p><code>reserve</code></p><p>строка: если этот параметр задан, то он должен указывать на существующую блокировку. Сумма <code>amount</code> будет добавлена к этой блокировке. Если этот параметр отсутствует, то создаётся новая блокировка.</p></li><li><p><code>expires</code></p><p>отметка о времени: если этот параметр задан, то он определяет, когда закончится срок действия этой операции блокировки средств.</p></li><li><p><code>overdraft</code></p><p>число: если этот параметр задан, то с его помощью можно будет зарезервировать сумму, превышающую значение текущего Остатка. Если этот параметр не задан, то попытка списать сумму, превышающую текущий Остаток, будет отвергнута.</p></li><li><p><code>charge</code></p><p>число: сумма к списанию при автоматическом освобождении блокировки.</p></li><li><p><code>reference</code>, <code>description</code></p><p>эти строки могут быть указаны, если задан атрибут <code>charge</code>. Они используются так же, как в операции <code>credit</code>, и применяются при списании средств при автоматическом освобождении блокировки.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>reserve</code></p><p>строка: имя резерва (аналогично параметру <code>reserve</code>, если он задан).</p></li><li><p><code>amount</code></p><p>число: текущее значение резерва.</p></li><li><p><code>total</code></p><p>число: текущее значение свободных средств на Остатке.</p></li></ul></li></ul></li><li><p><code>release</code></p><p>Эта операция освобождает блокированные средства. Заблокированная сумма зачисляется на Остаток.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Этот Остаток уже должен существовать.</p></li><li><p><code>reserve</code></p><p>строка: имя существующей блокировки.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>reserve</code></p><p>строка: имя блокировки (аналогично параметру <code>reserve</code>, если он задан).</p></li><li><p><code>amount</code></p><p>число: текущее значение блокировки.</p></li><li><p><code>total</code></p><p>число: текущее значение свободных средств на Остатке.</p></li></ul></li></ul></li><li><p><code>charge</code></p><p>Эта операция списывает средства с Остатка или из блокированных средств.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Этот Остаток уже должен существовать.</p></li><li><p><code>amount</code></p><p>число: списываемая сумма.</p></li><li><p><code>reserve</code></p><p>строка: если этот параметр задан, то сумма списывается из указанной блокировки. Если этот параметр отсутствует, то списывание осуществляется из Остатка.</p></li><li><p><code>overdraft</code></p><p>необязательно, не может быть указан совместно с параметром <code>reserve</code>: задание этого параметра позволяет списать сумму, превышающую текущий Остаток. Если этот параметр не задан, то попытка списать сумму, превышающую текущий Остаток, будет отвергнута.</p></li><li><p><code>release</code></p><p>необязательно, не может быть указан без параметра <code>reserve</code>: если параметр задан, то блокировка освобождается после списания средств.</p></li><li><p><code>reference</code>, <code>description</code></p><p>аналогично операции <code>credit</code>.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>amount</code></p><p>число: текущее значение свободных средств на Остатке или сумма блокированных средств.</p></li><li><p><code>total</code></p><p>число: текущее значение свободных средств на Остатке (только при указании параметра <code>reserve</code>).</p></li><li><p><code>expires</code></p><p>отметка о времени: время окончания срока действия операции блокировки (только если был указан параметр <code>reserve</code> и установлено время окончания срока действия).</p></li></ul></li></ul></li><li><p><code>read</code></p><p>Эта операция читает текущий Остаток или текущий размер блокировки.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Этот Остаток уже должен существовать.</p></li><li><p><code>reserve</code></p><p>необязательная строка: если этот параметр существует, то он должен указывать на существующую блокировку. Операция читает размер блокировки. Если этот параметр отсутствует, то операция читает сумму Остатка.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>amount</code></p><p>число: текущее значение Остатка или размера блокировки.</p></li><li><p><code>expires</code></p><p>отметка о времени: время окончания срока действия операции блокировки (только если был указан параметр <code>reserve</code> и установлено время окончания срока действия).</p></li></ul></li></ul></li><li><p><code>history</code></p><p>Эта операция читает журнал транзакций Остатка.</p><ul><li><p>Параметры:</p><ul><li><p><code>balance</code></p><p>строка: название Остатка. Этот Остаток уже должен существовать.</p></li><li><p><code>timeFrom</code>, <code>timeTill</code></p><p>отметки о времени: Записи, которые были записаны, начиная с <code>timeFrom</code> (включительно) и до <code>timeTill</code> (не включая последнюю отметку).</p></li><li><p><code>limit</code></p><p>число: максимально число отображаемых записей.<br> Если это число положительно, то сначала возвращаются самые последние записи, а более старые отбрасываются при достижении лимита.<br> Если это число отрицательно, то сначала возвращаются самые старые записи, а более новые отбрасываются при достижении лимита.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>history</code></p><p>массив записей с транзакциями. Каждая запись содержит следующие элементы:</p><ul><li><p><code>Date</code></p><p>отметка времени: время транзакции.</p></li><li><p><code>amount</code></p><p>число: сумма транзакции (положительно для операций <code>credit</code>).</p></li><li><p><code>balance</code></p><p>число: значение Остатка после этой транзакции.</p></li><li><p><code>reference</code>, <code>description</code></p><p>копии этих параметров операций <code>credit</code> и <code>charge</code>.</p></li></ul></li></ul></li></ul></li><li><p><code>calllog</code></p><p>Эта операция читает журналы звонков.</p><ul><li><p>Параметры:</p><ul><li><p><code>timeFrom</code>, <code>timeTill</code></p><p>записи, которые были внесены в журнал, начиная с <code>timeFrom</code> (включительно) и до <code>timeTill</code> (не включая последнюю отметку).</p></li><li><p><code>limit</code></p><p>число: максимально число отображаемых записей.<br> Если это число положительно, то сначала возвращаются самые последние записи, а более старые отбрасываются при достижении лимита.<br> Если это число отрицательно, то сначала возвращаются самые старые записи, а более новые отбрасываются при достижении лимита.</p></li><li><p><code>filter</code></p><p>необязательная строка: если указана, то операция возвращает только записи, в которых адрес или реальное имя абонента соответствуют указанной строке.</p></li></ul></li><li><p>Результаты:</p><ul><li><p><code>callHistory</code></p><p>массив записей с транзакциями. Каждая запись содержит следующие элементы:</p><ul><li><p><code>Date</code></p><p>отметка времени: время начала звонка в GMT.</p></li><li><p><code>direction</code></p><p>строка &quot;inp&quot; для входящих звонков, строка &quot;out&quot; для исходящих звонков.</p></li><li><p><code>To</code></p><p>строка с адресом абонента</p></li><li><p><code>RealName</code></p><p>(необязательно) &quot;настоящее имя&quot; абонента.</p></li><li><p><code>Call-ID</code></p><p>строка с Call-ID.</p></li><li><p><code>disconnected</code></p><p>отметка времени: время окончания звонка (GMT).</p></li><li><p><code>connected</code></p><p>отметка времени: время соединения. Если отсутствует, то соединения не было.</p></li><li><p><code>dialogError</code></p><p>(необязательно) строка с ошибкой при установлении звонка.</p></li><li><p><code>dialogApp</code></p><p>(необязательно) Если звонок принимался приложением УПАТС, то этот атрибут содержит имя приложения.</p></li></ul></li><li><p><code>amount</code></p><p>общее число найденных звонков.</p></li></ul></li></ul></li></ul>',20)]))}const h=p(c,[["render",d]]);export{m as __pageData,h as default};
