import{_ as t}from"./chunks/SignalScheme.BkxABKcO.js";import{_ as e,c as i,o as p,ag as n}from"./chunks/framework.jCcxW76o.js";const h=JSON.parse('{"title":"Сигналы в Реальном Времени","description":"","frontmatter":{"legacyLink":"russian/Signals.html"},"headers":[],"relativePath":"russian/admin/signals/index.md","filePath":"russian/admin/signals/index.md"}'),l={name:"russian/admin/signals/index.md"};function a(u,o,d,c,r,s){return p(),i("div",null,o[0]||(o[0]=[n('<p></p><h1 id="сигналы-в-реальном-времени" tabindex="-1">Сигналы в Реальном Времени <a class="header-anchor" href="#сигналы-в-реальном-времени" aria-label="Permalink to &quot;Сигналы в Реальном Времени&quot;">​</a></h1><p>Одной из основных функций Сервера CommuniGate Pro является поддержка коммуникаций в реальном времени. Играя роль Сервера Сигналов, Сервер получает Сигналы реального времени (Запросы) из различных источников (модули SIP и XMPP, внутренние сессии, &quot;плечи звонков&quot;, внутренние компоненты ядра и т.д.)<br> Сервер CommuniGate Pro либо обрабатывает (терминирует) эти Запросы самостоятельно, либо доставляет их удалённым сторонам (через протоколы SIP или XMPP), либо направляет их во внутренние сессии и в &quot;плечи звонков&quot;.</p><p>Для каждого Запроса, модуль Signal дополнительно может генерировать <em>промежуточные</em> Ответы (такие как &quot;Trying&quot; или &quot;Ringing&quot;) и один <em>завершающий</em> Ответ.</p><h2 id="AOR" tabindex="-1">Адреса Записей (AOR) <a class="header-anchor" href="#AOR" aria-label="Permalink to &quot;Адреса Записей (AOR) {#AOR}&quot;">​</a></h2><p>Пользователи могут настроить свои устройства (IP телефоны, средства для организации аудио/видео конференций, программы для передачи мгновенных сообщений) на подключение к выбранному Серверу автоматически при установлении соединения с Интернет.</p><p>Каждый пользователь имеет уникальный &quot;идентификатор XMPP&quot; или &quot;идентификатор SIP&quot;, называемый также AOR (Address of Record, Адрес Записи).</p><p>Для несессионных протоколов, таких, как SIP, Сервер регистрирует пользователей, запоминая их &quot;SIP идентификаторы&quot; и используемые ими сетевые (IP) адреса.</p><p>Каждый пользователь может иметь несколько активных <em>регистраций</em>, если он имеет несколько коммуникационных устройств, находящихся в режиме онлайн (офисный IP телефон, рабочая станция, программы для обмена мгновенными сообщениями на ноутбуке и т.д.)</p><p>Регистрации позволяют SIP пользователям взаимодействовать друг с другом не зная сетевых адресов, используя только &quot;SIP идентификаторы&quot; (AOR).</p><p>AOR имеют тот же вид, что и адреса электронной почты: <code>username@domainName</code>. AOR пользователя CommuniGate Pro является его полное имя Пользователя, и таким образом, SIP AOR в точности совпадает с адресом электронной почты.</p><p>CommuniGate Pro использует компонент <a href="./../sysadmin/Router.html">Маршрутизатор</a> для всех операций реального времени, так что Псевдонимы, <a href="./../objects/Forwarders.html">Переадресаторы</a> и других механизмы Маршрутизации также будут работать и для Коммуникаций Реального Времени.</p><h2 id="Signal" tabindex="-1">Сигналы <a class="header-anchor" href="#Signal" aria-label="Permalink to &quot;Сигналы {#Signal}&quot;">​</a></h2><p>Сигнал является базовой Задачей Реального времени. Один из участников коммуникаций Реального Времени отправляет Сигналы другому участнику для начала, изменения или прекращения коммуникационного диалога, изменения статуса и т.п.</p><p>Отправляющая сторона формирует объект с Запросом и посылает его в модуль Signal сервера CommuniGate Pro. Модуль Signal обрабатывает Запрос, отправляет, если требуется, Запросы другим участникам и возвращает объект с Ответом отправляющей стороне.</p><p>Многие модули и компоненты CommuniGate Pro могут использовать Сигналы:</p><ul><li>Компонент сервера <a href="./SIP.html">Модуль SIP</a> получает Запросы от внешних участников коммуникаций Реального Времени (SIP клиенты, другие SIP сервера), используя SIP протокол. Когда Модуль Signal генерирует объект с Ответом, SIP Модуль отправляет ответ обратно внешнему участнику.</li><li><a href="./XMPP.html">Модуль XMPP</a> и <a href="./../access/XIMSS.html">Модуль XIMSS</a> отправляют и получают Сигнальные Запросы и Ответы, а также передают их между клиентскими приложениями и Сервером CommuniGate Pro.</li><li>Внутренние <a href="#Nodes">Узлы Реального Времени</a>, такие как <a href="./../../development/PBXApp.html">Программы Реального Времени</a> (Приложения PBX) могут отправлять различные Сигнальные запросы.</li><li><a href="./../../development/Rules.html">Правила Автоматической Обработки</a> могут использовать Сигналы (отправлять Мгновенные Сообщения как уведомления).</li></ul><h2 id="Processing" tabindex="-1">Обработка Запросов <a class="header-anchor" href="#Processing" aria-label="Permalink to &quot;Обработка Запросов {#Processing}&quot;">​</a></h2><p>Когда модуль Signal получает Запрос, он вычисляет для него идентификатор ресурса URI. Он берет URI Запроса (или первый имеющийся Route URI из набора Route Запроса) и использует компонент <a href="./../sysadmin/Router.html">Маршрутизатор</a> для определения адреса назначения Запроса. Далее существует несколько вариантов развития событий:</p><ul><li>Маршрутизатор вернул код ошибки (например, URI Запроса адресуется несуществующему локальному Пользователю). Этот код ошибки возвращается источнику Сигнала, и обработка останавливается.</li><li>Маршрутизатор вернул нелокальный адрес (адрес не из локального Домена). Запрос передаётся в <a href="./SIP.html">Модуль SIP</a> для релеинга. Ответ от модуля SIP передаётся источнику Сигнала.</li><li>Маршрутизатор вернул адрес локального внутреннего <a href="#Nodes">Узла Реального Времени</a>. Запрос передаётся на обработку в этот Узел. Ответ Узла передаётся источнику Сигнала.</li><li>Маршрутизатор вернул локальный адрес Пользователя и Запрос может быть обработан Модулем Signal самостоятельно. Запрос обрабатывается, и Ответ возвращается источнику Сигнала. Эти случаи включает в себя также Запросы типа REGISTER и другие Запросы, URI которых указывают на локальные Домены.</li><li>Маршрутизатор вернул локальный адрес и Запрос не может быть обработан Модулем Signal самостоятельно. Начинается <a href="#Forking">процесс Ответвления</a>, URI Запроса используется в качестве начального набора AOR.</li><li>Маршрутизатор вернул фиктивный адрес <code>null</code>. Положительный ответ (код OK) возвращается источнику Сигнала, и обработка останавливается.</li></ul><p>Следующая диаграмма иллюстрирует схему обработки Сигналов в Сервере CommuniGate Pro:</p><p><img src="'+t+'" alt="Схема Сигналов"></p><h2 id="Rules" tabindex="-1">Автоматическая Обработка (Правила) <a class="header-anchor" href="#Rules" aria-label="Permalink to &quot;Автоматическая Обработка (Правила) {#Rules}&quot;">​</a></h2><p>После того, как адрес был обработан при помощи Маршрутизатора, но до того, как он был ретранслирован локальному или удалённому участнику, применяются Общесерверные и Общекластерные <a href="./SignalRules.html">Правила Автоматической Обработки Сигналов</a>.</p><p>Правила управляют ходом обработки запроса: они могут перенаправить его на другой адрес или отвергнуть Запрос.</p><p>С помощью Автоматических Правил обрабатываются только Запросы, инициирующие Диалог.</p><h2 id="Forking" tabindex="-1">Ответвление <a class="header-anchor" href="#Forking" aria-label="Permalink to &quot;Ответвление {#Forking}&quot;">​</a></h2><p>Модуль Signal обслуживает наборы AOR (Адресов Записи) и Contact для каждого обрабатываемого Запроса. Модуль начинает процесс Ответвления, обрабатывая адреса из набора AOR.</p><p>При получении во время обработки любого AOR ответа типа 2xx, обработка останавливается. Если Запрос имел тип INIVTE, то все невыполненные Запросы, ретранслированные на другие AOR, отменяются.</p><p>После обработки всех AOR, модуль возвращает &quot;лучший&quot; результат обработки источнику Запроса.</p><p>Если AOR, подлежащий обработке, <a href="./../sysadmin/Router.html">Направляется</a> на нелокальный адрес, то этот адрес помещается в набор Contact.</p><p>Если AOR, подлежащий обработке, <a href="./../sysadmin/Router.html">Направляется</a> на локальную Группу, то все участники группы добавляются в набор AOR.</p><p>Если AOR, подлежащий обработке, <a href="./../sysadmin/Router.html">Направляется</a> на локального Пользователя, то все активные <em>Регистрации</em> Пользователя (зарегистрированные адреса устройств Пользователя) добавляются в набор Contact.</p><p>Если AOR уже существует в наборе AOR, то он не добавляется к набору AOR.</p><p>Если адрес уже существует в наборе Contact, то он не добавляется к набору Contact.</p><p>Модуль Signal проверяет каждый адрес и добавляет его к набору Contact.<br> Если новый адрес Contact является адресом <a href="#Nodes">Локального Узла</a>, то Запрос передаётся на обработку в этот Узел.<br> Если новый адрес Contact является внешним адресом, то Запрос передаётся в Модуль SIP для релеинга.</p><p>Когда локальный или внешний участник возвращает Ответ типа Redirect, то модуль проверяет начальный AOR (URI Запроса).</p><ul><li>Если начальный AOR был Направлен на локального Пользователя или Группу, то адреса, указанные в Ответе типа Redirect, добавляются в набор AOR и процесс Подключения продолжается.</li><li>Если начальный AOR был Направлен на удалённый адрес, то Ответ типа Redirect возвращается источнику Запроса.</li></ul><h2 id="Config" tabindex="-1">Настройка Модуля Signal <a class="header-anchor" href="#Config" aria-label="Permalink to &quot;Настройка Модуля Signal {#Config}&quot;">​</a></h2><p>Для того, чтобы настроить параметры модуля Signal, используйте Веб Интерфейс Администратора. Откройте в области Установки страницу Real-Time, затем откройте страницу Сигналы:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Обработка</b></td></tr><tr><td>Уровень Журнала: <select name="TempFilesLogLevel"><option value="0">Катастрофы</option><option value="1" selected="selected">Сбои</option><option value="2">Основное</option><option value="3">Проблемы</option><option value="4">Подробности</option><option value="5">Всё</option></select></td><td>Процессоры: <select name="Processors"><option value="0">выкл</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">другое</option></select></td><td>Ограничение на Объекты: <select name="XT"><option value="1">30</option><option>100</option><option>300</option><option>500</option><option selected="selected">1000</option><option>2000</option><option>5000</option><option>10000</option><option>30000</option><option>100000</option><option value="2222">другое</option></select></td><td>Ограничение на События: <select name="XT1"><option value="1">30</option><option>100</option><option selected="selected">300</option><option>500</option><option>1000</option><option>2000</option><option>5000</option><option>10000</option><option>30000</option><option value="2222">другое</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку, чтобы указать, какую информацию компонент Signal должен сохранять в Журнале работы Сервера. Обычно используется уровень <code>Сбои</code> (только неразрешимые проблемы), уровень <code>Основное</code> (отчёты о ходе обработки Сигналов) или уровень <code>Проблемы</code> (сбои, отчёты о ходе обработки Сигналов и не фатальные ошибки).<br> В случае, если в работе компонента Signal возникают проблемы, возможно, целесообразным будет увеличить детализацию до уровня <code>Подробности</code> или <code>Всё</code>: в этом случае в Системный Журнал будет записываться более подробная информация о внутренней работе компонента. Когда проблема решена, верните настройку Уровень Журнала в её обычное значение, так как иначе Системный Журнал будет очень быстро увеличивать свой размер.<br> Записи, помещённые компонентом Signal в Журнал работы Сервера, имеют пометку <code>SIGNAL</code>.</p></li><li><p><code>Процессоры</code></p><p>Компонент Signal использует несколько одновременных процессоров (нитей) для обработки &quot;задач&quot; Сигналов. Один процессор может обрабатывать несколько задач Сигналов. Если вы используете большое количество <a href="./SignalRules.html">Автоматических Правил</a>, выполнение которых занимает относительно много времени, то вы должны разрешить компоненту использовать большее количество процессоров для обработки сигналов.</p></li><li><p><code>Ограничение на Объекты</code></p><p>Эта настройка определяет, какое количество &quot;Задач&quot; компонент Signal может обрабатывать одновременно.<br> При превышении этого ограничения новые Сигналы отвергаются и отправителям Сигналов направляется Ответ с кодом ошибки.</p></li><li><p><code>Ограничение на События</code></p><p>Эта настройка задаёт критическое число необработанных событий (отправленных во все активные &quot;задачи&quot; Сигналов).<br> При превышении этого ограничения компонент входит в режим перегрузки (Процессоры компонента не смогут обрабатывать возникающие события), новые Сигналы отвергаются и отправителям Сигналов направляется Ответ с кодом ошибки.</p></li></ul><p>Используйте панель Установок Обработки, чтобы указать параметры обработки сигнальных задач.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Установки Обработки</b></td></tr><tr><td align="right">Ограничение числа AOR:</td><td><select class="popup" name="AORLimit"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="31">другое</option></select></td><td align="right">Ограничение по Времени:</td><td><select class="popup" name="TimeLimit"><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900" selected="selected">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400">24 час</option><option value="901">другое</option></select></td></tr><tr><td align="right">Ограничение числа Разветвлений:</td><td><select class="popup" name="ForkLimit"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30" selected="selected">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="31">другое</option></select></td><td align="right"> </td><td><input type="checkbox" name="AuthAllINVITEs" value="1" checked="checked"> Аутентифицировать все исходящие</td></tr></tbody></table></div></form><ul><li><p><code>Ограничение числа AOR</code></p><p>Эта установка ограничивает количество AOR, которое может быть обработано в одной операции. Она ограничивает общее количество ответвлений, перенаправлений и т.п. для одного запроса.</p></li><li><p><code>Ограничение числа Разветвлений</code></p><p>Эта установка ограничивает количество ответвлений для одной операции.</p></li><li><p><code>Ограничение по Времени</code></p><p>Эта настройка задаёт ограничение по времени для обработки запроса.</p></li><li><p><code>Аутентифицировать все исходящие</code></p><p>Сервер CommuniGate Pro для определённых Запросов требует авторизации пользователя:</p><ul><li>когда запросы отправляются удалённо через SIP, аутентификация выполняется в <a href="./SIP.html#ServerConfig">Модуле SIP</a></li><li>модули <a href="./../access/XIMSS.html">XIMSS</a> и <a href="./XMPP.html">XMPP</a> отправляют все Сигналы от имени зарегистрированного Пользователя, предварительно проведя аутентификацию</li><li><a href="./../../development/PBXApp.html">Приложения Реального Времени</a> отправляют Сигналы от имени <em>текущего Пользователя</em> (если только Приложение не представляется как &quot;никто&quot;)</li></ul><p>Эта опция требует аутентификации всех звонков (начальных запросов INVITE), начатых от имени Пользователей этого Сервера.</p><p>Когда Сигнал, начинающий звонок (начальный запрос INVITE с дескриптором аудио/видео сессии), аутентифицирован, Модуль Signal проводит дополнительную обработку аутентифицированного Пользователя.</p><p>Компонент Signal может ограничить число &quot;звонков&quot;, которое Пользователь может совершать в течение указанного периода времени. При попытке совершения большего количества звонков, они будут отвергаться без обработки.<br> Это ограничение может быть установлено индивидуально для каждого Пользователя, или же могут использоваться Общесерверные, Общекластерные или Доменные установки по умолчанию для Аккаунтов. Дополнительную информацию смотрите в разделе <a href="./../objects/Accounts.html#Signal">Пользователи</a>.</p></li></ul><h2 id="Account" tabindex="-1">Отправка Сигналов Пользователям <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Отправка Сигналов Пользователям {#Account}&quot;">​</a></h2><p>Если первый AOR в наборе (AOR, указанный в URI Запроса) является локальным адресом Пользователя, а Запрос имеет тип INVITE, то запрашивается регистрация устройства Пользователя и значения некоторых параметров из Установок и Настроек Пользователя.</p><p>У Пользователя могут быть настроены <a href="./SignalRules.html">Автоматические Сигнальные Правила</a>, которые запрашиваются одновременно с регистрациями устройств Пользователя. Эти Правила, наряду с Правилами, Общими для Домена пользователя, применяются ко всем запросам, отправляемым Пользователю.</p><p>Компонент Signal управляет количеством &quot;звонков&quot; (начальных INVITE запросов с Дескрипторами аудио/видео Сессий), которые Пользователь может принимать в течение заданного интервала времени. При получении большего количества запросов, они будут отвергаться без обработки.<br> Это ограничение может быть установлено индивидуально для каждого Пользователя, или же могут использоваться Общесерверные, Общекластерные или Доменные установки по умолчанию для Аккаунтов. Дополнительную информацию смотрите в разделе <a href="./../objects/Accounts.html#Signal">Пользователи</a>.</p><h2 id="Remote" tabindex="-1">Отправка Сигналов в Удалённые Системы <a class="header-anchor" href="#Remote" aria-label="Permalink to &quot;Отправка Сигналов в Удалённые Системы {#Remote}&quot;">​</a></h2><p>Если Сигнал должен быть ретранслирован в удалённую систему, то компонент Signal направляет его в какой-либо сигнальный модуль.</p><p>Адрес-получатель Сигнала может явно направляться в какой-либо модуль. Например, все домены с суффиксом <code>._xmpp</code> направляются в <a href="./XMPP.html">модуль XMPP</a>.</p><p>Если адрес-получатель Сигнала явно не направляется в какой-либо модуль, то компонент Signal проверяет имя домена, в котором находится адрес-получатель</p><ul><li>Если имя домена является адресом IP, то Сигнал направляется в модуль <a href="./SIP.html">SIP</a>.</li><li>Если имя домена имеет в DNS записи SIP SRV, то Сигнал направляется в модуль <a href="./SIP.html">SIP</a>.</li><li>Если имя домена имеет в DNS записи XMPP SRV, то Сигнал направляется в модуль <a href="./XMPP.html">XMPP</a>.</li><li>Во всех других случаях Сигнал направляется в модуль <a href="./SIP.html">SIP</a>.</li></ul><h2 id="ServiceCalls" tabindex="-1">Сервисные Звонки <a class="header-anchor" href="#ServiceCalls" aria-label="Permalink to &quot;Сервисные Звонки {#ServiceCalls}&quot;">​</a></h2><p>Если запрос направлен на имя <code>*nnnn</code> в любой из локальных <a href="./../objects/Domains.html">Доменов</a> (где <em>nnnn</em> это любая последовательность, начинающаяся с десятичной цифры), то Запрос перенаправляется инициатору (на адрес <code>From:</code> Запроса).</p><p>Это возможность позволяет пользователю набирать номера <code>*nnnn</code> для получения от Сервера специальных услуг. Запрос направляется на Пользователя, у которого запускается сервисное приложение. Приложение обеспечивает требуемый сервис, получая значение набранной &quot;опции сервиса&quot; из адреса <code>To:</code> Запроса.</p><h2 id="Registrar" tabindex="-1">Услуги Регистрации <a class="header-anchor" href="#Registrar" aria-label="Permalink to &quot;Услуги Регистрации {#Registrar}&quot;">​</a></h2><p>Коммуникационные устройства, используемые пользователями CommuniGate Pro, должны зарегистрировать себя до того, как они смогут получать запросы от других участников.</p><p>Запросы на Регистрацию требуют проведения Аутентификации Пользователя.</p><p>При изменении регистраций Пользователя могут использоваться Полномочия другого <a href="./../objects/Accounts.html">Пользователя</a>, если аутентифицированный Пользователь имеет право доступа <a href="./../sysadmin/#DomainPrivs">Может выступать от имени других</a> для соответствующего Домена.</p><p>Для того, чтобы настроить Услуги Регистрации, откройте в области Установки страницу Real-Time и перейдите по ссылке Сигналы.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Услуги</b></td></tr><tr><td rowspan="2">Время Регистрации:</td><td align="right">Минимальное:</td><td><select name="MinRegister"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30" selected="selected">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="31">другое</option></select></td><td align="right">По умолчанию:</td><td><select name="DefaultRegister"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800" selected="selected">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="1801">другое</option></select></td><td align="right">Максимальное:</td><td><select name="MaxRegister"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400" selected="selected">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="86401">другое</option></select></td></tr><tr><td align="right">Случайная поправка:</td><td><select name="MinRegister"><option value="0" selected="selected">0 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="15">15 сек</option><option value="30">30 сек</option><option value="60">60 сек</option><option value="120">2 мин</option><option value="300">5 мин</option><option value="31">другое</option></select></td><td colspan="4"> </td></tr><tr><td>MS RTC:</td><td align="right">Интегрировать с Ростером:</td><td><select name="RTCRoster"><option value="0" selected="selected">Выключено</option><option value="1" selected="selected">Включено</option></select></td><td colspan="2"></td></tr></tbody></table></div></form><ul><li><p><code>Регистрация: Минимальное</code></p><p>Используйте эту опцию для задания минимального периода времени срока действия Регистрации.<br> Если Запрос на Регистрацию имеет более короткий период действия, то Запрос отвергается и отправляется Ответ со значением минимально допустимого периода времени. Участник (обычно - SIP устройство) может переслать Запрос на Регистрацию с исправленным сроком действия.</p></li><li><p><code>Регистрация: По умолчанию</code></p><p>Значение этой опции используется, если в Запросе на Регистрацию не указан срок действия Регистрации.</p></li><li><p><code>Регистрация: Максимальное</code></p><p>Используйте эту опцию для задания максимального периода времени срока действия Регистрации.<br> Если Запрос на Регистрацию имеет более длительный срок, то он укорачивается до указанного здесь значения.</p></li><li><p><code>Регистрация: Случайная поправка</code></p><p>Если это опция установлена в ненулевое значение X, то запрошенное время срока действия Регистрации уменьшается на случайное значение от 0 до X.<br> Крупные сайты могут использовать эту возможность для смягчения &quot;регистрационной бури&quot;, когда большое количество устройств начинает регистрироваться одновременно (после сбоя сети или остановки системы на обслуживание).<br> Запрошенное время срока действия уменьшается только если оно больше чем <code>2*X</code> и больше чем <code>Минимальное+X</code>.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Компонент Регистрации поддерживает расширения SIP <code>gruu</code> (Globally Routable User Agent (UA) URIs - глобально маршрутизируемые адреса пользовательских устройств).</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Клиенты, использующие для регистрации имена доменов, начинающиеся с префиксов <code>srtp.</code> или <code>dtls.</code>, помечаются как требующие шифрования медиа потока. Аналогично, если на сервере разрешены <a href="./LOCAL.html#RouteSettings">&#39;Детализированные&#39; Адреса</a>, и во время регистрации имя аутентификации в качестве детализации содержало строку <code>srtp</code> или <code>dtls</code>, то во входящих звонках этому Клиенту тоже будет предлагаться шифрование медиа потока.</p></div><h2 id="Events" tabindex="-1">Наборы Событий <a class="header-anchor" href="#Events" aria-label="Permalink to &quot;Наборы Событий {#Events}&quot;">​</a></h2><p>Модуль Signal поддерживает несколько Наборов Событий. При получении Запроса SUBSCRIBE, предназначенного для локального Пользователя, модуль может обработать Запрос самостоятельно, не пересылая его зарегистрированным устройствам Пользователя.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Как обходное решение для большого количества некорректно работающих клиентов, Модуль принимает Запросы SUBSCRIBE, отправленные в локальные Домены (вместо локальных Пользователей). В таких запросах, для замены адреса типа домен в адресе URI Запроса используется адрес в поле <code>To</code>.</p></div><p>Модуль Signal обслуживает &quot;кортежи&quot; состояний для каждого Пользователя и для каждого поддерживаемого Набора Событий. Модуль позволяет одному или нескольким устройствам обновлять &quot;кортежи&quot; и агрегирует их в единую для всего Набора &quot;информацию о состоянии&quot; Пользователя. Когда агрегированная &quot;информация о состоянии&quot; изменяется, модуль отправляет всем подписанным участникам запросы NOTIFY, содержащие обновлённое состояние.</p><p>Модуль Signal позволяет внешним участникам изменять &quot;кортежи&quot; используя запросы PUBLISH.</p><p>Модуль Signal позволяет внешним участникам изменять &quot;кортежи&quot; для определённых Наборов используя нестандартные запросы SERVICE.</p><p>Модуль Signal обеспечивает работу &quot;наблюдателей&quot; для всех Наборов Событий. Они обеспечивают информацию о подписчиках на &quot;основные&quot; Наборы Событий. Также реализованы наборы &quot;наблюдателей за наблюдателями&quot;.</p><p>Если явно не указано иначе, подписка на Наборы Событий Пользователя возможна только для самого Пользователя и для Пользователей, обладающих Правами Доступа <a href="./../sysadmin/#DomainPrivs"><code>Может выступать от имени других</code></a>в домене Пользователя, а также Пользователям с <a href="./../objects/Accounts.html#AccessRights">правом Delegate</a> к этому Пользователю.<br> Такие же ограничения действуют на подписки к наборам &quot;наблюдателей&quot;.</p><h3 id="Presence" tabindex="-1">Статус Присутствия <a class="header-anchor" href="#Presence" aria-label="Permalink to &quot;Статус Присутствия {#Presence}&quot;">​</a></h3><p>В Модуле Signal реализован Сервер Статуса Присутствия. Модуль поддерживает форматы <code>PIDF</code>, <code>CPIM-PIDF</code> и <code>XPIDF</code> для информации о Статусе Присутствия.</p><p>Модуль Signal обеспечивает специальную обработку для запросов REGISTER. Если внешний участник (SIP устройство) указывает поддержку метода SUBSCRIBE, то модуль устанавливает с этим участником диалог подписки на статус присутствия.<br> Затем модуль обрабатывает все запросы NOTIFY, отправляемые этим участником для обслуживания &quot;кортежа&quot; или &quot;сегмента&quot; его Статуса Присутствия.</p><p>Значение сегмента статуса присутствия является одной из текстовых строк из фиксированного набора, перечисленных в порядке возрастания приоритета:</p><ul><li><code>offline</code> - вне сети</li><li><code>away</code> - нет на месте</li><li><code>out-lunch</code> - на перерыве</li><li><code>in-meeting</code> - на совещании</li><li><code>be-back</code> - скоро вернусь</li><li><code>online</code> - в сети</li><li><code>on-phone</code> - на телефоне</li><li><code>busy</code> - занят</li></ul><p>Агрегированное значение события - это значение сегмента с самым высоким приоритетом или значение <code>offline</code> (&quot;вне сети&quot;), если сегменты отсутствуют.</p><p>При формировании запроса NOTIFY агрегированное значение преобразовывается в документ статуса присутствия в одном из поддерживаемых форматов.</p><p>Подписка на этот Набор Событий доступна всем согласно стандартной схеме подтверждения.</p><h3 id="MessageSummary" tabindex="-1">Сводка о Сообщениях <a class="header-anchor" href="#MessageSummary" aria-label="Permalink to &quot;Сводка о Сообщениях {#MessageSummary}&quot;">​</a></h3><p>В Модуле Signal реализован сервис MWI (Индикация Ожидающих Сообщений). Модуль поддерживает формат представления Информации <code>simple-message-summary</code>.</p><p>Сервер самостоятельно обслуживает кортеж/сегмент &quot;INBOX&quot; для этого набора Событий. Значение сегмента являются <a href="./../../development/Data.html">массивом</a>:</p><ul><li>первый элемент - это число сообщений в INBOX, имеющих флаг $Media и не имеющих флага Seen (число непрочитанных медиа сообщений);</li><li>второй элемент - это общее число сообщений в INBOX, имеющих флаг $Media (общее число медиа сообщений);</li></ul><p>Агрегированное значение события - это массив, содержащий поэлементную сумму всех значений массивов сегментов.</p><p>Когда формируется запрос NOTIFY, использующий информацию в формате <code>simple-message-summary</code>, то значение первого элемента агрегированного массива используется как число новых голосовых сообщений, а разница между значением второго и первого элементов используется как число старых голосовых сообщений.<br> Если значение первого элемента не равно нулю, то элемент <code>Messages-Waiting</code> устанавливается в значение <code>yes</code>; в противном случае оно сбрасывается в <code>no</code>.</p><h3 id="Registration" tabindex="-1">Регистрация <a class="header-anchor" href="#Registration" aria-label="Permalink to &quot;Регистрация {#Registration}&quot;">​</a></h3><p>В Модуле Signal реализована Услуга Мониторинга за Регистрацией. Модуль поддерживает формат представления Информации <code>reginfo+xml</code> и может информировать участников, находящихся в сети (таких, как SIP клиенты) обо всех других устройствах, зарегистрированных за Пользователем.</p><h3 id="DialogPackage" tabindex="-1">Диалог <a class="header-anchor" href="#DialogPackage" aria-label="Permalink to &quot;Диалог {#DialogPackage}&quot;">​</a></h3><p>В Модуле Signal реализована Услуга Мониторинга за Диалогом. Модуль поддерживает формат представления Информации <code>dialog-info+xml</code> и может информировать находящихся в сети участников (таких, как SIP клиенты) обо всех других активных диалогах Пользователя.</p><p>Подписка на набор Диалог возможна только для самого Пользователя, других Пользователей с <a href="./../sysadmin/#DomainPrivs">правом Администратора Домена</a> <code>CanControlCalls</code> (Полный доступ ко всем Звонкам), а также для тех Пользователей, которым Пользователь предоставил <a href="./../objects/Accounts.html#AccessRights">Право Доступа</a> CallControl.</p><h2 id="Calls" tabindex="-1">Звонки <a class="header-anchor" href="#Calls" aria-label="Permalink to &quot;Звонки {#Calls}&quot;">​</a></h2><p>Сервер CommuniGate Pro может создавать объекты Диалог при обработке определённых запросов INVITE. Объекты Диалог содержат информацию о звонке/сессии/диалоге, созданными этими запросами.<br> Объекты типа диалог уничтожаются по завершению звонков.</p><p>Если вызывающий абонент аутентифицирован, то статус звонка записывается в данные Пользователя, инициирующего звонок и генерируется запись <a href="#CDR">CDR</a>. При завершении звонка, для этого исходящего звонка в <a href="#CallLogs">файл с журналом звонков</a> вызывающего Пользователя добавляется протоколирующая запись.</p><p>Если адресат (вызываемый абонент) аутентифицирован, то статус звонка записывается в данные Пользователя, принимающего звонок и генерируется запись <a href="#CDR">CDR</a>. При завершении звонка, для этого исходящего звонка в <a href="#CallLogs">файл с журналом звонков</a> вызывающего Пользователя добавляется протоколирующая запись.</p><p>Если аутентифицированный участник (вызывающий или вызываемый) ставится на удержание, то используется его настройка Пользователя &quot;Музыка при Ожидании&quot;.<br> Если она не установлена в <code>выключено</code>, то указанный звуковой файл читается из Хранилища Файлов Пользователя. Если имя файла задано как &quot;*&quot; или если указанный файл не найден, то читается файл <code>HoldMusic</code> из <a href="./../../development/PBXApp.html">Среды для Приложений Реального Времени</a> Домена Пользователя.<br> Когда звуковой файл прочитан, создаётся <a href="./MediaServer.html">Медиа Канал</a> и он получает задание на воспроизведение этого файла другому участнику.</p><p>Для того, чтобы настроить компонент Менеджер Диалога, используйте Веб Интерфейс Администратора. Откройте в разделе Установки страницу Real-Time, затем откройте страницу Сигналы:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Звонки</b></td></tr><tr><td align="RIGHT">Уровень Журнала:</td><td><select name="CallLogLevel"><option value="0">Катастрофы</option><option value="1">Сбои</option><option value="2">Основное</option><option value="3">Проблемы</option><option value="4" selected="selected">Подробности</option><option value="5">Всё</option></select></td><td align="RIGHT">Ограничение по Времени:</td><td><select name="CallTimeLimit"><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400" selected="selected">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="864000">10 дн</option><option value="1209600">2 нед</option><option value="2592000">30 дн</option><option value="8640000">100 дн</option><option value="901">другое</option></select></td></tr><tr><td align="RIGHT">Тайм-аут по Сигналам:</td><td><select name="CallSignalIdle"><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600" selected="selected">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400">24 час</option><option value="2401">другое</option></select></td><td align="RIGHT">Тайм-аут по Медиа:</td><td><select name="CallMediaIdle"><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900" selected="selected">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="57600">16 час</option><option value="86400">24 час</option><option value="1201">другое</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку для того, чтобы указать, какую информацию компонент Менеджер Диалога должен сохранять в Журнале работы Сервера. Обычно используется уровень <code>Сбои</code> (только неразрешимые проблемы), уровень <code>Основное</code> (сбои и основные события) или уровень <code>Проблемы</code> (сбои, основные события и не фатальные ошибки).<br> Записи, помещённые компонентом Менеджер Диалога в Журнал работы Сервера, имеют пометку <code>DIALOG</code>.</p></li><li><p><code>Ограничение по Времени</code></p><p>Эта настройка задаёт ограничение по времени для Диалогов Звонка. При превышении этого лимита, объект Диалог удаляется. Устанавливайте значение для этого ограничения достаточно большим, чтобы избежать прерывания звонков.</p></li><li><p><code>Тайм-аут по неактивности</code>, <code>Тайм-аут по Медиа</code></p><p>Если в Диалоге не отправляется Сигналов в течение указанного периода времени, и, если осуществляется Проксирование Медиа, связанное с этим Диалогом, но в течение указанного периода времени отсутствуют медиа данные, то этот объект Диалог удаляется. Устанавливайте значения для этих ограничений достаточно большим, чтобы избежать прерывания звонков.</p></li></ul><h3 id="CallLogs" tabindex="-1">Журналы Звонков Пользователя <a class="header-anchor" href="#CallLogs" aria-label="Permalink to &quot;Журналы Звонков Пользователя {#CallLogs}&quot;">​</a></h3><p>Журналы Звонков Пользователя сохраняются в виде текстовых файлов в <a href="./../storage/FileStore.html#CallLogs">Файловом хранилище</a> Пользователя.</p><p>Записи в этих файлах имеют следующий формат:</p><p><code>2_dd-mmm hh:mm:ss_direction_peer_callId_callTime_alertTime_errorCode[_programName]</code> где:</p><ul><li><p><code>_</code></p><p>символ табуляции (символ с кодом 0x09)</p></li><li><p><code>2</code></p><p>версия формата записи</p></li><li><p><code>dd</code></p><p>2-значный номер дня месяца</p></li><li><p><code>mmm</code></p><p>3-х символьное имя месяца</p></li><li><p><code>hh</code>, <code>mm</code>, <code>ss</code></p><p>2-значные цифры с часом (00..23), минутой (00..59) и секундой (00..59) окончания звонка</p></li><li><p><code>direction</code></p><p>1 символ направления звонка: <code>I</code> - входящий, <code>O</code> - исходящий</p></li><li><p><code>peer</code></p><p>адрес электронной почты участника звонка, в формате<br>   <code>&lt;username@domainName&gt;</code><br> или<br>   <code>&quot;real name&quot; &lt;username@domainName&gt;</code></p></li><li><p><code>callId</code></p><p>строка с <code>Call-ID</code>.</p></li><li><p><code>callTime</code></p><p>продолжительность звонка (в секундах). Время между моментом соединения и моментом рассоединения. Если звонок не был выполнен успешно, то это поле будет пустым.</p></li><li><p><code>alertTime</code></p><p>продолжительность вызова (в секундах). Время между началом звонка и моментом соединения или (если звонок не был выполнен успешно) время между началом звонка и моментом неуспешного завершения звонка.</p></li><li><p><code>errorCode</code></p><p>строка с кодом ошибки для неудачного звонка или причина рассоединения звонка. Если звонок был завершён успешно, то это поля является пустым.</p></li><li><p><code>programName</code></p><p>это необязательное поле содержит имя <a href="./../../development/PBXApp.html">Приложения Реального Времени</a>, которое обрабатывало этот звонок.</p></li></ul><h3 id="CDR" tabindex="-1">Детализированная Информация о Звонках (CDR) <a class="header-anchor" href="#CDR" aria-label="Permalink to &quot;Детализированная Информация о Звонках (CDR) {#CDR}&quot;">​</a></h3><p>Модуль Signal может генерировать Детализированную Информацию о Звонках для обрабатываемых им транзакциях INVITE и BYE. Он может также генерировать Детализированную Информацию о Звонках для выполненных звонков, используя информацию из объектов <a href="#Calls">Диалог</a>.</p><p>CDR может генерироваться и храниться в <a href="./../sysadmin/Logs.html#Suppl">Дополнительном Журнале</a> CDR.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Наблюдение</b></td></tr><tr><td><input name="CDRCallLog" value="1" checked="checked" type="checkbox"> Записывать CDR для Звонков</td><td><input name="CDRLog" value="1" type="checkbox"> Записывать Invite/BYE CDR</td></tr></tbody></table></div></form><ul><li><p><code>Записывать CDR для Звонков</code></p><p>Выберите эту опцию для того, чтобы включить создание файлов Журнала CDR для Звонков (объектов Диалога).</p></li><li><p><code>Записывать Invite/BYE CDR</code></p><p>Выберите эту опцию для того, чтобы включить созданий файлов Журнала CDR для запросов INVITE и BYE.</p></li></ul><p>Когда включена программа Помощник <a href="./../../development/Helpers.html#CDR">Внешний Обработчик CDR</a>, то Модуль Signal генерирует CDR всех типов и отправляет их в эту программу.</p><p>Текстовые данные CDR для запросов INVITE/BYE имеют следующий формат (для разделения полей используется символ табуляции): <code>01 NNN-method dialog-identifier parties network-addresses flags</code> где:</p><ul><li><p><code>01</code></p><p>версия используемого формата CDR</p></li><li><p><em>NNN</em></p><p>код выполнения транзакции (цифровой)</p></li><li><p><em>Method</em></p><p>операция/метод транзакции (INVITE, BYE).</p></li><li><p><em>dialog-identifier</em></p><p>идентификатор диалога - поле <code>Call-ID</code>, параметр <code>tag</code> поля <code>From</code>, параметр <code>tag</code> поля <code>To</code>), заключённые в угловые скобки <strong>&lt;</strong> и <strong>&gt;</strong>.<br> Обратите внимание: Если вызов прерван вызываемым абонентом, то <em>fromTag</em> транзакции BYE совпадает с <em>toTag</em> транзакции INVITE и наоборот.</p></li><li><p><em>parties</em></p><p>адреса URI из полей <code>From</code> и <code>To</code> транзакции, заключённые в угловые скобки <strong>&lt;</strong> и <strong>&gt;</strong>.</p></li><li><p><em>network-addresses</em></p><p>сетевой адрес (IP), с которого получен был получен запрос на транзакцию, в квадратных скобках <strong>[</strong> и <strong>]</strong>.</p></li><li><p><em>flags</em></p><p>необязательные поля, разделённые символом табуляции:</p><ul><li><p><code>[auth:accountName]</code></p><p>элемент добавляется, если запрос в транзакции был аутентифицирован. Имя аутентифицированного Пользователя CommuniGate Pro - <em>accountName</em>.</p></li><li><p><code>[redir:accountName]</code></p><p>этот элемент добавляется, если запрос в транзакции был перенаправлен с локального Пользователя. Имя Пользователя CommuniGate Pro, перенаправившего запрос, - <em>accountName</em>.</p></li><li><p><code>[billing:billingData]</code></p><p>этот элемент добавляется, если запрос в транзакции имеет поле P-Billing-Id. Строка <em>billingData</em> является содержимым поля.</p></li><li><p><code>[referred:referredby]</code></p><p>этот элемент добавляется если запрос в транзакции имеет поле Referred-By. Строка <em>referredby</em> является содержимым поля. Текстовые данные CDR для запросов INVITE/BYE имеют следующий формат (для разделения полей используется символ табуляции):</p><p><code>02 callType accountName alertTime connectTime reason dialog-identifier [&quot;fromName&quot;] &lt;from&gt; [&quot;toName&quot;] &lt;to&gt;[[toProgramName]] flags</code> где:</p><ul><li><p><code>02</code></p><p>версия используемого формата CDR</p></li><li><p><em>callType</em></p><p>тип вызова (INP, OUT).</p></li><li><p><em>accountName</em></p><p>полное имя Пользователя (<em>accountName</em>@<em>domainName</em>).</p></li><li><p><em>alertTime</em></p><p>интервал времени (в секундах) между временем, когда звонок был инициирован и временем, когда звонок был принят или отвергнут.</p></li><li><p><em>connectTime</em></p><p>интервал времени (в секундах) между временем, когда звонок был принят и временем, когда звонок был завершён. Если звонок не был принят, то в этом поле содержится символ <code>-</code> (минус).</p></li><li><p><em>reason</em></p><p>причина, по которой звонок был отвергнут или завершён.</p></li><li><p><em>dialog-identifier</em></p><p>идентификатор диалога - поле <code>Call-ID</code>, параметр <code>tag</code> поля <code>From</code>, параметр <code>tag</code> поля <code>To</code>), заключённые в угловые скобки <strong>&lt;</strong> и <strong>&gt;</strong>.</p></li><li><p><em>from</em>, <em>to</em></p><p>адреса URI полей <code>From</code> и <code>To</code> транзакции.</p></li><li><p><em>fromName</em>, <em>toName</em></p><p>значение &quot;Настоящее Имя&quot; полей <code>From</code> и <code>To</code> транзакции. Все другие поля являются необязательными. Если они заданы, то заключены в двойные кавычки (<strong>&quot;</strong>).</p></li><li><p><em>toProgramName</em></p><p>необязательно - имя PBX Приложения, принявшего звонок.</p></li><li><p><em>flags</em></p><p>аналогично используемым с записями версии 01.</p></li></ul></li></ul></li></ul><h2 id="Nodes" tabindex="-1">Узлы Обработки Сигналов <a class="header-anchor" href="#Nodes" aria-label="Permalink to &quot;Узлы Обработки Сигналов {#Nodes}&quot;">​</a></h2><p>Сервер CommuniGate Pro динамически создаёт, запускает и удаляет Узлы обработки сигналов Реального Времени.</p><p>Узел - это внутренний объект Сервера CommuniGate Pro, который может получать Запросы Сигналов и давать Ответы на эти Запросы. Узел также может отправлять Запросы и обрабатывать Ответы.</p><p>Различные компоненты и модули CommuniGate Pro используют Узлы для работы с Сигналами:</p><ul><li>Компонент <a href="./../../development/PBXApp.html">Приложения Реального Времени</a> создаёт Узел для каждого &quot;плеча звонка&quot;.</li><li>Сессии <a href="./../../development/XMLAPI.html">XIMSS</a> создают Узел для каждого &quot;плеча звонка&quot; XIMSS.</li><li>Субкомпонент <a href="#Presence">Статус Присутствия</a> создаёт Узел и использует его для обслуживания Подписок на События Статуса Присутствия для устройств, которые не могут обновлять своё состояние Присутствия.</li></ul><p>Для того, чтобы настроить параметры компонента Узлы, используйте Веб Интерфейс Администратора. Откройте в разделе Установки страницу Real-Time, затем откройте страницу Узлы:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Обработка</b></td></tr><tr><td>Уровень Журнала: <select name="TempFilesLogLevel"><option value="0">Катастрофы</option><option value="1" selected="selected">Сбои</option><option value="2">Основное</option><option value="3">Проблемы</option><option value="4">Подробности</option><option value="5">Всё</option></select></td><td>Процессоры: <select name="Processors"><option value="0">выкл</option><option value="1">1</option><option value="2">2</option><option value="3" selected="selected">3</option><option value="5">5</option><option value="7">7</option><option value="10">10</option><option value="15">15</option><option value="30">30</option><option value="50">50</option><option value="100">100</option><option value="300">300</option><option value="1000">1000</option><option value="3000">3000</option><option value="4">другое</option></select></td><td>Ограничение на Объекты: <select name="NT"><option value="1">50</option><option>100</option><option>300</option><option>500</option><option selected="selected">1000</option><option>2000</option><option>5000</option><option>10000</option><option>20000</option><option>50000</option><option value="2222">другое</option></select></td><td>Ограничение на События: <select name="NT1"><option value="1">50</option><option>100</option><option selected="selected">300</option><option>500</option><option>1000</option><option>2000</option><option>5000</option><option>10000</option><option>20000</option><option>50000</option><option value="2222">другое</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку для того, чтобы указать, какую информацию компонент Узлы должен сохранять в Журнале работы Сервера. Обычно используется уровень <code>Сбои</code> (только неразрешимые проблемы), уровень <code>Основное</code> (сбои и основные события) или уровень <code>Проблемы</code> (сбои, основные события и не фатальные ошибки). В случае, если в работе компонента Узлы возникают проблемы, возможно, целесообразным будет увеличить детализацию до уровня <code>Подробности</code> или <code>Всё</code>: в этом случае в Системный Журнал будет записываться более подробная информация о внутренней работе компонента. Когда проблема решена, верните настройку Уровень Журнала в её обычное значение, так как иначе Системный Журнал будет очень быстро увеличивать свой размер.<br> Записи, помещённые компонентом Узлы в Журнал работы Сервера, имеют пометку <code>NODE</code>.</p></li><li><p><code>Процессоры</code></p><p>Компонент Узлы использует несколько одновременных процессоров (нитей) для обработки &quot;задач&quot; Сигналов. Один процессор может обрабатывать несколько задач Узлов.<br> Если вы используете большое количество Узлов, операции которых занимают относительно много времени (Приложения Реального Времени и т.п.), то вы должны разрешить компоненту использовать большее количество процессоров.</p></li><li><p><code>Ограничение на Объекты</code></p><p>Эта настройка определяет, какое количество Узлов компонент может обрабатывать одновременно. Если это число превышено, то попытки создать новый Узел приведут к ошибке.</p></li><li><p><code>Ограничение на События</code></p><p>Эта настройка задаёт критическое число необработанных событий (отправленных во все активные Узлы). При превышении этого ограничения компонент входит в режим перегрузки (Процессоры компонента не смогут обрабатывать возникающие события), и попытка создания новых Узлов приведёт к ошибке.</p></li></ul><h2 id="CallLegs" tabindex="-1">Плечи Звонка <a class="header-anchor" href="#CallLegs" aria-label="Permalink to &quot;Плечи Звонка {#CallLegs}&quot;">​</a></h2><p>Сервер создаёт специальные Узлы Обработки Сигналов, называемые <em>Плечи Звонка</em>. Каждое Плечо Звонка терминирует сигналы для одного телефонного звонка. Каждая <a href="./../../development/PBXApp.html">Задачи PBX</a> является Плечом Звонка и каждая <a href="./../access/XIMSS.html">XIMSS</a> сессия может создавать одно или более Плечо Звонка для обслуживания телефонных звонков, инициированных или принятых в XIMSS сессии пользователя.</p><p>Настройки на панели Плечи Звонков применяются для всех типов Плечей Звонков:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Плечи Звонков</b></td></tr><tr><td>Тайм-аут:</td><td align="right">Минимальное:</td><td><select name="MinSessionRefresh"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90" selected="selected">90 сек</option><option value="120">2 мин</option><option value="180">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="86400">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="91">другое</option></select></td><td align="right">По умолчанию:</td><td><select name="DefaultSessionRefresh"><option value="1">1 сек</option><option value="2">2 сек</option><option value="3">3 сек</option><option value="5">5 сек</option><option value="10">10 сек</option><option value="15">15 сек</option><option value="20">20 сек</option><option value="30">30 сек</option><option value="40">40 сек</option><option value="60">60 сек</option><option value="90">90 сек</option><option value="120">2 мин</option><option value="180" selected="selected">3 мин</option><option value="300">5 мин</option><option value="600">10 мин</option><option value="900">15 мин</option><option value="1200">20 мин</option><option value="1800">30 мин</option><option value="2400">40 мин</option><option value="3600">60 мин</option><option value="7200">2 час</option><option value="10800">3 час</option><option value="14400">4 час</option><option value="21600">6 час</option><option value="36000">10 час</option><option value="43200">12 час</option><option value="86400">24 час</option><option value="172800">2 дн</option><option value="259200">3 дн</option><option value="604800">7 дн</option><option value="181">другое</option></select></td></tr><tr><td>Ограничение Релеинга:</td><td></td><td><select name="MaxForwards"><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="5">5</option><option value="10">10</option><option value="15">15</option><option value="20" selected="selected">20</option><option value="30">30</option><option value="40">40</option><option value="60">60</option><option value="70">70</option><option value="90">90</option><option value="100">100</option><option value="21">другое</option></select></td><td colspan="2"></td></tr></tbody></table></div></form><ul><li><p><code>Тайм-аут</code></p><p>Используйте эту настройку для указания частоты обмена сторонами запросами INVITE (или OPTION) для проверки того, что звонок не разъединился.</p></li><li><p><code>Ограничение Релеинга</code></p><p>Используйте эту настройку для задания значения поля <code>Max-Forwards</code> для запросов, отправляемых в Плечах Звонка.</p></li></ul><h2 id="API" tabindex="-1">Интерфейс к Сигналам (API) <a class="header-anchor" href="#API" aria-label="Permalink to &quot;Интерфейс к Сигналам (API) {#API}&quot;">​</a></h2><p>Задачи Сигналов могут получать &quot;события&quot; от других компонентов CommuniGate Pro, таких, как задачи <a href="./../../development/CGPL.html">CG/PL</a> и клиентские сессии <a href="./../access/XIMSS.html">XIMSS</a>. Для того, чтобы отправить событие, отправитель должен получить <em>описатель сигнала</em>.</p><p>Задача Сигналов принимает следующие события:</p><ul><li><p><code>decline</code></p><p>Это события заставляет задачу Сигналов прекратить обработку Сигнального Запроса и отвергнуть его с кодом ошибки 603 Отвергнуто.</p></li><li><p><code>fork</code></p><p>Данные этого события должны быть строкой или массивом строк. Сигнальный Запрос ответвляется на URI, задаваемые этими строками.</p></li><li><p><code>redirect</code></p><p>Аналогично <code>fork</code>, но все текущие &quot;ответвлённые&quot; Запросы прекращаются.</p></li></ul>',131)]))}const g=e(l,[["render",a]]);export{h as __pageData,g as default};
