import{_ as d,C as s,c as p,o as r,ag as n,j as t,a as e,G as a,w as i}from"./chunks/framework.jCcxW76o.js";const E=JSON.parse('{"title":"Инфраструктура Открытых Ключей (PKI)","description":"","frontmatter":{"legacyLink":"russian/PKI.html"},"headers":[],"relativePath":"russian/admin/sysadmin/PKI.md","filePath":"russian/admin/sysadmin/PKI.md"}'),u={name:"russian/admin/sysadmin/PKI.md"},c={action:"Null.html"},m={class:"settingsBox"},g={width:"100%"},S={class:"settingsBox"},h={width:"100%"};function b(A,l,I,C,v,M){const o=s("font");return r(),p("div",null,[l[12]||(l[12]=n(`<h1 id="инфраструктура-открытых-ключеи-pki" tabindex="-1">Инфраструктура Открытых Ключей (PKI) <a class="header-anchor" href="#инфраструктура-открытых-ключеи-pki" aria-label="Permalink to &quot;Инфраструктура Открытых Ключей (PKI)&quot;">​</a></h1><p>Обычные (&quot;классические&quot;) методы криптографии используют блоки данных, называемых &quot;секретные ключи&quot;. Информация, зашифрованная с использованием &quot;секретных ключей&quot; может быть расшифрована любым, кто знает метод шифрования и владеет &quot;секретным ключом&quot;. Такой тип криптографии называется симметричной криптографией.</p><p>Альтернативные методы криптографии базируются на использовании пары ключей - &quot;закрытого ключа&quot; и &quot;открытого ключа&quot;. Эти ключи должны создаваться вместе, с использованием специальных алгоритмов. Информация, зашифрованная &quot;закрытым ключом&quot;, может быть расшифрована любым, кто знает соответствующий &quot;открытый ключ&quot;, а любая информация, зашифрованная &quot;открытым ключом&quot;, может быть расшифрована только с использованием соответствующего &quot;закрытого ключа&quot;.<br> Инфраструктура Открытых Ключей (Public Key Infrastructure, PKI) является технологией, основывающейся на такой асимметричной криптографии.</p><h2 id="Terms" tabindex="-1">Терминология PKI <a class="header-anchor" href="#Terms" aria-label="Permalink to &quot;Терминология PKI {#Terms}&quot;">​</a></h2><ul><li><p><strong>Закрытый Ключ (Private Key)</strong></p><p>Блок данных (большое двоичное число), созданное с использованием алгоритмов PKI. Каждый из сторон, осуществляющих передачу информации безопасным образом, должна хранить свой Закрытый Ключ так, чтобы исключить к нему доступ посторонних. Этот ключ никогда не должен передаваться между сторонами, осуществляющими обмен информацией.</p></li><li><p><strong>Открытый Ключ (Public Key)</strong></p><p>Блок данных (большое двоичное число), созданный вместе с Закрытым Ключом. Каждая сторона, осуществляющая безопасные коммуникации, может и должна публично распространять свой Открытый Ключ. Изначально предполагается, что Открытый Ключ известен всем, в том числе и злоумышленникам. Открытые Ключи обычно распространяются в виде Сертификатов.</p></li><li><p><strong>Дайджест Данных (Data Digest)</strong></p><p>Относительно небольшой блок данных, вычисленный с применением к оригинальному блоку данных (обычно большего размера) специальных дайджест-функций (хэш-функций).</p></li><li><p><strong>Подпись Данных (Data Signature)</strong></p><p>Дайджест блока Данных, зашифрованный с использованием Закрытого Ключа Подписывающего.</p></li><li><p><strong>Подписанные Данные (Signed Data)</strong></p><p>Блок Данных, к которому прилагается Подпись этого блока. Сторона, получающая Подписанные Данные, используя Открытый Ключ Подписывающего может расшифровать Подпись и, сравнив получившийся Дайджест Данных с Дайджестом Данных, вычисленным самостоятельно, может убедиться, что блок данных не был изменён в процессе передачи.</p></li><li><p><strong>Сертификат (Certificate)</strong></p><p>Блок данных, содержащий имя владельца Сертификата (называемом так же Темой Сертификата), Открытый Ключ владельца, имя Издателя Сертификата, Серийный Номер Сертификата и некоторые дополнительные элементы данных. Такой блок данных подписывается Издателем Сертификата.<br> Сертификаты играют роль Цифровых идентификационных карт (удостоверений).</p></li><li><p><strong>Издатель (Issuer)</strong></p><p>Сторона, которая выпускает сертификаты для третьих лиц, подписывая их своим Закрытым Ключом Издателя. Издатели так же называются Центрами Сертификации (Удостоверяющими Центрами). Каждый сертификат, созданный определённым Издателем, имеет уникальный серийный номер.</p></li><li><p><strong>Доверенные Центры Сертификации (Trusted Authorities)</strong></p><p>Список, индивидуально ведущийся стороной, обменивающейся информацией. Каждый элемент списка содержит имя &quot;доверенного центра сертификации&quot; и его Открытый Ключ.<br> Когда сторона получает любой Сертификат, она может проверить, включён ли Издатель в список &quot;доверенных центров сертификации&quot; и с помощью Открытого Ключа этого &quot;доверенного центра сертификации&quot; проверить Подпись Сертификата.<br> Современные операционные системы позволяют пользователям безопасно вести базу данных Доверенных Центров Сертификации.</p></li><li><p><strong>Корневые Центры Сертификации (Root Authorities)</strong></p><p>Повсеместно признаваемые Центры Сертификации. Большинство современных операционных систем по умолчанию содержат несколько Корневых Центров Сертификации в базе данных Доверенных Центров Сертификации, что делает эти Корневые Центры Сертификации доверенными для всех пользователей этого компьютера, работающих в этой операционной системе.</p></li><li><p><strong>Цепочка Сертификаций (Authority Chain)</strong></p><p>Набор Издателей Сертификата для определённого Сертификата.<br> Некоторый Центр X может не быть широко распространён как &quot;доверенный&quot;, но его собственный Сертификат может быть выпущен более широко признаваемым Центром Y. В этом случае, Сертификаты, выпущенные X, не будут признаваться, но если эти Сертификаты посланы вместе с собственным Сертификатом Центра X, выпущенным Центром Y, то эти Сертификаты могут быть признаны всем сторонами, которые доверяют Центру Y.</p></li><li><p><strong>Само-Подписанный Сертификат (Self-Signed Certificate)</strong></p><p>Сертификат, выпущенный стороной самой для себя. Тема и Издатель такого Сертификата совпадают. Само-Подписанный Сертификат содержит Открытый Ключ стороны и подписан Закрытым Ключом этой же стороны.<br> Само-Подписанные Сертификаты могут быть доверенными только если другие стороны явно включили их в свои списки &quot;доверенных центров Сертификации&quot;.</p></li><li><p><strong>Многостороннее Шифрование (Multiparty Encryption)</strong></p><p>Метод шифрования, используемый для отправки данных нескольким сторонам с известными Сертификатами. Зашифрованные один раз сообщения могут быть независимо от других сторон расшифрованы любой стороной, которая обладает Закрытым Ключом, соответствующий одному из Сертификатов, используемых при шифровании.</p></li></ul><h2 id="DomainKeys" tabindex="-1">Установки PKI Домена <a class="header-anchor" href="#DomainKeys" aria-label="Permalink to &quot;Установки PKI Домена {#DomainKeys}&quot;">​</a></h2><p>В каждом Домене CommuniGate Pro есть свои собственные Установки PKI. Они включают в себя Закрытый Ключ, связанный с Доменом, и Сертификаты, содержащие Открытый Ключ.</p><p>Для изменения Установок PKI для какого-либо Домена, откройте через Веб Интерфейс Администратора страницу Установки Домена и нажмите на ссылку Безопасность. Появится страница с настройками PKI:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Услуги PKI Криптографии</b></td></tr><tr><td align="center"><select name="CertificateType"><option value="-1" selected="selected">по умолчанию(Test)</option><option value="0">Включено</option><option value="1">Выключено</option><option value="2">Test</option></select></td></tr></tbody></table></div></form><p>Эта опция позволяет вам выбрать режим PKI для этого Домена:</p><ul><li><p><code>Выключено</code></p><p>Если указана эта опция, то функции PKI для этого Домена выключены. Если указана эта опция, то все другие Установки PKI Домена игнорируются.</p></li><li><p><code>Test</code></p><p>Если указана эта опция, то для этого Домена будут использоваться Общий для Сервера Тестовый Закрытый Ключ и самоподписанный Тестовый Сертификат. Если эта опция указана, то вы не должны указывать другие Установки PKI Домена. Используйте этот режим только для тестовых целей.<br> Общий для Сервера Тестовый Сертификат содержит в поле Тема имя Главного Домена и <code>AO SBK</code> в поле Издатель. Этот Сертификат действителен в течение 30 дней с момента последнего перезапуска Сервера.</p></li><li><p><code>Включено</code></p><p>Если эта опция выбрана, активируются все другие Установки PKI Домена.</p></li></ul><h3 id="KeyGen" tabindex="-1">Назначение Закрытого Ключа <a class="header-anchor" href="#KeyGen" aria-label="Permalink to &quot;Назначение Закрытого Ключа {#KeyGen}&quot;">​</a></h3><p>Первоначально Домены CommuniGate Pro не имеют Закрытых Ключей. Вы должны ввести размер ключа и нажать на кнопку Сгенерировать Ключ для создания случайного Закрытого Ключа и назначения его этому Домену.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Закрытый Ключ</b></td></tr><tr><td align="CENTER">Размер Ключа:<select name="KeySize"><option value="0">Импортировать</option><option value="512" selected="selected">512</option><option value="1024">1024</option><option value="2048">2048</option><option>4096</option></select></td><td align="CENTER" rowspan="2"> <input name="GenKey" type="reset" value="Сгенерировать Ключ" class="button"></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>В зависимости от платформы, на которой работает сервер, может потребоваться несколько секунд для создания 2048-битового Ключа.</p></div><p>Только после назначения Закрытого Ключа на странице Безопасность появятся поля, связанные с Сертификатами.</p><p>Для того, чтобы создать Закрытый Ключ, вы можете использовать программы сторонних производителей (такие, как OpenSSL). Вы должны указать такой программе вывести Закрытый Ключ в <code>PEM формате</code> (как показано ниже).<br> Выберите пункт <code>Импортировать</code> в меню Размер Ключа и нажмите на кнопку Сгенерировать Ключ. Появится текстовое поле. Скопируйте Закрытый Ключ в PEM-формате (или в формате RSA или PKCS#8) в это текстовое поле, и нажмите на кнопку Сгенерировать Ключ:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Закрытый Ключ</b></td></tr><tr><td align="CENTER">Размер Ключа:<select name="KeySize"><option value="0" selected="selected">Импортировать</option><option value="512">512</option><option value="1024">1024</option><option value="2048">2048</option><option>4096</option></select></td><td align="CENTER"> <input name="GenKey" type="reset" value="Сгенерировать Ключ" class="button"></td></tr><tr><td align="center" colspan="2">Введите Закрытый Ключ (в PEM формате):<br><textarea name="PrivateKey" cols="65" rows="7">-----BEGIN RSA PRIVATE KEY-----
MIIBPAIBAAJBAKrbeqkuRk8VcRmWFmtP+LviMB3+6dizWW3DwaffznyHGAFwUJ/I
Tv0XtbsCyl3QoyKGhrOAy3RvPK5M38iuXT0CAwEAAQJAZ3cnzaHXM/bxGaR5CR1R
rD1qFBAVfoQFiOH9uPJgMaoAuoQEisPHVcZDKcOv4wEg6/TInAIXBnEigtqvRzuy
oQIhAPcgZzUq3yVooAaoov8UbXPxqHlwo6GBMqnv20xzkf6ZAiEAsP4BnIaQTM8S
mvcpHZwQJdmdHHkGKAs37Dfxi67HbkUCIQCeZGliHXFa071Fp06ZeWlR2ADonTZz
rJBhdTe0v5pCeQIhAIZfkiGgGBX4cIuuckzEm43g9WMUjxP/0GlK39vIyihxAiEA
mymehFRT0MvqW5xAKAx7Pgkt8HVKwVhc2LwGKHE0DZM=
-----END RSA PRIVATE KEY-----</textarea></td></tr></tbody></table></div></form><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Убедитесь, что импортируемый ключ не зашифрован паролем. Текст, первые строки в котором имеют примерно такой вид:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>-----BEGIN RSA PRIVATE KEY-----</span></span>
<span class="line"><span>Proc-Type: 4,ENCRYPTED</span></span>
<span class="line"><span>DEK-Info: DES-CBC,90C96A721C4E4B0B</span></span>
<span class="line"><span></span></span>
<span class="line"><span>GzLyio+Or3zXm1N7ILWlYDsR6cgPlzHomAxi6aeUthl4lSqBHaqMlh+/76I/6sNx</span></span>
<span class="line"><span>.................</span></span></code></pre></div><p>свидетельствует, что Закрытый Ключ зашифрован и не может быть импортирован на Сервер.</p></div><p>Если Закрытый Ключ установлен корректно, и этот Ключ может использоваться для асимметричной криптографии, вы увидите следующую панель:</p>`,20)),t("form",c,[t("div",m,[t("table",g,[t("tbody",null,[l[2]||(l[2]=t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Закрытый Ключ")])],-1)),l[3]||(l[3]=t("tr",null,[t("td",{align:"right"},"Размер:"),t("td",null,"512 бит"),t("td",{rowspan:"2"},[e(" "),t("input",{name:"RemoveKey",value:"Удалить Ключи и Сертификат",class:"button",type:"reset"})])],-1)),t("tr",null,[l[1]||(l[1]=t("td",{align:"right"},"Тест Ключа:",-1)),t("td",null,[a(o,{color:"GREEN"},{default:i(()=>l[0]||(l[0]=[t("i",null,"Verification String is OK",-1)])),_:1})])])])])])]),l[13]||(l[13]=n(`<p>Если в поле Тест Ключа содержится указание на ошибку, импортируемый Закрытый Ключ не может использоваться в асимметричной криптографии.</p><p>Используйте кнопку Удалить Ключи и Сертификат, чтобы удалить введённый Закрытый Ключ Домена. Так как Сертификат Домена может использоваться совместно с одним и только одним Закрытым Ключом, то он станет бесполезным, когда вы удалите Закрытый Ключ; таким образом существующий Сертификат Домена также будет удалён.</p><h3 id="CertGen" tabindex="-1">Назначение Сертификата <a class="header-anchor" href="#CertGen" aria-label="Permalink to &quot;Назначение Сертификата {#CertGen}&quot;">​</a></h3><p>Для поддержи функций Инфраструктуры Открытых Ключей, Домен должен иметь Сертификат.</p><p>Имя Сертификата Домена (часть Имени-Идентификатора поля Тема Сертификата) должно соответствовать имени домена, используемого клиентскими приложениями.<br> Если Домен CommuniGate Pro имеет Псевдонимы Домена, попытки соединения с Сервером с использованием Псевдонима Домена приведут к появлению предупреждения на компьютере клиента, уведомляющего пользователя о несоответствии в именах. Так как Сертификат может содержать только одно имя, выбирайте имя (реальное имя Домена или один из Псевдонимов Домена), которое будут использовать ваши пользователи в своих клиентских приложениях. Если имя вашего Домена CommuniGate Pro <code>company.dom</code>, и это имя домена не имеет A-записи в DNS, но Домен имеет псевдоним <code>mail.company.dom</code>, который, в свою очередь, имеет A-запись в DNS, указывающую на Сервер CommuniGate Pro, то ваши пользователи будут использовать имя <code>mail.company.dom</code> в настройках своих клиентских приложений и в URL Веб Интерфейса Пользователя, так что Сертификат Домена должен быть выпущен на имя <code>mail.company.dom</code>, а не на <code>company.dom</code>.</p><p>Вы так же можете использовать &quot;шаблон подстановки&quot; имён домена для ваших сертификатов. Если имя Домена имеет минимум 2 компоненты, то меню Имя-Идентификатор будет содержать &quot;шаблон подстановки&quot; имени Домена: первая компонента имени Домена будет заменена символом звёздочка (<code>*</code>). Если имя Домена состоит из только двух компонент, то компонент звёздочка будет добавлен для формирования трехкомпонентного имени.</p><p>Для создания Сертификата, заполните все поля в таблице Атрибутов Сертификата:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Генератор Сертификатов</b></td></tr><tr><td align="right">Имя-Идентификатор:</td><td><select name="cn"><option value="d1.communigatepro.ru" selected="selected">d1.communigatepro.ru</option><option value="myalias.dom">myalias.dom</option><option value="*.communigatepro.ru">*.communigatepro.ru</option></select></td></tr><tr><td align="right">Альтернативное Имя:</td><td><input name="SAN" value="d1.communigatepro.ru, d2.communigatepro.ru" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Страна:</td><td><input name="c" value="US" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Область:</td><td><input name="st" value="CA" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Город:</td><td><input name="l" value="Sausalito" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Организация:</td><td><input name="o" value="ACME Yacht Rentals, Inc." size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Подразделение:</td><td><input name="ou" value="On-line Services" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Контакт:</td><td><input name="contact" value="bill@domain.company" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Подпись:</td><td><select name="HashName"><option value="Default" selected="selected">по умолчанию(SHA1)</option><option value="MD5">MD5</option><option value="SHA1">SHA1</option><option value="SHA2">SHA2</option></select></td></tr><tr align="center"><td><input name="GenTemp" value="Создать Само-Подписанный" class="button" type="reset"></td><td><input name="GenCSR" value="Создать Запрос на Подписание" class="button" type="reset"></td></tr></tbody></table></div></form><ul><li><p><code>Имя-Идентификатор</code></p><p>Когда Сертификат посылается клиентскому приложению, приложение проверяет соответствие Имени-Идентификатора Сертификата с именем, указанным пользователем в URL и/или в настройках почтовой программы.</p></li><li><p><code>Контакт</code></p><p>Это поле должно содержать корректный адрес электронной почты; этот адрес не обязательно должен быть в Домене CommuniGate Pro.</p></li></ul><p>Все другие поля являются необязательными для заполнения.</p><p>Для того, чтобы получить Сертификат из внешнего источника, (из &quot;доверенного центра сертификации&quot;), нажмите кнопку &quot;Создать Запрос на Подписание&quot;. Появится текстовое поле, содержащее CSR (Запрос на Подписание Сертификата) в PEM-формате:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Генератор Сертификатов</b></td></tr><tr><td align="right">Имя-Идентификатор:</td><td><select name="cn"><option value="d1.communigatepro.ru" selected="selected">d1.communigatepro.ru</option><option value="myalias.dom">myalias.dom</option><option value="*.communigatepro.ru">*.communigatepro.ru</option></select></td></tr><tr><td align="right">Страна:</td><td><input name="c" value="US" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Область:</td><td><input name="st" value="CA" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Город:</td><td><input name="l" value="Sausalito" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Организация:</td><td><input name="o" value="ACME Yacht Rentals, Inc." size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Подразделение:</td><td><input name="ou" value="On-line Services" size="30" maxlength="200" type="text"></td></tr><tr><td align="right">Контакт:</td><td><input name="contact" value="bill@domain.company" size="30" maxlength="200" type="text"></td></tr><tr align="center"><td><input name="GenTemp" value="Создать Само-Подписанный" class="button" type="reset"></td><td><input name="GenCSR" value="Создать Запрос на Подписание" class="button" type="reset"></td></tr><tr><th colspan="2">Введите Сертификат (в PEM формате)</th></tr><tr><td colspan="2" align="center"><textarea cols="65" rows="10">-----BEGIN CERTIFICATE REQUEST-----
MIIBZTCCAQ8CAQAwgakxCzAJBgNVBAYTAlVTMQswCQYDVQQIEwJDQTESMBAGA1UE
BxMJU2F1c2FsaXRvMSEwHwYDVQQKExhBQ01FIFlhY2h0IFJlbnRhbHMsIEluYy4x
GTAXBgNVBAsTEE9uLWxpbmUgU2VydmljZXMxFzAVBgNVBAMTDmQxLnN0YWxrZXIu
Y29tMSIwIAYJKoZIhvcNAQkBFhNiaWxsQGRvbWFpbi5jb21wYW55MFwwDQYJKoZI
hvcNAQEBBQADSwAwSAJBAKrbeqkuRk8VcRmWFmtP+LviMB3+6dizWW3DwaffznyH
GAFwUJ/ITv0XtbsCyl3QoyKGhrOAy3RvPK5M38iuXT0CAwEAAaAAMA0GCSqGSIb3
DQEBBAUAA0EABFysKDutO/ZF16Sp7+LL3IcjUb29xlvZSnBXYsD/qWKqUF4gzfch
4Qyxci6ynsh7HNjdJBFdFyO+J2ywXZilYg==
-----END CERTIFICATE REQUEST-----</textarea><br><i>передайте этот запрос Центру Сертификации (Удостоверяющему Центру) и вставьте их ответ ниже</i></td></tr><tr><th colspan="2">Введите Сертификат (в PEM формате)</th></tr><tr><td colspan="2" align="center"><textarea name="Certificate" rows="10" cols="72" class="settingsTextarea"></textarea><br><input name="SetCert" value="Установить Сертификат" class="button" type="reset"></td></tr></tbody></table></div></form><p>Скопируйте текст CSR и передайте его в выбранный вами Центр Сертификации (CA). Вы можете передать его по электронной почте или через специальную Веб форму на сайте CA. Центр Сертификации должен вернуть вам подписанный Сертификат в PEM-формате. Введите Сертификат в поле внизу и нажмите кнопку Установить Сертификат.</p><p>Если Сертификат принимается, то отображается информация о нём:</p>`,14)),l[14]||(l[14]=t("form",{action:"Null.html"},[t("div",{class:"settingsBox"},[t("table",{width:"100%"},[t("tbody",null,[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Сертификат Домена")])]),t("tr",{valign:"top"},[t("th",{align:"right"},[t("b",null,"Кому Выдан:")]),t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",null,"Страна"),t("td",null,"US")]),t("tr",null,[t("td",null,"Область"),t("td",null,"CA")]),t("tr",null,[t("td",null,"Город"),t("td",null,"Sausalito")]),t("tr",null,[t("td",null,"Организация"),t("td",null,"ACME Yacht Rentals, Inc.")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"On-line Services")]),t("tr",null,[t("td",null,[t("i",null,"Имя-Идентификатор")]),t("td",null,"d1.communigatepro.ru")]),t("tr",null,[t("td",null,"Контакт"),t("td",null,"bill@domain.company")])])])])]),t("tr",{valign:"top"},[t("th",{align:"right"},[t("b",null,"Кем Выдан:")]),t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",null,"Страна"),t("td",null,"US")]),t("tr",null,[t("td",null,"Область"),t("td",null,"CA")]),t("tr",null,[t("td",null,"Город"),t("td",null,"Sausalito")]),t("tr",null,[t("td",null,"Организация"),t("td",null,"ACME Yacht Rentals, Inc.")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"On-line Services")]),t("tr",null,[t("td",null,[t("i",null,"Имя-Идентификатор")]),t("td",null,"d1.communigatepro.ru")]),t("tr",null,[t("td",null,"Контакт"),t("td",null,"bill@domain.company")])])])])]),t("tr",{valign:"top"},[t("th",{align:"right"},"Серийный Номер:"),t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",null,"89AB673940123456")])])])])]),t("tr",{valign:"top"},[t("th",{align:"right"},"Действителен:"),t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",{align:"right"},"От:"),t("td",null,"06-Нов-07"),t("td",{align:"right"},"До:"),t("td",null,"05-Нов-09")])])])])]),t("tr",null,[t("td",{colspan:"2",align:"center"},[t("input",{name:"RefreshCert",value:"Обновить Само-Подписанный",class:"button",type:"reset"}),e("  "),t("input",{name:"RemoveCert",value:"Удалить Сертификат",class:"button",type:"reset"})])])])])])],-1)),l[15]||(l[15]=n(`<p>Панель с информацией о Сертификате показывает имя Издателя Сертификата (Центра Сертификации), Тему Сертификата (данные, которые вы ввели и имя домена), серийный номер Сертификата и срок его действия.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Введённый Закрытый Ключ будет использоваться для безопасного обмена информацией ТОЛЬКО при условии, что опция Услуги PKI Криптографии имеет значение <code>Включено</code>.</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>В Сертификате в данных &quot;Темы&quot; содержится имя Домена или Псевдонима Домена.</p></div><p>Когда вы переименовываете Домен в CommuniGate Pro, имя домена в Сертификате Домена не изменяется, и клиентские приложения могут начать предупреждать пользователей о несоответствии в имени.</p><p>Для того, чтобы удалить Сертификат Домена, нажмите на кнопку Удалить Сертификат.</p><h3 id="CAGen" tabindex="-1">Назначение Цепочки Сертификации <a class="header-anchor" href="#CAGen" aria-label="Permalink to &quot;Назначение Цепочки Сертификации {#CAGen}&quot;">​</a></h3><p>Если Издатель Сертификата известен программному обеспечению пользователя (почтовым программам и браузерам), то, когда клиент получает от Сервера Сертификат, предупреждающее сообщение на экране пользователя не появляется. Во многих случаях, &quot;Доверенный Центр Сертификации&quot; не выпускает сертификаты самостоятельно. Вместо этого, он делегирует право выпускать сертификату какому-нибудь третьему Центру Сертификации (Удостоверяющему Центру). Когда ваш Сервер использует Сертификат, выданный таким Центром Сертификации, Сервер так же должен предоставлять Сертификат этого Центра Сертификации, выданный &quot;Доверенным Центром Сертификации&quot;. Программное обеспечение клиента проверит сначала ваш Сертификат, обнаружит, что эмитент вашего Сертификата не является &quot;Доверенным Центром Сертификации&quot;, и затем проверит дополнительный Сертификат(ы), которые предоставил Сервер. Если такой дополнительный Сертификат выпущен &quot;Доверенным Центром Сертификации&quot;, и он подтверждает эмитента вашего Сертификата Домена, то ваш Сертификат принимается без предупреждений.</p><p>Когда вы получаете Сертификат из Центра Сертификации, который не указан в списке &quot;Доверенных Центров Сертификации&quot; в клиентском программном обеспечении, то этот промежуточный Центр Сертификации так же должен предоставить вам свой собственный Сертификат, подписанный &quot;Доверенным Центром Сертификации&quot;. Этот Сертификат должен быть в таком же PEM-формате, как и ваш Сертификат Домена:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Цепочка Сертификации (Необязательно)</b></td></tr><tr><td colspan="2" align="center"><textarea name="CAChain" cols="74" rows="12">-----BEGIN CERTIFICATE-----
MIIEMTCCA5qgAwIBAgIQI2yXHivGDQv5dGDe8QjDwzANBgkqhkiG9w0BAQIFADBfMQswCQYD
VQQGEwJVUzEXMBUGA1UEChMOVmVyaVNpZ24sIEluYy4xNzA1BgNVBAsTLkNsYXNzIDMgUHVi
bGljIFByaW1hcnkgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNOTcwNDE3MDAwMDAwWhcN
MDQwMTA3MjM1OTU5WjCBujEfMB0GA1UEChMWVmVyaVNpZ24gVHJ1c3QgTmV0d29yazEXMBUG
A1UECxMOVmVyaVNpZ24sIEluYy4xMzAxBgNVBAsTKlZlcmlTaWduIEludGVybmF0aW9uYWwg
U2VydmVyIENBIC0gQ2xhc3MgMzFJMEcGA1UECxNAd3d3LnZlcmlzaWduLmNvbS9DUFMgSW5j
b3JwLmJ5IFJlZi4gTElBQklMSVRZIExURC4oYyk5NyBWZXJpU2lnbjCBnzANBgkqhkiG9w0B
AQEFAAOBjQAwgYkCgYEA2IKA6NYZAn0fhRg5JaJlK+G/1AXTvOY2O6rwTGxbtueqPHNFVbLx
veqXQu2aNAoV1Klc9UAl3dkHwTKydWzEyruj/lYncUOqY/UwPpMo5frxCTvzt01OOfdcSVq4
wR3Tsor+cDCVQsv+K1GLWjw6+SJPkLICp1OcTzTnqwSye28CAwEAAaOCAZAwggGMMA8GA1Ud
EwQIMAYBAf8CAQAwCwYDVR0PBAQDAgEGMBEGCWCGSAGG+EIBAQQEAwIBBjAgBgNVHSUEGTAX
BgpghkgBhvhFAQgBBglghkgBhvhCBAEwggE1BgNVHSAEggEsMIIBKDCCASQGC2CGSAGG+EUB
BwEBMIIBEzAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cudmVyaXNpZ24uY29tL0NQUzCB5gYI
KwYBBQUHAgIwgdkwFRYOVmVyaVNpZ24sIEluYy4wAwIBARqBv1ZlcmlTaWduJ3MgQ2VydGlm
aWNhdGlvbiBQcmFjdGljZSBTdGF0ZW1lbnQsIHd3dy52ZXJpc2lnbi5jb20vQ1BTLCBnb3Zl
cm5zIHRoaXMgY2VydGlmaWNhdGUgJiBpcyBpbmNvcnBvcmF0ZWQgYnkgcmVmZXJlbmNlIGhl
cmVpbi4gU09NRSBXQVJSQU5USUVTIERJU0NMQUlNRUQgJiBMSUFCSUxJVFkgTFRELiAoYykx
OTk3IFZlcmlTaWduMA0GCSqGSIb3DQEBAgUAA4GBALiMmMMrSPVyzWgNGrN0Y7uxWLaYRSLs
EY3HTjOLYlohJGyawEK0Rak6+2fwkb4YH9VIGZNrjcs3S4bmfZv9jHiZ/4PC/NlVBp4xZkZ9
G3hg9FXUbFXIaWJwfE22iQYFm8hDjswMKNXRjM1GUOMxlmaSESQeSltLZl5lVR5fN5qu
-----END CERTIFICATE-----</textarea><br><input name="SetCA" value="Установить Цепочку" class="button" type="reset"></td></tr></tbody></table></div></form><p>Цепочка Центров Сертификации (Удостоверяющих Центров) может включать несколько сертификатов: первый удостоверяет эмитента Сертификата Домена, который вы ввели, но сам может быть выпущен некоторым промежуточным центром сертификации. Следующий Сертификат удостоверяет этот промежуточный Центр Сертификации, и так далее. Последний Сертификат в цепочке должен быть выдан каким-нибудь центром сертификации, &quot;известным&quot; клиентскому программному обеспечению - обычно, каким-нибудь Корневым Центром Сертификации.</p><p>Если ваша Цепочка Центров Сертификации содержит несколько отдельных Сертификатов в PEM-формате, введите их всех в поле Цепочка Сертификации (Необязательно). Сертификат, выданный Корневым Центром Сертификации, должен быть последним в списке.</p><p>Нажмите на кнопку Установить Цепочку для назначения Домену Цепочки Сертификации. Если все Сертификаты в цепочке имеют правильный формат и успешно декодированы, то показывается список Цепочки Сертификации:</p>`,12)),l[16]||(l[16]=t("form",{action:"Null.html"},[t("div",{class:"settingsBox"},[t("table",{width:"100%"},[t("tbody",null,[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Цепочка Сертификации (Необязательно)")])]),t("tr",{align:"left"},[t("th",null,"Кому Выдан:"),t("th",null,"Кем Выдан:"),t("th",null,"От"),t("th",null,"До")]),t("tr",{valign:"top"},[t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",null,"Организация"),t("td",null,"VeriSign Trust Network")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"VeriSign, Inc.")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"VeriSign International Server CA - Class 3")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"www.verisign.com/CPS Incorp.by Ref. LIABILITY LTD.(c)97 VeriSign")])])])]),t("td",null,[t("table",{class:"settingsBox",width:"100%"},[t("tbody",null,[t("tr",null,[t("td",null,"Страна"),t("td",null,"US")]),t("tr",null,[t("td",null,"Организация"),t("td",null,"VeriSign, Inc.")]),t("tr",null,[t("td",null,"Подразделение"),t("td",null,"Class 3 Public Primary Certification Authority")])])])]),t("td",{align:"center"},"17-Апр-97"),t("td",{align:"center"},"08-Янв-04")]),t("tr",null,[t("td",{colspan:"4",align:"center"},[t("input",{name:"RemoveChain",value:"Удалить Цепочку",class:"button",type:"reset"})])])])])])],-1)),l[17]||(l[17]=n(`<div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>CommuniGate Pro проверяет только формат каждого Сертификата в цепочке. Он не проверяет, например, что каждый Сертификат действительно удостоверяет эмитента предыдущего Сертификата, или что последний Сертификат выдан Корневым Центром Сертификации.</p></div><p>После того, как Цепочка Сертификации установлена, она отправляется клиентам вместе с Сертификатом Домена.</p><p>Нажмите на кнопку Удалить Цепочку для удаления Цепочки Сертификации из Установок Безопасности Домена.</p><h2 id="Install" tabindex="-1">Использование Само-Подписанных Сертификатов <a class="header-anchor" href="#Install" aria-label="Permalink to &quot;Использование Само-Подписанных Сертификатов {#Install}&quot;">​</a></h2><p>Если вы не хотите использовать внешний Центр Сертификации, то вы можете создать Само-Подписанный Сертификат.<br> Нажмите на кнопку Создать Само-Подписанный и Сервер CommuniGate Pro создаст для вас Само-Подписанный Сертификат: издателем будет то лицо, которое вы указали, и Сертификат будет подписан Закрытым Ключом Домена. Если Домен имеет Само-Подписанный Сертификат, клиентские приложения будут предупреждать пользователя, что используемый сервер представил сертификат, &quot;выпущенный неизвестным центром&quot;. Пользователи могут <a href="#Install">&quot;установить&quot;</a> самоподписанные сертификаты, чтобы избежать появления этих предупреждений.</p><p>Когда клиентское приложение получает Сертификат, и его издатель не включён в их список Доверенных Центров Сертификации, приложение может показывать предупреждения или отказаться принять Сертификат.</p><p>Ваши пользователи могут &quot;установить&quot; ваш Сертификат Домена в свои списки Доверенных Центров Сертификации. После установки, Сертификат становится &quot;доверенным&quot;. Для некоторых программ (такие, как Mac-версии Microsoft Outlook и Outlook Express), установка &quot;недоверенного&quot; Сертификата является единственным способом использования этого Сертификата для безопасного обмена информацией.</p><p>Для установки Сертификата Домена, пользователь должен использовать браузер и открыть через <a href="./../access/WebUser.html">Веб Интерфейс Пользователя</a> для требуемого Домена страницу входа. Если в Домене включены Сертификаты, то появится ссылка на Сертификат Безопасности. Пользователь должен перейти по этой ссылке для загрузки Сертификата Домена и &quot;открыть&quot; его. Браузер должен позволить пользователю проверить Сертификат и установить его в список Доверенных Центров Сертификации.</p><p>Если в Домене есть Само-Подписанный Сертификат, то на странице Веб Администрирования появляется кнопка &quot;Обновить Само-Подписанный&quot;. Нажмите на эту кнопку что создать новый Само-Подписанный Сертификат с тем же самым серийным номером, но с новым сроком действия.</p><h2 id="Trusted" tabindex="-1">Доверенные Корневые Сертификаты <a class="header-anchor" href="#Trusted" aria-label="Permalink to &quot;Доверенные Корневые Сертификаты {#Trusted}&quot;">​</a></h2><p>Сервер CommuniGate Pro может проверять действительность Сертификатов, которые ему предоставляют. Например, <a href="./WebSMIME.html">Веб Интерфейс Пользователя</a> проверяет Сертификаты, когда показывает подписанные сообщения.</p><p>Сертификат считается действительным, если:</p><ul><li>он совпадает с одним из Доверенных Сертификатов, или</li><li>он выдан одним из обладателей Доверенных Сертификатов.</li></ul><p>Есть несколько наборов Доверенных Сертификатов:</p><ul><li>Встроенные доверенные Сертификаты: эти сертификаты устанавливаются вместе с Сервером CommuniGate Pro, и обновляются вместе с обновлением Сервера.</li><li>Общесерверные и общекластерные Доверенные Сертификаты.</li><li>Общие для Домена Доверенные Сертификаты.</li></ul><p>Когда выполняется любая PKI-операция для какого-нибудь Домена (или для определённого Пользователя в этом Домене), проверяются следующие Доверенные Сертификаты:</p><ul><li>Доверенные Сертификаты Домена</li><li>Общекластерные Доверенные Сертификаты, если Домен обслуживается в Кластере и общесерверные Доверенные Сертификаты, если Домен не обслуживается в Кластере</li><li>встроенные Доверенные Сертификаты</li></ul><p>Когда PKI-операция выполняется для нужд самой Системы (например, при установке исходящего TLS-соединения), проверяются следующие Доверенные Сертификаты:</p><ul><li>Общесерверные Доверенные Сертификаты</li><li>Общекластерные Доверенные Сертификаты</li><li>встроенные Доверенные Сертификаты</li></ul><p>Используйте Веб Интерфейс Администратора для обновления Общсерверных и Общекластерных Доверенных Сертификатов. Откройте страницу Безопасность в разделе Пользователи. Откроется страница Доверенные Сертификаты:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><th> </th><th>Кому Выдан:</th><th>Серийный Номер</th><th>От</th><th>До</th></tr><tr><td></td><td>RSA Data Security, Inc.</td><td><span style="font-size:-2;font-family:monospace;">02AD667E4E45FE5E576F3C98195EDDC0</span></td><td>09-Ноя-94</td><td>08-Янв-10</td></tr><tr><td></td><td>Thawte Personal Freemail CA</td><td><span style="font-size:-2;font-family:monospace;">00</span></td><td>01-Янв-96</td><td>01-Янв-21</td></tr><tr><td></td><td>Thawte Personal Basic CA</td><td><span style="font-size:-2;font-family:monospace;">00</span></td><td>01-Янв-96</td><td>01-Янв-21</td></tr><tr><td><input type="checkbox" value="0" name="Cert"></td><td>My Company CA</td><td><span style="font-size:-2;font-family:monospace;">010256FF</span></td><td>01-Янв-96</td><td>01-Янв-21</td></tr></tbody><tfoot><tr><td colspan="5"><input name="Remove" value="Удалить Помеченные" class="button" type="reset"></td></tr></tfoot></table></div></form><p>Включённые в показываемый список Доверенные Сертификаты имеют слева кнопку-флажок. Для удаление выбранных Сертификатов, отметьте флажок и нажмите кнопку Удалить Помеченные.</p><p>В дополнение к показанным Сертификатам, Общие для Домена страницы показывают встроенные Доверенные Сертификаты и Общесерверные Доверенные Сертификаты (или Общекластерные для Распределенных Доменов).<br> Общесерверные и Общекластерные страницы с Доверенными Сертификатами показывают встроенные Доверенные Сертификаты.<br> Рядом с этими дополнительными сертификатами нет кнопки-флажка.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Введите Сертификат (в PEM формате)</b></td></tr><tr><td align="center"><textarea name="Certificate" cols="72" rows="10">-----BEGIN CERTIFICATE-----
MIIDLTCCApagAwIBAgIBADANBgkqhkiG9w0BAQQFADCB0TELMAkGA1UEBhMCWkEx
FTATBgNVBAgTDFdlc3Rlcm4gQ2FwZTESMBAGA1UEBxMJQ2FwZSBUb3duMRowGAYD
VQQKExFUaGF3dGUgQ29uc3VsdGluZzEoMCYGA1UECxMfQ2VydGlmaWNhdGlvbiBT
ZXJ2aWNlcyBEaXZpc2lvbjEkMCIGA1UEAxMbVGhhd3RlIFBlcnNvbmFsIEZyZWVt
YWlsIENBMSswKQYJKoZIhvcNAQkBFhxwZXJzb25hbC1mcmVlbWFpbEB0aGF3dGUu
Y29tMB4XDTk2MDEwMTAwMDAwMFoXDTIwMTIzMTIzNTk1OVowgdExCzAJBgNVBAYT
AlpBMRUwEwYDVQQIEwxXZXN0ZXJuIENhcGUxEjAQBgNVBAcTCUNhcGUgVG93bjEa
MBgGA1UEChMRVGhhd3RlIENvbnN1bHRpbmcxKDAmBgNVBAsTH0NlcnRpZmljYXRp
b24gU2VydmljZXMgRGl2aXNpb24xJDAiBgNVBAMTG1RoYXd0ZSBQZXJzb25hbCBG
cmVlbWFpbCBDQTErMCkGCSqGSIb3DQEJARYccGVyc29uYWwtZnJlZW1haWxAdGhh
d3RlLmNvbTCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA1GnX1LCUZFtx6UfY
DFG26nKRsIRefS0Nj3sS34UldSh0OkIsYyeflXtL734Zhx2G6qPduc6WZBrCFG5E
rHzmj+hND3EfQDimAKOHePb5lIZererAXnbr2RSjXW56fAylS1V/Bhkpf56aJtVq
uzgkCGqYx7Hao5iR/Xnb5VrEHLkCAwEAAaMTMBEwDwYDVR0TAQH/BAUwAwEB/zAN
BgkqhkiG9w0BAQQFAAOBgQDH7JJ+Tvj1lqVnYiqk8E0RYNBvjWBYYawmu1I1XAjP
MPuoSpaKH2JCI4wXD/S6ZJwXrEcp352YXtJsYHFcoqzceePnbgBHH7UNKOgCneSa
/RP0ptl8sfjcXyMmCZGAc9AUG95DqYMl8uacLxXK/qarigd1iwzdUYRr5PjRznei
gQ==
-----END CERTIFICATE-----</textarea><br><br><input name="Create" value="Установить Сертификат" class="button" type="reset"></td></tr></tbody></table></div></form><p>Для того, чтобы добавить Сертификат, введите данные Сертификата в PEM-формате в текстовое поле и нажмите кнопку Установить Сертификат. В показываемом списке должен появиться новый Сертификат.</p><h2 id="TLS" tabindex="-1">Безопасные Соединения SSL/TLS <a class="header-anchor" href="#TLS" aria-label="Permalink to &quot;Безопасные Соединения SSL/TLS {#TLS}&quot;">​</a></h2><p>TLS (Безопасность Уровня Транспорта) протокол - это PKI-приложение, используемое для обеспечения безопасности и целостности данных, передаваемых между сторонами в процессе осуществления коммуникации. Стороны используют PKI-шифрование для безопасного обмена данными, являющимися &quot;секретными ключами&quot;, а затем все данные, передаваемые между сторонами, шифруются с использованием этих &quot;секретных ключей&quot;. Более ранняя версия TLS-протокола называлась SSL-протокол (протокол безопасных соединений).</p><p>Сервер CommuniGate Pro поддерживает SSL/TLS соединения для всех сервисов и модулей, использующих TCP. Безопасные соединения могут устанавливаться двумя способами:</p><ul><li>Клиентское приложение использует специальный порт для соединения с Сервером и начинает устанавливать TLS (зашифрованное) соединение сразу после установления TCP-соединения на этот порт. Этот метод используется всеми браузерами, при задании URL вида <code>https://</code>.<br> Этот метод используется также, когда в SIP-клиенте активирована опция &quot;TLS-транспорт&quot;.<br> Некоторые почтовые клиенты используют её для POP, IMAP, LDAP и (редко) SMTP соединений.<br> Для поддержки таких клиентов, настройте <a href="./../network/Listener.html">Приёмники</a> для HTTP, SIP, POP, IMAP, SMTP и LDAP модулей: Приёмники должны принимать TCP-соединения на специальные порты (смотрите правильные Безопасные Номера Портов в описаниях модулей) и опция Начальный SSL/TLS должна быть включена для этих портов.</li><li>Клиентское приложение использует стандартный порт для связи с Сервером, и затем передаёт специальную команду (обычно называемую STARTTLS или STLS) через установленное незащищенное TCP-соединение. Когда Сервер получает такую команду он начинает устанавливать безопасное соединение. Для поддержки таких клиентов вы не должны настраивать дополнительные порты в модуле Приёмники.</li></ul><p>Обычно Сертификаты для SSL/TLS коммуникаций могут быть назначены только для таких <a href="./../objects/Domains.html">Доменов</a> CommuniGate Pro, которые имеют минимум один назначенный сетевой (IP) адрес. Это ограничение происходит из-за дизайна TLS-протокола, используемого сегодня: когда клиентское приложение хочет инициировать безопасное соединение, у Сервера нет информации о Домене, с которым хочет соединиться клиент. Сервер знает только, на какой местный IP-адрес обратился клиент, и поэтому он открывает тот Домен, которому назначен этот IP-адрес, и использует PKI Установки именно этого Домена.</p><p>Исключением из этого правила является XMPP протокол. До того, как XMPP клиент посылает команду <code>starttls</code>, он явно указывает имя требуемого домена в данных <code>&lt;stream&gt;</code>, и таким образом, Сервер может инициировать TLS-сессию с Доменом, который не имеет назначенного сетевого адреса.</p><p>Чтобы настроить Общесерверные параметры работы с SSL/TLS, используйте Веб Интерфейс Администратора. Откройте в области Установки страницу Общее, затем откройте страницу Прочее:</p>`,32)),l[18]||(l[18]=t("form",{action:"Null.html"},[t("div",{class:"settingsBox"},[t("table",{width:"100%"},[t("tbody",{style:{display:"table",width:"100%"}},[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Сессии TLS")])]),t("tr",null,[t("td",{align:"right"},"Уровень Журнала:"),t("td",null,[t("select",{name:"TLSLogLevel"},[t("option",{value:"0"},"Катастрофы"),t("option",{value:"1"},"Сбои"),t("option",{value:"2",selected:"selected"},"Основное"),t("option",{value:"3"},"Проблемы"),t("option",{value:"4"},"Подробности"),t("option",{value:"5"},"Всё")])]),t("td",null,[t("input",{name:"TLSProcessDomainNames",value:"1",type:"checkbox",checked:"checked"}),e("Обрабатывать Имя адресуемого Домена ")])]),t("tr",null,[t("td",{align:"right"},"Время жизни:"),t("td",null,[t("select",{name:"TLSTimeToLive"},[t("option",{value:"15"},"15 сек"),t("option",{value:"30",selected:"selected"},"30 сек"),t("option",{value:"60"},"минуту"),t("option",{value:"120"},"2 мин"),t("option",{value:"180"},"3 мин"),t("option",{value:"300"},"5 мин"),t("option",{value:"600"},"10 мин"),t("option",{value:"900"},"15 мин"),t("option",{value:"1800"},"30 мин"),t("option",{value:"3600"},"час"),t("option",{value:"7200"},"2 час."),t("option",{value:"10800"},"3 час."),t("option",{value:"21600"},"6 час."),t("option",{value:"43200"},"12 час."),t("option",{value:"86400"},"день"),t("option",{value:"172800"},"2 дня"),t("option",{value:"259200"},"3 дня"),t("option",{value:"604800"},"неделю"),t("option",{value:"864000"},"10 дней"),t("option",{value:"1209600"},"2 недели"),t("option",{value:"2678400"},"месяц")])]),t("td",null,[t("input",{name:"TLSAbortOnWrongCert",value:"1",type:"checkbox"}),e("Отсоединяться получив неверный Сертификат ")])]),t("tr",null,[t("td",{align:"right"},"Mинимальная Версия:"),t("td",null,[t("select",{name:"TLSMinVersion"},[t("option",{value:"0"},"SSLv3"),t("option",{value:"1",selected:"selected"},"TLSv1.0"),t("option",{value:"2"},"TLSv1.1"),t("option",{value:"3"},"TLSv1.2"),t("option",{value:"4"},"TLSv1.3")])])]),t("tr",null,[t("td",{colspan:"1"}," ")]),t("tr",null,[t("td",{class:"settingsBox",width:"100%",colspan:"4"},[t("table",{width:"80%"},[t("tbody",{style:{display:"table",width:"100%"}},[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Настройки шифрования")])]),t("tr",null,[t("td",{align:"right"},"Текущий Список Шифров:"),t("td",null,[t("div",{style:{"word-wrap":"break-word",width:"400px"}},"DEFAULT")])]),t("tr",null,[t("td",{align:"right"},"Текущий Наборы Шифров:"),t("td",null,[t("div",{style:{"word-wrap":"break-word",width:"400px"}},"TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256")])]),t("tr",null,[t("td",{align:"right"},"Набор шифрования:"),t("td",null,[t("select",{name:"OpenSSLCipherSet"},[t("option",{value:"0"},"Все доступные"),t("option",{value:"1",selected:"selected"},"Стандартный"),t("option",{value:"2"},"Пользовательский")])])]),t("tr",{valign:"top"},[t("td",{align:"right"},"Пользовательский Список Шифров:"),t("td",{colspan:"3"},[t("textarea",{style:{"font-size":"9pt"},name:"OpenSSLCustomCipherList",rows:"2",cols:"60"},"DEFAULT@SECLEVEL=2")])]),t("tr",{valign:"top"},[t("td",{align:"right"},"Пользовательские Наборы Шифров:"),t("td",{colspan:"3"},[t("textarea",{style:{"font-size":"9pt"},name:"OpenSSLCustomCipherSuites",rows:"2",cols:"60"},"TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:TLS_AES_128_CCM_8_SHA256:TLS_AES_128_CCM_SHA256")])])])])])])])])])],-1)),l[19]||(l[19]=n('<ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку для того, чтобы указать какую информацию модуль TLS должен сохранять в Журнале работы Сервера. Записи, помещённые модулем TLS в Журнал работы Сервера, имеют пометку <code>TLS</code>.</p></li><li><p><code>Время жизни</code></p><p>Эта настройка указывает <em>время кэширования</em> TLS-сессий. Когда все соединения, использующие TLS-сессию, закрываются, Сервер будет ждать указанное время до удаления параметров TLS-сессии. Эта возможность позволяет клиентам устанавливать новые соединения, <em>возобновляя</em> старые TLS-сессии. Это уменьшает время создания соединений и снижает загрузку Сервером центрального процессора. Эта возможность особенно важна для HTTP-клиентов, открывающих и закрывающих соединения очень часто.</p></li><li><p><code>Mинимальная Версия</code></p><p>Эта установка задаёт самую старую допустимую версию протокола SSL/TLS. Если удалённая сторона указывает поддержку версии SSL/TLS старее, чем указано в этой установке, то попытка создания безопасного соединения отвергается.<br> Этот параметр действует только на входящие соединения.</p></li><li><p><code>Обрабатывать Имя адресуемого Домена</code></p><p>Если эта установка включена, сервер поддерживает расширение протокола TLS, которое позволяет клиентам указываеть имя Домена Сервера, к которому они подсоединяются. Это свойство позволяет обслуживать несколько доменов с использованием TLS, используя единственный сетевой адрес IP.</p></li><li><p><code>Отсоединяться получив неверный Сертификат</code></p><p>Если Сервер потребовал от клиента <a href="#ClientCert">предоставления Сертификата</a>, то клиент может отправить некорректный сертификат: просроченный, выданный другому пользователю и т.д.<br> Если включена это опция, то процесс установления TLS соединения будет прерываться. Если эта опция выключена, то некорректные сертификаты игнорируются.</p></li></ul><h3 id="TLSCipherSettings" tabindex="-1">Настройки шифрования <a class="header-anchor" href="#TLSCipherSettings" aria-label="Permalink to &quot;Настройки шифрования {#TLSCipherSettings}&quot;">​</a></h3><p>Эти настройки определяют Список Шифров и Наборы Шифров, которые сервер использует для TLS для сеансов HTTP и SMTP. Эти параметры определяют, какие методы шифрования сервер предлагает клиентам во время процесса согласования TLS для TLSv1.2 и ниже (Список Шифров) и для TLSv1.3 (Наборы Шифров). Для получения дополнительной информации о параметрах и их форматах см. <a href="https://docs.openssl.org/3.3/man1/openssl-ciphers/#cipher-list-format" target="_blank" rel="noreferrer">документацию OpenSSL</a>.</p><ul><li><p><code>Текущий Список Шифров</code> и <code>Текущие Наборы Шифров</code></p><p>Показывает Список Шифров и Наборы Шифров, используемых в данный момент сервером.</p></li><li><p><code>Набор шифрования</code></p><p>Этот параметр указывает, какой набор Списка Шифров и Наборов Шифров следует использовать:</p><ul><li><p><code>Все доступные</code></p><p>Использовать все доступные методы шифрования.</p></li><li><p><code>Стандартный</code></p><p>Использовать методы шифрования, включенные по умолчанию в OpenSSL.</p></li><li><p><code>Пользовательский</code></p><p>Использовать определяемые пользователем Список Шифров и Наборы Шифров.</p></li></ul></li><li><p><code>Пользовательский Список Шифров</code> и <code>Пользовательские Наборы Шифров</code></p><p>Определяемые пользователем Список Шифров и Наборы Шифров.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p><code>Пользовательский Список Шифров</code> и <code>Пользовательские Наборы Шифров</code> будут использоваться только в том случае, если для <code>Набора шифрования</code> установлена ​​опция <code>Пользовательский</code>.</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Будьте осторожны при использовании <code>Пользовательского Списока Шифров</code> и <code>Пользовательских Наборов Шифров</code>, поскольку неправильно отформатированный или недостаточный набор методов шифрования может привести к невозможности использования HTTPS как пользователями, так и администраторами.</p></div><h2 id="ClientCert" tabindex="-1">Сертификаты Клиентов <a class="header-anchor" href="#ClientCert" aria-label="Permalink to &quot;Сертификаты Клиентов {#ClientCert}&quot;">​</a></h2><p>Сервер CommuniGate Pro может затребовать Сертификат Клиента в случаях, когда внешний клиент (почтовая программа, браузер или устройство для коммуникаций в реальном времени) устанавливает <a href="#TLS">TLS</a> соединение с определённым Доменом.</p><p>Через Веб Интерфейс Администратора откройте страницу Установки Домена для этого Домена и нажмите на ссылку Безопасность. Появится страница с настройками PKI:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Запрашивать Сертификаты у Клиентов</b></td></tr><tr><td align="right">Кем Выдан:</td><td><select name="XX"><option value="0"></option><option value="1" selected="selected">Certificate Name 1</option><option value="2">Certificate Name 2</option><option value="3">Certificate Name 3</option></select></td><td align="right">Обязателен:</td><td><select name="X1X"><option value="-1" selected="selected">По умолчанию(Нет)</option><option value="0">Нет</option><option value="1">Да</option></select></td></tr></tbody></table></div></form><ul><li><p><code>Кем Выдан</code></p><p>Выберите один из <a href="#Trusted">Доверенных Сертификатов</a>, указанных для этого Домена.<br> Когда Доверенный Сертификат выбран, то от TLS-клиента, устанавливающего соединение с этим Доменом, будет потребовано предоставление действительного сертификата, выпущенного владельцем выбранного Доверенного Сертификата. Эти сертификаты могут использоваться для <a href="./Security.html#Certificate">Аутентификации По Сертификату</a>.</p></li><li><p><code>Обязателен</code></p><p>Если указана эта опция, то TLS соединения с Доменом смогут устанавливать только клиенты, предоставляющие действительные Сертификаты.</p></li></ul><p>Сервер CommuniGate Pro обрабатывает запросы на клиентские сертификаты при установлении соединений <a href="#TLS">TLS</a> с внешними серверами (по протоколам SMTP, XMPP, SIP, POP и другим). В качестве клиентского при этом отправляется Сертификат TLS, установленный в Главном Домене.</p><h2 id="SMIME" tabindex="-1">Функциональность S/MIME <a class="header-anchor" href="#SMIME" aria-label="Permalink to &quot;Функциональность S/MIME {#SMIME}&quot;">​</a></h2><p>S/MIME - это PKI приложение, используемое для цифровой подписи, а также шифрования почтовых и других сообщений. Если TLS обеспечивает безопасность данных в момент пересылки по незащищённой сети, такой как Интернет, то S/MIME обеспечивает безопасность данных между конечными пользователями: S/MIME сообщение шифруется отправителем (с использованием Многостороннего Шифрования) и передаётся на сервер отправителя в зашифрованной форме. Та же зашифрованная форма используется, когда сообщение передаётся через сеть, когда оно хранится на промежуточных серверах, и когда оно помещается в папки получателей. Только получатели, используя свои Закрытые Ключи, могут расшифровать сообщение и только в тот момент, когда они фактически читают сообщение: само сообщение остаётся зашифрованным в папках получателей.</p><p>Для того, чтобы конечные пользователи могли использовать S/MIME безопасность, все они должны обладать своими собственными PKI-ключами. Каждый пользователь должен иметь Закрытый Ключ, безопасно хранящийся в месте, доступном только для этого пользователя, и соответствующий ему Открытый Ключ, встроенный в Сертификат. Этот Сертификат должен быть выдан Центром Сертификации (Удостоверяющим Центром), которому доверяют другие пользователи.</p><p>Веб Интерфейс Пользователя и XIMSS Интерфейс CommuniGate Pro поддерживают функциональность S/MIME. Сервер обеспечивает безопасное хранение Закрытых Ключей пользователей. Эти ключи могут быть разблокированы и использованы исключительно самими пользователями через указанные Интерфейсы.</p><p>Чтобы использовать обычное клиентское приложение на компьютере пользователя (POP, IMAP, или MAPI клиент), Закрытый Ключ пользователя должен храниться в специальном PKI-хранилище операционной системы компьютера.<br> Веб Интерфейс Пользователя и XIMSS Интерфейс могут экспортировать и импортировать Закрытые Ключи, так что пользователи могут использовать один и тот же Закрытый Ключ как для приложений, запущенных на своём компьютере, так и при работе через Интерфейсы. Дополнительную информацию смотрите в разделе <a href="./WebSMIME.html">Безопасная почта</a>.</p><h2 id="SMIMEKeys" tabindex="-1">Установки S/MIME Домена <a class="header-anchor" href="#SMIMEKeys" aria-label="Permalink to &quot;Установки S/MIME Домена {#SMIMEKeys}&quot;">​</a></h2><p>В Сервере CommuniGate Pro используется Сертификат Сервера, выдающий Сертификаты пользователям.</p><p>Домен CommuniGate Pro может выступать как Центр Сертификации (Удостоверяющий Центр) для всех его Пользователей, если:</p><ul><li>Опция <a href="#DomainKeys">Услуги PKI Криптографии</a> Включена.</li><li>Домен имеет действительный Закрытый Ключ.</li><li>Домен имеет действительный специальные S/MIME Сертификат.</li></ul><p>Чтобы задать S/MIME Установки Домена, используйте Веб Интерфейс Администратора и откройте страницы Установки Домена. Откройте страницу Безопасность и нажмите на ссылку S/MIME. Если Домен имеет действительный Закрытый Ключ, то показывается страница, подобная той, что показывается при работе с обычным Доменным Сертификатом. Эти поля используются для ввода специального S/MIME сертификата Домена. Этот Сертификат используется как Издатель (Центр Сертификации) для всех S/MIME Сертификатов, запрашиваемых пользователями в этом Домене.</p><h2 id="SMIMERules" tabindex="-1">Автоматическое Шифрование S/MIME <a class="header-anchor" href="#SMIMERules" aria-label="Permalink to &quot;Автоматическое Шифрование S/MIME {#SMIMERules}&quot;">​</a></h2><p>Возможности S/MIME могут быть использованы для безопасного хранения сообщений. CommuniGate Pro может зашифровывать все или только определённые сообщения до сохранения их в папках пользователей.</p><p>Действие <code>Записать Зашифровано в</code>, задаваемое в <a href="./../mail/QueueRules.html">Правилах</a>, используется для шифрования всех входящих сообщений электронной почты и хранения их в указанной папке.</p><p>Сообщения шифруются S/MIME Сертификатом владельца папки. Если действие <code>Записать Зашифровано в</code>, заданное в Правилах, используется в Правиле уровня Пользователя (то есть Правила, заданного Пользователем или Правила, Общего для Домена), и указанная папка не принадлежит Пользователю, сообщение шифруется при помощи Сертификата владельца папки и текущего Пользователя.</p><ul><li><p>Пример:</p><p>Пользователь под именем john имеет Правило, которое выполняет следующее действие:<br><code>Записать Зашифровано в   ~jim/INBOX</code><br> Когда выполняется это действие, сообщение сохраняется зашифрованным с использованием обоих Сертификатов john и jim в Папке INBOX Пользователя jim. И john, и jim смогут расшифровать и прочитать это сообщение.</p></li></ul><h2 id="SMIMEPost" tabindex="-1">Шифрование Хранимых Сообщений <a class="header-anchor" href="#SMIMEPost" aria-label="Permalink to &quot;Шифрование Хранимых Сообщений {#SMIMEPost}&quot;">​</a></h2><p>После того, как пользователь CommuniGate Pro получил некие незашифрованные сообщения, он может предпочесть хранить их в Папках на Сервере зашифрованными. <a href="./../access/MAPI.html">MAPI</a> и <a href="./../access/XIMSS.html">XIMSS</a> клиенты, а также <a href="./WebSMIME.html">Веб Интерфейс Пользователя</a> обеспечивают функции Зашифровать и Расшифровать, которые позволяют пользователям зашифровывать и расшифровывать отдельные сообщения в своих Папках.</p><h2 id="DKIM" tabindex="-1">Добавление DKIM-Подписи <a class="header-anchor" href="#DKIM" aria-label="Permalink to &quot;Добавление DKIM-Подписи {#DKIM}&quot;">​</a></h2><p>DKIM (DomainKeys Identified Mail) это метод аутентификации E-mail сообщений, основанный на добавлении к письму особого заголовка с цифровой Подписью. Подпись создаётся методом шифрования на основе Закрытого и Открытого Ключей. Принимающий сервер может использовать Открытый Ключ, чтобы проверить, что Подпись соответствует Закрытому Ключу, и что тело письма и наиболее важные заголовки не были изменены в процессе пересылки.</p><p>Чтобы задать DKIM Установки Домена, используйте Веб Интерфейс Администратора и откройте страницы Установки Домена. Откройте страницу Безопасность и нажмите на ссылку DKIM.</p><p>Чтобы включить добавление Подписей к исходящим сообщениям, нужно выполнить следующие шаги:</p>',33)),t("ol",null,[t("li",null,[l[9]||(l[9]=t("p",null,[e("Создать (или импортировать созданный внешней утилитой) Закрытый Ключ, подобно назначению Закрытого Ключа для "),t("a",{href:"./PKI.html#KeyGen"},"Домена"),e("."),t("br"),e(" После того, как Закрытый Ключ будет назначен, соответствующий Открытый Ключ будет показан.")],-1)),t("div",S,[t("table",h,[t("tbody",null,[l[6]||(l[6]=t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Закрытый Ключ")])],-1)),l[7]||(l[7]=t("tr",null,[t("td",{align:"right"},"Размер:"),t("td",null,"1024 bit"),t("td",{rowspan:"2"},[e(" "),t("input",{type:"submit",name:"RemoveKey",value:"Удалить Ключ",class:"button"})])],-1)),t("tr",null,[l[5]||(l[5]=t("td",{align:"right"},"Тест Ключа:",-1)),t("td",null,[a(o,{color:"GREEN"},{default:i(()=>l[4]||(l[4]=[t("i",null,"Verification String is OK",-1)])),_:1})])])])]),l[8]||(l[8]=t("table",{width:"90%",class:"settingsBox"},[t("caption",null,"Открытый Ключ"),t("tbody",null,[t("tr",null,[t("td",null,[t("textarea",{style:{width:"99%"},rows:"3",readonly:""},"MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDjLml46+DMPGpLpSQROFxyNnyFcyX9ZtscLo3YegyhB266JOYNzlfdPU4gBKWS89lnr2yVWC6dUgIVInJhin+stzROZ1MBd9dx6iOE4xAC2LxZeYvzjT07CoXzfdyb35N1TpSfL09ERXilNUgAoDqTAaJ+eGeN+N45LQTPtd0+QQIDAQAB")])])])],-1))])]),l[10]||(l[10]=t("li",null,[t("p",null,[e("Задать значение для поля "),t("code",null,"Домен"),e(" - это должно быть имя текущего Домена, или имя соответствующего домена верхнего уровня.")])],-1)),l[11]||(l[11]=t("li",null,[t("p",null,[e("Выбрать и задать значение поля "),t("code",null,"Селектор"),e(" - произвольную строчку.")])],-1))]),l[20]||(l[20]=t("div",{class:"settingsBox"},[t("table",{width:"100%"},[t("tbody",null,[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"Параметры DKIM-Подписи")])]),t("tr",null,[t("td",{align:"right"},"Домен:"),t("td",null,[t("table",{border:"0",cellspacing:"0",cellpadding:"1"},[t("tbody",null,[t("tr",null,[t("td",null,[t("input",{type:"radio",name:"DKIMdomain-Def",value:"1"})]),t("td",{class:"settingFixed"},"mail.dept1.company.com ")]),t("tr",{valign:"top"},[t("td",null,[t("input",{type:"radio",name:"DKIMdomain-Def",value:"0",checked:"checked"})]),t("td",null,[t("input",{name:"DKIMdomain",size:"40",maxlength:"10000",value:"company.com"})])])])])])]),t("tr",null,[t("td",{align:"right"},"Селектор:"),t("td",null,[t("table",{border:"0",cellspacing:"0",cellpadding:"1"},[t("tbody",null,[t("tr",null,[t("td",null,[t("input",{type:"radio",name:"DKIMselector-Def",value:"1"})]),t("td",{class:"settingFixed"},"mail ")]),t("tr",{valign:"top"},[t("td",null,[t("input",{type:"radio",name:"DKIMselector-Def",value:"0",checked:"checked"})]),t("td",null,[t("input",{name:"DKIMselector",size:"20",maxlength:"10000",value:"feb2017"})])])])])])])])])],-1)),l[21]||(l[21]=t("ol",{start:"4"},[t("li",null,[t("p",null,[e("Создать DNS TXT запись для имени "),t("code",null,"Selector._domainkey.Domain"),e(" со значением "),t("code",null,'"v=DKIM1; p=MIGfMA0GCSqG..."'),e(' где значение "p=" - это Ваш Открытый Ключ.')])]),t("li",null,[t("p",null,[e("Используйте кнопку "),t("code",null,"Проверить"),e(", чтобы убедиться, что DNS-запись существует и содержит правильный Открытый Ключ. Учтите, что для новосозданных DNS записей требуется время, чтобы распространиться по всему миру.")])])],-1)),l[22]||(l[22]=t("div",{class:"settingsBox"},[t("table",{width:"100%"},[t("tbody",null,[t("tr",null,[t("td",{class:"settingBoxCaption",colspan:"2"},[t("b",null,"DNS Запись")])]),t("tr",null,[t("td",{align:"left",valign:"top"},[t("input",{name:"CheckDNS",type:"submit",value:"Проверить",class:"button"})])]),t("tr",null,[t("td",null,[t("textarea",{style:{width:"99%"},rows:"4",readonly:""},'feb2017._domainkey.company.com text = "v=DKIM1; p=MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDjLml46+DMPGpLpSQROFxyNnyFcyX9ZtscLo3YegyhB266JOYNzlfdPU4gBKWS89lnr2yVWC6dUgIVInJhin+stzROZ1MBd9dx6iOE4xAC2LxZeYvzjT07CoXzfdyb35N1TpSfL09ERXilNUgAoDqTAaJ+eGeN+N45LQTPtd0+QQIDAQAB"')])])])])],-1)),l[23]||(l[23]=n('<ol start="6"><li>После того, как все вышеперечисленные шаги завершены, переключите значение <code>Включено</code> на <code>Да</code></li></ol><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Подписывать исходящие Сообщения</b></td></tr><tr><td>Включено: <select name="DKIMenabled"><option value="0">Нет</option><option value="1" selected="selected">Да</option></select></td></tr></tbody></table></div><p>Рекомендуется регулярно (приблизительно раз в 3 месяца) производить ротацию Ключей, путём генерации нового Закрытого Ключа и создания новой DNS-Записи с новым <code>Селектором</code>.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>DKIM Подписи составляются компонентой <a href="./../mail/#Enqueue">Enqueuer</a> при постановке сообщения в Очередь, но физически добавляются, когда сообщение сохраняется или отправляется.</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>В процессе составления DKIM Подписей принадлежность сообщения к Домену определяется адресом в заголовке <code>From:</code> сообщения. Пользователь из другого Домена может изменить адрес в <code>From:</code> так, что его письма будут подписываться согласно настройкам текущего Домена. Также, сообщения, пересылаемые через CommuniGate сервер из внешних источников, могут быть подписаны текущим Доменом, если их адреса в <code>From:</code> совпадают с именами объектов в текущем Домене.</p></div>',5))])}const y=d(u,[["render",b]]);export{E as __pageData,y as default};
