import{_ as o,c as a,o as c,ag as t}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Маршрутизатор","description":"","frontmatter":{"legacyLink":"russian/Router.html"},"headers":[],"relativePath":"russian/admin/sysadmin/Router.md","filePath":"russian/admin/sysadmin/Router.md"}'),l={name:"russian/admin/sysadmin/Router.md"};function d(p,e,n,i,s,m){return c(),a("div",null,e[0]||(e[0]=[t(`<h1 id="маршрутизатор" tabindex="-1">Маршрутизатор <a class="header-anchor" href="#маршрутизатор" aria-label="Permalink to &quot;Маршрутизатор&quot;">​</a></h1><p>Этот раздел предназначен для опытных Администраторов. В большинстве случаев достаточно методов маршрутизации, применяемых по умолчанию. Вам необходимо ознакомиться с этим разделом, если ваш Сервер работает как релей (ретранслятор) сообщений или сигналов для других систем, или если вам необходимо использовать сложные схемы маршрутизации.</p><p>Когда Сервер обрабатывает полученное <a href="./../mail/">Сообщение</a>, он извлекает информацию о получателях из &quot;конверта&quot; сообщения и решает, в очередь какого модуля должно быть помещено это сообщение, какому объекту модуль должен послать это сообщение, и какой адрес должен использоваться для доставки сообщения этому объекту. Подобные операции выполняются с <a href="./../cluster/Signals.html">Сигналами Реального Времени</a>, приходящими из внешних источников или созданными внутренними компонентами сервера и предназначенными для локальных или внешних объектов.</p><p><a href="./../cluster/Access.html">Модули Доступа</a> (такие, как <a href="./../access/POP.html">POP</a>, <a href="./../access/IMAP.html">IMAP</a>, <a href="./../access/WebUser.html">Веб Интерфейс Пользователя</a> и т.д.) также работают с адресами. Когда клиентские приложения или программы входят на сервер, они указывают имя Пользователя, от имени которого они хотят войти на Сервер. Этот адрес обрабатывается с использованием таких же операций, как и при обработке адресов Сообщений и Сигналов.</p><p>Эти операции маршрутизации реализованы в компоненте Маршрутизатор сервера CommuniGate Pro. Любой адрес, получаемый вашим Сервером, обрабатывается с использованием компонента Маршрутизатор. Это обеспечивает дополнительную целостность и связность в работе всех компонентов Сервера: когда, например, вы создаёте <a href="./../objects/#Aliases">Псевдоним</a> для некоторого Пользователя, этот Псевдоним может быть использован как для отправки электронной почты и Сигналов этому Пользователю, так и для входа на Сервер от имени этого Пользователя.</p><h2 id="Address" tabindex="-1">Структура Адреса <a class="header-anchor" href="#Address" aria-label="Permalink to &quot;Структура Адреса {#Address}&quot;">​</a></h2><p>Каждый адрес электронной почты или адрес Сигналов состоит из двух строк: локальной части и имени домена. Обычно, адрес выглядит как <code>xxxx@yyyyy</code>, где yyyyy - это имя домена (уникальное имя почтовой системы получателя), а xxxx - это его локальная часть, то есть, имя пользователя в той системе.</p><ul><li><p>Адреса могут иметь более сложную структуру, например, адрес электронной почты может так же содержать некоторую информацию о пути:</p><p><code>&lt;@zzzz:xxxx@yyyyy&gt;</code> или <code>zzzz!yyyyy!xxxx</code> или <code>xxxx%yyyyy@zzzz</code><br> Эти адреса указывают, что сообщения электронной почты или Сигналы сначала должны быть отправлены на систему zzzz, и затем эта система должны доставить их на xxxx@yyyyy (пользователю xxxx на систему yyyyy).</p></li></ul><p>Когда Маршрутизатор разбирает адрес, он извлекает имя системы, на которую должно быть доставлено сообщение. Оно становится доменной частью адреса. Остальная часть адреса считается локальной частью - то есть, локальная часть определяет конкретного получателя, которому должны быть доставлены сообщения или сигналы, после доставки их в систему, заданную по имени домена. В примере, приведенном выше, zzzz является доменной частью имени, а xxxx@yyyyy - локальной частью.</p><p>Дополнительную информацию о форматах адреса электронной почты вы можете найти в RFC822 и сопутствующих документах.</p><p>Если в локальной части содержится сложный адрес (то есть в локальной части содержится имя (имена) домена и локальная часть), то локальная часть представляется с использованием символа <code>%</code>: <code>local%domain1%domain2</code>; в классической форме в CommuniGate Pro этому соответствует полный адрес <code>local%domain1%domain2@domain</code>.</p><h2 id="OwnDomain" tabindex="-1">Имя Главного Домена <a class="header-anchor" href="#OwnDomain" aria-label="Permalink to &quot;Имя Главного Домена {#OwnDomain}&quot;">​</a></h2><p>Когда имя домена извлекается из адреса, Маршрутизатор сравнивает его с именем домена Сервера (смотрите в настройках <a href="./#General">Общее</a>). Если они совпадают, то значению имени домена присваивается пустая строка. Когда имя домена приравнивается к пустой строке, Маршрутизатор перезапускает обработку локальной части, снова пытаясь разделить её на доменную и локальную часть.<br> Например, если Имя Главного Домена вашего Сервера company.com, то адреса будут преобразованы следующим образом:</p><p>Адрес</p><p>локальная часть</p><p>доменная часть</p><table tabindex="0"><thead><tr><th style="text-align:right;">Address</th><th>local part</th><th>domain part</th></tr></thead><tbody><tr><td style="text-align:right;"><code>support@company.com</code></td><td><code>support</code></td><td><code>company.com</code></td></tr><tr><td style="text-align:right;"><em>преобразовывается в --&gt;</em></td><td><code>support</code></td><td></td></tr><tr><td style="text-align:right;"><code>&lt;@company.com:sales@example.com&gt;</code></td><td><code>sales@example.com</code></td><td><code>company.com</code></td></tr><tr><td style="text-align:right;"><em>преобразовывается в --&gt;</em></td><td><code>sales@example.com</code></td><td></td></tr><tr><td style="text-align:right;"><em>преобразовывается в --&gt;</em></td><td><code>sales</code></td><td><code>example.com</code></td></tr></tbody></table><h2 id="MX" tabindex="-1">Домены и Записи в DNS <a class="header-anchor" href="#MX" aria-label="Permalink to &quot;Домены и Записи в DNS {#MX}&quot;">​</a></h2><p>В дополнение к Главному Домену Сервера, ваш Сервер может обслуживать много независимых <a href="./../objects/Domains.html">Доменов</a>.</p><p>Для обработки Сообщений и Сигналов, направляемых на Домены вашего Сервера, вы должны убедиться, что Сообщения, отправленные в какой-либо домен, направляются на ваш Сервер, имеющий соответствующую запись в глобальной системе DNS.</p><p>Пример 1: ваш сервер (example.com) обслуживает Домен example.com и Домен partners-example.com. Убедитесь, что MX-записи DNS созданы для обоих Доменов, и что эти записи указывают на ваш Сервер example.com.</p><p>Пример 2: ваш сервер (example.com) работает как &quot;Удалённый POP&quot; почтовый релей для некоторых клиентов системы. Каждый домен имеет своё собственное имя домена (client1.com, client2.com и client3.com), и вы настроили ваш Маршрутизатор таким образом, чтобы вся электронная почта, направляемая на домен client1.com, перенаправлялась на общедоменного Пользователя client1, и т.д.<br> Для этого вы должны убедиться, что вся электронная почта, отправляемая в домен client1.com, направляется на ваш сервер (example.com). В DNS должна быть создана MX-запись client1.com, указывающая на ваш Сервер (example.com).</p><h2 id="Table" tabindex="-1">Таблица Маршрутизации <a class="header-anchor" href="#Table" aria-label="Permalink to &quot;Таблица Маршрутизации {#Table}&quot;">​</a></h2><p>Когда разбирается адрес и извлекается его доменная часть, Маршрутизатор проверяет записи маршрутизации в Таблице Маршрутизации.</p><p>Для того, чтобы настроить Таблицу Маршрутизации, используйте Веб Интерфейс Администратора. Откройте страницу Маршрутизатор в разделе Установки:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td align="center">Уровень Журнала: <select name="LogLevel"><option value="0">Катастрофы</option><option value="1" selected="selected">Сбои</option><option value="2">Основное</option><option value="3">Проблемы</option><option value="4">Подробности</option><option value="5">Всё</option></select></td></tr><tr><td align="center"><textarea style="font-size:9pt;" name="RouterTable" rows="12" cols="80">fax.company.com = company.com ; -&gt; в этот же домен
hq.company.com = newhq.company.com ; -&gt; на другой сервер
Relay:*.test.com = company.com
; aaa.test.com, bbb.test.com ; просто строка с комментарием
&lt;sales&gt; = john ; простой псевдоним
&lt;sales@client1.com&gt; = sales-client1 ; простой чужой псевдоним
&lt;info@client1.com&gt; = info@otherhost.com; пользователь -&gt; другой пользователь
&lt;*@client2.com&gt; = *.cl2 ; sales@.. -&gt; sales.cl2
test.com = Unified.local ; Общедоменный пользователь
</textarea></td></tr><tr><td align="center"><input name="ExtendNonQualifiedDomains" value="1" type="checkbox"> Добавлять <input name="DomainQualifier" value="myorg.org" size="20" maxlength="63" type="text"> к неквалифицированным доменным именам</td></tr></tbody></table></div></form><p>Каждая строка в Таблице Маршрутизации является записью маршрутизации. Запись маршрутизации содержит необязательные префиксы, левую часть, знак равно (<code>=</code>) и правую часть. Символ точка с запятой (<code>;</code>) используется для указания комментария после правой части записи маршрутизации. В Таблицу может быть добавлена строка с комментарием, начинающаяся с символа точка с запятой.</p><p>Маршрутизатор берет разобранный адрес (то есть доменную и локальные части адреса) и сканирует все записи в Таблице сверху вниз. Если найдена подходящая запись, то она применяется (как описано ниже), и модифицированный адрес снова обрабатывается в Маршрутизаторе.</p><ul><li><p><code>Уровень Журнала</code></p><p>Используйте эту настройку для того, чтобы указать какую информацию Маршрутизатор CommuniGate Pro должен сохранять в Журнале работы Сервера. Обычно используется уровень <code>Сбои</code> (проблемы с маршрутизацией адресов). В случае, если в работе Маршрутизатора возникают проблемы, возможно, целесообразным будет увеличить детализацию до уровня <code>Подробности</code> или <code>Всё</code>: в этом случае в Журнал работы Сервера будет записываться подробная информация о работе Маршрутизатора. Записи, помещённые компонентом Маршрутизатор в Журнал работы Сервера, имеют пометку <code>ROUTER</code>.</p></li></ul><h3 id="RecordPrefix" tabindex="-1">Префикс <a class="header-anchor" href="#RecordPrefix" aria-label="Permalink to &quot;Префикс {#RecordPrefix}&quot;">​</a></h3><p>Записи Маршрутизации могут иметь префиксы режима Ретрансляции (релей-префиксы): <code>Relay:</code> (может сокращаться до <code>R:</code>), <code>NoRelay:</code> (может сокращаться до <code>N:</code>) или <code>RelayAll:</code>. Дополнительную информацию смотрите в разделе <a href="./Protection.html#RouterRelay">Защита</a>.<br> Если ни один из этих префиксов не указан, то по умолчанию используется префикс <code>NoRelay:</code>.</p><p>Записи Маршрутизации могут иметь ноль, один или несколько следующих префиксов по типам операций:</p><ul><li><code>Mail:</code> (может сокращаться до <code>M:</code>). Записи с этим префиксом применяются в случаях, когда адреса обрабатываются для доставки электронной почты.</li><li><code>Access:</code> (может сокращаться до <code>A:</code>). Записи с этим префиксом применяются в случаях, когда адреса обрабатываются в операциях аутентификации и авторизации.</li><li><code>Signal:</code> (может сокращаться до <code>S:</code>). Записи с этим префиксом применяются в случаях, когда маршрутизация адресов выполняется во время обработки Сигналов.</li></ul><p>Эти префиксы должны указываться после необязательных префиксов режима Ретрансляции. Если ни один из этих префиксов не указан, по умолчанию запись Маршрутизации применяется ко всем операциям.</p><h3 id="RecordSample" tabindex="-1">Образец <a class="header-anchor" href="#RecordSample" aria-label="Permalink to &quot;Образец {#RecordSample}&quot;">​</a></h3><p>Левая часть записи Маршрутизации содержит Образец: строку с необязательным шаблоном подстановки.</p><p>Поддерживаются следующие шаблоны подстановки:</p><ul><li><p><code>*</code></p><p>шаблон подстановки, совпадающий со строкой нулевой или произвольной длины.</p><ul><li><p>Пример:</p><p><code>sta*r</code><br> Этому образцу соответствует любая строка вида <code>sta_XXXXXX_r</code>, где <em>XXXXXX</em> - произвольная подстрока (включая пустую подстроку в строке star).</p></li></ul></li><li><p><code>(размер тип)</code></p><p><em>тип</em> - это подстрока типа:</p><ul><li><code>d</code> - десятичные цифры (<code>0</code> .. <code>9</code>)</li><li><code>h</code> - шестнадцатеричные цифры (<code>0</code> .. <code>9</code>, <code>A</code> .. <code>F</code>, <code>a</code> .. <code>f</code>)</li><li><code>L</code> - алфавитно-цифровые символы (<code>0</code> .. <code>9</code>, <code>A</code> .. <code>Z</code>, <code>a</code> .. <code>z</code>)</li><li><code>*</code> - любые символы</li></ul><p><em>размер</em> - это необязательное указание длины подстроки. Длина может быть задана в следующих формах:</p><ul><li><p><code>_nnn_</code> (где <em>nnn</em> десятичное число): соответствующая подстрока должна иметь <em>nnn</em> символов.</p></li><li><p><code>_nnn_+</code>: соответствующая подстрока должна иметь <em>nnn</em> или больше символов.</p></li><li><p><code>_nnn-mmm_</code> (где <em>mmm</em> десятичное число, <em>mmm</em> &gt;= <em>nnn</em> ): соответствующая подстрока должна иметь от <em>nnn</em> до <em>mmm</em> символов.</p></li><li><p>Пример:</p><p><code>sta(3*)r</code><br> Этому образцу соответствует любая строка вида <code>sta_XXX_r</code>, где <em>XXX</em> - любые три символа.</p></li><li><p>Пример:</p><p><code>sta(4+d)r</code><br> Этому образцу соответствует любая <code>sta_DDDDD_r</code> строка, где <em>DDDDD</em> 4 или более десятичных цифр.</p></li><li><p>Пример:</p><p><code>sta(3-5h)r</code><br> Этому образцу соответствует любая <code>sta_HHH_r</code> строка, где <em>HHH</em> 3, 4 или 5 шестнадцатеричных цифр.</p></li></ul></li></ul><p>Символ обратной косой черты (<code>\\</code>) используется как управляющий символ: <code>\\\\</code> обрабатывается как одна косая черта, <code>\\*</code> обрабатывается как символ звёздочка и так далее.</p><p>В Образце разрешено использовать только один символ шаблона подстановки.</p><h3 id="RecordRoute" tabindex="-1">Маршрут <a class="header-anchor" href="#RecordRoute" aria-label="Permalink to &quot;Маршрут {#RecordRoute}&quot;">​</a></h3><p>Правая часть записи Маршрутизации содержит Маршрут: строку с необязательным шаблоном подстановки <code>*</code>.</p><p>Если Образец Записи соответствует обрабатываемому адресу, адрес изменяется согласно Маршруту Записи. Подстрока, соответствующая шаблону подстановки Образца, подставляется в шаблон подстановки Маршрута.</p><p>Символ обратной косой черты (<code>\\</code>) используется как управляющий символ: <code>\\\\</code> обрабатывается как одна косая черта, <code>\\*</code> обрабатывается как символ звёздочка и так далее.</p><p>В Маршруте разрешено использовать только один символ шаблона подстановки.</p><h3 id="записи-маршрутизации-уровня-домена" tabindex="-1">Записи Маршрутизации Уровня Домена <a class="header-anchor" href="#записи-маршрутизации-уровня-домена" aria-label="Permalink to &quot;Записи Маршрутизации Уровня Домена&quot;">​</a></h3><p>Если левая часть записи Маршрутизации содержит имя домена, то запись определяет маршрут для всего этого домена.</p><p>Если при обработке какого-либо адреса имя домена соответствует имени домена, указанному в такой записи, то доменная часть заменяется правой частью записи маршрутизации.</p><ul><li><p>Пример:</p><p><code>hq.company.com = twisted.company.com</code><br> Все адреса с доменной частью hq.company.com изменяются таким образом, что их доменная часть будет twisted.company.com. Процесс маршрутизации перезапускается для определения маршрута изменённого адреса.</p></li></ul><p>Путь маршрутизации может указывать ретрансляторы (релеи).</p><ul><li><p>Пример:</p><p><code>hq.company.com = hq.company.com@relay.company.com</code><br> Вся электронная почта и Сигналы, направляемые на имя домена hq.company.com будут перенаправлены на систему (домен) relay.company.com и затем, с той системы, на домен hq.company.com.</p></li></ul><p>Если электронная почта и Сигналы должны маршрутизироваться одинаковым или похожим образом для нескольких доменов, то вы можете использовать символ звёздочка (<code>*</code>) как шаблон подстановки.</p><ul><li><p>Пример:</p><p><code>*.old_company.com = new_company.com</code><br> В этому случае адреса во всех доменах, заканчивающихся на .old_company.com будут изменяться на доменную часть new_company.com с неизменённой локальной частью (именами пользователей).</p></li></ul><p>Такой тип маршрутизации очень часто используется для обработки всех субдоменов в некотором домене.</p><ul><li><p>Пример:</p><p><code>*.mycompany.com = mycompany.com</code><br> Если mycompany.com является именем Главного Домена Сервера, то такая запись маршрутизации заставит Сервер обрабатывать электронную почты и Сигналы, отправляемые на все субдомены Главного Домена, и адрес <a href="mailto:user@mail.mycompany.com" target="_blank" rel="noreferrer">user@mail.mycompany.com</a> будет обрабатываться как адрес <a href="mailto:user@mycompany.com" target="_blank" rel="noreferrer">user@mycompany.com</a>.</p></li><li><p>Пример:</p><p><code>*.old_company.com = *.new_company.com</code><br> Если задана такая строка, и в домен host5.old_company.com приходит Электронная почта или Сигналы, то они направляются на host5.new_company.com.</p></li><li><p>Пример:</p><p><code>system-*.mycompany.com = uu*.local</code><br> Эта строка маршрутизации перенаправит system-abc.mycompany.com на uuabc.local.</p></li></ul><p>Кроме записей маршрутизации уровня домена, маршрутизация для домена может задаваться также через записи <a href="#Alias">уровня пользователя</a> (смотрите ниже).<br> Записи для <a href="./../mail/Local.html#Unified">Общедоменных Пользователей</a> так же являются записями маршрутизации уровня домена.</p><h3 id="записи-маршрутизации-уровня-пользователя" tabindex="-1">Записи Маршрутизации Уровня Пользователя <a class="header-anchor" href="#записи-маршрутизации-уровня-пользователя" aria-label="Permalink to &quot;Записи Маршрутизации Уровня Пользователя&quot;">​</a></h3><p>Если левая часть записи маршрутизации содержит адрес в угловых скобках(<code>&lt;</code> и <code>&gt;</code>), то это запись уровня Пользователя - правило маршрутизации для конкретного адреса.</p><p>Когда разбирается адрес и Маршрутизатор сканирует записи в Таблице, он сравнивает доменную часть адреса с доменной частью всех записей маршрутизации уровня Пользователя.</p><p>Если доменная часть совпадает, Маршрутизатор сравнивает локальную часть адреса с локальной частью адреса в записи уровня пользователя. Если обе, доменная и локальная части, совпадают, то правая часть записи маршрутизации уровня пользователя используется для формирования нового адреса. Маршрутизатор перезапускается, разбирает и обрабатывает этот новый адрес.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Из-за того, что Имя Главного Домена Сервера в разбираемом адресе сразу же заменяется пустой строкой, записи уровня пользователя, которые должны применяться к адресам в Главном Домене, вообще не должны содержать никакой доменной части.</p></div><p>В примере ниже <code>mycompany.com</code> является Именем Главного Домена Сервера.</p><ul><li><p>Пример:</p><p><code>&lt;sales&gt; = bill</code> в этом случае, все сообщения на адрес <a href="mailto:sales@mycompany.com" target="_blank" rel="noreferrer">sales@mycompany.com</a> будут направлены на bill, как если бы они были адресованы на <a href="mailto:bill@mycompany.com" target="_blank" rel="noreferrer">bill@mycompany.com</a>.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Если для некоторого локального имени <code>xxxx</code> существует запись уровня пользователя, то нет необходимости действительно создавать реального Пользователя <code>xxxx</code> на Сервере. Более того, создание такого Пользователя будет абсолютно бесполезным, так как никакое сообщение или сигнал никогда не попадёт к Пользователю: всё, направляемое на имя <code>xxxx</code>, будет куда-то перенаправлено.</p></div></li></ul><p>Правая часть записи уровня пользователя может быть любым адресом.</p><ul><li><p>Пример:</p><p><code>&lt;sales&gt; = Bill@thatcompany.com</code><br> Все сообщения, направляемые на адрес <a href="mailto:sales@mycompany.com" target="_blank" rel="noreferrer">sales@mycompany.com</a> будут перенаправлены на <a href="mailto:Bill@thatcompany.com" target="_blank" rel="noreferrer">Bill@thatcompany.com</a>. Маршрутизатор берёт новый адрес, извлекается имя домена (thatcompany.com) и локальную часть (Bill), затем Маршрутизатор перезапускается, пытаясь определить маршрут для thatcompany.com.</p></li></ul><p>Вы можете использовать шаблон подстановки (<code>*</code>) в локальной части записи уровня пользователя. Этот же символ может быть использован и любой части адреса в правой части для задания строки подстановки.</p><ul><li><p>Пример:</p><p><code>&lt;dept-*&gt; = postmaster@*-dept.mycompany.com</code><br> Эта запись перенаправит всю электронную почту и Сигналы, отправленные для <a href="mailto:dept-sales@mycompany.com" target="_blank" rel="noreferrer">dept-sales@mycompany.com</a> на пользователя postmaster, обслуживающегося на сервере отдела sales-dept.mycompany.com.</p></li></ul><p>Вы можете использовать записи уровня пользователя для перенаправления электронной почты и Сигналов, отправленных на любой из Доменов вашего Сервера. В следующем примере client.com является локальным Доменом.</p><ul><li><p>Пример:</p><p><code>&lt;sales@client.com&gt; = Bill@client.com</code><br> Все сообщения, направляемые на адрес <a href="mailto:sales@client.com" target="_blank" rel="noreferrer">sales@client.com</a> будут перенаправлены на <a href="mailto:Bill@client.com" target="_blank" rel="noreferrer">Bill@client.com</a>.</p></li><li><p>Пример:</p><p><code>&lt;sales@client.com&gt; = Bill</code><br> Все сообщения, направляемые на адрес <a href="mailto:sales@client.com" target="_blank" rel="noreferrer">sales@client.com</a> будут перенаправлены на <a href="mailto:Bill@mydomain.com" target="_blank" rel="noreferrer">Bill@mydomain.com</a> (то есть на адрес Bill в Главном Домене).</p></li></ul><p>В большинстве случаев вы не должны использовать записи Маршрутизатора уровня пользователя: если возникает необходимость использования альтернативных имён для какого-нибудь Пользователя, используйте вместо этого <a href="./../objects/Accounts.html">Псевдонимы Пользователя</a>. Если вам необходимо перенаправить электронную почту и Сигналы, отправленные на какое-либо имя в локальном Домене Сервера на какой-нибудь другой адрес, используйте <a href="./../objects/Forwarders.html">Переадресаторы</a>.</p><p>Вы можете создать псевдоним для конкретного пользователя чужой системы. Например, если вся электронная почта, отправленная в какой-нибудь домен, должна быть перенаправлена на определённый почтовый хост или на объединённого пользователя, но определённые адреса в этом домене должны быть направлены на адреса на вашей или другой системе.</p><ul><li><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Mail:&lt;sales@client1.com&gt; = sales-client1</span></span>
<span class="line"><span>Mail:client1.com = new.client1.com</span></span></code></pre></div><p>Эти записи направляют всю электронную почту, отправляемую на адрес sales в домене client1.com на Пользователя sales-client1 в Главном Домене Сервера, а сообщения на других пользователей в домене client1.com направляются на систему new.client1.com.</p></li></ul><p>Шаблон подстановки (<code>*</code>) может использоваться только в локальной части полного имени пользователя (то есть до символа <code>@</code>).</p><p>Вы можете использовать возможности шаблона подстановки для обслуживания нескольких доменов в одном Домене CommuniGate Pro, создав уникальное &quot;адресное пространство&quot; для каждого имени домена.</p><ul><li><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@client5.com&gt; = cl5-*</span></span>
<span class="line"><span>&lt;*@client7.com&gt; = cl7-*</span></span></code></pre></div><p>Электронная почта и Сигналы, отправляемые на адрес <a href="mailto:sales@client5.com" target="_blank" rel="noreferrer">sales@client5.com</a> будут перенаправлены на Пользователя cl5-sales в Главном Домене, электронная почта и Сигналы, отправляемые на адрес <a href="mailto:info@client5.com" target="_blank" rel="noreferrer">info@client5.com</a>, будут перенаправлены на Пользователя cl7-info в Главном Домене, а Электронная почта и Сигналы, отправляемые на адрес <a href="mailto:sales@client7.com" target="_blank" rel="noreferrer">sales@client7.com</a>, будут перенаправлены на Пользователя cl7-sales в Главном Домене.</p><p>Этот метод может использоваться, когда вы не хотите создавать полнофункциональные <a href="./../objects/Domains.html">Домены</a> CommuniGate Pro для доменов, содержащих в лучшем случае нескольких Пользователей.</p></li></ul><h3 id="общие-локальные-записи-маршрутизации" tabindex="-1">Общие Локальные Записи Маршрутизации <a class="header-anchor" href="#общие-локальные-записи-маршрутизации" aria-label="Permalink to &quot;Общие Локальные Записи Маршрутизации&quot;">​</a></h3><p>В записях уровня пользователя в доменной части может использоваться шаблон подстановки (<code>*</code>). Эти записи применяются к адресам, которые имеются в любом локальном Домене (то есть в Домене, созданном на Сервере или в Кластере Сервера CommuniGate Pro). Правая часть адреса такой записи указывает адрес в этом же локальном Домене.</p><ul><li><p>Пример:</p><p><code>&lt;abuse@*&gt; = postmaster</code><br> Эта запись перенаправит адрес abuse@<em>domainX.dom</em> на postmaster@domainX.dom для любого Домена <em>domainX.dom</em>, созданного в вашей системе CommuniGate Pro.</p></li></ul><p>Если в правой части адреса имеется доменная часть, то адрес перенаправляется в этот домен.</p><ul><li><p>Пример:</p><p><code>&lt;abuse@*&gt; = postmaster@somedomain.com</code><br> Эта запись перенаправит адрес abuse@domainX.dom на адрес postmaster%somedomain.com@domainX.dom для любого Домена domainX.dom, созданного в вашей системе CommuniGate Pro. Затем адрес postmaster%somedomain.com@domainX.dom будет перенаправлен на адрес <a href="mailto:postmaster@somedomain.com" target="_blank" rel="noreferrer">postmaster@somedomain.com</a>.</p></li></ul><p>Локальная часть левой стороны адреса может содержать шаблон подстановки (как обычная запись уровня пользователя). Строка, совпадающая с шаблоном подстановки может использоваться в правой части адреса.</p><ul><li><p>Пример:</p><p><code>&lt;+*@*&gt; = 011*</code><br> Эта запись перенаправит адрес <code>+490088899@domainX.dom</code> на адрес <code>011490088899@domainX.dom</code> для любого Домена domainX.dom, созданного в вашей системе CommuniGate Pro.</p></li></ul><h2 id="Special" tabindex="-1">Специальные Адреса <a class="header-anchor" href="#Special" aria-label="Permalink to &quot;Специальные Адреса {#Special}&quot;">​</a></h2><p>Если маршрут адреса указывает в один из локальных доменов (включая пустую доменную часть, которая указывает главный домен), локальная часть адреса проверяет на совпадение с одним из специальных значений:</p><ul><li><p><code>null</code></p><p>этот адрес направляется в фиктивный внутренний модуль &quot;Чёрная дыра&quot;.<br> Когда сообщение направляется в &quot;Чёрную дыру&quot;, адрес сразу же получает отметку &quot;доставлено&quot;, без какой-либо дальнейшей обработки.<br> Если в &quot;Чёрную дыру&quot; адресуется Сигнальный запрос, то он немедленно считается &quot;доставленным&quot; с генерацией ответа &quot;200 ОК&quot;, если только запрос не был <code>INVITE</code>, <code>UPDATE</code> или <code>OPTIONS</code>: в этих случаях ответом на запрос будет 480 &quot;No Address Found&quot;.</p><ul><li><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;*@bad.company.com&gt; = null</span></span>
<span class="line"><span>&lt;junk&gt; = null</span></span></code></pre></div><p>С такими записями в Таблице Маршрутизации, Сервер выкинет всю почту, посылаемую в домен <code>bad.company.com</code>, так же, как и всю почту, отправляемую на адрес junk в Главном Домене.</p></li></ul></li><li><p><code>MAILER-DAEMON</code>, <code>Calendar-Alarm</code></p><p>эти специальные адреса обрабатываются аналогично адресу <code>null</code>.</p></li><li><p><code>error</code></p><p>Почтовые сообщения и Сигналы, отправленные на этот адрес, отвергаются без обработки, создавая, однако, ответ/отчёт с ошибкой доставки. Если доменная часть имени адреса <code>error</code>, или если доменная часть пустая, а локальная часть <code>error</code>, адрес отвергается без обработки с генерацией ответа/отчёта с ошибкой доставки.</p><ul><li><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>bad.company.com = error</span></span>
<span class="line"><span>&lt;junk&gt; = error</span></span></code></pre></div><p>Если введены такие строки, Сервер будет отвергать все сообщения электронной почты и Сигналы, отправляемые в домен bad.company.com или на адрес junk в Главном Домене.</p></li></ul></li><li><p><code>blacklisted</code></p><p>Почтовые сообщения и Сигналы, отправленные на этот адрес, отвергаются без обработки, но с созданием ответа/отчёта с ошибкой &quot;адрес в чёрном списке&quot;.<br> Дополнительную информацию смотрите в разделе <a href="./../mail/SMTP.html#BlackList">Модуль SMTP</a>.</p></li><li><p><code>spamtrap</code></p><p>Почтовые сообщения и Сигналы, отправленные на этот адрес, отвергаются без обработки, но <a href="./../mail/SMTP.html">модуль SMTP</a> обрабатывает их особо. Дополнительную информацию смотрите в разделе <a href="./Protection.html#SpamTrap">Защита</a>.</p></li><li><p><code>incomplete</code></p><p>Сигналы, отправляемые на такие адреса, отвергаются с сообщением об ошибке &quot;Address Incomplete&quot;. Это может быть полезно для поддержки SIP клиентов, которые отправляют запрос INVITE ранее, чем был полностью набран номер.</p><ul><li><p>Пример:</p><p><code>&lt;(1-4d)@*&gt; = incomplete</code></p><p>Когда введена такая запись, набор 1-, 2- или 3-х значных номеров будет возвращать клиенту код с ошибкой &quot;Address Incomplete&quot;, заставляя его ждать дополнительного ввода от пользователя.</p></li></ul></li><li><p><code>listserver</code></p><p>Почтовые сообщения на этот адрес передаются в <a href="./../mail/LIST.html#Service">Модуль LIST</a>.</p></li><li><p><code>all</code></p><p>Почтовые сообщения на этот адрес рассылаются всем Пользователям Домена. Дополнительную информацию смотрите в разделе <a href="./../objects/Domains.html#All">Домены</a>.</p></li><li><p><code>alldomains</code></p><p>Почтовые сообщения на этот адрес рассылаются всем Пользователям всех Доменов. Дополнительную информацию смотрите в разделе <a href="./../objects/Domains.html#AllDomains">Домены</a>.</p></li></ul><p>Если маршрут адреса указывает на домен null, то адрес обрабатывается так же, как если бы он указывал локальной частью на null в локальном домене (смотрите выше).</p><p>Если маршрут адреса указывает на домен error, то адрес обрабатывается так же, как если бы он указывал локальной частью на error в локальном домене (смотрите выше).</p><p>Если маршрут адреса указывает на домен blacklisted, то адрес обрабатывается так же, как если бы он указывал локальной частью на blacklisted в локальном домене (смотрите выше).</p><p>Если доменная часть имени заканчивается символами <code>.here</code> или <code>._here</code>, этот суффикс удаляется, и оставшаяся часть имени используется как имя локального Домена CommuniGate Pro. Этот суффикс позволяет вам избежать зацикливания маршрутизации в определённых ситуациях.</p><ul><li><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>dept1.xyz.com = dept1.xyz.com._here</span></span>
<span class="line"><span>dept2.xyz.com = dept2.xyz.com._here</span></span>
<span class="line"><span>*.xyz.com = *.abc.com</span></span></code></pre></div><p>Электронная почта и Сигналы, отправляемые на все субдомены домена xyz.com, перенаправляются на субдомены домена abc.com, за исключением адресов в субдоменах dept1.xyz.com и dept2.xyz.com, которые направляются в локальные Домены dept1.xyz.com и dept2.xyz.com CommuniGate Pro.</p></li></ul><h2 id="Via" tabindex="-1">Явная маршрутизация через Удалённую Систему <a class="header-anchor" href="#Via" aria-label="Permalink to &quot;Явная маршрутизация через Удалённую Систему {#Via}&quot;">​</a></h2><p>После того, как применены все записи из Таблицы Маршрутизации, Маршрутизатор проверяет, не оканчивается ли имя домена суффиксом <code>._via</code>. Суффикс удаляется, имя домена считается хостом - конечным адресатом, а локальная часть адреса используется как адрес, который будет передан на этот хост.</p><ul><li><p>Пример:</p><p>Именем Главного Домена Сервера является <code>company.com</code>.<br> Электронная почта и Сигналы, отправляемые в Домен <code>sales.company.com</code> должны быть переданы на отдельный сервер sales.company.com, а адреса в других субдоменах домена company.com должны обрабатываться как адреса в Главном Домене, то есть адрес <a href="mailto:user@subdomain.company.com" target="_blank" rel="noreferrer">user@subdomain.company.com</a> должен обрабатываться как адрес <a href="mailto:user@company.com" target="_blank" rel="noreferrer">user@company.com</a>.<br> Вы можете реализовать такую маршрутизацию, используя следующие записи:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>sales.company.com = sales.company.com._via ; явно перенаправлять на удалённый хост</span></span>
<span class="line"><span>*.company.com = company.com ; все остальные субдомены перенаправлять</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Адреса в домене sales.company.com будут передаваться с удалённой доменной частью, то есть адрес <code>&lt;user@sales.company.com&gt;</code> будет передаваться на хост sales.company.com как <code>&lt;user&gt;</code>.</p></div><p>Это может привести к проблемам, если сервер sales.company.com не принимает адреса без указания домена. Смотрите следующий пример для возможного решения этой проблемы.</p></li><li><p>Пример:</p><p>Электронная почта и Сигналы, отправляемые на домены client1.com, client2, и client3.com должны отправляться на сайт host.com.<br> Вы можете реализовать такую маршрутизацию, используя следующую запись:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>client1.com = client1.com@host.com._via</span></span>
<span class="line"><span>client2.com = client2.com@host.com._via</span></span>
<span class="line"><span>client3.com = client3.com@host.com._via</span></span></code></pre></div><p>или более гибко:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>client1.com = client1.com@relay</span></span>
<span class="line"><span>client2.com = client2.com@relay</span></span>
<span class="line"><span>client3.com = client3.com@relay</span></span>
<span class="line"><span>relay = host.com._via</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Здесь вы можете указывать только <code>host.com</code> вместо <code>host.com._via</code> (подразумевается, что нет других записей в Маршрутизаторе для host.com), но в этом случае почта для <code>user@client1.com</code> будет отправляться на host.com как <code>user%client1.com@host.com</code>. Указывая суффикс <code>._via</code> вы не только говорите Маршрутизатору направить адрес в модуль ретрансляции (релеинга), но также заставляете этот модуль отправлять только локальную часть адреса на удалённый сервер.</p></div><p>Обработка Адресов без суффикса <code>._via</code></p><table tabindex="0"><thead><tr><th></th><th></th><th></th></tr></thead><tbody><tr><td><code>user @ client1.host</code></td><td>Маршрутизатор преобразовывает в</td><td><code>user%client1.host @ relay</code></td></tr><tr><td><code>user%client1.host @ relay</code></td><td>Маршрутизатор преобразовывает в</td><td><code>user%client1.host @ host.com</code></td></tr><tr><td><code>user%client1.host @ host.com</code></td><td>Маршрутизатор останавливается</td><td><em>нет правил для host.com</em></td></tr><tr><td><code>user%client1.host @ host.com</code></td><td>Маршрутизатор принимает</td><td>для хоста SIP/SMTP <code>host.com</code> как <code>user%client1.host@host.com</code></td></tr></tbody></table><p>Обработка Адресов с суффиксом <code>._via</code></p><table tabindex="0"><thead><tr><th></th><th></th><th></th></tr></thead><tbody><tr><td><code>user @ client1.host</code></td><td>Маршрутизатор преобразовывает в</td><td><code>user%client1.host @ relay</code></td></tr><tr><td><code>user%client1.host @ relay</code></td><td>Маршрутизатор преобразовывает в</td><td><code>user%client1.host @ host.com._via</code></td></tr><tr><td><code>user%client1.host @ host.com._via</code></td><td>Маршрутизатор принимает</td><td>для <code>host.com</code> как <code>user@client1.host</code></td></tr></tbody></table></li></ul><p>Если доменная часть адреса содержит суффикс <code>._via</code>, модуль проверяет последнюю часть доменного имени после удаления суффикса. Если это часть является числом, символ точка (<code>.</code>) отделяющий эту часть заменяется на символ двоеточия (<code>:</code>):</p><p><code>host.domain.dom.26.via</code> --&gt; host.domain.dom:26 Если имя домена содержит символ двоеточие, то модули SIP, XMPP и SMTP:</p><ul><li>Не используют MX/SRV записи в DNS, а запрашивают из DNS только A-записи.</li><li>Вместо использования стандартных номеров портов (25 для SMTP, 5060 для SIP) используют номер после символа двоеточие как номера TCP порта для установления соединения.</li></ul><p>Маршрутизатор также проверяет доменную часть адреса, оканчивающуюся суффиксом <code>._relay</code>. Суффикс удаляется, и получившееся доменное имя используется как конечное имя хоста (после изменения необязательного разделителя номера порта на символ двоеточие).<br> Это имя домена (после удаления необязательного номера порта и его разделителя) добавляется к локальному имени, используя символ <code>@</code> как разделитель.</p><ul><li><p>Пример:</p><p>Главный Домен Сервера <code>company.com</code>.<br> Электронная почта и Сигналы для доменов <code>xxxx.department.company.com</code> (где xxxx может быть sales, marketing и так далее) должны быть отправлены на отдельные сервера, согласно A-записям в DNS, а адреса во всех других субдоменах company.com должны обрабатываться как адреса в Главном Домене, то есть адрес <a href="mailto:user@subdomain.company.com" target="_blank" rel="noreferrer">user@subdomain.company.com</a> должен обрабатываться как адрес <a href="mailto:user@company.com" target="_blank" rel="noreferrer">user@company.com</a>.<br> Вы можете реализовать такую маршрутизацию, используя следующую запись:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>*.sales.company.com = *.sales.company.com._relay ; явно релеить наружу</span></span>
<span class="line"><span>*.company.com = company.com ; все остальные субдомены перенаправлять</span></span></code></pre></div></li></ul><p>Маршрутизатор также проверяет доменную часть адреса, оканчивающуюся суффиксом <code>._dir</code>. Суффикс обрабатывается аналогично суффиксу <code>_via</code>. Дополнительно сервер пытается прочитать запись из <a href="./../directory/">Справочника</a>, используя <code>dn</code>, построенный из оригинального адреса и домена назначения в виде <code>mail=user@domain, cn=host.com</code>.<br> Если запись может быть прочитана (для этого может быть необходимо создать <a href="./../directory/#Remote">Удалённый Том</a> для поддерева <code>cn=host.com</code>), результат обработки адреса принимается, иначе генерируется ошибка маршрутизации адреса.<br> Если используется суффикс в виде <code>._dis</code>, то <code>mail=user@domain</code> используется в качестве фильтра поиска в поддереве Справочника <code>cn=host.com</code>.<br> Если попытка прочитать запись заканчивается ошибкой, связанной с невозможностью подсоединения к удалённому серверу, генерируемая ошибка маршрутизации имеет временный характер, так что внешние отправители по протоколу SMTP попытаются доставить по этому адресу позже.</p><h2 id="PBXApp" tabindex="-1">Маршрутизация в Приложения Реального Времени <a class="header-anchor" href="#PBXApp" aria-label="Permalink to &quot;Маршрутизация в Приложения Реального Времени {#PBXApp}&quot;">​</a></h2><p>Множество Сигналов (и, в особенности, телефонные звонки) должны обрабатываться &quot;стандартными&quot; или специальными <a href="./../../development/PBXApp.html">Приложениями Реального Времени</a>. Для направления Сигналов в Приложение вам необходимо указать имя Приложения и, отделённое символом решётка (<code>#</code>), имя Пользователя, от имени которого будет запущено приложение:</p><ul><li><p>Следующие записи направляют Сигналы, отправляемые на адрес <em>someName</em>@<em>someDomain</em> в приложение <code>myProgram</code>, запущенное от имени Пользователя <code>user@domain</code>:</p><p><code>&lt;someName@someDomain&gt; = myProgram#user@domain</code></p></li></ul><p>Вы можете указать параметры приложения, добавив их после имени приложения вложенными в фигурные скобки <code>{</code> и <code>}</code> и разделив их запятой (<code>,</code>).</p><ul><li><p>Следующая запись направляет Сигналы, полученные на адрес <em>someName</em>@<em>someDomain</em> в приложение <code>myProgram</code>, запущенное от имени Пользователя <code>user@domain</code>. Программа запускается с двумя параметрами - &quot;mixer&quot; и &quot;fast&quot;:</p><p><code>&lt;someName@someDomain&gt; = myProgram{mixer,fast}#user@domain</code></p></li></ul><p>Шаблоны подстановки в правой части записи Маршрутизатора подменяются до начала обработки, так что вы можете использовать значение шаблонов подстановки в качестве параметров приложения.</p><ul><li><p>Следующая запись направляет Сигналы, отправляемые на адрес <code>+(20d)@someDomain</code> в приложение <code>myProgram</code>, запущенное от имени Пользователя <code>user@domain</code>. Программа запускается с параметром. Параметром является соединение строки <code>num=</code> и значения шаблона подстановки - телефонный номер без первого символа <code>+</code>:</p><p><code>&lt;+(20d)@someDomain&gt; = myProgram{num=*}#user@domain</code></p></li></ul><h2 id="Telnum" tabindex="-1">Маршрутизация Телефонных Номеров <a class="header-anchor" href="#Telnum" aria-label="Permalink to &quot;Маршрутизация Телефонных Номеров {#Telnum}&quot;">​</a></h2><p>Если доменной частью адреса является <code>telnum</code>, локальная часть адреса обрабатывается как телефонный номер в стандарте E.164.</p><p>Маршрутизатор предпринимает следующие шаги <strong>до</strong> применения Таблицы Маршрутизации и других методов Маршрутизации:</p><ul><li>Маршрутизатор проверяет, назначен ли телефонный номер какому-нибудь Пользователю из какого-нибудь Домена CommuniGate Pro. Если такой пользователь найден, Сигналы перенаправляются этому Пользователю. Дополнительную информацию о Назначении Телефонных Номеров смотрите в разделе <a href="./../objects/Accounts.html#Telnums">Пользователи</a>.</li><li>Маршрутизатор применяет методы <a href="#ENUM">ENUM Маршрутизации</a>, используя все указанные Телефонные домены ENUM в DNS. В среде <a href="./../cluster/">Динамического Кластера</a>, сначала проверяются Общие для Сервера ENUM Домены, затем используются Общие для Кластера ENUM Домены.</li></ul><p>Если телефонный номер не перенаправляется никаким из вышеуказанных методов, Маршрутизатор обрабатывает его как обычный адрес.</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>ENUM-Домены</b></td></tr></tbody><tbody><tr><td align="center"><input type="text" name="A000000" value="e164.arpa" size="20" maxlength="254"></td></tr><tr><td align="center"><input type="text" name="A000000" value="e164.org" size="20" maxlength="254"></td></tr><tr><td align="center"><input type="text" name="A000000" value="" size="20" maxlength="254"></td></tr></tbody></table></div></form><p>Для того, чтобы добавить ENUM Домен, введите его имя в пустое поле и нажмите кнопку Модифицировать.<br> Для того, чтобы удалить ENUM Домен, удалите его имя из поля и нажмите кнопку Модифицировать.<br> Домены используются в определённом порядке.</p><p>Смотрите раздел <a href="./../signals/PSTN.html">ТфОП</a> для дополнительной информации о работе с Телефонной Сетью Общего Пользования и маршрутизации телефонных номеров.</p><h2 id="IP" tabindex="-1">Маршрутизация по адресу IP <a class="header-anchor" href="#IP" aria-label="Permalink to &quot;Маршрутизация по адресу IP {#IP}&quot;">​</a></h2><p>После того, как применены все записи из Таблицы Маршрутизации, Маршрутизатор проверяет, не оканчивается ли в действительности имя домена IP адресом. Если IP адрес имени домена не заключён в квадратные скобки, Маршрутизатор добавляет их: <code>user@10.34.45.67</code> преобразовывается в <code>user@[10.34.45.67]</code>. Это позволяет вам указывать записи в Таблице Маршрутизации для адресов IP, полагая, что этот адрес всегда заключён в квадратные скобки.</p><p>Для адреса IP, заключённого в квадратные скобки, Маршрутизатор проверяет, не назначен ли этот адрес IP одному из Доменов на Сервере. Если такой Домен найден, то адрес IP заменяется именем этого Домена. Если адрес IP является адресом IP Главного Домена Сервера, то вместо доменной части имени используется пустая строка, и Маршрутизатор делает следующую итерацию после разбора локальной части имени адреса.</p><p>Если IP адрес не назначен локальному Домену, Маршрутизатор обрабатывает имя домена <code>[10.34.45.67]</code> как имя <a href="#Via"><code>10.34.45.67._default_port_._via</code></a>:<br> Маршрутизатор отправляет адрес в SIP или SMTP модуль, отрезая доменную часть и используя её как имя хоста для ретрансляции (релеинга).</p><h2 id="Modules" tabindex="-1">Маршрутизация через Модули <a class="header-anchor" href="#Modules" aria-label="Permalink to &quot;Маршрутизация через Модули {#Modules}&quot;">​</a></h2><p>Если никакая запись из Таблицы Маршрутизации не может применена к адресу, и адрес не является специальным адресом или адресом IP локального домена, Маршрутизатор вызывает каждый коммуникационный модуль, запрашивая выполнение операции маршрутизации.</p><p>Каждый модуль смотрит на переданный адрес и может:</p><ul><li>игнорировать адрес если модуль не знает, как его обрабатывать;</li><li>изменить адрес (например, модуль LIST преобразовывает адрес <code>listname-admin@listdomain</code> в реальный адрес владельца списка рассылки);</li><li>отвергнуть адрес (например, модуль Местной Доставки отвергает адреса <code>username@domainname</code>, если domainname - это имя локального домена, и Пользователь или Псевдоним с именем username отсутствует в Домене);</li><li>принять адрес.</li></ul><p>Если модуль изменяет адрес, Маршрутизатор производит новую итерацию, повторяя все шаги для этого нового модифицированного адреса.</p><p>Если Маршрутизатор вызывается из компонента <a href="./../mail/">Установщик Сообщений в очередь</a>, и модуль принимает адрес, сообщение ставиться в очередь в этот модуль на доставку.</p><p>Если Маршрутизатор вызывается из компонента <a href="./../cluster/Signals.html">Сигналы</a>, и модуль принимает адрес, Сигнальный Запрос отправляется в этот модуль на обработку.</p><p>Каждый модуль вызывается дважды. Первый раз Маршрутизатор вызывает каждый модуль для обработки &quot;явных&quot; адресов. В этом вызове модули обрабатывают только те адреса, которые определённо направляются в этот модуль: модуль SMTP обрабатывает адреса с доменной частью, оканчивающейся на <code>._smtp</code>, модуль LIST обрабатывает адреса существующих списков рассылки и так далее.</p><p>Если все модули проигнорировали адрес, Маршрутизатор вызывает каждый модуль снова, с запросом на &quot;финальную&quot; попытку. На этой стадии, модуль Местной Доставки обрабатывает все адреса, направляемые в локальные домены, SIP модуль принимает все адреса типа сигналы, SMTP модуль обрабатывает все адреса с именами доменов, в которых содержится хотя бы одна точка и так далее.</p><p>Этот двухпроходный метод позволяет нескольким модулям корректно обрабатывать адреса, не полагаясь на определённый порядок вызова модулей. Если бы каждый модуль обрабатывал адрес в один проход, то адреса <code>_listname@domainname_</code> (которые выглядят как адреса локальных пользователей) отвергались бы модулем Местной Доставки, если бы он вызывался до LIST модуля, адреса <code>_user@accountName.local_</code> принимались бы SMTP модулем вместо модуля Местной Доставки и так далее.</p><p>Дополнительную информацию смотрите в описаниях модулей.</p><h2 id="External" tabindex="-1">Маршрутизация через Внешних Помощников <a class="header-anchor" href="#External" aria-label="Permalink to &quot;Маршрутизация через Внешних Помощников {#External}&quot;">​</a></h2><p>После того, как применены все записи из Таблицы Маршрутизации, Маршрутизатор проверяет, не оканчивается ли имя домена строкой <code>external</code>. В этом случае доменная часть отрезается, а локальная часть передаётся в программу <a href="./Security.html#External">Внешней Аутентификации</a>.</p><p>Внешняя программа может использовать любой метод для обработки переданного адреса, и должна возвращать модифицированный адрес или код ошибки.</p><p>Если возвращается модифицированный адрес, Маршрутизатор осуществляет следующую итерацию с этим новым модифицированным адресом.</p><ul><li><p>Пример:</p><p>Сигналы на адреса, начинающиеся с <code>011</code> в любом локальном Домене должны маршрутизироваться внешней программой-помощником.<br> Вы можете реализовать такую маршрутизацию, используя следующую запись:<br><code>NoRelay:Signal:&lt;011*@*&gt; = tele-*@external ; маршрутизировать через внешнюю программу</code></p><p>Если Сигнал отправляется на 0115556666@local.domain.dom, где local.domain.dom это локальный Домен, адрес будет перенаправлен на tele-5556666@external и Внешний Помощник получит запрос на маршрутизацию адреса tele-5556666.</p></li></ul><h2 id="ENUM" tabindex="-1">Маршрутизация ENUM <a class="header-anchor" href="#ENUM" aria-label="Permalink to &quot;Маршрутизация ENUM {#ENUM}&quot;">​</a></h2><p>Маршрутизатор поддерживает базирующуюся на DNS маршрутизацию телефонных номеров. Это метод обычно применяется для <em>номеров E.164</em> - телефонных номеров, начинающихся с символа плюс, за которым следует код страны, год города и местный номер.</p><p>Если доменное имя содержит суффикс <code>._enum</code>, то Маршрутизатор:</p><ul><li>в соответствии с RFC2916 отправит DNS NATPR запрос для номера в локальной части адреса, используя имя домена (без суффикса <code>._enum</code>) как суффикс поиска.</li><li>обработает все полученные в ответ записи типа <code>E2U+SIP</code> для адресов типа Сигналы или E2U+EMAIL для других адресов.</li><li>если будет найдена отображающая строка, начинающаяся с префикса <code>sip:</code>, <code>sips:</code> или <code>mailto:</code>, удалит префикс.</li></ul><p>Маршрутизатор перезапускается, обрабатывая найденную отображающую строку как новый адрес назначения.</p><p>Если поиск в DNS возвращает ошибку &quot;unknown host name&quot;, суффикс домена <code>._enum</code> заменяется суффиксом <code>._noenum</code>, и Маршрутизатор перезапускается для обработки этого модифицированного адреса.</p><ul><li><p>Пример:</p><p>Записи в Маршрутизаторе:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;+(7-15d)@*&gt; = +*@telnum ; прямой +номер в e164 домен &quot;telnum&quot;</span></span>
<span class="line"><span>telnum = e164.arpa._enum ; прямой +номер в e164.arpa</span></span>
<span class="line"><span>e164.arpa._noenum = pstn</span></span>
<span class="line"><span>&lt;+44*@pstn&gt; = gatewaycaller{+44*}#pbx</span></span>
<span class="line"><span>pstn = main.office.dom</span></span></code></pre></div><p>Адрес +74992713154@some.local.domain.dom будет обрабатываться по следующим шагам:</p><ul><li>Первая запись в Маршрутизаторе преобразовывает этот адрес в <code>+74992713154@telnum</code></li><li>Вторая запись в Маршрутизаторе преобразовывает этот адрес в <code>+74992713154@e164.arpa._enum</code></li><li>Маршрутизатор ищет в DNS NAPTR запись <code>4.5.1.3.1.7.2.9.9.4.7.e164.arpa</code></li><li>Найдена результирующая запись <code>sip:pbx@communigatepro.ru</code>, удаляется префикс <code>sip:</code>, и Маршрутизатор перезапускается для обработки адреса <code>pbx@communigatepro.ru</code></li></ul><p>Адрес +74992713152@some.local.domain.dom будет обрабатываться по следующим шагам:</p><ul><li>Первая запись в Маршрутизаторе преобразовывает этот адрес в <code>+74992713152@telnum</code></li><li>Вторая запись в Маршрутизаторе преобразовывает этот адрес в <code>+74992713152@e164.arpa._enum</code></li><li>Маршрутизатор ищет в DNS NAPTR запись <code>2.5.1.3.1.7.2.9.9.4.7.e164.arpa</code></li><li>Для этого имени домена не существует NAPTR записи; таким образом, адрес конвертируется в <code>+74992713152@e164.arpa._noenum</code>, и Маршрутизатор перезапускается для обработки этого адреса</li><li>Третья запись Маршрутизатора преобразовывает адрес в <code>+74992713152@pstn</code> и Маршрутизатор перезапускается для обработки этого адреса</li><li>Четвёртая запись в Маршрутизаторе перенаправляет все вызовы с кодом страны <code>+44</code> на локальное PBX приложение <code>gatewaycaller</code>, но эта запись не соответствует адресу <code>+74992713152@pstn</code></li><li>Пятая запись в Маршрутизаторе перенаправляет этот адрес в <code>+74992713152@main.office.dom</code>; таким образом, Сигнал ретранслируется через сервер <code>main.office.dom</code>.</li></ul></li></ul><h2 id="маршрутизация-tel-uri" tabindex="-1">Маршрутизация <code>tel:</code> URI <a class="header-anchor" href="#маршрутизация-tel-uri" aria-label="Permalink to &quot;Маршрутизация \`tel:\` URI&quot;">​</a></h2><p>URI вида <code>tel:_phoneNumber_</code> при разборе преобразуется в <code>sip:_phoneNumber_@tel</code>. Фиктивный домен <code>tel</code> обычно перенаправляется сразу в <code>telnum</code> для обобщённой обработки телефонных номеров.</p><p>При преобразовании URI из внутреннего представления, URI вида <code>sip:_phoneNumber_@tel</code> преобразуются в <code>tel:_phoneNumber_</code>.</p><h2 id="Defaults" tabindex="-1">Записи по умолчанию <a class="header-anchor" href="#Defaults" aria-label="Permalink to &quot;Записи по умолчанию {#Defaults}&quot;">​</a></h2><p>Когда сервер CommuniGate Pro устанавливается впервые, следующие записи помещаются в Таблицу Маршрутизации:</p><ul><li><p><code>&lt;root&gt; = postmaster</code></p><p>Эта запись перенаправляет всю электронную почту и Сигналы, адресованные на имя <code>root</code>, на Пользователя postmaster.<br> Это полезно на Unix системах, где множество протоколирующих утилит настроено на отправку отчётов по почте пользователю <code>root</code>.</p></li><li><p><code>localhost =</code></p><p>На многих системах имя домена <code>localhost</code> используется для локального адреса IP системы, и некоторые почтовые программы используют это имя как имя домена.<br> Эта запись преобразовывает адреса в домене &quot;localhost&quot; на адреса в главном домене сервера.</p></li><li><p><code>mailhost =</code></p><p>Некоторые почтовые программы используют имя <code>mailhost</code> как имя домена локального почтового сервера.<br> Эта запись преобразовывает такие адреса на адреса Пользователей в Главном Домене CommuniGate Pro.</p></li><li><p><code>&lt;blacklist-admin*@blacklisted&gt; = postmaster</code></p><p>для заблокированных хостов. Эта запись реализует обработку <a href="./../mail/SMTP.html#BlackList">Неблокируемых Адресов (Белых Дыр)</a></p></li><li><p><code>&lt;\\*(3-4d)@*&gt; = voicemail#*</code></p><p>Эта запись перенаправляет все Сигналы (звонки), адресованные на номера вида <code>*_nnn_</code> и <code>*_nnnn_</code> из любых локальных Доменов в приложение <a href="./PBXVoicemail.html">PBX Voicemail</a>, запускаемое для Пользователя с Псевдонимом <em>nnn</em>.</p></li><li><p><code>&lt;7(2d)@*&gt; = pbx{*}#pbx</code></p><p>Эта запись перенаправляет все Сигналы (вызовы), адресованные на номер <code>7_nn_</code> в любом локальном Домене на Пользователя pbx в этом же Домене.<br> Эта запись Маршрутизатора необходима для реализации определённых функций поставляемого вместе с системой приложения <a href="./PBXCenter.html">PBX Центр</a>.</p></li><li><p><code>&lt;8(3d)@*&gt; = pickup{*}#pbx</code></p><p>Эта запись перенаправляет все Сигналы (вызовы), адресованные на номера вида <code>8_nn_</code> в любом локальном Домене а Пользователя pbx из этого же Домена и запускает приложение <code>pickup</code>. Приложение далее осуществляет маршрутизацию адреса <em>nnn</em>@<em>callerDomain</em> и &quot;отвечает&quot; на входящий звонок, ожидающий ответа этого Пользователя.<br> Дополнительную информацию смотрите в разделе <a href="./PBXServices.html#InPickup">Услуги PBX</a>.</p></li><li><p><code>tel = telnum</code></p><p>Эта запись используется для обработки URI вида <code>tel:_phoneNumber_</code> (смотрите <a href="#TelSchema">выше</a>).</p></li><li><p><code>&lt;+(8-20d)@*&gt; = +*@telnum</code></p><p>Эта запись перенаправляет все адреса <code>+_nnnn...nn_</code> в любом локальном Домене на фиктивный домен <code>telnum</code>.</p></li><li><p><code>Signal:telnum = pstn</code></p><p>Эта запись перенаправляет все Сигналы (вызовы) отправляемые на фиктивный домен <code>telnum</code> на фиктивный домен <code>pstn</code>.</p></li><li><p><code>Signal:&lt;*@pstn&gt; = gatewaycaller{*}#pbx</code></p><p>Эта запись перенаправляет все Сигналы (вызовы) отправляемые на фиктивный домен <code>pstn</code> на приложение <code>gatewaycaller</code>, запускаемое от имени Пользователя Главного Домена <code>pbx</code>.<br> Телефонный номер (локальная часть адреса в домене <code>pstn</code>) передаётся приложению в качестве параметра.</p></li><li><p><code>Signal:&lt;911@*&gt; = emergency@localhost</code></p><p>Эта запись перенаправляет все Сигналы (вызовы), отправляемые на адрес <code>911</code> в любом локальном Домене на имя <code>emergency</code> в домене <code>localhost</code> (это имя домена обычно направляется в Главный Домен).</p></li><li><p><code>Signal:&lt;112@*&gt; = emergency@localhost</code></p><p>Эта запись перенаправляет все Сигналы (вызовы), отправляемые на адрес <code>112</code> в любом локальном Домене на имя <code>emergency</code> в домене <code>localhost</code> (это имя домена обычно направляется в Главный Домен).</p></li><li><p><code>Signal:&lt;emergency&gt; = emergency#pbx</code></p><p>Эта запись перенаправляет все Сигналы (вызовы) отправляемые на адрес <code>emergency</code> в Главном Домене на приложение <code>emergency</code>, запускаемое от имени Пользователя Главного Домена <code>pbx</code>.</p></li><li><p><code>Signal:&lt;(7d)@*&gt; = localAreaCall{*}#pbx@localhost</code></p><p>Эта запись перенаправляет все Сигналы (вызовы) отправляемые на семизначные номера в каждом локальном Домене на приложение <code>localAreaCall</code>, запускаемое от имени Пользователя Главного Домена <code>pbx</code>.<br> Телефонный номер (локальная часть адреса) передаётся приложению в качестве параметра.</p></li></ul><p>При необходимости, все записи, добавляемые по умолчанию, могут быть изменены или удалены.</p><h2 id="Qualifier" tabindex="-1">Дополнение Неквалифицированных Доменных Имён <a class="header-anchor" href="#Qualifier" aria-label="Permalink to &quot;Дополнение Неквалифицированных Доменных Имён {#Qualifier}&quot;">​</a></h2><p>Пользователи работающие на сайтах, которые имеют много различных Серверов (<code>server1.myorg.org</code>, <code>server2.myorg.org</code>, <code>server3.myorg.org</code>) часто используют адреса с неквалифицированными доменными именами (<code>user@server1</code>, <code>user@server2</code>, <code>user@server3</code>). Когда вы имеете несколько серверов на вашем домене &quot;верхнего уровня&quot; myorg.org, вы можете &quot;исправлять&quot; такие адреса, указав в Таблице записи:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>server1 = server1.myorg.org</span></span>
<span class="line"><span>server2 = server2.myorg.org</span></span>
<span class="line"><span>server3 = server3.myorg.org</span></span></code></pre></div><p>Если в вашем домене &quot;верхнего уровня&quot; myorg.org много серверов, то становится практически невозможно указать в Таблице Маршрутизатора записи для них всех. В этом случае вы можете использовать опцию Добавлять <code>myorg.org</code> к Неквалифицированным Доменным Именам. Если эта опция включена, и для адреса не может быть найден маршрут, используя Таблицу Маршрутизатора и Модули, и доменная часть адреса не содержит символа точка, то указанная строка (<code>myorg.org</code>) будет добавлена к доменному имени (разделённая точкой). Адрес <code>user@someserver</code> будет преобразован в адрес <code>user@someserver.myorg.org</code> и Маршрутизатор попытается обработать этот новый, исправленный адрес.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Использование Неквалифицированных Доменных Имен в адресах электронной почты или Сигналах является очень плохой практикой. Включите эту опцию только если вы не можете обеспечить выполнение вашими пользователями политики использования корректных, полных имён доменов во всех используемых ими адресах.</p></div><h2 id="GlobalAliases" tabindex="-1">Общедоменные Псевдонимы <a class="header-anchor" href="#GlobalAliases" aria-label="Permalink to &quot;Общедоменные Псевдонимы {#GlobalAliases}&quot;">​</a></h2><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Общедоменные Псевдонимы</b></td></tr></tbody><tbody><tr align="left"><th>Локальное Имя</th><th>Преобразовать в</th></tr><tr><td><input type="text" name="A000000" value="abuse" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="postmaster@maindomain.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000001" value="" size="20" maxlength="254"></td><td><input type="text" name="I000001" value="" size="40" maxlength="254"></td></tr></tbody></table></div></form><p>Эта таблица позволяет вам указать псевдонимы, которые будут работать для всех локальных Доменов.</p><p>Эти записи проверяются, когда Сервер CommuniGate Pro обнаруживает сообщение или сигнал, который должен быть направлен на некоторое имя в один из локальных доменов Сервера. Если локальная часть адреса совпадает с полем Локальное Имя в одной из этих записей, то адрес направляется на указанный в поле Преобразовать в.</p><p>Если, например, адреса <code>abuse</code> и <code>postmaster@maindomain.dom</code> введены в таблицу Общедоменные Псевдонимы (как показано выше), то все сообщения, направляемые на любой адрес <code>abuse@domain.dom</code> (где <em>domain.com</em> является одним из Доменов CommuniGate Pro) преобразовывается в <code>postmaster@maindomain.com</code>.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Используя эти записи, можно очень легко создать зацикливание маршрутизации: если введёте</p></div><p><code>postmaster -&gt; postmaster@maindomain.dom</code>в эту таблицу, вы создадите зацикливание (петлю), которое приведёт к тому, что <strong>зайти на Сервер пользователем <code>_postmaster_</code> будет невозможно.</strong> Если вы хотите, чтобы электронная почта и Сигналы на все имена <code>postmaster</code> во всех Доменах CommuniGate Pro направлялась на пользователя postmaster в главном домене CommuniGate Pro, то вы должны использовать: <code>postmaster -&gt; anyname@postmaster.local</code>или, если включена опция <a href="./../mail/Local.html">Прямая адресация Папок</a>: <code>postmaster -&gt; mailboxName#postmaster</code></p><p>Вы можете использовать символы шаблона подстановки (<code>*</code>) в этих полях.</p><p>Например, вы можете создать &quot;правила набора номера&quot; вашей организации, которая имеет 10 различных отделов, и каждый обслуживается в собственном Домене:</p><form action="Null.html"><div class="settingsBox"><table width="100%"><tbody><tr><td class="settingBoxCaption" colspan="2"><b>Общедоменные Псевдонимы</b></td></tr></tbody><tbody><tr align="left"><th>Локальное Имя</th><th>Преобразовать в</th></tr><tr><td><input type="text" name="A000000" value="91*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain1.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000001" value="92*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain2.dom" size="40" maxlength="254"></td></tr><tr><td><input type="text" name="A000002" value="93*" size="20" maxlength="254"></td><td><input type="text" name="I000000" value="*@domain3.dom" size="40" maxlength="254"></td></tr></tbody></table></div></form><p>Если Пользователи в каждом Домене имеют псевдонимы в диапазоне <code>200-299</code>, то пользователи могут вызывать других пользователей в том же домене, набирая номер <code>_2xx_</code>.<br> Они набирают префикс <code>91</code> (номер <code>912_xx_</code>) для того, чтобы связаться с пользователями в Домене domain1.com.<br> Они набирают префикс <code>92</code> для того, чтобы связаться с пользователями в Домене domain2.com, и так далее.</p><h2 id="Cluster" tabindex="-1">Общекластерная Таблица Маршрутизация <a class="header-anchor" href="#Cluster" aria-label="Permalink to &quot;Общекластерная Таблица Маршрутизация {#Cluster}&quot;">​</a></h2><p><a href="./../cluster/Dynamic.html#SharedSettings">Динамический Кластер</a> CommuniGate Pro обслуживает Общекластерную Таблицу Маршрутизации. Когда вы открываете страницу Веб Администрирования Маршрутизатор у любого члена Кластера, то вы видите ссылку, с помощью которой вы можете открыть страницу с Общекластерной Таблицей Маршрутизации. Все изменения, сделанные в этой Таблице, автоматически распространяются на все члены Кластера.</p><p>Общекластерная Таблица Маршрутизации обрабатывается как расширение Таблицы Маршрутизатора Сервера: записи в Общекластерной Таблице Маршрутизации проверяются, когда никакие записи из Таблицы Маршрутизатора Сервера не могут быть применены.</p>`,167)]))}const h=o(l,[["render",d]]);export{u as __pageData,h as default};
