import{_ as a,c as o,o as t,ag as p}from"./chunks/framework.jCcxW76o.js";const u=JSON.parse('{"title":"Язык Программирования CommuniGate Pro (CG/PL)","description":"","frontmatter":{"legacyLink":"russian/CGPL.html"},"headers":[],"relativePath":"russian/development/CGPL.md","filePath":"russian/development/CGPL.md"}'),d={name:"russian/development/CGPL.md"};function c(s,e,n,l,m,i){return t(),o("div",null,e[0]||(e[0]=[p(`<h1 id="язык-программирования-communigate-pro-cg-pl" tabindex="-1">Язык Программирования CommuniGate Pro (CG/PL) <a class="header-anchor" href="#язык-программирования-communigate-pro-cg-pl" aria-label="Permalink to &quot;Язык Программирования CommuniGate Pro (CG/PL)&quot;">​</a></h1><p>Язык программирования CommuniGate Pro (CG/PL) является мощным, но, в то же время, простым процедурным языком. Он может использоваться при работе с различными компонентами Сервера CommuniGate Pro, включая:</p><ul><li><a href="./PBXApp.html">Приложения Реального Времени</a> (такие, как &quot;IP-PBX&quot; или УПАТС)</li><li><a href="./WebApp.html">Веб Приложения</a></li><li><a href="#SyncScripts">Синхронные Скрипты</a>.</li></ul><p>Структура и возможности языка остаются одинаковыми для всех приложений, но в разных средах используются различные наборы встроенных функций и процедур.</p><p>Ниже приводится пример простой CG/PL программы (с использованием как &quot;основного&quot;, так и &quot;альтернативного&quot; синтаксиса):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>//</span></span>
<span class="line"><span>// A simple CG/PL application</span></span>
<span class="line"><span>//</span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  myName = &quot;Jim&quot; + &quot; &quot; + &quot;Smith&quot;;</span></span>
<span class="line"><span>  if length(myName) &gt; 10 then</span></span>
<span class="line"><span>    myName = Substring(myName,0,8) + &quot;..&quot;;</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end;</span></span></code></pre></div><p></p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>/*</span></span>
<span class="line"><span> * A simple CG/PL application</span></span>
<span class="line"><span> */</span></span>
<span class="line"><span>entry Main {</span></span>
<span class="line"><span>  myName = &quot;Jim&quot; + &quot; &quot; + &quot;Smith&quot;;</span></span>
<span class="line"><span>  if(myName.length() &gt; 10) {</span></span>
<span class="line"><span>    myName = myName.substring(0,8) + &quot;..&quot;;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h2 id="Data" tabindex="-1">Модель Данных <a class="header-anchor" href="#Data" aria-label="Permalink to &quot;Модель Данных {#Data}&quot;">​</a></h2><p>Вся информация представляется в виде <em>объектов</em>. Объект может быть типа <a href="./Data.html#String">строка</a>, <a href="./Data.html#Number">число</a>, <a href="./Data.html#DataBlock">блок данных</a>, <a href="./Data.html#Date">отметка о времени</a>, <a href="./Data.html#IPAddr">IP адрес</a>, <a href="./Data.html#Array">массив</a>, <a href="./Data.html#Dictionary">словарь</a> или <a href="./Data.html#XML">XML объект</a>. Дополнительную информацию смотрите в разделе <a href="./Data.html">Данные</a>.</p><p>Объектом также может быть <a href="#MailboxRef"><em>описатель Папки</em></a>, <a href="#MultiTask"><em>описатель Задачи</em></a> или любой другой специальный объект, определённый для конкретной среды.</p><p>Особым типом объекта является <em>пустое значение</em> (значение <code>null</code> или значение &quot;нет объекта&quot;).</p><p>При обработке логических (<em>булевых</em>) значений, <em>пустое значение</em> используется для значения &quot;ложно&quot;, а строка &quot;YES&quot; используется для <em>значения &quot;истинно&quot;</em>.</p><h2 id="Lexemes" tabindex="-1">Лексемы <a class="header-anchor" href="#Lexemes" aria-label="Permalink to &quot;Лексемы {#Lexemes}&quot;">​</a></h2><p><em>Исходным кодом</em> программы является простой текст в кодировке UTF-8.</p><p>Лексемами языка являются:</p><ul><li><em>ключевые слова</em> - <code>and</code>, <code>by</code>, <code>elif</code>, <code>else</code>, <code>entry</code>, <code>exitif</code>, <code>external</code>, <code>false</code>, <code>for</code>, <code>forward</code>, <code>function</code>, <code>if</code>, <code>is</code>, <code>not</code>, <code>loop</code>, <code>null</code>, <code>or</code>, <code>procedure</code>, <code>return</code>, <code>spawn</code>, <code>stop</code>, <code>then</code>, <code>true</code>, <code>var</code>, <code>xor</code>, <code>while</code>. Все ключевые слова не зависит от регистра (можно задавать прописными и строчными буквами).</li><li><em>имена</em> - последовательности, начинающиеся с алфавитных символов и заканчивающиеся алфавитными символами, цифрами и/или символами подчёркивания Все имена независимы от регистра. Ключевые слова не могут использоваться в качестве имён.</li><li><em>signs</em> - <code>+</code>, <code>-</code>, <code>*</code>, <code>//</code>, <code>/</code>, <code>%</code>, <code>+=</code>, <code>-=</code>, <code>*=</code>, <code>/=</code>, <code>%=</code>, <code>=</code>, <code>==</code>, <code>!=</code>, <code>&lt;</code>, <code>&lt;=</code>, <code>&gt;</code>, <code>&gt;=</code>, <code>!</code>, <code>&amp;</code>, <code>&amp;&amp;</code>, <code>&amp;=</code>, <code>|</code>, <code>||</code>, <code>|=</code>, <code>?</code>, <code>;</code>, <code>,</code>, <code>:</code>, <code>(</code>, <code>)</code>, <code>[</code>, <code>]</code>, <code>{</code>, <code>}</code></li><li><em>числа</em> - последовательности цифр.</li><li><em>строки</em> - строки в кавычках, описанные в разделе <a href="./Data.html">Данные</a>.</li></ul><p>Комментарием являются символы двойной косой черты (<code>//</code>) и все символы, следующие за ними до символа EOL (конец строки) включительно.</p><p>Комментарий может начинаться с пары &quot;косая черта и звёздочка&quot; (<code>/*</code>) и включать в себя все символы до первой встреченной пары &quot;звёздочка и косая черта&quot; (<code>*/</code>), включая их тоже.</p><p><em>пробельные символы</em> - последовательность из 1 или более пробелов, символов табуляции, символов EOL и/или комментариев. Между именем и ключевым словом требуется как минимум один пробельный символ; другие лексемы могут разделяться любым количеством пробельных символов.</p><h2 id="Literals" tabindex="-1">Литералы <a class="header-anchor" href="#Literals" aria-label="Permalink to &quot;Литералы {#Literals}&quot;">​</a></h2><p>Литералы - это константные выражения, представляющие сами себя. Литералом является одно из следующих:</p><ul><li>лексема <em>число</em></li><li>лексема <em>строка</em></li><li>ключевое слово <code>null</code> (пустое значение)</li><li>ключевое слово <code>false</code> (значение &quot;ложно&quot;, то же, что пустое значение)</li><li>ключевое слово <code>true</code> (значение &quot;истинно&quot;)</li></ul><h2 id="ProcDefs" tabindex="-1">Разделы программы <a class="header-anchor" href="#ProcDefs" aria-label="Permalink to &quot;Разделы программы {#ProcDefs}&quot;">​</a></h2><p>Код программы состоит из нескольких разделов:</p><ul><li>Точки Входа являются разделами кода, выполняемыми при активировании программы.</li><li>Процедуры и функции являются разделами кода, которые могут использоваться в пределах Точки Входа (<em>вызываться из них</em>) или в других процедурах и/или функциях.</li></ul><p>Процедуры и функции могут вызываться <em>рекурсивно</em>: процедура или функция может вызывать саму себя - напрямую или через вызов других процедур или функций.</p><p>Все разделы кода также допускают <em>повторный вход</em>: один и тот же раздел кода может использоваться одновременно в различных <em>копиях</em> запущенных программ или <em>Задач.</em></p><p>Перед тем, как какие-либо разделы кода могут использоваться, они должны быть объявлены. Понятие объявления включает в себя также предобъявления, внешние объявления и определения.</p><p>Код программы может содержать не более одного предобъявления раздела кода, указываемого до его определения.<br> Предобъявления используются в программах, содержащих два или более раздела кода, которые могут вызывать друг друга, что делает невозможным определение каждого раздела до его использования в другом разделе кода.</p><h3 id="Modules" tabindex="-1">Модули <a class="header-anchor" href="#Modules" aria-label="Permalink to &quot;Модули {#Modules}&quot;">​</a></h3><p>Внешние объявления позволяют разделам кода вызывать другие разделы кода, определённы в отдельных <em>модулях</em> кода программы.<br> Внешние объявления разрешены только в таких средах, которые поддерживают их, например, в таких, как среды <a href="./PBXApp.html">Приложений Реального Времени</a>. Дополнительную информацию смотрите в описании среды. Если внешнее объявление задаёт имя раздела как регулярное имя, при использовании этого раздела загружается модуль с этим именем: если внешнее определение имеет вид<br><code>function myName(param) external;</code> и вызывается функция myName, тогда загружается отдельный модуль с именем &quot;myName&quot;, а в нём уже выполняется функция &quot;myName&quot;.<br> Внешнее объявление может содержать квалифицированное имя, явно задающее имя модуля: если внешнее определение имеет вид<br><code>function myModule::myName(param) external;</code> и вызывается функция myModule::myName, тогда загружается отдельный модуль с именем &quot;myModule&quot;, а в нём уже выполняется функция &quot;myName&quot;.<br> Имя раздела кода и имена его параметров, указываемые во внешнем объявлении, должны соответствовать имени раздела кода и именам его параметров, указанных в определении раздела кода, данном во внешнем модуле с кодом программы.<br> В определениях раздела кода может задаваться большее количество параметров, чем задано во внешнем объявлении. Отсутствующим параметрам присваиваются нулевые значение при использовании таких внешних объявлений.</p><p>Код программы должен содержать только одно внешнее объявление или только одно определение (но не оба) для каждого используемого раздела кода.</p><h3 id="Entry" tabindex="-1">Точки Входа <a class="header-anchor" href="#Entry" aria-label="Permalink to &quot;Точки Входа {#Entry}&quot;">​</a></h3><p>Объявление точка входа состоит из ключевого слова <code>entry</code> и имени точки входа, за которым следует:</p><ul><li><p>для предобъявления:</p><p>ключевое слово <code>forward</code> с символом точка с запятой (<code>;</code>)</p></li><li><p>для определения точки входа:</p><p>ключевое слово <code>is</code>, за которым следует последовательность операторов, оканчивающаяся ключевым словом <code>end</code> (за которым может идти ключевое слово <code>entry</code>); и символ точка с запятой (<code>;</code>)</p></li><li><p>для альтернативного определения точки входа:</p><p>левая фигурная скобка (<code>{</code>), за которой следует последовательность операторов, завершающаяся правой фигурной скобкой (<code>}</code>)</p></li></ul><p>Если работающая программа достигает конца последовательности операторов раздела точки входа, то выполняется неявный оператор <code>stop</code>.</p><p>В следующем примере демонстрируется точка входа для <a href="./PBXApp.html">Приложения Реального Времени</a>. Приложение пытается принять входящий звонок и, в случае успеха, проигрывает звуковой файл. Код точки входа заканчивает работу и приложение прекращает своё выполнение (что также прекращает звонок):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry main is</span></span>
<span class="line"><span>  if acceptCall() == null then</span></span>
<span class="line"><span>    playFile(&quot;greeting.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>Или, в альтернативном виде (также используется альтернативная форма условного оператора):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry main {</span></span>
<span class="line"><span>  if (acceptCall() == null) {</span></span>
<span class="line"><span>    playFile(&quot;greeting.wav&quot;);</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="Procedure" tabindex="-1">Процедуры <a class="header-anchor" href="#Procedure" aria-label="Permalink to &quot;Процедуры {#Procedure}&quot;">​</a></h3><p>Объявление процедуры состоит из ключевого слова <code>procedure</code>, имени процедуры, левой круглой скобки, необязательного списка имён параметров и правой круглой скобки, за которой следует:</p><ul><li><p>для предобъявления:</p><p>ключевое слово <code>forward</code> с символом точка с запятой (<code>;</code>)</p></li><li><p>для определения процедуры:</p><p>ключевое слово <code>is</code>, за которым следует последовательность операторов, оканчивающаяся ключевым словом <code>end</code> (за которым может идти ключевое слово <code>procedure</code>); и символ точка с запятой (<code>;</code>)</p></li><li><p>для альтернативного определения процедуры:</p><p>левая фигурная скобка (<code>{</code>), за которой следует последовательность операторов, завершающаяся правой фигурной скобкой (<code>}</code>)</p></li><li><p>для внешнего объявления:</p><p>ключевое слово <code>external</code> с символом точка с запятой (<code>;</code>)</p></li></ul><p>Если работающая программа достигает конца последовательности операторов процедуры, то выполняется неявный оператор <code>return</code>.</p><p>В следующем примере демонстрируется процедура для <a href="./PBXApp.html">Приложения Реального Времени</a>, произносящая заданное число:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure sayNumber(x) is</span></span>
<span class="line"><span>  x = x % 100;</span></span>
<span class="line"><span>  if x &gt;= 10 then</span></span>
<span class="line"><span>    PlayFile(String(x/10*10)+&quot;.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>  if x != 0 then</span></span>
<span class="line"><span>    PlayFile(String(x%10)+&quot;.wav&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end procedure;</span></span></code></pre></div><p>Если используется предобъявление, то определение процедуры должно иметь в точности те же самые параметры, что были указаны при предобъявлении.</p><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure sayMoney(x,units) forward;</span></span>
<span class="line"><span>procedure sayNumber(x) forward;</span></span>
<span class="line"><span>procedure sayMoney(x,units) is</span></span>
<span class="line"><span>  sayNumber(x);</span></span>
<span class="line"><span>  PlayFile(units+&quot;.wav&quot;);</span></span>
<span class="line"><span>end procedure;</span></span></code></pre></div><h3 id="Function" tabindex="-1">Функции <a class="header-anchor" href="#Function" aria-label="Permalink to &quot;Функции {#Function}&quot;">​</a></h3><p>Объявление функции осуществляется также, как и объявление процедуры, но вместо ключевого слова <code>procedure</code> используется ключевое слово <code>function</code>.</p><p>Все пути работы программы в разделе кода функции должны заканчиваться оператором <code>return</code> или <code>stop</code>.</p><p>В следующем примере определяется функция, вычисляющая факториал своего аргумента:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function Factorial(x) is</span></span>
<span class="line"><span>  if x &lt;= 1 then return 1; end if;</span></span>
<span class="line"><span>  return Factorial(x-1)*x;</span></span>
<span class="line"><span>end function;</span></span></code></pre></div><p>Ниже приводится то же определение функции в альтернативной форме с использованием тернарного оператора:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function Factorial(x) {</span></span>
<span class="line"><span>  return x &lt;= 1 ? 1 : Factorial(x-1)*x;</span></span>
<span class="line"><span>}</span></span></code></pre></div><p>Имена для всех разделов кода (точек входа, процедур и функций), используемые в одной программе, должны быть уникальными.</p><h2 id="Vars" tabindex="-1">Переменные <a class="header-anchor" href="#Vars" aria-label="Permalink to &quot;Переменные {#Vars}&quot;">​</a></h2><p>Переменные - контейнеры для данных. Любой объект (включая нулевое значение) может быть присвоен переменной и становится таким образом значением переменной. Сначала это значение является нулевым.</p><p>Переменные являются локальными по отношению к той функции/процедуре, где они были созданы. Все их значения теряются при выходе из функции/процедуры (при возврате).</p><p>Для объявления переменных используйте ключевое слово <code>var</code>, за которым указывайте список имён переменных:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var var1,var2,var3;</span></span></code></pre></div><p>При объявлении переменной ей можно сразу присвоить некоторое значение, используя выражение начального значения:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var var1=expr1,var2,var3=expr3;</span></span></code></pre></div><p>Любой раздел кода может содержать несколько объявлений <code>var</code>. Переменные можно использовать после их объявления (в разделе кода).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>var myCount = 3;       // создана переменная myCount и</span></span>
<span class="line"><span>                       // ей присвоено числовое значение 3</span></span>
<span class="line"><span>myCount = myCount + 2; // значение переменной myCount изменено на 5</span></span>
<span class="line"><span>myCount = &quot;Service&quot;;   // значение переменной myCount изменено на строку</span></span></code></pre></div><p>Если раздел кода не содержит объявлений <code>var</code>, то любое имя, не объявленное как имя <a href="#ProcDefs">процедуры или функции</a> и не совпадающее с именем <a href="#BuiltFuncs">встроенной</a> процедуры или функции, объявляет переменную.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myCount = 3;           // создана переменная myCount и</span></span>
<span class="line"><span>                       // ей присвоено числовое значение 3</span></span>
<span class="line"><span>myCount = myCount + 2; // значение переменной myCount изменено на 5</span></span>
<span class="line"><span>myCount = &quot;Service&quot;;   // значение переменной myCount изменено на строку</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Объявление переменной внутри некоторого &quot;блочного оператора&quot; (например, <code>if</code> или <code>loop</code>) действует только внутри этого блока.</p></div><p>&quot;Переменные Задачи&quot; хранятся в словаре, уникальном для каждой &quot;копии&quot; Задачи, и они могут использоваться во всех разделах после объявления переменной Задачи. Словари с переменными Задачи уничтожается после завершения Задачи.</p><p>Переменные задачи объявляются с помощью того же ключевого слова <code>var</code> и списка имён переменных, но эти объявления должны быть размещены вне любого раздела кода и не должны использовать выражений начального значения.</p><p>Альтернативой использованию &quot;переменных задачи&quot; является прямой доступ к словарю переменных, используя встроенную функцию <a href="#VarsF"><code>Vars()</code></a>.</p><h2 id="Const" tabindex="-1">Константы <a class="header-anchor" href="#Const" aria-label="Permalink to &quot;Константы {#Const}&quot;">​</a></h2><p>Константы - это имена, связанные с литералами.</p><p>Для объявления констант используйте ключевое слово <code>const</code>, за которым указывайте список имён переменных:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>const c1=1234,c2=&quot;test&quot;,cFlag=true;</span></span></code></pre></div><p>Когда используется имя константы, оно заменяется на связанное с ним значение.</p><h2 id="Exprs" tabindex="-1">Выражения <a class="header-anchor" href="#Exprs" aria-label="Permalink to &quot;Выражения {#Exprs}&quot;">​</a></h2><p>В языке реализованы унарные операции. Унарные операции задаются как</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>операция операнд</span></span></code></pre></div><p>Поддерживаются следующие унарные операции:</p><ul><li><p><code>-</code></p><p>унарный минус. Если значением операнда является число, то значением операции является число, взятое с обратным знаком; в противном случае значением операции является число 0.<br> Следующие выражения имеют значение -5:</p><p><code>-5</code><br><code>-(3+2)</code></p></li><li><p><code>+</code></p><p>унарный плюс. Если значением операнда является число, то значением операции является то же число; в противном случае значением операции является число 0.<br> Следующие выражения имеют значение 5:</p><p><code>+5</code><br><code>+(10/2)</code></p></li><li><p><code>not</code></p><p>Отрицание. Если операнд имеет нулевое значение, то значением операции является значение &quot;истинно&quot;; в противном случае значением операции является нулевое значение.<br> Вместо ключевого слова <code>not</code> может использоваться символ <code>!</code>.<br> Следующие выражения имеют значение &quot;YES&quot;:</p><p><code>not null</code><br><code>!(2 == 3)</code></p></li></ul><p>Унарные операции обладают более высоким приоритетом, чем бинарные и тернарные операции.</p><p>Следующее выражение имеют значение -1, а не -3:</p><p><code>-2 + 1</code></p><p>В языке реализованы бинарные операции. Бинарные операции задаются как</p><blockquote><p><em>левый операнд операция правый операнд</em></p></blockquote><p>Если явно не указано обратное, то сначала вычисляются оба операнда (в произвольном порядке), а затем к значениям операндов применяется операция.</p><p>Поддерживаются следующие бинарные операции, перечисленные в порядке убывания их приоритета:</p><ul><li><p><code>*</code>, <code>/</code>, <code>%</code></p><p>Эти арифметические операции могут быть применены только к операндам, имеющим числовые значения. Если ни один из этих операндов не является Числом или если правый операнд в операции <code>/</code> или <code>%</code> является числом 0, то вся операция принимает нулевое значение. Следующие выражения имеют значение 10:</p><p><code>5 \\* 2</code><br><code>-20 / -2</code><br><code>30 % 20</code></p></li><li><p><code>+</code>, <code>-</code></p><p>Эти арифметические операции могут быть применены числовым операндам, имеющим числовые значения. Операция <code>+</code> может применяться к паре строковых значений операндов и результатом также будет строка, являющаяся соединением (конкатенацией) строк. Операция <code>+</code> может применяться к паре значений операндов типа блок данных - результатом также будет блок данных, являющийся соединением (конкатенацией) блоков данных. Операция <code>+</code> может применяться к паре значений операндов блок данных и строка - результатом также будет копия блока данных с добавленными в конец блока данных байтами строки. Операция <code>+</code> может применяться к паре значений операндов блок данных и число в промежутке 0..255 - результатом также будет копия блока данных с добавленными в конец блока данных байтом (соответствующему значению числового операнда). Операция <code>+</code> может быть применена к операндам, имеющим числовое значение и значение типа отметка времени и результатом будет отметка времени, являющаяся на указанное в числовом операнде число секунд &quot;более поздней&quot;, чем первоначальная отметка времени. Операция <code>-</code> может быть применена к левому операнду, имеющему значение типа отметка времени и правому операнду, имеющему числовое значение; результатом будет отметка времени, являющаяся на указанное в числовом операнде число секунд &quot;более ранней&quot;, чем первоначальная отметка времени. Операция <code>-</code> может быть применена к паре операндов, имеющих значение типа отметка времени; результатом будет число секунд, на которое левый операнд отличается от правого. В других случаях значение операции является нулевым. Следующие выражения имеют значение 5:</p><p><code>3 + 2</code><br><code>-2 - -7</code></p><p>Следующее выражение имеет значение &quot;John Doe&quot;:</p><p><code>&quot;Joh&quot; + &quot;n Doe&quot;</code></p></li><li><p><code>&lt;</code>, <code>&lt;=</code>, <code>==</code>, <code>!=</code>, <code>&gt;=</code>, <code>&gt;</code></p><p>Эти операции сравнения могут применяться к паре числовых операндов и их результатом является истина, если условие арифметического сравнения выполняется.<br> Эти операции сравнения могут применяться к паре операндов - отметок времени и их результатом является истина, если условие арифметического сравнения выполняется.<br> Эти операции сравнения могут применяться к паре операндов - строк и их результатом является истина, если условие арифметического сравнения выполняется. Строки здесь представляются как последовательности 16-битных символов Unicode в кодировке UTF-8 и сравниваются посимвольно.<br> Эти операции сравнения могут применяться к паре операндов - блоков данных и их результатом является истина, если условие арифметического сравнения выполняется. Блоки данных представляются здесь последовательностями байт (со значениями в диапазоне 0..255) и сравниваются побайтно.<br> Операции сравнения <code>==</code>, <code>!=</code> могут также применяться к любой паре объектов для проверки, &quot;равны&quot; ли они.</p><ul><li>Нулевое значение равно только нулевому значению.</li><li>Числа равны, если равны их числовые значения.</li><li>Строки равны, если они имеют одинаковую длину и одинаковые символы в каждой позиции строки.</li><li>Блоки данных равны, если они имеют одинаковую длину и одинаковые байты данных в каждой позиции блока.</li><li>Массивы равны, если они имеют одинаковое число элементов и элементы в каждой позиции совпадают.</li><li>Словари равны, если они имеют одинаковое число пар ключ-значение, строки ключей и значения для каждого ключа совпадают в обоих словарях.</li><li>Для всех остальных типов объектов любой объект равен только самому себе (никакие два различных объекта не считаются равными).</li></ul><p>В других случаях значение операции сравнения является нулевым. Следующие выражения имеют значение &quot;YES&quot;:</p><p><code>1+2 == 3</code><br><code>2+2 != 3</code><br><code>2+2 &gt;= 3</code><br><code>&quot;Joe&quot; == &quot;Joe&quot;</code><br><code>null == (2 == 3)</code></p></li><li><p><code>and</code>, <code>or</code>, <code>xor</code>, <code>and then</code>, <code>or else</code></p><p>это логические операции сравнивают свои операнды с нулевыми значениями. Значение операции <code>and</code> является истинными, если оба операнда имеют ненулевые значения; в противном случае значения является нулевым. Символ <code>&amp;</code> может использоваться вместо ключевого слова <code>and</code>. Значение операции <code>or</code> является истинным, если хотя бы один из операндов имеет ненулевое значение; в противном случае значение является нулевым. Вместо ключевого слова <code>or</code> может использоваться символ <code>|</code>. Значение операции <code>xor</code> является нулевым, если оба операнда имеют ненулевые значения или оба операнда имеют нулевые значения. В противном случае значением операции является значение ненулевого операнда. Вместо ключевого слова <code>xor</code> может использоваться символ <code>^</code>. Операция <code>and then</code> вычисляет сначала значение левого операнда. Если его значение является нулевым, то правый операнд не вычисляется и результатом всей операции является нулевое значение. В противном случае вычисляется правый операнд и его значение становится значением операции. Символы <code>&amp;&amp;</code> могут использоваться вместо ключевого слова <code>and then</code>. Операция <code>or else</code> вычисляет сначала значение левого операнда. Если его значение является ненулевым, то правый операнд не вычисляется и результатом всей операции является значение левого операнда. В противном случае вычисляется правый операнд и его значение становится значением операции. Вместо ключевого слова <code>or else</code> могут использоваться символы <code>||</code>. Следующие выражения имеют значение &quot;YES&quot;:</p><p><code>1+2 == 3 &amp; 2+2 == 4</code><br><code>2+2 == 3 or else 7-5 == 2</code><br><code>false ^ true</code></p></li></ul><p>Бинарные операции, имеющие одинаковый приоритет, выполняются слева направо: <code>X op Y op Z</code> совпадает с <code>( X op Y ) op Z</code></p><p>Бинарные операции обладают более высоким приоритетом, чем тернарные операции.</p><p>В языке реализована одна тернарная операция:</p><ul><li><p><code>cond ? expr1 : expr2</code></p><ul><li>Вычисляется операнд <em>cond</em>.</li><li>Если вычисленное значение не является нулевым, то вычисляется операнд <em>expr1</em> и его значение становится значением операции.</li><li>В противном случае вычисляется операнд <em>expr2</em>, и его значение становится значением операции.</li></ul><p>Следующие выражения имеют значение &quot;Good&quot;:</p><p><code>3 == 3 ? &quot;Good&quot; : &quot;Bad&quot;</code><br><code>null ? 77777 : &quot;Good&quot;</code></p></li></ul><p>Тернарная операция группируется справа налево: <code>A ? B : C ? D : E</code> совпадает с <code>A ? B : (C ? D : E)</code></p><p>В языке реализованы операции с индексами:</p><p><code>объект[индекс]</code></p><ul><li><p>где</p><p>выражение <em>объект</em> должно иметь значением массив, словарь, строку или блок данных (в противном случае операция приведёт к возникновению исключительной ситуации). выражение <em>индекс</em> должно иметь цифровое значение, которое меньше числа элементов в <em>объекте</em> или меньше длины строки <em>объекта</em> или блока данных.<br> Если выражение <em>объект</em> является массивом, то операция возвращает элемент массива номер <em>индекс</em> (первый элемент имеет номер 0).<br> Попытка получения несуществующего элемента вернёт нулевое значение.<br> Присвоение нового значения первому несуществующему элементу массива добавляет в массив этот элемент с таким значением.<br> Попытка присвоения нового значения любому другому несуществующему элементу приведёт к возникновению исключительной ситуации.<br> Если SquareArray имеет значения (1,4,9,16,25), то следующее выражение имеет значение 9:</p></li></ul><p><code>SquareArray[2]</code></p><p>а следующий оператор:</p><p><code>SquareArray[5] = &quot;Blue&quot;;</code></p><p>изменяет значения SquareArray на (1,4,9,16,25,&quot;Blue&quot;).</p><p>Если выражение <em>объект</em> является словарём, то операция возвращает ключ словаря номер <em>индекс</em> (первый ключ имеет номер 0).<br> Попытка получение несуществующего ключа вернёт нулевое значение. Попытка присвоения ключу нового значения приведёт к возникновению исключительной ситуации.</p><p>Если SquareDictionary имеет значения {&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}, то следующее выражение имеет значение &quot;three&quot;:</p><p><code>SquareDictionary[2]</code></p><p>Если выражение <em>объект</em> является строкой, то операция возвращает однобайтовую строку, в которой содержится символ строки номер <em>индекс</em> (первый символ строки имеет номер 0). Попытка получение несуществующего символа вернёт нулевое значение. Попытка присвоения нового значения любому символу строки приведёт к возникновению исключительной ситуации. Если значением SquareString является &quot;grass&quot;, то следующее выражение имеет значение &quot;r&quot;:</p><p><code>SquareString[1]</code></p><p>Если выражение <em>объект</em> является блоком данных, то операция возвращает число, представляющее байт номер <em>индекс</em> в блоке данных (первый байт блока данных имеет номер 0). Байты Блока Данных имеют числовые значения без знака (в диапазоне 0..255). Попытка получение несуществующего байта вернёт нулевое значение. Попытка присвоения нового значения любому байту в Блоке Данных приведёт к возникновению исключительной ситуации.</p><p>В языке реализована работа с ключами или операции с элементами словаря:</p><p><code>словарь.имяКлюча</code></p><ul><li><p>где</p><p>выражение <em>словарь</em> должно иметь своим значением словарь (иначе операция приведёт к возникновению исключительной ситуации), а <em>имяКлюча</em> является именем. Операция ссылается на элемент <em>словаря</em>, имеющий ключ <em>имяКлюча</em>. Попытка получения элемента по несуществующему ключу вернёт нулевое значение Присвоение ключу нулевого значения приводит к удалению из словаря этой пары ключ-значение. При попытке присвоения ненулевого значения несуществующему ключу в словарь добавляется новая пара ключ-значение с таким ключом.<br> Если значениями SquareDictionary являются {&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}, то следующее выражение имеют значение 9:</p></li></ul><p><code>SquareDictionary.three</code></p><p>а следующее выражение имеет значение &quot;null&quot;:</p><p><code>SquareDictionary.four</code></p><p>В языке реализована работа с вычисляемыми ключами, или операции с элементами словаря:</p><p><code>словарь.(выражКлюча)</code></p><ul><li><p>где</p><p>выражение <em>словарь</em> должно иметь своим значением словарь и выражение <em>выражКлюча</em> должно иметь строковое значение (в противном случае операция приведёт к возникновению исключительной ситуации). Операция ссылается на элемент <em>словаря</em> по ключу, равному значению <em>выражКлюча</em>. Если SquareDictionary имеет значения {&quot;one&quot; = 1; &quot;two&quot; = &quot;four&quot;; &quot;three&quot;=9;}, то следующее выражение имеет значение &quot;9&quot;:</p></li></ul><p><code>SquareDictionary.(&quot;th&quot; + &quot;ree&quot;)</code></p><p>В языке реализована возможность вызова функций. Вызов функции задаётся как имя, за которым в круглых скобках (необязательно) содержится список выражений (<em>выражения-параметров</em>):</p><p><code>functionName()</code><br><code>functionName(arg1)</code><br><code>functionName(arg1,arg2,...)</code></p><p>Используемое <em>functionName</em> должно быть именем <a href="#BuiltFuncs">встроенной функции</a> или именем ранее <a href="#ProcDefs">определённой функции</a>. Выражения параметров (если они есть) вычисляются и код функции выполняется с использованием значений выражений параметров. Результатом функции является объект, с которым могут выполняться операции с индексами и операции с элементами словаря.</p><p>Если функция MyFunction имеет 2 параметра и возвращаемое ею значения является массивом <code>(1,&quot;four&quot;,9)</code>, то следующее выражение имеет значение &quot;four&quot;:</p><p><code>MyFunction(myData,&quot;zzz&quot;)[1]</code></p><p>Функция с одним или более параметрами может быть вызвана как <em>метод</em>:</p><p><code>arg1.functionName()</code><br><code>arg1.functionName(arg2)</code><br><code>arg1.functionName(arg2,arg3,...)</code></p><p>Вызов функции MyFunction (смотри выше) может быть осуществлен через метод:</p><p><code>myData.MyFunction(&quot;zzz&quot;)[1]</code></p><h2 id="Opers" tabindex="-1">Операторы <a class="header-anchor" href="#Opers" aria-label="Permalink to &quot;Операторы {#Opers}&quot;">​</a></h2><p>В последовательности операторов может находиться ноль или более операторов, разделяемых символом точка с запятой (<code>&#39;;&#39;</code>).</p><p>Пустой оператор не выполняет никаких действий:</p><p><code>;</code></p><p>Нулевой оператор состоит из ключевого слова <code>null</code>. Он не выполняет действий:</p><p><code>null;</code></p><p>Оператор присваивания состоит из ссылки на контейнер данных (переменную, элемент массива или элемент словаря), оператора присваивания и выражения. Выражение и ссылка на контейнер данных вычисляются (в произвольном порядке) и значение выражения используется для изменения контейнера данных.<br> Оператор <code>=</code> присваивает значение выражения контейнеру данных.</p><p><code>myVar = 123 + 111;</code><br><code>myVar = &quot;string&quot;;</code></p><p>Другие операторы присваивания состоят из бинарной операции и символа <code>=</code> . Они применяют соответствующую бинарную операцию к текущему значению контейнера данных и значению выражения и сохраняют результат в контейнере данных.</p><p><code>myVar[123] += 123; myVar.message += &quot;, program stopped&quot;;</code></p><p>Если контейнер данных является элементом массива, то этот элемент должен существовать или он должен быть первым из несуществующих элементов; то есть, если в массиве имеется три элемента, то вы можете присваивать значения элементам 0,1,2 и 3. В последнем случае в массив добавляется новый элемент.</p><p>Если контейнер данных является элементом массива, то присвоение ему нулевого значения фактические удаляет этот элемент из словаря.</p><p>Оператор вызова процедуры задаётся также, как выражение вызова функции. Используемое имя должно быть именем <a href="#BuiltFuncs">встроенной процедуры</a> или именем ранее <a href="#ProcDefs">определённой процедуры</a>.</p><p>Если процедура MyProc имеет два параметра, то следующий оператор является корректным вызовом процедуры:</p><p><code>MyProc(myData,&quot;zzz&quot;);</code></p><p>Для процедуры, имеющей один или более параметров, оператор вызова может быть указан как <em>метод:</em></p><p><code>arg1.procedureName()</code><br><code>arg1.procedureName(arg2)</code><br><code>arg1.procedureName(arg2,arg3,...)</code></p><p>Вызов процедуры MyProc (смотрите выше) может быть осуществлен через метод:</p><p><code>myData.MyProc(&quot;zzz&quot;);</code></p><p>Оператор stop прекращает выполнение Задачи. Он состоит из ключевого слова <code>stop</code>:</p><p><code>stop;</code></p><p>Оператор return завершает выполнение процедуры или функции.<br> Оператор return в функции состоит из ключевого слова <code>return</code> и выражения. Это выражение вычисляется, и его значение становится значением вызванной функции.</p><p><code>return 12*year+month;</code></p><p>Оператор return в процедуре состоит из ключевого слова <code>return</code>.</p><p><code>return;</code></p><p>Условный оператор состоит из ключевого слова <code>if</code>, за которым следует выражение (<em>if-выражение</em>), ключевого слова <code>then</code>, последовательности операторов (<em>if-последовательность</em>) и ключевого слова <code>end</code>, за которым может быть указано ключевое слово <code>if</code>.<br> Если <em>if-выражение</em> вычислено и имеет ненулевое значение, то выполняется <em>if-последовательность</em>, после чего выполнение условного оператора завершается.</p><p>В следующем примере значение переменной myCount увеличивается на 2, если это значение меньше 10:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>Условный оператор может после <em>if-последовательности</em> иметь одну или более <em>elif-последовательностей</em>. Каждая <em>elif-часть</em> состоит из ключевого слова <code>elif</code>, выражения (<em>elif-выражение</em>), ключевого слова <code>then</code> и последовательности операторов (<em>elif-последовательность</em>).<br> Если <em>if-выражение</em> имеет нулевое значение, то вычисляется первое <em>elif-выражение</em> и, если оно, в свою очередь, имеет ненулевое значение, то выполняется эта <em>elif-последовательность</em>, после чего выполнение условного оператора завершается. Если значение <em>elif-выражения</em> является нулевым, то обрабатывается следующая <em>elif-часть</em>.<br> В следующем примере проверяется значение переменной myCount. Если значение меньше 10, то значение переменной увеличивается на 2. Иначе (т.е., если значение переменной не меньше, чем 10), если значение меньше чем 20, то оно уменьшается на 3:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>elif myCount &lt; 20 then</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>Условный оператор может содержать <em>else-часть</em>. Она указывается после <em>if-последовательности</em> и после всех <em>elif-частей</em> (если такие есть). <em>Else-часть</em> состоит из ключевого слова <code>else</code> и последовательности операторов (<em>else-последовательность</em>).<br> Если <em>if-выражение</em> имеет нулевое значение, а также все (если есть) <em>elif-выражения</em> имеют нулевые значения, то выполняется <em>else-последовательность</em>, после чего выполнение условного оператора завершается.<br> В следующем примере значение переменной myCount увеличивается на 2, если её текущее значение меньше 10; уменьшается на 3, если значение не меньше 10, но меньше 20 и умножается на 4 во всех других случаях:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if myCount &lt; 10 then</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>elif myCount &lt; 20 then</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>else</span></span>
<span class="line"><span>  myCount = myCount * 4;</span></span>
<span class="line"><span>end if;</span></span></code></pre></div><p>Оператор цикла состоит из ключевого слова <code>loop</code> перед которым может быть задана преамбула; последовательности операторов (<em>начальная последовательность</em>) и ключевого слова <code>end</code>, за которым может идти ключевое слово <code>loop</code>.<br> Повторяется выполнение операторов в последовательности.<br> Преамбула для <em>цикла while</em> состоит из ключевого слова <code>while</code> и выражения (<em>while-выражения</em>).<br> while-выражение вычисляется перед выполнением последовательности операторов. Если результатом while-выражения является нулевое значение, оператор цикла заканчивается.<br> Преамбула для <em>цикла for</em> состоит из ключевого слова <code>for</code>, за которым может следовать <em>оператор инициализации</em>, за которым могут следовать ключевое слово <code>while</code> и выражение (<em>while-выражение</em>), за которыми могут следовать ключевое слово <code>by</code> с оператором присвоения (<em>оператор итерации</em>).<br><em>Оператор инициализации</em> - это либо оператор присвоения, либо ключевое слово <code>var</code> с объявлениями переменных. В последнем случае объявленные переменные могут использоваться только внутри <em>while-выражения</em>, <em>оператора итерации</em> и последовательности операторов цикла.<br> Если указан <em>оператор инициализации</em>, то он выполняется один раз, когда начинается обработка цикла.<br> Если указано <em>while-выражение</em>, то оно вычисляется перед каждым выполнением последовательности операторов цикла. Если результатом while-выражения является нулевое значение, оператор цикла заканчивается.<br> Если указан <em>оператор итерации</em>, то он выполняется после каждого выполнения последовательности операторов цикла.</p><p>В следующем примере проверяется значение переменной myCount, и оно увеличивается на 2, пока это значение меньше 10:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>while myCount &lt; 10 loop</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>В следующем примере происходит вызов процедуры myProc в цикле без условий:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>loop</span></span>
<span class="line"><span>  myProc(2,&quot;test.wav&quot;);</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>В следующем примере происходит вызов процедуры myProc 3 раза, со значениями параметра 5,7,9:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>for i = 5 while i &lt; 10 by i += 2 loop</span></span>
<span class="line"><span>  myProc(i);</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><p>Оператор может содержать одну или более <em>exitif-частей</em> между начальной последовательностью и ключевым словом <code>end</code>. Каждая exitif-часть состоит из ключевого слова <code>exitif</code>, выражения (<em>exitif-выражение</em>), символа точка с запятой (<code>;</code>) и последовательности операторов. После выполнения начальной последовательности вычисляется первое <em>exitif-выражение</em>. Если его значение не является нулевым, то выполнение оператора <code>loop</code> прекращается. В противном случае выполняется последовательность операторов <code>exitif</code> и вычисляется следующее <em>выражение exitif</em>. После выполнения последнего оператора exitif выполнение оператора <code>loop</code> повторяется.</p><p>В следующем примере к переменной myWord добавляется строка &quot;aaa&quot;, проверяется длина переменной, если длина меньше 20, то к переменной myWord добавляется строка &quot;bbb&quot; и процесс повторяется:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>loop</span></span>
<span class="line"><span>  myWord = myWord + &quot;aaa&quot;;</span></span>
<span class="line"><span>exitif length(myWord) &gt;= 20;</span></span>
<span class="line"><span>  myWord = myWord + &quot;bbb&quot;;</span></span>
<span class="line"><span>end loop;</span></span></code></pre></div><h3 id="альтернативные-формы" tabindex="-1">Альтернативные Формы <a class="header-anchor" href="#альтернативные-формы" aria-label="Permalink to &quot;Альтернативные Формы&quot;">​</a></h3><p>Некоторые операторы в последовательности могут быть представлены в <em>альтернативной</em> форме. Операторы в <em>альтернативной</em> форме не оканчиваются символом точка с запятой.</p><p>Альтернативная форма условного оператора состоит из ключевого слова <code>if</code>, за которым следует выражение (<em>if-выражение</em>) и последовательности операторов (<em>if-последовательность</em>), заключённой в фигурные скобки <code>{</code> и <code>}</code>.<br> Альтернативная форма условного оператора может содержать одну (или более) elif-частей после заключённой в фигурные скобки if-последовательности. Каждая elif-часть состоит из ключевого слова <code>elif</code>, выражения (<em>elif-выражение</em>) и последовательности операторов (elif-последовательность), заключённой в фигурные скобки.<br> Альтернативная форма условного оператора может содержать else-часть. Она указывается после заключённой в фигурные скобки if-последовательности и после всех возможных elif-частей. Else-часть состоит из ключевого слова <code>else</code> и последовательности операторов (<em>else-последовательность</em>), заключённых в фигурные скобки.</p><p>В следующем примере значение переменной myCount увеличивается на 2, если её текущее значение меньше 10; уменьшается на 3, если значение не меньше 10, но меньше 20 и умножается на 4 во всех других случаях:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>if (myCount &lt; 10) {</span></span>
<span class="line"><span>  myCount = myCount + 2;</span></span>
<span class="line"><span>} elif (myCount &lt; 20) {</span></span>
<span class="line"><span>  myCount = myCount - 3;</span></span>
<span class="line"><span>} else {</span></span>
<span class="line"><span>  myCount = myCount * 4;</span></span>
<span class="line"><span>}</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>If-выражения или elif-выражения заключать в круглые скобки необязательно.</p></div><p>Альтернативная форма оператора цикла while состоит из ключевого слова <code>while</code>, за которым следует выражение (<em>while-выражение</em>), левая фигурная скобка (<code>{</code>), последовательность операторов (<em>начальная последовательность</em>) и правая фигурная скобка <code>}</code>.<br> Альтернативная форма оператора цикла for состоит из ключевого слова <code>for</code>, за которым следует левая круглая скобка (<code>(</code>), необязательный <em>оператор инициализации</em>, точка с запятой (<code>;</code>), необязательное выражение условия (<em>while-выражение</em>), точка с запятой (<code>;</code>), необязательный <em>оператор итерации</em>, правая круглая скобка (<code>)</code>), левая фигурная скобка (<code>{</code>), последовательность операторов (<em>начальная последовательность</em>) и правая фигурная скобка <code>}</code>.<br> Каждая возможная exitif-часть состоит из ключевого слова <code>exitif</code>, выражения (exitif-выражение), символа точка с запятой (<code>;</code>) и последовательности операторов.</p><p>В следующем примере к переменной myWord добавляется строка &quot;aaa&quot;, проверяется длина переменной, если длина меньше 20, то к переменной myWord добавляется строка &quot;bbb&quot; и процесс повторяется:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>while ( true ) {</span></span>
<span class="line"><span>  myWord = myWord + &quot;aaa&quot;;</span></span>
<span class="line"><span>exitif (length(myWord) &gt;= 20);</span></span>
<span class="line"><span>  myWord = myWord + &quot;bbb&quot;;</span></span>
<span class="line"><span>}</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Exitif-выражения или while-выражения заключать в круглые скобки необязательно.</p></div><p>В следующем примере вычисляется факториал значения переменной X и присваивается переменной myFactor.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myFactor = 1;</span></span>
<span class="line"><span>for(i = 0; i &lt;= X; i += 1) {</span></span>
<span class="line"><span>  myFactor *= i;</span></span>
<span class="line"><span>}</span></span></code></pre></div><h2 id="BuiltFuncs" tabindex="-1">Встроенные Процедуры и Функции <a class="header-anchor" href="#BuiltFuncs" aria-label="Permalink to &quot;Встроенные Процедуры и Функции {#BuiltFuncs}&quot;">​</a></h2><p>Следующие процедуры и функции являются встроенными в язык, и они доступны для всех приложений: Нельзя использовать их имена для собственных определений процедур или функций.</p><ul><li><p><code>Same(arg1,arg2)</code></p><p>Эта функция возвращает значение истина, если значения аргументов <em>arg1</em> и <em>arg2</em> являются одним и тем же объектом или если оба они имеют нулевые значения, или если оба значения являются истинными. В других случаях функция возвращает нулевое значение. Значение функции <code>Same(&quot;J&quot; + &quot;ack&quot;,&quot;Jack&quot;)</code> является нулевым. В следующем примере:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>x = &quot;my string&quot;;</span></span>
<span class="line"><span>y = &quot;my string&quot;;</span></span>
<span class="line"><span>z = x;</span></span>
<span class="line"><span>test1 = Same(x,y);</span></span>
<span class="line"><span>test2 = Same(x,x);</span></span>
<span class="line"><span>test3 = Same(x,z);</span></span></code></pre></div><p>результатом <code>test1</code> является нулевое значение, а результатами <code>test2</code> и <code>test3</code> является значение истина.</p></li><li><p><code>Copy(arg)</code></p><p>Если значение <em>arg</em> является нулевым, то эта функция возвращает нулевое значение. В противном случае, функция возвращает копию значения <em>arg</em>. Для сложных объектов (таких, как массивы, словари, XML объекты), эта функция копирует также все элементы сложных объектов.</p></li><li><p><code>Length(arg)</code></p><p>Если <em>arg</em> является строкой, то это функция возвращает размер строки (в байтах); Если <em>arg</em> является блоком данных, то это функция возвращает размер блока данных (в байтах); Если <em>arg</em> является массивом, то это функция возвращает число элементов массива; Если <em>arg</em> является словарём, то это функция возвращает число ключей словаря; Если <em>arg</em> является описателем папки, то это функция возвращает число сообщений в папке; Во всех других случаях эта функция возвращает число 0.</p></li><li><p><code>Min(arg1,arg2)</code></p><p>Если значение <em>arg1</em> <code>&lt;</code> значения <em>arg2</em>, то функция возвращает значение <em>arg1</em>, иначе она возвращает значение <em>arg2.</em> Смотрите выше определение операции <code>&lt;</code>.</p></li><li><p><code>Max(arg1,arg2)</code></p><p>Если значение <em>arg1</em> <code>&gt;</code> значения <em>arg2</em>, то функция возвращает значение <em>arg1</em>, иначе она возвращает значение <em>arg2.</em> Смотрите выше определение операции <code>&gt;</code>.</p></li><li><p><code>Void(arg1)</code></p><p>Эта процедура не делает ничего, значение <em>arg1</em> выбрасывается. Эта процедура полезна для вызова функции, значение которой не представляет интереса.</p></li><li><p><code>ProcCall(name)</code><br><code>ProcCall(name,arg1)</code><br><code>ProcCall(name,arg1,arg2)</code><br><code>ProcCall(name,arg1,....)</code></p><p>У этой процедуры 1 или более параметров. Значение <em>name</em> должно быть строкой, задающей простое или квалифицированное имя внешней процедуры. Эта внешняя процедура будет вызвана с оставшимися параметрами. Для вызываемых таким образом процедур не нужны внешние объявления.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>ProcCall(&quot;myModule::myProc&quot;,123,&quot;2222&quot;);</span></span></code></pre></div><p>обрабатывается так же, как</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>procedure myModule::myProc(x,y) external;</span></span>
<span class="line"><span>myModule::myProc(123,&quot;2222&quot;);</span></span></code></pre></div></li><li><p><code>FuncCall(name)</code><br><code>FuncCall(name,arg1)</code><br><code>FuncCall(name,arg1,arg2)</code><br><code>FuncCall(name,arg1,....)</code></p><p>У этой функции 1 или более параметров. Значение <em>name</em> должно быть строкой, задающей простое или квалифицированное имя внешней функции. Эта внешняя функция будет вызвана с оставшимися параметрами. Для вызываемых таким образом функций не нужны внешние объявления.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>x = FuncCall(&quot;myModule::myFunc&quot;,123,&quot;2222&quot;);</span></span></code></pre></div><p>обрабатывается так же, как</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>function myModule::myFunc(x,y) external;</span></span>
<span class="line"><span>x = myModule::myFunc(123,&quot;2222&quot;);</span></span></code></pre></div></li><li><p><code>objectClass(arg)</code></p><p>эта функция возвращает строку с именем класса, которому принадлежит значение <em>arg</em> (&quot;SharedString&quot; для строк, &quot;SharedNumber&quot; для чисел, &quot;SharedDate&quot; для отметок времени, &quot;SharedData&quot; для блоков данных и т.д.)</p></li></ul><h3 id="Strings" tabindex="-1">Строки <a class="header-anchor" href="#Strings" aria-label="Permalink to &quot;Строки {#Strings}&quot;">​</a></h3><ul><li><p><code>IsString(arg)</code></p><p>Эта функция возвращает истину, если <em>arg</em> является строкой; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>String(arg)</code></p><p>Если значением <em>arg</em> является строка, то эта функция возвращает эту строку. Если значением <em>arg</em> является число, то эта функция возвращает строку с десятичным представление этого числа. Если значением <em>arg</em> является блок данных, то эта функция возвращает строку, в которой содержится этот блок данных (интерпретируемый как текстовые данные). Если значением <em>arg</em> является отметка времени, то эта функция возвращает её текстовое представление в стандартном для системы виде. Если значением <em>arg</em> является IP адрес, то эта функция возвращает каноническое представление этого сетевого адреса. Если значением <em>arg</em> является Объект XML, то эта функция возвращает текстовое тело Объекта XML (&quot;текстовый узел&quot;). Если значение <em>arg</em> является нулевым, то эта функция возвращает нулевое значение. Во всех других случаях эта функция возвращает строку с текстовым представлением значения <em>arg</em>.</p></li><li><p><code>Substring(str,from,len)</code></p><p>Если значением <em>str</em> является строка, значением <em>from</em> является число, а значение <em>len</em> является неотрицательным числом, то эта функция возвращает строку, являющуюся подстрокой строки <em>str</em> и имеющую длину <em>len</em>. Если <em>from</em> имеет неотрицательное значение, то подстрока начинается с позиции <em>from</em> (первый символ строки имеет позицию 0). Если <em>from</em> имеет отрицательное значение, то подстрока заканчивается в позиции -1-<em>from</em>, считая от конца строки (для того, чтобы включить в подстроку только последний символ из <em>str</em>, значение <em>from</em> должно быть -1). Если значение <em>from</em> (или значение -1-<em>from</em>) равно или больше длине строки <em>str</em>, то результатом является пустая строка. Если значение <em>from</em> + <em>len</em> (или -1-<em>from</em> + <em>len</em>) больше, чем длина строки <em>str</em>, то результирующая строка будет короче <em>len</em>. Во всех других случаях эта функция возвращает нулевое значение.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Эта функция интерпретирует сроку как последовательность байт, и, как следствие, она может исказить не-ASCII символы, хранящиеся в виде многобайтовой последовательности.</p></div></li><li><p><code>FindSubstring(str,substr)</code><br><code>FindSubstring(str,substr,offset)</code></p><p>Значения <em>str</em> и <em>substr</em> должны быть строками, а значение <em>offset</em> должно быть числом. Функция проверяет, что значение <em>substr</em> является подстрокой в строке значения <em>str</em>. Если параметр <em>offset</em> задан, и его значение больше нуля, то во время поиска игнорируются первые <em>offset</em> байт значения <em>str</em>, и результатом является позиция первого вхождения подстроки в значении <em>str</em>. Если параметр <em>offset</em> задан, и его значение меньше нуля, то во время поиска игнорируются последние -1-<em>offset</em> байт значения <em>str</em>, и результатом является позиция последнего вхождения подстроки в значении <em>str</em>. Все позиции считаются от 0.<br> Если подстрока не найдена, эта функция возвращает число -1.<br> Пример 1. Например, значением <code>FindSubstring(&quot;forest&quot;,&quot;for&quot;)</code> является 0.<br> Пример 2. Значением <code>FindSubstring(&quot;A forest&quot;,&quot;for&quot;)</code> является 2.<br> Пример 3. Значением <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;, 1)</code> является 2.<br> Пример 4. Значением <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;, 4)</code> является 9.<br> Пример 5. Значением <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;, -3)</code> является 9.<br> Пример 6. Значением <code>FindSubstring(&quot;A forest for all&quot;,&quot;for&quot;, -5)</code> является 2.</p></li><li><p><code>Range(str,from,len)</code></p><p>Эта функция работает так же, как и функция <code>Substring</code>, но если значение <em>str</em> является строкой, то она интерпретируется как последовательность &quot;глифов&quot; - одно- и многобайтовых последовательностей, представляющих ASCII и не-ASCII символы. Значения <em>from</em> и <em>len</em> задают позицию подстроки и её длину в терминах символов, а не байт. Если <em>str</em> является блоком данных, то функция возвращает блок данных, содержащий часть значений <em>str</em> и вырезанный с использованием вышеописанных правил, где <em>from</em> и <em>len</em> задают позицию и длину в байтах.</p></li><li><p><code>EOL()</code></p><p>Эта функция возвращает строку, содержащую символ(ы) EOL (конца строки), используемые в ОС Сервера.</p></li><li><p><code>CRLF()</code></p><p>Эта функция возвращает строку с символами EOL, принятыми в Интернет (<code>&lt;возврат каретки&gt;&lt;перевод строки&gt;</code>).</p></li><li><p><code>ToUpperCase(str)</code></p><p>Если значением <em>str</em> является строка, то результатом функции будет строка, все буквы в которой преобразованы к верхнему регистру.</p></li><li><p><code>ToLowerCase(str)</code></p><p>Если значением <em>str</em> является строка, то результатом функции будет строка, все буквы в которой преобразованы к нижнему регистру.</p></li><li><p><code>IsDigit(str)</code></p><p>Эта функция возвращает значение истина, если <em>str</em> является строкой из одного символа и этот символ является десятичной цифрой (<code>0</code>..<code>9</code>); в противном случае функция возвращает нулевое значение.</p></li><li><p><code>IsWhiteSpaces(str)</code></p><p>Эта функция возвращает истину, если значением <em>str</em> является строка, содержащая только &quot;пробельные символы&quot;: пробелы, символы табуляции <code>&lt;tab&gt;</code>, возврата каретки <code>&lt;carriage-return&gt;</code> или перевода строки <code>&lt;line-feed&gt;</code>; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>FindRegEx(str,picture)</code></p><p>Эта функция сравнивает строку <em>str</em> с шаблоном <em>picture</em> строки, содержащем <em>регулярные выражения</em>. Если <em>str</em> или <em>picture</em> не являются строками, или строка <em>picture</em> не может быть интерпретирована как <em>регулярное выражение</em>, или строка <em>str</em> не соответствует <em>регулярному выражению</em>, то функция возвращает нулевое значение. В противном случае функция возвращает массив строк. Нулевой элемент этого массива содержит копию строки <em>str</em>, а остальные дополнительные элементы (если они есть) содержат подстроки строки <em>str</em>, соответствующие <em>группам регулярных выражений</em>. В строке <em>picture</em> должно быть задано регулярное выражение в соответствии с <em>расширенным синтаксисом POSIX</em>.</p></li><li><p><code>EmailDomainPart(address)</code></p><p>Если значение <em>address</em> является строкой и строка содержит символ @, то эта функция возвращает строку, содержащую часть строки <em>address</em> после первого символа @. В противном случае функция возвращает нулевое значение.</p></li><li><p><code>EmailUserPart(address)</code></p><p>Если значение <em>address</em> не является строкой, то эта функция возвращает нулевое значение. Если значение <em>address</em> не содержит символ @, то эта функция возвращает ту же самую строку. В противном случае (значение <em>address</em> является строкой, содержащей символ @), эта функция возвращает строку, содержащую часть строки <em>address</em> перед первым символом @.</p></li></ul><h3 id="Numbers" tabindex="-1">Числа <a class="header-anchor" href="#Numbers" aria-label="Permalink to &quot;Числа {#Numbers}&quot;">​</a></h3><ul><li><p><code>IsNumber(arg)</code></p><p>Эта функция возвращает значение истина, если <em>arg</em> является числом; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>Number(arg)</code></p><p>Если значением <em>arg</em> является число, то эта функция возвращает это же число. Если значением <em>arg</em> является строка, то эта функция возвращает числовое значение этой строки до первого нецифрового символа. Например, значением <code>Number(&quot;123#&quot;)</code> является 123. Во всех других случаях эта функция возвращает число 0.</p></li><li><p><code>RandomNumber()</code></p><p>Эта функция возвращает случайное целое число в диапазоне <code>[0..9223372036854775807]</code> (<code>[0..2*63-1]</code>).</p></li></ul><h3 id="TimeStamps" tabindex="-1">Отметки Времени <a class="header-anchor" href="#TimeStamps" aria-label="Permalink to &quot;Отметки Времени {#TimeStamps}&quot;">​</a></h3><ul><li><p><code>IsDate(arg)</code></p><p>Эта функция возвращает истину, если <em>arg</em> является отметкой времени; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>Date(arg)</code></p><p>Если значением <em>arg</em> является отметка времени, то эта функция возвращает эту отметку времени. Если значением <em>arg</em> является число 0, то эта функция возвращает отметку времени &quot;далёкого прошлого&quot;. Если значением <em>arg</em> является отрицательное число, то эта функция возвращает отметку времени &quot;далёкого будущего&quot;. Если значением <em>arg</em> является положительное число N, то эта функция возвращает отметку времени, соответствующую началу N-ного дня, считая со 2-го января 1970-го. Если значением <em>arg</em> является строка, являющаяся текстовым представлением отметки времени, то эта функция возвращает эту отметку времени. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>GMTTime()</code></p><p>Эта функция возвращает объект - отметку времени, имеющую значение текущего времени GMT.</p></li><li><p><code>LocalTime()</code></p><p>Эта функция возвращает объект - отметку времени, имеющую значение текущего локального времени.</p></li><li><p><code>GMTToLocal(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает отметку времени, содержащую конвертированное из GMT в локальное время значение <em>arg</em>. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>LocalToGMT(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает отметку времени, содержащее конвертированное из локального времени в GMT время значение <em>arg</em>. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>Year(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее год из значения <em>arg</em>. Если отметка времени имеет значение &quot;далёкое прошлое&quot;, то эта функция возвращает число 0. Если отметка времени имеет значение &quot;далёкое будущее&quot;, то эта функция возвращает число 9999. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>Month(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает строку, содержащую имя месяца из значения <em>arg</em> (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec). Если значение <em>arg</em> является числом в диапазон 1..12, то эта функция возвращает строку, содержащее имя месяца номер <em>arg</em> (<code>Month(1)</code> возвращает Jan). Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>MonthNum(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее номер месяца из значения <em>arg</em> (1 для Января). Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>MonthDay(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее день месяца из значения <em>arg</em> (1 возвращается для первого дня месяца). Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>Hour(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее час из значения <em>arg</em>. Если отметка времени имеет значение &quot;далёкое прошлое&quot;, то эта функция возвращает число 0. Если отметка времени имеет значение &quot;далёкое будущее&quot;, то эта функция возвращает число 9999. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>Minute(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее минуты из значения <em>arg</em>. Если отметка времени имеет значение &quot;далёкое прошлое&quot;, то эта функция возвращает число 0. Если отметка времени имеет значение &quot;далёкое будущее&quot;, то эта функция возвращает число 9999. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>Second(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее секунды из значения <em>arg</em>. Если отметка времени имеет значение &quot;далёкое прошлое&quot;, то эта функция возвращает число 0. Если отметка времени имеет значение &quot;далёкое будущее&quot;, то эта функция возвращает число 9999. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>WeekDay(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает день недели из значения <em>arg</em> (Mon, Tue, Wed, Thu, Fri, Sat, Sun). Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>YearDay(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число, содержащее день года из значения <em>arg</em> (число 1 возвращается для первого января). Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>TimeOfDay(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число секунд между датой из значения <em>arg</em> и началом этой даты. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>DateNumber(arg)</code></p><p>Если значение <em>arg</em> является отметкой времени, то эта функция возвращает число полных дней между датой из значения <em>arg</em> и первым января 1970. Во всех других случаях эта функция возвращает нулевое значение.</p></li><li><p><code>DateByMonthDay(year,monthNum,monthDay)</code></p><p>Значения <em>year</em>, <em>monthNum</em>, <em>monthDay</em> должны быть положительными числами. Если любой из этих объектов задан некорректно, то эта функция возвращает нулевое значение. В противном случае функция возвращает объект с отметкой времени, представляющий указанную дату. Следующее выражение имеет своим значением отметку времени в полночь 5 ноября 2008 года:</p><p><code>DateByMonthDay(2008,11,5)</code></p></li><li><p><code>DateByYearDay(year,yearDay)</code></p><p>Значения <em>year</em>, <em>yearDay</em> должны быть положительными числами. Если любой из этих объектов задан некорректно, то эта функция возвращает нулевое значение. В противном случае функция возвращает объект с отметкой времени, представляющий полночь указанной даты. Следующее выражение имеет своим значением отметку времени в полночь 1 февраля 2006 года:</p><p><code>DateByYearDay(2006,32)</code></p></li></ul><h3 id="IPAddrs" tabindex="-1">Адреса IP <a class="header-anchor" href="#IPAddrs" aria-label="Permalink to &quot;Адреса IP {#IPAddrs}&quot;">​</a></h3><ul><li><p><code>IsIPAddress(arg)</code></p><p>Эта функция возвращает истину, если значение <em>arg</em> является адресом IP; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>IPAddress(arg)</code></p><p>Если значением <em>arg</em> является адрес IP, то эта функция возвращает этот адрес IP. Если значением <em>arg</em> является строка с корректным представлением адреса IP (возможно с номером порта), то эта функция возвращает этот адрес IP. Во всех других случаях эта функция возвращает нулевое значение.</p></li></ul><h3 id="Datablocks" tabindex="-1">Блоки Данных <a class="header-anchor" href="#Datablocks" aria-label="Permalink to &quot;Блоки Данных {#Datablocks}&quot;">​</a></h3><ul><li><p><code>IsData(arg)</code></p><p>Эта функция возвращает истину, если <em>arg</em> является блоком данных; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>RandomData(length)</code></p><p>Значение <em>length</em> должно быть положительным числом, не превышающим 4096. Эта функция возвращает блок данных указанной длины, заполненный случайными данными.</p></li><li><p><code>EmptyData()</code></p><p>Эта функция пустой блок данных.</p></li></ul><h3 id="Arrays" tabindex="-1">Массивы <a class="header-anchor" href="#Arrays" aria-label="Permalink to &quot;Массивы {#Arrays}&quot;">​</a></h3><ul><li><p><code>IsArray(arg)</code></p><p>Эта функция возвращает истину, если <em>arg</em> является массивом; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>NewArray()</code></p><p>Эта функция создаёт новый пустой массив.</p></li><li><p><code>Invert(arg)</code></p><p>Значение <em>arg</em> должно быть массивом, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Эта функция возвращает массив, содержащий те же самые элементы, что и <em>arg</em>, но в обратном порядке.</p></li><li><p><code>Find(source,object)</code></p><p>Если значением <em>source</em> является массив, то эта функция возвращает число - индекс первого элемента в массиве, равного значению <em>object</em>. Если в массиве <em>source</em> не содержится такого объекта, то возвращается отрицательное числовое значение. Если значением <em>source</em> является объект <a href="#Calendars">описателя Календаря</a>, результатом функции будут события из календаря (смотрите ниже). Если значением <em>source</em> является что-то ещё, то возвращается отрицательное числовое значение.</p></li><li><p><code>AddElement(target,element)</code></p><p>Если значение <em>target</em> является массивом, то эта процедура добавляет значение <em>element</em> как новый последний элемент этого массива. Если значением myArray является (1,4,9,16,25), то вызов <code>AddElement(myArray,&quot;test&quot;)</code> изменит значение myArray на (1,4,9,16,25,&quot;test&quot;). Если значение <em>target</em> является Объектом XML, то процедура добавляет значение <em>element</em> как новый подэлемент (значение <em>element</em> должно быть строкой или Объектом XML). Во всех других случаях вызов этой процедуры приведёт к возникновению исключительной ситуации.</p></li><li><p><code>RemoveElement(target,what)</code></p><p>Эта процедура удаляет элемент из массива. Если значением <em>target</em> является массив, значением <em>what</em> должно быть число или строка, содержащая десятичное число, задающее элемент массива, который подлежит удалению. Если значением myArray является (1,4,9,16,25), то вызов <code>RemoveElement(myArray,2)</code> изменит значение <code>myArray</code> на (1,4,16,25). Во всех других случаях вызов этой процедуры приведёт к возникновению исключительной ситуации.</p></li><li><p><code>InsertElement(target,index,element)</code></p><p>Эта процедура вставляет элемент в массив. Значение <em>target</em> должно быть массивом, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Значением <em>index</em> должно быть число или строка, содержащая десятичное число, задающее место, куда должно быть вставлено значение <em>element</em>. Для всех существующих элементов массива с индексом <em>index</em> и выше значение их индекса увеличится на один. Если значением myArray является (1,4,9,16,25), то вызов <code>InsertElement(myArray,2,&quot;Jack&quot;)</code> изменит значение myArray на (1,4,&quot;Jack&quot;,9,16,25).</p></li><li><p><code>SortStrings(arg)</code></p><p>Эта процедура сортирует элементы массива. Значение <em>target</em> должно быть массивом и все элементы этого массива должны быть строками, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Элементы массива сравниваются как независимые от регистра строки UTF-8.</p></li></ul><h3 id="Dictionaries" tabindex="-1">Словари <a class="header-anchor" href="#Dictionaries" aria-label="Permalink to &quot;Словари {#Dictionaries}&quot;">​</a></h3><ul><li><p><code>IsDictionary(arg)</code></p><p>Эта функция возвращает истину, если <em>arg</em> является словарём; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>NewDictionary()</code></p><p>Эта функция создаёт новый пустой словарь.</p></li><li><p><code>SetCaseSensitive(target,flag)</code></p><p>Эта процедура указывает, должны ли ключи словаря обрабатываться как зависимые от регистра. Значение <em>target</em> должно быть словарём, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Если <em>flag</em> имеет нулевое значение, то словарь <em>target</em> будет независимым от регистра, иначе он будет зависимым от регистра. Новые словари создаются как зависимые от регистра.</p></li></ul><h3 id="XML" tabindex="-1">Объекты XML <a class="header-anchor" href="#XML" aria-label="Permalink to &quot;Объекты XML {#XML}&quot;">​</a></h3><ul><li><p><code>IsXML(arg)</code></p><p>Эта функция возвращает значение истина, если значение <em>arg</em> является Объектом XML, иначе функция возвращает нулевое значение.</p></li><li><p><code>NewXML(type)</code><br><code>NewXML(type,prefix)</code><br><code>NewXML(type,prefix,namespace)</code></p><p>Эта функция создаёт новый Объект XML типа <em>type</em>. Значение <em>type</em> должно быть строкой, в которой содержится корректный тэг XML. Значение <em>prefix</em> может быть нулевым значением или строкой, содержащей корректный префикс XML. Этот префикс используется для определения имени объекта XML, если же он не задан или его значение нулевое, то используется пустая строка. Если задано значение <em>namespace</em> и оно не нулевое, оно должно быть содержащей пространство имён строкой, связываемое со значением <em>prefix</em>.</p></li><li><p><code>SetNamespace(data,namespace)</code><br><code>SetNamespace(data,namespace,prefix)</code></p><p>Эта процедура связывает префикс XML с некоторым пространством имён. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Если же <em>prefix</em> не задан или его значение нулевое, то используется пустая строка. Иначе, значение должно быть строкой, содержащей корректный префикс XML. Если <em>namespace</em> имеет нулевое значение, то пространство имён, связываемое с <em>prefix</em>, удаляется. В противном случае <em>namespace</em> должно быть строкой, содержащей пространство имён, связываемое со значением <em>prefix</em>.</p></li><li><p><code>GetNamespace(data)</code><br><code>GetNamespace(data,prefix)</code></p><p>Эта функция возвращает строку с пространством имён, связанным с указанным префиксом XML или нулевое значение, если связанное пространство имён не существует. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Если же <em>prefix</em> не задан или его значение нулевое, то используется пустая строка. Иначе, значение должно быть строкой, содержащей корректный префикс XML.</p></li><li><p><code>SetNamespace(data,namespace,prefix)</code></p><p>Эта функция возвращает строку с префиксом, присвоенным указанному пространству имён, или нулевое значение, если пространство имён не входит в Объект XML. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Значение <em>prefix</em> должно быть строкой, содержащей корректный префикс XML.</p></li><li><p><code>SetAttribute(data,value,name)</code><br><code>SetAttribute(data,value,name,prefix )</code></p><p>Эта процедура устанавливает атрибут Объекта XML для указанного имени и префикса. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Значение <em>name</em> должно быть строкой, содержащей корректное имя атрибута XML. Значение <em>prefix</em> должно быть либо нулевым, либо строкой, содержащей корректный префикс XML. Если значение <em>value</em> является нулевым, то атрибут с указанным именем и префиксом удаляется. В противном случае значение <em>value</em> должно быть строкой, содержащей новое значение атрибута.</p></li><li><p><code>GetAttribute(data,name)</code><br><code>GetAttribute(data,name,prefix)</code></p><p>Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Значение <em>prefix</em> должно быть либо нулевым, либо строкой, содержащей корректный префикс XML. Значение <em>name</em> должно быть строкой, содержащей корректное имя атрибута XML. Эта функция возвращает строку со значением атрибута с заданным именем и префиксом, или нулевое значение, если такого атрибута не существует. Если значением <em>name</em> является число, оно должно задавать индекс атрибута (начиная с 0). Если атрибут с указанным индексом не существует, эта функция возвращает нулевое значение. Иначе эта функция возвращает массив строк. Первым элементом массива будет имя атрибута, вторым - префикс атрибута. Если значение <em>name</em> не является ни строкой, ни числом, то вызов этой функции приведёт к возникновению исключительной ситуации.</p></li><li><p><code>XMLBody(data,type)</code><br><code>XMLBody(data,type,namespace)</code><br><code>XMLBody(data,type,namespace,index)</code></p><p>Эта функция возвращает подэлемент XML с указанным типом, пространством имён и позицией, либо нулевое значение, если такого подэлемента не существует. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Значение <em>type</em> должно быть нулевым или строкой, в которой содержится корректное имя тэга XML. Если значение <em>type</em> является нулевым, то эта функция возвращает подэлементы любого типа. Значение <em>namespace</em> должно быть либо нулевым, либо строкой, содержащей пространство имён. Если значение <em>namespace</em> не указано или имеет нулевое значение, то функция ищет подэлементы, игнорируя их пространства имён. Значение <em>index</em>, если указано, должно быть неотрицательным числом. Для получения первого подэлемента заданного типа и пространства имён, значение <em>index</em> должно быть 0.</p></li><li><p><code>XMLType(data)</code></p><p>Эта функция возвращает строку с типом Объекта XML. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации.</p></li><li><p><code>XMLPrefix(data)</code></p><p>Эта функция возвращает строку с префиксом типа Объекта XML. Значение <em>data</em> должно быть Объектом XML, иначе вызов этой функции приведёт к возникновению исключительной ситуации.</p></li></ul><h3 id="Conversion" tabindex="-1">Преобразование Данных <a class="header-anchor" href="#Conversion" aria-label="Permalink to &quot;Преобразование Данных {#Conversion}&quot;">​</a></h3><ul><li><p><code>ObjectToString(arg)</code></p><p>Эта функция возвращает строку с текстовым представлением значения <em>arg</em>. Если значение <em>arg</em> является нулевым, то эта функция возвращает строку &quot;#null#&quot;.</p></li><li><p><code>ObjectToXML(arg)</code></p><p>Эта функция возвращает XML-представление значения <em>arg</em>, в соответствии с разделом <a href="./Data.html#XMLObjects">Объекты XML</a>.</p></li><li><p><code>ToObject(arg)</code></p><p>Если значением <em>arg</em> является строка или блок данных, то эта функция возвращает объект, содержащий текстовое представление значения <em>arg</em>. Если значением <em>arg</em> является объект XML, то эта функция возвращает объект, представляемый этим XML (в соответствии с разделом <a href="./Data.html#XMLObjects">Объекты XML</a>). В остальных случаях вызов этой функции приведёт к возникновению исключительной ситуации. Если преобразование заканчивается неуспешно, или если значением <em>arg</em> была строка &quot;#null#&quot;, то эта функция возвращает нулевое значение.</p></li><li><p><code>Base32Encode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой или блоком данных, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Эта функция возвращает строку с данными <em>arg</em> в кодировке base32.</p></li><li><p><code>Base32Decode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Эта функция возвращает блок данных, в котором содержится раскодированные из кодировки base32 данные <em>arg</em>.</p></li><li><p><code>Base64Encode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой или блоком данных, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Эта функция возвращает строку с данными <em>arg</em> в кодировке base64.</p></li><li><p><code>Base64Decode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Эта функция возвращает блок данных, в котором содержится раскодированные из кодировки base64 данные <em>arg</em>.</p></li><li><p><code>Base64UrlEncode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой или блоком данных, иначе вызов этой процедуры приведёт к возникновению исключительной ситуации. Эта функция возвращает строку с данными <em>arg</em> в кодировке base64url.</p></li><li><p><code>Base64UrlDecode(arg)</code></p><p>Значение <em>arg</em> должно быть строкой, иначе вызов этой функции приведёт к возникновению исключительной ситуации. Эта функция возвращает блок данных, в котором содержится раскодированные из кодировки base64url данные <em>arg</em>.</p></li><li><p><code>AppToXML(data,format)</code></p><p>Эта функция преобразовывает данные приложения в представление XML. Значение <em>data</em> должно быть строкой или блоком данных, содержащих текст данных приложения. Значение <em>format</em> должно быть строкой, задающей формат данных приложения. Поддерживаются следующие форматы:</p><ul><li>vCard - формат vCard, функция возвращает либо объект XML для <a href="./Data.html#XMLVCard">vCard</a>, либо массив объектов XML vCard.</li><li>vCardGroup - формат vCardGroup, функция возвращает объект XML для <a href="./Data.html#XMLVCardGroup">vCardGroup</a>.</li><li>iCalendar - формат iCalendar, функция возвращает объект XML для <a href="./Data.html#XMLiCalendar">iCalendar</a>.</li><li>sdp - формат SDP, функция возвращает объект XML для <a href="./Data.html#XMSDP">SDP</a>.</li></ul><p>Если функция не может разобрать данные приложения или указанный формат не поддерживается, то функция возвращает строку с кодом ошибки.</p></li><li><p><code>XMLToApp(data)</code></p><p>Эта функция преобразовывает представление XML в данные приложения (смотрите выше). Значением <em>data</em> должен быть объект XML. Функция возвращает строку с данными приложения. Если объект XML не является представлением некоторого поддерживаемого формата данных приложения, то результирующая строка будет текстовым представлением значения <em>data</em> объекта XML. Если функция не может преобразовать XML представление в данные приложения, то результирующая строка будет содержать код ошибки.</p></li><li><p><code>ObjectToJSON(arg)</code></p><p>Эта функция возвращает строку с представлением JSON (JavaScript Object Notation) значения <em>arg</em>. Нулевые значения представляются как элементы null. Объекты отметок времени представляются как строки дат в формате RFC822. Блоки двоичных данных представляются как сериализованные в Base64 строки.</p></li><li><p><code>JSONToObject(arg)</code></p><p>Если значением <em>arg</em> является строка или блок данных, то функция возвращает объект с текстовым представлением значения <em>arg</em> в формате JSON. В остальных случаях вызов этой функции приведёт к возникновению исключительной ситуации. Если преобразование заканчивается неуспешно или если значение <em>arg</em> является строкой null, то эта функция возвращает нулевое значение.</p></li><li><p><code>Convert(data,format)</code></p><p>Эта функция преобразует значение <code>data</code> в формат, указанный в значении <em>format</em>, который должен быть строкой. Поддерживаются следующие значения <em>format</em> (с учётом регистра, если явно не указано иначе):</p><ul><li><p>&quot;base32&quot;</p><p>Если значением <em>data</em> является строка, функция возвращает блок данных, декодированный из строки согласно формату base32. Если значением <em>data</em> является блок данных, функция возвращает строку в формате base32, с кодированными данными.</p></li><li><p>&quot;base64&quot;</p><p>Если значением <em>data</em> является строка, функция возвращает блок данных, декодированный из строки согласно формату base64. Если значением <em>data</em> является блок данных, функция возвращает строку в формате base64, с кодированными данными.</p></li><li><p>&quot;hex&quot;</p><p>Если значением <em>data</em> является строка, она должна содержать шестнадцатеричные символы, тогда функция возвращает блок декодированных данных. Если значением <em>data</em> является блок данных, функция возвращает строку с данными, кодированными в виде шестнадцатеричной строки. Формат &quot;HEX&quot; использует алфавитные символы в верхнем регистре, а &quot;hex&quot; - в нижнем.</p></li><li><p>&quot;toURI&quot;</p><p>Параметр <em>data</em> должен быть строкой, функция возвращает эту строку закодированной согласно правилам для URI. При использовании ключей &quot;toURIHTTP&quot; и &quot;toURISIP&quot; кодирование происходит с дополнительными ограничениями на использование отдельных символов согласно спецификациям протоколов HTTP и SIP, соответственно.</p></li><li><p>&quot;fromURI&quot;</p><p>Параметр <em>data</em> должен быть строкой с кодированным URI, функция возвращает эту строку декодированной. При использовании ключа &quot;fromURIPLUS&quot; символ <code>+</code> заменяется на пробел.</p></li><li><p>&quot;ucs-2[+][le|be]&quot;</p><p>Если значением <em>data</em> является строка, функция возвращает блок данных, закодированный из строки согласно формату ucs-2. Если значением <em>data</em> является блок данных, функция возвращает строку, декодированную согласно формату ucs-2. Суффиксы le или be указывают на порядок байт в кодировке ucs-2 (соответственно, little-endian или big-endian). По умолчанию используется порядок big-endian. Если декодируемый блок данных содержит признак BOM (byte order mark), то суффиксы le и be игнорируются. При указании символа + признак BOM (byte order mark) записывается в закодированные данные. При декодировании этот символ игнорируется.</p></li><li><p>&quot;<em>charsetName</em>&quot; (любая кодировка символов, известная Серверу CommuniGate Pro)</p><p>Если значением <em>data</em> является строка, функция возвращает блок данных, содержащий строку в указанной кодировке символов. Если значением <em>data</em> является блок данных, функция возвращает строку, декодированную согласно указанной кодировке символов.</p></li><li><p>&quot;utfcode&quot;</p><p>Если значением <em>data</em> является строка, функция возвращает число: код Unicode первого символа в строке. Если значением <em>data</em> является число, функция считает его за код символа Unicode и возвращает строку из одного этого символа.</p></li><li><p>&quot;words&quot;</p><p>Если значение <em>data</em> - строка, функция разбивает её на &quot;слова&quot; - непустые подстроки, разделённые последовательностями &quot;пробельных символов&quot; и &quot;переводов строки&quot;, - и возвращает массив строк-&quot;слов&quot;.</p></li><li><p>&quot;asn.1&quot;</p><p>Если значением <em>data</em> является массив, он должен представлять некоторую <a href="./Data.html#ASN1">структуру данных в кодировке ASN.1</a>. Функция возвращает блок данных с этой структурой, закодированной согласно формату ASN.1 BER. В случае неудачи, функция возвращает строку с кодом ошибки. Если значением <em>data</em> является блок данных, функция возвращает массив, представляющий эту <a href="./Data.html#ASN1">структуру данных в кодировке ASN.1</a>. В случае неудачи, функция возвращает строку с кодом ошибки.</p></li><li><p>&quot;dns-a&quot;</p><p>Если значением <em>data</em> является строка, функция производит поиск записи типа A в DNS для имени из этой строки. Функция возвращает или массив с Адресами IP из найденных записей, или строку с кодом ошибки.</p></li><li><p>&quot;dns-aaaa&quot;</p><p>То же, что и &quot;dns-a&quot;, но для DNS записей типа AAAA.</p></li><li><p>&quot;dns-ptr&quot;</p><p>Если значением <em>data</em> является строка, функция производит поиск записи типа PTR в DNS для имени из этой строки. Если значением <em>data</em> является Адрес IP, функция производит поиск записи типа PTR &quot;IN-Addr&quot; в DNS для этого адреса. Функция возвращает или массив с одной строкой - найденным именем домена, или строку с кодом ошибки.</p></li><li><p>&quot;dns-txt&quot;</p><p>Если значением <em>data</em> является строка, функция производит поиск записи типа TXT в DNS для имени из этой строки. Функция возвращает или массив со строками из найденных записей, или строку с кодом ошибки.</p></li><li><p>&quot;gennonce&quot;</p><p>Функция возвращает блок данных &quot;nonce&quot;. Параметр <em>data</em> должен быть числом, задающим размер данных &quot;nonce&quot; (в байтах). Если значение находится вне диапазонов поддерживаемых размеров &quot;nonce&quot;, функция возвращает нулевое значение.</p></li><li><p>&quot;checknonce&quot;</p><p>Эта функция возвращает истину, если <em>data</em> является блоком данных c правильным &quot;nonce&quot;; в противном случае функция возвращает нулевое значение.</p></li></ul></li><li><p><code>SystemInfo(what)</code></p><p>Функция зачитывает данные о платформе по ключу в значении параметра <em>what</em>, которое должно быть строкой. Поддерживаются следующие значения <em>what</em> (с учётом регистра, если явно не указано иначе):</p><ul><li><p>&quot;serverVersion&quot;</p><p>Функция возвращает строку с номером версии Сервера CommuniGate Pro.</p></li><li><p>&quot;serverOS&quot;</p><p>Функция возвращает строку с именем Операционной Системы, на которой запущен Сервер CommuniGate Pro.</p></li><li><p>&quot;serverCPU&quot;</p><p>Функция возвращает строку с типом процессора, на котором запущен Сервер CommuniGate Pro.</p></li><li><p>&quot;mainDomainName&quot;</p><p>Функция возвращает строку с именем Главного Домена Сервера CommuniGate Pro.</p></li><li><p>&quot;licenseDomainName&quot;</p><p>Функция возвращает строку с именем Кластера в кластерных конфигурациях, с именем Главного Домена на системах вне кластеров.</p></li><li><p>&quot;startTime&quot;</p><p>Функция возвращает отметку времени запуска этой копии Сервера CommuniGate Pro.</p></li><li><p>&quot;serverInstance&quot;</p><p>Функция возвращает строку, уникальную для каждой запущенной копии Сервера CommuniGate Pro.</p></li><li><p>&quot;clusterInstance&quot;</p><p>Функция возвращает строку, уникальную для каждой запущенной копии Кластера CommuniGate Pro, но одинаковую для всех членов одного кластера</p></li><li><p>&quot;knownCharsets&quot;</p><p>Функция возвращает массив строк с именами таблиц кодировок, известных серверу.</p></li><li><p>&quot;knownDigesters&quot;</p><p>Функция возвращает словарь, где каждый ключ является именем метода хэширования, а значение по этому ключу - словарь с параметрами метода, например, <code>size</code> содержит размер значения хэш-функции.</p></li><li><p>&quot;knownCiphers&quot;</p><p>Функция возвращает словарь, где каждый ключ является именем метода шифрования, а значение по этому ключу - словарь с параметрами метода, например, <code>block</code> содержит размер блока.</p></li></ul></li><li><p><code>QRCode(str)</code></p><p>Эта функция возвращает блок данных, содержащий картинку в формате <em>image/png</em> представления QR для значения строки <em>str</em>.</p></li><li><p><code>TOTPCode(str)</code></p><p>Эта функция возвращает цифровую последовательность, содержащую одноразовый пароль на основе времени (TOTP) для секрета, закодированного в формате base32, и переданного как значение строки <em>str</em>.</p></li></ul><h3 id="Crypto" tabindex="-1">Криптография <a class="header-anchor" href="#Crypto" aria-label="Permalink to &quot;Криптография {#Crypto}&quot;">​</a></h3><ul><li><p><code>CryDigest(algName,data)</code></p></li><li><p><code>CryDigest(algName,data,salt)</code></p><p>Функция вычисляет криптографический дайджест для блока данных <em>data</em>. Значение <em>algName</em> должно быть строкой, задающей алгоритм дайджеста (MD5, SHA1 и т.д.). Если указан третий параметр <em>salt</em>, для подсчёта дайджеста используется алгоритм <code>HMAC</code>, где значение третьего параметра используется в качестве ключа, а <em>algName</em> для обоих этапов <code>HMAC</code>. Если указан неизвестный алгоритм, то функция возвращает нулевое значение, иначе - блок данных с вычисленным дайджестом.</p></li><li><p><code>CryEncrypt(algName,key,data)</code></p><p>Функция шифрует блок данных <em>data</em>, используя блок данных <em>key</em> как ключ шифрования. Для блочных методов шифрования последний блок используется как вектор инициализации. Значение <em>algName</em> должно быть строкой, задающей алгоритм шифрования (RC4, DES3, AES и т.д.). Если указан неизвестный алгоритм, то функция возвращает нулевое значение, иначе - блок данных с зашифрованными данными.</p></li><li><p><code>CryDecrypt(algName,key,data)</code></p><p>Функция расшифровывает блок данных <em>data</em>, используя блок данных <em>key</em> как ключ шифрования. Для блочных методов шифрования последний блок используется как вектор инициализации. Значение <em>algName</em> должно быть строкой, задающей алгоритм шифрования. Если указан неизвестный алгоритм, то функция возвращает нулевое значение, иначе - блок данных с расшифрованными данными.</p></li></ul><h3 id="Environment" tabindex="-1">Среда <a class="header-anchor" href="#Environment" aria-label="Permalink to &quot;Среда {#Environment}&quot;">​</a></h3><ul><li><p><code>Vars()</code></p><p>Эта функция возвращает словарь, уникальный для этой <em>Задачи</em> (для этого вызова программы). Этот словарь может использоваться для хранения переменных, видимых во всех процедурах и функциях, выполняемых в рамках этой Задачи. Когда Задача запускается с параметрами (например, когда <a href="./PBXApp.html">Приложение Реального Времени</a> запускается для обработки Сигнала, перенаправленного <a href="./../admin/sysadmin/Router.html#PBXApp">Маршрутизатором</a>), то массив с параметрами помещается в элемент <code>startParameter</code> словаря <code>Vars()</code>. В следующем примере запрашиваются два первых параметра Задачи:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>firstParam  = Vars().startParameter[0];</span></span>
<span class="line"><span>secondParam = Vars().startParameter[1];</span></span></code></pre></div></li></ul><h3 id="Addresses" tabindex="-1">Адреса и URI <a class="header-anchor" href="#Addresses" aria-label="Permalink to &quot;Адреса и URI {#Addresses}&quot;">​</a></h3><ul><li><p><code>SIPURIToEmail(uri)</code></p><p>Эта функция преобразовывает значение <em>uri</em> из SIP URI в строку с адресом электронной почты. Если значение <em>uri</em> не является строкой, или оно не может быть разобрано как SIP URI, то функция возвращает нулевое значение.</p></li><li><p><code>EmailToSIPURI(email)</code></p><p>Эта функция преобразовывает значение <em>email</em> с адресом электронной почты в строку SIP URI. Если значение <em>email</em> не является строкой, или оно не может быть разобрано как адрес электронной почты, то функция возвращает нулевое значение.</p></li><li><p><code>PhoneNumberToSIPURI(phoneNumber)</code></p><p>Эта функция преобразовывает значение <em>phoneNumber</em> в строку SIP URI. Если значение <em>phoneNumber</em> не является строкой, или оно не может быть разобрано как телефонный номер, то функция возвращает нулевое значение. Функция удаляет все форматирующие символы из значения <em>phoneNumber</em>, оставляя только цифры и (если он существует) символ плюс (+) в начале. Функция добавляет имя текущего Домена в преобразованный номер.</p></li><li><p><code>RouteAddress(email,type)</code></p><p>Эта функция использует <a href="./../admin/sysadmin/Router.html">Маршрутизатор</a> для обработки адреса <em>email</em>. Значение <em>type</em> указывает тип адреса: оно должно быть строкой со значением mail, signal или access. Если маршрутизация адреса заканчивается неудачно, то эта функция возвращает строку с кодом ошибки. В противном случае функция возвращает словарь, в котором содержатся следующие элементы:</p><ul><li><p><code>module</code></p><p>имя модуля CommuniGate Pro, в котором будет обрабатываться этот адрес.</p></li><li><p><code>host</code></p><p>строка с именем хоста (локальный Пользователь, удалённый Домен и т.д.), на который перенаправляется адрес.</p></li><li><p><code>object</code></p><p>строка с именем объекта хоста, на который перенаправляется адрес.</p></li><li><p><code>canRelay</code></p><p>этот необязательный элемент существует и имеет значение истина, если информация на этот адрес может перенаправляться.</p></li></ul></li><li><p><code>RouteENUM(service,phoneNumber,domain)</code></p><p>Эта функция использует <a href="./../admin/network/#DNR">DNS Клиент (DNR)</a> для преобразования телефонного номера <em>phoneNumber</em> (любую последовательность цифр, возможно, с символом + в начале) в URL. Значение <em>service</em> должно быть строкой. Оно указывает &quot;сервис&quot; ENUM (такой, как E2U+SIP или E2U+MAIL). Значение <em>domain</em> должно быть строкой. Оно указывает имя Домена ENUM (такое, как e164.arpa). Если телефонный номер был преобразован успешно, то эта функция возвращает массив. Первым элементом массива является строка - получившийся URL. В противном случае эта функция возвращает строку с кодом ошибки.</p></li></ul><h3 id="Account" tabindex="-1">Данные Пользователя <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Данные Пользователя {#Account}&quot;">​</a></h3><p>Следующие функции и процедуры доступны, если у программы (Задачи) существует набор &quot;текущего Пользователя&quot;.</p><ul><li><p><code>MyDomain()</code></p><p>Эта функция возвращает строку с именем текущего Домена, если он есть. Если для текущей Задачи отсутствует связанный с ней конкретный Пользователь или Домен, то функция возвращает нулевое значение.</p></li><li><p><code>MyEmail()</code></p><p>Эта функция возвращает строку с адресом электронной почты текущего Пользователя, если он есть. Если для текущей Задачи отсутствует связанный с ней конкретный Пользователь, то функция возвращает нулевое значение.</p></li><li><p><code>GetAccountPreferences(keyName)</code></p></li><li><p><code>GetAccountPreferences(keyName,flag)</code></p><p>Эта функция возвращает Настройки текущего Пользователя. Если <em>keyName</em> является непустой строкой, то возвращается объект Настроек Пользователя, связанный с этим ключом. Иначе возвращается словарь со всеми фактически действующими Настройками Пользователя. Если строка <em>keyName</em> начинается с префикса ~<em>username</em>/, то префикс удаляется. Строка <em>username</em> задаёт имя Пользователя, которого необходимо использовать. Если этот Пользователь не является текущим Пользователем, то операция заканчивается успешно только в случае, если текущий Пользователь имеет для указанного Домена Пользователя право доступа Администратора Домена. Если flag имеет ненулевое значение, то названия папок по ключам, перечисленным ниже, в возвращаемом значении настроек будут декодированы из кодировки IMAP-UTF7 в UTF-8:</p><ul><li>DraftsBox</li><li>SentBox</li><li>CalendarBox</li><li>ContactsBox</li><li>NotesBox</li><li>TasksBox</li><li>TrashBox</li><li>JunkBox</li><li>HistoryBox</li></ul></li><li><p><code>SetAccountPreferences(keyValue,keyName)</code></p><p>Эта функция изменяет Настройки текущего Пользователя. Если <em>keyName</em> является непустой строкой, то значение <em>keyValue</em> задаёт новый объект для этого ключа. Если <em>keyValue</em> имеет нулевое значение, то объект удаляется из Настроек Пользователя, и для указанного ключа начинает действовать значение по умолчанию. Если строка <em>keyName</em> начинается с префикса ~<em>username</em>/, то префикс удаляется. Строка <em>username</em> задаёт имя Пользователя, настройки которого необходимо изменить. Если этот Пользователь не является текущим Пользователем, то операция заканчивается успешно только в случае, если текущий Пользователь имеет для указанного Домена Пользователя право доступа Администратора Домена. Если <em>keyName</em> является строкой вида ~<em>username</em>/ или пустой строкой, либо не является строкой, то значение <em>keyValue</em> должно быть словарём. Он используется для изменения Настроек Пользователя. Эта функция возвращает нулевое значение, если данные Настроек Пользователя были успешно изменены; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>Impersonate(email)</code></p><p>Эта функция осуществляет маршрутизацию адреса <em>email</em> и использует результат как текущего Пользователя. Если маршрутизируемый адрес не является локальным, то производится обнуление значения текущего Пользователя. Если маршрутизируемый адрес является локальным, и он не совпадает с текущим Пользователем, то текущий Пользователь должен иметь для указанного Домена Пользователя право доступа <a href="./../admin/sysadmin/#Privs">CanImpersonate</a> (Может выступать от имени других). При изменении текущего Пользователя также изменяются текущие настройки, выбранный язык и выбранный часовой пояс. Эта функция возвращает нулевое значение, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>ReadGroupMembers(groupName)</code></p><p>Эта функция читает содержимое <a href="./../admin/objects/Groups.html">Группы</a>. Значение <em>groupName</em> должно быть строкой. В этом параметре задаётся имя Группы, содержимое которой необходимо прочитать. Если это имя не содержит имени Домена, то используется текущий Домен. Эта функция возвращает массив строк, в которых содержатся адреса электронной почты членов Группы. Эта функция возвращает нулевое значение, если Группы с указанным именем не существует. Текущий Пользователь должен обладать для Домена Группы правами доступа Администратора Домена.</p></li><li><p><code>ReadTelnums()</code><br><code>ReadTelnums(accountName)</code></p><p>Эта функция читает <a href="./../admin/objects/Accounts.html#Telnums">Телефонные Номера</a>, присвоенные Пользователю <em>accountName</em> или, если <em>accountName</em> имеет нулевое значение, присвоенные текущему Пользователю. Эта функция возвращает массив строк. Эта функция возвращает нулевое значение, если Пользователя с указанным именем не существует. Для получения Телефонных Номеров, присвоенных другому Пользователю, текущий Пользователь должен обладать для Домена Пользователя <em>accountName</em> правами доступа Администратора Домена.</p></li><li><p><code>UpdateAccountMailRule(ruleData)</code><br><code>UpdateAccountMailRule(ruleData,accountName)</code></p></li><li><p><code>UpdateAccountSignalRule(ruleData)</code><br><code>UpdateAccountSignalRule(ruleData,accountName)</code></p><p>Эти команды изменяют Правила обработки Очереди/Сигналов Пользователя. Параметр <em>ruleData</em> является строкой или массивом. Он имеет то же смысл, что и параметр <em>newRule</em> для команд CLI <a href="./CLI.html#RuleUpdate">UpdateAccountMailRule</a> и <a href="./CLI.html#RuleUpdate">UpdateAccountSignalRule</a>. Эти функции изменяют Правила Пользователя <em>accountName</em> или, если <em>accountName</em> имеет нулевое значение, Правила текущего Пользователя. Для изменения Правил Очереди другого Пользователя, текущий Пользователь должен обладать правом доступа <code>RulesAllowed</code> (Разрешённые Правила для Почты) Администратора Домена для Домена Пользователя <em>accountName</em>. Для изменения Правил Сигналов другого Пользователя, текущий Пользователь должен обладать правом доступа <code>SignalRulesAllowed</code> (Разрешённые Правила для Звонков) Администратора Домена для Домена Пользователя <em>accountName</em>. Эта функция возвращает нулевое значение, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li></ul><h3 id="Mailboxes" tabindex="-1">Папки <a class="header-anchor" href="#Mailboxes" aria-label="Permalink to &quot;Папки {#Mailboxes}&quot;">​</a></h3><ul><li><p><code>ListMailboxes(filter)</code></p><p>Эта функция выдаёт список всех Папок текущего Пользователя. Значение <em>filter</em> должно быть строкой - она определяет шаблон для поиска. Если она имеет нулевое значение, то используется шаблон для поиска <code>*</code> (все Папки Пользователя). Для поиска Папок другого Пользователя, шаблон поиска должен быть задан как <code>~accountname/pattern</code>. Если операция закончилась успешно, то эта функция возвращает словарь. Если операция закончилась успешно, то эта функция возвращает словарь. Каждый ключ словаря является строкой с найденным именем Папки. Значением этого элемента является:</p><ul><li>словарь с атрибутами Папки - если найденная папка является только &quot;хранилищем элементов&quot;.</li><li>пустым массивом - если найденная Папка является только &quot;папкой&quot; (узлом иерархии без функции хранения).</li><li>массивом с одним элементом словаря - если найденная Папка является как просто &quot;папкой&quot;, так и &quot;хранилищем элементов&quot;.</li></ul><p>Если права Доступа к Папке позволяют текущему Пользователю видеть эту Папку, но не позволяют текущему Пользователю открывать её, то словарь с Атрибутами Папки заменяется строкой, содержащей Права Доступа к Папке для текущего Пользователя. Если эта функция заканчивает свою работу неуспешно, то она возвращает строку с кодом ошибки.</p></li><li><p><code>CreateMailbox(mailboxName,class)</code></p><p>Эта функция создаёт <a href="./../admin/storage/Mailboxes.html">Папку</a> <em>mailboxName</em> у текущего Пользователя. Если <em>class</em> имеет ненулевое значение, то он задаёт Класс Папки для вновь создаваемой Папки. Эта функция возвращает нулевое значение, если Папка была успешно создана; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>RenameMailbox(oldMailboxName,newMailboxName,renameSub)</code></p><p>Эта функция переименовывает папку <em>oldMailboxName</em> текущего Пользователя в папку <em>newMailboxName</em>. Оба параметра должны иметь строковые значения. Если значение <em>renameSub</em> является ненулевым, то также переименовываются Подпапки внутри <em>oldMailboxName</em>. Эта функция возвращает нулевое значение, если Папка была успешно переименована; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>DeleteMailbox(mailboxName,deleteSub)</code></p><p>Эта функция удаляет Папку <em>mailboxName</em> текущего Пользователя. Если значение <em>deleteSub</em> является ненулевым, то также удаляются Подпапки внутри <em>mailboxName</em>. Эта функция возвращает нулевое значение, если Папка была успешно удалена; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>GetMailboxACLs(mailboxName)</code></p><p>Эта операция читает Список Прав Доступа (ACL) к Папке <em>mailboxName</em>. Если функция успешно прочитала данные ACL, то она возвращает словарь, в котором идентификаторы ACL являются ключами, а значением являются строки с соответствующими правами доступа. В противном случае функция возвращает строку с кодом ошибки.</p></li><li><p><code>SetMailboxACLs(mailboxName,newACLs)</code></p><p>Эта операция изменяет Список Прав Доступа (ACL) для Папки <em>mailboxName</em>. Значение <em>newACL</em> должно быть словарём, в котором идентификаторы ACL являются ключами, а значением являются строки с соответствующими правами доступа. Для удаление идентификатора ACL из словаря, задайте его значение как пустой массив. Эта функция возвращает нулевое значение, если ACL Папки был успешно изменён; в противном случае возвращается строка с кодом ошибки.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Для доступа к папкам других пользователей указывайте имя Папки в виде &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>mailboxName</em>&quot;.</p></div></li><li><p><code>GetMailboxAliases(accountName)</code></p><p>Эта функция читает <a href="./../admin/storage/Mailboxes.html#Aliases">Псевдонимы Папки</a>, созданные у Пользователя <em>accountName</em> или, если <em>accountName</em> имеет нулевое значение, у текущего Пользователя. Если функция успешно читает данные о Псевдонимах Папки, то она возвращает словарь. Каждый ключ словаря является именем Псевдонима Папки; значением ключа является строка с именем папки, на которую указывает этот Псевдоним. В противном случае функция возвращает строку с кодом ошибки.</p></li><li><p><code>SetMailboxAliases(newAliases,accountName)</code></p><p>Эта функция задаёт Псевдонимы Папки, созданные для Пользователя <em>accountName</em> или, если <em>accountName</em> имеет нулевое значение, для текущего Пользователя. Старые Псевдонимы Папки удаляются. Значение <em>newAliases</em> должно быть словарём. Каждый ключ словаря является именем Псевдонима Папки; значением ключа является строка с именем папки, на которую указывает этот Псевдоним. Эта функция возвращает нулевое значение, если Псевдонимы Папки были успешно изменены; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>GetMailboxSubscription(accountName)</code></p><p>Эта функция читает <a href="./../admin/storage/Mailboxes.html#Subscription">подписки на Папки</a>, созданные у Пользователя <em>accountName</em> или, если <em>accountName</em> имеет нулевое значение, у текущего Пользователя. Если функция успешно читает данные подписки на Папки, то она возвращает массив. Каждый элемент массива должен быть строкой, в которой содержится имя Папки. В противном случае функция возвращает строку с кодом ошибки.</p></li><li><p><code>SetMailboxSubscription(newSubscription,accountName)</code></p><p>Эта функция задаёт подписки на Папки, созданные для Пользователя <em>accountName</em>или, если <em>accountName</em> имеет нулевое значение, для текущего Пользователя. Старые элементы подписки на Папки удаляются. Значение <em>newSubscription</em> должно быть массивом. Каждый элемент массива должен быть строкой, в которой содержится имя Папки. Эта функция возвращает нулевое значение, если подписки на Папки были успешно изменены; в противном случае возвращается строка с кодом ошибки.</p></li></ul><h3 id="MailboxRef" tabindex="-1">Описатели Папок <a class="header-anchor" href="#MailboxRef" aria-label="Permalink to &quot;Описатели Папок {#MailboxRef}&quot;">​</a></h3><p>Описатели Папок являются внутренними объектами, представляющими <a href="./../admin/storage/Mailboxes.html">Папки</a>. Сообщения в папках можно указывать с помощью числовых значений уникальных идентификаторов (UID) или текущими значениями индекса.</p><p>Некоторые операции используют в качестве параметра &quot;набор сообщений&quot;. Набор сообщений представляет собой набор чисел, которые интерпретируются либо как уникальные идентификаторы (UID), либо как индексы. Если значение параметра &quot;набор сообщений&quot; задано числом, то набор включает только это число. Значение параметра &quot;набор сообщений&quot; может быть задано массивом чисел. Все эти числа входят в набор. Массив может содержать &quot;диапазоны&quot; - массивы, содержащие два числа: границы диапазона. Такой набор включает в себя границы диапазона и все числа между ними. Примеры:</p><p>если значение параметра &quot;набор сообщений&quot; задано числом 123, то набор включает только это число 123; если значение параметра &quot;набор сообщений&quot; задано массивом (123, 125, 130), то набор включает числа 123,125,130; если значение параметра &quot;набор сообщений&quot; задано массивом (123, (125,128), 130), то набор включает числа 123,125,126,127,128,130.</p><ul><li><p><code>OpenMailbox(mailboxName)</code></p><p>Эта функция открывает Папку. Значение <em>mailboxName</em> должно быть строкой. Оно указывает имя Папки. Если имя не начинается с символа <code>~</code>, то открывается папка у текущего Пользователя (если она существует). Текущий Пользователь (если есть) должен иметь для указанной папки права доступа <a href="./../admin/storage/Mailboxes.html#ACL">Read/Select</a>. Функция возвращает описатель Папки, если Папка была успешно открыта; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>OpenMailboxView(params)</code></p><p>Эта функция открывает Папку и создаёт описатель Папки. Значение <em>params</em> должно быть словарём, в котором содержаться строковые элементы <code>mailbox</code> и <code>sortField</code>; также там могу содержаться опциональные строковые элементы <code>mailboxClass</code>, <code>sortOrder</code>, <code>filter</code>, <code>filterField</code> и числовые элементы <code>UIDValidity</code>, <code>UIDMin</code>. Дополнительную информацию о значениях этих параметров смотрите в разделе <a href="./XMLAPI.html#folderOpen">XIMSS</a>. Функция возвращает описатель Папки, если Папка была успешно открыта; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>MailboxUIDs(boxRef,flags)</code></p><p>Эта функция возвращает числовой массив с идентификаторами сообщений (UID) в папке. Значение <em>boxRef</em> должно быть описателем Папки. Если значение <em>flags</em> является строкой, то оно должно содержать разделённый запятой список <a href="./../admin/storage/Mailboxes.html#Flags">Имён флагов сообщений</a> и/или <a href="./../admin/storage/Mailboxes.html#Flags">Обратных Имён флагов сообщений</a>. В результирующий массив включаются только те идентификаторы, сообщения которых имеют указанные Флаги и не имеют указанные Обратные флаги. В следующем примере запрашиваются идентификаторы всех сообщений, которые имеют флаг Seen и не имеют флага Deleted:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>myMailbox = OpenMailbox(&quot;INBOX&quot;);</span></span>
<span class="line"><span>seen = MailboxUIDs(myMailbox,&quot;Seen,Undeleted&quot;);</span></span></code></pre></div></li><li><p><code>SubscribeEvents(object,refData)</code></p><p>Эта функция включает или выключает возможность генерирования событий объектом <em>object</em>. Если значение <em>refData</em> является нулевым, то <em>object</em> прекращает генерирование событий. В противном случае, значение <em>refData</em> должно быть <a href="./Data.html">&quot;базовым&quot;</a> объектом. Если <em>object</em> генерирует события и отправляет их в эту Задачу, то элемент <em>parameter</em> события содержит значение <em>refData</em>. Если значением <em>object</em> является описатель Папки, то он должен быть создан функцией <code>OpenMailboxView</code>. Уведомления о Событии Папки отправляется в эту Задачу при удалении, добавлении или изменении сообщений Папки. &quot;Представление папки&quot; фактически не изменяется (то есть, функция <code>MailboxUIDs</code> возвращает тот же набор идентификаторов сообщений) до тех пор, пока к этому описателю Папки не будет применена функция Sync.</p></li><li><p><code>IsMailboxNotifyEvent(data)</code></p><p>Эта функция возвращает значение истина, если значением <code>data</code> является уведомление о Событии Папки; в противном случае функция возвращает нулевое значение.</p></li><li><p><code>Sync(boxRef)</code></p><p>Эта функция проверяет наличие изменений в Папке. Значение <em>boxRef</em> должно быть Описателем Папки. Эта функция берёт первое из необработанных изменений в Папке и &quot;обрабатывает&quot; его, изменяя UIDы сообщений (добавляя добавленные сообщения, удаляя удалённые сообщения). Функция возвращает словарь, в котором содержатся следующие элементы:</p><ul><li><p><code>mode</code></p><p>строка removed, added,updated или &quot;attrsUpdated&quot;, указывающая на тип изменения Папки.</p></li><li><p><code>UID</code></p><p>число - UID удалённого, добавленного или изменённого сообщения</p></li><li><p><code>index</code></p><p>для изменённого сообщения - его позиция в массиве UIDов сообщений. для удалённого сообщения - его позиция в массиве UIDов сообщений до того, как оно было удалено из этого массива. для добавленного сообщения - его позиция в массиве UIDов сообщений после того, как оно было добавлено в этот массив. Если необработанные изменения Папки отсутствуют, то функция возвращает нулевое значение.</p></li></ul></li><li><p><code>MailboxInternalTimeByUID(boxRef,uid)</code></p><p>Эта функция возвращает объект - отметку времени, в которой содержится Внутренняя Дата сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения. Если сообщение с указанным идентификатором не существует в папке, то функция возвращает нулевое значение.</p></li><li><p><code>MailboxFlagsByUID(boxRef,uid)</code></p><p>Эта функция возвращает строку, в которой содержится разделённый через запятую список имён флагов сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения. Если сообщение с указанным идентификатором не существует в папке, то функция возвращает нулевое значение.</p></li><li><p><code>MailboxFlagsByUID(boxRef,uid)</code></p><p>Эта функция возвращает объект - отметку времени, в которой содержится &quot;оригинальный&quot; (постоянный) идентификатор сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения. Если сообщение с указанным идентификатором не существует в папке, то функция возвращает нулевое значение.</p></li><li><p><code>MailboxUIDByOrigUID(boxRef,origUID)</code></p><p>Эта функция возвращает число - UID сообщения, которому соответствует &quot;оригинальный&quot; (постоянный) идентификатор origUID. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>origUID</em> должно быть числом - оригинальным идентификатором сообщения. Если сообщение с указанным оригинальным идентификатором не существует в папке, то функция возвращает нулевое значение.</p></li><li><p><code>MailboxSetFlags(boxRef,idData,params)</code></p><p>Эта функция изменяет флаги сообщения в папке. Значение <em>boxRef</em> должно быть Описателем Папки, а <em>idData</em> - допустимое значение &quot;набора сообщений&quot; (смотрите выше). Если значение <em>params</em> является строкой, то оно должно содержать разделённый запятой список <a href="./../admin/storage/Mailboxes.html#Flags">Имён флагов сообщений</a> и/или <a href="./../admin/storage/Mailboxes.html#Flags">Обратных Имён флагов сообщений</a>. Если значением <em>params</em> является словарь, то он должен состоять из следующих элементов:</p><ul><li><p><code>flags</code></p><p>строка со значением флагов</p></li><li><p><code>useIndex</code></p><p>если задан этот необязательный элемент, то &quot;набор сообщений&quot; в параметре <em>idData</em> считается списком индексов в представлении папки <em>boxRef</em>, иначе &quot;набор сообщений&quot; должен содержать идентификаторы (UID). Использовать этот элемент можно, только если описатель папки <em>boxRef</em> был создан с помощью функции OpenMailboxView. В остальных случаях вызов этой функции приведёт к возникновению исключительной ситуации. Функция устанавливает флаги, заданные по их Именам и сбрасывает флаги, заданные по их Обратным Именам. Функция возвращает нулевое значение, если текущий Пользователь (если он есть) имеет достаточные <a href="./../admin/storage/Mailboxes.html#ACL">Права Доступа</a> к Папке для изменения флагов и флаги были успешно изменены; в противном случае функция возвращает строку с кодом ошибки.</p></li></ul></li><li><p><code>MailboxExpunge(boxRef)</code></p><p>Эта функция удаляет все сообщения папки, отмеченные как &quot;удалённые&quot;. Значение <em>boxRef</em> должно быть описателем Папки. Эта функция возвращает нулевое значение, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>MailboxAudioByUID(boxRef,uid)</code></p><p>Эта функция возвращает блок данных, в котором содержится аудио-часть сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения. Если сообщение с указанным идентификатором не существует в папке или если сообщение не имеет части <code>audio</code>, то функция возвращает нулевое значение.</p></li><li><p><code>MailboxRedirectByUID(boxRef,uid,addresses)</code></p></li><li><p><code>MailboxForwardByUID(boxRef,uid,addresses)</code></p><p>Эти функции могут использоваться для того, чтобы переслать или перенаправить заданные сообщения на указанный адрес электронной почты. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения, <em>addresses</em> должен быть строкой, содержащий один или несколько адресов электронной почты, разделённых запятыми (<code>,</code>). Эти функции возвращают нулевое значение, если операция завершилась успешно; в противном случае ими возвращается строка с кодом ошибки.</p></li><li><p><code>MailboxAppend(boxRef,headers,content)</code></p><p>Эта функция создаёт сообщение электронной почты и добавляет его в папку. Значение <em>boxRef</em> должно быть описателем Папки. Значения <em>headers</em> и <em>content</em> обрабатываются так же, как в функции <a href="#SubmitEMail"><code>SubmitEMail</code></a>. Словарь <em>headers</em> может содержать следующие дополнительные элементы:</p><ul><li><p><code>flags</code></p><p>строка с флагами сообщения, которые будут установлены для нового сообщения в Папке. Могут быть указаны несколько флагов, разделённые запятой. Дополнительную информацию смотрите в разделе <a href="./../admin/storage/Mailboxes.html#Flags">Папки</a>.</p></li><li><p><code>internalDate</code></p><p>значение типа отметка времени с &quot;внутренней отметкой времени&quot; для создаваемого сообщения. Если оно отсутствует, то используется текущее время.</p></li><li><p><code>replacesUID</code>, <code>replaceMode</code></p><p>значение UID с предыдущей версией этого сообщения. Значения этих атрибутов - те же, что и в операции <a href="./XMLAPI.html#messageAppend">XIMSS <code>messageAppend</code></a>.</p></li><li><p><code>report</code></p><p>если этот элемент задан, то он должен иметь значение &quot;uid&quot;. Если значение <em>content</em> является объектом XML для данных <a href="./Data.html#XMLvCard">vCard</a> или <a href="./Data.html#XMLvCardGroup">vCardGroup</a>, то создаётся запись Контактов (обычные элементы <em>headers</em> при этом игнорируются), и эта запись добавляется в Папку. Если операция закончилась неуспешно, то эта функция возвращает строку с кодом ошибки. Если операция заканчивается успешно, то функция возвращает нулевое значение или, если был указан элемент <code>report</code> в словаре <em>headers</em>, функция возвращает число - значение UID для вновь созданного сообщения Папки.</p></li></ul></li><li><p><code>MailboxCopy(boxRef,uidData,parameters)</code></p><p>Эта функция копирует или передвигает сообщения электронной почты из одной Папки в другую Папку. Значение <em>boxRef</em> должно быть описателем Папки. Значение <em>uidData</em> должно быть или числом, или массивом чисел, или массивом с числами и &quot;диапазонами&quot;, где &quot;диапазон&quot; - массив из 2 чисел. &quot;Диапазон&quot; содержит &quot;стартовое&quot; и &quot;конечное&quot; число, а также (неявно) - все числа между ними. Все эти числа определяют набор уникальных идентификаторов (UID) или индексов в Папке копируемых писем. Если значение <em>uidData</em> - число 123, копируется сообщение с UID 123. Если значение <em>uidData</em> - массив (123, 125, 130), копируются сообщения с UID 123, 125, 130. Если значение <em>uidData</em> - массив (123, (125,128), 130), копируются сообщения с UID 123, 125, 126, 127, 128, 130. Если значением <em>parameters</em> является строка, то она указывает имя Папки-приёмника. В противном случае, значение <em>parameters</em> должно быть словарём, содержащим следующие элементы:</p><ul><li><p><code>targetMailbox</code></p><p>строка с именем Папки, в которую будут скопированы или передвинуты сообщения.</p></li><li><p><code>doMove</code></p><p>если этот элемент присутствует, то оригинальные сообщения будут удалены после их успешного копирования.</p></li><li><p><code>mailboxClass</code></p><p>если значением этого элемента является строка, и Папка targetMailbox не существует, то такая Папка будет создана. Если значением элемента является непустая строка, то это значение используется как <a href="./../admin/storage/Mailboxes.html#Classes">Класс Папки</a> для создаваемой Папки.</p></li><li><p><code>useIndex</code></p><p>если задан этот необязательный элемент, то &quot;набор сообщений&quot; в параметре <em>uidData</em> считается списком индексов в &quot;представлении папки&quot; <em>boxRef</em>. Использовать этот элемент можно, только если описатель папки <em>boxRef</em> был создан с помощью функции OpenMailboxView. Иначе вызов этой функции приведёт к возникновению исключительной ситуации.</p></li><li><p><code>report</code></p><p>если этот элемент задан, результат функции - массив чисел: UID копий сообщений в целевой Папке. Эта функция возвращает нулевое значение или массив, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li></ul></li><li><p><code>GetMessageAttr(boxRef,uid)</code></p><p>Эта функция читает атрибуты Сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения (UID). Эта функция возвращает словарь со значениями атрибутов сообщения, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>UpdateMessageAttr(boxRef,uid,newData)</code></p><p>Эта функция изменяет атрибуты Сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения (UID). Значение <em>newData</em> должно быть словарём с новыми значениями атрибутов. Чтобы удалить атрибут, его значение в словаре должно быть строкой &quot;default&quot;. Эта функция возвращает нулевое значение, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li></ul><h3 id="MessageRef" tabindex="-1">Описатели Сообщений <a class="header-anchor" href="#MessageRef" aria-label="Permalink to &quot;Описатели Сообщений {#MessageRef}&quot;">​</a></h3><p>Описатели Сообщений являются внутренними объектами, представляющими индивидуальные сообщения, хранящиеся в <a href="./../admin/storage/Mailboxes.html">Папках</a>.</p><ul><li><p><code>OpenMessage(boxRef,uid)</code></p><p>Эта функция открывает Описатель Сообщения. Значение <em>boxRef</em> должно быть описателем Папки, значение <em>uid</em> должно быть числом - идентификатором сообщения (UID). Функция возвращает Описатель Сообщения, если сообщение было успешно открыто; в противном случае возвращается нулевое значение.</p></li><li><p><code>MessagePart(msgRef,type)</code></p><p>Значение <em>msgRef</em> должно быть Описателем Сообщения. Если значение <code>type</code> является нулевым, то эта функция возвращает словарь, содержащий MIME структуру сообщения. В противном случае, значение <code>type</code> должно быть строкой. В нём указывается искомая подчасть сообщения:</p><ul><li><p>audio</p><p>подчасть, где Content-Type имеет тип <code>audio/*</code>.</p></li><li><p>plain</p><p>подчасть, где Content-Type имеет тип <code>text/plain</code>.</p></li><li><p>text</p><p>подчасть, где Content-Type имеет тип <code>text/*</code>. Если доступны несколько альтернативных подчастей, то часть с типом <code>text/plain</code> имеет низший приоритет; за ним следует часть text/html. Если подчасть найдена, то функция возвращает словарь со структурой MIME подчасти. Если никакой подчасти не найдено, то функция возвращает нулевое значение. Если сообщение не может быть прочитано или разобрано, то функция возвращает строку с кодом ошибки. Элементами словаря являются:</p></li><li><p><code>estimatedSize</code></p><p>примерный размер декодированного тела сообщения (или части сообщения).</p></li><li><p><code>filename</code></p><p>необязательно - имя файла декодированной части сообщения.</p></li><li><p><code>Content-Type</code></p><p>тип содержимого сообщения (или части сообщения), такой как &quot;text&quot;, &quot;image&quot;, и т.п.)</p></li><li><p><code>Content-Subtype</code></p><p>подтип содержимого сообщения (или части сообщения), такой как &quot;plain&quot;, &quot;jpeg&quot;, и т.п.)</p></li><li><p><code>DispositionParams</code></p><p>словарь с параметрами поля <code>Content-Disposition</code></p></li><li><p><code>ContentTypeParams</code></p><p>словарь с параметрами поля <code>Content-Type</code></p></li><li><p><code>MIMEPartID</code></p><p>Этот элемент является пустой строкой для самого сообщения. Для подчасти сообщения, этот элемент является строкой с идентификатором части сообщения.</p></li><li><p><code>MIMEParts</code></p><p>массив подчастей MIME. Каждый элемент массива является словарём, в котором содержится MIME структура подчасти.</p></li><li><p><code>contentFieldName</code></p><p>строка со значением поля <code>Content-contentFieldName</code></p></li></ul></li><li><p><code>MessageHeader(msgRef,partID,fieldName)</code></p><p>Эта функция возвращает массив указанных полей заголовка сообщения или словарь с полями заголовка сообщения. Если сообщение не может быть прочитано или разобрано, то функция возвращает строку с кодом ошибки. Значение <em>msgRef</em> должно быть Описателем Сообщения. Если <em>partID</em> имеет нулевое значение, то возвращаются заголовки сообщения. Если <em>partID</em> является строкой, то она должна быть идентификатором части сообщения и часть сообщения должна иметь тип <code>text/rfc822headers</code> (либо быть подчастью части <code>message/rfc822</code>). Возвращаются поля заголовка указанной части сообщения. Если значение <em>fieldName</em> является строкой, то оно задаёт имя поле заголовка сообщения, а значением функции является массив с заданными значениями полей. Иначе, значение <em>fieldName</em> должно быть нулевым. В этом случае значением функции является словарь: ключами словаря являются имена всех полей заголовков сообщения, а их значения - массивы с соответствующими значениями полей. Если имя поля указывает на поле типа Email (From, To, Sender и т.п.), то каждое значение поля является словарём. Элемент словаря с пустым ключом (&quot;&quot;) является разобранным адресом электронной почты. Необязательный элемент <code>realName</code> содержит строку с &quot;комментарием&quot; из адреса. Если именем поля является E-<em>emailField</em>, где <em>emailField</em> - имя поля типа Email, то значением поля является строка с разобранным адресом электронной почты. Если именем поля является поле типа дата (Date, ResentDate), то значением поля является отметка времени. Во всех других случаях, значениями полей являются декодированные из MIME и перекодированные в кодировку UTF-8 строки, содержащие данные поля.</p><p>Пример: Описатель Сообщения <code>msgRef</code> ссылается на сообщение со следующим заголовком:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>  From: &quot;Sender Name&quot; &lt;fromName@domain&gt;</span></span>
<span class="line"><span>  Subject: I&#39;ll be there!</span></span>
<span class="line"><span>  To: &quot;Recipient Name&quot; &lt;toName@domain&gt;, &lt;toName1@domain1&gt;,</span></span>
<span class="line"><span>  To: &lt;toName2@domain2&gt;</span></span>
<span class="line"><span>  Cc: &quot;Cc Name&quot; &lt;toName3@domain3&gt;</span></span>
<span class="line"><span>  MIME-Version: 1.0</span></span>
<span class="line"><span>  X-Mailer: SuperClient v7.77</span></span>
<span class="line"><span>  Date: Fri, 24 Oct 2008 02:51:24 -0800</span></span>
<span class="line"><span>  Message-ID: &lt;ximss-38150012@this.server.dom&gt;</span></span>
<span class="line"><span>  Content-Type: text/plain; charset=&quot;utf-8&quot;</span></span></code></pre></div><p>Тогда результатом <code>MessageHeader(msgRef,null,&quot;To&quot;)</code> будет</p><p><code>({&quot;&quot;=&quot;toName@domain&quot;,realName=&quot;Sender Name&quot;},{&quot;&quot;=&quot;toName1@domain1&quot;},{&quot;&quot;=&quot;toName2@domain2&quot;})</code></p><p>функция <code>MessageHeader(msgRef,null,&quot;E-Cc&quot;)</code> возвращает</p><p><code>(&quot;toName3@domain3&quot;)</code></p><p>функция <code>MessageHeader(msgRef,null,null)</code> возвращает</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>  {</span></span>
<span class="line"><span>   Cc = ({&quot;&quot;=&quot;toName3@domain3&quot;,realName=&quot;Cc Name&quot;});</span></span>
<span class="line"><span>   Date = (#T24-10-2008_10:51:24);</span></span>
<span class="line"><span>   From = ({&quot;&quot;=&quot;fromName@domain&quot;,realName=&quot;Sender Name&quot;});</span></span>
<span class="line"><span>   Message-ID = (&quot;&lt;ximss-38150012@this.server.dom&gt;&quot;);</span></span>
<span class="line"><span>   Subject = (&quot;I&#39;ll be there!&quot;);</span></span>
<span class="line"><span>   To=({&quot;&quot;=&quot;toName@domain&quot;,realName=&quot;Recipient Name&quot;},{&quot;&quot;=&quot;toName1@domain1&quot;},{&quot;&quot;=&quot;toName2@domain2&quot;});</span></span>
<span class="line"><span>   X-Mailer = (&quot;SuperClient v7.77&quot;);</span></span>
<span class="line"><span>  }</span></span></code></pre></div><ul><li><p><code>MessageBody(msgRef,partID)</code></p><p>Эта функция возвращает сообщение или тело части сообщения. Значение <em>msgRef</em> должно быть Описателем Сообщения. Если <em>partID</em> имеет нулевое значение, то возвращается тело всего сообщения. Если <em>partID</em> является строкой, то она должна быть идентификатором части сообщения. Возвращается тело части сообщения. Если сообщение не может быть прочитано или если указанная часть сообщения не найдена, то эта функция возвращает строку с кодом ошибки. Если типом содержимого сообщения или части сообщения является text/*, то функция перекодирует результат в кодировку UTF-8. Если типом содержимого сообщения или части сообщения является text/xml, то функция возвращает разобранный объект XML. Для всех остальных типов содержимого функция возвращает блок данных с данными тела сообщения.</p></li></ul><h3 id="Calendars" tabindex="-1">Календари <a class="header-anchor" href="#Calendars" aria-label="Permalink to &quot;Календари {#Calendars}&quot;">​</a></h3><p>Описатели Календарей являются внутренними объектами, представляющими Папки календарей. Описатель Календаря может быть использован для чтения событий календаря в указанных временных интервалах, для публикации новых событий, для приёма, отказа и отмены Встреч.</p><ul><li><p><code>OpenCalendar(mailboxName)</code></p><p>Эта операция открывает указанную Папку как &quot;Календарь&quot;. Значение <em>mailboxName</em> должно быть строкой. Оно указывает имя Папки. Если имя не начинается с символа <code>~</code>, то открывается папка у текущего Пользователя (если она существует). Текущий Пользователь (если есть) должен иметь для указанной папки права доступа <a href="./../admin/storage/Mailboxes.html#ACL">Read/Select</a>. Функция возвращает описатель Календаря, если Папка была успешно открыта и её содержимое могло быть разобрано как Календарь; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>Find(calendarRef,params)</code></p><p>значение <em>calendarRef</em> описателем Календаря, а значение <em>params</em> должно быть словарём. Эта функция зачитывает события из указанного временного интервала. Словарь <em>params</em> должен содержать элементы <code>timeFrom</code> и <code>timeTill</code> с отметками времени, а также необязательные числовые элементы <code>limit</code> и <code>skip</code>, и необязательный элемент <code>byAlarm</code>. Эти атрибуты имеют тот же смысл, что и в операции <a href="./XMLAPI.html#findEvents"><code>findEvents</code></a> протокола XIMSS. Если вызов функции не удался, то возвращается строка с кодом ошибки. Иначе, возвращается массив словарей для каждых 24-часовых суток (в выбранном часовом поясе) из указанного временного интервала. Каждый словарь содержит следующие элементы:</p><ul><li><p><code>timeFrom</code>, <code>timeTill</code>, <code>skip</code>, <code>items</code></p><p>эти атрибуты имеют тот же смысл, что и в сообщения с данными <a href="./XMLAPI.html#events"><code>events</code></a> протокола XIMSS.</p></li><li><p><code>events</code></p><p>Массив найденных Событий в виде словарей со следующими элементами:</p><ul><li><p><code>UID</code>, <code>timeFrom</code>, <code>dateFrom</code>, <code>duration</code>, <code>alarmTime</code></p><p>эти элементы имеют тот же смысл, что атрибуты <code>event</code> в сообщения с данными <a href="./XMLAPI.html#events"><code>events</code></a> протокола XIMSS</p></li><li><p><code>data</code></p><p><a href="./Data.html#XMLvevent">представление XML</a> найденного События</p></li><li><p><code>parent</code></p><p>этот атрибут присутствует если найденное Событие является исключением повторяющегося События. Значением этого элемента является <a href="./Data.html#XMLvevent">представление XML</a> основного События. Значение элемента <code>data</code> включено в значение элемента <code>parent</code> как дочерний элемент элемента <code>exceptions</code>.</p></li></ul></li></ul></li><li><p><code>ProcessCalendar(calendarRef,params)</code></p><p>значение <em>calendarRef</em> описателем Календаря, а значение <em>params</em> должно быть словарём. Функция применяет заданную в словаре <em>params</em> операцию к указанному Календарю. Если операция заканчивается успешно, то функция возвращает нулевое значение. Иначе, возвращается строка с кодом ошибки. Тип операции задаётся строковым элементом <code>opCode</code> словаря <em>params</em>:</p><ul><li><p>&quot;PUBLISH&quot;</p><p>Функция публикует Событие или Задание в Календарь. Другие элементы <em>params</em>:</p><ul><li><p><code>data</code></p><p>элемент <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> для помещения в выбранный Календарь.</p></li><li><p><code>attachments</code></p><p>необязательный массив с описанием приложений, каждый элемент массива указан в виде <a href="#EMailPart">части сообщения EMail</a>. Если этот элемент не указан, а календарный объект с таким UID уже существует в календаре, то приложения копируются из существующего объекта. Для удаления всех приложений укажите пустой массив.</p></li><li><p><code>sendRequests</code></p><p>этот необязательный строковый элемент имеет тот же смысл, что и соответствующий атрибут операции <a href="./XMLAPI.html#calendarPublish">calendarPublish</a> протокола XIMSS.</p></li></ul></li><li><p>&quot;CANCEL&quot;</p><p>Функция удаляет Событие или Задание из Календаря. Другие элементы <em>params</em>:</p><ul><li><p><code>data</code></p><p>элемент <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a>, удаляемый из Календаря.</p></li><li><p><code>UID</code></p><p>этот необязательный числовой элемент имеет тот же смысл, что и соответствующий атрибут операции <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> протокола XIMSS.</p></li><li><p><code>itemUID</code>, <code>sendRequests</code></p><p>эти необязательные строковые элементы имеют тот же смысл, что и соответствующие атрибуты операции <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> протокола XIMSS.</p></li><li><p><code>recurrenceId</code></p><p>этот необязательная отметка времени имеет тот же смысл, что и соответствующий атрибут операции <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> протокола XIMSS.</p></li><li><p><code>requestComment</code></p><p>этот необязательный строковый элемент имеет тот же смысл, что и тело запроса <a href="./XMLAPI.html#calendarCancel">calendarCancel</a> протокола XIMSS.</p></li></ul></li><li><p>&quot;DECLINE&quot;</p><p>Эта операция отвергает приглашение и отправляет отрицательный ответ организатору События. Другие элементы <em>params</em>:</p><ul><li><p><code>data</code></p><p>отклоняемый элемент <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a>.</p></li><li><p><code>sendReply</code></p><p>этот необязательный строковый элемент имеет тот же смысл, что и соответствующий атрибут операции <a href="./XMLAPI.html#calendarDecline">calendarDecline</a> протокола XIMSS.</p></li><li><p><code>replyComment</code></p><p>этот необязательный строковый элемент имеет тот же смысл, что и тело запроса <a href="./XMLAPI.html#calendarDecline">calendarDecline</a> протокола XIMSS. Значение <em>calendarRef</em> может быть нулевым. В этом случае только создаётся сообщение с отрицательным ответом.</p></li></ul></li><li><p>&quot;ACCEPT&quot;</p><p>Эта операция помещает событие в Календарь и отправляет положительный ответ организатору События. Существующий объект с тем же UID удаляется. Другие элементы <em>params</em>:</p><ul><li><p><code>data</code></p><p>принимаемый элемент <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a>.</p></li><li><p><code>attachments</code></p><p>этот необязательный атрибут имеет тот же смысл, что и в операции <code>PUBLISH</code>.</p></li><li><p><code>PARTSTAT</code>, <code>sendReply</code></p><p>эти необязательные строковые элементы имеют тот же смысл, что и соответствующие атрибуты операции <a href="./XMLAPI.html#calendarAccept">calendarAccept</a> протокола XIMSS.</p></li><li><p><code>replyComment</code></p><p>этот необязательный строковый элемент имеет то же значение, что и тело запроса <a href="./XMLAPI.html#calendarAccept">calendarAccept</a> протокола XIMSS.</p></li></ul></li><li><p>&quot;UPDATE&quot;</p><p>Эта операция изменяет Событие в Календаре с использованием объекта <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> типа reply. Этот объект подтверждает принятие или отказ приглашения на встречу для этого участника. Другие элементы <em>params</em>:</p><ul><li><p><code>data</code></p><p>объект <a href="./Data.html#XMLiCalendar"><code>iCalendar</code></a> типа &quot;reply&quot;, используемый для изменения События в Календаре.</p></li></ul></li></ul></li></ul><h3 id="FileStorage" tabindex="-1">Хранилище Файлов <a class="header-anchor" href="#FileStorage" aria-label="Permalink to &quot;Хранилище Файлов {#FileStorage}&quot;">​</a></h3><p>Следующие функции управляют файлами и файловыми директориями в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a> текущего Пользователя. Для доступа к Хранилищу Файлов другого Пользователя, указывайте имя папки или файла в виде строки ~<em>account</em>[@<em>domainName</em>]/<em>fileName</em>.</p><ul><li><p><code>ReadStorageFile(fileDescr)</code></p><p>Эта функция читает файл Хранилища Файлов. Если значением <em>fileDescr</em> является строка, то в ней задаётся имя файла из <a href="./../admin/storage/FileStore.html">Хранилища Файлов</a>, который необходимо прочитать. Читается весь файл - и таким способом можно прочитать только файлы с размером, не превышающим 1 Мб. Если значением <em>fileDescr</em> является словарь, то используются следующие элементы словаря:</p><ul><li><p><code>fileName</code></p><p>строка с именем файла, который необходимо прочитать.</p></li><li><p><code>position</code></p><p>необязательный элемент. Его значением должно быть неотрицательное число, которое указывает на позицию в файле (в байтах), с которой необходимо читать файл.</p></li><li><p><code>limit</code></p><p>необязательный элемент. Его значение должно быть неотрицательным числом, задающим максимальный размер читаемых данных (в байтах). Если файл короче, чем начальная позиция чтения плюс максимальный размер чтения, то прочитанный блок данных будет соответственно короче. Это значение не должно превышать 1 Мб. Эта функция возвращает блок данных, в котором находится содержимое файла; если указанный файл не может быть прочитан, то возвращается нулевое значение.</p></li></ul></li><li><p><code>WriteStorageFile(fileDescr,data)</code></p><p>Эта функция сохраняет значение <em>data</em> (которое должно быть строкой или блоком данных) в указанный файл в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Значение <em>fileDescr</em> является строкой; в ней задаётся имя файла, в который необходимо записать данные. Файл полностью перезаписывается. Если значением <em>fileDescr</em> является словарь, то используются следующие элементы словаря:</p><ul><li><p><code>fileName</code></p><p>строка с именем файла, который необходимо записать</p></li><li><p><code>position</code></p><p>необязательный элемент. Если он задан, то файл перезаписывается не полностью. Если значением этого элемента является неотрицательное число, то оно указывает на позицию в файле (в байтах), с которой необходимо начать запись в файл. Если значением этого элемента являются строки end или append, то операция записи начинается с текущего конца файла. Если значением этого элемента является строка new, то операция записи сначала проверяет, что такой файл не существует. Эта функция возвращает нулевое значение, если файл был успешно записан; в противном случае возвращается строка с кодом ошибки.</p></li></ul></li><li><p><code>AppendStorageFile(fileName,data)</code></p><p>Эта функция добавляет блок данных или строку <em>data</em> в конец файла с именем <em>fileName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Если <em>fileName</em> не является строкой или <em>data</em> не является ни блоком данных, ни строкой, то вызов этой функции приведёт к возникновению исключительной ситуации. Эта функция возвращает нулевое значение, если файл был успешно записан; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>DeleteStorageFile(fileName)</code></p><p>Эта функция удаляет файл из <a href="./../admin/storage/FileStore.html">Хранилища Файлов</a>. Эта функция возвращает нулевое значение, если файл был успешно удалён; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>RenameStorageFile(oldFileName,newFileName)</code></p><p>Эта функция переименовывает файл <em>oldFileName</em> в <a href="./../admin/storage/FileStore.html">Хранилища Файлов</a> в <em>newFileName</em>. Оба параметра должны иметь строковые значения. Эта функция возвращает нулевое значение, если файл был успешно переименован; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>CreateStorageDirectory(directoryName)</code></p><p>Эта функция создаёт директорию <em>directoryName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Эта функция возвращает нулевое значение, если директория была успешно создана; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>RenameStorageDirectory(oldDirectoryName,newDirectoryName)</code></p><p>Эта функция переименовывает директорию <em>oldDirectoryName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a> в <em>newDirectoryName.</em> Оба параметра должны иметь строковые значения. Эта функция возвращает нулевое значение, если директория была успешно переименована; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>DeleteStorageDirectory(directoryName)</code></p><p>Эта функция уничтожает директорию <em>directoryName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Директория должна быть пустой. Эта функция возвращает нулевое значение, если директория была успешно удалена; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>ListStorageFiles(folderName)</code></p><p>Эта функция возвращает информацию о всех файлах в указанной поддиректории <a href="./../admin/storage/FileStore.html">Хранилища Файлов</a>. Если <em>folderName</em> не является строкой, то возвращается информация о директории верхнего уровня <a href="./../admin/storage/FileStore.html">Хранилища Файлов</a> текущего Пользователя. В случае ошибки эта функция возвращает нулевое значение. В противном случае функция возвращает словарь. Для каждого файла или директории ключ словаря содержит имя, а значением является словарь со следующими элементами:</p><ul><li><p><code>STFileSize</code></p><p>числовое значение, равное размеру файла в байтах. Этот элемент задан для файлов, но отсутствует для директорий.</p></li><li><p><code>STCreated</code></p><p>необязательный атрибут с отметкой времени создания файла.</p></li><li><p><code>STModified</code></p><p>необязательный атрибут с отметкой времени изменения файла.</p></li><li><p><code>MetaModified</code></p><p>необязательный атрибут с отметкой времени изменения набора атрибутов файла или директории.</p></li></ul></li><li><p><code>ReadStorageFileAttr(fileName,attributes)</code></p><p>Эта функция читает атрибуты файла или директории <em>fileName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Если <em>fileName</em> не является строкой или <em>attributes</em> не является ни массивом, ни нулевым значением, то вызов функции приведёт к возникновению исключительной ситуации. Значение <em>attributes</em> должно быть либо нулевым (и тогда зачитываются все атрибуты), либо должно быть массивом строк с именами атрибутов, значения которых надо прочитать. Если атрибуты удалось прочитать, то функция возвращает массив атрибутов файла, где каждый элемент - объект XML. В противном случае функция возвращает строку с кодом ошибки.</p></li><li><p><code>WriteStorageFileAttr(fileName,attributes)</code></p><p>Эта функция изменяет атрибуты файла или директории <em>fileName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Если <em>fileName</em> не является строкой или <em>attributes</em> не является массивом, то вызов функции приведёт к возникновению исключительной ситуации. Значение <em>attributes</em> должно быть массивом объектов XML. Дополнительную информацию смотрите в описании Протокола <a href="./XMLAPI.html#fileAttrWrite">XIMSS</a>. Эта функция возвращает нулевое значение, если атрибуты были успешно изменены; в противном случае возвращается строка с кодом ошибки.</p></li><li><p><code>LockStorageFile(fileName,params)</code></p><p>Эта функция управляет &quot;блокировкой&quot; файла или директории <em>fileName</em> в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a>. Если <em>fileName</em> не является строкой или <em>params</em> не является словарём, то вызов функции приведёт к возникновению исключительной ситуации. Значение <em>params</em> должно быть словарём с параметрами запроса блокировки. Дополнительную информацию смотрите в описании Протокола <a href="./XMLAPI.html#fileLock">XIMSS</a>. Эта функция возвращает словарь, если операция завершилась успешно; в противном случае возвращается строка с кодом ошибки.</p></li></ul><h3 id="Roster" tabindex="-1">Ростер <a class="header-anchor" href="#Roster" aria-label="Permalink to &quot;Ростер {#Roster}&quot;">​</a></h3><p>В следующих встроенных функциях реализован интерфейс к Ростеру Пользователя.</p><ul><li><p><code>ReadRoster()</code><br><code>ReadRoster(accountName)</code></p><p>Эта функция читает элементы данных Ростера. Если значение <em>accountName</em> является нулевым, то читается Ростер текущего Пользователя; в противном случае значение <em>accountName</em> должно быть строкой, указывающей имя Пользователя, чьи элементы данных Ростера будут прочитаны. Эта функция возвращает словарь с элементами данных Ростера, где ключами словаря являются адреса электронной почты контактов, а значениями словаря будут следующие элементы:</p><ul><li><p><code>Inp</code></p><p>&quot;входящий&quot; режим подписки: он управляет тем, может ли контакт наблюдать за статусом присутствия пользователя. Возможные значения: нулевое значение, истинно, &quot;Pending&quot;, &quot;Blocked&quot;.</p></li><li><p><code>Out</code></p><p>&quot;исходящий&quot; режим подписки: он управляет тем, может ли пользователь наблюдать за статусом присутствия контакта. Возможные значения: нулевое значение, истинно, &quot;Pending&quot;.</p></li><li><p><code>Настоящее Имя</code></p><p>строка с настоящим именем контакта (необязательная). Если функция не смогла прочитать данные Ростера, то она возвращает строку с кодом ошибки.</p></li></ul></li><li><p><code>SetRoster(params)</code><br><code>SetRoster(params,accountName)</code></p><p>Эта функция изменяет элементы данных Ростера. Если <em>accountName</em> имеет нулевое значение, то изменяются Ростер текущего Пользователя; в противном случае значением <em>accountName</em> должна быть строка, задающее имя Пользователя, чьи данные необходимо изменить. Значение <em>params</em> должно быть словарём со следующими элементами:</p><ul><li><p><code>peer</code></p><p>строка с адресом электронной почты контакта (&quot;<em>accountName</em>@<em>domainName</em>&quot;).</p></li><li><p><code>what</code></p><p>Строка с типом операции:</p><ul><li>&quot;update&quot;: изменяет информацию контакта.</li><li>&quot;remove&quot;: удаляет контакт из Ростера.</li><li>&quot;subscribed&quot;: подтверждает запрос контакта на наблюдение за информацией о статусе присутствия пользователя.</li><li>&quot;unsubscribed&quot;: отвергает запрос контакта на наблюдение за информацией о статусе присутствия пользователя или отзывает предоставленное ранее право на наблюдение.</li><li>&quot;subscribe&quot;: отправляет запрос на наблюдение за информацией о статусе присутствия контакта.</li><li>&quot;subBoth&quot;: подтверждает запрос контакта на наблюдение за информацией о статусе присутствия пользователя и отправляет запрос на наблюдение за информацией о статусе присутствия контакта.</li><li>&quot;unsubscribe&quot;: останавливает наблюдение за информацией о статусе присутствия контакта.</li></ul></li><li><p><code>data</code></p><p>необязательный словарь с новой информацию о контакте.</p></li></ul></li></ul><h3 id="Dataset" tabindex="-1">Наборы Данных <a class="header-anchor" href="#Dataset" aria-label="Permalink to &quot;Наборы Данных {#Dataset}&quot;">​</a></h3><p>В следующих встроенных функциях реализован интерфейс к Наборам Данных Пользователя. Для доступа к Набору данных других Пользователей, имя набора данных должно быть задано строкой &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>datasetName</em>&quot;.</p><ul><li><p><code>DatasetList(datasetName,filterField,filterValue)</code></p><p>Эта функция читает данные из набора данных Пользователя. Значение <em>datasetName</em> должно быть строкой с именем набора данных. Значения <em>filterField</em> и <em>filterValue</em> должны быть нулевыми или строками. Если эти значения являются строками, то они указывают на имя и значение записи. В результат включаются только те записи, указанный атрибут которых совпадает с заданным значением. Эта функция возвращает словарь с записями из набора данных. Ключами словаря являются имена записей, а элементами словаря являются данные записей. Каждая запись данных является словарём, в котором содержатся атрибуты записи данных. Если записи из набора данных не могут быть прочитаны, то функция возвращает строку с кодом ошибки.</p></li><li><p><code>DatasetCreate(datasetName)</code></p><p>Эта функция создаёт набор данных Пользователя. Значение <em>datasetName</em> должно быть строкой, задающей имя набора данных. Если набор данных был успешно создан, то функция возвращает нулевое значение. В противном случае, функция возвращает строку с кодом ошибки.</p></li><li><p><code>DatasetRemove(datasetName,ifExists)</code></p><p>Эта функция удаляет набор данных Пользователя. Значение <em>datasetName</em> должно быть строкой, задающей имя набора данных. Если значение <em>ifExists</em> является ненулевым и удаляемый набор данных уже не существует, то функция не возвращает код ошибки. Если набор данных был успешно удалён, то функция возвращает нулевое значение. В противном случае, функция возвращает строку с кодом ошибки.</p></li><li><p><code>DatasetSet(datasetName,entryName,entryData,ifExists)</code></p><p>Эта функция изменят записи данных в наборе данных Пользователя. Значение <em>datasetName</em> должно быть строкой, задающей имя набора данных. Значение <em>entryName</em> должно быть строкой, задающей имя записи. Значение <em>entryData</em> должно быть словарём, задающим данные записи (атрибуты). Если значение <em>ifExists</em> нулевое, то если набор данных не существует, он создаётся; данные с указанными именем также создаются, если они не существуют. Если набор данных был успешно изменён, то функция возвращает нулевое значение. В противном случае, функция возвращает строку с кодом ошибки.</p></li><li><p><code>DatasetDelete(datasetName,entryName,ifExists)</code></p><p>Эта функция удаляет данные из набора данных Пользователя. Значение <em>datasetName</em> должно быть строкой, задающей имя набора данных. Значение <em>entryName</em> должно быть строкой, задающей имя записи. Если значение <em>ifExists</em> является ненулевым и удаляемые данные набора данных уже не существуют, то функция не возвращает код ошибки. Если набор данных был успешно удалён, то функция возвращает нулевое значение. В противном случае, функция возвращает строку с кодом ошибки.</p></li></ul><h3 id="Directory" tabindex="-1">Справочник <a class="header-anchor" href="#Directory" aria-label="Permalink to &quot;Справочник {#Directory}&quot;">​</a></h3><p>В следующих встроенных функциях реализован интерфейс к Менеджеру <a href="./../admin/directory/">Справочника</a>.</p><ul><li><p><code>DirectorySearch(baseDN,filter,parameters)</code></p><p>Эта функция выполняет поиск в справочнике, возвращая словарь с найденными записями. Значение <em>baseDN</em> должно быть строкой с базовым DN поиска. Если это значение равно &quot;$&quot;, то установки <a href="./../admin/directory/CentralDir.html">Центрального Справочника</a> используются для создания Базового DN текущего Домена. Значение <em>filter</em> должно быть либо нулевым, либо строкой с фильтром поиска согласно RFC2254. Значение <em>parameters</em> должно быть либо нулевым, либо словарём, в котором содержатся параметры поиска:</p><ul><li><p><code>limit</code></p><p>Если значением этого параметра является положительное число, то оно задаёт максимальное количество возвращаемых записей. Иначе возвращается не более 100 записей.</p></li><li><p><code>keys</code></p><p>Если значением этого параметра является &quot;DN&quot;, то ключами словаря с результатами являются Полные DN записи. В противном случае, ключами словаря с результатами являются RDN записей.</p></li><li><p><code>scope</code></p><p>Если значением этого параметра является &quot;sub&quot;, то выполняется поиск в поддеревьях. Иначе ищутся только записи непосредственно под Базовым DN.</p></li><li><p><code>attributes</code></p><p>Если значение этого параметра является массивом строк, то в найденные записи включаются только перечисленные в этом массиве атрибуты. В противном случае, в записи включаются все атрибуты. Если операция поиска в справочнике заканчивается неуспешно (отсутствует запись Базового DN, недостаточно прав доступа и т.д.), то функция возвращает строку с кодом ошибки.</p></li></ul></li><li><p><code>DirectoryModify(theDN,newRDN,record)</code></p><p>Эта функция вносит изменения в справочник: создаёт или удаляет запись, переименовывает запись. Значение <em>theDN</em> должно быть строкой с DN записи. Если это значение равно &quot;$&quot;, то используются установки <a href="./../admin/directory/CentralDir.html">Центрального Справочника</a> для создания Базового DN текущего Домена. Значение <em>newRDN</em> должно быть либо нулевым, либо строкой с новым относительным DN для записи. Значение <em>record</em> должно быть либо нулевым (и тогда запись, указанная параметром theDN будет удалена), либо словарём с атрибутами для вновь создаваемой записи.</p><p>Если изменение в справочнике заканчивается неуспешно (отсутствует запись Базового DN, недостаточно прав доступа и т.д.), то функция возвращает строку с кодом ошибки.</p></li></ul><h3 id="Services" tabindex="-1">Услуги <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Услуги {#Services}&quot;">​</a></h3><ul><li><p><code>GetLanguage()</code></p><p>Значением функции является строка с текущим &quot;выбранным языком&quot;.</p></li><li><p><code>SetLanguage(lang)</code></p><p>Эта процедура устанавливает &quot;выбранный язык&quot;. Значением <em>lang</em> должна быть строка с именем языка или нулевое значение для установки языка по умолчанию.</p></li><li><p><code>GetTimeZoneName()</code></p><p>Значением функции является строка с именем текущего &quot;выбранного часового пояса&quot;. Если не выбрано никакого часового пояса (используется часовой пояс сервера), то функция возвращает нулевое значение.</p></li><li><p><code>SetTimeZone(zoneName)</code></p><p>Эта процедура устанавливает текущий часовой пояс. Значение <em>zoneName</em> должно быть строкой с именем известного часового пояса. Если указывается неизвестное имя часового пояса или значение <em>zoneName</em> не является строкой, то устанавливается фиктивное значение <em>no zone</em> и используется текущий часовой пояс Сервера.</p></li><li><p><code>ReadEnvirFile(fileName)</code></p><p>Функция зачитывает файл из текущей &quot;среды&quot;, например, из среды <a href="./PBXApp.html">Приложений Реального Времени</a>. Эта функция возвращает блок данных, в котором находится содержимое файла; если указанный файл не может быть прочитан, то возвращается нулевое значение.</p></li><li><p><code>ReadSkinObject(tagName)</code><br><code>ReadSkinObject(tagName,index)</code><br><code>ReadSkinObject(tagName,index,skinName)</code></p><p>Функция зачитывает указанный объект из <a href="./WebApp.html#Strings">Текстового Набора Данных</a> указанного Вида Интерфейса (или Базового Вида Интерфейса, если параметр <em>skinName</em> не задан). Объект задаётся по ключу <em>tagName</em> и параметру <em>index</em>, который может быть:</p><ul><li><p><code>null</code></p><p>зачитывается объект полностью</p></li><li><p><em>строка</em></p><p>используется как ключ доступа к элементам объекта-словаря</p></li><li><p><em>число</em></p><p>используется как индекс для доступа к элементам объекта (массива или словаря)</p></li><li><p><em>массив</em></p><p>элементы последовательно используются в качестве ключей или индексов в иерархии объектаЗначением функции является объект, заданный параметрами <em>tagName</em> и <em>index</em>, или нулевой объект, если по заданным параметрам в Тектовом Наборе Данных ничего не найдено.</p></li></ul></li><li><p><code>SysLog(arg)</code></p><p>Эта процедура записывает в Журнал Сервера текстовое представление значения <em>arg</em>.</p></li><li><p><code>SysProfile(arg)</code></p><p>Если значение <em>arg</em> является нулевым, то процедура уменьшает внутренний целочисленный счётчик <em>уровня профилирования</em> на 1; в противном случае она увеличивает его на 1. Счётчик <em>уровня профилирования</em> при запуске программы устанавливается в ноль. Если счётчик <em>уровня профилирования</em> имеет положительное значение, то в Журнал Сервера помещаются профилирующие записи при входе во все определённые пользователем (и в некоторые из встроенных функций/процедур), а также при выходе из них.</p></li><li><p><code>ExecuteCLI(arg)</code></p><p>Эта функция выполняет команду <a href="./CLI.html">Интерфейса Командной Строки (CLI)</a>. Значение <em>arg</em> должно быть строкой, содержащей одну команду CLI. Если команда CLI выполнена успешно, то эта функция возвращает нулевое значение. В противном случае эта функция возвращает строку с кодом ошибки. Если команда CLI возвращала какие-либо данные, то они помещаются в <a href="#VarsF">переменную Задачи</a> <code>executeCLIResult</code> (обращение к переменной может быть осуществлено как <code>Vars().executeCLIResult)</code>. Если команда CLI закончилась неуспешно, или если она не возвращала никаких данных, то этой переменной Задачи присваивается нулевое значение.</p></li><li><p><code>SetApplicationStatus(arg)</code></p><p>Эта процедура копирует аргумент в дескриптор текущей Задачи. Внешние модули и субъекты могут получать эту информацию из дескриптора Задачи.</p></li><li><p><code>StoreCDR(arg)</code></p><p>Эта процедура отправляет значение <em>arg</em> (которое должно быть строкой) в программу <a href="./Helpers.html#CDR">Внешнего Обработчика CDR</a>. К значению <em>arg</em> добавляется префикс APP, а программа в первой части значения <em>arg</em> указывает своё имя и номер версии; это позволяет программе - Внешнему Обработчику различать записи, созданные в разных программах: APP <em>arg</em></p></li><li><p><code>DoBalance(parameters,accountName)</code></p><p>Эта функция выполняет операцию <a href="./../admin/misc/Billing.html">Тарификации</a>. Если <em>accountName</em> имеет нулевое значение, то операция применяется для текущего Пользователя. В противном случае, значением <em>accountName</em> должна быть строка, задающая имя требуемого Пользователя. В любом случае, операция осуществляется с ограничениями, накладываемыми существующими Правами Доступа. Значение <em>parameters</em> должно быть словарём. В нём задаются параметры операции (дополнительную информацию смотрите в разделе <a href="./../admin/misc/Billing.html">Тарификация</a>). Имя операции задаётся значением элемента словаря параметров с ключом &quot;op&quot;. Если операция заканчивается неудачно, то функция возвращает строку с кодом ошибки. В противном случае функция возвращает словарь с результатами операции (как описано в разделе <a href="./../admin/misc/Billing.html">Тарификация</a>).</p></li><li><p><code>Statistics(elementName,opCode,setValue)</code></p><p>Функция читает или изменяет <a href="./../admin/sysadmin/Statistics.html">Элемент Статистики</a> Сервера. Значением <em>elementName</em> должна быть строка с OID <a href="./../admin/sysadmin/Statistics.html">Элемента Статистики</a> или именем <a href="./../admin/sysadmin/Statistics.html#Custom">Модифицируемого Элемента Статистики</a>. Значением <em>setValue</em> должно быть число. Значение <em>opCode</em> должно быть либо нулевым, либо строкой. Если значение строки - &quot;inc&quot;, то значение Элемента увеличивается на значение <em>setValue</em>. Если значение строки - &quot;set&quot;, то значение Элемента устанавливается в значение <em>setValue</em>. Если же значение не задано или нулевое, то Элемент не меняется. Изменять можно только Модифицируемые Элементы Статистики. Функция возвращает или число с текущим значением Элемента Статистики, или строку с кодом ошибки.</p></li><li><p><code>CallHelper(name,parameters)</code><br><code>CallHelper(name,parameters,mode)</code></p><p>Эта функция отправляет запрос во <a href="./Helpers.html#AppHelpers">Внешний Помощник Приложений</a>. Значение <em>name</em> должно быть строкой, указывающей на имя Помощника Приложений. Значение <em>parameters</em> передаётся Помощнику. Необязательная строка <em>mode</em> используется для указания члена кластера, на котором запущен помощник. Функция возвращает объект с данными из ответа Помощника Приложений (может быть возвращено нулевое значение).</p></li><li><p><code>BannerRead(type,parameters)</code></p><p>Эта функция отправляет запрос во <a href="./Helpers.html#Banner">Внешнюю Рекламную Систему</a>. Значение <em>type</em> должно быть строкой, указывающей на тип рекламы (зависит от приложения, например, &quot;prontoEmailTop&quot;, &quot;myClientLeftBanner&quot;). Значение <em>parameters</em> передаётся во Внешнюю Рекламную Систему. Функция возвращает объект с рекламными данными из ответа Внешней Рекламной Системы (может быть возвращено нулевое значение).</p></li><li><p><code>syncDelay(milliseconds)</code></p><p>Эта функция замораживает выполнение скрипта на указанное количество миллисекунд.</p></li></ul><h3 id="Communications" tabindex="-1">Коммуникации <a class="header-anchor" href="#Communications" aria-label="Permalink to &quot;Коммуникации {#Communications}&quot;">​</a></h3><ul><li><p><code>HTTPCall(URL,parameters)</code></p><p>Эта функция выполняет транзакцию HTTP. У текущего Пользователя должна быть включена <a href="./../admin/objects/Accounts.html#Services">Услуга</a> <code>HTTP</code>. Значение <em>URL</em> должно быть строкой. Оно указывает URL запроса. Значение <em>parameters</em> должно быть словарём, в котором содержатся параметры поиска. В нём указываются требуемые параметры и, возможно, тело запроса. Эти значения вместе с максимальным тайм-аутом в 30 секунд передаются для обработки в Модуль <a href="./../admin/services/HTTP.html#Client">Клиент HTTP</a>. Функция возвращает или Словарь с результатами работы модуля HTTP, или строку с кодом ошибки.</p></li><li><p><code>SubmitEMail(headers,content)</code></p><p>Эта функция создаёт и отправляет сообщение электронной почты. Значение <em>headers</em> должно быть либо нулевым, либо словарём. В этом словаре указываются значения полей заголовка для создаваемого сообщения электронной почты. Обрабатываются следующие элементы словаря (все необязательные):</p><ul><li><p><code>From</code></p><p>значение элемента должно быть строкой с адресом электронной почты. Оно задаёт адрес <code>From:</code> сообщения.</p></li><li><p><code>To</code></p><p>значение элемента должно быть строкой с адресом электронной почты или массивом строк с адресами электронной почты. Оно задаёт адрес(а) <code>To:</code> сообщения</p></li><li><p><code>Cc</code></p><p>значение элемента должно быть строкой с адресом электронной почты или массивом строк с адресами электронной почты. В нём задаются адрес(а) <code>Cc:</code> сообщения.</p></li><li><p><code>Bcc</code></p><p>значение элемента должно быть строкой с адресом электронной почты или массивом строк с адресами электронной почты. В нём задаются адрес(а) <code>Bcc:</code> сообщения.</p></li><li><p><code>Subject</code></p><p>значение элемента должно быть строкой. В нём указывается поле <code>Subject:</code> сообщения.</p></li><li><p><code>Date</code></p><p>значение элемента должно быть отметкой времени. В нём указывается содержимое поля <code>Date:</code> сообщения. Если этот элемент отсутствует, то используется текущее время.</p></li><li><p><code>sourceType</code></p><p>значение элемента должно быть строкой. В нём указывается <a href="./../admin/mail/#Sources">источник сообщения</a>. Если этот элемент отсутствует, то используется строковое значение &quot;CGPL&quot;.</p></li><li><p><code>sourceAddress</code></p><p>значение элемента должно быть строкой. В нём указывается адрес источника сообщения (сетевой адрес, имя удалённой системы и т.д.)</p></li><li><p><code>Message-ID</code></p><p>значение элемента должно быть строкой. В нём указывается поле <code>Message-ID:</code> сообщения. Если этот элемент отсутствует, то используется автоматически генерируемая строка.</p></li><li><p><code>protocol</code></p><p>значение элемента должно быть строкой. В нём указывается имя протокола, использованного для передачи сообщения.</p></li><li><p><code>Content-Class</code></p><p>значение элемента должно быть строкой. В нём указывается значение поля заголовка сообщения <code>Content-Class:</code>.</p></li><li><p><code>X-Priority</code></p><p>значение элемента должно быть строкой. В нём указывается значение поля заголовка сообщения <code>X-Priority:</code>.</p></li><li><p><code>X-Mailer</code></p><p>значение элемента должно быть строкой. В нём указывается поле <code>X-Mailer:</code> сообщения. Если этот элемент отсутствует, то используется автоматически генерируемая строка. Параметр <em>content</em> задаёт тело сообщения электронной почты. Если значение является словарём, то элемент словаря <code>body</code> является фактическим содержанием, а другие элементы словаря определяют различные параметры тела сообщения (поля заголовка содержимого). В противном случае в <em>content</em> содержится фактическое содержание сообщения, а параметры содержимого считаются пустыми. Обрабатываются следующие (все являются необязательными) параметры содержания (элементы словаря):</p></li><li><p><code>Content-Type</code></p><p>значение элемента должно быть строкой. Оно указывает Content-Type содержимого тела сообщения. Если этот элемент не указан, то Content-Type устанавливается в &quot;text&quot;, если фактическим содержанием является строка; в противном случае Content-Type устанавливается в &quot;application&quot;</p></li><li><p><code>Content-Subtype</code></p><p>значение элемента должно быть строкой. Оно указывает подтип Content-Type содержимого тела сообщения. Если этот элемент отсутствует и Content-Type устанавливается в &quot;text&quot;, то Content-Subtype устанавливается в &quot;plain&quot;</p></li><li><p><code>filename</code></p><p>значение элемента должно быть строкой. Оно указывает имя файла содержимого тела сообщения.</p></li><li><p><code>Content-Disposition</code></p><p>значение элемента должно быть строкой. Оно указывает Content-Disposition содержимого тела сообщения. Если этот элемент отсутствует и присутствует элемент <code>fileName</code>, то значение Content-Disposition устанавливается в &quot;attachment&quot; Если фактическим содержимым является строка, то она сохраняется без изменений, используя <code>8-битную</code> кодировку Content-Transfer-Encoding. Если фактическим содержимым является блок данных, то он сохраняется в кодировке <code>base64</code> Content-Transfer-Encoding. Если фактическим содержимым является массив, то содержимое является multi-part. Используется только параметр Content-Subtype; если он отсутствует, то применяется значение &quot;mixed&quot;. Каждый элемент массива сохраняется также, как и значение <em>content</em>. Если фактическое содержимое - ни массив, ни строка, ни блок данных, то сохраняется пустое тело сообщения. Эта функция возвращает нулевое значение, если сообщение электронной почты было создано и отправлено (передано в Очередь). В противном случае эта функция возвращает строку с кодом ошибки.</p></li></ul><p>В следующем примере отправляется простое текстовое сообщение.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Message&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  result  = SubmitEmail(headers,&quot;Test Message Body\\eEnd Of Message\\e&quot;);</span></span></code></pre></div><p>В следующем примере отправляется multipart/mixed сообщение. В нём содержится HTML текст и вложенный файл.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>content = NewArray();</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  textPart = NewDictionary();</span></span>
<span class="line"><span>  textPart.(&quot;Content-Type&quot;) = &quot;text&quot;;</span></span>
<span class="line"><span>  textPart.(&quot;Content-Subtype&quot;) = &quot;html&quot;;</span></span>
<span class="line"><span>  textPart.body = &quot;&lt;HTML&gt;&lt;BODY&gt;This is an &lt;B&gt;HTML&lt;/B&gt; text&lt;/BODY&gt;&lt;/HTML&gt;&quot;;</span></span>
<span class="line"><span>  content[0] = textPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  dataPart = NewDictionary();</span></span>
<span class="line"><span>  dataPart.(&quot;Content-Type&quot;)    = &quot;image&quot;;</span></span>
<span class="line"><span>  dataPart.(&quot;Content-Subtype&quot;) = &quot;gif&quot;;</span></span>
<span class="line"><span>  dataPart.fileName = &quot;file.gif&quot;;</span></span>
<span class="line"><span>  dataPart.body     = ReadStorageFile(dataPart.fileName);</span></span>
<span class="line"><span>  content[1] = dataPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Attachment&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  headers.(&quot;Content-Class&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  result = SubmitEMail(headers,content);</span></span></code></pre></div><p>Во вновь создаваемые сообщения электронной почты можно включать части других сообщений. Если существует параметр тела содержимого <code>MIMEPartID</code> со строковым значением, то должен быть также задан параметр тела содержимого <code>source</code> со значением Описатель Сообщения. Если значением параметра If the <code>MIMEPartID</code> является &quot;message&quot;, то все Сообщение <code>source</code> копируется (как тело MIME части <code>message/rfc822</code>). Значение параметра <code>MIMEPartID</code> указывает на ту часть MIME сообщения <code>source</code>, которая будет скопирована в новое сообщение; при копировании части с заголовками используются только поля MIME (<code>Content-xxxxxx</code>).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>content = NewArray();</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  textPart = NewDictionary();</span></span>
<span class="line"><span>  textPart.(&quot;Content-Type&quot;)    = &quot;text&quot;;</span></span>
<span class="line"><span>  textPart.(&quot;Content-Subtype&quot;) = &quot;plain&quot;;</span></span>
<span class="line"><span>  textPart.body = &quot;Please see the attached letter.\\e&quot;;</span></span>
<span class="line"><span>  content[0] = textPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  attachPart = NewDictionary();</span></span>
<span class="line"><span>  attachPart.(&quot;source&quot;)    = MyOldMessage;</span></span>
<span class="line"><span>  attachPart.(&quot;MIMEPartID&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span>  content[1] = dataPart;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  headers = NewDictionary();</span></span>
<span class="line"><span>  headers.From    = &quot;from@sender.dom&quot;;</span></span>
<span class="line"><span>  headers.Subject = &quot;Test Forwarded message&quot;;</span></span>
<span class="line"><span>  headers.To      = &quot;To@recipient.dom&quot;;</span></span>
<span class="line"><span>  headers.(&quot;Content-Class&quot;) = &quot;message&quot;;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  result = SubmitEMail(headers,content);</span></span></code></pre></div></li><li><p><code>SendEMail(fromAddress,subject,to,headers,content)</code></p><p>Эта функция создаёт и отправляет сообщение электронной почты. Вызов этой функции осуществляется аналогично вызову функции SubmitEMail(<em>headers</em>,<em>content</em>), где значения <em>fromAddress</em>, <em>subject</em> и <em>to</em> (если они не являются нулевыми) используются вместо элементов словаря <em>headers</em> <code>From</code>,<code>Subject</code> и <code>To</code>.</p><p>В следующем примере отправляется простое текстовое сообщение.</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>result = SendEmail(&quot;from@sender.dom&quot;,&quot;Test Message&quot;,&quot;To@recipient.dom&quot;,</span></span>
<span class="line"><span>                      null,&quot;Test Message\\eEnd Of Message\\e&quot;);</span></span></code></pre></div></li><li><p><code>SendInstantMessage(fromAddress,toAddress,content)</code></p><p>Эта функция создаёт и отправляет Мгновенное Сообщение. Значение <em>fromAddress</em> должно быть строкой или нулевым. Оно задаёт адрес <code>From:</code> (отправителя) сообщения. Если задано нулевое значение, адрес отправителя равен адресу текущего Пользователя. Если задана строка, но она не содержит символа @, то отправителя равен адресу текущего Пользователя, а значение строки используется для имени ресурса (экземпляра) отправителя. Если строка содержит символ @, то имя ресурса (экземпляр) отправителя можно указать в адресе в виде &quot;user@domain/instance&quot;. Значение <em>toAddress</em> должно быть строкой. Оно задаёт адрес <code>To:</code> сообщения. Строка должна содержать символ @, и имя ресурса (экземпляр) получателя можно указать в адресе в виде &quot;user@domain/instance&quot;. Значение <em>content</em> должно быть строкой или словарём. Если значением является строка, то она задаёт содержимое сообщения. Если значением является словарь, то он должен состоять из следующих элементов:</p><ul><li><p><code>&quot;&quot;</code> (пустая строка)</p><p>этот необязательный элемент должен быть строкой - телом мгновенного сообщения.</p></li><li><p><code>type</code></p><p>необязательная строка: тип сообщения согласно протоколу XMPP: chat, groupchat и т.д.</p></li><li><p><code>id</code></p><p>необязательная строка: атрибут &quot;id&quot; запроса IM.</p></li><li><p><code>suppl</code></p><p>необязательный массив объектов XML, которые будут отправлены в мгновенном сообщении.</p></li><li><p><code>IMSubject</code></p><p>этот необязательный элемент должен быть строкой - темой мгновенного сообщения.</p></li><li><p><code>IMState</code></p><p>если указан этот необязательный элемент, то элементы &quot;&quot; (тело), IMSubject и suppl не должны использоваться. Этот элемент должен быть одной из строк &quot;gone&quot;, &quot;composing&quot;, &quot;paused&quot;, &quot;active&quot; и информирует получателя о намерениях отправителя. Функция только инициирует отправку Мгновенного Сообщения и не ожидает завершения операции. Эта функция возвращает нулевое значение, если Мгновенное Сообщение было создано и отправлено (передано компоненту Signal). В противном случае эта функция возвращает строку с кодом ошибки.</p></li></ul></li><li><p><code>SendXMPPIQ(fromAddress,toAddress,content)</code></p><p>Эта функция отправляет запрос IQ аналогично протоколу XMPP. Значения <em>fromAddress</em> и <em>toAddress</em> имеют тот же смысл, что в функции SendInstantMessage. Значение content должно быть словарём, содержащим следующие элементы:</p><ul><li><p><code>type</code></p><p>этот элемент должен быть строкой: &quot;get&quot;, &quot;set&quot;, &quot;result&quot; и т.д. Для отправки запроса о статусе присутствия этот элемент должен быть &quot;cgp_presence&quot;.</p></li><li><p><code>suppl</code></p><p>этот элемент - массив объектов XML, которые будут отправлены в запросе IQ.</p></li><li><p><code>id</code></p><p>этот элемент должен быть строкой: он задаёт атрибут &quot;id&quot; запроса IQ. Его не надо использовать в запросах о статусе присутствия.</p></li><li><p><code>opcode</code></p><p>этот элемент должен быть строкой, он используется только в запросах о статусе присутствия. Он задаёт значение атрибута &quot;type&quot; в запросе о статусе присутствия, например, &quot;unavailable&quot;.</p></li><li><p><code>status</code></p><p>этот элемент должен быть строкой, он используется только в запросах о статусе присутствия. Он задаёт статус присутствия, например, &quot;online&quot;, &quot;busy&quot; и т.д.</p></li></ul><p>Функция только инициирует отправку запроса и не ожидает завершения операции. Эта функция возвращает нулевое значение, если запрос был создан и отправлен (передан компоненту Signal). В противном случае эта функция возвращает строку с кодом ошибки.</p></li><li><p><code>RADIUSCall(address,parameters)</code></p><p>Эта функция создаёт и отправляет запрос RADIUS. Значение <em>address</em> должно быть адресом IP. Оно указывает адрес и порт сервера RADIUS, на который необходимо отправить запрос. Значение <em>parameters</em> должно быть словарём, содержащим следующие элементы:</p><ul><li><p><code>Type</code></p><p>этот элемент должен быть строкой. Он задаёт тип запроса RADIUS, который необходимо отправить: &quot;authenticate&quot;, &quot;accountingStart&quot;, &quot;accountingUpdate&quot;, &quot;accountingStop&quot;.</p></li><li><p><code>Secret</code></p><p>этот элемент должен быть строкой. Он указывает &quot;общий секрет&quot; сервера RADIUS.</p></li><li><p><code>Username</code></p><p>этот элемент должен быть строкой. Он используется для создания атрибута запроса <code>userName</code> (1).</p></li><li><p><code>Password</code></p><p>этот элемент должен существовать в запросе <code>authenticate</code>, и он должен быть строкой. Он содержит пароль в открытом виде, используемый в операции аутентификации.</p></li><li><p><code>nn</code> (где nn - десятичное число)</p><p>эти элементы задают дополнительные атрибуты запроса (по номерам атрибутов). Значения этих элементов должны быть строками или (для целочисленных параметров) числами, или (для параметра типа Интернет) адресами IP. Если значением элемента является блок данных, то содержимое блока данных отправляется без какого бы то ни было перекодирования. Если значением элемента является массив, то атрибут запроса добавляется в запрос ноль или большее количество раз, по одному разу для каждого значения массива.</p></li><li><p><code>-nnnnn</code> (где nnnnn - десятичное число)</p><p>эти элементы задают дополнительные, зависимые от производителя атрибуты (где nnnnn является идентификатором Производителя). Для получение более подробной информации о представлении зависимых от производителя атрибутов смотрите раздел <a href="./../admin/services/RADIUS.html">RADIUS</a>.</p></li><li><p><code>Error</code></p><p>Если значение этого необязательного элемента равно &quot;data&quot; и в ответ на запрос аутентификации получен ответ отказа, функция возвращает в словаре атрибутов ответа с дополнительным элементом <code>Error</code>. Если значение этого необязательного элемента не равно &quot;data&quot; и в ответ на запрос аутентификации получен ответ отказа, функция возвращает строку с кодом ошибки.</p></li><li><p><code>Retries</code></p><p>этот необязательный элемент должен быть числом или числовой строкой в диапазоне [1..20]. Он переопределяет используемое по умолчанию количество повторных попыток отправки запроса. Этот элемент должен быть установлен в 1, чтобы запрос RADIUS был отправлен только один раз.</p></li><li><p><code>Timeout</code></p><p>этот необязательный элемент должен быть числом или числовой строкой в диапазоне [0..30]. Он переопределяет используемое по умолчанию значение тайм-аута (в секундах). Если ответ не получен за указанное время, запрос посылается снова или возвращается сообщение об ошибке. Если операция RADIUS закончилась успешно, то эта функция возвращает словарь. В этом словаре содержатся атрибуты, которые сервер RADIUS отправил в ответ. Если операция RADIUS закончилась неуспешно, то эта функция возвращает строку с кодом ошибки.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Запросы отправляются через сокет UDP <a href="./../admin/services/RADIUS.html">модуля RADIUS</a>, так что этот модуль должен быть включён (он должен быть настроен на использование какого-либо ненулевого номера порта).</p></div></li></ul><p>В следующем примере отправляется запрос RADIUS на аутентификацию. Запрос содержит текстовый атрибут nasIdentifier (32).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>callParam = newDictionary();</span></span>
<span class="line"><span>callParam.Type     = &quot;authenticate&quot;;</span></span>
<span class="line"><span>callParam.Secret   = &quot;sys2&quot;;</span></span>
<span class="line"><span>callParam.Username = &quot;user4567&quot;;</span></span>
<span class="line"><span>callParam.Password = &quot;drum$1245&quot;;</span></span>
<span class="line"><span>callParam.(&quot;32&quot;)   = &quot;my NAS&quot;;</span></span>
<span class="line"><span>result = RADIUSCall(IPAddress(&quot;[10.0.1.77]:1812&quot;),callParam);</span></span></code></pre></div><p>В следующем примере отправляется учетный (accounting) запрос RADIUS. Запрос содержит текстовый атрибут nasIdentifier (32) и числовой атрибут acctSessionTime (46).</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>callParam = newDictionary();</span></span>
<span class="line"><span>callParam.Type     = &quot;accountingStart&quot;;</span></span>
<span class="line"><span>callParam.Secret   = &quot;sys2&quot;;</span></span>
<span class="line"><span>callParam.Username = &quot;user4567&quot;;</span></span>
<span class="line"><span>callParam.(&quot;32&quot;)   = &quot;my NAS&quot;;</span></span>
<span class="line"><span>callParam.(&quot;46&quot;)   = SessionTimeInMinites*60;</span></span>
<span class="line"><span>result = RADIUSCall(IPAddress(&quot;[10.0.1.77]:1812&quot;),callParam);</span></span></code></pre></div></li></ul><h3 id="SyncScripts" tabindex="-1">Синхронные Скрипты <a class="header-anchor" href="#SyncScripts" aria-label="Permalink to &quot;Синхронные Скрипты {#SyncScripts}&quot;">​</a></h3><p>Сегменты кода CG/PL могут быть использованы для немедленного выполнения синхронных операций и могут быть общими для разных сред. Такие единицы кода сохраняются в текстовых файлах с расширением <code>.scgp</code> (а внешние модули - в файлах с расширением <code>.scgi</code>) в <a href="./WebApp.html#Skins">Базовом наборе</a> файлов интерфейса.</p><p>Синхронный скрип принимает объект в качестве параметра, доступного по ключу <code>startParameter</code> в словаре <code>Vars()</code>, и возвращает объект в качестве результата. Максимальное время выполнения ограничено 5 минутами. Программы CG/PL, реализующие и <a href="./PBXApp.html">Приложения УПАТС</a>, и <a href="./WebApp.html">Web Приложения</a>, могут использовать общие файлы с синхронными скриптами.</p><ul><li><p><code>RunScript(scriptName)</code><br><code>RunScript(scriptName,paramObj)</code><br><code>RunScript(scriptName,paramObj,entryName)</code></p><p>Эта функция используется для выполнения синхронного скрипта. Значением <em>scriptName</em> должна быть строка с именем файла со скриптом, суффикс <code>.scgp</code> не обязателен. Параметр <em>paramObj</em> может быть использован для передачи аргументов (в виде объекта CG/PL) в скрипт. Параметр <em>entryName</em> может быть использован для указания точки входа. По умолчанию используется точка входа с именем <code>main</code>. Функция возвращает объект, созданный в результате выполнения синхронного скрипта. В случае проблем с загрузкой и выполнением скрипта возвращаетсяпустое значение (null).</p></li><li><p><code>SetResult(object)</code></p><p>Эта процедура используется только в синхронных скриптах для задания результата выполнения. Параметр <em>object</em> будет передан в качестве результата вызова функции RunScript.</p></li></ul><h2 id="MultiTask" tabindex="-1">Многозадачность <a class="header-anchor" href="#MultiTask" aria-label="Permalink to &quot;Многозадачность {#MultiTask}&quot;">​</a></h2><p>Некоторые среды (такие, как среды для <a href="./PBXApp.html">Приложений Реального Времени</a>) обеспечивают функции многозадачности. В таких средах разные экземпляры программ (<em>Задач</em>) могут обнаруживать друг друга и обмениваться данными. В этом разделе описываются дополнительные возможности языка, доступные в таких многозадачных средах.</p><p>Описатели задач являются внутренними объектами, представляющими Задачи. В <a href="./../admin/cluster/">Кластерной</a> среде в Описателе задачи содержится также ссылка на тот член Кластера, который выполняет эту Задачу.</p><h3 id="Spawn" tabindex="-1">Порождение <a class="header-anchor" href="#Spawn" aria-label="Permalink to &quot;Порождение {#Spawn}&quot;">​</a></h3><p>Программа (запущенная Задача) может создавать новую задачу, используя выражение порождения. Оно указывается при помощи ключевого слова <code>spawn</code>, за которым следует имя точки входа раздела кода. Новая Задача создаётся и запускается параллельно с Задачей, в которой было использовано выражение порождения, выполняя заданный точкой входа раздел кода.<br> За именем точки входа раздела кода может идти выражение, заключенное в круглые скобки. Если оно указано, то копия значения выражения присваивается элементу <code>startParameter</code> <a href="#VarsF">словаря <code>Vars()</code></a> в новой Задаче.<br> Описатель текущей Задачи присваивается элементу <code>parent</code> <a href="#VarsF">словаря <code>Vars()</code></a> в новой Задаче.<br> Значением выражения порождения является описатель Задачи для созданной новой Задачи или, если система не смогла создать новую Задачу, нулевое значение.</p><p>В следующем примере программа, выполняющая раздел кода <code>Main</code>, создаёт новую задачу, которая начинает выполняться с точки входа <code>DoBackup</code> и копирует файлы &quot;file1&quot;,&quot;file2&quot;,....&quot;file100&quot; в &quot;backup1&quot;,&quot;backup2&quot;,... .</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry DoBackup is</span></span>
<span class="line"><span>  nameIndex = 1;</span></span>
<span class="line"><span>  while nameIndex &lt;= 100 loop</span></span>
<span class="line"><span>    fileData = ReadStorageFile(&quot;file&quot; + String(nameIndex));</span></span>
<span class="line"><span>    if fileData != null then</span></span>
<span class="line"><span>      resultCode = WriteStorageFile(&quot;backup&quot; + String(nameIndex),fileData);</span></span>
<span class="line"><span>      if resultCode != null then</span></span>
<span class="line"><span>        Log(&quot;failed to backup file&quot; + String(nameIndex) +</span></span>
<span class="line"><span>            &quot;. Error Code=&quot; + resultCode);</span></span>
<span class="line"><span>      end if;</span></span>
<span class="line"><span>    end if;</span></span>
<span class="line"><span>  end loop;</span></span>
<span class="line"><span>end entry;</span></span>
<span class="line"><span> </span></span>
<span class="line"><span>entry Main is</span></span>
<span class="line"><span>  backuper = spawn DoBackup;</span></span>
<span class="line"><span>  if backuper == null then</span></span>
<span class="line"><span>    Log(&quot;Failed to start a Backup Task&quot;);</span></span>
<span class="line"><span>  end if;</span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>Задачи не имеют никаких общих переменных, даже если одна Задача прямо создала новую Задачу через выражение порождения.</p><ul><li><p><code>ThisTask()</code></p><p>Эта функция возвращает описатель Задачи для текущей Задачи.<br> Эта функция возвращает нулевое значение если текущая среда выполнения не является Задачей.</p></li><li><p><code>IsTask(arg)</code></p><p>Эта функция возвращает значение истина, если значением <em>arg</em> является Описатель Задачи; в противном случае функция возвращает нулевое значение.</p></li></ul><h3 id="Events" tabindex="-1">События <a class="header-anchor" href="#Events" aria-label="Permalink to &quot;События {#Events}&quot;">​</a></h3><p>Используется <em>Модель Исполнителя:</em> Задачи обмениваются данными отправляя друг другу <em>События</em>.</p><ul><li><p><code>SendEvent(taskRef,eventName)</code><br><code>SendEvent(taskRef,eventName,eventParam)</code></p><p>Эта функция отправляет Событие Задаче. Она возвращает нулевое значение (если Событие было успешно отправлено) или строку с кодом ошибки в ином случае (например, если указанная Задача не существует).<br> Значение <em>taskRef</em> должно быть описателем Задачи.<br> Значение <em>eventName</em> должно быть строкой, начинающейся с буквы латинского алфавита.<br> Необязательный <em>eventParam</em> должен иметь либо нулевое значение, либо быть описателем Задачи или <a href="./Data.html">&quot;базовым&quot;</a> объектом.<br> Эта функция только отправляет Событие в указанную Задачу-приёмник. Она не ожидает ни получения этой Задачей события, ни отправки какого-либо ответа из Задачи-приёмника.</p></li><li><p><code>ReadInput(secsToWait)</code></p><p>События, отправляемые в задачу, ставятся в очередь и при помощи этой функции задача может читать первое Событие, находящееся в очереди. Значением функции является словарь, в котором содержатся данные события.<br> Значение <em>secsToWait</em> должно быть неотрицательным числом.<br> Если очередь Событий Задачи пустая и Задача не получает новые События в течении указанного количества секунд, то функция возвращает нулевое значение.<br> Если эта функция возвращает словарь, то это словарь содержит следующие элементы:</p><ul><li><p><code>what</code></p><p>строка с именем События. Если событие было отправлено при помощи операции SendEvent, то эта строка является значением параметра <em>eventName</em>, использованного в операции SendEvent в Задаче-отправителе.</p></li><li><p><code>sender</code></p><p>описатель Задачи для Задачи-отправителя (Задачи, отправившей событие). В <a href="./../admin/cluster/">Кластерной</a> среде эта Задача и текущая Задача могут быть запущены на разных членах Кластера.<br> Если Событие было отправлено самой платформой или если отправитель не является Задачей, то элемент <code>sender</code> не существует.</p></li><li><p><code>parameter</code></p><p>параметр события. Если событие было отправлено при помощи операции SendEvent, то этот элемент содержит значение параметра <em>eventParam</em>, использованного в операции SendEvent.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>В зависимости от среды выполнения, функция ReadInput может возвращать и другие объекты. Например: если функция используется в среде <a href="./PBXApp.html">Приложения Реального Времени</a>, она может возвращать строку, содержащую первый из имеющихся в очереди символов тонового набора (DTMF).</p></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Функция ReadInput может иметь &quot;ложные пробуждения&quot;, то есть, она может возвращать нулевой объект даже до истечения указанного периода времени.</p></div></li></ul></li></ul><h3 id="Meetings" tabindex="-1">Встречи <a class="header-anchor" href="#Meetings" aria-label="Permalink to &quot;Встречи {#Meetings}&quot;">​</a></h3><p>Механизм Встречи позволяет Задаче делать себя известной другой Задаче, связанной с тем же Пользователем.</p><p>Каждый Пользователь может иметь несколько именованных Наборов Встреч и безымянный Набор Встреч, используемый по умолчанию. Несколько именованных Встреч могут создаваться в любом Наборе Встреч. Каждая Встреча является объектом типа словарь, в котором содержится ноль или больше описателей Задач.</p><p>Имя набора может быть задано строкой вида &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>setName</em>&quot; для доступа к Наборам Встреч других Пользователей.<br> Для доступа к Набору Встреч других Пользователей, текущий Пользователь должен иметь право доступа <code>Может выступать от имени других</code> для целевого Домена.</p><ul><li><p><code>CreateMeeting(setName,key)</code><br><code>CreateMeeting(setName,key,parameter)</code></p><p>Эта функция создаёт объект Встреча в некотором Наборе Встреч у текущего Пользователя.<br> Параметр <em>setName</em> задаёт имя Набора Встреч. Если значение этого параметра является нулевым значением или пустой строкой, то используется Набор Встреч, применяемый по умолчанию.<br> Параметр <em>key</em> должен быть строкой. В нём задаётся уникальный идентификатор новой Встречи. Например, приложение, реализующее конференцию в реальном времени, может генерировать случайную числовую строку, которая используется как пароль к конференции и, используя эту же строку, приложение может также создавать Встречу. Другие Задачи, связанные с тем же Пользователем, могут найти эту Встречу (и описатель задачи для Задачи, связанной с ней), если они знают значения параметров <em>key</em> и <em>setName</em>, использованные в операции CreateMeeting.<br> Значение параметра <em>parameter</em> сохраняется вместе со Встречей.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Сохраняется текстовое представление значения, так что в качестве <em>parameter</em> или дочерних элементов <em>parameter</em> могут использоваться только стандартные объекты. Например, вы не можете сохранить Папку или описатель Задачи.</p></div><p>Эта функция возвращает нулевое значение, если Встреча была создана. В противном случае эта функция возвращает строку с кодом ошибки.</p></li><li><p><code>ActivateMeeting(setName,key)</code><br><code>ActivateMeeting(setName,key,parameter)</code></p><p>Эта функция добавляет описатель текущей Задачи во Встречу у текущего Пользователя.<br> Значения параметров <em>setName</em> и <em>key</em> указывают на уже созданную Встречу.<br> В этой Встрече не должно хранится других описателей Задачи.<br> Текущая Задача становится <em>Активной Задачей</em> Встречи.<br> Значение параметра <em>parameter</em> сохраняется вместе со Встречей.<br> Эта функция возвращает нулевое значение, если описатель Задачи был добавлен успешно. В противном случае эта функция возвращает строку с кодом ошибки.</p></li><li><p><code>DeactivateMeeting(setName,key)</code><br><code>DeactivateMeeting(setName,key,parameter)</code></p><p>Эта функция удаляет описатель текущей Задачи из Встречи у текущего Пользователя.<br> Значения параметров <em>setName</em> и <em>key</em> указывают на уже созданную Встречу, и эта Встреча должна содержать описатель текущей Задачи.<br> Значение параметра <em>parameter</em> сохраняется вместе со Встречей.<br> Если эта операция завершается успешно, то у Встречи отсутствует <em>Активная Задача</em>.<br> Эта функция возвращает нулевое значение, если описатель Задачи был успешно удалён. В противном случае эта функция возвращает строку с кодом ошибки.</p></li><li><p><code>RemoveMeeting(setName,key)</code></p><p>Эта функция удаляет встречу из Набора Встреч текущего Пользователя.<br> Значения параметров <em>setName</em> и <em>key</em> задают удаляемую Встречу.<br> Эта функция возвращает нулевое значение, если Встреча была успешно удалена или указанная Встреча не найдена. В противном случае эта функция возвращает строку с кодом ошибки.</p></li><li><p><code>FindMeeting(setName,key)</code></p><p>Эта функция запрашивает информацию о Встрече из Набора Встреч текущего Пользователя.<br> Значения параметров <em>setName</em> и <em>key</em> задают искомую Встречу.<br> Если указанная Встреча у Пользователя отсутствует, то функция возвращает нулевое значение.<br> В противном случае функция возвращает словарь с информацией о Встрече, содержащий следующие элементы:</p><ul><li><p><code>parameter</code></p><p>значение параметра <em>parameter</em>, использованного в операции CreateMeeting.</p></li><li><p><code>id</code></p><p>описатель Задачи для <em>Активной Задачи</em> (если есть).<br> В <a href="./../admin/cluster/">Кластерной</a> среде Активная Задача и текущая Задача могут быть запущены на разных членах Кластера.</p></li></ul></li><li><p><code>ClearMeeting(setName,key)</code></p><p>Эта функция удаляет описатель Задачи из Встречи (если существует).<br> Значения параметров <em>setName</em> и <em>key</em> задают Встречу, которую необходимо очистить.<br> Эта функция может использоваться для очистки ссылок, установленных Задачей, прекратившей свою работу.<br> Эта функция возвращает нулевое значение, если Встреча была успешно очищена. В противном случае эта функция возвращает строку с кодом ошибки.</p></li></ul><h3 id="Queues" tabindex="-1">Очереди <a class="header-anchor" href="#Queues" aria-label="Permalink to &quot;Очереди {#Queues}&quot;">​</a></h3><p>Механизм Очереди позволяет Задаче делать себя известной для другой Задачи, связанной с тем же Пользователем. Когда зарегистрированная в Очереди Задача, найдена какой-либо другой Задачей, найденная задача удаляется из Очереди.</p><p>Имя очереди может быть задано строкой вида &quot;~<em>accountName</em>[@<em>domainName</em>]/<em>queueName</em>&quot; для доступа к Очередям других Пользователей.<br> Для доступа к Очередям других Пользователей, текущий Пользователь должен иметь право доступа <code>Может выступать от имени других</code> для целевого Домена.</p><ul><li><p><code>Enqueue(queueName)</code><br><code>Enqueue(queueName,parameter)</code><br><code>Enqueue(queueName,parameter,pty)</code></p><p>Эта функция регистрирует текущую Задачу у связанного с ней Пользователя.<br> Пользователь может иметь несколько Очередей с регистрациями Задач.<br> Параметр <em>queueName</em> задаёт имя Очереди. Если значение этого параметра является нулевым значением или пустой строкой, то используется Очередь Пользователя, применяемая по умолчанию.<br> Значение необязательного параметра <em>parameter</em> сохраняется вместе с регистрацией Задачи.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Сохраняется текстовое представление значения, так что в качестве <em>parameter</em> или дочерних элементов <em>parameter</em> могут использоваться только стандартные объекты. Например, вы не можете сохранить Папку или описатель Задачи.</p></div><p>Значение необязательного параметра <em>pty</em> должно быть строкой, содержащей десятичное число из одной цифры, символ точка (.) и любое число цифр. Задача ставится в Очередь перед всеми другими Задачами, имеющими меньшие значения параметра <em>pty</em>, но после всех других Задач с тем же или большим значением параметра <em>pty</em>. Если значением параметра <em>pty</em> является нулевая строка, то подразумевается значение по умолчанию &quot;1.0&quot;.<br> Задача может регистрировать себя несколько раз в разных Очередях, но в той же Очереди она может быть зарегистрирована только один раз. Если функция Enqueue используется Задачей, которая уже была поставлена в эту Очередь, то функция не создаёт повторную регистрацию. Вместо этого функция обновляет значение <em>parameter</em> уже находящейся в Очереди Задачи и может изменить позицию этой Задачи в Очереди согласно новому значению параметра <em>pty</em>.<br> Функция возвращает нулевое значение, если регистрация закончилась неуспешно. Если регистрация завершилась успешно, то функция возвращает словарь, в котором содержатся следующие элементы:</p><ul><li><p><code>length</code></p><p>число - общее число Задач в Очереди</p></li><li><p><code>position</code></p><p>число - текущая позиция текущей Задачи в Очереди.<br> Первая Задача в Очереди имеет позицию 0</p></li></ul></li><li><p><code>CheckQueue(queueName)</code></p><p>Эта функция проверяет позицию текущей Задачи в Очереди Пользователя.<br> Параметр <em>queueName</em> задаёт имя Очереди.<br> Функция возвращает нулевое значение, если она не смогла получить доступ к указанной Очереди. Иначе она возвращает тот же самый словарь, что и функция Enqueue.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Элемент <code>position</code> существует в возвращаемом словаре, только если текущая Задача находится в указанной Очереди. Если текущая Задача не находится в очереди или если она уже была удалена из очереди какой-либо другой задачей, то этот элемент отсутствует.</p></div></li><li><p><code>Dequeue(queueName)</code></p><p>Эта процедура удаляет текущую Задачу из Очереди Пользователя.<br> Параметр <em>queueName</em> задаёт имя Очереди.</p></li><li><p><code>ReadQueue(queueName)</code></p><p>Эта функция получает из Очереди Пользователя первую Задачу.<br> Параметр <em>queueName</em> задаёт имя Очереди.<br> Эта функция возвращает нулевое значение, если Задача в указанной Очереди не существует.<br> В противном случае функция возвращает словарь, в котором содержатся следующие элементы:</p><ul><li><p><code>id</code></p><p>описатель полученной Задачи. В <a href="./../admin/cluster/">Кластерной</a> среде эта Задача и текущая Задача могут быть запущены на разных членах Кластера</p></li><li><p><code>parameter</code></p><p>значение параметра <em>parameter</em>, использованного при постановке Задачи в Очередь</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>эта функция удаляет из Очереди первую Задачу. Если только полученная Задача не ставит себя заново в ту же Очередь, никакая другая Задача не обнаружит её в этой Очереди.</p></div></li></ul></li></ul><h2 id="Syntax" tabindex="-1">Формальный Синтаксис <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;Формальный Синтаксис {#Syntax}&quot;">​</a></h2><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td><em>string</em></td><td>&quot;string-data&quot;</td></tr><tr><td><em>number</em></td><td>&quot;digits&quot;</td></tr><tr><td><em>name</em></td><td>&quot;alpha-numeric-and-underscore-starting-with-alpha&quot;</td></tr><tr><td><em>variable</em></td><td><em>name</em></td></tr><tr><td><em>codeName</em></td><td><em>name</em> | <em>name</em> :: <em>name</em></td></tr><tr><td><em>varDeclaration</em></td><td><code>var</code> <em>name</em> 0*(<code>,</code> <em>name</em>)</td></tr><tr><td><em>varValueDeclaration</em></td><td><code>var</code> <em>name</em> [<code>=</code> <em>expr</em>] <strong>0*</strong> (<code>,</code> <em>name</em> [<code>=</code> <em>expr</em>] )</td></tr><tr><td><em>dataRef</em></td><td><em>variable</em> | <em>expr</em> <code>[</code> <em>expr</em> <code>]</code> | <em>expr</em> <code>.</code> <em>name</em> | <em>expr</em> <code>.(</code> <em>expr</em> <code>)</code></td></tr><tr><td><em>constDeclaration</em></td><td><code>const</code> <em>name</em> <code>=</code> <em>constExpr</em> <strong>0*</strong> (<code>,</code> <em>name</em> <code>=</code> <em>constExpr</em>)</td></tr><tr><td><em>constExpr</em></td><td><em>string</em> | <em>number</em> | <code>null</code> | <code>false</code> | <code>true</code></td></tr><tr><td><em>spawnExpr</em></td><td><code>spawn</code> <em>name</em> [ <code>(</code> <em>expr</em> <code>)</code> ]</td></tr><tr><td><em>basicExpr</em></td><td><em>constExpr</em> | <em>dataRef</em> | <em>expr</em> <code>.</code> <em>name</em> <code>(</code> [ <em>argList</em> ] <code>)</code> | <em>spawnExpr</em></td></tr><tr><td><em>unaryOp</em></td><td><code>!</code> | <code>not</code> | <code>-</code> | <code>+</code></td></tr><tr><td><em>unary</em></td><td><em>basicExpr</em> | <em>unaryOp</em> <em>unary</em> | <code>(</code> <em>expr</em> <code>)</code></td></tr><tr><td><em>multOp</em></td><td><code>\\</code> | <code>/</code> | <code>%</code></td></tr><tr><td><em>multBinary</em></td><td><em>unary</em> | <em>multBinary</em> <em>multOp</em> <em>unary</em></td></tr><tr><td><em>addOp</em></td><td><code>+</code> | <code>-</code></td></tr><tr><td><em>addBinary</em></td><td><em>multBinary</em> | <em>addBinary</em> <em>addOp</em> <em>multBinary</em></td></tr><tr><td><em>cmpOp</em></td><td><code>&lt;</code> | <code>&lt;=</code> | <code>==</code> | <code>!=</code> | <code>&gt;=</code> | <code>\\&gt;</code></td></tr><tr><td><em>cmpBinary</em></td><td><em>addBinary</em> | <em>cmpBinary</em> <em>cmpOp</em> <em>addBinary</em></td></tr><tr><td><em>logicOp</em></td><td><code>&amp;</code> | <code>and</code> | <code>|</code> | <code>or</code> | <code>&amp;&amp;</code> | <code>and then</code> | <code>||</code> | <code>or else</code></td></tr><tr><td><em>logicBinary</em></td><td><em>cmpBinary</em> | <em>logicBinary</em> <em>logOp</em> <em>cmpBinary</em></td></tr><tr><td><em>ternary</em></td><td><em>logicBinary</em> | <em>logicBinary</em> <code>?</code> <em>logicBinary</em> <code>:</code> <em>ternary</em></td></tr><tr><td><em>expr</em></td><td><em>ternary</em></td></tr><tr><td><em>argList</em></td><td><em>expr</em> <strong>0*</strong> (<code>,</code> <em>expr</em>)</td></tr><tr><td><em>funcCall</em></td><td><em>codeName</em> <code>(</code> [ <em>argList</em> ] <code>)</code></td></tr><tr><td><em>procCall</em></td><td><em>codeName</em> <code>(</code> [ <em>argList</em> ] <code>)</code> | <em>expr</em> <code>.</code> <em>name</em> <code>(</code> [ <em>argList</em> ] <code>)</code></td></tr><tr><td><em>letOp</em></td><td><code>=</code> | <code>+=</code> | <code>-=</code> | <code>*=</code> | <code>/=</code> | <code>%=</code> | <code>|=</code> | <code>&amp;=</code></td></tr><tr><td><em>letOper</em></td><td><em>dataRef</em> <em>letOp</em> <em>expr</em></td></tr><tr><td><em>nullOper</em></td><td>| <code>null</code></td></tr><tr><td><em>stopOper</em></td><td><code>stop</code></td></tr><tr><td><em>returnOper</em></td><td><code>return</code> [ <em>expr</em> ]</td></tr><tr><td><em>ifOper</em></td><td><code>if</code> <em>expr</em> <code>then</code> <em>opSequence</em> <strong>0*</strong> ( <code>elif</code> <em>expr</em> <code>then</code> <em>opSequence</em> ) [ <code>else</code> <em>opSequence</em> ] <code>end</code> [ <code>if</code> ]</td></tr><tr><td><em>altIfOper</em></td><td><code>if</code> <em>expr</em> <code>{</code> <em>opSequence</em> <code>}</code> <strong>0*</strong> ( <code>elif</code> <em>expr</em> <code>{</code> <em>opSequence</em> <code>}</code> ) [ <code>else</code> <code>{</code> <em>opSequence</em> <code>}</code> ]</td></tr><tr><td><em>loopInitOp</em></td><td><em>letOp</em> | <em>varValueDeclaration</em></td></tr><tr><td><em>loopPreamble</em></td><td><code>while</code> <em>expr</em> | <em>for</em> [ <em>loopInitOp</em> ] [<code>while</code> <em>expr</em> ] [ <code>by</code> <em>letOp</em> ]</td></tr><tr><td><em>altLoopPreamble</em></td><td><code>while</code> <em>expr</em> | <code>for</code> <code>(</code> [ <em>loopInitOp</em> ] <code>;</code> [ <em>expr</em> ] <code>;</code> [ <em>letOp</em> ] <code>)</code></td></tr><tr><td><em>loopOper</em></td><td>[ <em>loopPreamble</em> ] <code>loop</code> <em>opSequence</em> <strong>0*</strong> ( <code>exitif</code> <em>expr</em> <code>;</code> <em>opSequence</em>) <code>end</code> [ <code>loop</code> ]</td></tr><tr><td><em>altLoopOper</em></td><td><em>altLoopPreamble</em> <code>{</code> <em>opSequence</em> <strong>0*</strong> ( <code>exitif</code> <em>expr</em> <code>;</code> <em>opSequence</em>) <code>}</code></td></tr><tr><td><em>oper</em></td><td><em>nullOper</em> | <em>procCall</em> | <em>letOper</em> | <em>returnOper</em> | <em>stopOper</em> | <em>ifOper</em> | <em>loopOper</em> | <em>varValueDeclaration</em></td></tr><tr><td><em>altOper</em></td><td><em>altIfOper</em> | <em>altLoopOper</em></td></tr><tr><td><em>seqOper</em></td><td><em>oper</em> <code>;</code> | <em>altOper</em></td></tr><tr><td><em>opSequence</em></td><td><strong>0*</strong> ( <em>seqOper</em> )</td></tr><tr><td><em>entryBody</em></td><td><code>forward</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>entry</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>procBody</em></td><td><code>forward</code> <code>;</code> | <code>external</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>procedure</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>funcBody</em></td><td><code>forward</code> <code>;</code> | <code>external</code> <code>;</code> | <code>is</code> <em>opSequence</em> <code>end</code> [ <code>function</code> ] <code>;</code> | <code>{</code> <em>opSequence</em> <code>}</code></td></tr><tr><td><em>parmList</em></td><td><em>name</em> 0 <strong>*</strong> (<code>,</code> <em>name</em>)</td></tr><tr><td><em>entry</em></td><td><code>entry</code> <em>name</em> <em>entryBody</em></td></tr><tr><td><em>procedure</em></td><td><code>procedure</code> <em>codeName</em> <code>(</code> [ <em>parmList</em> ] <code>)</code> <em>procBody</em></td></tr><tr><td><em>function</em></td><td><code>function</code> <em>codeName</em> <code>(</code> [ <em>parmList</em> ] <code>)</code> <em>funcBody</em></td></tr><tr><td><em>program</em></td><td><strong>1*</strong> (<em>entry</em> | <em>procedure</em> | <em>function</em> | <em>varDeclaration</em> | <em>constDeclaration</em>)</td></tr></tbody></table>`,276)]))}const h=a(d,[["render",c]]);export{u as __pageData,h as default};
