import{_ as a,c as E,o,ag as T}from"./chunks/framework.jCcxW76o.js";const A=JSON.parse('{"title":"Интерфейс Командной Строки / API","description":"","frontmatter":{"legacyLink":"russian/CLI.html"},"headers":[],"relativePath":"russian/development/CLI.md","filePath":"russian/development/CLI.md"}'),d={name:"russian/development/CLI.md"};function c(S,e,i,l,t,r){return o(),E("div",null,e[0]||(e[0]=[T('<h1 id="интерфеис-команднои-строки-api" tabindex="-1">Интерфейс Командной Строки / API <a class="header-anchor" href="#интерфеис-команднои-строки-api" aria-label="Permalink to &quot;Интерфейс Командной Строки / API&quot;">​</a></h1><p>В Сервере CommuniGate Pro для целей администрирования предусмотрен Интерфейс Командной Строки (CLI). Этот интерфейс может использоваться как альтернатива Веб Интерфейсу Администратора.</p><p>CLI может также использоваться в качестве Интерфейса Прикладных Программ (API) и, таким образом, сервером можно управлять при помощи различных сценариев, скриптов, а также других программ, отправляющих команды CLI на сервер.</p><h2 id="Access" tabindex="-1">Доступ к CLI <a class="header-anchor" href="#Access" aria-label="Permalink to &quot;Доступ к CLI {#Access}&quot;">​</a></h2><p>Сервер CommuniGate Pro поддерживает несколько способов обращения к CLI:</p><ul><li>через TCP соединения к модулю <a href="./../admin/services/PWD.html">PWD</a> (расширение PWD/poppwd протокола)</li><li>через команду <a href="./CGPL.html#CLI">CG/PL <code>ExecuteCLI</code></a>.</li><li>через раздел <a href="./../admin/services/HTTP.html#CLI">HTTP</a> CLI.</li><li>используя операцию <a href="./XMLAPI.html#cliExecute"><code>cliExecute</code> протокола XIMSS</a>.</li></ul><p>Когда CLI используется через соединение PWD, то команды CLI принимаются после аутентификации пользователя. Для каждой команды CLI Сервер проверяет права доступа аутентифицированного пользователя.</p><p>Если команда возвращает какие-либо данные, то данные отправляются сразу после строки положительного ответа протокола. Комбинация CR-LF отправляется после данных.</p><p>Ниже приводится пример PWD сессии, содержащей команды CLI:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>C: telnet servername.com 106</span></span>\n<span class="line"><span>S: 200 CommuniGate Pro at mail.servername.com PWD Server 5.3 ready</span></span>\n<span class="line"><span>C: USER postmaster</span></span>\n<span class="line"><span>S: 300 please send the PASS</span></span>\n<span class="line"><span>C: PASS postmasterpassword</span></span>\n<span class="line"><span>S: 200 login OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1&quot;</span></span>\n<span class="line"><span>S: 501 Account with this name already exists</span></span>\n<span class="line"><span>C: RenameAccount &quot;user1&quot; into &quot;user2&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateDomain &quot;client1.com&quot;</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: CreateAccount &quot;user1@client1.com&quot; TextMailbox</span></span>\n<span class="line"><span>S: 200 OK</span></span>\n<span class="line"><span>C: ListDomains</span></span>\n<span class="line"><span>S: 200 data follow</span></span>\n<span class="line"><span>S: (mail.servername.com, client1.com, client2.com)</span></span>\n<span class="line"><span>C: QUIT</span></span>\n<span class="line"><span>S: 200 CommuniGate Pro PWD connection closed</span></span></code></pre></div><p>В документе <a href="http://www.communigatepro.ru/CGPerl/" target="_blank" rel="noreferrer">Perl Интерфейс CommuniGate Pro</a> (на английском языке) содержится описание и набор утилит на <a href="http://www.perl.org" target="_blank" rel="noreferrer">языке Perl</a>, позволяющий сценариям Perl получать доступ к CLI API CommuniGate Pro через протокол PWD. В документе также содержатся ссылки на несколько полезных примеров сценариев Perl (автоматизирующих создание и удаление Пользователей и т.п.)</p><p>В документе <a href="http://www.communigatepro.ru/CGJava/" target="_blank" rel="noreferrer">Java Интерфейс CommuniGate Pro</a> (на английском языке) содержится описание и набор классов на <a href="http://java.com" target="_blank" rel="noreferrer">языке Java</a>, позволяющий программам Java получать доступ к CLI API CommuniGate Pro через протокол PWD. В документе также содержатся ссылки на несколько полезных примеров программ Java.</p><h2 id="Syntax" tabindex="-1">Синтаксис CLI <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;Синтаксис CLI {#Syntax}&quot;">​</a></h2><p>Интерфейс CLI CommuniGate Pro использует стандартные <a href="./Data.html">Форматы Данных</a> для разбора команд и вывода результатов.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Правила Синтаксиса формата Словарь позволяют вам задавать строку без знаков кавычки, если в строке содержатся только алфавитно-цифровые символы. Вы должны использовать знак кавычки, если в строке содержится точка (.), запятая (,) или другие не алфавитно-цифровые символы.</p></div><p>Несмотря на то, что в стандартных форматах Данных могут использовать несколько текстовых строк, все задаваемые вами в качестве параметров CLI данные (включая массивы и словари) должны находиться в одной командной строке.</p><p>Если команда CLI возвращает какие-либо данные в формате массива или словаря, то эти выходные данные могут располагаться на нескольких строках.</p><h2 id="DomainSet" tabindex="-1">Управление Наборами Доменов <a class="header-anchor" href="#DomainSet" aria-label="Permalink to &quot;Управление Наборами Доменов {#DomainSet}&quot;">​</a></h2><p>Пользователь должен иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> для использования команд CLI по Администрированию Наборов Доменов.</p><p>Следующие команды доступны только для Администраторов Системы:</p><h3 id="LISTDOMAINS" tabindex="-1"><code>LISTDOMAINS</code> <a class="header-anchor" href="#LISTDOMAINS" aria-label="Permalink to &quot;`LISTDOMAINS` {#LISTDOMAINS}&quot;">​</a></h3><p>Используйте эту команду для получения списка доменов. Эта команда возвращает <em>массив</em> с именами всех доменов сервера.</p><h3 id="MAINDOMAINNAME" tabindex="-1"><code>MAINDOMAINNAME</code> <a class="header-anchor" href="#MAINDOMAINNAME" aria-label="Permalink to &quot;`MAINDOMAINNAME` {#MAINDOMAINNAME}&quot;">​</a></h3><p>Используйте эту команду для получения имени Главного Домена. Эта команда возвращает данные - <em>строку</em> с именем Главного Домена.</p><h3 id="GETDOMAINDEFAULTS" tabindex="-1"><code>GETDOMAINDEFAULTS</code> <a class="header-anchor" href="#GETDOMAINDEFAULTS" aria-label="Permalink to &quot;`GETDOMAINDEFAULTS` {#GETDOMAINDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для получения общесерверных Установок по Умолчанию для Домена. Эта команда возвращает <em>словарь</em> с Установками по Умолчанию для Домена.</p><h3 id="UPDATEDOMAINDEFAULTS" tabindex="-1"><code>UPDATEDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATEDOMAINDEFAULTS" aria-label="Permalink to &quot;`UPDATEDOMAINDEFAULTS newSettings` {#UPDATEDOMAINDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Установок по Умолчанию для Домена.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря с общесерверными Установками по Умолчанию для Домена. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены.</p></li></ul><h3 id="SETDOMAINDEFAULTS" tabindex="-1"><code>SETDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#SETDOMAINDEFAULTS" aria-label="Permalink to &quot;`SETDOMAINDEFAULTS newSettings` {#SETDOMAINDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Установок по Умолчанию для Домена.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря общесерверных Установками по Умолчанию для Домена.</p></li></ul><h3 id="GETCLUSTERDOMAINDEFAULTS" tabindex="-1"><code>GETCLUSTERDOMAINDEFAULTS</code> <a class="header-anchor" href="#GETCLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`GETCLUSTERDOMAINDEFAULTS` {#GETCLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><h3 id="UPDATECLUSTERDOMAINDEFAULTS" tabindex="-1"><code>UPDATECLUSTERDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`UPDATECLUSTERDOMAINDEFAULTS newSettings` {#UPDATECLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><h3 id="SETCLUSTERDOMAINDEFAULTS" tabindex="-1"><code>SETCLUSTERDOMAINDEFAULTS newSettings</code> <a class="header-anchor" href="#SETCLUSTERDOMAINDEFAULTS" aria-label="Permalink to &quot;`SETCLUSTERDOMAINDEFAULTS newSettings` {#SETCLUSTERDOMAINDEFAULTS}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>UPDATE</code>|<code>SET</code>]<code>DOMAINDEFAULTS</code> для работы с общекластерными Установками по Умолчанию для Домена.</p><h3 id="GETSERVERACCOUNTDEFAULTS" tabindex="-1"><code>GETSERVERACCOUNTDEFAULTS</code> <a class="header-anchor" href="#GETSERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETSERVERACCOUNTDEFAULTS` {#GETSERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для получения общесерверных Установок по Умолчанию для Пользователя. Эта команда возвращает <em>словарь</em> с глобальными Установками по Умолчанию для Пользователя.</p><h3 id="UPDATESERVERACCOUNTDEFAULTS" tabindex="-1"><code>UPDATESERVERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATESERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATESERVERACCOUNTDEFAULTS newSettings` {#UPDATESERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Установок по Умолчанию для Пользователя.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря с Установками по Умолчанию для Пользователя. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены.</p></li></ul><h3 id="SETSERVERACCOUNTDEFAULTS" tabindex="-1"><code>SETSERVERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#SETSERVERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETSERVERACCOUNTDEFAULTS newSettings` {#SETSERVERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Установок по Умолчанию для Пользователя.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря общесерверных Установок по Умолчанию для Пользователя.</p></li></ul><h3 id="GETCLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>GETCLUSTERACCOUNTDEFAULTS</code> <a class="header-anchor" href="#GETCLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETCLUSTERACCOUNTDEFAULTS` {#GETCLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><h3 id="UPDATECLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>UPDATECLUSTERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATECLUSTERACCOUNTDEFAULTS newSettings` {#UPDATECLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><h3 id="SETCLUSTERACCOUNTDEFAULTS" tabindex="-1"><code>SETCLUSTERACCOUNTDEFAULTS newSettings</code> <a class="header-anchor" href="#SETCLUSTERACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETCLUSTERACCOUNTDEFAULTS newSettings` {#SETCLUSTERACCOUNTDEFAULTS}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>UPDATE</code>|<code>SET</code>]<code>SERVERACCOUNTDEFAULTS</code> для работы с общекластерными Установками по Умолчанию для Пользователя.</p><h3 id="GETSERVERACCOUNTPREFS" tabindex="-1"><code>GETSERVERACCOUNTPREFS</code> <a class="header-anchor" href="#GETSERVERACCOUNTPREFS" aria-label="Permalink to &quot;`GETSERVERACCOUNTPREFS` {#GETSERVERACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для получения общесерверных Настроек Пользователя по умолчанию. Эта команда возвращает <em>словарь</em>, в котором содержатся Настройки по умолчанию.</p><h3 id="SETSERVERACCOUNTPREFS" tabindex="-1"><code>SETSERVERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#SETSERVERACCOUNTPREFS" aria-label="Permalink to &quot;`SETSERVERACCOUNTPREFS newSettings` {#SETSERVERACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Настроек Пользователя по умолчанию.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря общесерверных Настроек Пользователя по умолчанию. Все старые общесерверные Настройки Пользователя, применяемые по умолчанию, удаляются.</p></li></ul><h3 id="UPDATESERVERACCOUNTPREFS" tabindex="-1"><code>UPDATESERVERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#UPDATESERVERACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATESERVERACCOUNTPREFS newSettings` {#UPDATESERVERACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Настроек Пользователя по умолчанию.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения Настроек Пользователя по умолчанию. Он не обязан содержать в себе все настройки; отсутствующие в словаре Настройки просто не будут изменены.</p></li></ul><h3 id="GETCLUSTERACCOUNTPREFS" tabindex="-1"><code>GETCLUSTERACCOUNTPREFS</code> <a class="header-anchor" href="#GETCLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`GETCLUSTERACCOUNTPREFS` {#GETCLUSTERACCOUNTPREFS}&quot;">​</a></h3><h3 id="SETCLUSTERACCOUNTPREFS" tabindex="-1"><code>SETCLUSTERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#SETCLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`SETCLUSTERACCOUNTPREFS newSettings` {#SETCLUSTERACCOUNTPREFS}&quot;">​</a></h3><h3 id="UPDATECLUSTERACCOUNTPREFS" tabindex="-1"><code>UPDATECLUSTERACCOUNTPREFS newSettings</code> <a class="header-anchor" href="#UPDATECLUSTERACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATECLUSTERACCOUNTPREFS newSettings` {#UPDATECLUSTERACCOUNTPREFS}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>SET</code>|<code>UPDATE</code>]<code>SERVERACCOUNTPREFS</code> для работы с общекластерными Настройками Пользователя по Умолчанию.</p><h3 id="CREATEDOMAIN" tabindex="-1"><code>CREATEDOMAIN domainName [ SHARED ] [ PATH storage ] [ settings ]</code> <a class="header-anchor" href="#CREATEDOMAIN" aria-label="Permalink to &quot;`CREATEDOMAIN domainName [ SHARED ] [ PATH storage ] [ settings ]` {#CREATEDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для создания нового Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя создаваемого Домена.</p></li><li><p><code>storage : строка</code></p><p>Необязательный параметр; задаёт директорию &quot;Точки монтирования хранилища&quot; для данных Домена (имя должно быть указано без суффикса .mnt).</p></li><li><p><code>settings : словарь</code></p><p>Необязательный словарь с установками Домена. Ключевое слово SHARED используется при создании общекластерного Домена в Динамическом Кластере.</p></li></ul><h3 id="RENAMEDOMAIN" tabindex="-1"><code>RENAMEDOMAIN oldDomainName INTO newDomainName [ PATH storage ]</code> <a class="header-anchor" href="#RENAMEDOMAIN" aria-label="Permalink to &quot;`RENAMEDOMAIN oldDomainName INTO newDomainName [ PATH storage ]` {#RENAMEDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для переименования Домена.</p><ul><li><p><code>oldDomainName : строка</code></p><p>Этот параметр указывает имя существующего Домена.</p></li><li><p><code>newDomainName : строка</code></p><p>Этот параметр указывает новое имя Домена.</p></li><li><p><code>storage : строка</code></p><p>Необязательный параметр; задаёт новую директорию &quot;Точки монтирования хранилища&quot; для данных Домена (имя должно быть указано без суффикса .mnt).</p></li></ul><h3 id="DELETEDOMAIN" tabindex="-1"><code>DELETEDOMAIN domainName [ FORCE ]</code> <a class="header-anchor" href="#DELETEDOMAIN" aria-label="Permalink to &quot;`DELETEDOMAIN domainName [ FORCE ]` {#DELETEDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для удаления Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя удаляемого Домена.</p></li><li><p><code>FORCE</code></p><p>Этот необязательный параметр указывает, что Домен должен быть удалён, даже если он не пустой. Все объекты Домена (Пользователи, Группы и т.д.) будут удалены.</p></li></ul><h3 id="CREATEDIRECTORYDOMAIN" tabindex="-1"><code>CREATEDIRECTORYDOMAIN domainName [ settings ]</code> <a class="header-anchor" href="#CREATEDIRECTORYDOMAIN" aria-label="Permalink to &quot;`CREATEDIRECTORYDOMAIN domainName [ settings ]` {#CREATEDIRECTORYDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для создания нового Домена в Справочнике (Directory-Based).</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя создаваемого Домена.</p></li><li><p><code>settings : словарь</code></p><p>Необязательный словарь с установками Домена. Эта операция может быть выполнена, только если разрешено использование Доменов в Справочнике.</p></li></ul><h3 id="RELOADDIRECTORYDOMAINS" tabindex="-1"><code>RELOADDIRECTORYDOMAINS</code> <a class="header-anchor" href="#RELOADDIRECTORYDOMAINS" aria-label="Permalink to &quot;`RELOADDIRECTORYDOMAINS` {#RELOADDIRECTORYDOMAINS}&quot;">​</a></h3><p>Используйте эту команду, чтобы Сервер зачитал заново деревья Доменов в Справочнике и нашёл все новые Домены, созданные непосредственно в Справочнике, минуя административные интерфейсы CommuniGate Pro. Эта операция может быть выполнена, только если разрешено использование Доменов в Справочнике.</p><h3 id="LISTSERVERTELNUMS" tabindex="-1"><code>LISTSERVERTELNUMS [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTSERVERTELNUMS" aria-label="Permalink to &quot;`LISTSERVERTELNUMS [ FILTER filter ] limit` {#LISTSERVERTELNUMS}&quot;">​</a></h3><p>Используйте эту команду для чтения номеров Telnum, созданных во всех Доменах (не кластерных). Эта команда возвращает <em>словарь</em>, в котором каждый элемент является номером Telnum, а значение элемента - это имя Пользователя, которому этот номер назначен. Для пустого ключа <code>&quot;&quot;</code> добавляется числовой элемент, содержащий общее число созданных номеров Telnum.</p><ul><li><p><code>filter : строка</code></p><p>Если этот необязательный параметр указан, то возвращаются только те номера Telnum, в которых содержится указанная строка.</p></li><li><p><code>limit : число</code></p><p>Максимальное количество возвращаемых номеров Telnum.</p></li></ul><h3 id="LISTCLUSTERTELNUMS" tabindex="-1"><code>LISTCLUSTERTELNUMS [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTCLUSTERTELNUMS" aria-label="Permalink to &quot;`LISTCLUSTERTELNUMS [ FILTER filter ] limit` {#LISTCLUSTERTELNUMS}&quot;">​</a></h3><p>Аналогично команде LISTSERVERTELNUMS, но для общих кластерных Доменов.</p><h3 id="GETSERVERTRUSTEDCERTS" tabindex="-1"><code>GETSERVERTRUSTEDCERTS</code> <a class="header-anchor" href="#GETSERVERTRUSTEDCERTS" aria-label="Permalink to &quot;`GETSERVERTRUSTEDCERTS` {#GETSERVERTRUSTEDCERTS}&quot;">​</a></h3><p>Используйте эту команду для получения общесерверного набора Доверенных Сертификатов. Эта команда возвращает <em>массив</em> из <em>блоков данных.</em> В каждом <em>блоке данных</em> содержатся данные одного Сертификата X.509.</p><h3 id="SETSERVERTRUSTEDCERTS" tabindex="-1"><code>SETSERVERTRUSTEDCERTS newCertificates</code> <a class="header-anchor" href="#SETSERVERTRUSTEDCERTS" aria-label="Permalink to &quot;`SETSERVERTRUSTEDCERTS newCertificates` {#SETSERVERTRUSTEDCERTS}&quot;">​</a></h3><p>Используйте эту команду для установки общесерверного набора Доверенных Сертификатов.</p><ul><li><p><code>newCertificates : массив</code></p><p>Этот массив должен содержать <em>блоки данных</em> с данными сертификатов в соответствии с X.509. Этот массив используется для замещения общесерверного списка Доверенных Сертификатов.</p></li></ul><h3 id="GETCLUSTERTRUSTEDCERTS" tabindex="-1"><code>GETCLUSTERTRUSTEDCERTS</code> <a class="header-anchor" href="#GETCLUSTERTRUSTEDCERTS" aria-label="Permalink to &quot;`GETCLUSTERTRUSTEDCERTS` {#GETCLUSTERTRUSTEDCERTS}&quot;">​</a></h3><h3 id="SETCLUSTERTRUSTEDCERTS" tabindex="-1"><code>SETCLUSTERTRUSTEDCERTS newCertificates</code> <a class="header-anchor" href="#SETCLUSTERTRUSTEDCERTS" aria-label="Permalink to &quot;`SETCLUSTERTRUSTEDCERTS newCertificates` {#SETCLUSTERTRUSTEDCERTS}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>SET</code>]<code>SERVERTRUSTEDCERTS</code> для работы с общекластерным набором Доверенных Сертификатов.</p><h3 id="GETDIRECTORYINTEGRATION" tabindex="-1"><code>GETDIRECTORYINTEGRATION</code> <a class="header-anchor" href="#GETDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`GETDIRECTORYINTEGRATION` {#GETDIRECTORYINTEGRATION}&quot;">​</a></h3><p>Используйте эту команду для получения общесерверных установок Интеграции с Центральным Справочником. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Интеграции с Центральным Справочником.</p><h3 id="SETDIRECTORYINTEGRATION" tabindex="-1"><code>SETDIRECTORYINTEGRATION newSettings</code> <a class="header-anchor" href="#SETDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`SETDIRECTORYINTEGRATION newSettings` {#SETDIRECTORYINTEGRATION}&quot;">​</a></h3><p>Используйте эту команду для задания общесерверных установок Интеграции с Центральным Справочником.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря общесерверных установок Интеграции с Центральным Справочником.</p></li></ul><h3 id="GETCLUSTERDIRECTORYINTEGRATION" tabindex="-1"><code>GETCLUSTERDIRECTORYINTEGRATION</code> <a class="header-anchor" href="#GETCLUSTERDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`GETCLUSTERDIRECTORYINTEGRATION` {#GETCLUSTERDIRECTORYINTEGRATION}&quot;">​</a></h3><h3 id="SETCLUSTERDIRECTORYINTEGRATION" tabindex="-1"><code>SETCLUSTERDIRECTORYINTEGRATION newSettings</code> <a class="header-anchor" href="#SETCLUSTERDIRECTORYINTEGRATION" aria-label="Permalink to &quot;`SETCLUSTERDIRECTORYINTEGRATION newSettings` {#SETCLUSTERDIRECTORYINTEGRATION}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>SET</code>]<code>DIRECTORYINTEGRATION</code> для работы с общекластерными установками Интеграции с Центральным Справочником.</p><h3 id="CREATEDOMAINSTORAGE" tabindex="-1"><code>CREATEDOMAINSTORAGE [ SHARED ] PATH storage</code> <a class="header-anchor" href="#CREATEDOMAINSTORAGE" aria-label="Permalink to &quot;`CREATEDOMAINSTORAGE [ SHARED ] PATH storage` {#CREATEDOMAINSTORAGE}&quot;">​</a></h3><p>Используйте эту команду для создания &quot;Точки монтирования хранилища&quot; для новых Доменов.</p><ul><li><p><code>storage : строка</code></p><p>Этот параметр указывает имя &quot;Точки монтирования хранилища&quot;. Ключевое слово SHARED используется при создании &quot;Точки монтирования хранилища&quot; для кластерных Доменов в Динамическом Кластере.</p></li></ul><h3 id="LISTDOMAINSTORAGE" tabindex="-1"><code>LISTDOMAINSTORAGE [ SHARED ]</code> <a class="header-anchor" href="#LISTDOMAINSTORAGE" aria-label="Permalink to &quot;`LISTDOMAINSTORAGE [ SHARED ]` {#LISTDOMAINSTORAGE}&quot;">​</a></h3><p>Используйте эту команду для получения списка &quot;Точек монтирования хранилищ&quot; Доменов. Эта команда возвращает <em>массив</em> с именами &quot;Точек монтирования хранилищ&quot;. Ключевое слово SHARED используется при получении списка &quot;Точек монтирования хранилищ&quot; для кластерных Доменов в Динамическом Кластере.</p><h2 id="Domain" tabindex="-1">Управление Доменом <a class="header-anchor" href="#Domain" aria-label="Permalink to &quot;Управление Доменом {#Domain}&quot;">​</a></h2><p>Для использования команд CLI Управления Доменом необходимо иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правами на <a href="./../admin/sysadmin/#Domain">Управление Доменом</a>.</p><h3 id="GETDOMAINSETTINGS" tabindex="-1"><code>GETDOMAINSETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINSETTINGS" aria-label="Permalink to &quot;`GETDOMAINSETTINGS [ domainName ]` {#GETDOMAINSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Домена. Эта команда возвращает <em>словарь</em> с установками Домена. В словарь включаются только те установки, которые заданы явно (не являются установками по умолчанию).</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя существующего Домена.</p></li></ul><h3 id="GETDOMAINEFFECTIVESETTINGS" tabindex="-1"><code>GETDOMAINEFFECTIVESETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINEFFECTIVESETTINGS" aria-label="Permalink to &quot;`GETDOMAINEFFECTIVESETTINGS [ domainName ]` {#GETDOMAINEFFECTIVESETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения фактических установок Домена. Эта команда возвращает <em>словарь</em> с установками Домена domainName. В этот словарь включаются и явно заданные установки, и применяемые по умолчанию настройки.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя существующего Домена.</p></li></ul><h3 id="UPDATEDOMAINSETTINGS" tabindex="-1"><code>UPDATEDOMAINSETTINGS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEDOMAINSETTINGS" aria-label="Permalink to &quot;`UPDATEDOMAINSETTINGS [ domainName ] newSettings` {#UPDATEDOMAINSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя существующего Домена.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря с установками Домена. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены. Если новое значение установки указано как строка <code>default</code>, то значения установок Домена удаляются и вместо них используются применяемые по умолчанию установки Домена. Если эта команда используется Администратором Домена, то она будет изменять только те установки Домена, которые этому Администратору разрешается изменять.</p></li></ul><h3 id="GETACCOUNTDEFAULTS" tabindex="-1"><code>GETACCOUNTDEFAULTS [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTDEFAULTS" aria-label="Permalink to &quot;`GETACCOUNTDEFAULTS [ domainName ]` {#GETACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для получения Установок по Умолчанию для Пользователя в указанном Домене. Эта команда возвращает <em>словарь</em>, в котором содержатся установки по умолчанию.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену Администратора.</p></li></ul><h3 id="UPDATEACCOUNTDEFAULTS" tabindex="-1"><code>UPDATEACCOUNTDEFAULTS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTDEFAULTS" aria-label="Permalink to &quot;`UPDATEACCOUNTDEFAULTS [ domainName ] newSettings` {#UPDATEACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения Установок по Умолчанию для Пользователя в указанном Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения Установок по Умолчанию для Пользователя в указанном Домене. Словарь не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены. Если новое значение установки указано как строка <code>default</code>, то значения установок удаляются и вместо них используются глобальные общесерверные Настройки по Умолчанию для Пользователя. Если эта команда используется Администратором Домена, то она будет изменять только те Установки по Умолчанию для Пользователя, которые этому Администратору разрешается изменять.</p></li></ul><h3 id="GETACCOUNTDEFAULTPREFS" tabindex="-1"><code>GETACCOUNTDEFAULTPREFS [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`GETACCOUNTDEFAULTPREFS [ domainName ]` {#GETACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Используйте эту команду для получения Настроек Пользователя по умолчанию, действующих в указанном Домене. Эта команда возвращает <em>словарь</em>, в котором содержатся Настройки по умолчанию.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="SETACCOUNTDEFAULTPREFS" tabindex="-1"><code>SETACCOUNTDEFAULTPREFS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`SETACCOUNTDEFAULTPREFS [ domainName ] newSettings` {#SETACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Используйте эту команду для изменения Настроек Пользователя, применяемых в указанном Домене по умолчанию.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену аутентифицированного пользователя.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения Настроек Пользователя, применяемых в указанном Домене по умолчанию. Все старые Настройки Пользователя по умолчанию при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Настройки(WebUserSettings)</code>.</p></li></ul><h3 id="UPDATEACCOUNTDEFAULTPREFS" tabindex="-1"><code>UPDATEACCOUNTDEFAULTPREFS [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTDEFAULTPREFS" aria-label="Permalink to &quot;`UPDATEACCOUNTDEFAULTPREFS [ domainName ] newSettings` {#UPDATEACCOUNTDEFAULTPREFS}&quot;">​</a></h3><p>Используйте эту команду для изменения Настроек Пользователя, применяемых в указанном Домене по умолчанию.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену аутентифицированного пользователя.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения Настроек Пользователя, применяемых в указанном Домене по умолчанию. Он не обязан содержать в себе все Настройки; отсутствующие в словаре настройки просто не будут изменены. Если новое значение элемента указано как строка <code>default</code>, то значение Настройки по умолчанию удаляется и вместо неё используется значение из общесерверных (или общекластерных) Настроек Пользователя, применяемых по умолчанию. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Настройки(WebUserSettings)</code>.</p></li></ul><h3 id="GETACCOUNTTEMPLATE" tabindex="-1"><code>GETACCOUNTTEMPLATE [ domainName ]</code> <a class="header-anchor" href="#GETACCOUNTTEMPLATE" aria-label="Permalink to &quot;`GETACCOUNTTEMPLATE [ domainName ]` {#GETACCOUNTTEMPLATE}&quot;">​</a></h3><p>Используйте эту команду для получения установок Шаблона Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Шаблона.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="UPDATEACCOUNTTEMPLATE" tabindex="-1"><code>UPDATEACCOUNTTEMPLATE [ domainName ] newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTTEMPLATE" aria-label="Permalink to &quot;`UPDATEACCOUNTTEMPLATE [ domainName ] newSettings` {#UPDATEACCOUNTTEMPLATE}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Шаблона Пользователя.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения Шаблона Пользователя Домена. Все новые Пользователи в указанном Домене будут создаваться с установками из Шаблона. Словарь не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены. Если новое значение установки указано как строка <code>default</code>, то значение установки Шаблона удаляется. Если эта команда используется Администратором Домена, то она будет изменять только те установки Шаблона, которые этому Администратору разрешается изменять.</p></li></ul><h3 id="GETDOMAINALIASES" tabindex="-1"><code>GETDOMAINALIASES domainName</code> <a class="header-anchor" href="#GETDOMAINALIASES" aria-label="Permalink to &quot;`GETDOMAINALIASES domainName` {#GETDOMAINALIASES}&quot;">​</a></h3><p>Используйте эту команду для получения списка Псевдонимов Домена. Эта команда возвращает <em>массив</em> с именами псевдонимов Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li></ul><h3 id="GETDOMAINMAILRULES" tabindex="-1"><code>GETDOMAINMAILRULES domainName</code> <a class="header-anchor" href="#GETDOMAINMAILRULES" aria-label="Permalink to &quot;`GETDOMAINMAILRULES domainName` {#GETDOMAINMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для получения списка Почтовых Правил Домена. Эта команда возвращает <em>массив</em> Почтовых Правил Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li></ul><h3 id="SETDOMAINMAILRULES" tabindex="-1"><code>SETDOMAINMAILRULES domainName newRules</code> <a class="header-anchor" href="#SETDOMAINMAILRULES" aria-label="Permalink to &quot;`SETDOMAINMAILRULES domainName newRules` {#SETDOMAINMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Почтовых Правил Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>newRules : массив</code></p><p>Этот массив должен содержать Почтовые Правила Домена. Все старые Почтовые Правила Домена при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Почтовые Правила(RulesAllowed)</code>.</p></li></ul><h3 id="GETDOMAINSIGNALRULES" tabindex="-1"><code>GETDOMAINSIGNALRULES domainName</code> <a class="header-anchor" href="#GETDOMAINSIGNALRULES" aria-label="Permalink to &quot;`GETDOMAINSIGNALRULES domainName` {#GETDOMAINSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для получения списка Сигнальных Правил Домена. Эта команда возвращает <em>массив</em> Сигнальных Правил Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li></ul><h3 id="SETDOMAINSIGNALRULES" tabindex="-1"><code>SETDOMAINSIGNALRULES domainName newRules</code> <a class="header-anchor" href="#SETDOMAINSIGNALRULES" aria-label="Permalink to &quot;`SETDOMAINSIGNALRULES domainName newRules` {#SETDOMAINSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Сигнальных Правил Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>newRules : массив</code></p><p>Этот массив должен содержать Сигнальные Правила Домена. Все старые Сигнальные Правила Домена при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Сигнальные Правила(SignalRulesAllowed)</code>.</p></li></ul><h3 id="LISTADMINDOMAINS" tabindex="-1"><code>LISTADMINDOMAINS [ domainName ]</code> <a class="header-anchor" href="#LISTADMINDOMAINS" aria-label="Permalink to &quot;`LISTADMINDOMAINS [ domainName ]` {#LISTADMINDOMAINS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Доменов, которые могут управляться Пользователями Администраторами Домена из Домена domainName. Эта команда возвращает <em>массив</em> имён Доменов.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену аутентифицированного пользователя.</p></li></ul><h3 id="LISTDOMAINOBJECTS" tabindex="-1"><code>LISTDOMAINOBJECTS domainName [ FILTER filter ] limit [ ACCOUNTS ] [ ALIASES ] [ FORWARDERS ] [ COOKIE cookie ]</code> <a class="header-anchor" href="#LISTDOMAINOBJECTS" aria-label="Permalink to &quot;`LISTDOMAINOBJECTS domainName [ FILTER filter ] limit [ ACCOUNTS ] [ ALIASES ] [ FORWARDERS ] [ COOKIE cookie ]` {#LISTDOMAINOBJECTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка объектов Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>filter : строка</code></p><p>Этот необязательный параметр задаёт строку-фильтр: возвращаются только те объекты, имена которых включают в себя строку-фильтр как подстроку.</p></li><li><p><code>limit : числовая строка</code></p><p>В этом параметре задаётся максимальное число объектов в списке.</p></li><li><p><code>ACCOUNTS, ALIASES, FORWARDERS</code></p><p>Эти ключевые слова указывают типы объектов Домена, которые должны быть в списке.</p></li><li><p><code>cookie : строка</code></p><p>Этот необязательный параметр указывает строку с &quot;закладкой&quot;.</p></li></ul><p>Эта команда возвращает массив со следующими элементами:</p><ul><li><p>числовая <em>строка</em> с общим числом Пользователей в Домене</p></li><li><p><em>словарь</em> с Объектами Домена. Каждый ключ словаря является именем Объекта Домена. Значения словаря зависят от типа Объекта Домена:</p><ul><li><p>Пользователь</p><p>объектами словаря являются строки (тип Пользователя)</p></li><li><p>Псевдоним Пользователя</p><p>объект словаря является <em>массивом</em>. Его единственным элементом является строка с именем оригинального Пользователя - владельца Псевдонима.</p></li><li><p>Переадресатор</p><p>объект словаря является <em>массивом</em>. Его единственным элементом является <em>массив</em>. Его единственным элементом является строка с адресом Переадресатора.</p></li></ul></li><li><p>числовая <em>строка</em> с общим количеством Псевдонимов в Домене.</p></li><li><p>числовая <em>строка</em> с общим количеством Переадресаторов в Домене.</p></li><li><p>необязательная <em>строка</em> с новой &quot;закладкой&quot; (существует, только если в команде была часть <code>COOKIE cookie</code>.)</p></li></ul><p>Для перечисления Объектов в больших Доменах указывайте какое-нибудь разумное значение <em>limit</em> (менее 10 000) и задавайте пустую строку cookie. Если возвращаются не все Объекты, то выполните эту команду повторно, используя новое значение cookie, указанное в возвращаемом массиве. Если возвращаются все Объекты, то новое значение cookie в ответе является пустой строкой.</p><h3 id="LISTACCOUNTS" tabindex="-1"><code>LISTACCOUNTS [ domainName ]</code> <a class="header-anchor" href="#LISTACCOUNTS" aria-label="Permalink to &quot;`LISTACCOUNTS [ domainName ]` {#LISTACCOUNTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Пользователей в Домене. Эта команда возвращает <em>словарь</em> с ключами, в которых перечислены все Пользователи из указанного (или взятого по умолчанию) Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="LISTDOMAINTELNUMS" tabindex="-1"><code>LISTDOMAINTELNUMS domainName [ FILTER filter ] limit</code> <a class="header-anchor" href="#LISTDOMAINTELNUMS" aria-label="Permalink to &quot;`LISTDOMAINTELNUMS domainName [ FILTER filter ] limit` {#LISTDOMAINTELNUMS}&quot;">​</a></h3><p>Используйте эту команду для чтения номеров Telnum, созданных в указанном Домене. Эта команда возвращает <em>словарь</em>, в котором каждый элемент является номером Telnum, а значение элемента - это имя Пользователя, которому этот номер назначен. Для пустого ключа <code>&quot;&quot;</code> добавляется числовой элемент, содержащий общее число созданных номеров Telnum.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>filter : строка</code></p><p>Если этот необязательный параметр указан, то возвращаются только те номера Telnum, в которых содержится указанная строка.</p></li><li><p><code>limit : число</code></p><p>Максимальное количество возвращаемых номеров Telnum.</p></li></ul><h3 id="INSERTDIRECTORYRECORDS" tabindex="-1"><code>INSERTDIRECTORYRECORDS domainName</code> <a class="header-anchor" href="#INSERTDIRECTORYRECORDS" aria-label="Permalink to &quot;`INSERTDIRECTORYRECORDS domainName` {#INSERTDIRECTORYRECORDS}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы вставить записи Объектов Домена (Пользователи, Группы, Списки Рассылки, Переадресаторы) в Справочник.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену аутентифицированного пользователя. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Центральный Справочник (CentralDirectory)</code>.</p></li></ul><h3 id="DELETEDIRECTORYRECORDS" tabindex="-1"><code>DELETEDIRECTORYRECORDS domainName</code> <a class="header-anchor" href="#DELETEDIRECTORYRECORDS" aria-label="Permalink to &quot;`DELETEDIRECTORYRECORDS domainName` {#DELETEDIRECTORYRECORDS}&quot;">​</a></h3><p>Используйте эту команду для удаления записей объекта Домена из Справочника.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену аутентифицированного пользователя. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Центральный Справочник (CentralDirectory)</code>.</p></li></ul><h3 id="CREATEACCOUNTSTORAGE" tabindex="-1"><code>CREATEACCOUNTSTORAGE domainName PATH storage</code> <a class="header-anchor" href="#CREATEACCOUNTSTORAGE" aria-label="Permalink to &quot;`CREATEACCOUNTSTORAGE domainName PATH storage` {#CREATEACCOUNTSTORAGE}&quot;">​</a></h3><p>Используйте эту команду для создания &quot;Точки монтирования хранилища&quot; для новых Пользователей в Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>storage : строка</code></p><p>Этот параметр указывает имя &quot;Точки монтирования хранилища&quot;.</p></li></ul><h3 id="LISTACCOUNTSTORAGE" tabindex="-1"><code>LISTACCOUNTSTORAGE domainName</code> <a class="header-anchor" href="#LISTACCOUNTSTORAGE" aria-label="Permalink to &quot;`LISTACCOUNTSTORAGE domainName` {#LISTACCOUNTSTORAGE}&quot;">​</a></h3><p>Используйте эту команду для получения списка &quot;Точек монтирования хранилищ&quot; Пользователей в Домене. Эта команда возвращает <em>массив</em> с именами &quot;Точек монтирования хранилищ&quot;.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li></ul><p>Следующие команды доступны только Администраторам Системы:</p><h3 id="SETDOMAINALIASES" tabindex="-1"><code>SETDOMAINALIASES domainName newAliases</code> <a class="header-anchor" href="#SETDOMAINALIASES" aria-label="Permalink to &quot;`SETDOMAINALIASES domainName newAliases` {#SETDOMAINALIASES}&quot;">​</a></h3><p>Используйте эту команду для задания псевдонимов Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>newAliases : массив</code></p><p>Этот массив должен содержать строки с именами псевдонимов Домена. Все старые псевдонимы Домена при этом удаляются.</p></li></ul><h3 id="SETDOMAINSETTINGS" tabindex="-1"><code>SETDOMAINSETTINGS domainName newSettings</code> <a class="header-anchor" href="#SETDOMAINSETTINGS" aria-label="Permalink to &quot;`SETDOMAINSETTINGS domainName newSettings` {#SETDOMAINSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Домена.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря установок Домена. Все старые установки Домена при этом удаляются.</p></li></ul><h3 id="SETACCOUNTDEFAULTS" tabindex="-1"><code>SETACCOUNTDEFAULTS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTDEFAULTS" aria-label="Permalink to &quot;`SETACCOUNTDEFAULTS [ domainName ] newSettings` {#SETACCOUNTDEFAULTS}&quot;">​</a></h3><p>Используйте эту команду для изменения Установок по Умолчанию для Пользователя в указанном Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения Установок по Умолчанию для Пользователя в указанном Домене. Все старые Установки по Умолчанию для Пользователя удаляются.</p></li></ul><h3 id="SETACCOUNTTEMPLATE" tabindex="-1"><code>SETACCOUNTTEMPLATE [ domainName ] newSettings</code> <a class="header-anchor" href="#SETACCOUNTTEMPLATE" aria-label="Permalink to &quot;`SETACCOUNTTEMPLATE [ domainName ] newSettings` {#SETACCOUNTTEMPLATE}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Шаблона Пользователя.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения Шаблона Пользователя Домена. Все новые Пользователи в указанном Домене будут создаваться с установками из Шаблона. Все старые установки Шаблона Пользователя удаляются.</p></li></ul><h3 id="GETDOMAINLOCATION" tabindex="-1"><code>GETDOMAINLOCATION [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINLOCATION" aria-label="Permalink to &quot;`GETDOMAINLOCATION [ domainName ]` {#GETDOMAINLOCATION}&quot;">​</a></h3><p>Используйте эту команду для получения пути к файловой директории Домена (относительно <em>директории данных</em> Сервера). Эта команда возвращает <em>строку</em> с путём к файловой директории Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="SUSPENDDOMAIN" tabindex="-1"><code>SUSPENDDOMAIN domainName</code> <a class="header-anchor" href="#SUSPENDDOMAIN" aria-label="Permalink to &quot;`SUSPENDDOMAIN domainName` {#SUSPENDDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для приостановки Домена; все текущие активные сессии Пользователей Домена закрываются и не могут быть открыты снова.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, который должен быть приостановлен.</p></li></ul><h3 id="RESUMEDOMAIN" tabindex="-1"><code>RESUMEDOMAIN domainName</code> <a class="header-anchor" href="#RESUMEDOMAIN" aria-label="Permalink to &quot;`RESUMEDOMAIN domainName` {#RESUMEDOMAIN}&quot;">​</a></h3><p>Используйте эту команду для возобновления работы Домена; Пользователи смогут обслуживаться в этом Домене.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, работа которого должна быть возобновлена.</p></li></ul><h2 id="Account" tabindex="-1">Управление Пользователями <a class="header-anchor" href="#Account" aria-label="Permalink to &quot;Управление Пользователями {#Account}&quot;">​</a></h2><p>Для использования команд CLI для Управления Пользователями необходимо иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правами на <a href="./../admin/sysadmin/#Domain">Управление Доменом</a>.</p><h3 id="CREATEACCOUNT" tabindex="-1"><code>CREATEACCOUNT accountName [ accountType ] [ PATH storage ] [ LEGACY ] [ settings ]</code> <a class="header-anchor" href="#CREATEACCOUNT" aria-label="Permalink to &quot;`CREATEACCOUNT accountName [ accountType ] [ PATH storage ] [ LEGACY ] [ settings ]` {#CREATEACCOUNT}&quot;">​</a></h3><p>Используйте эту команду для создания новых пользователей.</p><ul><li><p><code>accountName : строка</code></p><p>Этот параметр задаёт имя нового Пользователя. Имя может содержать символ <code>@</code>, за которым следует имя Домена; в этом случае Пользователь создаётся в указанном Домене. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>accountType : MultiMailbox | TextMailbox | MailDirMailbox | AGrade | BGrade | CGrade | ResourceMailbox</code></p><p>Этот необязательный параметр указывает тип создаваемого Пользователя. Если тип Пользователя не указан, то создаётся Пользователь с типом <code>MultiMailbox</code> (Набор Папок).</p></li><li><p><code>storage : строка</code></p><p>Необязательный параметр; задаёт директорию &quot;Точки монтирования хранилища&quot; для данных Пользователя (имя должно быть указано без суффикса .mnt).</p></li><li><p><code>LEGACY</code></p><p>Этот необязательный флаг указывает системе создавать Пользователя с внешним (доступным старым почтовым программам) INBOX.</p></li><li><p><code>settings : словарь</code></p><p>Этот необязательный словарь начальные установки Пользователя. Пользователь создаётся с установками, указанными в Шаблоне Пользователя для выбранного Домена. Если указан параметр <em>settings</em>, то он используется для изменения установок из Шаблона. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>. Если эта команда используется Администратором Домена, то она будет работать только с теми установками Пользователя, которые этому Администратору разрешается изменять.</p></li></ul><h3 id="RENAMEACCOUNT" tabindex="-1"><code>RENAMEACCOUNT oldAccountName into newAccountName [ PATH storage ]</code> <a class="header-anchor" href="#RENAMEACCOUNT" aria-label="Permalink to &quot;`RENAMEACCOUNT oldAccountName into newAccountName [ PATH storage ]` {#RENAMEACCOUNT}&quot;">​</a></h3><p>Используйте эту команду для переименования Пользователей.</p><ul><li><p><code>oldAccountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newAccountName : строка</code></p><p>В этом параметре задаётся новое имя Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>storage : строка</code></p><p>Необязательный параметр; задаёт новую директорию &quot;Точки монтирования хранилища&quot; для данных Пользователя (имя должно быть указано без суффикса .mnt). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>.</p></li></ul><h3 id="DELETEACCOUNT" tabindex="-1"><code>DELETEACCOUNT oldAccountName</code> <a class="header-anchor" href="#DELETEACCOUNT" aria-label="Permalink to &quot;`DELETEACCOUNT oldAccountName` {#DELETEACCOUNT}&quot;">​</a></h3><p>Используйте эту команду для удаления Пользователей.</p><ul><li><p><code>oldAccountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>.</p></li></ul><h3 id="BLOCKACCOUNT" tabindex="-1"><code>BLOCKACCOUNT accountName MODE mode [ PREVENTLOGIN PREVENTDEL PREVENTSHOWFOLDERS ]</code> <a class="header-anchor" href="#BLOCKACCOUNT" aria-label="Permalink to &quot;`BLOCKACCOUNT accountName MODE mode [ PREVENTLOGIN PREVENTDEL PREVENTSHOWFOLDERS ]` {#BLOCKACCOUNT}&quot;">​</a></h3><p>Используйте эту команду для блокировки Пользователей.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>mode : Full | Part</code></p><p>В этом параметре задаётся режим блокировки Пользователя: Full - полный, Part - частичный. При полной блокировке, при делегированных правах доступа к папкам, будет запрещено удаление, перенос и папки будут закрыты к просмотру у делегата.</p></li><li><p><code>PREVENTLOGIN</code></p><p>Этот необязательный флаг применяется только к режиму частичной блокировки Пользователя и запрещает авторизацию Пользователя в системе любыми способами.</p></li><li><p><code>PREVENTDEL</code></p><p>Этот необязательный флаг применяется только к режиму частичной блокировки Пользователя и запрещает удалять письма из его почтового ящика.</p></li><li><p><code>PREVENTSHOWFOLDERS</code></p><p>Этот необязательный флаг применяется только к режиму частичной блокировки Пользователя и запрещает показывать папки писем из его почтового ящика. При частичной блокировке вы должны указать один из флагов, чтобы блокировка завершилась успешно. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>.</p></li></ul><h3 id="UNBLOCKACCOUNT" tabindex="-1"><code>UNBLOCKACCOUNT accountName</code> <a class="header-anchor" href="#UNBLOCKACCOUNT" aria-label="Permalink to &quot;`UNBLOCKACCOUNT accountName` {#UNBLOCKACCOUNT}&quot;">​</a></h3><p>Используйте эту команду для разблокировки Пользователей.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>.</p></li></ul><h3 id="SETACCOUNTTYPE" tabindex="-1"><code>SETACCOUNTTYPE accountName accountType</code> <a class="header-anchor" href="#SETACCOUNTTYPE" aria-label="Permalink to &quot;`SETACCOUNTTYPE accountName accountType` {#SETACCOUNTTYPE}&quot;">​</a></h3><p>Используйте эту команду для изменения типа Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>accountType : MultiMailbox | AGrade | BGrade | CGrade | ResourceMailbox</code></p><p>В этом параметре задаётся новый тип Пользователя. Тип текущего Пользователя также должен принадлежать к этому набору типов. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Пользователей (CanCreateAccounts)</code>.</p></li></ul><h3 id="GETACCOUNTSETTINGS" tabindex="-1"><code>GETACCOUNTSETTINGS accountName</code> <a class="header-anchor" href="#GETACCOUNTSETTINGS" aria-label="Permalink to &quot;`GETACCOUNTSETTINGS accountName` {#GETACCOUNTSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Пользователя. В словарь включаются только те установки Пользователя, которые заданы явно (не являются установками по умолчанию).</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Вместо имени Пользователя вы также можете указать один символ звёздочка (<code>*</code>). Это будет означать текущего аутентифицированного Пользователя.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все пользователи могут отправлять команду <code>GETACCOUNTSETTINGS</code> для самих себя.</p></div></li></ul><h3 id="UPDATEACCOUNTSETTINGS" tabindex="-1"><code>UPDATEACCOUNTSETTINGS accountName newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTSETTINGS" aria-label="Permalink to &quot;`UPDATEACCOUNTSETTINGS accountName newSettings` {#UPDATEACCOUNTSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newSettings : словарь</code></p><p>Данные этого словаря используются для изменения словаря установок Пользователя. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены. Если новое значение установки указано как строка <code>default</code>, то эта установка Пользователя удаляется и вместо неё используется установка Пользователя, применяемая по умолчанию. Если эта команда используется Администратором Домена, то она будет изменять только те установки Пользователя, которые этому Администратору разрешается изменять.</p></li></ul><h3 id="GETACCOUNTEFFECTIVESETTINGS" tabindex="-1"><code>GETACCOUNTEFFECTIVESETTINGS accountName</code> <a class="header-anchor" href="#GETACCOUNTEFFECTIVESETTINGS" aria-label="Permalink to &quot;`GETACCOUNTEFFECTIVESETTINGS accountName` {#GETACCOUNTEFFECTIVESETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения фактических установок Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Пользователя. В словарь включаются как набор явно заданных установок Пользователя, так и набор установок, применяемый по умолчанию.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Вместо имени Пользователя вы также можете указать один символ звёздочка (<code>*</code>). Это будет означать текущего аутентифицированного Пользователя.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все Пользователи могут отправлять команду <code>GETACCOUNTEFFECTIVESETTINGS</code> для самих себя.</p></div></li></ul><h3 id="GETACCOUNTONESETTING" tabindex="-1"><code>GETACCOUNTONESETTING accountName keyName</code> <a class="header-anchor" href="#GETACCOUNTONESETTING" aria-label="Permalink to &quot;`GETACCOUNTONESETTING accountName keyName` {#GETACCOUNTONESETTING}&quot;">​</a></h3><p>Используйте эту команду для получения одного элемента из фактических установок Пользователя. Эта команда возвращает <em>объект</em>, который может быть <em>строкой</em>, <em>массивом</em> или <em>словарём</em>, в котором содержится установка Пользователя, или нулевым объектом.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Вместо имени Пользователя вы также можете указать один символ звёздочка (<code>*</code>). Это будет означать текущего аутентифицированного Пользователя.</p></li><li><p><code>keyName : строка</code></p><p>В этом параметре задаётся имя элемента установки Пользователя.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все Пользователи могут отправлять команду <code>GETACCOUNTONESETTING</code> для самих себя.</p></div></li></ul><h3 id="SETACCOUNTPASSWORD" tabindex="-1"><code>SETACCOUNTPASSWORD accountName PASSWORD newPassword [ METHOD method | NAME tag ] [ CHECK ]</code> <a class="header-anchor" href="#SETACCOUNTPASSWORD" aria-label="Permalink to &quot;`SETACCOUNTPASSWORD accountName PASSWORD newPassword [ METHOD method | NAME tag ] [ CHECK ]` {#SETACCOUNTPASSWORD}&quot;">​</a></h3><p>Используйте эту команду для изменения пароля Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newPassword : строка</code></p><p>Эта строка задаёт новый пароль Пользователя. Новый пароль будет сохранён с использованием действующей установки Шифрование Пароля для этого Пользователя.</p></li><li><p><code>tag : строка</code></p><p>Этот необязательный параметр задаёт метку для Пароля Приложений. Если строка <em>newPassword</em> пуста, то соответствующий метке Пароль Приложений удаляется.</p></li><li><p><code>method : строка</code></p><p>Этот необязательный параметр указывает способ доступа Пользователя. Если этот способ &quot;SIP&quot;, то изменяется Альтернативный Пароль SIP, если способ - &quot;RADIUS&quot;, то изменяется Альтернативный Пароль RADIUS. Во всех других случаях изменяется установка Пароля CommuniGate. Новый пароль будет сохранён с использованием действующей установки Шифрование Пароля для этого Пользователя. Для использования этой команды необходимо обладать для Домена Пользователя правом Администратора Домена &quot;Основные Установки&quot;. Пользователь может изменять свой пароль. В этом случае или, когда явно указано ключевое слово <code>CHECK</code>, операция выполняется успешно, только если новый пароль удовлетворяет требованиям сложности и размера пароля и у Пользователя фактически включена установка <code>CanModifyPassword</code>.</p></li></ul><h3 id="VERIFYACCOUNTPASSWORD" tabindex="-1"><code>VERIFYACCOUNTPASSWORD accountName PASSWORD password</code> <a class="header-anchor" href="#VERIFYACCOUNTPASSWORD" aria-label="Permalink to &quot;`VERIFYACCOUNTPASSWORD accountName PASSWORD password` {#VERIFYACCOUNTPASSWORD}&quot;">​</a></h3><p>Используйте эту команду для проверки пароля Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>password : строка</code></p><p>Эта строка используется для указания проверяемого пароля (в открытом текстовом формате). Для использования этой команды необходимо обладать какими-нибудь правами Администрирования Домена в Домене этого Пользователя.</p></li></ul><h3 id="VERIFYACCOUNTIDENTITY" tabindex="-1"><code>VERIFYACCOUNTIDENTITY accountName FOR identity</code> <a class="header-anchor" href="#VERIFYACCOUNTIDENTITY" aria-label="Permalink to &quot;`VERIFYACCOUNTIDENTITY accountName FOR identity` {#VERIFYACCOUNTIDENTITY}&quot;">​</a></h3><p>Используйте эту команду для проверки допустимости содержимого заголовка &#39;From:&#39; в сообщениях Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>identity : строка</code></p><p>Эта строка должна содержать значение проверяемого заголовка &#39;From:&#39;, например, &quot;Real Name <a href="mailto:user@domain.dom" target="_blank" rel="noreferrer">user@domain.dom</a>&quot;Для использования этой команды необходимо обладать какими-нибудь правами Администрирования Домена в Домене этого Пользователя.</p></li></ul><h3 id="GETACCOUNTALIASES" tabindex="-1"><code>GETACCOUNTALIASES accountName</code> <a class="header-anchor" href="#GETACCOUNTALIASES" aria-label="Permalink to &quot;`GETACCOUNTALIASES accountName` {#GETACCOUNTALIASES}&quot;">​</a></h3><p>Используйте эту команду для получения списка псевдонимов Пользователя. Эта команда возвращает <em>массив</em> с именами псевдонимов Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTALIASES" tabindex="-1"><code>SETACCOUNTALIASES accountName newAliases</code> <a class="header-anchor" href="#SETACCOUNTALIASES" aria-label="Permalink to &quot;`SETACCOUNTALIASES accountName newAliases` {#SETACCOUNTALIASES}&quot;">​</a></h3><p>Используйте эту команду для задания псевдонимов Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newAliases : массив</code></p><p>Этот массив должен содержать строки с именами псевдонимов Пользователя. Старые псевдонимы Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Псевдонимы (CanCreateAliases)</code>.</p></li></ul><h3 id="GETACCOUNTTELNUMS" tabindex="-1"><code>GETACCOUNTTELNUMS accountName</code> <a class="header-anchor" href="#GETACCOUNTTELNUMS" aria-label="Permalink to &quot;`GETACCOUNTTELNUMS accountName` {#GETACCOUNTTELNUMS}&quot;">​</a></h3><p>Используйте эту команду для получения списка телефонных номеров, присвоенных Пользователю. Эта команда возвращает <em>массив</em> с присвоенными телефонными номерами.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTTELNUMS" tabindex="-1"><code>SETACCOUNTTELNUMS accountName newTelnums</code> <a class="header-anchor" href="#SETACCOUNTTELNUMS" aria-label="Permalink to &quot;`SETACCOUNTTELNUMS accountName newTelnums` {#SETACCOUNTTELNUMS}&quot;">​</a></h3><p>Используйте эту команду для присвоения Пользователю телефонных номеров.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newTelnums : массив</code></p><p>Этот массив должен содержать строки с телефонными номерами. Все ранее присвоенные Пользователю телефонные номера удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может присваивать Телефонные Номера (CanCreateTelnums)</code>.</p></li></ul><h3 id="MODIFYACCOUNTTELNUMS" tabindex="-1"><code>MODIFYACCOUNTTELNUMS accountName parameters</code> <a class="header-anchor" href="#MODIFYACCOUNTTELNUMS" aria-label="Permalink to &quot;`MODIFYACCOUNTTELNUMS accountName parameters` {#MODIFYACCOUNTTELNUMS}&quot;">​</a></h3><p>Используйте эту команду для изменения списка телефонных номеров, присвоенных Пользователю.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>parameters : словарь</code></p><p>Этот словарь должен содержать элемент с ключом <code>what</code>, задающий применяемую операцию:</p><ul><li><p><code>add</code></p><p>словарь <em>parameters</em> должен содержать ключ <code>telnum</code> со значением номера telnum, который должен быть добавлен к набору номеров Telnum указанного Пользователя. Если этот Telnum уже присвоен Пользователю, то возвращается код ошибки.</p></li><li><p><code>del</code></p><p>словарь <em>parameters</em> должен содержать ключ <code>telnum</code> со значением номера telnum, который должен быть удалён из набора номеров Telnum указанного Пользователя. Если этот Telnum не принадлежит Пользователю, то возвращается код ошибки.</p></li><li><p><code>pop</code></p><p>Словарь <em>parameters</em> не должен содержать других ключей. Первый из присвоенных Пользователю номеров Telnum удаляется из набора номеров Telnum указанного Пользователя и копируется в словарь ответа. Если набор номеров Telnum указанного Пользователя был пуст, то код ошибки не возвращается и в словарь результата не копируется никаких элементов. Эта команда возвращает <em>словарь</em>. В случае операции <code>pop</code> этот словарь содержит строку с ключом <code>telnum</code>, значением которого является строка с номером Telnum, удалённым из набора номеров Telnum Пользователя. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может присваивать Телефонные Номера (CanCreateTelnums)</code>.</p></li></ul></li></ul><h3 id="GETACCOUNTMAILRULES" tabindex="-1"><code>GETACCOUNTMAILRULES accountName</code> <a class="header-anchor" href="#GETACCOUNTMAILRULES" aria-label="Permalink to &quot;`GETACCOUNTMAILRULES accountName` {#GETACCOUNTMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для получения Почтовых Правил Пользователя. Эта команда возвращает <em>массив</em> Почтовых Правил Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTMAILRULES" tabindex="-1"><code>SETACCOUNTMAILRULES accountName newRules</code> <a class="header-anchor" href="#SETACCOUNTMAILRULES" aria-label="Permalink to &quot;`SETACCOUNTMAILRULES accountName newRules` {#SETACCOUNTMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Почтовых Правил Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newRules : массив</code></p><p>Этот массив должен содержать Почтовые Правила Пользователя. Все старые Почтовые Правила Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Почтовые Правила (RulesAllowed)</code>. Эта команда может доступна любому Пользователю для изменения собственных Правил (в соответствии с ограничениями, налагаемыми &quot;разрешёнными действиями&quot;).</p></li></ul><h3 id="GETACCOUNTSIGNALRULES" tabindex="-1"><code>GETACCOUNTSIGNALRULES accountName</code> <a class="header-anchor" href="#GETACCOUNTSIGNALRULES" aria-label="Permalink to &quot;`GETACCOUNTSIGNALRULES accountName` {#GETACCOUNTSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для получения Сигнальных Правил Пользователя. Эта команда возвращает <em>массив</em> Сигнальных Правил Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTSIGNALRULES" tabindex="-1"><code>SETACCOUNTSIGNALRULES accountName newRules</code> <a class="header-anchor" href="#SETACCOUNTSIGNALRULES" aria-label="Permalink to &quot;`SETACCOUNTSIGNALRULES accountName newRules` {#SETACCOUNTSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Сигнальных Правил Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newRules : массив</code></p><p>Этот массив должен содержать Сигнальные Правила Пользователя. Все старые Сигнальные Правила Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Сигнальные Правила (SignalRulesAllowed)</code>.</p></li></ul><h3 id="UPDATEACCOUNTMAILRULE" tabindex="-1"><code>UPDATEACCOUNTMAILRULE accountName newRule</code> <a class="header-anchor" href="#UPDATEACCOUNTMAILRULE" aria-label="Permalink to &quot;`UPDATEACCOUNTMAILRULE accountName newRule` {#UPDATEACCOUNTMAILRULE}&quot;">​</a></h3><h3 id="updateaccountmailrule-accountname-delete-oldrule" tabindex="-1"><code>UPDATEACCOUNTMAILRULE accountName DELETE oldRule</code> <a class="header-anchor" href="#updateaccountmailrule-accountname-delete-oldrule" aria-label="Permalink to &quot;`UPDATEACCOUNTMAILRULE accountName DELETE oldRule`&quot;">​</a></h3><h3 id="UPDATEACCOUNTSIGNALRULE" tabindex="-1"><code>UPDATEACCOUNTSIGNALRULE accountName newRule</code> <a class="header-anchor" href="#UPDATEACCOUNTSIGNALRULE" aria-label="Permalink to &quot;`UPDATEACCOUNTSIGNALRULE accountName newRule` {#UPDATEACCOUNTSIGNALRULE}&quot;">​</a></h3><h3 id="updateaccountsignalrule-accountname-delete-oldrule" tabindex="-1"><code>UPDATEACCOUNTSIGNALRULE accountName DELETE oldRule</code> <a class="header-anchor" href="#updateaccountsignalrule-accountname-delete-oldrule" aria-label="Permalink to &quot;`UPDATEACCOUNTSIGNALRULE accountName DELETE oldRule`&quot;">​</a></h3><p>Используйте эти команды для изменения Почтовых/Сигнальных Правил Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newRule : массив</code></p><p>Этот параметр должен быть массивом, первый элемент которого задаёт приоритет Правила, а второй задаёт имя Правила. Необязательные третий, четвёртый и пятый элементы задают условия Правил, Действия Правил и комментарии к Правилам. Если массив параметров содержит менее четырёх элементов, то первый элемент используется для изменения приоритета существующего Правила, имя которого задаётся во втором элементе массива. Если такое Правило не существует, то команда возвращает ошибку. Если массив параметров содержит 4 или более элементов, то весь массив параметров сохраняется как новое Правило. Если есть существующее Правило с таким же именем, то оно удаляется.</p></li><li><p><code>oldRule : строка</code></p><p>Эта строка-параметр (указываемая после ключевого слова DELETE) задаёт имя Правила, которое должно быть удалено. Если такое Правило не существует, то команда не совершает никаких операций и не возвращает ошибку. Команда <code>UpdateAccountMailRule</code> может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Правила для Почты (RulesAllowed)</code>. Команда <code>UpdateAccountSignalRule</code> может использоваться Администраторами Домена, только если они имеют право доступа <code>Разрешённые Правила для Звонков (SignalRulesAllowed)</code>. Эта команда может доступна любому Пользователю для изменения собственных Правил (в соответствии с ограничениями, налагаемыми &quot;разрешёнными действиями&quot;).</p></li></ul><h3 id="GETACCOUNTRPOPS" tabindex="-1"><code>GETACCOUNTRPOPS accountName</code> <a class="header-anchor" href="#GETACCOUNTRPOPS" aria-label="Permalink to &quot;`GETACCOUNTRPOPS accountName` {#GETACCOUNTRPOPS}&quot;">​</a></h3><p>Используйте эту команду для получения учётных записей RPOP Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся учётные записи RPOP Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTRPOPS" tabindex="-1"><code>SETACCOUNTRPOPS accountName newRecords</code> <a class="header-anchor" href="#SETACCOUNTRPOPS" aria-label="Permalink to &quot;`SETACCOUNTRPOPS accountName newRecords` {#SETACCOUNTRPOPS}&quot;">​</a></h3><p>Используйте эту команду для изменения учётных записей RPOP Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newRecords : словарь</code></p><p>Этот словарь должен содержать учётные записи RPOP Пользователя. Старые учётные записи RPOP Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Модификации RPOP (CanModifyRPOP)</code>.</p></li></ul><h3 id="GETACCOUNTRSIPS" tabindex="-1"><code>GETACCOUNTRSIPS accountName</code> <a class="header-anchor" href="#GETACCOUNTRSIPS" aria-label="Permalink to &quot;`GETACCOUNTRSIPS accountName` {#GETACCOUNTRSIPS}&quot;">​</a></h3><p>Используйте эту команду для получения учётных записей RSIP Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся учётные записи RSIP Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETACCOUNTRSIPS" tabindex="-1"><code>SETACCOUNTRSIPS accountName newRecords</code> <a class="header-anchor" href="#SETACCOUNTRSIPS" aria-label="Permalink to &quot;`SETACCOUNTRSIPS accountName newRecords` {#SETACCOUNTRSIPS}&quot;">​</a></h3><p>Используйте эту команду для изменения учётных записей RSIP Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newRecords : словарь</code></p><p>Этот словарь должен содержать учётные записи RSIP Пользователя. Старые учётные записи RSIP Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Модификации RSIP (CanModifyRSIP)</code>.</p></li></ul><h3 id="UPDATESCHEDULEDTASK" tabindex="-1"><code>UPDATESCHEDULEDTASK accountName taskData</code> <a class="header-anchor" href="#UPDATESCHEDULEDTASK" aria-label="Permalink to &quot;`UPDATESCHEDULEDTASK accountName taskData` {#UPDATESCHEDULEDTASK}&quot;">​</a></h3><p>Используйте эту команду для управления Расписанием Задач Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>taskData : словарь</code></p><p>Этот словарь должен содержать данные выполняемых по расписанию задач:</p><ul><li><p>id</p><p>строка с именем выполняемой по расписанию задачи. Если задачи с таким именем нет, создаётся новая запись Расписания Задач.</p></li><li><p>program</p><p>строка с именем программы выполняемой по расписанию задачи. Это должно быть имя <a href="./PBXApp.html">Приложения Реального Времени</a>, доступного в среде Домена Пользователя.</p></li><li><p>script</p><p>Если строка с именем программы выполняемой по расписанию задачи не задана, то этот параметр может задать строкой имя <a href="./CGPL.html#SyncScripts">Синхронного Скрипта</a>, доступного в среде Домена Пользователя. Если не указан ни этот элемент, ни <code>program</code> , то существующая запись в Расписании Задач (если такая есть) удаляется.</p></li><li><p>parameter</p><p>необязательный <a href="./Data.html">базовый объект</a>. Когда Задача запускается по расписанию, этот Объект передаётся ей в элементе <code>startParameter</code>.</p></li><li><p>when</p><p>отметка времени (время GMT), указывающая, когда Задача должна быть запущена по расписанию, или строка <code>now</code>.</p></li><li><p>period</p><p>необязательный параметр - строка <code>day</code>, <code>week</code>, <code>month</code> или <code>year</code> или число. Если он указан, то задача автоматически добавляется в расписание через указанный период времени (в случае указания числа - через такое количество секунд). Если этот параметр не указан, то Задача удаляется из Расписания сразу после выполнения. При запуске Задачи по Расписанию выполняется её точка входа <code>main</code>. Массив <code>startParameter</code> Задачи содержит следующие элементы:</p></li><li><p><code>startParameter[0]</code> - строка с именем выполняемой по расписанию задачи</p></li><li><p><code>startParameter[1]</code> содержит отметку времени запуска Задачи</p></li><li><p><code>startParameter[2]</code> (необязательный параметр) содержит данные <code>parameter</code> запускаемой по расписанию Задачи</p></li></ul><p>Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Модификации RSIP (CanModifyRSIP)</code> для этого Пользователя.</p></li></ul><h3 id="GETACCOUNTRIGHTS" tabindex="-1"><code>GETACCOUNTRIGHTS accountName</code> <a class="header-anchor" href="#GETACCOUNTRIGHTS" aria-label="Permalink to &quot;`GETACCOUNTRIGHTS accountName` {#GETACCOUNTRIGHTS}&quot;">​</a></h3><p>Используйте эту команду для получения массива прав доступа к Серверу или Домену, предоставленных указанному пользователю. Эта команда возвращает данные - <em>массив</em>, в котором перечисляются все Права доступа Пользователя к Серверу.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена.</p></li></ul><h3 id="GETACCOUNTINFO" tabindex="-1"><code>GETACCOUNTINFO accountName [Key keyName | ( keyList) ]</code> <a class="header-anchor" href="#GETACCOUNTINFO" aria-label="Permalink to &quot;`GETACCOUNTINFO accountName [Key keyName | ( keyList) ]` {#GETACCOUNTINFO}&quot;">​</a></h3><p>Используйте эту команду для получения словаря с &quot;информацией&quot; о Пользователе. Эта команда возвращает данные (смотрите ниже).</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше). Вместо имени Пользователя вы также можете указать один символ звёздочка (<code>*</code>). Это будет означать текущего аутентифицированного Пользователя.</p></li><li><p><code>keyList : массив</code></p><p>Этот необязательный параметр задаёт имена ключей, информацию по которым необходимо получить. Обратите внимание, что &quot;информационные&quot; данные Пользователя хранятся в словарях в файлах <code>.info</code>, а имена словарей &quot;инфо&quot; элементов начинаются с символа решётка (<code>#</code>). Вы НЕ должны включать символ решётка в параметр keyName команды GETACCOUNTINFO. Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>GETACCOUNTINFO &quot;user1@domain1.com&quot; (LastLogin,LastAddress)</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Имена элементов &quot;инфо&quot; зависимы от регистра клавиатуры.</p></div><p>Команда возвращает <em>словарь</em> всех существующих и указанных в массиве keyList элементов &quot;инфо&quot;.</p></li><li><p><code>keyName : строка</code></p><p>Этот необязательный параметр указывает имя запрашиваемого элемента &quot;инфо&quot;. Оно может быть указано только в том случае, если параметр <em>keyList</em> не задан. Обратите внимание, что &quot;информационные&quot; данные Пользователя хранятся в словарях, в файлах <code>.info</code>, а имена словарей &quot;инфо&quot; элементов начинаются с символа решётка. Вы НЕ должны включать символ решётка в параметр keyName команды GETACCOUNTINFO. Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>GETACCOUNTINFO &quot;user1@domain1.com&quot; Key LastLogin</span></span></code></pre></div><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Имена элементов &quot;инфо&quot; зависимы от регистра клавиатуры.</p></div><p>Команда возвращает указанный элемент &quot;инфо&quot;. Если элемент не найден, то команда возвращает пустую строку - два знака кавычек подряд (<code>&quot;&quot;</code>).</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все пользователи могут использовать команду <code>GETACCOUNTINFO</code> для получения элементов из своих собственных объектов &quot;инфо&quot;.</p></div></li></ul><h3 id="GETACCOUNTPREFS" tabindex="-1"><code>GETACCOUNTPREFS accountName</code> <a class="header-anchor" href="#GETACCOUNTPREFS" aria-label="Permalink to &quot;`GETACCOUNTPREFS accountName` {#GETACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для получения Настроек Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся Настройки Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Любой Пользователь может использовать команду <code>GETACCOUNTPREFS</code> для получения своих Настроек.</p></div></li></ul><h3 id="UPDATEACCOUNTPREFS" tabindex="-1"><code>UPDATEACCOUNTPREFS accountName newSettings</code> <a class="header-anchor" href="#UPDATEACCOUNTPREFS" aria-label="Permalink to &quot;`UPDATEACCOUNTPREFS accountName newSettings` {#UPDATEACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для изменения Настроек Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря Настроек Пользователя. Он не обязан содержать в себе все Настройки; отсутствующие в словаре настройки просто не будут изменены. Если новое значение Настроек указано как строка <code>default</code>, то значение Настроек удаляется и вместо них используются Настройки, применяемые по умолчанию. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Настройки (WebUserSettings)</code>.</p></li></ul><h3 id="SETACCOUNTPREFS" tabindex="-1"><code>SETACCOUNTPREFS accountName newSettings</code> <a class="header-anchor" href="#SETACCOUNTPREFS" aria-label="Permalink to &quot;`SETACCOUNTPREFS accountName newSettings` {#SETACCOUNTPREFS}&quot;">​</a></h3><p>Используйте эту команду для задания Настроек Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newSettings : словарь</code></p><p>В этом словаре должны находиться новые Настройки Пользователя. Все старые Настройки Пользователя при этом удаляются. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Настройки (WebUserSettings)</code>.</p></li></ul><h3 id="GETACCOUNTEFFECTIVEPREFS" tabindex="-1"><code>GETACCOUNTEFFECTIVEPREFS accountName</code> <a class="header-anchor" href="#GETACCOUNTEFFECTIVEPREFS" aria-label="Permalink to &quot;`GETACCOUNTEFFECTIVEPREFS accountName` {#GETACCOUNTEFFECTIVEPREFS}&quot;">​</a></h3><p>Используйте эту команду для получения фактических Настроек Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся Настройки Пользователя. В этот словарь включаются и явно заданные настройки, и применяемые по умолчанию настройки.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все пользователи могут использовать эту команду для получения всех своих фактических Настроек.</p></div></li></ul><h3 id="KILLACCOUNTSESSIONS" tabindex="-1"><code>KILLACCOUNTSESSIONS accountName</code> <a class="header-anchor" href="#KILLACCOUNTSESSIONS" aria-label="Permalink to &quot;`KILLACCOUNTSESSIONS accountName` {#KILLACCOUNTSESSIONS}&quot;">​</a></h3><p>Используйте эту команду для прекращения всех сессий Пользователя (POP, IMAP, FTP, WebUser и т.д.).</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Все Администратора Домена могут использовать эту команду.</p></div></li></ul><p>Следующая команда управляет <a href="./../admin/objects/Accounts.html#AccessRights">Правами Доступа</a> Пользователя. Эта команда доступна Пользователю и Администраторам Домена, только если они имеют право доступа <code>Может выступать от имени других (CanImpersonate)</code>.</p><h3 id="GETACCOUNTACL" tabindex="-1"><code>GETACCOUNTACL accountName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETACCOUNTACL" aria-label="Permalink to &quot;`GETACCOUNTACL accountName [ AUTH authAccountName ]` {#GETACCOUNTACL}&quot;">​</a></h3><p>Используйте эту команду для получения списка прав доступа (ACL) к Пользователю. Эта команда возвращает <em>словарь</em>, в котором содержатся элементы ACL.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя (требуемого Пользователя). Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя задано, то информация ACL возвращается только если указанный Пользователь имеет право доступа <code>Управлять</code> для требуемого Пользователя.</p></li></ul><h3 id="SETACCOUNTACL" tabindex="-1"><code>SETACCOUNTACL accountName [ AUTH authAccountName ] newACL</code> <a class="header-anchor" href="#SETACCOUNTACL" aria-label="Permalink to &quot;`SETACCOUNTACL accountName [ AUTH authAccountName ] newACL` {#SETACCOUNTACL}&quot;">​</a></h3><p>Используйте эту команду для изменения списка прав доступа (ACL) Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя (требуемого Пользователя). Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя задано, то информация ACL изменяется только если указанный Пользователь имеет право доступа <code>Управлять</code> для требуемого Пользователя.</p></li><li><p><code>newACL : словарь</code></p><p>В этом параметре задаются элементы прав доступа, которые должны быть изменены. Каждый ключ словаря задаёт <em>идентификатор</em>, а значения ключей должны быть строками с символами прав доступа. Если значение ключа начинается с символа минус (<code>-</code>), то права доступа, указанные в этой строке, убираются из элемента прав доступа. Если значение ключа начинается с символа плюс (<code>+</code>), то права доступа, указанные в этой строке, добавляются к элементу прав доступа. В других случаях, права доступа, указанные в строке, замещают набор прав в элементе прав доступа. Если элемент права доступа для указанного ключа не существует, то он будет создан. Если новый элемент права доступа имеет пустой набор прав доступа, то элемент удаляется.</p></li></ul><h3 id="GETACCOUNTACLRIGHTS" tabindex="-1"><code>GETACCOUNTACLRIGHTS accountName AUTH authAccountName</code> <a class="header-anchor" href="#GETACCOUNTACLRIGHTS" aria-label="Permalink to &quot;`GETACCOUNTACLRIGHTS accountName AUTH authAccountName` {#GETACCOUNTACLRIGHTS}&quot;">​</a></h3><p>Эта команда возвращает <em>строку</em> с фактически действующими правами доступа для данного authAccountName.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя (требуемого Пользователя). Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот параметр указывает имя Пользователя, чьи фактические права доступа к требуемому Пользователю должны быть получены.</p></li></ul><p>Следующие команды доступны только Администраторам Системы:</p><h3 id="SETACCOUNTSETTINGS" tabindex="-1"><code>SETACCOUNTSETTINGS accountName newSettings</code> <a class="header-anchor" href="#SETACCOUNTSETTINGS" aria-label="Permalink to &quot;`SETACCOUNTSETTINGS accountName newSettings` {#SETACCOUNTSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря установок Пользователя. Все старые установки Пользователя при этом удаляются.</p></li></ul><h3 id="GETACCOUNTLOCATION" tabindex="-1"><code>GETACCOUNTLOCATION accountName</code> <a class="header-anchor" href="#GETACCOUNTLOCATION" aria-label="Permalink to &quot;`GETACCOUNTLOCATION accountName` {#GETACCOUNTLOCATION}&quot;">​</a></h3><p>Используйте эту команду для получения пути к файловой директории Пользователя (для Пользователей с типом Набор Папок) или получения пути к файлу папки INBOX Пользователя (для пользователей, имеющих только одну папку). Эта команда возвращает <em>строку</em> с путём к файловой директории Пользователя. Путь указывается относительно к файловой директории Домена Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="GETACCOUNTPRESENCE" tabindex="-1"><code>GETACCOUNTPRESENCE accountName</code> <a class="header-anchor" href="#GETACCOUNTPRESENCE" aria-label="Permalink to &quot;`GETACCOUNTPRESENCE accountName` {#GETACCOUNTPRESENCE}&quot;">​</a></h3><p>Используйте эту команду для получения статуса присутствия Пользователя. Эта команда возвращает результат:</p><ul><li><p><em>массив</em> из двух <em>строк</em> - статус присутствия Пользователя и произвольное сообщение статуса, или</p></li><li><p><em>строка</em> - статус присутствия Пользователя (если произвольное сообщение статуса не задано), или</p></li><li><p>нулевой объект - если статус присутствия Пользователя не задан совсем.</p></li><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><p>Элемент <code>AccessMode</code> установок Пользователя и Домена задаёт <a href="./../admin/objects/Accounts.html#Services">Включённые Услуги</a>. Значение установки может быть одним из следующих:</p><ul><li>Строка <code>All</code>: включены все услуги.</li><li>Строка <code>None</code>: все услуги выключены.</li><li>Массив строк. В первом элементе массива содержится число или числовая строка, в последующих элементах - имена включённых услуг. Все услуги с номерами выше числа, указанного в первом элементе массива, тоже включены. Услуги (с их номерами), поддерживаемые текущими версиями Сервера:<br> 1:Mail, 2:POP, 3:IMAP, 4:WebMail, 5:PWD, 6:Agent, 7:WebSite, 8:Relay, 9:Roaming, 10:FTP, 11:MAPI, 12:TLS, 13:S/MIME, 14:LDAP, 15:WebCAL, 16:RADIUS, 17:SIP, 18:PBX, 19:XMPP, 20:XIMSS, 21:Signal, 22:AirSync, 23:HTTP, 24:MobilePBX, 25:XMedia, 26:YMedia, 27:MobileClient, 28:ClientMail, 29:ClientIM, 30:ClientVoIP</li></ul><h2 id="Group" tabindex="-1">Управление Группами <a class="header-anchor" href="#Group" aria-label="Permalink to &quot;Управление Группами {#Group}&quot;">​</a></h2><p>Для использования команд CLI Управления Группами необходимо иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Сервера или обладать правами на <a href="./../admin/sysadmin/#Domain">Управление Доменом</a>.</p><h3 id="LISTGROUPS" tabindex="-1"><code>LISTGROUPS [ domainName ]</code> <a class="header-anchor" href="#LISTGROUPS" aria-label="Permalink to &quot;`LISTGROUPS [ domainName ]` {#LISTGROUPS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Групп в Домене. Эта команда возвращает <em>массив</em>, в котором содержатся имена всех Групп в указанном (или взятом по умолчанию) Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="CREATEGROUP" tabindex="-1"><code>CREATEGROUP groupName [ settings ]</code> <a class="header-anchor" href="#CREATEGROUP" aria-label="Permalink to &quot;`CREATEGROUP groupName [ settings ]` {#CREATEGROUP}&quot;">​</a></h3><p>Используйте эту команду для создания новых Групп.</p><ul><li><p><code>groupName : строка</code></p><p>Этот параметр задаёт имя новой Группы. Имя может содержать символ <code>@</code>, за которым следует имя Домена; в этом случае Группа создаётся в указанном Домене. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>settings : словарь</code></p><p>Этот необязательный параметр задаёт начальные установки Группы и список участников. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Группы (CanCreateGroups)</code>.</p></li></ul><h3 id="RENAMEGROUP" tabindex="-1"><code>RENAMEGROUP oldGroupName into newGroupName</code> <a class="header-anchor" href="#RENAMEGROUP" aria-label="Permalink to &quot;`RENAMEGROUP oldGroupName into newGroupName` {#RENAMEGROUP}&quot;">​</a></h3><p>Используйте эту команду для переименования Групп.</p><ul><li><p><code>oldGroupName : строка</code></p><p>Этот параметр указывает имя существующей Группы. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newGroupName : строка</code></p><p>В этом параметре задаётся имя новой Группы. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Группы (CanCreateGroups)</code>.</p></li></ul><h3 id="DELETEGROUP" tabindex="-1"><code>DELETEGROUP groupName</code> <a class="header-anchor" href="#DELETEGROUP" aria-label="Permalink to &quot;`DELETEGROUP groupName` {#DELETEGROUP}&quot;">​</a></h3><p>Используйте эту команду для удаления Групп.</p><ul><li><p><code>groupName : строка</code></p><p>Этот параметр указывает имя существующей Группы. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Группы (CanCreateGroups)</code>.</p></li></ul><h3 id="GETGROUP" tabindex="-1"><code>GETGROUP groupName</code> <a class="header-anchor" href="#GETGROUP" aria-label="Permalink to &quot;`GETGROUP groupName` {#GETGROUP}&quot;">​</a></h3><p>Используйте эту команду для получения установок групп. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Группы и её члены.</p><ul><li><p><code>groupName : строка</code></p><p>Этот параметр указывает имя существующей Группы. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="SETGROUP" tabindex="-1"><code>SETGROUP groupName newSettings</code> <a class="header-anchor" href="#SETGROUP" aria-label="Permalink to &quot;`SETGROUP groupName newSettings` {#SETGROUP}&quot;">​</a></h3><p>Используйте эту команду для задания установок Группы.</p><ul><li><p><code>groupName : строка</code></p><p>Этот параметр указывает имя существующей Группы. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения словаря установок Группы. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Группы (CanCreateGroups)</code>.</p></li></ul><h2 id="Forward" tabindex="-1">Управление Переадресаторами <a class="header-anchor" href="#Forward" aria-label="Permalink to &quot;Управление Переадресаторами {#Forward}&quot;">​</a></h2><p>Для использования команд CLI управления Переадресаторами необходимо иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правами на <a href="./../admin/sysadmin/#Domain">Управление Доменом</a>.</p><h3 id="LISTFORWARDERS" tabindex="-1"><code>LISTFORWARDERS [ domainName ]</code> <a class="header-anchor" href="#LISTFORWARDERS" aria-label="Permalink to &quot;`LISTFORWARDERS [ domainName ]` {#LISTFORWARDERS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Переадресаторов в Домене. Эта команда возвращает <em>массив</em>, в котором содержатся имена всех Переадресаторов в указанном (или взятом по умолчанию) Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="CREATEFORWARDER" tabindex="-1"><code>CREATEFORWARDER forwarderName TO address</code> <a class="header-anchor" href="#CREATEFORWARDER" aria-label="Permalink to &quot;`CREATEFORWARDER forwarderName TO address` {#CREATEFORWARDER}&quot;">​</a></h3><p>Используйте эту команду для создания нового Переадресатора.</p><ul><li><p><code>forwarderName : строка</code></p><p>Этот параметр задаёт имя нового переадресатора. Имя может содержать символ <code>@</code>, за которым следует имя Домена; в этом случае Переадресатор создаётся в указанном Домене. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>address : строка</code></p><p>В этом параметре задаётся адрес электронной почты, на который Переадресатор должен перенаправлять сообщения и Сигналы. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Переадресаторы (CanCreateForwarders)</code>.</p></li></ul><h3 id="RENAMEFORWARDER" tabindex="-1"><code>RENAMEFORWARDER oldForwarderName INTO newForwarderName</code> <a class="header-anchor" href="#RENAMEFORWARDER" aria-label="Permalink to &quot;`RENAMEFORWARDER oldForwarderName INTO newForwarderName` {#RENAMEFORWARDER}&quot;">​</a></h3><p>Используйте эту команду для переименования Переадресаторов.</p><ul><li><p><code>oldForwarderName : строка</code></p><p>В этом параметре задаётся имя существующего Переадресатора. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newForwarderName : строка</code></p><p>В этом параметре задаётся имя нового Переадресатора. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Переадресаторы (CanCreateForwarders)</code>.</p></li></ul><h3 id="DELETEFORWARDER" tabindex="-1"><code>DELETEFORWARDER forwarderName</code> <a class="header-anchor" href="#DELETEFORWARDER" aria-label="Permalink to &quot;`DELETEFORWARDER forwarderName` {#DELETEFORWARDER}&quot;">​</a></h3><p>Используйте эту команду для удаления Переадресатора.</p><ul><li><p><code>forwarderName : строка</code></p><p>В этом параметре задаётся имя существующего Переадресатора. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Может создавать Переадресаторы (CanCreateForwarders)</code>.</p></li></ul><h3 id="GETFORWARDER" tabindex="-1"><code>GETFORWARDER forwarderName</code> <a class="header-anchor" href="#GETFORWARDER" aria-label="Permalink to &quot;`GETFORWARDER forwarderName` {#GETFORWARDER}&quot;">​</a></h3><p>Используйте эту команду для получения адреса Переадресатора. Команда возвращает <em>строку</em> с адресом электронной почты, на который этот Переадресатор перенаправляет сообщения и Сигналы.</p><ul><li><p><code>forwarderName : строка</code></p><p>В этом параметре задаётся имя существующего Переадресатора. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="FINDFORWARDERS" tabindex="-1"><code>FINDFORWARDERS domainName TO forwarderAddress</code> <a class="header-anchor" href="#FINDFORWARDERS" aria-label="Permalink to &quot;`FINDFORWARDERS domainName TO forwarderAddress` {#FINDFORWARDERS}&quot;">​</a></h3><p>Используйте эту команду для получения всех Переадресаторов, указывающих на указанный адрес. Эта команда возвращает <em>массив</em> со всеми найденными именами Переадресаторов.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>forwarderAddress : строка</code></p><p>Этот параметр задаёт искомый адрес электронной почты.</p></li></ul><h2 id="NamedTask" tabindex="-1">Управление Именованными Задачами <a class="header-anchor" href="#NamedTask" aria-label="Permalink to &quot;Управление Именованными Задачами {#NamedTask}&quot;">​</a></h2><p>Для использования команд CLI управления Именованными Задачами необходимо иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Сервера или обладать правами на <a href="./../admin/sysadmin/#Domain">Управление Доменом</a>.</p><h3 id="LISTDOMAINNAMEDTASKS" tabindex="-1"><code>LISTDOMAINNAMEDTASKS [ domainName ]</code> <a class="header-anchor" href="#LISTDOMAINNAMEDTASKS" aria-label="Permalink to &quot;`LISTDOMAINNAMEDTASKS [ domainName ]` {#LISTDOMAINNAMEDTASKS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Именованных Задач в Домене. Результатом работы команды является <em>словарь</em>, в котором все ключи - имена Именованных Задач, а значения - словари, содержащие имена владельца задачи, Настоящее Имя задачи и имя Приложения Реального Времени, обслуживающего Именованную Задачу.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="LISTACCOUNTNAMEDTASKS" tabindex="-1"><code>LISTACCOUNTNAMEDTASKS accountName</code> <a class="header-anchor" href="#LISTACCOUNTNAMEDTASKS" aria-label="Permalink to &quot;`LISTACCOUNTNAMEDTASKS accountName` {#LISTACCOUNTNAMEDTASKS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех Именованных Задач, принадлежащих указанному Пользователю. Эта команда возвращает <em>словарь</em> в том же формате, что и команда LISTDOMAINNAMEDTASKS.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя - владельца Именованных Задач.</p></li></ul><h3 id="CREATENAMEDTASK" tabindex="-1"><code>CREATENAMEDTASK taskName FOR accountName</code> <a class="header-anchor" href="#CREATENAMEDTASK" aria-label="Permalink to &quot;`CREATENAMEDTASK taskName FOR accountName` {#CREATENAMEDTASK}&quot;">​</a></h3><p>Используйте эту команду для создания новых Именованных Задач.</p><ul><li><p><code>taskName : строка</code></p><p>Этот параметр задаёт имя новой Именованной Задачи. Имя может содержать символ <code>@</code>, за которым следует имя Домена; в этом случае Именованная Задача создаётся в указанном Домене. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя - владельца Именованной Задачи. Оно не должно содержать символ <code>@</code> и имя Домена, поскольку Пользователь может владеть Именованной Задачей только в том же Домене. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Создание Именованных Задач (CanCreateNamedTasks)</code>.</p></li></ul><h3 id="RENAMENAMEDTASK" tabindex="-1"><code>RENAMENAMEDTASK oldTaskName into newTaskName</code> <a class="header-anchor" href="#RENAMENAMEDTASK" aria-label="Permalink to &quot;`RENAMENAMEDTASK oldTaskName into newTaskName` {#RENAMENAMEDTASK}&quot;">​</a></h3><p>Используйте эту команду для переименования Именованной Задачи.</p><ul><li><p><code>oldTaskName : строка</code></p><p>В этом параметре задаётся имя существующей Именованной Задачи. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newTaskName : строка</code></p><p>Этот параметр задаёт новое имя Именованной Задачи. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Создание Именованных Задач (CanCreateNamedTasks)</code>.</p></li></ul><h3 id="DELETENAMEDTASK" tabindex="-1"><code>DELETENAMEDTASK taskName</code> <a class="header-anchor" href="#DELETENAMEDTASK" aria-label="Permalink to &quot;`DELETENAMEDTASK taskName` {#DELETENAMEDTASK}&quot;">​</a></h3><p>Используйте эту команду для удаления Именованной Задачи.</p><ul><li><p><code>taskName : строка</code></p><p>В этом параметре задаётся имя существующей Именованной Задачи. Имя может включать в себя имя Домена (смотрите выше). Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Создание Именованных Задач (CanCreateNamedTasks)</code>.</p></li></ul><h3 id="GETNAMEDTASK" tabindex="-1"><code>GETNAMEDTASK taskName</code> <a class="header-anchor" href="#GETNAMEDTASK" aria-label="Permalink to &quot;`GETNAMEDTASK taskName` {#GETNAMEDTASK}&quot;">​</a></h3><p>Используйте эту команду для получения установок Именованной Задачи. Эта команда возвращает <em>словарь</em> с установками Именованной Задачи.</p><ul><li><p><code>taskName : строка</code></p><p>В этом параметре задаётся имя существующей Именованной Задачи. Имя может включать в себя имя Домена (смотрите выше).</p></li></ul><h3 id="UPDATENAMEDTASK" tabindex="-1"><code>UPDATENAMEDTASK taskName newSettings</code> <a class="header-anchor" href="#UPDATENAMEDTASK" aria-label="Permalink to &quot;`UPDATENAMEDTASK taskName newSettings` {#UPDATENAMEDTASK}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Именованной Задачи.</p><ul><li><p><code>taskName : строка</code></p><p>В этом параметре задаётся имя существующей Именованной Задачи. Имя может включать в себя имя Домена (смотрите выше).</p></li><li><p><code>newSettings : словарь</code></p><p>Данные этого словаря используются для изменения словаря установок Именованной Задачи. Эта команда может использоваться Администраторами Домена, только если они имеют право доступа <code>Создание Именованных Задач (CanCreateNamedTasks)</code>.</p></li></ul><h2 id="Rights" tabindex="-1">Управление Правами Доступа <a class="header-anchor" href="#Rights" aria-label="Permalink to &quot;Управление Правами Доступа {#Rights}&quot;">​</a></h2><p>Пользователь должен иметь право доступа к Серверу <a href="./../admin/sysadmin/#Privs">Может Всё</a>, чтобы использовать команды CLI для Управления Правами Доступа на Сервер.</p><h3 id="SETACCOUNTRIGHTS" tabindex="-1"><code>SETACCOUNTRIGHTS accountName newRights</code> <a class="header-anchor" href="#SETACCOUNTRIGHTS" aria-label="Permalink to &quot;`SETACCOUNTRIGHTS accountName newRights` {#SETACCOUNTRIGHTS}&quot;">​</a></h3><p>Используйте эту команду для задания Прав Доступа к Серверу для Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Имя может включать в себя имя Домена.</p></li><li><p><code>newRights : массив</code></p><p>Этот массив должен содержать коды Прав Доступа. Все старые права доступа Пользователя при этом удаляются. Для установки прав доступа для Пользователя не из Главного Домена (то есть, для установки Прав на Администрирование Домена) пользователю достаточно иметь только права доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Сервера.</p></li></ul><h2 id="Mailbox" tabindex="-1">Управление Папками <a class="header-anchor" href="#Mailbox" aria-label="Permalink to &quot;Управление Папками {#Mailbox}&quot;">​</a></h2><p>Для использования команд CLI по администрированию Папок, Пользователь должен быть или владельцем папки, или иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a>, или обладать правом доступа <code>Полный доступ ко всем Папкам (CanAccessMailboxes)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p><h3 id="LISTMAILBOXES" tabindex="-1"><code>LISTMAILBOXES accountName [ FILTER filter ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#LISTMAILBOXES" aria-label="Permalink to &quot;`LISTMAILBOXES accountName [ FILTER filter ] [ AUTH authAccountName ]` {#LISTMAILBOXES}&quot;">​</a></h3><p>Используйте эту команду для получения списка Папок Пользователя. Эта команда возвращает <em>словарь</em>. каждый ключ словаря задаёт имя папки;<br> Если пользователь authAccountName не указан или указанный пользователь имеет для этой папки право доступа <code>Входить</code>, то значение ключа содержит <em>словарь</em> с информацией о папке;<br> если указанное authAccountName не имеет права доступа <code>Входить</code>, то значение ключа содержит пустой <em>массив</em>;<br> если есть &quot;папка&quot; с ключом словаря, но нет &quot;обычной&quot; папки с таким именем, то значением ключа будет пустой <em>массив</em>;<br> если есть &quot;папка&quot; с ключом словаря, и также существует &quot;обычная&quot; папка с таким именем, то значением ключа будет <em>массив</em> из одного элемента - информация для &quot;обычной&quot; папки (или словарь, или пустой массив).</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>filter : строка</code></p><p>Этот необязательный параметр задаёт фильтр, применяемый к именам Папок Пользователя. В фильтре могут использоваться те же символы шаблона подстановки <code>*</code> и <code>%</code>, что и в команде LIST протокола IMAP. Если фильтр не указан, то считается, что в качестве фильтра задана строка <code>*</code> и возвращаются все Папки Пользователя.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция LIST. Если это имя задано, ты выводятся только те имена папок, для которых указанный Пользователь имеет право доступа <code>Видеть</code>.</p></li></ul><h3 id="CREATEMAILBOX" tabindex="-1"><code>CREATEMAILBOX accountName MAILBOX mailboxName [ CLASS mailboxClass ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#CREATEMAILBOX" aria-label="Permalink to &quot;`CREATEMAILBOX accountName MAILBOX mailboxName [ CLASS mailboxClass ] [ AUTH authAccountName ]` {#CREATEMAILBOX}&quot;">​</a></h3><p>Используйте эту команду для создания Папки у указанного Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>Этот параметр задаёт имя новой Папки.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена эта операция.</p></li><li><p><code>mailboxClass : строка</code></p><p>Этот необязательный параметр задаёт класс новой Папки</p></li></ul><h3 id="DELETEMAILBOX" tabindex="-1"><code>DELETEMAILBOX accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#DELETEMAILBOX" aria-label="Permalink to &quot;`DELETEMAILBOX accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#DELETEMAILBOX}&quot;">​</a></h3><h3 id="deletemailbox-accountname-mailboxes-mailboxname-auth-authaccountname" tabindex="-1"><code>DELETEMAILBOX accountName MAILBOXES mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#deletemailbox-accountname-mailboxes-mailboxname-auth-authaccountname" aria-label="Permalink to &quot;`DELETEMAILBOX accountName MAILBOXES mailboxName [ AUTH authAccountName ]`&quot;">​</a></h3><p>Используйте эту команду для удаления Папки у указанного Пользователя. Если используется ключевое слово MAILBOXES, то все вложенные папки (подпапки) также будут удалены.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя папки, которая должна быть удалена.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя указано, то папка удаляется, только если указанный Пользователь имеет право доступа <code>Создать</code> для &quot;внешней&quot; папки (это означает, что для того, чтобы удалить папку <code>Archive/March</code> Пользователь должен иметь право доступа <code>Создать</code> для папки <code>Archive</code>), а также указанный Пользователь имеет право <code>Удалить</code> для указанной папки.</p></li></ul><h3 id="RENAMEMAILBOX" tabindex="-1"><code>RENAMEMAILBOX accountName MAILBOX mailboxName INTO newMailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#RENAMEMAILBOX" aria-label="Permalink to &quot;`RENAMEMAILBOX accountName MAILBOX mailboxName INTO newMailboxName [ AUTH authAccountName ]` {#RENAMEMAILBOX}&quot;">​</a></h3><h3 id="renamemailbox-accountname-mailboxes-mailboxname-into-newmailboxname-auth-authaccountname" tabindex="-1"><code>RENAMEMAILBOX accountName MAILBOXES mailboxName INTO newMailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#renamemailbox-accountname-mailboxes-mailboxname-into-newmailboxname-auth-authaccountname" aria-label="Permalink to &quot;`RENAMEMAILBOX accountName MAILBOXES mailboxName INTO newMailboxName [ AUTH authAccountName ]`&quot;">​</a></h3><p>Используйте эту команду для переименования папки у указанного Пользователя. Если используется ключевое слово MAILBOXES, то все вложенные папки также будут переименованы.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя папки, которая должна быть переименована.</p></li><li><p><code>newMailboxName : строка</code></p><p>Этот параметр задаёт новое имя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя указано, то папка переименовывается, только если указанный Пользователь имеет право выполнять операцию DELETEMAILBOX с оригинальной папкой и операцию CREATEMAILBOX с новой папкой (смотрите выше).</p></li></ul><h3 id="GETMAILBOXINFO" tabindex="-1"><code>GETMAILBOXINFO accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETMAILBOXINFO" aria-label="Permalink to &quot;`GETMAILBOXINFO accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#GETMAILBOXINFO}&quot;">​</a></h3><p>Используйте эту команду для получения внутренней информации о Папке Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержится внутренняя информация о папке.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя существующей у указанного Пользователя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя задано, то информация о папке возвращается, только если указанный Пользователь имеет право доступа к папке <code>Входить</code>.</p></li></ul><h3 id="GETMAILBOXACL" tabindex="-1"><code>GETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETMAILBOXACL" aria-label="Permalink to &quot;`GETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ]` {#GETMAILBOXACL}&quot;">​</a></h3><p>Используйте эту команду для получения списка прав доступа к Папке Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся элементы прав доступа к папке.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя существующей у указанного Пользователя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя задано, то информация ACL возвращается, только если указанный Пользователь имеет право доступа к папке <code>Управлять</code>.</p></li></ul><h3 id="SETMAILBOXACL" tabindex="-1"><code>SETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ] newACL</code> <a class="header-anchor" href="#SETMAILBOXACL" aria-label="Permalink to &quot;`SETMAILBOXACL accountName MAILBOX mailboxName [ AUTH authAccountName ] newACL` {#SETMAILBOXACL}&quot;">​</a></h3><p>Используйте эту команду для изменения списка прав доступа к Папке Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя существующей у указанного Пользователя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция. Если это имя задано, то информация ACL изменяется, только если указанный Пользователь имеет право доступа к папке <code>Управлять</code>.</p></li><li><p><code>newACL : словарь</code></p><p>В этом параметре задаются элементы прав доступа, которые должны быть изменены. Каждый ключ словаря задаёт <em>идентификатор</em>, а значения ключей должны быть строками с символами прав доступа. Если значение ключа начинается с символа минус (<code>-</code>), то права доступа, указанные в этой строке, убираются из элемента прав доступа. Если значение ключа начинается с символа плюс (<code>+</code>), то права доступа, указанные в этой строке, добавляются к элементу прав доступа. В других случаях, права доступа, указанные в строке, замещают набор прав в элементе прав доступа. Если элемент права доступа для указанного ключа не существует, то он будет создан. Если новый элемент права доступа имеет пустой набор прав доступа, то элемент удаляется.</p></li></ul><h3 id="GETMAILBOXRIGHTS" tabindex="-1"><code>GETMAILBOXRIGHTS accountName MAILBOX mailboxName AUTH authAccountName</code> <a class="header-anchor" href="#GETMAILBOXRIGHTS" aria-label="Permalink to &quot;`GETMAILBOXRIGHTS accountName MAILBOX mailboxName AUTH authAccountName` {#GETMAILBOXRIGHTS}&quot;">​</a></h3><p>Эта команда возвращает <em>строку</em> с фактически действующими правами доступа к папке для данного authAccountName.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя существующей у указанного Пользователя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот опциональный параметр указывает имя Пользователя, чьи фактические права доступа к папке должны быть получены.</p></li></ul><h3 id="SETMAILBOXCLASS" tabindex="-1"><code>SETMAILBOXCLASS accountName MAILBOX mailboxName [ AUTH authAccountName ] CLASS newClass</code> <a class="header-anchor" href="#SETMAILBOXCLASS" aria-label="Permalink to &quot;`SETMAILBOXCLASS accountName MAILBOX mailboxName [ AUTH authAccountName ] CLASS newClass` {#SETMAILBOXCLASS}&quot;">​</a></h3><p>Используйте эту команду для задания &quot;класса&quot; папки Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>mailboxName : строка</code></p><p>В этом параметре задаётся имя существующей у указанного Пользователя папки.</p></li><li><p><code>authaccountname : строка</code></p><p>Этот опциональный параметр указывает имя Пользователя, чьи права доступа к папке должны быть использованы.</p></li><li><p><code>newClass : строка</code></p><p>Класс папки.</p></li></ul><h3 id="GETMAILBOXSUBSCRIPTION" tabindex="-1"><code>GETMAILBOXSUBSCRIPTION accountName</code> <a class="header-anchor" href="#GETMAILBOXSUBSCRIPTION" aria-label="Permalink to &quot;`GETMAILBOXSUBSCRIPTION accountName` {#GETMAILBOXSUBSCRIPTION}&quot;">​</a></h3><p>Эта команда возвращает <em>массив</em>, в котором содержится список &quot;подписанных папок&quot; Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li></ul><h3 id="SETMAILBOXSUBSCRIPTION" tabindex="-1"><code>SETMAILBOXSUBSCRIPTION accountName newSubscription</code> <a class="header-anchor" href="#SETMAILBOXSUBSCRIPTION" aria-label="Permalink to &quot;`SETMAILBOXSUBSCRIPTION accountName newSubscription` {#SETMAILBOXSUBSCRIPTION}&quot;">​</a></h3><p>Используйте эту команду для задания списка &quot;подписанных папок&quot; Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>newSubscription : массив</code></p><p>Список &quot;подписанных папок&quot;. Каждый элемент массива должен быть <em>строкой</em> с именем папки.</p></li></ul><h3 id="GETMAILBOXALIASES" tabindex="-1"><code>GETMAILBOXALIASES accountName</code> <a class="header-anchor" href="#GETMAILBOXALIASES" aria-label="Permalink to &quot;`GETMAILBOXALIASES accountName` {#GETMAILBOXALIASES}&quot;">​</a></h3><p>Эта команда возвращает <em>словарь</em>. Каждый ключ словаря является именем псевдонима существующей папки, а значение ключа является <em>строкой</em> с именем папки, на которую указывает этот псевдоним.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li></ul><h3 id="SETMAILBOXALIASES" tabindex="-1"><code>SETMAILBOXALIASES accountName newAliases</code> <a class="header-anchor" href="#SETMAILBOXALIASES" aria-label="Permalink to &quot;`SETMAILBOXALIASES accountName newAliases` {#SETMAILBOXALIASES}&quot;">​</a></h3><p>Используйте эту команду для задания Псевдонимов Папок Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>newAliases : словарь</code></p><p>Набор новых псевдонимов папок.</p></li></ul><h2 id="Alert" tabindex="-1">Управление Предупреждениями <a class="header-anchor" href="#Alert" aria-label="Permalink to &quot;Управление Предупреждениями {#Alert}&quot;">​</a></h2><p>Пользователь должен иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Интерфейса Администратора Сервера или право доступа <code>Может публиковать Предупреждения</code> в <a href="./../admin/sysadmin/#Domain">Управлении Доменом</a> для использования команд CLI для управления <a href="./../admin/sysadmin/Alerts.html">Предупреждениями</a>.</p><h3 id="GETDOMAINALERTS" tabindex="-1"><code>GETDOMAINALERTS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINALERTS" aria-label="Permalink to &quot;`GETDOMAINALERTS [ domainName ]` {#GETDOMAINALERTS}&quot;">​</a></h3><p>Используйте эту команду для получения Предупреждений Домена. Эта команда возвращает <em>словарь</em>, в котором содержатся строки с предупреждениями и отметки времени.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя существующего Домена.</p></li></ul><h3 id="SETDOMAINALERTS" tabindex="-1"><code>SETDOMAINALERTS [ domainName ] newAlerts</code> <a class="header-anchor" href="#SETDOMAINALERTS" aria-label="Permalink to &quot;`SETDOMAINALERTS [ domainName ] newAlerts` {#SETDOMAINALERTS}&quot;">​</a></h3><p>Используйте эту команду для изменения предупреждений Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя существующего Домена.</p></li><li><p><code>newAlerts : словарь</code></p><p>Этот словарь используется для замещения словаря предупреждений Домена. Все старые предупреждения Домена при этом удаляются.</p></li></ul><h3 id="POSTDOMAINALERT" tabindex="-1"><code>POSTDOMAINALERT domainName ALERT newAlert</code> <a class="header-anchor" href="#POSTDOMAINALERT" aria-label="Permalink to &quot;`POSTDOMAINALERT domainName ALERT newAlert` {#POSTDOMAINALERT}&quot;">​</a></h3><p>Используйте эту команду для публикации общедоменного предупреждения.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>newAlert : строка</code></p><p>В этой строке указывается текст предупреждения.</p></li></ul><h3 id="REMOVEDOMAINALERT" tabindex="-1"><code>REMOVEDOMAINALERT domainName ALERT timeStamp</code> <a class="header-anchor" href="#REMOVEDOMAINALERT" aria-label="Permalink to &quot;`REMOVEDOMAINALERT domainName ALERT timeStamp` {#REMOVEDOMAINALERT}&quot;">​</a></h3><p>Используйте эту команду для удаления общедоменного предупреждения.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена.</p></li><li><p><code>timeStamp : строка</code></p><p>В этой строке указывается отметка времени Предупреждения, которое должно быть удалено.</p></li></ul><h3 id="GETACCOUNTALERTS" tabindex="-1"><code>GETACCOUNTALERTS accountName</code> <a class="header-anchor" href="#GETACCOUNTALERTS" aria-label="Permalink to &quot;`GETACCOUNTALERTS accountName` {#GETACCOUNTALERTS}&quot;">​</a></h3><p>Используйте эту команду для получения Предупреждений Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся строки с предупреждениями Пользователю и отметки времени.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li></ul><h3 id="SETACCOUNTALERTS" tabindex="-1"><code>SETACCOUNTALERTS accountName newAlerts</code> <a class="header-anchor" href="#SETACCOUNTALERTS" aria-label="Permalink to &quot;`SETACCOUNTALERTS accountName newAlerts` {#SETACCOUNTALERTS}&quot;">​</a></h3><p>Используйте эту команду для изменения предупреждений Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>newAlerts : словарь</code></p><p>Этот словарь используется для замещения словаря предупреждений Пользователя. Все старые предупреждения Пользователя при этом удаляются.</p></li></ul><h3 id="POSTACCOUNTALERT" tabindex="-1"><code>POSTACCOUNTALERT accountName ALERT newAlert</code> <a class="header-anchor" href="#POSTACCOUNTALERT" aria-label="Permalink to &quot;`POSTACCOUNTALERT accountName ALERT newAlert` {#POSTACCOUNTALERT}&quot;">​</a></h3><p>Используйте эту команду для публикации предупреждения Пользователю.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>newAlert : строка</code></p><p>В этой строке указывается текст предупреждения.</p></li></ul><h3 id="REMOVEACCOUNTALERT" tabindex="-1"><code>REMOVEACCOUNTALERT accountName ALERT timeStamp</code> <a class="header-anchor" href="#REMOVEACCOUNTALERT" aria-label="Permalink to &quot;`REMOVEACCOUNTALERT accountName ALERT timeStamp` {#REMOVEACCOUNTALERT}&quot;">​</a></h3><p>Используйте эту команду для удаления предупреждения Пользователю.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>timeStamp : строка</code></p><p>В этой строке указывается отметка времени Предупреждения, которое должно быть удалено.</p></li></ul><p>Следующие команды доступны только Администраторам Системы:</p><h3 id="GETSERVERALERTS" tabindex="-1"><code>GETSERVERALERTS</code> <a class="header-anchor" href="#GETSERVERALERTS" aria-label="Permalink to &quot;`GETSERVERALERTS` {#GETSERVERALERTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка общесерверных Предупреждений. Эта команда возвращает <em>словарь</em>, в котором содержатся строки с предупреждениями сервера и отметки времени.</p><h3 id="SETSERVERALERTS" tabindex="-1"><code>SETSERVERALERTS newAlerts</code> <a class="header-anchor" href="#SETSERVERALERTS" aria-label="Permalink to &quot;`SETSERVERALERTS newAlerts` {#SETSERVERALERTS}&quot;">​</a></h3><p>Используйте эту команду для изменения общесерверных Предупреждений.</p><ul><li><p><code>newAlerts : словарь</code></p><p>Этот словарь используется для замещения общесерверного словаря предупреждений. Все старые общесерверные предупреждения при этом удаляются.</p></li></ul><h3 id="POSTSERVERALERT" tabindex="-1"><code>POSTSERVERALERT newAlert</code> <a class="header-anchor" href="#POSTSERVERALERT" aria-label="Permalink to &quot;`POSTSERVERALERT newAlert` {#POSTSERVERALERT}&quot;">​</a></h3><p>Используйте эту команду для публикации общесерверного Предупреждения.</p><ul><li><p><code>newAlert : строка</code></p><p>В этой строке указывается текст предупреждения.</p></li></ul><h3 id="REMOVESERVERALERT" tabindex="-1"><code>REMOVESERVERALERT timeStamp</code> <a class="header-anchor" href="#REMOVESERVERALERT" aria-label="Permalink to &quot;`REMOVESERVERALERT timeStamp` {#REMOVESERVERALERT}&quot;">​</a></h3><p>Используйте эту команду для удаления общесерверного предупреждения.</p><ul><li><p><code>timeStamp : строка</code></p><p>В этой строке указывается отметка времени Предупреждения, которое должно быть удалено.</p></li></ul><h3 id="GETCLUSTERALERTS" tabindex="-1"><code>GETCLUSTERALERTS</code> <a class="header-anchor" href="#GETCLUSTERALERTS" aria-label="Permalink to &quot;`GETCLUSTERALERTS` {#GETCLUSTERALERTS}&quot;">​</a></h3><h3 id="SETCLUSTERALERTS" tabindex="-1"><code>SETCLUSTERALERTS newAlerts</code> <a class="header-anchor" href="#SETCLUSTERALERTS" aria-label="Permalink to &quot;`SETCLUSTERALERTS newAlerts` {#SETCLUSTERALERTS}&quot;">​</a></h3><h3 id="POSTCLUSTERALERT" tabindex="-1"><code>POSTCLUSTERALERT newAlert</code> <a class="header-anchor" href="#POSTCLUSTERALERT" aria-label="Permalink to &quot;`POSTCLUSTERALERT newAlert` {#POSTCLUSTERALERT}&quot;">​</a></h3><h3 id="REMOVECLUSTERALERT" tabindex="-1"><code>REMOVECLUSTERALERT timeStamp</code> <a class="header-anchor" href="#REMOVECLUSTERALERT" aria-label="Permalink to &quot;`REMOVECLUSTERALERT timeStamp` {#REMOVECLUSTERALERT}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>GET</code>|<code>SET</code>|<code>POST</code>|<code>REMOVE</code>]<code>SERVERALERT</code>[<code>S</code>] для работы с общекластерными Предупреждениями.</p><h2 id="управление-настроиками-расширении-free-busy" tabindex="-1">Управление настройками расширений Free/Busy <a class="header-anchor" href="#управление-настроиками-расширении-free-busy" aria-label="Permalink to &quot;Управление настройками расширений Free/Busy&quot;">​</a></h2><p>Пользователь должен иметь права доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Интерфейса Администратора Сервера или права доступа <code>Может изменять настройки получения информации о занятости участников</code> в <a href="./../admin/sysadmin/#Domain">Управлении Доменом</a> для использования команд CLI для управления <a href="./../admin/misc/Calendars.html#FreeBusy">настройками получения информации занятости</a>.</p><h3 id="GETDOMAINFREEBUSY" tabindex="-1"><code>GETDOMAINFREEBUSY [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINFREEBUSY" aria-label="Permalink to &quot;`GETDOMAINFREEBUSY [ domainName ]` {#GETDOMAINFREEBUSY}&quot;">​</a></h3><p>Используйте эту команду для получения настроек занятости участников Домена. Эта команда возвращает <em>словарь</em>, в котором содержатся настройки записей Free/Busy домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя существующего Домена.</p></li></ul><h3 id="SETDOMAINFREEBUSY" tabindex="-1"><code>SETDOMAINFREEBUSY [ domainName ] newFreeBusy</code> <a class="header-anchor" href="#SETDOMAINFREEBUSY" aria-label="Permalink to &quot;`SETDOMAINFREEBUSY [ domainName ] newFreeBusy` {#SETDOMAINFREEBUSY}&quot;">​</a></h3><p>Используйте эту команду для изменения настроек занятости участников Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя существующего Домена.</p></li><li><p><code>newFreeBusy : словарь</code></p><p>Этот словарь используется для замещения настроек занятости участников Домена. Все старые настройки занятости участников Домена при этом удаляются.</p></li></ul><h2 id="управление-настроиками-расширении" tabindex="-1">Управление настройками расширений <a class="header-anchor" href="#управление-настроиками-расширении" aria-label="Permalink to &quot;Управление настройками расширений&quot;">​</a></h2><p>Пользователь должен иметь права доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Интерфейса Администратора Сервера или права доступа <code>Может изменять настройки расширений</code> в <a href="./../admin/sysadmin/#Domain">Управлении Доменом</a> для использования команд CLI для настройки расширений.</p><h3 id="GETDOMAINPLUGINSSETTINGS" tabindex="-1"><code>GETDOMAINPLUGINSSETTINGS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINPLUGINSSETTINGS" aria-label="Permalink to &quot;`GETDOMAINPLUGINSSETTINGS [ domainName ]` {#GETDOMAINPLUGINSSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения настроек расширений домена. Эта команда возвращает <em>словарь</em>, в котором содержатся настройки расширений (Plugins) домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя существующего Домена.</p></li></ul><h3 id="SETDOMAINPLUGINSSETTINGS" tabindex="-1"><code>SETDOMAINPLUGINSSETTINGS [ domainName ] newSettings</code> <a class="header-anchor" href="#SETDOMAINPLUGINSSETTINGS" aria-label="Permalink to &quot;`SETDOMAINPLUGINSSETTINGS [ domainName ] newSettings` {#SETDOMAINPLUGINSSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения настроек расширений Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя существующего Домена.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для замещения настроек расширений домена. Все старые настройки расширений домена при этом удаляются.</p></li></ul><h2 id="WebSite" tabindex="-1">Управление Хранилищем Файлов <a class="header-anchor" href="#WebSite" aria-label="Permalink to &quot;Управление Хранилищем Файлов {#WebSite}&quot;">​</a></h2><p>Следующие команды позволяют аутентифицированному пользователю работать с файлами в <a href="./../admin/storage/FileStore.html">Хранилище Файлов</a> Пользователя. Для доступа к Хранилищу Файлов:</p><ul><li>аутентифицированный пользователь должен быть владельцем хранилища, или</li><li>у аутентифицированного пользователя должно быть право доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> интерфейса Администратора Сервера или право <code>Доступ к Хранилищам Файлов (CanAccessWebSites)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>, или</li><li>аутентифицированному пользователю должны быть даны <a href="./../admin/storage/FileStore.html#ACL">Права Доступа к Файлам</a> для указанных файлов иди директорий (только если не указан параметр <code>AUTH</code>)</li></ul><p>Если имя файла заканчивается символом косая черта (<code>/</code>), то оно обозначает имя файловой директории.</p><h3 id="READSTORAGEFILE" tabindex="-1"><code>READSTORAGEFILE accountName FILE fileName [ OFFSET position ] [ SIZE sliceSize ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#READSTORAGEFILE" aria-label="Permalink to &quot;`READSTORAGEFILE accountName FILE fileName [ OFFSET position ] [ SIZE sliceSize ] [ AUTH authAccountName ]` {#READSTORAGEFILE}&quot;">​</a></h3><p>Используйте эту команду для получения файла из Хранилища Файлов Пользователя. Эта команда возвращает <em>массив</em> из трёх элементов. Первым элементом массива является <em>блок данных</em> с содержанием указанного файла, вторым элементом массива является отметка времени модификации файла и третьим элементом массива является текущий размер файла.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>fileName : строка</code></p><p>Этот параметр задаёт имя файла, которое необходимо получить из Хранилища Файлов.</p></li><li><p><code>position : число</code></p><p>Если задан этот параметр, то файл в Хранилище Файлов читается, начиная с указанной позиции в файле.</p></li><li><p><code>sliceSize : число</code></p><p>Если задан этот параметр, то будет прочитано не более чем указанное число байт данных файла.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="WRITESTORAGEFILE" tabindex="-1"><code>WRITESTORAGEFILE accountName FILE fileName [ OFFSET position ] [ AUTH authAccountName ] DATA fileData</code> <a class="header-anchor" href="#WRITESTORAGEFILE" aria-label="Permalink to &quot;`WRITESTORAGEFILE accountName FILE fileName [ OFFSET position ] [ AUTH authAccountName ] DATA fileData` {#WRITESTORAGEFILE}&quot;">​</a></h3><p>Используйте эту команду для сохранения файла в Хранилище Файлов Пользователя. Если в Хранилище Файлов файл с указанным именем уже существует, то старый файл удаляется. Если <em>fileName</em> указывает на директорию (оканчивается символом косая черта <code>/</code>), то команда создаёт директорию. В этом случае, часть OFFSET <em>position</em> должна отсутствовать, а параметр <em>fileData</em> должен быть пустым блоком данных.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>fileName : строка</code></p><p>Этот параметр задаёт имя файла в Хранилище Файлов.</p></li><li><p><code>position : смещение</code></p><p>Если этот параметр отсутствует или его значение равно нулю, то существующий файл (если он есть) сначала удаляется, а затем создаётся новый. Если этот параметр - неравное нулю число, то его значение должно быть положительным; файл в Хранилище Файлов перезаписывается/дополняется, начиная с указанной позиции в файле. Файл должен существовать, и указанная позиция не должна быть больше, чем текущий размер файла. Если этот параметр имеет значение <code>BEG</code>, то файл уже должен существовать; файл перезаписывается с начала, но его старые данные, находящиеся за пределами данных в fileData, не удаляются. Если эта опция имеет значение <code>END</code>, то данные fileData добавляются к концу файла. Если файл не существует, то он создаётся. Если эта опция имеет значение <code>NEW</code>, то файл не должен существовать; новый файл создаётся и данные из fileData записываются в него.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li><li><p><code>fileData : блок данных</code></p><p>В этом параметре содержатся данные файла.</p></li></ul><h3 id="RENAMESTORAGEFILE" tabindex="-1"><code>RENAMESTORAGEFILE accountName FILE oldFileName INTO newFileName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#RENAMESTORAGEFILE" aria-label="Permalink to &quot;`RENAMESTORAGEFILE accountName FILE oldFileName INTO newFileName [ AUTH authAccountName ]` {#RENAMESTORAGEFILE}&quot;">​</a></h3><p>Используйте эту команду для переименования файла или файловой директории в Хранилище Файлов Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>oldFileName : строка</code></p><p>В этом параметре задаётся имя существующего файла или файловой директории в Хранилище Файлов.</p></li><li><p><code>newFileName : строка</code></p><p>Этот параметр задаёт новое имя файла или файловой директории в Хранилище Файлов.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="DELETESTORAGEFILE" tabindex="-1"><code>DELETESTORAGEFILE accountName FILE fileName [ AUTH authAccountName ]</code> <a class="header-anchor" href="#DELETESTORAGEFILE" aria-label="Permalink to &quot;`DELETESTORAGEFILE accountName FILE fileName [ AUTH authAccountName ]` {#DELETESTORAGEFILE}&quot;">​</a></h3><p>Используйте эту команду для удаления файла или файловой директории из Хранилища Файлов Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя существующего файла или файловой директории в Хранилище Файлов.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="LISTSTORAGEFILES" tabindex="-1"><code>LISTSTORAGEFILES accountName [ PATH filePath ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#LISTSTORAGEFILES" aria-label="Permalink to &quot;`LISTSTORAGEFILES accountName [ PATH filePath ] [ AUTH authAccountName ]` {#LISTSTORAGEFILES}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех файлов в верхней директории Хранилища Файлов или в одной из его поддиректорий. Эта команда возвращает <em>словарь</em>, где каждый ключ является именем файла из Хранилища Файлов, а значением ключа является <em>словарь</em> для обычного файла и пустой <em>массив</em> для поддиректорий.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>filePath : строка</code></p><p>Этот необязательный параметр указывает имя поддиректории в Хранилище Файлов. Вы можете опустить этот параметр вместе с ключевым словом PATH, в этом случае команда возвращает список файлов в верхней директории Хранилища Файлов.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="GETSTORAGEFILEINFO" tabindex="-1"><code>GETSTORAGEFILEINFO accountName [ PATH filePath ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#GETSTORAGEFILEINFO" aria-label="Permalink to &quot;`GETSTORAGEFILEINFO accountName [ PATH filePath ] [ AUTH authAccountName ]` {#GETSTORAGEFILEINFO}&quot;">​</a></h3><p>Используйте эту команду для получения статистической информации обо всех файлах, находящихся в Хранилище Файлов Пользователя. Эта команда возвращает <em>массив</em> с двумя <em>числовыми</em> элементами. Первый элемент содержит общий размер всех файлов, находящихся в Хранилище Файлов, а второй элемент содержит число файлов, находящихся в Хранилище Файлов.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="READSTORAGEFILEATTR" tabindex="-1"><code>READSTORAGEFILEATTR accountName FILE fileName [ attributes ] [ AUTH authAccountName ]</code> <a class="header-anchor" href="#READSTORAGEFILEATTR" aria-label="Permalink to &quot;`READSTORAGEFILEATTR accountName FILE fileName [ attributes ] [ AUTH authAccountName ]` {#READSTORAGEFILEATTR}&quot;">​</a></h3><p>Эта функция читает атрибуты файла или директории fileName в Хранилище Файлов Пользователя. Эта команда возвращает <em>массив</em> из элементов XML с атрибутами файла или файловой директории.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя существующего файла или файловой директории в Хранилище Файлов.</p></li><li><p><code>attributes : массив</code></p><p>Необязательный параметр с массивом строк. Если указан, то только читаются значения только атрибутов с именами из этого массива.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="UPDATESTORAGEFILEATTR" tabindex="-1"><code>UPDATESTORAGEFILEATTR accountName FILE fileName attributes [ AUTH authAccountName ]</code> <a class="header-anchor" href="#UPDATESTORAGEFILEATTR" aria-label="Permalink to &quot;`UPDATESTORAGEFILEATTR accountName FILE fileName attributes [ AUTH authAccountName ]` {#UPDATESTORAGEFILEATTR}&quot;">​</a></h3><p>Эта функция читает атрибуты файла или директории fileName в Хранилище Файлов Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя существующего файла или файловой директории в Хранилище Файлов.</p></li><li><p><code>attributes : массив</code></p><p>Параметр задаёт массив элементов XML - новых значений атрибутов.</p></li><li><p><code>authAccountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, от имени которого должна быть произведена операция.</p></li></ul><h3 id="GETFILESUBSCRIPTION" tabindex="-1"><code>GETFILESUBSCRIPTION accountName</code> <a class="header-anchor" href="#GETFILESUBSCRIPTION" aria-label="Permalink to &quot;`GETFILESUBSCRIPTION accountName` {#GETFILESUBSCRIPTION}&quot;">​</a></h3><p>Эта команда возвращает <em>массив</em> со списком &quot;подписанных папок&quot; Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li></ul><h3 id="SETFILESUBSCRIPTION" tabindex="-1"><code>SETFILESUBSCRIPTION accountName newSubscription</code> <a class="header-anchor" href="#SETFILESUBSCRIPTION" aria-label="Permalink to &quot;`SETFILESUBSCRIPTION accountName newSubscription` {#SETFILESUBSCRIPTION}&quot;">​</a></h3><p>Используйте эту команду для задания списка &quot;подписанных папок&quot; Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>newSubscription : массив</code></p><p>Список &quot;подписанных папок&quot;. Каждый элемент массива должен быть <em>строкой</em> с именем папки.</p></li></ul><h2 id="Lists" tabindex="-1">Управление Списками Рассылки <a class="header-anchor" href="#Lists" aria-label="Permalink to &quot;Управление Списками Рассылки {#Lists}&quot;">​</a></h2><p>Для использования команд CLI Управления Списками Рассылки необходимо иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Все Домены</a> Интерфейса Администратора Сервера или обладать правами для <a href="./../admin/sysadmin/#Domain">Управления Доменом</a>.</p><h3 id="LISTLISTS" tabindex="-1"><code>LISTLISTS [ domainName ]</code> <a class="header-anchor" href="#LISTLISTS" aria-label="Permalink to &quot;`LISTLISTS [ domainName ]` {#LISTLISTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка Списков Рассылки Домена. Эта команда возвращает <em>массив</em> строк. Каждая строка является именем списка рассылки в указанном (или в выбранном по умолчанию) Домене.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена.</p></li></ul><h3 id="GETDOMAINLISTS" tabindex="-1"><code>GETDOMAINLISTS [ domainName ]</code> <a class="header-anchor" href="#GETDOMAINLISTS" aria-label="Permalink to &quot;`GETDOMAINLISTS [ domainName ]` {#GETDOMAINLISTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка Списков Рассылки Домена. Эта команда возвращает <em>словарь.</em> Каждый ключ словаря является именем списка рассылки в указанном (или в выбранном по умолчанию) Домене. Значением ключа является числовая строка с фактическим числом подписчиков списка (&quot;-1&quot;, если текущее число подписчиков списка неизвестно).</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена.</p></li></ul><h3 id="GETACCOUNTLISTS" tabindex="-1"><code>GETACCOUNTLISTS accountName</code> <a class="header-anchor" href="#GETACCOUNTLISTS" aria-label="Permalink to &quot;`GETACCOUNTLISTS accountName` {#GETACCOUNTLISTS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех списков рассылки, принадлежащих указанному Пользователю. Эта команда возвращает <em>словарь.</em> Каждый ключ словаря является именем списка рассылки, принадлежащего указанному (или выбранному по умолчанию) Пользователю. Значением ключа является числовая строка с фактическим числом подписчиков списка (&quot;-1&quot;, если текущее число подписчиков списка неизвестно).</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя - владельца списка.</p></li></ul><h3 id="CREATELIST" tabindex="-1"><code>CREATELIST listName for accountName</code> <a class="header-anchor" href="#CREATELIST" aria-label="Permalink to &quot;`CREATELIST listName for accountName` {#CREATELIST}&quot;">​</a></h3><p>Используйте эту команду для создания списка рассылки.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя создаваемого списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя владельца списка рассылки (без имени Домена). Оно должно быть именем уже существующего Пользователя из Домена списка рассылки. Эта команда может использоваться Администраторами Домена, только если у них есть право доступа &quot;Может создавать Списки Рассылки (CanCreateLists)&quot;.</p></li></ul><h3 id="RENAMELIST" tabindex="-1"><code>RENAMELIST listName into newName</code> <a class="header-anchor" href="#RENAMELIST" aria-label="Permalink to &quot;`RENAMELIST listName into newName` {#RENAMELIST}&quot;">​</a></h3><p>Используйте эту команду для переименования списка рассылки.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>newName : строка</code></p><p>Этот параметр задаёт новое имя списка рассылки (без доменной части). Эта команда может использоваться Администраторами Домена, только если у них есть право доступа &quot;Может создавать Списки Рассылки (CanCreateLists)&quot;.</p></li></ul><h3 id="DELETELIST" tabindex="-1"><code>DELETELIST listName</code> <a class="header-anchor" href="#DELETELIST" aria-label="Permalink to &quot;`DELETELIST listName` {#DELETELIST}&quot;">​</a></h3><p>Используйте эту команду для удаления списка рассылки.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя. Эта команда может использоваться Администраторами Домена, только если у них есть право доступа &quot;Может создавать Списки Рассылки (CanCreateLists)&quot;.</p></li></ul><p>Следующие команды могут использоваться владельцем списка рассылки, Администратором Домена с правом доступа &quot;Полный доступ ко всем Спискам (CanAccessLists )&quot; или Администратором Сервера с правами <a href="./../admin/sysadmin/#Privs">Все Домены</a>.</p><h3 id="GETLIST" tabindex="-1"><code>GETLIST listName</code> <a class="header-anchor" href="#GETLIST" aria-label="Permalink to &quot;`GETLIST listName` {#GETLIST}&quot;">​</a></h3><p>Используйте эту команду для получения установок списка. Эта команда возвращает <em>словарь</em>, в котором содержатся установки списка listName.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li></ul><h3 id="UPDATELIST" tabindex="-1"><code>UPDATELIST listName newSettings</code> <a class="header-anchor" href="#UPDATELIST" aria-label="Permalink to &quot;`UPDATELIST listName newSettings` {#UPDATELIST}&quot;">​</a></h3><p>Используйте эту команду для изменения установок списка.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря установок списка рассылки. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены.</p></li></ul><h3 id="LIST" tabindex="-1"><code>LIST listName operation [silently] [confirm] subscriber</code> <a class="header-anchor" href="#LIST" aria-label="Permalink to &quot;`LIST listName operation [silently] [confirm] subscriber` {#LIST}&quot;">​</a></h3><p>Используйте эту команду для изменения списка подписчиков.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>operation : subscribe | feed | digest | index | null | banned | unsubscribe</code></p><p>Этот параметр задаёт операцию (дополнительную информацию смотрите в разделе <a href="./../admin/mail/LIST.html">модуль LIST</a>).</p></li><li><p><code>silently</code></p><p>Этот необязательный параметр указывает серверу не отправлять подписчику Приветственное/Прощальное Письмо.</p></li><li><p><code>confirm</code></p><p>Этот необязательный параметр указывает серверу не отправлять подписчику запрос на подтверждение.</p></li><li><p><code>subscriber : адрес E-mail</code></p><p>Адрес подписчика. Он может включать в себя <em>комментарий</em>, используемый как настоящее имя подписчика. Пример:</p></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>LIST MyList@mydomain.com FEED confirm &quot;Bill Jones&quot; &lt;BJones@company.com&gt;</span></span></code></pre></div><h3 id="LISTSUBSCRIBERS" tabindex="-1"><code>LISTSUBSCRIBERS listName [ FILTER filter [ limit ] ]</code> <a class="header-anchor" href="#LISTSUBSCRIBERS" aria-label="Permalink to &quot;`LISTSUBSCRIBERS listName [ FILTER filter [ limit ] ]` {#LISTSUBSCRIBERS}&quot;">​</a></h3><p>Используйте эту команду для получения списка подписчиков. Эта команда возвращает <em>массив</em> с адресами электронной почты подписчиков.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>filter : строка</code></p><p>Если этот необязательный параметр указан, то возвращаются только адреса, в которых содержится указанная строка.</p></li><li><p><code>limit : число</code></p><p>Этот необязательный параметр ограничивает число возвращаемых адресов подписчиков.</p></li></ul><h3 id="READSUBSCRIBERS" tabindex="-1"><code>READSUBSCRIBERS listName [ FILTER filter [ limit ] ]</code> <a class="header-anchor" href="#READSUBSCRIBERS" aria-label="Permalink to &quot;`READSUBSCRIBERS listName [ FILTER filter [ limit ] ]` {#READSUBSCRIBERS}&quot;">​</a></h3><p>Используйте эту команду для получения списка подписчиков. Эта команда возвращает <em>массив</em>, первый элемент которого - полное число подписчиков списка, а второй элемент - массив словарей, описывающих подписчиков.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Он может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>filter : строка</code></p><p>Если этот необязательный параметр указан, то возвращаются только подписчики, в адресах которых содержится указанная строка.</p></li><li><p><code>limit : число</code></p><p>Этот необязательный параметр ограничивает число возвращаемых описателей подписчиков.</p></li></ul><p>Словарь, описывающий подписчика, состоит из следующих элементов:</p><ul><li><p><code>Sub</code></p><p>Строка с адресом электронной почты</p></li><li><p><code>RealName</code></p><p>необязательная строка с Настоящим Именем</p></li><li><p><code>mode</code></p><p>срока с режимом подписки (index, digest, null и т.д.)</p></li><li><p><code>subscribeTime</code></p><p>отметка времени подписки пользователя.</p></li><li><p><code>posts</code></p><p>число публикаций в этом списке</p></li><li><p><code>lastBounceTime</code></p><p>необязательная отметка времени последней ошибки при отправке сообщения этому пользователю.</p></li><li><p><code>bounces</code></p><p>необязательное число уведомлений об ошибках доставки сообщения этому подписчику.</p></li></ul><h3 id="GETSUBSCRIBERINFO" tabindex="-1"><code>GETSUBSCRIBERINFO listName NAME subscriberAddress</code> <a class="header-anchor" href="#GETSUBSCRIBERINFO" aria-label="Permalink to &quot;`GETSUBSCRIBERINFO listName NAME subscriberAddress` {#GETSUBSCRIBERINFO}&quot;">​</a></h3><p>Используйте эту команду для получения информации о подписчике списка. Эта команда возвращает <em>словарь</em> с информацией о подписчике.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Оно может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>subscriberAddress : строка</code></p><p>В этом параметре задаётся адрес электронной почты подписчика списка. Если подписчик не существует, то возвращается пустой словарь. В противном случае словарь содержит следующие элементы:</p></li><li><p><code>mode</code></p><p>Эта строка определяет режим подписки (<code>digest</code>, <code>index</code> и т.д.) Этот элемент равен <code>unsubcribe</code>, если подписка для адреса была отменена, но адрес ещё не был удалён из списка. Этот элемент равен <code>subscribe</code>, если пользователь начал процесс подписки, но подписка не была подтверждена.</p></li><li><p><code>confirmationID</code></p><p>В этом элементе содержится строка с Идентификатором Подтверждения для Пользователя.</p></li><li><p><code>timeSubscribed</code></p><p>Эта строка указывает время подписки адреса (в формате даты/времени ACAP).</p></li><li><p><code>posts</code></p><p>Этот элемент может содержать строки <code>special</code>, <code>moderateAll</code>, <code>prohibited</code> или строку с числом сообщений, опубликованных с этого адреса. Если следующая публикация с этого адреса должна модерироваться, то элемент содержит массив одностроковых элементов, содержащих число модерируемых публикаций.</p></li><li><p><code>bounces</code></p><p>Эта необязательная строка содержит число ошибок, полученных при отправке сообщений на этот адрес.</p></li><li><p><code>lastBounced</code></p><p>Эта необязательная строка указывает время последней ошибки, связанной с этим адресом. Время указано в формате ACAP.</p></li><li><p><code>RealName</code></p><p>Эта необязательная строка содержит настоящее имя подписчика.</p></li></ul><h3 id="SETPOSTINGMODE" tabindex="-1"><code>SETPOSTINGMODE listName FOR subscriberAddress [ UNMODERATED | MODERATEALL | PROHIBITED | SPECIAL | numberOfModerated ]</code> <a class="header-anchor" href="#SETPOSTINGMODE" aria-label="Permalink to &quot;`SETPOSTINGMODE listName FOR subscriberAddress [ UNMODERATED | MODERATEALL | PROHIBITED | SPECIAL | numberOfModerated ]` {#SETPOSTINGMODE}&quot;">​</a></h3><p>Используйте эту команду для задания режима публикации для указанного подписчика.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Оно может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>subscriberAddress : строка</code></p><p>В этом параметре задаётся адрес электронной почты подписчика списка.</p></li><li><p><code>postingMode : число</code></p><p>Этот необязательный параметр ограничивает число возвращаемых адресов подписчиков. Эта команда задаёт для указанного подписчика режим публикации. Если указано <em>numberOfModerated</em> (число), то режим публикации задаёт необходимость модерирования первых numberOfModerated сообщений от этого подписчика.</p></li></ul><h3 id="PROCESSBOUNCE" tabindex="-1"><code>PROCESSBOUNCE listName [ FATAL ] FOR subscriberAddress</code> <a class="header-anchor" href="#PROCESSBOUNCE" aria-label="Permalink to &quot;`PROCESSBOUNCE listName [ FATAL ] FOR subscriberAddress` {#PROCESSBOUNCE}&quot;">​</a></h3><p>Используйте эту команду для выполнения действий, выполняемых Менеджером Списка при получении ошибки от адреса подписчика.</p><ul><li><p><code>listName : строка</code></p><p>В этом параметре задаётся имя существующего списка рассылки. Оно может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется Домен пользователя.</p></li><li><p><code>subscriberAddress : строка</code></p><p>В этом параметре задаётся адрес электронной почты подписчика списка. Используйте ключевое слово <code>FATAL</code> для имитации &quot;фатальной&quot; ошибки. В противном случае команда будет имитировать нефатальную ошибку.</p></li></ul><h2 id="WebSkin" tabindex="-1">Управление Видами Веб Интерфейса <a class="header-anchor" href="#WebSkin" aria-label="Permalink to &quot;Управление Видами Веб Интерфейса {#WebSkin}&quot;">​</a></h2><p>Следующие команды могут использоваться для управления <a href="./WebApp.html">Видом Интерфейса</a> Веб Интерфейса Пользователя CommuniGate Pro.</p><p>Чтобы иметь возможность изменения Видов Интефейса Домена, у пользователя должно быть право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> или право доступа <code>Может модифицировать Виды Интерфейса (CanModifySkins)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p><h3 id="LISTDOMAINSKINS" tabindex="-1"><code>LISTDOMAINSKINS [ domainName ]</code> <a class="header-anchor" href="#LISTDOMAINSKINS" aria-label="Permalink to &quot;`LISTDOMAINSKINS [ domainName ]` {#LISTDOMAINSKINS}&quot;">​</a></h3><p>Используйте эту команду для получения списка пользовательских Видов Интерфейса Домена. Эта команда возвращает <em>массив</em> с именами Видов Интерфейса.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li></ul><h3 id="CREATEDOMAINSKIN" tabindex="-1"><code>CREATEDOMAINSKIN [ domainName SKIN ] skinName</code> <a class="header-anchor" href="#CREATEDOMAINSKIN" aria-label="Permalink to &quot;`CREATEDOMAINSKIN [ domainName SKIN ] skinName` {#CREATEDOMAINSKIN}&quot;">​</a></h3><p>Используйте эту команду для создания пользовательского Вида Интерфейса Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя нового Вида Интерфейса. Для того, чтобы создать Безымянный Вид Интерфейса Домена, в параметре <em>skinName</em> укажите пустую строку. Именованный Вид Интерфейса Домена может быть создан только если Безымянный Вид Интерфейса уже существует.</p></li></ul><h3 id="RENAMEDOMAINSKIN" tabindex="-1"><code>RENAMEDOMAINSKIN [ domainName SKIN ] skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMEDOMAINSKIN" aria-label="Permalink to &quot;`RENAMEDOMAINSKIN [ domainName SKIN ] skinName INTO newSkinName` {#RENAMEDOMAINSKIN}&quot;">​</a></h3><p>Используйте эту команду для переименования пользовательского именованного Вида Интерфейса Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего именованного Вида Интерфейса Домена.</p></li><li><p><code>newSkinName : строка</code></p><p>Этот параметр задаёт новое имя Вида Интерфейса.</p></li></ul><h3 id="DELETEDOMAINSKIN" tabindex="-1"><code>DELETEDOMAINSKIN [ domainName SKIN ] skinName</code> <a class="header-anchor" href="#DELETEDOMAINSKIN" aria-label="Permalink to &quot;`DELETEDOMAINSKIN [ domainName SKIN ] skinName` {#DELETEDOMAINSKIN}&quot;">​</a></h3><p>Используйте эту команду для удаления пользовательского Вида Интерфейса Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя Вида Интерфейса, который должен быть удалён. Для удаления именованного Вида Интерфейса Домена в значении параметра <em>skinName</em> укажите пустую строку. Безымянный Вид Интерфейса Домена может быть удалён, только если в Домене не осталось именованных Видов Интерфейса.</p></li></ul><h3 id="LISTDOMAINSKINFILES`" tabindex="-1"><code>LISTDOMAINSKINFILES</code> [ <code>domainName SKIN</code>] <code>skinName</code> <a class="header-anchor" href="#LISTDOMAINSKINFILES`" aria-label="Permalink to &quot;`LISTDOMAINSKINFILES` \\[ `domainName SKIN`\\] `skinName` {#LISTDOMAINSKINFILES`}&quot;">​</a></h3><p>Используйте эту команду для получения списков файлов из Пользовательского Вида Интерфейса Домена. Эта команда возвращает <em>словарь</em>, в ключах которого содержатся имена файлов Вида Интерфейса. Значением элементов словаря являются словари с атрибутами файлов.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Домена.</p></li></ul><h3 id="READDOMAINSKINFILE`" tabindex="-1"><code>READDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName</code> <a class="header-anchor" href="#READDOMAINSKINFILE`" aria-label="Permalink to &quot;`READDOMAINSKINFILE` \\[ `domainName SKIN` \\] `skinName FILE fileName` {#READDOMAINSKINFILE`}&quot;">​</a></h3><p>Используйте эту команду для чтения файла из пользовательского Вида Интерфейса Домена. Эта команда возвращает <em>массив</em>. Первым элементом массива является блок данных с содержанием файла Вида Интерфейса, вторым элементом массива является отметка времени с датой изменения файла.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Домена.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя существующего файла указанного Вида Интерфейса Домена.</p></li></ul><h3 id="STOREDOMAINSKINFILE" tabindex="-1"><code>STOREDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STOREDOMAINSKINFILE" aria-label="Permalink to &quot;`STOREDOMAINSKINFILE` \\[ `domainName SKIN` \\] `skinName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STOREDOMAINSKINFILE}&quot;">​</a></h3><h3 id="storedomainskinfile-domainname-skin-skinname-file-filename-delete" tabindex="-1"><code>STOREDOMAINSKINFILE</code> [ <code>domainName SKIN</code> ] <code>skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storedomainskinfile-domainname-skin-skinname-file-filename-delete" aria-label="Permalink to &quot;`STOREDOMAINSKINFILE` \\[ `domainName SKIN` \\] `skinName FILE fileName DELETE`&quot;">​</a></h3><p>Используйте эту команду для сохранения файла в пользовательском Виде Интерфейса Домена или для удаления файла из пользовательского Вида Интерфейса Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора. Если оно указано, то за ним должно следовать ключевое слово SKIN.</p></li><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Домена.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла Вида Интерфейса.</p></li><li><p><code>fileContent : блок данных</code></p><p>В этом блоке данных находится содержимое файла. Этот параметр указывается, только если используется ключевое слово DATA. Если указано ключевое слово DATA и Вид Интерфейса содержит файл с тем же именем, то старый файл удаляется. Файл с указанным именем удаляется из Кэша (в Динамическом Кластере файл удаляется из Кэша всех членов Кластера). Когда указано ключевое слово TRYCOMPILE файлы WSSP и CG/PL компилируются перед сохранением. В случае ошибки компиляции команда возвращает информацию о ней в ответе и загружаемый файл не сохраняется.</p></li></ul><p>Следующие команды доступны только Администраторам Системы:</p><h3 id="LISTSERVERSKINS" tabindex="-1"><code>LISTSERVERSKINS</code> <a class="header-anchor" href="#LISTSERVERSKINS" aria-label="Permalink to &quot;`LISTSERVERSKINS` {#LISTSERVERSKINS}&quot;">​</a></h3><p>Используйте эту команду для получения списка пользовательских Видов Интерфейса Сервера. Эта команда возвращает <em>массив</em> с именами Видов Интерфейса.</p><h3 id="CREATESERVERSKIN" tabindex="-1"><code>CREATESERVERSKIN skinName</code> <a class="header-anchor" href="#CREATESERVERSKIN" aria-label="Permalink to &quot;`CREATESERVERSKIN skinName` {#CREATESERVERSKIN}&quot;">​</a></h3><p>Используйте эту команду для создания пользовательского Вида Интерфейса Сервера.</p><ul><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя нового Вида Интерфейса.</p></li></ul><h3 id="RENAMESERVERSKIN" tabindex="-1"><code>RENAMESERVERSKIN skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMESERVERSKIN" aria-label="Permalink to &quot;`RENAMESERVERSKIN skinName INTO newSkinName` {#RENAMESERVERSKIN}&quot;">​</a></h3><p>Используйте эту команду для переименования пользовательского Вида Интерфейса Сервера.</p><ul><li><p><code>skinName : строка</code></p><p>Этот параметр указывает имя существующего Вида Интерфейса.</p></li><li><p><code>newSkinName : строка</code></p><p>Этот параметр задаёт новое имя Вида Интерфейса.</p></li></ul><h3 id="DELETESERVERSKIN" tabindex="-1"><code>DELETESERVERSKIN skinName</code> <a class="header-anchor" href="#DELETESERVERSKIN" aria-label="Permalink to &quot;`DELETESERVERSKIN skinName` {#DELETESERVERSKIN}&quot;">​</a></h3><p>Используйте эту команду для удаления пользовательского Вида Интерфейса Сервера.</p><ul><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя Вида Интерфейса, который должен быть удалён.</p></li></ul><h3 id="LISTSERVERSKINFILES" tabindex="-1"><code>LISTSERVERSKINFILES skinName</code> <a class="header-anchor" href="#LISTSERVERSKINFILES" aria-label="Permalink to &quot;`LISTSERVERSKINFILES skinName` {#LISTSERVERSKINFILES}&quot;">​</a></h3><p>Используйте эту команду для получения списка файлов из пользовательского Вида Интерфейса Сервера. Эта команда возвращает <em>словарь</em>, в ключах которого содержатся имена файлов Вида Интерфейса. Значением элементов словаря являются словари с атрибутами файлов.</p><ul><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Сервера.</p></li></ul><h3 id="READSERVERSKINFILE" tabindex="-1"><code>READSERVERSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#READSERVERSKINFILE" aria-label="Permalink to &quot;`READSERVERSKINFILE skinName FILE fileName` {#READSERVERSKINFILE}&quot;">​</a></h3><p>Используйте эту команду для чтения файла из пользовательского Вида Интерфейса Сервера. Эта команда возвращает <em>массив</em>. Первым элементом массива является блок данных с содержанием файла Вида Интерфейса, вторым элементом массива является отметка времени с датой изменения файла.</p><ul><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Сервера.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя существующего файла указанного Вида Интерфейса Сервера.</p></li></ul><h3 id="STORESERVERSKINFILE" tabindex="-1"><code>STORESERVERSKINFILE skinName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORESERVERSKINFILE" aria-label="Permalink to &quot;`STORESERVERSKINFILE skinName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORESERVERSKINFILE}&quot;">​</a></h3><h3 id="storeserverskinfile-skinname-file-filename-delete" tabindex="-1"><code>STORESERVERSKINFILE skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storeserverskinfile-skinname-file-filename-delete" aria-label="Permalink to &quot;`STORESERVERSKINFILE skinName FILE fileName DELETE`&quot;">​</a></h3><p>Используйте эту команду для сохранения файла в пользовательском Виде Интерфейса Сервера или для удаления файла из пользовательского Вида Интерфейса Сервера.</p><ul><li><p><code>skinName : строка</code></p><p>В этом параметре задаётся имя существующего Вида Интерфейса Сервера.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла Вида Интерфейса.</p></li><li><p><code>fileContent : блок данных</code></p><p>В этом блоке данных находится содержимое файла. Этот параметр указывается, только если используется ключевое слово DATA. Если указано ключевое слово DATA и Вид Интерфейса содержит файл с тем же именем, то старый файл удаляется. Файл с указанным именем удаляется из Кэша (в Динамическом Кластере файл удаляется из Кэша всех членов Кластера). Когда указано ключевое слово TRYCOMPILE файлы WSSP и CG/PL компилируются перед сохранением. В случае ошибки компиляции команда возвращает информацию о ней в ответе и загружаемый файл не сохраняется.</p></li></ul><h3 id="LISTCLUSTERSKINS" tabindex="-1"><code>LISTCLUSTERSKINS</code> <a class="header-anchor" href="#LISTCLUSTERSKINS" aria-label="Permalink to &quot;`LISTCLUSTERSKINS` {#LISTCLUSTERSKINS}&quot;">​</a></h3><h3 id="CREATECLUSTERSKIN" tabindex="-1"><code>CREATECLUSTERSKIN skinName</code> <a class="header-anchor" href="#CREATECLUSTERSKIN" aria-label="Permalink to &quot;`CREATECLUSTERSKIN skinName` {#CREATECLUSTERSKIN}&quot;">​</a></h3><h3 id="RENAMECLUSTERSKIN" tabindex="-1"><code>RENAMECLUSTERSKIN skinName INTO newSkinName</code> <a class="header-anchor" href="#RENAMECLUSTERSKIN" aria-label="Permalink to &quot;`RENAMECLUSTERSKIN skinName INTO newSkinName` {#RENAMECLUSTERSKIN}&quot;">​</a></h3><h3 id="DELETECLUSTERSKIN" tabindex="-1"><code>DELETECLUSTERSKIN skinName</code> <a class="header-anchor" href="#DELETECLUSTERSKIN" aria-label="Permalink to &quot;`DELETECLUSTERSKIN skinName` {#DELETECLUSTERSKIN}&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>LIST</code>|<code>CREATE</code>|<code>RENAME</code>|<code>DELETE</code>]<code>SERVERSKIN</code>[<code>S</code>] для работы с общекластерными Видами Интерфейса.</p><h3 id="LISTCLUSTERSKINFILES" tabindex="-1"><code>LISTCLUSTERSKINFILES skinName</code> <a class="header-anchor" href="#LISTCLUSTERSKINFILES" aria-label="Permalink to &quot;`LISTCLUSTERSKINFILES skinName` {#LISTCLUSTERSKINFILES}&quot;">​</a></h3><h3 id="READCLUSTERSKINFILE" tabindex="-1"><code>READCLUSTERSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#READCLUSTERSKINFILE" aria-label="Permalink to &quot;`READCLUSTERSKINFILE skinName FILE fileName` {#READCLUSTERSKINFILE}&quot;">​</a></h3><h3 id="STORECLUSTERSKINFILE" tabindex="-1"><code>STORECLUSTERSKINFILE skinName FILE fileName DATA fileContent</code> <a class="header-anchor" href="#STORECLUSTERSKINFILE" aria-label="Permalink to &quot;`STORECLUSTERSKINFILE skinName FILE fileName DATA fileContent` {#STORECLUSTERSKINFILE}&quot;">​</a></h3><h3 id="storeclusterskinfile-skinname-file-filename-delete" tabindex="-1"><code>STORECLUSTERSKINFILE skinName FILE fileName DELETE</code> <a class="header-anchor" href="#storeclusterskinfile-skinname-file-filename-delete" aria-label="Permalink to &quot;`STORECLUSTERSKINFILE skinName FILE fileName DELETE`&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>LIST</code>|<code>READ</code>|<code>STORE</code>]<code>SERVERSKINFILE</code>[<code>S</code>] для работы с общекластерными Видами Интерфейса.</p><h3 id="LISTSTOCKSKINFILES" tabindex="-1"><code>LISTSTOCKSKINFILES skinName</code> <a class="header-anchor" href="#LISTSTOCKSKINFILES" aria-label="Permalink to &quot;`LISTSTOCKSKINFILES skinName` {#LISTSTOCKSKINFILES}&quot;">​</a></h3><h3 id="readstockskinfile-skinname-file-filename" tabindex="-1"><code>READSTOCKSKINFILE skinName FILE fileName</code> <a class="header-anchor" href="#readstockskinfile-skinname-file-filename" aria-label="Permalink to &quot;`READSTOCKSKINFILE skinName FILE fileName`&quot;">​</a></h3><p>Используйте эти команды вместо команд [<code>LIST</code>|<code>READ</code>]<code>SERVERSKINFILE</code>[<code>S</code>] для работы со встроенными Видами Интерфейса.</p><h2 id="WebSession" tabindex="-1">Интеграция с Веб Интерфейсом <a class="header-anchor" href="#WebSession" aria-label="Permalink to &quot;Интеграция с Веб Интерфейсом {#WebSession}&quot;">​</a></h2><p>Следующие команды могут использоваться для интеграции Веб Интерфейса Пользователя CommuniGate Pro с приложениями сторонних производителей.</p><h3 id="CREATEWEBUSERSESSION" tabindex="-1"><code>CREATEWEBUSERSESSION accountName ADDRESS ip-address [ FOR orig-address ] [ SKIN skinName ]</code> <a class="header-anchor" href="#CREATEWEBUSERSESSION" aria-label="Permalink to &quot;`CREATEWEBUSERSESSION accountName ADDRESS ip-address [ FOR orig-address ] [ SKIN skinName ]` {#CREATEWEBUSERSESSION}&quot;">​</a></h3><p>Используйте эту команду для создания сессии WebUser для указанного Пользователя. Эта команда возвращает <em>строку</em> с идентификатором сессии WebUser. Эта строка может быть использована для создания URL, который позволит браузеру клиента &quot;войти&quot; в Сессию WebUser. Этот URL может иметь следующий формат:</p><p><code>http://cgateproserver:port/Session/_rrrrrrrrrrrr_/Mailboxes.wssp</code></p><p>где <code>rrrrrrrrrrrr</code> является возвращённой строкой с идентификатором сессии.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя.</p></li><li><p><code>ip-address : строка или адрес IP</code></p><p>В этом параметре задаётся адрес IP браузера клиента. Если у Пользователя включена Установка &quot;Фиксированный IP&quot;, то запросы в рамках сессии будут разрешены только с этого IP адреса.</p></li><li><p><code>orig-address : строка</code></p><p>В этом параметре задаётся оригинальный адрес IP браузера клиента в случае, если клиент соединяется через прокси. Параметр <em>ip-address</em> указывает IP адрес прокси. Если у Пользователя включена Установка &quot;Фиксированный IP&quot;, то соединения в рамках сессии будут разрешены только с IP адреса прокси и только с оригинального IP адреса (переданного с прокси в заголовке HTTP <code>X-FORWARDED-FOR</code>).</p></li><li><p><code>skinName : строка</code></p><p>Этот необязательный параметр указывает Вид Интерфейса, используемый для вновь создаваемой сессии. Для создания сессий WebUser аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="CREATEXIMSSSESSION" tabindex="-1"><code>CREATEXIMSSSESSION accountName ADDRESS ip-address [ FOR orig-address ]</code> <a class="header-anchor" href="#CREATEXIMSSSESSION" aria-label="Permalink to &quot;`CREATEXIMSSSESSION accountName ADDRESS ip-address [ FOR orig-address ]` {#CREATEXIMSSSESSION}&quot;">​</a></h3><p>Используйте эту команду для создания сессии XIMSS для указанного Пользователя. Эта команда возвращает <em>строку</em> с идентификатором Сессии XIMSS. Эта строка может быть использована для создания URL, который позволит браузеру клиента работать с Сессией XIMSS используя протокол HTTP.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя.</p></li><li><p><code>ip-address : строка</code></p></li><li><p><code>orig-address : строка</code></p><p>Эти параметры имеют тот же смысл, что и для команды <code>CREATEWEBUSERSESSION</code>. Для создания сессий XIMSS аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="CREATELITESESSION" tabindex="-1"><code>CREATELITESESSION ADDRESS ip-address [ FOR orig-address ]</code> <a class="header-anchor" href="#CREATELITESESSION" aria-label="Permalink to &quot;`CREATELITESESSION ADDRESS ip-address [ FOR orig-address ]` {#CREATELITESESSION}&quot;">​</a></h3><p>Используйте эту команду для создания сессии LITE. Эта команда возвращает <em>строку</em> с идентификатором Сессии LITE. Эта строка может быть использована для создания URL, который позволит браузеру клиента работать с Сессией LITE используя протокол HTTP.</p><ul><li><p><code>ip-address : string</code></p></li><li><p><code>orig-address : string</code></p><p>Эти параметры имеют тот же смысл, что и для команды <code>CREATEWEBUSERSESSION</code>. Для создания сессий LITE аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="FINDACCOUNTSESSION" tabindex="-1"><code>FINDACCOUNTSESSION accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]</code> <a class="header-anchor" href="#FINDACCOUNTSESSION" aria-label="Permalink to &quot;`FINDACCOUNTSESSION accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]` {#FINDACCOUNTSESSION}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы найти для указанного Пользователя существующую сессию. Эта команда возвращает <em>строку</em> с идентификатором Сессии.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя.</p></li><li><p><code>ip-address : строка или адрес IP</code></p><p>В этом необязательном параметре задаётся IP адрес браузера клиента. Если он указан, то команда найдёт только те сессии, у которых Настройка &quot;Фиксированный IP&quot; выключена или у которых IP адрес входа совпадает с указанным в этом параметре.</p></li><li><p><code>proxied-address : строка</code></p><p>В этом необязательном параметре задаётся IP адрес браузера клиента, если браузер находится за HTTP прокси. IP адрес такого прокси указывается в <em>ip-address</em>.</p></li><li><p><code>protocol : строка</code></p><p>Этот необязательный параметр указывает протокол Сессии (<code>WebUser</code>, <code>XIMSS</code>, <code>XMPP</code> и т.п.) Если он указан, то поиск осуществляется только в сессиях по указанному протоколу.</p></li><li><p><code>transport : строка</code></p><p>Этот необязательный параметр задаёт транспорт Сессии (<code>HTTP</code>, <code>XIMSS</code>, <code>XMPP</code> и т.п.) Если он указан, то поиск осуществляется только в сессиях, созданных с указанным транспортом.</p></li><li><p><code>client : строка</code></p><p>Этот необязательный параметр указывает клиента Сессии. Если он указан, то поиск осуществляется только в сессиях, созданных с указанным клиентом (если клиент проинформировал сессию о своём имени). Для использования этой команды аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="LISTACCOUNTSESSIONS" tabindex="-1"><code>LISTACCOUNTSESSIONS accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]</code> <a class="header-anchor" href="#LISTACCOUNTSESSIONS" aria-label="Permalink to &quot;`LISTACCOUNTSESSIONS accountName [ ADDRESS ip-address [ FOR proxied-address ] ] [ PROTOCOL protocol ] [ TRANSPORT transport ] [ CLIENT client ]` {#LISTACCOUNTSESSIONS}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы найти для указанного Пользователя все существующие сессии. Эта команда возвращает <em>массив</em> строк - идентификаторов Сессий. Параметры команды такие же, как у FINDACCOUNTSESSION. Для использования этой команды аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p><h3 id="LISTLITESESSIONS" tabindex="-1"><code>LISTLITESESSIONS [ ADDRESS ip-address [ FOR proxied-address ] ]</code> <a class="header-anchor" href="#LISTLITESESSIONS" aria-label="Permalink to &quot;`LISTLITESESSIONS [ ADDRESS ip-address [ FOR proxied-address ] ]` {#LISTLITESESSIONS}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы найти все существующие сессии LITE. Эта команда возвращает <em>массив</em> строк - идентификаторов Сессий. Параметры команды такие же, как у LISTACCOUNTSESSIONS. Для использования этой команды аутентифицированный пользователь должен иметь право <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p><h3 id="GETSESSION" tabindex="-1"><code>GETSESSION sessionID [ DOMAIN domainName ]</code> <a class="header-anchor" href="#GETSESSION" aria-label="Permalink to &quot;`GETSESSION sessionID [ DOMAIN domainName ]` {#GETSESSION}&quot;">​</a></h3><p>Используйте эту команду для получения данных Сессии. Эта команда возвращает <em>словарь</em>, в котором содержится <em>набор данных сессии</em> (описанный в разделе <a href="./WSSP.html">WSSP</a> настоящего руководства).</p><ul><li><p><code>sessionID : строка</code></p><p>В этом параметре задаётся Идентификатор Сессии.</p></li><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена, которому принадлежит Пользователь этой сессии. Если параметр <em>domainName</em> не указан, то для получения данных Сессии аутентифицированный пользователь должен иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a>. Если указано <em>domainName</em>, то аутентифицированный пользователь должен иметь для указанного Домена право доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>. Эта операция сбрасывает таймер неактивности сессии.</p></li></ul><h3 id="UPDATESESSION" tabindex="-1"><code>UPDATESESSION sessionID [ DOMAIN domainName ] dictParam</code> <a class="header-anchor" href="#UPDATESESSION" aria-label="Permalink to &quot;`UPDATESESSION sessionID [ DOMAIN domainName ] dictParam` {#UPDATESESSION}&quot;">​</a></h3><p>Используйте эту команду для прекращения сессии.</p><ul><li><p><code>sessionID : строка</code></p><p>В этом параметре задаётся Идентификатор Сессии.</p></li><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена, которому принадлежит Пользователь этой сессии.</p></li><li><p><code>dictParam : словарь</code></p><p>Этот параметр задаёт словарь с атрибутами для модификации. Специальное значение <code>#NULL#</code> может быть использовано для удаления атрибута. Если параметр <em>domainName</em> не указан, то для модификации Сессии аутентифицированный пользователь должен иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a>. Если указано <em>domainName</em>, то аутентифицированный пользователь должен иметь для указанного Домена право доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="KILLSESSION" tabindex="-1"><code>KILLSESSION sessionID [ DOMAIN domainName ]</code> <a class="header-anchor" href="#KILLSESSION" aria-label="Permalink to &quot;`KILLSESSION sessionID [ DOMAIN domainName ]` {#KILLSESSION}&quot;">​</a></h3><p>Используйте эту команду для прекращения сессии.</p><ul><li><p><code>sessionID : строка</code></p><p>В этом параметре задаётся Идентификатор Сессии.</p></li><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена, которому принадлежит Пользователь этой сессии. Если параметр <em>domainName</em> не указан, то для прекращения Сессии аутентифицированный пользователь должен иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a>. Если указано <em>domainName</em>, то аутентифицированный пользователь должен иметь для указанного Домена право доступа <code>Может создавать WebUser сессии (CanCreateWebUserSessions)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p></li></ul><h3 id="BLESSSESSION" tabindex="-1"><code>BLESSSESSION sessionID [ PASSWORD secret ] [ AUTH accountName ]</code> <a class="header-anchor" href="#BLESSSESSION" aria-label="Permalink to &quot;`BLESSSESSION sessionID [ PASSWORD secret ] [ AUTH accountName ]` {#BLESSSESSION}&quot;">​</a></h3><p>Используйте эту команду для завершения процесса Двухфакторной Аутентификации для указанной сессии.</p><ul><li><p><code>sessionID : строка</code></p><p>В этом параметре задаётся Идентификатор Сессии.</p></li><li><p><code>secret : строка</code></p><p>Этот необязательный параметр задаёт одноразовый пароль Двухфакторной Аутентификации.</p></li><li><p><code>accountName : строка</code></p><p>Этот необязательный параметр указывает имя Пользователя, которому принадлежит эта сессия. Если параметер <em>secret</em> не указан (когда Сессия должна быть в состоянии ожидания выполнения фоновой Двухфакторной Аутентификации), то аутентифицированный пользователь должен иметь право доступа <code>Master</code> <a href="./../admin/sysadmin/">Администратора сервера</a>. Если указан <em>accountName</em>, то аутентифицированный пользователь должен иметь для указанного Домена право доступа <code>Может выступать от имени других (CanImpersonate)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>. Специальные административные права не нужны, когда аутентифицированный пользователь завершает процесс Двухфакторной Аутентификации для своей же сессии.</p></li></ul><h2 id="PBXApp" tabindex="-1">Управление Приложениями Реального Времени <a class="header-anchor" href="#PBXApp" aria-label="Permalink to &quot;Управление Приложениями Реального Времени {#PBXApp}&quot;">​</a></h2><p>Следующие команды могут использоваться для обслуживания Среды Программ <a href="./PBXApp.html">Реального Времени</a> CommuniGate Pro.</p><p>Для изменения Среды Домена для Программ Реального Времени необходимо иметь право доступа <a href="./../admin/sysadmin/#Privs">Все Домены</a> или обладать правом доступа <code>Может модифицировать PBX Приложения (CanModifyPBXApps)</code> <a href="./../admin/sysadmin/#Domain">Администратора Домена</a>.</p><h3 id="CREATEDOMAINPBX" tabindex="-1"><code>CREATEDOMAINPBX domainName [ FILE language ]</code> <a class="header-anchor" href="#CREATEDOMAINPBX" aria-label="Permalink to &quot;`CREATEDOMAINPBX domainName [ FILE language ]` {#CREATEDOMAINPBX}&quot;">​</a></h3><p>Используйте эту команду для создания Среды Домена для Программ Реального Времени или для создания национального набора.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>language : строка</code></p><p>Этf необязательная строка содержит название локализации.</p></li></ul><h3 id="DELETEDOMAINPBX" tabindex="-1"><code>DELETEDOMAINPBX domainName FILE language</code> <a class="header-anchor" href="#DELETEDOMAINPBX" aria-label="Permalink to &quot;`DELETEDOMAINPBX domainName FILE language` {#DELETEDOMAINPBX}&quot;">​</a></h3><p>Используйте эту команду для удаления локализации из Среды Домена для Программ Реального Времени.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>language : строка</code></p><p>Этот параметр указывает название локализации.</p></li></ul><h3 id="LISTDOMAINPBXFILES" tabindex="-1"><code>LISTDOMAINPBXFILES domainName [ FILE language ]</code> <a class="header-anchor" href="#LISTDOMAINPBXFILES" aria-label="Permalink to &quot;`LISTDOMAINPBXFILES domainName [ FILE language ]` {#LISTDOMAINPBXFILES}&quot;">​</a></h3><p>Используйте эту команду для получения списка файлов с Приложениями Реального Времени из Среды Домена. Эта команда возвращает <em>словарь</em>, ключи которого являются именами файлов. Значением элементов словаря являются словари с атрибутами файлов.</p><ul><li><p><code>domainName : строка</code></p><p>Этот необязательный параметр указывает имя Домена. Если имя Домена не указано, то команда применяется к Домену администратора.</p></li><li><p><code>language : строка</code></p><p>Эта необязательная строка содержит название локализации.</p></li></ul><h3 id="READDOMAINPBXFILE" tabindex="-1"><code>READDOMAINPBXFILE domainName FILE fileName</code> <a class="header-anchor" href="#READDOMAINPBXFILE" aria-label="Permalink to &quot;`READDOMAINPBXFILE domainName FILE fileName` {#READDOMAINPBXFILE}&quot;">​</a></h3><p>Используйте эту команду для чтения файла с Приложением Реального Времени из Среды Домена. Эта команда возвращает <em>блок данных</em>, в котором находится содержимое файла.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла. Для получения файла из национального набора укажите его имя как <em>language</em>/<em>fileName</em>.</p></li></ul><h3 id="STOREDOMAINPBXFILE" tabindex="-1"><code>STOREDOMAINPBXFILE domainName FILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STOREDOMAINPBXFILE" aria-label="Permalink to &quot;`STOREDOMAINPBXFILE domainName FILE fileName DATA fileContent [ TRYCOMPILE ]` {#STOREDOMAINPBXFILE}&quot;">​</a></h3><h3 id="storedomainpbxfile-domainname-file-filename-delete" tabindex="-1"><code>STOREDOMAINPBXFILE domainName FILE fileName DELETE</code> <a class="header-anchor" href="#storedomainpbxfile-domainname-file-filename-delete" aria-label="Permalink to &quot;`STOREDOMAINPBXFILE domainName FILE fileName DELETE`&quot;">​</a></h3><p>Используйте эту команду для сохранения файла с Приложением Реального Времени в Среду Домена или для удаления файла с Приложением Реального Времени из Среды Домена.</p><ul><li><p><code>domainName : строка</code></p><p>Этот параметр указывает имя Домена.</p></li><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла. Для сохранения файла в национальном наборе укажите его имя как <em>language</em>/<em>fileName</em>.</p></li><li><p><code>fileContent : блок данных</code></p><p>Этот параметр указывается, только если используется ключевое слово DATA. В нём должно быть передано содержимое файла. Если указано ключевое слово DATA и среда содержит файл с указанным именем, то старый файл удаляется. Файл с указанным именем удаляется из Кэша Среды (в Динамическом Кластере файл удаляется из Кэша всех членов Кластера). Когда указано ключевое слово TRYCOMPILE файлы CG/PL компилируются перед сохранением. В случае ошибки компиляции команда возвращает информацию о ней в ответе и загружаемый файл не сохраняется.</p></li></ul><p>Следующие команды доступны только Администраторам Системы:</p><h3 id="CREATESERVERPBX" tabindex="-1"><code>CREATESERVERPBX language</code> <a class="header-anchor" href="#CREATESERVERPBX" aria-label="Permalink to &quot;`CREATESERVERPBX language` {#CREATESERVERPBX}&quot;">​</a></h3><p>Используйте эту команду для создания общесерверной Среды для Приложений Реального Времени или национального набора в ней.</p><ul><li><p><code>language : строка</code></p><p>Этот параметр указывает название локализации.</p></li></ul><h3 id="DELETESERVERPBX" tabindex="-1"><code>DELETESERVERPBX language</code> <a class="header-anchor" href="#DELETESERVERPBX" aria-label="Permalink to &quot;`DELETESERVERPBX language` {#DELETESERVERPBX}&quot;">​</a></h3><p>Используйте эту команду для удаления локализации из общесерверной Среды для Программ Реального Времени.</p><ul><li><p><code>language : строка</code></p><p>Этот параметр указывает название локализации.</p></li></ul><h3 id="LISTSERVERPBXFILES" tabindex="-1"><code>LISTSERVERPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTSERVERPBXFILES" aria-label="Permalink to &quot;`LISTSERVERPBXFILES [ language ]` {#LISTSERVERPBXFILES}&quot;">​</a></h3><p>Используйте эту команду для получения списка файлов Приложений Реального Времени из общесерверной Среды. Эта команда возвращает <em>словарь</em>, ключи которого являются именами файлов. Значением элементов словаря являются словари с атрибутами файлов.</p><ul><li><p><code>language : строка</code></p><p>Эта необязательная строка содержит название локализации.</p></li></ul><h3 id="READSERVERPBXFILE" tabindex="-1"><code>READSERVERPBXFILE fileName</code> <a class="header-anchor" href="#READSERVERPBXFILE" aria-label="Permalink to &quot;`READSERVERPBXFILE fileName` {#READSERVERPBXFILE}&quot;">​</a></h3><p>Используйте эту команду для чтения файла с Приложением Реального Времени из общесерверной Среды. Эта команда возвращает <em>блок данных</em>, в котором находится содержимое файла.</p><ul><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла. Для получения файла из национального набора укажите его имя как <em>language</em>/<em>fileName</em>.</p></li></ul><h3 id="STORESERVERPBXFILE" tabindex="-1"><code>STORESERVERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORESERVERPBXFILE" aria-label="Permalink to &quot;`STORESERVERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORESERVERPBXFILE}&quot;">​</a></h3><h3 id="storeserverpbxfile-filename-delete" tabindex="-1"><code>STORESERVERPBXFILE fileName DELETE</code> <a class="header-anchor" href="#storeserverpbxfile-filename-delete" aria-label="Permalink to &quot;`STORESERVERPBXFILE fileName DELETE`&quot;">​</a></h3><p>Используйте эту команду для сохранения файла с Приложением Реального Времени в общесерверную Среду или для удаления файла с Приложением Реального Времени из общесерверной среды.</p><ul><li><p><code>fileName : строка</code></p><p>В этом параметре задаётся имя файла. Для сохранения файла в национальном наборе укажите его имя как <em>language</em>/<em>fileName</em>.</p></li><li><p><code>fileContent : блок данных</code></p><p>Этот параметр указывается, только если используется ключевое слово DATA. В нём должно быть передано содержимое файла. Если указано ключевое слово DATA и среда содержит файл с указанным именем, то старый файл удаляется. Файл с указанным именем удаляется из Кэша Среды (в Динамическом Кластере файл удаляется из Кэша всех членов Кластера). Когда указано ключевое слово TRYCOMPILE файлы CG/PL компилируются перед сохранением. В случае ошибки компиляции команда возвращает информацию о ней в ответе и загружаемый файл не сохраняется.</p></li></ul><h3 id="CREATECLUSTERPBX" tabindex="-1"><code>CREATECLUSTERPBX language</code> <a class="header-anchor" href="#CREATECLUSTERPBX" aria-label="Permalink to &quot;`CREATECLUSTERPBX language` {#CREATECLUSTERPBX}&quot;">​</a></h3><h3 id="DELETECLUSTERPBX" tabindex="-1"><code>DELETECLUSTERPBX language</code> <a class="header-anchor" href="#DELETECLUSTERPBX" aria-label="Permalink to &quot;`DELETECLUSTERPBX language` {#DELETECLUSTERPBX}&quot;">​</a></h3><h3 id="LISTCLUSTERPBXFILES" tabindex="-1"><code>LISTCLUSTERPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTCLUSTERPBXFILES" aria-label="Permalink to &quot;`LISTCLUSTERPBXFILES [ language ]` {#LISTCLUSTERPBXFILES}&quot;">​</a></h3><h3 id="READCLUSTERPBXFILE" tabindex="-1"><code>READCLUSTERPBXFILE fileName</code> <a class="header-anchor" href="#READCLUSTERPBXFILE" aria-label="Permalink to &quot;`READCLUSTERPBXFILE fileName` {#READCLUSTERPBXFILE}&quot;">​</a></h3><h3 id="STORECLUSTERPBXFILE" tabindex="-1"><code>STORECLUSTERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]</code> <a class="header-anchor" href="#STORECLUSTERPBXFILE" aria-label="Permalink to &quot;`STORECLUSTERPBXFILE fileName DATA fileContent [ TRYCOMPILE ]` {#STORECLUSTERPBXFILE}&quot;">​</a></h3><h3 id="storeclusterpbxfile-filename-delete" tabindex="-1"><code>STORECLUSTERPBXFILE fileName DELETE</code> <a class="header-anchor" href="#storeclusterpbxfile-filename-delete" aria-label="Permalink to &quot;`STORECLUSTERPBXFILE fileName DELETE`&quot;">​</a></h3><p>Эти команды доступны только в Динамическом Кластере. Используйте эти команды вместо команд [<code>LIST</code>|<code>READ</code>|<code>STORE</code>]<code>SERVERPBXFILE</code>[<code>S</code>] для работы с файлами общекластерной Среды Приложений Реального Времени.</p><h3 id="LISTSTOCKPBXFILES" tabindex="-1"><code>LISTSTOCKPBXFILES [ language ]</code> <a class="header-anchor" href="#LISTSTOCKPBXFILES" aria-label="Permalink to &quot;`LISTSTOCKPBXFILES [ language ]` {#LISTSTOCKPBXFILES}&quot;">​</a></h3><h3 id="READSTOCKPBXFILE" tabindex="-1"><code>READSTOCKPBXFILE fileName</code> <a class="header-anchor" href="#READSTOCKPBXFILE" aria-label="Permalink to &quot;`READSTOCKPBXFILE fileName` {#READSTOCKPBXFILE}&quot;">​</a></h3><p>Используйте эти команды вместо команд[<code>LIST</code>|<code>READ</code>|<code>STORE]SERVERPBXFILE</code>[<code>S</code>] для работы с файлами общекластерной Среды Приложений Реального Времени.</p><h2 id="PBXRun" tabindex="-1">Выполнение Приложений Реального Времени <a class="header-anchor" href="#PBXRun" aria-label="Permalink to &quot;Выполнение Приложений Реального Времени {#PBXRun}&quot;">​</a></h2><p>Следующие команды могут использоваться для выполнения Задач Приложений <a href="./PBXApp.html">Реального Времени</a> CommuniGate Pro.</p><h3 id="STARTPBXTASK" tabindex="-1"><code>STARTPBXTASK accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]</code> <a class="header-anchor" href="#STARTPBXTASK" aria-label="Permalink to &quot;`STARTPBXTASK accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]` {#STARTPBXTASK}&quot;">​</a></h3><p>Используйте эту команду для запуска новой Задачи PBX. Эта команда возвращает <em>строку</em> с идентификатором Задачи.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя. Задача запускается от имени этого Пользователя. Имя может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется текущий Домен пользователя.</p></li><li><p><code>programName : строка</code></p><p>Имя запускаемой программы (файл .sppr).</p></li><li><p><code>entryName : строка</code></p><p>Этот необязательный параметр указывает точку входа программы. Если этот параметр не указан, то используется точка входа <code>main</code>.</p></li><li><p><code>parameter : объект</code></p><p>Этот необязательный параметр указывает стартовый параметр программы. Программы может получить этот параметр при помощи следующего кода:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Vars().startParameter</span></span></code></pre></div></li></ul><h3 id="SENDTASKEVENT" tabindex="-1"><code>SENDTASKEVENT taskID EVENT eventName [ PARAM parameter ]</code> <a class="header-anchor" href="#SENDTASKEVENT" aria-label="Permalink to &quot;`SENDTASKEVENT taskID EVENT eventName [ PARAM parameter ]` {#SENDTASKEVENT}&quot;">​</a></h3><p>Используйте эту команду для отправки События существующей Задаче PBX.</p><ul><li><p><code>taskID : строка</code></p><p>В этом параметре задаётся ID Задачи.</p></li><li><p><code>eventName : строка</code></p><p>Имя отправляемого События.</p></li><li><p><code>parameter : объект</code></p><p>Это - необязательный параметр События.</p></li></ul><h3 id="KILLNODE" tabindex="-1"><code>KILLNODE taskID</code> <a class="header-anchor" href="#KILLNODE" aria-label="Permalink to &quot;`KILLNODE taskID` {#KILLNODE}&quot;">​</a></h3><p>Используйте эту команду для завершения существующей PBX Задачи.</p><ul><li><p><code>taskID : строка</code></p><p>В этом параметре задаётся ID Задачи.</p></li></ul><h3 id="READNODESTATUS" tabindex="-1"><code>READNODESTATUS taskID</code> <a class="header-anchor" href="#READNODESTATUS" aria-label="Permalink to &quot;`READNODESTATUS taskID` {#READNODESTATUS}&quot;">​</a></h3><p>Используйте эту команду для чтения текущего <a href="./CGPL.html#SetAppStatus">статуса приложения</a> существующей PBX Задачи. Эта команда возвращает объект со статусом приложения.</p><ul><li><p><code>taskID : строка</code></p><p>В этом параметре задаётся ID Задачи.</p></li></ul><h2 id="полнотекстовыи-поиск" tabindex="-1">Полнотекстовый поиск <a class="header-anchor" href="#полнотекстовыи-поиск" aria-label="Permalink to &quot;Полнотекстовый поиск&quot;">​</a></h2><h3 id="BUILDDOMAINSEARCHINDEX" tabindex="-1"><code>BUILDDOMAINSEARCHINDEX domainName [ ENABLEFORALL ]</code> <a class="header-anchor" href="#BUILDDOMAINSEARCHINDEX" aria-label="Permalink to &quot;`BUILDDOMAINSEARCHINDEX domainName [ ENABLEFORALL ]` {#BUILDDOMAINSEARCHINDEX}&quot;">​</a></h3><p>Используйте эту команду для построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для всех Пользователей Домена. Если у Пользователя уже построен <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a>, то он не будет перестроен. Если в настройках Пользователей по умолчанию <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> отключён, то будет построен индекс только для тех Пользователей, у которых он включён в настройках.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> для Пользователей которого должен быть построен.</p></li><li><p><code>ENABLEFORALL</code></p><p>Этот необязательный параметр включает <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> для всех Пользователей по умолчанию. <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> не будет включён для Пользователей, у которых он был отключён в настройках.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Построение <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для больших (более 1 Гб) почтовых ящиков может занимать длительное время, поэтому рекомендуется запускать Индексацию во время низкой загруженности Сервера.</p></div><h3 id="GETDOMAINSEARCHINDEXSTATE" tabindex="-1"><code>GETDOMAINSEARCHINDEXSTATE domainName</code> <a class="header-anchor" href="#GETDOMAINSEARCHINDEXSTATE" aria-label="Permalink to &quot;`GETDOMAINSEARCHINDEXSTATE domainName` {#GETDOMAINSEARCHINDEXSTATE}&quot;">​</a></h3><p>Используйте эту команду для получения состояния <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> Домена. Эта команда возвращает данные — строку со значением <code>none</code>, если <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> в Домене отсутствует, <code>waiting</code>, если Домен ожидает построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a>, <code>indexing</code>, если Домен в процессе построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a>, и <code>ready</code>, если <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> готов к работе.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, состояние <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для которого должно быть получено.</p></li></ul><h3 id="REMOVEDOMAINSEARCHINDEX" tabindex="-1"><code>REMOVEDOMAINSEARCHINDEX domainName</code> <a class="header-anchor" href="#REMOVEDOMAINSEARCHINDEX" aria-label="Permalink to &quot;`REMOVEDOMAINSEARCHINDEX domainName` {#REMOVEDOMAINSEARCHINDEX}&quot;">​</a></h3><p>Используйте эту команду для очистки <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> всех Пользователей Домена. <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> в Умолчаниях для Пользователей должен быть выключен. Если в настройках конкретного Пользователя <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> будет включён, то очистка для него не выполнится.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для которого должен быть очищен.</p></li></ul><h3 id="BUILDACCOUNTSEARCHINDEX" tabindex="-1"><code>BUILDACCOUNTSEARCHINDEX accountName</code> <a class="header-anchor" href="#BUILDACCOUNTSEARCHINDEX" aria-label="Permalink to &quot;`BUILDACCOUNTSEARCHINDEX accountName` {#BUILDACCOUNTSEARCHINDEX}&quot;">​</a></h3><p>Используйте эту команду для построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> Пользователя. Если у Пользователя уже построен <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a>, то он будет перестроен полностью. Если в настройках Пользователя или Домена <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> отключён, то он будет включён для указанного Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся полное имя Пользователя с указанием Домена, <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> для которого должен быть построен.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Построение <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для больших (более 1 Гб) почтовых ящиков может занимать длительное время, поэтому рекомендуется запускать Индексацию во время низкой загруженности Сервера.</p></div><h3 id="GETACCOUNTSEARCHINDEXSTATE" tabindex="-1"><code>GETACCOUNTSEARCHINDEXSTATE accountName</code> <a class="header-anchor" href="#GETACCOUNTSEARCHINDEXSTATE" aria-label="Permalink to &quot;`GETACCOUNTSEARCHINDEXSTATE accountName` {#GETACCOUNTSEARCHINDEXSTATE}&quot;">​</a></h3><p>Используйте эту команду для получения состояния <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> Пользователя. Эта команда возвращает данные — строку со значением <code>none</code>, если <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> Пользователя отсутствует, <code>waiting</code>, если Пользователь ожидает построения Индекса Поиска, <code>indexing</code>, если Пользователь в процессе построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a>, и <code>ready</code>, если <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> готов к работе.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся полное имя Пользователя с указанием Домена, состояние <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для которого должно быть получено.</p></li></ul><h3 id="GETACCOUNTSEARCHINDEXSIZE" tabindex="-1"><code>GETACCOUNTSEARCHINDEXSIZE accountName</code> <a class="header-anchor" href="#GETACCOUNTSEARCHINDEXSIZE" aria-label="Permalink to &quot;`GETACCOUNTSEARCHINDEXSIZE accountName` {#GETACCOUNTSEARCHINDEXSIZE}&quot;">​</a></h3><p>Используйте эту команду для получения размера <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> Пользователя. Эта команда возвращает данные — число.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся полное имя Пользователя с указанием Домена, состояние <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для которого должно быть получено.</p></li></ul><h3 id="REMOVEACCOUNTSEARCHINDEX" tabindex="-1"><code>REMOVEACCOUNTSEARCHINDEX accountName</code> <a class="header-anchor" href="#REMOVEACCOUNTSEARCHINDEX" aria-label="Permalink to &quot;`REMOVEACCOUNTSEARCHINDEX accountName` {#REMOVEACCOUNTSEARCHINDEX}&quot;">​</a></h3><p>Используйте эту команду для очистки <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> Пользователя. <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> Пользователя или Домена должен быть выключен.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся полное имя Пользователя с указанием Домена, <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> которого должен быть очищен.</p></li></ul><h3 id="SEARCHININDEX" tabindex="-1"><code>SEARCHININDEX accountName SEARCHSTRING searchString [ OPTIONS options ]</code> <a class="header-anchor" href="#SEARCHININDEX" aria-label="Permalink to &quot;`SEARCHININDEX accountName SEARCHSTRING searchString [ OPTIONS options ]` {#SEARCHININDEX}&quot;">​</a></h3><p>Используйте эту команду для поиска строки в <a href="./../admin/sysadmin/#searchIndex">Индексе Поиска</a>. Эта команда возвращает объект с результатами поиска. При некорректном формате строки запрос не будет обработан, а сервер вернёт ошибку <code>Invalid Query</code>.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся полное имя Пользователя с указанием Домена, поиск по <a href="./../admin/sysadmin/#searchIndex">Индексу Поиска</a> которого должен быть выполнен.</p></li><li><p><code>searchString : строка</code></p><p>В этом параметре задаётся строка, поиск которой должен быть выполнен. Поддерживает <a href="./../admin/sysadmin/#searchSyntax">синтаксис запросов поиска</a>.</p></li><li><p><code>options : словарь</code></p><p>Словарь с <a href="./XMLAPI/#searchOptions">параметрами поиска</a>.</p></li></ul><h3 id="BUILDGROUPSEARCHINDEX" tabindex="-1"><code>BUILDGROUPSEARCHINDEX domainName groupName [ ENABLEFORALL ]</code> <a class="header-anchor" href="#BUILDGROUPSEARCHINDEX" aria-label="Permalink to &quot;`BUILDGROUPSEARCHINDEX domainName groupName [ ENABLEFORALL ]` {#BUILDGROUPSEARCHINDEX}&quot;">​</a></h3><p>Используйте эту команду для построения <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для всех Пользователей в Группе. Если у Пользователя уже построен <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a>, то он не будет перестроен. Если в настройках Пользователей по умолчанию <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> отключён, то будет построен индекс только для тех Пользователей, у которых он включён в настройках.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя Домена, <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> для Группы которого должен быть построен.</p></li><li><p><code>groupName : строка</code></p><p>В этом параметре задаётся имя Группы, <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> для пользователей которой должен быть построен.</p></li><li><p><code>ENABLEFORALL</code></p><p>Этот необязательный параметр включает <a href="./../admin/sysadmin/#searchIndex">Индекс Поиска</a> в настройках каждого Пользователя в Группе.</p></li></ul><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Построение <a href="./../admin/sysadmin/#searchIndex">Индекса Поиска</a> для больших (более 1 Гб) почтовых ящиков может занимать длительное время, поэтому рекомендуется запускать Индексацию во время низкой загруженности Сервера.</p></div><h2 id="SyncScripts" tabindex="-1">Синхронные Скрипты <a class="header-anchor" href="#SyncScripts" aria-label="Permalink to &quot;Синхронные Скрипты {#SyncScripts}&quot;">​</a></h2><p>Следующие команды могут использоваться для выполнения <a href="./CGPL.html#SyncScripts">Синхронных Скриптов</a>, расположенных на сервере.</p><h3 id="RUNSCRIPT" tabindex="-1"><code>RUNSCRIPT accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]</code> <a class="header-anchor" href="#RUNSCRIPT" aria-label="Permalink to &quot;`RUNSCRIPT accountName PROGRAM programName [ ENTRY entryName ] [ PARAM parameter ]` {#RUNSCRIPT}&quot;">​</a></h3><p>Используйте эту команду для запуска на сервере синхронного скрипта. Эта команда возвращает <em>объект</em>, созданный в результате выполнения синхронного скрипта.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя Пользователя. Скрипт запускается от имени этого Пользователя. Имя может включать в себя имя Домена. Если имя Домена не указано, то по умолчанию используется текущий Домен пользователя.</p></li><li><p><code>programName : строка</code></p><p>Имя запускаемого скрипта (файл .scgp).</p></li><li><p><code>entryName : строка</code></p><p>Этот необязательный параметр указывает точку входа скрипта. Если этот параметр не указан, то используется точка входа <code>main</code>.</p></li><li><p><code>parameter : объект</code></p><p>Этот необязательный параметр указывает стартовый параметр скрипта. Скрипт может получить этот параметр при помощи следующего кода:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Vars().startParameter</span></span></code></pre></div></li></ul><h2 id="Services" tabindex="-1">Операции с данными Пользователя <a class="header-anchor" href="#Services" aria-label="Permalink to &quot;Операции с данными Пользователя {#Services}&quot;">​</a></h2><p>Следующие команды могут использоваться для управления различными данными Пользователя.</p><h3 id="REMOVEACCOUNTSUBSET" tabindex="-1"><code>REMOVEACCOUNTSUBSET accountName SUBSET subsetName</code> <a class="header-anchor" href="#REMOVEACCOUNTSUBSET" aria-label="Permalink to &quot;`REMOVEACCOUNTSUBSET accountName SUBSET subsetName` {#REMOVEACCOUNTSUBSET}&quot;">​</a></h3><p>Используйте эту команду для удаления &quot;набора данных&quot; Пользователя (например, такого, как адресная книга <code>RepliedAddresses</code>).</p><p>Использование этой команды доступно либо самому Пользователю, либо Пользователю, имеющем право доступа <a href="./../admin/sysadmin/#Domain">Основные Установки</a> Администратора Домена.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>subsetName : строка</code></p><p>В этом параметре задаётся имя существующего у указанного Пользователя набора данных.</p></li></ul><h3 id="DATASET" tabindex="-1"><code>DATASET accountName parameters</code> <a class="header-anchor" href="#DATASET" aria-label="Permalink to &quot;`DATASET accountName parameters` {#DATASET}&quot;">​</a></h3><p>Используйте эту команду для управления набором данных Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся результаты операции.</p><p>Использование этой команды доступно либо самому Пользователю, либо Пользователю, имеющем право доступа <a href="./../admin/sysadmin/#Domain">Основные Установки</a> Администратора Домена.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>parameters : словарь</code></p><p>Этот словарь должен содержать:</p><ul><li><p><code>subsetName : строка</code></p><p>строка, задающая набор данных или его подмножество</p></li><li><p><code>what</code></p><p>строка с типом выполняемой операции. Другие элементы словаря зависят от типа операции. Ниже перечисляются доступные операции (значения <code>what</code>) и дополнительные элементы словаря <em>parameters</em> для каждой операции:</p></li></ul></li><li><p><code>listSubsets</code></p><p>операция перечисляет все разделы Набора Данных Пользователя. Чтобы перечислить Наборы Данных верхнего уровня Пользователя, в качестве значения <code>subsetName</code> пустую строку. Словарь результата будет содержать имена найденных подмножеств в качестве ключей и пустые строки в качестве их значений.</p></li><li><p><code>createSet</code></p><p>операция создаёт указанный Набор Данных.</p></li><li><p><code>removeSet</code></p><p>операция удаляет указанный Набор Данных.</p></li><li><p><code>listEntries</code></p><p>операция выдаёт список элементов подмножества. Словарь результата будет содержать имена найденных элементов в качестве ключей и атрибуты этих элементов виде словарей.</p><ul><li><p><code>attribute</code>, <code>data</code></p><p>необязательный строковые элементы; указывают имя и значение атрибута. Если они указаны, то операция возвращает только те данные, у которых указанный атрибут имеет указанное значение. Для фильтрации по именам элементов используйте имя атрибута <code>entry</code>.</p></li><li><p><code>mode</code></p><p>необязательная строка, задающая режим сравнения; если она отсутствует или её значение равно <code>eq</code>, тогда указанный атрибут должен быть равен указанному значению;<br> если её значение <code>beg</code>, тогда начало значения атрибута должно совпадать с указанным значением;<br> если её значение <code>end</code>, то конец значения атрибута должен совпадать с указанным значением;<br> если её значение <code>incl</code>, значение указанного атрибута должно включать в себя указанное значение.</p></li></ul></li><li><p><code>setEntry</code></p><p>эта операция создаёт новую запись или изменяет запись.</p><ul><li><p><code>data</code></p><p>словарь с парами ключ-значение атрибутов; они используются для создания новой записи или изменения существующей.</p></li><li><p><code>entryName</code></p><p>строка с именем записи; если записи с таким названием не существует, то она будет создана. Если этот элемент отсутствует, для новой записи генерируется уникальное имя.</p></li><li><p><code>ifExists</code></p><p>если параметр задан, тогда новая запись не может быть создана, и только существующая запись может быть изменена; если параметр не задан, а указанный набор данных не существует, он создаётся.</p></li></ul></li><li><p><code>deleteEntry</code></p><p>операция удаляет указанную запись из указанного Набора Данных.</p><ul><li><p><code>entryName</code></p><p>строка с именем записи</p></li></ul></li><li><p><code>addRandomEntry</code></p><p>операция добавляет новую запись в набор данных или его подмножество. Генерируется уникальное имя для новой записи. Если операция успешна, в словаре результата будет элемент <code>entryName</code> с именем созданной записи.</p><ul><li><p><code>data</code></p><p>словарь с парами ключ-значение атрибутов. Он должен содержать атрибут addressbook.Email.</p></li><li><p><code>entryLimit</code></p><p>необязательное число; если указано и больше нуля, то операция проверяет текущее количество записей в подмножестве набора данных и не превышает этот предел. Если набор данных уже содержит запись с таким же значением атрибута addressbook.Email, набор данных не изменяется.</p></li></ul></li><li><p><code>findAddress</code></p><p>эта операция находит запись с указанным значением атрибута addressbook.Email. Результат операции является словарём. Если запись найдена, её имя в словаре результатом передаётся как элемент с пустым именем.</p><ul><li><p><code>address</code></p><p>строка с искомым адресом электронной почты</p></li></ul></li></ul><h3 id="ROSTER" tabindex="-1"><code>ROSTER accountName parameters</code> <a class="header-anchor" href="#ROSTER" aria-label="Permalink to &quot;`ROSTER accountName parameters` {#ROSTER}&quot;">​</a></h3><p>Используйте эту команду для управления Ростером Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся результаты операции.</p><p>Использование этой команды доступно либо самому Пользователю, либо Пользователю, имеющем право доступа <a href="./../admin/sysadmin/#Domain">Основные Установки</a> Администратора Домена.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>parameters : словарь</code></p><p>Этот словарь должен содержать элемент <code>what</code>, строка которого задаёт применяемую операцию: <code>List</code>, <code>Update</code>, <code>remove</code>, <code>Presence</code>, <code>probe</code>. Другие элементы словаря зависят от типа операции.</p></li></ul><h3 id="BALANCE" tabindex="-1"><code>BALANCE accountName parameters</code> <a class="header-anchor" href="#BALANCE" aria-label="Permalink to &quot;`BALANCE accountName parameters` {#BALANCE}&quot;">​</a></h3><p>Используйте эту команду для управления балансовыми Остатками Пользователя. Эта команда возвращает <em>словарь</em>, в котором содержатся результаты операции (согласно описанию, приведённому в разделе <a href="./../admin/misc/Billing.html">Тарификация</a>).</p><p>Использование этой команды доступно либо самому Пользователю, либо Пользователю, имеющем право доступа <a href="./../admin/sysadmin/#Domain">Может Кредитовать Пользователей (CanCreditAccounts)</a> Администратора Домена.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>parameters : словарь</code></p><p>Этот словарь должен содержать строковый элемент <code>op</code>, задающий применяемую операцию: <code>list</code>, <code>reserve</code>, <code>release</code>, <code>charge</code>, <code>credit</code>, <code>read</code>, <code>readAll</code>, <code>history</code>, <code>remove</code>. Другие элементы словаря зависят от типа операции; их описание приведено в разделе <a href="./../admin/misc/Billing.html">Тарификация</a>.</p></li></ul><h2 id="Settings" tabindex="-1">Установки Сервера <a class="header-anchor" href="#Settings" aria-label="Permalink to &quot;Установки Сервера {#Settings}&quot;">​</a></h2><p>Пользователь должен иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Установки</a> Интерфейса Администрирования Сервера для использования команд CLI, затрагивающих Установки Сервера.</p><h3 id="LISTMODULES" tabindex="-1"><code>LISTMODULES</code> <a class="header-anchor" href="#LISTMODULES" aria-label="Permalink to &quot;`LISTMODULES` {#LISTMODULES}&quot;">​</a></h3><p>Используйте эту команду для получения списка модулей Сервера. Эта команда возвращает <em>массив</em> с именами модулей.</p><h3 id="GETMODULE" tabindex="-1"><code>GETMODULE moduleName</code> <a class="header-anchor" href="#GETMODULE" aria-label="Permalink to &quot;`GETMODULE moduleName` {#GETMODULE}&quot;">​</a></h3><p>Используйте эту команду для получения установок модуля. Эта команда возвращает <em>словарь</em>, в котором содержатся установки модуля.</p><ul><li><p><code>moduleName : строка</code></p><p>В этом параметре задаётся имя модуля Сервера CommuniGate Pro.</p></li></ul><h3 id="SETMODULE" tabindex="-1"><code>SETMODULE moduleName newSettings</code> <a class="header-anchor" href="#SETMODULE" aria-label="Permalink to &quot;`SETMODULE moduleName newSettings` {#SETMODULE}&quot;">​</a></h3><p>Используйте эту команду для изменения установок модуля.</p><ul><li><p><code>moduleName : строка</code></p><p>В этом параметре задаётся имя модуля Сервера CommuniGate Pro.</p></li><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками модуля.</p></li></ul><h3 id="UPDATEMODULE" tabindex="-1"><code>UPDATEMODULE moduleName newSettings</code> <a class="header-anchor" href="#UPDATEMODULE" aria-label="Permalink to &quot;`UPDATEMODULE moduleName newSettings` {#UPDATEMODULE}&quot;">​</a></h3><p>Используйте эту команду для изменения установок модуля.</p><ul><li><p><code>moduleName : строка</code></p><p>В этом параметре задаётся имя модуля Сервера CommuniGate Pro.</p></li><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря установок модуля. Он не обязан содержать в себе все установки; отсутствующие в словаре установки просто не будут изменены.</p></li></ul><h3 id="GETQUEUESETTINGS" tabindex="-1"><code>GETQUEUESETTINGS</code> <a class="header-anchor" href="#GETQUEUESETTINGS" aria-label="Permalink to &quot;`GETQUEUESETTINGS` {#GETQUEUESETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Очереди. Эта команда возвращает <em>словарь</em>, в котором содержатся Установки Очереди.</p><h3 id="SETQUEUESETTINGS" tabindex="-1"><code>SETQUEUESETTINGS newSettings</code> <a class="header-anchor" href="#SETQUEUESETTINGS" aria-label="Permalink to &quot;`SETQUEUESETTINGS newSettings` {#SETQUEUESETTINGS}&quot;">​</a></h3><p>Используйте эту команду для задания Установок Очереди.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками Очереди.</p></li></ul><h3 id="GETSIGNALSETTINGS" tabindex="-1"><code>GETSIGNALSETTINGS</code> <a class="header-anchor" href="#GETSIGNALSETTINGS" aria-label="Permalink to &quot;`GETSIGNALSETTINGS` {#GETSIGNALSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Сигналов. Эта команда возвращает <em>словарь</em>, в котором содержатся установки компонента.</p><h3 id="SETSIGNALSETTINGS" tabindex="-1"><code>SETSIGNALSETTINGS newSettings</code> <a class="header-anchor" href="#SETSIGNALSETTINGS" aria-label="Permalink to &quot;`SETSIGNALSETTINGS newSettings` {#SETSIGNALSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для задания установок Сигналов.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками Сигналов.</p></li></ul><h3 id="GETMEDIASERVERSETTINGS" tabindex="-1"><code>GETMEDIASERVERSETTINGS</code> <a class="header-anchor" href="#GETMEDIASERVERSETTINGS" aria-label="Permalink to &quot;`GETMEDIASERVERSETTINGS` {#GETMEDIASERVERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для чтения установок компонента Медиасервера. Эта команда возвращает <em>словарь</em>, в котором содержатся установки компонента.</p><h3 id="SETMEDIASERVERSETTINGS" tabindex="-1"><code>SETMEDIASERVERSETTINGS newSettings</code> <a class="header-anchor" href="#SETMEDIASERVERSETTINGS" aria-label="Permalink to &quot;`SETMEDIASERVERSETTINGS newSettings` {#SETMEDIASERVERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для записи установок компонента Медиасервера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками компонента.</p></li></ul><h3 id="GETSESSIONSETTINGS" tabindex="-1"><code>GETSESSIONSETTINGS</code> <a class="header-anchor" href="#GETSESSIONSETTINGS" aria-label="Permalink to &quot;`GETSESSIONSETTINGS` {#GETSESSIONSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Сессий пользователя. Эта команда возвращает <em>словарь</em> с установками Сессий.</p><h3 id="SETSESSIONSETTINGS" tabindex="-1"><code>SETSESSIONSETTINGS newSettings</code> <a class="header-anchor" href="#SETSESSIONSETTINGS" aria-label="Permalink to &quot;`SETSESSIONSETTINGS newSettings` {#SETSESSIONSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для задания установок Сессий.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками Сессий.</p></li></ul><h3 id="GETCLUSTERSETTINGS" tabindex="-1"><code>GETCLUSTERSETTINGS</code> <a class="header-anchor" href="#GETCLUSTERSETTINGS" aria-label="Permalink to &quot;`GETCLUSTERSETTINGS` {#GETCLUSTERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Кластера. Эта команда возвращает <em>словарь</em>, в котором содержатся установки Кластера.</p><h3 id="SETCLUSTERSETTINGS" tabindex="-1"><code>SETCLUSTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETCLUSTERSETTINGS" aria-label="Permalink to &quot;`SETCLUSTERSETTINGS newSettings` {#SETCLUSTERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для задания установок Кластера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками Кластера.</p></li></ul><h3 id="GETLOGSETTINGS" tabindex="-1"><code>GETLOGSETTINGS</code> <a class="header-anchor" href="#GETLOGSETTINGS" aria-label="Permalink to &quot;`GETLOGSETTINGS` {#GETLOGSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок Журнала Сервера. Эта команда возвращает <em>словарь</em> с установками Журнала Сервера.</p><h3 id="UPDATELOGSETTINGS" tabindex="-1"><code>UPDATELOGSETTINGS newSettings</code> <a class="header-anchor" href="#UPDATELOGSETTINGS" aria-label="Permalink to &quot;`UPDATELOGSETTINGS newSettings` {#UPDATELOGSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения установок Журнала Сервера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Этот словарь используется для изменения словаря установок Журнала Сервера.</p></li></ul><h3 id="GETNETWORK" tabindex="-1"><code>GETNETWORK</code> <a class="header-anchor" href="#GETNETWORK" aria-label="Permalink to &quot;`GETNETWORK` {#GETNETWORK}&quot;">​</a></h3><p>Используйте эту команду для получения установок Сети. Эта команда возвращает <em>словарь</em> с установками Сети сервера.</p><h3 id="SETNETWORK" tabindex="-1"><code>SETNETWORK newSettings</code> <a class="header-anchor" href="#SETNETWORK" aria-label="Permalink to &quot;`SETNETWORK newSettings` {#SETNETWORK}&quot;">​</a></h3><p>Используйте эту команду для задания Установок Сети сервера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Новые установки Сети.</p></li></ul><h3 id="GETDNRSETTINGS" tabindex="-1"><code>GETDNRSETTINGS</code> <a class="header-anchor" href="#GETDNRSETTINGS" aria-label="Permalink to &quot;`GETDNRSETTINGS` {#GETDNRSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для получения установок DNR (Клиента DNS). Эта команда возвращает <em>словарь</em> с установками DNR.</p><h3 id="SETDNRSETTINGS" tabindex="-1"><code>SETDNRSETTINGS newSettings</code> <a class="header-anchor" href="#SETDNRSETTINGS" aria-label="Permalink to &quot;`SETDNRSETTINGS newSettings` {#SETDNRSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для записи установок DNR (Клиента DNS).</p><ul><li><p><code>newSettings : словарь</code></p><p>Новые установки DNR.</p></li></ul><h3 id="GETBANNED" tabindex="-1"><code>GETBANNED</code> <a class="header-anchor" href="#GETBANNED" aria-label="Permalink to &quot;`GETBANNED` {#GETBANNED}&quot;">​</a></h3><p>Используйте эту команду для получения установок Запрещённых Строк. Эта команда возвращает <em>словарь</em> с установками Запрещённые Строки сервера.</p><h3 id="SETBANNED" tabindex="-1"><code>SETBANNED newSettings</code> <a class="header-anchor" href="#SETBANNED" aria-label="Permalink to &quot;`SETBANNED newSettings` {#SETBANNED}&quot;">​</a></h3><p>Используйте эту команду для задания установок Запрещённых Строк сервера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Новая установка Запрещённых Строк сервера.</p></li></ul><h3 id="GETCLUSTERNETWORK" tabindex="-1"><code>GETCLUSTERNETWORK</code> <a class="header-anchor" href="#GETCLUSTERNETWORK" aria-label="Permalink to &quot;`GETCLUSTERNETWORK` {#GETCLUSTERNETWORK}&quot;">​</a></h3><h3 id="SETCLUSTERNETWORK" tabindex="-1"><code>SETCLUSTERNETWORK newSettings</code> <a class="header-anchor" href="#SETCLUSTERNETWORK" aria-label="Permalink to &quot;`SETCLUSTERNETWORK newSettings` {#SETCLUSTERNETWORK}&quot;">​</a></h3><p>Используйте эти команды для получения и изменения общекластерных установок Сети.</p><h3 id="GETCLUSTERBANNED" tabindex="-1"><code>GETCLUSTERBANNED</code> <a class="header-anchor" href="#GETCLUSTERBANNED" aria-label="Permalink to &quot;`GETCLUSTERBANNED` {#GETCLUSTERBANNED}&quot;">​</a></h3><h3 id="SETCLUSTERBANNED" tabindex="-1"><code>SETCLUSTERBANNED newSettings</code> <a class="header-anchor" href="#SETCLUSTERBANNED" aria-label="Permalink to &quot;`SETCLUSTERBANNED newSettings` {#SETCLUSTERBANNED}&quot;">​</a></h3><p>Используйте эти команды для получения и изменения общекластерных установок Запрещённых Строк.</p><h3 id="GETSERVERMAILRULES" tabindex="-1"><code>GETSERVERMAILRULES</code> <a class="header-anchor" href="#GETSERVERMAILRULES" aria-label="Permalink to &quot;`GETSERVERMAILRULES` {#GETSERVERMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для чтения Общесерверных Почтовых Правил. Эта команда возвращает <em>массив</em> Почтовых Правил Сервера.</p><h3 id="SETSERVERMAILRULES" tabindex="-1"><code>SETSERVERMAILRULES newRules</code> <a class="header-anchor" href="#SETSERVERMAILRULES" aria-label="Permalink to &quot;`SETSERVERMAILRULES newRules` {#SETSERVERMAILRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Общесерверных Почтовых Правил.</p><ul><li><p><code>newRules : массив</code></p><p>Массив с новыми Почтовыми Правилами Сервера.</p></li></ul><h3 id="GETSERVERSIGNALRULES" tabindex="-1"><code>GETSERVERSIGNALRULES</code> <a class="header-anchor" href="#GETSERVERSIGNALRULES" aria-label="Permalink to &quot;`GETSERVERSIGNALRULES` {#GETSERVERSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для чтения Общесерверных Сигнальных Правил. Эта команда возвращает <em>массив</em> с Сигнальными Правилами Сервера.</p><h3 id="SETSERVERSIGNALRULES" tabindex="-1"><code>SETSERVERSIGNALRULES newRules</code> <a class="header-anchor" href="#SETSERVERSIGNALRULES" aria-label="Permalink to &quot;`SETSERVERSIGNALRULES newRules` {#SETSERVERSIGNALRULES}&quot;">​</a></h3><p>Используйте эту команду для задания Общесерверных Сигнальных Правил.</p><ul><li><p><code>newRules : массив</code></p><p>Массив с новыми Сигнальными Правилами Сервера.</p></li></ul><h3 id="GETCLUSTERMAILRULES" tabindex="-1"><code>GETCLUSTERMAILRULES</code> <a class="header-anchor" href="#GETCLUSTERMAILRULES" aria-label="Permalink to &quot;`GETCLUSTERMAILRULES` {#GETCLUSTERMAILRULES}&quot;">​</a></h3><h3 id="SETCLUSTERMAILRULES" tabindex="-1"><code>SETCLUSTERMAILRULES newRules</code> <a class="header-anchor" href="#SETCLUSTERMAILRULES" aria-label="Permalink to &quot;`SETCLUSTERMAILRULES newRules` {#SETCLUSTERMAILRULES}&quot;">​</a></h3><h3 id="GETCLUSTERSIGNALRULES" tabindex="-1"><code>GETCLUSTERSIGNALRULES</code> <a class="header-anchor" href="#GETCLUSTERSIGNALRULES" aria-label="Permalink to &quot;`GETCLUSTERSIGNALRULES` {#GETCLUSTERSIGNALRULES}&quot;">​</a></h3><h3 id="SETCLUSTERSIGNALRULES" tabindex="-1"><code>SETCLUSTERSIGNALRULES newRules</code> <a class="header-anchor" href="#SETCLUSTERSIGNALRULES" aria-label="Permalink to &quot;`SETCLUSTERSIGNALRULES newRules` {#SETCLUSTERSIGNALRULES}&quot;">​</a></h3><p>Используйте эти команды для получения и изменения общекластерных Правил.</p><h3 id="GETROUTERTABLE" tabindex="-1"><code>GETROUTERTABLE</code> <a class="header-anchor" href="#GETROUTERTABLE" aria-label="Permalink to &quot;`GETROUTERTABLE` {#GETROUTERTABLE}&quot;">​</a></h3><p>Используйте эту команду для чтения Таблицы Маршрутизации. Эта команда возвращает <em>строку</em> (из нескольких строк) с текстом Таблицы Маршрутизации.</p><h3 id="SETROUTERTABLE" tabindex="-1"><code>SETROUTERTABLE newTable</code> <a class="header-anchor" href="#SETROUTERTABLE" aria-label="Permalink to &quot;`SETROUTERTABLE newTable` {#SETROUTERTABLE}&quot;">​</a></h3><p>Используйте эту команду для задания Таблицы Маршрутизации.</p><ul><li><p><code>newTable : строка</code></p><p>Строка (из несколько строк), в которой содержится текст новой Таблицы Маршрутизации. Обратите внимание: строки должны разделяться символами <code>\\e</code>.</p></li></ul><h3 id="GETROUTERSETTINGS" tabindex="-1"><code>GETROUTERSETTINGS</code> <a class="header-anchor" href="#GETROUTERSETTINGS" aria-label="Permalink to &quot;`GETROUTERSETTINGS` {#GETROUTERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для чтения установок Маршрутизации. Эта команда возвращает <em>словарь</em> с установками Маршрутизатора.</p><h3 id="SETROUTERSETTINGS" tabindex="-1"><code>SETROUTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETROUTERSETTINGS" aria-label="Permalink to &quot;`SETROUTERSETTINGS newSettings` {#SETROUTERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для задания установок Маршрутизатора.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми установками Маршрутизатора.</p></li></ul><h3 id="GETCLUSTERROUTERTABLE" tabindex="-1"><code>GETCLUSTERROUTERTABLE</code> <a class="header-anchor" href="#GETCLUSTERROUTERTABLE" aria-label="Permalink to &quot;`GETCLUSTERROUTERTABLE` {#GETCLUSTERROUTERTABLE}&quot;">​</a></h3><h3 id="SETCLUSTERROUTERTABLE" tabindex="-1"><code>SETCLUSTERROUTERTABLE newTable</code> <a class="header-anchor" href="#SETCLUSTERROUTERTABLE" aria-label="Permalink to &quot;`SETCLUSTERROUTERTABLE newTable` {#SETCLUSTERROUTERTABLE}&quot;">​</a></h3><h3 id="GETCLUSTERROUTERSETTINGS" tabindex="-1"><code>GETCLUSTERROUTERSETTINGS</code> <a class="header-anchor" href="#GETCLUSTERROUTERSETTINGS" aria-label="Permalink to &quot;`GETCLUSTERROUTERSETTINGS` {#GETCLUSTERROUTERSETTINGS}&quot;">​</a></h3><h3 id="SETCLUSTERROUTERSETTINGS" tabindex="-1"><code>SETCLUSTERROUTERSETTINGS newSettings</code> <a class="header-anchor" href="#SETCLUSTERROUTERSETTINGS" aria-label="Permalink to &quot;`SETCLUSTERROUTERSETTINGS newSettings` {#SETCLUSTERROUTERSETTINGS}&quot;">​</a></h3><p>Используйте эти команды для работы с общекластерной Таблицей Маршрутизации и установками Маршрутизатора.</p><h3 id="GETSERVERSETTINGS" tabindex="-1"><code>GETSERVERSETTINGS</code> <a class="header-anchor" href="#GETSERVERSETTINGS" aria-label="Permalink to &quot;`GETSERVERSETTINGS` {#GETSERVERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для чтения дополнительных установок Сервера. Эта команда возвращает <em>словарь</em> с дополнительными установками Сервера.</p><h3 id="UPDATESERVERSETTINGS" tabindex="-1"><code>UPDATESERVERSETTINGS newSettings</code> <a class="header-anchor" href="#UPDATESERVERSETTINGS" aria-label="Permalink to &quot;`UPDATESERVERSETTINGS newSettings` {#UPDATESERVERSETTINGS}&quot;">​</a></h3><p>Используйте эту команду для изменения дополнительных установок Сервера.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь с новыми Установками сервера.</p></li></ul><h3 id="REFRESHOSDATA" tabindex="-1"><code>REFRESHOSDATA</code> <a class="header-anchor" href="#REFRESHOSDATA" aria-label="Permalink to &quot;`REFRESHOSDATA` {#REFRESHOSDATA}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы заставить сервер прочитать заново данные об адресах IP из ОС Сервера: набор локальных адресов IP и набор адресов DNS.</p><h3 id="GETLANIPS" tabindex="-1"><code>GETLANIPS</code> <a class="header-anchor" href="#GETLANIPS" aria-label="Permalink to &quot;`GETLANIPS` {#GETLANIPS}&quot;">​</a></h3><p>Используйте эту команду для получения списка Адресов LAN. Эта команда возвращает <em>строку</em> (несколько строк) с Адресами LAN и диапазонами адресов.</p><h3 id="SETLANIPS" tabindex="-1"><code>SETLANIPS newAddresses</code> <a class="header-anchor" href="#SETLANIPS" aria-label="Permalink to &quot;`SETLANIPS newAddresses` {#SETLANIPS}&quot;">​</a></h3><p>Используйте эту команду для изменения списка Адресов LAN.</p><ul><li><p><code>newAddresses : строка</code></p><p>Этот параметр с типом строка (несколько строк) содержит набор адресов и диапазон адресов, задающие новый набор Адресов LAN.</p></li></ul><h3 id="GETCLUSTERLANIPS" tabindex="-1"><code>GETCLUSTERLANIPS</code> <a class="header-anchor" href="#GETCLUSTERLANIPS" aria-label="Permalink to &quot;`GETCLUSTERLANIPS` {#GETCLUSTERLANIPS}&quot;">​</a></h3><p>Используйте эту команду для получения общекластерного набора Адресов LAN. Эта команда возвращает <em>строку</em> (несколько строк) с общекластеными Адресами LAN и диапазонами адресов.</p><h3 id="SETCLUSTERLANIPS" tabindex="-1"><code>SETCLUSTERLANIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERLANIPS" aria-label="Permalink to &quot;`SETCLUSTERLANIPS newAddresses` {#SETCLUSTERLANIPS}&quot;">​</a></h3><p>Используйте эту команду для изменения общекластерного списка Адресов LAN.</p><ul><li><p><code>newAddresses : строка</code></p><p>Этот параметр с типом строка (несколько строк) содержит набор адресов и диапазон адресов, задающие новый набор общекластерных Адресов LAN.</p></li></ul><p>Следующие команды имеют одинаковые параметры и возвращают такие же данные, как команды <code>GETLANIPS | SETLANIPS | GETCLUSTERLANIPS | SETCLUSTERLANIPS</code>:</p><h3 id="GETPROXYIPS" tabindex="-1"><code>GETPROXYIPS</code> <a class="header-anchor" href="#GETPROXYIPS" aria-label="Permalink to &quot;`GETPROXYIPS` {#GETPROXYIPS}&quot;">​</a></h3><h3 id="SETPROXYIPS" tabindex="-1"><code>SETPROXYIPS newAddresses</code> <a class="header-anchor" href="#SETPROXYIPS" aria-label="Permalink to &quot;`SETPROXYIPS newAddresses` {#SETPROXYIPS}&quot;">​</a></h3><h3 id="GETCLUSTERPROXYIPS" tabindex="-1"><code>GETCLUSTERPROXYIPS</code> <a class="header-anchor" href="#GETCLUSTERPROXYIPS" aria-label="Permalink to &quot;`GETCLUSTERPROXYIPS` {#GETCLUSTERPROXYIPS}&quot;">​</a></h3><h3 id="SETCLUSTERPROXYIPS" tabindex="-1"><code>SETCLUSTERPROXYIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERPROXYIPS" aria-label="Permalink to &quot;`SETCLUSTERPROXYIPS newAddresses` {#SETCLUSTERPROXYIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Сетевых Адресов Доверенных Proxy Серверов.</p><h3 id="GETCLIENTIPS" tabindex="-1"><code>GETCLIENTIPS</code> <a class="header-anchor" href="#GETCLIENTIPS" aria-label="Permalink to &quot;`GETCLIENTIPS` {#GETCLIENTIPS}&quot;">​</a></h3><h3 id="SETCLIENTIPS" tabindex="-1"><code>SETCLIENTIPS newAddresses</code> <a class="header-anchor" href="#SETCLIENTIPS" aria-label="Permalink to &quot;`SETCLIENTIPS newAddresses` {#SETCLIENTIPS}&quot;">​</a></h3><h3 id="GETCLUSTERCLIENTIPS" tabindex="-1"><code>GETCLUSTERCLIENTIPS</code> <a class="header-anchor" href="#GETCLUSTERCLIENTIPS" aria-label="Permalink to &quot;`GETCLUSTERCLIENTIPS` {#GETCLUSTERCLIENTIPS}&quot;">​</a></h3><h3 id="SETCLUSTERCLIENTIPS" tabindex="-1"><code>SETCLUSTERCLIENTIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERCLIENTIPS" aria-label="Permalink to &quot;`SETCLUSTERCLIENTIPS newAddresses` {#SETCLUSTERCLIENTIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Сетевых Адресов Клиентов.</p><h3 id="GETBLACKLISTEDIPS" tabindex="-1"><code>GETBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETBLACKLISTEDIPS` {#GETBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="SETBLACKLISTEDIPS" tabindex="-1"><code>SETBLACKLISTEDIPS newAddresses</code> <a class="header-anchor" href="#SETBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETBLACKLISTEDIPS newAddresses` {#SETBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERBLACKLISTEDIPS" tabindex="-1"><code>GETCLUSTERBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETCLUSTERBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETCLUSTERBLACKLISTEDIPS` {#GETCLUSTERBLACKLISTEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERBLACKLISTEDIPS" tabindex="-1"><code>SETCLUSTERBLACKLISTEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETCLUSTERBLACKLISTEDIPS newAddresses` {#SETCLUSTERBLACKLISTEDIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Чёрного Списка (блокированных) Сетевых Адресов.</p><h3 id="GETWHITEHOLEIPS" tabindex="-1"><code>GETWHITEHOLEIPS</code> <a class="header-anchor" href="#GETWHITEHOLEIPS" aria-label="Permalink to &quot;`GETWHITEHOLEIPS` {#GETWHITEHOLEIPS}&quot;">​</a></h3><h3 id="SETWHITEHOLEIPS" tabindex="-1"><code>SETWHITEHOLEIPS newAddresses</code> <a class="header-anchor" href="#SETWHITEHOLEIPS" aria-label="Permalink to &quot;`SETWHITEHOLEIPS newAddresses` {#SETWHITEHOLEIPS}&quot;">​</a></h3><h3 id="GETCLUSTERWHITEHOLEIPS" tabindex="-1"><code>GETCLUSTERWHITEHOLEIPS</code> <a class="header-anchor" href="#GETCLUSTERWHITEHOLEIPS" aria-label="Permalink to &quot;`GETCLUSTERWHITEHOLEIPS` {#GETCLUSTERWHITEHOLEIPS}&quot;">​</a></h3><h3 id="SETCLUSTERWHITEHOLEIPS" tabindex="-1"><code>SETCLUSTERWHITEHOLEIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERWHITEHOLEIPS" aria-label="Permalink to &quot;`SETCLUSTERWHITEHOLEIPS newAddresses` {#SETCLUSTERWHITEHOLEIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Белого Списка (неблокируемых) Сетевых Адресов.</p><h3 id="GETNATEDIPS" tabindex="-1"><code>GETNATEDIPS</code> <a class="header-anchor" href="#GETNATEDIPS" aria-label="Permalink to &quot;`GETNATEDIPS` {#GETNATEDIPS}&quot;">​</a></h3><h3 id="SETNATEDIPS" tabindex="-1"><code>SETNATEDIPS newAddresses</code> <a class="header-anchor" href="#SETNATEDIPS" aria-label="Permalink to &quot;`SETNATEDIPS newAddresses` {#SETNATEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERNATEDIPS" tabindex="-1"><code>GETCLUSTERNATEDIPS</code> <a class="header-anchor" href="#GETCLUSTERNATEDIPS" aria-label="Permalink to &quot;`GETCLUSTERNATEDIPS` {#GETCLUSTERNATEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERNATEDIPS" tabindex="-1"><code>SETCLUSTERNATEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERNATEDIPS" aria-label="Permalink to &quot;`SETCLUSTERNATEDIPS newAddresses` {#SETCLUSTERNATEDIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Частных Сетевых Адресов (NAT).</p><h3 id="GETNATSITEIPS" tabindex="-1"><code>GETNATSITEIPS</code> <a class="header-anchor" href="#GETNATSITEIPS" aria-label="Permalink to &quot;`GETNATSITEIPS` {#GETNATSITEIPS}&quot;">​</a></h3><h3 id="SETNATSITEIPS" tabindex="-1"><code>SETNATSITEIPS newAddresses</code> <a class="header-anchor" href="#SETNATSITEIPS" aria-label="Permalink to &quot;`SETNATSITEIPS newAddresses` {#SETNATSITEIPS}&quot;">​</a></h3><h3 id="GETCLUSTERNATSITEIPS" tabindex="-1"><code>GETCLUSTERNATSITEIPS</code> <a class="header-anchor" href="#GETCLUSTERNATSITEIPS" aria-label="Permalink to &quot;`GETCLUSTERNATSITEIPS` {#GETCLUSTERNATSITEIPS}&quot;">​</a></h3><h3 id="SETCLUSTERNATSITEIPS" tabindex="-1"><code>SETCLUSTERNATSITEIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERNATSITEIPS" aria-label="Permalink to &quot;`SETCLUSTERNATSITEIPS newAddresses` {#SETCLUSTERNATSITEIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Сетевых Адресов Шлюзов в частные сети (NAT Sites).</p><h3 id="GETDEBUGIPS" tabindex="-1"><code>GETDEBUGIPS</code> <a class="header-anchor" href="#GETDEBUGIPS" aria-label="Permalink to &quot;`GETDEBUGIPS` {#GETDEBUGIPS}&quot;">​</a></h3><h3 id="SETDEBUGIPS" tabindex="-1"><code>SETDEBUGIPS newAddresses</code> <a class="header-anchor" href="#SETDEBUGIPS" aria-label="Permalink to &quot;`SETDEBUGIPS newAddresses` {#SETDEBUGIPS}&quot;">​</a></h3><h3 id="GETCLUSTERDEBUGIPS" tabindex="-1"><code>GETCLUSTERDEBUGIPS</code> <a class="header-anchor" href="#GETCLUSTERDEBUGIPS" aria-label="Permalink to &quot;`GETCLUSTERDEBUGIPS` {#GETCLUSTERDEBUGIPS}&quot;">​</a></h3><h3 id="SETCLUSTERDEBUGIPS" tabindex="-1"><code>SETCLUSTERDEBUGIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERDEBUGIPS" aria-label="Permalink to &quot;`SETCLUSTERDEBUGIPS newAddresses` {#SETCLUSTERDEBUGIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Сетевых Адресов Отладки.</p><h3 id="GETDENIEDIPS" tabindex="-1"><code>GETDENIEDIPS</code> <a class="header-anchor" href="#GETDENIEDIPS" aria-label="Permalink to &quot;`GETDENIEDIPS` {#GETDENIEDIPS}&quot;">​</a></h3><h3 id="SETDENIEDIPS" tabindex="-1"><code>SETDENIEDIPS newAddresses</code> <a class="header-anchor" href="#SETDENIEDIPS" aria-label="Permalink to &quot;`SETDENIEDIPS newAddresses` {#SETDENIEDIPS}&quot;">​</a></h3><h3 id="GETCLUSTERDENIEDIPS" tabindex="-1"><code>GETCLUSTERDENIEDIPS</code> <a class="header-anchor" href="#GETCLUSTERDENIEDIPS" aria-label="Permalink to &quot;`GETCLUSTERDENIEDIPS` {#GETCLUSTERDENIEDIPS}&quot;">​</a></h3><h3 id="SETCLUSTERDENIEDIPS" tabindex="-1"><code>SETCLUSTERDENIEDIPS newAddresses</code> <a class="header-anchor" href="#SETCLUSTERDENIEDIPS" aria-label="Permalink to &quot;`SETCLUSTERDENIEDIPS newAddresses` {#SETCLUSTERDENIEDIPS}&quot;">​</a></h3><p>Используйте эти команды для получения и установки общекластерных и общесерверных Игнорируемых Сетевых Адресов.</p><p>Пользователь должен иметь права доступа к разделам <a href="./../admin/sysadmin/#Privs">Установки</a> или <a href="./../admin/sysadmin/#Privs">Пользователи</a> Интерфейса Администратора Сервера для использования следующих команд CLI.</p><h3 id="ROUTE" tabindex="-1"><code>ROUTE address [ mail | access | signal ]</code> <a class="header-anchor" href="#ROUTE" aria-label="Permalink to &quot;`ROUTE address [ mail | access | signal ]` {#ROUTE}&quot;">​</a></h3><p>Используйте эту команду для получения маршрута указанного адреса.</p><ul><li><p><code>address : строка</code></p><p>В этом параметре задаётся адрес электронной почты, обрабатываемый Маршрутизатором CommuniGate Pro.</p></li><li><p><code>mail</code> или <code>access</code> или <code>signal</code></p><p>Эти необязательные флаги задают тип Маршрутизации (дополнительную информацию смотрите в разделе <a href="./../admin/sysadmin/Router.html">Маршрутизатор</a>). Режимом по умолчанию является <code>access</code>. Эта команда возвращает массив из трёх строк:</p></li><li><p><em>module</em></p><p>имя модуля CommuniGate Pro, в который направляется адрес или <code>SYSTEM</code> если адрес маршрутизируется на встроенный &quot;адрес&quot; (такой как <code>NULL</code>).</p></li><li><p><em>host</em></p><p>объект/очередь, обрабатываемая указанным модулем: для модуля SMTP это будет именем Домена в Интернет, для модуля Местной Доставки - локальное имя пользователя и т.д.</p></li><li><p><em>address</em></p><p>адрес внутри очереди (адрес электронной почты для SMTP, адрес Real-To: для модуля Местной Доставки и т.д.).</p></li></ul><h3 id="GETIPSTATE" tabindex="-1"><code>GETIPSTATE ip-address [ TEMP ]</code> <a class="header-anchor" href="#GETIPSTATE" aria-label="Permalink to &quot;`GETIPSTATE ip-address [ TEMP ]` {#GETIPSTATE}&quot;">​</a></h3><p>Используйте эту команду для получения статуса для указанного адреса IP. Эта команда возвращает <em>строку</em> с типом адреса IP. Если указано ключевое слово TEMP, проверяется набор адресов Временных Клиентов.</p><ul><li><p><code>ip-address : строка или адрес IP</code></p><p>В этом параметре задаётся IP адрес для проверки.</p></li></ul><p>Пользователь должен иметь права доступа к разделу <a href="./../admin/sysadmin/#Privs">Главное</a> Интерфейса Администратора Сервера для использования следующих команд CLI.</p><h3 id="GETSERVERINTERCEPT" tabindex="-1"><code>GETSERVERINTERCEPT</code> <a class="header-anchor" href="#GETSERVERINTERCEPT" aria-label="Permalink to &quot;`GETSERVERINTERCEPT` {#GETSERVERINTERCEPT}&quot;">​</a></h3><p>Используйте эту команду для чтения установок СОРМ - перехвата сообщений. Эта команда возвращает <em>словарь</em> с установками Перехвата.</p><h3 id="SETSERVERINTERCEPT" tabindex="-1"><code>SETSERVERINTERCEPT newSettings</code> <a class="header-anchor" href="#SETSERVERINTERCEPT" aria-label="Permalink to &quot;`SETSERVERINTERCEPT newSettings` {#SETSERVERINTERCEPT}&quot;">​</a></h3><p>Используйте эту команду для задания установок СОРМ - перехвата сообщений.</p><ul><li><p><code>newSettings : словарь</code></p><p>Словарь, содержащий установки Перехвата.</p></li></ul><h3 id="GETCLUSTERINTERCEPT" tabindex="-1"><code>GETCLUSTERINTERCEPT</code> <a class="header-anchor" href="#GETCLUSTERINTERCEPT" aria-label="Permalink to &quot;`GETCLUSTERINTERCEPT` {#GETCLUSTERINTERCEPT}&quot;">​</a></h3><h3 id="SETCLUSTERINTERCEPT" tabindex="-1"><code>SETCLUSTERINTERCEPT newSettings</code> <a class="header-anchor" href="#SETCLUSTERINTERCEPT" aria-label="Permalink to &quot;`SETCLUSTERINTERCEPT newSettings` {#SETCLUSTERINTERCEPT}&quot;">​</a></h3><p>Эти команды аналогичны командам GETSERVERINTERCEPT и SETSERVERINTERCEPT, но они работают с общекластерными установками СОРМ - перехвата сообщений.</p><h2 id="Monitor" tabindex="-1">Наблюдение <a class="header-anchor" href="#Monitor" aria-label="Permalink to &quot;Наблюдение {#Monitor}&quot;">​</a></h2><p>Пользователь должен иметь право доступа к разделу <a href="./../admin/sysadmin/#Privs">Наблюдение</a> Интерфейса Администрирования Сервера для использования команд CLI для Наблюдения за Сервером.</p><h3 id="GETSTATELEMENT" tabindex="-1"><code>GETSTATELEMENT ObjectID</code> <a class="header-anchor" href="#GETSTATELEMENT" aria-label="Permalink to &quot;`GETSTATELEMENT ObjectID` {#GETSTATELEMENT}&quot;">​</a></h3><p>Используйте эту команду для получения текущих значений элементов статистики сервера (SNMP).</p><ul><li><p><code>ObjectID : строка</code></p><p>Идентификатор элемента статистики сервера (дополнительную информацию смотрите в разделе <a href="./../admin/sysadmin/Statistics.html">SNMP</a>). Эта команда возвращает <em>число</em>, <em>строку</em> или другой объект со значением элемента статистики сервера.</p></li></ul><h3 id="SETSTATELEMENT" tabindex="-1"><code>SETSTATELEMENT ObjectID [ INC | SET ] setValue</code> <a class="header-anchor" href="#SETSTATELEMENT" aria-label="Permalink to &quot;`SETSTATELEMENT ObjectID [ INC | SET ] setValue` {#SETSTATELEMENT}&quot;">​</a></h3><p>Используйте эту команду для изменения значений элементов статистики сервера (SNMP). Изменять можно только Модифицируемые Элементы Статистики.</p><ul><li><p><code>ObjectID : строка</code></p><p>Идентификатор элемента статистики сервера (дополнительную информацию смотрите в разделе <a href="./../admin/sysadmin/Statistics.html">SNMP</a>).</p></li><li><p><code>setValue : числовая строка</code></p><p>при использовании ключевого слова <code>INC</code> значение прибавляется к текущему значению счётчика статистики, при использовании <code>SET</code> значение записывается в счётчик.</p></li></ul><h3 id="GETNEXTSTATNAME" tabindex="-1"><code>GETNEXTSTATNAME ObjectID</code> <a class="header-anchor" href="#GETNEXTSTATNAME" aria-label="Permalink to &quot;`GETNEXTSTATNAME ObjectID` {#GETNEXTSTATNAME}&quot;">​</a></h3><p>Используйте эту команду для перебора всех элементов статистики сервера (SNMP).</p><ul><li><p><code>ObjectID : строка</code></p><p>Идентификатор элемента статистики сервера (дополнительную информацию смотрите в разделе <a href="./../admin/sysadmin/Statistics.html">SNMP</a>). Эта команда возвращает <em>строку</em> с ObjectID следующего элемента статистики. Если значением параметра ObjectID передана пустая строка, команда выдаёт идентификатор первого элемента статистики. Команда возвращает код ошибки, если указанный в ObjectID элемент статистики не найден, или найден последний элемент.</p></li></ul><h3 id="GETDIALOGINFO" tabindex="-1"><code>GETDIALOGINFO DialogID</code> <a class="header-anchor" href="#GETDIALOGINFO" aria-label="Permalink to &quot;`GETDIALOGINFO DialogID` {#GETDIALOGINFO}&quot;">​</a></h3><p>Используйте эту команду для получения информации об Объекте Диалога Сигналов.</p><ul><li><p><code>DialogID : число</code></p><p>Идентификатор Диалога. Эта команда возвращает <em>словарь</em> с данными статуса Диалога.</p></li></ul><h3 id="SHUTDOWN" tabindex="-1"><code>SHUTDOWN</code> <a class="header-anchor" href="#SHUTDOWN" aria-label="Permalink to &quot;`SHUTDOWN` {#SHUTDOWN}&quot;">​</a></h3><p>Используйте эту команду для остановки Сервера CommuniGate Pro.</p><h2 id="Stats" tabindex="-1">Статистика <a class="header-anchor" href="#Stats" aria-label="Permalink to &quot;Статистика {#Stats}&quot;">​</a></h2><p>Статистические данные Пользователя собираются при условии, что у Пользователя включена опция Статистика. Для включения этой опции, Откройте в разделе Установки Веб Интерфейса Администратора Сервера CommuniGate Pro страницу Общее, затем на странице Прочее найдите панель Локальные Пользователи.</p><h3 id="GETACCOUNTSTAT" tabindex="-1"><code>GETACCOUNTSTAT accountName [ KEY keyName ]</code> <a class="header-anchor" href="#GETACCOUNTSTAT" aria-label="Permalink to &quot;`GETACCOUNTSTAT accountName [ KEY keyName ]` {#GETACCOUNTSTAT}&quot;">​</a></h3><p>Используйте эту команду для получения статистических данных об указанном Пользователе.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>keyName : строка</code></p><p>Этот необязательный параметр задаёт имя ключа со статистической информацией, который необходимо получить. Эта команда возвращает <em>число</em> или <em>отметку времени</em> с затребованной статистической информацией или (если ключевое слово <code>KEY</code> и параметр <em>keyName</em> не указаны) <em>словарь</em> со всеми доступными статистическими данными. Если статистические данные для указанного ключа не существуют, то возвращается пустая <em>строка.</em><br> Для использования этой команды необходимо обладать для требуемого Домена правами Администратора. Все пользователи могут получать о себе статистическую информацию.</p></li></ul><h3 id="RESETACCOUNTSTAT" tabindex="-1"><code>RESETACCOUNTSTAT accountName [ KEY keyName ]</code> <a class="header-anchor" href="#RESETACCOUNTSTAT" aria-label="Permalink to &quot;`RESETACCOUNTSTAT accountName [ KEY keyName ]` {#RESETACCOUNTSTAT}&quot;">​</a></h3><p>Используйте эту команду для очистки статистических данных указанного Пользователя.</p><ul><li><p><code>accountName : строка</code></p><p>В этом параметре задаётся имя существующего Пользователя. Символ звёздочка (<code>*</code>) может использоваться для указания текущего аутентифицированного Пользователя.</p></li><li><p><code>keyName : строка</code></p><p>Этот необязательный параметр задаёт имя ключа записи статистической информации, который необходимо сбросить. Если ключевое слово <code>KEY</code> и параметр <em>keyName</em> не указаны, то все статистические данные Пользователя сбрасываются. Для использования этой команды необходимо обладать для Домена Пользователя правом Администратора Домена &quot;Основные Установки&quot;.</p></li></ul><p>Реализованы следующие ключи со статистическими данными Пользователя:</p><table tabindex="0"><thead><tr><th>Имя Ключа</th><th>Значение</th></tr></thead><tbody><tr><td><code>StatReset</code></td><td>Дата и время отправки этому Пользователю последней команды <code>RESETACCOUNTSTAT</code> без параметров</td></tr><tr><td><code>MessagesReceived</code></td><td>Общее число сообщений, доставленных Пользователю</td></tr><tr><td><code>BytesReceived</code></td><td>Общий размер всех сообщений, доставленных Пользователю</td></tr><tr><td><code>MessagesSent</code></td><td>Общее число сообщений, отправленных от имени Пользователя</td></tr><tr><td><code>BytesSent</code></td><td>Общее размер всех сообщений, отправленных от имени Пользователя</td></tr><tr><td><code>CallsReceived</code></td><td>Общее число вызовов, полученных Пользователем</td></tr><tr><td><code>CallsSent</code></td><td>Общее число вызовов, совершённых от имени Пользователя</td></tr><tr><td><code>Logins</code></td><td>Общее число успешных аутентификаций Пользователя</td></tr></tbody></table><h3 id="GETDOMAINSTAT" tabindex="-1"><code>GETDOMAINSTAT domainName [ KEY keyName ]</code> <a class="header-anchor" href="#GETDOMAINSTAT" aria-label="Permalink to &quot;`GETDOMAINSTAT domainName [ KEY keyName ]` {#GETDOMAINSTAT}&quot;">​</a></h3><p>Используйте эту команду для получения статистических данных об указанном Домене.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена. Символ звёздочка (<code>*</code>) может использоваться для указания Домена текущего аутентифицированного Пользователя.</p></li><li><p><code>keyName : строка</code></p><p>Этот необязательный параметр задаёт имя ключа со статистической информацией, который необходимо получить. Эта команда возвращает <em>строку</em> с затребованной статистической информацией или (если ключевое слово <code>KEY</code> и параметр <em>keyName</em> не указаны) <em>словарь</em> со всеми доступными статистическими данными. Для использования этой команды необходимо обладать для требуемого Домена правами Администратора.</p></li></ul><h3 id="RESETDOMAINSTAT" tabindex="-1"><code>RESETDOMAINSTAT domainName [ KEY keyName ]</code> <a class="header-anchor" href="#RESETDOMAINSTAT" aria-label="Permalink to &quot;`RESETDOMAINSTAT domainName [ KEY keyName ]` {#RESETDOMAINSTAT}&quot;">​</a></h3><p>Используйте эту команду для очистки статистических данных об указанном Домене.</p><ul><li><p><code>domainName : строка</code></p><p>В этом параметре задаётся имя существующего Домена. Символ звёздочка (<code>*</code>) может использоваться для указания Домена текущего аутентифицированного Пользователя.</p></li><li><p><code>keyName : строка</code></p><p>Этот необязательный параметр задаёт имя ключа записи статистической информации, который необходимо сбросить. Если ключевое слово <code>KEY</code> и параметр <em>keyName</em> не указаны, то все статистические данные Домена сбрасываются. Для использования этой команды необходимо обладать для требуемого Домена правом Администратора &quot;Основные Установки &quot;.</p></li></ul><p>Реализованы следующие ключи со статистическими данными о Домене:</p><table tabindex="0"><thead><tr><th>Имя Ключа</th><th>Значение</th></tr></thead><tbody><tr><td><code>StatReset</code></td><td>Дата и время отправки этому Пользователю последней команды <code>RESETACCOUNTSTAT</code> без параметров</td></tr><tr><td><code>MessagesReceived</code></td><td>Общее число сообщений, доставленных Пользователю</td></tr><tr><td><code>BytesReceived</code></td><td>Общий размер всех сообщений, доставленных Пользователю</td></tr><tr><td><code>MessagesSent</code></td><td>Общее число сообщений, отправленных от имени Пользователя</td></tr><tr><td><code>BytesSent</code></td><td>Общее размер всех сообщений, отправленных от имени Пользователя</td></tr><tr><td><code>CallsReceived</code></td><td>Общее число вызовов, полученных Пользователем</td></tr><tr><td><code>CallsSent</code></td><td>Общее число вызовов, совершённых от имени Пользователя</td></tr><tr><td><code>Logins</code></td><td>Общее число успешных аутентификаций Пользователя</td></tr></tbody></table><h2 id="Directory" tabindex="-1">Управление Справочником <a class="header-anchor" href="#Directory" aria-label="Permalink to &quot;Управление Справочником {#Directory}&quot;">​</a></h2><p>Пользователь должен иметь право доступа к Серверу <a href="./../admin/sysadmin/#Privs">Справочник</a> для использования команд CLI для Управления Справочником.</p><h3 id="LISTDIRECTORYUNITS" tabindex="-1"><code>LISTDIRECTORYUNITS [ SHARED ]</code> <a class="header-anchor" href="#LISTDIRECTORYUNITS" aria-label="Permalink to &quot;`LISTDIRECTORYUNITS [ SHARED ]` {#LISTDIRECTORYUNITS}&quot;">​</a></h3><p>Используйте эту команду для получения списка хранилищ Справочника. Если использовано ключевое слово SHARED, выдаётся список общекластерных хранилищ.</p><p>Эта команда возвращает словарь, ключами которого являются DN точек монтирования хранилищ, а значениями - имена хранилищ.</p><h3 id="CREATEDIRECTORYUNIT" tabindex="-1"><code>CREATEDIRECTORYUNIT unitName [ SHARED ] [ REMOTE ] mountPoint</code> <a class="header-anchor" href="#CREATEDIRECTORYUNIT" aria-label="Permalink to &quot;`CREATEDIRECTORYUNIT unitName [ SHARED ] [ REMOTE ] mountPoint` {#CREATEDIRECTORYUNIT}&quot;">​</a></h3><p>Используйте эту команду для создания нового хранилища Справочника.</p><ul><li><p><code>unitName : строка</code></p><p>В этом параметре задаётся имя нового хранилища.</p></li><li><p><code>mountPoint : строка</code></p><p>В этом параметре задаётся точка монтирования (DN) нового хранилища. Если использовано ключевое слово SHARED, создаётся общекластерное хранилище. Если использовано ключевое слово REMOTE , создаётся Удалённое Хранилище (по протоколу LDAP), иначе создаётся Локальное хранилище (на файлах).</p></li></ul><h3 id="RELOCATEDIRECTORYUNIT" tabindex="-1"><code>RELOCATEDIRECTORYUNIT unitName [ SHARED ] newMountPoint</code> <a class="header-anchor" href="#RELOCATEDIRECTORYUNIT" aria-label="Permalink to &quot;`RELOCATEDIRECTORYUNIT unitName [ SHARED ] newMountPoint` {#RELOCATEDIRECTORYUNIT}&quot;">​</a></h3><p>Используйте эту команду для перемонтирования существующего хранилища на другой точки монтирования.</p><ul><li><p><code>unitName : строка</code></p><p>В этом параметре задаётся имя хранилища. Если использовано ключевое слово SHARED, создаётся общекластерное хранилище.</p></li><li><p><code>mountPoint : строка</code></p><p>В этом параметре задаётся новая точка монтирования (DN) хранилища.</p></li></ul><h3 id="DELETEDIRECTORYUNIT" tabindex="-1"><code>DELETEDIRECTORYUNIT unitName [ SHARED ]</code> <a class="header-anchor" href="#DELETEDIRECTORYUNIT" aria-label="Permalink to &quot;`DELETEDIRECTORYUNIT unitName [ SHARED ]` {#DELETEDIRECTORYUNIT}&quot;">​</a></h3><p>Используйте эту команду для удаления существующего хранилища Справочника.</p><ul><li><p><code>unitName : строка</code></p><p>В этом параметре задаётся имя хранилища. Если использовано ключевое слово SHARED, удаляется общекластерное хранилище.</p></li></ul><h3 id="GETDIRECTORYUNIT" tabindex="-1"><code>GETDIRECTORYUNIT unitName [ SHARED ]</code> <a class="header-anchor" href="#GETDIRECTORYUNIT" aria-label="Permalink to &quot;`GETDIRECTORYUNIT unitName [ SHARED ]` {#GETDIRECTORYUNIT}&quot;">​</a></h3><p>Используйте эту команду для получения установок Хранилища Справочника.</p><ul><li><p><code>unitName : строка</code></p><p>В этом параметре задаётся имя хранилища. Если использовано ключевое слово SHARED, используется общекластерное хранилище. Эта команда возвращает словарь, в котором содержатся установки Хранилища Справочника.</p></li></ul><h3 id="SETDIRECTORYUNIT" tabindex="-1"><code>SETDIRECTORYUNIT unitName [ SHARED ] newSettings</code> <a class="header-anchor" href="#SETDIRECTORYUNIT" aria-label="Permalink to &quot;`SETDIRECTORYUNIT unitName [ SHARED ] newSettings` {#SETDIRECTORYUNIT}&quot;">​</a></h3><p>Используйте эту команду для изменения установок существующего хранилища Справочника.</p><ul><li><p><code>unitName : строка</code></p><p>В этом параметре задаётся имя хранилища. Если использовано ключевое слово SHARED, используется общекластерное хранилище.</p></li><li><p><code>newSettings : словарь</code></p><p>В этом параметре задаются новые установки хранилища.</p></li></ul><h3 id="GETDIRECTORYACCESSRIGHTS" tabindex="-1"><code>GETDIRECTORYACCESSRIGHTS [ SHARED ]</code> <a class="header-anchor" href="#GETDIRECTORYACCESSRIGHTS" aria-label="Permalink to &quot;`GETDIRECTORYACCESSRIGHTS [ SHARED ]` {#GETDIRECTORYACCESSRIGHTS}&quot;">​</a></h3><p>Используйте эту команду для чтения Прав Доступа к Справочнику. Если использовано ключевое слово SHARED, читаются общекластерные права.</p><p>Эта команда возвращает массив с элементами Прав Доступа.</p><h3 id="SETDIRECTORYACCESSRIGHTS" tabindex="-1"><code>SETDIRECTORYACCESSRIGHTS [ SHARED ] newAccessRights</code> <a class="header-anchor" href="#SETDIRECTORYACCESSRIGHTS" aria-label="Permalink to &quot;`SETDIRECTORYACCESSRIGHTS [ SHARED ] newAccessRights` {#SETDIRECTORYACCESSRIGHTS}&quot;">​</a></h3><p>Используйте эту команду для смены Прав Доступа к Справочнику. Если использовано ключевое слово SHARED, изменяются общекластерные права.</p><ul><li><p><code>newAccessRights : массив</code></p><p>В этом параметре задаются новые Права Доступа к Справочнику.</p></li></ul><h2 id="Misc" tabindex="-1">Разные Команды <a class="header-anchor" href="#Misc" aria-label="Permalink to &quot;Разные Команды {#Misc}&quot;">​</a></h2><h3 id="LISTCLICOMMANDS" tabindex="-1"><code>LISTCLICOMMANDS</code> <a class="header-anchor" href="#LISTCLICOMMANDS" aria-label="Permalink to &quot;`LISTCLICOMMANDS` {#LISTCLICOMMANDS}&quot;">​</a></h3><p>Используйте эту команду для получения списка всех команд CLI, поддерживаемых этой версией Сервера CommuniGate Pro. Эта команда возвращает <em>массив</em> строк с именами команд CLI.</p><h3 id="NOOP" tabindex="-1"><code>NOOP</code> <a class="header-anchor" href="#NOOP" aria-label="Permalink to &quot;`NOOP` {#NOOP}&quot;">​</a></h3><p>Команда всегда завершается успешно.</p><h3 id="ECHO" tabindex="-1"><code>ECHO object</code> <a class="header-anchor" href="#ECHO" aria-label="Permalink to &quot;`ECHO object` {#ECHO}&quot;">​</a></h3><p>Эта команда возвращает <em>объект</em>, скопированный из параметра команды.</p><h3 id="GETVERSION" tabindex="-1"><code>GETVERSION</code> <a class="header-anchor" href="#GETVERSION" aria-label="Permalink to &quot;`GETVERSION` {#GETVERSION}&quot;">​</a></h3><p>Функция возвращает <em>строку</em> с номером версии Сервера CommuniGate Pro.</p><h3 id="GETSYSTEMINFO" tabindex="-1"><code>GETSYSTEMINFO what</code> <a class="header-anchor" href="#GETSYSTEMINFO" aria-label="Permalink to &quot;`GETSYSTEMINFO what` {#GETSYSTEMINFO}&quot;">​</a></h3><p>Команда возвращает <em>объект</em> аналогично функции CG/PL <a href="./CGPL.html">SystemInfo</a>, вызванной с параметром <em>what</em>. В случаях, когда функция возвращает нулевой объект, эта команда возвращает строку с кодом ошибки.</p><h3 id="GETCURRENTTIME" tabindex="-1"><code>GETCURRENTTIME</code> <a class="header-anchor" href="#GETCURRENTTIME" aria-label="Permalink to &quot;`GETCURRENTTIME` {#GETCURRENTTIME}&quot;">​</a></h3><p>Функция возвращает <em>отметку времени</em> с текущим значением внутреннего таймера Сервера CommuniGate Pro.</p><h3 id="SETLOGALL" tabindex="-1"><code>SETLOGALL [ ON | OFF ]</code> <a class="header-anchor" href="#SETLOGALL" aria-label="Permalink to &quot;`SETLOGALL [ ON | OFF ]` {#SETLOGALL}&quot;">​</a></h3><p>Используйте эту команду для управления режимом &quot;Запись всего в Журнал Сервера&quot; (этот же режим включается параметром командной строки <code>--LogAll</code>). Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="DUMPALLOBJECTS" tabindex="-1"><code>DUMPALLOBJECTS [ FILE ]</code> <a class="header-anchor" href="#DUMPALLOBJECTS" aria-label="Permalink to &quot;`DUMPALLOBJECTS [ FILE ]` {#DUMPALLOBJECTS}&quot;">​</a></h3><p>Используйте эту команду для выдачи списка всех объектов Сервера. Если указано ключевое слово FILE, то создаётся файл <code>objects_dump.txt</code> в корне &quot;директории данных&quot; сервера и в него осуществляется выдача; если такой файл уже существует, то команда ничего не делает. Если ключевое слово FILE не указано, то выдача осуществляется в журнал Операционной Системы.</p><div class="tip custom-block"><p class="custom-block-title">Обратите внимание</p><p>Этот список может содержать миллионы объектов, и команда может вызвать перегрузку журнала ОС. На время выполнения команды блокируются все операции создания и удаления объектов, что фактически блокирует все операции Сервера CommuniGate Pro до выдачи полного списка.</p></div><p>Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может Всё&quot;.</p><h3 id="TESTLOOP" tabindex="-1"><code>TESTLOOP seconds</code> <a class="header-anchor" href="#TESTLOOP" aria-label="Permalink to &quot;`TESTLOOP seconds` {#TESTLOOP}&quot;">​</a></h3><p>Используйте эту команду для тестирования загрузки CPU. Команда выполняет некий вычислительный цикл в течение указанного времени. Результатом команды является <em>число</em>, которое говорит о производительности треда, обработавшего команду (количество проходов цикла делённое на время теста). Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="SETTRACE" tabindex="-1"><code>SETTRACE facility [ ON | OFF ]</code> <a class="header-anchor" href="#SETTRACE" aria-label="Permalink to &quot;`SETTRACE facility [ ON | OFF ]` {#SETTRACE}&quot;">​</a></h3><p>Используйте эту команду для управления внутренними механизмами Сервера для записи в Журнал Операционной Системы. Параметр <em>facility</em> должен быть одной из следующих поддерживаемых строк:</p><ul><li><p><code>FileIO</code></p><p>запись всех файловых операций чтения/записи/сокращения</p></li><li><p><code>FileOp</code></p><p>запись всех файловых операций создания/переименования/удаления<br> Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p></li></ul><h3 id="WRITELOG" tabindex="-1"><code>WRITELOG logLevel logRecord</code> <a class="header-anchor" href="#WRITELOG" aria-label="Permalink to &quot;`WRITELOG logLevel logRecord` {#WRITELOG}&quot;">​</a></h3><p>Используйте эту команду для записи в Журнал работы Сервера.</p><ul><li><p><code>logLevel : число</code></p><p>В этом параметре задаётся уровень Журнала.</p></li><li><p><code>logRecord : строка</code></p><p>Этот параметр указывает строку, которая будет помещена в Журнал работы Сервера. Записи, созданные при помощи этой команды, имеют префикс <code>SYSTEM</code>. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p></li></ul><h3 id="RELEASESMTPQUEUE" tabindex="-1"><code>RELEASESMTPQUEUE queueName</code> <a class="header-anchor" href="#RELEASESMTPQUEUE" aria-label="Permalink to &quot;`RELEASESMTPQUEUE queueName` {#RELEASESMTPQUEUE}&quot;">​</a></h3><p>Используйте эту команду для освобождения очереди SMTP.</p><ul><li><p><code>queueName : строка</code></p><p>Этот параметр указывает имя очереди (домена), которую необходимо освободить. В среде Динамического Кластера эта команда освобождает указанную очередь SMTP на всех серверах. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p></li></ul><h3 id="REJECTQUEUEMESSAGE" tabindex="-1"><code>REJECTQUEUEMESSAGE messageID [ REPORT errorText ]</code> <a class="header-anchor" href="#REJECTQUEUEMESSAGE" aria-label="Permalink to &quot;`REJECTQUEUEMESSAGE messageID [ REPORT errorText ]` {#REJECTQUEUEMESSAGE}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы отвергнуть сообщение, находящееся в Очереди Сервера.</p><ul><li><p><code>messageID : число</code></p><p>В этом параметре задаётся Идентификатор Сообщения.</p></li><li><p><code>errorText : строка</code></p><p>Этот необязательный параметр указывает текст сообщения об ошибке, которое будет включено в уведомление отправителю сообщения о недоставке. Если этот параметр указан как <code>NONDN</code>, то DSN-уведомление не создаётся. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может отвергать Почтовые Очереди &quot;.</p></li></ul><h3 id="REJECTQUEUEMESSAGES" tabindex="-1"><code>REJECTQUEUEMESSAGES SENDER authedSender [ REPORT errorText ]</code> <a class="header-anchor" href="#REJECTQUEUEMESSAGES" aria-label="Permalink to &quot;`REJECTQUEUEMESSAGES SENDER authedSender [ REPORT errorText ]` {#REJECTQUEUEMESSAGES}&quot;">​</a></h3><p>Используйте эту команду для того, чтобы отвергнуть сообщение указанного аутентифицированного отправителя, находящееся в Очереди Сервера.</p><ul><li><p><code>authedSender : строка</code></p><p>В этом параметре задаётся адрес аутентифицированного отправителя.</p></li><li><p><code>errorText : строка</code></p><p>Этот необязательный параметр указывает текст сообщения об ошибке, которое будет включено в уведомление отправителю сообщения о недоставке. Если этот параметр указан как <code>NONDN</code>, то DSN-уведомление не создаётся. В среде Динамического Кластера эта команда удаляет сообщения на всех серверах. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может отвергать Почтовые Очереди &quot;.</p></li></ul><h3 id="GETMESSAGEQUEUEINFO" tabindex="-1"><code>GETMESSAGEQUEUEINFO moduleName QUEUE queueName</code> <a class="header-anchor" href="#GETMESSAGEQUEUEINFO" aria-label="Permalink to &quot;`GETMESSAGEQUEUEINFO moduleName QUEUE queueName` {#GETMESSAGEQUEUEINFO}&quot;">​</a></h3><p>Используйте эту команду для чтения информации об Очереди сообщений модуля.</p><ul><li><p><code>moduleName : строка</code></p><p>В этом параметре задаётся имя модуля.</p></li><li><p><code>queueName : строка</code></p><p>В этом параметре задаётся имя очереди модуля. Эта команда возвращает <em>словарь</em> с информацией об очереди. Если модуль не имеет указанной очереди, то словарь будет пустым. В противном случае в нём содержатся следующие элементы:</p></li><li><p><code>nTotal</code></p><p>число - общее число сообщений в очереди</p></li><li><p><code>size</code></p><p>число - общий размер всех сообщений в очереди</p></li><li><p><code>delayedTill</code></p><p>необязательная отметка времени - фактическое время освобождения для этой очереди</p></li><li><p><code>lastError</code></p><p>необязательная строка с отчётом о последней возникшей проблеме</p></li></ul><h3 id="GETCURRENTCONTROLLER" tabindex="-1"><code>GETCURRENTCONTROLLER</code> <a class="header-anchor" href="#GETCURRENTCONTROLLER" aria-label="Permalink to &quot;`GETCURRENTCONTROLLER` {#GETCURRENTCONTROLLER}&quot;">​</a></h3><p>Используйте эту команду для получения IP адреса текущего Контроллера Динамического Кластера. Эта команда возвращает <em>строку</em> с IP адресом Контроллера Кластера. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="RECONNECTCLUSTERADMIN" tabindex="-1"><code>RECONNECTCLUSTERADMIN</code> <a class="header-anchor" href="#RECONNECTCLUSTERADMIN" aria-label="Permalink to &quot;`RECONNECTCLUSTERADMIN` {#RECONNECTCLUSTERADMIN}&quot;">​</a></h3><p>Используйте эту команду, чтобы член Динамического Кластера заново открыл все свои внутрикластерные административные соединения, а для членов помимо Контроллера - ещё и открыть заново Административные соединения с Контроллером.</p><h3 id="GETTEMPCLIENTIPS" tabindex="-1"><code>GETTEMPCLIENTIPS</code> <a class="header-anchor" href="#GETTEMPCLIENTIPS" aria-label="Permalink to &quot;`GETTEMPCLIENTIPS` {#GETTEMPCLIENTIPS}&quot;">​</a></h3><p>Используйте эту команду для получения набора временных Сетевых Адресов Клиентов. Эта команда возвращает <em>строку</em> с разделёнными через запятую (<code>,</code>) Временными Сетевыми Адресами Клиентов. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="REPORTFAILEDLOGINADDRESS" tabindex="-1"><code>REPORTFAILEDLOGINADDRESS address</code> <a class="header-anchor" href="#REPORTFAILEDLOGINADDRESS" aria-label="Permalink to &quot;`REPORTFAILEDLOGINADDRESS address` {#REPORTFAILEDLOGINADDRESS}&quot;">​</a></h3><p>Используйте эту команду для увеличения счётчика неудачных попыток Входа с указанного IP адреса, используемого в функциональности <a href="./../admin/sysadmin/Protection.html#TempBlock">Временно Блокированные Адреса</a>.</p><ul><li><p><code>address : строка</code></p><p>Сетевой (IP) адрес, для которого должен быть увеличен счётчик неудачных попыток Входа. Для использования этой команды необходимо обладать правами по Администрированию Сервера &quot;Может менять установки Сервера&quot;.</p></li></ul><h3 id="TEMPBLACKLISTIP" tabindex="-1"><code>TEMPBLACKLISTIP address [ TIMEOUT seconds | DELETE ]</code> <a class="header-anchor" href="#TEMPBLACKLISTIP" aria-label="Permalink to &quot;`TEMPBLACKLISTIP address [ TIMEOUT seconds | DELETE ]` {#TEMPBLACKLISTIP}&quot;">​</a></h3><p>Используйте эту команду для добавления и удаления адреса в списке Временно Блокированных Сетевых Адресов.</p><ul><li><p><code>address : строка</code></p><p>Сетевой (IP) адрес для добавления или удаления.</p></li><li><p><code>seconds : число</code></p><p>Время, на которое адрес добавляется в список. Используйте ключевое слово DELETE, чтобы удалить адрес из списка.</p></li></ul><h3 id="GETTEMPBLACKLISTEDIPS" tabindex="-1"><code>GETTEMPBLACKLISTEDIPS</code> <a class="header-anchor" href="#GETTEMPBLACKLISTEDIPS" aria-label="Permalink to &quot;`GETTEMPBLACKLISTEDIPS` {#GETTEMPBLACKLISTEDIPS}&quot;">​</a></h3><p>Используйте эту команду для получения списка Временно Блокированных Сетевых Адресов. Эта команда возвращает <em>строку</em> с разделёнными через запятую (<code>,</code>) Временно Блокированными Сетевыми Адресами. Каждый IP адрес может иметь суффикс <code>-nnnn</code>, где nnnn является либо числом секунд, в течении которых этот адрес будет оставаться заблокированным, либо символом <code>*</code>, указывающим, что этот адрес заблокирован постоянно. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="SETTEMPBLACKLISTEDIPS" tabindex="-1"><code>SETTEMPBLACKLISTEDIPS addresses</code> <a class="header-anchor" href="#SETTEMPBLACKLISTEDIPS" aria-label="Permalink to &quot;`SETTEMPBLACKLISTEDIPS addresses` {#SETTEMPBLACKLISTEDIPS}&quot;">​</a></h3><p>Используйте эту команду для добавления адреса в список Временно Блокированных Сетевых Адресов.</p><ul><li><p><code>addresses : строка</code></p><p>Строка со списком IP адресов в формате выдачи команды <code>GetTempBlacklistedIPs</code>. Для использования этой команды необходимо обладать правами по Администрированию Сервера &quot;Может менять установки Сервера&quot;.</p></li></ul><h3 id="TEMPUNBLOCKIP" tabindex="-1"><code>TEMPUNBLOCKIP address [ TIMEOUT seconds | DELETE ]</code> <a class="header-anchor" href="#TEMPUNBLOCKIP" aria-label="Permalink to &quot;`TEMPUNBLOCKIP address [ TIMEOUT seconds | DELETE ]` {#TEMPUNBLOCKIP}&quot;">​</a></h3><p>Используйте эту команду для добавления и удаления адреса в списке Временно Неблокируемых Сетевых Адресов.</p><ul><li><p><code>address : строка</code></p><p>Сетевой (IP) адрес для добавления или удаления.</p></li><li><p><code>seconds : число</code></p><p>Время, на которое адрес добавляется в список. Используйте ключевое слово DELETE, чтобы удалить адрес из списка.</p></li></ul><h3 id="GETTEMPUNBLOCKABLEIPS" tabindex="-1"><code>GETTEMPUNBLOCKABLEIPS</code> <a class="header-anchor" href="#GETTEMPUNBLOCKABLEIPS" aria-label="Permalink to &quot;`GETTEMPUNBLOCKABLEIPS` {#GETTEMPUNBLOCKABLEIPS}&quot;">​</a></h3><p>Используйте эту команду для получения списка Временно Неблокируемых Сетевых Адресов. Эта команда возвращает <em>строку</em> с разделёнными через запятую (<code>,</code>) Временно Неблокируемыми Сетевыми Адресами. Каждый IP адрес может иметь суффикс <code>-nnnn</code>, где nnnn является либо числом секунд, в течении которых этот адрес будет оставаться неблокируемым, либо символом <code>*</code>, указывающим, что этот адрес неблокируем постоянно. Для использования этой команды необходимо обладать правами Администратора Сервера &quot;Может наблюдать за Сервером&quot;.</p><h3 id="SETTEMPUNBLOCKABLEIPS" tabindex="-1"><code>SETTEMPUNBLOCKABLEIPS addresses</code> <a class="header-anchor" href="#SETTEMPUNBLOCKABLEIPS" aria-label="Permalink to &quot;`SETTEMPUNBLOCKABLEIPS addresses` {#SETTEMPUNBLOCKABLEIPS}&quot;">​</a></h3><p>Используйте эту команду для добавления адреса в список Временно Неблокируемых Сетевых Адресов.</p><ul><li><p><code>addresses : строка</code></p><p>Строка со списком IP адресов в формате выдачи команды <code>GetTempUnblockableIPs</code>. Для использования этой команды необходимо обладать правами по Администрированию Сервера &quot;Может менять установки Сервера&quot;.</p></li></ul><h2 id="Index" tabindex="-1">Индекс <a class="header-anchor" href="#Index" aria-label="Permalink to &quot;Индекс {#Index}&quot;">​</a></h2><ul><li><p>Управление Наборами Доменов</p><p><a href="#LISTDOMAINS"><code>LISTDOMAINS</code></a>, <a href="#MAINDOMAINNAME"><code>MAINDOMAINNAME</code></a><br><a href="#GETDOMAINDEFAULTS"><code>GETDOMAINDEFAULTS</code></a>, <a href="#UPDATEDOMAINDEFAULTS"><code>UPDATEDOMAINDEFAULTS</code></a>, <a href="#SETDOMAINDEFAULTS"><code>SETDOMAINDEFAULTS</code></a>, <a href="#GETCLUSTERDOMAINDEFAULTS"><code>GETCLUSTERDOMAINDEFAULTS</code></a>, <a href="#UPDATECLUSTERDOMAINDEFAULTS"><code>UPDATECLUSTERDOMAINDEFAULTS</code></a>, <a href="#SETCLUSTERDOMAINDEFAULTS"><code>SETCLUSTERDOMAINDEFAULTS</code></a><br><a href="#GETSERVERACCOUNTDEFAULTS"><code>GETSERVERACCOUNTDEFAULTS</code></a>, <a href="#UPDATESERVERACCOUNTDEFAULTS"><code>UPDATESERVERACCOUNTDEFAULTS</code></a>, <a href="#SETSERVERACCOUNTDEFAULTS"><code>SETSERVERACCOUNTDEFAULTS</code></a>, <a href="#GETCLUSTERACCOUNTDEFAULTS"><code>GETCLUSTERACCOUNTDEFAULTS</code></a>, <a href="#UPDATECLUSTERACCOUNTDEFAULTS"><code>UPDATECLUSTERACCOUNTDEFAULTS</code></a>, <a href="#SETCLUSTERACCOUNTDEFAULTS"><code>SETCLUSTERACCOUNTDEFAULTS</code></a><br><a href="#GETSERVERACCOUNTPREFS"><code>GETSERVERACCOUNTPREFS</code></a>, <a href="#SETSERVERACCOUNTPREFS"><code>SETSERVERACCOUNTPREFS</code></a>, <a href="#UPDATESERVERACCOUNTPREFS"><code>UPDATESERVERACCOUNTPREFS</code></a>, <a href="#GETCLUSTERACCOUNTPREFS"><code>GETCLUSTERACCOUNTPREFS</code></a>, <a href="#SETCLUSTERACCOUNTPREFS"><code>SETCLUSTERACCOUNTPREFS</code></a>, <a href="#UPDATECLUSTERACCOUNTPREFS"><code>UPDATECLUSTERACCOUNTPREFS</code></a><br><a href="#CREATEDOMAIN"><code>CREATEDOMAIN</code></a>, <a href="#RENAMEDOMAIN"><code>RENAMEDOMAIN</code></a>, <a href="#DELETEDOMAIN"><code>DELETEDOMAIN</code></a>, <a href="#CREATEDIRECTORYDOMAIN"><code>CREATEDIRECTORYDOMAIN</code></a>, <a href="#RELOADDIRECTORYDOMAINS"><code>RELOADDIRECTORYDOMAINS</code></a><br><a href="#LISTSERVERTELNUMS"><code>LISTSERVERTELNUMS</code></a>, <a href="#LISTCLUSTERTELNUMS"><code>LISTCLUSTERTELNUMS</code></a><br><a href="#GETSERVERTRUSTEDCERTS"><code>GETSERVERTRUSTEDCERTS</code></a>, <a href="#SETSERVERTRUSTEDCERTS"><code>SETSERVERTRUSTEDCERTS</code></a>, <a href="#GETCLUSTERTRUSTEDCERTS"><code>GETCLUSTERTRUSTEDCERTS</code></a>, <a href="#SETCLUSTERTRUSTEDCERTS"><code>SETCLUSTERTRUSTEDCERTS</code></a><br><a href="#GETDIRECTORYINTEGRATION"><code>GETDIRECTORYINTEGRATION</code></a>, <a href="#GETCLUSTERDIRECTORYINTEGRATION"><code>GETCLUSTERDIRECTORYINTEGRATION</code></a>, <a href="#SETCLUSTERDIRECTORYINTEGRATION"><code>SETCLUSTERDIRECTORYINTEGRATION</code></a>,<br><a href="#CREATEDOMAINSTORAGE"><code>CREATEDOMAINSTORAGE</code></a>, <a href="#LISTDOMAINSTORAGE"><code>LISTDOMAINSTORAGE</code></a></p></li><li><p>Управление Доменом</p><p><a href="#GETDOMAINSETTINGS"><code>GETDOMAINSETTINGS</code></a>, <a href="#GETDOMAINEFFECTIVESETTINGS"><code>GETDOMAINEFFECTIVESETTINGS</code></a>, <a href="#UPDATEDOMAINSETTINGS"><code>UPDATEDOMAINSETTINGS</code></a>, <a href="#SETDOMAINSETTINGS"><code>SETDOMAINSETTINGS</code></a><br><a href="#GETACCOUNTDEFAULTS"><code>GETACCOUNTDEFAULTS</code></a>, <a href="#UPDATEACCOUNTDEFAULTS"><code>UPDATEACCOUNTDEFAULTS</code></a>, <a href="#SETACCOUNTDEFAULTS"><code>SETACCOUNTDEFAULTS</code></a><br><a href="#GETACCOUNTDEFAULTPREFS"><code>GETACCOUNTDEFAULTPREFS</code></a>, <a href="#UPDATEACCOUNTDEFAULTPREFS"><code>UPDATEACCOUNTDEFAULTPREFS</code></a>, <a href="#SETACCOUNTDEFAULTPREFS"><code>SETACCOUNTDEFAULTPREFS</code></a><br><a href="#GETDOMAINALIASES"><code>GETDOMAINALIASES</code></a>, <a href="#SETDOMAINALIASES"><code>SETDOMAINALIASES</code></a><br><a href="#GETACCOUNTTEMPLATE"><code>GETACCOUNTTEMPLATE</code></a>, <a href="#UPDATEACCOUNTTEMPLATE"><code>UPDATEACCOUNTTEMPLATE</code></a>, <a href="#SETACCOUNTTEMPLATE"><code>SETACCOUNTTEMPLATE</code></a><br><a href="#GETDOMAINMAILRULES"><code>GETDOMAINMAILRULES</code></a>, <a href="#SETDOMAINMAILRULES"><code>SETDOMAINMAILRULES</code></a>, <a href="#GETDOMAINSIGNALRULES"><code>GETDOMAINSIGNALRULES</code></a>, <a href="#SETDOMAINSIGNALRULES"><code>SETDOMAINSIGNALRULES</code></a>,<br><a href="#LISTADMINDOMAINS"><code>LISTADMINDOMAINS</code></a><br><a href="#LISTDOMAINOBJECTS"><code>LISTDOMAINOBJECTS</code></a>, <a href="#LISTACCOUNTS"><code>LISTACCOUNTS</code></a>, <a href="#LISTDOMAINTELNUMS"><code>LISTDOMAINTELNUMS</code></a><br><a href="#INSERTDIRECTORYRECORDS"><code>INSERTDIRECTORYRECORDS</code></a>, <a href="#DELETEDIRECTORYRECORDS"><code>DELETEDIRECTORYRECORDS</code></a><br><a href="#GETDOMAINLOCATION"><code>GETDOMAINLOCATION</code></a>, <a href="#CREATEACCOUNTSTORAGE"><code>CREATEACCOUNTSTORAGE</code></a>, <a href="#LISTACCOUNTSTORAGE"><code>LISTACCOUNTSTORAGE</code></a>,<br><a href="#SUSPENDDOMAIN"><code>SUSPENDDOMAIN</code></a>, <a href="#RESUMEDOMAIN"><code>RESUMEDOMAIN</code></a></p></li><li><p>Управление Пользователями</p><p><a href="#CREATEACCOUNT"><code>CREATEACCOUNT</code></a>, <a href="#RENAMEACCOUNT"><code>RENAMEACCOUNT</code></a>, <a href="#DELETEACCOUNT"><code>DELETEACCOUNT</code></a>, <a href="#BLOCKACCOUNT"><code>BLOCKACCOUNT</code></a>, <a href="#UNBLOCKACCOUNT"><code>UNBLOCKACCOUNT</code></a><br><a href="#SETACCOUNTTYPE"><code>SETACCOUNTTYPE</code></a>, <a href="#GETACCOUNTSETTINGS"><code>GETACCOUNTSETTINGS</code></a>, <a href="#UPDATEACCOUNTSETTINGS"><code>UPDATEACCOUNTSETTINGS</code></a>, <a href="#GETACCOUNTEFFECTIVESETTINGS"><code>GETACCOUNTEFFECTIVESETTINGS</code></a>, <a href="#GETACCOUNTONESETTING"><code>GETACCOUNTONESETTING</code></a>, <a href="#SETACCOUNTSETTINGS"><code>SETACCOUNTSETTINGS</code></a><br><a href="#SETACCOUNTPASSWORD"><code>SETACCOUNTPASSWORD</code></a>, <a href="#VERIFYACCOUNTPASSWORD"><code>VERIFYACCOUNTPASSWORD</code></a>, <a href="#VERIFYACCOUNTIDENTITY"><code>VERIFYACCOUNTIDENTITY</code></a><br><a href="#GETACCOUNTALIASES"><code>GETACCOUNTALIASES</code></a>, <a href="#SETACCOUNTALIASES"><code>SETACCOUNTALIASES</code></a>, <a href="#GETACCOUNTTELNUMS"><code>GETACCOUNTTELNUMS</code></a>, <a href="#SETACCOUNTTELNUMS"><code>SETACCOUNTTELNUMS</code></a> <a href="#MODIFYACCOUNTTELNUMS"><code>MODIFYACCOUNTTELNUMS</code></a><br><a href="#GETACCOUNTMAILRULES"><code>GETACCOUNTMAILRULES</code></a>, <a href="#SETACCOUNTMAILRULES"><code>SETACCOUNTMAILRULES</code></a>, <a href="#GETACCOUNTSIGNALRULES"><code>GETACCOUNTSIGNALRULES</code></a>, <a href="#SETACCOUNTSIGNALRULES"><code>SETACCOUNTSIGNALRULES</code></a>, <a href="#UPDATEACCOUNTMAILRULE"><code>UPDATEACCOUNTMAILRULE</code></a>, <a href="#UPDATEACCOUNTSIGNALRULE"><code>UPDATEACCOUNTSIGNALRULE</code></a>,<br><a href="#GETACCOUNTRPOPS"><code>GETACCOUNTRPOPS</code></a>, <a href="#SETACCOUNTRPOPS"><code>SETACCOUNTRPOPS</code></a>, <a href="#GETACCOUNTRSIPS"><code>GETACCOUNTRSIPS</code></a>, <a href="#SETACCOUNTRSIPS"><code>SETACCOUNTRSIPS</code></a>, <a href="#UPDATESCHEDULEDTASK"><code>UPDATESCHEDULEDTASK</code></a>, <a href="#GETACCOUNTRIGHTS"><code>GETACCOUNTRIGHTS</code></a>, <a href="#GETACCOUNTINFO"><code>GETACCOUNTINFO</code></a><br><a href="#GETACCOUNTPREFS"><code>GETACCOUNTPREFS</code></a>, <a href="#UPDATEACCOUNTPREFS"><code>UPDATEACCOUNTPREFS</code></a>, <a href="#SETACCOUNTPREFS"><code>SETACCOUNTPREFS</code></a>, <a href="#GETACCOUNTEFFECTIVEPREFS"><code>GETACCOUNTEFFECTIVEPREFS</code></a><br><a href="#KILLACCOUNTSESSIONS"><code>KILLACCOUNTSESSIONS</code></a><br><a href="#GETACCOUNTACL"><code>GETACCOUNTACL</code></a>, <a href="#SETACCOUNTACL"><code>SETACCOUNTACL</code></a>, <a href="#GETACCOUNTACLRIGHTS"><code>GETACCOUNTACLRIGHTS</code></a><br><a href="#GETACCOUNTLOCATION"><code>GETACCOUNTLOCATION</code></a> <a href="#GETACCOUNTPRESENCE"><code>GETACCOUNTPRESENCE</code></a></p></li><li><p>Управление Группами</p><p><a href="#LISTGROUPS"><code>LISTGROUPS</code></a>, <a href="#CREATEGROUP"><code>CREATEGROUP</code></a>, <a href="#RENAMEGROUP"><code>RENAMEGROUP</code></a>, <a href="#DELETEGROUP"><code>DELETEGROUP</code></a>, <a href="#GETGROUP"><code>GETGROUP</code></a>, <a href="#SETGROUP"><code>SETGROUP</code></a></p></li><li><p>Управление Переадресаторами</p><p><a href="#LISTFORWARDERS"><code>LISTFORWARDERS</code></a>, <a href="#CREATEFORWARDER"><code>CREATEFORWARDER</code></a>, <a href="#RENAMEFORWARDER"><code>RENAMEFORWARDER</code></a>, <a href="#DELETEFORWARDER"><code>DELETEFORWARDER</code></a>, <a href="#GETFORWARDER"><code>GETFORWARDER</code></a> <a href="#FINDFORWARDERS"><code>FINDFORWARDERS</code></a></p></li><li><p>Управление Именованными Задачами</p><p><a href="#LISTDOMAINNAMEDTASKS"><code>LISTDOMAINNAMEDTASKS</code></a>, <a href="#LISTACCOUNTNAMEDTASKS"><code>LISTACCOUNTNAMEDTASKS</code></a>, <a href="#CREATENAMEDTASK"><code>CREATENAMEDTASK</code></a>, <a href="#RENAMENAMEDTASK"><code>RENAMENAMEDTASK</code></a>, <a href="#DELETENAMEDTASK"><code>DELETENAMEDTASK</code></a>, <a href="#GETNAMEDTASK"><code>GETNAMEDTASK</code></a>, <a href="#UPDATENAMEDTASK"><code>UPDATENAMEDTASK</code></a></p></li><li><p>Управление Правами Доступа</p><p><a href="#SETACCOUNTRIGHTS"><code>SETACCOUNTRIGHTS</code></a></p></li><li><p>Управление Папками</p><p><a href="#LISTMAILBOXES"><code>LISTMAILBOXES</code></a>, <a href="#CREATEMAILBOX"><code>CREATEMAILBOX</code></a>, <a href="#DELETEMAILBOX"><code>DELETEMAILBOX</code></a>, <a href="#RENAMEMAILBOX"><code>RENAMEMAILBOX</code></a>, <a href="#SETMAILBOXCLASS"><code>SETMAILBOXCLASS</code></a><br><a href="#GETMAILBOXINFO"><code>GETMAILBOXINFO</code></a>, <a href="#GETMAILBOXACL"><code>GETMAILBOXACL</code></a>, <a href="#SETMAILBOXACL"><code>SETMAILBOXACL</code></a>, <a href="#GETMAILBOXRIGHTS"><code>GETMAILBOXRIGHTS</code></a><br><a href="#GETMAILBOXSUBSCRIPTION"><code>GETMAILBOXSUBSCRIPTION</code></a>, <a href="#SETMAILBOXSUBSCRIPTION"><code>SETMAILBOXSUBSCRIPTION</code></a><br><a href="#GETMAILBOXALIASES"><code>GETMAILBOXALIASES</code></a>, <a href="#SETMAILBOXALIASES"><code>SETMAILBOXALIASES</code></a></p></li><li><p>Управление Предупреждениями</p><p><a href="#GETDOMAINALERTS"><code>GETDOMAINALERTS</code></a>, <a href="#SETDOMAINALERTS"><code>SETDOMAINALERTS</code></a>, <a href="#POSTDOMAINALERT"><code>POSTDOMAINALERT</code></a>, <a href="#REMOVEDOMAINALERT"><code>REMOVEDOMAINALERT</code></a><br><a href="#GETACCOUNTALERTS"><code>GETACCOUNTALERTS</code></a>, <a href="#SETACCOUNTALERTS"><code>SETACCOUNTALERTS</code></a>, <a href="#POSTACCOUNTALERT"><code>POSTACCOUNTALERT</code></a>, <a href="#REMOVEACCOUNTALERT"><code>REMOVEACCOUNTALERT</code></a><br><a href="#GETSERVERALERTS"><code>GETSERVERALERTS</code></a>, <a href="#SETSERVERALERTS"><code>SETSERVERALERTS</code></a>, <a href="#POSTSERVERALERT"><code>POSTSERVERALERT</code></a>, <a href="#REMOVESERVERALERT"><code>REMOVESERVERALERT</code></a>, <a href="#GETCLUSTERALERTS"><code>GETCLUSTERALERTS</code></a>, <a href="#SETCLUSTERALERTS"><code>SETCLUSTERALERTS</code></a>, <a href="#POSTCLUSTERALERT"><code>POSTCLUSTERALERT</code></a>, <a href="#REMOVECLUSTERALERT"><code>REMOVECLUSTERALERT</code></a></p></li><li><p>Управление Хранилищем Файлов</p><p><a href="#READSTORAGEFILE"><code>READSTORAGEFILE</code></a>, <a href="#WRITESTORAGEFILE"><code>WRITESTORAGEFILE</code></a>, <a href="#RENAMESTORAGEFILE"><code>RENAMESTORAGEFILE</code></a>, <a href="#DELETESTORAGEFILE"><code>DELETESTORAGEFILE</code></a>, <a href="#LISTSTORAGEFILES"><code>LISTSTORAGEFILES</code></a>, <a href="#GETSTORAGEFILEINFO"><code>GETSTORAGEFILEINFO</code></a> <a href="#READSTORAGEFILEATTR"><code>READSTORAGEFILEATTR</code></a> <a href="#UPDATESTORAGEFILEATTR"><code>UPDATESTORAGEFILEATTR</code></a> <a href="#GETFILESUBSCRIPTION"><code>GETFILESUBSCRIPTION</code></a> <a href="#SETFILESUBSCRIPTION"><code>SETFILESUBSCRIPTION</code></a></p></li><li><p>Управление Списками Рассылки</p><p><a href="#LISTLISTS"><code>LISTLISTS</code></a>, <a href="#GETDOMAINLISTS"><code>GETDOMAINLISTS</code></a>, <a href="#GETACCOUNTLISTS"><code>GETACCOUNTLISTS</code></a><br><a href="#CREATELIST"><code>CREATELIST</code></a>, <a href="#RENAMELIST"><code>RENAMELIST</code></a>, <a href="#DELETELIST"><code>DELETELIST</code></a>, <a href="#GETLIST"><code>GETLIST</code></a>, <a href="#UPDATELIST"><code>UPDATELIST</code></a><br><a href="#LIST"><code>LIST</code></a>, <a href="#LISTSUBSCRIBERS"><code>LISTSUBSCRIBERS</code></a>, <a href="#READSUBSCRIBERS"><code>READSUBSCRIBERS</code></a><br><a href="#GETSUBSCRIBERINFO"><code>GETSUBSCRIBERINFO</code></a>, <a href="#SETPOSTINGMODE"><code>SETPOSTINGMODE</code></a>, <a href="#PROCESSBOUNCE"><code>PROCESSBOUNCE</code></a></p></li><li><p>Управление Видами Веб Интерфейса</p><p><a href="#LISTDOMAINSKINS"><code>LISTDOMAINSKINS</code></a>, <a href="#CREATEDOMAINSKIN"><code>CREATEDOMAINSKIN</code></a>, <a href="#RENAMEDOMAINSKIN"><code>RENAMEDOMAINSKIN</code></a>, <a href="#DELETEDOMAINSKIN"><code>DELETEDOMAINSKIN</code></a>, <a href="#LISTDOMAINSKINFILES"><code>LISTDOMAINSKINFILES</code></a>, <a href="#READDOMAINSKINFILE"><code>READDOMAINSKINFILE</code></a>, <a href="#STOREDOMAINSKINFILE"><code>STOREDOMAINSKINFILE</code></a><br><a href="#LISTSERVERSKINS"><code>LISTSERVERSKINS</code></a>, <a href="#CREATESERVERSKIN"><code>CREATESERVERSKIN</code></a>, <a href="#RENAMESERVERSKIN"><code>RENAMESERVERSKIN</code></a>, <a href="#DELETESERVERSKIN"><code>DELETESERVERSKIN</code></a>, <a href="#LISTSERVERSKINFILES"><code>LISTSERVERSKINFILES</code></a>, <a href="#READSERVERSKINFILE"><code>READSERVERSKINFILE</code></a>, <a href="#STORESERVERSKINFILE"><code>STORESERVERSKINFILE</code></a><br><a href="#LISTCLUSTERSKINS"><code>LISTCLUSTERSKINS</code></a>, <a href="#CREATECLUSTERSKIN"><code>CREATECLUSTERSKIN</code></a>, <a href="#RENAMECLUSTERSKIN"><code>RENAMECLUSTERSKIN</code></a>, <a href="#DELETECLUSTERSKIN"><code>DELETECLUSTERSKIN</code></a>, <a href="#LISTCLUSTERSKINFILES"><code>LISTCLUSTERSKINFILES</code></a>, <a href="#READCLUSTERSKINFILE"><code>READCLUSTERSKINFILE</code></a>, <a href="#STORECLUSTERSKINFILE"><code>STORECLUSTERSKINFILE</code></a><br><a href="#LISTSTOCKSKINFILES"><code>LISTSTOCKSKINFILES</code></a>, <a href="#READSTOCKSKINFILE"><code>READSTOCKSKINFILE</code></a></p></li><li><p>Интеграция с Веб Интерфейсом</p><p><a href="#CREATEWEBUSERSESSION"><code>CREATEWEBUSERSESSION</code></a>, <a href="#CREATEXIMSSSESSION"><code>CREATEXIMSSSESSION</code></a>, <a href="#CREATELITESESSION"><code>CREATELITESESSION</code></a>, <a href="#FINDACCOUNTSESSION"><code>FINDACCOUNTSESSION</code></a>, <a href="#LISTACCOUNTSESSIONS"><code>LISTACCOUNTSESSIONS</code></a>, <a href="#LISTLITESESSIONS"><code>LISTLITESESSIONS</code></a>, <a href="#GETSESSION"><code>GETSESSION</code></a>, <a href="#UPDATESESSION"><code>UPDATESESSION</code></a>, <a href="#KILLSESSION"><code>KILLSESSION</code></a>, <a href="#BLESSSESSION"><code>BLESSSESSION</code></a></p></li><li><p>Управление Приложениями Реального Времени</p><p><a href="#CREATEDOMAINPBX"><code>CREATEDOMAINPBX</code></a>, <a href="#DELETEDOMAINPBX"><code>DELETEDOMAINPBX</code></a>, <a href="#LISTDOMAINPBXFILES"><code>LISTDOMAINPBXFILES</code></a>, <a href="#READDOMAINPBXFILE"><code>READDOMAINPBXFILE</code></a>, <a href="#STOREDOMAINPBXFILE"><code>STOREDOMAINPBXFILE</code></a><br><a href="#CREATESERVERPBX"><code>CREATESERVERPBX</code></a>, <a href="#DELETESERVERPBX"><code>DELETESERVERPBX</code></a>, <a href="#LISTSERVERPBXFILES"><code>LISTSERVERPBXFILES</code></a>, <a href="#READSERVERPBXFILE"><code>READSERVERPBXFILE</code></a>, <a href="#STORESERVERPBXFILE"><code>STORESERVERPBXFILE</code></a><br><a href="#CREATECLUSTERPBX"><code>CREATECLUSTERPBX</code></a>, <a href="#DELETECLUSTERPBX"><code>DELETECLUSTERPBX</code></a>, <a href="#LISTCLUSTERPBXFILES"><code>LISTCLUSTERPBXFILES</code></a>, <a href="#READCLUSTERPBXFILE"><code>READCLUSTERPBXFILE</code></a>, <a href="#STORECLUSTERPBXFILE"><code>STORECLUSTERPBXFILE</code></a><br><a href="#LISTSTOCKPBXFILES"><code>LISTSTOCKPBXFILES</code></a>, <a href="#READSTOCKPBXFILE"><code>READSTOCKPBXFILE</code></a></p></li><li><p>Выполнение Приложений Реального Времени</p><p><a href="#STARTPBXTASK"><code>STARTPBXTASK</code></a>, <a href="#SENDTASKEVENT"><code>SENDTASKEVENT</code></a>, <a href="#KILLNODE"><code>KILLNODE</code></a>, <a href="#READNODESTATUS"><code>READNODESTATUS</code></a></p></li><li><p>Полнотекстовый поиск</p><p><a href="#BUILDDOMAINSEARCHINDEX"><code>BUILDDOMAINSEARCHINDEX</code></a>, <a href="#GETDOMAINSEARCHINDEXSTATE"><code>GETDOMAINSEARCHINDEXSTATE</code></a>, <a href="#REMOVEDOMAINSEARCHINDEX"><code>REMOVEDOMAINSEARCHINDEX</code></a>, <a href="#BUILDACCOUNTSEARCHINDEX"><code>BUILDACCOUNTSEARCHINDEX</code></a>, <a href="#GETACCOUNTSEARCHINDEXSTATE"><code>GETACCOUNTSEARCHINDEXSTATE</code></a>, <a href="#GETACCOUNTSEARCHINDEXSIZE"><code>GETACCOUNTSEARCHINDEXSIZE</code></a>, <a href="#REMOVEACCOUNTSEARCHINDEX"><code>REMOVEACCOUNTSEARCHINDEX</code></a>, <a href="#SEARCHININDEX"><code>SEARCHININDEX</code></a>, <a href="#BUILDGROUPSEARCHINDEX"><code>BUILDGROUPSEARCHINDEX</code></a></p></li><li><p>Синхронные Скрипты</p><p><a href="#RUNSCRIPT"><code>RUNSCRIPT</code></a></p></li><li><p>Услуги для Пользователя</p><p><a href="#REMOVEACCOUNTSUBSET"><code>REMOVEACCOUNTSUBSET</code></a> <a href="#DATASET"><code>DATASET</code></a> <a href="#ROSTER"><code>ROSTER</code></a> <a href="#BALANCE"><code>BALANCE</code></a></p></li><li><p>Установки Сервера</p><p><a href="#LISTMODULES"><code>LISTMODULES</code></a>, <a href="#GETMODULE"><code>GETMODULE</code></a>, <a href="#SETMODULE"><code>SETMODULE</code></a>, <a href="#UPDATEMODULE"><code>UPDATEMODULE</code></a><br><a href="#GETQUEUESETTINGS"><code>GETQUEUESETTINGS</code></a>, <a href="#SETQUEUESETTINGS"><code>SETQUEUESETTINGS</code></a>, <a href="#GETSIGNALSETTINGS"><code>GETSIGNALSETTINGS</code></a>, <a href="#SETSIGNALSETTINGS"><code>SETSIGNALSETTINGS</code></a>, <a href="#GETMEDIASERVERSETTINGS"><code>GETMEDIASERVERSETTINGS</code></a>, <a href="#SETMEDIASERVERSETTINGS"><code>SETMEDIASERVERSETTINGS</code></a><br><a href="#GETSESSIONSETTINGS"><code>GETSESSIONSETTINGS</code></a>, <a href="#SETSESSIONSETTINGS"><code>SETSESSIONSETTINGS</code></a><br><a href="#GETCLUSTERSETTINGS"><code>GETCLUSTERSETTINGS</code></a>, <a href="#SETCLUSTERSETTINGS"><code>SETCLUSTERSETTINGS</code></a><br><a href="#GETLOGSETTINGS"><code>GETLOGSETTINGS</code></a>, <a href="#UPDATELOGSETTINGS"><code>UPDATELOGSETTINGS</code></a><br><a href="#GETNETWORK"><code>GETNETWORK</code></a>, <a href="#SETNETWORK"><code>SETNETWORK</code></a>, <a href="#GETCLUSTERNETWORK"><code>GETCLUSTERNETWORK</code></a>, <a href="#SETCLUSTERNETWORK"><code>SETCLUSTERNETWORK</code></a><br><a href="#GETDNRSETTINGS"><code>GETDNRSETTINGS</code></a>, <a href="#SETDNRSETTINGS"><code>SETDNRSETTINGS</code></a>,<br><a href="#GETBANNED"><code>GETBANNED</code></a>, <a href="#GETCLUSTERBANNED"><code>GETCLUSTERBANNED</code></a>, <a href="#SETBANNED"><code>SETBANNED</code></a>, <a href="#SETCLUSTERBANNED"><code>SETCLUSTERBANNED</code></a><br><a href="#GETSERVERMAILRULES"><code>GETSERVERMAILRULES</code></a>, <a href="#SETSERVERMAILRULES"><code>SETSERVERMAILRULES</code></a>, <a href="#GETCLUSTERMAILRULES"><code>GETCLUSTERMAILRULES</code></a>, <a href="#SETCLUSTERMAILRULES"><code>SETCLUSTERMAILRULES</code></a><br><a href="#GETSERVERSIGNALRULES"><code>GETSERVERSIGNALRULES</code></a>, <a href="#SETSERVERSIGNALRULES"><code>SETSERVERSIGNALRULES</code></a>, <a href="#GETCLUSTERSIGNALRULES"><code>GETCLUSTERSIGNALRULES</code></a>, <a href="#SETCLUSTERSIGNALRULES"><code>SETCLUSTERSIGNALRULES</code></a><br><a href="#GETROUTERTABLE"><code>GETROUTERTABLE</code></a>, <a href="#SETROUTERTABLE"><code>SETROUTERTABLE</code></a>, <a href="#GETCLUSTERROUTERTABLE"><code>GETCLUSTERROUTERTABLE</code></a>, <a href="#SETCLUSTERROUTERTABLE"><code>SETCLUSTERROUTERTABLE</code></a><br><a href="#GETROUTERSETTINGS"><code>GETROUTERSETTINGS</code></a>, <a href="#SETROUTERSETTINGS"><code>SETROUTERSETTINGS</code></a>, <a href="#GETCLUSTERROUTERSETTINGS"><code>GETCLUSTERROUTERSETTINGS</code></a>, <a href="#SETCLUSTERROUTERSETTINGS"><code>SETCLUSTERROUTERSETTINGS</code></a><br><a href="#REFRESHOSDATA"><code>REFRESHOSDATA</code></a><br><a href="#GETLANIPS"><code>GETLANIPS</code></a>, <a href="#SETLANIPS"><code>SETLANIPS</code></a>, <a href="#GETCLUSTERLANIPS"><code>GETCLUSTERLANIPS</code></a>, <a href="#SETCLUSTERLANIPS"><code>SETCLUSTERLANIPS</code></a><br><a href="#GETPROXYIPS"><code>GETPROXYIPS</code></a>, <a href="#SETPROXYIPS"><code>SETPROXYIPS</code></a>, <a href="#GETCLUSTERPROXYIPS"><code>GETCLUSTERPROXYIPS</code></a>, <a href="#SETCLUSTERPROXYIPS"><code>SETCLUSTERPROXYIPS</code></a><br><a href="#GETCLIENTIPS"><code>GETCLIENTIPS</code></a>, <a href="#SETCLIENTIPS"><code>SETCLIENTIPS</code></a>, <a href="#GETCLUSTERCLIENTIPS"><code>GETCLUSTERCLIENTIPS</code></a>, <a href="#SETCLUSTERCLIENTIPS"><code>SETCLUSTERCLIENTIPS</code></a><br><a href="#GETBLACKLISTEDIPS"><code>GETBLACKLISTEDIPS</code></a>, <a href="#SETBLACKLISTEDIPS"><code>SETBLACKLISTEDIPS</code></a>, <a href="#GETCLUSTERBLACKLISTEDIPS"><code>GETCLUSTERBLACKLISTEDIPS</code></a>, <a href="#SETCLUSTERBLACKLISTEDIPS"><code>SETCLUSTERBLACKLISTEDIPS</code></a><br><a href="#GETWHITEHOLEIPS"><code>GETWHITEHOLEIPS</code></a>, <a href="#SETWHITEHOLEIPS"><code>SETWHITEHOLEIPS</code></a>, <a href="#GETCLUSTERWHITEHOLEIPS"><code>GETCLUSTERWHITEHOLEIPS</code></a>, <a href="#SETCLUSTERWHITEHOLEIPS"><code>SETCLUSTERWHITEHOLEIPS</code></a><br><a href="#GETNATEDIPS"><code>GETNATEDIPS</code></a>, <a href="#SETNATEDIPS"><code>SETNATEDIPS</code></a>, <a href="#GETCLUSTERNATEDIPS"><code>GETCLUSTERNATEDIPS</code></a>, <a href="#SETCLUSTERNATEDIPS"><code>SETCLUSTERNATEDIPS</code></a><br><a href="#GETNATSITEIPS"><code>GETNATSITEIPS</code></a>, <a href="#SETNATSITEIPS"><code>SETNATSITEIPS</code></a>, <a href="#GETCLUSTERNATSITEIPS"><code>GETCLUSTERNATSITEIPS</code></a>, <a href="#SETCLUSTERNATSITEIPS"><code>SETCLUSTERNATSITEIPS</code></a><br><a href="#GETDEBUGIPS"><code>GETDEBUGIPS</code></a>, <a href="#SETDEBUGIPS"><code>SETDEBUGIPS</code></a>, <a href="#GETCLUSTERDEBUGIPS"><code>GETCLUSTERDEBUGIPS</code></a>, <a href="#SETCLUSTERDEBUGIPS"><code>SETCLUSTERDEBUGIPS</code></a><br><a href="#GETDENIEDIPS"><code>GETDENIEDIPS</code></a>, <a href="#SETDENIEDIPS"><code>SETDENIEDIPS</code></a>, <a href="#GETCLUSTERDENIEDIPS"><code>GETCLUSTERDENIEDIPS</code></a>, <a href="#SETCLUSTERDENIEDIPS"><code>SETCLUSTERDENIEDIPS</code></a><br><a href="#ROUTE"><code>ROUTE</code></a> <a href="#GETIPSTATE"><code>GETIPSTATE</code></a><br><a href="#GETSERVERINTERCEPT"><code>GETSERVERINTERCEPT</code></a>, <a href="#SETSERVERINTERCEPT"><code>SETSERVERINTERCEPT</code></a>, <a href="#GETCLUSTERINTERCEPT"><code>GETCLUSTERINTERCEPT</code></a>, <a href="#SETCLUSTERINTERCEPT"><code>SETCLUSTERINTERCEPT</code></a><br><a href="#GETSERVERSETTINGS"><code>GETSERVERSETTINGS</code></a> <a href="#UPDATESERVERSETTINGS"><code>UPDATESERVERSETTINGS</code></a></p></li><li><p>Наблюдение</p><p><a href="#GETSTATELEMENT"><code>GETSTATELEMENT</code></a>, <a href="#SETSTATELEMENT"><code>SETSTATELEMENT</code></a>, <a href="#GETNEXTSTATNAME"><code>GETNEXTSTATNAME</code></a>, <a href="#GETDIALOGINFO"><code>GETDIALOGINFO</code></a>, <a href="#SHUTDOWN"><code>SHUTDOWN</code></a></p></li><li><p>Статистика</p><p><a href="#GETACCOUNTSTAT"><code>GETACCOUNTSTAT</code></a>, <a href="#RESETACCOUNTSTAT"><code>RESETACCOUNTSTAT</code></a>, <a href="#GETDOMAINSTAT"><code>GETDOMAINSTAT</code></a>, <a href="#RESETDOMAINSTAT"><code>RESETDOMAINSTAT</code></a></p></li><li><p>Управление Справочником</p><p><a href="#LISTDIRECTORYUNITS"><code>LISTDIRECTORYUNITS</code></a>, <a href="#CREATEDIRECTORYUNIT"><code>CREATEDIRECTORYUNIT</code></a>, <a href="#RELOCATEDIRECTORYUNIT"><code>RELOCATEDIRECTORYUNIT</code></a>, <a href="#DELETEDIRECTORYUNIT"><code>DELETEDIRECTORYUNIT</code></a>, <a href="#GETDIRECTORYUNIT"><code>GETDIRECTORYUNIT</code></a>, <a href="#SETDIRECTORYUNIT"><code>SETDIRECTORYUNIT</code></a>, <a href="#GETDIRECTORYACCESSRIGHTS"><code>GETDIRECTORYACCESSRIGHTS</code></a>, <a href="#SETDIRECTORYACCESSRIGHTS"><code>SETDIRECTORYACCESSRIGHTS</code></a></p></li><li><p>Разные Команды</p><p><a href="#LISTCLICOMMANDS"><code>LISTCLICOMMANDS</code></a>, <a href="#NOOP"><code>NOOP</code></a>, <a href="#ECHO"><code>ECHO</code></a>, <a href="#GETVERSION"><code>GETVERSION</code></a>, <a href="#GETSYSTEMINFO"><code>GETSYSTEMINFO</code></a>, <a href="#GETCURRENTTIME"><code>GETCURRENTTIME</code></a>, <a href="#SETLOGALL"><code>SETLOGALL</code></a>, <a href="#DUMPALLOBJECTS"><code>DUMPALLOBJECTS</code></a>, <a href="#TESTLOOP"><code>TESTLOOP</code></a>, <a href="#WRITELOG"><code>WRITELOG</code></a>, <a href="#RELEASESMTPQUEUE"><code>RELEASESMTPQUEUE</code></a>, <a href="#REJECTQUEUEMESSAGE"><code>REJECTQUEUEMESSAGE</code></a>, <a href="#REJECTQUEUEMESSAGES"><code>REJECTQUEUEMESSAGES</code></a>, <a href="#GETMESSAGEQUEUEINFO"><code>GETMESSAGEQUEUEINFO</code></a>, <a href="#GETCURRENTCONTROLLER"><code>GETCURRENTCONTROLLER</code></a>, <a href="#RECONNECTCLUSTERADMIN"><code>RECONNECTCLUSTERADMIN</code></a>,<br><a href="#GETTEMPCLIENTIPS"><code>GETTEMPCLIENTIPS</code></a>, <a href="#REPORTFAILEDLOGINADDRESS"><code>REPORTFAILEDLOGINADDRESS</code></a>,<br><a href="#TEMPBLACKLISTIP"><code>TEMPBLACKLISTIP</code></a>, <a href="#GETTEMPBLACKLISTEDIPS"><code>GETTEMPBLACKLISTEDIPS</code></a>, <a href="#SETTEMPBLACKLISTEDIPS"><code>SETTEMPBLACKLISTEDIPS</code></a>,<br><a href="#TEMPUNBLOCKIP"><code>TEMPUNBLOCKIP</code></a>, <a href="#GETTEMPUNBLOCKABLEIPS"><code>GETTEMPUNBLOCKABLEIPS</code></a>, <a href="#SETTEMPUNBLOCKABLEIPS"><code>SETTEMPUNBLOCKABLEIPS</code></a></p></li></ul>',1080)]))}const n=a(d,[["render",c]]);export{A as __pageData,n as default};
