import{_ as i,c as a,o as t,ag as e}from"./chunks/framework.jCcxW76o.js";const r=JSON.parse('{"title":"Форматы Данных","description":"","frontmatter":{"legacyLink":"russian/Data.html","outline":[2,3]},"headers":[],"relativePath":"russian/development/Data.md","filePath":"russian/development/Data.md"}'),n={name:"russian/development/Data.md"};function l(p,s,h,d,k,E){return t(),a("div",null,s[0]||(s[0]=[e(`<h1 id="форматы-данных" tabindex="-1">Форматы Данных <a class="header-anchor" href="#форматы-данных" aria-label="Permalink to &quot;Форматы Данных&quot;">​</a></h1><p>Сервер CommuniGate Pro обрабатывает большинство типов данных как абстрактные <em>объекты</em>. В этом разделе описывается абстрактные, базовые типы объектов, используемые всеми компонентами Сервера.</p><p>Для каждого типа объекта указывается текстовое представление объекта.</p><p>Когда объект сохраняется в файле, отправляется в ответ по команде <a href="./CLI.html">CLI/API</a> или извлекается с Сервера любым другим способом, то используется текстовое представление объекта.</p><p>Когда Сервер читает объект извне (из файла настроек, из команды CLI и т.д.), он преобразовывает полученное текстовое представление во внутренний объект.</p><h2 id="Syntax" tabindex="-1">Текстовое Представление <a class="header-anchor" href="#Syntax" aria-label="Permalink to &quot;Текстовое Представление {#Syntax}&quot;">​</a></h2><p>Объекты представляются в виде текста из одной или нескольких строк (в зависимости от контекста).</p><p>Элементы представления объекта могут разделяться &quot;пустым пространством&quot;. В одностроковом представление в качестве &quot;пустого пространства&quot; может использоваться только символ пробела.<br> В многостроковом представлении пробел и символ &quot;горизонтальной табуляции&quot;, а также символы EOL (обозначения конца строки, CR и/или LF) тоже считаются символами &quot;пустого пространства&quot;. Дополнительно &quot;пустым пространством&quot; считается комментарий, который может состоять из:</p><ul><li>символов двойной косой черты (<code>//</code>) и всех символов, следующих за ними до символа EOL (конец строки) включительно.</li><li>последовательности символов косой черты и звёздочки (<code>/*</code>) и всех символов, следующих за ними до последовательности символов звёздочки и косой черты (<code>*/</code>) включительно.</li></ul><h2 id="Atomic" tabindex="-1">Простые Объекты <a class="header-anchor" href="#Atomic" aria-label="Permalink to &quot;Простые Объекты {#Atomic}&quot;">​</a></h2><p>Простые объекты являются неструктурированными, обычными объектами одного из типов данных.</p><h3 id="String" tabindex="-1">Строки <a class="header-anchor" href="#String" aria-label="Permalink to &quot;Строки {#String}&quot;">​</a></h3><p>Строка является последовательностью байт, представляющих текст в кодировке UTF-8 и не содержащих двоичный нулевой байт.</p><p>Текстовое представление строки является либо <em>атомарным</em> - последовательностью букв латинского алфавита (в кодировке ASCII) и цифр, либо <em>строкой в кавычках</em> - последовательностью любых отображаемых символов (используя кодировку UTF-8), исключая символ кавычки и символ обратной косой черты, заключённой в кавычки (<code>&quot;</code>).</p><p>Примеры:</p><ul><li><code>MyName</code></li><li><code>My2ndName</code></li><li><code>&quot;Моё имя с пробелами and the . symbol&quot;</code></li></ul><p>Если вы хотите включить символ кавычки в строку в кавычках, укажите символ обратной косой черты и кавычки, а если вы хотите включить символ обратной косой черты в строку в кавычках, укажите два символа обратной косой черты подряд.</p><p>Примеры:</p><ul><li><code>&quot;a \\&quot;string\\&quot; within string&quot;</code></li><li><code>&quot;Single \\\\ backslash&quot;</code></li></ul><p>Вы можете использовать комбинацию символов <code>\\r</code>, чтобы включить в строку символ <em>возврата каретки</em>; вы можете использовать комбинацию символов <code>\\n</code>, чтобы включить в строку символ <em>перевод строки</em> и вы можете использовать комбинацию символов <code>\\e</code>, чтобы включить в строку независимую от операционной системы последовательность символов для <em>Конца Строки</em>.</p><p>Примеры:</p><ul><li><code>&quot;Line1\\eLine2&quot;</code></li><li><code>TEXT3\\rTEXT67\\nTEXT78&quot;</code></li></ul><p>Используйте комбинацию <code>\\r</code> или <code>\\n</code> для включения знаков возврата каретки и конца строки только если они НЕ используются как разделители строк.</p><p>Чтобы включить в строку символ <em>табуляции</em>, вы можете использовать комбинацию символов <code>\\t</code>.</p><p>Пример:</p><ul><li><code>&quot;Line1:\\tField1\\tField2\\eLine2:\\tField1\\tField2&quot;</code></li></ul><p>Можно использовать комбинацию символов <code>\\nnn</code>, чтобы включить в строку любой символ; здесь <em>nnn</em> - трёхзначное десятичное число, равное коду ASCII требуемого символа.</p><p>Пример:</p><ul><li><code>&quot;Using the \\012 (Vertical Tabulation) symbol&quot;</code></li></ul><p>Можно использовать комбинацию символов <code>\\u&#39;nnn&#39;</code>, чтобы включить в строку любой символ; здесь <em>nnn</em> - шестнадцатеричное число, равное коду Unicode требуемого символа.</p><p>Пример:</p><ul><li><code>&quot;Using the \\u&#39;2764&#39; (Heavy black heart) symbol&quot;</code></li></ul><p>В многострочном представлении строка может быть представлена последовательностью двух и более строк, при необходимости разделённых одним и более символами &quot;пустого пространства&quot;. Это позволяет записывать длинные строковые значения в несколько строк.</p><h3 id="DataBlock" tabindex="-1">Блоки Данных <a class="header-anchor" href="#DataBlock" aria-label="Permalink to &quot;Блоки Данных {#DataBlock}&quot;">​</a></h3><p>Блоки данных (datablock) являются базовыми, неструктурированными блоками двоичных данных. Они создаются как текстовые строки двоичных данных в кодировке Base64, заключённые в квадратные скобки.</p><p>Пример:</p><ul><li><code>[HcqHfHI=]</code><br> это блок двоичных данных, содержащих следующие 5 двоичных байт данных: <code>0x1D 0xCA 0x87 0x7C 0x72</code></li></ul><p>Символы &quot;пустого пространства&quot; могут помещаться где угодно внутри квадратных скобок.</p><h3 id="Number" tabindex="-1">Числа <a class="header-anchor" href="#Number" aria-label="Permalink to &quot;Числа {#Number}&quot;">​</a></h3><p>Числа (numbers) являются основными неструктурированными объектами данных. Каждый объект Число содержит одно 64-битное целое значение со знаком. Число представляется в виде текстовой строки, начинающейся с символа <code>#</code>, за которым следует (необязательный) символ минуса (<code>-</code>), за которым, в свою очередь, следует одна или более десятичная цифра или <em>индикатор системы счисления</em> с цифрами, разрешёнными в указанной системе счисления.<br> Индикатор основания системы счисления <code>0x</code> задаёт значение основания 16 (шестнадцатеричное число), индикатор <code>0o</code> задаёт значение основания 8 (восьмеричное число), индикатор <code>0b</code> задаёт значение 2 (двоичное число).</p><p>Примеры:</p><ul><li><code>#-234657</code></li><li><code>#0x17EF</code></li><li><code>#-0b1000111000</code></li></ul><h3 id="Date" tabindex="-1">Отметки времени <a class="header-anchor" href="#Date" aria-label="Permalink to &quot;Отметки времени {#Date}&quot;">​</a></h3><p>Отметки Времени (time stamps) являются основными неструктурированными объектами данных. Каждая Отметка Времени содержит одно значение глобального времени. Значение времени представляется в GMT времени как текстовая строка, начинающаяся с символов <code>#T</code> и содержащая значение дня, месяца, года и, необязательно, часа, минуты и секунды.</p><p>Пример:</p><ul><li><code>#T22-10-2009_15:24:45</code></li></ul><p>Определены также две специальные Отметки Времени - одна для &quot;далёкого прошлого&quot; (<code>#TPAST</code>) и другая для &quot;далёкого будущего&quot; (<code>#TFUTURE</code>).</p><h3 id="IPAddr" tabindex="-1">IP Адреса <a class="header-anchor" href="#IPAddr" aria-label="Permalink to &quot;IP Адреса {#IPAddr}&quot;">​</a></h3><p>IP Адреса (IP Addresses) являются основными неструктурированными объектами данных. Каждый объект IP Адрес содержит в себе IPv4 или IPv6 адрес и, необязательно, номер порта. IP Адрес представляется в виде текстовой строки, начинающейся с символов <code>#I</code> и содержащей канонический IPv4 или IPv6 адрес, за которым через двоеточие может следовать номер порта.</p><p>Примеры:</p><ul><li><code>#I[10.0.44.55]:25</code></li><li><code>#I[2001:470:1f01:2565::a:80f]:25</code></li></ul><h3 id="Null" tabindex="-1">Нулевой Объект <a class="header-anchor" href="#Null" aria-label="Permalink to &quot;Нулевой Объект {#Null}&quot;">​</a></h3><p>Нулевой объект является уникальным простым объектом, представляющим отсутствие любого другого объекта.<br> Нулевой объект представляется в виде текстовой строки <code>#NULL#</code>.</p><h3 id="Unknown" tabindex="-1">Другие Объекты <a class="header-anchor" href="#Unknown" aria-label="Permalink to &quot;Другие Объекты {#Unknown}&quot;">​</a></h3><p>Когда сервер преобразует объекты из внутреннего в текстовое представление, в их структуре может встретится специфичный для приложения объект, для которого нет текстового представления. Такие объекты представляются в виде текста <code>#(objectName:address)</code>, где <em>objectName</em> - строка из букв и цифр с именем класса объекта, а <em>address</em> -шестнадцатеричное число с адресом объекта в памяти.</p><p>Такие объекты НЕ должны использоваться в текстовом представлении, которое конвертируется в объект данных.</p><h2 id="Structured" tabindex="-1">Структурированные Объекты <a class="header-anchor" href="#Structured" aria-label="Permalink to &quot;Структурированные Объекты {#Structured}&quot;">​</a></h2><h3 id="Array" tabindex="-1">Массивы <a class="header-anchor" href="#Array" aria-label="Permalink to &quot;Массивы {#Array}&quot;">​</a></h3><p>Объект Массив (array) - это упорядоченный набор объектов (элементов массива).</p><p>Текстовое представление массива - список представлений его элементов, разделённых символами запятой (<code>,</code>) и заключённый в круглые скобки.</p><p>Пример:</p><ul><li><code>(Element1 , &quot;Element2&quot; , &quot;Element 3&quot;)</code></li></ul><p>Элементом массива может быть любой объект - строка, массив, словарь и т.д.</p><p>Пример:</p><ul><li><code>(Element1 , (&quot;Sub Element1&quot;, SubElement2) , &quot;Element 3&quot;)</code></li></ul><p>Любое число пробелов, символов табуляции и/или символов новой строки (символов конца строки) может находиться между скобками и элементом, а также между элементом и символом запятой.</p><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>(</span></span>
<span class="line"><span>  Element1  ,</span></span>
<span class="line"><span>  (    &quot;Sub Element1&quot;,</span></span>
<span class="line"><span>   SubElement2  )</span></span>
<span class="line"><span>  ,</span></span>
<span class="line"><span>&quot;Element 3&quot;  )</span></span></code></pre></div><p>Массив может содержать ноль элементов (пустой массив).</p><p>Пример:</p><ul><li><code>()</code></li></ul><h3 id="Dictionary" tabindex="-1">Словари <a class="header-anchor" href="#Dictionary" aria-label="Permalink to &quot;Словари {#Dictionary}&quot;">​</a></h3><p>Объект Словарь (dictionary) является набором пар ключ-значение. Ключи словаря являются строками. Каждый ключ в словаре должен быть уникальным. Ключи словаря обрабатываются как <strong>зависимые от регистра</strong> строки, за исключением случая, если явно не указано иное.</p><p>Любой объект может использоваться как значение, связанное с ключом.</p><p>Текстовым представлением словаря является последовательность его пар ключ/значение, заключённая в фигурные скобки.<br> Каждая пара представляется как строка с ключом, за которым следует знак равно (<code>=</code>) и текстовое представление значения связанного объекта, оканчивающегося символом точка с запятой (<code>;</code>).</p><p>Пример:</p><ul><li><code>{Key1=Element1; Key2 =&quot;Element2&quot; ; &quot;Third Key&quot;=&quot;Element 3&quot;; }</code></li></ul><p>Значением объекта в любой паре ключ/значение может быть строка, массив, словарь или любой другой объект.</p><p>Пример:</p><ul><li><code>{Key1=(Elem1,Elem2); Key2={Sub1=&quot;XXX 1&quot;; Sub2=X245;}; }</code></li></ul><p>Любое число пробелов, символов табуляции и/или символов новой строки (символов конца строки) может находиться между фигурными скобками и парой, рядом с символом равно и рядом с символом точка с запятой.</p><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>{</span></span>
<span class="line"><span> Key1  =   (Elem1,Elem2)   ;</span></span>
<span class="line"><span> Key2 = {  Sub1 = &quot;XXX 1&quot;;</span></span>
<span class="line"><span>    Sub2=X245;  };</span></span>
<span class="line"><span>}</span></span></code></pre></div><p>Словарь может иметь ноль элементов (пустой словарь).</p><p>Пример:</p><ul><li><code>{}</code></li></ul><h3 id="XML" tabindex="-1">XML <a class="header-anchor" href="#XML" aria-label="Permalink to &quot;XML {#XML}&quot;">​</a></h3><p>Объект XML является документом XML. Он имеет имя, набор пространств имён (строки), набор атрибутов со значениями типа строка и ноль, один или несколько элементов тела. Каждый элемент тела является либо строкой, либо объектом XML.</p><p>Текстовым представлением объекта XML является его стандартное текстовое представление, начинающееся с символа угловая скобка.</p><h2 id="Rules" tabindex="-1">Правила Формального Синтаксиса <a class="header-anchor" href="#Rules" aria-label="Permalink to &quot;Правила Формального Синтаксиса {#Rules}&quot;">​</a></h2><p>Ниже приводится формальное определение синтаксиса для текстовых представлений объектов базовых типов.</p><table tabindex="0"><thead><tr><th></th><th></th></tr></thead><tbody><tr><td><em>b-digit</em></td><td><code>0</code> | <code>1</code></td></tr><tr><td><em>o-digit</em></td><td><code>0</code> .. <code>7</code></td></tr><tr><td><em>d-digit</em></td><td><code>0</code> .. <code>9</code></td></tr><tr><td><em>h-digit</em></td><td><em>d-digit</em> | <code>A</code> .. <code>F</code> | <code>a</code> .. <code>f</code></td></tr><tr><td><em>a-symbol</em></td><td><code>A</code> .. <code>Z</code> | <code>a</code> .. <code>z</code> | <em>d-digit</em></td></tr><tr><td><em>u-symbol</em></td><td><em>a-symbol</em> | <em>любой символ utf-8 не из ASCII таблицы</em></td></tr><tr><td><em>l-symbol</em></td><td><em>u-symbol</em> | <code>.</code> | <code>-</code> | <code>_</code> | <code>@</code></td></tr><tr><td><em>atom</em></td><td><strong>1*</strong> <em>l-symbol</em></td></tr><tr><td><em>b-symbol</em></td><td><em>a-symbol</em> | <code>+</code> | <code>/</code> | <code>=</code></td></tr><tr><td><em>s-symbol</em></td><td><em>любой отображаемый символ кроме <code>&quot;</code> и <code>\\</code></em> | <code>\\\\</code> | <code>\\&quot;</code> | <code>\\r</code> | <code>\\n</code> | <code>\\e</code> | <code>\\t</code> | <code>\\</code> <em>d-digit</em> <em>d-digit</em> <em>d-digit</em></td></tr><tr><td><em>string</em></td><td><code>&quot;</code> <strong>0*</strong> <em>s-symbol</em> <code>&quot;</code> | <em>atom</em></td></tr><tr><td><em>datablock</em></td><td><code>[</code> <strong>1*</strong> <em>b-symbol</em> <code>]</code></td></tr><tr><td><em>day</em></td><td><code>0</code> .. <code>3</code> <em>d-digit</em> <em>(двухзначное число в диапазоне 1..31)</em></td></tr><tr><td><em>month</em></td><td><code>0</code> .. <code>1</code> <em>d-digit</em> <em>(двухзначное число в диапазоне 1..12)</em></td></tr><tr><td><em>year</em></td><td><code>1</code> .. <code>2</code> <em>d-digit</em> <em>d-digit</em> <em>d-digit</em> <em>(четырёхзначное число в диапазоне 1970..2038)</em></td></tr><tr><td><em>hour</em></td><td><code>0</code> .. <code>2</code> <em>d-digit</em> <em>(двухзначное число в диапазоне 0..23)</em></td></tr><tr><td><em>minute</em></td><td><code>0</code> .. <code>5</code> <em>d-digit</em> <em>(двухзначное число в диапазоне 0..59)</em></td></tr><tr><td><em>second</em></td><td><code>0</code> .. <code>5</code> <em>d-digit</em> <em>(двухзначное число в диапазоне 0..59)</em></td></tr><tr><td><em>number</em></td><td><code>#</code> [ <code>-</code> ] <strong>1*</strong> <em>d-digit</em> | <code>#</code> [<code>-</code>] <code>0x</code> 1* <em>h-digit</em> | <code>#</code> [<code>-</code>] <code>0b</code> 1* <em>b-digit</em> | <code>#</code> [<code>-</code>] <code>0o</code> 1* <em>o-digit</em></td></tr><tr><td><em>timestamp</em></td><td><code>#T</code> <em>day</em> <code>-</code> <em>month</em> <code>-</code> <em>year</em> [ <code>_</code> <em>hour</em> <code>:</code> <em>minute</em> <code>:</code> <em>second</em> ]</td></tr><tr><td><em>ip4</em></td><td><strong>1*</strong> <em>d-digit</em> <code>.</code> <strong>1*</strong> <em>d-digit</em> <code>.</code> <strong>1*</strong> <em>d-digit</em> <code>.</code> <strong>1*</strong> <em>d-digit</em></td></tr><tr><td><em>ip6</em></td><td><strong>0*</strong> (<strong>1*</strong> <em>h-digit</em> <code>:</code>) [<code>:</code> [ 0*(<strong>1*</strong> <em>h-digit</em> <code>:</code>) ] ]</td></tr><tr><td><em>ip-address</em></td><td><code>#I[</code> [ <em>ip4</em> | <em>ip6</em> ] <code>]</code> [ <code>:</code> <strong>1*</strong> <em>d-digit</em> ]</td></tr><tr><td><em>null-object</em></td><td><code>#NULL#</code></td></tr><tr><td><em>array</em></td><td><code>(</code> <code>[</code> <em>object</em> <strong>0*</strong> ( <code>,</code> <em>object</em> ) <code>]</code> <code>)</code></td></tr><tr><td><em>dictionary</em></td><td><code>{</code> <strong>0*</strong> ( <em>string</em> <code>=</code> <em>object</em> <code>;</code> ) <code>}</code></td></tr><tr><td><em>XML</em></td><td><code>&lt;</code> <em>XML в стандартном формате</em> <code>\\&gt;</code></td></tr><tr><td><em>object</em></td><td><em>string</em> | <em>datablock</em> | <em>number</em> | <em>timestamp</em> | <em>ip-address</em> | <em>null-object</em> | <em>array</em> | <em>dictionary</em> | <em>XML</em></td></tr></tbody></table><h2 id="XMLObjects" tabindex="-1">Объекты XML <a class="header-anchor" href="#XMLObjects" aria-label="Permalink to &quot;Объекты XML {#XMLObjects}&quot;">​</a></h2><p>CommuniGate Pro может преобразовывать сложные структуры (такие как vCards, iCalendar, SDP объекты) в простые объекты XML. Представление XML может также потребоваться для таких объектов как блоки данных, массивы или словари. Этот раздел описывает представление XML в CommuniGate Pro для всех таких объектов и сложных структур.</p><h3 id="XMLString" tabindex="-1">Строка <a class="header-anchor" href="#XMLString" aria-label="Permalink to &quot;Строка {#XMLString}&quot;">​</a></h3><p>Строка представляется текстовым элементом.<br> Если это верхний элемент XML, то строка представляется как элемент XML <code>object</code> с текстовым телом, содержащим эту строку.</p><p>Если строка содержит специальные символы, то она должна быть представлена как элемент <code>binString</code> с текстовым телом в кодировке base64.<br> Пустая строка может быть представлена пустым элементом <code>binString</code>.</p><h3 id="XMLDataBlock" tabindex="-1">Блок Данных <a class="header-anchor" href="#XMLDataBlock" aria-label="Permalink to &quot;Блок Данных {#XMLDataBlock}&quot;">​</a></h3><p>Блок данных представляется как элемент XML <code>base64</code>.<br> Телом элемента XML является содержимое блока данных в кодировке base64.</p><p>Пример:</p><ul><li><code>&lt;base64&gt;STYRyui=&lt;/base64&gt;</code></li></ul><h3 id="XMLNumber" tabindex="-1">Число <a class="header-anchor" href="#XMLNumber" aria-label="Permalink to &quot;Число {#XMLNumber}&quot;">​</a></h3><p>Число представляется как элемент XML <code>number</code>.<br> Телом элемента XML является текстовое представление значения числового объекта (десятичное или, если указан индикатор системы счисления, шестнадцатеричное, восьмеричное или бинарное).</p><p>Примеры:</p><ul><li><code>&lt;number&gt;123456&lt;/number&gt;</code></li><li><code>&lt;number&gt;0x78FAB5&lt;/number&gt;</code></li></ul><h3 id="XMLDate" tabindex="-1">Отметка Времени <a class="header-anchor" href="#XMLDate" aria-label="Permalink to &quot;Отметка Времени {#XMLDate}&quot;">​</a></h3><p>Отметка Времени представляется как элемент XML <code>date</code>.<br> Телом элемента XML является текстовое представление отметки времени в формате iCalendar.</p><p>Пример:</p><ul><li><code>&lt;date&gt;20101122T123000Z&lt;/date&gt;</code></li></ul><h3 id="XMLIPAddr" tabindex="-1">IP Адреса <a class="header-anchor" href="#XMLIPAddr" aria-label="Permalink to &quot;IP Адреса {#XMLIPAddr}&quot;">​</a></h3><p>IP адрес представляются как элемент XML <code>ipAddr</code>.<br> Телом элемента XML является текстовое представление IP адреса, заключённое в квадратные скобки и необязательное отделённое двоеточием десятичное число - номера порта.</p><p>Пример:</p><ul><li><code>&lt;ipAddr&gt;[10.0.2.2]:8010&lt;/ipAddr&gt;</code></li></ul><h3 id="XMLNull" tabindex="-1">Нулевое значение <a class="header-anchor" href="#XMLNull" aria-label="Permalink to &quot;Нулевое значение {#XMLNull}&quot;">​</a></h3><p>Объект с нулевым значением представляется как пустой элемент XML <code>null</code>.</p><h3 id="XMLArray" tabindex="-1">Массив <a class="header-anchor" href="#XMLArray" aria-label="Permalink to &quot;Массив {#XMLArray}&quot;">​</a></h3><p><a href="#Array">Массив</a> представляется как последовательность из одного или более XML элементов <code>subValue</code>.<br> Тело элемента XML представляет элемент массива.<br> Пустой массив представляется как один элемент XML <code>subValue</code> без тела.<br> Если верхний XML элемент, то массив представляется как элемент XML <code>object</code>, с текстовым телом, содержащим элементы XML <code>subValue</code>.</p><p>Пример:</p><ul><li><code>&lt;subValue&gt;my string&lt;/subValue&gt;&lt;subValue&gt;&lt;number&gt;123456&lt;/number&gt;&lt;/subValue&gt;</code></li></ul><h3 id="XMLDictionary" tabindex="-1">Словарь <a class="header-anchor" href="#XMLDictionary" aria-label="Permalink to &quot;Словарь {#XMLDictionary}&quot;">​</a></h3><p><a href="#Dictionary">Словарь</a> представляется как последовательность из одного или более элементов XML <code>subKey</code>.<br> Атрибут <code>key</code> элемента XML задаёт ключ элемента словаря, а тело XML представляет значение элемента словаря.<br> Пустой словарь представляется как один элемент XML <code>subKey</code> без атрибута <code>key</code> и без тела.<br> Если словарь является верхним элементом XML, то он представляется как элемент XML <code>object</code>, с текстовым телом, содержащим элементы XML <code>subKey</code>.</p><p>Пример:</p><ul><li><code>&lt;subKey key=&quot;firstKey&quot;&gt;my string&lt;/subKey&gt;&lt;subKey key=&quot;secondKey&quot;&gt;&lt;number&gt;123456&lt;/number&gt;&lt;/subKey&gt;</code></li></ul><h3 id="XMLvCard" tabindex="-1"><code>vCard</code> <a class="header-anchor" href="#XMLvCard" aria-label="Permalink to &quot;\`vCard\` {#XMLvCard}&quot;">​</a></h3><p>Этот элемент XML представляет объект vCard (согласно спецификации Jabber/XEP для документов XML vCard).</p><ul><li><p>Атрибуты:</p><ul><li><p><code>modified</code></p><p>Этот необязательный атрибут содержит значение свойства <code>REV</code> (время GMT в формате iCalendar).</p></li></ul></li><li><p>Тело:</p><p>Содержит свойства vCard как XML элементы с такими же именами, преобразованными к верхнему регистру ASCII.<br> Каждый элемент свойства содержит:</p><ul><li><p>Атрибуты:</p><p><em>отсутствуют</em></p></li><li><p>Тело:</p><p>набор элементов XML, представляющих параметры свойства и значение свойства:</p><ul><li><p>параметры</p><p>Элементы XML с такими же именами, как и имена параметров, преобразованные к верхнему регистру ASCII. Параметры <code>ENCODING</code> и <code>QUOTED-PRINTABLE</code> свойств vCard используются для декодирования значений свойства, и поэтому они не сохраняются.</p></li><li><p>значение:</p><ul><li><p>структурированные значения (<code>N</code>,<code>ORG</code>,<code>ADR</code>)</p><p>набор элементов XML с именами элементов структуры и текстовые тела, содержащие часть структурированного значения свойства.</p></li><li><p>двоичное значение</p><p>элемент XML <code>BINVAL</code> с текстовым телом, содержащим значение свойства в кодировке base64.</p></li><li><p>текстовое значение</p><p>элемент XML <code>VALUE</code> с текстовым телом, содержащим значение свойства.</p></li></ul></li></ul></li></ul></li></ul><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>begin:VCARD</span></span>
<span class="line"><span>source:ldap://cn=bjorn Jensen, o=university of Michigan, c=US</span></span>
<span class="line"><span>name:Bjorn Jensen</span></span>
<span class="line"><span>n:Jensen;bjorn;A;Mr;II</span></span>
<span class="line"><span>email;type=INTERNET:bjorn@umich.edu</span></span>
<span class="line"><span>org:U of Michigan;Computer Science Dept.</span></span>
<span class="line"><span>tel;type=WORK,MSG:+1 313 747-4454</span></span>
<span class="line"><span>key;type=x509;encoding=B:dGhpcyBjb3VsZCBiZSAKbXkgY2VydGlmaWNhdGUK</span></span>
<span class="line"><span>end:VCARD</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOURCE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;ldap://cn=bjorn Jensen, o=university of Michigan, c=US&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SOURCE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Bjorn Jensen&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">N</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FAMILY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Jensen&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">FAMILY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">GIVEN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;bjorn&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">GIVEN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIDDLE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;A&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MIDDLE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">PREFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Mr.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">PREFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SUFFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;II&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">SUFFIX</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">N</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMAIL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;bjorn@umich.edu&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">EMAIL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORGNAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;U of Michigan&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORGNAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORGUNIT</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Computer Science Dept.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORGUNIT</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">ORG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">TEL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">WORK</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MSG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+1 313 747-4454&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">TEL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">KEY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">X509</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BINVAL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;dGhpcyBjb3VsZCBiZSAKbXkgY2VydGlmaWNhdGUK&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BINVAL</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">KEY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="XMLvCardGroup" tabindex="-1"><code>vCardGroup</code> <a class="header-anchor" href="#XMLvCardGroup" aria-label="Permalink to &quot;\`vCardGroup\` {#XMLvCardGroup}&quot;">​</a></h3><p>Этот элемент XML представляет объект vCardGroup.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>modified</code></p><p>Этот необязательный атрибут содержит значение свойства <code>REV</code> (время GMT в формате iCalendar).</p></li><li><p>Тело:</p><p>Cвойства vCardGroup как XML элементы с такими же именами, преобразованные к верхнему регистру ASCII: <code>NAME</code>, <code>NOTE</code>, <code>UID</code>. Каждый элемент включает в себя элемент XML <code>VALUE</code> с текстовым телом, содержащим значение свойства.</p><p>Ноль, один или несколько элементов XML <code>MEMBER</code>, по одному на каждого члена группы. Текстовым телом XML элемента является адрес члена группы, а необязательный атрибут <code>CN</code> содержит &quot;настоящее имя&quot; элемента.</p><p>Пример:</p></li></ul></li></ul><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>BEGIN:VGROUP</span></span>
<span class="line"><span>PRODID:CommuniGate Pro 6.1</span></span>
<span class="line"><span>VERSION:1.0</span></span>
<span class="line"><span>NAME:Basket Buddies</span></span>
<span class="line"><span>NOTE:My basketball team.</span></span>
<span class="line"><span>UID:594895837.1@team.dom</span></span>
<span class="line"><span>REV:20071214T174114Z</span></span>
<span class="line"><span>MEMBER;CN=&quot;Jack Nimble&quot;:jack@nimble.dom</span></span>
<span class="line"><span>MEMBER;CN=&quot;Tim Slow&quot;:tim@slow.dom</span></span>
<span class="line"><span>END:VGROUP</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCardGroup</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> modified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20071214T174114Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Basket Buddies&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NAME</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NOTE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;My basketball team.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">NOTE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;594895837.1@team.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">VALUE</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">UID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MEMBER</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> CN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Jack Nimble&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;jack@nimble.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MEMBER</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MEMBER</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> CN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Tim Slow&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;tim@slow.dom&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">MEMBER</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vCardGroup</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="XMLiCalendar" tabindex="-1"><code>iCalendar</code> <a class="header-anchor" href="#XMLiCalendar" aria-label="Permalink to &quot;\`iCalendar\` {#XMLiCalendar}&quot;">​</a></h3><p>Этот элемент XML представляет объект iCalendar.</p><ul><li><p>Тело:</p><p>элемент <a href="#XMLvCalendar"><code>vCalendar</code></a>.</p></li></ul><h4 id="XMLvCalendar" tabindex="-1"><code>vCalendar</code> <a class="header-anchor" href="#XMLvCalendar" aria-label="Permalink to &quot;\`vCalendar\` {#XMLvCalendar}&quot;">​</a></h4><p>Этот элемент XML представляет объект vCalendar.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>version</code></p><p>версия vCalendar (<code>2.0</code> для iCalendar)</p></li><li><p><code>method</code></p><p>необязательный атрибут с методом vCalendar</p></li><li><p><code>prodid</code></p><p>необязательная строка, идентифицирующая продукт, использованный для создания этого объекта vCalendar.</p></li></ul></li><li><p>Тело:</p><p>набор элементов <a href="#XMLvtimezone"><code>vtimezone</code></a>, <a href="#XMLvevent"><code>vevent</code></a> и/или <a href="#XMLvtodo"><code>vtodo</code></a>), <a href="#XMLvfreebusy"><code>vfreebusy</code></a>.</p></li></ul><h4 id="XMLvtimezone" tabindex="-1"><code>vtimezone</code> <a class="header-anchor" href="#XMLvtimezone" aria-label="Permalink to &quot;\`vtimezone\` {#XMLvtimezone}&quot;">​</a></h4><p>Этот элемент XML представляет объект VTIMEZONE.</p><ul><li><p>Тело:</p><p>набор элементов XML:</p><ul><li><code>tzid</code>: тело элемента содержит название часового пояса.</li><li><code>standard</code> и, необязательно, <code>daylight</code>: эти тела элементов содержат следующие XML элементы: <ul><li><code>tzoffsetto</code>: тело элемента содержит значение сдвига времени.</li><li><code>tzoffsetfrom</code> (необязательно) тело элемента содержит значение сдвига времени.</li><li><code>rrule</code> (необязательно): тело элемента содержит строку с описателем повторяемости.</li></ul></li></ul></li></ul><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>BEGIN:VTIMEZONE</span></span>
<span class="line"><span>TZID:Europe/Central</span></span>
<span class="line"><span>BEGIN:STANDARD</span></span>
<span class="line"><span>DTSTART:19710101T030000</span></span>
<span class="line"><span>TZOFFSETFROM:+0200</span></span>
<span class="line"><span>TZOFFSETTO:+0100</span></span>
<span class="line"><span>RRULE:FREQ=YEARLY;BYMONTH=10;BYDAY=-1SU</span></span>
<span class="line"><span>END:STANDARD</span></span>
<span class="line"><span>BEGIN:DAYLIGHT</span></span>
<span class="line"><span>DTSTART:19710101T020000</span></span>
<span class="line"><span>TZOFFSETFROM:+0100</span></span>
<span class="line"><span>TZOFFSETTO:+0200</span></span>
<span class="line"><span>RRULE:FREQ=YEARLY;BYMONTH=3;BYDAY=-1SU</span></span>
<span class="line"><span>END:DAYLIGHT</span></span>
<span class="line"><span>END:VTIMEZONE</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vtimezone</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Europe/Central&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">standard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;19710101T030000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzoffsetto</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+0100&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzoffsetto</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;FREQ=YEARLY;BYMONTH=10;BYDAY=-1SU&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">standard</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">daylight</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;19710101T020000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzoffsetto</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;+0200&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tzoffsetto</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;FREQ=YEARLY;BYMONTH=3;BYDAY=-1SU&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">daylight</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vtimezone</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h4 id="xmlvevent" tabindex="-1"><code>vevent</code>, <code>vtodo</code> <a class="header-anchor" href="#xmlvevent" aria-label="Permalink to &quot;\`vevent\`, \`vtodo\` {#xmlvevent}&quot;">​</a></h4><p>Эти элементы XML представляют объекты VEVENT и VTODO.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>localTime</code></p><p>этот атрибут присутствует только для неповторяющихся календарных объектов. В нём содержится дата и время начала календарного объекта. Используется местное Время в Часовом Поясе, выбранном для текущего пользователя.</p></li><li><p><code>localStart</code></p><p>этот атрибут присутствует только для повторяющихся календарных объектов. В нём содержится время начала календарного объекта (секунды, начиная с полуночи). Используется местное Время в Часовом Поясе, выбранном для текущего пользователя.</p></li></ul></li><li><p>Тело:</p><p>Набор элементов XML, каждый представляющий одно свойства.</p><p>Параметры свойства представляются как атрибуты элемента.<br> Значение свойства представляется в теле Элемента.<br> Если значение начинается с префикса <code>MAILTO:</code>, то этот префикс удаляется.<br> Если календарный объект имеет &quot;исключения&quot;, добавляется элемент XML <code>exceptions</code>. Его дочерние элементы XML представляют исключения для объектов VEVENT и VTODO.</p></li></ul><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>BEGIN:VEVENT</span></span>
<span class="line"><span>ORGANIZER;CN=&quot;Jim Smith&quot;:MAILTO:jim_smith@example.com</span></span>
<span class="line"><span>RRULE:FREQ=WEEKLY;INTERVAL=2;BYDAY=MO,TU,WE,TH;UNTIL=20060305T000000Z</span></span>
<span class="line"><span>DTSTAMP:20051204T140844Z</span></span>
<span class="line"><span>UID:566852630.4@mail.example.com</span></span>
<span class="line"><span>SEQUENCE:1</span></span>
<span class="line"><span>SUMMARY:test - recurrent</span></span>
<span class="line"><span>DTSTART;TZID=NorthAmerica/Pacific:20051204T100000</span></span>
<span class="line"><span>DTEND;TZID=NorthAmerica/Pacific:20051204T110000</span></span>
<span class="line"><span>X-MICROSOFT-CDO-BUSYSTATUS:BUSY</span></span>
<span class="line"><span>LAST-MODIFIED:20051204T140844Z</span></span>
<span class="line"><span>CREATED:20051204T140844Z</span></span>
<span class="line"><span>PRIORITY:5</span></span>
<span class="line"><span>END:VEVENT</span></span>
<span class="line"><span>BEGIN:VEVENT</span></span>
<span class="line"><span>UID:566852630.4@mail.example.com</span></span>
<span class="line"><span>RECURRENCE-ID:20051206T180000Z</span></span>
<span class="line"><span>SUMMARY:test - recurrent (later this time)</span></span>
<span class="line"><span>DTSTART;TZID=NorthAmerica/Pacific:20051206T120000</span></span>
<span class="line"><span>DTEND;TZID=NorthAmerica/Pacific:20051206T130000</span></span>
<span class="line"><span>END:VEVENT</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vevent</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">organizer</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> CN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Jim Smith&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;jim_smith@example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">organizer</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;FREQ=WEEKLY;INTERVAL=2;BYDAY=MO,TU,WE,TH;UNTIL=20060305T000000Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">rrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstamp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051204T140844Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstamp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;566852630.4@mail.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sequence</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sequence</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;test - recurrent&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051204T100000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051204T110000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">busystatus</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;BUSY&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">busystatus</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">last-modified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051204T140844Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">last-modified</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">created</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051204T140844Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">created</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">priority</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;5&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">priority</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">exceptions</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;566852630.4@mail.example.com&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">uid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">recurrenceId</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051206T180000Z&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">recurrenceId</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;test - recurrent (later this time)&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">summary</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051206T120000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> tzid</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;NorthAmerica/Pacific&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;20051206T130000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">exceptions</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vevent</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h4 id="XMLvfreebusy" tabindex="-1"><code>vfreebusy</code> <a class="header-anchor" href="#XMLvfreebusy" aria-label="Permalink to &quot;\`vfreebusy\` {#XMLvfreebusy}&quot;">​</a></h4><p>Эти элементы XML представляют объекты VFREEBUSY.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>dtstart</code></p><p>начало временного периода, покрываемого объектом VFREEBUSY.</p></li><li><p><code>dtend</code></p><p>конец временного периода, покрываемого объектом VFREEBUSY.</p></li><li><p><code>dtstamp</code></p><p>время создания этого объекта VFREEBUSY.</p></li></ul></li><li><p>Тело:</p><p>набор элементов XML <code>freebusy</code>, каждый из которых представляет один временной интервал. Временные интервалы не пересекаются.</p><p>Атрибуты:</p><ul><li><p><code>dtstart</code></p><p>начало временного интервала.</p></li><li><p><code>dtend</code></p><p>конец временного интервала.</p></li><li><p><code>fbtype</code></p><p>необязательный атрибут с типом занятости. Если он не указан, то интервал имеет статус <code>BUSY</code>.</p></li></ul></li></ul><p>Пример:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>BEGIN:VFREEBUSY</span></span>
<span class="line"><span>DTSTART:20080329T075517Z</span></span>
<span class="line"><span>DTEND:20080604T075517Z</span></span>
<span class="line"><span>DTSTAMP:20080405T075517Z</span></span>
<span class="line"><span>FREEBUSY:20080329T075517Z/20080329T120000Z</span></span>
<span class="line"><span>FREEBUSY:20080330T070000Z/20080330T120000Z</span></span>
<span class="line"><span>FREEBUSY:20080331T070000Z/20080331T120000Z</span></span>
<span class="line"><span>END:VFREEBUSY</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vfreebusy</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080604T075517Z&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtstamp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080405T075517Z&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080329T075517Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">freebusy</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080329T120000Z&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080329T075517Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">freebusy</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080330T120000Z&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080330T070000Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">freebusy</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtend</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080331T120000Z&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> dtstart</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20080331T070000Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">vfreebusy</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="XMLRRULE" tabindex="-1"><code>xrule</code> <a class="header-anchor" href="#XMLRRULE" aria-label="Permalink to &quot;\`xrule\` {#XMLRRULE}&quot;">​</a></h3><p>Этот элемент XML представляет повторяющийся календарный объект.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>freq</code></p><p>тип повторяемости.</p></li><li><p><code>interval</code></p><p>параметр с интервалом. Если отсутствует, интервал подразумевается равным 1.</p></li><li><p><code>wkst</code></p><p>название дня, с которого начинается неделя. Если отсутствует, то подразумевается <code>MO</code> (Понедельник).</p></li><li><p><code>count</code></p><p>необязательный атрибут с целочисленным значением, в котором указывается параметр COUNT.</p></li><li><p><code>until</code></p><p>необязательный атрибут, указывающий параметр UNTIL в формате даты-времени iCalendar.</p></li></ul></li><li><p>Тело:</p><p>набор элементов XML:</p><ul><li><p><code>BYMONTH</code>, <code>BYWEEKNO</code>, <code>BYYEARDAY</code>, <code>BYMONTHDAY</code>, <code>BYSETPOS</code></p><p>тело каждого элемента содержит число - номер месяца, недели и т.п. За исключением элемента <code>BYMONTH</code>, число может быть отрицательным.</p></li><li><p><code>BYDAY</code></p><p>каждое тело элемента содержит одно наименование дня (<code>MO</code>, <code>TU</code>, .. <code>SU</code>); каждый элемент может содержать необязательный числовой атрибут <code>week</code> - номер недели (он может быть отрицательным).</p></li></ul></li></ul><p>Пример:</p><ul><li><code>RRULE:FREQ=WEEKLY;INTERVAL=2;BYDAY=MO,TU,WE,TH;UNTIL=20060305T000000Z</code></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">xrule</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> freq</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;WEEKLY&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> interval</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> until</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;20060305T000000Z&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;MO&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;TU&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;WE&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;TH&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">xrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>Пример:</p><ul><li><code>RRULE:FREQ=YEARLY;BYMONTH=10;BYDAY=-1SU</code></li></ul><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">xrule</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> freq</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;YEARLY&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYMONTH</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;10&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYMONTH</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> week</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;SU&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">BYDAY</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">xrule</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h3 id="XMLCertificate" tabindex="-1"><code>x509</code> <a class="header-anchor" href="#XMLCertificate" aria-label="Permalink to &quot;\`x509\` {#XMLCertificate}&quot;">​</a></h3><p>Этот элемент XML представляет сертификат X.509.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>version</code></p><p>версия формата сертификата.</p></li><li><p><code>subject</code></p><p>необязательный адрес E-Mail, связанный с сертификатом.</p></li></ul></li><li><p>Тело:</p><p>набор элементов XML:</p><ul><li><p><code>subject</code>, <code>issuer</code></p><p>эти элементы XML содержат дочерние элементы XML с частями имени Сертификата и Издателя. Поддерживаются части <code>c</code>, <code>country</code>, <code>l</code>, <code>city</code>, и т.д. Значением дочернего элемента является тело элемента.</p></li><li><p><code>validFrom</code>, <code>validTill</code></p><p>текстовые тела каждого элемента содержат в формате iCalendar период действия сертификата</p></li><li><p><code>base64</code></p><p>необязательный элемент - его тело содержит данные сертификата в формате base64.</p></li></ul></li></ul><h3 id="XMLSDP" tabindex="-1"><code>sdp</code> <a class="header-anchor" href="#XMLSDP" aria-label="Permalink to &quot;\`sdp\` {#XMLSDP}&quot;">​</a></h3><p>Этот элемент XML представляет объект SDP.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>ip</code></p><p>IP адрес медиа по умолчанию (необязательно).</p></li><li><p><code>origUser</code></p><p>поле с именем пользователя источника (необязательно).</p></li><li><p><code>sessionID</code></p><p>поле идентификатора сессии источника.</p></li><li><p><code>sessionVersion</code></p><p>поле версии сессии источника.</p></li><li><p><code>origIP</code></p><p>IP адрес, указанный в полях nettype, addrtype и unicast-address источника (необязательно).</p></li><li><p><code>subject</code></p><p>название сессии (необязательно). Если отсутствует, то используется название <code>-</code>.</p></li></ul></li><li><p>Тело:</p><p>набор элементов <a href="#XMLSDPInfo"><em>info</em></a>, <a href="#XMLSDPAttr"><code>attribute</code></a> и <a href="#XMLSDPMedia"><code>media</code></a>.</p></li></ul><h4 id="XMLSDPMedia" tabindex="-1"><code>media</code> <a class="header-anchor" href="#XMLSDPMedia" aria-label="Permalink to &quot;\`media\` {#XMLSDPMedia}&quot;">​</a></h4><p>Этот элемент XML представляет объект SDP Медиа.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>media</code></p><p>типа медиа (такой, как <code>audio</code>, <code>video</code>). Если этот атрибут отсутствует, то используется значение <code>audio</code>.</p></li><li><p><code>ip</code></p><p>адрес и порт медиа.</p></li><li><p><code>protocol</code></p><p>медиа протокол (такой, как <code>udp</code>, <code>tcp</code>, <code>RTP/AVP</code>). Если этот атрибут отсутствует, то используется значение <code>RTP/AVP</code>.</p></li><li><p><code>direction</code></p><p>направление медиа (<code>sendrecv</code>, <code>sendonly</code>, <code>recvonly</code>, <code>inactive</code>).</p></li><li><p><code>rtcp</code></p><p>адрес и порт rtcp (необязательно)</p></li></ul></li><li><p>Тело:</p><p>набор элементов <a href="#XMLSDPCodec"><code>codec</code></a>, <a href="#XMLSDPInfo"><em>info</em></a>, and <a href="#XMLSDPAttr"><code>attribute</code></a>.</p></li></ul><h4 id="XMLSDPCodec" tabindex="-1"><code>codec</code> <a class="header-anchor" href="#XMLSDPCodec" aria-label="Permalink to &quot;\`codec\` {#XMLSDPCodec}&quot;">​</a></h4><p>Этот элемент XML представляет кодек SDP Медиа.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>id</code></p><p>идентификатор кодека - номер типа данных RTP (число из диапазона 0..127).</p></li><li><p><code>name</code></p><p>имя кодека (такое, как <code>PCMU/8000</code>).</p></li><li><p><code>format</code></p><p>параметр формата кодека (необязательно).</p></li></ul></li></ul><h4 id="XMLSDPAttr" tabindex="-1"><code>attr</code> <a class="header-anchor" href="#XMLSDPAttr" aria-label="Permalink to &quot;\`attr\` {#XMLSDPAttr}&quot;">​</a></h4><p>Этот элемент XML представляет атрибут объекта SDP или SDP Медиа.</p><ul><li><p>Атрибуты:</p><ul><li><p><code>name</code></p><p>имя атрибута.</p></li></ul></li><li><p>Тело:</p><p>необязательная строка со значением атрибута.</p></li></ul><h4 id="XMLSDPInfo" tabindex="-1"><em>info</em> <a class="header-anchor" href="#XMLSDPInfo" aria-label="Permalink to &quot;_info_ {#XMLSDPInfo}&quot;">​</a></h4><p>Этот элемент XML представляет информационное поле объекта SDP или SDP Медиа. Поддерживаемые поля:<br> для SDP: <code>info</code>, <code>uri</code>, <code>email</code>, <code>phone</code>, <code>phone</code>, <code>bandwidth</code>, <code>time</code>, <code>repeat</code>, <code>zone</code> и <code>key</code>;<br> для SDP Медиа: <code>title</code>, <code>bandwidth</code> и <code>key</code>;</p><ul><li><p>Атрибуты:</p><p><em>отсутствуют</em>.</p></li><li><p>Тело:</p></li></ul><p>необязательная строка со значением поля.</p><p>Пример: образец документа SDP и его представления XML:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>v=0</span></span>
<span class="line"><span>o=- 6385718 9999 IN IP4 192.168.1.65</span></span>
<span class="line"><span>s=-</span></span>
<span class="line"><span>e=support@communigatepro.ru</span></span>
<span class="line"><span>c=IN IP4 192.168.1.65</span></span>
<span class="line"><span>t=0 0</span></span>
<span class="line"><span>a=sdpattr1:sdpvalue</span></span>
<span class="line"><span>a=sdpattr2</span></span>
<span class="line"><span>m=audio 16398 RTP/AVP 0 4 8 101</span></span>
<span class="line"><span>t=title value</span></span>
<span class="line"><span>a=rtpmap:0 PCMU/8000</span></span>
<span class="line"><span>a=rtpmap:4 G723/8000</span></span>
<span class="line"><span>a=rtpmap:8 PCMA/8000</span></span>
<span class="line"><span>a=rtpmap:101 telephone-event/8000</span></span>
<span class="line"><span>a=fmtp:101 0-15</span></span>
<span class="line"><span>a=sendrecv</span></span>
<span class="line"><span>a=mediaattr1:mediavalue</span></span>
<span class="line"><span>a=mediaattr2</span></span></code></pre></div><div class="language-xml vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">xml</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sdp</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> ip</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;[192.168.1.65]&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> origUser</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sessionID</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;6385718&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> sessionVersion</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;9999&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> originIP</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;[192.168.1.65]&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">email</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;support@communigatepro.ru&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">email</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sdpattr1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;sdpvalue&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sdpattr2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">media</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> media</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;audio&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> ip</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;[192.168.1.65]:16398&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> protocol</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;RTP/AVP&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> direction</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sendrecv&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">codec</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;PCMU/8000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">codec</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;4&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;G723/8000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">codec</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;8&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;PCMA/8000&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">codec</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> id</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;101&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;telephone-event/8000&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> format</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0-15&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">title</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;title value&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">title</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mediaattr1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;mediavalue&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">attr</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> name</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mediaattr2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> /&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">media</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">sdp</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><h2 id="ASN1" tabindex="-1">ASN.1 <a class="header-anchor" href="#ASN1" aria-label="Permalink to &quot;ASN.1 {#ASN1}&quot;">​</a></h2><p>CommuniGate Pro может преобразовывать структуры в формате ASN.1 в объекты.</p><p>Каждый элемент данных ASN.1 преобразуется в <a href="#Array">массив</a>.</p><p>Для элементов данных ASN.1 класса Universal элемент массива с индексом 0 содержит строку с именем типа: <code>boolean</code>, <code>integer</code>, <code>bits</code>, <code>octets</code>, <code>null</code>, <code>oid</code>, <code>objdescr</code>, <code>external</code>, <code>real</code>, <code>enum</code>, <code>embed</code>, <code>string</code>, <code>reloid</code>, <code>rsrv1</code>, <code>rsrv2</code>, <code>seq</code>, <code>set</code>, <code>stringNum</code>, <code>stringPrint</code>, <code>stringT61</code>, <code>stringIA5</code>, <code>string22</code>, <code>timeUTC</code>, <code>time</code>, <code>stringGraphic</code>, <code>stringISO64</code>, <code>stringGeneral</code>, <code>stringUniversal</code>, <code>string29</code>, <code>stringBMP</code>, <code>string31</code>. Иначе элемент массива с индексом 0 содержит строку с именем класса (application, choice,private), элемент массива с индексом 1 содержит число - код элемента данных.</p><p>Для элементов данных типа &quot;constructed&quot; оставшиеся элементы массива (возможно - 0 элементов) содержат конвертированные элементы ASN.1.<br> Для &quot;примитивных&quot; элементов данных оставшиеся элементы массива содержат представление данных, которое зависит от типа элемента:</p><ul><li><p><code>boolean</code></p><p><a href="#Null">Нулевой Объект</a> для &quot;false&quot;, любой другой объект для &quot;true&quot;</p></li><li><p><code>integer</code>, <code>enum</code> (не длиннее 8 байт)</p><p><a href="#Number">Число</a></p></li><li><p><code>null</code></p><p><a href="#Null">Нулевой Объект</a></p></li><li><p><code>string</code>, <code>_subtype_string</code> (данные не содержат бинарный нуль)</p><p><a href="#String">Строка</a></p></li><li><p><code>time</code>, <code>timeUTC</code></p><p><a href="#Date">Отметка Времени</a></p></li><li><p><code>oid</code>, <code>reloid</code></p><p>представление в виде <a href="#String">Строки</a> для идентификатора объекта (ObjectID) (<em>nn</em>.<em>mm</em>.<em>ll</em>.<em>kk</em>.<em>rr</em>)</p></li><li><p><em>другие типы данных</em></p><p><a href="#DataBlock">Блок Данных</a></p></li></ul>`,195)]))}const c=i(n,[["render",l]]);export{r as __pageData,c as default};
