import{_ as i,c as a,o as n,ag as e}from"./chunks/framework.jCcxW76o.js";const E=JSON.parse('{"title":"Расширения","description":"","frontmatter":{"legacyLink":"russian/Plugins.html","outline":[2,3]},"headers":[],"relativePath":"russian/development/Plugins.md","filePath":"russian/development/Plugins.md"}'),p={name:"russian/development/Plugins.md"};function l(t,s,h,k,o,d){return n(),a("div",null,s[0]||(s[0]=[e(`<h1 id="расширения" tabindex="-1">Расширения <a class="header-anchor" href="#расширения" aria-label="Permalink to &quot;Расширения&quot;">​</a></h1><p>Расширения позволяют простым способом, установив всего один файл, расширять функционал сервера CommuniGate и его пользовательского интерфейса, не прибегая к модификации встроенного функционала сервера.</p><p>Установить расширение, скачанное с сайта <a href="https://communigatepro.ru/" target="_blank" rel="noreferrer">communigatepro.ru</a> или разработанное самостоятельно, можно в разделе Пользователи → Расширения интерфейса администрирования Dash.</p><h2 id="FileFormat" tabindex="-1">Формат файла расширения <a class="header-anchor" href="#FileFormat" aria-label="Permalink to &quot;Формат файла расширения {#FileFormat}&quot;">​</a></h2><p>Файл расширения представляет собой ZIP-архив с расширением <code>.cgplugin</code>.</p><p>В корне архива обязательно должен находиться файл описания расширения <code>cgplugin.json</code>. JSON-Schema для него: <a href="../../development/cgplugin.schema.json">cgplugin.schema.json</a>.</p><p>Основные параметры файла конфигурации расширения:</p><ul><li><code>id</code> <em>(обязательно)</em> - Название расширения. Латиница, цифры и подчёркивание. Должно быть уникальным для конкретного расширения. Рекомендуется использовать обратную запись названия домена перед именем расширения, например, <code>ru_communigatepro_ExamplePlugin</code></li><li><code>author</code> <em>(обязательно)</em> - Имя автора расширения. Например, <code>Ivan Ivanov</code> или <code>AO SBK</code></li><li><code>version</code> <em>(обязательно)</em> - Версия расширения по <a href="https://semver.org/" target="_blank" rel="noreferrer">SemVer 2.0</a>. Например, <code>1.0.0</code></li><li><code>title</code> <em>(обязательно)</em> - Имя поля из <a href="#Locales">словарей локализации</a>, которое будет использоваться при отображении расширения в интерфейсе администрирования. Например, <code>PluginTitle</code>.</li><li><code>description</code> <em>(необязательно)</em> - Имя поля из <a href="#Locales">словарей локализации</a>, которое будет использоваться при отображении описания расширения в интерфейсе администрирования. Например, <code>PluginDescription</code>.</li><li><code>url</code> - Адрес домашней страницы расширения. Например, <code>https://communigatepro.ru/</code></li><li><code>icon</code> - Опциональное имя файла иконки из архива для отображения расширения при просмотре его через интерфейс администрирования. Иконка должна быть в формате svg и иметь пропорции 1:1 (квадратные).</li><li><code>min_product_version</code> - Опциональный параметр, который указывает минимальную версию сервера, необходимую для корректной работы плагина. Если параметр не указан, предполагается, что плагин совместим со всеми версиями сервера.</li></ul><h2 id="Locales" tabindex="-1">Локализация <a class="header-anchor" href="#Locales" aria-label="Permalink to &quot;Локализация {#Locales}&quot;">​</a></h2><p>При загрузке расширения из него автоматически загружаются доступные <a href="./WebApp.html#Strings">файлы локализации</a> с расширением <code>.data</code> в формате <a href="./Data.html#Dictionary">Словарей CommuniGate Pro</a>.</p><p>Данные из этих словарей будут доступны другому коду, в том числе, скриптам на CG/PL, содержащимся в расширении, с префиксом вида <code>&lt;id расширения&gt;.</code>.</p><h2 id="Extends" tabindex="-1">Точки расширения <a class="header-anchor" href="#Extends" aria-label="Permalink to &quot;Точки расширения {#Extends}&quot;">​</a></h2><p>Список точек расширения заполняется в секции <code>extends</code> файла описания. Доступны несколько типов расширений, описанные ниже.</p><h3 id="config" tabindex="-1">Параметры конфигурации <a class="header-anchor" href="#config" aria-label="Permalink to &quot;Параметры конфигурации {#config}&quot;">​</a></h3><p>Описываются в секции <code>config</code> в виде объекта с описаниями параметров конфигурации. Каждый ключ - идентификатор одного параметра конфигурации, под которым он будет храниться и передаваться запускаемым из расширения скриптам CG/PL.</p><ul><li><code>type</code> <em>(обязательно)</em> - Тип параметра, используется для выбора формата хранения параметра и типа отображаемого в интерфейсе администрирования виджета. На данный момент поддерживаются только параметры типов <code>string</code> и <code>boolean</code>.</li><li><code>title</code> <em>(обязательно)</em> - Строка из файлов <a href="#Locales">локализации</a>, которая будет использоваться при отображении названия параметра в интерфейсе администрирования.</li><li><code>required</code> - Обязателен ли параметр конфигурации для заполнения (если поле отсутствует, параметр необязательный).</li><li><code>editPresentation</code> - Позволяет указать способ отображения элемента управления для параметра. Для типа <code>string</code> поддерживаются <code>password</code> и <code>multilineText</code>. Если для <code>string</code> ничего не указано, будет показано обычное однострочное поле ввода.</li><li><code>enum</code> - Позволяет задать несколько допустимых вариантов для параметра конфигурации.</li><li><code>enumTitle</code> <em>(обязательно, если есть enum)</em> - Строка из файлов <a href="#Locales">локализации</a>, которая указывает на словарь, который будет использоваться при отображении вариантов параметра конфигурации в интерфейсе администрирования.</li></ul><p>Пример:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;APIKey&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;editPresentation&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;password&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;APIKeyTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;ServerType&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;enum&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;proxy&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;DNS&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;mail&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">],</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;enumTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;ServerTypeEnumTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;ServerTypeTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><h3 id="checkConfig" tabindex="-1">Проверка параметров конфигурации <a class="header-anchor" href="#checkConfig" aria-label="Permalink to &quot;Проверка параметров конфигурации {#checkConfig}&quot;">​</a></h3><p>В расширение можно добавить файл сценария на языке CG/PL, выполняющий проверку корректности заполнения параметров конфигурации. Данный файл должен находиться в архиве с расширением.</p><p>Такой файл сценария может как выполнять базовые проверки по регулярным выражениям или заполнению полей, так и проверять корректность введённых параметров путём обращения к внешнему серверу. В файле сценария должен содержаться метод <code>checkConfig</code>, выполняющий проверку параметров конфигурации, доступных ему через свойство <code>pluginSettings</code> окружения запуска сценария.</p><p>Пример параметра:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;APIKey&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;APIKeyTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;checkConfig&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;checkconfig.scgp&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Пример файла сценария:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry checkConfig {</span></span>
<span class="line"><span>  var settings = Vars().pluginSettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(settings.APIKey) != 10) {</span></span>
<span class="line"><span>    SetResult(&quot;invalid API key&quot;)</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="vcs" tabindex="-1">Видеоконференции <a class="header-anchor" href="#vcs" aria-label="Permalink to &quot;Видеоконференции {#vcs}&quot;">​</a></h3><p>Описываются в секции <code>vcs</code> в виде объекта с описаниями предоставляемых расширением скриптов для интеграции систем видеоконференцсвязи (далее - ВКС). Ключ - идентификатор, который будет использоваться для определения конкретной системы ВКС внутри CommuniGate Pro. Каждое описание - объект со следующими параметрами:</p><ul><li><code>title</code> <em>(обязательно)</em> - Строка из файлов <a href="#Locales">локализации</a>, которая будет использоваться при отображении параметра в интерфейсе пользователя.</li><li><code>script</code> <em>(обязательно)</em> - Имя (с расширением) находящегося в архиве файла сценария на языке CG/PL, реализующего интеграцию с ВКС.</li><li><code>icon</code> - Опционально: имя svg-файла с пиктограммой из архива. Пиктограмма будет отображаться пользователю в элементах интерфейса, связанных с конкретной системой видеоконференций. Она должна иметь пропорции 1:1 (квадратные).</li></ul><p>Пример:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;vcs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;bbb&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;BBBTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;bbb.scgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;bbb.svg&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Каждый модуль поддержки видеоконференции должен быть отдельным сценарием CG/PL в <a href="./CGPL.html#SyncScripts">формате scgp</a>.</p><p>Каждая функция оформляется отдельным методом внутри файла сценария (отдельной «точкой входа»). Сценарий всегда запускается в контексте пользователя, создающего конференцию, будь то через событие в календаре или через кнопку в чате.</p><p>Точки входа, которые должны быть реализованы в коде файла сценария, описаны ниже.</p><h4 id="vcsCreateConf" tabindex="-1">Точка входа <code>createConf</code> <a class="header-anchor" href="#vcsCreateConf" aria-label="Permalink to &quot;Точка входа \`createConf\` {#vcsCreateConf}&quot;">​</a></h4><ul><li><p><code>createConf</code></p><p>Создаёт видеоконференцию.</p><p>Параметры доступны в словаре <code>Vars().startParameter</code>:</p><ul><li><p><code>title</code> <em>(опционально)</em></p><p>Тема конференции.</p></li><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции.</p></li><li><p><code>isAllDay</code> <em>(опционально)</em></p><p>Флаг, определяющий тип конференции, если конференция длится целый день с 0 до 24 часов - 1, если конференция имеет любое другое время начало и конца - 0.</p></li><li><p><code>rRule</code> <em>(опционально)</em></p><p>Правило повторения события и ВКС, согласно <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.8.5.3" target="_blank" rel="noreferrer">RFC5545, section 3.8.5.3</a>.</p><p>Примеры:</p><ul><li><p><code>FREQ=DAILY;UNTIL=20241215T000000Z</code></p><p>ежедневное повторение, до 15 декабря 2024 г.</p></li><li><p><code>FREQ=WEEKLY;BYDAY=SU,MO,TU,WE,TH,FR</code></p><p>еженедельное повторение каждый день недели.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYMONTHDAY=2;UNTIL=20250328T000000Z</code></p><p>ежемесячно каждый второй месяц второй день до 28 марта 2025 г.</p></li><li><p><code>FREQ=MONTHLY;BYDAY=-1SU,-1MO,-1TU,-1WE,-1TH,-1FR,-1SA;UNTIL=20250319T000000Z</code></p><p>ежемесячно каждый последний понедельник, вторник, среду, четверг, пятницу, субботу, воскресенье до 19 марта 2025 г.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYDAY=1SU,1TU,1FR;UNTIL=20250321T000000Z</code></p><p>ежемесячно каждый второй месяц каждый первый вторник, пятницу, воскресенье до 21 марта 2025 г.</p></li><li><p><code>FREQ=YEARLY;BYMONTH=4;BYMONTHDAY=6;UNTIL=20261231T000000Z</code></p><p>ежегодно каждый четвертый месяц каждое шестое число до 31 декабря 2026 г.</p></li></ul></li><li><p><code>from</code> <em>(опционально)</em></p><p>Время начала конференции в UnixTime.</p></li><li><p><code>duration</code> <em>(опционально)</em></p><p>Продолжительность конференции в секундах.</p></li><li><p><code>offset</code> <em>(опционально)</em></p><p>Смещение временной зоны организатора относительно UTC (0) в секундах.</p></li><li><p><code>participants</code> <em>(опционально)</em></p><p>Массив объектов, описывающих участников конференции.</p><ul><li><p><code>name</code> <em>(опционально)</em></p><p>Имя участника</p></li><li><p><code>email</code></p><p>Адрес e-mail участника</p></li></ul></li></ul><p>Возвращаемое значение - словарь с полями:</p><ul><li><p><code>cid</code></p><p>ID созданной конференции в строковом формате или ID созданной конференции и дополнительные параметры, если есть, в Base64Url после создания ВКС. Строка должна быть URL friendly и не содержать пробелов, двоеточия.</p></li><li><p><code>link</code></p><p>Общая ссылка на подключение к конференции.</p></li><li><p><code>participantLinks</code> <em>(опционально)</em></p><p>Cловарь, содержащих в себе индивидуальные ссылки на подключение к конференции для всех зарегистрированных участников. Если данная интеграция не поддерживает создание индивидуальных ссылок, параметр можно не указывать, ключ в словаре - aдрес e-mail участника, значение - индивидуальная ссылка для подключения к конференции:</p></li><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции. Если поле будет возвращено, то оно перезапишет данное поле в календарном событии. Возвращённая пустая строка очистит поле в календарном событии.</p></li></ul><p>Ошибка:</p><ul><li><p><code>error</code></p><p>Текстовое описание ошибки при создании конференции. Если произошла ошибка, поле должно присутствовать.</p></li></ul></li></ul><h4 id="vcsUpdateConf" tabindex="-1">Точка входа <code>updateConf</code> <a class="header-anchor" href="#vcsUpdateConf" aria-label="Permalink to &quot;Точка входа \`updateConf\` {#vcsUpdateConf}&quot;">​</a></h4><ul><li><p><code>updateConf</code></p><p>Обновляет видеоконференцию.</p><p>Параметры доступны в словаре <code>Vars().startParameter</code>. Аналогичны параметрам <a href="#vcsCreateConf">точки входа <code>createConf</code></a> плюс <code>cid</code>.</p><ul><li><p><code>cid</code></p><p>Идентификатор конференции или идентификатор конференции и дополнительные параметры в Base64Url, необходимые для обновления ВКС.</p></li><li><p><code>title</code> <em>(опционально)</em></p><p>Тема конференции.</p></li><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции.</p></li><li><p><code>isAllDay</code> <em>(опционально)</em></p><p>Флаг, определяющий тип конференции, если конференция длится целый день с 0 до 24 часов - 1, если конференция имеет любое другое время начало и конца - 0.</p></li><li><p><code>rRule</code> <em>(опционально)</em></p><p>Правило повторения события и ВКС, согласно <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.8.5.3" target="_blank" rel="noreferrer">RFC5545, section 3.8.5.3</a>.</p><p>Примеры:</p><ul><li><p><code>FREQ=DAILY;UNTIL=20241215T000000Z</code></p><p>ежедневное повторение, до 15 декабря 2024 г.</p></li><li><p><code>FREQ=WEEKLY;BYDAY=SU,MO,TU,WE,TH,FR</code></p><p>еженедельное повторение каждый день недели.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYMONTHDAY=2;UNTIL=20250328T000000Z</code></p><p>ежемесячно каждый второй месяц второй день до 28 марта 2025 г.</p></li><li><p><code>FREQ=MONTHLY;BYDAY=-1SU,-1MO,-1TU,-1WE,-1TH,-1FR,-1SA;UNTIL=20250319T000000Z</code></p><p>ежемесячно каждый последний понедельник, вторник, среду, четверг, пятницу, субботу, воскресенье до 19 марта 2025 г.</p></li><li><p><code>FREQ=MONTHLY;INTERVAL=2;BYDAY=1SU,1TU,1FR;UNTIL=20250321T000000Z</code></p><p>ежемесячно каждый второй месяц каждый первый вторник, пятницу, воскресенье до 21 марта 2025 г.</p></li><li><p><code>FREQ=YEARLY;BYMONTH=4;BYMONTHDAY=6;UNTIL=20261231T000000Z</code></p><p>ежегодно каждый четвертый месяц каждое шестое число до 31 декабря 2026 г.</p></li></ul></li><li><p><code>from</code> <em>(опционально)</em></p><p>Время начала конференции в UnixTime.</p></li><li><p><code>duration</code> <em>(опционально)</em></p><p>Продолжительность конференции в секундах.</p></li><li><p><code>offset</code> <em>(опционально)</em></p><p>Смещение временной зоны организатора относительно UTC (0) в секундах.</p></li><li><p><code>participants</code> <em>(опционально)</em></p><p>Массив объектов, описывающих участников конференции.</p><ul><li><p><code>name</code> <em>(опционально)</em></p><p>Имя участника</p></li><li><p><code>email</code></p><p>Адрес e-mail участника</p></li></ul></li></ul><p>Возвращаемое значение - словарь с полями, полностью совпадает по формату с возвращаемым значением <a href="#vcsCreateConf">точки входа <code>createConf</code></a>.</p><ul><li><p><code>cid</code> <em>(опционально, возвращается, если при обновлении удалилась старая ВКС)</em></p><p>ID созданной конференции в строковом формате. Строка должна быть URL friendly и не содержать пробелов, двоеточия.</p></li><li><p><code>link</code> <em>(опционально, возвращается, если при обновлении удалилась старая ВКС)</em></p><p>Общая ссылка на подключение к конференции.</p></li><li><p><code>participantLinks</code> <em>(опционально)</em></p><p>Словарь, содержащий в себе индивидуальные ссылки на подключение к конференции для всех зарегистрированных участников. Если данная интеграция не поддерживает создание индивидуальных ссылок, параметр можно не указывать, ключ в словаре - aдрес e-mail участника, значение - индивидуальная ссылка для подключения к конференции.</p></li><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции. Если поле будет возвращено, то оно перезапишет данное поле в календарном событии. Возвращённая пустая строка очистит поле в календарном событии.</p></li></ul><p>Ошибка:</p><ul><li><p><code>error</code></p><p>Текстовое описание ошибки при обновлении конференции. Если произошла ошибка, поле должно присутствовать.</p></li></ul></li></ul><h4 id="vcsDeleteConf" tabindex="-1">Точка входа <code>deleteConf</code> <a class="header-anchor" href="#vcsDeleteConf" aria-label="Permalink to &quot;Точка входа \`deleteConf\` {#vcsDeleteConf}&quot;">​</a></h4><ul><li><p><code>deleteConf</code></p><p>Удаляет видеоконференцию.</p><p>Параметры доступны в словаре <code>Vars().startParameter</code>:</p><ul><li><p><code>cid</code></p><p>идентификатор конференции или идентификатор конференции и дополнительные параметры в Base64Url, необходимые для удаления ВКС (ID и дополнительные параметры, закодированные в Base64Url, разбирает сам плагин на своё усмотрение).</p></li><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции.</p></li></ul><p>Возвращаемое значение - словарь с полями:</p><ul><li><p><code>description</code> <em>(опционально)</em></p><p>Подробное описание темы конференции. Если поле будет возвращено, то оно перезапишет данное поле в календарном событии. Возвращённая пустая строка очистит поле в календарном событии.</p></li></ul><p>Ошибка:</p><ul><li><p><code>error</code></p><p>Текстовое описание ошибки при удалении конференции. Если произошла ошибка, поле должно присутствовать.</p></li></ul></li></ul><h3 id="freebusy" tabindex="-1">Занятость участников <a class="header-anchor" href="#freebusy" aria-label="Permalink to &quot;Занятость участников {#freebusy}&quot;">​</a></h3><p>Описывается в секции <code>freebusy</code> в виде объекта с описаниями предоставляемых расширением скриптов для получения информации о занятости (далее - Free/Busy). Ключ - идентификатор, который будет использоваться для определения типа сервера, откуда будет загружаться информация о занятости внутри CommuniGate Pro. Каждое описание - объект со следующими параметрами:</p><ul><li><p><code>title</code> <em>(обязательно)</em></p><p>Строка из файлов <a href="#Locales">локализации</a>, которая будет использоваться при отображении в интерфейсе пользователя типа подключаемого источника.</p></li><li><p><code>script</code> <em>(обязательно)</em></p><p>Имя (с расширением) находящегося в архиве файла сценария на языке CG/PL, реализующего получение информации о занятости.</p></li><li><p><code>config</code> <em>(опционально)</em></p><p>Параметры, передаваемые в скрипт, аналогичны <a href="#config">параметрам расширения</a>. Доступны в скрипте в словаре <em>Vars().freebusySettings</em>.</p></li><li><p><code>checkConfig</code> <em>(опционально)</em></p><p>Имя (с расширением) находящегося в архиве файла сценария на <a href="./CGPL.html#SyncScripts">языке CG/PL</a>, реализующего проверку параметров FreeBusy (из секции config выше).</p></li></ul><p>Пример:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {},</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;freebusy&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;CommunigatePro&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;CommunigateProTitle&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;freebusy.scgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;Host&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">            &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;HostTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">          }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;checkConfig&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;checkFreeBusyConfig.scgp&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Каждый модуль получения информации о доступности / занятости участников (Free/Busy) должен быть отдельным сценарием CG/PL в <a href="./CGPL.html#SyncScripts">формате scgp</a>.</p><p>Точки входа, которые должны быть реализованы в коде файла сценария, описаны ниже.</p><h4 id="freebusyGetFreeBusy" tabindex="-1">Точка входа <code>getFreeBusy</code> <a class="header-anchor" href="#freebusyGetFreeBusy" aria-label="Permalink to &quot;Точка входа \`getFreeBusy\` {#freebusyGetFreeBusy}&quot;">​</a></h4><ul><li><p><code>getFreeBusy</code></p><p>Получение информации Free/Busy.</p><p>Параметры доступны в словаре <code>Vars().startParameter</code>:</p><ul><li><p><code>email</code> <em>(обязательно)</em></p><p>e-mail пользователя для которого запрашивается информация.</p></li><li><p><code>timeStart</code> <em>(опционально)</em></p><p>Начало запрашиваемого периода информации о занятости в <a href="./CGPL.html#TimeStamps">формате временной метки</a>.</p></li><li><p><code>timeEnd</code> <em>(опционально)</em></p><p>Окончание запрашиваемого периода информации о занятости в <a href="./CGPL.html#TimeStamps">формате временной метки</a>.</p></li></ul><p>Возвращаемое значение - строка в формате iCalendar Object <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.4" target="_blank" rel="noreferrer">RFC 5545, section 3.4</a>, включающий в себя компонент <a href="https://datatracker.ietf.org/doc/html/rfc5545#section-3.6.4" target="_blank" rel="noreferrer">RFC 5545, section 3.6.4</a>. В случае ошибки должна возвращаться пустая строка.</p></li></ul><p>В скрипте доступны следующие данные, кроме описанного выше <code>Vars().startParameter</code>:</p><ul><li><p><code>Vars().pluginSettings</code> - словарь</p><p>Общие настройки расширения, описанные в <code>extends/config</code></p></li><li><p><code>Vars().freebusySettings</code> - словарь</p><p>Настройки домена получения Free/Busy, описанные в <code>extends/freebusy/freebusyid_/config</code></p><ul><li><p><code>Host</code></p><p>Host адрес почтового сервера для домена</p></li><li><p><code>...</code></p><p>Остальные параметры, указанные в секции <code>extends/freebusy/config</code> и настроеные администратором сервера/домена.</p></li></ul></li></ul><p>Пример файла сценария:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry getFreeBusy is</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // email передаётся в словаре startParameter</span></span>
<span class="line"><span>  var param = Vars().startParameter;</span></span>
<span class="line"><span>  var email = param.email;</span></span>
<span class="line"><span>  var timeStart = param.timeStart;</span></span>
<span class="line"><span>  var timeEnd = param.timeEnd;</span></span>
<span class="line"><span>  if (isDate(timeStart)) {</span></span>
<span class="line"><span>    // обработать временные данные</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // pluginSettings и freebusySettings общие для запросов на данный Free/Busy домен (в сервере передаётся как переменные среды окружения env)</span></span>
<span class="line"><span>  var pluginSettings = Vars().pluginSettings;</span></span>
<span class="line"><span>  var freebusySettings = Vars().freebusySettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  var host = freebusySettings.Host;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // отправиляем запрос за информацией</span></span>
<span class="line"><span>  var params = NewDictionary();</span></span>
<span class="line"><span>  params.responseFormat = &quot;&quot;;</span></span>
<span class="line"><span>  var url = host + &quot;~&quot; + email + &quot;/freebusy.vfb&quot;;</span></span>
<span class="line"><span>  var httpResult = HTTPCall(url, params);</span></span>
<span class="line"><span>  if (isString(httpResult)) {</span></span>
<span class="line"><span>    SetResult(httpResult);</span></span>
<span class="line"><span>  } else {</span></span>
<span class="line"><span>    SetResult(httpResult.body);</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>end entry;</span></span></code></pre></div><p>Файл сценария проверки параметров получения информации о доступности / занятости участников (Free/Busy) может как выполнять базовые проверки по регулярным выражениям или заполнению полей, так и проверять корректность введённых параметров путём обращения к внешнему серверу. Это должен быть отдельный сценарий в <a href="./CGPL.html#SyncScripts">формате scgp</a>. В файле сценария должен содержаться метод <code>checkConfig</code>, выполняющий проверку параметров конфигурации Free/Busy, доступных ему через словарь <em>Vars().freebusySettings</em> окружения запуска сценария. Так же доступны общие парамеры расширения в словаре <em>Vars().pluginSettings</em>.</p><p>Пример файла сценария проверки параметров Free/Busy:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>entry checkConfig {</span></span>
<span class="line"><span>  // Общие настройки расширения, если необходимы</span></span>
<span class="line"><span>  var pluginSettings = Vars().pluginSettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  // Настройки Free/Busy</span></span>
<span class="line"><span>  var freebusySettings = Vars().freebusySettings;</span></span>
<span class="line"><span></span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(freebusySettings.Host) == 0) {</span></span>
<span class="line"><span>    SetResult(&quot;Host is empty&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (Length(freebusySettings.Password) &lt; 6) {</span></span>
<span class="line"><span>    SetResult(&quot;Password too short&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  var req = NewDictionary();</span></span>
<span class="line"><span>  req.method = &quot;GET&quot;;</span></span>
<span class="line"><span>  var res = HTTPCall(freebusySettings.Host), req);</span></span>
<span class="line"><span></span></span>
<span class="line"><span>  if (!res.isDictionary()) {</span></span>
<span class="line"><span>    SetResult(&quot;failed to connect to server&quot;);</span></span>
<span class="line"><span>    stop;</span></span>
<span class="line"><span>  }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>}</span></span></code></pre></div><h3 id="helpers" tabindex="-1">Помощники <a class="header-anchor" href="#helpers" aria-label="Permalink to &quot;Помощники {#helpers}&quot;">​</a></h3><p>В расширении можно добавить исполняемые файлы помощников (как бинарные, так и на скриптовых языках). Используются так же как и установленные и настроенные на странице <a href="./Helpers.html">Помощники</a>.</p><p>Помощники в расширениях могут быть двух типов: <a href="./Helpers.html#Filters">фильтрации сообщений</a> и <a href="./Helpers.html#AppHelpers">помощники приложений</a>. Имя помощника определяется названием секции в <code>cgplugin.json</code>. Включение помощников осуществляется включением выключением расширения. Настройка помощников осуществляется со страницы настройки расширения. Параметры настройки определяются также в <code>cgplugin.json</code>. Помощникам, установленным в составе расширений, доступны настройки расширения. Для получения настроек расширения помощник должен отправить серверу (после установки версии протокола) <code>GETCONFIG</code>, подписка на обновление конфигурации расширения, команда серверу <code>SUBSCRIBECONFIG</code> и ответ сервера в случае изменения настроек <code>CONFIGUPDATED</code>. <a href="./Helpers.html#Protocol">Описание протокола</a>.</p><p>Пример протокола (I - сообщения сервера, O - сообщения помощника):</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>O: H00007 GETCONFIG</span></span>
<span class="line"><span>I: H00007 OK { type = &quot;cat&quot; }</span></span>
<span class="line"><span></span></span>
<span class="line"><span>O: H00005 SUBSCRIBECONFIG</span></span>
<span class="line"><span>I: H00005 OK</span></span>
<span class="line"><span></span></span>
<span class="line"><span>I: 00010 CONFIGUPDATED { type = &quot;dog&quot; }</span></span>
<span class="line"><span>O: 00010 OK</span></span></code></pre></div><p>Помощники определяются в объекте <code>helpers</code> объектами с описаниями программ для разных архитектур. В разделе <code>all</code> могут быть указаны помощники, написанные на скриптовых языках и независимые от архитектуры, при этом, если для текущей архитектуры будет переопределён <code>helper_id</code>, то будет использоваться именно он. (в примере ниже на архитектуре x86_64 будут запущены два помощника: <code>all/@helper_id1</code> и <code>x86_64/helper_id2</code>). Наличие в секции <code>config</code> параметров <code>LogLevel</code>, <code>RestartPause</code>, <code>Timeout</code> необходимо для задания настройки помощников в расширении. Если они не заданы, то сервер установит в этом случае предопределённые настройки.</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;config&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;LogLevel&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;LogLevelTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;RestartPause&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;RestartPauseTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;Timeout&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;TimeoutTitle&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;SomeExtensionParameter1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SomeExtensionParameter1Title&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;SomeExtensionParameter2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;string&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;required&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;SomeExtensionParameter2Title&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;helpers&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;all&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;helper_id1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;system_exe&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;/usr/bin/bash&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;exe&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;script1.sh&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;params&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;--logAll -k value1 --key2=value2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;filter&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;helper_id2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;system_exe&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;/usr/bin/perl&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;exe&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;script2.pl&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;params&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;--p1 --p2 --p3&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;app&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;x86_64&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;helper_id2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;exe&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;program2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;params&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;--p1 --p2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">          &quot;type&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;app&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>В описании помощников в расширениях должен быть задан хотя бы один из элементов <code>system_exe</code>, <code>exe</code>.</p><ul><li><code>system_exe</code> <em>(опционально)</em> - исполняемый файл, уже присутствующий в системе, предполагался для указания интерпретатора скриптового языка.</li><li><code>exe</code> <em>(опционально)</em> - исполняемый файл в составе расширения, бинарный или на скриптовом языке.</li><li><code>params</code> <em>(опционально)</em> - Параметры, передаваемые помощнику.</li><li><code>type</code> <em>(обязательно)</em> - тип помощника, <code>app</code> или <code>filter</code>.</li></ul><h3 id="skins" tabindex="-1">Интерфейсы <a class="header-anchor" href="#skins" aria-label="Permalink to &quot;Интерфейсы {#skins}&quot;">​</a></h3><p>В расширении можно добавить файлы интерфейсов (<a href="./WSSP.html">wssp</a>, <a href="./WebApp.html">wcgp</a>, изображения, js, css...) Файлы из расширения будут использоваться при совпадении имени скина и имени файла. Порядок поиска файлов скинов: интерфейсы, заданные для домена, &quot;общесерверные&quot; интерфейсы, интерфейсы в расширениях, интерфейсы в поставке сервера (стоковые). При этом в расширениях может только один раз указываться конкретный интерфейс. Если расширение выключено, указанные в нём файлы и скины не участвуют в поиске. При включении / выключении расширения с файлами интерфейсов на сервере происходит сброс кэша интерфейсов.</p><p>Описывается в секции <code>WebSkins</code> в виде объекта с именами интерфейсов, где в каждом объекте указывается каталог с файлами или список файлов. Для неименованного интерфейса можно указать в качестве имени интерфейса (объекта с описанием используемых файлов) пустую строку или строки <code>unnamed</code>, <code>noname</code></p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;dirs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;hPronto-&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;files&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;login.wssp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;login.css&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>В описании интерфейсов в расширениях должно быть задано хотя бы одно из <code>dirs</code>, <code>files</code>. Все файлы, перечисленные в массиве <code>files</code>, должны присутствовать в расширении, как и каталог, если таковой указан в <code>dirs</code>.</p><ul><li><code>dirs</code> <em>(опционально)</em> - список каталогов (не более 1 каталога) с файлами интерфейса.</li><li><code>files</code> <em>(опционально)</em> - файлы интерфейса, лежащие в корне расширения.</li></ul><h3 id="sso" tabindex="-1">Технология единого входа (Single sign-on) <a class="header-anchor" href="#sso" aria-label="Permalink to &quot;Технология единого входа (Single sign-on) {#sso}&quot;">​</a></h3><p>В расширении указывается список методов авторизации SSO. Для этого необходимы скрипты wcgp из неименованного (базового) скина. Данное расширение &quot;несамостоятельно&quot; и требует наличия точки расширения <a href="#skins">Интерфейсы (WebSkins)</a> с неименованным интерфейсом.</p><p>Описывается в массиве <code>SingleSignOn</code> список объектов с полями</p><ul><li><code>script</code> <em>(обязательно)</em> - имя файла скрипта <code>wcgp</code>, добавляемого тем же плагином, на который Web-интерфейс потом будет перенаправлен при нажатии соответствующей кнопки на экране входа (должен быть в плагине и добавлен в неименованный интерфейс).</li><li><code>title</code> <em>(обязательно)</em> - cтрока из файлов <a href="#Locales">локализации</a>, которая будет использоваться при отображении метода входа.</li><li><code>icon</code> - (опционально) имя файла в формате <code>svg</code> иконки. (Файл должен быть в плагине и добавлен в неименованный интерфейс)</li></ul><p>Пример</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">{</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">  &quot;extends&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">      &quot;unnamed&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;dirs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;WebSkins&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    },</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">    &quot;SingleSignOn&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: [</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sso1.wcgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Title1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;icon&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;icon1.svg&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      },</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      {</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;script&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;sso2.wcgp&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>
<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">        &quot;title&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;Title2&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">      }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    ]</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>Файлам wcgp и wssp доступен список Single Sign-On, как массив словарей по переменной <code>SingleSignOnList</code>.</p><p>Каждый элемент массива - словарь с полями, описанными выше: <code>script</code>, <code>title</code>, <code>icon</code> (опционально). Кроме того, в каждом элементе есть поле <code>PluginId</code>, его можно использовать для перевода поля <code>title</code> (подстановки строк из файла локализации плагина).</p>`,78)]))}const c=i(p,[["render",l]]);export{E as __pageData,c as default};
