import{_ as s,c as i,o as t,ag as a}from"./chunks/framework.jCcxW76o.js";const E=JSON.parse('{"title":"Программирование Веб-Сервера (WSSP)","description":"","frontmatter":{"legacyLink":"russian/WSSP.html"},"headers":[],"relativePath":"russian/development/WSSP.md","filePath":"russian/development/WSSP.md"}'),o={name:"russian/development/WSSP.md"};function p(d,e,l,n,c,h){return t(),i("div",null,e[0]||(e[0]=[a(`<p></p><h1 id="программирование-веб-сервера-wssp" tabindex="-1">Программирование Веб-Сервера (WSSP) <a class="header-anchor" href="#программирование-веб-сервера-wssp" aria-label="Permalink to &quot;Программирование Веб-Сервера (WSSP)&quot;">​</a></h1><p>Модуль Веб Приложения CommuniGate Pro обрабатывает запросы для файлов WSSP вызывая <a href="./WebApp.html#Processing">компонент</a>, который создаёт <em>набор данных</em> - <a href="./Data.html">словарь</a>, содержащий ключи - текстовые строки и значения, связанные с этими ключами. Значения могут быть текстовыми строками, числами, отметками времени, массивами или словарями. Дополнительную информацию о типах данных смотрите в разделе <a href="./Data.html">Данные</a>.</p><p>Например, когда требуется вывести страницу Домена по умолчанию, вызывается специальный компонент. Компонент обрабатывает параметры запроса (HTML FORM) и создаёт <em>набор данных</em> - <em>словарь</em>, содержащий ключи и их значения. Например, набор данных, созданный компонентом при обработке запроса на Вход (Login) может содержать ключи <code>canAutoSignup</code>, <code>hasMailLists</code> и <code>hasCertificate</code>.</p><p>Модуль Веб Приложения может затем использовать код сценария из файла WSSP для преобразования этого набора данных в страницу, использующую язык разметки (HTML, WML и т.д.).</p><h2 id="Elements" tabindex="-1">Элементы Сценария <a class="header-anchor" href="#Elements" aria-label="Permalink to &quot;Элементы Сценария {#Elements}&quot;">​</a></h2><p>Файл WSSP является файлом с языком разметки (обычно - HTML) с двумя дополнительными типами элементов:</p><ul><li>текстовыми элементами, начинающимися и заканчивающимися двумя символами процентов (<code>%%</code>)</li><li>структурными элементами, начинающимися маркером <code>&lt;!--%%</code> и заканчивающимися маркером <code>--&gt;</code>.</li></ul><p>Ниже приводится образец документа WSSP:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">html</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">h1</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Welcome to %%server%%. Your ID is %%ID%%.&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">h1</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">    &lt;!--%%IF EXISTS(lastLogin)--&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    Last time you visited us on %%lastLogin%%</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">    &lt;!--%%ENDIF--&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">body</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">html</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>Этот WSSP документ содержит текстовые элементы <code>%%server%%</code>, <code>%%ID%%</code> и <code>%%lastLogin%%</code>, а также структурные элементы <code>&lt;!--%%IF EXISTS(lastLogin)--&gt;</code> и <code>&lt;!--%%ENDIF--&gt;</code> (эти текстовые элементы являются фиктивными, не пытайтесь использовать эти примеры в ваших .wssp страницах).</p><p>Если документ WSSP должен содержать символы вне таблицы ASCII, то должна использоваться кодировка UTF-8. При обработке документа WSSP, модуль Веб Приложения запрашивает значение строки <code>charset</code> из созданного словаря с данными. Если это значение не равно <code>UTF-8</code>, то текст WSSP преобразовывается в эту <em>кодировку страницы</em>.</p><h2 id="Exprs" tabindex="-1">Выражения <a class="header-anchor" href="#Exprs" aria-label="Permalink to &quot;Выражения {#Exprs}&quot;">​</a></h2><p>Текстовые и структурные элементы WSSP используют выражения - комбинации имён и символов, при помощи которых задаются данные, получаемые из словарей и других доступных источников данных.</p><p>В сценариях WSSP используется несколько типов выражений:</p><ul><li>элемент данных</li><li>итератор массива</li><li>элемент с ключом</li><li>элемент с индексом</li><li>вызов функции</li><li>логическое выражение</li><li>строковая константа</li></ul><p>Алфавитно-цифровая строка (такая, как <code>system</code> или <code>id</code>) является именем элемента данных. Значением такого выражения является значение из набора данных, связанного с этим именем. Если в наборе данных не имеется указанного ключа, то значением выражения является нулевое значение.<br> Пример: набор данных имеет ключ <code>system</code> и связанное с ним значение строку <code>Sun Solaris</code>; соответственно, значением выражения <code>system</code> является строка <code>Sun Solaris</code>.</p><p>Словарь набора данных является независимым от регистра, так что имена элементов данных также являются независимыми от регистра.</p><p>Алфавитно-цифровая строка, за которой следуют символы <code>[]</code>интерпретируется как имя итератора индекса. Оно может использоваться только внутри структуры <code>&lt;!--%%FOREACH name...--&gt;</code> ....<code>&lt;!--%%ENDFOR name--&gt;</code>, где определён этот элемент с индексом (смотрите ниже). Имена итераторов индекса независимы от регистра.</p><p>Выражение, за которым следует символ точка (<code>.</code>) и алфавитно-цифровая строка является элементом с ключом. Выражение до символа точки вычисляется, и его значение должно быть словарём. Алфавитно-цифровая строка после символа точки задаёт ключ, который будет использоваться для получения значения из этого словаря. Если значением выражения до символа точка не является словарь, или если он не содержит указанного ключа, то значение элемента с ключом является нулевым.<br> Ключи могут быть указаны как строки в кавычках, в этом случае они могут содержать не алфавитно-цифровые символы.<br> Пример: набор данных имеет ключ <code>settings</code> и связанный с ним словарь из двух элементов <code>{OS = &quot;Sun Solaris&quot;; CPU = &quot;sparc&quot;;}</code>. Значением выражения <code>settings.OS</code> будет строка <code>Sun Solaris</code>, значение выражения <code>settings.&quot;OS1&quot;</code> будет пустым.</p><p>Выражение, за которым следует <em>выражение индекса</em> в квадратных скобках (<code>[index]</code>) является элементом с индексом. Выражение до квадратной скобки вычисляется, его значение должно быть массивом или словарём. <em>Выражение индекса</em> вычисляется и его значением должно быть число или числовая строка. Это число указывает, какой именно элемент массива или ключ словаря будет значением этого индексированного выражения. Если значение <em>выражения индекса</em> равно <code>0</code>, то возвращается первый элемент массива или первый ключ словаря.<br><em>Выражение индекса</em> может быть задано как числовая константа.<br> Если значение выражения до символа квадратная скобка не является массивом или словарём, или значение <em>выражения индекса</em> не является числом, или если значение <em>выражения индекса</em> имеет отрицательное, либо равное, либо большее, чем число элементов массива/словаря, значение, то значение выражения индекса считается пустым.</p><p>Алфавитно-цифровая строка, за которой следует символ <code>(</code>, является вызовом функции. Элементы после символа <code>(</code> задают параметры функции, за которыми должен следовать символ <code>)</code>.<br> Имена функций независимы от регистра.<br> В списке ниже приводятся все доступные функции и их параметры.</p><p>Логические выражения являются двумя выражениями, разделёнными символами <code>|</code> (ИЛИ), символом <code>&amp;</code> (И) или символом <code>^</code> (ИСКЛЮЧАЮЩЕЕ ИЛИ).<br> Так же возможно использование скобок:</p><p><code>expression1 | expression2</code><br><code>expression1 &amp; expression2</code><br><code>(expression1 &amp; expression2) | expression3</code></p><p>Логическое (булево) значение выражения положительно (истинно), если:</p><ul><li>значение выражение является строкой, не начинающейся с символов <code>N</code>, <code>n</code>, <code>-</code> и <code>0</code>, или</li><li>значение выражения является ненулевым числом.</li><li>значение выражения является отметкой времени, и это не константа &quot;далёкое прошлое&quot;.</li></ul><p>Строковая константа заключается в двойные кавычки. Символы двойной кавычки и обратной косой черты должны быть защищены в константной строке символом обратной косой черты <code>\\</code>: <code>&quot;My \\&quot;test\\&quot; string&quot;</code>.</p><ul><li><p><code>SESSION(key)</code></p><p>Эта функция может использоваться только в связанных с сессиями запросах. Значением функции является значение набора данных сессии, связанного со строкой <em>key</em>. Параметр <em>key</em> может быть задан как алфавитно-цифровая строка или константная строка.<br> Пример: значением выражения <code>SESSION(accountName)</code> является имя Пользователя CommuniGate Pro, для которого была открыта эта сессия.<br> Набор данных сессии является независимым от регистра. В нём содержатся следующие ключи и значения:</p><table tabindex="0"><thead><tr><th>Ключ</th><th>Значение</th></tr></thead><tbody><tr><td><code>ID</code></td><td>строка с уникальным идентификатором этой сессии</td></tr><tr><td><code>accountName</code></td><td>строка с именем Пользователя сессии</td></tr><tr><td><code>domainName</code></td><td>строка с именем Домена, которому принадлежит Пользователь этой сессии</td></tr><tr><td><code>filesRef</code></td><td>строка с префиксом URL, необходимым для получения файлов Вида Интерфейса сессии</td></tr><tr><td><code>fullAccountName</code></td><td>строка с полным именем Пользователя сессии <code>accountName@domainName</code></td></tr><tr><td><code>loginAddress</code></td><td>строка, содержащая сетевой (IP) адрес, с которого этот пользователь установил сессию</td></tr><tr><td><code>loginTime</code></td><td>отметка времени начала сессии</td></tr><tr><td><code>selectableMailboxes</code></td><td>массив, в котором содержатся имена всех &quot;выбираемых&quot; папок</td></tr><tr><td><code>addressBooks</code></td><td>массив, в котором содержатся имена всех доступных адресных книг</td></tr><tr><td><code>webFolders</code></td><td>массив с именами папок в Хранилище Файлов</td></tr><tr><td><code>selectedMailbox</code></td><td>строка с именем Папки назначения для последней операции Копировать/Передвинуть</td></tr><tr><td><code>selectedAddressBook</code></td><td>строка с именем выбранной адресной книги.</td></tr><tr><td><code>selectedWebFolder</code></td><td>строка с именем Папки в Хранилище Файлов, выбранной для последней операции Записать Файлы</td></tr><tr><td><code>webSiteEnabled</code></td><td>этот элемент - строка со значением <code>&quot;YES&quot;</code> существует, если Лимит Хранилища для Хранилища Файлов не установлен в ноль</td></tr><tr><td><code>openMailboxes</code></td><td>словарь со всеми открытыми Папками (ключами словаря являются имена Папок в кодировке UTF8).</td></tr></tbody></table><p><a href="./WebApp.html#Session">Веб Приложения CG/PL</a> могут добавлять ключи в набор данных сессии.</p></li><li><p><code>SETTINGS(key)</code></p><p>Эта функция может использоваться только в запросах внутри сессий. Значением функции является значение фактически действующей настройки Веб Интерфейса Пользователя, связанной со строкой <em>key</em>. Параметр <em>key</em> может быть задан как алфавитно-цифровая строка или константная строка.</p></li><li><p><code>ACCOUNTSETTINGS(key)</code></p><p>Эта функция может использоваться только в запросах внутри сессий. Значением функции является значение фактически действующей установки Пользователя, связанной со строкой <em>key</em>. Параметр <em>key</em> может быть задан как алфавитно-цифровая строка или строка в кавычках.</p></li><li><p><code>INCLUDEARG(number)</code></p><p>Эта функция может использоваться только внутри включаемого файла. <em>Key</em> должно быть десятичным числом, указывающим номер параметра элемента <code>&lt;!--%%INCLUDE--&gt;</code> которым был вызван этот файл.<br> Первый параметр имеет номер 0.<br> Если в элементе <code>&lt;!--%%INCLUDE--&gt;</code> не было указано достаточное количество параметров, то значение функции является пустым.</p></li><li><p><code>EXISTS(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение не является нулевым или строку <code>&quot;NO&quot;</code>, если возвращённое значение является нулевым.</p></li><li><p><code>DOESNOTEXIST(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;NO&quot;</code>, если вычисленное значение не является нулевым или строку <code>&quot;YES&quot;</code>, если возвращённое значение является пустым.</p></li><li><p><code>YESNO(expression)</code></p><p>Параметром является выражение. Его логическое значение вычисляется и, если оно положительно (истинно), то функция возвращает строку <code>&quot;YES&quot;</code>; в противном случает она возвращает строку <code>&quot;NO&quot;</code>.</p></li><li><p><code>BOOLARRAY()</code></p><p>Значением является массив из двух элементов, содержащий строки <code>&quot;NO&quot;</code> и <code>&quot;YES&quot;</code>.</p></li><li><p><code>NOT(expression)</code></p><p>Параметром является выражение. Вычисляется логическое значение и функция возвращает пустое значение, если значение положительно (истинно); иначе функция возвращает строку <code>&quot;YES&quot;</code>.</p></li><li><p><code>EQUALS(expression1 AND expression2)</code></p><p>Оба выражения вычисляются и, если вычисленные значения совпадают (включая случай, когда оба выражения имеют пустое значение), то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>EQUALSNOCASE(expression1 AND expression2)</code></p><p>Оба выражения вычисляются. Функция возвращает строку <code>&quot;YES&quot;</code>, если оба вычисленных выражения имеют пустое значение, либо они являются строками, и эти строки совпадают при использовании независимой от регистра операции сравнения ASCII строк. Во всех других случаях функция возвращает пустое значение.</p></li><li><p><code>EQUALS(expression AND string)</code></p><p>Значение выражения вычисляется и сравнивается с константной строкой. Если значение соответствует строке, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>EQUALSNOCASE(expression AND string)</code></p><p>Значение выражения вычисляется и сравнивается с константной строкой. Функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное выражение совпадает со строкой при использовании независимой от регистра операции сравнения ASCII строк. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISINDEX(expression IN scanner)</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Значение выражения вычисляется и, если строка и её числовое значение совпадают с текущим индексом в массиве, для которого используется этот <em>scanner</em>, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISFIRST(scanner)</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Если текущее значение индекса массива равно нулю, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISLAST(scanner)</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Если текущее значение индекса равно числу элементов массива или словаря минус единица, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISEVEN(scanner)</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Если текущее значение индекса чётное, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISHALF(scanner)</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Если текущее значение индекса равно числу элементов массива или словаря, разделённому на 2, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.</p></li><li><p><code>CHECKED(expression)</code></p><p>Параметром является выражение. Вычисляется его логическое значение и, если значение положительно (истинно), то функция возвращает строку <code>&quot;checked&quot;</code>; в противном случае функция возвращает пустое значение.</p></li><li><p><code>REQUIRED(expression)</code></p><p>Параметром является выражение. Вычисляется его логическое значение и, если значение положительно (истинно), то функция возвращает строку <code>&quot;required&quot;</code>; в противном случае функция возвращает пустое значение.</p></li><li><p><code>HASPARENTMAILBOX(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является строкой, являющейся именем иерархической папки. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISSTRING(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является строкой. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISNUMBER(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является числом. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISARRAY(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является массивом. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISDICTIONARY(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является словарём. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISDATE(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является отметкой времени. В противном случае функция возвращает пустое значение.</p></li><li><p><code>ISDATA(expression)</code></p><p>Параметром является выражение. Его значение вычисляется, и функция возвращает строку <code>&quot;YES&quot;</code>, если вычисленное значение является блоком данных. В противном случае функция возвращает пустое значение.</p></li><li><p><code>NULL()</code></p><p>Эта функция возвращает пустое значение.</p></li><li><p><code>EMPTYSTRING()</code></p><p>Значением этой функции является пустая строка.</p></li><li><p><code>EMPTYARRAY()</code></p><p>Значением этой функции является пустой массив.</p></li><li><p><code>EMPTYDICTIONARY()</code></p><p>Значением этой функции является пустой словарь.</p></li><li><p><code>CURRENTTIME()</code></p><p>Значением функции является отметка времени - текущее глобальное время.</p></li><li><p><code>SELECTEDLANGUAGE()</code></p><p>Значением функции является строка с именем текущего &quot;выбранного языка&quot;.</p></li><li><p><code>SELECTEDTIMEZONE()</code></p><p>Значением функции является строка с именем текущего &quot;выбранного часового пояса&quot;.</p></li><li><p><code>STRING(key)</code></p><p>Значением этой функции является объект, связанный с <em>key</em> в Наборе Текстовых Данных Вида Интерфейса. Объект должен быть строкой, в противном случае функция возвращает пустое значение. Ключ может быть задан либо как строка в кавычках, либо как выражение - значение выражения вычисляется и используется как ключ.</p></li><li><p><code>DICTIONARY(key)</code></p><p>Значением этой функции является объект, связанный с <em>key</em> в Наборе Текстовых Данных Вида Интерфейса. Объект должен быть словарём, в противном случае функция возвращает пустое значение. Ключ может быть задан либо как строка в кавычках, либо как выражение - значение выражения вычисляется и используется как ключ.</p></li><li><p><code>ARRAY(key)</code></p><p>Значением этой функции является объект, связанный с <em>key</em> в Наборе Текстовых Данных Вида Интерфейса. Объект должен быть массивом, в противном случае функция возвращает пустое значение. Ключ может быть задан либо как строка в кавычках, либо как выражение - значение выражения вычисляется и используется как ключ.</p></li><li><p><code>TRANSLATE(string USING dictionary)</code></p><p>Параметр <em>string</em> должен быть выражением со значением типа строка; параметр <em>dictionary</em> должен быть выражением со значением типа словарь. Если для ключа, заданного значением первого параметра в словаре содержится значение типа строка, то функция возвращает эту строку. В противном случае возвращается значение параметра <em>string</em>;<br> Пример: набор данных содержит элемент <code>boxName</code> со значением типа строка <code>INBOX</code> и элемент <code>boxNames</code> - словарь <code>{INBOX = Incoming; Trash = &quot;Trash Can&quot;;}</code>. Значением выражение <code>TRANSLATE(boxName USING boxNames)</code> является строка <code>&quot;Incoming&quot;</code>.</p></li><li><p><code>CONTAINS(string IN array)</code></p><p>Если значение параметра <em>array</em> является массивом и строка совпадает с одним из элементов массива, то функция возвращает строку <code>&quot;YES&quot;</code>. В противном случае функция возвращает пустое значение.<br> Строка может быть задана либо как константная строка, либо как выражение.</p></li><li><p><code>RANDOMELEMENT(array)</code></p><p>Параметр <em>array</em> должен иметь значение типа массив; значением этой функции является случайным образом выбранный элемент массива.</p></li><li><p><code>MONTHNAMES()</code></p><p>Функция возвращает фиксированный массив из 12 строковых элементов: <code>(&quot;Jan&quot;,&quot;Feb&quot;,&quot;Mar&quot;,&quot;Apr&quot;,&quot;May&quot;,&quot;Jun&quot;,&quot;Jul&quot;,&quot;Aug&quot;,&quot;Sep&quot;,&quot;Oct&quot;,&quot;Nov&quot;,&quot;Dec&quot;)</code>.</p></li><li><p><code>WEEKDAYS()</code> и <code>WEEKDAYS(expression)</code></p><p>Если выражение не указано, то функция возвращает фиксированный массив из 7 строковых элементов: (<code>Sun</code>,<code>Mon</code>,<code>Tue</code>,<code>Wed</code>,<code>Thu</code>,<code>Fri</code>,<code>Sat</code>).<br> Если указано выражение, то его значением должна быть строка с одним из названий дня недели; в этом случае функция возвращает массив с названиями дней недели, начинающийся с указанного дня недели: <code>WEEKDAYS(startOfWeek)</code><br> возвращает <code>(&quot;Tue&quot;,&quot;Wed&quot;,&quot;Thu&quot;,&quot;Fri&quot;,&quot;Sat&quot;,&quot;Sun&quot;,&quot;Mon&quot;)</code> если значение переменной startOfWeek было <code>&quot;Tue&quot;</code>.</p></li><li><p><code>KNOWNCHARSETS()</code></p><p>Функция возвращает фиксированный массив строковых элементов - названий кодировок, известных системе: <code>(&quot;ISO-8059-1&quot;,&quot;ISO-2022-jp&quot;,&quot;KOI8-R&quot;, ...)</code>.</p></li><li><p><code>KNOWNTIMEZONES()</code></p><p>Функция возвращает фиксированный массив строковых элементов - названий часовых поясов, известных системе <code>(&quot;NorthAmerica/Pacific&quot;,&quot;Europe/Central&quot;,&quot;(+0900) Japan/Korea&quot;, ...)</code></p></li><li><p><code>REQUESTSECURE()</code></p><p>Функция возвращает строку <code>&quot;YES&quot;</code>, если текущий HTTP запрос является безопасным (то есть, отправленным по протоколу HTTPS); в противном случае функция возвращает пустое значение.</p></li><li><p><code>REQUESTRESOURCE()</code></p><p>Функция возвращает строку ресурса (локальную часть строки URL, возможно с параметрами) текущего запроса HTTP.</p></li><li><p><code>REQUESTSOURCEIP()</code></p><p>Функция возвращает строку с Адресом IP, с которого был получен запрос HTTP.</p></li><li><p><code>SERVERVERSION()</code></p><p>Функция возвращает строку с номером версии Сервера CommuniGate Pro.</p></li></ul><h2 id="Text" tabindex="-1">Текстовые Элементы <a class="header-anchor" href="#Text" aria-label="Permalink to &quot;Текстовые Элементы {#Text}&quot;">​</a></h2><p>Текстовые элементы указываются в двойных знаках процентов. Телом текстового элемента является выражение (возможно с префиксом).</p><ul><li><p><code>%%expression%%</code></p><p>Выражение вычисляется. Если значением выражения является строка или число, то оно заменяет собой текстовый элемент в результирующем коде разметки.<br> В противном случае весь текстовый элемент удаляется из результирующего кода разметки.</p></li><li><p><code>%%HTML:expression%%</code></p><p>Выражение вычисляется. Если значением выражения является строка или число, то оно заменяет собой текстовый элемент, используя специальные символы HTML. Значение строки конвертируется из UTF-8 в требуемую кодировку.<br> В противном случае весь текстовый элемент удаляется из результирующего кода разметки.</p><ul><li><p>Пример:</p><p>Если результатом выражения является строка <code>&quot;&gt;=GO=&gt;&quot;</code>, то этот текстовый элемент заменяется на:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&amp;gt;=GO=&amp;gt;</span></span></code></pre></div></li></ul></li><li><p><code>%%HTMLUTF8:expression%%</code></p><p>Выражение вычисляется. Если значением выражения является строка или число, то оно заменяет собой текстовый элемент, используя специальные HTML символы (строка не конвертируется из UTF-8 в кодировку страницы).<br> В противном случае весь текстовый элемент удаляется из результирующего кода разметки.</p><ul><li><p>Пример:</p><p>Если результатом выражения является строка <code>&gt;=GO=&gt;</code>, то этот текстовый элемент заменяется на:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&amp;gt;=GO=&amp;gt;</span></span></code></pre></div></li></ul></li><li><p><code>%%URL:expression%%</code></p><p>Выражение вычисляется. Если значением выражения является строка или число, то оно заменяет собой текстовый элемент, используя специальные символы для URL.<br> В противном случае весь текстовый элемент удаляется из результирующего кода разметки.</p><ul><li><p>Пример:</p><p>Если результатом выражения является строка <code>&quot;Stop It?&quot;</code>, то этот текстовый элемент заменяется на:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Stop%20It%3F</span></span></code></pre></div></li></ul></li><li><p><code>%%MAILBOXRAWNAME:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка, то она преобразовывается из кодировки IMAP для имён папок в кодировку UTF-8, затем она преобразовывается в требуемую кодировку, а затем преобразованная строка заменяет собой текстовый элемент, используя специальные HTML символы.</p></li><li><p><code>%%MAILBOXNAME:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка X, то вычисляется выражение <code>TRANSLATE(X USING DICTIONARY(&quot;MailboxNames&quot;))</code>. Затем префикс работает аналогично префиксу <code>MAILBOXRAWNAME:</code>.</p></li><li><p><code>%%MAILBOXLASTNAME:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка X, то она интерпретируется как имя папки. Если это имя иерархической папки, то используется только последняя часть имени; в противном случае используется всё имя. Имя (или его последняя часть) преобразовывается таким же образом, как и при использовании префикса <code>MAILBOXNAME:</code>.</p></li><li><p><code>%%URLMAILBOXPARENT:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка X, то она интерпретируется как имя папки. Если это имя иерархической папки, то используется имя родительской папки. Оно преобразовывается таким же образом, как и при использовании префикса <code>URL:</code>. Если это имя не иерархической папки, то весь текстовый элемент удаляется из результирующего кода разметки.</p></li><li><p><code>%%JAVASCRIPT:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой или числом, то весь текстовый элемент удаляется из результирующего кода разметки. Если значением выражения является строка или число, то оно заменяет собой текстовый элемент, используя специальные символы для JavaScript. Результат преобразовывается в Unicode и все символы вне ASCII представляются в виде последовательностей <code>\\uhhhh</code>.</p><div class="tip custom-block"><p class="custom-block-title">Note</p><p>этот префикс не ставит знаков кавычек в начале и в конце строки.</p></div><ul><li><p>Пример:</p><p>если результатом выражения является строка <code>&#39;What do &quot;they&quot; think?&#39;</code>, то этот текстовый элемент заменяется на:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>What do \\&quot;they\\&quot; think</span></span></code></pre></div></li></ul></li><li><p><code>%%JSON:expression%%</code></p><p>Выражение вычисляется. Значение конвертируется в представление JSON (JavaScript Object Notation), и эта строка подменяет собой текстовый элемент. Отметки времени представляются как строки дат в формате RFC822.</p><ul><li><p>Пример:</p><p>если результатом выражения является массив <code>( &#39;What do &quot;they&quot; think?&#39;, #123)</code>, то этот текстовый элемент заменяется на:</p><div class="language-json vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">json</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">[</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;What do </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">\\&quot;</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">they</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">\\&quot;</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> think&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">124</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">]</span></span></code></pre></div></li></ul></li><li><p><code>%%SIZE:expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой или числом, то весь текстовый элемент удаляется из результирующего кода разметки.<br> Если значением выражения является строка, то она конвертируется в числовое значение (число байт).<br> Строка должна содержать некоторое число и, возможно, суффикс <code>k</code> или <code>K</code> (в этом случае число умножается на 1024), либо суффикс <code>m</code> или <code>M</code> suffix (в этом случае число умножается на 1048576).<br> В качестве альтернативы, строка может начинаться с буквы <code>u</code> или <code>U</code>; в этом случае она конвертируется в числовое значение -1.<br> Если значением выражения является число, то используется это числовое значение.<br> Результирующее число преобразовывается в &quot;строку размера&quot; с использованием словаря, получаемого при помощи выражения <code>DICTIONARY(&quot;SizePictures&quot;)</code>. Если число отрицательное, то для трансляции строки <code>unlimited</code> применяется словарь и результат используется для замещения этого текстового элемента; при этом проводятся такие же преобразования, как и для текстового элемента с префиксом <code>HTML:</code>.<br> Далее проверяется, является ли вычисленное число байт целым числом Мегабайт или Килобайт, и больше ли оно чем один. Затем из словаря получается значение строки, связанной с ключом <code>&quot;M&quot;</code>, <code>&quot;K&quot;</code> или <code>&quot;&quot;</code> (пустая строка). Предполагается, что в строке содержится комбинация символов <code>^0</code>, замещаемая числом мегабайт, килобайт или байт, заданных в значении <em>expression</em>. Результирующая строка обрабатывается аналогично методу, используемому префиксом текстового элемента <code>HTML:</code>.<br> Если результатом выражения <code>DICTIONARY(&quot;SizePictures&quot;)</code> является пустое значение, или словарь не содержит значения строки для требуемого ключа, то результирующая строка строится с использованием числа и имени ключа (<code>20M</code>, <code>1345K</code>, <code>182345777</code>).</p></li><li><p><code>%%ROUNDSIZE:expression%%</code></p><p>Этот префикс работает так же, как и префикс <code>SIZE:</code>, но числовое значение <em>expression</em> может быть изменено: если значение равно или больше 10000, то оно конвертируется в значение, выраженное в &quot;Кило&quot; (значение = значение / 1024 * 1024), а если значение больше либо равно чем 10240000, то оно конвертируется в значение, выраженное в &quot;Мега&quot; (значение = значение / 1048576 * 1048576).</p></li><li><p><code>%%TIME:expression%%</code></p><p>Выражение вычисляется.<br> Если результат является пустым значением, то весь текстовый элемент удаляется из результирующего кода разметки.<br> Если результатом является число, то его значение интерпретируется как число секунд.<br> Если значением выражения является строка, то она конвертируется в числовое значение (число секунд):<br> Строка должна содержать некоторое число и, возможно, либо суффикс <code>s</code> или <code>S</code>, либо суффикс <code>m</code> или <code>M</code> (в этом случае число умножается на 60), либо суффикс <code>h</code> или <code>H</code> (в этом случае число умножается на 3600), либо суффикс <code>d</code> или <code>D</code> (в этом случае число умножается на 86400).<br> Результирующее число преобразовывается в &quot;строку времени&quot; с использованием словаря, получаемого при помощи выражения <code>DICTIONARY(&quot;TimePictures&quot;)</code>.<br> Далее проверяется, является ли вычисленное число секунд целым числом недель, дней, часов или минут, и больше ли оно чем один. Затем из словаря получается значение строки, связанной с ключом <code>weeks</code>, <code>days</code>, <code>hours</code>, <code>minutes</code> или <code>seconds</code>. Предполагается, что в строке содержится комбинация символов <code>^0</code>, замещаемая числом недель, дней, часов, минут или секунд, заданных в значении <em>expression</em>. Результирующая строка преобразовывается из UTF-8 в требуемую кодировку, а затем преобразованная строка заменяет собой текстовый элемент, используя специальные символы HTML.<br> Если результатом выражения <code>DICTIONARY(&quot;TimePictures&quot;)</code> является пустое значение, или словарь не содержит значения строки для требуемого ключа, то результирующая строка строится с использованием числа, пробела и имени ключа (<code>3 weeks</code>, <code>11 hours</code>, <code>5 seconds</code>).</p><ul><li><p>Пример:</p><p>Если элемент данных <code>elapsedTime</code> равен строке <code>2400</code>, то текстовый элемент</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>%%TIME:elapsedTime%%</span></span></code></pre></div><p>будет заменяться следующей строкой:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>40 minutes</span></span></code></pre></div><p>Если <code>DICTIONARY(&quot;TimePictures&quot;)</code> существует и содержит в ключе <code>minutes</code> значение <code>&quot;^0mins&quot;</code>, то текстовый элемент</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>%%TIME:elapsedTime%%</span></span></code></pre></div><p>будет заменяться на строку</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>40mins</span></span></code></pre></div></li></ul></li><li><p><code>%%DATETIME(formatName):expression%%</code></p><p>Выражение вычисляется. Если значение не является отметкой времени, то весь текстовый элемент удаляется из результирующего кода разметки. Если значение является отметкой времени, то оно преобразовывается в текстовую строку заданного формата.<br> Параметр <em>format</em> может быть задан как алфавитно-цифровая строка или строка в кавычках.</p><p>Строка формата является результатом выражения <code>DICTIONARY(&quot;DatePictures&quot;).formatName</code>. Если это выражение не имеет результата в виде текстовой строки, то вместо него используется строка <code>((^h:^m:^s ^W ^D-^M-^Y))</code>.</p><p>При обработке строки формата соответствующие комбинации символов заменяются фактическими значениями отметок времени:</p><table tabindex="0"><thead><tr><th>символы</th><th>заменяются на</th></tr></thead><tbody><tr><td><code>^D</code></td><td>день месяца (2 цифры)</td></tr><tr><td><code>^d</code></td><td>день месяца (1 или 2 цифры)</td></tr><tr><td><code>^M</code></td><td>имя месяца (одно из возвращаемых функцией MONTHNAMES()), транслированное через словарь <code>DICTIONARY(&quot;DatePictures&quot;))</code></td></tr><tr><td><code>^N</code></td><td>номер месяца (2 цифры, от <code>01</code> до <code>12</code>)</td></tr><tr><td><code>^Y</code></td><td>год (2 цифры)</td></tr><tr><td><code>^y</code></td><td>год (4 цифры)</td></tr><tr><td><code>^s</code></td><td>значение секунд (2 цифры)</td></tr><tr><td><code>^m</code></td><td>значение минут (2 цифры)</td></tr><tr><td><code>^H</code></td><td>значение часов (2 цифры), от <code>00</code> до <code>23</code></td></tr><tr><td><code>^h</code></td><td>значение часов (1 или 2 цифры), от <code>12</code>, <code>1</code> и до <code>11</code></td></tr><tr><td><code>^t</code></td><td>строка <code>AM</code> или <code>PM</code>, транслированная через <code>DICTIONARY(&quot;DatePictures&quot;)</code></td></tr><tr><td><code>^w</code></td><td>номер дня недели (Воскресенье - 0)</td></tr><tr><td><code>^W</code></td><td>имя дня недели (одно из возвращаемых функцией WEEKDAYS()), транслированное через словарь <code>DICTIONARY(&quot;DatePictures&quot;)</code></td></tr></tbody></table><p>Результирующая строка помещается в код разметки с использованием такой же обработки, как и у префикса <code>HTML:</code>.</p></li><li><p><code>%%LOCALDATETIME(formatName):expression%%</code></p><p>Обработка совпадает с используемой в префиксе <code>DATETIME(formatName)</code>, но значение отметки времени преобразовывается сначала в местное время.</p></li><li><p><code>%%DATETIMEAS(format):expression%%</code></p><p>Выражение вычисляется. Если значение не является отметкой времени, то весь текстовый элемент удаляется из результирующего кода разметки. Если значение является отметкой времени, то оно преобразовывается в текстовую строку заданного формата.<br> Параметр <em>format</em> должен быть строкой или выражением со значением типа строка. Эта строка используется в качестве строки формата.</p></li><li><p><code>%%LOCALDATETIMEAS(format):expression%%</code></p><p>Обработка совпадает с используемой в префиксе <code>DATETIMEAS(format)</code>, но значение отметки времени преобразовывается сначала в местное время.</p></li><li><p><code>%%DATE:expression%%</code></p><p>Обрабатывается так же, как префикс <code>DATETIME(&quot;dateOnly&quot;)</code>.</p></li><li><p><code>%%LOCALDATE:expression%%</code></p><p>Обрабатывается так же, как префикс <code>LOCALDATETIME(&quot;dateOnly&quot;)</code>.</p></li><li><p><code>%%DATEWEEK:expression%%</code></p><p>Обрабатывается так же, как префикс <code>DATETIME(&quot;dayAndDate&quot;)</code>.</p></li><li><p><code>%%DATETIME:expression%%</code></p><p>Обрабатывается так же, как префикс <code>DATETIME(&quot;dateAndTime&quot;)</code>.</p></li><li><p><code>%%LOCALDATETIME:expression%%</code></p><p>Обрабатывается так же, как префикс <code>LOCALDATETIME(&quot;dateAndTime&quot;)</code>.</p></li><li><p><code>%%DATETIMESHORT:expression%%</code></p><p>Обрабатывается так же, как:</p><ul><li>префикс <code>DATETIME(&quot;timeOnly&quot;)</code>, если значение отметки о времени, заданное в выражении, &quot;очень близко&quot; к текущему времени (абсолютная разница менее 22 часов),</li><li>префикс <code>DATETIME(&quot;monthDate&quot;)</code>, если значение отметки о времени, заданное в выражении, &quot;близко&quot; к текущей дате (абсолютная разница менее 180 дней),</li><li>префикс <code>DATETIME(&quot;dateOnly&quot;)</code> во всех остальных случаях.</li></ul></li><li><p><code>%%LOCALDATETIMESHORT:expression%%</code></p><p>Обработка совпадает с используемой в префиксе <code>DATETIMESHORT:</code>, но значение выражения преобразовывается сначала в местное время.</p></li><li><p><code>%%HTMLTRUNCATED(number):expression%%</code></p><p>Выражение вычисляется. Если значение не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка, то она обрезается, а затем из UTF-8 преобразовывается в требуемую кодировку, а далее преобразованная строка заменяет собой текстовый элемент, используя специальные HTML символы. Заменяется не более чем <em>number</em> число символов (&quot;глифов&quot;). Если в строке имеется большее количество глифов, то символы <code>..</code> будут добавлены в конец строки.<br> Пример: если результатом выражения является строка <code>&quot;Test Subject&quot;</code>, то текстовый элемент с префиксом HTMLTRUNCATED(10) заменяется на</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>Test Subje..</span></span></code></pre></div></li><li><p><code>%%HTMLTRUNCATED(expression1):expression%%</code></p><p>Аналогично вышеописанному, но параметр <em>expression1</em> является вычисляемым выражением. Параметр <em>expression1</em> должен иметь числовое значение. Это значение задаёт число глифов, которое будет взято из строки <em>expression</em>.<br> Пример: <code>HTMLTRUNCATED(STRING(&quot;FieldLength&quot;)):theField</code></p></li><li><p><code>%%HTMLSUBST(parameter0,parameter1,...):expression%%</code></p><p>Вычисляются выражение и все N параметров. Если значения параметров не является строкой, то весь текстовый элемент удаляется из результирующего кода разметки. Если результатом является строка, то все её подстроки вида ^N заменяются на строковые значения выражения parameterN (подстроки <code>^0</code> заменяются на значения parameter0, подстроки <code>^1</code> заменяются на значения parameter1 и т.д.). Если значением параметра не является строка, то подстрока ^N удаляется.<br> Результирующая строка преобразовывается из кодировки UTF-8 в требуемую кодировку, а затем преобразованная строка заменяет собой текстовый элемент, используя специальные HTML символы.<br> Пример: если элемент <code>text1</code> Набора данных Text является строкой <code>&quot;My String1&quot;</code>, элемент var2 Набора данных Result является <code>My Var2</code>, а элемент <code>text2</code> Набора данных Text является строкой <code>&quot;comparing ^0 &amp; ^1&quot;</code> , то следующий код:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>%%HTMLSUBST(STRING(&quot;text1&quot;),var2):STRING(&quot;text2&quot;)%%</span></span></code></pre></div><p>будет заменяться на строку</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>comparing My String1 &amp;amp; My Var2</span></span></code></pre></div><p>.</p></li><li><p><code>%%URLSUBST(parameter0,parameter1,...):expression%%</code></p><p>Аналогично вышеописанному, но результирующая строка заменяет собой этот текстовый элемент, используя специальные символы для URL.</p></li><li><p><code>%%INDEX:scanner%%</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Этот текстовый элемент заменяется на десятичное значение индекса сканнера. Для первого элемента используется значение 0.</p></li><li><p><code>%%INDEX1:scanner%%</code></p><p>Параметр <em>scanner</em> должен быть именем внешней по отношению к этой части кода сценария конструкции <code>&lt;!--%%FOREACH scanner IN ...--&gt;</code>. Этот текстовый элемент заменяется на десятичное значение индекса сканнера. Для первого элемента используется значение 1.</p></li><li><p><code>%%DUMP:expression%%</code></p><p>Выражение вычисляется. <a href="./Data.html">Текстовое представление</a> значения выражения заменяет этот текстовый элемент.</p></li><li><p><code>%%LENGTH:expression%%</code></p><p>Выражение вычисляется.<br> Если значением является строка, то этот текстовый элемент заменяется на длину строки (в байтах).<br> Если значение является массивом, то этот текстовый элемент заменяется на количество элементов в массиве.<br> Если значением является словарь, то этот текстовый элемент заменяется на количество пар ключ-значение, содержащихся в этом словаре.<br> В противном случае, этот текстовый элемент удаляется.</p></li><li><p><code>%%CENTS:expression%%</code></p><p>Выражение вычисляется. Его числовое значение преобразовывается в числовую строку с как минимум 3 десятичными цифрами, а символ десятичной запятой (<code>.</code>) вставляется перед двумя последними десятичными цифрами. Результирующая строка заменяет собой этот текстовый элемент.</p></li></ul><h2 id="Structs" tabindex="-1">Структурные Элементы <a class="header-anchor" href="#Structs" aria-label="Permalink to &quot;Структурные Элементы {#Structs}&quot;">​</a></h2><p>Структурные элементы начинаются с маркера <code>&lt;!--%%</code> и заканчиваются маркером <code>--&gt;</code>. Сами структурные элементы всегда удаляются из результирующего кода разметки.</p><ul><li><p><code>&lt;!--%%IF expression--&gt;</code></p><p>За этим структурным элементом могут следовать один или несколько элементов<br><code>&lt;!--%%ELIF expression--&gt;</code><br> за ними может идти элемент<br><code>&lt;!--%%ELSE--&gt;</code><br> за ними должен быть элемент<br><code>&lt;!--%%ENDIF--&gt;</code><br> .</p><p>Вычисляется логическое значение выражения элемента IF, затем вычисляются значения выражений ELIF (если они существуют) до тех пор, пока одно из этих значений не окажется положительным (истинно).<br> Если найден элемент с таким значением, то обрабатывается часть сценария, находящаяся между этим элементом и элементами ELIF, ELSE или ENDIF.<br> Если элемент не найден и элемент ELSE отсутствует, то сценарий между элементами IF и ENDIF удаляется полностью; в противном случае обрабатывается часть сценария, находящаяся между элементами ELSE и ENDIF.</p><ul><li><p>Пример:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%IF EXISTS(lastLogin)--&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">We have not seen you since &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">i</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;%%HTML:lastLogin%%&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">i</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%ELSE--&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">Welcome, new user!</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">&lt;!--%%ENDIF--&gt;</span></span></code></pre></div><p>Если в этом примере набор данных содержит элемент <code>lastLogin</code> со строковым значением <code>20-Apr-2007</code>, то эта часть сценария выведет следующий текст:<br><code>We have not seen you since &lt;i&gt;20-Apr-2007&lt;/i&gt;</code></p><p>Если набор данных не содержит элемента <code>lastLogin</code>, то эта часть сценария выведет следующий текст:<br><code>Welcome, new user!</code></p></li></ul></li><li><p><code>&lt;!--%%FOREACH scanner in expression--&gt;</code><br> или<br><code>&lt;!--%%FORALL scanner in expression--&gt;</code></p><p>За этим структурным элементом может следовать элемент<br><code>&lt;!--%%EMPTYFOR scanner--&gt;</code><br> который должен оканчиваться элементом<br><code>&lt;!--%%ENDFOR scanner--&gt;</code><br> . Все элементы должны иметь одинаковую алфавитно-цифровую строку <em>scanner</em>.</p><p>Значение <em>expression</em> вычисляется. Результирующее значение должно быть массивом или словарём.<br> Часть сценария между элементами <code>&lt;!--%%FOREACH scanner</code> ...<code>--&gt;</code> и <code>&lt;!--%%EMPTYFOR scanner--&gt;</code> или (если элемент <code>&lt;!--%%EMTPYFOR scanner--&gt;</code> не существует) часть сценария между элементами <code>&lt;!--%%FOREACH scanner</code> ...<code>--&gt;</code> и <code>&lt;!--%%ENDFOR scanner--&gt;</code> обрабатывается повторно, для каждого элемента словаря или массива.</p><p>Выражения, заданные в этой части сценария (называемой &quot;телом цикла&quot;) могут использовать <em>ссылку на scanner <code>scanner</code></em><code>[]</code> для того, что бы получить доступ к текущему элементу значения <em>expression</em>.<br> Если <em>expression</em> является словарём, то <em>ссылка на ключ <code>scanner</code></em><code>[*]</code> может использоваться для доступа к ключу текущего элемента.<br> Если значение <em>expression</em> не является массивом или словарём, или же если оно является пустым массивом или словарём и при этом задан элемент <code>&lt;!--%%EMPTYFOR scanner--&gt;</code>, то обрабатывается часть сценария между элементами <code>&lt;!--%%EMPTYFOR scanner--&gt;</code> и <code>&lt;!--%%ENDFOR scanner--&gt;</code>.</p><ul><li><p>Пример:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">table</span><span style="--shiki-light:#B31D28;--shiki-light-font-style:italic;--shiki-dark:#FDAEB7;--shiki-dark-font-style:italic;"> border</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;File Name&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;File Size&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  &lt;!--%%FOREACH elem in fileList--&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;%%HTML:elem[].name%%&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;%%elem[].size%%&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  &lt;!--%%EMPTYFOR elem--&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> colspan</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;nbsp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  &lt;!--%%ENDFOR elem--&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">table</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div><p>В этом примере предполагается, что элемент данных <code>fileList</code> является массивом словарей. Предполагается, что в каждом словаре содержатся строковые значения для ключей <code>name</code> и <code>size</code>.<br> Если значением <code>fileList</code> является<br><code>({name=MyReport; size=2300;},{name=&quot;My Old Report&quot;; size=4000;})</code><br> то эта часть сценария создаст следующий HTML код:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">table</span><span style="--shiki-light:#B31D28;--shiki-light-font-style:italic;--shiki-dark:#FDAEB7;--shiki-dark-font-style:italic;"> border</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;File Name&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;File Size&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;MyReport&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;2300&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;My Old Report&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    &lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;4000&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">td</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  &lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">tr</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">table</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul><p>Конструкции <code>&lt;!--%%IF</code> ...<code>--&gt;</code> ...<code>&lt;!--%%ELSE--&gt;</code> ...<code>&lt;!--%%ENDIF--&gt;</code> и конструкции <code>&lt;!--%%FOREACH</code> ...<code>--&gt;</code> ... <code>&lt;!--%%ENDFOR</code> ...<code>--&gt;</code> могут быть вложенными.</p></li><li><p><code>&lt;!--%%FOREACHINC scanner in expression--&gt;</code></p><p>Аналогично конструкции <code>&lt;!--%%FOREACH</code> , но часть кода в &quot;теле цикла&quot; повторяется на один раз больше, чем число элементов в массиве (или в словаре) значений <em>expression</em>.<br> Для этого дополнительного этапа значения <code>scanner[*]</code> и <code>scanner[]</code> являются пустыми.<br> Если значение <em>expression</em> не является массивом или словарём, то тело цикла не повторяется и обрабатывается часть сценария между элементами <code>&lt;!--%%EMPTYFOR scanner--&gt;</code> и <code>&lt;!--%%ENDFOR scanner--&gt;</code> (если они есть).</p></li><li><p><code>&lt;!--%%FOREACHREV scanner in expression--&gt;</code></p><p>Аналогично конструкции <code>&lt;!--%%FOREACH</code> , но часть кода в &quot;теле цикла&quot; повторяется для каждого элемента массива (или словаря) в значении <em>expression</em>, взятых в обратном порядке (последний элемент - первым).</p></li><li><p><code>&lt;!--%%INCLUDE filename</code>[<code>( parameter1</code> [<code>, parameter2 ...</code> ]<code>)</code>]<code>--&gt;</code></p><p>Параметр <em>filename</em> должен быть константной строкой или выражением со значением типа строка.<br> Файл с указанным именем <em>filename</em> берётся из того же Вида Интерфейса, из которого был взят этот сценарий. В файле должен содержаться WSSP код. Этот код выполняется в текущем контексте (используя тот же набор данных).<br> Результирующий код разметки используется для замены этого структурного элемента.</p><p>Для файлов, предназначенных для использования в элементе INCLUDE, рекомендуется использовать расширения <code>.wssi</code>.</p><p>Элементы INCLUDE могут быть вложенными, то есть, файл <code>.wssi</code> может включать в себя другой файл <code>.wssi</code>.</p><p>В отличие от операторов <code>#include</code> в языках C и C++, этот оператор является реальным оператором, а не оператором препроцессора. В результате, если элемент <code>&lt;!--%%INCLUDE filename--&gt;</code> используется внутри конструкции <code>&lt;!--%%FOREACH</code> ...<code>--&gt;</code> ... <code>&lt;!--%%ENDFOR</code> ...<code>--&gt;</code>, то код <em>filename</em> может выполняться несколько раз, по разу для каждого элемента массива, используемого в конструкции FOREACH.</p><p>Вы также можете указать один или несколько параметров, заключив их в круглые скобки и разделяя их запятой. Каждый параметр является выражением, которое обрабатывается до выполнения кода <em>filename</em>.<br> Код в <em>filename</em> может получать значения параметров, используя функцию <code>INCLUDEARG</code>.</p></li><li><p><code>&lt;!--%%NUMERICMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN (number1,number2,....,numberN)</code> [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент заменяется на последовательность строковых элементов <code>&lt;option value=&quot;value&quot;&gt;presentation</code>.<br> Число элементов и <em>value</em>, используемое для каждого элемента, определяются согласно списку чисел <em>number1</em>,<em>number2</em>,....,<em>numberN</em>. Эти числа должны быть заданы в возрастающем порядке и не должны быть меньше -1.<br> Выражение <em>selected</em> вычисляется, и его значением должна быть строка. Строковое числовое значение используется для добавления ключевого слова <code>selected</code> в элемент <code>&lt;option value=&quot;value&quot;&gt;</code>, имеющий это же <em>value</em>.<br> Ключевое слово <code>DISPLAY</code> и выражение <em>dictionary</em> могут быть опущены. В этом случае строки <em>presentation</em> совпадают со строками <em>value</em>, то есть, эти строки являются числами.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>sizeLimit</code> имеет строковое значение <code>200</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%NUMERICMENU sizeLimit IN (-1,0,100,200,300)--&gt;</span></span></code></pre></div><p>будет заменяться следующим текстом кода разметки:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;-1&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;0&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;100&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;200&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;200&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;300&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;300&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul><p>Если ключевое слово <code>DISPLAY</code> и выражение <em>dictionary</em> указаны, то выражение вычисляется. Если значением выражения является словарь, то строки <em>presentation</em> являются числовыми значениями, &quot;транслированными&quot; через этот словарь; далее результат преобразовывается в требуемую кодировку и представляется при помощи специальных символов HTML.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>sizeLimit</code> имеет строковое значение <code>200</code>.<br> Текстовый набор данных Вида Интерфейса содержит словарь <code>Limits</code>: <code>{&quot;-1&quot; = Unlimited; 0 = &quot;Off &amp; Shut&quot;;}</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%NUMERICMENU sizeLimit IN (-1,0,100,200,300) DISPLAY DICTIONARY(&quot;Limits&quot;)--&gt;</span></span></code></pre></div><p>будет заменяться следующим текстом кода разметки:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Unlimited&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Off </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> Shut&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;100&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;200&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;200&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;300&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;300&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul><p>Если указано ключевое слово <code>DEFAULT</code> с выражением <em>selectedDefault</em>, то дополнительная строка <code>&lt;option value=&quot;-2&quot;&gt;defaultPresentation</code> добавляется перед последовательностью. Если значение выражения <em>selected</em> является пустым, то к этому строковому элементу будет добавлено ключевое слово <code>selected</code>.</p><p>Строка <em>defaultPresentation</em> является строкой <code>DefaultValuePicture</code>, полученной из Текстового Набора данных Вида Интерфейса. Эта строка должна содержать комбинацию символов <code>^0</code>. Эта комбинация символов заменяется на значение выражения <em>selectedDefault</em>. Если указан словарь DISPLAY, то значение выражения <em>selectedDefault</em> сначала транслируется.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>sizeLimit</code> имеет строковое значение <code>200</code>.<br> Элемент набора данных <code>defLimit</code> является строкой <code>-1</code>.<br> В Текстовом Наборе данных Вида Интерфейса содержится строка <code>DefaultValuePicture</code>: <code>default(^0)</code>.<br> Текстовый набор данных Вида Интерфейса содержит словарь <code>Limits</code>: <code>{&quot;-1&quot; = Unlimited; 0 = &quot;Off &amp; Shut&quot;;}</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%NUMERICMENU sizeLimit DEFAULT defLimit IN (-1,0,100,200,300) DISPLAY DICTIONARY(&quot;Limits&quot;)--&gt;</span></span></code></pre></div><p>будет заменяться на следующий текст разметки (HTML):</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;default(Unlimited)&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Unlimited&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Off </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">&amp;amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> Shut&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;100&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;100&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;200&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;200&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;300&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;300&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul></li><li><p><code>&lt;!--%%TIMEMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN (time1,time2,....,timeN)</code> [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент обрабатывается так же, как и элемент NUMERICMENU. Единицы <em>timeN</em> задают временные интервалы, преобразовываемые в числовые значения (число секунд), используя такой же алгоритм, как и при обработке текстового элемента <a href="#TIMEPrefix"><code>TIME:</code></a>.<br> Выражения <em>selected</em> и <em>selectedDefault</em> должны возвращать строки. Каждая строка преобразовывается в числовое значение (число секунд), используя такой же алгоритм, как и при обработке текстовых элементов <a href="#TIMEPrefix"><code>TIME:</code></a>.<br> Значения транслируются при помощи указанного словаря <code>DISPLAY</code>. Если словарь <code>DISPLAY</code> не задан или не содержит для данного значения строки, то строки <em>presentation</em> для времени создаются с использованием такого же метода, как и при обработке текстовых элементов <code>TIME:</code>.</p></li><li><p><code>&lt;!--%%SIZEMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN (size1,size2,....,sizeN)</code> [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент обрабатывается так же, как и элемент NUMERICMENU. Единицы <em>sizeN</em> задают размеры данных, преобразовываемые в числовые значения (число байт), используя такой же алгоритм, как и при обработке текстовых элементов <a href="#SIZEPrefix"><code>SIZE:</code></a>.<br> Результатом выражений <em>selected</em> и <em>selectedDefault</em> должны быть строки. Каждая строка преобразовывается в числовое значение (число байт), используя такой же алгоритм, как и при обработке текстового элемента <code>SIZE:</code>.<br> Значения транслируются при помощи указанного словаря <code>DISPLAY</code>. Если словарь <code>DISPLAY</code> не задан или не содержит для данного значения строки, то строки <em>presentation</em> для размера создаются с использованием такого же метода, как и при обработке текстовых элементов <code>SIZE:</code>.</p></li><li><p><code>&lt;!--%%ENUMMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN valueSet</code> [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент заменяется на последовательность строковых элементов <code>&lt;option value=&quot;value&quot;&gt;presentation</code>.</p><p>Число элементов и <em>value</em>, используемое для каждого элемента, определяются по значению выражения <em>valueSet</em>. Это значение должно быть массивом строк. <em>Value</em> в каждом элементе является строковым индексом в результирующем массиве valueSet.</p><p>Выражение <em>selected</em> вычисляется и его значением должна быть строка. Ключевое слово <code>selected</code> добавляется в элемент <code>&lt;option value=&quot;value&quot;&gt;</code>, созданный для элемента массива <em>valueSet</em>, который соответствует результату выражения <em>selected</em>.</p><p>Ключевое слово <code>DISPLAY</code> и выражение <em>dictionary</em> могут быть опущены. В этом случае строки <em>presentation</em> совпадают со результирующими строками элементов <em>valueSet</em>.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>color</code> является строкой <code>&quot;Green&quot;</code>.<br> Элемент набора данных <code>colors</code> является массивом <code>(&quot;Blue&quot;, &quot;Green&quot;, &quot;Red&quot;)</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%ENUMMENU color IN colors--&gt;</span></span></code></pre></div><p>будет заменяться на следующий текст разметки (HTML):</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Blue&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Green&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Red&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul><p>Если ключевое слово <code>DISPLAY</code> и выражение <em>dictionary</em> указаны, то выражение вычисляется. Если значением выражения является словарь, то он используется для &quot;трансляции&quot; массива строк <em>valueSet</em> до преобразования их в требуемую кодировку и помещения в результирующий код разметки с использованием специальных символов HTML.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>color</code> является строкой <code>&quot;Green&quot;</code>.<br> Элемент набора данных <code>colors</code> является массивом <code>(&quot;Blue&quot;, &quot;Green&quot;, &quot;Red&quot;)</code>.<br> Набор данных Вида Интерфейса содержит словарь <code>Colors</code>: <code>{Blue = &quot;Night Blue&quot;; Green = &quot;Grass Green&quot;;}</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%ENUMMENU color IN colors DISPLAY DICTIONARY(&quot;Colors&quot;)--&gt;</span></span></code></pre></div><p>будет заменяться на следующий текст разметки (HTML):</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Night Blue&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Grass Green&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Red&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul><p>Если указаны ключевое слово <code>DEFAULT</code> с выражением <em>selectedDefault</em>, то дополнительная строка <code>&lt;option value=&quot;-1&quot;&gt;defaultPresentation</code> добавляется до последовательности. Если значение выражения <em>selected</em> является пустым, то к этому строковому элементу будет добавлено ключевое слово <code>selected</code>.</p><p>Строка <em>defaultPresentation</em> является строкой <code>DefaultValuePicture</code>, полученной из Текстового Набора данных Вида Интерфейса. Эта строка должна содержать комбинацию символов <code>^0</code>. Эта комбинация символов заменяется на значение выражения <em>selectedDefault</em>. Если указано ключевое слово <code>DISPLAY</code>, то значение выражения <em>selectedDefault</em> сначала транслируется.</p><ul><li><p>Пример:</p><p>Элемент набора данных <code>color</code> является строкой <code>&quot;Green&quot;</code>.<br> Элемент набора данных <code>defColor</code> является строкой <code>&quot;Blue&quot;</code>.<br> Элемент набора данных <code>colors</code> является массивом <code>(&quot;Blue&quot;, &quot;Green&quot;, &quot;Red&quot;)</code>.<br> В Текстовом Наборе данных Вида Интерфейса содержится строка <code>DefaultValuePicture</code>: <code>default(^0)</code>.<br> Набор данных Вида Интерфейса содержит словарь <code>Colors</code>: <code>{Blue = &quot;Night Blue&quot;; Green = &quot;Grass Green&quot;;}</code>.<br> Элемент:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span>&lt;!--%%ENUMMENU color DEFAULT defColor IN colors DISPLAY DICTIONARY(&quot;Colors&quot;)--&gt;</span></span></code></pre></div><p>будет заменяться на следующий HTML код:</p><div class="language-html vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">html</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;-1&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;default(Night Blue)&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;0&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Night Blue&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1&quot;</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> selected</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Grass Green&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&lt;</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> value</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">=</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;2&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;Red&lt;/</span><span style="--shiki-light:#22863A;--shiki-dark:#85E89D;">option</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">&gt;</span></span></code></pre></div></li></ul></li><li><p><code>&lt;!--%%BOOLMENU selected</code> [<code>DEFAULT selectedDefault</code> ] [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент заменяется на последовательность строковых элементов <code>&lt;option value=&quot;value&quot;&gt;presentation</code> аналогично тому, как это происходит при обработке элемента ENUMMENU.<br> В отличие от элемента ENUMMENU, в этом элементе не содержится часть <code>IN valueSet</code>: вместо этого используется встроенный массив <code>(&quot;NO&quot;,&quot;YES&quot;)</code>.</p></li><li><p><code>&lt;!--%%MAILBOXMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN mailboxList</code> [<code>NOINBOX</code> ]<code>--&gt;</code></p><p>Этот элемент заменяется на последовательность строковых элементов <code>&lt;option value=&quot;value&quot;&gt;presentation</code> аналогично тому, как это происходит при обработке элемента ENUMMENU.<br> Значения выражений <em>selected</em> и <em>selectedDefault</em> конвертируются так же, как они конвертируются для текстового элемента, имеющего префикс <code>MAILBOXNAME:</code>, используя словарь <code>MailboxNames</code> из Текстового Набора данных Вида Интерфейса; по этой причине элементы MAILBOXMENU не имеют части DISPLAY.<br> Если указано ключевое слово NOINBOX, то папка INBOX (если она существует в <em>mailboxList</em>) не отображается.</p></li><li><p><code>&lt;!--%%DAYTIMEMENU selected</code> [<code>DEFAULT selectedDefault</code> ] [<code>PERIOD timePeriod</code> ] <code>--&gt;</code></p><p>Этот элемент заменяется на последовательность строковых элементов <code>&lt;option value=&quot;value&quot;&gt;presentation</code> для формирования меню времени дня. Каждое значение является временем в секундах и его представлением является строка, отображающая это время с использованием формата &quot;hourMinute&quot; (или строки формата &quot;^H:^m&quot;, если элемент &quot;hourMinute&quot; не найден в данных <code>DICTIONARY(&quot;DatePictures&quot;)</code>.<br> Значение времени генерируются, начиная с полуночи (<code>00:00</code>) и до 23:59 с шагом, заданным в timePeriod (в минутах).<br> Если ключевое слово PERIOD и значение timePeriod не указаны, то используется шаг в 30 минут (1800 секунд).<br> Если ключевое слово PERIOD указано, то значение timePeriod может быть либо числовой константой, задающей интервал времени в минутах, либо выражением. Значение выражения вычисляется и преобразовывается в число. Это число указывает период времени в секундах.<br> Выражения <em>selected</em> и <em>selectedDefault</em> должны иметь числовые значения - текущее выбранное (и являющееся умолчанием) время дня (секунды, считая от полуночи).</p></li><li><p><code>&lt;!--%%CALENDARTIMEMENU selected</code> [<code>PERIOD timePeriod</code> ] <code>--&gt;</code></p><p>Этот элемент создаёт такое же меню HTML, как и элемент DAYTIMEMENU.<br> Значение выражения <em>selected</em> должно быть отметкой времени. Временная часть этого значения используется как текущее выбранное значение времени дня.</p></li><li><p><code>&lt;!--%%LOCALCALENDARTIMEMENU selected</code> [<code>PERIOD timePeriod</code> ] <code>--&gt;</code></p><p>Этот элемент создаёт такое же меню HTML, как и элемент DAYTIMEMENU.<br> Значение выражения <em>selected</em> должно быть отметкой времени. Значение преобразовывается в местный часовой пояс, и временная часть этого значения используется как текущее выбранное значение времени дня.</p></li><li><p><code>&lt;!--%%STRINGMENU selected</code> [<code>DEFAULT selectedDefault</code> ] <code>IN valueSet</code> [ <code>DISPLAY dictionary</code>]<code>--&gt;</code></p><p>Этот элемент работает аналогично элементу ENUMMENU, но используемые значения являются фактическими значениями данных, а не их номерами, как в элементе ENUMMENU. Значением по умолчанию является строка <code>default</code>.</p></li><li><p><code>&lt;!--%%CALENDARDATECONTROL selected NAME name</code> [<code>DAYSBEFORE before</code>] [<code>DAYSAFTER after</code>] [<code>CANNEVER</code> ] <code>--&gt;</code></p><p>Этот элемент создаёт элемент управления или набор элементов управления для данных календаря, используя выражение <em>selected</em>. Значение выражения должно быть отметкой времени; в противном случае весь текстовый элемент удаляется из результирующего кода разметки.</p><p>Если указанное время раньше текущей даты больше чем на <em>before</em> дней или если оно позже текущей даты больше чем на <em>after</em> дней, то этот элемент заменяется текстом с несколькими текстовыми элементами управления. В противном случае создаётся управляющий элемент меню.</p><p>Значения <em>before</em> и <em>after</em> должен быть заданы как числа.<br> Если значение <em>before</em> не указано явно, оно считается равным 7.<br> Если значение <em>after</em> не указано явно, оно считается равным 31.<br> Если используется ключевое слово CANNEVER, то меню содержит пункт <code>Never</code>, имеющим значение <em>remote future</em>. Если выбранное значение равно значению <em>remote future</em>, то создаётся элемент управления в виде меню.</p><p>Элемент <em>name</em> должен быть строкой.</p><p>Для создания элементов управления форматная строка <code>dateOnly</code> берётся из словаря <code>DatePictures</code> и коды текстового элемента управления используются для замены имеющихся в ней комбинаций символов <code>^D</code>, <code>^M</code>, <code>^Y</code> и <code>^y</code>. Каждый элемент управления имеет заданный <em>name</em> и префикс: элемент управления для дня имеет имя <code>name-D</code>, элемент управления для месяца имеет имя <code>name-M</code>, элемент управления для 2 цифр года года имеет имя <code>name-Y</code>, и элемент управления для 4 цифр года имеет имя <code>name-y</code>.</p><p>Если создаётся меню, то генерируется элемент языка разметки <code>select</code>. Он имеет заданное имя <em>name</em>. Меню содержит элемент для текущей даты, элементы <em>before</em> для предыдущих дат и элементы <em>after</em> для последующих дат. Форматирование элементов осуществляется при помощи форматной строки <code>dayAndMonthDate</code> из словаря <code>DatePictures</code>.<br> Для даты &quot;after+1&quot; добавляется дополнительный элемент с текстом <code>...</code>. При выборе этого элемента выбранное значение даты переносится за диапазон дат, имеющихся в меню, что позволяет пользователю использовать текстовый элемент управления и выбирать произвольную дату.</p></li><li><p><code>&lt;!--%%LOCALCALENDARDATECONTROL selected NAME name</code> [<code>DAYSBEFORE before</code>] [<code>DAYSAFTER after</code>] <code>--&gt;</code></p><p>Этот элемент создаёт такой же код разметки HTML, как и элемент CALENDARDATECONTROL.<br> Значение выражения <em>selected</em> должно быть отметкой времени. Предполагается, что значение выражено в глобальном (GMT) времени, поэтому сначала значение преобразовывается в местное время.</p></li></ul>`,34)]))}const r=s(o,[["render",p]]);export{E as __pageData,r as default};
